14/07/00 18:14:00
   
fromHandle: anExternalHandle
	"Returns an instance of the receiver obtained from anExternalHandle."

	^self new
		handle: anExternalHandle;
		yourself!  
fromInteger: anInteger
	"Returns an instance of the receiver obtained from handle anInteger."

	^self fromHandle: (ExternalHandle fromInteger: anInteger)! 
test
	"Test the receiver.
	EZTwainLibrary test
	"

	(DIB fromHandle: EZTwainLibrary current acquireNative) inspect!  
fileName
        "Answer the receiver's file name."

    ^'Eztw32.dll'!
acquireToClipboard: hwnd
	" Like AcquireNative, but puts the resulting image, if any, into the system clipboard.
	  Under Windows, this will put a CF_DIB item in the clipboard if successful.
	  If this call fails, the clipboard is either empty or contains the old contents."

    ^self acquireToClipboard: hwnd types: TwainAnyType!  
dibNumColors: handle
	" DIB handling utilities - Number of colors in color table of DIB. "

    <api: TWAIN_DibNumColors handle ulongReturn>
    ^self invalidArgument!   
abortAllPendingXfers
	" Low level - no comments."

    <api: TWAIN_AbortAllPendingXfers boolean>
    ^self invalidArgument!   
writeNativeToFile: hdib hfile: hfile
	" BMP file utilities -Writes a DIB to a file in .BMP format.
 hdib        = DIB handle, as returned by TWAIN_AcquireNative
 fh        = file handle, as returned by _open, _lopen or OpenFile
 Return value as for TWAIN_WriteNativeToFilename
	"

    <api: TWAIN_WriteNativeToFile handle handle long>
    ^self invalidArgument! 
loadSourceManager
	" Low level - Finds and loads the Data Source Manager, TWAIN.DLL.
 If Source Manager is already loaded, does nothing and returns TRUE. "

    <api: TWAIN_LoadSourceManager boolean>
    ^self invalidArgument!   
openSourceManager: hwnd
	" Low level - Opens the Data Source Manager, if not already open.
	If the Source Manager is already open, does nothing and returns TRUE.
	This call will fail if the Source Manager is not loaded."

    <api: TWAIN_OpenSourceManager handle boolean>
    ^self invalidArgument!  
getCurrentResolution
	" Low level - Ask the source for the current resolution.
	Resolution is in dots per current unit!! (See TWAIN_GetCurrentUnits above)
	If anything goes wrong (it shouldn't) this function returns 0.0"

    <api: TWAIN_GetCurrentResolution double>
    ^self invalidArgument!   
getCurrentUnits
	" Low level - Ask the source what its current unit of measure is.
	If anything goes wrong, this function just returns TWUN_INCHES (0).
	"

    <api: TWAIN_GetCurrentUnits ulongReturn>
    ^self invalidArgument! 
mgr: dg dat: dat msg: msg pData: pData
	" Lowest level - Passes a triplet to the Data Source Manager (DSM).
	The last result code can be retrieved with TWAIN_GetResultCode(), and the corresponding condition code can be retrieved with TWAIN_GetConditionCode().
	If no source is open this call will fail, result code TWRC_FAILURE, condition code TWCC_NODS."

    <api: TWAIN_Mgr ulong ulong ulong struct boolean>
    ^self invalidArgument!   
modalEventLoop
	" Low level - Process messages until termination, source disable, or image transfer."

    <api: TWAIN_ModalEventLoop none>
    ^self invalidArgument!
setCurrentUnits: units
	" Low level - Set the current unit of measure for the source.
	Unit of measure codes are in TWAIN.H, but TWUN_INCHES is 0.
	"

    <api: TWAIN_SetCurrentUnits ulong ulong>
    ^self invalidArgument!  
dibHeight: handle
	" DIB handling utilities - Height of DIB, in pixels (rows). "

    <api: TWAIN_DibHeight handle ulongReturn>
    ^self invalidArgument!
acquireToClipboard
	" Like AcquireNative, but puts the resulting image, if any, into the system clipboard.
	  Under Windows, this will put a CF_DIB item in the clipboard if successful.
	  If this call fails, the clipboard is either empty or contains the old contents."

    ^self acquireToClipboard: nil! 
acquireNative
	" Acquires a single image of any type.
	See comment of #acquireNative:types: for more detail
	"

    ^self
		acquireNative: nil "let the receiver open the parent window"
		types: TwainAnyType!
acquireNative: hwnd
	" Acquires a single image of any type.
	See comment of #acquireNative:types: for more detail
	"

    ^self acquireNative: hwnd types: TwainAnyType! 
getPixelType
	" Low level - Ask the source for the current pixel type.
	If anything goes wrong (it shouldn't), this function returns 0 (TWPT_BW)."

    <api: TWAIN_GetPixelType ulongReturn>
    ^self invalidArgument! 
disableSource
	" Low level - Disables the open Data Source, if any.
	This closes the source's user interface.
	If there is not an enabled source, does nothing and returns TRUE."

    <api: TWAIN_DisableSource boolean>
    ^self invalidArgument!
hideUI
	" Low level - Returns the 'hide source user interface' flag. "

    ^self getHideUI!   
selectImageSource
	" This is the routine to call when the user chooses the 'Select Source...' menu command from your application's File menu.
	If you want to be meticulous, disable your 'Acquire' and 'Select Source'
	menu items or buttons if TWAIN_IsAvailable() returns false
	"

    ^self selectImageSource: nil!   
selectImageSource: hwnd
	" This is the routine to call when the user chooses the 'Select Source...' menu command from your application's File menu.
	If you want to be meticulous, disable your 'Acquire' and 'Select Source'
	menu items or buttons if TWAIN_IsAvailable() returns false
	"

    <api: TWAIN_SelectImageSource handle boolean>
    ^self invalidArgument! 
state
	" Basic TWAIN Inquiries - Returns the TWAIN Protocol State per the spec. "

    <api: TWAIN_State ulongReturn>
    ^self invalidArgument!  
enableSource: hwnd
	" Low level - Enables the open Data Source.
	This posts the source's user interface and allows image acquisition to begin.
	If the source is already enabled, this call does nothing and returns TRUE."

    <api: TWAIN_EnableSource handle boolean>
    ^self invalidArgument!
conditionCode
	" Low level - Return the condition code from the last triplet sent to TWAIN. "

    <api: TWAIN_GetConditionCode ulongReturn>
    ^self invalidArgument!   
currentUnits
	" Low level - Ask the source what its current unit of measure is.
	If anything goes wrong, this function just returns TWUN_INCHES (0).
	"

    ^self getCurrentUnits!  
setCurrentResolution: double
	" Low level - (Try to) set the current resolution for acquisition.	"

    <api: TWAIN_SetCurrentResolution double boolean>
    ^self invalidArgument!   
isAvailable
	" Basic TWAIN Inquiries - Find out if TWAIN is installed on the system.
	It takes a little time on the first call, after that it's fast, just testing a flag.
	"

    <api: TWAIN_IsAvailable boolean>
    ^self invalidArgument!  
unloadSourceManager
	" Low level - Unloads the Data Source Manager i.e. TWAIN.DLL - releasing any associated memory or resources.
	This call will fail if the Source Manager is open, otherwise it always succeeds and returns TRUE."

    <api: TWAIN_UnloadSourceManager boolean>
    ^self invalidArgument!   
acquireNative: hwnd types: pixTypes
	" The minimal use of EZTWAIN.DLL is to just call this routine,
	 with 0 for both params.  EZTWAIN creates a window if hwndApp is 0.

	Acquires a single image, from the currently selected Data Source, using Native-mode transfer.
	It waits until the source closes (if it's modal) or forces the source closed if not.
	The return value is a handle to the acquired image.
	Only one image can be acquired per call.

	Under Windows, the return value is a global memory handle - applying
	GlobalLock to it will return a (huge) pointer to the DIB, which
	starts with a BITMAPINFOHEADER.

	NOTE: You are responsible for disposing of the returned DIB - these things
	can eat up your Windows memory fast!!  See TWAIN_FreeNative below.

	The image type can be restricted using the following masks.
	A mask of 0 means 'any pixel type is welcome'.

	Caution: You should not assume that the source will honor a pixel type
	restriction!!  If you care, check the parameters of the DIB.
	"

    <api: TWAIN_AcquireNative handle ushort ulongReturn>
    ^self invalidArgument!  
resultCode
	" Low level - Return the result code (TWRC_xxx) from the last triplet sent to TWAIN. "

    ^self getResultCode!   
drawDibToDC: hdc destination: destination hdib: hdib source: source
	" DIB handling utilities - Draws a DIB on a device context.
	You should call CreateDibPalette, select that palette into the DC, and do a RealizePalette(hDC) first. "

    ^self
		drawDibToDC: hdc
		destination: destination leftTop
		extent: destination extent
		hdib: hdib
		source: source!  
acquireToFilename: hwnd
	" Acquire an image and write it to a .BMP, the user is prompted with a Save File dialog.
	Return values:
		-1 means the Acquire failed.
		0 means the Save failed (or was cancelled)
		1 indicates success.
	"

    ^self acquireToFilename: hwnd pathName: nil! 
acquireToFilename
	" Acquire an image and write it to a .BMP, the user is prompted with a Save File dialog.
	Return values:
		-1 means the Acquire failed.
		0 means the Save failed (or was cancelled)
		1 indicates success.
	"

    ^self acquireToFilename: nil!  
negotiateXferCount: nXfers
	" Low level - Negotiate with open Source the number of images application will accept."

    <api: TWAIN_NegotiateXferCount long boolean>
    ^self invalidArgument!  
pixelType
	" Low level - Ask the source for the current pixel type.
	If anything goes wrong (it shouldn't), this function returns 0 (TWPT_BW)."

    ^self getPixelType!  
drawDib: hdib toDC: hdc destination: destination source: source
	" DIB handling utilities - Draws a DIB on a device context.
	You should call CreateDibPalette, select that palette into the DC, and do a RealizePalette(hDC) first. "

    ^self
		drawDibToDC: hdc
		destination: destination
		hdib: hdib
		source: source!
freeNative: hdib
	" Release the memory allocated to a native format image, as returned by TWAIN_AcquireNative.	"

    <api: TWAIN_FreeNative handle none>
    ^self invalidArgument!  
createDibPalette: handle
	" DIB handling utilities - Create and return a logical palette to be used for drawing the DIB.
	For 1, 4, and 8-bit DIBs the palette contains the DIB color table.
	For 24-bit DIBs, a default halftone palette is returned. "

    <api: TWAIN_CreateDibPalette handle ulongReturn>
    ^self invalidArgument!   
getResultCode
	" Low level - Return the result code (TWRC_xxx) from the last triplet sent to TWAIN. "

    <api: TWAIN_GetResultCode ulongReturn>
    ^self invalidArgument!  
closeSourceManager: hwnd
	" Low level - Closes the Data Source Manager, if it is open.
	If a source is open, disables and closes it as needed.
	If the Source Manager is not open, does nothing and returns TRUE."

    <api: TWAIN_CloseSourceManager handle boolean>
    ^self invalidArgument!   
openDefaultSource
	" Low level - This opens the source selected in the Select Source dialog.
	If the Source Manager is already open, does nothing and returns TRUE.
	Fails if the source manager is not loaded and open."

    <api: TWAIN_OpenDefaultSource boolean>
    ^self invalidArgument!
setCurrentPixelType: nPixType
	" Low level - (Try to) set the current pixel type for acquisition."

    <api: TWAIN_SetCurrentPixelType ulong boolean>
    ^self invalidArgument! 
bitDepth: nBits
	" Low level - (Try to) set the current bitdepth (for the current pixel type)."

    ^self setBitDepth: nBits! 
registerApp: majorNum minorNum: minorNum
	language: language
	country: country
	version: version
	manufacturer: manufacturer
	family: family
	product: product
	" Application Registration - Can be called *AS THE FIRST CALL*, to register the application.
	If this function is not called, the application is given a 'generic' registration by EZTWAIN.
	Registration only provides this information to the Source Manager and any sources you may open - it is used for debugging, and (frankly) by some sources to give special treatment to certain applications.
	"

    <api: TWAIN_RegisterApp long long long long struct struct struct struct none>
    ^self invalidArgument!
dibDepth: handle
	" DIB handling utilities - Depth of DIB, in bits i.e. bits per pixel. "

    <api: TWAIN_DibDepth handle ulongReturn>
    ^self invalidArgument!
setCapOneValue: cap type: itemType value: itemValue
	" Low level - Do a DAT_CAPABILITY/MSG_SET, on capability 'Cap' (e.g. ICAP_PIXELTYPE, CAP_AUTOFEED, etc.) using a TW_ONEVALUE container with the given item type and value.
	Obviously, the item value must fit into 32 bits.	"

    <api: TWAIN_SetCapOneValue ulong ulong long boolean>
    ^self invalidArgument! 
getHideUI
	" Low level - Returns the 'hide source user interface' flag. "

    <api: TWAIN_GetHideUI boolean>
    ^self invalidArgument!  
hideUI: aBoolean
	" Low level - Control the 'hide source user interface' flag. "

    ^self setHideUI: aBoolean!   
loadNativeFromFile: hfile
	" BMP file utilities - Like LoadNativeFromFilename, but takes an already open file handle. "

    <api: TWAIN_LoadNativeFromFile handle ulongReturn>
    ^self invalidArgument!
currentPixelType: nPixType
	" Low level - (Try to) set the current pixel type for acquisition."

    ^self setCurrentPixelType: nPixType!  
dibWidth: handle
	" DIB handling utilities - Width of DIB, in pixels (columns). "

    <api: TWAIN_DibWidth handle ulongReturn>
    ^self invalidArgument!
setHideUI: boolean
	" Low level - Control the 'hide source user interface' flag. "

    <api: TWAIN_SetHideUI boolean none>
    ^self invalidArgument!
bitDepth
	" Low level - Get the current bitdepth, which can depend on the current PixelType.
	Bit depth is per color channel e.g. 24-bit RGB has bit depth 8.
	If anything goes wrong, this function returns 0."

    ^self getBitDepth! 
getBitDepth
	" Low level - Get the current bitdepth, which can depend on the current PixelType.
	Bit depth is per color channel e.g. 24-bit RGB has bit depth 8.
	If anything goes wrong, this function returns 0."

    <api: TWAIN_GetBitDepth ulongReturn>
    ^self invalidArgument!
acquireToFilename: hwnd pathName: pathName
	" Acquire an image and write it to a .BMP (Windows Bitmap) file.
	  The file name and path in pszFile are used.  If pszFile is NULL or points to an empty string, the user is prompted with a Save File dialog.
	Return values:
		-1 means the Acquire failed.
		0 means the Save failed (or was cancelled)
		1 indicates success.
	"

    <api: TWAIN_AcquireToFilename handle struct long>
    ^self invalidArgument! 
messageHook: lpmsg
	" Low level - This function detects Windows messages that should be routed to an enabled Data Source, and picks them off.
	In a full TWAIN app, TWAIN_MessageHook is called inside the main GetMessage loop.
    The skeleton code looks like this:
           MSG msg;
         while (GetMessage((LPMSG)&msg, NULL, 0, 0)) {
               if (!!TWAIN_MessageHook ((LPMSG)&msg)) {
                   TranslateMessage ((LPMSG)&msg);
                   DispatchMessage ((LPMSG)&msg);
               }
           }   //  while
	"

    <api: TWAIN_MessageHook struct ulongReturn>
    ^self invalidArgument!
drawDibToDC: hdc destination: destination extent: extent hdib: hdib source: source
	" DIB handling utilities - Draws a DIB on a device context.
	You should call CreateDibPalette, select that palette into the DC, and do a RealizePalette(hDC) first. "

    ^self
		drawDibToDC: hdc
		dx: destination x
		dy: destination y
		w: extent x
		h: extent y
		hdib: hdib
		sx: source x
		sy: source y!   
acquireToClipboard: hwnd types: pixTypes
	" Like AcquireNative, but puts the resulting image, if any, into the system clipboard.
	  Under Windows, this will put a CF_DIB item in the clipboard if successful.
	  If this call fails, the clipboard is either empty or contains the old contents."

    <api: TWAIN_AcquireToClipboard handle ushort boolean>
    ^self invalidArgument!
setBitDepth: nBits
	" Low level - (Try to) set the current bitdepth (for the current pixel type)."

    <api: TWAIN_SetBitDepth ulong boolean>
    ^self invalidArgument! 
writeNativeToFilename: hdib fileName: fileName
	" BMP file utilities - Writes a DIB handle to a .BMP file.

 hdib        = DIB handle, as returned by TWAIN_AcquireNative
 pszFile    = far pointer to NUL-terminated filename
 If pszFile is NULL or points to a null string, prompts the user
 for the filename with a standard file-save dialog.

 Return values:
     0    success
    -1    user cancelled File Save dialog
    -2    file open error (invalid path or name, or access denied)
    -3    (weird) unable to lock DIB - probably an invalid handle.
    -4    writing BMP data failed, possibly output device is full
	"

    <api: TWAIN_WriteNativeToFilename handle struct long>
    ^self invalidArgument!
ds: dg dat: dat msg: msg pData: pData
	" Lowest level - Passes the triplet (DG, DAT, MSG, pData) to the open data source if any.
	The last result code can be retrieved with TWAIN_GetResultCode(), and the corresponding condition code can be retrieved with TWAIN_GetConditionCode().
	If no source is open this call will fail, result code TWRC_FAILURE, condition code TWCC_NODS."

    <api: TWAIN_DS ulong ulong ulong struct boolean>
    ^self invalidArgument!   
currentUnits: units
	" Low level - Set the current unit of measure for the source.
	Unit of measure codes are in TWAIN.H, but TWUN_INCHES is 0.
	"

    ^self setCurrentUnits: units!
loadNativeFromFilename: pathName
	" BMP file utilities - Load a .BMP file and return a DIB handle (as from AcquireNative.)
	If pathName is NULL or points to a null string, the user is prompted.
	Returns a DIB handle if successful, otherwise NULL.
	"

    <api: TWAIN_LoadNativeFromFilename struct ulongReturn>
    ^self invalidArgument!   
currentResolution
	" Low level - Ask the source for the current resolution.
	Resolution is in dots per current unit!! (See TWAIN_GetCurrentUnits above)
	If anything goes wrong (it shouldn't) this function returns 0.0"

    ^self getCurrentResolution!   
currentResolution: double
	" Low level - (Try to) set the current resolution for acquisition.	"

    ^self setCurrentResolution: double!   
easyVersion
	" Basic TWAIN Inquiries - Returns the version number of EZTWAIN.DLL, multiplied by 100.
	So e.g. version 2.01 will return 201 from this call.
	"

    <api: TWAIN_EasyVersion ulongReturn>
    ^self invalidArgument!  
getCapCurrent: cap type: itemType value: lpValue
	" Low level - Do a DAT_CAPABILITY/MSG_GETCURRENT on capability 'Cap'.
	Copy the current value out of the returned container into *pVal.
	If the operation fails (the source refuses the request), or if the container is not a ONEVALUE or ENUMERATION, or if the item type of the returned container is incompatible with the expected TWTY_ type in nType, returns FALSE.
	If this function returns FALSE, *pVal is not touched."

    <api: TWAIN_GetCapCurrent ulong ulong struct boolean>
    ^self invalidArgument!
negotiatePixelTypes: wPixTypes
	" Low level - Negotiate with the source to restrict pixel types that can be acquired.
	This tries to restrict the source to a *set* of pixel types.
	See TWAIN_AcquireNative above for some mask constants.
	 --> This is only allowed in State 4 (TWAIN_SOURCE_OPEN)
	A parameter of 0 (TWAIN_ANYTYPE) causes no negotiation & no restriction.
	You should not assume that the source will honor your restrictions, even if this call succeeds!!
	"

    <api: TWAIN_NegotiatePixelTypes ulong boolean>
    ^self invalidArgument! 
drawDibToDC: hdc dx: dx dy: dy w: w h: h hdib: hdib sx: sx sy: sy
	" DIB handling utilities - Draws a DIB on a device context.
	You should call CreateDibPalette, select that palette into the DC, and do a RealizePalette(hDC) first. "

    <api: TWAIN_DrawDibToDC ulong ulong ulong ulong ulong handle ulong ulong none>
    ^self invalidArgument!  
capOneValue: cap type: itemType value: itemValue
	" Low level - Do a DAT_CAPABILITY/MSG_SET, on capability 'Cap' (e.g. ICAP_PIXELTYPE, CAP_AUTOFEED, etc.) using a TW_ONEVALUE container with the given item type and value.
	Obviously, the item value must fit into 32 bits.	"

    ^self setCapOneValue: cap type: itemType value: itemValue!  
closeSource
	" Low level - Closes the open Data Source, if any.
	If the source is enabled, disables it first.
	If there is not an open source, does nothing and returns TRUE."

    <api: TWAIN_CloseSource boolean>
    ^self invalidArgument! 
acquire
	"Acquires anEZTwainDIB and returns it (or nil if failed)."

	^self dibFromInteger: self acquireNative!
acquireNative
	" Private -  Acquires a single image of any type.
	Returns a handle to a EZTwainDIB."

	^self dll acquireNative!   
selectImageSource
	" Lets the user select the source medium."

	^self dll selectImageSource!   
hideUI
	"Returns the 'hide source user interface' flag."

	^self dll getHideUI!
loadFromPathName: pathName
	"   Load a .BMP file and return a DIB handle (as from AcquireNative.)
	if pathName isNil or an empty string the user will be prompted to determine file name. "

	^self dibFromInteger: (self dll loadNativeFromFilename: pathName)!  
hideUI: aBoolean
	"Sets the 'hide source user interface' flag."

	^self dll setHideUI: aBoolean asParameter!   
isAvailable
	" Basic TWAIN Inquiries - Find out if TWAIN is installed on the system. "

	^self dll isAvailable!
dibFromInteger: anInteger
	" Private - Returns anEZTwainDIB obtained from anInteger."

	^anInteger ~= 0 ifTrue: [ EZTwainDIB fromInteger: anInteger ].
	! 
acquireToPathName: pathName
	"  Acquire an image and write it to a .BMP (Windows Bitmap) file.
	if pathName isNil or an empty string the user will be prompted to determine file name. "

	^self dll acquireToFilename: nil pathName: pathName!   
pixelType
	"Returns the source for the current pixel type."

	^self dll getPixelType!  
pixelType: anInteger
	"Sets the source for the current pixel type."

	^self dll setPixelType: anInteger asParameter!   
acquireToClipboard
	" Like AcquireNative, but puts the resulting image, if any, into the system clipboard. "

	^self dll acquireToClipboard!   
dll
    "Returns the instance var of the receiver
     for external manipulation"

	dll isNil ifTrue: [ self initializeDll ].
    ^dll!  
dll: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    dll := anObject!   
initializeDll
	" Private - Initializes the receiver's dll"

	dll := EZTwainLibrary current.!   
asParameter
    "Returns the receiver as aParameter to be passed to an API call"

	^self handle asParameter!   
boundingBox
	"Returns the receiver's boundingBox."

	^0@0 extent: self extent! 
width
	" DIB handling utilities - Width of DIB, in pixels (columns). "

	self isValid ifFalse: [ ^0 ].
	^self dll dibWidth: self asParameter! 
displayAt: aPoint with: aPen
	"Display the receiver using aPen device context at source location."

	^self draw: self boundingBox with: aPen at: aPoint.!  
display: destination with: aPen at: source
	"Select the receiver's palette and display destination rectangle of the receiver using aPen device context at source location."

	^self draw: destination with: aPen at: source.!  
height
	" DIB handling utilities - Height of DIB, in pixels (columns). "

	self isValid ifFalse: [ ^0 ].
	^self dll dibHeight: self asParameter!  
asDIB
	"Returns aDIB from the receiver."

	^self isValid ifTrue: [ DIB fromHandle: self handle ]!  
asBitmap
	"Returns aBitmap from the receiver."

	^self isValid ifTrue: [ self asDIB asBitmap ]!
extent
	"Returns the receiver's extent."

	^self width @ self height!  
release
	"Release the receiver."

	self isValid ifTrue: [
		self dll freeNative: self asParameter.
		handle := nil.
	].
	super release!
handle: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    handle := anObject! 
handle
    "Returns the instance var of the receiver
     for external manipulation"
    ^handle!  
dibPalette
	"  DIB handling utilities - Create and return a logical palette handle to be used for drawing the DIB. "

	^self dll createDibPalette: self asParameter!   
draw: destination with: aPen at: source
	" Private - Display destination rectangle of the receiver using aPen device context at source location."

	self isValid ifFalse: [ ^false ].
	aPen allHandles do: [ :hdc |
		self dll
			drawDib: self asParameter
			toDC: hdc
			destination: destination
			source: source
	].
	^true! 
isValid
	"Returns true if the receiver is Valid."

	^self handle notNil and: [ self handle isValid ]!  
dibDepth
	" DIB handling utilities - Depth of DIB, in bits i.e. bits per pixel. "

	^self dll dibDepth: self asParameter!  
display
	"Display the receiver using display pen."

	^self draw: self boundingBox with: Display pen at: 0@0.!  
fromHandle: hDIB
    "Answer an instance of Bitmap copied from a memory dib handle hDIB.
    Implemented by Ale..."

    | addressPtr address bitmapInfo bits dib rgb bytes |
    #addedByOStyle.
	hDIB = 0 ifTrue: [ ^nil  ].
    (Smalltalk includesKey: #ExternalAddress)
    ifTrue: [    "32 bits version"
        ( addressPtr :=  KernelLibrary globalLock: hDIB asParameter) = 0 ifTrue: [ ^self osError ].
        address := (Smalltalk at: #ExternalAddress) fromInteger: addressPtr.
    ]
    ifFalse: [    "16 bits version"
        addressPtr := KernelLibrary globalLock: hDIB asParameter.
        address := (Smalltalk at: #WinAddress) fromString: addressPtr.
    ].
    bitmapInfo := WinBitmapInfoHeader new.
    bitmapInfo contents
        replaceFrom: 1
        to: bitmapInfo contents size
        with: address
        startingAt: 1.

    bitmapInfo bitCount = 24
    ifFalse: [
        rgb := ByteArray new:  (
            WinBitmapInfo
                colorTableSize: bitmapInfo bitCount
                clrUsed: bitmapInfo clrUsed).
        rgb
            replaceFrom: 1
            to: rgb size
            with: address
            startingAt: bitmapInfo contents size + 1.
    ].

    bitmapInfo := WinBitmapInfo fromBytes: (
        rgb isNil
            ifTrue: [ bitmapInfo contents ]
            ifFalse: [ bitmapInfo contents, rgb ] ).
    bitmapInfo sizeImage = 0
    ifTrue: [
        bytes := (((bitmapInfo width * bitmapInfo bitCount) + 31) // 32 * 4) * bitmapInfo height
    ]
    ifFalse: [bytes := bitmapInfo sizeImage].

    bits := ByteArray new: bytes.
    bits
        replaceFrom: 1
        to: bits size
        with: address
        startingAt: bitmapInfo contents size + 1.

    KernelLibrary globalUnlock: hDIB asParameter.
    ^self new
        bitmapInfo: bitmapInfo;
        bits: bits;
        yourself!