Copyright 1990-1992 Digitalk Inc.  All rights reserved

! Object class methods !
icon
    "Returns an appropiate icon for the receiver.
    Implemented By Ale."
    | icon validateIcon runtimeIcon |
    #addedByOStyle.
    runtimeIcon := Icon runtimeIcon.
    validateIcon := [
        icon isNil
        ifFalse: [
            icon handle = runtimeIcon
            ifTrue: [ "icon not found"
                icon release.
                icon := nil ]
            ifFalse: [^icon]
        ].
    ].

    icon := Icon fromModule: ObjectStyleDLL library name: self name.
    validateIcon value.

    " Busca en el icono de la superclase"
    self allSuperclasses
     do: [:each|
        icon := Icon fromModule: ObjectStyleDLL library name: each name.
        validateIcon value.
    ].

    ^nil! !

! Object methods !   
addedByOSI
    "Added by OSI. Execute the following to get a list
     of all methods added to base classes by WindowBuilder.

        Smalltalk sendersOf: #addedByOSI.

    "
    #addedByOSI!   
addedByOStyle
    "Added by Object Style.
    Execute the following to get a list
    of all methods added to base classes.

        Smalltalk sendersOf: #addedByOStyle.

    "
    #addedByOStyle!  
asParameter16
    "Answer the receiver in a form suitable for
     passing as a parameter to a 16bits API procedure call.
    Implemented by Ale for compatibility when porting to ST/V32s..."
    #addedByOStyle.
   ^self asParameter! 
asString

    "Added by OSI - Answer the receiver's string representation"

    | stream |

    #addedByOSI.
    stream := WriteStream on: String new.
    self printOn: stream.
    ^stream contents.!  
error: aString
    "Create a walkback window describing an error condition
     with the error message aString in the window label.
     Touched By Ale for class name notification"
    #modifiedByOStyle.
    Cursor reset.
    Process
        queueWalkback: '[',self errorReceiverName,']',aString
        makeUserIF: CurrentProcess isUserIF
        resumable: false!
errorReceiverName
    "Private - Returns the receiver's name used for error notifying.
     Implemented by Ale for message Object>>#error:"
    #addedByOStyle.
    ^self class name! 
fileInActivate: anObjectFiler
        " Activate instance which has just been loaded.
         Default is to do nothing.
        To notify user of non-fatal problem send:
                anObjectFiler recordInfoMessage: 'info message'
                anObjectFiler recordWarningMessage: 'warning message'
        "
    ^self!  
fileOutSurrogate: anObjectFiler
        " Answer surrogate for object filing after performing any
        dump preprocessing.  Default is to do nothing.
        To notify user of non-fatal problem send:
                anObjectFiler recordInfoMessage: 'info message'
                anObjectFiler recordWarningMessage: 'warning message'
        "
    ^self!  
icon
    "Returns the icon associated with the receiver.
     Implemented by Ale."
    #addedByOStyle.
    ^self class icon!  
ifNil: aBlock

    "Added by OSI. This replaces the construct 'isNil ifTrue: []'.
     In this case self is NOT nil"

    #addedByOSI.
    ^self!   
initWindow
    "Added by OSI"
    #addedByOSI.! 
isCompositePane

    "Added by OSI"
    #addedByOSI.
    ^false!  
isDictionary

    "Added by OSI"
    #addedByOSI.
    ^false! 
isInterfaceObject
    "Added by OSI"
    #addedByOSI.
    ^false!  
isMDIFrame

    "Added by OSI - Added to eliminate the isKindOf: in
      NotificationManager>>activeWindow to improve performance."
    #addedByOSI.
    ^false!
isMessage

    "Added by OSI"
    #addedByOSI.
    ^false!
isObjectFromResource
    "Answer true if receiver is a kind of ObjectFromResource."
    #addedByOStyle.
    ^false!
isRadio

    "Added by OSI"
    #addedByOSI.
    ^false!  
isRectangle

    "Added by OSI"
    #addedByOSI.
    ^false!  
isStatusPane
        "Answer true if receiver is an instance of class
         StatusPane, else answer false."

    ^false!   
isSubPane

    "Added by OSI"
    #addedByOSI.
    ^false!
isToolPane
        "Answer true if receiver is an instance of class
         ToolPane, else answer false."

    ^false!   
isWBAction

    "Added by OSI"
    #addedByOSI.
    ^false!   
isWBClassBrowser
    "Added by OSI"
    #addedByOSI.
    ^false!   
isWBInternalClass
    "Added by OSI"
    #addedByOSI.
    ^false!  
isWBWindow

    "Added by OSI- Added to eliminate the respondsTo: in
      NotificationManager>>readWinQueue to improve performance."
    #addedByOSI.
    ^false!   
loadBy: aLoader
    aLoader load: self!  
minWindowSize
    "Added by OSI"
    #addedByOSI.
    ^nil!
modifiedByOSI
    "Added by OSI. Execute the following to get a list
     of all base class methods modified by WindowBuilder.

        Smalltalk sendersOf: #modifiedByOSI.

    "
    #addedByOSI.!  
modifiedByOStyle
    "Added by Object Style.
    Execute the following to get a list
    of all base class methods modified.

        Smalltalk sendersOf: #modifiedByOStyle.

    "
    #addedByOStyle.! 
notFullyImplemented
    "Alert the user because the method
     has not been fully implemented yet..."
    #addedByOStyle.
    MessageBox warning: 'Not Fully implemented.\Yet...' withCrs!   
notImplementedYet
    "Generates an error because the method
     has not been implemented"
    #addedByOStyle.
    ^self error: 'Not implemented. Yet...'!   
openWindow
    "Added by OSI"
    #addedByOSI.! 
preInitWindow
    "Added by OSI"
    #addedByOSI.!  
rehash
     "Rehashing of the receiver.
     Used by Loader for restoring objects.
     Implemented by Ale.."
    #addedByOStyle.
    "This method can be refined by subclasses"!
statusPaneHelp:aKey
    "Answer the hint text used by
    the StatusPane for help support.
    aKey is the selector of highlighted menu item.
    Touched By Ale for no global var needed"

    #modifiedByOStyle.
    ^(Smalltalk at: #HelpStatusPane ifAbsent: [^nil]) at:aKey ifAbsent:[]!  
unloadBy: aLoader
    "Write out the instance variables of the receiver
     using the loader object aLoader."
    aLoader unload: self! !

! Behavior methods ! 
allMethodsReferencingInstVar: instName
    "Source rebuilded by Ale..."
    #modifiedByOStyle.
    ^((self allMethodsAssigningInstVar: instName)
    , (self allMethodsUsingInstVar: instName)) asSet!
comment: aString
    "Change the receiver's comment.
     Added by Ale.."
    #addedByOStyle.
    comment := aString! 
compiledMethods
    "Answer all the compiled code of the methods
     defined in the receiver.
     Modified by Ale.."
    #modifiedByOStyle.
    ^self methodDictionary!
deletedSources
    "Returns the name of the methos without source code.
    Implemented By Ale..."
    #addedByOStyle.
    ^self selectors
        select: [:each|
            (self compiledMethodAt: each) sourceString isNil
        ]! 
removeSources
    "Remove all the in the receiver.
    Implemented by Ale..."
    #addedByOStyle.
    self selectors do: [:each| self removeSourcesOfSelector: each]! 
removeSourcesOfSelector: aSymbol
    "Remove the sources of the method named aSymbol.
    Implemented by Ale..."
    | method |
    #addedByOStyle.
    method := self compiledMethodAt: aSymbol.
    method isNil ifTrue: [^self error: 'Method ',aSymbol,' not found'].
    (method byteCodeArray isInDLL)
    ifFalse: [ method sourceIndex: 0 sourcePosition: 0 ]! !

! Class methods ! 
fileOutOn: aStream
        "Append the class definition message
         for the receiver to aStream.
    Touched by Ale for comment: support..."
    | aString |
    aStream cr;
        nextPutAll: self superclass printString; space;
        nextPutAll: self kindOfSubclass; space;
        nextPutAll: name storeString; cr; space; space.
    self isBits
        ifFalse: [
            aStream nextPutAll: 'instanceVariableNames: '.
            (aString := self instanceVariableString) isEmpty
                ifFalse:[aStream cr; nextPutAll: '    '].
            aStream
                nextPutAll: aString storeString;
                cr; space; space].
    aStream
        nextPutAll: 'classVariableNames: '.
    (aString := self classVariableString) isEmpty
        ifFalse:[aStream cr; nextPutAll: '    '].
    aStream
        nextPutAll: aString storeString; cr; space; space;
        nextPutAll: 'poolDictionaries: '.
    (aString := self sharedVariableString) isEmpty
        ifFalse:[aStream cr; nextPutAll: '    '].
    aStream
        nextPutAll: aString storeString

    .#modifiedByOStyle.
    comment size > 0
    ifTrue: [
        aStream nextPutAll: '.';cr;cr;
            nextPutAll: '  (Smalltalk at: #',name,') comment: ',comment storeString
    ].! 
removeFromSystem
    "Remove the receiver from Smalltalk.  Report
    an error if there are instances of the receiver.
    Touched by Ale to support subclasses & instances remotion"
    | index index2 allInstances |
    ((OrderedCollection new
        add: UndefinedObject;
        add: Class;
        add: True;
        add: False;
        add: DeletedClass;
        add: EmptySlot;
        add: SmallInteger;
        add: UnresolvedObject;
        yourself)
            includes: self)
                ifTrue: [^self error: 'Class cannot be removed.'].
    #modifiedByOStyle.
    (allInstances := self allInstances) notEmpty ifTrue: [
        (MessageBox confirm: 'Class ',self name,' has instances.',
            '\Do you want to eliminate them ?' withCrs)
        ifTrue: [ allInstances do: [:each| each become: String new ] ]
        ifFalse: [^self error: 'Has Instances'].
    ].
    self allSubclasses notEmpty ifTrue: [
        self subclasses do: [:each| each removeFromSystem]
    ].
    Smalltalk removeKey: self symbol ifAbsent: [].
    index := TableOfClasses indexOf: self class.
    index2 := TableOfClasses indexOf: self.
    self class superclass == nil ifFalse:
        [self class superclass
             removeSubclass: self class].
    self class become: DeletedClass class.
    self superclass == nil ifFalse:
        [self superclass removeSubclass: self].
    self become: DeletedClass.
    TableOfClasses at: index put: TableOfClassesFreeListHead.
    TableOfClassesFreeListHead := index.
    TableOfClasses at: index2 put: TableOfClassesFreeListHead.
    TableOfClassesFreeListHead := index2!   
removeSources
    "Remove all the sources in the receiver.
    Implemented by Ale..."
    #addedByOStyle.
    super removeSources.
    self class removeSources! 
sortedSubclasses

    "Added by C&P.  Strip out Digitalk's hidden classes and sort."

    ^((self subclasses reject: [:c | c symbol trimBlanks isEmpty ]) asSortedCollection: [:a :b | a name < b name ]) asOrderedCollection! !

! MetaClass methods ! 
comment: aString
    "Change the receiver's comment.
    Implemented by Ale..."
    #addedByOStyle.
    ^self instanceClass comment: aString! 
name: newName
    environment: aSystemDictionary
    subclassOf: superclass
    instanceVariableNames: stringOfInstVarNames
    variable: variableBoolean
    words: wordBoolean
    pointers: pointerBoolean
    classVariableNames: stringOfClassVarNames
    poolDictionaries: stringOfPoolNames
    comment: commentString
    changed: changed
        "Private - Create or modify the class and the metaclass
         of name newName to be as defined by the arguments.
    Touched by Ale for nil superclass support..."
    | answer aStream aSymbol |
    #modifiedByOStyle.
    (aSystemDictionary includesKey: newName)
        ifTrue: [answer := aSystemDictionary at: newName]
        ifFalse: [
            answer := self new.
            answer assignClassHash.
            superclass isNil
                ifTrue: [answer superclass: nil]
                ifFalse: [
                    superclass addSubclass: answer.
                    self superclass addSubclass: self].
            answer
                initializeClass;
                rename: newName in: aSystemDictionary].
    answer
        pointer: pointerBoolean word: wordBoolean
            variable: variableBoolean;
        instVarNames: stringOfInstVarNames;
        classVarNames: stringOfClassVarNames;
        sharedPools: stringOfPoolNames;
        comment: commentString.

    aStream := WriteStream on: (String new: 64).
    answer fileOutOn: aStream.
    Smalltalk
        logSource: aStream contents
        forClass: answer.
    answer compileAll.
    answer class compileAll.
    answer allSubclasses do: [ :aClass |
        aClass compileAll.
        aClass class compileAll].

    ^answer! !

! CategoryManager class methods !  
addCategory: aCategory
 "Add a new category"
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^false ].
 (Categories includesKey: aCategory)
  ifTrue: [ ^false ].
 Categories at: aCategory put: CategorySet new.
 ^true!
addClass: aClass toCategory: aCategory
 "Add a class to a category"
 | cc cls |
 self makeValid.
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^false ].
 cls := self instanceClassNameOf: aClass.
 (Smalltalk at: cls asSymbol ifAbsent: [ ^false ]) isClass
  ifFalse: [ ^false ].
 cc := Categories at: aCategory ifAbsent: [ Categories at: aCategory put: CategorySet new ].
 (cc includes: cls)
  ifTrue: [ ^false ].
 cc add: cls.
 cc add: (cls,' class').
 ^true.! 
addMethod: aMethod toCategory: aCategory inClass: aClass
 "add a new method to a category in a class"
 | cls1 cls d |
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^false ].
 cls1 := self instanceClassNameOf: aClass.
 cls := self realClassNameOf: aClass.
 (((cls includes: $ )
  ifFalse: [ (Smalltalk at: cls1 asSymbol ifAbsent: [ ^false ]) ]
  ifTrue: [ (Smalltalk at: cls1 asSymbol ifAbsent: [ ^false ]) class ])
    selectors includes: aMethod)
     ifFalse: [ ^false ].
 self makeValid.
 self addMethodCategory: aCategory toClass: cls.
 d := (Classes at: cls) at: aCategory.
 (d includes: aMethod)
  ifTrue: [ ^false ].
 d add: aMethod.
 ^true!
addMethodCategory: aCategory toClass: aClass
 "add a new methodcategory to a class"
 | cls d |
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^false ].
 cls := self realClassNameOf: aClass.
 d := Classes at: cls ifAbsent: [ Classes at: cls put: (d := Dictionary new). d ].
 (d includesKey: aCategory)
  ifTrue: [ ^false ]
  ifFalse: [ d at: aCategory put: CategorySet new.
   ^true ].!
categories
 "return a list of all categories"
 | sc |
 sc := SortedCollection new.
 sc add: '- ALL -'.
 self makeValid.
 sc addAll: (Categories keys).
 ^sc!   
categoriesCV
 "return the classvariable Categories"
 ^Categories!   
categoriesForClass: aClass
 "return a list of categories in which the aClass is stored"
 | cls sc |
 cls := self instanceClassNameOf: aClass.
 self makeValid.
 sc := SortedCollection new.
 Categories associationsDo: [ :as |
  (as value includes: cls)
   ifTrue: [ sc add: as key ]
 ].
 ^sc!  
category: aCategory comment: aString
 "Put a comment to a Category"
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^false ].
 (Categories includesKey: aCategory)
  ifFalse: [ ^false ].
 (Categories at: aCategory) comment: aString.
 ^true!  
classClassesAt: aCategory
 "return a list of MetaClasses which are stored in aCategory"
 ^self instanceClassesAt: aCategory!
commentAt: aCategory
 "return the comment for aCategory"
 | sc s |
 self makeValid.
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^String new ].
 ^(Categories at: aCategory ifAbsent: [ CategorySet new ]) comment!
copyCategory: aCategory to: aNewCategory
 "copy one category to another"
 | nc |
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^false ].
 self makeValid.
 (self instanceClassesAt: aCategory) do: [ :cls |
  self addClass: cls toCategory: aNewCategory ]!   
copyMethodCategory: aCategory fromClass: aClass to: aNewCategory
 "copy a methodcategory to another"
 | cls d |
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^false ].
 (self invalidCategories includes: aNewCategory)
  ifTrue: [ ^false ].
 cls := self realClassNameOf: aClass.
 d := Classes at: cls ifAbsent: [ ^false ].
 (d at: aCategory ifAbsent: [ Set new ])
  do: [ :mth | self addMethod: mth toCategory: aNewCategory inClass: aClass ].
 ^true!   
fileCategoriesInFrom: aStream
 "reconfiurate the categories"
 | co w1 w2 cc mc cl me |
 [aStream atEnd]
  whileFalse: [ w1 := self nextWordFrom: aStream.
   w1 = 'CC'
    ifTrue: [ cc := self nextWordFrom: aStream. ].
   w1 = 'CO'
    ifTrue: [ co := (aStream next: ((self nextWordFrom: aStream) asInteger)).
     self nextWordFrom: aStream.
     self addCategory: cc.
     self category: cc comment: co ].
   w1 = 'CL'
    ifTrue: [ cl := self nextWordFrom: aStream. ].
   w1 = 'MC'
    ifTrue: [ mc := self nextWordFrom: aStream. ].
   w1 = 'ME'
    ifTrue: [ me := self nextWordFrom: aStream. ].
   w1 = 'C'
    ifTrue: [ self addClass: cl toCategory: cc. ].
   w1 = 'M'
    ifTrue: [ self addMethod: me asSymbol toCategory: mc inClass: cl. ].
  ].!
fileCategoriesOutOn: aStream
 "Save the Classes and Categories on aStream"
 Categories associationsDo: [ :as |
  (as key first ~= $-)
   ifTrue: [ aStream nextPutAll: 'CC@',as key,'@';cr.
    as value comment isEmpty
     ifFalse: [ aStream nextPutAll: 'CO@',as value comment size printString,'@',as value comment,'@';cr. ].
    as value do: [ :c |
     (c includes: $ )
      ifFalse: [ aStream nextPutAll: 'CL@',c,'@C@';cr ]. ].
   ].
 ].
 aStream nextPutAll: 'CC@- ALL -@';cr.
 Classes associationsDo: [ :as |
  aStream nextPutAll: 'CL@',as key,'@';cr.
  as value associationsDo: [ :mas |
   (mas key first ~= $-)
    ifTrue: [ aStream nextPutAll: 'MC@',mas key,'@';cr.
     mas value do: [ :mmas |
      aStream nextPutAll: 'ME@',mmas,'@M@';cr ].
    ].
  ].
 ].! 
instanceClassesAt: aCategory
 "return a list of classes which are stored in aCategory"
 | sc s |
 self makeValid.
 sc := SortedCollection new.
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^sc ].
 ((Categories at: aCategory ifAbsent: [ Set new ])
  select: [ :i | (i indexOf: $ ) = 0 ]) do: [ :c |
   s := c asSymbol.
   (Smalltalk at: s ifAbsent: [ self removeClass: c. nil ])
    isClass ifTrue: [ sc add: c ]. ].
 ^sc! 
instanceClassNameOf: aClass
 "returns the name of the class aClass as a String"
 aClass isString
  ifTrue: [ (aClass includes: $ )
   ifTrue: [ ^aClass copyFrom: 1 to: (aClass indexOf: $ ) - 1 ]
   ifFalse: [ ^aClass ] ]
  ifFalse: [ (aClass isClass)
   ifTrue: [ ^aClass name ]
   ifFalse: [ ^aClass instanceClass name ] ].! 
invalidCategories
 "return an Array of invalid categories"
 ^#('- ALL -' '- No Category -')!
makeValid
 "Initialize the classvariables"
 Categories isNil
  ifTrue: [ Categories := Dictionary new ].
 Classes isNil
  ifTrue: [ Classes := Dictionary new ].!
methodCategoriesForClass: aClass
 "return a list of methodcategories for aClass"
 | cls sc |
 cls := self realClassNameOf: aClass.
 self makeValid.
 sc := SortedCollection new.
 sc addAll: self invalidCategories.
 (Classes at: cls ifAbsent: [ Dictionary new ])
  associationsDo: [ :as | sc add: as key ].
 ^sc!   
methodsForMethodCategory: aCategory forClass: aClass
 "returns a list of methods belonging to aCategory"
 | cls1 d cls sc |
 cls := self realClassNameOf: aClass.
 self makeValid.
 sc := SortedCollection new.
 (cls includes: $ )
  ifTrue: [ cls1 := (Smalltalk at: (self instanceClassNameOf: aClass) asSymbol) class. ]
  ifFalse: [ cls1 := (Smalltalk at: (self instanceClassNameOf: aClass) asSymbol). ].

 (self invalidCategories includes: aCategory)
  ifTrue: [
   cls1 selectors do: [ :s | sc add: s ].
   (aCategory = '- ALL -')
    ifTrue: [ ^sc ].
   cls1 := self realClassNameOf: aClass.
   d := Classes at: cls ifAbsent: [ ^sc ].
   d associationsDo: [ :as |
    as value do: [ :m |
     sc remove: m ifAbsent: []
    ].
   ].
   ^sc
   ].
 d := (Classes at: cls ifAbsent: [ ^sc ]).
 sc := d at: aCategory ifAbsent: [ ^sc ].
 sc do: [ :m |
 (cls1 selectors includes: m)
  ifFalse: [ sc remove: m ].
 ].
 sc := sc asSortedCollection.
 ^sc!
nextWordFrom: aFileStream
 "return the next word from aStream"
 | s c |
 s := String new.
 [aFileStream atEnd]
  whileFalse: [ c := aFileStream next.
   c = $@
    ifTrue: [ ^s ]
    ifFalse: [ (c < $ )
  ifFalse: [ s := (s , (String with: c)) ]]].
 ^s!   
realClassNameOf: aClass
 "returns the name of the class aClass as a String"
 aClass isString
  ifTrue: [ ^aClass ]
  ifFalse: [ ^aClass name ]!   
removeCategory: aCategory
 "remove a category"
 self makeValid.
 Categories removeKey: aCategory ifAbsent: [ ^false ].
 ^true!
removeClass: aClass
 "remove aClass from the CategoryManager"
 | d cls |
 cls := self instanceClassNameOf: aClass.
 self makeValid.
 Classes removeKey: cls ifAbsent: [].
 Classes removeKey: (cls,' class') ifAbsent: [].
 Categories do: [ :s |
  s remove: cls ifAbsent: [].
  s remove: (cls,' class') ifAbsent: [].
 ].
 ^true!   
removeClass: aClass fromCategory: aCategory
 "remove aClass from the category aCategory"
 | d cls |
 cls := self instanceClassNameOf: aClass.
 self makeValid.
 d := Categories at: aCategory ifAbsent: [ ^false ].
 d remove: cls ifAbsent: [ ^false ].
 d remove: (cls,' class') ifAbsent: [ ^false ].
 ^true!  
removeMethod: aMethod fromClass: aClass
 "remove a method from aClass"
 | cls d |
 cls := self realClassNameOf: aClass.
 self makeValid.
 d := Classes at: cls ifAbsent: [ ^false ].
 d associationsDo: [ :as |
  as value remove: aMethod ifAbsent: [] ].
 ^true!
removeMethod: aMethod toCategory: aCategory inClass: aClass
 "remove a method from aCategory in aClass"
 | cls d |
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^false ].
 cls := self realClassNameOf: aClass.
 self makeValid.
 d := (Classes at: cls) at: aCategory ifAbsent: [ ^false ].
 d remove: aMethod ifAbsent: [ ^false ].
 ^true!   
removeMethodCategory: aCategory fromClass: aClass
 "remove methodcategory from a class aClass"
 | cls d |
 cls := self realClassNameOf: aClass.
 d := Classes at: cls ifAbsent: [ ^false ].
 d removeKey: aCategory ifAbsent: [ ^false ].
 ^true!   
renameCategory: aCategory to: aNewCategory
 "rename a category"
 self makeValid.
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^false ].
 (self invalidCategories includes: aNewCategory)
  ifTrue: [ ^false ].
 (Categories includesKey: aNewCategory)
  ifTrue: [ ^false ].
 Categories at: aNewCategory put:
  (Categories at: aCategory ifAbsent: [ ^false ]).
 Categories removeKey: aCategory.
 ^true!  
renameMethodCategory: aCategory fromClass: aClass to: aNewCategory
 "rename a methodcategory"
 | cls d |
 (self invalidCategories includes: aCategory)
  ifTrue: [ ^false ].
 (self invalidCategories includes: aNewCategory)
  ifTrue: [ ^false ].
 cls := self realClassNameOf: aClass.
 d := Classes at: cls ifAbsent: [ ^false ].
 (d includesKey: aNewCategory)
  ifTrue: [ ^false ].
 d at: aNewCategory put: (d at: aCategory ifAbsent: [ ^false ]).
 d removeKey: aCategory.
 ^true! 
reset
 "Initialize the classvariables new"
 Categories := Dictionary new.
 Classes := Dictionary new.! !

! ClipboardManager methods !   
setBitmap: aBitmap
    "Copy aBitmap to the clipboard.
    Patched by Ale for no bitmap garbage collection
     of bitmap in clipboard.
    Touched By Ale..."
    |clipboardBitmap handle|
    (aBitmap isNil or: [aBitmap handle isNil]) ifTrue: [^nil].
    self open ifFalse: [^nil].
    handle := aBitmap handle.
    clipboardBitmap := Bitmap fromHandle: aBitmap handle.
    UserLibrary emptyClipboard.
    UserLibrary setClipboardData: CfBitmap
        hMem: clipboardBitmap handle.
    clipboardBitmap removeTableReferences. "Ale Patch"
    #modifiedByOStyle.
    self close! !

! OSClipboardManager class methods ! 
aboutToSaveImage
    "Private - Register the receiver if needed..."

    super aboutToSaveImage.

    "Register the receiver for notification at startUp..."
    (Smalltalk startUpObjects includes: self) ifTrue: [^self].
    Smalltalk notifyAtStartUp: self.

    "Change the Clipboard object to be an instance of the receiver..."
    (Clipboard isMemberOf: self)
    ifFalse: [
        Clipboard := self new
    ].!   
startUp
    "Private - Prepare the receiver for startUp..."

    super startUp.
    UserFormats := Dictionary new.
    Open := false.! !

! OSClipboardManager methods !   
clear
    "Clear the contents of the clipboard."
    | result |
    self open ifFalse: [self close.^nil].
    result := self empty.
    self close.
    ^result!
close
    "Close the clipboard, if opened."
    Open ifFalse: [ ^nil ].
    super close.
    Open := false!   
containsBitmap
    "Answer whether the clipboard contains a bitmap."
    ^self containsFormat: CfBitmap!
containsMetaFile
    "Answer whether the clipboard contains a metafile."
    ^self containsFormat: CfMetafilepict!  
containsObject
    " Answer whether the clipboard contains an object. "
    ^self containsFormat: self formatObject!
containsText
    "Answer whether the clipboard contains text."
    ^self containsFormat: CfText!
empty
    "Private - empty the clipboard. Note: it must be opened first."
    ^UserLibrary emptyClipboard!  
formatNamed: aString
    "Answer the clipboard format named aString.
     Register the format if not previously defined."

    ^UserFormats
        at: aString
        ifAbsent: [ self registerFormat: aString ]! 
formatObject
    " Answer the clipboard format for Smalltalk objects "
    ^self formatNamed: 'Object Style Object'!
getObject
    "Answer the contents of the clipboard as an object,
     or nil if the clipboard is empty or cannot render an object."

    ^self getObject: self formatObject! 
getObject: aFormat
    "Private - Answer the contents of the clipboard as an object,
     or nil if the clipboard is empty or cannot render an object
     in aFormat."
    | hText lpText addr size filedObject |
    self open ifFalse: [self close. ^nil].
    (self containsFormat: aFormat) ifFalse: [self close. ^nil].

    ( hText := UserLibrary getClipboardData: aFormat ) = 0 ifTrue: [self close. ^nil].

    lpText := KernelLibrary globalLock: hText.
    lpText := WinLong integerFrom: lpText. #modifiedByOStyle.
    addr := WinAddress fromInteger: lpText.
    size := (String fromAddress: addr length: 4) asStream nextULong.
    addr := WinAddress fromInteger: lpText + 4.
    filedObject := String fromAddress: addr length: size.
    KernelLibrary globalUnlock: hText.

    self close.

    ^ObjectFiler loadFrom: (ReadWriteStream on: filedObject)! 
getStringOrNil
    "Answer the contents of the clipboard as a String, or nil
     if the clipboard is empty or cannot render a string."
    | a hText lpText s |
    (self containsFormat: CfText) ifFalse: [^nil].
    self open ifFalse: [^nil].
    (hText := UserLibrary getClipboardData: CfText) = 0
        ifTrue: [
            self close.
            ^nil].
    lpText := KernelLibrary globalLock: hText.
    a := WinAddress fromBytes: lpText.
    a highHalf = 0
        ifTrue: [s := nil]
        ifFalse: [s := String fromAddress: a].
    KernelLibrary globalUnlock: hText.
    self close.
    ^s!
open
    "Open the clipboard."
    ^Open := super open! 
registerFormat: aString
    "Register aString as a user-defined clipboard format.
     Answer the format."
    | aFormat |
    (aFormat := UserLibrary registerClipboardFormat: aString asParameter) = 0
    ifTrue: [ ^self error: 'Can''t register clipboard format named ',aString ].
    UserFormats at: aString put: aFormat.
    ^aFormat!   
setObject: anObject
    "Set the contents of the clipboard to anObject."
    self setObject: anObject format: self formatObject.!   
setObject: anObject format: aFormat
    "Private - Set the contents of the clipboard to anObject
     using format aFormat."
    | filedObject size description |
    filedObject := WriteStream on: (String new: 1024).
    filedObject nextULongPut: 0.  " size placeholder "
    ObjectFiler dump: anObject on: filedObject.
    size := filedObject position.
    filedObject
        reset;
        nextULongPut: ( size - 4 ).  " size of filed object itself "
    filedObject := filedObject copyFrom: 1 to: size.
    self open ifFalse: [^nil].
    self empty.
    UserLibrary
        setClipboardData: aFormat
        hMem: (WinAddress memoryHandleFrom: filedObject asParameter).
    description := (UserFormats keyAtValue: aFormat), ' (', anObject printString, ')'.
    UserLibrary
        setClipboardData: CfDsptext
        hMem: (WinAddress memoryHandleFrom: description asParameter).
   self close.! !

! CodeManager methods !  
closeNotifier
    "Private - Close the notifier if present and working on file..."

    notifier isNil ifTrue: [ ^self ].
    notifier isStream ifTrue: [ notifier close ].

    notifier := nil.!  
notifier
    "Returns the receiver's notification stream;
    it will be created if needed..."

    notifier isNil ifTrue: [
        notifier := (MessageBox confirm: 'Quiere archivo de reportes ?')
        ifTrue: [ (File pathName: 'SysDmp.log') setToEnd;yourself ]
        ifFalse: [
            TextWindow new
                label: self class name,' Trazando...';
                openOn: String new;
                yourself
        ].
    ].
    ^notifier!
notifier: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    notifier := anObject! 
notify: stage
    "Clear receiver's contents and notify about a new stage"

    | line |
    (self notifier respondsTo: #pane)
    ifTrue: [ self notifier pane selectAll; clearSelection ]
    ifFalse: [
        line := String new: 100.
        line atAllPut: $-.
        self show: line
    ].
    self show: stage.!   
promptFileName: fileSpec
    "Private - Lets the user select a file name.
    Returns the fileName or nil if cancelled..."

    ^self promptFileName: fileSpec showAll: true! 
promptFileName: fileSpec showAll: aBoolean
    "Private - Lets the user select a file name.
    Returns the fileName or nil if cancelled..."

    | dialog |
    dialog := FileDialog new.
    dialog
        title: 'Seleccione el archivo...';
        yourself.
    aBoolean ifTrue: [
        dialog
            addFilter: '*.pol' description: 'Diccionario de Objetos (*.POL)';
            addFilter: '*.glb' description: 'Objetos globales (*.GLB)';
            addFilter: '*.vob' description: 'Cdigo de componentes (*.VOB)';
            yourself.
    ].
    dialog
        addFilter: '*.vin' description: 'Libreras de componentes (*.VIN)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        defFilter: fileSpec;fileSpec: fileSpec;
        hideReadonly;
        open.
    ^dialog file! 
show: message
    "Private - Show the message onto the notifier window..."

    self notifier cr;show: message!
useSources
    "Returns true if the receiver must consider source code..."

    useSources isNil ifTrue: [ useSources := MessageBox confirm: 'Desea usar cdigo fuente?' ].
    ^useSources!  
useSources: aBoolean
    "Force the receiver to consider sourceCode (or not)..."

    useSources := aBoolean! !

! ClassExport methods ! 
canDump: anObject
    "Private - True if the receiver can dump anObject"

    ^anObject isNil
    or: [ anObject isSymbol
    or: [ anObject isNumber
    or: [ anObject isCharacter
    or: [ anObject isString
    or: [ anObject isArray
    or: [ anObject isByteArray
    or: [ anObject isCompiledMethod
    or: [ (anObject isKindOf: Behavior)
    or: [ anObject == true
    or: [ anObject == false
    or: [ anObject class == Dictionary ]]]]]]]]]]]!   
dump: anObject into: aStream
    "Private - Dump anObject structure into aStream"

    | temp |

    anObject isNil ifTrue: [aStream nextPut: $n. ^self].    "n=nil"
    anObject isSymbol ifTrue: [aStream nextPut: $#;nextPutAll: anObject;cr. ^self]. "#=symbol"
    anObject isCompiledMethod ifTrue: [ ^self dumpCompiledMethod: anObject into: aStream ]. "m=compiledMethod"
    anObject isFloat ifTrue: [aStream nextPutAll: 'f',anObject asString trimBlanks;cr. ^self]. "f=float"
    anObject isInteger ifTrue: [aStream nextPutAll: anObject asString trimBlanks;cr. ^self]. "[-]digit=number"
    anObject isCharacter ifTrue: [aStream nextPut: $$;nextPutAll: anObject asciiValue asString;cr. ^self]."$=character"
    anObject isAssociation ifTrue: [ ^self dumpAssociation: anObject into: aStream ]. "?=assoc"
    anObject = true ifTrue: [aStream nextPut: $T. ^self]. "T=true"
    anObject = false ifTrue: [aStream nextPut: $F. ^self]. "F=false"
    anObject isString ifTrue: [ "s[size]=string"
        aStream nextPut: $s;nextPutAll: anObject size asString;cr;nextPutAll: anObject.
        ^self
    ].
    anObject isByteArray ifTrue: [ "b[size]=byteArray"
        aStream nextPut: $b;nextPutAll: anObject size asString;cr;nextPutAll: anObject asString.
        ^self
    ].
    anObject isArray ifTrue: [ "a[size](elements...)=array"
        aStream nextPut: $a;nextPutAll: anObject size asString;cr.
        anObject do: [:each| self dump: each into: aStream].
        ^self
    ].
    anObject class == Dictionary ifTrue: [ "d[name][size](elements...)=dictionary"
        (Smalltalk keyAtValue: anObject) notNil ifTrue: [
            self show: 'Bajando pool : ',(Smalltalk keyAtValue: anObject)
        ].
        aStream
            nextPut: $d;
            nextPutAll: (Smalltalk keyAtValue: anObject ifAbsent: [String new]);cr;
            nextPutAll: anObject contents size asString;cr.
        anObject contents do: [:each|
            self
                dump: ((each notNil and: [ self canDump: each value ])
                    ifTrue: [ Array with: each key with: each value ])
                into: aStream
        ].
        ^self
    ].
    anObject isClass ifTrue: [ ^self dumpClass: anObject into: aStream ]. "c=class"

    self error: 'Objeto de clase no soportada : ', anObject class name!
dumpAssociation: assoc into: aStream
    "Private - Dump the association into aStream (lookUp key for global variable reference...)"

    aStream nextPut: $?.
    self dump: assoc key into: aStream.
    "values must be bound during loading..."! 
dumpClass: anObject into: aStream
    "Private - Dump class structure information into aStream"

    | temp |
    temp := ReadWriteStream on: String new.
    self useSources ifTrue: [ anObject fileOutOn: temp ].

    self show: 'Bajando clase : ',anObject name.
    aStream nextPut: $c;nextPutAll: anObject name;cr.
    self
       "1" dump: (anObject superclass notNil ifTrue: [anObject superclass symbol]) into: aStream;
       "2" dump: anObject structure into: aStream;
       "3" dump: anObject isPointers into: aStream;
       "4" dump: anObject kindOfSubclass into: aStream;
       "5" dump: anObject instanceVariableString into: aStream;
       "6" dump: (anObject instVarAt: (anObject class allInstVarNames indexOf: 'comment')) into: aStream;
       "7" dump: anObject classVariableString into: aStream;
       "8" dump: anObject sharedVariableString into: aStream;
       "9" dumpMethodsOf: anObject class into: aStream;
       "10" dumpMethodsOf: anObject into: aStream;
       "11" dump: temp contents into: aStream. "source code"!   
dumpClasses: aCollection
    "Dump classes structure information..."

    | file all |
    file := File newFile: 'Classes.dmp'.
    file lineDelimiter: Lf.
    all := OrderedCollection new.
    aCollection do: [:cls| all addAll: cls withAllSubclasses ].
    all remove: self class ifAbsent: []. "don't dump me..."
    self dump: all asArray into: file.
    file close.
    self closeNotifier.!  
dumpCompiledMethod: anObject into: aStream
    "Private - Dump a compiled method structure into aStream"

    | source |
    source := self useSources ifTrue: [ anObject sourceString ].
    aStream
        nextPut: $m;
        nextPutAll: anObject classField asString;cr;
        nextPutAll: anObject selector;cr.
    self
        dump: anObject byteCodeArray isInDLL into: aStream; "Original St/V method..."
        dump: anObject byteCodeArray into: aStream;
        dump: anObject asArray into: aStream; "dump literals..."
        dump: anObject primitive into: aStream;
        dump: source into: aStream;
        yourself.!   
dumpGlobals: aCollection
    "Dump globals named in to aCollection..."

    | file |
    file := File newFile: 'Globals.dmp'.
    file lineDelimiter: Lf.
    self
        dump: (aCollection asArray
            collect: [:global| Array with: global with: (Smalltalk at: global asSymbol) ])
        into: file.
    file close.
    self closeNotifier.!  
dumpMethodsOf: aClass into: aStream
    "Private - Dump the methods of aClass into aStream"

    | collection |
    collection := aClass selectors asSortedCollection asArray
        collect: [:symbol| aClass compiledMethodAt: symbol ].
    self dump: collection into: aStream!
dumpPools: aCollection
    "Dump pool dictionaries associated to aCollection of classes (and it's subclasses)..."

    | file all conflictive |
    file := File newFile: 'Pools.dmp'.
    file lineDelimiter: Lf.
    all := Set new.
    aCollection do: [:cls|
        cls withAllSubclasses do: [:each|
            all addAll: each sharedPools ]
    ].

    conflictive := #(
        WBConstants "same as WinConstants..."
        CommonDialogConstants
        CursorConstants
        "CharacterConstants
        FunctionKeys" ).

    conflictive do: [:each| "remove conflictive pool dictionaries..."
        all remove: each ifAbsent: []
    ].

    self
        dump: (all asArray collect: [:pool| Smalltalk at: pool ])
        into: file.
    file close.
    self closeNotifier.! 
dumpSystem
    "Dump All system structure information..."

    self
        dumpSystemPoolDictionaries;
        dumpSystemClasses!   
dumpSystemClasses
    "Dump All system classes structure information..."

    self dumpClasses: Smalltalk rootClasses! 
dumpSystemPoolDictionaries
    "Dump All system pool dictionaries..."

    self dumpPools: Smalltalk rootClasses! !

! ClassImport methods ! 
buildClasses: aCollection
    "Private - Build the classes in aCollection (of class specifications)"

    aCollection do: [:spec|
        self buildClassFrom: spec
    ]!   
buildClassFrom: spec
    "Private - Build the class determined from specification"

    | cls parent stream selector arguments currentClass
      name superclass kindOfSubclass
      structure isPointers instVarNames
      comment classVarNames sharedPools
      clsMethods instMethods source |

    stream := ReadStream on: spec.
    name := stream next asSymbol.
    currentClass := Smalltalk at: name ifAbsent: [].

    self show: 'Compilando : ',name.

    superclass := stream next.
    superclass notNil ifTrue: [ superclass := superclass asSymbol ].
    structure := stream next.
    isPointers := stream next.
    kindOfSubclass := stream next.
    instVarNames := stream next.
    comment := stream next.
    classVarNames := stream next.
    sharedPools := stream next.
    clsMethods := stream next.
    instMethods := stream next.
    source := stream next.

    parent := superclass notNil
        ifTrue: [
            Smalltalk at: superclass
            ifAbsent: [ self undefinedClass: superclass ]
        ].
    parent isNil ifTrue: [^nil]. "parent not found..."

    selector := (kindOfSubclass,
        (isPointers ifTrue: ['instanceVariableNames:'] ifFalse: [String new]),
        'classVariableNames:poolDictionaries:') asSymbol.
    arguments := OrderedCollection new.
    arguments add: name.
    isPointers ifTrue: [ arguments add: instVarNames ].
    arguments
        add: classVarNames;
        add: sharedPools.

    "validate pool dictionaries existence..."
    sharedPools asArrayOfSubstrings do: [:each|
        Smalltalk at: each asSymbol
            ifAbsent: [ self undefinedPoolDictionary: each]
    ].

    "if class must be recompiled..."
    (currentClass notNil
    and: [ currentClass structure == structure
    and: [ currentClass instanceVariableString = instVarNames
    and: [ currentClass classVariableString = classVarNames
    and: [ currentClass sharedVariableString = sharedPools
    ]]]]) ifFalse: [
        self show: (currentClass isNil ifTrue: [' *** Nueva clase ***'] ifFalse: [' *** Reconstruyendo ***']).
        (source size > 0 and: [ self useSources ])
        ifTrue: [
            (Compiler evaluate: source) notNil
            ifTrue: [ Smalltalk logEvaluate: source ].
        ]
        ifFalse: [
            parent
                perform: selector
                withArguments: arguments asArray.
        ]
    ].

    cls := Smalltalk at: name ifAbsent: [ ^self error: 'No pude crear la clase ',name ].
    (comment size > 0 and: [cls respondsTo: #comment:])
    ifTrue: [ cls comment: comment ].

    methods
        addAll: clsMethods;
        addAll: instMethods.

    (cls respondsTo: #hasBeenBound)
    ifTrue: [ cls hasBeenBound ].

    ^cls!  
buildMethods
    "Private - Build the loaded methos in secure order"

    | type method source spec conflictive intState |

    self notify: 'Conectando cdigo...'.
    methods size > 0 ifFalse: [ ^self ].
    methods := (methods collect: [:each| self methodFromSpec: each ]) asArray.

    self show: 'Ordenando mtodos...'.
    conflictive := (methods select: [:each|
        #( NotificationManager ) includes: (each at: 2) classField symbol ]) asSet.
    methods := (methods select: [:each| (conflictive includes: each) not ]), conflictive asArray.

    self show: 'Now building methods...'.
    intState := Process enableInterrupts: false.
    1 to: methods size do: [:i|
        spec := methods at: i.
        type := spec at: 1.
        method := spec at: 2.
        source := spec at: 3.
        (method notNil and: [ #(new exist) includes: type])
        ifTrue: [
            method classField
                addSelector: method selector
                withMethod: method.
        ] ifFalse: [ methods at: i put: nil ].
    ].
    Process enableInterrupts: intState.

    self show: 'Conectando cdigo fuente...'.
    methods do: [:spec|
        each notNil
        ifTrue: [
            method := spec at: 2.
            source := spec at: 3.
            source size > 0
            ifTrue: [
                Smalltalk
                    logSource: source
                    forSelector: method selector
                    inClass: method classField
            ] ifFalse: [ method sourceIndex: 0 sourcePosition: 0 ] "no source code..."
        ].
    ].

    self show: 'Todo el cdigo ha sido conectado...'.!
literal: aLiteral for: aCompiledMethod
    "Private - Returns an appropiate literal a aCompiledMethod"

    | key pools class assoc |
    aLiteral isAssociation ifFalse: [ ^aLiteral ].
    key := aLiteral key.
    class := aCompiledMethod classField.

    (Smalltalk includesKey: key) "global var reference..."
    ifTrue: [ ^Smalltalk associationAt: key ].

    "Pool constant reference...(from class or global pool)"
    pools := self poolsFor: class.
    pools do: [:dict|
        (dict includesKey: key) ifTrue: [
            ^dict associationAt: key
        ]
    ].

    assoc := Association key: key value: nil.

    (Smalltalk defineGlobal: key)
    ifTrue: [ Smalltalk add: assoc ].

    ^assoc!  
loadClasses
    "Load classes from file prompted to the user..."

    | pathName |
    pathName := self promptFileName: '*.VOB'.
    pathName notNil ifTrue: [ self loadClassesFrom: pathName ]! 
loadClassesFrom: pathName
    "Load classes dumped into file named pahName..."

    | file classes |
    (File exists: pathName) ifFalse: [^nil].
    file := File pathNameReadOnly: pathName.
    file lineDelimiter: Lf.
    self notify: 'Levantando componentes desde ',pathName.
    methods isNil ifTrue: [ methods := OrderedCollection new ].
    CursorManager execute changeFor: [
        [file atEnd] whileFalse: [
            classes := self nextObjectFrom: file.
            classes notNil ifTrue: [
                classes isArray ifTrue: [
                    self buildClasses: classes
                ]
                ifFalse: [
                    (MessageBox confirm: 'Una coleccin de especificacines de cdigo es esperada',
                        '\ y se encontr 'withCrs, classes asString,
                        '\\ Seguro desea continuar ?'withCrs)
                    ifFalse: [ self error: 'Contenido de mdulo invlido o mdulo deteriorado' ].
                ]
            ]
        ].
        self buildMethods.
    ].
    file close.
    self closeNotifier.!
loadGlobals
    "load globals from globals file..."

    | pathName |
    pathName := self promptFileName: '*.Glb'.
    pathName notNil ifTrue: [ self loadGlobalsFrom: pathName ].! 
loadGlobalsFrom: pathName
    "load globals from globals file..."

    | file array |
    (File exists: pathName) ifFalse: [^nil].
    file := File pathNameReadOnly: pathName.
    file lineDelimiter: Lf.
    self notify: 'Conectando objetos globales ',pathName.
    CursorManager execute changeFor: [
        [file atEnd] whileFalse: [
            array := self nextObjectFrom: file.
            array isArray ifFalse: [
                array do: [:each|
                    Smalltalk at: each first put: each last
                ]
            ].
        ].
    ].
    file close.
    self closeNotifier.! 
loadPools
    "Load pool dictionaries from file prompted to the user..."

    | pathName |
    pathName := self promptFileName: '*.Pol'.
    pathName notNil ifTrue: [ self loadPoolsFrom: pathName ]!   
loadPoolsFrom: pathName
    "Load pool dictionaries dumped into file named pahName..."

    | file name dict |
    (File exists: pathName) ifFalse: [^nil].
    file := File pathNameReadOnly: pathName.
    file lineDelimiter: Lf.
    self notify: 'Cargando diccionarios de referencias desde ',pathName.
    CursorManager execute changeFor: [
        [file atEnd] whileFalse: [
            self nextObjectFrom: file "dictionaries perform automatic binding..."
        ].
    ].
    file close.
    self closeNotifier.!
loadSpecification
    "Load globals,pools & classes from file prompted to the user..."

    | pathName profiler |
    pathName := self promptFileName: '*.VIN' showAll: false.
    ^pathName notNil
    ifTrue: [ self loadSpecificationFrom: pathName ]!   
loadSpecificationFrom: pathName
    "Load globals,pools & classes from file named pathName...
     returns the pathName or nil if failed"

    | profiler name description version binary load requires count include excludes |
    profiler := WinProfiler new.
    profiler
        pathName: pathName;
        applicationName: 'Module';
        yourself.
    description := profiler at: 'Description' ifAbsent: [String new].
    version := profiler at: 'Version' ifAbsent: ['Versin no encontrada'].
    name := profiler at: 'Name' ifAbsent: [
        (MessageBox confirm: 'El mdulo "',description,'" ver:',version
        ,'\ No tiene nombre.\\Es posible que el archivo no contenga un mdulo de objetos.\'withCrs
        ,'Verifique el archivo: ',pathName
        ,'\\Seguro desea continuar ?'withCrs)
        ifFalse: [^nil].
        ].

    requires := profiler at: 'Requires' ifAbsent: [String new].
    requires trimBlanks isEmpty
    ifFalse: [
        requires asArrayOfSubstrings
        do: [:each|
            (Smalltalk includesKey: each asSymbol)
            ifFalse: [
                MessageBox warning: 'El componente de nombre #',each,' es necesario para instalar este mdulo'
                    ,'\La instalacin no podr ser realizada...'.
                ^nil
            ].
        ]
    ].

    excludes := profiler at: 'Loaded if not exists' ifAbsent: [String new].
    excludes trimBlanks isEmpty
    ifFalse: [
        excludes asArrayOfSubstrings
        do: [:each|
            (Smalltalk includesKey: each asSymbol)
            ifTrue: [
                self show: 'Este componente no necesita ser instalado'.
                ^nil
            ].
        ]
    ].

    count := 1.
    [ include := profiler at: 'include ',count asString ifAbsent: [].
      include size > 0
    ] whileTrue: [
        (File exists: include)
        ifTrue: [ self loadSpecificationFrom: include ]
        ifFalse: [
            MessageBox warning: 'No encontre mdulo ',include,'\\Necesario para cargar 'withCrs,description.
            ^nil
        ].
        count := count + 1
    ].

    load := [:token :selector |
        binary := profiler at: token ifAbsent: [].
        binary size > 0
        ifTrue: [
            (File exists: binary)
            ifTrue: [ self perform: selector with: binary]
            ifFalse: [
                MessageBox warning: 'Archivo no encontrado ',binary
                    ,'\\Es posible que el mdulo no termine de instalarse correctamente...'withCrs
            ]
        ].
    ].

    load
        value: 'Globals' value: #loadGlobalsFrom:;
        value: 'Pools' value: #loadPoolsFrom:;
        value: 'Classes' value: #loadGlobalsFrom:;
        value: 'Globals' value: #loadGlobalsFrom:;
        yourself.

    ^pathName!   
methodFromSpec: spec
    "Private - Retrurns an array with type,method and source obtained from spec..."

    | stream currentMethod result method
     cls selector original state
     byteCodeArray literals primitive source |

    stream := ReadStream on: spec.
    cls := stream next.
    selector := stream next.
    original := stream next.
    byteCodeArray := stream next.
    literals := stream next.
    primitive := stream next.
    source := stream next.

    cls := (cls includes: $ )
    ifTrue: [ (Smalltalk at: (cls upTo: $ ) asSymbol ifAbsent: []) class ]
    ifFalse: [ Smalltalk at: cls asSymbol ifAbsent: [] ].

    currentMethod := cls compiledMethodAt: selector.
    state := currentMethod isNil
    ifTrue: [ #new ] ifFalse: [ #exist ].
    original ifTrue: [ state := #original ].

    " self show: 'Convirtiendo ',cls printString,'>>',selector printString,' [',state printString,']'. "

    ( "Smalltalk isRunTime not" Compiler notNil
    and: [ source size > 0 and: [ self useSources ]])
    ifTrue: [
        result := cls compile: source in: cls.
        method := result isNil ifFalse: [ result value ].
    ]
    ifFalse: [
        method := CompiledMethod new: literals size.
        method
            classField: cls;
            selector: selector;
            byteCodeArray: byteCodeArray;
            primitive: (currentMethod notNil
                ifTrue: [ currentMethod primitive ]
                ifFalse: [ primitive ]);
            yourself.
        1 to: literals size do: [:i|
            method at: i put: (self literal: (literals at: i) for: method)
        ].
    ].

    Smalltalk isRunTime ifTrue: [ source := nil ].

    ^Array
        with: state
        with: method
        with: source!  
next: count objectsFrom: aStream
    "Private - Returns the next count objects from aStream in an array..."

    | result |
    result := Array new: count.
    1 to: count do: [:i|
        result at: i put: (self nextObjectFrom: aStream)
    ].
    ^result! 
nextClassFrom: aStream
    "Private - Load the next class specification from aStream..."

    | spec |
    spec := OrderedCollection new.
    spec add: aStream nextLine. "class name"
    self show: 'Conectando dinmicamente clase : ',spec first.
    spec addAll: (self next: 11 objectsFrom: aStream).
    ^spec asArray!   
nextCompiledMethodFrom: aStream
    "Private - Load the next compiledMethod specification from aStream..."

    | spec byteCodeArray |
    spec := OrderedCollection new.
    spec
        addLast: aStream nextLine; "class field specification..."
        addLast: aStream nextLine asSymbol; "selector..."
        yourself.

    "(spec first,'>>',spec last) displayAt: 10@10."

    spec addAll: (self next: 5 objectsFrom: aStream).
    ^spec asArray!  
nextDictionaryFrom: aStream
    "Private - Load the next dictionary specification from aStream..."

    | name size dict |
    name := aStream nextLine trimBlanks.
    size := aStream nextLine asInteger.
    dict := Dictionary new.

    name isEmpty
    ifFalse: [ "global dictionary (must be bound...)"
        name := name asSymbol.
        self show: 'Componente ',name printString,' conectado...'.
        (Smalltalk includesKey: name)
        ifTrue: [ dict := Smalltalk at: name ]
        ifFalse: [ Smalltalk at: name put: dict ].
    ].

    (self next: size objectsFrom: aStream) do: [:each|
        each isNil ifFalse: [
            dict at: each first put: each last.
            self show: '    ',each first printString,' >> ',each last printString.
        ]
    ].

    ^dict!
nextObjectFrom: aStream
    "Private - Load the next object from aStream..."

    | token size result |
    [   token := aStream peek.
        token isNil ifTrue: [^nil].
        token isSeparator ] whileTrue: [ aStream next ].

    (token isDigit or: [token = $-])
    ifTrue: [ ^aStream nextLine asInteger ].

    token := aStream next.
    token = $n ifTrue: [ ^nil ].
    token = $T ifTrue: [ ^true ].
    token = $F ifTrue: [ ^false ].
    token = $f ifTrue: [ ^aStream nextLine asFloat ].
    token = $# ifTrue: [ ^aStream nextLine asSymbol ].
    token = $$ ifTrue: [
        token := aStream nextLine asInteger.
        ^token <256
            ifTrue: [ token asCharacter ]
            ifFalse: [ Character basicNew instVarAt: 1 put: token; yourself ]
    ].
    token = $? ifTrue: [ ^Association key: (self nextObjectFrom: aStream) value: nil ].
    token = $s ifTrue: [
        size := aStream nextLine asInteger.
        ^aStream next: size
    ].
    token = $b ifTrue: [
        size := aStream nextLine asInteger.
        result := ByteArray new: size.
        result replace: size with: (aStream next: size).
        ^result
    ].
    token = $a ifTrue: [
        size := aStream nextLine asInteger.
        ^self next: size objectsFrom: aStream
    ].
    token = $c ifTrue: [ ^self nextClassFrom: aStream ].
    token = $m ifTrue: [ ^self nextCompiledMethodFrom: aStream ].
    token = $d ifTrue: [ ^self nextDictionaryFrom: aStream ].

    ^self error: 'Token Invlido (mdulo deteriorado o versin antigua) : ',token asString!  
poolsFor: aClass
    "Private - Returns a collection with all the pool dictionaries for aClass"

    | pools |
    pools := OrderedCollection with: aClass classPool.
    pools
        addAll: (aClass allSuperclasses collect: [:each| each classPool ]);
        addAll: (aClass sharedPools
            collect: [:each|
                Smalltalk at: each
                    ifAbsent: [ self undefinedPoolDictionary: each ]
            ]);
        yourself.
    ^pools!   
realMethods
    "Private - Build the real compiled methods objects to be filed-in"

    methods size > 0 ifFalse: [ ^#() ].
    ^methods collect: [:spec|
    ].!
undefinedClass: aName
    "Private - Notify the user about a Class not defined and let him to load from a file..."

    | fileName class |
    (MessageBox confirm: 'La clase ',aName,' no existe en este',
            ' espacio de objetos...\ Desea cargarla desde un archivo ?' withCrs)
    ifTrue: [
        fileName := self promptFileName: '*.VIN'.
        fileName isNil ifFalse: [
            self class new loadClassesFrom: fileName.
            class := Smalltalk at: aName asSymbol ifAbsent: [].
        ].
        "....ouch...class notNil"true ifTrue: [ ^class].
    ].
    ^self error: 'La clase ',aName,' no existe en este espacio de objetos...'!  
undefinedPoolDictionary: aName
    "Private - Notify the user about a pool dictionary not defined
     and let him to load from a file..."

    | fileName pool |
    (MessageBox confirm: 'El diccionario de variables ',aName,' no existe',
            ' en este espacio de objetos...\ Desea cargarlo desde un archivo ?' withCrs)
    ifTrue: [
        fileName := self promptFileName: '*.Pol'.
        fileName isNil ifFalse: [
            self class new loadPoolsFrom: fileName.
            pool := Smalltalk at: aName asSymbol ifAbsent: [].
        ].
        pool notNil ifTrue: [^pool].
    ].
    ^self error: 'El diccionario de variables ',aName,' no existe en este espacio de objetos...'!   
useSources
    "Returns true if the receiver must consider source code..."

    ^false! !

! Array methods ! 
asByteArray
        "Added by OSI - Answer a ByteArray whose contents are the
         bytes of the receiver."
    | byteArray |
    #addedByOSI.
    byteArray := ByteArray new: self size.
    1 to: self size do: [ :i | byteArray at: i put: (self at: i) ].
    ^byteArray!   
asOrderedCollectionRecursively
    "Added by OSI"
    #addedByOSI.
    ^(self collect: [ :element |
        element isArray
            ifTrue: [ element asOrderedCollectionRecursively ]
            ifFalse: [ element == #nil
                ifTrue: [ nil ]
                ifFalse: [ element ]]]) asOrderedCollection!
convertBytesToString
        "Added by OSI - Answer a String whose contents are the
         bytes of the receiver."
    #addedByOSI.
    ^self asByteArray asString! !

! ChunkStructure class methods !   
classComment
	^'This class contains the complete information of the scanned file'
	"Modified: 11.06.93 / 10.13.23 / T.Lentzsch"!
classUpdate
	^'
	"Modified: 11.06.93 / 10.13.23 / T.Lentzsch"'
	"Modified: 11.06.93 / 10.13.23 / T.Lentzsch"!  
new
	"Answer a predefined structure"

	^self new: 7
	"Modified: 09.11.92 / 07.57.35 /  T.Lentzsch"! !

! ChunkStructure methods !   
chunks
	"Answer the number of chunks"

	^self at: 3
	"Modified: 09.11.92 / 08.01.18 /  T.Lentzsch"!   
chunks: anInteger
	"Set the number of chunks"

	^self at: 3 put: anInteger
	"Modified: 09.11.92 / 08.01.32 /  T.Lentzsch"!
classMethod
	"Answer true if is a class method"

	^self at: 5
	"Modified: 09.11.92 / 08.07.18 /  T.Lentzsch"! 
classMethod: aBoolean
	"Set true if is a class method"

	^self at: 5 put: aBoolean
	"Modified: 09.11.92 / 08.07.38 /  T.Lentzsch"!
className
	"Answer the class name"

	^self at: 4
	"Modified: 09.11.92 / 08.05.21 /  T.Lentzsch"!  
className: aString
	"Set the class name"

	^self at: 4 put: aString
	"Modified: 09.11.92 / 08.04.32 /  T.Lentzsch"!   
displayMode
	"Answer the display mode:
		0 - visible
		1 - hidden
		2 - removed"

	^self at: 6
	"Modified: 09.11.92 / 08.30.20 /  T.Lentzsch"! 
displayMode: anInteger
	"Set the display mode:
		0 - visible
		1 - hidden
		2 - removed"

	^self at: 6 put: anInteger
	"Modified: 09.11.92 / 08.30.37 /  T.Lentzsch"!  
hidden
	"Answer true if is a hidden entry"

	^(self at: 6) = 1
	"Modified: 09.11.92 / 08.33.22 /  T.Lentzsch"!
hidden: aBoolean
	"Set true if is a hidden entry"

	^self at: 7 put: aBoolean
	"Modified: 09.11.92 / 08.20.55 /  T.Lentzsch"! 
isClass
	"Answer true if is a class entry"

	^(self at: 6) = 3
	"Modified: 09.11.92 / 09.40.28 /  T.Lentzsch"!
isHidden
	"Answer true if is a hidden entry"

	^(self at: 6) = 1
	"Modified: 09.11.92 / 08.33.34 /  T.Lentzsch"!  
isRemoved
	"Answer true if is a removed entry"

	^(self at: 6) = 2
	"Modified: 09.11.92 / 08.34.07 /  T.Lentzsch"!
isSame
	"Answer true if is a same entry"

	^(self at: 6) = 4
	"Modified: 09.11.92 / 09.47.25 /  T.Lentzsch"!  
isVisible
	"Answer true if is a visible entry"

	^(self at: 6) = 0
	"Modified: 09.11.92 / 08.33.56 /  T.Lentzsch"!
item
	"Answer the item"

	^self at: 1
	"Modified: 09.11.92 / 07.59.02 /  T.Lentzsch"! 
item: aString
	"Set the item"

	^self at: 1 put: aString
	"Modified: 09.11.92 / 07.59.59 /  T.Lentzsch"!  
position
	"Answer the file position"

	^self at: 2
	"Modified: 09.11.92 / 08.01.03 /  T.Lentzsch"!
position: anInteger
	"Set the file position"

	^self at: 2 put: anInteger
	"Modified: 09.11.92 / 08.00.24 /  T.Lentzsch"! 
tilde
	"Answer true if is a hidden entry"

	^self at: 7
	"Modified: 09.11.92 / 08.31.29 /  T.Lentzsch"!   
tilde: aBoolean
	"Set true if is a hidden entry"

	^self at: 7 put: aBoolean
	"Modified: 09.11.92 / 08.31.23 /  T.Lentzsch"! !

! CompiledMethod methods !  
fileOutOn: aStream
    "Permorms fileOut of receiver's source code"
    "Created by Ale 8 Mar, 1995 for easy fileOut of methods..."

    | source |
    #addedByOStyle.
    source := self sourceString.
    source isNil ifTrue: [ ^nil ].

    "Place class header..."
    aStream
        setToEnd;cr; nextPut: $!!;
            nextPutAll: ' ',class name , ' methods !!'.

    "Place source code..."
    aStream
        cr;nextPutAll: source;
        nextPutAll: '!! !!'.! !

! ByteArray methods !  
asString
        "Answer a String whose contents are the
         bytes of the receiver."
    #addedByOSI.
    ^(String new: self size) replace: self size with: self.!   
replaceBytes: count with: aCollection
        "Private - replace count bytes of the receiver
         with bytes of aCollection.  aCollection
         may be either a Smalltalk byte object or
         an instance of WinAddress.  Answer the receiver."
    WinAddress
        copyFromDBS: aCollection
        to: self
        count: count! 
replaceBytesFrom: byteStart
    to: byteStop
    with: aByteObject
    startingAt: byteRepStart
        "Private - replace the bytes of the receiver at index
         positions start through stop with consecutive
         bytes of aByteObject beginning at index
         position repStart.  Answer the receiver."
    | index1 index2 |
    <primitive: 129>
    aByteObject class isBytes
        ifFalse: [self error: 'source must be a byte object'].
    (self == aByteObject and: [byteRepStart < byteStart])
        ifTrue: [ "do backward move for same object"
            index2 := byteRepStart + byteStop - byteStart.
            index1 := byteStop.
            [byteStart <= index1]
                whileTrue: [
                self
                    at: index1
                    put: (aByteObject basicAt: index2) asInteger.
                index1 := index1 - 1.
                index2 := index2 - 1].
            ^self].
    "do forward move"
    index2 := byteRepStart.
    index1 := byteStart.
    [index1 <= byteStop]
        whileTrue: [
            self
                at: index1
                put: (aByteObject basicAt: index2) asInteger.
            index1 := index1 + 1.
            index2 := index2 + 1]! 
replaceFrom: start to: stop withAddress: aWinAddress startingAt: int
        "Replace the elements of the receiver at index
         positions start through stop with consecutive
         elements at aWinAddress beginning at 
         position int.  Answer the receiver."
    ^self replaceFrom: start to: stop with: aWinAddress startingAt: int! !

! FileHandle class methods !   
open: aString
    in: aDirectory
    action: anAction
    fileSize: aFileSize
    attribute: anAttr
    flags: openFlags
    mode: openMode
        "Answer a file handle for an opened file
         named aString in aDirectory with the
        associated parameters.

         Possible values for the parameters are:
            anAction - for output, currently not used.
            aFileSize - in bytes, currently not used.
            anAttr -
                FileNormal, FileReadonly, FileHidden, FileSystem, FileArchived
                (FileArchived is treated same as FileNormal).
            openFlags -
                FileCreate, FileOpen, FileTruncate.
            openMode -
                OpenAccessReadonly, OpenAccessReadwrite, OpenAccessWriteonly
                OpenShareDenynone, OpenShareDenyread,
                    OpenShareDenyreadwrite, OpenShareDenywrite.
        Modified by LRP for fileName display during error"
    | aHandle answer  createFlag fileName buf |
    fileName := (aDirectory fullDirName, aString) asParameter.
    (self isThere: fileName)
        ifTrue: [
            answer :=
                KernelLibrary
                    openFile: fileName
                    reopenBuffer: (buf := WinOfstruct new) asParameter
                    style: openMode.
            answer < 0
                ifTrue: [
                    buf nErrCode = 32
                        ifTrue: [
                            self cleanHandles
                                ifTrue: [  "cleanup handles and retry"
                                    (answer := KernelLibrary
                                        openFile: fileName
                                        reopenBuffer: (buf := WinOfstruct new) asParameter
                                        style: openMode)
                                            < 0 ifTrue: [^self error: 'sharing violation : ',aString]]
                                ifFalse: [ #modifiedByOS.^self error: 'sharing violation:',aString ]]
                        ifFalse: [^Dos dosError: buf nErrCode]]]
        ifFalse: [
            (openFlags bitAnd: FileCreate) ~= 0
                ifTrue: [
                    (answer :=
                        KernelLibrary
                            lcreat: fileName
                            style: anAttr) < 0
                                ifTrue: [ #modifiedByOS.^self  error: 'file creation failed:',aString]
                                ifFalse: [ "reopen in the right mode"
                                    KernelLibrary lclose: answer.
                                    answer := KernelLibrary
                                        lopen: fileName style: openMode]]
                ifFalse: [ #modifiedByOS.^self error: 'file open error:',aString ]].

    aHandle := self fromInteger: answer.
    FileHandles isNil ifTrue: [
        FileHandles := Set new].
    FileHandles add: aHandle.
    ^aHandle!   
openWithoutError: aString
    in: aDirectory
    action: anAction
    fileSize: aFileSize
    attribute: anAttr
    flags: openFlags
    mode: openMode
        "Answer a file handle for an opened file
         named aString in aDirectory with the
        associated parameters.

         Possible values for the parameters are:
            anAction - for output, currently not used.
            aFileSize - in bytes, currently not used.
            anAttr -
                FileNormal, FileReadonly, FileHidden, FileSystem, FileArchived
                (FileArchived is treated same as FileNormal).
            openFlags -
                FileCreate, FileOpen, FileTruncate.
            openMode -
                OpenAccessReadonly, OpenAccessReadwrite, OpenAccessWriteonly
                OpenShareDenynone, OpenShareDenyread,
                    OpenShareDenyreadwrite, OpenShareDenywrite.
    Who touched this method? why?"
    | aHandle answer  createFlag fileName buf |
    #modifiedByOStyle.
    fileName := (aDirectory fullDirName, aString) asParameter.
    (self isThere: fileName)
        ifTrue: [
            answer :=
                KernelLibrary
                    openFile: fileName
                    reopenBuffer: (buf := WinOfstruct new) asParameter
                    style: openMode.
            answer < 0
                ifTrue: [
                    buf nErrCode = 32
                        ifTrue: [
                            self cleanHandles
                                ifTrue: [  "cleanup handles and retry"
                                    (answer := KernelLibrary
                                        openFile: fileName
                                        reopenBuffer: (buf := WinOfstruct new) asParameter
                                        style: openMode)
                                            < 0 ifTrue: [^nil]]
                                ifFalse: [^nil]]
                        ifFalse: [^Dos dosError: buf nErrCode]]]
        ifFalse: [
            (openFlags bitAnd: FileCreate) ~= 0
                ifTrue: [
                    (answer :=
                        KernelLibrary
                            lcreat: fileName
                            style: anAttr) < 0
                                ifTrue: [^self  error: 'file creation failed:',aString]
                                ifFalse: [ "reopen in the right mode"
                                    KernelLibrary lclose: answer.
                                    answer := KernelLibrary
                                        lopen: fileName style: openMode]]
                ifFalse: [^nil]].

    aHandle := self fromInteger: answer.
    FileHandles isNil ifTrue: [
        FileHandles := Set new].
    FileHandles add: aHandle.
    ^aHandle! !

! String methods ! 
, aString
        "Answer a new string containing the characters
         of the receiver followed by the the characters of
         aString."
    ((self isDoubleByteString xor: aString isDoubleByteString)
        and: [ aString isString ])
        ifFalse: [ ^super , aString ].
    ^(DoubleByteString fromString: self) , (DoubleByteString fromString: aString)! 
<= aString
        "Answer true if the receiver is before or equal to
         aString in the current sort sequence, else answer false.
         The comparison is not case sensitive."
    <primitive: 131>
    (self isSymbol or: [aString isSymbol])
        ifTrue: [
            aString isDoubleByteSymbol
                ifTrue: [
                    self  isDoubleByteSymbol
                        ifFalse: [^(DoubleByteSymbol intern: self) <= aString ]]
                ifFalse: [
                    self isDoubleByteSymbol
                        ifTrue: [^self <= (DoubleByteSymbol intern: aString) ]]]
        ifFalse: [
            aString isDoubleByteString
                ifTrue: [
                    self  isDoubleByteString
                        ifFalse: [^(DoubleByteString fromString: self) <= aString ]]
                ifFalse: [
                    self isDoubleByteString
                        ifTrue: [^self <= (DoubleByteString fromString: aString) ]]].
    ^self primitiveFailed!  
= aString
        "Answer true if the receiver is equal to
         aString, else answer false.  The comparison
         is case sensitive."
    | sbs dbs i |
    <primitive: 132>
    " fails when self class ~= aString class "
    aString isSymbol ifTrue: [^false].
    (aString isString) ifTrue: [  " comparing String and DoubleByteString "
        (self size = aString size) ifFalse: [^false].
        self isDoubleByteString
            ifTrue: [dbs := self. sbs := aString]
            ifFalse: [sbs := self. dbs := aString].
        i := 1.
        dbs do: [ :aChar |
            ((sbs at: i) = aChar) ifFalse: [^false].
            i := i + 1].
        ^true].
    ^false!  
asByteArray
        "Answer a ByteArray whose contents are the
         bytes of the receiver."
    ^(ByteArray new: self size) replace: self size with: self.!
asMessage
    "Added by OSI - Converts a piece of code into a message selector"
    | array semiArray result |

    self isEmpty ifTrue:[ ^nil ].
    #addedByOSI.
    array := self asArrayOfSubstrings.
    semiArray := array select: [ :s |
        (s last == $: and:
        [ s size > 1 and:
        [(s at: s size - 1) ~= $$ ]])].
    semiArray size > 0
        ifTrue: [
            result := ''.
            semiArray do: [ :s | result := result, s trimBlanks ]]
        ifFalse: [
            result := (ReadStream on: array first) nextWord.
            result isNil ifTrue: [ result := array first ].
            (result first isUpperCase and: [ array size > 1 ])
                ifTrue: [ result := (ReadStream on: (array at: 2)) nextWord ]].
    ^result asSymbol!   
asNormalizedString
        "Interpret the receiver as a mixed string encoding
         using the lead byte flags of the current code page.
         Answer the equivalent DoubleByteString if the receiver
         contains any double-byte characters.  Answer the
         receiver if it only contains single byte characters."
    (NationalLanguage isDoubleByteCp) ifFalse: [^self].
    ^self asNormalizedString: NationalLanguage leadBytes!  
asNormalizedString: leadByteFlags
        "Interpret the receiver as a mixed string encoding
         based on the given array of leadByteFlags.
         Answer the equivalent DoubleByteString if the receiver
         contains any double-byte characters.  Answer the
         receiver if it only contains single byte characters."
    | aFlag |
    (aFlag := VWVMLibrary mixedString: self
      containsLeadByte: leadByteFlags ) < 0 ifFalse: [
            (aFlag asBoolean) ifFalse: [ ^self ]
                ifTrue: [ ^DoubleByteString fromMixedString: self
                     leadBytes: leadByteFlags ]].  
    "This code gets execute only when the above fails."
    self do: [ :aChar |
        (aChar isLeadByte: leadByteFlags) ifTrue: [
            ^DoubleByteString
                fromMixedString: self
                leadBytes: leadByteFlags]].
    ^self!
asNumber

    "Convierte un string al formato numerico mas adecuado (MSG/LRP)"
    #modifiedByOStyle.

    ((self includes: NationalLanguage decimalSeparator first)
     or: [ self includes: $e ]) ifTrue: [
        ^self trimBlanks asFloat
    ].

    ^self trimBlanks asInteger.!
asProperNoun
    "Added by OSI. Answer a String containing the receiver
     with alphabetic characters in mixed proper case."
    | answer size index aCharacter |
    #addedByOSI.
    size := self size.
    answer := String new: size.
    index := 1.
    [index <= size]
        whileTrue: [
            aCharacter := self at: index.
            (index == 1 or: [
            (self at: index - 1) isWhitespace and: [
            aCharacter isLowerCase ]])
                ifTrue: [aCharacter := aCharacter asUpperCase].
            answer at: index put: aCharacter.
            index := index + 1].
    ^answer! 
asQuotedString

    "Added by OSI"

    | stream |
    #addedByOSI.
    stream := WriteStream on: String new.
    self printOn: stream.
    ^stream contents! 
asTime
        "Answer a Time representing the receiver."
    ^Time fromString: self!   
at: anInteger put: aCharacter
        "Answer aCharacter.  At index position
         anInteger in the receiver put the
         character aCharacter.  Mutate the receiver
         into a DoubleByteString if aCharacter
         is a double-byte character."
    | dbString |
    <primitive: 64>
    self checkIndex: anInteger.
    self checkCharacter: aCharacter.
    aCharacter isDoubleByte
        ifTrue: [
            dbString := DoubleByteString fromString: self.
            dbString at: anInteger put: aCharacter.
            self become: dbString.
            ^aCharacter].
    ^self primitiveFailed!   
beginsWith: aString

    "Added by OSI"
    #addedByOSI.
    ^(self size >= aString size) and: [
        (1 to: aString size)
            detect: [:i | (self at: i) ~~ (aString at: i)]
            ifNone: [^true].
        false]! 
centered: anInteger
    "Retorna el contenido del receptor centrado dentro de un
     string de anInteger caracteres. (Miguel Grinberg)"
    #modifiedByOStyle.

    ^self centered: anInteger fillChar: $ .!
centered: anInteger fillChar: aChar
    "Retorna el contenido del receptor centrado dentro de un
     string de anInteger caracteres rellenado con el caracter
     aChar. (Miguel Grinberg)"

    | s i |
    #modifiedByOStyle.
    (self size > anInteger) ifTrue: [
        ^ self copyFrom: 1 to: anInteger
    ].

    s := String new: anInteger.
    i := anInteger - self size // 2.
    1 to: i do: [ :n|
        s at: n put: aChar.
    ].
    self do: [ :c|
        i := i + 1.
        s at: i put: c.
    ].
    i + 1 to: anInteger do: [ :n|
        s at: n put: aChar.
    ].
    ^s.! 
equals: aString
        "Answer true if the receiver is equal to
         the argument aString, else answer false.
         Note that the comparison is case sensitive."
    | sbs dbs i |
    <primitive: 132>
    " fails when self class ~= aString class "
    aString isSymbol ifTrue: [^false].
    (aString isString) ifTrue: [  " comparing String and DoubleByteString "
        (self size = aString size) ifFalse: [^false].
        self isDoubleByteString
            ifTrue: [dbs := self. sbs := aString]
            ifFalse: [sbs := self. dbs := aString].
        i := 1.
        dbs do: [ :aChar |
            ((sbs at: i) = aChar) ifFalse: [^false].
            i := i + 1].
        ^true].
    ^false!  
equalsIgnoreCase: aString
        "Answer true if the reciever is equal to
         aString, anse answer false.
         The compairision is not case sensitive."
   " ^self <= aString and: [(self < aString) not] "
    ^NationalLanguage string: self isEqualToIgnorCase: aString!
hasContent

    "Added by OSI"

    (self isEmpty) ifTrue: [
        #addedByOSI.
        ^false
    ].

    self do: [ :aChar |
        (aChar == $ ) not ifTrue: [
            ^true
        ].
    ].

    ^false!  
isPrefixOf: aString
    "Answer true if the reciever is a
     prefix of aString.  Comparison
     is case sensitive.
    Implemented by Ale..."
    #addedByOStyle.
    self == aString
        ifTrue: [^true].
    self size > aString size
        ifTrue: [^false].
    1 to: self size do: [:index |
        (self at: index) = (aString at: index)
            ifFalse: [^false]].
    ^true! 
leftAligned: anInteger
    "Retorna el contenido del receptor justificado a izquierda
     dentro de un string de anInteger caracteres. (Miguel Grinberg)"
    #modifiedByOStyle.

    ^self leftAligned: anInteger fillChar: $ .!   
leftAligned: anInteger fillChar: aChar

    "retorna el contenido del receptor justificado a izquierda
     dentro de un string de anInteger caracteres rellenado con
     el caracter aChar. (Miguel Grinberg)
    Touched by Ale for fast processing"

    | i blanks |
    #modifiedByOStyle.
    self size > anInteger ifTrue: [ ^ self copyFrom: 1 to: anInteger ].
    i := anInteger - self size.
    blanks := String new: i.
    blanks atAllPut: aChar.
    ^self , blanks!
loadBy: aLoader
    "Load the instance variables of the receiver using
     the loader object aLoader.
     Touched by Ale for fast reading...
    | aStream index size |  "
    aLoader stream getBytesFor: self.
    "
    size := aLoader loaderIndex.
    aStream := aLoader stream.
    index := 1.
    [index <= size]
        whileTrue: [
            self at: index put: aStream next.
            index := index + 1].
    "
    #modifiedByOStyle.
    aLoader stream next!
matchOf: aString
    "Answer a Fraction that describes the degree of the match.
     Zero is no match at all.  One is the best match possible.
     A bonus is awarded if the length of the two strings is within 2 characters.
    Implemented by Ale..."
    | i j k minSize bonus|
    #addedByOStyle.
    minSize := (j := self size)
        min: (k := aString size).
    self == aString
        ifTrue: [^1].
    minSize = 0 ifTrue: [^0].
    bonus := (j - k) abs < 2
        ifTrue: [1] ifFalse: [0].
    i := 1.
    [i <= minSize and:
        [(self at: i) asUpperCase
         = (aString at: i) asUpperCase]]
            whileTrue: [i := i + 1].
    [j > 0 and: [k > 0 and:
        [(self at: j) asUpperCase
        = (aString at: k) asUpperCase]]]
            whileTrue: [j := j - 1.
                k := k - 1].
    ^(i - 1 + self size - j
        + bonus) / (2 * minSize + bonus)!  
mnemonicChar

    "Added by OSI.  Scan for the mnenomic character (&), and
     answer the character following it.  If no mnemonic, answer nil."

    | index |
    #addedByOSI.
    index := (self indexOf: $& ifAbsent: [ self size ]) + 1.
    index > self size ifTrue: [
        ^nil
    ].

    ^(self at: index) asUpperCase! 
prefixOf: aString
    "Answer true if the reciever is a
     prefix of aString.  Comparison
     is case sensitive.
    Implemented by Ale..."
    #addedByOStyle.
    ^self isPrefixOf: aString!   
replace: count with: aCollection
        "Answer the receiver.  Replace count number of
         characters in the beginning of the receiver
         from the same number of characters in the
         beginning of aCollection.  aCollection can
         be a WinAddress and count can be a large 
         integer. Mutate the receiver into a DoubleByteString
         if aCollection is a DoubleByteString."
    | dbString |
    (aCollection isDoubleByteString)
        ifTrue: [
            dbString := DoubleByteString fromString: self.
            dbString replace: count with: aCollection.
            self become: dbString]
        ifFalse: [ 
            WinAddress
                copyFrom: aCollection
                to: self
                count: count].! 
replaceBytesFrom: byteStart
    to: byteStop
    with: aByteObject
    startingAt: byteRepStart
        "Private - replace the bytes of the receiver at index
         positions start through stop with consecutive
         bytes of aByteObject beginning at index
         position repStart.  Answer the receiver."
    | index1 index2 |
    <primitive: 129>
    aByteObject class isBytes
        ifFalse: [self error: 'source must be a byte object'].
    (self == aByteObject and: [byteRepStart < byteStart])
        ifTrue: [ "do backward move for same object"
            index2 := byteRepStart + byteStop - byteStart.
            index1 := byteStop.
            [byteStart <= index1]
                whileTrue: [
                self
                    at: index1
                    put: (aByteObject basicAt: index2) asCharacter.
                index1 := index1 - 1.
                index2 := index2 - 1].
            ^self].
    "do forward move"
    index2 := byteRepStart.
    index1 := byteStart.
    [index1 <= byteStop]
        whileTrue: [
            self
                at: index1
                put: (aByteObject basicAt: index2) asCharacter.
            index1 := index1 + 1.
            index2 := index2 + 1]! 
replaceFrom: start
    to: stop
    with: aString
    startingAt: repStart
        "Replace the characters of the receiver at index
         positions start through stop with consecutive
         characters of aString beginning at index
         position repStart.  Mutate the receiver into a
         DoubleByteString if aString is a DoubleByteString.
         Answer the receiver."
    | dbString index1 index2 |
    <primitive: 105>
    (aString isDoubleByteString)
        ifTrue: [
            dbString := DoubleByteString fromString: self.
            dbString
                replaceFrom: start to: stop
                with: aString startingAt: repStart.
            self become: dbString.
            ^dbString].
    (aString class isBytes)
        ifFalse: [
            ^super
                replaceFrom: start
                to: stop
                with: aString
                startingAt: repStart].
    (self == aString and: [repStart < start])
        ifTrue: [ "do backward move for same object"
            index2 := repStart + stop - start.
            index1 := stop.
            [start <= index1]
                whileTrue: [
                self
                    at: index1
                    put: (aString at: index2) asCharacter.
                index1 := index1 - 1.
                index2 := index2 - 1].
            ^self].
    "do forward move"
    index2 := repStart.
    index1 := start.
    [index1 <= stop]
        whileTrue: [
            self
                at: index1
                put: (aString at: index2) asCharacter.
            index1 := index1 + 1.
            index2 := index2 + 1]!
replaceFrom: start to: stop withObject: aCharacter
        "Replace the characters of the receiver
         at index positions start through stop
         with aCharacter.  Mutate the receiver
         into a DoubleByteString if aCharacter
         is a double-byte character.  Answer aCharacter."
    | dbString |
    <primitive: 106>
    self checkCharacter: aCharacter.
    aCharacter isDoubleByte
        ifTrue: [
            dbString := DoubleByteString fromString: self.
            dbString
                replaceFrom: start to: stop
                withObject: aCharacter.
            self become: dbString.
            ^aCharacter].
    ^super
        replaceFrom: start
        to: stop
        withObject: aCharacter!
rightAligned: anInteger
    "Retorna el contenido del receptor justificado a derecha
     dentro de un string de anInteger caracteres. (Miguel Grinberg)"
    #modifiedByOStyle.
    ^self rightAligned: anInteger fillChar: $ .! 
rightAligned: anInteger fillChar: aChar
     "Retorna el contenido del receptor justificado a derecha
     dentro de un string de anInteger caracteres rellenado con
     el caracter aChar. (Miguel Grinberg)
    Touched by Ale for fast processing"

    | i blanks |
    #modifiedByOStyle.
    self size > anInteger ifTrue: [ ^ self copyFrom: 1 to: anInteger ].
    i := anInteger - self size.
    blanks := String new: i.
    blanks atAllPut: aChar.
    ^blanks , self!  
stripMnemonic

    "Added by OSI"
    #addedByOSI.
    ^self select: [ :c | (c = $~) not & (c = $&) not ]!
truncatedAt: anInteger
    "Who Added this method? why?"
    #AddedByOS.
    ^self copyFrom: 1 to: (anInteger min: self size)! 
unloadBy: aLoader
    "Write out the instance variables of the receiver
     using the loader object aLoader.
    Touched By Ale..."
    #modifiedByOStyle.
    aLoader stream
        nextPutAll: (aLoader classIndexFor: self class);
        nextBytePut: 10;
        nextPutAll: self basicSize printString;
        nextBytePut: 10;
        nextPutAll: self;
        nextBytePut: 10!   
upTo: aCharacter

    "Added by OSI - answer the string up to the given character,
     or the entire string if the character isn't found"

    | s |
    #addedByOSI.
    s := ReadStream on: self.
    ^s upTo: aCharacter! !

! DoubleByteString class methods ! 
fromAddress: aWinAddress
        "Answer a DoubleByteString whose bytes are copied
        from memory at aWinAddress."
    | s charIndex byteIndex |
    s := self new: 1.
    charIndex := 1.
    byteIndex := 1.
    [s replaceBytesFrom: 1
          to: 2
          with: aWinAddress
          startingAt: byteIndex.
    (s at: 1) asciiValue = 0] whileFalse: [
        charIndex := charIndex + 1.
        byteIndex := byteIndex + 2].
    ^self fromAddress: aWinAddress length: charIndex - 1.! 
fromAddress: aWinAddress length: anInteger
        "Answer a DoubleByteString of size anInteger characters
         whose bytes are copied from memory at aWinAddress."
    | t |
    t := self new: anInteger.
    t replaceFrom: 1
          to: anInteger
          withAddress: aWinAddress
          startingAt: 1.
   ^t!  
fromMixedString: aString
        " Answer a DoubleByteString representing aString.  The
        single-byte characters of aString are interpreted as a
        mixed-string encoding in the current national language."
    ^(NationalLanguage isDoubleByteCp)
        ifTrue: [self fromMixedString: aString leadBytes: NationalLanguage leadBytes]
        ifFalse: [self fromString: aString].!  
fromMixedString: aString leadBytes: leadByteFlags
        " Answer a DoubleByteString representing aString.  The
        single-byte characters of aString are interpreted as a
        mixed-string encoding, based on the given leadByteFlags
        array of Booleans. "
    | stringSize stringIndex dbString dbStringSize dbByteIndex
        leadByte trailByte nullByte |
    stringSize := aString size.
    (stringSize = 0) ifTrue: [^self new].
    (dbStringSize := VWVMLibrary doubleByteStringSizeFrom: aString
      leadBytes: leadByteFlags) < 0 ifFalse: [
        dbString := self new: dbStringSize.
        (VWVMLibrary mixedString: aString
               toDoubleByteString: dbString
            leadBytes: leadByteFlags) < 0 ifFalse: [^dbString]].
    "The following is executed only when the VWVMLibrary APIs fail."
    nullByte := 0 asCharacter.
    dbString := self new: stringSize.  " worst case is all SBC's "
    dbByteIndex := 0.
    stringIndex := 0.
    [stringIndex < stringSize] whileTrue: [
        stringIndex := stringIndex + 1.
        leadByte := aString at: stringIndex.
        (leadByte isLeadByte: leadByteFlags)
            ifTrue: [  " double-byte character "
                stringIndex := stringIndex + 1.
                (stringIndex > stringSize)
                    ifTrue: [ trailByte := nullByte]     "String with missing trail byte"
                    ifFalse: [ trailByte := aString at: stringIndex]]
         ifFalse: [   " single-byte character "
                trailByte := leadByte.
                leadByte := nullByte].
        dbByteIndex := dbByteIndex + 1.
        dbString basicAt: dbByteIndex put: leadByte.
        dbByteIndex := dbByteIndex + 1.
        dbString basicAt: dbByteIndex put: trailByte.
        ].
    ^dbString copyFrom: 1 to: (dbByteIndex // 2)!  
fromString: aString
        " Answer a DoubleByteString containing the characters
        of aString. "
    | stringSize dbString dbByteIndex aChar |
    aString isDoubleByteString ifTrue: [ ^aString ].
    stringSize := aString size.
    (stringSize = 0) ifTrue: [^self new].  " degenerate case "
    dbString := self new: stringSize.
    dbByteIndex := 0.
    aString do: [ :trailByte |
        dbByteIndex := dbByteIndex + 2.  " lead byte is already 0 "
        dbString basicAt: dbByteIndex put: trailByte].
    ^dbString!
new: anInteger
        " Answer a new DoubleByteString containing anInteger characters. "
    ^super new: (anInteger * 2)! !

! DoubleByteString methods !
asAsciiZ
        "Answer a new String containing the characters
         of the receiver in mixed-string encoding, followed
         by one character of code point value zero. "
    ^self asMixedStringWithNull: true!  
asByteArray
        "Answer a ByteArray whose contents are the
         bytes of the receiver.  Each character in the
         receiver is represented by two bytes in the
         ByteArray, where the first byte of each pair
         is the high-order lead byte of the character
         and the second byte is the low-order trail
         byte of the character."
    | b |
    b := ByteArray new: self basicSize.
    ^b replaceFrom: 1 to: b size with: self startingAt: 1.!   
asCompactString
        " Answer the most compact string containing the
         characters of the receiver. "
    ^self containsDBCharacter
        ifTrue: [self]
        ifFalse: [self asMixedString]   " produces a single-byte String "!   
asMixedString
        "Answer a new String containing the characters
         of the receiver in mixed-string encoding. "
    ^self asMixedStringWithNull: false!  
asMixedStringWithNull: appendNull
        " Private - answer a new String containing
        all the characters of the receiver in 
        mixed-length encoding.  Optionally append
        a null-terminator byte."
    | sizeInBytes mixedString stringIndex byteIndex aChar |
    (sizeInBytes := VWVMLibrary mixedStringSizeFrom: self) < 0
        ifFalse: [
            mixedString := String new:
                (sizeInBytes + (appendNull ifTrue: [1] ifFalse: [0])).
            (stringIndex := VWVMLibrary doubleByteString: self toMixedString: mixedString) < 0
                ifFalse: [
                    appendNull ifTrue: [
                        stringIndex := stringIndex + 1.
                        mixedString at: stringIndex put: 0 asCharacter].
                    ^mixedString]].
    "The following is executed only when the VWVMLibrary APIs fail."
    sizeInBytes := self basicSize.
    mixedString := String new:
        (sizeInBytes + (appendNull ifTrue: [1] ifFalse: [0])).
    stringIndex := 1.
    byteIndex := 1.
    [byteIndex <= sizeInBytes]
        whileTrue: [
            aChar := self basicAt: byteIndex.
            (aChar asInteger = 0) ifFalse: [       " lead byte of DBC "
                mixedString at: stringIndex put: aChar.
                stringIndex := stringIndex + 1].
            mixedString at: stringIndex put: (self basicAt: (byteIndex + 1)).
            stringIndex := stringIndex + 1.
            byteIndex := byteIndex + 2].
    appendNull
         ifTrue: [mixedString at: stringIndex put: 0 asCharacter]
         ifFalse: [stringIndex := stringIndex - 1].
    ^mixedString copyFrom: 1 to: stringIndex! 
asNormalizedString
    ^self invalidMessage! 
asNormalizedString: leadByteFlags
    ^self invalidMessage!  
asSymbol
        "Answer a symbol whose characters
         are the same as the receiver string."
    ^self containsDBCharacter
        ifTrue: [DoubleByteSymbol intern: self]
        ifFalse: [Symbol intern: self asMixedString]!
at: anInteger
        "Answer the character at position
         anInteger in the receiver string."
    | byteIndex |
    self checkIndex: anInteger.
    byteIndex := self byteIndexOfCharAt: anInteger.
    ^Character
        leadByte: (self basicAt: byteIndex)
        trailByte: (self basicAt: (byteIndex + 1))!  
at: anInteger put: aCharacter
        "Answer aCharacter.  At index position
         anInteger in the receiver put the
         character aCharacter."
    | byteIndex |
    self checkIndex: anInteger.
    self checkCharacter: aCharacter.
    byteIndex := self byteIndexOfCharAt: anInteger.
    self
        basicAt: byteIndex put: aCharacter leadByte;
        basicAt: (byteIndex + 1) put: aCharacter trailByte.
    ^aCharacter!  
byteIndexOfCharAt: anInteger
        "Private - answer the index of the lead byte of
          the character at anInteger in the receiver. "
    ^(anInteger * 2) - 1! 
charIndexOfByteAt: anInteger
        " Private - answer the index of the character containing
          the byte anInteger in the receiver. "
    ^(anInteger + 1) // 2!   
containsDBCharacter
        " Answer whether the receiver contains any double-byte characters. "
    | byteIndex lastCharByteIndex sbcLeadByte answer|
    (answer := VWVMLibrary containsDoubleByteCharacter: self) < 0
        ifFalse: [^answer asBoolean].
    "This code gets execute only when the above fails."
    byteIndex := 1.
    lastCharByteIndex := self basicSize - 1.
    sbcLeadByte := 0 asCharacter.
    [byteIndex > lastCharByteIndex]
        whileFalse: [
            ((self basicAt: byteIndex) ~= sbcLeadByte) ifTrue: [^true].
            byteIndex := byteIndex + 2].
    ^false! 
do: aBlock
        "Answer the receiver.  For each character in the receiver,
         evaluate aBlock with that character as the argument."
    | byteIndex lastCharByteIndex |
    byteIndex := 1.
    lastCharByteIndex := self basicSize - 1.
    [byteIndex > lastCharByteIndex]
        whileFalse: [
            aBlock value: (Character
                leadByte: (self basicAt: byteIndex)
                trailByte: (self basicAt: (byteIndex + 1))).
            byteIndex := byteIndex + 2]! 
inspect
        "Open an inspector window on the receiver."
    DoubleByteStringInspector new openOn: self! 
isDoubleByteString
        "Answer true if receiver is an instance of class
         DoubleByteString, else answer false."
    ^true!  
replace: count with: aCollection
        "Replace count characters of the receiver
         with characters of aCollection.  aCollection
         may be either a Smalltalk byte object or
         an instance of WinAddress.  Answer the receiver."
    | sourceClass sourceBytes |
    sourceClass := aCollection class.
    sourceBytes :=
        ((sourceClass == String) or: [sourceClass == Symbol])
             ifTrue: [DoubleByteString fromString: aCollection]
            ifFalse: [aCollection].
    self replaceBytes: (count * 2) with: sourceBytes! 
replaceBytes: count with: aCollection
        "Private - replace count bytes of the receiver
         with bytes of aCollection.  aCollection
         may be either a Smalltalk byte object or
         an instance of WinAddress.  Answer the receiver."
    WinAddress
        copyFromDBS: aCollection
        to: self
        count: count! 
replaceBytesFrom: byteStart
    to: byteStop
    with: aCollection
    startingAt: byteRepStart
        "Private - replace the bytes of the receiver at index
         positions start through stop with consecutive
         bytes of aCollection beginning at index
         position repStart.  Answer the receiver."
    | index1 index2 stop |
    <primitive: 129>
    (aCollection class isBytes)
        ifFalse: [
            ^super
                replaceFrom: (self charIndexOfByteAt: byteStart)
                to: (self charIndexOfByteAt: byteStop)
                with: aCollection
                startingAt: byteRepStart].
    " primitive failure on large byte objects "
    (self == aCollection and: [byteRepStart < byteStart])
        ifTrue: [ "do backward move for same object"
            index2 := byteRepStart + byteStop - byteStart.
            index1 := byteStop.
            [byteStart <= index1]
                whileTrue: [
                self
                    basicAt: index1
                    put: (aCollection basicAt: index2) asCharacter.
                index1 := index1 - 1.
                index2 := index2 - 1].
            ^self].
    "do forward move"
    index2 := byteRepStart.
      index1 := byteStart.
      [index1 <= byteStop]
           whileTrue: [
              self
                   basicAt: index1
                put: (aCollection basicAt: index2) asCharacter.
               index1 := index1 + 1.
              index2 := index2 + 1].!
replaceFrom: start
    to: stop
    with: aCollection
    startingAt: repStart
        "Replace the characters of the receiver at index
         positions start through stop with consecutive
         characters of aCollection beginning at index
         position repStart.  Answer the receiver."
    | byteStart byteStop sourceBytes byteRepStart |
    " replace 16-bit characters [start..stop] in the receiver "
    byteStart := self byteIndexOfCharAt: start.
    byteStop := (self byteIndexOfCharAt: stop) + 1.
    aCollection isDoubleByteString ifTrue: [
        sourceBytes := aCollection.
        byteRepStart := self byteIndexOfCharAt: repStart]
     ifFalse: [
        (aCollection isString) ifTrue: [
            sourceBytes := DoubleByteString fromString: aCollection.  "fromMixed??"
            byteRepStart := sourceBytes byteIndexOfCharAt: repStart]
        ifFalse: [   " could be ByteArray or WinAddress... "
            sourceBytes := aCollection.
            byteRepStart := repStart]].
    self
        replaceBytesFrom: byteStart
        to: byteStop
        with: sourceBytes
        startingAt: byteRepStart! 
replaceFrom: start to: stop withObject: aCharacter
        "Replace the characters of the receiver
         at index positions start through stop
         with aCharacter.  Answer aCharacter."
    | index |
    index := start.
    [index <= stop]
        whileTrue: [
            self at: index put: aCharacter.
            index := index + 1].
    ^aCharacter!   
size
        " Answer the number of characters in the receiver string. "
    ^super size // 2! !

! DoubleByteSymbol class methods !  
intern: aDBString
        "Private - Answer a DoubleByteSymbol whose character
         sequence is the same as that of aDBString."
    | answer symbol |
    symbol := (super new: aDBString size) initContents: aDBString.
    (answer := SymbolTable symbolAt: symbol) == nil
        ifTrue: [
            answer := symbol.
            SymbolTable add: symbol].
    ^answer!  
mustBeSymbol: aSymbol
        "Report an error if aSymbol is not a Symbol."
    aSymbol isSymbol
        ifFalse: [^self error: 'Must be a Symbol']!   
new: ignoreArgument
        "Private - Answer an instance of the receiver.
         This method reports an error."
    ^self invalidMessage! !

! DoubleByteSymbol methods ! 
= aSymbol
        "Answer true if the receiver object is the
         the argument aSymbol, else answer false."
    <primitive: 110>!  
asCompactString
        " Answer the most compact string containing the
         characters of the receiver. "
    ^self asString! 
asString
        "Answer a String of the characters
         contained by the receiver."
    ^(DoubleByteString new: self size)
        replaceFrom: 1
        to: self size
        with: self!
asSymbol
        "Answer a Symbol for the receiver.  The receiver
         itself is answered since it is a Symbol."
    ^self!
at: anInteger put: aCharacter
        "Replace the character in the receiver indexed by
         anInteger with the argument aCharacter.  This
         message is not valid for symbols, since they
         are not allowed to change."
    ^self invalidMessage!  
basicHash
        "Answer the integer hash
         of the receiver."
    ^self hash!  
containsDBCharacter
        " Answer whether the receiver contains any double-byte characters. "
    ^true! 
deepCopy
        "Answer a copy of the receiver with shallow
         copies of each instance variable.  Because
         symbols are unique (cannot be copied),
         answer the receiver."
     ^self!  
equals: aSymbol
        "Answer true if the receiver is equal to
         the argument aSymbol, else answer false.
         Note that the comparison is case sensitive."
    <primitive: 132>
    ^false!
hash
        "Answer the integer hash
         of the receiver."
    <primitive: 93>!  
id
        "Private - Answer the integer id
         of the receiver."
    <primitive: 75>!
id: anInteger
        "Private - Set the id of the
         receiver to anInteger."
    <primitive: 76>!   
initContents: aDBString
        "Private - initialize the receiver to contain
         the character sequence in aDBString."
    super
        replaceBytesFrom: 1 to: aDBString basicSize
        with: aDBString
        startingAt: 1!   
isDoubleByteSymbol
        "Answer true if receiver is an instance of class
         DoubleByteSymbol, else answer false."
    ^true!  
isSymbol
        "Private - Answer true if receiver is an instance of class
         Symbol or one of its subclasses, else answer false."
    ^true!   
printOn: aStream
        "Append the ASCII representation of
         the receiver to aStream."
    aStream nextPutAll: self!  
replace: count with: aCollection
        "Replace count elements of the receiver
         with elements of aCollection.  This
         message is not valid for symbols, since they
         are not allowed to change."
    ^self invalidMessage!   
replaceBytes: count with: aCollection
        "Private - replace count bytes of the receiver
         with bytes of aCollection.  aCollection
         may be either a Smalltalk byte object or
         an instance of WinAddress.  This
         message is not valid for symbols, since they
         are not allowed to change."
    ^self invalidMessage! 
replaceBytesFrom: byteStart
    to: byteStop
    with: aVariableByteObject
    startingAt: byteRepStart
        "Private - replace the bytes of the receiver at index
         positions start through stop with consecutive
         bytes of aVariableByteObject beginning at index
         position repStart.  This message is not valid
         for symbols, since they are not allowed to change."
    ^self invalidMessage!  
replaceFrom: start
    to: stop
    with: aString
    startingAt: repStart
        "Replace the characters of the receiver at index
         positions start through stop with consecutive
         characters of aString beginning at index
         position repStart.  This message is not valid
         for symbols, since they are not allowed to change."
    ^self invalidMessage!   
replaceFrom: start to: stop withObject: aCharacter
        "Replace the characters of the receiver
         at index positions start through stop
         with aCharacter.  This message is not valid
         for symbols, since they are not allowed to change."
    ^self invalidMessage!
shallowCopy
        "Answer a shallow copy of the receiver.
         Because symbols are unique (cannot be
         copied), answer the receiver."
    ^self! 
species
        "Answer class DoubleByteString as the
         species of double-byte symbols."
    ^DoubleByteString! 
storeOn: aStream
        "Append the text representation of the
         receiver to aStream from which the
         receiver can be reconstructed."
    aStream
        nextPut: $#;
        nextPutAll: self! !

! Symbol class methods !   
intern: aString
        "Private - Answer a Symbol whose character sequence
         is the same as that of aString."
    | answer symbol |
    symbol := (super new: aString size) initContents: aString.
    (answer := SymbolTable symbolAt: symbol) == nil
        ifTrue: [
            answer := symbol.
            SymbolTable add: symbol].
    ^answer!
purgeUnusedSymbols
        "Purge unused symbols from symbol table."
    | aBag newSymbolTable newHashArray prev i intState |
"permanent symbols"
    i := #(mustBeBoolean cantReturn doesNotUnderstand: stackOverflow).
    intState := Process enableInterrupts: false.
"get a set of method selectors"
    newHashArray := Array new: SymbolHashArray size.
    CompiledMethod allInstances do: [:i |
        newHashArray
            at: i selector id + 1
            put: i selector].
"purge SymbolTable and SymbolHashArray so that
 gc will collect all symbols not used."
    SymbolHashArray := newHashArray.
"rebuild SymbolTable and SymbolHashArray
 using all instances of Symbol."
    newSymbolTable := SymbolSet new: SymbolTable size.
    SymbolTable do: [:sym|
        (sym isInDLL) ifTrue: [
            newSymbolTable add: sym.
            SymbolHashArray
                at: sym id + 1
                put: sym]].
    SymbolTable instVarAt: 2 put: nil.
    SymbolTable := nil.
    (Array with: Symbol with: DoubleByteSymbol) do: [ :aSymbolClass |
        aSymbolClass allInstances do: [:sym |
        newSymbolTable add: sym.
        SymbolHashArray
            at: sym id + 1
            put: sym]].
    SymbolTable := newSymbolTable.
"shrink hash array"
    "find last symbol"
    i := SymbolHashArray size.
    [(SymbolHashArray at: i) isSymbol]
        whileFalse: [i := i - 1].
    newHashArray := Array new: (i + 1000
        min: SymbolHashArray size).
    newHashArray
        replaceFrom: 1
        to: newHashArray size
        with: SymbolHashArray
        startingAt: 1.
"rebuild hash array"
    "find first free slot"
    i := 1.
    [((newHashArray at: i) isSymbol)]
        whileTrue: [i := i + 1].
    SymbolHashArrayFreeListHead := i.

    prev := SymbolHashArrayFreeListHead.
    i to: newHashArray size do: [:j |
        ((newHashArray at: j) isSymbol)
            ifFalse: [
                newHashArray at: prev put: j.
                prev := j]].
    SymbolHashArray := newHashArray.
    Process enableInterrupts: intState.! !

! Symbol methods !
asCompactString
        " Answer the most compact string containing the
         characters of the receiver. "
    ^self asString! 
asCUAPresentableString

    "Added by OSI"

    "Take a smalltalk style symbol, separate its capital-letter-delimited tokens
     into words separated by spaces and return a string."

    | inStream outStream nextChar |
    #addedByOSI.
    inStream := ReadStream on: self asString.
    outStream := WriteStream on: (String new: self asString size).

    nextChar := inStream next.
    outStream nextPut: nextChar.

    [ inStream atEnd ] whileFalse: [
        nextChar := inStream next.
        (nextChar isUpperCase) ifTrue: [
            outStream nextPut: $ .
        ].
        outStream nextPut: nextChar asLowerCase.
    ].

    ^outStream contents!   
asMixedString
        "Answer the reciever as a String in mixed-encoding."
    ^self asString!  
asNormalizedString
    ^self invalidMessage! 
asNormalizedString: leadByteFlags
    ^self invalidMessage!  
asPresentableString

    "Added by OSI"

    "Take a smalltalk style symbol, separate its capital-letter-delimited tokens
     into words separated by spaces, capitalize the first word, and return a string."

    | inStream outStream nextChar |
    #addedByOSI.
    inStream := ReadStream on: self asString.
    outStream := WriteStream on: (String new: self asString size).

    nextChar := inStream next.
    outStream nextPut: nextChar asUpperCase.

    [ inStream atEnd ] whileFalse: [
        nextChar := inStream next.
        (nextChar isUpperCase) ifTrue: [
            outStream nextPut: $ .
        ].
        outStream nextPut: nextChar.
    ].

    ^outStream contents!  
equals: aSymbol
        "Answer true if the receiver is equal to
         the argument aSymbol, else answer false.
         Note that the comparison is case sensitive."
    <primitive: 132>
    ^false!
initContents: aString
        "Private - initialize the receiver to contain
         the character sequence in aString."
    super
        replaceFrom: 1 to: aString size
        with: aString
        startingAt: 1! 
replace: count with: aCollection
        "Replace count elements of the receiver
         with elements of aCollection.  This
         message is not valid for symbols, since they
         are not allowed to change."
    ^self invalidMessage!   
replaceBytesFrom: byteStart
    to: byteStop
    with: aVariableByteObject
    startingAt: byteRepStart
        "Private - replace the bytes of the receiver at index
         positions start through stop with consecutive
         bytes of aVariableByteObject beginning at index
         position repStart.  This message is not valid
         for symbols, since they are not allowed to change."
    ^self invalidMessage!  
replaceFrom: start
    to: stop
    with: aString
    startingAt: repStart
        "Replace the characters of the receiver at index
         positions start through stop with consecutive
         characters of aString beginning at index
         position repStart.  This message is not valid
         for symbols, since they are not allowed to change."
    ^self invalidMessage!   
replaceFrom: start to: stop withObject: aCharacter
        "Replace the characters of the receiver
         at index positions start through stop
         with aCharacter.  This message is not valid
         for symbols, since they are not allowed to change."
    ^self invalidMessage! !

! Process class methods ! 
errorNoWalkback
   "Private - An error occurred for which we want
    no walkback window.  Drop the sender chain
    and restart the Notifier.
    Touched by Ale for StartUpApplication error handling."
    | process application |
    Window new clearMouseCapture.
    Cursor reset.
    Clipboard close.
    self enableInterrupts: false.
    process := self copyStack.
    CurrentProcess := self new.
    CurrentProcess makeUserIF.

    #modifiedByOStyle.
    "try to find application and let it handle the current error..."
    application := Smalltalk at: #StartUpApplication ifAbsent: [].
    (application respondsTo: #errorIn:label:)
    ifTrue: [ application errorIn: process label: '*Error No Walkback*' ].

    process isRecursive ifTrue: [self unwind].
    process := nil.
    self dropSenderChain.
    Processor initialize.
    self enableInterrupts: true.
    Notifier run.!  
queueWalkback: aString  makeUserIF: ifBoolean resumable: resumeBoolean
    "Private - Enter a walkback for current process
     in pending event queue.  Create new
     user interface process if ifBoolean
     is true.
     Touched by Ale for StartUpApplication error handling"
    | process firstTime callBack application |
    [].
    firstTime := true.
    Process enableInterrupts: false.
    process := Process copyStack.
    firstTime
        ifTrue: [ "before resume"
            firstTime := false.
            CurrentProcess := Process new.
            ifBoolean ifTrue: [CurrentProcess makeUserIF].

            #modifiedByOS.
            Debugger isNil
                ifTrue: [
                    "try to find application and let it handle the current error..."
                    application := Smalltalk at: #StartUpApplication ifAbsent: [].
                    (application respondsTo: #errorIn:label:)
                    ifTrue: [ application errorIn: process label: aString ].
                ]
                ifFalse: [
                    PendingEvents add: (Message new
                        selector: #errorIn:label: ;
                        arguments: (Array with: process with: aString))].
            (callBack := process isRecursive)
                ifTrue: [process runable: 0]    "no resume or restart"
                ifFalse: [resumeBoolean
                               ifTrue: [process runable: 2]  "restart or resume"
                               ifFalse: [process runable: 1]].  "only restart"
            process := nil.
            callBack ifTrue: [self unwind].
            self dropSenderChain.
            KeyboardSemaphore signal.  "force null event"
            Process enableInterrupts: true.
            ifBoolean
                ifTrue: [
                    Notifier run]
                ifFalse: [
                    Process enableInterrupts: false.
                    Processor schedule]]
        ifFalse: [ "after resume"
            resumeBoolean
                ifFalse: [self error: 'process not resumable']]! !

! SortedCollection methods ! 
unloadBy: aLoader
    "Write out the instance variables of the receiver
     using the loader object aLoader.  Convert the
     receiver to an OrderedCollection since blocks
     of code cannot be loaded or unloaded.
     Touched by Ale  14 Nov 1990;10:54:16"
    "(MessageBox confirm: 'Convierto ',self class name,' a OrderedCollection ?')
    ifTrue:  ["self asOrderedCollection unloadBy: aLoader"]
    ifFalse: [super unloadBy: aLoader]".
    #modifiedByOStyle.! !

! Set methods !   
rehash
    "Private - Loader... Rehash the receiver.
    Implemented by Ale..."
    #addedByOStyle.
    self rehashFrom: 1! !

! CategorySet methods !  
comment
 "Return the commentstring"
 options isNil ifTrue: [ ^String new ].
 ^options at: #comment ifAbsent: [ String new ].!  
comment: aString
 "Set the contents of comment"
 options isNil ifTrue: [ options := Dictionary new ].
 options at: #comment put: aString.! !

! Dictionary methods ! 
isDictionary

    "Added by OSI"
    #addedByOSI.
    ^true! !

! CPBitmapDict class methods !  
addBitmaps: aFileName

    | theDict |
    (Smalltalk includesKey: #CPSrcDir) ifTrue: [
        theDict := self fromFile: (Smalltalk at: #CPSrcDir), aFileName.
    ] ifFalse: [
        theDict := self fromFile: aFileName.
    ].
    TheDict isNil ifTrue: [
        self defaultBitmapDictionary: theDict
    ] ifFalse: [
        theDict associationsDo: [ :assoc | self defaultBitmapDictionary add: assoc ].
    ].! 
addSystemBitmaps: aFileName

    | theDict |
    (Smalltalk includesKey: #CPSrcDir) ifTrue: [
        theDict := self fromFile: (Smalltalk at: #CPSrcDir), aFileName.
    ] ifFalse: [
        theDict := self fromFile: aFileName.
    ].
    WBSystem isNil ifTrue: [
        self systemBitmapDictionary: theDict
    ] ifFalse: [
        theDict associationsDo: [ :assoc | self systemBitmapDictionary add: assoc ].
    ].!
at: key
    "Returns the bitmap named aKey.
     Implemented by Ale for better implementation."
    #modifiedByOStyle.
    ^self
        at: key
        ifAbsent: []!  
at: key ifAbsent: block

    ^self defaultBitmapDictionary at: key ifAbsent: block! 
at: key put: value

    self defaultBitmapDictionary at: key put: value!
default
   "Private - Returns the currently used
    bitmap dictionary.
    Touched By Ale..."
    #modifiedByOStyle.

    TheDict isNil ifTrue: [TheDict := self new].
    ^TheDict!  
defaultBitmapDictionary
    "Touched by Ale for better implementation"
    #modifiedByOStyle.
    ^self default!   
defaultBitmapDictionary: aDict

    TheDict := aDict!   
fromFile: fileName
    "Touched by Ale for fast reading...
    Touched By Ale..."
    | file aDict |

    #modifiedByOStyle.
    file := File fastPathName: fileName.

    file nextLine = 'BITMAPS' ifFalse: [
        file close.
        ^MessageBox message: 'This file is not a valid bitmap dictionary.'
    ] ifTrue: [
        aDict := self new.
        [ file atEnd ] whileFalse: [
            aDict at: file nextLine trimBlanks put: (Bitmap fromStream: file).
        ].
    ].
    file close.

    ^aDict!   
keyAtValue: v

    ^self defaultBitmapDictionary keyAtValue: v! 
keyAtValue: v ifAbsent: block

    ^self defaultBitmapDictionary keyAtValue: v ifAbsent: block! 
keys

    ^self defaultBitmapDictionary keys!   
loadBitmaps

    self loadBitmaps: 'bitmaps.bdt'!   
loadBitmaps: aFileName
   "Merge the bitmaps in file named aFileName
     with the bitmaps in the current image.
     Touched by Ale for better implementation."
    | dict |
    (Smalltalk includesKey: #CPSrcDir) ifTrue: [
        dict := self fromFile: (Smalltalk at: #CPSrcDir), aFileName.
    ] ifFalse: [
        dict := self fromFile: aFileName.
    ].
    #modifiedByOStyle.
    self mergeBitmaps: dict.
    ^dict!  
loadSystemBitmaps: aFileName

    (Smalltalk includesKey: #CPSrcDir) ifTrue: [
        self systemBitmapDictionary: (self fromFile: (Smalltalk at: #CPSrcDir), aFileName)
    ] ifFalse: [
        self systemBitmapDictionary: (self fromFile: aFileName)
    ].!  
mergeBitmaps: aDictionary
   "Merge the bitmaps in aDictionary
     with the bitmaps in the current image...
    Implemented by Ale..."
    #addedByOStyle.

    aDictionary associationsDo: [:asoc|
        self default
            at: asoc key
            put: asoc value
    ]!   
new
    "Reimplemented to support OSBitmapDict replacement.
    Implemented by Ale..."
    #addedByOStyle.

    self == CPBitmapDict
    ifTrue: [ ^OSBitmapDict new ].

    ^super new!  
saveBitmaps

    self defaultBitmapDictionary saveOn: 'bitmaps'!
sysAt: key

    ^self systemBitmapDictionary at: key!   
sysAt: key ifAbsent: block

    ^self systemBitmapDictionary at: key ifAbsent: block!   
sysAt: key put: value

    self systemBitmapDictionary at: key put: value!  
sysKeys

    ^self systemBitmapDictionary keys! 
systemBitmapDictionary

    ^WBSystem!  
systemBitmapDictionary: aDict

    WBSystem := aDict!   
values

    ^self defaultBitmapDictionary values! !

! CPBitmapDict methods ! 
saveOn: fileName
    "Touched by Ale for fast saving..."
    | file |

    #modifiedByOStyle.
    file := File newFastFile: fileName.
    file nextPutAll: 'BITMAPS'; cr.
    self keysDo: [:k |
        file nextPutAll: k; cr.
        (self at: k) storeOnStream: file.
    ].
    file close.! !

! OSBitmapDict class methods ! 
buildDefaultBytes: aStream
    "Private - Build the defaultDLLBytes method..."

    | source |
    source := ReadWriteStream on: String new.
    source
        nextPut: $!!;nextPutAll: ' ',self symbol,' class methods ';nextPut: $!!;
        cr;nextPutAll: 'defaultDLLBytes
    "Private - Returns the default bytes for an Empty dll file"
    ^#('.

    [aStream atEnd] whileFalse: [
        source cr;next: 4 put: $ .
        32 timesRepeat: [
            aStream atEnd
            ifFalse: [ source nextPutAll: aStream next asciiValue asString;space ]
        ]
    ].

    source cr;nextPutAll: '    )'.

    source fileIn! 
buildDirectory: aDirectory
    "Private - Grant that the directory aDirectory exists.
    If not, create it"

    | root |
    aDirectory isString
    ifTrue: [
        root := aDirectory.
        (root includes: $\) ifFalse: [ root := '.\',root ].
        ^self buildDirectory: (Directory pathName: root)
    ].
    aDirectory valid ifTrue: [^aDirectory].
    root := aDirectory pathName reversed asStream.
    root upTo: $\.
    self buildDirectory:
        (Directory pathName: (root upTo: nil) reversed).
    aDirectory create.
    ^aDirectory! 
convert: cpBitmapDict
    "Private - Convert cpBitmapDict to a new instance of the receiver..."

    | osBitmapDict |
    cpBitmapDict class == self ifTrue: [^self].
    osBitmapDict := self new.
    cpBitmapDict keys do: [:key|
        osBitmapDict
            at: key
            put: (cpBitmapDict at: key)
    ].
    cpBitmapDict become: osBitmapDict.!   
defaultDLLBytes
    "Private - Returns the default bytes for an Empty dll file"

    #platformDependent.

    ^#(
    77 90 0 1 3 0 0 0 8 0 0 0 255 255 8 0 0 1 0 0 0 0 0 0 64 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 1 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    186 16 0 14 31 180 9 205 33 184 1 76 205 33 144 144 84 104 105 115 32 112 114 111 103 114 97 109 32 114 101 113
    117 105 114 101 115 32 77 105 99 114 111 115 111 102 116 32 87 105 110 100 111 119 115 46 13 10 36 32 32 32 32 32
    32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
    32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
    78 69 6 1 124 0 27 0 0 0 0 0 1 131 3 0 0 32 0 0 2 0 1 0 0 0 3 0 3 0 2 0
    5 0 64 0 88 0 92 0 107 0 111 0 151 1 0 0 4 0 8 0 0 0 2 0 0 0 0 0 0 0 0 3
    2 0 23 0 80 13 23 0 3 0 107 1 80 13 107 1 5 0 88 0 65 12 88 0 8 0 0 0 5 88 76 65
    78 71 0 0 3 87 69 80 1 0 0 1 0 8 0 0 6 75 69 82 78 69 76 4 85 83 69 82 4 255 3 205
    63 2 66 0 0 205 63 2 73 1 0 205 63 2 2 0 0 205 63 2 56 0 0 1 63 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    1 0 154 255 255 0 0 85 137 229 49 192 154 255 255 0 0 93 154 255 255 0 0 3 0 3 0 3 0 255 0 3
    0 3 0 13 0 255 0 2 0 3 0 19 0 255 0 4 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    2 0 69 85 139 236 30 137 62 18 0 137 54 22 0 140 6 24 0 227 14 51 192 30 80 81 154 255 255 0 0 11
    192 116 14 51 192 163 28 0 64 163 40 0 139 229 93 77 203 139 236 93 77 89 89 203 88 88 161 40 0 139 62 18
    0 203 140 216 144 69 85 139 236 30 86 87 142 216 139 70 6 163 40 0 232 116 0 184 1 0 95 94 31 93 77 202
    2 0 89 91 235 4 51 201 51 219 163 40 0 137 14 42 0 137 30 44 0 131 62 46 0 0 116 3 232 76 0 161
    42 0 139 22 44 0 139 200 11 202 116 56 131 236 64 139 244 131 250 255 116 7 142 194 38 139 22 0 0 80 82 255
    54 40 0 184 56 0 30 80 22 86 154 255 255 0 0 139 230 51 192 80 22 86 80 80 184 16 16 80 154 255 255 0
    0 131 196 64 161 40 0 180 76 205 33 196 30 36 0 140 192 11 195 116 19 51 192 163 36 0 163 38 0 163 48 0
    184 203 0 14 80 6 83 203 195 80 111 114 116 105 111 110 115 32 67 111 112 121 114 105 103 104 116 32 40 99 41 32
    49 57 57 52 32 79 83 116 121 108 101 46 51 192 135 6 48 0 203 131 62 48 0 0 117 1 203 161 48 0 233 65
    255 139 244 54 142 68 2 38 59 85 2 127 7 124 20 38 59 5 114 15 38 59 85 6 124 8 127 7 38 59 69 4
    119 1 203 184 201 0 233 25 255 5 0 2 43 196 115 21 247 216 54 59 6 10 0 114 12 54 59 6 14 0 115 4
    54 163 14 0 203 184 202 0 233 247 254 3 0 3 1 27 0 1 0 4 0 3 1 171 0 2 0 164 1 3 1 189
    0 2 0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 4 0 32
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 82 117 110 116 105 109 101 32
    101 114 114 111 114 32 37 100 32 97 116 32 37 48 52 88 58 37 48 52 88 46 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    )!  
emptyCode
    "Private - Returns the default bytes for an empty dynalink..."

    EmptyCode isNil
    ifTrue: [ self initializeEmptyCode ].
    ^EmptyCode!  
fromResource: aResName
    "Private - Returns the bitmap named aResName
     from resource file (or a thin bitmap if absent).."

    ^Bitmap
        fromDLLFile: self libraryName
        name: self libraryName
    "
        fromModule: self libraryName
        id: aResName
    "!
initialize
    "Initialize the receiver.
    Replace old Bitmap dict with a new instance..."

   self
        convert: self defaultBitmapDictionary;
        convert: self systemBitmapDictionary.! 
initializeEmptyCode
    "Private - Initialize the receiver's Empty code bits..."

    | file contents pathName bytes |

    pathName := 'Empty.DLL'.
    (File exists: pathName)
    ifTrue: [
        file := File pathName: pathName.
        self buildDefaultBytes: file.
        contents := file contents.
        file close.
    ]
    ifFalse: [
        bytes := self defaultDLLBytes.
        contents := String new: bytes size.
        1 to: bytes size do: [:i|
            contents at: i put: (Character value: (bytes at: i))
        ]
    ].
    EmptyCode := contents.!  
libraryName
    "Private - Returns the default bitmaps library name"
    LibraryName isNil ifTrue: [ LibraryName := 'OSBmps.Dll' ].
    ^LibraryName!  
libraryName: aString
    "Private - Sets the default bitmaps library name"

    LibraryName := aString!
resourceNameFor: aString
    "Private - Returns the name in the resource file for aString.
     Implemented by Ale for loading bitmaps from resource file..."

    ^aString collect: [:c| c == $ ifTrue: [$_] ifFalse: [c]]! !

! OSBitmapDict methods !
canBuildModule
    "Private - True if a new library can be builded"
    | answers dll originalSize command file result back |
    answers := OSPrompter new
        title: 'Building bitmaps module...';
        questions: #( 'Resource Compiler ?' 'Resource source file ?' );
        answers: (Array with: 'RC' with: self resourcePathName );
        open.

    answers isNil ifTrue: [^false].
    answers first trimBlanks isEmpty ifTrue: [^false].
    answers last trimBlanks isEmpty ifTrue: [^false].
    dll := self class libraryName.
    command := answers first,' ',answers last,' ',dll.

    (File exists: dll)
    ifTrue: [
        back := (dll upTo: $.),'.Bak'.
        (MessageBox confirm: 'File ',dll,' already exists.\It will be renamed to: 'withCrs,
            back,'\Do you want to continue ?' withCrs)
        ifFalse: [^false].
        File
            remove: back ifAbsent: [];
            rename: dll to: back.
    ].

    "Creates the DLL..."
    (File pathName: dll)
        nextPutAll: self class emptyCode;
        close.
    originalSize := self class emptyCode size.

    result := KernelLibrary
        winExec: command asParameter
        cmdShow: SwShownormal.

    result < 32 "An Error has occurred"
    ifTrue: [
        self showExecError: result in: command.
        ^nil
    ].

    MessageBox message: 'Close this window when resource compiler has finished'.

    file := File pathName: dll.
    result := file size.
    file close.
    result = originalSize ifTrue: [
        UserLibrary messageBeep: 0.
        (MessageBox confirm:
            'The result library size has been reduced from '
            ,originalSize asString,' to ',result asString,',\'withCrs,
            ' please verify the compiler execution window\'withCrs,
            ' to see a provable error.\\' withCrs,
            ' Do you want to continue ?')
        ifFalse: [^false].
    ].

    ^MessageBox confirm: 'Continue with ProxyObject generation... ?'!  
convertToProxyObjects
    "Private - Convert all the receiver's bitmaps to proxies..."

    | proxyClass |
    proxyClass := Smalltalk
        at: #ProxyObjectFromModule
        ifAbsent: [ ^self error: 'Proxy Objects not allowed in modules.' ].
    self associationsDo: [:asoc|
        asoc value:
            (proxyClass
                ofClass: #Bitmap
                fromModule: self class libraryName
                id: (self class resourceNameFor: asoc key))
    ]!
dumpToModule
    "Pack the bitmaps into the default Dynalink module"

    FileHandle cleanHandles.

    self
        saveAsResources;
        purgeProxyObjects.

    self canBuildModule
    ifTrue: [ self convertToProxyObjects ].

    Bitmap purgeUnusedBitmaps.!
fileNames
    "Private - Returns the receiver's keys as proper filenames"

    | result fName adapt directory used |
    directory := self storeDirectory.

    adapt := [ "filename selection block..."
        fName := fName copyFrom: 1 to: fName size - 3.
        fName size > 5 ifTrue: [ fName := fName copyFrom: 1 to: 5 ].
        (1 to: 99)
            detect: [:i|
                (used includes: fName, i asString,'.bmp')
                ifTrue: [ false ]
                ifFalse: [ fName := fName,i asString,'.bmp'. true ]
            ]   ifNone: [ fName := nil ]
    ].

    result := Dictionary new.
    used := Set new.
    self keys do: [:key|
        fName := key collect: [:c|
            (' :\$*&!!+?<>,.;"@#%^()/[]{}|' includes: c)
            ifTrue: [$_] ifFalse: [c]
            ].
        fName := File fileName: fName extension: 'bmp'.
        fName := fName asLowerCase.
        (used includes: fName) ifTrue: [ adapt value ].
        fName notNil ifTrue: [
            result at: directory ,'\',fName put: key.
            used add: fName.
        ]
    ].
    ^result!
loadFromBmps
    "Load the receiver's bitmaps from dumped bitmap files..."
    | fileNames bmp |
    fileNames := self fileNames.

    fileNames keysDo: [:fileName |
        (File exists: fileName)
        ifTrue: [
            bmp := Bitmap fromFile: fileName.
            bmp notNil
            ifTrue: [
                self at: (fileNames at: fileName) put: bmp
            ]
        ]
    ].!   
purgeProxyObjects
    "Private - Convert proxy objects to real bitmaps"

    self associationsDo: [:asoc|
        asoc value isObjectFromResource
        ifTrue: [
            asoc value notNil "Force object loading..."
            ifTrue: [
                asoc value: asoc value yourself
            ]
        ]
    ]!   
resourcePathName
    "Private - Returns the resource file pathName..."
    ^(self class libraryName upTo: $.),'.RC'!
saveAsBmps
    "Save the receiver's bitmaps as .BMP files"
    | fileNames bmp |
    fileNames := self fileNames.
    fileNames keysDo: [:fileName |
        bmp := self at: (fileNames at: fileName).
        bmp outputToFile: fileName
    ].!  
saveAsResources
    "Save the receiver's bitmaps as .BMP files and generates a resource file..."
    | fileNames resource bitmap |
    resource := File newFile: self resourcePathName.
    fileNames := self fileNames.
    fileNames keys do: [:fName|
        bitmap := self at: (fileNames at: fName).
        bitmap outputToFile: fName.
        resource
            nextPutAll: (self class resourceNameFor: (fileNames at: fName));
            nextPutAll: ' BITMAP ';
            nextPutAll: fName; cr
    ].
    resource close.!   
showError: anInteger in: command
    "Private - An error loading program has occurred.
     Notify the user about this..."
    | errors label |
    errors := #(
        (0  'Memoria insuficiente')
        (2  'Archivo no encontrado')
        (3  'Archivo no encontrado')
        (5  'Atentado de linkeo dinamico a un programa')
        (6  'La libreria requiere distintos segmentos para ejecutarse')
        (10 'Versin incorrecta de sistema operativo')
        (11 'Archivo ejecutable de formato invlido.')
        (12 'Aplicacin de Sistema Operativo OS/2')
        (13 'Aplicacin de Sistema Operativo DOS 4.0')
        (14 'Tipo de ejecutable desconocido')
        (15 'Atentado de ejecucin de un programa no preparado para modo protejido.')
        (16 'Attempt to load a second instance of an .Exe
 containing multiple, writable data segments.')
        (17 'Attempt in large-frame EMS mode to load a
 second instance of an application that links to
 certain nonshareale DLLs already in use')
        (18 'Aplicacin no preparada para correr en modo protejido')
    ).

    errors do: [:each|
        each first = anInteger
        ifTrue: [label := each last]
    ].
    label isNil ifTrue: [label := 'UnKnown Exec error : ', anInteger printString,' in ',command].

    UserLibrary messageBeep: 0.
    MessageBox warning: 'Error de ejecucion (DOS Shell)\' withCrs,label,'\'withCrs,command!
storeDirectory
    "Private - Returns the receiver's store directory"
    self class buildDirectory: self storeDirectoryPath.
    ^self storeDirectoryPath!
storeDirectoryPath
    "Private - Returns the receiver's store directory path name"
    ^'.\OSBmps'! !

! LargeIdentityDictionary class methods ! 
initialSize
        "Private - Answer the initial number of elements
         that a new instance of LargeIdentityDictionary
         contains."
    ^1021!   
new: anInteger
        "Private - Answer an IdentityDictionary
         capable of containing anInteger
         number of elements."
    ^(self basicNew initialize: anInteger * 2)! !

! LargeIdentityDictionary methods !
findKeyIndex: key
        "Private - Answer the index position of the
         key/value pair in the receiver whose key equals
         aKey or the index of the first empty position
         where such an pair would be stored."
    | index lastIndex |
    lastIndex := contents size.
    index := self indexForKey: key.
    [key == (contents at: index)]
        whileFalse: [
            (contents at: index) isNil
                ifTrue: [^index].
            (index := index + 2) > lastIndex
                ifTrue: [ "index wraparound"
                    index := 1]].
    ^index!   
indexForKey: key
        " Private - hash key to index. "
    ^((key basicHash) \\ (contents size // 2)) * 2 + 1! !

! SystemDictionary methods ! 
compressChanges
    "Build a new change log file retaining only the latest version of changed
     methods in the current change log. Save the image to the image file.
    Touched by Ale for class definition placing of current touched classes"
    | logDirectory stream tempLogName dialog classes |
    #modifiedByOStyle.

    dialog := DialogBox new
        fromDLLFile: 'vwdlgs20.dll'
        templateName:'CompressingChange'.
    dialog showWindow.

    logDirectory := (Sources at: 2) file directory.
    stream := logDirectory newFile: 'ChangLog.tmp'.
    stream lineDelimiter: Cr.
    tempLogName := stream pathName.

    classes := self getSourceClasses.
    "store class headers for changed classes"
    classes do: [ :class |
        (class isInDLL not                                "not a Digitalk/V class"
        or: [class instVarNames isInDLL not]) "basic class but instances changed..."
        ifTrue: [self fileOut: class into: stream]
    ].
    "store methods"
    classes do: [ :class |
        self compressChangesOf: class class into: stream.
        self compressChangesOf: class into: stream].
    stream close.
    (Sources at: 2) close.
    File remove: (Sources at: 2) pathName.
    File
        rename: tempLogName
        to: (Sources at: 2) pathName.
    Sources
        at: 2
        put: (logDirectory file: (Sources at: 2) file name).
    (Sources at: 2) lineDelimiter: Cr.
    ApplicationWindow new saveImageNoConfirm.
    dialog close.!   
compressChangesOf: aClass into: aStream
    "Private - Write latest version of all methods
    in aClass that are in the change log to aStream.
    Touched by Ale for shrinked format (redundant
     headers removed)"
    | method |
    aClass selectors
        detect: [:each|
         (aClass compiledMethodAt: each) sourceIndex = 2 ]
        ifNone: [^self]. "no changed methods"

    "Place 'aClass methods'  header"
    self putHeaderOf: aClass into: aStream.
    #modifiedByOStyle.

    "Place methods sources in chunk format"
    aClass selectors asSortedCollection do: [ :s |
        method := aClass compiledMethodAt: s.
        method sourceIndex = 2
            ifTrue: [
                aStream cr.
                self
                    putMethod: method
                    withIndex: 2
                    to: aStream]].

    "place class group termination chunk"
    aStream space;nextPut: $!!. "Changed for proper fileIn..."!
compressSymbols
    "Purge unused symbols.
    Implemented by Ale..."
    #addedByOStyle.
    ^Symbol purgeUnusedSymbols! 
copyright
    "Answers the copyright information embedded in the image.
     Ale - Patch for multiuser login bug"
    |aFile answer|
    #modifiedByOStyle.

    aFile := File pathName: self imageName
                attribute: FileNormal
                mode: (OpenAccessReadonly | OpenShareCompat).
    aFile atEnd
        ifTrue:[ aFile close]
        ifFalse:[
            aFile position: 16r1319.
            (aFile next = $C and:[aFile next = $R])
                ifTrue:[
                    answer := aFile upTo:(Character value:0).
                    aFile close.
                    ^answer]
                ifFalse:[
                    aFile close.
                    ^self error:'Could not find copyright info signature characters']].! 
copyright: aString
        "Embeds copyright information contained in aString
          into the image.    aString must be less than 1024 bytes.
          Note: the string will be embedded into the image
          immediately (Saving the image is not required)."
    |aFile|
    #modifiedByOStyle.

    aString size > 1024  ifTrue:[
        ^ self error: 'Signon file name exceeded maximum file name length'].
    aFile := File pathName: self imageName
                attribute: FileNormal
                mode: (OpenAccessReadonly"write"  | OpenShareCompat).
    aFile atEnd
        ifTrue:[ aFile close]
        ifFalse:[
            aFile position: 16r1319.
            (aFile next = $C and:[aFile next = $R])
                ifTrue:[
                    aFile nextPutAll:aString asParameter.
                    aFile close]
                ifFalse:[
                    aFile close.
                    ^self error:'Could not find copyright info signature characters']].!  
exit
    "Private - Exit Smalltalk/V.
    Touched by ObjectStyle for Float library releasing"
    CursorManager execute change.
    SystemWindow exit.

    #modifiedByOStyle.
    "Ale.  send terminate if it will be understood..."
    (SmalltalkEmulatorInst respondsTo: #terminate)
    ifTrue: [
        SmalltalkEmulatorInst terminate.
        SmalltalkEmulatorInst := nil.
    ].

    Notifier closeAllWindows.    "so that global resource released"
    self notifyExitObjects.
    HelpManager exit.
    Icon exit.
    AbortProcDLL exit.
    CallBack exit.
    Bitmap releaseAllHandles.
    Bitmap deleteMemoryDC;
        deleteAuxillaryDC.

    "LRP - Ale     for proper float library free..."
    "   this fails--> FloatLibrary free. "
    FloatEmulator free.

    VWVMLibrary free.      "It's not freed at this time.  It's ref count is decreased by one."
    Display pen deleteDC.
    WinLogicalObject destroyAll.
    Sources notNil ifTrue: [
        Sources do: [:each |
            each notNil ifTrue: [each close]]].
    Font releaseAllHandles.
    CursorManager normal change.
    Notifier
        quit: nil
        addresses: (Array with: WinMsgNS)!   
fileOut: aClass into: aStream
    "Place the header definition of aClass into aStream.
    Implemented by Ale..."
    | stream |
    #addedByOStyle.
    (aClass selectors
         detect: [:one|
            (aClass compiledMethodAt: one) sourceIndex = 2
         ] ifNone: []
    ) isNil
     & (aClass class selectors
         detect: [:one|
            (aClass class compiledMethodAt: one) sourceIndex = 2
         ] ifNone: []
    ) isNil
    ifTrue: [^nil]. "no changes"
    stream := WriteStream on: (String new: 200).
    aClass fileOutOn: stream.
    aStream
        cr; cr;
        nextPutAll: '"define class"';
        nextChunkPut: stream contents;
        flush!   
imageName
    "Private - Answers the name of the image.
      For the runtime application, this is the name of the exe.
     Touched by LRP - to ignore extended parameters"
    | imageName string|
    #modifiedByOStyle.

    "Check to see if VWin was invoked with a image parameter"
    self isRunTime
        ifTrue: [
            string := String new: 256.
            KernelLibrary getModuleFileName: WIN hInstance
                    name: string size: string size.
            ^ string trimBlanks].
    imageName := String new:50.
    WinAddress copyFrom: WinAddress getVWargs to: imageName count: 50.
    imageName := imageName trimNullTerminator.
    imageName := imageName asStream upTo: $/.  "discard comand line options"
    imageName := (imageName asStream upTo: $-) trimBlanks.
    imageName size > 0
        ifFalse:[ imageName := 'v.exe'].
    ^ imageName!   
methodsInDLL
    "Returns the methods with sources in VWScrXX.DLL.
    Implemented by Ale..."
    #addedByOStyle.
    ^self methodsWithSourceIndex: 3!
methodsInLOG
    "Returns the methods with sources in Change.LOG.
    Implemented by Ale..."
    #addedByOStyle.
    ^self methodsWithSourceIndex: 2! 
methodsInSML
    "Returns the methods with sources in Sources.SML.
    Implemented by Ale..."
    #addedByOStyle.
    ^self methodsWithSourceIndex: 1!
methodsWithoutSources
    "Returns the method with sources removed.
    Implemented by Ale..."
    | result |
    #addedByOStyle.
    result := Set new.
    (self methodsWithSourceIndex: 0)
    do: [:each|
        each sourcePosition = 0
        ifTrue: [result add: each]
    ].
    ^result!   
methodsWithSourceEmbebed
    "Returns the methods with sources embebed in it.
    Implemented by Ale..."
    | result |
    #addedByOStyle.
    result := Set new.
    (self methodsWithSourceIndex: 0)
    do: [:each|
        each sourcePosition = 0
        ifFalse: [result add: each]
    ].
    ^result!
methodsWithSourceIndex: anIndex
    "Private - Returns the methods that has the index anIndex
     as Source index.

        Source Source           meaning
        Index   Position
            0       0               Sources has been removed
            0       4               Sources in method literals
            1       ofs            Sources in .SML
            2       ofs            Sources in .LOG
            3       ofs            Source sin VWSrc10.DLL
    "
    | classes result method |
    #addedByOStyle.
    classes := self getSourceClasses.
    result := Set new.
    classes do: [:aClass |
        aClass selectors do: [ :s |
            method := aClass compiledMethodAt: s.
            method sourceIndex = anIndex
            ifTrue: [result add: method]
        ].
        aClass class selectors do: [ :s |
            method := aClass class compiledMethodAt: s.
            method sourceIndex = anIndex
            ifTrue: [result add: method]
        ].
    ].
    ^result!   
save
        "Private - Truncate and Save image on image file.
        Returns true if the image was saved, false
        if the image was not saved.
    Who touched this method? why?"
    | aFile hFile stubLength stubBuffer imageName backupName
     fileName int handles answer |
    #modifiedByOStyle.

    "Check to see if VWin was invoked with  a image parameter"
    imageName := String new:50.
    WinAddress copyFrom: WinAddress getVWargs to: imageName count: 50.
    imageName := imageName trimNullTerminator.
    imageName := imageName asStream upTo: $/.  "discard comand line options"
    imageName := (imageName asStream upTo: $-) trimBlanks.
    imageName size > 0
        ifFalse:[ imageName := 'v.exe'].

    "Delete v.old to free up disk space"
    backupName := File splitPath: imageName in: Disk.
    fileName := backupName at: 3.
    fileName fileExtension trimBlanks size = 0
        ifTrue: [
            imageName := imageName, '.exe'].
    backupName := File drive: (backupName at: 1)
        path: (backupName at: 2)
        file: (((ReadStream on: (backupName at: 3))
                upTo: $.) , '.bak').
    BackupImage ifTrue: [
        File remove: backupName ifAbsent:[nil]].

    aFile := (File pathName: imageName) asByteFileStream.
    aFile atEnd
        ifTrue:[ aFile close]
        ifFalse:[
        stubLength := (WinStructure fromBytes: (aFile next: 36))
                                uLongAtOffset:32.
        aFile position: 0.
        stubBuffer := aFile next: stubLength.
        aFile close.

        "If BackupImage is false then delete v.exe"
        BackupImage
            ifTrue:[
                File rename: imageName to: backupName]
            ifFalse:[
                File remove: imageName].

        ((hFile := KernelLibrary openFile: Disk drivePathName, '\vwimage.tmp' asParameter
                        reopenBuffer: (WinOfstruct new) asParameter
                        style: OfCreate "| OfShareExclusive") == -1)
            ifTrue:[
                MessageBox message: 'Could not open Image file'.
                ^ False].

        KernelLibrary lwrite: hFile
                            string: stubBuffer asParameter
                            size: stubBuffer size.
        KernelLibrary lclose: hFile].

    int := Process enableInterrupts: false.
    DynamicLinkLibrary withAllSubclasses do: [:class |
        class clearCachedAddresses].
    handles := IdentityDictionary new.
    File allInstancesPrim do: [:each |
        handles at: each put: each fileId.
        each fileId: nil].
    answer := self savePrim.
    handles associationsDo: [:a |
        a key fileId: a value].
    Process enableInterrupts: int.

    (answer isNil)
        ifTrue:[
            MessageBox titled:'Insufficient Disk Space'
                withText: 'Could not save image.  Set BackupImage global variable to false or free up disk space WITHOUT exiting Smalltalk and please try again.'
                style: MbOk | MbIconexclamation.
            ^ false ]
        ifFalse:[
            File remove: imageName ifAbsent: [nil].
            self openChangeLogIn: (Sources at: 2) file directory.
            self logEvaluate:
                    '""*** saved image on: '
                    , Date today printString, ' '
                    , Time now printString, ' ***""'.
            (Sources at: 2) flush].
        File rename: 'vwimage.tmp' to: imageName.
        ^ true.!
signonDLL
    "Answers the signon DLL's file name embedded in the image.
     When the Smalltalk runtime application (the image) is executed,
     the signon DLL specified in aString will first be loaded before
     the application is started up.
    Touched by Object Style for multiuser support"
    |aFile answer string|

    #modifiedByOStyle.
    aFile := File pathName: self imageName "Multiuser Patch"
                attribute: FileNormal
                mode: (OpenAccessReadonly | OpenShareCompat).
    aFile atEnd
        ifTrue:[ aFile close]
        ifFalse:[
            aFile position: 16r1212.
            (aFile next = $S and:[aFile next = $F])
                ifTrue:[
                    answer := aFile upTo:(Character value:0).
                    aFile close.
                    ^answer]
                ifFalse:[
                    aFile close.
                    ^self error:'Could not find signon file name signature characters']].!   
signonDLL: aString
        "Embeds the signon DLL's file name contained in aString
         into the image.  When the Smalltalk runtime application
         ( the image) is executed, the signon DLL specified in
         aString will first be loaded before the application is started
         up.
          Note: the string will be embedded into the image
          immediately (Saving the image is not required)
    Who touched this method? why?"
    |aFile|
    #modifiedByOStyle.

    aString size > MaxFileNameLength  ifTrue:[
        ^ self error: 'Signon file name exceeded maximum file name length'].
    aFile := File pathName: self imageName
                attribute: FileNormal
                mode: (OpenAccessReadonly"write"  | OpenShareCompat).
    aFile atEnd
        ifTrue:[ aFile close]
        ifFalse:[
            aFile position: 16r1212.
            (aFile next = $S and:[aFile next = $F])
                ifTrue:[
                    aFile nextPutAll:aString asParameter.
                    aFile close]
                ifFalse:[
                    aFile close.
                    ^self error:'Could not find signon file name signature characters']].!   
startUp
    "Private - Initiate a Smalltalk/V session and execute
     the 'go' file.
    Touched for fileIn of go file only during Development..."
    | f |
    Process enableInterrupts: false.
    CurrentEvents := OrderedCollection new.
    WIN := WinInfo new.
    WIN getIt.
    KernelLibrary := WIN kernelHandle.
    UserLibrary := UserDLL getHandle.
    GDILibrary := GDIDLL getHandle.
    KeyboardLibrary := KeyboardDLL getHandle.
    VWVMLibrary := VWVMDLL open.
    NationalLanguage := NationalLanguageSupport new.
    Float startUp.
    WinLogicalObject initObjects.
    OriginalScreenExtent := Display extent.
    OriginalSysFontSize := SysFont charSize.
    Screen initialize.
    Bitmap initialize.
    Font initialize.
    Font allInstancesPrim do:[:font | font initFontHandle].
    Notifier initializeWindowHandles.
    GraphicsTool initialize.
    Smalltalk at: #OldScreenMode
        put: (Array new: 5).
    CursorManager initialize.
    WinMsgNS :=   WinMessage new.
    WinMsgNS contents:
        (KernelLibrary globalLock:
            (KernelLibrary globalAlloc: 0 bytes: 30)).
    PoppedModelessWindows := OrderedCollection new.
    Process enableInterrupts: true.
    Processor initialize.
    Sources := Array new: 3.
    Disk := Directory current.
    FileHandle initHandles.
    DialogBox initialize.
    FileDialog initialize.
    Terminal font: SysFont.
    CallBack startUp.
    HelpManager startUp.
    Icon startUp.
    AbortProcDLL startUp.
    self notifyStartUpObjects.
    Smalltalk isRunTime ifFalse: [
        #modifiedByOStyle.
        f := Disk file: 'go'.
        f size > 0
            ifTrue: [f fileIn; close]
            ifFalse: [f close. File remove: f pathName].
        ((Sources at: 1) isNil and: [FileHandle isThere: (File fullPathName:'sources.sml')])
            ifTrue: [
                Sources at: 1 put: (File pathNameReadOnly: 'sources.sml')].
        (Sources at: 2) isNil ifTrue: [
            Sources at: 2 put: (File pathName: 'change.log')].
        (Sources at: 3) isNil ifTrue: [
            Sources at: 3 put: (self openDllSource)]].

    self closeSignOn.

    Notifier resume.
    Smalltalk isRunTime ifTrue: [
        self changeRuntimeIcon].

    "Opening of SmalltalkEmulator and SystemWindow is done in
    Notifier resume now."

    Notifier startRun! !

! Context methods !  
blockArgumentCount
    "Returns the instance var of the receiver
     for external manipulation.
    Touched By Ale..."
    #modifiedByOStyle.
    ^blockArgumentCount!  
method
    "Returns the receiver's method.
    Implemented by Ale for source support..."
    #addedByOStyle.
    ^homeContext method! 
printOn: aStream
        "Append the ASCII representation of the receiver
         to aStream.
    Implemented by Ale for source dump..."
    | source |
    #addedByOStyle.
    source := self sourceString.
    source isNil ifTrue: [ ^super printOn: aStream ].
    aStream nextPutAll: source.!  
scanCollectionIC: cole for: ic
    "Private - Scan a collection of parse structures for IC at ic
    and returns the node wich contains the IC or nil ifFailed.
    WARNING : Platform dependent...
    Implemented by Ale for source support..."

    | node |
    #addedByOStyle.
    cole isEmpty ifTrue: [^nil].

    node := cole
        detect: [:each|
            each icStart notNil
              and: [each icEnd notNil
              and: [ic between: each icStart and: each icEnd ]]
            ] ifNone: [].

    ^self scanIC: node for: ic!  
scanGeneric: struct for: ic in: instVars
    "Private - Scan a compiled statement structure struct for IC at ic
    and inside it's instance variables...
    WARNING : Platform dependent...
    Implemented by Ale for source support..."

    | node var checkBound checkBounds |
    #addedByOStyle.
    checkBound := [:x :y| x icEnd isNil ifTrue: [ x instVarAt: 2 put: y icEnd] ].
    checkBounds := [:col |
        2 to: col size do: [:i|
            checkBound value: (col at: i - 1) value: (col at: i)
        ].
        col size = 1 ifTrue: [ checkBound value: col first value: struct].
    ].

    instVars do: [:inst|
        var :=
            inst isInteger
            ifTrue: [ struct instVarAt: inst ]
            ifFalse: [ struct perform: inst ].
        var notNil
        ifTrue: [
            node := var isCollection
                ifTrue: [
                    checkBounds value: var.
                    self scanCollectionIC: var for: ic
                ]
                ifFalse: [
                    checkBound value: var value: struct.
                    self scanIC: var for: ic
                ].
            node notNil ifTrue: [^node]
        ]
    ].

    ^nil!
scanIC: struct for: ic
    "Private - Scan a compiled statement structure struct for IC at ic
    and returns the node wich contains the IC.
    WARNING : Platform dependent...
    Implemented by Ale for source support..."

    | ok child |
    #addedByOStyle.
    struct isNil ifTrue: [^nil].
    ok := struct icStart notNil
        and: [ struct icEnd notNil
        and: [ ic between: struct icStart and: struct icEnd ]].

    (struct respondsTo: #optimizeMethod)
    ifTrue: [ "VMethod parse node..."
        child := self scanGeneric: struct for: ic in: #(statements).
        ^child isNil & ok ifTrue: [struct] ifFalse: [ child ]
    ].

    (struct respondsTo: #assignees:)
    ifTrue: [ "VAssign parse node..."
        child := self scanGeneric: struct for: ic in: #(7). "instVar=expression"
        ^child isNil & ok ifTrue: [struct] ifFalse: [ child ]
    ].

    (struct respondsTo: #optimizeBlock:)
    ifTrue: [ "VBlock parse node..."
        child := self scanGeneric: struct for: ic in: #(7). "instVar=statements"
        ^child isNil & ok ifTrue: [struct] ifFalse: [ child ]
    ].

    (struct respondsTo: #expression:)
    ifTrue: [ "VExpression parse node..."
        child := self scanGeneric: struct for: ic in: #(6). "instVar=expression"
        ^child isNil & ok ifTrue: [struct] ifFalse: [ child ]
    ].

    (struct respondsTo: #genOr:)
    ifTrue: [ "VMessage parse node..."
        child := self scanGeneric: struct for: ic in: #(receiver arguments).
        ^child isNil & ok ifTrue: [struct] ifFalse: [ child ]
    ].

    "unKnown parse node or non container node..."
    ^ok ifTrue: [struct] ifFalse: []!  
searchForEOB: aStream
    "Private - Search for end of block character in aStream...
    Implemented by Ale for source support..."

    | current |
    #addedByOStyle.
    [
        aStream atEnd ifTrue: [^nil].
        aStream peek = $]
    ] whileFalse: [
        current := aStream next.
        current = $[ ifTrue: [ self searchForEOB: aStream].
        current = $$ ifTrue: [ aStream next ].
        current = $' ifTrue: [
            [ aStream skipTo: $'.
            aStream peek = $' ] whileTrue: [ aStream next ].
        ].
        current = $" ifTrue: [ aStream skipTo: $" ].
    ].
    aStream next!   
sourceString
    "Returns the source copde of the receiver.
    WARNING : Platform dependent...
    Implemented by Ale for source support..."

    | block mth source descriptor root node ic start end point stream |

    #addedByOStyle.
    (Smalltalk product = 'Smalltalk/V Windows'
    and: [ Smalltalk version = '2.0' ])
    ifFalse: [ ^"nil "self error: 'This method must be reimplemented.' ].

    block := self.
    ic := block startPC - 12. "VCompiler objectHeaderSize" "compiler dependent"
    mth :=  block method. mth isNil ifTrue: [^nil].
    source := mth sourceString. source isNil ifTrue: [^nil].

    descriptor := Compiler positionsOf: source in: mth classField.
    descriptor isNil ifTrue: [^nil].
    root := descriptor whoContains: ic.
    node := self scanIC: root for: ic.
    node isNil ifTrue: [ ^nil ].

    start := node position.
    end := node endPosition.
    end isNil ifTrue: [
        stream := source asStream.
        stream position: start.
        self searchForEOB: stream.
        end := stream position.
    ].
    ^source copyFrom: start to: end! 
startPC
    "Returns the instance var of the receiver
     for external manipulation
    Implemented by Ale for source support..."
    #addedByOStyle.
    ^startPC! !

! HomeContext methods !
method
    "Returns the receiver's method.
    Implemented by Ale for source support..."
    #addedByOStyle.
    ^method! !

! CPCLBField class methods !   
new

    ^super new initialize! !

! CPCLBField methods ! 
autoFieldWidth

    ^fieldWidth isNil!  
defaultJustification

    ^#left!   
fieldPixelWidth

    cachedWidth isNil ifTrue: [
        cachedWidth := self fieldWidth * font width.
    ].

    ^cachedWidth! 
fieldPixelWidth: anObject

    "set the field width for this field, in pixels
    (used for autofieldWidth)"

    cachedWidth := anObject!   
fieldWidth

    ^fieldWidth!
fieldWidth: anObject

    "set the field width for this field, in characters"

    fieldWidth := anObject.!   
fieldWidthString

    self autoFieldWidth ifTrue: [
        ^'Auto'
    ] ifFalse: [
        ^fieldWidth printString
    ].!
font

    ^font!
font: anObject

    font := anObject.
    self autoFieldWidth ifFalse: [
        cachedWidth := fieldWidth * font width.
    ].! 
header

    ^header!
header: anObject

    header := anObject!   
headerHeight

    "Private"

    ^self headerLineCount * self font height!
headerLineCount

    "Private"

    ^(self header occurrencesOf: Lf) + 1! 
initialize

    justification := self defaultJustification.!
justification

    ^justification!  
justification: anObject

    justification := anObject! 
justificationOffsetFor: aString

    "Answer the offset within the field that the
     text should start displaying at for correct justification"

    | offset |

    (justification = #left) ifTrue: [
        offset := 0.
    ] ifFalse: [
        (justification = #right) ifTrue: [
            offset := self fieldPixelWidth - ( font stringWidth: aString).
        ] ifFalse: [
            offset := ((self fieldPixelWidth - ( font stringWidth: aString)) // 2).
        ].
    ].
    ^offset!  
justificationString

    | string |

    string := self justification asString.
    string at: 1 put: (string at: 1) asUpperCase.
    ^string!  
printOn: aStream

    aStream nextPutAll: '(', self header printString, ',', self selectorString, ',', self fieldWidthString, ',', self justification, ')'.!
selector

    ^selector!
selector: anObject

    selector := anObject!   
selectorString

    selector isNil ifTrue: [
        ^''
    ].

    ^'#', selector asString!   
storeOn: aStream indentString: indentString

    | indent theHeader |

    indent := indentString, '    '.

    aStream nextPutAll: indentString, self class name, ' new'; cr.

    self header isNil  ifTrue: [
        theHeader := ''.
    ] ifFalse: [
        theHeader := self header.
    ].
    aStream nextPutAll: indent, 'header: ',  header asQuotedString.

    self autoFieldWidth not ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indent, 'fieldWidth: ', self fieldWidth asString.
    ].
    self justification ~= self defaultJustification ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indent, 'justification: #', self justification asString.
    ].
    (self selector notNil and: [ self selector notEmpty ]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indent, 'selector: #', self selector asString.
    ].!   
windowsJustification

    justification = #left ifTrue: [
        ^SsLeft
    ].

    justification = #right ifTrue: [
        ^SsRight
    ].

    justification = #center ifTrue: [
        ^SsCenter
    ].

    self error: 'Invalid Justification'.! !

! CPTreeNode class methods ! 
new

    ^super new initialize! !

! CPTreeNode methods ! 
asFlatList

    | list |

    list := OrderedCollection new.
    list add: self.
    self collapsed ifTrue: [
        ^list
    ].

    children notNil ifTrue: [
        children do: [ :c |
            list addAll: c asFlatList
        ].
    ].

    ^list! 
asFullList

    | list |

    list := OrderedCollection new.
    list add: self.
    children notNil
        ifTrue: [
            children do: [ :c |    list addAll: c asFullList    ]].
    ^list!
children

    ^children!
children: anObject

    children := anObject!   
childrenMethod

    ^self owner childrenMethod! 
collapsed

    ^collapsed!  
collapsed: anObject

    collapsed := anObject! 
collapsedString

    (self collapsed & children notNil and: [ children notEmpty ])  ifTrue: [
        ^'...'
    ] ifFalse: [
        ^''
    ].!   
depthInTree

    self parent isNil ifTrue: [
        ^0
    ] ifFalse: [
        ^self parent depthInTree + 1
    ].!   
displayWidth: aFont

    | charWidth |

    charWidth := aFont width.

    ^(self leftMargin * charWidth) +
     (self depthInTree * self indentWidth *  charWidth) +
     self iconWidth + (self iconMargin * charWidth) +
     (aFont stringWidth: self listString)!   
displayWith: aPen inBox: aRectangle

    | icon startX startY charWidth |

    icon := self icon.

    charWidth := aPen font width.

    startX := aRectangle origin x + (self leftMargin * charWidth) +
            (self depthInTree * self indentWidth * charWidth).

    icon notNil ifTrue: [
        startY := aRectangle origin y + ((aRectangle height - icon height) // 2).
        icon displayAt: startX@startY with: aPen.
        startX := startX +  icon width + (self iconMargin *  charWidth).
    ].

    startY := aRectangle origin y + ((aRectangle height - aPen font height) // 2).

    aPen
        setTextAlign: TaTop;
        displayText: self listString at: startX@startY.!  
expandOrCollapse

    collapsed := collapsed not.!  
expandTo

    self parent isNil
        ifTrue: [ nil ]
        ifFalse: [
            self parent collapsed: false.
            self parent expandTo].!
getChildren

    | childrenMethod objectChildren |

    (childrenMethod := self childrenMethod) notNil ifTrue: [
        objectChildren := object perform: childrenMethod.
    ].

    objectChildren notNil ifTrue: [
        children := objectChildren collect: [ :c |
            CPTreeNode new object: c owner: self owner parent: self
        ].
    ].!  
icon

    | meth |

    (meth := self iconMethod) notNil ifTrue: [
        ^object perform: meth
    ] ifFalse: [
        ^nil
    ].!
iconHeight

    | i |

    (i := self icon) notNil ifTrue: [
        ^i height
    ] ifFalse: [
        ^0
    ].!
iconMargin

    ^1! 
iconMethod

    ^self owner iconMethod! 
iconWidth

    | i |

    (i := self icon) notNil ifTrue: [
        ^i width
    ] ifFalse: [
        ^0
    ].!  
indentWidth

    "Number of characters to indent per hierarchical level"

    ^3! 
initialize

    collapsed := false.!
leftMargin

    ^1! 
listString

    ^(object perform: self nameMethod), self collapsedString!   
maxDisplayWidth: aFont

    | maxDisplayWidth |

    maxDisplayWidth := self displayWidth: aFont.

    self collapsed ifTrue: [
        ^maxDisplayWidth
    ].

    children notNil ifTrue: [
        children do: [ :c |
            maxDisplayWidth := (c maxDisplayWidth: aFont) max: maxDisplayWidth.
        ].
    ].

    ^maxDisplayWidth!   
maxIconHeight

    | max |

    max := self iconHeight.

    children notNil ifTrue: [
        children do: [ :c |
            max := max max: c maxIconHeight.
        ].
    ].

    ^max!  
nameMethod

    ^self owner nameMethod! 
object

    ^object!
object: anObject owner: anOwner parent: aParent

    object := anObject.
    self owner: anOwner.
    self parent: aParent.

    self getChildren.! 
owner

    ^owner!  
owner: anObject

    owner := anObject! 
parent

    ^parent!
parent: anObject

    parent := anObject!   
printOn: aStream

    aStream nextPutAll: '<', self listString, '> '.
    self icon notNil ifTrue: [
        aStream nextPutAll: '[has icon]'
    ].! !

! OSTreeNode methods !
getChildren

    | childrenMethod objectChildren |

    (childrenMethod := self childrenMethod) notNil ifTrue: [
        objectChildren := self getObjectFrom: childrenMethod.
    ].

    objectChildren notNil ifTrue: [
        children := objectChildren collect: [ :c |
            OSTreeNode new object: c owner: self owner parent: self
        ].
    ].!  
getObjectFrom: msg
    "Private - Obtain the result of evaluating msg into the receiver's object.
    Multiple protocols are supported..."

    msg isSymbol ifTrue: [^object perform: msg].

    msg isContext ifTrue: [
      ^msg blockArgumentCount = 1
        ifTrue: [ msg value: object ]
        ifFalse: [ msg value ]
    ].

    msg isNil ifTrue: [^nil].
    msg isString ifTrue: [^object perform: msg asSymbol].

    (msg respondsTo: #evaluate:)
    ifTrue: [ ^msg evaluate: object ].

    (msg respondsTo: #value:)
    ifTrue: [ ^msg value: object ].

    ^self error: 'Unsupported message selector'!   
icon

    | iconMethod |

    (iconMethod := self iconMethod) notNil ifTrue: [
        ^self getObjectFrom: iconMethod
    ] ifFalse: [
        ^nil
    ].!  
indentWidth
    "Number of characters to indent per hierarchical level"

    ^indentWidth! 
indentWidth: anInteger
    "Sets the Number of characters to indent per hierarchical level"

    indentWidth := anInteger! 
initialize
    "Private - Initialize the receiver..."

    super initialize.
    indentWidth := 3.!   
listString

    | nameMethod string |
    nameMethod := self nameMethod.
    (nameMethod  isNil or: [(string := self getObjectFrom: nameMethod) isNil])
    ifTrue: [ string := object asString ].
    ^string, self collapsedString! !

! CursorManager class methods !  
corner

    "Added by OSI"
    #addedByOSI.
    ^CursorConstants at: 'Corner'!
initialize

    "Modified by OSI to support additional cursors."

        "Private - Fill the Cursors dictionary with available cursors."
    #modifiedByOSI.
    CursorConstants at: 'HourGlass'
        put: (self new handle: (
            self getWinCursor: IdcWait)).
    CursorConstants at: 'Arrow'
        put: (self new handle: (
            self getWinCursor: IdcArrow)).
    CursorConstants at: 'Normal'
        put: self new .
    CursorConstants at: 'Text'
        put: (self new handle: (
            self getWinCursor: IdcIbeam)).
    CursorConstants at: 'CrossHair'
        put: (self new handle: (
            self getWinCursor: IdcCross)).

    CursorConstants at: 'Origin'
        put: (self new handle: (
            self getWinCursor: IdcSizenesw)).
    CursorConstants at: 'Corner'
        put: (self new handle: (
            self getWinCursor: IdcSizenwse)).
    CursorConstants at: 'LeftRight'
        put: (self new handle: (
            self getWinCursor: IdcSizewe)).
    CursorConstants at: 'UpDown'
        put: (self new handle: (
            self getWinCursor: IdcSizens)).! 
leftRight

    "Added by OSI"
    #addedByOSI.
    ^CursorConstants at: 'LeftRight'!  
loadCursor: cursorName fromDLL: library
    "Returns an instance of the receiver
     named cursorName from a dll.
     Nil if not found.
    Implemented by Ale..."
    | handle dll |
    #addedByOStyle.
    dll := library isString
        ifTrue: [DynamicLinkLibrary open: library] "library name"
        ifFalse: [library "handle"]. "dynamic link library asumed"

    handle := UserLibrary
        loadCursor: dll
        name: cursorName asParameter.

    handle = 0 ifTrue: [^nil].
    ^self new
        handle: (WinHandle fromInteger: handle);
        yourself!  
upDown

    "Added by OSI"
    #addedByOSI.
    ^CursorConstants at: 'UpDown'! !

! CursorManager methods ! 
free
    "Destroy cursor resources and free asociated memory.
    Implemented by Ale for freeUp of loaded cursors..."
    #addedByOStyle.
    ^(UserLibrary destroyCursor: handle) = 0
        ifTrue: [false] ifFalse: [handle := nil.true]!
release
    "Discard all receiver's resources.
    Implemented by Ale..."
    #addedByOStyle.
    self free.
    super release! !

! Directory class methods ! 
extractDateTimeFrom: aString
        "Answer a String in form 'yy-mm-dd hh:mm:ss'
         describing date and time from DOS directory
         entry aString."
    | answer byte1 byte2 field1 field2 field3 aStream |
    answer := String new: 18.
    aStream := WriteStream on: answer.
        "computing the yy-mm-dd part"
    byte1 := (aString at: 25) asciiValue.
    byte2 := (aString at: 26) asciiValue.
    field1 := (byte2 bitShift: -1) + 80.
    field2 := (byte1 bitShift: -5)
        + ((byte2 bitAnd: 1) * 8).
    field3 := byte1 bitAnd: 31.
    (Date newDay: field3
        month: (Date nameOfMonth: field2)
        year: field1) printOn: aStream.
    aStream space; space.
        "computing the hh:mm:ss part"
    byte1 := (aString at: 23) asciiValue.
    byte2 := (aString at: 24) asciiValue.
    field1 := byte2 bitShift: -3.
    field2 := (byte1 bitShift: -5)
        + ((byte2 bitAnd: 7) * 8).
    field3 := (byte1 bitAnd: 31) * 2.
    (Time hours: field1 minutes: field2 seconds: field3) printOn: aStream.
    ^answer! !

! Directory methods !   
fastFile: aString
    "Answer a FastFileStream for the file named aString in the current directory.
    If the file does not exist, it will be created.
    Implemented by Ale..."
    #addedByOStyle.
    ^FastFileStream on: (File open: aString in: self)!
fastFile: aString
    action: anAction
    fileSize: aFileSize
    attribute: anAttr
    flags: openFlags
    mode: aMode
        "Answer a FileStream for the file named
         aString in the receiver directory with DosOpen parameters
         anAction, aFileSize, anAttr, openFlags, and aMode.
         See FileHandle open:in:action:fileSize:attribute:flags:mode:
         for more details.
    Implemented by Ale..."
    #addedByOStyle.
    ^FastFileStream on: (File open: aString in: self
        action: anAction fileSize: aFileSize
        attribute: anAttr flags: openFlags mode: aMode)!
fastFileReadOnly: aString
        "Answer a FileStream for the file named
         aString in the receiver directory.  If the file
         does not exist, it will be created. The file opened
         will be read only.
    Implemented by Ale..."
    #addedByOStyle.
    ^self
        fastFile: aString
        action: (WinStructure new: 2) asParameter
        fileSize: 0
        attribute: FileReadonly
        flags: FileOpen
        mode: OpenAccessReadonly | OpenShareDenynone!   
newFastFile: aString
    "Answer a FastFileStream for the file named
     aString in the receiver directory.
    If the file exists, it will be removed
     and a new file will be created.
    Implemented by Ale..."
    | answer |
    #addedByOStyle.
    answer := self fastFile: aString.
    answer size > 0
    ifTrue: [
        answer close.
        File remove: answer pathName.
        answer := self fastFile: aString
    ].
    ^answer! !

! DIB class methods ! 
fromBitmap: aBitmap
   "Create a DIB bitmap from a Device Dependent Bitmap.
    Implemented by Ale..."
    #addedByOStyle.
   ^self new fromBitmap: aBitmap!  
fromDLLFile: aFileName name: bitmapName
    "Answer an instance of the receiver loaded from aModule,
    identified by bitmapName.
    Implemented by Ale for Bitmap compatibility..."
    | hLibrary handle dib |
    #addedByOStyle.
    (hLibrary :=
        KernelLibrary loadLibrary: aFileName asAsciiZ) >= 32
            ifTrue: [
                dib := self fromModule: hLibrary id: bitmapName ].
    KernelLibrary freeLibrary: hLibrary.
    ^dib!   
fromFile: bitmapFile
   "Create a DIB bitmap from bitmapFile.
     Touched by Ale for returning nil if file not found or EOF"
    | file bfh dib |
    #modifiedByOStyle.
    (File exists: bitmapFile) ifFalse: [^nil].
    file := (File fastPathNameReadOnly: bitmapFile) asByteFileStream.
    file atEnd ifTrue: [file close.^nil].
    bfh := self readFileHeader: file.
    bfh bfType  = 'BM' ifFalse: [ file close. ^nil "^self error: 'Invalid file format' " ].
    file atEnd ifTrue: [file close.^nil].
    dib := self new  fromStream: file.
    file close.
    ^dib!
fromHandle: hDIB
    "Answer an instance of Bitmap copied from a memory dib handle hDIB.
    Implemented by Ale..."

    | lpDib sizeInBytes bytes addr stream dib |
    #addedByOStyle.
    hDIB isNil ifTrue: [^nil].
    lpDib := KernelLibrary globalLock: hDIB.
    addr := WinAddress fromString: lpDib.
    sizeInBytes := (WinAddress fromString: (KernelLibrary globalSize:hDIB)) asInteger.
    bytes := String new: sizeInBytes.
    WinAddress
        copyFrom: addr
        to: bytes
        count: sizeInBytes.
    dib := self new fromStream: (ReadWriteStream on: bytes).
    KernelLibrary globalUnlock: hDIB.
    ^dib! 
fromModule: aFileName id: bitmapId
    "Create a DIB bitmap from aFileName. Its id is
     bitmapName, it can be either a string or an integer.
    Touched by Ale for Bitmap protocoll compatibility..."
    |hLibrary hrsrc hglb resource bytesResource stream dib id|
    #modifiedByOStyle.
    aFileName isString
       ifTrue: [ (hLibrary := KernelLibrary loadLibrary: aFileName asAsciiZ) >= 32 ifFalse: [^nil] ]
        ifFalse: [hLibrary := aFileName "in Bitmap protocol the name for module is it's Id"].
    id := bitmapId.
    id isInteger ifTrue:[id := WinAddress new lowHalf: id].
    hrsrc := KernelLibrary findResource: hLibrary asParameter
                    name: id asParameter
                    type: (WinLong new lowHalf:RtBitmap) asParameter.
    hrsrc = 0 ifTrue:[
        KernelLibrary freeLibrary: hLibrary.
        ^nil].
    hglb := KernelLibrary loadResource: hLibrary asParameter hrsrc:hrsrc asParameter.
    resource := KernelLibrary lockResource: hglb.
    resource := WinAddress fromString: resource.
    bytesResource := ByteArray new: ((WinAddress fromString: (KernelLibrary globalSize:hglb)) asInteger).
    bytesResource replace: bytesResource size with: resource.
    stream := ReadWriteStream on:bytesResource asString.
    dib := self new
        fromStream: stream.
    KernelLibrary globalUnlock: hglb.
    aFileName isString ifTrue: [KernelLibrary freeLibrary: hLibrary].
    ^dib! !

! DIB methods ! 
bitmapInfo
    "Returns the instance var of the receiver
     for external manipulation.
    Implemented by LRP..."
    #addedByOStyle.
    ^bitmapInfo! 
bitmapInfo: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done).
    Implemented by LRP..."
    #addedByOStyle.
    bitmapInfo := anObject!
bits
    "Returns the instance var of the receiver
     for external manipulation.
    Implemented by LRP..."
    #addedByOStyle.
    ^bits! 
bits: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done).
    Implemented by LRP..."
    #addedByOStyle.
    bits := anObject!
fromBitmap: aBitmap
   "Create a DIB bitmap from a DDB.
    Implemented by Ale..."
    #addedByOStyle.

    bits := aBitmap getDIBits.
    bitmapInfo := aBitmap bitmapInfo.

    "re-compute missing values..."
    bitmapInfo ~= bits size
    ifTrue: [ bitmapInfo sizeImage: bits size ].
    (bitmapInfo clrUsed = 0
    and: [ bitmapInfo bitCount <= 8 "use palette..."])
    ifTrue: [ bitmapInfo clrUsed: (1 bitShift: bitmapInfo bitCount) ].! 
fromStream: aStream
    "Private - Set the receiver's instance variables, parsing aStream.
    Touched By Ale..."
    | origin bytes bitmap rgbColor clrUsed colors |
    #modifiedByOStyle.
    origin := aStream position.
    bitmapInfo := self readBitmapHeader: aStream.

    bitmapInfo bitCount > 8 " = 24 no color table for >8 bits bmps... "
    ifFalse: [
            clrUsed := bitmapInfo clrUsed.
            clrUsed = 0 ifTrue: [ clrUsed := 1 bitShift: bitmapInfo bitCount ].
            colors := ByteArray new: clrUsed * 4.
            aStream getBytesFor: colors.
            clrUsed = (1 bitShift: bitmapInfo bitCount)
            ifTrue: [ rgbColor := colors ]
            ifFalse: [
                rgbColor := ByteArray new: (1 bitShift: bitmapInfo bitCount) * 4.
                rgbColor replaceFrom: 1 to: colors size with: colors startingAt: 1.
            ]
    ].

    bitmapInfo sizeImage = 0
    ifTrue: [
        bytes := (((
            bitmapInfo width * bitmapInfo bitCount) + 31) // 32 * 4) * bitmapInfo height]
    ifFalse: [bytes := bitmapInfo sizeImage].
    bits := ByteArray new:  bytes.

    "Ale Patch..."
    aStream position: origin + bitmapInfo size + colors size.
    aStream getBytesFor: bits.

    bitmapInfo :=
        rgbColor isNil
            ifTrue: [WinBitmapInfo new contents: bitmapInfo contents]
             ifFalse: [
                WinBitmapInfo new contents: bitmapInfo contents, rgbColor].!  
outputToFile: pathName
    "Private - Save receiver into a file named pathName.
    Implemented by Ale..."

    | file bmpFileHdr coreSize |
    #addedByOStyle.
    file := File newFastFile: pathName.
    bmpFileHdr := WinBitmapFileHeader new.
    coreSize := bmpFileHdr contents size + self bitmapInfo size.
    bmpFileHdr
        bfType: 'BM';
        bfSize: coreSize + self bits size;
        offBits: coreSize.
    file
        nextPutAll: bmpFileHdr contents;
        nextPutAll: self bitmapInfo contents;
        nextPutAll: self bits contents;
        yourself.
    file close.!  
palette
    "Answer the receiver palette.
    Implemented by LRP..."
    #addedByOStyle.
    ^bitmapInfo palette! 
palette: aPalette
    "Sets aPalette in the receiver.
    Implemented by LRP..."
    #addedByOStyle.
    ^bitmapInfo palette: aPalette! !

! DynamicDataExchange methods !  
dataTo: to ackReq: ackReq release: release requested: requested format: format data: value item: item
    "Private - Send data to the client in response to a request or an advise.
     Touched only for better indent.
    Touched By Ale..."
    |aItemName data hData answer formattedData|
    #modifiedByOStyle.
    aItemName := WinHandle stringToAtom: item.
    hData := 0.
    value notNil ifTrue: [
        formattedData := value.
        format = CfText
            ifTrue: [ formattedData := formattedData asAsciiZ ].
        data := WinStructure new: 4 + formattedData size.
        data uShortAtOffset: 0 put: 0.
        ackReq ifTrue: [
            data uShortAtOffset: 0 put: (data uShortAtOffset: 0) | 16r8000].
        release ifTrue: [
            data uShortAtOffset: 0 put: (data uShortAtOffset: 0) | 16r2000].
        requested ifTrue: [
            data uShortAtOffset: 0 put: (data uShortAtOffset: 0) | 16r1000].

        data uShortAtOffset: 2 put: format.
        data bytesAtOffset: 4 put: formattedData.
        hData := WinAddress memoryHandleFrom: data contents
              withAllocFlag: GmemDdeshare | GmemMoveable.
    ].

    answer := self postTo: to
           msg: WmDdeData
           lParamLo: hData
           lParamHi: aItemName.
    answer ifFalse: [
        "PostMessage failed destroy atom and memory"
        WinHandle deleteAtom: aItemName.
         KernelLibrary globalFree: hData]
        ifTrue:[pendingAck:= #WmDdeData].
    ^answer.!
pokeTo: to release: release format: format data: value item: item
    "Private - Send data value in specified format to the server
     Touched only for better indent.
    Touched By Ale..."
    |aItemName data hData answer formattedData|
    #modifiedByOStyle.
    aItemName := WinHandle stringToAtom: item.
    formattedData := value.
    format = CfText ifTrue: [ formattedData := formattedData asAsciiZ].
    data :=WinStructure new: 4 + formattedData size.
    data uShortAtOffset: 0 put: 0.
    release ifTrue: [
        data uShortAtOffset: 0 put: (data uShortAtOffset: 0) | 16r2000
    ].
    data uShortAtOffset: 2 put: format.
    data bytesAtOffset: 4 put: formattedData.

    hData := WinAddress memoryHandleFrom: data contents
          withAllocFlag: GmemDdeshare | GmemMoveable.

    answer := self postTo: to
           msg: WmDdePoke
           lParamLo: hData
           lParamHi: aItemName.
    answer ifFalse: [
        "PostMessage failed destroy atom and memory"
        WinHandle deleteAtom: aItemName.
         KernelLibrary globalFree: hData]
        ifTrue:[pendingAck:= #WmDdePoke].
    ^answer.! !

! SmalltalkEmulator class methods ! 
newServer
        "Private - Starts the SmalltalkEmulator sever.
    Who touched this method? why?"
    | dde server|
    #modifiedByOStyle.

    dde := self new.
    (server := DDEAuxServer new open) notNil
        ifTrue: [
            dde server: server;
                isClient: false.
            dde server recieverObj: dde.
            dde server dde: dde.
            dde application: 'Smalltalk'.
            dde topic: 'Emulator'.
            dde initExportedItems.
            dde initClient.

            dde addExportedItem: 'Result' object: 0.
            dde addExportedItem: 'Answer' object: ' '.
            dde addExportedItem: 'ErrorMessage' object: ' ' ]
       ifFalse: [ dde:= nil ].

    ^dde! !

! SmalltalkEmulator methods !   
compilerError: aString at: anInteger in: codeString for: aClass
        "Private - Display the error message aString
         as the selected text at the indicated position
         anInteger in the source codeString.
    Who touched this method? why?"

    #modifiedByOStyle.
    self updateExportedItem: 'Result' object: anInteger.
    self updateExportedItem: 'ErrorMessage' object: aString.!   
ddePokeItem: item object: object
        "Private - a Client has requested a evaluation
        of a smalltalk expression.
    Who touched this method? why?"
    #modifiedByOStyle.

    item = 'DoIt' ifTrue: [
        self doIt: object.
        ^ true].

    item = 'InspectIt' ifTrue: [
        self inspectIt: object.
        ^ true].

    item = 'FileItIn' ifTrue: [
        self fileItIn: object.
        ^ true].

    ^false!  
doIt: aString
        "Private - Compile and execute the selected text.
         If no error, log it on the change log
         and answer the result of the evaluation,
         else perform the aBlock.
    Who touched this method? why?"

    | anAnswer|
    #modifiedByOStyle.

    self updateExportedItem: 'Result' object: 0.

    anAnswer := Compiler
                evaluate: aString
                in: UndefinedObject
                to: nil
                notifying: self
                ifFail: [
                    CursorManager normal change.
                    ^self].

    Smalltalk logEvaluate: aString.
    self updateExportedItem: 'Answer' object: anAnswer.
    ^anAnswer! 
fileItIn: aString
        "Private - Compile and evaluate the selected
         text (in change log format).
    Who touched this method? why?"
    #modifiedByOStyle.

    CursorManager execute change.
    (ReadStream on: aString) fileIn.
    CursorManager normal change! !

! OSEmulator class methods ! 
new
    ^super new initialize!   
newServer
        "Private - Starts the OSEmulator sever."
    | dde server|

    dde := self new.
    (server := OSDDEAuxServer new open) notNil
        ifTrue: [
            dde server: server;
                isClient: false.
            dde server recieverObj: dde.
            dde server dde: dde.
            dde application: 'ObjectStyle'.
            dde topic: 'Report'.
            dde initExportedItems.
            dde initClient.

            dde addExportedItem: 'Result' object: 0.
            dde addExportedItem: 'Answer' object: ' '.
            dde addExportedItem: 'ErrorMessage' object: ' ' ]
       ifFalse: [ dde:= nil ].

    ^dde! !

! OSEmulator methods !  
addDotsTo: aNumber for: item
    "Private - Returns the receiver as a dotted string"
    | input output digCount |

    output := WriteStream on: (String new: 20).
    digCount := self numberOfDigitsFor: item.
    input := ReadStream
        on: (digCount ~= 0
            ifTrue: [aNumber asFloat printRounded: digCount]
            ifFalse: [aNumber asInteger asString]) reversed.

    digCount = 0 ifFalse: [
        output nextPutAll: (input next: digCount + 1)
    ].

    [input atEnd] whileFalse: [
        3 timesRepeat: [
            input atEnd ifFalse: [ output nextPut: input next ]
        ].
        input atEnd ifFalse: [
            output nextPut: NationalLanguage thousandsSeparator first
        ]
    ].

    ^output contents reversed!   
at: aName ifAbsent: aBlock
    "Private - Return the root object named aName"

    aName = 'self' ifTrue: [^self].

    (exportedItems includesKey: aName)
    ifTrue: [^exportedItems at: aName].

    aName at: 1 put: aName first asUpperCase.

    ^Smalltalk
        at: aName asSymbol
        ifAbsent: aBlock!
closeTracer
    "Close the tracer on the receiver"

    tracer isNil ifTrue: [^self].
    tracer close.
    tracer := nil.!  
commandFrom: aStream
    "Private - parse aStream finding inmediate command references.
     Returns the object or nil.
     The syntax is:
        =Variable[=value][:Class[:name|#number]]
        ?Variable{.msg}
     "
    | command varName class id result token |
    (command := aStream next) = $=
    ifTrue: [
        "=Variable[=value][:Class:name]"
        varName := aStream nextWord.
        aStream next = $=
        ifTrue: [
            exportedItems
                at: varName
                put: (self nextParamFrom: aStream).
            ^String new "hide the result"
        ].
        class := self nextNameFrom: aStream.
        token := aStream next.
        id := aStream upTo: nil.
        class := Smalltalk at: class asSymbol ifAbsent: [^'invalid class'].
        exportedItems
            at: varName
            put: (token = $:
                        ifTrue: [class named: id]
                        ifFalse: [class number: id]).
            ^String new "hide the result"
    ]
    ifFalse: [
        command = $?
        ifTrue: [
            "?Variable{.msg} not implemented yet"
            varName := aStream nextWord.
            result := self at: varName
                ifAbsent: [^'NA'  "'Variable ',varName,' not found.' "].
            [aStream atEnd] whileFalse: [
                result := self scanBlock value: aStream value: result].
            result isNil ifTrue: [^'NA'].
            ^result
        ]
        ifFalse: [^'invalid command']
    ]!
ddeExportItem: item
    "A client has requested for a new item;
     Returns the aviability of the item and
     DO NOT set the exportedItems with the new
      item to export..."

    | anObject |
    anObject := self parseItem: item.
    anObject isNil ifTrue: [^false].
    "
        *Warning* the item will not be added for
                          updating by request...
        self addExportedItem: item object: anObject.
    "
    ^true!  
doIt: aString
    "Private - Compile and execute the selected text.
     If no error, log it on the change log
     and answer the result of the evaluation,
     else perform the aBlock."

    Compiler isNil
    ifTrue: [^self error: 'Compiler not present...'].

    ^super doIt: aString! 
exportedItemAt: item
    "Private - Returns the item..."

    ^self parseItem: item!   
fileItIn: aString
    "Private - Compile and evaluate the selected
     text (in change log format)."

    Compiler isNil
    ifTrue: [^self error: 'Compiler not present...'].

    ^super fileItIn: aString! 
initialize
    "Private - Initialize the receiver"

    profiler := Dictionary new "temporariamente inhibido...
        self profiler
            applicationName: 'Decimal Places' "
        .
    digits := Dictionary new.! 
inspectIt: aString
        "Private - Open an inspector on the result of evaluating
         the selected text."

    Compiler isNil
    ifTrue: [^self error: 'Compiler not present...'].

    ^super inspectIt: aString! 
lastParse
    "Private - Returns last parse operation requested"

    lastParse isNil ifTrue: [
        lastParse := Array
            with: String new
            with: Time now asSeconds
            with: String new
    ].
    ^lastParse! 
nextNameFrom: aStream
    "Private - Returns the next name in aStream"
    | result |
    aStream atEnd ifTrue: [^nil].
    aStream peek == $' ifFalse: [^aStream nextWord].
    result := WriteStream on: String new.
    [aStream peek == $'] whileTrue: [
        aStream next.
        result nextPutAll: (aStream upTo: $')
    ].
    ^result contents!   
nextParamFrom: aStream
    "Private - Returns the next parameter in aStream"
    | result |
    aStream atEnd ifTrue: [^nil].
    aStream peek = $' ifTrue: [^self nextNameFrom: aStream].
    result := aStream nextWord.
    result = 'nil' ifTrue: [^nil].
    result = 'true' ifTrue: [^true].
    result = 'false' ifTrue: [^false].
    result size = 0 ifTrue: [^result].
    result first isDigit
    ifTrue: [
        ^(result includes: $.)
        ifTrue: [result asFloat]
        ifFalse: [result asInteger]
    ].
    ^result!   
numberOfDigitsFor: item
    "Private - Returns the number of digits to place in the field 'item' "
    | message result |
    ^digits
        at: (message := (item reversed upTo: $.) reversed)
        ifAbsent: [
            result := profiler
                at: message
                ifAbsent: [
                    profiler at: message put: (result := '0').
                    result
                ].
            result := result asInteger.
            digits
                at: message
                put: result.
            result
        ]!   
openNavigator
    "Open the droper on the receiver
     Doit in deferred mode"

    (Message new
        receiver: self
        selector: #openDroper
        arguments: #()) performDeferred! 
openTracer
    "Open the tracer on the receiver"
    tracer isNil ifFalse: [
        tracer mainView bringToTop.
        ^self
    ].
    tracer := TextWindow new
        label: 'DDE tracer...';
        openOn: String new;
        yourself.!
parseItem: aString
    "Private - parse aString finding the resulting object for the query.
     Returns the object or nil.
     The syntax is:

        Class[:name/#number]{.msg}
        =Variable[=value][:Class[:name][#number]]
        ?Variable{.msg}

       where:
            Class is a class.
            name & number is the name or register number descriptor for the root object.
            msg is a simple message or an unary message.

        example:

            Group:grupo1.market.name            returns the name of the market of the group named 'grupo1'

     "
    | result stream getRoot scan message param token |

    "Is the same query has been done recently, use the old result"
    (self lastParse first = aString and: [
    Time now asSeconds - (self lastParse at: 2) < 3 "seconds"])
    ifTrue: [
        result := lastParse last.
        tracer isNil ifFalse: [tracer cr;nextPutAll: '*Using catched value*', result asString].
        ^result
    ].

    "Compute the query..."
    scan := [
            message := stream nextWord.
            stream peek == $:
            ifTrue: [
                stream next.
                message :=  (message ,':') asSymbol.
                param := self nextParamFrom: stream
            ]
            ifFalse: [
                message :=  message asSymbol.
                param := nil.
            ].
            (result respondsTo: message)
            ifFalse: [
                tracer isNil ifFalse: [tracer cr;nextPutAll: '*Invalid Message*',message].
                ^'*NA*' "invalid message"
            ].
            result := param isNil
            ifTrue: [result perform: message]
            ifFalse: [result perform: message with: param]
        ].
    getRoot := [
            stream atEnd ifTrue: [^'No field specified...'"nil"]. "failed"
            result := self
                at: stream nextWord
                ifAbsent: [stream upTo: nil.^'Root Object not found'].
            stream atEnd ifTrue: [^result].
            (#($: $!!) includes: stream peek) ifFalse: [^'Syntax Error ("#","!!" or ":" spected)...'].
            (token := stream next) = $!!
            ifTrue: [result := scan value]
            ifFalse: [result := result named: (self nextNameFrom: stream)]
        ].

    "parse the query stream..."
    tracer isNil ifFalse: [tracer cr;nextPutAll: 'Query:',aString].
    stream := ReadStream on: aString.
    result := nil.
    (#($? $= ) includes: stream peek) "commands"
    ifTrue: [result := self commandFrom: stream]
    ifFalse: [
        getRoot value.
        [result isNil | stream atEnd] whileFalse: [ scan value ]
    ].

    "Patch para nros pto flotante"
    result isNumber
    ifTrue: [result := self addDotsTo: result for: aString].

    tracer isNil ifFalse: [tracer cr;nextPutAll: 'Answer:',result asString].

    self lastParse
        at: 1 put: aString;
        at: 2 put: Time now asSeconds;
        at: 3 put: result.

    ^result!   
scanBlock
    "Private - Returns the message parsing block "
    | message param |

    ^[:stream : result |
            message := stream nextWord.
            stream peek == $:
            ifTrue: [
                stream next.
                message :=  (message ,':') asSymbol.
                param := self nextParamFrom: stream
            ]
            ifFalse: [
                message :=  message asSymbol.
                param := nil.
            ].

            (result notNil and: [result respondsTo: message])
            ifFalse: [ result := '*NA*'  "invalid message" ]
            ifTrue: [
                result := param isNil
                ifTrue: [result perform: message]
                ifFalse: [result perform: message with: param]
            ].
         result
        ]!
selected
    "Private - Return the root object named aName"

    ^self at: 'TheStudy' ifAbsent: [^nil]!
selected: aStudy
    "Private - Set the root object named aName"

    ^exportedItems at: 'TheStudy' put: aStudy!   
switchTracer
    "Switch the tracer on the receiver"
    tracer isNil
    ifTrue: [self openTracer]
    ifFalse: [self closeTracer]!  
terminate
    "Terminate DDE session."

    super terminate.
    self initExportedItems! !

! File class methods !  
fastPathName: aString
    "Answer a FileStream with path name aString.
    Implemented by Ale..."
    #addedByOStyle.
    ^self fastPathName: aString in: Disk!   
fastPathName: aString in: aDirectory
    "Answer a FileStream with path name aString
    with default directory aDirectory.
    Implemented by Ale..."
    | anArray |
    #addedByOStyle.
    anArray := self splitPath: aString in: aDirectory.
    ^(Directory new
        drive: (anArray at: 1);
        pathName: (anArray at: 2))
            fastFile: (anArray at: 3)! 
fastPathNameReadOnly: aString
        "Answer a read only FastFileStream with path name aString."
    | anArray |
    anArray := self splitPath: aString in: Disk.
    ^(Directory new
        drive: (anArray at: 1);
        pathName: (anArray at: 2))
            fastFileReadOnly: (anArray at: 3)!   
fileName: longString extension: eString
    "Answer a String which is a file name abbreviated
     from nString and eString. Lower case
     vowels are dropped from the right of nString
     until it is less than or equal to 8 characters.
    Touched by Ale for space character remotion..."
    | size aString nString |

    #modifiedByOStyle.
    nString := longString reject: [:c| c == $ ].

    size := nString size.
    aString :=
        (nString reversed select: [ :char |
        (char isVowel and: [char isLowerCase])
            ifTrue: [(size := size - 1) < 8]
            ifFalse: [true]]) reversed, '       '.
    size := 0.
    aString := aString select: [ :char |
        ((char isDoubleByte)
            ifTrue: [size := size + 2]
            ifFalse: [size := size + 1]) <= 8].
    ^(aString) trimBlanks,
        (String with: $.),
        ((eString, '   ') copyFrom: 1 to: 3) trimBlanks!  
newFastFile: aString
    "Answer a FileStream with path name aString.
    Implemented by Ale..."
    | anArray |
    #addedByOStyle.
    anArray := self splitPath: aString in: Disk.
    ^(Directory new
        drive: (anArray at: 1);
        pathName: (anArray at: 2))
            newFastFile: (anArray at: 3)! !

! File methods ! 
fileInActivate: anObjectFiler
        " Activate instance which has just been loaded. "
    self open.  " check if directory and file still exist?? "
    ^self!   
fileOutSurrogate: anObjectFiler
        " Answer surrogate for object filing. "
    ^(self copy) fileId: nil! !

! Font class methods !   
face: aString
    size: aPoint
    fixedWidth: fixedWidth
    attributes: a

    "Added by OSI"

    #addedByOSI.
    ^self face: aString size: aPoint fixedWidth: fixedWidth! !

! Font methods !  
bold: aValue
    "Modified by OSI.  Non bold used to set weight to 0"
        "set the bold boolean of the font to aValue."
    #modifiedByOSI.
    aValue notNil ifTrue: [
        aValue ifTrue:
            [logFont lfWeight: 700    ]
        ifFalse:
            [logFont lfWeight: 400    ]].
    changed := true.!  
fileOutSurrogate: anObjectFiler
        " Answer surrogate for object filing.
          Smash hFont handle; gets recreated automatically when
          font is referenced after reloading. "
    | surrogate |
    surrogate := self copy. 
    surrogate fontHandle: nil.
    ^surrogate!
fixedWidth
        "Answer true if the font is of fixed
         width, else answer false."
     ^( textMetrics tmPitchAndFamily & 16r01 ) =  0  "Fixed pitch = 0"!
fromBytes: aLogFontByteArray

    "Added by OSI - Create a font from the bytes of a logical font"
    | contents |

    #addedByOSI.
    contents := ByteArray new: aLogFontByteArray size.
    1 to: aLogFontByteArray size do: [ :i |
        contents at: i put: (aLogFontByteArray at: i).
    ].

    logFont := WinLogFont fromBytes: contents.
    changed := true.
    self makeFont.!   
italic
    "Modified by OSI - Used to say = 1"
    #modifiedByOSI.
    ^textMetrics tmItalic ~= 0.!
loadBy: aLoader
    "Private - Load the receiver from a saved instance..."
    aLoader load: self.
    self initFontHandle!
logicalBytes

    "Added by OSI"

    | byteStream |
    #addedByOSI.
    byteStream := WriteStream on: String new.
    byteStream nextPutAll: '#( '.
    self logFont contents do: [ :b |
        byteStream nextPutAll: b asString, ' '.
    ].
    byteStream nextPut: $).
    ^byteStream contents!   
nonPortableStoreOn: aStream indentString: indentString

    "Added by OSI"
    #addedByOSI.
    aStream
        nextPutAll: indentString, 'Font new';
        cr; nextPutAll: indentString, 'fromBytes: ', self logicalBytes.!  
portableStoreOn: aStream indentString: indentString

    "Added by OSI"
    #addedByOSI.
    aStream
        nextPutAll: indentString, 'Font';
        cr; nextPutAll: indentString, 'face: ''', self faceName, '''';
        cr; nextPutAll: indentString, 'size: ', (self charSize x@ self pointSize) asString;
        cr; nextPutAll: indentString, 'fixedWidth: ', self fixedWidth asString.

    (self bold = false) & (self italic = false) & (self strikeOut = false) & (self underscore = false) ifFalse: [
      aStream
        cr; nextPutAll: indentString, 'bold: ', self bold asString;
        cr; nextPutAll: indentString, 'hollow: ', false asString;
        cr; nextPutAll: indentString, 'italic: ', self italic asString;
        cr; nextPutAll: indentString, 'negative: ', false asString;
        cr; nextPutAll: indentString, 'strikeOut: ', self strikeOut asString;
        cr; nextPutAll: indentString, 'underscore: ', self underscore asString
    ].!   
storeOn: aStream indentString: indentString

    "Added by OSI"
    #addedByOSI.
    aStream
        nextPutAll: indentString, 'Font new';
        cr; nextPutAll: indentString, 'fromBytes: ', self logicalBytes.! 
strikeOut
    "Modified by OSI - Used to say = 1"
    #modifiedByOSI.
     ^ textMetrics tmStrikeOut ~= 0.!
stringExtent: aString

    "Added by OSI to fix stringwidth bug."

    | answer hold |

    #addedByOSI.
    hold := Display pen font.
    Display pen font: self.
    aString isNil ifTrue: [
        answer := 0
    ] ifFalse: [
        answer := self stringWidth: (aString reject: [:c | c == $~ ]).
    ].
    Display pen font: hold.
    ^answer @ self height!   
underscore
    "Modified by OSI - Used to say = 1"
    #modifiedByOSI.
    ^textMetrics tmUnderline ~= 0.! 
wbEquals: aFont

    "Added by OSI"
    #addedByOSI.
    ^((self == aFont) or: [  (self faceName = aFont faceName) & (self charSize = aFont charSize)])!  
wbStringWidth: aString

    "Added by OSI"
    | answer hold found |
    #addedByOSI.
    hold := Display pen font.
    Display pen font: self.
    found := false.
    answer := self stringWidth: (aString reject: [:c | found := ((c == $~) | (c == $&) & found not) ]) .
    Display pen font: hold.
    ^answer! !

! ForwardReference methods ! 
loaderNumber
    "Answer the index into the loader array where
     the forward referenced object is located."
    ^loaderNumber!  
loaderNumber: aNumber
    "Set the index into the loader array where
     the forward referenced object is located."
    loaderNumber:= aNumber!   
loaderNumber: aNumber object: anObject objectIndex: index
    "Set the forward reference feilds corresponding to:
     - the index into the loader array
     - the object that referenced it
     - the index into the referencing object"
    loaderNumber:= aNumber.
    object:= anObject.
    objectIndex:= index!
object
    "Answer the referencing object"
    ^object! 
object: anObject
    "Set the referencing object"
    object:= anObject!
objectIndex
    "Answer the index into the referncing object"
    ^objectIndex! 
objectIndex: index
    "Set the index into the referencing object"
    objectIndex:= index! !

! FramingParameters class methods !
dialogUnit
    "
    *ATENCION*   Ale 15/09/93

    Esto es dependiente del driver de video.
    Con lo que si cambia cambiara el tamao (en pixels)
    de las ventanas creadas con WindowBuilder.
    Aunque se les haya dado tamao fijo (con set pane size...)

    Debido a esto no pueden generarse con WindowBuilder
     ventanas de un tamao (en pixels) independiente del video.

    ^ 9 / 16 @ (5 / 8 )

    Touched by Ale..."
    #modifiedByOStyle.
    ^(SysFont width  / 16)  @  (SysFont height / 32)! 
new

    ^super new initialize! !

! FramingParameters methods !  
bDU: y r: aSymbol

    bottom := (y * FramingParameters dialogUnit y) rounded.
    aSymbol == #center ifFalse: [ bottom := bottom abs ].
    bottomRel := aSymbol.!   
bottom

    ^bottom!
bottom: y relativeTo: aSymbol

    aSymbol == #center
        ifTrue: [ bottom := y ] ifFalse: [ bottom := y abs ].
    bottomRel := aSymbol.!
bottomDialogUnits

    ^(bottom / FramingParameters dialogUnit y) rounded!  
bottomProportional: y

    self bP: y!  
bottomRel

    ^bottomRel!  
bP: y

    y = 0  ifTrue: [
        bottom := 0.
        bottomRel := #top.
    ] ifFalse: [
        y = 1 ifTrue: [
            bottom := 0.
            bottomRel := #bottom.
        ] ifFalse: [
            bottom := y.
            bottomRel := #top.
        ].
    ].!  
centerX

    ^centerX!  
centerY

    ^centerY!  
clientRect

    ^clientRect!
clientRect: e

    clientRect :=  e!
cRDU

        ^(self clientRect leftBottom / FramingParameters dialogUnit) rounded rightBottom: (self clientRect rightTop / FramingParameters dialogUnit) rounded.! 
cRDU: aRect

        | newRect |

        newRect := (aRect leftBottom * FramingParameters dialogUnit) rounded rightBottom: (aRect rightTop * FramingParameters dialogUnit) rounded.

        self clientRect: newRect.!
fromRect: aRect inRect: parentRect

    self left: aRect left relativeTo: #left.
    self right: aRect right relativeTo: #left.
    self top: parentRect top - aRect top relativeTo: #top.
    self bottom: parentRect top - aRect bottom relativeTo: #top.
    initialExtent := aRect extent.! 
iDUE

    ^(initialExtent / self class dialogUnit ) rounded!
iDUE: e

    initialExtent := (e * self class dialogUnit) rounded.! 
indent

    ^indent!
indent: anIndent

    indent := anIndent.!  
initialExtent

    ^initialExtent!  
initialExtent: e

    initialExtent := e!   
initialize

    centerX := false.
    centerY := false.
    indent := 0@0.
    initialExtent := 0@0.!
lDU: x r: aSymbol

    left := (x * FramingParameters dialogUnit x) rounded.
    aSymbol == #center ifFalse: [ left := left abs ].
    leftRel  := aSymbol.!  
left

    ^left!
left: x relativeTo: aSymbol

    aSymbol == #center
        ifTrue: [ left := x ] ifFalse: [ left := x abs ].
    leftRel  := aSymbol.!   
leftDialogUnits

    ^(left / FramingParameters dialogUnit x) rounded!  
leftProportional: x

    self lP: x!
leftRel

    ^leftRel!  
lP: x

    left := x.
    leftRel := #left.!   
newFramerFromNewRect: newRect parentRect: containerRect

    "Create a new framing parameters for this pane, based on the
     values of self (i.e. update the relative values). "

    | newFramer |

    "Easy cases are left and bottom, vs. left and top for windows."

    newFramer := FramingParameters new.

    centerX ifTrue: [
        newFramer xCentered.
    ] ifFalse: [
        left notNil ifTrue: [
           left isInteger ifTrue: [
                (leftRel = #left) ifTrue: [
                    newFramer left: newRect left relativeTo: #left.
                ] ifFalse: [ (leftRel = #center) ifTrue: [
                    newFramer left: newRect left - (containerRect width // 2) relativeTo: #center.
                ] ifFalse: [
                    newFramer left: containerRect width - newRect left relativeTo: #right.
                ]].
            ] ifFalse: [
                newFramer leftProportional: (newRect left / containerRect width).
            ].
        ].

        right notNil ifTrue: [
           right isInteger ifTrue: [
                (rightRel = #left) ifTrue: [
                    newFramer right: newRect right relativeTo: #left.
                ] ifFalse: [ (rightRel = #center) ifTrue: [
                    newFramer right: newRect right - (containerRect width // 2) relativeTo: #center.
                ] ifFalse: [
                    newFramer right: containerRect width - newRect right relativeTo: #right.
                ]].
            ] ifFalse: [
                newFramer rightProportional: (newRect right / containerRect width).
            ].
        ].
    ].

    centerY ifTrue: [
        newFramer yCentered.
    ] ifFalse: [
        top notNil ifTrue: [
           top isInteger ifTrue: [
                (topRel = #top) ifTrue: [
                    newFramer top: newRect top relativeTo: #top.
                ] ifFalse: [ (topRel = #center) ifTrue: [
                    newFramer top: newRect top - (containerRect height // 2) relativeTo: #center.
                ] ifFalse: [
                    newFramer top: containerRect height - newRect top relativeTo: #bottom.
                ]].
            ] ifFalse: [
                newFramer topProportional: (newRect top / containerRect height).
            ].
        ].

        bottom notNil ifTrue: [
           bottom isInteger ifTrue: [
                (bottomRel = #top) ifTrue: [
                    newFramer bottom: newRect bottom relativeTo: #top.
                ] ifFalse: [ (bottomRel = #center) ifTrue: [
                    newFramer bottom: newRect bottom - (containerRect height // 2) relativeTo: #center.
                ] ifFalse: [
                    newFramer bottom: containerRect height - newRect bottom relativeTo: #bottom.
                ]].
            ] ifFalse: [
                newFramer bottomProportional: (newRect bottom / containerRect height).
            ].
        ].
    ].

    newFramer initialExtent: newRect extent.

    ^newFramer! 
printOn: aStream

    centerX ifTrue: [
        aStream nextPutAll: '<xCentered>'; cr.
    ] ifFalse: [
        aStream nextPutAll: 'L:  <', left asString, ',', leftRel asString, '>'; cr.
        aStream nextPutAll: 'R: <', right asString, ',', rightRel asString, '>'; cr.
    ].

    centerY ifTrue: [
        aStream nextPutAll: '<yCentered>'; cr.
    ] ifFalse: [
        aStream nextPutAll: 'T: <', top asString, ',', topRel asString, '>'; cr.
        aStream nextPutAll: 'B: <', bottom asString, ',', bottomRel asString, '>'; cr.
    ].

    aStream nextPutAll: 'indent: ', indent asString; cr.
    aStream nextPutAll: 'clientRect: ', clientRect asString; cr.
    aStream nextPutAll: 'initialExtent: ', initialExtent asString; cr.!
rDU: x r: aSymbol

    right := (x * FramingParameters dialogUnit x) rounded.
    aSymbol == #center ifFalse: [ right := right abs ].
    rightRel := aSymbol.!   
right

    ^right!  
right: x relativeTo: aSymbol

    aSymbol == #center
        ifTrue: [ right := x ] ifFalse: [ right := x abs ].
    rightRel := aSymbol.!
rightDialogUnits

    ^(right / FramingParameters dialogUnit x) rounded!
rightProportional: x

    self rP: x!   
rightRel

    ^rightRel!
rP: x

    x = 1 ifTrue: [
        right := 0.
        rightRel := #right.
    ] ifFalse: [
        x = 0 ifTrue: [
            right := 0.
            rightRel := #left.
        ] ifFalse: [
            right := x.
            rightRel := #left.
        ].
    ].!
storeOn: aStream indentString: indentString

    aStream nextPutAll: 'FramingParameters new iDUE: ', (initialExtent / self class dialogUnit ) rounded asString.

    centerX ifTrue: [
        aStream nextPutAll: '; xC'.
    ] ifFalse: [
        left notNil ifTrue: [
            left isFraction ifTrue: [
                aStream nextPutAll: '; lP: ', left asString.
            ] ifFalse: [
                aStream nextPutAll: '; lDU: ', self leftDialogUnits asString, ' '.
                aStream nextPutAll: 'r: #',leftRel asString.
            ].
        ].

        right notNil ifTrue: [
            right isFraction ifTrue: [
                aStream nextPutAll: '; rP: ', right asString.
            ] ifFalse: [
                aStream nextPutAll: '; rDU: ', self rightDialogUnits asString, ' '.
                aStream nextPutAll: 'r: #',rightRel asString.
            ].
        ].
    ].


    centerY ifTrue: [
        aStream nextPutAll: '; yC'.
    ] ifFalse: [
        top notNil ifTrue: [
            top isFraction ifTrue: [
                aStream nextPutAll: '; tP: ', top asString.
            ] ifFalse: [
                aStream nextPutAll: '; tDU: ', self topDialogUnits asString, ' '.
                aStream nextPutAll: 'r: #',topRel asString.
            ].
        ].

        bottom notNil ifTrue: [
            bottom isFraction ifTrue: [
                aStream nextPutAll: '; bP: ', bottom asString.
            ] ifFalse: [
                aStream nextPutAll: '; bDU: ', self bottomDialogUnits asString, ' '.
                aStream nextPutAll: 'r: #',bottomRel asString.
            ].
        ].
    ].

        clientRect notNil ifTrue: [
                aStream nextPutAll: '; cRDU: (',  self cRDU asString, ')'.
        ].

        indent = (0@0) ifFalse: [
                aStream nextPutAll: '; indent: ', indent asString.
        ].!
tDU: y r: aSymbol

    top := (y * FramingParameters dialogUnit y) rounded.
    aSymbol == #center ifFalse: [ top := top abs ].
    topRel := aSymbol.!   
top

    ^top!  
top: y relativeTo: aSymbol

    aSymbol == #center
        ifTrue: [ top := y ] ifFalse: [ top := y abs ].
    topRel := aSymbol.!
topDialogUnits

    ^(top / FramingParameters dialogUnit y) rounded!
topProportional: y

    self tP: y! 
topRel

    ^topRel!
tP: y

    y = 1 ifTrue: [
        top := 0.
        topRel := #bottom.
    ] ifFalse: [
        top := y.
        topRel := #top.
    ].!
value: containerRect

    "Answer a rectangle based on self's framing parameters
     with a parent rectangle containerRect."

    | realTop realBottom realRight realLeft distance |

    centerX ifTrue: [
        distance := (containerRect extent x - initialExtent x) // 2.
        realLeft := containerRect left right: distance.
        realRight := containerRect right left: distance.
    ] ifFalse: [
        left isNil ifFalse: [
            left isInteger ifFalse: [
                realLeft := containerRect left right: (containerRect width * left) rounded.
            ] ifTrue: [
                (leftRel = #left) ifTrue: [
                    realLeft  := containerRect left right: left.
                ] ifFalse: [ (leftRel = #center) ifTrue: [
                    realLeft  := containerRect center x right: left.
                ] ifFalse: [
                    realLeft := containerRect right left: left.
                ]].
            ].
        ].

        right isNil ifFalse: [
            right isInteger ifFalse: [
                realRight := containerRect left right: (containerRect width * right) rounded.
            ] ifTrue: [
                (rightRel = #left) ifTrue: [
                    realRight  := containerRect left right: right.
                ] ifFalse: [ (rightRel = #center) ifTrue: [
                    realRight  := containerRect center x right: right.
                ] ifFalse: [
                    realRight := containerRect right left: right.
                ]].
            ].
        ] ifTrue: [
            realRight := realLeft right: initialExtent x.
        ].

        left isNil ifTrue: [
            realLeft := realRight left: initialExtent x.
        ].

    ].

    centerY ifTrue: [
        distance := (containerRect extent y - initialExtent y) // 2.
        realTop := containerRect top down: distance.
        realBottom := containerRect bottom up: distance.
    ] ifFalse: [

        top isNil ifFalse: [
            top isInteger ifFalse: [
                realTop := containerRect top down: (containerRect height * top) rounded.
            ] ifTrue: [
                (topRel = #top) ifTrue: [
                    realTop  := containerRect top down: top.
                ] ifFalse: [ (topRel = #center) ifTrue: [
                    realTop  := containerRect center y down: top.
                ] ifFalse: [
                    realTop := containerRect bottom up: top.
                ]].
            ].
        ].

        bottom isNil ifFalse: [
            bottom isInteger ifFalse: [
                realBottom := containerRect top down: (containerRect height * bottom) rounded.
            ] ifTrue: [
                (bottomRel = #top) ifTrue: [
                    realBottom  := containerRect top down: bottom.
                ] ifFalse: [ (bottomRel = #center) ifTrue: [
                    realBottom  := containerRect center y down: bottom.
                ] ifFalse: [
                    realBottom := containerRect bottom up: bottom.
                ]].
            ].
        ] ifTrue: [
            realBottom := realTop down: initialExtent y.
        ].

        top isNil ifTrue: [
            realTop := realBottom up: initialExtent y.
        ].
    ].

    ^(realLeft @ realTop rightBottom: realRight @ realBottom)! 
xC

    centerX := true.!   
xCentered

    self xC! 
yC

    centerY := true.!   
yCentered

    self yC! !

! GraphicObject class methods !
example

    | e |

    e := self new.
    e rect: (0@0 extent: 300@200).

    ^e! 
new

    ^super new initialize! !

! GraphicObject methods !  
containsPoint: p

    ^rect containsPoint: p!   
displayWith: aPen

    aPen
        foreColor: (self getSysColor: ColorWindowframe);
        place: rect origin;
        box: rect corner.!  
displayWith: aPen clipRect: r

    self displayWith: aPen.! 
extent

    ^rect extent!   
extent: e

    rect extent: e!  
fullCopy

    | copy |

    copy := self class new.

    self fullCopyTo: copy.

    ^copy!   
fullCopyTo: c!
initialize

    rect := 0@0 extent: 0@0!
maxSize

    ^32000@32000!  
minSize

    ^1@1!  
rect

    ^rect!
rect: aRect

    rect := aRect! 
suggestedSize

    ^nil! !

! InterfaceObject class methods ! 
classAndStyleDict

    ClassAndStyleDict isNil ifTrue: [
        ClassAndStyleDict := Dictionary new.
        ClassAndStyleDict
            at: 128 put: (
                OrderedCollection new
                    add: (Array with: 15 with: BsPushbutton with: Button);
                    add: (Array with: 15 with: BsDefpushbutton with: Button);
                    add: (Array with: 15 with: BsOwnerdraw with: DrawnButton);
                    add: (Array with: 15 with: BsCheckbox with: CheckBox);
                    add: (Array with: 15 with: BsAutocheckbox with: CheckBox);
                    add: (Array with: 15 with: Bs3state with: ThreeStateButton);
                    add: (Array with: 15 with: BsAuto3state with: ThreeStateButton);
                    add: (Array with: 15 with: BsRadiobutton with: RadioButton);
                    add: (Array with: 15 with: BsAutoradiobutton with: RadioButton);
                    add: (Array with: 15 with: BsGroupbox with: GroupBox);
                    yourself
            );
            at: 129 put: (
                OrderedCollection new
                    add: EntryField;
                    add: (Array with: 4 with: EsMultiline with: TextEdit);
                    yourself
            );
            at: 131 put: (
                OrderedCollection new
                    add: ListBox;
                    add: (Array with: 8 with: LbsMultiplesel with: MultipleSelectListBox);
                    yourself
            );
            at: 133 put: ComboBox;
            at: 132 put: (
                OrderedCollection new
                    add: (Array with: 1with: SbsVert with: WBVerticalScrollBar);
                    add: (Array with: 1 with: SbsHorz with: WBHorizontalScrollBar);
                    yourself
            );
            at: 130 put: (
                OrderedCollection new
                    add: (Array with: 15 with:  SsIcon with: StaticGraphic);
                    add: (Array with: 15 with: SsBlackrect with: StaticBox);
                    add: (Array with: 15 with: SsBlackframe with: StaticBox);
                    add: (Array with: 15 with: SsWhiterect with: StaticBox);
                    add: (Array with: 15 with: SsWhiteframe with: StaticBox);
                    add: (Array with: 15 with: SsGrayrect with: StaticBox);
                    add: (Array with: 15 with: SsGrayframe with: StaticBox);
                    add: (Array with: 15 with: SsCenter with: StaticText);
                    add: (Array with: 15 with: SsLeft with: StaticText);
                    add: (Array with: 15 with: SsRight with: StaticText);
                    add: (Array with: 15 with: SsSimple with: StaticText);
                    yourself
            ).
    ].

    ^ClassAndStyleDict!
classFrom: c and: s

    | theClass styleList winClass |

    winClass := c.
    winClass isString ifTrue: [
        winClass := (#('BUTTON' 'EDIT' 'STATIC' 'LISTBOX' 'SCROLLBAR' 'COMBOBOX') indexOf: winClass) + 127.
    ].
    theClass := self classAndStyleDict at: winClass ifAbsent: [ PGenericSubpane ].
    theClass isClass ifFalse: [
        styleList := theClass.
        (styleList at: 1) isClass ifTrue: [
            theClass := styleList at: 1.
            styleList := styleList copyFrom: 2 to: styleList size.
        ].
        styleList do: [:a |
            (s bitAnd: (a at: 1)) = (a at: 2) ifTrue: [
                theClass := a at: 3
            ].
        ].
    ].

    ^theClass!   
clearClassAndStyleDict

    "    InterfaceObject clearClassAndStyleDict     "

    ClassAndStyleDict := nil.! 
defaultRealClassName

    ^self name copyFrom: 2 to: self name size.!   
example

    | e n |

    e := super example.
    n:= self defaultRealClassName.
    e style: e defaultStyle;
        contents: n;
        font: e defaultFont;
        extent: e defaultSize;
        realClass:  (Smalltalk at: n asSymbol ifAbsent: [ SubPane ] ).

    ^e!
exampleFrom: aClassName

    | e  |

    e := super example.

    e usesTitle ifTrue: [
        e text: aClassName.
    ].

    e style: e defaultStyle;
        font: e defaultFont;
        extent: e defaultSize;
        realClass:  (Smalltalk at: aClassName asSymbol ifAbsent: [ SubPane ] ).

    ^e!  
newFromStyle: s classID: classID rect: r text: t resID: id

    | i smalltalkClass theStyle |

    smalltalkClass := self classFrom: classID and: s.

    smalltalkClass = PGenericSubpane ifTrue: [
        i := PGenericSubpane new realClass: SubPane.
    ] ifFalse: [
        i := (WBRealLayoutPane basicNew pseudoClassFor: smalltalkClass name).
        theStyle := i styleFrom: s.
        i := i new.
        i realClass: smalltalkClass.
    ].


    i contents: t;
        rect: r;
        resID: id;
        style: theStyle;
        framingBlock: (
            WBFramingParameters new
                left: r origin x relativeTo: #left;
                right: (r origin x + r extent y ) relativeTo: #left;
                top: r origin y relativeTo: #top;
                bottom: (r origin y + r extent y) relativeTo: #top
        ).

    i font isNil ifTrue: [
        i font: i defaultFont.
    ].

    ^i!
purgeCache

    Down notNil ifTrue: [
        Down release.
    ].
    Up notNil ifTrue: [
        Up release.
    ].
    Right notNil ifTrue: [
        Right release.
    ].
    Left notNil ifTrue: [
        Left release.
    ].

    Down := Up := Right := Left := nil.
    self allSubclasses do: [ :c |
        c purgeCache
    ].!   
styleFrom: s

    ^nil! !

! InterfaceObject methods !
autoSizeFrom

    ^#leftJustified!  
backColor

    backColor = self defaultBackColor ifTrue: [
        (self parent notNil and: [ self parent backColor ~= ClrChiseledgray ]) ifTrue: [
            ^self parent backColor
        ] ifFalse: [
            ^backColor
        ].
    ] ifFalse: [
        ^backColor
    ].!   
backColor: c

    backColor := c!   
changesSize

    ^false!
changesTitle

    ^false!   
contents

    ^contents!
contents: c

    c isNil ifFalse: [
        contents := c
    ].! 
copySpecificsTo: aCopy!   
cpBackColor

    "Provided for ST/V 1.1 compatibility in Subpanes"

    ^self backColor!  
defaultBackColor

    ^self getSysColor: ColorWindow!   
defaultFont

    "OSI 12/23/92 - used the stored system font"
    ^PWindowBuilder wbDefaultFont!   
defaultFontOS
    "Private - Used for default font generation.
    Implemented by Ale..."

    | root |
    root := self.
    [ root parent notNil ] whileTrue: [ root := root parent ].
    root realClass isNil ifTrue: [ ^nil ].
    (root realClass respondsTo: #defaultFont)
    ifTrue: [ ^root realClass defaultFont ].
    ^nil!
defaultForeColor

    ^self getSysColor: ColorWindowtext!   
defaultSize

    | s |

    (s := self suggestedSize) notNil ifTrue: [
        ^s
    ].

    ^100@100!   
defaultStyle

    | s |

    (s := self styles) isNil ifTrue: [
        ^nil
    ] ifFalse: [
        ^s first
    ]! 
displayGenericWith: aPen clipRect: clipRect

    | aName region  |

    ('AEIOU' includes: self realClass name first) ifTrue: [
        aName := 'An ', self realClass name.
    ] ifFalse: [
        aName := 'A ', self realClass name.
    ].

    aPen
        place: rect origin;
        box: rect corner.

    region := aPen setClipRect: ((rect insetBy: 1) intersect: clipRect).
    aPen
        centerWinText:  aName
        at:  rect center;
        destroyRegion: region.! 
displayWithBothScrollBars: aPen

    super displayWith: aPen.

    aPen
        fill: ((rect leftTop rightBottom: (rect rightBottom leftAndUp: (self scrollBarWidth @ self scrollBarHeight) - 1)) insetBy: 1)
            color: self backColor.

    self drawVScrollBarWith: aPen
     at: ((rect rightTop left: self scrollBarWidth)
            rightBottom: (rect rightBottom up: self scrollBarHeight - 1)).

    self drawHScrollBarWith: aPen
     at: ((rect leftBottom up: self scrollBarHeight)
            rightBottom: (rect rightBottom left: self scrollBarWidth - 1)).

    aPen
        fill: (((rect rightBottom leftAndUp: (self scrollBarWidth @ self scrollBarHeight)) rightBottom: rect rightBottom) insetBy: 1)
        color: (self getSysColor: ColorScrollbar)!   
displayWithLeftScrollBar: aPen

    super displayWith: aPen.

    aPen
        fill: ((rect leftTop rightBottom: (rect right left: self scrollBarWidth - 1) @ rect bottom)  insetBy: 1)
            color: self backColor.

    self drawVScrollBarWith: aPen
     at: ((rect rightTop left: self scrollBarWidth)
            rightBottom: (rect rightBottom)).!
downArrow

    Down isNil ifTrue: [
        Down := Bitmap new fromSysID: ObmDnarrow.
    ].

    ^Down!
drawHScrollBarWith: aPen at: aRect

    | thumbRect nonThumbRect leftArrowRect rightArrowRect arrowWidth |

    arrowWidth := self scrollBarArrowWidth - 1.
    leftArrowRect := (aRect leftTop rightBottom: (aRect left right: arrowWidth) @ aRect bottom).
    rightArrowRect := ((aRect right left: arrowWidth + 1) @ aRect top rightBottom: aRect rightBottom).
    thumbRect := (aRect left right: arrowWidth) @ aRect top rightBottom: (aRect left right: self scrollBarThumbWidth + arrowWidth) @ aRect bottom.
    nonThumbRect := (((aRect left right: arrowWidth + self scrollBarThumbWidth) @ aRect top) rightBottom: (aRect right left: arrowWidth + 1)@ aRect bottom) insetBy: (0@1).
    aPen
        foreColor: ClrBlack;
        fill: (thumbRect insetBy: 2) color: (self getSysColor: ColorBtnface);
        drawRect3DLight: thumbRect;
        fill: nonThumbRect color: self scrollBarColor;
        foreColor: (self getSysColor: ColorWindowframe);
        lineFrom: aRect left @ (aRect bottom up: 1) to: aRect right @ (aRect bottom up: 1);
        lineFrom: aRect leftTop to: aRect rightTop;
        drawRectangle: thumbRect;
        copyBitmap: self leftArrow from: self leftArrow boundingBox to: leftArrowRect;
        copyBitmap: self rightArrow from: self rightArrow boundingBox to: rightArrowRect.! 
drawVScrollBarWith: aPen at: aRect

    | thumbRect nonThumbRect upArrowRect downArrowRect arrowHeight |

    arrowHeight := self scrollBarArrowHeight - 1.
    upArrowRect := (aRect leftTop rightBottom: aRect right @ (aRect top down: arrowHeight)).
    downArrowRect := (aRect left @ (aRect bottom up: arrowHeight + 1) rightBottom: aRect rightBottom).
    thumbRect := aRect left @ (aRect top down: arrowHeight) rightBottom: aRect right @ (aRect top down: self scrollBarThumbHeight + arrowHeight).
    nonThumbRect := (aRect left @ (aRect top down: arrowHeight + self scrollBarThumbHeight) rightBottom: aRect right @ (aRect bottom up: arrowHeight + 1)) insetBy: (1@0).
    aPen
        foreColor: ClrBlack;
        fill: (thumbRect insetBy: 2) color: (self getSysColor: ColorBtnface);
        drawRect3DLight: thumbRect;
        fill: nonThumbRect color: self scrollBarColor;
        foreColor: (self getSysColor: ColorWindowframe);
        lineFrom: (aRect right left: 1) @ aRect top to: (aRect right left: 1) @ aRect bottom;
        lineFrom: aRect leftTop to: aRect leftBottom;
        drawRectangle: thumbRect;
        copyBitmap: self upArrow from: self upArrow boundingBox to: upArrowRect;
        copyBitmap: self downArrow from: self downArrow boundingBox to: downArrowRect.!
font

    ^font!
font: f

    font := f! 
foreColor

    ^foreColor!  
foreColor: c

    foreColor := c!   
framingBlock

    ^framingBlock!
framingBlock: f

    framingBlock := f! 
fullCopyTo: copy


    copy realClass: self realClass.

    self == copy ifFalse: [
        copy handlers: IdentityDictionary new.
        handlers keysDo: [:k |
            copy handlers at: k put: (handlers at: k).
        ].
    ].

    copy
        paneName: self paneName;
        style: self style;
        font: self font;
        menu: (self menu notNil ifTrue: [ self menu fullCopy ] ifFalse: [ nil ]);
        framingBlock: self framingBlock;
        tabPosition: self tabPosition;
        foreColor: self foreColor;
        backColor: self realBackColor;
        rect: self rect deepCopy.

    copy usesTitle ifTrue: [
        copy contents: self contents.
    ].
    self copySpecificsTo: copy.! 
generateAllStyles

    ^false!  
generateTabStopsAndGroups

    ^self tabPosition isNil or: [ self tabPosition firstInGroup ]!   
genReceiveWindowMessagesOn: aStream indentString: spaceString

    (self realClass canUnderstand: #receiveAllWindowMessages) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'receiveAllWindowMessages'.
    ].!  
getSysColor: c

    ^UserLibrary
        getSysColor: c!   
handlers

    ^handlers!
handlers: h

    handlers := Dictionary new.
    h keysDo: [ :key |
        (h at: key) isMessage ifTrue: [
        handlers at: key put: (h at: key) selector.
        ] ifFalse: [
            handlers at: key put: (h at: key).
        ].
    ].!   
hasOtherEditor

    ^(self respondsTo: #attributeEditor)!   
hitRect

    ^rect! 
importantEvents

    ^OrderedCollection with: #getContents.!
initialize

    super initialize.
    handlers := IdentityDictionary new.

    framingBlock := FramingParameters new
        left: 0 relativeTo: #left;
        right: 0 relativeTo: #left;
        top: 0 relativeTo: #top;
        bottom: 0 relativeTo: #top.

    font := self defaultFont.
    foreColor := self defaultForeColor.
    backColor := self defaultBackColor.! 
isComposite

    ^self isCompositePane! 
isCompositePane

    ^false!
isFrameObject

    ^false!  
isGroupable

    ^false!
isGrouper

    ^false!  
isInterfaceObject

    ^true!   
leftArrow

    Left isNil ifTrue: [
        Left := Bitmap new  fromSysID: ObmLfarrow.
    ].

    ^Left!   
menu

    ^menu!
menu: m

    menu := m! 
menuEditor

    ^WBMenuEditor new!  
mutateSpecificsFrom: aPane!   
mutateTo: aClassName
    "Mutate a pane into another type"
    | class mutation supportedEvents size |
    (Smalltalk includesKey: aClassName asSymbol) ifTrue: [
        class := WBRealLayoutPane basicNew pseudoClassFor: aClassName.
        mutation := class new.
        mutation
            initialize;
            realClass: (Smalltalk at: aClassName asSymbol);
            handlers: IdentityDictionary new.
        supportedEvents := mutation supportedEvents.
        handlers keysDo: [:k |
            (supportedEvents includes: k) ifTrue: [
                mutation handlers at: k put: (handlers at: k)
            ].
        ].
        (mutation styles notNil and: [mutation styles includes: self style]) ifTrue: [
            mutation style: self style
        ] ifFalse: [
            mutation style: mutation defaultStyle
        ].
        mutation usesMenu & self usesMenu ifTrue: [
            mutation menu: (self menu notNil ifTrue: [ self menu fullCopy ] ifFalse: [ nil ])
        ].
        mutation usesColor & self usesColor ifTrue: [
            (self foreColor = self defaultForeColor) ifFalse: [
                mutation foreColor: self foreColor
            ] ifTrue: [
                mutation foreColor: mutation defaultForeColor
            ].
            (self realBackColor = self defaultBackColor) ifFalse: [
                mutation backColor: self realBackColor
            ] ifTrue: [
                mutation backColor: mutation defaultBackColor
            ].
        ].
        mutation usesFont & self usesFont ifTrue: [
            mutation font: self font
        ].
        mutation usesTitle & self usesTitle ifTrue: [
            self contents isNil ifTrue: [
                mutation text: ''
            ] ifFalse: [
                mutation text: self text
            ].
        ].
        mutation
            paneName: self paneName;
            framingBlock: self framingBlock;
            tabPosition: self tabPosition;
            rect: self rect deepCopy.
        (mutation changesSize and: [ (size := mutation suggestedSize) notNil]) ifTrue: [
            mutation rect: (mutation rect extent: size)
        ].
        self mutationRotationList isEmpty ifFalse: [
            (self mutationRotationList includes: aClassName asSymbol) ifTrue: [
                mutation rect: (mutation rect extent: mutation rect extent transpose)
            ].
        ].
        mutation mutateSpecificsFrom: self.
        ^mutation
    ] ifFalse: [
        ^nil
    ].!
mutationExceptions

    ^#()!   
mutationList
    | list |
    self realClass isNil ifTrue: [ ^nil ].
    list := Set new.
    list addAll: self realClass withAllSubclasses.
    self mutationTypes do: [ :className |
        (Smalltalk includesKey: className asSymbol) ifTrue: [
            list addAll: (Smalltalk at: className asSymbol) withAllSubclasses
        ].
    ].
    self mutationExceptions do: [ :className |
        (Smalltalk includesKey: className asSymbol) ifTrue: [
            list remove: (Smalltalk at: className asSymbol)
        ].
    ].
    list remove: self realClass.
    list := (list reject: [ :class | class isWBInternalClass ]) collect: [ :class | class name ].
    (list includes: 'ScrollBar') ifTrue: [
        list
            remove: 'ScrollBar';
            add: 'WBVerticalScrollBar';
            add: 'WBHorizontalScrollBar'.
    ].
    ^list asSortedCollection! 
mutationRotationList

    ^#()! 
mutationTypes

    ^#()!
paneName

    ^name!
paneName: n

    name := n! 
parent

    ^parentWindow!  
parent: anInterfaceObject

    parentWindow := anInterfaceObject.!  
printOn: aStream

    aStream cr.
    super printOn: aStream.
    self paneName isNil ifFalse: [ aStream cr; nextPutAll: '    Name: ',self paneName ].
    self contents isNil ifFalse: [ aStream cr; nextPutAll: '    Contents: ',self contents asString ].
    self rect isNil ifFalse: [ aStream cr; nextPutAll: '    Rect: ',self rect asString ].
    self font isNil ifFalse: [ aStream cr. self font portableStoreOn: aStream indentString: '    ' ].!  
readSpecificsFrom: c! 
realBackColor

    ^backColor!  
realClass

    ^realClass!  
realClass: aClass

    realClass := aClass.!
realClassName

    ^realClass name! 
reframe: parentRect

    self rect: (parentRect unLocalizeRect: (framingBlock value: (0@0 extent: parentRect extent)))! 
removeEvents

    ^#( display ).!   
resetColors

    "Deal with color changes from the control panel"

    backColor isInteger ifFalse: [
        self backColor: self defaultBackColor.
    ].
    self foreColor isInteger ifFalse: [
        self foreColor: self defaultForeColor.
    ].!   
resetPen: aPen

    aPen
        down;
        font: SysFont;
        backColor: (self getSysColor: ColorWindow);
        foreColor: (self getSysColor: ColorWindowframe);
        setTextAlign: TaTop!
resID

    ^resID!  
resID: i

    resID := i!   
rightArrow

    Right isNil ifTrue: [
        Right := Bitmap new  fromSysID: ObmRgarrow
    ].

    ^Right!
scrollBarArrowHeight

    ^UserLibrary
        getSystemMetrics: SmCyvscroll!  
scrollBarArrowWidth

    ^UserLibrary
        getSystemMetrics: SmCxhscroll!   
scrollBarColor

    ^(self getSysColor: ColorScrollbar)!
scrollBarHeight

    ^UserLibrary
        getSystemMetrics: SmCyhscroll!   
scrollBarThumbHeight

    ^UserLibrary
        getSystemMetrics: SmCyvthumb!   
scrollBarThumbWidth

    ^UserLibrary
        getSystemMetrics: SmCxhthumb!
scrollBarWidth

    ^UserLibrary
        getSystemMetrics: SmCxvscroll!
setPopupMenu: aRealMenu

    menu := aRealMenu asWBPMenu!   
setStyleFrom: aRealStyle

    aRealStyle isNil ifTrue: [
        ^self style: self defaultStyle
    ].

    self style: (self class styleFrom: aRealStyle).!
staysToBack

    ^false!
storeColorOn: aStream indentString: indentString
    | colorString |
    (self foreColor  ~= self defaultForeColor ) ifTrue: [
        colorString := ColorConstants keyAtValue: foreColor.
        colorString isNil ifFalse: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'foreColor: ', colorString.
        ].
    ].

    (self realBackColor notNil and: [ self realBackColor  ~= self defaultBackColor ]) ifTrue: [
        colorString := ColorConstants keyAtValue: self realBackColor.
        colorString isNil ifFalse: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'backColor: ', colorString.
        ].
    ].! 
storeContentsOn: aStream indentString: spaceString

    (self usesTitle and: [ self contents notNil]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'contents: '.
        self contents printOn: aStream.
    ].!  
storeOn: aStream indentString: indentString
    "Touched by Ale for default font support..."
    | spaceString defaultFont |

    spaceString := indentString.

    aStream nextPutAll: spaceString, self realClassName, ' new'; cr.

    spaceString := spaceString, '    '.

    aStream nextPutAll: spaceString, 'owner: ',PWindowBuilder secondArg.

    self storeRectOn: aStream indentString: spaceString.
    self paneName isNil ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'paneName: ''', self paneName asString, ''''.
    ].

    self storeSpecificsOn: aStream indentString: spaceString.

    self storeStyleOn: aStream indentString: spaceString.

    self generateTabStopsAndGroups ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'startGroup'.
        (self usesFocus & self tabPosition notNil)  ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'tabStop'.
        ].
    ].

    self handlers keysDo: [ :symbol |
        (self handlers at: symbol) isSymbol ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'when: #', symbol,' perform: #', (self handlers at: symbol).
            ].
    ].

    self storeContentsOn: aStream indentString: spaceString.

    self menu notNil ifTrue: [
        self genReceiveWindowMessagesOn: aStream indentString: spaceString.
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'setPopupMenu: ('; cr.
        self menu storeOn: aStream indentString: spaceString, '    '.
        aStream cr; nextPutAll: spaceString, ')'.
    ].

    #modifiedByOStyle.
    defaultFont := self defaultFontOS.
    (defaultFont notNil and: [self font wbEquals: defaultFont])
    ifTrue: [aStream nextPutAll: ';'; "cr;" nextPutAll: "spaceString," ' font: self defaultFont' ]
    ifFalse: [
        (self font wbEquals: self defaultFont) ifFalse: [
            aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'font: ('; cr.
            self font storeOn: aStream indentString: spaceString, '    '.
            aStream cr; nextPutAll: spaceString, ')'.
        ].
    ].

    self storeColorOn: aStream indentString: spaceString.


    aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'yourself'.!  
storeRectOn: aStream indentString: spaceString

        framingBlock initialExtent: self extent.

        aStream nextPutAll: ';'; cr;  nextPutAll: spaceString,'framingBlock: ( '.
        self framingBlock storeOn: aStream indentString: spaceString,'    '.
        aStream nextPutAll: ')'.!  
storeSpecificsOn: aStream indentString: aString

    "Subpanes subclass this to write out specific information about themselves
     as source code."! 
storeStyleOn: aStream indentString: spaceString

    (self style notNil and: [ self generateAllStyles | (self style ~= self defaultStyle) ]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString.
        self style printOn: aStream.
    ].!
style

    ^style!  
style: s

    style := s!   
styles

    ^nil!   
supportedEvents
    | list |
    list := self importantEvents asOrderedCollection.
    list addAll:
        ((self realClass supportedEvents reject: [ :sym |
            (list includes: sym) or: [ self removeEvents includes: sym ]])
            asSortedCollection asArray).
    ^list!   
tabPosition

    ^tabPosition!  
tabPosition: p

    tabPosition := p!   
text

    ^self contents!   
text: aString

    self contents: aString!  
upArrow

    Up isNil ifTrue: [
        Up := Bitmap new  fromSysID: ObmUparrow
    ].

    ^Up!
usesColor

    ^true!   
usesFocus

    ^true!   
usesFont

     ^true!   
usesForeColor

    ^true!   
usesFraming

    ^true! 
usesMenu

    ^true!
usesTitle

    ^false!  
when: e perform: m

    handlers at: e put: m!  
winClass

    | c i  |

    "8/2/92 TAP - For default controls we needed to use a numeric value, not a string,
     since Borland's Resource Workshop doesn't honor string class names for built-in
     controls."
    c := self realClass basicNew winClass.
    i := #( 'BUTTON' 'EDIT' 'STATIC' 'LISTBOX' 'SCROLLBAR' 'COMBOBOX') indexOf: c.

    i = 0 ifTrue: [
        ^c
    ] ifFalse: [
        ^127 + i
    ].! 
winClassStyle

    ^0!  
winStyle

    | theStyle |

    theStyle :=
        WsChild   |
        WsVisible |
        WsClipsiblings |
        self winClassStyle |
        self winUserStyle.

    (self tabPosition isNil or: [ self tabPosition firstInGroup ]) ifTrue: [
        theStyle := theStyle | WsGroup.
        (self usesFocus & self tabPosition notNil) ifTrue: [
            theStyle := theStyle | WsTabstop.
        ].
    ].

    ^theStyle! 
winUserStyle

    ^0! !

! FrameObject methods !  
contentRect

    ^(rect insetBy: 1)!
drawFrameWith: aPen at: aPoint

    | theRect |
    theRect := (aPoint extentFromLeftTop: rect extent).
    aPen place: aPoint;
        box: theRect corner.!
frameExtent

    ^rect extent!  
importantEvents

    ^OrderedCollection new.!   
isFrameObject

    ^true! !

! WindowFrameObject class methods !  
indent

    ^UserLibrary getSystemMetrics: SmCxsize!
newForClass: c

    (c inheritsFrom: CompositePane) ifTrue: [
        ^CompositeFrameObject new
    ].

    ^self new!  
purgeCache

    Minimize notNil ifTrue: [
        Minimize release.
    ].
    Maximize notNil ifTrue: [
        Maximize release.
    ].

    SysMenu notNil ifTrue: [
        SysMenu release.
    ].
    Minimize := Maximize := SysMenu := nil!   
styleFrom: winStyle

    | s |

    s := Set new.

    (winStyle bitIsOn: WsSysmenu) ifTrue: [
        s add: #sysmenu.
    ].

    (winStyle bitIsOn: WsCaption) ifTrue: [
        s add: #titlebar.
    ].
    (winStyle bitIsOn: DsModalframe) ifTrue: [
        s add: #modal.
    ].
    (winStyle bitIsOn: DsSysmodal) ifTrue: [
        s add: #sysmodal.
    ].

    ^s! !

! WindowFrameObject methods !   
addSubpane: c

    "Windows import."

    children add: c.!   
attributeEditor

    self isDialog ifTrue: [
        ^WBDialogEditor new
    ] ifFalse: [
        ^WBWindowEditor new
    ].!   
backColor

    ^backColor.! 
borderWidth

    (self isModal) ifTrue: [
        ^(UserLibrary getSystemMetrics: SmCxdlgframe) + 1
    ] ifFalse: [
        (self style includes: #sizable) ifTrue: [
            ^UserLibrary getSystemMetrics: SmCxframe
        ] ifFalse: [
            ^UserLibrary getSystemMetrics: SmCxborder
        ].
    ].!   
children

    ^children!
children: c

    children := c.!
contentRect

    | contentRect |

    contentRect := rect left @ (rect top down: self titleHeight + self menuHeight) rightBottom: rect right @ rect bottom.

    ^contentRect insetBy: self borderWidth!
copySpecificsTo: aPane

    aPane
        iconFile: self iconFile.!
createdBy

    ^createdBy!  
createdBy: aString

    createdBy := aString!   
defaultBackColor

    ^self getSysColor: ColorWindow!   
defaultStyle

    (self realClass notNil and: [ self isDialog ]) ifTrue: [
        ^#( sysmenu modal titlebar )
    ] ifFalse: [
        ^#( sysmenu minimize maximize sizable titlebar )
    ].!   
drawBorderWith: aPen in: windowRect

    | r borderWidth borderColor topRect bottomRect leftRect rightRect linePos |

    r := windowRect.
    (self style includes: #sizable) ifFalse: [
        borderWidth := self borderWidth - 1.
    ] ifTrue: [
        borderWidth := self borderWidth - 2.
    ].
    linePos := borderWidth + self sysMenuBitmap extent + 1.

    aPen
        foreColor: (self getSysColor: ColorWindowframe);
        drawRectangle: r.

    (self style includes: #sizable) | self isModal ifTrue: [

        r := r insetBy: 1.

        topRect := r leftTop rightBottom: r right @ (r top down: borderWidth).
        leftRect := r leftTop rightBottom: (r left right: borderWidth) @ r bottom.
        bottomRect := r left @ (r bottom up: borderWidth) rightBottom: r rightBottom.
        rightRect := ((r right left: borderWidth) @ r top rightBottom: r rightBottom).

    (self style includes: #sizable) ifTrue: [
        borderColor := self getSysColor: ColorActiveborder.
    ] ifFalse: [
        borderColor := self getSysColor: ColorActivecaption.
    ].

    aPen
        fill: topRect color: borderColor;
        fill: leftRect color: borderColor;
        fill: bottomRect color: borderColor;
        fill: rightRect color: borderColor;
        foreColor: (self getSysColor: ColorWindowframe).

    (self style includes: #sizable) ifTrue: [
        aPen
            drawRectangle: (topRect insetBy: (linePos x @ -1));
            drawRectangle: (leftRect insetBy: (-1@ linePos y));
            drawRectangle: (rightRect insetBy: (-1@ linePos y));
            drawRectangle: (bottomRect insetBy: (linePos x @ -1));
            drawRectangle: (r insetBy: borderWidth).
        ].

    ].!
drawFrameWith: aPen at: aPoint

    | r region |

    region := aPen setClipRect: (r := aPoint extentFromLeftTop: rect extent).
    self drawBorderWith: aPen in: r.
    aPen destroyRegion: region.

    r extent > ((self borderWidth @ self borderWidth) * 2) ifTrue: [
        region := aPen setClipRect: (r := r insetBy: self borderWidth).
        self drawTitleWith: aPen in: r.
        aPen destroyRegion: region.
    ].!
drawTitleTextWith: aPen in: r

    | titleRect |

     titleRect := r leftTop extentFromLeftTop: r width @ self titleHeight.

    self isDialog ifTrue: [
        titleRect := (titleRect leftTop rightAndDown: 1@1) extentFromLeftTop: titleRect extent - (2@0).
    ].
    self hasTitleBar ifTrue: [
        aPen
            fill: titleRect color: (self getSysColor: ColorActivecaption);
            font: SysFont;
            setTextAlign: TaTop;
            foreColor: (self getSysColor: ColorCaptiontext);
            setBackMode: Transparent;
            centerWinText: contents at: titleRect center;
            setBackMode: Opaque.
    ].!   
drawTitleWith: aPen in: r

    | titleRect b menuRect xPos yPos space |

     titleRect := r leftTop extentFromLeftTop: r width @ self titleHeight.

    self isDialog ifTrue: [
        titleRect := (titleRect leftTop rightAndDown: 1@1) extentFromLeftTop: titleRect extent - (2@0).
    ].
    self hasTitleBar ifTrue: [
        aPen
            fill: titleRect color: (self getSysColor: ColorActivecaption);
            font: SysFont;
            setTextAlign: TaTop;
            foreColor: (self getSysColor: ColorCaptiontext);
            setBackMode: Transparent;
            centerWinText: contents at: titleRect center;
            setBackMode: Opaque;
            foreColor: (self getSysColor: ColorWindowframe);
            lineFrom: titleRect left @ (titleRect bottom up: 1) to: titleRect right @ (titleRect bottom up: 1).
    ].

    (self style includes: #sysmenu) ifTrue: [
        (b := self sysMenuBitmap) displayAt: (titleRect leftTop) with: aPen.
        aPen lineFrom: (titleRect left right: b width) @ titleRect top
            to: (titleRect left right: b width) @ titleRect bottom.
    ].

    (self style includes: #maximize) ifTrue: [
        (b := self maximizeBitmap) displayAt: (titleRect rightTop left: b width) with: aPen.
    ].

    (self style includes: #minimize) ifTrue: [
        (self style includes: #maximize) ifTrue: [
            (b := self minimizeBitmap) displayAt: (titleRect rightTop left: (b width * 2)) with: aPen.
        ] ifFalse: [
            (b := self minimizeBitmap) displayAt: (titleRect rightTop left: b width) with: aPen.
        ].
    ].

    menu notNil ifTrue: [
        menuRect := r left @ titleRect bottom extentFromLeftTop: r width @ self menuHeight.
        aPen
            fill: menuRect color: (self getSysColor: ColorMenu);
            foreColor: (self getSysColor: ColorWindowframe);
            lineFrom: menuRect left @ (menuRect bottom up: 1) to: menuRect right @ (menuRect bottom up: 1);
            foreColor: ColorMenutext.
            xPos := menuRect left right: 6.
            yPos := menuRect top.
            space := aPen stringWidthOf: '  '.

        aPen
            foreColor: (self getSysColor: ColorMenutext);
            setBackMode: Transparent.

        menu allTitles do: [ :t |
            aPen winDrawText: t at: xPos@yPos.
            xPos := xPos right: (aPen stringWidthOf: t) + space.
        ].
        aPen setBackMode: Opaque.
    ].!   
hasTitleBar

    ^self style includes: #titlebar!   
iconFile

    ^iconFile!
iconFile: aString

    iconFile := aString.!
initialize

    super initialize.

    style := #().
    children := OrderedCollection new.! 
isCompositePane

    ^self realClass inheritsFrom: CompositePane.!  
isDialog

    ^self realClass inheritsFrom: WindowDialog!   
isModal

    ^(self style includes: #modal) | (self style includes: #sysmodal)! 
maximizeBitmap

    Maximize isNil ifTrue: [
        Maximize := (Bitmap new fromSysID: ObmZoom).
    ].

    ^Maximize!
menuEditor

    ^WBMenubarEditor new!   
menuHeight

    menu isNil ifTrue: [
        ^0
    ].

    ^(UserLibrary getSystemMetrics: SmCymenu) + 1.! 
minimizeBitmap

    Minimize isNil ifTrue: [
        Minimize := (Bitmap new fromSysID: ObmReduce).
    ].

    ^Minimize!  
modifiedBy

    ^modifiedBy!
modifiedBy: aString

    modifiedBy := aString! 
owner: ignore

    "For Windows Conversion"!
storeOn: aStream indentString: indentString

    framingBlock isNil ifTrue: [
        framingBlock := FramingParameters new.
        rect origin = (0@0) ifTrue: [
            framingBlock xC; yC.
        ] ifFalse: [
            framingBlock left: rect left relativeTo: #left; top: rect top relativeTo: #top.
        ].
    ].

    aStream nextPutAll: 'self topPaneClass new'; cr.

    aStream nextPutAll: indentString, 'owner: ',PWindowBuilder secondArg,';'; cr.
    aStream nextPutAll: indentString, 'labelWithoutPrefix:  ', self contents asQuotedString, ';'; cr.
    aStream nextPutAll: indentString, 'noSmalltalkMenuBar'.
    self iconFile notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll:  indentString, 'iconFile: ', self iconFile asQuotedString.
    ].
    self paneName notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll:  indentString, 'viewName: ', self paneName asQuotedString.
    ].
    self storeRectOn: aStream indentString: indentString.
    aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'pStyle: #', self  style asArray asString.
    self createdBy isNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll:  indentString, 'createdBy: ',
            ((Smalltalk at: #WindowBuilderUser ifAbsent: [ '' ]), ', ',
            (Smalltalk at: #WindowBuilderCompany ifAbsent: [ '' ]), ' - ',
            Date today asString,' ',Time now asString) asQuotedString
    ] ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll:  indentString, 'createdBy: ', self createdBy asQuotedString.
        aStream nextPutAll: ';'; cr; nextPutAll:  indentString, 'modifiedBy: ',
            ((Smalltalk at: #WindowBuilderUser ifAbsent: [ '' ]), ', ',
            (Smalltalk at: #WindowBuilderCompany ifAbsent: [ '' ]), ' - ',
            Date today asString,' ',Time now asString) asQuotedString
    ].
    self handlers keysDo: [ :symbol |
        (self handlers at: symbol) isSymbol ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'when: #', symbol,' perform: #', (self handlers at: symbol).
            ].
    ].

        (self foreColor  ~= self defaultForeColor ) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'foreColor: ', (ColorConstants keyAtValue: foreColor).
        ].

        ( self realBackColor  ~= self defaultBackColor ) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'backColor: ', (ColorConstants keyAtValue: backColor).
        ].!   
storeOn: aStream indentString: indentString mdi: mdi

    framingBlock isNil ifTrue: [
        framingBlock := FramingParameters new.
        rect origin = (0@0) ifTrue: [
            framingBlock xC; yC.
        ] ifFalse: [
            framingBlock left: rect left relativeTo: #left; top: rect top relativeTo: #top.
        ].
    ].

    mdi ifTrue: [
        aStream nextPutAll: 'MDIChild new'; cr;
            nextPutAll: indentString, 'frame: self frame;'; cr.
    ] ifFalse: [
        aStream nextPutAll: 'self topPaneClass new'; cr.
    ].

    aStream nextPutAll: indentString, 'owner: ',PWindowBuilder secondArg,';'; cr.
    aStream nextPutAll: indentString, 'labelWithoutPrefix:  ', self contents asQuotedString, ';'; cr.
    aStream nextPutAll: indentString, 'noSmalltalkMenuBar'.
    self iconFile notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll:  indentString, 'iconFile: ', self iconFile asQuotedString.
    ].
    self paneName notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll:  indentString, 'viewName: ', self paneName asQuotedString.
    ].
    self storeRectOn: aStream indentString: indentString.
    aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'pStyle: #', self  style asArray asString.
    PWindowBuilder recordCreatorInformation ifTrue: [
        self createdBy isNil ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll:  indentString, 'createdBy: ',
                ((Smalltalk at: #WindowBuilderUser ifAbsent: [ '' ]), ', ',
                (Smalltalk at: #WindowBuilderCompany ifAbsent: [ '' ]), ' - ',
                Date today asString,' ',Time now asString) asQuotedString
        ] ifFalse: [
            aStream nextPutAll: ';'; cr; nextPutAll:  indentString, 'createdBy: ', self createdBy asQuotedString.
            aStream nextPutAll: ';'; cr; nextPutAll:  indentString, 'modifiedBy: ',
                ((Smalltalk at: #WindowBuilderUser ifAbsent: [ '' ]), ', ',
                (Smalltalk at: #WindowBuilderCompany ifAbsent: [ '' ]), ' - ',
                Date today asString,' ',Time now asString) asQuotedString
        ].
    ].
    self handlers keysDo: [ :symbol |
        (self handlers at: symbol) isSymbol ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'when: #', symbol,' perform: #', (self handlers at: symbol).
            ].
    ].

        (self foreColor  ~= self defaultForeColor ) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'foreColor: ', (ColorConstants keyAtValue: foreColor).
        ].

        ( self realBackColor  ~= self defaultBackColor ) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'backColor: ', (ColorConstants keyAtValue: backColor).
        ].!
storeRectOn: aStream indentString: indentString

    framingBlock clientRect: self contentRect.

    super storeRectOn: aStream indentString: indentString.!  
supportedEvents

     ^self realClass basicNew topPaneClass supportedEvents asSortedCollection! 
sysMenuBitmap

    | temp w |

    SysMenu isNil ifTrue: [
        temp := (Bitmap new fromSysID: ObmClose).
        w := (UserLibrary getSystemMetrics: SmCxsize).
        SysMenu := Bitmap new ownDCScreenWidth: w height: temp height.
        SysMenu pen
            copyBitmap: temp
            from: (temp boundingBox leftTop extent: ( w @ temp boundingBox height))
            at: 0@0.
    ].

    ^SysMenu!  
titleHeight

    self hasTitleBar | (style includes: #minimize) | (style includes: #sysmenu) | (style includes: #maximize) ifTrue: [
        ^(UserLibrary getSystemMetrics: SmCysize) + 1
    ].

    ^0!  
titleRectFrom: aPoint

    | titleRect leftIndent rightIndent |

    titleRect := (aPoint extentFromLeftTop: rect extent) insetBy: self borderWidth.
    titleRect := titleRect leftTop extentFromLeftTop: titleRect width @ self titleHeight.

    leftIndent := rightIndent := 0.
    (self style includes: #sysmenu) ifTrue: [
        leftIndent := self sysMenuBitmap width.
    ].

    (self style includes: #maximize) ifTrue: [
        rightIndent := self maximizeBitmap width
    ].
    (self style includes: #minimize) ifTrue: [
        rightIndent := rightIndent + self maximizeBitmap width
    ].

    ^(titleRect left right: leftIndent) @ titleRect top extentFromLeftTop: (titleRect width - rightIndent - leftIndent) @ titleRect height.!
usesFont

     ^false!  
usesForeColor

    ^false!  
usesMenu

    ^self isDialog not!   
usesTitle

    ^self hasTitleBar! !

! CompositeFrameObject methods ! 
drawFrameWith: aPen at: aPoint

    | r region |

    region := aPen setClipRect: (r := aPoint extentFromLeftTop: rect extent).
    aPen
        foreColor: (self getSysColor: ColorWindowframe);
        drawRectangle: r.
    aPen destroyRegion: region.!  
paneName: n!  
storeOn: aStream indentString: indentString

    aStream reset.
    PWindowBuilder secondArg = 'self' ifFalse: [
        aStream
            nextPutAll: '    | wbOwner |'; cr;
            nextPutAll: '    wbOwner := self.'; cr
    ].
    aStream
        nextPutAll: '    (self'; cr; nextPutAll: '        yourself'.

    self storeRectOn: aStream indentString: indentString.

"    self handlers keysDo: [ :symbol |
        ((self handlers at: symbol) isKindOf: Symbol) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'when: #', symbol,' perform: #', (self handlers at: symbol).
            ].
    ]."

    (self foreColor  ~= self defaultForeColor ) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'cpForeColor: ', (ColorConstants keyAtValue: foreColor).
    ].

    ( self realBackColor  ~= self defaultBackColor ) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'cpBackColor: ', (ColorConstants keyAtValue: backColor).
    ].!   
storeOn: aStream indentString: indentString mdi: mdi

    self storeOn: aStream indentString: indentString! 
supportedEvents

    ^#()!  
usesMenu

    ^false!   
usesTitle

    ^false! !

! PButton class methods !   
styleFrom: s

    (s bitIsOn: BsDefpushbutton) ifTrue: [
        ^#defaultPushButton
    ] ifFalse: [
        ^#pushButton
    ].! !

! PButton methods ! 
changesSize

    ^true! 
contents
    contents isNil ifTrue: [ contents := '' ].
    ^contents!  
contents: aString

    | string |

    string := aString stripMnemonic asUpperCase.
    (string = 'OK') ifTrue: [
        specialId := 1.
    ] ifFalse: [
        (string = 'CANCEL') ifTrue: [
            specialId := 2.
        ] ifFalse: [
            specialId := nil.
        ].
    ].

    super contents: aString.!   
copySpecificsTo: aPane

    aPane specialId: self specialId.!   
defaultBackColor

    ^self getSysColor: ColorBtnface!  
defaultFont

    ^PWindowBuilder wbDefaultFont! 
defaultForeColor

    ^self getSysColor: ColorBtntext!  
defaultSize

    ^self suggestedSize!   
displayWith: aPen clipRect: clipRect

    | inset region bottom right r clip |

     r := rect.
    style == #defaultPushButton ifTrue: [
        inset := 1.
        aPen drawRectangle: (r insetBy: 1).
    ] ifFalse: [
        inset := 0.
    ].

    bottom := r bottom up: 1.
    right := r right left: 1.

    aPen
        lineFrom: r left @ (r top down: 1) to: r left @ bottom;
        lineFrom: right @ (r top down: 1) to: right @ bottom;
        lineFrom: (r left right: 1) @ r top to: right @  r top;
        lineFrom: (r left right: 1) @ bottom to: right @ bottom.


    aPen
        fill: (r insetBy: inset + 3) color: self defaultBackColor;
        drawRect3D: (r insetBy: inset).

    clip := ((r insetBy: inset + 3) intersect: clipRect).

    (clip left isRightOf: clip right) | (clip top isBelow: clip bottom) ifFalse: [
        region := aPen setClipRect: ((r insetBy: inset + 3) intersect: clipRect).

        aPen
            setBackMode: Transparent;
            foreColor: self foreColor;
            font: font;
            setTextAlign: TaTop;
            centerWinText: contents at: r center;
            setBackMode: Opaque.


        aPen destroyRegion: region.
    ].!  
importantEvents

    ^super importantEvents
        addFirst: #clicked;
        yourself! 
isGroupable

    ^true! 
mutationExceptions

    ^#(Toggle CPHorizontalPictureButton)!   
mutationTypes

    ^#(Button CPBitmapButton CPBitmapPane)!  
readSpecificsFrom: c

    specialId := c propertyAt: #id!   
specialId

    ^specialId!  
specialId: anObject

    specialId := anObject! 
storeSpecificsOn: aStream indentString: indentString

    self specialId = 1 ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'idOK'.
    ].

    self specialId = 2 ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'idCancel'.
    ].! 
style: aStyle

    "Added to fix problem with default pushbuttons not getting
     activated on cr in regular windows.  Fix it by setting their id to 1, or ID_OK.
     Note that there can only be one default pushbutton in the window."

    super style: aStyle.
    (self style = #defaultPushButton) ifTrue: [
        self specialId: 1.
    ] ifFalse: [
        self specialId: nil.
    ].!  
styles

    ^#(pushButton defaultPushButton)!   
suggestedSize

    ^((self font wbStringWidth: self contents) + 20) @(self font height + 14).!  
usesColor

    ^false!  
usesTitle

    ^true!   
winUserStyle

    style == #defaultPushButton ifTrue: [
        ^BsDefpushbutton
    ].

    ^BsPushbutton! !

! PComboBox class methods !
purgeCache

    DownArrow notNil ifTrue: [
        DownArrow release.
    ].
    DownArrow := nil.!  
styleFrom: s

    (s bitIsOn: CbsDropdownlist) ifTrue: [
        ^#dropDownList
    ] ifFalse: [
        (s bitIsOn: CbsDropdown) ifTrue: [
            ^#dropDown
        ] ifFalse: [
            ^#simpleList
        ].
    ].! !

! PComboBox methods !  
attributeEditor

    ^WBListEditor new! 
containsPoint: p

    ^self hitRect containsPoint: p!   
copySpecificsTo: aPane

    aPane
        contents: self contents.!
defaultFont

   "OSI 12/23/92 - used the stored system font"
    ^PWindowBuilder wbDefaultFont
    "^ListFont"!   
displayWith: aPen

    | r bottomRect buttonWidth topRect theBackColor list region newPoint |

    theBackColor := (style == #dropDownList)
        ifFalse: [ ClrWhite ]
        ifTrue: [ self backColor ].

    buttonWidth := self scrollBarWidth.

    r := (rect right left: buttonWidth) @ rect top extentFromLeftTop: buttonWidth @ (self font height + 8).

    (style == #dropDown) ifTrue: [
        topRect := (rect leftTop extentFromLeftTop: rect width @ r height).
        aPen fill: (topRect insetBy: 1@0) color: self backColor.
        topRect := (rect leftTop extentFromLeftTop: (rect width - buttonWidth - 7) @ r height).
    ] ifFalse: [
        (style == #dropDownList) ifTrue: [
            topRect := (rect leftTop extentFromLeftTop: (rect width - buttonWidth) @ r height).
        ] ifFalse: [
            topRect := (rect leftTop extentFromLeftTop: rect width @ r height).
    ]].

    aPen drawRectangle: topRect;
            fill: (topRect insetBy: 1) color: ClrWhite.

    (style == #dropDownList) ifTrue: [
        aPen drawRectangle: topRect;
            fill: (topRect insetBy: 2) color: theBackColor].

    (style == #simpleList) ifTrue: [
        bottomRect := (rect left right: 8) @ (rect top down: r height - 1) rightBottom: rect rightBottom.
        "Must be an increment of font height"
        bottomRect := bottomRect leftTop extent: (bottomRect width @ ((bottomRect height - 2 truncateTo: aPen font height)+2)).
        aPen rectangle: bottomRect;
            fill: (bottomRect insetBy: 1) color: theBackColor.
        "OSI 12/27/92 - Draw the list contents"
        list := self contents.
        list isNil
            ifFalse: [
                aPen font: self font.
                region := aPen setClipRect: (bottomRect insetBy: 1@1).
                newPoint := (bottomRect insetBy: 3@1) leftTop.
                1 to: list size do: [ :i |
                    aPen displayText: (list at: i) at: newPoint.
                    newPoint := newPoint down: aPen font height ].
                aPen destroyRegion: region].
    ] ifFalse: [
      aPen
        fill: (r insetBy: 2) color: (self getSysColor: ColorBtnface);
        drawRect3DLight: r;
        drawRectangle: r;
        foreColor: ClrBlack;  "Should be ColrBtntext, but fails..."
        backColor: (self getSysColor: ColorBtnface);
        copyBitmap: self downArrow
            from: self downArrow boundingBox
            at: r origin + ((r extent - self downArrow extent) // 2)
            rule: Srcand.
    ].! 
downArrow

    DownArrow isNil ifTrue: [
        DownArrow := Bitmap new fromSysID: ObmCombo
    ].

    ^DownArrow!
generateAllStyles

    ^true!   
genReceiveWindowMessagesOn: aStream indentString: spaceString

    "Don't generate method for subclasses of EntryField or ListBox - they already have it"!  
hitRect

    style == #simpleList ifTrue: [
        ^super hitRect
    ].

    ^(rect leftTop extentFromLeftTop: rect width @ (self font height + 8))!  
importantEvents

    ^super importantEvents
        addFirst: #textChanged;
        addFirst: #select;
        yourself! 
maxSize

    ^32000@32000!  
minSize

    (self style = #simpleList) ifTrue: [
        ^1@1
    ] ifFalse: [
        ^1@ (self font height + 8)
    ].!  
mutateSpecificsFrom: aPane
    | list |
    ((list := aPane contents) notNil and: [ list isArray ]) ifTrue: [
        self contents: list deepCopy
    ].!
mutationExceptions

    ^#(CPScrollingPane)!
mutationTypes

    ^#(ListBox CPScrollingPane RadioButtonGroup)!
storeSpecificsOn: aStream indentString: indentString
    "Write out the list"
    self contents isNil ifFalse: [
        self contents isEmpty ifFalse: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'contents: #( '.
                self contents do:[ :item | aStream nextPutAll: item asQuotedString,' ' ].
                aStream nextPutAll: ')' ] ].!   
styles

    ^#(dropDown simpleList dropDownList   )!
usesColor

    ^(style == #simpleList) ifTrue: [ false ] ifFalse: [ true ]! 
usesForeColor

    ^(style == #dropDownList) ifTrue: [ true ] ifFalse: [ false ]!   
winUserStyle

    ^((Array with: CbsDropdown with: CbsDropdownlist with: CbsSimple)
        at: (#(dropDown dropDownList simpleList) indexOf: style))! !

! PCompositePane class methods !   
styleFrom: s

    (s bitIsOn: WsBorder) ifFalse: [
        ^#defaultStyle
    ] ifTrue: [
        (s bitIsOn: WsVscroll) ifFalse: [
            ^#borders
        ] ifTrue: [(s bitIsOn: WsHscroll) ifFalse: [
            ^#verticalScrollBar
        ] ifTrue: [
            ^#scrollbars
        ]].
    ].! !

! PCompositePane methods !   
backColor

    self parent isCompositePane ifTrue: [
        ^super backColor
    ] ifFalse: [
        backColor = super defaultBackColor ifTrue: [
            ^super backColor
        ] ifFalse: [
            ^backColor
        ].
    ].! 
children

    children isNil ifTrue: [ children := #() ].
    ^children!   
children: aCollection

    children := aCollection! 
copySpecificsTo: aPane

    aPane
        initialFraming: self initialFraming.!
defaultBackColor
    self parent isCompositePane ifTrue: [
        ^self parent defaultBackColor
    ] ifFalse: [ defaultBackColor isNil ifTrue: [
        ^super defaultBackColor
    ] ifFalse: [
        ^defaultBackColor
    ]].! 
defaultBackColor: aColor

    defaultBackColor := aColor!   
displayWith: aPen clipRect: inRect
    | region r clipRect |
    r := inRect.
    aPen fill: self rect color: self backColor.
    self style == #scrollbars ifTrue: [
        self displayWithBothScrollBars: aPen.
        r := inRect insetBy: 1.
        r := Rectangle
            leftTop: r leftTop
            extent: ((r extent x - self scrollBarWidth + 1)@(r extent y - self scrollBarHeight + 1)).
        r := r intersect: inRect.
     ] ifFalse: [ self style == #verticalScrollBar ifTrue: [
        self displayWithLeftScrollBar: aPen.
        r := inRect insetBy: 1.
        r := Rectangle
            leftTop: r leftTop
            extent: ((r extent x - self scrollBarWidth + 1)@(r extent y)).
        r := r intersect: inRect.
    ] ifFalse: [ self style == #borders ifTrue: [
        self displayWith: aPen.
        r := inRect insetBy: 1.
    ]]].
    self children do: [ :child |
        child reframe: self rect.
        (r intersects: child rect) ifTrue: [
            region := aPen setClipRect: (clipRect := r intersect: child rect).
            child displayWith: aPen clipRect: clipRect.
            aPen destroyRegion: region.
        ].
    ].!  
initialFraming

    ^initialFraming!
initialFraming: aFramingParameter

    initialFraming := aFramingParameter! 
isCompositePane

    ^true! 
realClass: aClass
    | temp convertor |
    super realClass: aClass.
    temp := aClass new.
    temp addSubpanes.
    self initialFraming: temp framingBlock deepCopy.
    temp backColor notNil ifTrue: [
        (self backColor = self defaultBackColor) ifTrue: [
            self backColor: temp backColor.
        ].
        self defaultBackColor: temp backColor.
    ] ifFalse: [
        self defaultBackColor: (self getSysColor: ColorWindow).
        self backColor: (self getSysColor: ColorWindow)
    ].
    self extent: self defaultSize.

    convertor := WBRealLayoutPane basicNew.
    self children: (convertor convertView: temp realClass: aClass) children.
    self children do: [ :child | child parent: self ].! 
storeColorOn: aStream indentString: indentString! 
storeContentsOn: aStream indentString: spaceString

    "Added by Ale for add of subpanes when the events has been assigned yet...
    Implemented by Ale..."
    #addedByOStyle.
    aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'addSubpanes'.

    ^super storeContentsOn: aStream indentString: spaceString! 
storeSpecificsOn: aStream indentString: indentString
    "Touched By Ale..."
    #modifiedByOStyle.
    super storeColorOn: aStream indentString: indentString.
    " Patched by Ale for add of subpanes when events yet assigned...
      The commented code will be placed in storeContentsOn:indentString: methods...
    aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'addSubpanes'
    "!   
styles

    ^#(defaultStyle borders scrollbars verticalScrollBar)!  
suggestedSize

    self initialFraming isNil ifTrue: [
        ^100@100
    ] ifFalse: [
        ^(self initialFraming value: Display boundingBox) extent
    ].!   
usesFont

    ^false!   
usesForeColor

    ^false!  
usesMenu

    ^false! !

! PCPSubPane class methods ! 
exampleFrom: aClassName

    | e  |

    e := self basicNew.

    e realClass:  (Smalltalk at: aClassName asSymbol ifAbsent: [ SubPane ] ).
    e
        rect: (0@0 extent: 0@0);
        handlers: IdentityDictionary new;
        framingBlock: (FramingParameters new lDU: 0 r: #left; tDU: 0 r: #top);
        foreColor: e defaultForeColor;
        backColor: e defaultBackColor.


    e usesTitle ifTrue: [
        e contents: aClassName.
    ].

    e style: e defaultStyle;
        font: e defaultFont;
        extent: e defaultSize.

    ^e! !

! PCPSubPane methods !
attributeEditor

    (realPane respondsTo: #attributeEditor) ifTrue: [
        ^realPane attributeEditor
    ].!  
backColor: f

    super backColor: f.
    realPane backColor: f!   
changesSize

    (realPane respondsTo: #changesSize) ifTrue: [
        ^realPane changesSize
    ].

    ^super changesSize!
contents: f

    super contents: f.
    realPane notNil ifTrue: [
        realPane contents: f
    ].!   
copySpecificsTo: aPane

    (realPane respondsTo: #copySpecificsTo:) ifTrue: [
        ^realPane copySpecificsTo: aPane realPane
    ].

    ^super copySpecificsTo: aPane! 
defaultBackColor

    (realPane respondsTo: #defaultBackColor) ifTrue: [
        ^realPane defaultBackColor
    ].

    ^super defaultBackColor!
defaultFont

   "OSI 1/22/92 - used the stored system font"
    ^PWindowBuilder wbDefaultFont
    "(realPane respondsTo: #defaultFont) ifTrue: [
        ^realPane defaultFont
    ].
    ^super defaultFont"! 
defaultForeColor

    (realPane respondsTo: #defaultForeColor) ifTrue: [
        ^realPane defaultForeColor
    ].

    ^super defaultForeColor!
defaultSize

    (realPane respondsTo: #defaultSize) ifTrue: [
        ^realPane defaultSize
    ].

    ^super defaultSize!
displayWith: aPen clipRect: clipRect

    aPen font: self font.
    realPane reframeIfNeeded: rect.
    realPane displayWith: aPen inRect: rect clipRect: clipRect.!  
font: f

    super font: f.
    realPane font: f!  
foreColor: f

    super foreColor: f.
    realPane foreColor: f!   
fullCopyTo: p

    p realPane: realPane.
    super fullCopyTo: p.
    p usesContents ifTrue: [
        p contents: self contents.
    ].
    p parent: realPane parent.!   
generateTabStopsAndGroups

    (realPane respondsTo: #generateTabStopsAndGroups ) ifTrue: [
        ^realPane generateTabStopsAndGroups
    ].

    ^super generateTabStopsAndGroups!   
hasOtherEditor

    ^(realPane respondsTo: #attributeEditor)
    and: [ realPane attributeEditor notNil ]! 
isGroupable

    (realPane respondsTo: #isGroupable) ifTrue: [
        ^realPane isGroupable
    ].

    ^super isGroupable!
maxSize

    (realPane respondsTo: #maxSize) ifTrue: [
        ^realPane maxSize
    ].

    ^super maxSize!
minSize

    (realPane respondsTo: #minSize) ifTrue: [
        ^realPane minSize
    ].

    ^super minSize!
mutateSpecificsFrom: aPane

    (realPane respondsTo: #mutateSpecificsFrom:) ifTrue: [
        (aPane respondsTo: #realPane) ifTrue: [
            ^realPane mutateSpecificsFrom: aPane realPane
        ] ifFalse: [
            ^realPane mutateSpecificsFrom: aPane
        ].
    ].

    ^super mutateSpecificsFrom: aPane!
mutationExceptions

    (realPane respondsTo: #mutationExceptions) ifTrue: [
        ^realPane mutationExceptions
    ].

    ^super mutationExceptions!
mutationRotationList

    (realPane respondsTo: #mutationRotationList) ifTrue: [
        ^realPane mutationRotationList
    ].

    ^super mutationRotationList!
mutationTypes

    (realPane respondsTo: #mutationTypes) ifTrue: [
        ^realPane mutationTypes
    ].

    ^super mutationTypes!
parent: anInterfaceObject

    super parent: anInterfaceObject.
    realPane parent: anInterfaceObject.!   
readSpecificsFrom: c

    (realPane respondsTo: #readSpecificsFrom:) ifTrue: [
        realPane readSpecificsFrom: c.
        ^(realPane respondsTo: #cpStyle) ifTrue: [
            style := realPane cpStyle
        ]
    ].

    ^super readSpecificsFrom: c!
realClass: c

    super realClass: c.
    self realPane: c pObject.
    (c canUnderstand: #contents) ifTrue: [
        self contents isNil ifFalse: [
            self contents: self contents
        ].
    ].! 
realPane

    ^realPane!
realPane: p

    realPane := p.
    realPane font: self defaultFont.!  
staysToBack

    (realPane respondsTo: #staysToBack) ifTrue: [
        ^realPane staysToBack
    ].

    ^super staysToBack!
storeColorOn: aStream indentString: indentString

    (ColorConstants includes: foreColor) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'foreColor: ', (ColorConstants keyAtValue: foreColor).
    ].
    (ColorConstants includes: self realBackColor) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'backColor: ', (ColorConstants keyAtValue: self realBackColor).
    ].!   
storeSpecificsOn: aStream indentString: aString

    (realPane respondsTo: #storeSpecificsOn:indentString:) ifTrue: [
        ^realPane storeSpecificsOn: aStream indentString: aString
    ].

    ^super storeSpecificsOn: aStream indentString: aString! 
style: f

    super style: f.
    f notNil ifTrue: [
        realPane perform: f.
    ].!
styles

    (realPane respondsTo: #styles) ifTrue: [
        ^realPane styles
    ].

    ^super styles!
suggestedSize

    (realPane respondsTo: #suggestedSize) ifTrue: [
        realPane rectanglePrivate: rect.
        ^realPane suggestedSize
    ].

    ^super suggestedSize!  
usesColor

    (realPane respondsTo: #usesColor) ifTrue: [
        ^realPane usesColor
    ].

    ^super usesColor!
usesContents

    (realPane respondsTo: #usesContents) ifTrue: [
        ^realPane usesContents
    ].

    ^false! 
usesFocus

    (realPane respondsTo: #usesFocus) ifTrue: [
        ^realPane usesFocus
    ].

    ^super usesFocus!
usesFont

    (realPane respondsTo: #usesFont) ifTrue: [
        ^realPane usesFont
    ].

    ^super usesFont!
usesForeColor

    (realPane respondsTo: #usesForeColor) ifTrue: [
        ^realPane usesForeColor
    ].

    ^super usesForeColor!
usesMenu

    (realPane respondsTo: #usesMenu) ifTrue: [
        ^realPane usesMenu
    ].

    ^super usesMenu!
usesTitle

    (realPane respondsTo: #usesTitle) ifTrue: [
        ^realPane usesTitle
    ].

    ^super usesTitle! !

! PDrawnButton methods !  
attributeEditor
    "OSI 12/31/92"
    ^WBFileSelectorEditor
        titled: 'Select Bitmap File'
        filters: #('*.BMP')
        descriptions: #('Bitmap Files (*.BMP)')!   
bitmapExtent
    "OSI 12/31/92"
    | bitmap extent |
    bitmap := Bitmap fromFile: self contents.
    extent := bitmap extent.
    bitmap release.
    ^extent!   
changesSize

    ^true! 
changesTitle

    ^true!
defaultBackColor

    ^self getSysColor: ColorBtnface!  
defaultFont

    ^PWindowBuilder wbDefaultFont! 
defaultForeColor

    ^self getSysColor: ColorBtntext!  
displayWith: aPen clipRect: r

    | labelOrFileName bitmap |
    labelOrFileName := self contents.
    (self style == #invisible or: [
        labelOrFileName isNil or: [
        labelOrFileName isEmpty ]]) ifTrue: [
        ^self displayGenericWith: aPen clipRect: r
    ].
    (self fileExists: labelOrFileName)
        ifTrue: [ bitmap := Bitmap fromFile: labelOrFileName ]
        ifFalse: [
            bitmap := Bitmap
                screenWidth: self extent x
                height: self extent y.
            bitmap pen
                draw3DButton: (self justFileName: labelOrFileName)
                rect: bitmap boundingBox
                font: (self font isNil ifTrue: [ self defaultFont ] ifFalse: [ self font ])
                foreColor: self foreColor
                backColor: self realBackColor ].
    (style == #fixedSize)
        ifTrue: [
            aPen
                copyBitmap: bitmap
                    from: bitmap boundingBox
                    at: rect origin
                    rule: Srccopy]
        ifFalse: [
            aPen
                copyBitmap: bitmap
                    from: bitmap boundingBox
                    to: rect
                    rule: Srccopy].
    bitmap release.! 
fileExists: fileName

    | array file exists extension |
    (fileName includes: $*) ifTrue: [ ^false ].
    array := File splitPath: fileName in: Disk.
    ((file := array at: 3) includes: $.) ifFalse: [ ^false ].
    exists := ((file ~= '.') and: [ (file ~= '..') and: [ File exists: fileName ]]).
    exists ifTrue: [
        file := file asStream.
        extension := (file skipTo: $.; upTo: $.) asUpperCase.
        extension = 'BMP' ifTrue: [ ^true ]].
    ^false!   
importantEvents

    ^super importantEvents
        addFirst: #clicked;
        yourself! 
isGroupable

    ^true! 
justFileName: pathName
    | fileName |
    fileName := (File splitPath: pathName in: Disk) at: 3.
    (fileName occurrencesOf: $.) = 1 ifTrue: [
        ^fileName upTo: $.
    ] ifFalse: [
        ^fileName
    ]! 
minSize
    "OSI 12/31/92"
    ^((style == #fixedSize) and: [ self fileExists: self contents ])
        ifTrue: [ self bitmapExtent ]
        ifFalse: [ 16@16 ]! 
mutationExceptions

    ^#(Toggle CPHorizontalPictureButton)!   
mutationTypes

    ^#(Button CPBitmapButton CPBitmapPane)!  
readSpecificsFrom: c
    "OSI 12/31/92"
    contents := c cpContents.
    contents isString ifFalse: [ contents := '' ].
    style := c cpStyle.
    style isNil ifTrue: [
        style := self styles first.
    ].! 
storeContentsOn: aStream indentString: spaceString

    (self usesTitle and: [ self contents notNil and: [ self contents notEmpty ]]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'cpContents: '.
        self contents printOn: aStream.
    ].!
styles
    ^#(fixedSize stretchToFit invisible)! 
suggestedSize

    ^(self fileExists: self contents)
        ifTrue: [ self bitmapExtent ]
        ifFalse: [ ((self font wbStringWidth: (self justFileName: self contents)) + 20) @(self font height + 14) ]!
usesColor

    ^false!  
usesTitle

    ^self style ~= #invisible!   
winClassStyle

    ^BsOwnerdraw! !

! PActionButton methods ! 
action

    ^action!
action: aString

    action := aString! 
attributeEditor

    Notifier isAltDown ifTrue: [
        ^super attributeEditor
    ] ifFalse: [
        ^WBActionEditor new
    ].!   
copySpecificsTo: aPane

    aPane
        action: self action.!
importantEvents

    ^super importantEvents
        remove: #clicked;
        yourself!   
readSpecificsFrom: c

    super readSpecificsFrom: c.
    self action: c action asString.! 
storeContentsOn: aStream indentString: spaceString

    super storeContentsOn: aStream indentString: spaceString.

    (self action notNil and: [ self action notEmpty ]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'action: #',self action
    ].! !

! PCPStaticGraphic methods ! 
displayWith: aPen clipRect: r

    | labelOrFileName bitmap |
    labelOrFileName := self contents.
    (labelOrFileName isNil or: [ labelOrFileName isEmpty ]) ifTrue: [
        ^self displayGenericWith: aPen clipRect: r
    ].
    (self fileExists: labelOrFileName)
        ifTrue: [ bitmap := Bitmap fromFile: labelOrFileName ]
        ifFalse: [
            bitmap := Bitmap
                screenWidth: self extent x
                height: self extent y.
            bitmap pen
                fill: self realBackColor;
                foreColor: self foreColor;
                backColor: self realBackColor;
                setBackMode: Transparent;
                setTextAlign: TaTop;
                font: (self font isNil ifTrue: [ self defaultFont ] ifFalse: [ self font ]);
                centerWinText: labelOrFileName at: bitmap boundingBox center ].
    (style == #fixedSize)
        ifTrue: [
            aPen
                copyBitmap: bitmap
                    from: bitmap boundingBox
                    at: rect origin
                    rule: Srccopy]
        ifFalse: [
            aPen
                copyBitmap: bitmap
                    from: bitmap boundingBox
                    to: rect
                    rule: Srccopy].
    bitmap release.!
importantEvents

    ^super importantEvents
        remove: #clicked;
        yourself!   
styles
    ^#(fixedSize stretchToFit)! !

! PLinkButton methods !  
attributeEditor

    Notifier isAltDown ifTrue: [
        ^super attributeEditor
    ] ifFalse: [
        ^WBLinkEditor new
    ].! 
copySpecificsTo: aPane

    aPane
        link: self link;
        type: self type.!  
importantEvents

    ^super importantEvents
        remove: #clicked;
        yourself!   
link

    ^link!
link: aString

    link := aString! 
readSpecificsFrom: c

    super readSpecificsFrom: c.
    self link: c link asString.
    self type: c type asString.!
storeContentsOn: aStream indentString: spaceString

    super storeContentsOn: aStream indentString: spaceString.

    (self link notNil and: [ self link notEmpty ]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'link: #',self link
    ].
    (self type notNil and: [ self type notEmpty ]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'type: #',self type
    ].!  
type

    ^type!
type: aString

    type := aString! !

! PEntryField class methods !  
exampleFrom: aClass

    | e |

    e := super exampleFrom: aClass.
    e contents: ''.

    ^e!   
styleFrom: s

    (s bitIsOn: EsPassword) ifTrue: [
        ^#password
    ].
    ^#defaultStyle! !

! PEntryField methods !   
changesSize

    ^true! 
contents: c
    (c notNil and: [ c isEmpty ])
        ifTrue: [ contents := nil ]
        ifFalse: [ super contents: c ]!  
defaultSize

    ^100 @ self suggestedSize y!   
displayWith: aPen

    | region displayContents |

    aPen
        fill: (rect insetBy: 1) color: self backColor;
        foreColor: (self getSysColor: ColorWindowframe);
        place: rect origin;
        box: rect corner.

    "Draw the initialization text"
    self contents isNil
        ifFalse: [
            displayContents := (style == #password)
                ifTrue: [ self contents copy atAllPut: $* ]
                ifFalse: [ self contents ].
            region := aPen setClipRect: (rect insetBy: 3).
            aPen
                foreColor: self foreColor;
                backColor: self backColor.
            self justification == #left ifTrue: [
                aPen
                    displayText: displayContents at: (rect insetBy: 4@4) leftTop
            ] ifFalse: [ self justification == #right ifTrue: [
                aPen
                    displayText: displayContents
                    at: ((rect insetBy: 4@4) rightTop left: (aPen stringWidthOf: displayContents))
            ] ifFalse: [
                aPen centerText: displayContents at: rect center
            ]].
            aPen destroyRegion: region.
        ].!  
framingBlock: f

    f indent: 0@0.
    super framingBlock: f.!
genReceiveWindowMessagesOn: aStream indentString: spaceString

    "Don't generate method for EntryField or ListBox - they already have it"!
importantEvents

    ^super importantEvents
        addFirst: #textChanged;
        yourself! 
justification

    ^#left!  
maxSize

    ^32000@(self suggestedSize y)! 
minSize

    ^1@ self suggestedSize y!  
mutationExceptions

    ^#(CPChildEntryField Toggle CPSpinEditor)!  
mutationTypes

    ^#(EntryField StaticText Toggle CPSpinEditor)!   
reframe: parentRect

    super reframe: parentRect.

    rect extent: ((rect extent max: self minSize) min: self maxSize)!
storeRectOn: aStream indentString: indentString

        framingBlock indent: 3@4.
        super storeRectOn: aStream indentString: indentString.! 
styles

    ^#(defaultStyle password readonly)! 
suggestedSize

    ^rect width @ (self font height + 8).!   
usesTitle

    ^true!   
winClassStyle

    ^EsAutohscroll | EsNohidesel | WsBorder! !

! PEnhancedEntryField methods !
attributeEditor

    ^WBEnhancedEntryFieldEditor new!   
autoTab

    ^autoTab ifNil: [ autoTab := false ].! 
autoTab: aBoolean

    autoTab := aBoolean! 
case

    ^case!
case: aSymbol

    case := aSymbol! 
character

    ^character!  
character: aSymbol

    character := aSymbol!   
copySpecificsTo: aPane

    aPane
        autoTab: self autoTab;
        maximumSize: self maximumSize;
        getFocus: self getFocus;
        case: self case;
        justification: self justification;
        character: self character;
        field: self field.!  
field

    ^field!  
field: aSymbol

    field := aSymbol!   
getFocus

    getFocus isNil ifTrue: [ getFocus := #selectAll ].
    ^getFocus!
getFocus: aSymbol

    getFocus := aSymbol! 
justification

    justification isNil ifTrue: [ justification := #left ].
    ^justification! 
justification: aSymbol

    justification := aSymbol!   
maximumSize

    maxSize isNil ifTrue: [ maxSize := 0 ].
    ^maxSize! 
maximumSize: anInteger

    maxSize := anInteger!   
readSpecificsFrom: c

    self
        autoTab: c isAutoTab;
        maximumSize: c maxSize;
        getFocus: c getFocus;
        case: c case;
        justification: c justification;
        character: c character;
        field: c field.!
storeSpecificsOn: aStream indentString: indentString

    self maximumSize == 0 ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'maxSize: ', self maximumSize asString ].
    self getFocus == #selectAll ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'getFocus: #', self getFocus asString ].
    self case notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'case: #', self case asString ].
    self character notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'character: #', self character asString ].
    self field notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'field: #', self field asString ].
    self justification == #left ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, self justification asString ].
    self autoTab ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'autoTab' ].! !

! PFormattedEntryField methods !   
styles

    ^#( acceptAlpha acceptDate acceptDollar acceptFloat acceptInteger acceptPhoneNumber acceptPositiveInteger )! !

! PEntryFieldGroup methods !  
addSubpanes

    | numRows labelWidth fieldHeight scrollWidth vertOffset lowest |

    self children: nil.
    self font isNil ifTrue: [ self font: self defaultFont ].
    labelWidth := (self contents inject: 0 into: [ :max :item | max max: (self font wbStringWidth: item) ]) + 8.
    fieldHeight := self font height + 8.
    self style == #verticalScrollBar ifTrue: [
        scrollWidth := self scrollBarWidth
    ] ifFalse: [
        scrollWidth := 0
    ].
    self style == #defaultStyle ifTrue: [
        vertOffset := self font height + 2.
        self children add: (
            PGroupBox new
                framingBlock: ( FramingParameters new iDUE: self rect extent; lP: 0; rP: 1; tP: 0; bP: 1);
                paneName: 'group';
                contents: self label;
                realClass: GroupBox;
                yourself).
    ] ifFalse: [
        vertOffset := 0.
    ].

    lowest := 0.
    numRows := self contents size max: 1.
    1 to: numRows do: [ :row |
            row > self contents size ifFalse: [
                self children add: (
                   PStaticText new
                        framingBlock: ( FramingParameters new
                            left: 2 relativeTo: #left;
                            right: 2 + labelWidth relativeTo: #left;
                            top: 10 + vertOffset + ((fieldHeight + 4) * (row - 1)) relativeTo: #top;
                            bottom: 2 + vertOffset + ((fieldHeight + 4) * row) relativeTo: #top);
                        style: #rightJustified;
                        contents: (self contents at: row),':';
                        realClass: StaticText;
                        yourself).
                self children add: (
                   self fieldPClass new
                        framingBlock: ( FramingParameters new
                            left: 6 + labelWidth relativeTo: #left;
                            right: 4 + scrollWidth relativeTo: #right;
                            top: 6 + vertOffset + ((fieldHeight + 4) * (row - 1)) relativeTo: #top;
                            bottom: (lowest := 2 + vertOffset + ((fieldHeight + 4) * row)) relativeTo: #top;
                            indent: 3 @ 4);
                        paneName: (self contents at: row);
                        realClass: self fieldClass;
                        yourself).
           ].
    ].
    self contents size > 0 ifTrue: [ self bestSize y: lowest + 4 ].

    self foreColor: self foreColor.
    self backColor: self realBackColor.!  
attributeEditor

    ^WBListEditor new! 
backColor: aColor

    super backColor: aColor.
    self children do: [ :child | child backColor: aColor ].!   
bestSize

    ^bestSize ifNil: [ bestSize := 250@100 ]! 
children

    ^children ifNil: [ children := OrderedCollection new ].!  
children: aCollection

    children := aCollection! 
contents

    ^contents ifNil: [ contents := #() ].!
contents: aCollection

    super contents: (aCollection isDictionary
        ifTrue: [ aCollection keys asOrderedCollection asArray ]
        ifFalse: [ aCollection asArray ]).

    self addSubpanes.!
copySpecificsTo: aPane

    aPane
        label: self label;
        contents: self contents.!
defaultFont

    ^PWindowBuilder wbDefaultFont! 
defaultSize

    ^self bestSize!
displayWith: aPen clipRect: inRect
    | region r clipRect |
    r := inRect.
    aPen fill: self rect color: self backColor.

    self style == #verticalScrollBar ifTrue: [
        self displayWithLeftScrollBar: aPen.
        r := inRect insetBy: 1.
        r := Rectangle
            leftTop: r leftTop
            extent: ((r extent x - self scrollBarWidth + 1)@(r extent y)).
        r := r intersect: inRect.
    ].

    self children do: [ :child |
        child reframe: self rect.
        region := aPen setClipRect: (clipRect := r intersect: child rect).
        child displayWith: aPen clipRect: clipRect.
        aPen destroyRegion: region.
    ].!
fieldClass

    ^WBEntryField!  
fieldPClass

    ^PEntryField!  
foreColor: aColor

    super foreColor: aColor.
    self children do: [ :child | child foreColor: aColor ].!   
isComposite

    ^true! 
label

    ^label ifNil: [ label := 'EntryFieldGroup' ]!
label: aString

    | gb |

    label := aString.

    self children isEmpty ifFalse: [
        gb := self children detect: [ :child | child isKindOf: PGroupbox] ifNone: [nil].
        gb isNil ifFalse: [ gb contents: aString ]
    ].!  
mutateSpecificsFrom: aPane
    | list |
    ((list := aPane contents) notNil and: [ list isArray | list isDictionary ]) ifTrue: [
        self contents: list deepCopy
    ].
    (aPane respondsTo: #label) ifTrue: [
        self label: aPane label
    ].! 
mutationExceptions

    ^#(CPScrollingPane)!
mutationTypes

    ^#(ListBox CPScrollingPane RadioButtonGroup EntryFieldGroup)!
readSpecificsFrom: c

    self
        label: c label;
        style: c cpStyle;
        contents: c list.

    self style isNil ifTrue: [ self style: self styles first ].!   
storeContentsOn: aStream indentString: spaceString!   
storeSpecificsOn: aStream indentString: indentString
    "Write out the list"
    self label isEmpty ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'label: ',self label asQuotedString
    ].
    super storeStyleOn: aStream indentString: indentString.
    self contents isNil ifFalse: [
        (self contents isArray and: [ self contents notEmpty ]) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'contents: #( '.
                self contents do:[ :item | aStream nextPutAll: item asQuotedString,' ' ].
                aStream nextPutAll: ')'
        ]
    ].!
storeStyleOn: aStream indentString: spaceString!  
style: aSymbol

    super style: aSymbol.
    self addSubpanes.!   
styles

    ^#(defaultStyle noGroupBox verticalScrollBar)!  
suggestedSize

    ^(self rect width) @ (self bestSize y)!  
text

    ^self label!  
text: aString

    ^self label: aString!
usesFont

     ^false!  
usesMenu

     ^false!  
usesTitle

    ^true! !

! PGenericSubpane methods !  
displayWith: aPen clipRect: r

    self displayGenericWith: aPen clipRect: r!   
realClass: aClass

    realClass := aClass.
    self style: self defaultStyle.!
usesFocus

   ^false! !

! PGraphPane class methods ! 
styleFrom: s

    (s bitIsOn: WsBorder) ifFalse: [
        ^#noBorders
    ] ifTrue: [
        (s bitIsOn: WsHscroll) ifFalse: [
            ^#noScrollBars
        ] ifTrue: [
            ^#defaultStyle
        ].
    ].! !

! PGraphPane methods !   
backColor

    ^ClrWhite!   
displayWith: aPen

    aPen fill: self backColor.
    (style == #noBorders) ifTrue: [
        ^self
    ].
    super displayWith: aPen.

    (style == #noScrollBars) ifTrue: [
        ^self
    ].

    self displayWithBothScrollBars: aPen.!  
mutationExceptions

    ^#(FreeDrawPane)!   
mutationTypes

    ^#(GraphPane)!   
removeEvents

    ^#().!
styles

    ^#(defaultStyle noScrollBars noBorders)!
usesFocus

    ^false! !

! PTextPane methods !   
defaultFont

    ^PWindowBuilder wbDefaultFont
    "^TextFont"!
mutationExceptions

    ^#(CPChildEntryField Toggle CPSpinEditor)!  
mutationTypes

    ^#(EntryField StaticText Toggle CPSpinEditor)!   
usesFocus

    ^true! !

! PGroupbox methods !
contents
    contents isNil ifTrue: [ contents := '' ].
    ^contents!  
displayWith: aPen

    | top textRect bottom |

    top := rect top down: self font height // 2.
    bottom := rect bottom up: 1.
    aPen font: font.
    textRect := (rect leftTop rightAndDown: 7 @ 3) extent: (font wbStringWidth: self contents) @ self font height.

    aPen
        lineFrom: rect left @ top to: rect left @ bottom;
        lineFrom: (rect right left: 1) @ top to: (rect right left: 1) @ bottom;
        lineFrom: rect left @ bottom to: rect right @ bottom;
        lineFrom: rect left @ top to: (rect left right: 5) @ top;
        lineFrom: (rect left right: ((aPen stringWidthOf: self contents) + 12)) @ top to: rect right @ top.

    aPen
        foreColor: foreColor;
        backColor: self backColor;
        setTextAlign: TaTop;
        winDrawText: self contents at: textRect leftTop.!   
mutationTypes

    ^#(GroupBox CP3DFrame StaticBox)!
staysToBack

    ^true! 
usesMenu

    ^false!   
usesTitle

    ^true!   
winClassStyle

    ^BsGroupbox! !

! PListBox class methods ! 
styleFrom: s

    (s bitIsOn: LbsOwnerdrawfixed) ifTrue: [
        ^#ownerDrawFixed
    ].
    (s bitIsOn: LbsOwnerdrawvariable) ifTrue: [
        ^#ownerDrawVariable
    ].

    ^#defaultStyle! !

! PListBox methods ! 
attributeEditor

    ^WBListEditor new! 
copySpecificsTo: aPane

    aPane contents: self contents.! 
defaultFont

    ^PWindowBuilder wbDefaultFont
    "^ListFont"!
displayWith: aPen
    | list newPoint region |
    self displayWithLeftScrollBar: aPen.

    "Draw the list contents"
    list := self contents.
    list isNil
        ifFalse: [
            aPen
                foreColor: self foreColor;
                backColor: self backColor;
                font: self font.
            region := aPen setClipRect:
                ((rect insetBy: 1@1) expandBy: (0@0 extent: self scrollBarWidth negated@0)).
            newPoint := (rect insetBy: 3@1) leftTop.
            1 to: list size do: [ :i |
                aPen displayText: (list at: i) at: newPoint.
                newPoint := newPoint down: aPen font height ].
            aPen destroyRegion: region].!   
genReceiveWindowMessagesOn: aStream indentString: spaceString

    "Don't generate method for EntryField or ListBox - they already have it"!
importantEvents

    ^super importantEvents
        addFirst: #doubleClickSelect;
        addFirst: #select;
        yourself!   
mutateSpecificsFrom: aPane
    | list |
    ((list := aPane contents) notNil and: [ list isArray ]) ifTrue: [
        self contents: list deepCopy
    ].!
mutationExceptions

    ^#(CPScrollingPane)!
mutationTypes

    ^#(ListBox CPScrollingPane RadioButtonGroup)!
pmClassStyle

    ^LbsNotify | LbsNointegralheight! 
storeSpecificsOn: aStream indentString: indentString
    "Write out the list"
    self contents isNil ifFalse: [
        (self contents isArray and: [ self contents notEmpty ]) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'contents: #( '.
                self contents do:[ :item | aStream nextPutAll: item asQuotedString,' ' ].
                aStream nextPutAll: ')' ] ].!  
styles

    ^#(defaultStyle ownerDrawFixed ownerDrawVariable)!  
winUserStyle

    style == #defaultStyle ifFalse: [
        style == #ownerDrawFixed ifTrue: [
            ^LbsOwnerdrawfixed
        ] ifFalse: [
            ^LbsOwnerdrawvariable
        ].
    ].

    ^0! !

! PCPHierarchicalListBox class methods !   
exampleFrom: aClass

    | p |

    p := super exampleFrom: aClass.
    p
        nameMethod: p defaultNameMethod;
        childrenMethod: p defaultChildrenMethod;
        iconMethod: p defaultIconMethod.

    ^p! !

! PCPHierarchicalListBox methods !   
attributeEditor

    ^WBHierarchicalListBoxEditor  new! 
childrenMethod

    ^childrenMethod!
childrenMethod: anObject

    childrenMethod := anObject!   
copySpecificsTo: aPane

    aPane
        nameMethod: self nameMethod;
        childrenMethod: self childrenMethod;
        iconMethod: self iconMethod.!
defaultChildrenMethod

    ^nil!
defaultIconMethod

    ^nil!
defaultNameMethod

    ^#printString!   
iconMethod

    ^iconMethod!
iconMethod: anObject

    iconMethod := anObject!   
mutateSpecificsFrom: aPane!   
nameMethod
    nameMethod isNil ifTrue: [ nameMethod := self defaultNameMethod ].
    ^nameMethod!  
nameMethod: anObject

    nameMethod := anObject!   
readSpecificsFrom: c

    c copySpecificsTo: self.! 
storeSpecificsOn: aStream indentString: indentString

    self nameMethod = self defaultNameMethod ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'nameMethod: #', self nameMethod.
    ].

    self childrenMethod = self defaultChildrenMethod ifFalse:  [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'childrenMethod: #', self childrenMethod.
    ].

    self iconMethod = self defaultIconMethod ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'iconMethod: #', self iconMethod.
    ].! !

! POSHierarchicalListBox methods ! 
attributeEditor

    ^(Smalltalk at: #OSHierarchicalListBoxEditor)  new!
copySpecificsTo: aPane

    super copySpecificsTo: aPane.
    aPane indentWidth: self indentWidth.!
defaultIndentWidth

    ^3! 
indentWidth
    "Returns the instance var of the receiver
     for external manipulation"
    indentWidth isNil ifTrue: [^self defaultIndentWidth].
    ^indentWidth! 
indentWidth: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    indentWidth := anObject!   
storeSpecificsOn: aStream indentString: indentString


    self nameMethod = self defaultNameMethod ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'nameMethod: ', self nameMethod.
    ].

    self childrenMethod = self defaultChildrenMethod ifFalse:  [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'childrenMethod: ', self childrenMethod.
    ].

    self iconMethod = self defaultIconMethod ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'iconMethod: ', self iconMethod.
    ].


    self indentWidth = self defaultIndentWidth ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'indentWidth: ', self indentWidth asString.
    ].! !

! PListPane methods !
styles

    ^nil! !

! PMultipleSelectListBox methods !   
winClassStyle

    ^super pmClassStyle | LbsMultiplesel! !

! PRadioButtonGroup methods ! 
addSubpanes
    | extent numRows index rb fontHeight inset inner |
    fontHeight := (SysFont height + 6) / (SysFont height / 32).
    self children: nil.
    self children add: (
        PGroupBox new
            framingBlock: ( FramingParameters new iDUE: self rect extent; lP: 0; rP: 1; tP: 0; bP: 1);
            paneName: 'group';
            contents: self label;
            realClass: GroupBox;
            yourself).
    inset := 8 @ fontHeight.
    inner := self rect extent - inset.
    numRows := ((self contents size +  self numColumns - 1) // self numColumns) max: 1.
    extent := (inner x // numColumns) @ fontHeight.
    1 to: self numColumns do: [ :column |
        1 to: numRows do: [ :row |
            index := (column - 1) * numRows + row.
            index > self contents size ifFalse: [
                self children add: (
                   rb := self buttonPClass new
                        framingBlock: ( FramingParameters new
                            iDUE: extent;
                            lP: ((column - 1) / self numColumns) * 0.9 + (((self numColumns - column + 1) / self numColumns) * 0.1);
                            rP: (column / self numColumns) * 0.9 + (((self numColumns - column) / self numColumns) * 0.1);
                            tDU: inset y + ((row - 1) * extent y) r: #top;
                            bDU: inset y + (row * extent y) r: #top);
                        when: #clicked perform: #setRadio:;
                        contents: (self contents at: index);
                        paneName: (self contents at: index);
                        realClass: self buttonClass;
                        yourself).
           ].
        ].
    ].
    self foreColor: self foreColor.
    self backColor: self realBackColor.!   
attributeEditor

    ^WBListEditor new! 
backColor: aColor

    super backColor: aColor.
    aColor = self defaultForeColor ifTrue: [
        self children do: [ :child | child foreColor: child defaultForeColor ]
    ] ifFalse: [
        self children do: [ :child | child backColor: aColor ]
    ].!
buttonClass

    ^RadioButton!  
buttonPClass

    ^PRadioButton!
children

    ^children ifNil: [ children := OrderedCollection new ].!  
children: aCollection

    children := aCollection! 
contents: aCollection

    super contents: aCollection.

    numColumns isNil ifTrue: [ ^nil ].
    self addSubpanes.!   
copySpecificsTo: aPane

    aPane
        label: self label;
        contents: self contents.!
defaultFont

    ^PWindowBuilder wbDefaultFont! 
displayWith: aPen clipRect: inRect
    | region r clipRect |
    r := inRect.
    aPen fill: self rect color: self backColor.

    self style == #verticalScrollBar ifTrue: [
        self displayWithLeftScrollBar: aPen.
        r := inRect insetBy: 1.
        r := Rectangle
            leftTop: r leftTop
            extent: ((r extent x - self scrollBarWidth + 1)@(r extent y)).
        r := r intersect: inRect.
    ].

    self children do: [ :child |
        child reframe: self rect.
        region := aPen setClipRect: (clipRect := r intersect: child rect).
        child displayWith: aPen clipRect: clipRect.
        aPen destroyRegion: region.
    ].!
foreColor: aColor

    super foreColor: aColor.
    aColor = self defaultForeColor ifTrue: [
        self children do: [ :child | child foreColor: child defaultForeColor ]
    ] ifFalse: [
        self children do: [ :child | child foreColor: aColor ]
    ].!
initialize

    super initialize.
    self
        numColumns: 1.!
isComposite

    ^true! 
label

    ^label ifNil: [ label := 'RadioButtonGroup' ]!   
label: aString

    label := aString.

    self children isEmpty ifFalse: [
        self children first contents: aString
    ]!
mutateSpecificsFrom: aPane
    | list |
    ((list := aPane contents) notNil and: [ list isArray ]) ifTrue: [
        self contents: list deepCopy
    ].
    (aPane respondsTo: #label) ifTrue: [
        self label: aPane label
    ].! 
mutationExceptions

    ^#(CPScrollingPane)!
mutationTypes

    ^#(ListBox CPScrollingPane RadioButtonGroup EntryFieldGroup)!
numColumns

    ^numColumns ifNil: [ numColumns := 1 ]! 
numColumns: anInteger

    numColumns := anInteger.

    style := anInteger asString, ' Column'.

    numColumns isNil ifTrue: [ ^nil ].
    self addSubpanes.!
readSpecificsFrom: c

    self
        label: c label;
        numColumns: c numColumns;
        contents: c contents.!  
reframe: parentRect

    super reframe: parentRect.

    self addSubpanes.!   
setStyleFrom: aRealStyle! 
storeContentsOn: aStream indentString: spaceString!   
storeSpecificsOn: aStream indentString: indentString
    "Write out the list"
    self label isEmpty ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'label: ',self label asQuotedString
    ].
    self numColumns > 1 ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'numColumns: ',self numColumns asString
    ].
    self contents isNil ifFalse: [
        (self contents isArray and: [ self contents notEmpty ]) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'contents: #( '.
                self contents do:[ :item | aStream nextPutAll: item asQuotedString,' ' ].
                aStream nextPutAll: ')'
        ]
    ].!  
storeStyleOn: aStream indentString: spaceString!  
style: s

    super style: s.
    self numColumns: s first asString asInteger.!
styles

    ^(1 to: 9) collect: [ :int | int asString,' Column' ].! 
suggestedSize

    ^150@100!
text

    ^self label!  
text: aString

    ^self label: aString!
usesFont

     ^false!  
usesMenu

     ^false!  
usesTitle

    ^true! !

! PCheckBoxGroup methods !   
buttonClass

    ^CheckBox! 
buttonPClass

    ^PCheckBox!   
label

    ^label ifNil: [ label := 'CheckBoxGroup' ]! !

! PScrollBar class methods !
defaultRealClassName

    ^'ScrollBar'.! !

! PScrollBar methods !
attributeEditor

    ^WBScrollBarEditor new!
copySpecificsTo: aPane

    aPane
        minimum: self minimum;
        maximum: self maximum;
        lineIncrement: self lineIncrement;
        pageIncrement: self pageIncrement.!  
initialize

    super initialize.
    self
        minimum: 0;
        maximum: 100;
        lineIncrement: 1;
        pageIncrement: 24.! 
lineIncrement

    ^lineIncrement!  
lineIncrement: i

    lineIncrement := i!   
maximum

    ^maximum!  
maximum: m

    maximum := m!   
minimum

    ^minimum!  
minimum: m

    minimum := m!   
mutateSpecificsFrom: aPane

    (aPane respondsTo: #realPane) ifTrue: [
        (aPane realPane respondsTo: #min) ifTrue: [
            self minimum: aPane realPane min
        ].
        (aPane realPane respondsTo: #max) ifTrue: [
            self maximum: aPane realPane max
        ].
        ^nil
    ].

    (aPane respondsTo: #minimum) ifTrue: [
        self minimum: aPane minimum
    ].
    (aPane respondsTo: #maximum) ifTrue: [
        self maximum: aPane maximum
    ].
    (aPane respondsTo: #pageIncrement) ifTrue: [
        self pageIncrement: aPane pageIncrement
    ].
    (aPane respondsTo: #lineIncrement) ifTrue: [
        self lineIncrement: aPane lineIncrement
    ].!  
mutationExceptions

    ^#(CPValuator CPGauge CPSlider)!
mutationTypes

    ^#(CPValuator ScrollBar)!
pageIncrement

    ^pageIncrement!  
pageIncrement: i

    pageIncrement := i!   
readSpecificsFrom: c

    self
        minimum: c minimum;
        maximum: c maximum;
        lineIncrement: c lineIncrement;
        pageIncrement: c pageIncrement.! 
realClassName

    ^'ScrollBar'!
scrollBarColor

    ^self backColor!
storeSpecificsOn: aStream indentString: indentString

    self minimum = 0 ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'minimum: ', self minimum asString.
    ].

    self maximum = 100 ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'maximum: ', self maximum asString.
    ].

    self lineIncrement = 1 ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'lineIncrement: ', self lineIncrement asString.
    ].

    self pageIncrement = 24 ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'pageIncrement: ', self pageIncrement asString.
    ].! !

! PWBHorizontalScrollBar methods !  
defaultSize

    ^100 @ self suggestedSize y!   
displayWith: aPen

    self drawHScrollBarWith: aPen at: rect.! 
mutationRotationList

    ^#(WBVerticalScrollBar CPVerticalBarGauge CPVerticalSlider)!  
storeSpecificsOn: aStream indentString: indentString

    super storeSpecificsOn: aStream indentString: indentString.

    aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'horizontal'.!  
suggestedSize

    ^self extent x@17!   
winClassStyle

    ^SbsHorz! !

! PWBVerticalScrollBar methods !  
defaultSize

    ^self suggestedSize x@100! 
displayWith: aPen

    self drawVScrollBarWith: aPen at: rect.! 
mutationRotationList

    ^#(WBHorizontalScrollBar CPHorizontalBarGauge CPHorizontalSlider)!
storeSpecificsOn: aStream indentString: indentString

    super storeSpecificsOn: aStream indentString: indentString.

    aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'vertical'.!
suggestedSize

    ^17@self extent y!   
winClassStyle

    ^SbsVert! !

! PStaticBox class methods !  
exampleFrom: aClassName

    | e |

    e := super exampleFrom: aClassName.
    e style: #grayRectangle;
        font: e defaultFont;
        extent: e suggestedSize.

    ^e!  
styleFrom: s

    | symbolStyles frameStyle |

    frameStyle := s bitAnd: 15.
    symbolStyles := Dictionary new.
    symbolStyles
        at: SsWhiterect put: #whiteRect;
        at: SsWhiteframe put: #whiteFrame;
        at: SsBlackframe put: #blackFrame;
        at: SsBlackrect put: #blackRectangle;
        at: SsGrayrect put: #grayRectangle;
        at: SsGrayframe put: #grayFrame.

    ^symbolStyles at: frameStyle ifAbsent: [ #blackFrame ].! !

! PStaticBox methods ! 
defaultForeColor

    ^nil! 
defaultStyle

    ^#whiteRectangle! 
displayWith: aPen

    | c |


    style first = $w ifTrue: [
        c := (self getSysColor: ColorWindow).
    ] ifFalse: [
        style first = $b ifTrue: [
            c := (self getSysColor: ColorWindowframe).
        ] ifFalse: [
            c := (self getSysColor: ColorBackground)
        ].
    ].


    (style at: style size - 1) = $m ifTrue: [
        aPen
            foreColor: c;
            drawRectangle: rect.
    ] ifFalse: [
        aPen fill: rect color: c.
    ].!   
mutationTypes

    ^#(GroupBox CP3DFrame StaticBox)!
readSpecificsFrom: c

    self style: c justified.! 
styles

    ^#(whiteRect whiteFrame blackFrame blackRectangle grayFrame grayRectangle)! 
suggestedSize

    ^100@100!
usesColor

    ^false!  
usesFocus

    ^false!  
usesMenu

    ^false!   
winUserStyle

    ^((OrderedCollection new
            add: SsWhiterect;
            add: SsWhiteframe;
            add: SsBlackframe;
            add: SsBlackrect;
            add: SsGrayframe;
            add: SsGrayrect;
            yourself) asArray
        at: (#(whiteRect whiteFrame blackFrame
                blackRectangle grayFrame grayRectangle) indexOf: style))! !

! PStaticGraphic methods ! 
defaultSize

    ^32@32!
displayWith: aPen clipRect: r

    self displayGenericWith: aPen clipRect: r!   
suggestedSize

    ^32@32!  
usesFocus

    ^false!  
usesMenu

    ^false! !

! PStaticText class methods !
styleFrom: s

    (s bitIsOn: SsRight) ifTrue: [
        ^#rightJustified
    ] ifFalse: [
        (s bitIsOn: SsCenter) ifTrue: [
            ^#centered
        ] ifFalse: [
            ^#leftJustified
        ].
    ].! !

! PStaticText methods !  
attributeEditor

    ^WBStaticTextEditor new!   
autoSizeFrom

    ^self style!  
changesSize

    ^true! 
changesTitle

    ^true!
defaultForeColor

    ^self getSysColor: ColorWindowtext!   
displayWith: aPen

    | just s aRect |

    aPen fill: rect color: self backColor.


    aPen
        foreColor: foreColor;
        backColor: self backColor;
        font: font.

    just :=  ((OrderedCollection new
                add: SsLeft;
                add: SsRight;
                add: SsCenter;
                yourself) asArray
               at: (#(leftJustified rightJustified centered) indexOf: style) ).

    s := contents.
    aRect := rect.

    aPen setTextAlign: TaTop.
    aPen winDrawText: s in: aRect format: just | DtWordbreak!  
mutationExceptions

    ^#(CPChildEntryField Toggle)!   
mutationTypes

    ^#(EntryField StaticText Toggle)!
styles

    ^#(leftJustified rightJustified centered)!  
suggestedSize

    | lines max s |

    lines := (self contents occurrencesOf: Lf) + 1.
    max := 0.
    s := ReadStream on: self contents.
    [ s atEnd ] whileFalse: [
        max := max max: (self font wbStringWidth: (s upTo: Lf)).
    ].

    ^(max + 5) @(lines * self font height).!   
usesMenu

    ^false!   
usesTitle

    ^true!   
winUserStyle

    ^((OrderedCollection new
            add: SsLeft;
            add: SsRight;
            add: SsCenter;
            yourself) asArray
        at: (#(leftJustified rightJustified centered) indexOf: style))! !

! PStatusPane methods !
attributeEditor

    ^WBStatusPaneEditor new!   
contents: ignore

    contents := nil!  
copySpecificsTo: aPane

    aPane statusBoxes: self statusBoxes.!   
defaultBackColor

    ^WinInfo colorButtonFace.!
defaultFont

    ^Font face:'Helv' size:(0 @ (self height - (2 * self inset))) fixedWidth:false!
defaultForeColor

    ^WinInfo colorButtonText.!
displayBox: box with: aPen

    |rcDraw  string|

    box rectangle isNil ifTrue:[^self].
    (box rectangle right isLeftEqualOf: box rectangle left)
        ifTrue:[^nil].

    rcDraw := box rectangle.
    aPen fill: ((rcDraw leftBottom leftAndUp:(0 @ 1)) rightTop: (rcDraw leftTop rightAndDown:( 1 @ 0)))
        color: WinInfo colorButtonShadow.
    aPen fill: ((rcDraw leftTop rightAndDown: (1 @ 0)) rightBottom: (rcDraw rightTop leftAndDown:( 0 @ 1)))
        color: WinInfo colorButtonShadow.
    aPen fill: ((rcDraw leftBottom rightAndUp:(0 @ 0))  rightTop: (rcDraw rightBottom leftAndUp:( 0 @ 1)))
        color: WinInfo colorButtonHighlight.
    aPen fill: ((rcDraw rightBottom leftAndUp:(1 @ 0)) rightTop: (rcDraw rightTop leftAndDown:( 2 @ 0)))
        color: WinInfo colorButtonHighlight.

    box contents isNil ifTrue:[^self].
    string := box contents isString
        ifTrue: [ box contents ]
        ifFalse: [ box contents printString ].
    rcDraw := box rectangle insetBy: (1 @ 1).
    aPen
        backColor: self realBackColor;
        foreColor: self foreColor;
        displayText: string at: (rcDraw leftBottom rightAndUp: (1 @ (aPen font height + 1)))
        clipRect: rcDraw
        options: EtoOpaque | EtoClipped.! 
displayWith: aPen

    aPen
        font: self font;
        fill: rect color: self realBackColor;
        lineFrom: rect origin to: rect rightTop;
        foreColor: ClrWhite;
        lineFrom: (rect origin down: 1) to: (rect rightTop down: 1);
        foreColor: self foreColor.

    aPen
        backColor: WinInfo colorButtonFace;
        foreColor: WinInfo colorButtonText.

    self statusBoxes do: [ :each | self displayBox: each with: aPen ].! 
framingBlock: f

    | width |
    parentWindow isNil ifTrue: [
        width := 300
    ] ifFalse: [
        width := parentWindow rect width
    ].
    framingBlock := FramingParameters new
        iDUE: width @ (self height / (SysFont height / 32));
        lDU: 0 r: #left;
        rDU: 0 r: #right;
        tDU: self height / (SysFont height / 32) r: #bottom;
        bDU: 0 r: #bottom.

    self updateBoxes! 
generateTabStopsAndGroups

    ^false!  
height

    ^WinInfo cyCaption - 1! 
inset

    ^3!  
readSpecificsFrom: c

    self statusBoxes: c contents.
    c isResizable ifTrue: [
        self style: (c justified,'Justified') asSymbol
    ] ifFalse: [
        self style: (c justified,'JustifiedFixed') asSymbol
    ].

    self updateBoxes.!   
reframe: parentRect

    super reframe: parentRect.
    self updateBoxes!  
statusBoxes

    statusBoxes isNil ifTrue: [ statusBoxes := OrderedCollection new ].
    ^statusBoxes! 
statusBoxes: aCollection

    statusBoxes := aCollection!   
staysToBack

    ^true! 
storeContentsOn: aStream indentString: indentString

    self statusBoxes isEmpty ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'contents: ('; cr.
        aStream nextPutAll: indentString, '    OrderedCollection new'; cr.
        self statusBoxes do: [ :f |
            aStream nextPutAll: indentString, '        addLast: ('; cr.
            f storeOn: aStream indentString: indentString, '            '.

            aStream cr; nextPutAll: indentString, '        )'.
            aStream nextPutAll: ';'; cr
        ].

        aStream nextPutAll: indentString, '        yourself'; cr.
        aStream nextPutAll: indentString, ')'.
    ].!  
style: aStyle

    super style: aStyle.
    self updateBoxes!  
styles

    ^#(rightJustified leftJustified rightJustifiedFixed leftJustifiedFixed)!
updateBoxes

    self style == #leftJustified ifTrue:[
        self updateBoxesLeftJustified
    ] ifFalse: [ self style == #leftJustifiedFixed ifTrue:[
        self updateBoxesLeftJustifiedFixed
    ] ifFalse: [ self style == #rightJustifiedFixed ifTrue:[
        self updateBoxesRightJustifiedFixed
    ] ifFalse:[
        self updateBoxesRightJustified
    ]]].!   
updateBoxesLeftJustified

    | xPos aRect box |
    xPos := self updateBoxesLeftJustifiedFixed.
    self statusBoxes isEmpty ifTrue: [^self].

    box := self statusBoxes last.
    xPos := xPos left: box width + 6.
    aRect := xPos @ rect top corner: (rect width left: self height - 12) @ (rect bottom down: 2).
    aRect := aRect insetBy: (0 @ self inset).
    box rectangle: aRect.!  
updateBoxesLeftJustifiedFixed

    |xPos aRect|

    xPos := rect left.
    self statusBoxes do: [ :box |
        xPos := xPos right: box space.
        aRect := xPos @ rect top corner: (xPos + box width + 6) @ (rect bottom down: 2).
        aRect := aRect insetBy: (0 @ self inset).
        box rectangle: aRect.
        xPos := xPos right: box width + 6].
    ^xPos!   
updateBoxesRightJustified

    | xPos aRect box |
    xPos := self updateBoxesRightJustifiedFixed.
    self statusBoxes isEmpty ifTrue:[^self].

    box := self statusBoxes first.
    xPos := xPos right: box space.
    xPos := xPos right: box width + 6.
    aRect := (12 + box space @ rect top) corner: xPos @ (rect bottom down: 2).
    aRect := aRect insetBy: (0 @ self inset).
    box rectangle: aRect.!  
updateBoxesRightJustifiedFixed

    |xPos aRect|

    xPos := rect right - self height.
    self statusBoxes reverseDo: [ :box |
        xPos := xPos left: box width + 6.
        aRect := xPos @ rect top corner: (xPos + box width + 6) @ (rect bottom down: 2).
        aRect := aRect insetBy: (0 @ self inset).
        box rectangle: aRect.
        xPos := xPos left: box space].
    ^xPos!  
usesFocus

    ^false!  
usesFraming

    ^false! !

! PTextEdit class methods !   
styleFrom: s

    (s bitIsOn: WsBorder) ifFalse: [
        ^#noBorders
    ] ifTrue: [
        (s bitIsOn: WsHscroll) ifTrue: [
            ^#scrollBars
        ] ifFalse: [ (s bitIsOn: WsVscroll) ifTrue: [
            ^#wordWrap
        ] ifFalse: [
            ^#defaultStyle
        ]].
    ].! !

! PTextEdit methods !  
defaultFont

    ^PWindowBuilder wbDefaultFont
    "^TextFont"!
displayWith: aPen

    aPen fill: self backColor.
    (style == #noBorders) ifTrue: [
        ^self
    ].
    super displayWith: aPen.

    (style == #scrollBars) ifTrue: [
        self displayWithBothScrollBars: aPen.
    ].
    (style == #wordWrap) ifTrue: [
        self displayWithLeftScrollBar: aPen.
    ].!   
importantEvents

    ^super importantEvents
        addFirst: #textChanged;
        yourself! 
mutationExceptions

    ^#(CPChildEntryField Toggle CPSpinEditor)!  
mutationTypes

    ^#(EntryField StaticText Toggle CPSpinEditor)!   
styles

    ^#(defaultStyle scrollBars noBorders wordWrap)! 
winClassStyle

    ^EsAutovscroll | EsMultiline! !

! PToggle methods !   
changesSize

    ^true! 
defaultFont

    ^PWindowBuilder wbDefaultFont
    "^SysFont"! 
defaultForeColor

    ^self getSysColor: ColorWindowtext!   
displayleftIconAt: p with: aPen

    aPen drawRectangle: (p extent: self iconExtent).!  
displayWith: aPen

    | y |

    y := (rect center y up: (self font height // 2)) down: 1.

    aPen
        fill: rect color: self backColor;
        foreColor: foreColor;
        backColor: self backColor;
        font: font;
        setTextAlign: TaTop;
        winDrawText: contents at: (rect left right: self iconExtent x + 4) @ y.

    self displayleftIconAt: rect left @ y with: aPen.!   
iconExtent

    ^13@13! 
importantEvents

    ^super importantEvents
        addFirst: #clicked;
        yourself! 
isGroupable

    ^true! 
mutationExceptions

    ^#(Toggle CPHorizontalPictureButton)!   
mutationTypes

    ^#(Button CPBitmapButton)!   
suggestedSize

    ^(( self font wbStringWidth: self contents) + 20) @((self font height + 4) max: 16)! 
usesTitle

    ^true! !

! PCheckBox class methods !  
styleFrom: s

    (s bitIsOn: BsAutocheckbox) ifFalse: [
        ^#checkBox
    ] ifTrue: [
        ^#autoCheckBox
    ].! !

! PCheckBox methods !   
styles

    ^#(autoCheckBox checkBox)!  
winUserStyle

    style == #checkBox ifTrue: [
        ^BsCheckbox
    ].

    ^BsAutocheckbox! !

! PRadioButton class methods ! 
purgeCache

    RadioBitmap notNil ifTrue: [
        RadioBitmap release.
    ].
    RadioBitmap := nil.!
styleFrom: s

    (s bitIsOn: BsAutoradiobutton) ifFalse: [
        ^#radioButton
    ] ifTrue: [
        ^#autoRadioButton
    ].! !

! PRadioButton methods !   
displayleftIconAt: p with: aPen

    aPen
        place: ((p extent: self iconExtent) center down: 1);
        circle: self iconExtent // 2!  
styles

    ^#(autoRadioButton radioButton)!
winUserStyle

    style == #radioButton ifTrue: [
        ^BsRadiobutton
    ].

    ^BsAutoradiobutton! !

! PThreeStateButton class methods !   
styleFrom: s

    (s bitIsOn: BsAuto3state) ifFalse: [
        ^#threeState
    ] ifTrue: [
        ^#autoThreeState
    ].! !

! PThreeStateButton methods ! 
styles

    ^#(autoThreeState threeState)!  
winUserStyle

    style == #threeState ifTrue: [
        ^Bs3state
    ].

    ^BsAuto3state! !

! PWBInvisibleGroupPane class methods !  
defaultRealClassName

    "Never really used;  just a placeholder."

    ^'Object'! !

! PWBInvisibleGroupPane methods !
displayWith: aPen

    aPen
        drawFocusRect: self rect.! 
isGrouper

    ^true! !

! PWBToolBar methods !   
attributeEditor

    ^WBToolBarEditor new!  
cellSize

    ^cellSize ifNil: [ cellSize := self defaultCellSize ].!   
cellSize: aPoint

    cellSize := aPoint!   
changesSize

    ^true! 
copySpecificsTo: aPane

    aPane
        cellSize: self cellSize deepCopy;
        useSystem: self useSystem;
        elements: self elements deepCopy.!
defaultCellSize

    ^25 @ 22!  
displayElement: key with: aPen

    | element |

    element := self elements at: key.
    element isNil ifTrue: [ ^nil ].

    aPen
        copy: element pen
        from: element boundingBox
        to: (element rectangle translateBy: (rect leftTop right: 1)).! 
displayWith: aPen

    | just s aRect |

    aPen fill: rect color: self backColor.

    self elements isEmpty ifTrue: [
        aPen
            place: rect origin;
            box: rect corner.
    ] ifFalse: [
        1 to: self elements size do: [ :i | self displayElement: i with: aPen]
    ].!   
elements

    ^elements ifNil: [ elements := OrderedCollection new ].!  
elements: aCollectionOfWBTools

    elements := aCollectionOfWBTools!   
framingBlock: f
    | width |
    self style == #mdiToolBar ifFalse: [
        ^super framingBlock: f
    ].
    parentWindow isNil ifTrue: [
        width := 300
    ] ifFalse: [
        width := parentWindow rect width
    ].
    framingBlock := FramingParameters new
        iDUE: width @ (self cellSize y / (SysFont height / 32));
        lDU: 0 r: #left;
        rDU: 0 r: #right;
        tDU: 0 r: #top;
        bDU: self cellSize y / (SysFont height / 32) r: #top!
importantEvents

    ^super importantEvents
        addFirst: #select;
        add: #selecting;
        add: #doubleClick;
        add: #gettingFocus;
        add: #showHelp;
        yourself!  
maxSize

    ^32000@(self suggestedSize y)! 
minSize

    ^self cellSize!
readSpecificsFrom: c

    self
        cellSize: c cellSize;
        useSystem: c useSystem;
        style: c tpStyle;
        elements: c elements.!   
storeSpecificsOn: aStream indentString: indentString

    self useSystem ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'useSystem: true'.
    ] ifFalse: [ self cellSize = self defaultCellSize ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'cellSize: ', self cellSize printString.
    ]].

    self elements do: [ :element |
        (element bitmapSelector notNil and: [ element bitmapSelector notEmpty ]) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'add: #'.
            element bitmapSelector trimBlanks = element selector trimBlanks ifFalse: [
                aStream nextPutAll: element bitmapSelector asString; nextPutAll: ' selector: #'.
            ].
            (element selector isNil or: [ element selector isEmpty ]) ifTrue: [
                aStream nextPutAll: 'nil'
            ] ifFalse: [
                aStream nextPutAll: element selector asString
            ].
            element numSpaces > 0 ifTrue: [
                aStream nextPutAll: ' spaces: '; nextPutAll: element numSpaces asString
            ].
            (element rbSelector notNil and: [ element rbSelector notEmpty ]) ifTrue: [
                aStream nextPutAll: ' rbSelector: #'; nextPutAll: element rbSelector asString
            ].
        ].
    ].!  
style: aStyle

    super style: aStyle.
    aStyle == #mdiToolBar ifTrue: [
        framingBlock := FramingParameters new
            lDU: 0 r: #left;
            rDU: 0 r: #right;
            tDU: 0 r: #top;
            bDU: self cellSize y / (SysFont height / 32) r: #top.
    ].!   
styles

    ^#(toggle preAutomatic postAutomatic mdiToolBar)!   
suggestedSize

    self elements isEmpty ifTrue: [
        ^self cellSize
    ] ifFalse: [
        ^((elements at: elements size) rectangle right + 2) @ (self cellSize y)
    ]!   
usesFraming

    ^self style ~~ #mdiToolBar!
useSystem

    ^useSystem ifNil: [ useSystem := false ].!   
useSystem: aBoolean

    useSystem := aBoolean! !

! PWBToolPalette methods ! 
arrangesVertically
    "Private - True if the receiver has a vertical shape"
    ^true! 
attributeEditor

    ^(Smalltalk at: self editorClassName
        ifAbsent: [WBToolBarEditor]) new!
cellSize

    ^cellSize ifNil: [ cellSize := self defaultCellSize ].!   
cellSize: aPoint

    cellSize := aPoint!   
changesSize

    ^true! 
collectionCopy: aCollection

    | dict |
    aCollection isDictionary
    ifFalse: [^aCollection copy].

    dict := Dictionary new.
    aCollection keys do: [:key|
        dict at: key x @ key y put: (aCollection at: key)
    ].
    ^dict!   
copySpecificsTo: aPane

    aPane
        cellSize: self cellSize deepCopy;
        useSystem: self useSystem;
        elements: self elements deepCopy.!
defaultCellSize

    realClass isNil ifTrue: [^nil].
    ^realClass basicNew defaultCellSize!  
displayElement: key with: aPen

    | box element |
    element := self elements at: key.
    element rectangle isNil
    ifTrue: [ element rectangle: (self rectForKey: key) ].
    box := element rectangle translateBy: rect leftTop +
        (self arrangesVertically ifTrue: [0] ifFalse: [1@0]).
    aPen
        copy: element pen
        from: element boundingBox
        to: box!  
displayWith: aPen

    | just s aRect |

    aPen fill: rect color: self backColor.

    self elements isEmpty ifTrue: [
        aPen
            place: rect origin;
            box: rect corner.
    ] ifFalse: [
        self keys do: [ :key | self displayElement: key with: aPen]
    ].!  
editorClassName
    "Private - Returns the receiver's editor name"

    | pName |
    pName := self class name.
    ^(self class defaultRealClassName,'Editor') asSymbol!
elements

    ^elements ifNil: [ elements := OrderedCollection new ].!  
elements: aCollectionOfWBTools

    elements := aCollectionOfWBTools.!  
framingBlock: f

    | width |
    self style = #mdiToolBar ifFalse: [ ^super framingBlock: f ].

    parentWindow isNil
    ifTrue: [width := 300]
    ifFalse: [width := parentWindow rect width].

    framingBlock := FramingParameters new
        iDUE: width @ (self cellSize y / (SysFont height / 32));
        lDU: 0 r: #left;
        rDU: 0 r: #right;
        tDU: 0 r: #top;
        bDU: self cellSize y / (SysFont height / 32) r: #top!   
importantEvents

    ^super importantEvents
        addFirst: #select;
        add: #selecting;
        add: #doubleClick;
        add: #gettingFocus;
        add: #showHelp;
        yourself!  
keys
    "Private - returns all the receiver's keys..."

    ^(self elements isKindOf: Dictionary)
        ifTrue: [ self elements keys ]
        ifFalse: [ 1 to: self elements size ]! 
maxSize

    ^self arrangesVertically
    ifTrue: [ self suggestedSize x @ 32000 ]
    ifFalse: [ 32000 @ self suggestedSize x ]! 
minSize

    ^self cellSize!
readSpecificsFrom: c

    self
        cellSize: c cellSize;
        useSystem: c useSystem;
        style: c tpStyle;
        elements: (self collectionCopy: c elements)! 
rectForKey: key
    | displacement |
    displacement := self arrangesVertically
    ifTrue: [ 0 @ self cellSize y ]
    ifFalse: [ self cellSize x @ 0 ].
    ^key - 1* displacement extentFromLeftTop: cellSize!   
sortedElements

    | cole |
    elements isDictionary ifFalse: [^elements].
    cole := SortedCollection sortBlock: [:a :b| a key x < b key x or: [a key x = b key x and: [a key y < b key y ]] ].
    elements associationsDo: [:asoc| cole add: asoc].
    ^cole asArray collect: [:each| each value]!   
storeSpecificsOn: aStream indentString: indentString

    self useSystem ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'useSystem: true'.
    ] ifFalse: [ self cellSize = self defaultCellSize ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'cellSize: ', self cellSize printString.
    ]].

    self sortedElements do: [ :element |
        (element bitmapSelector notNil and: [ element bitmapSelector notEmpty ]) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'add: #'.
            element bitmapSelector trimBlanks = element selector trimBlanks ifFalse: [
                aStream nextPutAll: element bitmapSelector asString; nextPutAll: ' selector: #'.
            ].
            (element selector isNil or: [ element selector isEmpty ]) ifTrue: [
                aStream nextPutAll: 'nil'
            ] ifFalse: [
                aStream nextPutAll: element selector asString
            ].
            element numSpaces > 0 ifTrue: [
                aStream nextPutAll: ' spaces: '; nextPutAll: element numSpaces asString
            ].
            (element rbSelector notNil and: [ element rbSelector notEmpty ]) ifTrue: [
                aStream nextPutAll: ' rbSelector: #'; nextPutAll: element rbSelector asString
            ].
        ].
    ].!
style: aStyle

    super style: aStyle.
    aStyle == #mdiToolBar ifTrue: [
        framingBlock := FramingParameters new
            lDU: 0 r: #left;
            rDU: 0 r: #right;
            tDU: 0 r: #top;
            bDU: self cellSize y / (SysFont height / 32) r: #top.
    ].!   
styles
    | prototype |
    realClass isNil ifTrue: [^nil].
    prototype := realClass basicNew.
    ^#(toggle preAutomatic postAutomatic mdiToolBar)
        select: [:selector| prototype respondsTo: selector ]! 
suggestedSize
    | max |
    self elements isEmpty ifTrue: [ ^self cellSize ].
    max := 0.
    self arrangesVertically
    ifTrue: [
        self tools do: [:tool| max := max max: tool rectangle bottom ].
        ^self cellSize x @ max + 1
    ]
    ifFalse: [
        self tools do: [:tool| max := max max: tool rectangle right ].
        ^max + 1 @ self cellSize y + 1
    ]!  
tools
    "Private - returns all the receiver's tools..."

    ^(self elements isKindOf: Dictionary)
        ifTrue: [ self elements values ]
        ifFalse: [ self elements ]!
usesFraming

    ^self style ~~ #mdiToolBar!
useSystem

    ^useSystem ifNil: [ useSystem := false ].!   
useSystem: aBoolean

    useSystem := aBoolean! !

! POSToolPalette methods ! 
framingBlock: f

    | height |
    self style = #mdiToolBar ifFalse: [ ^super framingBlock: f ].

    parentWindow isNil
    ifTrue: [height := 300]
    ifFalse: [height := parentWindow rect height].

    framingBlock := FramingParameters new
        iDUE: 0"(self cellSize x / (SysFont height / 32))" @ height;
        lDU: 0 r: #left;
        rDU: self cellSize x + 4 / (SysFont height / 32) r: #left;
        tDU: 0 r: #top;
        bDU: 0 r: #bottom! !

! PWBToolBarOS methods !   
arrangesVertically
    "Private - True if the receiver has a vertical shape"
    ^false!
framingBlock: f

    | width |
    self style = #mdiToolBar ifFalse: [ ^super framingBlock: f ].

    parentWindow isNil
    ifTrue: [width := 300]
    ifFalse: [width := parentWindow rect width].

    framingBlock := FramingParameters new
        iDUE: width @ (self cellSize y / (SysFont height / 32));
        lDU: 0 r: #left;
        rDU: 0 r: #right;
        tDU: 0 r: #top;
        bDU: self cellSize y / (SysFont height / 32) r: #top! !

! Bitmap class methods ! 
allInstancesPrim
    "Reimplemented here to patch Bitmap behavior.
    Routed to OSBitmap for GCollect..."

    #addedByOStyle.
    self == Bitmap ifTrue: [ ^OSBitmap allInstancesPrim, super allInstancesPrim ].

    ^super allInstancesPrim.!  
buttonWidth: w height: h
    "Added by OSI - Create a new tool bar button bitmap template"
    | button |
    #addedByOSI.
    button := self screenWidth: w * 2 height: h.
    button pen
        fill: (ColorConstants at: 'ClrPalegray');
        foreColor: (ColorConstants at: 'ClrBlack');
        lineFrom: 1@0 to: (w - 1)@0;
        lineFrom: (w + 1)@0 to: (2 * w - 1)@0;
        lineFrom: (2 * w - 1)@1 to: (2 * w - 1)@(h - 1);
        lineFrom: 1@(h - 1) to: (w - 1)@(h - 1);
        lineFrom: (w + 1)@(h - 1) to: (2 * w - 1)@(h - 1);
        lineFrom: 0@1 to: 0@(h - 1);
        lineFrom: (w - 1)@1 to: (w - 1)@(h - 1);
        lineFrom: w@1 to: w@(h - 1);
        foreColor: (ColorConstants at: 'ClrWhite');
        lineFrom: 1@1 to: 1@(h - 2);
        lineFrom: 2@1 to: (w - 2)@1;
        foreColor: (ColorConstants at: 'ClrDarkgray');
        lineFrom: 1@(h - 2) to: (w - 1)@(h - 2);
        lineFrom: 2@(h - 3) to: (w - 1)@(h - 3);
        lineFrom: (w - 2)@1 to: (w - 2)@(h - 2);
        lineFrom: (w - 3)@2 to: (w - 3)@(h - 2);
        lineFrom: (w + 1)@1 to: (w + 1)@(h - 1);
        lineFrom: (w + 2)@1 to: (2 * w - 1)@1;
        lineFrom: (w + 2)@2 to: (w + 2)@(h - 1);
        lineFrom: (w + 3)@2 to: (2 * w - 1)@2.
    ^button!
fromModule: aModuleHandle id:  bitmapName
    "Answer an instance of Bitmap whose id is bitmapName
     contain in the module identified by aModuleHandle.
     bitmapName may be an integer or a string.
    Touched by Ale for zero handle return handling.
    *Warning* This implementation is not compatible
        with all implementors or #fromModule:id:
        (because in the others implementation
         aModuleName is spected)"
    | handle bitmap |
    handle := UserLibrary
        loadBitmap: aModuleHandle asParameter
        name: bitmapName asParameter.
    #modifiedByOStyle.
    (handle isNil or: [handle = 0]) ifTrue: [^nil].
    bitmap := Bitmap fromHandle: handle.
    GDILibrary deleteObject: handle.
    ^bitmap! 
fromStream: s

    "Added by OSI.
    *** OJO ***  Revisar este metodo... "

    | bfh bih bi bits rgbColor bytes bitmap |

    #addedByOSI.
    #modifiedByOStyle.
    bfh := self readFileHeader: s.
    bih := self readBitmapHeader: s.
    bih bitCount = 24 ifFalse: [
        rgbColor := ByteArray new: ((1 bitShift: bih bitCount) * 4).
        1 to: rgbColor size do: [: i |
            rgbColor at: i put: s nextByte
        ]
    ].
    bih sizeImage = 0 ifTrue: [
        bytes := (((
            bih width * bih bitCount) + 31) // 32 * 4) * bih height
    ] ifFalse: [
        bytes := bih sizeImage.
    ].
    bits := ByteArray new:  bytes.
    s getBytesFor: bits.

    bitmap := self new.
    bitmap bitmapInfo: (
        rgbColor isNil
            ifTrue: [WinBitmapInfo new contents: bih contents]
             ifFalse: [
                WinBitmapInfo new contents: bih contents, rgbColor]).
    bitmap createBitmap: bits.
    bitmap
        deviceContext: MemoryContext;
        graphicsTool: (
            Pen forDC: MemoryContext medium: bitmap).
    ^bitmap!   
new
    "Reimplemented here to patch Bitmap behavior.
    Routed to OSBitmap..."

    #addedByOStyle.
    self == Bitmap ifTrue: [ ^OSBitmap new ].

    ^super new!   
purgeUnusedBitmaps
    "Private - Purge unused bitmaps from the system.
    Touched here to support bitmap patching..."

    ^OSBitmap purgeUnusedBitmaps
    "
    | handles all bitmaps |
    all := BitmapHandleTable keys.
    BitmapHandleTable := Dictionary new.
    bitmaps := Bitmap allInstances.
    handles := bitmaps collect: [:each | each handle].
    GDILibrary selectObject: MemoryContext
        with: DefaultBitmap.
    all do: [:each |
        (handles includes: each)
            ifFalse: [
                GDILibrary deleteObject: each]].
    bitmaps do: [:each |
        BitmapHandleTable at: each handle put: each]
    "! !

! Bitmap methods !  
archive
    "Private - Returns instance var only for debuggin porpouses.
    Implemented by Ale..."
    #addedByOStyle.
    ^archive! 
cpCopy

    "Added by OSI"

    | newBitmap |

    #addedByOSI.
    newBitmap := Bitmap
            width: self width
            height: self height
            planes: self planes
            bitCount: self bitCount.
        self displayAt: 0@0 with: newBitmap pen.

    ^newBitmap!
createDIBPalette
    "Private - Create a GDI palette from the color table of bitmapInfo.
    Touched by Ale for >32.768 colors support"
    | logPalette |
    #modifiedByOStyle.
    self numberOfColors = 0 "self bitCount > = 24 Ale patch" ifTrue: [^0].
    logPalette := WinStructure new: (self numberOfColors * 4 + 4).
    logPalette uShortAtOffset: 0 put: 16r300;
        uShortAtOffset: 2 put: (1 bitShift: bitmapInfo bitCount).
    logPalette contents
        replaceFrom: 5
        to: logPalette size
        with: bitmapInfo contents
        startingAt: 41.
    ^GDILibrary createPalette: logPalette asParameter! 
displayAt: aPoint
    "Display the receiver at aPoint with Display pen.
    Implemented by Ale..."
    #addedByOStyle.
    ^self displayAt: aPoint with: Display pen! 
displayWith: aPen
    "Display the receiver using aPen in all it's boundingBox..
    Implemented by Ale..."
    #addedByOStyle.

    aPen
        copyBitmap: self
        from: self boundingBox
        to: aPen boundingBox!   
fileInActivate: anObjectFiler
        " Activate instance which has just been loaded. "
    deviceContext notNil ifTrue: [^self].  " already activated "
    self
        " VPM version: 
        deviceContext: self class context.
        "
        "DISABLE: validate."  " MikeT change in LAF image "
        " VW version: "
        deviceContext: OldMemoryContext; 
        restoreBitmap.   "ISSUE: Necessary on VW??"
    ^self!
fileOutSurrogate: anObjectFiler
        " Answer surrogate for object filing.
          Save bitmap in archive; don't store DC, pen, or bitmapHandle. "
    | surrogate instVarNames |
    self saveBitmap. 
    surrogate := self copy.
    instVarNames := surrogate class allInstVarNames.
    surrogate   " clear system resource handles to nil "
        instVarAt: (instVarNames indexOf: 'deviceContext') put: nil;
        instVarAt: (instVarNames indexOf: 'graphicsTool') put: nil;
        instVarAt: (instVarNames indexOf: 'bitmapHandle') put: nil.
    ^surrogate!
fromSysID: id
    "Added by OSI"
    | handle bitmap |
    #addedByOSI.
    handle := UserLibrary
        loadBitmap: nil asParameter
        name: id.
    handle isNil ifTrue: [^self].
    bitmap := Bitmap fromHandle: handle.
    GDILibrary deleteObject: handle.
    ^bitmap!
getCb: bitCount
    "Private - Answer the size of the bitmapInfo struct.
    Touched by Ale for >32.768 colors support"
    | count |
    count := WinBitmapInfoHeader sizeInBytes.
    #modifiedByOStyle.
    bitCount > 8 "= 24   Ale patch"
        ifTrue: [^count]     "No color table for this format."
        ifFalse: [^(count + (4 * (1 bitShift: bitCount)))]! 
numberOfColors
    "Answer the number of colors in the bitmap.
    Touched by Ale for >32.768 colors support"
    #modifiedByOStyle.
    self bitCount > 8  " = 24  Ale patch "
        ifTrue: [^0]         "A 24 bitCount bitmap has no color table."
        ifFalse: [^(1 bitShift: self bitCount)]!
outputToFile: aFileName
    "Output the receiver in DIB format to aFileName.
     Patched by Ale for new file creation and fast saving..."
    | file fileHeader colors bitmapHeader bits |
    #modifiedByOStyle.
    bits := self getDIBits.
    bits isNil ifTrue: [^self].
    fileHeader := WinBitmapFileHeader new.
    fileHeader bfType: 'BM';
        bfSize: 14 + bitmapInfo contents size + bits size;
        reserved1: 0;
        reserved2: 0;
        offBits: 14 + bitmapInfo contents size.

    "downloading into a fast file stream"
    file := File newFastFile: aFileName.
    file
        nextPutAll: fileHeader contents;
        nextPutAll: bitmapInfo contents;
        nextPutAll: bits;
        yourself.
    file close! 
rehash
    "Rehashing of the receiver
     is the same as restoring bitmap.
    Implemented by Ale..."
    #addedByOStyle.

    archive isNil ifTrue: [^nil].

    deviceContext := OldMemoryContext.
     self restoreBitmap!   
removeTableReferences
    "Remove the receiver from BitmapTable because
     it's handle is now invalid.
    Implemented By Ale to support clipboard setttings"

    deviceContext = MemoryContext
        ifTrue: [self deselect]
        ifFalse: [graphicsTool deleteDC].

    BitmapHandleTable removeKey: bitmapHandle ifAbsent: [ ].
    graphicsTool := deviceContext :=  bitmapHandle := nil!   
restoreBitmap
        "Private - Recreate the receiver and copy the bits
         from the archive buffer. This is done upon restarting
         a saved image.
    Touched By Ale..."
    | logPalette hPalette hPrevious lpBits colorTable pbinfo hdc |
    #modifiedByOStyle.
    archive isNil ifTrue: [
        bitmapHandle := nil.
        ^self].

    pbinfo := bitmapInfo copy.
    colorTable := pbinfo colorTable.
    deviceContext = OldMemoryContext
        ifTrue: [
            self isMono
                ifTrue: [self width: self width height: self height]
                ifFalse: [self screenWidth: self width height: self height]]
        ifFalse: [
            self isMono
                ifTrue: [self ownDCWidth: self width height: self height]
                ifFalse: [self ownDCScreenWidth: self width height: self height]].

    "Use old color table."
    bitmapInfo colorTable size >= colorTable size
        ifTrue: [
            bitmapInfo contents
                replaceFrom: 41
                to: (41 + colorTable size - 1)
                with: colorTable]
        ifFalse: [
            bitmapInfo colorTable: (
                colorTable copyFrom: 1 to: bitmapInfo colorTable size)].

    hdc := UserLibrary getDC: nil.
    hPalette := self createDIBPalette.
    hPalette ~= 0
        ifTrue: [
            hPrevious := UserLibrary selectPalette: hdc
                with: hPalette
                forceBackground: false.
            UserLibrary realizePalette: hdc].

    lpBits := WinAddress copyToNonSmalltalkMemoryZ: archive.
    "Allocate an extra byte to workaround a device driver bug."
    GDILibrary
        setDIBits: hdc
        hBitmap: self handle
        startScan: 0
        scans: self height
        bits: lpBits asParameter
        bitsInfo: pbinfo asParameter
        wUsage: DibRgbColors.
    lpBits unlockAndFree.

    hPalette ~= 0
        ifTrue: [
            UserLibrary selectPalette: hdc
                with: hPrevious
                forceBackground: false.
            GDILibrary deleteObject: hPalette].
    UserLibrary releaseDC: nil with: hdc.
    archive := nil!  
restoreFromSaveImage
    "Private - Recreate the receiver restarting
     a saved image.
     Implemented by Ale for patching bug
     in saving image with bitmaps"

   " *Warning* it's not needed
   self restoreBitmap.
    "
    #modifiedByOStyle.

    archive := nil. "The bits is no longer needed..."!   
storeOnStream: s

    "Added by OSI for saving bitmaps with the CPBitmapManager.
    Touched by Ale for fast transfer"

    | file fileHeader bits |
    #modifiedByOStyle.
    #addedByOSI.
    bits := self getDIBits.
    bits isNil ifTrue: [^self].
    fileHeader := WinBitmapFileHeader new.
    fileHeader bfType: 'BM';
        bfSize: 14 + bitmapInfo contents size + bits size;
        reserved1: 0;
        reserved2: 0;
        offBits: 14 + bitmapInfo contents size.

    s nextPutAll: fileHeader contents asString.
    "  Ale patch
    bitmapInfo contents do: [: aByte |
        s nextPut: aByte asCharacter].
    bits do: [: aByte |
        s nextPut: aByte asCharacter].
    "
    s
        nextPutAll: bitmapInfo contents;
        nextPutAll: bits!   
unloadBy: aLoader
    "Private - The receiver must save bits when unloaded.
    Implemented by Ale..."
    | handle device tool bits |
    #addedByOStyle.

    "save instances"
    handle := bitmapHandle.
    device := deviceContext.
    tool := graphicsTool.
    bits := archive.

   "save bits"
    self saveBitmap.

    "clear instances"
    bitmapHandle :=
    deviceContext :=
    graphicsTool := nil.

    "unLoad now"
    super unloadBy: aLoader.

    "restore instances"
    bitmapHandle := handle.
    deviceContext := device.
    graphicsTool   := tool.
    archive := bits.

    "thats all folks..."! !

! OSBitmap class methods !  
purgeUnusedBitmaps
    "Private - Purge unused bitmaps from the system.
    The action to be performed will free all OSbitmaps handles..."

    | handles all bitmaps getHandle theHandle |

    "OSBitmaps free their handles..."
    OSBitmap allInstances do: [:each| each saveBitmap ].

    "now perform old action for remaining bitmaps..."
    all := BitmapHandleTable keys.
    BitmapHandleTable := Dictionary new.
    all isEmpty ifTrue: [^self]. "done"

    Terminal bell. "unespected condition..."

    getHandle := [:bmp|
        (bmp respondsTo: #privateHandle)
            ifTrue: [bmp privateHandle]
            ifFalse: [bmp handle]
    ].

    bitmaps := Bitmap allInstances.
    handles := (bitmaps collect: [:each | getHandle value: each ]) asSet.
    GDILibrary selectObject: MemoryContext with: DefaultBitmap.
    all do: [:each | (handles includes: each) ifFalse: [GDILibrary deleteObject: each]].

    bitmaps do: [:each |
        theHandle := getHandle value: each.
        theHandle notNil
        ifTrue: [
            BitmapHandleTable at: theHandle put: each
        ]
    ]! !

! OSBitmap methods !
freeHandle
    "Private - Free the receiver's bits..."

    bitmapHandle isNil ifTrue: [^self].
    deviceContext = MemoryContext
        ifTrue: [self deselect]
        ifFalse: [graphicsTool deleteDC].
    GDILibrary deleteObject: bitmapHandle.
    BitmapHandleTable removeKey: bitmapHandle ifAbsent: [ ].
    bitmapHandle := nil.!
handle
    "Private - Answer the handle."

    self validate.
    ^bitmapHandle!  
privateHandle
    "Private - Answer the handle."

    ^bitmapHandle!   
release
   "Delete the receiver from the device context. Freeing
    up all system storage associated with the receiver."

    bitmapHandle isNil ifTrue: [^self].
    ^super release!   
restoreBitmap
    "Private - Recreate the receiver and copy the bits
     from the archive buffer. This is not needed until
     the bitmap is really used..."

    "do nothing..."! 
restoreFromSaveImage
    "Private - Recreate the receiver restarting
     a saved image.
     Implemented by Ale for doing nothing until needed"

    self saveBitmap.!  
saveBitmap
    "Private - Save the receiver's bits in an archive buffer when saving image."

    bitmapHandle isNil ifTrue: [^self].
    archive := self getDIBits.
    self freeHandle.!
select
    "Private - Select the receiver into the device context
     and answer the previously selected bitmap handle."

    self validate.
    ^super select! 
validate
    "Private - Validate receiver's handle and try to rebuild it if posible"

    bitmapHandle isNil ifFalse: [^self].

    deviceContext := OldMemoryContext.
    super restoreBitmap! !

! Printer methods !
release
    "Delete the receiver's the device context. Freeing
    up all system storage associated with the receiver.
    Even when the receiver has not been used...
    Implemented by Ale... No se liberaba el
         deviceContext si no se hacia un endPrintJob"

    #addedByOStyle.
    super release.
    abortProcAddress notNil ifTrue: [
        self freeAbortProc.
        abortProcAddress := nil.
    ].
    deviceContext notNil ifTrue: [
        graphicsTool deleteDC.
        deviceContext := nil.
    ].! !

! OSPrinter methods ! 
capability
    "Returns an object for getting receiver's DC capabilities..."

    ^GraphicCapability for: self!
deviceContext: hDC
    "Changes the device context of the receiver; release old graphic tool"
    | aGraphicsTool |
    hDC = 0 ifTrue: [^self error: 'Error while opening printer.'].
    graphicsTool notNil ifTrue: [ self deleteGraphicsTool ].
    super deviceContext: hDC.
    graphicsTool := Pen forDC: hDC medium: self.
    graphicsTool
        width: (GDILibrary getDeviceCaps: hDC index: Horzres);
        height: (GDILibrary getDeviceCaps: hDC index: Vertres)!   
endPrinterPage
    "Notify Ending printing on a page..."!
initialize
    "Private - Create a device context for a printer "

    super initialize.
    label := StartUpApplication product.!
label
    "Returns the receiver's output label for PrintManager"
    ^label!
label: aString
    "Sets the receiver's output label for PrintManager"
    label := aString!
setup
    "Open a Printer setup dialog and configure the receiver
    OJO No anda bien en V20..."

    |aOwner dlg |
    (PrintDialog respondsTo: #printerSetup) "VW32..."
    ifTrue: [ PrintDialog printerSetup ]
    ifFalse: [
        aOwner := WindowHandle queryActive.
        dlg := PrintDialog new.
        dlg
            openOwner:aOwner
            style: (CommonDialogConstants at: 'PdPrintsetup').
        (dlg hDCPrinter = 0 or: [dlg hDCPrinter isNil])
        ifTrue: [
            Terminal bell.
            MessageBox warning: 'Servicios de configuracin de impresora\no disponibles en esta versin' withCrs.
            "self notFullyImplemented siempre da nil..."
        ]
        ifFalse: [ self deviceContext: dlg hDCPrinter ].
    ].! 
startPrinterPage
    "Notify Starting a new page..."!
startPrintJob
        "Start a print job.  Everything drawn between startPrintJob
         and endPrintJob will become one entry in the print queue."
    abort := false.
    self
        setAbortProc;
        escape: Startdoc inputData: self label asParameter! !

! P3Printer methods ! 
endPrinterPage
    "Notify Ending printing on a page..."

    P3PrintDLL library endPrinterPage: self deviceContext asParameter!   
formFeed
    "Send a form feed to the printer."

    self endPrinterPage.
    super formFeed.
    self startPrinterPage.!
startPrinterPage
    "Notify Starting a new page..."

    P3PrintDLL library startPrinterPage: self deviceContext asParameter! !

! Screen methods ! 
pointFromUser: aRectangle offset: anOffset

    "Modified by OSI to erase last extra rectangle left on screen."

        "Display aRectangle and answer a point selected
         by the user."
    | loc oldLoc oldCorner newCorner w |
    #modifiedByOSI.
    oldLoc := Cursor sense - anOffset.
    oldCorner := oldLoc + aRectangle extent.
    graphicsTool setRop2: R2Notxorpen;
        place: oldLoc;
        box: oldCorner.
    Notifier consumeInputUntil: [: event |
        loc := Cursor sense - anOffset.
        oldCorner := oldLoc + aRectangle extent.
        newCorner := loc + aRectangle extent.
        loc ~= oldLoc
            ifTrue: [
                graphicsTool
                    place: oldLoc;
                    box: oldCorner;
                    place: loc;
                    box: newCorner.
                oldLoc := loc].
        (event selector = #button1Down:)  ].
    "Added by OSI."
    graphicsTool
        place: loc;
        box: newCorner.
    ^loc!
rectangleFromUser
    "Answer a rectangle obtained from the user.
    Touched by Ale because sometimes origin&corner are nil..."
    | origin corner rect aPoint |

    #modifiedByOStyle.
    origin := corner := Cursor sense.

    Notifier activeMainWindow captureMouseInput.
    CursorManager crossHair change.
    graphicsTool setRop2: R2Notxorpen.
    Notifier consumeInputUntil: [: event |
        event selector = #button1Down:
            ifTrue: [
                graphicsTool place: (
                    origin := corner := Cursor sense)].
        event selector = #button1Move:
            ifTrue: [
                aPoint := Cursor sense.
                corner  ~= aPoint
                    ifTrue: [
                        graphicsTool
                            place: origin;
                            box: corner;
                            place: origin;
                            box: aPoint.
                        corner := aPoint]].
        event selector = #button1Up:].
    graphicsTool place: origin;
        box: corner.
    graphicsTool setRop2: R2Copypen.
    CursorManager normal change.
    UserLibrary releaseCapture.
    ^(origin corner: corner)! !

! StoredPicture class methods !   
fromFile: pathName
    "Returns an instance of the receiver from file.
    Implemented by Ale..."
    #addedByOStyle.
    ^StoredPicture new load: pathName! !

! StoredPicture methods !   
archive
    "Returns the instance var of the receiver
     for external manipulation.
    Implemented by Ale..."
    #addedByOStyle.
    ^archive!   
archive: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done).
    Implemented by Ale..."
    #addedByOStyle.
    archive := anObject!  
buildContext
    "Private - Rebuild deviceContext and graphics medium.
    Implemented by Ale..."
    #addedByOStyle.
    deviceContext := GDILibrary createMetaFile: nil.
    graphicsTool := Pen forDC: deviceContext medium: self.
    graphicsTool
        width: Display width;
        height: Display height.! 
copied
    "Returns a copy of the receiver.
    Implemented by Ale..."
    #addedByOStyle.
    ^self class new copyFrom: self!
copyFrom: aStoredPicture
    "Copy receiver's contents from aStoredPicture.
    Implemented by Ale..."
    #addedByOStyle.

    aStoredPicture saveBits.
    archive := aStoredPicture archive.
    self restoreBits.
    aStoredPicture restoreBits.
    archive := nil.
    aStoredPicture archive:  nil.
    self
        graphicsTool: aStoredPicture pen;
        deviceContext: aStoredPicture deviceContext.! 
height
        "Answer the height of the receiver.
    Implemented by Ale..."
    #addedByOStyle.
    graphicsTool isNil ifTrue: [self buildContext].
    ^super height! 
rehash
    "Rehashing of the receiver
     is the same as restoring it.
    Implemented by Ale..."
    #addedByOStyle.
    archive isNil ifTrue: [^nil].

    self restoreBits.

    "Assume memory metafile"
    deviceContext := GDILibrary createMetaFile: nil.
    graphicsTool := Pen forDC: deviceContext medium: self.

    graphicsTool
        width: (archive at: 1);
        height: (archive at: 2).

    archive := nil!
release
    "Delete the receiver from the system thus freeing
     the system resources associated with the receiver.
     Touched by Ale for ignore multiple releasing.
     Touched by Ale for better handling of deleteMetafile error"
    | oldHandle |
    #modifiedByOStyle.
    (hMetaFile isNil or: [hMetaFile = 0])
    ifTrue: [ ^self "Has been released yet..."].
    (GDILibrary deleteMetaFile: self handle)
    ifFalse: [
        oldHandle := hMetaFile. "ussefull for repair"
        hMetaFile:=nil. "avoid multiple errors"
        ^self error: 'DeleteMetaFile error'
    ].
    hMetaFile := nil!   
restoreBits
    "Private - Restore the receiver's metafile bits info.
    Touched By Ale..."
    | hMem segment |
    #modifiedByOStyle.
    (archive isNil or: [archive last size = 0]) ifTrue: [^nil].
    hMem := WinAddress memoryHandleFrom: (archive at: 3).
    KernelLibrary globalLock: hMem.
    self handle: (GDILibrary setMetaFileBits: hMem).
    KernelLibrary globalUnlock: hMem.!   
saveBits
    "Private - Save the receiver's metafile bits info.
    Touched By Ale..."
     | hMem address count |
    #modifiedByOStyle.
    archive := Array with: self width with: self height with: nil.
     hMem := GDILibrary getMetaFileBits: hMetaFile.
    address := WinAddress fromBytes: (
            KernelLibrary globalLock: hMem).
    count := (WinLong fromBytes: (
            KernelLibrary globalSize: hMem)) asInteger.
    archive at: 3 put: (ByteArray new: count).
    WinAddress
        copyFrom: address
        to: (archive at: 3)
        count: count.
    KernelLibrary globalUnlock: hMem.
    hMetaFile := nil.!   
unloadBy: aLoader
    "Save receiver bits and perform unloading...
     The restore bits again.
    Implemented by Ale..."
    #addedByOStyle.
    self saveBits.
    deviceContext := graphicsTool := nil.
    super unloadBy: aLoader.
    self restoreBits.
    archive := nil.!  
width
        "Answer the width of the receiver.
    Implemented by Ale..."
    #addedByOStyle.
    graphicsTool isNil ifTrue: [self buildContext].
    ^super width! !

! GraphicsTool methods !  
fill: aRectangle bitmap: aBitmap

    "Added by OSI"

    | oldBrush newBrush |
    #addedByOSI.
    newBrush := GDILibrary createPatternBrush: aBitmap handle.

    oldBrush := self selectObject: newBrush.
    self patternFill: aRectangle
        rule: Patcopy.
    self selectObject: oldBrush.
    self deleteObject: newBrush!   
fill: aRectangle color: aColor
     "Fill aRectangle with aColor. aColor can be an RGB
       value or an index to the color palette."
    "Modified by OSI - if aColor is the index for the steelpattern,
     fill in its bitmap instead"
    "Touched by Ale for getting bitmap from default dict if present..."
    | oldBrush newBrush color |

    aColor = ClrChiseledgray ifTrue: [
        #modifiedByOSI.#modifiedByOS.
        ^self fill: aRectangle
            bitmap: (CPBitmapDict at: 'steelPattern'
                ifAbsent: [CPBitmapDict sysAt: 'steelPattern'])
    ].

    aColor isNil
        ifTrue: [color := ClrBackground]
        ifFalse: [color := aColor].
    newBrush :=  GDILibrary createSolidBrush: color.
    oldBrush := self selectObject: newBrush.
    self patternFill: aRectangle
        rule: Patcopy.
    self selectObject: oldBrush.
    self deleteObject: newBrush!
floodFill
    "Fill the receiver medium with backColor
     at current location up to any other color.
    Implemented by Ale..."
    | aColor point |
    #addedByOStyle.
    aColor := (WinAddress fromBytes:(
      GDILibrary
        getPixel: self handle
        x: (point := self location) x
        y: point y)) asInteger.
    aColor = -1 ifTrue: [^nil].
    "sorry but couldn't fill outside clipping region"
    GDILibrary
        extFloodFill: deviceContext
        x: point x
        y: point y
        color: aColor
        type:  Floodfillsurface.!
floodFill: aColor
    "Fill the receiver medium with backColor
     at current location upTo find aColor.
    Implemented by Ale..."
    #addedByOStyle.
    GDILibrary
        floodFill: self handle
        x: self location x
        y: self location y
        color: aColor!  
invertRegion: aRegion
    "Inverts contents of aRegion.
    Implemented by Ale..."
    #addedByOStyle.
    ^GDILibrary
        invertRgn: self handle
        region: aRegion!  
polyLine: anArray
    "Draw aPolygon specified in anArray of points
     using current attributes.
    Implemented by Ale..."
    | points |
    #addedByOStyle.
    points := WinPolygon new: anArray size.
    1 to: anArray size
    do: [:i| points at: i put: (anArray at: i)].
    GDILibrary
        polyLine: deviceContext
        points: points asParameter
        count: points size! !

! TextTool methods !  
centerText: aString at: aPoint

    "Added by OSI - Display aString centered at aPoint."
    #addedByOSI.
    self displayText: aString
        at: aPoint -
            ((font stringWidth: aString)
                @ font height // 2)! 
centerWinText: aString at: aPoint

    "Added by OSI"
    #addedByOSI.
    self winDrawText: aString
        at: aPoint -
            ((font wbStringWidth: aString)
                @ font height // 2)!  
displayText: aString at: aPoint clipRect:aRectangle options:options
        "Display aString at aPoint within a clip rectangle."
        "options can be one of the following values:"
        "EtoClipped, EtoOpaque"
    | str |
    str := (aString isString)
        ifTrue: [aString]
        ifFalse: [aString printString].
    str size > 8000 ifTrue: [ "size must be < 32k"
        str := (str copyFrom: 1 to: 8000), '...etc...'].
    self allHandles do: [: h |
            GDILibrary extTextOut:h  asParameter
                                                    x: aPoint x
                                                    y: aPoint y
                                                    options:options
                                                    rect:aRectangle asParameter
                                                    text:str asParameter
                                                    length:str size
                                                    dx:nil asParameter]!
winDrawText: str at: aPoint

    "Added by OSI"
    #addedByOSI.
    self winDrawText: str in: (aPoint extentFromLeftTop: 30000@30000) format: 0.!
winDrawText: str in: aRect format: f

    "Added by OSI"
    #addedByOSI.
    self allHandles do: [:h |
        UserLibrary
            drawText: h
            text: str asParameter
            length: str size
            rect: (WinRectangle fromRectangle: aRect) asParameter
            format: f asParameter
    ].! !

! Pen methods !
buttonHighlight

    "Added by OSI"
    | color |
    ((WinAddress fromString: (KernelLibrary getVersion)) byteAtOffset: 0) = 3 ifTrue: [
        #addedByOSI.
        ^ClrWhite
    ] ifFalse: [
        ^UserLibrary getSysColor: ColorBtnhighlight
    ].!
draw3DButton: aString rect: aRect font: aFont
    "Added by OSI - draw a 3D button"
    #addedByOSI.
    self draw3DButton: aString rect: aRect font: aFont
        foreColor: ClrBlack
        backColor: (UserLibrary getSysColor: ColorBtnface)!  
draw3DButton: aString rect: aRect font: aFont foreColor: fore backColor: back
    "Added by OSI - draw a 3D button"
    | theFont bottom right region |
    #addedByOSI.
    theFont := aFont isNil ifTrue: [ Font fromFont: ButtonFont ] ifFalse: [ aFont ].
    bottom := aRect bottom up: 1.
    right := aRect right left: 1.
    self
        setBackMode: Opaque;
        fill: (aRect insetBy: 3) color: back;
        drawRect3D: aRect;
        foreColor: ClrBlack;
        lineFrom: aRect left @ (aRect top down: 1) to: aRect left @ bottom;
        lineFrom: right @ (aRect top down: 1) to: right @ bottom;
        lineFrom: (aRect left right: 1) @ aRect top to: right @  aRect top;
        lineFrom: (aRect left right: 1) @ bottom to: right @ bottom.
    region := self setClipRect: (aRect insetBy: 4).
    self
        setBackMode: Transparent;
        font: theFont;
        setTextAlign: TaTop.
    "(back = (UserLibrary getSysColor: ColorBtnface))
        ifTrue: [ self
            foreColor: ClrWhite;
            centerWinText: aString at: aRect center + 1]."
    self
        foreColor: fore;
        centerWinText: aString at: aRect center;
       setBackMode: Opaque.
    self destroyRegion: region.! 
drawFocusRect: aRect

    "Added by OSI"
    #addedByOSI.
    self allHandles do: [: h |
        UserLibrary
            drawFocusRect: h
            rectangle: aRect asParameter
    ].!
drawRect3D: aRect

    "Added by OSI"
    | theHandle leftRight1 leftRight2 rightLeft2 rightLeft3 topDown1 topDown2 bottomUp2 bottomUp3 |
    #addedByOSI.
    theHandle := self handle.
    leftRight1 := aRect left right: 1.
    leftRight2 := aRect left right: 2.
    rightLeft2 := aRect right left: 2.
    rightLeft3 := aRect right left: 3.
    topDown1 := aRect top down: 1.
    topDown2 := aRect top down: 2.
    bottomUp2 := aRect bottom up: 2.
    bottomUp3 := aRect bottom up: 3.

    self
        foreColor: self buttonHighlight;
        quickLineFrom: leftRight1 @ topDown1 to: rightLeft2 @ topDown1 using: theHandle;
        quickLineFrom: leftRight1 @ topDown2 to: rightLeft3 @ topDown2 using: theHandle;
        quickLineFrom: leftRight1 @ topDown1 to: leftRight1 @ bottomUp2 using: theHandle;
        quickLineFrom: leftRight2 @ topDown1 to: leftRight2 @ bottomUp3 using: theHandle;
        foreColor: (UserLibrary getSysColor: ColorBtnshadow);
        quickLineFrom: leftRight1 @ bottomUp2 to: (aRect right left: 1) @ bottomUp2 using: theHandle;
        quickLineFrom: leftRight2 @ bottomUp3 to: rightLeft2 @ bottomUp3 using: theHandle;
        quickLineFrom: rightLeft2 @ topDown1 to: rightLeft2 @ (aRect bottom up: 1) using: theHandle;
        quickLineFrom: rightLeft3 @ topDown2 to: rightLeft3 @ bottomUp2 using: theHandle!  
drawRect3D: aRect depth: d style: style

    "Added by OSI"

    | back fore |

    #addedByOSI.
    style == #outline ifTrue: [
        ^self
            foreColor: ClrWhite;
            drawRectangle: (aRect leftTop + 1 corner: aRect corner);
            foreColor: (UserLibrary getSysColor: ColorBtnshadow);
            lineFrom: aRect leftTop to: aRect leftBottom;
            lineFrom: aRect leftTop to: aRect rightTop;
            lineFrom: aRect rightBottom - 2 to: (aRect left + 2)@(aRect bottom - 2);
            lineFrom: aRect rightBottom - 2 to: (aRect right - 2)@(aRect top + 2)
    ].

    style = #in ifTrue: [
        fore := ClrWhite.
        back := (UserLibrary getSysColor: ColorBtnshadow).
    ] ifFalse: [
        back := ClrWhite.
        fore := (UserLibrary getSysColor: ColorBtnshadow).
    ].

    1 to: d do: [:i |
        self
            foreColor: fore;
            lineFrom: (aRect left right: i) @ (aRect bottom up: i + 1) to: (aRect rightBottom leftAndUp: i @ (i + 1));
            lineFrom: (aRect right left: i + 1) @ (aRect top down: i) to: (aRect rightBottom leftAndUp: (i+1)@i);
            foreColor: back;
            lineFrom: (aRect leftTop + i) to: (aRect left + i) @ (aRect bottom - i);
            lineFrom: (aRect leftTop + i) to: (aRect right - i) @ (aRect top + i)
    ].!   
drawRect3DLight: aRect

    "Added by OSI"
    #addedByOSI.
    self
        foreColor: self buttonHighlight;
        lineFrom: (aRect left @ (aRect top down: 1)) to: ((aRect right left: 1) @ (aRect top down: 1));
        lineFrom: ((aRect left right: 1) @ (aRect top down: 1)) to: ((aRect left right: 1)@ (aRect bottom up: 1));
        foreColor: (UserLibrary getSysColor: ColorBtnshadow);
        lineFrom: (aRect left right: 1) @ (aRect bottom up: 2) to: (aRect rightBottom leftAndUp: 1@2);
        lineFrom: (aRect left right: 2) @ (aRect bottom up: 3) to: ((aRect right left: 1) @ (aRect bottom up: 3));
        lineFrom: (aRect right left: 2) @ (aRect top down: 1) to: (aRect rightBottom leftAndUp: 2@1);
        lineFrom: (aRect right left: 3) @ (aRect top down: 2) to: (aRect right left: 3) @ (aRect bottom up: 1).!   
drawRectangle: aRectangle

    "Added by OSI since rectangle: fills."

    #addedByOSI.
    self place: aRectangle origin.
    self box: aRectangle corner.!
fillRegion: aRegion
    "Fill the region aRegion with the current brush.
    Implemented by Ale..."
    #addedByOStyle.
    ^GDILibrary
                fillRegion: self handle asParameter
                region: aRegion asParameter
                brush: logicalBrush asParameter!   
frameRegion: aRegion
    "Frame the region aRegion with the receiver.
    Implemented by Ale..."
    #addedByOStyle.
    ^GDILibrary
                frameRegion: self handle asParameter
                region: aRegion asParameter
                brush: logicalBrush asParameter
                width: 1
                height: 1!
frameRegion: aRegion width: penWidth height: penHeight
     "Frame the region aRegion with the receiver.
     use width & height for line width.
    Implemented by Ale..."
    #addedByOStyle.
    ^GDILibrary
                frameRegion: self handle asParameter
                region: aRegion asParameter
                brush: logicalBrush asParameter
                width: penWidth
                height: penHeight! 
lineFrom: p1 to: p2

    "Added by OSI"
    #addedByOSI.
    self place: p1;
        line: p2.!  
paintRegion: aRegion
    "Paint the region aRegion with the current selected brush.
    Implemented by Ale..."
    #addedByOStyle.
    ^GDILibrary
                paintRgn: self handle asParameter
                region: aRegion asParameter!   
quickLineFrom: p1 to: p2 using: aHandle

    "Added by OSI for 3D rects."
    #addedByOSI.
    GDILibrary moveTo: aHandle x: p1 x y: p1 y.
    GDILibrary lineTo: aHandle x: p2 x y: p2 y.! !

! HelpManager methods ! 
defaultContext: contextId for: aWindow
    "Private - Returns the default context to search in the help file.
     Or nil for item help
    Who touched this method? why?"
    | prologue |
    #modifiedByOStyle.
    prologue := aWindow windowText.
    prologue isEmpty ifTrue: [^nil].
    ^prologue select: [:c| c isSeparator not ]!   
displayHelp: anId
    "Brings up the Windows Help for the topic defined by anId.
        anId can be either a string, an Integer or nil
     Touched by Ale for default context ID handling & help errors"
    |contextId old|
    #modifiedByOStyle.
    contextId := anId.
    self helpMode ifTrue:[self turnOffHelpMode].

    contextId isString ifTrue:[
        contextId := contextId asString.
        1 to: contextId size do: [:i |
            (contextId at: i) = $: ifTrue: [contextId at: i put: $_]].
        contextId := mapDictionary at: contextId
            ifAbsent:[ "default context handing..."
                self defaultContext: contextId for: applicationWindow
            ]
    ].
    contextId isNil ifTrue:[^self displayExtendedHelpPanel].

    (0 = (UserLibrary  "notify help errors to application"
        winHelp: applicationWindow asParameter
        helpFile: helpFile asParameter
        command: HelpContext
        dwData: contextId))
    ifFalse: [ self helpFailed: contextId ].!  
displayHelpKey: aKey
    "Brings up the Windows Help for the topic with key aKey
     Implemented by Ale for Help Keys handling.
    Implemented by Ale..."

    |contextId old|
    #addedByOStyle.
    contextId := aKey.
    self helpMode ifTrue:[self turnOffHelpMode].
    contextId isString ifTrue:[
        contextId := contextId asString.
        1 to: contextId size do: [:i |
            (contextId at: i) = $: ifTrue: [contextId at: i put: $_]].
        contextId := mapDictionary at: contextId
            ifAbsent:[ "default context handing..."
                self defaultContext: contextId for: applicationWindow
            ]
    ].
    contextId isNil ifTrue:[^self displayExtendedHelpPanel].

    (0 = (UserLibrary  "notify help errors to application"
        winHelp: applicationWindow asParameter
        helpFile: helpFile asParameter
        command: HelpKey
        dwData: contextId))
    ifFalse: [ self helpFailed: contextId ].!
helpFailed: contextId
    "Private - A help Request has failed. Notify the application
     if it respondsTo: #helpFailed: .
    Implemented by Ale..."
    #addedByOStyle.
    (StartUpApplication respondsTo: #helpFailed:)
    ifTrue: [StartUpApplication helpFailed: contextId]!   
helpMenu
    "Private - Answer the Help menu.
    Touched By Ale for application menu item addOn"
    | menu appName |
    #modifiedByOStyle.
    appName := (StartUpApplication respondsTo: #product)
        ifTrue: [StartUpApplication product]
        ifFalse: [applicationWindow label].
    menu :=  HelpMenu new
        owner: self;
        title: '&Help';
        selector: nil;
        appendItem: '&Contents' selector: #displayHelpIndex;
        appendItem: '&Search for Help on...' selector: #searchHelpOn;
        appendItem: '&How to Use Help' selector: #displayHelpForHelp.
    aboutDlgClass notNil
        ifTrue: [menu appendSeparator;
            appendItem: '&About ',appName,' ...' selector:#about].
    ^menu! !

! OSHelpManager methods ! 
about
    "Private - Open a dialog window to show the product information."

    aboutDlgClass isNil
    ifTrue: [ AboutApp new open ]
    ifFalse: [ super about ]! 
defaultContext: contextId for: aWindow
    "Private - Returns the default context to search in the help file.
    1.- Try to determine context with window's owner using protocoll #helpContextFor:in:
    2.- if owner does not understand this protocol or returns nil infer heclp context
            from owner class name and contextId (appended with separator)
    3.- Else try to use super implementation (that returns the window title...).
    "

    | result owner separator |
    contextId isNil ifTrue: [ ^nil ].
    separator := $:. "Character for context build (aWindow owner class name appended to contextId with separator)"

    owner := aWindow notNil ifTrue: [aWindow owner].
    (owner respondsTo: #helpContextFor:in:)
    ifTrue: [ result := owner helpContextFor: contextId in: aWindow ].

    result isNil ifTrue: [
        result := (owner isNil or: [contextId isString not])
            ifTrue: [super defaultContext: contextId for: aWindow]
            ifFalse: [ owner class name,(String with: separator),contextId ]
    ].

    "
    Smalltalk isRunTime ifFalse: [
        Transcript
            cr;show: 'Searching for help...';
            cr;show: '  contextId:',contextId asString,' for window: ', aWindow asString,' result:',result asString.
    ].
    "

    ^result!  
helpMenu
    "Private - Answer the Help menu."

    | tab |
    tab := String with: Tab.
    ^HelpMenu new
        owner: self;
        title: 'A&yudas';
        selector: nil;
        appendItem: '&Indice...',tab,'F1' selector: #displayHelpIndex accelKey: VkF1 accelBits: AfVirtualkey;
        appendItem: '&Buscar ayuda sobre...',tab,'Alt+F1' selector: #searchHelpOn accelKey: VkF1 accelBits: AfVirtualkey|VkControl ;
        appendItem: 'Ayuda de &pantalla...',tab,'Shift+F1' selector: #helpPick;
        appendSeparator;
        appendItem: '&Como usar las ayudas' selector: #displayHelpForHelp;
        appendItem: 'Curso &Tutorial' selector: #openTutorial;
        appendSeparator;
        appendItem: 'T&ruco del dia...' selector: #tipOfTheDay;
        appendSeparator;
        appendItem: '&Orden de compra...' selector: #printOrderForm;
        appendItem: '&Registracin...' selector: #printRegisterForm;
        appendItem: '&Soporte Tcnico...' selector: #technicalSupport;
        appendSeparator;
        appendItem: '&Acerca de este producto...' selector: #about;
        yourself!   
helpPick
    "Sets the receiver in helpMode..."

   self turnOnHelpMode!   
openTutorial
    "Open the Tutorial..."

    (applicationWindow owner respondsTo: #openTutorial)
    ifTrue: [ applicationWindow owner openTutorial ]!
printOrderForm
    "Prints an Order Form"

    (applicationWindow owner respondsTo: #printOrderForm)
    ifTrue: [ applicationWindow owner printOrderForm ]!  
printRegisterForm
    "Prints a Registration Form"

    (applicationWindow owner respondsTo: #printRegisterForm)
    ifTrue: [ applicationWindow owner printRegisterForm ]!   
technicalSupport
    "Display the technicalSupport dialog"

    (applicationWindow owner respondsTo: #technicalSupport)
    ifTrue: [ applicationWindow owner technicalSupport ]! 
tipOfTheDay
    "Lets the user vew the tips of the day dialog"

    LogoView new open.! !

! Icon class methods !
fromFile: fileName
        "Answer an instance of Bitmap copied from fileName.
         fileName must have a '.ico' extension..
    Touched By Ale..."
    |type dibHeaderSize bih dibOffset
     bi xorMaskHandle rgbColor xorMask andMask
    flippedAndMask andMaskSize icon file monoWidthSize|
    #modifiedByOStyle.

    file := (File pathName: fileName) asByteFileStream.

    file position: 2.
    (type := file nextUShort) ~= 1 ifTrue:[
        ^ self error:'Resource is not an Icon'].
    file position: 18.
    dibOffset := file nextULong.
    file position: dibOffset.
    bih := Bitmap readBitmapHeader: file.

    rgbColor := ByteArray new: ((1 bitShift: bih bitCount) * 4).
    1 to: rgbColor size do: [: i |
        rgbColor at: i put: file nextByte].

    andMaskSize := (bih width / 8 * bih width).
    bih height: bih height // 2.
    bih sizeImage: bih sizeImage - andMaskSize.

    xorMask := ByteArray new:  bih sizeImage.
    andMask := ByteArray new: andMaskSize.
    1 to: xorMask size do: [: i |
        xorMask at: i put: file nextByte].
    1 to: andMask size do: [: i |
        andMask at: i put: file nextByte].
    file close.

    bi := bih contents, rgbColor.
    xorMaskHandle := GDILibrary
                createDIBitmap: Display pen handle
                infoHeader: bih asParameter
                dwUsage: CbmInit
                initBitsStruct: xorMask
                initInfo: bi
                wUsage: DibRgbColors.

    flippedAndMask := ByteArray new: andMask size.
    monoWidthSize := bih width / 8.
"    1 to: bih height do: [:i|
        1 to: monoWidthSize do: [:j|
            flippedAndMask at: i - 1 * monoWidthSize  + j
                                    put: (andMask at: andMask size
                                                - (i * monoWidthSize) + j)]]. "
    icon := super new
        initialize;
        readOnly: false;
        andMask: (Bitmap new
            width: bih width
            height: bih height
            bits: andMask);
        xorMask: (Bitmap fromHandle: xorMaskHandle);
        createIcon.
    GDILibrary deleteObject:xorMaskHandle asParameter.
    ^ icon!
fromModule: library id:anId
    "Answer an Icon object. library is a DLL file name or a Dynalink
     anId can be a string or an Integer
    Touched by Ale for dynalink support..."

    #modifiedByOStyle.
    library isString ifFalse: [ "try to find the fileName"
        (library class respondsTo: #fileName)
        ifTrue: [^self fromModule: library class fileName id:anId]
    ].

    ^super new
        initialize;
        fromModule: library id:anId! 
fromModule:aFileName name: anId
    "Answer an Icon object. aFileName is a DLL file name
    anId can be a string or an Integer
    Returns a valid icon, or nil.
    Touched by LRP 24/JUN/93 "
    | icon |
    #modifiedByOStyle.
    anId isNil ifTrue: [^nil].
    (anId isString and: [anId isEmpty]) ifTrue: [^nil].
    icon := self fromModule:aFileName id: anId.
    icon handle = Icon runtimeIcon
    ifTrue: [ icon release. ^nil ] ifFalse: [ ^icon ].! !

! Icon methods !   
asPointer
   "Answer the receiver as a Pointer.
    Implemented by Ale..."
    #addedByOStyle.
    ^self asPointerWithHotSpot:
            self extent // 2! 
asPointerWithHotSpot: aPoint
    "Answer a WINDOWS pointer with the same image
    as the receiver and aPoint as its hot spot.
    Implemented by Ale..."
    #addedByOStyle.
    ^CursorManager new
            handle: (
                WinHandle fromInteger: (
                    self pointerHandle: aPoint))! 
displayAt: aPoint with: aPen
    "Display the receiver through aPen.
    Implemented by Ale..."
    #addedByOStyle.
    UserLibrary
        drawIcon: aPen handle
        x: aPoint x asParameter
        y: aPoint y asParameter
        hIcon: self handle.!
dragFrom: aPoint in: aWindow
    "Answer the last origin (relative to aWindow) of the icon
     being dragged starting from aPoint.
    Added by Ale for simple drag&drop support...
    Implemented by Ale..."
    | hotSpot loc cursor win oldWin action topCornerOffset |
    #addedByOStyle.
    hotSpot := "0 @ self extent y" aPoint "- origin".
    topCornerOffset := hotSpot - (0 @ self "visibleE"extent y).
    oldWin := aWindow.
    (cursor := self asPointerWithHotSpot: hotSpot) changeFor:
        [Notifier consumeInputUntil: [:event |
            (event selector = #button1Move: or: [
            event selector = #button2Move:])
                ifTrue: [
                    aWindow mouse: (
                        event arguments at: 1).
                    aWindow event: #iconDrag.
                    win := Window windowFromPoint:
                        Cursor sense - topCornerOffset.
                    oldWin == win ifFalse: [
                        (oldWin respondsTo: #iconLeaving:) ifTrue: [
                            oldWin iconLeaving: self].
                        (win respondsTo: #iconAcceptable:)
                            ifTrue: [
                                (win iconAcceptable: self)
                                    ifTrue: [cursor change]
                                    ifFalse: [CursorManager stopSign change]]
                            ifFalse: [CursorManager stopSign change].
                        oldWin := win].
                    (win notNil and: [win respondsTo: #iconPassing:])
                        ifTrue: [
                            win iconPassing: self]].
            (event selector = #button1Up:) or: [
                event selector = #button2Up:]]].
    loc := Cursor sense.
    action :=
        (Notifier isKeyDown: VkControl)
            ifTrue: [#copy]
            ifFalse: [
                   " (Notifier isKeyDown: VkAlt)
                        ifTrue: [#move]
                        ifFalse: [        "
                            (Notifier isKeyDown: VkShift)
                                ifTrue: [#clone]
                                ifFalse: [#none]].
    cursor destroy.
    ^Association
        key: action
        value: ((loc mapToWindow: aWindow handle)
            - hotSpot
            extent: self "visibleE"extent)!
height
    ^self extent y!   
pointerHandle: hotSpot
    "Private - Answer the pointer handle created from the receiver.
    Implemented by Ale..."
    | pointer bitmap readable |
    #addedByOStyle.
    self readOnly
    ifTrue: [
        readable := self readable.
        pointer := readable pointerHandle: hotSpot.
        readable release.
        ^pointer
    ].
    bitmap := Bitmap extent: xorMask extent.
    bitmap pen copyBitmap: xorMask
        from: xorMask boundingBox
        at: 0 @ 0.
    pointer := UserLibrary createCursor: WIN hInstance
         xHotSpot: hotSpot x
         yHotSpot: hotSpot y
         width: self extent x
         height: self extent y
         andBits: andMask getDDBits
         xorBits: bitmap getDDBits.
    bitmap release.
    ^pointer!   
readable
    "Private - Answer the receiver copied as a not readOnly icon.
    Implemented by Ale..."
    | and xor |
    #addedByOStyle.
    xor := Bitmap width: self extent x height: self extent y.
    and := Bitmap width: self extent x height: self extent y.
    xor pen reverse: (0@0 extent: self extent).
    self displayWith: xor pen.
    self displayWith: and pen.
    "
    and displayAt: 0@0.
    xor displayAt: xor width + 1 @0.
    "
    ^self class fromBitmap: xor andMask: and!  
width
    "Implemented by Ale?..."
    #addedByOStyle.
    ^self extent x! !

! Loader methods ! 
changeCursor
    "Private - Change the cursor to reading...
    The cursor will be changed only
    if the current cursor is the default cursor"

    Cursor == CursorManager normal
    ifFalse: [^self].
    CursorManager execute change!   
classIndexFor: aClass
    "Unloading - Answer the string for the class of the next
     object to be unloaded."
    | index |
    index := classDict at: aClass
        ifAbsent: [
            classDict at: aClass put: objectNumber.
            ^aClass name].
    ^'%',index printString!
forwardRefs
    "Answer the dictionary of forward references found
     so far by the loader"
    ^forwardRefs!
getClass
    "Loading - Answer the class of the next object in the file"
    | classString char index num |
    (char := stream next) == $%
        ifTrue: [^(loader at: (num := stream upTo: Lf) asInteger) class].
    classString := (String with: char) , (stream upTo: Lf).
    ^Smalltalk at: classString asSymbol!  
getSize
    "Loading - Answer the next object size"
    ^(stream upTo: Lf) asInteger!   
invalidRoot: aClass
    "An object of this class cant be unloaded..."
    ^self error: aClass name ,' objects can''t be unloaded'!  
load: anObject
    "Loading - Load the next object from the file"
    | index instVar nextChar newRef anArray|
    index := 1.
    anObject class isBytes
        ifTrue: [
            anObject isFloat ifTrue: [
                anArray := ByteArray new: loaderIndex.
                stream getBytesFor: anArray.
                stream next.
                1 to: loaderIndex do: [:i |
                    anObject at: i put: (anArray at: i) ].
                ^self
            ].
            stream getBytesFor: anObject.
            stream next.
            ^self].
    "anObject class is pointers"
    [index <= loaderIndex]
        whileTrue: [
            nextChar:= stream peek.
            instVar:= self nextInstVar.
            anObject instVarAt: index put: instVar.
            (((nextChar == $%) and: [instVar isMemberOf: SmallInteger])
                            and: [instVar >= objectNumber])
               ifTrue: [newRef:= ForwardReference new loaderNumber: instVar
                                   object: anObject objectIndex: index.
                        anObject instVarAt: index put: newRef.
                        (forwardRefs includesKey: instVar)
                            ifFalse: [forwardRefs at: instVar
                                        put: (OrderedCollection with: newRef)]
                            ifTrue: [(forwardRefs at: instVar) add: newRef]].
           index := index + 1]!  
loaderIndex
    "Loading - Indicates the size of the next object in the file.
     Unloading - Used as an object reference pointer"
    ^loaderIndex!  
loadFrom: aStream
    "Load Smalltalk/V286 objects from aStream and return root
     Touched by Ale  14 Nov 1990;11:27:32
     Touched by Ale  1   Set 1991;12:07:32; #next support"
    | numOfObjects anObject cursor |
    stream := self streamFrom: aStream.
    numOfObjects := (stream upTo: Lf) trimBlanks asInteger.
    numOfObjects = 0 ifTrue: [^nil].
    cursor := Cursor.
    CursorManager execute change.
    loader := Array new: numOfObjects.
    forwardRefs:= Dictionary new.
    objectNumber := 1.
    [objectNumber <= numOfObjects]
        whileTrue: [
            loader at: objectNumber put: String new.
            objectNumber := objectNumber + 1].
    objectNumber := 1.
    [objectNumber <= numOfObjects]
        whileTrue: [self next].
    loader do: [:each| each rehash].
    cursor change.
    ^loader at: 1! 
loadInstance
    "Loading - Create an empty instance of the next object
     in the file
     Touched by Ale  14 Nov 1990;11:28:52"
    | class |
    class := self getClass.
    loaderIndex := self getSize.
    ((class inheritsFrom: Set) or: [(class inheritsFrom: OrderedCollection)])
        ifTrue: [^class new: loaderIndex - (class instSize - 1)].
    class isVariable
        ifTrue: [^class basicNew: loaderIndex - class instSize]
        ifFalse: [^class basicNew]!
next
    "Loading - Returns the next object from input stream.
     Created By Ale for streaming support"
    | anObject |
    "load empty object"
    anObject := self loadInstance.
    "update reference"
    loader at: objectNumber put: anObject.
    "load internals"
    (loader at: objectNumber) loadBy: self.
    "update forward refs"
    (forwardRefs at: objectNumber ifAbsent: [''])
        do: [:ref| ref object instVarAt: ref objectIndex put: anObject].
    "inc object count"
    objectNumber := objectNumber + 1.
    ^anObject!  
nextInstVar
    "Loading - Answer the next instance variable from the stream.
     Touched By Ale for packed format support"
    | char ptr answer classString size |
    char := stream next.
    char == Lf ifTrue: [^nil]. "empty line == nil"
    char == $%
        ifTrue: [
            ptr := stream upTo: Lf.
            ptr = 't' ifTrue: [^true].
            ptr = 'f' ifTrue: [^false].
            ptr = 'n' ifTrue: [^nil].
            ptr asInteger >= objectNumber
              ifTrue: [^ptr asInteger]
              ifFalse:[^loader at: ptr asInteger]].
    char == $-
        ifTrue: [^(stream upTo: Lf) asInteger negated].
    char isDigit
        ifTrue: [^((String with: char), (stream upTo: Lf)) asInteger].
    char == $$  ifTrue: [^(stream upTo: Lf) first].
    char == $#  ifTrue: [^(stream upTo: Lf) asSymbol].

    (char == $t or: [char == $f]) ifTrue: [stream upTo: Lf. ^char == $t].

    char == $!!
        ifFalse: [
            classString := (String with: char),
                (stream upTo: Lf).
            size := classString size.
            (size > 6
                and: [(classString copyFrom: size - 5 to: size) = ' class'])
                ifTrue: [
                    classString := classString
                        copyFrom: 1 to: size - 6.
                    ^(Smalltalk at: classString asSymbol) class].
            ^Smalltalk at: classString asSymbol].
    stream peek == $!!
        ifTrue: [
            answer := (Compiler evaluate: stream nextChunk)
                fileInFrom: stream]
        ifFalse: [answer := Compiler evaluate: stream nextChunk].
    ^answer! 
objectNumber
    "Loading - How many objects have been loaded.
       including the current object.
     Unloading - Number of objects written to the
       stream so far"
    ^objectNumber!   
stream
    "Answer the stream of the receiver"
    ^stream! 
streamFrom: aStream
    "Builds a FileStream (on Disk)
     from aStream if it is a String
     Created by Ale  16 Nov 1990;10:20:11
     Touched by Ale for fast reading... "
    ^(aStream isKindOf: String)
    ifFalse: [
        aStream class == FileStream
        ifTrue: [FastFileStream new fromFileStream: aStream]
        ifFalse: [aStream]
    ]
    ifTrue:  [
        File fastPathName: (
            (aStream includes: $.)
             ifTrue:  [aStream]
             ifFalse: [aStream,'.sto'])
    ]! 
unload: anObject
    "Unloading - unload anObject to the stream.
     Touched by Ale for fast saving..."
    | size index |
    size := anObject class instSize + anObject basicSize.
    stream
        nextPutAll: (self classIndexFor: anObject class);
        nextPut: Lf;
        nextPutAll: size printString;
        nextPut: Lf.
    index := 1.
    anObject class isPointers
        ifTrue: [
            [index <= size]
                whileTrue: [
                    stream nextPutAll: (self unloadIndexFor:
                        (anObject instVarAt: index)).
                    index := index + 1.
                    stream nextPut: Lf].
            ^self].
    anObject class isBytes
        ifTrue: [
            stream nextPutAll: anObject. "for fast writing..."
            "
            [index <= size]
                whileTrue: [
                    stream nextPut: (anObject at: index) asCharacter.
                    index := index + 1].
            "
            ^stream nextPut: Lf].
    anObject class isWords
        ifTrue: [
            [index <= size]
                whileTrue: [
                    stream nextPut: ((anObject at: index) // 256) asCharacter.
                    stream nextPut: ((anObject at: index) \\ 256) asCharacter.
                    index := index + 1].
            ^stream nextPut: Lf]! 
unload: anObject on: aStream
    "Unload anObject on aStream
     Touched by Ale  14 Nov 1990;11:32:24"
    | class cursor place |
    (anObject isKindOf: Behavior)
        ifTrue: [^self invalidRoot: anObject class].
    class := anObject class.
    (class == UndefinedObject
     or: [class == Symbol
     or: [class == Character
     or: [(anObject isKindOf: Boolean)
     or: [anObject isKindOf: Integer]]]])
        ifTrue: [^self invalidRoot: class].
    stream := self streamFrom: aStream.
    place  := stream position.
    loaderIndex  := 1.
    objectNumber := 1.
    loader       := IdentityDictionary new.
    classDict    := IdentityDictionary new.
    loaderQueue  := OrderedCollection new.
    stream   "place for object count"
        nextPutAll: '        ';
        nextPut: Lf.
    loader at: anObject put: 1.
    loaderQueue addLast: anObject.
    cursor := Cursor.
    CursorManager execute change.
    [loaderQueue isEmpty]
        whileFalse: [
            loaderQueue removeFirst unloadBy: self.
            objectNumber := objectNumber + 1].
    stream
        position: place;
        nextPutAll: ((loaderIndex printString , '       ')
            copyFrom: 1 to: 7).
    cursor change!
unloadIndexFor: anObject
    "Unloading -- Answer the external string representation for
     anObject used in the unload stream."
    | tempInt |
    anObject == nil
        ifTrue: [^''   "... '%n'  "]. "touched by Ale..."
    anObject == true
        ifTrue: [^'t'   "...  '%t' " ]. "touched by Ale..."
    anObject == false
        ifTrue: [^'f'   "...  '%f' " ]. "touched by Ale..."

    anObject isBehavior ifTrue: [^anObject name]. "touched by Ale..."

    anObject isInteger ifTrue: [^anObject printString]. "touched by Ale..."

    anObject isCharacter ifTrue: [^String with: $$ with: anObject]. "touched by Ale..."

    anObject class == Symbol ifTrue: [^'#',anObject].

    tempInt := loader at: anObject
    ifAbsent: [
        loaderIndex := loaderIndex + 1.
        loaderQueue addLast: anObject.
        loader at: anObject put: loaderIndex
    ].

    ^'%', tempInt printString! !

! Character class methods ! 
leadByte: aCharacter1 trailByte: aCharacter2
        "Answer the character whose high-order byte
         is the code point value of aCharacter1 and
         whose low-order byte is the code point value
         of aCharacter2."
    ^self value:
        ((aCharacter1 asInteger bitShift: 8) + aCharacter2 asInteger)!
value: anInteger
        "Answer the character whose code point
         value is anInteger."
    (0 > anInteger or: [65535 < anInteger])
        ifTrue: [self error: 'Character value out of range 0..65535'].
    (255 < anInteger)
        ifTrue: [  " double-byte characters may not be unique "
            ^(self basicNew) instVarAt: 1 put: anInteger; yourself].
    "The following takes advantage of the fact that in our system
        consecutive characters in the ASCII sequence [0..255] have
        consecutive object pointer numbers"
    ^AllCharacters at: (anInteger + 1)! !

! Character methods !
< aCharacter
        "Answer true if the receiver occurs before aCharacter
         in the current sort sequence, else answer false."
    ^NationalLanguage character: self  isLessThan: aCharacter!   
<= aCharacter
        "Answer true if the receiver occurs before or at the same
         position as aCharacter in the current sort sequence,
         else answer false."
    ^NationalLanguage character: self  isLessThanOrEqualTo: aCharacter!
= aCharacter
        "Answer true if the receiver code point value
         is equal to the code point value of aCharacter,
         else answer false."
    ^(aCharacter isCharacter)
        ifTrue: [asciiInteger = aCharacter asciiValue]
        ifFalse: [false]! 
> aCharacter
        "Answer true if the receiver occurs after aCharacter
         in the current sort sequence, else answer false."
    ^NationalLanguage character: self  isGreaterThan: aCharacter! 
>= aCharacter
        "Answer true if the receiver occurs at the same position
         or after aCharacter in the current sort sequence,
         else answer false."
    ^NationalLanguage character: self  isGreaterThanOrEqualTo: aCharacter! 
asLowerCase
        "Answer the lower case value of the receiver
         if it is a letter, else answer the receiver."
    ^NationalLanguage asLowerCase: self!   
asUpperCase
        "Answer the upper case value of the receiver
         if it is a letter, else answer the receiver."
    ^NationalLanguage asUpperCase: self!   
isDigit
        "Answer true if the receiver is in the range
         of characters from 0 to 9 or any other character
         as defined by the current system language, 
         else answer false."
    ^(asciiInteger > 47 and: [asciiInteger < 58])
        ifTrue: [true]
        ifFalse: [NationalLanguage isDigit: self].!  
isDoubleByte
        "Answer whether the receiver is a double-byte character."
    ^asciiInteger > 255! 
isLeadByte
        " Answer whether the receiver is a lead byte code
        in the current national language. "
    ^self isLeadByte: (NationalLanguage leadBytes)!   
isLeadByte: leadByteFlags
        " Answer whether the receiver is the lead byte of a DBC
        encoding.  The leadByteFlags is an array [1..255] of Booleans,
        indexed by the receiver's code point value. "
    (asciiInteger = 0) ifTrue: [^false].
    (asciiInteger > 255)
        ifTrue: [^self error: 'Character out of byte range [1..255]'].
    ^leadByteFlags at: asciiInteger!   
isLetter
        "Answer true if the receiver is in the range of
         of characters from a and z or in the range from
         A and Z or a letter as defined by the current
         system language, else answer false."
    ^((asciiInteger > 64 and: [asciiInteger < 91])
        or: [asciiInteger > 96 and: [asciiInteger < 123]])
        ifTrue: [true]
        ifFalse: [NationalLanguage isLetter: self].!  
isLowerCase
        "Answer true if the receiver is a lower-case letter,
         else answer false."
    ^NationalLanguage isLowerCase: self! 
isSeparator
        "Answer true if the receiver character is either a
         space, tab, carriage-return, line-feed, form-feed
         character, or double-byte space, else answer false."
    ^self == Space
        or: [self == Tab
            or: [self == Cr
                or: [self == Lf
                    or: [self == Ff
                        or: [self = DoubleByteSpace]]]]]!
isSingleByte
        "Answer whether the receiver is a single-byte character."
    ^asciiInteger < 256! 
isUpperCase
        "Answer true if the receiver is an upper-case letter,
         else answer false."
    ^NationalLanguage isUpperCase: self!
isWhitespace
        "Answer true if the receiver is white space,
        else answer false."
    ^self asInteger <= Space asInteger
        or: [ self = DoubleByteSpace ]!  
leadByte
        "Answer the character corresponding to the receiver's lead byte."
    ^(asciiInteger bitShift: -8) asCharacter!
printOn: aStream
        "Append the character representation of
         the receiver to aStream."
    aStream nextPut: $$.
    (NationalLanguage isDoubleByteCp not and: [self isDoubleByte])
        ifTrue: [aStream nextPut: self leadByte; nextPut: self trailByte]
        ifFalse: [aStream nextPut: self]! 
trailByte
        "Answer the character corresponding to the receiver's trail byte."
    ^(asciiInteger \\ 256) asCharacter! !

! Date class methods !
calendarForMonth: aSymbol year: anInteger
    "Answer a String containing the formatted calendar
     for the month name aSymbol in the year anInteger.
     Touched for international language support"
    | aStream index daysInMonth firstDayIndex daysBlank |
    #modifiedByOStyle.
    firstDayIndex := (self newDay: 1 month: aSymbol
        year: anInteger) dayIndex.
    aStream := WriteStream on: (String new: 200).
    daysInMonth := self daysInMonth: aSymbol
        forYear: anInteger.
    1 to: 7 do: [ :i |
        aStream nextPutAll: (((self nameOfDay: i) asString) copyFrom: 1 to: 2).
        aStream nextPut: $ ].
    aStream cr.
    daysBlank := firstDayIndex \\ 7.
    index := 1.
    [index <= daysBlank ]
        whileTrue: [
            aStream nextPutAll: '   '.
            index := index + 1].
    1 to: 9 do: [ :i |
        index > 7
            ifTrue: [
                index := 1.
                aStream cr].
        aStream space.
        i printOn: aStream.
        aStream space.
        index := index + 1].
    10 to: daysInMonth do: [ :i |
        index > 7
            ifTrue: [
                index := 1.
                aStream cr].
        i printOn: aStream.
        aStream space.
        index := index + 1].
    ^aStream contents!   
dateArray: aString
        "Added by OSI - Answer an array containg the
         the elements of Date specified by aString.  aString
         must represent a date in one of three formats:
         'Dec 31, 1989' or '31 Dec 1989' or '12/31/89'
         but the delimiters between the month, day and
         year can be any sequence of non-alphanumeric
         characters. The array is ordered #( day Month Year )"
    | aStream word1 word2 month year |
    #addedByOSI.
    aStream := aString asStream.
    word1 := aStream nextWord.
    word1 isNil ifTrue: [ ^#(0 0 0)].
    word1 := word1 asLowerCase.
    word2 := aStream nextWord.
    word2 isNil ifTrue: [ ^#(0 0 0)].
    word2 := word2 asLowerCase.
    year := aStream nextWord.
    year isNil ifTrue: [ ^#(0 0 0)].
    year := year asLowerCase asInteger.
    year < 100 ifTrue: [
        year < 60 ifTrue: [
            year := year + 2000
        ] ifFalse: [
            year := year + 1900
        ].
    ].

    word1 first isLetter ifTrue: [ " 'jan 1 1990' style"
        month := MonthNames at: (MonthStrings at: word1 ifAbsent: [ 0 ]) ifAbsent: [ 0 ].
        ^Array
            with: word2 asInteger
            with: month
            with: year
    ].

    word2 first isLetter ifTrue: [ " '1 jan 1990' style"
        month := MonthNames at: (MonthStrings at: word2 ifAbsent: [ 0 ]) ifAbsent: [ 0 ].
        ^Array
            with: word1 asInteger
            with: month
            with: year
    ].

    " must be '1/20/90' or 1/20/1990' style"
    ^Array
        with: word2 asInteger
        with: word1 asInteger
        with: year!  
dayNames
        "Answer the class variable that contain
         the associations between the day name
         as symbols and the day indices."
    #modifiedByOStyle.
    ^DayNames.! 
dayOfWeek: aSymbol
    "Answer a number from 1 to 7 indicating the
     weekday number for aSymbol (1 meaning Monday,
     to 7 meaning Sunday).
     Touched for international language support"
    #modifiedByOStyle.
    ^DayNames at: aSymbol
        ifAbsent: [ self errorInDay ]!  
fromString: aString
        "Answer a Date specified by aString.  aString
         must represent a date in one of three formats:
         'Jan 2, 1990'  or '2 Jan, 1990' or '02-01-90'
         but the delimiters between the month, day and
         year can be any sequence of non-alphanumeric
         characters."
    | aStream field1 field2 field3 day month year check temp |
    #modifiedByOStyle.
    aStream := aString asStream.
    check := [
        (month between: 1 and: 12)
        ifFalse: [ temp := day. day := month. month := temp ]
    ].
    field1 := aStream nextWord.
    (DayNames includesKey: field1 asSymbol)
        ifTrue: [field1 := aStream nextWord].
    field2 := aStream nextWord.
    (field2 equalsIgnoreCase:  'of')
        ifTrue: [field2 := aStream nextWord].
    field3 := aStream nextWord.
    year := field3 asInteger.
    year < 100 ifTrue: [year := year + 1900].

    field1 first isLetter                            " 'Jan 2, 1990' format"
        ifTrue: [
            month := self monthNameFromString: field1.
            day := field2 asInteger.
            ^self
                newDay: day
                month: month
                year: year].

    field2 first isLetter                             " '2 Jan, 1990' format"
        ifTrue: [
            month := self monthNameFromString: field2.
            day := field1 asInteger.
            ^self
                newDay: day
                month: month
                year: year].

        "Must be '02-01-90' or 02-01-1990' style"
    (NationalLanguage dateFormat) = DfMDY                      "mm-dd--yy"
        ifTrue: [
            month := field1 asInteger.
            day := field2 asInteger.
            check value.
            ^self
                newDay: day
                month: (self nameOfMonth: month)
                year: year]
        ifFalse: [
            (NationalLanguage dateFormat) = DfDMY              "dd-mm-yy"
                ifTrue: [
                    month := field2 asInteger.
                    day := field1 asInteger.
                    check value.
                    ^self
                        newDay: day
                        month: (self nameOfMonth: month)
                        year: year]
                ifFalse: [                                          "yy-mm-dd"
                    year := field1 asInteger.
                    year < 100 ifTrue: [year := year + 1900].
                    month := field2 asInteger.
                    day := field3 asInteger.
                    check value.
                    ^self
                        newDay: day
                        month: (self nameOfMonth: month)
                        year: year]].!   
fromStringDMY: aString
    "       LRP Dic 15, 1992: modified to support 'ddmmaa'
    "
    | aStream word1 word2 month year |
    #modifiedByOStyle.
    aString size = 6 ifTrue: [
        ^self fromString: ((aString copyFrom: 4 to: 5), (aString copyFrom: 1 to: 2), (aString copyFrom: 7 to: 8))
    ]  ifFalse: [
        aStream := aString asStream.
        word1 := aStream nextWord.
        word2 := aStream nextWord.
        year := aStream nextWord.
        ^self fromString: (word2, '/', word1,'/', year)
    ]! 
indexOfMonth: aSymbol
        "Answer a number from 1 to 12 indicating
         the month index for the aSymbol."
    #modifiedByOStyle.
    ^MonthNames at: aSymbol
        ifAbsent: [self errorInMonth]!  
initialize
    "Private - Initialize the class dictionary variables
     DayNames that contain the associations between
     the day name as symbols and the day indices.
     MonthNames that contain the associations between
     the month names as symbols and the month indices.
     Touched for international language support"

    #modifiedByOStyle.
        "This is one time code so it is commented --
    DayNames := Dictionary new.
    DayNames
        at: #Mon put: 1;
        at: #Monday put: 1;
        at: #Tue put: 2;
        at: #Tuesday put: 2;
        at: #Wed put: 3;
        at: #Wednesday put: 3;
        at: #Thr put: 4;
        at: #Thursday put: 4;
        at: #Fri put: 5;
        at: #Friday put: 5;
        at: #Sat put: 6;
        at: #Saturday put: 6;
        at: #Sun put: 7;
        at: #Sunday put: 7.
    MonthNames := Dictionary new.
    MonthNames
        at: #Jan put: 1;
        at: #January put: 1;
        at: #Feb put: 2;
        at: #February put: 2;
        at: #Mar put: 3;
        at: #March put: 3;
        at: #Apr put: 4;
        at: #April put: 4;
        at: #May put: 5;
        at: #Jun put: 6;
        at: #June put: 6;
        at: #Jul put: 7;
        at: #July put: 7;
        at: #Aug put: 8;
        at: #August put: 8;
        at: #Sep put: 9;
        at: #September put: 9;
        at: #Oct put: 10;
        at: #October put: 10;
        at: #Nov put: 11;
        at: #November put: 11;
        at: #Dec put: 12;
        at: #December put: 12.--"!
monthNameFromString: aString
    "Answer a Symbol for a month name corresponding
     to the month name in aString.
     Touched for international language support"
    | aName |
    #modifiedByOStyle.
    aName := aString trimBlanks asSymbol.
    MonthNames associationsDo: [ :assoc |
        (assoc key equalsIgnoreCase: aName)
            ifTrue: [ ^assoc key ]].
    ^self errorInMonth!  
monthNames
        "Answer the class variable that contain
         the associations between the month name
         as symbols and the month indices."
    #modifiedByOStyle.
    ^MonthNames.! 
nameOfDay: anInteger
    "Answer the weekday name as a Symbol corresponding
     to the weekday index anInteger (Monday for
     index 1, to Sunday for index 7).
     Touched for international language support"
    | aName |
    #modifiedByOStyle.
    (anInteger > 7 or: [anInteger < 1])
        ifTrue: [self errorInDay].
    DayNames associationsDo: [ :assoc |
        (anInteger = assoc value) ifTrue: [
            aName isNil
                ifTrue: [ aName := assoc key ]
                ifFalse: [
                    ^(aName size > assoc key size)     "answer long name"
                        ifTrue: [ aName ]
                        ifFalse: [ assoc key]]]].
    aName isNil
        ifTrue: [ self errorInDay ]
        ifFalse: [ ^aName ].!   
nameOfMonth: anInteger
    "Answer the month name as a Symbol corresponding
     to the month index anInteger (January for index 1,
     to December for index 12).
     Touched for international language support"
    | aName |
    #modifiedByOStyle.
    (anInteger > 12 or: [anInteger < 1])
        ifTrue: [self errorInMonth].
    MonthNames associationsDo: [ :assoc |
        (anInteger = assoc value) ifTrue: [
            aName isNil
                ifTrue: [ aName := assoc key ]
                ifFalse: [
                    ^(aName size > assoc key size)     "answer long name"
                        ifTrue: [ aName ]
                        ifFalse: [ assoc key]]]].
    aName isNil
        ifTrue: [ self errorInMonth]
        ifFalse: [ ^aName ].!   
replaceDayNames: aDictionary
        "Attempt to replace the class variable that contain
         the associations between the day name and the
         day index. The day name must be a symbol
         and the day index must be between 1 and 7.
         Answer whether successful. "
    #modifiedByOStyle.
    aDictionary associationsDo: [ :assoc |
        (assoc key isSymbol and: [assoc value >= 1 and: [assoc value <= 7]])
            ifFalse: [^false]].
    DayNames := aDictionary.
    ^true.!
replaceMonthNames: aDictionary
        "Attempt to replace the class variable that contain
         the associations between the month name and the
         month index. The month name must be a symbol
         and the month index must be between 1 and 12.
         Answer whether successful. "
    #modifiedByOStyle.
    aDictionary associationsDo: [ :assoc |
        (assoc key isSymbol and: [assoc value >= 1 and: [assoc value <= 12]])
            ifFalse: [^false]].
    MonthNames := aDictionary.
    ^true.!  
shortNameOfDay: anInteger
        "Answer the short weekday name as a Symbol
         corresponding to the weekday index anInteger
         (Mon for index 1, to Sun for index 7)."
    | aName |
    #modifiedByOStyle.
    (anInteger > 7 or: [anInteger < 1])
        ifTrue: [self errorInDay].
    DayNames associationsDo: [ :assoc |
        (anInteger = assoc value) ifTrue: [
            aName isNil
                ifTrue: [ aName := assoc key ]
                ifFalse: [
                    ^(aName size < assoc key size)     "answer short name"
                        ifTrue: [ aName ]
                        ifFalse: [ assoc key]]]].
    aName isNil
        ifTrue: [ self errorInDay ]
        ifFalse: [ ^aName ].!  
shortNameOfMonth: anInteger
        "Answer the short month name as a Symbol corresponding
         to the month index anInteger (Jan for index 1,
         to Dec for index 12)."
    | aName |
    #modifiedByOStyle.
    (anInteger > 12 or: [anInteger < 1])
        ifTrue: [self errorInMonth].
    MonthNames associationsDo: [ :assoc |
        (anInteger = assoc value) ifTrue: [
            aName isNil
                ifTrue: [ aName := assoc key ]
                ifFalse: [
                    ^(aName size < assoc key size)     "answer short name"
                        ifTrue: [ aName ]
                        ifFalse: [ assoc key]]]].
    aName isNil
        ifTrue: [ self errorInMonth]
        ifFalse: [ ^aName ].! 
validateDay: dInteger month: mInteger year: yInteger
    "Added by OSI - Check the validity of the day number
     dInteger for the month aSymbol in the year yInteger.
     If the date is invalid, report the error."

    #addedByOSI.
    ^(mInteger < 1 or: [
        mInteger > 12 or: [
        dInteger < 1 or: [
        dInteger > (self
            daysInMonth: (self nameOfMonth: mInteger)
            forYear: yInteger)]]]) not!   
validateString: aString
    "Added by OSI - Validate whether aString represents
     a valid date"

    | array |
    #addedByOSI.
    array := self dateArray: aString.
    ^self validateDay: (array at: 1) month: (array at: 2) year: (array at: 3)! !

! Date methods !  
formPrint
    "Answer a string representing the receiver date in
     the form specified by the current system date format.
     Touched for international language & Control Panel support"
    | aStream |
    #modifiedByOStyle.
    aStream := WriteStream on: (String new: 8).
    self printOn: aStream.
    ^aStream contents! 
printLongOn: aStream
        "Append a string representing the receiver date
         to aStream in the form specified by the current
         system long date format."
    #modifiedByOStyle.
    self printOn: aStream
        withPicture: (NationalLanguage longDateFormat)!   
printOn: aStream
        "Append a string representing the receiver date
         to aStream in the form specified by the current
         system date format."
    | field1 field2 field3 |
    #modifiedByOStyle.
    (NationalLanguage dateFormat) = DfMDY              "mm-dd-yy"
        ifTrue: [
            field1 := self monthIndex.
            field2 := self dayOfMonth.
            field3 := self year \\ 100]
        ifFalse: [
            (NationalLanguage dateFormat) = DfDMY      "dd-mm-yy"
                ifTrue: [
                    field1 := self dayOfMonth.
                    field2 := self monthIndex.
                    field3 := self year \\ 100 ]
                ifFalse: [                                      "yy-mm-dd"
                    field1 := self year \\ 100.
                    field2 := self monthIndex.
                    field3 := self dayOfMonth ]].
    field1 <= 9 ifTrue: [ aStream nextPut: $0 ].
    field1 printOn: aStream.
    aStream nextPutAll: NationalLanguage dateSeparator.
    field2 <= 9 ifTrue: [ aStream nextPut: $0 ].
    field2 printOn: aStream.
    aStream nextPutAll: NationalLanguage dateSeparator.
    field3 <= 9 ifTrue: [ aStream nextPut: $0 ].
    field3 printOn: aStream.!
printOn: aStream withPicture: aString
        "Private - Append a string representing the receiver date
         to aStream in the form specified by the aString
         date format picture."
    | m d y value length pictureStream |
    #modifiedByOStyle.
    m := self monthIndex.
    d := self dayOfMonth.
    y := self year.
    pictureStream := aString asStream.

    [ pictureStream atEnd ] whileFalse: [
        value := pictureStream next.
        (value = $M or: [value = $d or: [value = $y]])
            ifFalse: [ aStream nextPut: value ]
            ifTrue: [
                pictureStream backupOver: value.
                value := pictureStream nextWord.
                length := value size.
                (value at: 1) = $M ifTrue: [
                    length = 1 ifTrue: [ m printOn: aStream ].
                    length = 2 ifTrue: [
                        m <= 9 ifTrue: [ aStream nextPut: $0 ].
                        m printOn: aStream ].
                    length = 3 ifTrue: [
                        (self  class shortNameOfMonth: m) printOn: aStream ].
                    length = 4 ifTrue: [
                        (self  class nameOfMonth: m) printOn: aStream ] ]
                ifFalse: [
                    (value at: 1) = $d ifTrue: [
                        length = 1 ifTrue: [ d printOn: aStream ].
                        length = 2 ifTrue: [
                            d <= 9 ifTrue: [ aStream nextPut: $0 ].
                            d printOn: aStream ].
                        length = 3 ifTrue: [
                            (self  class shortNameOfDay: self dayIndex) printOn: aStream ].
                        length = 4 ifTrue: [
                            (self  class nameOfDay: self dayIndex) printOn: aStream ] ]
                    ifFalse: [
                        (value at: 1) = $y ifTrue: [
                            length = 2
                                ifTrue: [ y \\ 100 printOn: aStream ]
                                ifFalse: [ y printOn: aStream ] ] ].
                ].
            ].
        ].! 
printShortOn: aStream
        "Append a string representing the receiver date
         to aStream in the form specified by the current
         system short date format."
    #modifiedByOStyle.
    self printOn: aStream
        withPicture: (NationalLanguage shortDateFormat)! !

! Number methods !
asNumber
    "Returns the receiver.
    Implemented by LRP"
    #addedByOStyle.
    ^self!
dpiFromDpm
    "Convert from dots per meter to dots per inch.
    Implemented by Ale..."
    #addedByOStyle.

    ^ self "dpm" * 254 + 5000 / 10000! 
dpmFromDpi
    "Convert from dots per inch to dots per meter.
    Implemented by Ale..."
    #addedByOStyle.

    ^ self "dpi" * 10000 + 127 / 254!  
isFraction

    "Added by OSI"
    #addedByOSI.
    ^(self = self truncated) not! 
printFraction: numberFractionDigits
    "Answer a string, the ASCII representation
     of the receiver truncated to numberFractionDigits
     decimal places.
     Touched for international language support"
   | stream fraction integer |
    #modifiedByOStyle.
    numberFractionDigits < 0
        ifTrue: [self error: 'Negative digit count'].
    stream := WriteStream on: (String new: 16).
    integer := self truncated.
    (self > -1) & (self < 0)
        ifTrue: [stream show: '-0']
        ifFalse: [integer printOn: stream].
    stream nextPutAll: NationalLanguage decimalSeparator.
    fraction := (self - integer) abs.
    integer := 0.
    numberFractionDigits timesRepeat: [
        fraction := (fraction - integer) * 10.
        (integer := fraction // 1) printOn: stream].
    ^stream contents! !

! Float class methods ! 
fromString: aString
    "Answer the floating point conversion of the receiver;
     the receiver is expected to be a sequence of
     the form [(+|-)] [digits] [decSep [digits] ] [(E|e) [(+|-) digits]].
     Touched for international language support"
    | string integer fraction exponent char index decSep |
    #modifiedByOStyle.
    aString size = 0 ifTrue: [^0.0].
    (char := aString at: 1) = $-
        ifTrue: [ ^(aString copyFrom: 2 to: aString size) asFloat negated].
    decSep := NationalLanguage decimalSeparator.
    string := aString, decSep, 'Ez'.
    integer := index := 0.
    char = $+
        ifTrue: [index := 1].
    [(char := string at: (index := index + 1)) isDigit]
        whileTrue: [integer := integer * 10 + char digitValue].
    fraction := 1.
    char = (decSep at: 1)
        ifTrue: [
            [(char := string at: (index := index + 1)) isDigit]
                whileTrue: [
                    integer := integer * 10 + char digitValue.
                    fraction := fraction * 10]].
    (char = $E or: [char = $e])
        ifTrue: [exponent := (string copyFrom: index+1 to: string size) asInteger]
        ifFalse: [
            integer = 0 ifTrue: [^0.0].
            exponent := 0].
    integer = 0 ifTrue: [^0.0].
    exponent := 10 raisedToInteger: exponent.
    ^((integer / fraction) * exponent) asFloat! !

! Float methods !
printOn: aStream
    "Append the ASCII representation (maximum of 8 digits) of
     the receiver to aStream.
     Touched for international language support"
    #modifiedByOStyle.
    self printOn: aStream
        decimalSeparator: NationalLanguage decimalSeparator! 
replaceBytesFrom: byteStart
    to: byteStop
    with: aByteObject
    startingAt: byteRepStart
        "Private - replace the bytes of the receiver at index
         positions start through stop with consecutive
         bytes of aByteObject beginning at index
         position repStart.  Answer the receiver."
    | index1 index2 |
    <primitive: 129>
    #modifiedByOStyle.
    aByteObject class isBytes
        ifFalse: [self error: 'source must be a byte object'].
    (self == aByteObject and: [byteRepStart < byteStart])
        ifTrue: [ "do backward move for same object"
            index2 := byteRepStart + byteStop - byteStart.
            index1 := byteStop.
            [byteStart <= index1]
                whileTrue: [
                self
                    at: index1
                    put: (aByteObject basicAt: index2) asInteger.
                index1 := index1 - 1.
                index2 := index2 - 1].
            ^self].
    "do forward move"
    index2 := byteRepStart.
    index1 := byteStart.
    [index1 <= byteStop]
        whileTrue: [
            self
                at: index1
                put: (aByteObject basicAt: index2) asInteger.
            index1 := index1 + 1.
            index2 := index2 + 1]! !

! Integer methods !
bitIsOn: n

    "Added by OSI"

    #addedByOSI.
    ^(self bitAnd: n) = n! !

! Time class methods !  
fromString: aString
        " Answer a Time for the value given by aString.
          aString must be in the form specified by the
          current system time format."
    | aStream hh mm ss timeSeparator timeId|
    aStream := ReadStream on: aString.
    timeSeparator := NationalLanguage timeSeparator at: 1.
    hh := (aStream upTo: timeSeparator) asInteger.       " hours "
    ((NationalLanguage isTimeFormat12Hour and: [hh = 0 or: [hh > 12]])
     or: [(NationalLanguage isTimeFormat12Hour = false) and: [hh > 23]])
        ifTrue: [^self error: 'error in hours'].
    mm := (aStream upTo: timeSeparator) asInteger.    " minutes "
    (mm > 59) ifTrue: [^self error: 'error in minutes'].
    ss := (aStream upTo: $ ) asInteger.                            " seconds "
    (ss > 59) ifTrue: [^self error: 'error in seconds'].
    timeId := aStream next: ((aStream readLimit) - (aStream position)).
    timeId := timeId trimBlanks.
    (NationalLanguage isTimeFormat12Hour)
        ifTrue: [                "12 hours"
            (hh = 12) ifTrue: [hh := 0].
            (timeId = NationalLanguage time1159)
                ifFalse: [
                    (timeId = NationalLanguage time2359)
                        ifTrue: [ hh := hh + 12]
                        ifFalse: [^self error: 'error in time string']]]
        ifFalse: [                "24 hours"
            (timeId size > 0) ifTrue: [^self error: 'invalid time string format']].
    ^self fromSeconds: ( hh * 60 + mm * 60 + ss)!  
hours: anInteger1 minutes: anInteger2 seconds: anInteger3
        "Answer a Time which represents the given
         number of hours, minutes, and seconds from
         midnight of the current day."
    #addedByOSI.
    ^self new
        seconds: (anInteger1 * 60 + anInteger2 * 60 + anInteger3)!
printMillisecondsToRun: aBlock
        "Answer the number of milliseconds it
         takes to evaluate aBlock..
    Implemented by LRP..."
    #addedByOStyle.
    Transcript cr; nextPutAll: (self millisecondsToRun: aBlock) asString! !

! Time methods !  
printOn: aStream
    "Append a string representing the receiver time
     to aStream in the form specified by the current
     system time format.
     Touched for international language support"
    | time am|
    #modifiedByOStyle.
    am := true.
    time := self hours.
    NationalLanguage isTimeFormat12Hour ifTrue: [
        time > 12
            ifTrue: [
                time := time - 12.
                am := false]
            ifFalse: [
                (time = 12)
                    ifTrue: [am := false]
                    ifFalse: [ time = 0 ifTrue: [time := 12]]]].
    (time < 10) ifTrue: [aStream nextPut: $0 ].
    time printOn: aStream.
    aStream nextPutAll: NationalLanguage timeSeparator.
    time := self minutes.
    (time < 10) ifTrue: [aStream nextPut: $0 ].
    time printOn: aStream.
    aStream nextPutAll: NationalLanguage timeSeparator.
    time := self seconds.
    (time < 10) ifTrue: [aStream nextPut: $0 ].
    time printOn: aStream.
    (NationalLanguage isTimeFormat12Hour)
        ifTrue: [
            aStream nextPutAll: ' '.
            am
                ifTrue: [aStream nextPutAll: NationalLanguage time1159]
                ifFalse: [aStream nextPutAll: NationalLanguage time2359]].! !

! Menu class methods !   
colorMenu: ownerWindow selector: aSymbol
        "Answer a Menu with the standard colors.
         When the user selects a color from the menu,
         aSymbol is sent to ownerWindow as a message
         with one argument which is the color chosen.
    Touched by Ale for color index generation...  #17-May-84"
    | menu colors |
    #modifiedByOStyle.
    colors := OrderedCollection new.
    colors
        add: #('&Blanco' ClrWhite);
        add: #('&Negro' ClrBlack);
        add: #('&Azul' ClrBlue);
        add: #('&Rojo' ClrRed);
        add: #('&Verde' ClrGreen);
        add: #('Ro&sa' ClrPink);
        add: #('C&yan' ClrCyan);
        add: #('Amar&illo' ClrYellow);
        add: #('&Gris oscuro' ClrDarkgray);
        add: #('A&zul oscuro' ClrDarkblue);
        add: #('R&ojo oscuro' ClrDarkred);
        add: #('Magenta' ClrDarkpink);
        add: #('V&erde oscuro' ClrDarkgreen);
        add: #('&Turquesa' ClrDarkcyan);
        add: #('&Marrn' ClrBrown);
        add: #('Gris &plido' ClrPalegray);
        yourself.
    menu := self
        labelArray: (colors collect: [:pair| pair first])
        lines: Array new
        selectors: (colors collect: [:pair| ColorConstants at: pair last asString ifAbsent: [0]]).
    menu
        title: '&Color';
        owner: ownerWindow;
        selector: aSymbol;
        yourself.
    ^menu

   "Original implementation...
    ^(Menu
        labels: 'White\Black\Blue\Red\Green\Pink\Cyan\Yellow\Dark gray\Pale blue\Dark red\Dark pink\Dark green\Dark cyan\Brown\Pale gray' withCrs
        lines: #()
        selectors: #(16rFFFFFF 0 16rFF0000 16rFF 16rFF00 16rFF00FF 16rFFFF00 16rFFFF 16r828282 16r800000 16r80 16r800080 16r8000  16r1000006 16r8080 16rC0C0C0))
                title: '&Color';
                owner: ownerWindow;
                selector: aSymbol;
                yourself
    "! !

! Menu methods !  
appendItem: aLabelString action: aSymbol
    "Added by OSI - create a menu item that performs an action"
    #addedByOSI.
    ^self appendItem: aLabelString action: aSymbol acceleratorString: ''!
appendItem: aLabelString action: aSymbol acceleratorString: aString
    "Added by OSI - create a menu item that performs an action"
    | aMessage |
    #addedByOSI.
    aMessage := (Message new)
            receiver: (self wbAction window: self owner action: aSymbol)
            selector: #perform
            arguments: #()
            yourself.

    self appendItem: aLabelString selector: aMessage acceleratorString: aString!  
appendItem: aLabelString link: aViewManagerClassName type: linkType
    "Added by OSI - create a menu item that links to another window"
    #addedByOSI.
    ^self appendItem: aLabelString link: aViewManagerClassName type: linkType acceleratorString: ''! 
appendItem: aLabelString link: aViewManagerClassName type: linkType acceleratorString: aString
    "Added by OSI - create a menu item that links to another window"
    | aMessage |
    #addedByOSI.
    (Smalltalk includesKey: aViewManagerClassName asSymbol) ifFalse: [
        aMessage := (Message new)
            receiver: MessageBox selector: #message:
                arguments: #('Link Menu Error!!');
            yourself.
    ] ifTrue: [
        aMessage := Message new.
        aMessage receiver: (Smalltalk at: aViewManagerClassName asSymbol).
        linkType asSymbol == #Child ifTrue: [
            aMessage selector: #openWithParent:; arguments: (Array with: self owner).
        ] ifFalse: [ linkType asSymbol == #Sibling ifTrue: [
            aMessage selector: #openWithMyParent:; arguments: (Array with: self owner).
        ] ifFalse: [
            aMessage selector: #open; arguments: #().
        ]].
    ].
    self appendItem: aLabelString selector: aMessage acceleratorString: aString!  
appendItem: aLabelString selector: aSelector acceleratorString: aString

    "Added by OSI for PM portability"

        "Append an item with label aLabelString and
         selector aSelector to the receiver menu.  Parse the
         accelerator info from aString.  aString has the following
         syntax:
            One or more of 'Ctrl', 'Alt', or 'Shift'.
            A plus sign (+).
            A single character (indicating Ctrl+S for example)
                or an integer (indicating Ctrl+Del for example).
            Examples:
                'Ctrl+S' means Control key and the S key.
                'AltShift+C' means Alt and Shift keys and the C key.
                'Ctrl+27' means Control and the Del key (VkDelete = 27)."
    | s bits bitsString key keyString |
    #addedByOSI.
    aString isEmpty ifTrue: [
        ^self appendItem: aLabelString selector: aSelector
            accelKey: nil accelBits: nil ].
    s := aString asStream.
    bitsString := s upTo: $+.
    keyString := s upTo: $+.
    keyString first isDigit
        ifTrue: [
            key := 0.
            1 to: keyString size do: [:i |
                key := key * 10 + ( keyString at: i ) digitValue ].
            key := PMToWinKeyMap at: key.
            bits := 8 "AfVirtualkey" ]
        ifFalse: [
            key := keyString first.
            bits := 0 ].
    ( bitsString includes: $C ) ifTrue: [ bits := bits | 2 ]. "AfControl"
    ( bitsString includes: $A ) ifTrue: [ bits := bits | 1 ]. "AfAlt"
    ( bitsString includes: $S ) ifTrue: [ bits := bits | 4 ]. "AfShift"
    ^self appendItem: aLabelString selector: aSelector
           accelKey: key accelBits: bits! 
asPMenuItem

    "Added by OSI"

    | item pMenu subMenu accelArray |

    #addedByOSI.
    pMenu := WBPMenuItem new.
    pMenu title: (title upTo: Tab).
    (selector isMessage and: [
        selector receiver isKindOf: WBAction]) ifTrue: [
        selector receiver receiver: nil
    ].
    pMenu selector: selector.

    1 to: self numberOfItems do: [ :i |
        item := items at: i.
        item isSubmenu ifTrue: [
            subMenu := item submenu asPMenuItem.
        ] ifFalse: [
            subMenu := WBPMenuItem new.
        ].
        subMenu isSeparator: (item style = MfSeparator).

        item contents notNil ifTrue: [
            subMenu title: (item contents upTo: Tab).
        ] ifFalse: [
            subMenu title: '--------'
        ].
        (item selector isMessage and: [
            item selector receiver isKindOf: WBAction]) ifTrue: [
            item selector receiver receiver: nil
        ].
        subMenu selector: item selector.

        accelArray := accel at: i.
        accelArray notNil ifTrue: [
            subMenu accelerator: (
                WBKeyAccel new
                    accelArray: accelArray;
                    yourself
            ).
        ].
        pMenu addChild: subMenu.
     ].

    ^pMenu!  
asWBPMenu

    "Added by OSI"
    #addedByOSI.
    ^self asPMenuItem! 
buildItem: i menu: menuNumber menuBar: menuBar

    "Modified by OSI"

        "Private - Build the i'th item in the menu indexed by
         the menuNumber of the menuBar."
    | a item afBits |
    #modifiedByOSI.
    item := (items at: i).
    item id: (menuNumber * 256 + i).
    (item submenu notNil)
        ifTrue:  [item submenu buildWindow: menuBar].
    accel size >= i ifTrue: [
        (accel at: i) notNil ifTrue: [
            a := accel at: i.
            1 to: a size // 2 do:[:index|
                afBits := a at: index * 2.
                afBits notNil ifTrue: [
                    afBits := afBits bitAnd: 7.  "AfAlt | AfShift | AfControl"
                ].
                menuBar accelTable
                    at: (Array with: (a at:index * 2 - 1) with: afBits )
                    put: (menuNumber * 256 + i)]]].
    window insertItem: item label: item contents.!   
clearPopup
    "Added by OSI"
    #addedByOSI.
    popup := nil.!  
copyItemAttributes: item from: aMenu
    "Private - Copy the 'checked' and 'disabled' attributes
     to the receiver item from the corresponding item in aMenu.
    Patched by Ale 'cause a bug sends this message
     with aMenu = nil"
    | miSelf miAMenu |
    aMenu isNil ifTrue: [^self].
    miAMenu := aMenu getMenuItem: item.
    miSelf := self getMenuItem: item.
    miSelf style: miAMenu style.
    self updateItem: miSelf!  
disableAll
        "Disable all items for the receiver."
    "Added by OSI"
    #addedByOSI.
    items do: [:mi |
        mi isMenu ifTrue: [ mi disableAll ].
        self disableItem: mi selector ]! 
enableAll
        "Enable all items for the receiver."
    "Added by OSI"
    #addedByOSI.
    items do: [:mi |
        mi isMenu ifTrue: [ mi enableAll ].
        self enableItem: mi selector ]! 
getMenuItem: item ifAbsent: aBlock
        "Private - Answer the MenuItem for 'item'.
         item can be the label or the selector.
.
    Who touched this method? why?"
    #modifiedByOStyle.
    ^items at: (self getIndex: item ifAbsent: aBlock)!
insertItemDynamically: string selector: aSelector atIndex: index

    "Added by OSI"
    #addedByOSI.
    self insertItem: string
        selector: aSelector
        accelKey: nil
        accelBits: nil
        after: index.

    UserLibrary
        insertMenu: window asParameter
        position: index
        flags: items last style + MfByposition
        id: (self menuItem id - 1) + items size
        contents: string asParameter.! 
removeAllItemsDynamically

    "Added by OSI"
    #addedByOSI.
    items do: [ :item |
        self removeItemDynamically: item contents ]!  
removeItemDynamically: string

    "Added by OSI"

    | pos |
    #addedByOSI.
    pos := items indexOf: (items select: [:i | i contents = string]) first.

    UserLibrary
        deleteMenu: window asParameter
        position:  pos - 1
        flag: MfByposition! 
wbAction
    "Added by OSI"
    #addedByOSI.
    ^WBAction! !

! HelpMenu class methods !
standard
    "Returns a standard instance the receiver"
    ^self new
        withIndex;
        standard;
        withAbout: nil;
        yourself!
standardFor: anApplication
    "Returns a standard instance the receiver
        confiogured for anApplication"
    ^self new
        withIndex;
        standard;
        withAbout: anApplication;
        yourself! !

! HelpMenu methods !   
buildWindow: menuBar
        "Private - Build the host system side of the menu for the receiver.
         Set the id field for each menu item.
         The id is two bytes. First byte is the number
         assigned to the menu.  Second byte is the
         ordinal number of the item.  Thus ensuring unique ids
         across all the menus in a window.
         Answer the MenuItem for the receiver."
    | menuNumber a |
    menuNumber := menuBar newSubMenuFor: self.
    menuNumber isNil ifTrue: [^nil].
    menuItem := MenuItem new
        id: (menuNumber * 256) + 1;
        contents: 'TempText';
        submenu: self;
        style: MfString + MfPopup + MfHelp;
        yourself.
    1 to: items size do: [:i|
        self buildItem: i menu: menuNumber menuBar: menuBar].
    ^menuItem! 
initialize
    "Private - Initializes the receiver"
    super initialize.
    self
        title: '&Help';
        selector: #helpOnKey:
            "For non symbol selectors use
            the helpOnKey: symbol. For more
             detail look at Menu #selector: message"!  
standard
    "Private - Returns the standard items to the receiver"
    self
        appendItem: '&Basic Skills' selector: #helpBasics;
        appendItem: '&Glossary' selector: #helpGlosssary;
        appendSeparator ;
        appendItem: '&Keyboard' selector: #helpKeyboard;
        appendItem: '&Commands' selector: #helpCommands;
        appendItem: '&Procedures' selector: #helpProcedures;
        appendItem: 'Using &Help' selector: #helpOnHelp;
        appendSeparator!
withAbout: anApplication
    "Private - Add the About... entry to the receiver"
   anApplication isNil
    ifTrue: [
        self
            appendItem: '&About...' selector: #helpAbout
        ]
    ifFalse: [
        self
            appendItem: 'Help &on ',anApplication
                selector: anApplication;
            appendSeparator ;
           appendItem: '&About ',anApplication
                                    ,'...' selector: #helpAbout
    ]! 
withIndex
    "Private - Add the index entry to the receiver"
   self
        appendItem: '&Index' selector: #helpIndex;
        appendSeparator! !

! MDIMenu methods !
buildItem: i menu: menuNumber menuBar: menuBar
        "Private - Build the i'th item in the menu indexed by
         the menuNumber of the menuBar."
    | a item |
    item := (items at: i).
    item selector notNil ifTrue:[item id: (menuNumber * 256 + i)].
    (item submenu notNil)
        ifTrue:  [item submenu buildWindow: menuBar].
    accel size >= i ifTrue: [
        (accel at: i) notNil ifTrue: [
            a := accel at: i.
            menuBar accelTable at: a put: (menuNumber * 256 + i)]].
    window insertItem: item label: item contents.!  
isMDIMenu
        "Answer true if receiver is an instance of class
         MDIMenu, else answer false."
        "added by SNI"
    ^true! !

! Message methods !   
isMessage

    "Added by OSI"
    #addedByOSI.
    ^true! 
performDeferred
    "Perform the expression by requeueing the request.
    Implemented by Ale for deferred actions support..."

    | int |
    #addedByOStyle.
    int := Process enableInterrupts: false.
    DeferredRequests add: self.
    KeyboardSemaphore signal.
    Process enableInterrupts: int.! !

! NationalLanguageSupport class methods ! 
new
    ^super new initialize! !

! NationalLanguageSupport methods !  
asLowerCase: aCharacter
        "Answer the lower-case value of aCharacter
         if it is a letter, else answer aCharacter."
    | anInteger |
    anInteger := aCharacter asInteger.
    ((anInteger > 0) and: [anInteger < 256])
        ifTrue: [^allLowerCase at: anInteger].
    ^aCharacter!  
asUpperCase: aCharacter
        "Answer the upper-case value of the aCharacter
         if it is a letter, else answer the aCharacter."
    | anInteger |
    anInteger := aCharacter asInteger.
    ((anInteger > 0) and: [anInteger < 256])
        ifTrue: [^allUpperCase at: anInteger].
    ^aCharacter!  
character: aCharacter1 isGreaterThan: aCharacter2
        "Answer true if the aCharacter1 is greater
         than aCharacter2, else answer false."
    (aCharacter1 isDoubleByte or: [aCharacter2 isDoubleByte])
        ifTrue: [
            ^self string: (String with: aCharacter1)
            isGreaterThan: (String with: aCharacter2)]
        ifFalse: [
            ^(collateTable at: (aCharacter1 asInteger + 1)) >
            (collateTable at: (aCharacter2 asInteger + 1))]!
character: aCharacter1 isGreaterThanOrEqualTo: aCharacter2
        "Answer true if the aCharacter1 is greater than
         or equal to aCharacter2, else answer false."
    (aCharacter1 isDoubleByte or: [aCharacter2 isDoubleByte])
        ifTrue: [
            ^self string: (String with: aCharacter1)
            isGreaterThanOrEqualTo: (String with: aCharacter2)]
        ifFalse: [
            ^(collateTable at: (aCharacter1 asInteger + 1)) >=
            (collateTable at: (aCharacter2 asInteger + 1))]! 
character: aCharacter1 isLessThan: aCharacter2
        "Answer true if the aCharacter1 is less than
         aCharacter2, else answer false."
    (aCharacter1 isDoubleByte or: [aCharacter2 isDoubleByte])
        ifTrue: [
            ^self string: (String with: aCharacter1)
            isLessThan: (String with: aCharacter2)]
        ifFalse: [
            ^(collateTable at: (aCharacter1 asInteger + 1)) <
            (collateTable at: (aCharacter2 asInteger + 1))]! 
character: aCharacter1 isLessThanOrEqualTo: aCharacter2
        "Answer true if the aCharacter1 is less than
         or equal to aCharacter2, else answer false."
    (aCharacter1 isDoubleByte or: [aCharacter2 isDoubleByte])
        ifTrue: [
            ^self string: (String with: aCharacter1)
            isGreaterThanOrEqualTo: (String with: aCharacter2)]
        ifFalse: [
            ^(collateTable at: (aCharacter1 asInteger + 1)) <=
            (collateTable at: (aCharacter2 asInteger + 1))]!   
collateTable
        "Answer the current collate-sequence (sorting weight) table."
    ^collateTable!   
collateTable: aCollateTable
        "Replace the current collate-sequence (sorting weight) table."
    ^collateTable := aCollateTable.! 
compareString: aString1 withString: aString2
        "The comparison is case-sensitive.
         Answer < 0 if aString1 is less than aString2
                      = 0 if aString1 is identical to aString2
                      > 0 if aString1 is greater than aString2."
    ^UserLibrary
        lStrCmp: aString1 asParameter
        withString: aString2 asParameter! 
compareStringi: aString1 withString: aString2
        "The comparison is case-insensitive.
         Answer < 0 if aString1 is less than aString2
                      = 0 if aString1 is identical to aString2
                      > 0 if aString1 is greater than aString2."
    ^UserLibrary
        lStrCmpi: aString1 asParameter
        withString: aString2 asParameter! 
country
        "Answer the current system value for country identifier."
    ^country! 
countryName
        "Answer the current system value for country name."
    ^countryName!   
currency
        "Answer the current system value for currency symbol."
    ^currency!  
currencyDigits
        "Answer the current system value for the number of digits
         following the decimal point in a currency amount."
    ^currencyDigits!  
currencyFormat
        "Answer the current system value for currency format.
         Answer 0 = Currency symbol prefix, no separation ($1)
                      1 = Currency symbol suffix, no separation (1$)
                      2 = Currency symbol prefix, one char separation ($ 1)
                      3 = Currency symbol suffix, one char separation (1 $)."
    ^currencyFormat! 
dataSeparator
        "Answer the current system value for data/list separator."
    ^dataSeparator!
dateFormat
        "Answer the current system value for date format.
         Answer 0 = Month-Day-Year (DfMDY)
                      1 = Day-Month-Year (DfDMY)
                      2 = Year-Month-Day (DfYMD)."
    ^dateFormat! 
dateSeparator
        "Answer the current system value for date separator."
    ^dateSeparator! 
decimalLeadZero
        "Answer the current system value for decimal lead zero.
         Answer 0 = no leading zero (.7)
                      1 = leading zero (0.7)."
    ^decimalLeadZero! 
decimalPlace
        "Answer the current system value for the number of digits
         following the decimal point in a number."
    ^decimalPlace!   
decimalSeparator
        "Answer the current system value for decimal separator."
    ^decimalSeparator!
initCharacterPredicates
        "Private - Initialize the receiver's isLetter, isDigit
          allLowerCase, and allUpperCase collection for
          the system current country and language settings."
    | upper aString |
    allUpperCase := Array new: 255.
    allLowerCase := Array new: 255.
    isLetter := Array new: 255.
    isDigit := Array new: 255.
    aString := String new: 2.
    1 to: 255 do: [:cp |
        aString at: 1 put: (cp asCharacter).
        UserLibrary ansiUpperBuff: aString length: 1.
        allUpperCase at: cp put: (aString at: 1).

        aString at: 1 put: (cp asCharacter).
        UserLibrary ansiLowerBuff: aString length: 1.
        allLowerCase at: cp put: (aString at: 1).

       (isLetter at: cp put: (UserLibrary isCharAlpha: cp))
            ifTrue: [isDigit at: cp put: false]
            ifFalse: [isDigit at: cp put: (UserLibrary isCharAlphaNumeric: cp)].
    ].!
initCollateTable
        "Private - Initialize the receiver's collateTablewith
          the collating-sequence table for the current country
          and language settings. The table is a character
          array of 256 elements in which each element in
          the table specifies the sorting weight of the
          corresponding character. The sorting weight is the
          value used to determine if a character appears
          before or after another character in a sorted list."
    | collection aString bString|
    "Copy the previously compiled collate table if
      there is no change in the system settings."
    ((NationalLanguage collateTable) notNil
        and: [(self country = NationalLanguage country)
        and: [self language = NationalLanguage language]])
        ifTrue: [self collateTable: (NationalLanguage collateTable)]
        ifFalse: [
           aString := String new: 2.
           bString := String new: 2.
           collection := SortedCollection sortBlock: [ :a :b |
               aString at: 1 put: a.
               bString at: 1 put: b.
               (UserLibrary lStrCmpi: aString withString: bString) <= 0 ].
           0 to: 255 do: [ :i | collection add: (i asCharacter)].
           collateTable := ByteArray new: 256.
           1 to: 256 do: [ :i |
               collateTable at: ((collection at: i) asInteger + 1) put: (i - 1)]].
    "Load table used by String primitive <= "
    VWVMLibrary loadCollateTable: collateTable.!  
initCountryInfo
        "Private - Initialize the receiver with the
          country-dependent formatting information.
          These are setting from WIN.INI initialization
          file under [INTL] application heading.
          The default values are of United States."
    country := self queryNationalProfileInt: 'iCountry'.
    dateFormat := self queryNationalProfileInt: 'iDate'.
    dateFormat = nil
        ifTrue: [dateFormat := 0].
    dateSeparator := self queryNationalProfileString: 'sDate'.
    dateSeparator = nil
        ifTrue: [dateSeparator := '/'].
    timeFormat := self queryNationalProfileInt: 'iTime'.
    timeFormat = nil
        ifTrue: [timeFormat := 0].
    timeSeparator := self queryNationalProfileString: 'sTime'.
    timeSeparator = nil
        ifTrue: [timeSeparator := ':'].
    time1159 := self queryNationalProfileString: 's1159'.
    time1159 = nil
        ifTrue: [time1159 := 'AM'].
    time2359 := self queryNationalProfileString: 's2359'.
    time2359 = nil
        ifTrue: [time2359 := 'PM'].
    currencyFormat := self queryNationalProfileInt: 'iCurrency'.
    currencyFormat = nil
        ifTrue: [currencyFormat := 0].
    currency := self queryNationalProfileString: 'sCurrency'.
    currency = nil
        ifTrue: [currency := '$'].
    thousandsSeparator := self queryNationalProfileString: 'sThousand'.
    thousandsSeparator = nil
        ifTrue: [thousandsSeparator := ','].
    decimalPlace := self queryNationalProfileInt: 'iDigits'.
    decimalPlace = nil
        ifTrue: [decimalPlace := 2].
    decimalSeparator := self queryNationalProfileString: 'sDecimal'.
    decimalSeparator = nil
        ifTrue: [decimalSeparator := '.'].
    dataSeparator := self queryNationalProfileString: 'sList'.
    dataSeparator = nil
        ifTrue: [dataSeparator := ','].
"New ones unique to Windows"
    language := self queryNationalProfileString: 'sLanguage'.
    countryName := self queryNationalProfileString: 'sCountry'.
    countryName = nil
        ifTrue: [countryName := 'United States'].
    shortDateFormat := self queryNationalProfileString: 'sShortDate'.
    shortDateFormat = nil
        ifTrue: [shortDateFormat := 'M/d/yy'].
    longDateFormat := self queryNationalProfileString: 'sLongDate'.
    longDateFormat = nil
        ifTrue: [longDateFormat := 'dddd, MMMM dd, yyyy'].
    measurementSystem := self queryNationalProfileInt: 'iMeasure'.
    measurementSystem = nil
        ifTrue: [measurementSystem := 1].
    timeLeadZero := self queryNationalProfileInt: 'iTLZero'.
    timeLeadZero = nil
        ifTrue: [timeLeadZero := 0].
    currencyDigits := self queryNationalProfileInt: 'iCurrDigits'.
    currencyDigits = nil
        ifTrue: [currencyDigits := 2].
    negativeCurrencyFormat := self queryNationalProfileInt: 'iNegCurr'.
    negativeCurrencyFormat = nil
        ifTrue: [negativeCurrencyFormat := 0].
    decimalLeadZero := self queryNationalProfileInt: 'iLZero'.
    decimalLeadZero = nil
        ifTrue: [decimalLeadZero := 1].!
initialize
        "Private - Initialize the receiver."
    self initCountryInfo.
    self initCollateTable.
    self initCharacterPredicates.
    self setDBCSInfo.!
isAlphaNumeric: aCharacter
        "Answer true if aCharacter is a
         letter or digit, else answer false."
    ^((self isLetter: aCharacter) or: [self isDigit: aCharacter])!
isDigit: aCharacter
        "Answer true if aCharacter is a
         digit, else answer false."
    | anInteger |
    anInteger := aCharacter asInteger.
    ((anInteger > 0) and: [anInteger < 256])
        ifTrue: [ ^isDigit at: anInteger].
    ^false!   
isDoubleByteCp
        "Answer whether the current national language is double-byte."
    ^isDoubleByteCp!  
isLetter: aCharacter
        "Answer true if aCharacter is a
         a letter, else answer false."
    | anInteger |
    anInteger := aCharacter asInteger.
    (anInteger > 0 and: [aCharacter ~= DoubleByteSpace])
        ifFalse: [^false].
    (anInteger < 256)
        ifTrue: [ ^isLetter at: anInteger].
    ^true  "All double-byte characters are upper-case letters."!  
isLowerCase: aCharacter
        "Answer true if aCharacter is a
         lower-case letter, else answer false."
    | anInteger |
    anInteger := aCharacter asInteger.
    ((anInteger > 0) and: [anInteger < 256])
        ifTrue: [^(allUpperCase at: anInteger) ~= aCharacter].
    ^false!   
isTimeFormat12Hour
        "Answer whether the current system time format is 12-hour."
    ^timeFormat = 0! 
isUpperCase: aCharacter
        "Answer true if aCharacter is a
         upper-case letter, else answer false."
    | anInteger |
    anInteger := aCharacter asInteger.
    (anInteger > 0 and: [aCharacter ~= DoubleByteSpace])
        ifFalse: [^false].
    (anInteger < 256)
        ifTrue: [^(allLowerCase at: anInteger) ~= aCharacter].
    ^true  "All double-byte characters are upper-case letters."!   
language
        "Answer the current system value for language."
    ^language! 
leadBytes
        " Answer the current leadBytes flag array."
    ^leadBytes!   
longDateFormat
        "Answer the current system value for long date format."
    ^longDateFormat! 
measurementSystem
        "Answer the current system value for measurement system.
         Answer 0 = metric
                      1 = english."
    ^measurementSystem! 
negativeCurrencyFormat
        "Answer the current system value for negative currency format.
         Answer 0 = ($1)
                      1 = -$1
                      2 = $-1
                      3 = $1-
                      4 = (1$)
                      5 = -1$
                      6 = 1-$
                      7 = 1$-."
    ^negativeCurrencyFormat!
queryNationalProfileInt: aKeyName
        "Answer the integer value of key aKeyName in
        the [Intl] application section of the WIN.INI profile file.
        Answer nil if aKeyName cannot be found."
    | answer |
    answer := KernelLibrary getProfileInt: 'Intl' asParameter
        keyName: aKeyName asParameter
        default: -1.
    answer = -1
        ifTrue: [^nil]
        ifFalse: [^answer].! 
queryNationalProfileString: aKeyName
        "Answer the string value of key aKeyName in
        the [Intl] application section of the WIN.INI profile file.
        Answer nil if aKeyName cannot be found."
    | aString result |
    result := KernelLibrary getProfileString: 'Intl' asParameter
        keyName: aKeyName asParameter
        default: '' asParameter
        returnedString: (aString := String new: 80)
        size: 80.
    result > 0
        ifTrue: [^(aString copyFrom: 1 to: result) asNormalizedString]
        ifFalse: [^nil].! 
setDBCSInfo
        "Private - set DBCS state for current national language. "
    | flag |
    leadBytes := Array new: 255.  " indexed by code point value [1..255] "
    isDoubleByteCp := false.
    1 to: 255 do: [ :cp |
        flag := KernelLibrary isDBCSLeadByte: cp.
        flag ifTrue: [ isDoubleByteCp := true ].
        leadBytes at: cp put: flag].!
shortDateFormat
        "Answer the current system value for short date format."
    ^shortDateFormat!  
string: aString1 isEqualToIgnorCase: aString2
        "Answer true if aString1 is equal to aString2
         in the current sort sequence, else answer false.
         The comparison is not case sensitive."
    ^(self compareStringi: aString1 withString: aString2) = 0!  
string: aString1 isGreaterThan: aString2
         "Answer true if aString1 is after aString2
         in the current sort sequence, else answer false.
         The comparison is not case sensitive."
    ^(self compareStringi: aString1 withString: aString2) > 0! 
string: aString1 isGreaterThanOrEqualTo: aString2
        "Answer true if aString1 is after or equal to aString2 
         in the current sort sequence, else answer false.
         The comparison is not case sensitive."
    ^(self compareStringi: aString1 withString: aString2) >= 0!   
string: aString1 isLessThan: aString2
        "Answer true if aString1 is before aString2
        in the current sort sequence, else answer false.
        The comparison is not case sensitive."
    ^(self compareStringi: aString1 withString: aString2) < 0!  
string: aString1 isLessThanOrEqualTo: aString2
        "Answer true if aString1 is before or equal to aString2
         in the current sort sequence, else answer false.
         The comparison is not case sensitive."
    ^(self compareStringi: aString1 withString: aString2) <= 0!  
thousandsSeparator
        "Answer the current system value
        of the thousands separator."
    ^thousandsSeparator!  
time1159
        "Answer the current system value 
        for time string describing AM."
    ^time1159!  
time2359
        "Answer the current system value for 
        time string describing PM."
    ^time2359!  
timeFormat
        "Answer the current system value for time format.
         Answer 0 = 12-hour clock
                      1 = 24-hour clock."
    ^timeFormat! 
timeLeadZero
        "Answer the current system value for time lead zero.
         Answer 0 = no leading zero (9:15:24)
                      1 = leading zero (09:15:24)."
    ^timeLeadZero!
timeSeparator
        "Answer the current system value for time separator."
    ^timeSeparator! !

! NotificationManager class methods !  
transcriptClass
    "Private - Answer the Transcript class.
    Touched By Ale for MDI Detect..."
    #modifiedByOStyle.

    ^Smalltalk at: #MDITranscript ifAbsent: [TextWindow]! !

! NotificationManager methods ! 
activeWindow

    "Added by OSI to support keyboard translation for MDI windows"
        "Answer the active toppane."

    | win newWin |
    #addedByOSI.
    ((win := self findWindow: WindowHandle queryActive) isMDIFrame) ifTrue: [
        (newWin := win mdiGetActive) notNil ifTrue: [
            ^newWin
        ].
    ].

    ^win!  
closeAllWindows
        "Private - Close all windows including Transcript."
    |oldWindows|
    Transcript notNil ifTrue: [Transcript clearTextModified].
    Transcript := nil.
"we copy the collection because we will remove the elements
during the iteration"
    oldWindows := windows copy.
    oldWindows do: [:w |
        (w isKindOf: ApplicationWindow)
            ifTrue: [
                w clearTextModified.
                w close]].
    self cleanUpAllMessages!  
isAltDown
        "Added by OSI - Answer true if a alt key is down."
    #addedByOSI.
    ^self isKeyDown: AltKey! 
isCtrlDown
        "Added by OSI - Answer true if a control key is down."
    #addedByOSI.
    ^self isKeyDown: ControlKey!
mdiInitialize
    "Private - Initialize the MDI classes."

    WinEvents  at: WmMdiactivate put:#wmMdiactivate:with:.

    MDISystem system.!
notify: event
    "Private - Translate a host system event into the appropriate
     message sent to the window specified in the event.
     Touched by LRP - "
    |   w  |
    #modifiedByOStyle.
    (w := self findWindow: event hwnd) isNil
        ifTrue:[
            "Can't find window in the event manager but if the
                message is WmCreate then, send it to NewWindow
                window"
            ^(ApplicationWindow newWindow notNil
             and:[ (WinEvents at:event msg) notNil ])
                ifTrue:[
                   ApplicationWindow newWindow
                            handle: (WindowHandle fromInteger: event hwnd);
                            perform: (self selectorFor: event msg)
                            withArguments:
                                    (Array
                                        with: event wparam
                                        with: event lparam)
                ]
        ]
        ifFalse: [
            ^w perform: (self selectorFor: event msg)
                  withArguments:
                    (Array
                        with: event wparam
                        with: event lparam)
        ].!   
readWinQueue

    "Modified by OSI to support dialog keys in regular windows"

        "Private - Read a message from host system's event queue."
    | old  hWnd  activeWindow |
    old :=  Process enableInterrupts: false.
    (UserLibrary peekMessage: (WinMsgNS asParameter)
        hwnd: nil
        min: 0
        max: 0
        remove: true)
           ifFalse: [Process enableInterrupts: old. ^self].

    PoppedModelessWindows size > 0
        ifTrue: ["There are popped up modeless windows"
            PoppedModelessWindows do: [:each |
                 (UserLibrary
                    isDialogMessage: each
                    lpmsg: WinMsgNS asParameter)
                        = 0 ifFalse: [Process enableInterrupts: old.
                                            ^self]]].

    WinMsg  replaceFrom: 1 to: 2 with: WinMsgNS startingAt: 3.
    ((WinMsg = WmKeyDownString) or: [WinMsg = WmSysKeyDownString])
        ifTrue: [
            (self translateAccelerator: WinMsgNS)
                ifTrue: [
                    Process enableInterrupts: old.
                    ^self]].

    "Added by OSI to provide dialog key support in titled windows"
    #modifiedByOSI.
    activeWindow := self activeWindow.

    activeWindow notNil ifTrue: [
        "OSI - Removed respondsTo: - enhances speed"
      (activeWindow owner isWBWindow)  ifTrue: [
        (UserLibrary
            isDialogMessage: activeWindow handle
            lpmsg: WinMsgNS asParameter) = 0 ifFalse: [
            Process enableInterrupts: old.
            ^self
        ].
      ].
    ].


    UserLibrary
        translateMessage: (WinMsgNS asParameter).
    UserLibrary
        dispatchMessage: (WinMsgNS asParameter).
    Process enableInterrupts: old!   
reinitDelayed
    "Private - initialize and open a new Transcript.
    Touched by Ale for transcript text saving..."
    | text |
    #modifiedByOStyle.
    (Transcript respondsTo: #contents) ifTrue: [text := Transcript contents].
    self closeAllWindows.
    self initialize.
    self class transcriptClass initializeTranscript.
    SmalltalkEmulatorInst := SmalltalkEmulator newServer.
    SystemWindow startUp.
    (text notNil and: [Transcript respondsTo: #pane])
    ifTrue: [ Transcript pane contents: text ].! 
remove: aWindow
    "Private - Remove aWindow from the Notifier.
    Touched by Ale for automatic exit if needed"

    #modifiedByOStyle.
    self removeEventsFor: aWindow.
    windows removeKey: aWindow handle asInteger ifAbsent: [].

    "When runTime & there are no more windows we must exit..."
    (aWindow isApplicationWindow
     and: [Smalltalk isRunTime
     and: [
        (windows
            detect: [:each| each isApplicationWindow ]
            ifNone: []) isNil]])
    ifTrue: [
        "Exiting Smalltalk..."
        ^Smalltalk exit
    ]! 
startUpApplication: oldWindows
    "Place startup code for your application here in
     place of this default code.
     Modified By Ale :
       StartUpApplication could be a global variable
        (anObject or aClass) that must
        startUp the application when open
     Note :
       OldWindows are the open windows when
       image was saved.
     Warning :
       The StartUpApplication object must respondsTo #open
       (else a text pane will be opened)
    "
    | application |
    #modifiedByOStyle.
    "Search for aplication..."
    application := Smalltalk at: #StartUpApplication ifAbsent: [].

    "Login Needed for runTime evaluation"
    (application respondsTo: #initLog)
    ifTrue:[ application initLog ]
    ifFalse: [
        "StartUpApplication login file (idem change.log)"
        Sources at: 2 put: (ReadWriteStream on: String new)
    ].

    "Replace inspectors and debuggers at runTime if the replacement
     classes exists"
    (Smalltalk includesKey: #RTInspector)
    ifTrue: [
        Smalltalk at: #Inspector put: (Smalltalk at: #RTInspector ifAbsent: []).
        Smalltalk at: #Debugger put: (Smalltalk at: #RTDebugger ifAbsent: []).
        Smalltalk at: #DictionaryInspector
            put: (Smalltalk at: #RTDictionaryInspector ifAbsent: []).
    ].

    "Try to open the application..."
    (application respondsTo: #open)
    ifTrue:   [
        Transcript := RunTimeTranscript new.
        application open
    ]
    ifFalse: [
        Terminal bell.
        '\* Warning * \ No StartUpApplication defined !!!!' withCrs edit.
        "
        self relocateWindows: oldWindows.
        self reopenWindows: oldWindows
        "
    ]!
translateAccelerator: winMsgNS
        "Private -  Translates a system message into accelerator key stroke.
         Answer true if it is an accelerator key stroke, else answer false."
    | aWindow afBits aMenuWindow accelTable
      index hWnd hWndString char childWindow|

    char :=KeyboardLibrary
        mapVirtualKey:
            (((ByteArray new: 1)
                replaceFrom:1
                to: 1
                with: winMsgNS
                startingAt: 9) at: 1)
        mapType: 1.
    hWndString := ((ByteArray new: 2)
        replaceFrom:1
        to: 2
        with: winMsgNS
        startingAt: 1).
    hWnd := ((hWndString at: 2) * 256)
                    + (hWndString at: 1).

    "Is hWnd a Smalltalk window"
    (aWindow := Notifier findRealWindow: hWnd)  notNil ifTrue: [
        childWindow := aWindow.
        aWindow mainWindow isMDIChild | aWindow isMDIClient ifTrue:[(self translateMDISysAccel:winMsgNS) ifTrue:[^true]].
        aWindow := aWindow mainWindow.
        (aMenuWindow := aWindow menuWindow) notNil ifTrue: [
            afBits := 0.
            (UserLibrary getKeyState: VkControl) < 0 ifTrue:
                [afBits := afBits + AfControl].
            (UserLibrary getKeyState: VkShift) < 0 ifTrue:
                [afBits := afBits + AfShift].
            (UserLibrary getKeyState: VkMenu) < 0 ifTrue:
                [afBits := afBits + AfAlt].
            "afBits = 0 ifTrue:
                [afBits := nil]."

            ((childWindow accel: char afBits: afBits) = true) ifTrue: [
                ^true
            ].
            ((aWindow accel: char afBits: afBits) = true) ifTrue: [
                ^true
            ].

            "If Control-Break then halt."
            afBits = AfControl ifTrue: [
                char = 145  ifTrue: [
                    Process interrupt: 2.
                    ^true]].

    "OSI - We changed AfVirtualkey to have a nonzero value to differentiate it
     from AfChar (for use in the menueditor), and as a result lost some accelerators."
            #modifiedByOSI.
            (accelTable := aMenuWindow accelTable) notNil ifTrue: [
                (index := accelTable at: (Array with: char with: afBits) ifAbsent:[
                    afBits notNil ifTrue: [
                        accelTable at: (Array with: char with: (afBits bitOr: AfVirtualkey)) ifAbsent: [ nil ].
                    ] ifFalse: [
                        nil
                    ].
                ] )
                    notNil ifTrue: [
                         aMenuWindow sendInputEvent: #performMenuItem: with: index.
                         ^true]]]].
    ^false!
translateMDISysAccel: winMsgNS
        "Private - Translate MDI accelarator keys."

    | aWindow hWnd hWndString  answer|


    hWndString := ((ByteArray new: 2)
        replaceFrom:1
        to: 2
        with: winMsgNS
        startingAt: 1).
    hWnd := ((hWndString at: 2) * 256)
                    + (hWndString at: 1).

    "Is hWnd a Smalltalk window"

    (aWindow := Notifier findRealWindow: hWnd)  notNil ifTrue: [
        aWindow mainWindow isMDIChild ifTrue:[aWindow:=aWindow mainWindow parent].
            answer:=UserLibrary
                                translateMDISysAccel: aWindow  asParameter
                                msg:  winMsgNS asParameter.
            ^answer].

    ^false! !

! ObjectFiler class methods ! 
describe
        " Describe the contents of a filed object. "
    | srcPathName dstPathName |
    srcPathName := (FileDialog new openFile) file.
    srcPathName isNil ifTrue: [^nil].
    dstPathName := ((ReadStream on: srcPathName) upTo: $.), '.txt'.
    ^self describeFromPathName: srcPathName newFile: dstPathName!
describeAllFromPathName: srcPathName newFile: dstPathName
        " Describe the contents of all filed objects in the
        file specified by srcPathName on file dstPathName;
        answer the number of filed objects. "
    | srcFileStream dstFileStream decompressor numFiledObjects |
    srcFileStream := File pathNameReadOnly: srcPathName.
    dstFileStream := File newFile: dstPathName.
    decompressor := self new.
    numFiledObjects := 0.
    [srcFileStream atEnd] whileFalse: [
        numFiledObjects := numFiledObjects + 1.
        (numFiledObjects > 1) ifTrue: [
            dstFileStream nextPutAll: '------------------------------'; cr; nextPut: Ff].
        decompressor describeFrom: srcFileStream to: dstFileStream].
    srcFileStream close.
    dstFileStream close.
    ^numFiledObjects!   
describeClasses
        " Describe the classes in a filed object. "
    | srcPathName dstPathName |
    srcPathName := (FileDialog new openFile) file.
    srcPathName isNil ifTrue: [^nil].
    dstPathName := ((ReadStream on: srcPathName) upTo: $.), '.txt'.
    ^self describeClassesFromPathName: srcPathName 
        newFile: dstPathName! 
describeClassesFrom: srcStream to: dstStream
        " Describe the classes in the filed object at the current
        position in the srcStream on dstStream. "
    self new describeClassesFrom: srcStream to: dstStream.!   
describeClassesFromPathName: srcPathName newFile: dstPathName
        " Describe the classes in the filed object in the
        file specified by srcPathName on file dstPathName. "
    | srcFileStream dstFileStream decompressor |
    srcFileStream := File pathNameReadOnly: srcPathName.
    dstFileStream := File newFile: dstPathName.
    self new describeClassesFrom: srcFileStream to: dstFileStream.
    srcFileStream close.
    dstFileStream close.!  
describeFrom: srcStream to: dstStream
        " Describe the contents of the filed object at the current
        position in the srcStream on dstStream. "
    self new describeFrom: srcStream to: dstStream.!
describeFromPathName: srcPathName newFile: dstPathName
        " Describe the contents of the filed object in the
        file specified by srcPathName on file dstPathName. "
    | srcFileStream dstFileStream decompressor |
    srcFileStream := File pathNameReadOnly: srcPathName.
    dstFileStream := File newFile: dstPathName.
    self new describeFrom: srcFileStream to: dstFileStream.
    srcFileStream close.
    dstFileStream close.!   
dump: anObject
        " Store anObject. "
    | aPathName |
    aPathName := (FileDialog new saveFile: 'FiledObj.obj') file.
    aPathName isNil ifTrue: [^nil].
    ^self dump: anObject newFile: aPathName!   
dump: anObject newFile: aPathName
        " Store anObject in the file specified by aPathName. "
    | fileStream |
    fileStream := File newFile: aPathName.
    self new dump: anObject on: fileStream.
    fileStream close.
    ^anObject! 
dump: anObject on: aStream
        " Store anObject on aStream, starting at the current position. "
    self new dump: anObject on: aStream.
    ^anObject!
dumpAll: aCollection newFile: aPathName
        " Store each object in aCollection on the file
        specified by aPathName. "
    | fileStream dumper |
    fileStream := File newFile: aPathName.
    dumper := self new.
    aCollection do: [ :anObject |
        dumper dump: anObject on: fileStream].
    fileStream close.
    ^aCollection!   
initErrorClass: aClass
        " Private - add aClass and its subclasses to 
        ErrorClasses unless they have implemented
        an override to the default behavior or refusing
        to be filed out. "
    ((aClass includesSelector: #fileOutSurrogate:)
    or: [aClass includesSelector: #fileInActivate:])
        ifFalse: [  
            ErrorClasses add: aClass.
            aClass subclasses do: [ :aSubClass |
                self initErrorClass: aSubClass]].!
initialize
        " ObjectFiler class initialization "
    | systemInfo aClass |

    systemInfo := self systemInfo.

    Seal := Esc.  " control code byte to mark start of filed object "

    " entry/section delimiter, entry type constants "
    NUL := 0 asCharacter.
    TagClass := 1 asCharacter.
    TagMetaClass := 2 asCharacter.
    RepFixedPointers := 1 asCharacter.
    RepVariablePointers := 2 asCharacter.
    RepVariableBytes := 3 asCharacter.
    ClassIdSymbol := 1.
    ClassIdDBSymbol := 2.

    " The dump id name space of a filed object is a contiguous range of
         integers which fall into 4 distinct regions:
            (1) ids for immutable objects and certain singular classes:
                    nil, true, false, MetaClass, Smalltalk,
                    Notifier, Processor, PM/WIN, Display, Clipboard
            (2) sequentially assigned ids for behavior descriptors
                    (class and metaclass entries)
            (3) sequentially assigned ids for non-behavior objects
            (4) ids for immutable objects of type Character and Integer
                    (single-byte characters only; DBC gets dynamic id)
        Only the dynamically assigned descriptors must be filed. "
    IdNUL := 0.
    IdNil := 1.

    " SingularClasses are terminals of the dump enumeration.  They are
        classes which are defined to only have a single instance.  They
        are assigned standard ids at the beginning of the dump id name
        name space.  These objects are bound to their environment at
        object load time. "
    SingularClasses := Set new.
    SingularClasses
        add: UndefinedObject;
        add: True;
        add: False;
        add: MetaClass class;
        add: SystemDictionary;
        add: SymbolSet;
        add: NotificationManager;
        add: ProcessScheduler;
        add: ClipboardManager;
        add: (Smalltalk at: systemInfo) class;  " PMInfo or WinInfo "
        add: Screen.
    NumPredefinedIds := 11.
    self initSingularIds.  " SingularObjects and SingularNames "

    " Classes whose objects and behaviors are not logged.  Either a
        singular class whose instance ids are predefined or immutable
        objects whose ids are computable. "
    TerminalClasses := Set new.
    TerminalClasses
        addAll: SingularClasses;
        addAll: (Integer withAllSubclasses).
    " only single-byte characters are terminals "
    (Character compiledMethodAt: #isSingleByte) isNil
        ifTrue: [TerminalClasses add: Character].

    " Classes which cannot be dumped (runtime execution state, compiled methods). "
    ErrorClasses := Set new.
    #(CompiledMethod Context FileHandle Process SortedCollection) 
    do: [ :symbol |
        (aClass := Smalltalk at: symbol ifAbsent: [nil]) notNil 
            ifTrue: [self initErrorClass: aClass]].!   
initSingularIds
        " Private - global bindings must be refreshed after image load "
    | systemInfo |

    systemInfo := self systemInfo.

    SingularObjects := LargeIdentityDictionary new: 31.
    SingularObjects   " dumper uses to map object to dump id "
        "at: nil put: IdNil;"   " sigh, can't have nil be a key "
        at: true put: 2;
        at: false put: 3;
        at: MetaClass put: 4;
        at: Smalltalk put: 5;
        at: SymbolTable put: 6;
        at: Notifier put: 7;
        at: Processor put: 8;
        at: Clipboard put: 9;
        at: (Smalltalk at: systemInfo) put: 10;  " PM or WIN global "
        at: Display put: 11.

    SingularNames := Array new: NumPredefinedIds.
    SingularNames  " decompressor indexes by dump id "
        at: 1 put: 'nil';
        at: 2 put: 'true';
        at: 3 put: 'false';
        at: 4 put: 'MetaClass';
        at: 5 put: 'Smalltalk';
        at: 6 put: 'SymbolTable';
        at: 7 put: 'Notifier';
        at: 8 put: 'Processor';
        at: 9 put: 'Clipboard';
        at: 10 put: systemInfo asString;
        at: 11 put: 'Display'.! 
load
        " Answer the first object stored a file. "
    | aPathName |
    aPathName := (FileDialog new openFile) file.
    aPathName isNil ifTrue: [^nil].
    ^self loadFromPathName: aPathName!
loadAllFromPathName: aPathName
        "  Answer a collection containing all the objects stored
        in the file specified by aPathName. "
    | fileStream loader restoredObjects |
    fileStream := File pathNameReadOnly: aPathName.
    loader := self new.
    restoredObjects := OrderedCollection new.
    [fileStream atEnd] whileFalse: [
        restoredObjects add: (loader loadFrom: fileStream)].
    fileStream close.
    ^restoredObjects! 
loadAllFromPathName: aPathName loadMaps: loadMapsDict
        "  Answer a collection containing all the objects
        stored in the file specified by aPathName. The
        loadMapsDict defines mappings for loading classes
        whose shape has changed. "
    | fileStream loader restoredObjects |
    fileStream := File pathNameReadOnly: aPathName.
    loader := self new.
    restoredObjects := OrderedCollection new.
    [fileStream atEnd] whileFalse: [
        restoredObjects add:
            (loader loadFrom: fileStream loadMaps: loadMapsDict)].
    fileStream close.
    ^restoredObjects! 
loadFrom: aStream
        " Answer the filed object stored at the current
        position on aStream. "
    ^self new loadFrom: aStream!  
loadFrom: aStream loadMaps: loadMapsDict
        " Answer the filed object stored at the current
        position on aStream.   The loadMapsDict
        defines mappings for loading classes
        whose shape has changed. "
    ^self new
        loadFrom: aStream
        loadMaps: loadMapsDict!   
loadFromPathName: aPathName
        " Answer the first object stored in the file
        specified by aPathName. "
    | fileStream restoredObject |
    fileStream := File pathNameReadOnly: aPathName.
    restoredObject := self new loadFrom: fileStream.
    fileStream close.
    ^restoredObject!   
loadFromPathName: aPathName loadMaps: loadMapsDict
        " Answer the first object stored in the file
        specified by aPathName.  The loadMapsDict
        defines mappings for loading classes
        whose shape has changed. "
    | fileStream restoredObject |
    fileStream := File pathNameReadOnly: aPathName.
    restoredObject := self new
        loadFrom: fileStream
        loadMaps: loadMapsDict.
    fileStream close.
    ^restoredObject! 
systemInfo
        " Answer the symbol identifying the host system info global "
    (Smalltalk at: #PM ifAbsent: [nil]) notNil ifTrue: [^#PM].
    (Smalltalk at: #WIN ifAbsent: [nil]) notNil ifTrue: [^#WIN].
    self error: ['Unknown Smalltalk/V system'].! 
version
        " Answer version stamp for the object file format.
            = 1, Smalltalk/V Dumper (Goodies #1 package)
            = 2, Smalltalk/V 286 Dumper
            = 3, Smalltalk/V PM 1.2 ObjectFiler
            = 4, Smalltalk/V Win 2.0 ObjectFiler
            = 5, Smalltalk/V PM 1.3 ObjectFiler
            = 6, Smalltalk/V PM 2.0 ObjectFiler
         "
    | systemInfo |
    systemInfo := self systemInfo.
    (systemInfo = #PM) ifTrue: [^6].
    (systemInfo = #WIN) ifTrue: [^4].
    self error: ['Unknown ObjectFiler version'].!   
versionCanBeDescribed: aVersion
        " Answer whether a filed object from aVersion
        can be described by this ObjectFiler. "
    ^(Array with: 3 with: 4 with: 5 with: 6) includes: aVersion  
        " VPM 1.2; VW 2.0; VPM 1.3; VPM 2.0 "!
versionCanBeLoaded: aVersion
        " Answer whether a filed object from aVersion
        can be loaded by this ObjectFiler. "
    | systemInfo |
    systemInfo := self systemInfo.
    (systemInfo = #PM) 
        ifTrue: [
            ^((Array with: 3 with: 5 with: 6)  "VPM 1.2, 1.3, 2.0"
                 includes: aVersion)]. 
    (systemInfo = #WIN) 
         ifTrue: [^(aVersion = 4)].   "VW 2.0"
    self error: ['Unknown ObjectFiler version'].!   
versionHasDllInfo: aVersion
        " Answer whether a filed object from aVersion
        contains DLL information in its behavior descriptors. "
    ^(aVersion = 6)   " VPM 2.0 "! !

! ObjectFiler methods !  
assignComputedIdRanges: lastDynamicId
        " Private - Assign the end of the dump id name space,
        given the last id assigned in the dynamic range
        (behaviors and objects) "
    idCharacterZero := lastDynamicId + 1.
    idIntegerZero := idCharacterZero + 256.! 
clientContext
        " Answer the client context associated with
        the current dump or load operation.
        Can be accessed in fileInSurrogate: and
         fileOutActivate: methods to provide
         context-dependent behavior. "
    ^clientContext!   
clientContext: anObject
        " Store anObject on behalf of the client.
        The client context can be accessed in
        fileOutSurrogate: and fileInActivate: methods
        to allow context-dependent behavior. "
    clientContext := anObject!  
clientMessageHandler: aHandler
        " Register a client message handler.
        aHandler is a two-argument block or message
        which is invoked when a problem is
        encountered during object loading or dumping.
        The first argument is this ObjectFiler.
        The second argument is an assoc
        with key => value information:
            'info' => an information message (string)
            'warning' => a warning message (string)
            'abort' => a fatal error message (string)
            'summary' => number of warnings encountered 
                (Dictionary of integers indexed by above key strings)
        The 'summary' notification is sent at operation 
        completion when warnings were encountered
        (allows client to do sumary or termination processing). "
    clientMessageHandler := aHandler.!
computedObjectDescription: computedObject
        " Private - answer a description of a predefined/computed object "
    ^computedObject isCharacter
        ifTrue: [
            (computedObject printString),
                ' (Character code ', (computedObject asciiValue printString), ')']
        ifFalse: [
            computedObject printString, ' (Integer)']!  
computedObjectFromId: objectId
        " Private - answer the object described by the given
        computed dump id (Character or Integer at the end of
        the dump name space) "
    | integerId |
    ^(objectId < idIntegerZero)
        ifTrue: [
            (objectId - idCharacterZero) asCharacter]
        ifFalse: [
            (integerId := objectId - idIntegerZero) odd
                ifTrue: [(integerId // 2) negated]  " odd is negative "
                ifFalse: [integerId // 2]].  " even is positive "!
describeBehaviorDescriptors
        " Private - Read the <behavior descriptors section>
        to find referenced classes and MetaClasses.
        Dump in id order (not file order). "
    | numEntries hasDllName classInfo 
      tag classId name rep
      numNamedInstVars instVarNames dllName |

    " set up pseudo-classId entries for self-contained object descriptors "
    behaviors
        at: ClassIdSymbol
        put: (Association key: 'Symbol' value: RepVariableBytes).
    behaviors
        at: ClassIdDBSymbol
        put: (Association key: 'DoubleByteSymbol' value: RepVariableBytes).
    objects at: ClassIdSymbol put: (Array new: 0).  " no named inst vars "
    objects at: ClassIdDBSymbol put: (Array new: 0).

    " read unordered entries "
    numEntries := 0.
    hasDllName := self class versionHasDllInfo: objectVersion.
    classInfo := Array new: (behaviors size).
    [(tag := objectStream next) ~= NUL] whileTrue: [
        numEntries := numEntries + 1.
        classId := objectStream getInteger.
        name := objectStream upTo: NUL.
        rep := objectStream next.
        numNamedInstVars := objectStream getInteger.
        instVarNames := Array new: numNamedInstVars.
        1 to: numNamedInstVars do: [ :i |
            instVarNames at: i put: (objectStream upTo: NUL)].
        dllName := (hasDllName
            ifTrue: [objectStream upTo: NUL]
            ifFalse: [nil]).
        classInfo at: classId put: 
            (Association key: tag value: dllName).
        behaviors
            at: classId
            put: (Association key: name value: rep).
        objects at: classId put: instVarNames].

    " report in id order "
    textStream
        cr; nextPutAll: 'Behavior descriptors section (id = behavior entry)'; cr.
    (NumPredefinedIds + 1) to: (behaviors size) do: [ :classId |
        name := (behaviors at: classId) key.
        rep := (behaviors at: classId) value.
        numNamedInstVars := (objects at: classId) size.
        textStream nextPutAll:
            (classId printString), ' = ',
            (((classInfo at: classId) key = TagClass)
                ifTrue: [
                    'Class ', name, ' (',
                    (self repDescription: rep), ', ',
                    ((numNamedInstVars = 0)
                        ifTrue: ['no'] ifFalse: [numNamedInstVars printString]),
                    ' named instance variables)']
                ifFalse: ['MetaClass ', name]);
            cr.
        dllName := (classInfo at: classId) value.
        (dllName size > 0)  " not supported or base system DLL "
            ifTrue: [textStream nextPutAll: 
                '        (bind ', dllName, 
                '.dll if not found in loading image)'; cr].
        ].   " processing behavior entries "
    textStream
        nextPutAll: '(', numEntries printString, ' behavior descriptor entries)'; cr.
    "ASSERT [numEntries = numBehaviors]."!   
describeClasses
        " Private - Read the <behavior descriptors section>
        to find referenced classes and MetaClasses.
        Dump in class name order (not file order). "
    | numEntries hasDllName classInfo 
      tag classId name rep
      numNamedInstVars instVarNames dllName
      reportDict |

    " set up pseudo-classId entries for self-contained object descriptors "
    behaviors
        at: ClassIdSymbol
        put: (Association key: 'Symbol' value: RepVariableBytes).
    behaviors
        at: ClassIdDBSymbol
        put: (Association key: 'DoubleByteSymbol' value: RepVariableBytes).
    objects at: ClassIdSymbol put: (Array new: 0).  " no named inst vars "
    objects at: ClassIdDBSymbol put: (Array new: 0).

    " read unordered entries "
    numEntries := 0.
    hasDllName := self class versionHasDllInfo: objectVersion.
    classInfo := Array new: (behaviors size).
    reportDict := Dictionary new.
    [(tag := objectStream next) ~= NUL] whileTrue: [
        numEntries := numEntries + 1.
        classId := objectStream getInteger.
        name := objectStream upTo: NUL.
        rep := objectStream next.
        numNamedInstVars := objectStream getInteger.
        instVarNames := Array new: numNamedInstVars.
        1 to: numNamedInstVars do: [ :i |
            instVarNames at: i put: (objectStream upTo: NUL)].
        dllName := (hasDllName
            ifTrue: [objectStream upTo: NUL]
            ifFalse: [nil]).
        classInfo at: classId put: 
            (Association key: tag value: dllName).
        behaviors
            at: classId
            put: (Association key: name value: rep).
        objects at: classId put: instVarNames.
        reportDict 
            at: ((tag = TagClass)
                ifTrue: [name]
                ifFalse: [name, ' class']) 
            put: classId.
        ].

    " report in alphabetical order "
    reportDict keys asSortedCollection do: [ :className |
        classId := reportDict at: className.
        tag := (classInfo at: classId) key.
        rep := (behaviors at: classId) value.
        instVarNames := objects at: classId.
        numNamedInstVars := instVarNames size.
        textStream nextPutAll: className.
        (tag = TagClass)
            ifTrue: [
                textStream nextPutAll: 
                    ' (', (self repDescription: rep), ', ',
                    ((numNamedInstVars = 0)
                        ifTrue: ['no'] 
                        ifFalse: [numNamedInstVars printString]),
                    ' named instance variables)'].
        textStream cr.
        dllName := (classInfo at: classId) value.
        (dllName size > 0)  " not supported or base system DLL "
            ifTrue: [textStream nextPutAll: 
                '        (bind ', dllName, 
                '.dll if not found in loading image)'; cr].
        ((tag = TagClass) and: [numNamedInstVars > 0])
            ifTrue: [
                1 to: numNamedInstVars do: [ :i |
                    textStream nextPutAll: 
                        '    ', i printString,
                        ' - ', (instVarNames at: i); cr]].
        ].   " processing behavior entries "!
describeClassesFrom: srcStream to: dstStream
        " Describe the classes in the filed object on 
        srcStream in a text report on dstStream. "
    | initialPosition rootObjectId lastBehaviorId
      firstObjectId lastObjectId numBehaviorEntries |

    CursorManager execute change.
    Seal isNil ifTrue: [self class initialize].
    self class initSingularIds.  " refresh global bindings "

    objectStream := ((srcStream respondsTo: #asByteFileStream)
        ifTrue: [srcStream asByteFileStream]
        ifFalse: [srcStream]).
    initialPosition := objectStream position.  " remember so we can report size"
    textStream := dstStream.
    messageCounts := nil.

    " header section (version, last dynamically assigned id, root object) "
    (objectStream next ~= Seal)
        ifTrue: [
            self recordWarningMessage: 'Incorrect seal for filed object.'.
            objectStream position: initialPosition.  " back out "
            CursorManager normal change.
            ^nil].
    objectVersion := objectStream getInteger.
    (self class versionCanBeDescribed: objectVersion)
        ifFalse: [
            self recordWarningMessage: 
                'This ObjectFiler cannot describe filed objects of version ',
                objectVersion printString.
            objectStream position: initialPosition.  " back out "
            CursorManager normal change.
            ^nil].
    numBehaviors := objectStream getInteger.
    numObjects := objectStream getInteger.
    rootObjectId := objectStream getInteger.
    (objectStream next ~= NUL)
        ifTrue: [
            self recordWarningMessage: 
                'File format error (bad header section)'.
            objectStream position: initialPosition.  " back out "
            CursorManager normal change.
            ^nil].

    " set up the dump id name space "
    lastBehaviorId := NumPredefinedIds + numBehaviors.
    firstObjectId := lastBehaviorId + 1.
    "(numObjects > 0) ifTrue: [ASSERT [firstObjectId = rootObjectId]]."
    lastObjectId := lastBehaviorId + numObjects.
    self assignComputedIdRanges: lastObjectId.

    " print header info and describe the id name space "
    self describeObjectVersion.
    textStream
        nextPutAll:
            'Number of classes = ', (numBehaviors printString); cr;
        nextPutAll:
            'Number of objects = ', (numObjects printString); cr;
        cr.

    " objects is indexed by the dump ID of a behavior.
        Records instance variable names. "
    objects := Array new: lastBehaviorId.
    " behaviors is indexed by a behavior dump ID and contains the
        class name and representation "
    behaviors := Array new: lastBehaviorId.

    self
        describeClasses;
        describeObjectsNop.

    textStream
        cr; nextPutAll:
            'Filed object size = ', (((objectStream position) - initialPosition) printString),
            ' bytes';
        cr; cr.
    CursorManager normal change.! 
describeFrom: srcStream to: dstStream
        " Describe the filed object on srcStream in
        a human-readable report on dstStream. "
    | initialPosition rootObjectId lastBehaviorId
      firstObjectId lastObjectId numBehaviorEntries |

    CursorManager execute change.
    Seal isNil ifTrue: [self class initialize].
    self class initSingularIds.  " refresh global bindings "

    objectStream := ((srcStream respondsTo: #asByteFileStream)
        ifTrue: [srcStream asByteFileStream]
        ifFalse: [srcStream]).
    initialPosition := objectStream position.  " remember so we can report size"
    textStream := dstStream.
    messageCounts := nil.

    " header section (version, last dynamically assigned id, root object) "
    (objectStream next ~= Seal)
        ifTrue: [
            self recordWarningMessage: 'Incorrect seal for filed object.'.
            objectStream position: initialPosition.  " back out "
            CursorManager normal change.
            ^nil].
    objectVersion := objectStream getInteger.
    (self class versionCanBeDescribed: objectVersion)
        ifFalse: [
            self recordWarningMessage: 
                'This ObjectFiler cannot describe filed objects of version ',
                objectVersion printString.
            objectStream position: initialPosition.  " back out "
            CursorManager normal change.
            ^nil].
    numBehaviors := objectStream getInteger.
    numObjects := objectStream getInteger.
    rootObjectId := objectStream getInteger.
    (objectStream next ~= NUL)
        ifTrue: [
            self recordWarningMessage: 
                'File format error (bad header section)'.
            objectStream position: initialPosition.  " back out "
            CursorManager normal change.
            ^nil].

    " set up the dump id name space "
    lastBehaviorId := NumPredefinedIds + numBehaviors.
    firstObjectId := lastBehaviorId + 1.
    "(numObjects > 0) ifTrue: [ASSERT [firstObjectId = rootObjectId]]."
    lastObjectId := lastBehaviorId + numObjects.
    self assignComputedIdRanges: lastObjectId.

    " print header info and describe the id name space "
    self describeObjectVersion.
    textStream
        nextPutAll:
            'Number of behavior entries = ', (numBehaviors printString); cr;
        nextPutAll:
            'Number of object entries = ', (numObjects printString); cr;
        nextPutAll: 'Root object id = ', (rootObjectId printString).
    " special case: add description of non-filed root object "
    (rootObjectId <= NumPredefinedIds) ifTrue: [
        textStream nextPutAll: ' => ', (SingularNames at: rootObjectId)].
    (rootObjectId > lastObjectId) ifTrue: [
        textStream nextPutAll:
            ' => ',
            (self computedObjectDescription:
                    (self computedObjectFromId: rootObjectId))].
    textStream cr; cr.

    " describe the id ranges  "
    textStream nextPutAll:
            'Dump id name space:'; cr.
    1 to: NumPredefinedIds do: [ :i |
        textStream nextPutAll: '    ', (i printString), ' = ', (SingularNames at: i); cr].
    (numBehaviors > 0) ifTrue: [textStream
        nextPutAll:
            '    ', '[', (NumPredefinedIds + 1) printString, '..',
            lastBehaviorId printString, '] = behavior ids'; cr].
    (numObjects > 0) ifTrue: [textStream
        nextPutAll:
            '    ', '[', firstObjectId printString, '..',
            lastObjectId printString, '] = object ids'; cr].
    textStream
        nextPutAll:
            '    [', idCharacterZero printString, '..',
            (idCharacterZero + 255) printString,
            '] = Character codes [0..255]'; cr;
        nextPutAll:
            '    ', idIntegerZero printString, '.. = Integer values (0, 1, -1, 2, -2, ...)'; cr.

    " objects is indexed by the dump ID of a behavior or object entry.
        For a behavior, records instance variable names.
        For an object, records the class id. "
    objects := Array new: lastObjectId.
    " behaviors is indexed by a behavior dump ID and contains the
        class name and representation "
    behaviors := Array new: lastBehaviorId.

    self
        describeBehaviorDescriptors;
        describeObjectDescriptors.

    textStream
        cr; nextPutAll:
            'Filed object size = ', (((objectStream position) - initialPosition) printString),
            ' bytes';
        cr; cr.
    CursorManager normal change.!  
describeId: id
        " Private - Answer a description of the object referenced by id."
    | behavior name |

    " predefined names which aren't actually filed "
    (id <= NumPredefinedIds)
        ifTrue: [^SingularNames at: id].

    " dynamically assigned behavior and object dump ids "
    (id <= (NumPredefinedIds + numBehaviors)) ifTrue:  [
        ^(((behaviors at: id) value = NUL)  " no rep info for metaclass "
            ifTrue: ['MetaClass ']
            ifFalse: ['Class ']),
        (behaviors at: id) key].
   (id < idCharacterZero) ifTrue: [
         ^((behaviors at: ((objects at: id) at: 1)) key), ' instance ', (id printString)].

    " computable objects at the end of the dump name space (Character, Integer) "
    ^self computedObjectDescription: (self computedObjectFromId: id).! 
describeObjectDescriptors
        " Private - Read the <object descriptors section> "
    | numEntries objectId classId size basicHash
      classInfo values entryInfo
      numNamedVars instVarNames |

    numEntries := 0.
    [(objectId := objectStream getInteger) ~= IdNUL] whileTrue: [
        numEntries := numEntries + 1.
        classId := objectStream getInteger.
        size := objectStream getInteger.
        basicHash := objectStream getInteger.
        classInfo := behaviors at: classId.
        (classInfo value = RepVariableBytes) ifTrue: [
            values :=
                ((classInfo key = 'DoubleByteString')
                or: [classInfo key = 'DoubleByteSymbol'])
                    ifTrue: [(Smalltalk at: #DoubleByteString) basicNew: size]
                    ifFalse: [String new: size].
                    " leave symbols as strings for report "
            objectStream getBytesFor: values]
        ifFalse: [
            values := Array new: (((objects at: classId) size) + size).
            1 to: values size do: [ :i |
                values at: i put: (objectStream getInteger)]].
        objects at: objectId put:
            (Array with: classId with: size with: basicHash with: values).
        ].  " processing object description entry "

    " dump objects in id order (not filed order) "
    textStream cr; nextPutAll: 'Object descriptors section (id = object entry)'; cr.
    (behaviors size + 1) to: (objects size) do: [ :objectId |
        entryInfo := objects at: objectId.
        classId := entryInfo at: 1.
        size := entryInfo at: 2.
        basicHash := entryInfo at: 3.
        values := entryInfo at: 4.
        textStream nextPutAll: (objectId printString), ' = '.
        ((classId = ClassIdSymbol) or: [classId = ClassIdDBSymbol])
        ifTrue: [   "symbols were read in as strings"
            textStream nextPutAll:
                '#', values, ' (basicHash = ', basicHash printString, ')'; cr]
        ifFalse: [
            textStream nextPutAll:
                ((behaviors at: classId) key),
                ' instance (basicHash = ', basicHash printString, ')'; cr.
            ((behaviors at: classId) value = RepVariableBytes) ifTrue: [
                textStream nextPutAll:
                    '    ', 'bytes(', size printString, '): ',
                    values; cr]
            ifFalse: [
                instVarNames := objects at: classId.
                numNamedVars := instVarNames size.
                " named instance variables "
                1 to: numNamedVars do: [ :i |
                    textStream nextPutAll:
                        '    ', (instVarNames at: i), ': ',
                        (self describeId: (values at: i)); cr].
                " indexed instance variables "
                1 to: size do: [ :i |
                    textStream nextPutAll:
                        '    ', i printString, ': ',
                        (self describeId: (values at: (numNamedVars + i))); cr]]].
        ].
    textStream
        nextPutAll: '(', numEntries printString, ' object descriptor entries)'; cr.
    "ASSERT [numEntries = numObjects]."!  
describeObjectsNop
        " Private - Read the <object descriptors section> "
    | objectId classId size basicHash classInfo
      values summaryDict numInstances total count |

    numInstances := Array new: behaviors size.
    numInstances atAllPut: 0.

    [(objectId := objectStream getInteger) ~= IdNUL] whileTrue: [
        classId := objectStream getInteger.
        size := objectStream getInteger.
        basicHash := objectStream getInteger.
        classInfo := behaviors at: classId.
        (classInfo value = RepVariableBytes) ifTrue: [
            values :=
                ((classInfo key = 'DoubleByteString')
                or: [classInfo key = 'DoubleByteSymbol'])
                    ifTrue: [(Smalltalk at: #DoubleByteString) basicNew: size]
                    ifFalse: [String new: size].
                    " leave symbols as strings for report "
            objectStream getBytesFor: values]
        ifFalse: [
            values := Array new: (((objects at: classId) size) + size).
            1 to: values size do: [ :i |
                values at: i put: (objectStream getInteger)]].
        numInstances at: classId 
            put: ((numInstances at: classId) + 1).
        ].  " processing object description entry "

    " report instance counts "
    textStream cr; nextPutAll: 'Object counts by class:'; cr.
    summaryDict := Dictionary new.
    1 to: behaviors size do: [ :i |
        ((classInfo := behaviors at: i) notNil
        and: [(classInfo value ~= NUL)  " skip metaclasses "
        and: [(count := numInstances at: i) > 0]])
            ifTrue: [summaryDict at: classInfo key put: count]].
    total := 0.
    summaryDict keys asSortedCollection do: [ :className |
        count := summaryDict at: className.
        textStream nextPutAll: 
            className, ': ', count printString, 
            ((count = 1) ifTrue: [' instance'] ifFalse: [' instances']); 
            cr.
        total := total + count].
    textStream nextPutAll: total printString, ' objects'; cr.! 
describeObjectVersion
        " Private - emit header describing the objectVersion. "
    textStream
        nextPutAll: '"Smalltalk/V filed object description"'; cr;
        nextPutAll: (
            'Version ', objectVersion printString,
            ' (1 = V; 2 = V286; 3 = VPM 1.2;',
           ' 4 = VW 2.0; 5 = VPM 1.3; 6 = VPM 2.0)'); 
        cr; cr.!
dllNameDict: anIdentityDictionary
        " Register the DLL mapping dictionary to use
        for object dumping.  Entries map a class
        to a string containing the DLL name to use for
        that class when an object is dumped. "
    dllNameDict := anIdentityDictionary.!  
dllNameOf: behavior
        " Private "
    | dllName |
    (dllNameDict notNil
    and: [(dllName := dllNameDict at: behavior ifAbsent: [nil]) notNil])
        ifTrue: [^dllName fileNameLessPath fileName].
    ^(behavior isInDLL and: [behavior isInBase not])
        ifTrue: [behavior dllName fileNameLessPath fileName]
        ifFalse: ['']!   
dump: anObject on: aStream
        " Write a compressed description of anObject
        (along with anObject's referenced structure)
        onto aStream. "
    | lastDynamicId |

    CursorManager execute change.
    Seal isNil ifTrue: [self class initialize].
    self class initSingularIds.  " refresh global bindings "

    objectStream := ((aStream respondsTo: #asByteFileStream)
        ifTrue: [aStream asByteFileStream]
        ifFalse: [aStream]).
    messageCounts := nil.

    " behaviors dictionary maps class/metaclass object to its dump id. "
    " The dump ids of behaviors follow the predefined objects in the name space. "
    behaviors := LargeIdentityDictionary new: 127.

    " objects dictionary maps non-behavior object to an association
        defining its relative object id [1..n] and surrogate. "
    " The dump ids of objects follow the behaviors in the name space."
    " Relative object number is mapped to dump id after behavior ids known. "
    objects := LargeIdentityDictionary new.

    " enumerate the contents of anObject, logging all its component
      objects and behaviors "
    objectVersion := self class version.
    numBehaviors := 0.
    numObjects := 0.
    self log: anObject.
    lastDynamicId := NumPredefinedIds + numBehaviors + numObjects.
    self assignComputedIdRanges: lastDynamicId.

    " write the <header section> of the filed object dump:
        <seal> <version> <num behaviors> <num objects> <root object id> <NUL> "
    objectStream
        nextPut: Seal;
        putInteger: objectVersion;
        putInteger: behaviors size;
        putInteger: objects size;
        putInteger: (self dumpIdOf: anObject);
        nextPut: NUL.

   " write the body of the filed object dump "
    self
        dumpBehaviorDescriptors;    " <behavior descriptors section> "
        dumpObjectDescriptors.         " <object descriptors section> "

    messageCounts notNil
        ifTrue: [self recordSummaryMessage: 'object dumping'].
    CursorManager normal change.!   
dumpBehaviorDescriptors
        " Private - Write the <behavior descriptors section>. "
    | hasDllName behavior tag name rep numInstVars |

    " write a <behavior descriptor> entry for each behavior "
    " <behavior type> <id> <nameString> <NUL> 
            <representation>
            <number of named instance vars> [<inst var name>]... 
            <DLL name> <NUL>  [version-dependent] "
    " for class, store names of all the inst vars in <name> <NUL> form "
    hasDllName := self class versionHasDllInfo: objectVersion.
    behaviors associationsDo: [ :assoc |
        behavior := assoc key.
        name := behavior name.
        (behavior class == MetaClass)
            ifTrue: [
                tag := TagMetaClass.
                rep := NUL.
                numInstVars := 0.
                name := name copyFrom: 1 to: (name size - 6).  " strip trailing ' class' "]
            ifFalse: [
                tag := TagClass.
                rep := self repOf: behavior.
                numInstVars := behavior instSize].
        objectStream
            nextPut: tag;
            putInteger: assoc value;  " id "
            nextPutAll: name; nextPut: NUL;
            nextPut: rep;
            putInteger: numInstVars.
        (numInstVars > 0)
            ifTrue: [(behavior allInstVarNames) do: [ :instVarName |
                objectStream nextPutAll: instVarName; nextPut: NUL]].
        hasDllName
            ifTrue: [objectStream 
                nextPutAll: (self dllNameOf: behavior);
                nextPut: NUL].
        ].

    objectStream nextPut: NUL.  " section terminator "!   
dumpIdOf: anObject
        " Private - Answer the dump id of anObject in the objectStream."
    | objectsEntry |

    " predefined identifiers at the beginning of the dump id name space "
    anObject isNil ifTrue: [^IdNil].
    (SingularClasses includes: anObject class) ifTrue: [
        ^SingularObjects at: anObject
            ifAbsent: [
                self recordWarningMessage: 
                    ' duplicate member of singular class ',
                    anObject class printString, ' was encountered; mapped to nil.'.
                IdNil]].

    " dynamically assigned behavior id "
    (anObject isKindOf: Behavior) ifTrue: [^behaviors at: anObject].

    " computed ids of immutable objects at the end of the name space "
    anObject isCharacter ifTrue: [
        ((anObject respondsTo: #isSingleByte) not
        or: [anObject isSingleByte]) ifTrue: [
            ^idCharacterZero + anObject asciiValue]].  "single-byte char"
        "ifFalse: [double-byte character with dynamic id]"
    (anObject isKindOf: Integer) ifTrue: [
        ^idIntegerZero +
            (anObject positive  " use low-order bit for sign "
                ifTrue: [anObject * 2]   " even id for positive "
                ifFalse: [anObject negated * 2 + 1])].  " odd id for negative "

    " objects with dynamically assigned ids "
    objectsEntry := objects at: anObject ifAbsent: [nil].
    ^(objectsEntry isNil)
        ifTrue: [IdNil]
        ifFalse: [NumPredefinedIds + numBehaviors + objectsEntry key]!  
dumpObjectDescriptors
        " Private - Write the <object descriptors section> of the object dump "
    | lastBehaviorId objectId object class classId |

    " Write an <object descriptor> for each (surrogate) object:
        <object id> <class id> <number of indexed instance variables>
            <basicHash> <bytesOrPointers>
      "
    lastBehaviorId := NumPredefinedIds+ numBehaviors.
    objects do: [ :assoc |  " ignore original object, only need surrogate "
        objectId := lastBehaviorId + assoc key.  " last behavior id + relative object id "
        object := assoc value.   " surrogate "
        class := object class.
        classId :=
            object isSymbol
                ifTrue: [(class == Symbol)
                    ifTrue: [ClassIdSymbol]
                    ifFalse: [ClassIdDBSymbol]]
                ifFalse: [self dumpIdOf: class].
            " We can play games with symbol class ids because
                we know class ids start at NumPredefinedIds + 1 "
        objectStream
            putInteger: objectId;
            putInteger: classId;
            putInteger: object basicSize;
            putInteger: object basicHash.
        (class isBytes) ifTrue: [
            objectStream putBytesFrom: object]
        ifFalse: [   " pointers "
            1 to: (class instSize + object basicSize) do: [ :i |
                objectStream
                    putInteger: (self dumpIdOf: (object instVarAt: i))]]].

    objectStream nextPut: NUL.  " section terminator "!   
fileInActivateForErrorClass: errorObject
        " Private - nuke the nasty stuff.  Objects should be doing this themselves... "
    | errorClass errorMessage surrogate instVarNames slot
      homeContext blockArgCount index |

    " won't be able to load sortBlock, but rest of SortedCollection is ok "
    (errorObject isKindOf: SortedCollection) ifTrue: [
        errorObject sortBlock isContext 
            ifFalse: [^errorObject].  " not error if something safe sorting it "
        self recordWarningMessage: 
            'The sortBlock of a SortedCollection cannot be loaded properly, won''t be bound.'.
        ^errorObject].

    errorClass := errorObject class.
    errorMessage := 'ObjectFiler error: cannot load a ', errorClass name.
    self recordWarningMessage:
        'a ', errorClass name,
        ' cannot be loaded properly, won''t  be bound.'.

    (errorObject isKindOf: CompiledMethod) ifTrue: [
        surrogate :=
            errorMessage, ' (', errorObject classField name,
            '>>', errorObject selector asString, ')'.
        ^surrogate].

    (errorObject isKindOf: Context) ifTrue: [
        instVarNames := errorObject class allInstVarNames.
        homeContext := errorObject instVarAt: (instVarNames indexOf: 'homeContext').
        slot := instVarNames indexOf: 'blockArgumentCount'.  " VW only; not in VPM "
        (slot = 0) ifFalse: [blockArgCount := errorObject instVarAt: slot].
        (errorObject isKindOf: HomeContext) ifTrue: [
            errorMessage :=
                errorMessage,
                (blockArgCount isNil
                    ifTrue: [' (homeContext, method, receiver values follow)']
                    ifFalse: [' (blockArgumentCount, homeContext, method, receiver values follow)']).
            surrogate := Array new: (blockArgCount isNil ifTrue: [4] ifFalse: [5]).
            surrogate at: 1 put: errorMessage.
            blockArgCount isNil ifTrue: [
                index := 2]
            ifFalse: [
                surrogate at: 2 put: blockArgCount.
                index := 3].
            surrogate at: index put: homeContext.
            index := index + 1.
            slot := instVarNames indexOf: 'method'.
            surrogate at: index put: (errorObject instVarAt: slot).
            index := index + 1.
            slot := instVarNames indexOf: 'receiver'.
            surrogate at: index put: (errorObject instVarAt: slot)]
        ifFalse: [
            blockArgCount isNil ifTrue: [
                errorMessage := errorMessage, ' (homeContext value follows)'.
                surrogate := Array
                    with: errorMessage
                    with: homeContext]
            ifFalse: [
                errorMessage :=
                    errorMessage,
                    ' (blockArgumentCount, homeContext value follows)'.
                surrogate := Array
                    with: errorMessage
                    with: blockArgCount
                    with: homeContext]].
        ^surrogate].

    (errorObject isKindOf: Process) ifTrue: [
        surrogate := errorMessage, ' (name = ', errorObject name printString, ')'.
        ^surrogate].

    ^errorMessage! 
fileOutSurrogateForErrorClass: errorObject
        " Private - nuke the nasty stuff.  Objects should be doing this themselves... "
    | errorClass surrogate instVarNames slot |

    " can't store sortBlock, give user a chance to salvage SortedCollection "
    (errorObject isKindOf: SortedCollection) ifTrue: [
        errorObject sortBlock isContext 
            ifFalse: [^errorObject].  " not error if something safe sorting it "
        (MessageBox confirm: 'Dump SortedCollection as OrderedCollection?')
            ifTrue: [
                ^errorObject asOrderedCollection]
            ifFalse: [
                self recordWarningMessage: 
                    'The sortBlock of a SortedCollection cannot be dumped properly, won''t be bound when loaded.'.
                ^errorObject]].

    errorClass := errorObject class.
    surrogate := errorClass basicNew.  " drops any indexed variables "
    self recordWarningMessage:
        'a ', errorClass name,
        ' cannot be dumped properly, won''t be bound when loaded.'.

    " selectively allow some information to be filed as clues... "
    (errorObject isKindOf: CompiledMethod) ifTrue: [
        surrogate
            classField: errorObject classField;
            selector: errorObject selector.
        ^surrogate].
    (errorObject isKindOf: Context) ifTrue: [
        " funky stuff because methods (properly!!) don't exist to get/set all of this "
        instVarNames := errorObject class allInstVarNames.
        slot := instVarNames indexOf: 'homeContext'.
        surrogate instVarAt: slot put: (errorObject instVarAt: slot).
        slot := instVarNames indexOf: 'blockArgumentCount'.  " VW only; not in VPM "
        (slot = 0) ifFalse: [surrogate instVarAt: slot put: (errorObject instVarAt: slot)].
        (errorObject isKindOf: HomeContext) ifTrue: [
            slot := instVarNames indexOf: 'method'.
            surrogate instVarAt: slot put: (errorObject instVarAt: slot).
            slot := instVarNames indexOf: 'receiver'.
            surrogate instVarAt: slot put: (errorObject instVarAt: slot)].
        ^surrogate].
    (errorObject isKindOf: Process) ifTrue: [
        surrogate
            initPositions: 0;  " empty contents so hash works properly "
            name: errorObject name.
        ^surrogate].

    ^surrogate!   
instanceLayoutChanging: anArray
       " Private - answer whether inst var remapping needed. "
    | filedSize loadMap |
    filedSize := anArray at: 1.
    loadMap := anArray at: 2.
    (filedSize ~= loadMap size)
        ifTrue: [^true].   " adding or dropping values "
    1 to: (filedSize min: loadMap size) do: [ :i |
        ((loadMap at: i) = i) ifFalse: [^true]].  " inst var shuffled or dropped "
    ^false!
instVarLoadMapFrom: aCollection filedNames: filedNames loadNames: loadNames
        " Private - answer an instVarLoadMap based on the
        assoc's in aCollection which strings in filedNames
        to strings in loadNames.  Answer nil if an invalid
        instance variable name was specified. "
    | loadMap loadSlot filedSlot |
    loadMap := Array new: loadNames size.
    aCollection do: [ :assoc |
        loadSlot := loadNames indexOf: assoc key ifAbsent: [^nil].
        filedSlot := filedNames indexOf: assoc value 
            ifAbsent: [filedNames indexOf: assoc key " try current name "
                ifAbsent: [nil]].  " a new inst var is ok "
        filedSlot notNil
            ifTrue: [loadMap at: loadSlot put: filedSlot]].
    ^loadMap!   
loadBehaviorDescriptors: loadMapsDict
         " Private - Read the <behavior descriptors section>
        of the objectStream to find referenced classes and
        MetaClasses and put pointers to them in objects list
        at their dump id.  Where there is a size mismatch,
        record an instVar map in the behaviors list. "
    | hasDllName dllBinder tag classId name rep 
      numNamedInstVars filedInstVarNames dllName
      behavior loadName loadRep loadInstVarNames
      loadAssoc instVarLoadMap title |

    hasDllName := self class versionHasDllInfo: objectVersion.
    hasDllName 
        ifTrue: [dllBinder := Smalltalk at: #ObjectLibraryBind].
    [(tag := objectStream next) ~= NUL] whileTrue: [
        classId := objectStream getInteger.
        name := objectStream upTo: NUL.
        rep := objectStream next.
        numNamedInstVars := objectStream getInteger.
        filedInstVarNames := Array new: numNamedInstVars.
        1 to: numNamedInstVars do: [ :i |
            filedInstVarNames at: i put: (objectStream upTo: NUL)].
        dllName := (hasDllName
            ifTrue: [objectStream upTo: NUL]
            ifFalse: [nil]).
        loadAssoc := loadMapsDict at: name ifAbsent: [nil].
        " determine the class to load into "
        loadAssoc notNil ifTrue: [  " override normal loading "
            loadName := loadAssoc key.
            (Smalltalk includesKey: loadName asSymbol) ifFalse: [
                self recordWarningMessage:
                    self warningLoadCancelled,
                    ' - class ', loadName, ' not found in this system',
                    ' (specified by load map as new class of filed ',
                    name, ' instances).'.
                ^nil]]
        ifFalse: [  " allow user to specify load class if class is not present "
            loadName := name.
            ((dllName size > 0)   " automatically bind DLL "
            and: [(Smalltalk includesKey: loadName asSymbol) not])
                ifTrue: [
                    self recordInfoMessage: 
                        'Attempting to bind DLL ', dllName,
                        ' to locate class ', loadName.
                    (dllBinder attemptBindTo: dllName)
                       ifTrue: [self recordInfoMessage: '    ...done']
                       ifFalse: [self recordInfoMessage: '   (unable to open or wrong version)'].
                    ].
            [Smalltalk includesKey: loadName asSymbol] whileFalse: [
                loadName := Prompter
                    prompt: 'Class ', name, ' is not in target system, enter new name:'
                    default: loadName.
                (loadName isNil) ifTrue: [   " bail if user cancelled "
                    self recordWarningMessage: 
                        self warningLoadCancelled,
                        ' - class ', name, ' not found in this system.'.
                    ^nil]]].
        behavior := Smalltalk at: loadName asSymbol.
        " determine whether load class is compatible or needs inst map "
        (tag = TagMetaClass) ifTrue: [
            behavior := behavior class]
        ifFalse: [   " check for incompatible class changes "
            " check for representation mismatch "
            loadRep := self repOf: behavior.
            (self rep: rep canBeLoadedInto: loadRep filedClass: name) ifFalse: [
                self recordWarningMessage:
                    self warningLoadCancelled,
                    ' -  cannot load filed ',
                    (self repDescription: rep), ' class ', name,
                    ' into ', (self repDescription: loadRep), ' class ', loadName.
                ^nil].
            " build load map for shape change or per loadMapsDict "
            loadInstVarNames := behavior allInstVarNames.
            loadAssoc notNil ifTrue: [
                instVarLoadMap := self
                    instVarLoadMapFrom: loadAssoc value
                    filedNames: filedInstVarNames
                    loadNames: loadInstVarNames.
                instVarLoadMap isNil ifTrue: [  " invalid mapping "
                    self recordWarningMessage: 
                         self warningLoadCancelled,
                         ' - load map supplied for changed class ',
                         name, ' is unusable.'.
                    ^nil]]
            ifFalse: [   " check for shape changes "
                ((numNamedInstVars ~= behavior instSize)
                or: [filedInstVarNames ~= loadInstVarNames]) ifTrue: [
                    " need to get mapping for shape change "
                    ((self class version = 6) 
                    and: [behavior name = 'Association'
                    and: [name = 'Association']]) ifTrue: [
                        " automatically upgrade assoc in VPM 2.0 "
                        instVarLoadMap := Array with: 2 with: 1]
                    ifFalse: [   " make user tell us what to do "
                        title := 'Loading class ', name.
                        (loadName ~= name)
                            ifTrue: [title := title, ' into ', loadName].
                        instVarLoadMap := ObjectLoadDialog new
                            openFor: title
                            sourceTitle: 'Filed:'
                            sourceVars: filedInstVarNames
                             destTitle: 'Loading:'
                            destVars: loadInstVarNames.
                        instVarLoadMap isNil ifTrue: [  " user cancelled "
                            self recordWarningMessage: 
                                 self warningLoadCancelled,
                                 ' - instance variable remapping for changed class ',
                                 name, ' cancelled.'.
                            ^nil]]
                    ]
                ifFalse: [  " no shape change or mapping override "
                    instVarLoadMap := nil]].
            instVarLoadMap notNil ifTrue: [
                instVarLoadMap := Array
                    with: numNamedInstVars    " num filed values "
                    with: instVarLoadMap.
                (self instanceLayoutChanging: instVarLoadMap)
                    ifTrue: [behaviors at: classId put: instVarLoadMap].
                ]].
        objects at: classId put: behavior.
        " track shape changes only if loading blocks "
        (remappedObjects isNil
        and: [behavior == HomeContext])  
            ifTrue: [remappedObjects := 
                LargeIdentityDictionary new: 127].
        ].!  
loadFrom: aStream
        " Answer the object encoded on aStream at
        aStream's current position. "
    ^self loadFrom: aStream loadMaps: Dictionary new!
loadFrom: aStream loadMaps: loadMapsDict
        " Answer the object encoded on aStream at
        aStream's current position.  The loadMapsDict
        defines mappings for loading classes whose
        shape has changed.  The loadMapsDict key
        is the name of a filed class.  The value is an
        assoc whose key is the name of the class into
        which to load the filed instances and whose
        value is a collection of assoc's defining the instance
        variable mappings.  The key of an inst var map assoc
        is the name of the instance variable to be loaded
        and the value is the name of the filed inst var to
        load into its slot in the restored object.  An inst var
        is loaded with nil if there is no mapping for it. "
    | initialPosition rootObjectId lastBehaviorId
      firstObjectId lastObjectId |

    CursorManager execute change.
    Seal isNil ifTrue: [self class initialize].
    self class initSingularIds.  " refresh global bindings "

    objectStream := ((aStream respondsTo: #asByteFileStream)
        ifTrue: [aStream asByteFileStream]
        ifFalse: [aStream]).
    messageCounts := nil.
    operationAborted := false.
    initialPosition := objectStream position.  " for failure backout "

    " read the header section to verify version and establish the name space "
    (objectStream next ~= Seal)
        ifTrue: [
            self recordWarningMessage: 'Incorrect seal for filed object.'.
            objectStream position: initialPosition.  " back out "
            CursorManager normal change.
            ^nil].
    objectVersion := objectStream getInteger.
    (self class versionCanBeLoaded: objectVersion)
        ifFalse: [
            self recordWarningMessage: 
                'This ObjectFiler cannot load filed objects of version ',
                objectVersion printString.
            objectStream position: initialPosition.  " back out "
            CursorManager normal change.
            ^nil].
    numBehaviors := objectStream getInteger.
    numObjects := objectStream getInteger.
    rootObjectId := objectStream getInteger.
    (objectStream next ~= NUL)
        ifTrue: [
            self recordWarningMessage: 
                'File format error (bad header section)'.
            objectStream position: initialPosition.  " back out "
            CursorManager normal change.
            ^nil].

    " set up the dump id name space "
    lastBehaviorId := NumPredefinedIds + numBehaviors.
    firstObjectId := lastBehaviorId + 1.
    lastObjectId := lastBehaviorId + numObjects.
    self assignComputedIdRanges: lastObjectId.

    " objects is indexed by the dump ID of a behavior or object entry.
        For a behavior, contains loading system's behavior object.
        For an object, contains the restored object. "
    objects := Array new: lastObjectId.
    " behaviors is indexed by the dump ID of a behavior enty.
        For a behavior, contains an instVar mapping for size/shape changes. "
    behaviors := Array new: lastBehaviorId.
    " remappedObjects maps slot-shuffled objects to source info
        when loading blocks "
    remappedObjects := nil.

    " load the predefined objects "
    objects at: IdNil put: nil.
    SingularObjects associationsDo: [ :anAssociation |
        objects at: anAssociation value put: anAssociation key].

    (self loadBehaviorDescriptors: loadMapsDict) isNil ifTrue: [
        " unable to bind xrefs to load environment "
        objectStream position: initialPosition.  " back out "
        CursorManager normal change.
        ^ nil].
    self
        loadObjectDescriptors;
        restoreInstVars: firstObjectId;
        restoreLoadedObjects: firstObjectId rootObjectId: rootObjectId.
    operationAborted
        ifFalse: [self restoreLoadedHashStructures: firstObjectId].
    remappedObjects := nil.

    messageCounts notNil
        ifTrue: [self recordSummaryMessage: 'object loading'].
    CursorManager normal change.

    operationAborted ifTrue: [^nil].  " fatal load error encountered "
    ^(rootObjectId < idCharacterZero)
        ifTrue: [objects at: rootObjectId]
        ifFalse: [self computedObjectFromId: rootObjectId].! 
loadInstVarIds: skeletonObject mapping: loadMap size: size
        " Private - Read pointer <values> of an <object descriptor>
        and stash the ids in the instance variables of skeletonObject.
        An instVarMap may be supplied to reorder the named instVars;
        it will always be provided when the load class is a different
        size than was the dump class. "
    | class filedSize filedValues instVarLoadMap filedIndex |

    class := skeletonObject class.

    " load named instance variables "
    loadMap isNil
        ifTrue: [  " no size change and no reordering of named instance variables "
            1 to: class instSize do: [ :i |
                skeletonObject instVarAt: i put: (objectStream getInteger)]]
        ifFalse: [  " reordering inst vars or changing class size "
            filedSize := loadMap at: 1.
            instVarLoadMap := loadMap at: 2.
            "ASSERT [instVarLoadMap size = class instSize]."
            " read all the filed values "
            filedValues := Array new: filedSize.
            1 to: filedSize do: [ :i |
                filedValues at: i put: (objectStream getInteger)].
            " load slots in skeleton, using filed values per user mapping "
            1 to: class instSize do: [ :i |
                filedIndex := instVarLoadMap at: i.
                skeletonObject instVarAt: i put:
                    ((filedIndex isNil)
                        ifTrue: [IdNil]
                        ifFalse: [filedValues at: filedIndex])].
            remappedObjects notNil
                ifTrue: [remappedObjects at: skeletonObject 
                                put: loadMap].
            ].

    " load indexed instance variables "
    (size > 0) ifTrue: [
        (class isVariable) ifTrue: [
            1 to: size do: [ :i |
                skeletonObject basicAt: i put: (objectStream getInteger)]]
        ifFalse: [  " drop filed indexed values on the floor "
            1 to: size do: [ :i | objectStream getInteger]]].!
loadLayoutChanges: anObject
        " Answer inst var change history for anObject.
        If the positions of anObject's instance values changed
        during loading, an array is answered with entries:
            1 - filed size of anObject
            2 - array indexed by current inst var slot containing
                    filed slot index that was loaded into this slot
                    (nil if no value loaded into this slot)
        May only be called by a fileInActivate: method. "
    ^remappedObjects at: anObject ifAbsent: [nil]!   
loadObjectDescriptors
        " Private - Read the <object descriptors section> of the file.
        For each <object descriptor>, put the byte-date object
        or a pointer skeleton whose slots contain dump ids
        in the object list at its dump id. "
    | objectId classId size basicHash class anObject |

    [(objectId := objectStream getInteger) ~= IdNUL] whileTrue: [
        classId := objectStream getInteger.
        size := objectStream getInteger.
        basicHash := objectStream getInteger.
        ((classId = ClassIdSymbol) or: [classId = ClassIdDBSymbol]) ifTrue: [
            anObject := (classId = ClassIdSymbol)
                ifTrue: [String new: size]
                ifFalse: [(Smalltalk at: #DoubleByteString) basicNew: size].
            objectStream getBytesFor: anObject.
            anObject := anObject asSymbol]
        ifFalse: [
            class := objects at: classId.
            anObject := self new: class size: size.
            anObject hash: basicHash.  " hash: is really basicHash: "
            (class isBytes)
                ifTrue: [objectStream getBytesFor: anObject]
                ifFalse: [self
                    loadInstVarIds: anObject
                    mapping: (behaviors at: classId)
                    size: size]].
        objects at: objectId put: anObject].!   
log: anObject
        " Private - Ensure anObject is in one of the two dictionaries,
        (behaviors or objects).  Recurse to log anObject's
        class and instance variables."
    | class surrogate |

    " behaviors entry maps behavior to its dump id. "
    (anObject isKindOf: Behavior) ifTrue: [
        (anObject == MetaClass) ifTrue: [^anObject].  " in TerminalClasses "
        (behaviors includesKey: anObject) ifFalse: [
            numBehaviors := numBehaviors + 1.
            behaviors at: anObject put: (NumPredefinedIds + numBehaviors)].
        ^anObject].

    " objects entry maps non-terminal object to its
        relative object number [1..n] and surrogate "
    ((TerminalClasses includes: anObject class)
    or: [(anObject isCharacter and: [anObject isSingleByte])
    or: [objects includesKey: anObject]])
        ifTrue: [^anObject].

    " allow object to sanitize its contents or transform itself if desired "
    surrogate := anObject fileOutSurrogate: self.
    class := surrogate class.
    (ErrorClasses includes: class) ifTrue: [
        surrogate := self fileOutSurrogateForErrorClass: surrogate.
        class := surrogate class].

    " log object's class in behaviors if not a self-describing <object descriptor> "
    surrogate isSymbol
        ifFalse: [self log: class].

    " log the object itself "
    numObjects := numObjects + 1.
    objects
        at: anObject
        put: (Association key: numObjects value: surrogate).

    " log each named instance variable and any indexed inst vars "
    (class isPointers) ifTrue: [
        1 to: (class instSize + surrogate basicSize) do: [ :i |
            self log: (surrogate instVarAt: i)]].
    ^anObject!
new: aClass size: numIndexedInstVars
        " Private - Answer a new skeleton instance of aClass. "
    ^(aClass isVariable)
        ifTrue: [aClass basicNew: numIndexedInstVars]
        ifFalse: [aClass basicNew]!   
objectVersion
        " Answer the filed version of the object
        currently being loaded or dumped. "
    ^objectVersion! 
recordAbortMessage: aString
        " Abort the operation in progress and notify the 
        user that a fatal error has occurred. "
    self recordMessage: aString 
        type: 'abort' 
        prefix: '*****FATAL ERROR: '.
    operationAborted := true.!  
recordInfoMessage: aString
        " Notify the user that something interesting has occurred. "
    self recordMessage: aString type: 'info' prefix: ''.!   
recordMessage: message type: type prefix: prefix
        " Private - record message about the current operation. "
    | messageWindow date |

   " update the message counts "
    messageCounts isNil
        ifTrue: [
            messageCounts := Dictionary new.
            #( 'summary' 'info' 'warning' 'abort') do: [ :aType |
                    messageCounts at: aType put: 0]].
    messageCounts 
        at: type put: ((messageCounts at: type) + 1);
        at: 'summary' put: ((messageCounts at: 'summary') + 1).

    clientMessageHandler notNil
        ifTrue: [
            clientMessageHandler 
                value: self 
                value: (Association key: type value: message).
            ^self].

    messageStream isNil ifTrue: [
        messageWindow := TextWindow new openOn: String new.
        date := Date today.
        messageStream := messageWindow pane.
        messageStream
            nextPutAll: 'ObjectFiler messages (';
            "nextPutAll: Date today printString; nextPut: Space;"
            nextPutAll: date dayOfMonth printString; nextPut: $-;
            nextPutAll: (date monthName copyFrom: 1 to: 3); nextPut: $-;
            nextPutAll: (date year printString copyFrom: 3 to: 4); nextPut: Space;
            nextPutAll: Time now printString;
            nextPutAll: ')'; cr; cr].
    messageStream 
        nextPutAll: prefix;
        nextPutAll: message; cr.!  
recordSummaryMessage: operationDescription
        " Private - summarize messages 
        were encountered during the dump or
        load operation that has just completed. "
    | numWarnings |
    clientMessageHandler notNil
        ifTrue: [
            clientMessageHandler 
                value: self 
                value: (Association key: 'summary' value: messageCounts)]
        ifFalse: [
            ((numWarnings := messageCounts at: 'warning') > 0) 
                ifTrue: [messageStream
                    cr; nextPutAll: '***** '; 
                    nextPutAll: numWarnings printString;
                    nextPutAll: ' warnings encountered during ';
                    nextPutAll: operationDescription;
                    nextPutAll: ' *****'; cr].
            ((messageCounts at: 'abort') > 0)
                ifTrue: [messageStream
                    cr; nextPutAll: '***** ';
                    nextPutAll: operationDescription;
                    nextPutAll: ' aborted *****'].
            messageCounts := messageStream := nil].!   
recordWarningMessage: aString
        " Notify the user that a non-fatal error has occurred.
        Usually indicates the dumping or loading of
        an object that should be bound but won't be."
    self recordMessage: aString type: 'warning' prefix: 'Warning: '.!  
rep: filedRep canBeLoadedInto: loadRep filedClass: className
        " Private - answer whether filed class can be loaded into
        class with loadRep representation "
    (filedRep = loadRep)
        ifTrue: [^true].
    ((filedRep = RepVariableBytes) | (loadRep = RepVariableBytes))
        ifTrue: [^false].  " can't load into bytes into pointers or vice-versa "
    " pointers can be either indexed or fixed on either side "
    (filedRep = RepVariablePointers) "& (loadRep = RepFixedPointers)"
        ifTrue: [self recordWarningMessage:
                'Indexed instance variables of class ', className,
                ' dropped (loaded into non-indexed class)'].
    ^true!  
repDescription: rep
        " Private - answer a string describing rep "
    ^(rep = RepFixedPointers)
        ifTrue: ['fixedPointers']
        ifFalse: [(rep = RepVariablePointers)
            ifTrue: ['variablePointers']
            ifFalse: ['variableBytes']]!
repOf: class
        " Private - answer representation of class "
    ^(class isPointers)
        ifTrue: [(class isVariable)
            ifTrue: [RepVariablePointers]
            ifFalse: [RepFixedPointers]]
        ifFalse: [RepVariableBytes]!   
restoreInstVars: firstObjectId
        " Private - restore instance variables in the skeleton objects "
    | anObject class id |

    firstObjectId to: (objects size) do: [ :objectId |
        anObject := objects at: objectId.
        class := anObject class.
        (class isPointers) ifTrue: [
            1 to: (class instSize + anObject basicSize) do: [ :i |
                id := anObject instVarAt: i.   " dump id "
                anObject instVarAt: i put:
                    ((id < idCharacterZero)
                        ifTrue: [objects at: id]  " predefined and dynamically assigned ids "
                        ifFalse: [self computedObjectFromId: id])]]]  " computed objects "! 
restoreLoadedHashStructures: firstObjectId
        " Private - rehash objects dumped from VPM 1.2
        which rely on basicHash. "
    | containsIdDict lastObjectId loadedObject rehashedDict
      contentsSlot |
    (objectVersion = 3) " need to check VPM 1.2 IdDict's "
        ifFalse: [^self].  
    " check classes to see if any IdentityDictionary's were loaded "
    containsIdDict := false.
    (NumPredefinedIds + 1) to: (firstObjectId - 1) do: [ :i |
        (objects at: i) == IdentityDictionary
            ifTrue: [containsIdDict := true]].
    containsIdDict ifFalse: [^self].
    " scan objects to fix IdentityDictionary instances "
    "ASSUMPTION: nobody should point to IdDict contents
        array other than the dict itself, so don't bother with
        second-pass scan over objects to check for references
        which need to be reset to the new contents. "
    lastObjectId := objects size.
    contentsSlot := IdentityDictionary allInstVarNames indexOf: 'contents'.
    " restore in bottom-up order (ids were assigned top-down in object graph) "
    lastObjectId to: firstObjectId by: -1 do: [ :objectId |
        loadedObject := objects at: objectId.
        (loadedObject class == IdentityDictionary)
            ifTrue: [
                rehashedDict := IdentityDictionary newSize:
                    (loadedObject contents size // 2).
                loadedObject associationsDo: [ :anAssoc |
                    rehashedDict add: anAssoc].
                loadedObject
                    instVarAt: contentsSlot
                    put: rehashedDict contents]].!   
restoreLoadedObjects: firstObjectId rootObjectId: rootObjectId
        " Private - restore objects which need special initialization.
        Allow activation to transform the identity of the restored object. "
    | lastObjectId loadedObject activatedObject transformations class
      patchQ |

    lastObjectId := objects size.

    " restore in bottom-up order (ids were assigned top-down in object graph) "
    transformations := LargeIdentityDictionary new: 127.
    patchQ := OrderedCollection new.
    lastObjectId to: firstObjectId by: -1 do: [ :objectId |
        loadedObject := objects at: objectId.
        activatedObject :=
            (ErrorClasses includes: loadedObject class)
                ifTrue: [self fileInActivateForErrorClass: loadedObject]
                ifFalse: [loadedObject fileInActivate: self].
        (activatedObject ~~ loadedObject) ifTrue: [
            transformations at: loadedObject put: activatedObject.
            (activatedObject class isPointers)
                ifTrue: [patchQ add: activatedObject]].
        operationAborted ifTrue: [^nil]].

    (transformations size = 0) ifTrue: [^self].

    " fix up pointers in any objects which are being transformed to new identities "
    patchQ do: [ :aTransformedObject |
        class := aTransformedObject class.
        1 to: (class instSize + aTransformedObject basicSize) do: [ :i |
            activatedObject :=
                    transformations at: (aTransformedObject instVarAt: i) ifAbsent: [nil].
            activatedObject notNil
                ifTrue: [aTransformedObject instVarAt: i put: activatedObject]]].

    " fix references to any objects which changed their identity when activated "
    firstObjectId to: lastObjectId do: [ :objectId |
        loadedObject := objects at: objectId.
        class := loadedObject class.
        (class isPointers) ifTrue: [
            1 to: (class instSize + loadedObject basicSize) do: [ :i |
                activatedObject :=
                    transformations at: (loadedObject instVarAt: i) ifAbsent: [nil].
                activatedObject notNil
                    ifTrue: [loadedObject instVarAt: i put: activatedObject]]]].  " become: "

    " special check in case the root object transformed itself "
    (rootObjectId < idCharacterZero) ifTrue: [
        activatedObject :=
            transformations at: (objects at: rootObjectId) ifAbsent: [nil].
        activatedObject notNil
            ifTrue: [objects at: rootObjectId put: activatedObject]].!
warningLoadCancelled
        " Answer the warning message prefix used
        in all warning messages about a load
        operation being cancelled by the user."
    ^'Object loading cancelled'! !

! OSObject class methods !   
atKey: aKey
    "Private - Returns the object at aKey"

    ^ApplicationSystem atKey: aKey!
atKey: aKey ifAbsent: aBlock
    "Private - Returns the object at aKey"

    ^ApplicationSystem atKey: aKey ifAbsent: aBlock!  
atKey: aKey put: anObject
    "Private - Set the object at aKey"

    ^ApplicationSystem atKey: aKey put: anObject!
defaultProfilePathName
    "Private - Returns default profiler path name"

    ^StartUpApplication defaultProfilePathName! 
new
    "Creates an initialized object"
    ^super new initialize!  
profilePathName
    "Returns the name of the profile file"

    ^self atKey: #profilerPathName
        ifAbsent: [
            self atKey: #profilerPathName put: self defaultProfilePathName
        ]!
profiler
    "Private - Returns a profiler for the receiver"
    | profiler |
    profiler := WinProfiler new
        pathName: self profilePathName;
        applicationName: self name.
    ^profiler!
warning: aLabel
    "Log the message aLabel and alert the user..."
    ^StartUpApplication warning: aLabel! !

! OSObject methods !   
atKey: aKey
    "Private - Returns the object at aKey"

    ^ApplicationSystem atKey: aKey!
atKey: aKey ifAbsent: aBlock
    "Private - Returns the object at aKey"

    ^ApplicationSystem atKey: aKey ifAbsent: aBlock!  
atKey: aKey put: anObject
    "Private - Set the object at aKey"

    ^ApplicationSystem atKey: aKey put: anObject!
initialize
    "Private - Initialize the receiver"
    "Default action is to do class initialization if needed"
    "This method could be refined by subclasses..."!   
model
    "Returns the current application model or nil"
    ^self atKey: #model ifAbsent: []!  
profiler
    "Returns the default profiler for the receiver"
    ^self class profiler! !

! ApplicationModel methods !
system
    "Private - Returns the current System"

    ^self atKey: #system ifAbsent: []! !

! CDGuiaModel class methods !   
initializeHelp
    "Private - Initializes the Help dictionary.
    CDGuiaModel initializeHelp.
    "
    | dict |

    "Initialize the standard Help contents"
    self initializeStandardHelp.

    dict := Smalltalk at: #HelpStatusPane ifAbsent: [^nil].

    #(
        ('Archivo' 'Comandos para trabajar con archivos.')
        (fileNew 'Abre una nueva ventana...')
        (fileOpen 'Abre un nuevo mapa...')
        (fileRead 'Permite armar una nueva capa de informacin leyendo una base de datos.')
        (filePageSetup 'Permite configurar el tamao de pgina...')
        (filePrint 'Impresin rpida tratando de ocupar una pgina...')
        (filePrintPreview 'Permite hubicar y retamaar el rea a imprimir...')
        (printerSetup 'Configura impresora...')
        (fileRun 'Permite ejecutar otro programa.')
        (fileExit 'Termina la aplicacin.')

        ('Edit' 'Comandos de edicin...')
        (editCopy 'Copia al portafolios del sistema la informacin selecta')
        (editSearch 'Permite buscar usando direcciones...')
        (editSelect 'Selecciona un elemento...')
        (editSelectAll 'Selecciona todos...')
        (editDelete 'Borra el elemento selecto...')
        (editRemoveSelection 'Remueve el elemento selecto...')
        (editCapture 'Permite capturar el estado actual como un objeto...')

        ('Herramientas' 'Comandos de seleccin de herramientas...')
        (customizeToolBar 'Permite configurar la barra de herramientas...')
        (toolComputer 'Configuracin general del sistema...')
        (gridSetup 'Permite cambiar el tamao de la grilla...')
        (rulerSetup 'Permite cambiar la escala de la regla...')
        (toolCleanUp 'Trata de liberar memoria...')
        (toggleStickers 'Activa o desactiva etiquetas...')
        (toolSound 'Activa o desactiva sistema de ayuda por voz...')

        ('Ver' 'Comandos de visualizacin...')
        (toggleGrid 'Activa o Desactiva la grilla.')
        (toggleRuler 'Activa o Desactiva la regla.')
        (toggleToolPane 'Oculta o muestra barra de herramientas.')
        (toggleRuler 'Activa o Desactiva la regla.')
        (toggleStatusPane 'Mostrar texto explicativo.')
        (viewStamp 'Activa panel de visualizacion reducida.')
        (viewReferences 'Activa panel de referencias.')
        (fileSearch 'Activa panel de bsqueda de informacin.')
        (viewLayers 'Activa panel de seleccion de informacin.')
        (viewObjects 'Activa panel de objetos.')
        (viewHeader 'Edita cabeceras de pgina.')
        (viewFooter 'Edita pies de pgina.')
        (viewZoomIn 'Zoom para acercar...')
        (viewZoomOut 'Zoom para alejar...')
        (toggleFullScreen 'Pantalla completa.')

        ('Ventana' 'Comandos para organizar ventanas...')
        (mdiNewWindow 'Permite abrir una nueva ventana basada en la ventana actual')
        (mdiCascade 'Organiza las ventanas en cascada.')
        (mdiTileHoriz 'Organiza las ventanas una debajo de otra.')
        (mdiTile 'Organiza las ventanas una al lado de otra.')
        (mdiArrange 'Alinea las ventanas iconizadas.')
        (mdiUpdate 'Actualiza la ventana activa.')
        (mdiCloseAll 'Cierra todas las ventanas no iconizadas.')
        (toggleMDI 'Des/Activa modo multiple documento.')
        ('MDIMenu' 'Activa la ventana con este ttulo.')
        ('MDISysMenu' 'Mueve, retamaa o cierra una ventana.')

        ('Ayudas' 'Comandos de ayudas y registracin.')
        (helpContents 'Muestra el ndice de las ayudas.')
        (searchHelpOn 'Permite buscar ayuda por un tema en particular.')
        (helpPick 'Permite elegir la ayuda correspondiente a un elemento en pantalla')
        (displayHelpForHelp 'Ensea como usar las ayudas.')
        (openTutorial 'Ensea a usar el sistema.')
        (tipOfTheDay 'Muestra la ventana con el truco del da.')
        (printOrderForm 'Imprime formulario de Orden de Compra.')
        (printRegisterForm 'Imprime formulario de registracin.')
        (technicalSupport 'Muestra informacin referente al soporte tcnico y de consultas.')
        (helpAbout 'Muestra informacin sobre versin y Copyright.')
        (displayHelpIndex helpContents)
        (helpTips tipOfTheDay)
        (helpTutorial openTutorial)
        (helpSearch searchHelpOn)
        (helpOnHelp displayHelpForHelp)
        (helpOrderForm printOrderForm)
        (helpRegistration printRegisterForm)
        (helpTechnical technicalSupport)
        (about helpAbout)
    )
    do: [:each|
        dict
            at: each first asString
            put: (each last isSymbol
                ifTrue: [ dict at: each last asString ]
                ifFalse: [ each last asString ])
    ].! 
initializeStandardHelp
    "Private - Initialize the standard Help contents."
    | dict |
    dict := Smalltalk at: #HelpStatusPane ifAbsent: [^nil].
    #(
        ('Window' 'Comandos para reordenar o seleccionar ventanas.')
        ('Help' 'Comandos de ayuda.')
        ('File' 'Comandos de manejo de archivos.')
        ('Edit' 'Comandos de edicin.')
        ('Smalltalk' 'Comandos de desarrollo.')
        ('about' 'Muestra informacin sobre versin y Copywrite.')
        ('accept' 'Guarda el texto modificado en el panel de texto activo.')
        ('again' 'Repite el ltimo comando de bsqueda.')
        ('clearSelection' 'Borra la seleccin.')
        ('copySelection' 'Copia la seleccin al portafolio del sistema.')
        ('cutSelection' 'Corta la seleccin y la coloca en el portafolio del sistema.')
        ('displayHelpForHelp' 'Ensea como usar las ayudas.')
        ('displayHelpIndex' 'Muestra el indice de la ayuda.')
        ('findReplace' 'Busca texto y permite cambiarlo.')
        ('mdiArrange' 'Alinea las ventanas iconizadas.')
        ('mdiCascade' 'Organiza las ventanas en cascada.')
        ('mdiCloseAll' 'Cierra todas las ventanas abiertas.')
        ('mdiNewWindow' 'Abre una nueva ventana')
        ('mdiTile' 'Organiza las ventanas una al lado de otra.')
        ('openFile' 'Abre un archivo existente')
        ('openWorkspace' 'Abre otra rea de trabajo.')
        ('pasteSelection' 'Coloca el contenido del portafolio reemplazando el texto selecto.')
        ('print' 'Imprime el texto activo o la pantalla.')
        ('printSelection' 'Imprime el texto selecto.')
        ('Partial File' 'Permite leer el archivo entero.')
        ('readEntireFile' 'Lee el archivo entero. Ahora...')
        ('restore' 'Recupera el contenido del texto activo.')
        ('saveAs' 'Guarda el contenido del texto actual con otro nombre.')
        ('searchHelpOn' 'Obtiene ayudas segn palabras claves.')
        ('selectAll' 'Selecciona todo el texto de un panel.')
        ('setFonts' 'Configura los fuentes de las listas, el texto y botones.')
        ('setPrinterFonts' 'Configura las fuentes de impresora.')
        ('ScClose' 'Cerrar la ventana.')
        ('ScMaximize' 'Maximizar la ventana.')
        ('ScMinimize' 'Minimizar la ventana.')
        ('ScMove' 'Mover la ventana.')
        ('ScNextwindow' 'Ir a la prxima ventana.')
        ('ScRestore' 'Restaurar ventana.')
        ('ScSize' 'Retanaar ventana')
        ('ScTasklist' 'Mostrar la lista de tareas.')
        ('SysMenu' 'Mueva, retamaa o cierra la ventana.')
        ('MDIMenu' 'Activa la ventana con este ttulo.')
        ('MDISysMenu' 'Mueve, retamaa o cierra una ventana.')
        ('undo' 'Deshace el ltimo paso.')
        ('zoom' 'Zoom de texto activo.')
    ) do: [:each| dict at: each first asString put: each last asString]! !

! CDGuiaModel methods !   
activate: aViewManager
    "Sets the active viewManager in use"

    | view |

    viewInUse == aViewManager ifTrue: [^self].

    aViewManager notNil ifTrue: [
        (aViewManager isKindOf: MapViewManager)
        ifFalse: [  "don't activate other view managers..."
            ^nil
        ]
    ].

    viewInUse := aViewManager.
    self updateToolsAndMenues.

    (aViewManager isNil or: [aViewManager respondsTo: #stamp])
    ifTrue: [
        view := self stampViewFor: aViewManager.
        view notNil
        ifTrue: [ view owner viewManager: aViewManager ].
    ].

    (aViewManager isNil or: [aViewManager respondsTo: #mapView])
    ifTrue: [
        view := self layersViewFor: aViewManager.
        view notNil
        ifTrue: [ view owner viewManager: aViewManager ].
        view := self searchViewFor: aViewManager.
        view notNil
        ifTrue: [ view owner viewManager: aViewManager ].
    ].

    (aViewManager isNil or: [aViewManager respondsTo: #references])
    ifTrue: [
        view := self referencesViewFor: aViewManager.
        view notNil
        ifTrue: [ view owner viewManager: aViewManager ].
    ].!
activateLayersFor: aMapViewManager
    "Activates the current layers view in use or open
     a new view on aMapViewManager..."

    | mapView view viewClass |
    viewClass := ActiveLayersViewManager.
    mapView := aMapViewManager mapView.
    mapView isNil ifTrue: [^nil].
    view := self layersViewFor: aMapViewManager.
    view isNil
    ifTrue: [ ^self openView: viewClass with: mapView ].

    view minimized
    ifTrue: [ view showRestoredWindow ]
    ifFalse: [ view setFocus ].!   
activateReferencesFor: aMapViewManager
    "Activates the current references view in use or open
     a new view on aMapViewManager..."

    | references referencesView viewClass |
    viewClass := ReferencesViewManager.
    references := aMapViewManager references.
    references isNil ifTrue: [^nil].
    referencesView := self referencesViewFor: aMapViewManager.
    referencesView isNil
    ifTrue: [ ^self openView: (viewClass new viewManager: aMapViewManager;yourself) ].

    referencesView minimized
    ifTrue: [ referencesView showRestoredWindow ]
    ifFalse: [ referencesView setFocus ].!   
activateSearchFor: aMapViewManager
    "Activates the current layers view in use or open
     a new view on aMapViewManager..."

    | mapView view viewClass |
    viewClass := ObjectsInSelectionView.
    mapView := aMapViewManager mapView.
    mapView isNil ifTrue: [^nil].
    view := self searchViewFor: aMapViewManager.
    view isNil
    ifTrue: [ ^self openView: viewClass with: mapView ].

    view minimized
    ifTrue: [ view showRestoredWindow ]
    ifFalse: [ view setFocus ].!
activateStampFor: aMapViewManager
    "Activates the current stamp view in use or open
     a new view on aMapViewManager..."

    | stamp stampView viewClass |
    viewClass := StampViewManager.
    stamp := aMapViewManager stamp.
    stamp isNil ifTrue: [^nil].
    stampView := self stampViewFor: aMapViewManager.
    stampView isNil
    ifTrue: [ ^self openView: (viewClass new viewManager: aMapViewManager;yourself) ].

    stampView minimized
    ifTrue: [ stampView showRestoredWindow ]
    ifFalse: [ stampView setFocus ].! 
canBuildMaps
    "Returns the instance var of the receiver
     for external manipulation"
    ^canBuildMaps!  
canBuildMaps: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    canBuildMaps := anObject! 
changed: what with: whom with: where
    "Implemented for map change-update protocoll"

    | view |
    what = #map:property:
    ifTrue: [
        "update related views..."
        where = #boundingBox ifTrue: [].
        where = #layers ifTrue: [ view := self layersViewFor: nil ].
        where = #references ifTrue: [view := self referencesViewFor: nil ].
        where = #stamp ifTrue: [ view := self stampViewFor: nil ].
        view notNil ifTrue: [ view owner fullUpdate ].
        ^self
    ].

    ^super changed: what with: whom with: where!  
cloneWindow
    "The user wants to create a new view
     based on the current view in use..."

    | clone current clones edits |
    current := self viewInUse.
    (current isKindOf: MapViewManager)
    ifFalse: [ ^self fileNew ].

    clones := Smalltalk isRunTime
        ifTrue: [ Array with: current class new ]
        ifFalse: [
            edits := self fileEditClasses.
            edits size = 0 ifTrue: [^self].
            edits collect: [:each| each new ]
        ].

    clones do: [:clone|
        (clone respondsTo: #cloneFrom:)
        ifTrue: [ clone cloneFrom: self viewInUse ].
        self openView: clone.
        (clone respondsTo: #copyAttributesFrom:)
        ifTrue: [ clone copyAttributesFrom: current ].
    ].!   
closeAll
    "Close all documents."

    StartUpApplication cleanDesktop.! 
currentViewsOn: aMap
    "Returns the current viewmanagers in use showing states of aMap..."

    ^Notifier windows values asArray
        select: [:one|
            one isApplicationWindow
            and: [ (one owner respondsTo: #mapView)
            and: [ one owner mapView map = aMap ]]
        ]!   
customizeToolBar
    "Lets the user customize the toolbar"

    | toolBar |
    (toolBar := self toolBar) notNil
    ifTrue: [ self editToolBar: self toolBar toolPane ].!   
defaultGridSize
    "Returns the default grid size"
    ^self
        atKey: #defaultGridSize
        ifAbsent: [
            self atKey: #defaultGridSize
                put: 50@50
        ]!   
displayHelpForHelp
    "Display Help on Help"

    self mainView helpManager displayHelpForHelp!   
displayHelpIndex
    "Display Help Index"

    ^self helpContents! 
editCapture
    "Capture state in the current window."

    self sendToView: #editCapture.!
editCopy
    "Copy the selection in the current window."

    self sendToView: #editCopy.! 
editSearch
    "Open the search window"

    self sendToView: #editSearch! 
editToolBar: aToolBar
    "Lets the user edit the toolbar..."

    | profiler index stream string inUse current selector |

    "
    (aToolBar currentIndex) notNil
    ifTrue: [ ^aToolBar rbEventFor: index ].
    "

    CustomizeToolbarDialog
        openOn: aToolBar
        with: self tools
        comments: (Smalltalk at: #HelpStatusPane ifAbsent: [Dictionary new]).

    "save toolbar configuration"
    inUse := aToolBar contents collect: [:each| each selector ].
    stream := ReadStream on: self tools.
    index := 1.
    profiler := self toolBar profiler.
    [stream atEnd] whileFalse: [
            string := String new.
            [stream atEnd or: [(current := stream next) isNumber]] whileFalse: [
                (inUse includes: current) ifTrue: [ string := string ,' ', current ].
            ].
            profiler at: 'Tools', index asString put: string trimBlanks.
            index := index + 1
    ].

    self updateToolsAndMenues.!  
fileEdit
    "Open a new editor..."
    | aViewMap edits |

    aViewMap := self mapFromUser.
    aViewMap isNil ifTrue: [^nil].

    edits := self fileEditClasses.
    edits size = 0 ifTrue: [^self].
    edits do: [:each|
        self openView: each with: aViewMap
    ]!   
fileEditClasses
    "Private - Lets the user select editor classes..."

    | selections titles editors index |

    editors := MapViewManager withAllSubclasses.
    editors
        add: LumiBusView;
        yourself.
    titles := editors collect: [:each| each mainViewTitle copy ].
    1 to: titles size do: [:i|
        ((titles at: i) isNil or: [ (titles at: i) trimBlanks size = 0])
        ifTrue: [ titles at: i put: (editors at: i) printString ].
    ].
    selections := MultiSelectListDialog new
        title: 'Seleccione las herramientas a usar sobre el mapa...';
        openOn: titles.

    (selections isNil or: [ selections isEmpty ]) ifTrue: [^nil].

    ^selections collect: [:each|
        index := titles indexOf: each.
        index = 0 ifTrue: [ each ] ifFalse: [ editors at: index ]
        ]!   
fileExit
    "Close the receiver"

    self mainView event: #close!
fileNew
    "Open a new view..."

    | aMapView |
    aMapView := self mapFromUser.
    aMapView notNil
    ifTrue: [
        self closeAll.
        self
            openView: MapViewManager
            with: aMapView
    ]!  
fileOpen
    "Open a new map"

    self fileOpen: nil! 
fileOpen: guess
    "Open a new map named guess..."

    | aMapView |
    aMapView := self mapViewNamed: guess.
    aMapView notNil
    ifTrue: [
        self
           openView: MapViewManager
           with: aMapView.
    ].!   
filePrint
    "Send the file/Print message to the current view."

    self sendToView: #filePrint.!
filePrintPreview
    "Send the file/Print.Preview message to the current view."

    self sendToView: #filePrintPreview.!  
fileRead
    "Send the fileRead to the current view."

    self sendToView: #fileRead.!
fileRun
    "Lets the user run a program"

    RunProgramDialog new open.! 
fileSearch
    "Open the search-Object window"

    self sendToView: #fileSearch!  
fullScreenRectangle
    "Private - Returns the frame rectangle for a full screen top-window"
    | rect |
    rect := Display boundingBox.
    rect := rect expandBy: (UserLibrary getSystemMetrics: SmCxframe).
    rect := (rect leftTop up: (UserLibrary getSystemMetrics: SmCycaption))
        rightBottom: rect rightBottom.
    ^rect!  
gridSetup
    "Configure the grid in the current window."

    self sendToView: #gridSetup!
helpAbout
    "Display Help About dialog"

    self mainView helpManager about!
helpContents
    "Display Help Index"

    self mainView helpManager displayHelpIndex! 
helpOnHelp
    "Display Help on Help"

    self mainView helpManager displayHelpForHelp!   
helpOrderForm
    "Display Order Form"

    self printOrderForm.!  
helpPick
    "Display Help in Pick mode"

    self mainView helpManager helpPick!  
helpRegistration
    "Display Registration Form"

    self printRegisterForm.! 
helpSearch
    "Display Help in Search mode"

    self mainView helpManager searchHelpOn!  
helpTechnical
    "Display Technical Support Information"

    self technicalSupport.! 
helpTips
    "Display tipOfTheDay"

    self mainView helpManager tipOfTheDay! 
helpTutorial
    "Open the Tutorial"

    self openTutorial!   
initialize
    "Private - Initializes the receiver..."

    super initialize.
    Smalltalk isRunTime ifFalse: [ self class initializeHelp ].
    canBuildMaps := false.!
isInMDI
    "Private - True if the receiver is in MDI mode"

    ^self toolBar isKindOf: MDIViewManager!   
layersViewFor: aMapViewManager
    "Returns the current stamp viewmanager in use for aMapViewManager or nil if absent..."

    ^Notifier windows values
        detect: [:one| one isApplicationWindow and: [ one owner class = ActiveLayersViewManager ] ]
        ifNone: [ nil ]! 
mainView
    "Private - Returns the currently mainView in use"

    ^self toolBar mainView!
mapFromUser
    "Private - Prompt the user for a map. and returns
    aMapView (or return nil if cancelled)..."

    ^self mapViewNamed: nil! 
mapViewNamed: guess
    "Private - Returns aMapView named guess.
    If guess is not found or nil; prompt the user for a map.
    Return nil if cancelled..."
    | dialog file mapView profiler mapName maps |

    profiler := self profiler applicationName: 'Maps'.
    maps := profiler keys.
    (maps includes: guess)
    ifTrue: [ file := profiler at: guess ]
    ifFalse: [
        mapName := ListDialog new
          title: 'Seleccione un mapa...';
          openOn: profiler keys asArray.
       mapName isNil ifFalse: [ file := profiler at: mapName ]
    ].

    file size = 0
    ifTrue: [ "Prompt for map from file"
        dialog := FileDialog new.
        dialog
            title: 'Leer mapa desde...';
            addFilter: '*.mpv' description: 'Visiones de mapas (*.MPV)';
            addFilter: '*.ini' description: 'Archivos de inicializacin standard (*.INI)';
            addFilter: '*.*' description: 'Todos los archivos (*.*)';
            addFilter: '*.st' description: 'Cdigo Smalltalk (*.ST)';
            addFilter: '*.map' description: 'Archivos de Mapas (*.MAP)';
            defFilter: '*.map';fileSpec: '*.map';
            hideReadonly;
            open.
        file := dialog file.
    ].

    file size > 0 ifTrue: [
      (file includes: $.) ifFalse: [ file := file,'.Map' ].
      CursorManager execute changeFor: [
        file := file asLowerCase.
        (file reversed copyFrom: 1 to: 3) = 'ini'
        ifTrue: [ mapView := MapView new name: file ]
        ifFalse: [
            (file reversed copyFrom: 1 to: 3) reversed = 'mpv'
            ifTrue: [ mapView := ObjectFiler loadFromPathName: file ]
            ifFalse: [
                (file reversed copyFrom: 1 to: 3) reversed = 'map'
                ifTrue: [
                    mapView := MapView new.
                    mapView map: (Map fromFile: file)
                ]
                ifFalse: [
                    Compiler isNil
                    ifTrue: [
                        ^self error: 'El compilador Smalltalk no est disponible,'
                                ,'\por lo que no se podrn usar archivos de cdigo....' withCrs
                                ,'\Elija otro mapa o llame a su proveedor.\' withCrs
                                ,'No se puede cargar template: ',file
                    ].
                    file := File pathName: file.
                    mapView := Compiler evaluate: file contents.
                    file close.
                ]
            ]
        ]
      ].
    ].

    (mapView isNil or: [ mapView map isNil ]) ifTrue: [ ^nil ].
    (mapName notNil and: [mapView map name ~= mapName])
    ifTrue: [ mapView map name: mapName ].

    ^mapView!  
mdiCloseAll
    "Close all MDI documents which are not minimized."

    ^self closeAll!
mdiNewWindow
    "The user wants to create a new view
     based on the current view in use..."

    ^self cloneWindow!   
message: aString
    "Private - Show the message aString in the current statusBox"

    | statusBox |
    (statusBox := self statusBox) isNil ifTrue: [^nil].
    statusBox contents: aString!   
objectHolder
    "Returns a view for holding objects"

    | holders |
    Notifier windows values asArray
        reverseDo: [:one|
            (one isApplicationWindow and: [ one owner class = self objectHolderClass ])
            ifTrue: [^one owner].
    ].
    ^self viewObjects! 
objectHolderClass
    " Private - Returns the class for holding objects"

    ^ObjectHolderView!   
openTutorial
    "Open the tutorial"

    MessageBox warning: 'Curso tutorial no encontrado...'.!  
openView: aView
    "Private - Open a View.
    aView can be aViewManager or a ViewManager subclass.
    The view will be opened as an MDI Child if MDI is in use"

    ^self openView: aView with: nil! 
openView: aView with: aMapView
    "Private - Open a View.
    aView can be aViewManager or a ViewManager subclass.
    The view will be opened as an MDI Child if MDI is in use"

    | instance |
    instance := aView isClass
        ifTrue: [ aView new ]
        ifFalse: [ aView ].

    CursorManager execute changeFor: [
        aMapView notNil
        ifTrue: [ instance mapView: aMapView ].
        self isInMDI
        ifTrue: [ instance openWithMDIParent: self toolBar ]
        ifFalse: [ instance open ].
    ].

    ^instance!
openView: aViewClassName withState: aState
    "Open a new view with a state aState of class aViewClassName"

    | viewClass aViewManager |
    viewClass := Smalltalk
        at: aViewClassName asSymbol
        ifAbsent: [
            self warning: 'Clase no encontrada :',aViewClassName.
            ^nil
        ].

    aViewManager := self openView: viewClass.
    (aViewManager respondsTo: #state:)
    ifTrue: [ aViewManager state: aState ]
    ifFalse: [
        (aViewManager respondsTo: #position:)
        ifTrue: [ aViewManager position: aState position ].
    ]..! 
printer
    "Returns the system printer..."

    ^self system printer! 
printerSetup
    "Open the printer setUp dialog..."

    self printer setup!   
printOrderForm
    "Prints an Order Form"

    self openView: OrderFormView!   
printRegisterForm
    "Prints a Registration Form"

    self openView: RegistrationView!   
rbSelectorsFor: aCollection
    "Private - Returns aDictionary for rbSelectors in aCollection"
    | rbMap result |
    rbMap := #(
        "(toolSelector rbSelector)"
        (filePrint printerSetup)
        (toggleGrid gridSetup)
        (toggleRuler rulerSetup)
        (filePageSetup filePageSetup)
        (viewHeader filePageSetup)
        (viewFooter filePageSetup)
        (customizeToolBar customizeToolBar)
    ).
    result := Dictionary new.
    rbMap do: [:pair|
        (aCollection includes: pair first)
        ifTrue: [ result at: pair first put: pair last ]
    ].
    ^result! 
referencesViewFor: aMapViewManager
    "Returns the current stamp viewmanager in use for aMapViewManager or nil if absent..."

    ^Notifier windows values
        detect: [:one| one isApplicationWindow and: [ one owner class = ReferencesViewManager ] ]
        ifNone: [ nil ]!   
searchHelpOn
    "Open the search on help dialog..."

    self mainView helpManager searchHelpOn!  
searchViewFor: aMapViewManager
    "Returns the current search objects viewmanager in use for aMapViewManager or nil if absent..."

    ^Notifier windows values
        detect: [:one| one isApplicationWindow and: [ one owner class = ObjectsInSelectionView ] ]
        ifNone: [ nil ]! 
sendToView: aSymbol
    " Private - Send aSymbol message to the current window (if any).
    Returns the result of sending the message or nil"
    | view result |
    view := self viewInUse.
    view isNil ifTrue: [^nil].
    aSymbol isMessage
    ifTrue: [
        result := aSymbol
            receiver: view;
            perform.
        self updateToolsAndMenues.
        ^result
    ].
    (view respondsTo: aSymbol)
    ifFalse: [
        Smalltalk isRunTime not
        ifTrue: [
            UserLibrary messageBeep: 0.
            MessageBox warning: 'View must implement the method for #',aSymbol,'\\Not implemented yet...' withCrs
        ].
        ^nil
    ].
    result := view perform: aSymbol.
    self updateToolsAndMenues.
    ^result! 
show: type message: aString
    "Private - Show the message aString in the current statusBox with
     color determined by message type.
        Red for #error
        Yellow for #warning
        Blue for messages
        Black for others
    "

    | statusBox statusPane oldColor |
    (statusBox := self statusBox) isNil ifTrue: [^nil].
    (statusPane := statusBox statusPane) isNil ifTrue: [^nil].
    oldColor := statusPane foreColor.
    statusPane foreColor:
        (type = #error
        ifTrue: [ClrRed]
        ifFalse: [
            type = #warning
            ifTrue: [ ClrYellow ]
            ifFalse: [
                type = #message
                ifTrue: [ ClrBlue ]
                ifFalse: [ ClrBlack ]
            ]
        ]).
    statusBox contents: aString.
    statusPane foreColor: oldColor.!
speaker
    "Returns an object that can do text to speach..."

    ^self system moduleFor: 'Stickers module'!  
stampViewFor: aMapViewManager
    "Returns the current stamp viewmanager in use for aMapViewManager or nil if absent..."

    ^Notifier windows values
        detect: [:one| one isApplicationWindow and: [ one owner class = StampViewManager ] ]
        ifNone: [ nil ]! 
statusBox
    "Private - Returns the current Status Box pane in use"

    | toolBar |
    (toolBar := self toolBar) isNil ifTrue: [^nil].
    ^toolBar statusBox!
technicalSupport
    "Display the technicalSupport dialog"

    self openView: TechnicalSheetView! 
testInterfase: map
    "Private - Update interfase acording to currently active mdiView"

    | stream menu isValid inUse toolPane  |

    " *WARNING*
        ToolPane does not support activate/deactivate of tools...
        This method is delegated to toolbar in MDI... "

    self isInMDI
        ifTrue: [ ^self toolBar testInterfase: map ]
        ifFalse: [ ^nil ]. "don't  validate if not in MDI..."

    toolPane := self toolPane.

    inUse := self viewInUse.
    isValid := [:selector|
        inUse notNil and: [
            (self respondsTo: selector)
            and: [ inUse owner canDo: selector ]]
    ].

    stream := ReadStream on: map.
    [stream atEnd] whileFalse: [
        menu := stream next.
        stream next
        do: [:item|
            (isValid value: item)
            ifTrue: [ toolPane enableItem: item ]
            ifFalse: [ toolPane disableItem: item ]
        ]
    ]!  
toggleFullScreen
    "Toggle to full screen mode"
    | fullScreen frameRect topPane |
    fullScreen := self atKey: #fullScreen ifAbsent: [false].
    topPane := self isInMDI
        ifTrue: [ self mainView ]
        ifFalse: [
            self viewInUse isNil ifTrue: [Terminal bell. ^self].
            self viewInUse mainView
        ].
    fullScreen = true
    ifTrue: [
        frameRect := self atKey: #oldFrame ifAbsent: [Terminal bell. ^self]
    ]
    ifFalse: [
        frameRect := self fullScreenRectangle.
        self atKey: #oldFrame put: topPane frameRectangle
    ].


    topPane handle
        setWindowPos: nil
        rectangle: frameRect
        fs: SwpNozorder.

    self atKey: #fullScreen put: fullScreen not.!
toggleGrid
    "Toggle the grid in the current window."

    self sendToView: #toggleGrid.!
toggleMDI
    "Toggle the MDI mode"

    | toolBar mdi |

    "disable fullScreen mode flag..."
    self atKey: #fullScreen put: nil.

    toolBar := self toolBar.

    (mdi := self isInMDI)
    ifTrue: [ self system openNonMDIView ]
    ifFalse: [
        self closeAll.
        self system openMDIView
    ].

    toolBar
        whenClose: [];
        close.

    self system profiler
        at: #MDI
        put: mdi not asString.

    self updateToolsAndMenues.! 
toggleRuler
    "Toggle the ruler in the current window."

    self sendToView: #toggleRuler.! 
toggleStickers
    "Toggle the stickes in the current window."

    self system withModule: 'Stickers module' do: [:module| module toggle ]!   
toolBar
    "Private - Returns the current toolBar in use"

    ^self atKey: #toolBar ifAbsent: [^nil]!
toolCleanUp
    "Try to free unused memory..."

    Tile clearCache.
    FileHandle cleanHandles.
    self message: 'Memoria libre : ',Smalltalk unusedMemory asString.! 
toolComputer
    "Lets the user setUp the application ini entries..."

    IniSettingsDialog new openOn: self profiler.!   
toolPane
    "Private - Returns the current toolBar pane in use"

    | toolBar |
    (toolBar := self toolBar) isNil ifTrue: [^nil].
    ^toolBar toolPane! 
tools
    "Private - Returns all the receiver's tools for toolbar"

    ^#(
        fileNew fileOpen fileRead "filePageSetup"
        5 filePrint filePrintPreview printerSetup
        5 editCopy editSearch editCapture
        5 toggleGrid toggleRuler toggleFullScreen
            "viewHeader viewFooter" fileSearch
            viewStamp viewLayers viewReferences
            viewObjects viewZoomIn viewZoomOut
        5 customizeToolBar toolComputer
        5 toggleStickers toolSound gridSetup rulerSetup toolCleanUp
        ),
    (self isInMDI
        ifTrue: [ #(5 mdiNewWindow mdiCascade mdiTileHoriz mdiTile mdiCloseAll toggleMDI) ]
        ifFalse: [ #(5 mdiNewWindow mdiCloseAll toggleMDI) ]) "<-- also supported in non MDI mode..."
    ,#(
        5 fileRun fileExit
        5 helpContents helpPick helpAbout
            helpSearch helpOnHelp helpTutorial helpTips
            helpOrderForm helpRegistration helpTechnical
        ),
    (self canBuildMaps
        ifTrue: [ #(7 fileEdit) ] "<-- Development..."
        ifFalse: [ #() ])!   
toolSound
    "Toggle the speech mode..."

    self system withModule: 'Stickers module' do: [:module| module toggleSpeech ]!  
updateToolsAndMenues
    "Private - Update tools and menues acording to currently selected view"

    self testInterfase: #(
        'Archivo' ( filePrintPreview filePrint filePageSetup)
        'Editar' (editCopy editCapture editSearch)
        'Ver' (
            toggleGrid toggleRuler
            viewZoomIn viewZoomOut
            viewStamp viewLayers viewReferences
            )
        'Configurar' (
            gridSetup rulerSetup
            filePageSetup
            )
        ).!  
updateView
    " Private - Send updateView message to the current window (if any)."
    | view |
    view := self viewInUse.
    (view respondsTo: #updateView) ifFalse: [^nil].
    ^view updateView!   
viewInUse
    "Returns the currently open view in use"

    viewInUse isNil ifTrue: [^nil].
    (viewInUse views isEmpty or: [ viewInUse mainView isHandleOk not ])
    ifTrue: [ self activate: nil ].
    ^viewInUse! 
viewLayers
    "Activates or open the layers view."

    self sendToView: #viewLayers.!
viewObjects
    "Activates or open an objects view."

    | view |
    view := self openView: self objectHolderClass.
    view isNil ifFalse: [
        view editSelector: #activate
    ].
    ^view!
viewReferences
    "Activates or open the references view."

    self sendToView: #viewReferences.!
viewStamp
    "Activates or open the stamp view."

    self sendToView: #viewStamp.!   
viewZoomIn
    "ZoomIn the view in the current window."

    self sendToView: #viewZoomIn.!
viewZoomOut
    "ZoomOut the view in the current window."

    self sendToView: #viewZoomOut.! !

! ApplicationModule methods !  
applicationEnds: anApplicationSystem
    "Protocoll for ending the receiver...
    This method can be refined by subclasses..."!
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver...
    This method can be refined by subclasses..."!  
open
    "Protocoll for open the receiver's view...
    This method can be refined by subclasses..."! !

! AboutAppModule methods !   
open
    "Open the About App dialog box"

    (Smalltalk
        at: #AboutApp
        ifAbsent: [^self warning: 'About dialog no configurado.']) new open.! !

! AppCursorModule methods !
applicationEnds: anApplicationSystem
    "Protocoll for ending the receiver..."

    super applicationEnds: anApplicationSystem.

    "Resture system cursors..."
    CursorManager normal change.
    CursorMovie restoreCursorConstants.
    CursorManager execute change.! 
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    super applicationStarts: anApplicationSystem.

    "Change the execute cursor to a better shaped cursor movie"
    CursorMovie replaceExecuteCursor.
    CursorManager execute change.! !

! InstalationModule class methods !
profiler
    "Private - Returns a profiler for the receiver"

    ^super profiler
        applicationName: 'Instalation';
        yourself! !

! InstalationModule methods !   
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    super applicationStarts: anApplicationSystem.

    (self isInstalled: anApplicationSystem)
    ifFalse: [
        self install: anApplicationSystem
    ]! 
canLoadModule: aModuleName ifAbsent: aOneParameterBlock
    " Private - Test for module aModuleName(.dll).
    If it can't be loaded dynamically, evaluates aOneParameterBlock...
    If loading failed, evaluates aOneParameterBlock with a text for the
     error (or nil if error is unknown).
    "

    | answer |
    answer := KernelLibrary loadLibrary: aModuleName asParameter.
    answer < self minimumModuleHandle
    ifTrue: [  ^aOneParameterBlock value: (self errorNumber: answer) ]. "loading has failed..."
    KernelLibrary freeLibrary: answer asParameter.
    ^true!
errorNumber: aCodeNumber
    " Private - Returns a string that holds the description of error number aCodeNumber (or nil)"

    | dict |
    dict := Dictionary new.
    dict
        at: 0   put: 'El sistema se qued sin memoria, el archivo estaba deteriorado,\ o su tabla de rehubicacin de cdigo es invlida.';
        at: 2   put: 'No se encontr el archivo.';
        at: 3   put: 'No se encontr el directorio.';
        at: 5    put: 'Se trat de linkear dinmicamente a un programa,\ o hubo un error en el sistema de proteccin de red.';
        at: 6    put: 'La librera requiere segmentos de datos separados para cada programa.';
        at: 8    put: 'No hay suficiente memoria para cargar el mdulo.';
        at: 10  put: 'La versin de Windows no es correcta.';
        at: 11  put: 'El archivo ejecutable es invlido.\ Quizs no sea un programa windows o el archivo est deteriorado.';
        at: 12  put: 'El mdulo fue diseado para otro sistema operativo.';
        at: 13  put: 'El mdulo fue diseado para MS-DOS 4.0.';
        at: 14  put: 'El formato del ejecutable es desconocido.';
        at: 15  put: 'Se trat de cargar un mdulo construido para modo "real" (Versin natigua de Windows).';
        at: 16  put: 'Se trat de cargar un mdulo conteniendo mltiples segmentos de datos,\ que no estaban marcados como de "solo lectura".';
        at: 19  put: 'Se trat de cargar un mdulo comprimido.\ El archivo debe estar descomprimido para poder ser usado.\ Ud. podra usar el programa "Expand" de windows para descomprimirlo.';
        at: 20  put: 'El archivo de linking dinmico (DLL) es invlido.\Uno de los componentes requeridos para cargar este mdulo no pudo ser localizado.';
        at: 21  put: 'Este mdulo requiere Microsoft Windows 32-bit.';
        yourself.
    ^(dict at: aCodeNumber ifAbsent: [^nil]) withCrs! 
findExecutableFor: pathName ifAbsent: aOneParameterBlock
    " Private - Find the executable module for opening a document;
    if successfull, returns the module file name, if failed evaluates
     aOneParameterBlock with text indicating error code"

    | answer buffer |
    buffer := String new: 256.
    answer := ShellDLL library
        findExecutable: pathName asParameter
        inDir: Disk pathName asParameter
        onto: buffer.
    answer > self minimumModuleHandle ifTrue: [ ^buffer trimBlanks ].
    ^aOneParameterBlock value: (
        self minimumModuleHandle - 1 = answer
        ifTrue: [ 'Los archivos con esta extensin no estn asociados.\Ud podra usar el administrador de archivos para asociarlo.' ]
        ifFalse: [ self errorNumber: answer ])! 
install: anApplicationSystem
    " Private - Must perform product instalation...
    This method must be refined by subclasses...
    WARNING:  Default action is to test modules in profiler
    & singal application as installed..."

    self testModules.
    self profiler at: 'Installed' put: 'true'!  
isInstalled: anApplicationSystem
    " Private - Returns true if anApplicationSystem must be (re-)installed. "

    ^(self profiler at: 'Installed') = 'true'! 
minimumModuleHandle
    " Private - Returns the minimum value for a valid module handle... "
    ^32!   
test: moduleName
    for: aDynamicLinkLibraryClass
    ifAbsent: anInstalationBlock

    " Test for the precence of executable file of module to satisfy
     loading of aDynamicLinkLibraryClass.
    If not found, Notify the user about the error ocurred and
     if the user wants to install the component evaluates anInstalationBlock.
    "
    | fileName |

    fileName := aDynamicLinkLibraryClass isString
        ifTrue: [ aDynamicLinkLibraryClass ]
        ifFalse: [ aDynamicLinkLibraryClass fileName ].

    fileName isNil ifTrue: [ ^false ].
    ^self
        canLoadModule: fileName
        ifAbsent: [:text|
            Terminal bell.
            (MessageBox confirm: 'Error en la deteccin del mdulo ',moduleName,'\Archivo: 'withCrs,fileName
                ,'\'withCrs,text,'\\Este mdulo es necesario para que la aplicacin funcione correctamente.'withCrs
                ,'\\ Desea realizar la instalacin del componente ahora ?'withCrs)
            ifTrue: [ anInstalationBlock value ]
            ifFalse: [
                (MessageBox message: 'Desea abortar la aplicacin ahora ?')
                ifTrue: [ Smalltalk isRunTime ifTrue: [Smalltalk exit] ifFalse: [ self error: 'Aplicacin abortada' ] ]
            ].
            false
        ]! 
testModules
    "Test all the modules configured in profiler... "

    | id specification stream profiler clsName |
    profiler := self profiler.
    specification := OrderedCollection new.
    id := 1.
    [ stream := ReadStream on: (profiler at: 'Module ',id asString).
    stream atEnd ] whileFalse: [
        clsName := stream peek = $'
            ifTrue: [ stream next;upTo: $' ]
            ifFalse: [ stream nextWord trimBlanks asSymbol ].
        specification addLast: (Array
                with:  clsName "class name"
                with: stream nextWord trimBlanks asSymbol "selector"
                with: (stream upTo: nil) trimBlanks "description"
            ).
        id := id + 1.
    ].

    ^self testModules: specification asArray!  
testModules: specification
    "Test all the modules acording to an specification array.
    specification must be an array of subarrays containing
        moduleDynalinkClass , instalation selector & module name
    "

    | moduleName dllSupport selector |
    specification do: [:spec|

        moduleName := spec last.
        dllSupport := spec first.
        dllSupport isSymbol
        ifTrue: [ "find class in Smalltalk..."
            dllSupport := Smalltalk at: dllSupport
                ifAbsent: [ ^self error: 'Dynalink not found: ',dllSupport ]
        ].
        selector := spec at: 2.
        (self respondsTo: selector)
        ifFalse: [ ^self error: 'Instalation mdule must understand #',selector ].

        self
            test: moduleName
            for: dllSupport
            ifAbsent: [ self perform: selector ]

    ]! !

! CDGuiaInstalationModule class methods ! 
aboutToSaveImage
    " Private - Clear instalation directory..."

    InstalationDirectory := nil! 
instalationDirectory
    " Returns the current instalation directory..."

    | path |
    InstalationDirectory notNil ifTrue: [ ^InstalationDirectory ].

    InstalationDirectory := Directory pathName: (self profiler at: 'Instalation Drive' ifAbsent: [Disk pathName]).
    [ InstalationDirectory valid ]
    whileFalse: [
        path := OSPrompter
            prompt: 'Defina el directorio donde se encuentra el disco de instalacin'
            default: InstalationDirectory pathName.
        path notNil ifTrue: [ InstalationDirectory := Directory pathName: path trimBlanks].
    ].
    ^InstalationDirectory! !

! CDGuiaInstalationModule methods !  
fullInstall
    " Private - Re-Instalation of all the aplication..."

    self install: application product with: (self pathForInstall: 'Application').
    Smalltalk isRunTime
    ifTrue: [ Smalltalk exit ]
    ifFalse: [ MessageBox message: 'Instalation in progress...' ].!  
install: component with: programName
    " Private - Run instalation program programName when
      the user confirm the placement of instalation device...
    Returns true if programName can be executed..."

    | answer style firstTime |
    style := MbOkcancel | MbIconhand.
    firstTime := true.
    [
        answer := MessageBox
            titled: 'Instalacin de ',component
            withText: 'Coloque el disco de instalacin conteniendo el archivo:\  'withCrs,programName
                ,'\ y contine la instalacin.'withCrs
            style: style.
        answer = Idcancel ifTrue: [ ^false ].
        firstTime
        ifTrue: [ ProgramManager new run: programName ]
        ifFalse: [ RunProgramDialog new openOn: programName. true ]
    ] whileFalse: [
        firstTime := false.
        style := style | MbOkcancel - MbOkcancel | MbRetrycancel
    ].!  
installHalo
    " Private - Instalation of Halo imaging libraries..."

    | module |
    module := 'Mdulo de Procesamiento de imgenes'.
    self
        install: module with: (self pathForInstall: 'Halo');
        waitFor: module.! 
installP3
    " Private - Instalation of Picture++ imaging libraries..."

    | module |
    module := 'Mdulo de impresin e imgenes'.
    self
        install: module with: (self pathForInstall: 'Picture++');
        waitFor: module.!  
installQE
    " Private - Instalation of Q+E libraries..."

    | module |
    module := 'Mdulo de interfz a base de datos relacionales'.
    self
        install: module with: (self pathForInstall: 'Q+E');
        waitFor: module.! 
installVFW
    " Private - Instalation of Video for Windows libraries..."

    | module |
    module := 'Mdulo de Video para Windows'.
    self
        install: module with: (self pathForInstall: 'Video For Windows');
        waitFor: module.!   
pathForInstall: module
    " Private - Returns the path for the instalation program of module"

    ^self class instalationDirectory pathName,'\',
        (self profiler
            at: module,' Instalation'
            ifAbsent: [ 'instalar.exe' ])!  
waitFor: aModule
    " Private - Wait until the module aModule is loaded..."

    [ (CoffeBreak saying: 'Espere a que la instalacin del mdulo ',aModule
        ,'se complete.\Luego presione el botn de continuar...'withCrs) = #continue ] whileFalse: []! !

! RDBMSModule methods !  
applicationEnds: anApplicationSystem
    "Protocoll for ending the receiver..."

    super applicationEnds: anApplicationSystem.
    Relation exit.!  
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    super applicationStarts: anApplicationSystem.
    Relation startUp! !

! TileGarbageCollectModule methods !  
applicationEnds: anApplicationSystem
    "Protocoll for ending the receiver..."

    "Free mark&Sweep timers"
    TimerWindow stopTimer: self.

    super applicationEnds: anApplicationSystem.

    "Free catched image resources..."
    Tile clearCache.! 
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    | selector gcSelectors interval |
    super applicationStarts: anApplicationSystem.

    gcSelectors :=
        #( bitCleaning
            sweetCleaning
            justCleaning
            heavyCleaning).

    "Initialize the Garbage Collect block"
    PictureObject gcBlock: [ :inst :retry |
        (retry between: 1 and: gcSelectors size)
        ifTrue: [ self perform: (gcSelectors at: retry) ].
        retry < gcSelectors size
        ifTrue: [ #retry ] "try again if failed..."
        ifFalse: [ nil ] "can't obtain enought memory..."
    ].

    "Start mark&sweep collector..."
    interval := anApplicationSystem profiler at: 'Garbage Collect Interval' ifAbsent: [].
    interval notNil ifTrue: [
        interval := interval trimBlanks asInteger.
        interval > 0
        ifTrue: [
            TimerWindow
                startTimer: self
                interval: interval * 60 * 1000 "milliseconds"
        ]
    ].! 
bitCleaning
    "Private - Realizes the most light cleaning..."

    Tile purgeCache: 10. "percent"!   
heavyCleaning
    "Private - Realizes a heavy cleanUp task..."

    Tile clearCache. "clear all the tiles cache..."

    Terminal bell.

    "It's a good time for some system cleaning..."
    Bitmap purgeUnusedBitmaps.
    FileHandle cleanHandles.
    Icon purgeUnusedIcons.! 
justCleaning
    "Private - Realizes a an acceptable cleaning..."

    Tile clearCache: 50. "percent"! 
sweetCleaning
    "Private - Realizes a light cleaning..."

    Tile clearCache: 20. "percent"!
tick
    "Private - Process timer ticks events of
     mark&sweep garbage collector"

    Tile sweep.! !

! TileImagesModule methods !  
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    | class |
    super applicationStarts: anApplicationSystem.

    class := anApplicationSystem profiler at: 'ImageClass' ifAbsent: [].
    class notNil ifTrue: [
        class := Smalltalk at: class trimBlanks asSymbol ifAbsent: []
    ].
    Tile imageClass: class.! !

! DDEServerModule methods !  
applicationEnds: anApplicationSystem
    "Protocoll for ending the receiver..."

    super applicationEnds: anApplicationSystem.
    server notNil ifTrue: [
        server terminate.
        server := nil
    ].!   
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    super applicationStarts: anApplicationSystem.
    server := OSEmulator newServer.! 
server
    "Returns current DDE server for Smalltalk emulation services..."
    ^server! !

! LogAppModule methods !  
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    super applicationStarts: anApplicationSystem.
    application := anApplicationSystem.! 
log: aSymbol for: aProcess label: aLabel
    "Private - Log an error in loggin file"
    | log |
    (log := self logFile) isNil ifTrue: [^self].
    log
        cr;
        nextPutAll: Date today printString,' ',Time now printString;
        nextPutAll: ' #',aSymbol,' ',aLabel;
        cr.
    aProcess notNil
    ifTrue: [aProcess walkbackOn: log maxLevels: 10].
    (log respondsTo: #close) ifTrue: [ log close ].! 
logFile
    "Private - Returns the receiver's log file or nil..."

    | logName token |
    token := 'LogFileName'.
    logName := application
        atKey: token
        ifAbsent: [
            (application profiler
                at: token
                ifAbsent: [String new]) trimBlanks
        ].
    (logName isEmpty or: [ logName = 'NONE']) ifTrue: [^nil].
    ^File pathName: logName! !

! ModuleInstaller methods !   
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    | profiler count module toBeRemoved lastModuleID |
    profiler := self profiler.
    toBeRemoved := Set new.
    count := 1.
    lastModuleID := profiler at: 'lastModuleID' ifAbsent: [self defaultLastModuleID].
    [ module := profiler at: 'Module ',count asString ifAbsent: [].
      module notNil and: [count <= lastModuleID]] whileTrue: [
        module := PathFinder locationFor: module.
        module size > 0
        ifTrue: [
            (File exists: module)
            ifFalse: [
                (MessageBox confirm: 'No se encontr el mdulo #',count asString
                    ,'\\Archivo: 'withCrs,module
                    ,'\Desea desconectarlo del sistema?'
                    ,'\\Si luego contina teniendo problemas instale el sistema nuevamente' withCrs)
                ifTrue: [ toBeRemoved add: count ].
            ]
            ifTrue: [
                ClassImport new
                    notifier: (WriteStream on: String new); "install & no notify the user..."
                    loadSpecificationFrom: module;
                    yourself
            ].
        ].
        count := count + 1 ].

    toBeRemoved do: [:each|
        profiler removeKey: 'Module ',each asString
    ]!  
defaultLastModuleID
    "Private - Returns the default lastModuleID"

    ^10! 
installModule
    "Install & Register a new module prompted to the user..."

    | result import |
    import := ClassImport new.

    result := import loadSpecification.
    result isNil ifTrue: [ ^nil ].

    self register: result!
register: pathName
    "Private - Register a new module in file pathName..."

    | id lastModuleID profiler |
    profiler := self profiler.
    lastModuleID := self profiler at: 'lastModuleID' ifAbsent: [self defaultLastModuleID].
    id := ((lastModuleID to: 1 by: -1)
        detect: [:index| (profiler at: 'Module ',index asString ifAbsent: []) notNil ]
        ifNone: [0]) + 1.
    id > lastModuleID
    ifTrue: [ self profiler at: 'lastModuleID' put: lastModuleID + 5 ].

    profiler at: 'Module ',id asString put: pathName! !

! MoreOpenFilesModule methods !
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    | amount |

    super applicationStarts: anApplicationSystem.

    amount := KernelLibrary setHandleCount: maxOpenFiles.

    amount < maxOpenFiles
    ifTrue: [
        self warning:
            'El sistema puede necesitar hasta '
            ,maxOpenFiles asString
            ,' archivos abiertos al mismo tiempo\' withCrs
            ,' y solo se le han podido obtener ',amount asString
            ,'\ por lo que podran existir problemas en el\ funcionamiento del sistema...' withCrs
    ]!   
initialize
    "Private - Initialize the receiver"

    super initialize.
    maxOpenFiles := 30.!
maxOpenFiles
    "Returns the instance var of the receiver
     for external manipulation"
    ^maxOpenFiles!  
maxOpenFiles: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    maxOpenFiles := anObject! !

! OSProtectionModule methods ! 
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    super applicationStarts: anApplicationSystem.
    self test.!  
test
    "Receiver's testing..."

    OSSoftwareProtection test.! !

! StickersModule methods !  
applicationEnds: anApplicationSystem
    "Protocoll for ending the receiver..."

    self stopTimer.
    self releaseVoiceServer.
    super applicationEnds: anApplicationSystem.!   
applicationStarts: anApplicationSystem
    "Protocoll for startingUp the receiver..."

    super applicationStarts: anApplicationSystem.

    application := anApplicationSystem.
    self
        getSettings;
        startTimer.!  
canRun: pathName
    " Private - Try to run program named pathName.
    Returns true if success..."

    | programManager |
    pathName size = 0 ifTrue: [^false].
    programManager := ProgramManager new.
    programManager errorBlock: [:err| "don't care about run erros" ].
    ^programManager run: pathName.!   
closePopUp
    " Private - Close the current stiker window..."

    | old |
    old := popUp.
    popUp := mouseLocation := nil.
    old notNil ifTrue: [ old close ].! 
getMapFrom: pathName
    " Private - Get receiver's map from file pathName (use Object filer)..."

    map := nil.
    pathName isEmpty ifTrue: [ ^nil ].
    map := ObjectFiler loadFromPathName: pathName! 
getSettings
    " Private - Get receiver's settings from profiler..."

    | profiler setting |
    profiler := self profiler.
    setting := profiler at: 'inUse'.
    inUse := setting notNil ifTrue: [setting asLowerCase = 'true' ] ifFalse: [true].
    setting := profiler at: 'useVoice'.
    useVoice := setting notNil ifTrue: [setting asLowerCase = 'true' ] ifFalse: [true].
    setting := profiler at: 'backColor'.
    backColor := setting notNil
        ifTrue: [
            (setting notEmpty and: [ setting first isDigit ])
            ifTrue: [ setting asInteger ]
            ifFalse: [ ColorConstants at: setting trimBlanks ifAbsent: [backColor] ]
        ]
        ifFalse: [backColor].
    setting := profiler at: 'map'.
    setting notNil ifTrue: [ self getMapFrom: setting trimBlanks ].

    useVoice ifTrue: [ self openVoiceServer ].!  
getStickerSending: selector to: receiver with: arguments ifFailed: aBlock
    "Private - Try to use protocoll specified by selector to talk with receiver;
     if supported,  send the message.
    Fails if the receiver does not understand selector or return nil.
    When failed evaluates aBlock and returns its value..."

    | result |
    ^((receiver respondsTo: selector)
      and: [
        result := receiver perform: selector withArguments: arguments.
        " (selector ,'>',result asString) displayAt: 10@10. "
        result notNil ])
      ifTrue: [ result ]
      ifFalse: [ aBlock value ]! 
initialize
    "Private - Initialize the receiver"

    super initialize.
    backColor := "ClrYellow" Pen red: 255 green: 255 blue: 172.
    inUse := true.
    useVoice := true.! 
openPopUp
    " Private - Open the stiker window..."

    popUp := StickerDialog new.
    popUp
        backColor: backColor;
        open.!
openVoiceServer
    " Private -  Try to open a DDE server for voice notification.
     Server configuration must be stored in profiler"

    ^self openVoiceServer: true! 
openVoiceServer: retry
    " Private -  Try to open a DDE server for voice notification.
     Server configuration must be stored in profiler"

    | profiler server topic message |
    profiler := self profiler.
    server := profiler at: 'application' ifAbsent: [^false].
    server trimBlanks isEmpty ifTrue: [^false].
    topic := profiler at: 'topic' ifAbsent: ['talk'].
    voiceItem := profiler at: 'item' ifAbsent: ['talk'].

    self releaseVoiceServer.
    voiceServer := DDEClient
        newClient: nil asParameter
        application: server asParameter
        topic: topic asParameter.

    (voiceServer isNil & retry and: [self canRun: (profiler at: 'serverPath' ifAbsent: [])])
    ifTrue: [ "try to reconect to server in deferred mode..."
        (Message new
            receiver: self
            selector: #openVoiceServer:
            arguments: (Array with: false)) performDeferred.
    ].

    ^voiceServer notNil!   
releaseVoiceServer
    " Private -  Release current voice resource..."

    voiceServer notNil ifTrue: [voiceServer terminate].
    voiceServer := nil.!  
say: text
    " Private - Say text using voice server..."

    useVoice ifFalse: [^self].
    voiceServer isNil ifTrue: [^false].

    ^voiceServer
        pokeItem: voiceItem asParameter
        object: (AddressFinder normalize: text) asParameter!  
startTimer
    " Private - Start the timer..."

    | interval |

    timer notNil ifTrue: [ ^self ]. "has been activated"

    interval := self profiler at: 'timer' ifAbsent: [].
    interval notNil ifTrue: [
        interval := interval trimBlanks asInteger.
        interval > 0
        ifTrue: [
            timer := TimerWindow
                startTimer: self
                interval: interval * 1000 "milliseconds"
        ]
    ].!  
stickerFor: aWindow
    "Private - Infer the sticker for aWindow...
        Try several methods of comunications with owner & window for gettin the sticker
        Supported protocoll
            with           selector                                  arguments
            owner       #stickerForObjectAt:in:      aPoint,aWindow
            owner       #sticker                                none
            window    #stickerForObjectAt:          aPoint
            window    #sticker                                 none
            window    #propertyAt:                         #sticker
            application #stickerForObjectAt:in:   aPoint,aWindow
        Note: aPoint is window relative...
    "
    | owner  aPoint |

    (aWindow notNil and: [aWindow isHandleOk]) ifFalse: [ ^nil ]. "not found or just closed..."
    owner := aWindow owner.
    aPoint := mouseLocation mapToWindow: aWindow.

    ^self
        getStickerSending: #stickerForObjectAt:in: to: owner with: (Array with: aPoint with: aWindow)
        ifFailed: [
            self getStickerSending: #sticker to: owner with: #()
                ifFailed: [
                    self getStickerSending: #stickerForObjectAt: to: aWindow with: (Array with: aPoint)
                    ifFailed: [
                        self getStickerSending: #sticker to: aWindow with: #()
                        ifFailed: [
                            self getStickerSending: #propertyAt: to: aWindow with: #(sticker)
                            ifFailed: [
                                self getStickerSending: #stickerForObjectAt:in: to: application with: (Array with: aPoint with: aWindow)
                                ifFailed: [
                                    self stickerForObjectAt: aPoint in: aWindow
                                ]
                            ]
                        ]
                    ]
                ]
        ]!  
stickerForObjectAt: aPoint in: aWindow
    "Private - Try to Infer the sticker for aWindow using private map..."

    map isNil ifTrue: [ ^nil ].
    ^(map at: aWindow class name ifAbsent: [^nil]) "first key for window class..."
        at: aWindow paneName ifAbsent: [] "second key for pane names..."!   
stopTimer
    " Private - Stop the Timer..."

    "Free timers..."
    timer := nil.
    TimerWindow stopTimer: self.
    self closePopUp.! 
tick
    "Private - Process timer ticks events..."

    | currentWindow sticker |

    (inUse or: [useVoice]) ifFalse: [ ^self ].
    mouseLocation := Cursor sense.

    currentWindow := CursorManager windowUnderCursor.
    (currentWindow isNil and: [popUp notNil]) "over a non-Smalltalk window..."
    ifTrue: [ lastSticker := nil. ^popUp sticker: nil ].

    sticker := self stickerFor: currentWindow.

    (useVoice and: [sticker ~= lastSticker and: [sticker isString]])
    ifTrue: [ self say: sticker asString ].

    lastSticker := sticker.
    inUse ifFalse: [ ^self ].

    "for hide & show..."
    popUp isNil ifTrue: [ self openPopUp ].
    popUp notNil ifTrue: [ popUp sticker: sticker ].

    "for open & close...  Obsolete...
    sticker isNil
    ifTrue: [ popUp notNil ifTrue: [ self closePopUp ] ]
    ifFalse: [
        popUp isNil
        ifTrue: [ self openPopUp ]
        ifFalse: [ popUp sticker: sticker ]
    ].
    "! 
toggle
    " Private - Toggle the receiver's state..."

    inUse := inUse not.
    self profiler at: 'inUse' put: inUse asString.

    inUse
    ifTrue: [ self startTimer ]
    ifFalse: [ self stopTimer ]!
toggleSpeech
    " Private - Toggle the speech mode..."

    useVoice := useVoice not.
    self profiler at: 'useVoice' put: useVoice asString.

    useVoice
    ifTrue: [ self openVoiceServer ]
    ifFalse: [ self releaseVoiceServer ].! !

! CDGuiaObject class methods ! 
imageClass
    "Private - Returns the class used for processing images"

    ImageClass isNil
    ifTrue: [
        ImageClass := BMPImage " DIBImage, HaloImage or P3Image ..."
    ].
    ^ImageClass!   
imageClass: aClass
    "Private - Sets the class used for processing images"

    ImageClass := aClass! !

! GridView methods !  
cellSize
    "Returns the instance var of the receiver
     for external manipulation"
    ^cellSize!  
cellSize: aPoint
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    cellSize := aPoint! 
color
    "Returns the instance var of the receiver
     for external manipulation"
    ^color!
color: anInteger
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    color := anInteger! 
colors
    "Returns the posible colors in the receiver as anArray"

    ^(Array with: ClrBlack with: ClrWhite with: ClrRed with: ClrBlue),
     (Array with: ClrPalegray with: ClrYellow with: ClrDarkred with: ClrPink),
     (Array with: ClrDarkcyan with: ClrDarkgreen with: ClrDarkgray with: ClrDarkblue),
     (Array with: ClrCyan with: ClrGreen with: ClrBrown with: ClrLightgray)!   
display: aRectangle with: aPen
    "Private - Draw the receiver inside aRectangle..."

    hidden ifTrue: [^self].
    self drawIn: aRectangle with: aPen.!   
drawIn: aRectangle with: aPen
    "Private - Draw the receiver inside aRectangle..."

    | interval left top right bottom backPos backColor |
    interval := self cellSize.
    left := aRectangle left // interval x * interval x.
    right := aRectangle right + interval x - 1 // interval x * interval x.
    top := aRectangle top // interval y * interval y.
    bottom := aRectangle bottom + interval y - 1 // interval y * interval y.
    backPos := aPen location. backColor := aPen foreColor.
    aPen
        foreColor: self color;
        setLineWidth: self lineWidth;
        setRop2: R2Notxorpen;
        setLineType: self style.
    left to: right by: interval x do: [:x|
        aPen place: x@top;goto: x@bottom
    ].
    top to: bottom by: interval y do: [:y|
        aPen place: left@y;goto: right@y
    ].
    aPen
        setRop2: R2Copypen;
        setLineType: PsSolid;
        place: backPos;
        foreColor: backColor;
        yourself!
hidden
    "Returns the instance var of the receiver
     for external manipulation"
    ^hidden!  
hidden: aBoolean
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    hidden := aBoolean! 
initialize
    "Private - Initialize the receiver..."

    super initialize.

    hidden := true.
    color := ClrBlack.
    cellSize := 50@50.
    lineWidth := 1.
    style := self styles first.
    mapMode := self mapModes first.!
lineWidth
    "Returns the instance var of the receiver
     for external manipulation"
    ^lineWidth!
lineWidth: anInteger
    "Sets the instance var of the receiver
     with anInteger. (No checking is done)"
    lineWidth := anInteger!
mapMode
    "Returns the instance var of the receiver
     for external manipulation"
    ^mapMode!
mapMode: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    mapMode := anObject!   
mapModes
    "Returns the posible mapModes in the receiver as anArray"

    ^(Array
        with: MmAnisotropic
        with: MmHienglish
        with: MmHimetric
       "with: MmIsotropic"),
    (Array
        with: MmLoenglish
        with: MmLometric
        with: MmText
        with: MmTwips)!
style
    "Returns the instance var of the receiver
     for external manipulation"
    ^style!
style: aPsStyle
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    style := aPsStyle!   
styles
    "Returns the posible styles in the receiver as anArray"

    ^(Array
        with: PsDot
        with: PsSolid
        with: PsDash),
    (Array
        with: PsDashdot
        with: PsDashdotdot)! 
toggle
    "Toggle the hidden attribute..."

    self hidden: self hidden not! 
visible
    "True if the receiver is visible"
    ^hidden not!  
visible: aBoolean
    "Sets if the receiver is visible state"

    ^self hidden: aBoolean not! !

! LayerView class methods !
on: aLayer
    "Answer a new instance of the receiver based on aLayer."

    ^self new
        layer: aLayer;
        yourself! !

! LayerView methods !   
boundingBox
    ^selectedCategories isEmpty
    ifTrue: [ layer boundingBox ]
    ifFalse: [
        selectedCategories asArray first boundingBox
    ]! 
canZoom: anInteger
    "Answers true if the receiver can zoom to anInteger"

    ^self layer canZoom: anInteger!   
categories
    "Answer a collection of the categories of the receivers layer."

    ^self layer categories!
categoryNamed: aString
    "Answer the category whose name is aString."

    ^self layer categoryNamed: aString!   
categoryNames
    "Answer a collection of the category names of the receivers layer."

    ^self layer categoryNames!  
display: aRectangle at: aPoint with: aPen zoom: scale
    "Outputs the receiver's layer layerRect in destRect thru aPen."

    | cats |
    (cats := self selectedCategories) isEmpty ifTrue: [ ^self ].
    self layer display: cats rectangle: aRectangle at: aPoint with: aPen zoom: scale!   
display: layerRect in: destRect with: aPen
    "Outputs the receiver's layer layerRect in destRect thru aPen."

    | cats |
    (cats := self selectedCategories) isEmpty ifTrue: [ ^self ].
    self layer display: cats rectangle: layerRect in: destRect with: aPen! 
elementsInRectangle: aRectangle
    "Return the elements inside aRectangle
    LRP 12/MAY/94"
    | elements |
    elements := OrderedCollection new: 100.
    self categories do: [:oneGrid |
            elements addAll: (oneGrid elementsInRectangle: aRectangle)
    ].
    ^elements!   
initialize
    "Private - Initializes the receiver."

    super initialize.
    selectedCategories := Set new.
    layer := Layer new.!  
isCategorySelected: aCategory
    "Answers true wether aCategory is in the collection of selectedCategories."

    aCategory isString
        ifTrue: [ ^self isCategorySelected: (self categoryNamed: aCategory) ].
    ^self selectedCategories includes: aCategory!   
isOpaque
    "Answer true if the receivers layer has a level lower than 20"

    ^self level < 20! 
layer
    "Returns the layer on which the receiver keeps the visual state"
    ^layer!  
layer: aLayer
    "Sets the layer over which the receiver keeps the current visual state"

    layer := aLayer.
    self selectedCategories: aLayer defaultCategories.!   
level
    "Answer the level of the receivers layer."

    ^self layer level!   
name
    "Answers the receivers layer name."

    ^self layer name!
print: sourceRect inside: destRect using: aPrinter
    "Implemented for printing...
      sourceRect will be the area inside the receiver's boundingBox (in pixels) to be printer
      destRect will be the destination area for output (in inches)
      aPrinter will be the current printer to use (placed in the current page).
    "

    | factor capability destination |

    "compute dest rect in pixels..."
    capability := aPrinter capability.
    factor := aPrinter extent / capability extentInInches.
    destination := (destRect scaleBy: factor) truncated.

    "Default drawing of the receiver..."
    self display: sourceRect in: destination with: aPrinter pen.! 
resetSelection
    "Proceeds to include all the default layer properties."

    self layer: layer! 
select: aCategory
    "Proceeds to include aCategory in the collection of selectedCategories."

    aCategory isString
    ifTrue: [ ^self select: (self categoryNamed: aCategory) ].

    (self selectedCategories includes: aCategory)
    ifFalse: [
        layer selectExclusive ifTrue: [ self unselectAll ].
        self selectedCategories add: aCategory
    ]!   
selectAll
    "Proceeds to include all the layer Categories."

    layer selectExclusive
    ifTrue: [ ^self select: layer categories first ].
    self selectedCategories addAll: layer categories! 
selectedCategories
    "Returns the instance var of the receiver
     for external manipulation"
    ^selectedCategories!  
selectedCategories: aCollection
    "Sets the receiver's selected categories as a set"

    selectedCategories := aCollection asSet!   
selectedCategoryNames
    "Answer a collection of the selected category names of the receiver's layer."

    | set |
    set := Set new.
    self selectedCategories do: [:categ|
        set add: (layer nameOfCategory: categ)
    ].
    ^set! 
unselect: aCategory
    "Proceeds to exclude aCategory in the collection of selectedCategories."

    aCategory isString
        ifTrue: [ ^self unselect: (self categoryNamed: aCategory) ].
    (self selectedCategories includes: aCategory)
        ifTrue: [ self selectedCategories remove: aCategory ]!  
unselectAll
    "Proceeds to include no Categories."

    self selectedCategories removeAll: self selectedCategories copy! !

! TileLayerView methods !  
elementsInRectangle: aRectangle
    "Return the elements inside aRectangle.
    The TileLayer does not have elements.
    LRP 12/MAY/94"

    ^#()!  
print: sourceRect inside: destRect using: aPrinter
    "Implemented for printing...
      sourceRect will be the area inside the receiver's boundingBox (in pixels) to be printer
      destRect will be the destination area for output (in inches)
      aPrinter will be the current printer to use (placed in the current page).
    "

    self selectedCategories do: [:aTiledImage|
        aTiledImage print: sourceRect inside: destRect using: aPrinter
    ]! !

! MapView methods !
boundingBox
    "Returns the bounding box of the receiver."

    | layer |
    layer := self layers
        detect: [ :each | each isOpaque and: [each selectedCategories notEmpty] ]
        ifNone: [ ^self map boundingBox ].
    ^layer boundingBox!   
buildLayers
    "Private - Resets the receivers layer (views) of the currently active map."
    | layerViews aMap |
    aMap := self map.
    aMap isNil ifTrue: [ ^self ].
    layers := SortedCollection sortBlock: Layer sortBlock.
    layerViews := aMap layers collect: [:each| each asView ].
    layers addAll: layerViews.
    layerViews do: [:view| "autoSelect opaque layers..."
        view isOpaque ifTrue: [ self select: view ]
    ]! 
canZoom: anInteger
    "Answers true if the receiver can zoom to anInteger"

    self selectedLayers
        detect: [:each| (each canZoom: anInteger) not ]
        ifNone: [^true].
    ^false!   
canZoomIn
    "Answers true if the receiver can zoom in"

    ^self canZoom: self scale * 2!   
canZoomOut
    "Answers true if the receiver can zoom out"

    ^self canZoom: self scale / 2! 
checkLayers
    "Private - Check the receivers layer (views) of the currently active map."
    | layerViews new view |

    layers copy do: [:aLayerView|
        (map layers includes: aLayerView layer)
        ifFalse: [ layers remove: aLayerView ] "layer has been removed from map..."
    ].
    new := Set new.
    map layers copy do: [:aMapLayer|
        layers
            detect: [:each| each layer = aMapLayer ]
            ifNone: [ "newly created layer..."
                view := aMapLayer asView.
                layers add: view.
                new add: view.
            ]
    ].

    new do: [:each|
        self select: each
    ].!  
copy
    "Returns a copy of the receiver"
    ^self class new copyFrom: self!   
copyFrom: aMapView
    "Private - Copy receiver's contents from aMapView"

    self initialize.
    layers := aMapView layers.
    scale := aMapView scale.
    selectedLayers addAll: aMapView selectedLayers.
    map := aMapView map.!  
displayRectangle: aRectangle at: aPoint with: aPen
    "Outputs the receivers rectangle aRectangle scaled to the
    current scale with aPen."

    0@0 >= aRectangle extent ifTrue: [ ^self ].
    self selectedLayers
        detect: [ :each | each isOpaque and: [each selectedCategories notEmpty] ]
        ifNone: [ aPen fill: aRectangle color: aPen backColor ].

    self selectedLayers do: [ :aLayerView |
        aLayerView display: aRectangle at: aPoint with: aPen zoom: scale ]! 
displayRectangle: aRectangle with: aPen
    "Outputs the receivers rectangle aRectangle scaled to the
    current scale with aPen."

    ^self displayRectangle: aRectangle at: 0@0 with: aPen!   
elementsInRectangle: aRectangle
    "Return the elements inside aRectangle
    LRP 12/MAY/94"

    | elements |
    elements := OrderedCollection new.
    self selectedLayers do: [:aLayerView |
            elements addAll: (aLayerView elementsInRectangle: aRectangle)
    ].
    ^elements!
initialize
    "Private - Initializes the receiver."

    super initialize.
    selectedLayers := SortedCollection sortBlock: Layer sortBlock.
    layers := SortedCollection sortBlock: Layer sortBlock.
    scale := 1.
    self map: Map new.!  
layers
    "Returns the collection of layer (views) that are present in the
    receivers map"

    map layers size = layers size
    ifFalse: [ self checkLayers ].
    ^layers!   
layers: aCollection
    "Sets the collection of layer (views) present in the receivers map
    to aCollection"
    layers := aCollection!  
map
    "Returns the map of the receiver."

    ^map!  
map: aMap
    "Sets the receiver's map
    and update the layers views..."

    aMap isNil ifTrue: [ ^nil ].
    map := aMap.
    self buildLayers! 
name
    ^map name!  
print: sourceRect inside: destRect using: aPrinter
    "Implemented for printing...
      sourceRect will be the area inside the receiver's boundingBox (in pixels) to be printed
      destRect will be the destination area for output (in inches)
      aPrinter will be the current printer to use (placed in the current page).
    "

    0@0 >= destRect extent ifTrue: [ ^self ].
    self selectedLayers do: [ :aLayerView |
        aLayerView print: sourceRect inside: destRect using: aPrinter
    ]!  
references
    ^map references!  
scale
    "Returns the scale of the receiver
     for external manipulation"
    ^scale!   
scale: anInteger
    "Sets the instance var of the receiver
     with anInteger. (No checking is done)"
    scale := anInteger!
select: aLayer
    "Proceeds to include aLayer in the collection of selectedLayers."

    (selectedLayers includes: aLayer)
    ifFalse: [ selectedLayers add: aLayer ].! 
selectedLayers
    "Returns the collection of layers that are selected for displaying"

    ^selectedLayers!   
selectedLayers: aLayerCollection
    "Sets the collection to be displayed by the reciever to
     aLayerCollection. (No checking is done)"

    selectedLayers := aLayerCollection!   
stamp
    ^map stamp!
stamp: anObject
    "Sets the map stamp..."
    map stamp: anObject!
toggle: aLayer
    "Proceeds to revert the visible status of aLayer."

    (selectedLayers includes: aLayer)
        ifTrue: [ self unselect: aLayer ]
        ifFalse: [ self select: aLayer ].!
unselect: aLayer
    "Proceeds to exclude aLayer in the collection of selectedLayers."

    (selectedLayers includes: aLayer)
        ifTrue: [ selectedLayers remove: aLayer ].! 
zoomIn
    "Increases the zoom by one power (if possible)."

    self canZoomIn
        ifTrue: [ self scale: (self scale * 2) ]! 
zoomOut
    "Decreases the zoom by one power (if possible)."

    self canZoomOut
        ifTrue: [ self scale: (self scale / 2) ]! !

! MapViewState methods ! 
activate
    "Perform activation of the receiver on it's model"

    | model |
    model := self model.
    model isNil ifFalse: [
        model openView: self viewClass withState: self
    ]!   
icon
    "Returns the instance var of the receiver
     for external manipulation"

    ^icon notNil ifTrue: [icon] ifFalse: [super icon]!
icon: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    icon := anObject! 
initialize
    "Private - Initialize the receiver"

    super initialize.

    settings := Dictionary new.!  
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!  
name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject! 
position
    "Returns the receiver's position"
    | value |
    value := self settings.
    #(view position) do: [:each|
        value isNil ifTrue: [^0@0].
        value := value at: each ifAbsent: []
    ].
    ^value! 
settings
    "Returns the instance var of the receiver
     for external manipulation"
    ^settings!  
settingsFor: aTopic
    "Returns the current settings for aTopic as a dictionary"

    ^self settings
        at: aTopic
        ifAbsent: [
            self settings
                at: aTopic
                put: Dictionary new
        ]! 
viewClass
    "Returns the instance var of the receiver
     for external manipulation"
    ^viewClass!
viewClass: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    viewClass := anObject! !

! CellElement class methods !
iconOf: aSymbol
    "Answer the icon that is used to represent the instances of the receiver
    that belong to the category aSymbol."

    ^self icons
                at: aSymbol
                ifAbsent: [ Icon fromModule: ObjectStyleDLL library id: 'Object' ]! 
icons
    "Answer the dictionary of icons that are used to represent the instances of the receiver."

    ^Icons isNil
        ifTrue: [ Icons := Dictionary new ]
        ifFalse: [ Icons ]! !

! CellElement methods !  
category
    "Returns the category of the receiver."
    ^category! 
category: aString
    "Sets the catefory of the receiver to aString."
    category := aString!  
display: gridRectangle in: destRect with: aPen
    "Outputs the receiver's gridRectangle in destRect thru aPen."

    | scale |

    scale := destRect extent / gridRectangle extent.
    aPen place: (self position * scale) truncated.
    self displayWith: aPen.!  
displayWith: aPen
    "Outputs the receiver in aRectangle thru aPen."

    | penPos icon |

    penPos := aPen location.
"    (icon := self class iconOf: self type) isNil
        ifFalse: [ icon displayAt: aPen location with: aPen ].
    aPen centerText: self name printString at: penPos"

    aPen centerText: ':'! 
id
    "Returns the instance var of the receiver
     for external manipulation"
    ^id!  
id: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    id := anObject! 
initialize
    "Private - Initializes the receiver."

    super initialize.
    position := 0 @ 0.
    type := name := #unknown.!
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!  
name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject! 
position
    "Returns the instance var of the receiver
     for external manipulation"
    ^position!  
position: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    position := anObject! 
type
    "Returns the instance var of the receiver
     for external manipulation"
    ^type!  
type: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    type := anObject! !

! RouteCellElement methods !   
initialize
    "Private - Initializes the receiver."

    super initialize.
    route := #unknownRoute!   
route
    "Returns the instance var of the receiver
     for external manipulation"
    ^route!
route: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    route := anObject! !

! SearchStreetObject class methods ! 
aboutToSaveImage
    "Private - The Smalltalk image is being saved.
     Force reloading of tables upon startUp.
    SearchStreetObject aboutToSaveImage
    "

    AliasTable :=
    IgnoreTable :=
    NormalizeTable :=
    NumericExtensions := nil.!
aliasFor: aString
    "Private - Returns the alias for aString.
    (must aString MUST match a valid alias;
     use normalized strings...)"

    ^self aliasTable
        at: aString
        ifAbsent: [ aString ]!  
aliasTable
    "Private - Returns the dictionary used for Alias replacement"

    AliasTable isNil ifTrue: [ self initializeAliasTable ].
    ^AliasTable!
ignoreTable
    "Private - Returns the dictionary used for words ignored"

    IgnoreTable isNil ifTrue: [ self initializeIgnoreTable ].
    ^IgnoreTable!
indexFor: aStreetNet
    "Returns an index structure for searching into aStreetNet..."

    | index |

    self notFullyImplemented.
    ^index.!   
initializeAliasTable
    "Private - Initialize Alias Table...
    See method #aliasFor: for documentation.
    AddressFinder initializeAliasTable;aliasTable
    "

    | file pathName |
    AliasTable := Dictionary new.

    AliasTable "set with default values..."
        "no defaults..."
        yourself.

    pathName := self profiler at: 'Alias Table' ifAbsent: [].
    pathName size = 0 ifTrue: [ ^self ].
    pathName := PathFinder locationFor: pathName.
    (File exists: pathName) ifFalse: [^self].

    file := File pathNameReadOnly: pathName.
    [ file atEnd ] whileFalse: [
        file peek isSeparator ifTrue: [ file next ]
        ifFalse: [
            file peek = $;
            ifTrue: [ file nextLine ] "skip comments"
            ifFalse: [
                AliasTable
                    at: (self normalize: (file upTo: $=)) "use normalized keys..."
                    put: (self normalize: file nextLine)
            ]
        ]
    ].
    file close.!   
initializeIgnoreTable
    "Private - Initialize Ignored words Table...
    AddressFinder initializeAliasTable;aliasTable
    "

    | file pathName |
    IgnoreTable := Set new.

    IgnoreTable "set with default values..."
        "no defaults..."
        yourself.

    pathName := self profiler at: 'Ignore Table' ifAbsent: [].
    pathName size = 0 ifTrue: [ ^self ].
    pathName := PathFinder locationFor: pathName.
    (File exists: pathName) ifFalse: [^self].

    file := File pathNameReadOnly: pathName.
    [ file atEnd ] whileFalse: [
        file peek isSeparator ifTrue: [ file next ]
        ifFalse: [
            file peek = $;
            ifTrue: [ file nextLine ] "skip comments"
            ifFalse: [
                IgnoreTable add: (self normalize: file nextLine)
            ]
        ]
    ].
    file close.!
initializeNormalizeTable
    "Private - Initialize Normalization Table...
    See method #normalize: for documentation.
    AddressFinder initializeNormalizeTable;normalizeTable
    "

    | file pathName keys line |
    NormalizeTable := Dictionary new.

    NormalizeTable "set with default values..."
        at: $, put: String new; "blank character..."
        at: $; put: String new; "blank character..."
        at: $' put: String new; "eliminate character..."
        at: Cr put: $ ;
        at: Lf put: $ ;
        at: Tab put: $ ;
        yourself.

    pathName := self profiler at: 'Normalization Table' ifAbsent: [].
    pathName size = 0 ifTrue: [ ^self ].
    pathName := PathFinder locationFor: pathName.
    (File exists: pathName) ifFalse: [^self].

    file := File pathNameReadOnly: pathName.
    [ file atEnd ] whileFalse: [
        file peek isSeparator ifTrue: [ file next ]
        ifFalse: [
            file peek = $;
            ifTrue: [ file nextLine ] "skip comments"
            ifFalse: [
                keys := file upTo: $=.
                line := file nextLine trimBlanks.
                keys do: [:char| NormalizeTable at: char put: line ]
            ]
        ]
    ].
    file close.! 
initializeNumericExtensions
    "Private - Initialize NumericExtensions...
    See method #numericExtensions for documentation.
    AddressFinder initializeNumericExtensions
    "

    | file pathName |
    NumericExtensions := Set new.

    NumericExtensions "set with default values..."
        add: 'DE'; "Caso: 15 DE NOVIEMBRE DE 1889"
        add: 'No';  "Caso: CALLE No 10"
        yourself.

    pathName := self profiler at: 'NumericExtensions' ifAbsent: [].
    pathName size = 0 ifTrue: [ ^self ].
    pathName := PathFinder locationFor: pathName.
    (File exists: pathName) ifFalse: [^self].

    file := File pathNameReadOnly: pathName.
    [ file atEnd ] whileFalse: [
        file peek isSeparator ifTrue: [ file next ]
        ifFalse: [
            file peek = $;
            ifTrue: [ file nextLine ] "skip comments"
            ifFalse: [
                file peek = $- "next word will be removed if preceded with a $-..."
                ifTrue: [
                    file next.
                    NumericExtensions remove: file nextWord ifAbsent: []
                ]
                ifFalse: [ NumericExtensions add: file nextWord ]
            ]
        ]
    ].
    file close.!
normalize: aString
    "Private - Returns a normalized string from aString
        AddressFinder normalize: 'O&Cnnel nts'
    "

    | table output |
    table := self normalizeTable.
    output := WriteStream on: String new.
    aString trimBlanks do: [:char|
        output nextPutAll: (
            table
                at: char
                ifAbsent: [String with: char])
    ].
    ^output contents asUpperCase! 
normalizeTable
    "Private - Returns the dictionary used for normalization"

    NormalizeTable isNil ifTrue: [ self initializeNormalizeTable ].
    ^NormalizeTable!
numericExtensions
    "Private - Returns the words set used for numerical
    join for streets.
    Case:  for address
        15 DE NOVIEMBRE DE 1889 988
        will be interpreted as the number 988 of street
         named '15 DE NOVIEMBRE DE 1889'
         if the string 'DE' is in NumericExtensions
    "

    NumericExtensions isNil ifTrue: [ self initializeNumericExtensions ].
    ^NumericExtensions!   
partsOf: aString
    "Returns aString fractioned in normalized parts..."

    | normal parts output |

    "normalization & fractionin..."
    normal := self normalize: aString.
    parts := normal asArrayOfSubstrings.

    "alias replacement..."
    parts := parts collect: [:each| self aliasFor: each ].

    output := WriteStream on: (Array new: parts size).
    "strip ignored words..."
    parts do: [:each|
        (self ignoreTable includes: each)
        ifFalse: [ output nextPut: each ]
    ].
    ^output contents! !

! SearchStreetObject methods !   
normalize: aString
    "Private - Returns aString normalized..."

    ^self class normalize: aString! !

! AddressFinder class methods ! 
aboutToSaveImage
    "Private - The Smalltalk image is being saved.
     Force reloading of default speller if needed  "

    self default: nil.! 
default
    "Returns the default address finder..."

    Default isNil ifTrue: [ self initializeDefault ].
    ^Default!  
default: anAddressFinder
    "Sets the default address finder..."

    Default := anAddressFinder.!
defaultPath
    "Private - Returns the default path name..."

    | pathName |
    pathName := self profiler
        at: 'Default' ifAbsent: [
            pathName := 'Default.Spc'.
            self profiler at: 'Default' put: pathName.
        ^pathName
        ].
    ^pathName notNil ifTrue: [ pathName trimBlanks ]! 
defaultPath: pathName
    "Private - Sets the default path name..."

    ^self profiler at: 'Default' put: pathName!   
initializeDefault
    "Private - Initialize the default address finder..."

    | instance file |
    file := self defaultPath.
    (file size = 0 or: [
        file := PathFinder locationFor: file.
        (File exists: file) not ])
    ifTrue: [ instance := self new ]
    ifFalse: [
        instance := ObjectFiler loadFromPathName: file.
        (instance isKindOf: self) ifFalse: [ ^self error: 'Archivo Invalido...' ].
    ].

    Default := instance! !

! AddressFinder methods !
autoSave
    "Returns the instance var of the receiver
     for external manipulation"
    ^autoSave!  
autoSave: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    autoSave := anObject! 
cancelled
    "Returns the instance var of the receiver
     for external manipulation"
    ^cancelled!
cancelled: aBoolean
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"

    cancelled := aBoolean.!
close
    "Close the receiver..."

    self release!   
cornerOf: main and: other
    "Private - Returns an array with lines for intersection of main street
     with lo street or nil if the two streets does not cross.
    First element of result is the segment in the main street
     and the last is in the other street
    "

    | mainLines otherLines collect cole one |
    collect := [:points|
        cole := OrderedCollection new.
        2 to: points size do: [:i|
            cole add: (Segment from: (points at: i - 1) to: (points at: i))
        ].
        cole asArray
    ].
    mainLines := collect value: main points.
    otherLines := collect value: other points.

    mainLines do: [:line|
        one := otherLines
            detect: [:each| (line intersect: each) notNil ]
            ifNone: [].
        one notNil ifTrue: [ "found..."
            ^Array with: line with: one
        ].
    ].

    "does not intersect..."
    ^nil!
editDictionary
    "Lets the user edit current dictionary..."

    ^self notImplementedYet!
fileInDictionary
    "Lets the user fileIn a new dictionary..."

    | dialog file dic |

    dialog := FileDialog new.
    dialog
        title: 'Seleccione el diccionario...';
        addFilter: '*.dir' description: 'Diccionario de direcciones (*.DIR)';
        addFilter: '*.spc' description: 'Configuracin de Spelling de direcciones (*.SPC)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        defFilter: '*.dir';fileSpec: '*.dir';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].
    (file includes: $.)
    ifFalse: [ file := file,'.Dir' ].

    dic := ObjectFiler loadFromPathName: file.
    dic isNil ifTrue: [ ^self error: 'Archivo Invalido...' ].

    dic class == self class ifTrue: [ dic := dic xRef ].

    dic class = xRef class
    ifFalse: [ ^self error: 'El archivo no contiene un diccionario aceptable.' ].

    self xRef addAll: dic.!  
fileOutDictionary
    "Lets the user fileOut current dictionary..."

    | dialog file |
    file := 'User.Dir'.
    dialog := FileDialog new.
    dialog
        title: 'Seleccione el archivo donde guardarlo...';
        addFilter: '*.dir' description: 'Diccionario de direcciones (*.DIR)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        fileSpec: file;
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].

    (file includes: $.) ifFalse: [ file := file,'.DIR' ].
    CursorManager execute changeFor: [
        ObjectFiler dump: self xRef newFile: file
    ].
    ^file!  
find: aString
    "Private - use #find:using:...
    Find the position associated with aString in streetNet.
    aString can be a complete address, or a street name.
    Returned object can be:
        nil if failed.
        aCollection (of StreetReferences) if a street has been found
                         in aStreetNet but no number has been detected
        aPoint, aRectangle or an array of points : if an address can be found
        (see #initialize message for more details...)
    "

    | street number digits address normalized result |

    cancelled := false.

    result := self streetNamed: aString.
    result isNil ifFalse: [ "exactly match of a street..."
        ^self return: result
    ].

    (self formats includes: #lumi) ifTrue: [
        result := self findLumi: aString.
        result isNil ifFalse: [ ^self return: result ].
    ].

    (self formats includes: #intersections) ifTrue: [
        result := self findIntersections: aString.
        result isNil ifFalse: [ ^self return: result ].
    ].

    lastSearch := self scanAddress: aString trimBlanks asStream.
    lastSearch isNil ifTrue: [^nil]. "failed to scan a valid address"

    " MessageBox message: 'Searching for\'withCrs,asoc asString. "

    normalized := self normalize: lastSearch key.
    street := self findStreet: normalized.
    street isNil ifTrue: [ ^nil ]. "failed to find a street..."

    digits := lastSearch value trimBlanks.
    (digits isNil or: [digits isEmpty or: [digits first isDigit not]])
    ifTrue: [ ^self return: street ]. "failed to find a number..."

    number := digits asInteger.
    lastSearch value: number.
    address := street
            detect: [:one| one isPath ]
            ifNone: [
                street detect: [:ref| ref holdsNumber: number ] ifNone: []
            ].
    address isNil ifTrue: [ ^self return: street ]. "invalid  number?"

    result := address pointForNumber: number.

    ^self return: result! 
find: aString using: aStreetNet
    "Find aString using aStreetNet..."

    | old result |
    old := streetNet.
    streetNet := aStreetNet.
    result := self find: aString.
    streetNet := old.
    ^result!
findIntersections: aString
    "Private - Find a provable address determined by a corner..."

    | between and
      words stream
      main lo hi
      buildString getPath
      result |

    between := 'ENTRE'.
    and := 'Y'.

    "detect if valid syntax... (must have at least an 'and'  and only one 'between' "
    words := (self normalize: aString) asArrayOfSubstrings.
    (words occurrencesOf: and) = 1 ifFalse: [^nil].
    (words occurrencesOf: between) > 1 ifTrue: [^nil].

    "split street names..."
    stream := ReadStream on: words.
    ((words includes: between) and: [words first ~= between])
    ifTrue: [
        main := stream upTo: between.
        lo := stream upTo: and.
        hi := stream upTo: nil.
    ]
    ifFalse: [
        main := stream upTo: and.
        lo := stream upTo: nil.
        hi := nil.
    ].

    "rebuild street names..."
    buildString := [:collection|
        result := WriteStream on: String new.
        collection do: [:word| result nextPutAll: word;space ].
        result contents trimBlanks
    ].
    main := self findStreet: (buildString value: main).
    main isNil ifTrue: [ ^nil ].
    lo := self findStreet: (buildString value: lo).
    lo isNil ifTrue: [ ^nil ].
    hi notNil ifTrue: [ hi := self findStreet: (buildString value: hi) ].

    "get valid(edited) paths..."
    getPath := [:cole| cole detect: [:path| path isPath] ifNone: [ ] ].
    main := getPath value: main.
    main isNil ifTrue: [ ^nil ].
    lo := getPath value: lo.
    lo isNil ifTrue: [ ^nil ].
    hi notNil
    ifTrue: [
        hi := getPath value: hi.
        hi isNil ifTrue: [ ^nil ].
    ].

    "obtain corner or points for path..."
   ^self pointsOf: main between: lo and: hi!  
findLumi: aString
    "Private - Find a provable lumi address in aString..."

    | lumi |
    lumi := LumiAddress fromStream: aString trimBlanks asStream.
    (lumi notNil and: [ lumi isValid ]) ifFalse: [ ^nil ].
    lastSearch := Association key: 'Lumi ',aString value: nil.
    ^lumi boundingBox!   
findStreet: aStreet
    "Private - Search for a street in streetNet.
    Returns nil if failed or aCollection of StreetReferences"

    | result parts alias old return |
    streetNet isNil ifTrue: [ ^nil ].

    "If aStreet is NOT a string then can be aPoint or
     aRectangle & must be returned inmediatelly...
    This occurs for regions in xRef..."
    aStreet isString ifFalse: [ ^self return: aStreet ].

    "search in ignore list"
    (ignoreList includes: aStreet) ifTrue: [^nil].

    "search for an alias in xRef collection..."
    alias := self xRef
        detect: [:one| one first = aStreet ] ifNone: [].
    alias notNil ifTrue: [ ^self findStreet: alias last ].

    "Try exact matching..."
    result := self streetNamed: aStreet.
    result notNil ifTrue: [ ^result ].

    old := searching.
    searching := aStreet.
    return := self matchFor: (self partsOf: aStreet).
    searching := old.
    ^return! 
formats
    "Returns the instance var of the receiver
     for external manipulation"
    ^formats!
fuzzySearch
    "Returns the instance var of the receiver
     for external manipulation"
    ^fuzzySearch!
fuzzySearch: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    fuzzySearch := anObject!   
ignoreList
    "Returns the instance var of the receiver
     for external manipulation"
    ^ignoreList!  
initialize
    "Private - Initialize the receiver.."

    xRef size = 0 ifTrue: [ xRef := OrderedCollection new ]. "quick xRef dictionary..."
    ignoreList := Set new.

    returns := #object. " can be #point. "
        "by default returns anObject (or nil)  but can return aPoint if is been set to #point....
            the returned object can be:
                nil : no-object can be found...
                aPoint : position for object found...
                aRectangle : the boundingBox of the object region (lumi case)
                anArray of points : for path of streets (case: Av. Crdoba entre Malabia y J. B. Justo) *Not implemented Yet...*
        "

    formats := #(standard lumi intersections) asSet. "by default accept only standard format.."
    lumiOption := #random. "by default returns random points for lumi addresses if must return a point..."

    fuzzySearch := true.
    autoSave := false. "save when done flag..."!   
lastSearch
    "Returns the instance var of the receiver
     for external manipulation"
    ^lastSearch!  
lumiOption
    "Returns the instance var of the receiver
     for external manipulation"
    ^lumiOption!  
lumiOption: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lumiOption := anObject! 
matchFor: arrayOfWords
    "Private - Returns aStreet in the receiver's Net
    that closelly matches arrayOfWords.
    If there are many candidates, the user will
     be prompted for a valid street...
    Returns nil if failed."

    | result parts matches set ranking weight best cole |
    arrayOfWords size = 0 | streetNet isNil ifTrue: [^nil].

    matches := arrayOfWords collect: [:word| streetNet index matchesFor: word ].

    "collect best ranked street..."
    best := matches collect: [:array| array notEmpty ifTrue: [ array first value ] ].
    cole := SortedCollection sortBlock: [:a :b| a size <= b size ].
    cole addAll: best.
    best := cole asArray.
    best first isEmpty ifFalse: [
        cole := best copyFrom: 2 to: best size.
        best := best first select: [:one| (cole detect: [:array| array includes: one] ifNone: []) notNil ].
        best size = 1 ifTrue: [ ^self streetNamed: best asArray first ].
    ].

    "collect best ranked streets..."
    set := Set new.
    matches do: [:match|
        set addAll: match first value
    ].

    set isEmpty ifTrue: [^nil].
    set size = 1 ifTrue: [
        ^self streetNamed: set asArray first
    ].

    "ignore weak search..."
    self fuzzySearch ifFalse: [ ^nil ].

    "compute total percent matching..."
    ranking := Dictionary new.
    set do: [:each| ranking at: each put: 0 ].

    1 to: arrayOfWords size do: [:i|
        weight := (arrayOfWords at: i) size.
        (matches at: i) do: [:asoc|
            asoc value do: [:street|
                (ranking includesKey: street)
                ifTrue: [
                    ranking at: street put: weight * asoc key + (ranking at: street)
                ]
            ]
        ]
    ].

    result := SortedCollection sortBlock: [:a :b| a value / a key size >= (b value / b key size) ].
    ranking associationsDo: [:asoc| result add: asoc ].

    result := self
        oneOf: (result asArray collect: [:each| each key ])
        bestRanked: best.
    result isNil ifTrue: [^nil].

    ^self streetNamed: result!  
oneOf: aCollection bestRanked: best
    "Private - Lets the user select one of aCollection of names"

    | dialog |
    aCollection size = 1ifTrue: [ ^aCollection first ].
    dialog := AddressFinderPrompt new.
    dialog
        speller: self;
        bestRanked: best;
        allSuggestions: aCollection;
        open.
    ^dialog selected!   
partsOf: aStreet
    "Returns the parts f the street aStreet..."

    ^self class partsOf: aStreet!
pointsOf: main between: lo and: hi
    "Private - Returns the points in main path between path lo and path hi..."

    | loLines hiLines cole point stream points loSide hiSide loIndex hiIndex |

    loLines := self cornerOf: main and: lo.
    loLines isNil ifTrue: [^nil]. "main-lo corner not found"

    hi isNil ifTrue: [ "return interpolated point for main-lo corner..."
        ^loLines first intersect: loLines last
    ].

    hiLines := self cornerOf: main and: hi.
    hiLines isNil ifTrue: [^nil]."main-hi corner not found"

    "return path for main between lo and hi..."
    cole := OrderedCollection new.
    point := loLines first intersect: loLines last.
    point isNil ifFalse: [ cole add: point ].

    points := main points.
    loIndex := points indexOf: loLines first start.
    hiIndex := points indexOf: hiLines first end.
    loSide := loLines first start.
    hiSide := hiLines first end.
    loIndex <= hiIndex
    ifFalse: [ "must swap points...
        hiSide := loLines first end.
        loSide := hiLines first start. "
        points := points reversed.
    ].
    stream := ReadStream on: points.
    stream upTo: loSide.
    cole
        " addLast: loSide;  "
        addAll: (stream upTo: hiSide);
        "  addLast: hiSide; "
        yourself.

    point := hiLines first intersect: hiLines last.
    point isNil ifFalse: [ cole add: point ].
    ^cole asArray collect: [:each| each truncated ]!  
release
    "Release the receiver...
    Save xRef if autosave is on..."

    (self autoSave = true and: [ self xRef notEmpty ])
    ifTrue: [ self fileOutDictionary ].

    ^super release!  
return: anObject
    "Private - Returns appropiate object obtained from anObject"

    | result |

    anObject isNil ifTrue: [ ^nil ]. "always return nil..."
    returns = #object ifTrue: [ ^anObject ]. "always return the Object..."

    "collection of points will be converted to first return..."
    anObject isCollection ifTrue: [
        anObject do: [:each|
            result := self return: each.
            result notNil ifTrue: [ ^result ].
        ].
    ].

    (anObject isKindOf: StreetReference)
    ifTrue: [ ^self return: anObject boundingBox ].

    anObject isRectangle "convert to point..."
    ifTrue: [
        lumiOption = #random
        ifTrue: [
            randomizer isNil ifTrue: [ randomizer := Random new ].
            ^(anObject width * randomizer next @ (anObject height * randomizer next)
                + anObject origin) truncated
        ].
        ^anObject perform: lumiOption
    ].

    ^anObject!   
returns
    "Returns the instance var of the receiver
     for external manipulation"
    ^returns!
returns: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    returns := anObject!   
saveAs: pathName
    "Save the receiver in file named pathName..."

    | old |
    old := streetNet.
    streetNet := nil.
    ObjectFiler dump: self newFile: pathName.
    streetNet := old.!   
scanAddress: aStream
    "Private - Scan aStream for a astreet name and an address reference.
    Returns:
        nil if failed
        anAssociation
            key     street name to find...
            value   Addr. number and other references (like 'piso:1 of: 234' )
    "
    | asoc word last key extensions stop |
    aStream atEnd ifTrue: [ ^nil ].
    key := String new.
    extensions := self class numericExtensions.

    [   stop := aStream position.
        word := aStream nextWord.
        (word isNil or: [ word isEmpty ]) not
        and: [ "word is a number and last is a name extension"
            word first isDigit not
            or: [ last isNil or: [ extensions includes: last ]]
        ]
    ]
    whileTrue: [
        last := word.
        aStream atEnd ifFalse: [
            [aStream atEnd or: [aStream peek isSeparator]] "skip punctuation marks"
             whileFalse: [ aStream next ].
        ].
        stop := aStream position.
    ].

    key := (aStream copyFrom: 1 to: stop) trimBlanks.
    key isEmpty ifTrue: [^nil].
    aStream position: stop.

    ^Association
        key: key trimBlanks
        value: (aStream upTo: nil) trimBlanks!  
searching
    "Returns the instance var of the receiver
     for external manipulation"
    ^searching!
streetNamed: aStreet
    "Private - Returns the street named aStreet (found in streetNet).
    Update lastSearch key value with aStreet has been found..."

    | result |
    streetNet isNil ifTrue: [ ^nil ].
    result := streetNet streetNamed: aStreet ifAbsent: [ ^nil ].
    lastSearch notNil ifTrue: [ lastSearch key: aStreet ].
    ^result asArray! 
streetNet
    "Returns the instance var of the receiver
     for external manipulation"
    ^streetNet!
streetNet: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"

    streetNet := anObject.
    lastSearch := nil.!
xRef
    "Returns the instance var of the receiver
     for external manipulation"
    ^xRef!  
xRef: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    xRef := anObject! !

! StreetIndex class methods !  
for: aStreetNet
    "Returns an instance of the receiver
    built from aStreetNet"

    ^self new
        initialize: aStreetNet! !

! StreetIndex methods !  
dumpOn: aStream
    "Dump receiver's contents on aStream for debuggin duplicates...

        | file |
        file := File newFile: 'streets.dmp'.
        StreetBuilder allInstances first map streets index dumpOn: file.
        file close.

    "

    | cole |
    contents keys asSortedCollection do: [:each|
        cole := contents at: each ifAbsent: [#()].
        cole size > 1 ifTrue: [ "has duplicates..."
           aStream cr;nextPutAll: each.
            cole asSortedCollection do: [:one|
                aStream cr;next: 4 put: $ ;nextPutAll: one
            ]
        ]
    ]!  
initialize: aStreetNet
    "Private - Initializes the receiver for working with aStreetNet"

    | parts set |
    CursorManager execute changeFor: [
        contents := Dictionary new.
        aStreetNet keys do: [:aName|
            parts := self class partsOf: aName.
            parts do: [:each|
                set := contents at: each ifAbsent: [Set new].
                set add: aName.
                contents at: each put: set.
            ].
        ]
    ].! 
matchesFor: aString
    "Returns the matches for word in aString
    in a collection of associations were
      keys are the percent of matching
      values are the collection of names that
                 matches with this percent
    Notes:
        if there are a key that is EQUAL to aString only one result will be returned...
        only match percent > 30% will be considered if there are any...
    "

    | dict result percent holder |

    "try exact matching..."
    result := contents at: aString ifAbsent: [].
    result isNil ifFalse: [ ^Array with: (Association key: 1 value: result) ].

    "obtain fuzzy matching collection..."
    result := SortedCollection sortBlock: [:a :b| a key >= b key].
    dict := Dictionary new.

    contents keysDo: [:key|
        percent := key matchOf: aString.
       " percent > 0.3
        ifTrue: [ "
            holder := dict at: percent ifAbsent: [
                holder := Set new.
                dict at: percent put: holder.
                result add: (Association key: percent value: holder).
                holder ].
            holder addAll: (contents at: key)
         " ] "
    ].

    ^result! !

! StreetNet class methods !   
fromFile: aFileName
    "Perform Parsing of file named aFileName.
     See #scan:  method for more details..."

    | file result realPath |
    realPath := PathFinder locationFor: aFileName.
    file := File pathNameReadOnly: realPath.
    result := self fromStream: file.
    file close.
    ^result!   
fromStream: aStream
    "Scan aStream or text in Lumi-Format
    and returns a new instance of the receiver
    with the data loaded.
    Lumi-Format is defined as:
        Line := StreetName | PathDescriptor
        StreetName := {aCharacter | Separator}
        PathDescriptor := NumericPathDescriptor | NoNumberDescriptor | EscapeDescriptor
        NumericPathDescriptor := [Separator] {Numbers} '-' Numbers [Separator] Address
        NoNumberDescriptor := 's/n' [Separator] Address
        EscapeDescriptor := '#' ClassName [ Information ]
        Address := aDigit aDigit '-' ('A'..'I') '-' ('1'..'6')
        Numbers := [aDigit]
        Separator := aCharacter that is a separator (as space or tabs...)
        ClassName := a Class name...
        Information := {aCharacter}

    Example:

ACASSUSO
    5100-5900   60-H-1
    5901-7625   59-E-4
ACCESO AL AEROPUERTO NACIONAL DE EZEIZA
    s/n 51-F-6
    s/n 52-G-2

    "
    | result currentStreet line
      paths addr lumi
      newStreet newPath lineNumber
      error escapeCharacter |

    escapeCharacter := $#.

    "Error notifying block..."
    error := [:text|
        UserLibrary messageBeep: 0.
        (MessageBox confirm: '*Error*\'withCrs,text
                ,'\en lnea: 'withCrs,lineNumber printString
                ,'\Contenido:'withCrs,line
                ,'\\Desea continuar ?'withCrs)
        ifFalse: [ ^self error: 'Error: ',text ].
    ].

    "New Street parsing logic..."
    newStreet := [:stream|
        stream notNil
        ifTrue: [
            (stream peek isDigit and: [stream contents includes: $-]) ifTrue: [
                error value: 'Posiblemente NO sea una calle :'withCrs,stream contents,'\Quizs falta un TAB...'withCrs.
                stream reset.
            ].
            currentStreet notNil ifTrue: [
                result addStreet: paths asArray as: currentStreet.
                paths := nil.
            ].
        ].
        currentStreet := (stream isNil ifFalse: [stream contents])
    ].

    "New Path parsing logic..."
    newPath := [:stream|
        currentStreet isNil ifTrue: [ error value: 'Debe haber un nombre antes...' ].
        paths isNil ifTrue: [ paths := OrderedCollection new ].
        stream peek = escapeCharacter
        ifTrue: [
            stream next.
            addr := (Smalltalk at: stream nextWord asSymbol) fromStream: stream
        ]
        ifFalse: [ addr := LumiAddress fromStream: stream ].
        (addr notNil and: [addr isValid])
        ifTrue: [ paths add: addr ]
        ifFalse: [ error value: 'Hubicacin invlida para la altura ',addr name,'\ de la calle 'withCrs,currentStreet ].
    ].

    "Current parsing Main logic..."
    lineNumber := 0.
    result := self new.
    [ aStream atEnd ] whileFalse: [
        line := aStream nextLine.
        lineNumber := lineNumber + 1.
        line isEmpty
        ifFalse: [
            line first isSeparator
            ifFalse: [ newStreet value: line trimBlanks asStream ]
            ifTrue: [ newPath value: line trimBlanks asStream ]
        ]
    ].
    newStreet value: nil.
    ^result! !

! StreetNet methods !
addStreet: aStreetPath as: aStreetName
    "Add a new street with path aStreetPath named aStreetName..."

   ^self
        at: aStreetName
        put: aStreetPath! 
at: aStreetName put: aStreetPath
    "Set street with path aStreetPath & name aStreetName..."

    self streets
        at: aStreetName
        put: aStreetPath.
    self resort.

    ^aStreetPath! 
buildIndex
    "Private - Build the receiver's indexes"

    index := StreetIndex for: self!   
fileOutOn: aStream
    "Files Out the receiver's contents in text format
    into aStream..."

    | street |
    self keys asSortedCollection do: [:each|
        street := self streets at: each ifAbsent: [].
        street size > 0
        ifTrue: [
            aStream cr;nextPutAll: each.
            street do: [:ref|
                aStream cr;tab.
                (ref isKindOf: LumiAddress)
                ifFalse: [ aStream nextPut: $#;nextPutAll: ref class name;tab ].
                ref fileOutOn: aStream
            ]
        ]
    ]! 
find: aString
    "Returns the result of finding address in aString..."

    ^self
        find: aString
        notifying: nil
        with: nil!  
find: aString notifying: monitor with: aSelector
    "Returns the result of finding address in aString...
    if found, send aSelector message to monitor.
     aSelector must have one argument (the street name) "

    ^self
        find: aString
        using: AddressFinder new
        notifying: monitor
        with: aSelector!   
find: aString using: anAddressFinder
    "Returns the result of finding address in aString using anAddressFinder... "

    ^self
        find: aString
        using: anAddressFinder
        notifying: nil with: nil! 
find: aString
    using: anAddressFinder
    notifying: monitor
    with: aSelector
    "Returns the result of finding address in aString using anAddressFinder...
    if found, send aSelector message to monitor.
     aSelector must have one argument (the street name) "

    | result streetName |
    result := anAddressFinder find: aString using: self.
    result isNil ifTrue: [ ^nil ].
    streetName := anAddressFinder lastSearch notNil
        ifTrue: [ anAddressFinder lastSearch key ].
    (aSelector notNil & streetName notNil and: [ monitor respondsTo: aSelector])
    ifTrue: [ monitor perform: aSelector with: streetName ].
    ^result!
index
    "Returns the instance var of the receiver
     for external manipulation"

    index isNil ifTrue: [ self buildIndex ].
    ^index!
initialize
    "Private - Initializes the receiver."

    super initialize.

    name := 'Nueva Ciudad'.
    streets := Dictionary new.!
isEmpty
    "Returns true if the receiver is empty..."

    ^self streets isEmpty! 
keys
    "Returns the street names in the receiver..."

    ^self streets keys!
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!  
name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject! 
names
    "Returns the current street names"

    ^self streets keys!  
prepareForEdition: aName
    "Private - Prepare street aName for edition...
    (convert array to ordered collection...)"

    | array |
    array := self streets at: aName ifAbsent: [^self].
    array isArray ifFalse: [^self].
    self streets at: aName put: array asOrderedCollection.!
remove: aStreetName
    "Removes aStreetName..."

    streets removeKey: aStreetName ifAbsent: [^self].
    self resort.! 
rename: aStreetName to: newName
    "Rename aStreetName..."

    (newName = aStreetName
    or: [ (streets includesKey: aStreetName) not ]) ifTrue: [^self].

   streets
        at: newName
        put: (streets at: aStreetName);
        removeKey: aStreetName ifAbsent: [].
    self resort.! 
resort
    "Private - Force Re-build of  the receiver's indexes"

    index := nil.!   
size
    "Returns the receiver's size as number of streets"

    ^self streets size!   
street: aName
    "Returns aStreetPath named aName
     prepared to be edited (or nil if absent)"

    self prepareForEdition: aName.
    ^self streetNamed: aName!  
streetNamed: aName
    "Returns aStreetPath named aName (or nil if not found)"

    ^self streetNamed: aName ifAbsent: []! 
streetNamed: aName ifAbsent: aBlock
    "Returns aStreetPath named aName"

    ^self streets at: aName ifAbsent: aBlock!   
streets
    "Returns the instance var of the receiver
     for external manipulation"
    ^streets!
validate
    "Private - Check for address name inconsistences.
    StreetNet allInstances do: [:each| each validate ].
    "

    | paths names count |
    streets associationsDo: [:asoc|
        paths := asoc value select: [:each| each name notNil ].
        paths do: [:each| each name: each name ].
        paths size > (paths collect: [:each| each name]) asSet size
        ifTrue: [ "has duplicates"
            count := 0.
            paths do: [:each|
                each name = 's/n'
                ifTrue: [
                    count > 0 ifTrue: [ each name: each name, count printString ].
                    count := count + 1
                ]
            ]
        ]
    ]! !

! StreetReference class methods !  
fromStream: stream
    "Must return an instance of the receiver from aStream
    (in text format)..."

    ^self new fromStream: stream! !

! StreetReference methods ! 
boundingBox
    " Returns the boundingBox for the receiver..."

    ^self implementedBySubclass!   
fileOutOn: aStream
    "Files Out the receiver's contents in text format
    into aStream..."

    ^self implementedBySubclass!   
fromStream: stream
    "Must return an instance of the receiver from aStream
    (in text format)...
    Or nil if failed..."

    ^self implementedBySubclass!  
holdsNumber: aNumber
    "Returns true if the receiver can return
    a point representing the address for number aNumber"

    ^false "refined by subclasses..."!
isPath
    "Default answer is false..."
    ^false! 
isValid
    "Default answer is true..."
    ^true!  
name
    "Default answer is nil..."
    ^nil!   
pointForNumber: aNumber
    "Returns the location for an address with number aNumber"

    ^self implementedBySubclass! !

! LumiAddress class methods ! 
addressFor: aString
    "Sets returns a collection address of the receiver if it is a valid address.
    Returns nil if failed..."
    | result plane letter number stream |
    stream := ReadStream on: aString.
    stream atEnd ifTrue: [^nil].

    plane := stream upTo: $-.
    (plane detect: [:c| c isDigit not ] ifNone: []) notNil ifTrue: [^nil].
    plane := plane asInteger.
    stream atEnd ifTrue: [^nil].

    letter := stream next asUpperCase.
    "try to correct more common errors..."
    (#($L $| $1) includes: letter) ifTrue: [letter := $I].
    (letter between: $A and: $I) ifFalse: [^nil].
    stream atEnd ifTrue: [^nil].

    stream upTo: $-.
    number := (stream upTo: nil) asInteger.
    (number between: 1 and: 6) ifFalse: [^nil].

    ^Array with: plane with: letter with: number!  
boundingBoxFor: anAddress
    "Private - Returns the boundingBox (in pixels) for anAddress
     computed from Settings...
        LumiAddress boundingBoxFor: '40-c-2'
    "

    |  x y u v table box displacement result |
    anAddress isNil ifTrue: [ ^0@0 ].
    anAddress isString "convert it to an address array..."
    ifTrue: [ ^self boundingBoxFor: (self addressFor: anAddress) ].
    y := x := 0.
    u := anAddress last - 1.
    v := (anAddress at: 2) asciiValue - $A asciiValue.
    table := self pageScheme.
    1 to: table size do: [:i|
        ((table at: i) includes: anAddress first)
        ifTrue: [
            y := i.
            x:= (table at: i) indexOf: anAddress first.
        ]
    ].
    box := self pageExtent / (6@9).
    displacement := u @ v * box.
    result := x @ y - 1 * self pageExtent + displacement.
    ^(result "- (box // 2)" extent: box) truncated!
fromStream: stream
    "Must return an instance of the receiver from aStream
    (in text format)..."

    | addr |
    addr := String new.
    [stream atEnd not and: [stream peek isSeparator not]]
     whileTrue: [ addr := addr , (String with: stream next) ].
    stream atEnd ifTrue: [ stream reset ].
    ^self name: addr address: (stream upTo: nil) trimBlanks.!
initializeSettings
    "Private - Initializes the receiver's settings dictionary"

    | profiler |
    profiler := self profiler.
    Settings := Dictionary new.
    profiler pathName: (PathFinder locationFor: (
        (profiler
            at: 'Data'
            ifAbsent: [
                self error: 'Falta entrada "Data" en grupo ['
                    ,self name,'] en ',profiler pathName
            ]))).

    self initializeSettings: profiler!  
initializeSettings: profiler
    "Private - Initializes the receiver's settings using data in a profiler"

    | level pages keys line set value |
    profiler applicationName: 'Page Scheme'.
    set := [:key|
        line := profiler at: key ifAbsent: [
            self error: 'Falta seteo de ',key,' en archivo ', profiler pathName
        ].
        Settings at: key put: line asInteger
    ].

    set
        value: 'pageWidth';
        value: 'pageHeight';
        yourself.

    keys := profiler keys collect: [:each| each asInteger ].
    pages := OrderedCollection new.
    level := 0.
    [ level := level + 1.
      keys includes: level ] whileTrue: [
        line := profiler at: level asString.
        line := line asArrayOfSubstrings collect: [:each| each asInteger ].
        pages addLast: line.
    ].
    Settings at: 'Page Scheme' put: pages! 
name: aName address: aString
    "Returns an initialized instance of the receiver"

    ^self new
        name: aName;
        address: aString;
        yourself!  
pageExtent
    "Private - Returns the page settings"

    ^(self settings at: 'pageWidth')
        @ (self settings at: 'pageHeight')!
pageScheme
    "Private - Returns the page scheme"

    ^self settings at: 'Page Scheme' ifAbsent: [#()]!  
settings
    "Private - Returns the receiver's settings dictionary"

    Settings size = 0 ifTrue: [ self initializeSettings ].
    ^Settings! !

! LumiAddress methods !   
address
    "Returns the instance var of the receiver
     for external manipulation"
    ^address!
address: aString
    "Sets the address of the receiver if it is a valid address.
    Returns nil if failed..."

    ^address := self class addressFor: aString!   
boundingBox
    " Returns the boundingBox for the receiver..."

    ^self class boundingBoxFor: self address!  
fileOutOn: aStream
    "Files Out the receiver's contents in text format
    into aStream..."

    aStream
        nextPutAll: name trimBlanks;
        tab.
    address do: [:key|
        key == address first
        ifFalse: [ aStream nextPut: $- ].
        aStream nextPutAll: (key isNumber
            ifTrue: [key printString] ifFalse: [String with: key])
    ].!   
holdsNumber: aNumber
    "Returns true if the receiver can return
    a point representing the address for number aNumber"

    | stream |
    stream := ReadStream on: self name.
    ^aNumber
        between: stream nextWord asInteger
        and: stream nextWord asInteger!
isValid
    "Returns true if the receiver is valid..."

    ^address notNil!   
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!  
name: aString
    "Sets the instance var of the receiver.
    Check for a minimum of 5 characters
     previous to first $- (if present...)"

    (aString isString and: [
        (aString indexOf: $-) between: 1 and: 4 ])
    ifTrue: [ ^self name: ' ',aString].

    name := aString!  
pointForNumber: aNumber
    "Returns the location for an address with number aNumber"

    ^self boundingBox center!   
printOn: aStream
    "Outputs the receiver to aStream."

    super printOn: aStream.
    aStream
        nextPutAll: '[',self name;
        space;
        nextPutAll: self address printString,']'.! !

! StreetNote methods !  
boundingBox
    " Returns the boundingBox for the receiver..."
    ^nil!
contents
    "Returns the instance var of the receiver
     for external manipulation"
    ^contents!  
contents: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    contents := anObject! 
fileOutOn: aStream
    "Files Out the receiver's contents in text format
    into aStream..."

    aStream nextPutAll: contents!  
fromStream: aStream
    "Private - FilesIn the receiver from aStream.
    Returns nil if failed..."

   self contents: (aStream upTo: nil) trimBlanks!
initialize
    "Private - Initialize the receiver"

    super initialize.
    contents := String new.! !

! StreetPath class methods !  
autoIncrementValue
    "Returns the default autoincrement for address numbers..."

    AutoIncrementValue isNil ifTrue: [ AutoIncrementValue := 1000 ].
    ^AutoIncrementValue!  
autoIncrementValue: aValue
    "Set the default autoincrement for address numbers..."

    AutoIncrementValue := aValue! !

! StreetPath methods !   
, aStreetPath
    "Append aStreetPath to the receiver in a new instance..."

    | copy |
    copy := self copy.
    copy addAll: aStreetPath.
    ^copy!   
addAll: aStreetPath
    "Append aStreetPath to the receiver..."

    | point number |
    1 to: aStreetPath size do: [:i|
        point := aStreetPath at: i.
        number := aStreetPath numbers at: i.
        self
            addLast: point;
            at: self size putNumber: number
    ].! 
addFirst: aPoint
    "Add aPoint to the receiver at first position..."

    numbers addFirst:
        (numbers isEmpty
        ifTrue: [1]
        ifFalse: [ numbers first - self class autoIncrementValue ]).
    ^path addFirst: aPoint.!   
addLast: aPoint
    "Append aPoint to the receiver..."

    numbers addLast:
        (numbers isEmpty
        ifTrue: [1]
        ifFalse: [ numbers last + self class autoIncrementValue ]).
    ^path addLast: aPoint.!  
at: index
    "Delegates functionality to path to satisfy collection protocoll"

    ^path at: index!  
at: index put: aPoint
    "Delegates functionality to path to satisfy collection protocoll"

    ^path at: index put: aPoint!  
at: index putNumber: aNumber
    "Place aNumber associated with point at index position"

    ^numbers at: index put: aNumber! 
boundingBox
    " Returns the boundingBox for the receiver..."

    | x y u v |
    path isEmpty ifTrue: [^0@0 extent: 0@0].
    x := u := path first x.
    y := v := path first y.
    path do: [:aPoint|
        x := x min: aPoint x.
        y := y min: aPoint y.
        u := u max: aPoint x.
        v := v max: aPoint y.
    ].
    ^x@y rightBottom: u@v!
collect: aBlock
    "Delegates functionality to path to satisfy collection protocoll"

    ^path collect: aBlock!  
copy
    "Returns a copy of the receiver..."

    ^self deepCopy!  
copyFrom: start to: stop
    "Returns a copy of the receiver from start to stop..."

    ^self species new
        path: (path copyFrom: start to: stop)
        numbers: (numbers copyFrom: start to: stop)!
copyWith: aPoint
    "Returns a copy of the receiver with aPoint appended to end..."

    | copy |
    copy := self copy.
    copy addLast: aPoint.
    ^copy!  
do: aBlock
    "Delegates functionality to path to satisfy collection protocoll"

    ^path do: aBlock!
fileOutOn: aStream
    "Files Out the receiver's contents in text format
    into aStream..."

    | count |
    count := path size.
    aStream
        nextPutAll: count printString;
        tab.
    1 to: count do: [:i|
        aStream
            space;nextPutAll: (numbers at: i) printString;
            space;nextPutAll: (path at: i) x printString;
            space;nextPutAll: (path at: i) y printString;
            yourself
    ]!   
first
    "Delegates functionality to path to satisfy collection protocoll"

    ^path first!  
firstNumber
    "Returns the first number..."

    ^numbers first! 
fromStream: aStream
    "Private - FilesIn the receiver from aStream.
    Returns nil if failed..."

    | count nextNumber |
    nextNumber := [
        [aStream peek isSeparator] whileTrue: [aStream next].
        (aStream upTo: $ ) asInteger
    ].
    count := nextNumber value.
    count timesRepeat:[
        numbers addLast: nextNumber value.
        path
            addLast: nextNumber value
                @ nextNumber value
    ].!
holdsNumber: aNumber
    "Returns true if the receiver can return
    a point representing the address for number aNumber"

    | interval |
    self isEmpty ifTrue: [^false].
    interval := self interval.
    ^aNumber between: interval first and: interval last!
indexOf: aPoint
    "Delegates functionality to path to satisfy collection protocoll"

    ^path indexOf: aPoint!  
initialize
    "Private - Initialize the receiver"

    super initialize.
    path := OrderedCollection new.
    numbers := OrderedCollection new.!  
interval
    "Private - Returns a sorted collection for valid addresses"

    ^self numbers asSortedCollection!
isEmpty
    "Delegates functionality to path to satisfy collection protocoll"

    ^path isEmpty!  
isPath
    "Yes, Yes,  the receiver is a path object..."
    ^true! 
last
    "Delegates functionality to path to satisfy collection protocoll"

    ^path last!
lastNumber
    "Returns the last number..."

    ^numbers last!
numberAt: index
    "Returns the number at index position (or nil if out of bounds)"

    (index between: 1 and: numbers size) ifFalse: [^nil].
    ^self numbers at: index!  
numberFor: aPoint
    "Returns the number associated with aPoint (or nil if not present)"

    ^self numberAt: (self indexOf: aPoint)! 
numberFor: aPoint is: aNumber
    "Sets the number associated with aPoint"

    ^self
        at: (self indexOf: aPoint)
        putNumber: aNumber! 
numbers
    "Returns the instance var of the receiver
     for external manipulation"
    ^numbers!
path
    "Returns the instance var of the receiver
     for external manipulation"
    ^path!  
path: thePath numbers: theNumbers
    "Private - Set the receiver with new collections"

    path := thePath.
    numbers := theNumbers.! 
pointForNumber: aNumber
    "Returns the location for an address with number aNumber"

    | interval last lo hi |
    interval := self interval.
    self isEmpty ifTrue: [ ^nil ].
    (aNumber between: interval first and: interval last)
    ifFalse: [ "invalid address number"
        aNumber < interval first ifTrue: [ ^self pointForNumber: interval first ].
        aNumber > interval last ifTrue: [ ^self pointForNumber: interval last ].
        ^nil "ouch... que paso?"
    ].

    last := interval first.
    interval do: [:each|
        each = aNumber
        ifTrue: [ ^self at: (self numbers indexOf: each) ].
        each > aNumber
        ifTrue: [ "interpolate address..."
            lo := self at: (self numbers indexOf: last).
            hi := self at: (self numbers indexOf: each).
            ^((hi - lo) * (aNumber - last) / (each - last) + lo) truncated
        ].
        last := each.
    ].

    ^nil "what happen?"! 
points
    "Returns the instance var of the receiver
     for external manipulation"
    ^path!
remove: aPoint
    "Remove aPoint..."

    ^self remove: aPoint ifAbsent: []!  
remove: aPoint ifAbsent: aBlock
    "Removes aPoint and it's number reference..."

    | index |
    index := path indexOf: aPoint.
    index > 0 ifFalse: [^aBlock value].
    numbers := (numbers copyFrom: 1 to: index - 1),
         (numbers copyFrom: index + 1 to: numbers size).
    ^path remove: aPoint ifAbsent: aBlock.!  
size
    "Delegates functionality to path to satisfy collection protocoll"

    ^path size! !

! Information class methods ! 
descriptions
    "Returns a dictionary with all information classes for keys and its descriptions as values.
    This descriptions are obtained from profiler..."

    | profiler result description |
    profiler := Information profiler. "force to use the profiler of Information..."
    result := Dictionary new.
    self withAllSubclasses do: [:each|
        description := profiler at: each name ifAbsent: [].
        (description notNil and: [(description trimBlanks = 'ABSTRACTA') not])
        ifTrue: [ result at: each put: description ].
    ].
    ^result!  
editor
    "Returns the dialog for editing the receiver's instances"
    ^InformationDialog!
fromUser
    "Returns a new instance obtained from class selected by the user (or nil)..."

    | descriptions selected |
    descriptions := self descriptions.
    selected := ListDialog new
        title: 'Seleccione el tipo de informacin que desea usar...';
        openOn: descriptions values asSortedCollection.
    selected isNil ifTrue: [ ^nil ].
    ^(descriptions keyAtValue: selected) new! !

! Information methods !
address
    "Returns the instance var of the receiver
     for external manipulation"
    ^address isString ifTrue: [ address withCrs ]!   
address: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    address := anObject!   
description
    "Returns a short description of the receiver"

    | description tab |
    tab := String with: Space with: Tab with: Space.
    description := name.
    address size = 0 ifFalse: [ description := description ,tab,address asString ].
    phone size = 0 ifFalse: [ description := description ,tab,phone asString ].
    ^description!
edit
    "Edit the receiver"

    | editor |
    editor := self class editor new.
    editor information: self.
    "self model openView: editor"
    editor open.!
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!  
name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject! 
phone
    "Returns the instance var of the receiver
     for external manipulation"
    ^phone!
phone: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    phone := anObject!   
position
    "Returns the instance var of the receiver
     for external manipulation"
    ^position!  
position: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    position := anObject! 
printOn: aStream
    "Output the receiver in ascii format to aStream."

    name isNil
    ifTrue: [
        aStream space;nextPutAll: 'sin nombre'.
        aStream nextPutAll: ' [', self class name ,']'.
    ]
    ifFalse: [
        aStream space; nextPutAll: name.
        address notNil ifTrue: [ aStream next: 4 put: $ ;nextPutAll: address ].
        phone notNil ifTrue: [ aStream next: 4 put: $ ;nextPutAll: phone ].
    ].!
run
    "Run the receiver's...
    Default action is to display information..."

    | stream |
    stream := WriteStream on: String new.
    self name size > 0 ifTrue: [
        stream nextPutAll: self name;cr
    ].
    self address size > 0 ifTrue: [
        stream nextPutAll: self address;cr
    ].
    self phone size > 0 ifTrue: [
        stream nextPutAll: self phone;cr
    ].
    stream contents isEmpty ifTrue: [ ^nil ].
    MessageBox message: stream contents! !

! ChildMapInformation class methods !   
editor
    "Returns the dialog for editing the receiver's instances"
    ^ChildMapInformationDialog! !

! ChildMapInformation methods !   
childMap
    "Returns the instance var of the receiver
     for external manipulation"
    ^childMap!  
childMap: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    childMap := anObject! 
run
    "Run the receiver's...
    Default action is to display information..."

    self model fileOpen: self childMap! !

! MultimediaInformation class methods ! 
editor
    "Returns the dialog for editing the receiver's instances"
    ^MultimediaInformationDialog! !

! MultimediaInformation methods !   
pathName
    "Returns the instance var of the receiver
     for external manipulation"
    ^pathName!  
pathName: aPathName
    "Sets the receiver's pathName to a symbolic pathName"

    pathName := aPathName size > 0
        ifTrue: [ PathFinder nameFor: aPathName ].! 
run
    "Run the receiver's...
    Open the program associated with the receiver..."

    pathName size = 0 ifTrue: [ ^super run ].
    self run: (PathFinder locationFor: self pathName trimBlanks)!
run: commandLine
    "Private - Run the program associated with commandLine..."

    ProgramManager run: commandLine! !

! AudioInformation methods !
run: commandLine
    "Private - Play the audio associated with commandLine.
        (can be one windows system sound name like asterisk,etc -in win.ini-)"

    MMSystemDLL library
        sndPlaySound: commandLine asParameter
        flags: SndAsync! !

! ImageInformation methods !
run: commandLine
    "Private - Open a PhotoView on the file named commandLine"

    | view |
    view := PhotoViewManager new.
    view pathName: commandLine.
    self model openView: view.
    view label: self name.! !

! NoteInformation class methods !  
editor
    "Returns the dialog for editing the receiver's instances"
    ^NoteInformationDialog! !

! NoteInformation methods !   
contents
    "Returns the instance var of the receiver
     for external manipulation"
    ^contents!  
contents: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    contents := anObject! 
run
    "Run the receiver's...
    Default action is to display information..."

    self contents isNil ifTrue: [ ^super run ].
    MessageBox
        titled: name
        withText: contents asString
        style: MbOk | MbIconinformation! !

! LayerScanner class methods ! 
scan: aLayerSpecFile for: aMap
    "Scan file named aLayerSpectFile for data to be filedIn aMap"

    | file |
    (File exists: aLayerSpecFile)
    ifFalse: [
        UserLibrary messageBeep: 0.
        (MessageBox confirm: 'El archivo ',aLayerSpecFile,' no existe o no est disponible para lectura.\Desea continuar ?' withCrs)
        ifTrue: [^self].
        self error: 'Archivo ',aLayerSpecFile,' no disponible.'.
    ].
    file := File pathNameReadOnly: aLayerSpecFile.
    self new
        stream: file;
        map: aMap;
        scan.
    file close! !

! LayerScanner methods !
category: aString
    "Creates or select a category"

    category := aString! 
columns
    "Returns the instance var of the receiver
     for external manipulation"
    ^columns!
columns: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    columns := anObject!   
currentPosition
    "Private - Returns the current receiver's position"

    formula size = 0 ifTrue: [ ^self defaultPosition ].
    ^self evaluate: formula ifFail: [ self error: 'Formula errnea...\'withCrs,formula asString ]!   
defaultPosition
    "Private - Returns the current receiver's position
    computed from a default formula"

    | xPos yPos zOrder |
    xPos := self ordinalValueFor: x.
    yPos := self ordinalValueFor: y.
    zOrder := self rectFor: z.
    zOrder isNil ifTrue: [^xPos @ yPos]. "page does not exists..."
    ^xPos @ yPos
        / (columns@rows) * zOrder extent    "scale to page..."
        + zOrder origin     "translate to page origin"!  
dumpPagesInto: aStream
    "Private - Dump receiver's pages into aStream..."

    self pages isEmpty ifTrue: [^self].

    aStream
        cr;
        cr;nextPutAll: '"Posicin de las pginas (coord. z)"';
        cr;nextPutAll: '  pages := Dictionary new.';
        cr;nextPutAll: '  pages' withCrs.
    self pages keysDo: [:key|
        aStream cr;nextPutAll: '    at: '.
        key storeOn: aStream.
        aStream nextPutAll: ' put: (',(self pages at: key) asString.
        aStream nextPutAll: ');'
    ].
    aStream
        cr;nextPutAll: '   yourself.';
        nextChunkPut: String new.!  
evaluate: source ifFail: aBlock
    "Private - Evaluates source in the receiver"
    | result |
    result := Compiler
        evaluate: source
        in: self class
        to: self
        notifying: Transcript
        ifFail: aBlock.
    ^result!   
fileIn: aLayerSpecFile
    "Private - Get the receiver's Specification from file..."

    | file |
    aLayerSpecFile size = 0 ifTrue: [^nil].
    (File exists: aLayerSpecFile)
    ifFalse: [
        UserLibrary messageBeep: 0.
        (MessageBox confirm: 'El archivo ',aLayerSpecFile,' no existe o no est disponible para lectura.\Desea continuar ?' withCrs)
        ifTrue: [^self].
        self error: 'Archivo ',aLayerSpecFile,' no disponible.'.
    ].
    file := File pathNameReadOnly: aLayerSpecFile.
    [ file atEnd ] whileFalse: [
        self evaluate: file nextChunk ifFail: [ self error: 'Lectura de ',aLayerSpecFile,' fallida...' ]
    ].
    file close.!
fileOut: aString
    "Save the receiver's Specification to file aString..."

    | file |
    aString size = 0 ifTrue: [^nil].
    file := File newFile: aString.

    file
        cr;nextPutAll: '"    Private - Seteos para el intrprete de capas de texto...';
        cr;nextPutAll: '    Configuracin para carga automtica de Informacin.';
        cr;nextPutAll: '    @',Date today asString,' ',Time now asString, ' "';
        nextChunkPut: String new.

    file
        cr;
        cr;nextPutAll: '"Nombre de la clase de instancias a crear"';
        cr;nextPutAll: '  self instanceClass:' ,instanceClass asString;
        nextChunkPut: String new.

    file
        cr;
        cr;nextPutAll:'"Componentes de las tablas (selector,tipo)"';
        cr;nextPutAll: '  self variables:', self variablesString printString;
        nextChunkPut: String new.

    file
        cr;
        cr;nextPutAll:'"Cuadriculado de cada pgina."';
        cr;nextPutAll: '  self rows:' ,rows asString,';columns:',columns asString;
        nextChunkPut: String new.

    file
        cr;
        cr;nextPutAll:'"Formula a utilizar para calcular posicionamiento de los objetos"';
        cr;nextPutAll: '  self formula:',formula printString;
        nextChunkPut: String new.

    self dumpPagesInto: file.

    file close.!   
formula
    "Returns the instance var of the receiver
     for external manipulation"
    ^formula!
formula: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    formula := anObject!   
getCommand
    "Private - Scan the stream looking for a command..."

    | command selector argument message |

    command := stream nextLine asStream.

    selector := (command upTo: $:) trimBlanks,':'.
    selector isEmpty ifTrue: [^nil].

    argument := (command upTo: nil) trimBlanks.
    (argument notEmpty and: [argument first = $!!])
    ifTrue: [
        argument := Compiler evaluate: (argument copyFrom: 2 to: argument size)
    ].

    selector := selector asSymbol.
    message := Message new.
    message
        receiver: (
            (self respondsTo: selector)
              ifTrue: [self]
              ifFalse: [ currentLayer ]);
        selector: selector;
        arguments: (Array with: argument);
        yourself.

    message perform.! 
getInformation
    "Private - Scan the stream looking for information...
    Information must contain rows separated by Tabs in a line.
    The number of rows must be variables size + 3 (for x,y and z).
    first filed must be not-empty."

    | line instance position |
    line := stream nextLine asStream.
    line atEnd ifTrue: [^self].
    instance := instanceClass new.

    variables do: [:asoc|
        instance
            perform: asoc key
            with: (self valueFor: (line upTo: Tab) type: asoc value)
    ].

    x := line upTo: Tab.
    y := line upTo: Tab.
    z := line upTo: Tab.

    (Notifier isAltDown annd: [Smalltalk isRunTime not]) ifTrue: [ self halt ].
    position := self currentPosition.

    currentLayer
        add: instance
        at: position
        type: category!  
initialize
    "Private - Initialize the receiver..."

    super initialize.
    variables := OrderedCollection new.
    self instanceClass: Information.
    formula := currentLayer := category := nil.
    rows := columns := 5.!   
instanceClass
    "Returns the instance var of the receiver
     for external manipulation"
    ^instanceClass!
instanceClass: aClass
    "Sets the class of node informations.
     Update the variables with aClass..."

    instanceClass := aClass.
    self resetVariables.!
layer: aString
    "Creates and select a new layers"

    currentLayer := map layers
        detect: [:each| each name = aString ]
        ifNone: [ map newLayer: aString ].

    category := nil.!   
map: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    map := anObject!   
ordinalValueFor: aString
    "Private - Returns the ordinal value for aString"

    aString isEmpty ifTrue:[^0].
    aString first isDigit ifTrue: [ ^aString asInteger ].
    ^aString first asUpperCase asciiValue - 64!   
page: page file: file column: column
    "Private - Sets the receiver's values..."

    x := column.
    y := file.
    z := page.!  
pages
    "Returns the instance var of the receiver
     for external manipulation."

    pages isNil ifTrue: [ pages := Dictionary new].
    ^pages!
peekToken
    "Private - Returns the next available token (or nil)..."

    self skipSeparators.
    stream atEnd ifTrue: [^nil].

    ^stream peek!
readPagesFrom: aString
    "Private - Get the receiver's offsets from file named aString..."

    | dict |
    aString size = 0 ifTrue: [^nil].
    (File exists: aString) ifTrue: [
        dict := ObjectFiler loadFromPathName: aString
    ].
    dict isNil ifTrue: [^self].
    dict keysDo: [:key|
        self pages at: key put: (dict at: key)
    ].!   
rectFor: aString
    "Private - Get the receiver's rectangle for page named aString or an empty rectangle..."

    ^self pages at: aString ifAbsent: []!   
resetVariables
    "Private - Rebuild receiver's variables from current instanceClass"

     | dict selector |
    dict := Dictionary new.
    self variables do: [:asoc|
        dict at: asoc key put: asoc value
    ].
    self instanceClass allInstVarNames
    do: [:var|
        selector := (var,':') asSymbol.
        dict at: selector
            ifAbsent: [
                dict at: selector put: String
            ]
    ].
    self variables: (
        dict keys asSortedCollection asOrderedCollection
        collect: [:each| Association key: each value: (dict at: each)]).!  
rows
    "Returns the instance var of the receiver
     for external manipulation"
    ^rows!  
rows: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    rows := anObject! 
scan
    "Private - Scan the receiver's contents..."

    | token |
    [stream atEnd] whileFalse: [
        token := self peekToken.
        token = $; ifTrue: [ stream nextLine ] "skip comment..."
        ifFalse: [
            token = $!! "expresion..."
            ifTrue: [
                stream next.
                self getCommand
            ]
            ifFalse: [ self getInformation ]
        ]
    ]!
skipSeparators
    "Private - Answer the next non-blank character,else answer nil."
    | c |
    [stream atEnd] whileFalse: [
        c := stream peek.
        c isSeparator
        ifTrue: [ stream next ]
        ifFalse: [ ^c]
    ].! 
stream: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    stream := anObject! 
valueFor: aString type: aClass
    "Private - Returns the value for aString"

    aString isNil ifTrue:[^nil].
    aClass == String ifTrue: [ ^aString trimBlanks ].
    ^aClass fromString: aString!
variables
    "Returns the instance var of the receiver
     for external manipulation"
    ^variables!
variables: argument
    "Private - Sets the variables for reading data into the receiver..."

    | spec selector type |

    argument isString ifFalse: [ "else must be a collection..."
        variables := argument.
        ^self
    ].

    "Scan the string for receiver's variables..."
    variables := OrderedCollection new.
    spec := argument asStream.
    [spec atEnd] whileFalse: [
        selector := ((spec upTo: $:) trimBlanks,':') asSymbol.
        type := Smalltalk at: (spec upTo:$ ) asSymbol.
        variables add: (Association key: selector value: type)
    ]!   
variablesString
    "Private - Returns the variables string representation..."

    | output |
    output := WriteStream on: String new.
    variables do: [:asoc|
        output
            space;
            nextPutAll: asoc key;
            nextPutAll: asoc value asString
    ].
    ^output contents! !

! LumiMapper methods !
boundingBoxOfCell: aString
    " Private - Returns the bounding box for cell determined by aString.
    Returns nil if failed. Box units are in Lumi coordinates..."

    ^LumiAddress boundingBoxFor: aString!   
displacement
    "Returns the instance var of the receiver
     for external manipulation"
    ^displacement!  
displacement: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    displacement := anObject! 
initialize
    " Private - Initializes the receiver..."

    super initialize.
    displacement := 0@0.
    scale := 1@1.
    rotationAngle := 0.!  
leftTopOfCell: aString
    " Private - Returns the leftTop position of box for cell determined by aString.
    Returns nil if failed. Returned point is in map coordinates..."

    | box |
    box := self boundingBoxOfCell: aString.
    ^box notNil ifTrue: [ self lumi2Map: box leftTop ]! 
lumi2Map: aPoint
    " Private - Returns aPoint in map coordinates from a point in lumi coordinates...
    if aPoint is nil returns nil..."

    | point |
    ^aPoint notNil ifTrue: [
        point := aPoint - displacement * scale.
        (point x * rotationAngle cos + (point y * rotationAngle sin)
        @ (point x * rotationAngle sin + (point y * rotationAngle cos))) truncated
    ]!   
rotationAngle
    "Returns the instance var of the receiver
     for external manipulation"
    ^rotationAngle!
rotationAngle: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    rotationAngle := anObject!   
rotationDegrees: angle
    "Sets the rotation angle to angle degrees..."

    ^self rotationAngle: angle degreesToRadians! 
scale
    "Returns the instance var of the receiver
     for external manipulation"
    ^scale!
scale: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    scale := anObject! !

! MapableArea methods !  
beCuadrant: anInteger of: aGrid
    "Makes the receiver be anInteger cuadrant of aGrid."

    | newOrigin newExtent |

"Set the spatial coordinates of the receiver."
    newOrigin := aGrid origin copy.
    newExtent := aGrid extent / 2.
    anInteger < 3
                    ifTrue: [ newOrigin := newOrigin right: newExtent x ].
    (anInteger = 2 or: [ anInteger = 3 ])
                    ifTrue: [ newOrigin := newOrigin down: newExtent y ].
    self origin: newOrigin extent: newExtent.!  
boundingBox
    "Returns the receiver's bounding box"

    boundingBox notNil ifTrue: [ ^boundingBox ].

    "the receiver must recompute the boundingBox value..."
    self computeBoundingBox.
    ^boundingBox := boundingBox truncated!
boundingBox: aRectangle
    "Set the receiver's bounding box"

    aRectangle isNil ifTrue: [^boundingBox := nil].
    self origin: aRectangle origin extent: aRectangle extent.
    ^aRectangle!
center
    "Answer the center of the receivers rectangle."

    ^self boundingBox center!  
computeBoundingBox
    "Private - Build the receiver's bounding box.
    This method can be refined by subclasses..."

   self boundingBox: self defaultRectangle!
corner
    "Answer the corner of the receivers rectangle."

    ^self boundingBox corner!  
defaultRectangle
    "Private - Returns the default rectangle for the receiver."

    ^-1@-1 extent: 0@0!  
elements
    "Returns the instance var of the receiver
     for external manipulation"
    ^elements!  
elementsInRectangle: aRectangle
    "Answer a collection of elements that are included in aRectangle."

    | answer |
    answer := Set new.
    self withElementsInRect: aRectangle do: [:each| answer add: each ].
    ^answer!  
expandTo: aPoint
    "Expands the receiver's boundingBox to include aPoint"
    | box |
    box := self boundingBox.
    (box containsPoint: aPoint) ifTrue: [^self].

    self boundingBox: (
        (box left min: aPoint x) @ (box top min: aPoint y)
        corner: (box right max: aPoint x) @ (box bottom max: aPoint y) )!   
extent
    "Returns the extent of the receivers rectangle"

    ^self boundingBox extent!  
extent: aPoint
    "Sets the extent of the receivers rectangle to aPoint"

    self boundingBox extent: aPoint.!   
height
    ^self extent y!   
initialize
    "Private - Initializes the receiver."

    super initialize.
    boundingBox := self defaultRectangle.
    elements := OrderedCollection new.!
isRoute
    "True if the receiver is an Object of a route"
    ^false!  
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name isNil
        ifTrue: [ 'a ',self class name]
        ifFalse: [ name ]!
name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject! 
origin
    "Returns the origin var of the receivers rectangle."

    ^self boundingBox origin! 
origin: aPoint
    "Sets the origin of the receivers rectangle to aPoint."

    self boundingBox origin: aPoint.!  
origin: point1 extent: point2
    "Sets the origin and extent of the receivers rectangle."

    boundingBox := point1 extent: point2.! 
width
    ^self extent x!
withElementsInRect: aRectangle do: aBlock
    "Evaluates aBlock with the elements that are included in aRectangle.
     aBlock must be a oneParam block.
     The argument for evaluation will be the current element.
    Returns the receiver.
    Implemented by Ale..."

    self implementedBySubclass! !

! Cell class methods !   
maxDensity
    "Answer the maximum 'cell element' count."

    ^3! 
minExtent
    "Answer the minimum cell size."

    ^2 @ 2! !

! Cell methods !   
add: anElement
    "Adds anElement to the collection of the receiver."

    | answer |

    ((self elements size >= self class maxDensity)
        and: [ self boundingBox extent > self class minExtent ])
        ifTrue: [ answer := self elements add: anElement.
                        self become: self asGrid ]
        ifFalse: [ answer := self elements add: anElement ].
    ^answer!  
asGrid
    "Divides the receiver into four sub-grids.
    Answer the grid that composes the receiver."

    | grid cuadrants |

    grid := Grid new.
    grid origin: self origin extent: self extent.
    self elements do: [ :anElement |
        grid add: anElement ].
    ^grid!  
basicAdd: anID
    "Adds anID to the collection of IDs present in the receiver."

    elements := elements, (Array with: anID).
    ((elements size >= self class maxDensity)
        and: [ self boundingBox extent > self class minExtent ])
        ifTrue: [ self become: self asGrid ]!
basicElements
    "Answer all the elements in the receiver."

    ^elements!   
cuadrantsWithSegment: aSegArray
    "Answers a collection of cuadrants that are intersected by the
    line  described by the two points in aSegArray."

    (self boundingBox intersectsLine: (aSegArray at: 1) to: (aSegArray at: 2))
        ifTrue: [ ^Array with: self ].
    ^nil!
display: gridRectangle in: destRect with: aPen
    "Outputs the receiver's gridRectangle in destRect thru aPen."

    | scale myRect |

    scale := destRect extent / gridRectangle extent.
    myRect := self boundingBox.
    aPen drawRectangle: (myRect scaleBy: scale) truncated.!   
do: aBlock
    "Iterates over the elements of the receiver"

    self elements do: aBlock! 
elements: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    elements := anObject! 
lockIDs
    "Removes the references inside the grid to the elements by
    replacing them to the element's IDs.
    * * * WARNING * * *
    This should only be done when the cell has been finished
    because NO further editing will be possible afterwards."

    self elements: (self elements collect: [ :each | each id ]) asArray!
remove: anElement
    "Removes anElement to the collection of the receiver."

    self elements remove: anElement ifAbsent: []!
withElementsInRect: aRectangle do: aBlock
    "Evaluates aBlock with the elements that are included in aRectangle.
     aBlock must be a oneParam block.
     The argument for evaluation will be the current element.
    Returns the receiver.
    Implemented by Ale..."

    self basicElements do: [:element|
        (aRectangle containsPoint: element position)
        ifTrue: [aBlock value: element]
    ].! !

! RouteCell class methods !
maxDensity
    "Answer the maximum 'cell element' count."

    ^10! !

! RouteCell methods ! 
add: aRoute
    "Adds aRoute to the collection of the receiver."

    | answer |

"    (aRoute segmentsIn: self boundingBox) isEmpty
        ifTrue: [ ^nil ]."

    (aRoute intersects: self boundingBox) ifFalse: [ ^nil ].
    answer := self elements add: aRoute.
    ((self elements size >= self class maxDensity)
        and: [ self extent > self class minExtent ])
        ifTrue: [ self become: self asGrid ].
    ^answer!
asGrid
    "Divides the receiver into four sub-grids, watching the distribution by
    area instead of the super by points..
    Answer the grid that composes the receiver."

    | grid cuadrants |

    grid := RouteGrid new.
    grid origin: self origin extent: self extent.
    self basicElements do: [ :each |
        grid add: each ].
    ^grid!  
cuadrantOf: aRoute
    "Answer a collection with self if aRoute falls in the receiver,
    else the collection will be empty."

"    ^(aRoute segmentsIn: self boundingBox) isEmpty
        ifTrue: [ #() ]
        ifFalse: [ Array with: self ]"

    ^(aRoute intersects: self boundingBox)
            ifTrue: [ Array with: self ]
            ifFalse: [ #() ]!   
elements: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    elements := anObject asSet!   
initialize
    "Private - Initializes the receiver."

    super initialize.
    elements := Set new.! 
withElementsInRect: aRectangle do: aBlock
    "Evaluates aBlock with the elements that are included in aRectangle.
     aBlock must be a oneParam block.
     The argument for evaluation will be the current element.
    Returns the receiver.
    Implemented by Ale..."

    | searchRect |
    searchRect := aRectangle intersect: self boundingBox.
    (searchRect origin isLeftAndAbove: searchRect corner)
    ifTrue: [ self basicElements do: aBlock ]
.! !

! Grid class methods !   
maxExtent
    "Answer the maximum extent that an instance can be."

    ^100 @ 100! !

! Grid methods !  
add: anElement
    "Adds anElement to the receiver."

    ^(self cuadrantOf: anElement) add: anElement!
add: aString at: aPoint typeZap: aSymbol
    "Adds a new cell element with name aString, that is located in aPoint."

    | newElem |
    (self boundingBox containsPoint: aPoint)
        ifFalse: [ ^self error: 'Fuera de los lmites de la grilla.' ].
    newElem := CellElement new.
    newElem
        name: aString;
        position: aPoint;
        type: aSymbol.
    self add: newElem!  
addLevel
    "Private - Divides the cells in the receiver into four sub-grids."

    | cuadrants |

    cuadrants := OrderedCollection new: 4.
    self cuadrantsDo: [ :each | cuadrants add: each asGrid ].
    elements := cuadrants asArray!
asGrid
    "Private - Divides the receiver into four sub-grids.
    Answer the grid that holds the subs"

    ^self!  
asRouteGrid
    "Makes the receiver handle routes instead of places."

    | allElements newGrid |

    allElements := self basicElements.
    newGrid := RouteGrid new.
    newGrid origin: self origin extent: self extent.
    allElements do: [ :each |
        newGrid add: each ].
    self become: newGrid.! 
basicElements
    "Private - Answer all the elements in the receiver."

    | answer |

    answer := OrderedCollection new.
    self cuadrantsDo: [ :each |
        answer addAll: each basicElements ].
    ^answer!
beCuadrant: anInteger of: aGrid
    "Makes the receiver be anInteger cuadrant of aGrid."

    | newElements |

    super beCuadrant: anInteger of: aGrid.

"Now add the spatial contents."
    newElements := (aGrid cuadrant: anInteger) elements select: [ :anElement |
                                anElement position between: self origin and: self corner ].
    newElements do: [ :anElement |
        self cuadrant: (self cuadrantOf: anElement) add: anElement ].!
cuadrant: anInteger
    "Answer the grid that holds the elements of anInteger cuadrant of the receiver:
         at: 4   |   at: 1
       ---------+---------
         at: 3   |   at: 2                                                                                                                  "

    ^self elements at: anInteger!  
cuadrantOf: anElement
    "Answer the cuadrant that holds anElement."

    ^self cuadrantWithPoint: anElement position!
cuadrantsDo: aBlock
    "Iterates over the cuadrants of the receiver."

    self elements do: aBlock!  
cuadrantsWithSegment: aSegArray
    "Answers a collection of cuadrants that are intersected by the
    line  described by the two points in aSegArray."

    | answer subAnswer |

    answer := OrderedCollection new.
    self cuadrantsDo: [ :aCuad |
        subAnswer := aCuad cuadrantsWithSegment: aSegArray.
        subAnswer isNil
            ifFalse: [ answer addAll: subAnswer ] ].
    ^answer! 
cuadrantWithPoint: aPoint
    "Answer the cuadrant that holds aPoint:
         at: 4   |   at: 1
       ---------+---------
         at: 3   |   at: 2                                                                                                                  "

    | center |

    ^(center := self center) y > aPoint y
        ifTrue: [ center x > aPoint x
                        ifTrue: [ self cuadrant: 4 ]
                        ifFalse: [ self cuadrant: 1 ] ]
        ifFalse: [ center x > aPoint x
                        ifTrue: [ self cuadrant: 3]
                        ifFalse: [ self cuadrant: 2 ] ]! 
defaultRectangle
    "Private - Returns the default rectangle for the receiver."

    ^0 @ 0 extent: self class maxExtent! 
display
    "Outputs the receiver to the Display"

    ^self displayWith: Display pen! 
display: gridRectangle in: destRect with: aPen
    "Outputs the receiver's gridRectangle in destRect thru aPen."

    | scale myRect |
    scale := destRect extent / gridRectangle extent.
    myRect := self boundingBox.
    aPen drawRectangle: (myRect scaleBy: scale) truncated.
    self cuadrantsDo: [ :each |
        each display: gridRectangle in: destRect with: aPen ].!
displayWith: aPen
    "Outputs the receiver thru aPen."

    | theElements scale myRect destRect |
    myRect := self boundingBox.
    destRect := aPen boundingBox.
    self display: myRect in: destRect with: aPen.
    scale := destRect extent / myRect extent.
    self
        withElementsInRect: myRect
        do: [ :each |
            each
                display: myRect
                in: destRect
                with: aPen
        ]! 
do: aBlock
    "Iterates over the elements of the receiver."

    self elements do: [ :each | each do: aBlock ]!   
elements: cellArray
    "Sets the instance var of the receiver with cellArray of four positions that
    represent each of the four cuadrants of the receiver:
         at: 4   |   at: 1
       ---------+---------
         at: 3   |   at: 2                                                                                                                  "

    1 to: 4 do: [ :x | (cellArray at: x) beCuadrant: x of: self ].
    elements := cellArray.!
extent: aPoint
    "Sets the extent of the receivers rectangle to aPoint"

    super extent: aPoint.
    self resetCuadrantsCoordinates!  
initialize
    "Private - Initializes the receiver."

    super initialize.
    self initializeCuadrants.!
initializeCuadrants
    "Private - Initializes the receiver's cuadrants."

    elements := Array new: 4.
    1 to: 4 do: [ :x |
        elements at: x put: ((Cell new) beCuadrant: x of: self; yourself) ].!
lockIDs
    "Removes the references inside the grid to the elements by
    replacing them to the element's IDs.
    * * * WARNING * * *
    This should only be done when the grid has been finished
    because NO further editing will be possible afterwards."

    self elements do: [ :each | each lockIDs ]! 
origin: aPoint
    "Sets the origin of the receivers rectangle to aPoint."

    super origin: aPoint.
    self resetCuadrantsCoordinates! 
origin: point1 extent: point2
    "Sets the origin and extent of the receivers rectangle."

    super origin: point1 extent: point2.
    self resetCuadrantsCoordinates!  
printCuadrantsOn: aStream
    "Outputs the receivers cuadrants to aStream."

    self cuadrantsDo: [ :each |
        aStream cr.
        each printOn: aStream ].
    aStream cr; nextPut: $].! 
remove: anElement
    "Removes anElement to the receiver."

    ^(self cuadrantOf: anElement) remove: anElement!   
resetCuadrantsCoordinates
    "Private - A change in the oirigin or extent of the receiver has occured.
    Reflect it in its cuadrants."

    | cole box |
    box := self boundingBox.
    cole := elements.
    self initializeCuadrants.
    cole do: [:cuadrant|
        cuadrant
            withElementsInRect: box
            do: [:element| self add: element]
    ].!  
withElementsInRect: aRectangle do: aBlock
    "Evaluates aBlock with the elements that are included in aRectangle.
     aBlock must be a oneParam block.
     The argument for evaluation will be the current element.
    Returns the receiver.
    Implemented by Ale..."

    | searchRect |
    searchRect := aRectangle notNil ifTrue: [aRectangle intersect: self boundingBox].
    (searchRect isNil or: [searchRect origin isLeftAndAbove: searchRect corner])
    ifTrue: [
        (searchRect isNil or: [searchRect = self boundingBox ])
        ifTrue: [ self basicElements do: [:each| aBlock value: each ] ]
        ifFalse: [
            self cuadrantsDo: [ :aCuad |
                aCuad withElementsInRect: searchRect do: aBlock
            ]
        ]
    ]! !

! RouteGrid methods !  
add: aRoute
    "Adds aRoute to the receiver."

    (self cuadrantOf: aRoute) do: [ :each |
        each add: aRoute ]!   
asRouteGrid
    "Makes the receiver handle routes instead of places."

    ^self!  
basicElements
    "Private - Answer all the elements in the receiver."

    ^super basicElements asSet!
canZoom: anInteger
    "Answers true if the receiver can zoom to anInteger"

    ^anInteger between: 1/8 and: 8!   
cuadrantOf: aRoute
    "Answer a collection of cuadrants that hold anElement."

    | answer aux |


    answer := Set new.
    self cuadrantsDo: [ :each |
        (aux := aRoute segmentsIn: each boundingBox) isEmpty
            ifFalse: [ answer add: each ] ].
    ^answer!  
elementsInRectangle: aRectangle
    "Return the elements inside aRectangle
    LRP 12/MAY/94
    Revisar"
    ^#()!   
initialize
    "Private - Initializes the receiver."

    super initialize.
    "Obsolete...  Ale"!   
initializeCuadrants
    "Private - Initializes the receiver's cuadrants."

    elements := Array new: 4.
    1 to: 4 do: [ :x | elements at: x put: (RouteCell new) ].

    self elements: elements.!   
isRoute
    "True if the receiver is an Object of a route"
    ^true!   
remove: aRoute
    "Removes anElement to the receiver."

    (self cuadrantOf: aRoute) do: [ :each |
        each remove: aRoute ]! !

! Layer class methods !  
editor
    "Private - Returns the editor for the receiver's instances"

    ^Smalltalk
        at: (self name,'Editor') asSymbol
        ifAbsent: []!   
maxNumberOfObjects
    " Private - returns the maximum number of objects for a layer..."

    | maxNumberOfObjects default |
    ^self
        atKey: #maxNumberOfObjects
        ifAbsent: [
            default := 100.
            maxNumberOfObjects := (self profiler at: 'maxNumberOfObjects' ifAbsent: [default]) asInteger.
            maxNumberOfObjects = 0 ifTrue: [ maxNumberOfObjects := default ].
            self
                atKey: #maxNumberOfObjects
                put: maxNumberOfObjects.
            maxNumberOfObjects
        ]!
sortBlock
    "Answer a two argument block for sorting the instances
    of the receiver depending on the level."

    ^[ :layerA :layerB | layerA level < layerB level ]!
viewClass
    "Private - Returns the receiver's view class"
    ^LayerView! !

! Layer methods !  
add: anElement at: aPoint type: aSymbol
    "Adds anElement to the category aSymbol, that is located in aPoint."

    | newElem catGrid gridLocks id position|

    self canHoldMoreObjects ifFalse: [
        ('La capa ',self name asString,' no puede contener ms objetos...')
            displayAt: 10@10.
        ^self
    ].

    self expandTo: aPoint.
    (catGrid := self categoryNamed: aSymbol) isNil
        ifTrue: [ catGrid := self addCategory: aSymbol ].
    anElement position: aPoint.
    gridLocks := catGrid class includesSelector: #lockIDs.
    gridLocks ifTrue: [
        id := self nextId.                                                          "Set the ID"
        "anElement id: id."
        self positions: (self positions),
                            (Array with: aPoint x with: aPoint y).        "Register the position"
        elements := (self elements),
                            (Array with: anElement)                          "Register the element"
    ].

    "Add it to the grid"
    catGrid add: anElement.

    numberOfObjects := self numberOfObjects + 1.!   
addCategory: gridName
    "Adds a new category to the receiver.
    Answers the newly created category."

    | newGrid |
    (newGrid := self categoryNamed: gridName) isNil ifFalse: [ ^newGrid ].
    newGrid := Grid new.
    newGrid
        name: gridName;
        origin: self origin extent: self extent.
    self boundingBox: nil.    "force to recompute boundingBox..."
    numberOfObjects := nil.
   ^self categories add: newGrid!
addDefaultCategory: aCategory
    "Adds a default categories for the receiver."

    defaultCategoryNames :=
      ((Array with: aCategory), self defaultCategories)
        collect: [:each| each name ]!   
asView
    "Returns the receiver as a View"
    ^self class viewClass on: self! 
basicElements
    "Private - Answer all the elements in the receiver."

    | answer |
    answer := OrderedCollection new.
    self categories do: [ :each |
        answer addAll: each basicElements ].
    ^answer!
canHold: anElement
    "Must return true if the receiver can hold anElement as an element"

    ^anElement isKindOf: Information!  
canHoldMoreObjects
    "Returns true if the receiver can hold more objects..."

    | maxNumberOfObjects |
    maxNumberOfObjects := self class maxNumberOfObjects.
    maxNumberOfObjects < 0 ifTrue: [ ^true ].
    ^maxNumberOfObjects >= self numberOfObjects!  
canZoom: anInteger
    "Answers true if the receiver can zoom to anInteger"

    ^anInteger between: 1/8 and: 8!   
categories
    "Returns the dictionary of categories present in the receiver."
    ^categories! 
categories: aCollection
    "Sets the dictionary of categories present in the receiver."
    categories := aCollection! 
categoryNamed: aString
    "Answer the category whose name is aString or nil."

    ^self categories detect: [ :each | each name = aString ] ifNone: [ nil ]!  
categoryNames
    "Answer a collection of the category names of the receiver."

    ^self categories collect: [ :each | each name ]!   
computeBoundingBox
    "Private - Build the receiver's bounding box.
    This method can be refined by subclasses..."

    | top right bottom left box |
    top := right := bottom := left := 0.
    self categories do: [:categ|
        box := categ boundingBox.
        left := left min: box left.
        top := top min: box top.
        right := right max: box right.
        bottom := bottom max: box bottom.
    ].
    boundingBox := left @ top rightBottom: right @ bottom.!
defaultCategories
    "Returns the default categories for the receiver."

    | result |
    result := OrderedCollection new.
    defaultCategoryNames = #all
    ifTrue: [ result addAll: self categories ]
    ifFalse: [
        self categoryNames do: [:each|
            (defaultCategoryNames includes: each)
            ifTrue: [ result add: (self categoryNamed: each) ]
        ].
    ].
    result isEmpty ifTrue: [^result].
    selectExclusive ifTrue: [^Array with: result first].
    ^result!  
defaultIcon
    "Private - Returns the default icon for category objects"
    | default |
    default := 'Default Object Bitmap'.
    ^self
        iconNamed: self name,' icon'
        ifAbsent: [
          self
            iconNamed: default
            ifAbsent: [
                self icons
                    at: default
                    put: (Bitmap extent: 8@8)
            ]
        ]!
defaultTool
    "Private - Returns the default tool for category objects"

    ^self
        toolNamed: 'Default Tool Bitmap'
        ifAbsent: [
            self tools
                at: 'Default Tool Bitmap'
                put: (Bitmap extent: 8@8)
        ]!  
display: categoryCollection rectangle: aRectangle at: aPoint with: aPen zoom: scale
    "Outputs the categories in the receiver's aRectangle
    at aPoint with aPen."

    | theElements icon position iconExtent realRect |
    theElements := OrderedCollection new: 100.
    categoryCollection do: [ :categ |
        categ isRoute
        ifTrue: [
            categ
                withElementsInRect: (aRectangle scaleBy: scale reciprocal) truncated
                do: [ :each | each display: aRectangle at: aPoint with: aPen zoom: scale ]
        ]
        ifFalse: [
            icon := self iconFor: categ.
            iconExtent := (icon extent * scale max: self minimumIconSize) truncated.
            realRect := (aRectangle scaleBy: scale reciprocal) truncated expandBy: iconExtent.
            categ
                withElementsInRect: realRect
                do: [ :each |
                    position := (aPoint + each position * scale) truncated.
                    self displayIcon: icon inside: (position - (iconExtent // 2) extent: iconExtent) using: aPen.
                ]
        ]
    ].! 
displayIcon: anIcon inside: aRectangle using: aPen
    "Private - Display anIcon inside aRectangle with aPen... inscript into a circle for major view."

     aPen place: aRectangle center";circleFilled: self minimumIconSize x".

    anIcon isBitmap ifTrue: [
        aPen
            copyBitmap: anIcon
            from: anIcon boundingBox
            to: aRectangle truncated
            rule: (self useTransparence ifTrue: [Srcand] ifFalse: [Srccopy]).
        ^self
    ].
    anIcon displayAt: aRectangle leftTop - (anIcon extent // 2) with: aPen.! 
editIconFor: aCategory
    "Private - lets the user edit the icon of the category aCategory..."

    | icon theName |
    aCategory isNil ifTrue: [ "edit default object icon..."
        ^self name isNil ifFalse: [
                self editIconFor: self name ]
    ].
    icon := self icons at: (theName := self iconNameFor: aCategory)
        ifAbsent: [ self icons at: theName put: (self iconFor: aCategory) cpCopy ].

    BitEditor new openOn: icon!
editTool
    "Private - lets the user edit the tool of the receiver"

    self editToolFor: nil!   
editToolFor: aCategory
    "Private - lets the user edit the tool for category aCategory"

    | tool theName |
    aCategory isNil ifTrue: [ "edit default tool..."
        ^self name isNil ifFalse: [
                self editToolFor: self name ]
    ].
    tool := self tools at: (theName := self toolNameFor: aCategory)
        ifAbsent: [ self tools at: theName put: (self toolFor: aCategory) cpCopy ].

    OSToolEditor new openOn: tool!  
editWith: aViewManager
    "Edit the receiver..."

    | editor |
    editor := self class editor.
    editor isNil
    ifTrue: [ self inspect ]
    ifFalse: [
        self model openView:
            (editor new
                view: aViewManager;
                layer: self;
                yourself)
    ]!   
extent: aPoint
    "Sets the extent of the receivers rectangle to aPoint"

    super extent: aPoint.
    self resetCuadrantsCoordinates!  
fileInUsing: aMapView
    "Files In data from databases..."

    | map |
    map := aMapView map.
    map isNil ifTrue: [ ^self error: 'Debe tener un mapa...' ].
    ^map fileInLayer: self!   
iconFor: aCategory
    "Private - Returns the icon for the category aCategory"

    ^self
        iconNamed: (self iconNameFor: aCategory)
        ifAbsent: [ self defaultIcon ]!   
iconFor: aCategory is: aBitmap
    "Private - Sets the icon for the category aCategory"

    | aName |
    aName := self iconNameFor: aCategory.
    aBitmap isNil ifTrue: [
        icons removeKey: aName ifAbsent: [].
        ^self
    ].
    ^icons
        at: aName
        put: aBitmap!  
iconNamed: anIconName ifAbsent: aBlock
    "Private - Returns the iconnamed anIconName"
    | bmpName |
    bmpName := anIconName size = 0
        ifTrue: [ 'Default Object Bitmap' ]
        ifFalse: [ anIconName ].
    ^self icons
        at: bmpName
        ifAbsent: [
            CPBitmapDict
                at: bmpName
                ifAbsent: [ aBlock value ]
        ]!
iconNameFor: aCategory
    "Private - Returns the icon for the category aCategory"

    aCategory isNil ifTrue: [ ^self name,' icon' ]. "default icon for the receiver..."
    ^(aCategory isString ifTrue: [ aCategory ] ifFalse: [ aCategory name ]),' icon'!   
icons
    "Private - Returns the current icons dictionary..."

    icons isDictionary ifFalse: [ "validate contents"
        icons := Dictionary new
    ].
    ^icons! 
initialize
    "Private - Initializes the recevier."

    super initialize.
    level := 50.
    positions := Array new.
    lastId := 1.
    categories := OrderedCollection new.
    defaultCategoryNames := #all.
    selectExclusive := false.!  
lastId
    "Returns the instance var of the receiver
     for external manipulation"
    ^lastId!  
lastId: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lastId := anObject! 
level
    "Answers the level (or order by which the receiver
    is sorted by to be drawn."
    ^level!
level: anInteger
    "Sets the level (or order) by which the receiver is ordered
    by or drawn."
    level := anInteger! 
lockIDs
    "Removes the references inside the grid to the elements by
    replacing them to the element's IDs.
    * * * WARNING * * *
    This should only be done when the layer has been finished
    because NO further editing will be possible afterwards."

    self categories do: [ :each | each lockIDs ]!  
minimumIconSize
    "Private - Returns the minimum icon size"

    ^10@10! 
nameOfCategory: aCategory
    "Answer the category name..."

    ^aCategory name!  
nextId
    "Private - Answer a new ID to be given to an element of the receiver,
    automatically increases the last ID."

    | next |

    lastId := (next := lastId) + 1.
    ^next!   
numberOfObjects
    "Returns the instance var of the receiver
     for external manipulation"

    numberOfObjects isNil ifTrue: [
        numberOfObjects := 0.
        self withElementsInRect: nil do: [:each| numberOfObjects := numberOfObjects + 1]
    ].
    ^numberOfObjects!
origin: aPoint
    "Sets the origin of the receivers rectangle to aPoint."

    super origin: aPoint.
    self resetCuadrantsCoordinates! 
origin: point1 extent: point2
    "Sets the origin and extent of the receivers rectangle."

    super origin: point1 extent: point2.
    self resetCuadrantsCoordinates!  
positions
    "Returns the instance var of the receiver
     for external manipulation"
    ^positions!
positions: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    positions := anObject!   
remove: anElement
    "Removes anElement to the receiver."

    | id |
    id := elements indexOf: anElement.
    id = 0 ifTrue: [^nil].
    self categories do: [:categ| categ remove: anElement].
    self elements at: id put: nil.
    self positions
        at: (id - 1 * 2 + 1) put: nil;
        at: (id - 1 * 2 + 2) put: nil.
     self boundingBox: nil.    "force to recompute boundingBox..."
     numberOfObjects := nil!   
removeCategory: aCategory
    "Remove aCategory from receiver's categories"

    categories remove: aCategory ifAbsent: [].
    defaultCategoryNames isSymbol
    ifFalse: [ defaultCategoryNames remove: aCategory name ifAbsent: [] ].
    self boundingBox: nil.    "force to recompute boundingBox..."
     numberOfObjects := nil!
removeDefaultCategory: aCategory
    "Removes a default categories for the receiver."

    defaultCategoryNames :=
      (self defaultCategories copyWithout: aCategory)
        collect: [:each| each name ]!   
resetCuadrantsCoordinates
    "Private - A change in the origin or extent of the receiver has occured.
    Reflect it in the grid."

    | origin extent |
    origin := self origin.
    extent := self extent.
    self categories do: [ :each |
        each origin: origin extent: extent ]!  
selectExclusive
    "Returns the instance var of the receiver
     for external manipulation"
    ^selectExclusive!
selectExclusive: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    selectExclusive := anObject!   
tool
    "Private - Returns the bitmap tool for the receiver"

    ^self
        toolNamed: self toolName
        ifAbsent: [ self defaultTool ]!
toolFor: aCategory
    "Private - Returns the bitmap tool for the category aCategory"

    ^self
        toolNamed: (self toolNameFor: aCategory)
        ifAbsent: [ self tool "defaultTool"]!  
toolName
    "Private - Returns the name for tool for the receiver"

    ^'_layer:',self name! 
toolNamed: anIconName ifAbsent: aBlock
    "Private - Returns the tool named anIconName"
    | bmpName |
    bmpName := anIconName size = 0
        ifTrue: [ 'Default Tool Bitmap' ]
        ifFalse: [ anIconName ].
    ^self tools
        at: bmpName
        ifAbsent: [
            CPBitmapDict
                at: bmpName
                ifAbsent: [ aBlock value ]
        ]! 
toolNameFor: aCategory
    "Private - Returns the bitmap name tool for the category aCategory"

    ^'_category:',(aCategory isString ifTrue: [aCategory] ifFalse: [aCategory name])!  
tools
    "Private - Returns the dictionary of tool bitmaps"

    tools isDictionary ifFalse: [ tools := Dictionary new ].
    ^tools!
useTransparence
    "Returns the instance var of the receiver
     for external manipulation"
    ^useTransparence ~= false!   
useTransparence: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    useTransparence := anObject!   
withElementsInRect: aRectangle do: aBlock
    "Evaluates aBlock with the elements that are included in aRectangle.
     aBlock must be a oneParam block.
     The argument for evaluation will be the current element.
    Returns the receiver.
    Implemented by Ale..."

    | element allElements |
    allElements := self elements.
    self
        withIdsInRect: aRectangle
        do: [ :anId |
            element := anId isNumber
                ifTrue: [allElements at: anId] ifFalse: [ anId ].
            aBlock value: element
        ].!   
withIdsInRect: aRectangle do: aBlock
    "Private - Evaluates aBlock with the ids of elements that are included in aRectangle.
     aBlock must be a oneParam block.
     The argument for evaluation will be the current element id.
     Returns the receiver.
     Implemented by Ale..."

    | searchRect top right bottom left |
    aRectangle isNil ifTrue: [ ^self withIdsInRect: self boundingBox do: aBlock ].
    searchRect := aRectangle intersect: self boundingBox.
    top := searchRect top.
    right := searchRect right.
    bottom := searchRect bottom.
    left := searchRect left.
    self categories do: [:categ|
        categ withElementsInRect: aRectangle
        do:[ :anId |
            anId isNumber
            ifTrue: [
                (((self xAt: anId) between: left and: right)
                and: [ (self yAt: anId) between: top and: bottom ])
                ifTrue: [ aBlock value: anId ]
            ]
            ifFalse: [ aBlock value: anId ]
        ]
    ]!
xAt: anId
    "Answer the x coordinate of the object identified with anId."

    ^positions at: (anId - 1 * 2 + 1)!
yAt: anId
    "Answer the y coordinate of the object identified with anId."

    ^positions at: (anId - 1 * 2 + 2)! !

! TileLayer class methods !   
editor
    "Private - Returns the editor for the receiver's instances"

    ^Smalltalk isRunTime ifFalse: [super editor]!  
viewClass
    "Private - Returns the receiver's view class"
    ^TileLayerView! !

! TileLayer methods !  
add: aTiledImage at: ignore type: aSymbol
    "Adds aTiledImage to the category aSymbol..."

    | imageRect |

    (aTiledImage respondsTo: #boundingBox)
    ifFalse: [ ^self warning: 'Esta capa no puede contener objetos.' ].

    imageRect := aTiledImage boundingBox.
    ((self boundingBox containsPoint: imageRect origin)
    and: [(self boundingBox containsPoint: imageRect corner)])
    ifFalse: [ self boundingBox: (imageRect leftTop corner: imageRect rightBottom) ].
    categories at: aSymbol put: aTiledImage!   
addCategory: gridName
    "Adds a new category to the receiver.
    Answers the newly created category."

    ^categories at: gridName put: TiledImage new.!  
addDefaultCategory: aCategory
    "Adds a default categories for the receiver."

    defaultCategoryNames := Array with: (categories keyAtValue: aCategory)!   
canHold: anElement
    "Must return true if the receiver can hold anElement as an element"

    ^anElement isKindOf: TiledImage!   
canZoom: anInteger
    "Answers true if the receiver can zoom to anInteger"

    categories asArray
        detect: [:each| each canZoom: anInteger]
        ifNone: [^false].
    ^true!   
categories
    "Returns the categories present in the receiver"
    ^categories values asArray! 
categories: aDictionary
    "Sets the dictionary of categories present in the receiver."
    categories := aDictionary! 
categoryNamed: aString
    "Answer the category whose name is aString or nil."
    ^categories at: aString ifAbsent: []!
categoryNames
    "Answer a collection of the category names of the receiver."
    ^categories keys!
display: categoryCollection rectangle: aRectangle at: aPoint with: aPen zoom: scale
    "Outputs the categories in the receiver's aRectangle
    at aPoint with aPen."

    categoryCollection do: [:tiledImage|
        tiledImage displayRectangle: aRectangle at: aPoint with: aPen zoom: scale.
    ]!  
initialize
    "Private - Initializes the recevier."

    super initialize.
    level := 0.
    selectExclusive := true.
    categories := Dictionary new.! 
lockIDs
    "Removes the references inside the grid to the elements by
    replacing them to the element's IDs.
    * * * WARNING * * *
    This should only be done when the layer has been finished
    because NO further editing will be possible afterwards."

    "Do nothing with tiled images..."! 
nameOfCategory: aCategory
    "Answer the category name..."

    ^categories keyAtValue: aCategory!
remove: anElement
    "Removes anElement to the receiver."

   ^self invalidMessage!   
removeCategory: aCategory
    "Remove aCategory from receiver's categories"

    categories removeKey:
        (categories keyAtValue: aCategory) ifAbsent: [].!  
removeDefaultCategory: aCategory
    "Ignored..."!   
resetCuadrantsCoordinates
    "Private - A change in the origin or extent of the receiver has occured.
    Reflect it in the grid."

    "Do nothing with tiled images..."!   
withElementsInRect: aRectangle do: aBlock
    "Evaluates aBlock with the elements that are included in aRectangle.
     aBlock must be a oneParam block.
     The argument for evaluation will be the current element.
    Returns the receiver.
    Implemented by Ale..."

   ^self invalidMessage!  
withIdsInRect: aRectangle do: aBlock
    "Private - Evaluates aBlock with the ids of elements that are included in aRectangle.
     aBlock must be a oneParam block.
     The argument for evaluation will be the current element id.
     Returns the receiver.
     Implemented by Ale..."

   ^self invalidMessage! 
xAt: anId
    "Answer the x coordinate of the object identified with anId."

   ^self invalidMessage!  
yAt: anId
    "Answer the y coordinate of the object identified with anId."

   ^self invalidMessage! !

! Map class methods !   
fromFile: pathName
    "Retrieve an instance of the receiver(or a subclass)
    from file named pathName (pathName will be macro expanded)"

    | map file |
    file := PathFinder locationFor: pathName.
    file isNil ifTrue: [ ^nil ].
    map := ObjectFiler loadFromPathName: file.
    map isNil ifTrue: [^nil].
    (map isKindOf: self) ifFalse: [
        self warning: 'El archivo ',file,' no tiene un mapa'.
        ^nil
    ].
    ^map! !

! Map methods !   
addLayer: aLayer
    "Add a new layer to the receiver"

    self layers addLast: aLayer.
    self boundingBox: nil.    "force to recompute boundingBox..."
    self model changed: #map:property: with: self with: #layers.! 
asView
    "Returns a new view on the receiver"

    ^MapView new
        map: self;
        yourself!   
atProperty: aSymbol put: anObject
    "Private - Place a new object at property aSymbol.
    Notify the receiver's model about a property change"

    anObject isNil
    ifTrue: [ self properties removeKey: aSymbol ifAbsent: [] ]
    ifFalse: [ self properties at: aSymbol put: anObject ].

    self model changed: #map:property: with: self with: aSymbol.!  
backUpStreets
    "Private - BackUp the streets in the receiver"

    | stream bytes streets |
    streets := self streets.
    (streets isNil or: [ streets isEmpty ])
    ifFalse: [
        stream := WriteStream on: (String new: 1024 * 10).
        streets fileOutOn: stream.
        bytes := stream contents.
    ].
    self atProperty: #BackUpStreets put: bytes.! 
canZoom: anInteger
    "Answers true if the receiver can zoom to anInteger"

    self layers
        detect: [:each| (each canZoom: anInteger) not ]
        ifNone: [^true].
    ^false!   
computeBoundingBox
    "Returns the receiver's boundingBox.
    Rebuild the boundingBox from layers if needed..."

    | layerBox |
    super computeBoundingBox.

    "Try to expand the boundingBox if needed..."
    self layers do: [:aLayer|
        aLayer computeBoundingBox. "force recompute in layer..."
        (layerBox := aLayer boundingBox) notNil
        ifTrue: [
            boundingBox :=
                ((boundingBox leftTop min: layerBox leftTop)
                    corner: (boundingBox rightBottom max: layerBox rightBottom))
        ]
    ].

    self model changed: #map:property: with: self with: #boundingBox.
    ^boundingBox!
defaultRectangle
    "Private - Returns the default rectangle for the receiver."

    ^0@0 extent: 10@10.! 
display: aRectangle layers: aLayerCollection scale: aScale with: aPen
    "Outputs the elements in aLayerCollection present in aRectangle
    with aScale scale thru aPen."

    | trueRectangle |
    trueRectangle := aRectangle scaleBy: aScale.
    aLayerCollection do: [ :aLayer |
        aLayer display: trueRectangle in: aRectangle with: aPen ]!
fileInLayer
    "FileIn a new Layer from a database"

    ^self fileInLayer: nil!  
fileInLayer: aLayer
    "FileIn a Layer from a database"

    | reader |
    reader := LayerReader new.
    reader
        layer: aLayer;
        map: self;
        yourself.
    self model openView: reader!  
fileOutSurrogate: anObjectFiler
    " Answer surrogate for object filing.  Zap streets... "

    (self profiler at: 'Use Streets Backup') = 'true'
    ifTrue: [ "fileOut streets as a string..."
        self
            backUpStreets;
            streets: nil
    ]
    ifFalse: [
        self removeStreetsBackUp.
    ].

    ^self! 
hasStreets
    "Answer true if the receiver has streets"

    ^(self properties
        at: #streets
        ifAbsent: [
            self properties
                at: #BackUpStreets
                ifAbsent: []
        ]) size > 0!
initialize
    "Private - Initializes the receiver."

    super initialize.
    elements := OrderedCollection new.
    self initializeRoutes.!   
initializeRoutes
    "Private - Initializes the receiver's routes layers."

    "do nothing by default...
    self newLayer: self routeLayerName
    "!  
layerNamed: aString
    "Returns the layer named aString if absent returns nil..."

    ^self layerNamed: aString ifAbsent: []!
layerNamed: aString ifAbsent: aBlock
    "Returns the layer named aString if absent evaluates aBlock."

    ^self layers
        detect: [:aLayer| aLayer name = aString ]
        ifNone: aBlock!   
layers
    "Answer a collection of layers present in the receiver."

    ^elements!
lockIDs
    "Removes the references inside the grid to the elements by
    replacing them to the element's IDs.
    * * * WARNING * * *
    This should only be done when the layer has been finished
    because NO further editing will be possible afterwards."

    self layers do: [ :each | each lockIDs ]!  
newLayer: aSymbol
    "Creates a new layer (identified by aSymbol)
    If a layer named aSymbol already exists ther returns it..."

    ^self newLayer: aSymbol opaque: false!
newLayer: aSymbol opaque: opaque
    "Creates a new layer (identified by aSymbol)
    If a layer named aSymbol already exists ther returns it..."

    | layerClass layer |
    layerClass := opaque
        ifTrue: [TileLayer]
        ifFalse: [Layer].
    ^self layers
        detect: [:aLayer| aLayer name = aSymbol and: [aLayer class = layerClass] ]
        ifNone: [
           self boundingBox: nil.    "force to recompute boundingBox..."
           self layers add: (
                layer := layerClass new
                    name: aSymbol;
                    origin: self origin extent: self extent;
                    yourself
                ).
            self model changed: #map:property: with: self with: #layers.
            layer
        ]! 
properties
    "Returns the receiver's properties..."

    properties isNil ifTrue: [ properties := Dictionary new ].
    ^properties!
references
    "Answer the bitmap that represents
     the references of the receiver"

    ^self properties at: #references ifAbsent: []!
references: aBitmap
    "Sets the bitmap that is the receivers references"

    | references old |
    old := self references.
    references := aBitmap isBitmap
        ifTrue: [self stampClass fromBitmap: aBitmap] "We will use dibs..."
        ifFalse: [aBitmap].
    self atProperty: #references put: references.
    old release.!
release
    "Private - Release the receiver's resources."

    self stamp: nil.
    super release.!   
removeLayer: aLayer
    "Remove from the receiver the layer aLayer..."

    self layers remove: aLayer ifAbsent: [ ^self ].
    self boundingBox: nil.    "force to recompute boundingBox..."
    self model changed: #map:property: with: self with: #layers.!  
removeStreetsBackUp
    "Private - Remove streets backUp..."

    self atProperty: #BackUpStreets put: nil.!   
restoreStreets
    "Private - Restore the streets in the receiver from backUp stream"

    | stream streets |
    stream := ReadStream on: (
        self properties
            at: #BackUpStreets
            ifAbsent: [^nil]).
    streets := StreetNet fromStream: stream.
    self streets: streets.
    ^streets!
routeLayer
    "Answer the layer that holds the routes."

    ^self layerNamed: self routeLayerName!   
routeLayerName
    "Answer the name of the layer that holds the routes."

    ^'Rutas'!
routesFrom: startRect to: endRect
    "Answer a collection of routes that are in both rectangles."

    | startCollection endCollection |

    startCollection := self routesIn: startRect.
    endCollection := self routesIn: endRect.
    ^startCollection select: [ :each | endCollection includes: each ]!
routesIn: aRectangle
    "Answer a collection of routes that pass thru aRectangle."

    | result routes |
    routes :=  self routeLayer.
    routes size = 0 ifTrue: [ ^Set new ].
    result := Set new.
    self
        withElementsInRect: aRectangle
        grids: (Array with: routes)
        do: [:each| result add: each ].
    ^result!   
stamp
    "Answer the bitmap that represents
     the reduced image of the receiver"

    ^self properties at: #stamp ifAbsent: []!   
stamp: aBitmap
    "Sets the bitmap that is the receivers stamp"

    | stamp old |
    old := self stamp.
    stamp := aBitmap isBitmap
        ifTrue: [self stampClass fromBitmap: aBitmap] "We will use dibs..."
        ifFalse: [aBitmap].
    self atProperty: #stamp put: stamp.
    old release.!   
stampClass
    "Returns the proper class for the stamp"

    ^self class imageClass!   
streets
    "Answer the object that holds
     the streets of the receiver"

    ^self properties
        at: #streets
        ifAbsent: [ self restoreStreets ]!   
streets: aStreetNet
    "Sets the object that holds the streets in the receiver"

    ^self atProperty: #streets put: aStreetNet!  
transportation
    "Answer the receiver's transportation services"

    ^self properties
        at: #transportation
        ifAbsent: [
            self properties
                at: #transportation
                put: TransportationNet new
        ]!   
withElementsInRect: aRectangle do: aBlock
    "Evaluates aBlock with the elements that are included in aRectangle.
     aBlock must be a oneParam block.
     The argument for evaluation will be the current element.
    Returns the receiver.
    Implemented by Ale..."

    self
        withElementsInRect: aRectangle
        grids: self elements
        do: aBlock!   
withElementsInRect: aRectangle grids: aCollection do: aBlock
    "Evaluates aBlock with the elements that are included in aRectangle
     looking in aCollection of grids.
     aBlock must be a oneParam block.
     The argument for evaluation will be the current element.
    Returns the receiver.
    Implemented by Ale..."

    aCollection do: [ :grid | grid withElementsInRect: aRectangle do: aBlock ]! !

! MatchedKeyPoints class methods !  
left: leftPoint right: rightPoint
    ^self new
        keyPointLeft: (KeyPoint new origin: leftPoint);
        keyPointRight: (KeyPoint new origin: rightPoint)! !

! MatchedKeyPoints methods !
alignLeft: aMatchedKeyPoint
    | otherLeft |
    otherLeft := aMatchedKeyPoint keyPointLeft.!  
displayAt: aPoint   with: aPen

    keyPointLeft displayAt: aPoint with: aPen.
    keyPointRight displayAt: aPoint with: aPen.

    aPen lineFrom: keyPointLeft origin  to: keyPointRight origin.!   
includes: aKeyPoint
    aKeyPoint = keyPointLeft ifTrue: [^true].
    aKeyPoint = keyPointRight ifTrue: [^true].
    ^false!   
keyPointLeft
    "Returns the instance var of the receiver
     for external manipulation"
    self validatePoints.
    ^keyPointLeft!
keyPointLeft: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"

    keyPointLeft := anObject.
    self match.! 
keyPointRight
    "Returns the instance var of the receiver
     for external manipulation"
    self validatePoints.
    ^keyPointRight!  
keyPointRight: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    keyPointRight := anObject.
    self match.! 
keyPoints
    ^Array
        with: keyPointLeft
        with: keyPointRight!   
match
    (keyPointLeft notNil and: [keyPointRight notNil]) ifTrue: [
        keyPointLeft match: keyPointRight
    ].!
positionLeft
    ^keyPointLeft origin!   
positionRight
    ^keyPointRight origin! 
validatePoints
    | swap |
    (keyPointLeft isNil or: [keyPointRight isNil])ifTrue: [^self].

    keyPointLeft origin x > keyPointRight origin x ifTrue: [
        swap := keyPointLeft.
        keyPointLeft := keyPointRight.
        keyPointRight := swap.
    ].! !

! OSGraphicObject methods ! 
origin
    "Returns the instance var of the receiver
     for external manipulation"
    ^origin!  
origin: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    origin := anObject! !

! KeyPoint methods !   
boundingBox
    | o |
    o := (origin - (self radius @ self radius)  extent: (self radius * 2) @ (self radius * 2)).
    ^o!  
displayAt: aPoint
    "Display the receiver at aPoint with Display pen."

    ^self displayAt: aPoint with: Display pen.!  
displayAt: aPoint   with: aPen
    "Display the receiver at aPoint with aPen."
    | point |
    point := self radius + 2  @ 0.
    aPen place: origin.
    aPen circle: self radius.
    aPen lineFrom: (origin - point) to: (origin + point).
    point := point transpose.
    aPen lineFrom: (origin - point) to: (origin + point).
    match notNil  ifTrue: [
"        match displayAt: aPoint   with: aPen. "
    ].!   
initialize
    drawLine := false.!   
match
    "Returns the instance var of the receiver
     for external manipulation"
    ^match!
match: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"

    anObject isNil ifTrue: [match :=nil.^self].
    anObject class = self class ifFalse: [^self].
    match isNil ifFalse: [
        match match: nil.
    ].
    match := anObject.

    anObject match = self ifFalse: [
        anObject match: self.
        drawLine := true.
    ].!   
radius
    "Returns the radius of re receiver"
    ^8! !

! Tile class methods !  
aboutToSaveImage
    "Private - The Smalltalk image is being saved.
     Clear the receiver's cache..."

    self clearCache.!
cache
    "Private - Returns the dictionary of catched tiles.
     If not has been used creates a new cache..."

    self atKey: #tilesCache ifAbsent: [
        self atKey: #tilesCache put: Dictionary new
    ].
    ^self atKey: #tilesCache.! 
cachedAt: aTileFileName
    "Private - Returns the tile if exists in the cache else returns nil"

    ^self cache at: aTileFileName ifAbsent: [nil].!  
cachedAt: aTileFileName put: aTile
    "Private - Adds aTile to the cache or remove the current entry named
     aTileFileName if aTile is nil..."

    aTile isNil
    ifTrue: [ self cache removeKey: aTileFileName ifAbsent: [] ]
    ifFalse: [ self cache at: aTileFileName put: aTile ]!  
clearCache
    "Clears all the cached instances"

    self cache values do: [:each | each release ].
    self atKey: #tilesCache put: nil.!   
minSweepSize
    "Garbage collect - Rerturns minimum cache size for sweep..."

    ^7! 
name: fullName
    "Returns a tile of name aName and number aNumber"

    ^self name: fullName imageClass: nil!
name: fullName imageClass: imageClass
    "Returns a tile of name aName and number aNumber"
    | tile |
    (tile := self cachedAt: fullName) isNil
    ifTrue: [
        tile := self new.
        tile
            name: fullName;
            bitmapClass: imageClass.
        self cachedAt: fullName put: tile
    ].
    ^tile! 
purgeCache: percent
    "Purges the tiles in the cache upTo percent
     of total cached instances"

    | objectsOk stream |
    objectsOk := OrderedCollection new.
    self cache values do: [:tile|
        tile isHandleOk ifTrue: [ objectsOk add: tile ]
    ].
    objectsOk isEmpty ifTrue: [^self].
    stream := ReadStream on: objectsOk.
    (objectsOk size * percent // 100 max: 1) timesRepeat: [
        stream atEnd ifTrue: [^self].
        stream next release.
    ].!
removeFromCache: aTile
    "Private - Removes aTile from the cache..."

    self cachedAt: aTile name put: nil.!   
sweep
    "Garbage collect - Perform sweep operation for catched instances..."

    | cache intState |

    "for debug porpouses...
    ('*Sweep* ', Time now asSeconds asString) displayAt: 10@10.
    Terminal bell. "

    cache :=  self cache.
    cache size > self minSweepSize ifFalse: [ ^self ].

    intState := Process enableInterrupts: false.
    cache values do: [:each| each sweep ].
    Process enableInterrupts: intState.! !

! Tile methods !  
bitmap
    "Returns the instance var of the receiver
     for external manipulation"

    | fileName |
    bitmap notNil ifTrue: [^bitmap].
    fileName := self name.
    (fileName notNil and: [
    (File exists: fileName)]) ifTrue: [ "<--- Creo que se puede ahorrar la consulta a disco
            aprovechando que fromFile: puede devolver nil cuando el file no existe..."
        bitmap := self bitmapClass fromFile: fileName.
    ].
    ^bitmap!  
bitmap: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"

    | old |
    old := bitmap.
    bitmap := anObject.
    old release.!   
bitmapClass
    "Private - Returns the class for the bitmap instance generation"

    ^bitmapClass isNil
    ifTrue: [ self class imageClass ]
    ifFalse: [ bitmapClass ]! 
bitmapClass: aPictureClass
    "Private - Set the class for the bitmap instance generation"

    bitmapClass := aPictureClass.

    (bitmap notNil & aPictureClass notNil
     and: [(bitmap isKindOf: aPictureClass) not])
    ifTrue: [ self releaseBitmap ].!   
boundingBox
    "Returns the receiver's boundingBox computed from the current bitmap"

    ^self origin extent: self extent!   
copy
    ^self class new
        name: name;
        bitmap: bitmap copy;
        origin: origin copy.!   
crop: aRectangle
    "Crop the receiver's bitmap to aRectangle"

    self isHandleOk ifFalse: [^self].
    self bitmap: (bitmap crop: aRectangle)!
display: aRectangle at: aPoint with: aPen
    "Display the receiver cropped to aRectangle at aPoint with aPen."

    self
        display: aRectangle
        bitmap: self bitmap
        at: aPoint
        with: aPen!   
display: aRectangle bitmap: image at: aPoint with: aPen
    "Private - Display the image cropped to aRectangle at aPoint using aPen.
    image can be nil...
    aPoint can be aPoint or aRectangle...
    "

    | color destination |

    aRectangle isNil ifTrue: [
        ^self display: self boundingBox bitmap: image at: aPoint with: aPen
    ].
    destination := aPoint isRectangle
        ifTrue: [  aPoint  ]
        ifFalse: [
            aPoint extent: (image isNil ifTrue: [0@0] ifFalse: [image extent])
        ].

    image isNil
    ifTrue: [
        color := aPen foreColor.
        aPen
            foreColor: ClrBlack;
            place: destination center truncated;
            displayText: (self name reversed upTo: $\) reversed;
            foreColor: color
    ]
    ifFalse: [
        bitmap isBitmap ifTrue: [
            aPen
                copyBitmap: bitmap
                from: aRectangle
                to: destination
        ]
        ifFalse: [
            bitmap
                display: (aRectangle translateBy: self origin negated)
                at: aPoint + aRectangle origin
                with: aPen.
        ]
    ].

    self mark. "mark the receiver as used for non garbage collect..."!   
displayAt: aPoint
    "Display the receiver at aPoint with Display pen."

    ^self displayAt: aPoint with: Display pen.!  
displayAt: aPoint with: aPen
    "Display the receiver at aPoint with aPen."

    self
        display: nil
        bitmap: self bitmap
        at: aPoint
        with: aPen! 
displayLightAt: aPoint with: aPen
    "Display the receiver in preview mode at aPoint with aPen."

    | rect color |
    color := aPen foreColor.
    rect := self boundingBox translateBy: aPoint.
    rect width = 0 ifTrue: [
        rect := rect extent: 100@100
    ].
    aPen
        foreColor: ClrBlack;
        drawRectangle: rect;
        place: rect center;
        centerText: (self name reversed upTo: $\) reversed;
        foreColor: color.! 
edit
    "Open an editor with the receiver..."

    ^TileEditor new openOn: self!  
extent
    "Answer a Point which is the extent of the receiver."

    self bitmap isNil ifTrue: [^0@0].
    ^bitmap extent!   
height
    "Answer the height of the receiver."

    self bitmap isNil ifTrue: [^0].
    ^bitmap height!  
initialize
    "Private - Initialize the receiver"

    self mark. "GC - mark as used..."

    super initialize.
    origin := 0@0.!
isHandleOk
    "Returns if the object's handle is ok"

    ^bitmap notNil! 
isValid
    "Returns if the receiver can be displayed"

    ^self isHandleOk and: [ bitmap isValid ]!  
mark
    "Garbage Collect - Signal the receiver as marked for non removal during next sweep"

    mark := true.!   
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!  
name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject! 
origin: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"

    | result |
    result := super origin: anObject.
    " Transcript cr;show: 'Tile ',name,' origin: ',self origin asString,' bitmap: ',self bitmap asString. "
    ^result!  
print: sourceRect inside: destRect using: aPrinter
    "Implemented for printing...
      sourceRect will be the area inside the receiver's boundingBox (in pixels) to be printer
      destRect will be the destination area for output (in inches)
      aPrinter will be the current printer to use (placed in the current page).
    "

    | factor capability destination |
    self bitmap isNil "file not found; will display the file name..."
    ifTrue: [
        "compute dest rect in pixels..."
        capability := aPrinter capability.
        factor := aPrinter extent / capability extentInInches.
        destination := (destRect scaleBy: factor) truncated.
        self "will display a box & the file name..."
            display: nil
            bitmap: self bitmap
            at: destination
            with: aPrinter pen
    ]
    ifFalse: [ "Perform bitmap printing..."
        self bitmap
            print: (sourceRect translateBy: self origin negated)
            inside: destRect
            using: aPrinter
    ]!
release
    "Release the receivers bitmap"

    self class removeFromCache: self.
    self isHandleOk ifFalse: [^self].
    self releaseBitmap.! 
releaseBitmap
    "Private - Release the current bitmap"

    bitmap release.
    bitmap := nil.! 
restore
    "Force the receiver's bitmap to be reloaded from file"

    self isHandleOk
    ifTrue: [ self releaseBitmap ].!  
rotate: angle
    "Rotate the receiver's bitmap by angle in degrees"

    ^self
        rotate: angle
        anchor: 'Topleft'
        at: 0@0!
rotate: angle anchor: anchorMode at: aPoint
    "Rotate the receiver's bitmap by angle in degrees"

    self bitmap isNil ifTrue: [^nil].
    self bitmap:
        (self bitmap
            rotatedTo: (angle * 10) asInteger
            anchor: anchorMode
            at: aPoint)! 
save
    "Save the receiver's bitmap..."

    self isValid
    ifTrue: [ self bitmap saveAs: self name ].!
saveAs: newName
    "Save the receiver with a new name..."
    self halt.
    self bitmap saveAs: newName.!
sweep
    "Garbage Collect - Perform sweep: Delete mark and
    release the receiver if has not been marked."

    mark == true
    "  ifTrue: [ Transcript cr;show: ('Safe: ',name asString) displayAt: 10@30 ] "
    ifFalse: [
    "    Transcript cr;show: ('Release: ',name asString). "
        self release
    ].

    mark := false.! 
translateBy: delta
    "Translate the receiver by delta..."

    self origin: origin + delta!  
width
    "Answer the width of the receiver."

    self bitmap isNil ifTrue: [^0].
    ^bitmap width! !

! PathFinder class methods !   
aboutToSaveImage
    "Private - The Smalltalk image is being saved.
     Force Locations to be reloaded upon startUp"

    Locations := nil.! 
locationFor: path
    "Returns the full path name for path...
    Expands Location macros...
    Returns the path or nil..."

    ^self new locationFor: path!   
locations
    "Returns locations of root directories."

    ^self new locations!   
nameFor: pathName
    "Returns the symbolic path for pathName...
    Keywords will be extracted from current locations."

    ^self new nameFor: pathName! !

! PathFinder methods !
collectReferencesFrom: prologue and: epilogue using: dictionary
    "Private - Returns a collection of string that can be used as a symbolic reference
    to the pathName obtaining from joining prologue and epilogue arrays of parts.
    dictionary will be used for keyword reduction..."

    | header result |
    dictionary isEmpty ifTrue: [ ^Array with: (self pathFromArray: prologue,epilogue) ].
    epilogue isEmpty ifTrue: [
        (dictionary includesKey: (self pathFromArray: prologue))
        ifTrue: [ ^Array with: (dictionary at: (self pathFromArray: prologue)) ].
        ^Array with: (self pathFromArray: prologue)
    ].
    result := Set new.
    (dictionary includesKey: (self pathFromArray: prologue) asLowerCase,'\')
    ifTrue: [
        result add: (dictionary at: ((self pathFromArray: prologue) asLowerCase), '\') ,(self pathFromArray: epilogue)
    ]
    ifFalse: [
        result add: (dictionary
            at: (self pathFromArray: prologue) asLowerCase
            ifAbsent: [ self pathFromArray: prologue ]) , '\' ,(self pathFromArray: epilogue)
    ].
    result addAll: (self
        collectReferencesFrom: (prologue, (Array with: epilogue first))
        and: (epilogue copyFrom: 2 to: epilogue size)
        using: dictionary).
    ^result!   
getLocations
    "Private - Read file root locations from default file."

    ^self getLocationsFrom: self locationsPathName!  
getLocationsFrom: fileName
    "Private - Read file root locations from file named fileName"
    | profiler root |
    Locations := Dictionary new.
    #('Paths' 'TiledImage Locations') "try with new & old group names..."
    detect: [:each|
        profiler := WinProfiler new
            pathName: fileName;
            applicationName: each.
        profiler keys notEmpty
    ] ifNone: [].
    profiler keys do: [:key|
        root := (profiler at: key) trimBlanks.
        root isEmpty
        ifFalse: [ Locations at: key asLowerCase put: root ]
    ].
    ^Locations!
locationEndCharacter
    "Private - returns the character used for mark location end."
    ^$}! 
locationFor: path
    "Private - Returns the full path name for path...
    Expands Location macros...
    Returns the path or nil..."

    | stream result root |
    result := String new.
    stream := ReadStream on: path.
    [stream atEnd] whileFalse: [
        result := result , (stream upTo: self locationStartCharacter).
        stream atEnd
        ifFalse: [
            root := stream upTo: self locationEndCharacter.
            root trimBlanks isEmpty
            ifFalse: [
                root := self locations
                    at: root asLowerCase
                    ifAbsent: [
                        MessageBox warning: 'Ruta de mapas no encontrada >>',root,
                            '\\Verifique el archivo de seteo de rutas [' withCrs,self locationsPathName,']'.
                        ^nil
                    ]. "root entry not found"
                result := result , root.
            ]
        ]
    ].

    (result includes: self locationStartCharacter) ifTrue: [ "be recursive..."
        ^self locationFor: result
    ].

    ^result!   
locations
    "Private - Returns locations of root directories."

    Locations notNil ifTrue: [^Locations].
    self getLocations.
    ^Locations!  
locationsPathName
    "Private - Returns the path for the location ini file"

    ^Disk pathName,'\TilesLoc.Ini'!  
locationStartCharacter
    "Private - returns the character used for mark location start."
    ^${! 
nameFor: pathName
    "Private - Returns the symbolic path for pathName...
    Shrink using Location keys..."

    | parts keywords stream result sorted key |
    keywords := Dictionary new.
    self locations keys do: [:aKey|
        key := (String with: self locationStartCharacter), aKey,(String with: self locationEndCharacter).
        keywords at: (self locationFor: key) asLowerCase put: key
    ].
    keywords isEmpty | pathName isNil ifTrue: [ ^pathName ].

    "extract minimal parts of pathName"
    parts := OrderedCollection new.
    stream := ReadStream on: (self locationFor: pathName) asLowerCase.
    [stream atEnd] whileFalse: [ parts add: (stream upTo: $\) ].

    "collect symbolic references..."
    result := self collectReferencesFrom: Array new and: parts using: keywords.
    result isEmpty ifTrue: [ ^pathName ].

    "returns the sorter result..."
    sorted := SortedCollection sortBlock: [:a :b| a size <= b size ].
    sorted addAll: result.
    ^sorted first!   
pathFromArray: anArray
    "Private - Returns a path obtained from anArray."

    | stream input |
    stream := WriteStream on: String new.
    anArray isEmpty ifTrue: [ ^String new ].
    input := ReadStream on: anArray.
    stream nextPutAll: input next.
    [input atEnd] whileFalse: [
        stream
            nextPut: $\;
            nextPutAll: input next;
            yourself
    ].
    ^stream contents! 
saveLocations
    "Private - Save file root locations to default file."

    ^self saveLocationsIn: self locationsPathName!
saveLocationsIn: fileName
    "Private - Save file root locations to file named fileName"
    | profiler |
    (File exists: fileName)
    ifFalse: [
        (File pathName: fileName)
            nextPutAll: '; Path finder references...';cr;cr;
            nextPutAll: '[Paths]';cr;
            close
    ].
    profiler := WinProfiler new
        pathName: fileName;
        applicationName: 'Paths'.

    profiler keys do: [:each|
        profiler at: each put: String new
    ].

    self locations keys do: [:key|
        profiler at: key put: (Locations at: key)
    ].! !

! PictureCutter class methods !  
cut
    "Cut an image..."

   ^self cut: nil in: nil!  
cut: sourcePathName
    "Cut the image in sourcePathName..."

   ^self cut: sourcePathName in: nil!
cut: sourcePathName in: aPoint
    "Cut the image found in file sourcePathName in aPoint
    tiles and store the result in new files named by order.
    If sourcePathName isNil the image will be prompted to the user.
    If aPoint isNil the number of cuts will be prompted for the user"

    | source imageClass |
    imageClass := self imageClass.
    source := sourcePathName isNil
        ifTrue: [ imageClass fromFile ]
        ifFalse: [
            imageClass fromFile:
                (PathFinder locationFor: sourcePathName)
        ].
    source isNil ifTrue: [^nil].
    self new
        source: source;
        dest: sourcePathName;
        cut: aPoint;
        release! !

! PictureCutter methods !   
cut: aPoint
    "Private - Cut source in tiles of aPoint"
    | point text count |
    source isNil ifTrue: [^nil].
    point := aPoint.

    aPoint isNil
    ifTrue: [
        text := OSPrompter
            prompt: 'Picture cuts ? (aPoint)'
            default: '10@10'.
        text isNil ifTrue: [^nil].
        point := Compiler evaluate: text.
        point isNil ifTrue: [^nil].
        point isPoint
        ifFalse: [
            self release.
            ^self error: 'Must be a Point...'
        ].
    ].
    count := 1.
    source
        withTiles: point
        do: [:each|
            self save: each as: count.
            each release.
            count := count + 1.
        ].!   
dest: anObject
    "Sets the instance var of the receiver..."

    | pathName extension |
    dest := anObject.
    pathName := dest isNil
        ifTrue: [ OSPrompter prompt: 'Name for the cutted files ?' default: 'Cut' ]
        ifFalse: [ dest upTo: $. ].
    pathName size = 0 ifTrue: [^nil].

    extension := dest isNil
        ifTrue: [ OSPrompter prompt: 'Extension for the cutted files ?' default: 'TIF' ]
        ifFalse: [ (dest reversed upTo: $.) reversed ].
    extension size = 0 ifTrue: [^nil].


    dest := pathName,'.',extension!   
release
    "Release the receiver's resources..."

    source release.
    source := nil.
    ^super release!
save: aPicture as: anInteger
    "Private - Save the cutted piede aPicture as number anInteger"
    | fileName |
    aPicture isNil ifTrue: [^self].
    fileName := (dest upTo: $.),anInteger asString,'.',(dest reversed upTo: $.) reversed.
    aPicture saveAs: (PathFinder locationFor: fileName).! 
source: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    source := anObject! !

! Route methods !  
addFrom: aPoint
    "Adds a new route element before the end of the 'routeFrom',
    and that is located at aPoint."

    ^self addFrom: (self newAt: aPoint) before: self start! 
addFrom: aRouteCellElement after: anElement
    "Adds a new route element right after anElement to routeFrom.
    If anElement is the first one then report an error."

    (aRouteCellElement isKindOf: Point)
        ifTrue: [ ^self addFrom: (self newAt: aRouteCellElement) after: anElement ].
    anElement = self start ifTrue: [ ^self cantChangeTerminals ].
    self routeFrom add: aRouteCellElement before: anElement!
addFrom: aRouteCellElement before: anElement
    "Adds a new route element right before anElement to routeFrom.
    If anElement is the last one then report an error."

    (aRouteCellElement isKindOf: Point)
        ifTrue: [ ^self addFrom: (self newAt: aRouteCellElement) before: anElement ].
    anElement = self finish ifTrue: [ ^self cantChangeTerminals ].
    self routeFrom add: aRouteCellElement before: anElement! 
addTo: aPoint
    "Adds a new route element before the end of the 'routeTo',
    and that is located at aPoint."

    ^self addTo: (self newAt: aPoint) before: self finish!  
addTo: aRouteCellElement after: anElement
    "Adds a new route element right after anElement to routeTo.
    If anElement is the last one then report an error."

    (aRouteCellElement isKindOf: Point)
        ifTrue: [ ^self addTo: (self newAt: aRouteCellElement) after: anElement ].
    anElement = self finish ifTrue: [ ^self cantChangeTerminals ].
    self routeTo add: aRouteCellElement after: anElement! 
addTo: aRouteCellElement before: anElement
    "Adds a new route element right before anElement to routeTo.
    If anElement is the first one then report an error."

    (aRouteCellElement isKindOf: Point)
        ifTrue: [ ^self addTo: (self newAt: aRouteCellElement) before: anElement ].
    anElement = self start ifTrue: [ ^self cantChangeTerminals ].
    self routeTo add: aRouteCellElement before: anElement! 
cantChangeTerminals
    "Private - Generates an error because the terminal points
         of the receiver can't be changed"

    ^self error: 'Los puntos terminales de una ruta no pueden cambiarse.'!  
closestPointTo: aPoint toRoute: aBoolean
    "Answer a route point that is closest to aPoint.
    Checks the routeTo if aBoolean, else the routeFrom."

    | route minDist minIndex segPoint distance |

    route := aBoolean
                        ifTrue: [ self routeTo ]
                        ifFalse: [ self routeFrom ].
    minDist := (route first position - aPoint) modulus.
    minIndex := 1.
    2 to: route size do: [ :index |
        segPoint := (route at: index) position.
        distance := (segPoint - aPoint) modulus.
        distance < minDist
            ifTrue: [ minDist := distance.
                            minIndex := index ] ].
    ^route at: minIndex!  
closestSegmentTo: aPoint toRoute: aBoolean
    "Answer a segment that passes closest to aPoint.
    Checks the routeTo if aBoolean, else the routeFrom."

    | route minDist minIndex segPoint distance segment1 segment2 |

    route := aBoolean
                        ifTrue: [ self routeTo ]
                        ifFalse: [ self routeFrom ].
    minDist := (route first position - aPoint) modulus.
    minIndex := 1.
    2 to: route size do: [ :index |
        segPoint := (route at: index) position.
        distance := (segPoint - aPoint) modulus.
        distance < minDist
            ifTrue: [ minDist := distance.
                            minIndex := index ] ].
    minIndex = 1
        ifTrue: [ ^Segment from: (route at: minIndex) position to: (route at: minIndex + 1) position ].
    minIndex = route size
        ifTrue: [ ^Segment from: (route at: minIndex - 1) position to: (route at: minIndex) position ].

    segment1 := Segment from: (route at: minIndex - 1) position to: (route at: minIndex) position.
    segment2 := Segment from: (route at: minIndex) position to: (route at: minIndex + 1) position.
    (segment1 distanceTo: aPoint) < (segment2 distanceTo: aPoint)
        ifTrue: [ ^segment1 ]
        ifFalse: [ ^segment2 ]!
display: aRectangle at: aPoint with: aPen zoom: scale
    "Outputs the receiver's aRectangle at aPoint using aPen."

    | back |
    back := aPen foreColor.
    aPen foreColor: ClrRed.
    (self segmentsIn: aRectangle) do: [ :aSegment |
        aPen
            lineFrom: (aSegment start + aPoint * scale) truncated
            to: (aSegment end + aPoint * scale) truncated
    ].
    aPen foreColor: back.!   
display: gridRectangle in: destRect with: aPen
    "Outputs the receiver's gridRectangle in destRect thru aPen."

    | scale back |
    back := aPen foreColor.
    aPen foreColor: ClrRed.
    scale := destRect extent / gridRectangle extent.
    (self segmentsIn: gridRectangle) do: [ :aSegment |
        aPen
            lineFrom: (aSegment start * scale) truncated
            to: (aSegment end * scale) truncated
    ].
    aPen foreColor: back.! 
distanceFrom: startPoint to: endPoint
    "Answer an array with the distances between the startPoint to the receiver,
    and from the receiver to the endPoint.
    Allways consider the shortest possible distances."

    | start end indexStart indexEnd auxPoint auxDist aux direction |

    start := self closestPointTo: startPoint toRoute: true.
    end := self closestPointTo: endPoint toRoute: true.
    indexStart := self routeTo indexOf: (self routeTo detect: [ :each | each = start ]).
    indexEnd := self routeTo indexOf: (self routeTo detect: [ :each | each = end ]).
    indexStart < indexEnd
        "We are sure that the route to is the correct..."
        ifTrue: [ ^Array with: ((self closestSegmentTo: startPoint toRoute: true) distanceTo: startPoint)
                                    with: ((self closestSegmentTo: endPoint toRoute: true) distanceTo: endPoint) ].

    indexStart = indexEnd
        "Both are close to the same point, check to see if the direction is the correct..."
        ifTrue: [ auxPoint := (self routeTo at: indexStart) position.
                    auxDist := (self start position - auxPoint ) modulus.
                    direction := true.
                    2 to: indexStart - 1 do: [ :index |
                        (aux := ((self routeTo at: index) position - auxPoint) modulus) < auxDist
                            ifTrue: [ auxDist := aux ]
                            ifFalse: [ direction := false ] ].
                    direction
                        ifTrue: [ indexStart + 1 to: self routeTo size do: [ :index |
                                            (aux := ((self routeTo at: index) position - auxPoint) modulus) > auxDist
                                                ifTrue: [ auxDist := aux ]
                                                ifFalse: [ direction := false ] ] ].
                    direction
                        ifTrue: [ ^Array with: ((self closestSegmentTo: startPoint toRoute: true) distanceTo: startPoint)
                                                    with: ((self closestSegmentTo: endPoint toRoute: true) distanceTo: endPoint) ] ].

    start := self closestPointTo: startPoint toRoute: false.
    end := self closestPointTo: endPoint toRoute: false.
    indexStart := self routeFrom indexOf: (self routeFrom detect: [ :each | each = start ]).
    indexEnd := self routeFrom indexOf: (self routeFrom detect: [ :each | each = end ]).
    indexStart < indexEnd
        "We are sure that the route from is the correct..."
        ifTrue: [ ^Array with: ((self closestSegmentTo: startPoint toRoute: false) distanceTo: startPoint)
                                    with: ((self closestSegmentTo: endPoint toRoute: false) distanceTo: endPoint) ].

    indexStart = indexEnd
        ifTrue: [ Terminal bell.
                        ^Array with: ((self closestSegmentTo: startPoint toRoute: false) distanceTo: startPoint)
                                    with: ((self closestSegmentTo: endPoint toRoute: false) distanceTo: endPoint) ]

    self error: 'Ruta sin puntos prximos...'. "Route without proximity to a point"!
finish
    "Returns the last 'point' of the receivers route"

    ^self routeTo last!  
id
    "Returns the instance var of the receiver
     for external manipulation"
Terminal bell.
    ^1!   
id: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
Terminal bell.! 
initialize
    "Private - Initializes the receiver."

    super initialize.
    self name: #unknownRoute.
    routeTo := OrderedCollection new.
    routeFrom := OrderedCollection new.!
initialize: aString starting: startPoint ending: endPoint
    "Private - Initializes the receiver with aString as its name and
    starting in startPoint and ending in endPoint."

    | start end |

    self initialize.
    self name: aString.
    start := RouteCellElement new.
    start
        name: aString, ' start';
        position: startPoint;
        type: #routeTerminal.
    end := RouteCellElement new.
    end
        name: aString, ' finish';
        position: endPoint;
        type: #routeTerminal.

    self routeTo
        addFirst: start;
        addLast: end.
    self routeFrom
        addFirst: end;
        addLast: start.!
intersects: aRectangle
    "Answers true if the receiver has a segment that intersects with aRectangle."

    | route index intersects |

    route := self routeTo.
    index := 1.
    intersects := false.
    [ index < route size and: [ intersects not ] ]
     whileTrue: [
        index := index + 1.
        intersects :=
            (Segment
                from: (route at: index - 1) position
                to: (route at: index) position)
           intersects: aRectangle.
    ].
    intersects ifTrue: [ ^intersects ].

    route := self routeFrom.
    index := 1.
    [ index < route size and: [ intersects not ] ]
    whileTrue: [
        index := index + 1.
        intersects := (Segment
            from: (route at: index - 1) position
            to: (route at: index) position)
              intersects: aRectangle.
    ].
    ^intersects! 
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!  
name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject! 
newAt: aPoint
    "Answers a new route element that is located at aPoint."

    | element |

    element := RouteCellElement new.
    element
        name: self name, ' point';
        position: aPoint;
        type: #routePoint;
        route: self.
    ^element!   
position
    "Returns the instance var of the receiver
     for external manipulation"
Terminal bell.
    ^self start position + self finish position // 2!   
position: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
Terminal bell!
printOnFrom: aStream
    "Outputs the receivers 'From' route on aStream."

    | last |

    last := self start.
    aStream cr; nextPut: $(.
    self routeFrom do: [ :aSegVertice |
        aStream nextPutAll: aSegVertice position printString.
        aSegVertice = last
            ifTrue: [ aStream nextPut: $) ]
            ifFalse: [ aStream nextPutAll: ' => ' ] ].! 
printOnTo: aStream
    "Outputs the receivers 'To' route on aStream."

    | last |

    last := self finish.
    aStream cr; nextPut: $(.
    self routeTo do: [ :aSegVertice |
        aStream nextPutAll: aSegVertice position printString.
        aSegVertice = last
            ifTrue: [ aStream nextPut: $) ]
            ifFalse: [ aStream nextPutAll: ' => ' ] ].!  
route: startPoint to: endPoint
    "Answer routeTo or routeFrom depending on which keeps the same direction
    as the  one dictated by startPoint and endPoint."

    | pivotPoint pivotIndex toCount fromCount dist1 dist2 |

    dist1 := self closestPointTo: startPoint toRoute: true.
    dist2 := self closestPointTo: endPoint toRoute: true.
    dist1 := self routeTo indexOf: (self routeTo detect: [ :each | each = dist1 ]).
    dist2 := self routeTo indexOf: (self routeTo detect: [ :each | each = dist2 ]).
    dist1 < dist2
        "We are sure that the route to is the correct..."
        ifTrue: [ ^self routeTo ].

    toCount := fromCount := 0.
    pivotPoint := startPoint + endPoint / 2.

    pivotIndex := self routeTo indexOf: (self closestPointTo: pivotPoint toRoute: true).
    1 to: self routeTo size do: [ :index |
        index ~= pivotIndex
            ifTrue: [ dist1 := ((self routeTo at: index) position - startPoint) modulus.
                            dist2 := ((self routeTo at: index) position - endPoint) modulus.
                            dist1 >= dist2
                                ifTrue: [ toCount := toCount + 1 ]
                                ifFalse: [ toCount := toCount - 1 ] ] ].
    toCount > 0
        ifTrue: [ ^self routeTo ].

    dist1 := self closestPointTo: startPoint toRoute: false.
    dist2 := self closestPointTo: endPoint toRoute: false.
    dist1 := self routeFrom indexOf: (self routeFrom detect: [ :each | each = dist1 ]).
    dist2 := self routeFrom indexOf: (self routeFrom detect: [ :each | each = dist2 ]).
    dist1 < dist2
        "We are sure that the route from is the correct..."
        ifTrue: [ ^self routeFrom ].

    pivotIndex := self routeFrom indexOf: (self closestPointTo: pivotPoint toRoute: false).
    1 to: self routeFrom size do: [ :index |
        index ~= pivotIndex
            ifTrue: [ dist1 := ((self routeFrom at: index) position - startPoint) modulus.
                            dist2 := ((self routeFrom at: index) position - endPoint) modulus.
                            dist1 <= dist2
                                ifTrue: [ fromCount := fromCount + 1 ]
                                ifFalse: [ fromCount := fromCount - 1 ] ] ].

    fromCount > 0
        ifTrue: [ ^self routeFrom ].

    self error: 'No puede determinarse la direccin del viaje'!
routeFrom
    "Returns the instance var of the receiver
     for external manipulation"
    ^routeFrom!
routeFrom: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    routeFrom := anObject!   
routeTo
    "Returns the instance var of the receiver
     for external manipulation"
    ^routeTo!
routeTo: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    routeTo := anObject!   
segmentsIn: aRectangle
    "Answer a collection of arrays that represent the segments
    that pass thru a rectangle."

    | answer aux p1 p2 segment |

    answer := OrderedCollection new.
    aux := self routeTo asArray.
    2 to: aux size do: [ :x |
        p1 := (aux at: (x - 1)) position.
        p2 := (aux at: x) position.
        ((segment := Segment from: p1 to: p2) intersects: aRectangle)
            ifTrue: [ answer add: segment ] ].
    aux := self routeFrom asArray.
    2 to: aux size do: [ :x |
        p1 := (aux at: (x - 1)) position.
        p2 := (aux at: x) position.
        ((segment := Segment from: p1 to: p2) intersects: aRectangle)
            ifTrue: [ answer add: segment ] ].

    ^answer!
segmentsInBack: aRectangle
    "Answer a collection of arrays that represent the segments
    that pass thru a rectangle."

    | answer aux p1 p2 segments |

    answer := OrderedCollection new.
    segments := OrderedCollection new.
    aux := self routeTo asArray.
    2 to: aux size do: [ :x |
        p1 := (aux at: (x - 1)) position.
        p2 := (aux at: x) position.
        segments add: (Segment from: p1 to: p2).
        (aRectangle intersectsSegment: p1 to: p2)
            ifTrue: [ answer add: (Array with: p1 with: p2) ] ].
    aux := self routeFrom asArray.
    2 to: aux size do: [ :x |
        p1 := (aux at: (x - 1)) position.
        p2 := (aux at: x) position.
        segments add: (Segment from: p1 to: p2).
        (aRectangle intersectsSegment: p1 to: p2)
            ifTrue: [ answer add: (Array with: p1 with: p2) ] ].

    segments do: [ :each |
        (each intersects: aRectangle)
            ifTrue: [ ((answer includes: (Array with: each start with: each end))
                                or: [ answer includes: (Array with: each end with: each start) ])
                            ifFalse: [ self halt ] ]
            ifFalse: [ ((answer includes: (Array with: each start with: each end))
                                or: [ answer includes: (Array with: each end with: each start) ])
                            ifTrue: [ self halt ] ] ].

"    ^answer"
    ^segments!  
start
    "Returns the first 'point' of the receivers route"

    ^self routeTo first! !

! TiledImage class methods !   
fromFile: pathName
    "Returns an instance of the receiver obtained from file
    named 'pathName' ..."

    ^self new
        loadFrom: pathName;
        zoom: 1;
        yourself! 
new: aPoint
    "Create a new instance of aPoint x tiles and aPoint y tiles"

    ^self new
        sizeInTiles: aPoint;
        yourself!   
storageClass
    " Private - Returns the current storage-system class..."

    | cls |
    cls := self profiler at: 'Storage System class' ifAbsent: [^nil].
    ^Smalltalk at: cls asSymbol ifAbsent: []! !

! TiledImage methods !   
basicPrint: sourceRect inside: destRect using: aPrinter
    "Implemented for printing...
      sourceRect will be the area inside the receiver's boundingBox (in pixels) to be printer
      destRect will be the destination area for output (in inches)
      aPrinter will be the current printer to use (placed in the current page).
    "

    | tile destOrigin destExtent delta |

    delta := destRect extent / sourceRect extent.
    (self tilesInRectangle: sourceRect)
    do: [:tileNumber |
        tile := self tileNumber: tileNumber.
        tile notNil ifTrue: [
            destOrigin := tile origin - sourceRect origin * delta + destRect origin.
            destExtent := tile extent * delta.
            tile
                print: (tile boundingBox intersect: sourceRect)
                inside: ((destOrigin extent: destExtent) intersect: destRect)
                using: aPrinter
        ].
    ].! 
boundingBox
    "Answer a rectangle which bounds the receiver."

    ^0@0 extent: self extent! 
canZoom: anInteger
    "Answers true if the receiver can zoom to anInteger"

    ^self information includesKey: anInteger! 
computeTileExtent
    "Private - Compute tile extent from the first tile..."
    | tile tileName ext |
    extent := nil.
    tileName := self fileNameTile: 1.
    tileName isNil ifTrue: [^1@1].
    tile := Tile name: tileName imageClass: self imageClass.
    tile isNil ifTrue: [^1@1].
    self tileExtent: (ext := tile extent).
    ^ext!  
convertAllTo: newExtension
    "Convert receiver tiles to new images
    using extension newExtension for all
    the receiver's zooms"

    self zooms do: [:each|
        self
            withZoom: each
            do: [ self convertTo: newExtension ]
    ].! 
convertTo: newExtension
    "Convert receiver tiles to new images
    using extension newExtension for the
    current zoom"

    | tile bitmap |
    1 to: self numberOfTiles
    do: [:i|
        tile := self tileNumber: i.
        tile notNil ifTrue: [
            bitmap := tile bitmap.
            bitmap isValid
            ifTrue: [
                bitmap saveAs: (tile name upTo: $.),'.',newExtension.
                tile release.
            ]
        ].
    ].
    self fileExtension: newExtension! 
currentInformation
    "Private - returns the information for current zoom."

    currentZoom isNil ifTrue: [^Dictionary new].

    ^self information
        at: currentZoom
        ifAbsent: [
            information
                at: currentZoom
                put: Dictionary new
            ]!   
displayAt: aPoint
    "Display the receiver at aPoint with Display pen."

    ^self displayAt: aPoint with: Display pen!   
displayAt: aPoint with: aPen
    "Display the receiver at aPoint on aPen's medium
      using aPen."

    | tile |
    1 to: self numberOfTiles do: [:tileNumber |
        tile := self tileNumber: tileNumber.
        tile notNil ifTrue: [tile displayAt: aPoint with: aPen]
    ].!   
displayRectangle: aRectangle at: aPoint with: aPen
    "Display the receiver in aRectangle on aPen's medium
     using aPen."

    | tile tileBox displayBox drawExtent tileExtent |
    tileBox := 0@0 extent: self tileExtent.
    (self tilesInRectangle: aRectangle)
    do: [:tileNumber |
        tile := self tileNumber: tileNumber.
        tile notNil ifTrue: [
            tileExtent := tile extent.
            (tileExtent x < tileBox width or: [tileExtent y < tileBox height])
            ifTrue: [ "must erase non overlaping regions..."
                (tileBox nonIntersections: (0@0 extent: tileExtent)) do: [:box|
                    aPen fill: (box translateBy: tile origin) color: aPen backColor ]
            ].
            displayBox := aRectangle intersect: tile boundingBox.
            drawExtent := displayBox rightBottom  - displayBox leftTop. "ojo... width y height no sirven pues son absolutos..."
            (drawExtent x > 0 and: [ drawExtent y > 0])
            ifTrue: [
                tile display: displayBox at: aPoint with: aPen.
                "aPen place: displayBox origin;box: displayBox corner"
            ].
        ].
    ].!   
displayRectangle: aRectangle at: aPoint with: aPen zoom: scale
    "Display the receiver in aRectangle on aPen's medium using aPen."

    self zoom: scale.
    ^self displayRectangle: aRectangle at: aPoint with: aPen! 
displayRectangle: aRectangle with: aPen
    "Display the receiver in aRectangle on aPen's medium using aPen."

    ^self displayRectangle: aRectangle at: aPen location with: aPen!
extent
    "Returns the instance var of the receiver
     for external manipulation"

    extent isNil
    ifTrue: [ extent := self sizeInTiles * self tileExtent ].

    ^extent! 
fileExtension
    "Returns the file extension for the receiver's images
     using the current zoom"

    ^self currentInformation at: #fileExtension: ifAbsent: [String new]!
fileExtension: anObject
    "Sets the file root-name for the receiver's images
     using the current zoom"

    ^self currentInformation
        at: #fileExtension:
        put: anObject!
fileName
    "Returns the file root-name for the receiver's images
     using the current zoom"

    ^self currentInformation at: #fileName: ifAbsent: [String new]!  
fileName: anObject
    "Sets the file root-name for the receiver's images
     using the current zoom"

    ^self currentInformation
        at: #fileName:
        put: anObject!  
fileNameTile: tileNumber
    "Private - Returns the full file name for tile 'tileNumber' "

    | extension root |
    root := self root. root isNil ifTrue: [^nil].
    extension := self fileExtension. extension isNil ifTrue: [^nil].
    (tileNumber between: 1 and: self numberOfTiles) ifFalse: [^nil].
    ^root, tileNumber asString, '.', extension! 
getPrivateInformation
    "Private - Extract settings form iniFile..."
    | profiler thisProfiler dict getValue
     getPoint stream x y token profilerPath |
    information := Dictionary new.
    iniFile isNil ifTrue: [^self].

    profilerPath := PathFinder locationFor: iniFile.
    profiler := WinProfiler new
        pathName: profilerPath;
        applicationName: self class name.
    token := profiler at: 'imageClass' ifAbsent: [#default].
    token size = 0 ifTrue: [token := #default].
    token = #default
    ifTrue: [ self imageClass: nil ]
    ifFalse: [
        self imageClass:
            (Smalltalk at: token trimBlanks asSymbol ifAbsent: [])
    ].

    profiler applicationName: 'Zooms'.

    getValue := [:aSymbol|
        dict
            at: aSymbol
            put: (thisProfiler at: (aSymbol asString upTo: $:))
        ].

    getPoint := [:array|
        stream := ReadStream on: array.
        token := stream next.
        x := thisProfiler at: stream next.
        y := thisProfiler at: stream next.
        x notNil & y notNil ifTrue: [ dict at: token put: x asNumber@y asNumber ]
        ].

    profiler keys do: [:key|
        thisProfiler :=
            WinProfiler new
                pathName: profilerPath;
                applicationName: (profiler at: key ifAbsent: [key asString]).
        dict := Dictionary new.
        getValue
            value: #fileName:;
            value: #fileExtension:.
        getPoint
            value: #(sizeInTiles: 'widthInTiles' 'heightInTiles');
            value: #(tileExtent: 'tileWidth' 'tileHeight').
        information at: (Compiler evaluate: key) put: dict.
    ].! 
imageClass
    "Returns a class used for generation image tiles.
    Or nil if not preferred image class..."

    ^imageClass!
imageClass: aClass
    "Sets a class used for generation image tiles.
    aClass class can be nil for default app use of image handler..."

    imageClass := aClass! 
information
    "Private - Returns the receiver's information"

    information isNil ifTrue: [
        self getPrivateInformation
    ].
    ^information! 
iniName
    "Returns the name of the initialization file of the receiver"

    ^iniFile!   
iniName: aPathName
    "Sets the name of the initialization file for the receiver"

    iniFile := aPathName!  
initialize
    "Private - Initialize the receiver"

    super initialize.
    currentZoom := 1.!  
inside: aRectangle do: aBlock
    "Perform aBlock with the tiles in aRectangle.
    aBlock must be a two argument block;
    During block evaluation
        1st argument will be the current bounding rectangle
        2nd argument will be the current tile
    "
    | tile tileBox |
    tileBox := 0@0 extent: self tileExtent.
    (self tilesInRectangle: aRectangle)
    do: [:tileNumber |
        tile := self tileNumber: tileNumber.
        tile notNil ifTrue: [
            aBlock
                value: (tileBox translateBy: tile origin)
                value: tile.
        ].
    ].! 
loadFrom: anIniFileName
    "Extrae self de un ini llamado anIniFileName"

    iniFile := anIniFileName.
    self getPrivateInformation.! 
newZoom: aNumber
    "Create a new zoom factor in the receiver..."
    | dict |
    aNumber isNumber
    ifFalse: [^self error: 'El zoom debe ser un Nmero.'].
    dict := Dictionary new.
    dict
        at: #fileName: put: self fileName;
        at: #fileExtension: put: self fileExtension;
        at: #sizeInTiles: put: self sizeInTiles;
        at: #tileExtent: put: self tileExtent;
        yourself.
    information at: aNumber put: dict.!
numberOfTiles
    "Private - Returns the number of tiles in the receiver..."
    | matrix |
    matrix := self sizeInTiles.
    ^matrix x * matrix  y!
pack
    "Pack the receiver into an image library for resources optimization."

    | library count storageClass |

    storageClass := self class storageClass.
    storageClass isNil
    ifTrue: [ ^self error: 'No puede empaquetarse por no estar implementado storage-system' ].

    count := self numberOfTiles.
    count > 0 ifFalse: [ ^self error: 'Esta imgen no tiene tiles a empaquetar.' ].

    library := storageClass named: self root.
    library notNil
    ifTrue: [
        library isValid
        ifTrue: [
            library release.
            (MessageBox confirm: 'La librera ya est creada y es vlida.\Seguro desea escribir dentro de ella ms imgenes ?' withCrs)
            ifFalse: [ ^nil ].
        ].
        library release.
    ].

    library := storageClass createLibrary: self root count: count.
    Tile clearCache.
    1 to: count do: [:index|
        library at: index put: (self tileNumber: index).
    ].
    Tile clearCache.
    library release.!  
packAll
    "Pack the receiver for all the receiver's zooms"

    self zooms do: [:each|
        self
            withZoom: each
            do: [ self pack ]
    ].

    "change the receiver to use packed storage system..."
    self imageClass: self class storageClass.! 
print: sourceRect inside: destRect using: aPrinter
    "Implemented for printing...
      sourceRect will be the area inside the receiver's boundingBox (in pixels) to be printer
      destRect will be the destination area for output (in inches)
      aPrinter will be the current printer to use (placed in the current page).

    WARNING: The P3 library will be used for printing...

    "

    "No era del todo satisfactorio por eso lo baje a PictureBitmap...
       * Uno de los defectos era que si se tiene que hacer un redraw mientras
          esta imprimiendo se nota diferencias de paleta en el display (con la p3)
       * Otro que la P3 no maneja bien las unidades de impresion???
            (por lo que no sale coordinado con el recuadro...)

    self
        withImageClass: P3Image
        do: [ self basicPrint: sourceRect inside: destRect using: aPrinter ]
    "

    ^self basicPrint: sourceRect inside: destRect using: aPrinter!
removeZoom: aNumber
    "Remove the zoom settings aNumber"

    ^information removeKey: aNumber ifAbsent: [nil]!   
root
    "Private - Returns the root file name for tiles..."

    ^PathFinder locationFor: self fileName!  
save
    "Save the receiver's settings to the ini file..."

    self saveAs: iniFile.! 
saveAs: pathName
    "Save the receiver's settings to an ini file named pathName"

    | profiler dialog file realPath |
    pathName size = 0
    ifTrue: [
        dialog := FileDialog new.
        dialog
            title: 'Elija el archivo donde guardar el seteo.';
            addFilter: '*.ini' description: 'Archivos de inicializacin standards (*.INI)';
            addFilter: '*.*' description: 'Todos los archivos (*.*)';
            fileSpec: (iniFile isNil ifTrue: ['Anonimo.Ini'] ifFalse: [PathFinder locationFor: iniFile]);
            hideReadonly;
            overwritePrompt;
            save.
        file := dialog file.
        file isNil ifTrue: [^nil].
        ^self saveAs: file
    ].

    realPath := PathFinder locationFor: pathName.
    (File exists: realPath)
    ifFalse: [ (File newFile: realPath) close ].

    profiler := WinProfiler new
        pathName: realPath;
        applicationName: self class name.

    profiler at: 'imageClass' put:
        (self imageClass isNil
            ifTrue: [#default]
            ifFalse: [self imageClass symbol]).

    profiler applicationName: 'Zooms'.

    self zooms do: [:each|
        profiler
            applicationName: 'Zooms';
            at: each asString put: each asString;
            applicationName: each asString.
        self
            withZoom: each
            do: [
                profiler
                    at: 'fileName' put: self fileName;
                    at: 'fileExtension' put: self fileExtension;
                    at: 'widthInTiles' put: self sizeInTiles x;
                    at: 'heightInTiles' put: self sizeInTiles y;
                    at: 'tileWidth' put: self tileExtent x;
                    at: 'tileHeight' put: self tileExtent y;
                    yourself
            ].
    ].

    iniFile := pathName.!
sizeInTiles
    "Returns the receiver's size in tiles
    for the current zoom..."

    ^self currentInformation
        at: #sizeInTiles:
        ifAbsent: [1@1]! 
sizeInTiles: aPoint
    "Sets the receiver's size in tiles
    for the current zoom..."

    ^self currentInformation
        at: #sizeInTiles:
        put: aPoint!
tileExtent
    "Returns the instance var of the receiver
     for external manipulation"
    | tileExtent |
    tileExtent := self currentInformation at: #tileExtent: ifAbsent: [].
    tileExtent isNil ifTrue: [ tileExtent := self computeTileExtent ].
    ^tileExtent!
tileExtent: aPoint
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"

    currentZoom notNil
    ifTrue: [ self currentInformation at: #tileExtent: put: aPoint ].!  
tileNumber: tileNumber
    "Private - Returns a 'Tile' object for self at 'tileNumber'
     Generacin de posicin para cada tile
        Orden de los tiles
                  0 1 2
                  |  |  |
         0 -> 1 2 3
         1 -> 4 5 6
         2 -> 7 8 9
    "
    | tile row col tileName widthInTiles tileExtent |
    tileName := self fileNameTile: tileNumber.
    tileName isNil ifTrue: [^nil].
    tile := Tile name: tileName imageClass: self imageClass.
    tile isNil ifTrue: [^nil].
    widthInTiles := self sizeInTiles x max: 1.
    row := tileNumber - 1 // widthInTiles.
    col := tileNumber - 1 \\ widthInTiles.
    tileExtent := self tileExtent.
    tile origin: (tileExtent x * col) @ (tileExtent y * row) + 1.
    ^tile.!
tilesInRectangle: aRectangle
    "Private - Returns the tiles inside aRectangle."

    |  start end result number maxTile widthInTiles tileExtent |
    widthInTiles := self sizeInTiles x.
    maxTile := widthInTiles * self sizeInTiles y.
    tileExtent := self tileExtent.
    result := OrderedCollection new.
    (tileExtent x = 0 or: [tileExtent y = 0]) ifTrue: [^result].
    start := aRectangle leftTop // self tileExtent + 1.
    end := aRectangle rightBottom // self tileExtent + 1.
    start y to: end y do: [:row |
        start x to: end x do: [:col |
            number := row * widthInTiles - widthInTiles + col.
            number <= maxTile ifTrue: [ result add: number ].
        ].
    ].
    ^result! 
withImageClass: anImageClass do: aBlock
    "Private - Evaluates aBlock forcing the receiver to the imageClass anImageClass.
    USE with CARE: All the tiles cache will be cleared...
    The result of evaluating aBlock will be returned."

    | oldClass result |
    Tile clearCache.
    oldClass := self imageClass.
    self imageClass: anImageClass.
    result := aBlock value.
    self imageClass: oldClass.
    Tile clearCache.
    ^result!  
withZoom: aZoom do: aBlock
    "Perform aBlock with zoom aZoom and restore old zoom state.
     Returns the result of evaluating aBlock..."
    | old result |
    old := currentZoom.
    self zoom: aZoom.
    result := aBlock value.
    self zoom: old.
    ^result! 
zoom
    "Returns the current zoom in use"
    ^currentZoom!
zoom: aNumber
    "Configure the receiver for using zoom"
    | options |
    currentZoom = aNumber ifTrue: [^self].
    aNumber isNil ifTrue: [^self zoom: 1].
    aNumber isNumber ifFalse: [^self error: 'El zoom debe ser un nmero.'].

    (self canZoom: aNumber)
    ifFalse: [
        self getPrivateInformation.
        (self canZoom: aNumber) ifFalse: [^nil]
    ].

    currentZoom := extent := nil.
    options := self currentInformation.
    options keysDo: [:each|
        self perform: each with: (options at: each)
    ].
    currentZoom := aNumber.!   
zooms
    "Returns the available zooms in the receiver"
    ^self information keys asSortedCollection! !

! BusLine class methods !   
name: aName in: aTransportationNet
    "Returns an instance of the receiver for working in aTransportationNet"

    ^self new
        name: aName;
        net: aTransportationNet;
        yourself! !

! BusLine methods !  
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!  
name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject! 
net
    "Returns the instance var of the receiver
     for external manipulation"
    ^net!
net: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    net := anObject! !

! TransportationNet methods !
get: aTransportationMedium named: aString
    " Returns line named aString (or create on if does not exist)"

    ^self lineNamed: aString ifAbsent: [
            lines add: (aTransportationMedium name: aString in: self)
        ]!  
initialize
    " Private - Initializes the receiver..."

    super initialize.
    lines := Set new.
    sheets := Dictionary new.!  
lineNamed: aString
    " Returns line named aString (or nil if absent)"

    ^self lineNamed: aString ifAbsent: []!
lineNamed: aString ifAbsent: aBlock
    " Returns line named aString (evaluates aBlock if absent)"

    ^lines detect: [:each| each name = aString] ifNone: aBlock!
lines
    "Returns the instance var of the receiver
     for external manipulation"
    ^lines!
sheets
    "Returns the instance var of the receiver
     for external manipulation"
    ^sheets! !

! ApplicationSystem class methods ! 
aboutBox
    "Private - Open the About App dialog box"

    self withModule: 'About Dialog Box' do: [:about| about open].! 
aboutToSaveImage
    "Perform system cleanUp for saving image..."

    super aboutToSaveImage.

    "Invalidate Turle gloval variable if not open..."
    Turtle notNil
    ifTrue: [ "Has been opened..."
        Turtle privateHandle isNil "and closed..."
        ifTrue: [ Turtle := nil ]
    ].! 
allObjects
    "Returns the most used objects cache"

    AllObjects isNil ifTrue: [self initializeAllObjects].
    ^AllObjects!  
atKey: aKey
    "Returns the Application Object  named aKey;
     if absent returns nil"
    ^self atKey: aKey ifAbsent: [ ]!  
atKey: aKey ifAbsent: aBlock
    "Returns the Application Object  named aKey
     if absent evaluates aBlock"
    ^self allObjects at: aKey ifAbsent: aBlock!  
atKey: aKey put: anObject
    "Places anObject as an object named aKey.
     if anObject isNil removes it "
    anObject isNil
    ifTrue: [
        self allObjects removeKey: aKey ifAbsent: [].
        ^nil
    ].
    ^self allObjects at: aKey put: anObject!   
cleanAllObjects
    "Private - Clean the AllObjects dictionary"
    | allObjects |
    allObjects := self allObjects.
    "Release dependences of the objects in use..."
    allObjects values do: [:each| each release].
    allObjects keys do: [:each|
        allObjects removeKey: each ifAbsent: []
    ]!  
cleanDesktop
    "Private - Clean the windows on the desktop"

    "TIP: Hiding the windows first we
        inhibit background redisplay when each
        window is closed..."
    self currentOpenWindows
    do: [:manager |
        manager views
        do: [:each| each hideWindow ]
    ].

    self currentOpenWindows
      do: [:manager | manager close ]!  
cleanUpDesktop
    "Private - Clean the windows on the desktop and purge database cache"

    CursorManager execute changeFor: [ self cleanDesktop ]!  
close
    "close toolbar and exit application"

    self toolBar notNil
    ifTrue: [ self toolBar close ]!   
closeModules
    "Private - Ends the current modules..."

    self currentModules associationsDo: [:asoc|
        asoc value applicationEnds: self
    ]!
copywrite
    "Private - Returns the Copywrite Information"

    ^(self profiler
        at: 'Copywrite'
        ifAbsent: ['@Object Style \ Soler 4545 \ Tel/Fax: 833-3363']) withCrs!  
currentDDEServer
    "Private - Returns the DDE Server..."

    ^self withModule: 'DDE Server' do: [:module| module server]!   
currentModules
    "Private - Returns current running modules..."

    ^self atKey: #modules ifAbsent: [
        self atKey: #modules put: Dictionary new]!   
currentOpenWindows
    "Private - Returns the windows on the desktop"

    | manager viewClasses set |
    set := Set new.
    viewClasses :=
        (Smalltalk isRunTime
        ifTrue: [ #(Object ) ]
        ifFalse: [ #(OSViewManager OSDialog) ])
        collect: [:each| Smalltalk at: each ifAbsent: []].
    Notifier windows do: [:aWindow|
        aWindow isApplicationWindow
        ifTrue: [
            manager := aWindow owner.
            viewClasses do: [:cls|
                (manager isKindOf: cls)
                ifTrue: [ set add: manager ]
            ]
        ].
    ].
    set remove: self toolBar ifAbsent: [].
    ^set!
defaultProfilePathName
    "Private - Returns default profiler path name"

    ^self implementedBySubclass!
errorIn: aProcess label: aLabel
    "Maneja los errores en runtime"

    | notifyer |
    FileHandle cleanHandles.
    self log: #error for: aProcess label: aLabel.
    notifyer := self model.
    notifyer notNil ifTrue: [
        notifyer show: #error message: 'Error : ',aLabel
    ]!   
exitApplication
    "Private - Exit the receiver engines."

    CursorManager execute change.

    self log: #beginExit label: self name.
    self cleanDesktop.
    self atKey: #toolBar put: nil.

    "Close current modules & cleanUp Objects..."
    self
        closeModules;
        cleanAllObjects.

    "Signal app exit..."
    self log: #endExit label: self name.

    "Restore normal cursor..."
    CursorManager normal change.

    "Clear system setUp"
    self atKey: #system put: nil.!   
helpDictionary
    "Private - Returns the Help dictionary map"

    ^Dictionary new!   
helpFailed: contextId
    "Private - A help Request has failed.Lets the user know the topic. "

    self warning: 'Ayuda inexistente : "' withCrs, contextId asString,'"'.!
helpFileName
    "Returns the help file name.
    This method must be refinde by subclasses..."

    ^nil!
helpRequest
    "Send the request to the toolbar it it exists"

    | toolBar |
    (toolBar := self toolBar) isNil ifTrue: [^self].
    toolBar mainView helpRequest!   
initializeAllObjects
    "Private - Initialize the All Objects"

   AllObjects := Dictionary new.
    self atKey: #system put: self.! 
initializeModules
    "Private - Initialize the All the receiver's modules"
    | module |
    self modules do: [:array|
        module := Smalltalk at: array first ifAbsent: [].
        module notNil
        ifTrue: [
            module := module new.
            module applicationStarts: self.
            self currentModules
                at: array last
                put: module
        ].
    ]!
installModule
    "Private - Perform module instalation..."

    ^self withModule: 'Module Installer' do: [:module| module installModule]! 
label
    "Private - Returns the default system label of toolbar"

     ^self name!
log: aSymbol for: aProcess label: aLabel
    "Private - Log an error in loggin file"

    ^self
        withModule: 'LOG File'
        do: [:module| module log: aSymbol for: aProcess label: aLabel ]!  
log: aSymbol label: aLabel
    "Private - Log an error in loggin file"

    ^self log: aSymbol for: nil label: aLabel! 
model
    "Returns the current application model or nil"
    ^self atKey: #model ifAbsent: []!  
model: anApplicationModel
    "Sets the current application model to anApplicationModel"
    ^self atKey: #model put: anApplicationModel!   
moduleFor: aString
    "Returns the current module in use
    for aString...
    Example:
        self moduleFor: 'DDE Server'
        (Will return the default server connection or nil if absent...)
    "

    ^self currentModules at: aString ifAbsent: []!  
modules
    "Private - Returns the description for modules
    to be automatically instaled in the receiver...
    This method can be refined by subclasses.
    Must return an array of subarrays that contains
    class name & description of the receiver's module..."

    ^#(
        "modules must be sorted by startUp order..."
        (LogAppModule 'LOG File')
        (AppCursorModule 'Cursor Replacement')
        (AboutAppModule 'About Dialog Box' )
        (DDEServerModule 'DDE Server' )
        (ModuleInstaller 'Module Installer')
        "
        (OSProtectionModule 'Sofware Protection')
        (MoreOpenFilesModule 'More Open Files Module')
        (AppDataModule 'Database Module')
        "
        )!  
open
    "Message for application startUp..."
    | log  banner |

    "Initialize catched objects and modules..."
    self
        initializeAllObjects;
        initializeModules.

    self profiler keys isEmpty ifTrue: [
        ModalMessageBox
            warning: 'Configuration file is missing\Make ' withCrs,
                self profilePathName , ' available'  .
        Smalltalk isRunTime ifTrue: [Smalltalk exit].
        ^self
    ].

    "Check for Runtime Library existence..."
    self resourceClass library isNil & Smalltalk isRunTime
    ifTrue: [^Smalltalk exit].

    "Open the banner"
    banner := self openBanner.
    CursorManager execute change.

    " Be CUA compliant"
    CUA := (self profiler at: 'CUA' ifAbsent: ['true']) asLowerCase = 'true'.

    "Signal the application startUp"
    self log: #starting label: self name.

    "Open the main toolbar window"
    self
        queryUser;
        openToolBar;
        yourself.

    "Close startUp banner"
    banner notNil ifTrue: [ banner close ].

    "Open aditional windows"
    self openOtherWindows.! 
openBanner
    "Private - Open the banner and returns it"
    "Default action is no banner"

    ^(Smalltalk at: #LogoView ifAbsent: [^nil]) new open!
openNotes
    "Private - Open a notes window"

    ^String new edit!   
openOtherWindows
    "Private - Open the aditional windows of the receiver.
    The default is to do nothing..."!   
openToolBar
    "Private - Open the main tool bar window"
    | toolBar |
    toolBar := (Smalltalk
        at: #MainToolBar
        ifAbsent: [^self implementedBySubclass]) new.

    "Register the toolbar as current toolBar"
    self atKey: #toolBar put: toolBar.

    "Special tools may be added here..."
    toolBar
        addTools: self tools;
        whenClose: [ self exitApplication ].
    "End of toolBar settings..."

    toolBar
        label: self label;
        open.

    self setUpHelpManagerFor: toolBar.! 
pack
    "Private - Packs the current image extracting unused components"
    | toDestroy |

    (MessageBox confirm: 'Do you want to pack this image ?')
    ifFalse: [^nil].

    "Destroy development projects"
    #( WBProject ) do: [:project|
        (toDestroy := Smalltalk at: project ifAbsent: []) notNil
        ifTrue: [ toDestroy destroy ]
    ].

    "Remove non-runtime classes"
    #( ProjectClasses CPBitmapManager
        ChunkBrowser CategoryBrowser CategoryManager
     ) do: [:aClass|
        (toDestroy := Smalltalk at: aClass ifAbsent: []) notNil
        ifTrue: [ toDestroy removeFromSystem ]
    ].

    MessageBox
        message: 'This system has been packed.\Now save the image please...' withCrs.

    Notifier reinitialize.! 
printer
    "Returns an instance of Printer ready to be used"

    ^self
        atKey: #printer
        ifAbsent: [
            self
                atKey: #printer
                put: self printerClass new
        ]!  
printerClass
    "Private - Returns the class to be used for receiver's default printer"

    ^OSPrinter!  
product
    "Private - Returns the Product name"

    ^(self profiler
        at: 'Product'
        ifAbsent: [self label]) withCrs! 
queryUser
    "Private - Prompt for the user working and set the current user.
    The default is to do nothing..."!
resourceClass
    " Private - returns the class for resources..."

    ^ObjectStyleDLL!
runProgram
    "Private - User selected the Run... menu item
    and wants to run a program.
    Implemented By Ale"

    | dialog |
    dialog := (Smalltalk at: #RunProgramDialog ifAbsent: [^nil]) new.
    dialog open!
setUpHelpManagerFor: aViewManager
    "Private - SetUp the Helpmanager of the receiver"

    | hm |
    aViewManager mainView isMDIChild | self helpFileName isNil
    ifTrue: [ ^self ].

    hm := OSHelpManager
            for: aViewManager mainView
            title: self label,' Help'
            file: self helpFileName.

    "Now initialization for the Help Ids..."
    hm map: self helpDictionary.

    aViewManager mainView helpManager: hm.

    ^hm!
system
    "Private - Returns the current System"

    ^self atKey: #system ifAbsent: []!  
test
    "Private - Test the system.
    This method can be used during Software Protection tests.
    Default action is to do nothing."

    ^self withModule: 'Sofware Protection' do: [:module| module test ]!
toolBar
    "Returns the system toolBar"
    ^self atKey: #toolBar! 
tools
    "Returns the tools for the current user.
    Default action is to set none..."
    | user |
    "... user := User working. "
    user isNil ifTrue: [^Array new].
    ^user tools!
version
    "Private - Returns the Product name"

    ^(self profiler
        at: 'Version'
        ifAbsent: ['1.0']) withCrs!  
warning: aLabel
    "Private - Alert the user about aLabel"

    | notifyer |
    self log: #warning label: aLabel.
    notifyer := self model.
    notifyer notNil ifTrue: [
        notifyer show: #warning message: 'Atencin : ',aLabel
    ]!
withModule: aString do: aBlock
    "Private - Perform aBlock using the module named aString"
    | module |
    module := self moduleFor: aString.
    ^module notNil ifTrue: [ aBlock value: module ].! !

! ApplicationSystem methods !   
initialize
    "Private - Initialize the receiver"
    "Default action is to do class initialization if needed"
    "This method could be refined by subclasses..."

    super initialize.
    AllObjects isNil ifTrue: [self class initializeAllObjects].! !

! CDGuiaApplication class methods !
defaultProfilePathName
    "Private - Returns default profiler path name"

    ^Disk drivePathName,'\CD-Guia.Ini'! 
helpFileName
    "Returns the help file name"

    ^'CD-Guia.Hlp'! 
label
    "Private - Returns the default system label of toolbar"

     ^'CD-Guia'!
modules
    "Private - Returns the description for modules..."

    ^super modules,
    #(
        "modules must be sorted by startUp order..."
        (CDGuiaInstalationModule 'Instalation module')
        (TileGarbageCollectModule 'Tiles Garbage Collector module')
        (TileImagesModule 'Image Manager module')
        (StickersModule 'Stickers module')
        )!  
openMDIView
    "Private - Open the MDI view window"

    | view |
    view := MDICDGuia new.
    self atKey: #toolBar put: view.
    view
        whenClose: [ self exitApplication ];
        open.

    self model updateToolsAndMenues.!
openNonMDIView
    "Private - Open the main tool bar window in non MDI mode"

    super openToolBar.

    self toolBar toolPane
        owner: self model;
        when: #doubleClicked perform: #editToolBar:!
openToolBar
    "Private - Open the main tool bar window"

    "Sets the Application model in Use..."
    self model: CDGuiaModel new.
    self model canBuildMaps:
        (Smalltalk isRunTime not or: [ (self profiler at: 'canBuildMaps' ifAbsent: ['false']) asLowerCase = 'true' ]).

    (self profiler at: 'MDI' ifAbsent: ['false']) = 'true'
    ifTrue: [ self openMDIView ]
    ifFalse: [ self openNonMDIView ]!   
printerClass
    "Private - Returns the class to be used for receiver's default printer"

    ^P3Printer!  
toolFor: aSymbol
    "Private - Returns aTool named aName..."
    | bitmap bmp tool |
    bmp := CPBitmapDict at: aSymbol asString.
    bmp width = 75
    ifTrue: [ "3 state tool"
        bitmap := Bitmap screenExtent: 50@bmp height.
        bitmap pen
            copyBitmap: bmp
            from: bitmap boundingBox
            to: bitmap boundingBox
    ] ifFalse: [ bitmap := bmp ].
    tool := Tool fromBitmap: bitmap.
    ^tool
        extent: bitmap width // 2 @ bitmap height;
        selector: aSymbol;
        owner: self model;
        yourself! 
tools
    "Returns the tools from the current toolBar SetUp."

    | tools inUse index profiler groups
      tool currentTools |
    currentTools := OrderedCollection new.
    tools := self model tools.
    profiler := (Smalltalk at: #MainToolBar) basicNew profiler.
    groups := (tools select: [:each| each isNumber]) size + 1.
    inUse := OrderedCollection new.
    1 to: groups do: [:i|
        (profiler at: 'Tools',i asString ifAbsent: [String new]) asArrayOfSubstrings
        do: [:selector|
            inUse add: selector asSymbol
        ]
    ].

    tools do: [:each|
        (inUse includes: each)
        ifTrue: [
            tool := self toolFor: each.
            index := (tools indexOf: each) - 1.
            (index > 0 and: [(tools at: index) isNumber])
            ifTrue: [ tool space: (tools at: index) ].
            currentTools addLast: tool.
        ]
    ].

    currentTools
        detect: [:each| each selector = #customizeToolBar]
        ifNone: [
            tool := self toolFor: #customizeToolBar.
            tool space: 10.
            currentTools addLast: tool
        ].

    ^Array with: currentTools asArray! !

! ChuteObject class methods ! 
new
    ^super new
        initialize;
        yourself! !

! ChuteObject methods !  
addFrameAt: aPoint extent: extent offset: displacement

    self
        addFrameAt: (aPoint extent: extent)
        offset: displacement!
addFrameAt: aRectangle offset: displacement

    self steps add: (Array with: aRectangle with: displacement)!   
addFrameAtX: x y: y extent: extent offset: displacement

    self
        addFrameAt: x@y
        extent: extent
        offset: displacement!   
addFrames: frameSpec
    "Add new frames for the receiver from frameSpec
     frameSpec must be an array with this format
        #( extentX extentY offsetX offsetY
            yCoord1 (xCoord1 xCoord2 xCoord3 ... )
            yCoord2 (xCoord1 xCoord2 xCoord3 ... )
            --------------------------
            yCoordn (xCoord1 xCoord2 xCoord3 ... )
          )

    "
    | stream extent x y offset |
    stream := ReadStream on: frameSpec.
    extent := stream next @ stream next.
    offset := stream next @ stream next.
    [ stream atEnd ] whileFalse: [
        y := stream next.
        stream next do: [:x|
            self
                addFrameAtX: x y: y
                extent: extent
                offset: offset
        ]
    ]!   
backColor
    ^backColor!
backColor: aColor
    ^backColor:= aColor!   
bitmap
    ^bitmap!  
bitmap: aBitmap
    ^bitmap := aBitmap!  
initialize
    "Private - Initialize the receiver"

    steps := OrderedCollection new.
    backColor :=  ClrWhite.!  
steps
    ^steps! !

! CursorMovie class methods ! 
clock
    "Returns an instance of the receiver
     with cursor named clock1,clock2,clock3...
     loaded from ObjectStyleDLL"
    ^self
        fromModule: ObjectStyleDLL library
        id: 'clock'!
fromModule: aModule id: aName
    "Returns an instance of the receiver
     with cursor loaded from aModule.
     aName can be acollection of names
     or a string that will be used to build
      the names of the cursos to load
        See message #clock for a demo"
    ^self new
        load: aName from: aModule;
        yourself!  
new
    ^super new initialize!   
replaceCursor: aCursorName with: aCursor
    "Replaces the cursor named aCursorName in CursorConstants to aCursor.
      Returns the old cursor or nil if absent.
      The old cursor will NOT be released."
    | old |
    old := CursorConstants at: aCursorName ifAbsent: [].
    CursorConstants at: aCursorName put: aCursor.
    ^old! 
replaceExecuteCursor
    "Replaces the execute to the clock cursor"
    | clock |
    (clock := self clock) isEmpty
    ifFalse: [ self replaceCursor: 'HourGlass' with: clock ]! 
restoreCursorConstants
    "Restore the CursorConstants to original cursors"
    CursorConstants associationsDo: [:asoc|
        (asoc value isKindOf: CursorMovie)
        ifTrue: [asoc value release]
    ].
    "Restore original cursors..."
    CursorManager initialize.! !

! CursorMovie methods !  
add: aCursorManager
    "Add a cursor to the receiver's collection"
    ^self collection add: aCursorManager!   
atEnd
    "True if the receiver is atEnd"
    ^position >= collection size! 
change
    "Set the current cursor to the next available in the receiver"
    collection size = 0 ifTrue: [^self].
    (position = 0 or: [position > collection size])
    ifTrue: [position := 1].
    (current := collection at: position) change.
    position := position + 1!  
changeFor: aBlock
    "Set the current cursor to the next available in the receiver"
    collection size = 0 ifTrue: [^self].
    (position = 0 or: [position > collection size])
    ifTrue: [position := 1].
    (current := collection at: position) changeFor: aBlock.
    position := position + 1!
collection
    "Returns the instance var of the receiver
     for external manipulation"
    ^collection!  
do: aBlock until: aCondition
    "Perform aBlock changin the cursor until aCondition is satisfied.
     Restore the cursor upon termination..."
    | cursor |
    cursor := Cursor.
    self reset.
    [   self change.
        aBlock value
    ] until: [ aCondition value ].
    cursor change.!
doesNotUnderstand: aMessage
        "Delegates the response to the current cursor if not nil."
    current isNil ifTrue: [^super doesNotUnderstand: aMessage].
    aMessage receiver: current.
    ^aMessage perform! 
free
    "Free receiver's cursors"
    | aCursor |
    [ collection isEmpty ] whileFalse: [
        aCursor := collection removeLast.
        aCursor == Cursor "Current cursor can't be released now..."
        ifFalse: [aCursor release]
    ].
    self reset.!  
initialize
    "Private - Initialize the receiver"
    collection := OrderedCollection new.
    position := 1.
    current := nil.!   
isEmpty
    "True if the receiver has no cursors"
    ^collection isEmpty!  
load: aCollection from: aModule
    "Load the cursor resources from aModule.
     aCollection must be aCollection of names
     or aString that will be used to get cursor
     names appending the number of the position
        ...if aCollection = 'Clock'
            the cursor with names Clock1,Clock2,Clock...
            will be loaded upto a cursor is not found (or 50 cursors are loaded)
    "
    | stream prologue cursor cursorName |
    aCollection class == String
    ifTrue: [
        prologue := aCollection.
        stream := ReadStream on: (1 to: 50)
    ]
    ifFalse: [ stream := ReadStream on: aCollection ].
    [stream atEnd] whileFalse: [
        cursorName := stream next.
        cursorName isNumber
            ifTrue: [cursorName := prologue , cursorName printString].
        cursor := CursorManager
            loadCursor: cursorName
            fromDLL: aModule.
        cursor isNil
        ifTrue: [^self]
        ifFalse: [self add: cursor]
    ]!
release
    "Release receiver's cursors and posible dependences"
    self free.
    ^super release!
remove: aCursorManager
    "Remove a cursor from the receiver's collection"
    ^self collection remove: aCursorManager ifAbsent: []!   
reset
    "Set the receiver to start position"
    position := 1.
    current := nil.! !

! DragAndDropServer class methods !
aboutToSaveImage
     "Private - Default code.  Redefined by subclasses."

    self
        destroyCursors!   
cursors
     "Private - Returns cursor resources"
    ^Cursors! 
destroyCursors
     "Private - Destroy cursor resources"
    Cursors notNil
    ifTrue: [
        Cursors values do: [:each| each release].
        Cursors := nil
    ].!  
for: aWindow
    "Returns an instance of the receiver for aWindow"
    ^self new
        window: aWindow;
        yourself!   
initializeCursors
     "Private - Initialize cursor resources"
    | stream library cursorName aCursor |
    stream := ReadStream on: #(
        "cursor resources table...
            this table contents the cursor
            resource names in the default
            resource DLL for drag&drop operation.
        "
        copy 'copy file'
        copyAll 'copy files'
        move 'move file'
        moveAll 'move files'
        select 'select'
        invalid 'unavailable'
        ).
    Cursors := Dictionary new.
    [stream atEnd] whileFalse: [
        cursorName := stream next.
        aCursor := CursorManager
            loadCursor: stream next
            fromDLL: ObjectStyleDLL library.
        aCursor isNil
        ifFalse: [Cursors at: cursorName put: aCursor]
    ].

    "assume default operation for drop is copying the dragged object"
    Cursors
        at: #default
        put: (Cursors
            at: #copy
            ifAbsent: [CursorManager normal]);
        at: #defaultAll
        put: (Cursors
            at: #copyAll
            ifAbsent: [CursorManager normal])!
new
    ^super new initialize! !

! DragAndDropServer methods !
beginDrag
    "The receiver is notifyed to begin a drag operation"
    lastCursor := destination := nil.
    originalCursor := Cursor.
    objectToDrop :=
        (source respondsTo: #draggedObject)
        ifTrue: [source draggedObject]
        ifFalse: [nil].
    objectToDrop notNil
    ifTrue: [
        multipleSelectionDrag :=
            (source respondsTo: #isMultipleSelection)
            and: [source isMultipleSelection]
        ]!  
currentCursor
    "Private - Returns the proper cursor for the window under cursor"
    | model return |
    "is over a ST/V window?"
    destination := CursorManager windowUnderCursor.
    destination isNil ifTrue: [^self cursorFor: #invalid].

    return := [:aCursor| aCursor notNil ifTrue: [^aCursor]].

    "La accion de auto-drag&drop (no es til)"
    destination == source
    ifTrue: [
        destination := nil.
        ^originalCursor notNil
          ifTrue: [originalCursor]
          ifFalse: [^self cursorFor: #invalid"CursorManager normal"]
    ].

    " This code must be invalidated for inter window drag&drops...
    destination mainWindow owner == source mainWindow owner
    ifTrue: [destination := nil.^self cursorFor: #invalid].
    "

    model := destination owner.

     "is a dropable view manager"
    (model respondsTo: #canDrop:into:)
    ifFalse: [destination := nil.^self cursorFor: #invalid].

    "can handle the object to drop?"
    (model canDrop: objectToDrop into: destination) == true
    ifFalse: [destination := nil.^self cursorFor: #invalid].

    action :=
        (Notifier isKeyDown: VkShift) ifTrue: [#move]
        ifFalse: [
            (Notifier isKeyDown: VkControl) ifTrue: [#copy]
            ifFalse: [#default]
        ].

    "check if the model or the source or the destination
     want's to set the cursor himself..."
    (model respondsTo: #cursorForDrop:into:)
    ifTrue: [^return value: (model cursorForDrop: objectToDrop into: destination)].
    (source respondsTo: #cursorForDrop:into:)
    ifTrue: [^return value: (source cursorForDrop: objectToDrop into: destination)].
    (destination respondsTo: #cursorForDrop:from:)
    ifTrue: [^return value: (destination cursorForDrop: objectToDrop from: source)].


    objectToDrop isString not & objectToDrop isCollection
    ifTrue: [action := (action asString , 'All') asSymbol].

    "
    Transcript
        cr;nextPutAll: action;
        cr;nextPutAll: objectToDrop class name;
            space;nextPutAll: objectToDrop asString.
    "

    ^self cursorFor: action!
cursorFor: aSymbol
    "Returns the proper cursor for handling the operation
     expressed by aSymbol."
    Cursors isNil ifTrue: [self class initializeCursors].
    action := aSymbol.
    ^Cursors at: aSymbol ifAbsent: [CursorManager normal]! 
drag
    "The receiver is notifyed to stay into a drag operation.
     Look for the proper cursor"
    | newCursor |
    originalCursor isNil ifTrue: [^nil]. "beginDrag event not registered..."
    lastCursor == (newCursor := self currentCursor)
    ifFalse: [
        lastCursor := newCursor.
        newCursor change
    ].!   
endDrag
    "The receiver is notifyed to end a drag operation"
    | model |

    originalCursor isNil ifTrue: [^nil].
    originalCursor change.
    originalCursor := nil.
    destination isNil ifTrue: [^nil].

    model := destination owner.
    multipleSelectionDrag ifFalse: [objectToDrop := Array with: objectToDrop].

    objectToDrop do: [:each|
       ((model respondsTo: #drop:into:at:)
         or: [model respondsTo: #drop:into:])
        ifTrue: [
            "if the model needs the position of the dropped objet
             then sends the message #drop:into:at:"
            (model respondsTo: #drop:into:at:)
            ifTrue:  [
                model
                    drop: each
                    into: destination
                    at: Cursor offset
                         - destination frameRectangle origin ]
            ifFalse: [ model drop: each into: destination ].

            "perform move operation if the source  owner
             can remove aDroppedObject"
            ((#(move moveAll) includes: action)
             and: [source owner respondsTo: #removeDragged:from:])
            ifTrue: [source owner removeDragged: each from: source]
        ].
    ].! 
initialize
    "Private - Initialize the receiver.
    This method could be refined by subclasses."!
window: aWindow
    "Register aWindow as the window served by the receiver..."
    source := aWindow! !

! GraphicCapability class methods !  
for: aGraphicsMedium
    "Returns an instance of the receiver for aGraphicsMedium"
    ^self new
        graphicsMedium: aGraphicsMedium;
        yourself! !

! GraphicCapability methods !
aspect
    "Returns aPoint with relative aspect for line drawing."

    ^self aspectX @ self aspectY!  
aspectX
    "Relative width of a device pixel used for line drawing."
    ^self capability: Aspectx!
aspectXY
    "Diagonal width of a device pixel used for line drawing."
    ^self capability: Aspectxy!  
aspectY
    "Relative height of a device pixel used for line drawing."
    ^self capability: Aspecty!   
bitsPerPixel
    "Number of adjacent color bits for each pixel."
    ^self capability: Bitspixel!   
canClip
    "True if the dc can clip areas"

    ^self clipCaps ~= CpNone "0 in Win32 SDk is recomended to check with zero..."!
capability: aCapability
    "Private - Query the Device for the capability aCapability.
    Returns the query result (See getDeviceCaps function in SDK for more details).
    aCapability can be anInteger (for a cosnstant value)
    or aString for a WinConstant name
        E.g. : for getting Height of the device in pixels
            aCapability can be Vertres or 'Vertres'
    "
    ^GDILibrary
        getDeviceCaps: self deviceContext asParameter
        index: (aCapability isInteger
            ifTrue: [aCapability]
            ifFalse: [
              WinConstants
                at: aCapability
                ifAbsent: [ ^self error: 'Invalid Capability constant requested ',aCapability asString ]])!  
clipCaps
    "Clipping capabilities the device supports. It can be
    one of the following values:
        CpNone (0) Output is not clipped.
        CpRectangle (1) Output is clipped to rectangles.
        CpRegion (?) Output is clipped to regions. -This value is no longer documented in Win3.1 & Win32-
    "
    ^self capability: Clipcaps! 
colorResolution
    "Color resolution of the device, in bits per pixel."

    self hasPalette ifFalse: [^0].
    ^self capability: Colorres!  
curveCaps
    "Curve capabilities the device supports."

    ^self capability: Curvecaps!  
curveSupport: aCurveCaps
    "Returns true if the device supports aCurveCaps capability constant.
    aCurveCaps can be anInteger or an Cc constant name in WinConstant.
    E.g.: CcNone,CcCircles,CcPie,CcChord,CcEllipses,CcWide,CcStyled,CcWidestyled,CcInteriors
    "

    ^(self curveCaps bitAnd: (
        aCurveCaps isInteger
        ifTrue: [aCurveCaps]
        ifFalse: [
            WinConstants
                at: aCurveCaps
                ifAbsent: [^self error: 'Invalid curve caps constant ',aCurveCaps asString]])) ~= 0! 
deviceContext
    "Returns the current deviceContext in the receiver"

    graphicsMedium isInteger ifTrue: [^graphicsMedium].
    (graphicsMedium respondsTo: #deviceContext)
    ifTrue: [ ^graphicsMedium deviceContext ].
    ^graphicsMedium!  
driverVersion
    "Version number of the device driver."
    ^self capability: Driverversion!   
extent
    "Extent of the display in pixels x raster lines"

    ^self horzRes @ self vertRes! 
extentInInches
    "Extent of the physical display, in inches."

    ^self extentInMillimeters / 25.4! 
extentInMillimeters
    "Extent of the physical display, in millimeters."

    ^self horzSize @ self vertSize! 
graphicsMedium: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)
    anObject can be:
        1.- a valid device context id
        2.- an object that respondsTo #deviceContext (E.g. aGraphicsMedium)
        3.- aDeviceContext object
    "

    graphicsMedium := anObject.
    hasPalette := nil.!   
hasPalette
    "True if the dc can handle palettized output"

    hasPalette isNil ifTrue: [
        hasPalette := (self rasterCaps bitAnd: RcPalette) ~= 0
    ].
    ^hasPalette! 
horzRes
    " Width of the display, in pixels."
    ^self capability: Horzres!  
horzSize
    "Width of the physical display, in millimeters."
    ^self capability: Horzsize!   
lineCaps
    "Line capabilities the device supports."

    ^self capability: Linecaps! 
lineSupport: aLineCaps
    "Returns true if the device supports aLineCaps capability constant.
    aLineCaps can be anInteger or an Lc constant name in WinConstant.
    E.g.: LcNone,LcPolyline,LcMarker,LcPolymarker,LcWide,LcStyled,LcInteriors
    "

    ^(self lineCaps bitAnd: (
        aLineCaps isInteger
        ifTrue: [aLineCaps]
        ifFalse: [
            WinConstants
                at: aLineCaps
                ifAbsent: [^self error: 'Invalid line caps constant ',aLineCaps asString]])) ~= 0!  
logicalPixelsX
    "Number of pixels per logical inch along the display width."
    ^self capability: Logpixelsx!   
logicalPixelsY
    "Number of pixels per logical inch along the display height."
    ^self capability: Logpixelsy!  
numBrushes
    "Number of device-specific brushes."
    ^self capability: Numbrushes!   
numColors
    "Number of entries in the device's color table."
    ^self capability: Numcolors! 
numFonts
    "Number of device-specific fonts."
    ^self capability: Numfonts! 
numMarkers
    "Number of device-specific markers."
    ^self capability: Nummarkers!   
numPens
    "Number of device-specific pens."
    ^self capability: Numpens!
pDeviceSize
    "Size of the PDEVICE internal structure, in bytes."
    ^self capability: Pdevicesize!  
pixelsPerInch
    "Returns a point with the number of pixels per logical inch along the display"

    ^self logicalPixelsX @ self logicalPixelsY!  
planes
    "Number of color planes."
    ^self capability: Planes!  
polygonalCaps
    "Polygonal capabilities the device supports."

    ^self capability: Polygonalcaps!  
polygonalSupport: aPolygonalCaps
    "Returns true if the device supports aPolygonalCaps capability constant.
    aPolygonalCaps can be anInteger or an Pc constant name in WinConstant.
    E.g.: PcNone,PcPolygon,PcRectangle,PcWindpolygon,PcScanline,
        PcWide,PcStyled,PcWidestyled,PcInteriors
    "

    ^(self polygonalCaps bitAnd: (
        aPolygonalCaps isInteger
        ifTrue: [aPolygonalCaps]
        ifFalse: [
            WinConstants
                at: aPolygonalCaps
                ifAbsent: [^self error: 'Invalid polygonal caps constant ',aPolygonalCaps asString]])) ~= 0!   
rasterCaps
    "Raster capabilities the device supports."

    ^self capability: Rastercaps!   
rasterSupport: aRasterCaps
    "Returns true if the device supports aRasterCaps capability constant.
    aRasterCaps can be anInteger or an RC_ constant name in WinConstant.
    E.g.: RcBanding,RcBigfont,RcBitblt,RcBitmap64,RcDiBitmap,RcDibtodev,
     RcFloodfill,RcGdi20Output,RcPalette,RcScaling,RcStretchblt,RcStretchdib
    "

    ^(self rasterCaps bitAnd: (
        aRasterCaps isInteger
        ifTrue: [aRasterCaps]
        ifFalse: [
            WinConstants
                at: aRasterCaps
                ifAbsent: [^self error: 'Invalid raster caps constant ',aRasterCaps asString]])) ~= 0!
reservedPaletteEntries
    "Number of reserved entries in the system palette."

    self hasPalette ifFalse: [^0].
    ^self capability: Numreserved! 
sizePalette
    "Number of entries in the system palette."

    self hasPalette ifFalse: [^0].
    ^self capability: Sizepalette! 
support: aXXCapsName
    "Returns true if the device supports aXXCapsName capability constant.
    aXXCapsName MUST be a string with a name of a Rc,Lc,Cc,Pc or Tc constant in WinConstant.
    With this name will be selected the api to be used for retrieve the capability...
    "
    | selector group type |
    group := aXXCapsName first.
    type := aXXCapsName at: 2.
    type = $c ifFalse: [ ^aXXCapsName error: 'Must be a capability constant name' ].
    group = $R ifTrue: [ selector := #rasterSupport: ]
    ifFalse: [
        group = $T ifTrue: [ selector := #textSupport: ]
        ifFalse: [
            group = $L ifTrue: [ selector := #lineSupport: ]
            ifFalse: [
                group = $C ifTrue: [ selector := #curveSupport: ]
                ifFalse: [
                    group = $P ifTrue: [ selector := #polygonalSupport: ]
                    ifFalse: [ ^aXXCapsName error: 'Invalid capability constant' ]
                ]
            ]
        ]
    ].
    ^self perform: selector with: aXXCapsName asString!   
supportBanding
    "Returns true if the device supports banding."

    ^self rasterSupport: RcBanding! 
technology
    "Device technology."
    ^self capability: Technology!   
technologyName
    "Device technology as a string..."
    | tech |
    tech := self technology.
    tech = DtPlotter ifTrue: [^'Vector plotter'].
    tech = DtRasdisplay ifTrue: [^'Raster display'].
    tech = DtRasprinter ifTrue: [^'Raster printer'].
    tech = DtRascamera ifTrue: [^'Raster camera'].
    tech = DtCharstream ifTrue: [^'Character stream'].
    tech = DtMetafile ifTrue: [^'Metafile'].
    tech = DtDispfile ifTrue: [^'Display file'].!
textSupport: aTextCaps
    "Returns true if the device supports aTextCaps capability constant.
    aTextCaps can be anInteger or an TC_ constant name in WinConstant.
    E.g.: TcOpCharacter,TcOpStroke,TcCpStroke,TcCr90,TcCrAny,TcSfXYindep,
        TcSaDouble,TcSaInteger,TcSaContin,TcEaDouble,TcIaAble,TcUaAble,
        TcSoAble,TcRaAble,TcVaAble
    See SDK 3.1 help for more detail search for getDeviceCaps function...
    "

    ^(self textCaps bitAnd: (
        aTextCaps isInteger
        ifTrue: [aTextCaps]
        ifFalse: [
            WinConstants
                at: aTextCaps
                ifAbsent: [^self error: 'Invalid text caps constant ',aTextCaps asString]])) ~= 0! 
vertRes
    "Height of the display, in raster lines."
    ^self capability: Vertres!
vertSize
    "Height of the physical display, in millimeters."
    ^self capability: Vertsize! !

! HaloObject class methods !
imageClass
    "Private - Returns the class for new images of the receiver..."
    ^HaloVirtualImage!   
imageInstanceClass
    "Private - Returns the class for new image-instances of the receiver..."
    ^HaloImageInstance! 
initializeErrors
    "Private - Initialize errors dictionary.
        HaloObject initializeErrors.
    "

    HaloErrors := Dictionary new.

    HaloErrors

        at: ImeCancelled put: 'Procesamiento Cancelado.';
        at: ImeNoMemory put: 'Memoria Insuficiente.';
        at: ImeMemAccess put: 'Error accediendo a memoria (en lock).';

        at: ImeCacheRealloc put: 'No se pudo rehubicar memoria una nueva seleccion.';

        at: ImeClose put: 'Error cerrando la seleccion.';

        at: ImeInvSize put: 'Seleccion demasiado grande.';
        at: ImeInvLineNo put: 'Numero de linea invalido.';
        at: ImeInvExtent put: 'Problemas con las dimensiones.';

        at: ImeDiskOpen put: 'Error abriendo archivo.';
        at: ImeDiskRead put: 'Error de lectura en el disco.';
        at: ImeDiskWrite put: 'Error grabando en el disco.';

        at: ImeInvHandle put: 'Handle invalido.';
        at: ImeHandleLimit put: 'Se acabaron los handles...';

        at: ImeInvClass put: 'Accion no soportada para este formato de imagen.';
        at: ImeInvCmd put: 'Comando invalido.';
        at: ImeInvParam put: 'Parametro invalido.';

        at: ImeNotSupported put: 'Accion no soportada aun.';
        at: ImeClipped put: 'AOI object clipped.';
        at: ImeEmpty put: 'Objeto AOI vacio.';
        at: ImeInvType put: 'Objeto AOI de tipo invalido.';

        at: IfferrHandlelimit put: 'Demasiados archivos abiertos.';
        at: IfferrParameter put: 'Parametro invalido.';
        at: IfferrNotsupported put: 'Accion no soportada para este formato de imagen.';
        at: IfferrNotavailable put: 'Accion no disponible.';
        at: IfferrMemory put: 'Memoria Insuficiente.';
        at: IfferrImage put: 'Informacion deteriorada o formato incorrecto.';
        at: IfferrHeader put: 'El archivo no respeta el formato esperado.';
        at: IfferrIoOpen put: 'Error en apertura de archivo.';
        at: IfferrIoClose put: 'Error en cerrado de archivo.';
        at: IfferrIoRead put: 'Error en lectura de archivo.';
        at: IfferrIoWrite put: 'Error en escritura de archivo.';
        at: IfferrIoSeek put: 'Error en posicionamiento en archivo.';

        yourself.!   
new
    "Reutrns an instance of the receiver initialized "
    ^super new initialize! !

! HaloObject methods !   
asParameter
    "Returns the receiver's handle"
    ^handle asParameter16!  
checkError: anInteger
    "Private - Check the value of anInteger for an error value"

    | text |
    anInteger >= 0 ifTrue: [^self].
    text := HaloErrors at: anInteger
            ifAbsent: [
               HaloErrors
                    at: anInteger - ImeHiffl
                    ifAbsent: [ 'Error desconocido en procesamiento de imagenes :', anInteger asString ]
            ].
    self error: text!  
copyPropertiesFrom: anObject
    "Private - Copy the receivers properties from anObject"

    anObject properties
    associationsDo: [:asoc|
        self properties at: asoc key put: asoc value
    ]!   
do: aBlock tracking: aTitle
    "Private - Performs aBlock with a tracking window
     titled aTitle with annotations notes aString.
    aBlock must be a one-parameter block
    (the tracking structure will be passed for evaluating aBlock)"

    ^self do: aBlock tracking: aTitle notes: '\Momentito...' withCrs! 
do: aBlock tracking: aTitle notes: aString
    "Private - Performs aBlock with a tracking window
     titled aTitle with annotations notes aString.
    aBlock must be a one-parameter block
    (the tracking structure will be passed for evaluating aBlock)"

    ^self do: aBlock tracking: aTitle notes: aString withCancel: false!
do: aBlock tracking: aTitle notes: aString withCancel: aBoolean
    "Private - Performs aBlock with a tracking window
     titled aTitle with annotations notes aString.
    aBlock must be a one-parameter block
    (the tracking structure will be passed for evaluating aBlock).
     Returns nil if dialog cancelled by the user."

    | dialog trackingStructure result |
    dialog := HaloProcessDialog new.
    dialog
        title: aTitle;
        saying: aString;
        mustBeOpened: self useProgressDialogs.
    aBoolean ifTrue: [ dialog addCancelButtton ].
    trackingStructure := SelfDefinedStructure named: 'HilTrack'.
    trackingStructure trackProc: dialog callBack asParameter16.
    result := aBlock value: trackingStructure.
    dialog release.
    dialog cancelled ifTrue: [^nil].
    ^result!
handle
    "Returns the instance var of the receiver
     for external manipulation"
    ^handle!  
handle: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    handle := anObject! 
initialize
    "Private - Initialize the receiver"
    "Default action is to do class initialization if needed"
    "This method could be refined by subclasses..."

    HaloErrors isNil ifTrue: [ self class initializeErrors ].!  
isHandleOk
    "True if the receiver has a valid handle"

    ^handle notNil and: [ handle ~= 0 ]! 
isValid
    "True if the receiver is valid..."

    ^self isHandleOk!  
properties
    "Private - Returns the receicer's properties"
    properties isNil ifTrue: [ properties := Dictionary new ].
    ^properties!   
propertyAt: aSymbol
    "Private - Returns the receicer's property named aSymbol or ni if absent"
    ^self properties at: aSymbol ifAbsent: []!
propertyAt: aSymbol ifAbsent: aBlock
    "Private - Returns the receicer's property named aSymbol or evaluates aBlock if absent"
    ^self properties at: aSymbol ifAbsent: aBlock! 
propertyAt: aSymbol put: anObject
    "Private - Sets the receicer's property named aSymbol to anObject"
    anObject isNil
    ifTrue: [ ^self properties removeKey: aSymbol ifAbsent: [] ].
    ^self properties at: aSymbol put: anObject! 
release
    "Releases the receiver"

    self
        releaseProperties;
        destroy.

    super release.! 
releaseProperties
    "Private - Releases the receiver's properties"

    properties size > 0
    ifTrue: [
        properties keysDo: [:each|
            (properties at: each) release ].
        properties := nil.
    ].!
useProgressDialogs
    "True if the receiver must open file progress dialogs.
     Default action is not to use dialogs..."
    ^self properties at: #useProgressDialogs ifAbsent: [false]!
useProgressDialogs: aBoolean
    "Must be set to true if the receiver must open file progress dialogs.
     Default action is not to use dialogs..."

    self properties at: #useProgressDialogs put: aBoolean! !

! HaloImageInstance class methods ! 
for: aParent
    "Returns an instance of the receiver for working in aParent "
    ^self new parent: aParent! !

! HaloImageInstance methods !
asDIB
    "Private - Returns the receiver as aDIB in Smalltalk memory
    compatible with Display device context..."

    ^self asDIBCompatibleWith: Display pen! 
asDIBCompatibleWith: aPen
    "Private - Returns the receiver as aDIB in Smalltalk memory
    compatible with aPen device context..."

    ^self asDIBCompatibleWith: aPen zoomFactor: 1! 
asDIBCompatibleWith: aPen zoomFactor: zoom
    "Private - Returns the receiver as aDIB in Smalltalk memory
    compatible with aPen device context..."

    | dib hDIB |
    hDIB := self asMemoryDIBCompatibleWith: aPen zoomFactor: zoom.
    hDIB = 0 ifTrue: [ ^nil ].
    dib := DIB fromHandle: hDIB.
    KernelLibrary globalFree: hDIB.
    ^dib!
asMemoryDIBCompatibleWith: aPen zoomFactor: zoom
    "Private - Returns the receiver as aDIB in memory
    compatible with aPen device context...
    Return an extenal memory handle.
    *WARNING* The handle MUST be released by the caller..."

    | memoryHandle library |
    self isValid ifFalse: [ ^nil ].
    library := HiLDispDLL library.
    memoryHandle := library
        createDibFor: self asParameter16
        zoomFactor: zoom
        hDC: aPen handle asParameter16.
    library checkError.
    ^memoryHandle!
asMono
    "Private - Returns a new virtual image converting the receiver to Bilevel"

    ^self convertTo: ImcBilevel title: 'Convirtiendo imagen.'!  
basicBoundingBox
    "Private - Returns the receiver's boundingBox (in pixels)
     getting it's value from the library"
    | result value |
    self isValid ifFalse: [^0@0].
    value :=  WinRectangle16 new.
    result :=HiLimMgrDLL library
            hilImControlInst: self asParameter
            command:   ImcmdIGetextent
            sParam: nil lParam: nil
            pParam: value asParameter16.
    self checkError: result.
    ^value asRectangle!
basicExtent
    "Private - Returns the receiver's extent (in pixels)
     getting it's value from the library"
    | result value |
    self isValid ifFalse: [^0@0].
    value :=  WinPoint16 new.
    result :=HiLimMgrDLL library
            hilImControlInst: self asParameter
            command:   ImcmdIGetsize
            sParam: nil lParam: nil
            pParam: value asParameter16.
    self checkError: result.
    ^value asPoint!
bitCount
    "Returns the size of a pixel in bits"
    | imageClass bpp |
    imageClass := self imageFormat.
    imageClass = ImcBilevel ifTrue: [^1].
    imageClass = ImcRgb
    ifTrue: [
        bpp := GDILibrary
            getDeviceCaps: Display deviceContext
            index: Bitspixel *
                (GDILibrary
                    getDeviceCaps: Display deviceContext
                    index: Planes).
        ^bpp min: 8
    ].
    ^8!
blur: strength
    "Perform Blur (atenuado) on the receiver.
     Strength must be between 0 and 10..."

    | result done |
    done := self do: [:trackingStructure|
        result := HiLEnhDLL library
            hilBlur: self asParameter
            strength: strength asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Atenuando...'
    notes: '\Momentito...' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #blur: with: (Array with: strength).!  
boundingBox
    "Returns the instance var of the receiver
     for external manipulation"

    boundingBox isNil
    ifTrue: [ boundingBox := parent boundingBox ].
    ^boundingBox!   
brightness: aValue
    "Adjust the brightness of the receiver.
     aValue is in the range 0 to +100"

    | lut |
    lut := self lutForChannel: 0.
    lut isNil ifTrue: [^nil].
    lut brightness: aValue.
    self realizeLuts.! 
colorReduce: start to: numColors
    "Private - Returns a new virtual image converting the receiver
     to palletize image with numColors entries"

    ^self colorReduce: start to: numColors title: 'Convirtiendo imagen a ',numColors asString,' colores.'!   
colorReduce: start to: numColors title: aTitle
    "Private - Returns a new virtual image converting the receiver
     to palletize image with numColors entries"

    | result done |
    done := self do: [:trackingStructure|
        result := HiLConvDLL library
            hilColorReduce: self asParameter
            start: start asParameter16
            colors: numColors asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: aTitle
    notes: '\Momentito...' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #colorReduce:to:title: with: (Array with: start with: numColors with: aTitle).

    ^(self class imageClass new)
        handle: result;
        copyPropertiesFrom: self;
        yourself! 
contrast: aValue
    "Adjust the contrast of the receiver.
     aValue is in the range 0 to +90"

    | lut |
    lut := self lutForChannel: 0.
    lut isNil ifTrue: [^nil].
    lut contrast: aValue.
    self realizeLuts.!
convertTo: imageClass
    "Private - Returns a new virtual image converting the receiver to imageClass"

    ^self convertTo: imageClass title: 'Convirtiendo imagen.'!
convertTo: imageClass title: aTitle
    "Private - Returns a new virtual image converting the receiver to imageClass"

    | result done |
    done := self do: [:trackingStructure|
        result := HiLConvDLL library
            hilConvert: self asParameter
            class: imageClass asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: aTitle
    notes: '\Momentito...' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #convertTo:title: with: (Array with: imageClass with: aTitle).

    ^(self class imageClass new)
        handle: result;
        copyPropertiesFrom: self;
        yourself!  
copy
    "Returns a new virtual image copied from the receiver"
    | format |
    format := self format.
    format isNil
    ifTrue: [^super copy].
    ^self
        convertTo: format
        title: 'Duplicando imagen...'!  
copyToClipboard
    "Copies the receiver to the Clipboard"

    | bmp |
    self isValid ifFalse: [^nil].
    CursorManager execute changeFor: [
        bmp := Bitmap screenExtent: self extent.
        self displayAt: 0@0 with: bmp pen.
        Clipboard setBitmap: bmp.
        bmp release.
    ].! 
despeckle: cellSize sensitivity: sensitivity
    "Perform Despeckle on the receiver.
     sensitivity must be between 0 and 255;
     cellSize can be 3 5 or 7..."

    | result done |
    done := self do: [:trackingStructure|
        result := HiLEnhDLL library
            hilDespeckle: self asParameter
            cellSize: cellSize asParameter16
            sensitivity: sensitivity asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Removiendo ruido en la imagen...'
    notes: '\Momentito...' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #despeckle:sensitivity: with: (Array with: cellSize with: sensitivity).!  
destroy
    "Private - Destroy the receiver"

    self isValid ifTrue: [
        "self checkError:"
            (HiLimMgrDLL library
                hilImClose: self asParameter).
        handle := nil
    ]!  
displayAt: aPoint with: aPen
    "Display the receiver using aPen at  aPoint ..."

    | box |
    self isValid ifFalse: [ ^nil ].
    box := (aPoint extent: self extent) truncated.
    (box width <= 0 or: [ box height <= 0]) ifTrue: [ ^self ].

    HiLDispDLL library
        display: self asParameter
        hDC: aPen handle asParameter16
        zoomFactor: 1 asParameter16
        at: aPoint truncated asParameter16
        into: box asParameter16;
        checkError;
        yourself!
displayWith: aPen
    "Display the receiver using aPen."

    ^self displayAt: 0@0 with: aPen! 
distortRelative: points
    "Perform Distortion on the receiver
     acording to points.
    points must be a collection of points
     in the interval 0 to 100 "

    | relative box |
    box := 0@0 extent: self extent.
    relative := [:aPoint| box extent * aPoint // 100 ].
    ^self distortTo: (
            points collect: [:point|
                box origin + (relative value: point) ])!  
distortTo: points
    "Perform Distortion on the receiver
     acording to absolute points.
    *WARNING* an new halo virtual
     image will be returned or nil if cancelled"

    | result done pnts |
    pnts := self winPointList: points.
    done := self do: [:trackingStructure|
        result := HiLxFormDLL library
            hilDistort: self asParameter
            corners: pnts asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Distorsionando...'
    notes: 'Momentito...\Una nueva imagen esta siendo generada.' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #distortTo: with: (Array with: points).

    ^(self class imageClass new)
        handle: result;
        copyPropertiesFrom: self;
        yourself!
doEffect: anEffect as: aTitle
    "Private - Perform anEffect on the receiver"

    | result done |
    done := self do: [:trackingStructure|
        result := HiLEnhDLL library
            hilFilter: self asParameter
            filterType: anEffect asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: aTitle
    notes: '\Momentito...' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #doEffect:as: with: (Array with: anEffect with: aTitle).!
edge: aString
    "Private - Perform Edge-aString the receiver"

    ^self effect: 'Edge' type: aString!   
edgeHorizontal
    "Perform Edge effect the receiver"

    ^self edge: 'Horz'! 
edgeThick
    "Perform Edge effect the receiver"

    ^self edge: 'Thick'! 
edgeThin
    "Perform Edge effect the receiver"

    ^self edge: 'Thin'!   
edgeVertical
    "Perform Edge effect the receiver"

    ^self edge: 'Vert'!   
effect: anEffect type: aString
    "Private - Perform anEffect-aString the receiver"

    | effect |
    effect := HaloConstants
        at: 'Flt',anEffect,aString
        ifAbsent: [^self error: 'Efecto ',anEffect,'-',aString,' invlido.'].
    self
        doEffect: effect
        as: 'Efecto ',anEffect,'-',aString!  
emboss: aString
    "Private - Perform Emboss-aString the receiver"

    ^self effect: 'Emboss' type: aString! 
embossAbove
    "Perform Emboss effect the receiver"

    ^self emboss: 'Above'!   
embossDiagonal
    "Perform Emboss effect the receiver"

    ^self emboss: 'Diag'! 
embossLeft
    "Perform Emboss effect the receiver"

    ^self emboss: 'Left'! 
equalize: type
    "Perform Equalization on the receiver"

    | result method |
    method := HaloConstants
        at: 'Eq',type
        ifAbsent: [^self error: 'Ecualizacin ',type,' invlida.'].
    result := HiLEnhDLL library
        hilHistEq: self asParameter
        method: method asParameter16.
    self checkError: result!   
equalizeBell
    "Perform Equalization on the receiver"

    ^self equalize: 'Bell'!   
equalizeBestFit
    "Perform Equalization on the receiver"

    ^self equalize: 'Bestfit'! 
equalizeExponential
    "Perform Equalization on the receiver"

    ^self equalize: 'Exponential'! 
equalizeLinear
    "Perform Equalization on the receiver"

    ^self equalize: 'Linear'!   
equalizeLogarithmic
    "Perform Equalization on the receiver"

    ^self equalize: 'Logarithmic'! 
extent
    "Returns the extent of the receiver.
    Computed from it's bounding box"

    ^self boundingBox extent!   
flipHoriz
    "Private - Returns a new virtual image
    builded as the receiver's flipped"

    ^self rotatedTo: 'Leftright'!
flipVert
    "Private - Returns a new virtual image
    builded as the receiver's flipped"

    ^self rotatedTo: 'Updown'!
format
    "Returns the image class in Halo, the possible values are
        ImcGray    ImcGray12     ImcBilevel     ImcRgb     ImcFloat      ImcPalette "
    | result value |

    self isValid ifFalse: [^nil].

    value := WinLong new.
    result :=HiLimMgrDLL library
            hilImControlInst: self asParameter
            command: ImcmdGetclass
            sParam: nil lParam: nil
            pParam: value asParameter16.
    self checkError: result.
    ^value asInteger!
gama: aValue
    "Adjust the gama of the receiver.
     aValue is in the range 0 to +40"

    | lut |
    lut := self lutForChannel: 0.
    lut isNil ifTrue: [^nil].
    lut gama: aValue.
    self realizeLuts.!
height
    "Returns the height of the receiver.
    Computed from it's bounding box"

    ^self boundingBox height!   
histogramValues
    "Private - Returns the values of the histogram of the receiver"
    | result struct values entries |
    self isValid ifFalse: [^nil].
    entries := 256.
    struct :=  WinStructure new: entries * 4.
    result :=HiLimMgrDLL library
            hilImControlInst: self asParameter16
            command: ImcmdIGethist asParameter16
            sParam: 0
            lParam: nil
            pParam: struct asParameter16.
    self checkError: result.
    values := Array new: entries.
    1 to: entries do: [:i|
        values at: i put: (struct longAtOffset: i - 1 * 4)
    ].
    ^values! 
invertAll
    "Perform Invertion on all the color planes the receiver."

    ^self invertRed: true green: true blue: true! 
invertRed: bRed green: bGreen blue: bBlue
    "Perform Invertion on the receiver."

    | result done |
    done := self do: [:trackingStructure|
        result := HiLEnhDLL library
            hilInvert: self asParameter16
            bRed: bRed asParameter16
            bGreen: bGreen asParameter16
            bBlue: bBlue asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Invirtiendo imagen...'
    notes: '\Momentito...' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #invertRed:green:blue: with: (Array with: bRed with: bGreen with: bBlue).!
isMono
    "True if the receiver is a bilevel image"
    ^self class = ImcBilevel!  
line: aString
    "Private - Perform Line-aString the receiver"

    ^self effect: 'Line' type: aString!   
lineBoth
    "Perform Line effect the receiver"

    ^self line: 'Both'!   
lineHorizontal
    "Perform Line effect the receiver"

    ^self line: 'Horz'! 
lineVertical
    "Perform Line effect the receiver"

    ^self line: 'Vert'!   
lut
    "Private - Returns the receiver's LookUp Table"
    | result lut |
    lut := ByteArray new: 256 * 3.
    result := HiLimMgrDLL library
        hilImControlInst: self asParameter
        command: ImcmdGetresponse
        sParam: 0
        lParam: nil
        pParam: lut.
    self checkError: result.
    ^lut.!
lutForChannel: aChannel
    "Private - Returns the receiver's Look Up Table for channel aChannel.
     aChannel can be:
            0 or nil for luminance
            1           for red
            2           for green
            3           for blue
     Returns a HilBCGM structure pointing to the LUT or nil if not avaliable
    "
    | result address |
    self isValid ifFalse: [^nil].
    self imageFormat = ImcBilevel ifTrue: [^nil].
    address :=  WinAddress new.
    result :=HiLimMgrDLL library
            hilImControlInst: self asParameter
            command: ImcmdGetlutaddr
            sParam: (aChannel isNil ifTrue: [0] ifFalse: [aChannel]) asParameter16
            lParam: nil
            pParam: address asParameter16.
    self checkError: result.
    ^HilBCGM atAddress: address!  
metalize
    "Metalizes the receiver"

    self sculptMetal!   
openIn: aRectangle
    "Open the receiver for aRectangle as read&write"
    | error |
    error := HiLimMgrDLL library
         hilImOpen: parent asParameter16
         access: ImaRdwr
         lpRect: aRectangle asParameter16.
    error = 0 ifTrue: [ self checkError: error ].
    handle := error.
    boundingBox := aRectangle.!   
openReadOnlyIn: aRectangle
    "Open the receiver for aRectangle as readOnly"
    | error |
    error := HiLimMgrDLL library
         hilImOpen: parent asParameter16
         access: ImaRd
         lpRect: aRectangle asParameter16.
    error = 0 ifTrue: [ self checkError: error ].
    handle := error.
    boundingBox := aRectangle.!   
parent
    "Returns the instance var of the receiver
     for external manipulation"
    ^parent!  
parent: anObject
    "Sets the instance var of the receiver
     with anObject. (The properties will be copied)"

    parent := anObject.
    self copyPropertiesFrom: parent.!  
pixelize: aPoint
    "Perform Pixelization of the receiver to all channels
    using pixel tile of aPoint."

    ^self pixelize: aPoint red: true green: true blue: true! 
pixelize: aPoint red: bRed green: bGreen blue: bBlue
    "Perform Pixelization of the receiver to red green & blue
     channels using pixel tile of aPoint.
     bRed bGreen & bBlue must be boolean values."

    | result done |
   done :=  self do: [:trackingStructure|
        result := HiLEnhDLL library
            hilPixelize: self asParameter
            bRed: bRed asParameter16
            bGreen: bGreen asParameter16
            bBlue: bBlue asParameter16
            tileWidth: aPoint x asParameter16
            tileHeight: aPoint y asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Pixelizando imagen...'
    notes: '\Momentito...' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #pixelize:red:green:blue: with: (Array with: aPoint with: bRed with: bGreen with: bBlue).!   
posterize: bitDepth
    "Perform Posterization of the receiver to all channels
    using bitDepth as remaining bits."

    ^self posterize: bitDepth red: true green: true blue: true!
posterize: bitDepth red: bRed green: bGreen blue: bBlue
    "Perform Posterization of the receiver to red green & blue
     channels using bitDepth as significand bits to be retained.
     bRed bGreen & bBlue must be boolean values."

    | result done |
    done := self do: [:trackingStructure|
        result := HiLEnhDLL library
            hilPosterize: self asParameter
            bRed: bRed asParameter16
            bGreen: bGreen asParameter16
            bBlue: bBlue asParameter16
            bitDepth: bitDepth asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Posterizando imagen...'
    notes: '\Momentito...' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #posterize:red:green:bllue: with: (Array with: bitDepth with: bRed with: bGreen with: bBlue).!   
realizeLuts
    "Private - Command used to update brightness, contrast, gama etc... "
    | result |
    self isValid ifFalse: [^nil].
    result :=HiLimMgrDLL library
            hilImControlInst: self asParameter
            command: ImcmdRealizeluts
            sParam: 0 lParam: nil
            pParam: nil.
    self checkError: result.
    ^self! 
record: aSymbol with: parameters
    "Private - Perform recording into receiver's recorder"

    | recorder |
    recorder := self recorder.
    recorder isNil ifTrue: [^nil].
    recorder
        record: aSymbol
        with: parameters
        for: self! 
recorder
    "Returns the macro recorder"

    ^parent isNil
    ifTrue: [nil]
    ifFalse: [parent recorder]!   
reverse
    "Perform Invertion on all the color planes the receiver."

    ^self invertRed: true green: true blue: true!   
rotatedTo: aString
    "Private - Returns a new virtual image
    builded as the receiver's rotated to aString"

    | type result done |
    type := HaloConstants
        at: 'Or',aString
        ifAbsent: [^self error: 'Rotacin ',aString,' invlida.'].

    done := self do: [:trackingStructure|
        result := HiLxFormDLL library
            hilOrient: self asParameter
            type: type asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Rotando...'
    notes: 'Momentito...\Una nueva imagen est siendo generada.' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #rotatedTo: with: (Array with: aString).

    ^(self class imageClass new)
        handle: result;
        copyPropertiesFrom: self;
        yourself!
rotatedTo: angleX10 anchor: aConstantName at: aPoint
    "Private - Returns a new virtual image
    builded as the receiver's free angle rotated"

    | anchor result done |
    anchor := HaloConstants
        at: 'Ra',aConstantName
        ifAbsent: [^self error: 'Ancla de rotacin ',aConstantName,' invlida.'].

    done := self do: [:trackingStructure|
        result := HiLxFormDLL library
            hilRotate: self asParameter
            angle: angleX10 asParameter16
            anchor: anchor asParameter16
            pAnchor: aPoint asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Rotando...'
    notes: 'Momentito...\Una nueva imagen est siendo generada.' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #rotatedTo:anchor:at: with: (Array with: angleX10 with: aConstantName with: aPoint).

    ^(self class imageClass new)
        handle: result;
        copyPropertiesFrom: self;
        yourself!   
rotateLeft
    "Private - Returns a new virtual image
    builded as the receiver's rotated"

    ^self rotatedTo: 'Rotate270'!   
rotateRight
    "Private - Returns a new virtual image
    builded as the receiver's rotated"

    ^self rotatedTo: 'Rotate90'!   
saveAs: aFileName format: format
    "Saves the receiver directly to a file"

    | result |
    self do: [:trackingStructure|
        result := HiLxFormDLL library
            hilSaveImage: aFileName asParameter16
            inst: self asParameter16
           fileFormat: format asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Grabando archivo.'
    notes: '\' withCrs,aFileName.
    self checkError: result! 
scaledBy: scale smooth: smooth
    "Private - Returns a new virtual image
    builded as the receiver's scaled by scale
    (scale must be between 0 to 100 and can be aPoint)"

    | extent result |
    extent := (self extent * scale / 100) truncated.
    ^self scaledTo: extent smooth: smooth! 
scaledTo: extent smooth: smooth
    "Private - Returns a new virtual image
    builded as the receiver's scaled to extent"

    | result done |

    (extent isNil
        or: [ extent x <= 0
        or: [ extent y <= 0 ]])
    ifTrue: [^self scaled].

    done := self do: [:trackingStructure|
        result := HiLxFormDLL library
            hilScale: self asParameter
            width: extent x asParameter16
            height: extent y asParameter16
            bSmooth: smooth asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Escalando...'
    notes: 'Momentito...\Una nueva imagen est siendo generada.' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #scaledTo:smooth: with: (Array with: extent with: smooth).

    ^(self class imageClass new)
        handle: result;
        copyPropertiesFrom: self;
        yourself!
sculpt: aString
    "Private - Perform Sculpt-aString the receiver"

    ^self effect: 'Sculpt' type: aString! 
sculptAbove
    "Perform Sculpt effect the receiver"

    ^self sculpt: 'Above'!   
sculptDiagonal
    "Perform Sculpt effect the receiver"

    ^self sculpt: 'Diag'! 
sculptLeft
    "Perform Sculpt effect the receiver"

    ^self sculpt: 'Left'! 
sculptMetal
    "Perform Sculpt effect the receiver"

    ^self sculpt: 'Metal'!   
sharpen: strength
    "Perform Sharpen on the receiver.
     Strength must be between 0 and 10..."

    | result done |
    done := self do: [:trackingStructure|
        result := HiLEnhDLL library
            hilSharpen: self asParameter16
            strength: strength asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Resaltando bordes...'
    notes: '\Momentito...' withCrs
    withCancel: true.

    done isNil ifTrue: [^nil].
    self checkError: result.
    self record: #sharpen: with: (Array with: strength).!   
width
    "Returns the width of the receiver.
    Computed from it's bounding box"

    ^self boundingBox width!  
winPointList: anArrayOfPoints
        "Private - answer a WinStructure containing a list
        of POINT structures corresponding to anArrayOfPoints."
    | winPoints byteOffset |
    winPoints := WinStructure new:
            (anArrayOfPoints size * WinPoint16 sizeInBytes).
    byteOffset := 0.
    anArrayOfPoints do: [ :aPoint |
        winPoints
            shortAtOffset: byteOffset put: aPoint x truncated;
            shortAtOffset: (byteOffset + 2) put: aPoint y truncated.
        byteOffset := byteOffset + 4].
    ^winPoints! !

! HaloMacro methods ! 
initialize
    "Private - Initialize the receiver"

    super initialize.
    steps := OrderedCollection new.!
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!  
name: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    name := anObject! 
record: aSymbol with: parameters for: anHaloImageInstance
    "Record an action that has been done over anHaloImageInstance"

    self steps addLast:
        (Array
            with: aSymbol
            with: parameters
            with: anHaloImageInstance boundingBox)!
run: aCollection with: aHaloVirtualImage inside: aRectangle
    "Private - Run the commands in aCollection using aHaloVirtualImage
     as model and aRectange as bounding effects box.
    if aRectangle is nil the original bounding boxes will be used."

    | instance message |
    message := Message new.
    aCollection do: [:each|
        instance := aHaloVirtualImage
            createInstance: (
                aRectangle isNil
                ifTrue: [ each at: 3 ]
                ifFalse: [aRectangle]).
        message
            receiver: instance;
            selector: (each at: 1);
            params: (each at: 2);
            perform.
        aHaloVirtualImage destroyInstance: instance.
    ]!   
runWith: aHaloVirtualImage inside: aRectangle
    "Run the commands in the receiver using aHaloVirtualImage
     as model and aRectange as bounding effects box.
    if aRectangle is nil the original bounding boxes will be used."

   ^self run: self steps with: aHaloVirtualImage inside: aRectangle!   
steps
    "Returns the instance var of the receiver
     for external manipulation"
    ^steps! !

! HaloMacroRecorder methods ! 
initialize
    "Private - Initialize the receiver"

    super initialize.
    self reset.!
loadFrom: fileName
    "Load receiver's instances from a file named fileName"

    self
        reset;
        mergeWith: fileName!  
mergeWith: fileName
    "Merge receiver's instances from a file named fileName"

    | loaded dict |
    loaded := Loader new loadFrom: fileName.
    loaded isNil ifTrue: [^nil].
    dict := Dictionary new.
    macros do: [:each|
        dict at: each name put: each
    ].
    loaded do: [:aMacro|
        dict at: aMacro name put: aMacro
    ].
    macros := dict values asSet asOrderedCollection!  
record: aSymbol with: parameters for: anHaloImageInstance
    "Record an action that has been done over anHaloImageInstance"

    ^current notNil
    ifTrue: [ current record: aSymbol with: parameters for: anHaloImageInstance ]!  
reset
    "Clear receiver's contents"

    macros := OrderedCollection new.
    current := nil.!  
saveAs: fileName
    "Save receiver's instances to a file named fileName"

    Loader new
        unload: macros
        into: fileName! 
startRecording: aMacroName for: aHaloVirtualImage
    "Start recording actions on aHaloVirtualImage into a new macro named aMacroName"

    current := HaloMacro new.
    current name: aMacroName.
    aHaloVirtualImage recorder: self.!   
stopRecordingFor: aHaloVirtualImage
    "Stop recording actions on aHaloVirtualImage into current macro & save it"

    | obsolete |
    current isNil ifTrue: [^nil].
    aHaloVirtualImage recorder: nil.
    obsolete := macros
        detect: [:one| one name = current name]
        ifNone: [ ^macros add: current ].
    macros
        at: (macros indexOf: obsolete)
        put: current.
    current := nil.! !

! HaloVirtualImage class methods ! 
aboutToSaveImage
        "Private - Default code.  Redefined by subclasses."

    Patch release.
    Patch := nil.

    self allInstances do: [:each | each destroy ].! 
canUnderstand: aSymbol
    "Reimplemented here to use full instance"
    ^(super canUnderstand: aSymbol)
        or: [ self imageInstanceClass canUnderstand: aSymbol ]!   
formats
    "Returns the receiver's supported formats.
     must be aDictionary with
        key     description for format
        value   format value
    "
    ^Dictionary new
        at: 'Bilevel Image' put: ImcBilevel;
        at: 'Gray Image' put: ImcGray;
        at: 'Palette Image' put: ImcPalette;
        at: 'RGB Image' put: ImcRgb;
        yourself! !

! HaloVirtualImage methods !   
boundingBox
    "Returns the receiver's boundingBox"
    ^0@0 extent: self extent - 1!  
createInstance: aRectangle
    "Creates an instance of the receiver with aRectangle as boundingBox.
     If aRectangle is nil the hole image will be selected..."

    ^(self class imageInstanceClass for: self)
            openIn: (aRectangle isNil
                ifTrue: [self boundingBox]
                ifFalse: [aRectangle intersect: self boundingBox]);
            yourself!  
createReadOnlyInstance: aRectangle
    "Creates an instance of the receiver with aRectangle as boundingBox.
     If aRectangle is nil the hole image will be selected..."

    ^(self class imageInstanceClass for: self)
            openReadOnlyIn: (aRectangle isNil
                ifTrue: [self boundingBox]
                ifFalse: [aRectangle intersect: self boundingBox]);
            yourself!  
destroy
    "Private - Destroy the receiver"

    self isHandleOk ifFalse: [^self].

    "destroy virtual image..."
    self checkError:
        (HiLimMgrDLL library
            hilImDestroy: handle asParameter16).

    "cleanUp..."

    handle := nil.! 
destroyInstance: anImageInstance
    "Destroy an instance of the receiver and removes it from instances.
     If the instance is not a receiver's instance returns nil"

    anImageInstance release! 
display: aRectangle at: aPoint with: aPen
    "Display aRectangle using aPen..."
    | rect |
    rect := aRectangle intersect: self boundingBox.
    self
        inside: rect
        doReadOnly: [:inst| inst displayAt: aPoint with: aPen ]!
display: aRectangle with: aPen
    "Display aRectangle using aPen..."
    | rect |
    rect := aRectangle intersect: self boundingBox.
    self
        inside: rect
        doReadOnly: [:inst| inst displayAt: rect origin with: aPen ]!  
doesNotUnderstand: aMessage
    "Try to solve the message using a hole image instance."

    | result |
    (self class imageInstanceClass canUnderstand: aMessage selector)
    ifTrue: [
        self inside: nil do: [:inst|
            aMessage receiver: inst.
            result := aMessage perform.
        ].
        ^result
    ].
    ^super doesNotUnderstand: aMessage!
extent
    "Returns the extent of the receiver.
    Computed from it's bounding box"

    | result point |
    self isValid ifFalse: [^1@1].
    point := WinPoint16 new.
    result :=HiLimMgrDLL library
            hilImControl: self asParameter
            command: ImcmdGetsize
            sParam: nil lParam: nil
            pParam: point asParameter16.
    self checkError: result.
    ^point asPoint!
fileFormatOfFile: pathName inMemory: aBoolean
    " Private - Detect format of image in file pathName.
    pathName can be a memoryFile address..."

    | pszFormat |
    pszFormat := HiFflDLL library
        hifflIdentify: pathName
        bFile: aBoolean not.
    pszFormat = 0 ifTrue: [ ^nil ].
    ^String fromAddress: (WinAddress fromInteger: pszFormat)!  
fileName
    "Returns the instance var of the receiver
     for external manipulation"
    ^fileName!  
fileName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    fileName := anObject! 
fileOutSurrogate: anObjectFiler
    " Answer surrogate for object filing.  Zap handle. "
    | surrogate |
    surrogate := self copy.
    surrogate handle: nil.
    ^surrogate!
format
    "Returns the instance var of the receiver
     for external manipulation"

    (format isNil and: [fileName notNil and: [File exists: fileName]])
    ifTrue: [ format := self fileFormatOfFile: fileName inMemory: false ].

    ^format!  
format: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    format := anObject! 
height
    "Returns the height of the receiver.
    Computed from it's extent"

    ^self extent y!   
inside: aRectangle do: aBlock
    "Perform aBlock with a new instance created from the receiver
     at boundingBox. aBlock must be a one-parameter block to be
    evaluated (the used instance of the receiver will be passed
    to evaluate aBlock)."
    | instance result |
    self isValid ifFalse: [^nil].
    instance := self createInstance: aRectangle.
    result := aBlock value: instance.
    self destroyInstance: instance.
    ^result! 
inside: aRectangle doReadOnly: aBlock
    "Perform aBlock with a new instance created from the receiver
     at boundingBox. aBlock must be a one-parameter block to be
    evaluated (the used instance of the receiver will be passed
    to evaluate aBlock)."
    | instance result |
    self isValid ifFalse: [^nil].
    instance := self createReadOnlyInstance: aRectangle.
    result := aBlock value: instance.
    self destroyInstance: instance.
    ^result! 
isValid
    "True if the receiver is valid..."

    handle isNil
    ifTrue: [ ^self restore ].

    ^super isValid.!   
loadFile: aFileName format: fileFormat
    "Loads the receiver from aFileName with format fileFormat.
     format must be the module name for the receiver's format.
     The receiver must be tested for validity when operation ends."

    "run the patch..."
    self patch.

    fileFormat isNil ifTrue: [
        ^self loadFile: aFileName format: (self fileFormatOfFile: aFileName inMemory: false)
    ].

    "Destroy old references"
    self destroy.

    self do: [:trackingStructure|
        handle := HiLxFormDLL library
            hilLoadImage: aFileName asParameter16
            fileFormat: fileFormat asParameter16
            lpTrack: trackingStructure asParameter16
    ]
    tracking: 'Leyendo archivo.'
    notes: '\' withCrs,aFileName.
    self checkError: handle.
    self
        fileName: aFileName;
        format: fileFormat.!  
loadMemoryFile: memory size: chunkSize format: fileFormat
    "Loads the receiver from a memory file at aWinAddress with format fileFormat.
     format must be the module name for the receiver's format.
     The receiver must be tested for validity when operation ends."

    | realFormat |

    "run the patch..."
    self patch.

    fileFormat isNil ifTrue: [
        realFormat := self fileFormatOfFile: memory inMemory: true.
        realFormat isNil ifTrue: [ ^nil ].
        ^self
            loadMemoryFile: memory
            size: chunkSize
            format: realFormat
    ].

    "Destroy old references"
    self
        fileName: nil;
        format: nil;
        destroy.

    self do: [:trackingStructure|
        "
        MessageBox message: 'Sending ',chunkSize asString,' bytes.\ First 3 bytes are: ' withCrs,
            (memory copyFrom: 1 to: 3)asString,'\fileFormat: 'withCrs,fileFormat asString.
        "self halt.
        handle := HiLDispDLL library
            loadMemoryImage: memory
            size: chunkSize asParameter16
            fileFormat: fileFormat asParameter16
            lpTrack: trackingStructure asParameter16.
    ]
    tracking: 'Leyendo imgen.'
    notes: '\en memoria...' withCrs.

    HiLDispDLL library checkError.
    self checkError: handle.
    self format: fileFormat.!   
patch
    "Private - Patch added by Ale for detected
     error on some machines.
    First image load returns a zero handle value
      and can't be used...
    "
    | fName aFormat |

    Patch isNil ifFalse: [ ^self ]. "has been patched, yet..."

    fName := '8x8.bmp'.
    (File exists: fName)
    ifFalse: [ "create a dummy DIB image..."
        (Bitmap screenExtent: 8@8)
            outputToFile: fName;
            release
    ].

    self do: [:trackingStructure|
        aFormat := HaloConstants at: 'BMP'
            ifAbsent: [ self fileFormatOfFile: fName inMemory: false ].
        Patch := self class new
            handle: (
                HiLxFormDLL library
                hilLoadImage: fName asParameter16
                fileFormat: aFormat asParameter16
                lpTrack: trackingStructure asParameter16);
            fileName: fName;
            format: aFormat
    ]
    tracking: 'Patchando libreria....'
    notes: '\' withCrs,fName.!
recorder
    "Returns the instance var of the receiver
     for external manipulation"
    ^recorder!  
recorder: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    recorder := anObject! 
restore
    "Force the receiver to be reloaded..."

    (format isNil or: [fileName isNil]) ifTrue: [^false].
    self destroy.
    self loadFile: self fileName format: self format.
    ^self isHandleOk! 
save
    "Saves the receiver..."

    fileName notNil
    ifTrue: [ self saveAs: fileName format: format ]!   
saveAs: aFileName format: frmt
    "Saves the receiver directly to a file"

    self
        inside: nil
        do: [:instance|
            instance saveAs: aFileName format: frmt ]! 
width
    "Returns the width of the receiver.
    Computed from it's extent"

    ^self extent x! 
width: width height: height format: frmt
    "Creates a new image in the receiver with format format."

    "Destroy old references"
    self isValid ifTrue: [ self destroy ].

    self do: [:trackingStructure|
        handle := HiLimMgrDLL library
            hilImCreate: width asParameter16
            height: height asParameter16
            class: frmt asParameter16
            lpTrack: trackingStructure asParameter16
    ]
    tracking: 'Creando imagen...'
    notes: String new.
    self checkError: handle.

    format := frmt.! !

! Line class methods !  
from: pointStart to: pointEnd
    "Answer an instance of the receiver that passes thru
    the points pointStart and pointEnd."

    | slope offset |

    pointStart x > pointEnd x
    ifTrue: [ ^self from: pointEnd to: pointStart ].

    slope := pointStart - pointEnd.
    slope x = 0
        ifTrue: [ slope := nil.
                        offset := pointStart x ]
        ifFalse: [ slope := slope y / slope x.
                        offset := pointStart y - ( slope * pointStart x) ].
    ^self slope: slope originOffset: offset!
slope: slope originOffset: offset
    "Answer an instance of the receiver whose formula is
    expressed as Y = slope * X + offset."

    ^(self new)
            slope: slope;
            originOffset: offset;
            yourself! !

! Line methods !  
containsPoint: aPoint
    "True if aPoint is in the receiver"

    ^self includes: aPoint! 
distanceTo: aPoint
    "Answer the minimum distance between aPoint and the receiver."

    | normal intPoint |
    normal := self normalTo: aPoint.
    intPoint := self intersect: normal.
    ^(aPoint - intPoint) modulus!   
gap
    "Private - Returns the minimum value for bounds checking..."

    ^1!  
includes: aPoint
    "True if aPoint is in the receiver"

    self isVertical ifTrue: [ ^aPoint x = self originOffset ].
    ^(aPoint y - (self value: aPoint x)) abs < self gap! 
initialize
    "Private - Initializes the receiver.
    By default the formula is Y = X."

    super initialize.
    slope := 0.
    originOffset := 0.
    lineBlock := [ :x | self slope * x + self originOffset ].! 
intersect: aLine
    "Answers the point of intersection between aLine and the receiver.
    If aLine is parallel to the receiver then answers nil."

    | point |
    aLine isNil ifTrue: [^nil].
    self slope = aLine slope ifTrue: [ ^nil ].
    self isVertical ifTrue: [ ^self originOffset @ (aLine value: self originOffset) ].
    aLine isVertical ifTrue: [ ^aLine intersect: self ].

    point := Point new.
    point x: (aLine originOffset - self originOffset) / (self slope - aLine slope).
    point y: (self value: point x).

    aLine isSegment ifFalse: [ ^point ].
    ^(aLine includes: point) ifTrue: [ point ] ifFalse: [ nil ]!  
intersects: aRect
    "Answers true if the receiver and aRectangle have some
    point in common."

    | left right swap |

    self isVertical
        ifTrue: [ ^self originOffset between: aRect left and: aRect right].

    left := self value: aRect left.
    right := self value: aRect right.
    (left isNil or: [ right isNil ])
        ifTrue: [ ^self originOffset between: aRect left and: aRect right ].

    left > right
        ifTrue: [ swap := left.
                    left := right.
                    right := swap ].

    ((aRect top between: left and: right)
        or: [ (aRect bottom between: left and: right)
            or: [ (left between: aRect top and: aRect bottom)
                or: [ right between: aRect top and: aRect bottom ] ] ])
        ifTrue: [ ^true ].

    self slope < 0
        ifTrue: [ ((left between: aRect bottom and: aRect top)
                            or: [ right between: aRect bottom and: aRect top ])
                                ifTrue:[ self halt. ^true ] ]
        ifFalse: [ ((left between: aRect top and: aRect bottom)
                            or: [ right between: aRect top and: aRect bottom ])
                                ifTrue:[ self halt. ^true ] ].

    ^false!   
isHorizontal
    "Answer true if the receiver is parallel to the X-axis."

    ^self slope = 0!
isSegment
    "True if the receiver is a Segment
    Used for intersections..."

    ^false!  
isVertical
    "Answer true if the receiver is not a function (vertical line) for which
    the slope is undefined."

    ^self slope isNil!  
lineBlock
    "Returns the instance var of the receiver
     for external manipulation"
    ^lineBlock!
lineBlock: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    lineBlock := anObject!   
normalTo: aPoint
    "Answer a line that represents the normal of aPoint to the receiver."

    | newSlope newOffset |

    self isVertical
        ifTrue: [ ^self class slope: 0 originOffset: aPoint y ].

    self isHorizontal
        ifTrue: [ ^self class slope: nil originOffset: aPoint x ].

    newSlope := 1 / self slope negated.
    newOffset := aPoint y - ( newSlope * aPoint x ).
    ^self class slope: newSlope originOffset: newOffset.!   
originOffset
    "Returns the instance var of the receiver
     for external manipulation"
    ^originOffset!  
originOffset: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    originOffset := anObject.
    self setLineBlock! 
setLineBlock
    "Reformulates the block that evaluates the receivers formula."

    self slope isNil        "A line that is in X = aKonstant"
        ifTrue: [ self lineBlock: [ :x | nil ] ]
        ifFalse: [ self lineBlock: [ :x | self slope * x + self originOffset ] ]!
slope
    "Returns the instance var of the receiver
     for external manipulation"
    ^slope!
slope: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    slope := anObject.
    self setLineBlock!   
value: x
    "Answer the value of the receiver at the x coordinate."

    ^self isVertical
        ifTrue: [ x = self originOffset
                        ifTrue: [ x ]
                        ifFalse: [ nil ] ]
        ifFalse: [ self lineBlock value: x ]! !

! Segment class methods !   
from: pointStart to: pointEnd
    "Answer an instance of the receiver that passes thru
    the points pointStart and pointEnd."

    pointStart x > pointEnd x
    ifTrue: [ ^self from: pointEnd to: pointStart ].

    ^(super from: pointStart to: pointEnd)
        start: pointStart;
        end: pointEnd;
        yourself! !

! Segment methods !
boundingBox
    "Returns receiver's boundiongBox..."

    self checkBounds.
    ^((start x min: end x) @ (start y min: end y))
        rightBottom: ((start x max: end x) @ (start y max: end y))!   
checkBounds
    " Private - Check receiver's bounds and transpose if appropiate..."

    | point |
    self start < self end ifFalse: [
        point := self start.
        self
            start: self end;
            end: point
    ].!
distanceTo: aPoint
    "Answer the minimum distance between aPoint and the receiver."

    | normal distStart distEnd intPoint distance |

    (normal := self normalTo: aPoint) isNil
        ifTrue: [ distStart := (aPoint - self start) abs.
                        distEnd := (aPoint - self end) abs.
                        distance := distStart modulus min: distEnd modulus ]
        ifFalse: [ intPoint := self intersect: normal.
                        distance := (aPoint - intPoint) modulus ].
    ^distance! 
end
    "Returns the instance var of the receiver
     for external manipulation"
    ^end!
end: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    end := anObject!   
includes: aPoint
    "True if aPoint is in the receiver"

    ^(self boundingBox containsPoint: aPoint)
    and: [ super includes: aPoint ]!  
intersect: aLine
    "Answers the point at which aLine and the receiver intersect.
    If the point is outside the receiver, answers nil."

    | point scale |
    point := super intersect: aLine.
    (point notNil and: [ (self boundingBox containsPoint: point) not ])
    ifTrue: [ point := nil ].

    "only for debugin...
    scale := 1.
    Display pen
        place: self start // scale; circle: 2;
        goto: self end // scale;
        place: aLine start // scale; circle: 2;
        goto: aLine end // scale;
        yourself.
    point notNil ifTrue: [
        Display pen
            place: self start // scale;
            box: self end // scale;
            place: aLine start // scale;
            box: aLine end // scale;
            place: point // scale;
            circle: scale * 2;
            yourself
    ].
    "
    "only for debuggin...
    point notNil ifTrue: [
        Transcript cr;nextPutAll: '(', self start truncated asString,'=>',self end truncated asString
            ,') corta a (', aLine start truncated asString,'=>',aLine end truncated asString
            ,')  en ',point truncated asString.
    ].
    "

    ^point!   
intersects: aRect
    "Answer true if the receiver has some point in common with aRect."

    | aux1 aux2 |

"Verify if the receiver has an overlapping in the X-axis with the segment"
    ((self start x between: aRect left and: aRect right)
        or: [ (self end x between: aRect left and: aRect right)
            or: [ (aRect left between: self start x and: self end x)
                or: [ aRect right between: self start x and: self end x ] ] ])
            ifFalse: [ ^false ].

    (aux1 := self start y) > (aux2 := self end y)
        ifTrue: [ aux1 := aux2.
                    aux2 := self start y ].
"Verify if the receiver has an overlapping in the Y-axis with the segment"
    ((aRect top between: aux1 and: aux2)
        or: [ (aRect bottom between: aux1 and: aux2)
            or: [ (aux1 between: aRect top and: aRect bottom)
                or: [ aux2 between: aRect top and: aRect bottom ] ] ])
            ifFalse: [ ^false ].

"Now check if the segment intersects..."
    ^super intersects: aRect!
isSegment
    "True if the receiver is a Segment
    Used for intersections..."

    ^true!   
normalTo: aPoint
    "Answer a line that is the normal to the receiver if and only if
    the intersection is included in the segment, else nil."

    | normal |

    normal := super normalTo: aPoint.
    (self intersect: normal) isNil
        ifTrue: [ ^nil ].
    ^normal!   
originOffset
    "Returns the instance var of the receiver
     for external manipulation"

    ^self isVertical
        ifTrue: [ self start x ]
        ifFalse: [ super originOffset ]!  
start
    "Returns the instance var of the receiver
     for external manipulation"
    ^start!
start: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    start := anObject! !

! PictureObject class methods !  
aboutToSaveImage
    "Private - Resets the block to be evaluated when an instance can't be created. "

    GCBlock := nil.
    super aboutToSaveImage.!   
gcBlock: aBlock
    "Private - Sets the block to be evaluated when an instance can't be created.

    This block can perform some garbage-collection tasks.
    WARNING: This block must be setUp on each startUp of the current application.
        (when you save the image it will be cleared)

    aBlock must be a context with two parameters:
        param1  instance with the problem.
        param2  number of retries.

    and can return:
        #retry  to retry operation.
        another object to returns it's value as the loaded object.
    "

    GCBlock := aBlock.!
new
    "Returns an initialized instance of the receiver"
    ^super new initialize! !

! PictureObject methods ! 
doWithGC: aBlock while: testBlock
    "Private - Performs aBlock doing garbage collection
    while aBlock returns a value that evaluated in testBlock
    results in a true value.
    Returns the result of the retry operation...
    "

    | status option count |
    count := 0.
    [   status := aBlock value.
        testBlock value
    ] whileTrue: [
        GCBlock isNil ifTrue: [^nil].
        option := GCBlock value: self value: count.
        count := count + 1.
        option = #retry ifFalse: [^option].
    ]!   
initialize
    "Private - Initializes the receiver"
    "Default action is to do nothing.
     This method can be refined by subclasses"!  
properties
    "Private - Returns the receicer's properties"
    properties isNil ifTrue: [ properties := Dictionary new ].
    ^properties!   
propertyAt: aSymbol
    "Private - Returns the receicer's property named aSymbol or ni if absent"
    ^self properties at: aSymbol ifAbsent: []!
propertyAt: aSymbol ifAbsent: aBlock
    "Private - Returns the receicer's property named aSymbol or evaluates aBlock if absent"
    ^self properties at: aSymbol ifAbsent: aBlock! 
propertyAt: aSymbol put: anObject
    "Private - Sets the receicer's property named aSymbol to anObject"
    anObject isNil
    ifTrue: [ ^self properties removeKey: aSymbol ifAbsent: [] ].
    ^self properties at: aSymbol put: anObject! 
release
    "Private - Releases the receiver"

    super release.
    self releaseProperties.!
releaseProperties
    "Private - Releases the receiver's properties"

    properties size > 0
    ifTrue: [
        properties keysDo: [:each|
            (properties at: each) release ].
        properties := nil.
    ].! !

! PictureControl class methods !  
canUnderstand: aSymbol
    "Reimplemented here to use full instance"
    ^(super canUnderstand: aSymbol)
        or: [ self pictureClass canUnderstand: aSymbol ]! 
on: aPicture
    "Returns an instance of the receiver for working on aPicture"

    ^self new
        picture: aPicture;
        yourself!   
pictureClass
    "The receiver's must returns the spected class for picture images"

    ^PictureBitmap! !

! PictureControl methods !   
basicActions
    "Private - Returns the receivers basic actions..."

    ^#()! 
can: anAction
    "Returns true if the receiver can perform anAction.
    e.g.:   self can: #record
    This method can be refined by subclasses to
    returns a more aproppiate response acording to
    the picture state..."

    ^((properties at: #actions ifAbsent: [#()]) includes: anAction)
        or: [ anAction isSymbol and: [ self respondsTo: anAction ]]!
doesNotUnderstand: aMessage
    "Try to solve the message using the receiver's picture."

    picture isNil
    ifFalse: [
        aMessage receiver: picture.
        ^aMessage perform
    ].
    ^super doesNotUnderstand: aMessage!   
exchangePicture: aPicture
    "Private - Exchange picture to aPicture"

    aPicture isNil ifTrue: [^self].
    picture
        release;
        become: aPicture!  
initialize
    "Private - Receiver's initialization..."

    super initialize.
    self initializeActions.!   
initializeActions
    "Private - The receiver must register all the available actions
     that can perform..."

    | actions |
    actions := self basicActions.
    actions isEmpty
    ifFalse: [
        self properties
            at: #actions
            put: actions
    ].!
picture
    "Returns the instance var of the receiver
     for external manipulation"
    ^picture!
picture: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    picture := anObject! !

! HaloControl class methods !
pictureClass
    "The receiver's must returns the spected class for picture images"

    ^HaloImage! !

! HaloControl methods !  
basicActions
    "Private - The receiver must return a set with actions
     that it can perform at any time."

    ^super basicActions
     , #(
        save restore
        record
    )!  
blur
    "Perform Blur (atenuado) on the picture
     acording to user request."

    | dialog strength |
    dialog := HaloValueDialog new.
    dialog
        title: 'Atenuado de imagen...';
        scale: (0 to: 10); value: 5;
        question: 'Cuanto desea atenuar la imagen ?';
        between: 0 and: 1 say: 'Levemente';
        between: 2 and: 5 say: 'Poco';
        between: 6 and: 7 say: 'Algo';
        between: 8 and: 9 say: 'Mucho';
        for: 10 say: 'Al mximo'.

    dialog open.

    strength := dialog value.
    strength isNil ifTrue: [^nil].

    ^picture blur: strength! 
convertToMono
    "Converts the picture to mono..."

    | mono |
    mono := picture asMono.
    mono isNil ifTrue: [^nil].
    self exchangePicture: mono.!   
despeckle
    "Perform Despeckle on the receiver
     acording to user request"

    | dialog sensitivity cellSize |
    dialog := HaloDespeckleDialog new.
    dialog
        title: 'Remocin de ruido...';
        scale: (0 to: 255);
        value: 127;
        area: #medium;
        yourself.

    dialog open.

    sensitivity := dialog value.
    sensitivity isNil ifTrue: [^nil].
    cellSize := #(0 0 small 0 medium 0 large) indexOf: dialog area.
    cellSize = 0 ifTrue: [^nil].

    ^picture despeckle: cellSize sensitivity: sensitivity! 
distort
    "Perform Distortion on the receiver
     acording to user request"

    | dialog corners |
    dialog := HaloDistortDialog new.
    dialog title: 'Deformacin de imagen...'.
    dialog open.

    corners := dialog corners.
    corners isNil ifTrue: [^nil].

    ^self distortRelative: corners! 
histogram
    "Open an Histogram dialog."
    | values |
    values := picture histogramValues.
    values notNil ifTrue: [
        HistogramDialog new openOn: values
    ]!   
invert
    "Perform Invertion on the receiver
     acording to user request."

    | dialog red green blue |
    dialog := HaloRGBDialog new.
    dialog title: 'Inversin de imagen...'.
    dialog open.

    red := dialog red.
    red isNil ifTrue: [^nil].
    green := dialog green.
    blue := dialog blue.

    ^picture
        invertRed: red
        green: green
        blue: blue!   
pixelize
    "Perform Pixelization of the receiver
     acording to user request."

    | dialog red green blue x y |
    dialog := HaloPixelizeDialog new.
    dialog title: 'Pixelizado de imagen...'.
    dialog open.

    red := dialog red.
    red isNil ifTrue: [^nil].
    green := dialog green.
    blue := dialog blue.
    x := dialog width.
    y := dialog height.

    ^picture
        pixelize: x@y
        red: red
        green: green
        blue: blue!  
posterize
    "Perform Posterization of the receiver
     acording to user request."

    | dialog red green blue |
    dialog := HaloPosterizeDialog new.
    dialog title: 'Posterizado de imagen...'.
    dialog open.

    red := dialog red.
    red isNil ifTrue: [^nil].
    green := dialog green.
    blue := dialog blue.

    ^picture
        posterize: dialog bits
        red: red
        green: green
        blue: blue!  
rotate
    "Returns a new imageformed by
     rotating the receiver
     acording to user request"

    | dialog angle rotated |
    dialog := HaloRotateDialog new.
    dialog title: 'Rotacin de imagen...'.
    dialog open.

    angle := dialog angle.
    angle isNil ifTrue: [^nil].

    rotated := picture
        rotatedTo: (angle * 10) truncated
        anchor: dialog anchor
        at: dialog anchorPoint.

    self exchangePicture: rotated.!   
scaled
    "Returns a new image formed by
     scaling the receiver
     acording to user request"

    | dialog scale scaled |
    dialog := HaloScaleFreeDialog new.
    dialog title: 'Escalado...'.
    dialog open.

    scale := dialog scale.
    scale isNil ifTrue: [^nil].

    scaled := picture
        scaledBy: scale
        smooth: dialog smooth.
    self exchangePicture: scaled.! 
scaledAbsolute
    "Returns a new image formed by
     scaling the receiver
     acording to user request"

    | dialog newExtent scaled |
    dialog := HaloScaleAbsoluteDialog new.
    dialog
        newExtent: picture extent;
        title: 'Escalado...'.
    dialog open.

    newExtent := dialog newExtent.
    newExtent isNil ifTrue: [^nil].

    scaled := picture
        scaledTo: newExtent
        smooth: dialog smooth.

    self exchangePicture: scaled.!  
sharpen
    "Perform Sharpen on the receiver
     acording to user request."

    | dialog strength |
    dialog := HaloValueDialog new.
    dialog
        title: 'Acentuado de bordes...';
        scale: (0 to: 10); value: 5;
        question: 'Cuanto desea resaltar la imagen ?';
        between: 0 and: 1 say: 'Levemente';
        between: 2 and: 5 say: 'Poco';
        between: 6 and: 7 say: 'Algo';
        between: 8 and: 9 say: 'Mucho';
        for: 10 say: 'Al mximo'.

    dialog open.

    strength := dialog value.
    strength isNil ifTrue: [^nil].

    ^picture sharpen: strength! !

! PictureBitmap class methods !   
canUnderstand: aSymbol
    "Reimplemented here to use full instance"
    | imageClass |
    imageClass := self imageClass.
    ^(super canUnderstand: aSymbol)
        or: [ imageClass ~= self
            and: [imageClass canUnderstand: aSymbol] ]! 
controller
    "Must return the appropiate controller class
     for the receiver's instances."

    ^Smalltalk at: #PictureControl!  
copyOf: aPictureBitmap extent: aPoint
    "Private - Returns a copy of the receiver of size aPoint"

   ^self implementedBySubclass!   
crop: aRectangle from: aPictureBitmap
    "Returns an instance of the receiver cropping aPictureBitmap
    to aRectangle or nil if failed..."

   ^self implementedBySubclass!
displayStamp: pathName with: aPen
    "Display a stamp formed from file pathName using aPen;
     and then releases the objects involved"

    | image |
    image := self fromFile: pathName.
    image isNil ifTrue: [^self].
    image displayStampWith: aPen.
    image release!  
formatForFilesWithExtension: extension
    "Private - Returns the format constant to be used
    for loading instances of file named with extension."

    ^self implementedBySubclass!   
formats
    "Returns the receiver's supported formats.
     must be aDictionary with
        key     description for format
        value   format value
    "
    ^Dictionary new! 
fromFile
    "Returns an instance of the receiver loaded from
    file named pathName; The format of the image will
    be infered from the file extension."

    | pathName |
    pathName := self pathFromUser.
    ^pathName isNil
     ifFalse: [ self fromFile: pathName ]!  
fromFile: pathName
    "Returns an instance of the receiver loaded from
    file named pathName; The format of the image will
    be infered from the file extension."

    ^self
        fromFile: pathName
        format: (
            self formatForFilesWithExtension: pathName fileExtension
        )!   
fromFile: aFileName format: aFormat
    "Returns an instance of the receiver loaded from aFileName.
     or nil if failed..."

    ^self new fileInFrom: aFileName format: aFormat!   
fromStream: aStream
    "Returns an instance of the receiver loaded from aStream.
     or nil if failed..."

    ^self new fromStream: aStream format: nil "autodetect..."!   
fromStream: aStream format: aFormat
    "Returns an instance of the receiver loaded from aStream.
     or nil if failed..."

    ^self new fromStream: aStream format: aFormat!   
fromUser
    "Returns an instance of the receiver loaded from
    file given by the user..."

    ^self fromFile! 
imageClass
    "Private - Returns the handle instance class"

    ^self "implementedBySubclass"!   
pathFromUser
    "Private - Returns a pathName prompter to the user (or nil if cancelled)."

    | dialog file filters allImages each |
    filters := #(
        ('*.tif' 'TIFF Files (*.TIF)')
        ('*.bmp;*.rle;*.dib' 'Bitmap Files (*.BMP,*.DIB,*.RLE)')
        ('*.flf' 'Flat Files (*.FLF)')
        ('*.cut' 'Halo CUT Files (*.CUT)')
        ('*.pcx;*.pcc' 'PCX Files (*.PCX,*.PCC)')
        ('*.pic' 'PICT Files (*.PIC)')
        ('*.gif' 'GIF Files (*.GIF)')
        ('*.jpg' 'JPEG Files (*.JPG)')
        ('*.tga' 'TARGA Files (*.TGA)')
        ('*.ras;*.im8' 'Sun Raster Files (*.RAS,*.IM8)')
        ('*.gif' 'GIF Files (*.GIF)')
        ('*.gif' 'GIF Files (*.GIF)')
    ).

    dialog := FileDialog new.
    dialog title: 'Select an image file...'.

    allImages := filters first first.
    2 to: filters size do: [:i|
        each := filters at: i.
        allImages := allImages, ';' , each first.
        dialog addFilter: each first description: each last.
    ].

    dialog
        addFilter: allImages description: 'All Image Files...';
        addFilter: '*.*' description: 'All Files (*.*)';
        defFilter: allImages; fileSpec: allImages;
        hideReadonly;
        open.
    ^dialog file!
printEngine
    "Returns the object that knows how to print...
    The object must understand:  #print:from:to:using:
    Usare P3Image..."

    ^P3Image!   
rotate: aRectangle from: aPictureBitmap
    "Returns an instance of the receiver rotated from aPicture.
     or nil if failed..."

   ^self implementedBySubclass!
rotate: aPicture to: angleX10 anchor: aConstantName at: aPoint
    "Private - Returns a new picture builded as aPicture rotated..."

   ^self implementedBySubclass!   
scale: aPictureBitmap to: aRectangle
    "Private - Returns a copy of the receiver of size aRectangle"

   ^self implementedBySubclass!
width: width height: height format: format
    "Creates a new instance of extent width@height and format format"
    ^self new width: width height: height format: format! !

! PictureBitmap methods !   
adapt: aNumber toScale: anInterval
    "Private - Scales aNumber (between -100 and 100) to anInterval.
     Returns the scaled value..."
    | lo hi amount |
    lo := -100.
    hi := 100.
    amount := aNumber - lo / (hi - lo).
    ^(anInterval last - anInterval first * amount) truncated + anInterval first!  
asParameter
    "Returns the receiver's hImage as parameter"

    ^hImage asParameter16!   
basicRelease
    "Private - Used for reimplementing release..."

    self stamp: nil.
    ^super release! 
boundingBox
    "Returns the receiver's boundingBox"

    ^self implementedBySubclass! 
brightness: aValue
    "Adjust the brightness of the receiver.
     aValue may be in the range -100 to +100"

    ^self implementedBySubclass!
contrast: aValue
    "Adjust the contrast of the receiver.
    aValue may be in the range -100 to +100"

    ^self implementedBySubclass! 
controller
    "Must return the appropiate control for the receiver."

    ^self class controller on: self!
copy
    "Returns a new PictureBitmap from the receiver..."

    ^self class crop: self boundingBox from: self!
copyToClipboard
    "Copies the receiver to the Clipboard"

    ^self implementedBySubclass!   
crop: aRectangle
    "Returns a new PictureBitmap from the receiver at aRectangle"

    ^self class crop: aRectangle from: self!   
cutTiles: aPoint
    "Cut the receiver in an array of images.
    El receptor sera cortado en aPoint x por aPoint y
     partes las que seran devueltas en una coleccion
     ordenada.
    Los cortes seran realizados primero en sentido horizontal
     y luego en la vertical.

    Asi el corte del receptor en 7@3 resultara en una colleccion
    de imagenes de 21 elementos cortados en el siguiente orden...

        +-----+-----+-----+-----+-----+-----+-----+
        |   1  |  2   |  3  |   4  |  5  |   6  |  7  |
        +-----+-----+-----+-----+-----+-----+-----+
        |   8  |  9   | 10  | 11 | 12  | 13  | 14  |
        +-----+-----+-----+-----+-----+-----+-----+
        |  15 | 16  |  17 | 18  | 19  | 20 |  21 |
        +-----+-----+-----+-----+-----+-----+-----+

    *ATENCION* El corte se realizara truncando la imagen
     si su extent no es multiplo de aPoint

    "

   ^self withTiles: aPoint do: nil!  
display: aRectangle at: aPoint with: aPen
    "Display the receiver's cropped to aRectangle
     with aPen at aPoint...
    This method can be reimplemented for efficiency"

    (self crop: aRectangle)
        displayAt: aPoint with: aPen;
        release!   
display: sourceRect inside: destRect using: aPen
    "Display the sourceRect region of the receiver in destRect using aPen"

    | source bBox sourceImage destImage |
    self isValid ifFalse: [^nil].
    bBox := self boundingBox.
    sourceRect isNil ifTrue: [ ^self display: bBox inside: destRect using: aPen ].
    source := sourceRect intersect: bBox.
    sourceImage := source = bBox
        ifTrue: [ self ] ifFalse: [ self crop: source ].
    destImage := sourceImage stampOfSize: destRect extent.
    destImage displayAt: destRect origin with: aPen.
    sourceImage == self ifFalse: [ sourceImage release ].!  
display: aRectangle with: aPen
    "Display the receiver's box contained in aRectangle
     with aPen at aRectangle origin..."

    ^self display: aRectangle at: aRectangle origin with: aPen!   
display: aRectangle with: aPen zoomFactor: zoomFactor
    "Display the receiver with aPen..."

    | stamp box |
    self isValid ifFalse: [^nil].
    (zoomFactor isNil or: [ zoomFactor = 1 ])
    ifTrue: [ ^self display: aRectangle with: aPen ].
    stamp := self
        stampOfSize: (self extent * zoomFactor) truncated
        effects: Dictionary new.
    stamp isNil
    ifTrue: [aPen fill: aRectangle color: aPen backColor]
    ifFalse: [
        stamp
            display: (aRectangle origin extent: (aRectangle extent * zoomFactor) truncated)
            with: aPen
    ].! 
display: aRectangle with: aPen zoomFactor: zoomFactor bandHeight: height
    "Display aRectangle of the receiver with aPen...
    The receiver will be zoomed by the zoomFactor AND
    The display will by HORIZONTAL BANDS... of height pixels."


    self display: aRectangle
                with: aPen
                zoomFactor: zoomFactor
                bandHeight: height
                at: 0@0! 
display: aRectangle with: aPen zoomFactor: zoomFactor bandHeight: height at: aPoint
    "Display aRectangle of the receiver with aPen at aPoint.
    The receiver will be zoomed by the zoomFactor AND
    The display will by HORIZONTAL BANDS... of height pixels (of the receiver image)."

    | imageRect start end left cropExtent cropRect crop stretch dispPoint oldTrackBoolean |

    (height isNil or: [ height <= 0 or: [ height >= self height ] ])
        ifTrue: [ ^self display: aRectangle
                                    with: aPen
                                    zoomFactor: zoomFactor
                                    bandHeight: (self height // 5 max: 20)
                                    at: aPoint ].
    (zoomFactor isNil or: [ zoomFactor <= 0 ])
        ifTrue: [ ^self display: aRectangle
                                    with: aPen
                                    zoomFactor: 1
                                    bandHeight: height
                                    at: aPoint ].
"Make sure we don't have a bunch of dialogs saying copying..., stretching..., etc."
    oldTrackBoolean := self useProgressDialogs.
    self useProgressDialogs: false.
    imageRect := self boundingBox intersect: aRectangle.
    start := imageRect top.
    end := imageRect bottom.
    left := imageRect left.
    dispPoint := aPoint.
    cropExtent := imageRect width - 1 @ (height + 1).

    start to: end by: height do: [ :index |
        cropRect := (left@ index extent: cropExtent) intersect: imageRect.
        crop := self crop: cropRect.
        stretch := crop scaledTo: (0@0 extent: (crop extent - 1 * zoomFactor)).
        crop release.
        stretch displayAt: dispPoint with: aPen.
        stretch release.
        dispPoint := dispPoint down: (height - 1 * zoomFactor).
    ].
"Set back to the normal tracking dialogs."
    self useProgressDialogs: oldTrackBoolean.!
display: aRectangle with: aPen zoomFactor: zoomFactor bandHeight: height atBack: aPoint
    "Display aRectangle of the receiver with aPen at aPoint.
    The receiver will be zoomed by the zoomFactor AND
    The display will by HORIZONTAL BANDS... of height pixels (of the receiver image)."

    | start end left cropExtent stretchExtent cropRect stretchRect crop stretch dispPoint pixelsZoom |

    (height isNil or: [ height <= 0 or: [ height >= self height ] ])
        ifTrue: [ ^self display: aRectangle
                                    with: aPen
                                    zoomFactor: zoomFactor
                                    bandHeight: (self height // 5 max: 20)
                                    at: aPoint ].
    (zoomFactor isNil or: [ zoomFactor <= 0 ])
        ifTrue: [ ^self display: aRectangle
                                    with: aPen
                                    zoomFactor: 1
                                    bandHeight: height
                                    at: aPoint ].
    start := aRectangle top.
    end := aRectangle bottom.
    end  := end // height - 1 * height.
    left := self boundingBox left.
    dispPoint := aPoint.
    pixelsZoom := height * zoomFactor.
    cropExtent := self width - 1 @ (height + 1).
    stretchExtent := cropExtent * zoomFactor.
    stretchRect := 0@0 extent: stretchExtent.
Transcript cr; cr;
    nextPutAll: 'Image boundingBox => ', self boundingBox asString; cr;
    nextPutAll: 'Rectangle boundingBox => ', aRectangle asString; cr;
    nextPutAll: 'Display boundingBox => ', (aRectangle origin * zoomFactor extent: aRectangle extent * zoomFactor) asString; cr;
    nextPutAll: 'Stretch rectangle => ', stretchRect asString; cr;
    nextPutAll: 'Zoom Factor => ', zoomFactor asString; cr;
    nextPutAll: 'Band height => ', height asString; cr;
    nextPutAll: 'Pixel height => ', pixelsZoom asString; cr.

    start to: end by: height do: [ :index |
        cropRect := left@ index extent: cropExtent.
        crop := self crop: cropRect.
        stretch := crop scaledTo: stretchRect.
        crop release.
Transcript cr; cr;
    nextPutAll: 'Crop rectangle => ', cropRect asString; cr;
    nextPutAll: 'Display point => ', dispPoint asString.
        stretch displayAt: dispPoint with: aPen.
        stretch release.
        dispPoint := dispPoint down: pixelsZoom.
    ].!   
displayAt: aPoint with: aPen
    "Display the receiver with aPen at aPoint."

    self isValid ifFalse: [^nil].
    ^self implementedBySubclass!  
displayStampWith: aPen
    "Display the receiver's stamp image with aPen..."

    | stamp box |
    self isValid ifFalse: [^nil].
    box := aPen canvasBox.
    box isNil ifTrue: [ box := aPen boundingBox ].
    stamp := self stampOfSize: box extent effects: Dictionary new.
    stamp isNil
    ifTrue: [self displayWith: aPen]
    ifFalse: [stamp displayWith: aPen].!
displayStampWith: aPen effects: aDictionary
    "Display the receiver's stamp image with aPen..."

    | stamp box |
    self isValid ifFalse: [^nil].
    box := aPen canvasBox.
    box isNil ifTrue: [ box := aPen boundingBox ].
    stamp := self stampOfSize: box extent effects: aDictionary.
    stamp isNil
    ifTrue: [self displayWith: aPen]
    ifFalse: [stamp displayWith: aPen].!  
displayWith: aPen
    "Display the receiver with aPen..."

    ^self implementedBySubclass!
doesNotUnderstand: aMessage
    "Try to solve the message using the receiver's handle."

    hImage isNil
    ifFalse: [
        aMessage receiver: hImage.
        ^aMessage perform
    ].
    ^super doesNotUnderstand: aMessage!  
effects: aDictionary
    "Private - Process the receiver with the effects in aDictionary.
     aDictionary must be a dictionary with keys corresponding
     to messages to send to the receiver and values for
     parameters for the effect"

    | value |
    aDictionary isNil ifTrue: [^self].
    aDictionary keysDo: [:effect|
        value := aDictionary at: effect.
        self perform: effect with: value.
        self properties at: effect put: value.
    ]!  
extent
    "Returns the receiver's extent"

    ^self width @ self height! 
fileInFrom: aFileName format: aFormat
    "Private - Read the receiver internal structure from aFile..."

    ^self implementedBySubclass! 
flipHoriz: aRectangle
    "Flip the receiver in aRectangle"

    ^self implementedBySubclass!  
flipVert: aRectangle
    "Flip the receiver in aRectangle"

    ^self implementedBySubclass!   
fromFile: aFileName
    "Read the receiver from aFileName.
     Returns nil if failed..."

    self release.
    self fileInFrom: aFileName format: nil.
    self isHandleOk ifFalse: [^nil].!  
fromStream: aStream format: aFormat
    "Returns an instance of the receiver loaded from aStream.
     or nil if failed...
    Default implementation copy all stream contents to a new
     temporaty file and use the #fileInFrom:format: message
     to fileIn the receiver. Then removes the temporary file..."

    | tempName result |
    tempName := KernelLibrary getTempFileName: 'OStyle'.
    (File newFastFile: tempName)
        nextPutAll: aStream contents;
        close.
    result := self
        fileInFrom: tempName
        format: aFormat.
    File remove: tempName ifAbsent: [].
    ^result!
height
    "Returns the receiver's height"

    ^self implementedBySubclass!   
hue: aValue
    "Adjust the hue of the receiver.
    aValue may be in the range -100 to +100"

    ^self implementedBySubclass!   
isHandleOk
    "True if the receiver has a valid handle"

    ^hImage notNil!  
isValid
    "True if the receiver is valid..."

    ^self isHandleOk!  
matchesEffects: aDictionary
    "Private - True if the receiver has been processed with effects in aDictionary"

    | one two |
    aDictionary isNil ifTrue: [^true].
    aDictionary keys
        detect: [:effect |
            one := self properties at: effect ifAbsent: [].
            two := aDictionary at: effect ifAbsent: [].
            one notNil & two notNil
            ifTrue: [ one ~= two ]
            ifFalse: [ one ~= 0 and: [ two ~= 0 ] ]
        ]
        ifNone: [^true].
    ^false!   
modified
    "True if the receiver has been modified"

    ^self implementedBySubclass!
outputToPrinter
    "Print the receiver on the system printer."

    ^self implementedBySubclass!  
pasteFromClipboard
    "Copies the Clipboard to the receiver"

    ^self implementedBySubclass!
pathName
    "Returns the instance var of the receiver
     for external manipulation"
    ^pathName!  
pathName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    pathName := anObject! 
print: sourceRect inside: destRect using: aPrinter
    " This message must be implemented for Printing...
       sourceRect will be the area inside the receiver's boundingBox (in pixels) to be printer
       destRect will be the destination area for output (in inches)
       aPrinter will be the current printer to use (placed in the current page).
    "
    | printEngine |
    printEngine := self class printEngine.
    printEngine isNil ifTrue: [ ^self implementedBySubclass ].
    ^printEngine
        print: self
        from: sourceRect
        to: destRect
        using: aPrinter!
privateHandle
    "Private - Returns the receiver's handle"

   ^hImage!   
privateHandle: anObject
    "Private - Forces the receiver's handle"

    self privateHandle release.
    hImage := anObject! 
processEffect: aSymbol inside: aRectangle
    "Private - Perform the effect of aSymbol inside aRectangle"

    (self suportedEffects includes: aSymbol)
    ifTrue: [
        ^self
            perform: (aSymbol,':') asSymbol
            with: aRectangle
    ].
    ^self unsupportedEffect: aSymbol!
release
    "Release the receiver's resources..."

    ^self implementedBySubclass!
remainsInMemory: aBoolean
    "if aBoolean is true the receiver will not be garbage collected"
    "Default action is to do nothing..."!
reverse
    "Reverse the receiver's image"

    ^self implementedBySubclass!   
rotate: aRectangle
    "Returns a new PictureBitmap from the receiver rotated aRectangle"

    ^self class rotate: aRectangle from: self!  
rotatedTo: angleX10 anchor: aConstantName at: aPoint
    "Private - Returns a new picture
    builded as the receiver's free angle rotated"

    ^self class
        rotate: self
        to: angleX10
        anchor: aConstantName
        at: aPoint!  
saturation: aValue
    "Adjust the saturation of the receiver.
    aValue may be in the range -100 to +100"

    ^self implementedBySubclass! 
save
    "Private - Save the receiver to file named pathName..."

   ^self saveAs: self pathName!  
saveAs: aFileName
    "Private - Save the receiver to aFileName.
     Returns nil if failed..."

   ^self
        saveAs: aFileName
        format: (self class
            formatForFilesWithExtension: aFileName fileExtension)! 
saveAs: aFile at: offset format: aFormat
    "Private - Save the receiver embedded into an storage system file (aFile) at offset
     Returns nil if failed..."

    ^self implementedBySubclass! 
saveAs: aFileName format: aFormat
    "Private - Save the receiver to aFileName.
     Returns nil if failed..."

   ^self implementedBySubclass!  
scaledAbsolute
    "Returns a copy of the receiver scaled by the user"

    ^self implementedBySubclass!   
scaledTo: aRectangle
    "Returns a new PictureBitmap from the receiver at aRectangle"

    ^self class scale: self to: aRectangle!
stamp
    "Private - Returns the receiver's stamp"

    ^self propertyAt: #stamp ifAbsent: []! 
stamp: aPictureBitmap
    "Private - Set receiver's stamp"

    self stamp release.
    self propertyAt: #stamp put: aPictureBitmap.! 
stampOfSize: aPoint
    "Private - Returns a stamp image of the receiver of size aPoint.
     The stamp will be catched into the receiver's properties."

    ^self stampOfSize: aPoint effects: nil! 
stampOfSize: aPoint effects: aDictionary
    "Private - Returns a stamp image of the receiver of size aPoint.
     The stamp will be catched into the receiver's properties."

    | stamp |
    stamp := self stamp.
    stamp isNil ifTrue: [
        stamp := self class copyOf: self extent: aPoint.
        self stamp: stamp.
    ]
    ifFalse: [
        (stamp width = aPoint x
        and: [ stamp height = aPoint y
        and: [ stamp matchesEffects: aDictionary ]])
        ifFalse: [ "build a new stamp..."
            CursorManager execute
            changeFor: [
                stamp release.
                stamp := self class copyOf: self extent: aPoint.
                stamp effects: aDictionary.
                self stamp: stamp.
            ]
        ].
    ].
    ^stamp!  
suportedEffects
    "Private - Returns the effects suported by the receiver."

    ^#( flipHoriz flipVert rotate)! 
unsupportedEffect: aSymbol
    "Private - Notify the user about an unsupported effect"

    ^self error: 'Efecto no soportado an...[', aSymbol,']'!   
width
    "Returns the receiver's width"

    ^self implementedBySubclass! 
width: width height: height format: format
    "Sets the receiver with new instance of extent width@height and format format"

    ^self implementedBySubclass!
withTiles: aPoint do: aBlock
    "Cut the receiver in an array of images
     and evaluates aBlock with each cutted piece.
    aBlock must release the cutted piece if needed.
    aBlock must be a one-param Block or nil...

    El receptor sera cortado en aPoint x por aPoint y
     partes las que seran devueltas en una coleccion
     ordenada.
    Los cortes seran realizados primero en sentido horizontal
     y luego en la vertical.

    Asi el corte del receptor en 7@3 resultara en una colleccion
    de imagenes de 21 elementos cortados en el siguiente orden...

        +-----+-----+-----+-----+-----+-----+-----+
        |   1  |  2   |  3  |   4  |  5  |   6  |  7  |
        +-----+-----+-----+-----+-----+-----+-----+
        |   8  |  9   | 10  | 11 | 12  | 13  | 14  |
        +-----+-----+-----+-----+-----+-----+-----+
        |  15 | 16  |  17 | 18  | 19  | 20 |  21 |
        +-----+-----+-----+-----+-----+-----+-----+

    *ATENCION* El corte se realizara truncando la imagen
     si su extent no es multiplo de aPoint

    "

    | box extent result piece |
    result := OrderedCollection new.
    extent := self extent // aPoint.
    0 to: aPoint y - 1 do: [:y|
        box := 0@y * extent y extent: extent.
        aPoint x timesRepeat: [
            piece := self crop: box.
            aBlock isNil ifFalse: [ aBlock value: piece ].
            result add: piece.
            box moveBy: extent x @ 0
        ]
    ].
    ^result asArray! !

! BMPImage class methods !   
crop: aRectangle from: aBmpImage
    "Returns an instance of the receiver cropped from aPicture.
     or nil if failed..."

    | bmp bitmap |
    bitmap := aBmpImage bitmap.
    bitmap isNil ifTrue: [^nil].

    bmp := self imageClass
        width: aRectangle width
        height: aRectangle height
        planes: bitmap planes
        bitCount: bitmap bitCount.

    bmp pen
        copyBitmap: bitmap
        from: aRectangle
        to: bmp boundingBox.

    ^self new
        bitmap: bmp;
        yourself!   
formatForFilesWithExtension: extension
    "Private - Returns the format constant to be used
    for loading instances of file named with extension."

    extension size = 0 ifTrue: [^nil].

    (#('bmp' 'dib') includes: extension asLowerCase)
    ifFalse: [
        ^self error: 'Only BMP & DIB are suppported'
    ].

    ^nil!  
imageClass
    "Private - Returns the handle instance class"

    ^Bitmap! 
scale: aBmpImage to: aRectangle
    "Private - Returns a copy of the receiver of size aRectangle"

    | bmp bitmap |
    bitmap := aBmpImage bitmap.
    bitmap isNil ifTrue: [^nil].

    bmp := self imageClass
        width: aRectangle width
        height: aRectangle height
        planes: bitmap planes
        bitCount: bitmap bitCount.

    bmp pen
        copyBitmap: bitmap
        from: bitmap boundingBox
        to: bmp boundingBox.

    ^self new
        bitmap: bmp;
        yourself! !

! BMPImage methods !   
bitmap
    "Private - Returns the receiver's bitmap"

    ^hImage! 
bitmap: aBitmap
    "Private - Sets the receiver's bitmap"

    hImage := aBitmap! 
boundingBox
    "Returns the receiver's boundingBox"

    self isValid
    ifTrue: [^hImage boundingBox].

    ^0@0 extent: 0@0!
copyToClipboard
    "Copies the receiver to the Clipboard"

    self isValid ifTrue: [
        ^Clipboard setBitmap: hImage
    ]!   
display: aRectangle at: aPoint with: aPen
    "Display the receiver's box contained in aRectangle
     with aPen at aRectangle origin..."

    self isValid ifTrue: [
        aPen
            copyBitmap: hImage
            from: aRectangle
            to: (aPoint extent: aRectangle extent)
    ]! 
display: sourceRect inside: destRect using: aPen
    "Display the sourceRect region of the receiver in destRect using aPen"

    self isValid ifFalse: [^nil].
    aPen
        copyBitmap: hImage
        from: sourceRect
        to: destRect!  
display: aRectangle with: aPen zoomFactor: zoomFactor
    "Display the receiver with aPen..."

    self isValid ifFalse: [^nil].
    (zoomFactor isNil or: [ zoomFactor = 1 ])
    ifTrue: [
        ^self display: aRectangle with: aPen
    ].

    aPen
        copyBitmap: hImage
        from: hImage boundingBox
        to: (aRectangle origin extent: (aRectangle extent * zoomFactor) truncated).!   
displayAt: aPoint with: aPen
    "Display the receiver with aPen at aPoint."

    self isValid ifFalse: [^nil].
    hImage displayAt: aPoint with: aPen.! 
displayWith: aPen
    "Display the receiver with aPen..."

    | box |
    self isValid ifFalse: [^nil].
    box := hImage boundingBox.
    aPen
        copyBitmap: hImage
        from: box
        to: box!   
fileInFrom: aFileName format: aFormat
    "Private - Read the receiver internal structure from aFile..."

    | dib |
    dib := DIB fromFile: aFileName.
    dib isNil ifTrue: [^nil].
    hImage := dib asBitmap.
    self pathName: aFileName.! 
fromStream: aStream format: aFormat
    "Returns an instance of the receiver loaded from aStream..."

    self privateHandle: (Bitmap fromStream: aStream).!   
height
    "Returns the receiver's height"

    self isValid ifFalse: [^0].
    ^hImage height!   
outputToPrinter
    "Print the receiver on the system printer."

    self isValid ifFalse: [^nil].
    ^hImage outputToPrinter!   
pasteFromClipboard
    "Copies the Clipboard to the receiver"

    self release.
    hImage := Clipboard getBitmap.!  
release
    "Private - Releases the receiver"

    self basicRelease.
    self isValid ifFalse: [^self].
    hImage release.
    hImage := nil.!
saveAs: aFileName
    "Private - Save the receiver to aFileName.
     Returns nil if failed..."

   ^self
        saveAs: aFileName
        format: nil!
saveAs: aFileName format: aFormat
    "Private - Save the receiver to aFileName.
     Returns nil if failed..."

    self isValid ifFalse: [^nil].
    hImage outputToFile: aFileName!   
width
    "Returns the receiver's width"

    ^self isValid
        ifTrue: [hImage width]
        ifFalse: [0]! 
width: width height: height format: format
    "Sets the receiver with new instance of extent width@height and format format"

    (format isNil or: [format = #screen])
    ifTrue: [
        hImage := Bitmap screenExtent: width@height.
        ^self
    ].

    format = #mono
    ifTrue: [
        hImage := Bitmap extent: width@height.
        ^self
    ].

    (#(16 color16) includes: format)
    ifTrue: [
        hImage := Bitmap width: width height: height planes: 4 bitCount: 1.
        ^self
    ].

    format isArray ifTrue: [ " #(planes bitCount) specified..."
        hImage := Bitmap width: width height: height planes: format first bitCount: format last.
        ^self
    ].

    hImage := Bitmap screenExtent: width@height! !

! DIBImage class methods !
aboutToSaveImage
    "Private - Resets the block to be evaluated when an instance can't be created. "

    self releaseDrawDibs.
    super aboutToSaveImage.! 
crop: aRectangle from: aBmpImage
    "Returns an instance of the receiver cropped from aPicture.
     or nil if failed..."

    ^self notImplementedYet!  
drawDibFor: aPen
    "Private - Returns a DrawDib object for drawing with aPen"

    | result |
    result := self drawDIBs
        detect: [:one| one pen = aPen ]
        ifNone: [ DrawDib using: aPen ].
    self drawDIBs add: result.
    ^result!  
drawDIBs
    "Private - Returns currently catched DrawDib objects"

    DrawDIBs isNil ifTrue: [ DrawDIBs := Bag new ].
    ^DrawDIBs!
formatForFilesWithExtension: extension
    "Private - Returns the format constant to be used
    for loading instances of file named with extension."

    extension size = 0 ifTrue: [^nil].

    (#('bmp' 'dib' 'rle') includes: extension asLowerCase)
    ifFalse: [
        ^self error: 'Only BMP, RLE & DIB are suppported'
    ].

    ^nil!   
fromBitmap: aBitmap

    | result |
    result := self new.
    result privateHandle: (DIB fromBitmap: aBitmap).
    ^result!
imageClass
    "Private - Returns the handle instance class"

    ^DIB!
releaseDrawDib: aDrawDib
    "Private - Release the drawDib object and unregister from cache"

    aDrawDib isNil ifTrue: [^self].
    self drawDIBs remove: aDrawDib ifAbsent: [].
    aDrawDib release.!   
releaseDrawDibs
    "Private - Release all the the drawDibs in use"

    self drawDIBs asSet do: [:each|
        each release
    ].
    DrawDIBs := nil.!  
scale: aBmpImage to: aRectangle
    "Private - Returns a copy of the receiver of size aRectangle"

    ^self notImplementedYet! !

! DIBImage methods !  
boundingBox
    "Returns the receiver's boundingBox"

    self isValid
    ifTrue: [^self privateHandle boundingBox].

    ^0@0 extent: 0@0!
copyToClipboard
    "Copies the receiver to the Clipboard"

    self isValid ifTrue: [
        ^self withBitmapDo: [:bitmap| Clipboard setBitmap: bitmap ]
    ]!
dibFor: aRectangle
    "Private - Returns a DIB for the receiver's handle cropped to aRectangle...
    This method can be refined by subclasses..."

    ^hImage! 
display: aRectangle at: aPoint with: aPen
    "Display the receiver's box contained in aRectangle
     with aPen at aRectangle origin..."

    self
        display: aRectangle
        inside: (aPoint extent: aRectangle extent)
        using: aPen!
display: sourceRect inside: destRect using: aPen
    "Display the sourceRect region of the receiver in destRect using aPen"

    self isValid
    ifTrue: [
        (self drawDibFor: aPen)
            source: (self sourceFor: sourceRect);
            destination: destRect;
            display: (self dibFor: sourceRect)
    ]!   
displayAt: aPoint with: aPen
    "Display the receiver with aPen at aPoint."

    | box |
    self isValid
    ifTrue: [
        box := self boundingBox.
        (self drawDibFor: aPen)
            source: (self sourceFor: nil);
            destination: (aPoint extent: box extent);
            display: (self dibFor: box)
    ]!  
displayWith: aPen
    "Display the receiver with aPen..."

    self isValid
    ifTrue: [
        (self drawDibFor: aPen)
            source: (self sourceFor: nil);
            destination: nil;
            display: (self dibFor: self boundingBox)
    ]!   
drawDibFor: aPen
    "Private - Returns the drawDib object for drawing with aPen..."

    (drawDib isNil
     or: [ drawDib isValid not
     or: [drawDib pen ~= aPen]])
    ifTrue: [
        self releaseDrawDib.
        drawDib := self class drawDibFor: aPen
    ].
    ^drawDib! 
fileInFrom: aFileName format: aFormat
    "Private - Read the receiver internal structure from aFile..."

    | dib |
"debug...
Transcript printMillisecondsToRun: [
 "
    dib := self class imageClass fromFile: aFileName.
"
    Transcript show: 'Leyendo ',self class name,':',aFileName asString,' loadTime:'.
]. "

    dib isNil ifTrue: [ ^nil ].
    self privateHandle: dib.
    self pathName: aFileName.!  
fileOutSurrogate: anObjectFiler
    " Answer surrogate for object filing after performing any dump preprocessing."

    self releaseDrawDib.
    ^super fileOutSurrogate: anObjectFiler!  
fromStream: aStream format: aFormat
    "Returns an instance of the receiver loaded from aStream.
     or nil if failed..."

    | imageClass dib bfh |
    self release.
    imageClass := self class imageClass.

    bfh := imageClass readFileHeader: aStream.
    bfh bfType  = 'BM' ifFalse: [ ^nil "^self error: 'Formato de imgen invlido.' " ].

    dib := imageClass new fromStream: aStream.
    dib isNil ifTrue: [ ^nil ].

    self privateHandle: dib.!   
height
    "Returns the receiver's height"

    self isValid ifFalse: [^0].
    ^self boundingBox height! 
outputToPrinter
    "Print the receiver on the system printer."

    self isValid ifFalse: [^nil].
    ^self withBitmapDo: [:bmp| bmp outputToPrinter ]!  
pasteFromClipboard
    "Copies the Clipboard to the receiver"

    | bmp |
    self release.
    bmp := Clipboard getBitmap.
    self privateHandle: (self class imageClass fromBitmap: bmp).
    bmp release.!
release
    "Private - Releases the receiver"

    self basicRelease.
    self isValid ifFalse: [^self].
    self privateHandle release.
    self releaseDrawDib.!  
releaseDrawDib
    "Private - Releases the receiver's drawdib in use"

    drawDib isNil ifTrue: [^self].
    self class releaseDrawDib: drawDib.
    drawDib := nil.!   
saveAs: aFileName
    "Private - Save the receiver to aFileName.
     Returns nil if failed..."

   ^self
        saveAs: aFileName
        format: nil!
saveAs: aFileName format: aFormat
    "Private - Save the receiver to aFileName.
     Returns nil if failed..."

    self isValid ifFalse: [^nil].
    self privateHandle outputToFile: aFileName!   
sourceFor: aRectangle
    "Private - returns the source rectangle for aRectangle.
    This method can be reimplemented..."

    ^ aRectangle! 
width
    "Returns the receiver's width"

    self isValid ifFalse: [^0].
    ^self boundingBox width!
width: width height: height format: format
    "Sets the receiver with new instance of extent width@height and format format"

    | bitmap |
    bitmap := [:bmp|
        self privateHandle:
            (self class imageClass fromBitmap: bmp).
            bmp release.
        self
    ].
    (format isNil or: [format = #screen])
    ifTrue: [
        ^bitmap value: (Bitmap screenExtent: width@height)
    ].

    format = #mono
    ifTrue: [
        ^bitmap value: (Bitmap extent: width@height)
    ].

    (#(16 color16) includes: format)
    ifTrue: [
        ^bitmap value: (Bitmap width: width height: height planes: 4 bitCount: 1)
    ].

    format isArray ifTrue: [ " #(planes bitCount) specified..."
        ^bitmap value: (Bitmap width: width height: height planes: format first bitCount: format last)
    ].

    ^bitmap value: (Bitmap screenExtent: width@height)!
withBitmapDo: aBlock
    "Private - Evaluates aBlock with a (ddb) bitmap obtainied from
     the receiver, then release the bitmap..."

    | bitmap result |
    self isValid ifFalse: [ ^nil ].
    bitmap := self privateHandle asBitmap.
    result := aBlock value: bitmap.
    bitmap release.
    ^result! !

! HaloDIBImage class methods !
formatForFilesWithExtension: extension
    "Private - Returns the format constant to be used
    for loading instances of file named with extension."

    ^HaloImage formatForFilesWithExtension: extension! !

! HaloDIBImage methods !   
fileInFrom: aFileName format: aFormat
    "Private - Read the receiver internal structure from aFile..."

    | image dib |
    image := HaloImage fromFile: aFileName format: aFormat.
    image isNil ifTrue: [ ^nil ].
    self privateHandle: image asDIB.
    self pathName: aFileName.
    image release.! !

! VirtualDIBImage class methods !   
imageClass
    "Private - Returns the handle instance class"

    ^VirtualDIB! !

! VirtualDIBImage methods !
dibFor: aRectangle
    "Private - Returns a DIB for the receiver's handle cropped to aRectangle...
    Cropping i supported by the contained image..."

    ^hImage dibFor: aRectangle!   
privateHandle: anObject
    "Private - Forces the receiver's handle"

    super privateHandle: anObject.
    anObject notNil ifTrue: [ anObject useCache: true ].!
sourceFor: aRectangle
    "Private - returns the source rectangle for aRectangle.
    This method can be reimplemented..."

    ^ nil! !

! HaloImage class methods !   
controller
    "Must return the appropiate controller class
     for the receiver's instances."

    ^Smalltalk at: #HaloControl! 
copyOf: aPictureBitmap extent: aPoint
    "Private - Returns a copy of the receiver of size aPoint"

    ^self newImageFrom: [
        aPictureBitmap scaledTo: aPoint smooth: "false "true
        ]!   
crop: aRectangle from: aPictureBitmap
    "Returns an instance of the receiver cropped from aPicture.
     or nil if failed..."

    ^self newImageFrom: [
        aPictureBitmap inside: aRectangle doReadOnly: [:instance| instance copy ]
        ]! 
formatForFilesWithExtension: extension
    "Private - Returns the format constant to be used
    for loading instances of file named with extension."

    ^extension notNil
    ifTrue: [
        HaloConstants
            at: extension asUpperCase
            ifAbsent: []
    ] ifFalse: [] "use auto-detect..."!  
formats
    "Returns the receiver's supported formats.
     must be aDictionary with
        key     description for format
        value   format value
    "
    ^self imageClass formats!
imageClass
    "Private - Returns the handle instance class"
    ^HaloVirtualImage! 
newImageFrom: aBlock
    "Private - Returns a new inatnce of the receiver
     with handled obtained from evaluating a block"

    | image handle |
    image := self new.
    image
        doWithGC: [ handle := aBlock value ]
        while: [ handle isNil ].
    handle isNil ifTrue: [^nil].
    image privateHandle: handle.
    ^image!   
rotate: aRectangle from: aPictureBitmap
    "Returns an instance of the receiver rotated from aPicture.
     or nil if failed..."

   ^self newImageFrom: [
        aPictureBitmap inside: aRectangle do: [:instance| instance rotateRight ]
        ]! 
rotate: aPicture to: angleX10 anchor: aConstantName at: aPoint
    "Private - Returns a new picture builded as aPicture rotated..."

    ^self newImageFrom: [
        aPicture inside: nil doReadOnly: [:instance|
            instance rotatedTo: angleX10 anchor: aConstantName at: aPoint
            ]
        ]! 
scale: aPictureBitmap to: aRectangle
    "Private - Returns a copy of the receiver of size aRectangle extent"

    | extent |
    ^self newImageFrom: [
        extent := aRectangle isNil
            ifTrue: [nil] ifFalse: [aRectangle extent].
        aPictureBitmap scaledTo: extent smooth: true
        ]! !

! HaloImage methods ! 
boundingBox
    "Returns the receiver's boundingBox"

    self isValid
    ifTrue: [^hImage boundingBox].

    ^0@0 extent: 0@0!
brightness: aValue
    "Adjust the brightness of the receiver.
     aValue is in the range -100 to +100"

    hImage brightness: aValue + 100 // 2. "Halo uses values between 0 and 100"
    self stamp: nil.!   
contrast: aValue
    "Adjust the contrast of the receiver.
    aValue is in the range -100 to +100"

    hImage contrast: aValue + 100 * 90 // 200. "Halo uses values between 0 and 90"
    self stamp: nil.!
copyToClipboard
    "Copies the receiver to the Clipboard"

    ^hImage copyToClipboard!   
createImageFromEffect: aSymbol inside: aRectangle
    "Private - Perform the effect of aSymbol inside aRectangle
     and returns a new instance of the receiver"

    ^self class newImageFrom: [
        hImage inside: aRectangle do: [:instance| instance perform: aSymbol ]
    ]! 
display: aRectangle at: aPoint with: aPen
    "Display the receiver's box contained in aRectangle
     with aPen at aRectangle origin..."

    self isValid ifFalse: [^nil].
    hImage display: aRectangle at: aPoint with: aPen.!  
displayAt: aPoint with: aPen
    "Display the receiver with aPen at aPoint."

    self isValid ifFalse: [^nil].
    hImage displayAt: aPoint with: aPen.! 
displayWith: aPen
    "Display the receiver with aPen..."

    self isValid ifFalse: [^nil].
    hImage display: self boundingBox with: aPen.!
fileInFrom: aFileName format: format
    "Private - Read the receiver internal structure from aFile..."

"debug...
Transcript printMillisecondsToRun: [
 "
    self
        doWithGC: [
            hImage := self class imageClass new
                loadFile: aFileName
                format: (format isNil
                    ifTrue: [self class formatForFilesWithExtension: aFileName fileExtension]
                    ifFalse: [format])
        ] while: [ hImage isValid not ].
"
    Transcript show: 'Leyendo ',self class name,':',aFileName asString,' loadTime:'.
]. "

    self pathName: aFileName.

    self isValid ifFalse: [^nil].!
fromBytes: aVariableByteObject format: aFormat
    "FilesIn the receiver from a byte arrayed collection (or string)..."

    ^self fromMemory: aVariableByteObject size: aVariableByteObject size format: aFormat
    "
    | winAddress result |
    winAddress := WinAddress copyToNonSmalltalkMemory: aVariableByteObject.
    result := self fromMemory: winAddress size: aVariableByteObject size format: aFormat.
    winAddress unlockAndFree.
    ^result                "!  
fromMemory: aWinAddress size: chunkSize format: format
    "Private - Read the receiver internal structure from a memory chunk..."

    self
        doWithGC: [
            hImage := self class imageClass new
                loadMemoryFile: aWinAddress
                size: chunkSize
                format: (format notNil ifTrue: [self class formatForFilesWithExtension: format]).
        ] while: [ hImage notNil and: [hImage isValid not] ].

    self isValid ifFalse: [^nil].!   
fromStream: aStream format: aFormat
    "Returns an instance of the receiver loaded from aStream.
     or nil if failed..."

    ^super fromStream: aStream format: aFormat

"This code fails...  and must be tested for release version...
    ^self fromBytes: (aStream upTo: nil) format: aFormat
"!   
height
    "Returns the receiver's height"

    self isValid ifFalse: [^0].
    ^hImage height!   
hue: aValue
    "Adjust the hue of the receiver.
     aValue is in the range -100 to +100"

    hImage gama: aValue + 100 * 40 // 200. "Halo uses values between 0 and 40"
    self stamp: nil.! 
isHandleOk
    "True if the receiver has a valid handle"

    ^hImage notNil and: [ hImage ~= 0 ]! 
modified
    "True if the receiver has been modified"

    ^self isValid and: [ hImage modified ]! 
outputToDisplay
    "Outputs the receiver on the system screen."

        self
            display: self boundingBox
            with: Display pen
            zoomFactor: 25
            bandHeight: 10
            at: 10@10!   
outputToPrinter
    "Print the receiver on the system printer."
    | printer zoomFactor box origin bandHeight |
    printer := Printer new.
    printer startPrintJob.
    box := printer pen boundingBox insetBy: 10.
    zoomFactor := 10 "box width // hImage width
                  min: box height // hImage height".
    origin :=
        printer pen boundingBox extent
         - (self extent * zoomFactor)
         // 2.

    bandHeight := 20.

    self
        display: self boundingBox
        with: printer pen
        zoomFactor: zoomFactor
        bandHeight: bandHeight
        at: origin.

    printer endPrintJob! 
pasteFromClipboard
    "Copies the Clipboard to the receiver"

    ^self notImplementedYet!
processEffect: aSymbol inside: aRectangle
    "Private - Perform the effect of aSymbol inside aRectangle"

    hImage isNil ifTrue: [^self].
    hImage
        inside: aRectangle
        do: [:instance| instance perform: aSymbol ].
    self stamp: nil.!  
release
    "Private - Releases the receiver"

    self basicRelease.
    hImage isNil ifTrue: [^self].
    hImage release.
    hImage := nil.! 
remainsInMemory: aBoolean
    "if aBoolean is true the receiver will not be garbage collected"

    self useProgressDialogs: aBoolean! 
saturation: aValue
    "Adjust the saturation of the receiver.
     aValue is in the range -100 to +100"

    hImage gama: aValue + 100 * 40 // 200. "Halo uses values between 0 and 40"
    self stamp: nil.!   
saveAs: aFileName format: aFormat
    "Private - Save the receiver to aFileName.
     Returns nil if failed..."

    self isValid ifFalse: [^nil].
    hImage saveAs: aFileName format: aFormat! 
scaledAbsolute
    "Returns a copy of the receiver scaled by the user"

    ^self class newImageFrom: [ hImage scaledAbsolute ]!   
scaledTo: aPoint smooth: aBoolean
    "Returns a copy of the receiver scaled to aPoint"

    ^self class newImageFrom: [ hImage scaledTo: aPoint smooth: aBoolean ]!   
sharpen: aRectangle
    "Sharpen the receiver's image inside aRectangle"

    hImage isNil ifTrue: [^self].
    hImage inside: aRectangle do: [:instance| instance sharpen ].
    self stamp: nil.!  
width
    "Returns the receiver's width"

    self isValid ifFalse: [^0].
    ^hImage width!  
width: width height: height format: format
    "Sets the receiver with new instance of extent width@height and format format"

    self release.
    self
        doWithGC: [
            hImage := self class imageClass new
                width: width height: height
                format: format
        ] while: [ hImage isValid not ].! !

! P3Image class methods !
copyOf: aPictureBitmap extent: aPoint
    "Private - Returns a copy of the receiver of size aPoint"
    | handle image |
    image := self new.
    handle := P3EditDLL library
            scaleImageFast: aPictureBitmap asParameter16
            srcRect: nil
            width: aPoint x asParameter16
            height: aPoint y asParameter16.
    handle = 0 ifTrue: [^nil].
    image privateHandle: handle.
    ^image!
crop: aRectangle from: aPictureBitmap
    "Returns an instance of the receiver cropped from aPicture.
     or nil if failed..."
    | handle image |
    image := self new.
    handle := P3EditDLL library
            crop: aPictureBitmap asParameter16
            rect: aRectangle asParameter16.
    handle = 0 ifTrue: [^nil].
    image privateHandle: handle.
    ^image!  
formatForFilesWithExtension: extension
    "Private - Returns the format constant to be used"

    | ext |
    ext := extension asLowerCase.
    ext at: 1 put: ext first asUpperCase.
    ^P3Constants at: 'Ff',ext
        ifAbsent: [ "try subformat option... like BmpMono Bmp24"
            P3Constants at: 'Ffmt',extension
            ifAbsent: [^self error: 'Formato de imagen desconocido']
        ].! 
imageClass
    "Private - Returns the handle instance class"

    ^self!   
print: aPictureBitmap from: sourceRect to: destRect using: aPrinter
    "Print an instance of the receiver built from aPictureImage pathName..."

    "OJO las HaloImage pueden mantener el file abierto y no se podra imprimir..."
    | instance pathName failed factor capability destination |

    failed := [ "fail to print..."
        "compute dest rect in pixels..."
        capability := aPrinter capability.
        factor := aPrinter extent / capability extentInInches.
        destination := (destRect scaleBy: factor) truncated.
        aPrinter
            place: destination origin;
            box: destination corner;
            place: destination center;
            displayText: aPictureBitmap pathName asString.
        instance release.
        ^nil
    ].

    pathName := aPictureBitmap pathName.
    pathName isNil ifTrue: [ failed value ].
    instance := self fromFile: pathName.
    (instance notNil and: [instance isValid])
    ifTrue: [
        instance
            print: sourceRect
            inside: destRect
            using: aPrinter.
        instance release.
    ].!  
rotate: aRectangle from: aPictureBitmap
    "Returns an instance of the receiver rotated from aPicture.
     or nil if failed..."
    | handle image |
    image := self new.
    handle := P3EditDLL library
        rotate: aPictureBitmap asParameter16
        rect: aRectangle asParameter16.
    handle = 0 ifTrue: [^nil].
    image privateHandle: handle.
    ^image!  
scale: aPictureBitmap to: aRectangle
    "Private - Returns a copy of the receiver of size aRectangle"
    | handle image |
    image := self new.
    handle := P3EditDLL library
            scaleImage: aPictureBitmap asParameter16
            srcRect: nil
            width: aRectangle width asParameter16
            height: aRectangle height asParameter16.
    handle = 0 ifTrue: [^nil].
    image privateHandle: handle.
    ^image! !

! P3Image methods !   
adapt: aNumber
    "Private - Scales aNumber (between -100 and 100) to (-127 to: 127).
     Returns the scaled value..."

    ^self adapt: aNumber toScale: (-127 to: 127)!   
boundingBox
    "Returns the receiver's boundingBox"

    ^0@0 extent: self extent - 1!
brightness: aValue
    "Adjust the brightness of the receiver."

    hImage isNil ifTrue: [^self].
    P3ColorDLL library
        setBrightness: hImage
        to: (self adapt: aValue).
    self stamp: nil.!
contrast: aValue
    "Adjust the contrast of the receiver."

    hImage isNil ifTrue: [^self].
    P3ColorDLL library
        setContrast: hImage
        to: (self adapt: aValue).
    self stamp: nil.!  
copyToClipboard
    "Copies the receiver to the Clipboard"

    P3EditDLL library
        copyImageToClipboard: self asParameter! 
displayAt: aPoint with: aPen
    "Display the receiver with aPen at aPoint."

    self isValid ifFalse: [^nil].

    P3DispDLL library
        displayImage: self
        in: aPen handle
        at: aPoint! 
displayWith: aPen
    "Display the receiver with aPen..."

    self displayAt: 0@0 with: aPen! 
fileInFrom: aFile at: offset format: aFormat
    "Private - Read the receiver internal structure from aFile at offset offset and format aFormat
    WARNING:  Here format is required..."

    | format |
    format := aFormat isString
        ifTrue: [ self class formatForFilesWithExtension: aFormat ]
        ifFalse: [aFormat]. "a FfFormat assumed (in P3Constants...) "

    hImage := P3FileDLL library
        readEmbeddedImageFile: aFile
        offset: offset
        format: format.

    self isValid ifFalse: [^nil].! 
fileInFrom: aFileName format: aFormat
    "Private - Read the receiver internal structure from aFile..."

    hImage := P3FileDLL library readImageFile: aFileName asParameter16.
    self isValid ifFalse: [^nil].
    self pathName: aFileName.!   
flipHoriz: aRectangle
    "Flip the receiver in aRectangle"

    hImage isNil ifTrue: [^self].
    P3EditDLL library
        flipLeftRight: hImage
        rect: aRectangle asParameter16.
    self stamp: nil.!   
flipVert: aRectangle
    "Flip the receiver in aRectangle"

    hImage isNil ifTrue: [^self].
    P3EditDLL library
        flipTopBottom: hImage asParameter16
        rect: aRectangle asParameter16.
    self stamp: nil.!  
fromBytes: aVariableByteObject format: aFormat
    "FilesIn the receiver from a byte arrayed collection (or string)..."

    | winAddress result |
    winAddress := WinAddress copyToNonSmalltalkMemory: aVariableByteObject.
    result := self fromMemory: winAddress size: aVariableByteObject size format: aFormat.
    winAddress unlockAndFree.
    ^result!
fromMemory: aWinAddress size: chunkSize format: format
    "Private - Read the receiver internal structure from a memory chunk..."

    self
        doWithGC: [
            self notImplementedYet.
        ] while: [ hImage isValid not ].

    self isValid ifFalse: [^nil].! 
fromStream: aStream format: aFormat
    "Returns an instance of the receiver loaded from aStream.
     or nil if failed..."

    ^super fromStream: aStream format: aFormat

"This code fails...  and must be tested for release version...
    ^self fromBytes: (aStream upTo: nil) format: aFormat
"!   
height
    "Returns the receiver's height"

    self isValid ifFalse: [^0].
    ^P3InfoDLL library
        getImageHeight: self asParameter! 
hue: aValue
    "Adjust the hue of the receiver."

    hImage isNil ifTrue: [^self].
     P3ColorDLL library
        setHue: hImage
        to: (self adapt: aValue).
    self stamp: nil.!
isHandleOk
    "True if the receiver has a valid handle"

    ^hImage notNil and: [ hImage ~= 0 ]! 
outputToPrinter
    "Print the receiver on the system printer."

    | printer rectangle |
    CursorManager execute
    changeFor: [
        printer := Printer new.
        rectangle :=  50@50 extent: 600@0.
        P3PrintDLL library
            startPrinterPage: printer deviceContext;
            print: self asParameter on: printer to: rectangle;
            endPrinterPage: printer deviceContext.
    ]! 
pasteFromClipboard
    "Copies the Clipboard to the receiver"
    | localHandle |

    localHandle := P3EditDLL library getImageFromClipboard: self asParameter.
    localHandle = 0 ifTrue: [^nil].
    self release.
    hImage := localHandle.
    self stamp: nil.!   
print: sourceRect inside: destRect using: aPrinter
    " This message must be implemented for Printing...
       sourceRect will be the area inside the receiver's boundingBox (in pixels) to be printer
       destRect will be the destination area for output (in inches)
       aPrinter will be the current printer to use (placed in the current page).
    "

    | dest capability factor gap |
    gap := 0.01.

    P3PrintDLL library
        print: self
        source: sourceRect
        destination: (destRect intersect: (gap @ gap extent: aPrinter capability extentInInches - gap))
        printer: aPrinter.

        "compute dest rect in pixels...
        capability := aPrinter capability.
        factor := capability extent / capability extentInInches.
        dest := (destRect scaleBy: factor) truncated.
        aPrinter pen
            place: dest origin;
            box: dest corner
        "! 
release
    "Private - Releases the receiver"

    | lib |
    self basicRelease.
    hImage isNil ifTrue: [^self].
    lib := P3DispDLL library.
    lib isNil ifTrue: [^self].
    lib destroyImage: hImage.
    hImage := nil.!   
reverse
    "Reverse the receiver's image"

    hImage isNil ifTrue: [^self].
    P3EditDLL library negative:  hImage.
    self stamp: nil.! 
saturation: aValue
    "Adjust the saturation of the receiver."

    hImage isNil ifTrue: [^self].
    P3ColorDLL library
        setSaturation: hImage
        to: (self adapt: aValue).
    self stamp: nil.!
saveAs: aFile at: offset format: aFormat
    "Private - Save the receiver into storage system (aFile) at offset
     Returns nil if failed..."

   | result format |
   format := P3Constants
        at: aFormat
        ifAbsent: [ aFormat isString ifTrue: [ FfmtBmp256C ] ifFalse: [ aFormat ] ].

    self displayWith: Display pen halt.

   result := P3FileDLL library
        writeEmbeddedImageFile: self asParameter16
        on: aFile
        offset: offset asParameter16
        format: format asParameter16.
   result = 0 ifFalse: [^nil].!   
saveAs: aFileName format: aFormat
    "Private - Save the receiver to aFileName.
     Returns nil if failed..."

   | result format |
   format := P3Constants
        at: aFormat
        ifAbsent: [ FfmtBmp256C ].
   result := P3FileDLL library
        writeImageFile: self asParameter
        on: aFileName asParameter16
        format: format asParameter16.
   result = 0 ifFalse: [^nil].!   
width
    "Returns the receiver's width"

    self isValid ifFalse: [^0].
    ^P3InfoDLL library getImageWidth: self asParameter! !

! PictureLibrary class methods !   
aboutToSaveImage
    "Private - Free all libraries in use... "

    self freeLibraries.!   
extension
    " Private - Returns the receiver's file storage extension."

    ^'OSL'! 
freeLibraries
    "Private - Free all libraries in use...
    PictureLibrary freeLibraries
    "

    [ Libraries size > 0 ]
    whileTrue: [ Libraries removeFirst release ].
    Libraries := nil.!  
fromFile: fileName
    "Returns an image for storage systems obtained from fileName..."

    | root id extension library stream result |
    fileName size = 0 ifTrue: [ ^nil ].
    stream := ReadStream on: fileName reversed.
    extension := stream upTo: $..
    id := String new.
    [stream peek isDigit ] whileTrue: [ id := id , (String with: stream next) ].
    root := stream upTo: nil.
    extension := extension reversed.
    id := id reversed.
    root := root reversed.
    library := self named: root asUpperCase.
    library isNil ifTrue: [ ^nil ].
    result := library image: id format: extension.
    ^result!   
initializeLibraries
    "Private - Initialize libraries in use... "

    Libraries := OrderedCollection new.!  
libraries
    " Private - Returns current libraries in use."

    Libraries isNil ifTrue: [ self initializeLibraries ].
    ^Libraries!   
maxLibrarySize
    "Private - Maximun number of open libraries supported..."

    ^(self profiler at: #maxLibrarySize ifAbsent: [ 7 ]) asInteger max: 2!   
named: aName
    "Returns an instance of the receiver with name aName.
    aName will be used as storage pathName..."

    ^self libraries
        detect: [:one| one name = aName ]
        ifNone: [ self new name: aName ]!  
registerLibrary: aLibrary
    "Private - register aLibrary as a valid library..."

    | libraries |
    libraries := self libraries.
    Libraries := libraries select: [:each| each isOpen ].

    [
        libraries := self libraries.
        libraries size >= self maxLibrarySize
    ] whileTrue: [ libraries removeFirst release ].

    (libraries includes: aLibrary)
    ifFalse: [ libraries add: aLibrary ].! !

! PictureLibrary methods ! 
canBeOpened
    " Private - Returns true if the receiver can open it's file storage system."

    | pathName |
    pathName := self pathName.
    (File exists: self pathName) ifFalse: [^false].
    file := File fastPathNameReadOnly: self pathName.
    ^true! 
close
    "Close the receiver's strorage system and
     indexes and force to be reopened if used..."

    self isOpen ifTrue: [ file close ].
    index := file := nil.!
extension
    " Private - Returns the receiver's file storage extension."

    ^self class extension!  
fileInHeader
    " Private - FilesIn the header information for the receiver..."

    | header headerSize stream signature values position |

    "validate signature string..."
    signature := self signature.
    signature size > 0
    ifTrue: [
        values := file next: signature size.
        values = signature ifFalse: [
            ^self error: 'Formato de archivo invlido. Provablemente no sea una librera de imgenes.'
        ].
    ].

    "validate version number..."
    signature := 0.
    self versionNumbers do: [:i| signature := signature * 256 + i ].
    values := 0.
    1 to: self versionNumbers size do: [:i|
        values := values * 256 + file next asciiValue
    ].
    values > signature ifTrue: [
        MessageBox warning: 'Versin de librera de imgenes errnea o posterior al software.'
    ].

    "Read header..."
    headerSize := file nextULong.
    position := file position.
    file reset.
    header := file next: headerSize.
    stream := ReadStream on: header.
    stream position: position.

    signature := stream nextLine trimBlanks.
    signature size > 0
    ifTrue: [
        self imageSupportClass: (Smalltalk at: signature asSymbol ifAbsent: [])
    ]!
fileInIndex
    " Private - FilesIn the index information for the receiver..."

    | stream |

    "open the receiver's  storage if not open yet..."
    self isOpen ifFalse: [ self canBeOpened ifFalse: [ ^nil ] ].

    "position storage system at header offset"
    file reset.
    file atEnd ifTrue: [^nil].
    self fileInHeader.

    "get index size & initialize index table..."
    imageCount := file nextULong.
    index := Array new: imageCount.

    stream := WriteStream on: index.
    index size timesRepeat: [ stream nextPut: file nextULong ].
    ^index! 
headerSize
    " Private - Returns the size in bytes of the header..."

    ^128!  
image: id format: format
    " Load & returns image of id #id and format format in the receiver's storage system...
    Returns nil if failed..."

    | offset |
    offset := self offsetFromId: id.
    offset isNil ifTrue: [ ^nil ].
    ^self
        imageAtOffset: offset
        format: format!
imageAtOffset: offset format: aFormat
    "Private - Must load & return the image at offset 'offset' in the receiver's storage system.
    Must return nil if failed or a valid PictureBitmap..."

    ^self implementedBySubclass!   
imageSupportClass: aPictureBitmapClass
    "Private - Must set the image class for the receiver...
    aPictureBitmapClass can be nil."

    ^self implementedBySubclass! 
index
    " Private - Returns the index table.
    Try to fileIn it if file not open..."

    index isNil ifFalse: [ ^index ].
    self fileInIndex.
    ^index!
isOpen
    " Private - True if the receiver is valid..."

    ^file notNil and: [ file file fileId notNil ] "file open..."!
isValid
    "Returns true if the receiver can be used as a valid storage"

    | indexes |
    indexes := self index.
    indexes size = 0 ifTrue: [^false].
    ^indexes first > 0!
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^name!  
name: aName
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"

    name := aName.
    self class registerLibrary: self.! 
offsetFromId: anId
    " Private - Gets the offset for image in storage file..."

    | result |
    anId isNil ifTrue: [ ^nil ].
    anId isInteger ifFalse: [ ^self offsetFromId: anId asInteger ]. "use integer ids..."
    self index isNil ifTrue: [ ^nil ].
    (anId between: 1 and: imageCount) ifFalse: [ ^nil ].
    result := self index at: anId.
    ^result > 0 ifTrue: [ result ].!   
pathName
    " Private - Returns the receiver's file storage system pathName."

    ^name,'.',self extension!  
release
    "Release receiver's resources..."

    self close.
    super release.!
signature
    " Private - Returns the signature bytes..."

    ^'OSL'! 
versionNumbers
    " Private - Returns an array with current version numbers..."

    "version:1 subversion: 0 build: 0"
    ^Array with: 1 with: 0 with: 0! !

! StandardTileStorage class methods !   
createLibrary: aName count: count
    "Create a new library named aName to store up to count images..."

    ^self new
        initialize: count;
        name: aName;
        yourself!
supportedImages
    "The receiver must implement the picture classes that it supports..."

    ^PictureBitmap withAllSubclasses! !

! StandardTileStorage methods !  
at: aNumber put: aTile
    "Store aTile in the receiver's storage system..."

    | offset fName |
    readOnly ifTrue: [ ^self error: 'Sistema de almacenamiento de solo lectura.' ].

    "by default configure the receiver image class from fist tile..."
    imageSupportClass isNil
    ifTrue: [ imageSupportClass := aTile bitmapClass ].

    self isOpen ifFalse: [
        self canBeOpened ifFalse: [ ^nil ].
        index size * 4 > file size ifTrue: [ self fileOutIndex ].
    ].
    fName := aTile name.
    offset := file size.
    index at: aNumber put: offset.
    self
        saveTile: aTile
        at: offset
        format: (self formatFor: aTile).
    modified := true.
    file setToEnd.!  
canBeOpened
    " Private - Returns true if the receiver can open it's file storage system."

    | fName |
    readOnly ifTrue: [ ^super canBeOpened ].
    fName := self pathName.
    ((File exists: fName)
     and: [ MessageBox confirm: 'El archivo ',fName,'\Ya existe. Seguro lo sobreescribe ?'withCrs])
    ifTrue: [ file := File newFastFile: fName ]
    ifFalse: [ file := File fastPathName: fName ].
    ^true!
close
    "Close the receiver's strorage system and
     indexes and force to be reopened if used..."

    self isOpen ifTrue: [
        modified ifTrue: [ self fileOutIndex ].
        file close
    ].
    index := file := nil.! 
fileOutHeader
    " Private - FileOut the receiver's header information...
    Header includes version & imageSupportClass name
    Header has a fixed size..."

    | header stream |
    header := String new: self headerSize.
    stream := WriteStream on: header.

    "build header...              size
        * signature                3 bytes
        * version number        3 bytes
        * header size             4 bytes
        * imageSupportClass variable,nextLine
    "
    stream
        nextPutAll: self signature;
        nextPutAll: (self versionNumbers collect: [:byte| Character value: byte ]);
        nextFourBytesPut: header size;
        nextPutAll: (imageSupportClass isNil ifTrue: [String new] ifFalse: [ imageSupportClass name ]);
        cr;
        yourself.


    "save header information..."
    file nextPutAll: header.!
fileOutIndex
    " Private - FileOut the receiver's index into the file..."

    (self isOpen not or: [ readOnly ]) ifTrue: [ ^nil ].
    file reset.
    self fileOutHeader.
    file nextFourBytesPut: index size.
    index do: [:each| file nextFourBytesPut: each ].! 
formatFor: aTile
    "Private - Must return the format for image of tile aTile"

    ^aTile name fileExtension!
fromStream: aStream format: chunkFormat
    " Private - Returns an image from a stream in memory..."

    ^self imageSupportClass
        fromStream: aStream
        format: (self imageSupportClass formatForFilesWithExtension: chunkFormat)! 
imageAtOffset: offset format: aFormat
    "Load & Returns image at offset offset in the receiver's storage system...
    Must return nil if failed.
    See method #saveImage:at:format:  for standard-embedded-image chunks format"

    | chunkFormat chunkSize chunk result |
"debug...
Transcript printMillisecondsToRun: [
"
    file position: offset.
    file atEnd ifTrue: [ ^nil ].
    chunkFormat := file nextLine trimBlanks.
    chunkFormat size > 0 ifFalse: [ chunkFormat := aFormat ].
    file atEnd ifTrue: [ ^nil ].
    chunkSize := file nextULong.
    chunkSize > 0 ifFalse: [ ^nil ].
    chunk := file next: chunkSize.
    result := self
        fromStream: chunk asStream
        format: chunkFormat.
"
    Transcript show: 'Leyendo ',self class name,'[',name asString,']#',offset asString,' loadTime:'.
]. "
    ^result! 
imageSupportClass
    " Private - Defines the image load/save support class...
    Image support instances must understand:
        #fromStream: aStream format: aStringFormat
    By default use aplication image class...(in ini file...)
    "

    ^imageSupportClass isNil
        ifTrue: [TiledImage imageClass]
        ifFalse: [imageSupportClass]!
imageSupportClass: aPictureBitmapClass
    "Sets the image class for the receiver..."

    imageSupportClass := aPictureBitmapClass.!  
initialize
    " Private - Initialize the receiver."

    super initialize.
    readOnly := true.
    modified := false.!
initialize: aNumber
    " Private - Initialize the receiver for storing up to aNumber of images"

    self readOnly: false.
    imageCount := aNumber asInteger.
    index := Array new: imageCount.
    index atAllPut: 0.
    modified := true.! 
readOnly: anObject
    "Private - Sets the instance var of the receiver
     with anObject. (No checking is done)"

    readOnly := anObject! 
saveTile: aTile at: offset format: aFormat
    " Private - Save a new aTile at offset 'offset' in the receiver's file storage system..."

    "Standard-embedded-image format chunks is like:
        format<newLine>
        chunkSize(4bytes)[imageBits...]
    "

    | bits fName stream bytes |
    (File exists: aTile name)
    ifFalse: [ MessageBox warning: 'No encontr archivo: ', aTile name asString. ^nil ].

    stream := File fastPathNameReadOnly: aTile name.
    bytes := String new: stream size.
    stream getBytesFor: bytes.
    stream close.

"debug....
    Transcript cr;show:
         'ofs:',offset asString
        ,' Tile ',aTile name asString
        ,' size:',bytes size asString.
"

    file
        position: offset;
        nextPutAll: aFormat;cr;
        nextFourBytesPut: bytes size;
        nextPutAll: bytes;
        yourself.! !

! ProgramManager class methods !
run: commandLine
    "Executes the command line commandLine"

    ^self new run: commandLine! !

! ProgramManager methods !  
commandLineFor: aString
    "Private - Returns the command line for aString"

    | stream prologue extension epilogue root
      executables batchFiles commandLine |
    executables := #('exe' 'com' ).
    batchFiles := #('bat' ).

    stream := ReadStream on: aString.
    stream atEnd ifTrue: [^nil].
    prologue := String new.
    [ #($. $ ) includes: stream peek ]
    whileFalse: [
        prologue := prologue , (String with: stream next).
        stream atEnd ifTrue: [ ^aString ]
    ].
    extension := stream next = $.
        ifTrue: [ stream nextWord asLowerCase ]
        ifFalse: [ 'exe' ].

    epilogue := stream upTo: nil.
    extension size = 0 ifTrue: [ ^aString ].

    (executables includes: extension) ifTrue: [ ^aString ].
    (batchFiles includes: extension) ifTrue: [ self warning: 'batch file...',aString. ^aString ].

    "path name implicito..."
    commandLine := ShellDLL library regQuery: 'command' for: '.',extension,'\shell\open'.
    commandLine isNil ifTrue: [
        root := ShellDLL library regQuery: String new for: '.',extension.
        ((ShellDLL library regQuery: 'ddeexec' for: root,'\shell\open') notNil
        and: [self ddeExecute: root,'\shell\open'  arguments: aString]) ifTrue: [ ^nil ].
        commandLine := ShellDLL library regQuery: 'command' for: root,'\shell\open'.
    ].
    commandLine isNil ifTrue: [
        ^self error: 'La extension .',extension,' no esta asociada a ningn programa.'
    ].
    ^self parametersFrom: aString and: commandLine!   
ddeExecute: root arguments: params
    "Private - Execute the program associated to root with params
    using a DDE system channel..."
    | dde application topic ddeExec |
    ddeExec := ShellDLL library regQuery: 'ddeexec' for: root.
    ddeExec := self parametersFrom: params and: ddeExec.

    topic := ShellDLL library regQuery: 'topic' for: root,'\ddeExec'.
    topic isNil ifTrue: [ topic := 'System' ].
    application := ShellDLL library regQuery: 'application' for: root,'\ddeExec'.
    application isNil ifTrue: [
        application := ShellDLL library regQuery: 'command' for: root.
        application := (application reversed upTo: $\) reversed upTo: $.
    ].

    dde := DDEClient newClient: nil application: application topic: topic.
    dde isNil ifTrue: [ ^false ].
    dde
        executeCommand: ddeExec;
        terminate.
    ^true! 
errorBlock
    "Returns the instance var of the receiver
     for external manipulation"
    ^errorBlock!  
errorBlock: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    errorBlock := anObject! 
execute: commandLine
    "Private - Execute the command line..."

    ^self
        execute: commandLine
        mode: SwShownormal! 
execute: commandLine mode: aSwMode
    "Private - Execute the command line..."
    | result |
    commandLine size = 0 ifTrue: [ ^false ].
    result := KernelLibrary
        winExec: commandLine asParameter
        cmdShow: aSwMode.

    result < 32 "An Error has occurred"
    ifTrue: [
        errorBlock notNil ifTrue: [ errorBlock value: result ].
        ^false
    ].

    ^true!  
initialize
    " Private - Initialize the receiver."

    super initialize.
    errorBlock := [:err| self showError: err ].!  
parametersFrom: aString and: commandLine
    "Private - Returns the command line for aString"

    | parameters line index char stream |

    stream := ReadStream on: commandLine.
    parameters := aString asArrayOfSubstrings.
    index := 0.
    line := WriteStream on: String new.
    [stream atEnd] whileFalse: [
        char := stream next.
        char = $% ifTrue: [ "process parameter..."
            index := stream nextWord asInteger.
            (index between: 1 and: parameters size)
            ifTrue: [
                line nextPutAll: (parameters at: index).
                parameters at: index put: nil.
            ].
        ]
        ifFalse: [ line nextPut: char ].
    ].
    parameters do: [:remaining|
        remaining notNil ifTrue: [ line nextPutAll: ' ',remaining ]
    ].
    ^line contents! 
run: commandLine
    "Private - Run the command line...
    Command line can be an executable or an associated file..."

    ^self run: commandLine mode: SwShownormal!   
run: commandLine mode: aSwMode
    "Private - Run the command line...
    Command line can be an executable or an associated file..."

    ^self
        execute: (self commandLineFor: commandLine)
        mode: aSwMode! 
showError: anInteger
    "Private - An erro loading program has occurred.
     Notify the user about this"
    | errors label |
    errors := #(
        (0  'Memoria insuficiente')
        (2  'Archivo no encontrado')
        (3  'Archivo no encontrado')
        (5  'Atentado de linkeo dinamico a un programa')
        (6  'La libreria requiere distintos segmentos para ejecutarse')
        (10 'Versin incorrecta de sistema operativo')
        (11 'Archivo ejecutable de formato invlido.')
        (12 'Aplicacin de Sistema Operativo OS/2')
        (13 'Aplicacin de Sistema Operativo DOS 4.0')
        (14 'Formato de ejecutable desconocido')
        (15 'El programa no fu diseado para trabajar en modo protegido.')
        (16 'El programa no puede cargarse ms de una vez.')
        (17 'El programa no puede cargarse ms de una vez.')
        (18 'Aplicacin no preparada para correr en modo protegido')
    ).

    errors do: [:each|
        each first = anInteger
        ifTrue: [label := each last]
    ].
    label isNil ifTrue: [label := 'UnKnown Exec error : ', anInteger printString].

    UserLibrary messageBeep: 0.
    MessageBox warning: label! !

! ProjectClasses class methods !   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^self name!
abreviation: aString
    "Set the abreviation of the receiver"

    self compileSource: 'abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^', aString printString!   
addClass: aClass
    "Add a new class to the list of dependent in the receiver classes"
    | source cole stream cls toRemove generateCode |
    self == ProjectClasses ifTrue: [^self invalidMessage].

    cole := self classNames asSet asOrderedCollection.
    toRemove := Set new.
    cole do: [:each| "eliminate redundances..."
        cls := Smalltalk at: each ifAbsent: [each].
        (aClass inheritsFrom: cls) ifTrue: [^self]. "done..."
        (cls inheritsFrom: aClass) ifTrue: [toRemove add: each].
    ].
    cole removeAll: toRemove. "remove dependent classes..."
    cole add: (aClass isClass ifTrue: [aClass symbol ] ifFalse: [aClass]).

    "code generation block for class descriptions"
    generateCode := [:aCls|
        aCls isSymbol
        ifTrue: [source space;nextPutAll: aCls]
        ifFalse: [source nextPutll: '),(Array with: ',aCls printString,'),#(']
    ].

    source := ReadWriteStream on: (String new: 1000).
    source nextPutAll: 'classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#('.
    stream := ReadStream on: cole asArray.
    [stream atEnd] whileFalse: [
        source cr;next: 4 put: $ .
        4 timesRepeat: [ stream atEnd ifFalse: [
            generateCode value: stream next
        ]]
    ].
    source nextPutAll: ' )'.

    self compileSource: source contents!
addMethod: aMethod
    "Add a new method to the list of dependent in the receiver methods"
    | source dict generateCode aClass |
    self == ProjectClasses ifTrue: [^self invalidMessage].

    dict := self dependentMethods.

    aClass := aMethod classField.
    aClass := aClass isClass ifTrue: [aClass symbol] ifFalse: [aClass].
    dict at: aClass put:
        (dict at: aClass ifAbsent: [#()]) asArray, (Array with: aMethod selector).

    "code generation block for class descriptions"
    generateCode := [:aCls :aCole|
        aClass := aCls isSymbol
        ifTrue: [Smalltalk at: aCls ifAbsent: [self missingClass: aCls. nil]]
        ifFalse: [aCls].
        aClass isNil ifTrue: [^nil]. "exit now..."
        aCls isSymbol
        ifTrue: [source nextPutAll: aCls;space]
        ifFalse: [source nextPutAll: '),(Array with: ',aCls printString,'),#( '].
        source nextPutAll: aCole asArray printString
    ].

    source := ReadWriteStream on: (String new: 3000).
    source nextPutAll: 'methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#('.
    dict associationsDo: [:asoc|
        source cr;next: 4 put: $ .
        generateCode value: asoc key value: asoc value
    ].
    source nextPutAll: ' )'.

    self compileSource: source contents!   
basicFileOut
    "FileOut of the receiver and the ProjectClasses class sources
     for basic instalation of the receiver.
    *Warning* The source for all the is NOT included"

    | file classes |
    CursorManager execute change.

    file := Disk newFile:
        (File fileName: self abreviation extension: 'Cls').

    file  lineDelimiter: Cr.

    classes := Array with: ProjectClasses with: self.
    classes
    do: [:each|
        each basicFileOutOn: file.
        file nextChunkPut: ''.
    ].
    classes do: [:each|
        (ClassReader forClass: each class) fileOutOn: file.
        (ClassReader forClass: each) fileOutOn: file.
    ].

    file close.

    CursorManager normal change.!  
basicFileOutAll
    "FileOut of ProjectClasses and all subclasses class sources
     for basic instalation...
    ProjectClasses basicFileOutAll.
    "

    | file classes |
    CursorManager execute change.

    file := Disk newFile:
        (File fileName: 'Projects' extension: 'Cls').

    file  lineDelimiter: Cr.

    classes := ProjectClasses withAllSubclasses.
    classes
    do: [:each|
        each basicFileOutOn: file.
        file nextChunkPut: ''.
    ].
    classes do: [:each|
        (ClassReader forClass: each class) fileOutOn: file.
        (ClassReader forClass: each) fileOutOn: file.
    ].

    file close.

    CursorManager normal change.! 
basicFileOutOn: aStream
    "Permorms fileOut of the receiver only..."
    ^super fileOutOn: aStream!   
classesToRemove
    "Private - Returns the Project classes to be
    removed when it is destroyed.
    This method can be refined by subclasses..."

    ^self dependentClasses! 
classesWithoutSubclasses
    "Private - Returns the names of Project dependent classes
        That it's subclasses doesn't depends from the proyect."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#()!  
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#()!   
compileSource: source
    "Private - Compile and Log the source code in 'source' "
    | result |

    (result := self class compile: source trimBlanks) isNil
     ifTrue: [^self error: 'Error during code generation...'].

    Smalltalk logSource: source trimBlanks forSelector: result key inClass: self class! 
dependentClasses
    "Private - Returns the Project dependent classes."
    | classes noSubs result |
    classes := self classNames collect: [:each|
             Smalltalk at: each ifAbsent: [self missingClass: each] ].
    result := OrderedCollection new: classes size.
    noSubs := self classesWithoutSubclasses collect: [:each|
             Smalltalk at: each ifAbsent: [self missingClass: each] ].
    classes do: [:class |
        class notNil
        ifTrue: [
            result addAll:
                ((noSubs includes: class)
                    ifTrue: [Array with: class]
                    ifFalse: [class withAllSubclasses])
        ]
    ].
    ^result!  
dependentMethods
    "Private - Returns the Project dependent methods
     for individual classes."
    | result stream cls |
    result := Dictionary new.
    stream := ReadStream on: self methodsCollection.
    [stream atEnd] whileFalse: [
        cls := stream next.
        (result includesKey: cls)
        ifTrue: [ result at: cls put: (result at: cls), stream next ]
        ifFalse: [ result at: cls put: stream next asOrderedCollection ]
    ].
    ^result!
dependentProjects
    "Private - Returns the Project dependent proyects."
   ^(self proyectNames collect: [:each|
             Smalltalk at: each ifAbsent: [self missingProject: each] ]
    ) asArray!  
destroy
    "Destroy all the proyect"
    | class toRemove |
    (MessageBox confirm: 'Do you want to destroy ', self name,' ?') ifFalse: [^nil].

    self
        destroyMethods;
        destroyGlobalReferences.

    self classesToRemove asArray reversed
    do: [:each|
        class := Smalltalk at: each ifAbsent: [each].
        class selectors do: [:selector| class removeSelector: selector].
        class isMetaClass
        ifFalse: [
            class instVarNames atAllPut: 'x'. "destroy instances names"
            class classPool keys do: [:key| class classPool removeKey: key]. "destroy class var names"
            class sharedPools do: [:key| class removeSharedPool: key ]. "destroy shared pools references"
            class class selectors
                do: [:selector| class class removeSelector: selector].
        ]
    ].

    (MessageBox confirm: 'Remove the classes from system?')
    ifTrue: [
        self classesToRemove asArray reversed
        do: [:each| each removeFromSystem].
        self removeFromSystem.
    ].

    class := nil.
    Symbol purgeUnusedSymbols.
    Smalltalk unusedMemory.!  
destroyGlobalReferences
    "Private - Destroy all the proyect global variables references.
    Used for proyect destruction"

    "e.g. : Smalltalk at: #ProxyServers put: nil.
    Smalltalk removeKey: #ProxyServers."

    "default action is to remove unused PoolDictionary entries if the user wants to."
    | pools |
    self hasPoolDictionaries ifFalse: [^self].
    pools := self poolDictionaryNames.
    pools isEmpty ifTrue: [^self].
    self destroyUnusedPoolEntries: pools.!
destroyMethods
    "Destroy all the proyect methods..."
    | class toRemove |

    toRemove := self methodsToRemove.
    self nonRemovableMethods
        associationsDo: [:asoc|
            (toRemove includesKey: asoc key)
            ifTrue: [
                asoc value do: [:each|
                    (toRemove at: asoc key) remove: each ifAbsent: []
                ]
            ]
        ].

    toRemove associationsDo: [:asoc|
            class := Smalltalk at: asoc key ifAbsent: [asoc key].
            asoc value do: [:selector| class removeSelector: selector]
    ].

    self classesToRemove asArray reversed
    do: [:each|
        class := Smalltalk at: each ifAbsent: [each].
        class selectors do: [:selector| class removeSelector: selector].
        class isMetaClass
        ifFalse: [
            class class selectors
                do: [:selector| class class removeSelector: selector].
        ]
    ].!
destroyOtherSources
    "Destroy all the non proyect sources"
    | class dontRemove methods classes dependentClasses |
    (MessageBox confirm:
        ('Do you want to destroy \ALL the sources except\'
            ,' sources of ', self name,' ?') withCrs)
    ifFalse: [^nil].
    dontRemove := Set new.
    self dependentMethods
    associationsDo: [:asoc|
        class := Smalltalk at: asoc key ifAbsent: [asoc key].
        asoc value do: [:selector|
            dontRemove add: (class compiledMethodAt: selector)
        ].
    ].

    methods := Smalltalk methodsInLOG.
    dontRemove do: [:each| methods remove: each ifAbsent: []].
    classes := Set new.
    dependentClasses := self dependentClasses.
    methods copy do: [:each|
        (dependentClasses includes: each classField)
        ifTrue: [methods remove: each ifAbsent: []]
    ].


    (MessageBox confirm:
        ('Do you want to save the removed sources ?') withCrs)
    ifTrue: [
        (self saveOtherSources: methods) isNil
        ifTrue: [^nil].
    ].
    UserLibrary messageBeep: 0.
    (MessageBox confirm:
        ('Last Chance !!\Do you really want',
         ' to destroy \ALL the sources except\'
            ,' sources of ', self name,' ?') withCrs)
    ifFalse: [^nil].

    methods do: [:method|
        method classField
            removeSourcesOfSelector: method selector
    ].!  
destroySources
    "Destroy all the proyect sources"
    | class |
    (MessageBox confirm:
        ('Do you want to destroy \sources of ', self name,' ?') withCrs)
    ifFalse: [^nil].
    self dependentMethods
    associationsDo: [:asoc|
        class := Smalltalk at: asoc key ifAbsent: [asoc key].
        asoc value do: [:selector| class removeSourcesOfSelector: selector].
    ].
    self dependentClasses asArray reversed
    do: [:each| each removeSources].!
destroyUnusedPoolEntries: pools
    "Private - Destroy  unused PoolDictionary entries if the user wants to."

    | inUse collect poolDict |

    "Prompt the user..."
    (MessageBox confirm:
        'Do you want to destroy unused PoolDictionary entries ?\' withCrs,
        pools printString)
    ifFalse: [^nil].

    "Collect the used associations in a class method..."
    collect := [:methods|
        methods do: [:method|
            method do: [:literal|
                literal isAssociation
                ifTrue: [ inUse add: literal ]
            ]
        ]
    ].

    "Collect all associations in the receiver's classes..."
    inUse := Set new.
    self dependentClasses asArray
    do: [:cls|
        (cls sharedPools
        detect: [:pool| pools includes: pool ]
        ifNone: []) notNil
        ifTrue: [
            collect
                value: cls compiledMethods values;
                value: cls class compiledMethods values
        ]
    ].

    "Remove unused entries..."
    pools do: [:aPoolName|
        poolDict := Smalltalk at: aPoolName ifAbsent: [].
        poolDict isNil
        ifFalse: [
            poolDict keys do: [:aKey|
                (inUse includes: (poolDict associationAt: aKey))
                ifFalse: [ poolDict removeKey: aKey ]
            ]
        ]
    ].!  
details
    "Returns aString with the details
     of each dependent class extracted
     from it's sources.
    Ussefull as
        SolerProject details outputToPrinter
    "
    ^self details:
        (MessageBox confirm: ('Do you want the Private details \ for '
                    ,self name,' ?') withCrs)! 
details: withPrivates
    "Returns aString with the details
     of each dependent class extracted
     from it's sources.
    Ussefull as
        (SolerProject details: false) outputToPrinter
    "
    | stream detail getComment getName process src |
    stream := WriteStream on: (String new: 10000).
    getComment := [:aStream |
        aStream atEnd
        ifFalse: [aStream upTo: $";next;upTo: $".
            aStream atEnd ifFalse: [aStream next]
        ].
        aStream
    ].
    getName := [:src|
        [
            [src peek isSeparator] whileTrue: [src next].
            (src atEnd or: [src peek = $"])]
         whileFalse: [src nextWord].
        src
    ].
    detail := [:source |
        source size = 0
        ifFalse: [
            source copyFrom: 1
                to: (getComment
                        value: (getName value: source asStream)) position
        ] ifTrue: [String new]
    ].

    process := [:aClass|
        stream cr;nextPutAll: aClass name,' details !!'.
        aClass selectors asSortedCollection
        do: [:aSymbol|
            src := (detail value:
                    (aClass compiledMethodAt: aSymbol) sourceString).
            (withPrivates not
             and: [(src indexOfCollection: 'Private -') > 0])
            ifTrue: [src := nil].
            src size = 0
            ifFalse: [stream cr;nextPutAll: src].
        ]
    ].

    self dependentClasses do: [:class|
        stream cr.
        class fileOutOn: stream.
        stream cr.
        process value: class class; value: class.
    ].
    ^stream contents!  
dumpAllChanges
    "Dump all changes to the current image
         since las compressChanges"
    ^self new dumpAllChanges!
dumpChanges
    "Dump all changes to the project since
         las compressChanges"
    ^self new dumpChanges!
dumpOtherChanges
    "Dump all changes to the classes not in receiver's
       project  into a file"
    ^self new dumpOtherChanges!   
fileOutDictionariesInto: aStream
    "Private - Permorms fileOut of all the proyect's pool dictionaries"
    | fileOut dict |
    fileOut := [:aName|
        (dict := Smalltalk at: aName ifAbsent: [])
        isNil ifTrue: [^self error: 'PoolDictionary ',aName,'not found'].
        aStream
            cr;nextChunkPut: 'Smalltalk at: #',aName,' ifAbsent: [
    Smalltalk at: #',aName,' put: Dictionary new ].';
            cr;nextPutAll: ' ',aName.
        dict keys asSortedCollection do: [:each|
            aStream
                cr;next: 4 put: $ ;
                nextPutAll: 'at: ',each printString,
                    ' put: ',(dict at: each) printString,';'
        ].
        aStream nextChunkPut: '    yourself. '.
    ].

    self poolDictionaryNames do: [:aPool| fileOut value: aPool ]!  
fileOutNow
    "FileOut of the receiver in default file
        (fileName is detemined with the proyect name
         using .St extension)"

    | file |
    CursorManager execute change.

    file := Disk newFile:
        (File fileName: self abreviation extension: 'St').

    file  lineDelimiter: Cr.

    self fileOutOn: file.

    file close.

    CursorManager normal change.!   
fileOutOn: aStream
    "Permorms fileOut of all the proyect"
    "Created by Ale Jul  8, 1991"

    | class file path |

     "Do default fileOut"
    (aStream isKindOf: FileStream)
        ifFalse: [^self basicFileOutOn: aStream ].
    ((Sources includes: aStream)    "change.log or sources.sml"
      or: [ self == ProjectClasses])  "fileOut default if self"
    ifTrue: [^self basicFileOutOn: aStream ]. "done..."

    "Perform pools dictionary fileOuts if the receiver wants to"
    self hasPoolDictionaries
    ifTrue: [
        path := aStream pathName upTo: $. .
        file := File newFile: path,'.Pol'.
        self fileOutDictionariesInto: file.
        file close
    ].

    "Do fileOut for dependents proyects"
    self dependentProjects do: [:each| each fileOutNow].


    "FileOut Beggining"

    self preConditions size = 0
    ifFalse: [
        aStream nextChunkPut: self preConditions
    ].

    "Do default fileOut"
    self basicFileOutOn: aStream.
    aStream nextChunkPut: String new.

    "Do dependent classes fileOut"
    self dependentClasses do: [:peach|
        aStream cr.
        peach fileOutOn: aStream.
        aStream nextChunkPut: String new.
    ].
    self dependentClasses do: [:each|
        each class selectors isEmpty
        ifFalse: [
            (ClassReader forClass: each class) fileOutOn: aStream
        ].
         each selectors isEmpty
        ifFalse: [ (ClassReader forClass: each) fileOutOn: aStream ]
    ].

    "Do dependent methods fileOut"
    self dependentMethods associationsDo: [:asoc|
        class := Smalltalk at: asoc key ifAbsent: [asoc key].
        aStream setToEnd;cr;cr;cr;
            nextPut: $!!;
            nextPutAll: ' ',class name , ' methods !!'.
        asoc value do: [:selector|
            aStream cr;nextPutAll:
                (class compiledMethodAt: selector) sourceString;
                nextPut: $!!;cr
        ].
        aStream nextPutAll: ' !!'.
    ].

    self postConditions size = 0
    ifFalse: [
        aStream cr;nextPutAll: self postConditions
    ].

    aStream cr;nextPutAll: '" ',self name,' code..."'! 
hasPoolDictionaries
    "Private  - Returns true if the receiver has provate pool dictionaries.
    Default answer is false.
    This method can be reimplemented in subclasses"
    ^false!  
headers
    "Returns aString with the class headers of the proyect.
        Ussefull as
             SolerProject headers edit
    "
   | stream |
    stream := WriteStream on: (String new: 1000).
    stream
        cr;space;
        nextPutAll: self class name,' headers.';
        cr;cr.
    self dependentClasses
     do: [:class| class fileOutOn: stream. stream cr ].
    ^stream contents!
hierarchy
    "Returns aString with the class hierarchy tree for the proyect.
        Ussefull as
             WBProject hierarchy edit
    "
    | remaining roots print stream margin tabSize |
    remaining := self dependentClasses asArray.
    roots := remaining "reyect childs"
        reject: [:each| remaining includes: each superclass].
    print := [:aClass|
        stream
                next: margin put: $ ; "sangria"
                nextPutAll: aClass name;cr.
        margin := margin + tabSize.
        aClass subclasses do: [:one| print value: one ].
        margin := margin  - tabSize.
    ].
    margin := 3.tabSize := 3.
    stream := WriteStream on: (String new: 1000).
    stream
        cr;space;
        nextPutAll: self class name,' hierarchy tree.';
        cr;cr.
    roots do: [:class| print value: class ].
    ^stream contents!  
initialize
    "Initializes the receiver. When the proyect is filledIn,
     It is automatically initialized.
    Default initialization code do nothing..."
    "
        ProxyServers := ProxyServersCollection new.
    "!   
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    "*WARNING* This method must be refined by subclasses"

    ^#( "Default methods table"
            Object (notImplementedYet notFullyImplemented)

        )!
methodsToRemove
    "Private - Returns the Project methods of individual classes
     to be removed when project is destroyed.
    This method can be refined by subclasses..."

    ^self dependentMethods! 
missingClass: aSymbol
    "Private - A class named aSymbol
     has been missed notify the user.
     Returns nil for no recover"
    | notifier |
    notifier := Smalltalk
        at: #MessageBox
        ifAbsent: [].
    notifier isNil " no St windows..."
     ifTrue: [
        Menu message: '*Warning* class missing : ',aSymbol.
        ^nil
    ].
    (notifier confirm: ('Class missing ', aSymbol,'\Continue ? ...') withCrs)
    ifFalse: [^self error: 'Class missing ',aSymbol].
    ^nil! 
missingProject: aSymbol
    "Private - A proyect named aSymbol
     has been missed notify the user.
     Returns nil for no recover"
    | notifier |
    notifier := Smalltalk
        at: #MessageBox
        ifAbsent: [].
    notifier isNil " no St windows..."
     ifTrue: [
        Menu message: '*Warning* class missing : ',aSymbol.
        ^nil
    ].
    (notifier confirm: ('Project ', aSymbol,' is not found\Continue ? ...') withCrs)
    ifFalse: [^self error: 'Project missing ',aSymbol].
    ^nil!
nonRemovableMethods
    "Private - Returns the Project dependent methods
    that must not been removed."
    | result stream |
    result := Dictionary new.
    stream := ReadStream on: self nonRemovableMethodsCollection.
    [stream atEnd] whileFalse: [
        result at: stream next put: stream next
    ].
    ^result!  
nonRemovableMethodsCollection
    "Private - Returns the Project dependent methods that must not be removed
     for general classes as array of methodsNames subarrays."
    "*WARNING* This method must be refined by subclasses"

    ^#( "Default methods table"
            Object (notImplementedYet notFullyImplemented)
        )! 
poolDictionaryNames
    "Private - Returns the pool dictionary names used by the receiver.
     Used for fileOutDictionariesInto: "
    | pools |
    pools := Set new.
    self dependentClasses asArray
    do: [:each| pools addAll: each sharedPools ].
    ^pools asSortedCollection asArray select: [:pool |
        MessageBox confirm: 'Is ',pool printString,'\ a Pool Dictionary of ' withCrs,self name,' ?' ]! 
postConditions
    "Private  - Returns source needed for postloading this proyect"
    ^''! 
preConditions
    "Private  - Returns source needed for preloading this proyect"
    ^'"
    __________________________________________________
    @Object Style ', Date today printString,'

    This proyect sources are property of : Object Style
    Its use is NOT legal without written rights.

    Object Style.   Soler 4545 - Capital federal - Buenos Aires.  Rep. Argentina
    Tel/Fax : (54) 1 833-3363
    __________________________________________________
    "

    "Initialization of global variables"
',
    (self hasPoolDictionaries ifTrue: ['
    (File pathName: ''',self abreviation,'.Pol'') fileIn;close.
'] ifFalse: [String new])!   
proyectNames
    "Private - Returns the names of dependent proyects."
    "Default answer is empty"
    "*WARNING* This method must be refined by subclasses"
    ^#()!   
saveOtherSources: aCollection
    "Private - Let the user save all the sources in aCollection"
    | file classes dicc sortBlock |
    file := (FileDialog new saveFile: (
        File
            fileName: 'No',self abreviation
            extension: 'St')) file.
    file isNil ifTrue: [^self].
    file := File newFile: file.
    CursorManager execute change.
    classes := Set new.
    aCollection do: [:each| classes add: each classField ].
    classes do: [:class|
        class fileOutOn: file.
        file nextChunkPut: String new.
    ].
    dicc := Dictionary new.
    sortBlock := [:a :b | a selector < b selector ].
    aCollection do: [:each|
        (dicc at: each classField
             ifAbsent: [dicc at: each classField
                 put: (SortedCollection sortBlock: sortBlock)]
        ) add: each
    ].
    dicc keys do: [:each|
      file
        cr; cr; nextPut: $!!;
        nextPutAll: each; space;
        nextPutAll: 'methods !!'.
        (dicc at: each) do: [:method|
            file   cr;
                    nextChunkPut: method sourceString;
                    nextPutAll: ' !!'; cr
        ]
    ].
    file close.
    CursorManager normal change.! !

! ProjectClasses methods !  
changeLogFile
    "Private - Returns the change.log file... "
    ^ File pathNameReadOnly: 'Change.Log'!
dumpAllChanges
    "Dump all changes to the current image..."
    | offset all file |

    file := (FileDialog new
        saveTitle: 'Dump All Changes...'
        fileName: 'AllChg.Log') file.
    file isNil ifTrue: [^self].
    file := File newFile: file.

    offset := self savedImageOffset: 1.
    all := [:each| true]. "always dump.."
    self
        dumpChangesFor: all
        from: offset
        into: file.
    file close.!   
dumpChanges
    "Dump all changes to the receiver into a file"
    | offset who classes file |

    file := (FileDialog new
        saveTitle: 'Dump Changes for ',self class abreviation
        fileName: (File
                fileName: self class abreviation
                extension: 'Log')) file.
    file isNil ifTrue: [^self].
    file := File newFile: file.

    file isNil ifTrue: [^self].
    classes := self class dependentClasses.

    offset := self savedImageOffset: 1.
    who := [:each| classes includes: each].
     "dump changes on dependent classes only..."

    self
        dumpChangesFor: who
        from: offset
        into: file.
    file close.! 
dumpChangesFor: whoBlock from: offset into: file
    "Private - Dump all the source changes occurred since the
     offset in the change.log file to classes matching the whoBlock
     into the file file"
    | dump method selectors stream |
    "build the dump block..."
    dump := [:aClass|
           selectors := aClass selectors
                detect: [:one|
                    (method := aClass compiledMethodAt: one) sourceIndex = 2
                     and: [method sourcePosition > offset]
                    ] ifNone: [].
            selectors isNil ifFalse: [
                aClass isClass
                ifTrue: [
                    stream := WriteStream on: (String new: 200).
                    aClass fileOutOn: stream.
                    file
                        cr; cr;
                        nextPutAll: '"define class"';
                        nextChunkPut: stream contents;
                        flush
                ].
                Smalltalk putHeaderOf: aClass into: file.
                aClass selectors do: [:selector|
                    ((method := aClass compiledMethodAt: selector) sourceIndex = 2
                     and: [method sourcePosition > offset])
                    ifTrue: [ file nextChunkPut: method sourceString ].
                ].
                "place class group termination chunk"
                file nextPutAll: ' !!'.
            ]
    ].
    "Dump all the files..."
    Smalltalk rootClasses
    do: [:each|
        each withAllSubclasses do: [:class|
            (whoBlock value: class)
            ifTrue: [
                dump value: class.
                dump value: class class
            ]
        ]
    ]! 
dumpOtherChanges
    "Dump all changes to the classes not in receiver's
       project  into a file"
    | offset who classes file |

    file := (FileDialog new
        saveTitle: 'Dump Changes for non-',self class abreviation
        fileName: (File
                fileName: 'No',self class abreviation
                extension: 'Log')) file.
    file isNil ifTrue: [^self].
    file := File newFile: file.

    classes := self class dependentClasses.

    offset := self savedImageOffset: 1.
    who := [:each| (classes includes: each) not].
     "dump changes on non dependent classes only..."

    self
        dumpChangesFor: who
        from: offset
        into: file.
    file close.!
initialize
    CatchedOffsets := nil.!   
isOffsetValid: anInteger
    "Private - Check if the offset anInteger in the change.log file
     for the saved image is still valid "
    | file result |
    file := self changeLogFile.
    file size < anInteger ifTrue: [file close.^false].
    file position: anInteger.
    result := self isSavedImage: file.
    file close.
    ^result!  
isSavedImage: file
    "Private - Returns true if the next chunk
     in file is a 'saved image' chunk "
     | chunk |
        chunk := file nextChunk trimBlanks asStream.
     ^chunk nextLine trimBlanks = '"evaluate"'
        and: [chunk nextWord = 'saved'
        and: [chunk nextWord = 'image'
        and: [chunk nextWord = 'on']]]! 
savedImageOffset: count
    "Private - Find the offset in the change.log file
     for the saved image number 'count' "
    | offset file remaining lastPos catchedOffsets |
    (CatchedOffsets notNil
        and: [ CatchedOffsets size >= count
        and: [ self isOffsetValid: CatchedOffsets last ]])
    ifTrue: [^CatchedOffsets at: count].
    Transcript cr;nextPutAll: 'Finding saved image #',count printString,' ...'.
    catchedOffsets := OrderedCollection new.
    offset := 0.
    remaining := count.
    file := self changeLogFile.
    [remaining = 0 | file atEnd] whileFalse: [
        lastPos := file position.
        ((lastPos // 1024) printString,'Kb.') displayAt: 0@10.
        (self isSavedImage: file)
        ifTrue: [ "saved image detected..."
            remaining := remaining - 1.
            catchedOffsets add: (offset := lastPos).
        ]
    ].
    file close.
    CatchedOffsets := catchedOffsets asArray.
    Transcript cr;
        nextPutAll: 'Find saved image #',
            count printString,' at ', offset printString.
    ^offset! !

! BitmapPatchProject class methods !  
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'BmpPatch'!   
classNames
    "Private - Returns the names of Project dependent classes."
    ^#( OSBitmap )!  
methodsCollection
    "Private - Returns the Proyect dependent methods
     for general classes as array of methodsNames subarrays."

    ^(Array with: Bitmap class with: #(allInstancesPrim new purgeUnusedBitmaps)) ,
        #(  " Class (selectors...) " )! 
postConditions
    "Private  - Returns source needed for postloading this proyect"
    ^super postConditions, '
        Transcript cr;nextPutAll: ''Converting current bitmaps. Please wait...''.
        Bitmap allInstances do: [:each| each become: each cpCopy].
        Bitmap purgeUnusedBitmaps.'! !

! CDGuiaProject class methods !   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'CDGuia'! 
classNames
    "Private - Returns the names of Project dependent classes."

    ^self == CDGuiaProject
        ifTrue: [ self fromSubclasses: #classNames ]
        ifFalse: [ super classNames ]!   
fromSubclasses: aSymbol
    "Private - Collect results of sending aSymbol to all sub-classes."
    | cole element |
    cole := OrderedCollection new.
    self allSubclasses do: [:class|
        cole addAll: (class perform: aSymbol)
    ].
    ^cole asArray! 
hasPoolDictionaries
    "Private  - Returns true if the receiver has provate pool dictionaries."
    ^self poolDictionaryNames size > 0!
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."

    ^self == CDGuiaProject
        ifTrue: [ self fromSubclasses: #methodsCollection ]
        ifFalse: [ super methodsCollection ]!  
poolDictionaryNames
    "Private - Returns the pool dictionary names used by the receiver.
     Used for fileOutDictionariesInto: "

    ^self == CDGuiaProject
        ifTrue: [ self fromSubclasses: #poolDictionaryNames ]
        ifFalse: [ super poolDictionaryNames ]!   
preConditions
    "Private  - Returns source needed for preloading this proyect"
    ^super preConditions,'
        (Smalltalk includesKey: #',self name,' ifTrue: [
            (Smalltalk at: #',self name,')
                destroyMethods.
        ].
'! !

! AleGuiaProject class methods !
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'AleGuia'!
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
        CDGuiaApplication CDGuiaModel
        LayerScanner
        MDICDGuia
        ShadedPane PaneWithRulers
        MapViewManager LayerEditor
    )!  
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    GDIDLL (getViewportOrg:)
    UserDLL (
        createWindowEx:uLong:nameULong:style:x:y:width:height:parent:menu:instance:paramULong:
        createWindowEx:struct:nameStruct:style:x:y:width:height:parent:menu:instance:param:
        createWindowEx:className:name:style:x:y:width:height:parent:menu:instance:param:
        )
    )!
poolDictionaryNames
    "Private - Returns the pool dictionary names used by the receiver.
     Used for fileOutDictionariesInto: "
    ^#( HelpStatusPane )! !

! LeoGuiaProject class methods !
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'leoguia'!
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
         Tile TiledImage
    )! !

! ComposeProject class methods ! 
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'compoprj'!   
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
         OSGraphicObject MatchedKeyPoints KeyPoint ComposeImageEditor
    )! !

! TileProject class methods !   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'tileprj'!
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
         OSGraphicObject Tile TiledImage
    )! !

! XavaGuiaProject class methods !
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'XavaGuia'!   
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
     Route MapableArea CellElement Line Information
     MapView LayerView
     Random )!
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Object (notImplementedYet notFullyImplemented)
    Rectangle (intersectsLine:to: intersectsSegment:to:)
    Point (modulus) )! !

! DrawDIBProject class methods !   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"

    ^'DrawDIB'!  
classesWithoutSubclasses
    "Private - Returns the names of Project dependent classes
        That it's subclasses doesn't depends from the proyect."

    ^#(
        "Lo-Level classes"
        MsVideoDLL

        "Hi-Level classes"
        VFWObject

        "Window classes"

        "Test classes..."
    )! 
classNames
    "Private - Returns the names of Project dependent classes."

    ^#(
        "Lo-Level classes"
        DrawDibDLL

        "Hi-Level classes"
        DrawDib DIBImage

        "Window classes"

        "Test classes..."

    )! 
hasPoolDictionaries
    "Private  - Returns true if the receiver has provate pool dictionaries.
    Default answer is false.
    This method can be reimplemented in subclasses"
    ^true!   
poolDictionaryNames
    "Private - Returns the pool dictionary names used by the receiver.
     Used for fileOutDictionariesInto: "

    ^#( DrawDibConstants  )! !

! DynalinkProject class methods !  
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'Dynalink'!   
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
     Dynalink )! !

! HaloProject class methods !
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'Halo'

    "Modified: 10/27/93 / 10:19:06 AM / XAVA"!  
buildDictionary: aDictionary from: aString
    "Parses aString that has a C++ .H like header format, and converts
    the enums and #defines into entries of aDictionary"

    | getKey getValue getHexNumber getDecimalNumber getDefine
    skipComment skipCommentSmalltalk skipCommentAssembler skipCommentCPlusPlus skipSeparator
    error dictionaryAdd
    stream key value char |

    getKey := [ key := char asUpperCase asString asStream.
                    key setToEnd.
                    [ (char := stream next) isSeparator or: [ char = $, or: [ char = $= ] ] ] whileFalse:
                        [ char isLetter
                            ifTrue: [ key nextPut: char asLowerCase ]
                            ifFalse: [ char = $_
                                            ifTrue: [ key nextPut: stream next asUpperCase ]
                                            ifFalse: [ stream peek isLetter
                                                            ifTrue: [ key
                                                                            nextPut: char;
                                                                            nextPut: stream next asUpperCase ]
                                                            ifFalse: [ key nextPut: char ] ] ] ].
                    key := key contents ].
    getValue := [ char isSeparator
                            ifTrue: [ skipSeparator value ].
                        char = $=
                            ifTrue: [ char := stream next.
                                        char isSeparator
                                            ifTrue: [ skipSeparator value ].
                                            char = $-
                                                ifTrue: [ char := stream next.
                                                            char isDigit
                                                                ifTrue: [ stream peek = $x
                                                                                ifTrue: [ getHexNumber value ]
                                                                                ifFalse: [ getDecimalNumber value ] ]
                                                                ifFalse: [ error value: char ].
                                                            value := 0 - value ]
                                                ifFalse: [ char isDigit
                                                                ifTrue: [ stream peek = $x
                                                                                ifTrue: [ getHexNumber value ]
                                                                                ifFalse: [ getDecimalNumber value ] ]
                                                                ifFalse: [ error value: char ] ] ].
                        dictionaryAdd value.
                        stream atEnd
                            ifFalse: [ char isSeparator
                                                ifTrue: [ skipSeparator value ].
                                            char = $,
                                            ifTrue: [ char := stream next.
                                                        value := value + 1 ]
                                            ifFalse: [ char isLetter
                                                                ifTrue: [ value := 0 ] ] ] ].
    getHexNumber := [ stream next.
                                    value := 0.
                                    [ stream atEnd or: [ (char := stream next) isSeparator or: [ char = $, ] ] ] whileFalse:
                                        [ value := value * 16 + ( char digitValue ) ] ].
    getDecimalNumber := [ value := char asString asStream.
                                        value setToEnd.
                                        [ stream atEnd not and: [ (char := stream next) isDigit ] ] whileTrue:
                                            [ value nextPut: char ].
                                        value := value contents asInteger ].
    getDefine := [ (char := stream nextWord asLowerCase) = 'define'
                            ifTrue: [ char := stream next.
                                        char isSeparator
                                            ifTrue: [ skipSeparator value ].
                                        getKey value.
                                        char := $=.
                                        getValue value. ]
                            ifFalse: [ error value: char ] ].
    skipComment := [ char = $;
                                    ifTrue: [ skipCommentAssembler value ]
                                    ifFalse: [ char = $"
                                                    ifTrue: [ skipCommentSmalltalk value ]
                                                    ifFalse: [ char = $/
                                                                    ifTrue: [ stream peek = $*
                                                                                    ifTrue: [ skipCommentCPlusPlus value ]
                                                                                    ifFalse: [ error value: stream peek ] ] ] ] ].
    skipCommentSmalltalk := [ char := stream next.
                                                [ char = $" ] whileFalse: [ char := stream next ].
                                                stream atEnd
                                                    ifFalse: [ char := stream next ] ].
    skipCommentAssembler := [ stream nextLine.
                                                stream atEnd
                                                    ifFalse: [ char := stream next ] ].
    skipCommentCPlusPlus := [ stream next.  "Skipping char:*"
                                                    char := stream next.
                                                    [ char = $* and: [ stream peek = $/ ] ] whileFalse: [ char := stream next ].
                                                    stream peek = $/
                                                        ifTrue: [ stream next.
                                                                    stream atEnd
                                                                        ifFalse: [ char := stream next ] ]
                                                        ifFalse: [ error value: stream peek ] ].
    skipSeparator := [ [ stream atEnd not and: [ skipComment value. char isSeparator ] ] whileTrue: [ char := stream next ] ].
    error := [ :errorChar | self error: 'Invalid Character: ', errorChar printString ].
    dictionaryAdd := [ key size < 3
                                    ifTrue: [ error value: key ]
                                    ifFalse: [ aDictionary at: key put: value ] ].

    stream := aString asStream.
    key := String new.
    value := -1.
    char := stream next.
    [ stream atEnd ] whileFalse:
        [ skipSeparator value.
            char = $#
                ifTrue: [  getDefine value ]
                ifFalse: [ getKey value.
                            skipSeparator value.
                            getValue value ] ].

    ^aDictionary! 
buildPoolDictionaries
    "Private - Build all the proyect's pool dictionaries

        (Smalltalk at: #HaloConstants) keys do: [:each|
            (Smalltalk at: #HaloConstants) removeKey: each ].
        HaloProject buildPoolDictionaries
    "
 | dict |


    dict := Smalltalk at: #HaloConstants
        ifAbsent: [ Smalltalk at: #HaloConstants put: Dictionary new ].

    self buildDictionary: dict from: self headerString.
    "Modified: 11/02/93 / 02:57:49 PM / XAVA"!  
classesWithoutSubclasses
    "Private - Returns the names of Project dependent classes
        That it's subclasses doesn't depends from the proyect."
    ^#( ProgressDialog )!   
classNames
    "Private - Returns the names of Project dependent classes."
    ^#(
        "High level interfase"
          HaloObject HaloImage
        "Low level interfase"
          HaloImagingDLL HilBCGM
        "Dialogs interfase"
          HaloEffectDialog HistogramDialog
          ProgressDialog HaloProcessDialog
        )!
hasPoolDictionaries
    "Private  - Returns true if the receiver has provate pool dictionaries.
    Default answer is false.
    This method can be reimplemented in subclasses"
    ^true!   
headerString
    "Private -- Answers the string that groups all the defines
    & enums in the original .H file."

    ^'/*----------------------------------------------------------------------------
| Module    : hil.h
|
| Purpose   : include file for HALO Imaging Library
|
| Version   : 1.1
|
| History   : 06/19/92    DDS
|           7/03/93    DDS Version 1.1
|
| Copyright 1990-1993 Media Cybernetics, Inc.
|-----------------------------------------------------------------------------*/


    TR_OPEN = 0,
    TR_CLOSE,
    TR_SET_RANGE,
    TR_TEXT,
    TR_UPDATE,
    TR_NEXT,
    TR_PROC


    IMC_BILEVEL=0,
    IMC_GRAY,
    IMC_PALETTE,
    IMC_RGB,
    IMC_GRAY12,
    IMC_FLOAT,

    IMC_DUMMY_MAX = 0x7FFF

     /* access modes */
    IMA_RDNOCACHE = 0,      /* read only with disabled cache */
    IMA_RD,                 /* read only (don''t flush dirty blocks) */
    IMA_RDWR                /* normal read/write access */

ETERROR = 0,

    IMCMD_GETCLASS,
    IMCMD_GETBPP,

    /* file related commands */
    IMCMD_GETARTIST,
    IMCMD_SETARTIST,
    IMCMD_GETDATE,
    IMCMD_SETDATE,
    IMCMD_GETDESC,
    IMCMD_SETDESC,
    IMCMD_GETDPM,
    IMCMD_SETDPM,
    IMCMD_GETFILEFORMAT,
    IMCMD_SETFILEFORMAT,
    IMCMD_GETNAME,
    IMCMD_SETNAME,
    IMCMD_GETTITLE,
    IMCMD_SETTITLE,

    /* size commands */
    IMCMD_GETSIZE,
    IMCMD_GETEXTENT,
    IMCMD_GETBYTEWIDTH,
    IMCMD_I_GETSIZE,
    IMCMD_I_GETEXTENT,
    IMCMD_I_GETBYTEWIDTH,

    /* dirty flag */
    IMCMD_GETMODIFIED,
    IMCMD_SETMODIFIED,
    IMCMD_I_GETMODIFIED,
    IMCMD_I_SETMODIFIED,

    /* response lookup table commands */
    IMCMD_GETPALETTE,
    IMCMD_SETPALETTE,
    IMCMD_GETLUTCOUNT,
    IMCMD_GETLUTADDR,
    IMCMD_LUTRESET,
    IMCMD_REALIZELUTS,
    IMCMD_GETRESPONSE,

    /* histogram commands */
    IMCMD_GETHISTSTATUS,
    IMCMD_SETHISTSTATUS,
    IMCMD_GETHISTCHANNEL,
    IMCMD_SETHISTCHANNEL,
    IMCMD_I_GETHIST,

    /* other */
    IMCMD_I_GETACCESS,
    IMCMD_I_SETACCESS,

    IMCMD_SETFLOATRANGE,
    IMCMD_GETFLOATRANGE,

    IMCMD_SETRESPONSE,
    IMCMD_GETBYTEHEIGHT,
    IMCMD_I_GETBYTEHEIGHT,

    IMCMD_DUMMY_MAX = 0x7FFF
#define IMCMD_M_SIZE 0x8000


    IMGL_COPY = 0,              /* simple copy memory */
    IMGL_NORMAL                 /* normalize */


    IMPL_COPY = 0,              /* simple copy memory */
    IMPL_NORMAL                 /* copy from normalized image data */

         /* error codes */
    IME_NONE = 0,        /* No error */

    IME_CANCELLED = -1000,      /* The user cancelled the operation */
    IME_NO_MEMORY,              /* Insufficient memory to complete request */
    IME_MEM_ACCESS,             /* Error accessing memory (cannot lock) */

    IME_CACHE_REALLOC,          /* Cannot realloc cache when opening an inst */

    IME_CLOSE,                  /* Error closing an instance */

    IME_INV_SIZE,               /* Requested size exceeeds maximum */
    IME_INV_LINE_NO,            /* Invalid line number (out of bound) */
    IME_INV_EXTENT,             /* Problem with extents */

    IME_DISK_OPEN,              /* Error opening disk buffer */
    IME_DISK_READ,              /* Error reading disk buffer */
    IME_DISK_WRITE,             /* Error writing disk buffer */

    IME_INV_HANDLE,             /* Invalid handle */
    IME_HANDLE_LIMIT,           /* Exceeded max number of handle */

    IME_INV_CLASS,              /* Invalid class for the operation requested */
    IME_INV_CMD,                /* Invalid IMCMD */
    IME_INV_PARAM,              /* Invalid parameter in the passing arguments */

    IME_NOT_SUPPORTED,          /* Not supported */
    IME_CLIPPED,                /* AOI object clipped */
    IME_EMPTY,                  /* AOI object empty */
    IME_INV_TYPE,        /* Incompatible AOI object type */

    IME_HIFFL = -500        /* IMERROR - IME_HIFFL = IFFERROR */


    DTR_ANGLEDOT = 0,
    DTR_FLATDOT,
    DTR_ANGLELINE,
    DTR_HORZLINE,
    DTR_VERTLINE,
    DTR_ERRDIFF,
    DTR_THRESHOLD


    EQ_BESTFIT = 0,
    EQ_LINEAR,
    EQ_BELL,
    EQ_LOGARITHMIC,
    EQ_EXPONENTIAL


    FLT_EDGE_THIN = 6,
    FLT_EDGE_THICK,
    FLT_EDGE_HORZ,
    FLT_EDGE_VERT,
    FLT_SCULPT_ABOVE,
    FLT_SCULPT_LEFT,
    FLT_SCULPT_DIAG,
    FLT_SCULPT_METAL,
    FLT_EMBOSS_ABOVE,
    FLT_EMBOSS_LEFT,
    FLT_EMBOSS_DIAG,
    FLT_LINE_HORZ,
    FLT_LINE_VERT,
    FLT_LINE_BOTH


    IMM_COPY,
    IMM_AND,
    IMM_OR,
    IMM_NAND,
    IMM_NOR


    OR_LEFTRIGHT = 1,
    OR_UPDOWN,
    OR_TRANSPOSE,
    OR_ROTATE90,
    OR_ROTATE270,
    OR_ROTATE180


    RA_TOPLEFT = 1,
    RA_TOP,
    RA_TOPRIGHT,
    RA_LEFT,
    RA_CENTER,
    RA_RIGHT,
    RA_BOTTOMLEFT,
    RA_BOTTOM,
    RA_BOTTOMRIGHT

/*----------------------------------------------------------------------------
| Module    : hiffl.h
|
| Purpose   : include file for HALO Image File Format Library
|
| History   : 04/01/93  DDS
|
| Copyright 1990-1993 Media Cybernetics, Inc.
|-----------------------------------------------------------------------------*/


    IFFM_READ       = 0,
    IFFM_WRITE,
    IFFM_APPEND,
    IFFM_MEMORY = 0x80


    IFFCL_BILEVEL = 0,      /* 1 BPP */
    IFFCL_GRAY,             /* 2,4,6,8 BPP */
    IFFCL_PALETTE,          /* 2,4,6,8 BPP */
    IFFCL_RGB,              /* 24 BPP chunky */
    IFFCL_RGBPLANAR,        /* 24 BPP in 8 bit planes */
    IFFCL_RGBA,         /* 32 BPP chunky */
    IFFCL_RGBAPLANAR        /* 32 BPP in four 8 bit planes*/


    IFFCMD_GETERROR = 0,    /* get error code */
    IFFCMD_GETLINESIZE,     /* compute line size */
    IFFCMD_PALETTE,         /* get or set palette or map */
    IFFCMD_SETPACKMODE,     /* set mode for packing/unpacking pixels  */
    IFFCMD_DESCRIPTION,     /* get or set image description field   */
    IFFCMD_SOFTWARENAME,    /* get or set software name (TIFF, TGA) */
    IFFCMD_ARTISTNAME,      /* get or set artist name (TIFF, TGA)   */
    IFFCMD_RESOLUTION,      /* get dots per meter */
    IFFCMD_DOCUMENTNAME,    /* get of set the document name field */
    IFFCMD_DATETIME,        /* get or set the date/time field */
    IFFCMD_GETNUMIMAGES,    /* get the number of images */
    IFFCMD_IMAGESEEK,       /* seek to the next image */

    IFFCMD_TIFF = 0x4000,   /* TIFF specific commands */
    IFFCMD_TIFFTAG,
    IFFCMD_TIFFTAGDATA,
    IFFCMD_FAXSCALE,
    IFFCMD_PCX  = 0x4200,   /* PCX specific commands */
    IFFCMD_BMP  = 0x4400,   /* BMP specific commands */
    IFFCMD_BMP_VERSION,     /* Windows, os2 1.2, os2 2.0 versions */
    IFFCMD_HCUT = 0x4600,   /* HALO CUT specific commands */
    IFFCMD_TGA  = 0x4800,   /* TGA specific commands */
    IFFCMD_IMG  = 0x4A00,   /* IMG specific commands */
    IFFCMD_MSP  = 0x4C00,   /* MSP specific commands */
    IFFCMD_GIF  = 0x4E00,   /* GIF specific commands */
    IFFCMD_EPSF = 0x5000,   /* EPSF specific commands */
    IFFCMD_HFF  = 0x5200,   /* HFF specific commands */
    IFFCMD_FLAT = 0x5400,   /* FLAT specific commands */
    IFFCMD_FLAT_SETOFFSET,  /* set image offset for flat file*/
    IFFCMD_FLAT_PALETTE,    /* set filename for flat palette*/
    IFFCMD_FLAT_TRUNC,      /* Truncate > 8 bpp */
    IFFCMD_WPG  = 0x5600,   /* WPG specific commands */
    IFFCMD_JPEG = 0x5700,   /* WPG specific commands */
    IFFCMD_JPEGQ,           /* Quality */
    IFFCMD_PCD = 0x5800,    /* Kodak PCD specific commands */
    IFFCMD_PCDGETTRANSFORM,
    IFFCMD_PCDSETTRANSFORM,
    IFFCMD_PCDSETCLASS,

    IFFCMD_DUMMY_MAX = 0x7FFF

#define IFFCMD_GETDATASIZE  0x8000    /* OR with this to get the size */


    IFFPM_PACKED = 0,
    IFFPM_UNPACKED,
    IFFPM_LEFTJUSTIFIED,
    IFFPM_NORMALIZED


    IFFSEQ_TOPDOWN = 0,     /* most */
    IFFSEQ_BOTTOMUP,        /* BMP and TGA compressed */
    IFFSEQ_INTERLACED        /* for GIF */


    IFFERR_NONE = 0,        /* no error     */
    IFFERR_HANDLELIMIT,     /* too many open files */
    IFFERR_PARAMETER,       /* programmer error */
    IFFERR_NOTSUPPORTED,    /* feature not supported by format */
    IFFERR_NOTAVAILABLE,    /* item not available */
    IFFERR_MEMORY,          /* insufficient memory */
    IFFERR_IMAGE,           /* bad image data (decompression error) */
    IFFERR_HEADER,          /* header has bad fields */
    IFFERR_IO_OPEN,         /* error on open() */
    IFFERR_IO_CLOSE,        /* error on close() */
    IFFERR_IO_READ,         /* error on read() */
    IFFERR_IO_WRITE,        /* error on write() */
    IFFERR_IO_SEEK          /* error on lseek() */


    IFFCOMP_NONE    = 0,    /* no compression */
    IFFCOMP_DEFAULT,        /* whatever is defined for the format */
    IFFCOMP_RLE,            /* various RLE schemes (PACKBITS in TIFF) */
    IFFCOMP_CCITT1D,        /* TIFF modified G3 */
    IFFCOMP_CCITTG3,        /* TIFF raw G3  */
    IFFCOMP_CCITTG4,        /* TIFF G4      */
    IFFCOMP_LZW,            /* Lempel-Zif   */
    IFFCOMP_LZWHPRED,        /* LZW with TIFF horizontal differencing */
    IFFCOMP_JPEG        /* JPEG compression */


    IFFIT_PRIMARY = 0,
    IFFIT_THUMBNAIL,
    IFFIT_MASK


    IFFBV_WIN_3  = 0x10,            /* Windows 3.0 */
    IFFBV_OS2_1  = 0x20,            /* OS2 1.2 */
    IFFBV_OS2_2S = 0x40,            /* OS2 2.0 single image */
    IFFBV_OS2_2M = 0x41             /* OS2 2.0 multiple image */

/*----------------------------------------------------------------------------
| Module    : hildefs.h
|
| Purpose   : platform dependent include file for HALO Imaging Library for
|             Microsoft Windows 3.1 (Microsoft C 7.0 or Borland C++ 3.1)
|
| History   : 06/19/92  DDS
|
| Copyright 1990-1992 Media Cybernetics, Inc.
|-----------------------------------------------------------------------------*/

/*----------------------------------------------------------------------------
| EXTRAS .
|   Agregado por: Xavier on 27-X-93
|   Razon: #define''s fuera de los enum...
|-----------------------------------------------------------------------------*/

#define MAX_IMAGE_WIDTH     8192
#define IMC_M_SHARED  0x8000    /* OR mask to create shareable image */
#define IMC_M_DA      0x4000    /* OR mask to create direct access image */
#define IMCMD_M_SIZE 0x8000
#define IFF_MAXHANDLES    4        /* max number of open files */

;End of the string.     27-X-93'
    "Modified: 10/27/93 / 01:03:22 PM / XAVA"!  
poolDictionaryNames
    "Private - Returns the pool dictionary names used by the receiver.
     Used for fileOutDictionariesInto: "
    ^#(HaloConstants)! 
postConditions
    "Private  - Returns source needed for postloading this proyect"
    ^super postConditions,'
    HaloImagingDLL initializeStructures.
    '! !

! LoaderProject class methods !   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'Loader'! 
classNames
    "Private - Returns the names of Proyect dependent classes."
    ^#(
            "add the dependent classes here please..."
            Loader ForwardReference
        )! 
methodsCollection
    "Private - Returns the Proyect dependent methods
     for general classes as array of methodsNames subarrays."

    ^super methodsCollection ,
        #( "Default methods table"
            Object (loadBy: rehash unloadBy: )
            String  (loadBy: unloadBy: )
            SortedCollection (unloadBy:)
            Bitmap (rehash unloadBy: )
            StoredPicture (rehash unloadBy: )
            Set (rehash  )
            Stream (copyFrom:to:into:)
        )! !

! MDIProject class methods ! 
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'MDIProject'! 
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
     StatusPane ToolPane MDIMenu MDIFrame
     MDITranscript Tool MDIClient MDIViewManager
     MDIChild StatusBox WinStructure )!   
hasPoolDictionaries
    "Private  - Returns true if the receiver has provate pool dictionaries.
    Default answer is false.
    This method can be reimplemented in subclasses"
    ^true

    "Smalltalk at: #HelpStatusPane"
    "Smalltalk at: #HelpClassHierarchyBrowser"
    "Smalltalk at: #HelpMDISystem"!
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Window (statusPane toolPane)
    UserDLL (translateMDISysAccel:msg: defMDIChildProc:msg:wparam:lparam: defFrameProc:mdiClient:msg:wparam:lparam:)
    ViewManager (statusPane statusText: toolPane topPaneClass frame frame: disableSystemMenuItemClose)
    MenuWindow (addMDIMenu: destroyMDIMenu:)
    ),(Array with: NotificationManager class),#( (transcriptClass)
    ApplicationWindow (statusPane statusText statusText: toolPane disableSysMenu: modifySysMenu:position:)
    TextTool (displayText:at:clipRect:options:)
    WindowHandle (defMDIChildProc:)
    NotificationManager (translateMDISysAccel: mdiInitialize translateAccelerator: closeAllWindows)
    ),(Array with: WinInfo class),#( (colorButtonFace colorButtonHighlight colorButtonShadow colorButtonText cxBorder cxIcon cyBorder cyCaption cyIcon isWindows30 windowsMajorVersion windowsMinorVersion)
    ClassHierarchyBrowser (statusPaneHelp:)
    Object (notImplementedYet notFullyImplemented isStatusPane isToolPane statusPaneHelp:)
    DialogTopPane (statusPane toolPane)
    SubPane (show visible visible:)
    KernelDLL (getVersion)
    DialogBox (statusPane toolPane)
    ),(Array with: WinClientCreateStruct class),#( (sizeInBytes) )!
postConditions
    "Private  - Returns source needed for postloading this proyect"
    ^super postConditions,
'
    Notifier mdiInitialize.
    Smalltalk
        notifyAtStartUp: MDIFrame;
        notifyAtStartUp: MDIChild.
    MDIFrame startUp.
    MDIChild startUp.
    Notifier reinitialize.
'! !

! MultiLanguageProject class methods !  
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'XLang'!  
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#( StringStripper ProxyObjectFromResource )! !

! NLSProject class methods ! 
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'NLS/DBCS'!   
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
     DoubleByteString MixedFileStream NationalLanguageSupport DoubleByteStringInspector )! 
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Window (wmWinIniChange:with:)
    String (, <= = asNormalizedString asNormalizedString: asTime at:put: equals: equalsIgnoreCase: replace:with: replaceBytesFrom:to:with:startingAt: replaceFrom:to:with:startingAt: replaceFrom:to:withObject:)
    Symbol (asCompactString asMixedString asNormalizedString asNormalizedString: equals: initContents: replace:with: replaceBytesFrom:to:with:startingAt: replaceFrom:to:with:startingAt: replaceFrom:to:withObject:)
    ),(Array with: Symbol class),#( (intern: purgeUnusedSymbols)
    DDEAuxServer (wmDdeExecute:with: wmDdePoke:with:)
    WinHandle (replaceBytesFrom:to:with:startingAt: replaceFrom:to:with:startingAt:)
    ),(Array with: File class),#( (fileName:extension:)
    Object (notImplementedYet notFullyImplemented)
    Character (< <= = > >= asLowerCase asUpperCase isDigit isDoubleByte isLeadByte isLeadByte: isLetter isLowerCase isSeparator isSingleByte isUpperCase isWhitespace leadByte printOn: trailByte)
    ),(Array with: Character class),#( (leadByte:trailByte: value:)
    DynamicDataExchange (dataTo:ackReq:release:requested:format:data:item: pokeTo:release:format:data:item:)
    TopPane (winIniChange: wmWinIniChange:with:)
    ),(Array with: FileStream class),#( (on:)
    FileStream (asMixedFileStream asMixedFileStream: backupOver: getBytesFor:from:to: putBytesFrom:from:to: sizeOf:)
    ),(Array with: Directory class),#( (extractDateTimeFrom:)
    KernelDLL (isDBCSLeadByte:)
    UserDLL (ansiLower: ansiLowerBuff:length: ansiUpper: ansiUpperBuff:length: isCharAlpha: isCharAlphaNumeric: isCharLower: isCharUpper: isTwoByteCharPrefix: lStrCmp:withString: lStrCmpi:withString:)
    SystemDictionary (imageName save)
    ByteArray (replaceBytes:with: replaceBytesFrom:to:with:startingAt: replaceFrom:to:withAddress:startingAt:)
    Number (printFraction:)
    ),(Array with: Time class),#( (fromString:)
    Date (formPrint printLongOn: printOn: printOn:withPicture: printShortOn:)
    VWVMDLL (containsDoubleByteCharacter: doubleByteString:toMixedString: doubleByteStringSizeFrom:leadBytes: loadCollateTable: mixedString:containsLeadByte: mixedString:toDoubleByteString:leadBytes: mixedStringSizeFrom:)
    Time (printOn:)
    ),(Array with: Date class),#( (calendarForMonth:year: dayNames dayOfWeek: fromString: indexOfMonth: initialize monthNameFromString: monthNames nameOfDay: nameOfMonth: replaceDayNames: replaceMonthNames: shortNameOfDay: shortNameOfMonth:)
    FileDialog (fileSpec:)
    DDEAuxClient (wmDdeAck:with: wmDdeData:with:)
    ),(Array with: Float class),#( (fromString:)
    Float (printOn: replaceBytesFrom:to:with:startingAt:) )! !

! ObjectFilerProject class methods !  
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'ObjectFiler'!
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
     LargeIdentityDictionary ObjectFiler ObjectLoadDialog )!   
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    WinHandle (fileOutSurrogate:)
    File (fileInActivate: fileOutSurrogate:)
    Object (notImplementedYet notFullyImplemented fileInActivate: fileOutSurrogate:)
    Bitmap (fileInActivate: fileOutSurrogate:)
    WinLogicalObject (fileOutSurrogate:)
    Font (fileOutSurrogate:) )! 
postConditions
    "Private  - Returns source needed for postloading this proyect"
    ^super postConditions,
'
    (Smalltalk at: #ObjectLoadDialog) initialize.
    (Smalltalk at: #ObjectFiler) initialize.
'! !

! PictureProject class methods ! 
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'P3'! 
buildPoolDictionaries
    "Private - Build all the proyect's pool dictionaries

        (Smalltalk at: #P3Constants) keys do: [:each|
            (Smalltalk at: #P3Constants) removeKey: each ].
        PictureProject buildPoolDictionaries
    "
    | pool define stream count relative |

    define := [:array :dict |
        stream := ReadStream on: array.
        count := 1.
        [stream atEnd] whileFalse: [
            stream peek isNumber
            ifTrue: [count := stream next]
            ifFalse: [
                dict
                    at: stream next asString
                    put: count.
                count := count + 1
            ]
        ]
    ].
    relative := [:destination :params|
        dict at: destination asString
            put: (dict at: params first asString) * 256
                + (dict at: params last asString ifAbsent: [params last])
    ].

    dict := Smalltalk at: #P3Constants
        ifAbsent: [Smalltalk at: #P3Constants put: Dictionary new].

    "File Formats & Types supported"
    define
        value: #(
            1 FfTga FfTiff FfPcx FfGif FfBmp FfVi FfAll FfDcx
            10 FfJpg
        )
        value: dict;
        value: #(
            1 FitGray16 FitGray256
            11 FitCmap256 FitCmap16
            31 FitMono
            21 FitRgb16 FitRgb24 )
        value: dict;
        yourself.

    "File format constants for WriteImageFile..."
    relative
        value: #FfmtTiffMono value: #(FfTiff FitMono);
        value: #FfmtTiff16G value: #(FfTiff FitGray16);
        value: #FfmtTiff256G value: #(FfTiff FitGray256);
        value: #FfmtTiff256C value: #(FfTiff FitCmap256);
        value: #FfmtTiffRgb24 value: #(FfTiff FitRgb24);

        value: #FfmtPcxMono value: #(FfPcx FitMono);
        value: #FfmtPcx16C value: #(FfPcx FitCmap16);
        value: #FfmtPcx256C value: #(FfPcx FitCmap256);

        value: #FfmtBmpMono value: #(FfBmp FitMono);
        value: #FfmtBmp16C value: #(FfBmp FitCmap16);
        value: #FfmtBmp256C value: #(FfBmp FitCmap256);
        value: #FfmtBmpRgb24 value: #(FfBmp FitRgb24);

        value: #FfmtTga256G value: #(FfTga FitGray256);
        value: #FfmtTga256C value: #(FfTga FitCmap256);
        value: #FfmtTgaRgb16 value: #(FfTga FitRgb16);
        value: #FfmtTgaRgb24 value: #(FfTga FitRgb24);

        value: #FfmtGif256C value: #(FfGif FitCmap256);

        value: #FfmtJpg value: #(FfJpg 0);
        value: #FfmtJpg value: #(FfJpg FitGray256);
        value: #FfmtJpg value: #(FfJpg FitRgb24);

        value: #FfmtDcx value: #(FfDcx 0);
        yourself.

    " JPEG Options "
    define
        value: #( JpgSubs111 JpgSubs211 JpgSubs411)
        value: dict;
        value: #(
            21 JpgDecompressToColor JpgDecompressToGray
            41 JpgDecompressToRgb24Bit JpgDecompressToCmap8Bit JpgDecompressToGray8Bit
            43 JpgDecompressToDisplayFmt
            61 JpgColorCompression JpgGrayScaleCompression
        )
        value: dict;
        yourself.

    "Palette options & Sharing modes"
    define
        value: #(
            0 PalNone PalDefault PalCustom16C
                PalFastCustom256C PalQualCustom256C
                PalNative
            4 PalCustom256C
            1 PsNoShare PsShareCurrent PsShareDefault
        )
        value: dict;
        yourself.

    "Dithering Methods"
    define
        value: #(
            1 RmWindows RmMatch RmFsDither
                RmOdDither RmNoDither
        )
        value: dict;
        yourself.

    "Error Codes"
    define
        value: #(
            1 P3ErrFileOpen P3ErrFileOperation
                P3ErrUnsupportedFileFormat
                P3ErrFileFormatProcessing
                P3ErrFileCreate
                P3ErrInvalidImageHandle
            10 P3ErrInsuficientMemory
        )
        value: dict;
        yourself.!   
classNames
    "Private - Returns the names of Project dependent classes."
    ^ #( P3Image PictureDLL  )!  
hasPoolDictionaries
    "Private  - Returns true if the receiver has provate pool dictionaries.
    Default answer is false.
    This method can be reimplemented in subclasses"
    ^true!   
poolDictionaryNames
    "Private - Returns the pool dictionary names used by the receiver.
     Used for fileOutDictionariesInto: "
    | pools |
    pools := Set new.
    self dependentClasses asArray
    do: [:each| pools addAll: each sharedPools ].
    ^pools asSortedCollection asArray select: [:pool |
        (pool copyFrom: 1 to: 2) = 'P3' ]! !

! PictureSchemeProject class methods ! 
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'Picture'!
dependentClasses
    "Private - Returns the Project dependent classes."
    ^ #( PictureObject  PictureBitmap)
        collect: [:each| Smalltalk at: each ]! !

! ProjectManagement class methods ! 
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'Projects'!   
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
     ProjectView DragAndDropServer DrageableListPane StReader
     MultipleSelectDrageableListBox )!  
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Object (notImplementedYet notFullyImplemented asString)
    ),(Array with: CursorManager class),#( (loadCursor:fromDLL:)
    SystemDictionary (methodsInLOG methodsInDLL methodsInSML fileOut:into: methodsWithSourceIndex: methodsWithSourceEmbebed methodsWithoutSources) )! 
nonRemovableMethodsCollection
    "Private - Returns the Project dependent methods that must not be removed
     for general classes as array of methodsNames subarrays."
    "*WARNING* This method must be refined by subclasses"

    ^#( "Default methods table"
    Object (notImplementedYet notFullyImplemented)
    SystemDictionary (methodsInLOG methodsInDLL methodsInSML fileOut:into: methodsWithSourceIndex: methodsWithSourceEmbebed methodsWithoutSources)
    )! !

! RDBMSProject class methods ! 
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'RDBMS'!  
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#( DatabaseMapper RDBMS QELibDLL )! !

! RunProgramProject class methods !   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"

    ^'RunPrg'!   
classNames
    "Private - Returns the names of Project dependent classes."
    ^#( ProgramManager RunProgramDialog )!   
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."

    ^#(
        ApplicationWindow (runProgram)
    )! !

! SDSSProject class methods !  
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'SDsS'!   
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#( SelfDefinedSubStructure )!  
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."

    ^#( "methods table" SelfDefinedStructure ( privateAt: privateAt:put: ))
        ,(Array with: SelfDefinedStructure with: #(define:withFields: definitions isDefined: sizeInBytesFor: ))
        ,(Array with: Dynalink16 with: #(register:as:))! !

! SourceForBlocksProject class methods !
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'BlkSrc'! 
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."

    ^#( "methods table"
            Context ( printOn: sourceString
                method scanCollectionIC:for:
                scanGeneric:for:in: searchForEOB:
                scanIC:for: startPC )
            HomeContext (method)
        )! !

! SubPanesProject class methods !   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'SubPanes'!   
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
     CPEntryField SpinField CPCLBField CPHierarchicalListBox
     CPTreeNode CPSubPane )! 
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Object (notImplementedYet notFullyImplemented)
    UserDLL (getScrollRange:bar:lpMinPos:lpMaxPos: getWindow:relationship:)
    ),(Array with: Time class),#( (hours:minutes:seconds:)
    Window (cpBackColor wmGettext:with: wmKeyup:with: wmNchittest:with: wmUser99:with:) )!  
postConditions
    "Private  - Returns source needed for postloading this proyect"
    ^super postConditions,
'
    "Load bitmaps"
    CPBitmapDict addBitmaps: ''bitmaps.bdt''.
    CPBitmapDict addSystemBitmaps: ''system.bdt''.

    WinEvents at: 132 put: #wmNchittest:with:.
    WinEvents at: 257 put: #wmKeyup:with:.
    WinEvents at: 13  put: #wmGettext:with:.
    WinEvents at: 1123 put: #wmUser99:with:.
'!   
preConditions
    "Private  - Returns source needed for preloading this proyect"
    ^super preConditions,
'
    Smalltalk at: #WBConstants put: WinConstants.
    Smalltalk at: #SubpanesVersion put: ''Subpanes/V Windows 1.10''.
    ColorConstants at: ''ClrChiseledgray'' put: -1.

(Smalltalk includesKey: #PWindowBuilder) ifTrue: [
    PWindowBuilder
        addInSubPanes: nil;
        clearWBClasses;
        initProperties;
        reset ]
'! !

! VcOthers class methods !   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'VcOthers'!   
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
     ChunkTopPane CategoryPattern CategorySet ChunkBrowser
     ChunkPattern ChunkReadStream CategorySelectDialog ChunkDialog
     CategoryBrowser ChunkStructure ChunkTextPane CategoryManager )!   
hasPoolDictionaries
    "Private  - Returns true if the receiver has provate pool dictionaries.
    Default answer is false.
    This method can be reimplemented in subclasses"
    ^true!   
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Object (notImplementedYet notFullyImplemented)
    ApplicationWindow (openCategoryBrowser openChunkBrowser) )!  
poolDictionaryNames
    "Private - Returns the pool dictionary names used by the receiver.
     Used for fileOutDictionariesInto: "
    ^#(CatBrwHelpDict)! !

! VideoForWindowsProject class methods !  
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"

    ^'VFW'!  
classNames
    "Private - Returns the names of Project dependent classes."

    ^#(
        "Lo-Level classes"
        VideoForWindowsDLL MsACMDLL AVIFileDLL VFWFileDialog

        "Hi-Level classes"
        VFWObject

        "Window classes"
        MsMCIWindow

        "Test classes..."
        VFWTest VFWTestView
    )!  
hasPoolDictionaries
    "Private  - Returns true if the receiver has provate pool dictionaries.
    Default answer is false.
    This method can be reimplemented in subclasses"
    ^true!   
poolDictionaryNames
    "Private - Returns the pool dictionary names used by the receiver.
     Used for fileOutDictionariesInto: "

    ^#(
        DrawDibConstants
        CompressorConstants
        VideoConstants
        AVIFileConstants MsACMConstants)! !

! WBMDIPatchProject class methods !   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'WBMDIPatch'! 
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Object (notImplementedYet notFullyImplemented)
    ViewManager (mdiArrange mdiCascade mdiCloseAll mdiTile) )!   
preConditions
    "Private  - Returns source needed for preloading this proyect"
    ^super preConditions,
'
    (Smalltalk includesKey: #MDISystem) ifFalse: [
        MessageBox message: ''You must have Digitalks MDI support loaded to use this patch file. Install it and then reload this file.
A walkback follows.''.
        self error: ''MDI must be loaded first.''
    ].
'! !

! WBProject class methods !   
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'WBProject'!  
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
    CPBitmapManager WBFileSelectorEditor PStaticGraphic
    PGroupBox PGroupbox WBTabEditor PFormattedEntryField
    WBFramingEditor WBChoosePaneDialog PWBInvisibleGroupPane
    CPCreateButton WBGroupBox WBTopPane WBFramingParameters
    PRadioButtonGroup WBActionEditor WBInvisibleGroupPane
    PWBVerticalScrollBar WBStatusPaneEditor
    WBCompositePaneScratchWindow PCompositePane
    WBDefaultDialogScratchWindow ButtonEditor WB3DFrame
    PGenericSubpane WBFramerExample PEnhancedEntryField
    GraphicObject PStaticBox WBVerticalScrollBar
    FrameObject WindowFrameObject PTextEdit WBPMenubar
    PDrawnButton InterfaceObject WBMDIAttributesEditor
    WBTabPosition PEntryField PCheckBox
    WBDefaultScratchWindow WBLayoutPane WBScrapbookRetrieve
    WBMenuTester WBScratchWindow BitEditor
    WBMultiListChooser PToggle PEntryFieldGroup
    PAnimationPane WBListEntryField PCPStaticGraphic
    WBKeyEntryField PButton WBDefaultCompositePaneScratchWindow
    PComboBox PCheckBoxGroup PMultipleSelectListBox
    WBScrollingPane WBMenubarEditor WBDialogEditor
    TextEditWindow WBToolBarEditor PScrollBar
    CompositeFrameObject WBPMenu WinMinMaxInfo
    PThreeStateButton WBTreeNode WBMenuEditor PListBox
    PLinkButton PWBToolBar PRadioButton WBListEditor
    WBTreeListBox WBChooseClassDialog WBDialogScratchWindow
    WBCreateClassDialog WBTabOrderLayoutPane CPCreateBitmap
    WBEnhancedEntryFieldEditor WBAddInManager
    WBHorizontalScrollBar WBScrapbookStore WBStaticTextEditor
    WBRealLayoutPane WBPMenuItem WBAboutDialog
    PWBHorizontalScrollBar PGraphPane WBColorDialog
    WBKeyAccel PActionButton WBAttributeEditor
    PStatusPane WBLinkEditor WBWindowEditor
    WBScrollBarEditor WBTextPane PListPane PTextPane
    WindowBuilder PStaticText WBMultiToolPalette
    WBListChooser WBMDIAttributes )!  
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Window (getSubpaneOrder)
    String (asMessage)
    Array (asOrderedCollectionRecursively)
    StaticText (showHelp:)
    Object (notImplementedYet notFullyImplemented isWBClassBrowser isInterfaceObject isWBInternalClass)
    Rectangle (centerTop)
    Point (extentFromCenterTop: extentFromRightTop:)
    ),(Array with: Bitmap class),#( (buttonWidth:height:)
    Menu (removeAllItemsDynamically) )! !

! WBProPatchProject class methods !  
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'WBProPatch'! 
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Screen (pointFromUser:offset:)
    ViewManager (menuWindow)
    MenuWindow (performMenuItem:)
    ),(Array with: CursorManager class),#( (initialize)
    Object (notImplementedYet notFullyImplemented)
    Font (bold: italic strikeOut underscore) )! !

! WBProProject class methods !
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'WBPro'!  
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
     WBKeyAccel WBInvisibleGroupPane WBChooseClassDialog WBAboutDialog
     WBCreateClassDialog WBTabEditor WBMenuTester WindowBuilder
     WBColorDialog CPCreateBitmap WB3DFrame WBMenuEditor
     WBFramerExample WBTreeNode WBScratchWindow WBDialogScratchWindow
     WBAddInManager WBTextPane WBTopPane WBLayoutPane
     WBTabPosition WBFramingEditor WBDefaultDialogScratchWindow WBMDIAttributes
     WBScrapbookStore BitEditor WBDefaultScratchWindow GraphicObject
     WBMDIAttributesEditor WBListChooser WBAttributeEditor WBListEntryField
     WBScrapbookRetrieve WBKeyEntryField WBTreeListBox TextEditWindow
     WBScrollingPane )!
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Window (extent: getId getSubpaneOrder nameForInstVar: setStyle: tabPosition: wmGetminmaxinfo:with:)
    String (asMessage asQuotedString beginsWith: hasContent mnemonicChar upTo:)
    ComboBox (text)
    ),(Array with: ViewManager class),#( (isScratchWindow wbCreatedClasses)
    Symbol (asCUAPresentableString asPresentableString)
    StaticText (showHelp:)
    Point (extentFromCenterTop: extentFromRightTop:)
    ReadWriteStream (nextFourBytes nextTwoBytes)
    Font (wbEquals: wbStringWidth: logicalBytes nonPortableStoreOn:indentString: portableStoreOn:indentString: storeOn:indentString:)
    ClassHierarchyBrowser (isWBClassBrowser openSelecting: selectedClass selectedMethod)
    Stream (nextString:)
    ),(Array with: CPBitmapManager class),#( (addToolbarTool clearBMIcon clearToolbarTool createToolbarBitmapFrom:newName:innerRect: helpDict launchBitmapManager screenIcon toolBarTool)
    EntryField (password selectAll)
    ),(Array with: Bitmap class),#( (buttonWidth:height:)
    Object (notImplementedYet notFullyImplemented isInterfaceObject isWBClassBrowser isWBInternalClass)
    Rectangle (centerTop localizeRect: moveToLeftTop: offsetFromLeftTop: unLocalizeRect:)
    CPBitmapManager (addBitmap: bitmap bitmapDictionary: bitmapSelected: copyToClipboard copyToDefault create createNewButton delete duplicate edit edit: editButton exit fromClipboard fromFile fromScreen getFile:fileSpec:type: graphContents: listContents: load loadBitmapDictionaryFrom: open openOn: rename resizeButton save saveToFile statusPaneHelp: updateKeys: updateMenus)
    TopPane (handlers)
    SubPane (handlers: realHandlers)
    Bitmap (cpCopy fromSysID: storeOnStream:)
    TextWindow (addMenuItem:)
    UserDLL (drawFocusRect:rectangle: drawText:text:length:rect:format: openIcon:)
    MenuWindow (asWBPMenu asWBPMenuBar wbMenuTitled:)
    Array (asOrderedCollectionRecursively)
    ),(Array with: CursorManager class),#( (corner leftRight upDown)
    ByteArray (asString)
    ApplicationWindow (label menuWindow: wmGetminmaxinfo:with:)
    TextTool (centerText:at: centerWinText:at: winDrawText:at: winDrawText:in:format:)
    Number (isFraction)
    TextPane (realHandlers)
    Pen (buttonHighlight drawFocusRect: drawRect3D: drawRect3DLight: lineFrom:to: quickLineFrom:to:using:)
    Menu (asPMenuItem asWBPMenu insertItemDynamically:selector:atIndex: removeAllItemsDynamically removeItemDynamically:)
    ),(Array with: MessageBox class),#( (messageNote: yesNoCancelTitled:text:) )!  
postConditions
    "Private  - Returns source needed for postloading this proyect"
    ^super postConditions,
'
    PMToWinKeyMap
    at: 17 put: 38;      "VkPageup"
    at: 38 put: 118;    "VkF7"
    at: 15 put: 27;      "VkEscape"
    at: 26 put: 45;      "VkInsert"
    at: 47 put: 127;    "VkF16"
    at: 36 put: 116;    "VkF5"
    at: 43 put: 123;    "VkF12"
    at: 5 put: 8;         "VkBack"
    at: 18 put: 40;      "VkPagedown"
    at: 34 put: 114;    "VkF3"
    at: 41 put: 18;      "VkMenu"
    at: 46 put: 126;    "VkF15"
    at: 13 put: 19;      "VkPause"
    at: 39 put: 119;    "VkF8"
    at: 42 put: 122;    "VkF11"
    at: 32 put: 112;    "VkF1"
    at: 27 put: 46;      "VkDelete"
    at: 37 put: 117;    "VkF6"
    at: 23 put: 39;      "VkRight"
    at: 29 put: 144;    "VkNumlock"
    at: 45 put: 125;    "VkF14"
    at: 44 put: 124;    "VkF13"
    at: 41 put: 121;    "VkF10"
    at: 9 put: 16;       "VkShift"
    at: 6 put: 9;         "VkTab"
    at: 35 put: 115;    "VkF4"
    at: 19 put: 35;      "VkEnd"
    at: 16 put: 32;      "VkSpace"
    at: 20 put: 36;      "VkHome"
    at: 40 put: 120;    "VkF9"
    at: 33 put: 113;    "VkF2"
    at: 21 put: 37;      "VkLeft"
    at: 22 put: 38;      "VkUp"
    at: 24 put: 40.      "VkDown"
    PMToWinKeyMap keys do: [ :k |
        WinToPMKeyMap at: (PMToWinKeyMap at: k) put: k.
    ].

    VirtualKeyConstants at: ''AfVirtualkey'' put: 8.

    WinEvents at: 36  put: #wmGetminmaxinfo:with:.

    Smalltalk at: #PWindowBuilder put: WindowBuilder.

    PWindowBuilder startup.

    CPBitmapManager addToolbarTool.
    (Smalltalk version first = $2) ifTrue: [
        CPBitmapManager screenIcon.
    ].

    Smalltalk removeKey: #CPSrcDir ifAbsent: [].
'!
preConditions
    "Private  - Returns source needed for preloading this proyect"
    ^super preConditions,
'
    (Smalltalk includesKey: #IconEditor) ifFalse: [
        Transcript cr; show: ''*** In order to edit icons for windows you must install the IconEditor.''.
        Transcript cr; show: ''*** It can be found in EXAMPLES\ICONEDIT (ICONEDIT.ST).''.
    ].
    (Smalltalk includesKey: #ObjectFiler) ifFalse: [
        Transcript cr; show: ''*** In order to load and save scrapbooks you must install ObjectFiler.''.
        Transcript cr; show: ''*** It can be found in EXTRAS\OBJFILER (VWOBJFLR.ST).''.
    ].
    (Smalltalk includesKey: #MDISystem) ifFalse: [
        Transcript cr; show: ''*** In order to use MDI you must install MDI support.''.
        Transcript cr; show: ''*** It can be found in EXTRAS\MDI (MDI.ST).''.
        Transcript cr; show: ''*** Also load MDIPATCH.ST''.
    ].
    Smalltalk at: #PWindowBuilder put: nil.

    Smalltalk at: #WindowBuilderVersion put:  ''Version 1.01\Windows'' withCrs.
    Smalltalk at: #AcuFont put: nil.
    Smalltalk at: #WBConstants put: WinConstants.
    Smalltalk at: #PMToWinKeyMap put: Dictionary new.
    Smalltalk at: #WinToPMKeyMap put: Dictionary new.
    WinConstants at: ''ColorBtnhighlight'' put: 20.
    ColorConstants at: ''ClrChiseledgray'' put: -1.

    (Smalltalk includesKey: #WindowBuilder) ifTrue: [
        (Smalltalk at: #WindowBuilder)
            removeSelector: #pane:;
            removeSelector: #initInstVars.
    ].
    Smalltalk at: #WindowBuilderUser put: ''Mandrake''.
    Smalltalk at: #WindowBuilderCompany put: ''Object Style''.
    Smalltalk at: #WindowBuilderSerialNumber put: ''< NA >''.

    (Smalltalk at: #CPBitmapDict) loadSystemBitmaps: ''wbbmp.dct''.
    (Smalltalk at: #CPBitmapDict) addBitmaps: ''bitmaps.bdt''.
'! !

! WBRunPatchesProject class methods ! 
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'WBRTPatch'!  
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Window (windowText addSubpane: minimized)
    ListBox (indexOf:)
    GraphicsTool (fill:color:)
    ViewManager (openWindow removeView:)
    ApplicationWindow (validate activate defaultFrameStyle)
    NotificationManager (readWinQueue)
    ControlPane (basicStyle contents:)
    DrawnButton (stretchToFit fixedSize)
    EntryField (contents)
    Object (notImplementedYet notFullyImplemented)
    SubPane (wmKillfocus:with: aboutToSaveImage)
    TextPane (wmGetdlgcode:with:)
    DialogTopPane (mainWindow buildItems buildWindow: close defaultFrameStyle)
    WindowDialog (openModeless openWindow)
    Font (fixedWidth)
    Menu (buildItem:menu:menuBar: disableAll enableAll)
    DialogBox (queryItemText:) )! !

! WBRuntimeProject class methods !
abreviation
    "Returns the abreviated name for the receiver.
     This method could be refined by subclasses"
    ^'WBRuntime'!  
classNames
    "Private - Returns the names of Project dependent classes."
    "*WARNING* This method must be reimplemented in subclasses"
    ^#(
     WBEntryField WBCompositePaneTester ActionButton LinkButton
     WBAction WBDialogTopPane EnhancedEntryField WBWindowDialog
     CompositePane CPStaticGraphic CPBitmapDict WBListBox
     FramingParameters WBTool WBComboBox WBToolPalette )! 
methodsCollection
    "Private - Returns the Project dependent methods
     for general classes as array of methodsNames subarrays."
    ^#(
    Window (modifiedBy modifiedBy: paneName paneName: paneNamed: redraw addSubpaneDynamically: addToSubpaneOrder: createdBy createdBy: dialogTemplate dialogTemplate: helpManager iconFile iconFile:)
    ),(Array with: ViewManager class),#( (open openAsMDIParent openWithMDIParent: openWithMyParent: openWithParent: wbCreated)
    Integer (bitIsOn:)
    ViewManager (paneNamed: viewNamed: views openWithMDIParent: openWithMyParent: openWithOwner: openWithOwnerParent: openWithParent: isModal isWBWindow open openAsMDIParent openViews closeWindow createViews createViewsFor:owner: dialogTemplate dialogTemplate: execute:withTopPane:)
    String (asByteArray asProperNoun stripMnemonic)
    RadioButton (isRadio)
    GraphPane (noBorders noScrollBars)
    StaticText (isWsTabstop tabStop)
    TextEdit (noBorders noScrollBars scrollBars wmGetdlgcode:with: wordWrap)
    Toggle (isButton setDefault unsetDefault)
    ),(Array with: Font class),#( (face:size:fixedWidth:attributes:)
    ),(Array with: Bitmap class),#( (fromStream:)
    EntryField (maxSize maxSize: readonly setReadOnly:)
    DrawnButton (invisible cpContents cpContents: cpSize cpStyle fileExists:)
    GDIDLL (createPatternBrush:)
    UndefinedObject (ifNil:)
    Message (isMessage)
    WindowDialog (isModal openViews)
    Object (notImplementedYet notFullyImplemented addedByOSI ifNil: initWindow isCompositePane isDictionary isMDIFrame isMessage isRadio isRectangle isSubPane isWBAction isWBWindow minWindowSize modifiedByOSI openWindow preInitWindow)
    Rectangle (isRectangle)
    TopPane (close: frameStyleFromPStyle pStyle pStyle:)
    DialogTopPane (wmCreate:with: sizeWindow cachedBuildItems frameStyleFromPStyle)
    SubPane (wmSetfocus:with: accel:afBits: addStyle: getPopupMenu handlers isButton isGroupable isSubPane isWsGroup isWsTabstop startGroup tabStop)
    Font (fromBytes: stringExtent:)
    UserDLL (createDialogIndirect:dialogTemplate:parent:dialogFunction: getDlgItemTextW:item:text:maxCount: getWindowTextW:text:maxLength:)
    GraphicsTool (fill:bitmap:)
    Array (asByteArray convertBytesToString)
    ApplicationWindow (viewName: setBackColor: frameStyleFromPStyle)
    NotificationManager (activeWindow isAltDown isCtrlDown)
    GroupBox (isWsTabstop tabStop)
    ),(Array with: Date class),#( (dateArray: validateDay:month:year: validateString:)
    Dictionary (isDictionary)
    TextPane (noBorders noScrollBars)
    Pen (draw3DButton:rect:font: draw3DButton:rect:font:foreColor:backColor: drawRect3D:depth:style: drawRectangle:)
    Button (isButton isGroupable setDefault setDefault: setFocus unsetDefault wmKillfocus:with:)
    Menu (appendItem:action: appendItem:action:acceleratorString: appendItem:link:type: appendItem:link:type:acceleratorString: appendItem:selector:acceleratorString: clearPopup wbAction) )! 
postConditions
    "Private  - Returns source needed for postloading this proyect"
    ^super postConditions,
'
PMToWinKeyMap
    at: 17 put: 38;      "VkPageup"
    at: 38 put: 118;    "VkF7"
    at: 15 put: 27;      "VkEscape"
    at: 26 put: 45;      "VkInsert"
    at: 47 put: 127;    "VkF16"
    at: 36 put: 116;    "VkF5"
    at: 43 put: 123;    "VkF12"
    at: 5 put: 8;         "VkBack"
    at: 18 put: 40;      "VkPagedown"
    at: 34 put: 114;    "VkF3"
    at: 41 put: 18;      "VkMenu"
    at: 46 put: 126;    "VkF15"
    at: 13 put: 19;      "VkPause"
    at: 39 put: 119;    "VkF8"
    at: 42 put: 122;    "VkF11"
    at: 32 put: 112;    "VkF1"
    at: 27 put: 46;      "VkDelete"
    at: 37 put: 117;    "VkF6"
    at: 23 put: 39;      "VkRight"
    at: 29 put: 144;    "VkNumlock"
    at: 45 put: 125;    "VkF14"
    at: 44 put: 124;    "VkF13"
    at: 41 put: 121;    "VkF10"
    at: 9 put: 16;       "VkShift"
    at: 6 put: 9;         "VkTab"
    at: 35 put: 115;    "VkF4"
    at: 19 put: 35;      "VkEnd"
    at: 16 put: 32;      "VkSpace"
    at: 20 put: 36;      "VkHome"
    at: 40 put: 120;    "VkF9"
    at: 33 put: 113;    "VkF2"
    at: 21 put: 37;      "VkLeft"
    at: 22 put: 38;      "VkUp"
    at: 24 put: 40.      "VkDown"
    PMToWinKeyMap keys do: [ :k |
        WinToPMKeyMap at: (PMToWinKeyMap at: k) put: k.
    ].

    VirtualKeyConstants at: ''AfVirtualkey'' put: 8.
'!
preConditions
    "Private  - Returns source needed for preloading this proyect"
    ^super preConditions,
'
    Smalltalk at: #WBConstants put: WinConstants.
    Smalltalk at: #PMToWinKeyMap put: Dictionary new.
    Smalltalk at: #WinToPMKeyMap put: Dictionary new.
    ColorConstants at: ''ClrChiseledgray'' put: -1.
'! !

! DatabaseMap class methods !  
for: aClass
    ^self new
        mappedClass: aClass;
        yourself! !

! DatabaseMap methods !  
atField: aTupleName put: aFieldMap
    "Private - Loading - Place a new key field definition.
        Returns the receiver..."
    | aName |
    aName :=
        aTupleName = aFieldMap name
        ifTrue: [aFieldMap name] "use the same string..."
        ifFalse: [aTupleName].
    self tupleMap at: aName asSymbol put: aFieldMap!   
initialize
    tupleMap := Dictionary new.
    ^super initialize!   
keyField
    tupleMap associationsDo: [:each |
        each value getMessage = #number ifTrue: [
            ^each key
        ]
    ].
    ^nil.!  
mappedClass
    "Returns the instance var of the receiver
     for external manipulation"
    ^mappedClass!
mappedClass: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    mappedClass := anObject!   
name
    "Returns the name for the receiver (see for mapping naming convention)"
    ^mappedClass name,'DBMap'! 
printOn: aStream
        "Append the ASCII representation of the receiver
         to aStream..."
    | tab field |
    tab := '    '.
    aStream nextPutAll: '(',self class name,' for: ',mappedClass printString,')'.
    tupleMap keys asSortedCollection do: [:key|
        field := tupleMap at: key.
        key = field name
        ifTrue: [aStream cr;nextPutAll: tab,'with: (',field printString,');']
        ifFalse: [
            aStream cr;nextPutAll: tab,'atField: '.key storeOn: aStream. aStream nextPutAll: ' put: (',field printString,');'
        ]
    ].
    aStream cr;nextPutAll: tab,'yourself'! 
tupleMap
    "Returns the instance var of the receiver
     for external manipulation"
    ^tupleMap!  
tupleMap: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    tupleMap := anObject! 
with: aFieldMap
    "Private - Loading - Place a new key field definition.
        The name of the field will be used for placing
        Returns the receiver..."

    self tupleMap at: aFieldMap name put: aFieldMap! !

! FieldMap class methods ! 
for: anArray
    "Returns an instance of the receiver wortking with a nil class
     and using anArray for building the get & set messages.
     The name will be extracted from the getMessage"

    anArray isSymbol
    ifTrue: [^self for: (Array with: anArray with: (anArray ,':')asSymbol ) ].

    ^self for: anArray as: nil!
for: anArray as: aClass
    "Returns an instance of the receiver wortking with aClass
     and using anArray for building the get & set messages.
     The name will be extracted from the getMessage"

    anArray isSymbol
    ifTrue: [^self for: (Array with: anArray with: (anArray ,':')asSymbol ) as: aClass ].

    ^self new
        conversionClass: aClass;
        getMessage: anArray first;
        setMessage: anArray last;
        yourself! !

! FieldMap methods !   
conversionClass
    "Returns the instance var of the receiver
     for external manipulation"
    ^conversionClass!
conversionClass: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    conversionClass := anObject!   
getMessage
    "Returns the instance var of the receiver
     for external manipulation"
    ^getMessage!  
getMessage: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    getMessage := anObject! 
name
    "Returns the instance var of the receiver
     for external manipulation"
    ^getMessage!
printOn: aStream
        "Append the ASCII representation of the receiver
         to aStream..."

    aStream nextPutAll: self class name, ' for: #'.
    (setMessage notNil
        and: [getMessage printString
                = (setMessage printString copyFrom: 1 to: setMessage size - 1)])
    ifTrue: [ aStream nextPutAll: getMessage printString]
    ifFalse: [ aStream nextPutAll: '(',getMessage printString,' ',setMessage printString,')'].

    conversionClass isNil
    ifFalse: [
        aStream nextPutAll: ' as: ',conversionClass printString
     ]!  
setMessage
    "Returns the instance var of the receiver
     for external manipulation"
    ^setMessage!  
setMessage: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    setMessage := anObject! !

! Relation class methods ! 
aboutToSaveImage
    "Private - Register the receiver if needed..."

    super aboutToSaveImage.

    "All instances must be destroyed..."
    self exit.

    "Register the receiver for notification at exit..."
    (Smalltalk exitObjects includes: self) ifTrue: [^self].
    Smalltalk notifyAtExit: self.!   
addToCache: anObject
    "Insert anObject into the cache..."
    | set |
    set := self catchedObjectsOfClass: anObject class.
    set add: anObject.
    ^Cache at: anObject class put: set!   
cache
    "Private - Returns the current cahce of database objects"

    ^Cache!   
catchedObjectOfClass: aClass name: aName
    "Returns the current catched object of cklass aClass
     and name aName or nil if failed."

    (self catchedObjectsOfClass: aClass) do: [:each|
        each name = aName
        ifTrue: [^each].
    ].
    ^nil!
catchedObjectOfClass: aClass number: aNumber
    "Returns the currently catched object of number aNumber.
    WARNING: All catched objects MUST respond to #number"

    (self catchedObjectsOfClass: aClass) do: [:each|
        each number = aNumber
        ifTrue: [^each].
    ].
    ^nil! 
catchedObjectsOfClass: aClass
    "Private - Returns all the catched objects of class aClass"

    ^Cache
        at: aClass
        ifAbsent: [Set new]!
closeOpenRelations
    "Private - Close all currently open relations"

    [ All isEmpty ] whileFalse: [ All removeFirst close ]!  
closeQE
    "Private - Close Q+E engine"

    self resetCache.
    self closeOpenRelations.
    self disconnect.
    All := OrderedCollection new.! 
connect: aString
    "Private - Register a new connection.
     Returns the handle to the connection (or generates an error if failed)
    <attribute>=<value>[;<attribute>=<value>...]
        Attribute
        DRV          name of the driver for the database system ( e.g.: QEPdx )
        UID           User Id or name
        PWD         Password
        SRVR        Server computer name
        DB            Database name
        FILES       The full pathname of the directory containing the Netware SQL data files
        DICT         The full pathname of the directory containing the Netware SQL dictionary files
    "

    | hdbc |
    hdbc := self library qeConnect: aString asParameter.
    hdbc = 0
    ifTrue: [ self library checkError. self error: 'Connect failed' ]
    ifFalse: [ Conections at: aString put: hdbc ].
    ^hdbc!   
disconnect
    "Private - Destroy all current connections"

    | connected |
    connected := Conections values.
    Conections := Dictionary new.
    connected do: [ :hdbc| self library qeDisconnect: hdbc ].!  
execute: aString with: aConectionString
    "Executes an SQL expression with connection aConnectionString"

    Relation new
        connect: aConectionString;
        execSQL: aString;
        close.!   
exit
    "The receiver must free all resources in use..."

    self
        closeQE;
        resetCache.!
initialize
    "Private - Initialize the receiver's resources"

    All := OrderedCollection new.
    Conections := Dictionary new.
    self resetCache.!
library
    "Private - Returns library in use..."

    ^QELibDLL library!  
new
    "Returns a new registered instance of the receiver..."

    All isNil ifTrue: [self initialize].
    ^All add: super new! 
removeFromCache: anObject
    "Remove anObject from the cache (if present)"
    ^(self catchedObjectsOfClass: anObject class)
        remove: anObject ifAbsent: []!   
resetCache
    "Private - Reset the currently cache of objects..."

    Cache := IdentityDictionary new.!  
startUp
    "The receiver must initialize during startUp..."

    self initialize.!
trace: aString
    "Activates a trace procedure..."

    self library qeTraceOn: aString asParameter.! 
traceOff
    "Disable tracing..."

    self library qeTraceOff.! !

! Relation methods ! 
at: anInteger
    "Returns the row at anInteger."
    | result |
    position + 1 == anInteger ifTrue: [^self next].
    position - 1 == anInteger  ifTrue: [^self prev].

    self changeCursorWhile: [
        (self fetchAt: anInteger) ifFalse: [
            result := tuple fromStatement: hstmt
        ]
    ].
    ^result!   
basicExecSQL: aStatement
    "Private - ejecuta una sentencia SQL"

    self
        endSQL;
        hstmt: (self library qeExecSQL: hdbc stmt: aStatement asParameter);
        checkError: hstmt! 
beginTran
    "Begin transaction..."

    self library qeBeginTran: hdbc.! 
changeCursorWhile: aBlock
    "Private - Evaluates aBlock showing execute cursor...
    Returns aBlock value result..."

    | oldCursor result |
    oldCursor := Cursor == CursorManager execute ifFalse: [ Cursor ].
    oldCursor notNil ifTrue: [ CursorManager execute change].
    result := aBlock value.
    oldCursor notNil ifTrue: [ oldCursor change ].
    ^result!
checkError
    "Private - Generates an error if an Q+E Error has been occurred"

    | label error |
    error :=  self library qeErr.
    error = 0
    ifFalse: [
        label := '(DBErr#' ,  self library qeDBErr asString , ', Err# ',error asString,') ',self library qeErrMsg.
        self close.
        ^self error: label
    ]!
checkError: hst
    "Private - "

    hst = 0 ifTrue: [ ^self  checkError ].!  
close

    self endSQL.
    (All includes: self) ifTrue: [
        All remove: self.
    ].! 
collect: aBlock
        "Evaluate aBlock once for each element in the
         receiver and return a collection with the results."

    | rec result size |
    size := self size.
    result := OrderedCollection new: size.
    self changeCursorWhile: [
        size > 0 ifTrue: [
            rec := self first.
            [ rec notNil ] whileTrue: [
                result add: (aBlock value: rec).
                rec := self next.
            ].
        ]
    ].

    ^result!   
commitTran
    "Commit  transaction"
    self library qeCommit: hdbc.!  
conectionString
    "Private - Returns the connection string (see #connect: class method)"

    ^class conectionString!
connect: aString

    "<attribute>=<value>[;<attribute>=<value>...]
        Attribute
        DRV          name of the driver for the database system
        UID           User Id or name
        PWD         Password
        SRVR        Server computer name
        DB            Database name
        FILES       The full pathname of the directory
                            containing the Netware SQL data files
        DICT         The full pathname of the directory
                            containing the Netware SQL dictionary files "

    hdbc := Conections at: aString ifAbsent: [ self class connect: aString ].!
detect: aBlock ifNone: anotherBlock

    self do: [ :each|
        (aBlock value: each) ifTrue: [
            ^each
        ].
    ].

    ^anotherBlock value!   
do: aBlock
        "Evaluate aBlock once for each element in the
         receiver."

    | rec |

    self size > 0 ifTrue: [
        rec := self first.
        [ rec notNil ] whileTrue: [
            aBlock value: rec.
            rec := self next.
        ].
    ].! 
endSQL

    "Private - finaliza una consulta SQL"

    (hstmt ~= 0 and: [hstmt notNil])
    ifTrue: [
        self library qeEndSQL: hstmt.
        "Transcript cr;nextPutAll: 'End  SQL:',sqlStatement asString,' [',hstmt asString,']'."
    ].
    self hstmt: nil.!  
execSQL: aStatement

    "Private - ejecuta una sentencia SQL"

    self changeCursorWhile: [
        self endSQL.
        self hstmt: (self library qeExecSQL: hdbc stmt: aStatement asParameter).
        self checkError: hstmt.
        self library qeFetchSetOptions: hstmt options: 1.
        numRecs := nil.
        self checkError: hstmt.
        position := 0.
        tuple statement: hstmt.
    ]!  
fetchAt: anInteger

    "Private - Gets the anInteger object"

    | result |
    hstmt isNil ifTrue: [^true].

    self changeCursorWhile: [
        result := self library qeFetchRandom: hstmt recnum: anInteger
    ].
    position := result ~= 0
        ifTrue: [anInteger]
        ifFalse: [-2].

    ^result ~= 0!
fetchFirst

    "Private - Gets the first object"

    | result |
    hstmt isNil ifTrue: [^true].

    self changeCursorWhile: [
        result := self library qeFetchRandom: hstmt recnum: 1
    ].
    position := result ~= 0
        ifTrue: [1]
        ifFalse: [-3].
    ^result ~= 0!  
fetchLast

    "Private - Gets the last object"

    | result |
    hstmt isNil ifTrue: [^true].

    self changeCursorWhile: [
             result := self library qeFetchRandom: hstmt recnum: self size.
    ].
    position := result ~= 0
        ifTrue: [self size]
        ifFalse: [-4].
    ^result ~= 0!  
fetchNext

    "Private - Returns false while not at end (fetching an object)"


    | result |
    hstmt isNil ifTrue: [^false].

    self changeCursorWhile: [
        result := self library qeFetchNext: hstmt.
    ].
    position := result ~= 0
        ifTrue: [position + 1]
        ifFalse: [-5].
    ^result ~= 0!  
fetchPrev

    "Private - Gets the previous object"


    | result |
    hstmt isNil ifTrue: [^false].

    self changeCursorWhile: [
        result := self library qeFetchPrev: hstmt.
    ].
    position := result ~= 0
        ifTrue: [position - 1]
        ifFalse: [-6].
    ^result ~= 0! 
first

    "Returns the first object"

    self fetchFirst ifFalse: [
        ^tuple fromStatement: hstmt
    ].
    ^nil! 
hstmt
    "Returns the instance var of the receiver
     for external manipulation"
    ^hstmt!
hstmt: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    hstmt := anObject!   
indexOf: anObject
    "Returns the index of anObject in the current database...
    WARNING: anObject MUST respond to #number "

    | obj i  number fieldIndex |
    anObject isNil ifTrue: [^0].
    number := anObject number.
    fieldIndex := (tuple fieldIndex: class keyField).
    i := 1.
    self fetchFirst ifTrue: [^nil].
    number = (self library
                    qeValChar: hstmt
                    colnum: fieldIndex
                    fmtstring: '' asParameter maxlen: 0) ifTrue: [
            ^i
        ].

    [self fetchNext] whileFalse: [
        i := i + 1.
        number = (self library
                    qeValChar: hstmt
                    colnum: fieldIndex
                    fmtstring: '' asParameter maxlen: 0) ifTrue: [
            ^i
        ].
    ].

    ^0!
initialize
    "Private - Initialize the receiver..."

    super initialize.
    self initializeTuple.!   
initializeTuple
    "Private - Initialize the receiver's tuple..."

    tuple := Tuple new.!   
last

    "Returns the last object"

    self fetchLast ifFalse: [
        ^tuple fromStatement: hstmt
    ].
    ^nil!
library
    "Returns the instance var of the receiver
     for external manipulation"

    library isNil ifTrue: [ library := self class library ].
    ^library!
like: aString

    self sqlStatement: (class like: aString)!
map
    "Returns the instance var of the receiver
     for external manipulation"

    (map isNil and: [ class notNil ])
    ifTrue: [ self map: class map ].

    ^map!   
map: anObject
    "Private - Sets the map of the receiver.
    And Update the tuple's map..."

    map := anObject.
    tuple map: anObject.!
next

    "retorna el proximo elemento de la tabla"

    self fetchNext ifFalse: [
        ^tuple fromStatement: hstmt
    ].
    ^nil!
openOn: aClass

    class := aClass.
    self connect: self conectionString.!  
openOn: aClass sqlStatement: aString

    self
        openOn: aClass;
        sqlStatement: aString.!
prev

    "retorna el elemento anterior de la tabla"

    self fetchPrev ifFalse: [
        ^tuple fromStatement: hstmt
    ].
    ^nil!   
printString
    ^'a ',self class name,' SQLStatement : ', sqlStatement asString! 
refreshQuery
    "ejecuta el query nuevamente para actualizar la informacion"

    self sqlStatement:
        ((class respondsTo: #sqlSelect)
        ifTrue: [ class sqlSelect ]
        ifFalse: [ sqlStatement ]).!  
rehash
    "Private - Rehash the receiver after loading"
    self openOn: class sqlStatement: sqlStatement! 
release

    self close.
    ^super release.!  
rollbackTran
    "Rollback  transaction"
    self library qeRollback: hdbc.!
select: aBlock

    | rec c |

    self size > 0 ifTrue: [
        c := OrderedCollection new.
        rec := self first.
        [ rec notNil ] whileTrue: [
            (aBlock value: rec) ifTrue: [
                c add: rec.
            ].
            rec := self next.
        ].
        ^c
    ].

    ^#()!  
size
    | err |
    numRecs isNil ifTrue: [
        self changeCursorWhile: [
            numRecs := (self library qeFetchNumRecs: hstmt) max: 0.
            self checkError.
        ]

    ].

    ^numRecs!
sqlStatement: aString
    "Private - registra la sentencia SQL utilizada para acceder a la base de datos"

    self execSQL: aString.
    sqlStatement := aString.!   
update: anInteger

    self error: 'update: not supported on relations'.! !

! Table class methods !  
structureFor: aFileName connect: aString
    "Returns all the columns names for table named aFileName"

    | table  struct |
    table := Table new.
    table connect: aString.
    table basicExecSQL: 'SELECT * FROM ', aFileName.
    struct := table structure.
    table release.
    ^struct! !

! Table methods ! 
add: anObject

    "agrega el registro"

    | statement values hst toPlace fieldName numModified |
    numModified := 0.
    tuple fromObject: anObject.

    statement :=  'INSERT INTO ' , class dataBase, ' ('.
    values := ''.
    1 to: tuple size do: [ :i|
        fieldName := tuple colNames at: i.
        (tuple at: i) notNil ifTrue: [
            statement := statement, fieldName, ','.
            values := values, (tuple at: i)  , ','.
        ].
    ].
    values := values copyFrom: 1 to: values size - 1.
    statement := (statement copyFrom: 1 to: statement size - 1), ') VALUES (', values, ')'.

    self class addToCache: anObject.

    self changeCursorWhile: [
        hst := self library qeExecSQL: hdbc stmt: statement asParameter.
        self checkError: hst.

        numModified := (self library qeNumModRecs: hst).

        self class addToCache: anObject.
        self library qeEndSQL: hst.
    ].
    ^numModified!
atKey: aKey

    "ubica el registro por su clave"

    | hst r data |
    self changeCursorWhile: [
        hst := self library qeExecSQL: hdbc stmt: ('SELECT * FROM ' , class dataBase, ' WHERE ', (class conditionForKey: aKey)) asParameter.
        self checkError: hst.
        r := self library qeFetchNext: hst.
        r = 0 ifFalse: [
            data := nil.
        ]
        ifTrue: [
            data := tuple fromStatement: hst
        ].
        self library qeEndSQL: hst.
    ].
    ^data!   
includes: anObject

    "busca anObject en la tabla"

    | hst r data |
    self changeCursorWhile: [
        hst := self library qeExecSQL: hdbc stmt: ('SELECT * FROM ' , class dataBase, ' WHERE ', (class conditionFor: anObject)) asParameter.
        self checkError: hst.
        r := self library qeFetchNext: hst.
        self library qeEndSQL: hst.
    ].
    r = 0 ifFalse: [
        ^false
    ].
    ^true! 
isCollection
    ^true!  
open: dataBase on: aClass

    ^self
        openOn: aClass
        sqlStatement: 'SELECT * FROM ', dataBase! 
openOn: aClass

    ^self
        open: aClass dataBase
        on: aClass!   
openOn: aClass sqlStatement: aString

    super openOn: aClass.
    self sqlStatement: aString!
orderBy: o

    "retorna la relacion correspondiente a la consulta"
    ^Relation new on: class dataBase sqlStatement: 'SELECT * FROM ', class dataBase, ' ORDER BY ', o.! 
remove: anObject

    "borra el registro"

    ^self remove: anObject ifAbsent: []!   
remove: anObject ifAbsent: dontCare

    "borra el registro"

    | hst |
    self changeCursorWhile: [
        hst := self library qeExecSQL: hdbc stmt: ('DELETE FROM ' , class dataBase, ' WHERE ', (anObject class conditionFor: anObject)) asParameter.
        self checkError: hst.
        self library qeEndSQL: hst.
    ].
    self class removeFromCache: anObject.

    ^anObject!   
removeIndex: anInteger
    "borra el registro"
    self
        remove: (self at: anInteger);
        refreshQuery.!  
structure
    | cols colNames |
    cols := self library qeNumCols: hstmt.
    colNames := Array new: cols.
    "encontrar todos los nombres del los fields"
    1 to: cols do: [ :i |
        colNames at: i
                put: (self library qeColName: hstmt colnum: i)
    ].
    ^colNames!   
update: anObject
    "actualiza el registro (la clave debe ser la misma)"

    ^self update: anObject condition:  ' WHERE ', (anObject class conditionFor: anObject).! 
update: anObject  condition: condition

    "actualiza el registro (la clave debe ser la misma)"

    | statement  hst fieldName numModified |
    numModified := 0.
    tuple fromObject: anObject.
    statement :=  'UPDATE ' , class dataBase, ' SET '.
    1 to: tuple size do: [ :i|
        fieldName := tuple colNames at: i.
        (tuple at: i) notNil ifTrue: [
            statement := statement, (tuple colNames at: i), '=', (tuple at: i), ','
        ].
    ].
    statement := (statement copyFrom: 1 to: statement size - 1), condition.

    self changeCursorWhile: [
        hst := self library qeExecSQL: hdbc stmt: statement asParameter.
        self checkError: hst.

        numModified := (self library qeNumModRecs: hst).

        self class addToCache: anObject.
        self library qeEndSQL: hst.
    ].
    ^numModified! !

! RelationalTable methods !   
columnNames
    "Return the current column names..."

    ^tuple colNames! 
columnTypes
    "Return the current column types..."

    ^tuple colTypes! 
columnWidths
    "Return the current column widths..."

    ^tuple colWidths!  
conectionString
    "Returns the instance var of the receiver
     for external manipulation"
    ^conectionString!
conectionString: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    conectionString := anObject!   
conectionStringFor: dataBase
    "Private - Returns the connection string for database"

    | extensions ext |
    extensions := Dictionary new.
    extensions
        "
        at: 'DBF' put: 'dbf';
        "
        yourself.
    ext := (dataBase reversed upTo: $.) reversed asUpperCase.
    ^'DRV=qe',(extensions at: ext ifAbsent: [ext])! 
initializeTuple
    "Private - Initialize the receiver's tuple..."

    tuple := RelationalTuple new.! 
open: dataBase

    ^self open: dataBase on: nil!   
open: dataBase on: aClass

    conectionString isNil ifTrue: [
        self conectionString: (self conectionStringFor: dataBase)
    ].
    ^super open: dataBase on: aClass! !

! Tuple class methods !   
dateFrom: value
    value size = 0 ifTrue: [^nil].
    ^Date fromString: value.
    "   Date fromStringDMY: value.   "!
formatedDate: aDate

"    aDate isNil ifTrue: [^'{ 01/01/80 }']."
    (aDate isNil or: [ aDate = (Date newDay: 1 month: #Jan year: 1980) ]) ifTrue: [^'NULL'].
    ^'{ ',aDate monthIndex asString, '/', aDate dayOfMonth asString, '/', aDate year asString,' }'

    "
    | placeDigit |
    aDate isNil ifTrue: [^nil].
    placeDigit := [:i|
      i > 9
        ifTrue: [i asString]
        ifFalse: ['0',i asString]
    ].
    ^'[ d ', (String with: $'),
        aDate year asString,'-',
        (placeDigit value: aDate monthIndex) asString,'-',
        (placeDigit value: aDate dayOfMonth) asString,' 00:00:00.000000',
        (String with: $'),']'
     "
          "        Tuple formatedDate: Date today             "!  
formatedNumber: aNumber
    | stream |
    aNumber isNil ifTrue: [ ^'0' ].
    aNumber isInteger ifTrue: [ ^aNumber asString ].
    stream := WriteStream on: (String new: 10).

    aNumber printOn: stream decimalSeparator: '.'.
    ^stream contents!  
initialize
    " Tuple initialize "
    ToString := Dictionary new.
    ToString
        at: String put: [:value | value printString];
        at: False put: [:value | '0' printString];
        at: True put: [:value | '1' printString];
        at: Boolean put: [:value | (value ifTrue: ['1'] ifFalse: ['0']) printString];
        at: Date put: [:value| self formatedDate: value ];
        at: Time put: [:value| self error: 'Time not implementado' ];
        at: ByteArray put: [:value| self error: 'ByteArray No implementado'].
    Number allSubclasses do: [:each |
        ToString at: each put: [:value | self formatedNumber: value ]
    ].

    FromString := Dictionary new.
    FromString
        at: String put: [:value | value];
        at: Boolean put: [:value | value = '1'];
        at: Date put: [:value| self dateFrom: value];
        at: Time put: [:value| self timeFrom: value];
        at: ByteArray put: [:value| self error: 'ByteArray No implementado'].
    Number allSubclasses do: [:each |
        FromString
            at: each put: [:value | value asNumber].
    ].! !

! Tuple methods !  
at: aColumnNumber

    ^fields at: aColumnNumber!   
at: aColumnNumber put: aString
    | key |
    aString = '''''' ifTrue: [
        (key := (colTypes at: aColumnNumber) key) = #toNumber:class: ifTrue: [
            ^fields at: aColumnNumber put: '0'
        ].
        key = #toDateTime:class: ifTrue: [
            ^fields at: aColumnNumber put: '{ 01/01/80 }'
        ].
    ].
    ^fields at: aColumnNumber put: aString!   
colNames
    ^colNames!  
colTypes
    ^colTypes!  
colWidths
    "Returns the instance var of the receiver
     for external manipulation"
    ^colWidths!
connectColNum: colNum
    " Toma el tipo, nombre y opcionalmente aloca el buffer para el campo"
    | fieldName tupleMap|

    fieldName := colNames at: colNum
        put: (self library qeColName: lastHstmt colnum: colNum) "asSymbol".
    tupleMap := map notNil ifTrue: [ map tupleMap ] ifFalse: [Dictionary new].
    (tupleMap includesKey: fieldName)
            ifTrue: [
                colTypes at: colNum  put: (self fieldTypeConversion: colNum).
                colWidths at: colNum  put: (self library qeColWidth: lastHstmt colnum: colNum ).

                (map tupleMap at: fieldName) conversionClass isNil ifFalse: [
                            (colTypes at: colNum )
                                key: #toObject:class:;
                                value: (map tupleMap at: fieldName) conversionClass
                ]
            ].! 
fieldIndex: aName
    "Finds the index number of the field named aName"
    | result |

    (result := self colNames indexOf: aName) = 0 ifTrue: [
        self error:  aName, ' Field not found'
    ].
    ^result.! 
fieldTypeConversion: fieldNumber
    | type conversionArray |
    "
    QELIB Data Types returned by qeColType
    CHAR            1     Blank padded fixed length string
    VARCHAR        2     Variable length string
    DECIMAL        3     BCD number
    INTEGER        4     4-byte signed integer
    SMALLINT        5     2-byte signed integer
    FLOAT            6     4-byte floating point
    DOUBLEPRECISION    7     8-byte floating point
    DATETIME        8     26-byte date time value YYYY-MM-DD HH:MM:SS.FFFFFF

    Native data types returned by qeColDBType (can also return 1-8)
    LONGVARCHAR        100     Large text fields
    BINARY        101     Fixed length binary or raw data
    VARBINARY        102     Variable length binary data
    LONGVARBINARY        103     Large binary data fields
    NATIONALCHAR        104     Fixed length char strings may
                     have 2-byte chars (e.g. Kanji)
    VARNATIONALCHAR    105     Variable length national strings
    LONGVARNATIONALCHAR    106     Large national strings
    NUMERIC        107     Numeric, no fixed scale
    BIGINT        108     8-byte signed integer
    TINYINT        109     1-byte signed integer
    BIT            110     Bit value (0 or 1)
    DATE            111     Date
    TIME            112     Time
    RECID            113     Unique row ID
    RECVER        114     Row version number
    SERIAL        115     Automatically generated sequential number
    MONEY            116     Money
"
    type := (self library qeColDBType: lastHstmt colnum: fieldNumber).
    conversionArray := #( toString:class: toString:class:
                        toNumber:class: toNumber:class:
                        toNumber:class: toNumber:class:
                        toNumber:class: toDateTime:class:).
    ^type = 103 ifTrue: [
            Association
                     key: #toBlob:class:
                     value: nil
    ] ifFalse: [
            Association
                     key: (conversionArray at: (self library qeColType: lastHstmt colnum: fieldNumber))
                     value: nil
    ]!   
formatted: anObject as: aClass
    | block result |
    ToString isNil ifTrue: [self class initialize].
    block := ToString
            at: (aClass isNil ifTrue: [anObject class] ifFalse: [aClass])
            ifAbsent: [ [:value |
                (value respondsTo: #number) ifTrue: [value number printString] ]].
    ^(result :=block value: anObject) isNil
         ifTrue: ['NULL' "String new printString" ]
        ifFalse: [result]!  
fromObject: anObject
    "Convierte un objeto a una tupla"
    | index value |

    fields atAllPut: nil.
    map tupleMap associationsDo: [:each |
        index := self fieldIndex: each key.
        value := self
            formatted: (anObject perform: each value getMessage)
            as: each value conversionClass.
        self at: index put: value.
    ].!  
fromStatement: hstmt
    "Levanta y convierte la tupla a un objeto de la clase indicada por el mapping"

    ^self fromStatement: hstmt on: (map notNil ifTrue: [map mappedClass new])!
fromStatement: hstmt on: obj
    "Levanta y convierte la tupla a un objeto de la clase indicada por el mapping"
    | result number aClass i instance instValue |

    aClass := map notNil ifTrue: [ map mappedClass ].
    self statement: hstmt.

    (obj respondsTo: #number)
    ifTrue: [
        number := self library
                    qeValChar: hstmt
                    colnum: (self fieldIndex: aClass keyField)
                    fmtstring: '' asParameter maxlen: 0.
        result := Relation catchedObjectOfClass: aClass number: number.
        result notNil ifTrue: [^result].
    ].

    self loadFields: hstmt.
    obj isNil ifTrue: [ ^fields ].

    "levanta los campos que estan mapeados solamente"

    map tupleMap associationsDo: [:each |
        i := self fieldIndex: each key.
        instValue := fields at: i.

        instance := self
            perform: (colTypes at: i) key
            with:  instValue
            with: (colTypes at: i) value.

        obj perform: each value setMessage with: instance.
    ].

    Table addToCache: obj.

    ^obj!
lastHstmt
    "Returns the instance var of the receiver
     for external manipulation"
    ^lastHstmt!
library
    "Returns the instance var of the receiver
     for external manipulation"

    library isNil ifTrue: [ library := QELibDLL library ].
    ^library!  
loadFields: hstmt
    1 to: fields size do: [:each |
        fields at: each put:
                (self library qeValChar: hstmt colnum: each
                    fmtstring: '' asParameter maxlen: 0).
    ]!   
map
    "Returns the instance var of the receiver
     for external manipulation"
    ^map!
map: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    map := anObject!   
size

    ^fields size! 
size: anInteger

    fields := Array new: anInteger.
    colNames := Array new: anInteger.
    colTypes := Array new: anInteger.
    colWidths := Array new: anInteger.! 
statement: hstmt
    "Toma el nuevo  statement, e inicializa para recibir las nuevas columnas
     de la tabla"
    | cols  |
    hstmt isNil ifTrue: [
        self size: 0.
        lastHstmt := hstmt .
        ^self
    ].
    lastHstmt = hstmt ifFalse: [
        lastHstmt := hstmt .
        self size: (cols := self library qeNumCols: lastHstmt).
        "encontrar todos los nombres del los fields"
        1 to: cols do: [ :i |
            self connectColNum: i
        ].
    ].! 
toBlob: anObject  class: aClass
    ^anObject asString!  
toDateTime: anObject class: aClass

    anObject size < 6 ifTrue: [^nil].
    anObject = '01/01/80' ifTrue: [^nil].
    anObject = '01-01-80' ifTrue: [^nil].
    ^Date fromString: anObject.


"
inst := Date fromStringDMY: inst.
Convert to Time
inst := Time hours: (inst copyFrom: 1 to: 2) asInteger
            minutes: (inst copyFrom: 4 to: 5) asInteger
            seconds: (inst copyFrom: 7 to: 8) asInteger.
"!  
toNumber: anObject class: aClass
    " Nota no se soporta convertir desde BCD "
    ^anObject asNumber! 
toObject: anObject  class: aClass
    " Se convierte a un objeto de clase aClass (puede ser un proxy) "
    | block |
    anObject size =0 ifTrue: [^nil].
    FromString isNil ifTrue: [self class initialize].

    block := FromString at: aClass
            ifAbsent: [ [:value | (Smalltalk at: #RDBMSProxyObject) new
                                        class: aClass
                                        number: value]].
    ^block value: anObject! 
toString: anObject  class: aClass
    ^anObject asString! !

! SoftwareProtection class methods !  
run
    ^self new run!   
test
    ^self new test! !

! SoftwareProtection methods ! 
profiler
    "Returns the default profiler for the receiver"
    | profiler |
    profiler := super profiler.
    profiler applicationName: 'Protection'.
    ^profiler! 
run
    "Private - Runs the protection software test.
     The receiver must abort Smalltalk
         if testing failed"

    ^self implementedBySubclass!   
test
    "Runs the protection software test.
     Check for protection enable flag
        and run test if needed"

    (self profiler at: 'Enable') = 'No' ifFalse: [self run].!
warning: aLabel
    "Private - An Error Has Occurred during testing.
     ReportIt to the user and exits gracefully..."

    ModalMessageBox warning: aLabel.

    "*WARNING* Only aborts during runtime version"
    Smalltalk isRunTime
    ifTrue: [ Smalltalk exit ]! !

! DateProtection methods ! 
deadTime
    "Private - Returns the number of days that
     the software will be running ok"
    ^30 "days of life..."!   
directory: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    directory := anObject!   
fileName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    fileName := anObject! 
initialize
    "Private - Initializes the receiver"

    super initialize.
    self
        directory: Disk;
        fileName: ObjectStyleDLL fileName! 
run
    "Private - Runs the protection software test"
    | date lines |

    lines := directory formatted: fileName.
    lines isEmpty ifTrue: [^self warning: 'File not Found : ',fileName].
    date := Date fromString: (lines first at: 3).
    (date addDays: self deadTime) < Date today
    ifTrue: [ ^self warning: 'Evaluation time has expired.' ].! !

! SentinelPro class methods !
initialize
    "Private - Initialize the receiver...
    SentinelPro initialize.
    "

    Table := TableStream := nil! 
table
    ^Table! !

! SentinelPro methods !   
buildTable
    "Initializes the receiver"
    | value |
    Table := OrderedCollection new.
    Object withAllSubclasses do: [:each|
        (#(0 -1) includes: (value := self valueFor: each name))
        ifFalse: [
            Table add: (OrderedCollection
                 with: each name with: value)
        ]
    ].
    Table isEmpty
    ifTrue: [
        ^self warning: 'Provablemente el bloque de proteccin este desconectado...'
    ].
    TableStream := ReadWriteStream on: Table.! 
checkTable
    "Check receiver's integrity adding needed
         values if wrong value returned"
    | value string |
    value := self valueFor: (string := self nextString).
    (self validate: string with: value)
    ifFalse: [
        Table do: [:each|
            each first = string
            ifTrue: [
                each add: value.
                ^self
            ]
        ]
    ]!
initialize
    "Private - Initialize the receiver."

    super initialize.
    Table size = 0
        ifTrue: [self buildTable]
        ifFalse: [
            Smalltalk isRunTime
            ifFalse: [ self checkTable ]
        ]!   
nextString
    "Private - Runs the next string to be tested"
    TableStream atEnd ifTrue: [TableStream reset].
    TableStream atEnd ifTrue: [^String new].
    ^TableStream next first! 
register
    "Register the current protection block"

    Table size = 0
    ifTrue: [ self buildTable ].
    Table size = 0 ifTrue: [^nil].
    TableStream reset.
    [TableStream atEnd] whileFalse: [
        self checkTable
    ].!
run
    "Private - Runs the protection software test"
     | string result |

    TableStream size = Table size
    ifFalse: [TableStream := ReadWriteStream on: Table].

    result := self valueFor: (string := self nextString).
    (self validate: string with: result)
    ifFalse: [^self warning: 'Invalid Sentinel block']! 
validate: string with: result
    "Private - Validates the string with the result for correct matching"

    (#(0 -1) includes: result)
    ifTrue: [
            self warning: 'Sentinel Block not found'.
            ^false
    ].
    Table do: [:each|
            each first = string
            ifTrue: [ ^each includes: result ]
    ].
    ^false! 
valueFor: aString
    "Returns the value for string aString"
    aString size > 3 ifFalse: [^-1].
    ^SentinelProDLL library query: aString asParameter16! !

! OSSoftwareProtection class methods !
register
    "Register the current protection block"

    self new register! !

! OSSoftwareProtection methods ! 
initialize
    "Private - Initialize the receiver."

    self loadTable.
    super initialize.!   
keyFileName
    "Private - Returns the keys file name"
    ^(ObjectStyleDLL fileName upTo: $.),'.OVK'!  
loadTable
    "Private - Try to load the receiver's registered table."

    | path table |
    path := self keyFileName.
    (File exists: path)
    ifFalse: [
        ^self warning:
            'Archivo de configuracin ',
            (Smalltalk isRunTime ifFalse: ['"',path,'" '] ifTrue: [String new]),
            'no encontrado'
    ].
    table := ObjectFiler loadAllFromPathName: path.
    table size = 0
    ifTrue: [^self warning: 'Archivo de configuracin corrupto'].
    Table := table asOrderedCollection.
    TableStream := ReadWriteStream on: Table.!   
register
    "Register the current protection block"

    super register.
    ObjectFiler dump: Table asArray newFile: self keyFileName!  
warning: aLabel
    "Private - An Error Has Occurred during testing.
     Check for DateProtection...
     Do some funny actions..."

    | bmp box |
    "Play with the screen"
    box := Display boundingBox.
    box := box leftBottom - (0@50) rightBottom: box rightBottom.
    bmp := Bitmap fromScreen: box.
    bmp displayAt: box origin - (3@0).
    bmp release.
    UserLibrary messageBeep: 0.
    ModalMessageBox warning: aLabel.

    DateProtection run.

    "
    ^super warning: aLabel
    "! !

! StReader class methods !
fileIn
    "Lets the user select a file and perform
     fileIn on it..."
    | dialog file |
    dialog := FileDialog new.
    dialog
        addSmalltalkFileFilters;
        openFile.
    file := dialog file.
    file isNil ifTrue: [^nil].
    ^self fileIn: file!   
fileIn: aStream
    "File in the contents of aStream into this image.
     aStream can be a Stream or a fileName"
    | file result |
    (aStream isKindOf: Stream)
    ifTrue: [^self new fileIn: aStream].
    file := File pathName: aStream.
    result := self fileIn: file.
    file close.
    ^result!  
new
    ^super new
        initialize;
        yourself! !

! StReader methods ! 
collectMethod: aCompiledMethod into: aCollection
    "Private - Scan a collection for a method similar to aCompiledMethod,
        if found replaces it by aCompiledMethod if not add it to the collection"
    | mth |
    1 to: aCollection size do: [:index|
        mth := aCollection at: index.
        (mth selector == aCompiledMethod selector
        and: [ mth classField == aCompiledMethod classField ])
        ifTrue: [
            ^aCollection at: index put: aCompiledMethod
        ].
    ].
    ^aCollection add: aCompiledMethod! 
evaluate: aString
    "Private - Ask the user if the code in aString must be filled in..."
    (MessageBox confirm: ('File in this code chunk ?\\' withCrs, aString))
    ifTrue: [ Compiler evaluate: aString]!   
fileIn: aStream
    "File in the contents of aStream into this image..."
    | cursor toBeFiledIn chunk |
    cursor := Cursor.
    CursorManager execute change.
    [aStream atEnd or: [aStream peek isSeparator not ]] whileFalse: [aStream next].
    [aStream atEnd] whileFalse: [
            toBeFiledIn := aStream peekFor: $!!.
            chunk := aStream nextChunk.
            toBeFiledIn
                ifTrue: [self fileIn: chunk from: aStream]
                ifFalse:[self evaluate: chunk]].
    self performRealFileIn.
    CursorManager normal change.!   
fileIn: aString from: aFile
    "Private - Scan aString for selected class and fileIn aFile contents upTo nul chunk..."
    | stream chunk answer old |
    self getClassFrom: aString.
    [(chunk := aFile nextChunk) isEmpty]
    whileFalse:[
            answer := Compiler
                compile: chunk
                in: selectedClass.
            answer notNil
            ifTrue: [
                answer value sourceString: chunk.
                old := answer isNil
                    ifTrue: []
                    ifFalse: [selectedClass compiledMethodAt: answer key].
                old isNil
                ifTrue: [self collectMethod: answer value into: contents]
                ifFalse: [
                    old sourceString = answer value sourceString
                    ifFalse: [self collectMethod: answer value into: contents]
                ]
            ]
    ].!   
fileOutMethods: aCollection into: aStream
    "Private - FileOut the sources of aCollection of methods into aStream"
    aCollection do: [:mth|
        aStream
            cr;cr;
            nextPut: $!!;
            nextPutAll: mth classField name;
            space;
            nextPutAll: 'methods !!';
            cr;
            nextChunkPut: mth sourceString;
            nextPutAll: ' !!'; cr
    ].!  
getClassFrom: aString
    "Private - Scan aString looking for selected class..."
    | stream words |
    stream := ReadStream on: aString trimBlanks.
    words := OrderedCollection new.
    [stream atEnd] whileFalse: [words add: stream nextWord].
    words last isNil ifTrue: [words removeLast].
    words last = 'methods' ifTrue: [words removeLast].
    selectedClass := Smalltalk at: words first asSymbol ifAbsent: [^self error: 'Class not found : ', words first].
    words removeFirst.
    [words isEmpty] whileFalse: [selectedClass := selectedClass perform: words removeFirst asSymbol].
    ^selectedClass!   
initialize
    "Private - Initializes the receiver..."

    contents := OrderedCollection new: 500.!   
performRealFileIn
    "Private - Places the compiled code..."
    | replacedMethods newMethods old |
    replacedMethods := OrderedCollection new: contents size.
    newMethods := OrderedCollection new: contents size.
    contents do: [:each|
        old := each classField compiledMethodAt: each selector.
        old isNil
        ifTrue: [ newMethods add: each ]
        ifFalse: [ replacedMethods add: each ]
    ].

    self
        promptFileIn: newMethods as: 'New filledIn methods';
        promptFileIn: replacedMethods as: 'FilledIn patches & touched methods';
        yourself!   
promptFileIn: aCollection as: aLabel
    "Private - Prompt for the collection to be filled in..."
    | stream |
    (MessageBox confirm: 'Perform fileIn of the ',aLabel,' ?')
    ifTrue: [
        aCollection do: [:each|
            each classField
                addSelector: each selector
                withMethod: each.
             Smalltalk
                logSource: each sourceString
                forSelector: each selector
                inClass: each classField.
        ].
        MethodBrowser new
            label: aLabel;
            openOn: aCollection asArray.
    ]
    ifFalse: [
        stream := WriteStream on: (String new: 10000).
        self fileOutMethods: aCollection into: stream.
        TextWindow new
            label: aLabel , ' sources (not filledIn Yet...)';
            openOn: stream contents
    ].! !

! TipOfTheDay class methods !   
created
    "Returns the tips of the day included in the default file"

    ^self includedIn: self defaultPathName!
decript: aString
    "Private - Decript aString and returns the decripted value"

    ^self encript: aString!  
defaultPathName
    "Returns the default pathName of the receiver's instances"
    ^'Tips.Dat'! 
encript: aString
    "Private - Encript aString and returns the encripted value"

    | input output byte |
    input := ReadWriteStream on: aString asByteArray.
    output := ReadWriteStream on: (String new: aString size).
    [input atEnd] whileFalse: [
        byte := 255 - input next.
        output nextPut: byte asCharacter
    ].
    ^output contents! 
forToday
    "Returns the tip of the day for today"
    ^self new
        index: Date today dayOfMonth;
        yourself! 
getIndexFrom: pathName
    "Private - Returns the indexes included in a file named pathName"

    | file cole |
    cole := Set with: 0.
    (File exists: pathName) ifFalse: [#()].
    file := File pathName: pathName.
    1 to: self maxTips do: [:i|
        file atEnd
        ifFalse: [
            file nextULong = 0 "get offset"
            ifFalse: [ cole add: i ].
            file next. "get attribute"
        ]
    ].
    file close.
    cole remove: 0.
    ^cole! 
hookSize
    "Private - Returns the hook size"
    ^5 "bytes  4-ULong 1-attribute"! 
includedIn: pathName
    "Returns the tips of the day included in a file named pathName"

    | cole |
    cole := self getIndexFrom: pathName.
    ^cole asSortedCollection asArray
        collect: [:index|
            self new
                pathName: pathName;
                index: index;
                yourself
        ]!  
maxTips
    "Returns the maximum number of tips holded by a file"
    ^31!  
pack: pathName
    "Pack the tips in the file pathName..."

    | tips |
    pathName isNil
    ifTrue: [^self pack: self defaultPathName].
    tips := self includedIn: pathName.
    tips do: [:each | each fileIn ].
    File remove: pathName ifAbsent: [].
    tips do: [:aTip | aTip fileOut ]! !

! TipOfTheDay methods !   
centered
    "True if the receiver will be displayed centered"

    contents isNil ifTrue: [ self fileIn ].
    ^(attributes bitAnd: 1) ~= 0! 
centered: aBoolean
    "Set the flag to store the receiver centered"

    contents isNil ifTrue: [ self fileIn ].
    attributes := aBoolean
        ifTrue: [ attributes | 1 ]
        ifFalse: [ attributes bitAnd: 2r11111110 ]! 
contents
    "Returns the instance var of the receiver
     for external manipulation.
    If it's nil try to load the receiver from file named pathName
    "
    contents isNil ifTrue: [ self fileIn ].
    ^contents!   
contents: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    contents := anObject! 
cripted
    "True if the receiver will be stored in cripted mode"

    contents isNil ifTrue: [ self fileIn ].
    ^(attributes bitAnd: 2) ~= 0!  
cripted: aBoolean
    "Set the flag to store the receiver in cripted mode"

    contents isNil ifTrue: [ self fileIn ].
    attributes := aBoolean
        ifTrue: [ attributes | 2 ]
        ifFalse: [ attributes bitAnd: 2r11111101 ]!   
fileIn
    "Private - Files the receiver's in for file named pathName"

    | file offset |
    pathName isNil ifTrue: [^nil].
    (File exists: pathName) ifFalse: [^nil].
    file := File pathName: pathName.
    offset := self peekOffsetFrom: file.
    offset = 0 | offset isNil
    ifTrue: [ contents := nil ]
    ifFalse: [
        file position: offset.
        contents := file upTo: 0 asCharacter.
        self cripted ifTrue: [
            contents := self class decript: contents
        ].
    ].
    file close.!   
fileOut
    "Private - Save the receiver's contents into file named pathName"

    | file offset used |
    pathName isNil | contents isNil
    ifTrue: [^nil].
    index isNil ifTrue: [
        used := self class getIndexFrom: pathName.
        index := (1 to: self class maxTips)
            detect: [:i| (used includes: i) not ]
            ifNone: [ ^self error: 'No hay ms lugar en el archivo "',pathName,'"' ].
    ].
    file := File pathName: pathName.
    file atEnd ifTrue: [
        "build file header"
        self class maxTips
        timesRepeat: [ file next: self class hookSize put: 0 asCharacter ]
    ].
    file setToEnd.
    offset := file position.
    file
        nextPutAll: (self cripted
            ifTrue: [self class encript: contents asString]
            ifFalse: [contents asString]);
        nextPut: 0 asCharacter;
        position: index - 1 * self class hookSize;
        nextFourBytesPut: offset;
        nextPut: (attributes isNil
            ifTrue: [0] ifFalse: [attributes]) asCharacter;
        close.! 
index: anInteger
    "Sets the receiver's integer"

    anInteger isNil
    ifTrue: [
        index := nil.
        ^self
    ].
    index := anInteger \\ self class maxTips.
    index = 0 ifTrue: [ index := 1 ].!
initialize
    "Private - Initializes the receiver"

    super initialize.
    pathName := self class defaultPathName.
    attributes := 0.! 
pathName
    "Returns the instance var of the receiver
     for external manipulation"
    ^pathName!  
pathName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    pathName := anObject! 
peekOffsetFrom: aStream
    "Private - Reads the receiver's contents offset from aStream"

    | seekSize offset |
    seekSize := self class hookSize.

    aStream size < (index * seekSize) ifTrue: [^nil].

    aStream position: index - 1 * seekSize.
    offset := aStream nextULong.
    attributes := aStream next asciiValue.
    ^offset! !

! VFWObject class methods !  
from: aVFWObject
    "Returns an instance of the receiver initialized with aVFWObject library"

    ^self new
        library: aVFWObject library;
        yourself! !

! VFWObject methods !  
initializeLibrary
    "Private - The receiver must initialize it's library for api calls.
    This method must be implemented by subclasses..."

    ^self implementedBySubclass! 
library
    "Returns the instance var of the receiver
     for external manipulation;
    if it's nil then it will be initialized with
    the current library instance"

    library isNil ifTrue: [ self initializeLibrary ].
    ^library!  
library: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    library := anObject!   
returnInteger: aResult
    "Private - Converts an API 'long' result to an integer.
    (API long returns a string in St/V20)"

    aResult isString ifFalse: [ ^aResult asInteger ].
    ^(WinLong fromString: aResult) asInteger!   
withPointersTo: someVFWObjects do: aBlock
    "Private - Evaluates a Block with a structure holding pointers to handles
    or someVFWObjects. aBlock must be a one-Param block.
    When evaluated aBlock parameter will be a pointer to array memory.
    Memory will be released when aBlock ends evaluation..."

    | type dict struct idDict array max |
    "Build structure for holding pointers..."
    type := Array with: (
            Array
                with: #values
                with: (Array with: someVFWObjects size with: '*WinAddress' )
    ).
    dict := self library class registerDictionaryFor: type.
    idDict := IdentityDictionary new.
    max := Association key: nil value: #(0 0).
    dict associationsDo: [:asoc|
        idDict
            at: asoc key put: asoc value;
            at: (asoc key,(String with: $:)) asSymbol put: asoc value.
        asoc value first >= max value first ifTrue: [ max := asoc ]
    ].
    idDict
        at: #sizeInBytes
        put: max value first
            + (SelfDefinedStructure sizeInBytesFor: (max value at: 2)).

    struct := SelfDefinedStructure new: (idDict at: #sizeInBytes).
    struct definition: idDict.

    "Set structure values..."
    array := struct values.
    1 to: someVFWObjects size do: [:i|
        array at: i put: (someVFWObjects at: i) handle
    ].

    "Now evaluates aBlock..."
    ^self library withPointerTo: struct do: aBlock! !

! DrawDib class methods !
using: aPen
    "Returns an instance of the receiver for working with aPen"

    ^self new
        drawUsing: aPen;
        yourself! !

! DrawDib methods !   
asParameter
    "Returns the receiver as aParameter
     to be passed to an API call"

    ^handle!   
close
    "Close the receiver..."

    self closeDrawDib.
    handle := pen := nil.!  
closeDrawDib
    "Private - Close drawDIB library if needed"

    self isValid ifFalse: [ ^self ].
    self library
        drawDibEnd: self asParameter;
        drawDibClose: self asParameter.!  
destination
    "Returns the instance var of the receiver
     for external manipulation"
    ^destination!
destination: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    destination := anObject!   
deviceContext
    "Private - Returns the current display context.
     Generates an error if the receiver does not have a pen..."

    pen isNil ifTrue: [ ^self error: 'The pen is nil and can''t be used' ].

    ^pen handle!
display: aDib
    "Display aDIB using the current pen at destination...
    Returns true if success"

    | sourceRect destRect result |

    self deviceContext isNil ifTrue: [ ^false ].

    self isValid ifFalse: [ self openDrawDib ].

    sourceRect := source isNil
        ifTrue: [ aDib boundingBox ]
        ifFalse: [ source ].
    destRect := destination isNil
        ifTrue: [ aDib boundingBox ]
        ifFalse: [ destination ].

        self library withPointerTo: aDib bitmapInfo do: [:lpbi|
            self library withPointerTo: aDib bits do: [:lpBits|
                result := self library
                    drawDibDraw: self asParameter
                    hdc: self deviceContext asParameter
                    xDst: destRect left yDst: destRect top
                    dxDst: destRect width dyDst: destRect height
                    lpbi: lpbi asParameter lpBits: lpBits asParameter
                    xSrc: sourceRect left ySrc: sourceRect top
                    dxSrc: sourceRect width dySrc: sourceRect height
                    wFlags: DdfBackgroundpal
            ]
        ].

    ^result! 
display: aDib using: aPen
    "Display aDIB using a new pen aPen..."

    ^self
        drawUsing: aPen;
        display: aDib!  
drawUsing: aPen
    "Set the receiver for drawing with a pen.
    Release old settings if needed"

    aPen = pen ifTrue: [ ^self ].
    (self isValid and: [ pen notNil ])
    ifTrue: [ self close ].
    pen := aPen.!  
drawWith: aPen
    "Set the receiver for drawing with a pen.
    Release old settings if needed"

    ^self drawUsing: aPen!  
initializeLibrary
    "Private - The receiver must initialize it's library for api calls."

    library := DrawDibDLL library.
    library isNil ifTrue: [ self error: 'DrawDib Library not found.'. ].!  
isValid
    "True if the receiver is valid"

    ^handle notNil and: [ handle asInteger ~= 0 ]!
openDrawDib
    "Private - Open drawDIB library.
    Returns true if successfull"

    self closeDrawDib.
    handle := self library drawDibOpen.
    ^self isValid!
paletteChanged
    "The receiver MUST be notified about palette changes
    in the window that it's drawing..."

    (self isValid and: [ pen notNil ]) ifFalse: [ ^self ].
    self realizePalette: true.
    pen graphicsMedium isWindow
    ifTrue: [ pen graphicsMedium invalidateRect: nil ].!
pen
    "Returns the instance var of the receiver
     for external manipulation"
    ^pen!
queryNewPalette
    "The receiver MUST be notified about palette changes
    in the window that it's drawing..."

    (self isValid and: [ pen notNil ]) ifFalse: [ ^self ].
    self realizePalette: false.
    pen graphicsMedium isWindow
    ifTrue: [ pen graphicsMedium invalidateRect: nil ].!  
realizePalette: aBoolean
    "Private - Realize the palette into DC in use..."

    self library
        drawDibRealize: self asParameter
        hdc: self deviceContext asParameter
        fBackground: aBoolean!
release
    "Release the receiver's allocated resources."

    super release.
    self close.!
source
    "Returns the instance var of the receiver
     for external manipulation"
    ^source!  
source: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    source := anObject! !

! VirtualDIB class methods !   
fileNamed: pathName
    "Private - Returns a file stream named 'pathName'."

    ^(File pathName: pathName) asByteFileStream!  
fromFile: pathName
    "Returns an instance of the receiver supported by the file.
    Returns nil if failed..."

    ^self pathName: pathName!   
pathName: pathName
    "Returns an instance of the receiver
    supported by the file named 'pathName'.
    Returns nil if failed..."

    (File exists: pathName) ifFalse: [^nil].
    ^self new fileInFrom: (self fileNamed: pathName)! !

! VirtualDIB methods !   
align: number to: factor
    "Private -  Allign the value number to factor"
    ^factor - 1 + number // factor * factor!
boundingBox
    ^0@0 extent: self extent!
cachedDIBFor: aRectangle
    "Private - Returns a DIB to be filled in when performing receiver's crops..."

    | bmi bits lineWidth dib |
    bitmapInfo bitCount = 8 ifFalse: [ ^self notImplementedYet ]. "only 8bpp implemented..."
    self isValid ifFalse: [^nil].

    dibCache isNil ifFalse: [ "use catched dib..."
        dibCache extent = aRectangle extent ifTrue: [ ^dibCache ].
    ].

    "invalidate old cached instances..."
    dibCache release.
    lastOrigin := nil.

    bmi := WinBitmapInfo fromBytes: bitmapInfo contents.
    bits := ByteArray new: (self align: aRectangle width to: 4)* aRectangle height.
    bmi
        width: aRectangle width;
        height: aRectangle height;
        sizeImage: bits size;
        yourself.
    dib := DIB new.
    dib
        bitmapInfo: bmi;
        bits: bits.

    useCache = true ifTrue: [ dibCache := dib ].

    ^dib!   
checkLineCacheSize
    "Private - Check line chache size for insertion of a new line..."

    maxCachedLines <= cachedLines size
    ifTrue: [
        " destroy all cache...
        cachedLines keysDo: [:key|
            cachedLines removeKey: key.
            maxCachedLines > cachedLines size ifTrue: [^self].
        ]
        "
        cachedLines := Dictionary new.
    ]! 
dibFor: aRectangle
    "Returns a DIB obtained from croping the receiver to aRectangle,
    or nil if failed..."

    | dib scan width cropWidth i height scanNumber |

    dib := self cachedDIBFor: aRectangle.
    dib isNil ifTrue: [^nil].
    lastOrigin = aRectangle origin ifTrue: [ ^dib ].

    width := self align: bitmapInfo width to: 4.
    cropWidth := self align: aRectangle width to: 4.
    height := self height.
    aRectangle top to: aRectangle bottom - 1 do: [:y|
        i := aRectangle bottom - y - 1.
        self
            extract: height - y * width
            at: aRectangle left + 1
            into: dib bits
            from: i * cropWidth + 1"one-indexed"
            to: i + 1 * cropWidth
    ].
    lastOrigin := aRectangle left @ aRectangle top.

    ^dib! 
extent
    ^self width @ self height - 1!
extract: scanNumber at: offset into: dibBits from: start to: stop
    "Private - Move a scan line portion into a destination DIB bits"

    | line |
    maxCachedLines > 0
    ifTrue: [
        line := self scanLine: scanNumber.
        line notNil
        ifTrue: [
            dibBits
                replaceFrom: start
                to: stop
                with: line
                startingAt: offset.
            ^line
        ]
    ].

    source
        position: scanNumber + offset + bitsOffset;
        getBytesFor: dibBits
        from: start
        to: stop! 
fileInFrom: aStream
    "Private - Initialize the receiver from stream aStream.
    Returns the receiver or nil if failed..."

    | origin bytes bitmap rgbColor clrUsed colors bfh |
    aStream atEnd ifTrue: [ ^nil ].
    bfh := DIB readFileHeader: aStream.
    bfh bfType  = 'BM' ifFalse: [ ^self error: 'Invalid file format' ].
    aStream atEnd ifTrue: [ ^nil ].
    origin := aStream position.
    bitmapInfo := self readBitmapHeader: aStream.
    bitmapInfo bitCount > 8 " = 24 no color table for >8 bits bmps... "
    ifFalse: [
            clrUsed := bitmapInfo clrUsed.
            clrUsed = 0 ifTrue: [ clrUsed := 1 bitShift: bitmapInfo bitCount ].
            colors := ByteArray new: clrUsed * 4.
            aStream getBytesFor: colors.
            clrUsed = (1 bitShift: bitmapInfo bitCount)
            ifTrue: [ rgbColor := colors ]
            ifFalse: [
                rgbColor := ByteArray new: (1 bitShift: bitmapInfo bitCount) * 4.
                rgbColor replaceFrom: 1 to: colors size with: colors startingAt: 1.
            ]
    ].

    bitmapInfo sizeImage = 0
    ifTrue: [
        bytes := (((
            bitmapInfo width * bitmapInfo bitCount) + 31) // 32 * 4) * bitmapInfo height]
    ifFalse: [bytes := bitmapInfo sizeImage].

    "Ale Patch..."
    aStream position: origin + bitmapInfo size + colors size.
    bitsOffset := aStream position.
    self source: aStream.

    bitmapInfo :=
        rgbColor isNil
            ifTrue: [WinBitmapInfo new contents: bitmapInfo contents]
             ifFalse: [
                WinBitmapInfo new contents: bitmapInfo contents, rgbColor].!  
height
    ^bitmapInfo height!   
initialize
    "Private - Initializes the receiver..."

    super initialize.
    self
        useCache: true;
        maxCachedLines: 0
            "don't  cache lines by default.
             It can be wrong if image is very big.
            Used memory for caching:
                maxCachedLines * self width
            "!
isValid
    "Returns true if the receiver is valid..."
    ^source notNil!  
maxCachedLines
    "Returns the instance var of the receiver
     for external manipulation"
    ^maxCachedLines!  
maxCachedLines: anInteger
    "Sets the maximum number of scan lines to catch in source..."

    maxCachedLines := anInteger.
    cachedLines := nil. "destroy current cache if present..."!  
readBitmapHeader: bitmapFile
        "Private - Read the bitmap info header structure from a
         bitmapFile. Answer an instance of WinBitmapInfoHeader."
    | bih |
    bih := WinBitmapInfoHeader new.
    bih size: bitmapFile nextULong;
        width:  bitmapFile nextULong;
        height: bitmapFile nextULong;
        planes: bitmapFile nextUShort;
        bitCount: bitmapFile nextUShort;
        compression: bitmapFile nextULong;
        sizeImage: bitmapFile nextULong;
        xPelsPerMeter: bitmapFile nextULong;
        yPelsPerMeter: bitmapFile nextULong;
        clrUsed: bitmapFile nextULong;
        clrImportant: bitmapFile nextULong.
    ^bih!  
release
    " Release receiver's resources..."

    self isValid ifTrue: [
        source close
    ].
    super release.!  
scanLine: scanNumber
    "Private - Returns the current catched line number scanNumber"

    | line start |
    cachedLines isNil ifTrue: [
        cachedLines := Dictionary new
    ].

    ^cachedLines
        at: scanNumber
        ifAbsent: [
            line := ByteArray new: (self align: bitmapInfo width to: 4).
            source
                position: scanNumber + bitsOffset;
                getBytesFor: line from: 1 to: line size.
            self checkLineCacheSize.
            cachedLines at: scanNumber put: line.
            ^line
        ]!   
source: aStream
    "Private - Sets the receiver's source file..."

    source := aStream.

    "flush caches..."
    self
        useCache: self useCache;
        maxCachedLines: self maxCachedLines;
        yourself!   
useCache
    "Returns the instance var of the receiver
     for external manipulation"
    ^useCache!  
useCache: aBoolean
    "Sets the receiver to perform dib bits catching.
    WARNING: when using bits cache the builded DIBs
     can have the save bits information..."

    useCache := aBoolean.
    dibCache := nil. "destroy current cache if present..."!  
width
    ^bitmapInfo width! !

! WinProfiler class methods !  
forApplication
    "Returns an instance of the receiver for
     application profiling"
    | profiler application |
    profiler := self new.
    application := Smalltalk
        at: #StartUpApplication
        ifAbsent: [].
    profiler pathName:
        ((application notNil
            and: [application respondsTo: #profilePathName])
        ifTrue: [
                application profilePathName
        ] ifFalse: [
            'VApp.Ini'
        ]).
    ^profiler!   
new
    "Returns an instance of the receiver initrialized"
    ^super new
        initialize;
        yourself! !

! WinProfiler methods !  
applicationName
    "Returns the instance var of the receiver
     for external manipulation"
    ^applicationName!
applicationName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    applicationName := anObject!   
at: aKey
    "Gets the value at aKey in the profile file.
     Default answer will nil..."
    | result count |
    result := (String new: maxProfileStringSize) asParameter.
    count := pathName isNil
    ifTrue: [ "Stored in Win.Ini"
        KernelLibrary
            getProfileString: applicationName asParameter
            keyName: aKey asParameter
            default: 'nil' asParameter
            returnedString: result size: result size
    ]
    ifFalse: [ "Stored in private Profile"
        KernelLibrary
            getPrivateProfileString: applicationName asParameter
            keyName: aKey asParameter
            default: 'nil' asParameter
            returnedString: result size: result size
            fileName: pathName asParameter
    ].

    result := result asStream next: count.
    result = 'nil' ifTrue: [^nil].

    ^result!   
at: aKey ifAbsent: aBlock
    "Gets the value at aKey in the profile file.
     If the element does not exist then returns aBlock value..."
    | result |
    result := self at: aKey.
    ^result isNil
        ifTrue: [aBlock value]
        ifFalse: [result]!
at: aKey put: anObject
    "Place anObject text representation in the profile file"
    | toStore |
    toStore := anObject isString
        ifTrue: [anObject]
        ifFalse: [anObject printString].
    ^pathName isNil
    ifTrue: [ "Store in Win.Ini"
        KernelLibrary
            writeProfileString: applicationName asParameter
            key: aKey asParameter
            str: toStore asParameter
    ]
    ifFalse: [ "Store in private Profile"
        KernelLibrary
            writePrivateProfileString: applicationName asParameter
            key: aKey asParameter
            str: toStore asParameter
            fileName: pathName asParameter
    ]!   
initialize
    "Private - Initializes the receiver"

    "Initialize the maximum size spected for profile strings"
    maxProfileStringSize := 2048.

    applicationName := 'Vapp'. "V Application"!   
keys
    "Gets aList of key names in the profile file
     associated to the current applicationName."
    | result count stream line |
    result := (String new: maxProfileStringSize) asParameter.
    count := pathName isNil
    ifTrue: [ "Stored in Win.Ini"
        KernelLibrary
            getProfileString: applicationName asParameter
            keyName: nil
            default: '' asParameter
            returnedString: result size: result size
    ]
    ifFalse: [ "Stored in private Profile"
        KernelLibrary
            getPrivateProfileString: applicationName asParameter
            keyName: nil
            default: '' asParameter
            returnedString: result size: result size
            fileName: pathName asParameter
    ].

    stream := (result asStream next: count) asStream.
    result   := OrderedCollection new.
    [stream atEnd] whileFalse: [
        line := stream upTo: 0 asCharacter.
        line isEmpty ifFalse: [result add: line]
    ].

    ^result asArray!   
objectAt: aKey
    "Gets the value at aKey in the profile file
       evaluated using the compiler.
     Default answer will nil..."
    | evalBlock |
    evalBlock := [:source|
        source isNil
            ifTrue: [nil]
            ifFalse:[Compiler evaluate: source]
    ].
    ^ evalBlock value: (self at: aKey)! 
pathName
    "Returns the instance var of the receiver
     for external manipulation"
    ^pathName!  
pathName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    pathName := anObject! !

! CategoryPattern class methods !  
new: aString
 "use aString as the sourceString all other strings are compared to"
 ^self basicNew build: aString! !

! CategoryPattern methods !  
build: aString
 "compare all inputs with: aString"
 | chr chrAlt rs ws |
 match := OrderedCollection new.
 state := 0.
 fst := false.
 lst := false.
 modus := true.
 rs := ReadStream on: aString.
 ws := WriteStream on: (String new: (aString size)).
 [rs atEnd]
  whileFalse: [
   chr := rs next.
   (chr = $*)
    ifTrue: [ (chrAlt ~= $*)
     ifTrue: [ ws contents size > 0
      ifTrue: [ match add: (ws contents).
       state := state + 1.
       ws reset. ].
      match add: '*'.
      chrAlt := chr. ].
     ]
    ifFalse: [ ws nextPut: chr.
     chrAlt := chr. ].
 ].
 ws contents size > 0
  ifTrue: [ match add: (ws contents).
   state := state + 1.
   ws reset. ].
 compares := OrderedCollection new.
 match do: [ :m |
  m ~= '*'
   ifTrue: [ compares add: m ].
 ].
 (match size > 0)
  ifTrue: [ fst := match first = '*'.
   lst := match last = '*'. ]!
buildGroup: pos of: aString andAddTo: anOC
 "searches for the pattern in 'match at: pos' in string aString"
 | scanPos dif |
 scanPos := self getPositionsOf: (compares at: pos) in: aString.
 anOC isEmpty
  ifTrue: [ dif := 0 ]
  ifFalse: [ dif := anOC last + ((compares at: (pos - 1)) size) - 1].
 scanPos do: [ :i |
  anOC add: (i + dif).
  (pos = state)
   ifTrue: [ matchBlock add: (anOC deepCopy) ]
   ifFalse: [ self buildGroup: (pos + 1) of: (aString copyFrom: ((i + (compares at: pos) size)) to: (aString size)) andAddTo: anOC. ].
  anOC removeLast.
 ]! 
buildGroups
 "build groups using match"
 | tmp |
 matchBlock := OrderedCollection new.
 tmp := OrderedCollection new.
 state > 0
  ifTrue: [ self buildGroup: 1 of: input andAddTo: tmp. ]! 
getPositionsOf: aSource in: aString
 "return position of aSource in aString"
 | pos ok p |
 pos := OrderedCollection new.
 1 to: (aString size - aSource size + 1) do: [ :dif |
  ok := true.
  p := 0.
  aSource do: [ :c |
  (c = $?)
   ifFalse: [ ok := ok and: [ modus ifTrue: [ (aString at: (dif + p)) = c ]
    ifFalse: [ ((aString at: (dif + p)) asUpperCase) = (c asUpperCase) ] ]. ].
  p := p + 1.
  ].
  ok ifTrue: [ pos add: dif ].
 ].
 ^pos!
match: aString
 "check aString"
 | ok chr |
 input := aString.
 (state = 0) & (match size = 1)
  ifTrue: [ ^true ].
 self buildGroups.
 matchBlock size = 0
  ifTrue: [ ^false ].
 ok := false.
 matchBlock do: [ :m |
  ok := ok | (m first = 1).
 ].
 (ok not & fst not)
  ifTrue: [ ^false ].
 ok := false.
 matchBlock do: [ :m |
  ok := ok | (m last = (aString size - (compares last size) + 1)).
 ].
 (lst not)
  ifTrue: [ ^ok].
 ^true!
modus: aBoolean
 "if aBoolean is true then small an capital letters are not differed"
 modus := aBoolean.! !

! ChunkPattern class methods !  
classComment
	^'This class enables full wildcard search machanism'
	"Modified: 11.06.93 / 10.14.40 / T.Lentzsch"!   
classUpdate
	^'
	"Modified: 11.06.93 / 10.14.40 / T.Lentzsch"'
	"Modified: 11.06.93 / 10.14.40 / T.Lentzsch"!  
new: aString
	"use aString as the sourceString all other strings are compared to"

	^self basicNew build: aString! !

! ChunkPattern methods !   
build: aString
	"compare all inputs with: aString"

	| chr chrAlt rs ws |

	match := OrderedCollection new.
	state := 0.
	fst := false.
	lst := false.

	rs := ReadStream on: aString.
	ws := WriteStream on: (String new: (aString size)).

	[rs atEnd]
		whileFalse: [
			chr := rs next.
			(chr = $*)
				ifTrue: [ (chrAlt ~= $*)
										ifTrue: [ ws contents size > 0
																	ifTrue: [ match add: (ws contents).
																						state := state + 1.
																						ws reset. ].
															match add: '*'.
															chrAlt := chr. ].
							 ]
				ifFalse: [ ws nextPut: chr.
									 chrAlt := chr. ].
		].

	ws contents size > 0
		ifTrue: [ match add: (ws contents).
							state := state + 1.
						  ws reset. ].

	compares := OrderedCollection new.
	match do: [ :m |
		m ~= '*'
			ifTrue: [ compares add: m ].
	].

	(match size > 0)
		ifTrue: [ fst := match first = '*'.
							lst := match last = '*'. ]! 
buildGroup: pos of: aString andAddTo: anOC
	"searches for the pattern in 'match at: pos' in string aString"

	| scanPos dif |
	
	scanPos := self getPositionsOf: (compares at: pos) in: aString.

	anOC isEmpty
		ifTrue: [ dif := 0 ]
		ifFalse: [ dif := anOC last + ((compares at: (pos - 1)) size) - 1].
	
	scanPos do: [ :i |
		anOC add: (i + dif).
		(pos = state)
			ifTrue: [ matchBlock add: (anOC deepCopy) ]
			ifFalse: [ self buildGroup: (pos + 1) of: (aString copyFrom: ((i + (compares at: pos) size)) to: (aString size)) andAddTo: anOC. ].
		anOC removeLast.
	]
	"Modified: 27-03-92 / 11:47:50 am /  T.Lentzsch"!
buildGroups
	"build groups using match"

	| tmp |

	
	matchBlock := OrderedCollection new.
	tmp := OrderedCollection new.
	state > 0
		ifTrue: [ self buildGroup: 1 of: input andAddTo: tmp. ]!  
getPositionsOf: aSource in: aString
	"liefert die Startpositionen von aString in aSource"

	| pos ok p |
	
	pos := OrderedCollection new.

	1 to: (aString size - aSource size + 1) do: [ :dif |
		ok := true.
		p := 0.
		aSource do: [ :c |
		(c = $?)
			ifFalse: [ ok := ok and: [ true ifTrue: [ (aString at: (dif + p)) = c ]
																			 ifFalse: [ ((aString at: (dif + p)) asUpperCase) = (c asUpperCase) ] ]. ].
		p := p + 1.
		].
		ok ifTrue: [ pos add: dif ].
	].

	^pos
	"Modified: 08.01.93 / 15.18.55 /  T.Lentzsch"!   
match: aString
	"check aString"

	| ok chr |

	input := aString.

	(state = 0) & (match size = 1)
		ifTrue: [ ^true ].
	self buildGroups.

	matchBlock size = 0
		ifTrue: [ ^false ].

	ok := false.
	matchBlock do: [ :m |
		ok := ok | (m first = 1).
	].

	(ok not & fst not)
		ifTrue: [ ^false ].

	ok := false.
	matchBlock do: [ :m |
		ok := ok | (m last = (aString size - (compares last size) + 1)).
	].

	(lst not)
		ifTrue: [ ^ok].

	^true! !

! Point methods !   
extentFromCenterTop: aPoint
        "Added by OSI - Answer a Rectangle whose center top point is
         the receiver at the center top point and extent is aPoint."
    #addedByOSI.
    ^Rectangle
        leftTop: ((self x left: (aPoint x // 2))@ (self y))
        rightBottom: ((self x right: (aPoint x // 2)) @ (self y down: aPoint y))! 
extentFromRightTop: aPoint
        "Added by OSI - Answer a Rectangle whose origin is the receiver
         at the top-right corner and extent is aPoint."
    #addedByOSI.
    ^Rectangle
        leftTop: ((self x left: aPoint x)@ (self y))
        rightBottom: ((self x) @ (self y down: aPoint y))!  
modulus
    "Answer the distance from the origin to the receiver.
    Implemented by xava."

    #addedByOStyle.
    ^(x squared + y squared) sqrt! !

! Rectangle methods !   
centerTop
        "Added by OSI - Answer the center top Point."
    #addedByOSI.
    ^(self right + self left)//2 @ self top!  
intersectsLine: pointA to: pointB
    "Answer true if the receiver has some point in common with
    the line that passes thru the points pointA and pointB."
    "16-III-94 - xava - Added to calculate the intersections with lines."

    | m b lineBlock aux1 aux2 swap |

    #addedByOStyle.
    m := pointA - pointB.
    m x = 0 ifTrue: [
        ^pointA x between: self left and: self right
    ].
    m := m y / m x.
    b := pointA y - (m * pointA x).

    lineBlock := [ :x | m * x + b ].

    aux1 := lineBlock value: self left.
    aux2 := lineBlock value: self right.
    (aux1 between: self top and: self bottom) ifTrue: [ ^true ].
    (aux2 between: self top and: self bottom) ifTrue: [ ^true ].
    aux2 < aux1"Making irrelevant the slope sign"
    ifTrue: [
        swap := aux1.
        aux1 := aux2.
        aux2 := swap
    ].
    (self top between: aux1 and: aux2) ifTrue: [ ^true ].
    (self bottom between: aux1 and: aux2) ifTrue: [ ^true ].

    ^false!
intersectsSegment: pointA to: pointB
    "Answer true if the receiver has some point in common with
    the line that goes from pointA and pointB.
    Doesn't consider possible intersections outside the specified
    points of the segment."
    "17-III-94 - xava - Added to calculate the intersections with lines."

    | m b lineBlock aux1 aux2 |

    #addedByOStyle.

    "Verify if the receiver has an overlapping in the X-axis with the segement"
    (pointA x < pointB x)
        ifTrue: [ aux1 := pointA x. aux2 := pointB x ]
        ifFalse: [ aux1 := pointB x. aux2 := pointA x ].
    ((self left between: aux1 and: aux2)
     or: [ (self right between: aux1 and: aux2)
     or: [ (aux1 between: self left and: self right)
     or: [ aux2 between: self left and: self right ]]])
     ifFalse: [ ^false ].

    "Verify if the receiver has an overlapping in the Y-axis with the segement"
    (pointA y < pointB y)
    ifTrue: [ aux1 := pointA y. aux2 := pointB y ]
    ifFalse: [ aux1 := pointB y.    aux2 := pointA y ].
    ((self top between: aux1 and: aux2)
     or: [ (self bottom between: aux1 and: aux2)
     or: [ (aux1 between: self top and: self bottom)
     or: [ aux2 between: self top and: self bottom ] ] ])
    ifFalse: [ ^false ].

    "Now check if the segment intersects..."
    ^self intersectsLine: pointA to: pointB! 
isRectangle

    "Added by OSI"
    #addedByOSI.
    ^true!   
localizeRect: aRect

    "Added by OSI"

     "Answer a rectangle that is in coordinates relative to
     self.  The rectangle passed in is assumed in the
     same coordinates as self.  This method is system independent."

    #addedByOSI.
    ^(aRect leftTop - self origin) extentFromLeftTop: aRect extent! 
moveToLeftTop: aPoint

    "Added by OSI"
    #addedByOSI.
    self moveBy: aPoint - self leftTop!
offsetFromLeftTop: aRect

    "Added by OSI"

     "Answer a Point that is the offset difference between self's leftTop
     and aRect's leftTop, where positive values indicate aRect is below and
     to the right of self."

    #addedByOSI.
    ^(aRect left - self left) @ (aRect top - self top)!
unLocalizeRect: aRect

    "Added by OSI"

     "Answer a rectangle that is the same coordinates as
     self.  The rectangle passed in is assumed in self's coordinates."

    #addedByOSI.
    ^(aRect leftTop + self origin) extentFromLeftTop: aRect extent! !

! FrameRectangle class methods !
from: aRectangle
    ^self
        origin: aRectangle origin
        corner: aRectangle corner! !

! FrameRectangle methods !
value: anObject
    "Returns the current rectangle.
     Ignoring reframing..."
    ^self! !

! SpinField methods !  
backspace

    | newValue |

    self inEdit ifFalse: [ ^self ].

    newValue := value asString.
    newValue := newValue copyFrom: 1 to: newValue size - 1.

    newValue = '' ifTrue: [
        inputState := #nothing.
        ^self value: 0
    ].

    self value: newValue asInteger.!  
characterInput: c

    | i oldValue |

    choices notNil ifTrue: [
        i := value.
        [   i := i + 1.
            i > choices size ifTrue: [ i := 1 ].
            (((choices at: i) asString at: 1) asUpperCase = c asUpperCase) | (i = value)
        ] whileFalse: [].
        self value: i.
    ] ifFalse: [
        c isDigit | (c = $-) ifFalse: [
            Terminal bell.
        ] ifTrue: [
            inputState == #editing ifFalse: [
                c = $- ifTrue: [
                    inputState := #editing.
                    value := '-'.
                ] ifFalse: [
                    value := (String with: c) asInteger.
                    inputState := #editing.
                ].
                charactersTyped := 1.
            ] ifTrue: [
                value := (value asString, (String with: c)) asInteger.
                charactersTyped := charactersTyped + 1.
            ].
            oldValue := value.
            self display.
            (oldValue ~= value) | (charactersTyped = width) ifTrue: [
                self inputState: #focus.
                self display.
                parent shiftRight.
            ].
        ].
    ]!
choices

    ^choices!  
choices: aList

    choices := aList.
    value := 1.! 
decrement

    | newValue |

    newValue := value.
    choices notNil ifTrue: [
        newValue := newValue - 1.
        newValue < 1 ifTrue: [
            newValue := choices size.
        ].
    ] ifFalse: [
        (min isNil or: [ newValue > min ]) ifTrue: [
            newValue := newValue - 1.
        ].
    ].

    self value: newValue!   
display

    self displayAt: 0@0 with: parent pen clipRect: nil!
displayAt: offset with: pen clipRect: cRect
    "Touched By Ale for proper color usage..."
    | startX v displayRect fore back region clip |

    (rect isNil or: [ pen isNil ]) ifTrue: [ ^self ].

    displayRect := (rect translateBy: offset) insetBy: (1@0).
    startX := displayRect left.
    v := self valueString.
    justification isNil | (justification == #left) ifFalse: [
        justification == #right ifTrue: [
            startX := displayRect right - (parent font stringExtent: v) x.
        ] ifFalse: [
            startX := displayRect center x - ((parent font stringExtent: v) x // 2).
        ]
    ].

    inputState == #focus ifTrue: [
    #modifiedByOS.
"Ale's patch"
        fore := ClrHighlighttext "parent backColor".
        back  := ClrHighlight "parent foreColor."
    ] ifFalse: [
        back := parent backColor.
        fore := parent foreColor.
    ].

    clip := ((parent fieldRect translateBy: offset) expandBy: (1@2)).
    cRect isNil ifFalse: [
        clip := cRect intersect: clip.
    ].

    region := pen setClipRect: clip.

    displayRect := displayRect leftTop - (1@2) rightBottom: displayRect rightBottom + 1.
    pen
        foreColor: fore;
        backColor: back;
        fill: displayRect color: back ;
        setTextAlign: TaTop;
        setBackMode: Transparent;
        displayText: v at: startX @ displayRect top.

    pen destroyRegion: region.!
gettingFocus

    self inputState: #focus.
    self display.!  
increment

    | newValue |

    newValue := value.
    choices notNil ifTrue: [
        newValue := newValue + 1.
        newValue > choices size ifTrue: [
            newValue := 1.
        ].
    ] ifFalse: [
        (max isNil or: [ newValue < max ]) ifTrue: [
            newValue := newValue + 1.
        ].
    ].

    self value: newValue!   
inEdit

    ^inputState == #editing!
inputState

    ^inputState!
inputState: i

    inputState := i.

    (inputState ~= #editing) & (value = '-') ifTrue: [
        self value: 0
    ].!   
isStatic

    ^inputState == #static.!  
justification

    ^justification!  
justification: aSymbol

    justification := aSymbol!   
losingFocus

    self inputState: #normal.
    self display.!  
max

    ^max!  
max: m

    max := m!   
min

    ^min!  
min: m

    min := m!   
min: m1 max: m2

    min := m1.
    max := m2.!
normalizeValue

    max notNil ifTrue: [
        value > max ifTrue: [ value := max. ].
    ].
    min notNil ifTrue: [
        value < min ifTrue: [ value := min.  ].
    ].!
parent: p

    parent := p! 
rect

    ^rect!
rect: r

    rect := r! 
showLeadingZeros

    ^showLeadingZeros = true! 
showLeadingZeros: bool

    showLeadingZeros := bool.!  
value

    ^value!  
value: v

    (value = v) ifTrue: [ ^self ].

    value := v.

    v isInteger ifFalse: [
        inputState := #static.
        width := v size.
    ].

    self display.!   
valueString

    | s |

    (choices isNil or: [ choices isEmpty or: [value = 0 ] ]) ifFalse: [
        s := (choices at: value) asString.
    ] ifTrue: [
        value isInteger ifTrue: [
            inputState = #nothing ifTrue: [
                ^''
            ].
            self normalizeValue.
            s := value asString.
            self showLeadingZeros ifTrue: [
                s := ((String new: (width - s size max: 0)) atAllPut: $0), s.
            ].
            (width >= 1) & (s size > width) ifTrue: [
                s := s copyFrom: (s size - width + 1) to: s size.
            ].
        ] ifFalse: [
            s := value asString.
        ].
    ].

    ^s!
width

    ^width!  
width: w

    width := w! !

! SpinDateField methods !
valueString
    ^value = 0
    ifTrue: ['..']
    ifFalse: [super valueString]! !

! StatusBox class methods !   
new

    ^super new initialize! !

! StatusBox methods !  
contents
        "Answer the receiver's contents."

    ^contents! 
contents: anObject
        "Set the receiver's contents and update the statusPane."

    contents := anObject.
    self statusPane notNil
        ifTrue:[self statusPane updateStatusBox: self].!   
displayWith: aPen
        "Private - Display itself with aPen."
    |rcDraw  string|

    rectangle isNil ifTrue:[^self].
    (rectangle right isLeftEqualOf: rectangle left)
        ifTrue:[^self].

    rcDraw:=rectangle.
    aPen fill: ((rcDraw leftBottom leftAndUp:(0 @ 1)) rightTop: (rcDraw leftTop rightAndDown:( 1 @ 0)))
        color: WinInfo colorButtonShadow.
    aPen fill: ((rcDraw leftTop rightAndDown: (1 @ 0)) rightBottom: (rcDraw rightTop leftAndDown:( 0 @ 1)))
        color: WinInfo colorButtonShadow.
    aPen fill: ((rcDraw leftBottom rightAndUp:(0 @ 0))  rightTop: (rcDraw rightBottom leftAndUp:( 0 @ 1)))
        color: WinInfo colorButtonHighlight.
    aPen fill: ((rcDraw rightBottom leftAndUp:(1 @ 0)) rightTop: (rcDraw rightTop leftAndDown:( 2 @ 0)))
        color: WinInfo colorButtonHighlight.

    contents isNil ifTrue:[^self].
    string := contents isString
                        ifTrue:[contents]
                        ifFalse:[contents printString].
    state ifFalse:[string := ''].          "Is hidden ?"
    rcDraw:=rectangle insetBy: (1 @ 1).
    aPen displayText:string at: (rcDraw leftBottom rightAndUp: (1 @ (aPen font descender + 1)))
        clipRect:rcDraw
        options: EtoOpaque|EtoClipped.!  
initialize
        "Private - Initialize the receiver."

    state := true.
    space := 0.
    width := 0.! 
name
        "Answer the statusBox name.  A StatusBox's name is established by
         sending the 'name:' message to the statusBox."

    ^name!
name: aSymbol
        "Set the statusBox name to aSymbol
         which can be a Symbol or a String."

    name := aSymbol!   
rectangle
        "Private - Answer the receiver's rectangle."

    ^rectangle!
rectangle: aRectangle
        "Private - Set the receiver's rectangle."

    rectangle := aRectangle!  
show: aBoolean
        "Show the receiver's contents if aBoolean is true, else
        hide the receiver's contents."

    state := aBoolean.
    self statusPane notNil
        ifTrue:[self statusPane updateStatusBox: self].!   
space
        "Answer the receiver's offset in
        pixel units.
        An offset specifies the distance between a box and the previous one."

    ^space!   
space: anInteger
        "Set the receiver's offset to
        anInteger pixel units.
        An offset specifies the distance between a box and the previous one."

    space := anInteger! 
statusPane
        "Private - Answer the receiver's statusPane."

    ^statusPane! 
statusPane: aStatusPane
        "Private - Set the receiver's statusPane."

    statusPane := aStatusPane! 
storeOn: aStream indentString: indentString
    "Added by OSI"
    | indent theHeader |

    #addedByOSI.
    indent := indentString, '    '.

    aStream nextPutAll: indentString, self class name, ' new'.
    aStream cr; nextPutAll: indent, 'space: ', self space asString.

    self width > 0 ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indent, 'width: ', self width asString.
    ].
    (self contents notNil and: [ self contents hasContent ]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indent, 'contents: ', self contents asQuotedString.
    ].
    (self name notNil and: [ self name hasContent ]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indent, 'name: #', self name asString.
    ].!   
width
        "Answer the receiver's width in pixel units."

    ^width!   
width: anInteger
        "Set the receiver's width. anInteger is in pixel units."

    width := anInteger! !

! Stream methods ! 
copyFrom: first to: last into: aByteObject
    "Copy the characters of the receiver stream
     from positions first to last into aByteObject
     containing bytes.
        * WARNING: aByteObject must be aByteObject *
     Implemented By Ale for Loader (Loading byteArrays).
     Returns self"

    #addedByOStyle.
    aByteObject class isBytes
    ifFalse: [^self error: 'Must be a byte Object'].

    self position: first.

    collection size - position < (last - first + 1)
    ifTrue: [^self error: 'Copy beyond end of stream'].

    FastFileStream
        replaceLarge: aByteObject
        from: 1
        to: last - first + 1
        with: collection
        startingAt: position + 1.

    self position: self position + last - first + 1! 
getBytesFor: aByteObject
   "Directly copy from the stream to aByteObject.
    basicSize used instead of size because of NLS/DBCS functionality..
    Implemented by Ale..."
    #addedByOStyle.
    ^self
         copyFrom: self position
         to: self position + aByteObject size - 1
         into: aByteObject! 
nextString: s

    "Added by OSI"
    #addedByOSI.
    [ self atEnd ] whileFalse: [
        self nextWord = s ifTrue: [
            ^self
        ].
    ].

    ^nil! !

! ChunkReadStream class methods !   
classComment
	^'This class redefined read stream in file in handling'
	"Modified: 11.06.93 / 10.15.16 / T.Lentzsch"!
classUpdate
	^'
	"Modified: 11.06.93 / 10.15.16 / T.Lentzsch"'
	"Modified: 11.06.93 / 10.15.16 / T.Lentzsch"! !

! ChunkReadStream methods ! 
fileIn: aRequestor
	"Read and execute the Smalltalk source code chunks
	from the receiver.  If a chunk starts with !! send
	it the message fileInFrom: self"

    | aString toBeFiledIn result |

    self reset.
    [self atEnd or: [(self peek asInteger) > ($  asInteger) ]]
	whileFalse: [self next].

    [self atEnd] whileFalse: [
		toBeFiledIn := self peekFor: $!!.
		aString := self nextChunk.

		result := Compiler
			evaluate: aString
			in: UndefinedObject
			to: nil
			notifying: aRequestor
			ifFail: [].

		toBeFiledIn ifTrue: [
			result isNil ifFalse: [result fileInFrom: self]].
	]
	"Modified: 15.02.93 / 13.40.33 / T.Lentzsch"! !

! Random class methods !   
new
        "Answer a new random number stream."
    ^super new initializeSeed! !

! Random methods ! 
atEnd
        " There are always more random numbers "
    ^false!  
contents
        " You cannot get the contents of a ramdom genertor "
    ^self shouldNotImplement! 
initializeSeed
    collection := Array new.
    seed := (Time millisecondClockValue) bitAnd: 16r7FFF!   
next
        "Answer the next random number.
        29-III-94 - xava - Modified because sometimes the seed would
            end up being zero, which results in an endless loop."
    | temp |
    #modifiedByOStyle.
    [ (seed := 13849 + (27181 * seed) bitAnd: 65535) = 0 ]
        whileTrue: [ seed := (Time millisecondClockValue) bitAnd: 16r7FFF ].
    [0 = (temp := seed / 65536.0)] whileTrue: [].
    ^temp! !

! WriteStream methods !
nextULongPut: anInteger
    "Write the next uLong integer to the receiver's stream.
    Implemented by Ale for OSClipboard..."
    #addedByOStyle.
    ^self nextFourBytesPut: anInteger! 
putBytesFrom: aByteObject
        " Write the contents of aByteObject to the receiver.
          aByteObject can be a ByteArray or a String.
          basicSize used instead of size because of NLS/DBCS functionality.
    Added by Ale for using ObjectFiler with Streams of strings..."
    #addedByOStyle.
    self putBytesFrom: aByteObject from: 1 to: aByteObject basicSize!   
putBytesFrom: aByteObject from: start to: stop
        " Write the contents of aByteObject to the receiver.
          aByteObject can be a ByteArray or a String.
          start and stop are byte indices into aByteObject..
    Added by Ale for using ObjectFiler with Streams of strings..."
    #addedByOStyle.
   self nextPutAll: (aByteObject copyFrom: start to: stop) asString!  
putInteger: anInteger
    " Store an encoding of anInteger on the receiver.
     anInteger is expected to be unsigned.
    Added by Ale for using ObjectFiler with Streamns of strings..."
    #addedByOStyle.

    anInteger < 128
        ifTrue: [self nextPut: anInteger asCharacter]
        ifFalse: [
            self nextPut: (anInteger \\ 128 + 128) asCharacter;
                putInteger: anInteger // 128]! !

! ReadWriteStream methods !
getInteger
        " Answer the next Integer encoded in the receiver.
    Added by Ale for using ObjectFiler with Streamns of strings..."
    | answer |
    #addedByOStyle.
    (answer := self next asciiValue) >= 128
        ifTrue: [^self getInteger * 128 + answer - 128]
        ifFalse: [^answer]!   
nextFourBytes

     "Added byOSI.
      Answer the next two bytes from a byte array."

    | answer |
    #addedByOSI.
    answer := 0.
    #( 1 256 65536 16777216 ) do: [ : n |
        answer := answer + (self next * n)].
    ^answer! 
nextTwoBytes

        "Added by OSI.
         Answer the next two bytes from a byte array."

    #addedByOSI.
    ^self next + (self next * 256)! !

! FileStream class methods ! 
on: aFile
        "Answer a new instance of a file stream on aFile."
    ^((NationalLanguage isDoubleByteCp
        ifTrue: [MixedFileStream] ifFalse: [self])
            new)
        setCollection: aFile;
        setLimits! !

! FileStream methods !
asMixedFileStream
        " Make the receiver a character-oriented MixedFileStream
        which interprets mixed string encodings using the lead bytes
        of the current national language.  Answer the receiver. "
    ^self asMixedFileStream: NationalLanguage leadBytes!
asMixedFileStream: leadBytes
        " Make the receiver a character-oriented MixedFileStream
        which interprets mixed string encodings using the specified
        leadBytes flag array.  Answer the receiver. "
    | mixedStream |
    mixedStream := MixedFileStream new.
    1 to: FileStream instSize do: [ :i |
        mixedStream instVarAt: i put: (self instVarAt: i)].
    mixedStream leadBytes: leadBytes.
    (self position = 0)
        ifTrue: [mixedStream setLineDelimiterFromFirstPage].
    self become: mixedStream.
    ^mixedStream!   
backupOver: previousChar
        "Reposition the receiver to before the previous character.
        previousChar is the last character obtained from the receiver."
    self position:
        (self position - (self sizeOf: previousChar))! 
copyFrom: first to: last into: aByteObject
        "Copy the characters of the receiver stream
         from positions first to last into an object
         containing bytes.
    Touched by Ale for fixing bug in selector
         ussage replaceBytesFrom:to:with:startingAt:"
    | index putIndex number size |
    #modifiedByOStyle.
    size := file size.
    putIndex := 1.
    index := first.
    [index <= last]
        whileTrue: [
            index > size
                ifTrue: [^self error: 'copy beyond end of file'].
            self position: index - 1.
            number := (last min: pageStart + readLimit - 1)
                - index + 1.
            aByteObject
                "patched -> replaceBytesFrom:"
                replaceFrom: putIndex
                to: putIndex + number - 1
                with: collection
                startingAt: position + 1.
            putIndex := putIndex + number.
            position := position + number.
            index := index + number]! 
getBytesFor: aByteObject from: start to: stop
        " Directly copy from the stream to aByteObject.
          start and stop are byte indices into aByteObject..
    Touched By Ale..."
    | objectIndex writeTo bufferLeft |
    #modifiedByOStyle.
    writeTo := objectIndex := start - 1.
    [(objectIndex := writeTo) < stop] whileTrue: [
        bufferLeft := collection size - position.
        writeTo := writeTo + bufferLeft min: stop.
        aByteObject
            replaceBytesFrom: objectIndex + 1
            to: writeTo
            with: collection
            startingAt: position + 1.
        self position: self position + writeTo - objectIndex]!   
putBytesFrom: aByteObject from: start to: stop
        " Write the contents of aByteObject to the receiver.
          aByteObject can be a ByteArray or a String.
          start and stop are byte indices into aByteObject..
    Touched By Ale..."
    | writeTo objectLeft objectIndex |
    #modifiedByOStyle.
    objectIndex := start - 1.
    [objectIndex < stop] whileTrue: [
        objectLeft := stop - objectIndex.
        writeTo := collection size min: position + objectLeft.
        collection
            replaceBytesFrom: position + 1
            to: writeTo
            with: aByteObject
            startingAt: objectIndex + 1.
        objectIndex := objectIndex + writeTo - position.
        writtenOn := true.
        position := writeTo.
        self position: pageStart + position - 1]!   
sizeOf: aCharacter
        "Private - answer the size in bytes of aCharacter."
    ^(aCharacter isDoubleByte ifTrue: [2] ifFalse: [1])! !

! FastFileStream class methods !   
buffer
    " FastFileStream buffer "

    Buffer isNil ifTrue: [self initializeBuffer].
    ^Buffer!  
initializeBuffer
    "Private - Initialize the receiver's buffer
     FastFileStream initializeBuffer "
    Buffer := String new: 65000!   
instanceBufferSize
    "Private - Return the buffer size for instances "
    ^8 * 1024! 
replaceLarge: aLinColl
 from: start
 to: stop
 with: aCollection
 startingAt: repStart
    "Private - Replace the elements of aLinColl
     from start through stop with consecutive
     elements of aCollection beginning at repStart."

    | wA wB aH bH return warningStream |
     aCollection size = 0 ifTrue: [^aLinColl].
    (aLinColl size < 65536 and: [aCollection size < 65536])
    ifTrue: [
        ^aLinColl
            replaceFrom: start
            to: stop
            with: aCollection
            startingAt: repStart
    ].
    aLinColl class isBytes
    ifFalse: [
        ^aLinColl
            replaceFrom: start
            to: stop with: aCollection
            startingAt: repStart
    ].
    aCollection class isBytes
    ifFalse: [
        ^aLinColl
            replaceFrom: start
            to: stop with: aCollection
            startingAt: repStart
    ].

    wA := aLinColl isWinAddress ifTrue: [ aLinColl ]
        ifFalse: [ WinAddress copyToNonSmalltalkMemory: aLinColl ].
    wB := aCollection isWinAddress ifTrue: [ aCollection ]
        ifFalse: [ WinAddress copyToNonSmalltalkMemory: aCollection ].
    aH := wA memoryHandle.
    bH := wB memoryHandle.

    return := ExtMemDLL library
        replaceHuge: aH destSize: aLinColl size
        from: start to: stop
        with: bH srcSize: aCollection size
        startingAt:  repStart.

    wA == aLinColl
    ifFalse: [ WinAddress copyFrom: wA to: aLinColl count: aLinColl size ].

    KernelLibrary globalUnlock: aH.
    KernelLibrary globalUnlock: bH.
    wA == aLinColl ifFalse: [ wA free ].
    wB == aCollection ifFalse: [ wB free ].

    return = 0 ifFalse: [
        ^self error: (ExtMemDLL getErrorTextOfError: return)
    ].! !

! FastFileStream methods !  
atEnd
        "Answer true if the receiver is positioned at the
         end (beyond the last object), else answer false."
    ^self position >= self size
    "
    |fs pos|
    pos := position.
    fs := self file size.
    self position: pos.
    position < fs
         ifTrue: [^false]
         ifFalse:[^true]
    "!  
basicNext: anInteger
    "Private - Read anInteger number of bytes from the stream (don't use the buffer)"

    | reply buffer blockSize count temp|
    self position: self position.
    blockSize :=  self class buffer size.
    count := anInteger // blockSize.
    count = 0 ifTrue: [^self nextSmall: anInteger].

    temp := self class buffer.
    buffer := String new: anInteger.
    1 to: count do: [:i|
      reply := KernelLibrary lread: (self file fileId) string: temp size: blockSize.
      reply = -1
      ifTrue: [^self nfsError: 'Error de lectura (KernelLibrary). [', reply printString,']'].
      self position: self position + reply.
      reply < blockSize
      ifTrue: [
            self atEnd ifTrue: [ ^self nfsError: 'Eof in ',self printString ].
            ^self nfsError: 'Error de lectura (KernelLibrary). [', reply printString,']'
      ].
      self class replaceLarge: buffer from: i - 1 * blockSize + 1 to: i * blockSize with: temp startingAt: 1.
    ].

   temp := self nextSmall: (anInteger - (count * blockSize)).
   self class
        replaceLarge: buffer
        from: blockSize * count + 1
        to: anInteger
        with: temp
        startingAt: 1.

    ^buffer! 
close
    self file close!   
contents
    "Return the contents of the receiver"
    self reset.
    ^self next: self size!  
copyFrom: first to: last
    "Answer a String containing the characters of the
     receiver stream from positions first to last."
    | result pos |
    pos := self position.
    self position: first - 1.
    result := self next: last - first + 1.
    self position: pos.
    ^result! 
flush
    "Do the physical write. thus the file becomes closed"
    |pos|
    pos := self position.
    self file flushShare.
    self position: pos!
fromFileStream: aFileStream
    "Sets the receiver with the instances of aFileStream"

    collection := aFileStream file.
    self setLimits.
    position := aFileStream position.!
getBytesFor: aByteObject
    " Directly copy from the stream to aByteObject.
     basicSize used instead of size because of NLS/DBCS functionality. "

    | reply blockSize count temp|
    self position: self position.
    blockSize :=  self class buffer size.
    count := aByteObject basicSize // blockSize.
    temp := self class buffer.
    1 to: count do: [:i|
      reply := KernelLibrary lread: self file fileId string: temp size: blockSize.
      reply = -1
      ifTrue: [^self nfsError: 'Error KernelLibrary-Call read. [', reply printString,']'].
      self position: self position + reply.
      reply < blockSize
      ifTrue: [
            self atEnd ifTrue: [ ^self nfsError: 'Eof in ',self printString ].
            ^self nfsError: 'Error KernelLibrary-Call read. [', reply printString,']'].
      self class
            replaceLarge: aByteObject
            from: i - 1 * blockSize + 1
            to: i * blockSize
            with: temp startingAt: 1.
    ].

   temp := self nextSmall: (aByteObject basicSize - (count * blockSize)).
   self class
        replaceLarge: aByteObject
        from: blockSize * count + 1
        to: aByteObject basicSize
        with: temp startingAt: 1.

    ^aByteObject!   
lastByte
    "Private - Answer the lastByte of the stream"
    ^lastByte
    "
    |fs pos|
    pos := position.
    fs := self file size.
    self position: pos.
    ^fs
    "!
next
    "return the next character of the receiver"

    pageStart + collection size > position
    ifTrue: [
        position := position + 1.
        ^collection at: position - pageStart
    ].

     ^(self next: 1) first!
next: anInteger
    "Read anInteger number of bytes from the stream"

    | result index |

    (collection isNil or: [pageStart > self position])
    ifTrue: [self readCollection].

    (self position + anInteger + 1 between: pageStart and: pageStart + collection size)
    ifTrue: [
        index := position - pageStart + 1.
        result := collection copyFrom: index to: index + anInteger - 1.
        position := self position + anInteger.
        ^result
    ].

    collection := nil.
    ^self basicNext: anInteger!
nextPut: aChar
    "write a character to the receiver"

    | reply buffer|
    buffer := aChar asString.
    reply := KernelLibrary lwrite: self file fileId string: buffer size: 1.
    reply = -1
    ifTrue: [^self nfsError: 'Error KernelLibrary-Call write. [', reply printString,']'].
    position := position + reply.
    reply < buffer size
    ifTrue: [^self nfsError: 'Error KernelLibrary-Call write. [', reply printString,']'].! 
nextPutAll: aByteObject
    "Write the content of buffer to the stream"

    | reply temp count blockSize control|

    blockSize := self class buffer size.
    count := aByteObject size // blockSize.
    count = 0 ifTrue: [^self nextPutAllSmall: aByteObject].
    1 to: count do: [:i|
      temp := self return: aByteObject copyFrom: i - 1 * blockSize + 1 to: i * blockSize.
      reply := KernelLibrary lwrite: self file fileId string: temp size: temp size.
      reply = -1
      ifTrue: [^self nfsError: 'Error KernelLibrary-Call write. [', reply printString,']'].
      position := position + reply.
      reply < blockSize
      ifTrue: [^self nfsError: 'Error DosLibrary-Call write. Return: ', reply printString]
    ].

    temp := self return: aByteObject copyFrom: count * blockSize + 1 to: aByteObject size.
    self nextPutAllSmall: temp.
    lastByte := lastByte max: self position.!  
nextPutAllSmall: buffer
    "Private - Write the content of buffer (< 32000 byte) to the stream"

    | reply |
    reply := KernelLibrary lwrite: self file fileId string: buffer size: buffer size.
    reply = -1
    ifTrue: [ ^self nfsError: 'Error KernelLibrary-Call write. [', reply printString,']' ].
    position := position + reply.
    reply < buffer size
    ifTrue: [^self nfsError: 'Error KernelLibrary-Call write. [', reply printString,']'].!
nextSmall: anInteger
    "Private - Read anInteger number of bytes from the stream."

    | reply buffer realReadSize |
    anInteger = 0 ifTrue: [^String new].
    self position: self position.
    buffer := String new: anInteger.
    realReadSize := anInteger min: (self size - self position). "Patchado temporariamente para que no genere error si EOF..."
    anInteger > realReadSize
    ifTrue: [ Transcript cr;nextPutAll: 'EOF encontrado en ',self printString,' ',(anInteger - realReadSize) printString,' bytes missing' ].
    reply := KernelLibrary lread: self file fileId string: buffer size: realReadSize.
    reply = -1
    ifTrue: [^self nfsError: 'Error KernelLibrary-Call read. [', reply printString,']'].
    self position: self position + reply.
    reply < realReadSize
    ifTrue: [
            self atEnd ifTrue: [ ^self nfsError: 'Eof in ',self printString ].
            ^self nfsError: 'Error KernelLibrary-Call read. [', reply printString,']'
    ].
    ^buffer!
nfsError: aString
    "Private - Handle a erraneous condition regarding the filesystem."
    ^self error: aString!  
peek
        "Answer the next object in the receiver stream
         without advancing the stream position.  If the
         stream is positioned at the end, answer nil."
    | anObject |
    self atEnd ifTrue: [^nil].
    anObject := self next.
    self position: self position - 1.
    ^anObject!
position
    ^position!  
position: anInteger
    "sets the position in the receiver"

    |reply|
    reply := KernelLibrary llseek: self file fileId offset: anInteger origin: 0.
    reply = -1
    ifTrue: [self nfsError: 'Error DosLibrary-Call chgFilePtr. [', reply printString,']']
    ifFalse:[position := reply].
    lastByte := lastByte max: self position.
    ^position!  
readCollection
    "Private - Read the next collection bytes from file"

    self position: self position.
    pageStart := self position.
    collection := self basicNext:
        (self class instanceBufferSize min: self size - pageStart).
    self position: pageStart.!
reset
    "Set the position of the receiver stream to the start."
    self position: 0! 
return: buffer copyFrom: start to: stop
    "Private - Return a portion of the buffer"
    |new|
    new := buffer species new: (stop - start + 1).
    self class
        replaceLarge: new from: 1
        to: new size
        with: buffer
        startingAt: start.
    ^new!  
setLimits
    "Private - Initialize the stream size and position."
    file := collection.
    lastByte := self file size.

    collection :=  writeLimit :=  readLimit := nil.
    writtenOn := nil.
    lineDelimiter := Cr.

    self position: 0.
    pageStart := 0!   
setToEnd
        "Set the position of the receiver stream to the end."
    self position: self size!
size
    "Return the size of the keyStream"
    | current |
    current := self position.
    lastByte := self file size.
    self position: current.
    ^lastByte!
skip: anInteger
    "Skip anInteger number of bytes in the receiver"
    |reply|
    reply := KernelLibrary llseek: self file fileId offset: anInteger origin: 1.
    reply = -1
    ifTrue: [self nfsError: 'Error KernelLibrary-Call chgFilePtr. [', reply printString,']']
    ifFalse:[position := reply].
    lastByte := lastByte max: self position.
    ^position!
upTo: anObject
        "Answer the collection of objects from the receiver
         starting with the next accessible object and up to
         but not including anObject.  Set the position beyond
         anObject.  If anObject is not present, answer the
         remaining elements of the stream."

    | start index result |
    collection isNil ifTrue: [self readCollection].

    index := start := position - pageStart + 1.
    [ index <= collection size
    and: [(collection at: index) ~= anObject ]]
       whileTrue: [index := index + 1].

    index > collection size
    ifTrue: [^super upTo: anObject].

    result := collection copyFrom: start to: index - 1.
    position := position + result size + 1.
    ^result! !

! MixedFileStream methods !  
asByteFileStream
        " Make the receiver a byte-oriented FileStream.
        Answer the receiver. "
    | byteStream |
    byteStream := FileStream new.
    1 to: FileStream instSize do: [ :i |
        byteStream instVarAt: i put: (self instVarAt: i)].
    (self position = 0)
        ifTrue: [byteStream setLineDelimiterFromFirstPage].
    self become: byteStream.
    ^byteStream!  
asMixedFileStream: leadByteFlags
        " Make the receiver a character-oriented MixedFileStream
        which interprets mixed string encodings using the specified
        leadBytes flag array.  Answer the receiver. "
    (leadByteFlags == leadBytes) ifTrue: [^self].
    leadBytes := leadByteFlags.
    (self position = 0)
        ifTrue: [self setLineDelimiterFromFirstPage].
    ^self!
copyFrom: first to: last
        "Answer a string containing the characters of the
         receiver stream from byte positions first to last."
    ^(super copyFrom: first to: last)
        asNormalizedString: leadBytes!  
leadBytes
        "Answer the leadBytes flag array currently in use
        for normalizing mixed strings."
    ^leadBytes!
leadBytes: leadByteFlags
        "Set the leadBytes flag array for normalizing mixed strings."
    leadBytes := leadByteFlags.! 
next
        "Answer the next character accessible by the receiver
         and advance the stream position.  Report an error
         if the receiver stream is positioned at end."
    | char |
    char := self nextOneByteCharacter.
    (char isLeadByte: leadBytes)
        ifTrue: [char := Character
            leadByte: char
            trailByte: self nextOneByteCharacter].
    ^char!   
nextByte
        "Answer the next byte accessible by the receiver
         and advance the stream position.  Report an error
         if the stream is positioned at end."
    ^self nextOneByteCharacter asciiValue! 
nextOneByteCharacter
        " Private - answer the next byte. "
    ^super next!   
nextPutAll: aCollection
        "Write each of the characters in
         aCollection to the receiver stream."
    ^super nextPutAll:
        ((aCollection isDoubleByteString)
            ifTrue: [aCollection asMixedString]
            ifFalse: [aCollection])!
nextWord
        "Answer a String containing the next word in the
         receiver stream.  A word starts with a letter,
         followed by a sequence of letters and digits."
    | first aChar |
    [self atEnd ifTrue: [^nil].
    (aChar := self next) isAlphaNumeric]
        whileFalse: [].  "skip separators"
    first := (aChar isDoubleByte
        ifTrue: [self position - 1]
        ifFalse: [self position]).
    [self atEnd
        ifTrue: [^self copyFrom: first to: self position].
     (aChar := self next) isAlphaNumeric]
        whileTrue: [].
    self backupOver: aChar.
    ^self copyFrom: first to: self position!
reverseContents
        "Answer a collection of the same species as the
         receiver collection, with the contents in
         reverse order."
    ^self invalidMessage! 
setLimits
        "Private - Initialize the stream size and position."
    self leadBytes: NationalLanguage leadBytes.
    ^super setLimits!   
setLineDelimiterFromFirstPage
        " Private - find the first line ending in the file. "
    | inDBC char |
    lineDelimiter := Cr.
    inDBC := false.
    1 to: readLimit do: [ :i |
        inDBC
            ifTrue: [inDBC := false]
            ifFalse: [
                char := collection at: i.
                (char isLeadByte: leadBytes)
                    ifTrue: [inDBC := true]
                    ifFalse: [
                        (char == Cr) ifTrue: [
                            lineDelimiter := Cr.
                            ^self].
                        (char == Lf) ifTrue: [
                            lineDelimiter := Lf.
                            ^self].
                        ]]].!   
upTo: anObject
        "Answer the collection of objects from the receiver
         starting with the next accessible object and up to
         but not including anObject.  Set the position beyond
         anObject.  If anObject is not present, answer the
         remaining elements of the stream."
    ^self
        copyFrom: self position + 1
        to: ((self skipTo: anObject)
                ifTrue: [self position - (self sizeOf: anObject)]
                ifFalse: [self position])! !

! MemoryStream class methods ! 
on: aWinAddress
    "Answer a new instance of the receiver on aWinAddress."

    aWinAddress isWinAddress
    ifFalse: [ ^aWinAddress error: 'Must be a WinAddress' ].

    ^super on: aWinAddress! 
replaceLarge: aLinColl
 from: start
 to: stop
 with: aWinAddress
 startingAt: repStart
    "Private - Replace the elements of aLinColl
     from start through stop with consecutive
     elements of aCollection beginning at repStart."

    | wA aH bH return warningStream |
    stop < start ifTrue: [^aLinColl].
    (aLinColl size < 65536 and: [stop - start + 1 < 65536])
    ifTrue: [
        ^aLinColl
            replaceFrom: start
            to: stop
            with: aWinAddress
            startingAt: repStart
    ].
    aLinColl class isBytes
    ifFalse: [
        ^aLinColl
            replaceFrom: start
            to: stop with: aWinAddress
            startingAt: repStart
    ].

    wA := aLinColl isWinAddress ifTrue: [ aLinColl ]
        ifFalse: [ WinAddress copyToNonSmalltalkMemory: aLinColl ].
    aH := wA memoryHandle.
    bH := aWinAddress memoryHandle.

    return := ExtMemDLL library
        replaceHuge: aH destSize: aLinColl basicSize
        from: start to: stop
        with: bH srcSize: aWinAddress memorySize
        startingAt: repStart.

    wA == aLinColl
    ifFalse: [ WinAddress copyFrom: wA to: aLinColl count: aLinColl size ].

    KernelLibrary globalUnlock: aH.
    KernelLibrary globalUnlock: bH.
    wA == aLinColl ifFalse: [ wA free ].

    return = 0 ifFalse: [
        ^self error: (ExtMemDLL getErrorTextOfError: return)
    ].! !

! MemoryStream methods !  
getBytesFor: aByteObject
    "Directly copy from the stream to aByteObject."
    | start |
    start := self position + 1.
    self class
        replaceLarge: aByteObject
        from: 1
        to: aByteObject basicSize
        with: collection startingAt: start.
    self position: start + aByteObject basicSize - 1.
    ^aByteObject!   
next
    "Answer the next object accessible by the receiver
     and advance the stream position.  Report an error
     if the receiver stream is positioned at end."

    | index |
    self atEnd
    ifTrue: [ ^self error: 'read beyond end of stream' ]
    ifFalse: [
        index := self position + 1.
        self position: index.
        ^Character value: (collection at: index)
    ]! 
setLimits
    "Private - Initialize the receiver's size and position."
    position := 0.
    readLimit := writeLimit := collection memorySize! !

! Tool class methods !
fromBitmap: aBitmap
        "Answer a new tool. aFileName is a .BMP file name."

    ^self new fromBitmap: aBitmap!
fromFile:aFileName
        "Answer a new tool. aFileName is a .BMP file name."

    ^self new fromFile:aFileName!  
fromModule:aFileName id:aString
        "Answer a new tool. aFileName is a DLL file name.
        aString is a BITMAP name in this DLL."
    ^self new fromModule:aFileName id:aString!
new

    ^super new initialize! !

! Tool methods !   
colorChange
        "Private - Window's colors have changed."

    bitmap isDIB
        ifTrue:[bitmap colors: self sysColors].!  
defaultExtent
    "Private - Answer the default height/width of the receiver's tools."
    ^25 @ 22!
displayToolDownWith: aPen
        "Private - Display the tool down bitmap with aPen."

    bitmap isDIB
        ifTrue:[
            bitmap
                displayWith: aPen
                from: ((Rectangle leftTopUnit right: self extent x) extent: self extent)
                to: (self rectangle origin extent: self extent)].

    bitmap isBitmap
        ifTrue:[
            aPen
                copyBitmap: bitmap
                from: ((Rectangle leftTopUnit right: self extent x) extent: self extent)
                at: self rectangle origin].!   
displayToolUpWith: aPen
        "Private - Display the tool up bitmap with aPen."

    bitmap isDIB
        ifTrue:[
            bitmap
                displayWith: aPen
                from: (Rectangle leftTopUnit extent: self extent)
                to: (self rectangle origin extent: self extent)].

    bitmap isBitmap
        ifTrue:[
            aPen
                copyBitmap: bitmap
                from: (Rectangle leftTopUnit extent: self extent)
                at: self rectangle origin].! 
extent
        "Answer the receiver's extent."

    ^extent!   
extent:aPoint
        "Set the receiver's extent."

    extent := aPoint!  
fromBitmap: aBitmap
        "Set the receiver's bitmap."
    bitmap := aBitmap! 
fromFile:aFileName
        "Set the receiver's bitmap."

    bitmap := DIB fromFile:aFileName.
    self colorChange.! 
fromModule:aFileName id:bitmapId
        "Set the receiver's bitmap."
    bitmap := DIB fromModule:aFileName id: bitmapId.
    self colorChange.!  
initialize
        "Private - Initialize the receiver's instance variable."

    extent := self defaultExtent! 
name
        "Answer the tool name.  Tool's name is established by
         sending the 'name:' message to the tool."

    ^name! 
name: aSymbol
        "Set the tool name to aSymbol
         which can be a Symbol or a String."

    name := aSymbol!
owner
        "Answer the receiver's owner."

    ^owner!  
owner:anOwner
        "Set the receiver's owner."

    owner:=anOwner! 
rectangle
        "Private - Answer the receiver's rectangle."

    ^rectangle!
rectangle:aRectangle
        "Private - Set the receiver's rectangle."

    rectangle:=aRectangle! 
selector
    "Answer the receiver's selector."

    ^selector! 
selector:aSymbol
        "Set the receiver's selector. It can be either
        aSymbol or a message."

    selector:=aSymbol!
space
        "Answer the receiver's offset in pixel unit."

    ^space!   
space:anInteger
        "Set the receiver's offset to anInteger
        pixel units.
        An offset specifies the distance between a tool and the previous one."

    space := anInteger! 
sysColors
        "Private - Answer the System colors for push button."
    ^Dictionary new
        at: 4 put: WinInfo colorButtonText;
        at: 8 put: WinInfo colorButtonShadow;
        at: 9 put: WinInfo colorButtonFace;
"        at: 16 put: WinInfo colorButtonHighlight;"
        yourself.! !

! UndefinedObject methods !  
ifNil: aBlock

    "Added by OSI. This replaces the construct 'isNil ifTrue: []'.
     In the case self IS nil"

    #addedByOSI.
    ^aBlock value! !

! ViewManager class methods ! 
isScratchWindow

    "Added by OSI"
    #addedByOSI.
    ^false!  
open
    "Added by OSI - Open a new instance of the receiver."
    self addedByOSI.
    ^self new open!
openAsMDIParent
    "Added by OSI - Open a new instance of the receiver
     as an MDI parent."
    #addedByOSI.
    ^self new openAsMDIParent!   
openWithMDIParent: aViewManager
    "Added by OSI - Open a new instance of the receiver
     as an MDI child of aViewManager."
    #addedByOSI.
    ^self new openWithMDIParent: aViewManager!
openWithMyParent: aViewManager
    "Added by OSI - Open a new instance of the receiver
     as a child of aViewManager's parent (a sibling)."
    #addedByOSI.
    ^self new openWithMyParent: aViewManager!  
openWithParent: aViewManager
    "Added by OSI - Open a new instance of the receiver
     as a child of aViewManager."
    #addedByOSI.
    ^self new openWithParent: aViewManager!   
wbCreated

    "Added by OSI - answer whether this
     viewmanager is WindowBuilder generated."
    #addedByOSI.
    ^false!
wbCreatedClasses

    "Added by OSI"
    #addedByOSI.
    ^self allSubclasses select: [ :c |
        c wbCreated
    ].! !

! ViewManager methods !   
about
    "Open the about notifyer.
    Touched By Ale..."
    #modifiedByOStyle.
    (Smalltalk at: #AboutDialog
      ifAbsent: [^nil]) new open!  
closeWindow

    "Added by OSI for backward compatibility with
     WB Windows 1.x"
    #addedByOSI.
    ^self close!
createViews
    "Added by OSI - Default #createViews method."
    #addedByOSI.
    ^self createViewsFor: self owner: self! 
createViewsFor: target owner: owner
    "Added by OSI - Dummy method that returns nil."
    #addedByOSI.
    ^nil! 
dialogTemplate
    "Added by OSI"
    #addedByOSI.
    ^nil!   
dialogTemplate: ignore
    "Added by OSI"
    #addedByOSI.
    ^self!  
disableSystemMenuItemClose
    "Disable the receiver's mainView system menu item close."
    views size < 1 ifTrue: [
        self addView: (
            self topPaneClass new
                owner: self)].
    ^(views at: 1)  disableSystemMenuItemClose!  
execute: aBlock withTopPane: aTopPaneClass
    "Added by OSI to support openning windows as MDI
     parents and children. MDI support must be loaded."
    | result |
    #addedByOSI.
    Smalltalk at: #TopPaneClass put: aTopPaneClass.
    result := aBlock value.
    Smalltalk removeKey: #TopPaneClass.
    ^result!  
frame
        "Answer the receiver's frame if any."

    #modifiedByOSI.
    self mainView isMDIFrame ifTrue: [ ^self mainView ].
    self mainView isMDIChild ifFalse:[^nil].
    ^self mainView frame!
frame: aWindow
    "Set the receiver's frame to aWindow."
    views size < 1 ifTrue: [
        self addView: (
            MDIChild new
                owner: self)].
    (views at: 1) frame: aWindow!
incrementalSearch: aPane
    "Private - This method is implemented for incremental
     search in list panes.
    Implemented By Ale.
    Use as:
        aListPane  when: #charInput perform: #incrementalSearch:.
    Implemented by Ale..."
    #addedByOStyle.

    CurrentEvents add: (
        Message new
            receiver: self
            selector: #incrementalSearchFor:in:
            arguments: (Array
                    with: aPane characterTyped
                    with: aPane )
    ).
    ^1!
incrementalSearchFor: aCharacter in: aPane
    "Private - This method is implemented for incremental
     search in list panes..
    Implemented by Ale..."
    | cursor |
    #addedByOStyle.

    cursor := Cursor.
    CursorManager execute change.
    (aPane respondsTo: #incrementalSearchFor:)
    ifTrue: [ aPane incrementalSearchFor: aCharacter ].
    cursor change!  
isModal

    "Added by OSI"
    #addedByOSI.
    ^false!  
isWBWindow

    "Added by OSI"
    #addedByOSI.
    ^self class wbCreated!
mdiArrange
    "Added by OSI. Arrange the MDI documents."
    #addedByOSI.
    self frame mdiArrange!  
mdiCascade
    "Added by OSI. Cascade the MDI documents."
    #addedByOSI.
    self frame mdiCascade!  
mdiCloseAll
    "Added by OSI. Close all MDI documents
     which are not minimized."
    #addedByOSI.
    self frame mdiCloseAll!
mdiTile
    "Added by OSI. Tile the MDI documents."
    #addedByOSI.
    self frame mdiTile!   
menuWindow

    "Modified by OSI to allow asking for a menu if no view has been created.
     Used in Windows conversion."

    "Private - Answer the menu bar of the first view,
     retained for compatibility."

    #modifiedByOSI.
    views size < 1 ifTrue: [
        self addView: (
            (self topPaneClass) new
                owner: self)].
    ^self mainView menuWindow!  
modifyFileMenu
    "Modify the file menu if application wants
    Who touched this method? why?"
    | aWindow aMenu |
    #modifiedByOStyle.
    aWindow := self mainView menuWindow.
    aMenu := aWindow menuTitled: '&File'.
    aWindow removeMenu: aMenu!
open
    "Added by OSI - Open the receiver."
    | newInstance |
    newInstance := self createViews.
    newInstance notNil ifTrue: [
        newInstance openViews.
    ] ifFalse: [
        #addedByOSI.
        MessageBox message:
            self class name,' does not have a #createViews method or its own #open method.'
    ].
    ^newInstance!   
openAsMDIParent
    "Added by OSI - Open the receiver as an
     MDI parent window."
    | newInstance |
    (Smalltalk includesKey: #MDISystem) ifFalse: [
        MessageBox message: 'Cannot open ',self class name,
            ' because the MDI support is not installed.'.
        ^nil
    ].
    newInstance := self
        execute: [ self createViews ]
        withTopPane: (Smalltalk at: #MDIFrame).
    newInstance notNil ifTrue: [
        newInstance menuWindow menus isEmpty ifTrue: [
            newInstance menuWindow addMenu:
                (Menu new title: '&MDI'; owner: self; yourself)
        ].
        newInstance openViews.
    ] ifFalse: [
        #addedByOSI.
        MessageBox message:
            self class name,' does not have a #createViews method or its own #open method.'
    ].
    ^newInstance!   
openViews
    "Added by OSI"
    #addedByOSI.
    ^self openWindow!
openWindow

    "Modified by OSI to support preInitWindow and
      remove #respondsTo: message"

    "Open all the views."

    #modifiedByOSI.
    self preInitWindow.

    views do: [:each | each openWindow ]! 
openWithMDIParent: aViewManager
    "Added by OSI - Open the receiver with aViewManager as an MDI Parent."
    | newInstance frame |
    (Smalltalk includesKey: #MDISystem) ifFalse: [
        MessageBox message: 'Cannot open ',self class name,
            ' because the MDI support is not installed.'.
        ^nil
    ].
    frame := aViewManager frame.
    frame isNil ifTrue: [
        MessageBox message: 'Cannot open ',self class name,
            ' because the parent window does not have an MDI Frame.'.
        ^nil
    ].
    newInstance := self
        execute: [ self createViews ]
        withTopPane: (Smalltalk at: #MDIChild).
    newInstance notNil ifTrue: [
        self views do: [ :view |
            view frame: frame.
        ].
        newInstance openViews.
    ] ifFalse: [
        #addedByOSI.
        MessageBox message:
            self class name,' does not have a #createViews method.'
    ].
    ^newInstance! 
openWithMyParent: aViewManager
    "Added by OSI - Open a the receiver as a child of
     aViewManager's parent (a sibling)."
    aViewManager mainView parent isNil ifTrue: [
        #addedByOSI.
        ^self open
    ] ifFalse: [
        ^self openWithParent: aViewManager mainView parent
    ]! 
openWithOwner: aViewManager
    "Added by OSI - Open the receiver with aViewManager as owner of
    all the subpanes (the target of the #when:perform: messages). This
    method can only be used in conjunction with the 'Power Views' Add-In."
    | newInstance |
    newInstance := self createViewsFor: self owner: aViewManager.
    newInstance notNil ifTrue: [
        newInstance openViews.
    ] ifFalse: [
        #addedByOSI.
        MessageBox message:
            self class name,' does not have a #createViewsFor:owner: method.'
    ].
    ^newInstance! 
openWithOwnerParent: aViewManager
    "Added by OSI - Open the receiver with aViewManager as Parent
    and owner of all the subpanes. This method can only be used in
    conjunction with the 'Power Views' Add-In."
    | newInstance |
    newInstance := self createViewsFor: self owner: aViewManager.
    newInstance notNil ifTrue: [
        newInstance
            parent: aViewManager;
            openViews.
    ] ifFalse: [
        #addedByOSI.
        MessageBox message:
            self class name,' does not have a #createViewsFor:owner: method.'
    ].
    ^newInstance!
openWithParent: aViewManager
    "Added by OSI - Open the receiver with aViewManager as Parent."
    | newInstance |
    newInstance := self createViews.
    newInstance notNil ifTrue: [
        newInstance parent: aViewManager; openViews.
    ] ifFalse: [
        #addedByOSI.
        MessageBox message:
            self class name,' does not have a #createViews method.'
    ].
    ^newInstance! 
paneNamed: aSymbol

    "Added by OSI"

    | string pane |

    #addedByOSI.
    string := aSymbol asString.

    views do: [ :v |
        v children do: [ :c |
            (pane := c paneNamed: string) notNil ifTrue: [
                ^pane
            ].
        ].
    ].

    ^nil!   
removeView: aView
        "Remove aView from the view manager."
    views remove: aView!
statusPane
        "Answer the receiver's statusPane."

    ^self mainView statusPane! 
statusText: aString
    "Set the receiver's statusText to aString."
    views size < 1 ifTrue: [
        self addView: (
            self topPaneClass new
                owner: self)].
    ^(views at: 1) statusText: aString!   
toolPane
        "Answer the receiver's toolPane if any, else answer nil."

    ^self mainView toolPane!   
topPaneClass
    "Modified by OSI to support opening any window
     as an MDI parent or child"
        "Private - Answer the default top pane class."
    #modifiedByOSI.
    Smalltalk isRunTime ifFalse:[
        MDISystem isActive ifTrue:[^MDIChild]].
    ^Smalltalk at: #TopPaneClass ifAbsent: [ TopPane ].!  
viewNamed: aSymbol

    "Added by OSI"

    | string |

    #addedByOSI.
    string := aSymbol asString.

    views do: [ :v |
        v paneName = string ifTrue: [
            ^v
        ].
    ].

    ^nil!   
views

    "Added by OSI"
    #addedByOSI.
    ^views! !

! BitEditor methods ! 
addAdjacentCells: cell to: queue with: cellMatrix
        "Add adjacent cells to queue and record filled cell to
         cellMatrix."
    | adjacent |
    (cellMatrix at: cell x + 1) at: (cell y + 1) put: cell.
    adjacent := cell + (0 @ 1).
    ((copy boundingBox containsPoint: adjacent) and: [
        ((cellMatrix at: adjacent x + 1) at: adjacent y + 1) isNil])
            ifTrue: [
                queue add: adjacent].
    adjacent := cell - (1 @ 0).
    ((copy boundingBox containsPoint: adjacent) and: [
        ((cellMatrix at: adjacent x + 1) at: adjacent y + 1) isNil])
            ifTrue: [
                queue add: adjacent].
    adjacent := cell - (0 @ 1).
    ((copy boundingBox containsPoint: adjacent) and: [
        ((cellMatrix at: adjacent x + 1) at: adjacent y + 1) isNil])
            ifTrue: [
                queue add: adjacent].
    adjacent := cell + (1 @ 0).
    ((copy boundingBox containsPoint: adjacent) and: [
        ((cellMatrix at: adjacent x + 1) at: adjacent y + 1) isNil])
            ifTrue: [
                queue add: adjacent]!   
changeBits: aPane
    | aPoint  changePoint imagePoint |
    aPoint := aPane mouseLocation.
    (self isInGrid: aPoint)
        ifFalse: [^self].
    imagePoint := aPoint // scale.
    changePoint := imagePoint * scale.
    changePoint printString.
    bitPen fill: ((changePoint + 1) extent: (scale @ scale) - 1)
        color: bitColor.
    imagePen fill: (imagePoint extent: 1 @ 1)
        color: bitColor.
    copy pen fill: (imagePoint extent: 1 @ 1)
        color: bitColor! 
clear
    imagePen erase.
    bitPen erase.
    copy pen blank: copy boundingBox.
    self grid: scale!   
close
    super close.
    copy release!
colorSelected: aColor
    bitColor := aColor!
displayBits: aPane
    bitPen := aPane pen.
    bitPen
        copyBitmap: copy
        from: copy boundingBox
        to: (0 @ 0 extent: copy extent * scale).
    self grid: scale!   
displayImage: aPane
    imagePen := aPane pen.
    copy displayAt: 0 @ 0
        with: imagePen!   
editMenu: aPane
    "Touched By Ale..."
    #modifiedByOStyle.
    aPane setMenu: (
        (Menu
            labels: '&Clear\&Fill\&Replace\&Paste' withCrs
            lines: #(1 3)
            selectors: #(clear fill replace paste))
            owner: self;
            title: '&Edit';
            yourself)!  
exit: aButton
    self close!
fill
    | aPoint |
    Notifier consumeInputUntil: [: event |
        event selector = #button1Up: ].
    aPoint := Cursor sense mapScreenToClient: bitPen graphicsMedium.
    ((0 @ 0 extent: bitPen graphicsMedium rectangle extent)
        containsPoint: aPoint)
            ifTrue: [self fillAt: aPoint]!  
fillAt: aPoint
    "
    Who touched this method? why?"
    | cells originalColor adjColor cell imagePoint cellMatrix |
    #modifiedByOStyle.
    imagePoint := aPoint // scale.
    originalColor := GDILibrary getPixel: copy pen handle
        x: imagePoint x
        y: imagePoint y.
    copy pen backColor: bitColor.
    GDILibrary extFloodFill: copy pen handle
        x: imagePoint x
        y: imagePoint y
        color: originalColor
        fillType: Floodfillsurface.

    self displayImage: imagePen graphicsMedium.
    self displayBits: bitPen graphicsMedium.

    "Patched by Ale... but kept new to check - xava"
"    | back imagePoint fill |
    imagePoint := aPoint // scale.
    fill := [:aPen|
        back := aPen backColor.
        aPen
            backColor: bitColor;
            place: imagePoint;
            floodFill;
            backColor: back
    ].
    fill
        value: imagePen;
        value: copy pen.
    self mainView invalidateRect: nil"!  
grid: anInteger
        "Draw grid lines with anInteger spacing
         on the receiver medium.
    Who touched this method? why?"

    "
    Original code...
    | i len end width height |
    #modifiedByOS.
    width := copy width * scale.
    height := copy height * scale.
    bitPen foreColor: ClrWhite.
    i := 0.
    [i < width]
        whileTrue: [
            bitPen place: (i + 1)@ 0;
                goto: (i + 1) @ height;
                place: (i + anInteger - 1) @ 0;
                goto: (i + anInteger - 1) @ height.
            i := i + anInteger].
    i := 0.
    [i < height]
        whileTrue: [
            bitPen place: 0 @ (i + 1);
                goto: width @ (i + 1);
                place: 0 @ (i + anInteger - 1);
                goto: width @ (i + anInteger - 1).
            i := i + anInteger].
    bitPen foreColor: ClrBlack.
    i := 0.
    [i < width]
        whileTrue: [
            bitPen place: i @ 0;
                goto: i @ height.
            i := i + anInteger].
    i := 0.
    [i < height]
        whileTrue: [
            bitPen place: 0 @ i;
                goto: width @ i.
            i := i + anInteger]
    "
    "Draw grid lines with anInteger spacing on the receiver medium.
    Touched by Ale for non white lines when little scalling"
    | i len end width height |
    #modifiedByOStyle.
    width := copy width * scale.
    height := copy height * scale.
    anInteger > 7
    ifTrue: [
        bitPen foreColor: ClrWhite.
        i := 0.
        [i < width]
            whileTrue: [
                bitPen place: (i + 1)@ 0;
                    goto: (i + 1) @ height;
                    place: (i + anInteger - 1) @ 0;
                    goto: (i + anInteger - 1) @ height.
                i := i + anInteger].
        i := 0.
        [i < height]
            whileTrue: [
                bitPen place: 0 @ (i + 1);
                    goto: width @ (i + 1);
                    place: 0 @ (i + anInteger - 1);
                    goto: width @ (i + anInteger - 1).
                i := i + anInteger].
    ].
    bitPen foreColor: ClrBlack.
    i := 0.
    [i < width]
        whileTrue: [
            bitPen place: i @ 0;
                goto: i @ height.
            i := i + anInteger].
    i := 0.
    [i < height]
        whileTrue: [
            bitPen place: 0 @ i;
                goto: width @ i.
            i := i + anInteger]!  
initBitPen: aPane
    bitPen := aPane pen!   
initialize
        "Private - Initialize the receiver."
    bitColor := ClrDefault.
    super initialize!  
initImagePen: aPane
    imagePen := aPane pen!   
initWindowSize
        "Private - Answer the initial window extent."
    | size |
    size := 10 @ 10 min: (Display extent - windowSize).
    size :=  size extent: windowSize.
    ^size!   
isInGrid: aPoint
        "Private - Answer true if aPoint is in the grid."
    | gridRectangle |
    gridRectangle := 0 @ 0 extent: (copy extent * scale).
    (gridRectangle containsPoint: aPoint)
        ifTrue: [^true]
        ifFalse: [^false]! 
openOn: aBitmap
        "Open a BitEditor on aBitmap."
   self openOn: aBitmap clipRect: (0 @ 0 extent: aBitmap extent)!
openOn: aBitmap clipRect: aRect
    "Open a BitEditor on aBitmap.
    Touched by Ale for variable scale...
    Who touched this method? why?"
    | groupPane size imageSize |
    #modifiedByOStyle.
    scale := self scaleFor: aBitmap.
    imageForm := aBitmap.
    imageSize := (aRect extent min: imageForm extent) min:
        (Display width - 80 // scale @
            (Display height - 20 // scale)).
    imageRect := aRect origin extent:
        (aRect extent min: imageSize).
    imageSize := imageSize * scale + (5 @ 5).
    size := 76 @ (300 max: imageSize y).
    copy := Bitmap screenExtent: aRect extent.
    copy pen copyBitmap: aBitmap
        from: aRect
        at: 0 @ 0.
    self label: 'BitEditor'.
    self addSubpane: (
        GraphPane new
            model: self;
            when: #display perform: #displayImage:;
            style: GraphPane noScrollBarsFrameStyle;
            framingBlock: [: box |
                box origin extent: (size x @ (box height // 2))]).
    self addSubpane:
        (groupPane := GroupPane new
            framingBlock: [: box |
                box origin x @ (box origin y + (box height // 2))
                    extent: (size x @ (box height // 2))]).
    groupPane addSubpane:
        (Button new
            model: self;
            contents: 'Save';
            pushButton;
            when: #clicked perform: #save:;
            framingBlock: [: box |
                (box origin x + (box width // 6)) @ (box origin y + (box height // 6))
                    extent: (box width * 2 // 3) @ (box height // 3)]).
   groupPane addSubpane:
        (Button new
            model: self;
            contents: 'Exit';
            pushButton;
            when: #clicked perform: #exit:;
            framingBlock: [: box |
                (box origin x + (box width // 6)) @ (box origin y + (box height // 2))
                    extent: (box width * 2 // 3) @ (box height  // 3)]).
    self addSubpane:
        (GraphPane new
            owner: self;
            when: #getMenu perform: #editMenu:;
            when: #display perform: #displayBits:;
            when: #button1Down perform: #changeBits:;
            when: #button1Move perform: #changeBits:;
            style: GraphPane noScrollBarsFrameStyle;
            framingBlock: [: box |
                box origin x + (size x @ 0)  extent: (
                    (box width - size x) @ box height)]).
    #modifiedByOStyle.
    windowSize := 76 + imageSize x + 2 @
        (( 300 max: imageSize y) + SysFont height + 6) + scale.
    self openWindow.
    self menuWindow addMenu: (
        Menu colorMenu: self selector: #colorSelected:)!  
paste
    "Paste the clipboard's  bitmap into the receiver.
    Implemented by Ale..."
    | bmp |
    #addedByOStyle.
    bmp := Clipboard getBitmap.
    bmp isNil ifTrue: [^nil].
    (imagePen boundingBox extent = bmp extent
     or: [ (MessageBox confirm: 'Bitmap in the clipboard is not of the same extent.\Adjust bitmap size?'withCrs) not])
    ifTrue: [
        bmp
            displayAt: 0@0 with: imagePen;
            displayAt: 0@0 with: copy pen
    ]
    ifFalse: [
        imagePen copyBitmap: bmp from: bmp boundingBox to: imagePen boundingBox.
        copy pen copyBitmap: bmp from: bmp boundingBox to: copy pen boundingBox.
    ].
    self mainView invalidateRect: nil.!  
replace
    "Implemented by Ale..."
    | aPoint |
    #addedByOStyle.
    Notifier consumeInputUntil: [: event |
        event selector = #button1Up: ].
    aPoint := Cursor sense mapScreenToClient: bitPen graphicsMedium.
    ((0 @ 0 extent: bitPen graphicsMedium rectangle extent)
        containsPoint: aPoint)
            ifTrue: [self replaceAt: aPoint]!  
replaceAt: aPoint
    "Implemented by Ale... For full color replacement"
    | originalColor imagePoint fore replace color cursor |
    #addedByOStyle.
    cursor := Cursor.
    CursorManager execute change.
    imagePoint := aPoint // scale.
    originalColor := (WinAddress fromBytes:(GDILibrary getPixel: copy pen handle
        x: imagePoint x y: imagePoint y)) asInteger.
    replace := [:bmp|
        fore := bmp pen foreColor.
        bmp pen foreColor: bitColor.
        0 to: bmp height - 1 do: [:j|
            0 to: bmp width - 1 do: [:i|
                color := (WinAddress fromBytes:(
                  GDILibrary getPixel: bmp pen handle x: i y: j)) asInteger.
                originalColor = color
                ifTrue: [ bmp pen fill: (i@j extent: 1@1) color: bitColor ]
            ]
        ].
        copy pen foreColor: fore.
    ].

    replace value: copy.
    self displayImage: imagePen graphicsMedium.
    self displayBits: bitPen graphicsMedium.
    cursor change.!  
save: aButtton
    imageForm pen copyBitmap: copy
        from: copy boundingBox
        at: imageRect origin! 
scaleFor: aBitmap
    "Private Determine the most appropiate scale.
    Original scale value was fixed to 8 pixels.
    Implemented by Ale."

    | extent |
    #addedByOStyle.
    extent := (Display extent * 6 // 7 / aBitmap boundingBox extent) truncated.
    ^(((extent x min: extent y)max: 2) min: 10)! !

! ButtonEditor methods !   
changeBits: aPane
    | aPoint  changePoint imagePoint |
    aPoint := aPane mouseLocation.
    (self isInGrid: aPoint)
        ifFalse: [^self].
    imagePoint := aPoint // scale.
    changePoint := imagePoint * scale.
    changePoint printString.
    bitPen fill: ((changePoint + 2) extent: (scale @ scale) - 3)
        color: bitColor.
    imagePen fill: (imagePoint extent: 1 @ 1)
        color: bitColor.
    copy pen fill: (imagePoint extent: 1 @ 1)
        color: bitColor.
    (imagePoint x > (imageForm extent x / 2)) ifTrue: [ ^nil ].
    imagePoint := imagePoint + self offset.
    changePoint := imagePoint * scale.
    (self isInGrid: changePoint) ifFalse: [ ^self ].
    changePoint printString.
    bitPen fill: ((changePoint + 2) extent: (scale @ scale) - 3)
        color: bitColor.
    imagePen fill: (imagePoint extent: 1 @ 1)
        color: bitColor.
    copy pen fill: (imagePoint extent: 1 @ 1)
        color: bitColor! 
offset
    ^(imageForm width // 2)+2@2!  
open
    self openOn: 'TEMP2522.BMP'!
openOn: file
    file isString ifTrue: [
        fileName := file.
        self label: 'ButtonEditor [',file,']'.
        super openOn: (Bitmap fromFile: file)
    ] ifFalse: [
        self label: 'ButtonEditor [Untitled]'.
        super openOn: file
    ]! 
openOn: aBitmap clipRect: aRect
    "Open a BitEditor on aBitmap.
    Touched by Ale for variable scale..."
    | groupPane size imageSize |
    #modifiedByOStyle.
    scale := self scaleFor: aBitmap.
    imageForm := aBitmap.
    imageSize := (aRect extent min: imageForm extent) min:
        (Display width - 80 // scale @
            (Display height - 20 // scale)).
    imageRect := aRect origin extent:
        (aRect extent min: imageSize).
    imageSize := imageSize * scale + (5 @ 5).
    size := 76 @ (300 max: imageSize y).
    copy := Bitmap screenExtent: aRect extent.
    copy pen copyBitmap: aBitmap
        from: aRect
        at: 0 @ 0.
    self addSubpane: (
        GraphPane new
            model: self;
            when: #display perform: #displayImage:;
            style: GraphPane noScrollBarsFrameStyle;
            framingBlock: [: box |
                box origin extent: (size x @ (box height // 2))]).
    self addSubpane:
        (groupPane := GroupPane new
            framingBlock: [: box |
                box origin x @ (box origin y + (box height // 2))
                    extent: (size x @ (box height // 2))]).
    groupPane addSubpane:
        (Button new
            model: self;
            contents: 'Save';
            pushButton;
            when: #clicked perform: #save:;
            framingBlock: [: box |
                (box origin x + (box width // 6)) @ (box origin y + (box height // 6))
                    extent: (box width * 2 // 3) @ (box height // 3)]).
   groupPane addSubpane:
        (Button new
            model: self;
            contents: 'Exit';
            pushButton;
            when: #clicked perform: #exit:;
            framingBlock: [: box |
                (box origin x + (box width // 6)) @ (box origin y + (box height // 2))
                    extent: (box width * 2 // 3) @ (box height  // 3)]).
    self addSubpane:
        (GraphPane new
            owner: self;
            when: #getMenu perform: #editMenu:;
            when: #display perform: #displayBits:;
            when: #button1Down perform: #changeBits:;
            when: #button1Move perform: #changeBits:;
            style: GraphPane noScrollBarsFrameStyle;
            framingBlock: [: box |
                box origin x + (size x @ 0)  extent: (
                    (box width - size x) @ box height)]).
    #modifiedByOStyle.
    windowSize := 80 + imageSize x + 4 @
        (( 200 max: imageSize y) + SysFont height + 20 + scale).
    self openWindow.
    self menuWindow addMenu: (
        Menu colorMenu: self selector: #colorSelected:)!  
save: aPane
    | dialog file |
    super save: aPane.
    fileName isNil ifTrue: [ ^self ].
    dialog := FileDialog new
                        saveTitle: 'Save Bitmap'
                        fileName: fileName.
    file := dialog file.
    file isNil ifTrue: [^self].
    imageForm outputToFile: file.! !

! OSToolEditor methods ! 
changeBits: aPane
    | aPoint changePoint imagePoint shadeColor gridSize rect |

    "tool up drawing..."
    aPoint := aPane mouseLocation.
    (self isInGrid: aPoint) ifFalse: [^self].
    imagePoint := aPoint // scale.
    changePoint := imagePoint * scale.
    bitPen fill: ((changePoint + 2) extent: (scale @ scale) - 3) color: bitColor.
    imagePen fill: (rect := imagePoint extent: 1 @ 1) color: bitColor.
    copy pen fill: rect color: bitColor.

    "tool down drawing..."
    (imagePoint x > (imageForm extent x / 3)) ifTrue: [ ^nil ].
    imagePoint := imagePoint + self offset.
    changePoint := imagePoint * scale.
    bitPen fill: ((changePoint + 2) extent: (scale @ scale) - 3) color: bitColor.
    imagePen fill: (rect := imagePoint extent: 1 @ 1) color: bitColor.
    copy pen fill: rect color: bitColor.

    "tool disabled drawing..."
    gridSize := 2.
    (imagePoint x > (imageForm width * 2 // 3)) ifTrue: [ ^nil ].
    imagePoint := imagePoint + self offset - (3@4).
    shadeColor := (0@0 = (imagePoint - 1 \\ gridSize))
        ifTrue: [ ClrWhite ] ifFalse: [ bitColor ].
    changePoint := imagePoint * scale.
    bitPen fill: ((changePoint + 2) extent: (scale @ scale) - 3) color: shadeColor.
    imagePen fill: (rect := imagePoint extent: 1 @ 1) color: shadeColor.
    copy pen fill: rect color: shadeColor.! 
offset

    ^imageForm width // 3 +2@2! 
openOn: file
    file isString ifTrue: [
        fileName := file.
        super openOn: (Bitmap fromFile: file).
        self label: self class name,' [',file,']'.
    ] ifFalse: [
        super openOn: file.
        self label: self class name,' [Untitled]'.
    ]! !

! ChunkBrowser class methods !   
changesMenu
    "Create the changes menu"

    ^Menu new
        appendItem: 'Find...	Ctrl+F' selector: #find accelKey: $f accelBits: AfControl | AfChar;
        appendItem: 'Find Again...	Ctrl+G' selector: #again accelKey: $g accelBits: AfControl | AfChar;
        appendSeparator ;
        appendItem: 'Hide/Show	Ctrl+H' selector: #hide accelKey: $h accelBits: AfControl | AfChar;
        appendItem: 'Hide/Show Expression..	Ctrl+E' selector: #hideExpression accelKey: $e accelBits: AfControl | AfChar;
        appendItem: 'Hide/Show Selection...	Ctrl+S' selector: #hideSelection accelKey: $s accelBits: AfControl | AfChar;
        appendSeparator ;
        appendItem: 'Remove' selector: #remove;
        appendItem: 'Remove Expression...' selector: #removeExpression;
        appendItem: 'Remove Selection...' selector: #removeSelection;
        appendSeparator ;
        appendItem: 'Do It	Ctrl+D' selector: #doIt accelKey: $d accelBits: AfControl | AfChar;
        appendItem: 'Do It To End	Ctrl+T' selector: #doItToEnd accelKey: $t accelBits: AfControl | AfChar;
        appendItem: 'Do It All	Ctrl+A' selector: #doItAll accelKey: $a accelBits: AfControl | AfChar;
        title: '~Changes'
    "Modified: 29.06.93 / 08.21.36 / T.Lentzsch"!
classComment
    ^'This class contains the complete file handling and interactive mechanism'
    "Modified: 11.06.93 / 10.16.12 / T.Lentzsch"!  
classUpdate
    ^'
    "Modified: 11.06.93 / 10.16.12 / T.Lentzsch"'
    "Modified: 11.06.93 / 10.16.12 / T.Lentzsch"! 
conflictsMenu
    "Answer the option menu"

    ^Menu new
        appendItem: 'Check' selector: #check;
        appendSeparator ;
        appendItem: 'Confirm' selector: #confirm;
        appendItem: 'Compare' selector: #compare;
        title: 'Co~nflicts'
    "Modified: 02.06.93 / 13.47.22 / T.Lentzsch"!  
CHKBRcontents
    "Private - Create the chunk browser contents."

    | importBag methodBag initBag classBag |

    classBag := OrderedCollection new.

    classBag add: ChunkStructure.
    classBag add: ChunkPattern.
    classBag add: ChunkBrowser.
    classBag add: ChunkDialog.
    classBag add: ChunkReadStream.
    classBag add: ChunkTopPane.
    classBag add: ChunkTextPane.

    methodBag := OrderedCollection new.

    importBag := OrderedCollection new.

    initBag := OrderedCollection new.

    initBag add: (ChunkBrowser class compiledMethodAt: #CHKBRmessage).

    ^Array with: classBag with: methodBag with: importBag with: initBag
    "Modified: 29.06.93 / 08.40.15 / T.Lentzsch"!  
CHKBRdll
    "Script - Create the chunk browser library.
    ChunkBrowser CHKBRdll.
    "

    | lib unresolved ver log |

    ver := (String new: 2)
                at: 1 put: self CHKBRversion first;
                at: 2 put: self CHKBRversion last;
                yourself.

    log := (TextWindow new)
                label: 'Library transaction log';
                openOn: String new.

    lib := (Smalltalk at: #ObjectLibrary ifAbsent: [
                    (Smalltalk at: #ObjectLibraryBind) bindTo: 'vpmolb20'.
                    Smalltalk at: #ObjectLibrary
                ]) new: 'CHKBR' , ver , 'N'.

    lib description: 'Chunk Browser/V ' , self CHKBRversion , ' for Smalltalk/V'.
    lib feedback: log.
    lib includeSource: false.

    (self CHKBRcontents at: 1) do: [:elem | lib addClass: elem].
    (self CHKBRcontents at: 2) do: [:elem | lib addMethod: elem].
    (self CHKBRcontents at: 3) do: [:elem | lib addImport: elem].
    (self CHKBRcontents at: 4) do: [:elem | lib initMethod: elem].

    (unresolved := lib collectImports) notEmpty ifTrue: [
        unresolved inspect.
        ^self
    ].
    lib writeFile
    "Modified: 11.06.93 / 13.35.26 / T.Lentzsch"!  
CHKBRmessage
    "Protected - Print out a message when binding the object library"

    Transcript
        cr;show: 'Chunk Browser/V ',self CHKBRversion,' for Smalltalk/V';
        cr;show: 'Copyright (c) 1991-1993 VC Software Construction GmbH';
        cr;show: 'Written (w) by T.Lentzsch';
        cr;tab;show: 'ChunkBrowser open';cr.

    self ListBoxSetItemText.
    "Modified: 29.06.93 / 08.05.21 / T.Lentzsch"!   
CHKBRst
    "Script - Create the chunk browser source code dump.
    ChunkBrowser CHKBRst.
    "

    | string rs stream file ver |

    ver := (String new: 2)
                at: 1 put: self CHKBRversion first;
                at: 2 put: self CHKBRversion last;
                yourself.

    file := (FileDialog new saveFile: 'chkbr' , ver , '.st') file.
    file isNil ifTrue: [^nil].

    stream := File newFile: file.

    (self CHKBRcontents at: 1) do: [:class |
            class fileOutOn: stream.
            stream nextChunkPut: String new;cr
        ].
    (self CHKBRcontents at: 1) do: [:class |
            (ClassReader forClass: class class) fileOutOn: stream.
            (ClassReader forClass: class) fileOutOn: stream
        ].
    (self CHKBRcontents at: 4) do: [:elem |
        rs := ReadStream on: elem classField name.
        string := rs nextWord.
        (rs upTo: nil) trimBlanks = 'class'
        ifFalse: [string := string,' new'].

        stream
            cr;nextPutAll: '"evaluate"';
            nextChunkPut: string,' ',elem selector printString,'.';cr.
    ].

    stream close
    "Modified: 11.06.93 / 13.34.56 / T.Lentzsch"!  
CHKBRstwin
    "Script - Create the chunk browser source code dump.
    ChunkBrowser CHKBRstwin.
    "

    | string rs stream file ver s a |

    ver := (String new: 2)
                at: 1 put: self CHKBRversion first;
                at: 2 put: self CHKBRversion last;
                yourself.

    file := (FileDialog new saveFile: 'chkbr' , ver , 'w.st') file.
    file isNil ifTrue: [^self].

    stream := File newFile: file.

    (self CHKBRcontents at: 1) do: [:class |
            s := String new asStream.
            class fileOutOn: s.
            a := s contents asArrayOfSubstrings.
            s := String new.
            1 to: a size do: [:i | (a at: i) = 'PMConstants'
                ifTrue: [s := s , 'VirtualKeyConstants WinConstants ']
                ifFalse: [s := s , (a at: i) , ' ']].
            stream nextPutAll: s.
            stream
                nextChunkPut: String new;
                cr
        ].
    (self CHKBRcontents at: 1) do: [:class |
            (ClassReader forClass: class class) fileOutOn: stream.
            (ClassReader forClass: class) fileOutOn: stream
        ].
    (self CHKBRcontents at: 4) do: [:elem |
        rs := ReadStream on: elem classField name.
        string := rs nextWord.
        (rs upTo: nil) trimBlanks = 'class'
        ifFalse: [string := string,' new'].

        stream
            cr;nextPutAll: '"evaluate"';
            nextChunkPut: string,' ',elem selector printString,'.';cr.
    ].

    stream close
    "Modified: 11.06.93 / 13.34.08 / T.Lentzsch"! 
CHKBRversion
    "Answer the active chunk browser version"

    ^'3.1'
    "Modified: 11.06.93 / 12.58.44 / T.Lentzsch"!  
iconId
    "Answer the icon id for the receiver"
    ^1
    "Modified: 09.11.92 / 11.58.09 /  T.Lentzsch"! 
iconModule
    "Answer the module name for the icons"
    ^'chkbrres'
    "Modified: 13.05.93 / 11.22.31 / T.Lentzsch"!
ListBoxSetItemText
    "Public - If Method setItemText: doesn't exist in ListBox, create it"

    | result string |

    (ListBox selectors includes: #setItemText:) ifTrue: [^self].

    (Smalltalk includesKey: #PM)
    ifTrue: [
    string := 'setItemText: aString
    "Set the text for the selected item to aString"

    | l s index |

    handle = NullHandle ifTrue: [^self].

    (aString isString)
    ifTrue: [s := aString]
    ifFalse: [s := aString printString].

    s size > 512 ifTrue: [s := s copyFrom: 1 to: 512].

    index := self getSelection - 1.

    l := list deepCopy.
    list := l class new.
    1 to: index do: [:i| list add: (l at: i)].
    list := list,(list class with: aString).
    (index + 2) to: (l size) do: [:i| list add: (l at: i)].

    PMWindowLibrary
        sendMsg: handle
        msg: LmSetitemtext
        mp1: index
        mp2Struct: s asParameter.'.
    ]
    ifFalse: [
    string := 'setItemText: aString
    "Set the text for the selected item to aString"

    | index col size |

    size := self contents size.
    col := OrderedCollection new: size.
    index := self selectedIndex.
    1 to: size do: [:i |
        i = index
        ifTrue: [col add: aString]
        ifFalse: [col add: (list at: i)].
    ].

    self
        contents: col;
        selectIndex: index.'.
    ].

    result := ListBox compile: string notifying: Transcript.
    result isNil ifFalse: [
        Smalltalk
            logSource: string
            forSelector: result key
            inClass: ListBox.
    ].
    "Modified: 02.06.93 / 15.05.50 / T.Lentzsch"!  
open
    "Public - Open the chunk browser"

    ^self new open
    "Modified: 15.01.93 / 08.44.21 /  T.Lentzsch"! 
optionMenu
    "Answer the option menu"

    ^Menu new
        appendItem: 'Use Mark' selector: #useMark;
        appendItem: 'Reset Marked' selector: #resetMarked;
        appendItem: 'Remove Marked' selector: #removeMarked;
        appendSeparator ;
        appendItem: 'Recover Level...' selector: #setLevel;
        "appendSeparator ;
        appendItem: 'Debug' selector: #debug;"
        appendSeparator ;
        appendItem: 'Product Information...' selector: #info;
        title: '~Option'
    "Modified: 02.06.93 / 14.23.04 / T.Lentzsch"!
setupMenu
    "Answer the setup menu"

    ^Menu new
        appendItem: 'Display All' selector: #showAll;
        appendItem: 'Display Last' selector: #showLast;
        appendItem: 'Display Category' selector: #showCategory;
        appendItem: 'Display Same' selector: #showSame;
        appendSeparator ;
        appendItem: 'Load File...	Ctrl+L' selector: #loadFile  accelKey: $l accelBits: AfControl | AfChar;
        appendItem: 'Recover File...	Ctrl+R' selector: #recoverFile  accelKey: $r accelBits: AfControl | AfChar;
        appendSeparator ;
        appendItem: 'Create File...' selector: #createFile;
        appendItem: 'Append To File...' selector: #appendToFile;
        title: '~Setup'
    "Modified: 26.05.93 / 09.41.13 / T.Lentzsch"! !

! ChunkBrowser methods !
again
    "Protected - Find an item in the list"

    self find: false.
    "Modified: 14.05.93 / 09.18.59 / T.Lentzsch"! 
appendToFile
    "Protected - Append contents of item list to file"

    | file fStream array string |

    file := (FileDialog new saveFile: String new) file.
    file isNil ifTrue: [^self].

    CursorManager execute change.
    self labelWithoutPrefix: 'Saving...'.

    fStream := File pathName: file.
    fStream position: fStream readLimit;cr.

    self writeToFile: fStream.

    fStream close.

    self label: self labelString.
    CursorManager normal change
    "Modified: 15.01.93 / 07.50.17 /  T.Lentzsch"!   
buildMenuBar: aPane
    "Protected - Add setup menu to window"

    self menuWindow addMenu: self class setupMenu owner: self.
    self menuWindow addMenu: self class conflictsMenu owner: self.
    self menuWindow addMenu: self class optionMenu owner: self.
    "Modified: 25.05.93 / 12.15.47 / T.Lentzsch"! 
check
    "Protected - Check conflicts between the contents of
    the visible items in list an code in system"

    | stream |

    self labelWithoutPrefix: 'Checking conflicts...'.

    stream := WriteStream on: String new.

    self checkConflicts: stream.

    self label: self labelString.

    TextWindow new
        label: 'Possible conflicts';
        openOn: stream contents.
    "Modified: 29.06.93 / 08.17.45 / T.Lentzsch"!   
checkConflicts: stream
    "Protected - Check conflicts between the contents of
    the visible items in list an code in system"

    | bag bool form ssource string sel source class |

    bag := Bag new.

    visibleChanges do: [:struct |
        struct tilde ifFalse: [

            "set position in file"
            fileStream position: struct position.

            struct chunks = 2 ifTrue: [
                class := Smalltalk
                        at: struct className asSymbol
                        ifAbsent: [].

                class notNil ifTrue: [
                    struct classMethod ifTrue: [class := class class].
                    source := fileStream nextChunk.
                    sel := (self getMethod: source) asSymbol.

                    "search for conflict"
                    (class includesSelector: sel) ifTrue: [
                        string := struct className.
                        struct classMethod ifTrue: [string := string,' class'].
                        string := string,'>>',sel printString.

                        (bag includes: string) ifFalse: [
                            ssource := class sourceCodeAt: #sel.

                            form := Smalltalk
                                at: #SmalltalkFormatter
                                ifAbsent: [].
                            form notNil
                            ifTrue: [
                                bool := (form new tree: source) = (form new tree: ssource)]
                            ifFalse: [
                                bool := source = ssource].

                            bool ifFalse: [
                                bag add: string.
                                stream nextPutAll: string;cr.
                            ].
                        ].

                    ].
                ].
            ].
        ].
    ].

    (self propertyAt: #nextP) disabled ifFalse: [
        self next: (self propertyAt: #nextP).
        ^self checkConflicts: stream
    ].
    "Modified: 29.06.93 / 08.18.11 / T.Lentzsch"!  
className: aString
    "Protected - Check for class"

    | className string rs |

    rs := ReadStream on: aString.

    className := rs nextWord.
    string := rs nextWord.

    (((string = 'variableSubclass') or:
    [string = 'variableByteSubclass']) or:
    [string = 'subclass']) ifTrue: [^Array with: nil].

    (string = 'class')
    ifTrue: [^Array with: className with: true]
    ifFalse: [^Array with: className with: false].
    "Modified: 14.05.93 / 11.35.15 / T.Lentzsch"!   
close: aWindow
    "Protected - Close the file and exit"

    self reset.

     ((self propertyAt: #textP) respondsTo: #modified:)
    ifTrue: [(self propertyAt: #textP) modified: false].

    self mainView closeView.
    "Modified: 03.06.93 / 08.21.47 / T.Lentzsch"!  
compare
    "Protected - Toggle the compare mark"

    | menu |

    menu := self menuTitled: 'Conflicts'.

    (menu isChecked: #compare)
    ifTrue: [menu uncheckItem: #compare]
    ifFalse: [menu checkItem: #compare].
    "Modified: 25.05.93 / 12.10.31 / T.Lentzsch"!  
confirm
    "Protected - Toggle the confirm mark"

    | menu |

    menu := self menuTitled: 'Conflicts'.

    (menu isChecked: #confirm)
    ifTrue: [menu uncheckItem: #confirm]
    ifFalse: [menu checkItem: #confirm].
    "Modified: 25.05.93 / 12.10.23 / T.Lentzsch"!  
createFile
    "Protected - Create file with contents of item list"

    | file fStream array string |

    file := (FileDialog new saveFile: String new) file.
    file isNil ifTrue: [^self].

    CursorManager execute change.
    self labelWithoutPrefix: 'Saving...'.

    fStream := File newFile: file.

    self writeToFile: fStream.

    fStream close.

    self label: self labelString.
    CursorManager normal change
    "Modified: 15.01.93 / 07.51.11 /  T.Lentzsch"! 
disableSettings
    "Protected - Disable some menu items and buttons"

    (self menuTitled: 'Conflicts')
        disableItem: #check;
        disableItem: #confirm;
        disableItem: #compare.

    (self menuTitled: 'Option')
        disableItem: #useMark;
        disableItem: #resetMarked;
        disableItem: #removeMarked.

    (self menuTitled: 'Changes')
        disableItem: #find;
        disableItem: #again;
        disableItem: #hide;
        disableItem: #hideExpression;
        disableItem: #hideSelection;
        disableItem: #remove;
        disableItem: #removeExpression;
        disableItem: #removeSelection;
        disableItem: #doIt;
        disableItem: #doItToEnd;
        disableItem: #doItAll.

    (self menuTitled: 'Setup')
        disableItem: #createFile;
        disableItem: #appendToFile;
        checkItem: #showAll;
        uncheckItem: #showLast;
        disableItem: #showAll;
        disableItem: #showLast;
        disableItem: #showCategory;
        disableItem: #showSame.

    (self propertyAt: #previousP) disable.
    (self propertyAt: #nextP) disable.
    "Modified: 03.06.93 / 08.16.17 / T.Lentzsch"!   
displayText: aPane
    "Protected - Display contents for selected item"

    | struct string |

    (self propertyAt: #listP) selection isNil ifTrue: [^self].
    self enableSelectSettings.

    struct := visibleChanges at: (self propertyAt: #listP) selection.
    struct isNil ifTrue: [^self].

    fileStream position: struct position.
    string := fileStream nextChunk.

    (self propertyAt: #textP) contents: string
    "Modified: 03.06.93 / 08.23.47 / T.Lentzsch"!
doIt
    "Public -File in the selected item"

    CursorManager execute change.
    self labelWithoutPrefix: 'Compiling...'.

    self fileIn.

    self label: self labelString.
    CursorManager normal change.
    "Modified: 14.04.93 / 08.33.59 / T.Lentzsch"!
doItAll
    "Public -File in all entries from change list"

    (self propertyAt: #listP) selectIndex: 1.
    self doItToEnd.
    "Modified: 03.06.93 / 08.23.52 / T.Lentzsch"!  
doItToEnd
    "Public -File in from selected item of change list"

    | menu result methods aClass aSymbol loop |

    (MessageBox confirm: 'Start file in process...') ifFalse: [^self].

    self labelWithoutPrefix: 'Compiling...'.

    (self propertyAt: #textP) contents: String new.
    loop := true.

    self propertyAt: #dialog put: ChunkDialog new.
    (self propertyAt: #dialog) openAbortOn: self.
    self propertyAt: #abort put: false.

    Processor fork: [
        [loop] whileTrue: [
            (self propertyAt: #listP) selection to: visibleChanges size do: [:index |
                (self propertyAt: #abort) ifFalse: [
                    (self propertyAt: #listP) selectIndex: index.
                    self fileIn.
                ].
            ].

            loop := (self propertyAt: #nextP) disabled not.
            loop ifTrue: [self next: (self propertyAt: #nextP)].
          ].

        (self propertyAt: #dialog) close.
        self propertyAt: #dialog put: nil.

        self label: self labelString.

    ] at: Processor lowUserPriority.
    "Modified: 29.06.93 / 08.25.06 / T.Lentzsch"!   
enableSelectSettings
    "Protected - Enable some menu items"

    (self menuTitled: 'Changes')
        enableItem: #hide;
        enableItem: #remove;
        enableItem: #doIt;
        enableItem: #doItToEnd
    "Modified: 02.06.93 / 14.27.40 / T.Lentzsch"!   
enableSettings
    "Protected - Enable some menu items"

    (self menuTitled: 'Conflicts')
        enableItem: #check;
        enableItem: #confirm;
        enableItem: #compare.

    (self menuTitled: 'Option')
        enableItem: #useMark;
        enableItem: #resetMarked;
        enableItem: #removeMarked.

    (self menuTitled: 'Changes')
        enableItem: #find;
        enableItem: #again;
        enableItem: #hideExpression;
        enableItem: #hideSelection;
        enableItem: #removeExpression;
        enableItem: #removeSelection;
        enableItem: #doItAll.

    (self menuTitled: 'Setup')
        enableItem: #createFile;
        enableItem: #appendToFile;
        enableItem: #showAll;
        enableItem: #showLast;
        enableItem: #showCategory;
        enableItem: #showSame
    "Modified: 02.06.93 / 14.29.33 / T.Lentzsch"! 
exists: anIndex
    "Protected - Check if method exists"

    | sel aClass struct |

    struct := visibleChanges at: anIndex.
    self propertyAt: #class put: struct className.
    self propertyAt: #method put: (self getMethod: struct item).

    aClass := Smalltalk at: (self propertyAt: #class) asSymbol ifAbsent: [^false].

    aClass class = MetaClass
    ifTrue: [sel := (Smalltalk at: ((self propertyAt: #class) asSymbol)) class selectors]
    ifFalse: [sel := (Smalltalk at: ((self propertyAt: #class) asSymbol)) selectors].

    (sel includes: (self propertyAt: #method) asSymbol) ifFalse: [^false].

    ^true
    "Modified: 15.01.93 / 07.52.05 /  T.Lentzsch"!  
fileIn
    "Protected - File in the selected item"

    | result methods aClass aSymbol |

    result := self fileIn: (self propertyAt: #listP) selection.
    result ifFalse: [
        ((self menuTitled: 'Option') isChecked: #compare) ifTrue: [

            "reset window title and process flag"
            self label: self labelString.
            self propertyAt: #abort put: true.

            "get methods to be compared"
            aClass := Smalltalk at: (self propertyAt: #class) asSymbol ifAbsent: [].
            aSymbol := (self propertyAt: #method) asSymbol.
            methods := OrderedCollection new.
            (aClass includesSelector: aSymbol)
            ifTrue: [methods add: (aClass compiledMethodAt: aSymbol)].
            (aClass class includesSelector: aSymbol)
            ifTrue: [methods add: (aClass class compiledMethodAt: aSymbol)].

            MethodBrowser new openOn: methods.

            ^false
        ].
    ].

    ^true
    "Modified: 03.06.93 / 08.24.07 / T.Lentzsch"! 
fileIn: anIndex
    "Protected - File in the selected item"

    | answer menu struct ws |

    struct := visibleChanges at: anIndex.
    struct tilde ifTrue: [^true].

    answer := true.
    (self exists: anIndex) ifTrue: [
        menu := self menuTitled: 'Conflicts'.
        (menu isChecked: #confirm) ifTrue: [
            answer := MessageBox
                confirm: 'Method found in system. Overwrite...'.
        ].
    ].
    answer ifFalse: [^false].

    "set position in file"
    fileStream position: struct position.

    struct chunks = 1 ifTrue: [
        ws := WriteStream on: String new.
        ws nextPutAll: fileStream nextChunk.

        (self propertyAt: #textP) doIt: ws contents ifFail: [].
    ]
    ifFalse: [
        ws := ReadWriteStream on: String new.

        ws
            nextPut: (Character value: 33);
            nextPutAll: struct className.
        struct classMethod ifTrue: [ws nextPutAll: ' class'].
        ws
            nextPutAll: ' methods';
            nextChunkPut: String new;
            nextChunkPut: fileStream nextChunk.

        (ChunkReadStream on: ws contents) fileIn: self.
    ].

    self setMark.

    ^true
    "Modified: 03.06.93 / 08.22.04 / T.Lentzsch"!
find
    "Protected - Find an item in the list"

    self find: true.
    "Modified: 14.05.93 / 09.18.37 / T.Lentzsch"!   
find: aBoolean
    "Protected - Find an item in the list"

    | struct pattern string startIndex |

    aBoolean
    ifTrue: [
        string := self propertyAt: #find.
        string isNil ifTrue: [string := String new].

        string := Prompter prompt: 'Enter Search String' default: string.
        string isNil ifTrue: [^self].
        self propertyAt: #find put: string.
    ]
    ifFalse: [string := self propertyAt: #find].

    pattern := ChunkPattern new: string.
    (self propertyAt: #listP) selection isNil
    ifTrue: [startIndex := 1]
    ifFalse: [startIndex := (self propertyAt: #listP) selection].

    startIndex to: visibleChanges size do: [:i |

        struct := visibleChanges at: i.
        string := struct className.
        string isEmpty
        ifTrue: [string := (self propertyAt: #listP) contents at: i]
        ifFalse: [
            struct classMethod ifTrue: [string := string,' class'].
            string := string,'>>',struct item.
        ].

        i > startIndex ifTrue: [
            (pattern match: string) ifTrue: [
                (self propertyAt: #listP) selectIndex: i;setFocus.
                self displayText: (self propertyAt: #listP).
                ^self
            ].
        ].
    ].

    (self propertyAt: #nextP) disabled ifFalse: [
        self next: (self propertyAt: #nextP).
        ^self find: false
    ].

    MessageBox message: 'No Match'.
    "Modified: 03.06.93 / 08.25.40 / T.Lentzsch"! 
findLast: aString
    "Protected - Find the save statement in the file"

    | index line list pos |

    list := OrderedCollection new.
    fileStream reset.
    pos := fileStream position.

    [fileStream atEnd] whileFalse: [

        pos := fileStream position.
        line := fileStream nextLine.

        "evaluate line"
        line isEmpty ifFalse: [
            line first = $" ifTrue: [
                ((Pattern new: aString) match: line index: 1) notNil
                ifTrue: [list add: pos].
            ].
        ].
    ].

    index := (list size + 1 - (self propertyAt: #recoverLevel)) max: 1.

    list isEmpty
    ifTrue: [^nil]
    ifFalse: [^list at: index].
    "Modified: 26.01.93 / 15.45.15 /  T.Lentzsch"! 
getMethod: aString
    "Public -Extract method name out of sourcecode."

    | p cc s nsp nsp1 c aString1 |

    s := aString size.
    nsp := 1.
    cc := 1.

    aString1 := String new: 512.

    c := $E.
    [(c = $: )] whileFalse: [
        (cc > s) ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ].
        c := aString at: cc.
        (c = $") ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ].
        cc := cc + 1.
        (c <= $ )
        ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ]
        ifFalse: [ aString1 at: nsp put: c. nsp := nsp + 1. ].
    ].

    [cc > s] whileFalse: [

        [ (cc > s) ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ].
            c := aString at: cc.
            (c = $") ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ].
            cc := cc + 1.
            (c <= $ )] whileTrue: [].

        c := $E.
        [(c <= $ )] whileFalse: [
            (cc > s) ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ].
            c := aString at: cc.
            (c = $") ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ].
            cc := cc + 1.
        ].

        [ (cc > s) ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ].
            c := aString at: cc.
            (c = $") ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ].
            cc := cc + 1.
            (c <= $ ) ] whileTrue: [].

        nsp1 := nsp.
        aString1 at: nsp1 put: c.
        nsp1 := nsp1 + 1.
        c := $E.
        [(c = $:)] whileFalse: [
            (cc > s) ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ].
            c := aString at: cc.
            (c = $") ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ].
            cc := cc + 1.
            (c <= $ )
            ifTrue: [ ^aString1 copyFrom: 1 to: (nsp - 1) ]
            ifFalse: [ aString1 at: nsp1 put: c. nsp1 := nsp1 + 1. ].
        ].

        nsp := nsp1.
    ].

    ^aString1 copyFrom: 1 to: (nsp - 1)
    "Modified: 15.01.93 / 07.52.50 /  T.Lentzsch"!   
hide
    "Protected - Hide an item"

    self hideShow: String new.
    "Modified: 15.01.93 / 07.52.57 /  T.Lentzsch"!
hide: aPane
    "Protected - Hide an item"

    self hideShow: String new.
    "Modified: 15.01.93 / 07.53.01 /  T.Lentzsch"! 
hideExpression
    "Protected - Find an item in the list"

    | loop struct pattern string find |

    find := self propertyAt: #find.
    find isNil ifTrue: [find := String new].

    string := Prompter prompt: 'Enter search string' default: find.
    string isNil ifTrue: [^nil].
    self propertyAt: #find put: string.

    CursorManager execute change.

    pattern := ChunkPattern new: string.
    loop := true.

    [loop] whileTrue: [
        visibleChanges do: [:struct |
            string := struct className.
            string isEmpty
            ifTrue: [string := 'doIt ']
            ifFalse: [
                struct classMethod ifTrue: [string := string,' class'].
                string := string,'>>'
            ].
            string := string,struct item.

            (pattern match: string) ifTrue: [struct tilde: struct tilde not].
        ].

        loop := (self propertyAt: #nextP) disabled not.
        loop ifTrue: [self next: (self propertyAt: #nextP)].
    ].

    CursorManager normal change.
    self update.
    "Modified: 03.06.93 / 08.18.42 / T.Lentzsch"!
hideSelection
    "Protected - Create a modal item list"

    ChunkDialog new
        propertyAt: #action put: #hideOk:;
        openOn: self.
    "Modified: 03.06.93 / 08.28.39 / T.Lentzsch"!
hideShow: aString
    "Protected - Hide an item from the visible list"

    | struct string className |

    aString isEmpty
    ifFalse: [
        changes do: [:struc |
            (struc className = aString
            or: [    (struc className isEmpty
                and: [aString trimBlanks = 'doIt'])]) ifTrue: [struc tilde: struc tilde not].
        ]
    ]
    ifTrue: [
        struct := visibleChanges at: (self propertyAt: #listP) selection.
        string := (self propertyAt: #listP) selectedItem.

        "toggle mode"
        string first ~= $~
        ifTrue: [
            string := '~',string.
            struct tilde: true.
        ]
        ifFalse: [
            string := string copyFrom: 2 to: string size.
            struct tilde: false.
        ].

        (self propertyAt: #listP) setItemText: string.
    ].
    "Modified: 03.06.93 / 08.25.56 / T.Lentzsch"!
info
    "Open a message box with a product information"

    MessageBox
        titled: String new
        withText: 'Chunk Browser/V
Version ',self class CHKBRversion,'

Copyright (c) 1992-1993
VC Software Construction GmbH

38118 Braunschweig
Petritorwall 28
Germany

Phone +49 531 / 24240-0
Fax   +49 531 / 24240-24

Written (w) by T.Lentzsch'
    style: MbOk.
    "Modified: 29.06.93 / 08.10.19 / T.Lentzsch"!
initWindowSize
    "Public - Answer default initial window extent"

    ^430@420
    "Modified: 26.05.93 / 09.49.36 / T.Lentzsch"!
labelString
    "Answer the label string"

    ^'Chunk Browser/V'
    "Modified: 26.05.93 / 09.53.54 / T.Lentzsch"!   
loadFile
    "Protected - Load the complete file"

    | file |

    file := FileDialog new openFile file.
    file isNil ifTrue: [^self].

    self
        reset;
        disableSettings.

    fileStream := File pathNameReadOnly: file.

    self
        setPath: file;
        labelWithoutPrefix: 'Loading...';
        scanFile;
        label: self labelString;
        update.
    "Modified: 02.06.93 / 12.47.28 / T.Lentzsch"!  
menu: aPane
    "Protected - Setup the changes menu"

    aPane setMenu: self class changesMenu
    "Modified: 15.01.93 / 07.56.42 /  T.Lentzsch"!
next: aPane
    "Display the next lines in the  list"

    | last positions second |

    second := self propertyAt: #secondPosition.
    positions := self propertyAt: #positions.

    second notNil ifTrue: [
        positions add: second.
        self propertyAt: #secondPosition put: nil.
    ].

    last := positions last.

    (self propertyAt: #previousP) enable.
    self update.

    positions last = last ifTrue: [(self propertyAt: #nextP) disable].
    "Modified: 03.06.93 / 08.16.34 / T.Lentzsch"!   
open
    "Public - Open the change browser."

    self propertyAt: #recoverLevel put: 1.
    self propertyAt: #useMark put: false.

    self
        reset;
        label: self labelString;
        when: #close perform: #close:;
        when: #menuBuilt perform: #buildMenuBar:.

    self propertyAt: #listP put: ListBox new.
    self addSubpane: ((self propertyAt: #listP) owner: self;
        when: #select perform: #displayText:;
        when: #doubleClickSelect perform: #hide:;
        when: #getMenu perform: #menu:;
        framingBlock: [:box |
            box leftTop
                rightBottom:
                    (box rightTop
                        leftAndDown: 0 @ (box height * 54 // 100))
        ]).

    self propertyAt: #textP put: ChunkTextPane new.
    self addSubpane:((self propertyAt: #textP) owner: self;
        framingBlock: [:box |
            (box leftTop rightAndDown: 0 @ (box height * 54 // 100))
                rightBottom:
                    (box rightTop
                        leftAndDown: 0 @ (box height * 958 // 1000))
        ]).

    self propertyAt: #infoP put: StaticText new.
    (self propertyAt: #infoP) backColor: ClrPalegray.
    self addSubpane:((self propertyAt: #infoP) owner: self;
        framingBlock: [:box |
            (box leftTop rightAndDown: 1 @ (box height * 958 // 1000))
                rightBottom: (box rightBottom left: (box width * 10 // 100)).
        ]).

    self propertyAt: #previousP put: Button new.
    self addSubpane:((self propertyAt: #previousP) owner: self;
        contents: '-';
        when: #clicked perform: #previous:;
        framingBlock: [:box |
            (box leftTop rightAndDown: (box width * 90 // 100) @ (box height * 958 // 1000))
                extentFromLeftTop: (box width * 5 // 100) @ (box height * 42 // 1000).
        ]).

    self propertyAt: #nextP put: Button new.
    self addSubpane:((self propertyAt: #nextP) owner: self;
        contents: '+';
        when: #clicked perform: #next:;
        framingBlock: [:box |
            (box leftTop rightAndDown: (box width * 95 // 100) @ (box height * 958 // 1000))
                extentFromLeftTop: (box width * 5 // 100) @ (box height * 42 // 1000).
        ]).

    self
        openWindow;
        disableSettings.
    "Modified: 03.06.93 / 08.24.48 / T.Lentzsch"! 
previous: aPane

    | positions |

    positions := self propertyAt: #positions.

    positions size = 2 ifTrue: [self propertyAt: #secondPosition put: positions last].
    positions size > 1 ifTrue: [positions removeLast].

    (self propertyAt: #nextP) enable.
    self update: false.

    positions size = 1 ifTrue: [(self propertyAt: #previousP) disable].
    "Modified: 03.06.93 / 08.17.34 / T.Lentzsch"!   
propertyAt: key
    "Protected - Answer the value associated with key
    in the properties dictionary."

    properties isNil ifTrue: [^nil].
    ^properties at: key ifAbsent: [^nil]
    "Modified: 15.01.93 / 07.56.53 /  T.Lentzsch"!  
propertyAt: key put: aValue
    "Protected - Set the value associated with key
    in the properties dictionary."

    properties isNil ifTrue: [properties := IdentityDictionary new].
    aValue isNil ifTrue: [
        ^properties removeKey: key ifAbsent: []].
    properties at: key put: aValue
    "Modified: 15.01.93 / 07.56.58 /  T.Lentzsch"!
recoverFile
    "Protected - Load new file upto the save statment specified by the recover level"

    | file pos |

    file := FileDialog new openFile file.
    file isNil ifTrue: [^self].

    self
        reset;
        disableSettings.

    fileStream := File pathNameReadOnly: file.

    self
        setPath: file;
        labelWithoutPrefix: 'Loading...'.

    pos := self findLast: '*** saved image on: '.
    pos isNil ifTrue: [pos := 0].

    fileStream position: pos.

    self
        scanFile;
        label: self labelString;
        update.
    "Modified: 02.06.93 / 12.42.43 / T.Lentzsch"! 
remove
    "Protected - Remove item from list"

    self remove: String new.
    "Modified: 15.01.93 / 07.49.14 /  T.Lentzsch"!   
remove: aString
    "Protected - Remove an item from the visible list"

    | index list menu stream string |

    menu := self menuTitled: 'Conflicts'.
    (menu isChecked: #confirm) ifTrue: [
        (MessageBox confirm: 'Remove item') ifFalse: [^nil]].

    aString notEmpty
    ifTrue: ["remove all items equal to aString"
        changes do: [:struct |
            (struct className = aString
            or: [(struct className isEmpty
                and: [aString trimBlanks = 'doIt'])]) ifTrue: [struct displayMode: 2].
        ].
    ]
    ifFalse: ["remove selected item only"
        index := (self propertyAt: #listP) selection.

        (visibleChanges at: (self propertyAt: #listP) selection) displayMode: 2.
    ].

    list := OrderedCollection new.
    changes do: [:struct | struct isRemoved ifFalse: [list add: struct]].
    changes := list.

    self update.
    "Modified: 03.06.93 / 08.26.07 / T.Lentzsch"!  
removeExpression
    "Protected - Find an item in the list"

    | loop struct pattern string find |

    find := self propertyAt: #find.
    find isNil ifTrue: [find := String new].

    string := Prompter prompt: 'Enter search string' default: find.
    string isNil ifTrue: [^nil].
    self propertyAt: #find put: string.

    CursorManager execute change.

    pattern := ChunkPattern new: string.
    loop := true.

    [loop] whileTrue: [
        visibleChanges do: [:struct |
            string := struct className.
            string isEmpty
            ifTrue: [string := 'doIt ']
            ifFalse: [
                struct classMethod ifTrue: [string := string,' class'].
                string := string,'>>'
            ].
            string := string,struct item.

            (pattern match: string) ifTrue: [struct displayMode: 2].
        ].

        loop := (self propertyAt: #nextP) disabled not.
        loop ifTrue: [self next: (self propertyAt: #nextP)].
    ].

    CursorManager normal change.
    self update.
    "Modified: 03.06.93 / 08.18.51 / T.Lentzsch"!   
removeMarked
    "Protected - Remove all hidden entries from list"

    visibleChanges do: [:struct |
        struct tilde ifTrue: [struct displayMode: 2]].

    self update.
    "Modified: 26.01.93 / 15.44.13 /  T.Lentzsch"!  
removeSelection
    "Protected - Open a window"

    ChunkDialog new
        propertyAt: #action put: #removeOk:;
        openOn: self.
    "Modified: 03.06.93 / 08.28.27 / T.Lentzsch"!   
reset
    "Protected - Reset change list"

    | menu |

    self propertyAt: #positions put: (OrderedCollection with: 1).
    self propertyAt: #secondPosition put: nil.

    changes := OrderedCollection new.
    visibleChanges := OrderedCollection new.

    fileStream notNil ifTrue: [
        fileStream close.
        fileStream := nil.
    ].

    views isEmpty ifFalse: [
        menu := self menuWindow menuTitled: 'Setup'.
        menu
            uncheckItem: #showCategory;
            uncheckItem: #showSame;
            uncheckItem: #showLast.
    ].
    "Modified: 02.06.93 / 11.31.53 / T.Lentzsch"!
resetMarked
    "Protected - Reset all marked entries"

    visibleChanges do: [:struct | struct tilde: false].
    self update.
    "Modified: 15.01.93 / 07.48.19 /  T.Lentzsch"!  
scanFile
    "Protected - Scan the filestream and extract item, positions and kind of
    entry in list"

    | array string rs loop line className entry source pos struct |

    [fileStream atEnd] whileFalse: [

        pos := fileStream position.
        source := fileStream nextChunk trimBlanks.

        source isEmpty ifFalse: [

            "evaluate / define class"
            source first = $" ifTrue: [
                rs := ChunkReadStream on: source.
                rs upTo: $";upTo: $".
                source := (rs upTo: nil) trimBlanks.

                source size > 60
                ifTrue: [line := (source copyFrom: 1 to: 60),'...']
                ifFalse: [line := source].

                struct := ChunkStructure new
                    item: line;
                    position: pos;
                    chunks: 1;
                    className: String new;
                    classMethod: false;
                    displayMode: 0;
                    hidden: false;
                    yourself.

                changes add: struct.
            ]
            ifFalse: [
                array := self className: source.
                (array at: 1) isNil
                ifTrue: [
                    source size > 60
                    ifTrue: [line := (source copyFrom: 1 to: 60),'...']
                    ifFalse: [line := source].

                    struct := ChunkStructure new
                        item: line;
                        position: pos;
                        chunks: 1;
                        className: String new;
                        classMethod: false;
                        displayMode: 0;
                        hidden: false;
                        yourself.

                    changes add: struct.
                ]
                ifFalse: [
                    className := array at: 1.
                    (array at: 2)
                    ifTrue: [entry := className,' class>>']
                    ifFalse: [entry := className,'>>'].

                    loop := true.
                    [loop] whileTrue: [
                        pos := fileStream position.

                        string := fileStream nextChunk trimBlanks.

                        string isEmpty
                        ifTrue: [loop := false]
                        ifFalse: [
                            struct := ChunkStructure new
                                item: (self getMethod: string);
                                position: pos;
                                chunks: 2;
                                className: className;
                                classMethod: (array at: 2);
                                displayMode: 0;
                                tilde: false;
                                yourself.

                            changes add: struct.
                        ].
                    ].
                ].
            ].

        ].
    ]
    "Modified: 11.06.93 / 09.40.44 / T.Lentzsch"! 
setLevel
    "Protected - Set the active recover level"

    | level answer |

    level := Prompter
                prompt: 'Enter recover level'
                default: (self propertyAt: #recoverLevel) printString.

    level notNil ifTrue: [self propertyAt: #recoverLevel put: level asInteger].

    (self propertyAt: #recoverLevel) < 1 ifTrue: [
        answer := MessageBox confirm: 'Level must be greater 1...'.
        answer
        ifTrue: [self propertyAt: #recoverLevel put: 1]
        ifFalse: [self setLevel].
    ]
    "Modified: 14.05.93 / 11.39.35 / T.Lentzsch"!  
setMark
    "Protected - Set hide mark"

    | struct string |

    (self propertyAt: #useMark)    ifTrue: [
        struct := visibleChanges at: (self propertyAt: #listP) selection.
        string := (self propertyAt: #listP) selectedItem.

        string first = $~ ifFalse: [
            string := '~',string.
            struct tilde: true.
        ].

        (self propertyAt: #listP) setItemText: string;setFocus.
    ].
    "Modified: 03.06.93 / 08.26.14 / T.Lentzsch"! 
setPath: aString
    "Protected - Display path information"

    | post string stream |

    aString size > 30
    ifTrue: [
        string := (aString copyFrom: 1 to: 3),'...\'.
        stream := ReadStream on: aString reversed.
        post := (stream upTo: $\) reversed.
        string := string,(stream upTo: $\) reversed,'\',post.
    ]
    ifFalse: [string := aString].

    (self propertyAt: #infoP)
        contents: string asUpperCase,
        '   ',
        fileStream readLimit printString,
        ' Bytes'.
    "Modified: 03.06.93 / 08.14.27 / T.Lentzsch"!  
showAll
    "Protected - Show all change list entries"

    (self menuTitled: 'Setup') checkItem: #showAll;uncheckItem: #showLast.

    changes do: [:struct | struct isHidden ifTrue: [struct displayMode: 0]].

    self update.
    self displayText: (self propertyAt: #textP)
    "Modified: 03.06.93 / 08.22.17 / T.Lentzsch"! 
showCategory
    "Protected - Display all entries with equal first part of item"

    | menu stream string |

    menu := self menuWindow menuTitled: 'Setup'.

    (menu isChecked: #showCategory)
    ifTrue: [
        changes do: [:struct | struct isClass ifTrue: [struct displayMode: 0]].
        menu uncheckItem: #showCategory.
    ]
    ifFalse: [
        stream := ReadStream on: (self propertyAt: #listP) selectedItem.
        string := stream nextWord trimBlanks.

        changes do: [:struct |
            struct isVisible ifTrue: [
                struct className isEmpty
                ifTrue: [
                    string = 'doIt' ifFalse: [struct displayMode: 3].
                ]
                ifFalse: [
                    struct className = string
                    ifFalse: [struct displayMode: 3].
                ].
            ].
        ].

        menu checkItem: #showCategory.
    ].

    self update.
    self displayText: (self propertyAt: #textP).
    "Modified: 03.06.93 / 08.25.03 / T.Lentzsch"!
showLast
    "Protected - Display only the last modified entries"

    | changeDict item |

    (self menuTitled: 'Setup') checkItem: #showLast;uncheckItem: #showAll.

    changeDict := Dictionary new.

    "check changes in reverse order"
    changes reverseDo: [:struct |
        struct isVisible
        ifTrue: [
            item := struct className,struct item,struct classMethod printString.

            (changeDict includesKey: item)
            ifTrue: [struct displayMode: 1]
            ifFalse: [changeDict at: item put: nil]
        ].
    ].

    self update.
    self displayText: (self propertyAt: #textP).
    "Modified: 03.06.93 / 08.22.24 / T.Lentzsch"!   
showSame
    "Protected - Display all identical entries"

    | rest stream word menu item string |

    menu := self menuWindow menuTitled: 'Setup'.

    (menu isChecked: #showSame)
    ifTrue: [
        changes do: [:struct | struct isSame ifTrue: [struct displayMode: 0]].
        menu uncheckItem: #showSame.
    ]
    ifFalse: [
        item := (self propertyAt: #listP) selectedItem.
        stream := ReadStream on: item.
        word := stream nextWord trimBlanks.
        rest := stream nextLine trimBlanks.

        changes do: [:struct |
            struct isVisible ifTrue: [
                string := struct className.
                string isEmpty
                ifTrue: [
                    word = 'doIt'
                    ifTrue: [
                        ((ChunkPattern new: (rest,'*'))
                            match: struct item) ifFalse: [struct displayMode: 4].
                    ]
                    ifFalse: [struct displayMode: 4].
                ]
                ifFalse: [
                    struct classMethod ifTrue: [string := string,' class'].
                    string := string,'>>'.
                    string := string,struct item.
                    item = string ifFalse: [struct displayMode: 4].
                ].

            ].
        ].

        menu checkItem: #showSame.
    ].

    self update.
    self displayText: (self propertyAt: #textP).
    "Modified: 03.06.93 / 08.25.09 / T.Lentzsch"!   
topPaneClass
    "Answer the class which is used as top pane"

    ^ChunkTopPane
    "Modified: 02.06.93 / 12.38.18 / T.Lentzsch"!
update
    "Protected - Update list"

    self update: true.
    "Modified: 13.05.93 / 11.01.24 / T.Lentzsch"!
update: aBoolean
    "Protected - Update list. If aBoolean is true update the position
    list too."

    | startIndex list string menu bytes struct update positions |

    list := OrderedCollection new.
    visibleChanges := OrderedCollection new.
    bytes := 0.
    update := true.
    positions := self propertyAt: #positions.
    startIndex := positions last.

    "check all entries in change list"
    startIndex to: changes size do: [:i |

        update ifTrue: [
            struct := changes at: i.

            struct isVisible ifTrue: [
                string := struct className.
                string isEmpty
                ifTrue: [string := '  doIt ']
                ifFalse: [
                    struct classMethod ifTrue: [string := string,' class'].
                    string := string,'>>'.
                ].
                string := string,struct item.

                struct tilde ifTrue: [string := '~',string].

                bytes := bytes + string size.
                bytes > 16384
                ifTrue: [
                    update := false.
                    (self propertyAt: #nextP) enable.
                    aBoolean ifTrue: [(self propertyAt: #positions) add: i].
                ]
                ifFalse: [
                    list add: string.
                    visibleChanges add: struct.
                ].
            ].
        ].

    ].

    "update the list contents"
    (self propertyAt: #listP) contents: list.
    list isEmpty
    ifTrue: [
        (self propertyAt: #textP) contents: String new.

        menu := self menuWindow menuTitled: 'Setup'.
        (menu isChecked: #showLast) ifTrue: [^nil].
        (menu isChecked: #showCategory) ifTrue: [^nil].
        (menu isChecked: #showSame) ifTrue: [^nil].

        self disableSettings.
    ]
    ifFalse: [
        self enableSettings.
        (self propertyAt: #listP) selectIndex: 1;setFocus.
        self displayText: (self propertyAt: #listP).
    ].
    "Modified: 03.06.93 / 08.26.26 / T.Lentzsch"! 
useMark
    "Protected - Toggle the marker mark"

    | menu |

    menu := self menuTitled: 'Option'.

    (menu isChecked: #useMark)
    ifTrue: [menu uncheckItem: #useMark]
    ifFalse: [menu checkItem: #useMark].

    self propertyAt: #useMark put: (menu isChecked: #useMark).
    "Modified: 15.01.93 / 07.46.47 /  T.Lentzsch"!   
visibleChanges
    "Answer the instance variable"

    ^visibleChanges
    "Modified: 15.01.93 / 07.46.37 /  T.Lentzsch"! 
writeToFile: fStream
    "Protected - Write the contents of the change list to a chunk formatted file"

    | string |

    visibleChanges do: [:struct |

        (struct isVisible
        and: [struct tilde not]) ifTrue: [
            fileStream position: struct position.

            struct chunks = 1
            ifTrue: [fStream nextChunkPut: fileStream nextChunk;cr;cr]
            ifFalse: [
                "create class / methods header"
                string := struct className.
                struct classMethod ifTrue: [string := string,' class'].
                string := string,' methods '.

                fStream
                    nextPut: (Character value: 33);
                    nextPutAll: string;
                    nextPut: (Character value: 33);
                    nextChunkPut: fileStream nextChunk;
                    nextChunkPut: String new;
                    cr;cr.
            ].
        ].
    ].

    (self propertyAt: #nextP) disabled ifFalse: [
        self next: (self propertyAt: #nextP).
        ^self writeToFile: fStream
    ].
    "Modified: 29.06.93 / 08.04.16 / T.Lentzsch"! !

! ClassHierarchyBrowser methods ! 
canDrop: anObject into: aPane
    "Private - True if the receiver can handle anObject now...
    Implemented by Ale for drag&drop support"
    #modifiedByOStyle.

    ^anObject isBehavior
    or: [
        anObject isCompiledMethod
        "   and: [ anObject classField isClass ]   "
    ]!  
copyToClipboard
    "Private - Write the source for the selected class
        in chunk file format to the clipboard..
    Implemented by Ale..."
    | stream |
    #addedByOStyle.
    selectedClass isNil ifTrue: [^self].
    stream := WriteStream on: String new.
    CursorManager execute change.
    selectedClass fileOutOn: stream.
    stream nextChunkPut: String new.
    (ClassReader forClass: selectedClass class) fileOutOn: stream.
    (ClassReader forClass: selectedClass) fileOutOn: stream.
    CursorManager normal change.
    Clipboard setString: stream contents.! 
disableClassesMenu
    "Private - Disable the classes menu.
     Touched by Ale for more functionality"
    #modifiedByOStyle.
    (self menuTitled: '&Classes')
        disableItem: #removeSubClass;
        disableItem: #fileOut;
        disableItem: #fileOutWithSubclasses;
        disableItem: #printOut;
        disableItem: #printOutWithSubclasses;
        disableItem: #hideShow;
        disableItem: #browse;
        disableItem: #addSubClass;
        disableItem: #removeSources;
        disableItem: #copyToClipboard!   
disableMethodsMenu
    "Private - Disable the methods menu.
     Touched by Ale for more functionality"
    #modifiedByOStyle.
    (self menuTitled: '&Methods')
        disableItem: #removeSelector;
        disableItem: #removeSelectorSources;
        disableItem: #senders;
        disableItem: #implementors;
        disableItem: #messages;
        disableItem: #localSenders;
        disableItem: #localImplementors;
        disableItem: #printOutMethod;
        disableItem: #fileOutMethod.
    selectedClass isNil
        ifTrue: [(self menuTitled: '&Methods')
            disableItem: #newMethod]
        ifFalse: [(self menuTitled: '&Methods')
            enableItem: #newMethod]! 
drop: anObject into: aPane
    "Private - Set the current class & method with anObject
    Implemented by Ale for drag&drop support"
    #addedByOStyle.
    anObject isBehavior
    ifTrue: [ self findClass: anObject symbol ].

    anObject isCompiledMethod
    ifTrue: [
        self findClass: anObject classField symbol.
        anObject classField isClass
        ifTrue: [self instanceButton: nil ]
        ifFalse: [self classButton: nil ].
        (self paneAt: #selectors:) restoreSelected: anObject selector.
        self changed: #text:.
    ].

    (self paneAt: #text:) setFocus!   
enableClassesMenu
    "Private - Enable the classes menu.
     Touched by Ale for more functionality"
    #modifiedByOStyle.
    (self menuTitled: '&Classes')
        enableItem: #removeSubClass;
        enableItem: #fileOut;
        enableItem: #fileOutWithSubclasses;
        enableItem: #printOut;
        enableItem: #printOutWithSubclasses;
        enableItem: #hideShow;
        enableItem: #browse;
        enableItem: #addSubClass;
        enableItem: #removeSources;
        enableItem: #copyToClipboard!   
enableMethodsMenu
    "Private - Enable the methods menu.
     Touched by Ale for more functionality"
    #modifiedByOStyle.
    (self menuTitled: '&Methods')
        enableItem: #removeSelector;
        enableItem: #removeSelectorSources;
        enableItem: #newMethod;
        enableItem: #senders;
        enableItem: #implementors;
        enableItem: #messages;
        enableItem: #localSenders;
        enableItem: #localImplementors;
        enableItem: #printOutMethod;
        enableItem: #fileOutMethod.!
endPrinting: device
    "Private - Write the remaining contents
    in the output device to the printer.
    Implemented By Ale"
    #modifiedByOStyle.
    device contents size > 0
    ifTrue: [device contents outputToPrinter]! 
fileNameFor: aClass
    "Private - Returns an apropiate file name for aClass.
    Implemented By Ale"
    #modifiedByOStyle.
        ^(aClass respondsTo: #abreviation)
        ifTrue: [aClass abreviation]
        ifFalse: [aClass name]!
fileOut
    "Private - Write the source for the selected class
     in chunk file format to a file named with the class
     name reduced to 8 characters, extension 'cls'.
    Touched By Ale..."
    | file cursor |
    #modifiedByOStyle.
    selectedClass isNil
        ifTrue: [^self].
    file := (FileDialog new
        saveTitle: 'File out ', selectedClass name, ' class'
        fileName: (
            File
                fileName: (self fileNameFor: selectedClass)
                extension: 'cls')) file.
    file isNil ifTrue: [^self].
    file := File newFile: file.
    cursor := Cursor.
    CursorManager execute change.
    selectedClass fileOutOn: file.
    file nextChunkPut: String new.
    (ClassReader forClass: selectedClass class) fileOutOn: file.
    (ClassReader forClass: selectedClass) fileOutOn: file.
    file close.
    cursor change.!   
fileOutWithSubclasses
    "Private - Write the source for the selected class
    as well as its subclasses in chunk file format to
    a file named with the class
    name reduced to 8 characters, extension 'st'.
    Touched By Ale..."
    | file classes |
    #modifiedByOStyle.
    selectedClass isNil
        ifTrue: [^self].
    file := (FileDialog new
        saveTitle: 'File out ', selectedClass name, ' class and its subclasses'
        fileName: (
            File
                fileName: (self fileNameFor: selectedClass)
                extension: 'st')) file.
    file isNil ifTrue: [^self].
    CursorManager execute change.
    file := File newFile: file.
    (classes := selectedClass withAllSubclasses) do: [:c |
        c fileOutOn: file.
        file nextChunkPut: String new.
    ].
    classes do: [:c |
        (ClassReader forClass: c class) fileOutOn: file.
        (ClassReader forClass: c) fileOutOn: file].
    file close.
    CursorManager normal change.!   
findClass
        "Private - Prompt for a class to search for, and position at
         that point in the hierarchy.
    Touche by Ale for simil classes"
    | className class supers blanks result match simil |
    #modifiedByOStyle.
    self textModified ifTrue: [^self].
    className := Prompter prompt: 'Select a class to browse' default: ''.
    (className isNil or: [className isEmpty])
        ifTrue: [ ^ self ].
    className := className asSymbol.
    class := Smalltalk at: className ifAbsent: [ "Search for similar names..."
        simil := Array with: 0 with: nil.
        Smalltalk keysDo: [:key|
            match := key matchOf: className.
            match > simil first
            ifTrue: [
                simil
                    at: 1 put: match;
                    at: 2 put: key
            ]
        ].
        Smalltalk at: simil last ifAbsent: []
    ].
    (class isBehavior) ifFalse: [
        ^MessageBox message: '"', className,
                        '" is not a class.' ].
    CursorManager execute change.
    supers := (Array with: class), class allSuperclasses.
    blanks := 0.
    1 to: supers size do: [ :i |
        (originalClasses includes: (supers at: i))
           ifTrue: [ blanks := i ]].
    blanks = 0 ifTrue: [
        CursorManager normal change.
        ^MessageBox message: 'Class "', className,
                        '" not found in this browser.' ].
    supers do: [ :cl |
        hiddenClasses remove: cl ifAbsent: []].
    self update: originalClasses.
    methodSelectedLast := false.
    selectedMethod := nil.
    selectedInstVar := nil.
    selectedClass := class.
    self changed: #hierarchy:
        with: #restoreSelected:
        with: (((String new: ((blanks - 1 max: 0) * 2)) atAllPut: $ ),
            class name).
    self enableClassesMenu.
    self disableMethodsMenu.
    self
        changed: #instanceVars: ;
        changed: #selectors: ;
        changed: #text:.
    CursorManager normal change.! 
findClass: aClassName
    "Private - Position at class name aClassName in the hierarchy.
    Touched By Ale"
    | className class supers blanks result simil match |
    #modifiedByOStyle.
    className := aClassName.
    (className isNil or: [className isEmpty])
        ifTrue: [ ^ self ].
    className := className trimBlanks asSymbol.
    class := Smalltalk at: className
    ifAbsent: [ "Search for similar names..."
        simil := Array with: 0 with: nil.
        Smalltalk keysDo: [:key|
            match := key matchOf: className.
            match > simil first
            ifTrue: [
                simil
                    at: 1 put: match;
                    at: 2 put: key
            ]
        ].
        Smalltalk at: simil last ifAbsent: []
    ].
    (class isBehavior) ifFalse: [
        ^MessageBox message: '"', className,
                        '" is not a class.' ].
    CursorManager execute change.
    supers := (Array with: class), class allSuperclasses.
    blanks := 0.
    1 to: supers size do: [ :i |
        (originalClasses includes: (supers at: i))
           ifTrue: [ blanks := i ]].
    blanks = 0 ifTrue: [
        CursorManager normal change.
        ^MessageBox message: 'Class "', className,
                        '" not found in this browser.' ].
    supers do: [ :cl |
        hiddenClasses remove: cl ifAbsent: []].
    self update: originalClasses.
    methodSelectedLast := false.
    selectedMethod := nil.
    selectedInstVar := nil.
    selectedClass := class.
    self changed: #hierarchy:
        with: #restoreSelected:
        with: (((String new: ((blanks - 1 max: 0) * 2)) atAllPut: $ ),
            class name).
    self enableClassesMenu.
    self disableMethodsMenu.
    self
        changed: #instanceVars: ;
        changed: #selectors: ;
        changed: #text:.
    CursorManager normal change! 
instVarSetUp: instVarPane
        "Private - An instance variable was selected as
         visible/modifiable by outside.
        Implemented By Ale"
    | selected result aClass compileBlock |
    #modifiedByOStyle.
    aClass := instanceSelectedLast
        ifTrue: [selectedClass]
        ifFalse: [selectedClass class].
    selected := instVarPane selectedItem.
    (aClass instVarNames includes: selected)
    ifFalse: [Terminal bell.^nil].
    compileBlock := [:aString|
    result := self compile: aString
        notifying: Transcript pane
        in: aClass.
    result isNil
        ifTrue: [
            MessageBox
                message: ('Compiler Error compiling :\',aString) withCrs
        ]
        ifFalse: [
            Smalltalk
                logSource: aString
                forSelector: result key
                inClass: aClass]
     ].

    compileBlock
        value: selected,'
    "Returns the instance var of the receiver
     for external manipulation"
    ^',selected;
        value: selected,': anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    ',selected,' := anObject'.

    methodSelectedLast := false.
    selectedInstVar :=  nil.
    self disableMethodsMenu.
 "   self changed: #instanceVars:.  "
    self changed: #selectors:.
    self changed: #text:!   
isWBClassBrowser
    "Added by OSI"
    #addedByOSI.
    ^true!
menu: hierarchyPane
    "Private - Set the hierarchy pane menu.
     Touched By Ale..."
    #modifiedByOStyle.
    hierarchyPane setMenu: ((Menu
        labels: '&Add Subclass...\File &Out...\File Ou&t All...\&Print Out..\Pr&int Out All...\&Update\&Hide/Show\&Browse\&Find Class...\&Who Uses...\&Remove Class\Remove &Sources\Copy to Clipboard' withCrs
        lines: #(1 3 5 8 10 12)
        selectors: #(addSubClass fileOut fileOutWithSubclasses printOut printOutWithSubclasses update hideShow browse findClass whoUses removeSubClass removeSources copyToClipboard))
            title: '&Classes';
            owner: self;
            yourself)!   
openOn: aCollection
        "Create a class hierarchy browser window giving access
         to the classes in aCollection and their subclasses."
    | ratio groupPane |
    #modifiedByOStyle.

    hiddenClasses := Set new.
    (aCollection includes: Object)
        ifTrue: [
            aCollection do: [ :class |
                class subclasses do: [:each |
                    each subclasses isEmpty
                        ifFalse: [
                            hiddenClasses add: each]]]]
        ifFalse: [
            aCollection do: [ :class |
                class subclasses isEmpty
                    ifFalse: [
                        hiddenClasses add: class]]].
    ratio := 2 / 5.
    self update: aCollection.
     instanceSelectedLast := true.
    methodSelectedLast := false.
    assigned := used := true.
    self
        owner: self;
        label: self label;
        icon: (Icon fromModule: Icon defaultDLLFileName id:'ClassHierarchyBrowser').
    self addSubpane:
        (ListBox new
            owner: self;
            when: #getContents perform: #hierarchy: ;
            when: #select perform: #hierarchySelected: ;
            when: #doubleClickSelect perform: #hideShow: ;
            when: #getMenu perform: #menu: ;
            when: #charInput perform: #hierarchyCharInput: ;
            framingRatio:
                (Rectangle leftTopUnit extentFromLeftTop: 3/8 @ ratio)).
    self addSubpane:
        (ListBox new
            owner: self;
            when: #getContents perform: #instanceVars: ;
            when: #select perform: #instanceVar: ;
            when: #doubleClickSelect perform: #instVarSetUp: ;
            when: #getMenu perform: #instVarsMenu: ;
            framingBlock: [:box|
                box leftTop + ((box width * 3/8) truncated @ (2 *
                    (ButtonFont height + 4) ))
                  rightBottom: (box width * 5//8) @ ((box height * ratio) truncated)]).
    self addSubpane:
        (ListBox new
            owner: self;
            when: #getContents perform: #selectors: ;
            when: #select perform: #selector: ;
            when: #getMenu perform: #selectorMenu: ;
            framingRatio:
                (Rectangle leftTopUnit + (5/8 @ 0)
                    extentFromLeftTop: 3/8 @ ratio)).
    self addSubpane: (groupPane := GroupPane new
        framingBlock: [:box| box leftTop + ((box width * 3//8) @ 0)
            rightBottom: ((box width * 5//8)@(box leftTop y + (2 *
                    (ButtonFont height + 4) )))]).
    groupPane addSubpane:
        (RadioButton new
            owner: self;
            contents: 'instance';
            when: #clicked perform: #instanceButton:;
            selection: true;
            framingRatio: (1/15 @ 0 extentFromLeftTop: 14/15 @ (1/2))).
    groupPane addSubpane:
        (RadioButton new
            owner: self;
            contents: 'class';
            when: #clicked perform: #classButton:;
            framingRatio: (1/15 @ (1/2) extentFromLeftTop: 14/15 @ (1/2))).
    self addSubpane:
        (TextPane new
            owner: self;
            when: #getContents perform: #text: ;
            when: #save perform: #accept: ;
            framingRatio: (Rectangle leftBottomUnit
              extentFromLeftBottom: 1 @ (1 - ratio))).
    self openWindow.
    self disableClassesMenu.
    self disableMethodsMenu.
    self checkInstVarMenu! 
openSelecting: selectingClass

    "Added by OSI"

    | aCollection blanks supers ratio groupPane |
    #addedByOSI.
    aCollection := Array with: Object.

    hiddenClasses := Set new.
    aCollection do: [ :class |
        class subclasses do: [:each |
            each subclasses isEmpty ifFalse: [
                hiddenClasses add: each
            ]
        ]
    ].

    ratio := 2 / 5.
    self update: aCollection.
     instanceSelectedLast := true.
    methodSelectedLast := false.
    assigned := used := true.
    self
        owner: self;
        label: self label.
    self addSubpane:
        (ListBox new
            owner: self;
            when: #getContents perform: #hierarchy: ;
            when: #select perform: #hierarchySelected: ;
            when: #doubleClickSelect perform: #hideShow: ;
            when: #getMenu perform: #menu: ;
            when: #charInput perform: #hierarchyCharInput: ;
            framingRatio:
                (Rectangle leftTopUnit extentFromLeftTop: 3/8 @ ratio)).
    self addSubpane:
        (ListBox new
            owner: self;
            when: #getContents perform: #instanceVars: ;
            when: #select perform: #instanceVar: ;
            when: #getMenu perform: #instVarsMenu: ;
            framingBlock: [:box|
                box leftTop + ((box width * 3/8) truncated @ (2 *
                    (ButtonFont height + 4) ))
                  rightBottom: (box width * 5//8) @ ((box height * ratio) truncated)]).
    self addSubpane:
        (ListBox new
            owner: self;
            when: #getContents perform: #selectors: ;
            when: #select perform: #selector: ;
            when: #getMenu perform: #selectorMenu: ;
            framingRatio:
                (Rectangle leftTopUnit + (5/8 @ 0)
                    extentFromLeftTop: 3/8 @ ratio)).
    self addSubpane: (groupPane := GroupPane new
        framingBlock: [:box| box leftTop + ((box width * 3//8) @ 0)
            rightBottom: ((box width * 5//8)@(box leftTop y + (2 *
                    (ButtonFont height + 4) )))]).
    groupPane addSubpane:
        (RadioButton new
            owner: self;
            contents: 'instance';
            when: #clicked perform: #instanceButton:;
            selection: true;
            framingRatio: (1/15 @ 0 extentFromLeftTop: 14/15 @ (1/2))).
    groupPane addSubpane:
        (RadioButton new
            owner: self;
            contents: 'class';
            when: #clicked perform: #classButton:;
            framingRatio: (1/15 @ (1/2) extentFromLeftTop: 14/15 @ (1/2))).
    self addSubpane:
        (TextPane new
            owner: self;
            when: #getContents perform: #text: ;
            when: #save perform: #accept: ;
            framingRatio: (Rectangle leftBottomUnit
              extentFromLeftBottom: 1 @ (1 - ratio))).
    supers := (Array with: class), selectingClass allSuperclasses.
    blanks := 0.
    1 to: supers size do: [ :i |
        (originalClasses includes: (supers at: i))
           ifTrue: [ blanks := i ]].
    supers do: [ :cl |
        hiddenClasses remove: cl ifAbsent: []].

    self openWindow.

    self update: originalClasses.
    methodSelectedLast := false.
    selectedMethod := nil.
    selectedInstVar := nil.
    selectedClass := selectingClass.
    self changed: #hierarchy:
        with: #restoreSelected:
        with: (((String new: ((blanks - 1 max: 0) * 2)) atAllPut: $ ),
            selectingClass name).
    self
        changed: #instanceVars: ;
        changed: #selectors: ;
        changed: #text:.
    CursorManager normal change.!
printingDevice
        "Private - Returns the printer device for the receiver..
    Implemented by Ale..."
    #addedByOStyle.
    ^(Smalltalk at: #PrinterStream
        ifAbsent: [^WriteStream on: (String new: 1000)]
        ) new!
printOut
        "Private - Write the source for the selected class
         in chunk file format to the printer..
    Implemented by Ale..."
    | printer |
    #addedByOStyle.
    selectedClass isNil ifTrue: [^self].
    printer := self printingDevice.
    CursorManager execute change.
    selectedClass fileOutOn: printer.
    (ClassReader forClass: selectedClass class) fileOutOn: printer.
    (ClassReader forClass: selectedClass) fileOutOn: printer.
    printer nextPut: 12 asCharacter.
    self endPrinting: printer.
    CursorManager normal change!   
printOutMethod
        "Private - Write the source for the selected method
         in chunk file format to the printer.
        Implemented by Ale"
    | printer |
    #addedByOStyle.
    selectedClass isNil ifTrue: [^self].
    selectedMethod isNil ifTrue: [^self].
    printer := self printingDevice.
    CursorManager execute change.
    (ClassReader forClass:
        (instanceSelectedLast
                ifTrue: [selectedClass]
                ifFalse: [selectedClass class]))
        fileOutMethod: selectedMethod on: printer.
    printer nextPut: 12 asCharacter.
    self endPrinting: printer.
    CursorManager normal change!  
printOutWithSubclasses
        "Private - Write the source for the selected class
         as well as its subclasses in chunk file format to
         the printer.
        Implemented by Ale"
    | printer |
    #addedByOStyle.
    selectedClass isNil ifTrue: [^self].
    printer := self printingDevice.
    CursorManager execute change.
    selectedClass withAllSubclasses do: [:c |
        c fileOutOn: printer.
        printer nextChunkPut: String new.
        (ClassReader forClass: c class) fileOutOn: printer.
        (ClassReader forClass: c) fileOutOn: printer.
        printer nextPut: 12 asCharacter
    ].
    self endPrinting: printer.
    CursorManager normal change.!   
removeSelector
    "Private - Remove the selected method.
    Touched by Ale for placing of the removed source in clipboard"
    | aString method |
    #modifiedByOStyle.
    methodSelectedLast ifFalse: [^nil].
    selectedMethod isNil ifTrue: [^nil].
    instanceSelectedLast
        ifTrue: [
            method := selectedClass
                compiledMethodAt: selectedMethod.
            selectedClass removeSelector:
                selectedMethod.
            aString := selectedClass name]
        ifFalse: [
            method := selectedClass class
                compiledMethodAt: selectedMethod.
            selectedClass class removeSelector:
                selectedMethod.
            aString := selectedClass class name].
    Smalltalk logEvaluate:
        aString, ' removeSelector: #', selectedMethod.
    methodSelectedLast := false.
    selectedMethod := nil.

    aString := method source.
    aString isNil
    ifFalse: [Clipboard setString: aString].

    self
        changed: #selectors: with: #restore;
        changed: #text:! 
removeSelectorSources
        "Private - Remove the selected method sources..
    Implemented by Ale..."
    | aString |
    #addedByOStyle.
    methodSelectedLast
        ifFalse: [^nil].
    selectedMethod isNil
        ifTrue: [^nil].
    instanceSelectedLast
        ifTrue: [
            selectedClass removeSourcesOfSelector:
                selectedMethod.
            aString := selectedClass name]
        ifFalse: [
            selectedClass class removeSourcesOfSelector:
                selectedMethod.
            aString := selectedClass class name].
    self
        changed: #text:! 
removeSources
        "Private - Delete the selected class sources references.
    Implemented by Ale..."
    | newName subclassType answer |
    #addedByOStyle.
    selectedClass isNil
        ifTrue: [^nil].
    (MessageBox
        confirm: 'Delete Sources references for ', selectedClass name, '?')
        ifFalse: [^nil].
    CursorManager execute change.
    selectedClass removeSources.
    selectedMethod := nil.
    methodSelectedLast := false.
    self
        changed: #selectors: ;
        changed: #text:!
selectedClass

    "Added by OSI"
    #addedByOSI.
    ^selectedClass!
selectedMethod

    "Added by OSI"
    #addedByOSI.
    ^selectedMethod!  
selectorMenu: selectorPane
    "Private - Set the selector pane menu..
    Touched By Ale..."
    #modifiedByOStyle.
    selectorPane setMenu: ((Menu
        labels: '&New Method\&Senders\&Implementors\Local Senders\Local Implementors\&Messages\&PrintOut\&File Out...\&Remove\Remove &Source' withCrs
        lines: #(1 6 8)
        selectors: #( newMethod senders implementors localSenders localImplementors messages printOutMethod fileOutMethod removeSelector removeSelectorSources))
            title: '&Methods';
            owner: self;
            yourself)! 
statusPaneHelp:aKey
        "Private - Answer the default dictionary used by
        the status bar for help support."

    ^(Smalltalk at: #HelpClassHierarchyBrowser ifAbsent: [^nil]) at:aKey ifAbsent:[^super statusPaneHelp:aKey]!   
text: textPane
   "Private - Set the source text for
    the selected method or class definition
    for the selected class.
    Touched by Ale for comment support."
    | answer aClass |
    #modifiedByOStyle.
    selectedClass isNil
        ifTrue: [^textPane contents: String new].
    methodSelectedLast
        ifTrue: [
            aClass := instanceSelectedLast
                ifTrue: [selectedClass]
                ifFalse: [selectedClass class].
            selectedMethod isNil
                ifTrue: [^textPane contents: (self template)]
                ifFalse: [^textPane contents: (aClass sourceCodeAt: selectedMethod)]].
    answer := WriteStream on: (String new: 100).
    selectedClass fileOutOn: answer.
    ((selectedClass respondsTo: #comment) and: [selectedClass comment size > 0])
    ifTrue: [
        answer cr;nextPutAll: '  comment:
    ',selectedClass comment printString
    ].
    textPane contents: (answer contents )!   
whoUses
        "Private - Prompt for a global variable to search for, and position at
         that point in the hierarchy..
    Implemented by Ale..."
    | className class supers blanks result |
    #addedByOStyle.
    self textModified ifTrue: [^self].
    className := Prompter prompt: 'Name of global to search ?'
         default: (selectedClass isNil ifTrue: [''] ifFalse: [selectedClass name]).
    ^self whoUses: className.!   
whoUses: aName
        "Private - Find methods referencing the global variable named aName..
    Implemented by Ale..."
    #addedByOStyle.
    aName isNil ifTrue: [^nil].
    Smalltalk sendersOf:
        (Smalltalk
            associationAt: aName trimBlanks asSymbol
            ifAbsent: [
                MessageBox message: ' Global variable ',aName,' not found'.
                ^nil
            ])! !

! CategoryBrowser class methods !   
addUserDefinition: aLabel block: aBlock
 "Add a user defined Block to the CC-Menu"
 | ud |
 Options isNil ifTrue: [ Options := Dictionary new ].
 ud := Options at: #UD ifAbsent: [ Options at: #UD put: (ud := Dictionary new). ud ].
 ud at: aLabel put: aBlock.!  
dllNameWithVersion
 "Return the dll-name"
 ^(self isBeta
  ifTrue: [ 'CAT00' ]
  ifFalse: [ 'CATBR' ]),self versionHigh,self versionLow!  
iconId
 ^300!
iconModule
 ^'CATBR'!
initCATBR
	"Protected - Print out a message when binding the object library"

 Smalltalk isRunTime ifFalse: [
  self isBeta
   ifTrue: [(MessageBox message: 'This is a beta-dll. You cannot save your image anymore !!')].
  Transcript
   cr;show: 'CategoryBrowser ',CategoryBrowser version,'; ',Smalltalk product,' v',Smalltalk version;
   cr;show: 'Copyright (C) 1993 VC Software Construction';
   cr;show: 'Written (W) by Edgar Voss';
   cr;show: '  CategoryBrowser open'.
 ].!  
initializeUserDefinitions
 "In this method the user can write his own function-definitions. The contents of this method will be evaluated each time a CategoryBrowser is opened. In the example a menuitem named '3 * Bell' will be added to the classcategorymenu. In the parameter cb the CategoryBrowser itself will be passed."

 "Example:
 self addUserDefinition: '3 * Bell'
  block: [ :cb | 3 timesRepeat: [ Terminal bell ] ]."!   
isBeta
 "Return true if Version is a beta-version"
 ^self versionCode first = $0!   
open
 "Open the Browser"
 ^CategoryBrowser new openOn: Smalltalk rootClasses!   
plz
 "PRIVAT - Return the PLZ of Braunschweig"
 ^'38118'!   
removeUserDefinition: aLabel
 "Remove a user defined Block from the CC-Menu"
 Options isNil ifTrue: [ ^self ].
 (Options at: #UD ifAbsent: [ Dictionary new ])
  removeKey: aLabel ifAbsent: [].! 
reset
 "reset the classvariables"
 "CategoryBrowser reset."
 Options := nil.
 Save := nil.!   
version
 "Return the versionstring"
 | p |
 (self isBeta)
  ifTrue: [ p := 'beta-' ]
  ifFalse: [ p := 'v' ].
 ^p,(self versionHigh),'.',(self versionLow).!
versionCode
 "Return the version with four digits"
 ^'3025'!
versionHigh
 "Return the main version number"
 ^String with: self versionCode first!
versionLow
 "Return the minor version number"
 ^String with: self versionCode last! !

! CategoryBrowser methods !
aboutCategoryBrowser
 "open an aboutWindow"
 MessageBox message: '
CategoryBrowser ',self class version,'

(w) Edgar Voss, 1993

(c) VC Software Construction
Petritorwall 28
',self class plz,' Braunschweig
Germany
Phone: +49 531 24240-0
Fax: +49 531 24240-24'!  
accept: textPane
 "Private - Accept the contents of textPane
 as an updated method
 or class specification and compile it."
 | result aClass aString m |
 aString := textPane contents.
 methodSelectedLast
  ifFalse: [
    m := self acceptClass: aString from: textPane.
    m first
     ifFalse: [ (m last respondsTo: #classComment:)
      ifTrue: [ (m last respondsTo: #classComment)
       ifTrue: [ (m last classComment: (self methodHistoryIn: m last classComment)) ]
       ifFalse: [ (m last classComment: (self methodHistoryIn: String new)) ]. ]
      ifFalse: [ ((m last respondsTo: #comment) and: [ m last respondsTo: #comment: ])
      ifTrue: [ m last comment: (self methodHistoryIn: m last comment) ]. ].
     self changed: #categories:.
     self paneCat selection: selectedCategory ].
    ^textPane modified: false ].
 aString := self methodHistoryIn: textPane contents.
 aClass := self realClass.
 result := self compile: aString
  notifying: self
  in: aClass.
 result isNil
  ifTrue: [textPane modified: true]
  ifFalse: [
    CategoryManager addClass: aClass toCategory: self catCHANGED.
    (self paneCat contents includes: self catCHANGED)
     ifFalse: [ self changed: #categories:.
      selectedCategory isNil
       ifTrue: [ selectedCategory := self catALL ].
      self paneCat selection: selectedCategory. ].
   Smalltalk
    logSource: aString
    forSelector: result key
    inClass: aClass.
   (CategoryManager addMethod: result key toCategory: self catCHANGED inClass: aClass)
    ifTrue: [ self changed: #methodCategories:.
     self paneMCat selection: selectedMethodCategory ].
   result key == selectedMethod
    ifFalse: [
     selectedMethod := result key.
     CategoryManager addMethod: selectedMethod toCategory: self catCHANGED inClass: aClass.
     selectedMethodCategory notNil
      ifTrue: [ (CategoryManager addMethod: result key toCategory: selectedMethodCategory inClass: aClass)
       ifTrue: [ self changed: #methodCategories:.
        self paneMCat selection: selectedMethodCategory ] ].
     self changed: #selectors:
      with: #restoreSelected:
      with: selectedMethod;
       enableMethodsMenu].
     textPane modified: false ].
 self updateINFOpane.! 
acceptClass: aString from: aPane
 "Private - Accept aString as an updated
 class specification and compile it.  Notify
 aPane if the compiler detects errors."
 | result |
 result := Compiler
  evaluate: aString
  in: nil class
  to: nil
  notifying: aPane
  ifFail: [^Array with: true].
 Smalltalk logEvaluate: aString.
 self changed: #instanceVars:.
 result := Array with: ((result isKindOf: Class) not) with: result.
 result first
  ifFalse: [CategoryManager addClass: result last toCategory: self catCHANGED.].
 ^result.!  
addCategory
 "Add a category"
 | name pc |
 name := self getString: 'Name of new category: ' default: String new.
 (CategoryManager addCategory: name)
  ifFalse: [ ^self ].
 self changed: #categories:.
 selectedCategory isNil
  ifFalse: [ self paneCat selection: selectedCategory ].!   
addClasses
 "select classes and add them to the selected category"
 | value r o |
 self isCatSelected
  ifFalse: [ ^self ].
 value := Prompter
  prompt: 'Enter smalltalk expression'
  defaultExpression: buffer.
 value isNil ifTrue: [^nil].
 CursorManager execute change.
 (value isKindOf: Collection)
  ifFalse: [ value := Array with: value ].
 r := false.
 value do: [ :c | o := (CategoryManager addClass: c toCategory: selectedCategory).
  o ifTrue: [ browsedClasses add: c symbol ].
  r := r | o. ].
 r ifTrue: [
  self changed: #hierarchy:.
  selectedClass isNil
   ifFalse: [ self paneClasses selection: selectedClass symbol ].
 ].
 CursorManager normal change!   
addClasses: aCollection at: anInteger
 "Private - Add aCollection of classes to
 browsedClasses, each preceded by anInteger
 number of spaces.  anInteger indicates the
 level in the hierarchy."
 self isCatSelected
  ifFalse: [
   (aCollection asSortedCollection: Class sortBlock)
    do: [ :class |
     class symbol trimBlanks isEmpty
      ifFalse: [browsedClasses add:
       ((String new: anInteger * 2) atAllPut: $ )
       ,class symbol.
       (hiddenClasses includes: class)
        ifTrue: [browsedClasses add:
         browsedClasses
         removeLast, '...']
        ifFalse: [
         self addClasses: class subclasses at: anInteger + 1]]]]
  ifTrue: [ (CategoryManager instanceClassesAt: selectedCategory)
   do: [ :class | browsedClasses add: class asSymbol ]].!   
addHistory: aString
 "add a historyline to aString"
 | h user ws |
 user := Smalltalk at: #UserID ifAbsent: [
  user := Options at: #UserID ifAbsent: [ String new ].
  user isEmpty
   ifTrue: [[ user := Prompter prompt: 'Enter a user-id' default: String new.
    (user isNil or: [ user isEmpty ]) ]
     whileTrue: [].
    Options at: #UserID put: user. ].
    user ].
 ws := WriteStream on: String new.
 ((aString size > 0) and: [aString last < $ ])
  ifFalse: [ ws nextPutAll: ' ';cr;nextPutAll: ' '. ]
  ifTrue: [ ws nextPutAll: ' ' ].
 ws nextPutAll: '   "Modified: ',Date today printString,' / ',Time now printString,' / ',user,'"'.
 ^aString,(ws contents).!   
addOptionsMenu: aPane
 "add a menu to aPane"
 | a m |
 a := aPane menuWindow.
 m := Menu new
  appendItem: 'Set Buffersize...' selector: #setBufferSize;
  appendItem: 'Show Save' selector: #showSave.
 ((String new respondsTo: #addHistory) and:
  [Smalltalk includesKey: #UserID])
  ifFalse: [ m appendSeparator;
   appendItem: 'Make History' selector: #makeHistory;
   appendItem: 'Change User-ID...' selector: #changeUserID. ]
  ifTrue: [ Options at: #HISTORY put: true ].
 m appendSeparator;
  appendItem: 'File Categories In...' selector: #fileCategoriesIn;
  appendItem: 'File Categories Out...' selector: #fileCategoriesOut;
  appendSeparator;
  appendItem: 'Delete All Categories' selector: #clearAllCategories;
"  appendSeparator;
  appendItem: 'Help for Options' selector: #helpForOptions;"
  owner: self;
  title: 'Options';
  yourself.
 a addMenu: m.

 m := (self menuWindow menuTitled: '&File').
 m isNil
  ifTrue: [ m := self menuWindow menuTitled: '~File' ].
 m isNil
  ifTrue: [ ^self ].
 m appendSeparator;
  appendItem: 'About CategoryBrowser...' selector:
   (Message new receiver: self;
   selector: #aboutCategoryBrowser).!   
addSubclassesFrom: sc to: ws with: hl
 "add subclasses for showHierarchy"
 | sb |
 sb := SortedCollection sortBlock: [ :a :b | a name <= b name ].
 sc subclasses do: [ :cc | sb add: cc ].
 sb do: [ :s |
  ws nextPutAll: ((String new: (2*hl)) atAllPut: $ ).
  ws nextPutAll: (((s name at: 1) = $ )
   ifTrue: [((s name) replChar: $  with: $*)]
   ifFalse: [ s name ]),' ( '.
  s instVarNames do: [ :iv |
  ws nextPutAll: iv,' '. ].
  ws nextPutAll: ')';cr.
  self addSubclassesFrom: s to: ws with: (hl + 1).]! 
addSubClass
 "Add a subclass to the selected class"
 self isCatSelected
  ifTrue: [ ^MessageBox message: 'Select ''-ALL-'' to add subclass' ].
 ^super addSubClass!   
catALL
 "return all-String"
 ^'- ALL -'!
catCHANGED
 "return all-String"
 ^'- Changed -'!
categories: aPane
 "set list of categories in aPane"
 aPane contents: (CategoryManager categories).!
categoryMenu: aPane
 "Private - Set the category pane menu."
 | m1 m |
 m := Menu new.
 self updateCCMenu: m.
 m selector: #performCCItem:.
 m
  appendItem: 'Add Category...' selector: #addCategory;
  appendItem: 'Remove Category' selector: #removeCategory;
  appendItem: 'Rename Category...' selector: #renameCategory;
  appendItem: 'Copy Category...' selector: #copyCategory;
  appendSeparator.
 (Smalltalk includesKey: #CategoryOptionsBrowser)
  ifTrue: [ m appendItem: 'Set Category Options...' selector: #setCategoryOptions;
   appendSeparator ].
 m
  appendItem: 'Add Class(es)...' selector: #addClasses;
  appendItem: 'Select Class(es)...' selector: #selectClasses;
  appendItem: 'Remove Class(es)...' selector: #removeClasses;
  appendSeparator;
  appendItem: 'Show Hierarchy' selector: #showHierarchy;
  appendItem: 'Goto Classhierarchy' selector: #gotoClassHierarchy;
  appendItem: 'Goto Class...' selector: #gotoClass;
  appendSeparator;
  appendItem: 'File Classes Defs...' selector: #fileClassesDefs;
  appendItem: 'File Classes Out...' selector: #fileClassesOut;
  appendItem: 'File Project Out...' selector: #fileProjectOut.
 m1 := self documentsMenu.
 m1 isNil
  ifFalse: [ m appendSeparator;
   appendSubMenu: m1. ].
 m
  owner: self;
  title: 'CC'.
 aPane setMenu: m.!  
categorySelected: aPane
 "Select a category"
 aPane selection isNil
  ifFalse: [ selectedCategory := aPane selectedItem. ]
  ifTrue: [ selectedCategory := nil ].
 selectedClass := nil.
 selectedMethodCategory := nil.
 self update.
 self changed: #methodCategories:.
 self updateINFOpane.! 
changeUserID
 "Change the UserID"
 | user |
 user := Options at: #UserID ifAbsent: [ String new ].
 user := Prompter prompt: 'Change user-id' default: user.
 (user isNil or: [ user isEmpty ])
  ifTrue: [ ^MessageBox message: 'User-id has not been changed' ].
 Options at: #UserID put: user.!
childWindowClosed: aChildWindow
 "aChildWindow has been closed"
 childWindow remove: aChildWindow ifAbsent: [].!
classMethodsSelected
 "Return true if the classmethods are displayed else answer false"
 ^(self paneICB contents = 'Class')!
clearAllCategories
 "Remove all categories"
 self confirmMessage: 'Delete all categories ?'.
 (MessageBox confirm: 'Save categories ?')
  ifTrue: [ self fileCategoriesOut].
 CategoryManager reset.
 self changed: #categories:.
 selectedCategory := nil.
 self selectBaseCategory.!
close: aPane
 "Close the CategoryBrowser and all its childWindows"
 | child |
 [childWindow isEmpty]
  whileFalse: [ child := childWindow first.
   childWindow removeFirst.
   child mainView close ].
 super close.! 
compilerError: ce at: pos in: str for: obj
 "special errorhandling"
 | res  id |
 (ce = 'undefined')
  ifTrue: [ id := self getIdentifierFrom: str at: pos.
   id first isUpperCase
    ifFalse: [res := MessageBox confirm: 'define "',id,'" as lokal ?'.
     res ifTrue: [self insertTmp: id.
      ^self accept: (self paneTEXT)]]].
 self paneTEXT compilerError: ce at: pos in: str for: obj.! 
confirmMessage: aString
 "Confirm aString. If false terminate process"
 (MessageBox confirm: aString) ifFalse: [ Process errorNoWalkback ].!
copyCategory
 "copy categories"
 | pane name |
 self isCatSelected
  ifFalse: [ ^nil ].
 name := self getString: 'New Categoryname: ' default: selectedCategory.
 name := name trimBlanks.
 CategoryManager copyCategory: selectedCategory to: name.
 name := selectedCategory.
 self changed: #categories:.
 self paneCat selection: name.!
copyMethodCategory
 "copy methodcategories"
 | name |
 self isMCatSelected
  ifTrue: [name := self getString: 'New name for methodcategory' default: selectedMethodCategory.
   CategoryManager copyMethodCategory: selectedMethodCategory fromClass: self realClass to: name.
   (self paneMCat contents includes: name)
    ifFalse: [ self changed: #methodCategories:.
     self paneMCat selection: selectedMethodCategory.].].! 
documentIn: aClass
 "Create a document in the format given by aString"
 | doc |

 aClass isSymbol ifTrue: [ ^self perform: aClass ].
 self isCatSelected
  ifFalse: [ ^MessageBox message: 'No Category selected' ].
 doc := aClass new.
 (doc respondsTo: #createDocumentFor:)
  ifFalse: [ ^MessageBox message: 'No method ',aClass name,'>>createDocumentFor: implemented' ].
 doc createDocumentFor: selectedCategory.! 
documentsMenu
 "Answer the menu for to create a documentfile"
 | c m ok |
 m := Menu new.
 ok := (Smalltalk at: #SmalltalkDocumentor ifAbsent: [ nil ]).
 ok isNil
  ifFalse: [ m appendItem: #Documentor selector: #openDocumentor.
   ok := true ]
  ifTrue: [ ok := false ].

 (Smalltalk at: #VeDocumentor ifAbsent: [ ok ifFalse: [ ^nil ] ifTrue: [ ^m ]]) isClass ifFalse: [ ok ifFalse: [ ^nil ] ifTrue: [ ^m ] ].
 c := (Smalltalk at: #VeDocumentor) subclasses.
 c isEmpty ifTrue: [ ^ok ifTrue: [ m ] ifFalse: [ nil ] ].
 c do: [ :cls |
  (cls respondsTo: #formatName)
   ifTrue: [ ok ifTrue: [ m appendSeparator ].
    ok := true.
    m appendItem: (cls formatName,'...') selector: cls ]
 ].
 m selector: #documentIn:;
 owner: self;
 title: 'Create Document/File';
 yourself.
 ^m! 
fileCategoriesIn
 "File categories in"
 | file |
 file := FileDialog new openFile.
 file file isNil ifTrue: [^self].
 file := File pathName: (file file).
 CursorManager execute change.
 CategoryManager fileCategoriesInFrom: file.
 file close.
 self changed: #categories:.
 CursorManager normal change.!  
fileCategoriesOut
 "Save categories in an file"
 | file |
 file := (FileDialog new saveFile: '*.cat').
 file := file file.
 file isNil ifTrue: [ ^self ].
 file := File newFile: file.
 CategoryManager fileCategoriesOutOn: file.
 file close.!  
fileClassesDefs
 "File classedifinitions of the classes in selected category out"
 | file |
 selectedCategory isNil
  ifTrue: [ ^nil ].
 file := (FileDialog new saveFile: (
  File fileName: (selectedCategory reject: [ :c | c isLetter not ]) extension: 'def')) file.
    file isNil ifTrue: [^self].
 CursorManager execute change.
 file := File newFile: file.
 (CategoryManager instanceClassesAt: selectedCategory) asSortedCollection
 do: [ :c |
  (Smalltalk at: c asSymbol) fileOutOn: file.
   file nextChunkPut: String new.
   file cr.
  ].
 file close.
 CursorManager normal change!  
fileClassesOut
 "File complete classes of selected Category out"
 | file |
 selectedCategory isNil
  ifTrue: [ ^nil ].
 file := (FileDialog new saveFile: (
  File fileName: selectedCategory extension: 'cls')) file.
 file isNil ifTrue: [^self].
 CursorManager execute change.
 file := File newFile: file.
 (CategoryManager instanceClassesAt: selectedCategory) asSortedCollection
  do: [ :c |
   c := Smalltalk at: c asSymbol.
   c fileOutOn: file.
   file nextChunkPut: String new.
   (ClassReader forClass: c class) fileOutOn: file.
   (ClassReader forClass: c) fileOutOn: file].
 file close.
 CursorManager normal change!  
fileMethodsOut
 "File methods of selected methodcategory out"
 | file |
 selectedMethodCategory isNil ifTrue: [^self].
 file := (FileDialog new saveFile: (
  File
   fileName: (selectedMethodCategory reject: [:c | c isLetter not])
   extension: 'mct')) file.
  file isNil ifTrue: [^self].
  file := File newFile: file.
 self paneMethods contents asSortedCollection do: [ :mths |
  (ClassReader forClass: self realClass) fileOutMethod: mths on: file. ].
 file close.!
fileProjectOut
 "File classes and methods out, which belong to selected category"
 | file |
 selectedCategory isNil
  ifTrue: [ ^nil ].
 selectedMethodCategory isNil
  ifTrue: [ self fileProjectOut: selectedCategory ]
  ifFalse: [ self fileProjectOut: selectedMethodCategory ].! 
fileProjectOut: aMCategory
 "File classes of selected Category with the methods
 of aMCategory out"
 | mth file chk |
 file := (FileDialog new saveFile: (
  File fileName: (selectedCategory reject: [ :c | c isLetter not ]) extension: 'ctp')) file.
    file isNil ifTrue: [^self].
 CursorManager execute change.
 file := File newFile: file.
 file nextPutAll: '"evaluate"';cr.
 file nextPutAll: '"Project: ''',selectedCategory,''' with: ''',aMCategory,''' " !!'.
 file cr;cr.
 (CategoryManager instanceClassesAt: selectedCategory) asSortedCollection
  do: [ :c |
   c := Smalltalk at: c asSymbol.
   file cr;nextPutAll: '"define class"'.
   c fileOutOn: file.
   file nextChunkPut: String new.
   file cr.
   ].
 file cr.
 file cr.
 (CategoryManager instanceClassesAt: selectedCategory) asSortedCollection
  do: [ :c |
   c := Smalltalk at: c asSymbol.
   2 timesRepeat: [
   file nextPutAll: '!! ',c name,' methods !!'.
   chk := false.
    (((CategoryManager methodCategoriesForClass: c) includes: aMCategory)
    or: [#('- ALL -' '- No Category -') includes: aMCategory])
     ifTrue: [(CategoryManager methodsForMethodCategory: aMCategory forClass: c) do: [ :mm |
       file cr.
       file nextChunkPut: (c sourceCodeAt: mm).
       chk := true.].
      ]
     ifFalse: [ c selectors do: [ :mm |
       file cr.
       file nextChunkPut: (c sourceCodeAt: mm).
       chk := true.].].
     true ifTrue: [ file nextPutAll: ' !!'; cr ].
     file cr.
     c := c class.
    ].
  ].
 file close.
 CursorManager normal change.!   
findClass
 "Find one ore more classes"
 | name ep cls pane |
 (Smalltalk includesKey: #CategoryPattern)
  ifFalse: [ selectedCategory = self catALL
   ifTrue: [ ^super findClass ]
   ifFalse: [ ^MessageBox message: 'Category ',self catALL,' must be selected' ] ].
 name := self getString: 'Name of class:' default: String new.
 ep := (Smalltalk at: #CategoryPattern) new: name.
 (ep respondsTo: #modus:)
  ifTrue: [ ep modus: false ].
 cls := OrderedCollection new.
 Smalltalk associationsDo: [ : as |
  as value isClass
   ifTrue: [ (ep match: (as value name asString))
    ifTrue: [ cls add: (as key asString) ]]].
 (cls size = 0)
  ifTrue: [ ^MessageBox message: 'Class(es) "', name,'" not found in Smalltalk.' ].
 (cls size = 1)
  ifTrue: [ ^self findClassAndSelect: (Smalltalk at: (cls first asSymbol)) ].
 CategoryManager removeCategory: '- Find Class -'.
  cls do: [ :c |
   CategoryManager addClass: c toCategory: '- Find Class -'. ].
 (self paneCat contents includes: '- Find Class -')
  ifFalse: [ self changed: #categories: ].
 self paneCat selection: '- Find Class -'.
 self categorySelected: self paneCat.! 
findClassAndSelect: aClass
 "Select aClass in the classpane"
 | className class supers blanks result tmp pane |
 self textModified ifTrue: [^self].
 pane := self paneClasses.
 self isCatSelected
  ifTrue: [ ((CategoryManager instanceClassesAt: selectedCategory) includes: aClass name)
   ifTrue: [ pane selection: aClass symbol.
    ^self hierarchySelected: pane ]].
 pane := self paneCat.
 pane selection: self catALL.
 selectedCategory := self catALL.
 self categorySelected: pane.
 class := aClass.
 className := class symbol.
 (class isBehavior) ifFalse: [
  ^MessageBox message: '"', className,'" is not a class.' ].
 CursorManager execute change.
 supers := (Array with: class), class allSuperclasses.
 blanks := 0.
 1 to: supers size do: [ :i |
  (originalClasses includes: (supers at: i))
   ifTrue: [ blanks := i ]].
 blanks = 0 ifTrue: [
  CursorManager normal change.
  ^Menu message: 'Class "', className,'" not found in this browser.' ].
 supers do: [ :cl |
  hiddenClasses remove: cl ifAbsent: []].
 self update: originalClasses.
 methodSelectedLast := false.
 selectedMethod := nil.
 selectedInstVar := nil.
 selectedClass := class.
 self changed: #hierarchy:
  with: #restoreSelected:
  with: (((String new: ((blanks - 1 max: 0) * 2)) atAllPut: $ ),class name).
 self enableClassesMenu.
 self disableMethodsMenu.
 self changed: #methodCategories:;
  changed: #instanceVars: ;
  changed: #selectors: ;
  changed: #text:.
 CursorManager normal change!   
generalHelp: aPane
 "Display general help"
 self helpFor: HEHlpGenHelp.!
getIdentifierFrom: str at: pos
 "get identifier from str"
 | rs ws np c |
 rs := ReadStream on: (str copyFrom: pos to: (str size)),'  '.
 ws := WriteStream on: String new.
 [c := rs next.
  c isAlphaNumeric]
  whileFalse: [].
 [ws nextPut: c.
 c := rs next.
 c isAlphaNumeric]
  whileTrue: [].
 ^ws contents.! 
getString: aString default: aDefault
 "return a string with no leading blanks."
 | name |
 name := Prompter prompt: aString default: aDefault.
 (name isNil or: [ name trimBlanks isEmpty])
  ifTrue: [ Process errorNoWalkback ].
 ^name trimBlanks.!  
giveHelp: aPane
 "give help for aPane to the user"
 | help |
 help := HEHlpGenHelp.
 aPane = self paneTEXT
  ifTrue: [ help := HEHlpText ].
 aPane = self paneClasses
  ifTrue: [ help := HEHlpClass ].
 aPane = self paneCat
  ifTrue: [ help := HEHlpClassCategory ].
 aPane = self paneMCat
  ifTrue: [ help := HEHlpMethodCategory ].
 aPane = self paneMethods
  ifTrue: [ help := HEHlpMethod ].
 aPane = self paneInstances
  ifTrue: [ help := HEHlpInstanceVariables ].
 aPane = self paneINFO
  ifTrue: [ help := HEHlpInformation ].
 self helpFor: help.!   
gotoClass
 "Select a class and category from Save"
 | res |
 res := SortedCollection new.
 Save do: [ :i | (i notNil and: [ (i at: 3) notNil ]) ifTrue: [ res add: (i at: 3) ] ].
 res isEmpty ifTrue: [ ^self ].
 res := CategorySelectDialog new singleSelectFrom: res label: 'GOTO Selected Class'.
 (res isNil or: [ res isEmpty ]) ifTrue: [ ^self ].
 res := res first.
 self findClassAndSelect: ((res includes: $ )
  ifTrue: [ (Smalltalk at: (res asArrayOfSubstrings first asSymbol) ifAbsent: [ ^self ]) ]
  ifFalse: [ (Smalltalk at: (res asSymbol) ifAbsent: [ ^self ] ) ] ).
 (res includes: $ )
  ifTrue: [ instanceSelectedLast ifTrue: [ self instanceClassButton: self paneICB ] ]
  ifFalse: [ instanceSelectedLast ifFalse: [ self instanceClassButton: self paneICB ] ].!
gotoClassHierarchy
 "go from class in selectedCategory to hierarchy"
 | cat mcat class method  idx p a mm pane |
 selectedClass isNil
  ifTrue: [ ^nil ].
 self saveButton: self paneSAVE.
 cat := (self catALL).
 class := selectedClass.
 method := selectedMethod.
 pane := self paneCat.
 pane selection: cat.
 selectedCategory := cat.
 self categorySelected: pane.
 self findClassAndSelect: class.
 method isNil
  ifTrue: [ selectedMethod := nil.
   methodSelectedLast := false.
   self changed: #text:.
   ^nil ].
 pane := self paneMethods.
 pane selection: method.
 selectedMethod := method.
 methodSelectedLast := true.
 self changed: #text:.
 self enableMethodsMenu!  
helpFor: anID
 "Display help for anID"
 self mainView helpManager
  isNil ifTrue: [ ^self ].
 self mainView helpManager displayHelp: anID!
helpForOptions
 "Display help for the Optionsmenu"
 self helpFor: HEHlpOptions! 
hierarchy: hierarchyPane
 "Private - Set the indented list of
 classes, an OrderedCollection of strings."
 self isCatSelected
  ifTrue: [ hierarchyPane contents: (browsedClasses asSortedCollection) ]
  ifFalse: [ hierarchyPane contents: browsedClasses ]!   
hierarchySelected: hierarchyPane
 "Private - Display the selectors for the
 selected class in the selector list pane.
 Display also the methodcategories"
 super hierarchySelected: hierarchyPane.
 self changed: #methodCategories:.
 (self paneMCat contents includes: selectedMethodCategory)
  ifFalse: [ selectedMethodCategory := self catALL ].
 (selectedMethodCategory ~= self catALL)
  ifTrue: [ self changed: #methodCategories: ].
 self paneMCat selection: selectedMethodCategory.
 self methodCategorySelect: self paneMCat.
 buffer := selectedClass printString.
 self updateINFOpane.
 childWindow do: [ :child |
  (child respondsTo: #cbSelectClass:)
   ifTrue: [ child cbSelectClass: selectedClass ]
 ].!
initOptionsMenu
 "History or not"
 | menu op |
 menu := self menuTitled: 'Options'.
 op := Options at: #HISTORY ifAbsent: [ false ].
 menu getIndex: #makeHistory ifAbsent: [ ^self ].
 op
  ifTrue: [menu checkItem: #makeHistory.]
  ifFalse: [menu uncheckItem: #makeHistory.].!   
insertTmp: aString
 "insert a new local variable aString in the methodsource"
 | a c rs ww cc nc np |
 c := self paneTEXT contents.
 rs := ReadStream on: c.
 [cc := self nextPartFrom: rs.
 (cc last ~= $:) | (cc includes: $") ]
  whileFalse: [ cc := self nextPartFrom: rs  ].

 (cc includes: $")
  ifTrue: [ rs reset.
   [c := rs next.
   c ~= $"]
    whileTrue: [].
   rs next.
   [c := rs next.
   c ~= $"]
    whileTrue: [].
   np := rs position.]
  ifFalse: [np := rs position.
   cc := self nextPartFrom: rs.
   (cc includes: $")
    ifTrue: [ rs reset.
     [c := rs next.
     c ~= $"]
      whileTrue: [].
     rs next.
     [c := rs next.
     c ~= $"]
      whileTrue: [].
     np := rs position.
     ]
    ].
 cc := self nextPartFrom: rs.
 (cc first = $|)
  ifTrue: [ nc := self paneTEXT contents.
   rs position: np.
    [rs next ~= $|]
     whileTrue: [].
    c := rs next.
    (c = $ ) ifTrue: [ c := '' ] ifFalse: [ c := ' ' ].
    self paneTEXT contents: (nc copyFrom: 1 to: (rs position - 1)),' ',aString,c,(nc copyFrom: (rs position) to: nc size).
    self paneTEXT display. ]
  ifFalse: [ nc := self paneTEXT contents.
   self paneTEXT contents: (nc copyFrom: 1 to: np),'
 | ',aString,' |
',(nc copyFrom: (np + 1) to: (nc size)).
  self paneTEXT display. ].
 self paneTEXT modified: false.! 
instanceClassButton: aButton
 "Private - Change the state of the browser
 so that instance messages are selected."
 self textModified ifTrue: [
  self changed: 'instance' with: instanceSelectedLast.
  self changed: 'class' with: instanceSelectedLast not.
  ^self].
 instanceSelectedLast := instanceSelectedLast not.
 instanceSelectedLast
  ifTrue: [ aButton contents: 'Instance' ]
  ifFalse: [ aButton contents: 'Class' ].
 methodSelectedLast := false.
 selectedInstVar := nil.
 selectedMethodCategory := nil.
 selectedMethod := nil.
 self disableMethodsMenu.
 self changed: #instanceVars:.
 self changed: #selectors: ;
  changed: #text:;
  changed: #methodCategories:.
 self updateINFOpane.!  
isCatSelected
 "return true if category has been selected"
 ^(selectedCategory isNil | (selectedCategory = (self catALL))) not! 
isMCatSelected
 "return true if methodcategory has been selected"
 ^((selectedMethodCategory isNil) |
 (selectedMethodCategory = self catALL) |
 (selectedMethodCategory = '- No Category -')) not!   
label
 "Private - Answer the window label."
 ^'Category Browser ',self class version,' '!   
makeHistory
 "History or not; toggle menuitem"
 | menu |
 menu := self menuTitled: 'Options'.
 (menu isChecked: #makeHistory)
 ifTrue: [menu uncheckItem: #makeHistory.
  Options at: #HISTORY put: false.]
 ifFalse: [menu checkItem: #makeHistory.
  Options at: #HISTORY put: true.].! 
methodAddCategory
 "Add a new methodcategory"
 | name f g cls |
 (selectedClass isNil)
   ifTrue: [ ^nil ].
 name := self getString: 'Name of new methodcategory: ' default: String new.
 cls := self realClass.
 (CategoryManager addMethodCategory: name toClass: cls)
  ifTrue: [ self changed: #methodCategories:.
   selectedMethodCategory notNil
    ifTrue: [ self paneMCat selection: selectedMethodCategory]  ].! 
methodCategories: aPane
 "Set methodcategories in aPane"
 | sc |
 sc := self realClass.
 selectedClass isNil
  ifTrue: [ aPane contents: OrderedCollection new ]
  ifFalse: [ aPane contents: (CategoryManager methodCategoriesForClass: sc) ].
 self updateINFOpane.! 
methodCategoryMenu: aPane
 "Private - Set the methodcategory pane menu."
 aPane setMenu: ((Menu new
  appendItem: 'Add Category...' selector: #methodAddCategory;
  appendItem: 'Remove Category' selector: #methodRemoveCategory;
  appendItem: 'Rename Category...' selector: #renameMethodCategory;
  appendItem: 'Copy Category...' selector: #copyMethodCategory;
  appendSeparator;
  appendItem: 'Select Method(s)...' selector: #selectMethods;
  appendItem: 'Remove Method(s)...' selector: #removeMethods;
  appendSeparator;
  appendItem: 'Search...' selector: #searchMethods;
  appendItem: 'File Methods Out...' selector: #fileMethodsOut)
  owner: self;
  title: 'MC';
  yourself)! 
methodCategorySelect: aPane
 "a methodcategory has been selected"
 selectedMethodCategory := aPane selectedItem.
 self changed: #selectors:.
 selectedInstVar := nil.
 (self paneMethods contents includes: selectedMethod)
  ifTrue: [ self paneMethods selection: selectedMethod ]
  ifFalse: [ selectedMethod := nil.
   methodSelectedLast ifTrue: [
   methodSelectedLast := false.
   self changed: #text: ] ].
 self updateINFOpane.!   
methodHistoryIn: aString
 "If Options are set add a historyline to aString"
 (aString class ~= String)
  ifTrue: [ ^aString ].
 (Options class = Dictionary) ifFalse: [ Options := Dictionary new ].
 selectedClass = self class ifTrue: [ ^aString ].
 (Options at: #HISTORY ifAbsent: [ false ])
  ifTrue: [ (aString respondsTo: #addHistory)
   ifTrue: [ ^aString addHistory ]
   ifFalse: [ ^self addHistory: aString ] ]
  ifFalse: [ ^aString ]!
methodRemoveCategory
 "Remove the selected category"
 self isMCatSelected
  ifTrue: [
   self confirmMessage: 'Delete methodcategory ',selectedMethodCategory,'?'.
   CategoryManager removeMethodCategory: selectedMethodCategory fromClass: self realClass.
   selectedMethodCategory := nil.
   self changed: #methodCategories:.
   self changed: #selectors:.
   self paneMCat selection: self catALL ]
  ifFalse: [ MessageBox message: 'No or no valid methodcategory selected' ].!  
methodsRefList
 "return a list of methods to be displayed"
 | cls |
 selectedClass isNil
  ifTrue: [ ^OrderedCollection new ].
 selectedMethodCategory isNil
  ifTrue: [ selectedMethodCategory := self catALL ].
 cls := self realClass.
 ^CategoryManager methodsForMethodCategory: selectedMethodCategory forClass: cls.!  
nextPartFrom: aRS
 "Return a special part from aRS"
 | ws c |
 ws := WriteStream on: String new.
 [aRS atEnd]
  whileFalse: [ c := aRS next.
   c asciiValue <= 32
    ifTrue: [ ws contents size > 0 ifTrue: [ ^ws contents ]. ]
    ifFalse: [ ws nextPut: c ].
   ].
 ^ws contents.! 
openDocumentor
 "Open the Documentor"
 | d |
 childWindow do: [ :child |
  (child class = (Smalltalk at: #SmalltalkDocumentor))
   ifTrue: [ ^child mainView bringToTop ].
 ].
 d := (Smalltalk at: #SmalltalkDocumentor) new.
 d cb: self.
 childWindow add: d.
 selectedClass isNil
  ifTrue: [ d open ]
  ifFalse: [ d openOn: selectedClass ].!   
openOn: aCollection
 "Create a category browser window giving access
 to the classes in aCollection and their subclasses."
 | groupPane pane gpm sfh dn dz |
 dz := 36.
 dn := 100.
 Options isNil
  ifTrue: [ Options := Dictionary new ].
 Save isNil
  ifTrue: [
   Save := Array new: 1.
   self saveMAX: 1.
   self savePOS: 1.].
 (Options at: #FO ifAbsent: [ Options at: #FO put: false. true ])
  ifTrue: [ self aboutCategoryBrowser ].
 sfh := SysFont height + 8.
 gpm := 7.
 childWindow := OrderedCollection new.
 panes := Dictionary new.
 hiddenClasses := Set new.
 (aCollection includes: Object)
  ifTrue: [
   aCollection do: [ :class |
    class subclasses do: [:each |
     each subclasses isEmpty
      ifFalse: [ hiddenClasses add: each]]]]
  ifFalse: [
   aCollection do: [ :class |
    class subclasses isEmpty
     ifFalse: [hiddenClasses add: class]]].
 self update: aCollection.
 instanceSelectedLast := true.
 methodSelectedLast := false.
 assigned := used := true.
 (Options includesKey: #HISTORY)
  ifFalse: [ Options at: #HISTORY put: false ].

 self owner: self;
  label: self label;
  when: #close perform: #close:;
  when: #menuBuilt perform: #addOptionsMenu:;
  when: #help perform: #generalHelp:.

 self addSubpane:
 (pane := ListPane new owner: self;
  when: #getContents perform: #categories: ;
  when: #select perform: #categorySelected: ;
  when: #getMenu perform: #categoryMenu: ;
  when: #help perform: #giveHelp:;
  framingBlock: [ :box |
    (box leftTop rightAndDown: (2@2))
    extentFromLeftTop:
    (box width // 4 - 2)@(box height * dz // dn) ] ).
  panes at: #Cat put: pane.

 self addSubpane:
 (pane := ListPane new owner: self;
  when: #getContents perform: #hierarchy: ;
  when: #select perform: #hierarchySelected: ;
  when: #doubleClickSelect perform: #hideShow: ;
  when: #getMenu perform: #menu: ;
  when: #help perform: #giveHelp:;
  framingBlock: [ :box |
    (box leftTop rightAndDown: (box width // 4)@2)
    extentFromLeftTop:
    (box width // 4)@(box height * dz // dn) ] ).
  panes at: #Classes put: pane.

 self addSubpane:
 (pane := ListPane new owner: self;
  when: #getContents perform: #instanceVars: ;
  when: #select perform: #instanceVar: ;
  when: #getMenu perform: #instVarsMenu: ;
  when: #doubleClickSelect perform: #instanceVarDoubleClick:;
  when: #help perform: #giveHelp:;
  framingBlock: [ :box |
    (box leftTop rightAndDown: (box width * 2 // 4)@(box height * (dz // 2) // dn + 2))
    extentFromLeftTop:
    (box width // 4)@(box height * (dz // 2) // dn) ] ).
  panes at: #Instances put: pane.

 self addSubpane:
 (pane := ListPane new owner: self;
  when: #getContents perform: #methodCategories: ;
  when: #select perform: #methodCategorySelect: ;
  when: #getMenu perform: #methodCategoryMenu: ;
  when: #help perform: #giveHelp:;
  framingBlock: [ :box |
    (box leftTop rightAndDown: (box width * 2 // 4)@2)
    extentFromLeftTop:
    (box width // 4)@(box height * (dz // 2) // dn) ] ).
  panes at: #MCat put: pane.

 self addSubpane:
 (pane := ListPane new owner: self;
  when: #getContents perform: #selectors: ;
  when: #select perform: #selector: ;
  when: #getMenu perform: #selectorMenu: ;
  when: #help perform: #giveHelp:;
  framingBlock: [ :box |
    (box leftTop rightAndDown: (box width * 3 // 4)@2)
    extentFromLeftTop:
    (box width // 4 - 2)@(box height * dz // dn) ] ).
  panes at: #Methods put: pane.

 self addSubpane: (groupPane := GroupPane new owner: self;
  framingBlock: [ :box |
    (box leftTop rightAndDown: 2@(box height * dz // dn + 4))
    extentFromLeftTop:
    (box width - 4)@sfh ] ).

 groupPane addSubpane:
 (pane := Button new owner: self;
  contents: 'Save';
  when: #clicked perform: #saveButton:;
  when: #help perform: #giveHelp:;
  framingBlock: [ :box |
  (0 @ 0) corner:
  ((box width * 1 // gpm) @ (box height)) ] ).
 panes at: #SAVE put: pane.

 groupPane addSubpane:
 (pane := Button new owner: self;
  contents: 'Restore';
  when: #clicked perform: #restoreButton:;
  when: #help perform: #giveHelp:;
  framingBlock: [ :box |
  ((box width * 1 // gpm) @ 0) corner:
  ((box width * 2 // gpm) @ (box height)) ] ).
 panes at: #RESTORE put: pane.

 groupPane addSubpane:
 (pane := Button new owner: self;
  contents: 'Instance';
  when: #clicked perform: #instanceClassButton:;
  when: #help perform: #giveHelp:;
  framingBlock: [ :box |
  ((box width * 2 // gpm) @ 0) corner:
  ((box width * 3 // gpm) @ (box height)) ] ).
 panes at: #ICB put: pane.

 groupPane addSubpane:
 (pane := Button new owner: self;
  when: #clicked perform: #specialFunctions:;
  framingBlock: [ :box |
  ((box width * 3 // gpm) @ 0) corner:
  ((box width) @ (box height)) ] ).
 panes at: #INFO put: pane.

 self addSubpane:
 (pane := TextPane new owner: self;
  when: #getContents perform: #text:;
  when: #help perform: #giveHelp:;
  when: #save perform: #accept: ;
  framingBlock: [ :box |
    (box leftTop rightAndDown: 2@(box height * dz // dn + sfh + 6))
    extentFromLeftTop:
    (box width - 4)@(box height * (dn - dz) // dn - sfh -  6) ] ).
  panes at: #TEXT put: pane.

" (Smalltalk includesKey: #WIN)
  ifFalse: [ HelpManager for: self mainView title: 'Help' file: 'catbrw.hlp'. ].
"
 self openWindow.
 self disableClassesMenu.
 self disableMethodsMenu.
 self checkInstVarMenu.
 self initOptionsMenu.!   
paneCat
 ^(panes at: #Cat)!  
paneClasses
 ^(panes at: #Classes)!  
paneICB
 ^(panes at: #ICB)!  
paneInstances
 ^(panes at: #Instances)!  
paneINFO
 ^(panes at: #INFO)!
paneMCat
 ^(panes at: #MCat)!
paneMethods
 ^(panes at: #Methods)!  
paneSAVE
 ^(panes at: #SAVE)!
paneTEXT
 ^(panes at: #TEXT)!
performCCItem: aSelector
 "Execute aSelector"
 | ns |
 (aSelector class = Symbol)
  ifTrue: [ ^self perform: aSelector ].
 ns := ((Options at: #UD ifAbsent: [ ^self ])
  at: aSelector ifAbsent: [ ^self ]).
 (ns isKindOf: Context) ifFalse: [ ^self ].
 ^ns value: self!   
realClass
 "return the Class or the Metaclass"
 instanceSelectedLast
  ifTrue: [^selectedClass]
  ifFalse: [^selectedClass class].!   
removeCategory
 "Remove a category"
 self isCatSelected
  ifFalse: [ ^nil ].
 self confirmMessage: 'Delete category ''',selectedCategory,'''?'.
 (selectedCategory = self catCHANGED)
  ifTrue: [ (MessageBox confirm: 'Do you want to delete the methodcategories for ''-Changed-'' too ?')
   ifTrue: [ Smalltalk rootClasses do: [ :rc |
    rc withAllSubclasses do: [ :sc |
     CategoryManager removeMethodCategory: selectedCategory fromClass: sc.
     CategoryManager removeMethodCategory: selectedCategory fromClass: sc class. ].
    ] ] ].
 CategoryManager removeCategory: selectedCategory.
 self changed: #categories:.
 selectedClass isNil
  ifTrue: [ ^self selectBaseCategory ].
 self gotoClassHierarchy.!
removeClasses
 "Remove classes from selected category"
 | l1 l2 |
 self isCatSelected
  ifFalse: [ ^nil ].
 l1 := self paneClasses contents.
 l2 := CategorySelectDialog new selectFrom: l1 label: 'REMOVE Selected Class(es)'.
 (l2 isNil or: [ l2 isEmpty ])
  ifTrue: [ ^nil ].
 l2 do: [ :c |
  CategoryManager removeClass: c asString fromCategory: selectedCategory. ].
 self update.
 (selectedClass isNil or: [(l2 includes: selectedClass name)])
  ifTrue: [ selectedClass := nil. ].
 selectedClass isNil
  ifFalse: [ self paneClasses selection: selectedClass symbol ]
  ifTrue: [ self changed: #methodCategories:. ].!   
removeMethods
 "remove methods from selected methodcategory"
 | l3 l1 l2 |
 self isMCatSelected
  ifFalse: [ ^self ].
 l3 := self paneMethods contents.
 l1 := CategorySelectDialog new
  selectFrom: l3 label: 'REMOVE Selected method(s)'.
 (l1 isNil or: [ l1 isEmpty ])
  ifTrue: [ ^self ].
 l1 do: [ :m |
  CategoryManager removeMethod: m toCategory: selectedMethodCategory inClass: self realClass. ].
 self changed: #selectors:.
  (l1 includes: selectedMethod)
   ifTrue: [ selectedMethod := nil ].
    self paneMethods selection: selectedMethod.!
removeSelector
 "Private - Remove the selected method.
    Patched LRP to put source code in the Clipboard if the method is a class method"
 | aString |
 methodSelectedLast
  ifFalse: [^nil].
 selectedMethod isNil
  ifTrue: [^nil].
 Clipboard setString: (selectedClass sourceCodeAt: selectedMethod).
 instanceSelectedLast
  ifTrue: [
   Clipboard setString: (selectedClass sourceCodeAt: selectedMethod).
   selectedClass removeSelector: selectedMethod.
   aString := selectedClass name]
  ifFalse: [
   Clipboard setString: (selectedClass class sourceCodeAt: selectedMethod).
   selectedClass class removeSelector: selectedMethod.
   aString := selectedClass class name].
 Smalltalk logEvaluate: aString, ' removeSelector: #', selectedMethod.
 methodSelectedLast := false.
 CategoryManager removeMethod: selectedMethod fromClass: self realClass.
 selectedMethod := nil.
 self changed: #selectors: with: #restore;
  changed: #text:.
 self updateINFOpane.!
removeSubClass
 "Private - Delete the selected class."
 | newName subclassType answer sc scn |
 selectedClass isNil
  ifTrue: [^nil].
 self confirmMessage: 'Delete Class "', selectedClass name, '"?'.
 selectedClass isInDLL ifTrue: [^MessageBox message: 'Class is connected to DLL'].
 CursorManager execute change.
 sc := selectedClass.
 scn := selectedClass name.
 sc removeFromSystem.
 CategoryManager removeClass: sc.
 selectedMethod := nil.
 methodSelectedLast := false.
 self update: originalClasses.
 self changed: #hierarchy: with: #restore.
 selectedClass := nil.
 self
  changed: #selectors:;
  changed: #instanceVars:;
  changed: #text:.
 CursorManager normal change.!
renameCategory
 "Rename the selected category"
 | pane name |
 self isCatSelected
  ifFalse: [ ^nil ].
 name := self getString: 'New Categoryname: ' default: selectedCategory.
 (CategoryManager renameCategory: selectedCategory to: name)
  ifTrue: [ self changed: #categories:.
   self paneCat selection: name.
   selectedCategory := name ].!
renameMethodCategory
 "Rename selected methodcategory"
 | name |
 self isMCatSelected
  ifTrue: [ name := self getString: 'New name for methodcategory' default: selectedMethodCategory.
   (CategoryManager renameMethodCategory: selectedMethodCategory fromClass: self realClass to: name)
    ifTrue: [
     selectedMethodCategory := name.
     self changed: #methodCategories:.
     self paneMCat selection: name ]
    ].!
restoreButton: aPane
 "restore the saved status"
 | cat mcat class method  idx p a mm pane |
 p := self savePOS.
 mm := self savePOS.
 [a := Save at: p.
 p := p - 1.
 p <= 0 ifTrue: [ p := self saveMAX ].
 self savePOS: p.
 a isNil]
  whileTrue: [ (p = mm)
   ifTrue: [ ^nil ]].
 cat := a at: 1.
 mcat := a at: 2.
 class := a at: 3.
 method := a at: 4.
 selectedClass := nil.
 selectedMethod := nil.
 selectedCategory := nil.
 selectedMethodCategory := nil.
 pane := self paneCat.
 pane selection: cat.
 selectedCategory := cat.
 self categorySelected: pane.
 class isNil
  ifTrue: [ self changed: #text.
   ^nil ].
 (class includes: $ )
 ifTrue: [ instanceSelectedLast ifTrue: [ self instanceClassButton: self paneICB. ].
  class := Smalltalk at: ((class copyFrom: 1 to: ((class indexOf: $ ) - 1)) asSymbol) ifAbsent: [ ^self ]. ]
 ifFalse: [ instanceSelectedLast ifFalse: [ self instanceClassButton: self paneICB ].
  class := Smalltalk at: (class asSymbol) ifAbsent: [ ^self ]. ].
 pane := self paneClasses.
 (selectedCategory = self catALL)
  ifTrue: [ self findClassAndSelect: class ]
  ifFalse: [ (browsedClasses includes: class symbol)
   ifTrue: [ pane selection: class symbol ]
   ifFalse: [ ^nil ]].
 self hierarchySelected: pane.
 pane := self paneMCat.
 selectedCategory = self catALL
 ifFalse: [ pane selection: mcat.
  selectedMethodCategory := mcat.
  self methodCategorySelect: pane].
 method isNil
  ifTrue: [ selectedMethod := nil.
   methodSelectedLast := false.
   self changed: #text:.
   ^nil ].
 pane := self paneMethods.
 pane selection: method.
 idx := pane selection.
 idx isNil
  ifTrue: [ selectedMethod := nil.
   methodSelectedLast := false. ]
  ifFalse: [ selectedMethod := method.
   methodSelectedLast := true.  ].
 self changed: #text:.
 self enableMethodsMenu.
 ((selectedInstVar notNil) and: [assigned | used])
  ifTrue: [self mainView activeTextPane searchFor: selectedInstVar].
 self mainView activeTextPane: (self paneTEXT).! 
saveButton: aPane
 "save the current status"
 | a p |
 selectedClass isNil ifTrue: [ ^self ].
 p := (self savePOS \\ self saveMAX) + 1.
 a := Array new: 4.
 selectedCategory isNil
  ifTrue: [ a at: 1 put: self catALL. ]
  ifFalse: [ a at: 1 put: selectedCategory.].
 selectedMethodCategory isNil
  ifTrue: [ a at: 2 put: self catALL. ]
  ifFalse: [ a at: 2 put: selectedMethodCategory. ].
 a at: 3 put: self realClass name.
 a at: 4 put: selectedMethod.
 self savePOS: p.
 Save at: p put: a.
 self mainView activeTextPane: (self paneTEXT).!  
saveMAX
 ^(Options at: #MAX)!
saveMAX: aValue
 ^(Options at: #MAX put: aValue)!
savePOS
 ^(Options at: #POS)!
savePOS: aValue
 ^(Options at: #POS put: aValue)!
searchMethods
 "Search method with a special contents"
 | m st ep cls |
 selectedClass isNil
  ifTrue: [ ^nil ].
 st := Prompter prompt: 'Searchtext:' default: String new.
 st isNil ifTrue: [ ^nil ].
 st isEmpty ifTrue: [ ^nil ].
 ep := (Smalltalk at: #CategoryPattern ifAbsent: [ Smalltalk at: #WildPattern ]) new: st.
 cls := self realClass.
 m := OrderedCollection new.
 self paneMethods contents do: [ :s |
  (ep match: (cls sourceCodeAt: s))
   ifTrue: [ m add: s ].
 ].
 m isEmpty
    ifTrue: [ ^MessageBox message: 'no method matches ',st ].
 CategoryManager removeMethodCategory: (st := '- Find Method -') fromClass: cls.
 m do: [ :mm |
  CategoryManager addMethod: mm toCategory: st inClass: cls ].
 selectedMethodCategory := st.
 self changed: #selectors:.
 self changed: #methodCategories:.
 self paneMCat selection: selectedMethodCategory.!   
selectBaseCategory
 "select '- ALL -'"
 self paneCat selection: self catALL.
 selectedCategory := self catALL.
 self categorySelected: self paneCat!  
selectClasses
 "Add classes to selected category"
 | l1 l2 |
 self isCatSelected
  ifFalse: [ ^nil ].
 l1 := self paneClasses contents.
 l2 := SortedCollection new.
 CursorManager execute change.
 Object withAllSubclasses do: [ :cls |
  cls := cls name asSymbol.
  (l1 includes: cls)
   ifFalse: [ l2 add: cls ].
  ].
 CursorManager normal change.
 l1 := CategorySelectDialog new selectFrom: l2 label: 'ADD Selected Class(es)'.
 (l1 isNil or: [ l1 isEmpty ])
  ifTrue: [ ^nil ].
 l1 do: [ :c |
  CategoryManager addClass: c asString toCategory: selectedCategory ].
 self update.
 selectedClass isNil
  ifFalse: [ self paneClasses selection: selectedClass symbol ].!
selectedCategory
 "Return the selected category"
 ^selectedCategory!
selectedClass
 "Return the selected class"
 ^selectedClass! 
selectedMethod
 "Return the selected method"
 ^selectedMethod!  
selectedMethodCategory
 "Return the selected methodcategory"
 ^selectedMethodCategory!  
selectMethods
 "add methods to select methodcategory"
 | l3 l1 l2 |

 self isMCatSelected
    ifFalse: [ ^self ].
 l1 := self realClass selectors.
 l1 isEmpty ifTrue: [ ^self ].
 l2 := SortedCollection new.
 l3 := self paneMethods contents.
 l1 do: [ :m |
  (l3 includes: m)
            ifFalse: [ l2 add: m ]
  ].

 l1 := CategorySelectDialog new
  selectFrom: l2 label: 'ADD Selected method(s)'.
 (l1 isNil or: [ l1 isEmpty ])
  ifTrue: [ ^self ].
 l1 do: [ :m |
  CategoryManager addMethod: m toCategory: selectedMethodCategory inClass: self realClass. ].
 self changed: #selectors:.
 self paneMethods selection: selectedMethod.!
selector: selectorPane
 "Private - Display the selected
 method in the text pane."
| sc |
selectedMethod := selectorPane isNil
  ifTrue: [nil]
  ifFalse: [selectorPane selectedItem].
 methodSelectedLast := true.
 self changed: #text:.
 self enableMethodsMenu.
 ((selectedInstVar notNil) and: [assigned | used]) ifTrue: [
  self mainView activeTextPane searchFor: selectedInstVar].
 self updateINFOpane.!   
selectors: selectorPane
 "Private - Set the sorted list of method
 selectors for the selected class and
 dictionary type (class or instance)."
 | methods slist tmpList refList rl1 |
 selectedClass isNil
  ifTrue: [^selectorPane contents: Array new].
 refList := self methodsRefList.
 instanceSelectedLast
  ifTrue: [
   selectedInstVar isNil
    ifTrue: [ rl1 := SortedCollection new.
     slist := selectedClass selectors asSortedCollection.
     slist do: [ :i |
      (refList includes: i)
       ifTrue: [ rl1 add: i ]].
     ^selectorPane contents: rl1]
    ifFalse: [
     methods := assigned
      ifTrue: [
       used
        ifTrue: [selectedClass allMethodsReferencingInstVar: selectedInstVar]
        ifFalse: [selectedClass allMethodsAssigningInstVar: selectedInstVar]]
      ifFalse: [
       used
        ifTrue: [selectedClass allMethodsUsingInstVar: selectedInstVar]
        ifFalse: [^selectorPane contents: selectedClass selectors asSortedCollection]].
      slist := (methods asOrderedCollection collect: [:m | m selector]) asSortedCollection.
      rl1 := SortedCollection new.
      slist do: [ :i |
       (refList includes: i)
        ifTrue: [ rl1 add: i ]].
      ^selectorPane contents: rl1]]
  ifFalse: [
   ^selectorPane contents: refList asSortedCollection]!
setBufferSize
 "set buffersize"
 | size |
 size := self getString: 'enter buffer size value' default: (self saveMAX) printString.
 size := size asInteger.
 size := size min: 25.
 size := 1 max: size.
 self saveMAX: size.
 Save := (Save,(Array new: size)) copyFrom: 1 to: size.
 (self savePOS) > size
  ifTrue: [ self savePOS: (size - 1) ]! 
setCategoryOptions
 "Set the Options for a Category"
 MessageBox message: 'Sorry, not implemented yet!!'!   
showHierarchy
 "display the hierarchy of the selected class"
 | c d oc ws iv tx hl rstr |
 (selectedClass isNil)
  ifTrue: [ ^nil ].
 oc := OrderedCollection new.
 hl := 0.
 rstr := (String new: 30) atAllPut: $ .
 c := self realClass.
 d := c.
 [c superclass isNil]
  whileFalse: [ ws := WriteStream on: String new.
   ws nextPutAll: ' ( '.
   c instVarNames do: [ :iv |
    ws nextPutAll: iv,' '. ].
   ws nextPutAll: ')'.
   oc add: (c name,ws contents).
   c := c superclass ].
 ws := WriteStream on: String new.
 ws nextPutAll: ' ( '.
 c instVarNames do: [ :iv |
  ws nextPutAll: iv,' '. ].
 ws nextPutAll: ')'.
 oc add: (c name,ws contents).
 ws := WriteStream on: String new.
 oc reversed do: [ :o |
  ((oc indexOf: o) = 1)
   ifTrue: [ ws nextPutAll: (('->',rstr) copyFrom: 1 to: (2*hl)),o;cr. ]
   ifFalse: [ ws nextPutAll: (rstr copyFrom: 1 to: (2*hl)),o;cr. ].
  hl := hl + 1].
 self addSubclassesFrom: d to: ws with: hl.
 self paneTEXT contents: (ws contents);
  display!
showSave
 "display the save-buffer"
 | ws ap |
 ws := WriteStream on: String new.
 ws cr.
 ws nextPutAll: 'Saved status: (number, classcategory, methodcategory, class, method)';cr.
 ws nextPutAll: ((String new: 90) atAllPut: $-);cr.
 ap := self savePOS.
 1 to: self saveMAX do: [ :no |
  ap = no
   ifTrue: [ ws nextPutAll: '--> ' ]
   ifFalse: [ ws nextPutAll: '    ' ].
  (Save at: no) isNil
   ifTrue: [ ws nextPutAll: '<',no printString,'>';cr. ]
   ifFalse: [ ws nextPutAll: no printString,' ',(Save at: no) printString;cr. ].
 ].
 ws cr;cr.
 ws nextPutAll: 'function with marked position: ';cr.
 ws nextPutAll: '  SAVE-Button    : position after marking will be overwritten';cr.
 ws nextPutAll: '  RESTORE-Button : marked position will be displayed next';cr.
 self paneTEXT contents: ws contents;
  display.!   
specialFunctions: aPane
 "open a special function-window"
 (aPane contents = 'Mths:0')
  ifTrue: [CategorySelectDialog new open].! 
text: aPane
 "Change the contents of the textpane aPane"
 | comment |
 super text: aPane.
 ((aPane contents isEmpty) and: [ self isCatSelected ])
  ifTrue: [ comment := (CategoryManager commentAt: selectedCategory).
   comment isEmpty
    ifTrue: [ aPane contents: ('
CategoryManager
  category:
    ', selectedCategory printString ,'
  comment: ',comment printString) ]
    ifFalse: [ aPane contents: ('
CategoryManager
  category:
    ', selectedCategory printString ,'
  comment:
    ',comment printString) ].
  aPane modified: false. ].!   
updateCCMenu: m
 "Add the userdefinitions to the CC menu"
 | d sm c |
 self class initializeUserDefinitions.
 m isNil
  ifTrue: [ ^self ].
 d := (Options at: #UD ifAbsent: [ Dictionary new ]).
 (d size = 0) ifTrue: [ ^self ].
 sm := Menu new owner: self;
  title: 'User Definitions';
  selector: #performCCItem:.
 c := 49.
 d keys asSortedCollection do: [ :k |
  sm appendItem: (k,'	Ctrl+Alt+',(String with: c asCharacter))
    selector: k
    accelKey: c asCharacter
    accelBits: AfChar | AfControl | AfAlt.
 c := c + 1.
 ].
 m appendSubMenu: sm;
  appendSeparator.! 
updateINFOpane
 "Fill the info-pane with new contents"
 | c cm |
 c := WriteStream on: String new.
 selectedClass isNil
  ifFalse: [
   selectedMethod isNil
    ifTrue: [ c nextPutAll: 'Mths:',self realClass selectors size printString.
     ((selectedClass respondsTo: #dllName) and: [ selectedClass dllName notNil ])
      ifTrue: [ c nextPutAll: '  Lib:',(selectedClass dllName reversed asStream upTo: $\) reversed ] ]
    ifFalse: [ cm := self realClass compiledMethodAt: selectedMethod.
     cm isNil ifTrue: [^c nextPutAll: 'Mths:',self realClass selectors size printString ].
     c nextPutAll: 'Src:',cm sourceString size printString.
     c nextPutAll: ' BCA:',cm byteCodeArray size printString.
     c nextPutAll: ' Data:',cm size printString.
     c nextPutAll: ' Loc:'.
     c nextPutAll: ((cm sourceIndex = 3)
      ifFalse: [ (#('No Source' 'SML-File' 'LOG-File') at: (cm sourceIndex + 1)) ]
      ifTrue: [ ((cm respondsTo: #dllName) and: [ cm dllName notNil ])
       ifTrue: [ (cm dllName reversed asStream upTo: $\) reversed ]
       ifFalse: [ '???' ] ]) ].
  ].
 (self paneINFO contents = c contents)
  ifTrue: [ ^self ].
 self paneINFO contents: c contents.! !

! CPBitmapManager class methods ! 
addToolbarTool

    | class |

    class := Smalltalk at: #MDISystem ifAbsent: [ nil ].

    class notNil ifTrue: [
        class addExtraTool: self toolBarTool.
    ].! 
clearBMIcon

    "  CPBitmapManager clearBMIcon   "

    BMIcon := nil.!  
clearToolbarTool

    "      CPBitmapManager clearToolbarTool      "

    ToolbarTool := nil.!
createToolbarBitmapFrom: bitmapName newName: newName innerRect: innerRect

    | newBitmap  bitmap singleBitmapExtent |

    bitmapName isString ifFalse: [
        bitmap := bitmapName
    ] ifTrue: [
        bitmap := CPBitmapDict at: bitmapName ifAbsent: [ Terminal bell. ^self ].
    ].

    newBitmap := (CPBitmapDict at: 'toolPaneExample') cpCopy.
    singleBitmapExtent := (Smalltalk at: #Tool) basicNew defaultExtent.

    newBitmap pen
        copyBitmap: bitmap
        from: bitmap boundingBox
        to: innerRect.

    newBitmap pen
        copyBitmap: bitmap
        from: bitmap boundingBox
        to: (innerRect leftTop + ((1 + singleBitmapExtent x)@1) extentFromLeftTop: innerRect extent).

    CPBitmapDict at: newName put: newBitmap.! 
helpDict

    HelpDict isNil ifTrue: [
        HelpDict := Dictionary new.
        HelpDict
            at: 'File' put: 'Create, retrieve, and savebitmaps.';
            at: 'create' put: 'Create a new bitmap.';
            at: 'fromScreen' put: 'Capture a bitmap from the screen.';
            at: 'fromFile' put: 'Import a .ico or .bmp file as a bitmap.';
            at: 'load' put: 'Import a bitmap dictionary (.bdt) file';
            at: 'save' put: 'Save the list of bitmaps to a dictionary (.bdt) file';
            at: 'exit' put: 'Close the bitmap manager.';

            at: 'Edit' put: 'Bitmap copying, pasting, duplicating, and editing';
            at: 'copyToClipboard' put: 'Copy the currently selected bitmap to the clipboard.';
            at: 'fromClipboard' put: 'Paste the bitmap on the clipboard into the bitmap manager.';
            at: 'delete' put: 'Delete the currently selected bitmap from the bitmap manager.';
            at: 'duplicate' put: 'Create a copy of the currently selected bitmap.';
            at: 'rename' put: 'Change the name of the currently selected bitmap.';
            at: 'edit'  put: 'Launch the Digitalk bit editor on the currently selected bitmap.'
    ].

    ^HelpDict!   
launchBitmapManager

    self new open! 
new
    "Reimplemented for generating OS Replacement objects...
    Implemented By Ale for External Bitmap support..."

    #addedByOStyle.
    self == CPBitmapManager
    ifFalse: [^super new].

    ^(Smalltalk
        at: #OSBitmapManager
        ifAbsent: [^super new]) new!   
screenIcon

    | dir |

    BMIcon isNil ifTrue: [
        (Smalltalk includesKey: #CPSrcDir) ifTrue: [
            dir := (Smalltalk at: #CPSrcDir).
        ] ifFalse: [
            dir := ''.
        ].
        BMIcon := Icon fromFile: dir, 'bitmgr.ico'.
    ].

    ^BMIcon!   
toolBarTool

    ToolbarTool isNil ifTrue: [
        ToolbarTool :=  (Smalltalk at: #Tool) new fromBitmap: (CPBitmapDict sysAt: 'bitmapManagerToolbarBitmap').
        ToolbarTool
            selector: #launchBitmapManager;
            owner: CPBitmapManager;
            name: 'BitmapManager Tool';
            space: 1
    ].

    ^ToolbarTool! !

! CPBitmapManager methods ! 
addBitmap: b

    | name |

    b isNil ifFalse: [
        ((name := Prompter prompt: 'Name for new bitmap: ' default: '') notNil and: [ name isEmpty not ]) ifTrue: [
            bitmapDictionary at: name put: b.
            bitmapName := name.
            bitmapDictionary size = 1 ifTrue: [
                self updateMenus.
            ].
            self
                changed: #listContents:;
                changed: #graphContents:.
        ].
    ].!   
bitmap

    ^bitmapDictionary at: bitmapName!   
bitmapDictionary: dict

    bitmapDictionary := dict.
    bitmapDictionary isEmpty ifFalse: [
        bitmapName := dict keys asSortedCollection first.
    ].!  
bitmapSelected: aPane

    bitmapName := aPane selectedItem.
    self changed: #graphContents:!
copyToButton
    "Converts the currently selected bitmap to a button.
     Implemented by Ale..."
    | button bitmap offset |
    #addedByOStyle.
    bitmapName isNil ifTrue: [^nil].
    button := CPCreateButton new open result.
    bitmap := self bitmap.
    button extent //  2 - bitmap extent < (3@3)
    ifTrue: [ self error: 'Button too small' ].
    offset := button width // 4 - (bitmap width // 2) @ (button height - bitmap height // 2).
    bitmap
        displayAt: offset with: button pen;
        displayAt: button width // 2 + 2 @ 2 + offset with: button pen;
        yourself.
    self addBitmap: button.!   
copyToClipboard

    bitmapName notNil ifTrue: [
        Clipboard setBitmap: self bitmap.
        (self menuWindow menuTitled: 'Edit')
            enableItem: #fromClipboard.
    ].! 
copyToDefault

    bitmapName notNil ifTrue: [
        CPBitmapDict defaultBitmapDictionary at: bitmapName put: self bitmap cpCopy.
    ].!   
create

    self addBitmap: CPCreateBitmap new open result! 
createNewButton

    self addBitmap: CPCreateButton new open result.!   
delete

    (MessageBox confirm: 'Delete bitmap: "', bitmapName, '"?') ifTrue: [
        bitmapDictionary removeKey: bitmapName.
        bitmapDictionary isEmpty ifTrue: [
            bitmapName := nil.
            self updateMenus.
        ] ifFalse: [
            bitmapName := bitmapDictionary keys asSortedCollection first.
        ].
        self
            changed: #listContents:;
            changed: #graphContents:.

        list setFocus.
    ].! 
duplicate

    bitmapName notNil ifTrue: [
        self addBitmap: self bitmap cpCopy.
    ].!
edit

    bitmapName notNil & (Smalltalk includesKey: #BitEditor) ifTrue: [
        (Smalltalk at: #BitEditor) new openOn: self bitmap.
    ] ifFalse: [
        MessageBox message: 'The BitEditor class from the FreeDraw example must be installed to bit edit bitmaps.'
    ].! 
edit: aPane

    self edit.!
editButton

    bitmapName notNil & (Smalltalk includesKey: #ButtonEditor) ifTrue: [
        (Smalltalk at: #ButtonEditor) new openOn: self bitmap.
    ] ifFalse: [
        MessageBox message: 'The file BUTTONED.ST must be installed to edit buttons.'
    ].!  
exit

    self close!   
fromClipboard

    | b |

    (b := Clipboard getBitmap) notNil ifTrue: [
        self addBitmap: b.
    ] ifFalse: [
        MessageBox message: 'The Windows Clipboard does not contain a bitmap.'
    ].!  
fromFile

    | file bitmap icon stream extension |

    file := self getFile: 'Load Bitmap From:'
        fileSpec: '*.bmp'
        type: #file.

    file isNil ifTrue: [
        ^self
    ].

    stream := ReadStream on: file.
    stream upTo: $..
    extension := stream nextLine.
    extension = 'ICO' ifTrue: [
        icon := Icon fromFile: file.
        bitmap := Bitmap screenWidth: 32 height: 32.
        icon displayWith: bitmap pen.
    ] ifFalse: [
        bitmap := Bitmap fromFile: file.
    ].

    self addBitmap: bitmap!  
fromScreen

    | bitmap button extent inset |
    bitmap := Bitmap fromUser.
    Notifier isAltDown ifFalse: [
        self addBitmap: bitmap
    ] ifTrue: [
        "Place the bitmap into the currently selected button bitmap"
        inset := 1.
        button := self bitmap.
        extent := ((button width // 2) - 5 - (inset * 2)) @ (button height - 5 - (inset * 2)).
        bitmap extent < extent ifTrue: [
            Notifier isCtrlDown ifFalse: [
                button pen
                    copyBitmap: bitmap
                    from: bitmap boundingBox
                    to: (((2@2 + inset) + ((extent - bitmap extent) // 2))extent: bitmap extent)
                    rule: Srccopy.
            ].
            button pen
                copyBitmap: bitmap
                from: bitmap boundingBox
                to: (((button width // 2 + 4 + inset)@(4 + inset) + ((extent - bitmap extent) // 2))extent: bitmap extent)
                rule: Srccopy.
        ] ifFalse: [
            Notifier isCtrlDown ifFalse: [
                button pen
                    copyBitmap: bitmap
                    from: bitmap boundingBox
                    to: ((2@2 + inset) extent: extent)
                    rule: Srccopy.
            ].
            button pen
                copyBitmap: bitmap
                from: bitmap boundingBox
                to: ((button width // 2 + 4 + inset)@(4 + inset) extent: extent)
                rule: Srccopy.
        ].
        self changed: #graphContents:.
    ].!  
getFile: title fileSpec: fileSpec type: type

    | d |

    (Smalltalk version = '1.1') ifFalse: [
        d := FileDialog new
            title: title;
            fileSpec: fileSpec;
            hideReadonly.
        type == #library ifTrue: [
            d
                addFilter: '*.bdt' description: 'Bitmap dictionaries (*.BDT)';
                defFilter: '*.bdt'
        ] ifFalse: [
            d
                addFilter: '*.bmp' description: 'Bitmap file (*.BMP)';
                addFilter: '*.ico' description: 'Icon file (*.ICO)';
                defFilter: '*.bmp'.
        ].
        ^d
            open;
            file
    ] ifTrue: [
        ^(FileDialog new
            openTitle: title
            fileSpec: fileSpec
            showFileInButton: false) file
    ].!  
graphContents: aPane

    | b o |

    aPane pen erase.
    bitmapName notNil ifTrue: [
        b := self bitmap.
        b displayAt: (o := aPane extent - b extent // 2) with: aPane pen.
    ].!   
listContents: aPane

    | keys |

    bitmapDictionary isEmpty ifTrue: [
        keys := #().
    ] ifFalse: [
        keys := bitmapDictionary keys asSortedCollection.
    ].

    aPane
        contents: keys;
        selection: bitmapName!
load

    | file aDict add |

    add := Notifier isAltDown.

    file := self getFile: 'Load Bitmaps From:'
        fileSpec: '*.bdt'
        type: #library.

    file notNil ifTrue: [
        CursorManager execute change.
        (aDict := CPBitmapDict fromFile: file) notNil ifTrue: [
            (bitmapDictionary == CPBitmapDict defaultBitmapDictionary) ifTrue: [
                add ifTrue: [
                    aDict associationsDo: [ :assoc | self defaultBitmapDictionary add: assoc ].
                ] ifFalse: [
                    CPBitmapDict defaultBitmapDictionary: aDict
                ].
            ] ifFalse: [ (bitmapDictionary == CPBitmapDict systemBitmapDictionary) ifTrue: [
                add ifTrue: [
                    aDict associationsDo: [ :assoc | self systemBitmapDictionary add: assoc ].
                ] ifFalse: [
                    CPBitmapDict systemBitmapDictionary: aDict
                ].
            ]].
            self bitmapDictionary: aDict.

            self
                changed: #listContents:;
                changed: #graphContents:.
        ].
        CursorManager normal change.
    ].!   
loadBitmapDictionaryFrom: fileName

    | file aDict |

    file := File pathName: fileName.
    file nextLine = 'BITMAPS' ifFalse: [
        file close.
        ^MessageBox message: 'This file is not a valid bitmap dictionary.'
    ] ifTrue: [
        aDict := Dictionary new.
        [ file atEnd ] whileFalse: [
            aDict at: file nextLine put: (Bitmap fromStream: file).
            self bitmapDictionary: aDict.
        ].
    ].
    file close.!
open

    | system |

    bitmapDictionary isNil ifTrue: [
        self bitmapDictionary: ((system := Notifier isAltDown)
            ifTrue: [ CPBitmapDict systemBitmapDictionary ]
            ifFalse: [ CPBitmapDict defaultBitmapDictionary ])
    ].

    self
            owner: self;
            labelWithoutPrefix:  (system
                ifTrue: ['System Bitmap Manager']
                ifFalse: ['Bitmap Manager']);
            when: #activate perform: #updateKeys:;
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingRatio: ((Rectangle leftTopUnit rightAndDown: (1/3 @ 0))
                        extentFromLeftTop: 2/3 @ 1);
                    style: GraphPane noScrollBarsFrameStyle;
                    when: #getContents perform: #graphContents:;
                    when: #button1DoubleClick perform: #edit:;
                    yourself
            );
            addSubpane: (
                list := ListBox new
                    owner: self;
                    framingRatio:
                        (Rectangle leftTopUnit
                            extentFromLeftTop: 1/3 @ 1);
                    when: #getContents perform: #listContents:;
                    when: #select perform: #bitmapSelected:;
                    when: #doubleClickSelect perform: #edit:;
                    yourself
            ).

    self menuWindow
        addMenu: (
            Menu new
                title: '&File';
                owner: self;
                appendItem: '&New...	Ctrl+N' selector: #create accelKey: $n accelBits: AfControl | AfChar;
                appendItem: 'New Button...' selector: #createNewButton;
                appendItem: 'From &Screen...' selector: #fromScreen;
                appendItem: 'From &File...' selector: #fromFile;
                appendItem: 'Save &To File...' selector: #saveToFile;
                appendSeparator;
                appendItem: '&Open Bitmap File...	Ctrl+O' selector: #load accelKey: $o accelBits: AfControl | AfChar;
                appendItem: 'Save Bitmaps &As...	Ctrl+S' selector: #save accelKey: $s accelBits: AfControl | AfChar;
                appendSeparator;
                appendItem: 'E&xit' selector: #exit
        );
        addMenu: (
            myEdit := Menu new
                title: '&Edit';
                owner: self;
                appendItem: '&Copy To Clipboard	Ctrl+C' selector: #copyToClipboard accelKey: $c accelBits: AfChar | AfControl;
                appendItem: 'Copy to &Button...	Ctrl+B' selector: #copyToButton accelKey: $B accelBits: AfChar | AfControl;
                appendItem: '&Paste From &Clipboard...	Ctrl+V' selector: #fromClipboard accelKey: $v accelBits: AfChar | AfControl;
                appendItem: 'De&lete	Ctrl+Delete' selector: #delete accelKey: VkDelete accelBits:  AfVirtualkey | AfControl;
                appendItem: '&Duplicate' selector: #duplicate;
                appendItem: '&Rename...' selector: #rename;
                appendSeparator;
                appendItem: '&Bit Edit...	Ctrl+E' selector: #edit accelKey: $e accelBits: AfControl | AfChar;
                appendItem: '~Button Edit...	Ctrl+B' selector: #editButton accelKey: $b accelBits: AfControl | AfChar;
                appendItem: '~Resize Button...	Ctrl+R' selector: #resizeButton accelKey: $r accelBits: AfControl | AfChar
        ).
        system ifTrue: [
            myEdit
                appendSeparator;
                appendItem: 'Copy to Default Dictionary' selector: #copyToDefault
        ].

    self icon: self class screenIcon.

    self mainView noSmalltalkMenuBar.
    self openWindow.

    bitmapName notNil ifTrue: [
        list selection: bitmapName.
    ].!
openOn: dict

    self bitmapDictionary: dict.

    ^self open!   
removeMenus: ignore

    self mainView menuWindow menus do: [:m |
        (m == myFile) | (m == myEdit) ifFalse: [
            self mainView menuWindow removeMenu: m.
        ].
    ].

    self updateMenus.!  
rename

    | b n |

    (n := Prompter prompt: 'Name for bitmap:' default: bitmapName) notNil ifTrue: [
        n notEmpty ifTrue: [
            b := bitmapDictionary at: bitmapName.
            bitmapDictionary
                removeKey: bitmapName;
                at: n put: b.
            bitmapName := n.
            self
                changed: #listContents:.
        ].
    ].! 
resizeButton

    | extent current button changeList newSize |

    button := self bitmap.
    Notifier isAltDown ifTrue: [
        extent := button extent.
        changeList := bitmapDictionary select: [ :bitmap |
            bitmap extent = extent ].
    ] ifFalse: [
        changeList := bitmapDictionary select: [ :bitmap |
            bitmap == button ].
    ].
    extent := button width // 2 @ button height.
    newSize := Prompter prompt: 'Enter new button size:' default: extent asString.
    newSize isNil ifTrue: [ ^nil ].

    newSize := ((newSize upTo: $@) trimBlanks asInteger) @
        ((newSize reversed upTo: $@) reversed trimBlanks asInteger).

    changeList keysDo: [ :name |
        current := changeList at: name.
        button := Bitmap buttonWidth: newSize x height: newSize y.

        (newSize x < extent x or: [ newSize y < extent y or: [ Notifier isCtrlDown ]]) ifTrue: [
            button pen
                copyBitmap: current
                from: (2@2 extent: (extent - 5))
                to: (2@2 extent: (newSize - 5))
                rule: Srccopy.
            button pen
                copyBitmap: current
                from: ((current width // 2 + 4) @ 4 extent: (extent - 5))
                to: ((button width // 2 + 4) @ 4 extent: (newSize - 5))
                rule: Srccopy.
        ] ifFalse: [
           button pen
                copyBitmap: current
                from: (2@2 extent: (extent - 5))
                to: ((2@2 + ((newSize - extent) // 2)) extent: (extent - 5))
                rule: Srccopy.
            button pen
                copyBitmap: current
                from: ((current width // 2 + 4) @ 4 extent: (extent - 5))
                to: (((button width // 2 + 4) @ 4 + ((newSize - extent) // 2)) extent: (extent - 5))
                rule: Srccopy.
        ].
        bitmapDictionary at: name put: button.
    ].
    self changed: #graphContents:.!
save

    | file s dict keys |

    Notifier isAltDown ifTrue: [
        keys := (Smalltalk at: #WBMultiListChooser ifAbsent: [ ^nil ])
            fromList: bitmapDictionary keys asSortedCollection
            prompt: 'Select bitmaps to store:'.
        (keys isNil or: [ keys isEmpty ]) ifTrue: [ ^nil ].
        dict := bitmapDictionary associationsSelect: [ :bitmap |
            keys includes: bitmap key ].
    ] ifFalse: [
        dict := bitmapDictionary
    ].

    file := self getFile: 'Save Bitmaps To:'
        fileSpec: 'bitmaps.bdt'
        type: #library.

    file notNil ifTrue: [
        CursorManager execute change.
        dict saveOn: file.
        CursorManager normal change.
    ].!   
saveBitmapDictionaryOn: fileName

    | file |

    file := File newFile: fileName.
    file nextPutAll: 'BITMAPS'; cr.
    bitmapDictionary keysDo: [:k |
        file nextPutAll: k; cr.
        (bitmapDictionary at: k) storeOnStream: file.
    ].
    file close.!
saveToFile

    | file s |

    bitmapName isNil ifTrue: [ ^nil ].

    file := self getFile: 'Save Bitmap To:'
        fileSpec: '*.bmp'
        type: #file.

    file notNil ifTrue: [
        CursorManager execute change.
        self bitmap outputToFile: file.
        CursorManager normal change.
    ].!
statusPaneHelp:aKey
    "Answer the default dictionary used by
    the status bar for help support"

    ^self class helpDict at:aKey ifAbsent:[]!
updateKeys: aPane

    "On Window Activation."

    | keys |

    Clipboard getBitmap isNil ifTrue: [
        (self menuWindow menuTitled: 'Edit')
            disableItem: #fromClipboard.
    ] ifFalse: [
        (self menuWindow menuTitled: 'Edit')
            enableItem: #fromClipboard.
    ].

    list contents = (keys := bitmapDictionary keys asSortedCollection) ifFalse: [
        bitmapDictionary isEmpty ifTrue: [
            bitmapName := nil.
        ] ifFalse: [
            (keys includes: bitmapName) ifFalse: [
                bitmapName := keys first.
            ].
        ].
        self updateMenus.
        self changed: #listContents:.
    ].

    self changed: #graphContents:.!   
updateMenus

    | sel |

    bitmapName isNil ifTrue: [
        sel := #disableItem:.
    ] ifFalse: [
        sel := #enableItem:.
    ].

    (self menuTitled: 'File') perform: sel with: #save.

    #(edit delete duplicate copyToClipboard) do: [:i |
        (self menuTitled: 'Edit') perform: sel with: i.
    ].! !

! OSBitmapManager class methods ! 
disableWindowDuringLongTasks
    "Private - True if the receiver's instances must
    disable mainwindow when performing long tasks"

    ^false! 
literalsToReplace
    "Private - Dont use this method..
    Its for reference during instance initialization..."

    "Literal replacements..."
    Prompter. "will be replaced by... " OSPrompter.! !

! OSBitmapManager methods !
bitmap

    ^bitmapDictionary at: bitmapName ifAbsent: []!  
buttonFromScreen

    | bitmap button extent inset |
    inset := 1.
    bitmap := Bitmap fromUser.
    button := CPCreateButton new open result.
    button isNil ifTrue: [^self].
    extent := ((button width // 2) - 5 - (inset * 2)) @ (button height - 5 - (inset * 2)).
    bitmap extent < extent ifTrue: [
        Notifier isCtrlDown ifFalse: [
            button pen
                copyBitmap: bitmap
                from: bitmap boundingBox
                to: (((2@2 + inset) + ((extent - bitmap extent) // 2))extent: bitmap extent)
                rule: Srccopy.
        ].
        button pen
            copyBitmap: bitmap
            from: bitmap boundingBox
            to: (((button width // 2 + 4 + inset)@(4 + inset) + ((extent - bitmap extent) // 2))extent: bitmap extent)
            rule: Srccopy.
    ]
    ifFalse: [
        Notifier isCtrlDown ifFalse: [
            button pen
                copyBitmap: bitmap
                from: bitmap boundingBox
                to: ((2@2 + inset) extent: extent)
                rule: Srccopy.
        ].
        button pen
            copyBitmap: bitmap
            from: bitmap boundingBox
            to: ((button width // 2 + 4 + inset)@(4 + inset) extent: extent)
            rule: Srccopy.
    ].

    self addBitmap: button.!
buttonsToTools
    "Converts all the buttons to tools."
    | button |

    (MessageBox confirm: 'Sure you want to convert all buttons to tools ?')
    ifFalse: [^self].

    self do: [ :aName :aBitmap |
        (self isButton: aBitmap)
        ifTrue: [ bitmapDictionary at: aName put: (self buttonToTool: aBitmap) ]
    ] to: bitmapDictionary saying: 'Buttons to tools '
      atEnd: [ self changed: #graphContents: ]!   
buttonToTool
    "Converts the currently selected button to a tool."
    | button tool source dest |
    bitmapName isNil ifTrue: [^nil].
    button := self bitmap.
    (self isButton: button) ifFalse: [^self].
    bitmapDictionary at: bitmapName put: (self buttonToTool: button).
    self changed: #graphContents:!
buttonToTool: aBitmap
    "Converts aBitmap to a tool."
    | button tool source dest |
    button := aBitmap.
    tool := OSTool buttonWidth: button width // 2 height: button height planes: 3.

    source := 1@1 extent: button width // 2 @ button height - 1.
    source := source insetBy: 1.
    dest := 1@1 extent: tool width // 3 @ tool height - 1.
    dest := dest insetBy: 1.
    tool pen copyBitmap: button from: source to: dest.
    source moveBy: button width // 2 @ 0 + 1.
    dest moveBy: tool width // 3 @ 0 + 1.
    tool pen copyBitmap: button from: source to: dest.
    source moveBy: (button width // 2 @ 0 + 1) negated.
    dest moveBy: tool width // 3 @ -1.
    tool pen copyBitmap: button from: source to: dest.

    OSTool
        gray: tool
        into: (tool width // 3 * 2 @ 0  extent: tool width // 3 @ tool height - 1).

    ^tool! 
captureMenu
    "Private - Returns the list capture menu"

    ^Menu new
        owner: self;
        appendItem: '&Bitmap...' selector: #fromScreen;
        appendItem: 'B&utton...' selector: #buttonFromScreen;
        appendItem: '&Tool...	Alt+C' selector: #toolFromScreen accelKey: $c accelBits: AfAlt | AfChar;
        title: '&Capture...'!  
changed: aSymbol

    "Filter graphContents: for redisplay..."

    aSymbol == #graphContents:
    ifTrue: [ ^graphPane invalidateRect: nil ].

    ^super changed: aSymbol!   
colorsOf: aBitmap
    "Private - returns all the colors in a bitmap."

    | bag pixel |
    bag := Bag new.
    0 to: aBitmap width - 1 do: [:x|
        0 to: aBitmap height - 1 do: [:y|
            pixel := (WinAddress fromBytes:(
                GDILibrary
                    getPixel: aBitmap pen handle
                    x: x y:y)) asInteger.
            bag add: pixel.
        ].
    ].
    ^bag!  
conversionsMenu
    "Private - Returns the bitmap conversions menu"

    ^Menu new
        owner: self;
        appendItem: '&Button to Tool' selector: #buttonToTool;
        appendItem: '&Tool to Button' selector: #toolToButton;
        appendSeparator;
        appendItem: 'to 1&6 colors...	Ctrl+6' selector: #convertTo16 accelKey: $6 accelBits: AfControl | AfChar;
        appendItem: 'to &Mono...	Ctrl+0' selector: #convertToMono accelKey: $0 accelBits: AfControl | AfChar;
        appendItem: 'to &Screen DC...	Ctrl+1' selector: #convertToScreen accelKey: $1 accelBits: AfControl | AfChar;
        appendSubMenu: (
            Menu new
                owner: self;
                    appendItem: '1&6 colors...' selector: #convertAllTo16;
                    appendItem: '&Mono...' selector: #convertAllToMono;
                    appendItem: '&Screen DC...' selector: #convertAllToScreen;
                title: '&All to...'
            );
        title: 'C&onvert...'!   
convertAllTo: aString
    "Private - convert All bitmap(s) to mode in aString..."
    | selector |
    selector := ('convertTo',aString,':') asSymbol.
    self
        do: [:aName :aBitmap |
            bitmapDictionary at: aName put: (self perform: selector with: aBitmap)
        ] to: bitmapDictionary
        saying: 'Converting to ',aString,'. '
        atEnd: [ self changed: #graphContents: ]! 
convertAllTo16
    "Private - convert All bitmap(s)..."
    self convertAllTo: '16'!
convertAllToMono
    "Private - convert All bitmap(s)..."
    self convertAllTo: 'Mono'!
convertAllToScreen
    "Private - convert All bitmap(s)..."
    self convertAllTo: 'Screen'!
convertTo16
    "Private - convert selected bitmap(s)..."
    self convertWith: #convertTo16:!  
convertTo16: aBitmap
    "Private - converts aBitmap to 16 colors and returns the converted bitmap..."
    | bitmap |
    bitmap := Bitmap width: aBitmap width height: aBitmap height planes: 1 bitCount: 4.
    bitmap pen copyBitmap: aBitmap from: aBitmap boundingBox to: bitmap boundingBox.
    ^bitmap!  
convertToMono
    "Private - convert selected bitmap(s)..."
    self convertWith: #convertToMono:!  
convertToMono: aBitmap
    "Private - converts aBitmap to Mono and returns the converted bitmap..."
    | bitmap |
    bitmap := Bitmap width: aBitmap width height: aBitmap height.
    bitmap pen copyBitmap: aBitmap from: aBitmap boundingBox to: bitmap boundingBox.
    ^bitmap!   
convertToScreen
    "Private - convert selected bitmap(s)..."
    self convertWith: #convertToScreen:!  
convertToScreen: aBitmap
    "Private - converts aBitmap to Screen DC and returns the converted bitmap..."
    | bitmap |
    bitmap := Bitmap screenWidth: aBitmap width height: aBitmap height.
    bitmap pen copyBitmap: aBitmap from: aBitmap boundingBox to: bitmap boundingBox.
    ^bitmap!  
convertToSystemColors
    "Private - convert selected bitmap(s)..."
    self convertWith: #convertToSystemColors:!  
convertToSystemColors: aBitmap
    "Private - Convert aBitmap to system palette colors."
    | pixel |
    0 to: aBitmap width - 1 do: [:x|
        0 to: aBitmap height - 1 do: [:y|
            pixel := (WinAddress fromBytes:(
                GDILibrary
                    getPixel: aBitmap pen handle
                    x: x y:y)) asInteger.
            (pixel bitAnd: 16r01000000) = 0
            ifTrue: [ "non indexed value..."
                aBitmap pen
                    foreColor: (Pen rgbToPalette: pixel);
                    place: x@y;goto: x+1@y
            ]
        ]
    ].
    ^aBitmap!  
convertWith: aSymbol
    "Private - Convert selected bitmaps with aSymbol"
    | current bitmap extent changeList |

    current := self bitmap.
    Notifier isAltDown ifTrue: [
        extent := current extent.
        changeList := bitmapDictionary select: [ :each | each extent = extent ].
    ] ifFalse: [
        changeList := bitmapDictionary select: [ :each | each == current ].
    ].

    changeList keysDo: [ :name |
        current := changeList at: name.
        bitmapDictionary at: name put: (self perform: aSymbol with: current).
    ].
    self changed: #graphContents:.!   
copyMenu
    "Private - Returns the bitmap copy menu"

    ^Menu new
        owner: self;
        appendItem: '&Clipboard	Ctrl+C' selector: #copyToClipboard accelKey: $c accelBits: AfChar | AfControl;
        appendItem: '&Button...' selector: #copyToButton;
        appendItem: '&Tool...' selector: #copyToTool;
        title: '&Copy To...'!
copyToButton
    "Converts the currently selected bitmap to a button.
     Implemented by Ale..."
    | button bitmap offset |
    bitmapName isNil ifTrue: [^nil].
    bitmap := self bitmap.
    (self isTool: bitmap) ifTrue: [
        ^self addBitmap: (self toolToButton: bitmap)
    ].
    button := CPCreateButton new open result.
    button isNil ifTrue: [^self].
    offset := button width // 2 - bitmap width // 2 @ (button height - bitmap height // 2).
    bitmap
        displayAt: offset with: button pen;
        displayAt: button width // 2 + 2 @ 2 + offset with: button pen;
        yourself.
    self addBitmap: button.!  
copyToTool
    "Converts the currently selected bitmap to a tool.
     Implemented by Ale..."
    | button bitmap offset |
    #addedByOStyle.
    bitmapName isNil ifTrue: [^nil].
    bitmap := self bitmap.
    (self isButton: bitmap) ifTrue: [
        ^self addBitmap: (self buttonToTool: bitmap)
    ].
    button := OSCreateTool new open result.
    button isNil ifTrue: [^self].
    offset := button width // 3 - bitmap width // 2 @ (button height - bitmap height // 2).
    bitmap
        displayAt: offset with: button pen;
        displayAt: button width // 3 + 2 @ 2 + offset with: button pen;
        displayAt: button width * 2 // 3 + 2 @ 2 + offset with: button pen;
        yourself.
    OSTool
        gray: button
        into: (button width // 3 * 2 @ 0  extent: button width // 3 @ button height - 1).
    self addBitmap: button.!   
count: title with: aBlock
    "Private - Count the bitmaps that evaluates aBlock to true"

    | count otherInfo |
    count := 0.
    bitmapDictionary keys do: [:key|
        (aBlock value: (bitmapDictionary at: key))
        ifTrue: [ count := count + 1 ]
    ].
    otherInfo := '\\ Total of images : ' withCrs,bitmapDictionary size asString.

    count > 1
    ifTrue: [ ^MessageBox message: 'There are ',count asString,' ',title,'s',otherInfo ].
    count = 1
    ifTrue: [ ^MessageBox message: 'There are only a ',title,otherInfo ].
    count = 0
    ifTrue: [ ^MessageBox message: 'There are no ',title,'s',otherInfo ].!   
countBitmaps
    "Private - Count all the bitmaps"

    ^self
        count: 'Bitmap'
        with: [:aBitmap|
            ((self isButton: aBitmap)
            or: [self isButton: aBitmap]) not
        ]! 
countButtons
    "Private - Count all the buttons"

    ^self
        count: 'Button'
        with: [:aBitmap| (self isButton: aBitmap) ]!   
countColors
    "Private - Count all the colors used in selected bitmap..."
    | histogram |
    CursorManager execute changeFor: [
        histogram := self colorsOf: self bitmap
    ].
    self dumpHistogram: histogram title: 'Colors Used...'!  
countTools
    "Private - Count all the tools"

    ^self
        count: 'Tool'
        with: [:aBitmap| (self isTool: aBitmap) ]!   
createMenu
    "Private - Returns the list inst-creation menu"

    ^Menu new
        owner: self;
        appendItem: '&Bitmap...	Ctrl+N' selector: #create accelKey: $n accelBits: AfControl | AfChar;
        appendItem: 'B&utton...' selector: #createNewButton;
        appendItem: '&Tool...	Alt+T' selector: #createNewTool accelKey: $t accelBits: AfAlt | AfChar;
        title: '&New'!
createNewTool

    self addBitmap: OSCreateTool new open result.!   
delete

    (MessageBox confirm: 'Delete ',(self descriptionFor: self bitmap),': "', bitmapName, '"?') ifTrue: [
        bitmapDictionary removeKey: bitmapName.
        bitmapDictionary isEmpty ifTrue: [
            bitmapName := nil.
            self updateMenus.
        ] ifFalse: [
            bitmapName := bitmapDictionary keys asSortedCollection first.
        ].
        self
            changed: #listContents: with: #restore;
            changed: #graphContents:.
        list setFocus.
    ].!
descriptionFor: aBitmap
    "Private - Returns the description for the bitmap."

    | stream |
    stream := WriteStream on: String new.

    aBitmap isObjectFromResource
    ifTrue: [ stream nextPutAll: 'Proxy' ].

    stream nextPutAll:
        ((self isButton: aBitmap)
        ifTrue: ['Button']
        ifFalse: [
            (self isTool: aBitmap)
            ifTrue: [ 'Tool' ]
            ifFalse: [aBitmap class name]
        ]),
        (aBitmap isMono
        ifTrue: [' mono']
        ifFalse: [' ',aBitmap numberOfColors asString,' colors']).

    ^stream contents!  
displayContents: aPane

    | bitmap box |

    bitmapName isNil
    ifTrue: [^aPane pen erase]
    ifFalse: [
        bitmap := self bitmap.
        bitmap isNil ifTrue: [ ^aPane pen erase ].
        box := aPane extent - bitmap extent // 2 extent: bitmap extent.
        (aPane rectangleToDisplay nonIntersections: box)
        do: [:rect| aPane pen fill: rect color: aPane backColor ].
        aPane pen
            copyBitmap: bitmap
            from: bitmap boundingBox
            to: box.
        aPane pen
            foreColor: "ClrDarkblue"ClrDarkgray;
            place: box origin - 2;
            box: box corner + 2;
            place: box center x @ (box bottom + 15);
            setTextAlign: TaTop;
            setBackMode: Transparent;
            centerText: bitmap extent asString;
            place: box center x @ (box bottom + 35);
            centerText: (self descriptionFor: bitmap);
            foreColor: ClrBlack;
            yourself.
    ].! 
do: aBlock to: aDictionary saying: text atEnd: endBlock
    "Private - Perform aBlock to all elements..."

    | count size dict disable box |
    disable := self class disableWindowDuringLongTasks.
    dict := aDictionary.
    count := 0.
    size := dict size.
    [
        disable ifTrue: [self mainView disable].
        dict keys asSortedCollection do: [:each|
            aBlock value: each value: (dict at: each).
            count := count + 1.
            graphPane isHandleOk
            ifTrue: [
                box := 0@0 extent: graphPane pen boundingBox width @ (graphPane font height + 6).
                graphPane pen
                    fill: box color: graphPane backColor;
                    drawRect3D: box;
                    foreColor: ClrDarkblue;
                    displayText: text,(count * 100 // size) asString,'% [',each,']'
                    at: box origin + (4@2)
            ]
        ].
        endBlock value.
        disable ifTrue: [self mainView enable].
        Terminal bell.
        Bitmap purgeUnusedBitmaps.
    ] forkAt: 3!
drawBorder: aBitmap
    "Private - Redraw the border of aBitmap if it is aButton or a Tool"

    (self isButton: aBitmap)
    ifTrue: [ OSTool drawBordersOf: aBitmap planes: 2 ].
    (self isTool: aBitmap)
    ifTrue: [ OSTool drawBordersOf: aBitmap planes: 3 ].! 
dumpHistogram: collection title: title
    "Private - Dump all the colors used in Histogram in a notifier window..."
    | notifier systemColors color count histogram |
    histogram := collection copy.
    notifier := TextWindow
        windowLabeled: title
        frame: (graphPane frameRectangle insetBy: 3).
        systemColors := ColorConstants.
    notifier cr;nextPutAll: 'System Colors used:'.
    systemColors keys asSortedCollection
    do: [:key|
        color := systemColors at: key.
        count := histogram occurrencesOf: color.
        (count = 0 and: [(color bitAnd: 16r01000000) > 0]) ifTrue: [ "colorRef..."
            color := histogram occurrencesOf: (Pen paletteToRgb: color)
        ].
        count > 0 ifTrue: [
            notifier cr;nextPutAll: count asString ,'->',key.
            count timesRepeat: [histogram remove: color]
        ]
    ].
    histogram isEmpty ifFalse: [
        notifier cr;cr;nextPutAll: 'Non System Colors but same RGB...'.
        systemColors keys asSortedCollection
        do: [:key|
            color := systemColors at: key.
            (color bitAnd: 16r01000000) = 0
            ifFalse: [
                color := Pen paletteToRgb: color.
                count := histogram occurrencesOf: color.
                count > 0 ifTrue: [
                   notifier cr;nextPutAll: count asString ,'->',key.
                   count timesRepeat: [histogram remove: color]
                ]
            ]
        ]
    ].
    histogram isEmpty ifFalse: [
        notifier cr;cr;nextPutAll: 'Non system colors used:'.
        histogram asSet asSortedCollection
        do: [:color|
            count := histogram occurrencesOf: color.
            count > 0 ifTrue: [
                notifier cr;nextPutAll: count asString ,'->',(self rgbString: color).
                count timesRepeat: [histogram remove: color]
            ]
        ]
    ].!   
dumpToModule
    "Private - Pack the bitmaps into the default Dynalink module"

    self testOSDictionaries.
    CursorManager execute changeFor: [
            bitmapDictionary dumpToModule
    ].!   
edit

    bitmapName notNil ifTrue: [
        (self isButton: self bitmap) ifTrue: [^self editButton].
        (self isTool: self bitmap) ifTrue: [^self editTool].
        super edit
    ].!  
editableBitmap
    "Private - Returns an editable bitmap"

    ^self editableBitmap: self bitmap!  
editableBitmap: bitmap
    "Private - Returns an editable bitmap"

    self testOSDictionaries.
    bitmap isObjectFromResource "mutate to real object..."
    ifTrue: [ bitmap become: bitmap yourself ].
    ^bitmap! 
editBitmap

   self editableBitmap isNil ifTrue: [^self].
   ^super edit!  
editButton

    self editableBitmap isNil ifTrue: [^self].
    ^super editButton!  
editMenu
    "Private - Returns the bitmap edit menu"

    ^Menu new
        owner: self;
        appendItem: '&Bitmap...	Ctrl+E' selector: #editBitmap accelKey: $e accelBits: AfControl | AfChar;
        appendItem: 'B&utton...	Ctrl+B' selector: #editButton accelKey: $b accelBits: AfControl | AfChar;
        appendItem: '&Tool...	Ctrl+T' selector: #editTool accelKey: $t accelBits: AfControl | AfChar;
        title: 'Edit &As..'!  
editTool

    self editableBitmap isNil ifTrue: [^self].
    bitmapName notNil & (Smalltalk includesKey: #OSToolEditor) ifTrue: [
        (Smalltalk at: #OSToolEditor) new openOn: self editableBitmap.
    ]!  
getMenu
    "Private - Returns the file menu "

    | menu tab |
    tab := String with: Tab.
    menu := Menu new.
    menu
        title: '&File';
        owner: nil;
        appendItem: '&New Workspace',tab,'Alt+N' selector: #openWorkspace accelKey: $n accelBits: AfAlt | AfChar ;
        appendItem: '&Open...',tab,'Alt+O' selector: #openFile accelKey: $o accelBits: AfAlt | AfChar.

    Smalltalk isRunTime ifFalse: [
      menu
        appendItem: '&Install...',tab,'Alt+I' selector: #install accelKey: $i accelBits: AfAlt | AfChar;
        appendSeparator;
        appendItem: '&Browse Classes',tab,'Alt+B' selector: #openClassBrowser accelKey: $b accelBits: AfAlt | AfChar;
        appendItem: 'Browse Chun&ks',tab,'Alt+K' selector: #openChunkBrowser accelKey: $k accelBits: AfAlt | AfChar;
        appendSeparator;
        appendItem: 'C&lean Up' selector: #cleanUp;
        appendItem: 'Save Image...' selector: #saveImage
        yourself.
    ].

    menu
        appendSeparator ;
        appendItem: 'E&xit',tab,'Alt+X' selector: #close accelKey: $x accelBits: AfAlt | AfChar ;
        appendItem: 'R&un...',tab,'Alt+U' selector: #runProgram accelKey: $u accelBits: AfAlt | AfChar.

    ^menu!  
graphContents: aPane

    "Now its functionality ihas been replaced by displayContents:..."
      #obsolete.!  
graphMenu: aPane
    "Private - Setup the graph menu"

    aPane setMenu: (
            myEdit := Menu new
                title: '&Edit';
                owner: self;
                appendSubMenu: self copyMenu;
                appendItem: '&Paste From Clipboard...	Ctrl+V' selector: #fromClipboard accelKey: $v accelBits: AfChar | AfControl;
                appendItem: 'De&lete	Del' selector: #delete;
                appendSeparator;
                appendItem: '&Edit' selector: #edit;
                appendItem: 'Re&size' selector: #resize;
                appendSubMenu: self editMenu;
                appendSubMenu: self resizeMenu;
                appendSeparator;
                appendItem: 'D&uplicate' selector: #duplicate;
                appendItem: '&Rename...' selector: #rename;
                yourself
        ).
        self onSystem ifTrue: [
            myEdit
                appendSeparator;
                appendItem: 'Copy to Default Dictionary' selector: #copyToDefault
        ].

    myEdit
        accelKey: DeleteKey accelBits: AfVirtualkey  for: #delete! 
histogram
    "Private - Count all the colors used..."
    | histogram notifier systemColors color count |
    histogram := Bag new.
    self
        do: [ :aName :aBitmap |
          histogram addAll: (self colorsOf: aBitmap) ]
        to: bitmapDictionary
        saying: 'Building histogram '
        atEnd: [ self dumpHistogram: histogram title: 'Histogram' ]! 
initialize
    "Private - Initialize the receiver"
    | mth change current stream from to |
    super initialize.
    mth := self class class compiledMethodAt: #literalsToReplace.
    mth isNil ifTrue: [Terminal bell.^self].
    mth first == mth last ifTrue: [^self].
    stream := ReadStream on: mth.
    change := [:aClass|
        aClass selectors do: [:selector|
            current := aClass compiledMethodAt: selector.
            (current includes: from)
            ifTrue: [
                1 to: current size do: [:index|
                    (current at: index) == from
                    ifTrue: [
                        current at: index put: to
                    ]
                ]
            ]
        ]
    ].

    [stream atEnd] whileFalse: [
      from := stream next.
      to := stream next.
      change
          value: self class superclass;
          value: self class superclass class;
          value: self class;
          value: self class class;
          yourself
    ]!
isButton: aBitmap
    "Private - True if aBitmap is a button "

    ^25 * 2 @ 22 = aBitmap extent
        or: [ 28 * 2 @ 28 = aBitmap extent ]!   
isTool: aBitmap
    "Private - True if aBitmap is a tool "

    ^25 * 3 @ 22 = aBitmap extent
        or: [ 28 * 3 @ 28 = aBitmap extent ]!   
listMenu: aPane
    "Private - Setup the list menu"

    aPane setMenu: (
            Menu new
                title: 'Bitm&ap';
                owner: self;
                appendSubMenu: self createMenu;
                appendSubMenu: self captureMenu;
                appendSubMenu: self storeMenu;
                appendSeparator;
                appendSubMenu: self conversionsMenu;
                appendSubMenu: self specialMenu;
                appendSubMenu: self testMenu;
                appendSeparator;
                appendItem: 'D&uplicate' selector: #duplicate;
                appendItem: '&Rename...' selector: #rename;
                yourself
        )!  
loadBmps

    self testOSDictionaries.
    CursorManager execute changeFor: [
            bitmapDictionary loadFromBmps
    ].
    self
        changed: #listContents:;
        changed: #graphContents:.!   
onSystem
    "Private - Returns true if during editing system bitmaps..."

     ^bitmapDictionary == CPBitmapDict systemBitmapDictionary!  
open

    | system |

    bitmapDictionary isNil ifTrue: [
        self bitmapDictionary: ((system := Notifier isAltDown)
            ifTrue: [ CPBitmapDict systemBitmapDictionary ]
            ifFalse: [ CPBitmapDict defaultBitmapDictionary ])
    ].

    self
            owner: self;
            labelWithoutPrefix:  (system
                ifTrue: ['OS System Bitmap Manager']
                ifFalse: ['OS Bitmap Manager']);
            when: #activate perform: #updateKeys:;
            addSubpane: (
                (graphPane := OSImagePane new)
                    owner: self;
                    framingRatio: ((Rectangle leftTopUnit rightAndDown: (1/3 @ 0))
                        extentFromLeftTop: 2/3 @ 1);
                    font: (Font face: 'Arial' size: 7@0 fixedWidth: true);
                    style: GraphPane noScrollBarsFrameStyle;
                    when: #display perform: #displayContents:;
                    when: #button1DoubleClick perform: #edit:;
                    when: #getMenu perform: #graphMenu:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                list := ListBox new
                    owner: self;
                    framingRatio:
                        (Rectangle leftTopUnit
                            extentFromLeftTop: 1/3 @ 1);
                    when: #getContents perform: #listContents:;
                    when: #select perform: #bitmapSelected:;
                    when: #doubleClickSelect perform: #edit:;
                    when: #getMenu perform: #listMenu:;
                    yourself
            ).

    self icon: self class screenIcon.
    self mainView backColor: ClrPalegray.

    self openWindow.

    bitmapName notNil ifTrue: [
        list
            selection: bitmapName;
            setFocus;
            yourself
    ].!  
resize
    "Private - Resize the current bitmap"
    | current |
    current := self bitmap.
    (self isButton: current) ifTrue: [^self resizeButton].
    (self isTool: current) ifTrue: [^self resizeTool].
    ^self resizeBitmap!  
resizeBitmap
    "Private - Resize the current bitmap"
    | bitmap newSize current |
    current := self bitmap.
    newSize := Prompter prompt: 'Enter new bitmap size:' default: current extent asString.
    newSize isNil ifTrue: [ ^nil ].
    newSize := ((newSize upTo: $@) trimBlanks asInteger) @
        ((newSize reversed upTo: $@) reversed trimBlanks asInteger).
    bitmap := Bitmap screenWidth: newSize x height: newSize y.
    bitmap pen
        copyBitmap: current
        from: current boundingBox
        to: bitmap boundingBox.
    bitmapDictionary at: bitmapName put:bitmap.
    self changed: #graphContents:.!
resizeMenu
    "Private - Returns the bitmap resize menu"

    ^Menu new
        owner: self;
        appendItem: '&Bitmap...' selector: #resizeBitmap;
        appendItem: 'B&utton...' selector: #resizeButton;
        appendItem: '&Tool...' selector: #resizeTool;
        title: 'Resi&ze As..'!
resizeTool

    | extent current tool changeList newSize source dest |

    tool := self bitmap.
    Notifier isAltDown ifTrue: [
        extent := tool extent.
        changeList := bitmapDictionary select: [ :bitmap |
            bitmap extent = extent ].
    ] ifFalse: [
        changeList := bitmapDictionary select: [ :bitmap |
            bitmap == tool ].
    ].
    extent := tool width // 3 @ tool height.
    newSize := Prompter prompt: 'Enter new tool size:' default: extent asString.
    newSize isNil ifTrue: [ ^nil ].

    newSize := ((newSize upTo: $@) trimBlanks asInteger) @
        ((newSize reversed upTo: $@) reversed trimBlanks asInteger).

    changeList keysDo: [ :name |
        current := changeList at: name.
        tool := OSTool buttonWidth: newSize x height: newSize y planes: 3.
        source := 1@1 extent: current width // 3 @ current height - 1.
        source := source insetBy: 1.
        dest := 1@1 extent: tool width // 3 @ tool height - 1.
        dest := dest insetBy: 1.
        tool pen copyBitmap: current from: source to: dest.
        source moveBy: current width // 3 @ 0 + 1.
        dest moveBy: tool width // 3 @ 0 + 1.
        tool pen copyBitmap: current from: source to: dest.
        source moveBy: current width // 3 @ -1.
        dest moveBy: tool width // 3 @ -1.
        tool pen copyBitmap: current from: source to: dest.
        bitmapDictionary at: name put: tool.
    ].
    self changed: #graphContents:.!
rgb: aValue
    "Private - Returns an array with RGB values"
    | red green blue |
    red := aValue \\ 16r100.
    green := aValue // 16r100 \\ 16r100.
    blue := aValue // 16r10000 \\ 16r100.
    ^Array with: red with: green with: blue!
rgbString: aValue
    "Private - Returns a string with RGB representation"

    | rgb red green blue percentR percentG percentB stream index nearest rgbPalette |
    rgb := self rgb: aValue.
    red := rgb first.
    green := rgb at: 2.
    blue := rgb last.

    percentR := red + 1 * 100 // 256.
    percentG := green + 1 * 100 // 256.
    percentB := blue + 1 * 100 // 256.

    index := Pen rgbToPalette: aValue.
    nearest := ColorConstants keyAtValue: index ifAbsent: [].

    stream := WriteStream on: String new.
    stream
        nextPutAll: ' RGB(',red asString;
        space;nextPutAll: green asString;
        space;nextPutAll: blue asString, ') ';
        nextPutAll: percentR asString,'% ';
        nextPutAll: percentG asString,'% ';
        nextPutAll: percentB asString,'% ';
        yourself.

    nearest isNil
    ifFalse: [
        rgbPalette := self rgb: (Pen paletteToRgb: index).
        stream
            nextPutAll: 'Nearest: ',nearest;
            nextPutAll: ' RGB ',rgbPalette asString
    ].

    ^stream contents!
save: aDictionary as: title
    "Private - Perform saving of aDictionary"
    | file s dict keys |

    Notifier isAltDown ifTrue: [
        keys := (Smalltalk at: #WBMultiListChooser ifAbsent: [ ^nil ])
            fromList: aDictionary keys asSortedCollection
            prompt: 'Select ',title,' to store:'.
        (keys isNil or: [ keys isEmpty ]) ifTrue: [ ^nil ].
        dict := aDictionary associationsSelect: [ :asoc | keys includes: asoc key ].
    ] ifFalse: [ dict := bitmapDictionary ].

    file := self getFile: 'Save ',title,' To:' fileSpec: title,'.bdt' type: #library.

    file notNil ifTrue: [
        CursorManager execute
        changeFor: [ dict saveOn: file ]
    ].!   
saveAsBmps

    self testOSDictionaries.
    CursorManager execute changeFor: [
            bitmapDictionary saveAsBmps
    ].!  
saveAsResources

    self testOSDictionaries.
    CursorManager execute changeFor: [
            bitmapDictionary saveAsResources
    ].!
saveButtons
    "Private - Perform saving of buttons"
    | dict |
   dict := bitmapDictionary associationsSelect: [ :asoc | self isButton: asoc value ].
   self save: dict as: 'Buttons'!   
saveTools
    "Private - Perform saving of tools"
    | dict |
   dict := bitmapDictionary associationsSelect: [ :asoc | self isTool: asoc value ].
   self save: dict as: 'Tools'!   
specialMenu
    "Private - Returns the bitmap special menu"

    ^Menu new
        owner: self;
        appendItem: '&Paint with Palette colors' selector: #convertToSystemColors;
        appendItem: 'Count colors...' selector: #countColors;
        appendSeparator;
        appendItem: '&Count Bitmaps' selector: #countBitmaps;
        appendItem: 'C&ount Buttons' selector: #countButtons;
        appendItem: 'Co&unt Tools' selector: #countTools;
        appendSeparator;
        appendItem: '&Buttons to Tools...' selector: #buttonsToTools;
        appendItem: '&Tools to Buttons...' selector: #toolsToButtons;
        appendSeparator;
        appendItem: 'Dump to Module ',OSBitmapDict libraryName,'	Ctrl+K' selector: #dumpToModule accelKey: $k accelBits: AfControl | AfChar;
        title: 'S&pecial...'!  
storeMenu
    "Private - Returns the list store menu"

    ^Menu new
        owner: self;
        appendItem: 'Get From &File...' selector: #fromFile;
        appendItem: 'Save To B&MP File...' selector: #saveToFile;
        appendSeparator;
        appendItem: '&Open Bitmap File...	Ctrl+O' selector: #load accelKey: $o accelBits: AfControl | AfChar;
        appendItem: '&ReLoad from BMPs dump' selector: #loadBmps;
        appendSeparator;
        appendItem: 'Dump to BMPs' selector: #saveAsBmps;
        appendItem: 'Dum&p to Resource file' selector: #saveAsResources;
        appendItem: 'Build Module [',OSBitmapDict libraryName,']	Ctrl+K' selector: #dumpToModule accelKey: $k accelBits: AfControl | AfChar;
        appendSeparator;
        appendItem: 'Save &All...	Ctrl+S' selector: #save accelKey: $s accelBits: AfControl | AfChar;
        appendItem: 'Save B&uttons...' selector: #saveButtons;
        appendItem: 'Save &Tools...' selector: #saveTools;
        title: '&Store'!
testAll
    "Private - Perform all testings in order..."

    self testSelectors do: [:test|
        (self respondsTo: test)
        ifTrue: [ self perform: test ]
    ]!  
testBorders
    "Private - Test the buttons and tools borders."

    (MessageBox confirm: 'Sure you want to redraw buttons & tools borders ?')
    ifFalse: [^self].

    self do: [ :aName :aBitmap |
          self drawBorder: aBitmap
        ] to: bitmapDictionary saying: 'Drawing border '
        atEnd: [ self changed: #graphContents: ]! 
testMenu
    "Private - Returns the bitmap test menu"

    ^Menu new
        owner: self;
        appendItem: '&Borders...	Ctrl+1' selector: #testBorders accelKey: $1 accelBits: AfControl | AfChar;
        appendItem: '&Histogram...	Ctrl+2' selector: #histogram accelKey: $2 accelBits: AfControl | AfChar;
        "
        appendItem: '&Colors...	Ctrl+3' selector: #testColors accelKey: $3 accelBits: AfControl | AfChar;
        "
        appendSeparator;
        appendItem: '&All...	Ctrl+L' selector: #testAll accelKey: $l accelBits: AfControl | AfChar;
        title: '&Test...'!   
testOSDictionaries
    "Private - Check OSBitmapDict functioning properly"

    (bitmapDictionary isKindOf: OSBitmapDict)
    ifFalse: [ OSBitmapDict initialize ].!  
testSelectors
    "Private - Returns the selectors for testing bitmaps.
    Some can be unimplemented yet..."

    ^#(
        testBorders
        testColors
        histogram
    )!
toolFromScreen

    | bitmap tool box |
    bitmap := Bitmap fromUser.
    bitmap isNil ifTrue: [^self].
    tool := OSCreateTool new open result.
    tool isNil ifTrue: [^self].
    box := 0@0 extent: tool width // 3 @ tool height - 1.
    box := box insetBy: 2.
    box extent > bitmap extent
    ifTrue: [
        box := box origin + (box extent - bitmap extent // 2) extent: bitmap extent.
    ].
    tool pen
        copyBitmap: bitmap
        from: bitmap boundingBox
        to: box
        rule: Srccopy.
    box moveBy: tool width // 3 @ 0 + 2.
    tool pen
        copyBitmap: bitmap
        from: bitmap boundingBox
        to: box
        rule: Srccopy.
    box moveBy: tool width // 3 @ 0.
    tool pen
        copyBitmap: bitmap
        from: bitmap boundingBox
        to: box
        rule: Srccopy.
    OSTool
        gray: tool
        into: (tool width * 2 // 3 @ 0 extent: tool width // 3 @ tool height - 1).

    self addBitmap: tool!  
toolsToButtons
    "Converts all the tools to buttons."

    (MessageBox confirm: 'Sure you want to convert all tools to buttons ?')
    ifFalse: [^self].

    self do: [ :aName :aBitmap |
        (self isTool: aBitmap)
        ifTrue: [ bitmapDictionary at: aName put: (self toolToButton: aBitmap) ]
    ] to: bitmapDictionary saying: 'Tools to Buttons '
      atEnd: [ self changed: #graphContents: ]! 
toolToButton
    "Converts the currently selected tool to a button."
    | tool |
    bitmapName isNil ifTrue: [^nil].
    tool := self bitmap.
    (self isTool: tool) ifFalse: [^self].
    bitmapDictionary at: bitmapName put: (self toolToButton: tool).
    self changed: #graphContents:!   
toolToButton: aBitmap
    "Converts aToolBitmap to a button."
    | button tool extent |
    tool := aBitmap.
    extent := tool width // 3 * 2 @ tool height.
    button := Bitmap screenExtent: extent.
    button pen
        copyBitmap: tool
        from: (0@0 extent: extent)
        to: (0@0 extent: extent).
    ^button! 
topPaneClass
    "Answer the class which is used as top pane.
     Patched by Ale to Support dynamic MDI as implemented by OSI"

    (Smalltalk includesKey: #TopPaneClass)
    ifTrue: [ ^Smalltalk at: #TopPaneClass ].

    ^TopAppPane! !

! Debugger methods !  
resume: aPane
    self resume! !

! DoubleByteStringInspector methods !
setInstList
        "Private - Initialize an OrderedCollection of
         instance variable names and/or numbers for
         the list pane."
    instList := OrderedCollection new: (self size + 1).
    instList add: 'self'.
    1 to: object size do: [ :index |
        instList add: index printString]! !

! MDIViewManager methods !
activeTextPane
        "Answer the active textPane of the active MDI document."
    |activeTextPane|
    activeTextPane:=self frame mdiGetActive.
    activeTextPane isNil ifTrue:[^nil].
    activeTextPane:=activeTextPane activeTextPane.
    ^activeTextPane!   
close
        "Close all the views."
    views do: [:v | v isMDIChild ifFalse: [v closeView]]!  
frame
        "Answer the receiver's frame."
    ^mdiFrame! 
frame:aTopPane
        "Set the receiver's frame and answer aTopPane."

    mdiFrame:=aTopPane.
    ^aTopPane!
mdiArrange
        "Arrange the MDI documents."
    self frame mdiArrange!  
mdiCascade
        "Cascade the MDI documents."
    self frame mdiCascade!  
mdiCloseAll
        "Close all MDI documents which are not minimized."

    self frame mdiCloseAll.!   
mdiNewWindow
        "Create a new TextWindow MDI document
        from the active TextPane."

    self frame activeTextPane notNil ifTrue:[
        TextWindow new frame:self frame;  label: 'Workspace';
        openOn:self frame activeTextPane contents].! 
mdiTile
        "Tile the MDI documents."

    self frame mdiTile! !

! MDISystem class methods !
activate
        "Switch to MDI mode."

    Mdiactive:=true.
    Transcript notNil ifTrue:[
        TranscriptText := Transcript mainView activeTextPane contents].
    Notifier reinitialize.
    Mdidisplay:=true.!  
addExtraTool: aTool
        "Add aTool to the ExtraTools class variable.
         At MDI activation the tools in this class array are added
         to the MDISystem toolPane. "

    ExtraTools isNil ifTrue:[ ExtraTools := Array new].
    ExtraTools := ExtraTools asOrderedCollection.
    (ExtraTools includes: aTool) ifFalse:[
        ExtraTools add: aTool].
    ExtraTools := ExtraTools asArray.!   
deactivate
        "Switch to non MDI mode."

    Mdiactive:=false.
    Mdidisplay:=true.
    Transcript notNil ifTrue:[
        TranscriptText := Transcript mainView activeTextPane contents].
    Notifier reinitialize.!   
display
        "Private - display message up on the switch between MDI mode
        and non MDI mode."
    Mdidisplay ifFalse:[^self].
    Transcript notNil ifTrue:[
        Transcript mainView activeTextPane contents: TranscriptText].
    MDISystem display:false.
    ^Mdidisplay! 
display:aBoolean
        "Private - set the receiver's Mdidisplay to aBoolean."
    Mdidisplay:=aBoolean!   
frame
        "Private - answer the MDI Frame Transcript Window."
    ^MdiFrame!
isActive
        "Private - Answer true if the MDI mode is active, else answer false."
    ^Mdiactive!  
mdiMenu
        "Private - Answer the standard MDI Window menu."
    ^MDIMenu new
        appendItem: '&New Window' selector:#mdiNewWindow accelKey:$n accelBits:AfControl;
        appendItem: '&Cascade	Shift+F5' selector: #mdiCascade accelKey: VkF5 accelBits: AfVirtualkey|AfShift ;
        appendItem: '&Tile	Shift+F4' selector: #mdiTile accelKey: VkF4 accelBits: AfVirtualkey|AfShift ;
        appendItem: 'Arrange &Icons' selector: #mdiArrange;
        appendItem: 'Close &All' selector: #mdiCloseAll;
        title: '&Window'.!   
mdiSelected
        "Private - answer true if an MDI document is already active, else answer false."
    ^MdiSelected!  
mdiSelected:aBoolean
        "Private - set the receiver's MdiSelected to a boolean."
    MdiSelected:=aBoolean!
optionMenu
        "Private - Answer the receiver's option menu."
    ^Menu new
        appendItem: '&StatusPane' selector:#toggleStatusPane;
        appendItem: '&ToolPane' selector:#toggleToolPane;
        appendItem: 'Quit &MDI	Alt+M' selector:(Message new receiver: MDISystem;
                    selector: #deactivate) accelKey: $m accelBits: AfAlt | AfChar;
        title: self optionTitle.!  
optionTitle
        "Private - Answer the option menu title.
        If you modify this method, change the reference
        in HelpMDISystem."

    ^'Se&ttings'!   
removeAllExtraTools
        "Reinitialize the ExtraTools class variable."

    ExtraTools := nil!  
removeExtraTool: aTool
        "Remove aTool from the ExtraTools class variable.
         At MDI activation the tools in this class array are added
         to the MDISystem toolPane."

    ExtraTools isNil ifTrue:[ ^ self].
    ExtraTools := ExtraTools asOrderedCollection.
    ExtraTools remove: aTool ifAbsent:[].
    ExtraTools := ExtraTools asArray.
    ExtraTools isEmpty ifTrue:[ ExtraTools := nil].!  
statusPaneHelp:aKey
        "Private - Answer the  hint text used by
        the StatusPane for the help support."

    ^HelpMDISystem at:aKey ifAbsent:[^super statusPaneHelp:aKey].!
system
        "Private - Initialize MDISystem class variables."

    Mdiactive:=false.
    Mdidisplay:=false.
    MdiSelected:=false.!  
version
        "Answer the MDI version number as a string."
    ^'1.0'! !

! MDISystem methods ! 
changeSysMenu: aPane
        "Private - Change the system menu."

    "The following code changes the Close item in the
      sysmenu to say Exit Smalltalk/V..."

    self mainView modifySysMenu:'Exit Smalltalk/V...    Alt+F4' position:8.
    Time startTimer: 99 period: 1000 forWindow: self mainView.
    self  toggleKey:self mainView.! 
childActivate:aPane
        "Private - An MDI document has been activated.
        Update the StatusPane."

    |text|
    self frame isNil ifTrue:[^self].
    text:=self frame mdiGetActive statusText.
    text isNil
        ifTrue:[(self statusPane statusBoxAt: #status) contents: self frame mdiGetActive label]
        ifFalse:[(self statusPane statusBoxAt: #status) contents: text]!
close
        "Private - Close the receiver."

    MdiFrame := nil.
    ^super close! 
close: aPane
        "Private - Close the receiver."
    | answer|
    Transcript notNil ifTrue: [
        Transcript close:aPane.
        ^self]
    ifFalse: [self exitClose:aPane.self close].!  
compressChanges
    "Private - Perform changes compression.
    Implemented by Ale..."

    #addedByOStyle.
    Smalltalk compressChanges!   
copySelection
        "Private - The user has clicked the copy tool."
    |activeTextPane|
    activeTextPane:=self activeTextPane.
    activeTextPane isNil ifTrue:[^self].
    activeTextPane copySelection!   
cutSelection
        "Private - The user has clicked the cut tool"
    |activeTextPane|
    activeTextPane:=self activeTextPane.
    activeTextPane isNil ifTrue:[^self].
    activeTextPane cutSelection!   
doIt
        "Private - The user has clicked the doIt tool."
    |activeTextPane|
    activeTextPane:=self activeTextPane.
    activeTextPane isNil ifTrue:[^self].
    activeTextPane doIt! 
exitClose: aPane
        "Private - Stop the timer."

    Time stopTimer: 99 forWindow: aPane.!
fileItIn
        "Private - The user has clicked the fileItIn tool."

    |activeTextPane|
    activeTextPane:=self activeTextPane.
    activeTextPane isNil ifTrue:[^self].
    activeTextPane fileItIn!   
frame
        "Answer the MDISystem frame."

    ^MdiFrame!
globalReferences
        "Private - Prompt the user to enter a string
        Find the global references to that symbol."

    |referenced|

    self activeTextPane notNil ifTrue:[
        referenced:=self activeTextPane selectedItem].

    referenced:=Prompter promptWithBlanks:'Find Global References' default:referenced.
    referenced isNil ifTrue:[^self].
    referenced size = 0 ifTrue:[^self].
    Smalltalk sendersOf:(Smalltalk associationAt:referenced asSymbol).!  
inspectIt
        "Private - The user has clicked the inspectIt tool."
    |activeTextPane|
    activeTextPane:=self activeTextPane.
    activeTextPane isNil ifTrue:[^self].
    activeTextPane inspectIt!  
mdiMenu:anMDIFrame
        "Private - Create the MDI menus."

    anMDIFrame mdiMenuWindow addMenu:self class optionMenu owner:self.
    anMDIFrame mdiMenuWindow addMenu:self class mdiMenu owner:self.! 
open
        "Private - Create the MDISystem frame window."

    MDISystem isActive ifFalse:[
        self error:'The MDI Mode is not activated'].
    MDISystem frame notNil ifTrue:[
        self error:'You are already in the MDI mode'].

    CursorManager execute change.
    self
        addView: (MdiFrame:=
            MDIFrame new
                owner: self;
                when: #close perform: #close:;
                when: #validated perform: #changeSysMenu:;
                when: #timer perform:#timer:;
                when: #toggleKey perform:#toggleKey:;
                when: #mdiMenuBuilt perform: #mdiMenu:;
                when: #childActivate perform:#childActivate:;
                icon: (Icon fromModule: Icon defaultDLLFileName id:'Transcript');
                labelWithoutPrefix: WindowLabelPrefix;
                framingBlock: [:box | box scaleBy: 1/2]).
    self
        addSubpane:(
            StatusPane new
                owner:self;
                when:#getContents perform: #statusPane:).

    self
        addSubpane:(
            ToolPane new
                owner:self;
                when:#getContents perform:#toolPane:).
    self openIn: ((1 @ 2 corner: 90 @ 27)
            scaleBy: (SysFont width @ SysFontHeight)).

    self toggleMenu: self class optionTitle item:#toggleToolPane.
    self toggleMenu: self class optionTitle item:#toggleStatusPane.
    MDITranscript new open.!  
pasteSelection
        "Private - The user has clicked the paste tool."
    |activeTextPane|
    activeTextPane:=self activeTextPane.
    activeTextPane isNil ifTrue:[^self].
    activeTextPane pasteSelection!
printIt
        "Private - The user has clicked the printIt tool."
    |activeTextPane|
    activeTextPane:=self activeTextPane.
    activeTextPane isNil ifTrue:[^self].
    activeTextPane printIt!
resourceDLLFile
        "Private - Answer the DLL filename for resources."
    ^Icon defaultDLLFileName!
statusPane:aStatusPane
        "Private - Set the StatusPane contents."
    | statusBoxes |
    statusBoxes := OrderedCollection new
                                    add: ( StatusBox new
                                        space: aStatusPane font width;
                                        name: #status);
                                    add: ( StatusBox new
                                        space: aStatusPane font width;
                                        width: (aStatusPane font stringWidth: Time now printString);
                                        name: #time);
                                    add: ( StatusBox new
                                        space: aStatusPane font width;
                                        width: (aStatusPane font stringWidth: 'CAPS');
                                        contents: 'CAPS';
                                        name: #caps);
                                    add: ( StatusBox new
                                        space: aStatusPane font width;
                                        width: (aStatusPane font stringWidth: 'NUM');
                                        contents: 'NUM';
                                        name: #num);
                                    add: ( StatusBox new
                                        space: aStatusPane font width;
                                        width: (aStatusPane font stringWidth: 'OVR');
                                        contents: 'OVR';
                                        name: #ovr);
                                    yourself.

    aStatusPane contents: statusBoxes.
    (self statusPane statusBoxAt: #status) contents: 'Busy'.!   
statusPaneHelp:aKey
    "Private - Answer the hint text used by
    the StatusPane for the help support."

    ^HelpMDISystem at:aKey ifAbsent:[^super statusPaneHelp:aKey].! 
timer:aTopPane
        "Private - Update the time in the StatusPane."

    (aTopPane statusPane statusBoxAt: #time) contents:Time now.!
toggleKey:aPane
        "Private - Update the StatusPane to display the state
        of the toggle keys. The normal modes, such as Insert or
        non-Caps-lock mode, are indicated in the status bar by the absence
        of the indicator for the opposite mode. This is compliant
        with the Microsoft user Interface Style Guide for Windows 3.1."


    (aPane statusPane statusBoxAt: #caps) show: (Notifier isKeyToggled: VkCapital).

    (aPane statusPane statusBoxAt: #num) show: (Notifier isKeyToggled: VkNumlock).

    (aPane statusPane statusBoxAt: #ovr) show: (Notifier isKeyToggled: VkInsert).!  
toggleMenu: menuName item: itemName
        "Private - Toggle the selected menu item."

    | theMenu aBoolean|

    theMenu := self frame menuWindow menuTitled: menuName.
    (aBoolean:=theMenu isChecked:itemName)
        ifTrue: [self frame uncheckItem:itemName forAllMDIChildMenus:menuName]
        ifFalse: [self frame checkItem:itemName forAllMDIChildMenus:menuName].

    ^aBoolean!
toggleStatusPane
        "Private - Show/Hide the StatusPane."

        self toggleMenu: self class optionTitle item:#toggleStatusPane.
        self statusPane show.
        self mdiArrange.!  
toggleToolPane
        "Private - Show/Hide the ToolPane."

        self toggleMenu: self class optionTitle item:#toggleToolPane.
        self toolPane show.
        self mdiArrange.!  
toolPane:aPane
        "Private - Set the toolPane contents."

    |aToolCollection aTool|

    aToolCollection:=OrderedCollection new.


    aTool:=Tool fromModule:self resourceDLLFile id:'create'.
    aTool selector:(Message new receiver:self mainView mainWindow; selector:#openWorkspace);space:6.
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'open'.
    aTool selector:(Message new receiver:self mainView mainWindow; selector:#openFile).
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'filein'.
    aTool selector:(Message new receiver:self mainView mainWindow; selector:#install).
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'save'.
    aTool selector:(Message new receiver:self mainView mainWindow; selector:#accept).
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'print'.
    aTool selector:(Message new receiver:self mainView mainWindow; selector:#print).
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'saveimage'.
    aTool selector:(Message new receiver:self mainView mainWindow; selector:#saveImage).
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'cut'.
    aTool selector:#cutSelection;owner:self;space:11.
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'copy'.
    aTool selector:#copySelection;owner:self.
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'paste'.
    aTool selector:#pasteSelection;owner:self.
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'showit'.
    aTool selector:#printIt;owner:self;space:11.
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'doit'.
    aTool selector:#doIt;owner:self.
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'inspectit'.
    aTool selector:#inspectIt;owner:self.
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'fileit'.
    aTool selector:#fileItIn;owner:self.
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'global'.
    aTool selector:#globalReferences;owner:self.
    aToolCollection add:aTool.

    aTool:=Tool fromModule:self resourceDLLFile id:'classhierarchybrowsertool'.
    aTool selector:
        (Message new receiver:self mainView mainWindow;selector:#openClassBrowser);
        space:11.
    aToolCollection add:aTool.

    ExtraTools notNil ifTrue:[
        ExtraTools do:[:aTool | aToolCollection add: aTool]].

    aPane contents: aToolCollection.!  
unusedMemory
    "Private - Shows unusedMemory.
    Implemented by Ale..."

    #addedByOStyle.
    MessageBox message: 'Unused Memory : ',Smalltalk unusedMemory printString! !

! OSMDIViewManager class methods !   
allObjects
    "Returns the most used objects cache"
    ^ApplicationSystem allObjects! 
atKey: aKey
    "Returns the Application Object  named aKey;
     if absent returns nil"
    ^self atKey: aKey ifAbsent: [ ]!  
atKey: aKey ifAbsent: aBlock
    "Returns the Application Object  named aKey
     if absent evaluates aBlock"
    ^self allObjects at: aKey ifAbsent: aBlock!  
atKey: aKey put: anObject
    "Places anObject as an object named aKey.
     if anObject isNil removes it "
    anObject isNil
    ifTrue: [
        self allObjects removeKey: aKey ifAbsent: [].
        ^nil
    ].
    ^self allObjects at: aKey put: anObject!   
defaultFont
    "Private - Returns the default font of the receiver"
    ^OSViewManager defaultFont!
model
    "Private - Returns the current Application model"
    ^self atKey: #model!
profiler
    "Private - Returns the profiler for the receiver.
     Or nil..."
    | profiler |
    profiler := StartUpApplication profiler.
    profiler applicationName: self name.
    ^profiler!
test
    "Test sofware rights"
    ^StartUpApplication test! !

! OSMDIViewManager methods !  
asterisk
    "Private - Produces an asterisk sound"

    self play:  'SystemAsterisk'! 
beep
    "Private - Produces a Beep"

    UserLibrary messageBeep: 0!  
childActivate:aPane
        "Private - Update the StatusPane. Shows
        the label of the active MDI document"
    |mdiActive|
    (mdiActive := self frame mdiGetActive) notNil ifTrue:[
        (self statusPane statusBoxAt: #status) contents: mdiActive label].! 
childClose:aPane
        "Private - Update the StatusPane.
        If there is no more document, erase the StatusBox #status"

    self frame mdiGetActive isNil ifTrue: [
        (self statusPane statusBoxAt: #status) contents: ''].!
defaultFont
    "Private - Returns the default font of the receiver"
    ^self class defaultFont!   
helpOn: aPane
    "Private - Attends general helps"

    | hm |
    hm := self mainView helpManager.
    hm isNil ifFalse: [ hm displayHelpKey: nil ].!  
mdiActive
    "Private - Returns the active MDI document or nil"

    ^self frame mdiGetActive!
mdiTileHoriz
    "Tile the receiver's windows horizontally"
    | openWindows iconizedWindows
     rect statusHeight toolHeight winRect |
    openWindows := OrderedCollection new.
    iconizedWindows := OrderedCollection new.
    self frame mdiChildren do: [:child|
        child minimized
        ifTrue: [ iconizedWindows add: child ]
        ifFalse: [ openWindows add: child ]
    ].
    statusHeight := self statusPane visible
        ifTrue:[ self statusPane rectangle height ]
        ifFalse: [0].
    toolHeight := self toolPane visible
        ifTrue:[ self toolPane rectangle height]
        ifFalse: [0].
    rect := self frame rectangle.
    rect := rect leftTop extent: rect extent
        - (0@(statusHeight + toolHeight)).
    rect := rect leftTop extent: rect extent
            - (0@(iconizedWindows isEmpty
                ifTrue: [0] ifFalse: [Icon iconSize y + SysFont height])).

    0 to: openWindows size - 1 do: [:i|
        winRect := rect left @ (rect top + (rect height * i // openWindows size))
            rightBottom: rect right @ (rect top + (rect height * (i + 1) // openWindows size)).
        (openWindows at: i + 1) moveWindowTo: winRect
    ].! 
mdiUpdate
    "Update currently selected window"

    |mdiActive|
    (mdiActive := self frame mdiGetActive) notNil
    ifTrue:[ mdiActive invalidateRect: nil"updateWindow" ].! 
model
    "Private - Returns the current Application model"

    ^self class model!
openWindow
    "Private - Set the icon of the receiver and open the window"

    "Test the user protection
    self class test. "

    self mainView
        icon: self icon;
        when: #help perform: #helpOn:.

    super openWindow.
    StartUpApplication setUpHelpManagerFor: self .!
play: aSoundName
    "Private - Produces the sound named aSoundName.
     aSoundName can be a fileName
        or the name of an Win.Ini [Sounds] entry "

    MMSystemDLL library
        sndPlaySound:  aSoundName asParameter
        flags: 0! 
profiler
    "Private - Returns the profiler for the receiver.
     Or nil..."
    ^self class profiler!   
warning: aLabel
    "Log the message aLabel and alert the user..."

    ^StartUpApplication warning: aLabel! !

! MDICDGuia class methods !  
canUnderstand: aSelector
    "True if the receiver can understand aSelector or
     the class of the current model can understand it... "
    ^(super canUnderstand: aSelector)
        or: [ self model class canUnderstand: aSelector ]!
fileMenu
    "Private - Answer the receiver's fileMenu"
    | tab menu |
    tab := String with: Tab.
    menu := Menu new.
    menu
        title: '&Archivo';
        appendItem: '&Abrir...' selector: #fileOpen;
        appendSeparator.
    (self model respondsTo: #filePageSetup)
    ifTrue: [ menu appendItem: '&Pgina...' selector: #filePageSetup ].
    menu
        appendItem: 'Ver &Hoja....' selector: #filePrintPreview;
        appendItem: '&Imprimir Ahora' selector: #filePrint;
        appendItem: '&Configurar Impresora' selector: #printerSetup;
        appendSeparator;
        appendItem: 'Ejec&utar...',tab,'Alt+U' selector: #fileRun acceleratorString: 'Alt+U';
        appendSeparator;
        appendItem: '&Salir',tab,'Alt+X' selector: #fileExit acceleratorString: 'Alt+X';
        yourself.
    ^menu!
helpFileName
    "Private - Returns the receiver's help file path name"

    ^'CD-Guia.Hlp'!   
helpMapDictionary
    "Private - Returns the receiver's help mappings"
    | mapPathName |
    mapPathName := (self helpFileName upTo: $.) ,'.h'.
    (File exists: mapPathName)
    ifTrue: [ ^StringDictionaryReader createIdDictionary: mapPathName].
    ^Dictionary new!   
mdiMenu
    "Private - Answer the standard MDI Window menu "
    | tab |
    tab := String with: Tab.
    ^MDIMenu new
        appendItem: '&Nueva ventana' selector: #mdiNewWindow accelKey:$n accelBits:AfControl;
        appendSeparator;
        appendItem: '&Cascada',tab,'Shift+F5' selector: #mdiCascade accelKey: VkF5 accelBits: AfVirtualkey|AfShift ;
        appendItem: 'Mosaico &Horizontal' selector: #mdiTileHoriz;
        appendItem: 'Mosaico &Vertical',tab,'Shift+F4' selector: #mdiTile accelKey: VkF4 accelBits: AfVirtualkey|AfShift ;
        appendItem: '&Alinear Iconos'  selector: #mdiArrange;
        appendItem: 'Ac&tualizar' selector: #mdiUpdate acceleratorString: '';
        appendSeparator;
        appendItem: 'Cerrar &Todas' selector: #mdiCloseAll;
        title: 'V&entana'.!   
optionMenu
    "Private - Answer the option menu"
    | tab menu |
    tab := String with: Tab.
    menu := Menu new.
    menu
        appendItem: '&Grilla' selector: #toggleGrid;
        appendItem: '&Botonera' selector: #toggleToolPane;
        appendItem: '&Regla' selector: #toggleRuler;
        appendItem: '&Indicaciones' selector: #toggleStatusPane;
        yourself.
    (self model respondsTo: #viewHeader)
    ifTrue: [
        menu
            appendSeparator;
            appendItem: '&Cabecera...' selector: #viewHeader;
            appendItem: 'P&ie de pgina...' selector: #viewFooter;
            yourself
    ].
    menu
        appendSeparator;
        appendItem: '&Zoom Acercar',tab,'Ctrl+Up' selector: #viewZoomIn acceleratorString: 'Ctrl+17';
        appendItem: 'Zoom Ale&jar',tab,'Ctrl+Down' selector: #viewZoomOut acceleratorString: 'Ctrl+18';
        appendSeparator;
        appendItem: '&Pantalla Completa' selector: #toggleFullScreen;
        appendItem: '&Modo MDI' selector: #toggleMDI;
        title: '&Ver';
        yourself.
    ^menu! 
preferencesMenu
    "Private - Answer the configuration menu"
    ^Menu new
        appendItem: '&Grilla...' selector: #gridSetup;
        appendItem: '&Regla...' selector: #rulerSetup;
        appendSeparator;
        appendItem: '&Impresora...' selector: #printerSetup;
        appendItem: '&Pgina...' selector: #filePageSetup;
        appendSeparator;
        appendItem: '&Herramientas...' selector: #configureToolBar;
        title: '&Configurar'.! !

! MDICDGuia methods !   
childActivate: anMDIDocument
    "Private - Update the StatusPane.
     Shows the label of the active MDI document.
     Update tools and menues...
    "
    super childActivate: anMDIDocument.
    self model activate: self frame mdiGetActive owner.!  
close
    "Private - Close the receiver..."

    | profiler frame stream |

    whenClose notNil ifTrue: [ whenClose value ].
    Time stopTimer: 99 forWindow: self mainView.
    profiler := self profiler.
    (profiler notNil and: [self mainView minimized not])
    ifTrue: [
        frame := self mainView frameRectangle.
        stream := WriteStream on: String new.
        stream
            space;nextPutAll: frame left asString;
            space;nextPutAll: frame top asString;
            space;nextPutAll: frame width asString;
            space;nextPutAll: frame height asString.
        profiler at: #frame put: stream contents.
    ].
    ^super close!  
close: aPane
    "Private - Close the receiver application"

    ^self close!  
configureToolBar
    "Private - Edits the receiver's toolPane"

    ^self editToolBar: self toolPane!  
doesNotUnderstand: aMessage
    "Private - Try to solve the problen using the receiver's model"

    (self model respondsTo: aMessage selector)
    ifTrue: [ "delegates response to the model..."
        ^self model
            perform: aMessage selector
            withArguments: aMessage arguments
    ].
    ^super doesNotUnderstand: aMessage!   
fillToolBar: aToolBar
    "Fill The receiver's toolBar"

    | tools inUse index profiler groups rbSelectors |
    tools := self model tools.
    profiler := self profiler.
    groups := (tools select: [:each| each isNumber]) size + 1.
    inUse := OrderedCollection new.
    1 to: groups do: [:i|
        (profiler at: 'Tools',i asString ifAbsent: [String new]) asArrayOfSubstrings
        do: [:selector| inUse add: selector asSymbol ]
    ].

    (inUse includes: #customizeToolBar)
    ifFalse: [ inUse addLast: #customizeToolBar ].
    rbSelectors := self model rbSelectorsFor: inUse.

    tools do: [:each|
        (inUse includes: each)
        ifTrue: [
            index := (tools indexOf: each) - 1.
            (index > 0 and: [(tools at: index) isNumber])
            ifTrue: [
                aToolBar
                    add: each
                    spaces: (tools at: index)
                    rbSelector: (rbSelectors at: each ifAbsent: [])
            ]
            ifFalse: [
                aToolBar
                    add: each
                    rbSelector: (rbSelectors at: each ifAbsent: [])
            ]
        ]
    ].!  
helpContextFor: contextId in: aWindow
    " Private - Returns a nul response bu try to say the text for contextId if present..."

    | result speaker text |

    result := nil. "responds with nil as default..."
    contextId isSymbol
    ifTrue: [
        speaker := self speaker.
        speaker notNil ifTrue: [
            text := self statusPaneHelp: contextId asString.
            speaker say: text
        ]
    ].

    ^result!   
initWindowSize
    "Private - Returns the window size for the main view"

    | origin profiler stream basicSize rect |
    basicSize := Display extent - (50@20).
    profiler := self profiler.
    profiler isNil ifTrue: [ ^basicSize ].

    stream := ReadStream on: (profiler at: #frame).
    stream atEnd ifTrue: [^basicSize].

    rect := (stream nextWord asInteger @ stream nextWord asInteger
        extent: stream nextWord asInteger @ stream nextWord asInteger)
        intersect: Display boundingBox.

    rect extent > (0@0) ifFalse: [^basicSize].
    ^rect!
label
    "Private - Returns the receiver's label"
    ^StartUpApplication product! 
mdiMenu:anMDIFrame
        "Private - Create the menuBar for the frame"

    anMDIFrame mdiMenuWindow
        addMenu: self class fileMenu owner:self;
        addMenu: self class optionMenu owner:self;
        addMenu: self class preferencesMenu owner:self;
        addMenu: self class mdiMenu owner:self;
        yourself!   
mdiNewWindow
    "Create a new view cloned from current view."

    self model mdiNewWindow!   
open
    "Open the receiver..."
    | hm toolPane |
    self
        addView: (self frame:(
            MDIFrame new
                owner: self;
                labelWithoutPrefix: self label;
                when: #close perform: #close:;
                when: #validated perform: #timerStart:;
                when: #timer perform:#timer:;
                when: #toggleKey perform:#toggleKey:;
                when: #mdiMenuBuilt perform: #mdiMenu:;
                when: #childActivate perform: #childActivate:;
                when: #childClose perform: #childClose:;
                " framingBlock: [:box | box insetBy: 50@20 ]; "
                yourself)).
    self
        noSmalltalkMenuBar;
            addSubpane: (
                OSToolBar new
                    owner: self;
                    "framingBlock: ( FramingParameters new iDUE: 951 @ 44; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 0 r: #top; bDU: 44 r: #top);"
                    paneName: 'ToolPane';
                    mdiToolBar;
                    startGroup;
                    backColor: ClrPalegray;
                    when: #showHelp perform: #paletteHelp:;
                    when: #mouseMove perform: #showToolLabel:;
                    when: #doubleClick perform: #editToolBar:;
                    when: #getContents perform: #fillToolBar:;
                    yourself
            );
        addSubpane:(
                StatusPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 951 @ 38; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 38 r: #bottom; bDU: 0 r: #bottom);
                    contents: (
                        OrderedCollection new
                            addLast: (
                                StatusBox new
                                    space: 7;
                                    width: 10;
                                    name: #status
                            );
                            addLast: (
                                StatusBox new
                                    space: 5;
                                    width: 45;
                                    name: #date
                            );
                            addLast: (
                                StatusBox new
                                    space: 3;
                                    width: 60;
                                    name: #time
                            );
                            addLast: (
                                StatusBox new
                                    space: 5;
                                    width: 27;
                                    name: #caps
                            );
                            addLast: (
                                StatusBox new
                                    space: 3;
                                    width: 25;
                                    name: #num
                            );
                            yourself
                    );
                    yourself
            );
            yourself.

    StartUpApplication setUpHelpManagerFor: self.

    self openWindow.! 
paletteHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := self statusPaneHelp: selector asString.
    text isNil ifTrue: [ text := String new ].
    self statusBox contents: text!  
respondsTo: aSelector
    "Private - True if the receiver or its model responds to aSelector.
    Used for redirecting interfase messages"

    ^(super respondsTo: aSelector) or: [ self model respondsTo: aSelector]!   
showToolLabel: anOSToolBar
    "Show the label corresponding to a Tool"

    | label selector index lastTime lastLabel |
    index := anOSToolBar currentIndex.
    index isNil ifTrue: [^nil].
    selector := anOSToolBar selectorAt: index.
    selector isNil ifTrue: [^nil].
    label := self statusPaneHelp: selector asString.

    lastTime := anOSToolBar propertyAt: #lastTime.
    lastTime notNil ifTrue: [
        Time millisecondClockValue - lastTime > 1000 "one second relax"
        ifTrue: [
            (anOSToolBar propertyAt: #lastLabel) = lastLabel ifTrue: [^self].
            self statusBox contents: label.
        ]
    ].
    anOSToolBar propertyAt: #lastTime put: Time millisecondClockValue.
    anOSToolBar propertyAt: #lastLabel put: label.!   
statusBox
    "Returns the status box pane..."

    ^self statusPane statusBoxAt: #status.!
statusPaneHelp:aKey
    "Private - Answer the hint text to the StatusPane"

    | dict |
    dict := Smalltalk at: #HelpStatusPane ifAbsent: [Dictionary new].
    ^dict at: aKey
    ifAbsent:[
        (dict includesKey: aKey asSymbol) ifTrue: [^dict at: aKey asSymbol].
        " Smalltalk isRunTime ifFalse: [ ^'***',aKey ]. "
        ^super statusPaneHelp:aKey
    ]!   
stickerForObjectAt: aPoint in: aPane

    | selector text |
    (aPane isKindOf: WBToolPalette)
    ifTrue: [
        selector := aPane selectorAt: aPane currentIndex.
        selector isNil ifTrue: [^nil].
        ^self statusPaneHelp: selector asString
    ].

    ^nil "no sticker..."!
testInterfase: map
    "Private - Update interfase acording to currently active mdiView"

    | stream group menu isValid mdiActive owner toolPane frame |

    mdiActive := self model viewInUse"mdiActive".
    mdiActive isNil ifTrue: [ ^nil ].
    toolPane := self toolPane.
    toolPane isNil ifTrue: [ ^nil ].
    frame := self frame.
    frame isNil ifTrue: [ ^nil ].

    isValid := [:selector|
        mdiActive notNil and: [
            owner := mdiActive owner.
            (owner respondsTo: selector)
            and: [ (owner respondsTo: #canDo:) not
               or: [ owner canDo: selector ]] "use #canDo: protocoll if appropiate"
            ]
    ].

    stream := ReadStream on: map.
    [stream atEnd] whileFalse: [
        group := stream next.
        menu := self mainView menuWindow menuTitled: group.
        stream next do: [:item|
            (isValid value: item)
            ifTrue: [
                menu notNil ifTrue: [ frame enableItem: item forAllMDIChildMenus: group ].
                toolPane enableItem: item.
            ]
            ifFalse: [
                menu notNil ifTrue: [ frame disableItem: item forAllMDIChildMenus: group ].
                toolPane disableItem: item.
            ]
        ]
    ]! 
timer: aTopPane
    "Private - Update the time in the StatusPane."

    (aTopPane statusPane statusBoxAt: #time) contents: Time now asString.
    (aTopPane statusPane statusBoxAt: #date) contents: Date today formPrint.!   
timerStart: aTopPane
    "Private - Start the timer for updating status bar."

    "Start timer for status bar"
    Time startTimer: 99 period: 1000 forWindow: self mainView.

    "Update Caps & num toggles in status"
    self toggleKey: self mainView.

    "Set menues toggles"
    self toggleView: #('StatusPane' 'ToolPane' 'MDI').!  
toggleKey:aPane
        "Private - Update the StatusPane to display the state
        of the toggle keys. The normal modes, such as Insert or
        non-Caps-lock mode, are indicated in the status bar by the absence
        of the indicator for the opposite mode. This is compliant
        with the Microsoft user Interface Style Guide for Windows 3.1."

    (aPane statusPane statusBoxAt: #caps)
        contents: ((Notifier isKeyToggled: VkCapital)
            ifTrue: ['CAPS'] ifFalse: [String new]).

    (aPane statusPane statusBoxAt: #num)
        contents: ((Notifier isKeyToggled: VkNumlock)
            ifTrue: ['NUM'] ifFalse: [String new]).!
toggleMenu: menuName item: itemName
    "Private - Toggle the selected menu item"

    | theMenu aBoolean|
    theMenu := self frame menuWindow menuTitled: menuName.
    (aBoolean := theMenu isChecked:itemName)
    ifTrue: [
        self frame uncheckItem:itemName forAllMDIChildMenus:menuName
    ]
    ifFalse: [
        self frame checkItem:itemName forAllMDIChildMenus:menuName
    ].
    ^aBoolean!   
toggleStatusPane
        "Private - Show/Hide the StatusPane."

        self toggleView: 'StatusPane'.
        self statusPane show.
        self mdiArrange.!   
toggleToolPane
    "Private - Show/Hide the ToolPane"

    self toggleView: 'ToolPane'.
    self toolPane show.
    self mdiArrange.
    self statusBox contents: String new.!  
toggleView: property
    "Private - Toggle the selected menu item named #toggle+property "

    | itemName |
    property isArray "multiple properties are allowed..."
    ifTrue: [
        ^property collect: [:each| self toggleView: each ]
    ].

    itemName := ('toggle' , property) asSymbol.
    ^self toggleMenu: '&Ver'  item: itemName!   
toolPane
    "Private - Returns the receiver's toolPane"

    ^self paneNamed: 'ToolPane'! 
whenClose: aBlock
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    whenClose := aBlock! !

! MethodBrowser methods !
draggedObjectIn: aPane
    "Private - Returns the currently dragged object.
    Implemented by Ale for drag&drop support"

    ^selectedMethod!   
fileOutAll
    "Private - FileOut all methods to an external file..."

     | dialog file |

    dialog := FileDialog new.
    dialog
        title: 'FileOut to...';
        addSmalltalkFileFilters;
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].
    CursorManager execute changeFor: [
        file := File newFile: file.
        methods do: [:each| each fileOutOn: file ].
        file close.
    ].!   
listMenu: listPane
    "Private - Set the list pane menu.
    Touched by Ale for fileOut support..."

    #modifyedByOStyle.
    listPane setMenu: ((Menu
        labels: '&Remove From List\&Senders\&Implementors\Local Senders\Local Implementors\&Messages\&FileOut All...' withCrs
        lines: (Array with: 1 with: 6)
        selectors: #(removeSelector senders implementors localSenders localImplementors messages fileOutAll))
            title: '&Methods';
            owner: self;
            yourself)!
openOn: aMethodCollection
    "Create a method browser window on aMethodCollection.
     Touched by Ale for drag&drop support"
    | ratio |
    ratio := 2 / 5.
    methods := aMethodCollection asOrderedCollection.
    self addSubpane:
        ("ListBox  Ale patch"
         OSListPane new
            owner: self;
            when: #getContents perform: #methodList: ;
            when: #getMenu perform: #listMenu: ;
            when: #select perform: #method:;
            framingRatio:
                (Rectangle leftTopUnit
                    extentFromLeftTop: (1 @ ratio))).
    self addSubpane:
        (methodPane := TextPane new
            owner: self;
            when: #getContents perform: #text: ;
            when: #save perform: #accept: ;
            framingRatio:
                ((Rectangle leftTopUnit rightAndDown:  0 @ ratio)
                    extentFromLeftTop: 1@(1 - ratio))).
    self icon: (Icon fromModule: Icon defaultDLLFileName id:'MethodBrowser').

    self openWindow;
        disableMethodsMenu! !

! OSViewManager class methods ! 
allObjects
    "Returns the most used objects cache"
    ^ApplicationSystem allObjects! 
atKey: aKey
    "Returns the Application Object  named aKey;
     if absent returns nil"
    ^self atKey: aKey ifAbsent: [ ]!  
atKey: aKey ifAbsent: aBlock
    "Returns the Application Object  named aKey
     if absent evaluates aBlock"
    ^self allObjects at: aKey ifAbsent: aBlock!  
atKey: aKey put: anObject
    "Places anObject as an object named aKey.
     if anObject isNil removes it "
    anObject isNil
    ifTrue: [
        self allObjects removeKey: aKey ifAbsent: [].
        ^nil
    ].
    ^self allObjects at: aKey put: anObject!   
defaultFont
    "Private - Returns the default font of the receiver"
    | defaultFont |
    defaultFont := self atKey: #defaultFont.
    defaultFont isNil ifFalse: [^defaultFont].
    defaultFont := Font new
        fromBytes:
            #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97
                 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 ).
    self atKey: #defaultFont put: defaultFont.
    ^defaultFont!  
mainViewTitle
    "Private - Returns the main view title (by default).
    This method can be refined by subclasses...
    Default action is to return title found in receiver's
     profiler section with key=windowTitle or nil if absent..."

    ^self profiler at: 'windowTitle'! 
open
    "Creates an instance of the receiver and opens it..."

    ^self new open!
openInstances
    "Private - Returns the currently open ViewManagers
    that are instances of the receiver... "

    | cole |
    cole := Set new.
    Notifier windows do: [:each|
        (each isApplicationWindow
            and: [ each owner isKindOf: self ])
        ifTrue: [ cole add: each owner ]
    ].
    ^cole asArray!  
profiler
    "Private - Returns the profiler for the receiver.
     Or nil..."
    | profiler |
    profiler := ApplicationSystem profiler.
    profiler applicationName: self name.
    ^profiler! 
test
    "Test sofware rights"
    ^StartUpApplication test! !

! OSViewManager methods ! 
asterisk
    "Private - Produces an asterisk sound"

    self play:  'SystemAsterisk'! 
backUpFile: pathName
    "Private - If file named pathName is present try
     to rename it with extension .Bak "

    | root stream backName |
    (File exists: pathName) ifFalse: [ ^self ].
    (pathName includes: $.)
    ifFalse: [ root := pathName ]
    ifTrue: [
        stream := ReadStream on: pathName reversed.
        (stream upTo: $.) size > 3 ifTrue: [ stream reset ].
        root := (stream upTo:nil) reversed.
    ].
    backName := root,'.Bak'.
    File
        remove: backName ifAbsent: [];
        rename: pathName to: backName;
        yourself!
beep
    "Private - Produces a Beep"

    UserLibrary messageBeep: 0!  
close
    "Close all the views.
    Reimplememnted by Ale because the views collection will
    change in size (and do: will not work) during closeView..."

    views copy do: [:v | v closeView]!  
colorButtonFace
    "Private - Returns the colorButtonFace value."

    #platformDependent.
    ^WinInfo colorButtonFace! 
colorButtonShadow
    "Private - Returns the colorButtonShadow value."

    #platformDependent.
    ^WinInfo colorButtonShadow!   
defaultFont
    "Private - Returns the default font of the receiver"
    ^self class defaultFont!   
disable: aControl
    "Private - Disable a pane or more panes.
     aControl can be :
        1.- aPane to be disabled.
        2.- aSymbol that is the pane's getContents symbol
        3.- anArray of Symbols/Panes
    "

    aControl isArray ifFalse: [^self disable: (Array with: aControl)].
    aControl do: [:each|
        self send: #disable
            to: (each isSymbol
                ifTrue: [self paneAt: each]
                ifFalse: [each])
    ]!
enable: aControl
    "Private - Enable a pane or more panes.
     aControl can be :
        1.- aPane to be enabled.
        2.- aSymbol that is the pane's getContents symbol
        3.- anArray of Symbols/Panes
    "

    aControl isArray ifFalse: [^self enable: (Array with: aControl)].
    aControl do: [:each|
        self send: #enable
            to: (each isSymbol
                ifTrue: [self paneAt: each]
                ifFalse: [each])
    ]! 
enable: aControl when: aCondition
    "Private - Enable a pane or more panes when aCondition is met.
     aCondition can be aBoolean or a non parameter block to be evaluated.
    "
    | enable |
    enable := aCondition isBoolean
        ifTrue: [aCondition]
        ifFalse: [aCondition value].
    enable
    ifTrue: [ self enable: aControl ]
    ifFalse: [ self disable: aControl ]!  
fileExit
    "Private - Implemented by Ale for commodity..."

    self close!  
fullUpdate
    "Private - Refreshes all the panes."

    views do: [:aView|
        aView children do: [:each|
            (each handlesEvent: #getContents)
            ifTrue: [each event: #getContents]
        ]
    ]!  
helpContextFor: contextId in: aWindow
    " Private - Returns a nul response bu try to say the text for contextId if present..."

    | speaker text model |
    model := self model.
    model isNil ifTrue: [^nil].

    (self class respondsTo: #helpMap)
    ifTrue: [
        speaker := self model speaker.
        speaker notNil ifTrue: [
            text := (self class helpMap
                detect: [:one| one first = contextId ]
                ifNone: [Array with: nil with: nil]) last.
            text notNil ifTrue: [ speaker say: text ].
        ]
    ].

    ^model notNil ifTrue: [ model helpContextFor: contextId in: aWindow ]!
helpOn: aPane
    "Private - Attends general helps"

    | hm |
    hm := self mainView helpManager.
    hm isNil ifFalse: [ hm displayHelpKey: nil ].!  
label: aString
    "Sets the main view label (without prefix)..."

    ^self labelWithoutPrefix: aString!  
mainViewClosed: aTopPane

    "Callback for the #close event in the TopPane 'mainView'.
     (Generated by WindowBuilder)"

    self close!  
model
    "Private - Returns the current Application model"
    ^self class atKey: #model!  
openWindow
    "Private - Set the icon of the receiver and open the window.
    Touched by Ale for sending close event when closed..."

    "Test the user protection
    self class test. "

    views do: [:aView|
      aView
        icon: self icon;
        when: #help perform: #helpOn:;
        yourself
    ].

    (self mainView handlers includesKey: #close)
    ifFalse: [
      self mainView
        when: #close perform: #mainViewClosed:;
        yourself
    ].

    self noSmalltalkMenuBar.

    super openWindow.

    (StartUpApplication respondsTo: #setUpHelpManagerFor:)
    ifTrue: [ StartUpApplication setUpHelpManagerFor: self ].!   
play: aSoundName
    "Private - Produces the sound named aSoundName.
     aSoundName can be a fileName
        or the name of an Win.Ini [Sounds] entry "

    MMSystemDLL library
        sndPlaySound:  aSoundName asParameter
        flags: 0! 
profiler
    "Private - Returns the profiler for the receiver.
     Or nil..."
    ^self class profiler!   
send: aSymbol to: aPane
    "Private - Send a Symbol message to aPane;
    The message will be send in deferred mode"

    (Message new
        receiver: aPane
        selector: aSymbol
        arguments: Array new ) performDeferred.! 
startTimerEach: milliseconds
    "Private - Start a Timer for milliseconds in the receiver.
    See comments in message #tick... "

    TimerWindow
        startTimer: self
        interval: milliseconds!
stickerForObjectAt: aPoint in: aPane

    | selector text |
    (aPane isKindOf: WBToolPalette)
    ifTrue: [
        selector := aPane selectorAt: aPane currentIndex.
        selector isNil ifTrue: [^nil].
        ^self statusPaneHelp: selector asString
    ].

    ^nil "no sticker..."!
stopTimer
    "Private - End sthe timer in use for the receiver...
    See comments in message #tick... "

    TimerWindow stopTimer: self!   
tick
    "Private - Process timer ticks events...
    Do nothing here; can be reimplemented by subclasses...

    This message will be sended when using
        #startTimerEach: milliseconds
    Timer must be stopped with
        #stopTimer
    "!   
title
    "Returns the receiver's  title"

    ^self titleWith: nil!   
titleWith: anObject
    "Returns the receiver's  title obtained from default title
     and anObject description append at end..."

    | prologue epilogue |
    prologue := self class mainViewTitle.
    prologue size = 0 ifTrue: [ prologue := nil ].
    epilogue := anObject notNil
          ifTrue: [
            (anObject respondsTo: #name)
            ifTrue: [ anObject name ]
            ifFalse: [ anObject asString ]
            ].
    (prologue isNil and: [ epilogue isNil ]) ifTrue: [ ^nil ].
    ^(prologue isNil ifTrue: [String new] ifFalse: [prologue])
        ,(epilogue isNil ifTrue: [String new]
            ifFalse: [prologue isNil ifTrue: [epilogue] ifFalse: [' - ',epilogue]])!  
titleWithPath: path
    "Returns the receiver's  title obtained from default title
     and path description append at end..."

    ^self titleWith:
        (path isNil
            ifTrue: [' - [Anonimo]']
            ifFalse: [ ' - [',path,']' ])!   
toolDebug
    "Private - Inspect the receiver..."

    Smalltalk isRunTime
    ifTrue: [
        ^self
            beep;
            message: 'Las opciones de debuggin estn desabilitadas'
    ].
    self inspect!
toolHalt
    "Private - Halt the receiver..."

    Smalltalk isRunTime
    ifTrue: [
        ^self
            beep;
            message: 'Las opciones de debuggin estn desabilitadas'
    ].
    self halt!   
topPaneClass
    "Answer the class which is used as top pane.
     Patched by Ale to Support dynamic MDI as implemented by OSI"

    (Smalltalk includesKey: #TopPaneClass)
    ifTrue: [ ^Smalltalk at: #TopPaneClass ].

    ^TopAppPane!
updateTitle
    "Update the label of the receiver's window..."

    | newTitle |
    newTitle := self title.
    newTitle notNil ifTrue: [
        self label: newTitle
    ].!
warning: aLabel
    "Log the message aLabel and alert the user..."

    ^StartUpApplication warning: aLabel! !

! ActiveLayersViewManager class methods !
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (fileNew 'Permite crear una nueva capa de informacin...')
        (fileOpen 'Permite agregar una capa de informacin previamente guardada en un archivo.')
        (fileSave 'Permite guardar la capa de informacin selecta en un archivo.')
        (fileRead 'Permite armar una nueva capa de informacin leyendo una base de datos.')
        (fileSearch 'Permite buscar un dato en todas las capas de informacin activas.')
        (editDelete 'Elimina la capa de informacin selecta.')

        (edit 'Permite editar las propiedades de la capa de informacin selecta.')
        (editSelect 'Selecciona la capa de informacin.')
        (editRemoveSelection 'Deselecciona la capa de informacin.')
        (editSelectAll 'Muestra toda la informacin disponible...')
        (editUnselectAll 'Deselecciona todos los tpicos de la capa de informacin actual.')
        (editSearch 'Permite buscar una dato en la capa de informacin selecta.')
    )!  
wbCreated

    ^true! !

! ActiveLayersViewManager methods !  
canEdit: aLayer
    "Private - Returns true if the user can edit aLayer"

    ^Smalltalk isRunTime not or: [
        self model viewInUse notNil
    ]!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  '';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 357 @ 680; lDU: 1952 r: #left; tDU: 14 r: #top; cRDU: (9 @ 672 rightBottom: 347 @ 46));
            pStyle: #(sysmenu titlebar sizable minimize);
            backColor: ClrPalegray;
            addSubpane: (
                OSListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 532; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 94 r: #top; bDU: 0 r: #bottom);
                    defaultStyle;
                    startGroup;
                    when: #getContents perform: #layers:;
                    when: #getMenu perform: #listMenu:;
                    when: #select perform: #layerSelected:;
                    when: #doubleClickSelect perform: #layerToggled:;
                    when: #drawItem perform: #drawLayer:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 48; lDU: 2 r: #left; rDU: 341 r: #left; tDU: 2 r: #top; bDU: 50 r: #top);
                    add: #fileNew;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #fileRead;
                    add: #editDelete;
                    add: #fileSearch;
                    postAutomatic;
                    startGroup;
                    when: #getContents perform: #toolbarContents:;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 48; lDU: 2 r: #left; rDU: 341 r: #left; tDU: 46 r: #top; bDU: 94 r: #top);
                    add: #edit;
                    add: #editSelect;
                    add: #editRemoveSelection;
                    add: #editSelectAll;
                    add: #editUnselectAll;
                    add: #editSearch;
                    postAutomatic;
                    startGroup;
                    when: #getContents perform: #toolbarContents:;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
displayCategory: anAssociation at: aPoint with: aPen
    "Private - Display category name string with aPen"

    | dest selected displacement inset |
    dest := self iconExtent x // 2 + 1 @ 1 + aPoint extent: self iconExtent.

    selected := self isCategorySelected: anAssociation.
    displacement := (selected ifTrue: [self iconExtent x] ifFalse: [0]) @0.
    inset := selected ifTrue: ["3"0] ifFalse: [0].

    aPen
        copyBitmap:
            (anAssociation value layer toolFor: anAssociation key)
        from: ((displacement extent: self iconExtent) insetBy: inset)
        to: dest! 
displayLayer: layer at: aPoint with: aPen
    "Private - Display tool name string with aPen"

    | dest selected displacement inset|
    dest := aPoint + 1 extent: self iconExtent.

    selected := self isLayerSelected: layer.
    displacement := (selected ifTrue: [self iconExtent x] ifFalse: [0]) @0.
    inset := selected ifTrue: ["3"0] ifFalse: [0].

    aPen
        copyBitmap: layer layer tool
        from: ((displacement extent: self iconExtent) insetBy: inset)
        to: dest!
draggedObjectIn: aPane
    "Private - Returns the currently dragged object.
    Implemented for drag&drop support..."

    | item |
    mapView notNil
    ifTrue: [
        item := (self paneAt: #layers:) selectedItem.
        "self message: item asString."
        ^item " isAssociation  an association or a layerView can be dragged...
        ifTrue: [ item key ]
        ifFalse: [ item ] "
    ].

    ^nil! 
drawLayer: aPane

    "Callback for the #drawItem event in an unnamed MultipleSelectListBox.
     (Generated by WindowBuilder)"

    | box list margin index fore pen textPosition object label |
    pen := aPane graphicsTool.
    box := aPane drawBox.
    list := aPane contents.
    object := list at: aPane drawIndex.
    object isAssociation
    ifTrue: [
        self displayCategory: object at: box origin with: aPane graphicsTool.
        margin := self iconExtent x * 3 // 2 + 6.
        label := object key.
    ]
    ifFalse: [
        self displayLayer: object at: box origin with: aPane graphicsTool.
        margin := self iconExtent x + 6.
        label := object name.
    ].
    textPosition := margin @ (self iconExtent y - aPane font height // 2) + box origin.
    pen
        setTextAlign: TaTop;
        setBackMode: Transparent;
        foreColor: ClrWhite;place: textPosition + 1;displayText: label;
        foreColor: aPane foreColor;place: textPosition;displayText: label;
        setBackMode: Opaque.!   
edit
    "Lets the user destroy a layer..."

    | layer selectedLayer |
    selectedLayer := self selectedLayer.
    selectedLayer isNil ifTrue: [ ^self beep ].
    layer := selectedLayer layer.
    layer editWith: self model viewInUse!  
editDelete
    "Lets the user destroy a layer..."

    | layer |
    layer := self selectedLayer layer.
    self beep.
    layer isNil ifTrue: [^self].
    (MessageBox confirm: 'Seguro desea borrar la capa de informacin ',layer name asString,'?')
    ifFalse: [ ^self ].
    self editUnselectAll.
    self mapView map removeLayer: layer.
    self mapView layers.
    self fullUpdate;updateViews.! 
editRemoveSelection
    "Private - Remueve item selecto"

    | layer |
    layer := self selectedLayer.
    layer isNil ifTrue: [^self].
    (self isLayerSelected: layer)
    ifTrue: [
        (self paneAt: #layers:) restoreSelected: layer.
        self layerToggled: (self paneAt: #layers:)
    ].!
editSelect
    "Private - Selecciona item selecto"

    | layer |
    layer := self selectedLayer.
    layer isNil ifTrue: [^self].
    (self isLayerSelected: layer)
    ifFalse: [
        self layerToggled: (self paneAt: #layers:)
    ].!  
editSelectAll
    "Private - Selecciona todos los topicos del item selecto"

    | layer |
    layer := self selectedLayer.
    layer isNil ifTrue: [^self].
    layer categoryNames
    do: [:categ| layer select: categ ].
    self updateViews.!   
editUnselectAll
    "Private - Selecciona ningun topico del item selecto"

    | layer |
    layer := self selectedLayer.
    layer isNil ifTrue: [^self].
    layer categoryNames
    do: [:categ| layer unselect: categ ].
    self updateViews.!   
fileNew
    "Lets the user create a new layer or category..."

    | item |
    item := (self paneAt: #layers:) selectedItem.
    (item isNil or: [ item respondsTo: #categories])
    ifTrue: [ self newLayer ]
    ifFalse: [ self newCategory ].!   
fileOpen
    "Lets the user select a layer file and file it in..."

    | dialog file layer map old |

    map := self mapView map.
    dialog := FileDialog new.
    dialog
        title: 'Capa de informacin a leer...';
        addFilter: '*.lay' description: 'Capas de informacin (*.LAY)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        defFilter: '*.lay';fileSpec: '*.lay';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].

    (file includes: $.) ifFalse: [ file := file,'.Lay' ].

    layer := ObjectFiler loadFromPathName: file.
    layer isNil ifTrue: [ ^self error: 'Archivo Invalido...' ].

    (layer isKindOf: Layer)
    ifFalse: [ ^self error: 'El archivo no contiene una capa de informacin' ].

    ((old := map layerNamed: layer name) isNil
    or: [ MessageBox confirm: 'Sobreescrive la capa de informacin de nombre ',layer name ])
    ifTrue: [
        map addLayer: layer.
        map removeLayer: old.
    ]
    ifFalse: [
        layer name: (OSPrompter prompt: 'Nuevo nombre para la capa de informacin ?' default: layer name).
        layer name isNil ifTrue: [ ^self ].
        map addLayer: layer.
    ].

    self fullUpdate.! 
fileRead
    "FilesIn information into current layer"

    | map layer |
    layer := self selectedLayer.
    layer isNil ifTrue: [^self beep].
    layer layer fileInUsing: mapView!   
fileSave
    "Lets the user save the selectedLayer in a new file..."

     | dialog file layer |
    layer := self selectedLayer layer.
    layer isNil ifTrue: [^self beep ].
    file := File fileName: layer name extension: 'Lay'.
    dialog := FileDialog new.
    dialog
        title: 'Seleccione el archivo donde guardarlo...';
        addFilter: '*.lay' description: 'Capas de Informacin (*.LAY)';
        addFilter: '*.*' description: 'All Files (*.*)';
        fileSpec: file;
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].

    (file includes: $.) ifFalse: [ file := file,'.Lay' ].
    self backUpFile: file.

    CursorManager execute changeFor: [
        ObjectFiler dump: layer newFile: file.
        self updateTitle.
    ].
    ^file!   
fullExtent
    "Private - Returns the extent for the receiver's view"
    ^120 @ 250!   
iconExtent
    "Returns the icon width"
    ^25@22! 
isCategorySelected: anAsoc
    "Private - True if aCategori (in anAsoc key) is selected"

    ^anAsoc value isCategorySelected: anAsoc key!
isLayerSelected: aLayer
    "Private - True if aLayer is selected"

    ^mapView notNil and: [
        mapView selectedLayers includes: aLayer
    ]!
layers: aPane

    "Callback for the #getContents event in an unnamed DrawList.
     (Generated by WindowBuilder)"

    | list layers |
    mapView isNil ifTrue: [ aPane contents: Array new.^self ].
    list := OrderedCollection new.
    layers := SortedCollection sortBlock: [:a :b | a name < b name ].
    layers addAll: mapView layers.
    layers do: [:layer|
        list add: layer.
        ((self isLayerSelected: layer) and: [layer respondsTo: #categoryNames])
        ifTrue: [
            list addAll: (layer categoryNames asSortedCollection
                collect: [:categ| Association key: categ value: layer ])
        ].
    ].
    aPane contents: list asArray! 
layerSelected: aPane

    "Callback for the #select event in an unnamed MultipleSelectListBox.
     (Generated by WindowBuilder)"

    self changed: #toolbarContents:.! 
layerToggled: aPane

    "Callback for the #doubleClickSelect event in an unnamed MultipleSelectListBox.
     (Generated by WindowBuilder)"

    | item layer |
    mapView notNil
    ifTrue: [
        item := (self paneAt: #layers:) selectedItem.
        Notifier isAltDown & Smalltalk isRunTime not ifTrue: [^self halt].
        item isAssociation
        ifTrue: [
            layer := item value.
            (layer isCategorySelected: item key)
            ifTrue: [ layer unselect: item key ]
            ifFalse: [ layer select: item key ]
        ]
        ifFalse: [
            layer := item.
            (self isLayerSelected: layer)
            ifTrue: [ mapView unselect: layer ]
            ifFalse: [ mapView select: layer ]
        ]
    ].
    self updateViews.!
listMenu
    "Private - Returns the list pane menu"

    | item menu |

    item := (self paneAt: #layers:) selectedItem.
    menu := Menu new
            owner: self;
            title: '&Informacion';
            yourself.
    menu appendItem: '&Nueva Capa de informacion' selector: #newLayer.
    item notNil ifTrue: [
        (item respondsTo: #categories)
        ifTrue: [
            menu
                appendItem: 'N&ueva Categoria' selector: #newCategory;
                appendSeparator.
        ] ifFalse: [ menu appendSeparator ].

        menu
            appendItem: 'seleccionar &Todas' selector: #editSelectAll;
            appendItem: 'seleccionar &Ninguna' selector: #editUnselectAll;
            yourself.
    ].
    menu
        appendSeparator;
        appendItem: '&Refrescar' selector: #updateViews;
        yourself.

    ^menu!   
listMenu: aPane

    "Callback for the #getMenu event in an unnamed OSListPane.
     (Generated by WindowBuilder)"

    aPane setMenu: self listMenu!
mapView
    "Returns the current mapView"
    ^mapView! 
mapView: aMapView
    "Update the receiver's views using aMapView"

    mapView := aMapView.

    aMapView isNil ifTrue: [
        ^self send: #fileExit to: self
    ].

    views notEmpty
    ifTrue: [
        self
            changed: #layers: with: #restoreSelected;
            changed: #toolbarContents:;
            updateTitle;
            yourself.
    ].!  
message: aString
    "Private - Show aString in the contents box"

    ^self message: aString in: #status! 
message: aString in: statusBox
    "Private - Show aString in the status box"

    | pane |
    pane := self statusPane.
    pane notNil
    ifTrue: [
        (pane statusBoxAt: statusBox) contents: aString
    ]! 
newCategory
    "Lets the user add a new category to curent layer..."

    | layerView layer category |
    layerView := self selectedLayer.
    layerView isNil ifTrue: [^self beep].
    layer := layerView layer.
    category := OSPrompter
        prompt: 'Nombre de la nueva categora para ',layer name asString,' ?'
        default: 'General'.
    (category isNil or: [(category := category trimBlanks) isEmpty]) ifTrue: [^nil].
    layer addCategory: category.
    self updateViews.!
newLayer
    "Lets the user add a new layer to current map..."

    | layer map current |
    layer := OSPrompter prompt: 'Nombre de la nueva capa de informacin ?' default: 'Informacin'.
    (layer isNil or: [(layer := layer trimBlanks) isEmpty]) ifTrue: [^nil].
    map := self mapView map.
    current := map layerNamed: layer ifAbsent: [
        map
            newLayer: layer
            opaque: (MessageBox confirm: 'Es "',layer,'" una capa de informacin opaca?').
        self mapView map: map. "notify layer changes..."
        ^self updateViews
    ].
    ^self warning: 'La capa de informacin "',layer,'" ya existe.'! 
preInitWindow
    "Private - Prepares the list pane for proper height..."

    | pane |
    pane := self paneAt: #layers:.
    pane
        ownerDrawFixed;
        height: self iconExtent y + 2;
        " style: pane style - WsBorder; "
        yourself.
    self updateTitle.
    self mainView
        framingBlock: [:box|
            box right - self fullExtent x - 2 @ 2 extent: self fullExtent ];
        yourself.! 
selectedLayer
    "Private - Returns selected layer or nil"

    | item |
    item := (self paneAt: #layers:) selectedItem.
    ^item isAssociation
    ifTrue: [ item value ]
    ifFalse: [ item ]!  
statusPaneHelp:aKey
    "Private - Answer the hint text to the StatusPane"

    | dict label pair value |
    label := [:selector :text|
        (text size = 0 or: [self respondsTo: selector])
        ifTrue: [ text ]
        ifFalse: [ text ,' *An no implementado [',selector,']*']
    ].

    self class helpMap do: [:pair |
        pair first asString = aKey asString
        ifTrue: [ ^label value: pair first value: pair last ]
    ].

    dict := Smalltalk at: #HelpStatusPane ifAbsent: [Dictionary new].
    value := dict at: aKey
        ifAbsent: [ dict at: aKey asSymbol ifAbsent: [ super statusPaneHelp: aKey ]].
    ^label value: aKey value: value!   
toolbarContents: aPane

    "Callback for the #getContents event in an unnamed WBToolBar.
     (Generated by WindowBuilder)"

    | item |
    mapView isNil
    ifTrue: [
        #(editSelect editRemoveSelection editSelectAll editUnselectAll fileSave editSearch)
            do: [:tool| aPane disableItem: tool ].
        ^self
    ].

    item := (self paneAt: #layers:) selectedItem.
    item isNil
    ifTrue: [
        #(editSelect editRemoveSelection editSearch) do: [:tool| aPane disableItem: tool ].
    ]
    ifFalse: [
        #(editSelect editRemoveSelection editSearch) do: [:tool| aPane enableItem: tool ].
    ].
    (self canEdit: item)
    ifTrue: [ aPane enableItem: #edit ]
    ifFalse: [ aPane disableItem: #edit ].

    ((item respondsTo: #categories) not or: [item categories size = 0])
    ifTrue: [
        #(editUnselectAll editSelectAll) do: [:tool| aPane disableItem: tool ].
    ]
    ifFalse: [
        #(editUnselectAll editSelectAll) do: [:tool| aPane enableItem: tool ].
    ].

    ((item respondsTo: #categories) "and: [item canBeSaved ]")
    ifTrue: [ #(fileSave editDelete fileRead) do: [:tool| aPane enableItem: tool ] ]
    ifFalse: [ #(fileSave editDelete fileRead) do: [:tool| aPane disableItem: tool ] ].!  
toolHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := self statusPaneHelp: selector asString.
    text isNil ifTrue: [ text := String new ].
    self message: text!
updateViews
    "Private - Update the model view"

    | model |
    model := self model.
    model notNil ifTrue: [ model updateView ].
    self changed: #layers: with: #restoreSelected.!
viewManager: aViewManager
    "Private - Change receiver's aspect to reflect aViewManager properties..."

    ^self mapView: (aViewManager isNil ifFalse: [aViewManager mapView])! !

! ChuteWindow class methods !  
wbCreated

    ^true! !

! ChuteWindow methods !  
chute: aChuteObject

    playing := false.
    chute := aChuteObject.
    pane invalidateRect: nil.!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Chute Window';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 686 @ 400; xC; yC; cRDU: (9 @ 392 rightBottom: 677 @ 46));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            when: #close perform: #mainViewClosed:;
            backColor: ClrPalegray;
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 667 @ 298; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 48 r: #top; bDU: 0 r: #bottom);
                    paneName: 'graph';
                    noBorders;
                    startGroup;
                    when: #display perform: #displayGraph:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 585 @ 48; lDU: 0 r: #left; rDU: 585 r: #left; tDU: 0 r: #top; bDU: 48 r: #top);
                    add: #fileNew;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #edit spaces: 3;
                    add: #editCopy;
                    add: #editPaste;
                    add: #macroPlay spaces: 3;
                    add: #macroStop;
                    add: #toolHalt spaces: 3;
                    add: #fileExit spaces: 3;
                    postAutomatic;
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
displayGraph: aPane

    "Callback for the #display event in the GraphPane named 'graph'.
     (Generated by WindowBuilder)"

    aPane backColor: chute backColor.
    aPane erase.!   
edit

    self
        editBitmap;
        editBackColor;
        editSteps! 
editBackColor
    "Private - Lets the user change the back color"

    | color |
    color := Prompter
        prompt: 'Enter the back color constant name'
        default: 'ClrWhite'.
    color isNil ifTrue: [^self].
    color := ColorConstants
        at: color
        ifAbsent: [ Compiler evaluate: color ].
    color isNil ifTrue: [^self].
    chute backColor: color.! 
editBitmap
    "Private - Lets the user select the background bitmap"

    | dialog file bitmap |
    dialog := FileDialog new.
    dialog
        title: 'Specify Bitmap file...';
        addFilter: '*.bmp' description: 'Bitmap Files (*.BMP)';
        addFilter: '*.*' description: 'All Files (*.*)';
        defFilter: '*.bmp';fileSpec: '*.bmp';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].
    bitmap := Bitmap fromFile: file.
    bitmap isNil ifTrue: [ ^self error: 'Invalid biotmap file' ].
    chute bitmap: bitmap.! 
editCopy

    Clipboard setObject: chute.!  
editPaste
    | object |
    object := Clipboard getObject.
    (object isKindOf: ChuteObject) ifFalse: [ ^self error: 'Invalid Clipboard contents...' ].
    self chute: object! 
editSteps

    (MessageBox confirm: 'Do you want to inspect steps ?')
    ifTrue: [ chute steps inspect ].!
fileNew
    self chute: nil.!
fileOpen
    "The receiver will work in a map
    and scanner obtained from a file..."

     | dialog file object |

    dialog := FileDialog new.
    dialog
        title: 'Specify Chute Source file...';
        addFilter: '*.cht' description: 'Chute Files (*.CHT)';
        addFilter: '*.*' description: 'All Files (*.*)';
        defFilter: '*.cht';fileSpec: '*.cht';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].

    object := ObjectFiler loadFromPathName: file.
    (object isKindOf: ChuteObject) ifFalse: [ ^self error: 'Invalid file contents...' ].
    self chute: object!
fileSave
    "Lets the user save the chute in a new file..."

     | dialog file |

    dialog := FileDialog new.
    dialog
        title: 'Specify Chute file name...';
        addFilter: '*.cht' description: 'Chute Files (*.CHT)';
        addFilter: '*.*' description: 'All Files (*.*)';
        fileSpec: 'Chute.cht';
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].

    CursorManager execute changeFor: [
        ObjectFiler dump: chute newFile: file.
    ].!   
macroPlay
    | stream pen step last destination |
    playing ifTrue: [^self macroStop].
    chute steps isEmpty ifTrue: [^Terminal bell].
    last := 0@0 extent: 0@0.
    playing := true.
    stream := ReadStream on: chute steps asArray.
    [
        [playing] whileTrue: [
            stream atEnd ifTrue: [ stream reset ].
            step := stream next.
            pane isHandleOk
            ifFalse: [playing := false]
            ifTrue: [
                pen := pane pen.
                last left <= 0
                ifTrue: [
                    pen fill: last color: pane backColor.
                    last := pane frameRectangle right @0 extent: step first extent.
                ].
                destination := last translateBy: step last.
                pen
                    copy: chute bitmap pen
                    from: step first
                    to: destination.
                (last nonIntersections: destination) do: [:rect|
                    pen fill: rect color: pane backColor.
                ].
                last := destination.
                [ Time millisecondClockValue \\ 20 = 0] whileFalse: [ Processor yield ].
            ].
        ]
    ] forkAt: 3!  
macroStop

    playing ifFalse: [^self].
    playing := false.
    Terminal bell.!
mainViewClosed: aTopPane

    "Callback for the #close event in the TopPane 'mainView'.
     (Generated by WindowBuilder)"

    playing := false.
    super mainViewClosed: aTopPane.!  
preInitWindow
    "Initialize the receiver's windows"

    playing := false.
    pane := self paneNamed: 'graph'.
    chute isNil ifTrue: [ chute := ChuteObject new ].! !

! ComposeImageEditor class methods !   
wbCreated

    ^true! !

! ComposeImageEditor methods !   
close

    images do: [:each | each release ].
Terminal bell.
    ^super close.!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Imgen compuesta';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1042 @ 536; xC; yC; cRDU: (9 @ 528 rightBottom: 1033 @ 84));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            addSubpane: (
                OSImagePane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1024 @ 444; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 0 r: #top; bDU: 0 r: #bottom);
                    paneName: 'image';
                    startGroup;
                    when: #getContents perform: #image:;
                    when: #button1Up perform: #mouseUp:;
                    when: #button1Down perform: #mouseDown:;
                    when: #button1Move perform: #mouseMove:;
                    when: #display perform: #displayImages:;
                    when: #button1DoubleClick perform: #mouseDoubleClick:;
                    yourself
            );
        yourself
    ).

    v menuWindow
        yourself;
        addMenu: (
            Menu new
                title: '&Archivo';
                owner: self;
                appendItem: '&Abrir' selector: #fileOpen acceleratorString: '';
                appendItem: '&Cerrar' selector: #fileExit;
                appendItem: '&Refrescar' selector: #refresh;
                appendSeparator;
                appendItem: '&Inspeccionar' selector: #inspectorOpen
        );
        addMenu: (
            Menu new
                title: '&Editar';
                owner: self;
                appendItem: '&Render Match ' selector: #renderMatch;
                appendSeparator;
                appendItem: '&Preview' selector: #preview acceleratorString: ''
        ).!
displayImages: aPane

    "Callback for the #display event in an unnamed OSGraphPane.
     (Generated by WindowBuilder)"

    | rectangles boundingBox |
    images size = 0 ifTrue: [
        aPane erase.
        self displayKeyPoints: aPane.
        ^self
    ].
    aPane erase.

    boundingBox := aPane boundingBox.

    rectangles := aPane visibleRectangle.     "
    rectangles := aPane rectangleToDisplay.
"
    rectangles isCollection ifFalse: [
        rectangles := Array with: rectangles
    ].

    CursorManager execute changeFor: [
        rectangles do: [:rect|
          rect notNil ifTrue: [
            (rect nonIntersections: boundingBox)
            do: [:nonOverlaped| aPane pen fill: nonOverlaped color: aPane backColor ].
            images do: [:each |
                each displayAt: 0@0 with: aPane pen.
            ].
            self displayKeyPoints: aPane.
          ].
        ]
    ].! 
displayKeyPoints: aPane

    "Callback for the #display event in an unnamed OSGraphPane.
     (Generated by WindowBuilder)"
    | pen |
    pen := aPane pen.
    pen
        setRop2: R2Notxorpen.

    matchedKeyPointUp displayAt: 0@0 with: pen.
    matchedKeyPointDown displayAt: 0@0 with: pen.

    pen
        setRop2: R2Copypen.! 
fileExit

    "Callback for the menu item titled 'Close'.
     (Generated by WindowBuilder)"

    ^self close.!  
fileOpen

    "Callback for the menu item titled 'Open'.
     (Generated by WindowBuilder)"
    | oneImage |
    images size = 2 ifTrue: [
        images first release.
        images remove: images first.
    ].
    (oneImage := HaloImage fromFile) isNil ifTrue: [^self].
    oneImage := Tile new bitmap: oneImage.
    oneImage origin: images size * 50.
    images add: oneImage.
    position := oneImage width @ 0.
    self changed: #image:! 
image: aPane

    "Callback for the #getContents event in the OSImagePane named 'image'.
     (Generated by WindowBuilder)"!   
images
    "Returns the instance var of the receiver
     for external manipulation"
    ^images!  
images: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    images := anObject! 
initialize
    | startPoint |
    images := OrderedCollection new.
    position := 0@0.

    selectedPoint := 0@0.

    startPoint := 80 @ 80.
    matchedKeyPointUp := MatchedKeyPoints
        left:  startPoint copy
        right: (startPoint copy + (50@0)).

    startPoint := 80 @ 100.
    matchedKeyPointDown := MatchedKeyPoints
        left:  startPoint copy
        right: (startPoint copy + (50@0)).


    ^super initialize!  
inspectorOpen

    "Callback for the menu item titled 'inspect'.
     (Generated by WindowBuilder)"
    images asArray inspect!   
matchedKeyPointDown
    "Returns the instance var of the receiver
     for external manipulation"
    ^matchedKeyPointDown!
matchedKeyPointDown: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    matchedKeyPointDown := anObject!   
matchedKeyPointUp
    "Returns the instance var of the receiver
     for external manipulation"
    ^matchedKeyPointUp!
matchedKeyPointUp: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    matchedKeyPointUp := anObject!   
mouseDoubleClick: aPane

    "Callback for the #button1DoubleClick event in the OSImagePane named 'image'.
     (Generated by WindowBuilder)"
    | sel |

    sel := self selectedAt: aPane mouseLocation.
    sel isNil ifTrue: [^self].
    sel inspect.!  
mouseDown: aPane
        "Private - Process a mouse down event."

    selectedPoint := aPane mouseLocation.
    selected := self selectedAt: selectedPoint.
    selected isNil ifTrue: [^self].
    CursorManager crossHair change.
    selectedPoint := selectedPoint -  selected origin.!
mouseMove: aPane
        "Private - Process a mouse move event."
    | pen |
    selected isNil ifTrue: [^self].
    pen := aPane pen.
    pen
            setRop2: R2Notxorpen.

    selected class = KeyPoint ifTrue: [
        (matchedKeyPointUp includes: selected) ifTrue: [
            matchedKeyPointUp displayAt: 0@0 with: pen.
        ].
        (matchedKeyPointDown includes: selected) ifTrue: [
            matchedKeyPointDown displayAt: 0@0 with: pen.
        ].

        selected origin: aPane mouseLocation.
        (matchedKeyPointUp includes: selected) ifTrue: [
            matchedKeyPointUp displayAt: 0@0 with: pen.
        ].
        (matchedKeyPointDown includes: selected) ifTrue: [
            matchedKeyPointDown displayAt: 0@0 with: pen.
        ].

        pen
            setRop2: R2Copypen.
        ^self
    ].
    selected displayLightAt: 0@0 with: pen.
    selected origin: (aPane mouseLocation -  selectedPoint).
    selected displayLightAt: 0@0 with: pen.

    pen
            setRop2: R2Copypen.!
mouseUp: aPane
        "Private - Process a mouse up event."
    | matched pen |
    CursorManager normal change.
    selected isNil ifTrue: [Terminal bell.^self].

    selected class = KeyPoint ifTrue: [
        pen := aPane pen.
        pen
            setRop2: R2Notxorpen.
        self displayKeyPoints: aPane.
        selected origin: aPane mouseLocation.

        self displayKeyPoints: aPane.
        ^self
    ] ifFalse: [
        selected origin: (aPane mouseLocation -  selectedPoint).
    ].
    selected := nil.
    CursorManager normal change.
    aPane event: #display!   
preview

    "Callback for the menu item titled 'Preview'.
     (Generated by WindowBuilder)"! 
processedImageA

    "
    obtener punto mas a la derecha
    cortar en vertical pasando por dicho punto
     "
    ^(images at: 1) copy!   
processedImageB
    | imageB angulo |
    imageB := (images at: 2) copy.

    "posiciona keyPoint superior"

    imageB origin:  (imageB origin -
        (matchedKeyPointUp positionLeft - matchedKeyPointUp positionRight)).

    "la gira"

    angulo := ((matchedKeyPointUp positionLeft modulus: matchedKeyPointDown positionRight) /
        (matchedKeyPointUp positionLeft modulus: matchedKeyPointDown positionLeft) ) arcTan.

    imageB
        rotate: angulo;
        displayAt: 0@0.

    ^imageB!  
processedKeyPointDown

    ^MatchedKeyPoints
        left: (self matchedKeyPointDown keyPointLeft origin copy)
        right: (self matchedKeyPointDown keyPointRight origin copy)!   
processedKeyPointUp

    ^MatchedKeyPoints
        left: (self matchedKeyPointUp keyPointLeft origin copy)
        right: (self matchedKeyPointUp keyPointRight origin copy)! 
refresh

    "Callback for the menu item titled 'Refresh'.
     (Generated by WindowBuilder)"
    (self paneAt: #image:) invalidateRect: nil! 
renderMatch

    "Callback for the menu item titled 'Render Match '.
     (Generated by WindowBuilder)"
    | newImages |

    (self validateMatchKeyPoints) isNil ifTrue: [^self].

    newImages := OrderedCollection
        with: self processedImageA
        with:   self processedImageB.

    self class new
        images: newImages;
        matchedKeyPointUp: self processedKeyPointUp;
        matchedKeyPointDown: self processedKeyPointDown;
        open.!  
selectedAt: aPoint
        "Private - Answer the object containing aPoint, or nil."
    | sel |
    sel := self selectedKeyPointAt: aPoint.
    sel notNil ifTrue:[^sel].
    ^self selectedImageAt: aPoint.!
selectedImageAt: aPoint
        "Private - Answer the object containing aPoint, or nil."

    images do: [ :each |
        (each boundingBox containsPoint: aPoint)
            ifTrue: [^each]].
    ^nil! 
selectedKeyPointAt: aPoint
        "Private - Answer the object containing aPoint, or nil."
    matchedKeyPointUp keyPoints do: [ :each |
        (each boundingBox containsPoint: aPoint)
            ifTrue: [^each]].
    matchedKeyPointDown keyPoints do: [ :each |
        (each boundingBox containsPoint: aPoint)
            ifTrue: [^each]].
    ^nil! 
validateMatchedKeyPoints

    (self validateMatchKeyPoints: matchedKeyPointUp) isNil ifTrue: [^self].
    (self validateMatchKeyPoints: matchedKeyPointDown) isNil ifTrue: [^self].
    ^nil! 
validateMatchKeyPoints: matchedKeyPoint
    | imageA imageB |

    imageA := self selectedImageAt:matchedKeyPoint keyPointLeft origin.
    imageB := self selectedImageAt: matchedKeyPoint keyPointRight origin.
    imageA isNil ifTrue: [MessageBox warning: 'KeyPoint debe estar sobre la imagen'. ^nil].
    imageB isNil ifTrue: [MessageBox warning: 'KeyPoint debe estar sobre la imagen'. ^nil].
    imageA = imageB ifTrue: [MessageBox warning: 'KeyPoints deben estar sobre distintas imagenes'. ^nil].! !

! ImageEditor class methods ! 
cursorNames
    "Private - Returns the cursors handled by receiver's instances"

    ^#(
        hand move select
    "
        cut erase
        origin corner
        'paint' 'pencil'
        'print'
        'unavailable'
    "
    )!   
wbCreated

    ^true! !

! ImageEditor methods !  
button1DoubleClick: aPane

    "Callback for the #button1DoubleClick event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    | point |
    point := aPane mouseLocation.
    selection notNil
    ifTrue: [
        (selection containsPoint: point)
        ifTrue: [ self selectionDoubleClickedAt: point ].
        self selectionHasChanged.
    ].!
button1Down: aPane

    "Callback for the #button1Down event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    | point displacement mode |
    point := aPane mouseLocation.
    self useSelection ifFalse: [^self].

    self displaySelection.

    selection isNil
    ifTrue: [ selection := point x @ point y extent: 0@0 ].

    (selection width > 0 and: [selection containsPoint: point])
    ifTrue: [
        mode := #move.
        displacement := point - selection origin.
    ]
    ifFalse: [
        mode := #select.
        displacement := 0@0.
        selection := point x @ point y extent: 0@0.
    ].

    aPane
        propertyAt: #mode put: mode;
        propertyAt: #displacement put: displacement.

    self selectionStarts:aPane.

    self
        displaySelection;
        selectionHasChanged.!
button1DownShift: aPane

    "Callback for the #button1DownShift event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    "
    Currently do nothing...
    This method can be reimplemented or refined by subclasses..."!
button1Move: aPane

    "Callback for the #button1Move event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    | point displacement mode |
    self useSelection ifFalse: [^self].

    point := aPane mouseLocation.

    self displaySelection.
    (aPane propertyAt: #mode) = #move
    ifTrue: [
        selection moveTo: point - (aPane propertyAt: #displacement)
    ]
    ifFalse: [
        selection := selection origin corner: point
    ].

    self
        selectionInProgress:aPane;
        displaySelection;
        selectionHasChanged! 
button1Up: aPane

    "Callback for the #button1Up event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    | point displacement mode |

    Notifier isAltDown & Smalltalk isRunTime not ifTrue: [ self halt ].

    self useSelection ifFalse: [^self].

    point := aPane mouseLocation.

    self displaySelection.
    (aPane propertyAt: #mode) = #move
    ifTrue: [
        selection moveTo: point - (aPane propertyAt: #displacement)
    ]
    ifFalse: [
        selection := selection origin corner: point
    ].

    self selectionEnds:aPane.

    (selection width < self minimumSelection x
    or: [selection height < self minimumSelection y])
    ifTrue: [ selection := nil ].

    self
        displaySelection;
        selectionHasChanged;
        checkToolBar!
checkSelection
    "Private - The selection must be checked..."
    | left top right bottom |

    selection isNil ifTrue: [^self].

    left := selection left min: selection right.
    right := selection left max: selection right.
    top := selection top min: selection bottom.
    bottom := selection top max: selection bottom.

    selection := left @ top rightBottom: right @ bottom.!  
checkToolBar
    "Private - Check the toolbar contents..."

    | tools toolPane |
    toolPane := self paneAt: #fillToolBar:.
    tools := (toolPane contents collect: [:each| each selector]) asSet.

    image isNil
    ifTrue: [
        #(fileSave fileSaveAs) do: [:each|
            toolPane disableItem: each.
            tools remove: each
        ]
    ]
    ifFalse: [
        dirty ifFalse: [
            #(fileSave ) do: [:each| toolPane disableItem: each. tools remove: each ]
        ].
    ].

    tools
    do: [:selector|
            (self respondsTo: selector)
            ifTrue: [ toolPane enableItem: selector ]
            ifFalse: [ toolPane disableItem: selector ]
    ].

    self updateTitle.!
close
    "Close the receiver & release instances"

    | cursor |
    self destroyImage ifFalse: [^self].

    cursors isEmpty ifFalse: [
        cursors keys do: [:key|
            cursor := cursors at: key.
            cursor == CursorManager normal
            ifFalse: [ cursor release ].
            cursors removeKey: key.
        ]
    ].

    ^super close!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Image Tool';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1198 @ 664; xC; yC; cRDU: (7 @ 658 rightBottom: 1191 @ 82));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            backColor: ClrPalegray;
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1184 @ 44; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 0 r: #top; bDU: 44 r: #top);
                    add: #fileNew;
                    add: #fileRead;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #fileSaveAs;
                    add: #filePrint;
                    add: #editCut;
                    add: #editRepeat;
                    add: #editUndo;
                    add: #editPrint;
                    add: #editSelect;
                    add: #editSelectAll;
                    add: #viewStamp;
                    add: #macroRecord spaces: 3;
                    add: #macroPlay;
                    add: #macroStop;
                    add: #toolZoom spaces: 3;
                    add: #viewZoomIn;
                    add: #viewZoomOut;
                    add: #fileRun spaces: 5;
                    add: #fileExit;
                    startGroup; when: #getContents perform: #fillToolBar:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSImagePane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1184 @ 532; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 44 r: #top; bDU: 0 r: #bottom);
                    paneName: 'graph';
                    when: #button1DoubleClick perform: #button1DoubleClick:;
                    when: #button1Up perform: #button1Up:;
                    when: #button1Down perform: #button1Down:;
                    when: #button1Move perform: #button1Move:;
                    when: #display perform: #displayImage:;
                    when: #setScrollRectangle perform: #setScrollRectangle:;
                    when: #button1DownShift perform: #button1DownShift:;
                    when: #mouseMove perform: #mouseMove:;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).

    v menuWindow
        yourself;
        addMenu: (
            Menu new
                title: '&File';
                owner: self;
                appendItem: '&Open' selector: nil acceleratorString: ''
        ).!
cursorFor: action
    "Private - Returns the cursor for the action in aString or aSymbol 'action'
     or the normal cursor..."

    ^cursors at: action
        ifAbsent: [ CursorManager normal ]! 
destroyImage
    "Private - Destroy the current image...
    Returns true if sucessfully destroyed..."

    self saveConfirm ifFalse: [ ^false ].

    image release.
    image := nil.
    dirty := false.
    ^true!   
displayImage: aPane

    "Callback for the #display event in an unnamed OSGraphPane.
     (Generated by WindowBuilder)"

    | rectangles boundingBox |
    boundingBox := image isNil
        ifTrue: [0@0 corner: 0@0]
        ifFalse: [image boundingBox].
    rectangles := aPane rectangleToDisplay.
    rectangles isCollection ifFalse: [ rectangles := Array with: rectangles ].

    CursorManager execute changeFor: [
        rectangles do: [:rect|
          rect notNil ifTrue: [
            (rect nonIntersections: boundingBox)
            do: [:nonOverlaped| aPane pen fill: nonOverlaped color: aPane backColor ].
            self displayRectangle: (rect intersect: boundingBox) with: aPane pen.
          ].
        ].
        selection notNil ifTrue: [ self drawSelectionIn: rect with: aPane pen ].
    ].!  
displayRectangle: aRectangle with: aPen
    "Dibuja el area indicada por aRectangle usando aPen"

    image isNil ifTrue: [^aPen blank: aRectangle].

    (image respondsTo: #display:with:)
    ifTrue: [
        image
            display: (aRectangle intersect: image boundingBox)
            with: aPen
    ].
    image isBitmap ifTrue: [ ^image displayAt: 0@0 with: aPen ].!
displaySelection
    "Private - Display the current selection..."

    | aPane |
    aPane := self graphPane.
    selection notNil
    ifTrue: [
        self drawSelectionIn: aPane pen boundingBox with: aPane pen
    ]!   
drawSelectionIn: aRectangle with: aPen
    "Private - Draw the current selection..."

    | width backUp |
    backUp := aPen location.
    width := aPen width.
    aPen
        setRop2: R2Notxorpen;
        setLineWidth: self selectionLineWidth;

        place: selection origin;
        box: selection corner;

        setRop2: R2Copypen;
        setLineWidth: width;
        place: backUp;
        yourself!
editSelect
    "Private - UNSelect the current selection..."

    self selection: nil.!
editSelectAll
    "Private - Select all the image image..."

    self selection: (image isNil ifFalse: [ image boundingBox ])! 
fileNew
    "Private - Create a new image..."

    | answers width height format |

    answers := OSPrompter new
        title: 'Create Image...';
        questions: #( 'Width ?' 'Height ?' 'Class ? [Bilevel,Gray,Palette,RGB]');
        answers: (Array with: '100' with: '100' with: 'Gray' );
        open.

    answers isNil ifTrue: [^false].
    width := answers first asInteger.
    height := (answers at: 2) asInteger.

    (width <= 0 or: [height <= 0]) ifTrue: [^self warning: 'Invalid extent.'].

    format := HaloImage formats
        at: answers last ,' Image'
        ifAbsent: [ ^self warning: 'Invalid image format' ].

    self destroyImage ifFalse: [^self].

    self image: (HaloImage width: width height: height format: format).!
fileOpen
    "Private - Lets the user select a new image file..."

    | dialog file |

    dialog := FileDialog new.
    dialog
        title: 'Select an image file...';
        addFilter: '*.tif' description: 'TIFF Files (*.TIF)';
        addFilter: '*.bmp;*.rle;*.dib' description: 'Bitmap Files (*.BMP,*.DIB,*.RLE)';
        addFilter: '*.flf' description: 'Flat Files (*.FLF)';
        addFilter: '*.cut' description: 'Halo CUT Files (*.CUT)';
        addFilter: '*.pcx;*.pcc' description: 'PCX Files (*.PCX,*.PCC)';
        addFilter: '*.pic' description: 'PICT Files (*.PIC)';
        addFilter: '*.gif' description: 'GIF Files (*.GIF)';
        addFilter: '*.jpg' description: 'JPEG Files (*.JPG)';
        addFilter: '*.tga' description: 'TARGA Files (*.TGA)';
        addFilter: '*.ras;*.im8' description: 'Sun Raster Files (*.RAS,*.IM8)';
        addFilter: '*.*' description: 'All Files (*.*)';
        defFilter: '*.tif';
        fileSpec: '*.tif';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifFalse: [
      self destroyImage ifFalse: [^self].
      CursorManager execute changeFor: [
            file := file asLowerCase.
            self image: (HaloImage fromFile: file).
            path := file.
      ].
    ].!   
fileSave
    "Private - Save the current image..."

    | answer |
    path isEmpty ifTrue: [
        path := self promptForPath.
        path isEmpty ifTrue: [^self].
    ].
    self save.!
fileSaveAs
    "Private - Save the current image..."

    | newName |
    newName := self promptForPath.
    newName isEmpty ifTrue: [^self].
    path := newName.
    self save!  
fillToolBar: aToolPane
    "Private - Returns the cursor for the action in aString or aSymbol 'action'
     or the normal cursor..."

    self checkToolBar.! 
fullUpdate
    "Update all the receiver's panes and perform graph update"

    super fullUpdate.
    self updateView.!
graphPane
    "Private - rerturns receiver's graph pane"
    ^self paneNamed: 'graph'!  
image: anHaloImage
    "Private - Sets the receiver's new image..."

    image := anHaloImage.
    "selection := nil."
    self
        updateView;
        checkToolBar.! 
initialize
    " Private - Initialize the receiver..."

    super initialize.

    selection := nil.
    dirty := false.
    path := String new.

    self initializeCursors.!   
initializeCursors
    " Private - Initialize the receiver's cursors..."

    | cursor |
    cursors := Dictionary new.
    self class cursorNames
        do: [:each|
            cursor := CursorManager
                loadCursor: each
                fromDLL: ObjectStyleDLL library.
            cursors at: each
                put: (cursor notNil ifTrue: [ cursor]
                    ifFalse: [CursorManager normal]).
        ]!  
message: aString
    "Private - Show aString in the contents box"

    ^self message: aString in: #status! 
message: aString in: statusBox
    "Private - Show aString in the status box"

    | pane |
    pane := self statusPane.
    pane notNil
    ifTrue: [ (pane statusBoxAt: statusBox) contents: aString ]
    ifFalse: [ self label: self title,aString ]!  
minimumSelection
    "Private - Returns the minimum selection size"
    ^2@2!   
mouseMove: aPane

    "Callback for the #mouseMove event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    | point |
    point := aPane mouseLocation.
    selection notNil
    ifTrue: [
        (selection containsPoint: point)
        ifTrue: [ self graphPane setCursor: (self cursorFor: #move) ]
        ifFalse: [ self graphPane setCursor: (self cursorFor: #select) ]

    ]
    ifFalse: [ self graphPane setCursor: (self cursorFor: #hand) ].

    self message: point x asString,'|',point y asString.! 
promptForPath
    "Private - Prompt for a new image file name..."

    | answer dialog file |
    image isNil ifTrue: [^String new].
    dialog := FileDialog new.
    dialog
        title: 'Select a new image file name';
        fileSpec: path;
        hideReadonly;
        overwritePrompt;
        addFilter: '*.txt' description: 'Text Files (*.TXT)';
        addFilter: '*.*' description: 'All Files (*.*)';
        save.
    file := dialog file.
    file isNil ifTrue: [^String new].
    ^file!
save
    "Private - Write the image to file named path..."

    dirty := (image saveAs: path) notNil!  
saveConfirm
    "Private - Confirm to Save the current image, NO save or Cancel...
     Returns true if saved properly..."

    | answer |
    dirty ifFalse: [^true].

    answer := MessageBox
        titled: 'Image has been modified...'
        withText: 'Do you want to save changes ?' withCrs
        style: MbYesnocancel | MbIconquestion.

    answer = 7 ifTrue: [^true].             "NO"
    answer = 6 ifTrue: [ self fileSave ]. "YES"
     "Cancel..."

    ^dirty not!
selection: aRectangle
    "Private - Change the current selection to aRectangle..."

    self displaySelection.
    selection := aRectangle.
    self displaySelection.
    self checkToolBar.! 
selectionDoubleClickedAt: aPoint
    "Private - Perform action for doubleClick into the selection"

    "Default action is to do nothing..."!  
selectionEnds:aPane
    "Private - A selection operation has been done.
     aPane will have the #mode and #displacement"

    self checkSelection!   
selectionHasChanged
    "Private - The current selection has changed...
    The default action is to do nothing...
    This method can be refined by subclasses..."!   
selectionInProgress:aPane
    "Private - A selection operation is in progress.
     aPane will have the #mode and #displacement"

    "Default action is to do nothing.
    This method can be refined by subclasses..."!
selectionLineWidth
    "Private - Returns the current selection line width"
    ^1 "2"! 
selectionStarts: aPane
    "Private - Start with a new selection operation.
     aPane will have the #mode and #displacement"

    "Default action is to do nothing.
    This method can be refined by subclasses..."!   
setScrollRectangle: aPane

    "Callback for the #setScrollRectangle event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    image isNil ifTrue: [^self].
    aPane scrollingRectangle: image boundingBox.!
title
    "Private - Returns the receiver's title"

    ^self titleWithPath: path! 
updateView
    "Update the graph view"

    self graphPane invalidateRect: nil.
    "self setScrollRectangle: self graphPane."!   
useSelection
    "Private - Responds to if a selection can be done using the receiver...
    This method can be refined by subclasses"

    ^true! !

! LayerEditor class methods ! 
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (fileOpen 'Lee la capa desde un archivo...')
        (fileSave 'Graba capa de informacin.')
        (editLayerIcon 'Permite editar el cono de botonera para la capa de informacin...')
        (fullUpdate 'Refresca todos los datos...')
        (fileExit 'Cierra esta ventana.')

        (editNew 'Permite crear una nueva capa de informacion.')
        (edit 'Permite modificar la capa de informacion selecta.')
        (editUpdate 'Refresca la lista.')
        (editDelete 'Borra la capa de informacion selecta.')
        (editCategoryTool 'Permite editar el cono de botonera para la categora selecta...')

        (object 'Permite modificar el cono asociado a los objetos de la categora selecta.')
        (editCopy 'Copia el cono al clipboard.')
        (editPaste 'Coloca el bitmap del clipboard como cono de la categora selecta.')
        (editCapture 'Permite capturar un cono de la pantalla.')
        (objectErase 'Permite resetear el cono asociado a la categora selecta.')

        (toolHalt 'Halt...')
        (toolDebug 'Inspeccin de la ventana...')

        )!  
wbCreated

    ^true! !

! LayerEditor methods !  
boundingBox: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'BoundingBox').
     (Generated by WindowBuilder)"

    | box stream |
    box := layer boundingBox.
    stream := WriteStream on: String new.
    box extent > (0@0)
    ifTrue: [
        stream
            nextPutAll: box leftTop asString;
            nextPutAll: ' -> ';
            nextPutAll: box rightBottom asString;
            yourself.
    ].

    aPane contents: stream contents.!
categories: aPane

    "Callback for the #getContents event in an unnamed ListPane.
     (Generated by WindowBuilder)"

    | categories |
    categories := layer categories.
    aPane contents: (categories collect: [:each| each name]).
    selected := self categorySelected!   
categoryEdit: aPane

    "Callback for the #doubleClickSelect event in an unnamed ListPane.
     (Generated by WindowBuilder)"

    selected isNil ifTrue: [^self].
    (selected respondsTo: #editWith:)
    ifTrue: [ selected editWith: view ]
    ifFalse: [
        Smalltalk isRunTime ifFalse: [ ^selected inspect ].
        self beep
    ]!  
categorySelected
    " Private - returns the current selected category..."

    | categories item |
    categories := layer categories.
    item := (self paneAt: #categories:) selectedItem.
    ^categories detect: [:one| one name = item] ifNone: []!   
categorySelected: aPane

    "Callback for the #select event in an unnamed ListPane.
     (Generated by WindowBuilder)"

    | categories item |
    categories := layer categories.
    selected := self categorySelected.
    self
        changed: #editionTools:;
        changed: #iconExample:!   
computeBoundingBox: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    layer boundingBox: nil.
    self changed: #boundingBox:.!
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  '';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 594 @ 744; xC; yC; cRDU: (2 @ 742 rightBottom: 592 @ 40));
            pStyle: #(sysmenu titlebar minimize);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 535 @ 102; lDU: 27 r: #left; tDU: 172 r: #top);
                    contents: 'Seleccin'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 535 @ 84; lDU: 27 r: #left; tDU: 598 r: #top);
                    contents: 'Icono'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 562 @ 100; lDU: 14 r: #left; tDU: 48 r: #top);
                    in;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 501 @ 32; lDU: 23 r: #left; rDU: 523 r: #left; tDU: 56 r: #top; bDU: 88 r: #top);
                    rightJustified;
                    startGroup;
                    when: #getContents perform: #boundingBox:;
                    contents: 'BoundingBox'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 306 @ 54; lDU: 27 r: #left; rDU: 334 r: #left; tDU: 82 r: #top; bDU: 136 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Prioridad de dibujado (+Prioridad = +Abajo) :'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 210 @ 32; lDU: 331 r: #left; tDU: 636 r: #top);
                    startGroup;
                    when: #getContents perform: #useTransparence:;
                    when: #clicked perform: #toggleTransparence:;
                    contents: 'Transparentes'; font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                OSImagePane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 59 @ 52; lDU: 507 r: #left; rDU: 567 r: #left; tDU: 546 r: #top; bDU: 598 r: #top);
                    noBorders;
                    startGroup;
                    when: #getContents perform: #iconExample:;
                    when: #button1DoubleClick perform: #editIcon:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 562 @ 548; lDU: 14 r: #left; tDU: 146 r: #top);
                    contents: 'Categorias'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 222 @ 44; lDU: 347 r: #left; tDU: 98 r: #top);
                    min: 0;
                    max: 100;
                    contents: 50;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #setLevel:;
                    when: #valueChanged perform: #levelChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 475 @ 322; lDU: 27 r: #left; rDU: 503 r: #left; tDU: 278 r: #top; bDU: 600 r: #top);
                    defaultStyle;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #categories:;
                    when: #select perform: #categorySelected:;
                    when: #doubleClickSelect perform: #categoryEdit:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 402 @ 32; lDU: 43 r: #left; tDU: 202 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #toggleSelectAll:;
                    when: #getContents perform: #selectAll:;
                    contents: 'Seleccin Automtica de todas.'; font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 32; lDU: 43 r: #left; tDU: 234 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #toggleExclusive:;
                    when: #getContents perform: #exclusive:;
                    contents: 'Seleccin excluyente'; font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 48; lDU: 37 r: #left; rDU: 320 r: #left; tDU: 628 r: #top; bDU: 676 r: #top);
                    add: #object;
                    add: #editCopy;
                    add: #editPaste;
                    add: #editCapture;
                    add: #objectErase;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolPalette new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 59 @ 224; lDU: 507 r: #left; rDU: 567 r: #left; tDU: 278 r: #top; bDU: 502 r: #top);
                    add: #editNew;
                    add: #edit;
                    add: #editColor selector: #editCategoryTool;
                    add: #editUpdate;
                    add: #editDelete;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #editionTools:;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 43 @ 46; lDU: 526 r: #left; tDU: 52 r: #top);
                    bitmap: (CPBitmapDict at: 'compute');
                    startGroup;
                    tabStop;
                    when: #clicked perform: #computeBoundingBox:;
                    contents: ''; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 448 @ 48; lDU: 0 r: #left; rDU: 448 r: #left; tDU: 0 r: #top; bDU: 48 r: #top);
                    add: #fileOpen;
                    add: #fileSave;
                    add: #editColor selector: #editLayerIcon;
                    add: #editUpdate selector: #fullUpdate spaces: 3;
                    add: #toolDebug;
                    add: #toolHalt;
                    add: #fileExit;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
edit

    self categoryEdit: (self paneAt: #categories:)!   
editCapture
    "Lets the user capture the objects icon from screen..."

    | bmp |
    bmp := Bitmap fromUser.
    bmp isBitmap ifFalse: [^self beep].
    self layer iconFor: self selected is: bmp.
    self changed: #iconExample:.!  
editCategoryTool

    self selected isNil ifTrue: [^self beep].
    layer editToolFor: selected!   
editCopy
    "Lets the user copy the objects icon to clipboard..."

    Clipboard setBitmap: (self layer iconFor: self selected).! 
editDelete

    self beep.
    (MessageBox confirm: 'Seguro borra la categora ',self selected printString)
    ifFalse: [^self].

    layer removeCategory: selected.
    selected := nil.
    self fullUpdate.! 
editionTools: aPane

    "Callback for the #getContents event in an unnamed OSToolPalette.
     (Generated by WindowBuilder)"

    | toDisable tools toggle |
    toDisable := Set new.
    tools := #(editNew edit editUpdate editDelete editCategoryTool).
    self selected isNil
    ifTrue: [ toDisable addAll: #( edit editDelete editCategoryTool) ]
    ifFalse: [
        ((toggle := self paneAt: #selectAll:) notNil
        and: [ toggle selection = true ])
        ifTrue: [ toDisable add: #editSelect ].
    ].

    tools do: [:each|
        (toDisable includes: each)
        ifTrue: [ aPane disableItem: each ]
        ifFalse: [ aPane enableItem: each ]
    ]! 
editIcon: aPane

    "Callback for the #button1DoubleClick event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    self object! 
editLayerIcon

    layer editTool!  
editNew
    "Creates a new category for the layer..."
    | name |
    layer isNil ifTrue: [^self].
    name := OSPrompter prompt: 'Nombre de la nueva categora ?' default: String new.
    name isNil ifTrue: [^self].
    name trimBlanks isEmpty ifTrue: [^self].
    selected :=  layer addCategory: name.
    self changed: #categories: with: #restoreSelected: with: name.!   
editPaste
    "Lets the user paste the objects icon from clipboard..."

    | bmp |
    bmp := Clipboard getBitmap.
    bmp isBitmap ifFalse: [^self beep].
    self layer iconFor: self selected is: bmp.
    self changed: #iconExample:.!   
editUpdate

    self
        changed: #categories: with: #restoreSelected;
        changed: #editionTools:!   
exclusive: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Seleccion excluyente').
     (Generated by WindowBuilder)"!
fileOpen
    "Lets the user select a layer file and file it in..."

    | dialog file aLayer |

    dialog := FileDialog new.
    dialog
        title: 'Capa de informacin a leer...';
        addFilter: '*.lay' description: 'Capas de informacin (*.LAY)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        defFilter: '*.lay';fileSpec: '*.lay';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].
    (file includes: $.)
    ifFalse: [ file := file,'.Lay' ].

    aLayer := ObjectFiler loadFromPathName: file.
    aLayer isNil ifTrue: [ ^self error: 'El archivo no contiene objetos...' ].

    aLayer class == layer class
    ifFalse: [ ^self error: 'El archivo no contiene una capa de informacin compatible.' ].

    layer become: aLayer.
    selected := nil.
    self fullUpdate.!
fileSave
    "Lets the user save the selectedLayer in a new file..."

     | dialog file |
    layer isNil ifTrue: [^self beep ].
    file := File fileName: layer name extension: 'Lay'.
    dialog := FileDialog new.
    dialog
        title: 'Seleccione el archivo donde guardarlo...';
        addFilter: '*.lay' description: 'Capas de Informacin (*.LAY)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        fileSpec: file;
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].

    (file includes: $.) ifFalse: [ file := file,'.Lay' ].
    self backUpFile: file.

    CursorManager execute changeFor: [
        ObjectFiler dump: layer newFile: file.
        self updateTitle.
    ].
    ^file!
iconExample: aPane

    "Callback for the #getContents event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    | icon box |
    icon := self layer iconFor: self selected.
    aPane erase.
    icon isNil ifTrue: [^self].
    box := icon boundingBox translateBy: aPane pen boundingBox extent - icon boundingBox extent // 2.
    layer
        displayIcon: icon
        inside: box
        using: aPane pen.
    aPane pen
        place: box leftTop - 2;
        box: box rightBottom + 2!  
layer
    "Returns the instance var of the receiver
     for external manipulation"
    ^layer!
layer: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    layer := anObject!   
levelChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    layer level: aPane contents!   
message: aString
    "Private - Show aString in the contents box"

    ^self message: aString in: #status! 
message: aString in: statusBox
    "Private - Show aString in the status box"

    | pane |
    pane := self statusPane.
    pane notNil
    ifTrue: [
        (pane statusBoxAt: statusBox) contents: aString
    ]! 
object
    "Lets the user edit the objects icon..."

    self layer editIconFor: self selected!
objectErase
    "Lets the user reset the objects icon..."

    self layer iconFor: self selected is: nil.
    self changed: #iconExample:.!   
preInitWindow
    "Private - Preinitialize the receiver..."

    self updateTitle.!
selectAll: aPane

    "Callback for the #getContents event in an unnamed CP3DRadioButton (contents is 'Seleccion Automatica de todas.').
     (Generated by WindowBuilder)"!   
selected
    " Private - returns the current selected category..."

    ^selected := self categorySelected!
setLevel: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: layer level!
statusPaneHelp:aKey
    "Private - Answer the hint text to the StatusPane"

    | dict label pair value |
    label := [:selector :text|
        (text size = 0 or: [self respondsTo: selector])
        ifTrue: [ text ]
        ifFalse: [ text ,' *An no implementado [',selector,']*']
    ].

    self class helpMap do: [:pair |
        pair first asString = aKey asString
        ifTrue: [ ^label value: pair first value: pair last ]
    ].

    dict := Smalltalk at: #HelpStatusPane ifAbsent: [Dictionary new].
    value := dict at: aKey
        ifAbsent: [ dict at: aKey asSymbol ifAbsent: [ super statusPaneHelp: aKey ]].
    ^label value: aKey value: value!   
title
    "Private - Returns the title for the receiver's window"

    ^self titleWith: layer! 
toggleExclusive: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Seleccion excluyente').
     (Generated by WindowBuilder)"!  
toggleSelectAll: aPane

    "Callback for the #clicked event in an unnamed CP3DRadioButton (contents is 'Seleccion Automatica de todas.').
     (Generated by WindowBuilder)"! 
toggleTransparence: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Transparentes').
     (Generated by WindowBuilder)"

    self layer useTransparence: aPane selection.
    self changed: #iconExample:.!
toolHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := self statusPaneHelp: selector asString.
    text isNil ifTrue: [ text := String new ].
    self message: text!
useTransparence: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Transparentes').
     (Generated by WindowBuilder)"

    aPane selection: self layer useTransparence!  
view
    "Returns the instance var of the receiver
     for external manipulation"
    ^view!  
view: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    view := anObject! !

! LayerReader class methods !  
formats
    "Returns table formats..."
    Formats isNil ifTrue: [ self initializeFormats ].
    ^Formats! 
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (filePreview 'Muestra los datos de la tabla...')
        (viewHeader 'Permite ver informacin relativa a la table selecta.')
    )! 
initializeFormats
    "Private - Initialize table formats...
    LayerReader initializeFormats
    "

    Formats := #(
       "('Displayable Format Name' ('ext' 'parameters'))"
        ('dBase compatible' ('Dbf' 'DRV=QeDBF'))  "first format is the default format..."
        ('Btrieve' ('Btr' 'DRV=QeBTR'))
        ('Planillas Excel' ('Xls' 'DRV=QeXLS'))
        ('IBM DB2' ('DB' 'DRV=QeDB2;SRVR=?;UID=?;PWD=?;APP=Mapas'))
        ('Ingres' ('Ing' 'DRV=QeING;DB=?;UID=;OPTS=-1;SRVR=?'))
        ('NetWare SQL' ('Qlx' 'DRV=QeQLX;Files=?;Dict=?'))
        ('Oracle' ('Ora' 'DRV=QeOra;SRVR=?;UID=?;PWD=?'))
        ('OS/2' ('EE' 'DRV=QeEE;DB=?;UID=?;PWD=?'))
        ('Paradox' ('Pdx' 'DRV=QePDX'))
        ('Archivos de Texto' ('Txt' 'DRV=QeTXT'))
        ('XDB' ('Xdb' 'DRV=QeXDB;UID=?;PWD=?;SRVR=?'))
    )!
wbCreated

    ^true! !

! LayerReader methods !  
aborted: aBoolean
    "Set the aborted flag..."

    aborted := aBoolean.! 
accept: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Aceptar').
     (Generated by WindowBuilder)"

    | processBlock forkPriority fileInBlock forking |

    forkPriority := self forkPriority.
    processBlock := [
        self readTableDoing: fileInBlock.
        forking ifTrue: [ self close ]
    ].

    fileInBlock := [:dict|
        (self buildObjectFrom: dict) isNil
        ifTrue: [ self message: '*Error* leyendo ',(dict at: #name ifAbsent: [String new]) ]
    ].

    forking := (self paneAt: #forking:) selection.
    forking = true
    ifTrue: [
        reading := true.
        processBlock forkAt: forkPriority.
        self fullUpdate.
    ]
    ifFalse: [
        CursorManager execute
            changeFor: [ processBlock value ]
    ].!   
acceptButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Aceptar').
     (Generated by WindowBuilder)"

    self enable: aPane when: self canBeExecuted! 
browse: aPane
    "Lets the user select a file to be filedin..."

    | dialog file formats ext currentExt |

    dialog := FileDialog new.
    dialog title: 'Archivo de informacin a leer...'.

    currentExt := String new.
    formats := self class formats.
    formats do: [:each|
        ext := each last first.
        dialog
            addFilter: '*.',ext
            description: each first,' (*.',ext asUpperCase,')'.
        each first = format ifTrue: [
            currentExt := ext.
            dialog defFilter: '*.',ext;fileSpec: '*.',ext
        ]
    ].

    dialog
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].
    (file includes: $.)
    ifFalse: [ file := file,'.',currentExt ].

    (self paneAt: #pathName:)
        contents: file;
        selectAll.

    self fullUpdate.!
browseButton: aPane

    "Callback for the #getContents event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    self enable: aPane when: reading not!   
build: row using: columnNames
    "Private - Build a dictionary for informational instance creation from table..."

    | dict settings data |
    data := Dictionary new.
    1 to: row size do: [:i| data at: (columnNames at: i) put: (row at: i) ].
    dict := Dictionary new.
    (self configuration at: #settings) do: [:spec|
        dict
            at: spec first "instance-name"
            put: (self scan: spec last with: data)
    ].
    #(category layer) do: [:each|
        dict
            at: each asString
            put: (self scan: (self configuration at: each) with: data)
    ].
    ^dict!   
buildObjectFrom: dict
    "Private - Build anObject from dict..."

    | layerName categoryName object key position place |
    self map isNil ifTrue: [ ^nil ].

    position := dict at: #position ifAbsent: [ ^nil ].
    place := self pointFrom: position.
    place isNil ifTrue: [ ^nil ].

    layerName := dict at: 'layer' ifAbsent: [
        self layer notNil
        ifTrue: [self layer name]
        ifFalse: [ 'Informacin' ]
    ].
    (self layer notNil and: [layerName = self layer name])
    ifFalse: [ "find or build a layer..."
        self layer: (self map
            layerNamed: layerName
            ifAbsent: [ self map newLayer: layerName opaque: false ])
    ].
    self layer isNil ifTrue: [ ^nil ].

    categoryName := dict at: 'category' ifAbsent: ['General'].
    object := (Smalltalk at: (self configuration at: #class) ifAbsent: [Information]) new.
    (object class allInstVarNames collect: [:each| (each,':') asSymbol])
    do: [:selector|
        key := (selector asString upTo: $:) asSymbol.
        ((object respondsTo: selector) and: [ dict includesKey: key ])
        ifTrue: [ object perform: selector with: (dict at: key ifAbsent: []) ]
    ].

    (self layer canHold: object) ifFalse: [ ^nil ].

    self layer
        add: object
        at: place
        type: categoryName!
canBeConfigured
    "Private - True if the receiver can be configured."

    ^reading not and: [ (self paneAt: #pathName:) contents trimBlanks notEmpty ]! 
canBeExecuted
    "Private - True if the receiver can run..."

    ^self map notNil & configuration notNil and: [ self canBeConfigured ]!  
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    self close!   
close
    "Private - close the receiver"

    | speller |
    (configuration notNil
     and: [
        speller := configuration at: #speller ifAbsent: [].
        speller notNil])
    ifTrue: [ speller release ].

    ^super close!
configuration
    "Returns the instance var of the receiver
     for external manipulation"
    ^configuration!
configureButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Mapeo de Campos...').
     (Generated by WindowBuilder)"

    self enable: aPane when: self canBeConfigured! 
configureFields: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Mapeo de Campos...').
     (Generated by WindowBuilder)"

    | dialog |
    dialog := InformationReaderConfigurationDialog new.
    dialog
        parentDialog: self;
        open.
    dialog configuration notNil
    ifTrue: [
        configuration := dialog configuration.
        self fullUpdate.
    ].! 
configureSpeller: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Corrector de direcciones...').
     (Generated by WindowBuilder)"

    | dialog |
    dialog := SearchStreetConfigurationDialog new.
    dialog
        parentDialog: self;
        open.!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Lectura de disco...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 805 @ 456; xC; yC; cRDU: (2 @ 454 rightBottom: 802 @ 40));
            pStyle: #(sysmenu titlebar minimize);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 9 r: #left; rDU: 119 r: #left; tDU: 12 r: #top; bDU: 44 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Archivo:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 37 r: #left; rDU: 146 r: #left; tDU: 96 r: #top; bDU: 128 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Formato:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 34 r: #left; rDU: 144 r: #left; tDU: 148 r: #top; bDU: 180 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Params :'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPHorizontalBarGauge new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 462 @ 50; lDU: 23 r: #left; tDU: 306 r: #top);
                    min: 0;
                    max: 100;
                    contents: 0;
                    startGroup;
                    when: #getContents perform: #setPercent:;
                    foreColor: ClrDarkblue;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 56; lDU: 430 r: #left; rDU: 768 r: #left; tDU: 184 r: #top; bDU: 240 r: #top);
                    startGroup;
                    when: #getContents perform: #spellerButton:;
                    when: #clicked perform: #configureSpeller:;
                    contents: '  Mdulo de direcciones... '; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 40; lDU: 27 r: #left; tDU: 368 r: #top);
                    contents: (CPBitmapDict at: 'help icon');
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 704 @ 40; lDU: 73 r: #left; rDU: 777 r: #left; tDU: 368 r: #top; bDU: 408 r: #top);
                    startGroup;
                    when: #getContents perform: #notes:;
                    contents: 'Notas...'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 48; lDU: 656 r: #left; rDU: 775 r: #left; tDU: 244 r: #top; bDU: 292 r: #top);
                    add: #filePreview;
                    add: #viewHeader;
                    postAutomatic;
                    startGroup;
                    when: #showHelp perform: #toolHelp:;
                    when: #getContents perform: #toolbarContents:;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 768 @ 240; lDU: 18 r: #left; tDU: 56 r: #top);
                    contents: 'Opciones'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 603 @ 44; lDU: 128 r: #left; rDU: 731 r: #left; tDU: 8 r: #top; bDU: 52 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #pathName:;
                    when: #textChanged perform: #pathNameChanged:;
                    when: #characterInput perform: #pathNameChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 57 @ 44; lDU: 736 r: #left; tDU: 8 r: #top);
                    bitmap: (CPBitmapDict at: 'browse');
                    startGroup;
                    tabStop;
                    when: #getContents perform: #browseButton:;
                    when: #clicked perform: #browse:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 615 @ 248; lDU: 155 r: #left; rDU: 770 r: #left; tDU: 86 r: #top; bDU: 334 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #formats:;
                    when: #select perform: #formatSelect:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 613 @ 44; lDU: 155 r: #left; rDU: 768 r: #left; tDU: 136 r: #top; bDU: 180 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #parameters:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 274 @ 56; lDU: 153 r: #left; rDU: 427 r: #left; tDU: 184 r: #top; bDU: 240 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #configureButton:;
                    when: #clicked perform: #configureFields:;
                    contents: 'Mapeo de Campos...'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 347 @ 32; lDU: 155 r: #left; tDU: 248 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #forking:;
                    contents: 'Procesamiento en paralelo.'; font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 149 @ 56; lDU: 491 r: #left; rDU: 640 r: #left; tDU: 304 r: #top; bDU: 360 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #acceptButton:;
                    when: #clicked perform: #accept:;
                    contents: 'Aceptar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 647 r: #left; rDU: 793 r: #left; tDU: 304 r: #top; bDU: 360 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).! 
currentFormat
    "Private - Returns the current format parameters"

    ^self formatSpec: format! 
fieldEpilogue
    "Private - Returns the field epilogue character..."

    ^$>!
fieldPrologue
    "Private - Returns the field prologue character..."

    ^$<!
filePreview
    "Hace un dump del contenido de la tabla..."
    | monitor dumpBlock count |

    count := 1.
    dumpBlock := [:dict|
      monitor cr;nextPutAll: 'Registro #',count asString,' Capa:',(dict at: 'layer'),' categora:',(dict at: 'category').
      (dict keys asArray select: [:one| one isSymbol ])
        asSortedCollection do: [:key|
        monitor
            cr;next: 4 put: $ ;nextPutAll: key asString ,' >> ',(dict at: key ifAbsent: []) asString;
            yourself
        ].
        count := count + 1.
    ].

    CursorManager execute changeFor: [
        monitor := TextWindow
            windowLabeled: 'Datos en tabla : ',self pathName
            frame: ((Display width // 2 @ 0 rightBottom: Display extent) insetBy: 5).
        self readTableDoing: dumpBlock.
    ].!  
forking: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Procesamiento en paralelo').
     (Generated by WindowBuilder)"

    self enable: aPane when: self canBeConfigured!
forkPriority
    "Private - returns the priority used for forked reading."

    ^Processor userPriority " - 1 "!   
forkToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Procesamiento en paralelo').
     (Generated by WindowBuilder)"!  
formats
    "Private - Returns all the registered formats"

    ^self class formats!   
formats: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    aPane contents: (self formats collect: [:each| each first ]).
    self enable: aPane when: self canBeConfigured.
    aPane selection: format.!
formatSelect: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    format := aPane selectedItem.
    self changed: #acceptButton:.

    (self paneAt: #parameters:) contents: String new.
    self changed: #parameters:.! 
formatSpec: aFormatName
    "Private - Returns the format specification for format
     named aFormatName"

    ^(self formats
        detect: [:one| one first = aFormatName ]
        ifNone: [ #('Formato desconocido' ('' '')) ]) last! 
hasBeenAborted
    "Private - True if the receiver has been aborted..."

    ^aborted or: [ self hasBeenClosed ]!  
hasBeenClosed
    "Private - True if the receiver has been closed..."

    ^views size = 0!
initialize
    "Private - Initializes the receiver"

    super initialize.
    reading := aborted := false.
    format := self formats first first. "set to default format..."!  
layer
    "Returns the instance var of the receiver
     for external manipulation"
    ^layer!
layer: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    layer := anObject!   
map
    "Returns the instance var of the receiver
     for external manipulation"
    ^map!
map: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    map := anObject!   
message: aString
    "Private - Notify aString message"

    | pane |
    pane := self paneAt: #notes:.
    pane isNil ifTrue: [ ^nil ].
    pane contents: aString asString.!  
notes: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Notas...').
     (Generated by WindowBuilder)"

    | pathName |
    pathName := self pathName.
    aPane contents: (pathName size = 0
        ifTrue: ['Seleccione un archivo a leer (usando el botn del disco).']
        ifFalse: [
            reading = true
            ifTrue: [ 'Leyendo : ', pathName ]
            ifFalse: [String new]
        ])!
parameters: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    aPane contents size = 0
    ifTrue: [ aPane contents: self currentFormat last ].
    self enable: aPane when: self canBeConfigured.! 
pathName
    "Returns the current pathName..."

    ^(self paneAt: #pathName:) contents!   
pathName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    self enable: aPane when: reading not!
pathNameChanged: aPane

    "Callback for the #textChanged event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    ((Array with: Tab with: Cr) includes: aPane lastCharacterInput)
    ifTrue: [ ^(self paneAt: #browseButton:) setFocus ].

    self fullUpdate.!
percent: aValue
    "Set the percent gauge to aValue..."

    | pane |
    pane := self paneAt: #setPercent:.
    pane isNil ifTrue: [ ^self ].
    pane contents: aValue asInteger!
percentBetween: min and: max
    "Set lo & hight values for percent bar-gauge..."

    (self paneAt: #setPercent:)
        min: min asInteger;
        max: max asInteger;
        contents: min asInteger! 
pointFrom: aString
    "Private - Returns the place for an object;
     obtained from aString..."

    | useAddress stream streets speller result |
    (aString isNil or: [ self map isNil]) ifTrue: [^nil].
    aString trimBlanks isEmpty ifTrue: [^nil].

    useAddress := self configuration at: #useAddress ifAbsent: [true].

    useAddress ifTrue: [
        speller := self speller.
        speller returns: #point.
        streets := self map streets.
        streets isNil ifTrue: [ ^nil ].
        result := streets find: aString using: speller.
        aborted := aborted or: [ speller cancelled ].
        ^result
    ].

    stream := ReadStream on: aString.
    ^stream nextWord asInteger @ stream nextWord asInteger!
readTableDoing: aBlock
    "Read selected table doing aBlock with each record readed.
    aBlock must be a one-argument block that will be valued
     with aDictionary of instanceName>>value pairs.
    where instanceName will be the name for an instance
    variable and value will be the current record value"

    | table row |
    reading := true.aborted := false.
    table := RelationalTable new open: self pathName.
    self percentBetween: 0 and: (table size max: 1).
    1 to: table size do: [:i|
      self hasBeenAborted
      ifFalse: [
        row := (table at: i) collect: [:each | each trimBlanks].
        aBlock value: (self build: row using: table columnNames).
        self
            message: 'Registros procesados: ', i printString;
            percent: i.
        Processor yield.
      ]
    ].
    table close.
    reading := false.
    self hasBeenClosed
    ifTrue: [ self message: 'Procesamiento cancelado...' ]
    ifFalse: [ self message: 'Procesamiento finalizado.' ].
    self percent: 0.!   
scan: text with: data
    "Private - Scan field-source text and replace fields with data in data-dictionary..."

    | output input field |
    input := ReadStream on: text.
    output := WriteStream on: String new.
    [input atEnd] whileFalse: [
        output nextPutAll: (input upTo: self fieldPrologue).
        input atEnd ifFalse: [
            field := (input upTo: self fieldEpilogue) trimBlanks asUpperCase.
            field isEmpty ifFalse: [
                output nextPutAll: (data at: field ifAbsent: [ field ])
            ].
        ]
    ].
    ^output contents!   
setPercent: aPane

    "Callback for the #getContents event in an unnamed CPHorizontalBarGauge.
     (Generated by WindowBuilder)"

    self enable: aPane when: self canBeConfigured not.!  
speller
    "Returns the current speller in use (or creates a new one)...
     Returns nil if failed..."

    configuration isNil ifTrue: [^nil].
    ^configuration at: #speller
        ifAbsent: [ self speller: AddressFinder new ]!
speller: anObject
    "Sets the current speller in use..."

    ^configuration at: #speller put: anObject! 
spellerButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Corrector de direcciones...').
     (Generated by WindowBuilder)"

    self
        enable: aPane
        when: (self canBeConfigured & configuration notNil
                         and: [ (configuration at: #useAddress) = true ])! 
statusPaneHelp:aKey
    "Private - Answer the hint text to the StatusPane"

    | dict label pair value |
    label := [:selector :text|
        (text size = 0 or: [self respondsTo: selector])
        ifTrue: [ text ]
        ifFalse: [ text ,' [',selector,']']
    ].

    self class helpMap do: [:pair |
        pair first asString = aKey asString
        ifTrue: [ ^label value: pair first value: pair last ]
    ].

    dict := Smalltalk at: #HelpStatusPane ifAbsent: [Dictionary new].
    value := dict at: aKey
        ifAbsent: [ dict at: aKey asSymbol ifAbsent: [ super statusPaneHelp: aKey ]].
    ^label value: aKey value: value! 
toolbarContents: aPane

    "Callback for the #getContents event in an unnamed OSToolBar.
     (Generated by WindowBuilder)"

    self canBeExecuted
    ifTrue: [ #(filePreview viewHeader) do: [:tool| aPane enableItem: tool ] ]
    ifFalse: [ #(filePreview viewHeader) do: [:tool| aPane disableItem: tool ] ]!  
toolHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := self statusPaneHelp: selector asString.
    text isNil ifTrue: [ text := String new ].
    self message: text!
viewHeader
    "Lets the user view the table header & another information."

    | monitor table names types widths |

    CursorManager execute changeFor: [
        monitor := TextWindow
            windowLabeled: 'Datos en tabla : ',self pathName
            frame: ((Display width // 2 @ 0 rightBottom: Display extent) insetBy: 5).
        monitor cr;nextPutAll: 'Abriendo la tabla ',self pathName.
        table := RelationalTable new open: self pathName.
        monitor
            cr;show: 'Conexin:',table conectionString asString;
            cr;show: 'Cantidad de registros:',table size asString;
            cr;show: 'Descripcin de campos:';
            yourself.

        names := table columnNames.
        types := table columnTypes.
        widths := table columnWidths.
        1 to: names size do: [:i|
            monitor
                cr;space;space;
                nextPutAll: i asString,' = ',(names at: i) asString  " ,
                        '[',(types at: i) asString,':',(widths at: i) asString,']' "
        ].
        monitor cr;show: 'Cerrando la tabla.'.
        table close.
    ].! !

! LogoView class methods !
wbCreated

    ^true! !

! LogoView methods ! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Object Style';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 832 @ 396; xC; yC; cRDU: (2 @ 394 rightBottom: 830 @ 40));
            pStyle: #(sysmenu titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 384 @ 252; lDU: 11 r: #left; tDU: 10 r: #top);
                    contents: (CPBitmapDict at: 'LogoView');
                    startGroup;
                    when: #getContents perform: #fillPicture:;
                    backColor: ClrBackground;
                    yourself
            );
            addSubpane: (
                StaticText3D new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 366 @ 66; lDU: 21 r: #left; rDU: 386 r: #left; tDU: 272 r: #top; bDU: 338 r: #top);
                    startGroup;
                    when: #getContents perform: #fillVersion:;
                    contents: '';
                    font: (
                        Font new
                        fromBytes: #( 229 255 0 0 0 0 0 0 188 2 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 299 @ 282; lDU: 501 r: #left; rDU: 800 r: #left; tDU: 46 r: #top; bDU: 328 r: #top);
                    startGroup;
                    when: #getContents perform: #fillTheTipOfTheDay:;
                    contents: ''; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 71 @ 84; lDU: 423 r: #left; tDU: 42 r: #top);
                    contents: (CPBitmapDict at: 'TipOfTheDay');
                    startGroup;
                    backColor: ClrBackground;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 409 @ 330; lDU: 407 r: #left; tDU: 12 r: #top);
                    contents: 'Saba Ud que...'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
fillPicture: aPane

    "Callback for the #getContents event in an unnamed CPBitmapPane.
     (Generated by WindowBuilder)"

    picture notNil ifTrue: [ aPane contents: picture ].!
fillTheTipOfTheDay: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '').
     (Generated by WindowBuilder)"

    | tip contents |
    tip := TipOfTheDay forToday.
    contents := (tip isNil or: [ tip contents size = 0])
    ifTrue: [
        aPane centered.
        ('El sistema ha sido desarrollado por:\',
        '\Object Style\Soler 4545 - Capital\',
        'Buenos Aires\Argentina\\Tel/Fax. (54)-1-833-3363') withCrs ]
    ifFalse: [ tip contents ].

    tip centered
    ifTrue: [ aPane centered ].

    aPane contents: contents!  
fillVersion: aPane

    "Callback for the #getContents event in an unnamed StaticText3D (contents is '').
     (Generated by WindowBuilder)"

    product notNil ifTrue: [ self label: product ].
    version notNil
    ifTrue: [ aPane contents: 'Version: ',version ]
    ifFalse: [ aPane contents: 'Version: 1.0' ].!
initialize
    " Private - Initialize the receiver"

    | system |
    super initialize.
    system := ApplicationSystem system.
    system isNil ifFalse: [
        version := system version.
        product := system product.
    ].!  
picture: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    picture := anObject!   
product: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    product := anObject!   
version: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    version := anObject! !

! LumiBusView class methods !
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (fileExit 'Cierra esta ventana.')

        (editSelect 'Activa modo de agregado de lneas.')
        (editSelect 'Activa modo de borrado de lneas.')
        (edit 'Permite editar el medio de transporte selecto.')

        (viewZoomIn 'Agranda tamao de las celdas.')
        (viewZoomOut 'Disminuye tamao de las celdas')

        (toolHalt 'Halt en la ventana [debug]...')
        (toolDebug 'Inspeccin de la ventana [debug]...')
        )!
wbCreated

    ^true! !

! LumiBusView methods !  
addressFor: aPoint
    " Private - Returns the address for the currently selected bus..."


    ^self currentSheet asString,'-',
        (String with: ('ABCDEFGHI' at: aPoint y)),'-',
        aPoint x asString!  
busCompany: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    "do nothing here..."!  
button1DoubleClick: aPane

    "Callback for the #button1DoubleClick event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self edit.!  
button1Down: aPane

    "Callback for the #button1Down event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self markFocus: aPane.
    aPane propertyAt: #cell put: focus.!   
button1Move: aPane

    "Callback for the #button1Move event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self markFocus: aPane.!
button1Up: aPane

    "Callback for the #button1Up event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | origin destination |
    self markFocus: aPane.
    destination := focus.
    origin := aPane propertyAt: #cell.
    origin isNil ifTrue: [^nil].
    aPane propertyAt: #cell put: nil."focus"

    origin = destination "do nothing..."
    ifTrue: [
        net add: self bus at: (self addressFor: origin).
        ^self
    ].

    destination isNil "remove..."
    ifTrue: [
        net remove: self bus from: (self addressFor: origin) ifAbsent: [].
        ^self
    ].

    "user want to move bus..."
    net
        move: self bus
        from: (self addressFor: origin)
        to: (self addressFor: destination).! 
coordinatesFor: aPoint
    " Private - Returns the collumn@row cell under aPoint or nil if none"

    | cell |
    cell := aPoint // zoom + 1.
    (cell x between: 1 and: 6) ifFalse: [^nil].
    (cell y between: 1 and: 9) ifFalse: [^nil].
    ^cell!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Medios de Transporte';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 969 @ 800; xC; yC; cRDU: (2 @ 798 rightBottom: 967 @ 40));
            pStyle: #(sysmenu titlebar minimize);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 32; lDU: 46 r: #left; rDU: 146 r: #left; tDU: 64 r: #top; bDU: 96 r: #top);
                    startGroup;
                    contents: 'Plano#';
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 905 @ 610; lDU: 50 r: #left; rDU: 955 r: #left; tDU: 138 r: #top; bDU: 748 r: #top);
                    noBorders;
                    startGroup;
                    when: #getContents perform: #sheetCells:;
                    when: #button1DoubleClick perform: #button1DoubleClick:;
                    when: #button1Down perform: #button1Down:;
                    when: #button1Move perform: #button1Move:;
                    when: #display perform: #displayCells:;
                    when: #mouseMove perform: #mouseMove:;
                    when: #button1Up perform: #button1Up:;
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 610; lDU: 11 r: #left; rDU: 48 r: #left; tDU: 138 r: #top; bDU: 748 r: #top);
                    noBorders;
                    startGroup;
                    when: #getContents perform: #sheetColumns:;
                    when: #display perform: #displayColumns:;
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 905 @ 34; lDU: 50 r: #left; rDU: 955 r: #left; tDU: 102 r: #top; bDU: 136 r: #top);
                    noBorders;
                    startGroup;
                    when: #getContents perform: #sheetRows:;
                    when: #display perform: #displayRows:;
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 965 @ 48; lDU: 0 r: #left; rDU: 965 r: #left; tDU: 0 r: #top; bDU: 48 r: #top);
                    add: #fileOpen;
                    add: #fileSave;
                    add: #edit spaces: 3;
                    add: #viewZoomIn spaces: 3;
                    add: #viewZoomOut;
                    add: #editUpdate;
                    add: #fileExit spaces: 5;
                    postAutomatic;
                    startGroup;
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 293 r: #left; rDU: 384 r: #left; tDU: 64 r: #top; bDU: 96 r: #top);
                    startGroup;
                    contents: 'Lnea:';
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 32; lDU: 686 r: #left; rDU: 786 r: #left; tDU: 64 r: #top; bDU: 96 r: #top);
                    startGroup;
                    contents: 'Ramal:';
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 46; lDU: 146 r: #left; tDU: 48 r: #top);
                    min: 32;
                    max: 62;
                    contents: 32;
                    startGroup;
                    when: #getContents perform: #sheetNumberContents:;
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 200; lDU: 786 r: #left; rDU: 942 r: #left; tDU: 48 r: #top; bDU: 248 r: #top);
                    dropDown;
                    startGroup;
                    when: #getContents perform: #ramal:;
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 592; lDU: 393 r: #left; rDU: 677 r: #left; tDU: 48 r: #top; bDU: 640 r: #top);
                    dropDown;
                    startGroup;
                    when: #getContents perform: #busCompany:;
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    yourself
            );
        yourself
    ).! 
currentBus
    " Private - Returns the current bus selected (or nil if absent)"

    | text |
    text := (self paneAt: #busCompany:) contents.
    (text isNil or: [text trimBlanks isEmpty]) ifTrue: [^nil].
    ^net get: BusLine named: text!   
currentRamal
    " Private - Returns the current bus ramal selected (or nil if absent)"

    | text |
    text := (self paneAt: #ramal:) contents.
    (text isNil or: [text trimBlanks isEmpty]) ifTrue: [^nil].
    ^text!
currentSheet
    " Private - Returns the current sheet"

    ^(self paneAt: #sheetNumberContents:) value!  
displayCells: aPane

    "Callback for the #display event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen numberOfColumns numberOfRows |
    aPane erase.
    numberOfColumns := 6.
    numberOfRows := 9.
    pen := aPane pen.
    pen
        backColor: aPane backColor;
        yourself.
    0 to: numberOfColumns do: [:x|
        pen
            place: x @ 0 * zoom;
            goto: x @ numberOfRows * zoom;
            yourself
    ].
    0 to: numberOfRows do: [:y|
        pen
            place: 0 @ y * zoom;
            goto: numberOfColumns @ y * zoom;
            yourself
    ].!  
displayColumns: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen |
    aPane erase.
    pen := aPane pen.
    pen
        backColor: aPane backColor;
        place: 10@ (zoom y // 2 + pen font height).
    'ABCDEFGHI' do: [:c|
        pen
            centerText: (String with: c);
            place: pen location + (0@ zoom y)
    ].!   
displayRows: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen |
    aPane erase.
    pen := aPane pen.
    pen
        place: zoom x // 2 @(pen font height + 2);
        backColor: aPane backColor;
        yourself.
    1 to: 6 do: [:i|
        pen
            centerText: i asString;
            place: pen location + (zoom x @ 0)
    ].! 
edit

    self notImplementedYet!   
editUpdate

    self fullUpdate!
initialize
    " Private - Initializes the receiver..."

    super initialize.
    zoom := 60@33.
    net := TransportationNet new.! 
mapView: aMapView
    "Set the receiver for working with current map view Bus-Net"

    self sheets: aMapView map transportation!  
markFocus: aPane
    "Private - Mark the focus cell and update it to current mouse location"

    | pen newPos |
    pen := aPane pen.
    pen isNil ifTrue: [^self].

    newPos := self coordinatesFor: aPane mouseLocation.

    focus isNil ifFalse: [
        self withBox: focus do: [:box|
            pen
                reverse: (box insetBy: 3);
                yourself
        ]
    ].
    focus := newPos.

    focus isNil ifFalse: [
        self withBox: focus do: [:box|
            pen
                reverse: (box insetBy: 3);
                yourself
        ]
    ].!  
message: aString
    "Private - Show aString in the contents box"

    ^self message: aString in: #status! 
message: aString in: statusBox
    "Private - Show aString in the status box"

    | pane |
    pane := self statusPane.
    pane notNil
    ifTrue: [
        (pane statusBoxAt: statusBox) contents: aString
    ]! 
mouseMove: aPane

    "Callback for the #mouseMove event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen newPos |
    pen := aPane pen.
    pen isNil ifTrue: [^self].

    newPos := self coordinatesFor: aPane mouseLocation.
    hightLight = newPos ifTrue: [^self].

    hightLight isNil ifFalse: [
        self withBox: hightLight do: [:box|
            pen
                setRop2: R2Notxorpen;
                place: box leftTop + 1;
                box: box rightBottom - 1;
                setRop2: R2Copypen;
                yourself
        ]
    ].
    hightLight := newPos.

    hightLight isNil ifFalse: [
        self withBox: hightLight do: [:box|
            pen
                setRop2: R2Notxorpen;
                place: box leftTop + 1;
                box: box rightBottom - 1;
                setRop2: R2Copypen;
                yourself
        ]
    ].! 
ramal: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    "do nothing here..."!   
sheetCells: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    hightLight := nil.
    self displayCells: aPane.!  
sheetColumns: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self displayColumns: aPane.!  
sheetNumberContents: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    "do nothing here..."!
sheetRows: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self displayRows: aPane.!
statusPaneHelp:aKey
    "Private - Answer the hint text to the StatusPane"

    | dict label pair value |
    label := [:selector :text|
        (text size = 0 or: [self respondsTo: selector])
        ifTrue: [ text ]
        ifFalse: [ text ,' *An no implementado [',selector,']*']
    ].

    self class helpMap do: [:pair |
        pair first asString = aKey asString
        ifTrue: [ ^label value: pair first value: pair last ]
    ].

    dict := Smalltalk at: #HelpStatusPane ifAbsent: [Dictionary new].
    value := dict at: aKey
        ifAbsent: [ dict at: aKey asSymbol ifAbsent: [ super statusPaneHelp: aKey ]].
    ^label value: aKey value: value!   
toolHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := self statusPaneHelp: selector asString.
    text isNil ifTrue: [ text := String new ].
    self message: text!
viewZoomIn

    zoom := zoom + 3.
    self fullUpdate! 
viewZoomOut

    (zoom x min: zoom y) - 3 > 10
    ifTrue: [ zoom := zoom - 3 ]
    ifFalse: [ ^self beep ].
    self fullUpdate!
withBox: cell do: aBlock
    "Private - Evaluates aBlock with boundingBox of cell..."

    | box |
    box := 0@0 + 1 extent: zoom.
    aBlock value: (box translateBy: cell - 1 * zoom).! !

! MainToolBar class methods !
open
    ^self new open! 
profiler
    "Private - Returns the profiler for the receiver.
     Or nil..."
    | profiler |
    profiler := StartUpApplication profiler. "Ojo que esto esta bien... (no heredar de OSViewManager)"
    profiler applicationName: self name.
    ^profiler! !

! MainToolBar methods ! 
addTools: aCollection
    "Build the tools in the receiver with the specification in aCollection.
     See tools initialization in the receiver's class..."

    | aTool space owner bitmap module |
    space := 6.
    aCollection do: [:group|
        space = 0 ifTrue: [space := 11].
        group do: [:each|
            (each isKindOf: Tool)
            ifTrue: [ aTool := each ]
            ifFalse: [
                module := ObjectStyleDLL library.
                bitmap :=  each at: 1.
                owner := each at: 2.
                owner == #self ifTrue: [owner := self].
                (owner isSymbol and: [ owner first isUpperCase])
                ifTrue: [owner := Smalltalk at: owner ifAbsent: [owner]].
                (bitmap isEmpty and: [owner respondsTo: #icon])
                ifTrue: [bitmap := owner icon]
                ifFalse: [
                    (bitmap isEmpty and: [owner isBehavior])
                    ifTrue: [bitmap := owner symbol]
                ].
                aTool := self toolFrom: module icon: bitmap.
                aTool
                    selector: (each at: 3);
                    owner: owner;
                    yourself.
                space = 0 ifFalse: [
                    aTool space: space.
                    space := 2
                ].
            ].
            tools add: aTool.
        ].
        space := 0.
    ].!
alwaysOnTop
    "Returns the instance var of the receiver
     for external manipulation"
    ^alwaysOnTop!
alwaysOnTop: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    alwaysOnTop := anObject!   
autoSave
    "Private - Perform autosaving service..."

    | current |
    current := Notifier findWindow: WindowHandle queryActive.
    (current notNil and: [current owner respondsTo: #save])
    ifTrue: [
        self mainView setWindowText: 'autoSaving...',current class name.
        current owner save.
        self mainView setWindowText: self label.
    ].!   
autoSaveFrecuency
    "Returns the instance var of the receiver
     for external manipulation"
    ^autoSaveFrecuency!
autoSaveFrecuency: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    autoSaveFrecuency := anObject!   
basicClose
    "Private - Perform default close"
    ^super close!  
bringToTop
    "Private - Bring the receiver's topView to top"

    UserLibrary
        setWindowPos: self mainView handle
        insertAfter: (WinHandle fromInteger: 16rFFFF)
        x: 0    y: 0    cx: 0    cy: 0
        flags: SwpNoactivate | SwpNomove | SwpNosize!  
buildTools: aPane
    "Private - Fillin the ToolPane."

    aPane
        height: self height;
        contents: tools.! 
close
    "Private - Perform receiver closing action"

    | profiler pos |
    self releaseTimer.
    whenClose notNil ifTrue: [whenClose value].
    ((profiler := self profiler) notNil
        and: [self mainView minimized not])
    ifTrue: [
        pos := self mainView frameRectangle origin.
        profiler
            at: #origin
            put: (pos x printString,' ',pos y printString)
    ].
    ^super close!   
closeMe: aPane
    "Private - Perform receiver closing action"
    self close!  
cxBorder
    "Private - Returns the cxBorder value."

    #platformDependent.
    ^WinInfo cxBorder!  
cyCaption
    "Private - Returns the cyCaption value."

    #platformDependent.
    ^WinInfo cyCaption!   
exitWhenClosed
    "Perform Smalltalk exit when closed"

    self whenClose: [
        Smalltalk isRunTime ifTrue: [Smalltalk exit]
    ].!  
extent
    "Returns the receiver's computed extent"
    ^self width @ (SysFont height + self height)!   
height
    "Private - Returns the ToolPane height."

    height isNil ifFalse: [^height].
    height := 0.
    tools do: [:each| height := height max: each extent y].
    height := height + 8.
    ^height!  
initialize
    "Private - Initialize the receiver"

    | profiler |
    super initialize.
    label := self class name.
    tools := OrderedCollection new.
    alwaysOnTop := false.
    autoSaveFrecuency := 0.
    lastSaveTime := Time now asSeconds.

    profiler := self profiler.
    profiler isNil
    ifFalse: [
        alwaysOnTop := (profiler at: #alwaysOnTop ifAbsent: [false]) = true asString.
        autoSaveFrecuency := (profiler at: #autoSaveFrecuency ifAbsent: [0]) asInteger.
    ].!
initWindowSize
    "Private - Returns the window size for the main view"

    | origin profiler stream |
    profiler := self profiler.
    profiler isNil
    ifTrue: [ origin := Display width - self width // 2 @ 0 ]
    ifFalse: [
        stream := ReadStream on: (profiler at: #origin).
        stream atEnd
        ifTrue: [origin := Display width - self width // 2 @ 0]
        ifFalse: [
            origin := stream nextWord asInteger @ stream nextWord asInteger
        ].
    ].
    ^origin extent: self extent!
label
    "Returns the instance var of the receiver
     for external manipulation"
    ^label!
label: aString
    "Sets the receiver's label"
    label := aString.
    views size > 0
    ifTrue: [ super label: aString ]! 
open
    "Open the receiver Window.
     *WARNING* This code isNot WindowBuilder compatible.
      DON'T edit this code with WB"

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  self label;
            noSmalltalkMenuBar;
            pStyle: #(sysmenu titlebar minimize);
            when: #validated perform: #validate:;
            when: #close perform: #closeMe:;
            when: #timer perform: #tic:;
            backColor: ClrPalegray;
            addSubpane: (
                self toolPaneClass new
                    owner: self;
                    when: #getContents perform: #buildTools:;
                    yourself
            );
        yourself
    ).

    self
        openWindow;
        setTimer.

    alwaysOnTop ifTrue: [self bringToTop].!   
openWorkspace
    "Private - Open a workSpace"

    ^self mainView openWorkspace!  
releaseTimer
    "Private - Release the timer resource"

    Time
        stopTimer: 7 "only a timer"
        forWindow: self mainView!  
setTimer
    "Private - Set the timer resource"

    Time
        startTimer: 7 "only a timer"
        period: 1000 "attend each second..."
        forWindow: self mainView!   
statusBox
    "The receiver has no status box"
    ^nil!
tic: topPane
    "Private - Process the timer tic message"

   autoSaveFrecuency > 0 ifFalse: [^self].

    Time now asSeconds - lastSaveTime > autoSaveFrecuency
    ifTrue: [
        lastSaveTime := 99999999. "secure for non recursive savings..."
        self autoSave.
        lastSaveTime := Time now asSeconds
    ].!   
toolFrom: module icon: iconName
    "Private - Build aTool from an icon iconName in module module"

    | bitmap icon tool box anIcon |
    iconName isString
        ifTrue: [anIcon := Icon fromModule: module id: iconName]
        ifFalse: [anIcon := iconName].
    bitmap := Bitmap screenExtent: (anIcon extent x * 2 @ anIcon extent y).
    bitmap pen fill: self colorButtonFace.
    box := 0@0 extent: anIcon extent.

    box := box insetBy: 1.
    bitmap pen
        white;
        place: box origin;goto: box right @ box top;
        place: box origin;goto: box left @ box bottom;
        foreColor: self colorButtonShadow;
        place: box corner;goto: box right @ box top;
        place: box corner;goto: box left @ box bottom;
        place: box corner - 1; goto: box right - 1 @ (box top + 1);
        place: box corner - 1; goto: box left + 1 @ (box bottom - 1);
        black;
        place: box origin - 1;
        box: box corner + 1.

    UserLibrary
        drawIcon: bitmap pen handle
        x: 0 y: 0 hIcon: anIcon handle.

    box := 0@0 extent: anIcon extent.
    box := box translateBy: anIcon extent x @ 0.

    box := box insetBy: 1.

    bitmap pen
        foreColor: self colorButtonShadow;
        place: box origin;goto: box right @ box top;
        place: box origin;goto: box left @ box bottom;
        black;
        place: box origin - 1;
        box: box corner + 1.

    UserLibrary
        drawIcon: bitmap pen handle
        x: box left y: box top
        hIcon: anIcon handle.

    tool := (Tool
        fromBitmap: bitmap)
        extent: anIcon extent;
        yourself.
    anIcon release.
    ^tool!  
toolPaneClass
    "Private - Answer the class for the tool pane."

    ^ToolPane!  
tools
    "Returns the instance var of the receiver
     for external manipulation"
    ^tools!
toolsHasChanged
    "The tools has been changed, resize the receiver for
    holding the new tools..."

    tools := (self paneAt: #buildTools:) contents.
    width := height := nil. "force to recompute extent..."
    self mainView moveWindowTo:
        (self mainView frameRectangle leftTop extent: self extent).! 
topPaneClass
    "Private - Answer the default top pane class."
    ^Smalltalk
        at: #TopmostTopPane
        ifAbsent: [TopAppPane]!
validate: aPane
    "Private - Callback for the #validated event in the TopPane.
     The toolBar will be initialized here, with no scroll bars."

    | toolBar |

    toolBar := self paneAt: #buildTools:.
    toolBar style: WsBorder | WsChild | WsVisible | WsClipsiblings | WsClipchildren.
    UserLibrary
        setScrollRange: toolBar asParameter
        bar: SbHorz
        min: 0
        max: 0
        redraw: false.
    UserLibrary
        setScrollRange: toolBar asParameter
        bar: SbVert
        min: 0
        max: 0
        redraw: false.!  
whenClose: aBlock
    "Sets the action to be evaluated when
     the receiver will be closed"
    whenClose := aBlock! 
width
    "Private - Returns the receiver's width."

    width isNil ifFalse: [^width].
    width := 0.
    tools do: [:each|
        width := width + each extent x
            + (each space notNil
                ifTrue: [each space]
                ifFalse: [0] )
    ].
    width := width max:
          self cyCaption "botones de sysMenu y minimize..."
         + self cxBorder * 2 "bordes de yapa..."
         + (SysFont stringWidth: self label). "label extent..."
    ^width! !

! MapBuilder class methods !
initializeStampSize
    "Private - Initialize recommended stamp size"

    StampSize := 680@480 // 4!  
stampSize
    "Private - Returns the current recommended stamp size"

    StampSize isNil ifTrue: [ self initializeStampSize ].
    ^StampSize!   
wbCreated

    ^true! !

! MapBuilder methods !   
bitmapName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    "only for pane reference..."!  
bitmapNameChanged: aPane

    "Callback for the #textChanged event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    | contents last |
    last := bitmapName.
    bitmapName := nil.
    contents := aPane contents trimBlanks.
    contents isEmpty
    ifFalse: [
        (File exists: contents) ifTrue: [ bitmapName := contents ].
    ].

    bitmapName = last ifFalse: [
        self fullUpdate
    ]!  
browseBitmap
    "Private - Lets the user browse disk to find a bitmap file..."

    | pathName |
    pathName := self processingClass pathFromUser.
    pathName isNil ifFalse: [
        (self paneAt: #bitmapName:)
            contents: pathName;
            event: #textChanged
    ]!
build: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Construir el mapa Ahora').
     (Generated by WindowBuilder)"

    | map source mapName scales
     colors buildStamp pane failed |

    bitmapName isNil ifTrue: [^self beep].
    failed := [:text| source release.self beep; warning: text. ^nil ].

    pane := self paneAt: #mapName:.
    mapName := pane contents trimBlanks.
    mapName isEmpty ifTrue: [^failed value: 'Complete el nombre del mapa'].

    self newDirectory ifFalse: [^nil].

    self message: 'Cargando imagen ',bitmapName.
    source := self processingClass fromFile: bitmapName.
    (source isNil or: [source isValid not])
    ifTrue: [ ^failed value: 'Problemas al cargar el bitmap inicial...' ].
    self message: 'Imagen cargada con exito...'.

    buildStamp := (self paneAt: #buildStamp:) selection.

    scales := (self paneAt: #zooms:) selectedItems.
    scales isEmpty ifTrue: [ ^failed value: 'Seleccione al menos un zoom...' ].

    colors := (self paneAt: #layers:) selectedItems.
    colors isEmpty ifTrue: [ ^failed value: 'Seleccione al menos una capa...' ].

    map := Map new.
    map name: mapName.

    buildStamp ifTrue: [
        self buildStamp: map from: source
    ].

    CursorManager execute changeFor: [

        colors reverseDo: [:color|
            scales reverseDo: [:scale|
                "must build a new category for color&scale in the map..."
                self
                    message: 'Construyendo:',color,' ',scale;
                    map: map
                    layer: 'Fondo'
                    color: color
                    scale: scale
                    source: source
            ]
        ].

        source release.

        map
            name: mapName;
            computeBoundingBox.

        self saveMap: map.

    ].!   
buildButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Construir el mapa Ahora').
     (Generated by WindowBuilder)"

    self enable: aPane when: bitmapName notNil.!  
buildDirectory: aDirectory
    "Private - Grant that the directory aDirectory exists.
    If not, create it"

    | root |
    aDirectory isNil ifTrue: [^nil].
    aDirectory isString
    ifTrue: [
        root := aDirectory.
        (root includes: $\) ifFalse: [ root := '.\',root ].
        ^self buildDirectory: (Directory pathName: root)
    ].
    aDirectory valid ifTrue: [^aDirectory].
    root := aDirectory pathName reversed asStream.
    root upTo: $\.
    self buildDirectory:
        (Directory pathName: (root upTo: nil) reversed).
    aDirectory create.
    ^aDirectory!   
buildStamp: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Estampilla').
     (Generated by WindowBuilder)"

    bitmapName isNil ifTrue: [ aPane selection: true ]!   
buildStamp: aMap from: source
    "Private - Build a stamp from source and place in map if success"

    | stamp stampSize answers pathName cancel |
    cancel := [ (MessageBox confirm: 'Desea cancelar la creacin de la estampilla?') ifTrue: [^nil] ].
    stampSize := self class stampSize.
    answers := OSPrompter new
            title: 'Confirme las dimensiones de la estampilla';
            questions: #( 'Ancho' 'Alto' ), (Array with: 'Porcentaje %   Orig.Extent:',source extent asString);
            answers: (Array with: stampSize x asString with: stampSize y asString with: String new);
            open.
    answers isNil ifTrue: [ cancel value ].
    answers last asInteger > 0
    ifTrue: [
        stampSize := source extent * answers last asInteger // 100
    ]
    ifFalse: [
        stampSize
            x: answers first asInteger;
            y: (answers at: 2) asInteger.
    ].

    stamp := source scaledTo: (0@0 extent: stampSize).
    pathName := (self pathNameFor: self currentDirectory),'\stamp.bmp'.
    stamp saveAs: pathName.
    stamp release.

    aMap stamp: (DIB fromFile: pathName).
    self message: 'Estampilla construida con exito...'! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Map Builder';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 850 @ 488; xC; yC; cRDU: (2 @ 486 rightBottom: 848 @ 40));
            pStyle: #(sysmenu titlebar minimize);
            when: #dropFiles perform: #dropFilesInto:;
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 9 r: #left; rDU: 165 r: #left; tDU: 20 r: #top; bDU: 52 r: #top);
                    startGroup;
                    contents: 'Bitmap inicial:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 210 @ 32; lDU: 9 r: #left; rDU: 219 r: #left; tDU: 68 r: #top; bDU: 100 r: #top);
                    startGroup;
                    contents: 'Nombre del mapa:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 9 r: #left; rDU: 201 r: #left; tDU: 116 r: #top; bDU: 148 r: #top);
                    startGroup;
                    contents: 'Directorio inicial:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 18 r: #left; rDU: 110 r: #left; tDU: 154 r: #top; bDU: 186 r: #top);
                    startGroup;
                    contents: 'Zooms'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 82 @ 32; lDU: 315 r: #left; rDU: 398 r: #left; tDU: 154 r: #top; bDU: 186 r: #top);
                    startGroup;
                    contents: 'Capas'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 843 @ 6; lDU: 0 r: #left; rDU: 843 r: #left; tDU: 374 r: #top; bDU: 380 r: #top);
                    blackRectangle;
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 455 @ 32; lDU: 377 r: #left; rDU: 832 r: #left; tDU: 396 r: #top; bDU: 428 r: #top);
                    startGroup;
                    when: #getContents perform: #messages:;
                    contents: ''; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 503 @ 44; lDU: 219 r: #left; rDU: 722 r: #left; tDU: 6 r: #top; bDU: 50 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #bitmapName:;
                    when: #textChanged perform: #bitmapNameChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 622 @ 44; lDU: 219 r: #left; rDU: 841 r: #left; tDU: 54 r: #top; bDU: 98 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #mapName:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 503 @ 266; lDU: 219 r: #left; rDU: 722 r: #left; tDU: 102 r: #top; bDU: 368 r: #top);
                    dropDown;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #rootDirectory:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                MultipleSelectListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 148; lDU: 18 r: #left; rDU: 302 r: #left; tDU: 180 r: #top; bDU: 328 r: #top);
                    contents: #( '400x400' '200x200' '100x100' '50x50' '25x25' '10x10' );
                    defaultStyle;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #zooms:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 18 r: #left; tDU: 330 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #buildStamp:;
                    contents: 'Estampilla'; font: self defaultFont;
                    yourself
            );
            addSubpane: (
                MultipleSelectListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 517 @ 188; lDU: 315 r: #left; rDU: 832 r: #left; tDU: 180 r: #top; bDU: 368 r: #top);
                    contents: #( '256 colores' '256 grises' '16 colores' '2 colores' );
                    defaultStyle;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #layers:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 357 @ 56; lDU: 9 r: #left; rDU: 366 r: #left; tDU: 384 r: #top; bDU: 440 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #build:;
                    when: #getContents perform: #buildButton:;
                    contents: 'Construir el mapa Ahora'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 48; lDU: 727 r: #left; rDU: 846 r: #left; tDU: 6 r: #top; bDU: 54 r: #top);
                    add: #editBrowse selector: #browseBitmap;
                    add: #help selector: #helpBitmap;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 48; lDU: 727 r: #left; rDU: 846 r: #left; tDU: 102 r: #top; bDU: 150 r: #top);
                    add: #editNew selector: #newDirectory;
                    add: #editDelete selector: #removeDirectory;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
currentDirectory
    "Returns the current selected root directory"

    | root pane |
    pane := self paneAt: #rootDirectory:.
    (root := pane text trimBlanks) isEmpty
    ifTrue: [^nil].
    ^root!  
dropFilesInto: aMainView
    "Private - The receiver'scan drop files into it's contents"

    self send: #dropFilesNow to: self!   
dropFilesNow
    "Private - The receiver'scan drop files into it's contents"

    | pane size |
    pane := self paneAt: #bitmapName:.
    pane setFocus.
    self mainView droppedFiles do: [:each|
            size := each size.
            " (each asLowerCase reversed copyFrom: 1 to: (3 min: size)) reversed = 'bmp'
            ifTrue: [ "
                bitmapName := each.
                pane contents: each
           " ] "
        ].

    self fullUpdate.!
helpBitmap
    "Private - Display help topics..."

    MessageBox message: '
 La construccion del mapa se hara cortando tiles de una imagen "gigante".
 Esta imagen debera estar en un archivo (bitmap inicial).
 Se espera que dicho bitmap este en 256 colores.

 Pasos para armar la imagen inicial:
    1.- Scanear el mapa con ImageIn en color,150dpi (tipo de scaneo: Mapas).
    2.- Pasar a 256 colores con PaintShop.
    3.- Corregir Gama con PaintShop (Gama correct value: 2.2).
    4.- Grabarlo como BMP.'!   
layers: aPane

    "Callback for the #getContents event in an unnamed MultipleSelectListPane.
     (Generated by WindowBuilder)"
    | contents selection |
    self enable: aPane when: bitmapName notNil.
    bitmapName isNil ifTrue: [
        contents := aPane contents.
        selection := #('256 colores' '16 colores' '2 colores')
            collect: [:each| contents indexOf: each ].
        aPane selection: selection.
    ].!   
map: aMap
    layer: layerName
    color: aColor
    scale: aScale
    source: source
    " Private - Build a new map category in layer 'layerName'
     for displaying aMap with color aColor and scale aScale.
     Tiles of the tiled image will be cut from source..."

    | scale layer parameters haloInstance
      bitmapTooBig tileExtent tiledImage
      tile root tileName tileNumber tileRoot scaledTile
      widthInTiles heightInTiles dibSize
      colorSpec iniPath profiler cropBox |

    bitmapTooBig := 70 * 1024. "bitmap to be considered too big for a tile..."

    "Compute real scale..."
    scale := (aScale asLowerCase upTo: $x) asInteger / 100.

    "Find the layer & build it if needed..."
    layer := aMap layerNamed: layerName
        ifAbsent: [ aMap newLayer: layerName opaque: true ].

    "WARNING: HALO Imaging dependent..."
    (source isKindOf: HaloImage)
    ifFalse: [ ^source release;error: 'Must be a Halo image...' ].

    "Compute parameters..."
    parameters := #(
        "( 'colorMode'  bitsxPixel )"
        ( '256 colores' 8 self)
        ( '256 grises' 8  'ImcGray')
        ( '16 colores' 4 16)
        ( '2 colores' 1 'ImcBilevel')
    ) detect: [:each| each first = aColor ]
      ifNone: [ ^self error: 'Invalid color format name...' ].

    "Build tile store directory..."
    colorSpec := ((aColor upTo: $ ),(aColor reversed asStream nextWord reversed copyFrom: 1 to: 3)).
    root := (self pathNameFor: self currentDirectory),'\',aScale, '\',colorSpec.
    root := self buildDirectory: root.

    "Compute best tile extent"
    tileExtent := source extent // 2.
    [tileExtent > (100 @ 100)
    and: [
        dibSize := tileExtent x * scale * tileExtent y * scale * (parameters at: 2) / 8 + 1024.
        dibSize > bitmapTooBig ]]
    whileTrue: [
        tileExtent := tileExtent * 4 / 5.
        tileExtent := (tileExtent x max: 70) @ (tileExtent y max: 70).
        tileExtent := tileExtent truncated.
    ].

    "Build the tiles..."
    tileNumber := widthInTiles := heightInTiles := 0.
    0 to: source height by: tileExtent y do: [:y|
        heightInTiles := heightInTiles + 1.
        widthInTiles   := 0.
        0 to: source width by: tileExtent x do: [:x|
            widthInTiles := widthInTiles + 1.
            tileNumber := tileNumber + 1.
            tileName := 'tile',tileNumber asString.
            self message: 'Construyendo ',aColor,',',aScale,':',tileName,' (',x asString,',',y asString,').'.
            cropBox := (x@y extent: tileExtent) intersect: source boundingBox.
            (cropBox width > 1 and: [ cropBox height > 1 ])
            ifTrue: [
                parameters last = #self "do not convert to another image class..."
                ifTrue: [ tile := source crop: cropBox ]
                ifFalse: [
                    tile := HaloImage newImageFrom: [
                        source
                          inside: cropBox
                          doReadOnly: [:instance|
                            parameters last isString
                            ifTrue: [ "class convertion..."
                                instance convertTo: (
                                    HaloConstants at: parameters last
                                        ifAbsent: [self error: 'Invalid image class...'])
                            ]
                            ifFalse: [ instance colorReduce: 0 to: parameters last ] "paletized bitmap..."
                          ]
                    ].
                ]
            ].
            tile notNil
            ifTrue: [
                scale ~= 1
                ifTrue: [
                    scaledTile := tile scaledTo: (0@0 extent: cropBox extent * scale) truncated.
                    tile release.
                    tile := scaledTile.
                ].
                tile
                    saveAs: root pathName,'\',tileName,'.Bmp'
                    format: (HaloConstants at: 'BMP');
                    release.
            ].
        ]
    ].

    "Build ini file..."
    iniPath := (self pathNameFor: self currentDirectory),'\',colorSpec,'.Ini'.
    profiler := WinProfiler new.
    profiler
         pathName: iniPath;
        applicationName: 'Zooms';
        at: scale asString put: scale asString;
        applicationName: scale asString;
        at: 'fileName' put: root pathName,'\Tile';
        at: 'fileExtension' put: 'bmp';
        at: 'widthInTiles' put: widthInTiles;
        at: 'heightInTiles' put: heightInTiles;
        yourself.

    "Build the tiled image (the layer category)...."
    tiledImage := layer addCategory: aColor.
    tiledImage
        imageClass: nil; "default image class..."
        loadFrom: iniPath;
        yourself.! 
mapName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    self enable: aPane when: bitmapName notNil.!  
message: aString
    "Private - Notifies aString..."

    (self paneAt: #messages:) contents: aString! 
messages: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '').
     (Generated by WindowBuilder)"

    aPane contents:
        (bitmapName isNil
        ifTrue: ['Seleccione el bitmap inicial a cortar...']
        ifFalse: ['Se cortara:',(bitmapName reversed upTo:$\) reversed])! 
newDirectory
    "Private - Lets the user build a new directory...
    Returns true if successful"

    | root |
    root :=self currentDirectory.
    root isNil
    ifTrue: [
        self
            beep;
            warning: 'Complete el directorio inicial del mapa',
            '\El directorio inicial sera donde se hubicara el nuevo mapa...'withCrs.
        ^false
    ].
    self buildDirectory: (self pathNameFor: root).
    ^true!
pathNameFor: symbolicPath
    "Private - Expand path macros..."

    ^PathFinder locationFor: symbolicPath!
processingClass
    "Private - Returns the class used for image processing..."

    ^HaloImage!
removeDirectory
    "Private - Lets the user remove the root directory..."

    self notImplementedYet!
rootDirectory: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    self enable: aPane when: bitmapName notNil.
    aPane contents size = 0
    ifTrue: [
        aPane
            contents: (PathFinder locations keys asSortedCollection asArray collect: [:each| '{',each,'}']);
            text: '{Mapas}'
    ]!   
saveMap: aMap
    " Private - Save the map in a file and update cdguia.ini entry..."

    | fileName |

    fileName := File fileName: aMap name extension: 'Map'.

    ObjectFiler
        dump: aMap
        newFile: fileName.

    self profiler
        applicationName: 'Maps';
        at: aMap name put: fileName!   
zooms: aPane

    "Callback for the #getContents event in an unnamed OSListPane.
     (Generated by WindowBuilder)"
    | selection contents |
    self enable: aPane when: bitmapName notNil.
    bitmapName isNil ifTrue: [
        contents := aPane contents.
        selection := #('200x200' '100x100' '50x50' '25x25')
            collect: [:each| contents indexOf: each ].
        aPane selection: selection.
    ].! !

! MapViewManager class methods ! 
aboutToSaveImage
    "Private - Must destroy current cursors..."

    self destroyCursors! 
cursorFor: action
    "Private - Returns the cursor for the action in aString or aSymbol 'action'
     or the normal cursor..."

    ^self cursors
        at: action
        ifAbsent: [ CursorManager normal ]!   
cursorNames
    "Private - Returns the cursors handled by receiver's instances"

    ^#(
        hand move select
    "
        cut erase
        origin corner
        'paint' 'pencil'
        'print'
        'unavailable'
    "
    )!   
cursors
    " Private - Returns the receiver's cursors..."

    Cursors isNil ifTrue: [self initializeCursors].
    ^Cursors! 
destroyCursors
    "Private - Destroy current cursors..."

    | systemCursors |
    Cursors size ~= 0
    ifTrue: [
        systemCursors := #(normal arrow corner crossHair execute text)
            collect: [:sys| CursorManager perform: sys ].
        Cursors values do: [:cursor|
            (systemCursors includes: cursor) "not a system cursor"
            ifFalse: [ cursor release ]
        ]
    ].
    Cursors := nil.!  
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (fileRestore 'Refresca todos los datos...')
        (fileExit 'Cierra esta ventana.')

        (toolHalt 'Halt en la ventana [debug]...')
        (toolDebug 'Inspeccin de la ventana [debug]...')
        )!   
initializeCursors
    " Private - Initialize the receiver's cursors..."

    | cursor |
    Cursors := Dictionary new.
    self cursorNames
        do: [:each|
            cursor := CursorManager
                loadCursor: each
                fromDLL: ObjectStyleDLL library.
            Cursors at: each
                put: (cursor notNil ifTrue: [ cursor]
                    ifFalse: [CursorManager normal]).
        ]!
openOn: aMapView
    "Open an instance of the receiver working on aMap"

    ^self new openOn: aMapView!   
wbCreated

    ^true! !

! MapViewManager methods !   
activateView: aPane

    "Callback for the #activate event in the TopPane 'mainView'.
     (Generated by WindowBuilder)"

    | model |
    model := self model.
    model notNil ifTrue: [ model activate: self ].!   
button1DoubleClick: aPane

    "Callback for the #button1DoubleClick event in the OSImagePane named 'map'.
     (Generated by PathFinder)"

    | point elements selected |
    point := self mouseLocation.
    self useSelection & selection notNil
    ifTrue: [
        (selection containsPoint: point)
        ifTrue: [ self selectionDoubleClickedAt: point ].
        self selectionHasChanged.
    ].

    elements := self elementsInRectangle: (self focusRectangle translateBy: point).
    elements size > 0 ifTrue: [ "elements first run"
        "descriptions := self descriptions."
    selected := elements size > 1
        ifTrue: [
            ListDialog new
                title: 'Seleccione...';
                openOn: elements
        ]
        ifFalse: [ elements first ].
    selected isNil ifTrue: [ ^nil ].
    selected run
 ].!
button1Down: aPane

    "Callback for the #button1Down event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    | point displacement mode |
    self useSelection ifFalse: [^self].
    point := self mouseLocation.

    self displaySelection.

    selection isNil
    ifTrue: [ selection := point x @ point y extent: 0@0 ].

    (self selectionCanBeMoved
        and: [selection width > 0
        and: [selection containsPoint: point]])
    ifTrue: [
        mode := #move.
        displacement := point - selection origin.
    ]
    ifFalse: [
        mode := #select.
        displacement := 0@0.
        selection := point x @ point y extent: 0@0.
    ].

    aPane
        propertyAt: #mode put: mode;
        propertyAt: #displacement put: displacement.

    self selectionStarts:aPane.

    self
        displaySelection;
        selectionHasChanged.!   
button1DownShift: aPane

    "Callback for the #button1DownShift event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    | point displacement mode |
    self useSelection ifFalse: [^self].
    point := self mouseLocation.

    (selection isNil "or: [selection containsPoint: point]")
    ifTrue: [ ^self button1Down: aPane ].

    self displaySelection.

    selection :=
        (selection left min: point x) @
        (selection top min: point y)
      corner:
        (selection right max: point x) @
        (selection bottom max: point y).

    aPane
        propertyAt: #mode put: nil;
        propertyAt: #displacement put: nil.

    self
        displaySelection;
        selectionHasChanged.!
button1Move: aPane

    "Callback for the #button1Move event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    | point displacement mode |
    self useSelection ifFalse: [^self].

    point := self mouseLocation.
    mode := aPane propertyAt: #mode.
    mode isNil ifTrue: [^self].

    self displaySelection.
    mode = #move
    ifTrue: [ selection moveTo: point - (aPane propertyAt: #displacement) ]
    ifFalse: [ selection := selection origin corner: point ].

    self
        selectionInProgress:aPane;
        displaySelection;
        selectionHasChanged!
button1Up: aPane

    "Callback for the #button1Up event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    | point displacement mode |

    Notifier isAltDown & Smalltalk isRunTime not ifTrue: [ self halt ].
    Notifier isCtrlDown & Smalltalk isRunTime not ifTrue: [ self refresh ].

    self useSelection ifFalse: [^self].

    point := self mouseLocation.
    mode := aPane propertyAt: #mode.

    mode isNil ifTrue: [^self].

    self displaySelection.
    mode = #move
    ifTrue: [ selection moveTo: point - (aPane propertyAt: #displacement) ]
    ifFalse: [ selection := selection origin corner: point ].

    (selection width < self minimumSelection x
    or: [selection height < self minimumSelection y])
    ifTrue: [ selection := nil ].

    self selectionEnds:aPane.

    self
        displaySelection;
        selectionHasChanged!   
canDo: aSymbol
    " Returns true if the receiver can do the action at aSymbol
     at this moment...
    Check some functionality provided by default...
    By default return true if implemented...
    This method can be refined by subclasses..."

    | model  map streets |
    model := self model.
"
    Transcript cr;nextPutAll: 'canDo: ',aSymbol.
"
    aSymbol == #fileSearch
    ifTrue: [ ^self map notNil ].

    aSymbol == #editSearch
    ifTrue: [ ^(map := self map) notNil and: [ map hasStreets ] ].

    aSymbol == #fileRead ifTrue: [ ^self map notNil ].

    aSymbol == #editCopy
    ifTrue: [ ^self useSelection and: [ selection notNil ] ].

    aSymbol == #viewZoomIn ifTrue: [ ^self mapView canZoomIn ].
    aSymbol == #viewZoomOut ifTrue: [ ^self mapView canZoomOut ].

    aSymbol == #viewStamp ifTrue: [ ^self stamp notNil ].
    aSymbol == #viewReferences ifTrue: [ ^self references notNil ].

    ^self respondsTo: aSymbol asSymbol! 
canDrop: anObject into: aPane
    "Private - An Object want to be dropped into aPane..."

    "don't drop into topView"
    aPane == self mainView ifTrue: [^false].
    anObject isNil ifTrue: [^false].

    aPane = self mapPane "default drop is only inside map pane..."
    ifFalse: [^false].

    (anObject isAssociation and: [anObject value isKindOf: LayerView])
    ifTrue: [ ^anObject value isOpaque not ].

    (anObject isKindOf: LayerView)
    ifTrue: [ ^anObject isOpaque not ].

    ((anObject respondsTo: #position) "positionable objects can be dropped..."
    and: [ true"self mapView boundingBox containsPoint: anObject position"])
    ifTrue: [ ^true ].

    ^false!   
centerHere
    "Private - Center the the graph pane at mouse location point..."

    self position: self mouseLocation - (self mapPane frameRectangle extent // 2 * self zoomFactor)!  
checkSelection
    "Private - The selection must be checked..."
    | left top right bottom |

    selection isNil ifTrue: [^self].

    left := selection left min: selection right.
    right := selection left max: selection right.
    top := selection top min: selection bottom.
    bottom := selection top max: selection bottom.

    selection := left @ top rightBottom: right @ bottom.!  
cloneFrom: aViewManager
    "Get receiver's information from aViewManager"

    mapView := aViewManager mapView copy.

    ^self!
close
    "Close the receiver & release instances"

    | model result |
    result := super close.
    (model := self model) notNil ifTrue: [
        self
            send: #updateToolsAndMenues
            to: model
    ].
    ^result!   
copyAttributesFrom: aViewManager
    "Get receiver's information from aViewManager"

    grid := aViewManager grid copy.
    aViewManager rulerPanes first visible
    ifFalse: [ self toggleRuler ].

    self position: aViewManager position.

    ^self! 
createGraphPane: aPaneWithRulers
    "Private - Process the getContens event for the rulered pane"

    mapPane := OSImagePane new.
    mapPane
        owner: self;
        when: #button1Up perform: #button1Up:;
        when: #button1DoubleClick perform: #button1DoubleClick:;
        when: #button1Down perform: #button1Down:;
        when: #button1Move perform: #button1Move:;
        when: #display perform: #displayMap:;
        when: #setScrollRectangle perform: #setScrollRectangle:;
        when: #button1DownShift perform: #button1DownShift:;
        when: #mouseMove perform: #mouseMove:;
        when: #getMenu perform: #getImageMenu:;
        backColor: ClrPalegray;
        setCursor: (self cursorFor: #hand);
        yourself.

    aPaneWithRulers contents: mapPane!
createObject: anObject
    at: aPoint
    category: aCategoryName
    layer: aLayer
    "Private - Adds new Object to be dropped into a layer at aPoint..."

    | answers layer element dialog|
    aPoint isNil ifTrue: [^nil].

    aCategoryName isNil | aLayer isNil
    ifTrue: [
       " answers := OSPrompter new
            title: 'Donde desea ubicar el objeto ?';
            questions: #( 'Capa' 'sub-Capa' );
            answers: ((Array with: aLayer with: aCategoryName)
                collect: [:each| each isNil ifTrue: ['Informacin']
                    ifFalse: [ each isString ifTrue: [each] ifFalse: [each name]]]);
            open."

    " ************************************* "
        dialog := LayerAndSubLayerDialog new.
        dialog openOn: self map layers.
        answers:= dialog answers.
    " **************************************  "
        (answers isNil
        or: [answers first trimBlanks isEmpty | answers last trimBlanks isEmpty])
        ifTrue: [^nil].
        layer := self map layers
            detect: [:each| each name = answers first ]
            ifNone: [ self layerNotFound: answers first ].
        ^self
            createObject: anObject
            at: aPoint
            category: answers last
            layer: layer
    ].

    anObject isNil
    ifTrue: [
        element := Information fromUser.
        element isNil ifTrue: [ ^nil ].
    ]
    ifFalse: [ element := anObject ].

    element edit.

    element name isNil ifTrue: [
        self beep.
        MessageBox warning: 'El elemento debe tener al menos el nombre...'.
        ^self
    ].
    (aLayer canHold: element) ifFalse: [^self warning: 'La capa ',aLayer asString,' no puede contener el elemento.'].

    aLayer add: element at: aPoint type: aCategoryName.
    self updateView.!   
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Map View';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 942 @ 640; xC; yC; cRDU: (9 @ 632 rightBottom: 933 @ 46));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            when: #activate perform: #activateView:;
            when: #dropFiles perform: #dropFilesInto:;
            backColor: ClrPalegray;
            addSubpane: (
                PaneWithRulers new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 923 @ 586; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 0 r: #top; bDU: 0 r: #bottom);
                    paneName: 'graph';
                    backColor: ClrPalegray;
                    startGroup;
                    when: #getContainedPane perform: #createGraphPane:;
                    addSubpanes;
                    yourself
            );
        yourself
    ).! 
currentScale

    ^self mapView scale!  
cursorFor: action
    "Private - Returns the cursor for the action in aString or aSymbol 'action'
     or the normal cursor..."

    ^self class cursorFor: action!   
displayMap: aPane

    "Callback for the #display event in an unnamed OSGraphPane.
     (Generated by WindowBuilder)"

    | rectangle boundingBox |
    mapView isNil ifTrue: [ ^aPane erase ].

    boundingBox := mapView boundingBox.
    rectangle := aPane rectangleToDisplay.
    CursorManager execute changeFor: [
        rectangle notNil ifTrue: [
            (rectangle nonIntersections: boundingBox)
            do: [:nonOverlaped| aPane pen fill: nonOverlaped color: aPane backColor ].
            self displayRectangle: (rectangle intersect: boundingBox) with: aPane pen.
        ].
        self drawTheGridIn: rectangle with: aPane pen.
        self drawHightLightsIn: rectangle with: aPane pen.
        selection notNil ifTrue: [ self drawSelectionIn: rectangle with: aPane pen ].
    ].!  
displayRectangle: aRectangle with: aPen
    "Dibuja el area indicada por aRectangle usando aPen"

    mapView isBitmap ifTrue: [ ^mapView displayAt: 0@0 with: aPen ].

    mapView
        displayRectangle: aRectangle
        with: aPen.!  
displaySelection
    "Private - Display the current selection..."

    | aPane |
    aPane := self mapPane.
    (aPane pen notNil and: [ selection notNil ])
    ifTrue: [ self drawSelectionIn: aPane pen boundingBox with: aPane pen ]!   
drawHightLightsIn: aRectangle with: aPen
    "Private - Draw the hightlights points inside aRectangle with aPen.
    aRectangle will be ignored because it's assumed that highLights are small."

    highLights notNil
    ifTrue: [ self highlight: highLights ].! 
drawSelectionIn: aRectangle with: aPen
    "Private - Draw the current selection..."

    | backUp scale |
    backUp := aPen location.
    scale := self scale.
    aPen
        setRop2: R2Notxorpen;
        setLineWidth: self selectionLineWidth;
        place: (selection origin * scale) truncated;
        box: (selection corner * scale) truncated;
        setRop2: R2Copypen;
        setLineWidth: 1;
        place: backUp;
        yourself!
drawStreets
    "Private - Display all the streets"

    | color width pen streets scale |
    (mapPane isNil or: [(pen := mapPane pen) isNil]) ifTrue: [^self beep].
    width := pen lineWidth.
    color := pen foreColor.
    scale := self scale.
    pen
        foreColor: ClrBlue;
       "setRop2: R2Notxorpen; "
       setLineWidth: (self gap "* scale ----- don't  reduce street traces" max: 1) truncated.
    streets := self streets.
    CursorManager execute
    changeFor: [
        (streets notNil and: [ (streets := streets streets) size > 0 ])
        ifTrue: [
            streets do: [:aCollection|
              aCollection do: [:aStreet|
                (aStreet isPath and: [aStreet isEmpty not])
                ifTrue: [
                    pen place: (aStreet first * scale) truncated.
                    aStreet do: [:point| pen goto: (point * scale) truncated ]
                ]
              ]
            ]
        ].
    ].
    pen
        foreColor: color;
        setRop2: R2Copypen;
        setLineWidth: width.!
drawTheGridIn: aRectangle with: aPen
    "Private - Draw the grid..."

     grid display: aRectangle with: aPen.!  
drop: anObject into: aPane at: aPoint
    "Private - An Object want to be dropped at aPoint..."

    | point |
    point := aPoint + aPane topCorner.
    (anObject isKindOf: LayerView)
    ifTrue: [
        ^self
            createObject: nil
            at: point
            category: nil
            layer: anObject layer
    ].

    "support drop of asociations with category=>viewLayer pairs..."
    (anObject isAssociation and: [anObject value isKindOf: LayerView])
    ifTrue: [
        ^self
            createObject: nil
            at: point
            category: anObject key
            layer: anObject value layer
    ].

    (anObject respondsTo: #position)
    ifTrue: [ ^self position: anObject position - (self mainView extent // 2) ].

    ^nil!
dropFile: pathName into: pane at: aPoint
    "Private - A file named pathName want to be dropped at aPoint..."

    | point anObject |
    anObject := FileInformation new.
    anObject pathName: pathName.
    self
        createObject: anObject
        at: aPoint
        category: nil
        layer: nil!   
dropFilesInto: aMainView
    "Private - The receiver'scan drop files into it's contents"

    self send: #dropFilesNow to: self!   
dropFilesNow
    "Private - The receiver'scan drop files into it's contents"

    | drop pane offset box |
    offset := Cursor sense.
    pane := self mapPane.
    pane setFocus.
    box := pane frameRectangle.
    drop := box containsPoint: offset.
    drop ifTrue: [
        self mainView droppedFiles do: [:each|
            self dropFile: each into: pane at: offset - box leftTop + pane topCorner.
            "displace dropped files info by some pixels horizontally"
            offset := offset + (30@0).
        ].
    ].
    ^drop "Returns true if dropped over image pane..."! 
editCapture
    "Capture state in the current window;
     and store it in an open object holder."

    | state holder model |
    state := self state.
    state isNil ifTrue: [^self beep].
    model := self model.
    model isNil ifTrue: [^self beep].
    holder := model objectHolder.
    holder isNil ifTrue: [^self beep].
    holder add: state.!  
editCopy

    | bitmap |
    (self useSelection not or: [selection isNil])
    ifTrue: [^self beep].

    CursorManager execute changeFor: [
        bitmap := Bitmap screenExtent: selection extent.
        self mapView displayRectangle: selection at: selection origin negated with: bitmap pen.

    "No se que pasa pero si no hago un display no sale en clipboard..."
        self displaySelection.
        bitmap displayAt: selection origin with: self mapPane pen.
        self displaySelection.

        Clipboard setBitmap: bitmap.
    ]!  
editSearch
    "Lets the user goto an typed Address..."

    | input result box extent color streets position exit |
    CursorManager execute change.
    exit := [ CursorManager normal change. ^self ].
    extent := 1@1 * 50.
    streets := self streets.
    streets isNil ifTrue: [ self beep. exit value ].
    input := mapPane propertyAt: #editSearch.
    input isNil ifTrue: [ input := 'Soler 4545 @Object Style Tel. : 833-3363' ].
    [
    input := OSPrompter
        prompt: 'Direccin a hubicar ? (Calle y nmero o Calle solamente)'
        default: input.
    input isNil ifTrue: [ exit value ].
    highLights := nil.
    CursorManager execute change.
    mapPane propertyAt: #editSearch put: input.
    result := self streets find: input notifying: self with: #streetFound:.
    result notNil ifTrue: [
        (result isArray and: [ result size = 1 and: [ result first isKindOf: StreetReference]])
        ifTrue: [ "query returns a street..."
            result := result first.
            box := result boundingBox.
        ]
        ifFalse: [
            result isPoint ifTrue: [ box := result - (extent // 2) extent: extent ].
            result isRectangle ifTrue: [ box := result ].
            result isArray ifTrue: [
                result first isPoint
                ifTrue: [
                    box := result first copy rightBottom: result first copy.
                    result do: [:point|
                        box leftTop x: (box leftTop x min: point x).
                        box leftTop y: (box leftTop y min: point y).
                        box rightBottom x: (box rightBottom x max: point x).
                        box rightBottom y: (box rightBottom y max: point y).
                    ].
                ] ifFalse: [ box := result first boundingBox ].
            ].
        ].
       box isNil
        ifTrue: [ self warning: 'No encontr la direccin.' ]
        ifFalse: [
            position := box center - (self mapPane frameRectangle extent // 2 * self zoomFactor).
            position := position truncated.
            box := box truncated.
           (result isCollection or: [result isKindOf: StreetReference])
            ifTrue: [ highLights := result ]
            ifFalse: [ highLights := box ].
            self position: position.
            self updateView.
        ]
    ] ifFalse: [ self warning: 'No encontr la direccin.' ].
    true"result isNil" ] whileTrue: [].! 
editUpdate
    "Update the receiver..."
    self fullUpdate!
elementsInRectangle: aRectangle
    "Return the elements inside aRectangle
    LRP 12/MAY/94"

    | aView |
    aView := self mapView.
    aView isNil ifTrue: [^#()].
    ^aView elementsInRectangle: aRectangle!
fileCopy
    "Copy the receiver's contents to the clipboard..."

    CursorManager execute changeFor: [
        Clipboard setObject: self objectToCopy
    ]!
fileNew
    "Activates a new map in the receiver"

    self mapView map: Map new.
    self refresh.!  
fileOpen
    "The receiver will work in a map
    and scanner obtained from a file..."

     | dialog file map |

    dialog := FileDialog new.
    dialog
        title: 'Seleccione el archivo a abrir...';
        addFilter: '*.map' description: 'Archivos de Mapa (*.Map)';
        addFilter: '*.mpv' description: 'Visiones de mapas (*.MPV)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        defFilter: '*.map';fileSpec: '*.map';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].
    (file includes: $.)
    ifFalse: [ file := file,'.Map' ].

    map := ObjectFiler loadFromPathName: file.
    map isNil ifTrue: [ ^self error: 'El archivo no contiene objetos...' ].

    (map isKindOf: Map)
    ifTrue: [ mapView map: map ]
    ifFalse: [
        (map isKindOf: MapView)
        ifTrue: [ self mapView: map ]
        ifFalse: [ ^map error: 'El objeto encontrado en el archivo no es el esperado.' ].
    ].

    self fullUpdate!
filePaste
    "Paste the clipboard's contents to the receiver..."
    | map |
    CursorManager execute changeFor: [
        map := Clipboard getObject
    ].
    map isNil ifTrue: [^nil].
    (map isKindOf: Map) ifTrue: [^self map: map].
    (map isKindOf: MapView) ifTrue: [self mapView: map.^self refresh].

    MessageBox message: 'El objeto en el portapapeles no puede ser volcado en esta ventana...'!  
filePrint

    CursorManager execute
    changeFor: [
        PrintPreviewDialog new
            printArea: selection;
            "printer: self model printer;"
            image: self mapView;
            mode: #dotToDot;
            zoomTo: 80; "percent of the page..."
            centerSelection;
            printNow
    ].!
filePrintPreview

    CursorManager execute change.
    PrintPreviewDialog new
        printArea: (self useSelection ifTrue: [selection]);
        openOn: self mapView! 
fileRead
    "FilesIn a new layer..."

    | map |
    map := self map.
    map notNil ifTrue: [ map fileInLayer ]!  
fileRestore
    "Refresh the receiver's contents..."

    self refresh.!   
fileSave
    "Lets the user save the map..."

    ^self fileSaveAs: nil!   
fileSaveAs: pathName
    "Lets the user save the map in a new file...
    Returns the new file name is successfull or nil"

     | dialog file |

    dialog := FileDialog new.
    dialog
        title: 'Determine el nombre del archivo...';
        addFilter: '*.map' description: 'Archivo de mapa (*.MAP)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        fileSpec: (pathName isNil ifTrue: ['Anonimo.Map'] ifFalse: [pathName]);
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].

    (file includes: $.) ifFalse: [ file := file,'.Map' ].
    self backUpFile: file.

    CursorManager execute changeFor: [
        ObjectFiler dump: mapView map newFile: file.
        self updateTitle.
    ].
    ^file! 
fileSearch
    "Private - Lets the user activate a seach-objects view"
    | model view |
    model := self model.
    model isNil ifTrue: [^self].
    model activateSearchFor: self!   
focusRectangle
    "Private - Returns the rectangle for focus..."

    ^(10@10) negated extent: 20@20! 
fullUpdate
    "Update all the receiver's panes and perform graph update"

    super fullUpdate.
    self
        updateView;
        updateTitle.! 
gap
    "Private - Returns the gap size"

    ^3!  
getImageMenu: aPane
    "Callback for the #getMenu event in the image-pane..."

    aPane setMenu: (self imageMenu: aPane).!   
gotoHere
    "Private - Move the graph pane to the mouse location point..."

    self position: self mouseLocation - 50 "margencito..."!   
grid
    ^grid!  
gridSetup
    "Lets the user change the grid"

    CustomizeGridDialog new openOn: grid.
    self updateView.!
highlight: points
    "Private - Hightlight the pointse..."

    | color width pen scale highlightColor highlightRop |
    (mapPane isNil or: [(pen := mapPane pen) isNil]) ifTrue: [^nil].

    scale := self scale.
    highlightColor := self pathColor.
    highlightRop :=  R2Notxorpen.
    width := pen lineWidth.
    color := pen foreColor.

    points isRectangle
    ifTrue: [
        pen
            setRop2: highlightRop;
            foreColor: highlightColor;
            setLineWidth: ((points width max: points height) * scale max: 1) truncated;
            place: (points center * scale) truncated;
            goto: (points center * scale) truncated;
            yourself.
    ]
    ifFalse: [
        pen
            setRop2: highlightRop;
            foreColor: highlightColor;
            setLineWidth: (self gap * 4 * scale max: 1) truncated.
        pen place: (points first * scale) truncated.
        points do: [:point|
            pen
                goto: (point * scale) truncated;
                "debug...   circle: (self gap * 2 * scale max: 1) truncated;"
                yourself.
        ].
    ].
    pen
        foreColor: color;
        setLineWidth: width;
        setRop2: R2Copypen;
        yourself!  
imageMenu: aPane
    " Private - Returns menu for the image pane..."

    | menu |
    menu := Menu
        labels: '&Redibujar\&Dibujar las calles\&Posicionarse aqu\&Centrarse aqu\&Grabar posicin\Resta&urar posicin' withCrs
        lines: #(2 4 6)
        selectors: #( fullUpdate drawStreets gotoHere centerHere savePosition restorePosition).
    menu
        owner: self;
        appendSubMenu:
            ((Menu colorMenu: self selector: #pathColor:)
                title: 'C&olor de marcas';
                yourself);
        yourself.

    ^menu.!  
initialize
    " Private - Initialize the receiver..."

    selection := nil.
    super initialize.
    grid := GridView new.!   
initializeMap
    "Initialize the receiver's map..."

    mapView isNil
    ifTrue: [ mapView := self model mapFromUser ].
    mapView isNil ifTrue: [
        mapView := Map new asView.
    ].!  
layerNotFound: layerName
    "Private - Lets the user add a new layer in in development..."

    | layer |
    (MessageBox confirm: 'Capa de informacin no encontrada : ', layerName,'\ Desea crearla ?'withCrs)
    ifTrue: [
        layer := self map newLayer: layerName.
        layer notNil ifTrue: [ ^layer ].
        self mapView layers. "force layers check..."
    ].
    ^self error: 'Capa de informacin no encontrada : ', layerName! 
map
    "Private - Returns the receiver's map."

    ^mapView map! 
map: aMap
    "Set the receiver's map..."

    mapView map: aMap.
    self fullUpdate.!   
mapPane
    "Private - Returns the pane for the map."

    ^mapPane!   
mapScale
    "Returns the origin map scale"
   "self map scale"

    ^100000! 
mapView
    "Returns the instance var of the receiver
     for external manipulation"
    ^mapView!
mapView: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    mapView := anObject!   
message: aString
    "Private - Show aString in the contents box"

    ^self message: aString in: #status! 
message: aString in: statusBox
    "Private - Show aString in the status box"

    | pane |
    pane := self statusPane.
    pane notNil
    ifTrue: [
        (pane statusBoxAt: statusBox) contents: aString
    ]! 
minimumSelection
    "Private - Returns the minimum selection size"
    ^2@2!   
mouseLocation
    "Private - Returns the mouse location relative to mapPane
        adapted to current zoom factor"

    ^(self mapPane mouseLocation * self zoomFactor) truncated!   
mouseMove: aPane

    "Callback for the #mouseMove event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    | point elements text |
    point := self mouseLocation.

    self useSelection
    ifTrue: [
        selection notNil
        ifTrue: [
            (selection containsPoint: point)
            ifTrue: [ mapPane setCursor: (self cursorFor: #move) ]
            ifFalse: [ mapPane setCursor: (self cursorFor: #select) ]
       ] ifFalse: [ mapPane setCursor: (self cursorFor: #hand) ].
    ].

    elements := self elementsInRectangle: (self focusRectangle translateBy: point) truncated.

    text := point asString.
    elements isEmpty
    ifFalse: [
        text := text , ' >> '.
        elements do: [:each|
            text := text , each description asString.
            each == elements last ifFalse: [ text := text,' || ' ]
        ].
    ].
    self message: text!  
objectToCopy
    "Private - Returns the object in the receiver to be copied to clipboard"
    ^mapView map! 
openOn: aMapView
    "Open the receiver working on aMapView"

    mapView := aMapView.
    ^self open!
pathColor
    "Private - returns the default path color..."

    | pathColor |
    pathColor := self mapPane propertyAt: #pathColor.
    pathColor isNil ifTrue: [^ClrDarkgreen].
    ^pathColor!   
pathColor: aColor
    "Private - Sets the color to be user for drawing the path"

    self mapPane propertyAt: #pathColor put: aColor.
    self updateView.!  
position
    "Returns the position of the receiver's mapPane"

    ^self mapPane topCorner * self zoomFactor!  
position: aPoint
    "Position the receiver's mapPane at aPoint"

    | corner |
    (aPoint x < 0 or: [aPoint y < 0])
    ifTrue: [ ^self position: (aPoint x max: 0) @ (aPoint y max: 0) ].
    corner := self map extent - self mapPane frameRectangle extent.
    (corner x > 0 and: [corner y > 0])
    ifTrue: [
        (aPoint x > corner x or: [aPoint y > corner y])
        ifTrue: [^self position: (corner x min: aPoint x) @ (aPoint y min: corner y) ].
    ].

    self mapPane pen isNil ifTrue: [^self].

    "hay que hacerlo por si cambio el zoom... ???"
    self setScrollRectangle: self mapPane.

    self mapPane
        scrollTopCornerTo: (aPoint  * self scale) truncated;
        updateSliders;
        yourself.!   
preInitWindow
    "Private - Load default receiver's map..."

    self
        initializeMap;
        updateTitle.!  
references
    "Private - Returns current references in use."

    ^(mapView respondsTo: #references)
    ifTrue: [ mapView references ]
    ifFalse: [
        "Answer a default stamp for testing...Ale"
        CPBitmapDict at: 'recycle'
    ]!  
refresh
    "Private - Refresh the current views of mapView using the app-model..."
    | model openViews |
    mapView map: mapView map.
    model := self model.
    model notNil ifTrue: [
        openViews := model currentViewsOn: mapView map.
        openViews := views asSet collect: [:each| each owner ].
        openViews do: [:each|
            each mapView map: mapView map. "layers & categories can be changed..."
            each fullUpdate
        ]
    ].!  
restorePosition
    "Private - Restore the graph position to last saved..."

    | point |
    point := self mapPane propertyAt: #userSavedPosition.
    point isNil ifTrue: [ ^self beep ].
    self position: point.! 
rulerPanes
    "Private - Returns the rulers panes..."

    ^(self paneNamed: 'graph') rulers! 
savePosition
    "Private - Save the graph location..."

    self mapPane propertyAt: #userSavedPosition put: self position.!  
scale
    "Private - Returns current scale..."

    ^self mapView scale!   
selection
    "Private - Returns the receiver's selection..."

    ^selection! 
selection: aRectangle
    "Private - Sets the receiver's selection..."

    self displaySelection.
    selection := aRectangle.
    self displaySelection.!  
selectionCanBeMoved
    "Private - Returns true if the current selection can be moved..."

    "Default action is to move selection..."
    ^true!
selectionDoubleClickedAt: aPoint
    "Private - Perform action for doubleClick into the selection"

    "Default action is to do nothing..."!  
selectionEnds:aPane
    "Private - A selection operation has been done.
     aPane will have the #mode and #displacement"

    self checkSelection.
    self model updateToolsAndMenues.!
selectionHasChanged
    "Private - The current selection has changed...
    The default action is to do nothing...
    This method can be refined by subclasses..."!   
selectionInProgress:aPane
    "Private - A selection operation is in progress.
     aPane will have the #mode and #displacement"

    "Default action is to do nothing.
    This method can be refined by subclasses..."!
selectionLineWidth
    "Private - Returns the current selection line width"
    ^2! 
selectionStarts: aPane
    "Private - Start with a new selection operation.
     aPane will have the #mode and #displacement"

    "Default action is to do nothing.
    This method can be refined by subclasses..."!   
setScrollRectangle: aPane

    "Callback for the #setScrollRectangle event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    mapView isNil ifTrue: [^self].
    aPane scrollingRectangle: mapView boundingBox.!
showMapAt: aPoint
    "Position the receiver's graphPane centered at aPoint"

    self position: aPoint - (self mapPane frameRectangle extent // 2)!   
stamp
    "Private - Returns current stamp in use."

    ^(mapView respondsTo: #stamp)
    ifTrue: [ mapView stamp ]
    ifFalse: [
        "Answer a default stamp for testing...Ale"
        CPBitmapDict at: 'recycle'
    ]!  
state
    "Private - Returns the receiver's current view state"

    | state settings properName |

    self mapView isNil ifTrue: [^nil].

    properName := [:aString|
        (aString includes: $ ) ifFalse: [aString]
        ifTrue: [ aString asArrayOfSubstrings last ]
    ].

    state := MapViewState new.

    settings := state settingsFor: #grid.
    settings at: #grid put: grid deepCopy.

    settings := state settingsFor: #ruler.
    settings at: #visible put: self  rulerPanes first visible.

    settings := state settingsFor: #view.
    settings
        at: #position put: self position;
        at: #selection put: selection deepCopy;
        at: #map put: self map name;
        at: #scale put: self mapView scale copy;
        at: #selectedLayers put:
                (self mapView selectedLayers asArray
                    collect: [:layer| Array with: layer name with: layer selectedCategoryNames asArray ]);
        yourself.

    state
        name: (properName value: self map name);
        icon: self map icon;
        viewClass: self class symbol;
        yourself.

    ^state! 
statusPaneHelp:aKey
    "Private - Answer the hint text to the StatusPane"

    | dict label pair value |
    label := [:selector :text|
        (text size = 0 or: [self respondsTo: selector])
        ifTrue: [ text ]
        ifFalse: [ text ,' *An no implementado [',selector,']*']
    ].

    self class helpMap do: [:pair |
        pair first asString = aKey asString
        ifTrue: [ ^label value: pair first value: pair last ]
    ].

    dict := Smalltalk at: #HelpStatusPane ifAbsent: [Dictionary new].
    value := dict at: aKey
        ifAbsent: [ dict at: aKey asSymbol ifAbsent: [ super statusPaneHelp: aKey ]].
    ^label value: aKey value: value!   
streets
    "Private - Returns the current street net (or nil)"

   ^self map streets! 
title
    "Private - Returns the current title..."

    | prologue scale |
    prologue := super titleWith: mapView.
    scale := "(self currentScale * 100) truncated" self mapScale / ( self currentScale).
    ^(prologue isNil ifTrue: [String new] ifFalse: [prologue])
        ,(scale > 0 ifTrue: [' Escala: 1:',scale asString,' '] ifFalse: [String new])!
toggleGrid
    "Toggle the grid..."

    grid toggle.
    self updateView!
toggleLayer: aLayer
    "Toggle the layer aLayer in the current window."

    mapView isNil ifTrue: [^self].

    (mapView selectedLayers includes: aLayer)
    ifTrue: [ mapView unselect: aLayer ]
    ifFalse: [ mapView select: aLayer ].

    self mapPane invalidateRect: nil.!
toggleRuler
    "Toggle the ruler..."

    (self paneNamed: 'graph') toggleRuler!  
toolHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := self statusPaneHelp: selector asString.
    text isNil ifTrue: [ text := String new ].
    self message: text!
updateView
    "Update the graph view"
    | thePane |
    thePane := self mapPane.
    thePane notNil ifTrue: [ thePane invalidateRect: nil ].!  
useSelection
    "Private - Responds to if a selection can be done using the receiver...
    This method can be refined by subclasses"

    ^true!
viewLayers
    "Private - Lets the user activate a layers view"
    | model view |
    model := self model.
    model isNil ifTrue: [^self].
    model activateLayersFor: self!  
viewReferences
    "Private - Lets the user activate a references view"
    | model view |
    model := self model.
    model isNil ifTrue: [^self].
    model activateReferencesFor: self!  
viewStamp
    "Private - Lets the user activate a stamp view"
    | model view |
    model := self model.
    model isNil ifTrue: [^self].
    model activateStampFor: self! 
viewZoomIn
    "Perform zoomIn"
    | position |
    self mapView canZoomIn
    ifTrue: [
        position := self position.
        self mapView zoomIn.
        self mapPane notNil ifTrue: [ self mapPane erase ].
        self
            position: position;
            send: #updateView to: self;
            updateTitle;
            yourself
    ] ifFalse: [ self beep ].!  
viewZoomOut
    "Perform zoomOut"

    | position |
    self mapView canZoomOut
    ifTrue: [
        position := self position.
        self mapView zoomOut.
        self mapPane notNil ifTrue: [ self mapPane erase ].
        self
            position: position;
            send: #updateView to: self;
            updateTitle;
            yourself
    ] ifFalse: [ self beep ].!
zoomFactor
    "Private - Returns current zoom factor..."

    ^self mapView scale reciprocal! !

! MapEditor class methods !
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (fileNew 'Crea un nuevo mapa.')
        (fileOpen 'Abre un file de mapa...')
        (fileCopy 'Copia todo el mapa actual al clipboard.')
        (filePaste 'Carga el mapa desde el clipboard...')
        (fileSave 'Graba el mapa actual.')
        (fileSaveAs 'Graba el mapa actual con otro nombre.')
        (fileRead 'Lee un archivo de datos...')

        (editNew 'Permite crear una nueva capa de informacion')
        (edit 'Permite modificar la capa de informacion selecta')
        (editCopy 'Permite copiar toda la capa de informacion al clipboard')
        (editPaste 'Agrega la capa de informacion que este presente en el clipboard')
        (editUpdate 'Refresca la lista')
        (editDelete 'Borra la capa de informacion selecta')

        (toolHalt 'Inspeccion del receptor...')
        (toolDebug 'Inspeccion del mapa...')

        ), super helpMap! 
wbCreated

    ^true! !

! MapEditor methods !
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Editor de mapas';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1426 @ 912; lDU: 16 r: #left; tDU: 20 r: #top; cRDU: (9 @ 904 rightBottom: 1417 @ 46));
            pStyle: #(sysmenu maximize titlebar sizable minimize);
            when: #activate perform: #activateView:;
            backColor: ClrPalegray;
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 375 @ 342; lDU: 18 r: #left; tDU: 350 r: #bottom);
                    startGroup;
                    contents: 'Propiedades visuales'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 32; lDU: 27 r: #left; rDU: 128 r: #left; tDU: 74 r: #top; bDU: 106 r: #top);
                    startGroup;
                    contents: 'Nombre:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 256 @ 32; lDU: 27 r: #left; rDU: 283 r: #left; tDU: 120 r: #top; bDU: 152 r: #top);
                    startGroup;
                    contents: 'Capas de Informacin:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 232; lDU: 37 r: #left; tDU: 254 r: #bottom);
                    contents: (CPBitmapDict at: 'recycle');
                    stretchToFit;
                    startGroup;
                    when: #getContents perform: #propertyContents:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 142 @ 32; lDU: 411 r: #left; tDU: 104 r: #bottom);
                    rightJustified;
                    startGroup;
                    when: #getContents perform: #selectedSize:;
                    contents: 'Size'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 32; lDU: 571 r: #left; tDU: 104 r: #bottom);
                    contents: (CPBitmapDict at: 'size');
                    startGroup; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 142 @ 32; lDU: 414 r: #left; tDU: 146 r: #bottom);
                    rightJustified;
                    startGroup;
                    when: #getContents perform: #selectedOrigin:;
                    contents: 'Position'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 32; lDU: 571 r: #left; tDU: 146 r: #bottom);
                    contents: (CPBitmapDict at: 'position');
                    startGroup; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 475 @ 44; lDU: 130 r: #left; rDU: 606 r: #left; tDU: 68 r: #top; bDU: 112 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #mapName:;
                    when: #textChanged perform: #mapNameChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 512 @ 348; lDU: 21 r: #left; rDU: 533 r: #left; tDU: 152 r: #top; bDU: 358 r: #bottom);
                    defaultStyle;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #layers:;
                    when: #select perform: #selectLayer:;
                    when: #doubleClickSelect perform: #layerDoubleClicked:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 231 @ 132; lDU: 153 r: #left; tDU: 314 r: #bottom);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #properties:;
                    when: #select perform: #propertySelected:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 48; lDU: 30 r: #left; tDU: 314 r: #bottom);
                    add: #fileOpen selector: #fileOpenProperty;
                    add: #editDelete selector: #editDeleteProperty;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolPalette new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 59 @ 360; lDU: 549 r: #left; rDU: 608 r: #left; tDU: 152 r: #top; bDU: 512 r: #top);
                    add: #editNew;
                    add: #edit;
                    add: #editCopy;
                    add: #editPaste;
                    add: #editUpdate;
                    add: #fileRead;
                    add: #editDelete;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                PaneWithRulers new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 777 @ 840; lDU: 622 r: #left; rDU: 9 r: #right; tDU: 8 r: #top; bDU: 10 r: #bottom);
                    paneName: 'graph';
                    backColor: ClrPalegray;
                    startGroup;
                    tabStop;
                    when: #getContainedPane perform: #createGraphPane:;
                    addSubpanes; font: self defaultFont;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 601 @ 50; lDU: 16 r: #left; rDU: 617 r: #left; tDU: 10 r: #top; bDU: 60 r: #top);
                    add: #fileNew;
                    add: #fileOpen;
                    add: #fileRead spaces: 3;
                    add: #fileSave spaces: 3;
                    add: #fileSaveAs;
                    add: #fileCopy spaces: 3;
                    add: #filePaste;
                    add: #toolHalt spaces: 3;
                    add: #fileRestore;
                    add: #fileExit spaces: 5;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 121 @ 50; lDU: 487 r: #left; tDU: 60 r: #bottom);
                    add: #toolHalt;
                    add: #toolDebug;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).! 
edit
    "Lets the user edit the durrent layer"
    | current |
    current := self selectedLayer.
    current isNil ifTrue: [^self].
    (current respondsTo: #editWith:) ifTrue: [ ^current editWith: self ].
    ^current inspect!   
editCopy
    "Lets the user copy the durrent layer to the clipboard"
    | current |
    current := self selectedLayer.
    current isNil ifTrue: [^self].
    CursorManager execute changeFor: [
        Clipboard setObject: current
    ]!  
editDelete
    "Lets the user delete the current selected layer..."
    | layer |
    (mapView isNil or: [mapView map isNil]) ifTrue: [ ^self ].
    layer := self selectedLayer.
    layer isNil ifTrue: [^self fullUpdate].
    (MessageBox confirm: 'Esta seguro de querer borrar ',layer name asString, ' ?')
    ifTrue: [
        mapView map removeLayer: layer.
        self fullUpdate.
    ].!
editDeleteProperty

    property isNil ifTrue: [^self].
    (mapView isNil or: [mapView map isNil]) ifTrue: [ ^self ].

    self property: nil.! 
editLayer: aPane
    "Lets the user edit the durrent layer"
    ^self edit! 
editNew
    "Lets the user create a new layer..."
    | newLayer |
    (mapView isNil or: [mapView map isNil]) ifTrue: [ ^self ].
    newLayer := OSPrompter prompt: 'Nombre de la nueva capa ?' default: String new.
    newLayer isNil ifTrue: [^nil].
    newLayer := newLayer trimBlanks.
    newLayer isEmpty ifTrue: [^nil].
    mapView map
        newLayer: newLayer
        opaque: (MessageBox confirm: 'Es una capa de informacin opaca?\\*ATENCIN : Las capas opacas no pueden contener objetos.'withCrs).
    self
        changed: #layers: with: #restoreSelected: with: newLayer;
        yourself!   
editPaste
    "Lets the user paste a layer from the clipboard"
    | layer |
    layer := Clipboard getObject.
    layer isNil ifTrue: [^nil].

    CursorManager execute changeFor: [
        (layer isKindOf: Layer)
        ifTrue: [
            self map layers add: layer.
            self fullUpdate
        ]
        ifFalse: [
            (layer isKindOf: Map)
            ifTrue: [
                layer layers do: [:aLayer|
                    self map layers add: aLayer
                ].
                self fullUpdate
            ]
            ifFalse: [
                MessageBox warning: 'No se como colocar el objeto en el portapapeles [',layer class name,']'
            ]
        ]
    ].! 
fileExtension
    "Private - Returns the default file extension"
    ^'.Map'!   
fileOpenProperty

    | dialog file image |
    (mapView isNil or: [mapView map isNil]) ifTrue: [ ^self ].
    image := mapView map stampClass fromUser.
    self property: image.!  
fileRead
    "The receiver will work using scanner obtained from a file..."

    | dialog file |
    dialog := FileDialog new.
    dialog
      title: 'Archivo a leer...';
      addFilter: '*.txt' description: 'Archivos de texto (*.txt)';
      addFilter: '*.*' description: 'Todos los archivos (*.*)';
      defFilter: '*.txt';fileSpec: '*.txt';
      hideReadonly;open.
    file := dialog file.
    file isNil ifTrue: [^self].
    CursorManager execute changeFor: [
        LayerScanner scan: file for: mapView map
    ].
    self refresh.!
fileSave
    "Lets the user save the map..."

    pathName size = 0 ifTrue: [^self fileSaveAs ].

    CursorManager execute changeFor: [
        ObjectFiler dump: mapView map newFile: pathName.
    ].!  
fileSaveAs
    "Lets the user save the map in a new file..."

    | newName |
    newName := self fileSaveAs: pathName.
    newName notNil ifTrue: [
        pathName := newName
    ].!   
initialize
    "Private - Initialize the receiver"

    super initialize.
    property := #stamp.
    pathName := String new.!   
layerDoubleClicked: aPane

    "Callback for the #doubleClickSelect event in an unnamed ListPane.
     (Generated by WindowBuilder)"

    self editLayer: nil!   
layers: aPane

    "Callback for the #getContents event in an unnamed ListPane.
     (Generated by WindowBuilder)"

    | names |
    (mapView isNil or: [mapView map isNil]) ifTrue: [ ^self ].
    names := mapView map layers collect: [:each |each name].
    aPane contents: names.
    names size > 0 ifTrue: [aPane selection: 1].!   
mapName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    (mapView isNil or: [mapView map isNil]) ifTrue: [ ^self ].

    aPane contents: mapView map name!   
mapNameChanged: aPane

    "Callback for the #textChanged event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    (mapView isNil or: [mapView map isNil]) ifTrue: [ ^self ].

    mapView map name: aPane contents!
properties: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    aPane
        contents: self propertyDictionary values asSortedCollection;
        selection: (self propertyDictionary at: property ifAbsent: [])! 
property: aProperty
    "Private - Sets the new property contents..."

    mapView map perform: (property,':') asSymbol with: aProperty.
    self changed: #propertyContents:.!   
propertyContents: aPane

    "Callback for the #getContents event in an unnamed CPBitmapPane.
     (Generated by WindowBuilder)"

    | contents |

    (property isNil | mapView isNil
    or: [mapView map isNil
    or: [mapView map stamp isNil
    or: [
        contents := mapView map perform: property.
        contents isNil
    ]]])
    ifTrue: [ ^aPane contents: (CPBitmapDict at: 'recycle') ].

    aPane contents: contents!
propertyDictionary
    "Private - Returns the dictionary for properties"

    ^Dictionary new
        at: #stamp put: 'Estampilla';
        at: #references put: 'Cuadro de Referencias';
        yourself! 
propertySelected: aPane

    "Callback for the #select event in an unnamed CPSpinButton.
     (Generated by WindowBuilder)"

    property = aPane selectedItem ifTrue: [^self].
    property := self propertyDictionary keyAtValue: aPane selectedItem ifAbsent: [].
    self changed: #propertyContents:.!
selectedLayer
    "Private - returns the currently selected layer or nil..."
    | current |
    current := (self paneAt: #layers:) selectedItem.
    current isNil ifTrue: [^nil].
    current := mapView map layers
        detect: [:each| each name = current]
        ifNone: [self fullUpdate.^nil].
    ^current!  
selectedOrigin: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Position').
     (Generated by WindowBuilder)"

    selection isNil
    ifTrue: [ aPane contents: String new ]
    ifFalse: [ aPane contents: selection leftTop asString ]! 
selectedSize: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Size').
     (Generated by WindowBuilder)"

    selection isNil
    ifTrue: [ aPane contents: String new ]
    ifFalse: [ aPane contents: selection extent asString ]!
selectionHasChanged
    "Private - The current selection has changed..."

    super selectionHasChanged.

    self
        changed: #selectedOrigin:;
        changed: #selectedSize:;
        yourself.! 
selectLayer: aPane

    "Callback for the #select event in an unnamed ListPane.
     (Generated by WindowBuilder)"!
title
    "Private - Returns the current title..."

    ^self titleWithPath: pathName! !

! InterfaceMapGenerator class methods !
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (fileNew 'Crea un nuevo scanner.')
        (fileOpen 'Abre un file de scanner y un mapa de fondo...')
        (fileSave 'Graba el codigo del scanner actual.')
        (fileEditWindow 'Abre una ventana de texto con el ultimo fuente generado...')
        (fileRead 'Abre un file de scanner...')
        (changeMap 'Permite cambiar el mapa de fondo...')
        (toolHalt 'Inspeccion del receptor...')
        (toolDebug 'Inspeccion del scanner...')
        (toolCalculate 'Calcula la escala en base a la seleccion actual...')
        (gotoPage 'Hubica una nueva basada en la seleccion actual...')
        ), super helpMap!
wbCreated

    ^true! !

! InterfaceMapGenerator methods !
changeMap
    "Lets the user change the map file..."

    | map |
    map := self model mapFromUser.
    map isNil ifTrue: [^self].
    mapView := map.
    self fullUpdate.!  
classes: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | cole |
    cole := Information withAllSubclasses.

    aPane
        contents: cole;
        selection: scanner instanceClass.

    self enable: aPane when: cole size > 1.!   
columns: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: scanner columns! 
columnsChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    scanner columns: aPane contents! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Constructor de interfases de capas de informacin';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1435 @ 632; lDU: 16 r: #left; tDU: 20 r: #top; cRDU: (9 @ 624 rightBottom: 1426 @ 46));
            pStyle: #(sysmenu maximize titlebar sizable minimize);
            when: #activate perform: #activateView:;
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 32; lDU: 119 r: #left; rDU: 183 r: #left; tDU: 320 r: #top; bDU: 352 r: #top);
                    startGroup;
                    contents: 'Tipo'; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 73 @ 32; lDU: 101 r: #left; rDU: 174 r: #left; tDU: 104 r: #top; bDU: 136 r: #top);
                    startGroup;
                    contents: 'Clase'; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 27 r: #left; rDU: 155 r: #left; tDU: 480 r: #top; bDU: 512 r: #top);
                    startGroup;
                    contents: 'Expresion:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 82 @ 32; lDU: 27 r: #left; rDU: 110 r: #left; tDU: 436 r: #top; bDU: 468 r: #top);
                    startGroup;
                    contents: 'Filas:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 322 r: #left; rDU: 432 r: #left; tDU: 436 r: #top; bDU: 468 r: #top);
                    startGroup;
                    contents: 'Columnas:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                PaneWithRulers new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 754 @ 498; lDU: 654 r: #left; rDU: 9 r: #right; tDU: 70 r: #top; bDU: 10 r: #bottom);
                    paneName: 'graph';
                    backColor: ClrPalegray;
                    startGroup;
                    when: #getContainedPane perform: #createGraphPane:;
                    addSubpanes; font: self defaultFont;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 393 @ 44; lDU: 658 r: #left; rDU: 1051 r: #left; tDU: 8 r: #top; bDU: 52 r: #top);
                    add: #gotoPage;
                    add: #toolCalculate;
                    add: #viewStamp selector: #changeMap spaces: 5;
                    add: #toolHalt spaces: 5;
                    add: #toolDebug;
                    startGroup;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 114 @ 32; lDU: 123 r: #right; rDU: 9 r: #right; tDU: 14 r: #top; bDU: 46 r: #top);
                    startGroup;
                    when: #getContents perform: #selectedSize:;
                    contents: 'Tam.'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 32; lDU: 169 r: #right; rDU: 133 r: #right; tDU: 14 r: #top; bDU: 46 r: #top);
                    contents: (CPBitmapDict at: 'size');
                    startGroup; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 309 r: #right; rDU: 181 r: #right; tDU: 14 r: #top; bDU: 46 r: #top);
                    startGroup;
                    when: #getContents perform: #selectedOrigin:;
                    contents: 'Posicin'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 32; lDU: 357 r: #right; rDU: 320 r: #right; tDU: 14 r: #top; bDU: 46 r: #top);
                    contents: (CPBitmapDict at: 'position');
                    startGroup; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 638 @ 336; lDU: 9 r: #left; tDU: 56 r: #top);
                    contents: 'Creacin de objetos'; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 601 @ 216; lDU: 27 r: #left; tDU: 160 r: #top);
                    contents: 'Columnas de tabla'; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 638 @ 172; lDU: 9 r: #left; tDU: 396 r: #top);
                    contents: 'Formula'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 638 @ 56; lDU: 9 r: #left; tDU: 2 r: #top);
                    in; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 48; lDU: 119 r: #left; tDU: 430 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #columns:;
                    when: #valueChanged perform: #columnsChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 44; lDU: 446 r: #left; tDU: 430 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #rows:;
                    when: #valueChanged perform: #rowsChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 530 @ 44; lDU: 27 r: #left; rDU: 558 r: #left; tDU: 512 r: #top; bDU: 556 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #formula:;
                    when: #textChanged perform: #formulaChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 75 @ 44; lDU: 558 r: #left; rDU: 633 r: #left; tDU: 512 r: #top; bDU: 556 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #testFormula:;
                    contents: 'Test'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 443 @ 272; lDU: 185 r: #left; rDU: 629 r: #left; tDU: 96 r: #top; bDU: 368 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #classes:;
                    when: #select perform: #newClassSelected:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 56; lDU: 46 r: #left; rDU: 183 r: #left; tDU: 200 r: #top; bDU: 256 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #removeInstance:;
                    contents: 'Remover'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 56; lDU: 46 r: #left; rDU: 183 r: #left; tDU: 260 r: #top; bDU: 316 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #resetInstances:;
                    contents: 'Reset'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 430 @ 112; lDU: 187 r: #left; rDU: 617 r: #left; tDU: 202 r: #top; bDU: 314 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #instances:;
                    when: #select perform: #instanceSelected:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 430 @ 44; lDU: 187 r: #left; rDU: 617 r: #left; tDU: 320 r: #top; bDU: 364 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #instanceType:;
                    when: #textChanged perform: #instanceTypeChanged:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 615 @ 44; lDU: 16 r: #left; rDU: 631 r: #left; tDU: 8 r: #top; bDU: 52 r: #top);
                    add: #fileNew;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #fileEditWindow;
                    add: #fileRead;
                    add: #viewStamp selector: #changeMap spaces: 5;
                    add: #toolHalt;
                    add: #fileExit spaces: 10;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!  
fileEditWindow
    "Open filedOut source file..."

    | file |
    pathName isNil ifTrue: [^self beep].

    (File exists: pathName)
    ifFalse: [^self error: 'El archivo ',pathName,' ha sido borrado o no est disponible para lectura.'].

    file := File pathNameReadOnly: pathName.
    TextWindow new sendInputEvent: #openOnFile: with: file.
    file close!  
fileNew
    "The receiver will work in a new map..."

    self initializeScanner.
    pathName := nil.
    self changeMap.!  
fileOpen
    "The receiver will work in a map
    and scanner obtained from a file..."

     | dialog file map source |

    dialog := FileDialog new.
    dialog
        title: 'Elija el archivo a interpretar...';
        addFilter: '*.src' description: 'Archivos de cdigo de interfz (*.SRC)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        defFilter: '*.src'; fileSpec: '*.src';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].

    self initializeScanner.
    scanner fileIn: file.
    pathName := file.

    self changeMap.! 
fileRead
    "The receiver will work using scanner obtained from a file..."

     | dialog file map source |
    pathName isNil
    ifTrue: [
        dialog := FileDialog new.
        dialog
            title: 'Elija el archivo a interpretar...';
            addFilter: '*.src' description: 'Archivos de cdigo de interfz (*.SRC)';
            addFilter: '*.*' description: 'Todos los archivos (*.*)';
            defFilter: '*.src'; fileSpec: '*.src';
            hideReadonly;
            open.
        file := dialog file.
        file isNil ifTrue: [^self].
    ] ifFalse: [ file := pathName ].

    self initializeScanner.
    scanner fileIn: pathName.

    self fullUpdate.!
fileSave
    "The receiver save the scanner in a file..."

     | dialog file |

    dialog := FileDialog new.
    dialog
        title: 'Elija donde desea grabar el cdigo de interfz';
        addFilter: '*.src' description: 'Archivos de cdigo de interfz (*.SRC)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        fileSpec: (pathName isNil ifTrue: ['Anonimo.Src'] ifFalse: [pathName]);
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^self].

    CursorManager execute changeFor: [

        (file includes: $.) ifFalse: [file := file,'.Src'].
        self backUpFile: file.

        scanner fileOut: file.
        pathName := file.
    ].!
formula: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    aPane contents: scanner formula.! 
formulaChanged: aPane

    "Callback for the #textChanged event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    scanner formula: aPane contents trimBlanks!
gotoPage
    " Private - Set a new page offset at current selection..."

    | answers name position |
    selection isNil ifTrue: [^self beep].
    answers := OSPrompter new
        title: 'Configuracion de pgina...';
        questions: #( 'Nombre de la pgina ?' 'Posicin en el mapa :');
        answers: (Array with: (scanner pages size + 1) asString with: selection asString );
        open.

    answers isNil ifTrue: [^nil].
    name := answers first trimBlanks.
    name size = 0 ifTrue: [^self].

    position := scanner
        evaluate: (answers at: 2)
        ifFail: [^self error: 'Expresin errnea para pgina ', (answers at: 2)].

    scanner pages at: name put: position!  
initialize
    " Private - Initialize the receiver..."

    super initialize.
    self initializeScanner! 
initializeScanner
    " Private - Initialize the receiver Scanner..."

    scanner := LayerScanner new.!   
instances: aPane

    "Callback for the #getContents event in an unnamed ListBox.
     (Generated by WindowBuilder)"

    | cole |
    cole := scanner variables collect: [:asoc| asoc key ].
    aPane contents: cole.
    cole size > 0 ifTrue: [ aPane selection: 1 ].!
instanceSelected: aPane

    "Callback for the #select event in an unnamed ListBox.
     (Generated by WindowBuilder)"

    self changed: #instanceType:!
instanceType: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    | item |
    item := (self paneAt: #instances:) selectedItem.
    item isNil
    ifTrue: [ aPane contents: String new ]
    ifFalse: [
        scanner variables do: [:asoc|
          asoc key = item
          ifTrue: [ aPane contents: asoc value asString ]
        ]
    ].!  
instanceTypeChanged: aPane

    "Callback for the #textChanged event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    | item |
    item := (self paneAt: #instances:) selectedItem.
    item isNil
    ifFalse: [
        scanner variables do: [:asoc|
          asoc key = item
          ifTrue: [ asoc value: (Smalltalk at: aPane contents asSymbol )]
        ]
    ].!   
minimumSelection
    "Private - Returns the minimum selection size"
    ^1@1!   
newClassSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    scanner instanceClass: aPane selectedItem.
    self resetInstances: nil!   
removeInstance: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Remove').
     (Generated by WindowBuilder)"

    | item |
    item := (self paneAt: #instances:) selectedItem.
    item isNil
    ifFalse: [
        scanner variables do: [:asoc|
          asoc key = item
          ifTrue: [
            scanner variables remove: asoc.
            self changed: #instances:;changed:#instanceType:.
            ^self
            ]
        ]
    ].! 
resetInstances: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Reset').
     (Generated by WindowBuilder)"

    scanner resetVariables.

    self
        changed: #instances:;
        changed: #instanceType:;
        yourself!  
rows: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: scanner rows!   
rowsChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    scanner rows: aPane contents!   
selectedOrigin: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Position').
     (Generated by WindowBuilder)"

    selection isNil
    ifTrue: [ aPane contents: String new ]
    ifFalse: [ aPane contents: selection leftTop asString ]! 
selectedSize: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Size').
     (Generated by WindowBuilder)"

    selection isNil
    ifTrue: [ aPane contents: String new ]
    ifFalse: [ aPane contents: selection extent asString ]!
selectionHasChanged
    "Private - The current selection has changed..."

    super selectionHasChanged.

    self
        changed: #selectedOrigin:;
        changed: #selectedSize:;
        yourself.! 
testFormula: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Test').
     (Generated by WindowBuilder)"

    | answers point |
    answers := OSPrompter new
        title: 'Valores para testeo de intrprete...';
        questions: #( 'Nro de Hoja ?' 'Fila ?' 'Columna ?' );
        answers: (Array with: '38' with: 'G' with: '2' );
        open.

    answers isNil ifTrue: [^nil].

    scanner
        page: answers first
        file: (answers at: 2)
        column: (answers at: 3).

    point := scanner currentPosition.
    point isPoint
    ifTrue: [
        self showMapAt: point truncated.
        mapPane pen
            place: point truncated;
            circleFilled: 5.
    ].

    MessageBox message: 'Resultado :', point asString!   
toolCalculate
    "Calculate scale based on the current selection"

    | answers files columns extent |
    selection isNil ifTrue: [^self beep].
    extent := selection extent.
    answers := OSPrompter new
        title: 'Clculo de escala basado en la seleccin...';
        questions: #( 'Nmero de Filas ?' 'Nmero de Columnas ?' 'Ancho de la Hoja ? (en pixels)');
        answers: (Array with: scanner rows asString with: scanner columns with: extent asString);
        open.

    answers isNil ifTrue: [^nil].
    files := scanner evaluate: answers first ifFail: [self beep].
    columns := scanner evaluate: (answers at: 2) ifFail: [self beep].
    extent := scanner evaluate: (answers at: 3) ifFail: [self beep].
    extent isPoint ifFalse: [^self error: 'El ancho de la hoja debe ser un punto...'].

    scanner scale: extent / (columns @ files).

    self
        changed: #rows:;
        changed: #columns:;
        yourself! !

! MapReferenceEditor class methods !   
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (fileNew 'Crea un nuevo mapa.')
        (fileSave 'Graba el mapa actual.')
        (fileSaveAs 'Graba el mapa actual con otro nombre.')
        (fileRead 'Lee un archivo de datos...')

        (editNew 'Permite crear una nueva informacion en el punto selecto')
        (editNewDocument 'Permite crear una nueva informacion en el punto selecto')
        (edit 'Permite modificar la informacion selecta')
        (editCopy 'Permite copiar toda la informacion selecta al clipboard')
        (editPaste 'Agrega la informacion que este presente en el clipboard en el punto selecto')
        (editUpdate 'Refresca la ventana')
        (editDelete 'Borra la informacion selecta')

        ), super helpMap!  
wbCreated

    ^true! !

! MapReferenceEditor methods !   
categories: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | layer |
    (layer := self layerNamed:self selectedLayer) isNil ifTrue: [^aPane contents: #()].
    aPane contents: layer categoryNames asSortedCollection.! 
categoryNamed: aString
    "Private - Returns the category named aString in the current selected layer
    or nil..."
    | layer |
    layer := self layerNamed: self selectedLayer.
    layer isNil ifTrue: [^nil].
    ^layer categoryNamed: aString!
checkSelection
    "Private - The selection must be checked..."

    selection isNil ifTrue: [^self].
    super checkSelection.
    (selection width < self selectionRadix
    or: [selection height < self selectionRadix])
    ifTrue: [ self selectionInProgress: nil ].!   
classes: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    descriptions isNil ifTrue: [ descriptions := Information descriptions ].
    aPane
        contents: descriptions values asSortedCollection;
        selection: (descriptions at: Information).! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Editor de referencias';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 942 @ 784; xC; yC; cRDU: (9 @ 776 rightBottom: 933 @ 46));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            when: #activate perform: #activateView:;
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 32; lDU: 9 r: #left; rDU: 110 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    startGroup;
                    contents: 'Capa:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 9 r: #left; rDU: 137 r: #left; tDU: 58 r: #top; bDU: 90 r: #top);
                    startGroup;
                    contents: 'Categora:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 82 @ 32; lP: 48/101; rP: 57/101; tDU: 58 r: #top; bDU: 90 r: #top);
                    startGroup;
                    contents: 'Tipo:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 293 @ 270; lDU: 139 r: #left; rP: 189/404; tDU: 8 r: #top; bDU: 278 r: #top);
                    dropDown;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #layers:;
                    when: #select perform: #layerSelected:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 293 @ 270; lDU: 139 r: #left; rP: 189/404; tDU: 58 r: #top; bDU: 328 r: #top);
                    dropDown;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #categories:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 384 @ 270; lP: 57/101; rDU: 18 r: #right; tDU: 58 r: #top; bDU: 328 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #classes:; font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 293 @ 48; lP: 57/101; rDU: 110 r: #right; tDU: 8 r: #top; bDU: 56 r: #top);
                    add: #editNewDocument;
                    add: #edit;
                    add: #editDelete;
                    add: #fileSave spaces: 3;
                    add: #fileExit spaces: 5;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                PaneWithRulers new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 923 @ 618; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 112 r: #top; bDU: 0 r: #bottom);
                    paneName: 'graph';
                    backColor: ClrPalegray;
                    startGroup;
                    tabStop;
                    when: #getContainedPane perform: #createGraphPane:;
                    addSubpanes;
                    yourself
            );
        yourself
    ).!  
drawSelectionIn: aRectangle with: aPen
    "Private - Draw the current selection..."

    | backUp |
    backUp := aPen location.
    aPen
        setRop2: R2Notxorpen;
        setLineWidth: self selectionLineWidth;
        place: selection center;
        circle: self selectionRadix;
        setRop2: R2Copypen;
        setLineWidth: 1;
        place: backUp;
        yourself!  
edit
    "Edit the elements at current selection"

    | elements layer |
    elements := self selectedElements.
    elements do: [:element| element edit ].!
editDelete
    "Remove the elements at current selection"

    | elements layer |
    elements := self selectedElements.
    elements do: [:element|
        (MessageBox confirm: 'Seguro borra el elemento ', element name asString,' ?')
        ifTrue: [
            (self layerNamed: self selectedLayer) remove: element
        ].
        self updateView
    ].!  
editNewDocument
    "Lets the user add a new information at selected point..."

    | point layerName layer category class element |
    point := self selectedPoint.
    point isNil ifTrue: [
        self beep.
        MessageBox message: 'Seleccione el punto donde colocar la informacin...'.
        ^self
        ].
    layerName := self selectedLayer.
    layerName size = 0 ifTrue: [
        self beep.
        MessageBox message: 'Seleccione una capa de informacin...'.
        ^self
        ].
    category := self selectedCategory.
    category size = 0 ifTrue: [
        self beep.
        MessageBox message: 'Seleccione una categoria...'.
        ^self
        ].
    class := self selectedClass.
    class isNil ifTrue: [
        self beep.
        MessageBox message: 'Seleccione una clase de informacin...'.
        ^self
        ].

    layer := self layerNamed: layerName.
    layer isNil ifTrue: [
        layer := self map newLayer: layerName.
        self changed: #layers:.
    ].

    element := class new.
    element edit.

    element name isNil ifTrue: [
        MessageBox warning: 'El elemento debe tener nombre...'.
        ^self beep
    ].

    layer add: element at: point type: category.
    self updateView.!   
layerNamed: aString
    "Private - Returns the layer named aString or nil..."

    ^self map layerNamed: aString!  
layers: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | layers |
    layers := (self map layers collect: [:each| each name]) asSortedCollection.
    aPane contents: layers.
    layers size > 0 ifTrue: [ aPane text: layers first ].! 
layerSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    self changed: #categories: with: #restoreSelected! 
minimumSelection
    "Private - Returns the minimum selection size"
    ^0@0!   
selectedCategory

    | text |
    text := (self paneAt: #categories:) text.
    ^text size > 0 ifTrue: [text]!   
selectedClass

    | item |
    item := (self paneAt: #classes:) selectedItem.
    ^item notNil ifTrue: [ descriptions keyAtValue: item ]!
selectedElements

    | layer category elements |
    selection isNil ifTrue: [^#()].
    layer := self layerNamed: self selectedLayer.
    layer isNil ifTrue: [
        self beep.
        MessageBox message: 'Seleccione una capa de informacion...'.
        ^#()
        ].
    category := layer categoryNamed: self selectedCategory.
    category isNil ifTrue: [
        self beep.
        MessageBox message: 'Seleccione una categoria...'.
        ^#()
        ].
    elements := (category elementsInRectangle: selection) asArray.
    elements isEmpty ifTrue: [^#()].
    elements size > 1 ifTrue: [
        elements := MultiSelectListDialog new
            title: 'Elija cuales desea seleccionar...';
            openOn: elements.
        elements isNil ifTrue: [^#()].
    ].
    ^elements! 
selectedLayer

    | text |
    text := (self paneAt: #layers:) text.
    ^text size > 0 ifTrue: [text]!  
selectedPoint
    "Private - Returns the currently selected point or nil..."

    ^selection notNil ifTrue: [ selection center ]!  
selectionInProgress:aPane
    "Private - A selection operation is in progress.
     aPane will have the #mode and #displacement"

    | radix |
    selection isNil ifTrue: [^self].
    radix := self selectionRadix.
    selection := selection center - (radix // 2) extent: radix! 
selectionRadix
    "Private - Returns the current selection radix..."

    ^16! !

! PathEditor class methods !  
cursors
    " Private - Initialize the receiver's cursors..."

    (super cursors includesKey: #flag)
    ifFalse: [
        Cursors
            at: #flag put: CursorManager crossHair;
            at: #add put: CursorManager normal;
            yourself
    ].
    ^super cursors!
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (fileSave 'Graba el recorrido y mapa actual.')
        (editCopy 'Permite insertar un punto nuevo entre otros dos...')
        (editDelete 'Borra el punto selecto')
        (editUpdate 'Refresca la ventana')
        (editMove 'Permite mover un punto')
        (editSelect 'Permite agregar un punto al final')
        (toolDebug 'Inspeccin del recorrido actual...')
        ), super helpMap!
wbCreated

    ^true! !

! PathEditor methods !   
addFlag
    "Private - Lets the user add a new flag..."

    self mode: #flag! 
addFlag: aPane
    "Private - Add a new flag..."

    | point current pen |
    point := self mouseLocation.
    flags addLast: point.
    self
        displayFlag: self flagIcon
        at: flags last
        with: mapPane pen.!
addPoint: aPane
    "Private - Add current point to the path"

    | point |
    self path isNil ifTrue: [^self beep].
    point := self mouseLocation.
    path perform: self addSelector with: point copy.
    self drawPath.!   
addSelector
    "Private - Returns the selector to be used for addition"
    | selector |
    selector := self mapPane propertyAt: #addSelector.
    selector isNil ifTrue: [^#addLast:].
    ^selector! 
addSelector: aSymbol
    "Private - Sets the selector to be used for addition"

    self mapPane propertyAt: #addSelector put: aSymbol!
basicFileSave
    "Private - Do default saving..."

    super fileSave.!   
boundsAround: point
    "Private - Return the boundingRectangle for points around
    point in the current path..."

    | vertex bounds index |
    vertex := Array with: point with: point with: point.
    index := path indexOf: point.
    index > 1 ifTrue: [vertex at: 1 put: (path at: index - 1)].
    index < path size ifTrue: [vertex at: 3 put: (path at: index + 1)].
    ^self boundsOf: vertex!  
boundsOf: aCollection
    "Private - Returns the bounding rectangle for current path"

    | left right top bottom |
    aCollection size < 2 ifTrue: [^nil].
    left := right := aCollection first x.
    top := bottom := aCollection first y.
    aCollection do: [:each|
        left := left min: each x.
        right := right max: each x.
        top := top min: each y.
        bottom := bottom max: each y.
    ].
    ^(left @ top rightBottom: right @ bottom)
        expandBy: self gap + 1 "yapa"!   
button1DoubleClick: aPane

    "Callback for the #button1DoubleClick event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    super button1DoubleClick: aPane.
    self do: (mode at: 4) with: aPane!  
button1Down: aPane

    "Callback for the #button1Down event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    super button1Down: aPane.
    self do: mode first with: aPane! 
button1Move: aPane

    "Callback for the #button1Move event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    super button1Move: aPane.
    self do: (mode at: 3) with: aPane!   
button1Up: aPane

    "Callback for the #button1Up event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    super button1Up: aPane.
    self do: (mode at: 2) with: aPane! 
clearPoint: aPane
    "Private - Clear selected point"

    self
        lastPoint: nil;
        currentPoint: nil.! 
createGraphPane: aPaneWithRulers
    "Private - Process the getContens event for the rulered pane"

    super createGraphPane: aPaneWithRulers.
    self mode: #add.! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Editor de Recorridos';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1216 @ 704; xC; yC; cRDU: (9 @ 696 rightBottom: 1207 @ 46));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            when: #activate perform: #activateView:;
            backColor: ClrPalegray;
            addSubpane: (
                PaneWithRulers new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1198 @ 596; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 54 r: #top; bDU: 0 r: #bottom);
                    paneName: 'graph';
                    backColor: ClrPalegray;
                    startGroup;
                    when: #getContainedPane perform: #createGraphPane:;
                    addSubpanes;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 706 @ 48; lDU: 5 r: #left; rDU: 711 r: #left; tDU: 2 r: #top; bDU: 50 r: #top);
                    add: #editSelect;
                    add: #editMove;
                    add: #editDelete;
                    add: #editCopy;
                    add: #fileSave;
                    add: #editNew selector: #newFlags spaces: 3;
                    add: #fileOpen selector: #openFlags;
                    add: #fileSave selector: #saveTheFlags;
                    add: #editFlag selector: #addFlag rbSelector: #removeLastFlag;
                    add: #toolHalt spaces: 3;
                    add: #toolDebug;
                    add: #fileExit spaces: 3;
                    startGroup;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 350 @ 48; lDU: 352 r: #right; rDU: 2 r: #right; tDU: 2 r: #top; bDU: 50 r: #top);
                    add: #gotoFirst;
                    add: #gotoLast;
                    add: #editUpdate;
                    add: #fileNew spaces: 3;
                    add: #fileOpen;
                    add: #fileSaveAs;
                    postAutomatic;
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).! 
currentIndex
    "Private - Returns the current index"

    ^self mapPane propertyAt: #currentIndex!   
currentIndex: anObject
    "Private - Sets the current index"

    self mapPane propertyAt: #currentIndex put: anObject!   
currentPoint
    "Private - Returns the current point"

    ^self mapPane propertyAt: #currentPoint!   
currentPoint: anObject
    "Private - Sets the current point"

    self mapPane propertyAt: #currentPoint put: anObject!   
deletePoint: aPane
    "Private - Delete the currently selected point"

    | point current pen rect |
    self path size = 0 ifTrue: [^self beep].
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    point := self currentPoint.
    point isNil ifTrue: [^self].
    (MessageBox confirm: 'Seguro remueve el punto ',point asString,' ?')
    ifFalse: [^self].
    rect := self boundsAround: point.
    path remove: point ifAbsent: [^self beep].
    self updateRectangle: rect.!   
detectMovePoint: aPane
    "Private - Detect point under cursor & switches to move mode..."

    | point distances index |
    self detectPoint: aPane.
    path size = 0 ifTrue: [^self].
    point := self mouseLocation.
    distances := path collect: [:each| (each - point) modulus asInteger ].
    index := (1 to: distances size) detect: [:i|
        (distances at: i) <= self gap
    ] ifNone: [0].

    index > 0
    ifTrue: [ self editMove ]
    ifFalse: [ self editSelect ].

    self lastPoint: nil.
    self detectPoint: aPane.!  
detectPoint: aPane
    "Private - Detect point under cursor"

    | point distances min index |
    self
        lastPoint: nil;
        currentPoint: nil.
    path size = 0 ifTrue: [^self].
    point := self mouseLocation.
    distances := path collect: [:each| (each - point) modulus asInteger ].
    min := distances first.
    index := 1.
    1 to: distances size do: [:i|
        (distances at: i) <= min
        ifTrue: [
            min := distances at: i.
            index := i
        ].
    ].

    self
        currentIndex: index;
        currentPoint: (path at: index)! 
displayFlag: anIcon at: aPoint with: aPen
    "Private - Display aFlag icon at aPoint"

    anIcon notNil
    ifTrue: [
        anIcon isBitmap
        ifTrue: [
            aPen
                copyBitmap: anIcon
                from: anIcon boundingBox
                to: ((aPoint - (anIcon extent // 2) extent: anIcon extent) scaleBy: self scale)
                rule: Srcand.
            ^self
        ].
        anIcon
            displayAt: (aPoint - (anIcon extent // 2)) * self scale
            with: aPen
    ]
    ifFalse: [
        aPen
            place: aPoint * self zoomFactor;
            circleFilled: 10.
    ]! 
displayRectangle: aRectangle with: aPen
    "Dibuja el area indicada por aRectangle usando aPen"

    super displayRectangle: aRectangle with: aPen.
    self
        drawPathIn: aRectangle with: aPen;
        drawFlagsIn: aRectangle with: aPen;
        yourself.!
do: action with: aPane
    "Private - Perform action with aPane"

    (action isNil or: [action = #none]) ifTrue: [^self].

    self
        perform: action
        with: aPane!  
drawFlagsIn: aRectangle with: aPen
    "Private - Draw the flags in aRectangle using aPen."

    | icon |
    icon := self flagIcon.
    flags do: [:each|
      (aRectangle isNil or: [aRectangle containsPoint: each])
      ifTrue: [ self displayFlag: icon at: each with: aPen ]
    ]!  
drawPath
    "Private - Draw the current path using map pane pen"
    | pen |
    pen := self mapPane pen.
    pen notNil ifTrue: [
        self drawPathIn: nil with: pen
    ].!  
drawPathIn: aRectangle with: aPen
    "Private - Draw the current path in aRectangle using aPen."

    | width color scale |
    aRectangle notNil
    ifTrue: [ (aRectangle width > 0 and: [ aRectangle height > 0 ]) ifFalse: [^self] ].
    self path size = 0 ifTrue: [^self].
    scale := self scale.
    width := aPen lineWidth.
    color := aPen foreColor.
" Transcript printMillisecondsToRun: [ "
    aPen
        foreColor: self pathColor;
        setRop2: "R2Notxorpen"R2Copypen;
        setLineWidth: self gap;
        yourself.

    aPen place: (path first * scale) truncated.
    path do: [:point| aPen goto: (point * scale) truncated ].
    path do: [:point| aPen place: (point * scale) truncated;circleFilled: ((self gap * scale) truncated max: 1) ].

    aPen
        foreColor: color;
        setLineWidth: width;
        setRop2: R2Copypen;
        yourself.
"]"! 
editCopy
    "Private - Set mode to split..."

    self mode: #split!  
editDelete
    "Private - Set mode to remove..."

    self mode: #delete!  
editMove
    "Private - Set mode to move..."

    self mode: #move!
editSelect
    "Private - Set mode to addLast..."

    self mode: #add!
fileNew
    "Clear the path"

    | old |

    "
    self beep.
    (MessageBox confirm: 'Seguro borra todos los puntos?')
    ifFalse: [^self].
    "

    old := path.
    path := self newPath.

    old isEmpty
    ifTrue: [  "clicked again..."
        Terminal bell.
        self editSelect.
    ]
    ifFalse: [
        self updateRectangle: (self boundsOf: old)
    ].!
fileOpen
    "Open a new path to be added to the receiver"

     | dialog file cole |

    dialog := FileDialog new.
    dialog
        title: 'Elija el archivo de recorridos a leer';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        addFilter: '*.pth' description: 'Archivos de recorridos (*.PTH)';
        defFilter: '*.pth';fileSpec: '*.pth';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].

    (file includes: $.)
    ifFalse: [ file := file ,'.pth' ].
    cole := ObjectFiler loadFromPathName: file.
    cole isNil ifTrue: [ ^self error: 'El archivo no contiene objetos...' ].
    cole isCollection ifFalse: [^self error: 'El contenido del archivo no es el esperado.'].

    cole do: [:each|
        self path perform: self addSelector with: each
    ].

    self updateRectangle: (self boundsOf: cole)!  
fileSave
    "Private - Save the current path evaluating the saveBlock and saving the map..."

    whenSaved value.
    super basicFileSave.! 
fileSaveAs
    "Private - Save the current path to a .PTH file..."

     | dialog file |

    self path size = 0 ifTrue: [^self beep].

    dialog := FileDialog new.
    dialog
        title: 'Elija donde guardar los recorridos.';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        addFilter: '*.pth' description: 'PArchivos de recorridos (*.PTH)';
        fileSpec: 'Anonimo.Pth';
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file size = 0 ifTrue: [^nil].

    (file includes: $.) ifFalse: [ file := file ,'.pth' ].
    self backUpFile: file.

    CursorManager execute changeFor: [
        ObjectFiler dump: path newFile: file.
    ].! 
flagIcon
    "Private - Returns the flag icon"

    ^CPBitmapDict at: 'flag' ifAbsent: []! 
gap
    "Private - Returns the gap size"

    ^5!  
gotoFirst
    "Lets the used add points previous to the first point in the path...
    Automatically set to add mode..."

    self
        addSelector: #addFirst:;
        editSelect! 
gotoLast
    "Lets the user add points next to the last point in the path...
    Automatically set to add mode..."

    self
        addSelector: #addLast:;
        editSelect!
initialize
    "Private - Initialize the receiver"

    super initialize.
    self initializePath.
    flags := OrderedCollection new.
    self whenSaved: nil.
    mode := Array new: 5.! 
initializePath
    "Private - Initialize the receiver's path..."

    path := self newPath.!   
lastPoint
    "Private - Returns the last point"

    ^self mapPane propertyAt: #lastPoint!
lastPoint: anObject
    "Private - Sets the last point"

    self mapPane propertyAt: #lastPoint put: anObject!
mode: aSymbol
    "Private - Configure the receiver for working in mode named aSymbol"

    | stream |
    stream := ReadStream on: self modes.
    [stream atEnd] whileFalse: [
        aSymbol = stream next
        ifTrue: [
            mode := stream next.
            mode last == #none ifFalse: [ self perform: mode last ].
            ^self
        ]
        ifFalse: [ stream next ]
    ].
    self error: 'Invalid mode #',aSymbol!
modes
    "Private - Return receiver's  interfase modes"

   ^#(
        "supportedMode (1Down 1Up 1Move DoubleClick mouseMove cursorShape modeSelectSelector)"
        add (detectMovePoint: addPoint: showNextPointToAdd: none none add none)
        move (detectMovePoint: movePoint: movingPoint: none showPoint: none none)
        delete (detectPoint: deletePoint: none none showPoint: none none)
        split (detectPoint: splitPoint: splittingPoint: none showPoint: none none)
        flag (none addFlag: none none none flag none)
        )! 
mouseMove: aPane

    "Callback for the #mouseMove event in the OSImagePane named 'map'.
     (Generated by WindowBuilder)"

    super mouseMove: aPane.
    self do: (mode at: 5) with: aPane.

    (mode at: 6) = #none ifFalse: [
        self mapPane setCursor: (self cursorFor: (mode at: 6))
    ].! 
movePoint: aPane
    "Private - Move the currently selected point"

    | point current rect1 rect2 |
    path size = 0 ifTrue: [^self].
    point := self mouseLocation.
    current := self currentPoint.
    current isNil ifTrue: [^self].
    rect1 := self boundsAround: current.
    current
        x: point x;
        y: point y.
    rect2 := self boundsAround: current.
    self updateRectangle: (rect1 merge: rect2)! 
movingPoint: aPane
    "Private - Show result of moving the currently selected point"

    | point last pen pred next index draw width pt scale |
    path size = 0 ifTrue: [^self].
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    point := self mouseLocation.
    index := self currentIndex.
    index isNil ifTrue: [^self].
    scale := self scale.
    last := self lastPoint.
    index > 1 ifTrue: [ pred := path at: index - 1].
    index < path size ifTrue: [ next := path at: index + 1].

    draw := [:p|
        pt :=  (p * scale) truncated.
       pred notNil ifTrue: [ pen lineFrom: (pred * scale) truncated to: pt ].
       pen place: pt truncated;circle: self gap.
       next notNil ifTrue: [ pen lineFrom: pt to: (next * scale) truncated ].
    ].

    width := pen lineWidth.
    pen
        setRop2: R2Notxorpen;
        setLineWidth: self gap.
    last notNil ifTrue: [ draw value: last ].
    draw value: point.
    pen
        setRop2: R2Copypen;
        setLineWidth: width.

    self lastPoint: point.!  
newFlags
    "Clear the current flags..."

    | old |

    self beep.
    (MessageBox confirm: 'Seguro borra todas las banderas ?')
    ifFalse: [^self].

    flags := OrderedCollection new.
    self updateView.!   
newPath
    "Private - Returns a new path..."

    ^OrderedCollection new! 
openFlags
    "Private - Read flags to be added to the receiver"

     | dialog file cole |

    dialog := FileDialog new.
    dialog
        title: 'Elija el archivo de banderas a leer...';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        addFilter: '*.flg' description: 'Archivos de banderas (*.FLG)';
        defFilter: '*.flg';fileSpec: '*.flg';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].

    cole := ObjectFiler loadFromPathName: file.
    cole isNil ifTrue: [ ^self error: 'El archivo no contiene objetos.' ].
    cole isCollection ifFalse: [^self error: 'El contenido del archivo es invlido'].

    flags addAll: cole.
    self updateView.! 
path
    "Returns the instance var of the receiver
     for external manipulation"
    ^path!  
pathBounds
    "Private - Returns the bounding rectangle for current path"

    ^self boundsOf: path!  
removeLastFlag
    "Private - Remove last flag..."

    | removed icon |
    flags isEmpty ifTrue: [^self beep].
    removed := flags removeLast.
    icon := self flagIcon.
    self updateRectangle: ((
        removed - (icon extent // 2)
            extent: icon extent) expandBy: 5)!
saveTheFlags
    "Private - Save the registered flags in a file"

     | dialog file |
    dialog := FileDialog new.
    dialog
        title: 'Elija el archivo donde guardar las banderas';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        addFilter: '*.flg' description: 'Archivos de banderas (*.FLG)';
        fileSpec: 'Anonimo.flg';
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file size = 0 ifTrue: [^nil].

    (file includes: $.) ifFalse: [ file := file ,'.flg' ].
    self backUpFile: file.

    CursorManager execute changeFor: [
        ObjectFiler dump: flags newFile: file.
    ].!   
showNextPointToAdd: aPane
    "Private - Show next point to be added to the path"

    | point last pen addTo width scale |
    path size = 0 ifTrue: [^self].
    point := self mouseLocation.
    last := self lastPoint.
    self lastPoint: point.
    addTo := self addSelector = #addLast:
        ifTrue: [path last]
        ifFalse: [path first].

    pen := aPane pen.
    pen isNil ifTrue: [^self].
    width := pen lineWidth.
    scale := self scale.
    pen
        setRop2: R2Notxorpen;
        setLineWidth: self gap.
    last notNil ifTrue: [
      pen
        lineFrom: (addTo * scale) truncated to: (last * scale) truncated;
        "circle: self gap;"
        yourself
    ].
      pen
        lineFrom: (addTo * scale) truncated
        to: (point * scale) truncated;
        "circle: self gap;"
        yourself.

      pen
        setRop2: R2Copypen;
        setLineWidth: width;
        yourself.!
showPoint: aPane
    "Private - Show next point to be moved to the path"

    | point current pen last width scale |
    path size = 0 ifTrue: [^self].
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    point := self mouseLocation.
    scale := self scale.
    width := pen lineWidth.
    pen
        setRop2: R2Notxorpen;
        setLineWidth: self gap.

    last := self lastPoint.
    last isNil ifFalse: [
        pen place: (last * scale) truncated;circle: self gap.
    ].
    self detectPoint: aPane.
    current := self currentPoint.
    current isNil
    ifFalse: [ pen place: (current * scale) truncated;circle: self gap ].
    self lastPoint: current.

    pen
        setRop2: R2Copypen;
        setLineWidth: width;
        yourself.!  
splitPoint: aPane
    "Private - Add a new point between the currently selected point and the next"

    | point index rect |
    path size = 0 ifTrue: [^self].
    index := self currentIndex.
    index >= path size ifTrue: [^self beep].
    point := self mouseLocation.

    path :=
        ((path copyFrom: 1 to: index)
            copyWith: point)
        , (path copyFrom: index + 1 to: path size).

    self updateRectangle: (self boundsAround: point)!   
splittingPoint: aPane
    "Private - Show result of splitting the currently selected point"

    | point last pen pred next index draw width pt scale |
    path size = 0 ifTrue: [^self].
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    point := self mouseLocation.
    index := self currentIndex.
    (index isNil or: [index = path size]) ifTrue: [^self].
    scale := self scale.
    last := self lastPoint.
    pred := path at: index.
    next := path at: (index + 1 min: path size).

    draw := [:p|
        pt := (p  * scale) truncated.
        pen
            lineFrom: (pred * scale) truncated
            to: pt;
            circle: self gap;
            lineFrom: pt
            to: (next * scale) truncated;
            yourself
    ].
    width := pen lineWidth.
    pen
        setRop2: R2Notxorpen;
        setLineWidth: self gap.
    last notNil ifTrue: [ draw value: last ].
    draw value: point.
    pen
        setRop2: R2Copypen;
        setLineWidth: width.

    self lastPoint: point.! 
updatePath
    "Private - Update the view bounded by the path..."

    self updateRectangle: self pathBounds!  
updateRectangle: aRectangle
    "Private - Update aRectangle in the receiver's mapView"

    self mapPane invalidateRect: nil "(aRectangle scaleBy: self zoomFactor reciprocal) truncated"
        " aRectangle  no se porque a veces no funciona esta mierda... "!   
updateView
    "Private - update the view..."

    self
        currentPoint: nil;
        lastPoint: nil;
        currentIndex: nil.

    super updateView.! 
useSelection
    "Private - Responds to if a selection can be done using the receiver...
    This method can be refined by subclasses"

    ^false!   
whenSaved: aBlock
    "Sets the action to be performed when the user selected save"

    aBlock isNil ifTrue: [
        ^self whenSaved: [
                self warning: 'Accin de gardar indefinida.'
            ]
    ].
    whenSaved := aBlock.! !

! StreetBuilder class methods !   
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (fileRead 'Lee calles de archivo de texto con guia (Lumi)...')
        (fileOpen 'Lee archivo de calles...')
        (fileSave 'Graba todo el mapa con sus calles...')
        (fileSaveAs 'Graba las calles...')

        (editSelect 'Permite agregar nuevas esquinas...')
        (editInsert 'Permite insertar nuevas esquinas entre otros ya existentes...')
        (editMove 'Permite mover una esquinas, ajustando su posicin... (con derecho permite mover todas)')
        (editDelete 'Permite borrar una esquina... (con botn derecho permite borrar todas)')
        (editCopy 'Copia las esquinas al clipboard.')
        (editPaste 'Coloca los las esquinas que han sido copiados al clipboard sobre el mapa...')
        (editSearch 'Permite hubicarse en una cierta direccin (La calle debe estar ya editada).')

        (editName 'Permite cambiar el nombre de la ciudad.')
        (editRename 'Permite cambiar el nombre de una calle.')
        (customize 'Permite cambiar algunos parmetros.')

        (goto 'Permite testear las calles visualmente.')
        (gotoFirst 'Permite agregar esquinas al comienzo...')
        (gotoLast 'Permite agregar esquinas al final...')
        (gotoPred 'Hubica el mapa en la primera esquina de la calle selecta...')
        (gotoNext 'Hubica el mapa en la ltima esquina de la calle selecta...')

        ), super helpMap!
wbCreated

    ^true! !

! StreetBuilder methods !
addPoint: aPane
    "Private - Add current point to the path"

    | point max |
    super addPoint: aPane.
    self path size = 1
    ifTrue: [ path at: 1 putNumber: self startNumber ].

    self mustShowFlags ifTrue: [ self showFlags ].!   
changeAddress: aPane

    "Callback for the #textChanged event in an unnamed EntryField (contents is 'No').
     (Generated by WindowBuilder)"


    | last pane number point |
    aPane lastCharacterInput = Cr ifFalse: [ ^self ]. "only react when CR pressed..."

    point := self lastPoint.
    last := self path numberFor: point.
    last isNil ifTrue: [^self].

    number := aPane contents asInteger.
    number = last printString ifTrue: [^self].

    (number = 0 and: [(aPane contents = '0') not])
    ifTrue: [ aPane selectAll;setFocus. ^self beep ]. "invalid input"

    self path
        numberFor: point
        is: (number min: self maxAddressNumber).

    self mustShowFlags ifTrue: [ self mapPane invalidateRect: nil ].!  
changeNotes: aPane

    "Callback for the #textChanged event in an unnamed OSEntryField (contents is 'Notas').
     (Generated by WindowBuilder)"

    | street notes text |
    notes := self currentNotes.
    text := aPane contents trimBlanks.
    street := self currentStreet.
    notes isNil ifTrue: [
        text size = 0 ifTrue: [^self].
        street isNil ifTrue: [^self beep].
        street addLast: (notes := StreetNote new)
    ].
    text size = 0 ifTrue: [ "must delete the note..."
        street remove: notes ifAbsent: [].
        ^self
    ].
    notes contents: text!  
createGraphPane: aPaneWithRulers
    "Private - Process the getContens event for the rulered pane"

    super createGraphPane: aPaneWithRulers.

    self mapPane
        when: #getMenu perform: #getImageMenu:;
        font: self defaultFont;
        yourself!   
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Trazado de Calles';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1554 @ 880; xC; yC; cRDU: (9 @ 872 rightBottom: 1545 @ 46));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            when: #activate perform: #activateView:;
            backColor: ClrPalegray;
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 48; lDU: 855 r: #left; rDU: 1138 r: #left; tDU: 0 r: #top; bDU: 48 r: #top);
                    add: #edit selector: #editName;
                    add: #editSelectAll selector: #editRename;
                    add: #tool selector: #customize;
                    add: #editFlag rbSelector: #showFlags;
                    add: #editSearch rbSelector: #showFlags;
                    postAutomatic;
                    startGroup;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 160 @ 44; lDU: 1371 r: #left; rDU: 5 r: #right; tDU: 2 r: #top; bDU: 46 r: #top; indent: 3 @ 4);
                    startGroup;
                    when: #getContents perform: #setNotes:;
                    when: #textChanged perform: #changeNotes:;
                    when: #characterInput perform: #changeNotes:;
                    contents: 'Notas'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 96 @ 44; lP: 449/672; rP: 491/672; tDU: 48 r: #top);
                    startGroup;
                    when: #clicked perform: #selectSwitch:;
                    contents: 'ver...'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 117 @ 362; lDU: 5 r: #left; rDU: 121 r: #left; tDU: 48 r: #top; bDU: 410 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #letters:;
                    when: #select perform: #selectLetter:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 901 @ 362; lDU: 123 r: #left; rP: 461/692; tDU: 48 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #streets:;
                    when: #select perform: #streetSelected:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 295 @ 144; lP: 127/173; rDU: 114 r: #right; tDU: 48 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #streetReferences:;
                    when: #select perform: #referenceSelected:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 107 @ 44; lDU: 112 r: #right; tDU: 48 r: #top; bDU: 92 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #setAddress:;
                    when: #textChanged perform: #changeAddress:;
                    when: #characterInput perform: #changeAddress:;
                    contents: 'No'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                PaneWithRulers new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1536 @ 730; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 96 r: #top; bDU: 0 r: #bottom);
                    paneName: 'graph';
                    backColor: ClrPalegray;
                    startGroup;
                    tabStop;
                    when: #getContainedPane perform: #createGraphPane:;
                    addSubpanes;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 229 @ 48; lDU: 0 r: #left; rDU: 229 r: #left; tDU: 0 r: #top; bDU: 48 r: #top);
                    add: #fileRead;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #fileSaveAs;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 631 @ 48; lDU: 226 r: #left; rDU: 857 r: #left; tDU: 0 r: #top; bDU: 48 r: #top);
                    add: #editSelect;
                    add: #gotoFirst spaces: 2;
                    add: #gotoLast;
                    add: #editInsert spaces: 2;
                    add: #editMove rbSelector: #editMoveAll;
                    add: #editDelete spaces: 2 rbSelector: #editDeleteAll;
                    add: #editCopy spaces: 2;
                    add: #editPaste;
                    add: #helpPick selector: #goto spaces: 2;
                    add: #gotoNext rbSelector: #gotoNextStreet;
                    add: #gotoPred rbSelector: #gotoPreviousStreet;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 238 @ 48; lDU: 1134 r: #left; rDU: 1371 r: #left; tDU: 0 r: #top; bDU: 48 r: #top);
                    add: #editUpdate;
                    add: #toolHalt;
                    add: #toolDebug;
                    add: #fileExit spaces: 3;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!  
currentNotes
    "Private - Returns current street note or nil..."

    | street |
    street := self currentStreet.
    ^street notNil
        ifTrue: [ street detect: [:one| one isKindOf: StreetNote ] ifNone: [] ]!
currentPath
    "Private - Returns current path in use.
    If the current street has no path it will be created...
    If there are no street selected nil will be returned..."

    | currentStreet |
    ^(currentStreet := self currentStreet) notNil
    ifTrue: [
        currentStreet detect: [:one| one isPath ]
            ifNone: [ currentStreet add: self newPath ].
    ]!   
currentStreet
    "Private - Returns the current selected street (or nil)"

    | name |
    name := (self paneAt: #streets:) selectedItem.
    name isNil ifTrue: [ ^nil ].
    ^self streets street: name!
customize
    "Customize parameters..."

    | answers |
    answers := OSPrompter new
        title: 'Cambio de parmetros...';
        questions: #( 'Autoincremento para numeracin de calles ?' );
        answers: (Array with: StreetPath autoIncrementValue );
        open.
    answers isNil ifTrue: [^false].
    StreetPath autoIncrementValue: answers first asInteger.!
deferredDrawPoints: aCollection
    "Private - Display a line for points in aCollection in deferred mode..."

    (Message new
        receiver: self
        selector: #drawPoints:
        arguments: (Array with: aCollection) ) performDeferred.!   
deleteAllPoints: aPane
    "Private - Delete All points..."

    self path size = 0 ifTrue: [^self beep].
    (MessageBox confirm: 'Seguro desea borrar todos los puntos marcados?')
    ifTrue: [
        path points copy do: [:each| path remove: each ].
        self updateView.
    ].
    self editSelect.!   
drawFlagsIn: aRectangle with: aPen
    "Private - Draw the flags in aRectangle using aPen."

    self mustShowFlags ifTrue: [ self showFlags ].

    ^super drawFlagsIn: aRectangle with: aPen!  
drawPathIn: aRectangle with: aPen
    "Private - Draw the current path in aRectangle using aPen."

    | width color scale |
    aRectangle notNil
    ifTrue: [
        (aRectangle width > 0 and: [ aRectangle height > 0 ]) ifFalse: [^self]
    ].
    self path size = 0 ifTrue: [^self].
    width := aPen lineWidth.
    color := aPen foreColor.
    scale := self scale.
    aPen
        foreColor: self pathColor;
        setRop2: "R2Notxorpen"R2Copypen;
        setLineWidth: self gap;
        yourself.

    aPen place: (path first * scale) truncated.
    path do: [:point| aPen goto: (point * scale) truncated ].
    path do: [:point| aPen place: (point * scale) truncated;circleFilled: self gap ].

    aPen
        foreColor: color;
        setLineWidth: width;
        setRop2: R2Copypen;
        yourself.!   
drawPoints: aCollection
    "Private - Display a line for points in aCollection"

    | color width pen scale |
    (mapPane isNil or: [(pen := mapPane pen) isNil]) ifTrue: [^nil].
    aCollection size = 0 ifTrue: [^self].
    width := pen lineWidth.
    color := pen foreColor.
    scale := self scale.
    pen
        foreColor: self pathColor;
        setLineWidth: self gap;
        setRop2: R2Notxorpen;
        yourself.
    pen place: (aCollection first * scale) truncated.
    aCollection do: [:point| pen goto: (point * scale) truncated ].
    pen
        foreColor: color;
        setLineWidth: width;
        setRop2: R2Copypen;
        yourself.!
editCopy
    "Private - Copy current points to clipboard..."

    Clipboard setObject: path!   
editDeleteAll
    "Private - Set mode to remove..."

    self
        beep;
        mode: #deleteAll;
        message: 'Haga click en el mapa para borrar todas las esquinas...'!   
editFlag
    "Lets the user edit an annotation in the current street"

    | pane |
    self currentStreet isNil ifTrue: [^self beep].
    pane := self paneAt: #setNotes:.
    pane contents: String new.
    self enable: pane.
    pane setFocus!  
editInsert
    "Private - Set mode to insert..."

    self mode: #split!   
editMoveAll
    "Private - Set mode to remove..."

    self
        beep;
        mode: #moveAll;
        message: 'Moviendo todas las esquinas...'!
editName
    "Private - Edit the current streets name..."

    | string |
    self streets isNil ifTrue: [^self beep].
    string := OSPrompter
            prompt: 'Nombre de la ciudad ?'
            default: self streets name.
    string isNil ifTrue: [^self].
    self streets name: string trimBlanks!  
editPaste
    "Private - Paste points from clipboard..."

    | points |
    points := Clipboard getObject.
    (points notNil & self path notNil and: [
    (points isKindOf: StreetPath)])
    ifFalse: [ ^self beep ].
    path addAll: points.
    self drawPath.!   
editRename
    "Private - Lets the user rename a street..."

    | string name streets |
    name := (self paneAt: #streets:) selectedItem.
    name isNil ifTrue: [ ^self beep ].
    streets := self streets.
    streets isNil ifTrue: [^self beep].
    string := OSPrompter
            prompt: 'Nuevo nombre de la calle ',name,' ?'
            default: name.
    string isNil ifTrue: [^self].
    string := string trimBlanks.
    ((streets streetNamed: string ifAbsent: []) isNil
    or: [
        self beep.
        MessageBox confirm: 'La calle ',string,' ya existe...\Seguro la sobreescribe ?' withCrs
    ]) ifFalse: [ ^self beep ].
    self streets rename: name to: string.
    self
        changed: #streets:
        with: #restoreSelected:
        with: string! 
endNumber
    "Private - Returns the last number for the end point"

    | block dict street cole stream |
    dict := Dictionary new.
    dict
        at: #addLast: put: [
            stream := cole last asStream.
            stream upTo: $-.
            stream atEnd ifTrue: [1]
            ifFalse: [ (stream upTo: nil) trimBlanks asInteger ]
        ];
        at: #addFirst: put: [ (cole first upTo: $-) trimBlanks asInteger ];
        yourself.
    block := dict at: self addSelector ifAbsent: [].
    block isNil ifTrue: [ self beep. ^1 ].

    street := self currentStreet.
    street isNil ifTrue: [ ^1 ].

    cole := SortedCollection new.
    street notNil ifTrue: [
        street do: [:each|
            each name notNil
            ifTrue: [ cole add: each name ]
        ].
    ].
    cole isEmpty ifTrue: [
        ^path size > 0 ifTrue: [ path lastNumber ] ifFalse: [ 0 ]
    ].

    ^block value! 
fileOpen
    "Open a new city to be associated to the receiver"


    self fileRead.
    "
    | dialog file streets |
    (self streets isNil or: [ self streets isEmpty])
    ifFalse: [
        (MessageBox confirm: 'La lectura de nuevas calles destruir',
            ' las calles existentes;\Seguro desea continuar ?' withCrs)
        ifFalse: [^self].
    ].

    dialog := FileDialog new.
    dialog
        title: 'Seleccione el nombre del archivo de calles...';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        addFilter: '*.cty' description: 'Calles (*.CTY)';
        defFilter: '*.cty';fileSpec: '*.cty';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].

    (file includes: $.) ifFalse: [ file := file ,'.cty' ].
    CursorManager execute changeFor: [
        streets := ObjectFiler loadFromPathName: file.
    ].
    streets isNil ifTrue: [ ^self error: 'El archivo no contiene calles' ].
    self map streets: streets.

    self fullUpdate.
    "!  
fileRead
    "Private - Lets the user load a new streetNet table from file"

    | dialog file net |
    dialog := FileDialog new.
    dialog
      title: 'Seleccione el archivo a leer...';
      addFilter: '*.txt' description: 'Archivos de texto (*.txt)';
      addFilter: '*.*' description: 'Todos los archivos (*.*)';
        addFilter: '*.cty' description: 'Archivos de calles (*.CTY)';
        defFilter: '*.cty';fileSpec: '*.cty';
      hideReadonly;open.
    file := dialog file.
    file isNil ifTrue: [^self].
    self message: 'Leyendo archivo ',file,'...'.
    CursorManager execute changeFor: [
        net := StreetNet fromFile: file
    ].
    net isNil ifFalse: [ self map streets: net ].
    self message: 'Lectura de ',file,' concluida...'.
    self fullUpdate.!   
fileSave
    "Private - Save the map..."

    super basicFileSave.!
fileSaveAs
    "Private - Save the current streets to a .CTY file..."

     | dialog file |

    dialog := FileDialog new.
    dialog
        title: 'Donde guardo las calles?';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        addFilter: '*.cty' description: 'Archivos de Calles (*.CTY)';
        defFilter: '*.cty';fileSpec: 'Anonimo.Cty';
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file size = 0 ifTrue: [^nil].

    (file includes: $.) ifFalse: [ file := file ,'.cty' ].
    self backUpFile: file.

    self message: 'Grabando calles en archivo ',file,'...'.
    CursorManager execute changeFor: [
        file := File newFile: file.
        self streets fileOutOn: file.
        file close.
    ].
    self message: 'Grabacin concluida...'.!   
goto
    "Lets the user test the streets..."

    (MessageBox confirm: 'Desea testing impreso ?\\'withCrs,
        'En caso de contestar afirmativamente, se imprimiran las',
        ' regiones delimitadas por cada calle en hojas contiguas...')
    ifTrue: [ ^self printedTest ].
    ^self test! 
gotoLumi
    "Obsolete - Lets the user goto a Lumi Address..."

    | input address box position |
    input := '52-E-1'.
    [
    input := OSPrompter
        prompt: 'Direccin "LUMI" a hubicar ? (plano-fila-columna)'
        default: input.
    input isNil ifTrue: [^self].
    address := LumiAddress name: nil address: input trimBlanks.
    address isValid
    ] whileFalse: [ self beep ].

    position := address notNil
    ifTrue: [
        box := address boundingBox.
        box center - (self mapPane frameRectangle extent // 2)
    ].

    position notNil
    ifTrue: [
        self
            position: position;
            selection: box.

    ]
    ifFalse: [ self beep ].!  
gotoNext
    "Private - Move the the graph pane to the last point..."

    self path size = 0 ifTrue: [^self beep].
    self position: self path last - (self mapPane frameRectangle extent // 2)!
gotoNextStreet
    "Private - Position the receiver in the next street..."

    | streets this stream item |
    (streets := self streets) = 0 ifTrue: [^self beep].
    stream := ReadStream on: streets names asSortedCollection.
    item := (self paneAt: #streets:) selectedItem.
    item notNil ifTrue: [ stream upTo: item ].
    (stream atEnd or: [ (this := stream next) isNil]) ifTrue: [^self beep].
    self highlightStreet: this.

    (self paneAt: #letters:) selectedItem = (String with: this first)
    ifFalse: [ self changed: #letters: with: #restoreSelected: with: (String with: this first) ].
    self
        lastStreetSelected: nil;
        changed: #streets: with: #restoreSelected: with: this;
        " gotoPred;  "
        yourself! 
gotoPred
    "Private - Move the the graph pane to the first point..."

    self path size = 0 ifTrue: [^self beep].
    self position: self path first - (self mapPane frameRectangle extent // 2)!  
gotoPreviousStreet
    "Private - Position the receiver in the previous street..."

    | streets this stream item |
    (streets := self streets) = 0 ifTrue: [^self beep].
    stream := ReadStream on: streets names asSortedCollection.
    item := (self paneAt: #streets:) selectedItem.
    item notNil ifTrue: [ stream upTo: item ].
    stream position: (stream position - 2 max: 0).
    this := stream next.
    self highlightStreet: this.
    (self paneAt: #letters:) selectedItem = (String with: this first)
    ifFalse: [ self changed: #letters: with: #restoreSelected: with: (String with: this first) ].
    self
        lastStreetSelected: nil;
        changed: #streets: with: #restoreSelected: with: this;
        " gotoPred; "
        yourself!   
highlightStreet: streetName
    "Private - Hightlight the street named streetName..."

    | streets points paths |
    streets := self streets.
    streets isNil ifTrue: [^self beep].

    paths := streets streetNamed: streetName.
    paths size > 0
    ifTrue: [
        points := paths detect: [:one| one isPath ] ifNone: [ paths first ].
        self
            " selection: points boundingBox; "
            position: (points isPath ifTrue: [points first] ifFalse: [points boundingBox first])
                 - (self mapPane frameRectangle extent // 2).
        points isPath ifTrue: [ self highlight: points ].
    ].!
imageMenu: aPane
    "Callback for the #getMenu event in the image-pane..."

    | menu |
    menu := super imageMenu: aPane.
    menu
        appendSeparator;
        appendItem: '&Nueva calle...' selector: #newStreet;
        appendItem: '&Renombrar calle...' selector: #editRename;
        appendItem: '&Eliminar calle...' selector: #removeStreet;
        yourself.
    ^menu!
initialize
    "Private - Initializes the receiver..."

    super initialize.
    selectBlock := self selectDefault.! 
initializePath
    "Private - Initialize the receiver's path...
    The receiver's path will be initialized when selecting a street..."

    path := nil.!
lastLetterSelected
    "Private - Returns the last letter selected (or nil)"

    ^self mapPane propertyAt: #lastLetterSelected!   
lastLetterSelected: aLetter
    "Private - Sets the last letter selected."

    self mapPane
        propertyAt: #lastLetterSelected
        put: aLetter!   
lastStreetSelected
    "Private - Returns the last street selected (or nil)"

    ^self mapPane propertyAt: #lastStreetSelected!   
lastStreetSelected: aStreet
    "Private - Sets the last street selected."

    path := nil. "force path query..."
    self mapPane
        propertyAt: #lastStreetSelected
        put: aStreet!   
letters: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | streets letters last |
    CursorManager execute changeFor: [
        last := aPane selectedItem.
        streets := self streets.
        aPane contents: (streets notNil
            ifTrue: [
                letters := streets keys collect: [:each| each first ].
                letters asSet asSortedCollection collect: [:c| String with: c ]
            ]).
        last notNil ifTrue: [ aPane selection: last ].
    ].
    self enable: aPane when: letters size > 0.!  
maxAddressNumber
    "Private - Returns the maximum address valid number..."

    ^30000!  
modes
    "Private - Return receiver's  interfase modes"

   ^#(
        "supportedMode (1Down 1Up 1Move DoubleClick mouseMove cursorShape modeSelectSelector)"
        add (detectMovePoint: addPoint: showNextPointToAdd: none showPoint: add none)
        move (detectMovePoint: movePoint: movingPoint: none showPoint: none none)
        delete (detectPoint: deletePoint: none none showPoint: none none)
        split (detectPoint: splitPoint: splittingPoint: none showPoint: none none)
        moveAll (detectPoint: moveAllPoints: movingAllPoints: none showPoint: none none)
        deleteAll (none deleteAllPoints: none none none none none)
        )!
moveAllPoints: aPane
    "Private - Move the currently selected point"

    | distance |
    self path size = 0 ifTrue: [^self beep].
    distance := self mouseLocation - self currentPoint.
    path points do: [:each|
        each
            x: each x + distance x;
            y: each y + distance y.
    ].
    self updateView! 
movingAllPoints: aPane
    "Private - Show result of moving all the points"

    | point last pen index draw distance width pt scale |
    path size = 0 ifTrue: [^self].
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    point := self mouseLocation.
    index := self currentIndex.
    index isNil ifTrue: [^self].
    scale := self scale.

    width := pen lineWidth.
    last := self lastPoint.

    draw := [:p|
        pt := (p * scale) truncated.
       distance := pt - (path at: index).
       pen place: (path first + distance * scale) truncated.
       path points do: [:each| pen goto: (each + distance * scale) truncated ].
    ].

    pen
        setRop2: R2Notxorpen;
        setLineWidth: self gap.
    last notNil ifTrue: [ draw value: last ].
    draw value: point.
    pen
        setRop2: R2Copypen;
        setLineWidth: width.

    self lastPoint: point.!  
mustShow: aStreetName
    "Private - Returns true if the receiver must show the street named aStreet."

   ^selectBlock isNil or: [ selectBlock value: aStreetName ]!  
mustShowFlags
    "Private - Returns true if the receiver must show the flags."
    | mustShowFlags toggle |
    mustShowFlags := (self mapPane propertyAt: #mustShowFlags) = true.
    toggle := Notifier isCtrlDown.
    toggle ifTrue: [
        mustShowFlags := mustShowFlags not.
        self mustShowFlags: mustShowFlags.
    ].
    ^mustShowFlags!
mustShowFlags: aBoolean
    "Private - Sets the flag when the receiver must show the flags."

    ^self mapPane propertyAt: #mustShowFlags put: aBoolean!  
newPath
    "Private - Returns a new path..."

    ^StreetPath new!
newStreet
    "Private - Lets the user create a street..."

    | string name streets |
    streets := self streets.
    streets isNil ifTrue: [^self beep].
    name := (self paneAt: #streets:) selectedItem.
    name isNil ifTrue: [ name := String new ].
    string := OSPrompter
            prompt: 'Nombre de la nueva calle ?'
            default: name.
    string isNil ifTrue: [^self].
    ((streets streetNamed: string ifAbsent: []) isNil
    or: [
        self beep.
        MessageBox confirm: 'La calle ',string,' ya existe...\Seguro la sobreescribe ?' withCrs
    ]) ifTrue: [ streets addStreet: #() as: string ].

    self
        changed: #letters:
        with: #restoreSelected:
        with: (String with: string first);
        lastStreetSelected: nil;
        changed: #streets:
        with: #restoreSelected:
        with: string;
        editSelect!
path
    "Private - Returns current path in use.
    If the current street has no path it will be created...
    If there are no street selected nil will be returned..."

    path isNil ifTrue: [ path := self currentPath ].
    ^path!  
printedTest
    "Print the path of each street for testing..."

    | streets names points paths exit
      newPrinter newPage printer pen pageNumber printerFont
      box computeDestination minimumScale
      destination inches capability
      point place reduction |
    pageNumber := 1.
    streets := self streets.
    streets isNil ifTrue: [^self beep].
    names := streets names asSortedCollection.
    names size = 0 ifTrue: [ ^self beep ].
    exit := [
        printer
            endPrinterPage;
            endPrintJob;
            release.
        printerFont release.
        CursorManager normal change.
    ].
    newPrinter := [
        printer notNil
        ifTrue: [
            printer
                endPrintJob;
                release.
        ].
        printer := OSPrinter new
            label: 'Test de calles [',streets name asString,']';
            startPrintJob;
            startPrinterPage;
            yourself.
        printerFont release.
        printerFont := Font fromLogFont: self defaultFont logFont.
        printerFont
            pointSize: printerFont pointSize
            graphicsMedium: printer.
        (pen := printer pen) font: printerFont.
    ].
    newPage := [
        pageNumber := pageNumber + 1.
        printer
            formFeed;
            startPrinterPage.
        (pen := printer pen) font: printerFont;place: 0@ printerFont height.
        point := pen location.
        pen
            centerText: 'Pgina #',pageNumber asString at: pen boundingBox width // 2@10;cr;
            lineFrom: 0@ point y to: pen boundingBox width - 1 @ point y;
            yourself
    ].

    computeDestination := [:text|
       "adapta destination para que entre en la hoja,
        calcula destination en pulgadas,
        imprime label...
        y pasa la pgina si no entra"
        minimumScale := 1"4/5".
        (pen boundingBox height > (box height * minimumScale)
        and: [ pen boundingBox height - pen location y > (box height * minimumScale) ])
        ifFalse: [
            printer
                endPrinterPage;
                yourself.
            pageNumber \\ 3 = 0
            ifTrue: [
                (MessageBox confirm: 'Contina la impresin ?')
                ifFalse: [ ^exit value ].
                newPrinter value.
            ].
            newPage value.
        ].
        point := pen location copy.
        pen
            lineFrom: 0@ point y to: pen boundingBox width - 1 @ point y;
            cr;nextPutAll: text;cr.
        point := pen location copy.
        reduction := 1@1 / 5 rightBottom: 1@1 * 4/5.
        destination := 0@point y extent: box extent * 2.
        [ destination width > (pen boundingBox width - 10) ]
            whileTrue: [ destination := (destination scaleTo: reduction) truncated ].
        [ destination height > (pen boundingBox height - point y - 1) ]
            whileTrue:  [ destination := (destination scaleTo: reduction) truncated ].
        destination
            leftTop: (pen boundingBox width - destination width // 2 max: 0) @ point y
            extent: destination extent.
        capability := printer capability.
        inches := destination scaleBy: capability extentInInches / capability extent.
    ].

    place := [:pt|
        "compute pixel offset of point pt"
        (pt - box origin * (destination extent / box extent) + destination leftTop) truncated
    ].

    newPrinter value.
    CursorManager execute changeFor: [
        names do: [:each|
            paths := streets streetNamed: each.
            paths size > 0
            ifTrue: [
                points := paths detect: [:one| one isPath ] ifNone: [ paths first ].
                box := (points boundingBox expandBy: 50) intersect: self map boundingBox.
                computeDestination value: each.
                self message: 'Pgina # ',pageNumber asString,' calle ',each asString ",' (',destination asString,')' ".
                self mapView print: box inside: inches using: printer.
                "
                pen
                    setLineWidth: 2;
                    place: destination leftTop - 2;
                    box: destination rightBottom + 2.
                "
                points isPath & points isEmpty not ifTrue: [
                    pen
                        setPenStyle: PsDot color: ClrGreen width: self gap;
                        setRop2: R2Notxorpen;
                        yourself.
                    pen place: (place value: points first).
                    points do: [:point| pen goto: (place value: point) ].
                    pen
                        setRop2: R2Copypen;
                        resetAttributes.
                ].
                pen place: 0@(destination bottom + 10).
            ].
        ].
    ].
    exit value!
referenceSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | position address street selectedItem box |
    selectedItem := aPane selectedItem.
    selectedItem isNil ifTrue: [ ^self ].

    street := self currentStreet.
    street notNil ifTrue: [
        address := street
            detect: [:segment| segment name = selectedItem ]
            ifNone: [].
    ].

    position := address notNil
    ifTrue: [
        box := address boundingBox.
        box center - (self mapPane frameRectangle extent // 2)
    ].

    position notNil
    ifTrue: [
        self
            position: position;
            selection: box.

    ]
    ifFalse: [ self beep ].!
removeStreet
    "Private - Lets the user remove a street..."

    | name streets |
    name := (self paneAt: #streets:) selectedItem.
    name isNil ifTrue: [ ^self beep ].
    streets := self streets.
    streets isNil ifTrue: [^self beep].
    (MessageBox confirm: 'Seguro elimina la calle ',name,' ?') ifFalse: [^self beep].
    self streets remove: name.

    self
        lastStreetSelected: nil;
        changed: #streets:!   
selectAllBlock
    "Private - Block for select all the streets"

    ^[:aStreetName| true ]!   
selectAvenues
    "Private - Returns the select block for avenues"

    "only show non-edited streets"
    ^[:aStreetName|
        (aStreetName indexOfCollection: 'Av.') > 0
        and: [
            ((self streets street: aStreetName)
                detect: [:one| one isKindOf: StreetPath ] ifNone: [])
            size = 0
        ]
     ]!  
selectDefault
    "Private - Returns the default select block."

    ^self selectAllBlock! 
selectFind
    "Private - Returns the Find... select block."

    | found text |
    "only show streets with notes including text"
    text := OSPrompter
        prompt: 'Texto a buscar en las notas ?'
        default: (text isNil ifTrue: [String new] ifFalse: [text]).
    text size = 0 ifTrue: [^nil].

    ^[:aStreetName|
        found := (self streets street: aStreetName)
            select: [:one| (one isKindOf: StreetNote) and: [ (one contents indexOfCollection: text) > 0] ].
        found size > 0 ]!   
selectLetter: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | letter |
    letter := aPane selectedItem.
    letter = self lastLetterSelected ifTrue: [^self]. "ignore repetitive selections"
    self lastLetterSelected: letter.

    self
        changed: #streets:;
        changed: #streetReferences:;
        yourself! 
selectNonEdited
    "Private - Returns the block for editin remaining streets.
    (only non-visited streets will be shown)"

    | edited |
    "only show non-edited streets"
    ^[:aStreetName|
        edited := (self streets street: aStreetName)
            detect: [:one| one isKindOf: StreetPath ] ifNone: [].
        edited size = 0 ]!
selectSwitch: aPane

    "Callback for the #clicked event in 'ver...'  button..."

    | current labels what index |
    labels := #(
        'Ver todas las calles'
        'Ver las calles an no marcadas.'
        'Ver las que tengan ... en las notas.'
        'Ver las avenidas an no marcadas.'
        'Ver las calles provablemente mal editadas...'
        ).
    what := ListDialog new
            title: 'Que calles desea ver ?';
            openOn: labels.
    what isNil ifTrue: [ ^self beep ].
    index := labels indexOf: what.
    selectBlock :=
        index = 3 ifTrue: [ self selectFind ]
        ifFalse: [
            what := OrderedCollection new.
            what
                addLast: self selectAllBlock;
                addLast: self selectNonEdited;
                addLast: nil; "hecha la excepcin para que haga el prompty solo si es necesario..."
                addLast: self selectAvenues;
                addLast: self selectWrong.
            what at: index
        ].

    current := (self paneAt: #streets:) selectedItem.
    self
        lastStreetSelected: nil;
        changed: #streets: with: #restoreSelected: with: current;
        updateView;
        yourself.! 
selectWrong
    "Private - Returns the select block for provably wrong-edited streets"

    | this last fail street |
    ^[:aStreetName|
        street := self streets street: aStreetName.
        fail := nil.
        this := street detect: [:one| one isKindOf: StreetPath ] ifNone: []. "has been edited..."
        this size > 0 ifTrue: [
            last := this numbers first - 1.
            fail := this numbers detect: [:number| "detect bad ordered number..."
                (number ~= 0 and: [ number <= last ])
                ifTrue: [ true ]
                ifFalse: [ last := number. false ].
            ] ifNone: [].
        ].
        fail notNil
     ]!   
setAddress: aPane

    "Callback for the #getContents event in an unnamed EntryField (contents is 'No').
     (Generated by WindowBuilder)"

    "   self enable: aPane when: self path size > 0   "!
setNotes: aPane

    "Callback for the #getContents event in an unnamed OSEntryField (contents is 'Notas').
     (Generated by WindowBuilder)"

    | notes |
    notes := self currentNotes.
    notes notNil ifTrue: [
        aPane contents: notes contents;selectAll
    ] ifFalse: [ aPane contents: String new ].
    self enable: aPane when: (notes notNil or: [self currentStreet notNil]).!  
showAll
    "Private - Returns true if the receiver must show all streets"

    ^selectBlock == self selectAllBlock!   
showFlags
    "Show aFlag trought the current street"

    | street pen interval place width
      increment numbers point scale pt |

    self drawStreets.

    self path size = 0 ifTrue: [^self].
    scale := self scale.

    increment := 100.
    place := [:p|
        p notNil ifTrue: [
            pt := (p  * scale) truncated.
            pen
                place: pt; circleFilled: 5;
                place: pt + (10@5 * scale) truncated; displayText: number asString
        ]
    ].

    interval := self path interval.
    numbers := interval first + (increment - 1) // increment * increment to: interval last by: increment.

    pen := self mapPane pen.
    width := pen lineWidth.
    pen setLineWidth: 1.
    number := interval first.
    place value: (path pointForNumber: interval first).
    numbers do: [:number|
        place value: (path pointForNumber: number)
    ].
    number := interval last.
    place value: (path pointForNumber: interval last - 1).
    pen setLineWidth: width.!  
showPoint: aPane
    "Private - Show next point to be moved to the path"

    super showPoint: aPane.
    self updateAddress! 
splitPoint: aPane
    "Private - Add a new point between the currently selected point and the next"

    | oldPath index |
    oldPath := self path.
    oldPath isNil ifTrue: [^self beep].
    super splitPoint: aPane.
    index := self currentStreet indexOf: oldPath.
    index > 0
    ifTrue: [ self currentStreet at: index put: path ]
    ifFalse: [ ^self error: 'Trazado perdido' ]!   
startNumber
    "Private - Returns the start number for the start point"

    | block dict street cole stream |
    dict := Dictionary new.
    dict
        at: #addFirst: put: [
            stream := cole last asStream.
            stream upTo: $-.
            stream atEnd ifTrue: [1]
            ifFalse: [ (stream upTo: nil) trimBlanks asInteger ]
        ];
        at: #addLast: put: [ (cole first upTo: $-) trimBlanks asInteger ];
        yourself.
    block := dict at: self addSelector ifAbsent: [].
    block isNil ifTrue: [ self beep. ^1 ].

    street := self currentStreet.
    street isNil ifTrue: [ ^1 ].

    cole := SortedCollection new.
    street notNil ifTrue: [
        street do: [:each|
            each name notNil
            ifTrue: [ cole add: each name ]
        ].
    ].
    cole isEmpty ifTrue: [
        ^path size > 0 ifTrue: [ path firstNumber ] ifFalse: [ 0 ]
    ].

    ^block value!   
streetFound: aStreetName
    "Private - Notify the user about a found street..."

    self message: 'Resultado de la bsqueda: ',aStreetName asString! 
streetReferences: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | street cole |
    street := self currentStreet.
    cole := SortedCollection new.
    street notNil ifTrue: [
        street do: [:each|
            each name notNil
            ifTrue: [ cole add: each name ]
        ].
    ].
    aPane contents: cole.
    self enable: aPane when: cole notEmpty.
    cole notEmpty ifTrue: [
        aPane selection: cole first.
        self referenceSelected: aPane.
    ].!  
streets: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | streets cole letter showAll |
    CursorManager execute changeFor: [
        streets := self streets.
        letter := (self paneAt: #letters:) selectedItem.
        showAll := self showAll.
        letter isNil | streets isNil
        ifTrue: [ cole:= #() ]
        ifFalse: [
            cole := OrderedCollection new.
            streets keys do: [:each|
                (each notEmpty
                    and: [each first = letter first
                    and: [showAll or: [self mustShow: each]]])
                ifTrue: [ cole add: each ]
            ].
        ].
        aPane contents: cole asSortedCollection.
    ].

    self enable: aPane when: cole size > 0.

    "
    (cole size > 0 and: [ aPane selectedItem size = 0 ])
    ifTrue: [
        aPane selection: 1.
        self streetSelected: aPane.
    ].
    "! 
streetSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | street |
    street := aPane selectedItem.
    street = self lastStreetSelected ifTrue: [^self]. "ignore repetitive selections"
    self lastStreetSelected: street.
    self
        updateView;
        changed: #setNotes:;
        changed: #streetReferences:;
        editSelect;
        yourself!  
test
    "Lets the user test the streets visually..."

    | answer streets names failed points paths exit monitor pen |
    (mapPane isNil or: [(pen := mapPane pen) isNil]) ifTrue: [^nil].
    streets := self streets.
    streets isNil ifTrue: [^self beep].
    names := streets names asSortedCollection.
    names size = 0 ifTrue: [ ^self beep ].
    failed := Set new.
    exit := [
        failed isEmpty ifFalse: [
            monitor := TextWindow
                windowLabeled: 'Calles errneas.'
                frame: ((Display width // 2 @ 0 rightBottom: Display extent) insetBy: 5).
            failed do: [:one| monitor cr;nextPutAll: one ]
        ].
    ].
    names do: [:each|
        paths := streets streetNamed: each.
        paths size > 0
        ifTrue: [
            self highlightStreet: each.
            answer := MessageBox yesNoCancelTitled: 'Confirme' text: 'Esta bien la calle ',each.
            answer isNil ifTrue: [^exit value].
            answer = #no ifTrue: [ failed add: each ]
        ].
    ].
    exit value!
updateAddress
    "Private - Update the address window..."

    | last pane |
    self mainView isActive ifFalse: [ ^self ].
    (self mainView isMDIChild and: [self frame isActive])
    ifFalse: [ ^self ].

    pane := self paneAt: #setAddress:.
    pane setFocus;selectAll.

    self path isNil ifTrue: [^self].
    last := self path numberFor: self lastPoint.
    last isNil ifTrue: [^self].

    pane contents = last printString
    ifTrue: [^self].

    pane
        contents: last printString;
        selectAll! !

! TileEditor class methods !  
cursorNames
    "Private - Returns the cursors handled by receiver's instances"

    ^#(
        hand move select cut
    "
        erase
        origin corner
        'paint' 'pencil'
        'print'
        'unavailable'
    "
    )!   
wbCreated

    ^true! !

! TileEditor methods !   
checkSelection
    "Private - The selection must be checked..."

    mode = #rotate ifTrue: [^self].

    ^super checkSelection! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Editor de Imgenes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1006 @ 800; xC; yC; cRDU: (9 @ 792 rightBottom: 997 @ 46));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            backColor: ClrPalegray;
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 576 @ 48; lDU: 0 r: #left; rDU: 576 r: #left; tDU: 0 r: #top; bDU: 48 r: #top);
                    add: #fileRestore;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #editSelect spaces: 3 rbSelector: #editSelectAll;
                    add: #editColor;
                    add: #editCut rbSelector: #editCutNow;
                    add: #editRepeat selector: #editRotate rbSelector: #editRotateAngle;
                    add: #toolMeasure;
                    add: #editUpdate spaces: 3;
                    add: #fileExit spaces: 5;
                    postAutomatic;
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSImagePane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 987 @ 698; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 48 r: #top; bDU: 0 r: #bottom);
                    startGroup;
                    when: #getContents perform: #tilePane:;
                    when: #button1DoubleClick perform: #button1DoubleClick:;
                    when: #button1Move perform: #button1Move:;
                    when: #button1Down perform: #button1Down:;
                    when: #display perform: #displayTile:;
                    when: #setScrollRectangle perform: #setScrollRectangle:;
                    when: #button1DownShift perform: #button1DownShift:;
                    when: #mouseMove perform: #mouseMove:;
                    when: #button1Up perform: #button1Up:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 375 @ 32; lDU: 603 r: #left; rDU: 9 r: #right; tDU: 8 r: #top);
                    startGroup;
                    when: #getContents perform: #mouseLocation:;
                    contents: 'Hubicacin'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
displayTile: aPane

    "Callback for the #display event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    | pen rectangle boundingBox |
    aPane isNil ifTrue: [^self].
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    tile isNil ifTrue: [^self].

    CursorManager execute changeFor: [
        boundingBox := 0@0 extent: tile extent.
    ].
    (boundingBox width > 0 and: [boundingBox height > 0])
    ifFalse: [^self].

    rectangle := aPane rectangleToDisplay.
    CursorManager execute changeFor: [
        rectangle notNil ifTrue: [
            (rectangle nonIntersections: boundingBox)
            do: [:nonOverlaped| pen fill: nonOverlaped color: aPane backColor ].
            tile
                display: (rectangle translateBy: tile origin)
                at: tile origin negated
                with: pen.
            self drawTheGridIn: rectangle with: pen.
            selection notNil ifTrue: [ self drawSelectionIn: rectangle with: pen ].
        ].
    ].!
drawSelectionIn: aRectangle with: aPen
    "Private - Draw the current selection..."

    | backUp |
    mode = #rotate ifFalse: [
        ^super drawSelectionIn: aRectangle with: aPen
    ].
    backUp := aPen location.
    aPen
        setRop2: R2Notxorpen;
        setLineWidth: self selectionLineWidth;
        place: selection origin;
        circle: self pivotRadix;
        goto: selection corner;
        setRop2: R2Copypen;
        setLineWidth: 1;
        place: backUp;
        yourself!   
editColor
    "Change the image class..."

    | answers format |

    answers := OSPrompter new
        title: 'Convertir imgen a ...';
        questions: #( 'Clase de la imgen ? [Bilevel,Gray,Palette,RGB]');
        answers: (Array with: 'Gray' );
        open.

    answers isNil ifTrue: [^false].

    format := HaloImage formats
        at: answers first ,' Image'
        ifAbsent: [ ^self warning: 'Formato de imgen invlido o no soportado.' ].

    CursorManager execute
    changeFor: [
        tile bitmap: (tile bitmap convertTo: format)
    ].
    self mapPane redraw.! 
editCut
    "Change to Crop mode..."

    self mode: #cut.!
editCutNow
    "Private - Perform cut action"

    (mode = #cut and: [ selection notNil ])
    ifFalse: [ self beep ].
    CursorManager execute changeFor: [ tile crop: selection ].
    self
        editSelectAll;
        editUpdate! 
editRotate
    "Change to rotate rect mode..."

    self mode: #rotate.!   
editRotateAngle
    "Change to rotate rect mode..."

    | answers angle anchor |

    answers := OSPrompter new
        title: 'Rotacin de Imagen...';
        questions: #( 'ngulo ?' 'Anclar en [Topleft,Top,Topright,Left,Center,Right] ?');
        answers: (Array with: '0' with: 'Center' );
        open.

    answers isNil ifTrue: [^false].
    angle := answers first asNumber.
    angle isNumber ifFalse: [^self warning: 'El ngulo debe ser un numero distinto de cero'].

    anchor := answers last.

    CursorManager execute
    changeFor: [
        tile rotate: 360 - angle anchor: anchor at: 0@0.
    ].

    self mapPane redraw.!
editSelect
    "Change to mark rect mode..."

    self mode: #select!  
editSelectAll
    "Select all the image..."

    self selection: (0@0 extent: tile extent).!   
editUpdate
    "Update the receiver & current TiledImageBuilders..."

    | builder |
    self fullUpdate.

    builder := (Notifier windows
        detect: [:one| one owner isKindOf: TiledImageBuilder ]
        ifNone: [^self]) owner.
    builder updateViews.!
fileOpen
    "Sets receiver's contents from a new file name..."

    | image |
    image := Tile imageClass fromUser.
    image isNil ifTrue: [^self beep].
    tile bitmap: image.
    self mapPane setScrollRanges.
    self editUpdate.!   
fileRestore
    "Refresh the receiver from file"

    | fName |
    fName := tile name.
    (MessageBox confirm:
        'Seguro desea recuperar el estado desde el archivo\ 'withCrs,fName,' ?')
    ifFalse: [ ^self beep ].

    CursorManager execute changeFor: [ tile restore ].

    self editUpdate.!  
fileSave
    "Save receiver's contents..."

    tile bitmap notNil
    ifTrue: [
        CursorManager execute
        changeFor: [ tile save ]
    ].!
initialize
    "Private - Initialize the receiver"

    super initialize.
    mode := #select.
    tile := Tile new.!
initializeMap
    "Initialize the receiver's map..."!
mapPane
    "Private - Returns the pane for the map."

    mapPane isNil ifTrue: [
        mapPane := self paneAt: #tilePane:.
    ].
    ^mapPane! 
mode: aSymbol
    "Private - Change the receiver's interfase mode
     to aSymbol..."
    | old |
    old := selection.
    self selection: nil.
    mode := aSymbol.
    self selection: old.!
mouseLocation: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Mouse Location').
     (Generated by WindowBuilder)"

    | stream point |
    point := [:p| stream nextPutAll: p x asString,'x',p y asString ].
    stream := WriteStream on: String new.
    stream nextPutAll: mode asString,' '.
    mouse isNil ifFalse: [ point value: mouse ].
    selection isNil ifFalse: [
        mode = #rotate
        ifTrue: [
            stream nextPutAll: '=>',self rotationAngle asString,' grados'.
        ]
        ifFalse: [
            stream nextPutAll: ' '.
            point value: selection origin.
            stream nextPutAll: '>>'.
            point value: selection corner.
            stream nextPutAll: ' ['.
            point value: selection extent.
            stream nextPutAll: ']'.
        ]
    ].
    aPane contents: stream contents! 
mouseMove: aPane

    "Callback for the #mouseMove event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    mouse := self mouseLocation.
    self changed: #mouseLocation:.

    mode = #rotate ifTrue: [
        ^self mapPane setCursor: (self cursorFor: #select)
    ].

    selection notNil
    ifTrue: [
        (selection containsPoint: mouse)
        ifTrue: [
            self mapPane setCursor:
                (self cursorFor:
                    (mode = #cut
                    ifTrue: [#cut]
                    ifFalse: [#move]))
        ]
        ifFalse: [ self mapPane setCursor: (self cursorFor: #select) ]
    ] ifFalse: [ self mapPane setCursor: (self cursorFor: #hand) ].!   
openOn: aTile
    "Open the receiver for working with aTile"

    tile := aTile isString
        ifTrue: [ Tile name: (PathFinder locationFor: aTile) ]
        ifFalse: [aTile].

    ^self open! 
pivotRadix
    "Private - Returns the radix for the pivot point..."
    ^5! 
privateRotationAngle
    "Private - Returns the current rotation angle in device coordinates..."

    | tan x y degrees |
    selection isNil ifTrue: [^0].

    tan := selection rightBottom - selection leftTop.
    x := tan x. y := tan y.
    x = 0
    ifTrue: [
        y >= 0
        ifTrue: [^90]
        ifFalse: [^270]
    ].
    y = 0
    ifTrue: [
        x >= 0
        ifTrue: [^0]
        ifFalse: [^180]
    ].

    degrees := ((y / x) abs arcTan radiansToDegrees * 10) truncated / 10.0 .

    (x > 0 and: [y > 0]) ifTrue: [^degrees]. "1st cuadrant"
    x > 0 ifTrue: [^360 - degrees]. "3rd cuadrant"

    y > 0 ifTrue: [^180 - degrees]. "2nd cuadrant"

    ^180 + degrees!  
rotationAngle
    "Private - Returns the current rotation angle..."

    | angle |
    angle := 360 - self privateRotationAngle.
    ^angle = 360
    ifTrue: [0]
    ifFalse: [angle]!
selection: aRectangle
    "Private - Sets the receiver's selection..."

    super selection: aRectangle.
    self changed: #mouseLocation:!   
selectionCanBeMoved
    "Private - Returns true if the current selection can be moved..."

    ^mode ~= #rotate!   
selectionDoubleClickedAt: aPoint
    "Private - Perform action for doubleClick into the selection"

    mode = #cut
    ifTrue: [
        CursorManager execute
        changeFor: [ tile crop: selection ].
        self editSelectAll.
        mapPane redraw.
        ^self
    ].

    self beep! 
selectionEnds: aPane
    "Private - A selection operation has been done.
     aPane will have the #mode and #displacement"

    | angle |
    mode = #rotate
    ifTrue: [
        angle := self privateRotationAngle.
        angle = 0 ifTrue: [^self].
        (MessageBox confirm: 'Rota la imagen en ',self rotationAngle asString,' grados ?')
        ifFalse: [^self].
        CursorManager execute
        changeFor: [ tile rotate: angle ].
        mapPane redraw.
        ^self
    ]
    ifFalse: [
        ^super selectionEnds: aPane
    ]!   
selectionInProgress:aPane
    "Private - A selection operation is in progress.
     aPane will have the #mode and #displacement"

    mouse := self mouseLocation.
    self changed: #mouseLocation:.!   
selectionLineWidth
    "Private - Returns the current selection line width"
    ^1! 
setScrollRectangle: aPane

    "Callback for the #setScrollRectangle event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    aPane scrollingRectangle: (0@0 extent: tile extent)!   
tilePane: aPane

    "Callback for the #getContents event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    self send: #redraw to: aPane.!  
title
    "Private - Returns the title for the receiver's window"

    ^self titleWith: tile!  
toolMeasure
    "Change to measure mode..."

    | rect |
    rect := OSPrompter
        prompt: 'New selection rectangle'
        default: selection asString.
    rect isNil ifTrue: [^self].
    rect := Compiler evaluate: rect.
    rect isRectangle ifFalse: [ rect error: 'Debe ser un rectngulo...' ].
    self selection: rect.! !

! ObjectHolderView methods !
add: anObject
    "Add anObject to current objects in the holder"

    holder contents: (holder contents copyWith: anObject)!  
addAll: aCollection
    "Add aCollection to current objects in the holder"

    holder contents: holder contents , aCollection!
canDrop: anObject into: aPane
    "Private - True if the receiver can handle anObject now..."

    ^true "accept all objects anytime"! 
createViews
    "Create the receiver's view...
    Warning do NOT edit this window with WBuilder..."

    | mainView |
    mainView := self topPaneClass new.
    mainView
        owner: self;
        noSmalltalkMenuBar;
        backColor: ClrPalegray;
        pStyle: #(sysmenu sizable minimize);
        yourself.

    mainView
        addSubpane: (
            OSToolBar new
                    owner: self;
                    framingBlock: self toolBarFrame;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #edit;
                    add: #editDelete;
                    postAutomatic;
                    backColor: ClrPalegray;
                    yourself
        );
        addSubpane: (
            ObjectsHolderPane new
                owner: self;
                framingBlock: self holderFrame;
                when: #getContents perform: #holderContents:;
                when: #doubleClicked perform: #editSelection:;
                yourself
            ).

    self addView: mainView.!
drop: anObject into: aPane
    "The receiver insert anObject into aPane"

    | contents |
    contents := holder contents.
    (contents includes: anObject)
    ifFalse: [
        holder contents: contents , (Array with: anObject)
    ]!
edit
    "Performs the editBlock with currently selected objects.
     (if editBlock isNil then edit the selection)"

    editBlock isNil ifTrue: [ ^holder editSelection ].
    ^holder withSelectionDo: editBlock! 
editBlock
    "Returns the instance var of the receiver
     for external manipulation"
    ^editBlock!
editBlock: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    editBlock := anObject!   
editDelete
    "Private - Delete current selected objects"

    holder contents size = 0 ifTrue: [^self].
    holder selection size = 0 ifTrue: [
        (MessageBox confirm: 'Seguro borra todos los objetos ?')
        ifTrue: [ holder selectAll ] ifFalse: [^self].
    ].
    holder removeSelection!  
editSelection: aPane
    "Private - Process selection edition event"

    self edit!   
editSelector: aSymbol
    "Sets the editBlock for performing aSymbol when an object is doubleclicked"

    ^self editBlock: [:each| each perform: aSymbol ]!   
fileOpen
    "Private - FileIn stored objects"

     | dialog file collection |

    dialog := FileDialog new.
    dialog
        title: 'Seleccione un archivo de objetos...';
        addFilter: '*.vob' description: 'Archivo de objetos (*.VOB)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        defFilter: '*.vob';fileSpec: '*.vob';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].
    (file includes: $.) ifFalse: [ file := file,'.vob'].
    collection := ObjectFiler loadFromPathName: file.
    (collection isKindOf: Array) ifFalse: [ ^self error: 'Contenido de archivo invalido...' ].
    holder contents: collection!   
fileSave
    "Private - Lets the user save the current objects in a new file..."

     | dialog file |

    holder contents isEmpty ifTrue: [ ^self ].

    dialog := FileDialog new.
    dialog
        title: 'Donde desea guardar los objetos ?';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        addFilter: '*.vob' description: 'Archivo de objetos (*.VOB)';
        fileSpec: 'Objetos.vob';
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].

    CursorManager execute changeFor: [
        ObjectFiler dump: holder contents asArray newFile: file.
    ].!  
holder
    "Returns the instance var of the receiver
     for external manipulation"
    ^holder!  
holderContents: aPane

    "Callback for the #getContents event in an unnamed ObjectsHolderPane.
     (Generated by WindowBuilder)"

    holder := aPane.!   
holderFrame
    "Private - Returns the frame block for the objects holder pane"
    ^[:box| box leftTop + (0@self toolBarHeight) corner: box corner ]!  
initMdiWindowSize
    "Private - Returns the window size for the main view"

    ^self initWindowSize! 
initWindowSize
    "Private - Returns the window size for the main view"

    ^120@270!
toolBarFrame
    "Private - Returns the frame block for the toolbar"
    ^[:box| box leftTop extent: box width @ self toolBarHeight ]!  
toolBarHeight
    "Private - Returns the height of the toolbar"

    ^22!  
topPaneClass
    "Private - Answer the default top pane class."
    | model |
    model := self model.
    ^Smalltalk
        at: ((model isNil or: [model isInMDI not]) ifTrue: [#LittleTopPane] ifFalse: [#LittleMDIChild])
        ifAbsent: [super topPaneClass]! !

! ObjectsInSelectionView class methods ! 
helpMap
    "Private - Answer the map array for showing alternative help.
    This method can be refined by subclasses..."

   ^#(
        (newSearch 'Permite elegir nuevas opciones de bsqueda...')
        (fullUpdate 'Actualiza la lista de resultados.')
        (viewObjects 'Permite volcar la informacin encontrada en una ventana de texto.')
        (saveObjects 'Permite volcar la informacin encontrada en un archivo de texto.')
        (gotoObject 'Hubica el mapa actual en la posicin dada por el objeto selecto.')
        (toolCalculate 'Cuenta la cantidad de objetos encontrados.')
    )! 
wbCreated

    ^true! !

! ObjectsInSelectionView methods !   
collectObjects
    " Private - collect objects from current view..."

    | selection mapView count |
    selectedObjects := nil.
    viewManager isNil ifTrue: [ ^self ].
    views size = 0 ifTrue: [ ^self ].

    selection := viewManager selection.
    selection isRectangle ifFalse: [ selection := nil].

    mapView := viewManager mapView.
    mapView isNil ifTrue: [ ^self ].
    selectedObjects :=
        (mapView elementsInRectangle: selection) asArray
        select: [:each| self mustBeShown: each ].

    count := selectedObjects size.
    views first labelWithoutPrefix:
         (count > 0
        ifFalse: [ 'ningun objeto' ]
        ifTrue: [
            count = 1 ifTrue: ['un solo objeto']
            ifFalse: [ count asString,' objetos' ]
        ]).! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Bsquedas';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 393 @ 464; xC; yC; cRDU: (9 @ 456 rightBottom: 384 @ 46));
            pStyle: #(sysmenu titlebar sizable minimize);
            backColor: ClrPalegray;
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 347 @ 48; lDU: 2 r: #left; rDU: 350 r: #left; tDU: 2 r: #top; bDU: 50 r: #top);
                    add: #helpSearch selector: #newSearch;
                    add: #editUpdate selector: #fullUpdate;
                    add: #toolView selector: #viewObjects spaces: 3;
                    add: #fileSave selector: #saveObjects;
                    add: #editSearch selector: #gotoObject spaces: 3;
                    add: #toolCalculate;
                    postAutomatic;
                    startGroup;
                    when: #getContents perform: #toolbarContents:;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 375 @ 362; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 48 r: #top; bDU: 0 r: #bottom);
                    defaultStyle;
                    startGroup;
                    when: #getContents perform: #objects:;
                    when: #doubleClickSelect perform: #editObject:;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
draggedObjectIn: aPane
    "Private - Returns the currently dragged object.
    Implemented for drag&drop support..."

    ^self selectedObject!  
dumpObjectsInto: aStream
    " Private - Dump objects into aStream..."

    selectedObjects do: [:each|
        aStream cr;nextPutAll: each description
    ]!   
dumpObjectsInto: aStream withTabs: aBoolean
    " Private - Dump objects into aStream..."

    | line separator |
    separator := $,.
    selectedObjects do: [:each|
        line := each description.
        aBoolean ifFalse: [
            line := line collect: [:c| c == Tab ifTrue: [ separator ] ifFalse: [c] ]
        ].
        aStream cr;nextPutAll: line
    ]!
editObject: aPane

    "Callback for the #doubleClickSelect event in an unnamed OSListPane.
     (Generated by WindowBuilder)"

    | selectedObject |
    selectedObject := self selectedObject.
    selectedObject notNil ifTrue: [ selectedObject edit ]!   
fullUpdate
    "Refresh the receiver's panes..."

    self collectObjects.
    ^super fullUpdate! 
gotoObject
    " Lets the user position current view at selected object location..."

    | selectedObject |
    selectedObject := self selectedObject.
    (selectedObject notNil and: [ viewManager respondsTo: #position:])
    ifTrue: [
        viewManager position:
            selectedObject position - (viewManager mainView frameRectangle extent // 2)
    ]!
mapView: aMapView
    "Reset the receiver..."

    ^self viewManager: self model viewInUse!
message: aString
    "Private - Show aString in the contents box"

    ^self message: aString in: #status! 
message: aString in: statusBox
    "Private - Show aString in the status box"

    | pane |
    pane := self statusPane.
    pane notNil
    ifTrue: [
        (pane statusBoxAt: statusBox) contents: aString
    ]! 
mustBeShown: anInformation
    " Private - Returns true if anInformation must be shown..."

    | match |
    self searchCriteria isNil ifTrue: [ ^true ].
    match := [:index :value |
    ].

    searchCriteria
        detect: [:criteria| "any that not match..."
            criteria first notNil and: [
                (criteria first match: (anInformation perform: criteria last) asString asUpperCase index: 1) isNil
            ]
        ]
        ifNone: [^true]. "all matches"
    ^false! 
newSearch
    " Lets the user select a new search criteria..."

    | questions answers line |
    answers := self searchCriteria collect: [:tuple|
        tuple first isNil
        ifTrue: [ String new ]
        ifFalse: [ tuple first input ]
    ].
    questions := #(
        'Nombre (puede contener caracteres * y ?)'
        'Direccin (puede contener caracteres * y ?)'
        'Telfonos (puede contener caracteres * y ?)'
    ).

    answers := OSPrompter new
        title: 'Defina el criterio de bsqueda...';
        questions: questions;
        answers: answers;
        open.

    answers isNil ifTrue: [^false].

    1 to: answers size do: [:index|
        line := (answers at: index) trimBlanks asUpperCase.
        (self searchCriteria at: index) at: 1
            put: (line size = 0 ifFalse: [Pattern new: line])
    ].

    self fullUpdate.!
objects: aPane

    "Callback for the #getContents event in an unnamed OSListPane.
     (Generated by WindowBuilder)"

    | model view |
    model := self model.
    (model isNil or: [
        view := model viewInUse.
        viewManager ~= view ])
    ifTrue: [
        viewManager := view.
        self collectObjects.
    ].

    aPane contents:
        (self selectedObjects collect: [:each| each description ])! 
saveObjects
    " Lets the user dump object contents in a file..."

    | dialog file |
    self selectedObjects size > 0 ifFalse: [
        MessageBox warning: 'No hay objetos en la lista...\Seleccione otra regin del mapa o cambie el criterio de bsqueda.' withCrs.
        ^self
    ].
    file := 'Objects.Txt'.
    dialog := FileDialog new.
    dialog
        title: 'Seleccione el archivo donde guardar el texto';
        addFilter: '*.txt' description: 'Archivos de textos (*.TXT)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        fileSpec: file;
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].
    (File exists: file)
    ifTrue: [
        (MessageBox confirm: 'El archivo ',file,' ya existe.\Desea sobreescribirlo (perdiendo el contenido actual) ?')
        ifFalse: [ ^nil ].
    ].

    file := File newFile: file.
    CursorManager execute changeFor: [
        self dumpObjectsInto: file withTabs: false
    ].
    file close.!  
searchCriteria
    "Returns the instance var of the receiver
     for external manipulation"

    searchCriteria isNil ifTrue: [
        searchCriteria := #( (none name) (none address) (none phone)).
        searchCriteria do: [:tuple| tuple at: 1 put: nil ]. "set search criteria as don't care..."
    ].
    ^searchCriteria!
selectedObject
    "Private - Returns the currently selected object or nil..."

    | index |
    viewManager notNil
    ifTrue: [
        index := (self paneAt: #objects:) selection.
        index isNil ifTrue: [ ^nil ].
        (index between: 1 and: self selectedObjects size)
        ifTrue: [ ^self selectedObjects at: index ]
    ].
    ^nil!   
selectedObjects
    "Returns the instance var of the receiver
     for external manipulation"

    selectedObjects isNil ifTrue: [ selectedObjects := Array new ].
    ^selectedObjects! 
statusPaneHelp:aKey
    "Private - Answer the hint text to the StatusPane"

    | dict label pair value |
    label := [:selector :text|
        (text size = 0 or: [self respondsTo: selector])
        ifTrue: [ text ]
        ifFalse: [ text ,' *An no implementado [',selector,']*']
    ].

    self class helpMap do: [:pair |
        pair first asString = aKey asString
        ifTrue: [ ^label value: pair first value: pair last ]
    ].

    dict := Smalltalk at: #HelpStatusPane ifAbsent: [Dictionary new].
    value := dict at: aKey
        ifAbsent: [ dict at: aKey asSymbol ifAbsent: [ super statusPaneHelp: aKey ]].
    ^label value: aKey value: value!   
toolbarContents: aPane

    "Callback for the #getContents event in an unnamed WBToolBar.
     (Generated by WindowBuilder)"

    "do nothing..."!   
toolCalculate
    " Count the number of objects under selection..."

    self
        message: 'Buscando objetos...';
        fullUpdate;
        message: 'Cantidad de objetos : ', self selectedObjects size asString!
toolHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := self statusPaneHelp: selector asString.
    text isNil ifTrue: [ text := String new ].
    self message: text!
viewManager: aViewManager
    "ViewManager with focus has changed..."

    viewManager := aViewManager.
    self
        collectObjects;
        changed: #objects:!
viewObjects
    " Lets the user dump object contents in a text pane..."

    | monitor |
    self selectedObjects size > 0 ifFalse: [
        MessageBox warning: 'No hay objetos en la lista...\Seleccione otra regin del mapa o cambie el criterio de bsqueda.' withCrs.
        ^self
    ].
    CursorManager execute changeFor: [
        monitor := TextWindow
            windowLabeled: 'Objetos en la selectos en ',viewManager map name asString
            frame: ((Display width // 2 @ 0 rightBottom: Display extent) insetBy: 5).
        self dumpObjectsInto: monitor withTabs: false
    ].! !

! ReferencesViewManager class methods !
wbCreated

    ^true! !

! ReferencesViewManager methods !
button1Down: aPane

    "Callback for the #button1Down event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"!
button1Move: aPane

    "Callback for the #button1Move event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"!
button1Up: aPane

    "Callback for the #button1Up event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"!
close
    "Close the receiver & release instances"

    drawDib release.
    drawDib := nil.

    ^super close! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  '';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 329 @ 320; lDU: 11 r: #left; tDU: 134 r: #top; cRDU: (14 @ 452 rightBottom: 338 @ 174));
            pStyle: #(sysmenu titlebar minimize);
            " palette not implemented yet...
            when: #queryNewPalette perform: #queryNewPalette:;
            when: #paletteChanged perform: #paletteChanged:;
            when: #paletteIsChanging perform: #paletteIsChanging:;
            "
            backColor: ClrPalegray;
            addSubpane: (
                OSImagePane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 325 @ 278; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 0 r: #top; bDU: 0 r: #bottom);
                    startGroup;
                    when: #getContents perform: #imageContents:;
                    when: #display perform: #displayContents:;
                    when: #button1DoubleClick perform: #doubleClick:;
                    when: #button1Move perform: #button1Move:;
                    when: #button1Down perform: #button1Down:;
                    when: #button1Up perform: #button1Up:;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
displayContents: aPane

    "Callback for the #display event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    | dib box rect backColor |
    self drawDib isNil ifTrue: [ ^self ].
    (dib := self image) isNil ifTrue: [ ^aPane erase ].

    rect := aPane rectangleToDisplay.
    rect isNil ifTrue: [^self].
    (rect width > 0 and: [rect height > 0]) ifFalse: [^self].

    backColor := aPane pen backColor.
    box := dib boundingBox.
    (rect intersects: box)
    ifFalse: [ aPane pen fill: rect color: backColor ]
    ifTrue: [
        (rect nonIntersections: box)
        do: [:each| aPane pen fill: each color: backColor ].
        self drawDib
            source: rect;
            destination: rect;
            display: dib using: aPane pen.
    ].

    self displaySelection.! 
displaySelection
    "Private - Display the current selection..."!   
doubleClick: aPane

    "Callback for the #button1DoubleClick event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"! 
drawDib
    "Returns the current drawDib for the receiver..."

    | pane |
    drawDib notNil ifTrue: [^drawDib].

    pane := self mapPane.
    drawDib := DrawDib using: (pane notNil ifTrue: [pane pen])!  
fullExtent
    "Private - Return the receiver's main view extent"

    ^1@ (UserLibrary getSystemMetrics: SmCysize) + 1
    + (self hasContents
        ifTrue: [self image extent]
        ifFalse: [ 50@0 ])! 
hasContents
    "Private - True if the receiver's has an image..."

    ^self image notNil!
hasScrollBars
    "Private - Returns true if the receiver must use scroll bars in image pane"

    ^false! 
image
    "Private -  Returns the current image to display"

    ^self mapView notNil ifTrue: [ self mapView references ]! 
imageContents: aPane

    "Callback for the #getContents event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    aPane invalidateRect: nil.!
initWindowSize
    "Private - Returns the initial window size & position."

    ^7@7 extent: self fullExtent!  
map
    "Private - Returns the current map."

    viewManager isNil ifTrue: [^nil].
    viewManager mapView isNil ifTrue: [^nil].
    ^viewManager mapView map!  
mapPane
    "Private - Returns the pane for the map."

    ^self paneAt: #imageContents:!  
mapView
    "Private - Returns the current mapView."

    viewManager isNil ifTrue: [^nil].
    viewManager mapView isNil ifTrue: [^nil].
    ^viewManager mapView!  
openWindow
    "Private - Load default receiver's map..."

    super openWindow.
    self updateWindowSize.!  
paletteChanged: aPane

    "Callback for the #paletteChanged event in the TopPane 'mainView'.
     (Generated by WindowBuilder)"

    self drawDib paletteChanged!   
paletteIsChanging: aPane

    "Callback for the #paletteIsChanging event in the TopPane 'mainView'.
     (Generated by WindowBuilder)"

    "ignored..."!
preInitWindow
    "Private - Load default receiver's map..."

    self mainView framingBlock: [:box| self initWindowSize ].
    self hasScrollBars ifFalse: [
        self mapPane noBorders
    ].!
queryNewPalette: aPane

    "Callback for the #queryNewPalette event in the TopPane 'mainView'.
     (Generated by WindowBuilder)"

    self drawDib queryNewPalette!
updateWindowSize
    "Priavet - Update the window size acording to the stamp"

    views size = 0 ifTrue: [^self].

    self hasContents
    ifFalse: [ ^self mainView hideWindow ].
    self mainView showWindow.

    self mainView moveWindowTo:
       (self mainView frameRectangle origin extent: self fullExtent)!   
viewManager
    "Returns the instance var of the receiver
     for external manipulation"
    ^viewManager!
viewManager: aViewManager
    "Change the viewManager in the receiver..."

    viewManager := aViewManager.
    selection := nil.
    views isEmpty ifTrue: [^self].
    self
        updateWindowSize;
        changed: #imageContents:;
        yourself! !

! PhotoViewManager methods !
button1Up: aPane
    "Callback for the #button1Up event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    self close!
hasScrollBars
    "Private - Returns true if the receiver must use scroll bars in image pane"

    ^self initWindowSize extent < self fullExtent!  
image
    "Private -  Returns the current image to display"

    dib isNil ifTrue: [
        dib := DIB fromFile: pathName
    ].
    ^dib! 
initWindowSize
    "Private - Returns the initial window size & position."

    | extent factor |
    factor := 3 / 4.
    extent := self fullExtent.
    [extent > (Display extent * factor)] whileTrue: [
        extent := (extent * factor) truncated
    ].
    ^(Cursor offset extent: extent) translateBy: (extent // 2) negated! 
pathName
    "Returns the instance var of the receiver
     for external manipulation"
    ^pathName!  
pathName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    pathName := anObject! !

! StampViewManager methods !   
button1Up: aPane

    "Callback for the #button1Up event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    (viewManager respondsTo: #showMapAt:)
    ifTrue: [ ^viewManager showMapAt: aPane mouseLocation / self scale / viewManager scale ].
    (viewManager respondsTo: #position:)
    ifTrue: [ ^viewManager position: aPane mouseLocation / self scale / viewManager scale ].!
close
    "Close the receiver & release instances"

    self stopTimer.

    ^super close!   
currentSelection
    "Private - Returns the current viewPort in the viewManager
     adapted to receiver's stamp extent..."

    | pane |
    self hasContents ifFalse: [^nil].
    pane := viewManager mapPane.
    pane isNil ifTrue: [^self].
    ^(pane visibleRectangle scaleBy: self scale) truncated!  
displaySelection
    "Private - Display the current selection..."

    | aPane |
    (aPane := self mapPane) isNil ifTrue: [^self].
    (selection notNil and: [ aPane isHandleOk ])
    ifTrue: [ self drawSelectionIn: aPane pen boundingBox with: aPane pen ]!   
drawSelectionIn: aRectangle with: aPen
    "Private - Draw the current selection..."

    | backUp |
    backUp := aPen location.
    aPen
        setRop2: R2Notxorpen;
        setLineWidth: self selectionLineWidth;
        place: selection origin;
        box: selection corner;
        setRop2: R2Copypen;
        setLineWidth: 1;
        place: backUp;
        yourself.!   
image
    "Private -  Returns the current image to display"
    | mapView |
    mapView := self mapView.
    ^mapView notNil ifTrue: [ mapView map stamp ]!   
preInitWindow
    "Private - Load default receiver's map..."

    super preInitWindow.
    (self paneAt: #imageContents:) setCursor: 'hand'.

   "Update the selection each second..."
    self startTimerEach: 1000.! 
scale
    "Private - Returns the scale..."

    | map |
    self hasContents ifFalse: [^0@0].
    map := viewManager map.
    map isNil ifTrue: [ ^self].
    ^map stamp extent / map boundingBox extent / viewManager scale!  
selectionLineWidth
    "Private - Returns the current selection line width"
    ^2! 
tick
    "Private - Process timer ticks events..."
    | current |
    super tick.
    current := self currentSelection.
    current = selection ifTrue: [^self].
    self displaySelection.
    selection := current.
    self displaySelection.! !

! RegistrationView class methods !
bitmaps
    "Private - returns the specification for all the
    icons for drawing the form.
    The line format is: (bitmapName centerX centerY)
        bitmapName must be a valid bitmap name in CPBitmapDict
    "

    ^#(
        "Recycle Logo"
        ('recycle' 90 7)

    )!
info
    "Private - returns the specification for all the
    pane selectors for drawing the form information.
    The line format is:
        (selector left top)
    "

    ^#(
        (customerTitle: 24 11)
        (customerName: 24 14)
        (address: 24 20)
        (city: 24 23) (zip: 87 23)
        (country: 24 26)
        (phone: 24 29) (fax: 70 29)
        (date: 66.6 36)
    ), self particularInfo!
lines
    "Private - returns the specification for all the
    lines for drawing the form.
    The line format is:
        (width style left top right bottom)
    style must be a PsConstant (in WinConstant)
    "

    ^#(
        "Form frame"
        (3 PsSolid 1 1 99 1)
        (3 PsSolid 99 1 99 50)
        (3 PsSolid 99 50 1 50)
        (3 PsSolid 1 50 1 1)

        "ObjectStyle Info frame"
        (1 PsDashdotdot 5 55 95 55)
        (1 PsDashdotdot 95 55 95 95)
        (1 PsDashdotdot 95 95 5 95)
        (1 PsDashdotdot 5 95 5 55)

    )! 
particularInfo
    "Private - Returns the particular information of the receiver"

    ^#(
        (company: 24 17)
    )!   
particularTexts
    "Private - Returns the texts for particular use of the receiver "

    ^#(
        (big 'Compaia:' 4 17)
        (big 'Firma:' 4 32)
    )!
pictureFrame
    "Private - returns the boundingBox of the picture in the form."

    ^20@32 rightBottom: 60@47!   
texts
    "Private - returns the specification for all the
    texts for drawing the form.
    The line format is:
        ([big/small] 'text' left top)
    "

    ^#(

        (big 'Apellido:' 4 11)
        (big 'Nombres:' 4 14)
        (big 'Direccion:' 4 20)
        (big 'Ciudad:' 4 23) (big 'C.P.:' 66.6 23)
        (big 'Pais:' 4 26)
        (big 'Tel.:' 4 29) (big 'Fax.:' 58 29)
        (big 'Fecha:' 66.6 33)

        (big 'Dirigir este formulario a:' 8 67)
        (big 'Object Style.' 22 72)
        (big 'Mansilla 2401 1er. Piso' 22 75)
        (big 'Capital Federal' 22 78)
        (big 'Buenos Aires' 22 81)
        (big 'Argentina' 22 84)
        (big 'Tel./Fax: (54)-01-962-7027' 22 87)

        "
        500@3700 * 100 / (4500.0 @ 6500.00)
        "

    ), self particularTexts!
titles
    "Private - returns the specification for all the
    titles for drawing the form.
    The line format is:
        ( 'aTitle' left top)
    "

    ^Array with:
        (Array with: (StartUpApplication product,' ver: ',StartUpApplication version) with: 25 with: 7)!
wbCreated

    ^true! !

! RegistrationView methods ! 
adapt: aPoint to: box
    "Private - Adapt aPoint to aRectangle (box)."

    ^aPoint * box extent // 100!  
address: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"! 
city: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"!
closeMe: aPane

    "Callback for the #close event in the TopPane 'mainView'.
     (Generated by WindowBuilder)"

    | pane |
    pane := self paneAt: #signature:.
    pane notNil
    ifTrue: [ (pane propertyAt: #sign) release ].

    self close.!
company: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"! 
country: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Formulario de Registracion';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1143 @ 592; xC; yC; cRDU: (2 @ 590 rightBottom: 1141 @ 40));
            pStyle: #(sysmenu titlebar minimize);
            when: #close perform: #closeMe:;
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 18 r: #left; rDU: 155 r: #left; tDU: 12 r: #top; bDU: 44 r: #top);
                    startGroup;
                    contents: 'Apellido:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 18 r: #left; rDU: 174 r: #left; tDU: 62 r: #top; bDU: 94 r: #top);
                    startGroup;
                    contents: 'Nombres:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 32; lDU: 18 r: #left; rDU: 192 r: #left; tDU: 112 r: #top; bDU: 144 r: #top);
                    startGroup;
                    contents: 'Compaia:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 32; lDU: 18 r: #left; rDU: 183 r: #left; tDU: 162 r: #top; bDU: 194 r: #top);
                    startGroup;
                    contents: 'Direccion:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 18 r: #left; rDU: 146 r: #left; tDU: 212 r: #top; bDU: 244 r: #top);
                    startGroup;
                    contents: 'Ciudad:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 73 @ 32; lDU: 821 r: #left; rDU: 894 r: #left; tDU: 210 r: #top; bDU: 242 r: #top);
                    startGroup;
                    contents: 'C.P.';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 18 r: #left; rDU: 110 r: #left; tDU: 262 r: #top; bDU: 294 r: #top);
                    startGroup;
                    contents: 'Pais:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 32; lDU: 18 r: #left; rDU: 165 r: #left; tDU: 312 r: #top; bDU: 344 r: #top);
                    startGroup;
                    contents: 'Telefono:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 32; lDU: 622 r: #left; rDU: 686 r: #left; tDU: 312 r: #top; bDU: 344 r: #top);
                    startGroup;
                    contents: 'Fax';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 18 r: #left; rDU: 128 r: #left; tDU: 356 r: #top; bDU: 388 r: #top);
                    startGroup;
                    contents: 'Firma:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 665 @ 184; lDU: 183 r: #left; rDU: 848 r: #left; tDU: 356 r: #top; bDU: 540 r: #top);
                    noScrollBars;
                    startGroup;
                    when: #getContents perform: #signature:;
                    when: #button1Up perform: #signEnd:;
                    when: #display perform: #displaySignature:;
                    when: #button1Move perform: #signInProgress:;
                    when: #button1Down perform: #signStart:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 862 r: #left; rDU: 971 r: #left; tDU: 356 r: #top; bDU: 388 r: #top);
                    startGroup;
                    contents: 'Fecha:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 942 @ 48; lDU: 183 r: #left; rDU: 1125 r: #left; tDU: 2 r: #top; bDU: 50 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #customerTitle:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 942 @ 48; lDU: 183 r: #left; rDU: 1125 r: #left; tDU: 52 r: #top; bDU: 100 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #customerName:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 942 @ 48; lDU: 183 r: #left; rDU: 1125 r: #left; tDU: 102 r: #top; bDU: 150 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #company:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 942 @ 48; lDU: 183 r: #left; rDU: 1125 r: #left; tDU: 152 r: #top; bDU: 200 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #address:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 622 @ 48; lDU: 183 r: #left; rDU: 805 r: #left; tDU: 202 r: #top; bDU: 250 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #city:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 48; lDU: 905 r: #left; rDU: 1125 r: #left; tDU: 202 r: #top; bDU: 250 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #zip:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 942 @ 48; lDU: 183 r: #left; rDU: 1125 r: #left; tDU: 252 r: #top; bDU: 300 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #country:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 439 @ 48; lDU: 183 r: #left; rDU: 622 r: #left; tDU: 302 r: #top; bDU: 350 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #phone:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 439 @ 48; lDU: 686 r: #left; rDU: 1125 r: #left; tDU: 302 r: #top; bDU: 350 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #fax:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPDateEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 203 @ 48; lDU: 917 r: #left; tDU: 392 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #date:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 55 @ 48; lDU: 121 r: #left; tDU: 492 r: #top);
                    bitmap: (CPBitmapDict at: 'erase');
                    startGroup;
                    tabStop;
                    when: #clicked perform: #eraseSignature:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 265 @ 64; lDU: 855 r: #left; rDU: 1120 r: #left; tDU: 476 r: #top; bDU: 540 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #outputToPrinter:;
                    contents: '&Imprimir Ahora';
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
customerName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"!
customerTitle: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"!   
date: aPane

    "Callback for the #getContents event in an unnamed CPDateEditor.
     (Generated by WindowBuilder)"!  
displaySignature: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | frame bitmap |
    frame := aPane frameRectangle.
    (bitmap := aPane propertyAt: #sign) isNil
    ifTrue: [ ^nil ].
    bitmap displayAt: 0@0 with: aPane pen.!   
drawFormUsing: aPen
    "Private - Draw the Form using aPen."

    | box bitmap spec |
    box := aPen boundingBox.

    self class lines do: [:each|
        spec := ReadStream on: each.
        aPen
            setLineWidth: spec next;
            setLineType: (WinConstants at: spec next asString ifAbsent: [PsSolid]);
            place: (self adapt: spec next @ spec next to: box);
            goto: (self adapt: spec next @ spec next to: box)
    ].

    "
    bitmap := (self paneAt: #signature:) propertyAt: #sign.
    bitmap notNil ifTrue: [
        aPen
            copyBitmap: bitmap
            from: bitmap boundingBox
            to: (box extent - bitmap extent // 2 extent: bitmap extent * 2) truncated.
    ].
    "! 
drawPicturesUsing: aPen
    "Private - Draw the Pictures using aPen."

    | box dest bitmap spec |
    self drawSignatureUsing: aPen.
    box := aPen boundingBox.
    self class bitmaps do: [:each|
        spec := ReadStream on: each.
        (bitmap := CPBitmapDict at: spec next asString) notNil
        ifTrue: [
            dest := ((self adapt: spec next @ spec next to: box)
                extent: bitmap extent * 2) translateBy: bitmap extent negated.
            aPen
                copyBitmap: bitmap
                from: bitmap boundingBox
                to: dest
        ].
    ].!
drawSignatureUsing: aPen
    "Private - Draw the Signature using aPen."

    | box dest bitmap spec frame |
    box := aPen boundingBox.
    bitmap := (self paneAt: #signature:) propertyAt: #sign.
    frame := self class pictureFrame.
    dest := (self adapt: frame origin to: box)
        rightBottom: (self adapt: frame rightBottom to: box).
    bitmap notNil ifTrue: [
        aPen
            copyBitmap: bitmap
            from: bitmap boundingBox
            to: dest.
    ].!  
drawTextUsing: aPen
    "Private - Draw the Form using aPen."

    | box title big small info spec old text selector |
    box := aPen boundingBox.
    title  := Font face:'Helv' size: (self adapt: 3@5 to: box) fixedWidth: false.
    big  := Font face:'Helv' size: (self adapt: 2@3 to: box) fixedWidth: false.
    small  := Font face:'Times' size: (self adapt: 1@1.5 to: box) fixedWidth: false.
    info  := Font face:'Arial' size: (self adapt: 1.3@2 to: box) fixedWidth: false.
    old := aPen font.
    aPen font: title.
    self class titles do: [:each|
        spec := ReadStream on: each.
        aPen
            displayText: spec next
            at: (self adapt: spec next @ spec next to: box)
    ].
    self class texts do: [:each|
        spec := ReadStream on: each.
        spec next = #big
        ifTrue: [ aPen font: big ]
        ifFalse: [ aPen font: small ].
        aPen
            displayText: spec next
            at: (self adapt: spec next @ spec next to: box)
    ].
    aPen font: info.
    self class info do: [:each|
        spec := ReadStream on: each.
        selector := spec next.
        text := selector last = $:
            ifTrue: [ (self paneAt: selector) contents ]
            ifFalse: [ self perform: selector ].
        text isNil ifFalse: [
            aPen
                displayText: text asString
                at: (self adapt: spec next @ spec next to: box)
        ]
    ].
    aPen font: old.! 
eraseSignature: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    (self paneAt: #signature:) update.!   
fax: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"! 
outputToPrinter: aPane

    "Callback for the #clicked event in an unnamed Button (contents is '&Imprimir Ahora').
     (Generated by WindowBuilder)"

    | printer |
    printer := StartUpApplication printer.
    CursorManager execute changeFor: [
        printer startPrintJob.
        self
            drawFormUsing: printer pen;
            drawTextUsing: printer pen;
            drawPicturesUsing: printer pen;
            yourself.
        printer endPrintJob.
    ].!
phone: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"!   
signature: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | frame bitmap |
    frame := aPane frameRectangle.
    (bitmap := aPane propertyAt: #sign) isNil
    ifTrue: [
        bitmap := Bitmap extent: frame extent.
        aPane propertyAt: #sign put: bitmap.
    ].
    aPane pen erase.
    bitmap pen erase.!   
signEnd: aPane

    "Callback for the #button1Up event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self signInProgress: aPane.

   " (aPane propertyAt: #sign) displayAt: 0@0 only for debug..."! 
signInProgress: aPane

    "Callback for the #button1Move event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | bitmap point |
    bitmap := aPane propertyAt: #sign.
    bitmap isNil ifTrue: [ ^nil ].
    point := aPane mouseLocation.
    bitmap pen goto: point.
    aPane pen goto: point.!   
signStart: aPane

    "Callback for the #button1Down event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | point bitmap |
    bitmap := aPane propertyAt: #sign.
    bitmap isNil ifTrue: [ ^nil ].
    point := aPane mouseLocation.
    bitmap pen place: point.
    aPane pen place: point.!  
zip: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"! !

! OrderFormView class methods !
lines
    "Private - returns the specification for all the
    lines for drawing the form.
    The line format is:
        (width style left top right bottom)
    style must be a PsConstant (in WinConstant)
    "

    ^super lines,
    #(
        "Info frame"
        (5 PsDot 3 32 55 32)
        (5 PsDot 55 32 55 45)
        (5 PsDot 55 45 3 45)
        (5 PsDot 3 45 3 32)
    )! 
particularInfo
    "Private - Returns the particular information of the receiver"

    ^#(
        (numberOfCopies: 24 35)
        (versionSelected 24 40)
    )!   
particularTexts
    "Private - Returns the texts for particular use of the receiver "

    ^#(
        (big 'Copias:' 4 35)
        (big 'Version:' 4 40)
    )!
wbCreated

    ^true! !

! OrderFormView methods !
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Orden de Compra';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1143 @ 576; xC; yC; cRDU: (2 @ 574 rightBottom: 1141 @ 40));
            pStyle: #(sysmenu titlebar minimize);
            when: #close perform: #closeMe:;
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 539 @ 128; lDU: 585 r: #left; tDU: 324 r: #top);
                    contents: '';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 18 r: #left; rDU: 155 r: #left; tDU: 12 r: #top; bDU: 44 r: #top);
                    startGroup;
                    contents: 'Apellido:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 18 r: #left; rDU: 174 r: #left; tDU: 62 r: #top; bDU: 94 r: #top);
                    startGroup;
                    contents: 'Nombres:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 32; lDU: 18 r: #left; rDU: 183 r: #left; tDU: 112 r: #top; bDU: 144 r: #top);
                    startGroup;
                    contents: 'Direccin:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 18 r: #left; rDU: 146 r: #left; tDU: 162 r: #top; bDU: 194 r: #top);
                    startGroup;
                    contents: 'Ciudad:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 73 @ 32; lDU: 821 r: #left; rDU: 894 r: #left; tDU: 160 r: #top; bDU: 192 r: #top);
                    startGroup;
                    contents: 'C.P.';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 18 r: #left; rDU: 110 r: #left; tDU: 212 r: #top; bDU: 244 r: #top);
                    startGroup;
                    contents: 'Pais:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 32; lDU: 18 r: #left; rDU: 165 r: #left; tDU: 262 r: #top; bDU: 294 r: #top);
                    startGroup;
                    contents: 'Telfono:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 32; lDU: 622 r: #left; rDU: 686 r: #left; tDU: 262 r: #top; bDU: 294 r: #top);
                    startGroup;
                    contents: 'Fax';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 784 r: #left; rDU: 894 r: #left; tDU: 354 r: #top; bDU: 386 r: #top);
                    startGroup;
                    contents: 'Fecha:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 293 @ 32; lDU: 601 r: #left; rDU: 894 r: #left; tDU: 408 r: #top; bDU: 440 r: #top);
                    startGroup;
                    contents: 'Numero de Copias:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 942 @ 48; lDU: 183 r: #left; rDU: 1125 r: #left; tDU: 2 r: #top; bDU: 50 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #customerTitle:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 942 @ 48; lDU: 183 r: #left; rDU: 1125 r: #left; tDU: 52 r: #top; bDU: 100 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #customerName:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 942 @ 48; lDU: 183 r: #left; rDU: 1125 r: #left; tDU: 102 r: #top; bDU: 150 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #address:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 622 @ 48; lDU: 183 r: #left; rDU: 805 r: #left; tDU: 152 r: #top; bDU: 200 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #city:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 48; lDU: 905 r: #left; rDU: 1125 r: #left; tDU: 152 r: #top; bDU: 200 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #zip:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 942 @ 48; lDU: 183 r: #left; rDU: 1125 r: #left; tDU: 202 r: #top; bDU: 250 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #country:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 439 @ 48; lDU: 183 r: #left; rDU: 622 r: #left; tDU: 252 r: #top; bDU: 300 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #phone:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 439 @ 48; lDU: 686 r: #left; rDU: 1125 r: #left; tDU: 252 r: #top; bDU: 300 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #fax:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                RadioButtonGroup new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 558 @ 208; lDU: 18 r: #left; rDU: 576 r: #left; tDU: 310 r: #top; bDU: 518 r: #top);
                    label: 'Versin';
                    contents: #( 'Windows 3.1' 'Windows 3.1  (32 Bits)' 'Windows NT' );
                    startGroup;
                    tabStop;
                    when: #getContents perform: #versionRadios:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPDateEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 203 @ 48; lDU: 910 r: #left; tDU: 338 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #date:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 203 @ 48; lDU: 910 r: #left; tDU: 392 r: #top);
                    min: 1;
                    contents: 1;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #numberOfCopies:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 265 @ 64; lDU: 859 r: #left; rDU: 1125 r: #left; tDU: 458 r: #top; bDU: 522 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #outputToPrinter:;
                    contents: '&Imprimir Ahora';
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
drawSignatureUsing: aPen
    "Private - Draw the Signature using aPen."


    "Do Nothing... The receiver's does not use a signature..."! 
numberOfCopies: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"! 
versionRadios: aPane

    "Callback for the #getContents event in an unnamed RadioButtonGroup.
     (Generated by WindowBuilder)"

    aPane selection: 1.!  
versionSelected
    "Private - Returns current version selected"
    ^(self paneAt: #versionRadios:) selectedItem! !

! StringStripper class methods !
defaultDLLBytes
    "Private - Returns the default bytes for an Empty dll file"
    ^#(
    77 90 0 1 3 0 0 0 8 0 0 0 255 255 8 0 0 1 0 0
    0 0 0 0 64 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 1 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 186 16 0 14 31 180 9 205 33 184 1 76
    205 33 144 144 84 104 105 115 32 112 114 111 103 114 97 109 32 114 101 113
    117 105 114 101 115 32 77 105 99 114 111 115 111 102 116 32 87 105 110 100
    111 119 115 46 13 10 36 32 32 32 32 32 32 32 32 32 32 32 32 32
    32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
    32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32
    32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 32 78 69 6 1
    124 0 27 0 0 0 0 0 1 131 3 0 0 32 0 0 2 0 1 0
    0 0 3 0 3 0 2 0 5 0 64 0 88 0 92 0 107 0 111 0
    151 1 0 0 4 0 8 0 0 0 2 0 0 0 0 0 0 0 0 3
    2 0 23 0 80 13 23 0 3 0 107 1 80 13 107 1 5 0 88 0
    65 12 88 0 8 0 0 0 5 69 77 80 84 89 0 0 3 87 69 80
    1 0 0 1 0 8 0 0 6 75 69 82 78 69 76 4 85 83 69 82
    4 255 3 205 63 2 66 0 0 205 63 2 73 1 0 205 63 2 2 0
    0 205 63 2 56 0 0 1 63 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 1 0 154 255 255 0 0 85
    137 229 49 192 154 255 255 0 0 93 154 255 255 0 0 3 0 3 0 3
    0 255 0 3 0 3 0 13 0 255 0 2 0 3 0 19 0 255 0 4
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 2 0 69 85 139 236 30 137 62 18 0 137
    54 22 0 140 6 24 0 227 14 51 192 30 80 81 154 255 255 0 0 11
    192 116 14 51 192 163 28 0 64 163 40 0 139 229 93 77 203 139 236 93
    77 89 89 203 88 88 161 40 0 139 62 18 0 203 140 216 144 69 85 139
    236 30 86 87 142 216 139 70 6 163 40 0 232 116 0 184 1 0 95 94
    31 93 77 202 2 0 89 91 235 4 51 201 51 219 163 40 0 137 14 42
    0 137 30 44 0 131 62 46 0 0 116 3 232 76 0 161 42 0 139 22
    44 0 139 200 11 202 116 56 131 236 64 139 244 131 250 255 116 7 142 194
    38 139 22 0 0 80 82 255 54 40 0 184 56 0 30 80 22 86 154 255
    255 0 0 139 230 51 192 80 22 86 80 80 184 16 16 80 154 255 255 0
    0 131 196 64 161 40 0 180 76 205 33 196 30 36 0 140 192 11 195 116
    19 51 192 163 36 0 163 38 0 163 48 0 184 203 0 14 80 6 83 203
    195 80 111 114 116 105 111 110 115 32 67 111 112 121 114 105 103 104 116 32
    40 99 41 32 49 57 57 49 32 66 111 114 108 97 110 100 51 192 135 6
    48 0 203 131 62 48 0 0 117 1 203 161 48 0 233 65 255 139 244 54
    142 68 2 38 59 85 2 127 7 124 20 38 59 5 114 15 38 59 85 6
    124 8 127 7 38 59 69 4 119 1 203 184 201 0 233 25 255 5 0 2
    43 196 115 21 247 216 54 59 6 10 0 114 12 54 59 6 14 0 115 4
    54 163 14 0 203 184 202 0 233 247 254 3 0 3 1 27 0 1 0 4
    0 3 1 171 0 2 0 164 1 3 1 189 0 2 0 1 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 5 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 4 0 32 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 2 0 82 117 110 116
    105 109 101 32 101 114 114 111 114 32 37 100 32 97 116 32 37 48 52 88
    58 37 48 52 88 46 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0
    0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )!  
helpContents
    ^'
    String Stripper
    Version 1.10
    @1994 Object Style
    Mansilla 2401 1er Piso
    Buenos Aires - Argentina.
    Tel/Fax: (54)-01-962-7027
'! 
initialize
    "Private - Initialize the receiver.
        StringStripper initialize.
    "

    | file contents pathName bytes |

    pathName := 'Empty.DLL'.
    (File exists: pathName)
    ifTrue: [
        file := File pathName: pathName.
        contents := file contents.
        file close.
    ]
    ifFalse: [
        bytes := self defaultDLLBytes.
        contents := String new: bytes size.
        1 to: bytes size do: [:i|
            contents at: i put: (Character value: (bytes at: i))
        ]
    ].
    EmptyCode := contents.!
wbCreated

    ^true! !

! StringStripper methods !   
addAClass

    "Callback for the menu item titled 'Select...'.
     (Generated by WindowBuilder)"

    | class dialog |

    dialog := Smalltalk at: #MultiSelectListDialog ifAbsent: [
        class := OSPrompter
            prompt: 'Name for the class to add ?'
            default: String new.
        class isNil ifTrue: [^nil].
        (class := class trimBlanks) isEmpty ifTrue: [^self].
        class := Smalltalk at: class asSymbol
        ifAbsent: [^self error: 'Class not Found in Smalltalk'].
        class isBehavior ifFalse: [^self error: 'The selected object is not a class.'].
        class isClass ifFalse: [class := class instanceClass].
        (classes includes: class) ifFalse: [ classes add: class ].
        nil
    ].
    dialog notNil ifTrue: [
        CursorManager execute changeFor: [
            class := dialog new
                title: 'Seleccione las clases';
                font: (Font face:'Helv' size: 0 @ 8 fixedWidth:false);
                openOn: (self getSourceClasses: true).
        ].
        class size > 0 ifFalse: [^self].
        class do: [:each|
            (classes includes: each) ifFalse: [ classes add: each ].
        ]
    ].

    self changed: #listOfClasses:.!
addAGlobal

    "Callback for the menu item titled 'Select...'.
     (Generated by WindowBuilder)"

    | selection object |
    selection := String new.
    Smalltalk keysDo: [:key|
        (self isString: (Smalltalk at: key))
        ifTrue: [ selection := selection , ' ',key ]
    ].

    selection := OSPrompter
        prompt: 'Select the global strings to add...'
        default: selection.
    selection isNil ifTrue: [^nil].
    (selection := selection asArrayOfSubstrings) isEmpty ifTrue: [^self].

    selection do: [:each|
        object := Smalltalk at: each asSymbol.
        (self isString: object) ifFalse: [ ^ object error: 'Must be a String.' ].
        (globals includesKey: each asSymbol)
        ifFalse: [ globals at: each asSymbol put: object ]
    ].

    self changed: #listOfGlobals:.! 
addAnObject

    "Callback for the menu item titled 'Select...'.
     (Generated by WindowBuilder)"

    | expr object |
    expr := OSPrompter
        prompt: 'Escriba la expresion a evaluar para obtener el string a embeber...'
        default: String new.
    expr isNil ifTrue: [^nil].
    (expr := expr trimBlanks) isEmpty ifTrue: [^self].

    object := Compiler evaluate: expr.
    object isNil ifTrue: [^nil].

    objects detect: [:each| each == object]
    ifNone: [ objects addLast: object ].

    self changed: #listOfObjects:.! 
addAPool

    "Callback for the menu item titled 'Select...'.
     (Generated by WindowBuilder)"

    | selection pool isValidDict |
    isValidDict := [:aDict|
        aDict notEmpty and: [
            (aDict values detect: [:each| (self isString: each) not] ifNone: []) isNil
        ]
    ].
    CursorManager execute changeFor: [
        selection := String new.
        Smalltalk keysDo: [:key|
            (((pool := Smalltalk at: key) isMemberOf: Dictionary)
            and: [ isValidDict value: pool ])
            ifTrue: [ selection := selection , ' ',key ]
        ].
    ].

    selection := OSPrompter
        prompt: 'Select the Pool Dictionaries to add...'
        default: selection.
    selection isNil ifTrue: [^nil].
    (selection := selection asArrayOfSubstrings) isEmpty ifTrue: [^self].

    selection do: [:sel|
        pool := Smalltalk at: sel asSymbol.
        (pool isMemberOf: Dictionary) ifFalse: [ ^ sel error: 'Must be a Pool Dictionary.' ].
        (isValidDict value: pool) ifFalse: [ ^pool error: 'Must be a Pool Dictionary.' ].
        (pools includesKey: sel asSymbol)
        ifFalse: [ pools at: sel asSymbol put: pool ]
    ].

    self changed: #listOfPools:.!  
addString: aString
    "Private - Scan receiver's classes for strings"

    ^strings
        detect: [:one| one == aString ]
        ifNone: [ strings add: aString ]!   
allClassesHasBeenSelected
    "True if all the classes has been selected"

    ^(self paneAt: #allClassesToggle:) selection!   
allClassesToggle: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'All Classes').
     (Generated by WindowBuilder)"

    "used only for reference to the pane..."!  
allClassesToggled: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'All Classes').
     (Generated by WindowBuilder)"

    self changed: #listOfClasses:!
buildDLL
    "Private - True if the receiver must build a DLL"
    ^(self paneAt: #buildDLLToggle:) selection!  
buildDLLFileName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    aPane contents size = 0
    ifTrue: [ aPane contents: 'XLang.DLL' ].

    self enable: aPane when: self buildDLL.!
buildDLLToggle: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Build DLL :').
     (Generated by WindowBuilder)"

    aPane selection: true.!  
buildDLLToggled: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Build DLL :').
     (Generated by WindowBuilder)"

    self
        changed: #buildDLLFileName:;
        changed: #resourceCompilerName:;
        yourself.!
chunksFor: aString
    "Private - Returns aString in 256 pieces"
    | chunks step |
    aString size > 255 ifFalse: [^Array with: aString].
    step := 250.
    chunks := OrderedCollection new: aString size // step + 1.
    1 to: aString size by: step do: [:i|
        chunks addLast: (aString copyFrom: i to: i + step)
    ].
    ^chunks asArray! 
closeMainView: aPane

    "Callback for the #close event in the TopPane 'mainView'.
     (Generated by WindowBuilder)"

    self close.! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'String Stripper ver 1.10';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1143 @ 900; lDU: 23 r: #left; tDU: 14 r: #top; cRDU: (9 @ 892 rightBottom: 1134 @ 46));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            when: #close perform: #closeMainView:;
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 302 @ 32; lDU: 23 r: #left; rDU: 325 r: #left; tDU: 218 r: #top; bDU: 250 r: #top);
                    startGroup;
                    contents: 'Resource Compiler:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 238 @ 74; xC; tP: 71/141; bP: 250/423);
                    startGroup;
                    when: #getContents perform: #scanViewButton:;
                    when: #clicked perform: #openScanView:;
                    contents: 'Select from...';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 821 r: #left; rDU: 949 r: #left; tDU: 106 r: #top; bDU: 138 r: #top);
                    startGroup;
                    contents: 'Start ID:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 72; xC; tP: 263/423; bP: 299/423);
                    startGroup;
                    when: #getContents perform: #scanButton:;
                    when: #clicked perform: #scanNow:;
                    contents: 'Scan Now!!';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1125 @ 56; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 0 r: #top; bDU: 56 r: #top);
                    in;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StatusPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1125 @ 38; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 38 r: #bottom; bDU: 0 r: #bottom);
                    contents: (
                        OrderedCollection new
                            addLast: (
                                StatusBox new
                                    space: 7;
                                    width: 10;
                                    name: #contents
                            );
                            yourself
                    );
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1111 @ 204; lDU: 7 r: #left; rDU: 7 r: #right; tDU: 56 r: #top; bDU: 260 r: #top);
                    contents: 'Options';
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 40; lDU: 23 r: #left; rDU: 242 r: #left; tDU: 102 r: #top; bDU: 142 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #buildDLLToggled:;
                    when: #getContents perform: #buildDLLToggle:;
                    contents: 'Build DLL :';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 293 @ 40; lDU: 23 r: #left; rDU: 315 r: #left; tDU: 158 r: #top; bDU: 198 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #dumpRefToggled:;
                    when: #getContents perform: #dumpRefToggle:;
                    contents: 'Dump Refs Into:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 48; lDU: 327 r: #left; rDU: 313 r: #right; tDU: 98 r: #top; bDU: 146 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #buildDLLFileName:;
                    contents: 'XLang.DLL';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 48; lDU: 949 r: #left; rDU: 1104 r: #left; tDU: 98 r: #top; bDU: 146 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #startID:;
                    contents: '1';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 777 @ 48; lDU: 325 r: #left; rDU: 23 r: #right; tDU: 150 r: #top; bDU: 198 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #dumpRefFileName:;
                    contents: 'XLang.RC';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 777 @ 48; lDU: 325 r: #left; rDU: 23 r: #right; tDU: 202 r: #top; bDU: 250 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #resourceCompilerName:;
                    contents: 'RC ';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPColumnarListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1111 @ 540; lDU: 7 r: #left; rDU: 7 r: #right; tDU: 264 r: #top; bDU: 42 r: #bottom);
                    headerColor: (ColorConstants at: 'ClrPalegray');
                    fields: (
                        OrderedCollection new
                        addLast: (
                            CPCLBField new
                                header: 'Id.';
                                fieldWidth: 5;
                                selector: #first
                        );
                        addLast: (
                            CPCLBField new
                                header: 'Contents';
                                selector: #last
                        );
                        yourself
                    );
                    startGroup;
                    tabStop;
                    when: #getContents perform: #stringsTable:;
                    when: #doubleClickSelect perform: #editStringEntry:;
                    setPopupMenu: (
                        Menu new
                            title: '';
                            owner: self;
                            appendItem: '&Scan again' selector: #editSearch acceleratorString: '';
                            appendItem: '&Update Lists' selector: #updateLists acceleratorString: '';
                            appendSeparator;
                            appendItem: 'Remove &Duplicates' selector: #removeDupicates acceleratorString: '';
                            appendItem: 'Remove from &List' selector: #ignoreSelectedString acceleratorString: '';
                            appendSeparator;
                            appendItem: 'Build DLL Now!!' selector: #fileSave acceleratorString: ''
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 475 @ 44; lDU: 7 r: #left; rDU: 642 r: #right; tDU: 6 r: #top; bDU: 50 r: #top);
                    add: #editSelect;
                    add: #editDelete;
                    add: #editSearch spaces: 5;
                    add: #fileSave spaces: 5;
                    add: #fileOpen;
                    add: #fileRun;
                    add: #fileExit spaces: 5;
                    add: #helpContents;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #paletteHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Scan for strings into...';
            noSmalltalkMenuBar;
            viewName: 'selectionView';
            framingBlock: ( FramingParameters new iDUE: 942 @ 752; lDU: 123 r: #left; tDU: 290 r: #top; cRDU: (2 @ 750 rightBottom: 939 @ 78));
            pStyle: #(sysmenu titlebar minimize);
            backColor: ClrPalegray;
            addSubpane: (
                MultipleSelectListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 878 @ 232; lDU: 27 r: #left; rDU: 905 r: #left; tDU: 40 r: #top; bDU: 272 r: #top);
                    startGroup;
                    when: #getContents perform: #listOfClasses:;
                    when: #doubleClickSelect perform: #editClass:;
                    setPopupMenu: (
                        Menu new
                            title: '';
                            owner: self;
                            appendItem: '&All Classes' selector: #selectAllClasses acceleratorString: '';
                            appendItem: '&Select...' selector: #addAClass acceleratorString: '';
                            appendItem: '&From Project...' selector: #selectFromProject acceleratorString: '';
                            appendSeparator;
                            appendItem: '&Remove Selected' selector: #removeSelectedClasses acceleratorString: '';
                            appendItem: 'R&emove All' selector: #removeAllClasses acceleratorString: '';
                            appendSeparator;
                            appendItem: '&Update List' selector: #updateLists acceleratorString: ''
                    );
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 27 r: #left; tDU: 278 r: #top);
                    startGroup;
                    when: #getContents perform: #allClassesToggle:;
                    when: #clicked perform: #allClassesToggled:;
                    contents: 'All Classes';
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 421 @ 136; lDU: 27 r: #left; rDU: 448 r: #left; tDU: 360 r: #top; bDU: 496 r: #top);
                    startGroup;
                    when: #getContents perform: #listOfPools:;
                    setPopupMenu: (
                        Menu new
                            title: 'Untitled';
                            owner: self;
                            appendItem: '&Select...' selector: #addAPool acceleratorString: '';
                            appendItem: '&Inspect selected' selector: #inspectSelectedPool acceleratorString: '';
                            appendSeparator;
                            appendItem: '&Remove selected' selector: #removeSelectedPool acceleratorString: ''
                    );
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 421 @ 136; lDU: 489 r: #left; rDU: 910 r: #left; tDU: 360 r: #top; bDU: 496 r: #top);
                    startGroup;
                    when: #getContents perform: #listOfGlobals:;
                    setPopupMenu: (
                        Menu new
                            title: 'Untitled';
                            owner: self;
                            appendItem: '&Select...' selector: #addAGlobal acceleratorString: '';
                            appendItem: '&Inspect Selected' selector: #inspectSelectedGlobal acceleratorString: '';
                            appendSeparator;
                            appendItem: '&Remove Selected' selector: #removeSelectedGlobal acceleratorString: ''
                    );
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 878 @ 106; lDU: 27 r: #left; rDU: 905 r: #left; tDU: 548 r: #top; bDU: 654 r: #top);
                    startGroup;
                    when: #getContents perform: #listOfObjects:;
                    setPopupMenu: (
                        Menu new
                            title: 'Untitled';
                            owner: self;
                            appendItem: '&Select...' selector: #addAnObject acceleratorString: '';
                            appendItem: '&Inspect selected' selector: #inspectSelectedObject acceleratorString: '';
                            appendSeparator;
                            appendItem: '&Remove selected' selector: #removeSelectedObject acceleratorString: ''
                    );
                    font: (
                        Font new
                        fromBytes: #( 244 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 914 @ 310; lDU: 9 r: #left; tDU: 8 r: #top);
                    contents: 'Classes';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 453 @ 186; lDU: 9 r: #left; tDU: 324 r: #top);
                    contents: 'Pool Dictionaries';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 453 @ 186; lDU: 471 r: #left; tDU: 324 r: #top);
                    contents: 'Global Objects';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 914 @ 150; lDU: 9 r: #left; tDU: 512 r: #top);
                    contents: 'Other Objects Refs.';
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).

    v menuWindow
        yourself;
        addMenu: (
            Menu new
                title: '&Classes';
                owner: self;
                appendItem: '&All Classes	Ctrl+A' selector: #selectAllClasses acceleratorString: 'Ctrl+A';
                appendItem: '&Select...	Ctrl+S' selector: #addAClass acceleratorString: 'Ctrl+S';
                appendItem: '&From Project...	Ctrl+P' selector: #selectFromProject acceleratorString: 'Ctrl+P';
                appendSeparator;
                appendItem: '&Remove selected	Alt+R' selector: #removeSelectedClasses acceleratorString: 'Alt+R';
                appendItem: 'R&emove All' selector: #removeAllClasses acceleratorString: '';
                appendSeparator;
                appendItem: '&Update Lists' selector: #updateLists acceleratorString: ''
        );
        addMenu: (
            Menu new
                title: '&Pool Dictionary';
                owner: self;
                appendItem: '&Select...' selector: #addAPool acceleratorString: '';
                appendItem: '&Inspect selected' selector: #inspectSelectedPool acceleratorString: '';
                appendSeparator;
                appendItem: '&Remove selected' selector: #removeSelectedPool acceleratorString: ''
        );
        addMenu: (
            Menu new
                title: '&Global Var';
                owner: self;
                appendItem: '&Select...' selector: #addAGlobal acceleratorString: '';
                appendItem: '&Inspect Selected' selector: #inspectSelectedGlobal acceleratorString: '';
                appendSeparator;
                appendItem: '&Remove Selected' selector: #removeSelectedGlobal acceleratorString: ''
        );
        addMenu: (
            Menu new
                title: '&Objects';
                owner: self;
                appendItem: '&Select...' selector: #addAnObject acceleratorString: '';
                appendItem: '&Inspect selected' selector: #inspectSelectedObject acceleratorString: '';
                appendSeparator;
                appendItem: '&Remove selected' selector: #removeSelectedObject acceleratorString: ''
        ).! 
dumpRef
    "Private - True if the receiver must Dum DLL References to a file"
    ^(self paneAt: #dumpRefToggle:) selection!   
dumpRefFileName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    aPane contents size = 0
    ifTrue: [ aPane contents: 'XLang.RC' ].

    self enable: aPane when: self dumpRef.!   
dumpRefToggle: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Dump Refs Into:').
     (Generated by WindowBuilder)"

    aPane selection: true.!   
dumpRefToggled: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Dump Refs Into:').
     (Generated by WindowBuilder)"

    self
        changed: #dumpRefFileName:;
        yourself.!
editClass: aPane

    "Callback for the #doubleClickSelect event in an unnamed MultipleSelectListBox.
     (Generated by WindowBuilder)"

    | cls |
    cls := aPane selectedItem.
    cls notNil ifTrue: [ cls edit ].! 
editDelete

    strings := #().
    self fullUpdate.!  
editSearch

    ^self scanNow: nil! 
editSelect

    ^self openScanView: nil!
editStringEntry: aPane

    "Callback for the #doubleClickSelect event in an unnamed CPColumnarListBox.
     (Generated by WindowBuilder)"

    Notifier consumeInputUntil: [:event| event selector = #button1Up: ].
    aPane popupMenu popUp! 
fileExit
    "Close the receiver"
    ^self close!  
fileOpen
    "Open the Resorce Dump file"
    | dialog file |
    dialog := FileDialog new.
    dialog
        title: 'Open Resource File...';
        addFilter: '*.rc' description: 'Resource Files (*.RC)';
        addSmalltalkFileFilters;
        addFilter: '*.txt' description: 'Text Files (*.TXT)';
        addFilter: '*.*' description: 'All Files (*.*)';
        fileSpec: self refFileName;defFilter: '*.rc';
        hideReadonly;
        open.

    file := dialog file.
    file isNil ifTrue: [^self].
    file := File pathNameReadOnly: file.
    TextWindow new
            sendInputEvent: #openOnFile: with: file.
    file close!
fileRun
    "Lets the user run a program"

    (Smalltalk at: #RunProgramDialog ifAbsent: [^nil]) new open.!   
fileSave
    "Writes the Ref. info and builds the DLL"

    strings size = 0
    ifTrue: [ ^MessageBox warning: 'There must be at last one string scanned.' ].
    self writeRef.
    self buildDLL ifFalse: [^self].
    self writeDLL.!  
getSourceClasses: sorted
        "Private - Answer an OrderedCollection of all
         classes in hierarchical order or sorted by name."
    | theClasses |
    sorted
    ifTrue: [ theClasses := SortedCollection sortBlock: Class sortBlock ]
    ifFalse: [ theClasses := OrderedCollection new: 100 ].
    Smalltalk rootClasses do:[ :rootClass|
        rootClass name trimBlanks isEmpty
            ifFalse:[ theClasses add: rootClass].
        rootClass allSubclasses do: [ :c |
            c name trimBlanks isEmpty
                ifFalse: [theClasses add: c]]].
    ^theClasses asArray!
helpContents

    "Display simple help contents."
    ^MessageBox message: self class helpContents!
ignoreSelectedString

    "Callback for the menu item titled 'Remove from List'.
     (Generated by WindowBuilder)"

    | item |
    item := (self paneAt: #stringsTable:) selectedItem.
    item isNil ifTrue: [^nil].

    strings
        remove: item last
        ifAbsent: [^self error: 'Item has dissapear'].

    self changed: #stringsTable:!
initialize
    "Private - Initialize the receiver"

    super initialize.
    classes := SortedCollection sortBlock: Class sortBlock.
    pools := Dictionary new.
    globals := Dictionary new.
    objects := OrderedCollection new.
    strings := #().
    EmptyCode isNil ifTrue: [ self class initialize ].!  
initializeStrings
    "Private - Initialize the strings collection to hold some strings"

    strings := OrderedCollection new: 1000.! 
inspectSelectedGlobal

    "Callback for the menu item titled 'Inspect Selected'.
     (Generated by WindowBuilder)"

    | key |
    key := (self paneAt: #listOfGlobals:) selectedItem.
    key isNil ifTrue: [^self].

    self notImplementedYet.!   
inspectSelectedObject

    "Callback for the menu item titled 'Inspect selected'.
     (Generated by WindowBuilder)"

    | key |
    key := (self paneAt: #listOfObjects:) selectedItem.
    key isNil ifTrue: [^self].

    self notImplementedYet.!   
inspectSelectedPool

    "Callback for the menu item titled 'Inspect selected'.
     (Generated by WindowBuilder)"

    | key |
    key := (self paneAt: #listOfPools:) selectedItem.
    key isNil ifTrue: [^self].

    self notImplementedYet.!   
isString: anObject
    "Private - True if anObject can be considered as a String"

    ^anObject isObjectFromResource not
        and: [ anObject isMemberOf: String]!
listOfClasses: aPane

    "Callback for the #getContents event in an unnamed MultipleSelectListBox.
     (Generated by WindowBuilder)"

    | allSelected |
    allSelected := self allClassesHasBeenSelected.
    aPane contents: (
        allSelected
        ifTrue: [ #() ]
        ifFalse: [ classes ]).

    self enable: aPane when: allSelected not!
listOfGlobals: aPane

    "Callback for the #getContents event in an unnamed ListBox.
     (Generated by WindowBuilder)"

    aPane contents: globals keys asSortedCollection.!  
listOfObjects: aPane

    "Callback for the #getContents event in an unnamed ListBox.
     (Generated by WindowBuilder)"

    aPane contents: objects asArray!   
listOfPools: aPane

    "Callback for the #getContents event in an unnamed ListBox.
     (Generated by WindowBuilder)"

    aPane contents: pools keys asSortedCollection.!  
message: aString
    "Private - Display aString in the contents of the status box"
    (self statusPane statusBoxAt: #contents) contents: aString!  
openScanView: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Select from...').
     (Generated by WindowBuilder)"

    | view |
    view := self viewNamed: 'selectionView'.
    view isNil ifTrue: [^self].
    view isHandleOk ifFalse: [ ^view openWindow ].

    view bringToTop.!  
paletteHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := self statusPaneHelp: selector asString.
    text isNil ifTrue: [ text := String new ].
    self message: text! 
refFileName
    "Private - returns the path name for the ref. file"
    | fileName |
    fileName := (self paneAt: #dumpRefFileName:) contents.
    fileName size = 0 ifTrue: [^'Xlang.RC' ].
    ^fileName! 
removeAllClasses

    "Callback for the menu item titled 'Remove All'.
     (Generated by WindowBuilder)"

    classes removeAll: classes asArray.
    self changed: #listOfClasses:!   
removeDupicates

    "Callback for the menu item titled 'Remove Duplicates'.
     (Generated by WindowBuilder)"

    | unique all label element |
    self message: 'Searching for unique strings...'.
    unique := strings asSet.
    unique size = strings size
    ifTrue: [
        UserLibrary messageBeep: 0.
        ^MessageBox warning: 'There are no duplicated strings.'
    ].
    self message: ' ',(strings size - unique size) asString,' string(s) was duplicated...'.
    label := 'Eliminating references; Please wait, it can take a long time... '.
    self message: label.
    unique := unique asArray.
    all := strings asArray.
    self initializeStrings.
    CursorManager execute changeFor: [
        1 to: all size do: [:i|
            element := all at: i.
            unique
                detect: [:one| one == element ]
                ifNone: [ element become: (unique detect: [:each| each = element ]) ].
            self message: label,'[',(i * 100 // all size) asString,'%]'
        ].
        strings addAll: unique
    ].
    self message: 'Updating list...'.
    self changed: #stringsTable: with: #restoreSelected.
    self message: 'Duplicated strings eliminated...'.!  
removeSelectedClasses

    "Callback for the menu item titled 'Remove Selected'.
     (Generated by WindowBuilder)"

    | pane |
    pane := self paneAt: #listOfClasses:.
    classes removeAll: pane selectedItems.
    self changed: #listOfClasses:! 
removeSelectedGlobal

    "Callback for the menu item titled 'Remove Selected'.
     (Generated by WindowBuilder)"

    | pane |
    pane := self paneAt: #listOfGlobals:.
    globals removeKey: pane selectedItem ifAbsent: [].
    self changed: #listOfGlobals:!  
removeSelectedObject

    "Callback for the menu item titled 'Remove selected'.
     (Generated by WindowBuilder)"

    | pane |
    pane := self paneAt: #listOfObjects:.
    objects remove: pane selectedItem ifAbsent: [].
    self changed: #listOfObjects:! 
removeSelectedPool

    "Callback for the menu item titled 'Remove selected'.
     (Generated by WindowBuilder)"

    | pane |
    pane := self paneAt: #listOfPools:.
    pools removeKey: pane selectedItem ifAbsent: [].
    self changed: #listOfPools:!  
resourceCompilerName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    aPane contents size = 0
    ifTrue: [ aPane contents: 'RC ' ].

    self enable: aPane when: self buildDLL.!  
scanButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Scan Now!!').
     (Generated by WindowBuilder)"

    (Message new
        receiver: aPane
        selector: #visible:
        arguments: (Array with: strings size = 0)) performDeferred.!
scanClasses
    "Private - Scan receiver's classes for strings"

    | selected collect start literal |
    selected := self allClassesHasBeenSelected
        ifTrue: [
            selected := OrderedCollection new: 100.
            Smalltalk rootClasses do: [:root| selected addAll: root withAllSubclasses ].
            selected
        ]
        ifFalse: [ classes ].

    collect := [:methods|
        methods do: [:mth|
            start := mth primitiveNumber = 0 ifTrue: [1] ifFalse: [2]. "skip first literal for api calls"
            start to: mth size do: [:i|
                literal := mth at: i.
                (self isString: literal)
                ifTrue: [ self addString: literal ]
            ].
        ].
    ].

    selected do: [:class|
        self message: 'Scanning class: ', class name.
        collect
            value: class compiledMethods values asSet;
            value: class class compiledMethods values asSet;
            yourself
    ]!  
scanGlobals
    "Private - Scan receiver's globals for strings"

    self message: 'Scanning Pool Globals...'.
    globals values do: [:each| self addString: each ].!
scanNow: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Scan Now!!').
     (Generated by WindowBuilder)"

    CursorManager execute changeFor: [
        self
            initializeStrings;
            scanClasses;
            scanPools;
            scanGlobals;
            scanObjects;
            yourself.
    ].

    self message: 'Scanning Done.'.

    self
        changed: #scanButton:;
        changed: #scanViewButton:;
        changed: #stringsTable:;
        yourself!  
scanObjects
    "Private - Scan receiver's objects for strings"

    self message: 'Scanning Pool Objects...'.
    objects do: [:each| self addString: each ].!   
scanPools
    "Private - Scan receiver's pools for strings"

    self message: 'Scanning Pool Dictionaries...'.
    pools values do: [:aDict|
        aDict values do: [:each| self addString: each ].
    ].!  
scanViewButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Select from...').
     (Generated by WindowBuilder)"

    "los botones deben aparecer sincronizados..."
    self scanButton: aPane.! 
selectAllClasses

    "Callback for the menu item titled 'All Classes'.
     (Generated by WindowBuilder)"

    | pane |
    pane := self paneAt: #allClassesToggle:.
    pane selection: pane selection not.
    self changed: #listOfClasses:.! 
selectFromProject

    "Callback for the menu item titled 'From Project...'.
     (Generated by WindowBuilder)"

    | project class changed |
    project := OSPrompter
        prompt: 'Nombre del projecto a agregar ?'
        default: String new.
    project isNil ifTrue: [^nil].
    (project := project trimBlanks) isEmpty ifTrue: [^self].
    project := Smalltalk at: project asSymbol
        ifAbsent: [^MessageBox waqrning: 'Project ',project,' not found.' ].
    changed := false.
    project dependentClasses do: [:cls|
        cls isBehavior
        ifTrue: [
            class := cls isClass ifTrue: [cls] ifFalse: [cls instanceClass].
            (classes includes: class)
            ifFalse: [ classes add: class ]
        ]
    ].
    changed ifTrue: [
        self changed: #listOfClasses:
    ].!  
showError: anInteger
    "Private - An error loading program has occurred.
     Notify the user about this"
    | errors label |
    errors := #(
        (0  'Memoria insuficiente')
        (2  'Archivo no encontrado')
        (3  'Archivo no encontrado')
        (5  'Atentado de linkeo dinamico a un programa')
        (6  'La libreria requiere distintos segmentos para ejecutarse')
        (10 'Versin incorrecta de sistema operativo')
        (11 'Archivo ejecutable de formato invlido.')
        (12 'Aplicacin de Sistema Operativo OS/2')
        (13 'Aplicacin de Sistema Operativo DOS 4.0')
        (14 'Tipo de ejecutable desconocido')
        (15 'Atentado de ejecucin de un programa no preparado para modo protejido.')
        (16 'Attempt to load a second instance of an .Exe
 containing multiple, writable data segments.')
        (17 'Attempt in large-frame EMS mode to load a
 second instance of an application that links to
 certain nonshareale DLLs already in use')
        (18 'Aplicacin no preparada para correr en modo protejido')
    ).

    errors do: [:each|
        each first = anInteger
        ifTrue: [label := each last]
    ].
    label isNil ifTrue: [label := 'UnKnown Exec error : ', anInteger printString].

    UserLibrary messageBeep: 0.
    MessageBox warning: 'Error de ejecucion (DOS Shell)\' withCrs,label! 
startID
    "Private - Returns the start ID "
    ^(self paneAt: #startID:) contents asInteger max: 1!  
startID: aPane

    "Callback for the #getContents event in an unnamed EntryField (contents is '1').
     (Generated by WindowBuilder)"

    aPane contents size = 0
    ifTrue: [ aPane contents: '1' ].

    self enable: aPane when: self dumpRef.!
statusPaneHelp:aKey
    "Private - Answer the hint text to the StatusPane"

    | dict |
        #(
            (editSelect 'Activates the class selection view.')
            (editDelete 'Remove current scanned strings.')
            (editSearch 'Scan for strings in current selection.')
            (fileSave 'Genates the DLL.')
            (fileOpen 'Open a resource file...')
            (fileRun 'Run an application...')
            (helpContents 'Display a simple help note.')
            (fileExit 'Close this window.')
        ) do: [:pair | pair first asString = aKey asString ifTrue: [^pair last]].
    dict := Smalltalk at: #HelpStatusPane ifAbsent: [Dictionary new].
    ^dict at: aKey
    ifAbsent:[
        (dict includesKey: aKey asSymbol) ifTrue: [^dict at: aKey asSymbol].
        ^super statusPaneHelp:aKey
    ]! 
stringsTable: aPane

    "Callback for the #getContents event in an unnamed CPColumnarListBox.
     (Generated by WindowBuilder)"

    | cole sorted |
    (Message new
        receiver: aPane
        selector: #visible:
        arguments: (Array with: strings size > 0)) performDeferred.

    sorted := strings isNil
        ifTrue:[#()]
        ifFalse: [strings asSortedCollection].
    cole := Array new: sorted size.
    1 to: strings size do: [:i| cole at: i put: (Array with: i with: (sorted at: i)) ].
    aPane contents: cole.!   
updateLists

    "Callback for the menu item titled 'Update Lists'.
     (Generated by WindowBuilder)"

    self
        changed: #listOfClasses:;
        changed: #listOfPools:;
        changed: #listOfGlobals:;
        changed: #listOfObjects:;
        changed: #stringsTable:;
        yourself!  
writeDLL
    "Build the DLL..."
    | result dll toClone command label file id chunks originalSize |
    dll := (self paneAt: #buildDLLFileName: ) contents trimBlanks.
    dll isEmpty ifTrue: [
        UserLibrary messageBeep: 0.
        MessageBox warning: 'Enter the DLL file name. Please...'.
        ^nil
    ].
    (File exists: dll)
    ifTrue: [
        file := File pathName: dll.
        originalSize := file size.
        file close.
    ]
    ifFalse: [ "Creates the DLL if not exists yet..."
        self message: 'Creating file ',dll,'...'.
        (File pathName: dll)
            nextPutAll: EmptyCode;
            close.
        originalSize := EmptyCode size.
    ].
    command :=
            (self paneAt: #resourceCompilerName: ) contents
            ,' ',self refFileName ,' ',dll.
    self message: 'Compiling... [',command,']'.
    result := KernelLibrary
        winExec: command asParameter
        cmdShow: SwShownormal.

    result < 32 "An Error has occurred"
    ifTrue: [
        self showError: result.
        ^nil
    ].

    MessageBox message: 'Close this window when resource compiler has finished'.

    file := File pathName: dll.
    result := file size.
    file close.
    result = originalSize ifTrue: [
        (MessageBox confirm:
            ' The library has a wrong size,\'withCrs,
            ' please verify the compiler execution window\'withCrs,
            ' to see a provable error.\\' withCrs,
            ' Do you want to continue ?')
        ifFalse: [^nil].
    ].

    self dumpRef ifFalse: [
        File remove: self refFileName ifAbsent: []
    ].

    (MessageBox confirm: 'Generate proxy references to ',dll,' ?')
    ifTrue: [
        toClone := strings asArray.
        strings := nil. "mark as unused for no more reference (e.g. when updating windows...)"
        self fullUpdate.
        label := 'Transforming strings to proxies...'.
        self message: label.
        id := self startID.
        1 to: toClone size do: [:i|
            "
                Empty string can't be loaded from module.
                (is this a bug of String>>#fromModule:id: ?)
            "
            (toClone at: i) size > 0
            ifTrue: [
                chunks := self chunksFor: (toClone at: i).
                chunks size = 1
                ifFalse: [ id := id to: id + chunks size - 1 ].
                (toClone at: i) become: (
                    ProxyObjectFromModule
                        ofClass: #String
                        fromModule: dll
                        id: id).
                id isCollection ifTrue: [ id := id last ].
                id := id + 1.
            ].
            self message: label,'[',(i * 100 // toClone size) asString,'%]'.
        ]
    ].!
writeRef
    "Writes the Reference file"

    | stream label element id chunks |
    self dumpRef | self buildDLL ifFalse: [^self].
    CursorManager execute changeFor: [
        stream := File newFile: self refFileName.
        label := 'Writing ',stream file pathName,'...'.
        self message: label.
        stream
            cr;nextPutAll: 'STRINGTABLE';
            cr;nextPutAll: 'BEGIN';
            yourself.
        id := self startID.
        1 to: strings size do: [:i|
            chunks := self chunksFor: (strings at: i).
            chunks do: [:chunk|
                stream
                    cr;"nextPut: Tab;"space;
                    nextPutAll: id asString;
                    nextPut: $,;space;
                    nextPut: $".
                chunk do: [:c|
                    stream nextPutAll: (self writeRefStringFor: c)
                ].
                stream nextPut: $".
                id := id + 1.
            ].
            self message: label,' [',(i * 100 // strings size) asString,'%]'
        ].
        stream
            cr;nextPutAll: 'END';
            close;
            yourself.
    ].!
writeRefStringFor: aCharacter
    "Private - returns a string for writing aCharacter to the Ref file"

    (#($" $\) includes: aCharacter)
    ifTrue: [ ^String with: aCharacter with: aCharacter ].

    aCharacter = Cr ifTrue: [ ^'\r'].
    aCharacter = Lf ifTrue: [ ^'\n'].
    aCharacter = Tab ifTrue: [ ^'\t'].

    ^String with: aCharacter! !

! TechnicalSheetView class methods !  
wbCreated

    ^true! !

! TechnicalSheetView methods !   
copywriteInfo: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '').
     (Generated by WindowBuilder)"

    aPane contents: StartUpApplication copywrite!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Ficha Tcnica';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 869 @ 520; xC; yC; cRDU: (2 @ 518 rightBottom: 866 @ 40));
            pStyle: #(sysmenu titlebar minimize);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 832 @ 112; lDU: 18 r: #left; tDU: 16 r: #top);
                    contents: '';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 832 @ 312; lDU: 18 r: #left; tDU: 144 r: #top);
                    in;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 37 r: #left; rDU: 192 r: #left; tDU: 32 r: #top; bDU: 64 r: #top);
                    startGroup;
                    contents: 'Producto:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 37 r: #left; rDU: 192 r: #left; tDU: 80 r: #top; bDU: 112 r: #top);
                    startGroup;
                    contents: 'Versin:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 782 @ 32; lDU: 43 r: #left; rDU: 825 r: #left; tDU: 162 r: #top; bDU: 194 r: #top);
                    startGroup;
                    contents: 'Toda consulta tecnica referida a este producto';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 782 @ 32; lDU: 43 r: #left; rDU: 825 r: #left; tDU: 208 r: #top; bDU: 240 r: #top);
                    startGroup;
                    contents: ' ser atendida por:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 782 @ 152; lDU: 46 r: #left; rDU: 827 r: #left; tDU: 264 r: #top; bDU: 416 r: #top);
                    centered;
                    startGroup;
                    when: #getContents perform: #copywriteInfo:;
                    contents: '';
                    font: (
                        Font new
                        fromBytes: #( 235 255 0 0 0 0 0 0 188 2 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 613 @ 32; lDU: 210 r: #left; rDU: 823 r: #left; tDU: 32 r: #top; bDU: 64 r: #top);
                    startGroup;
                    when: #getContents perform: #productName:;
                    contents: 'xx';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 613 @ 32; lDU: 210 r: #left; rDU: 823 r: #left; tDU: 80 r: #top; bDU: 112 r: #top);
                    startGroup;
                    when: #getContents perform: #productVersion:;
                    contents: 'xx';
                    yourself
            );
        yourself
    ).!   
productName: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'xx').
     (Generated by WindowBuilder)"

    aPane contents: StartUpApplication product!
productVersion: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'xx').
     (Generated by WindowBuilder)"

    aPane contents: StartUpApplication version! !

! TestWindow class methods !   
wbCreated

    ^true! !

! TestWindow methods !   
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Test Window';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 539 @ 512; xC; yC; cRDU: (7 @ 506 rightBottom: 533 @ 44));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
            backColor: ClrPalegray;
            addSubpane: (
                OSHierarchicalListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 526 @ 416; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 46 r: #top; bDU: 0 r: #bottom);
                    nameMethod: #printString;
                    childrenMethod: #subclasses;
                    iconMethod: [:aNode| CPBitmapDict at: 'computer' ];
                    indentWidth: 1;
                    ownerDrawFixed;
                    startGroup;
                    when: #getContents perform: #setTreePane:;
                    when: #select perform: #selectElement:;
                    when: #doubleClickSelect perform: #editElement:;
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
editElement: aPane

    "Callback for the #doubleClickSelect event in an unnamed CPHierarchicalListBox.
     (Generated by WindowBuilder)"

    aPane selectedItem edit.!
selectElement: aPane

    "Callback for the #select event in an unnamed CPHierarchicalListBox.
     (Generated by WindowBuilder)"! 
setTreePane: aPane

    "Callback for the #getContents event in an unnamed CPHierarchicalListBox.
     (Generated by WindowBuilder)"

    aPane contents: Object! !

! TiledImageBuilder class methods !   
wbCreated

    ^true! !

! TiledImageBuilder methods !
beginCellSelect: aPane

    "Callback for the #button1Down event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    CursorManager crossHair change.
    self selectingCell: aPane.!   
cellAt: aPoint
    "Private - Returns the cell at aPoint or nil..."

    grid associationsDo: [:asoc|
        (asoc value containsPoint: aPoint)
        ifTrue: [^asoc key]
    ].
    ^nil!  
cellNameAndTile
    "Private - Returns the fileName and tile for the current cell..."
    | array |
    image
        withZoom: zoom
        do: [
            array := Array
                with: (image fileNameTile: cell)
                with: (image tileNumber: cell)
        ].
    ^array!
checkCell
    "Private - Check for the existence of the tile..."

    | array title |
    cell notNil
    ifTrue: [
        array := self cellNameAndTile.
        title := array first.
        array first isNil
        ifTrue: [ title := 'Nombre de archivo invalido.' ].
        array last isValid
        ifFalse: [ title := title,' *No encontrado*' ].
        self position: array last origin.
        (self viewNamed: 'exampleView') label: title.
    ]!
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Tiled Image Builder';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 526 @ 460; lDU: 110 r: #left; tDU: 116 r: #top; cRDU: (2 @ 458 rightBottom: 523 @ 40));
            pStyle: #(sysmenu titlebar minimize);
            backColor: ClrPalegray;
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 521 @ 48; lDU: 0 r: #left; rDU: 521 r: #left; tDU: 0 r: #top; bDU: 48 r: #top);
                    add: #fileNew;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #editNew spaces: 3;
                    add: #edit;
                    add: #editUpdate;
                    add: #toolDebug;
                    add: #toolCalculate;
                    add: #fileExit spaces: 5;
                    postAutomatic;
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 32; lDU: 9 r: #left; rDU: 73 r: #left; tDU: 56 r: #top; bDU: 88 r: #top);
                    startGroup;
                    contents: 'Path'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 32; lDU: 18 r: #left; rDU: 64 r: #left; tDU: 104 r: #top; bDU: 136 r: #top);
                    startGroup;
                    contents: 'Ext'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSImagePane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 512 @ 220; lDU: 5 r: #left; rDU: 517 r: #left; tDU: 144 r: #top; bDU: 364 r: #top);
                    noScrollBars;
                    startGroup;
                    when: #getContents perform: #drawnGrid:;
                    when: #button1DoubleClick perform: #editCell:;
                    when: #button1Down perform: #beginCellSelect:;
                    when: #button1Move perform: #selectingCell:;
                    when: #display perform: #displayGrid:;
                    when: #setScrollRectangle perform: #setScrollRectangle:;
                    when: #button1Up perform: #endCellSelect:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrDarkblue;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 443 @ 44; lDU: 73 r: #left; rDU: 517 r: #left; tDU: 48 r: #top; bDU: 92 r: #top; indent: 3 @ 4);
                    startGroup;
                    when: #getContents perform: #pathName:;
                    when: #textChanged perform: #pathNameChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 69 @ 44; lDU: 73 r: #left; rDU: 142 r: #left; tDU: 96 r: #top; bDU: 140 r: #top; indent: 3 @ 4);
                    startGroup;
                    when: #getContents perform: #extension:;
                    when: #textChanged perform: #extensionChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 130 @ 44; lDU: 185 r: #left; tDU: 368 r: #top);
                    min: 1;
                    max: 100;
                    contents: 1;
                    startGroup;
                    when: #getContents perform: #xSize:;
                    when: #valueChanged perform: #xSizeChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 130 @ 44; lDU: 366 r: #left; tDU: 368 r: #top);
                    min: 1;
                    max: 100;
                    contents: 1;
                    startGroup;
                    when: #getContents perform: #ySize:;
                    when: #valueChanged perform: #ySizeChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 32; lDU: 27 r: #left; rDU: 174 r: #left; tDU: 376 r: #top; bDU: 408 r: #top);
                    startGroup;
                    contents: 'Size in Tiles:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 27 @ 32; lDU: 327 r: #left; rDU: 354 r: #left; tDU: 376 r: #top; bDU: 408 r: #top);
                    centered;
                    startGroup;
                    contents: 'x'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 32; lDU: 350 r: #left; rDU: 414 r: #left; tDU: 104 r: #top; bDU: 136 r: #top);
                    startGroup;
                    contents: 'Tile#'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 418 r: #left; rDU: 510 r: #left; tDU: 104 r: #top; bDU: 136 r: #top);
                    rightJustified;
                    startGroup;
                    when: #getContents perform: #tileNumber:;
                    contents: '######'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 73 @ 32; lDU: 151 r: #left; rDU: 224 r: #left; tDU: 102 r: #top; bDU: 134 r: #top);
                    startGroup;
                    contents: 'Zoom'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 123 @ 152; lDU: 222 r: #left; rDU: 345 r: #left; tDU: 96 r: #top; bDU: 248 r: #top);
                    dropDown;
                    startGroup;
                    when: #getContents perform: #zoomFactors:;
                    when: #textChanged perform: #zoomChanged:;
                    when: #select perform: #zoomSelected:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Image View';
            noSmalltalkMenuBar;
            viewName: 'exampleView';
            framingBlock: ( FramingParameters new iDUE: 800 @ 460; lDU: 642 r: #left; tDU: 118 r: #top; cRDU: (9 @ 452 rightBottom: 791 @ 46));
            pStyle: #(sizable titlebar minimize);
            backColor: ClrPalegray;
            addSubpane: (
                OSImagePane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 782 @ 368; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 0 r: #top; bDU: 38 r: #bottom);
                    paneName: 'example';
                    startGroup;
                    when: #button1Up perform: #selectTile:;
                    when: #button1DoubleClick perform: #editTile:;
                    when: #display perform: #displayImage:;
                    when: #setScrollRectangle perform: #setScrollRectangle:;
                    when: #mouseMove perform: #displayMouseLocation:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 711 @ 28; lDU: 55 r: #left; rDU: 766 r: #left; tDU: 30 r: #bottom; bDU: 2 r: #bottom);
                    startGroup;
                    when: #getContents perform: #mouseLocation:;
                    contents: '...................'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 32; lDU: 2 r: #left; tDU: 38 r: #bottom);
                    contents: (CPBitmapDict at: 'position');
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
displayGrid: aPane

    "Callback for the #display event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen |
    pen := aPane pen.
    pen isNil ifTrue: [^nil].
    pen drawChain.

    cell notNil
    ifTrue: [
        pen reverse:
            (grid at: cell ifAbsent: [0@0 extent: 0@0])
    ].!
displayImage: aPane

    "Callback for the #display event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | rectangle boundingBox |
    aPane isNil ifTrue: [ ^self ].

    boundingBox := image boundingBox.
    (boundingBox width > 0 and: [boundingBox height > 0])
    ifFalse: [^self].

    rectangle := aPane rectangleToDisplay.
    cell isNil "erase when no cell selected..."
    ifTrue: [
        aPane pen fill: rectangle color: aPane backColor.
        ^self
    ].

    CursorManager execute changeFor: [
        rectangle notNil ifTrue: [
            (rectangle nonIntersections: boundingBox)
            do: [:nonOverlaped| aPane pen fill: nonOverlaped color: aPane backColor ].
            image displayRectangle: (rectangle intersect: boundingBox) with: aPane pen.
        ]
    ].!
displayMouseLocation: aPane

    "Callback for the #mouseMove event in the OSImagePane named 'example'.
     (Generated by WindowBuilder)"

    aPane notNil
    ifTrue: [
        mouse := aPane mouseLocation.
        self changed: #mouseLocation:
    ]!
drawnGrid: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen box sizeInTiles |
    aPane isNil ifTrue: [^nil].
    aPane erase.
    pen := aPane pen.
    pen isNil ifTrue: [^nil].
    box := 0@0 extent: aPane rectangle extent.
    image
        withZoom: zoom
        do: [ sizeInTiles := image sizeInTiles ].
    sizeInTiles isNil ifTrue: [^self].

    self initializeGridOf: sizeInTiles in: box.

    pen foreColor: ClrYellow.
    grid values do: [:each|
        pen
            place: each leftTop;
            box: each rightBottom
    ].
    pen foreColor: ClrBlack.! 
edit
    "Edit the receiver's selected cell"

    | tile answer |
    Compiler notNil ifTrue: [
        answer := OSPrompter prompt: 'Celda a editar ?' default: cell asString.
        answer isNil ifTrue: [^self beep].
        cell := Compiler evaluate: answer.
        self checkCell.
    ].
    self edit: cell!   
edit: cellNumber
    "Edit cell cellNumber"

    | tile |
    cell := cellNumber.
    cell isNil ifTrue: [^self beep].
    tile := image tileNumber: cell.
    (tile respondsTo: #edit)
    ifTrue: [ tile edit ]
    ifFalse: [ tile inspect ]! 
editCell: aPane

    "Callback for the #button1DoubleClick event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self edit: cell.!  
editNew
    "Create a new tile for the selected cell"

    | array tile |
    cell isNil ifTrue: [^self beep].
    array := self cellNameAndTile.

    array last isValid
    ifFalse: [
        (MessageBox confirm: 'Seguro desea reemplazar el tile existente por uno nuevo?')
        ifFalse: [^self].
    ].

    array first isNil
    ifTrue: [ ^MessageBox warning: 'Complete el pathName antes de agregar algun tile...' ].

    CursorManager execute
    changeFor: [
        tile := Tile imageClass fromUser.
        tile isNil
        ifTrue: [ File remove: array first ifAbsent: [self beep] ]
        ifFalse: [ tile saveAs: array first ].
    ].

    self fullUpdate.!
editTile: aPane

    "Callback for the #button1DoubleClick event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self edit: cell.!  
editUpdate
    "Update the receiver..."

    cell := nil.
    self fullUpdate!
endCellSelect: aPane

    "Callback for the #button1Up event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    CursorManager normal change.
    self selectingCell: aPane.
    self checkCell.
    aPane setFocus.!
extension: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    image
        withZoom: zoom
        do: [ aPane contents: image fileExtension ].!
extensionChanged: aPane

    "Callback for the #textChanged event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    image
        withZoom: zoom
        do: [ image fileExtension: aPane contents trimBlanks ].
    self fullUpdate.!
fileNew
    "Creates a new image..."

    self initializeImage
    ifTrue: [ self fullUpdate ].!  
fileOpen
    "Read contents from a new ini file..."

    | dialog file |

    dialog := FileDialog new.
    dialog
      title: 'Archivo de donde leer la configuracion...';
      addFilter: '*.ini' description: 'Standard Ini Files (*.INI)';
      addFilter: '*.*' description: 'All Files (*.*)';
      defFilter: '*.ini';fileSpec: '*.ini';
      hideReadonly;open.
    file := dialog file.
    file isNil ifTrue: [^self].

    self initializeImage
    ifTrue: [
        image
            loadFrom: file;
            zoom: zoom.
        self fullUpdate
    ].!  
fileSave

    image save.!  
fullUpdate
    "Update the receiver..."

    CursorManager execute
    changeFor: [
        "Tile clearCache."
        cell := nil.
        super fullUpdate.
        self
            mapPane invalidateRect: nil;
            yourself
    ].!   
initialize
    "Private - Initializes the receiver"

    super initialize.

    zoom := 1.
    grid := Dictionary new.

    self initializeImage.!
initializeGridOf: points in: aBox
    "Private - Build grid of points vells inside aBox..."

    | box extent count |
    grid := Dictionary new.
    (points x = 0 or: [points y = 0]) ifTrue: [^self].
    extent := aBox extent // points.
    (extent x > 1 and: [extent y > 1]) ifFalse: [^self].
    count := 1.
    0 to: points y - 1 do: [:y|
        box := 0@y * extent y extent: extent.
        points x timesRepeat: [
            grid at: count put: (box insetBy: 1).
            count := count + 1.
            box moveBy: extent x @ 0
        ]
    ].
    ^grid!  
initializeImage
    "Private - Creates a new image..."

    image notNil
    ifTrue: [
        (MessageBox confirm:
            'Los cambios posiblemente realizados sobre la imagen actual se perderan.',
            '\Seguro desea continuar ?' withCrs) ifFalse: [^false].
    ].

    image := TiledImage new.
    ^true! 
mapPane
    "Private - Returns the view for the image..."

    ^self paneNamed: 'example'! 
markCellWith: aPen
    "Private - Mark the current cell"

    cell notNil
    ifTrue: [
        aPen reverse:
            (grid at: cell ifAbsent: [0@0 extent: 0@0])
    ].!  
mouseLocation: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '...................').
     (Generated by WindowBuilder)"

    aPane contents: (mouse isNil ifFalse: [mouse asString])!
openOn: aTiledImage
    "Open the receiver for working on aTiledImage"

    image :=
        aTiledImage isString
        ifTrue: [ TiledImage fromFile: aTiledImage ]
        ifFalse: [ aTiledImage ].

    self open.! 
pathName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    image
        withZoom: zoom
        do: [
            aPane contents: image fileName
        ].!
pathNameChanged: aPane

    "Callback for the #textChanged event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    image
        withZoom: zoom
        do: [ image fileName: aPane contents trimBlanks ].
    self fullUpdate.!  
position: aPoint
    "Private - Position the receiver's mapPane at aPoint"

    | corner |
    (aPoint x < 0 or: [aPoint y < 0])
    ifTrue: [ ^self position: (aPoint x max: 0) @ (aPoint y max: 0) ].
    image
        withZoom: zoom
        do: [ corner := image extent - self mapPane frameRectangle extent ].
    (corner x > 0 and: [corner y > 0])
    ifTrue: [
        (aPoint x > corner x or: [aPoint y > corner y])
        ifTrue: [^self position: (corner x min: aPoint x) @ (aPoint y min: corner y) ].
    ].

    mouse := aPoint truncated - 50.
    self mapPane
        scrollTopCornerTo: mouse;
        setScrollRanges;
        updateSliders;
        changed: #mouseLocation:;
        yourself.!   
preInitWindow
    | extent |

    (self viewNamed: 'exampleView')
        framingBlock: [:box|
            (image respondsTo: #tileExtent)
            ifTrue: [
                extent := image tileExtent + 100 min: box extent - 5.
                box corner - 5 - extent extent: extent
             ]
            ifFalse: [ box origin + (200@5) corner: box corner  - 5 ]
        ]!  
selectingCell: aPane

    "Callback for the #button1Move event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | point newCell pen |
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    point := aPane mouseLocation.
    newCell := self cellAt: point.
    (newCell isNil or: [cell = newCell])
    ifTrue: [^self].
    self markCellWith: pen.
    cell := newCell.
    self changed: #tileNumber:.
    self markCellWith: pen.!
selectTile: aPane

    "Callback for the #button1Up event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    aPane redraw.!
setScrollRectangle: aPane

    "Callback for the #setScrollRectangle event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    aPane scrollingRectangle: (0@0 extent:
        (image isNil ifTrue: [100@100] ifFalse: [ image extent]))! 
tileNumber: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '######').
     (Generated by WindowBuilder)"

    cell isNil
    ifTrue: [ aPane contents: String new]
    ifFalse: [ aPane contents: cell asString ]!  
toolCalculate
    "Rebuild the image parameters..."

    image computeTileExtent.
    self fullUpdate.!   
updateViews
    "Private - Update graphic views..."

    self
        changed: #drawnGrid:;
        markCellWith: (self paneAt: #drawnGrid:) pen;
        yourself.

    self mapPane invalidateRect: nil.!   
xSize: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    image
        withZoom: zoom
        do: [ aPane contents: image sizeInTiles x ]!
xSizeChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    image
        withZoom: zoom
        do: [ image sizeInTiles x: aPane contents ].
    self updateViews.!
ySize: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    image
        withZoom: zoom
        do: [ aPane contents: image sizeInTiles y ]!
ySizeChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    image
        withZoom: zoom
        do: [ image sizeInTiles y: aPane contents ].
    self updateViews.!
zoomChanged: aPane

    "Callback for the #textChanged event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    | number |
    number := Compiler evaluate: aPane text.
    number isNumber
    ifFalse: [ number := 1 ].
    (image canZoom: number)
    ifFalse: [
        (MessageBox message: 'Crea un nuevo zoom ',number asString,' ?')
        ifTrue: [ image newZoom: number ]
        ifFalse: [^self beep].
    ].
    zoom := number.
    self fullUpdate.!
zoomFactors: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    aPane
        contents: image zooms;
        selection: 1.!   
zoomSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | newZoom |
    newZoom := aPane selectedItem.
    zoom = newZoom ifTrue: [^self].
    zoom := newZoom.
    self fullUpdate.! !

! TileLayerEditor class methods !
wbCreated

    ^true! !

! TileLayerEditor methods !  
categories: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | names |
    names := layer categoryNames asSortedCollection.
    aPane contents: names.
    self enable: aPane when: names size > 0.!   
categorySelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    self
        getCategoryInformation;
        yourself.

    category := layer categoryNamed: aPane selectedItem.
    zoom := nil.

    self
        updateCategory;
        updateZoom;
        yourself.!
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Editor de Capa Opaca';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 658 @ 480; xC; yC; cRDU: (2 @ 478 rightBottom: 656 @ 40));
            pStyle: #(sysmenu titlebar minimize);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 32; lDU: 43 r: #left; rDU: 144 r: #left; tDU: 20 r: #top; bDU: 52 r: #top);
                    startGroup;
                    contents: 'Nombre'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 7 r: #left; rDU: 144 r: #left; tDU: 66 r: #top; bDU: 98 r: #top);
                    startGroup;
                    contents: 'Categorias:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 11 r: #left; rDU: 103 r: #left; tDU: 174 r: #top; bDU: 206 r: #top);
                    startGroup;
                    contents: 'Zooms:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 32; lDU: 9 r: #left; rDU: 73 r: #left; tDU: 274 r: #top; bDU: 306 r: #top);
                    startGroup;
                    contents: 'Path:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 55 @ 32; lDU: 480 r: #left; rDU: 535 r: #left; tDU: 270 r: #top; bDU: 302 r: #top);
                    startGroup;
                    contents: 'Ext:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 25 r: #left; rDU: 217 r: #left; tDU: 334 r: #top; bDU: 366 r: #top);
                    startGroup;
                    contents: 'Number of Tiles:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 25 r: #left; rDU: 217 r: #left; tDU: 390 r: #top; bDU: 422 r: #top);
                    startGroup;
                    contents: 'Size of each tile:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 27 @ 32; lDU: 375 r: #left; rDU: 402 r: #left; tDU: 332 r: #top; bDU: 364 r: #top);
                    centered;
                    startGroup;
                    contents: 'x'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 27 @ 32; lDU: 375 r: #left; rDU: 402 r: #left; tDU: 396 r: #top; bDU: 428 r: #top);
                    centered;
                    startGroup;
                    contents: 'x'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 375 @ 32; lDU: 153 r: #left; rDU: 528 r: #left; tDU: 16 r: #top; bDU: 48 r: #top);
                    startGroup;
                    when: #getContents perform: #fillName:;
                    contents: 'Name...';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 318 @ 208; lDU: 155 r: #left; rDU: 473 r: #left; tDU: 216 r: #top; bDU: 424 r: #top);
                    dropDownList;
                    startGroup;
                    when: #getContents perform: #imageClasses:;
                    when: #select perform: #imageClassSelected:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 32; lDU: 9 r: #left; rDU: 155 r: #left; tDU: 224 r: #top; bDU: 256 r: #top);
                    startGroup;
                    contents: 'ImageClass:'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 48; lDU: 475 r: #left; rDU: 539 r: #left; tDU: 216 r: #top; bDU: 264 r: #top);
                    add: #toolDebug;
                    postAutomatic;
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 375 @ 366; lDU: 153 r: #left; rDU: 528 r: #left; tDU: 58 r: #top; bDU: 424 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #categories:;
                    when: #select perform: #categorySelected:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 155 r: #left; tDU: 108 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #defaultCategory:;
                    when: #clicked perform: #defaultCategoryChanged:;
                    contents: 'Default'; font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 48; lDU: 530 r: #left; rDU: 649 r: #left; tDU: 8 r: #top; bDU: 56 r: #top);
                    add: #fileOpen;
                    add: #fileSave;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 48; lDU: 530 r: #left; rDU: 649 r: #left; tDU: 56 r: #top; bDU: 104 r: #top);
                    add: #editNew selector: #newCategory;
                    add: #editDelete selector: #removeCategory;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 318 @ 208; lDU: 155 r: #left; rDU: 473 r: #left; tDU: 168 r: #top; bDU: 376 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #zooms:;
                    when: #select perform: #zoomSelected:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 48; lDU: 475 r: #left; rDU: 649 r: #left; tDU: 168 r: #top; bDU: 216 r: #top);
                    add: #editNew selector: #newZoom;
                    add: #fileSaveAs selector: #saveZoomInformation;
                    add: #editDelete selector: #removeZoom;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 389 @ 44; lDU: 80 r: #left; rDU: 469 r: #left; tDU: 264 r: #top; bDU: 308 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #fileName:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 44; lDU: 533 r: #left; rDU: 642 r: #left; tDU: 264 r: #top; bDU: 308 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #extension:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 48; lDU: 226 r: #left; tDU: 318 r: #top);
                    min: 1;
                    max: 1000;
                    contents: 1;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #widthInTiles:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 48; lDU: 407 r: #left; tDU: 318 r: #top);
                    min: 1;
                    max: 1000;
                    contents: 1;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #heightInTiles:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 48; lDU: 226 r: #left; tDU: 382 r: #top);
                    min: 1;
                    max: 10000;
                    contents: 1;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #tileWidth:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 48; lDU: 407 r: #left; tDU: 382 r: #top);
                    min: 1;
                    max: 10000;
                    contents: 1;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #tileHeight:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 48; lDU: 558 r: #left; rDU: 622 r: #left; tDU: 382 r: #top; bDU: 430 r: #top);
                    add: #toolMeasure;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
defaultCategory: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Default').
     (Generated by WindowBuilder)"

    category notNil
    ifTrue: [
        aPane selection: (layer defaultCategories includes: category)
    ] ifFalse: [ aPane selection: false ].
    self enable: aPane when: category notNil.!   
defaultCategoryChanged: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Default').
     (Generated by WindowBuilder)"

    category notNil
    ifTrue: [
        aPane selection
        ifTrue: [ layer addDefaultCategory: category ]
        ifFalse: [ layer removeDefaultCategory: category ]
    ].! 
extension: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    category isNil
    ifTrue: [ self disable: aPane.^self ].

    category
        withZoom: zoom
        do: [ aPane contents: category fileExtension ].

    self enable: aPane when: zoom notNil.!   
fileName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    category isNil
    ifTrue: [ self disable: aPane.^self ].

    category
        withZoom: zoom
        do: [ aPane contents: category fileName ].

    self enable: aPane when: zoom notNil.! 
fileOpen
    "Read layer's contents from a new ini file..."

    | dialog file |

    category isNil ifTrue: [
        self beep.
        MessageBox warning: 'Seleccione o cree una categoria.\Esta sera leida desde un archivo .INI' withCrs.
        ^nil
    ].

    dialog := FileDialog new.
    dialog
      title: 'Archivo de donde leer la configuracion...';
      addFilter: '*.ini' description: 'Standard Ini Files (*.INI)';
      addFilter: '*.*' description: 'All Files (*.*)';
      defFilter: '*.ini';fileSpec: '*.ini';
      hideReadonly;open.
    file := dialog file.
    file isNil ifTrue: [^self].

    (MessageBox confirm: 'La lectura de otro archivo de inicializacion destruira la informacion actual.',
        '\Seguro desea continuar ?' withCrs) ifFalse: [^self].

    category loadFrom: file.
    zoom := nil.
    self
        updateCategory;
        updateZoom.!   
fileSave

    category notNil ifTrue: [ category save ].!   
fillName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    aPane contents: layer name.! 
getCategoryInformation
    "Private - Gets the category information from the panes"

    category isNil ifTrue: [^self].

    "no information to get..."!
heightInTiles: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    category isNil
    ifTrue: [ self disable: aPane.^self ].

    category
        withZoom: zoom
        do: [ aPane contents: category sizeInTiles y ].

    self enable: aPane when: zoom notNil.!  
imageClasses: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    category notNil ifTrue: [
        aPane
            contents: #(default),(PictureBitmap allSubclasses collect: [:each | each symbol]);
            selection: (category imageClass isNil ifTrue: [ #default ] ifFalse: [ category imageClass symbol ]).
    ] ifFalse: [ aPane contents: Array new ].
    self enable: aPane when: category notNil.!  
imageClassSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | sel |
    sel := aPane selectedItem.
    (sel notNil and: [category notNil])
    ifTrue: [
        sel == #default
        ifTrue: [ sel := nil ]
        ifFalse: [ sel := Smalltalk at: sel ].
        category imageClass: sel.
    ].!  
iniName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    category notNil
    ifTrue: [ aPane contents: category iniFile ]
    ifFalse: [ aPane contents: String new ].

    self enable: aPane when: category notNil.! 
iniNameChanged: aPane

    "Callback for the #textChanged event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    category notNil ifTrue: [
        category iniName: aPane contents trimBlanks
    ].!
layer: aLayer
    "Set the receiver for editing a layer..."

    layer := aLayer.! 
newCategory

    | newName |
    newName := OSPrompter
        prompt: 'Nombre de la nueva categoria?'
        default: String new.
    newName size = 0 ifTrue: [self beep.^nil].

    layer addCategory: newName.
    self changed: #categories: with: #restoreSelected: with: newName.!   
newZoom

    | factor |
    category isNil ifTrue: [ ^self beep ].
    factor := OSPrompter prompt: 'Valor del nuevo Zoom ?' default: String new.
    factor isNil ifTrue: [^nil].
    factor := Compiler evaluate: factor.
    factor = 0 ifTrue: [
        (MessageBox confirm: 'El valor sera tomado como zoom CERO.\ Desea continuar ?' withCrs)
        ifFalse: [^self beep].
    ].
    category newZoom: factor.
    zoom := factor.
    self
        changed: #zooms: with: #restoreSelected: with: factor;
        updateZoom.!  
removeCategory

    category isNil ifTrue: [^nil].
    (MessageBox confirm: 'Seguro desea borrar la categoria ?') ifFalse: [^self].

    layer removeCategory: category.
    category := zoom := nil.
    self
        updateCategory;
        updateZoom;
        yourself.!   
removeZoom

    zoom isNil ifTrue: [^nil].
    (MessageBox confirm:
        'Seguro desea borrar el zoom de valor ',zoom asString,' ?') ifFalse: [^self].

    category removeZoom: zoom.
    zoom := nil.
    self updateZoom.!  
saveZoomInformation

    | pane value point |
    zoom isNil ifTrue: [^self].
    pane := [:aSymbol | (self paneAt: aSymbol) contents ].

    category
        withZoom: zoom
        do: [
            value := pane value: #fileName:.
            value size > 0
            ifTrue: [ category fileName: value ].
            value := pane value: #extension:.
            value size > 0
            ifTrue: [ category fileExtension: value ].
            point := (pane value: #tileWidth:) @ (pane value: #tileHeight:).
            category tileExtent: point.
            point := (pane value: #widthInTiles:) @ (pane value: #heightInTiles:).
            category sizeInTiles: point.
        ]!  
tileHeight: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    category isNil
    ifTrue: [ self disable: aPane.^self ].

    category
        withZoom: zoom
        do: [ aPane contents: category tileExtent y ].

    self enable: aPane when: zoom notNil.!  
tileWidth: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    category isNil
    ifTrue: [ self disable: aPane.^self ].

    category
        withZoom: zoom
        do: [ aPane contents: category tileExtent x ].
    self enable: aPane when: zoom notNil.! 
toolMeasure

    "Force to rectalculate tile extent from first tile of the category..."

    category tileExtent: nil.
    self
        changed: #tileHeight:;
        changed: #tileWidth:!   
updateCategory
    "Private - Update category dependent panes."

    self changed: #zooms: with: #restoreSelected.
    #(defaultCategory: ) do: [:each| self changed: each ]! 
updateZoom
    "Private - Update zoom dependent panes."

    #( fileName: extension:
        widthInTiles: heightInTiles:
        tileWidth: tileHeight:
        imageClasses:
    )
    do: [:each| self changed: each]! 
view: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"


    "ignore the setting..."!  
widthInTiles: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    category isNil
    ifTrue: [ self disable: aPane.^self ].

    category
        withZoom: zoom
        do: [ aPane contents: category sizeInTiles x ].

    self enable: aPane when: zoom notNil.!   
zooms: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | zooms |
    category notNil ifTrue: [
        zooms := category zooms.
        aPane contents: zooms
    ] ifFalse: [ aPane contents: String new ].
    self enable: aPane when: zooms size > 0!   
zoomSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | factor |
    Notifier isAltDown & Smalltalk isRunTime not ifTrue: [ category halt ].
    factor := aPane selectedItem.
    factor = zoom ifTrue: [^self].
    zoom := factor.
    self updateZoom.! !

! TipsOfTheDayEditor class methods !
wbCreated

    ^true! !

! TipsOfTheDayEditor methods !   
changePathName: aPane

    "Callback for the #clicked event in an unnamed CPHorizontalPictureButton (contents is 'Archivo...').
     (Generated by WindowBuilder)"

    | path |
    path := OSPrompter
            prompt: 'Nombre del archivo con los tips ?'
            default: (pathName isNil
                ifTrue: [ TipOfTheDay defaultPathName ]
                ifFalse: [pathName]).
    path isNil ifFalse: [
        path trimBlanks isEmpty ifTrue: [ path := nil ].
        pathName := path.
        self changed: #tipContents:.
    ].
    aPane selection: false.!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Tips del Da';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 681 @ 392; xC; yC; cRDU: (2 @ 390 rightBottom: 679 @ 40));
            pStyle: #(sysmenu titlebar minimize);
            when: #close perform: #mainViewClosed:;
            backColor: ClrPalegray;
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 71 @ 84; lDU: 23 r: #left; tDU: 48 r: #top);
                    contents: (CPBitmapDict at: 'TipOfTheDay');
                    startGroup;
                    backColor: ClrBackground;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 53 @ 28; lDU: 432 r: #left; rDU: 485 r: #left; tDU: 204 r: #top; bDU: 232 r: #top);
                    startGroup;
                    contents: 'Da:';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 409 @ 330; lDU: 9 r: #left; tDU: 8 r: #top);
                    contents: 'Saba Ud que...';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                TextEdit new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 299 @ 282; lDU: 105 r: #left; rDU: 405 r: #left; tDU: 42 r: #top; bDU: 324 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #tipContents:;
                    when: #textChanged perform: #tipTextChanged:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPHorizontalPictureButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 171 @ 44; lDU: 453 r: #left; tDU: 28 r: #top);
                    bitmap: (CPBitmapDict at: 'CheckDiskOn');
                    onBitmap: (CPBitmapDict at: 'CheckDiskOff');
                    startGroup;
                    tabStop;
                    when: #clicked perform: #changePathName:;
                    contents: 'Archivo...';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPHorizontalPictureButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 208 @ 68; lDU: 434 r: #left; tDU: 78 r: #top);
                    bitmap: (CPBitmapDict at: 'Radioactive');
                    onBitmap: (CPBitmapDict at: 'Radioactive Fire');
                    when: #clicked perform: #pack:;
                    contents: 'Compactar';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 44; lDU: 491 r: #left; tDU: 194 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #setDay:;
                    when: #valueChanged perform: #dayChanged:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 162 @ 32; lDU: 437 r: #left; tDU: 254 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #toggleCript:;
                    when: #getContents perform: #setCript:;
                    contents: 'Encriptado';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 32; lDU: 437 r: #left; tDU: 304 r: #top);
                    when: #clicked perform: #toggleCentered:;
                    when: #getContents perform: #setCentered:;
                    contents: 'Centrado';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).! 
dayChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    self changed: #tipContents:.
    (self paneAt: #tipContents: )setFocus.!
pack: aPane

    "Callback for the #clicked event in an unnamed CPHorizontalPictureButton (contents is 'Compactar').
     (Generated by WindowBuilder)"

    CursorManager execute
    changeFor: [
        TipOfTheDay pack: pathName.
        aPane selection: false.
        self changed: #tipContents:.
    ]! 
setCentered: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Centrado').
     (Generated by WindowBuilder)"!  
setCript: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Encriptado').
     (Generated by WindowBuilder)"

    self enable: aPane when: Smalltalk isRunTime not!   
setDay: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane
        min: 1;
        max: TipOfTheDay maxTips - 1;
        contents: 1!   
tipContents: aPane

    "Callback for the #getContents event in an unnamed TextEdit (contents is '').
     (Generated by WindowBuilder)"

    | index tip contents stream |
    index := (self paneAt: #setDay:) contents.
    tip := TipOfTheDay new.
    pathName isNil ifFalse: [ tip pathName: pathName ].
    tip index: index.
    contents := tip contents.
    stream := ReadStream on: contents.

    (self paneAt: #setCentered:) selection: tip centered.
    (self paneAt: #setCript:) selection: tip cripted.

    contents isNil
    ifTrue: [ aPane contents: String new ]
    ifFalse: [
        aPane
            contents: (stream upTo: nil);
            selectAll;
            yourself
    ].

    self
        enable: aPane
        when: (Smalltalk isRunTime not or: [tip cripted not])! 
tipTextChanged: aPane

    "Callback for the #textChanged event in an unnamed TextEdit (contents is '').
     (Generated by WindowBuilder)"

    | index tip header |
    index := (self paneAt: #setDay:) contents.
    tip := TipOfTheDay new.
    pathName isNil ifFalse: [ tip pathName: pathName ].
    header := WriteStream on: String new.

    tip
        index: index;
        contents: header contents, aPane contents;
        centered: (self paneAt: #setCentered:) selection;
        cripted: (self paneAt: #setCript:) selection;
        fileOut.!
toggleCentered: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Centrado').
     (Generated by WindowBuilder)"

    self tipTextChanged: (self paneAt: #tipContents:)!  
toggleCript: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Encriptado').
     (Generated by WindowBuilder)"

    self tipTextChanged: (self paneAt: #tipContents:)! !

! TextWindow class methods ! 
initializeTranscript
    "Private - Create the system transcript window.
    Who touched this method? why?"
    | mgr |
    #modifiedByOStyle.
    mgr := self new.
    mgr
        label: 'Transcript';
        model: mgr;
        icon: (Icon fromModule: Icon defaultDLLFileName id:'Transcript').
    mgr mainView
        when: #menuBuilt perform: #addMenuItem:;
        when: #validated perform: #changeSysMenu:;
        when: #close perform: #close:.
    Transcript := mgr.
    mgr
        addSubpane:
            (TextPane new
                model: '';
                yourself);
         openIn: ((1 @ 5 corner: 40 @ 19)
            scaleBy: (SysFont width @ SysFontHeight)).!  
walkBackWindowFor: aDebugger label: aString
    "Private - Create a new walkback window for aDebugger."
    "Touched by LRP for resume button placement"
    | aPane mainWindow extent |
    #modifiedByOStyle.
    extent := ((Display width // 2 max:
        aString size + 11 * TextFont width) min: Display width)
                @ (Display height // 2).
    aPane := TextPane new.
    mainWindow := self new.
    mainWindow
        label: aString;
        icon: (Icon fromModule: Icon defaultDLLFileName id:'WalkBack');
        foreColor: ClrWhite;
        backColor: ClrRed.
    mainWindow
        addSubpane:
                (Button new
                    pushButton;
                    owner: aDebugger;
                    contents: 'Debug';
                    when: #clicked perform: #debug:;
                    framingBlock: [:box | (box leftBottom rightAndUp: 10 @ ( ButtonFont height + 36)) extent:
                        (( ButtonFont stringWidth: 'Resume') @ (ButtonFont height) + 10) ]) .
    mainWindow
        addSubpane:
                (Button new
                    pushButton;
                    owner: aDebugger;
                    contents: 'Resume';
                    when: #clicked perform: #resume:;
                    framingBlock: [:box | (box leftBottom rightAndUp: 10 @ ( 3 * ButtonFont height + 36)) extent:
                        (( ButtonFont stringWidth: 'Resume') @ (ButtonFont height) + 10) ]) .

    mainWindow addSubpane: aPane.

    ^mainWindow openIn: (Display extent - extent // 2 extent: extent).! !

! TextWindow methods !
addMenuItem: aPane

    "Modified by OSI to add WB Menu to the Transcript.
    Touched By Ale for better menu"
        "Private - Add items to the system menu in Transcript."
    #modifiedByOStyle.
    self == Transcript ifTrue: [
        #modifiedByOStyleI.
        (self menuWindow menuTitled: '&File')
            appendSeparator;
            appendItem: 'About &V...' selector:
                (Message new receiver: self;
                    selector: #aboutV).

        "OSI - Changed to support WindowBuilder subclasses"
        self menuWindow addMenu: PWindowBuilder windowBuilderMenu.
    ].!
cleanUp
    "Private - Clean Up of hole system windows.
    Creating a new transcript.
    Implemented By Ale"
    #addedByOStyle.

   "clean up windows"
   Notifier reinitialize.!   
openDemo
    "Private - Open the graphics demo.
     Touched by Ale for StartUpApplication open"
    #modifiedByOStyle.
    StartUpApplication open!  
printMillisecondsToRun: aBlock
    "Output the millisecons wasted to execute aBlock
     into the receiver...
    Implemented by LRP..."
    #addedByOStyle.
    self cr;nextPutAll: (Time millisecondsToRun: aBlock) printString! !

! MDITranscript class methods !  
initializeTranscript
        "Private - Create the system transcript window."
    | mgr|
    MDISystem isActive ifTrue:[^MDISystem new open].
    ^self new open! !

! MDITranscript methods !  
addMenuItem: aPane
    "Private - Add items to the system menu in Transcript.
    Touched by Ale for better documentation of changes..."

    | tab |
    tab := String with: $	.
    super addMenuItem:aPane.
    #modifiedByOStyle.
    #fileMenu. "placed for senders forcing reference..."
    (self menuWindow menuTitled: '&File') appendSeparator.

    MDISystem isActive
    ifTrue:[
        (self menuWindow menuTitled: '&File')
            appendItem: 'Quit &MDI',tab,'Alt+M' selector:
                (Message new receiver: MDISystem;
                    selector: #deactivate) accelKey: $m accelBits: AfAlt | AfChar
    ]
    ifFalse:[
        (self menuWindow menuTitled: '&File')
            appendItem: 'Switch to &MDI',tab,'Alt+M' selector:
                (Message new receiver: MDISystem;
                    selector: #activate) accelKey: $m accelBits: AfAlt | AfChar
    ].!  
changeSysMenu: aPane
        "Private - Change the system menu."
    MDISystem isActive ifFalse:[^super changeSysMenu:aPane].!  
initMdiWindowSize
        "Private - Answer the receiver's size when it is an MDI document."
    |rect|
    rect:=self frame mdiClient rectangle.
    ^0 @ 0 extent: (rect width * 4  // 5) @ (rect height * 3 // 5)! 
open
        "Private - Create the system transcript window."
    | mgr|
    mgr := self.
    mgr
        label: 'Transcript';
        model: mgr;
        icon: (Icon fromModule: Icon defaultDLLFileName id:'Transcript');
        statusText:WindowLabelPrefix,' ',Smalltalk version.
    mgr mainView
        when: #menuBuilt perform: #addMenuItem:;
        when: #validated perform: #changeSysMenu:;
        when: #close perform: #close:;
        when: #opened perform: #opened:.
     MDISystem isActive ifTrue:[mgr disableSystemMenuItemClose].
    Transcript := mgr.
    mgr
        addSubpane:
            (TextPane new
                model: '';
                yourself);
         openIn: ((1 @ 5 corner: 40 @ 19)
            scaleBy: (SysFont width @ SysFontHeight)).! 
opened:aPane
        "Private - The Transcript has been opened."
    MDISystem display.! !

! RunTimeTranscript methods ! 
pane
    "Private - Answer the text pane."
    views isEmpty
    ifTrue: [
        Transcript := nil.
        self openOn: String new.
        self mainView setWindowText: 'RunTime Transcript'.
        Transcript := self.
    ].
    ^super pane! !

! TextEditWindow methods !
initWindowSize
        "Private - Answer the initial size of the receiver."
    ^10@10 extent: Display extent - (20@20)!
openOn: aString
        "Open the receiver with aString as its initial contents."
    file := aString.
    self addSubpane:
        (TextPane new
            owner: self;
            font: (Font face: 'Terminal' size: 8@14 fixedWidth: true);
            when: #getContents perform: #stringContents:;
            framingBlock: [ :box | box]).
    self openWindow.
    partial := false.! !

! WBCompositePaneTester class methods !  
isWBInternalClass

    ^true! !

! WBCompositePaneTester methods !
isWBWindow

    ^true!  
openOn: aCompositePaneClass

    self openOn: aCompositePaneClass parent: nil!  
openOn: aCompositePaneClass parent: aViewManager
    | composite iDUE |
    composite := (aCompositePaneClass new)
        addSubpanes;
        yourself.
    iDUE := composite framingBlock iDUE.
    composite
        framingBlock: nil;
        children: nil;
        propertyAt: #subpaneOrder put: nil.
    self addView: (
        self topPaneClass new
            owner: self;
            labelWithoutPrefix: aCompositePaneClass name,' Tester';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: (iDUE + (15@54)); xC; yC; cRDU: (0@0 rightBottom: iDUE));
            pStyle: #(sysmenu titlebar sizable);
            addSubpane: (
                composite
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: iDUE; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 0 r: #top; bDU: 0 r: #bottom);
                    addSubpanes;
                    scrollbars;
                    startGroup;
                    yourself
            );
        yourself
    ).
    aViewManager isNil ifFalse: [ self parent: aViewManager ].
    self openWindow.
    self mainView resize: self mainView rectangle repaint: true.! !

! WBDefaultScratchWindow class methods !  
isWBInternalClass

    ^true! !

! WBDefaultScratchWindow methods !   
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'New Window';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 686 @ 400; xC; yC; cRDU: (9 @ 392 rightBottom: 677 @ 46));
            pStyle: #(sysmenu sizable titlebar minimize maximize);
        yourself
    ).! 
isWBWindow

    ^true! !

! WBMenuTester class methods !  
isWBInternalClass

    ^true! !

! WBMenuTester methods ! 
isWBWindow

    ^true!  
menubar: aMenuList

    menus := aMenuList.!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := TopPane new
            owner: self;
            labelWithoutPrefix:  'Testing Menubar...';
            noSmalltalkMenuBar;
            framingBlock: ( FramingParameters new iDUE: 800 @ 208; xC; yC; cRDU: (3 @ 168 rightBottom: 797 @ 2));
            pStyle: #(sysmenu titlebar);
        yourself
    ).

    self openWindow! 
perform: selector
    "Scratch windows should not perform any events"
    ^MessageBox messageNote: 'Menu item selector: #',selector!
preInitWindow

    | mw |

    mw := MenuWindow new.
    menus notNil ifTrue: [
        menus do: [ :m |
            m allOwners: self.
            mw addMenu: m.
        ].
    ].

    mw owner: self.

    self mainView menuWindow: mw.! !

! WBScratchWindow class methods !
createMethod: methodString

    | fileInStream |

    fileInStream := ReadWriteStream on: (String new: methodString size).
    fileInStream
        nextPutAll: '!! WBScratchWindow methods !!';
        nextChunkPut: methodString;
        nextChunkPut: String new.

    fileInStream reset; fileIn.!
defaultClass

    ^ WBDefaultScratchWindow! 
isScratchWindow

    ^true! 
isWBInternalClass

    ^true!   
resetToDefault

    "self defaultClass selectors do: [:s |
        self createMethod: (self defaultClass sourceCodeAt: s).
    ]."! !

! WBScratchWindow methods !  
isWBWindow

    ^true!  
perform: selector
    "Scratch windows should not perform any events"
    ^MessageBox messageNote: 'Scratch windows cannot do anything. You must first create a new view manager class with the "Save As..." command in order to add behavior.'!
perform: selector with: arg
    "Scratch windows should not perform any events"
    ^self perform: selector!
when: anEvent perform: aSelector
    "Scratch windows should not perform any events"! !

! WBWindowDialog methods !
close
        "Close all the views."
    views do: [:v | v close]!  
openModalTo: aWindow
    "Open the dialog box modal to ownerTopPane."
    self createViews.
    self mainView openModal: aWindow mainView! 
topPaneClass
    "Private - Answer the defalut top pane class."
    ^WBDialogTopPane! !

! WindowBuilder class methods !  
aboutWB

    PWindowBuilder basicNew aboutWB!   
addInCompositePaneExamples: op
    "Register the additional CompositePane Example menu items"
    | addInName |
    (Smalltalk includesKey: #ListEditorPane) ifFalse: [ ^nil ].
    addInName := 'CompositePane Examples'.
    op == #name ifTrue:[ ^addInName ].
    op == #help ifTrue:[
^'Adds tool palette and "Add" menu options
to support several CompositePane
examples.'].
    PWindowBuilder extras removeKey: addInName ifAbsent: [ nil ].
    PWindowBuilder
        register: addInName menu: #('~OkCancelPane' 'OkCancelPane' '' ) after: 'SexPane';
        register: addInName menu: #('~NamePane' 'NamePane' '' ) after: 'OkCancelPane';
        register: addInName menu: #('~AddressPane' 'AddressPane' '' ) after: 'NamePane';
        register: addInName menu: #('~PersonPane' 'PersonPane' '' ) after: 'AddressPane';
        register: addInName menu: #('~ListEditorPane' 'ListEditorPane' '' ) after: 'PersonPane';
        register: addInName menu: #('~DictionaryEditorPane' 'DictionaryEditorPane' '' ) after: 'ListEditorPane';
        register: addInName menu: #('Address~EditorPane' 'AddressEditorPane' '' ) after: 'DictionaryEditorPane'.!
addInInstVarNameCheck: op
    "Register support for Instance Variable Name Checking"
    | addInName |
    addInName := 'Instance Variable Name Checking'.
    op == #name ifTrue:[ ^addInName ].
    op == #help ifTrue:[
^'Force the pane name to be a valid
instance variable name.'].

    PWindowBuilder
        register: addInName propertyAt: #InstVarNameCheck put: true.! 
addInPaneInspector: op
    "Register the additional Inspect menu items"
    | addInName |
    addInName := 'Pane Inspector'.
    op == #name ifTrue:[ ^addInName ].
    op == #help ifTrue:[
^'Pane Inspector'].
    PWindowBuilder extras removeKey: addInName ifAbsent: [ nil ].
    PWindowBuilder
        register: addInName menu: #('~Inspect' nil (
            ('~Inspect Selection' inspectSelection '')
            )) after: 'Add'.!
addInPowerViewSupport: op
    "Register support for Power Views"
    | addInName incompatible |
    addInName := 'Power View Support'.
    op == #name ifTrue:[ ^addInName ].
    op == #help ifTrue:[
^'WindowBuilder will generate
#createViewsFor:owner: methods. The
first argument is the ViewManager to add
the views to. The second argument is the
owner of the subpanes within the views
(e.g., the target of the #when:perform:
messages).'].
    incompatible := 'WindowBuilder 2.0 Code Generation'.
    (self extras includesKey: incompatible) ifTrue: [
        (MessageBox confirm: '''',addInName,''' is incompatible with ''',incompatible,'''. Disable it?') ifTrue: [
            self extras removeKey: incompatible
        ] ifFalse: [
            ^nil
        ]
    ].
    PWindowBuilder
        register: addInName propertyAt: #OpenMethodType put: #createViewsFor:owner:;
        register: addInName propertyAt: #OpenMethodArgs put: #('target' 'wbOwner');
        register: addInName propertyAt: #OpenMethodInitCode put: '
    target := arg1 isNil ifTrue: [ self ] ifFalse: [ arg1 ].
    wbOwner := arg2 isNil ifTrue: [ self ] ifFalse: [ arg2 ].'!
addInRecordCreatorInformation: op
    "Register support for Recording Creator Information"
    | addInName |
    addInName := 'Record Creator Information'.
    op == #name ifTrue:[ ^addInName ].
    op == #help ifTrue:[
^'Record information about who created
and last modified a window.'].

    PWindowBuilder
        register: addInName propertyAt: #RecordCreatorInformation put: true.! 
addInSubPanes: op
    "Register the additional SubPanes menu items"
    | addInName |
    (Smalltalk includesKey: #CPSubPane) ifFalse: [ ^nil ].
    addInName := 'SubPanes/V'.
    op == #name ifTrue:[ ^addInName ].
    op == #help ifTrue:[
^'Adds tool palette and "Add" menu options
to support the SubPanes/V widget
collection.'].
    PWindowBuilder extras removeKey: addInName ifAbsent: [ nil ].
    PWindowBuilder
        register: addInName menu: #('~3D Button' add: (
            ('~CPBitmapButton' 'CPBitmapButton' '')
            ('CPBitmap~Toggle' 'CPBitmapToggle' '')
            ('CP3DC~heckBox' 'CP3DCheckBox' '')
            ('CP3D~RadioButton' 'CP3DRadioButton' '')
            )) after: 'Button';
        register: addInName menu: #('CP~HierarchicalListBox' 'CPHierarchicalListBox' '' ) after: 'ComboBox';
        register: addInName menu: #('CPC~olumnarListBox' 'CPColumnarListBox' '' ) after: 'CPHierarchicalListBox';
        register: addInName menu: #('CP~TableEditor' 'CPTableEditor' '' ) after: 'CPColumnarListBox';
        register: addInName menu: #('CP~SpinButton' 'CPSpinButton' '' ) after: 'CPTableEditor';
        register: addInName menu: #('CPHorizontal~BarGauge' 'CPHorizontalBarGauge' '' ) after: 'Vertical Scroll Bar';
        register: addInName menu: #('CPVerticalB~arGauge' 'CPVerticalBarGauge' '' ) after: 'CPHorizontalBarGauge';
        register: addInName menu: #('~CPCircularGauge' 'CPCircularGauge' '' ) after: 'CPVerticalBarGauge';
        register: addInName menu: #('CPHorizontal~Slider' 'CPHorizontalSlider' '' ) after: 'CPCircularGauge';
        register: addInName menu: #('CPVerticalS~lider' 'CPVerticalSlider' '' ) after: 'CPHorizontalSlider';
        register: addInName menu: #('CP~NumericEditor' 'CPNumericEditor' '' ) after: 'TextPane';
        register: addInName menu: #('CPT~imeEditor' 'CPTimeEditor' '' ) after: 'CPNumericEditor';
        register: addInName menu: #('~CPDateEditor' 'CPDateEditor' '' ) after: 'CPTimeEditor';
        register: addInName menu: #('~CP3DFrame' 'CP3DFrame' '' ) after: 'GroupBox';
        register: addInName menu: #('~CPBitmapPane' 'CPBitmapPane' '' ) after: 'StaticGraphic';
        register: addInName menu: #('~CPValueSet' 'CPValueSet' '' ) after: 'WBToolBar'.! 
addInVersion2CodeGen: op
    "Register support for WindowBuilder 2.0 Code Generation"
    | addInName incompatible |
    addInName := 'WindowBuilder 2.0 Code Generation'.
    op == #name ifTrue:[ ^addInName ].
    op == #help ifTrue:[
^'WindowBuilder will generate standard
#open methods rather than #createView
methods.'].
    incompatible := 'Power View Support'.
    (self extras includesKey: incompatible) ifTrue: [
        (MessageBox confirm: '''',addInName,''' is incompatible with ''',incompatible,'''. Disable it?') ifTrue: [
            self extras removeKey: incompatible
        ] ifFalse: [
            ^nil
        ]
    ].
    PWindowBuilder
        register: addInName propertyAt: #OpenMethodType put: nil;
        register: addInName propertyAt: #OpenMethodArgs put: #('self' 'self');
        register: addInName propertyAt: #OpenMethodInitCode put: nil!   
addInVersion2MDISupport: op
    "Register support for WindowBuilder 2.0 MDI Support"
    | addInName |
    (Smalltalk includesKey: #MDISystem) ifFalse: [ ^nil ].
    addInName := 'WindowBuilder 2.0 MDI Support'.
    op == #name ifTrue:[ ^addInName ].
    op == #help ifTrue:[
^'Enables the WindowBuilder 2.0 MDI
Support. WindowBuilder Pro supports
MDI through the #openAsMDIParent
and #openWithMDIParent: methods.'].
    PWindowBuilder extras removeKey: addInName ifAbsent: [ nil ].
    PWindowBuilder
        register: addInName menu: #('&MDI...' mdi '') after: 'Add-&In Manager...'.!
addToolbarTool

    | class |

    class := Smalltalk at: #MDISystem ifAbsent: [ nil ].

    class notNil ifTrue: [
        class addExtraTool: self toolBarTool.
    ].! 
addWindowBuilderMenuHelpItems

    (Smalltalk includesKey: #HelpStatusPane) ifFalse: [
        ^self
    ].

    (Smalltalk at: #HelpStatusPane)
        at: 'WindowBuilder' put: 'Launch WindowBuilder.';
        at: 'newWindowBuilder' put: 'Open WindowBuilder on a scratch ViewManager.';
        at: 'newDialogWindowBuilder' put: 'Open WindowBuilder on a scratch WindowDialog.';
        at: 'editWindow' put: 'Open WindowBuilder on an existing ViewManager or WindowDialog.';
        at: 'launchBitmapManager' put: 'Open the CPBitmapManager.';
        at: 'aboutWB' put: 'Display version information on WindowBuilder.'! 
allViewManagerClasses

    WBClasses notNil ifTrue: [
        ^WBClasses
    ].

    "Exclude all WindowBuilder subclasses"
    WBClasses := WindowBuilder withAllSubclasses asOrderedCollection.
    self excludeOtherClasses.
    ViewManager allSubclasses do: [ :c |
        c isWBInternalClass ifTrue: [
                WBClasses add: c
        ].
    ].

    ^WBClasses! 
clearExtras
    "   WindowBuilder clearExtras    "
    Extras := Dictionary new.!   
clearHelpDict

    "   WindowBuilder clearHelpDict    "
    HelpDict := nil.!  
clearToolbarTool

    "   WindowBuilder clearToolbarTool    "
    ToolbarTool := nil.! 
clearWBClasses

    "  WindowBuilder clearWBClasses   "

    WBClasses := nil.!   
clearWBIcon

    "  WindowBuilder clearWBIcon   "

    WBIcon := nil.!
codeGenerationHook
    ^self propertyAt: #CodeGenerationHook!
createMethod: methodString in: aClass loggingSource: logSource
    "Do all method creation through this method"
    | result hook |
    result := aClass compile: methodString.
    result notNil & logSource ifTrue: [
        ((hook := self codeGenerationHook) notNil and: [ self respondsTo: hook asSymbol ]) ifTrue: [
            self perform: hook asSymbol with: methodString with: result key with: aClass
        ] ifFalse: [
            Smalltalk
                logSource: methodString
                forSelector: result key
                inClass: aClass
        ].
    ].!  
createMethod: bodyString titled: title in: aClass loggingSource: logSource

    | result methodString |

    methodString := title, '
', bodyString.
    "Consolidate all code creation"
    self
        createMethod: methodString
        in: aClass
        loggingSource: logSource!   
editWindow

    | c |
    PWindowBuilder preOpen.
    (c := self new getEditedClass) notNil ifTrue: [
        PWindowBuilder new openOn: c.
    ].! 
excludeOtherClasses
    "Exclude MDIViewManager subclasses unless MDI add-in is enabled"
    ((Smalltalk includesKey: #MDIViewManager) and: [
        (self extras includesKey: 'WindowBuilder 2.0 MDI Support') not ]) ifTrue: [
        WBClasses addAll: (Smalltalk at: #MDIViewManager) withAllSubclasses
    ].!
extras
    Extras isNil ifTrue: [ Extras := Dictionary new ].
    ^Extras!  
firstArg
    | arg |
    arg := self openMethodArgs at: 1.
    ^(arg isNil or: [ arg isString not ])
        ifTrue: [ 'self' ]
        ifFalse: [ arg asString ]!   
helpDict

    HelpDict isNil ifTrue: [
        HelpDict := Dictionary new.
        HelpDict
            at: 'File' put: 'Create, edit, import, export window definitions; edit app code.';
            at: 'createNew' put: 'Create a new window.';
            at: 'createNewDialog' put: 'Create a new dialog.';
            at: 'openNew' put: 'Open an existing window or dialog.';
            at: 'importFromWindows' put: 'Convert WindowBuilder 1.x generated windows.';
            at: 'importFromResFile' put: 'Convert dialog resources (.res files) to Smalltalk windows.';
            at: 'save' put: 'Save the currently edited ViewManager.';
            at: 'saveAs' put: 'Save the currently edited ViewManager with a new class name.';
            at: 'saveAsDefault' put: 'Use the current layout of windows as the default for new windows.';
            at: 'exportToResFile' put: 'Save the current dialog layout as a resource (.res) file.';
            at: 'editAppCode' put: 'Bring up CHB on currently edited ViewManager.';
            at: 'close' put: 'Close WindowBuilder.';

            at: 'Edit' put: 'Subpane editing, selection, ordering;  window testing, tab order editing ';
            at: 'undo' put: 'Undo the last command.';
            at: 'cut' put: 'Remove currently selected subpanes from layout, place on clipboard.';
            at: 'copy' put: 'Copy the currently selected subpanes to the clipboard.';
            at: 'paste' put: 'Load the cursor with the subpanes on the clipboard.';
            at: 'clear' put: 'Remove currently selected subpanes from layout.';
            at: 'selectAll'  put: 'Add all subpanes in window to the selection.';
            at: 'bringToFront' put: 'Bring currently selected pane to the front of all overlapping panes.';
            at: 'sendToBack' put: 'Send currently selected pane behind all overlapping panes.';
            at: 'duplicate'  put: 'Duplicate the currently selected subpanes.';
            at: 'mutate'  put: 'Morph the currently selected subpane into a different type.';
            at: 'eventSummary' put: 'Launch window summarizing event usage in this ViewManager.';
            at: 'editTabbing' put: 'Edit subpane tabbing order and grouping of buttons.';
            at: 'pasteWindowBitmapToClipboard' put: 'Copy a bitmap of current view to the Windows clipboard.';
            at: 'testWindow' put: 'Launch an example of currently edited ViewManager.';

            at: 'View' put: 'View creation, removal, switching.';
            at: 'viewSwitchTo' put: 'Switch to another view in this ViewManager.';
            at: 'viewCreate' put: 'Create a new view in this ViewManager.';
            at: 'viewRemove' put: 'Remove a view from this ViewManager.';

            at: 'Align' put: 'Alignment commands.';
            at: 'alignLeft' put: 'Align selected panes along left sides.';
            at: 'alignTop' put: 'Align selected panes along tops.';
            at: 'alignRight' put: 'Align selected panes along right sides.';
            at: 'alignBottom' put: 'Align selected panes along bottoms.';
            at: 'alignCenterHorizontal' put: 'Align selected panes along their horizontal centers.';
            at: 'alignCenterVertical' put: 'Align selected panes along their vertical centers.';
            at: 'alignDistributeHorizontal' put: 'Distribute selected panes horizontally.';
            at: 'alignDistributeVertical' put: 'Distribute selected panes vertically.';

            at: 'Center' put: 'Centering selected panes.';
            at: 'Distribute' put: 'Distribute selected panes.';
            at: 'horizontal' put: 'Do horizontally.';
            at: 'vertical' put: 'Do vertically.';

            at: 'Move By Pixel' put: 'Nudge selection around by one pixel increments.';
            at: 'moveSelectionUp' put: 'Nudge selection up one pixel.';
            at: 'moveSelectionDown' put: 'Nudge selection down one pixel.';
            at: 'moveSelectionLeft' put: 'Nudge selection left one  pixel.';
            at: 'moveSelectionRight' put: 'Nudge selection right one pixel.';

            at: 'Size By Pixel' put: 'Size selection by one pixel increments.';
            at: 'sizeSelectionUp' put: 'Shrink selection''s height by one pixel.';
            at: 'sizeSelectionDown' put: 'Grow selection''s height by one pixel.';
            at: 'sizeSelectionLeft' put: 'Shrink selection''s width by one pixel.';
            at: 'sizeSelectionRight' put: 'Grow selection''s width by one pixel.';

            at: 'Size' put: 'Size subpanes or window, set window position.';
            at: 'autosize' put: 'Size selected subpanes according to predefined hints.';
            at: 'replicateWidth' put: 'Set width of selected subpanes to be the same.';
            at: 'replicateHeight' put: 'Set height of selected subpanes to be the same.';
            at: 'setWindowSize' put: 'Specify the size of the selected subpane or window, in pixels.';
            at: 'setWindowPosition' put: 'Specify initial launching position of the window.';

            at: 'Options' put: 'Set grid, window zooming, MDI editing.';
            at: 'setGridSize' put: 'Set the size of the snap-to grid, in pixels.';
            at: 'drawGrid' put: 'Toggle display of the grid.';
            at: 'setDrawGrid' put: 'Toggle display of the grid (right mouse click for quick access to grid sizes).';
            at: 'autoSave' put: 'Toggle prompting for saving before Test Window.';
            at: 'autoSizeToggle' put: 'Toggle autosizing of StaticText and Buttons as text is entered.';
            at: 'zoomLayout' put: 'Zoom/unzoom the layout area of WindowBuilder.';
            at: 'addInManager' put: 'Invoke the WindowBuilder Add-In Manager.';
            at: 'mdi' put: 'Edit MDI specific options of the currently edited ViewManager.';

            at: 'Scrapbook' put: 'Scrapbook commands.';
            at: 'scrapbookStore' put: 'Store the currently selected panes as a page in the scrapbook.';
            at: 'scrapbookRetrieve' put: 'Retrieve a page from the scrapbook.';
            at: 'scrapbookNew' put: 'Create a new scrapbook.';
            at: 'scrapbookLoad' put: 'Load a scrapbook from disk.';
            at: 'scrapbookMerge' put: 'Merge a scrapbook from disk with the current one.';
            at: 'scrapbookSave' put: 'Save the current scrapbook to disk.';
            at: 'Quick Reference' put: 'Retrieve a page from the Quick Reference list.';

            at: 'Add' put: 'Load cursor with controls.';
            at: 'Button' put: 'Load cursor with one of the buttons.';
            at: '3D Button' put: 'Load the cursor with one of the 3D buttons.';
            at: 'List' put: 'Load the cursor with one of the listboxes.';
            at: 'Valuator' put: 'Load the cursor with one of the valuators.';
            at: 'Text' put: 'Load the cursor with one of the text editors.';
            at: 'Group' put: 'Load the cursor with one of the groupboxes.';
            at: 'Misc' put: 'Load the cursor with one of the miscellaneous subpanes.';
            at: 'Composite' put: 'Load the cursor with one of the composite subpanes.';
            at: 'Custom Panes' put: 'Load the cursor with one of the user-defined subpanes.';
            at: 'addCustomPane' put: 'Add a new custom pane to the Custom Panes menu.';
            at: 'removeCustomPane' put: 'Remove a custom pane from the Custom Panes menu.';

            at: 'setFont:' put: 'Set the font of the selected pane(s).';
            at: 'setColor:' put: 'Set the color of the selected pane(s).';
            at: 'setFraming:' put: 'Set the framing parameters for the selected pane(s).';
            at: 'setMenu:' put: 'Create a menu for the selected pane(s).';
            at: 'other:' put: 'Invoke the attribute editor for the selected pane.'.
    ].

    ^HelpDict!  
initMenu! 
initProperties
    "Set up the Properties dictionary"
    Properties := IdentityDictionary new.

    self propertyAt: #GridSize put: 4@4.
    self propertyAt: #DrawGrid put: false.
    self propertyAt: #AutoSize put: true.
    self propertyAt: #InstVarNameCheck put: false.
    self propertyAt: #OpenMethodType put: #createViews.
    self propertyAt: #OpenMethodArgs put: #('self' 'self').
    self propertyAt: #OpenMethodInitCode put: nil.
    self propertyAt: #CodeGenerationHook put: nil.
    self propertyAt: #RecordCreatorInformation put: false.
    "Subclass WBCreateClassDialog to record additional information about class creation (e.g., ENVY)"
    self propertyAt: #WBCreateClassDialog put: WBCreateClassDialog.

    WBScratchWindow removeSelector: #createViews.
    WBDialogScratchWindow removeSelector: #createViews.
    WBScratchWindow removeSelector: #open.
    WBDialogScratchWindow removeSelector: #open.

    self clearWBClasses.

    "Install extra menus and icons"
    self installExtras.!   
insertMenu: anArray after: menuNameString
    | menus target oc aString |
    menus := self wbMenus.
    aString := menuNameString stripMnemonic.
    oc := anArray asOrderedCollectionRecursively.
    target := menus detect: [ :m | (m at: 1) stripMnemonic = aString ] ifNone: [nil].
    target isNil
        ifFalse: [
            ^menus add: oc after: target].
    menus do: [ :menu |
        (menu at: 3) do: [ :mi |
            mi isSymbol ifFalse: [
                (mi at: 1) stripMnemonic = aString ifTrue: [
                    ^(menu at: 3) add: oc after: mi ].
                (mi at: 3) isString ifFalse: [
                    (mi at: 3) do: [ :msi |
                        msi isSymbol ifFalse: [
                            (msi at: 1) stripMnemonic = aString ifTrue: [
                                ^(mi at: 3) add: oc after: msi ]]]]]]]!   
insertMenu: anArray before: menuNameString
    | menus target oc aString |
    menus := self wbMenus.
    aString := menuNameString stripMnemonic.
    oc := anArray asOrderedCollectionRecursively.
    target := menus detect: [ :m | (m at: 1) stripMnemonic = aString ] ifNone: [nil].
    target isNil
        ifFalse: [
            ^menus add: oc before: target].
    menus do: [ :menu |
        (menu at: 3) do: [ :mi |
            mi isSymbol ifFalse: [
                (mi at: 1) stripMnemonic = aString ifTrue: [
                    ^(menu at: 3) add: oc before: mi ].
                (mi at: 3) isString ifFalse: [
                    (mi at: 3) do: [ :msi |
                        msi isSymbol ifFalse: [
                            (msi at: 1) stripMnemonic = aString ifTrue: [
                                ^(mi at: 3) add: oc before: msi ]]]]]]]!   
installCode: anArray
    self
        createMethod: anArray convertBytesToString
        in: self
        loggingSource: false!   
installExtras
    self extras do: [ :slot |
        slot do: [ :extra |
            extra perform ]]!  
isWBInternalClass

    ^true!   
labelName
    ^'WBuilder+'!  
launchBitmapManager

    (Smalltalk at: #CPBitmapManager) new open! 
listAddIns
    | list class |
    list := OrderedCollection new.
    class := self.
    [ class name = 'ViewManager' ] whileFalse: [
        list addAll: (class class methodDictionary keys asSortedCollection select: [ :selector |
            selector beginsWith: 'addIn' ]).
        class := class superclass
    ].
    ^list!   
menuName
    ^'&',self labelName!
newDialogWindowBuilder
    PWindowBuilder preOpen.
    PWindowBuilder new openDialog.!  
newWindowBuilder
    PWindowBuilder preOpen.
    PWindowBuilder new open.!  
openMethodArgs
    ^self propertyAt: #OpenMethodArgs!
openMethodInitCode
    ^self propertyAt: #OpenMethodInitCode!
openMethodType
    ^self propertyAt: #OpenMethodType!
preOpen!  
properties

    ^Properties!
propertyAt: aSymbol

    Properties isNil ifTrue: [ self initProperties ].
    ^Properties at: aSymbol ifAbsent: [ nil ]!  
propertyAt: aSymbol put: anObject

    Properties isNil ifTrue: [ self initProperties ].
    Properties at: aSymbol put: anObject! 
purgeCustomPanes

    " WindowBuilder purgeCustomPanes  "

    WBClasses := nil.
    CustomPanes := OrderedCollection new.!  
recordCreatorInformation
    ^self propertyAt: #RecordCreatorInformation!
register: extraName menu: anArray after: aString
    | slot |
    slot := self extras at: extraName ifAbsent: [ OrderedCollection new ].
    slot add:
        (Message new
            receiver: PWindowBuilder
            selector: #insertMenu:after:
            arguments: (Array with: anArray with: aString)).
    self extras at: extraName put: slot.!  
register: extraName menu: anArray before: aString
    | slot |
    slot := self extras at: extraName ifAbsent: [ OrderedCollection new ].
    slot add:
        (Message new
            receiver: PWindowBuilder
            selector: #insertMenu:before:
            arguments: (Array with: anArray with: aString)).
    self extras at: extraName put: slot.!
register: extraName propertyAt: aSymbol put: anObject
    | slot |
    slot := self extras at: extraName ifAbsent: [ OrderedCollection new ].
    slot add:
        (Message new
            receiver: PWindowBuilder
            selector: #propertyAt:put:
            arguments: (Array with: aSymbol with: anObject)).
    self extras at: extraName put: slot.!  
register: extraName removeMenu: aString
    | slot |
    slot := self extras at: extraName ifAbsent: [ OrderedCollection new ].
    slot add:
        (Message new
            receiver: PWindowBuilder
            selector: #removeMenu:
            arguments: (Array with: aString)).
    self extras at: extraName put: slot.!   
removeExtra: extraName

    self extras removeKey: extraName ifAbsent: [ nil ]! 
removeMenu: aString
    | menus target  |
    menus := self wbMenus.
    target := menus detect: [ :m | (m at: 1) = aString ] ifNone: [nil].
    target isNil
        ifFalse: [
            ^menus remove: target ifAbsent: [ nil ]].
    menus do: [ :menu |
        (menu at: 3) do: [ :mi |
            mi isSymbol ifFalse: [
                (mi at: 1) = aString ifTrue: [
                    ^(menu at: 3) remove: mi ifAbsent: [ nil ]].
                (mi at: 3) isString ifFalse: [
                    (mi at: 3) do: [ :msi |
                        msi isSymbol ifFalse: [
                            (msi at: 1) = aString ifTrue: [
                                ^(mi at: 3) remove: msi ifAbsent: [ nil ]]]]]]]]!   
reset

    InterfaceObject purgeCache.

    WBRealLayoutPane resetBitmap.

    "Set up Properties dictionary and install extras"
    self initProperties.

    CursorManager initialize.

    (Transcript menuWindow menuTitled: self labelName) isNil ifTrue: [
        PWindowBuilder addWindowBuilderMenuHelpItems.
        Transcript menuWindow addMenu:
            PWindowBuilder windowBuilderMenu.
    ].

    self updateForMDI.!  
scrapbook
    Scrapbook isNil
        ifTrue: [
            Scrapbook := Dictionary new.
            Scrapbook at: 'Quick Reference' put: Dictionary new].
    ^Scrapbook!   
scrapbook: aScrapbook

    Scrapbook := aScrapbook! 
scrapbookLoadFile: aFileName

    (Smalltalk includesKey: #ObjectFiler) ifTrue: [
        self scrapbook: ((Smalltalk at: #ObjectFiler) loadFromPathName: aFileName)
    ].!  
screenIcon

    | dir |

    WBIcon isNil ifTrue: [
        (Smalltalk includesKey: #CPSrcDir) ifTrue: [
            dir := (Smalltalk at: #CPSrcDir).
        ] ifFalse: [
            dir := ''.
        ].
        WBIcon := Icon fromFile: dir, 'wb.ico'.
    ].

    ^WBIcon!   
secondArg
    | arg |
    arg := self openMethodArgs at: 2.
    ^(arg isNil or: [ arg isString not ])
        ifTrue: [ 'self' ]
        ifFalse: [ arg asString ]!  
set

    Smalltalk at: #WindowBuilderVersion put:  'Version 1.01\Windows' withCrs.
    Smalltalk at: #PWindowBuilder put: WindowBuilder.
    WBClasses := nil.
    self initProperties.! 
startup

    CursorManager initialize.

    "Force caches to be set up for path independence"
    self screenIcon.

    WBRealLayoutPane initWinConstants.

    self reset.! 
toolBarTool

    ToolbarTool isNil ifTrue: [
        ToolbarTool :=  (Smalltalk at: #Tool) new fromBitmap: (CPBitmapDict sysAt:  'windowBuilderToolbarBitmap').
        ToolbarTool
            selector: #newWindowBuilder;
            owner: PWindowBuilder;
            name: 'WindowBuilder Tool';
            space: 11.
    ].

    ^ToolbarTool!   
updateForMDI

    self
        addToolbarTool;
        addWindowBuilderMenuHelpItems.!
wbCreateClassDialog
    ^self propertyAt: #WBCreateClassDialog!  
wbDefaultFont

    | defaultFont |
    defaultFont := self propertyAt: #WBDefaultFont.
    defaultFont isNil
        ifTrue: [
            defaultFont := Font fromStockFont: SystemFont.
            self propertyAt: #WBDefaultFont put: defaultFont].
    ^defaultFont!
wbMenuArray

^#(
    ('&File' nil
        (
            ('&New Window	Ctrl+N' createNew 'Ctrl+N')
            ('New &Dialog' createNewDialog '')
            ('&Open...	Ctrl+O' openNew 'Ctrl+O')
            separator
            ('&Composite Panes' nil
                (
                    ('&New' createNewCompositePane '')
                    ('&Open...' openNewComposite '')
                    separator
                    ('&Create...' createNewComposite '')
                    ('&Ungroup' ungroupComposite '')
                ))
            separator
            ('Import From &WB 1.x...	' importFromWindows '')
            ('&Import From Res File...	' importFromResFile '')
            separator
            ('&Save	Ctrl+S' save 'Ctrl+S')
            ('Save &As...	' saveAs '')
            ('Save As De&fault	' saveAsDefault '')
            ('Ex&port To Res File...	' exportToResFile '')
            separator
            ('&Edit ViewManager Code...	Ctrl+E' editAppCode 'Ctrl+E')
            ('E&xit	Ctrl+Q' close 'Ctrl+Q')
        ))
    ('&Edit' nil
        (
            ('&Undo	Ctrl+Z' undo 'Ctrl+Z')
             separator
            ('Cu&t	Ctrl+X' cut 'Ctrl+X')
            ('&Copy	Ctrl+C' copy 'Ctrl+C')
            ('&Paste	Ctrl+V' paste 'Ctrl+V')
            ('Cl&ear	Ctrl+Delete' clear 'Ctrl+27')
            ('&Select All	Ctrl+/' selectAll 'Ctrl+/')
            separator
            ('&Bring To Front	Ctrl+F' bringToFront 'Ctrl+F')
            ('Send To B&ack	Ctrl+B' sendToBack 'Ctrl+B')
            ('&Duplicate	Ctrl+D' duplicate 'Ctrl+D')
            ('&Morph...	Ctrl+M' mutate 'Ctrl+M')
            separator
            ('E&vent Summary...	Ctrl+R' eventSummary 'Ctrl+R')
            ('Edit Tabbing/&Groups...    	Ctrl+G' editTabbing 'Ctrl+G')
            ('Paste W&indow Bitmap to Clipboard	' pasteWindowBitmapToClipboard '')
            ('Test &Window	Ctrl+T' testWindow 'Ctrl+T')
        ))
    ('&View' nil
        (
            ('&Switch To...	' viewSwitchTo '')
            ('&Create...	' viewCreate '')
            ('&Remove...	' viewRemove '')
        ))
    ('&Align' nil
        (
            ('&Left	Ctrl+Shift+L' alignLeft 'ShiftCtrl+L')
            ('&Top	Ctrl+Shift+T' alignTop 'ShiftCtrl+T')
            ('&Right	Ctrl+Shift+R' alignRight 'ShiftCtrl+R')
            ('&Bottom	Ctrl+Shift+B' alignBottom 'ShiftCtrl+B')
            ('&Center' center:
                (
                    ('&Horizontally	Ctrl+Shift+C' horizontal 'ShiftCtrl+C')
                    ('&Vertically	Ctrl+Alt+Shift+C' vertical 'AltShiftCtrl+C')
                ))
            ('&Distribute' distribute:
                (
                    ('&Horizontally	Ctrl+Shift+D' horizontal 'ShiftCtrl+D')
                    ('&Vertically	Ctrl+Alt+Shift+D' vertical 'AltShiftCtrl+D')
                ))
            separator
            ('&Move By Pixel' doByPixel:
                (
                    ('&Up	Ctrl+Up' moveSelectionUp 'Ctrl+17')
                    ('&Down	Ctrl+Down' moveSelectionDown 'Ctrl+18')
                    ('&Left	Ctrl+Left' moveSelectionLeft 'Ctrl+21')
                    ('&Right	Ctrl+Right' moveSelectionRight 'Ctrl+23')
                ))
            ('&Size By Pixel' doByPixel:
                (
                    ('&Up	Ctrl+Shift+Up' sizeSelectionUp 'ShiftCtrl+17')
                    ('&Down	Ctrl+Shift+Down' sizeSelectionDown 'ShiftCtrl+18')
                    ('&Left	Ctrl+Shift+Left' sizeSelectionLeft 'ShiftCtrl+21')
                    ('&Right	Ctrl+Shift+Right' sizeSelectionRight 'ShiftCtrl+23')
                ))
        ))
    ('&Size' nil
        (
            ('&Auto Size Selection	Ctrl+Shift+A' autosize 'ShiftCtrl+A')
            separator
            ('Replicate &Width	Ctrl+Shift+W' replicateWidth 'ShiftCtrl+W')
            ('Replicate &Height	Ctrl+Shift+H' replicateHeight 'ShiftCtrl+H')
            separator
            ('&Set Window Size...	' setWindowSize '')
            ('Set Window &Position...	' setWindowPosition '')
        ))
    ('&Options' nil
        (
            ('&Grid Size...' setGridSize '')
            ('&Draw Grid' setDrawGrid '')
            separator
            ('&Auto Save' autoSave '')
            ('&Auto Size' autoSizeToggle '')
            ('&Zoom Layout	Alt+Z' zoomLayout 'Alt+Z')
            separator
            ('Add-&In Manager...' addInManager '')
        ))
    ('&Scrapbook' nil
        (
            ('&Store...' scrapbookStore '')
            ('&Retrieve...' scrapbookRetrieve '')
            separator
            ('&New' scrapbookNew '')
            ('&Load...' scrapbookLoad '')
            ('&Merge...' scrapbookMerge '')
            ('Sa&ve...' scrapbookSave '')
            separator
            ('&Quick Reference' scrapbookQuickReference: ())
        ))
    ('A~dd' nil
        (
            ('~Text' add:
                (
                    ('~StaticText' 'StaticText' '')
                    ('~EntryField' 'EntryField' '')
                    ('EnhancedEntry~Field' 'EnhancedEntryField' '')
                    ('~TextEdit' 'TextEdit' '')
                    ('Text~Pane' 'TextPane' '')
                ))
            ('~Button' add:
                (
                    ('~Button' 'Button' '')
                    ('~DrawnButton' 'DrawnButton' '')
                    ('~RadioButton' 'RadioButton' '')
                    ('~CheckBox' 'CheckBox' '')
                    ('~ThreeStateButton' 'ThreeStateButton' '')
                    ('~LinkButton' 'LinkButton' '')
                    ('~ActionButton' 'ActionButton' '')
                ))
            ('~List' add:
                (
                    ('~ListBox' 'ListBox' '')
                    ('List~Pane' 'ListPane' '')
                    ('~MultipleSelectListBox' 'MultipleSelectListBox' '')
                    ('~ComboBox' 'ComboBox' '')
                ))
            ('~Valuator' add:
                (
                    ('~Horizontal Scroll Bar' 'WBHorizontalScrollBar' '')
                    ('~Vertical Scroll Bar' 'WBVerticalScrollBar' '')
                ))
            ('~Group' add:
                (
                    ('~GroupBox' 'GroupBox' '')
                    ('~StaticBox' 'StaticBox' '')
                ))
            ('~Misc' add:
                (
                    ('~StaticGraphic' 'CPStaticGraphic' '')
                    ('~GraphPane' 'GraphPane' '')
                    ('~AnimationPane' 'AnimationPane' '')
                    ('~WBToolBar' 'WBToolBar' '')
                    ('Status~Pane' 'StatusPane' '')
                ))
            ('~Composite' add:
                (
                    ('~RadioButtonGroup' 'RadioButtonGroup' '')
                    ('~CheckBoxGroup' 'CheckBoxGroup' '')
                    ('~EntryFieldGroup' 'EntryFieldGroup' '')
                    ('~SexPane' 'SexPane' '')
                ))
            separator
            ('&Custom Panes' add: ())
            ('~Add Custom Pane...' addCustomPane '')
            ('~Remove Custom Pane...' removeCustomPane '')
        ))
    )!  
wbMenus
    | menus |
    menus := self propertyAt: #WBMenus.
    menus isNil
        ifTrue: [
            menus := self wbMenuArray asOrderedCollectionRecursively.
            self propertyAt: #WBMenus put: menus ].
    ^menus!  
windowBuilderMenu

    | menu menuName |

    menuName := PWindowBuilder menuName.
    menu := Menu new.
    menu
        owner: PWindowBuilder;
        title: menuName;
        appendItem: 'New ~Window	Ctrl+W' selector: #newWindowBuilder accelKey: $w accelBits: AfControl | AfChar;
        appendItem: 'New ~Dialog	Ctrl+L' selector: #newDialogWindowBuilder accelKey: $l accelBits: AfControl | AfChar;
        appendItem: '~Edit Window...	Ctrl+E' selector: #editWindow accelKey: $e accelBits: AfControl | AfChar;
        appendSeparator.

    (Smalltalk includesKey: #CPBitmapManager) ifTrue: [
        menu
            appendItem: 'Launch ~BitmapManager	Ctrl+B' selector: #launchBitmapManager accelKey: $b accelBits: AfControl | AfChar;
            appendSeparator.
    ].

    menu
        appendItem: '~About ',menuName,'...' selector: #aboutWB.

    ^menu! !

! WindowBuilder methods !
aboutWB

    WBAboutDialog new open!
activateClassBrowserOnClass:  aClass

    | chb |

    chb := Notifier windows values detect: [:w |
        w isApplicationWindow and: [
             (w owner isWBClassBrowser) and: [
                w owner selectedClass == aClass
            ].
        ].
    ] ifNone: [ nil ].

    chb notNil ifTrue: [
        chb := chb owner.

        "Make sure the open method gets refreshed"

        chb mainView minimized ifTrue: [
            UserLibrary openIcon: chb mainView asParameter
        ] ifFalse: [
            chb mainView bringToTop.
        ].

       (chb textModified) ifFalse: [
            chb
                changed: #selectors:
                with: #restoreSelected:
                with: chb selectedMethod;
                changed: #text:.
        ].
        ^self
    ].

    ^nil!  
activated: ignore

    (self mainView isHandleOk) ifFalse: [
        ^self
    ].

    self drawGrid ifTrue: [
        (self menuTitled: 'Options') checkItem: #setDrawGrid.
    ] ifFalse: [
        (self menuTitled: 'Options') uncheckItem: #setDrawGrid.
    ].!   
add: paneName

    | addPane className message |

    className := paneName reject: [ :c | c = $~ ].

    className = 'ArrowTool' ifTrue: [
        ^mainPane loadCursor: nil
    ].

    (Smalltalk includesKey: className asSymbol) ifFalse: [
        ^MessageBox messageNote: 'The class ', className, ' is not in this image.  You must file it in first.'
    ].
    className = editedClass name ifTrue: [
        ^MessageBox messageNote: 'You cannot add ',className,' to itself. This would result in infinite recursion.'
    ].

    addPane := (mainPane pseudoClassFor: className) exampleFrom: className.
    addPane isComposite & mainPane editedPane isDialog ifTrue: [
        MessageBox messageNote:
        'Sorry. WindowDialogs do not support nested tabbing within children (including GroupPanes and CompositePanes). Create your window as a subclass of WBDialogWindow instead.'
    ].

    mainPane loadCursor: addPane.!  
addCustomPane

    | newPaneClass aName |

    (newPaneClass :=  (WBChoosePaneDialog new classList:
        (SubPane allSubclasses reject: [ :c | c isWBInternalClass ])) result) isNil ifTrue: [
        ^self
    ].

    (self customPanes includes: newPaneClass name) ifFalse: [
        aName := newPaneClass name.
        self customPanes add: aName.
        customSubMenu
            insertItemDynamically: aName
            selector: aName
            atIndex: customSubMenu numberOfItems + 1.
    ].

    self updateRemoveCustomPane.

    self add: newPaneClass name!
addInManager

    WBAddInManager new open!  
alignBottom

    mainPane alignBottom.! 
alignCenterHorizontal

    mainPane alignCenterHorizontal.! 
alignCenterVertical

    mainPane alignCenterVertical.! 
alignDistributeHorizontal

    mainPane alignDistributeHorizontal.! 
alignDistributeVertical

    mainPane alignDistributeVertical.! 
alignLeft

    mainPane alignLeft!  
alignRight

    mainPane alignRight.!   
alignTop

    mainPane alignTop.!   
attributesHaveChanged

    mainPane
        hideSelectionDots;
        disableSelectionDots.

    thePane isFrameObject ifTrue: [
        mainPane
            hideSizeDot;
            hideWindow;
            reframeAll;
            showWindow.
    ] ifFalse: [
        mainPane redisplaySelection.
    ].

    mainPane
        enableSelectionDots;
        showSelectionDots.

    thePane isFrameObject ifTrue: [
        mainPane
            showSizeDot.
    ].

    self mainPaneChanged: true.!   
autosize

    mainPane autosizeSelection.
    self updateSizeAndPosition.! 
autoSave

    autoSave ifTrue: [
        (self menuTitled: 'Options') uncheckItem: #autoSave.
    ] ifFalse: [
        (self menuTitled: 'Options') checkItem: #autoSave.
    ].

    autoSave := autoSave not.!  
autoSize
    | autoSize |
    "Get AutoSize property from WindowBuilder"
    autoSize := self class propertyAt: #AutoSize.
    autoSize isNil ifTrue: [ self autoSize: false ].
    ^autoSize!   
autoSize: bool
    "Store into AutoSize property of WindowBuilder"
    self class propertyAt: #AutoSize put: bool.! 
autoSizeMenu

    self autoSize ifFalse: [
        (self menuTitled: 'Options') uncheckItem: #autoSizeToggle.
    ] ifTrue: [
        (self menuTitled: 'Options') checkItem: #autoSizeToggle.
    ].!  
autoSizeToggle

    self autoSize: self autoSize not.
    self autoSizeMenu.!  
bringToFront

    mainPane bringToFront!
buildMenus
    "Build WindowBuilder's menu bar"
    | menus mw aMenu aSubMenu |
    menus := self class wbMenus.
    mw := self mainView menuWindow.
    menus do: [ :m |
        aMenu := Menu new.
        aMenu
            title: (m at: 1);
            owner: self.
        (m at: 3) do: [ :mi |
            mi == #separator
                ifTrue: [ aMenu appendSeparator ]
                ifFalse: [
                    (mi at: 3) isString
                        ifTrue: [
                            aMenu
                                appendItem: (mi at: 1)
                                selector: (mi at: 2)
                                acceleratorString: (mi at: 3)]
                        ifFalse: [
                            aSubMenu := Menu new.
                            aSubMenu
                                title: (mi at: 1);
                                owner: self.
                            (mi at: 2) isNil
                                ifFalse: [ aSubMenu selector: (mi at: 2)].
                            (mi at: 3) do: [ :msi |
                                msi == #separator
                                    ifTrue: [ aSubMenu appendSeparator ]
                                    ifFalse: [
                                        aSubMenu
                                            appendItem: (msi at: 1)
                                            selector: (msi at: 2)
                                            acceleratorString: (msi at: 3)]].
                            aMenu
                                appendSubMenu: aSubMenu]]].
        mw addMenu: aMenu]!  
center: horizOrVert

    (horizOrVert first = $h) ifTrue: [
        mainPane alignCenterHorizontal.
    ] ifFalse: [
        mainPane alignCenterVertical.
    ].!  
changed

    ^changed!  
changed: bool

    changed := bool.!
checkIfSaveChanges: title

    | result |

    (self changed) ifTrue: [
        result := MessageBox yesNoCancelTitled: title text: 'Save changes before proceeding?'.
        (result isNil) ifTrue: [
            ^false
        ].

        (result == #yes) ifTrue: [
            self save isNil ifTrue: [
                ^false
            ].
        ].
    ].

    ^true!  
clear

    mainPane clear!  
close

    (self checkIfSaveChanges: 'Exiting WindowBuilder') ifFalse: [
        ^self
    ].
    self mainView parent isNil ifFalse: [
        self mainView parent mainView bringToTop
    ].
   super close.!  
close: ignore

    "Detect that Smalltalk is shutting down. Prevent our
     Save Changes query from coming up at shutdown. "
    Transcript isNil ifTrue: [
        ^nil
    ].

    (self checkIfSaveChanges: 'Exiting WindowBuilder') ifFalse: [
        ^self
    ].
    self mainView parent isNil ifFalse: [
        self mainView parent isMDIClient ifFalse: [
            self mainView parent mainView bringToTop
        ].
    ].

    ^nil! 
copy

    self enable: #(paste) inMenu: 'Edit'.
    mainPane copy! 
createNew

    (self checkIfSaveChanges: 'New Window') ifTrue: [
        WBScratchWindow resetToDefault.
        self editClass: WBScratchWindow.
    ].!
createNewComposite

    self copy.
    PWindowBuilder new newCompositePaneFrom: self!  
createNewCompositePane

    (self checkIfSaveChanges: 'New Composite Pane') ifTrue: [
        WBCompositePaneScratchWindow resetToDefault.
        self editClass: WBCompositePaneScratchWindow.
    ].! 
createNewDialog

    (self checkIfSaveChanges: 'New Dialog') ifTrue: [
        WBDialogScratchWindow resetToDefault.
        self editClass: WBDialogScratchWindow.
    ].!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'WindowBuilder: [Untitled]';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1426 @ 904; xC; yC; cRDU: (9 @ 896 rightBottom: 1417 @ 46));
            pStyle: #(sysmenu minimize maximize sizable titlebar);
            when: #close perform: #close:;
            when: #activate perform: #activated:;
            backColor: ClrPalegray;
            addSubpane: (
                WB3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1408 @ 36; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 36 r: #bottom; bDU: 0 r: #bottom);
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                WB3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 169 @ 44; lDU: 178 r: #right; rDU: 9 r: #right; tDU: 194 r: #bottom; bDU: 150 r: #bottom);
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                WB3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 169 @ 44; lDU: 352 r: #right; rDU: 183 r: #right; tDU: 194 r: #bottom; bDU: 150 r: #bottom);
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1408 @ 2; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 38 r: #bottom; bDU: 36 r: #bottom);
                    blackFrame;
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 2 @ 760; lDU: 142 r: #left; rDU: 144 r: #left; tDU: 52 r: #top; bDU: 38 r: #bottom);
                    blackFrame;
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 32; lDU: 151 r: #left; rDU: 251 r: #left; tDU: 134 r: #bottom; bDU: 102 r: #bottom);
                    paneName: 'styleText';
                    rightJustified;
                    startGroup;
                    contents: 'Style:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 32; lDU: 151 r: #left; rDU: 251 r: #left; tDU: 86 r: #bottom; bDU: 54 r: #bottom);
                    paneName: 'nameText';
                    rightJustified;
                    startGroup;
                    contents: 'Name:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; rDU: 489 r: #right; bDU: 102 r: #bottom);
                    paneName: 'whenText';
                    rightJustified;
                    startGroup;
                    contents: 'When:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; rDU: 489 r: #right; bDU: 50 r: #bottom);
                    paneName: 'performText';
                    rightJustified;
                    startGroup;
                    contents: 'Perform:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 160 r: #left; rDU: 251 r: #left; tDU: 186 r: #bottom; bDU: 154 r: #bottom);
                    paneName: 'titleText';
                    rightJustified;
                    startGroup;
                    contents: 'Text:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                WBToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 286 @ 44; lDU: 640 r: #right; rDU: 354 r: #right; tDU: 194 r: #bottom; bDU: 150 r: #bottom);
                    paneName: 'attributePalette';
                    useSystem: true;
                    add: #setFont:;
                    add: #setColor:;
                    add: #setFraming:;
                    add: #setMenu:;
                    add: #other:;
                    postAutomatic;
                    startGroup;
                    when: #showHelp perform: #paletteHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                WBMultiToolPalette new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 69 @ 688; lDU: 73 r: #left; rDU: 142 r: #left; tDU: 60 r: #top; bDU: 102 r: #bottom);
                    paneName: 'toolPalette';
                    startGroup;
                    when: #gettingFocus perform: #resetFocus:;
                    when: #select perform: #newTool:;
                    when: #selecting perform: #newToolMessage:;
                    when: #doubleClick perform: #placeCentered:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                WBToolPalette new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 69 @ 688; lDU: 5 r: #left; rDU: 73 r: #left; tDU: 60 r: #top; bDU: 102 r: #bottom);
                    paneName: 'groupPalette';
                    startGroup;
                    when: #gettingFocus perform: #resetFocus:;
                    when: #selecting perform: #newPaneType:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                WBToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1408 @ 44; lDU: 0 r: #left; rDU: 0 r: #right; tDU: 4 r: #top);
                    paneName: 'toolBar';
                    useSystem: true;
                    add: #testWindow spaces: 3;
                    add: #createNew spaces: 4;
                    add: #createNewDialog;
                    add: #openNew;
                    add: #save;
                    add: #cut spaces: 4;
                    add: #copy;
                    add: #paste;
                    add: #clear;
                    add: #sendToBack spaces: 4;
                    add: #bringToFront;
                    add: #duplicate;
                    add: #autosize spaces: 4;
                    add: #replicateWidth;
                    add: #replicateHeight;
                    add: #alignLeft spaces: 4;
                    add: #alignCenterHorizontal;
                    add: #alignRight;
                    add: #alignTop spaces: 2;
                    add: #alignCenterVertical;
                    add: #alignBottom;
                    add: #alignDistributeVertical spaces: 2;
                    add: #alignDistributeHorizontal;
                    add: #setDrawGrid spaces: 4 rbSelector: #popupGridSize:;
                    postAutomatic;
                    startGroup;
                    when: #showHelp perform: #paletteHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                DrawnButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 32; lDU: 347 r: #right; rDU: 311 r: #right; tDU: 190 r: #bottom; bDU: 158 r: #bottom);
                    paneName: 'positionButton';
                    startGroup;
                    when: #clicked perform: #setWindowPosition:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 28; lDU: 302 r: #right; rDU: 192 r: #right; tDU: 182 r: #bottom; bDU: 154 r: #bottom);
                    paneName: 'position';
                    startGroup;
                    contents: '0, 0';
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                DrawnButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 32; lDU: 174 r: #right; rDU: 137 r: #right; tDU: 190 r: #bottom; bDU: 158 r: #bottom);
                    paneName: 'sizeButton';
                    startGroup;
                    when: #clicked perform: #setWindowSize:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 28; lDU: 128 r: #right; rDU: 18 r: #right; tDU: 182 r: #bottom; bDU: 154 r: #bottom);
                    paneName: 'size';
                    startGroup;
                    contents: '0 x 0';
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 142 @ 2; lDU: 0 r: #left; rDU: 142 r: #left; tDU: 52 r: #top; bDU: 54 r: #top);
                    blackFrame;
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                WBToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 56; lDU: 5 r: #left; rDU: 137 r: #left; tDU: 98 r: #bottom; bDU: 42 r: #bottom);
                    paneName: 'editPalette';
                    useSystem: true;
                    add: #editAppCode;
                    add: #editTabbing spaces: 3;
                    postAutomatic;
                    startGroup;
                    when: #showHelp perform: #paletteHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1390 @ 28; lDU: 9 r: #left; rDU: 9 r: #right; tDU: 32 r: #bottom; bDU: 4 r: #bottom);
                    paneName: 'status';
                    startGroup;
                    contents: '';
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                WBScrollingPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 1266 @ 600; lDU: 142 r: #left; rDU: 0 r: #right; tDU: 52 r: #top; bDU: 198 r: #bottom);
                    paneName: 'scrollingPane';
                    startGroup;
                    foreColor: ClrWhite;
                    backColor: ClrWhite;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 489 @ 48; lDU: 261 r: #left; rDU: 658 r: #right; tDU: 194 r: #bottom; bDU: 146 r: #bottom; indent: 3 @ 4);
                    paneName: 'titleEditor';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #textChanged:;
                    foreColor: ClrBlack;
                    backColor: ClrWhite;
                    yourself
            );
            addSubpane: (
                WBComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 489 @ 184; lDU: 261 r: #left; rDU: 658 r: #right; tDU: 142 r: #bottom);
                    paneName: 'styleEditor';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #select perform: #setStyle:;
                    backColor: ClrWhite;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 489 @ 48; lDU: 261 r: #left; rDU: 658 r: #right; tDU: 90 r: #bottom; bDU: 42 r: #bottom; indent: 3 @ 4);
                    paneName: 'instVar';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #symbolNameChanged:;
                    backColor: ClrWhite;
                    yourself
            );
            addSubpane: (
                WBComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 471 @ 244; lDU: 480 r: #right; rDU: 9 r: #right; tDU: 142 r: #bottom);
                    paneName: 'when';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #select perform: #when:;
                    backColor: ClrWhite;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 471 @ 48; lDU: 480 r: #right; rDU: 9 r: #right; tDU: 90 r: #bottom; bDU: 42 r: #bottom; indent: 3 @ 4);
                    paneName: 'perform';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #performTextChanged:;
                    backColor: ClrWhite;
                    yourself
            );
        yourself
    ).!
currentEvent

    | event |

    event := currentWhen.
    event isNil ifTrue: [ ^nil ].
    (event at: 1) = $* ifTrue: [
        event := event copyFrom: 2 to: event size.
    ].

    ^event asSymbol!   
customPanes

    CustomPanes isNil ifTrue: [
        CustomPanes := SortedCollection new.
    ].

    ^CustomPanes! 
cut

    self enable: #(paste) inMenu: 'Edit'.
    mainPane cut!   
declareMethod: aMethodName commentString: commentString

    | methodStream result resultString |

    methodStream := ReadWriteStream on: String new.

    methodStream
        nextPutAll: (self methodHeaderFor: aMethodName); cr; cr;
        nextPutAll: '    "', commentString; cr;
        nextPutAll: '     (Generated by WindowBuilder)"'.

    resultString := methodStream contents.

    "Consolidate all code creation"
    PWindowBuilder
        createMethod: resultString
        in: editedClass
        loggingSource: true!  
disable: aCollection inMenu: aString
    | menu |
    menu := self menuTitled: aString.
    menu isNil ifTrue: [ menu := self mainView menuWindow wbMenuTitled: aString ].
    aCollection do: [ :item |
        menu disableItem: item.
        toolBar disableItem: item ].!  
distribute: horizOrVert

    (horizOrVert first = $h) ifTrue: [
        mainPane alignDistributeHorizontal.
    ] ifFalse: [
        mainPane alignDistributeVertical.
    ].!  
doByPixel: selector

    mainPane doByPixel: selector.! 
drawGrid
    | drawGrid |
    "Get DrawGrid property from WindowBuilder"
    drawGrid := self class propertyAt: #DrawGrid.
    drawGrid isNil ifTrue: [ self drawGrid: false ].
    ^drawGrid!   
drawGrid: bool
    "Store into DrawGrid property of WindowBuilder"
    self class propertyAt: #DrawGrid put: bool.
    mainPane display.!  
duplicate

    mainPane duplicate!  
editAppCode

    editedClass isScratchWindow
        ifTrue: [ self saveAs isNil ifTrue: [ ^nil ]].

    self tryToSaveChanges.

    (self activateClassBrowserOnClass: editedClass) isNil ifTrue: [
        ClassHierarchyBrowser new openSelecting: editedClass.
    ].!   
editClass: aTopPaneClass

    "The windows are built.  Set this thing up to edit a new class (either at start or in open...)."

    | editedPane temp |

    editedClass := aTopPaneClass.

    self labelWithoutPrefix: self label.

    (editedClass isScratchWindow) ifTrue: [
        cleanedOutCode := false.
        editedPane := mainPane editClass: editedClass defaultClass.
        self disable: #(editAppCode) inMenu: 'File'.
    ] ifFalse: [
        temp := mainPane editClass: editedClass.
        temp isNil ifTrue: [
            WBScratchWindow resetToDefault.
            self editClass: WBScratchWindow.
            ^nil
        ].
        editedPane := temp.
        self enable: #(editAppCode) inMenu: 'File'.
    ].

    (self menuTitled: 'View') disableAll.
    (editedPane isDialog or: [editedPane isCompositePane]) ifFalse: [
        (mainPane views size = 1) ifTrue: [
            (self menuTitled: 'View') enableItem: #viewCreate.
        ] ifFalse: [
            (self menuTitled: 'View') enableAll.
        ].
    ].

    editedPane isDialog ifTrue: [
        self enable: #(exportToResFile) inMenu: 'File'.
    ] ifFalse: [
        self disable: #(exportToResFile) inMenu: 'File'.
    ].

    self reinitWindowBuilder.

    "Check if clipboard is an object pasteable (is that a word?) for us"
    ((mainPane clipboard isArray) not or: [ mainPane clipboard size ~= 2 ]) ifTrue: [
        self disable: #(paste) inMenu: 'Edit'.
    ].

    self sendInputEvent: #changed:  with: false.

    self disable: #(save) inMenu: 'File'.
    self disable: #(createNewComposite ungroupComposite) inMenu: 'Composite Panes'.
    autoSave isNil ifTrue: [
        autoSave := false.
        self autoSave.
    ].! 
editTabbing

    | result |

    (result := (WBTabEditor new openOn: mainPane editedPane subpanes: mainPane exportedPanes) result) notNil ifTrue: [
        mainPane setPanes: result.
        self mainPaneChanged: true.
        mainPane unselectAll.
        mainPane invalidateRect: nil.
    ].!   
enable: aCollection inMenu: aString
    | menu |
    menu := self menuTitled: aString.
    menu isNil ifTrue: [ menu := self mainView menuWindow wbMenuTitled: aString ].
    aCollection do: [ :item |
        menu enableItem: item.
        toolBar enableItem: item ].! 
eventSummary

    | v className |

    className := editedClass isScratchWindow ifTrue: [
        'Untitled'
    ] ifFalse: [
        editedClass name
    ].
    v := TextEditWindow new.
    v labelWithoutPrefix: 'Event Summary [', className, ']'.
    v openOn: mainPane eventsSummaryString.!   
exportToResFile

    | fName |

    fName := (FileDialog new saveFile:
        (File
            fileName: editedClass name
            extension: (String with: $r with: $e with: $s))) file.

    fName notNil ifTrue: [
        mainPane exportToResFile: fName.
    ].!
fillInPerform

    | selector |


    thePane supportedEvents isEmpty  ifFalse: [
        currentWhen := when selectedItem.
    ] ifTrue: [
        currentWhen := #none.
        perform contents: ''.
    ].

    selector := thePane handlers at: self currentEvent ifAbsent: [ '' ].

    perform contents: selector asString.! 
generateCode

    | editedPane mdiAttributes firstArg methodStream paneList mdi openMethodType |

    CursorManager execute change.

    editedPane := mainPane editedPane.
    mdiAttributes := mainPane mdiAttributes.
    firstArg := self class firstArg.

    methodStream := WriteStream on: String new.
    methodStream nextPutAll: self openMethodHeaderText.

    (mdi := ((Smalltalk includesKey: #MDIViewManager) and: [ editedPane realClass inheritsFrom: (Smalltalk at: #MDIViewManager) ])) ifTrue: [
        methodStream cr; cr;
            nextPutAll: '    ',firstArg,' addView: ('; cr;
            nextPutAll: '        ',firstArg,' frame: (MDIFrame new'; cr;
            nextPutAll: '            owner: ',firstArg,';'; cr.
        self writeHandlers: mdiAttributes frameEvents on: methodStream.
        methodStream
            nextPutAll: '            labelWithoutPrefix: ', mdiAttributes label asQuotedString; cr;
            nextPutAll: '        )'; cr;
            nextPutAll: '    ).'.

        mdiAttributes hasToolPane ifTrue: [
            methodStream cr; cr;
                nextPutAll: '    ',firstArg,' addSubpane: ('; cr;
                nextPutAll: '        ToolPane new'; cr.
            self writeHandlers: mdiAttributes toolPaneEvents on: methodStream.
            methodStream
                nextPutAll: '            owner: ',firstArg; cr;
                nextPutAll: '    ).'.
        ].
        mdiAttributes hasStatusPane ifTrue: [
            methodStream cr; cr;
                nextPutAll: '    ',firstArg,' addSubpane: ('; cr;
                nextPutAll: '        StatusPane new'; cr.
            self writeHandlers: mdiAttributes statusPaneEvents on: methodStream.
            methodStream
                nextPutAll: '            owner: ',firstArg; cr;
                nextPutAll: '    ).'.
        ].
    ].

    editedPane children: mainPane panes.
    mainPane views do: [:v |

        methodStream cr; cr;
        nextPutAll: '    ',firstArg,' addView: ('; cr;
        nextPutAll: '        v := '.

    paneList := mainPane sortInZorder: v children.

        paneList := paneList reversed.

    v storeOn: methodStream indentString: '            ' mdi: mdi.
    methodStream nextPutAll: ';'; cr.
    paneList do: [:p |
        methodStream nextPutAll: '            addSubpane: (' ; cr.
        p storeOn: methodStream  indentString: '                '.
        methodStream cr; nextPutAll: '            );'; cr.
    ].
    methodStream
        nextPutAll: '        yourself'; cr;
        nextPutAll: '    ).'.

    (v menu notNil) ifTrue: [
        methodStream cr; cr; nextPutAll: '    v menuWindow'; cr.
        methodStream nextPutAll: '        yourself'.
        v menu storeOn: methodStream indentString: '    '.
        methodStream nextPutAll: '.'.
    ].
  ].
    methodStream cr; cr.

    "Support for CompositePanes - #addSubpanes"
    editedPane isCompositePane ifTrue: [
        self class createMethod: methodStream contents
            titled: 'addSubpanes' in: editedPane realClass
            loggingSource: (editedPane realClass isScratchWindow) not.

    "Support for v2.0 #open methods"
    ] ifFalse: [(openMethodType := self class openMethodType) isNil ifTrue: [
        (editedPane isDialog) & (editedPane isModal not) ifTrue: [
            methodStream nextPutAll: '    ',firstArg,' openModeless'.
        ] ifFalse: [
            methodStream nextPutAll: '    ',firstArg,' openWindow'.
        ].
        self class createMethod: methodStream contents
            titled: 'open' in: editedPane realClass
            loggingSource: (editedPane realClass isScratchWindow) not.

    "Support for #createViews"
    ] ifFalse: [
        self class createMethod: methodStream contents
            titled: self openMethodTitle in: editedPane realClass
            loggingSource: (editedPane realClass isScratchWindow) not.
        "Get rid of old #open method if no longer required"
        (mainPane propertyAt: #keepOpenMethod) == true ifFalse: [
            (editedPane realClass includesSelector: #open) ifTrue: [
                editedPane realClass removeSelector: #open
            ].
        ].
    ]].

    editedPane realClass isWBInternalClass ifFalse: [
        self class createMethod: '
    ^true' titled: 'wbCreated' in: editedPane realClass class loggingSource: true.
    ].

    CursorManager normal change.!  
getEditedClass

    | temp |

    (temp := (WBChooseClassDialog new classList: ViewManager wbCreatedClasses) result) notNil ifTrue: [
        editedClass := temp.
        self labelWithoutPrefix: self label.
        ^editedClass
    ].

    ^nil!  
getEditedCompositeClass

    | temp |

    (temp := (WBChooseClassDialog new classList: CompositePane wbCreatedClasses) result) notNil ifTrue: [
        editedClass := temp.
        self labelWithoutPrefix: self label.
        ^editedClass
    ].

    ^nil!   
getPointPrompting: promptString defaultPoint: defaultValue

    | string s point |

    (string := Prompter prompt: promptString default: defaultValue asString) isNil ifTrue: [
        ^nil
    ].

    (string includes: $@) ifTrue: [
        s := ReadStream on: string.
        point := (s upTo: $@) trimBlanks asInteger @ (s upTo: $@) trimBlanks asInteger.
        ^point
    ] ifFalse: [
       MessageBox messageNote: 'Value must be of the form ''x @ y''.'.
    ].

    ^nil!
getValidMethodName: string

    | result |

    result := (string select: [ :c | c isAlphaNumeric ]).

    (result notEmpty and: [ result first isDigit ]) ifTrue: [
        ^nil
    ].

    ^result!  
gridSize
    | gridSize |
    "Get GridSize property from WindowBuilder"
    gridSize := self class propertyAt: #GridSize.
    gridSize isNil ifTrue: [ self gridSize: 1@1 ].
    ^gridSize! 
gridSize: newSize
    | gridSize |
    "Store into GridSize property of WindowBuilder"
    gridSize := (newSize x max: 1) @ (newSize y max: 1).
    self class propertyAt: #GridSize put: gridSize.
    self drawGrid ifTrue: [
        mainPane display.
    ].!  
importFromResFile

    | theClass resFile |

    resFile := FileDialog new
        title: 'Import Resource File:';
        fileSpec: '*.res';
        hideReadonly;
        addFilter: '*.res' description: 'Resource file (*.RES)';
        defFilter: '*.res';
        open;
        file.
    resFile isNil ifFalse: [
        (theClass := mainPane importFromResFile: resFile) notNil ifTrue: [
            editedClass := theClass.
            changed := true.
            self saveInternal.
            self editClass: theClass.
        ].
    ].! 
importFromWindows

    | theClass windowsClasses |

    (windowsClasses := ViewManager allSubclasses select: [:c | c basicNew respondsTo: #addSubpanesTo: ]) isEmpty ifTrue: [
        ^MessageBox messageNote: 'No ViewManager subclasses were generated by WB 1.1.'
    ].

    (theClass := (WBChooseClassDialog new classList: windowsClasses allowOthers: false) result) isNil ifFalse: [
        (theClass := mainPane importWindow: theClass) notNil ifTrue: [
            editedClass := theClass.
            changed := true.
            self saveInternal.
            self editClass: theClass.
        ].
    ].!
initialize

    super initialize.
    changed := false.!   
initializePalettes

    | aFont |

    groupPalette useSystem: true; size: 1@14.
    toolPalette useSystem: true; size: 1@14.
    self toolCollection do: [ :group |
        groupPalette add: group key.
        toolPalette on: group key add: 'ArrowTool'.
        group value do: [ :tool |
            toolPalette on: group key add: tool
        ]
    ].
    toolPalette switchTo: 'Text'.

    aFont := Font new fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 1 2 1 34 72 101 108 118 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 ).
    positionPane font: aFont.
    sizePane font: aFont.
    statusPane font: aFont.

    (self paneNamed: 'sizeButton') contents: (CPBitmapDict sysAt: 'size').
    (self paneNamed: 'positionButton') contents: (CPBitmapDict sysAt: 'position').! 
initInstVars

    titleEditor := self paneNamed: 'titleEditor'.
    styleEditor := self paneNamed: 'styleEditor'.
    name := self paneNamed: 'instVar'.
    perform := self paneNamed: 'perform'.
    when := self paneNamed: 'when'.
    styleText := self paneNamed: 'styleText'.
    titleText := self paneNamed: 'titleText'.
    groupPalette := self paneNamed: 'groupPalette'.
    editPalette := self paneNamed: 'editPalette'.
    toolPalette := self paneNamed: 'toolPalette'.
    attributePalette := self paneNamed: 'attributePalette'.
    toolBar := self paneNamed: 'toolBar'.
    sizePane := self paneNamed: 'size'.
    positionPane := self paneNamed: 'position'.
    statusPane := self paneNamed: 'status'.! 
initMdiWindowSize

    | extent origin |

    extent := ((240@230) / FramingParameters dialogUnit) truncated.
    origin :=(self frame mdiChildren size - 1) * (16 @ 16).
    ^origin extentFromLeftTop: extent.!   
initWindow

    | mainMenu |

    editedClass isNil ifTrue: [
        editedClass := WBScratchWindow.
    ].
    self initInstVars.

    self initializePalettes.

    mainMenu := self mainView menuWindow.

    customSubMenu := mainMenu wbMenuTitled: 'Custom Panes'.

    self updateCustomPanesMenu.
    self updateQuickReferenceMenu.
    self autoSizeMenu.
    self editClass: editedClass.!  
inspectSelection

    (mainPane selection isEmpty) ifTrue: [
        mainPane editedPane inspect.
    ] ifFalse: [
        mainPane selection first inspect.
    ].!
instVarNameCheck
    | instVarNameCheck |
    "Get InstVarNameCheck property from WindowBuilder"
    instVarNameCheck := self class propertyAt: #InstVarNameCheck.
    instVarNameCheck isNil ifTrue: [ self instVarNameCheck: false ].
    ^instVarNameCheck!   
instVarNameCheck: bool
    "Store into InstVarNameCheck property of WindowBuilder"
    self class propertyAt: #InstVarNameCheck put: bool.! 
isMDIClient

    ^false!
isWBWindow

    ^true!  
label

    editedClass isNil | (editedClass isScratchWindow) ifTrue: [
        ^self class labelName,': [Untitled]'
    ] ifFalse: [
        ^self class labelName,': [', editedClass name,']'
    ].!  
layoutPaneClass

    ^WBRealLayoutPane! 
mainPane

    ^mainPane := self layoutPaneClass new
        owner: self;
        paneName: 'mainPane';
        framingBlock: [:b | (b leftTop leftAndUp: 2@2) extentFromLeftTop: 10000@10000 ];
        when: #cursorUnloaded   perform: #panePlaced:;
        when: #selectionChanged perform: #selectionChanged:;
        when: #operationOccurred perform: #undoableOperation:;
        when: #changed                perform: #mainPaneChanged:;
        when: #gettingFocus perform: #resetFocus:;
        when: #editPane perform: #other:;
        when: #rightButtonDown perform: #popupPaneMenu:;
        yourself! 
mainPaneChanged: ignore

    self enable: #(save) inMenu: 'File'.
    self changed: true.! 
mdi

    (Smalltalk includesKey: #MDIViewManager) ifFalse: [
        ^MessageBox message: 'You must install Digitalk''s MDI extensions before using MDI.'
    ].

    (editedClass inheritsFrom: (Smalltalk at: #MDIViewManager)) ifFalse: [
        ^MessageBox message: 'In order to build an MDI application, you must first save your window as a subclass of MDIViewManager.'
    ].

    (mainPane editMDIAttributes) notNil ifTrue: [
        self mainPaneChanged: true.
    ].!  
mdiCommentNameFor: aString event:  eventSymbol

    ^'Callback for the #', eventSymbol asString, ' event in the ', aString, '.'.!   
menuCommentNameFor: aMenuName

    ^'Callback for the menu item titled ', aMenuName stripMnemonic asQuotedString, '.'.! 
message: aString
    aString isNil ifTrue: [
        self statusPane showHelp: ''
    ] ifFalse: [
        self statusPane showHelp: aString
    ].! 
methodHeaderFor: aSelectorString

    (aSelectorString includes: $:) ifTrue: [
        ^aSelectorString, ' aPane'
    ] ifFalse: [
        ^aSelectorString
    ].! 
minWindowSize

  ^((210@180) / FramingParameters dialogUnit) truncated! 
mutate

    ^self mutate: #other!   
mutate: mutationType
    | newPane oldPane newPaneClass |

    mutationType == #other ifTrue: [
        (newPaneClass :=  (WBChoosePaneDialog new classList:
            (SubPane allSubclasses reject: [ :c | c isWBInternalClass ])) result) isNil ifTrue: [
            ^self
        ].
        newPane := thePane mutateTo: newPaneClass name asSymbol.
    ] ifFalse: [
        newPane := thePane mutateTo: mutationType.
    ].
    newPane isNil ifFalse: [
        oldPane := thePane.
        self pane: newPane.
        oldPane become: newPane.
        self pane: oldPane.
        mainPane display.
        self mainPaneChanged: true.
    ]! 
newCompositePaneFrom: aWindowBuilder

    editedClass := WBCompositePaneScratchWindow.
    self openWithParent: aWindowBuilder.
    mainPane placeLoadedPanesAtLeftTop.
    self mainView propertyAt: #creatingNewComposite put: true.
    self sendInputEvent: #changed: with: true.!  
newPaneType: palette
    | selector |
    CursorManager normal change.
    toolPalette
        switchTo: (selector := palette selectorAt: palette currentIndex).
    self message: (self statusPaneHelp: selector).
    mainPane loadCursor: nil.!  
newTool: palette

    self add: palette selector.!  
newToolMessage: palette
    | selector message |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [ ^nil ].
    selector = 'ArrowTool' ifTrue: [
        message := 'Use the arrow to select a pane for further editing.'.
    ] ifFalse: [
        message := 'Load the cursor with a ',selector,'.'
    ].
    self message: message.! 
openCompositePane: aCompositePaneClass from: aWindowBuilder

    editedClass := aCompositePaneClass.
    self openWithParent: aWindowBuilder.! 
openDialog

    editedClass := WBDialogScratchWindow.
    self open.!  
openMethodExtraArgs

    ^self class openMethodArgs inject: '' into: [ :a :b |
            b = 'self' ifTrue: [ a ] ifFalse: [ a,b,' ' ]]! 
openMethodHeaderText
    | text initCode |
    text := '
     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v ',self openMethodExtraArgs,'|'.
    ^(initCode := self class openMethodInitCode) isNil
        ifFalse: [ text, initCode ]
        ifTrue: [ text ]!  
openMethodTitle
    | openMethodType numArgs stream |
    openMethodType := self class openMethodType asString.
    numArgs := openMethodType occurrencesOf: $:.
    numArgs = 0 ifTrue: [ ^openMethodType ].
    numArgs = 1 ifTrue: [ ^openMethodType,' arg1' ].
    numArgs = 2 ifTrue: [
        stream := openMethodType asStream.
        ^(stream upTo: $:),': arg1 ',(stream upTo: $:),': arg2'
    ].
    ^self error: 'Can''t write more than two arguments'! 
openNew

    (self checkIfSaveChanges: 'Open Window') ifTrue: [
        (self getEditedClass) notNil ifTrue: [
            self editClass: editedClass.
        ].
    ].!  
openNewComposite

    (self checkIfSaveChanges: 'Open Composite') ifTrue: [
        (self getEditedCompositeClass) notNil ifTrue: [
            self editClass: editedClass.
        ].
    ].! 
openOn: appWindowClass

    editedClass := appWindowClass.

    self open.!   
other: ignore

    | c |

    (thePane isCompositePane and: [Notifier isAltDown not])  ifTrue: [
        PWindowBuilder new openCompositePane: thePane realClass from: self.
        ^nil
    ].
    (thePane hasOtherEditor) ifTrue: [
        (c := (thePane attributeEditor openOn: thePane) result) notNil ifTrue: [
            c fullCopyTo: thePane.
            (c changesTitle) ifTrue: [
                titleEditor contents: c text.
            ].
            self attributesHaveChanged.
            (c changesSize) ifTrue: [
                self autosize.
                self updateEvents: false.
            ].
        ].
    ].!  
paletteHelp: palette
    | selector |
    selector := palette selectorAt: palette currentIndex.
    self message: (self statusPaneHelp: selector asString).!   
pane: aPane

    | message |

    self disable: #(createNewComposite) inMenu: 'Composite Panes'.
    mainPane selection size > 1 ifTrue: [
        message := 'Multiple panes selected. The first is ',(self subpaneNameString: aPane), '.'.
        self enable: #(createNewComposite) inMenu: 'Composite Panes'.
    ] ifFalse: [ aPane == mainPane editedPane ifTrue: [
        (aPane contents isNil or: [ aPane contents isEmpty ]) ifTrue: [
            aPane isCompositePane ifTrue: [
                message := 'This is an untitled CompositePane.'
            ] ifFalse: [
                message := 'This is an untitled window.'
            ].
        ] ifFalse: [
            aPane isCompositePane ifTrue: [
                message := 'This is a CompositePane titled ',aPane contents asQuotedString,'.'
            ] ifFalse: [
                message := 'This is a window titled ',aPane contents asQuotedString,'.'
            ].
        ]
    ] ifFalse: [
        message := 'This is ', (self subpaneNameString: aPane), '.'
    ]].
    self message: message.

    (aPane == thePane) ifTrue: [
        ^self
    ].

    thePane := aPane.

    "Title"
    self updateTitle: thePane.

    "Name"
    thePane paneName isNil ifFalse: [
        name contents: thePane paneName
    ] ifTrue: [
        name contents: ''.
    ].

    "Events"
    self updateEvents: false.
    when selection: 1.
    self fillInPerform.

    "Style"
    thePane styles isNil ifTrue: [
        styleEditor
            contents: #(' ');
            selection: ' ';
            disable.
        styleText disable.
    ] ifFalse: [
        styleEditor
            contents: thePane styles;
            selection: thePane style;
            enable.
        styleText enable.
    ].

    "Composite Stuff"
    thePane isCompositePane ifTrue: [
        self enable: #(ungroupComposite) inMenu: 'Composite Panes'.
    ] ifFalse: [
        self disable: #(ungroupComposite) inMenu: 'Composite Panes'.
    ].

    self setStatus: attributePalette.

    self updateSizeAndPosition.

    self resetFocus: nil.!
panePlaced: ignore

    toolPalette selectItem: (toolPalette elementAtSelector: 'ArrowTool').!  
paste

    mainPane paste!  
pasteWindowBitmapToClipboard

    Clipboard setBitmap: mainPane layoutAsBitmap! 
performTextChanged: aPane

    (self getValidMethodName: aPane contents) = (thePane handlers at: self currentEvent ifAbsent: ['']) asString ifTrue: [
        ^self
    ].

    self saveWhenPerform.
    self mainPaneChanged: nil.!  
placeCentered: palette

    "Happens on doubleclick in palette.  Assumes select
     happened first"

    mainPane placeLoadedPane.! 
popupGridSize: aPane

    | selection labels gridLabel menu |
    labels := #('Grid Off' '2 x 2' '3 x 3' '4 x 4' '5 x 5' '6 x 6' '8 x 8' '10 x 10').
    gridLabel := self gridSize x.
    gridLabel = 1
        ifTrue: [ gridLabel := 'Grid Off']
        ifFalse: [ gridLabel := gridLabel asString,' x ',gridLabel asString ].

    (menu := Menu new
        labels: labels
        lines: #(1)
        selectors: labels)
            checkItem: gridLabel.
    aPane setPopupMenu: menu.
    selection := menu popUpIn: aPane.
    selection isNil ifTrue: [ ^nil ].
    (gridLabel := selection upTo: 'x') = 'Grid Off'
        ifTrue: [ self drawGrid: false; gridSize: 1@1 ]
        ifFalse: [ self gridSize: gridLabel asInteger @ gridLabel asInteger ]! 
popupPaneMenu: layoutPane

    | selection newSelection menu subMenu list |

    newSelection := layoutPane selection.

    newSelection isEmpty ifTrue: [
        menu := Menu new
            labels: #('Font' 'Color' 'Framing' 'Menubar' 'Window')
            lines: #()
            selectors: #(setFont: setColor: setFraming: setMenu: other:).
    ] ifFalse: [ newSelection size > 1 ifTrue: [
        menu := Menu new
            appendItem: 'Framing' selector: #setFraming:;
            appendSeparator;
            appendItem: 'Create Composite' selector: #createNewComposite;
            appendSeparator;
            appendItem: 'Align Left' selector: #alignLeft;
            appendItem: 'Align Horizontal Center' selector: #alignCenterHorizontal;
            appendItem: 'Align Right' selector: #alignRight;
            appendItem: 'Align Top' selector: #alignTop;
            appendItem: 'Align Vertical Center' selector: #alignCenterVertical;
            appendItem: 'Align Bottom' selector: #alignBottom;
            appendSeparator;
            appendItem: 'Distribute Vertically' selector: #alignDistributeVertical;
            appendItem: 'Distribute Horizontally' selector: #alignDistributeHorizontal.
    ] ifFalse: [ newSelection first isComposite ifTrue: [
        menu := Menu new
            appendItem: 'Color' selector: #setColor:;
            appendItem: 'Framing' selector: #setFraming:;
            appendItem: 'Edit' selector: #other:;
            appendSeparator ;
            appendItem: 'Ungroup' selector: #ungroupComposite;
            appendSeparator ;
            appendSubMenu: (
                subMenu := Menu new
                    title: 'Morph';
                    owner: self owner).
            (list := thePane mutationList) do: [ :item |
                subMenu appendItem: item selector: item ].
            list isEmpty ifFalse: [ subMenu appendSeparator ].
            subMenu appendItem: 'Other...' selector: 'other'.
    ] ifFalse: [
        menu := Menu new
            appendItem: 'Font' selector: #setFont:;
            appendItem: 'Color' selector: #setColor:;
            appendItem: 'Framing' selector: #setFraming:;
            appendItem: 'Menu' selector: #setMenu:;
            appendItem: 'Attributes' selector: #other:;
            appendSeparator ;
            appendSubMenu: (
                subMenu := Menu new
                    title: 'Morph';
                    owner: self owner).
            (list := thePane mutationList) do: [ :item |
                subMenu appendItem: item selector: item ].
            list isEmpty ifFalse: [ subMenu appendSeparator ].
            subMenu appendItem: 'Other...' selector: 'other'.
    ]]].
    self setStatus: menu.
    layoutPane setPopupMenu: menu.
    selection := menu popUpIn: layoutPane.
    layoutPane setPopupMenu: nil.
    selection isSymbol ifTrue: [
        ((selection at: selection size) == $:) ifTrue: [
            self sendInputEvent: selection with: nil
        ] ifFalse: [
            self perform: selection.
            self theMainPane invalidateRect: mainPane visibleFrameRect
        ].
    ] ifFalse: [ selection isString ifTrue: [
        self sendInputEvent: #mutate: with: selection asSymbol
    ]].!  
preInitWindow

    (self paneNamed: 'scrollingPane')
            addSubpane: self mainPane.

    self buildMenus.

    (self menuTitled: 'Edit')
        accelKey: BackspaceKey  accelBits: AfAlt | AfVirtualkey  for: #undo;
        accelKey: DeleteKey accelBits: AfShift | AfVirtualkey  for: #cut;
        accelKey: InsertKey accelBits:  AfChar | AfControl  for: #copy;
        accelKey: InsertKey accelBits: AfShift | AfVirtualkey  for: #paste.

    self icon: self class screenIcon.

    "Set the default font for all the controls"
    self mainView children do: [ :child | child font: self class wbDefaultFont ].!
prepareAppWindowsForSave: savedPaneList

    "Scan through the panes, looking for methods and instance
     variables to predeclare."

    |  allSelectors menuPanes methodsToDeclare methodNames panesToScan mdiAttributes |

    CursorManager execute change.

    "Since we don't log source, recompiling the class will fail
      when trying to compile the open method.  To avoid this, we
      remove the old method first"

    editedClass isScratchWindow ifTrue: [
        PWindowBuilder openMethodType isNil ifTrue: [
            editedClass removeSelector: #open
        ] ifFalse: [
            editedClass removeSelector: PWindowBuilder openMethodType.
        ].
    ].

    methodsToDeclare := Dictionary new.
    methodNames := editedClass selectors asOrderedCollection.

    editedClass allSuperclasses do: [ :aClass |
        methodNames addAll: aClass selectors.
    ].

    panesToScan := OrderedCollection new.
    savedPaneList do: [ :p |
        panesToScan addAll: p children copy.
    ].
    panesToScan addAll: mainPane panes.

    menuPanes := OrderedCollection new.


    savedPaneList do: [ :w |
        w menu notNil ifTrue: [
            allSelectors := w menu allSelectors.
            allSelectors keysDo: [:aSelector |
                (aSelector isSymbol) & (methodNames includes: aSelector) not ifTrue: [
                    methodsToDeclare at: aSelector put: (self menuCommentNameFor: (allSelectors at: aSelector)).
                ].
            ].
        ].
        w handlers do: [ :aSelector |
            (aSelector isSymbol) & (methodNames includes: aSelector) not ifTrue: [
                methodsToDeclare at:  aSelector put: (self topPaneCommentNameFor: w event: (w handlers keyAtValue: aSelector)).
            ].
        ].
    ].

    panesToScan do: [ :w |
        w menu notNil ifTrue: [
            allSelectors := w menu allSelectors.
            allSelectors keysDo: [:aSelector |
                (aSelector isSymbol) & (methodNames includes: aSelector) not ifTrue: [
                    methodsToDeclare at: aSelector put: (self menuCommentNameFor: (allSelectors at: aSelector)).
                ].
            ].
        ].
        w handlers do: [ :aSelector |
            (aSelector isSymbol) & (methodNames includes: aSelector) not ifTrue: [
                methodsToDeclare at:  aSelector put: (self subpaneCommentNameFor: w event: (w handlers keyAtValue: aSelector)).
            ].
        ].
    ].

    (mdiAttributes := mainPane mdiAttributes) notNil ifTrue: [
        mdiAttributes hasStatusPane ifTrue: [
            mdiAttributes statusPaneEvents do: [ :aSelector |
                (methodNames includes: aSelector) not ifTrue: [
                    methodsToDeclare at: aSelector put: (self mdiCommentNameFor:  'StatusPane for the MDI frame' event: (mdiAttributes statusPaneEvents keyAtValue: aSelector)).
                ].
            ].
        ].
        mdiAttributes hasToolPane ifTrue: [
            mdiAttributes toolPaneEvents do: [ :aSelector |
                (methodNames includes: aSelector) not ifTrue: [
                    methodsToDeclare at: aSelector put: (self mdiCommentNameFor:  'ToolPane for the MDI frame' event: (mdiAttributes toolPaneEvents keyAtValue: aSelector)).
                ].
            ].
        ].
        mdiAttributes frameEvents do: [ :aSelector |
            (methodNames includes: aSelector) not ifTrue: [
                methodsToDeclare at: aSelector put: (self mdiCommentNameFor:  'MDI frame' event: (mdiAttributes frameEvents keyAtValue: aSelector)).
            ].
        ].
    ].

    (methodsToDeclare notEmpty) & (editedClass isScratchWindow) ifTrue: [
        "Do not generate any methods for a scratch window"
        methodsToDeclare := Dictionary new.
    ].

    methodsToDeclare keysDo: [ :aMethod |
            self declareMethod: aMethod commentString: (methodsToDeclare at: aMethod).
    ].

    "Make sure it has the local Constants pool dictionary"
    (editedClass ~= WBScratchWindow) & (editedClass ~= WBDialogScratchWindow) &
    ((editedClass sharedPools includes: #WBConstants) not |
        (editedClass sharedPools includes: #ColorConstants) not)  ifTrue: [
        editedClass superclass
            subclass: editedClass name asSymbol
            instanceVariableNames: editedClass instanceVariableString
            classVariableNames: editedClass classVariableString
            poolDictionaries: editedClass sharedVariableString, ' WBConstants', ' ColorConstants'.
    ].

    CursorManager normal change.!   
propertyAt: aSymbol

    ^self class propertyAt: aSymbol!   
propertyAt: aSymbol put: anObject

    self class propertyAt: aSymbol put: anObject!
quickReferenceMenu

    ^(self mainView menuWindow) wbMenuTitled: 'Quick Reference'.!   
realStatusPane

    ^statusPane!
refresh

    self updateParent.
    mainPane editedPane children do: [ :c |
        c isCompositePane ifTrue: [ c realClass: c realClass ]
    ].
    mainPane
        hideSizeDot;
        hideWindow;
        reframeAll;
        showWindow.!
reinitWindowBuilder

    self selectionMenuItemsPerform: #disableItem:.
    (self menuTitled: 'Edit') disableItem: #undo.
    mainPane unselectAll.
    self selectionChanged: mainPane.!
removeCustomPane

    | result |

    result := WBListChooser fromList: self customPanes prompt: 'Remove which pane?'.
    result isNil ifTrue: [
        ^self
    ].

    (self customPanes includes: result) ifTrue: [
        self customPanes remove: result.
        customSubMenu removeItemDynamically: result.
    ].

    self updateRemoveCustomPane.!   
replicateHeight

    mainPane replicateHeight!  
replicateWidth

    mainPane replicateWidth!
resetFocus: ignore

    titleEditor setFocus; selectAll!
resetFonts

    | fonts |
    fonts := self propertyAt: #StoredFonts.

    ListFont := fonts at: 1.
    TextFont := fonts at: 2.
    ButtonFont := fonts at: 3.
    SysFont := fonts at: 4.!  
save

    (editedClass isScratchWindow) ifTrue: [
        ^self saveAs
    ].

    ^self saveInternal.! 
saveAs

        | temp windowType |

    mainPane editedPane isDialog ifTrue: [
        windowType := 'Dialog'.
    ] ifFalse: [ mainPane editedPane isCompositePane ifTrue: [
        windowType := 'CompositePane'
    ] ifFalse: [
        windowType := 'Window'.
    ]].


    (temp := (PWindowBuilder wbCreateClassDialog new forWindowType: windowType ) result) notNil ifTrue: [
        editedClass := temp.
        self labelWithoutPrefix: self label.
        self changed: true.
        self saveInternal.
        (windowType = 'Window') ifTrue: [
            (self menuTitled: 'View') enableAll.
        ].
    ] ifFalse: [
        ^nil
    ].! 
saveAsDefault

    | savedEditedClass |


    savedEditedClass := editedClass.
    (editedClass inheritsFrom: WindowDialog) ifTrue: [
        editedClass := WBDefaultDialogScratchWindow.
    ] ifFalse: [(editedClass inheritsFrom: CompositePane) ifTrue: [
        editedClass := WBDefaultCompositePaneScratchWindow.
    ] ifFalse: [
        editedClass := WBDefaultScratchWindow.
    ]].

    self changed: true.
    self saveInternal.
    self changed: true.

    editedClass := savedEditedClass.

    (editedClass isScratchWindow) ifTrue: [
        (self menuTitled: 'File') disableItem: #editAppCode.
    ].!  
saveInternal


    (self changed or: [ editedClass isScratchWindow ]) ifFalse: [
        ^self
    ].

    (self prepareAppWindowsForSave: mainPane views) isNil ifTrue: [
        ^nil
    ].

    mainPane editedPane realClass: editedClass.
    self generateCode.

    self changed: false.

    self disable: #(save) inMenu: 'File'.

    (editedClass isScratchWindow) ifFalse: [
        self enable: #(editAppCode) inMenu: 'File'.
    ].

    self updateParent.!   
saveWhenPerform

    | methodName savedSelection |

    perform contents hasContent ifTrue: [

        methodName := self getValidMethodName: perform contents.

        (perform contents = methodName) ifFalse: [
            savedSelection := perform getSelection.
            perform contents: methodName.
            perform setSelectionFrom: savedSelection origin x - 1 to: savedSelection corner x - 1.
        ].
        methodName isNil ifFalse: [
            thePane handlers at: self currentEvent put: (methodName, ':') asSymbol.
        ].
    ] ifFalse: [
        thePane handlers removeKey: self currentEvent ifAbsent: [].
    ].

    self updateEvents: true.! 
scrapbookLoad
    | fileName scrapbook |
    (Smalltalk includesKey: #ObjectFiler) ifFalse: [
        ^MessageBox message: 'Loading a Scrapbook requires the ObjectFiler. File in ''\EXTRAS\OBJFILER\VWOBJFLR.ST''.'
    ].
    fileName := (FileDialog new
                            openTitle: 'Load Scrapbook'
                            fileSpec: '*.SBK'
                            showFileInButton: false) file.
    fileName isNil ifFalse: [
        self class scrapbookLoadFile: fileName.
        self updateQuickReferenceMenu.
    ].! 
scrapbookMerge
    | fileName scrapbook mergeScrapbook overWrite |
    (Smalltalk includesKey: #ObjectFiler) ifFalse: [
        ^MessageBox message: 'Merging a Scrapbook requires the ObjectFiler. File in ''\EXTRAS\OBJFILER\VWOBJFLR.ST''.'
    ].
    fileName := (FileDialog new
                            openTitle: 'Merge Scrapbook'
                            fileSpec: '*.SBK'
                            showFileInButton: false) file.
    fileName isNil ifFalse: [
        mergeScrapbook := (Smalltalk at: #ObjectFiler) loadFromPathName: fileName.
        scrapbook := self class scrapbook.
        overWrite := nil.
        mergeScrapbook keysDo: [ :chapter |
            (scrapbook includesKey: chapter) ifFalse: [
                scrapbook at: chapter put: (mergeScrapbook at: chapter).
            ] ifTrue: [
                (mergeScrapbook at: chapter) keysDo: [ :page |
                    (overWrite isNil and: [ (scrapbook at: chapter) includesKey: page ]) ifTrue: [
                        overWrite := MessageBox confirm: 'Overwrite existing pages with the same names?'
                    ].
                    (overWrite == false and: [ ((scrapbook at: chapter) includesKey: page) ]) ifTrue: [
                        (scrapbook at: chapter) at: (page,'.2') put: ((mergeScrapbook at: chapter) at: page)
                    ] ifFalse: [
                        (scrapbook at: chapter) at: page put: ((mergeScrapbook at: chapter) at: page)
                    ].
                ].
            ].
        self updateQuickReferenceMenu.
        ].
    ].! 
scrapbookNew

    (MessageBox confirm: 'Are you sure that you want to throw out the old scrapbook and create another?') ifTrue: [
        self class scrapbook: nil.
        self updateQuickReferenceMenu.
    ]!   
scrapbookQuickReference: aString
    | pageName found |
    found := false.
    pageName := aString reject: [:c | found := ((c == $~) | (c == $&) & found not) ].
    mainPane clipboard: ((self class scrapbook at: 'Quick Reference') at: pageName ifAbsent: [nil]).
    mainPane clipboard isNil ifFalse: [
        mainPane paste
    ].!  
scrapbookRetrieve

    (WBScrapbookRetrieve new openOn: mainPane) removedQuick ifTrue: [
        self updateQuickReferenceMenu
    ]! 
scrapbookSave
    | fileName |
    (Smalltalk includesKey: #ObjectFiler) ifFalse: [
        ^MessageBox message: 'Saving a Scrapbook requires the ObjectFiler. File in ''\EXTRAS\OBJFILER\VWOBJFLR.ST''.'
    ].
    fileName := (FileDialog new saveTitle: 'Save Scrapbook' fileName: 'SCRAP.SBK') file.
    fileName isNil ifTrue: [ ^nil ].
    (Smalltalk at: #ObjectFiler) dump: self class scrapbook newFile: fileName.! 
scrapbookStore

    mainPane copy.
    (mainPane clipboard isNil or: [ mainPane clipboard first isEmpty ]) ifTrue: [
        ^MessageBox message: 'At least one pane must be selected first.'
    ].
    (WBScrapbookStore new openOn: mainPane) isQuick ifTrue: [
        self updateQuickReferenceMenu
    ]!   
selectAll

    mainPane selectAll.! 
selectionChanged: layoutPane

    | newSelection sizeMenu |

    toolBar cacheRedrawOn.

    newSelection := layoutPane selection.
    sizeMenu := self menuTitled: 'Size'.

    (self menuTitled: 'Edit')
        changeItem: #undo label: '&Undo	Ctrl+Z';
        disableItem: #undo.

    (newSelection size > 1) ifTrue: [
        self selectionMenuItemsPerform: #enableItem:.
        self enable: #(alignLeft alignRight alignTop alignBottom) inMenu: 'Align'.
        (self menuTitled: 'Align')
            enableItem: '~Center';
            enableItem: '~Distribute'.
        ( self menuWindow wbMenuTitled: 'Center') enableAll.
        ( self menuWindow wbMenuTitled: 'Distribute') enableAll.
        toolBar
            enableItem: #alignCenterHorizontal;
            enableItem: #alignCenterVertical;
            enableItem: #alignDistributeHorizontal;
            enableItem: #alignDistributeVertical.

        self pane: newSelection first.

        sizeMenu
            disableItem: #setWindowSize;
            disableItem: #setWindowPosition.

    ] ifFalse: [

        sizeMenu
            enableItem: #setWindowSize;
            enableItem: #setWindowPosition.

        self disable: #(alignLeft alignRight alignTop alignBottom) inMenu: 'Align'.
        (self menuTitled: 'Align')
            disableItem: '~Center';
            disableItem: '~Distribute'.
        ( self menuWindow wbMenuTitled: 'Center') disableAll.
        ( self menuWindow wbMenuTitled: 'Distribute') disableAll.
        toolBar
            disableItem: #alignCenterHorizontal;
            disableItem: #alignCenterVertical;
            disableItem: #alignDistributeHorizontal;
            disableItem: #alignDistributeVertical.
       newSelection isEmpty ifTrue: [
            self selectionMenuItemsPerform: #disableItem:.
            self pane: mainPane editedPane.
            sizeMenu
                changeItem: #setWindowSize label: '&Set Window Size...';
                changeItem: #setWindowPosition label: 'Set Window &Position...'.

        ] ifFalse: [
            sizeMenu
                changeItem: #setWindowSize label: '&Set Pane Size...';
                changeItem: #setWindowPosition label: 'Set Pane &Position...'.

            self enable: #(cut copy duplicate clear bringToFront sendToBack mutate) inMenu: 'Edit'.
            self enable: #(autosize) inMenu: 'Size'.
           self pane: newSelection first.
        ].
    ].

    toolBar cacheRedrawOff!
selectionMenuItemsPerform: op

     #(
            cut
            copy
            clear
            bringToFront
            sendToBack
            duplicate
            mutate

        ) do: [:s |
            (self menuTitled: 'Edit') perform: op with: s.
            toolBar perform: op with: s.
        ].

    #(
        autosize
        replicateWidth
        replicateHeight
    ) do: [ :s |
        (self menuTitled: 'Size') perform: op with: s.
        toolBar perform: op with: s.
    ].!
sendToBack

    mainPane sendToBack.!   
setColor: ignore

    | result selection |

       result := WBColorDialog new
            foreColor: thePane foreColor backColor: thePane realBackColor paneEdited: thePane.
          result notNil ifTrue: [
            mainPane selection isEmpty ifTrue: [
                selection := OrderedCollection with: mainPane editedPane.
            ] ifFalse: [
                selection := mainPane selection.
            ].
           selection do: [:p |
                p usesColor ifTrue: [
                    (result at: 1) isNil ifTrue: [
                        p foreColor: p defaultForeColor.
                    ] ifFalse: [
                        p foreColor: (result at: 1).
                    ].
                    (result at: 2) isNil ifTrue: [
                        p backColor: p defaultBackColor.
                    ] ifFalse: [
                        p backColor: (result at: 2).
                    ].
                ].
            ].
            self attributesHaveChanged.
        ].!   
setColorButton: choices

    thePane usesColor ifTrue: [
        choices enableItem: #setColor:.
    ] ifFalse: [
        choices disableItem: #setColor:.
    ].!  
setDefaultFonts

    self
        propertyAt: #StoredFonts
        put: (Array with: ListFont with: TextFont with: ButtonFont with: SysFont).

    ListFont := TextFont := ButtonFont := SysFont := self class wbDefaultFont.!  
setDrawGrid

    self drawGrid ifTrue: [
        (self menuTitled: 'Options') uncheckItem: #drawGrid.
    ] ifFalse: [

        ((self gridSize x < 3) | (self gridSize y < 3)) ifTrue: [
            (MessageBox confirm: 'Your grid is rather small, and will take some time to display.   Are you sure you wish to do this?') ifFalse: [
                ^self
            ].
        ].
        (self menuTitled: 'Options') checkItem: #setDrawGrid.
    ].

    self drawGrid: self drawGrid not.!
setFont: ignore

    | fontDialog |

        fontDialog := FontDialog new.
        fontDialog
            flags:  fontDialog flags - CfEffects;
           defaultFont: thePane font.
        fontDialog open.

        fontDialog chosen notNil ifTrue: [
            mainPane selection do: [:p |
                p usesFont ifTrue: [
                    p font: fontDialog chosen.
                    p foreColor: fontDialog textColor.
                ].
            ].
            self attributesHaveChanged.
        ].!
setFraming: ignore

    | f fp rects |

    fp := mainPane selection first framingBlock.

    mainPane hideSelectionDots; disableSelectionDots.

        rects := mainPane selection collect: [ :p |
                mainPane editedPaneContentRect localizeRect: p rect
        ].

    f := (WBFramingEditor new
        openOnFramer: fp
        rects: rects
        parentRect: (0@0 extent: mainPane editedPaneContentRect extent)) result.

    f notNil ifTrue: [
                1 to: mainPane selection size do: [ :i |
                        (mainPane selection at: i) framingBlock: (f at: i).
                mainPane reframePane: (mainPane selection at: i).
                ].
        self mainPaneChanged: true.
    ].

    mainPane enableSelectionDots; showSelectionDots; showSizeDot.!   
setFramingButton: choices

    thePane usesFraming & thePane isFrameObject not &
        mainPane editedPane isDialog not ifTrue: [
        choices enableItem: #setFraming:.
    ] ifFalse: [
        choices disableItem: #setFraming:.
    ].!  
setGridSize

    | gridSize |

    gridSize := self getPointPrompting: 'Grid Size:' defaultPoint: self gridSize.
    gridSize isNil ifTrue: [
        ^self
    ].

    ((gridSize x < 3) | (gridSize y < 3)) & self drawGrid ifTrue: [
        (MessageBox confirm: 'This grid size is rather fine, and will take some time to display.   Are you sure you wish to display it?') ifFalse: [
            self drawGrid: false.
            (self menuTitled: 'Options') uncheckItem: #setDrawGrid.
        ].
    ].
    self gridSize: gridSize.! 
setMenu: ignore

    | m |

    m := (thePane menuEditor openOn: thePane menu) result.

    m notNil ifTrue: [
        m hasChildren not ifTrue: [
            thePane menu: nil.
        ] ifFalse: [
            thePane menu: m
        ].
        self attributesHaveChanged.
    ].!
setStatus: choices

    "Other"
    (thePane hasOtherEditor or: [thePane isCompositePane]) ifTrue: [
        choices enableItem: #other:.
    ] ifFalse: [
        choices disableItem: #other:.
    ].

    "Font"
    thePane usesFont ifTrue: [
        choices enableItem: #setFont:.
    ] ifFalse: [
        choices disableItem: #setFont:.
    ].

    "Color"
    self setColorButton: choices.

    "Framing"
    self setFramingButton: choices.

    "Menu"
    thePane usesMenu ifTrue: [
        choices enableItem: #setMenu:.
    ] ifFalse: [
        choices disableItem: #setMenu:.
    ].! 
setStyle: comboBox

    | theStyle |

    styleEditor selectedItem isNil ifTrue: [
        ^self
    ].

    theStyle := styleEditor selectedItem trimBlanks.
    theStyle notEmpty ifTrue: [
        thePane style: theStyle asSymbol.
        self attributesHaveChanged.
        self setColorButton: attributePalette.
        self setFramingButton: attributePalette.
        self updateTitle: thePane.

    ].!   
setWindowPosition

    | r newOrigin  |

    mainPane selection notEmpty  ifTrue: [
        mainPane hideSelectionDots; disableSelectionDots.
        newOrigin := self getPointPrompting: 'New pane position:' defaultPoint: mainPane selectionOrigin.
        newOrigin notNil ifTrue: [
            mainPane selectionOrigin: newOrigin
        ].
        mainPane enableSelectionDots; showSelectionDots.
        self updateSizeAndPosition.
        ^self
    ].

    mainPane captureMouseInput.
    r := Display pointFromUser: (0@0 extent: mainPane editedPane rect extent)
                offset: (mainPane editedPane rect extent // 2).
    mainPane clearMouseCapture.

    mainPane editedPane rect: (r := r extent: mainPane editedPane rect extent).
    (mainPane editedPane framingBlock: FramingParameters new)
        framingBlock
            left: r left relativeTo: #left;
            top: r top relativeTo: #top.

    self updateSizeAndPosition.
    self changed: true.!  
setWindowPosition: ignore
    self setWindowPosition!
setWindowSize

    | newExtent  |

    newExtent := self getPointPrompting: 'New window size:' defaultPoint: thePane rect extent.

    newExtent notNil ifTrue: [
        thePane == mainPane editedPane ifTrue: [
            mainPane sizeWindowExternal: newExtent.
        ] ifFalse: [
            mainPane
                disableSelectionDots; hideSelectionDots;
                sizeSelectionToRect: (thePane rect leftTop extentFromLeftTop: newExtent);
                enableSelectionDots; showSelectionDots.
        ].
    ].

    self updateSizeAndPosition.!  
setWindowSize: ignore
    self setWindowSize!
statusPane

    ^self mainView statusPane!  
statusPaneHelp:aKey
    "Answer the default dictionary used by
    the status bar for help support"

    ^self class helpDict at:aKey ifAbsent:[]!
subpaneCommentNameFor: aSubpane event:  eventSymbol

    ^'Callback for the #', eventSymbol asString, ' event in ', (self subpaneNameString: aSubpane), '.'.!   
subpaneNameString: aSubpane

    | nameString  |

    aSubpane paneName isNil ifTrue: [
        nameString := 'an unnamed ', aSubpane realClass name.
        aSubpane contents isString ifTrue: [
            nameString := nameString, ' (contents is ', aSubpane contents asQuotedString, ')'.
        ].
    ] ifFalse: [
        nameString := 'the ', aSubpane realClass name, ' named ', aSubpane paneName asQuotedString.
    ].
    ^nameString! 
symbolNameChanged: ignore

    | badName |

    name contents = thePane paneName ifTrue: [ ^self ].

    name contents hasContent ifTrue: [
        name contents do: [ :c |
            c isAlphaNumeric ifFalse: [  badName := true ].
        ].
        (self instVarNameCheck and: [
            name contents first isUpperCase | (badName = true)]) ifTrue: [
            MessageBox messageNote: '''', name contents, ''' is an invalid pane name.'.
                name contents: ''.
        ] ifFalse: [
            thePane paneName: name contents.
        ].
    ] ifFalse: [
        thePane paneName: nil.
    ].

    self mainPaneChanged: true.!
testWindow

    self setDefaultFonts.
    self tryToSaveChanges notNil ifTrue: [
        editedClass open
    ].
    self sendInputEvent: #resetFonts!  
textChanged: ignore

    thePane usesTitle & (thePane text = titleEditor contents) not ifTrue: [
        thePane text: titleEditor contents.
        mainPane updateTitle: thePane.
        self mainPaneChanged: true.
        mainPane checkMnemonicConflicts.
        (self autoSize and: [ thePane changesSize ]) ifTrue: [
            self autosize.
            self updateEvents: false.
        ].
    ].!
theEditedClass

    ^editedClass!   
theMainPane

    ^mainPane! 
toolCollection
    | menus target tools |
    menus := self class wbMenus.
    target := menus detect: [ :m | (m at: 1) = 'A~dd' ] ifNone: [nil].
    target isNil ifTrue: [ ^nil].
    tools := OrderedCollection new.
    (target at: 3) do: [ :mi |
        mi == #separator ifTrue: [ ^tools ].
        tools add:
            (Association
                key: (mi at: 1) stripMnemonic
                value: ((mi at: 3) collect: [ :msi | msi at: 2 ]))
    ].
    ^tools!  
topPaneClass
        "Private - Answer the default top pane class."
    (Smalltalk includesKey: #MDISystem) ifTrue: [
        Smalltalk isRunTime ifFalse:[
            (Smalltalk at: #MDISystem) isActive ifTrue:[
                ^(Smalltalk at: #WBMDIChild ifAbsent: [ WBTopPane ])]]].
    ^WBTopPane!   
topPaneCommentNameFor: aTopPane event:  eventSymbol

    ^'Callback for the #', eventSymbol asString, ' event in the TopPane ', aTopPane paneName asQuotedString, '.'.! 
tryToSaveChanges

    (self changed or: [ editedClass isScratchWindow ]) ifTrue: [
        autoSave ifFalse: [
            (MessageBox
                confirm: 'Your viewmanager needs to be saved first.  Save and continue?'
            ) ifFalse: [
                ^nil
            ].
        ].
        CursorManager execute change.

        self saveInternal isNil ifTrue: [
            CursorManager normal change.
            ^nil
        ].
        cleanedOutCode := true.
        CursorManager normal change.
    ].

    (editedClass isScratchWindow) & (cleanedOutCode = false) & (changed not) ifTrue: [
        editedClass resetToDefault.
        cleanedOutCode  := true.
    ].! 
undo

    mainPane undo!
undoableOperation: layoutPane

    | aString aSymbol |

    aSymbol := mainPane lastOpSymbol.

    (#( move size sizeWindow clear undo align replicateSize autosize) includes: aSymbol) not |
        ((aSymbol = #undo) and: [ (mainPane previousOpSymbol = #place) ])  ifTrue: [
        ^(self menuTitled: 'Edit')
            changeItem: #undo label: 'Can''t &Undo', (String with: Tab), 'Ctrl+Z';
            disableItem: #undo
    ].

    aSymbol == #undo ifTrue: [
        aString := '&Redo', (String with: Tab),'Ctrl+Z'
    ] ifFalse: [
        aString := '&Undo ', aSymbol asPresentableString, (String with: Tab), 'Ctrl+Z'.
    ].

    (self menuTitled: '~Edit')
        changeItem: #undo label: aString;
        enableItem: #undo.! 
ungroupComposite

    thePane isComposite ifFalse: [ ^nil ].

    mainPane ungroupComposite!  
updateCustomPanesMenu

    | index m |

    index := customSubMenu numberOfItems + 1.

    self customPanes do: [ :p |
        customSubMenu insertItemDynamically: p selector: p atIndex: index.

        index := index + 1.
    ].

    self updateRemoveCustomPane.!  
updateEvents: refresh

    | oldEvents theEvents sel used unused |

    oldEvents := when contents.
    theEvents := thePane supportedEvents.
    used := OrderedCollection new.
    unused := OrderedCollection new.
    theEvents do: [ :e |
        (thePane handlers at: e ifAbsent: [ nil ]) isSymbol
            ifTrue: [ used add: '*', e ]
            ifFalse: [ unused add: e asString ]
    ].
    theEvents := used addAll: unused; yourself.

    theEvents = oldEvents ifTrue: [
        ^self
    ].

    refresh ifTrue: [
        sel := when selectedItem.

        (sel notNil and: [ sel notEmpty ]) ifTrue: [
            sel first = $* ifTrue: [
                sel := sel copyFrom: 2 to: sel size.
            ].
            perform contents notEmpty ifTrue: [
                sel := '*', sel.
            ].
        ].

        when
            contents: theEvents;
            selectItem: sel;
            invalidateRect: when rectangle.
    ] ifFalse: [
        when contents: theEvents.
    ].!   
updateParent
    | originalRect parentWB |
    (parentWB := self mainView parent) isNil ifFalse: [
        (self mainView propertyAt: #creatingNewComposite) == true ifTrue: [
            (MessageBox confirm: 'Replace original widgets with new CompositePane?') ifTrue: [
                originalRect := parentWB theMainPane selectedRect.
                parentWB
                    cut;
                    add: self theEditedClass name.
                parentWB theMainPane placeLoadedPanesAt: originalRect leftTop.
            ].
            self mainView propertyAt: #creatingNewComposite put: false.
        ] ifFalse: [
            parentWB isMDIClient ifFalse: [ parentWB refresh ].
        ].
        self mainView setFocus.
    ].!   
updatePosition: aPoint

    positionPane contents: aPoint x asString,', ',aPoint y asString.!   
updateQuickReferenceMenu

    | quickReferenceMenu index p stream |

    quickReferenceMenu := self quickReferenceMenu.
    quickReferenceMenu removeAllItemsDynamically.
    index := quickReferenceMenu numberOfItems + 1.
    (self class scrapbook at: 'Quick Reference')  keys asSortedCollection do: [ :page |
        (page includes: $&) ifFalse: [
            p := page
        ] ifTrue: [
            stream := WriteStream on: String new.
            page do: [ :character |
                stream nextPut: character.
                character = $&  ifTrue: [stream nextPut: character]].
            p := stream contents
        ].
        quickReferenceMenu insertItemDynamically: p selector: p atIndex: index.
        index := index + 1.
    ].!   
updateRemoveCustomPane

    self customPanes isEmpty ifTrue: [
        (self menuTitled: 'Add')
            disableItem: #removeCustomPane.
    ] ifFalse: [
        (self menuTitled: 'Add')
            enableItem: #removeCustomPane.
    ].!  
updateSize: aRect
    | point |
    point := aRect extent.
    sizePane contents: point x asString,'x',point y asString.!  
updateSizeAndPosition

    | point |
    self updateSize: thePane rect.

    mainPane selection notEmpty  ifTrue: [
        point := mainPane selectionOrigin.
     ] ifFalse: [
        point := mainPane editedPane rect leftTop.
    ].
    self updatePosition: point.! 
updateTitle: aPane

    "Title"
    aPane usesTitle ifTrue: [
        titleEditor contents: aPane text; enable.
        titleText enable.
    ] ifFalse: [
        titleEditor contents: ''; disable.
        titleText disable.
    ].! 
viewCreate

    | v |

    (v:= Prompter prompt: 'Name for new view:' default: '') isNil ifFalse: [
        mainPane newView: v.
        (self menuTitled: 'View') enableAll.
        self mainPaneChanged: true.
    ].! 
viewList

    ^(mainPane views select: [ :view |
        view paneName notNil
    ]) collect: [ :v | v paneName ].!   
viewRemove

    | v |

    (v:= WBListChooser new fromList: self viewList prompt: 'Remove which view?') isNil ifFalse: [
        mainPane removeView: v.
        (mainPane views size = 1) ifTrue: [
            (self menuTitled: 'View')
                disableItem: #viewSwitchTo;
                disableItem: #viewRemove.
        ].
        self mainPaneChanged: true.
    ].!   
viewSwitchTo

        | v |

        (v:= WBListChooser new fromList: self viewList prompt: 'Which view?' selection: mainPane editedPane paneName) isNil ifFalse: [
                mainPane switchToView: (mainPane viewAt: v).
                self reinitWindowBuilder.
        ].! 
when: ignore

    currentWhen = when selectedItem ifTrue: [
        ^self
    ].

    self fillInPerform.!  
writeHandlers: h on: aStream

    h notNil ifTrue: [
        h keysDo: [ :symbol |
            (h at: symbol) isSymbol ifTrue: [
                aStream nextPutAll: '            when: #', symbol,' perform: #', (h at: symbol), ';'; cr.
            ].
        ].
    ].!  
zoomLayout

    | scrollPane isZoomed |

    scrollPane := mainPane scrollPane.
    isZoomed := scrollPane zoomed.

    (self menuTitled: 'Options')  changeItem: #zoomLayout label: (
        isZoomed ifTrue: [
            '&Zoom Layout	Alt+Z'
        ] ifFalse: [
            'Un&zoom Layout	Alt+Z'
        ]
    ).

    scrollPane zoom.! !

! WindowDialog methods !   
isModal
    "Added by OSI - is the receiver modal or not"
    #addedByOSI.
    ^(self mainView pStyle includes: #modal) | (self mainView pStyle includes: #sysmodal)!  
openModeless

    "Modified by OSI to support preInitWindow"

        "Open the dialog box as a modeless window."

    #modifiedByOSI.
    self preInitWindow.

    self mainView openModeless!  
openViews
    "Added by OSI"
    #addedByOSI.
    ^ self isModal
        ifTrue: [ self openWindow ]
        ifFalse: [ self openModeless ].!
openWindow

    "Modified by OSI to support preInitWindow"

        "Open the dialog box modal to the
         current active window."

    #modifiedByOSI.
    self preInitWindow.

    self mainView open! !

! AboutDialog methods !   
open
    "Open a dialog box telling about Smalltalk/V.
    Touched By Ale for Application definition of About Dialog"
    | lineHeight |

    #modifiedByOStyle.
    "Test for About App Dialog"
    (Smalltalk includesKey: #AboutApp)
    ifTrue: [^(Smalltalk at: #AboutApp) new open].

    self label: 'About'.

    lineHeight := 8.
    self addSubpane:
        (StaticText new
            centered;
            contents: Smalltalk product, ' Release ', Smalltalk version;
            framingBlock: [:box |
                (box leftTop down: lineHeight)
                    extentFromLeftTop: box width @ lineHeight ] ).

    self addSubpane:
        (StaticText new centered;
            contents: '(c) Copyright Digitalk Inc. 1992';
            framingBlock: [:box |  (box leftTop down: lineHeight * 3)
                    extentFromLeftTop: box width @ lineHeight ] ).

    self addSubpane:
        (StaticText new centered;
            contents: 'All rights reserved';
            framingBlock: [:box | (box leftTop down: lineHeight * 4)
                    extentFromLeftTop: box width @ lineHeight ] ).

    self addSubpane:
        (StaticText new centered;
            contents: '9841 Airport Blvd.';
            framingBlock: [:box | (box leftTop down: lineHeight * 6)
                    extentFromLeftTop: box width @ lineHeight ] ).

    self addSubpane:
        (StaticText new centered;
            contents: 'Los Angeles, CA 90045';
            framingBlock: [:box | (box leftTop down: lineHeight * 7)
                    extentFromLeftTop: box width @ lineHeight ] ).

    self addSubpane:
        (StaticText new centered;
            contents: '(310) 645-1082';
            framingBlock: [:box | (box leftTop down: lineHeight * 8)
                    extentFromLeftTop: box width @ lineHeight ] ).

    self addSubpane:
        (StaticText new centered;
            contents: 'Smalltalk/V is a registered trademark';
            framingBlock: [:box | (box leftTop down: lineHeight * 12)
                    extentFromLeftTop: box width @ lineHeight ] ).

    self addSubpane:
        (StaticText new centered;
            contents: 'of Digitalk Inc.';
            framingBlock: [:box | (box leftTop down: lineHeight * 13)
                    extentFromLeftTop: box width @ lineHeight ] ).

    self addSubpane:
        (Button new defaultPushButton;
            idOK;
            contents: 'OK';
            when: #clicked perform: #ok:;
            framingBlock: [:box | (box leftTop rightAndDown:
                        (box width - 35) // 2 @ (lineHeight * 19 // 2))
                    extentFromLeftTop: 35 @ (lineHeight * 2)] ).

    self openWindow! !

! ButtonsTablet methods !  
actions: aCollection
    "Set the actions to be performed on the model
     when the buttons are clicked..."
    actions := aCollection!   
addButtonNumber: aNumber to: aTopPane
    "Private - Adds a button to aTopPane"

      aTopPane addSubpane:
            (CPBitmapButton new
                    owner: self;
                    framingBlock: [:box|
                        (self buttonWidth * (self positionFor: aNumber)) + self margin
                            extent: self buttonWidth @ self buttonWidth];
                    paneName: aNumber;
                    bitmap: (self bitmapForAction: aNumber);
                    when: #clicked perform: #enterState:;
                    backColor: ClrLightgray;
                    yourself
            )!   
bitmapForAction: aNumber
    "Private - Returns the bitmap for the action aNumber"
    | name |
    name := (actions at: aNumber) asString.
    name at: 1 put: name first asUpperCase.
    name := 'Tool', name.
    ^CPBitmapDict at: name!   
bringToTop
    "Private - Bring the receiver's topView to top"
    | position |
    position := self initWindowSize origin.
    UserLibrary
        setWindowPos: self mainView handle
        insertAfter: (WinHandle fromInteger: 16rFFFF)
        x: position x  y: position y  cx: 0  cy: 0
        flags: SwpNoactivate | SwpNosize! 
buttonWidth
    ^14! 
enterState: aButton
    | bmp selector |

    selector := actions at: aButton paneName.

    (model respondsTo: selector)
    ifTrue: [
        model perform: selector.
        "  model mainView bringToTop    don't activate topPane"
    ].! 
initWindowSize
    "Private - Answer the default window size."
    | position buttonWidth |
    position := self number.
    buttonWidth := self buttonWidth.
    position isPoint
    ifFalse: [ position := self number * buttonWidth * 4 @ 0 ].
    ^  position extent: (
        2 * buttonWidth
        @ (actions size + 1 // 2 * buttonWidth)
        + self margin)!
margin
    "Private - Returns the margin for top label"
    ^0@4!   
number
    "Returns the order number of the receiver.
    This number will be used when creating
    the receiver's window"
    ^number isNil
    ifTrue: [0]
    ifFalse: [number]!
number: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    number := anObject! 
open

     | topPane |

    topPane := self topPaneClass new.
    topPane
            owner: self;
            labelWithoutPrefix: self title;
            noSmalltalkMenuBar;
            viewName: 'mainView';
            pStyle: #( );
            backColor: ClrLightgray;
            " style: topPane defaultFrameStyle | WsMinimizebox; "
        yourself.
    self addView: topPane.

    1 to: actions size do: [:i|
        self addButtonNumber: i to: topPane
    ].

    self openModeless.

    self bringToTop!
openOn: anEditor
    "Open the receiver for working with anEditor"
    | icon |
    actions isNil
    ifTrue: [^self error: 'Must have some actions to do...'].

    model := anEditor.

    self open.

    icon := Icon fromModule: ObjectStyleDLL fileName id: 'Tablet'.
    icon notNil ifTrue: [
        self mainView icon: icon
    ].!   
position: aPoint
    "Sets the position of the receiver"
    number := aPoint!  
positionFor: aNumber
    "Private - Returns a point with the position
     offset"

    ^ aNumber - 1 \\ 2 @ (aNumber - 1 // 2)!  
title
    "Returns the receiver's title"
    ^title isNil
        ifTrue: [String new]
        ifFalse: [title]!  
title: aString
    "Set the receivers title"
    title := aString!  
topPaneClass
    "Private - Answer the defalut top pane class."
    ^LittleTopDialog! !

! CategorySelectDialog methods ! 
addNewPane: aPoint
 "Add a new pane"
 | p |
 p := Button new owner: self.
 p when: #clicked perform: #clicked:.
 p propertyAt: #cbPoint put: aPoint.
 items at: aPoint put: p.
 (aPoint ~= (3@3))
  ifTrue: [p contents: (String with: ((aPoint x)+(aPoint y * 4)+($A asciiValue))asCharacter)]
  ifFalse: [p contents: ' ' ].
 p framingBlock: [ :box |
  (box leftTop rightAndDown: ((10@4)+(aPoint * (self sfw@SysFont height))))
  extentFromLeftTop: (self sfw@SysFont height)].
 self addSubpane: p.!  
cancel: aButton
 "Private - The user selected cancel."
 items := nil.
 self mainView close!
check
 "check for ready"
 self loop: [ :x :y | ((items at: (x@y)) contents first ~= ('ABCDEFGHIJKLMNO ' at: (1 + x + (y * 4))))
   ifTrue: [ ^self ]. ].
 ^MessageBox message: 'You did it !!'.!  
clicked: aPane
 "move a field"
 | p1 p pp |
 (items at: (10@10)) setFocus.
 pp := aPane propertyAt: #cbPoint.
 p := self emptyField.
 p1 := (pp - p) abs.
 (p1 x + p1 y = 1)
  ifTrue: [
   (items at: p) contents: ((items at: pp) contents).
   (items at: pp) contents: ' '.
   self check. ].! 
emptyField
 "Return the coordinate of the empty field"
 self loop: [ :x :y | ((items at: (x@y)) contents = ' ') ifTrue: [ ^(x@y) ] ].!  
initWindowSize
 "size of the window"
 ^((self sfw * 4) + 20)@(SysFont height * 6)!  
loop: aBlock
 "loop"
 0 to: 3 do: [ :x |
 0 to: 3 do: [ :y |
  aBlock value: x value: y.
 ].
 ].!   
ok: aButton
 "Private - The user selected ok."
 (items class = ListBox)
  ifTrue: [ items selection isNil
   ifTrue: [ items := nil ]
   ifFalse: [ items := OrderedCollection with: items selectedItem ]
  ]
  ifFalse: [ items := items selectedItems. ].
 self mainView close! 
open
 "Open the CategoryChecker"
 | p |
 self labelWithoutPrefix: 'Puzzle  ',CategoryBrowser version.
 items := Dictionary new.
 self loop: [ :x :y | self addNewPane: (x@y). ].
 self addSubpane: (p := Button new owner: self;
  when: #clicked perform: #shuffle:;
  contents: 'Shuffle';
  framingBlock: [ :box |
   (box leftTop rightAndDown: (20@(SysFont height * 9 // 2)))
   extentFromLeftTop: ((self sfw * 4 - 20)@(SysFont height)) ]).
 items at: (10@10) put: p.
 self openModeless.
 p setFocus.
 ^self!   
selectFrom: list label: answerString
 "Open a window to select itemstrings"
 ^self selectFrom: list label: answerString listClass: MultipleSelectListPane " MultipleSelectListBox "
    "Modified: 07/20/93 / 01:39:24 PM / LRP"!  
selectFrom: list label: answerString listClass: aClass
 "Open a window to select itemstrings"
 | lineHeight charSize lb |
 self labelWithoutPrefix: answerString.
 charSize := WindowDialog unitMultiplier.
 lineHeight := charSize y * 2.
 items := nil.
 self addSubpane:
  (items := aClass new owner: self;
  contents: list;
  framingBlock: [ :box |
   ((box leftTop rightAndDown: (2@2)) extentFromLeftTop: ((box width - 4) @ (box height - lineHeight - 4))) ]).

 self addSubpane:
  (Button new
  defaultPushButton;
  contents: 'OK';
  when: #clicked perform: #ok:;
  framingBlock: [:box |
  (box leftTop rightAndDown: (2 @ (box height - lineHeight + 2)))
  extentFromLeftTop:  ((box width // 2 - 4)@(lineHeight - 4))] ).

 self addSubpane:
  (Button new
  contents: 'Cancel';
  when: #clicked perform: #cancel:;
  framingBlock: [:box |
  (box leftTop rightAndDown: ((box width // 2 + 2) @ (box height - lineHeight + 2)))
  extentFromLeftTop:  ((box width // 2 - 4)@(lineHeight - 4))] ).

 self openWindow.
 ^items  class = MultipleSelectListBox
  ifTrue: [ nil ]
  ifFalse: [ items ].!  
sfw
 "Return SysFont height"
 ^SysFont stringWidth: 'AAA'!  
shuffle: aButton
 "Shuffle the contents"
 | t s nc |
 t := 0.
 s := 'ABCD EFGHIJKLMNO'.
 (Date dateAndTimeNow printString) do: [ :c |
  t := t + c asciiValue * 2 ].
 self loop: [ :x :y |
  (items at: (x@y)) contents: (String with: (nc := (s at: (t \\ s size + 1)))).
  t := (t * 30) // (Time now seconds + 1).
  s := (s reject: [ :c | c = nc ]) reversed. ].!  
singleSelectFrom: list label: answerString
 "Open a window to select an itemstring"
 ^self selectFrom: list label: answerString listClass: ListBox! !

! ChunkDialog class methods !  
classComment
	^'This class is used for all chunk browser dialogs'
	"Modified: 11.06.93 / 10.14.08 / T.Lentzsch"!
classUpdate
	^'
	"Modified: 11.06.93 / 10.14.07 / T.Lentzsch"'
	"Modified: 11.06.93 / 10.14.07 / T.Lentzsch"! !

! ChunkDialog methods ! 
abort: aPane
	"Set requstors abort flag"

	(self propertyAt: #requestor) propertyAt: #abort put: true.
	"Modified: 03.06.93 / 08.29.56 / T.Lentzsch"! 
cancel: aPane
	"Exit the dialog"

	self close.
	"Modified: 14.05.93 / 09.46.02 / T.Lentzsch"! 
initializeItems: aPane
	"Create list of items"

	| set |

	set := Set with: '  doIt'.

	(self propertyAt: #requestor) visibleChanges do: [:struct |
		struct className isEmpty ifFalse: [set add: struct className].
	].

	aPane contents: set asSortedCollection.
	"Modified: 03.06.93 / 08.30.06 / T.Lentzsch"! 
initWindowSize
	"Answer the initial window size"

	self mainView children size = 1 ifTrue: [^80@20].

	^150@100
	"Modified: 21.12.92 / 10.31.51 /  T.Lentzsch"! 
ok: aPane
	"The ok button was clicked"

	aPane parent children do: [:child |

		child class = MultipleSelectListBox ifTrue: [
			(self propertyAt: #action) = #hideOk: ifTrue: [
				CursorManager execute change.
				child selectedItems do: [:item | (self propertyAt: #requestor) hideShow: item].
				CursorManager normal change.
				(self propertyAt: #requestor) update.
			].

			(self propertyAt: #action) = #removeOk: ifTrue: [
				CursorManager execute change.
				child selectedItems do: [:item | (self propertyAt: #requestor) remove: item].
				CursorManager normal change.
				(self propertyAt: #requestor) update.
			].
		].

	].

	self close
	"Modified: 03.06.93 / 08.30.52 / T.Lentzsch"!  
openAbortOn: aRequestor
	"Open the abort requestor"

	self propertyAt: #requestor put: aRequestor.

	self labelWithoutPrefix: 'Compiling...'.

	self addSubpane: (Button new
		contents: 'Abort';
		when: #clicked perform: #abort:;
		framingBlock: [:box | box]).

	self openModeless.
	"Modified: 03.06.93 / 08.29.38 / T.Lentzsch"!  
openOn: aRequestor
	"Open the filter list with action"

	self propertyAt: #requestor put: aRequestor.

	self labelWithoutPrefix: 'Select Item(s)'.

	self addSubpane: (MultipleSelectListBox new
		when: #getContents perform: #initializeItems:;
		framingBlock: [:box|
			(box leftTop right: 1)
				rightBottom: (box rightBottom leftAndUp: 1 @ (box height // 10))
		]).

	self addSubpane: (Button new
		contents: 'Ok';
		when: #clicked perform: #ok:;
		framingBlock: [:box|
			(box leftTop rightAndDown: 1@(box height * 9 // 10))
				extentFromLeftTop: (box width // 2)@(box height // 10)
		]).

	self addSubpane: (Button new
		contents: 'Cancel';
		when: #clicked perform: #cancel:;
		framingBlock: [:box|
			(box leftTop rightAndDown: (box width // 2)@(box height * 9 // 10))
				extentFromLeftTop: (box width // 2)@(box height // 10)
		]).

	self mainView openModal: aRequestor mainView.
	"Modified: 03.06.93 / 08.30.26 / T.Lentzsch"!  
propertyAt: key
	"Protected - Answer the value associated with key
	in the properties dictionary."

    properties isNil ifTrue: [^nil].
    ^properties at: key ifAbsent: [^nil]
	"Modified: 03.06.93 / 08.34.15 / T.Lentzsch"!
propertyAt: key put: aValue
	"Protected - Set the value associated with key
	in the properties dictionary."

    properties isNil ifTrue: [properties := IdentityDictionary new].
    aValue isNil ifTrue: [
        ^properties removeKey: key ifAbsent: []].
    properties at: key put: aValue
	"Modified: 03.06.93 / 08.34.10 / T.Lentzsch"! !

! CPCreateBitmap methods !  
cancel: aPane

    self close.! 
initWindow

    mono := self paneNamed: 'mono'.
    width := self paneNamed: 'width'.
    height := self paneNamed: 'height'.

    (self paneNamed: 'color') selection: true.!  
initWindowSize

    ^150@75!
ok: aPane

    | w h |

    w := width contents asInteger.
    h := height contents asInteger.
    mono selection ifTrue: [
        b := Bitmap width: w height: h
    ] ifFalse: [
        b := Bitmap screenWidth: w height: h
    ].

    self close.! 
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Create Bitmap';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 631 @ 328; xC; yC; cRDU: (11 @ 318 rightBottom: 619 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 160; lDU: 18 r: #left; rDU: 302 r: #left; tDU: 16 r: #top; bDU: 176 r: #top);
                    startGroup;
                    contents: 'Type';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 274 @ 160; lDU: 320 r: #left; rDU: 594 r: #left; tDU: 16 r: #top; bDU: 176 r: #top);
                    startGroup;
                    contents: 'Size';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 347 r: #left; rDU: 466 r: #left; tDU: 120 r: #top; bDU: 152 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Height:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 357 r: #left; rDU: 466 r: #left; tDU: 64 r: #top; bDU: 96 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Width:';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 238 @ 40; lDU: 46 r: #left; rDU: 283 r: #left; tDU: 56 r: #top; bDU: 96 r: #top);
                    paneName: 'mono';
                    startGroup;
                    tabStop;
                    contents: 'Monochrome';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 40; lDU: 46 r: #left; rDU: 174 r: #left; tDU: 112 r: #top; bDU: 152 r: #top);
                    paneName: 'color';
                    contents: 'Color';
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 48; lDU: 475 r: #left; rDU: 576 r: #left; tDU: 112 r: #top; bDU: 160 r: #top; indent: 3 @ 4);
                    paneName: 'height';
                    startGroup;
                    tabStop;
                    contents: '32';
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 48; lDU: 475 r: #left; rDU: 576 r: #left; tDU: 56 r: #top; bDU: 104 r: #top; indent: 3 @ 4);
                    paneName: 'width';
                    startGroup;
                    tabStop;
                    contents: '32';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 64; lDU: 18 r: #left; rDU: 165 r: #left; tDU: 192 r: #top; bDU: 256 r: #top);
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 64; lDU: 183 r: #left; rDU: 329 r: #left; tDU: 192 r: #top; bDU: 256 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!   
result

    ^b! !

! CPCreateButton methods ! 
initWindow

    super initWindow.
    self mainView labelWithoutPrefix:  'Create Button'.
    mono disable.
    width contents: '25'.
    height contents: '22'.!   
ok: aPane

    | w h |

    w := width contents asInteger.
    h := height contents asInteger.
    b := Bitmap buttonWidth: w height: h.

    self close.! !

! OSCreateTool methods !  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Create Tool';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 631 @ 360; xC; yC; cRDU: (11 @ 350 rightBottom: 619 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 347 r: #left; rDU: 466 r: #left; tDU: 120 r: #top; bDU: 152 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Height:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 357 r: #left; rDU: 466 r: #left; tDU: 64 r: #top; bDU: 96 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Width:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 48; lDU: 174 r: #left; rDU: 274 r: #left; tDU: 224 r: #top; bDU: 272 r: #top; indent: 3 @ 4);
                    paneName: 'planes';
                    startGroup;
                    contents: '3';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 126 @ 64; lDU: 329 r: #left; rDU: 455 r: #left; tDU: 208 r: #top; bDU: 272 r: #top);
                    paneName: 'ok';
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'OK';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 126 @ 64; lDU: 466 r: #left; rDU: 592 r: #left; tDU: 208 r: #top; bDU: 272 r: #top);
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 48; lDU: 475 r: #left; rDU: 576 r: #left; tDU: 56 r: #top; bDU: 104 r: #top; indent: 3 @ 4);
                    paneName: 'width';
                    startGroup;
                    tabStop;
                    contents: '25';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 48; lDU: 475 r: #left; rDU: 576 r: #left; tDU: 112 r: #top; bDU: 160 r: #top; indent: 3 @ 4);
                    paneName: 'height';
                    startGroup;
                    tabStop;
                    contents: '22';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 238 @ 40; lDU: 46 r: #left; rDU: 283 r: #left; tDU: 56 r: #top; bDU: 96 r: #top);
                    paneName: 'mono';
                    startGroup;
                    tabStop;
                    contents: 'Monochrome';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 40; lDU: 46 r: #left; rDU: 174 r: #left; tDU: 112 r: #top; bDU: 152 r: #top);
                    paneName: 'color';
                    contents: 'Color';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 34 r: #left; rDU: 162 r: #left; tDU: 232 r: #top; bDU: 264 r: #top);
                    rightJustified;
                    startGroup;
                    tabStop;
                    contents: 'Planes:';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 274 @ 160; lDU: 320 r: #left; rDU: 594 r: #left; tDU: 16 r: #top; bDU: 176 r: #top);
                    contents: 'Size';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 160; lDU: 18 r: #left; rDU: 302 r: #left; tDU: 16 r: #top; bDU: 176 r: #top);
                    contents: 'Type';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 104; lDU: 18 r: #left; tDU: 184 r: #top);
                    contents: 'Num Images';
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
initWindow

    super initWindow.
    self mainView labelWithoutPrefix:  'Create OSTool'.! 
ok: aPane

    | w h |

    w := width contents asInteger.
    h := height contents asInteger.
    b := OSTool
            buttonWidth: w height: h
            planes: ((self paneNamed: 'planes') contents asInteger max: 2).

    self close.!   
open
    "Added by OSI - Open the receiver."
    | newInstance |
    newInstance := self createViews.
    newInstance notNil ifTrue: [
        newInstance openViews.
    ] ifFalse: [
        #addedByOSI.
        MessageBox message:
            self class name,' does not have a #createViews method or its own #open method.'
    ].
    ^newInstance! !

! IniSettingsDialog class methods !  
wbCreated

    ^true! !

! IniSettingsDialog methods !
addGroup: group comment: comment
    "Private - Add a new group with a comment into the file in use"

    | file |
    group size = 0 ifTrue: [^self].
    file := self openFile.
    file
        setToEnd;cr;cr;
        nextPutAll: '[',group,'] ; ',comment;cr;
        close.!  
addTo: aGroup key: aKey value: aValue comment: comments
    "Private - Add a new entry to the group aGroup"

    | dict |
    dict := self contentsOfGroup: aGroup.
    ^dict
        at: aKey
        put: (Array
            with: comments
            with: aValue)! 
closeMe: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cerrar').
     (Generated by WindowBuilder)"

    self close!
commentsOf: aKey in: aGroup
    "Private - Returns the comments of the key aKey in aGroup."
    ^((self contentsOfGroup: aGroup)
        at: aKey ifAbsent: [^String new]) first!  
commentsOfGroup: aName
    "Private - Returns the comments of the group aName."

    ^(self settings at: aName ifAbsent: [^String new]) first! 
contentsOf: aKey in: aGroup
    "Private - Returns the contents of the key aKey in aGroup."
    ^((self contentsOfGroup: aGroup)
        at: aKey ifAbsent: [^String new]) last!   
contentsOfGroup: aName
    "Private - Returns the contents of the group aName."

    ^(self settings at: aName ifAbsent: [^Dictionary new]) last!  
createGroup: aName comment: commentString
    "Private - Adds a new group to the internal structure if not present"

    (self settings includesKey: aName)
    ifFalse: [ settings at: aName put: (Array with: commentString with: Dictionary new) ].
    ^settings at: aName!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Parmetros del sistema';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 887 @ 608; xC; yC; cRDU: (11 @ 598 rightBottom: 875 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 85 @ 28; lDU: 32 r: #left; rDU: 117 r: #left; tDU: 432 r: #top; bDU: 460 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Valor :';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 798 @ 170; lDU: 30 r: #left; rDU: 827 r: #left; tDU: 242 r: #top; bDU: 412 r: #top);
                    startGroup;
                    when: #getContents perform: #parameterDetail:;
                    contents: '...';
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 805 @ 40; lDU: 27 r: #left; rDU: 832 r: #left; tDU: 88 r: #top; bDU: 128 r: #top);
                    startGroup;
                    when: #getContents perform: #groupDetail:;
                    contents: '...';
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 393 @ 56; lDU: 23 r: #left; rDU: 416 r: #left; tDU: 492 r: #top; bDU: 548 r: #top);
                    startGroup;
                    when: #clicked perform: #installModule:;
                    contents: 'Instalar nuevos componentes...';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 56; lDU: 711 r: #left; rDU: 830 r: #left; tDU: 492 r: #top; bDU: 548 r: #top);
                    startGroup;
                    when: #clicked perform: #closeMe:;
                    contents: 'Cerrar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 837 @ 134; lDU: 11 r: #left; tDU: 4 r: #top);
                    contents: 'Grupos de Propiedades';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 837 @ 340; lDU: 11 r: #left; tDU: 148 r: #top);
                    contents: 'Parmetros';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 697 @ 238; lDU: 23 r: #left; rDU: 720 r: #left; tDU: 34 r: #top; bDU: 272 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #groupContents:;
                    when: #select perform: #groupSelect:;
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 697 @ 264; lDU: 23 r: #left; tDU: 178 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #parameters:;
                    when: #select perform: #parameterSelected:;
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 171 @ 36; lDU: 146 r: #left; rDU: 318 r: #left; tDU: 428 r: #top; bDU: 464 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #currentBooleanValue:;
                    when: #clicked perform: #setCurrentBooleanValue:;
                    contents: 'Habilitado/a';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 672 @ 44; lDU: 137 r: #left; rDU: 809 r: #left; tDU: 426 r: #top; bDU: 470 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #currentValue:;
                    when: #textChanged perform: #currentValueChanged:;
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 40; lDU: 734 r: #left; tDU: 36 r: #top);
                    bitmap: (CPBitmapDict at: 'groupNew');
                    startGroup;
                    tabStop;
                    when: #clicked perform: #newGroup:;
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 40; lDU: 784 r: #left; tDU: 36 r: #top);
                    bitmap: (CPBitmapDict at: 'groupRemove');
                    startGroup;
                    tabStop;
                    when: #clicked perform: #removeCurrentGroup:;
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 40; lDU: 734 r: #left; tDU: 180 r: #top);
                    bitmap: (CPBitmapDict at: 'itemNew');
                    startGroup;
                    tabStop;
                    when: #clicked perform: #newParameter:;
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 40; lDU: 784 r: #left; tDU: 180 r: #top);
                    bitmap: (CPBitmapDict at: 'itemRemove');
                    startGroup;
                    tabStop;
                    when: #clicked perform: #removeCurrentParameter:;
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).! 
currentBooleanValue: aPane

    "Callback for the #getContents event in an unnamed CheckBox (contents is 'Habilitado/a').
     (Generated by WindowBuilder)"

    | value selection |
    value := self currentValue.
    selection := value isString
        ifTrue: [ 'true' = value asLowerCase ]
        ifFalse: [false].

    aPane selection: selection.
    aPane visible: ( #( 'true' 'false' ) includes: value asLowerCase)!
currentValue
    "Private - Returns the current selected value"

    ^self contentsOf: currentKey in: currentGroup!
currentValue: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    | value |
    value := self currentValue.
    aPane contents: value.
    aPane visible: ( #( 'true' 'false' ) includes: value asLowerCase) not!   
currentValueChanged: aPane

    "Callback for the #textChanged event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    currentGroup isNil ifTrue: [^self].

    self setValueOf: currentKey in: currentKey to: aPane contents! 
defaultFont
    "Private - Returns the default font of the receiver"

    ^OSViewManager defaultFont!  
fileIn
    "Private - Perform fill in of the profile contents into the settings dictionary"

    | file windowsDirectory address size |
    settings := Dictionary new.

    file := self openFile.
    self scan: file.
    file close.

    self stripPrivates.!  
groupContents: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | names |
    names := self groups asSortedCollection asArray.
    aPane contents: names.
    names isEmpty ifTrue: [^self].
    aPane selectItem: names first.
    currentGroup := names first.
    self changed: #groupDetail:!   
groupDetail: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '...').
     (Generated by WindowBuilder)"

    aPane contents: (self commentsOfGroup: currentGroup)! 
groups
    "Private - Returns the profiler groups"

    ^self settings keys!   
groupSelect: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    currentGroup := aPane selectedItem.
    currentKey := nil.
    self
        changed: #groupDetail:;
        changed: #parameters:;
        changed: #parameterDetail:;
        changed: #currentValue:;
        changed: #currentBooleanValue:;
        yourself!
installModule: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Instalar nuevos componentes...').
     (Generated by WindowBuilder)"

    StartUpApplication installModule.
    self closeMe.!
newGroup: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    | dialog name comment |
    dialog := OSPrompter new.
    dialog
        title: 'Ingreso de nuevo grupo';
        questions: #('Nombre del nuevo grupo?' 'Comentarios');
        open.
    dialog answers isNil ifTrue: [^self].
    name := dialog answers first trimBlanks.
    name isEmpty ifTrue: [^self].
    comment := dialog answers last.

    (self contentsOfGroup: name) isEmpty
    ifFalse: [
        UserLibrary messageBeep: 0.
        MessageBox warning: 'El grupo ',name,'ya existe.'.
        ^nil
    ].

    self
        addGroup: name comment: comment;
        fileIn;
        changed: #groupContents:;
        changed: #parameters:!   
newParameter: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    | dialog name content comments |
    dialog := OSPrompter new.
    dialog
        title: 'Ingreso de nuevo parmetro.';
        questions: #('Nombre del nuevo parmetro?' 'Contenido' 'Comentarios');
        open.
    dialog answers isNil ifTrue: [^self].
    name := dialog answers first trimBlanks.
    name isEmpty ifTrue: [^self].
    content := dialog answers at: 2.
    comments := dialog answers at: 3.

    profiler applicationName: currentGroup.
    comments isEmpty
    ifFalse: [  profiler at: '; ',comments put: String new ].
    profiler at: name put: content asString.

    self
        fileIn;
        changed: #parameters:!   
openFile
    "Private - Returns a fileStream open over the file in use by the receiver"

    | file windowsDirectory address size |
    (File exists: profiler pathName)
    ifTrue: [ file := File pathName: profiler pathName ]
    ifFalse: [
        address := WinAddress allocateMemory: 200.
        size := KernelLibrary
            getWindowsDirectory: address asInteger
            length: 200.
        windowsDirectory := (address copyFrom: 1 to: size) asString.
        address free.
        (File exists: windowsDirectory ,'\', profiler pathName)
        ifFalse: [^self error: 'Archivo no encontrado'].
        file := File pathName:  windowsDirectory ,'\', profiler pathName.
    ].
    ^file!
openOn: aProfiler
    "Open the receiver for working on aProfiler"

    profiler := aProfiler.
    self open.

    self
        changed: #currentValue:;
        changed: #currentBooleanValue:;
        yourself!   
parameterDetail: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '...').
     (Generated by WindowBuilder)"

     aPane contents: (self commentsOf: currentKey in: currentGroup) trimBlanks!   
parameters: aPane

    "Callback for the #getContents event in an unnamed CPSpinButton.
     (Generated by WindowBuilder)"

    | names |
    names := (self contentsOfGroup: currentGroup) keys asSortedCollection asArray.
    aPane contents: names.
    names isEmpty ifTrue: [^self].
    aPane selectItem: names first.
    currentKey := names first.
    self changed: #parameterDetail:!  
parameterSelected: aPane

    "Callback for the #select event in an unnamed CPSpinButton.
     (Generated by WindowBuilder)"

    currentKey := aPane selectedItem.
    self
        changed: #parameterDetail:;
        changed: #currentValue:;
        changed: #currentBooleanValue:;
        yourself! 
removeCurrentGroup: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    | file result line path detect detected |
    (MessageBox confirm: 'Seguro borra el grupo ',currentGroup)
    ifFalse: [^self].
    CursorManager execute change.
    detected := false.
    detect := [
        detected not and: [
            detected := (line trimBlanks indexOfCollection: '[',currentGroup,']') = 1 ]
    ].
    result := WriteStream on: String new.
    file := self openFile.
    [ file atEnd ] whileFalse: [
        line := file nextLine.
        detect value
        ifTrue: [
            [   line := String new.
                file atEnd or: [
                    line := file nextLine.
                    line trimBlanks notEmpty
                    and: [line trimBlanks first = $[]
                ]
            ] whileFalse: [  ].
            result nextPutAll: line;cr
        ]
        ifFalse: [ result nextPutAll: line;cr ]
    ].
    path := file file pathName.
    file close.
    (File newFile: path)
        nextPutAll: result contents trimBlanks;
        close.
    self fileIn.
    CursorManager normal change.

    self
        changed: #groupContents:;
        changed: #parameters:! 
removeCurrentParameter: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    (MessageBox confirm: 'Seguro borra el parmetro ',currentKey,' ?')
    ifFalse: [^self].
    CursorManager execute change.
    profiler
        applicationName: currentGroup;
        at: currentKey put: String new.
    self fileIn.
    CursorManager normal change.
    self changed: #parameters:!  
removeGroup: aGroup
    "Private - Removes aGroup..."

   ^self settings removeKey: aGroup ifAbsent: []!   
removeKey: aKey in: aGroup
    "Private - Removes aKey in aGroup..."

   ^(self contentsOfGroup: aGroup)
        removeKey: aKey ifAbsent: []!
scan: aStream
    "Private - Scan aStream fillin in settings"

    | char line
      initComments comments
      getGroup getComment getEntry |

    initComments := [
        comments := WriteStream on: String new
    ].

    getComment := [:stream|
        stream countBlanks.
        stream peek = $;
        ifTrue: [stream next].
        (stream upTo: nil) trimBlanks
    ].

    getGroup := [ "Scan group header"
        initComments value.
        aStream next.
        currentGroup := aStream upTo: $].
        self
            createGroup: currentGroup
            comment: (getComment
                value: aStream nextLine asStream).
    ].

    getEntry := [:stream| "Get next key entry pair"
        self
            addTo: currentGroup
            key: (stream upTo: $=)
            value: stream nextLine
            comment: comments contents
    ].

    initComments value.
    [aStream atEnd] whileFalse: [
        aStream countBlanks.
        char := aStream peek.
        char = $[
        ifTrue: [ getGroup value ]
        ifFalse: [
            char = $;
            ifTrue: [
                comments cr;nextPutAll:
                    (getComment value: aStream nextLine asStream)
            ]
            ifFalse: [
                line := aStream nextLine.
                line trimBlanks isEmpty
                ifTrue: [ initComments value ]
                ifFalse: [ getEntry value: line asStream ]
            ]
        ].
    ]! 
setCurrentBooleanValue: aPane

    "Callback for the #clicked event in an unnamed CheckBox (contents is 'Habilitado/a').
     (Generated by WindowBuilder)"

    currentGroup isNil ifTrue: [^self].
    self setValueOf: currentKey in: currentKey to: aPane selection asString!   
settings
    "Private - Returns the filed in settings"

    settings isNil ifTrue: [ self fileIn ].
    ^settings!
setValueOf: aKey in: aGroup to: aValue
    "Private - Set the value aValue to aKey in aGroup"

    profiler
        applicationName: currentGroup;
        at: currentKey put: aValue.

    self
        addTo: aGroup
        key: aKey
        value: aValue
        comment: (self commentsOf: aKey in: aGroup)!
stripPrivates
    "Private - Extracts the private sections..."

    self groups do: [:aGroup|
        ((self commentsOfGroup: aGroup) indexOfCollection: 'Private') ~= 0
        ifTrue: [ self removeGroup: aGroup ]
        ifFalse: [
            (self contentsOfGroup: aGroup) keys do: [:aKey|
                ((self commentsOf: aKey in: aGroup) indexOfCollection: 'Private') ~= 0
                ifTrue: [ self removeKey: aKey in: aGroup ]
            ]
        ]
    ].! !

! ListDialog class methods ! 
heightInDialogUnits: heightInPoints
        " Private - answer heightInPoints as a height in
        in dialog box units, rounded up to the next
        character box boundary. "

    | charHeightPts nLines |
    charHeightPts := WindowDialog dialogUnit y.
    nLines := heightInPoints // charHeightPts.
    ( heightInPoints \\ charHeightPts ) > 0
        ifTrue: [ nLines := nLines + 1 ].
    ^nLines * WindowDialog charHeight!
initialize
        " Private - class initialization. "
    | platform product hostConstants |

    product := Smalltalk product.
    ( (product = 'Smalltalk/V Windows')
    or: [product = 'Smalltalk/V for Win32'] )
        ifTrue: [
            platform := 'VW'.
            hostConstants := Smalltalk at: #WinConstants].
    ( (product = 'Smalltalk/V PM')
    or: [product = 'Smalltalk/V for OS/2'])
        ifTrue: [
            platform := 'VOS'.
            hostConstants := Smalltalk at: #PMConstants].
    platform isNil ifTrue: [self error: 'unknown Smalltalk/V product'].

    " Dialog top pane style constants "
    (platform = 'VW')
        ifTrue: [
            FrameStyle := 0.
            #( 'DsModalframe' 'WsCaption' 'WsSysmenu'
                    'DsNoidlemsg' 'WsClipchildren' 'WsVisible' )
                do: [ :styleName |
                    FrameStyle := FrameStyle |
                        (hostConstants at: styleName) ] ].
    (platform = 'VOS')
        ifTrue: [FrameStyle := nil].  " use default "!
new
    ^super new initialize!   
widthInDialogUnits: widthInPoints
        " Private - answer widthInPoints as a width in
        in dialog box units, rounded up to the next
        character box boundary. "

    | charWidthPts nChars |
    charWidthPts := WindowDialog dialogUnit x.
    nChars := widthInPoints // charWidthPts.
    ( widthInPoints \\ charWidthPts ) > 0
        ifTrue: [ nChars := nChars + 1 ].
    ^nChars * WindowDialog charWidth! !

! ListDialog methods !   
cancel
        " Private - user pressed Cancel button "

    ^self close!  
cancel: aPane
    "Private - user pressed Cancel button.
    Implemented By Ale for porting to V20... "
    #addedByOStyle.
    ^self cancel! 
computeMaxEntriesToShowFor: aList in: aListPane
        " Private - adjust maxEntriesToShow if necessary,
        to ensure that this guy fits on the screen. "

    | availableLines |
    maxEntriesToShow := maxEntriesToShow isNil
        ifTrue: [ self defaultMaxEntriesToShow ]
        ifFalse: [ self numListEntries min: maxEntriesToShow ].
    availableLines :=
        ( Display height // self font height )
        - 7 " borders, title bar, buttons, internal margins"
        - textLines size.  " description text "
    maxEntriesToShow := maxEntriesToShow min: availableLines.!  
createListItemsIn: aTopPane startingAt: deltaLeftTop
        " Private - create the visual items representing
        the list.  Answer the extent.
    Touched by Ale for porting to V20..."
    | aListPane anExtent |
    aListPane := self newListPane.  " sets contents "
    anExtent := self extentForList: list in: aListPane.
    #modifiedByOStyle.
    aTopPane addSubpane:
        (aListPane
            setName: self listPaneName;
            selection: selection;
            when: #doubleClickSelect perform: #doubleClickedList:;
            "when: #doubleClicked: send: #doubleClickedList to: self;"
            framingBlock:
                (self framingBlock: deltaLeftTop extent: anExtent)).
    ^anExtent!   
createView
        " Private - create the window.
        Window sizing is done in dialog box units.
    Touched by Ale for porting to V20..."
    | charWidthDlg marginDlg topPane
      deltaLeftTop deltaTopLeft2 deltaLeftMarginX
      internalWidthDlg anExtent |

    charWidthDlg := WindowDialog charWidth.
    "lineHeightDlg := WindowDialog charHeight."
    marginDlg := charWidthDlg.

    self addView:
        (topPane := self topPaneClass new
            owner: self;
            labelWithoutPrefix: title;
            style: self defaultFrameStyle;
            "when: #cancelled send: #cancelled to: self;"
            yourself ).
    deltaLeftMarginX := marginDlg.
    deltaLeftTop := deltaLeftMarginX @ marginDlg.
    internalWidthDlg := self titleBarWidth: title.

    " create static text items for any text lines "
    textLines notNil ifTrue: [
        textLines do: [ :text |
            anExtent := self extentForLabel: text.
            topPane addSubpane:
                (StaticText new
                    font: self font;
                    contents: text;
                    framingBlock:
                        (self framingBlock: deltaLeftTop
                            extent: anExtent)).
            internalWidthDlg := internalWidthDlg max: anExtent x.
            deltaLeftTop :=
                deltaLeftMarginX
                @ (deltaLeftTop y + anExtent y)].
        deltaLeftTop :=   " vertical white space below text lines "
            deltaLeftMarginX
            @ (deltaLeftTop y + marginDlg).
        ].

    " the list "
    anExtent := self
        createListItemsIn: topPane
        startingAt: deltaLeftTop.
    internalWidthDlg := internalWidthDlg max: anExtent x.
    deltaLeftTop :=
        deltaLeftMarginX
        @ (deltaLeftTop y + anExtent y + marginDlg).

    " OK and Cancel buttons "
    anExtent := self extentForButton: 'Cancel'.
    deltaTopLeft2 :=
        (deltaLeftMarginX + anExtent x + marginDlg)
        @ deltaLeftTop y.
    #modifiedByOStyle.
    topPane addSubpane:
        (Button new
            defaultPushButton;
            font: self font;
            contents: 'OK';
            when: #clicked perform: #ok:;
            "when: #clicked send: #ok to: self ;"
            framingBlock:
                (self framingBlock: deltaLeftTop extent: anExtent)).
    #modifiedByOStyle.
    topPane addSubpane:
        (Button new
            pushButton;
            font: self font;
            contents: 'Cancel';
            when: #clicked perform: #cancel:;
            "when: #clicked send: #cancel to: self ;"
            framingBlock:
                (self framingBlock: deltaTopLeft2 extent: anExtent)).
    internalWidthDlg := internalWidthDlg max:
        ((2 * anExtent x) + marginDlg).

    clientExtentDlg :=
        (internalWidthDlg + (2 * marginDlg))
        @ (deltaLeftTop y + anExtent y + marginDlg).
    ^topPane!
defaultFrameStyle
        "Private - Answer the default frame style for the receiver."
    ^FrameStyle! 
defaultMaxEntriesToShow
        " Private "
    ^10!
doubleClickedList
        " Private - double click on list item is equivalent to OK "
    self ok!  
doubleClickedList: aPane
    " Private - double click on list item is equivalent to OK.
    Added by Ale for porting to V20..."
    #addedByOStyle.

    self doubleClickedList! 
extentForButton: aButtonLabel
        " Private - measure button and add white space around label "

    | charWidthDlg x y |
    charWidthDlg := WindowDialog charWidth.  " dialog units "
    self font = SysFont
        ifTrue: [
            x := aButtonLabel size * charWidthDlg.
            y := WindowDialog charHeight ]
        ifFalse: [
            x := self class widthInDialogUnits:
                ( self font stringWidth: aButtonLabel ).
            y := self class heightInDialogUnits: self font height ].
    ^( x + ( 2 * charWidthDlg ) )
    @ ( y + charWidthDlg )!  
extentForLabel: aLabel
        " Private - measure aLabel "

    self font = SysFont
        ifTrue: [
            ^(aLabel size * WindowDialog charWidth)
            @ WindowDialog charHeight ]
        ifFalse: [
            ^( self class widthInDialogUnits: ( self font stringWidth: aLabel ) )
            @ ( self class heightInDialogUnits: self font height ) ].!   
extentForList: aList in: aListPane
        " Private - answer the size in dialog box units
        for aList. "

    self computeMaxEntriesToShowFor: aList in: aListPane.
    ^( self listWidthDlg: aList )
    @ ( self listHeightDlg: aList in: aListPane )! 
font
        " Answer the font to use for the dialog items. "

    ^font notNil ifTrue: [ font ] ifFalse: [ SysFont ]! 
font: aFont
        " Specify the font to use for the dialog items. "

    font := aFont.! 
framingBlock: deltaLeftTop extent: extent
        " Private - answer the framing block for
        a window whose leftTop corner is deltaLeftTop
        from the upper left of the dialog window
        with extent. "
    ^[ :box |
        (box leftTop rightAndDown: deltaLeftTop)
        extentFromLeftTop: extent]!
initialize
        " Private "
    super initialize.
    minEntriesToShow := 1.
    returnItems := true.! 
initWindowSize
        " Answer the initial window extent of the client
        area in dialog box units. "
    ^clientExtentDlg!  
list: aPane
        " Nop - contents are set at pane creation time. "
    "DEBUG"!  
listHeightDlg: aList in: aListPane
        " Private - answer the height in dialog units "

    | nLines |
    nLines := ( aList size max: minEntriesToShow )
        min: maxEntriesToShow.
    self font = SysFont
        ifTrue: [
            ^( nLines * WindowDialog charHeight ) + 1 ]
        ifFalse: [
            ^self class heightInDialogUnits: ( nLines * self font height ) ].!
listPaneClass
        " Private "
    ^ListBox! 
listPaneName
        " Private "
    ^'listPane'!   
listWidthDlg: aList
        " Private - answer the height in dialog units.
    Touched by Ae for Object support..."

    | charWidth width |
    charWidth := WindowDialog charWidth.  " dialog units "
    width := 0.
    self font = SysFont
        ifTrue: [
            aList do: [ :el |
                width := width max: el asString size. #modifiedByOStyle ].
            width := width * charWidth ]
        ifFalse: [
            aList do: [ :el |
                width := width max: (self font stringWidth: el asString). #modifiedByOStyle. ].
            width := self class widthInDialogUnits: width ].
    width := width + ( 5 * charWidth ).  " scroll bar fudge "  " old: 4 "
    ^width!  
maxEntriesToShow: anInteger
    maxEntriesToShow := anInteger!   
minEntriesToShow: anInteger
    minEntriesToShow := anInteger!   
newListPane
        " Private - answer an initialized list pane. "
    ^self listPaneClass new
        font: self font;
        contents: list;
        yourself!
numListEntries
        " Private "
    ^list size!  
ok
        " Private - user pressed OK button. "
    self
        saveSelection;
        close.!  
ok: aPane
    " Private - user pressed OK button.
    Implemented By Ale for porting to V20... "
    #addedByOStyle.
    ^self ok!
openOn: aList
        " Open a list dialog displaying aList.
        Default is to select the first entry. "
    ^self openOn: aList selection: 1! 
openOn: aList selection: initialSelection
        " Open a list dialog displaying aList, with initialSelection
        as the initial selection. "
    | topPane |
    aList size = 0
        ifTrue: [ ^nil ].
    list := aList.
    selection := initialSelection.
    topPane := self createView.
    selection := nil.
    topPane openModal: pmOwner.
    ^selection!
pmOwner: aWindow
        " Set the owner of a modal dialog.  Should not
        generally be needed. "
    pmOwner := aWindow.!
returnItems: aBoolean
        " Specify whether to return selection as item or index. "
    returnItems := aBoolean.!   
saveSelection
        " Private "
    | listPane |
    listPane := self paneAt: self listPaneName.
    selection := (returnItems
        ifTrue: [listPane selectedItem]
        ifFalse: [listPane selectedIndex]).!   
textLines: oneOrMoreStrings
        " Specify one or more strings to be displayed
        at the top of the window. "
    textLines := (oneOrMoreStrings isString
        ifTrue: [Array with: oneOrMoreStrings]
        ifFalse: [oneOrMoreStrings]).!  
title: aString
        " Specify the title of the window "
    title := aString!
titleBarWidth: aString
        " Private - answer the width of a titleBar containing
        a system menu and aString (dialog box units). "
    ^(aString size + 4) * WindowDialog charWidth    " fudge sysMenu width "! !

! MultiSelectListDialog methods !   
doubleClickedList
        " Private - double click on list item is ignored in multi-select guy "!
listPaneClass
        " Private "
    ^MultipleSelectListBox!   
openOn: aList
        " Open a multi-select list dialog displaying aList.
        Default is to select none of the entries."
    ^self openOn: aList selection: Array new! 
saveSelection
        " Private - user selected zero or more entries "
    | listPane |
    listPane := self paneAt: self listPaneName.
    selection := (returnItems
        ifTrue: [listPane selectedItems]
        ifFalse: [listPane selections]).! !

! RadioButtonDialog methods ! 
createListItemsIn: aTopPane startingAt: initialDeltaLeftTop
        " Private - create the visual items representing
        the list.  Answer the extent.
    Touched by Ale for Object support.
    Touched by Ale for porting to V20..."

    | lineHeight totalExtent itemExtent deltaLeftTop
      aRadioButton selectedIndex |

    lineHeight := WindowDialog charHeight + 1.
    totalExtent :=
        ( self listWidthDlg: list )
        @ (list size  * lineHeight).
    itemExtent := totalExtent x @ lineHeight.

    deltaLeftTop := initialDeltaLeftTop.
    radioButtons := Array new: list size.
    1 to: list size do: [ :i |
        aTopPane addSubpane:
            ( (aRadioButton := RadioButton "auto" new autoRadioButton;yourself) "<--patch..."
                font: self font;
                contents: "label:" (list at: i) asString; "<--patch..."
                framingBlock:
                    (self framingBlock: deltaLeftTop extent: itemExtent) ). #modifiedByOStyle.
        radioButtons at: i put: aRadioButton.
        deltaLeftTop :=
            deltaLeftTop x
            @ (deltaLeftTop y + itemExtent y).
        ].
    selectedIndex := ( selection isInteger
        ifTrue: [ selection ]
        ifFalse: [ list indexOf: selection ifAbsent: [ 1 ] ] ).
    (radioButtons at: selectedIndex) "value:"selection: true. #modifiedByOStyle.
    ^totalExtent!
listWidthDlg: aList
        " Private - answer the height in dialog units.
    Touched by Ale for object support..."

    | charWidth width |
    charWidth := WindowDialog charWidth.  " dialog units "
    width := 0.
    self font = SysFont
        ifTrue: [
            aList do: [ :el |
                width := width max: el asString size. #modifiedByOStyle ].
            width := width * charWidth ]
        ifFalse: [
            aList do: [ :el |
                width := width max: (self font stringWidth: el asString). #modifiedByOStyle ].
            width := self class widthInDialogUnits: width ].
    width := width + ( 4 * charWidth ).  " radio button fudge "
    ^width!
saveSelection
        " Private
    Touched by Ale for porting to V20..."
    #modifiedByOStyle.
    1 to: list size do: [ :i |
        (radioButtons at: i) selection "value   <--patch"
            ifTrue: [
                selection := ( returnItems
                    ifTrue: [ list at: i ]
                    ifFalse: [ i ] ).
                ^self ] ].! !

! ObjectLoadDialog class methods ! 
availableListHeight
        " Private - answer the height in screen points that
        is available for use by the variable lists and their
        titles in order to ensure that the Ok/Cancel buttons
        are visible.  Estimate size of caption, borders, and
        description text at 7 lines. "
    ^Display height - (7 * SysFont height)!   
initialize
        " Private - initialize platform-dependent constants.
        (Portability workaround due to lack to common
        system constants dictionary that maps to platform.
        Objective here is source-code portability.) "
    | product hostConstants |

    Platform := nil.
    product := Smalltalk product.
    (product = 'Smalltalk/V Windows')
        ifTrue: [
            Platform := 'VW'.
            hostConstants := Smalltalk at: #WinConstants].
    (product = 'Smalltalk/V PM')
        ifTrue: [
            Platform := 'VPM'.
            hostConstants := Smalltalk at: #PMConstants].
    Platform isNil ifTrue: [self error: 'unknown Smalltalk/V product'].

    " instance method childFrameStyle "
    Platform = 'VW'
        ifTrue: [ChildFrameStyle :=
            (hostConstants at: 'WsChild')   |
            (hostConstants at: 'WsVisible') |
            (hostConstants at: 'WsClipsiblings') |
            (hostConstants at: 'WsClipchildren')].
    Platform = 'VPM'
        ifTrue: [ChildFrameStyle :=
            (hostConstants at: 'FcfNobytealign')].! 
maximumListSize
        " Answer the maximum number of source or
        destination variables that can be displayed
        in an ObjectLoadDialog on this system. "
    ^(self availableListHeight // self basicNew labelFont height)
        - 1  " exclude title line "! 
new
    ^super new initialize! !

! ObjectLoadDialog methods ! 
cancel: aPane
        " Private - user pressed Cancel button "
    loadMap := nil.
    self close.!
childFrameStyle
        " Private - my child windows have no scrollbars, no border "
    ^ChildFrameStyle  " factored to class var for portability "!   
computeExtentOf: anArrayOfStrings title: title
        " Private - Answer the extent of a bounding box
        which contains a vertical list of anArrayOfStrings
        under the title. "
    | font width |
    font := self labelFont.
    width := font stringWidth: title.
    anArrayOfStrings do: [ :aString |
        width := width max: (font stringWidth: aString)].
    ^width @ ((1 + anArrayOfStrings size) * font height)!  
createClientArea
        " Private - compute client area layout and create windows.
        Answer whether successful (need enough screen space).
        The graph pane layout for the instance variable load map
        is computed in screen points.  However, all the window
        sizing has to be done in dialog box units.  So
        normalize everything into character box units and do
        lots of ugly conversions from points to dialog box units. "
    | windowLabel charWidthDlg lineHeightDlg
      margin marginDlg gutter
      sourceListExtent destListExtent
      descrWidthDlg descrExtentDlg
      oneButtonExtentDlg buttonsExtentDlg
      topPane |

    windowLabel := 'Object Load Map'.

    charWidthDlg := WindowDialog charWidth.
    lineHeightDlg := WindowDialog charHeight.

    margin := WindowDialog dialogUnit x.
    marginDlg := WindowDialog charWidth.
    gutter := margin * 4.
    lineHeight := WindowDialog dialogUnit y.

    " compute the internal load map pane layout in points "
    sourceListExtent := self extentRounded:
        (self computeExtentOf: sourceList title: sourceTitle).
    destListExtent := self extentRounded:
        (self computeExtentOf: destList title: destTitle).
    listColumns := Array new: 4.
    listColumns   " ASSERT [Rectangle leftTopUnit x = 0] "
        at: 1 put: margin;  " left margin of source var list "
        at: 2 put: ((listColumns at: 1) right: sourceListExtent x);  " source var plugs "
        at: 3 put: ((listColumns at: 2)
                    right: (self plugExtent x + gutter));   " dest var sockets "
        at: 4 put: ((listColumns at: 3)
                    right: self socketExtent x).  " dest vars "
    listRect :=
        0 @ 0
        extent: (self extentRounded:
            (((listColumns at: 4) right: (destListExtent x + margin))
            @ (sourceListExtent y max: destListExtent y))).

    " make sure there's enough screen real estate to see buttons "
    (listRect height > self class availableListHeight)
        ifTrue: [
            MessageBox
                notify: windowLabel
                withText: 'Not enough screen space: ', description.
            ^false].

    " compute overall window layout in dialog box units "
    descrWidthDlg := description size * charWidthDlg.
    descrExtentDlg :=
        (descrWidthDlg @ lineHeightDlg) + (2 * marginDlg).
    oneButtonExtentDlg :=
        (('Cancel' size * charWidthDlg) @ lineHeightDlg)
        + marginDlg.
    buttonsExtentDlg :=
        ((3 * marginDlg) + (2 * oneButtonExtentDlg x))
        @ ((2 * marginDlg) + oneButtonExtentDlg y).
    clientExtentDlg :=
        (((((windowLabel size * charWidthDlg)
            max: descrExtentDlg x)
            max: (self widthInDialogUnits: listRect width))
            max: buttonsExtentDlg x) + marginDlg) " PM width fudge "
        @ (descrExtentDlg y + 2  " need top fudge factor for list??"
                + (self heightInDialogUnits: listRect height)
                + buttonsExtentDlg y).

    self addView:
        (topPane := self topPaneClass new
            owner: self;
            labelWithoutPrefix: windowLabel
            "Disable, not yet supported (VW 1.1/VPM 1.3 bug):
            when: #close perform: #close:
            "
            ).

    topPane addSubpane:
        (StaticText new
            contents: description;
            framingBlock: [ :box |
                (box leftTop rightAndDown: marginDlg)
                extentFromLeftTop: (descrWidthDlg @ lineHeightDlg)]).

    topPane addSubpane:
        (GraphPane new
            owner: self;
            style: self childFrameStyle;
            when: #getContents perform: #display:;
            when: #display perform: #display:;
            when: #button1Up perform: #select:;
            framingBlock: [ :box |
                 Rectangle
                    leftTop: (box leftTop down: descrExtentDlg y)
                    rightBottom: (box rightBottom up: buttonsExtentDlg y)]).

    topPane addSubpane:
        (Button new
            defaultPushButton;
            owner: self;
            contents: 'OK';
            when: #clicked perform: #ok:;
            framingBlock: [ :box |
                (box leftBottom rightAndUp: marginDlg)
                extentFromLeftBottom: oneButtonExtentDlg]).
    showCancel ifTrue: [topPane addSubpane:
        (Button new
            pushButton;
            owner: self;
            contents: 'Cancel';
            when: #clicked perform: #cancel:;
            framingBlock: [ :box |
                (box leftBottom rightAndUp:
                    (2 * marginDlg + oneButtonExtentDlg x) @ marginDlg)
                extentFromLeftBottom: oneButtonExtentDlg])].
    ^true!  
display: graphPane
        "Private - Display source and dest instance variable lists. "
    | pen |
    pen := graphPane pen.
    pen foreColor: ClrBlack.
    self
        displayList: sourceList
            title: sourceTitle
            at: ((listColumns at: 1) @ listRect top)
            with: pen;
        displayList: destList
            title: destTitle
            at: ((listColumns at: 4) @ listRect top)
            with: pen;
        displayLoadMap: graphPane.!  
displayConnectorFrom: leftTopPlug to: leftTopSocket with: pen color: color
        " Private - display connector from plug to socket "
    | halfHeight start end |
    halfHeight := lineHeight // 2.
    start := leftTopPlug
        rightAndDown: ((self plugExtent x + 1) @ halfHeight).
    end := leftTopSocket
        rightAndDown: ((halfHeight - 4) @ halfHeight).
    pen
        setLineWidth: 3;
        foreColor: color;
        place: start; 
        goto: end.!   
displayList: list title: titleString at: leftTop with: pen
        " Private - display list of strings "
    | loc |
    loc := leftTop down: (lineHeight - self labelFont descender).
    pen displayText: titleString at: loc.
    loc := loc down: lineHeight.
    list do: [ :aString |
        pen displayText: aString at: loc.
        loc := loc down: lineHeight].!  
displayLoadMap: graphPane
        "Private - Display plugs and sockets for inst var wiring."
    | pen top leftTopPlug leftTopSocket color sourceIndex |

    pen := graphPane pen.
    top := listRect top down: lineHeight.

    leftTopPlug := (listColumns at: 2) @ nil.  " y is set below "
    leftTopSocket := (listColumns at: 3) @ top.
    1 to: loadMap size do: [ :i |
        sourceIndex := loadMap at: i.
        color := (sourceIndex isNil ifTrue: [ClrRed] ifFalse: [ClrGreen]).
        self displaySocketAt: leftTopSocket with: pen color: color.
        sourceIndex notNil ifTrue: [
            leftTopPlug y: (top down: ((sourceIndex - 1) * lineHeight)).
            self
                displayPlugAt: leftTopPlug
                with: pen color: color.
            self
                displayConnectorFrom: leftTopPlug to: leftTopSocket
                with: pen color: color].
        leftTopSocket := leftTopSocket down: lineHeight].

    leftTopPlug := (listColumns at: 2) @ top.
    1 to: sourceList size do: [ :i |
        (loadMap includes: i)
            ifFalse: [self displayPlugAt: leftTopPlug with: pen color: ClrRed].
        leftTopPlug := leftTopPlug down: lineHeight].! 
displayPlugAt: leftTop with: pen color: color
        " Private - display source variable plug "
    | rect points |
    rect := leftTop extentFromLeftTop: self plugExtent.
    points := Array
        with: (rect leftTop rightAndDown: 2)
        with: (rect leftBottom rightAndUp: 2)
        with: (rect rightTop down: (rect height // 2)).
    self displayPolygon: points with: pen color: color.!  
displayPolygon: points with: pen color: color
        " Private - display filled polygon with pen. "
    "DISABLE: border painting looks tacky on VPM [DJL 20-Feb-92]
    self platform = 'VPM'
        ifTrue: [  
            pen
                setLineWidth: 5;
                foreColor: ClrDarkgray;
                setLineEnd: LineEndRound;  // kludge for setLineJoin: LinejoinRound//
                polygon: points;
                setLineEnd: LineEndDefault;
                foreColor: color].
    self platform = 'VW'
        ifTrue: [pen foreColor: ClrDarkgray].
    "
    pen
        setLineWidth: 1;
        foreColor: color;
        setFillColor: color;
        polygonFilled: points.!
displaySocketAt: leftTop with: pen color: color
        " Private - display destination variable socket "
    |  rect halfHeight points |
    rect := leftTop extentFromLeftTop: self socketExtent.
    halfHeight := rect height // 2.
    points := Array new: 5.
    points
        at: 1 put: (rect leftTop down: 2);
        at: 2 put: (rect rightTop leftAndDown: (3 @ 2));
        at: 3 put: (rect rightBottom leftAndUp: (3 @ 2));
        at: 4 put: (rect leftBottom up: 2);
        at: 5 put: (rect leftTop rightAndDown:
                            ((halfHeight - 2) @ halfHeight)).
    self displayPolygon: points with: pen color: color.!   
eraseLoadMap: graphPane
        "Private - Erase loadMap area of graphPane."
    graphPane pen
        fill: (Rectangle
            leftTop: ((listColumns at: 2) @ listRect top)
           rightBottom: ((listColumns at: 4) @ listRect bottom))
        color: ClrBackground!
extentRounded: extentInPoints
        " Private - answer extentInPoints rounded up to the
        next character boundary. "
    | charBoxPts nCharsWide nLines |
    charBoxPts := WindowDialog dialogUnit.
    nCharsWide := extentInPoints x // charBoxPts x.
    (extentInPoints x \\ charBoxPts x) > 0
        ifTrue: [nCharsWide := nCharsWide + 1].
    nLines := extentInPoints y // charBoxPts y.
    (extentInPoints y \\ charBoxPts y) > 0
        ifTrue: [nLines := nLines + 1].
    ^(nCharsWide @ nLines) * WindowDialog dialogUnit!   
heightInDialogUnits: heightInPoints
        " Private - answer heightInPoints as a height in
        in dialog box units, rounded up to the next
        character box boundary. "
    | charHeightPts nLines |
    charHeightPts := WindowDialog dialogUnit y.
    nLines := heightInPoints // charHeightPts.
    (heightInPoints \\ charHeightPts) > 0
        ifTrue: [nLines := nLines + 1].
    ^nLines * WindowDialog charHeight!  
indexOfPlug: aPoint
        " Private - answer the source list index corresponding
        to the plug at aPoint. "
    ^self
        indexOfShapeAt: aPoint
        numShapes: sourceList size
        left: (listColumns at: 2)
        width: self plugExtent x!
indexOfShapeAt: aPoint
    numShapes: numShapes
    left: left
    width: width
        " Private - answer the index corresponding
        to the plug or socket shape at aPoint.
        There are numShapes stacked vertically
        in listRect starting at left border."
    | top rect |
    top := listRect top down: lineHeight.
    rect := left @ top
        extentFromLeftTop: (width @ (numShapes * lineHeight - 1)).
    (rect containsPoint: aPoint)
        ifFalse: [^nil].
    ^((top - aPoint y) abs // lineHeight) + 1!
indexOfSocket: aPoint
        " Private - answer the dest list index corresponding
        to the socket at aPoint "
    ^self
        indexOfShapeAt: aPoint
        numShapes: destList size
        left: (listColumns at: 3)
        width: self socketExtent x!   
initialize
        " Private - initialize new instance"
    super initialize.
    showCancel := true.! 
initLoadMap
        " Private - install a default load map based on names. "
    | sourceSlots destSize |
    destSize := destList size.
    sourceSlots := Dictionary new.
    1 to: sourceList size do: [ :i |
        sourceSlots at: (sourceList at: i) put: i].
    loadMap := Array new: destSize.
    1 to: destSize do: [ :i |
        loadMap at: i
            put: (sourceSlots at: (destList at: i) ifAbsent: [nil])].! 
initWindowSize
        " Answer the initial window extent of the client
        area in dialog box units. "
    ^clientExtentDlg!  
labelFont
        " Private - answer font for displaying my labels "
    ^SysFont!  
ok: aPane
        " Private - user pressed OK button. "
    finalLoadMap := loadMap.  " workaround for missing close event "
    self close.!  
openFor: descriptionString
    sourceTitle: sourceTitleString
    sourceVars: sourceArrayOfStrings
    destTitle: destTitleString
    destVars: destArrayOfStrings
        " Open an ObjectLoadDialog.  The descriptionString
        is an information line at the top of the dialog.
        There are two stacks of zero or more instance variable
        names, source and dest, in a column under a title.
        Answer a load map for the destination variables.
        The load map is an array indexed by a destination
        instance variable index (slot index) containing
        a source instance variable index (slot number) or nil
        to load into that destination instance variable. "

    description := descriptionString.
    sourceTitle := sourceTitleString.
    sourceList := sourceArrayOfStrings.
    destTitle := destTitleString.
    destList := destArrayOfStrings.

    self initLoadMap.
    showCancel ifFalse: [finalLoadMap := loadMap].
            " workaround for not being able to catch/disable close "
    (self createClientArea)
        ifFalse: [^loadMap := nil].
    self openWindow.
    "Disable (close event not yet supported): ^loadMap"
    ^finalLoadMap!
platform
        " Private - answer whether running on VPM or VW.
        Used to implement platform compatibility workarounds. "
    ^Platform!   
plugExtent
        " Private - answer the area within which a plug shape
        is drawn. "
    ^WindowDialog dialogUnit x @ lineHeight!  
select: graphPane
        " Private - handle button1Up in inst var lists "
    | startPoint endPoint sourceIndex destIndex |
    startPoint := graphPane mouseLocation.
    sourceIndex := self indexOfPlug: startPoint.
    sourceIndex notNil ifTrue: [
        endPoint := self trackToDestFrom: startPoint in: graphPane.
        endPoint isNil ifTrue: [^self].  " ignore buttonup outside pane "
        destIndex := self indexOfSocket: endPoint.
        destIndex isNil ifTrue: [
            destIndex := loadMap indexOf: sourceIndex.
            (destIndex ~= 0)
                ifTrue: [loadMap at: destIndex put: nil]]
        ifFalse: [
            loadMap at: destIndex put: sourceIndex]]
    ifFalse: [
        destIndex := self indexOfSocket: startPoint.
        destIndex isNil ifTrue: [^self].
        endPoint := self trackToDestFrom: startPoint in: graphPane.
        endPoint isNil ifTrue: [^self].
        sourceIndex := self indexOfPlug: endPoint.
        loadMap at: destIndex put: sourceIndex].
    self
        eraseLoadMap: graphPane;
        displayLoadMap: graphPane.! 
showCancel: aBoolean
    showCancel := aBoolean! 
socketExtent
        " Private - answer the area within which a plug shape
        is drawn. "
    ^(WindowDialog dialogUnit x * 2) @ lineHeight!  
trackClipCursor: aPen to: aWindow
        " Private - restrict the cursor to aWindow.
         Specifying nil clears clipping. 
        This is only supported properly on Windows.
        On VPM, we clip display, but can't restrict the
        actual cursor movement. "
    | clippingRegion |
    self platform = 'VW'
        ifTrue: [
            clippingRegion := (aWindow isNil
                ifTrue: [nil]
                ifFalse: [
                    (Smalltalk at: #WinRectangle) fromRectangle:
                        (aWindow rectangle mapClientToScreen: aWindow)]).
            (Smalltalk at: #UserLibrary) 
                clipCursor: clippingRegion asParameter.
            ^self].
    "VPM implementation"
    self platform = 'VPM'
        ifTrue: [
            clippingRegion := (aWindow isNil
                ifTrue: [nil]
                ifFalse: [aPen createRegion: 
                        ((0@0 extent: aWindow extent) 
                              mapClientToScreen: aWindow)]).
            aPen setClipRegion: clippingRegion].!   
trackToDestFrom: aPoint in: graphPane
        " Private - track mouse until a buttonUp occurs and
        answer the point at which buttonUp occurred.
        Answer nil if buttonUp was outside graphPane.
        Tracking is done in desktop coordinates. "
    | origin dest nextDest pen targetWindow |

    graphPane captureMouseInput.
    pen := Display pen.
    pen
        setLineWidth: 1;
        foreColor: ClrBlack;
        setLineType: LineTypeSolid;     
        setForegroundMode: MixRuleInvertSurface.  " MixRuleNotXor?? "
    self trackClipCursor: pen to: graphPane parent.

    origin := aPoint mapClientToScreen: graphPane.
    dest := origin.
    pen place: origin; goto: dest.
    Notifier consumeInputUntil: [ :event |
        nextDest := Cursor sense.
        (dest = nextDest)
            ifFalse: [
                pen
                    place: origin; goto: dest;
                    place: origin; goto: nextDest.
                dest := nextDest].
        event selector = #button1Down:].
    targetWindow := CursorManager windowUnderCursor.
    Notifier consumeInputUntil: [ :event |
        event selector = #button1Up:].
    pen place: origin; goto: dest.

    pen
        setLineType: LineTypeDefault;
        setForegroundMode: MixRuleDefault.
    self trackClipCursor: pen to: nil. 
    graphPane clearMouseCapture.
   CurrentEvents := OrderedCollection new.

    dest := dest mapScreenToClient: graphPane.
    ^((0 @0 extent: graphPane rectangle extent)  " PM wierdness "
            containsPoint: dest)
        ifTrue: [dest]
        ifFalse: [nil]! 
widthInDialogUnits: widthInPoints
        " Private - answer widthInPoints as a width in
        in dialog box units, rounded up to the next
        character box boundary. "
    | charWidthPts nChars |
    charWidthPts := WindowDialog dialogUnit x.
    nChars := widthInPoints // charWidthPts.
    (widthInPoints \\ charWidthPts) > 0
        ifTrue: [nChars := nChars + 1].
    ^nChars * WindowDialog charWidth! !

! DatabaseMapper methods ! 
classesList
    "Returns the instance var of the receiver
     for external manipulation"
    ^classesList!
classesList: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    classesList := anObject!   
edit: aMap
    | aClass |
    aClass := aMap mappedClass.



    ^self
        openFor: 'Edit Mapping ', aClass dataBase, '<->', aClass name
        sourceVars:  (Table structureFor: aClass dataBase
            connect: aClass conectionString)
        destClass: aClass!  
initLoadMap
    super initLoadMap.
    classes := Array new: destList size.
    classesList isNil ifTrue: [
        classesList := OrderedCollection new.
    ].
    classesList addAllFirst: #('Boolean' 'Date' 'Number'
                'String' 'Time').!   
openFor: descriptionString
    sourceTitle: sourceTitleString
    sourceVars: fieldNames
    destTitle: className
    destVars: instNames

    | result |

    (result := super openFor: descriptionString
        sourceTitle: sourceTitleString
        sourceVars: fieldNames
        destTitle: className
        destVars: instNames) isNil ifTrue:[^nil].

    self updateMapWith: result.
    ^map! 
openFor: descriptionString
    sourceVars: fieldNames
    destClass: aClass

    | result  instNames |

    instNames := self selectorsFor: aClass new.
    map :=  DatabaseMap new mappedClass: aClass.
    ^self openFor: descriptionString
        sourceTitle: 'Record fields'
        sourceVars: fieldNames
        destTitle: 'Class ' ,  aClass name
        destVars: instNames! 
openOn: aMap
    | aClass |
    aClass := aMap mappedClass.

    ^self
        openFor: 'New Mapping ', aClass dataBase, '<->', aClass name
        sourceVars:  (Table structureFor: aClass dataBase
            connect: aClass conectionString)
        destClass: aClass! 
select: graphPane
        " Private - handle button1Up in inst var lists "
    | startPoint endPoint sourceIndex destIndex className indexLink backup |
    startPoint := graphPane mouseLocation.
    sourceIndex := self indexOfPlug: startPoint.
    sourceIndex notNil ifTrue: [
        endPoint := self trackToDestFrom: startPoint in: graphPane.
        endPoint isNil ifTrue: [^self].  " ignore buttonup outside pane "
        destIndex := self indexOfSocket: endPoint.
        destIndex isNil ifTrue: [
            destIndex := loadMap indexOf: sourceIndex.
            (destIndex ~= 0)
                ifTrue: [indexLink :=nil]]
        ifFalse: [
            indexLink := sourceIndex]]
    ifFalse: [
        destIndex := self indexOfSocket: startPoint.
        destIndex isNil ifTrue: [^self].
        endPoint := self trackToDestFrom: startPoint in: graphPane.
        endPoint isNil ifTrue: [^self].
        sourceIndex := self indexOfPlug: endPoint.
        indexLink := sourceIndex].

    (destIndex ~= 0) ifTrue: [
        backup := loadMap at: destIndex.
        loadMap at: destIndex put: indexLink.
        self
            eraseLoadMap: graphPane;
            displayLoadMap: graphPane.

            className := ListDialog new
                openOn: classesList
                title: 'Class for this Instance?'.

        className = ''
        ifTrue: [
            ^ classes at: destIndex put: nil
        ].

        className isNil ifTrue: [
            loadMap at: destIndex put: backup.
            self
                eraseLoadMap: graphPane;
                displayLoadMap: graphPane.
        ] ifFalse: [
            (classesList includes: className) ifFalse: [
                classesList add: className
            ].
            classes at: destIndex put: className.
        ]
    ]! 
selectorsFor: anObject
    "Private - Returns the name of the elements in the list
      for anObject"
    | instances selectors selector |

    selectors  := OrderedCollection new.

    "Add instancesas default list contents..."
    instances := anObject class allInstVarNames.
    1 to: instances size do: [:i|
        (anObject respondsTo:
             (selector := instances at: i) asSymbol)
        ifTrue: [selectors add: selector]
    ].

    "Add services based on anObject class..."
    (anObject class respondsTo: #databaseAddsOnFor:)
    ifTrue: [
        selectors addAll: (anObject class databaseAddsOnFor: anObject)
    ].
    (anObject class respondsTo: #databaseAddsOn)
    ifTrue: [
        selectors addAll: anObject class databaseAddsOn
    ].

    "Remove non deseable services..."
    selectors := selectors asSet.
    (anObject class respondsTo: #nonDatabaseAddsOnFor:)
    ifTrue: [
        (anObject class nonDatabaseAddsOnFor: anObject)
        do: [:each| selectors remove: each ifAbsent: []]
    ].
    (anObject class respondsTo: #nonDatabaseAddsOn)
    ifTrue: [
        anObject class nonDatabaseAddsOn
        do: [:each| selectors remove: each ifAbsent: []]
    ].

    ^selectors asSortedCollection asArray!
updateMapWith: result
    |  collection dictFields
        oneMap instName fieldName |

    " -- Make the resulting object of the mapping"


    dictFields := Dictionary new.

    1 to: destList size do: [:index |
        index isNil ifFalse: [
            instName := destList at: index.
            fieldName := (result at: index) isNil ifFalse: [
                    sourceList at: (result at: index)
            ] ifTrue: [nil].

            fieldName isNil ifFalse: [
                " -- mapping of a field -- "
                oneMap := FieldMap new.
                "instance name"
                oneMap name: instName;
                    setMessage: (instName,':') asSymbol;
                    getMessage: instName asSymbol.
                oneMap conversionClass: (
                    (classes at: index) notNil
                    ifTrue: [  (Smalltalk at: (classes at: index) asSymbol ifAbsent: []) ]
                    ifFalse: [nil]).
                dictFields at: fieldName put: oneMap.
            ].
        ].
    ].

    ^map tupleMap: dictFields.! !

! OSDialog class methods ! 
allObjects
    "Returns the most used objects cache"
    ^OSViewManager allObjects! 
atKey: aKey
    "Returns the Application Object  named aKey;
     if absent returns nil"
    ^self atKey: aKey ifAbsent: [ ]!  
atKey: aKey ifAbsent: aBlock
    "Returns the Application Object  named aKey
     if absent evaluates aBlock"
    ^self allObjects at: aKey ifAbsent: aBlock.! 
atKey: aKey put: anObject
    "Places anObject as an object named aKey.
     if anObject isNil removes it "
    anObject isNil
    ifTrue: [
        self allObjects removeKey: aKey ifAbsent: [].
        ^nil
    ].
    ^self allObjects at: aKey put: anObject!   
open
    "Creates an instance of the receiver and opens it..."
    ^self new open! !

! OSDialog methods !
beep
    "Private - Produces a Beep"

    UserLibrary messageBeep: 0!  
defaultFont
    "Private - Returns the default font of the receiver"

    ^OSViewManager defaultFont!  
disable: aControl
    "Private - Disable a pane or more panes.
     aControl can be :
        1.- aPane to be disabled.
        2.- aSymbol that is the pane's getContents symbol
        3.- anArray of Symbols/Panes
    "

    aControl isArray ifFalse: [^self disable: (Array with: aControl)].
    aControl do: [:each|
        self send: #disable
            to: (each isSymbol
                ifTrue: [self paneAt: each]
                ifFalse: [each])
    ]!
enable: aControl
    "Private - Enable a pane or more panes.
     aControl can be :
        1.- aPane to be enabled.
        2.- aSymbol that is the pane's getContents symbol
        3.- anArray of Symbols/Panes
    "

    aControl isArray ifFalse: [^self enable: (Array with: aControl)].
    aControl do: [:each|
        self send: #enable
            to: (each isSymbol
                ifTrue: [self paneAt: each]
                ifFalse: [each])
    ]! 
enable: aControl when: aCondition
    "Private - Enable a pane or more panes when aCondition is met.
     aCondition can be aBoolean or a non parameter block to be evaluated.
    "
    | enable |
    enable := aCondition isBoolean
        ifTrue: [aCondition]
        ifFalse: [aCondition value].
    enable
    ifTrue: [ self enable: aControl ]
    ifFalse: [ self disable: aControl ]!  
execute: command
    "Private - Execute the DOS command line in command.
     Notify the user if an error has been signaled..."

    | result |

    result := KernelLibrary
        winExec: command asParameter
        cmdShow: SwShowminimized.

    result < 32 "An Error has occurred"
    ifTrue: [ self showExecError: result ].

    ^result!   
fullUpdate
    "Private - Refreshes all the panes."

    views do: [:aView|
        aView children do: [:each|
            (each handlesEvent: #getContents)
            ifTrue: [each event: #getContents]
        ]
    ]!  
model
    "Private - Returns the current Application model"
    ^self class atKey: #model!  
openModeless
    "Private - Set the icon of the receiver and open the window"

    self mainView icon: self icon.
    ApplicationSystem setUpHelpManagerFor: self.
    super openModeless.!  
openWindow
    "Private - Set the icon of the receiver and open the window"

    self mainView icon: self icon.
    StartUpApplication setUpHelpManagerFor: self.
    super openWindow.! 
profiler
    "Private - Returns the profiler for the receiver.
     Or nil..."
    | profiler |
    profiler := ApplicationSystem profiler.
    profiler applicationName: self class name.
    ^profiler!   
send: aSymbol to: aPane
    "Private - Send a Symbol message to aPane;
    The message will be send in deferred mode"

   ^self send: aSymbol to: aPane withArguments:  Array new!
send: aSymbol to: aPane withArguments: arguments
    "Private - Send a Symbol message to aPane;
    The message will be send in deferred mode"

    (Message new
        receiver: aPane
        selector: aSymbol
        arguments: arguments) performDeferred.! 
showExecError: anInteger
    "Private - An error loading program has occurred.
     Notify the user about this"
    | errors label |
    errors := #(
        (0  'Out of memory')
        (2  'File not found')
        (3  'Path not found')
        (5  'Attempt to dynamically link to a task')
        (6  'Library requires separate data segments for each task')
        (10 'Incorrect Windows version')
        (11 'Invalid .Exe file')
        (12 'OS/2 Application')
        (13 'DOS 4.0 Application')
        (14 'Unknown .Exe type')
        (15 'Attempt in protected (std or 386 enanced) mode to load
 an .Exe created for an earlier version of Windows.')
        (16 'Attempt to load a second instance of an .Exe
 containing multiple, writable data segments.')
        (17 'Attempt in large-frame EMS mode to load a
 second instance of an application that links to
 certain nonshareale DLLs already in use')
        (18 'Attempt in real mode to load an application
 marked for protected mode only')
    ).

    errors do: [:each|
        each first = anInteger
        ifTrue: [label := each last]
    ].
    label isNil ifTrue: [label := 'Error de ejecucin desconocido : ', anInteger printString].

    self
        beep;
        warning: label!   
toolDebug
    "Private - Inspect the receiver..."

    Smalltalk isRunTime
    ifTrue: [
        ^self
            beep;
            message: 'Las opciones de debuggin estn desabilitadas'
    ].
    self inspect!
toolHalt
    "Private - Halt the receiver..."

    Smalltalk isRunTime
    ifTrue: [
        ^self
            beep;
            message: 'Las opciones de debuggin estn desabilitadas'
    ].
    self halt!   
warning: aLabel
    "Log the message aLabel and alert the user..."

    ^ApplicationSystem warning: aLabel! !

! CDGuiaDialog methods !  
mapView
    "Private - returns current mapView.
    Used for Spelled dict edit & viewMap"

    ^self mapViewFor: self speller!
mapViewFor: aSpeller
    "Private - returns current mapView.
    Used for Spelled dict edit & viewMap"

    | hack |

    "do some hacking to find parent..."
    hack := Notifier windows
        detect: [:window|
            window owner ~= self
            and: [ (window owner respondsTo: #speller)
            and: [ (window owner respondsTo: #map"View")
            and: [ window owner speller == aSpeller ]]]
        ] ifNone: [ ^nil ].
    ^hack owner map"View" asView! !

! AddressFinderPrompt class methods !  
wbCreated

    ^true! !

! AddressFinderPrompt methods !  
accept: aPane

    "Callback for the #clicked event in an unnamed Button (contents is '&Aceptar').
     (Generated by WindowBuilder)"

    self close.!  
acceptButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is '&Aceptar').
     (Generated by WindowBuilder)"

    self enable: aPane when: selected notNil!   
allSuggestions: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    allSuggestions := anObject! 
allwaysAccept: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Aceptar &siempre').
     (Generated by WindowBuilder)"

    speller xRef
        addLast: (Array
            with: speller searching
            with: selected).
    self accept: aPane.! 
allwaysAcceptButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Aceptar &siempre').
     (Generated by WindowBuilder)"

    self enable: aPane when: selected notNil!
allwaysIgnore: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Ign&orar siempre').
     (Generated by WindowBuilder)"

    speller ignoreList add: speller searching.
    self ignore: aPane.!   
allwaysIgnoreButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Ign&orar siempre').
     (Generated by WindowBuilder)"!
bestRanked: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    bestRanked := anObject! 
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is '&Cancelar').
     (Generated by WindowBuilder)"

    speller cancelled: true.
    self ignore: nil!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Bsqueda de calles';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1097 @ 408; xC; yC; cRDU: (11 @ 398 rightBottom: 1086 @ 48));
            pStyle: #(sysmenu titlebar modal);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 832 @ 306; lDU: 9 r: #left; tDU: 38 r: #top);
                    contents: 'Sugerencias';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 0 r: #left; rDU: 192 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'No se encontr:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 855 @ 32; lDU: 206 r: #left; rDU: 1061 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    startGroup;
                    when: #getContents perform: #streetName:;
                    contents: 'calle...';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 56; lDU: 421 r: #left; rDU: 558 r: #left; tDU: 64 r: #top; bDU: 120 r: #top);
                    startGroup;
                    contents: 'Mostrar las calles con:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 818 @ 212; lDU: 16 r: #left; rDU: 834 r: #left; tDU: 126 r: #top; bDU: 338 r: #top);
                    defaultStyle;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #streetsList:;
                    when: #select perform: #streetSelected:;
                    when: #doubleClickSelect perform: #streetDoubleclicked:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 56; lDU: 848 r: #left; rDU: 1067 r: #left; tDU: 52 r: #top; bDU: 108 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #acceptButton:;
                    when: #clicked perform: #accept:;
                    contents: '&Aceptar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 56; lDU: 848 r: #left; rDU: 1067 r: #left; tDU: 108 r: #top; bDU: 164 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #allwaysAcceptButton:;
                    when: #clicked perform: #allwaysAccept:;
                    contents: 'Aceptar &siempre';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 56; lDU: 848 r: #left; rDU: 1067 r: #left; tDU: 170 r: #top; bDU: 226 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancelar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 56; lDU: 848 r: #left; rDU: 1067 r: #left; tDU: 232 r: #top; bDU: 288 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #ignoreButton:;
                    when: #clicked perform: #ignore:;
                    contents: '&Ignorar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 56; lDU: 848 r: #left; rDU: 1067 r: #left; tDU: 288 r: #top; bDU: 344 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #allwaysIgnoreButton:;
                    when: #clicked perform: #allwaysIgnore:;
                    contents: 'Ign&orar siempre';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 32; lDU: 201 r: #left; tDU: 84 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #showAllToggle:;
                    when: #getContents perform: #setShowAll:;
                    contents: 'Mostrar todas';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 265 @ 264; lDU: 567 r: #left; rDU: 832 r: #left; tDU: 66 r: #top; bDU: 330 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #wordsList:;
                    when: #select perform: #wordSelected:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 48; lDU: 27 r: #left; rDU: 201 r: #left; tDU: 72 r: #top; bDU: 120 r: #top);
                    add: #viewStamp selector: #viewMap;
                    add: #edit selector: #editDictionary;
                    add: #editSpell;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!  
editDictionary
    "Lets the user configure the speller"

    SearchStreetConfigurationDialog new
        parentDialog: self;
        open!  
editSpell
    "Lets the user edit the speller dictionary"

    AddressTrainerDialog new openOn: self speller!  
ignore: aPane

    "Callback for the #clicked event in an unnamed Button (contents is '&Ignorar').
     (Generated by WindowBuilder)"

    selected := nil.
    self close! 
ignoreButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is '&Ignorar').
     (Generated by WindowBuilder)"!   
map
    "Private - returns current map.
    Used for Spelled dict edit & viewMap"

    | mapView |
    mapView := self mapView.
    ^mapView notNil ifTrue: [ mapView map ]!
mapViewSelected: aSelection
    "A region has been selected in the Map Dialog..."

    self notImplementedYet! 
selected
    "Returns the instance var of the receiver
     for external manipulation"
    ^selected!  
setShowAll: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Mostrar todas las sugerencias').
     (Generated by WindowBuilder)"!  
showAllToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Mostrar todas las sugerencias').
     (Generated by WindowBuilder)"

    wordSelected := nil.
    self fullUpdate!  
speller

    ^speller!  
speller: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    speller := anObject!   
streetDoubleclicked: aPane

    "Callback for the #doubleClickSelect event in an unnamed ListPane.
     (Generated by WindowBuilder)"

    self accept: nil! 
streetName: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'calle...').
     (Generated by WindowBuilder)"

    aPane contents: speller searching asString!   
streetsList: aPane

    "Callback for the #getContents event in an unnamed ListPane.
     (Generated by WindowBuilder)"

    | list |
    list := (((self paneAt: #setShowAll:) selection or: [ bestRanked size = 0 ])
        ifTrue: [ allSuggestions ] ifFalse: [ bestRanked ]) asArray.
    wordSelected notNil ifTrue: [
        list := list select: [:one| (one indexOfCollection: wordSelected) > 0  ]
    ].
    selected := nil.
    aPane contents: list!  
streetSelected: aPane

    "Callback for the #select event in an unnamed ListPane.
     (Generated by WindowBuilder)"

    selected := aPane selectedItem.
    self updateButtons.! 
updateButtons
    "Private - update all buttons."

    #(acceptButton: allwaysAcceptButton: ignoreButton:)
         do: [:each| self changed: each ]! 
viewMap
    "Lets the user view the map at selected street location..."

    | mapView point hack dialog |

    (selected isNil or: [
        mapView := self mapView.
        mapView isNil])
     ifTrue: [ ^self beep ].

    point := speller
        returns: #point;
        find: selected using: mapView map streets.
    point isPoint ifFalse: [ ^self beep ].

    dialog := MapDialog new.
    dialog
        mapView: mapView;
        speller: speller;
        position: point;
        selectionBlock: [ self mapViewSelected: dialog selection ].
    self
        send: #open
        to: dialog!
wordsList: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    aPane contents: (speller partsOf: speller searching)! 
wordSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    aPane selectedItem = wordSelected ifTrue: [ ^self ].
    wordSelected := aPane selectedItem.
    self changed: #streetsList:.! !

! AddressTrainerDialog class methods !
helpMap
    "Private - Help dictionary for tools..."

    ^#(
        (fileNew 'Borra todo el entrenamiento...')
        (fileOpen 'Lee entrenamiento desde un archivo...')
        (fileSave 'Salva el entrenamiento actual en un archivo...')
        (editNew 'Permite agregar un nuevo alias.')
        (edit 'Permite editar los alias selectos.')
        (editDelete 'Permite eliminar los alias selectos.')
        (toolCleanUp 'Borra todas los Alias....')
        (editNewIgnore 'Permite agregar un nombre a la lista.')
        (editDeleteIgnore 'Permite eliminar el nombre selecto.')
        (toolCleanUpIgnore 'Borra todos los nombres ignorados....')
        (fullUpdate 'Actualiza los paneles...')
        (viewMap 'Permite nombrar regiones en el mapa...')
        (close 'Cierra esta ventana...')
        (toolDebug 'Solo util durante testing....')
    )!   
wbCreated

    ^true! !

! AddressTrainerDialog methods ! 
alias: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'alias................').
     (Generated by WindowBuilder)"

    | text |
    text := selected isNil
        ifTrue: [String new]
        ifFalse: [ selected last ].

    aPane contents: text asString! 
aliasTools: aPane

    "Callback for the #getContents event in an unnamed OSToolPane.
     (Generated by WindowBuilder)"

    selected isNil
    ifTrue: [ #(edit editDelete) do: [:one| aPane disableItem: one ] ]
    ifFalse: [  #(edit editDelete) do: [:one| aPane enableItem: one ] ].

    speller xRef size = 0
    ifTrue: [ #(toolCleanUp) do: [:one| aPane disableItem: one ] ]
    ifFalse: [  #(toolCleanUp) do: [:one| aPane enableItem: one ] ].!   
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Entrenamiento de Direcciones';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 640 @ 680; xC; yC; cRDU: (11 @ 670 rightBottom: 629 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 514 @ 244; lDU: 23 r: #left; rDU: 537 r: #left; tDU: 88 r: #top; bDU: 332 r: #top);
                    startGroup;
                    when: #getContents perform: #keys:;
                    when: #select perform: #keySelected:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 567 @ 32; lDU: 27 r: #left; rDU: 594 r: #left; tDU: 336 r: #top; bDU: 368 r: #top);
                    startGroup;
                    when: #getContents perform: #alias:;
                    contents: 'alias................';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 402 @ 48; lDU: 0 r: #left; rDU: 402 r: #left; tDU: 0 r: #top; bDU: 48 r: #top);
                    add: #fileNew;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #viewStamp selector: #viewMap;
                    add: #editUpdate selector: #fullUpdate spaces: 2;
                    add: #toolDebug;
                    add: #fileExit selector: #close spaces: 3;
                    postAutomatic;
                    startGroup;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 542 @ 32; lDU: 59 r: #left; rDU: 601 r: #left; tDU: 574 r: #top; bDU: 606 r: #top);
                    startGroup;
                    when: #getContents perform: #notes:;
                    contents: 'notas................';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 40; lDU: 9 r: #left; tDU: 568 r: #top);
                    contents: (CPBitmapDict at: 'help icon');
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 512 @ 136; lDU: 21 r: #left; rDU: 533 r: #left; tDU: 418 r: #top; bDU: 554 r: #top);
                    startGroup;
                    when: #getContents perform: #ignoreList:;
                    when: #select perform: #ignoreSelected:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolPalette new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 59 @ 136; lDU: 542 r: #left; rDU: 601 r: #left; tDU: 88 r: #top; bDU: 224 r: #top);
                    add: #editNew;
                    add: #editDelete;
                    add: #toolCleanUp;
                    startGroup;
                    postAutomatic;
                    when: #getContents perform: #aliasTools:;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolPalette new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 59 @ 136; lDU: 537 r: #left; rDU: 597 r: #left; tDU: 418 r: #top; bDU: 554 r: #top);
                    add: #editNew selector: #editNewIgnore;
                    add: #editDelete selector: #editDeleteIgnore;
                    add: #toolCleanUp selector: #toolCleanUpIgnore;
                    startGroup;
                    postAutomatic;
                    when: #getContents perform: #ignoreTools:;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 599 @ 322; lDU: 9 r: #left; tDU: 52 r: #top);
                    contents: 'Lista de alias y reemplazos';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 594 @ 178; lDU: 9 r: #left; tDU: 382 r: #top);
                    contents: 'Nombres ignorados';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
editDelete

    | toRemove set |
    selected isNil ifTrue: [ ^self beep ].
    (MessageBox confirm: 'Seguro desea borrar el alias selecto ?')
    ifFalse: [ ^self ].
    speller xRef remove: selected ifAbsent: [].
    self fullUpdate.!   
editDeleteIgnore

    | toRemove |
    toRemove := (self paneAt: #ignoreList:) selectedItem.
    toRemove isNil ifTrue: [ ^self ].
    (MessageBox confirm: 'Seguro desea borrar de la lista de ignorados a ',toRemove asString,' ?')
    ifFalse: [ ^self ].
    speller ignoreList remove: toRemove ifAbsent: [].
    self fullUpdate.! 
editNew

    | answers |
    answers := OSPrompter new
        title: 'Agregado de un nuevo alias...';
        questions: #( 'Nombre exacto de la calle ?' 'Nombre del alias ?');
        open.

    answers isNil ifTrue: [ ^nil ].
    (answers first trimBlanks isEmpty or: [answers last trimBlanks isEmpty])
    ifTrue: [^self beep].

    answers at: 2 put: (self normalize: answers last).
    speller xRef addLast: answers.
    self fullUpdate! 
editNewIgnore

    | answers |
    answers := OSPrompter new
        title: 'Agregado de un nombre a ignorar...';
        questions: #( 'Nombre de la calle a ignorar siempre ?');
        open.

    answers isNil ifTrue: [ ^nil ].
    (answers first trimBlanks isEmpty or: [answers last trimBlanks isEmpty])
    ifTrue: [^self beep].

    speller ignoreList add: (self normalize: answers last).
    self fullUpdate!   
fileNew

    self beep.
    (MessageBox confirm: 'Seguro desea borrar todos los alias ?')
    ifFalse: [ ^self ].
    speller xRef removeAll: speller xRef copy.
    self fullUpdate.!  
fileOpen

    speller fileInDictionary.
    self fullUpdate.!  
fileSave

    speller fileOutDictionary.!   
ignoreList: aPane

    "Callback for the #getContents event in an unnamed MultipleSelectListBox.
     (Generated by WindowBuilder)"

    aPane contents: self speller ignoreList asSortedCollection! 
ignoreSelected: aPane

    "Callback for the #select event in an unnamed MultipleSelectListBox.
     (Generated by WindowBuilder)"

    self changed: #ignoreTools:! 
ignoreTools: aPane

    "Callback for the #getContents event in an unnamed OSToolPane.
     (Generated by WindowBuilder)"

    (self paneAt: #ignoreList:) selectedItem isNil
    ifTrue: [ #(editDeleteIgnore ) do: [:one| aPane disableItem: one ] ]
    ifFalse: [  #(editDeleteIgnore ) do: [:one| aPane enableItem: one ] ].

    speller ignoreList size = 0
    ifTrue: [ #(toolCleanUpIgnore) do: [:one| aPane disableItem: one ] ]
    ifFalse: [  #(toolCleanUpIgnore) do: [:one| aPane enableItem: one ] ].!
keys: aPane

    "Callback for the #getContents event in an unnamed MultipleSelectListBox.
     (Generated by WindowBuilder)"

    selected := nil.
    aPane contents: (self speller xRef collect: [:each| each first ])!  
keySelected: aPane

    "Callback for the #select event in an unnamed MultipleSelectListBox.
     (Generated by WindowBuilder)"

    selected := aPane selection.
    selected isNil ifFalse: [
        selected := speller xRef at: selected.
    ].
    self
        changed: #alias:;
        changed: #aliasTools:;
        yourself.!
mapViewSelected: aSelection
    "A region has been selected in the Map Dialog..."

    self notImplementedYet! 
message: aString
    "Private - Notify aString message"

    | pane |
    pane := self paneAt: #notes:.
    pane isNil ifTrue: [ ^nil ].
    pane contents: aString asString.!  
normalize: aString
    "Private - Returns the string aString normalized..."

    ^AddressFinder normalize: aString!
notes: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Notas...').
     (Generated by WindowBuilder)"

    aPane contents: 'Seleccione una o ms calles...'!  
openOn: aSpeller

    ^self
        speller: aSpeller;
        open!  
speller
    "Returns the instance var of the receiver
     for external manipulation"
    ^speller!
speller: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    speller := anObject!   
toolCleanUp

    self beep.
    (MessageBox confirm: 'Seguro desea borrar todos los alias ?') ifFalse: [ ^self ].
    speller xRef removeAll: speller xRef copy.
    self fullUpdate.!   
toolCleanUpIgnore

    self beep.
    (MessageBox confirm: 'Seguro desea borrar todos nombres ignorados ?') ifFalse: [ ^self ].
    speller ignoreList removeAll: speller ignoreList copy.
    self fullUpdate.! 
toolHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := (self class helpMap
        detect: [:each| each first = selector ] ifNone: [Array with: String new]) last.
    self message: text!   
viewMap
    "Lets the user view the map at selected street location..."

    | mapView point hack dialog |

    (mapView := self mapView) isNil ifTrue: [ ^self beep ].
    selected notNil
    ifTrue: [
        point := speller
            returns: #point;
            find: selected first using: mapView map streets.
    ].

    dialog := MapDialog new.
    dialog
        mapView: mapView;
        speller: speller;
        position: point;
        selectionBlock: [ self mapViewSelected: dialog selection ].
    self
        send: #open
        to: dialog! !

! CustomizeGridDialog class methods !
wbCreated

    ^true! !

! CustomizeGridDialog methods !  
cellSizeX: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: grid cellSize x!   
cellSizeXChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    | value |
    value := aPane contents.
    (value isNil or: [value < 1]) ifTrue: [^self].
    self displayGrid.
    grid cellSize x: value.
    self displayGrid.!
cellSizeY: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: grid cellSize y!   
cellSizeYChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    | value |
    value := aPane contents.
    (value isNil or: [value < 1]) ifTrue: [^self].
    self displayGrid.
    grid cellSize y: value.
    self displayGrid.!
colors: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    aPane
        contents: grid colors;
        selectItem: grid color.!  
colorSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    grid color: aPane selectedItem.
    self updateView.! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Grillado';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 686 @ 408; xC; yC; cRDU: (11 @ 398 rightBottom: 674 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 274 @ 232; lDU: 375 r: #left; rDU: 649 r: #left; tDU: 56 r: #top; bDU: 288 r: #top);
                    noScrollBars;
                    startGroup;
                    when: #getContents perform: #example:;
                    when: #display perform: #displayExample:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 160; lDU: 9 r: #left; rDU: 183 r: #left; tDU: 80 r: #top; bDU: 240 r: #top);
                    defaultStyle;
                    startGroup;
                    when: #getContents perform: #styles:;
                    when: #select perform: #styleSelected:;
                    when: #drawItem perform: #drawStyle:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 160; lDU: 192 r: #left; rDU: 366 r: #left; tDU: 80 r: #top; bDU: 240 r: #top);
                    defaultStyle;
                    startGroup;
                    when: #getContents perform: #colors:;
                    when: #select perform: #colorSelected:;
                    when: #drawItem perform: #drawColor:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 274 @ 100; lDU: 375 r: #left; rDU: 649 r: #left; tDU: 296 r: #top; bDU: 396 r: #top);
                    dropDownList;
                    startGroup;
                    when: #getContents perform: #mapMode:;
                    when: #select perform: #mapModeSelected:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 44; lDU: 233 r: #left; tDU: 248 r: #top);
                    min: 1;
                    max: 1000;
                    contents: 1;
                    startGroup;
                    when: #getContents perform: #cellSizeY:;
                    when: #valueChanged perform: #cellSizeYChanged:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 44; lDU: 517 r: #left; tDU: 8 r: #top);
                    min: 1;
                    max: 1000;
                    contents: 1;
                    startGroup;
                    when: #getContents perform: #cellSizeX:;
                    when: #valueChanged perform: #cellSizeXChanged:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 18 r: #left; tDU: 14 r: #top);
                    startGroup;
                    when: #getContents perform: #setVisible:;
                    contents: 'Visible';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 82 @ 32; lDU: 18 r: #left; rDU: 101 r: #left; tDU: 48 r: #top; bDU: 80 r: #top);
                    startGroup;
                    contents: 'Estilo :';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 82 @ 32; lDU: 201 r: #left; rDU: 283 r: #left; tDU: 48 r: #top; bDU: 80 r: #top);
                    startGroup;
                    contents: 'Color :';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 123 r: #left; rDU: 233 r: #left; tDU: 306 r: #top; bDU: 338 r: #top);
                    startGroup;
                    contents: 'Espesor:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 44; lDU: 233 r: #left; tDU: 298 r: #top);
                    min: 1;
                    max: 10;
                    contents: 1;
                    startGroup;
                    when: #getContents perform: #lineWidth:;
                    when: #valueChanged perform: #lineWidthChanged:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 416 r: #left; rDU: 507 r: #left; tDU: 16 r: #top; bDU: 48 r: #top);
                    startGroup;
                    contents: 'Ancho:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 32; lDU: 165 r: #left; rDU: 229 r: #left; tDU: 256 r: #top; bDU: 288 r: #top);
                    startGroup;
                    contents: 'Alto:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).! 
displayExample: aPane

    "Callback for the #display event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen |
    pen := aPane pen.
    pen isNil ifTrue: [^self].

    pen segments isEmpty
    ifTrue: [
       pen drawRetainPicture: [ self example: aPane ].
    ]
    ifFalse: [ pen drawChain ].

    grid
        drawIn: aPane pen boundingBox
        with: aPane pen!  
displayGrid
    "Private - Displays the grid with aPen"
    | pen |
    pen := self graphPane pen.
    grid
        drawIn: pen boundingBox
        with: pen!  
drawColor: aPane

    "Callback for the #drawItem event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | box list color margin pen index |
    margin := 5.
    pen := aPane graphicsTool.
    pen isNil ifTrue: [^self].
    box := aPane drawBox.
    list := aPane contents.
    list size = 0 ifTrue: [^self].
    index := aPane drawIndex.
    (index between: 1 and: list size) ifFalse: [^self].
    color := (list at: index) asInteger.
    pen fill: (box insetBy: margin@1) color: color.!
drawStyle: aPane

    "Callback for the #drawItem event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | box list style margin pen index |
    margin := 3.
    pen := aPane graphicsTool.
    pen isNil ifTrue: [^self].
    pen := Pen forDC: pen handle medium: pen graphicsMedium.
    box := aPane drawBox.
    list := aPane contents.
    list size = 0 ifTrue: [^nil].
    index := aPane drawIndex.
    (index between: 1 and: list size) ifFalse: [^nil].
    style := (list at: index) asInteger.
    box center y "- 1" to: box center y "+ 1"
    do: [:j|
        pen
            setLineType: style;
            place: margin @ j;
            goto: box width - margin @ j;
            setLineType: PsSolid.
    ].!
example: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen color box penWidth |
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    color := 0.
    box := 0@0 extent: pen canvasBox extent // 4.
    penWidth := box height // 16.
    pen
        setLineWidth: penWidth;
        place: box center * 2 // 3.
    0 to: box height // 2 by: penWidth do: [:y|
        pen
            foreColor: (Pen paletteIndex: color);
            circle: y.
        color := color + 1.
    ].
    pen
        setLineWidth: 1;
        foreColor: ClrBlack.!
graphPane
    ^self paneAt: #example:!   
initialize
    "Private - Initialize the receiver"

    super initialize.
    grid := GridView new.
    grid visible: true.! 
lineWidth: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: grid lineWidth.!   
lineWidthChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    | value |
    value := aPane contents.
    (value isNil or: [value < 1]) ifTrue: [^self].
    self displayGrid.
    grid lineWidth: value.
    self displayGrid.
    self enable: #styles: when: grid lineWidth = 1.!
mapMode: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    self enable: aPane when: false. "not implemented yet..."!   
mapModeSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"!
openOn: aGrid
    "Open the receiver on aGrid..."

    grid := aGrid.
    ^self open.!
openWindow
    "Private - Open the receiver's window"

    | combo |
    #(styles: colors:) do: [:each|
        combo := self paneAt: each.
        combo ownerDrawFixed
            "style: combo style | LbsNointegralheight | LbsHasstrings | LbsOwnerdrawfixed | LbsNotify"
    ].

    super openWindow.!  
setVisible: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Visible').
     (Generated by WindowBuilder)"

    aPane selection: grid visible.!  
styles: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    aPane
        contents: grid styles;
        selectItem: grid style.

    self enable: aPane when: grid lineWidth = 1.!  
styleSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    grid style: aPane selectedItem.
    self updateView.! 
updateView
    "Private - update the example view."

    ^self graphPane invalidateRect: nil! !

! InformationDialog class methods ! 
wbCreated

    ^true! !

! InformationDialog methods !
accept: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Aceptar').
     (Generated by WindowBuilder)"

    self getInformation.
    self close.! 
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    self close.!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Informacin';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 686 @ 304; xC; yC; cRDU: (11 @ 294 rightBottom: 674 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 18 r: #left; rDU: 155 r: #left; tDU: 26 r: #top; bDU: 58 r: #top);
                    startGroup;
                    contents: 'Nombre:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 18 r: #left; rDU: 137 r: #left; tDU: 76 r: #top; bDU: 108 r: #top);
                    startGroup;
                    contents: 'Direccin:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 18 r: #left; rDU: 146 r: #left; tDU: 126 r: #top; bDU: 158 r: #top);
                    startGroup;
                    contents: 'Telfonos:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 18 r: #top; bDU: 62 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationName:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 70 r: #top; bDU: 114 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationAddress:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 122 r: #top; bDU: 166 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationPhone:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 56; lDU: 347 r: #left; rDU: 485 r: #left; tDU: 178 r: #top; bDU: 234 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #accept:;
                    contents: 'Aceptar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 501 r: #left; rDU: 647 r: #left; tDU: 178 r: #top; bDU: 234 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).! 
getInformation
    "Private - Collect the receiver's information"

    element
        name: (self paneAt: #informationName:) contents;
        address: (self paneAt: #informationAddress:) contents;
        phone: (self paneAt: #informationPhone:) contents;
        yourself!
information: anInformation

    element := anInformation.!  
informationAddress: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    aPane contents: element address!   
informationName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    aPane contents: element name! 
informationPhone: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    aPane contents: element phone! !

! ChildMapInformationDialog class methods !  
wbCreated

    ^true! !

! ChildMapInformationDialog methods !
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Vnculo a Sub-Mapa';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 686 @ 360; xC; yC; cRDU: (11 @ 350 rightBottom: 674 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 18 r: #left; rDU: 155 r: #left; tDU: 26 r: #top; bDU: 58 r: #top);
                    startGroup;
                    contents: 'Nombre:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 18 r: #left; rDU: 137 r: #left; tDU: 76 r: #top; bDU: 108 r: #top);
                    startGroup;
                    contents: 'Direccin:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 18 r: #left; rDU: 146 r: #left; tDU: 126 r: #top; bDU: 158 r: #top);
                    startGroup;
                    contents: 'Telfonos:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 18 r: #left; rDU: 137 r: #left; tDU: 184 r: #top; bDU: 216 r: #top);
                    startGroup;
                    contents: 'SubMapa:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 18 r: #top; bDU: 62 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationName:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 70 r: #top; bDU: 114 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationAddress:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 122 r: #top; bDU: 166 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationPhone:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 120; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 176 r: #top; bDU: 296 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #maps:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 56; lDU: 347 r: #left; rDU: 485 r: #left; tDU: 240 r: #top; bDU: 296 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #accept:;
                    contents: 'Aceptar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 501 r: #left; rDU: 647 r: #left; tDU: 240 r: #top; bDU: 296 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
getInformation
    "Private - Collect the receiver's information"

    super getInformation.
    element childMap: (self paneAt: #maps:) selectedItem!
maps: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | childs profiler item |
    profiler := self profiler.
    profiler applicationName: 'Maps'.
    childs := profiler keys asArray.
    item := childs indexOf: element childMap.

    aPane contents: childs.
    item > 0 ifTrue: [
        aPane selection: item
    ].! !

! MultimediaInformationDialog class methods ! 
wbCreated

    ^true! !

! MultimediaInformationDialog methods !  
browse: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    | dialog file |
    dialog := FileDialog new
            title: 'Archivo a vincular...';
            fileSpec: '*.Exe';
            hideReadonly;
            addFilter: '*.txt' description: 'Archivos de texto (*.TXT)';
            addFilter: '*.avi;*.wav;*.mdi' description: 'Archivos Multimedia...';
            addFilter: '*.exe;*.bat;*.com' description: 'Programas...';
            addFilter: '*.bmp;*.dib;*.rle;*.tif;*.tga;*.pcx;*.jpg' description: 'Archivos de Imgenes...';
            addFilter: '*.*' description: 'Todos los archivos (*.*)';
            open.
    file := dialog file.
    file isNil ifTrue: [^self].
    (self paneAt: #pathName:) contents: file!   
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Informacin Multimedia';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 686 @ 344; xC; yC; cRDU: (11 @ 334 rightBottom: 674 @ 48));
            pStyle: #(sysmenu titlebar modal);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 18 r: #left; rDU: 155 r: #left; tDU: 26 r: #top; bDU: 58 r: #top);
                    startGroup;
                    contents: 'Nombre:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 18 r: #left; rDU: 137 r: #left; tDU: 76 r: #top; bDU: 108 r: #top);
                    startGroup;
                    contents: 'Direccin:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 18 r: #left; rDU: 146 r: #left; tDU: 126 r: #top; bDU: 158 r: #top);
                    startGroup;
                    contents: 'Telfonos:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 18 r: #left; rDU: 128 r: #left; tDU: 178 r: #top; bDU: 210 r: #top);
                    startGroup;
                    contents: 'Archivo:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 18 r: #top; bDU: 62 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationName:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 70 r: #top; bDU: 114 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationAddress:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 122 r: #top; bDU: 166 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationPhone:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 421 @ 44; lDU: 165 r: #left; rDU: 585 r: #left; tDU: 174 r: #top; bDU: 218 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #pathName:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 59 @ 44; lDU: 590 r: #left; tDU: 174 r: #top);
                    bitmap: (CPBitmapDict at: 'browse');
                    startGroup;
                    tabStop;
                    when: #clicked perform: #browse:;
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 56; lDU: 347 r: #left; rDU: 485 r: #left; tDU: 224 r: #top; bDU: 280 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #accept:;
                    contents: 'Aceptar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 501 r: #left; rDU: 647 r: #left; tDU: 224 r: #top; bDU: 280 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 48; lDU: 9 r: #left; rDU: 128 r: #left; tDU: 236 r: #top; bDU: 284 r: #top);
                    add: #fileRun;
                    add: #help;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
fileRun
    "Private - Collect the receiver's information
     and run the current element"

    self getInformation.
    element run!   
getInformation
    "Private - Collect the receiver's information"

    super getInformation.
    element pathName: (self paneAt: #pathName:) contents!
help
    "Private - Display help information"

    MessageBox message: 'El archivo ser ejecutado normalmente si es un archivo ejecutable; sino, se tratar de ejecutar segn su asociacin en el administrador de archivos...'!   
pathName: aPane

    "Callback for the #getContents event in an unnamed EntryField.
     (Generated by WindowBuilder)"

    aPane contents: element pathName! !

! NoteInformationDialog class methods !   
wbCreated

    ^true! !

! NoteInformationDialog methods !
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Informacin con nota';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 686 @ 528; xC; yC; cRDU: (11 @ 518 rightBottom: 674 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 18 r: #left; rDU: 155 r: #left; tDU: 26 r: #top; bDU: 58 r: #top);
                    startGroup;
                    contents: 'Nombre:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 18 r: #left; rDU: 137 r: #left; tDU: 76 r: #top; bDU: 108 r: #top);
                    startGroup;
                    contents: 'Direccin:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 18 r: #left; rDU: 146 r: #left; tDU: 126 r: #top; bDU: 158 r: #top);
                    startGroup;
                    contents: 'Telfonos:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 18 r: #top; bDU: 62 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationName:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 70 r: #top; bDU: 114 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationAddress:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 44; lDU: 165 r: #left; rDU: 649 r: #left; tDU: 122 r: #top; bDU: 166 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationPhone:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                TextEdit new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 631 @ 224; lDU: 18 r: #left; rDU: 649 r: #left; tDU: 176 r: #top; bDU: 400 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #fillContents:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 56; lDU: 347 r: #left; rDU: 485 r: #left; tDU: 408 r: #top; bDU: 464 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #accept:;
                    contents: 'Aceptar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 501 r: #left; rDU: 647 r: #left; tDU: 408 r: #top; bDU: 464 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).! 
fillContents: aPane

    "Callback for the #getContents event in an unnamed TextEdit.
     (Generated by WindowBuilder)"

    aPane contents: element contents!  
getInformation
    "Private - Collect the receiver's information"

    super getInformation.
    element contents: (self paneAt: #fillContents:) contents! !

! InformationReaderConfigurationDialog class methods !
helpMap
    "Private - Help dictionary for tools..."

    ^#(
        (fileNew 'Resetea a una nueva configuracin...')
        (fileOpen 'Lee la configuracin desde un archivo...')
        (fileSave 'Salva la configuracin en un archivo...')
        (editLock 'Fija/libera hubicacin del objeto selecto...')
        (mdiTile 'Rehubica los objetos...')
        (edit 'Permite editar el campo selecto, manualmente...')
        (editDelete 'Borra las asociaciones del objeto selecto...')
        (editUpdate 'Actualiza los paneles...')
    )!   
wbCreated

    ^true! !

! InformationReaderConfigurationDialog methods ! 
accept: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Aceptar').
     (Generated by WindowBuilder)"

    | position stream |
    position := self currentSettings detect: [:one| one first = #position ] ifNone: [].
    position notNil
    ifTrue: [
        stream := (position at: 4) asStream.
        (self useAddress
        ifTrue: [ "must validate address ref." 1 ]
        ifFalse: [ "must validate x@y reference..." 2 ])
        timesRepeat: [
            stream upTo: self fieldPrologue.
            stream atEnd ifTrue: [
                self warning: ('Falta informacin necesaria para determinar\',
                    'la posicion de los objetos en la capa de informacin.\\',
                    (self useAddress
                    ifTrue: [ 'Se requiere al menos un campo con la direccin completa para la posicion.' ]
                    ifFalse: [
                        ' Si no hubica mediante direcciones deben ir al menos dos campos;\',
                        ' uno para la coordenada X y otro para la Y...'])
                    ) withCrs.
                ^self
            ].
        ].
    ].

    self close! 
addPane: aPane
    "Private - Add the pane aPane to the receiver's mainView"

    | theParent |
    theParent := self paneAt: #objectsFrame:.
    theParent addSubpane: aPane.
    aPane parent: theParent.
    aPane buildWindow: theParent.
    aPane validate.
    aPane resize: theParent rectangle.

    " Es innecesario...
    aPane bringToTop. "!
addWindowFor: object
    "Private - Adds a child window to support object settings..."

    | pane properties |
    properties := object at: 2.
    pane := NoScrollGraphPane new.
    pane
        owner: self;
        style: WsChild | WsVisible | WsClipsiblings | WsBorder
            | ((properties includes: #locked) ifTrue: [0] ifFalse: [0 "WsThickframe"]);
        propertyAt: #object put: object;
        when: #display perform: #displayObject:;
        when: #button1Up perform: #clickObject:;
       " when: #button1Down perform: #moveObject:; "
        when: #button2Down perform: #moveObject:;
        when: #button1DoubleClick perform: #editObject:;
        backColor: ClrPalegray;
        font: self objectFont;
        yourself.

    pane
        framingBlock: (object at: 3);
        yourself.

    self addPane: pane!
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    configuration := nil.
    self close.!   
canDrop: anObject into: aPane
    "Private - True if the receiver can handle anObject now...
    Implemented by Ale for drag&drop support"

    ^anObject notNil
    and: [
        aPane = (self paneAt: #layerName:)
        or: [ aPane = (self paneAt: #categoryName:)
        or: [
            aPane parent = (self paneAt: #objectsFrame:)
            ifTrue: [ self message: anObject asString,'>>',(self xRef: (aPane propertyAt: #object) first).
                true]
            ifFalse: [false]
        ] ]
    ]!  
categoryName: aPane

    "Callback for the #getContents event in an unnamed OSEntryField.
     (Generated by WindowBuilder)"

    aPane contents: (configuration at: #category)! 
categoryNameChanged: aPane

    "Callback for the #textChanged event in an unnamed OSEntryField.
     (Generated by WindowBuilder)"

    configuration at: #category put: aPane contents!
checkSettings
    "Private - Check current settings..."

    | instances settings built object
     font box width stream numberOfLines
     default height gap
     extent top left |

    "remove invalid instances..."
    instances := (Smalltalk at: (configuration at: #class)) allInstVarNames
        collect: [:one| one asSymbol ].
    settings := self currentSettings.
    settings removeAll: (
        settings reject: [:object| instances includes: object first ]).

    "add missing fields..."
    instances do: [:instance|
        settings
            detect: [:tuple| tuple first = instance ]
            ifNone: [ "missing..."
                default := self table columnNames
                    detect: [:one| one = (self xRef: instance) asUpperCase ]
                    ifNone: [].
                default isNil
                ifTrue: [
                        default := self table columnNames
                            detect: [:guess| (guess matchOf: (self xRef: instance)) > 0.5 ]
                            ifNone: []
                ].
                default := default isNil
                    ifTrue: [ String new ]
                    ifFalse: [ self stringForField: default ].
                built := OrderedCollection new.
                built
                    addLast: instance;
                    addLast: Set new;
                    addLast: nil;
                    addLast: default;
                    yourself.
                settings addLast: built asArray
            ]
    ].

    "remove obsolete fields..."
    settings do: [:one|
        one at: 4 put: (self validateField: (one at: 4))
    ].

    "check boundingBox..."
    top := left := 3. gap := 12.
    extent := (self paneAt: #objectsFrame:) rectangle extent.
    font := self objectFont.
    1 to: settings size do: [:i|
        object := settings at: i.
        (object at: 3) isNil ifTrue: [ object at: 3 put: (FrameRectangle from: (0@0 extent: 3@3)) ].
        width := (font stringWidth: object first asString) + gap.
        stream := (object at: 4) asStream.
        numberOfLines := 1.
        [stream atEnd] whileFalse: [
            width := width max: (font stringWidth: stream nextLine) + gap.
            numberOfLines := numberOfLines + 1.
        ].
        height :=  font height * numberOfLines + 1.
        box := object at: 3.
        box left <= left ifTrue: [ box leftTop: 2 @ box top ].
        box top <= left ifTrue: [ box leftTop: box left @ top ].
        box rightBottom: box left + width @ (box top + height).
        top := top + height + 1.
        top > extent y ifTrue: [ top := 3. left := extent x // 2 + left].
    ].!  
clickObject: aPane
    "Private - Signal selected object"

    self currentObject: (aPane propertyAt: #object).
    aPane bringToTop.
    self message: 'Con el botn derecho puede mover los objetos...'.!  
close
    "Close the receiver..."

    table release.
    table := nil.

    self removeChildWindows: (self paneAt: #objectsFrame:).

    ^super close!   
configuration
    "Returns the instance var of the receiver
     for external manipulation"

    ^configuration!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Mapeo de campos...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 960 @ 704; xC; yC; cRDU: (11 @ 694 rightBottom: 949 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 73 @ 32; lDU: 398 r: #left; rDU: 471 r: #left; tDU: 94 r: #top; bDU: 126 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Capa:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 82 @ 32; lDU: 398 r: #left; rDU: 480 r: #left; tDU: 142 r: #top; bDU: 174 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Categ:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 549 @ 36; lDU: 73 r: #left; rDU: 622 r: #left; tDU: 596 r: #top; bDU: 632 r: #top);
                    startGroup;
                    when: #getContents perform: #notes:;
                    contents: 'Notas...';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 32; lDU: 407 r: #left; rDU: 471 r: #left; tDU: 36 r: #top; bDU: 68 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Tipo:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 40; lDU: 27 r: #left; tDU: 590 r: #top);
                    contents: (CPBitmapDict at: 'help icon');
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 32; lDU: 398 r: #left; rDU: 599 r: #left; tDU: 188 r: #top; bDU: 220 r: #top);
                    startGroup;
                    contents: 'Caja de objetos...';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 457 @ 340; lDU: 393 r: #left; tDU: 220 r: #top);
                    when: #getContents perform: #objectsFrame:;
                    contents: '';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 366 @ 530; lDU: 11 r: #left; tDU: 48 r: #top);
                    contents: 'Informacin Disponible...';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 341 @ 446; lDU: 25 r: #left; rDU: 366 r: #left; tDU: 80 r: #top; bDU: 526 r: #top);
                    defaultStyle;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #fields:;
                    when: #select perform: #fieldSelected:;
                    when: #doubleClickSelect perform: #fieldDoubleclicked:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 430 @ 402; lDU: 485 r: #left; rDU: 914 r: #left; tDU: 34 r: #top; bDU: 436 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #informationClass:;
                    when: #select perform: #informationClassSelected:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 430 @ 44; lDU: 485 r: #left; rDU: 914 r: #left; tDU: 82 r: #top; bDU: 126 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #layerName:;
                    when: #textChanged perform: #layerNameChanged:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 430 @ 44; lDU: 485 r: #left; rDU: 914 r: #left; tDU: 130 r: #top; bDU: 174 r: #top; indent: 3 @ 4);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #categoryName:;
                    when: #textChanged perform: #categoryNameChanged:;
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 329 @ 32; lDU: 30 r: #left; tDU: 530 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #useAddress:;
                    when: #clicked perform: #useAddressToggle:;
                    contents: 'Hubicar usando direccin';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 56; lDU: 631 r: #left; rDU: 768 r: #left; tDU: 584 r: #top; bDU: 640 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #accept:;
                    contents: 'Aceptar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 777 r: #left; rDU: 923 r: #left; tDU: 584 r: #top; bDU: 640 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 546 @ 578; lDU: 382 r: #left; tDU: 0 r: #top);
                    contents: 'Informacin a leer...';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolPalette new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 59 @ 176; lDU: 855 r: #left; rDU: 914 r: #left; tDU: 218 r: #top; bDU: 394 r: #top);
                    add: #edit;
                    add: #mdiTile;
                    add: #editDelete;
                    add: #editUpdate;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 229 @ 48; lDU: 11 r: #left; rDU: 240 r: #left; tDU: 4 r: #top; bDU: 52 r: #top);
                    add: #fileNew;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #toolDebug;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
currentObject
    "Private - Returns current selected object..."

    | settings |
    settings := self currentSettings.
    ^settings
        detect: [:one| (one at: 2) includes: #selected ]
        ifNone: [
            self currentObject: settings first.
            settings first
        ]! 
currentObject: anObject
    "Private - Selected object as current..."

    | childs current object old |
    childs := (self paneAt: #objectsFrame:) children.
    childs size > 0 ifTrue: [
        childs := childs values.
        childs do: [:child|
            object := child propertyAt: #object.
            object notNil
            ifTrue: [
                object = anObject
                ifTrue: [ current := child ]
                ifFalse: [
                    ((object at: 2) includes: #selected)
                    ifTrue: [ old := child ].
                ]
            ]
        ].
    ].

    self currentSettings do: [:each|
        (each at: 2) remove: #selected ifAbsent: []
    ].
    (anObject at: 2) add: #selected.

    old notNil ifTrue: [ old invalidateRect: nil ].
    current notNil ifTrue: [ current invalidateRect: nil ].!  
currentSettings
    "Private - Return current settings...
    Settings format:
        #(
            (field (properties...) (contents...) boundingBox)
        )
    "

    ^configuration at: #settings!
displayObject: aPane
    "Display object settings in aPane..."

    | pen object stream font top text gap oldColor |
    pen := aPane pen.
    pen isNil ifTrue: [ ^self ].
    object := aPane propertyAt: #object.
    pen fill: pen boundingBox color: pen backColor.
    object isNil ifTrue: [ ^self ].
    font := aPane font.
    "pen font: font. "
    top := font height.
    text := self xRef: object first asSymbol.
    gap := 3.
    oldColor := pen foreColor.
    ((object at: 2) includes: #selected) ifTrue: [
        pen foreColor: ClrYellow.
    ].
    pen
        displayText: text
        at: pen boundingBox width - (font stringWidth: text) // 2 @ (top - gap);
        place: 0@0;box: pen boundingBox width @ top;
        reverse: (0@0 rightBottom: pen boundingBox width @ top);
        yourself.
    pen foreColor: oldColor.

    stream := object last asStream.
    [stream atEnd] whileFalse: [
        top := top + font height.
        pen displayText: stream nextLine at: 0 @ (top - gap).
    ].!
drop: anObject into: aPane
    "Private - Drop a field into aPane..."

    | object output |
    (aPane = (self paneAt: #layerName:)
    or: [aPane = (self paneAt: #categoryName:)])
    ifTrue: [
        aPane
            contents: (self stringForField: anObject);
            event: #textChanged.
        ^true
    ].

    object := aPane propertyAt: #object.
    object isNil ifTrue: [^false].
    output := WriteStream on: String new.
    object last isEmpty ifFalse: [ output nextPutAll: object last;cr ].
    output
        nextPutAll: (self stringForField: anObject);
        yourself.
    object at: 4 put: output contents.

    self
        currentObject: object;
        mdiTile;
        yourself.

    ^true! 
edit
    "Edit currently selected object..."

    (self currentObject at: 4) edit! 
editDelete
    "Delete the currently selected object contents..."

    self currentObject at: 4 put: String new.
    self mdiTile. "changed: #objectsFrame:"! 
editLock
    "Locks the currently selected object..."

    | properties |
    properties := self currentObject at: 2.
    (properties includes: #locked)
    ifTrue: [ properties remove: #locked ]
    ifFalse: [ properties add: #locked ].
    self currentObject at: 3 put: nil.
    self changed: #objectsFrame:!   
editObject: aPane
    "Private - edit selected object"

    self edit.!
editUpdate

    self fullUpdate!
fieldDoubleclicked: aPane

    "Callback for the #doubleClickSelect event in an unnamed OSListPane.
     (Generated by WindowBuilder)"

    "nothing to do..."!  
fieldEpilogue
    "Private - Returns the field epilogue character..."

    ^parent fieldEpilogue!  
fieldPrologue
    "Private - Returns the field prologue character..."

    ^parent fieldPrologue!  
fields: aPane

    "Callback for the #getContents event in an unnamed OSListPane.
     (Generated by WindowBuilder)"

    | list |
    list := SortedCollection new.

    list addAll: self table columnNames.

    aPane contents: list asArray!   
fieldSelected: aPane

    "Callback for the #select event in an unnamed OSListPane.
     (Generated by WindowBuilder)"

    self changed: #notes:!   
fileNew
    "Lets the user re-initialize configuration..."

    self
        initializeConfiguration;
        fullUpdate!
fileOpen
    "Lets the user fileIn a new configuration..."

    | dialog file config |

    dialog := FileDialog new.
    dialog
        title: 'Archivo de donde leer configuracin...';
        addFilter: '*.lac' description: 'Configuracin de lectura (*.LAC)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        defFilter: '*.lac';fileSpec: '*.lac';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].
    (file includes: $.)
    ifFalse: [ file := file,'.Lac' ].

    config := ObjectFiler loadFromPathName: file.
    config isNil ifTrue: [ ^self error: 'Archivo Invalido...' ].

    config class == configuration class
    ifFalse: [ ^self error: 'El archivo no contiene una configuracin aceptable.' ].

    configuration := config.
    self fullUpdate.!   
fileSave
    "Lets the user fileOut current configuration..."

    | dialog file |
    configuration isNil ifTrue: [^self beep ].
    file := (parent pathName upTo: $.), '.Lac'.
    dialog := FileDialog new.
    dialog
        title: 'Seleccione el archivo donde guardarlo...';
        addFilter: '*.lac' description: 'Configuracin de lectura (*.LAC)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        fileSpec: file;
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].

    (file includes: $.) ifFalse: [ file := file,'.Lac' ].
    CursorManager execute changeFor: [
        ObjectFiler dump: configuration newFile: file
    ].
    ^file!  
informationClass: aPane

    "Callback for the #getContents event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | classes |
    classes := self informationClasses collect: [:each| each symbol ].
    aPane
        contents: (self xRef: classes);
        selection: (self xRef: (configuration at: #class)).!  
informationClasses
    "Private - returns class for informational objects..."

    ^Information withAllSubclasses! 
informationClassSelected: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"

    | selected |
    selected := aPane selectedItem.
    selected isNil ifTrue: [^self].
    selected := self xRef: selected.
    selected = (self configuration at: #class) ifTrue: [^self].
    self configuration at: #class put: selected.
    self changed: #objectsFrame:!  
initialize
    "Private - Initializes the receiver..."

    super initialize.
    self initializeDictionary.! 
initializeConfiguration
    "Private - Initialize with default configuration..."

    self initializeConfiguration:
        (parent notNil ifTrue: [ parent configuration ])! 
initializeConfiguration: aConfiguration
    "Private - Initialize with default configuration..."

    | set layer |
    layer := parent layer.
    configuration := Dictionary new.
    configuration
        at: #class put: #Information;
        at: #useAddress put: true;
        at: #settings put: OrderedCollection new;
        at: #layer put: (layer notNil ifTrue: [layer name] ifFalse: ['Informacin']);
        at: #category put: 'General';
        yourself.
    aConfiguration notNil
    ifTrue: [
        set := [:key| configuration at: key put: (self validateField: (aConfiguration at: key ifAbsent: [])) copy ].
        #(class useAddress useLumi layer category) do: [:each| set value: each ].
        self currentSettings
            addAll: ((aConfiguration at: #settings)
                collect: [:each| self validateFields: each deepCopy ])
    ].! 
initializeDictionary
    "Private - Initialize cross reference dictionary of terms..."

    | terms register |
    terms := #(
        "InformationClass description"
        (Information 'Informacin bsica.')
        (ChildMapInformation 'Referencia a otro mapa.')
        (MultimediaInformation 'Referencia a un documento o programa.')
        (AudioInformation 'Informacin con Audio asociado.')
        (FileInformation 'Referencia a un documento asociado.')
        (ImageInformation 'Informacin con Imgen asociado.')
        (VideoInformation 'Informacin con Video asociado.')
        (NoteInformation 'Informacin con un texto adicional.')

        "Table for instance names in spanish..."
        (name 'Nombre')
        (address 'Direccion')
        (phone 'Telefono')
        (position 'Posicion')
        (childMap 'Mapa')
        (pathName 'Archivo')
        (contents 'Contenido')
    ).
    register := [:pair|
        xRefDictionary
            at: pair first put: pair last;
            at: pair last put: pair first;
            yourself.
    ].
    xRefDictionary := Dictionary new.
    Information withAllSubclasses do: [:each|
        "Grant all information classes be registered..."
        register value: (Array with: each symbol with: each name)
    ].
    terms do: [:pair| register value: pair ].! 
isValidField: aField
    "True if aField is valid..."

    ^self table columnNames includes: aField asUpperCase!   
layerName: aPane

    "Callback for the #getContents event in an unnamed OSEntryField.
     (Generated by WindowBuilder)"

    aPane contents: (configuration at: #layer)!   
layerNameChanged: aPane

    "Callback for the #textChanged event in an unnamed OSEntryField.
     (Generated by WindowBuilder)"

    configuration at: #layer put: aPane contents!  
mdiTile
    "Resort objects..."

    self currentSettings do: [:object|
        object at: 3 put: nil
    ].
    self changed: #objectsFrame:!  
message: aString
    "Private - Notify aString message"

    | pane |
    pane := self paneAt: #notes:.
    pane isNil ifTrue: [ ^nil ].
    pane contents: aString asString.!  
moveObject: aPane
    "Private - Move a child window..."
    | box pen displacement
      drawBox drawFrame last |

    pen := aPane parent pen.
    pen
        setRop2: R2Notxorpen;
        setLineWidth: 3.
    box := aPane framingBlock value: aPane parent rectangle.
    displacement := Cursor sense - box origin.
    Notifier activeMainWindow captureMouseInput.
    CursorManager crossHair change.
    drawFrame := [ pen place: last origin;box: last corner ].
    drawBox := [
        last notNil ifTrue: [drawFrame value].
        last := Cursor sense - displacement extent: box extent.
        drawFrame value.
    ].
    Notifier consumeInputUntil: [: event |
        (#( button1Move: button2Move:) includes: event selector)
            ifTrue: [ drawBox value ].
        #( button1Up: button2Up:) includes: event selector].
    last notNil "has been dragged..."
    ifTrue: [drawFrame value].
    pen
        setRop2: R2Copypen;
        setLineWidth: 1.
    CursorManager normal change.
    box moveTo: Cursor sense - displacement.
    UserLibrary releaseCapture.

    aPane bringToTop.
    aPane resize: aPane parent rectangle.
    self redrawObjects! 
notes: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Notas...').
     (Generated by WindowBuilder)"

    aPane contents: 'Arrastre los campos hasta la caja de objetos...'! 
objectFont
    "Private - returns the font for objects panes..."

    | font |
    true ifTrue: [ ^self defaultFont ].
    font := (self paneAt: #objectsFrame:) font.
    font isNil ifTrue: [ font := SysFont ].
    ^font!  
objectsFrame: aPane

    "Callback for the #getContents event in the objects pane..."

    self checkSettings.

    (Message new
        receiver: self
        selector: #updateObjects:
        arguments: (Array with: aPane) ) performDeferred.! 
parentDialog: aParentDialog
    "Private - Set the receiver for working with parent parts"

    parent := aParentDialog.
    self initializeConfiguration.!   
redrawObjects
    "Private - Redraw objects panes..."

    | mainView |
    mainView := self mainView.
    (Message new
        receiver: mainView
        selector: #invalidateRect:
        arguments: (Array
            with: ((self paneAt: #objectsFrame:) framingBlock value: mainView rectangle))
    ) performDeferred.!   
removeChildWindows: aPane
    "Private - Remove object windows..."

    "remove old windows..."
    aPane children notNil
    ifTrue: [
        aPane children do: [:child|
            child close.
            aPane children removeKey: (
                aPane children keyAtValue: child)
        ].
    ].!  
stringForField: aField
    "Private - Returns the field textual description..."

    ^(String with: self fieldPrologue),aField,(String with: self fieldEpilogue)!  
table
    "Private - returns the current table in use..."

    table notNil ifTrue: [^table].
    "must be opened..."
    CursorManager execute changeFor: [
        table := RelationalTable new
            open: parent pathName
    ].
    ^table!   
toolHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := (self class helpMap
        detect: [:each| each first = selector ] ifNone: [Array with: String new]) last.
    self message: text!   
updateObjects: aPane
    "Private - Rebuild object windows..."

    | mainView |
    self removeChildWindows: aPane.

    "build new windows..."
    self currentSettings do: [:object|
        self addWindowFor: object
    ].

    aPane children notNil
    ifTrue: [
        aPane children values
        do: [ :child|
            (((child propertyAt: #object) at: 2) includes: #selected)
            ifTrue: [ child bringToTop ]
        ]
    ].

    self redrawObjects.!   
useAddress
    "Private - Returns true if using address..."

    ^configuration at: #useAddress!   
useAddress: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Hubicar usando direccin').
     (Generated by WindowBuilder)"

    | useAddress |
    useAddress := self useAddress.
    aPane selection: useAddress.!   
useAddressToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Hubicar usando direccin').
     (Generated by WindowBuilder)"

    configuration at: #useAddress put: aPane selection.
    self fullUpdate "changed: #objectsFrame:. "! 
validateField: aString
    "Private - Returns a valid string checking fields data"

    | input  output field |
    aString isString ifFalse: [ ^aString ].
    (aString includes: self fieldPrologue) ifFalse: [ ^aString ].
    input := aString asStream.
    output := WriteStream on: String new.
    [ input atEnd ] whileFalse: [
        output nextPutAll: (input upTo: self fieldPrologue).
        input atEnd
        ifFalse: [
            field := input upTo: self fieldEpilogue.
            field := field trimBlanks asUpperCase.
            (self isValidField: field)
            ifTrue: [
                output
                    nextPut: self fieldPrologue;
                    nextPutAll: field;
                    nextPut: self fieldEpilogue;
                    yourself.
            ]
        ]
    ].
    ^output contents!  
validateFields: aCollection
    "Private - Returns a validated collection...
    This method scan the collection recursivelly searching for fields..."

    ^aCollection collect: [:each|
          (each isString or: [ each isCollection not ])
            ifTrue: [ self validateField: each ]
            ifFalse: [ self validateFields: each ]
        ]!  
xRef: anObject
    "Private - Returns xReference for anObject...
    Used for language conversions..."

    (anObject isString or: [anObject isCollection not])
    ifTrue: [ ^xRefDictionary at: anObject ifAbsent: [anObject] ].

    ^anObject collect: [:each| xRefDictionary at: each ifAbsent: [each] ]! !

! LayerAndSubLayerDialog class methods !   
wbCreated

    ^true! !

! LayerAndSubLayerDialog methods !   
accept: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Aceptar').
     (Generated by WindowBuilder)"

    | layerText  categoryText |

    layerText :=  (self paneAt:#layerContents:) text.
    categoryText := (self paneAt:#subLayerContents:) text.
    layerText notEmpty ifTrue:[ self layerName: layerText].
    categoryText notEmpty ifTrue:[ self categoryName: categoryText].



    self close! 
answers
    "Return an array with a Layer and a Category"

    ^ Array
         with: (self layerName)
         with: (self categoryName)!   
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    categoryName := String new.
    layerName := String new.
    self close!
categoryChanged: aPane

    "Callback for the #textChanged event in an unnamed ComboBox.
     (Generated by WindowBuilder)"!   
categoryName
    "Returns the instance var of the receiver
     for external manipulation"
    ^categoryName!  
categoryName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    categoryName := anObject! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Donde desea ubicar el objeto?';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 668 @ 256; xC; yC; cRDU: (5 @ 251 rightBottom: 663 @ 43));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 57 @ 26; lDU: 18 r: #left; rDU: 75 r: #left; tDU: 26 r: #top; bDU: 51 r: #top);
                    startGroup;
                    contents: 'Capa';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 92 @ 26; lDU: 18 r: #left; rDU: 110 r: #left; tDU: 77 r: #top; bDU: 102 r: #top);
                    startGroup;
                    contents: 'Sub-Capa';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 482 @ 178; lDU: 165 r: #left; rDU: 647 r: #left; tDU: 18 r: #top; bDU: 195 r: #top);
                    dropDown;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #layerContents:;
                    when: #textChanged perform: #layerChanged:;
                    when: #select perform: #layerSelect:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 482 @ 186; lDU: 165 r: #left; rDU: 647 r: #left; tDU: 70 r: #top; bDU: 256 r: #top);
                    dropDown;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #subLayerContents:;
                    when: #textChanged perform: #categoryChanged:;
                    when: #select perform: #subLayerSelect:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 56; lDU: 345 r: #left; rDU: 484 r: #left; tDU: 133 r: #top; bDU: 189 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #accept:;
                    contents: 'Aceptar';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 500 r: #left; rDU: 645 r: #left; tDU: 133 r: #top; bDU: 189 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
layerChanged: aPane

    "Callback for the #textChanged event in an unnamed ComboBox.
     (Generated by WindowBuilder)"!  
layerContents: aPane

    "Callback for the #getContents event in an unnamed ListBox.
     (Generated by WindowBuilder)"

    aPane contents: ( self layers collect: [:each| each name] )!   
layerName
    "Returns the instance var of the receiver
     for external manipulation"
    ^layerName!
layerName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    layerName := anObject!   
layerNamed: aString
    "Returns a layer of layers named aString , or nil"

  ^  self layers detect: [:one| one name = aString]!   
layers
    "Returns the instance var of the receiver
     for external manipulation"
    ^layers!  
layers: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    layers := anObject! 
layerSelect: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"
    aPane selectedItem notNil ifTrue: [
        self layerName: ( "self layerNamed:" aPane selectedItem).
        self changed:#subLayerContents:
    ]!
openOn: aCollection
    self layers: aCollection.
    self open!
subLayerContents: aPane

    "Callback for the #getContents event in an unnamed ListBox.
     (Generated by WindowBuilder)"
     aPane contents:( layerName isNil
                                 ifTrue:[ nil]
                                 ifFalse:[(self layerNamed: layerName) categoryNames]
    )!  
subLayerSelect: aPane

    "Callback for the #select event in an unnamed ComboBox.
     (Generated by WindowBuilder)"
     aPane selectedItem notNil ifTrue: [
        self categoryName: "( ( self layerNamed: layer) categoryNamed: aPane  selectedItem )" aPane  selectedItem
    ].! !

! MapDialog class methods !   
helpMap
    "Private - Help dictionary for tools..."

    ^#(
        (editSelect 'Activa una nueva seleccin...')
        (editMove 'Permite mover el mapa con la mano...')
        (viewZoomIn 'Aumenta el zoom...')
        (viewZoomOut 'Disminuye el zoom...')
        (editSearch 'Permite hubicar una direccin en el mapa...')
        (fullUpdate 'Actualiza los paneles...')
        (close 'Cierra esta ventana...')
    )! 
wbCreated

    ^true! !

! MapDialog methods !
beginMove: aPane

    "Callback for the #button2Down event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    aPane
        propertyAt: #moveStart put: self origin + aPane mouseLocation;
        setCursor: #move.!  
beginSelect: aPane

    "Callback for the #button1Down event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    | point |
    tool = #move ifTrue: [ ^self beginMove: aPane ].

    self useSelection ifFalse: [^self].
    point := aPane mouseLocation.

    self displaySelection.

    selection := point x @ point y extent: 0@0.

    self displaySelection.!
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Visin simple de mapa...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 832 @ 552; xC; yC; cRDU: (11 @ 542 rightBottom: 821 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 402 @ 48; lDU: 9 r: #left; rDU: 411 r: #left; tDU: 2 r: #top; bDU: 50 r: #top);
                    add: #editSelect;
                    add: #editMove;
                    add: #viewZoomIn spaces: 2;
                    add: #viewZoomOut;
                    add: #editSearch spaces: 2;
                    add: #editUpdate selector: #fullUpdate;
                    add: #fileExit selector: #close spaces: 2;
                    postAutomatic;
                    startGroup;
                    when: #showHelp perform: #toolHelp:;
                    when: #getContents perform: #toolsContents:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSImagePane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 786 @ 404; lDU: 9 r: #left; rDU: 795 r: #left; tDU: 52 r: #top; bDU: 456 r: #top);
                    noScrollBars;
                    startGroup;
                    when: #getContents perform: #mapContents:;
                    when: #button1Up perform: #endSelect:;
                    when: #button1Down perform: #beginSelect:;
                    when: #button1Move perform: #selecting:;
                    when: #display perform: #displayMap:;
                    when: #mouseMove perform: #mouseMove:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 734 @ 32; lDU: 62 r: #left; rDU: 795 r: #left; tDU: 462 r: #top; bDU: 494 r: #top);
                    startGroup;
                    when: #getContents perform: #notes:;
                    contents: 'notas................';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 40; lDU: 11 r: #left; tDU: 456 r: #top);
                    contents: (CPBitmapDict at: 'help icon');
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 32; lDU: 576 r: #left; rDU: 795 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    startGroup;
                    when: #getContents perform: #mouseContents:;
                    contents: '................';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 32; lDU: 530 r: #left; tDU: 8 r: #top);
                    contents: (CPBitmapDict at: 'position');
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
displayMap: aPane

    "Callback for the #display event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    | pen boundingBox rectangle |
    pen := aPane pen.
    pen isNil ifTrue: [ ^self ].

    mapView isNil
    ifTrue: [
        pen fill: pen boundingBox color: ClrBlack.
        ^self
    ].

    boundingBox := mapView boundingBox.
    rectangle := aPane rectangleToDisplay translateBy: self origin.
    CursorManager execute changeFor: [
        rectangle notNil ifTrue: [
            (rectangle nonIntersections: boundingBox)
            do: [:nonOverlaped|
                aPane pen
                        fill: (nonOverlaped translateBy: self origin negated)
                        color: aPane backColor
            ].
            self displayRectangle: (rectangle intersect: boundingBox) with: aPane pen.
        ].
        selection notNil ifTrue: [ self drawSelectionIn: rectangle with: aPane pen ].
    ].!   
displayRectangle: aRectangle with: aPen
    "Dibuja el area indicada por aRectangle usando aPen"

    mapView isBitmap ifTrue: [ ^mapView displayAt: 0@0 with: aPen ].

    mapView
        displayRectangle: aRectangle
        at: self origin negated
        with: aPen.! 
displaySelection
    "Private - Display the current selection..."

    | aPane |
    aPane := self mapPane.
    selection notNil
    ifTrue: [ self drawSelectionIn: aPane pen boundingBox with: aPane pen ]!   
drawSelectionIn: ignored with: aPen
    "Private - Draw the current selection..."

    | backUp |
    backUp := aPen location.
    aPen
        setRop2: R2Notxorpen;
        setLineWidth: self selectionLineWidth;
        place: selection origin truncated;
        box: selection corner truncated;
        setRop2: R2Copypen;
        setLineWidth: 1;
        place: backUp;
        yourself!   
editMove

    tool := #move.!   
editSearch
    "Lets the user goto an address..."
    | input old result gap |
    gap := 64@48.
    [
    input := OSPrompter
        prompt: 'Direccin a hubicar ?'
        default: input.
    input isNil ifTrue: [^self].
    old := speller returns.
    speller returns: #point.
    result := self streets find: input using: speller.
    result notNil ifTrue: [
        result isPoint
        ifTrue: [
            selection := result - (gap // 2) extent: gap.
            self position: result
        ]
        ifFalse: [ self beep ].
    ] ifFalse: [ self warning: 'No encontr la direccin.' ].
    speller returns: old.
    true ] whileTrue: [].!
editSelect

    selection := nil.
    tool := #select.
    self fullUpdate.!  
endMove: aPane

    "Callback for the #button2Up event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    self
        moving: aPane;
        mouseMove: aPane.!   
endSelect: aPane

    "Callback for the #button1Up event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    | point |
    tool = #move ifTrue: [ ^self endMove: aPane ].
    self useSelection ifFalse: [^self].

    point := aPane mouseLocation.

    self displaySelection.
    selection := selection origin corner: point.
    (selection width < self minimumSelection x
    or: [selection height < self minimumSelection y])
    ifTrue: [ selection := nil ].
    self displaySelection.

    self selectionHasChanged.!  
initialize
    "Private - Initialize the receiver..."

    super initialize.
    origin := nil.
    useSelection := false.
    selection := nil.
    tool := #move.
    minimumSelection := 2@2.! 
mapContents: aPane

    "Callback for the #getContents event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    self send: #updateMap to: self!  
mapView: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    mapView := anObject!   
message: aString
    "Private - Notify aString message"

    | pane |
    pane := self paneAt: #notes:.
    pane isNil ifTrue: [ ^nil ].
    pane contents: aString asString.!  
minimumSelection
    "Returns the instance var of the receiver
     for external manipulation"
    ^minimumSelection!  
minimumSelection: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    minimumSelection := anObject! 
mouseContents: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '................').
     (Generated by WindowBuilder)"

    aPane contents: String new!
mouseMove: aPane

    "Callback for the #mouseMove event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    | pane location |
    pane := self paneAt: #mouseContents:.
    pane isNil ifTrue: [ ^self ].
    location := aPane mouseLocation + self origin.
    pane contents: location asString.

    tool = #move
    ifTrue: [ aPane setCursor: #move ]
    ifFalse: [ aPane setCursor: #select ]!   
moving: aPane

    "Callback for the #button2Move event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    | displacement start |
    start := aPane propertyAt: #moveStart.
    start isNil ifTrue: [^self].
    origin := start - aPane mouseLocation.
    aPane invalidateRect: nil.! 
notes: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'notas................').
     (Generated by WindowBuilder)"

    aPane contents: String new.!  
origin
    "Returns current origin..."

    origin isNil ifTrue: [
        origin := mapView isNil
            ifTrue: [ 0@0 ]
            ifFalse: [ mapView boundingBox center ]
    ].
    ^origin!
position: aPoint
    "Position the receiver at aPoint..."

    | pane |
    aPoint isNil ifTrue: [ ^self position: mapView boundingBox center ].
    pane := self paneAt: #mapContents:.
    pane isNil ifTrue: [ origin := aPoint - 100. ^self ].
    origin := aPoint - (pane frameRectangle extent // 2).
    pane invalidateRect: nil.!   
selecting: aPane

    "Callback for the #button1Move event in an unnamed OSImagePane.
     (Generated by WindowBuilder)"

    | point displacement mode |
    tool = #move ifTrue: [ ^self moving: aPane ].
    self useSelection ifFalse: [^self].

    point := aPane mouseLocation.

    self displaySelection.
    selection := selection origin corner: point.
    self displaySelection.!  
selection
    "Returns the instance var of the receiver
     for external manipulation"
    ^selection!
selection: anObject
    "Sets the instance var of the receiver
     with anObject and perform selectionBlock
     if appropiate"

    selection := anObject.
    (selectionBlock respondsTo: #value)
    ifTrue: [ selectionBlock value ].!
selectionBlock
    "Returns the instance var of the receiver
     for external manipulation"
    ^selectionBlock!  
selectionBlock: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    selectionBlock := anObject! 
selectionHasChanged
    "Private - Evaluates selectionBlock because the selection has been changed by the user..."

    (selectionBlock respondsTo: #value) ifTrue: [ selectionBlock value ].! 
selectionLineWidth
    "Private - Returns the current selection line width"
    ^2! 
speller
    "Returns the instance var of the receiver
     for external manipulation"

    speller isNil ifTrue: [ speller := AddressFinder default ].
    ^speller! 
speller: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    speller := anObject!   
streets
    "Private - Returns current streets"

    mapView isNil ifTrue: [ ^nil ].
    ^mapView map streets!
toolHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := (self class helpMap
        detect: [:each| each first = selector ] ifNone: [Array with: String new]) last.
    self message: text!   
toolsContents: aPane

    "Callback for the #getContents event in an unnamed OSToolBar.
     (Generated by WindowBuilder)"

    speller isNil
    ifTrue: [ #(editSearch) do: [:one| aPane disableItem: one ] ]
    ifFalse: [  #(editSearch) do: [:one| aPane enableItem: one ] ].

    useSelection
    ifTrue: [  #(editSelect) do: [:one| aPane enableItem: one ] ]
    ifFalse: [ #(editSelect) do: [:one| aPane disableItem: one ] ].!   
updateMap
    "Priavet - update the map view..."
    | pane |
    pane := self paneAt: #mapContents:.
    pane notNil ifTrue: [ pane invalidateRect: nil ].!  
useSelection
    "Returns the instance var of the receiver
     for external manipulation"
    ^useSelection!  
useSelection: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    useSelection := anObject! 
viewZoomIn

    self notFullyImplemented!   
viewZoomOut

    self notFullyImplemented! !

! SearchStreetConfigurationDialog class methods !   
helpMap
    "Private - Help dictionary for tools..."

    ^#(
        (fileUseDefault 'Usa configuracin standard...')
        (fileNew 'Resetea a una nueva configuracin...')
        (fileOpen 'Lee la configuracin desde un archivo...')
        (fileSave 'Salva la configuracin en un archivo...')
        (fileSaveAsDefault 'Salva la configuracin actual como standard...')
        (editUpdate 'Actualiza los paneles...')
        (close 'Cierra esta ventana...')

        (toolSpell 'Permite testear una direccin...')
        (spellTable 'Permite entrenar el sistema con los datos en la tabla actual...')
        (viewMap 'Permite testear una direccin viendo los resultados en el mapa...')
        (editSpellerDictionary 'Permite editar manualmente el diccionario de direcciones...')
        (openSpellerDictionary 'Lee un diccionario de direcciones desde un archivo...')
        (saveSpellerDictionary 'Graba el diccionario de direcciones actual a un archivo...')
    )! 
wbCreated

    ^true! !

! SearchStreetConfigurationDialog methods !  
autoSaveDictionary: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Grabar diccionario al terminar').
     (Generated by WindowBuilder)"

    aPane selection: self speller autoSave!   
autoSaveDictionaryToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Grabar diccionario al terminar').
     (Generated by WindowBuilder)"

    self speller autoSave: aPane selection.
    self message: 'Al estar habilitado, permitir guardar la configuracin al terminar para utilizarla en otras tablas.'!  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Configuracin de direcciones...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 786 @ 576; xC; yC; cRDU: (11 @ 566 rightBottom: 775 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 622 r: #left; rDU: 731 r: #left; tDU: 24 r: #top; bDU: 56 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Ejemplos';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 695 @ 100; lDU: 55 r: #left; rDU: 750 r: #left; tDU: 410 r: #top; bDU: 510 r: #top);
                    startGroup;
                    when: #getContents perform: #notes:;
                    contents: 'Notas...';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 40; lDU: 9 r: #left; tDU: 422 r: #top);
                    contents: (CPBitmapDict at: 'help icon');
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 645 r: #left; rDU: 736 r: #left; tDU: 186 r: #top; bDU: 218 r: #top);
                    rightJustified;
                    startGroup;
                    contents: '36-G-8';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 256 @ 32; lDU: 480 r: #left; rDU: 736 r: #left; tDU: 86 r: #top; bDU: 118 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Paso 234 Piso: 5 of: 3';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 32; lDU: 553 r: #left; rDU: 736 r: #left; tDU: 118 r: #top; bDU: 150 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Soler y Malabia';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 66 r: #left; rDU: 203 r: #left; tDU: 226 r: #top; bDU: 258 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Hubicacin:';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 32; lDU: 398 r: #left; rDU: 736 r: #left; tDU: 152 r: #top; bDU: 184 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Crdoba entre Cerrito y Callao';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 741 @ 232; lDU: 9 r: #left; tDU: 48 r: #top);
                    contents: 'Tipos de direcciones que pueden esperarse...';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 585 @ 48; lDU: 59 r: #left; tDU: 218 r: #top);
                    in;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 741 @ 124; lDU: 9 r: #left; tDU: 282 r: #top);
                    contents: 'Configuracin del intrprete';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 32; lDU: 23 r: #left; tDU: 86 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #standardFormat:;
                    when: #clicked perform: #standardFormatToggle:;
                    contents: 'Formato standard................................';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 539 @ 32; lDU: 23 r: #left; tDU: 118 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #weakAddress:;
                    when: #clicked perform: #weakNamesToggle:;
                    contents: 'Formato por interseccin...............................';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 631 @ 32; lDU: 23 r: #left; tDU: 184 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #useLumi:;
                    when: #clicked perform: #useLumiToggle:;
                    contents: 'Formato Lumi...............................................................';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 235 r: #left; tDU: 226 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #lumiOrigin:;
                    when: #clicked perform: #lumiOriginToggle:;
                    contents: 'origen';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 363 r: #left; tDU: 226 r: #top);
                    when: #getContents perform: #lumiCenter:;
                    when: #clicked perform: #lumiCenterToggle:;
                    contents: 'centro';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 32; lDU: 491 r: #left; tDU: 226 r: #top);
                    when: #getContents perform: #lumiRandom:;
                    when: #clicked perform: #lumiRandomToggle:;
                    contents: 'aleatoria';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 357 @ 32; lDU: 27 r: #left; tDU: 328 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #ignoreSpeller:;
                    when: #clicked perform: #ignoreSpellerToggle:;
                    contents: 'Ignorar direcciones fallidas.';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 421 @ 32; lDU: 27 r: #left; tDU: 360 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #autoSaveDictionary:;
                    when: #clicked perform: #autoSaveDictionaryToggle:;
                    contents: 'Grabar entrenamiento al terminar.';
                    font: self defaultFont;
                    foreColor: ClrBlack;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 48; lDU: 402 r: #left; rDU: 741 r: #left; tDU: 304 r: #top; bDU: 352 r: #top);
                    add: #toolSpell;
                    add: #editSpell selector: #spellTable;
                    add: #viewStamp selector: #viewMap;
                    add: #edit selector: #editSpellerDictionary spaces: 2;
                    add: #fileOpen selector: #openSpellerDictionary;
                    add: #fileSave selector: #saveSpellerDictionary;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:;
                    when: #getContents perform: #spellerTools:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSToolBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 402 @ 48; lDU: 2 r: #left; rDU: 405 r: #left; tDU: 2 r: #top; bDU: 50 r: #top);
                    add: #fileRestore selector: #fileUseDefault;
                    add: #fileNew;
                    add: #fileOpen;
                    add: #fileSave;
                    add: #fileSaveAs selector: #fileSaveAsDefault;
                    add: #toolDebug;
                    add: #fileExit selector: #close spaces: 3;
                    postAutomatic;
                    startGroup;
                    tabStop;
                    when: #showHelp perform: #toolHelp:;
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
editSpellerDictionary

    AddressTrainerDialog new openOn: self speller!   
fileNew
    "Lets the user re-initialize configuration..."

    self speller initialize.
    self fullUpdate! 
fileOpen
    "Lets the user fileIn a new configuration..."

    | dialog file config streetNet |
    dialog := FileDialog new.
    dialog
        title: 'Archivo de donde leer configuracin...';
        addFilter: '*.spc' description: 'Configuracin de Spelling de direcciones (*.SPC)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        defFilter: '*.spc';fileSpec: '*.spc';
        hideReadonly;
        open.
    file := dialog file.
    file isNil ifTrue: [^self].
    (file includes: $.)
    ifFalse: [ file := file,'.Spc' ].

    streetNet := self speller streetNet.
    config := ObjectFiler loadFromPathName: file.
    config isNil ifTrue: [ ^self error: 'Archivo Invalido...' ].

    config class == self speller class
    ifFalse: [ ^self error: 'El archivo no contiene una configuracin aceptable.' ].

    config streetNet: streetNet.
    self speller: config.
    self fullUpdate.!   
fileSave
    "Lets the user fileOut current configuration..."

    | dialog file |
    self speller isNil ifTrue: [^self beep ].
    file := (parent pathName upTo: $.), '.Spc'.
    dialog := FileDialog new.
    dialog
        title: 'Seleccione donde guardar el archivo...';
        addFilter: '*.spc' description: 'Configuracin de speller de direcciones (*.SPC)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        fileSpec: file;
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].

    (file includes: $.) ifFalse: [ file := file,'.SPC' ].
    self speller saveAs: file.
    ^file! 
fileSaveAsDefault
    "Save the current configuration as default configuration..."

    | speller dialog file |
    speller := self speller.
    speller isNil ifTrue: [^self beep ].
    speller == AddressFinder default
    ifFalse: [ AddressFinder default: speller ].
    file := file := AddressFinder defaultPath.
    dialog := FileDialog new.
    dialog
        title: 'Seleccione donde guardar el archivo...';
        addFilter: '*.spc' description: 'Configuracin de speller de direcciones (*.SPC)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        fileSpec: file;
        hideReadonly;
        overwritePrompt;
        save.
    file := dialog file.
    file isNil ifTrue: [^nil].

    (file includes: $.) ifFalse: [ file := file,'.SPC' ].
    self speller saveAs: file.
    AddressFinder defaultPath: file.
    ^file!  
fileUseDefault
    "Sets the configuration with the default configuration..."

    | streetNet |
    streetNet := self speller streetNet.
    self speller: AddressFinder default.
    self speller streetNet: streetNet.
    self fullUpdate! 
ignoreSpeller: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Ignorar direcciones fallidas').
     (Generated by WindowBuilder)"

    aPane selection: self speller fuzzySearch not!   
ignoreSpellerToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Ignorar direcciones fallidas').
     (Generated by WindowBuilder)"

    self speller fuzzySearch: aPane selection not.
    self message: 'Al estar habilitado, ignorar las calles con nombres ml escritos (permitiendo mayor velocidad de procesamiento).'! 
lumiCenter: aPane

    "Callback for the #getContents event in an unnamed CP3DRadioButton (contents is 'centro').
     (Generated by WindowBuilder)"

    aPane selection: self speller lumiOption = #center.
    self enable: aPane when: (self speller formats includes: #lumi).! 
lumiCenterToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DRadioButton (contents is 'centro').
     (Generated by WindowBuilder)"

    aPane selection
    ifTrue: [ self speller lumiOption: #center ].

    self message: 'Al estar habilitado, hubicar los objetos con direccin Lumi en el centro de la regin que determina su direccin.'!
lumiOrigin: aPane

    "Callback for the #getContents event in an unnamed CP3DRadioButton (contents is 'origen').
     (Generated by WindowBuilder)"

    aPane selection: self speller lumiOption = #origin.
    self enable: aPane when: (self speller formats includes: #lumi).! 
lumiOriginToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DRadioButton (contents is 'origen').
     (Generated by WindowBuilder)"

    aPane selection
    ifTrue: [ self speller lumiOption: #origin ].
    self message: 'Al estar habilitado, hubicar los objetos con direccin Lumi en el vertice superior izquierdo de la regin que determina su direccin.'!  
lumiRandom: aPane

    "Callback for the #getContents event in an unnamed CP3DRadioButton (contents is 'aleatorio').
     (Generated by WindowBuilder)"

    aPane selection: self speller lumiOption = #random.
    self enable: aPane when: (self speller formats includes: #lumi).!  
lumiRandomToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DRadioButton (contents is 'aleatorio').
     (Generated by WindowBuilder)"

    aPane selection
    ifTrue: [ self speller lumiOption: #random ].
    self message: 'Al estar habilitado, hubicar los objetos con direccin Lumi en forma aleatoria, dentro de la regin que determina su direccin.'! 
mapViewSelected: aSelection
    "A region has been selected in the Map Dialog..."

    self notImplementedYet! 
message: aString
    "Private - Notify aString message"

    | pane |
    pane := self paneAt: #notes:.
    pane isNil ifTrue: [ ^nil ].
    pane contents: aString asString.!  
notes: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Notas...').
     (Generated by WindowBuilder)"

    aPane contents: String new!
openSpellerDictionary

    self speller fileInDictionary!   
parentDialog: aDialog
    "Sets the parent dialog..."

    parent := aDialog.! 
saveSpellerDictionary

    self speller fileOutDictionary!  
speller
    "Private - returns current speller..."

    ^parent speller!   
speller: anObject
    "Private - Sets current speller..."

    ^parent speller: anObject!  
spellerTools: aPane

    "Callback for the #getContents event in an unnamed OSToolBar.
     (Generated by WindowBuilder)"

    | item spellTools |
    spellTools := #(toolSpell spellTable).
    self streets isNil
    ifTrue: [ spellTools do: [:tool| aPane disableItem: tool ] ]
    ifFalse: [ spellTools do: [:tool| aPane enableItem: tool ] ].! 
spellTable

    | table monitor trainBlock position name speller place time |
    speller := self speller.
    trainBlock := [:dict|
        position := dict at: #position ifAbsent: [].
        name := dict at: #name ifAbsent: [].
        time := Time millisecondsToRun: [
            place := self streets find: position using: speller.
            parent aborted: speller cancelled.
        ].
        parent hasBeenAborted
        ifTrue: [ monitor cr;cr;nextPutAll: '***Entrenamiento cancelado***' ]
        ifFalse: [
            monitor
                cr;nextPutAll: name asString ,' >> ',position;
                cr;nextPutAll: ' Hubicacin: ', place asString,' tiempo empleado en la hubicacin : ',time asString,' milisegundos.';
                yourself
        ]
    ].
    CursorManager execute changeFor: [
        monitor := TextWindow
            windowLabeled: 'Entrenando direcciones.'
            frame: ((Display width // 2 @ 0 rightBottom: Display extent) insetBy: 5).
        monitor nextPutAll: 'Abriendo tabla: ',parent pathName asString;cr.
        parent readTableDoing: trainBlock.
    ].!
standardFormat: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Formato standard').
     (Generated by WindowBuilder)"

    aPane selection: (self speller formats includes: #standard)!
standardFormatToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Formato standard').
     (Generated by WindowBuilder)"

    aPane selection
    ifTrue: [ self speller formats add: #standard ]
    ifFalse: [ self speller formats remove: #standard ifAbsent: [] ].

    self message: 'Habilita la interpretacin de direccines en formato standard. ATENCIN: el nmero de puerta, piso y/o dto seran ignorados (aunque se conservar la informacin).'! 
streets
    "Private - Returns current city streets..."

    ^parent map notNil ifTrue: [ parent map streets ]!
toolHelp: palette
    "Process the help event in the toolbar & palettes"
    | selector text |
    selector := palette selectorAt: palette currentIndex.
    selector isNil ifTrue: [^self].
    text := (self class helpMap
        detect: [:each| each first = selector ] ifNone: [Array with: String new]) last.
    self message: text!   
toolSpell
    "Lets the user test the street net & AddressFinder"
    | input text old speller result time |
    speller := self speller.
    [
    input := OSPrompter
        prompt: 'Direccin a hubicar ?'
        default: input.
    input isNil ifTrue: [^self].
    old := speller returns.
    speller returns: #point.
    time := Time millisecondsToRun: [
        result := self streets find: input using: speller
    ].
    result notNil ifTrue: [
        text := 'No se ha encontrado como hubicar el objeto.'.
        result isPoint
        ifTrue: [ text := 'El objeto sera hubicado en la posicin : ',result truncated asString ]
        ifFalse: [ text := text,'\Resultado:',result asString. ].
        text := text,'\Milisegundos empleados en la bsqueda: ',time asString.

        MessageBox message: text withCrs.
    ] ifFalse: [ self warning: 'No encontr la direccin.' ].
    speller returns: old.
    true"result isNil" ] whileTrue: [].!
useLumi: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Formato Lumi').
     (Generated by WindowBuilder)"

    aPane selection: (self speller formats includes: #lumi)!   
useLumiToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Formato Lumi').
     (Generated by WindowBuilder)"

    aPane selection
    ifTrue: [ self speller formats add: #lumi ]
    ifFalse: [ self speller formats remove: #lumi ifAbsent: [] ].

    self
        changed: #lumiOrigin:;
        changed: #lumiCenter:;
        changed: #lumiRandom:;
        yourself.

    self message: 'Habilita la interpretacin de direccines en formato de Gua Lumi. ATENCIN: Este formato es poco preciso; use esta opcin si no le queda otra alternativa...'! 
viewMap
    "Lets the user view the map and find streets using current speller"

    | dialog |
    dialog := MapDialog new.
    dialog
        mapView: parent mapView;
        speller: self speller;
        selectionBlock: [ self mapViewSelected: dialog selection ].
    self
        send: #open
        to: dialog!   
weakAddress: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Formato por interseccin ').
     (Generated by WindowBuilder)"

    aPane selection: (self speller formats includes: #intersections)! 
weakNamesToggle: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Formato por interseccin ').
     (Generated by WindowBuilder)"

    aPane selection
    ifTrue: [ self speller formats add: #intersections ]
    ifFalse: [ self speller formats remove: #intersections ifAbsent: [] ].

    self message: 'Habilita la interpretacin de direccines en por medio de interseccin de calles. ATENCIN: Este formato no es preciso y las calles no deben incluir las palabras "Y" ni "Entre"'! !

! CoffeBreak class methods !  
saying: aString
    "Open an instance of the receiver saying aString.
     and returns the user response"
    ^self new
        setText: aString;
        open;
        result! 
wbCreated

    ^true! !

! CoffeBreak methods !   
continue: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Continuar').
     (Generated by WindowBuilder)"

     result := #continue.
    self close! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Descanso';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 910 @ 308; xC; yC; cRDU: (11 @ 298 rightBottom: 898 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 218; lDU: 27 r: #left; tDU: 14 r: #top);
                    contents: (CPBitmapDict at: 'Waiting');
                    stretchToFit;
                    startGroup;
                    when: #getContents perform: #getBitmap:;
                    backColor: ClrBackground;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 601 @ 156; lDU: 274 r: #left; rDU: 875 r: #left; tDU: 18 r: #top; bDU: 174 r: #top);
                    startGroup;
                    when: #getContents perform: #text:;
                    contents: '';
                    font: self defaultFont;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 169 @ 58; lDU: 711 r: #left; rDU: 880 r: #left; tDU: 184 r: #top; bDU: 242 r: #top);
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #continue:;
                    contents: 'Continuar';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 176 @ 58; lDU: 530 r: #left; rDU: 706 r: #left; tDU: 184 r: #top; bDU: 242 r: #top);
                    when: #clicked perform: #retry:;
                    when: #getContents perform: #retryButton:;
                    contents: 'Reintentar';
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
getBitmap: aPane

    "Callback for the #getContents event in an unnamed CPBitmapPane.
     (Generated by WindowBuilder)"

    bitmap notNil ifTrue: [ aPane contents: bitmap ].!
initialize
    "Private - Initialize the receiver"

    super initialize.
    useRetry := false.
    text := String new.!
result
    "Returns the instance var of the receiver
     for external manipulation"
    ^result!  
retry: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Reintentar').
     (Generated by WindowBuilder)"

     result := #retry.
    self close!  
retryButton: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Reintentar').
     (Generated by WindowBuilder)"

    self enable: aPane when: useRetry! 
setText: aString
    "Set the text string to aString"

    text := aString.
    self changed: #text:! 
text: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '').
     (Generated by WindowBuilder)"

     aPane contents: text!  
useRetry
    "Returns the instance var of the receiver
     for external manipulation"
    ^useRetry!  
useRetry: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    useRetry := anObject! !

! CustomizeToolbarDialog class methods !   
openOn: aToolbar with: allTools comments: comments
    "Open the receiver for working on aToolbar.
     Lets the user to configure it from a collection
     of tools allTools showing comments
     in comments to the user"

    ^self new
        toolBar: aToolbar;
        tools: allTools;
        comments: comments;
        open!  
test
    "Test the receiver..."
    | comments |
    comments := Dictionary new.
    comments
        at: 'Archivo' put: 'Archivo...';
        at: #fileOpen put: 'Abre un nuevo mapa...';
        at: #fileRun put: 'Permite ejecutar otro programa.';
        at: #fileExit put: 'Termina la aplicacion.';

        at: 'Ayudas' put: 'Menu de Ayudas al usuario y registracion.';
        at: #helpAbout put: 'Muestra informacion sobre version y Copywrite.';
        at: #helpContents put: 'Muestra el indice de las ayudas.';
        at: #helpPick put: 'Permite elegir la ayuda correspondiente a un elemento en pantalla';
        yourself.
    ^self
        openOn: nil
        with: #(
            fileOpen filePageSetup filePrint filePrintPreview 5
            editCopy editSearch 5
            viewGrid viewHeader
            viewFooter viewZoomIn viewZoomOut viewFullScreen 5
            mdiNewWindow mdiCascade mdiTileHoriz mdiTile
            mdiCloseAll 5
            fileRun fileExit 5
            helpContents helpPick helpAbout)
        comments: comments!  
wbCreated

    ^true! !

! CustomizeToolbarDialog methods !   
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    self close!   
comments: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    comments := anObject! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Barra de Herramientas';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 795 @ 584; xC; yC; cRDU: (11 @ 574 rightBottom: 784 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                OSListPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 754 @ 444; lDU: 9 r: #left; rDU: 763 r: #left; tDU: 4 r: #top; bDU: 448 r: #top);
                    defaultStyle;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #fillList:;
                    when: #select perform: #selectTool:;
                    when: #drawItem perform: #drawTool:;
                    when: #doubleClickSelect perform: #toggleState:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 40; lDU: 18 r: #left; tDU: 456 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #visibleToggle:;
                    when: #clicked perform: #toggleState:;
                    contents: 'Visible';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 64; lDU: 391 r: #left; rDU: 583 r: #left; tDU: 456 r: #top; bDU: 520 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&Continuar';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 590 r: #left; rDU: 763 r: #left; tDU: 456 r: #top; bDU: 520 r: #top);
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar';
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
displayTool: aString at: aPoint with: aPen
    "Private - Display tool name string with aPen"

    | source dest bitmap iconExtent |
    bitmap := CPBitmapDict at: aString asString ifAbsent: [^self].
    iconExtent := self iconExtent.
    dest := aPoint + (3@0) extent: iconExtent.
    source := 0@0 extent: iconExtent.

    (inUse includes: aString) ifFalse: [
        source := source translateBy: iconExtent x @ 0.
        source := (source insetBy: 2) translateBy: 1.
        dest := (dest insetBy: 2) translateBy: 1.
    ].

    aPen
        copyBitmap: bitmap
        from: source
        to: dest.!   
drawTool: aPane

    "Callback for the #drawItem event in an unnamed DrawListPane.
     (Generated by WindowBuilder)"

    | box list str margin index fore pen |
    pen := aPane graphicsTool.
    box := aPane drawBox.
    list := aPane contents.
    str := list at: aPane drawIndex.
    self displayTool: str at: box origin with: aPane graphicsTool.
    margin := self iconExtent x + 6.
    pen
        foreColor: (
            (inUse includes: str)
                ifTrue: [pen foreColor]
                ifFalse: [UserLibrary getSysColor: ColorGraytext]);
        setTextAlign: TaTop;
        place: margin @ (self iconExtent y - aPane font height // 2) + box origin;
        displayText: (comments at: str asString ifAbsent: [str]).

    index := tools indexOf: str.
    (index > 1 and: [(tools at: index - 1) isNumber])
    ifTrue: [
        fore := pen foreColor.
        pen foreColor: ClrBlue.
        pen
            place: margin @ 0 + box origin;
            line: box rightTop.
        pen foreColor: fore
    ]!
fillList: aPane

    "Callback for the #getContents event in an unnamed DrawListPane.
     (Generated by WindowBuilder)"

    | cole |
    inUse := (toolBar contents collect: [:tool| tool selector ]) asOrderedCollection.
    cole := OrderedCollection new.
    tools do: [:each| each isNumber ifFalse: [ cole add: each ] ].
    aPane contents: cole! 
iconExtent
    "Returns the icon width"
    ^25@22! 
initialize
    "Private - Initialize the receiver"

    super initialize.
    inUse := Set new.
    tools := Set new.
    comments := Dictionary new.!  
ok: aPane

    "Callback for the #clicked event in an unnamed Button (contents is '&Continuar').
     (Generated by WindowBuilder)"

    | index owner cole tool |
    toolBar notNil
    ifTrue: [
        (toolBar isKindOf: ToolPane)
        ifTrue: [
            "only an owner is supported for customized toolbars"
            owner := toolBar owner.
            cole := OrderedCollection new.
            tools do: [:each|
                (inUse includes: each)
                ifTrue: [
                    tool := self toolFor: each.
                    tool owner: owner.
                    index := (tools indexOf: each) - 1.
                    (index > 0 and: [(tools at: index) isNumber])
                    ifTrue: [ tool space: (tools at: index) ].
                    cole addLast: tool.
                ]
            ].
            toolBar contents: cole asArray.
        ]
        ifFalse: [ "WBToolBar assumed"
            toolBar elements: toolBar newPage.
            tools do: [:each|
                (inUse includes: each)
                ifTrue: [
                    index := (tools indexOf: each) - 1.
                    (index > 0 and: [(tools at: index) isNumber])
                    ifTrue: [ toolBar add: each spaces: (tools at: index) ]
                    ifFalse: [ toolBar add: each ]
                ]
            ]
        ].
        toolBar redraw.
    ].

    (toolBar mainWindow owner respondsTo: #toolsHasChanged)
    ifTrue: [toolBar mainWindow owner toolsHasChanged].

    self close.!   
openWindow
    "Private - Open the receiver's window"

    | pane |
    pane := self paneAt: #fillList:.
    pane
        ownerDrawFixed;
        height: self iconExtent y;
        " style: pane style - WsBorder; "
        yourself.

    super openWindow.!   
selectTool: aPane

    "Callback for the #select event in an unnamed DrawListPane.
     (Generated by WindowBuilder)"

    self changed: #visibleToggle:.!   
toggleState: aPane

    "Callback for the #doubleClickSelect event in an unnamed DrawListPane.
     (Generated by WindowBuilder)"

    | item list |
    list := self paneAt: #fillList:.
    item := list selectedItem.
    item isNil ifTrue: [^nil].
    inUse
        remove: item
        ifAbsent: [ inUse add: item asSymbol ].
    aPane = list
    ifTrue: [ aPane invalidateRect: list drawBox ]
    ifFalse: [ list redraw ].
    self changed: #visibleToggle:.!   
toolBar: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    toolBar := anObject!   
toolFor: aSymbol
    "Private - Returns aTool named aName..."
    | bitmap bmp tool |
    bmp := CPBitmapDict at: aSymbol asString.
    bmp width = 75
    ifTrue: [ "3 state tool"
        bitmap := Bitmap screenExtent: 50@bmp height.
        bitmap pen
            copyBitmap: bmp
            from: bitmap boundingBox
            to: bitmap boundingBox
    ] ifFalse: [ bitmap := bmp ].
    tool := Tool fromBitmap: bitmap.
    ^tool
        extent: bitmap width // 2 @ bitmap height;
        selector: aSymbol;
        owner: self model;
        yourself! 
tools: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    tools := anObject!   
visibleToggle: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Visible').
     (Generated by WindowBuilder)"

    aPane selection: (
        inUse includes: (self paneAt: #fillList:) selectedItem)! !

! HaloEffectDialog class methods !  
wbCreated

    ^true! !

! HaloEffectDialog methods ! 
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    self close!   
gap
    "Private - Returns the receiver's gap measure"
    ^3@3 "pixels"!   
ok: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Aceptar').
     (Generated by WindowBuilder)"

    self close!
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Efecto...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 562 @ 272; xC; yC; cRDU: (11 @ 262 rightBottom: 551 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 42; lDU: 391 r: #left; rDU: 523 r: #left; tDU: 164 r: #top; bDU: 206 r: #top);
                    startGroup;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 42; lDU: 256 r: #left; rDU: 389 r: #left; tDU: 164 r: #top; bDU: 206 r: #top);
                    defaultPushButton;
                    startGroup;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; yourself
            );
        yourself
    ).

    self openWindow! 
openWindow
    "Open the receiver's window"

    title isNil ifFalse: [
        self mainView labelWithoutPrefix: title
    ].
    ^super openWindow!   
title
    "Returns the instance var of the receiver
     for external manipulation"
    ^title!
title: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    title := anObject! !

! HaloDistortDialog class methods !  
wbCreated

    ^true! !

! HaloDistortDialog methods !
button: aPane

    "Callback for the #select event in an unnamed CPValueSet.
     (Generated by WindowBuilder)"

    | selection |
    selection := aPane selection.
    selection y = 1
    ifTrue: [ "row 1"
        selection x = 1
        ifTrue: [
            corners first x: 0;y: 0.
            (corners at: 2) x: 0;y: 100.
            (corners at: 3) x: 100;y: 100.
            corners last x: 100;y: 0.
        ]
        ifFalse: [
            selection x = 2
            ifTrue: [
                corners first x: 40;y: 0.
                (corners at: 2) x: 0;y: 100.
                (corners at: 3) x: 100;y: 100.
                corners last x: 60;y: 0.
            ]
            ifFalse: [
                corners first x: 0;y: 0.
                (corners at: 2) x: 0;y: 100.
                (corners at: 3) x: 100;y: 60.
                corners last x: 100;y: 40.
            ]
        ]
    ]
    ifFalse: [
        selection y = 2
        ifTrue: [ "row 2"
            selection x = 1
            ifTrue: [
                corners first x: 0;y: 0.
                (corners at: 2) x: 0;y: 50.
                (corners at: 3) x: 100;y: 100.
                corners last x: 100;y: 50.
            ]
            ifFalse: [
                selection x = 2
                ifTrue: [
                    corners first x: 30;y: 30.
                    (corners at: 2) x: 0;y: 100.
                    (corners at: 3) x: 100;y: 100.
                    corners last x: 100;y: 0.
                ]
                ifFalse: [
                    corners first x: 0;y: 0.
                    (corners at: 2) x: 0;y: 100.
                    (corners at: 3) x: 70;y: 70.
                    corners last x: 100;y: 0.
                ]
            ]
        ]
        ifFalse: [ "row 3"
            selection x = 1
            ifTrue: [ self useLastSettings ]
            ifFalse: [
                selection x = 2
                ifTrue: [ self loadSettings ]
                ifFalse: [ self saveSettings ]
            ]
        ].
    ].
    self
        changed: #display:;
        changed: #setLeftBottomX:;
        changed: #setLeftBottomY:;
        changed: #setRightBottomX:;
        changed: #setRightBottomY:;
        changed: #setLeftTopX:;
        changed: #setLeftTopY:;
        changed: #setRightTopX:;
        changed: #setRightTopY:;
        yourself.!   
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    corners := nil.
    super cancel: aPane! 
corners
    "Returns the instance var of the receiver
     for external manipulation"
    ^corners!
corners: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    corners := anObject!   
display: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen lineTo |
    pen := aPane pen.
    pen isNil ifTrue: [^self].

    pen
        erase;
        foreColor: ClrDarkgray;
        place: 0@0;
        box: 100@100.

    lineTo := [:point|
        pen
            resetAttributes;
            black;
            setLineType: PsDot;
            goto: point;
            place: point - self gap;
            setLineType: PsSolid;
            foreColor: ClrBlue;
            box: point + self gap;
            place: point.
    ].

    pen place: corners last.
    corners do: [:dot| lineTo value: dot ].!   
dotMoved: aPane

    "Callback for the #button1Move event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen mark index border |
    inMotion isNil ifTrue: [^self].
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    mark := [
        pen
            setRop2: R2Notxorpen;
            place: inMotion last;
            goto: inMotion first;
            goto: (inMotion at: 2);
            place: inMotion first;
            circleFilled: self gap;
            setRop2: R2Copypen;
            yourself.
    ].

    "Update graphical view..."
    mark value.
    inMotion first
        x: aPane mouseLocation x;
        y: aPane mouseLocation y.
    mark value.

    "Update numeric view..."
    index := corners indexOf: inMotion first.
    index = 0 ifTrue: [^self].
    border := #('LeftTop' 'LeftBottom' 'RightBottom' 'RightTop') at: index.

    self
        changed: ('set',border,'X:') asSymbol;
        changed: ('set',border,'Y:') asSymbol;
        yourself.!
initialize
    "Private - Initialize the receiver"

    super initialize.

    corners := Array new: 4.
    corners
        at: 1 put: 0@0;
        at: 2 put: 0@100;
        at: 3 put: 100@100;
        at: 4 put: 100@0;
        yourself!  
lastDistort
    "Private - Returns last used distort parameters"

    | points stream key next |
    key := 'Last Distort'.
    next := [
        stream countBlanks.
        (stream upTo: $ ) asInteger
    ].
    ^self class
        atKey: key
        ifAbsent: [
            stream := (self profiler
                at: key ifAbsent: [ '0 0 0 100 100 100 100 0' ])
                asStream.
            points := Array
                with: next value @ next value
                with: next value @ next value
                with: next value @ next value
                with: next value @ next value.
            self class atKey: key put: points.
            points
        ]!   
lastDistort: points
    "Private - Save last used distort parameters"

    | stream key dump |
    key := 'Last Distort'.
    dump := [:aPoint|
        stream
            space;nextPutAll: aPoint x asString;
            space;nextPutAll: aPoint y asString
    ].
    stream := WriteStream on: String new.
    points do: [:each| dump value: each ].
    self profiler at: key put: stream contents.
    ^self class atKey: key put: (points collect: [:each| each copy])!
loadSettings
    "Private - Load current corner settings from a file"

    | dialog file avi loader |
    loader := Smalltalk
        at: #Loader
        ifAbsent: [^self error: 'Can''t load current settings'].
    dialog := FileDialog new.
    dialog
        addFilter: '*.DIS' description: 'Archivos de distorciones (*.DIS)';
        addFilter: '*.*' description: 'Todos los archivos (*.*)';
        defFilter: '*.DIS';
        openFile.

    file := dialog file.
    file isNil ifTrue: [^self].
    corners := loader new loadFrom: file.!  
mouseDown: aPane

    "Callback for the #button1Down event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | dot |
    inMotion := nil.
    dot := corners
        detect: [:each| (each - aPane mouseLocation) abs < self gap ]
        ifNone: [^self beep].

    inMotion := (
        dot = corners first
        ifTrue: [
            Array with: corners first with: (corners at: 2) with: corners last
        ]
        ifFalse: [
            dot = corners last
            ifTrue: [ Array with: corners last with: corners first with: (corners at: 3) ]
            ifFalse: [
                dot = (corners at: 3)
                ifTrue: [
                    Array with: (corners at: 3) with: (corners at: 2) with: corners last
                ]
                ifFalse: [
                    Array with: (corners at: 2) with: (corners at: 3) with: corners first
                ]
            ]
        ]
    )!   
mouseMoved: aPane

    "Callback for the #mouseMove event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    corners
        detect: [:each| (each - aPane mouseLocation) abs < self gap ]
        ifNone: [^CursorManager normal change].
    CursorManager crossHair change.! 
mouseUp: aPane

    "Callback for the #button1Up event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self
        dotMoved: aPane;
        changed: #display:!  
ok: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Aceptar').
     (Generated by WindowBuilder)"

    self lastDistort: corners.
    ^super ok: aPane!  
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Efecto...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 677 @ 372; xC; yC; cRDU: (11 @ 362 rightBottom: 665 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 258 @ 226; lDU: 57 r: #left; tDU: 44 r: #top);
                    startGroup;
                    contents: ''; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 272 @ 236; lDU: 370 r: #left; tDU: 14 r: #top);
                    startGroup;
                    contents: 'Distorsiones'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 39 @ 28; lDU: 267 r: #left; rDU: 306 r: #left; tDU: 8 r: #top; bDU: 36 r: #top);
                    rightJustified;
                    startGroup;
                    when: #getContents perform: #setRightTopX:;
                    contents: 'x3'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 39 @ 28; lDU: 267 r: #left; rDU: 306 r: #left; tDU: 278 r: #top; bDU: 306 r: #top);
                    rightJustified;
                    startGroup;
                    when: #getContents perform: #setRightBottomX:;
                    contents: 'x2'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 39 @ 28; lDU: 66 r: #left; rDU: 105 r: #left; tDU: 278 r: #top; bDU: 306 r: #top);
                    startGroup;
                    when: #getContents perform: #setLeftBottomX:;
                    contents: 'x1'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 39 @ 28; lDU: 9 r: #left; rDU: 48 r: #left; tDU: 230 r: #top; bDU: 258 r: #top);
                    rightJustified;
                    startGroup;
                    when: #getContents perform: #setLeftBottomY:;
                    contents: 'y1'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 39 @ 28; lDU: 322 r: #left; rDU: 361 r: #left; tDU: 230 r: #top; bDU: 258 r: #top);
                    startGroup;
                    when: #getContents perform: #setRightBottomY:;
                    contents: 'y2'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 39 @ 28; lDU: 325 r: #left; rDU: 363 r: #left; tDU: 50 r: #top; bDU: 78 r: #top);
                    startGroup;
                    when: #getContents perform: #setRightTopY:;
                    contents: 'y3'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 39 @ 28; lDU: 66 r: #left; rDU: 105 r: #left; tDU: 8 r: #top; bDU: 36 r: #top);
                    startGroup;
                    when: #getContents perform: #setLeftTopX:;
                    contents: 'x0'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 39 @ 28; lDU: 9 r: #left; rDU: 48 r: #left; tDU: 50 r: #top; bDU: 78 r: #top);
                    rightJustified;
                    startGroup;
                    when: #getContents perform: #setLeftTopY:;
                    contents: 'y0'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 231 @ 202; lDU: 71 r: #left; rDU: 302 r: #left; tDU: 56 r: #top; bDU: 258 r: #top);
                    noBorders;
                    startGroup;
                    when: #getContents perform: #display:;
                    when: #button1Up perform: #mouseUp:;
                    when: #button1Down perform: #mouseDown:;
                    when: #button1Move perform: #dotMoved:;
                    when: #mouseMove perform: #mouseMoved:; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 44; lDU: 370 r: #left; rDU: 503 r: #left; tDU: 260 r: #top; bDU: 304 r: #top);
                    defaultPushButton;
                    startGroup; tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 42; lDU: 510 r: #left; rDU: 642 r: #left; tDU: 260 r: #top; bDU: 302 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPValueSet new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 254 @ 202; lDU: 379 r: #left; tDU: 44 r: #top);
                    rows: 3 columns: 3;
                    bitmapItem: (CPBitmapDict at: 'Distort1') row: 1 column: 1;
                    bitmapItem: (CPBitmapDict at: 'Distort4') row: 2 column: 1;
                    bitmapItem: (CPBitmapDict at: 'Distort7') row: 3 column: 1;
                    bitmapItem: (CPBitmapDict at: 'Distort2') row: 1 column: 2;
                    bitmapItem: (CPBitmapDict at: 'Distort5') row: 2 column: 2;
                    bitmapItem: (CPBitmapDict at: 'ToolOpen') row: 3 column: 2;
                    bitmapItem: (CPBitmapDict at: 'Distort3') row: 1 column: 3;
                    bitmapItem: (CPBitmapDict at: 'Distort6') row: 2 column: 3;
                    bitmapItem: (CPBitmapDict at: 'ToolSave') row: 3 column: 3;
                    startGroup; tabStop;
                    when: #select perform: #button:;
                    backColor: ClrPalegray; yourself
            );
        yourself
    ).

    self openWindow!  
saveSettings
    "Private - Save current corner settings in a file"

    | file loader |
    loader := Smalltalk
        at: #Loader
        ifAbsent: [^self error: 'Can''t save current settings'].
    file := (FileDialog new
        saveTitle: 'Grabar Distorsin '
        fileName: (File
                fileName: 'Distor'
                extension: 'Dis')) file.
    file isNil ifTrue: [^self].
    loader new unload: corners on: file!   
setLeftBottomX: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'x1').
     (Generated by WindowBuilder)"

    aPane contents: (corners at: 2) x asString.!
setLeftBottomY: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'y1').
     (Generated by WindowBuilder)"

    aPane contents: (corners at: 2) y asString.!
setLeftTopX: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'x0').
     (Generated by WindowBuilder)"

    aPane contents: corners first x asString.! 
setLeftTopY: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'y0').
     (Generated by WindowBuilder)"

    aPane contents: corners first y asString.! 
setRightBottomX: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'x2').
     (Generated by WindowBuilder)"

    aPane contents: (corners at: 3) x asString.!   
setRightBottomY: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'y2').
     (Generated by WindowBuilder)"

    aPane contents: (corners at: 3) y asString.!   
setRightTopX: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'x3').
     (Generated by WindowBuilder)"

    aPane contents: corners last x asString.! 
setRightTopY: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'y3').
     (Generated by WindowBuilder)"

    aPane contents: corners last y asString.! 
useLastSettings
    "Private - Configure corners from last settings"

    | points |
    points := self lastDistort.
    1 to: corners size do: [:i|
        (corners at: i)
            x: (points at: i) x;
            y: (points at: i) y
    ].! !

! HaloPrintDialog class methods ! 
wbCreated

    ^true! !

! HaloPrintDialog methods !  
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Impresin de Imagen';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 864 @ 394; xC; yC; cRDU: (11 @ 384 rightBottom: 853 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 343 @ 210; lDU: 7 r: #left; tDU: 6 r: #top);
                    startGroup;
                    contents: 'Tamao de Impresion'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 343 @ 210; lDU: 357 r: #left; tDU: 6 r: #top);
                    startGroup;
                    contents: 'Posicin'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 42; lDU: 555 r: #left; rDU: 688 r: #left; tDU: 282 r: #top; bDU: 324 r: #top);
                    defaultPushButton;
                    startGroup;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar';
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 42; lDU: 690 r: #left; rDU: 823 r: #left; tDU: 282 r: #top; bDU: 324 r: #top);
                    startGroup;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar';
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 117 @ 44; lDU: 213 r: #left; tDU: 126 r: #top);
                    startGroup; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 114 @ 32; lDU: 21 r: #left; tDU: 42 r: #top);
                    startGroup;
                    contents: '1 en 1'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 231 @ 32; lDU: 21 r: #left; tDU: 72 r: #top);
                    startGroup;
                    contents: 'Pgina completa.'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 190 @ 32; lDU: 21 r: #left; tDU: 102 r: #top);
                    startGroup;
                    contents: 'Media pgina'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 176 @ 32; lDU: 21 r: #left; tDU: 132 r: #top);
                    startGroup;
                    contents: 'Escalado %'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 130 @ 48; lDU: 69 r: #left; tDU: 162 r: #top);
                    startGroup;
                    contents: 'Suave'; font: self defaultFont;
                    foreColor: ClrBlack; yourself
            );
            addSubpane: (
                StaticText3D new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 75 @ 30; lDU: 377 r: #left; tDU: 42 r: #top);
                    startGroup;
                    contents: 'A izq.'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText3D new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 75 @ 30; lDU: 377 r: #left; tDU: 72 r: #top);
                    startGroup;
                    contents: 'A der.'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 117 @ 48; lDU: 466 r: #left; tDU: 30 r: #top);
                    startGroup; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 117 @ 48; lDU: 466 r: #left; tDU: 84 r: #top);
                    startGroup; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 144 @ 32; lDU: 391 r: #left; tDU: 150 r: #top);
                    startGroup;
                    contents: 'centrado'; font: self defaultFont;
                    foreColor: ClrBlack; yourself
            );
        yourself
    ).

    self openWindow! !

! HaloRGBDialog class methods !   
wbCreated

    ^true! !

! HaloRGBDialog methods !
blue
    "Returns the instance var of the receiver
     for external manipulation"
    ^blue!  
blue: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    blue := anObject! 
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    red := green := blue := nil.
    super cancel: aPane!
clickBlue: aPane

    "Callback for the #clicked event in an unnamed CP3DRadioButton (contents is 'Azul').
     (Generated by WindowBuilder)"

    blue := aPane selection.
    self changed: #setBlue:.!   
clickGreen: aPane

    "Callback for the #clicked event in an unnamed CP3DRadioButton (contents is 'Verde').
     (Generated by WindowBuilder)"

    green := aPane selection.
    self changed: #setGreen:.!   
clickRed: aPane

    "Callback for the #clicked event in an unnamed CP3DRadioButton (contents is 'Rojo').
     (Generated by WindowBuilder)"

    red := aPane selection.
    self changed: #setRed:.!  
green
    "Returns the instance var of the receiver
     for external manipulation"
    ^green!
green: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    green := anObject!   
initialize
    "Private - Initialize the receiver"

    super initialize.

    red := green := blue := true.!
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Efecto...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 485 @ 220; xC; yC; cRDU: (11 @ 210 rightBottom: 473 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 434 @ 96; lDU: 16 r: #left; tDU: 8 r: #top);
                    startGroup;
                    contents: 'Planos a procesar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 46; lDU: 167 r: #left; rDU: 306 r: #left; tDU: 110 r: #top; bDU: 156 r: #top);
                    defaultPushButton;
                    startGroup; tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 46; lDU: 311 r: #left; rDU: 450 r: #left; tDU: 110 r: #top; bDU: 156 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 94 @ 32; lDU: 39 r: #left; tDU: 48 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #clickRed:;
                    when: #getContents perform: #setRed:;
                    contents: 'Rojo'; font: self defaultFont;
                    foreColor: ClrBlack; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 114 @ 32; lDU: 176 r: #left; tDU: 48 r: #top);
                    when: #clicked perform: #clickGreen:;
                    when: #getContents perform: #setGreen:;
                    contents: 'Verde'; font: self defaultFont;
                    foreColor: ClrBlack; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 96 @ 32; lDU: 334 r: #left; tDU: 48 r: #top);
                    when: #clicked perform: #clickBlue:;
                    when: #getContents perform: #setBlue:;
                    contents: 'Azul'; font: self defaultFont;
                    foreColor: ClrBlack; yourself
            );
        yourself
    ).

    self openWindow!   
red
    "Returns the instance var of the receiver
     for external manipulation"
    ^red!
red: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    red := anObject!   
setBlue: aPane

    "Callback for the #getContents event in an unnamed CP3DRadioButton (contents is 'Azul').
     (Generated by WindowBuilder)"

    aPane selection: blue!  
setGreen: aPane

    "Callback for the #getContents event in an unnamed CP3DRadioButton (contents is 'Verde').
     (Generated by WindowBuilder)"

    aPane selection: green!   
setRed: aPane

    "Callback for the #getContents event in an unnamed CP3DRadioButton (contents is 'Rojo').
     (Generated by WindowBuilder)"

    aPane selection: red! !

! HaloPixelizeDialog class methods !  
wbCreated

    ^true! !

! HaloPixelizeDialog methods !   
height
    "Returns the instance var of the receiver
     for external manipulation"
    ^height!  
height: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    height := anObject! 
heightChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    height := aPane contents.!
initialize
    "Private - Initialize the receiver"

    super initialize.

    width := height := 2.!
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Efecto...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 489 @ 324; xC; yC; cRDU: (11 @ 314 rightBottom: 478 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 434 @ 96; lDU: 16 r: #left; tDU: 8 r: #top);
                    startGroup;
                    contents: 'Planos a procesar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 434 @ 96; lDU: 16 r: #left; tDU: 106 r: #top);
                    startGroup;
                    contents: 'Pixelizado'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 59 @ 28; lDU: 247 r: #left; rDU: 306 r: #left; tDU: 158 r: #top; bDU: 186 r: #top);
                    startGroup;
                    contents: 'Alto'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 85 @ 28; lDU: 30 r: #left; rDU: 114 r: #left; tDU: 158 r: #top; bDU: 186 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Ancho'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 46; lDU: 167 r: #left; rDU: 306 r: #left; tDU: 212 r: #top; bDU: 258 r: #top);
                    defaultPushButton;
                    startGroup; tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 46; lDU: 311 r: #left; rDU: 450 r: #left; tDU: 212 r: #top; bDU: 258 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 94 @ 32; lDU: 39 r: #left; tDU: 48 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #clickRed:;
                    when: #getContents perform: #setRed:;
                    contents: 'Rojo'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 114 @ 32; lDU: 176 r: #left; tDU: 48 r: #top);
                    when: #clicked perform: #clickGreen:;
                    when: #getContents perform: #setGreen:;
                    contents: 'Verde'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 96 @ 32; lDU: 334 r: #left; tDU: 48 r: #top);
                    when: #clicked perform: #clickBlue:;
                    when: #getContents perform: #setBlue:;
                    contents: 'Azul'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 48; lDU: 126 r: #left; tDU: 138 r: #top);
                    min: 0;
                    max: 50;
                    contents: 2;
                    startGroup; tabStop;
                    when: #getContents perform: #setWidth:;
                    when: #valueChanged perform: #widthChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 48; lDU: 313 r: #left; tDU: 138 r: #top);
                    min: 0;
                    max: 50;
                    contents: 2;
                    startGroup; tabStop;
                    when: #getContents perform: #setHeight:;
                    when: #valueChanged perform: #heightChanged:; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
        yourself
    ).

    self openWindow!   
setHeight: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: height.!   
setWidth: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: width.! 
width
    "Returns the instance var of the receiver
     for external manipulation"
    ^width!
width: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    width := anObject!   
widthChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    width := aPane contents.! !

! HaloPosterizeDialog class methods !   
wbCreated

    ^true! !

! HaloPosterizeDialog methods !  
bits
    "Returns the instance var of the receiver
     for external manipulation"
    ^bits!  
bits: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    bits := anObject! 
bitsChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    bits := aPane contents.
    self changed: #bitsReading:.!   
bitsChanging: aPane

    "Callback for the #valueChanging event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    bits := aPane contents.
    self changed: #bitsReading:.! 
bitsReading: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '-*-').
     (Generated by WindowBuilder)"

    aPane contents: bits asString!
initialize
    "Private - Initialize the receiver"

    super initialize.

    bits := 3.!   
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Efecto...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 485 @ 332; xC; yC; cRDU: (11 @ 322 rightBottom: 473 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 434 @ 96; lDU: 14 r: #left; tDU: 8 r: #top);
                    startGroup;
                    contents: 'Planos a procesar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 434 @ 108; lDU: 14 r: #left; tDU: 104 r: #top);
                    startGroup;
                    contents: 'Degradacin'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 87 @ 28; lDU: 197 r: #left; rDU: 283 r: #left; tDU: 174 r: #top; bDU: 202 r: #top);
                    centered;
                    startGroup;
                    when: #getContents perform: #bitsReading:;
                    contents: '-*-'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 85 @ 28; lDU: 27 r: #left; rDU: 112 r: #left; tDU: 174 r: #top; bDU: 202 r: #top);
                    startGroup;
                    contents: 'Mucha'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 66 @ 28; lDU: 368 r: #left; rDU: 434 r: #left; tDU: 174 r: #top; bDU: 202 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Poca'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 46; lDU: 162 r: #left; rDU: 302 r: #left; tDU: 218 r: #top; bDU: 264 r: #top);
                    defaultPushButton;
                    startGroup; tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 46; lDU: 306 r: #left; rDU: 446 r: #left; tDU: 218 r: #top; bDU: 264 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 94 @ 32; lDU: 37 r: #left; tDU: 48 r: #top);
                    startGroup; tabStop;
                    when: #getContents perform: #setRed:;
                    when: #clicked perform: #clickRed:;
                    contents: 'Rojo'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 114 @ 32; lDU: 174 r: #left; tDU: 48 r: #top);
                    when: #getContents perform: #setGreen:;
                    when: #clicked perform: #clickGreen:;
                    contents: 'Verde'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 96 @ 32; lDU: 331 r: #left; tDU: 48 r: #top);
                    when: #getContents perform: #setBlue:;
                    when: #clicked perform: #clickBlue:;
                    contents: 'Azul'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPHorizontalSlider new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 409 @ 34; lDU: 25 r: #left; tDU: 134 r: #top);
                    max: 7;
                    startGroup; tabStop;
                    when: #getContents perform: #setBits:;
                    when: #valueChanging perform: #bitsChanging:;
                    when: #valueChanged perform: #bitsChanged:;
                    backColor: ClrPalegray; yourself
            );
        yourself
    ).

    self openWindow!   
setBits: aPane

    "Callback for the #getContents event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    aPane contents: bits! !

! HaloRotateDialog class methods ! 
wbCreated

    ^true! !

! HaloRotateDialog methods ! 
anchor
    "Returns a fixed anchor type"
    ^'Bottomleft'! 
anchorPoint
    "Returns a fixed anchor point"
    ^0@0!
angle
    "Returns the instance var of the receiver
     for external manipulation"
    ^angle!
angle: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    angle := anObject!   
angleChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    angle := aPane contents.
    self changed: #display:! 
angleDisplay: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: angle!  
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    angle := nil.
    super cancel: aPane!   
computeAngleFor: aPoint
    "Private - Compute the angle for aPoint"
    | cuadrant x y z |
    x := aPoint y.
    y := aPoint x.

    cuadrant := x > 0
        ifTrue: [
            y > 0
            ifTrue: [0]
            ifFalse: [ 180 ]
        ]
        ifFalse: [
            y > 0
            ifTrue: [ 0 ]
            ifFalse: [ 180 ]
        ].

    y = 0
    ifTrue: [angle := cuadrant]
    ifFalse: [angle := (x / y) arcTan radiansToDegrees + cuadrant ].
    angle := 360 - ( (angle * 10) truncated / 10 asFloat) \\ 360! 
display: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen lineTo |
    pen := aPane pen.
    pen isNil ifTrue: [^self].

    pen
        erase;
        foreColor: ClrDarkgray.
    #(0 90 180 270) do: [:each|
        pen place: 50@50;direction: each;go: 50
    ].
    pen
        black;
        home;
        direction: 0;
        place: 50@50.

    self drawBoxWith: pen.!   
dotMoved: aPane

    "Callback for the #button1Move event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen point mark |
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    mark := [
        pen
            setRop2: R2Notxorpen;
            " setLineWidth: 2; "
            foreColor: ClrRed"Green";
            place: point;goto: 50@50;
            " setLineWidth: 1; "
            yourself.
        self drawBoxWith: pen.
        pen setRop2: R2Copypen.
    ].
    point := aPane mouseLocation.
    mark value.
    self computeAngleFor: point - (50@50).
    mark value.
    self changed: #angleDisplay:!
drawBoxWith: aPen
    "Private - Draw the box with aPen"

    aPen
        direction: 360 - angle;
        foreColor: ClrDarkblue;
        down;go: 25;
        up;turn: 90;go: 25;down.
    1 to: 4 do: [:i|
        corners at: i put: aPen location copy.
        aPen
            turn: 90;
            black;
            go: 50;
            "
            foreColor: ClrDarkblue;
            circle: 3;
            "
            yourself
    ].
    aPen black! 
initialize
    "Private - Initialize the receiver"

    super initialize.
    angle := 0.
    corners := Array
        with: 0@0
        with: 0@0
        with: 0@0
        with: 0@0!  
mouseDown: aPane

    "Callback for the #button1Down event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    "do nothing now..."! 
mouseMoved: aPane

    "Callback for the #mouseMove event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    "
    corners
        detect: [:each| (each - aPane mouseLocation) abs < self gap ]
        ifNone: [^CursorManager normal change].
    CursorManager crossHair change.
    "!   
mouseUp: aPane

    "Callback for the #button1Up event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self
        dotMoved: aPane;
        changed: #display:!  
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Efecto...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 443 @ 304; xC; yC; cRDU: (11 @ 294 rightBottom: 432 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 258 @ 226; lDU: 11 r: #left; tDU: 10 r: #top);
                    startGroup;
                    contents: ''; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 231 @ 202; lDU: 25 r: #left; rDU: 256 r: #left; tDU: 22 r: #top; bDU: 224 r: #top);
                    noBorders;
                    startGroup;
                    when: #getContents perform: #display:;
                    when: #button1Up perform: #mouseUp:;
                    when: #button1Down perform: #mouseDown:;
                    when: #button1Move perform: #dotMoved:;
                    when: #mouseMove perform: #mouseMoved:; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 96 @ 28; lDU: 281 r: #left; rDU: 377 r: #left; tDU: 54 r: #top; bDU: 82 r: #top);
                    startGroup;
                    contents: 'ngulo:'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 42; lDU: 281 r: #left; rDU: 414 r: #left; tDU: 148 r: #top; bDU: 190 r: #top);
                    defaultPushButton;
                    startGroup; tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 42; lDU: 281 r: #left; rDU: 414 r: #left; tDU: 194 r: #top; bDU: 236 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 44; lDU: 281 r: #left; tDU: 90 r: #top);
                    min: 0;
                    max: 360;
                    startGroup; tabStop;
                    when: #getContents perform: #angleDisplay:;
                    when: #valueChanged perform: #angleChanged:; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
        yourself
    ).

    self openWindow! !

! HaloScaleAbsoluteDialog class methods !
wbCreated

    ^true! !

! HaloScaleAbsoluteDialog methods !  
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    newExtent := nil.
    super cancel: aPane!   
heightChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    newExtent y: aPane contents.
    lastChanged := #height.

    retainAspect
    ifTrue: [
        newExtent x: (newExtent y * aspect) truncated.
        self changed: #setWidth:.
    ].!  
initialize
    "Private - Initialize the receiver"

    super initialize.
    smooth := true.
    self newExtent: 100@100.
    retainAspect := true.
    lastChanged := #width.!   
newExtent
    "Returns the instance var of the receiver
     for external manipulation"
    ^newExtent!
newExtent: aPoint
    "Sets the instance var of the receiver
     with aPoint and the aspect"
    newExtent := aPoint.
    aspect := aPoint x / aPoint y.!
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Efecto...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 327 @ 364; xC; yC; cRDU: (11 @ 354 rightBottom: 315 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 236; lDU: 7 r: #left; tDU: 12 r: #top);
                    startGroup;
                    contents: 'Nuevo Tamao'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 85 @ 28; lDU: 23 r: #left; rDU: 107 r: #left; tDU: 110 r: #top; bDU: 138 r: #top);
                    startGroup;
                    contents: 'Alto'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 85 @ 28; lDU: 23 r: #left; rDU: 107 r: #left; tDU: 62 r: #top; bDU: 90 r: #top);
                    startGroup;
                    contents: 'Ancho'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 42; lDU: 9 r: #left; rDU: 146 r: #left; tDU: 252 r: #top; bDU: 294 r: #top);
                    defaultPushButton;
                    startGroup; tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 42; lDU: 151 r: #left; rDU: 290 r: #left; tDU: 252 r: #top; bDU: 294 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 158 @ 44; lDU: 119 r: #left; tDU: 46 r: #top);
                    min: 0;
                    startGroup; tabStop;
                    when: #getContents perform: #setWidth:;
                    when: #valueChanged perform: #widthChanged:; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 158 @ 44; lDU: 119 r: #left; tDU: 94 r: #top);
                    min: 0;
                    startGroup; tabStop;
                    when: #getContents perform: #setHeight:;
                    when: #valueChanged perform: #heightChanged:; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 249 @ 32; lDU: 25 r: #left; tDU: 144 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #retainChanged:;
                    when: #getContents perform: #retainAspect:;
                    contents: 'Mantener Aspecto'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 224 @ 32; lDU: 25 r: #left; tDU: 202 r: #top);
                    startGroup; tabStop;
                    when: #getContents perform: #setSmooth:;
                    when: #clicked perform: #smoothChanged:;
                    contents: 'Escalado Suave'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
        yourself
    ).

    self openWindow!  
retainAspect: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Mantener Aspecto').
     (Generated by WindowBuilder)"

    aPane selection: retainAspect!
retainChanged: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Mantener Aspecto').
     (Generated by WindowBuilder)"

    retainAspect := aPane selection.
    retainAspect ifFalse: [^self].

    lastChanged = #width
    ifTrue: [ self widthChanged: (self paneAt: #setWidth:) ]
    ifFalse: [ self heightChanged: (self paneAt: #setHeight:) ]! 
setHeight: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: newExtent y!   
setSmooth: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Suave').
     (Generated by WindowBuilder)"

    aPane selection: smooth!
setWidth: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: newExtent x!
smooth
    "Returns the instance var of the receiver
     for external manipulation"
    ^smooth!  
smooth: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    smooth := anObject! 
smoothChanged: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Suave').
     (Generated by WindowBuilder)"

    smooth := aPane selection.! 
widthChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    newExtent x: aPane contents.
    lastChanged := #width.

    retainAspect
    ifTrue: [
        newExtent y: (newExtent x * aspect reciprocal) truncated.
        self changed: #setHeight:.
    ].! !

! HaloScaleFreeDialog class methods ! 
wbCreated

    ^true! !

! HaloScaleFreeDialog methods !  
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    scale := nil.
    super cancel: aPane!   
computeScaleFor: aPoint
    "Private - Compute the scale factor for aPoint"

    scale := ((aPoint - 50) abs * 2 / stamp extent * 100) truncated!  
display: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen lineTo |
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    pen erase;place: 50@50.
    self drawBoxWith: pen.!
dotMoved: aPane

    "Callback for the #button1Move event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen point mark |
    pen := aPane pen.
    pen isNil ifTrue: [^self].
    mark := [
        pen place: 50@50.
        pen setRop2: R2Notxorpen.
        self drawBoxWith: pen.
        pen setRop2: R2Copypen.
    ].
    point := aPane mouseLocation.
    mark value.
    self computeScaleFor: point.
    mark value.
    self
        changed: #scaleX:;
        changed: #scaleY:.! 
drawBoxWith: aPen
    "Private - Draw the box with aPen"

    | extent box |

    extent := stamp extent * scale // 100.
    box := aPen location - (extent // 2) extent: extent.
    aPen
        copyBitmap: stamp from: stamp boundingBox to: box;
        "place: box origin; box: box corner; "
        yourself.

    (aPen boundingBox nonIntersections: box)
    do: [:each| aPen fill: each color: aPen backColor ].

    aPen foreColor: ClrDarkgray.
    #(0 90 180 270) do: [:each|
        aPen place: 50@50;direction: each;go: 50
    ].!
initialize
    "Private - Initialize the receiver"

    super initialize.
    stamp := CPBitmapDict at: 'ScaleStamp'.
    smooth := true.
    scale := 100@100.!
mouseDown: aPane

    "Callback for the #button1Down event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    "do nothing now..."! 
mouseMoved: aPane

    "Callback for the #mouseMove event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    "do nothing here"!
mouseUp: aPane

    "Callback for the #button1Up event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self
        dotMoved: aPane;
        changed: #display:!  
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Efecto...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 450 @ 354; xC; yC; cRDU: (11 @ 344 rightBottom: 439 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 258 @ 226; lDU: 14 r: #left; tDU: 14 r: #top);
                    startGroup;
                    contents: ''; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 144 @ 190; lDU: 277 r: #left; tDU: 50 r: #top);
                    startGroup;
                    contents: 'Escala %'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 121 @ 28; lDU: 290 r: #left; rDU: 411 r: #left; tDU: 156 r: #top; bDU: 184 r: #top);
                    startGroup;
                    contents: 'Vertical'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 121 @ 28; lDU: 290 r: #left; rDU: 411 r: #left; tDU: 76 r: #top; bDU: 104 r: #top);
                    startGroup;
                    contents: 'Horizontal'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 231 @ 202; lDU: 27 r: #left; rDU: 258 r: #left; tDU: 26 r: #top; bDU: 228 r: #top);
                    noBorders;
                    startGroup;
                    when: #getContents perform: #display:;
                    when: #button1Up perform: #mouseUp:;
                    when: #button1Down perform: #mouseDown:;
                    when: #button1Move perform: #dotMoved:;
                    when: #mouseMove perform: #mouseMoved:; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DCheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 117 @ 32; lDU: 290 r: #left; tDU: 16 r: #top);
                    startGroup;
                    when: #clicked perform: #smoothChanged:;
                    when: #getContents perform: #setSmooth:;
                    contents: 'Suave'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 42; lDU: 135 r: #left; rDU: 272 r: #left; tDU: 244 r: #top; bDU: 286 r: #top);
                    defaultPushButton;
                    startGroup; tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 42; lDU: 279 r: #left; rDU: 418 r: #left; tDU: 244 r: #top; bDU: 286 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 121 @ 44; lDU: 290 r: #left; tDU: 106 r: #top);
                    min: 0;
                    startGroup; tabStop;
                    when: #getContents perform: #scaleX:;
                    when: #valueChanged perform: #scaleXChanged:; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 121 @ 44; lDU: 290 r: #left; tDU: 184 r: #top);
                    min: 0;
                    startGroup; tabStop;
                    when: #getContents perform: #scaleY:;
                    when: #valueChanged perform: #scaleYChanged:; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
        yourself
    ).

    self openWindow! 
scale
    "Returns the instance var of the receiver
     for external manipulation"
    ^scale!
scale: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    scale := anObject!   
scaleX: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: scale x!  
scaleXChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    scale x: aPane contents.
    self changed: #display:.!   
scaleY: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    aPane contents: scale y!  
scaleYChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    scale y: aPane contents.
    self changed: #display:.!   
setSmooth: aPane

    "Callback for the #getContents event in an unnamed CP3DCheckBox (contents is 'Suave').
     (Generated by WindowBuilder)"

    aPane selection: smooth!
smooth
    "Returns the instance var of the receiver
     for external manipulation"
    ^smooth!  
smooth: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    smooth := anObject! 
smoothChanged: aPane

    "Callback for the #clicked event in an unnamed CP3DCheckBox (contents is 'Suave').
     (Generated by WindowBuilder)"

    smooth := aPane selection.! !

! HaloValueDialog class methods !  
wbCreated

    ^true! !

! HaloValueDialog methods !  
between: start and: end say: annotation
    "Register an annotation string for values between start and end"

    ^notes add: (Array with: (start to: end) with: annotation)!  
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    value := nil.
    super cancel: aPane!   
changeBlock: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    changeBlock := anObject!   
changingBlock: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    changingBlock := anObject!   
for: aValue say: annotation
    "Register an annotation string for value aValue"

    ^self between: aValue and: aValue say: annotation!   
initialize
    "Private - Initialize the receiver"

    super initialize.

    changeBlock := changingBlock := nil.
    notes := OrderedCollection new.
    question := String new.
    scale := 0 to: 100.
    value := 50.!
notification: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '').
     (Generated by WindowBuilder)"

    notes do: [:each|
        (each first includes: value)
        ifTrue: [^aPane contents: value asString,'.- ',each last]
    ].
    aPane contents: value asString! 
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Efecto...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 571 @ 196; xC; yC; cRDU: (11 @ 186 rightBottom: 560 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 254 @ 38; lDU: 11 r: #left; rDU: 265 r: #left; tDU: 92 r: #top; bDU: 130 r: #top);
                    startGroup;
                    when: #getContents perform: #notification:;
                    contents: ''; font: self defaultFont;
                    foreColor: ClrDarkblue;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 526 @ 38; lDU: 11 r: #left; rDU: 537 r: #left; tDU: 10 r: #top; bDU: 48 r: #top);
                    startGroup;
                    when: #getContents perform: #setQuestion:;
                    contents: ''; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPHorizontalSlider new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 526 @ 38; lDU: 11 r: #left; tDU: 52 r: #top);
                    contents: 5;
                    startGroup; tabStop;
                    when: #getContents perform: #setScale:;
                    when: #valueChanging perform: #valueChanging:;
                    when: #valueChanged perform: #valueChanged:;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 42; lDU: 270 r: #left; rDU: 402 r: #left; tDU: 92 r: #top; bDU: 134 r: #top);
                    defaultPushButton;
                    startGroup; tabStop; font: self defaultFont;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 42; lDU: 405 r: #left; rDU: 537 r: #left; tDU: 92 r: #top; bDU: 134 r: #top);
                    startGroup; tabStop; font: self defaultFont;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; yourself
            );
        yourself
    ).

    self openWindow! 
question: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    question := anObject! 
scale: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    scale := anObject!   
setQuestion: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '').
     (Generated by WindowBuilder)"

    aPane contents: question!
setScale: aPane

    "Callback for the #getContents event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    (scale includes: value)
    ifFalse: [
        value := scale last + scale first // 2
    ].
    aPane
        min: scale first;
        max: scale last;
        value: value!   
value
    "Returns the instance var of the receiver
     for external manipulation"
    ^value!
value: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    value := anObject!   
valueChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    value := aPane value.
    changeBlock notNil
    ifTrue: [
        changeBlock value: value
    ].
    self changed: #notification:!   
valueChanging: aPane

    "Callback for the #valueChanging event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    value := aPane value.
    changingBlock notNil
    ifTrue: [
        changingBlock value: value
    ].
    self changed: #notification:! !

! HaloDespeckleDialog class methods !  
wbCreated

    ^true! !

! HaloDespeckleDialog methods !  
area
    "Returns the instance var of the receiver
     for external manipulation"
    ^area!  
area: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    area := anObject! 
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    area := nil.
    super cancel: aPane!
initialize
    "Private - Initialize the receiver"

    super initialize.

    area := #medium.! 
large: aPane

    "Callback for the #clicked event in an unnamed CP3DRadioButton (contents is 'Grande').
     (Generated by WindowBuilder)"

    area := #large.
    self
        changed: #small:;
        changed: #medium:;
        changed: #large:;
        yourself!  
medium: aPane

    "Callback for the #clicked event in an unnamed CP3DRadioButton (contents is 'Media').
     (Generated by WindowBuilder)"

    area := #medium.
    self
        changed: #small:;
        changed: #medium:;
        changed: #large:;
        yourself! 
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Efecto...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 576 @ 248; xC; yC; cRDU: (11 @ 238 rightBottom: 565 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 368 @ 126; lDU: 174 r: #left; tDU: 4 r: #top);
                    startGroup;
                    contents: 'Sencibilidad'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 158 @ 166; lDU: 9 r: #left; tDU: 4 r: #top);
                    startGroup;
                    contents: 'rea'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 343 @ 38; lDU: 183 r: #left; rDU: 526 r: #left; tDU: 78 r: #top; bDU: 116 r: #top);
                    startGroup;
                    when: #getContents perform: #notification:;
                    contents: ''; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 38; lDU: 174 r: #left; rDU: 265 r: #left; tDU: 142 r: #top; bDU: 180 r: #top);
                    startGroup;
                    when: #getContents perform: #setQuestion:;
                    contents: ''; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 34; lDU: 23 r: #left; tDU: 40 r: #top);
                    startGroup; tabStop;
                    when: #getContents perform: #setSmall:;
                    when: #clicked perform: #small:;
                    contents: 'Chica'; font: self defaultFont;
                    foreColor: ClrBlack; yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 34; lDU: 23 r: #left; tDU: 82 r: #top);
                    when: #getContents perform: #setMedium:;
                    when: #clicked perform: #medium:;
                    contents: 'Media'; font: self defaultFont;
                    foreColor: ClrBlack; yourself
            );
            addSubpane: (
                CP3DRadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 23 r: #left; tDU: 124 r: #top);
                    when: #getContents perform: #setLarge:;
                    when: #clicked perform: #large:;
                    contents: 'Grande'; font: self defaultFont;
                    foreColor: ClrBlack; yourself
            );
            addSubpane: (
                CPHorizontalSlider new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 343 @ 40; lDU: 183 r: #left; tDU: 34 r: #top);
                    contents: 5;
                    startGroup; tabStop;
                    when: #getContents perform: #setScale:;
                    when: #valueChanging perform: #valueChanging:;
                    when: #valueChanged perform: #valueChanged:;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 48; lDU: 270 r: #left; rDU: 402 r: #left; tDU: 138 r: #top; bDU: 186 r: #top);
                    defaultPushButton;
                    startGroup; tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 133 @ 48; lDU: 409 r: #left; rDU: 542 r: #left; tDU: 138 r: #top; bDU: 186 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
        yourself
    ).

    self openWindow!   
setLarge: aPane

    "Callback for the #getContents event in an unnamed CP3DRadioButton (contents is 'Grande').
     (Generated by WindowBuilder)"

    aPane selection: area = #large!  
setMedium: aPane

    "Callback for the #getContents event in an unnamed CP3DRadioButton (contents is 'Media').
     (Generated by WindowBuilder)"

    aPane selection: area = #medium! 
setSmall: aPane

    "Callback for the #getContents event in an unnamed CP3DRadioButton (contents is 'Chica').
     (Generated by WindowBuilder)"

    aPane selection: area = #small!   
small: aPane

    "Callback for the #clicked event in an unnamed CP3DRadioButton (contents is 'Chica').
     (Generated by WindowBuilder)"

    area := #small.
    self
        changed: #small:;
        changed: #medium:;
        changed: #large:;
        yourself! !

! HistogramDialog class methods !
wbCreated

    ^true! !

! HistogramDialog methods !  
currentValue: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Valor').
     (Generated by WindowBuilder)"

    | point |
    (graph pen isNil
    or: [ (point := graph mouseLocation) isNil
    or: [ (point := self valueFor: point) isNil ]])
    ifTrue: [ ^aPane contents: String new ].

    aPane contents: (self drawBox height - self gap y - point y) asString!   
displayData: aPane

    "Callback for the #display event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen |

    pen := aPane pen.
    pen isNil ifTrue: [^self].
    pen segments isEmpty
    ifTrue: [
        pen drawRetainPicture: [
            self drawData: aPane
        ]
    ]
    ifFalse: [ pen drawChain ].

    lastPoint := nil.
    selection first < selection last
    ifFalse: [^self].

    self drawSelectionWith: pen.!
drawBox
    "Private - Returns the box used for drawing..."
    ^0@0 extent: 260@150!   
drawData: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pen |
    pen := aPane pen.
    pen notNil
    ifTrue: [
        CursorManager execute changeFor: [
            pen erase.
            self
                drawHistogramWith: pen
                in: self drawBox
        ]
    ]!  
drawHistogramWith: aPen in: aRectangle
    "Private - Draw the histogram data"

    | scaleX scaleY height width frame point |
    frame := aRectangle insetBy: self gap.
    height := frame height.
    width   := frame width.
    lo := hi := 0.
    data do: [:each|
        lo := lo min: each.
        hi := hi max: each.
    ].
    scaleY := [:aValue| frame bottom  - (aValue - lo * height // (hi - lo)) ].
    scaleX := [:aValue| (aValue * width / data size) truncated + frame left].
    plots    := Array new: data size.
    total     := 0.
    aPen
        black;
        place: frame rightBottom;
        goto: frame leftBottom;
        yourself.

    lo = hi ifTrue: [^self].

    aPen foreColor: ClrDarkblue.
    1 to: data size do: [:i|
        point := (scaleX value: i) @ (scaleY value: (data at: i)).
        aPen goto: point.
        plots at: i put: point.
        total := total + point y.
        "Transcript cr;nextPutAll: point asString."
    ].
    aPen goto: frame rightBottom.! 
drawSelectionWith: aPen
    "Private - Draw the current selection"

    | box |
    box := self drawBox.
    aPen reverse:
        (selection first @ box top
         corner: selection last @ box bottom)!   
gap
    "Private - Returnst the gap size"
   ^5@5!  
initialize
    "Private - Initialize the receiver"

    super initialize.
    selection := 0 to: 0.!  
mark: aPane

    "Callback for the #button1Move event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | x |
    self drawSelectionWith: aPane pen.
    x := aPane mouseLocation x.
    x < selection first
    ifTrue: [ selection := x to: selection last ]
    ifFalse: [
        x > selection last
        ifTrue: [ selection := selection first to: x ]
        ifFalse: [
            (selection first - x) abs < (selection last - x) abs
            ifTrue: [ selection := x to: selection last ]
            ifFalse: [ selection := selection first to: x ]
        ]
    ].
    self drawSelectionWith: aPane pen.!  
markBegin: aPane

    "Callback for the #button1Down event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | x |
    self drawSelectionWith: aPane pen.
    x := aPane mouseLocation x.
    selection := x to: x.
    self drawSelectionWith: aPane pen.!   
markEnd: aPane

    "Callback for the #button1Up event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    self mark: aPane.
    self changed: #selectedAmount:.!  
ok: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Continuar').
     (Generated by WindowBuilder)"

    self close!  
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Histograma';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 800 @ 380; xC; yC; cRDU: (11 @ 370 rightBottom: 789 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 608 @ 312; lDU: 5 r: #left; tDU: 4 r: #top);
                    startGroup;
                    contents: ''; font: self defaultFont;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 30; lDU: 619 r: #left; rDU: 766 r: #left; tDU: 54 r: #top; bDU: 84 r: #top);
                    startGroup;
                    when: #getContents perform: #currentValue:;
                    contents: 'Valor'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 30; lDU: 619 r: #left; rDU: 766 r: #left; tDU: 18 r: #top; bDU: 48 r: #top);
                    startGroup;
                    when: #getContents perform: #selectedAmount:;
                    contents: 'Porcentaje'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 594 @ 300; lDU: 11 r: #left; rDU: 606 r: #left; tDU: 10 r: #top; bDU: 310 r: #top);
                    noBorders;
                    startGroup;
                    when: #getContents perform: #drawData:;
                    when: #button1Up perform: #markEnd:;
                    when: #button1Move perform: #mark:;
                    when: #button1Down perform: #markBegin:;
                    when: #display perform: #displayData:;
                    when: #mouseMove perform: #showCurrentValue:; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 151 @ 56; lDU: 617 r: #left; rDU: 768 r: #left; tDU: 264 r: #top; bDU: 320 r: #top);
                    defaultPushButton;
                    startGroup; tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'Continuar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
        yourself
    ).

    self openWindow!   
openOn: aCollection
    "Open the receiver for working on aCollection of values"

    data := aCollection.
    ^self open!
openWindow
    "Private - Open the receiver's window"

    graph := self paneAt: #drawData:.
    super openWindow!
selectedAmount: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Porcentaje').
     (Generated by WindowBuilder)"

    | count |
    total isNil ifTrue: [ ^aPane contents: String new].
    count := 0.
    plots do: [:point|
        (point x between: selection first and: selection last)
        ifTrue: [ count := count + point y ].
    ].

    aPane contents: (count * 100 / total printRounded: 2),' %'!   
showCurrentValue: aPane

    "Callback for the #mouseMove event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | mark |
    mark := [
        aPane pen
            setRop2: R2Notxorpen;
            place: lastPoint;
            circle: 3;
            goto: lastPoint x @ self drawBox bottom;
            setRop2: R2Copypen
    ].
    lastPoint notNil
    ifTrue: [ mark value ].
    self changed: #currentValue:.
    lastPoint notNil
    ifTrue: [ mark value ].!
valueFor: aPoint
    "Private - Returns the value for aPoint"

    | x  box |
    box :=self drawBox.
    x := aPoint x - box left.

    (x between: plots first x and: plots last x)
    ifFalse: [^nil].

    plots do: [:point|
        point x >= aPoint x
        ifTrue: [^lastPoint := point ].
    ].

    ^lastPoint := plots last! !

! OSAttributeEditor class methods !  
wbCreated

    ^true! !

! OSAttributeEditor methods !
cancel: aPane

    thePane := nil.
    super close!
openOn: aWin

    thePane := aWin.
    ^self open! 
result

    ^thePane! !

! OSHierarchicalListBoxEditor class methods !
wbCreated

    ^true! !

! OSHierarchicalListBoxEditor methods !  
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'OS Hierarchical ListBox Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 978 @ 272; xC; yC; cRDU: (11 @ 262 rightBottom: 967 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 229 @ 32; lDU: 9 r: #left; rDU: 238 r: #left; tDU: 64 r: #top; bDU: 96 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Children Accessor:';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 32; lDU: 37 r: #left; rDU: 238 r: #left; tDU: 16 r: #top; bDU: 48 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Name Accessor:';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 32; lDU: 55 r: #left; rDU: 238 r: #left; tDU: 112 r: #top; bDU: 144 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Icon Accessor:';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 82 r: #left; rDU: 238 r: #left; tDU: 160 r: #top; bDU: 192 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Indent Width:';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 229 @ 44; lDU: 247 r: #left; tDU: 152 r: #top);
                    paneName: 'indentWidth';
                    min: 0;
                    max: 100;
                    contents: 3;
                    startGroup;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 56; lDU: 823 r: #left; rDU: 942 r: #left; tDU: 152 r: #top; bDU: 208 r: #top);
                    startGroup;
                    when: #clicked perform: #displayHelp:;
                    contents: '&Help';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 695 @ 44; lDU: 247 r: #left; rDU: 942 r: #left; tDU: 8 r: #top; bDU: 52 r: #top; indent: 3 @ 4);
                    paneName: 'nameAccessor';
                    startGroup;
                    tabStop;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 695 @ 44; lDU: 247 r: #left; rDU: 942 r: #left; tDU: 56 r: #top; bDU: 100 r: #top; indent: 3 @ 4);
                    paneName: 'childAccessor';
                    startGroup;
                    tabStop;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 695 @ 44; lDU: 247 r: #left; rDU: 942 r: #left; tDU: 104 r: #top; bDU: 148 r: #top; indent: 3 @ 4);
                    paneName: 'iconAccessor';
                    startGroup;
                    tabStop;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 56; lDU: 485 r: #left; rDU: 640 r: #left; tDU: 152 r: #top; bDU: 208 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 56; lDU: 649 r: #left; rDU: 805 r: #left; tDU: 152 r: #top; bDU: 208 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!   
displayHelp: aPane

    "Callback for the #clicked event in an unnamed Button (contents is '&Help').
     (Generated by WindowBuilder)"

    MessageBox message: '
    Name, icon & child Accesors can be
    the selectors of the messages to be
    send to tree nodes for getting the information
    or can be a oneArgument-Block to ve valued
    with the current node...
'!
getMethodName: rawName

    | name |

    name := rawName trimBlanks.
    (name size > 0 and: [ name first = $# ]) ifTrue: [
        name := name copyFrom: 2 to: name size.
    ].

    name first = $[ "Blocks supported"
    ifTrue: [ ^name ].

    name do: [ :c |
        c isAlphaNumeric not ifTrue: [
            MessageBox message: name, ' is an invalid selector'.
            ^true
        ].
    ].

    name size = 0 ifTrue: [ ^nil ].

    ^'#',name! 
initWindow

    self set: 'nameAccessor' with: thePane nameMethod.
    self set: 'childAccessor' with: thePane childrenMethod.
    self set: 'iconAccessor' with: thePane iconMethod.

    (self paneNamed: 'indentWidth') contents: thePane indentWidth.!  
ok: ignore

    | nameMethod childrenMethod iconMethod |

    ((nameMethod := self getMethodName: (self paneNamed: 'nameAccessor') contents) = false) ifTrue: [
        ^self
    ].
    ((childrenMethod := self getMethodName: (self paneNamed: 'childAccessor') contents) = false) ifTrue: [
        ^self
    ].
    ((iconMethod := self getMethodName: (self paneNamed: 'iconAccessor') contents) = false) ifTrue: [
        ^self
    ].

    thePane := thePane fullCopy.

    thePane
        nameMethod: nameMethod;
        childrenMethod: childrenMethod;
        iconMethod: iconMethod;
        indentWidth: (self paneNamed: 'indentWidth') contents.

    self close!  
set: paneName with: anObject
    "Private - Sets the contents of pane named paneName with anObject"
    | pane |
    pane := self paneNamed: paneName.
    pane contents: anObject asString.! !

! WBToolBarEditorCopy methods !
activated: aPane

    | element selection |
    self changed: #getBitmaps:.
    (selection := (self paneNamed: 'buttons') selection) isNil ifTrue: [ ^nil ].
    (element := elements at: selection) isNil ifTrue: [ ^nil ].
    (self paneNamed: 'bitmaps') selectItem: element bitmapSelector asString.!  
cellSize

    | cellSize |
    cellSize := (self paneNamed: 'cellSize') contents.
    ^((cellSize upTo: $@) trimBlanks asInteger) @
        ((cellSize reversed upTo: $@) reversed trimBlanks asInteger).!   
copy: aPane

    | index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    clipboard := elements at: index .
    (self paneNamed: 'paste') enable.!  
createViews

     "WARNING!!!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'WBToolBar Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1298 @ 552; xC; yC; cRDU: (11 @ 542 rightBottom: 1287 @ 48));
            pStyle: #(sysmenu modal titlebar);
            when: #activate perform: #activated:;
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 695 @ 480; lDU: 9 r: #left; rDU: 704 r: #left; tDU: 8 r: #top; bDU: 488 r: #top);
                    startGroup;
                    contents: 'Buttons';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 539 @ 408; lDU: 722 r: #left; rDU: 1262 r: #left; tDU: 8 r: #top; bDU: 416 r: #top);
                    startGroup;
                    contents: 'Button';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 503 @ 224; lDU: 741 r: #left; rDU: 1243 r: #left; tDU: 112 r: #top; bDU: 336 r: #top);
                    startGroup;
                    contents: 'Selectors';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 18 r: #left; rDU: 174 r: #left; tDU: 424 r: #top; bDU: 456 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Cell Size:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 731 r: #left; rDU: 859 r: #left; tDU: 64 r: #top; bDU: 96 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Bitmap:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 32; lDU: 759 r: #left; rDU: 942 r: #left; tDU: 152 r: #top; bDU: 184 r: #top);
                    startGroup;
                    contents: 'Left Button:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 32; lDU: 759 r: #left; rDU: 960 r: #left; tDU: 240 r: #top; bDU: 272 r: #top);
                    startGroup;
                    contents: 'Right Button:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 210 @ 32; lDU: 731 r: #left; rDU: 942 r: #left; tDU: 360 r: #top; bDU: 392 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Num Spaces:';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 40; lDU: 1088 r: #left; rDU: 1243 r: #left; tDU: 360 r: #top; bDU: 400 r: #top);
                    paneName: 'system';
                    startGroup;
                    when: #clicked perform: #toggleSystem:;
                    contents: 'System';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 238 @ 64; lDU: 722 r: #left; rDU: 960 r: #left; tDU: 424 r: #top; bDU: 488 r: #top);
                    paneName: 'editBitmaps';
                    startGroup;
                    when: #clicked perform: #editBitmaps:;
                    contents: 'Edit Bitmaps';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 48; lDU: 1198 r: #left; rDU: 1243 r: #left; tDU: 56 r: #top; bDU: 104 r: #top);
                    paneName: 'help';
                    startGroup;
                    when: #clicked perform: #help:;
                    contents: '?';
                    yourself
            );
            addSubpane: (
                WBListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 352; lDU: 27 r: #left; rDU: 494 r: #left; tDU: 48 r: #top; bDU: 400 r: #top);
                    paneName: 'buttons';
                    ownerDrawFixed;
                    startGroup;
                    tabStop;
                    when: #highlightItem perform: #highlightItem:;
                    when: #select perform: #selectButton:;
                    when: #drawItem perform: #drawItem:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 48; lDU: 183 r: #left; rDU: 338 r: #left; tDU: 416 r: #top; bDU: 464 r: #top; indent: 3 @ 4);
                    paneName: 'cellSize';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setCellSize:;
                    contents: '25 @ 22';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 40; lDU: 352 r: #left; rDU: 507 r: #left; tDU: 420 r: #top; bDU: 460 r: #top);
                    paneName: 'default';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #toggleDefault:;
                    contents: 'Default';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 48 r: #top; bDU: 112 r: #top);
                    paneName: 'insert';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #insert:;
                    contents: '&Insert';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 120 r: #top; bDU: 184 r: #top);
                    paneName: 'copy';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #copy:;
                    contents: '&Copy';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 192 r: #top; bDU: 256 r: #top);
                    paneName: 'paste';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #paste:;
                    contents: '&Paste';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 264 r: #top; bDU: 328 r: #top);
                    paneName: 'up';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #up:;
                    contents: '&Up';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 336 r: #top; bDU: 400 r: #top);
                    paneName: 'down';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #down:;
                    contents: '&Down';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 408 r: #top; bDU: 472 r: #top);
                    paneName: 'remove';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #remove:;
                    contents: '&Remove';
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 320 @ 344; lDU: 869 r: #left; rDU: 1189 r: #left; tDU: 56 r: #top; bDU: 400 r: #top);
                    paneName: 'bitmaps';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #getBitmaps:;
                    when: #select perform: #selectBitmap:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 48; lDU: 759 r: #left; rDU: 1225 r: #left; tDU: 184 r: #top; bDU: 232 r: #top; indent: 3 @ 4);
                    paneName: 'selector';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setSelector:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 48; lDU: 759 r: #left; rDU: 1225 r: #left; tDU: 272 r: #top; bDU: 320 r: #top; indent: 3 @ 4);
                    paneName: 'rbSelector';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setRBSelector:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 48; lDU: 951 r: #left; rDU: 1070 r: #left; tDU: 352 r: #top; bDU: 400 r: #top; indent: 3 @ 4);
                    paneName: 'numSpaces';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setNumSpaces:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 64; lDU: 978 r: #left; rDU: 1106 r: #left; tDU: 424 r: #top; bDU: 488 r: #top);
                    paneName: 'ok';
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 64; lDU: 1115 r: #left; rDU: 1262 r: #left; tDU: 424 r: #top; bDU: 488 r: #top);
                    paneName: 'cancel';
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
        yourself
    ).!
down: aPane

    | element index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    element := elements at: index.
    index == elements size ifTrue: [ ^nil ].
    elements removeIndex: index.
    elements add: element afterIndex: index.
    list invalidateRect: nil.
    list selection: index + 1.

    self updateButtons.!
drawItem: aPane

    | element |

    element := elements at: aPane drawIndex.
    element pen: nil.
    aPane pen
        copy: element pen
        from: element boundingBox
        to: ((aPane drawBox leftTop rightAndDown: 2) extent: element rectangle extent);
        setTextAlign: TaTop;
        font: SysFont;
        displayText: (element selector asString) at: aPane drawBox leftTop + ((element rectangle width + 6) @ 2)!  
editBitmaps: ignore

    (Smalltalk includesKey: #CPBitmapManager) ifTrue: [
        (Smalltalk includesKey: #MDISystem) ifTrue: [
            (Smalltalk at: #MDISystem) isActive ifTrue: [
                ^MessageBox message: 'Due to limitations in the implementation of MDI, the bitmap manager cannot be launched from within MDI.  Either use the toolbar, or switch out of MDI first.'
            ].
        ].
        (Smalltalk at: #CPBitmapManager) new sendInputEvent: #open.
    ] ifFalse: [
        MessageBox message: 'To view/edit bitmaps, you must first file in the CPBitmapManager.'
    ].!
getBitmaps: aPane

    | keys aPoint |

    aPoint := self cellSize.
    aPane
        contents: (keys := useSystem
            ifTrue: [
                self
                    validBitmapsFrom: CPBitmapDict systemBitmapDictionary
                    withSize: aPoint ]
            ifFalse: [
                self
                    validBitmapsFrom: CPBitmapDict defaultBitmapDictionary
                    withSize: aPoint ]).
    keys isEmpty ifFalse: [ aPane selection: keys first ].!
help: aPane

    MessageBox notify: 'Instructions for Creating Toolbars' withText:
'1) Create toolbar buttons using the BitmapManager and ButtonEditor. They must be the same size as the ''Cell Size''.
2) Insert a blank button using the ''Insert'' button.
3) Select a button bitmap from the Bitmap combobox (only bitmaps of the chosen Cell Size will appear). Each button MUST have an associated bitmap.
4) Specify any other desired attributes.'!
highlightItem: aPane

    aPane pen reverse: aPane drawBox! 
initWindow

    Notifier isAltDown ifFalse: [
        (self paneNamed: 'system') hideWindow
    ].

    list contents: (elements collect: [ :element | element selector asString ]).

    (self paneNamed: 'system') selection: thePane useSystem.
    (self paneNamed: 'cellSize') contents: thePane cellSize asString.
    (self paneNamed: 'paste') disable.

    elements isEmpty ifFalse: [
        list selection: 1.
        self selectButton: list
    ] ifTrue: [
        self updateButtons.
    ].!  
insert: aPane

    | index element |
    index := list selection.

    element := WBTool
        bitmap: (CPBitmapDict sysAt: 'toolPaneExample' ifAbsent: [ nil ])
        selector: ''.
    element rectangle: (0@0 extent: thePane cellSize).

    index isNil ifTrue: [
        elements add: element.
        index := elements size.
    ] ifFalse: [
        elements add: element afterIndex: index.
        index := index + 1.
    ].
    list
        contents: (elements collect: [ :element | element selector asString ]);
        selection: index.

    (self paneNamed: 'bitmaps') selectItem: nil.
    (self paneNamed: 'selector') setContents: ''.
    (self paneNamed: 'rbSelector') setContents: ''.
    (self paneNamed: 'numSpaces') setContents: '0'.

    self updateButtons.! 
ok: aPane

    | rect |

    thePane cellSize: self cellSize.

    elements := elements select: [ :element |
        element bitmapSelector notNil and: [ element bitmapSelector notEmpty ]].
    elements isEmpty ifFalse: [
        elements first rectangle: (Rectangle leftTop: (elements first numSpaces - 1 @ 0) extent: thePane cellSize).
        2 to: elements size do: [ :i |
            (elements at: i) rectangle: (Rectangle
                leftTop: (((elements at: i - 1) rectangle) rightTop right: (elements at: i) numSpaces - 1)
                extent: thePane cellSize)
        ].
    ].
    thePane elements: elements.
    thePane useSystem: useSystem.

    self close!  
paste: aPane

    | index |
    index := list selection.
    index isNil ifTrue: [
        elements add: clipboard deepCopy.
        index := elements size.
    ] ifFalse: [
        elements add: clipboard deepCopy beforeIndex: index
    ].
    list
        contents: (elements collect: [ :element | element selector asString ]);
        selection: index.

    self updateButtons.!   
preInitWindow

    elements := thePane elements deepCopy.
    useSystem := thePane useSystem.
    list := self paneNamed: 'buttons'.

    list height: thePane cellSize y + 4.! 
remove: aPane

    | index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    elements removeIndex: index.
    list
        contents: (elements collect: [ :element | element selector asString ]);
        selection: (index min: elements size).

    self updateButtons.!  
selectBitmap: aPane

    | element selector index |

    index := list selection.
    index isNil ifTrue: [ ^nil ].
    element := elements at: index.
    element bitmapSelector: aPane selectedItem.
    element bitmapSelector isNil ifTrue: [ ^nil ].

    useSystem ifTrue: [
        element bitmap: (CPBitmapDict sysAt: element bitmapSelector asString ifAbsent: [ nil ]).
    ] ifFalse: [
        element bitmap: (CPBitmapDict at: element bitmapSelector asString ifAbsent: [ nil ]).
    ].
    element boundingBox: nil.

    selector := self paneNamed: 'selector'.
    selector contents isEmpty ifTrue: [
        selector setContents: element bitmapSelector.
        element selector: element bitmapSelector.
    ].
    list
        invalidateRect: nil;
        setFocus!   
selectButton: aPane

    | element |
    element := elements at: aPane selection.
    (self paneNamed: 'bitmaps') selectItem: element bitmapSelector asString.
    (self paneNamed: 'selector') setContents: element selector.
    (self paneNamed: 'rbSelector') setContents: element rbSelector.
    (self paneNamed: 'numSpaces') contents: element numSpaces asString.

    self updateButtons.! 
setCellSize: aPane

    self changed: #getBitmaps:! 
setNumSpaces: aPane

    | element |
    element := elements at: list selection.
    element numSpaces: aPane contents asInteger.!
setRBSelector: aPane

    | element |
    element := elements at: list selection.
    element rbSelector: aPane contents.!
setSelector: aPane

    | element |
    element := elements at: list selection.
    element selector: aPane contents.

    list invalidateRect: nil!
toggleDefault: aPane

    aPane selection ifTrue: [
        (self paneNamed: 'cellSize')
            contents: '25 @ 22';
            disable
    ] ifFalse: [
        (self paneNamed: 'cellSize') enable
    ].!
toggleSystem: aPane

    useSystem := aPane selection.
    self changed: #getBitmaps:.!
up: aPane

    | element index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    element := elements at: index.
    index == 1 ifTrue: [ ^nil ].
    elements removeIndex: index.
    elements add: element beforeIndex: index - 1.
    list invalidateRect: nil.
    list selection: index - 1.

    self updateButtons.! 
updateButtons

    elements isEmpty ifTrue: [
        (self paneNamed: 'remove') disable.
        (self paneNamed: 'copy') disable.
        (self paneNamed: 'up') disable.
        (self paneNamed: 'down') disable.
        ^nil
    ] ifFalse: [
        (self paneNamed: 'remove') enable.
        (self paneNamed: 'copy') enable.
    ].
    list selection == elements size ifTrue: [
        (self paneNamed: 'down') disable
    ] ifFalse: [
        (self paneNamed: 'down') enable
    ].
    list selection == 1 ifTrue: [
        (self paneNamed: 'up') disable
    ] ifFalse: [
        (self paneNamed: 'up') enable
    ].!
validBitmapsFrom: aBitmapDictionary withSize: aPoint

    | size |
    size := aPoint x * 2 @ aPoint y.
    ^(aBitmapDictionary select: [ :bitmap | bitmap extent = size ])
        keys asSortedCollection! !

! OSToolBarEditor methods !
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'OSToolBar Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1298 @ 552; xC; yC; cRDU: (11 @ 542 rightBottom: 1287 @ 48));
            pStyle: #(sysmenu modal titlebar);
            when: #activate perform: #activated:;
            backColor: ClrPalegray;
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 695 @ 480; lDU: 9 r: #left; rDU: 704 r: #left; tDU: 8 r: #top; bDU: 488 r: #top);
                    startGroup;
                    contents: 'Buttons';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 539 @ 408; lDU: 722 r: #left; rDU: 1262 r: #left; tDU: 8 r: #top; bDU: 416 r: #top);
                    startGroup;
                    contents: 'Button';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 503 @ 224; lDU: 741 r: #left; rDU: 1243 r: #left; tDU: 112 r: #top; bDU: 336 r: #top);
                    startGroup;
                    contents: 'Selectors';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 18 r: #left; rDU: 174 r: #left; tDU: 424 r: #top; bDU: 456 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Cell Size:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 731 r: #left; rDU: 859 r: #left; tDU: 64 r: #top; bDU: 96 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Bitmap:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 32; lDU: 759 r: #left; rDU: 942 r: #left; tDU: 152 r: #top; bDU: 184 r: #top);
                    startGroup;
                    contents: 'Left Button:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 32; lDU: 759 r: #left; rDU: 960 r: #left; tDU: 240 r: #top; bDU: 272 r: #top);
                    startGroup;
                    contents: 'Right Button:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 210 @ 32; lDU: 731 r: #left; rDU: 942 r: #left; tDU: 360 r: #top; bDU: 392 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Num Spaces:';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 40; lDU: 1088 r: #left; rDU: 1243 r: #left; tDU: 360 r: #top; bDU: 400 r: #top);
                    paneName: 'system';
                    startGroup;
                    when: #clicked perform: #toggleSystem:;
                    contents: 'System';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 238 @ 64; lDU: 722 r: #left; rDU: 960 r: #left; tDU: 424 r: #top; bDU: 488 r: #top);
                    paneName: 'editBitmaps';
                    startGroup;
                    when: #clicked perform: #editBitmaps:;
                    contents: 'Edit Bitmaps';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 48; lDU: 1198 r: #left; rDU: 1243 r: #left; tDU: 56 r: #top; bDU: 104 r: #top);
                    paneName: 'help';
                    startGroup;
                    when: #clicked perform: #help:;
                    contents: '?';
                    yourself
            );
            addSubpane: (
                WBListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 352; lDU: 27 r: #left; rDU: 494 r: #left; tDU: 48 r: #top; bDU: 400 r: #top);
                    paneName: 'buttons';
                    ownerDrawFixed;
                    startGroup;
                    tabStop;
                    when: #highlightItem perform: #highlightItem:;
                    when: #select perform: #selectButton:;
                    when: #drawItem perform: #drawItem:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 48; lDU: 183 r: #left; rDU: 338 r: #left; tDU: 416 r: #top; bDU: 464 r: #top; indent: 3 @ 4);
                    paneName: 'cellSize';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setCellSize:;
                    contents: '25 @ 22';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 40; lDU: 352 r: #left; rDU: 507 r: #left; tDU: 420 r: #top; bDU: 460 r: #top);
                    paneName: 'default';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #toggleDefault:;
                    contents: 'Default';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 48 r: #top; bDU: 112 r: #top);
                    paneName: 'insert';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #insert:;
                    contents: '&Insert';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 120 r: #top; bDU: 184 r: #top);
                    paneName: 'copy';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #copy:;
                    contents: '&Copy';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 192 r: #top; bDU: 256 r: #top);
                    paneName: 'paste';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #paste:;
                    contents: '&Paste';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 264 r: #top; bDU: 328 r: #top);
                    paneName: 'up';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #up:;
                    contents: '&Up';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 336 r: #top; bDU: 400 r: #top);
                    paneName: 'down';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #down:;
                    contents: '&Down';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 408 r: #top; bDU: 472 r: #top);
                    paneName: 'remove';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #remove:;
                    contents: '&Remove';
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 320 @ 344; lDU: 869 r: #left; rDU: 1189 r: #left; tDU: 56 r: #top; bDU: 400 r: #top);
                    paneName: 'bitmaps';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #getBitmaps:;
                    when: #select perform: #selectBitmap:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 48; lDU: 759 r: #left; rDU: 1225 r: #left; tDU: 184 r: #top; bDU: 232 r: #top; indent: 3 @ 4);
                    paneName: 'selector';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setSelector:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 48; lDU: 759 r: #left; rDU: 1225 r: #left; tDU: 272 r: #top; bDU: 320 r: #top; indent: 3 @ 4);
                    paneName: 'rbSelector';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setRBSelector:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 48; lDU: 951 r: #left; rDU: 1070 r: #left; tDU: 352 r: #top; bDU: 400 r: #top; indent: 3 @ 4);
                    paneName: 'numSpaces';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setNumSpaces:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 64; lDU: 978 r: #left; rDU: 1106 r: #left; tDU: 424 r: #top; bDU: 488 r: #top);
                    paneName: 'ok';
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 64; lDU: 1115 r: #left; rDU: 1262 r: #left; tDU: 424 r: #top; bDU: 488 r: #top);
                    paneName: 'cancel';
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
        yourself
    ).! 
insert: aPane

    | index element |
    index := list selection.

    element := OSTool
        bitmap: (CPBitmapDict sysAt: 'toolPaneExample' ifAbsent: [ nil ])
        selector: ''.
    element rectangle: (0@0 extent: thePane cellSize).

    index isNil ifTrue: [
        elements add: element.
        index := elements size.
    ] ifFalse: [
        elements add: element afterIndex: index.
        index := index + 1.
    ].
    list
        contents: (elements collect: [ :element | element selector asString ]);
        selection: index.

    (self paneNamed: 'bitmaps') selectItem: nil.
    (self paneNamed: 'selector') setContents: ''.
    (self paneNamed: 'rbSelector') setContents: ''.
    (self paneNamed: 'numSpaces') setContents: '0'.

    self updateButtons.! 
validBitmapsFrom: aBitmapDictionary withSize: aPoint

    | size |
    size := aPoint x * 3 @ aPoint y.
    ^(aBitmapDictionary select: [ :bitmap | bitmap extent = size ])
        keys asSortedCollection! !

! OSToolPaletteEditor methods !
ok: aPane

    | rect point cellSize |

    thePane cellSize: self cellSize.

    elements := elements select: [ :element |
        element bitmapSelector notNil and: [ element bitmapSelector notEmpty ]].

    thePane elements isDictionary
    ifTrue: [
        thePane elements keys do: [:key|
            thePane elements removeKey: key
        ].
        point := 0@0.
        cellSize := self cellSize.
        elements do: [:element|
            thePane elements
                at: point
                put: element.
            element rectangle: (point extent: cellSize).
            point := point + (0@cellSize y).
        ].
    ]
    ifFalse: ["OrderedCollection elements..."
        thePane elements removeAll: thePane elements copy.
        cellSize := self cellSize.
        elements do: [:element|
            thePane elements add: element.
            element rectangle: nil"(thePane elements size - 1 * (0@cellSize y) extent: cellSize)."
        ].
    ].

    thePane useSystem: useSystem.

    self close! 
preInitWindow

    elements := thePane sortedElements asOrderedCollection.
    useSystem := thePane useSystem.
    list := self paneNamed: 'buttons'.

    list height: thePane cellSize y + 4.! !

! OSPrompter class methods !  
prompt: questionString default: answerString
    "Open a Prompter dialog box with questionString as
    its question and answerString as its default answer."
    ^self new prompt: questionString default: answerString! !

! OSPrompter methods !  
addQuestion: anInteger
    "Private - Build the panes for the question number anInteger"

    self mainView
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: (self framingTextBlock: anInteger);
                    propertyAt: #number put: anInteger;
                    startGroup; font: self defaultFont;
                    when: #getContents perform: #fillQuestion:;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: (self framingEditBlock: anInteger);
                    startGroup; tabStop; font: self defaultFont;
                    propertyAt: #number put: anInteger;
                    when: #getContents perform: #fillAnswer:;
                    when: #textChanged perform: #getAnswer:;
                    backColor: ClrPalegray; yourself
            )! 
answerNumber: anInteger
    "Returns the answer number anInteger"

    answers size < anInteger ifTrue: [^nil].
    anInteger > 0 ifFalse: [^nil].
    ^answers at: anInteger!   
answers
    "Returns the instance var of the receiver
     for external manipulation"
    ^answers!
answers: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    answers := anObject!   
cancel: aButton
    "Private - Process the Cancel event"

    answers := nil.
    self close.!
fillAnswer: aPane
    "Private - Fill the pane with the answer"

    | index |
    answers isNil
    ifTrue: [answers := Array new: questions size].
    1 to: answers size do: [:i|
        (answers at: i) isNil
        ifTrue: [ answers at: i put: String new ]
    ].

    index := aPane propertyAt: #number.
    aPane contents: (answers at: index) asString!
fillQuestion: aPane
    "Private - Fill the pane with the question"

    | index |
    index := aPane propertyAt: #number.
    aPane contents: (questions at: index) asString!   
framingEditBlock: anInteger
    "Private - Returns the framing block for the edit question pane"

    | extent |
    extent := self sizeOfAPane.
    ^FrameRectangle new
        leftTop: 2 @ (anInteger - 1 * 2 + 1 * extent y)
        extent: extent!   
framingTextBlock: anInteger
    "Private - Returns the framing block for the text question pane"

    | extent |
    extent := self sizeOfAPane.
    ^FrameRectangle new
        leftTop: 2 @ (anInteger - 1 * 2 * extent y)
        extent: extent!   
getAnswer: aPane
    "Private - Get the answer corresponding to a changed pane"

    | index |
    index := aPane propertyAt: #number.
    self answers isNil ifTrue: [ ^self ].
    self answers at: index put: aPane contents.!   
initWindowSize
    "Private - Answer the window size."
    | extent |
    extent := self sizeOfAPane.
    ^extent x @ (extent y * questions size * 2) + (self scale: 1 @ 6)!  
ok: aButton
    "Private - Process the Ok event"

    self close.! 
open
    "Open the receiver's window"

    questions size = 0
    ifTrue: [ questions := Array with: String new ].

    self addView: (
        self topPaneClass new
            owner: self;
            labelWithoutPrefix:
                (title isNil
                    ifTrue: ['Por favor responda...']
                    ifFalse: [title]);
            noSmalltalkMenuBar;
            viewName: 'mainView';
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray).

    1 to: questions size do: [:i| self addQuestion: i ].

    self mainView
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: [:box| box rightBottom - (self scale: 18@5) extent: (self scale: 8@4)];
                    defaultPushButton;
                    startGroup; tabStop;idOK;
                    font: self defaultFont;
                    when: #clicked perform: #ok:;
                    contents: 'Aceptar'; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: [:box| box rightBottom - (self scale: 9@5) extent: (self scale: 8@4)];
                    startGroup; tabStop;idCancel;
                    font: self defaultFont;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar'; yourself
            ).

    self openWindow.

    ^answers!  
prompt: questionString default: answerString
    "Open a the receiver's dialog box with questionString as
    its question and answerString as its default answer."

    self questions: (Array with: questionString).
    answerString isNil
    ifFalse: [ answers := Array with: answerString ].
    self open.
    ^self answerNumber: 1! 
questions
    "Returns the instance var of the receiver
     for external manipulation"
    ^questions!
questions: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    questions := anObject!   
scale: aPoint
    "Private - Scale aPoint to window dialog units."
    ^(aPoint * 7 / 2 ) truncated " WindowDialog unitMultiplier"! 
sizeOfAPane
    "Private -  Returns the space used by text & edit panes"

    | extent |
    extent := self scale: 45@5.
    extent y: (extent y min: WindowDialog unitMultiplier y + 2).
    ^extent!  
title
    "Returns the instance var of the receiver
     for external manipulation"
    ^title!
title: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    title := anObject! !

! PrintPreviewDialog class methods ! 
cursorNames
    "Private - Returns the cursors handled by receiver's instances"

    ^#(
        hand move select 'unavailable'
    "
        cut erase
        origin corner
        'paint' 'pencil'
        'print'
        'unavailable'
    "
    )! 
unitsTable
    "Private - Returns the tabel of units and conversion factors..."

    ^#(
        "name capMessage scale inch2UnitFactor reducedStr"
        ('centimetros' extentInMillimeters 0.1 2.54 ' cm' )
        ('puntos' extent 1 0 ' pts' )
        ('pulgadas' extentInInches 1 1 ' plg')
        ('milimetros' extentInMillimeters 1 254 ' mm')
        ('metros' extentInMillimeters 0.001 0.00254 ' mts')
    )!  
wbCreated

    ^true! !

! PrintPreviewDialog methods !   
box: box with: aPen width: width
    " Private - Draw abox box using aPen with width width..."

    aPen
        foreColor: ClrBlack;
        setLineWidth: width;
        place: (box origin - 1) truncated;
        box: (box corner + 1) truncated;
        setLineWidth: 1;
        yourself!
button1DoubleClick: aPane

    "Callback for the #button1DoubleClick event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    mode == #poster ifTrue: [^self].

    "yes, we do nothing here..."
    Smalltalk isRunTime ifFalse: [ self inspect ]! 
button1Down: aPane

    "Callback for the #button1Down event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | rect location |
    mode == #poster ifTrue: [^self].
    location := self currentMouseLocationInUnits.
    (self selection containsPoint: location)
    ifFalse: [
        aPane propertyAt: #anchorStart put: location.
        ^self
    ].

    location := aPane mouseLocation.
    rect := self selectionInPixels.
    aPane
        propertyAt: #anchorStart put: location;
        propertyAt: #anchor put: location;
        propertyAt: #rectangle put: rect.

    aPane pen
        foreColor: ClrBlack;
        setRop2: R2Notxorpen;
        place: rect origin;
        box: rect corner!   
button1DownShift: aPane

    "Callback for the #button1DownShift event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    mode == #poster ifTrue: [^self].

    "yes, we do nothing here..."!
button1Move: aPane

    "Callback for the #button1Move event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | rect anchor distance |
    mode == #poster ifTrue: [^self].
    self changed: #currentPosition:.
    rect := aPane propertyAt: #rectangle.
    rect isNil ifTrue: [ "selection is been changed..."
        aPane propertyAt: #anchorStart put: self currentMouseLocationInUnits.
        ^self
    ].
    "selection is been moved..."
    anchor := aPane propertyAt: #anchor.
    distance := aPane mouseLocation - anchor.
    aPane pen place: rect origin; box: rect corner.
    rect := rect translateBy: distance.
    aPane pen place: rect origin; box: rect corner.
    aPane
        propertyAt: #rectangle put: rect;
        propertyAt: #anchor put: anchor + distance.

    (self paneAt: #currentOrigin:)
        contents: (self stringFor: (self graph2Unit: rect origin)),self unitString
.!  
button1Up: aPane

    "Callback for the #button1Up event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | distance anchor start |
    mode == #poster ifTrue: [^self].
    start := aPane propertyAt: #anchorStart.
    anchor := aPane propertyAt: #anchor.
    anchor isNil ifTrue: [ "selection changed..."
      start notNil ifTrue: [ self moveTo: start ]
    ]
    ifFalse: [ "selection moved..."
        self button1Move: aPane.
        aPane pen setRop2: R2Copypen.
        self moveBy: (self graph2Unit: anchor - start)
    ].
    aPane
        propertyAt: #anchorStart put: nil;
        propertyAt: #anchor put: nil;
        propertyAt: #rectangle put: nil.
    self fullUpdate!   
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    self close!   
capability
    "Returns the instance var of the receiver
     for external manipulation"

    capability isNil ifTrue: [
        capability := GraphicCapability for: self printer.
    ].
    ^capability!
capability: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    capability := anObject! 
center: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Centrado').
     (Generated by WindowBuilder)"

    self
        centerSelection;
        fullUpdate.!  
centerSelection
    "Private - Center current selection"

    self selection isRectangle ifFalse: [^self].
    self moveTo: self currentPageSize - self selection extent / 2.!
close
    "Private - Close the receiver & release instances"

    | cursor systemCursors bmps |

    self saveInstances.

    cursors isEmpty ifFalse: [
        systemCursors := #(normal arrow corner crossHair execute text)
            collect: [:sys| CursorManager perform: sys ].
        cursors keys do: [:key|
            cursor := cursors at: key.
            (systemCursors includes: cursor) "not a system cursor"
            ifFalse: [ cursor release ].
            cursors removeKey: key.
        ]
    ].
    bmps := self mainView propertyAt: #frameShapes.
    bmps notNil ifTrue: [
        bmps do: [:each| each release]
    ].
    self printer: nil.
    ^super close!  
correctAspect
    "Correct the aspect of the current selection;
    Returns true if the selection has been changed."

    | aspect extent currentAspect sel factor |
    extent := self printArea extent.
    aspect := extent x / extent y.
    (sel := self selection) isNil ifTrue: [ ^false ].
    currentAspect := sel height = 0
        ifTrue: [ 9999999 ]
        ifFalse: [ sel width / sel height ].
    currentAspect = aspect ifTrue: [^false].
    factor := sel extent / extent.
    factor := factor x + factor y / 2.
    self selection: (sel origin extent: extent * factor).
    ^true!
correctAspect: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"


    self
        correctAspect;
        fullUpdate.!   
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Impresin de Mapa...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1088 @ 568; xC; yC; cRDU: (11 @ 558 rightBottom: 1077 @ 48));
            pStyle: #(sysmenu modal titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 709 @ 88; lDU: 14 r: #left; rDU: 722 r: #left; tDU: 8 r: #top; bDU: 96 r: #top);
                    startGroup;
                    contents: 'Region a Imprimir';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 709 @ 336; lDU: 14 r: #left; rDU: 722 r: #left; tDU: 96 r: #top; bDU: 432 r: #top);
                    startGroup;
                    contents: 'Tamao de la impresion';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 267 @ 32; lDU: 731 r: #left; rDU: 999 r: #left; tDU: 46 r: #top; bDU: 78 r: #top);
                    startGroup;
                    when: #getContents perform: #currentSize:;
                    contents: 'Medidas actuales';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                OSImagePane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 313 @ 314; lDU: 727 r: #left; rDU: 1040 r: #left; tDU: 110 r: #top; bDU: 424 r: #top);
                    noScrollBars;
                    startGroup;
                    when: #button1DoubleClick perform: #button1DoubleClick:;
                    when: #button1Up perform: #button1Up:;
                    when: #button1Down perform: #button1Down:;
                    when: #button1Move perform: #button1Move:;
                    when: #display perform: #imagePreviewDisplay:;
                    when: #button1DownShift perform: #button1DownShift:;
                    when: #mouseMove perform: #mouseMove:;
                    when: #getContents perform: #imagePreviewContents:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 267 @ 32; lDU: 731 r: #left; rDU: 999 r: #left; tDU: 16 r: #top; bDU: 48 r: #top);
                    startGroup;
                    when: #getContents perform: #currentOrigin:;
                    contents: 'Vertice Sup/Izq';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 318 @ 32; lDU: 731 r: #left; rDU: 1049 r: #left; tDU: 76 r: #top; bDU: 108 r: #top);
                    rightJustified;
                    startGroup;
                    when: #getContents perform: #currentPosition:;
                    contents: 'Posicion actual';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 578 r: #left; rDU: 715 r: #left; tDU: 336 r: #top; bDU: 368 r: #top);
                    startGroup;
                    when: #getContents perform: #unitText:;
                    contents: 'unidades....';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 82 @ 32; lDU: 631 r: #left; rDU: 713 r: #left; tDU: 382 r: #top; bDU: 414 r: #top);
                    startGroup;
                    when: #getContents perform: #pagePercentText:;
                    contents: '% Pag';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 229 @ 40; lDU: 41 r: #left; rDU: 270 r: #left; tDU: 40 r: #top; bDU: 80 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #setFullImage:;
                    when: #clicked perform: #fullImage:;
                    contents: 'Imagen Completa';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 210 @ 40; lDU: 459 r: #left; rDU: 670 r: #left; tDU: 40 r: #top; bDU: 80 r: #top);
                    when: #getContents perform: #setSelectedRegion:;
                    when: #clicked perform: #selectedRegion:;
                    contents: 'Region Selecta';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 270 @ 248; lDU: 434 r: #left; tDU: 128 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #units:;
                    when: #select perform: #unitSelected:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 366 @ 40; lDU: 41 r: #left; rDU: 407 r: #left; tDU: 136 r: #top; bDU: 176 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #setDotToDot:;
                    when: #clicked perform: #dotToDot:;
                    contents: '1:1 (Definicion de impresora)';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 229 @ 40; lDU: 41 r: #left; rDU: 270 r: #left; tDU: 182 r: #top; bDU: 222 r: #top);
                    when: #getContents perform: #setFullPage:;
                    when: #clicked perform: #fullPage:;
                    contents: 'Pagina completa';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 40; lDU: 434 r: #left; rDU: 626 r: #left; tDU: 182 r: #top; bDU: 222 r: #top);
                    when: #getContents perform: #setPage2:;
                    when: #clicked perform: #page2:;
                    contents: 'Media Pgina';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 238 @ 40; lDU: 41 r: #left; rDU: 279 r: #left; tDU: 228 r: #top; bDU: 268 r: #top);
                    when: #getContents perform: #setPage4:;
                    when: #clicked perform: #page4:;
                    contents: 'Cuarto de pgina';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 135 @ 44; lDU: 434 r: #left; rDU: 569 r: #left; tDU: 224 r: #top; bDU: 268 r: #top);
                    when: #getContents perform: #setCenter:;
                    when: #clicked perform: #center:;
                    contents: 'Centrado';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 40; lDU: 41 r: #left; rDU: 197 r: #left; tDU: 280 r: #top; bDU: 320 r: #top);
                    when: #getContents perform: #setPoster:;
                    when: #clicked perform: #poster:;
                    contents: 'Poster de';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 40; lDU: 41 r: #left; rDU: 233 r: #left; tDU: 332 r: #top; bDU: 372 r: #top);
                    when: #getContents perform: #setExactly:;
                    when: #clicked perform: #exactly:;
                    contents: 'Exactamente';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 40; lDU: 41 r: #left; rDU: 224 r: #left; tDU: 382 r: #top; bDU: 422 r: #top);
                    when: #getContents perform: #setZoom:;
                    when: #clicked perform: #zoom:;
                    contents: 'Proporcional';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 24; lDU: 624 r: #left; tDU: 220 r: #top);
                    bitmap: (CPBitmapDict at: 'go up');
                    when: #getContents perform: #setGoButton:;
                    when: #clicked perform: #goUp:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 24; lDU: 587 r: #left; tDU: 234 r: #top);
                    bitmap: (CPBitmapDict at: 'go left');
                    when: #getContents perform: #setGoButton:;
                    when: #clicked perform: #goLeft:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 24; lDU: 624 r: #left; tDU: 244 r: #top);
                    bitmap: (CPBitmapDict at: 'go down');
                    when: #getContents perform: #setGoButton:;
                    when: #clicked perform: #goDown:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 24; lDU: 661 r: #left; tDU: 234 r: #top);
                    bitmap: (CPBitmapDict at: 'go right');
                    when: #getContents perform: #setGoButton:;
                    when: #clicked perform: #goRight:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 48; lDU: 233 r: #left; tDU: 276 r: #top);
                    min: 1;
                    max: 10;
                    contents: 1;
                    when: #getContents perform: #setPosterX:;
                    when: #valueChanged perform: #posterXChanged:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 48; lDU: 434 r: #left; tDU: 276 r: #top);
                    min: 1;
                    max: 10;
                    contents: 1;
                    when: #getContents perform: #setPosterY:;
                    when: #valueChanged perform: #posterYChanged:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 44; lDU: 233 r: #left; tDU: 330 r: #top);
                    min: 1;
                    contents: 1;
                    when: #getContents perform: #imageWidth:;
                    when: #valueChanged perform: #selectionWidthChanged:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 44; lDU: 434 r: #left; tDU: 330 r: #top);
                    min: 1;
                    contents: 1;
                    when: #getContents perform: #imageHeight:;
                    when: #valueChanged perform: #selectionHeightChanged:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 44; lDU: 233 r: #left; tDU: 380 r: #top);
                    min: 1;
                    contents: 100;
                    when: #getContents perform: #setImageZoom:;
                    when: #valueChanged perform: #imageZoomChanged:;
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPHorizontalSlider new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 434 r: #left; tDU: 382 r: #top);
                    max: 100;
                    contents: 1;
                    when: #getContents perform: #setPagePercent:;
                    when: #valueChanging perform: #pagePercentChanging:;
                    when: #valueChanged perform: #pagePercentChanged:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 37 @ 32; lDU: 382 r: #left; rDU: 418 r: #left; tDU: 382 r: #top; bDU: 414 r: #top);
                    contents: '%';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 32; lDU: 382 r: #left; rDU: 427 r: #left; tDU: 336 r: #top; bDU: 368 r: #top);
                    contents: 'por';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 64 @ 32; lDU: 587 r: #left; rDU: 651 r: #left; tDU: 284 r: #top; bDU: 316 r: #top);
                    contents: 'Pag.';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 32; lDU: 382 r: #left; rDU: 427 r: #left; tDU: 284 r: #top; bDU: 316 r: #top);
                    contents: 'por';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 238 @ 64; lDU: 18 r: #left; rDU: 256 r: #left; tDU: 440 r: #top; bDU: 504 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #setUpPrinterContents:;
                    when: #clicked perform: #setUpPrinter:;
                    contents: 'Config. Impr.';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 279 @ 64; lDU: 263 r: #left; rDU: 542 r: #left; tDU: 440 r: #top; bDU: 504 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #setPrintNowContents:;
                    when: #clicked perform: #printNow:;
                    contents: 'Imprimir Ahora';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 549 r: #left; rDU: 722 r: #left; tDU: 440 r: #top; bDU: 504 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancelar';
                    font: (
                        Font new
                        fromBytes: #( 245 255 0 0 0 0 0 0 144 1 0 0 0 0 3 2 1 34 65 114 105 97 108 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 )
                    );
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPValueSet new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 318 @ 54; lDU: 731 r: #left; tDU: 448 r: #top);
                    rows: 1 columns: 5;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #setBorderShapes:;
                    when: #select perform: #shapeSelected:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPHorizontalSlider new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 318 @ 20; lDU: 727 r: #left; tDU: 424 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #setHorizontalSlider:;
                    when: #valueChanging perform: #horizontalSliderChanging:;
                    when: #valueChanged perform: #horizontalSliderChanged:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPVerticalSlider new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 23 @ 314; lDU: 1040 r: #left; tDU: 108 r: #top);
                    startGroup;
                    tabStop;
                    when: #getContents perform: #setVerticalSlider:;
                    when: #valueChanging perform: #verticalSliderChanging:;
                    when: #valueChanged perform: #verticalSliderChanged:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPBitmapButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 44; lDU: 1006 r: #left; tDU: 24 r: #top);
                    bitmap: (CPBitmapDict at: 'size');
                    startGroup;
                    tabStop;
                    when: #clicked perform: #correctAspect:;
                    contents: '';
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).!
currentMouseLocationInUnits
    "Private - returns the current mouse location in selected units"

    ^self graph2Unit: graphPane mouseLocation!   
currentOrigin: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Vertice Sup/Izq').
     (Generated by WindowBuilder)"

    aPane contents: (self stringFor: self selection origin),self unitString!
currentPageSize
    "Private - Returns the current page size in current units"

    | tuple default stream |
    default := 1@1.
    tuple := self class unitsTable detect: [:each| each first = self unit ] ifNone: [^default].
    stream := ReadStream on: tuple.
    stream next.
    ^(self capability perform: stream next) "get value"
        * stream next "adjust scale"!  
currentPosition: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Posicion actual').
     (Generated by WindowBuilder)"

    | rect |
    aPane contents:
        (((rect := self graphPaneRectangle) isNil) ifTrue: [String new]
          ifFalse: [(self stringFor: (self graph2Unit: graphPane mouseLocation)),self unitString ])!  
currentPosterExtent
    " Private - Returns the current poster extent in pages as aPoint..."

    | paneX paneY |
    paneX := self paneAt: #setPosterX:.
    paneX isNil ifTrue: [^1@1].
    paneY := self paneAt: #setPosterY:.
    paneY isNil ifTrue: [^1@1].
    ^paneX contents @ paneY contents!   
currentPosterSize
    " Private - Returns the current poster size in units..."

    ^self currentPosterExtent * self currentPageSize!  
currentScale
    "Private - Returns the current scale in use"

    self class unitsTable do: [:tuple|
        tuple first = unit ifTrue: [ ^tuple at: 3 ]
    ].
    ^1!
currentSize: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'Medidas actuales').
     (Generated by WindowBuilder)"

    aPane contents: (self stringFor: self selection extent),self unitString! 
currentZoomFactor
    "Private - Returns the more aproximated zoom factor
     for current selection dimentions"

    | extent width height percent |
    extent := self pixel2Unit: self printArea extent.
    width := self selection width / extent x.
    height := self selection height / extent y.
    percent := width + height / 2 * 100.
    ^percent truncated!   
cursorFor: action
    "Private - Returns the cursor for the action in aString or aSymbol 'action'
     or the normal cursor..."

    ^cursors at: action
        ifAbsent: [ CursorManager normal ]! 
doPrinting
    "Private - Executes output to printer..."

    CursorManager execute changeFor: [
        self printer
            startPrintJob;
            startPrinterPage.
        mode == #poster
        ifTrue: [ self printPoster ]
        ifFalse: [ self printOnePage ].
        self printer
            endPrinterPage;
            endPrintJob.
        printing := false.
        self fullUpdate.
    ].!  
dotToDot: aPane

    "Callback for the #clicked event in an unnamed CheckBox (contents is '1:1 (Definicion de impresora)').
     (Generated by WindowBuilder)"

    self mode: #dotToDot.
    self fullUpdate.! 
emptySelection
    " Private - Sets the selection to Zero"

    ^self selection: (0@0 extent: 0@0)!
exactly: aPane

    "Callback for the #clicked event in an unnamed CheckBox (contents is 'Exactamente').
     (Generated by WindowBuilder)"

    self mode: #exactly.
    self fullUpdate.! 
fullImage: aPane

    "Callback for the #clicked event in an unnamed CheckBox (contents is 'Imagen Completa').
     (Generated by WindowBuilder)"

    useSelection := aPane selection not.
    self fullUpdate.!   
fullPage: aPane

    "Callback for the #clicked event in an unnamed CheckBox (contents is 'Pagina completa').
     (Generated by WindowBuilder)"

    self mode: #fullPage.
    self fullUpdate.!   
goDown: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    self selection notNil
    ifTrue: [
        self moveTo: self selection left @ (self currentPageSize y - self selection height)
    ].
    self fullUpdate.!  
goLeft: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    self selection notNil
    ifTrue: [ self moveTo: 0 @ self selection top ].
    self fullUpdate.!
goRight: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    self selection notNil
    ifTrue: [
        self moveTo: (self currentPageSize x - self selection width) @ self selection top
    ].
    self fullUpdate.!   
goUp: aPane

    "Callback for the #clicked event in an unnamed CPBitmapButton (contents is '').
     (Generated by WindowBuilder)"

    self selection notNil
    ifTrue: [ self moveTo: self selection left @ 0 ].
    self fullUpdate.! 
graph2Unit: aValue
    " Private - Returns aValue (in graph pane coordinates) to current units"

    | factor result |
    factor := self currentPageSize / self graphPaneRectangle extent.
    ^aValue * factor!
graphPaneRectangle
    " Private - Returns the graph pane rectangle in use (in pixels)"

    | rect |
    (graphPane isNil or: [ (rect := graphPane rectangle) isNil])
    ifTrue: [^0@0 extent: 0@0].
    ^rect insetBy: 1!
horizontalSliderChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    self horizontalSliderChanging: aPane.
    self fullUpdate.! 
horizontalSliderChanging: aPane

    "Callback for the #valueChanging event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    | newCenter center |
    newCenter := aPane value.
    newCenter isNil ifTrue: [^self].
    self moveTo: newCenter - (self selection width // 2) @ self selection top.
    graphPane invalidateRect: nil.
    self changed: #currentOrigin:!  
image
    "Returns the instance var of the receiver
     for external manipulation"
    ^image!
image: anImage
    "Sets the instance var of the receiver"

    image := anImage.
    self initializeSelection.!  
imageDisplay: aPen inside: aRectangle
    "Private - Render the current image using aPen inside aRectangle"

    image isBitmap
    ifTrue: [ aPen copyBitmap: image from: self printArea to: aRectangle ]
    ifFalse: [
        (image respondsTo: #display:inside:using:)
        ifTrue: [ "try to use display: sourceRect inside: destRect using: aPen protocoll..."
            image display: self printArea inside: aRectangle using: aPen
        ] ifFalse: [ aPen backColor: ClrDarkblue;place: aRectangle origin;boxFilled: aRectangle corner ]
    ].! 
imageHeight: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    self selection notNil ifTrue: [ aPane value: self selection height truncated ].
    self enable: aPane when: mode == #exactly & printing not.!  
imagePreviewContents: aPane

    "Callback for the #getContents event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    graphPane := aPane.

    aPane invalidateRect: nil.!
imagePreviewDisplay: aPane

    "Callback for the #display event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    | pageBox pageSize pen rect blackBox |
    pen  := aPane pen.
    pen isNil ifTrue: [^self].
    pageBox := aPane rectangle.
    blackBox := [:r| pen fill: r color: ClrDarkgray ].
    self capability isNil ifTrue: [ blackBox value: pageBox.^self].

    mode == #poster ifTrue: [
        blackBox value: pageBox.
        ^self imagePreviewDisplayPoster: aPane
    ].

    pageBox := self graphPaneRectangle.
    pageSize := self currentPageSize.
    self selection isNil ifFalse: [
        rect := self selectionInPixels translateBy: pageBox origin.
        self imageDisplay: pen inside: rect.
    ].

    (aPane rectangle nonIntersections: pageBox)
    do: [:each| blackBox value: each ].

    rect isNil
    ifTrue: [ pen fill: pageBox color: ClrWhite ]
    ifFalse: [
        (pageBox nonIntersections: rect)
        do: [:paper| pen fill: paper color: ClrWhite ].
        mode ~= #poster ifTrue: [
            (shapes at: shape) value: pen value: rect.
        ].
    ].!  
imagePreviewDisplayPoster: aPane
    "Callback for the #display event when mode=#poster"

    | box extent pen factor |
    xy := self currentPosterExtent.
    factor := self graphPaneRectangle extent // xy max: 1@1.
    extent := xy * factor.
    box := self graphPaneRectangle extent - extent // 2 extent: extent.
    pen := aPane pen.

    self imageDisplay: pen inside: box.

    pen
        foreColor: ClrBlack;
        setRop2: R2Notxorpen;
        yourself.
    box left to: box right by: factor x do: [:i|
        pen lineFrom: i @ box top to: i @ box bottom
    ].
    box top to: box bottom by: factor y do: [:j|
        pen lineFrom: box left @ j to: box right @ j
    ].
    pen setRop2: R2Copypen.! 
imageWidth: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    self selection notNil ifTrue: [ aPane value: self selection width truncated ].
    self enable: aPane when: mode == #exactly & printing not.!
imageZoomChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    | newZoom |
    newZoom := aPane value.
    newZoom isNil ifTrue: [^self].
    self selection extent: (self pixel2Unit: self printArea extent * newZoom / 100).
    self changed: #currentSize.
    graphPane invalidateRect: nil.!   
initialize
    " Private - Initialize the receiver..."

    super initialize.

    image := CPBitmapDict at: 'LogoView' ifAbsent: [].
    printing := false.

    self
        initializeCursors;
        initializeShapes;
        initializeInstances;
        initializeSelection.!
initializeCursors
    " Private - Initialize the receiver's cursors..."

    | cursor |
    cursors := Dictionary new.
    self class cursorNames
        do: [:each|
            cursor := CursorManager
                loadCursor: each
                fromDLL: ObjectStyleDLL library.
            cursors at: each
                put: (cursor notNil ifTrue: [ cursor]
                    ifFalse: [CursorManager normal]).
        ]!  
initializeInstances
    " Private - Initialize the receiver's instances from profiler..."

    | profiler sel |
    profiler := self profiler.
    mode := (profiler at: #mode ifAbsent: [ #dotToDot ]) asSymbol.
    xy := (profiler at: #posterX ifAbsent: [1]) asInteger
             @ (profiler at: #posterY ifAbsent: [1]) asInteger.
    useSelection := (profiler at: #useSelection ifAbsent: [ 'true' ]) asLowerCase = 'true'.
    self unit: (profiler at: #unit ifAbsent: [ 'centimetros' ]) asLowerCase.
    shape := (profiler at: #shape ifAbsent: [ '1' ]) asInteger.
    shape = 0 ifTrue: [shape := 1].
    sel := profiler at: #selection ifAbsent: [].
    sel notNil ifTrue: [
        sel := ReadStream on: sel asArrayOfSubstrings.
        self selection: (sel next asFloat @ sel next asFloat extent: sel next asFloat @ sel next asFloat).
    ].!  
initializeSelection
    " Private - Initialize the receiver's selection..."

    | extent mustCenter defaultExtent |
    (image isNil and: [ self selection isNil ]) ifTrue: [ ^self emptySelection ].
    ((image respondsTo: #isValid) and: [image isValid not])
    ifTrue: [ ^self emptySelection ].
    defaultExtent := self pixel2Unit: self printArea extent.
    self selection isNil
    ifTrue: [
        self selection: (0@0 extent:defaultExtent).
        mustCenter := true.
    ]
    ifFalse: [ mustCenter := self isCentered ].

    (#(exactly zoom) includes: mode) "modes that does not modify the selection"
    ifFalse: [
      extent := mode == #dotToDot ifTrue: [ defaultExtent ]
        ifFalse: [
          mode == #fullPage ifTrue: [self currentPageSize]
          ifFalse: [
            mode == #page2 ifTrue: [self currentPageSize / 2]
            ifFalse: [
              mode == #page4 ifTrue: [self currentPageSize / 4]
              ifFalse: [ mustCenter := false. self currentPosterSize ]
            ]
          ]
        ].
        self selection: (
            (self selection isNil ifTrue: [0@0] ifFalse: [self selection origin])
                extent: extent)
    ].

    mustCenter ifTrue: [ self centerSelection ].! 
initializeShapes
    " Private - Initialize the receiver's shapes
    for drawing border image frames..."

    shapes := Dictionary new.
    shapes
        at: 1 put: [:aPen :box| ]; "no Draw"
        at: 2 put: [:aPen :box| self box: box with: aPen width: 1 ];"thin shape"
        at: 3 put: [:aPen :box| self box: box with: aPen width: 3 ];"medium shape"
        at: 4 put: [:aPen :box| self box: box with: aPen width: 1; box: (box expandBy: 2) with: aPen width: 1 ];"double shape"
        at: 5 put: [:aPen :box| self box: box with: aPen width: 3; box: (box expandBy: 4) with: aPen width: 3 ];"double-medium shape"
        yourself!
isCentered
    "Private - True if current selection is centered"

    ^self selection isRectangle and: [
        self selection origin = (self currentPageSize - self selection extent // 2)
    ]!  
mode: aSymbol
    "Sets the instance var of the receiver
    and update selection...
    Suported modes are:
        #exactly for fixed dimensions
        #fullPage for full page printing
        #page2 for 1/2 page size printing
        #page4 for 1/4 page size
        #dotToDot for printer def. use (1:1)
        #zoom for proportional zooming
        #poster for poster printing
    "

    mode := aSymbol.
    self initializeSelection.!   
mouseMove: aPane

    "Callback for the #mouseMove event in an unnamed GraphPane.
     (Generated by WindowBuilder)"

    mode == #poster ifTrue: [
        aPane setCursor: (self cursorFor: 'unavailable').
        ^self
    ].
    aPane setCursor:
        ((self selection containsPoint: (self graph2Unit: aPane mouseLocation))
        ifTrue: [ self cursorFor: #move ]
        ifFalse: [ self cursorFor: #hand ]).
    self changed: #currentPosition:!  
moveBy: aPoint
    " Private - Move current selection by distance aPoint"

    self selection: (self selection copy moveBy: aPoint)!   
moveTo: aPoint
    " Private - Move current selection to aPoint"

    self selection: (self selection copy moveTo: aPoint)!
openOn: anImage
    "Open the receiver for working with anImage"

    image := anImage.
    ^self open!   
page2: aPane

    "Callback for the #clicked event in an unnamed CheckBox (contents is 'Media Pagina').
     (Generated by WindowBuilder)"

    self mode: #page2.
    self fullUpdate.!
page4: aPane

    "Callback for the #clicked event in an unnamed CheckBox (contents is 'Cuarto de pagina').
     (Generated by WindowBuilder)"

    self mode: #page4.
    self fullUpdate.!
pageEnd: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    self enable: aPane when: mode == #poster.!   
pagePercentChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    self pagePercentChanging: aPane.
    self fullUpdate.!   
pagePercentChanging: aPane

    "Callback for the #valueChanging event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    | newValue newExtent pageSize |
    newValue := aPane value.
    newValue isNil ifTrue: [^self].
    (self paneAt: #pagePercentText:) contents: newValue asString,'%'.
    pageSize := self currentPageSize.
    newExtent := pageSize * newValue / 100.
    self selection: (self selection origin extent: newExtent).
    self selection rightBottom > pageSize
    ifTrue: [
        self moveTo: pageSize - self selection extent / 2
    ].
    self changed: #currentSize:.
    graphPane invalidateRect: nil.!   
pagePercentText: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '% Pag').
     (Generated by WindowBuilder)"

    aPane contents: '% Pag'.!   
pageStart: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    self enable: aPane when: mode == #poster.! 
pixel2Unit: aValue
    " Private - returns aValue (in pixels) in current units"

    aValue isRectangle ifTrue: [^ (self pixel2Unit: aValue origin) extent: (self pixel2Unit: aValue extent) ].

    ^aValue / self printer extent * self currentPageSize!   
poster: aPane

    "Callback for the #clicked event in an unnamed CheckBox (contents is 'Poster de').
     (Generated by WindowBuilder)"

    self mode: #poster.
    self fullUpdate.! 
posterXChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    self poster: nil.!   
posterYChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    self poster: nil.!   
print: sourceRect inside: destRect drawingFrame: drawFrame
    "Private - Prints in the current page the rectangle sourceRect
    (in image coordinates) inside destRect (in inches)"

    | source dest |
    sourceRect isNil
    ifTrue: [ source := self printArea ]
    ifFalse: [ source := sourceRect ].
    image isBitmap
    ifTrue: [ "use pixel coord. system"
        dest := (self units2Pixels: destRect) truncated.
        self printer pen
            copyBitmap: image
            from: source truncated
            to: dest
    ]
    ifFalse: [ "use inches..."
        dest := destRect.
        image print: source truncated  inside: dest using: self printer
    ].

    drawFrame ifTrue: [
        dest := (self units2Pixels: destRect) truncated.
        shape notNil ifTrue: [
            (shapes at: shape) value: self printer pen value: dest.
        ]
    ]!  
printArea
    "Returns the instance var of the receiver
     for external manipulation"

    printArea notNil & useSelection
    ifTrue: [ ^printArea ].

    image notNil
    ifTrue: [ ^image boundingBox ].

    ^0@0 extent: 1@1!   
printArea: aRectangle
    "Sets the instance var of the receiver with aRectangle.
    if aRectangle isNil the hole image will be used..."

    printArea := aRectangle!   
printer
    "Returns the instance var of the receiver
     for external manipulation"

    printer isNil ifTrue: [
        printer := OSPrinter new.
        hasCreatedThePrinter := true.
    ].

    ^printer! 
printer: aPrinter
    "Sets the instance var of the receiver with aPrinter & update capability.
    if aPrinter isNil a new printer will be created when needed..."

    hasCreatedThePrinter ifTrue: [ printer release ].
    hasCreatedThePrinter := false.
    printer := aPrinter.
    capability := nil.! 
printNow
    "Private - Executes output to printer..."

    printing := true.
    self fullUpdate.

    Terminal bell.
    (MessageBox confirm: 'Servicios de impresin configurable\no testeada en su totalidad en esta versin.\\Desea hacer la impresin de todos modos ?' withCrs)
    ifTrue: [ self send: #doPrinting to: self. "done deferred for buttons disabling..." ].!
printNow: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Imprimir Ahora').
     (Generated by WindowBuilder)"

    self
        printNow;
        close!   
printOnePage
    " Private - Prints in a single page..."

    self print: nil inside: self selection drawingFrame: true.!  
printPoster
    " Private - Prints in poster mode..."

    | extent fullPage |
    fullPage := 0@0 extent: self currentPageSize.
    xy := self currentPosterExtent.
    extent := image boundingBox extent / xy.
    1 to: xy x do: [:i|
      1 to: xy y do: [:j|
        self
            print: (i@j - 1 * extent extent: extent) truncated
            inside: fullPage
            drawingFrame: false.
        self printer formFeed
      ].
    ].!   
saveInstances
    " Private - Save the receiver's instances into profiler..."

    | profiler sel |
    sel := WriteStream on: String new.
    self selection notNil
    ifTrue: [
      sel
        space;nextPutAll: self selection left asFloat asString;
        space;nextPutAll: self selection top asFloat asString;
        space;nextPutAll: self selection width asFloat asString;
        space;nextPutAll: self selection height asFloat asString;
        yourself
    ].
    profiler := self profiler.
    profiler
        at: #mode put: mode asString;
        at: #useSelection put: useSelection asString;
        at: #unit put: unit asString;
        at: #shape put: shape asString;
        at: #posterX put: xy x asString;
        at: #posterY put: xy y asString;
        at: #selection put: sel contents;
        yourself! 
selectedRegion: aPane

    "Callback for the #clicked event in an unnamed CheckBox (contents is 'Region Selecta').
     (Generated by WindowBuilder)"

    useSelection := aPane selection.
    self
        changed: #setFullImage:;
        changed: #imagePreviewContents:!
selection
    "Returns the instance var of the receiver
     for external manipulation"
    ^selection!
selection: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    selection := anObject!   
selectionHeightChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    | newHeigth |
    newHeigth := aPane value.
    newHeigth isNil ifTrue: [^self].
    self selection extent: self selection width @ newHeigth.

    self changed: #currentSize:.
    graphPane invalidateRect: nil.!
selectionInPixels
    " Private - Returns the receiver's selection in pixels..."

   ^(self selection scaleBy: self graphPaneRectangle extent / self currentPageSize) truncated!   
selectionRectangle
    "Private - Returns the current selection rectangle..."

    | rect |
    (#fullPage == mode or: [ self selection isNil ])
    ifTrue: [ ^0@0 extent: self currentPageSize ].
    ^self selection!
selectionWidthChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    | newWidth |
    newWidth := aPane value.
    newWidth isNil ifTrue: [^self].
    self selection extent: newWidth @ self selection height.

    self changed: #currentSize:.
    graphPane invalidateRect: nil.!
setBorderShapes: aPane

    "Callback for the #getContents event in an unnamed CPValueSet.
     (Generated by WindowBuilder)"

    | bmp bmps box |
    bmps := self mainView propertyAt: #frameShapes.
    bmps isNil ifTrue: [
        bmps := OrderedCollection new.
        box := 0@0 extent: aPane rectangle width // 5 @ aPane rectangle height - 3.
        1 to: 5 do: [:i|
            bmp := Bitmap screenExtent: box extent.
            bmp pen
                backColor: WinInfo colorButtonFace;
                erase;
                fill: (box center corner: box corner) color: ClrDarkblue.
            (shapes at: i) value: bmp pen value: (bmp boundingBox center extent: bmp extent).
            bmps add: bmp
        ].
        self mainView propertyAt: #frameShapes put: bmps.
    ].

    1 to: bmps size do: [:i|
            aPane bitmapItem: (bmps at: i) row: 1 column: i.
    ].

    self enable: aPane when: mode ~= #poster & printing not.
    shape notNil ifTrue: [ aPane selection: shape @ 1 ].!
setCenter: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Centrado').
     (Generated by WindowBuilder)"

    self enable: aPane when: (#(fullPage poster) includes: mode) not & printing not.!  
setDotToDot: aPane

    "Callback for the #getContents event in an unnamed CheckBox (contents is '1:1 (Definicion de impresora)').
     (Generated by WindowBuilder)"

    aPane selection: mode == #dotToDot.
    self enable: aPane when: printing not.!  
setExactly: aPane

    "Callback for the #getContents event in an unnamed CheckBox (contents is 'Exactamente').
     (Generated by WindowBuilder)"

    aPane selection: mode == #exactly.
    self enable: aPane when: printing not.!  
setFullImage: aPane

    "Callback for the #getContents event in an unnamed CheckBox (contents is 'Imagen Completa').
     (Generated by WindowBuilder)"

    aPane selection: useSelection not.
    self enable: aPane when: printing not.!
setFullPage: aPane

    "Callback for the #getContents event in an unnamed CheckBox (contents is 'Pagina completa').
     (Generated by WindowBuilder)"

    aPane selection: mode == #fullPage.
    self enable: aPane when: printing not.!
setGoButton: aPane

    "Callback for the #getContents event in an unnamed CPButton
     (Generated by WindowBuilder)"

    self enable: aPane when: (#(fullPage poster) includes: mode) not & printing not! 
setHorizontalSlider: aPane

    "Callback for the #getContents event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    | pageWidth newPos |
    pageWidth := self currentPageSize x.
    newPos := self selection center x.
    newPos = aPane contents
    ifFalse: [
        aPane min: 0;max: pageWidth.
        aPane contents: newPos
    ].
    self enable: aPane when: mode ~= #poster & printing not.!  
setImageZoom: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    self selection notNil ifTrue: [ aPane value: self currentZoomFactor ].
    self enable: aPane when: mode == #zoom & printing not.! 
setPage2: aPane

    "Callback for the #getContents event in an unnamed CheckBox (contents is 'Media Pagina').
     (Generated by WindowBuilder)"

    aPane selection: mode == #page2.
    self enable: aPane when: printing not.! 
setPage4: aPane

    "Callback for the #getContents event in an unnamed CheckBox (contents is 'Cuarto de pagina').
     (Generated by WindowBuilder)"

    aPane selection: mode == #page4.
    self enable: aPane when: printing not.! 
setPagePercent: aPane

    "Callback for the #getContents event in an unnamed CPHorizontalSlider.
     (Generated by WindowBuilder)"

    | percent ratio |
    mode = #poster
    ifTrue: [ aPane selection: 100 ]
    ifFalse: [
        ratio := self selection extent / self currentPageSize.
        percent := ratio x + ratio y / 2 * 100.
        aPane contents = percent truncated
        ifFalse: [ aPane contents: percent truncated ]
    ].
    self enable: aPane when: mode ~= #poster & printing not.!
setPoster: aPane

    "Callback for the #getContents event in an unnamed CheckBox (contents is 'Poster de').
     (Generated by WindowBuilder)"

    aPane selection: mode == #poster.
    self enable: aPane when: printing not.!  
setPosterX: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    self enable: aPane when: mode == #poster & printing not.
    (xy notNil and: [aPane contents ~= xy x])
    ifTrue: [ aPane contents: xy x ].!   
setPosterY: aPane

    "Callback for the #getContents event in an unnamed CPNumericEditor.
     (Generated by WindowBuilder)"

    self enable: aPane when: mode == #poster & printing not.
    (xy notNil and: [aPane contents ~= xy y])
    ifTrue: [ aPane contents: xy y ]!
setPrintNowContents: aPane

    "Callback for the #getContents event in an unnamed Button.
     (Generated by WindowBuilder)"

    self enable: aPane when: printing not.!   
setSelectedRegion: aPane

    "Callback for the #getContents event in an unnamed CheckBox (contents is 'Region Selecta').
     (Generated by WindowBuilder)"

    aPane selection: useSelection.
    self enable: aPane when: printing not.!
setUpPrinter: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Config. Impr.').
     (Generated by WindowBuilder)"

    self printer setup.
    self fullUpdate.! 
setUpPrinterContents: aPane

    "Callback for the #getContents event in an unnamed Button.
     (Generated by WindowBuilder)"

    self enable: aPane when: printing not.!  
setVerticalSlider: aPane

    "Callback for the #getContents event in an unnamed CPVerticalSlider.
     (Generated by WindowBuilder)"

    | pageHeight newPos |
    pageHeight := self currentPageSize y.
    newPos := pageHeight - self selection center y.
    newPos = aPane contents
    ifFalse: [
        aPane min: 0;max: pageHeight.
        aPane contents: newPos
    ].
    self enable: aPane when: mode ~= #poster & printing not.!  
setZoom: aPane

    "Callback for the #getContents event in an unnamed CheckBox (contents is 'Proporcional').
     (Generated by WindowBuilder)"

    aPane selection: mode == #zoom.
    self enable: aPane when: printing not.!   
shapeSelected: aPane

    "Callback for the #select event in an unnamed CPValueSet.
     (Generated by WindowBuilder)"

    shape := aPane selection x.
    graphPane invalidateRect: nil.! 
stringFor: anObject
    "Private - Returns the string representation for anObject"

    anObject isInteger ifTrue: [
        ^anObject asString
    ].
    anObject isPoint ifTrue: [
        ^(self stringFor: anObject x) ,'x',(self stringFor: anObject y)
    ].
    anObject isNumber ifTrue: [
        ^anObject printFraction: 2
    ].
    anObject isRectangle
    ifTrue: [^(self stringFor: anObject origin),'=>',(self stringFor: anObject corner)].

    ^anObject asString!  
unit
    "Private - Returns the instance var of the receiver
     for external manipulation"
    ^unit!
unit: anObject
    "Private - Sets the instance var of the receiver
     with anObject. (No checking is done)"
    unit := anObject!   
units: aPane

    "Callback for the #getContents event in an unnamed CPSpinButton.
     (Generated by WindowBuilder)"

    | table |
    table := self class unitsTable.
    aPane
        contents: (table collect: [:tuple| tuple first]);
        selection: self unit.
    self enable: aPane when: printing not.!  
units2Inches: aValue
    "Private - Convert aValue to inches..."

    | tuple factor dpi |
    self unit = 'pulgadas' ifTrue: [^aValue].

    aValue isRectangle ifTrue: [
        ^(self units2Inches: aValue origin) extent: (self units2Inches: aValue extent)
    ].

    "aNumber assumed..."
    tuple := self class unitsTable detect: [:each| each first = self unit ] ifNone: [^0].
    factor := tuple at: 4.
    factor = 1 ifTrue: [ ^aValue ].

    factor = 0 "pixels..."
    ifTrue: [
        factor := self capability extentInInches / self capability extent
    ].

    ^aValue / factor! 
units2Pixels: aValue
    "Private - Convert aValue to pixels..."

    | dpi |
    self unit = 'puntos' ifTrue: [^aValue].
    aValue isRectangle ifTrue: [
        ^(self units2Pixels: aValue origin) extent: (self units2Pixels: aValue extent)
    ].
    dpi := self capability extent / self capability extentInInches.
    ^dpi * (self units2Inches: aValue)! 
unitSelected: aPane

    "Callback for the #select event in an unnamed CPSpinButton.
     (Generated by WindowBuilder)"

    | index oldSelection |
    index := aPane selection.
    index isNil ifTrue: [^self].
    oldSelection := self selectionInPixels.
    self unit: (self class unitsTable at: index) first.
    self selection: (self pixel2Unit:oldSelection).
    self fullUpdate.!   
unitString
    "Private - Returns the reduced name for the current unit"

    self class unitsTable do: [:each| each first = unit ifTrue: [^each last]].
    ^' ??'!  
unitText: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is 'xxxxxx.').
     (Generated by WindowBuilder)"

    aPane contents: self unit!   
verticalSliderChanged: aPane

    "Callback for the #valueChanged event in an unnamed CPVerticalSlider.
     (Generated by WindowBuilder)"

    self verticalSliderChanging: aPane.
    self fullUpdate.!   
verticalSliderChanging: aPane

    "Callback for the #valueChanging event in an unnamed CPVerticalSlider.
     (Generated by WindowBuilder)"

    | newCenter center |
    newCenter := aPane value.
    newCenter isNil ifTrue: [^self].
    self moveTo: self selection left @ (self currentPageSize y - newCenter - (self selection height / 2)).
    graphPane invalidateRect: nil.
    self changed: #currentOrigin:!  
zoom: aPane

    "Callback for the #clicked event in an unnamed CheckBox (contents is 'Proporcional').
     (Generated by WindowBuilder)"

    self mode: #zoom.
    self fullUpdate.!  
zoomTo: percent
    "Zoom current selection to a value percent
    of the current page dimensions with
    aspect ratio... "

    | extent size factor |
    extent := self printArea extent.
    size := self currentPageSize * percent / 100.

    factor := size / extent.
    factor := factor x min: factor y.

    self selection:
        (self selection origin
            extent: extent * factor)! !

! ProgressDialog class methods ! 
wbCreated

    ^true! !

! ProgressDialog methods !   
cancel: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    cancelBlock isNil ifFalse: [
        cancelBlock value
    ].
    self close!  
initialize
    "Private - Initialize the receiver"

    super initialize.
    withPages := true.
    position := 0.! 
interval: anInterval
    "Sets the interval range for the position of the receiver.
     Warning : The receiver must be open..."

    | pane |
    pane := self paneAt: #progress:.
    pane
        min: anInterval first;
        max: anInterval last.
    position := anInterval first.! 
isOpen
    "True if the receiver is open"
    ^views size > 0 and: [ self mainView isHandleOk ]!
notes: aPane

    "Callback for the #getContents event in an unnamed StaticText (contents is '').
     (Generated by WindowBuilder)"

    aPane contents:
        (notes isNil
        ifTrue: [String new]
        ifFalse: [notes])!
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Momentito...';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 603 @ 220; xC; yC; cRDU: (2 @ 218 rightBottom: 601 @ 40));
            pStyle: #(titlebar);
            backColor: ClrPalegray;
            addSubpane: (
                CP3DFrame new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 405 @ 96; lDU: 18 r: #left; tDU: 14 r: #top);
                    in;
                    startGroup; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 389 @ 82; lDU: 27 r: #left; rDU: 416 r: #left; tDU: 22 r: #top; bDU: 104 r: #top);
                    centered;
                    startGroup;
                    when: #getContents perform: #notes:;
                    contents: ''; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                CPBitmapPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 85 @ 66; lDU: 473 r: #left; tDU: 6 r: #top);
                    contents: (CPBitmapDict at: 'Page 1');
                    startGroup;
                    when: #getContents perform: #pages:;
                    backColor: ClrBackground; yourself
            );
            addSubpane: (
                CPHorizontalBarGauge new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 571 @ 40; lDU: 11 r: #left; tDU: 126 r: #top);
                    min: 0;
                    max: 100;
                    contents: 0;
                    startGroup;
                    when: #getContents perform: #progress:;
                    foreColor: ClrDarkgreen;
                    backColor: ClrPalegray; yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 139 @ 42; lDU: 443 r: #left; tDU: 78 r: #top);
                    startGroup; tabStop;
                    when: #clicked perform: #cancel:;
                    when: #getContents perform: #setCancel:;
                    contents: 'Cancelar'; font: self defaultFont;
                    backColor: ClrPalegray; yourself
            );
        yourself
    ).

    self openModeless! 
pages: aPane

    "Callback for the #getContents event in an unnamed CPBitmapPane.
     (Generated by WindowBuilder)"

    currentPage isNil
    ifTrue: [ currentPage := 1]
    ifFalse: [
        currentPage := currentPage + 1.
        currentPage > 4 ifTrue: [ currentPage := 1].
    ].
    aPane pen notNil
    ifTrue: [
         (CPBitmapDict at: 'Page ',currentPage asString)
            displayAt: 0@0 with: aPane pen
    ]!  
position: anInteger
    "Signal a new position for the receiver"

    anInteger = position ifTrue: [^self].
    position := anInteger.
    self
        changed: #progress:;
        changed: #pages:! 
progress: aPane

    "Callback for the #getContents event in an unnamed CPHorizontalBarGauge.
     (Generated by WindowBuilder)"

    aPane pen isNil ifTrue: [^self].
    position isNil ifTrue: [ position := 0 ].
    aPane
        contents: position;
        display!  
saying: aString
    "Sets the notes in the receiver to aString"

    notes := aString.!
setCancel: aPane

    "Callback for the #getContents event in an unnamed Button (contents is 'Cancelar').
     (Generated by WindowBuilder)"

    cancelBlock isNil
    ifTrue: [ aPane visible: false ]
    ifFalse: [ aPane visible: true ].!
whenCanceled: aBlock
    "Perform aBlock when canceled"

    cancelBlock := aBlock.
    self changed: #setCancel:.! !

! HaloProcessDialog methods !
addCancelButtton
    "Activates the cancel option."

    self whenCanceled: [ cancelled := true ].!
callBack
    "Returns the receiver's callback"
    ^callBack!   
cancelled
    "Returns the instance var of the receiver
     for external manipulation"
    ^cancelled = true! 
close
    "Close all the views.
     And prepare itself for reopenening..."

    super close.
    self initialize.!  
initialize
    "Private - Initialize the receiver"

    | stMessage |

    super initialize.
    mustBeOpened := true.

    callBack isNil
    ifTrue: [
        stMessage := Message new.
        stMessage
            receiver: self;
            selector: #track:start:end:text:.
        callBack := CallBack
            registerMessage: stMessage
            parameterTypes: #(short short short ulong)
            returnType: #short
            callingConvention: #pascal.
    ].!   
mustBeOpened: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    mustBeOpened := anObject! 
mustBeUpdated
    "Private - True if the receiver must be updated.
    (Each 500 milliseconds)"

    | time |
    time := Time millisecondClockValue.
    lastUpdate isNil
    ifTrue: [
        lastUpdate := time.
        ^true
    ].

    lastUpdate + 500 < time
    ifTrue: [
        lastUpdate := time.
        ^true
    ].
    ^false!
openModeless
    "Private - Open the receiver"

    title notNil ifTrue: [
        self mainView labelWithoutPrefix: title
    ].
    super openModeless.

    self changed: #setCancel:.!
release
    "Release the receiver's callback..."

    super release.

    callBack isNil
    ifFalse: [
        callBack release.
        callBack := nil
    ].!
runPendingEvents
    "Private - Process pending events...
     * WARNING * Done during callback)"

     Notifier readWinQueue.
     CurrentEvent nullEventWin.
     Notifier runPendingEvents.! 
title: aString
    "Sets the receiver's title"
    title := aString!
track: aMessage start: start end: end text: lpText
    "Private - Performs status tracking actions..."

    mustBeOpened ifFalse: [^0]. "ignore all requests"

    aMessage = TrOpen
    ifTrue: [
        cancelled := false.
        self open
    ]
    ifFalse: [
        self isOpen ifFalse: [^0].
        aMessage = TrUpdate
        ifTrue: [
             "consider units step"
            self mustBeUpdated
            ifTrue: [ self position: start ].
            self cancelled ifTrue: [^1].
        ]
        ifFalse: [
            aMessage = TrClose
            ifTrue: [ self close ]
            ifFalse: [
                aMessage = TrSetRange
                ifTrue: [ self interval: (start to: end) ]
                ifFalse: [ "ignored..." ]
            ]
        ]
    ].

    self runPendingEvents.
    ^0! !

! StickerDialog class methods !   
wbCreated

    ^true! !

! StickerDialog methods !
backColor: aColor
    "Sets the receiver's back color..."

    backColor := aColor.!   
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            font: self defaultFont;
            owner: self;
            labelWithoutPrefix:  '';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: (FrameRectangle origin: 0@0 extent: 0@0);
            when: #eraseBackground perform: #stickerContents:;
            pStyle: #();
        yourself
    ).!   
display: aSticker with: pen
    " Private - Display aSticker and update main view extent if needed..."

    | box view stream margin width extent line lineHeight font |
    "nothing to do..."
    aSticker isNil ifTrue: [ ^nil ].

    "expand symbols..."
    aSticker isSymbol ifTrue: [
        ^self display: (self stickerFromSymbol: aSticker) with: pen
    ].

    margin := 1@1 * 2.
    view := self mainView.
    box := view rectangle.
    pen fill: box color: backColor.

    ((aSticker respondsTo: #extent)
    and: [aSticker respondsTo: #displayAt:with:])
    ifTrue: [ "is like a bitmap..."
        extent := "margin * 2 +" aSticker extent.
        aSticker displayAt: 0@0"margin - 1" with: pen.
    ]
    ifFalse: [ "string assumed..."
        width := margin x * 2.
        font := view font.
        lineHeight := font height max: self defaultFont height.
        pen
            font: font;
            setTextAlign: TaTop;
            setBackMode: Transparent;
            place: margin.
        stream := ReadStream on: aSticker asString.
        [stream atEnd] whileFalse: [
            line := stream nextLine.
            pen displayText: line.
            stream atEnd ifFalse: [ pen place: margin + (0@ (pen location y + lineHeight)) ].
            width := width max: (margin x * 2 + (font stringWidth: line)).
        ].
        extent := width @ (pen location y + (margin y * 2 + lineHeight)).
        pen setBackMode: Opaque.
    ].

    extent = box extent ifFalse: [ "popUp must be resized..."
        self
            send: #popUpExtent: to: self withArguments: (Array with: extent);
            yourself
    ].!  
hide
    "Private - Hide the receiver..."

    | view hidden |
    view := self viewNamed: 'mainView'.
    view isNil ifTrue: [ ^nil ].
    hidden := (view propertyAt: #visible) = false.
    hidden ifTrue: [ ^self ].
    view hideWindow.
    view propertyAt: #visible put: false.! 
popUpExtent: aPoint
    " Private - Set the main view to new popUpExtent and moved near cursor"

    | box view displacement |

    view := self mainView.
    box := aPoint isNil
        ifTrue: [ view rectangle copy ]
        ifFalse: [ 0@0 extent: aPoint ].
    displacement := 0 @ 18.

    box moveTo: Cursor sense + displacement - ((box extent // 2) x @ 0).
    box left < 0 ifTrue: [ box moveBy: box left abs @ 0 ].
    box top < 0 ifTrue: [ box moveBy: 0@ box top abs ].
    box right > Display width ifTrue: [ box moveBy: (Display width - box right) @ 0 ].
    box bottom > Display height ifTrue: [ box moveBy: 0@ (Display height - box bottom) ].

    UserLibrary
        setWindowPos: view handle
        insertAfter: (WinHandle fromInteger: 16rFFFF)
        x: box left    y: box top    cx: box width    cy: box height
        flags: SwpNoactivate " | SwpNomove | SwpNosize "!
show
    "Private - Show (unHides) the receiver..."

    | view hidden |
    view := self viewNamed: 'mainView'.
    view isNil ifTrue: [ ^nil ].
    hidden := (view propertyAt: #visible) = false.
    hidden ifFalse: [ ^self ].
    view showWindow.
    view propertyAt: #visible put: true.!   
sticker
    "Returns the instance var of the receiver
     for external manipulation"
    ^sticker!
sticker: anObject
    "Sets the receiver's contents with a new sticker..."

    | view |

    "inmune to multiple sticker settings..."
    sticker = anObject ifTrue: [ ^self ].

    sticker := anObject.
    self mainView event: #eraseBackground.
    self send: (sticker isNil ifTrue: [#hide] ifFalse: [#show]) to: self.!
stickerContents: aPane

    "Callback for the #eraseBackground event in the main view..."

    | pen |
    pen := aPane pen.
    pen isNil ifTrue: [ ^nil ].
    pen erase.
    self display: sticker with: pen!  
stickerFromSymbol: aSymbol
    " Private - returns aString from symbol aSymbol..."

    | stream |
    stream := WriteStream on: String new.
    aSymbol do: [:c|
        c isUpperCase ifTrue: [ stream space ].
        stream nextPut: c.
    ].
    ^stream contents trimBlanks! 
topPaneClass
    " Private - Subclassified to support #eraseBackground message..."

    ^LittleTopDialog! !

! WBAboutDialog class methods ! 
isWBInternalClass

    ^true! !

! WBAboutDialog methods !
getSerialNumber: aPane
    | serial |
    serial := Smalltalk at: #WindowBuilderSerialNumber ifAbsent: [ nil ].
    serial isNil ifTrue: [ serial := '*INVALID*' ].
    aPane contents: ('Registered to:\',serial) withCrs!   
getUser: aPane
    | serial user company |
    (user := Smalltalk at: #WindowBuilderUser ifAbsent: [ nil ]) isNil ifTrue: [
        [(serial:= Prompter prompt: 'Please Enter Serial Number.' default: '') isNil
            or: [ serial isEmpty ]] whileTrue: [ ].
        Smalltalk at: #WindowBuilderSerialNumber put: '<',serial,'>'.
        self changed: #getSerialNumber:.
        [(user:= Prompter prompt: 'Please Enter User Name.' default: '') isNil
            or: [ user isEmpty ]] whileTrue: [ ].
        Smalltalk at: #WindowBuilderUser put: user.
        company := Prompter prompt: 'Please Enter Company Name.' default: ''.
        company isNil ifTrue: [ company := '' ].
        Smalltalk at: #WindowBuilderCompany put: company.
    ] ifFalse: [
        company := Smalltalk at: #WindowBuilderCompany ifAbsent: [ '' ]
    ].
    aPane contents: (user,'\',company) withCrs! 
getVersion: aPane

    aPane contents: WindowBuilderVersion!
initWindow
    | font |
    font := Font new
        fromBytes: #( 243 255 0 0 0 0 0 0 188 2 0 0 0 0 3 2 1 18 84 105 109 101 115 32 78 101 119 32 82 111 109 97 110 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 ).
    (self paneNamed: 'version') font: font.
    (self paneNamed: 'registeredTo') font: font.
    (self paneNamed: 'user') font: font.
    (self paneNamed: 'copyright') font: font.
    (self paneNamed: 'window') contents: (CPBitmapDict sysAt: 'window').
    (self paneNamed: 'osilogo') contents: (CPBitmapDict sysAt: 'osilogo').
    (self paneNamed: 'wbpro') contents: (CPBitmapDict sysAt: 'wbpro').
    (self paneNamed: 'address') contents: (CPBitmapDict sysAt: 'address').!
isWBWindow

    ^true!  
ok: aPane

    self close!  
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'New Window';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 997 @ 512; xC; yC; cRDU: (2 @ 510 rightBottom: 994 @ 2));
            pStyle: #();
            backColor: ClrPalegray;
            addSubpane: (
                CPStaticGraphic new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 329 @ 288; lDU: 0 r: #left; rDU: 329 r: #left; tDU: 0 r: #top; bDU: 288 r: #top);
                    paneName: 'window';
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 40; lDU: 9 r: #left; rDU: 260 r: #left; tDU: 440 r: #top; bDU: 508 r: #top);
                    paneName: 'registeredTo';
                    rightJustified;
                    startGroup;
                    when: #getContents perform: #getSerialNumber:;
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 530 @ 68; lDU: 280 r: #left; rDU: 768 r: #left; tDU: 440 r: #top; bDU: 508 r: #top);
                    paneName: 'user';
                    startGroup;
                    when: #getContents perform: #getUser:;
                    contents: '';
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 265 @ 64; lDU: 366 r: #left; rDU: 631 r: #left; tDU: 232 r: #top; bDU: 296 r: #top);
                    paneName: 'version';
                    centered;
                    startGroup;
                    when: #getContents perform: #getVersion:;
                    contents: '';
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                DrawnButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 329 @ 288; lDU: 663 r: #left; rDU: 992 r: #left; tDU: 0 r: #top; bDU: 288 r: #top);
                    paneName: 'osilogo';
                    startGroup;
                    when: #clicked perform: #thanks:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPStaticGraphic new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 329 @ 192; lDU: 329 r: #left; rDU: 658 r: #left; tDU: 24 r: #top; bDU: 216 r: #top);
                    paneName: 'wbpro';
                    startGroup;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 814 @ 64; lDU: 110 r: #left; rDU: 923 r: #left; tDU: 304 r: #top; bDU: 368 r: #top);
                    paneName: 'copyright';
                    centered;
                    startGroup;
                    contents: '(c) Copyright Objectshare Systems, Inc. 1993
(c) Copyright Cooper && Peters, Inc. 1991, 1992';
                    foreColor: ClrBlack;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                DrawnButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 750 @ 48; lDU: 137 r: #left; rDU: 887 r: #left; tDU: 376 r: #top; bDU: 424 r: #top);
                    paneName: 'address';
                    startGroup;
                    when: #clicked perform: #showAddress:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 197 @ 56; lDU: 777 r: #left; rDU: 974 r: #left; tDU: 440 r: #top; bDU: 496 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: 'OK';
                    backColor: ClrPalegray;
                    yourself
            );
        yourself
    ).

    self openModeless!   
showAddress: aPane

    MessageBox messageNote:
'Objectshare Systems, Inc.
5 Town & Country Village
Suite 735
San Jose, California 95128-2026
Phone: (408) 970-7280
Fax: (408) 970-7282
Compuserve: 76436,1063'! 
thanks: aPane
    | user |
    user := Smalltalk at: #WindowBuilderUser ifAbsent: [ '' ].
    MessageBox message: 'Special Thanks to:

Ken Cooper, Ted Peters, Dan Shafer,
Scott Herndon, Christine Comaford,
Eric Clayberg, Bob Yerex, Dina Fischer,
Ron Jeffries, Robb Canfield, S. Sridhar,
David Taylor, ',user,'
American Management Systems, Inc.
Knowledge Systems Corporation, Inc.
Object Technology International, Inc.'! !

! WBAddInManager class methods ! 
isWBInternalClass

    ^true! !

! WBAddInManager methods !   
done: aPane

    "Callback for the #clicked event in the Button named 'cancel'.
     (Generated by WindowBuilder)"

    changed ifTrue: [
        MessageBox messageNote: 'You must restart WindowBuilder for these changes to take effect.'
    ].
    self close!   
getHelpText

    PWindowBuilder listAddIns do: [ :s |
        selection = (PWindowBuilder perform: s with: #name) ifTrue: [
            ^PWindowBuilder perform: s with: #help
        ]
    ].
    ^''!   
initWindow

    changed := false.
    self loadList!   
install: aPane

    "Callback for the #clicked event in the Button named 'install'.
     (Generated by WindowBuilder)"

    PWindowBuilder perform: (PWindowBuilder listAddIns detect: [ :s |
        (PWindowBuilder perform: s with: #name) = selection ]) with: nil.
    self updateProperties.
    changed := true.
    self loadList!   
loadList
    | list extras |
    list := OrderedCollection new.
    extras := PWindowBuilder extras keys.
    (PWindowBuilder listAddIns collect: [ :s |
        PWindowBuilder perform: s with: #name ])
        do: [ :ai |
            ai isNil ifFalse: [
                (extras includes: ai)
                    ifTrue: [ list add: '*',ai ]
                    ifFalse: [ list add: ai ]]].
    (self paneNamed: 'list') contents: list.
    (self paneNamed: 'install') disable.
    (self paneNamed: 'remove') disable.! 
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Add-In Manager';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 713 @ 528; lDU: 361 r: #left; tDU: 226 r: #top; cRDU: (11 @ 518 rightBottom: 702 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                TextEdit new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 667 @ 152; lDU: 9 r: #left; rDU: 677 r: #left; tDU: 248 r: #top; bDU: 400 r: #top);
                    paneName: 'help';
                    scrollBars;
                    startGroup;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 667 @ 232; lDU: 9 r: #left; rDU: 677 r: #left; tDU: 8 r: #top; bDU: 240 r: #top);
                    paneName: 'list';
                    startGroup;
                    tabStop;
                    when: #select perform: #select:;
                    when: #doubleClickSelect perform: #toggle:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 9 r: #left; rDU: 155 r: #left; tDU: 408 r: #top; bDU: 464 r: #top);
                    paneName: 'install';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #install:;
                    contents: '&Enable';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 165 r: #left; rDU: 311 r: #left; tDU: 408 r: #top; bDU: 464 r: #top);
                    paneName: 'remove';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #remove:;
                    contents: '&Disable';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 530 r: #left; rDU: 677 r: #left; tDU: 408 r: #top; bDU: 464 r: #top);
                    paneName: 'done';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #done:;
                    contents: '&Done';
                    yourself
            );
        yourself
    ).

    self openWindow!   
remove: aPane

    "Callback for the #clicked event in the Button named 'remove'.
     (Generated by WindowBuilder)"

    PWindowBuilder removeExtra: selection.
    self updateProperties.
    changed := true.
    self loadList!   
select: aPane

    "Callback for the #select event in the ListBox named 'list'.
     (Generated by WindowBuilder)"

    (aPane selectedItem beginsWith: '*') ifTrue: [
        (self paneNamed: 'install') disable.
        (self paneNamed: 'remove') enable.
        selection := aPane selectedItem copyFrom: 2 to: aPane selectedItem size.
    ] ifFalse: [
        (self paneNamed: 'install') enable.
        (self paneNamed: 'remove') disable.
        selection := aPane selectedItem.
    ].
    (self paneNamed: 'help') contents: self getHelpText.!  
toggle: aPane

    "Callback for the #doubleClickSelect event in the ListBox named 'list'.
     (Generated by WindowBuilder)"

    (aPane selectedItem beginsWith: '*') ifTrue: [
        self remove: nil
    ] ifFalse: [
        self install: nil
   ]!  
updateProperties
    | gridSize drawGrid |
    gridSize := PWindowBuilder propertyAt: #GridSize.
    drawGrid := PWindowBuilder propertyAt: #DrawGrid.
    PWindowBuilder initProperties.
    PWindowBuilder propertyAt: #GridSize put: gridSize.
    PWindowBuilder propertyAt: #DrawGrid put: drawGrid.! !

! WBAttributeEditor class methods ! 
isWBInternalClass

    ^true! !

! WBAttributeEditor methods !
cancel: aPane

    thePane := nil.
    super close!
isWBWindow

    ^true!  
openOn: aWin

    thePane := aWin.
    ^self open! 
result

    ^thePane! !

! WBActionEditor methods !   
add: aPane

    | methodString answer methodPane |
    methodPane := self paneNamed: 'method'.
    methodPane evaluate: false.
    author := (self paneNamed: 'author') contents.
    action := (self paneNamed: 'name') contents.
    methodString := WriteStream on: String new.
    aPane contents = '&Add' ifTrue: [
        methodString
            nextPutAll: 'action',action;
            cr; nextPut: $";
            cr; nextPutAll: 'Created by ',author,' - ',Date today asString;
            cr; nextPut: $"; cr.
        methodPane offset: methodString position.
        methodString nextPutAll: methodPane contents.
    ] ifFalse: [
        methodString
            nextPutAll: 'action',action;
            cr; nextPut: $";
            nextPutAll: history;
            nextPutAll: 'Modified by ',author,' - ',Date today asString;
            cr; nextPut: $"; cr.
        methodPane offset: methodString position.
        methodString nextPutAll: methodPane contents.
    ].
    answer := Compiler
        compile: methodString contents
        in: WBAction
        notifying: methodPane
        ifFail: [ ^methodPane setFocus ].

    PWindowBuilder
        createMethod: methodString contents
        in: WBAction
        loggingSource: true.

    self updateList.!   
fileIn: aPane

    | dialog file |
    dialog := FileDialog new.
    dialog title: 'File In Actions';
        defFilter: '*.ACT';
        addFilter: '*.ACT' description: 'Action Lists';
        hideReadonly;
        open.

    file := dialog file.
    file isNil ifTrue: [^self].
    file := File pathNameReadOnly: file.
    CursorManager execute change.
    file fileIn.
    CursorManager normal change.
    file close.

    self updateList!  
fileOut: aPane

    | file classReader |

    file := (FileDialog new
        saveTitle: 'File out Actions'
        fileName: (
            File
                fileName: 'ACTIONS'
                extension: 'ACT')) file.
    file isNil ifTrue: [^self].
    file := File newFile: file.
    classReader := ClassReader forClass: (Smalltalk at: #WBAction).
    WBAction listActions do: [ :act |
        classReader fileOutMethod: ('action',act) asSymbol on: file].
    file close.! 
getAuthor: aPane

     aPane setContents: (Smalltalk at: #WindowBuilderUser ifAbsent: [ nil ])! 
help: aPane

    MessageBox notify: 'Action Attributes Help' withText:
'Enter the text for your action in the ''Method
Text'' box. The window may be referred to as
''self window''. The button or menuItem can be
refered to as ''self button'' or ''self menuItem''.'!
initWindow

    | listPane |
    changed := false.
    action := thePane action.
    self updateList.!   
loadList: aPane

    aPane contents: WBAction listActions!  
methodChanged: aPane

    aPane contents trimBlanks = method ifTrue: [
        (self paneNamed: 'add')
            contents: '&Change';
            disable.
        (self paneNamed: 'author') setContents: author.
    ] ifFalse: [
        (self paneNamed: 'author') setContents:
            (Smalltalk at: #WindowBuilderUser ifAbsent: [ author ]).
        (WBAction listActions includes: (self paneNamed: 'name') contents) ifTrue: [
            (self paneNamed: 'add')
                contents: '&Change';
                enable.
        ] ifFalse: [
            (self paneNamed: 'add')
                contents: '&Add';
                enable.
        ].
    ].
    changed := true.!   
newAuthor: aPane

    (self paneNamed: 'add')
        contents: '&Change';
        enable.
    author := aPane contents.
    changed := true.!  
newName: aPane

    aPane contents isEmpty ifTrue: [
        self getAuthor: (self paneNamed: 'author').
        (self paneNamed: 'add')
            contents: '&Add';
            disable
    ] ifFalse: [(WBAction listActions includes: aPane contents) ifTrue: [
        changed ifTrue: [
            self getAuthor: (self paneNamed: 'author').
            (self paneNamed: 'add')
                contents: '&Change';
                enable
        ] ifFalse: [
            (self paneNamed: 'author') setContents: author.
            (self paneNamed: 'add')
                contents: '&Change';
                disable
        ].
    ] ifFalse: [
        self getAuthor: (self paneNamed: 'author').
        (self paneNamed: 'add')
            contents: '&Add';
            enable
    ]].!
ok: aPane

    thePane action: (self paneNamed: 'list') selectedItem.
    thePane isInterfaceObject ifTrue: [
        thePane contents: thePane action
    ].

    self close! 
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Action Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1061 @ 528; lDU: 197 r: #left; tDU: 242 r: #top; cRDU: (11 @ 518 rightBottom: 1049 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 631 @ 384; lDU: 393 r: #left; rDU: 1024 r: #left; tDU: 8 r: #top; bDU: 392 r: #top);
                    startGroup;
                    contents: 'Action Definition';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 256 @ 32; lDU: 18 r: #left; rDU: 274 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    startGroup;
                    contents: 'Select an Action:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 32; lDU: 411 r: #left; rDU: 512 r: #left; tDU: 56 r: #top; bDU: 88 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Name:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 402 r: #left; rDU: 512 r: #left; tDU: 112 r: #top; bDU: 144 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Author:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 411 r: #left; rDU: 603 r: #left; tDU: 160 r: #top; bDU: 192 r: #top);
                    startGroup;
                    contents: 'Method Text';
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 357 @ 352; lDU: 18 r: #left; rDU: 375 r: #left; tDU: 40 r: #top; bDU: 392 r: #top);
                    paneName: 'list';
                    startGroup;
                    tabStop;
                    when: #select perform: #select:;
                    when: #doubleClickSelect perform: #ok:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 169 @ 56; lDU: 18 r: #left; rDU: 187 r: #left; tDU: 400 r: #top; bDU: 456 r: #top);
                    paneName: 'ok';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 169 @ 56; lDU: 201 r: #left; rDU: 370 r: #left; tDU: 400 r: #top; bDU: 456 r: #top);
                    paneName: 'cancel';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 320 @ 48; lDU: 521 r: #left; rDU: 841 r: #left; tDU: 48 r: #top; bDU: 96 r: #top; indent: 3 @ 4);
                    paneName: 'name';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #newName:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 48; lDU: 850 r: #left; rDU: 1006 r: #left; tDU: 48 r: #top; bDU: 96 r: #top);
                    paneName: 'add';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #add:;
                    contents: '&Add';
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 485 @ 48; lDU: 521 r: #left; rDU: 1006 r: #left; tDU: 104 r: #top; bDU: 152 r: #top; indent: 3 @ 4);
                    paneName: 'author';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #newAuthor:;
                    yourself
            );
            addSubpane: (
                WBTextPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 594 @ 184; lDU: 411 r: #left; rDU: 1006 r: #left; tDU: 192 r: #top; bDU: 376 r: #top);
                    paneName: 'method';
                    noScrollBars;
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #methodChanged:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 56; lDU: 393 r: #left; rDU: 558 r: #left; tDU: 400 r: #top; bDU: 456 r: #top);
                    paneName: 'help';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #help:;
                    contents: '&Help';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 56; lDU: 649 r: #left; rDU: 832 r: #left; tDU: 400 r: #top; bDU: 456 r: #top);
                    paneName: 'fileOut';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #fileOut:;
                    contents: '&File Out...';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 56; lDU: 841 r: #left; rDU: 1024 r: #left; tDU: 400 r: #top; bDU: 456 r: #top);
                    paneName: 'fileIn';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #fileIn:;
                    contents: 'File &In...';
                    yourself
            );
        yourself
    ).

    self openWindow!   
select: aPane
    | stream |
    action := aPane selectedItem.
    action isNil ifTrue: [ ^nil ].
    (self paneNamed: 'name') setContents: action.
    method := WBAction sourceCodeAt: ('action',action) asSymbol.
    stream := method asStream.
    stream skipTo: $".
    history := stream upTo: $".
    author := ((history asStream) skipTo: $y; skip: 1; upTo: $-) trimBlanks.
    (self paneNamed: 'author') setContents: author.
    stream skipTo: $".
    method := stream copyFrom: stream position to: stream size.
    (self paneNamed: 'method')
        contents: method;
        selectAll;
        selectBefore: 1@1.
    (self paneNamed: 'add')
        contents: '&Change';
        disable.
    changed := false.!
updateList
    | listPane |
    self loadList: (listPane := self paneNamed: 'list').
    action isNil ifFalse: [
        listPane selectItem: action.
        self select: listPane
    ].
    (self paneNamed: 'add') disable! !

! WBBitmapPicker methods !
activate: ignore

    | keys |

    (self paneNamed: 'name')
        contents: (keys := CPBitmapDict keys asSortedCollection);
        selection: (CPBitmapDict keyAtValue: thePane realPane contents ifAbsent: [ keys first ]).!   
editBitmaps: ignore

    (Smalltalk includesKey: #CPBitmapManager) ifTrue: [
        (Smalltalk includesKey: #MDISystem) ifTrue: [
            (Smalltalk at: #MDISystem) isActive ifTrue: [
                ^MessageBox message: 'Due to limitations in the implementation of MDI, the bitmap manager cannot be launched from within MDI.  Either use the toolbar, or switch out of MDI first.'
            ].
        ].
        (Smalltalk at: #CPBitmapManager) new sendInputEvent: #open.
    ] ifFalse: [
        MessageBox message: 'To view/edit bitmaps, you must first file in the CPBitmapManager.'
    ].!
ok: ignore

    | p |

    thePane := thePane fullCopy.
    p := thePane realPane.

    p contents: (CPBitmapDict at: (self paneNamed: 'name') selectedItem).

    self close.!  
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'CPBitmapPane Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 795 @ 208; xC; yC; cRDU: (11 @ 198 rightBottom: 784 @ 48));
            pStyle: #(sysmenu modal titlebar);
            when: #activate perform: #activate:;
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 18 r: #left; rDU: 137 r: #left; tDU: 24 r: #top; bDU: 56 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Bitmap:';
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 613 @ 424; lDU: 146 r: #left; rDU: 759 r: #left; tDU: 16 r: #top; bDU: 440 r: #top);
                    paneName: 'name';
                    dropDownList;
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 56; lDU: 421 r: #left; rDU: 759 r: #left; tDU: 80 r: #top; bDU: 136 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #editBitmaps:;
                    contents: '&Edit/View Bitmaps...';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 58; lDU: 18 r: #left; rDU: 192 r: #left; tDU: 80 r: #top; bDU: 138 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 56; lDU: 219 r: #left; rDU: 393 r: #left; tDU: 80 r: #top; bDU: 136 r: #top);
                    paneName: 'cancel';
                    idCancel;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! !

! WB2BitmapPicker methods !
activate: ignore

    (self paneNamed: 'name1') restoreSelected.
    (self paneNamed: 'name2') restoreSelected.!   
initWindow

    | key |

    (self paneNamed: 'name1') selection: (key := CPBitmapDict keyAtValue: thePane realPane bitmap ifAbsent: [ nil ]).
    (self paneNamed: 'pictureCheck') selection: key notNil.

    (self paneNamed: 'name2') selection: (key := CPBitmapDict keyAtValue: thePane realPane onBitmap ifAbsent: [ nil ]).
    (self paneNamed: 'pushedCheck') selection: key notNil.!   
keys

    ^CPBitmapDict keys asSortedCollection!
keys: aPane

    aPane contents: self keys.!
ok: ignore

    | p |

    thePane := thePane fullCopy.
    p := thePane realPane.

    (self paneNamed: 'pictureCheck') selection ifTrue: [
        p bitmap: (CPBitmapDict at: (self paneNamed: 'name1') selectedItem ifAbsent: [ nil ]).
    ] ifFalse: [
        p bitmap: nil.
    ].

    (self paneNamed: 'pushedCheck') selection ifTrue: [
        p onBitmap: (CPBitmapDict at: (self paneNamed: 'name2') selectedItem ifAbsent: [ nil ]).
    ] ifFalse: [
        p onBitmap: nil.
    ].

    self close.!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'CPBitmapButton Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 841 @ 272; xC; yC; cRDU: (11 @ 262 rightBottom: 830 @ 48));
            pStyle: #(sysmenu modal titlebar);
            when: #activate perform: #activate:;
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 503 @ 416; lDU: 302 r: #left; rDU: 805 r: #left; tDU: 16 r: #top; bDU: 432 r: #top);
                    paneName: 'name1';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #keys:;
                    when: #select perform: #pictureSelected:;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 503 @ 358; lDU: 302 r: #left; rDU: 805 r: #left; tDU: 80 r: #top; bDU: 438 r: #top);
                    paneName: 'name2';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #keys:;
                    when: #select perform: #pushedSelected:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 421 @ 56; lDU: 384 r: #left; rDU: 805 r: #left; tDU: 144 r: #top; bDU: 200 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #editBitmaps:;
                    contents: 'Edit/View Bitmaps...';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 162 @ 36; lDU: 18 r: #left; tDU: 24 r: #top);
                    paneName: 'pictureCheck';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #pictureClicked:;
                    contents: 'Picture:';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 36; lDU: 18 r: #left; tDU: 88 r: #top);
                    paneName: 'pushedCheck';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #pushedClicked:;
                    contents: 'Pushed Picture:';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 58; lDU: 18 r: #left; rDU: 174 r: #left; tDU: 144 r: #top; bDU: 202 r: #top);
                    idOK;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 56; lDU: 192 r: #left; rDU: 347 r: #left; tDU: 144 r: #top; bDU: 200 r: #top);
                    paneName: 'cancel';
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!  
pictureClicked: aPane

    aPane selection ifTrue: [
        (self paneNamed: 'name1') selection: self keys first.
    ] ifFalse: [
        (self paneNamed: 'name1') selection: nil.
    ].!   
pictureSelected: aPane

    aPane selection notNil ifTrue: [
        (self paneNamed: 'pictureCheck') selection: true.
    ].!
pushedClicked: aPane

    aPane selection ifTrue: [
        (self paneNamed: 'name2') selection: self keys first.
    ] ifFalse: [
        (self paneNamed: 'name2') selection: nil.
    ].!
pushedSelected: aPane

    aPane selection notNil ifTrue: [
        (self paneNamed: 'pushedCheck') selection: true.
    ].! !

! WBValueSetEditor methods !
activate: ignore

    bitmap contents: (CPBitmapDict keys asSortedCollection).! 
bitmapSelected: aPane

    | c |

    c := (CPBitmapDict at: aPane selectedItem ifAbsent: [ nil ]).
    c notNil ifTrue: [
        contents := c.
        self saveItemDetails.
    ].!   
cellSelected: aPane

    contents := aPane selectedItem.
    self fillInItemDetails.!  
colorSelected: aPane

    | c |

    c := (ColorConstants at: aPane selectedItem ifAbsent: [ nil ]).
    c notNil ifTrue: [
        contents := c.
        self saveItemDetails.
    ].!  
fillInItemDetails

    contents isBitmap ifTrue: [
        bitmap selection: (CPBitmapDict keyAtValue: contents).
        color selection: nil.
        text setContents: ''.
    ] ifFalse: [
        bitmap selection: nil.
        contents isString ifTrue: [
            text setContents: contents.
            color selection: nil.
        ] ifFalse: [
            text setContents: ''.
            color selection: (ColorConstants keyAtValue: contents).
        ].
    ].!  
initWindow

    | p |

    p := thePane realPane.

    (self paneNamed: 'rows') contents: p columnsRows y.

    (self paneNamed: 'columns') contents: p columnsRows x.

    (self paneNamed: 'palette') readSpecificsFrom: p.

    bitmap contents: (CPBitmapDict keys asSortedCollection).
    color contents: (ColorConstants keys asSortedCollection).

    self fillInItemDetails.!
ok: aPane

    thePane := thePane fullCopy.

    (self paneNamed: 'palette') copySpecificsTo: thePane realPane.

    self close.!   
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Palette Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1015 @ 696; xC; yC; cRDU: (11 @ 686 rightBottom: 1003 @ 48));
            pStyle: #(sysmenu modal titlebar);
            when: #activate perform: #activate:;
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 347 @ 168; lDU: 18 r: #left; rDU: 366 r: #left; tDU: 8 r: #top; bDU: 176 r: #top);
                    startGroup;
                    contents: 'Size';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 411 r: #left; rDU: 503 r: #left; tDU: 136 r: #top; bDU: 168 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Color:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 384 r: #left; rDU: 503 r: #left; tDU: 80 r: #top; bDU: 112 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Bitmap:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 82 @ 32; lDU: 421 r: #left; rDU: 503 r: #left; tDU: 24 r: #top; bDU: 56 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Text:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 32; lDU: 37 r: #left; rDU: 183 r: #left; tDU: 120 r: #top; bDU: 152 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Columns:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 32; lDU: 82 r: #left; rDU: 183 r: #left; tDU: 56 r: #top; bDU: 88 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Rows:';
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 48; lDU: 192 r: #left; tDU: 48 r: #top);
                    paneName: 'rows';
                    min: 1;
                    contents: 1;
                    startGroup;
                    tabStop;
                    when: #valueChanged perform: #rowsColumnsChanged:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 48; lDU: 192 r: #left; tDU: 112 r: #top);
                    paneName: 'columns';
                    min: 1;
                    contents: 1;
                    startGroup;
                    tabStop;
                    when: #valueChanged perform: #rowsColumnsChanged:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 48; lDU: 512 r: #left; rDU: 978 r: #left; tDU: 16 r: #top; bDU: 64 r: #top; indent: 3 @ 4);
                    paneName: 'text';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #textChanged:;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 469 @ 276; lDU: 512 r: #left; rDU: 981 r: #left; tDU: 72 r: #top; bDU: 348 r: #top);
                    paneName: 'name';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #select perform: #bitmapSelected:;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 469 @ 276; lDU: 512 r: #left; rDU: 981 r: #left; tDU: 128 r: #top; bDU: 404 r: #top);
                    paneName: 'color';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #select perform: #colorSelected:;
                    yourself
            );
            addSubpane: (
                CPValueSet new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 960 @ 384; lDU: 18 r: #left; tDU: 184 r: #top);
                    paneName: 'palette';
                    rows: 2 columns: 2;
                    startGroup;
                    tabStop;
                    when: #select perform: #cellSelected:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 357 @ 54; lDU: 622 r: #left; rDU: 978 r: #left; tDU: 576 r: #top; bDU: 630 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #editBitmaps:;
                    contents: '&Edit/View Bitmaps...';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 142 @ 54; lDU: 18 r: #left; rDU: 160 r: #left; tDU: 576 r: #top; bDU: 630 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 142 @ 54; lDU: 174 r: #left; rDU: 315 r: #left; tDU: 576 r: #top; bDU: 630 r: #top);
                    paneName: 'cancel';
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! 
preInitWindow

    bitmap := self paneNamed: 'name'.
    color := self paneNamed: 'color'.
    text := self paneNamed: 'text'.!   
rowsColumnsChanged: aPane

    (self paneNamed: 'palette')
        columnsRows: (self paneNamed: 'columns') contents @ (self paneNamed: 'rows') contents;
        reframe;
        display!  
saveItemDetails

    | p |

    (p := self paneNamed: 'palette') cellAt: p selection put: contents.
    p cacheBitmap; display.! 
textChanged: aPane

    contents := aPane contents.
    self saveItemDetails.! !

! WBColumnarListBoxEditor methods !
autoFieldWidth: aPane

    (self paneNamed: 'fieldWidth')
        disable.

    self updateSelectedItem.!
deleteItem: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Delete Item').
     (Generated by WindowBuilder)"

    | index |

    index := (self paneNamed: 'itemsList') selection.
    fields removeIndex: index.
    fields isEmpty ifTrue: [
        fields add: CPCLBField new.
    ].

    self
        changed: #getListContents:
        with: #restoreSelected:
        with: index.

    selectedField := fields at: ( index min: fields size).
    self updateEditors.!   
fieldWidthChanged: aPane

    "Callback for the #getContents event in the CPNumericEditor named 'fieldWidth'.
     (Generated by WindowBuilder)"

    self updateSelectedItem.!  
getListContents: aPane

    "Callback for the #getContents event in the CPColumnarListBox named 'itemsList'.
     (Generated by WindowBuilder)"

    aPane contents: fields.!
getListFields: aPane

    "Callback for the #getFields event in the CPColumnarListBox named 'itemsList'.
     (Generated by WindowBuilder)"

    aPane fields: (
      OrderedCollection
        with: (
            CPCLBField new
                header: 'Label';
                selector: #header;
                fieldWidth: 12
        )
        with: (
            CPCLBField new
                header: 'Method';
                selector: #selectorString;
                fieldWidth: 10
        )
        with: (
            CPCLBField new
                header: 'Just.';
                selector: #justificationString;
                fieldWidth: 8
        )
        with: (
            CPCLBField new
                header: 'Width';
                justification: #right;
                selector: #fieldWidthString
        )
    )!  
initWindow

    (self paneNamed: 'itemsList') selection: selectedField.

    self updateEditors.! 
insertItem: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Insert Item').
     (Generated by WindowBuilder)"

    | index |

    index := (self paneNamed: 'itemsList') selection.
    fields
        add: CPCLBField new
        afterIndex: index.

    self
        changed: #getListContents:
        with: #restoreSelected:
        with: index + 1.

    selectedField := fields at: index + 1.
    self updateEditors.! 
isLegitimateSymbol: aString

    aString do: [ :c |
        c isAlphaNumeric ifFalse: [ ^false ]
    ].

    ^true! 
justificationChanged: aPane

    "Callback for the #clicked event in the RadioButton named 'centerJustified'.
     (Generated by WindowBuilder)"

    self updateSelectedItem.!  
labelChanged: aPane

    "Callback for the #textChanged event in the EntryField named 'label'.
     (Generated by WindowBuilder)"
    (aPane contents notEmpty and: [
        (aPane contents at: aPane contents size) == $\]) ifTrue: [
        aPane contents: aPane contents withCrs.
        aPane setSelectionFrom: aPane contents size to: aPane contents size.
    ].
    self updateSelectedItem.!   
methodChanged: aPane

    "Callback for the #display event in the EntryField named 'method'.
     (Generated by WindowBuilder)"

    self updateSelectedItem.!   
moveDown: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Move &Down').
     (Generated by WindowBuilder)"
    | index field |

    index := (self paneNamed: 'itemsList') selection.
    index = fields size ifTrue: [
        ^self
    ].

    field := fields at: index.
    fields removeIndex: index.
    fields add: field afterIndex: index.
    self
        changed: #getListContents:
        with: #restoreSelected:
        with: index + 1.!
moveUp: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'Move &Up').
     (Generated by WindowBuilder)"
    | index field |

    index := (self paneNamed: 'itemsList') selection.
    index = 1 ifTrue: [
        ^self
    ].

    field := fields at: index.
    fields removeIndex: index.
    fields add: field beforeIndex: index - 1.
    self
        changed: #getListContents:
        with: #restoreSelected:
        with: index - 1.! 
noAutoFieldWidth: aPane

    "Callback for the #clicked event in an unnamed RadioButton (contents is '').
     (Generated by WindowBuilder)"

    (self paneNamed: 'fieldWidth') enable.
    self updateSelectedItem.!  
ok: aPane

    "Callback for the #clicked event in an unnamed Button (contents is 'OK').
     (Generated by WindowBuilder)"

    | p |

    thePane := thePane fullCopy.
    p := thePane realPane.
    p fields: fields.
    p showHeader: (self paneNamed: 'showTitles') selection.
    p headerColor: (ColorConstants at: (self paneNamed: 'headerColor') selectedItem).

    self close.!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'CPColumnarListBoxEditor';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1426 @ 560; xC; yC; cRDU: (11 @ 550 rightBottom: 1415 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 603 @ 344; lDU: 786 r: #left; rDU: 1390 r: #left; tDU: 16 r: #top; bDU: 360 r: #top);
                    contents: 'Field Attributes';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 168; lDU: 1033 r: #left; rDU: 1371 r: #left; tDU: 176 r: #top; bDU: 344 r: #top);
                    contents: 'Field Width';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 213 @ 170; lDU: 805 r: #left; rDU: 1017 r: #left; tDU: 176 r: #top; bDU: 346 r: #top);
                    contents: 'Justification';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 215 @ 32; lDU: 786 r: #left; rDU: 1001 r: #left; tDU: 376 r: #top; bDU: 408 r: #top);
                    rightJustified;
                    contents: 'Header Color:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 130 @ 32; lDU: 805 r: #left; rDU: 935 r: #left; tDU: 120 r: #top; bDU: 152 r: #top);
                    contents: 'Method:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 103 @ 32; lDU: 830 r: #left; rDU: 933 r: #left; tDU: 62 r: #top; bDU: 94 r: #top);
                    contents: 'Label:';
                    yourself
            );
            addSubpane: (
                CPColumnarListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 750 @ 408; lDU: 18 r: #left; tDU: 16 r: #top);
                    paneName: 'itemsList';
                    headerColor: (ColorConstants at: 'ClrPalegray');
                    fields: (
                        OrderedCollection new
                        addLast: (
                            CPCLBField new
                                header: 'Field 1'
                        );
                        addLast: (
                            CPCLBField new
                                header: 'Field 2'
                        );
                        addLast: (
                            CPCLBField new
                                header: 'Field 3'
                        );
                        yourself
                    );
                    startGroup;
                    tabStop;
                    when: #getContents perform: #getListContents:;
                    when: #select perform: #selectedField:;
                    when: #getFields perform: #getListFields:;
                    yourself
            );
            addSubpane: (
                CPEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 430 @ 48; lDU: 942 r: #left; rDU: 1371 r: #left; tDU: 56 r: #top; bDU: 104 r: #top; indent: 3 @ 4);
                    paneName: 'label';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #labelChanged:;
                    yourself
            );
            addSubpane: (
                CPEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 430 @ 48; lDU: 942 r: #left; rDU: 1371 r: #left; tDU: 112 r: #top; bDU: 160 r: #top; indent: 3 @ 4);
                    paneName: 'method';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #methodChanged:;
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 40; lDU: 837 r: #left; rDU: 937 r: #left; tDU: 214 r: #top; bDU: 254 r: #top);
                    paneName: 'leftJustified';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #justificationChanged:;
                    contents: '&Left';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 123 @ 40; lDU: 837 r: #left; rDU: 960 r: #left; tDU: 252 r: #top; bDU: 292 r: #top);
                    paneName: 'rightJustified';
                    when: #clicked perform: #justificationChanged:;
                    contents: '&Right';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 142 @ 40; lDU: 837 r: #left; rDU: 978 r: #left; tDU: 290 r: #top; bDU: 330 r: #top);
                    paneName: 'centerJustified';
                    when: #clicked perform: #justificationChanged:;
                    contents: 'Ce&nter';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 40; lDU: 1051 r: #left; rDU: 1161 r: #left; tDU: 216 r: #top; bDU: 256 r: #top);
                    paneName: 'autoFieldWidth';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #autoFieldWidth:;
                    contents: '&Auto';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 142 @ 40; lDU: 1051 r: #left; rDU: 1193 r: #left; tDU: 256 r: #top; bDU: 296 r: #top);
                    paneName: 'noAutoFieldWidth';
                    when: #clicked perform: #noAutoFieldWidth:;
                    contents: 'Chars:';
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 48; lDU: 1198 r: #left; tDU: 256 r: #top);
                    paneName: 'fieldWidth';
                    max: 8000;
                    startGroup;
                    tabStop;
                    when: #valueChanged perform: #fieldWidthChanged:;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 375 @ 192; lDU: 1015 r: #left; rDU: 1390 r: #left; tDU: 368 r: #top; bDU: 560 r: #top);
                    paneName: 'headerColor';
                    dropDownList;
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 217 @ 40; lDU: 786 r: #left; rDU: 1003 r: #left; tDU: 440 r: #top; bDU: 480 r: #top);
                    paneName: 'showTitles';
                    startGroup;
                    tabStop;
                    contents: 'Show Titles';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 190 @ 58; lDU: 18 r: #left; rDU: 208 r: #left; tDU: 432 r: #top; bDU: 490 r: #top);
                    startGroup;
                    tabStop;
                    when: #clicked perform: #moveDown:;
                    contents: 'Move &Down';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 190 @ 58; lDU: 215 r: #left; rDU: 405 r: #left; tDU: 432 r: #top; bDU: 490 r: #top);
                    when: #clicked perform: #moveUp:;
                    contents: 'Move &Up';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 176 @ 58; lDU: 411 r: #left; rDU: 587 r: #left; tDU: 432 r: #top; bDU: 490 r: #top);
                    when: #clicked perform: #deleteItem:;
                    contents: 'D&elete';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 176 @ 58; lDU: 594 r: #left; rDU: 770 r: #left; tDU: 432 r: #top; bDU: 490 r: #top);
                    when: #clicked perform: #insertItem:;
                    contents: '&Insert';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 58; lDU: 1070 r: #left; rDU: 1225 r: #left; tDU: 432 r: #top; bDU: 490 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 151 @ 58; lDU: 1237 r: #left; rDU: 1387 r: #left; tDU: 432 r: #top; bDU: 490 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!   
preInitWindow

    | p |

    p := thePane realPane.

    fields :=p fields collect: [ :f |
        f deepCopy.
    ].

    fields notEmpty ifTrue: [
        selectedField := fields first.
    ].

    (self paneNamed: 'headerColor')
        contents: ColorConstants keys asSortedCollection;
        selection: (ColorConstants keyAtValue: p headerColor).

    (self paneNamed: 'showTitles') selection: p showHeader.! 
selectedField: aPane

    selectedField := aPane selectedItem.
    self updateEditors.!
updateEditors

    | selector |


    (self paneNamed: 'label') contents: selectedField header.
    selectedField selector notNil ifTrue: [
        selector := selectedField selector asString.
    ] ifFalse: [
        selector := ''.
    ].
    (self paneNamed: 'method') contents: selector.


    (self paneNamed: 'autoFieldWidth') selection: selectedField autoFieldWidth.
    (self paneNamed: 'noAutoFieldWidth') selection: selectedField autoFieldWidth not.
    selectedField autoFieldWidth ifFalse: [
        (self paneNamed: 'fieldWidth')
            enable;
            contents: selectedField fieldWidth.
    ] ifTrue: [
        (self paneNamed: 'fieldWidth') disable.
    ].

    (self paneNamed: 'leftJustified') selection: (selectedField justification = #left).
    (self paneNamed: 'rightJustified') selection: (selectedField justification = #right).
    (self paneNamed: 'centerJustified') selection: (selectedField justification = #center).!   
updateSelectedItem

    |  selector justification |

    selector := (self paneNamed: 'method') contents.
    (self isLegitimateSymbol: selector) ifFalse: [
        MessageBox message: selector, ' is not a valid method name'.
        ^false
    ].
    selector isEmpty ifTrue: [
        selector := nil.
    ].

    (self paneNamed: 'noAutoFieldWidth') selection ifTrue: [
        selectedField fieldWidth: (self paneNamed: 'fieldWidth') contents.
    ] ifFalse: [
        selectedField fieldWidth: nil.
    ].

    (self paneNamed: 'leftJustified') selection ifTrue: [
        justification := #left
    ] ifFalse: [
        (self paneNamed: 'rightJustified') selection ifTrue: [
            justification := #right
        ] ifFalse: [
            justification := #center
        ].
    ].


    selectedField
        header: (self paneNamed: 'label') contents trimBlanks;
        selector: selector;
        justification: justification.

    (self paneNamed: 'itemsList') refreshSelection.! !

! WBCPTimeEditorEditor methods !  
initWindow

    | p |

    p := thePane realPane.

    (self paneNamed: 'hour12') selection: p format == #hour12.
    (self paneNamed: 'hour24') selection: p format == #hour24.

    (self paneNamed: 'amString')
        setTextLimit: 8;
        contents: p amString.
    (self paneNamed: 'pmString')
        setTextLimit: 8;
        contents: p pmString.

    (self paneNamed: 'separator')
        setTextLimit: 1;
        contents: p separator.

    (self paneNamed: 'leadingZero') selection: p leadingZero.!  
ok: ignore

    | p |

    thePane := thePane fullCopy.
    p := thePane realPane.

    (self paneNamed: 'hour12') selection ifTrue: [
        p format: #hour12
    ] ifFalse: [
        p format: #hour24
    ].

    p amString: (self paneNamed: 'amString') contents
        pmString: (self paneNamed: 'pmString') contents.

    p separator: (self paneNamed: 'separator') contents.

    p leadingZero: (self paneNamed: 'leadingZero') selection.

    self close.! 
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'CPTimeEditor Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 613 @ 368; xC; yC; cRDU: (11 @ 358 rightBottom: 601 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 32; lDU: 9 r: #left; rDU: 174 r: #left; tDU: 136 r: #top; bDU: 168 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Separator:';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 384 @ 40; lDU: 18 r: #left; rDU: 402 r: #left; tDU: 16 r: #top; bDU: 56 r: #top);
                    paneName: 'hour12';
                    startGroup;
                    tabStop;
                    contents: '12 Hour (00:00 - 11:59)';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 384 @ 40; lDU: 18 r: #left; rDU: 402 r: #left; tDU: 72 r: #top; bDU: 112 r: #top);
                    paneName: 'hour24';
                    contents: '24 Hour (12:00 - 23:59)';
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 48; lDU: 402 r: #left; rDU: 576 r: #left; tDU: 16 r: #top; bDU: 64 r: #top; indent: 3 @ 4);
                    paneName: 'amString';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 48; lDU: 402 r: #left; rDU: 576 r: #left; tDU: 72 r: #top; bDU: 120 r: #top; indent: 3 @ 4);
                    paneName: 'pmString';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 55 @ 48; lDU: 183 r: #left; rDU: 238 r: #left; tDU: 128 r: #top; bDU: 176 r: #top; indent: 3 @ 4);
                    paneName: 'separator';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 480 @ 40; lDU: 18 r: #left; rDU: 498 r: #left; tDU: 184 r: #top; bDU: 224 r: #top);
                    paneName: 'leadingZero';
                    startGroup;
                    tabStop;
                    contents: 'Leading Zero (09:15 vs. 9:15)';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 58; lDU: 18 r: #left; rDU: 174 r: #left; tDU: 240 r: #top; bDU: 298 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 58; lDU: 183 r: #left; rDU: 338 r: #left; tDU: 240 r: #top; bDU: 298 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! !

! WBDateEditorEditor methods !
initWindow

    | p |

    p := thePane realPane.

    (self paneNamed: 'mdy') selection: p format == #mdy.
    (self paneNamed: 'dmy') selection: p format == #dmy.
    (self paneNamed: 'ymd') selection: p format == #ymd.

    (self paneNamed: 'separator')
        setTextLimit: 1;
        contents: p separator.

    (self paneNamed: 'dayLeadingZero') selection: p dayLeadingZero.
    (self paneNamed: 'monthLeadingZero') selection: p monthLeadingZero.
    (self paneNamed: 'century') selection: p century.!  
ok: ignore

    | p |

    thePane := thePane fullCopy.
    p := thePane realPane.

    #('mdy' 'dmy' 'ymd') do: [:f |
        (self paneNamed: f) selection ifTrue: [
            p format: f.
        ].
    ].

    p
        separator: (self paneNamed: 'separator') contents;
        dayLeadingZero: (self paneNamed: 'dayLeadingZero') selection;
        monthLeadingZero: (self paneNamed: 'monthLeadingZero') selection;
        century: (self paneNamed: 'century') selection.


    self close.!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'CPDateEditor Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 741 @ 304; xC; yC; cRDU: (11 @ 294 rightBottom: 729 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 160; lDU: 18 r: #left; rDU: 192 r: #left; tDU: 8 r: #top; bDU: 168 r: #top);
                    startGroup;
                    contents: 'Order';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 32; lDU: 457 r: #left; rDU: 622 r: #left; tDU: 192 r: #top; bDU: 224 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Separator:';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 40; lDU: 46 r: #left; rDU: 165 r: #left; tDU: 40 r: #top; bDU: 80 r: #top);
                    paneName: 'mdy';
                    startGroup;
                    tabStop;
                    contents: 'MDY';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 40; lDU: 46 r: #left; rDU: 165 r: #left; tDU: 80 r: #top; bDU: 120 r: #top);
                    paneName: 'dmy';
                    contents: 'DMY';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 40; lDU: 46 r: #left; rDU: 165 r: #left; tDU: 120 r: #top; bDU: 160 r: #top);
                    paneName: 'ymd';
                    contents: 'YMD';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 457 @ 40; lDU: 219 r: #left; rDU: 677 r: #left; tDU: 40 r: #top; bDU: 80 r: #top);
                    paneName: 'dayLeadingZero';
                    startGroup;
                    tabStop;
                    contents: 'Day Leading Zero (07 vs. 7)';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 489 @ 40; lDU: 219 r: #left; rDU: 709 r: #left; tDU: 80 r: #top; bDU: 120 r: #top);
                    paneName: 'monthLeadingZero';
                    startGroup;
                    tabStop;
                    contents: 'Month Leading Zero (02 vs. 2)';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 366 @ 40; lDU: 219 r: #left; rDU: 585 r: #left; tDU: 120 r: #top; bDU: 160 r: #top);
                    paneName: 'century';
                    startGroup;
                    tabStop;
                    contents: 'Century (1990 vs. 90)';
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 73 @ 48; lDU: 631 r: #left; rDU: 704 r: #left; tDU: 184 r: #top; bDU: 232 r: #top; indent: 3 @ 4);
                    paneName: 'separator';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 171 @ 56; lDU: 18 r: #left; rDU: 190 r: #left; tDU: 184 r: #top; bDU: 240 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 171 @ 56; lDU: 210 r: #left; rDU: 382 r: #left; tDU: 184 r: #top; bDU: 240 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! !

! WBDialogEditor methods !  
initWindow

    | theStyle |

    theStyle := thePane style.

    (self paneNamed: 'systemMenu') selection: (theStyle includes: #sysmenu).
    (self paneNamed: 'systemModal') selection: (theStyle includes: #sysmodal).
    (self paneNamed: 'titleBar') selection: (theStyle includes: #titlebar).
    (self paneNamed: 'modal') selection: (theStyle includes: #modal).! 
ok: aPane

    | s |

    s := Set new.

    (self paneNamed: 'systemMenu') selection ifTrue: [
        s add: #sysmenu.
    ].

    (self paneNamed: 'titleBar') selection ifTrue: [
        s add: #titlebar.
    ].

    (self paneNamed: 'systemModal') selection ifTrue: [
        s add: #sysmodal.
    ].

    (self paneNamed: 'modal') selection ifTrue: [
        s add: #modal.
    ].

    thePane := thePane fullCopy.

    thePane style: s.


    super close.! 
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Window Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 594 @ 256; xC; yC; cRDU: (11 @ 246 rightBottom: 583 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                StaticBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 530 @ 4; lDU: 18 r: #left; rDU: 549 r: #left; tDU: 112 r: #top; bDU: 116 r: #top);
                    blackRectangle;
                    startGroup;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 295 @ 40; lDU: 18 r: #left; rDU: 313 r: #left; tDU: 16 r: #top; bDU: 56 r: #top);
                    paneName: 'systemMenu';
                    startGroup;
                    tabStop;
                    contents: '&System menu';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 313 @ 40; lDU: 293 r: #left; rDU: 606 r: #left; tDU: 16 r: #top; bDU: 56 r: #top);
                    paneName: 'systemModal';
                    startGroup;
                    tabStop;
                    contents: 'S&ystem modal';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 176 @ 40; lDU: 293 r: #left; rDU: 469 r: #left; tDU: 62 r: #top; bDU: 102 r: #top);
                    paneName: 'modal';
                    startGroup;
                    tabStop;
                    contents: '&Modal';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 56; lDU: 18 r: #left; rDU: 210 r: #left; tDU: 128 r: #top; bDU: 184 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 224 @ 40; lDU: 18 r: #left; rDU: 242 r: #left; tDU: 62 r: #top; bDU: 102 r: #top);
                    paneName: 'titleBar';
                    startGroup;
                    tabStop;
                    contents: '&Title bar';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 56; lDU: 229 r: #left; rDU: 421 r: #left; tDU: 128 r: #top; bDU: 184 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! !

! WBEnhancedEntryFieldEditor methods !   
caseDict

    ^Dictionary new
        at: 'UPPER' put: #UPPER;
        at: 'lower' put: #lower;
        at: 'Proper' put: #Proper;
        at: 'Unchanged' put: nil;
        yourself! 
getCase: aPane

    aPane contents: self caseDict keys asSortedCollection asArray!  
getCharacter: aPane

    | list |
    list := OrderedCollection new.
    list
        add: self noneString;
        addAll: EnhancedEntryField okCharacterMethods.
    aPane contents: list!   
getField: aPane

    | list |
    list := OrderedCollection new.
    list
        add: self noneString;
        addAll: EnhancedEntryField okFieldMethods.
    aPane contents: list!   
getFocus: aPane

    aPane contents: self getFocusDict keys asSortedCollection asArray! 
getFocusDict

    ^Dictionary new
        at: 'Select All' put: #selectAll;
        at: 'Cursor Before' put: #selectFirst;
        at: 'Cursor After' put: #selectLast;
        yourself!   
getJustification: aPane

    aPane contents: self justificationDict keys asSortedCollection asArray!
initWindow

    | function |
    (self paneNamed: 'case') selectItem: (self caseDict keyAtValue: thePane case).
    (self paneNamed: 'justification') selectItem: (self justificationDict keyAtValue: thePane justification).
    (self paneNamed: 'getFocus') selectItem: (self getFocusDict keyAtValue: thePane getFocus).

    (self paneNamed: 'size') contents: thePane maximumSize asString.
    (self paneNamed: 'autoTab') selection: thePane autoTab.

    thePane character isNil ifTrue: [
        function := self noneString
    ] ifFalse: [
        function := thePane character copyFrom: 3 to: thePane character size - 1
    ].
    (self paneNamed: 'character') selectItem: function.

    thePane field isNil ifTrue: [
        function := self noneString
    ] ifFalse: [
        function := thePane field copyFrom: 3 to: thePane field size
    ].
    (self paneNamed: 'field') selectItem: function.

    self supportsAutoTab ifFalse: [
        (self paneNamed: 'autoTab') hideWindow
    ].
    self supportsJustification ifFalse: [
        (self paneNamed: 'justText') disable.
        (self paneNamed: 'justification') disable
    ].! 
justificationDict

    ^Dictionary new
        at: 'Left' put: #left;
        at: 'Right' put: #right;
        at: 'Centered' put: #centered;
        yourself! 
noneString

    ^'- None -'!
ok: aPane

    | function |
    thePane case: (self caseDict at: (self paneNamed: 'case') selectedItem).
    thePane justification: (self justificationDict at: (self paneNamed: 'justification') selectedItem).
    thePane getFocus: (self getFocusDict at: (self paneNamed: 'getFocus') selectedItem).

    thePane maximumSize: (self paneNamed: 'size') contents asInteger.
    thePane autoTab: (self paneNamed: 'autoTab') selection.

    function := (self paneNamed: 'character') selectedItem.
    function = self noneString ifTrue: [
        thePane character: nil
    ] ifFalse: [
        thePane character: ('ok',function,':') asSymbol
    ].

    function := (self paneNamed: 'field') selectedItem.
    function = self noneString ifTrue: [
        thePane field: nil
    ] ifFalse: [
        thePane field: ('ok',function) asSymbol
    ].

    self close!   
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'EnhancedEntryField Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 859 @ 648; lDU: 302 r: #left; tDU: 234 r: #top; cRDU: (11 @ 638 rightBottom: 848 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 805 @ 336; lDU: 18 r: #left; rDU: 823 r: #left; tDU: 184 r: #top; bDU: 520 r: #top);
                    startGroup;
                    contents: 'Validation';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 32; lDU: 37 r: #left; rDU: 201 r: #left; tDU: 224 r: #top; bDU: 256 r: #top);
                    startGroup;
                    contents: 'Character:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 91 @ 32; lDU: 427 r: #left; rDU: 519 r: #left; tDU: 224 r: #top; bDU: 256 r: #top);
                    startGroup;
                    contents: 'Field:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 32; lDU: 366 r: #left; rDU: 530 r: #left; tDU: 536 r: #top; bDU: 568 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Max Size:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 169 @ 32; lDU: 265 r: #left; rDU: 434 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    startGroup;
                    contents: 'Get Focus:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 32; lDU: 18 r: #left; rDU: 219 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    paneName: 'justText';
                    startGroup;
                    contents: 'Justification:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 32; lDU: 567 r: #left; rDU: 667 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    startGroup;
                    contents: 'Case:';
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 229 @ 144; lDU: 18 r: #left; rDU: 247 r: #left; tDU: 40 r: #top; bDU: 184 r: #top);
                    paneName: 'justification';
                    startGroup;
                    tabStop;
                    when: #getContents perform: #getJustification:;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 283 @ 144; lDU: 265 r: #left; rDU: 549 r: #left; tDU: 40 r: #top; bDU: 184 r: #top);
                    paneName: 'getFocus';
                    startGroup;
                    tabStop;
                    when: #getContents perform: #getFocus:;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 256 @ 144; lDU: 567 r: #left; rDU: 823 r: #left; tDU: 40 r: #top; bDU: 184 r: #top);
                    paneName: 'case';
                    startGroup;
                    tabStop;
                    when: #getContents perform: #getCase:;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 373 @ 248; lDU: 39 r: #left; rDU: 411 r: #left; tDU: 256 r: #top; bDU: 504 r: #top);
                    paneName: 'character';
                    startGroup;
                    tabStop;
                    when: #getContents perform: #getCharacter:;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 366 @ 248; lDU: 430 r: #left; rDU: 795 r: #left; tDU: 256 r: #top; bDU: 504 r: #top);
                    paneName: 'field';
                    startGroup;
                    tabStop;
                    when: #getContents perform: #getField:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 101 @ 48; lDU: 539 r: #left; rDU: 640 r: #left; tDU: 528 r: #top; bDU: 576 r: #top; indent: 3 @ 4);
                    paneName: 'size';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 40; lDU: 649 r: #left; rDU: 823 r: #left; tDU: 528 r: #top; bDU: 568 r: #top);
                    paneName: 'autoTab';
                    startGroup;
                    tabStop;
                    contents: 'Auto &Tab';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 56; lDU: 18 r: #left; rDU: 183 r: #left; tDU: 528 r: #top; bDU: 584 r: #top);
                    paneName: 'ok';
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 56; lDU: 192 r: #left; rDU: 357 r: #left; tDU: 528 r: #top; bDU: 584 r: #top);
                    paneName: 'cancel';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!  
supportsAutoTab

    ^false!
supportsJustification

    ^false! !

! WBFileSelectorEditor class methods !  
titled: titleString filters: filterCollection descriptions: descCollection
    | new |
    new := super new.
    new
        title: titleString;
        filters: filterCollection;
        descriptions: descCollection.
    ^new! !

! WBFileSelectorEditor methods !  
descriptions: aCollection

    descriptions := aCollection! 
filters: aCollection

    filters := aCollection!   
initialize

    title := 'Select File'.
    filters := OrderedCollection with: '*.*'.
    descriptions := OrderedCollection with: 'All Files (*.*)'.! 
open

    | file contents |

    contents := thePane contents.
    ((contents includes: $*) not and: [ File exists: contents ])
        ifTrue: [ contents := (File splitPath: contents in: Disk) at: 3 ]
        ifFalse: [ contents := filters first ].
    fileDialog := FileDialog new.
    fileDialog
            title: title;
            fileSpec: contents;
            hideReadonly.
    1 to: filters size do: [ :i |
        fileDialog addFilter: (filters at: i) description: (descriptions at: i) ].

    fileDialog open.

    file := fileDialog file.
    file isNil
        ifFalse: [ thePane contents: file ].!  
title: anObject

    title := anObject! !

! WBHierarchicalListBoxEditor methods !
getMethodName: rawName

    | name |

    name := rawName trimBlanks.
    (name size > 0 and: [ name first = $# ]) ifTrue: [
        name := name copyFrom: 2 to: name size.
    ].

    name do: [ :c |
        c isAlphaNumeric not ifTrue: [
            MessageBox message: name, ' is an invalid selector'.
            ^true
        ].
    ].

    name size = 0 ifTrue: [
        ^nil
    ].

    ^name asSymbol!
initWindow

    (self paneNamed: 'nameAccessor') contents: thePane nameMethod.
    (self paneNamed: 'childAccessor') contents: thePane childrenMethod.
    (self paneNamed: 'iconAccessor') contents: thePane iconMethod.!
ok: ignore

    | nameMethod childrenMethod iconMethod |

    ((nameMethod := self getMethodName: (self paneNamed: 'nameAccessor') contents) = false) ifTrue: [
        ^self
    ].
    ((childrenMethod := self getMethodName: (self paneNamed: 'childAccessor') contents) = false) ifTrue: [
        ^self
    ].
    ((iconMethod := self getMethodName: (self paneNamed: 'iconAccessor') contents) = false) ifTrue: [
        ^self
    ].

    thePane := thePane fullCopy.

    thePane
        nameMethod: nameMethod;
        childrenMethod: childrenMethod;
        iconMethod: iconMethod.

    self close!  
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Hierarchical ListBox Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 686 @ 376; xC; yC; cRDU: (11 @ 366 rightBottom: 674 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 293 @ 32; lDU: 9 r: #left; rDU: 302 r: #left; tDU: 128 r: #top; bDU: 160 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Children Accessor:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 256 @ 32; lDU: 46 r: #left; rDU: 302 r: #left; tDU: 72 r: #top; bDU: 104 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Name Accessor:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 229 @ 32; lDU: 73 r: #left; rDU: 302 r: #left; tDU: 184 r: #top; bDU: 216 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Icon Accessor:';
                    yourself
            );
            addSubpane: (
                StaticBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 631 @ 4; lDU: 18 r: #left; rDU: 649 r: #left; tDU: 242 r: #top; bDU: 246 r: #top);
                    blackRectangle;
                    startGroup;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 494 @ 32; lDU: 91 r: #left; rDU: 585 r: #left; tDU: 16 r: #top; bDU: 48 r: #top);
                    startGroup;
                    contents: 'Messages to Objects In ListBox:';
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 48; lDU: 311 r: #left; rDU: 649 r: #left; tDU: 64 r: #top; bDU: 112 r: #top; indent: 3 @ 4);
                    paneName: 'nameAccessor';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 48; lDU: 311 r: #left; rDU: 649 r: #left; tDU: 120 r: #top; bDU: 168 r: #top; indent: 3 @ 4);
                    paneName: 'childAccessor';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 338 @ 48; lDU: 311 r: #left; rDU: 649 r: #left; tDU: 176 r: #top; bDU: 224 r: #top; indent: 3 @ 4);
                    paneName: 'iconAccessor';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 56; lDU: 18 r: #left; rDU: 174 r: #left; tDU: 256 r: #top; bDU: 312 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 56; lDU: 192 r: #left; rDU: 347 r: #left; tDU: 256 r: #top; bDU: 312 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! !

! WBLinkEditor class methods !  
descriptions

    Descriptions isNil ifTrue: [
        (Descriptions := Dictionary new)
            at: 'Independent' put:
'Opens the selected
window with no
parent.';
            at: 'Child' put:
'Opens the selected
window as a child of
the current window.';
            at: 'MDIChild' put:
'Opens the selected
window as an MDI
child of the current
MDI parent window.';
            at: 'Sibling' put:
'Opens the selected
window as a child of
the current window''s
parent.'.
    ].
    ^Descriptions!   
descriptions: aDictionary
    " WBLinkEditor descriptions: nil "
    Descriptions := aDictionary! !

! WBLinkEditor methods ! 
initWindow

    | listPane typePane |
    link := thePane link.
    type := thePane type.
    (self paneNamed: 'typeDescription') disable.
    (listPane := self paneNamed: 'list') contents: self viableClasses.
    link isNil ifFalse: [
        listPane selectItem: link.
        self select: listPane
    ].!
ok: aPane

    thePane link: (self paneNamed: 'list') selectedItem.
    thePane type: (self paneNamed: 'types') selectedItem.
    (thePane isInterfaceObject and: [ thePane link notNil ]) ifTrue: [
        thePane contents: thePane link,'...'
    ].

    self close! 
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Link Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 850 @ 476; lDU: 286 r: #left; tDU: 282 r: #top; cRDU: (297 @ 748 rightBottom: 1125 @ 330));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 357 @ 316; lDU: 457 r: #left; rDU: 814 r: #left; tDU: 28 r: #top; bDU: 344 r: #top);
                    startGroup;
                    contents: 'Link Type';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 421 @ 32; lDU: 14 r: #left; rDU: 434 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    startGroup;
                    contents: 'Select a ViewManger Class:';
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 320 @ 108; lDU: 475 r: #left; rDU: 795 r: #left; tDU: 68 r: #top; bDU: 176 r: #top);
                    paneName: 'types';
                    contents: #( 'Independent' 'Child' 'Sibling' );
                    startGroup;
                    when: #select perform: #selectType:;
                    when: #doubleClickSelect perform: #ok:;
                    yourself
            );
            addSubpane: (
                TextEdit new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 320 @ 148; lDU: 475 r: #left; rDU: 795 r: #left; tDU: 184 r: #top; bDU: 332 r: #top);
                    paneName: 'typeDescription';
                    startGroup;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 421 @ 364; lDU: 18 r: #left; rDU: 439 r: #left; tDU: 44 r: #top; bDU: 408 r: #top);
                    paneName: 'list';
                    startGroup;
                    tabStop;
                    when: #select perform: #select:;
                    when: #doubleClickSelect perform: #ok:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 169 @ 56; lDU: 457 r: #left; rDU: 626 r: #left; tDU: 352 r: #top; bDU: 408 r: #top);
                    paneName: 'ok';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 169 @ 56; lDU: 645 r: #left; rDU: 814 r: #left; tDU: 352 r: #top; bDU: 408 r: #top);
                    paneName: 'cancel';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! 
select: aPane
    | typePane |
    ((Smalltalk at: aPane selectedItem asSymbol) methodDictionary keys includes: #open) ifFalse: [
        (Smalltalk includesKey: #MDISystem) ifTrue: [
            (typePane := self paneNamed: 'types') contents: #('Independent' 'Child' 'Sibling' 'MDIChild')
        ] ifFalse: [
            (typePane := self paneNamed: 'types') contents: #('Independent' 'Child' 'Sibling')
        ].
    ] ifTrue: [
        (typePane := self paneNamed: 'types') contents: #('Independent')
    ].
    typePane selectItem: type asString.
    typePane selectedItem isNil ifTrue: [ typePane selectIndex: 1 ].
    self selectType: typePane.!
selectType: aPane

    (self paneNamed: 'typeDescription') contents:
        (self class descriptions at: aPane selectedItem)! 
viableClasses

    ^(ViewManager wbCreatedClasses collect: [ :aClass |
        aClass name ]) asSortedCollection asOrderedCollection.! !

! WBListEditor methods !   
add: aPane

    list add: item contents.
    listBox contents: list.
    item selectAll; setFocus.!   
change: aPane

    listBox selection isNil ifTrue: [ ^nil ].
    list at: listBox selection put: item contents.
    listBox contents: list.
    self disable.!   
delete: aPane

    Notifier isAltDown
        ifTrue: [ list := OrderedCollection new ]
        ifFalse: [
            listBox selection isNil ifTrue: [ ^nil ].
            list removeIndex: listBox selection].
    listBox contents: list.
    self disable.! 
disable

    (self paneNamed: #insert) disable.
    (self paneNamed: #change) disable.
    (self paneNamed: #delete) disable.
    item setFocus.!
enable

    (self paneNamed: #insert) enable.
    (self paneNamed: #change) enable.
    (self paneNamed: #delete) enable.!
initWindow

    list := thePane contents.
    list isNil
        ifTrue: [ list := OrderedCollection new ]
        ifFalse: [ list := list asOrderedCollection].
    (listBox := self paneNamed: 'list') contents: list.
    item := self paneNamed: #item!
insert: aPane

    listBox selection isNil ifTrue: [ ^nil ].
    list add: item contents beforeIndex: listBox selection.
    listBox contents: list.
    self disable.!  
ok: ignore

    thePane
        contents: list asArray.

    self close! 
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'List Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 823 @ 432; lDU: 459 r: #left; tDU: 236 r: #top; cRDU: (11 @ 422 rightBottom: 811 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 558 @ 48; lDU: 18 r: #left; rDU: 576 r: #left; tDU: 16 r: #top; bDU: 64 r: #top; indent: 3 @ 4);
                    paneName: 'item';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 555 @ 224; lDU: 21 r: #left; rDU: 576 r: #left; tDU: 80 r: #top; bDU: 304 r: #top);
                    paneName: 'list';
                    startGroup;
                    tabStop;
                    when: #select perform: #select:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 56; lDU: 594 r: #left; rDU: 777 r: #left; tDU: 16 r: #top; bDU: 72 r: #top);
                    paneName: 'add';
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #add:;
                    contents: '&Add';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 56; lDU: 594 r: #left; rDU: 777 r: #left; tDU: 80 r: #top; bDU: 136 r: #top);
                    paneName: 'insert';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #insert:;
                    contents: '&Insert';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 56; lDU: 594 r: #left; rDU: 777 r: #left; tDU: 144 r: #top; bDU: 200 r: #top);
                    paneName: 'change';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #change:;
                    contents: '&Change';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 56; lDU: 594 r: #left; rDU: 777 r: #left; tDU: 208 r: #top; bDU: 264 r: #top);
                    paneName: 'delete';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #delete:;
                    contents: '&Delete';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 56; lDU: 594 r: #left; rDU: 777 r: #left; tDU: 312 r: #top; bDU: 368 r: #top);
                    paneName: 'sort';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #sort:;
                    contents: '&Sort';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 56; lDU: 21 r: #left; rDU: 185 r: #left; tDU: 312 r: #top; bDU: 368 r: #top);
                    paneName: 'ok';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 56; lDU: 201 r: #left; rDU: 366 r: #left; tDU: 312 r: #top; bDU: 368 r: #top);
                    paneName: 'cancel';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!
select: aPane

    item contents: listBox selectedItem; setFocus.
    self enable.!
sort: aPane

    list := list asSortedCollection asOrderedCollection.
    listBox  contents: list.! !

! WBScrollBarEditor methods ! 
close
  ^self cancel: nil!   
initWindow

    (self paneNamed: 'lineInc') contents: thePane lineIncrement asString.
    (self paneNamed: 'pageInc') contents: thePane pageIncrement asString.
    (self paneNamed: 'minimum') contents: thePane minimum asString.
    (self paneNamed: 'maximum') contents: thePane maximum asString.! 
ok: ignore

    thePane
        lineIncrement: (self paneNamed: 'lineInc') contents asInteger;
        pageIncrement: (self paneNamed: 'pageInc') contents asInteger;
        minimum: (self paneNamed: 'minimum') contents asInteger;
        maximum: (self paneNamed: 'maximum') contents asInteger.

    self close!  
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Scroll Bar Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 503 @ 368; xC; yC; cRDU: (11 @ 358 rightBottom: 491 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 210 @ 32; lDU: 55 r: #left; rDU: 265 r: #left; tDU: 136 r: #top; bDU: 168 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Minimum:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 32; lDU: 64 r: #left; rDU: 265 r: #left; tDU: 192 r: #top; bDU: 224 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Maximum:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 256 @ 32; lDU: 9 r: #left; rDU: 265 r: #left; tDU: 80 r: #top; bDU: 112 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Page increment:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 249 @ 32; lDU: 18 r: #left; rDU: 267 r: #left; tDU: 24 r: #top; bDU: 56 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Line increment:';
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 48; lDU: 274 r: #left; rDU: 466 r: #left; tDU: 16 r: #top; bDU: 64 r: #top; indent: 3 @ 4);
                    paneName: 'lineInc';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 48; lDU: 274 r: #left; rDU: 466 r: #left; tDU: 72 r: #top; bDU: 120 r: #top; indent: 3 @ 4);
                    paneName: 'pageInc';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 48; lDU: 274 r: #left; rDU: 466 r: #left; tDU: 128 r: #top; bDU: 176 r: #top; indent: 3 @ 4);
                    paneName: 'minimum';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 48; lDU: 274 r: #left; rDU: 466 r: #left; tDU: 184 r: #top; bDU: 232 r: #top; indent: 3 @ 4);
                    paneName: 'maximum';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 56; lDU: 18 r: #left; rDU: 238 r: #left; tDU: 248 r: #top; bDU: 304 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 56; lDU: 247 r: #left; rDU: 466 r: #left; tDU: 248 r: #top; bDU: 304 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! !

! WBStaticTextEditor methods !   
initWindow

    (self paneNamed: 'text')
        contents: thePane contents;
        setFocus;
        selectAll.!   
ok: ignore
    | contents |
    contents := (self paneNamed: 'text') contents.
    thePane
        contents:  (contents copyFrom: 1 to: contents size - 2).

    self close!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Static Text Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 905 @ 424; xC; yC; cRDU: (11 @ 414 rightBottom: 894 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                TextPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 864 @ 284; lDU: 9 r: #left; rDU: 873 r: #left; tDU: 8 r: #top; bDU: 292 r: #top);
                    paneName: 'text';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 56; lDU: 9 r: #left; rDU: 210 r: #left; tDU: 304 r: #top; bDU: 360 r: #top);
                    idOK;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 56; lDU: 219 r: #left; rDU: 421 r: #left; tDU: 304 r: #top; bDU: 360 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! !

! WBStatusPaneEditor methods !
copy: aPane

    | index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    clipboard := boxes at: index .
    (self paneNamed: 'paste') enable.! 
down: aPane

    | box index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    box := boxes at: index.
    index == boxes size ifTrue: [ ^nil ].
    boxes removeIndex: index.
    boxes add: box afterIndex: index.
    list
        contents: (boxes collect: [ :box | box name asString ]);
        selection: index + 1.

    self updateBoxes.!  
initWindow

    list contents: (boxes collect: [ :box | box name asString ]).

    (self paneNamed: 'paste') disable.
    (self paneNamed: 'auto') selection: true.

    boxes isEmpty ifFalse: [
        list selection: 1.
        self selectBox: list
    ] ifTrue: [
        self updateBoxes.
    ].!   
insert: aPane

    | index |
    index := list selection.

    box := (Smalltalk at: #StatusBox) new
        name: '';
        width: 10;
        space: 7;
        contents: '';
        yourself.

    index isNil ifTrue: [
        boxes add: box.
        index := boxes size.
    ] ifFalse: [
        boxes add: box afterIndex: index.
        index := index + 1.
    ].
    list
        contents: (boxes collect: [ :box | box name asString ]);
        selection: index.

    (self paneNamed: 'name') contents: ''.
    (self paneNamed: 'width') contents: '10'.
    (self paneNamed: 'space') contents: '7'.
    (self paneNamed: 'contents') setContents: ''.

    self updateBoxes.!
ok: aPane

    thePane statusBoxes: boxes.

    self close!   
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'StatusPane Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1097 @ 432; xC; yC; cRDU: (11 @ 422 rightBottom: 1086 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 576 @ 352; lDU: 9 r: #left; rDU: 585 r: #left; tDU: 8 r: #top; bDU: 360 r: #top);
                    startGroup;
                    contents: 'Status Boxes';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 457 @ 272; lDU: 603 r: #left; rDU: 1061 r: #left; tDU: 8 r: #top; bDU: 280 r: #top);
                    startGroup;
                    contents: 'StatusBox';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 658 r: #left; rDU: 768 r: #left; tDU: 56 r: #top; bDU: 88 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Name:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 658 r: #left; rDU: 768 r: #left; tDU: 168 r: #top; bDU: 200 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Width:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 658 r: #left; rDU: 768 r: #left; tDU: 224 r: #top; bDU: 256 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Space:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 613 r: #left; rDU: 768 r: #left; tDU: 112 r: #top; bDU: 144 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Contents:';
                    yourself
            );
            addSubpane: (
                WBListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 357 @ 216; lDU: 27 r: #left; rDU: 384 r: #left; tDU: 48 r: #top; bDU: 264 r: #top);
                    paneName: 'boxes';
                    startGroup;
                    tabStop;
                    when: #select perform: #selectBox:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 393 r: #left; rDU: 567 r: #left; tDU: 48 r: #top; bDU: 112 r: #top);
                    paneName: 'insert';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #insert:;
                    contents: '&Insert';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 393 r: #left; rDU: 567 r: #left; tDU: 128 r: #top; bDU: 192 r: #top);
                    paneName: 'copy';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #copy:;
                    contents: '&Copy';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 393 r: #left; rDU: 567 r: #left; tDU: 200 r: #top; bDU: 264 r: #top);
                    paneName: 'paste';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #paste:;
                    contents: '&Paste';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 27 r: #left; rDU: 201 r: #left; tDU: 280 r: #top; bDU: 344 r: #top);
                    paneName: 'up';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #up:;
                    contents: '&Up';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 210 r: #left; rDU: 384 r: #left; tDU: 280 r: #top; bDU: 344 r: #top);
                    paneName: 'down';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #down:;
                    contents: '&Down';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 393 r: #left; rDU: 567 r: #left; tDU: 280 r: #top; bDU: 344 r: #top);
                    paneName: 'remove';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #remove:;
                    contents: '&Remove';
                    yourself
            );
            addSubpane: (
                EnhancedEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 265 @ 48; lDU: 777 r: #left; rDU: 1042 r: #left; tDU: 48 r: #top; bDU: 96 r: #top; indent: 3 @ 4);
                    paneName: 'name';
                    character: #okAlphaNumericNoSpace:;
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setName:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 265 @ 48; lDU: 777 r: #left; rDU: 1042 r: #left; tDU: 104 r: #top; bDU: 152 r: #top; indent: 3 @ 4);
                    paneName: 'contents';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setContents:;
                    yourself
            );
            addSubpane: (
                EnhancedEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 48; lDU: 777 r: #left; rDU: 923 r: #left; tDU: 160 r: #top; bDU: 208 r: #top; indent: 3 @ 4);
                    paneName: 'width';
                    maxSize: 4;
                    character: #okInteger:;
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setWidth:;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 40; lDU: 933 r: #left; rDU: 1042 r: #left; tDU: 168 r: #top; bDU: 208 r: #top);
                    paneName: 'auto';
                    startGroup;
                    tabStop;
                    contents: 'Auto';
                    yourself
            );
            addSubpane: (
                EnhancedEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 48; lDU: 777 r: #left; rDU: 923 r: #left; tDU: 216 r: #top; bDU: 264 r: #top; indent: 3 @ 4);
                    paneName: 'space';
                    maxSize: 4;
                    character: #okInteger:;
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setSpace:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 64; lDU: 759 r: #left; rDU: 905 r: #left; tDU: 296 r: #top; bDU: 360 r: #top);
                    paneName: 'ok';
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 64; lDU: 914 r: #left; rDU: 1061 r: #left; tDU: 296 r: #top; bDU: 360 r: #top);
                    paneName: 'cancel';
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!   
paste: aPane

    | index |
    index := list selection.
    index isNil ifTrue: [
        boxes add: clipboard deepCopy.
        index := boxes size.
    ] ifFalse: [
        boxes add: clipboard deepCopy beforeIndex: index
    ].
    list
        contents: (boxes collect: [ :box | box name asString ]);
        selection: index.

    self updateBoxes.! 
preInitWindow

    boxes := thePane statusBoxes deepCopy.
    list := self paneNamed: 'boxes'.!
remove: aPane

    | index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    boxes removeIndex: index.
    list
        contents: (boxes collect: [ :box | box name asString ]);
        selection: (index min: boxes size).

    self updateBoxes.! 
selectBox: aPane

    | box |
    box := boxes at: aPane selection.
    (self paneNamed: 'name') contents: box name asString.
    (self paneNamed: 'width') contents: box width asString.
    (self paneNamed: 'space') contents: box space asString.
    (self paneNamed: 'contents') setContents: box contents.

    self updateBoxes.!
setContents: aPane

    | box width |
    box := boxes at: list selection.
    box contents: aPane contents.

    (self paneNamed: 'auto') selection ifTrue: [
        (self paneNamed: 'width') contents:
            (width := thePane font wbStringWidth: aPane contents) asString.
        box width: width
    ].! 
setName: aPane
    "Touched by Ale for patching when selection is nil..."
    | box index |

    index := list selection.
    index isNil ifTrue: [UserLibrary messageBeep: 0.^nil].
    box :=boxes at: index.
    box name: aPane contents.
    list
        contents: (boxes collect: [ :box | box name asString ]);
        selection: index.!  
setSpace: aPane

    | box |
    box := boxes at: list selection.
    box space: aPane contents asInteger.!   
setWidth: aPane

    | box |
    box :=boxes at: list selection.
    box width: aPane contents asInteger.!
up: aPane

    | box index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    box := boxes at: index.
    index == 1 ifTrue: [ ^nil ].
    boxes removeIndex: index.
    boxes add: box beforeIndex: index - 1.
    list
        contents: (boxes collect: [ :box | box name asString ]);
        selection: index - 1.

    self updateBoxes.!
updateBoxes

    boxes isEmpty ifTrue: [
        (self paneNamed: 'remove') disable.
        (self paneNamed: 'copy') disable.
        (self paneNamed: 'up') disable.
        (self paneNamed: 'down') disable.
        ^nil
    ] ifFalse: [
        (self paneNamed: 'remove') enable.
        (self paneNamed: 'copy') enable.
    ].
    list selection == boxes size ifTrue: [
        (self paneNamed: 'down') disable
    ] ifFalse: [
        (self paneNamed: 'down') enable
    ].
    list selection == 1 ifTrue: [
        (self paneNamed: 'up') disable
    ] ifFalse: [
        (self paneNamed: 'up') enable
    ].! !

! WBTableEditorEditor methods !   
ok: aPane

    | p  |

    thePane := thePane fullCopy.
    p := thePane realPane.

    p
        rows: (self paneNamed: 'rows') contents;
        columns: (self paneNamed: 'columns') contents;
        headerColor: (ColorConstants at: 'Clr', (self paneNamed: 'colors') selectedItem);
        cellWidth: (self paneNamed: 'cellWidth') contents;
        showRowHeader:  (self paneNamed: 'showRowHeader') selection;
        showColumnHeader: (self paneNamed: 'showColumnHeader') selection;
        showGrid: (self paneNamed: 'showGrid') selection;
        sparseStorage: (self paneNamed: 'sparseStorage') selection.

    self close.!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'CPTableEditor Editor';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 832 @ 352; xC; yC; cRDU: (11 @ 342 rightBottom: 821 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 357 @ 216; lDU: 18 r: #left; rDU: 375 r: #left; tDU: 8 r: #top; bDU: 224 r: #top);
                    startGroup;
                    contents: 'Sizes';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 402 @ 216; lDU: 393 r: #left; rDU: 795 r: #left; tDU: 8 r: #top; bDU: 224 r: #top);
                    startGroup;
                    contents: 'Options';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 103 @ 32; lDU: 110 r: #left; rDU: 213 r: #left; tDU: 56 r: #top; bDU: 88 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Rows:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 32; lDU: 64 r: #left; rDU: 210 r: #left; tDU: 112 r: #top; bDU: 144 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Columns:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 210 @ 32; lDU: 338 r: #left; rDU: 549 r: #left; tDU: 240 r: #top; bDU: 272 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Header Color:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 32; lDU: 37 r: #left; rDU: 210 r: #left; tDU: 168 r: #top; bDU: 200 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Cell Width:';
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 135 @ 48; lDU: 219 r: #left; tDU: 48 r: #top);
                    paneName: 'rows';
                    min: 1;
                    max: 1000;
                    contents: 1;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 135 @ 48; lDU: 219 r: #left; tDU: 104 r: #top);
                    paneName: 'columns';
                    min: 1;
                    max: 600;
                    contents: 1;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CPNumericEditor new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 135 @ 48; lDU: 219 r: #left; tDU: 160 r: #top);
                    paneName: 'cellWidth';
                    max: 8000;
                    startGroup;
                    tabStop;
                    backColor: ClrPalegray;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 315 @ 40; lDU: 411 r: #left; rDU: 727 r: #left; tDU: 48 r: #top; bDU: 88 r: #top);
                    paneName: 'showRowHeader';
                    startGroup;
                    tabStop;
                    contents: 'Show Row Header';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 363 @ 40; lDU: 411 r: #left; rDU: 775 r: #left; tDU: 88 r: #top; bDU: 128 r: #top);
                    paneName: 'showColumnHeader';
                    startGroup;
                    tabStop;
                    contents: 'Show Column Header';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 197 @ 40; lDU: 411 r: #left; rDU: 608 r: #left; tDU: 128 r: #top; bDU: 168 r: #top);
                    paneName: 'showGrid';
                    startGroup;
                    tabStop;
                    contents: 'Show Grid';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 274 @ 40; lDU: 411 r: #left; rDU: 686 r: #left; tDU: 168 r: #top; bDU: 208 r: #top);
                    paneName: 'sparseStorage';
                    startGroup;
                    tabStop;
                    contents: 'Sparse Storage';
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 240 @ 190; lDU: 558 r: #left; rDU: 798 r: #left; tDU: 232 r: #top; bDU: 422 r: #top);
                    paneName: 'colors';
                    dropDownList;
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 18 r: #left; rDU: 165 r: #left; tDU: 232 r: #top; bDU: 288 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 174 r: #left; rDU: 320 r: #left; tDU: 232 r: #top; bDU: 288 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! 
preInitWindow

    | p c |

    p := thePane realPane.

    (self paneNamed: 'rows')
        contents: p rows.

    (self paneNamed: 'columns')
        contents: p columns.

    (self paneNamed: 'colors')
        contents:
            ((ColorConstants keys asSortedCollection
                reject: [ :color | color = 'ClrChiseledgray' ])
                collect: [ : color | color copyFrom: 4 to: color size]);
        selection: ((c := ColorConstants keyAtValue: p headerColor) copyFrom: 4 to: c size).

    (self paneNamed: 'cellWidth')
        contents: p cellWidth.

    (self paneNamed: 'showRowHeader')
        selection: p showRowHeader.

    (self paneNamed: 'showColumnHeader')
        selection: p showColumnHeader.

    (self paneNamed: 'showGrid')
        selection: p showGrid.

    (self paneNamed: 'sparseStorage')
        selection: p sparseStorage.! !

! WBToolBarEditor methods ! 
activated: aPane

    | element selection |
    self changed: #getBitmaps:.
    (selection := (self paneNamed: 'buttons') selection) isNil ifTrue: [ ^nil ].
    (element := elements at: selection) isNil ifTrue: [ ^nil ].
    (self paneNamed: 'bitmaps') selectItem: element bitmapSelector asString.!  
cellSize

    | cellSize |
    cellSize := (self paneNamed: 'cellSize') contents.
    ^((cellSize upTo: $@) trimBlanks asInteger) @
        ((cellSize reversed upTo: $@) reversed trimBlanks asInteger).!   
copy: aPane

    | index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    clipboard := elements at: index .
    (self paneNamed: 'paste') enable.!  
down: aPane

    | element index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    element := elements at: index.
    index == elements size ifTrue: [ ^nil ].
    elements removeIndex: index.
    elements add: element afterIndex: index.
    list invalidateRect: nil.
    list selection: index + 1.

    self updateButtons.!
drawItem: aPane

    | element |

    element := elements at: aPane drawIndex.
    element pen: nil.
    aPane pen
        copy: element pen
        from: element boundingBox
        to: ((aPane drawBox leftTop rightAndDown: 2) extent: element rectangle extent);
        setTextAlign: TaTop;
        font: SysFont;
        displayText: (element selector asString) at: aPane drawBox leftTop + ((element rectangle width + 6) @ 2)!  
editBitmaps: ignore

    (Smalltalk includesKey: #CPBitmapManager) ifTrue: [
        (Smalltalk includesKey: #MDISystem) ifTrue: [
            (Smalltalk at: #MDISystem) isActive ifTrue: [
                ^MessageBox message: 'Due to limitations in the implementation of MDI, the bitmap manager cannot be launched from within MDI.  Either use the toolbar, or switch out of MDI first.'
            ].
        ].
        (Smalltalk at: #CPBitmapManager) new sendInputEvent: #open.
    ] ifFalse: [
        MessageBox message: 'To view/edit bitmaps, you must first file in the CPBitmapManager.'
    ].!
getBitmaps: aPane

    | keys aPoint |

    aPoint := self cellSize.
    aPane
        contents: (keys := useSystem
            ifTrue: [
                self
                    validBitmapsFrom: CPBitmapDict systemBitmapDictionary
                    withSize: aPoint ]
            ifFalse: [
                self
                    validBitmapsFrom: CPBitmapDict defaultBitmapDictionary
                    withSize: aPoint ]).
    keys isEmpty ifFalse: [ aPane selection: keys first ].!
help: aPane

    MessageBox notify: 'Instructions for Creating Toolbars' withText:
'1) Create toolbar buttons using the BitmapManager and ButtonEditor. They must be the same size as the ''Cell Size''.
2) Insert a blank button using the ''Insert'' button.
3) Select a button bitmap from the Bitmap combobox (only bitmaps of the chosen Cell Size will appear). Each button MUST have an associated bitmap.
4) Specify any other desired attributes.'!
highlightItem: aPane

    aPane pen reverse: aPane drawBox! 
initWindow

    Notifier isAltDown ifFalse: [
        (self paneNamed: 'system') hideWindow
    ].

    list contents: (elements collect: [ :element | element selector asString ]).

    (self paneNamed: 'system') selection: thePane useSystem.
    (self paneNamed: 'cellSize') contents: thePane cellSize asString.
    (self paneNamed: 'paste') disable.

    elements isEmpty ifFalse: [
        list selection: 1.
        self selectButton: list
    ] ifTrue: [
        self updateButtons.
    ].!  
insert: aPane

    | index element |
    index := list selection.

    element := WBTool
        bitmap: (CPBitmapDict sysAt: 'toolPaneExample' ifAbsent: [ nil ])
        selector: ''.
    element rectangle: (0@0 extent: thePane cellSize).

    index isNil ifTrue: [
        elements add: element.
        index := elements size.
    ] ifFalse: [
        elements add: element afterIndex: index.
        index := index + 1.
    ].
    list
        contents: (elements collect: [ :element | element selector asString ]);
        selection: index.

    (self paneNamed: 'bitmaps') selectItem: nil.
    (self paneNamed: 'selector') setContents: ''.
    (self paneNamed: 'rbSelector') setContents: ''.
    (self paneNamed: 'numSpaces') setContents: '0'.

    self updateButtons.! 
ok: aPane

    | rect |

    thePane cellSize: self cellSize.

    elements := elements select: [ :element |
        element bitmapSelector notNil and: [ element bitmapSelector notEmpty ]].
    elements isEmpty ifFalse: [
        elements first rectangle: (Rectangle leftTop: (elements first numSpaces - 1 @ 0) extent: thePane cellSize).
        2 to: elements size do: [ :i |
            (elements at: i) rectangle: (Rectangle
                leftTop: (((elements at: i - 1) rectangle) rightTop right: (elements at: i) numSpaces - 1)
                extent: thePane cellSize)
        ].
    ].
    thePane elements: elements.
    thePane useSystem: useSystem.

    self close!  
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'WBToolBar Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1298 @ 552; xC; yC; cRDU: (11 @ 542 rightBottom: 1287 @ 48));
            pStyle: #(sysmenu modal titlebar);
            when: #activate perform: #activated:;
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 695 @ 480; lDU: 9 r: #left; rDU: 704 r: #left; tDU: 8 r: #top; bDU: 488 r: #top);
                    startGroup;
                    contents: 'Buttons';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 539 @ 408; lDU: 722 r: #left; rDU: 1262 r: #left; tDU: 8 r: #top; bDU: 416 r: #top);
                    startGroup;
                    contents: 'Button';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 503 @ 224; lDU: 741 r: #left; rDU: 1243 r: #left; tDU: 112 r: #top; bDU: 336 r: #top);
                    startGroup;
                    contents: 'Selectors';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 18 r: #left; rDU: 174 r: #left; tDU: 424 r: #top; bDU: 456 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Cell Size:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 731 r: #left; rDU: 859 r: #left; tDU: 64 r: #top; bDU: 96 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Bitmap:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 32; lDU: 759 r: #left; rDU: 942 r: #left; tDU: 152 r: #top; bDU: 184 r: #top);
                    startGroup;
                    contents: 'Left Button:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 32; lDU: 759 r: #left; rDU: 960 r: #left; tDU: 240 r: #top; bDU: 272 r: #top);
                    startGroup;
                    contents: 'Right Button:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 210 @ 32; lDU: 731 r: #left; rDU: 942 r: #left; tDU: 360 r: #top; bDU: 392 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Num Spaces:';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 40; lDU: 1088 r: #left; rDU: 1243 r: #left; tDU: 360 r: #top; bDU: 400 r: #top);
                    paneName: 'system';
                    startGroup;
                    when: #clicked perform: #toggleSystem:;
                    contents: 'System';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 238 @ 64; lDU: 722 r: #left; rDU: 960 r: #left; tDU: 424 r: #top; bDU: 488 r: #top);
                    paneName: 'editBitmaps';
                    startGroup;
                    when: #clicked perform: #editBitmaps:;
                    contents: 'Edit Bitmaps';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 46 @ 48; lDU: 1198 r: #left; rDU: 1243 r: #left; tDU: 56 r: #top; bDU: 104 r: #top);
                    paneName: 'help';
                    startGroup;
                    when: #clicked perform: #help:;
                    contents: '?';
                    yourself
            );
            addSubpane: (
                WBListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 352; lDU: 27 r: #left; rDU: 494 r: #left; tDU: 48 r: #top; bDU: 400 r: #top);
                    paneName: 'buttons';
                    ownerDrawFixed;
                    startGroup;
                    tabStop;
                    when: #highlightItem perform: #highlightItem:;
                    when: #select perform: #selectButton:;
                    when: #drawItem perform: #drawItem:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 48; lDU: 183 r: #left; rDU: 338 r: #left; tDU: 416 r: #top; bDU: 464 r: #top; indent: 3 @ 4);
                    paneName: 'cellSize';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setCellSize:;
                    contents: '25 @ 22';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 40; lDU: 352 r: #left; rDU: 507 r: #left; tDU: 420 r: #top; bDU: 460 r: #top);
                    paneName: 'default';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #toggleDefault:;
                    contents: 'Default';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 48 r: #top; bDU: 112 r: #top);
                    paneName: 'insert';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #insert:;
                    contents: '&Insert';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 120 r: #top; bDU: 184 r: #top);
                    paneName: 'copy';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #copy:;
                    contents: '&Copy';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 192 r: #top; bDU: 256 r: #top);
                    paneName: 'paste';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #paste:;
                    contents: '&Paste';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 264 r: #top; bDU: 328 r: #top);
                    paneName: 'up';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #up:;
                    contents: '&Up';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 336 r: #top; bDU: 400 r: #top);
                    paneName: 'down';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #down:;
                    contents: '&Down';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 64; lDU: 512 r: #left; rDU: 686 r: #left; tDU: 408 r: #top; bDU: 472 r: #top);
                    paneName: 'remove';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #remove:;
                    contents: '&Remove';
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 320 @ 344; lDU: 869 r: #left; rDU: 1189 r: #left; tDU: 56 r: #top; bDU: 400 r: #top);
                    paneName: 'bitmaps';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #getBitmaps:;
                    when: #select perform: #selectBitmap:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 48; lDU: 759 r: #left; rDU: 1225 r: #left; tDU: 184 r: #top; bDU: 232 r: #top; indent: 3 @ 4);
                    paneName: 'selector';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setSelector:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 466 @ 48; lDU: 759 r: #left; rDU: 1225 r: #left; tDU: 272 r: #top; bDU: 320 r: #top; indent: 3 @ 4);
                    paneName: 'rbSelector';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setRBSelector:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 48; lDU: 951 r: #left; rDU: 1070 r: #left; tDU: 352 r: #top; bDU: 400 r: #top; indent: 3 @ 4);
                    paneName: 'numSpaces';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #setNumSpaces:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 64; lDU: 978 r: #left; rDU: 1106 r: #left; tDU: 424 r: #top; bDU: 488 r: #top);
                    paneName: 'ok';
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 64; lDU: 1115 r: #left; rDU: 1262 r: #left; tDU: 424 r: #top; bDU: 488 r: #top);
                    paneName: 'cancel';
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!  
paste: aPane

    | index |
    index := list selection.
    index isNil ifTrue: [
        elements add: clipboard deepCopy.
        index := elements size.
    ] ifFalse: [
        elements add: clipboard deepCopy beforeIndex: index
    ].
    list
        contents: (elements collect: [ :element | element selector asString ]);
        selection: index.

    self updateButtons.!   
preInitWindow

    elements := thePane elements deepCopy.
    useSystem := thePane useSystem.
    list := self paneNamed: 'buttons'.

    list height: thePane cellSize y + 4.! 
remove: aPane

    | index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    elements removeIndex: index.
    list
        contents: (elements collect: [ :element | element selector asString ]);
        selection: (index min: elements size).

    self updateButtons.!  
selectBitmap: aPane

    | element selector index |

    index := list selection.
    index isNil ifTrue: [ ^nil ].
    element := elements at: index.
    element bitmapSelector: aPane selectedItem.
    element bitmapSelector isNil ifTrue: [ ^nil ].

    useSystem ifTrue: [
        element bitmap: (CPBitmapDict sysAt: element bitmapSelector asString ifAbsent: [ nil ]).
    ] ifFalse: [
        element bitmap: (CPBitmapDict at: element bitmapSelector asString ifAbsent: [ nil ]).
    ].
    element boundingBox: nil.

    selector := self paneNamed: 'selector'.
    selector contents isEmpty ifTrue: [
        selector setContents: element bitmapSelector.
        element selector: element bitmapSelector.
    ].
    list
        invalidateRect: nil;
        setFocus!   
selectButton: aPane

    | element |
    element := elements at: aPane selection.
    (self paneNamed: 'bitmaps') selectItem: element bitmapSelector asString.
    (self paneNamed: 'selector') setContents: element selector.
    (self paneNamed: 'rbSelector') setContents: element rbSelector.
    (self paneNamed: 'numSpaces') contents: element numSpaces asString.

    self updateButtons.! 
setCellSize: aPane

    self changed: #getBitmaps:! 
setNumSpaces: aPane

    | element |
    element := elements at: list selection.
    element numSpaces: aPane contents asInteger.!
setRBSelector: aPane

    | element |
    element := elements at: list selection.
    element rbSelector: aPane contents.!
setSelector: aPane

    | element |
    element := elements at: list selection.
    element selector: aPane contents.

    list invalidateRect: nil!
toggleDefault: aPane

    aPane selection ifTrue: [
        (self paneNamed: 'cellSize')
            contents: '25 @ 22';
            disable
    ] ifFalse: [
        (self paneNamed: 'cellSize') enable
    ].!
toggleSystem: aPane

    useSystem := aPane selection.
    self changed: #getBitmaps:.!
up: aPane

    | element index |
    index := list selection.
    index isNil ifTrue: [ ^nil ].
    element := elements at: index.
    index == 1 ifTrue: [ ^nil ].
    elements removeIndex: index.
    elements add: element beforeIndex: index - 1.
    list invalidateRect: nil.
    list selection: index - 1.

    self updateButtons.! 
updateButtons

    elements isEmpty ifTrue: [
        (self paneNamed: 'remove') disable.
        (self paneNamed: 'copy') disable.
        (self paneNamed: 'up') disable.
        (self paneNamed: 'down') disable.
        ^nil
    ] ifFalse: [
        (self paneNamed: 'remove') enable.
        (self paneNamed: 'copy') enable.
    ].
    list selection == elements size ifTrue: [
        (self paneNamed: 'down') disable
    ] ifFalse: [
        (self paneNamed: 'down') enable
    ].
    list selection == 1 ifTrue: [
        (self paneNamed: 'up') disable
    ] ifFalse: [
        (self paneNamed: 'up') enable
    ].!
validBitmapsFrom: aBitmapDictionary withSize: aPoint

    | size |
    size := aPoint x * 2 @ aPoint y.
    ^(aBitmapDictionary select: [ :bitmap | bitmap extent = size ])
        keys asSortedCollection! !

! WBValuatorEditor methods !   
initWindow

    | p |

    p := thePane realPane.

    (self paneNamed: 'value') contents: p value asString.
    (self paneNamed: 'min') contents: (p min isNil ifTrue: [ '' ] ifFalse: [ p min asString ]).
    (self paneNamed: 'max') contents: (p max isNil ifTrue: [ '' ] ifFalse: [ p max asString ]).

    p canShowPercentage ifTrue: [
        (self paneNamed: 'showPercentage') selection: p showPercentage.
    ] ifFalse: [
        (self paneNamed: 'showPercentage') hideWindow.
    ].! 
ok: ignore

    | p m |

    thePane := thePane fullCopy.
    p := thePane realPane.

    (m := (self paneNamed: 'min') contents) isEmpty ifTrue: [
        p min: nil.
    ] ifFalse: [
        p min: m asInteger.
    ].
    (m := (self paneNamed: 'max') contents) isEmpty ifTrue: [
        p max: nil.
    ] ifFalse: [
        p max: m asInteger.
    ].
    p value: (self paneNamed: 'value') contents asInteger.

    p canShowPercentage ifTrue: [
        p showPercentage: (self paneNamed: 'showPercentage') selection.
    ].

    self close!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Valuator Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 457 @ 384; xC; yC; cRDU: (11 @ 374 rightBottom: 446 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 64 r: #left; rDU: 219 r: #left; tDU: 32 r: #top; bDU: 64 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Minimum:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 32; lDU: 55 r: #left; rDU: 219 r: #left; tDU: 88 r: #top; bDU: 120 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Maximum:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 27 r: #left; rDU: 219 r: #left; tDU: 144 r: #top; bDU: 176 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Initial Value:';
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 48; lDU: 229 r: #left; rDU: 421 r: #left; tDU: 24 r: #top; bDU: 72 r: #top; indent: 3 @ 4);
                    paneName: 'min';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 48; lDU: 229 r: #left; rDU: 421 r: #left; tDU: 80 r: #top; bDU: 128 r: #top; indent: 3 @ 4);
                    paneName: 'max';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 48; lDU: 229 r: #left; rDU: 421 r: #left; tDU: 136 r: #top; bDU: 184 r: #top; indent: 3 @ 4);
                    paneName: 'value';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 302 @ 40; lDU: 73 r: #left; rDU: 375 r: #left; tDU: 200 r: #top; bDU: 240 r: #top);
                    paneName: 'showPercentage';
                    startGroup;
                    tabStop;
                    contents: 'Show Percentage';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 56; lDU: 9 r: #left; rDU: 201 r: #left; tDU: 256 r: #top; bDU: 312 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 56; lDU: 219 r: #left; rDU: 411 r: #left; tDU: 256 r: #top; bDU: 312 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! !

! WBWindowEditor methods ! 
initWindow

    | theStyle |

    theStyle := thePane style.
    iconFile := thePane iconFile.

    (self paneNamed: 'systemMenu') selection: (theStyle includes: #sysmenu).
    (self paneNamed: 'maximizeBox') selection: (theStyle includes: #maximize).
    (self paneNamed: 'minimizeBox') selection: (theStyle includes: #minimize).
    thePane isModal ifTrue: [
        (self paneNamed: 'sizingFrame') hideWindow.
        (self paneNamed: 'mainViewChild') hideWindow
    ] ifFalse: [
        (self paneNamed: 'sizingFrame') selection: (theStyle includes: #sizable).
    ].
    (self paneNamed: 'titleBar') selection: (theStyle includes: #titlebar).
    (self paneNamed: 'mainViewChild') selection: (theStyle includes: #mainViewChild).

    "Support for MainView children"
    (thePane paneName = 'mainView') ifTrue: [
        (self paneNamed: 'mainViewChild') hideWindow
    ].!   
ok: aPane

    | s anArray |

    s := Set new.
    (self paneNamed: 'systemMenu') selection ifTrue: [
        s add: #sysmenu.
    ].

    (self paneNamed: 'maximizeBox') selection ifTrue: [
        s add: #maximize.
    ].

    (self paneNamed: 'minimizeBox') selection ifTrue: [
        s add: #minimize.
    ].

    (self paneNamed: 'sizingFrame') selection ifTrue: [
        s add: #sizable.
    ].

    (self paneNamed: 'titleBar') selection ifTrue: [
        s add: #titlebar.
    ].

    "Support for MainView children"
    (self paneNamed: 'mainViewChild') selection ifTrue: [
        s add: #mainViewChild.
    ].

    iconEditor notNil ifTrue: [
        iconEditor fileName notNil ifTrue: [
            iconFile := ((anArray := File splitPath: iconEditor fileName in: Disk) at: 2),'\',(anArray at: 3).
        ]
    ].

    thePane := thePane fullCopy.

    thePane
        style: s;
        iconFile: iconFile.


    super close.! 
open


     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Window Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 667 @ 312; xC; yC; cRDU: (11 @ 302 rightBottom: 656 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 274 @ 40; lDU: 357 r: #left; rDU: 631 r: #left; tDU: 120 r: #top; bDU: 160 r: #top);
                    paneName: 'mainViewChild';
                    startGroup;
                    contents: '&MainView Child';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 56; lDU: 439 r: #left; rDU: 631 r: #left; tDU: 184 r: #top; bDU: 240 r: #top);
                    paneName: 'setIcon';
                    startGroup;
                    when: #clicked perform: #setIcon:;
                    contents: 'Set &Icon...';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 295 @ 40; lDU: 18 r: #left; rDU: 313 r: #left; tDU: 24 r: #top; bDU: 64 r: #top);
                    paneName: 'systemMenu';
                    startGroup;
                    tabStop;
                    contents: '&System menu';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 299 @ 40; lDU: 18 r: #left; rDU: 318 r: #left; tDU: 72 r: #top; bDU: 112 r: #top);
                    paneName: 'minimizeBox';
                    startGroup;
                    tabStop;
                    contents: 'Mi&nimize box';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 311 @ 40; lDU: 18 r: #left; rDU: 329 r: #left; tDU: 120 r: #top; bDU: 160 r: #top);
                    paneName: 'maximizeBox';
                    startGroup;
                    tabStop;
                    contents: 'Ma&ximize box';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 224 @ 40; lDU: 357 r: #left; rDU: 581 r: #left; tDU: 24 r: #top; bDU: 64 r: #top);
                    paneName: 'titleBar';
                    startGroup;
                    tabStop;
                    contents: '&Title bar';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 265 @ 40; lDU: 357 r: #left; rDU: 622 r: #left; tDU: 72 r: #top; bDU: 112 r: #top);
                    paneName: 'sizingFrame';
                    startGroup;
                    tabStop;
                    contents: 'Sizing &frame';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 56; lDU: 18 r: #left; rDU: 183 r: #left; tDU: 184 r: #top; bDU: 240 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 56; lDU: 201 r: #left; rDU: 366 r: #left; tDU: 184 r: #top; bDU: 240 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!
setIcon: aPane

    "Support for setting window icons"

    (Smalltalk includesKey: #WBIconEditor) ifFalse: [
        ^self setIconFromDialog
    ].
    iconEditor notNil ifTrue: [
        iconEditor fileName notNil ifTrue: [
            iconFile := iconEditor fileName.
        ].
    ].
    iconEditor := iconFile isNil ifTrue: [
        (Smalltalk at: #WBIconEditor) new open.
    ] ifFalse: [
        (File exists: iconFile) ifFalse: [
            MessageBox message: 'The icon file: ''',iconFile,''' cannot be found.'.
            (Smalltalk at: #WBIconEditor) new open.
        ] ifTrue: [
            (Smalltalk at: #WBIconEditor) new openOnFile: iconFile.
        ].
    ].!   
setIconFromDialog

    "Support for setting window icons"
    | file |
    iconFile isNil ifTrue: [
        file := nil
    ] ifFalse: [
        file := (File splitPath: iconFile in: Disk) at: 3
    ].
    iconFile := (FileDialog new
                            openTitle: (file isNil
                                ifTrue: ['Select Icon File']
                                ifFalse: ['Select Icon File - ',file])
                            fileSpec: '*.ICO'
                            showFileInButton: false) file.
    (iconFile asStream skipTo: $.; upTo: $.) asUpperCase = 'ICO' ifFalse: [
        MessageBox message: iconFile,' is not a valid .ICO file!!'.
        iconFile := nil
    ].! !

! WBChooseClassDialog class methods !
isWBInternalClass

    ^true! !

! WBChooseClassDialog methods !  
cancel: ignore

    result := nil.
    self close.!
classList: listOfClasses

    ^self classList: listOfClasses default: nil"(
         listOfClasses notEmpty ifTrue: [
            listOfClasses first
        ] ifFalse: [
            nil
        ]
    )    "!  
classList: listOfClasses allowOthers: bool

    allowOthers := bool.

    ^self classList: listOfClasses default: (
         listOfClasses notEmpty ifTrue: [
            listOfClasses first
        ] ifFalse: [
            nil
        ]
    )! 
classList: listOfClasses default: dClass

    classList := listOfClasses.

    default := dClass.

    self open.!  
initialize

    allowOthers := true.
    super initialize.!
initWindow

    classListBox := self paneNamed: 'classListBox'.

    classListBox contents: (classList collect: [ :aClass |
                aClass name
            ]) asSortedCollection asOrderedCollection.

    default notNil ifTrue: [
        classListBox selection: default name.
    ] ifFalse: [
        classListBox contents notEmpty ifTrue: [
            classListBox selection: 1.
        ].
    ].

    allowOthers ifFalse: [
        (self paneNamed: 'allowOthers') hideWindow; disable.
    ].!  
isWBWindow

    ^true!  
ok: ignore

    result := classListBox selectedItem.
    result notNil ifTrue: [
        result := Smalltalk at: result asSymbol.
    ].

    self close.! 
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Choose a class:';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 658 @ 512; xC; yC; cRDU: (11 @ 502 rightBottom: 647 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 603 @ 368; lDU: 18 r: #left; rDU: 622 r: #left; tDU: 16 r: #top; bDU: 384 r: #top);
                    paneName: 'classListBox';
                    startGroup;
                    tabStop;
                    when: #doubleClickSelect perform: #selectedClass:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 18 r: #left; rDU: 165 r: #left; tDU: 392 r: #top; bDU: 448 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 174 r: #left; rDU: 320 r: #left; tDU: 392 r: #top; bDU: 448 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 274 @ 56; lDU: 347 r: #left; rDU: 622 r: #left; tDU: 392 r: #top; bDU: 448 r: #top);
                    paneName: 'allowOthers';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #openNonWBView:;
                    contents: '&Non WB View...';
                    yourself
            );
        yourself
    ).

    self openWindow!   
openNonWBView: aPane

    |className wbCreatedClasses |

    wbCreatedClasses := ViewManager wbCreatedClasses.

    className := WBListChooser fromList: ((
        (Notifier isAltDown ifFalse: [
            (ViewManager allSubclasses select: [ :c |
            (c canUnderstand: #open) and: [
            ((wbCreatedClasses includes: c) not) and: [
            c isWBInternalClass not ]]])
        ] ifTrue: [
            "Hold down ALT key to get access to WindowBuilder windows"
            (ViewManager allSubclasses select: [ :c | c isWBInternalClass ])
        ])
        collect: [ :class |
            class name
        ])) asSortedCollection asOrderedCollection prompt: 'Which ViewManager?'.

    className isNil ifTrue: [ ^self ].

    result := Smalltalk at: className asSymbol.

    self close.!   
result

    ^result!
selectedClass: aClass

    "Assumes the class is already selected"

    self ok: nil.! !

! WBChoosePaneDialog methods !
abstractPaneList
    ^#(
        ControlPane
        Toggle
        CPChildEntryField
        StaticPane
        CPSubPane
        CPScrollingPane
        CPSpinEditor
        CPValuator
        CPGuage
        CPSlider
        ).!   
classList: listOfClasses

    self abstractPaneList do: [ :cn |
        (Smalltalk includesKey: cn) ifTrue: [
            listOfClasses remove: (Smalltalk at: cn) ifAbsent: [ nil ]
        ].
    ].
    (listOfClasses includes: ScrollBar) ifTrue: [
        listOfClasses
            remove: ScrollBar;
            add: WBHorizontalScrollBar;
            add: WBVerticalScrollBar.
    ].
    ^self classList: listOfClasses default: listOfClasses first!  
initWindow

    classListBox := self paneNamed: 'classListBox'.

    classListBox
            contents: (classList collect: [ :aClass |
                aClass name
            ]) asSortedCollection asOrderedCollection;
            selection: 1.! 
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Choose a class:';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 622 @ 520; xC; yC; cRDU: (11 @ 510 rightBottom: 610 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 567 @ 368; lDU: 18 r: #left; rDU: 585 r: #left; tDU: 16 r: #top; bDU: 384 r: #top);
                    paneName: 'classListBox';
                    startGroup;
                    tabStop;
                    when: #doubleClickSelect perform: #selectedClass:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 18 r: #left; rDU: 165 r: #left; tDU: 392 r: #top; bDU: 448 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 56; lDU: 183 r: #left; rDU: 329 r: #left; tDU: 392 r: #top; bDU: 448 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! 
preInitWindow

    | cancel |

    (cancel := self paneNamed: 'cancel') notNil ifTrue: [
        cancel idCancel.
    ].

    self labelWithoutPrefix: 'Choose a subpane type:'.! !

! WBColorDialog class methods !
isWBInternalClass

    ^true! !

! WBColorDialog methods !
cancel: ignore

    self close.!
colorBarWidth

    ^50! 
drawItem: aPane

"    drawBox drawIndex     "

    aPane pen
        fill: ((aPane drawBox leftTop extent: aPane drawBox height) insetBy: 1)
            color: (ColorConstants at: 'Clr', (colors at: aPane drawIndex) ifAbsent: [ thePane defaultBackColor ]);
        setTextAlign: TaTop;
        displayText: (colors at: aPane drawIndex) at: aPane drawBox leftTop + ((aPane drawBox height + 5) @ 0)! 
drawItemBack: aPane

    | c |

    (colors at: aPane drawIndex) = 'Default' ifTrue: [
        c := thePane defaultBackColor.
    ] ifFalse: [
        c := ColorConstants at: 'Clr', (colors at: aPane drawIndex).
    ].

    aPane pen
        fill: ((aPane drawBox leftTop extent: self colorBarWidth @ aPane drawBox height) insetBy: 1) color: c;
        setTextAlign: TaTop;
        font: ListFont;
        displayText: (colors at: aPane drawIndex) at: aPane drawBox leftTop + ((self colorBarWidth + 5) @ 0)! 
drawItemFore: aPane

    | c |

    (colors at: aPane drawIndex) = 'Default' ifTrue: [
        c := thePane defaultForeColor.
    ] ifFalse: [
        c := ColorConstants at: 'Clr', (colors at: aPane drawIndex).
    ].

    aPane pen
        fill: ((aPane drawBox leftTop extent: self colorBarWidth @ aPane drawBox height) insetBy: 1) color: c;
        setTextAlign: TaTop;
        font: ListFont;
        displayText: (colors at: aPane drawIndex) at: aPane drawBox leftTop + ((self colorBarWidth + 5) @ 0)! 
foreColor: f backColor: b paneEdited: aPane

    foreColor := f.
    backColor := b.
    thePane := aPane.

    self open.

    ^result!  
highlightItem: aPane

    aPane pen reverse: (aPane drawBox leftTop + ((self colorBarWidth + 2) @ 0) corner: aPane drawBox corner)! 
initWindow

    | c |

    colors := ((ColorConstants keys asOrderedCollection
        remove: 'ClrDefault';
        remove: 'ClrBackground';
        remove: 'ClrNeutral';
        remove: 'ClrHighlighttext';
        remove: 'ClrHighlight';
        yourself) collect: [:s | s copyFrom: 4 to: s size ])
        addFirst: 'Default';
        yourself .

    thePane isFrameObject not | (CPBitmapDict systemBitmapDictionary keys includes: 'steelPattern') not ifTrue: [
        colors remove: 'Chiseledgray'
    ].

    foreColor = thePane defaultForeColor ifTrue: [
        c := 'Default'.
    ] ifFalse: [
        c := ColorConstants keyAtValue: foreColor ifAbsent: [ 'ClrDefault' ].
        c := c copyFrom: 4 to: c size.
    ].

    (thePane usesForeColor) ifTrue: [
        (self paneNamed: 'foreColorList')
            contents: colors;
            selection: c.
    ] ifFalse: [
        (self paneNamed: 'foreColorList')
            contents: #( 'Default' );
            selection: 'Default';
            disable
    ].

    backColor = thePane defaultBackColor ifTrue: [
        c := 'Default'.
    ] ifFalse: [
        c := ColorConstants keyAtValue: backColor ifAbsent: [ 'ClrDefault' ].
        c := c copyFrom: 4 to: c size.
    ].
    (self paneNamed: 'backColorList')
        contents: colors;
        selection: c.!  
isWBWindow

    ^true!  
ok: aPane

    | c |

    result := Array new: 2.
     (c := (self paneNamed: 'foreColorList') selectedItem) = 'Default' ifTrue: [
        result at: 1 put: nil.
    ] ifFalse: [
        result at: 1 put: (ColorConstants at: 'Clr', c).
    ].

     (c := (self paneNamed: 'backColorList') selectedItem) = 'Default' ifTrue: [
        result at: 2 put: nil.
    ] ifFalse: [
        result at: 2 put: (ColorConstants at: 'Clr', c).
    ].

    self close.!   
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Set Pane Colors';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 869 @ 504; xC; yC; cRDU: (11 @ 494 rightBottom: 857 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 187 @ 32; lDU: 18 r: #left; rDU: 206 r: #left; tDU: 16 r: #top; bDU: 48 r: #top);
                    startGroup;
                    contents: 'Forecolor:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 197 @ 32; lDU: 439 r: #left; rDU: 635 r: #left; tDU: 16 r: #top; bDU: 48 r: #top);
                    startGroup;
                    contents: 'Backcolor:';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 56; lDU: 18 r: #left; rDU: 210 r: #left; tDU: 384 r: #top; bDU: 440 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 56; lDU: 229 r: #left; rDU: 421 r: #left; tDU: 384 r: #top; bDU: 440 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
            addSubpane: (
                WBListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 402 @ 320; lDU: 18 r: #left; rDU: 421 r: #left; tDU: 56 r: #top; bDU: 376 r: #top);
                    paneName: 'foreColorList';
                    ownerDrawFixed;
                    startGroup;
                    tabStop;
                    when: #highlightItem perform: #highlightItem:;
                    when: #drawItem perform: #drawItemFore:;
                    yourself
            );
            addSubpane: (
                WBListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 393 @ 320; lDU: 439 r: #left; rDU: 832 r: #left; tDU: 56 r: #top; bDU: 376 r: #top);
                    paneName: 'backColorList';
                    ownerDrawFixed;
                    startGroup;
                    tabStop;
                    when: #highlightItem perform: #highlightItem:;
                    when: #drawItem perform: #drawItemBack:;
                    yourself
            );
        yourself
    ).

    self openWindow! !

! WBCreateClassDialog class methods ! 
isWBInternalClass

    ^true! !

! WBCreateClassDialog methods !  
cancel:  aPane

    newClass := nil.
    self close.!  
classListFor: windowOrDialog

    (windowOrDialog = 'CompositePane') ifTrue: [
        ^(CompositePane withAllSubclasses collect: [ :c | c name ])
                asSortedCollection asOrderedCollection
    ].
    (windowOrDialog = 'Window') ifTrue: [
        ^((ViewManager allSubclasses reject: [ :c |
                (c inheritsFrom: WindowDialog) | (PWindowBuilder allViewManagerClasses includes: c)
            ]) collect: [ :c | c name ]) asSortedCollection asOrderedCollection
    ] ifFalse: [
        ^((WindowDialog allSubclasses reject: [ :c |
                (PWindowBuilder allViewManagerClasses includes: c)
            ]) collect: [ :c | c name]) asSortedCollection asOrderedCollection
    ].!  
forWindowType: aType

        limitTo := aType.
        self open.!
initialize

        limitTo := 'Window'.
        super initialize.!
initWindow

        | names selection temp |

        names := (ViewManager withAllSubclasses collect: [ :c | c name ]) asSortedCollection.

        limitTo = 'Window' ifTrue: [
                selection :=  'ViewManager'.
        ] ifFalse: [ limitTo = 'CompositePane' ifTrue: [
                self labelWithoutPrefix:  'Save CompositePane'.
                (self paneNamed: 'nameText') contents: 'CompositePane name:'.
                selection :=  'CompositePane'.
        ] ifFalse: [
                (self paneNamed: 'nameText') contents: 'WindowDialog name:'.
                selection := 'WindowDialog'.
        ]].

        (self paneNamed: 'superclassName')
                contents: (self superclassListFor: limitTo);
                selectItem: selection;
                getSelection.  "kludge to avoid Digitalk bug"

       (self paneNamed: 'className')
            contents: (self classListFor: limitTo).!   
isWBWindow

    ^true!  
ok:  aPane

        | className superclass  |

    className := (self paneNamed: 'className') text trimBlanks.

    className size > 0 ifFalse: [
        ^MessageBox messageNote: 'You must provide a class name.'
    ].

   className first isUpperCase ifFalse: [
        ^MessageBox messageNote: 'Class name must begin with an upper case letter.'
    ].

    className do: [ :c |
        ('~!!@#$%^&*()_+=-|}{\][/?><.,''";: ' includes: c) ifTrue: [
            ^MessageBox messageNote: 'Class name can only contain alpha numerics.'
        ].
    ].

    superclass := Smalltalk at: (self paneNamed: 'superclassName') selectedItem asSymbol.

    (Smalltalk includesKey: className asSymbol) ifFalse: [

        newClass := superclass subclass: className
            instanceVariableNames: ''
            classVariableNames: ''
            poolDictionaries: 'WBConstants'.
    ] ifTrue: [
        newClass := Smalltalk at: className asSymbol.

        (newClass == ViewManager) | (newClass == WindowDialog) ifTrue: [
            ^MessageBox messageNote: 'You cannot save window definitions in the abstract class ', newClass name, '.  Please choose a different name.'
        ].

        (limitTo = 'Window') & (newClass inheritsFrom: ViewManager) not ifTrue: [
            ^MessageBox messageNote: 'That class already exists, and is not a ViewManager subclass.  Please choose a different name.'
        ].

        (limitTo = 'Window') & (newClass inheritsFrom: WindowDialog) ifTrue: [
            ^MessageBox messageNote: 'That class already exists, and is a subclass of WindowDialog.  Please choose a different name.'
        ].

        (limitTo = 'Dialog') & (newClass inheritsFrom: WindowDialog) not ifTrue: [
            ^MessageBox messageNote: 'That class exists already, and is not a WindowDialog subclass.  Please choose a different name.'
        ].

        newClass superclass == superclass ifFalse: [
            ^MessageBox messageNote: 'The superclass of an existing class cannot be changed.'
        ].

        (MessageBox confirm: 'The class ''', newClass name, ''' exists.  Overwrite?') ifFalse: [
            ^self
        ].
    ].

      self close.!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Save ViewManager';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 686 @ 360; xC; yC; cRDU: (11 @ 350 rightBottom: 674 @ 48));
            pStyle: #(sysmenu modal minimize maximize titlebar);
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 363 @ 32; lDU: 27 r: #left; rDU: 391 r: #left; tDU: 16 r: #top; bDU: 48 r: #top);
                    paneName: 'nameText';
                    startGroup;
                    contents: 'ViewManager name:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 219 @ 32; lDU: 27 r: #left; rDU: 247 r: #left; tDU: 120 r: #top; bDU: 152 r: #top);
                    startGroup;
                    contents: 'Superclass:';
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 622 @ 240; lDU: 27 r: #left; rDU: 649 r: #left; tDU: 56 r: #top; bDU: 296 r: #top);
                    paneName: 'className';
                    dropDown;
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 622 @ 302; lDU: 27 r: #left; rDU: 649 r: #left; tDU: 160 r: #top; bDU: 462 r: #top);
                    paneName: 'superclassName';
                    dropDownList;
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 187 @ 60; lDU: 27 r: #left; rDU: 215 r: #left; tDU: 232 r: #top; bDU: 292 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 187 @ 60; lDU: 238 r: #left; rDU: 425 r: #left; tDU: 232 r: #top; bDU: 292 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!  
result

    ^newClass!  
superclassListFor: windowOrDialog

    (windowOrDialog = 'CompositePane') ifTrue: [
        ^(CompositePane withAllSubclasses collect: [ :c | c name ]) asSortedCollection
    ].
    (windowOrDialog = 'Window') ifTrue: [
        Notifier isAltDown ifTrue: [
            ^(ViewManager withAllSubclasses collect: [ :c | c name ]) asSortedCollection
        ] ifFalse: [
            ^((ViewManager withAllSubclasses reject: [ :c |
                    (c inheritsFrom: WindowDialog) | (PWindowBuilder allViewManagerClasses includes: c)
                ]) collect: [ :c | c name ]) asSortedCollection
        ].
    ] ifFalse: [
        Notifier isAltDown ifTrue: [
            ^(WindowDialog withAllSubclasses collect: [ :c | c name ]) asSortedCollection
        ] ifFalse: [
            ^((WindowDialog withAllSubclasses reject: [ :c |
                    (PWindowBuilder allViewManagerClasses includes: c)
                ]) collect: [ :c | c name]) asSortedCollection
        ].
    ].! !

! WBDefaultDialogScratchWindow class methods ! 
isWBInternalClass

    ^true! !

! WBDefaultDialogScratchWindow methods ! 
createViews

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'New Dialog';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 686 @ 400; xC; yC; cRDU: (11 @ 390 rightBottom: 674 @ 48));
            pStyle: #(sysmenu modal titlebar);
        yourself
    ).!
isWBWindow

    ^true! !

! WBDialogScratchWindow class methods ! 
createMethod: methodString

    | fileInStream |

    fileInStream := ReadWriteStream on: (String new: methodString size).
    fileInStream
        nextPutAll: '!! WBDialogScratchWindow methods !!';
        nextChunkPut: methodString;
        nextChunkPut: String new.

    fileInStream reset; fileIn.!  
defaultClass

    ^WBDefaultDialogScratchWindow!
isScratchWindow

    ^true! 
isWBInternalClass

    ^true!   
resetToDefault

    "self defaultClass selectors do: [:s |
        self createMethod: (self defaultClass sourceCodeAt: s).
    ]."! !

! WBDialogScratchWindow methods !
isWBWindow

    ^true!  
perform: selector
    "Scratch windows should not perform any events"
    ^MessageBox messageNote: 'Scratch windows cannot do anything. You must first create a new view manager class with the "Save As..." command in order to add behavior.'!
perform: selector with: arg
    "Scratch windows should not perform any events"
    self perform: selector! 
when: anEvent perform: aSelector
    "Scratch windows should not perform any events"! !

! WBFramingEditor class methods ! 
isWBInternalClass

    ^true! !

! WBFramingEditor methods !  
cancel: ignore

    result := nil.
    self close! 
cornerXAnchorChanged:  newAnchor

    (newAnchor selectedItem = 'Pane left') ifTrue: [
        originXAnchor disableItem: 'Pane right'.
    ] ifFalse: [
        originXAnchor enableItem: 'Pane right'.
    ].

    self setExampleRects.!   
cornerXStyleChanged: styleRadio

    (styleRadio contents = 'Scaled') & (styleRadio selection) ifTrue: [
        cornerXAnchor selection: 'Window left'.
        cornerXAnchor disable.
        rightRelative disable.
    ] ifFalse: [
        rightRelative enable.
        cornerXAnchor enable.
    ].

    self setExampleRects.! 
cornerYAnchorChanged:  newAnchor

    (newAnchor selectedItem = 'Pane top') ifTrue: [
        originYAnchor disableItem: 'Pane bottom'.
    ] ifFalse: [
        originYAnchor enableItem: 'Pane bottom'.
    ].

    self setExampleRects.!  
cornerYStyleChanged: styleRadio


    (styleRadio contents = 'Scaled') & (styleRadio selection)  ifTrue: [
        cornerYAnchor selection: 'Window top'.
        cornerYAnchor disable.
        bottomRelative disable.
    ] ifFalse: [
        bottomRelative enable.
        cornerYAnchor enable.
    ].

    self setExampleRects.! 
initializeExampleRects

    (parentRect width > parentRect height) ifTrue: [
        beforeScaleFactor :=  (beforeRect extent x * WBFramingParameters dialogUnit x) / parentRect width.
    ] ifFalse: [
        beforeScaleFactor := (beforeRect extent y * WBFramingParameters dialogUnit y) / parentRect height.
    ].

    beforeRect frameRect: (
        0@0 extent: (parentRect extent * beforeScaleFactor) rounded
    ).

    afterRect frameRect: (
        0@0 extent: (afterRect extent * WBFramingParameters dialogUnit) rounded
    ).

    largeParentRect := parentRect leftBottom extentFromLeftBottom: ((afterRect frameRect extent / beforeRect frameRect extent) * parentRect extent) rounded.!  
initializeOnFramer:  aFramer rects: thePanesRects parentRect: theParentsRect

    framingParameters := aFramer.
    currentRectList := thePanesRects.
    parentRect := theParentsRect.
    hasFramed := false.


    "Initialize all uninitialized combo boxes"
    originXAnchor contents: #(
            'Window left'
            'Window right'
            'Window center'
            'Pane right'
    ); enable.
    originYAnchor contents: #(
            'Window top'
            'Window bottom'
            'Window center'
            'Pane bottom'
    ); enable.
    cornerXAnchor contents: #(
            'Window left'
            'Window right'
            'Window center'
            'Pane left'
    ); enable.
    cornerYAnchor contents: #(
            'Window top'
            'Window bottom'
            'Window center'
            'Pane top'
    ); enable.

    originXAnchor selectIndex: 1.
    originYAnchor selectIndex: 1.
    cornerXAnchor selectIndex: 1.

    cornerYAnchor selectIndex: 1.

    originXStyleFixed selection: false; enable.
    originXStyleScaled selection: false; enable.
    originYStyleFixed selection: false; enable.
    originYStyleScaled selection: false; enable.
    cornerXStyleFixed selection: false; enable.
    cornerXStyleScaled selection: false; enable.
    cornerYStyleFixed selection: false; enable.
    cornerYStyleScaled selection: false; enable.

    bottomRelative enable.
    topRelative enable.
    rightRelative enable.
    leftRelative enable.

    "For initialization only - the y coordinate needs to be configured
     to a legal value for setExampleRects to work"
    yCenteredCheckBox selection: true.

    framingParameters isNil ifTrue: [
        originXStyleFixed selection: true.
        originXAnchor selectItem: 'Window left'.
        originXAnchor disableItem: 'Pane right'.

        originYStyleFixed selection: true.
        originYAnchor selectItem: 'Window top'.
        originYAnchor disableItem: 'Pane bottom'.

        cornerXStyleFixed selection: true.
        cornerXAnchor selectItem: 'Pane left'.

        cornerYStyleFixed selection: true.
        cornerYAnchor selectItem: 'Pane top'.

        xCenteredCheckBox selection: false.
        yCenteredCheckBox selection: false.

    ] ifFalse: [

        framingParameters centerX  ifTrue: [
            xCenteredCheckBox selection: true.
            self xCenteredToggled: xCenteredCheckBox.
        ] ifFalse: [
            xCenteredCheckBox selection: false.

            framingParameters left isNil ifTrue: [
                originXStyleFixed selection: true.
                originXAnchor selectItem: 'Pane right'.
                cornerXAnchor disableItem: 'Pane left'.
            ] ifFalse: [

                framingParameters left isInteger ifFalse: [
                    originXStyleScaled selection: true.
                    self originXStyleChanged: originXStyleScaled.
                ] ifTrue: [
                    originXStyleFixed selection: true.
                    originXAnchor selectItem: 'Window ', framingParameters leftRel asCUAPresentableString.
                    self originXStyleChanged: originXStyleScaled.
                ].

            ].

            framingParameters right isNil ifTrue: [
                cornerXStyleFixed selection: true.
                cornerXAnchor selectItem: 'Pane left'.
                originXAnchor disableItem: 'Pane right'.
            ] ifFalse: [

                framingParameters right isInteger ifFalse: [
                    cornerXStyleScaled selection: true.
                    self cornerXStyleChanged: cornerXStyleScaled.
                ] ifTrue: [
                    cornerXStyleFixed selection: true.
                    cornerXAnchor selectItem: 'Window ', framingParameters rightRel asCUAPresentableString.
                    self cornerXStyleChanged: cornerXStyleFixed.
                ].
            ].
        ].

        framingParameters centerY ifTrue: [
            yCenteredCheckBox selection: true.
            self yCenteredToggled: yCenteredCheckBox.
        ] ifFalse: [
            yCenteredCheckBox selection: false.

            framingParameters top isNil ifTrue: [
                originYStyleFixed selection: true.
                originYAnchor selectItem: 'Pane bottom'.

                cornerYAnchor disableItem: 'Pane top'.
            ] ifFalse: [

                framingParameters top isInteger ifFalse: [
                    originYStyleScaled selection: true.
                    self originYStyleChanged: originYStyleScaled.
                ] ifTrue: [
                    originYStyleFixed selection: true.
                    originYAnchor selectItem: 'Window ', framingParameters topRel asCUAPresentableString.
                    self originYStyleChanged: originYStyleFixed.
                ].
            ].

            framingParameters bottom isNil ifTrue: [
                cornerYStyleFixed selection: true.
                cornerYAnchor selectItem: 'Pane top'.
                originYAnchor disableItem: 'Pane bottom'.
            ] ifFalse: [

                framingParameters bottom isInteger ifFalse: [
                    cornerYStyleScaled selection: true.
                    self cornerYStyleChanged: cornerYStyleScaled.
                ] ifTrue: [
                    cornerYStyleFixed selection: true.

                    cornerYAnchor selectItem: 'Window ',framingParameters bottomRel asCUAPresentableString.
                    self cornerYStyleChanged: cornerYStyleFixed.
                ].
            ].
        ].
    ].

    hasFramed := true.

    self initializeExampleRects.
    self setExampleRects.! 
initInstVars

    xCenteredCheckBox := (self paneNamed: 'xCenteredCheckBox').
    yCenteredCheckBox := (self paneNamed: 'yCenteredCheckBox').
    originXStyleFixed := (self paneNamed: 'originXStyleFixed').
    originXStyleScaled := (self paneNamed: 'originXStyleScaled').
    originXAnchor := (self paneNamed: 'originXAnchor').
    cornerXStyleFixed := (self paneNamed: 'cornerXStyleFixed').
    cornerXStyleScaled := (self paneNamed: 'cornerXStyleScaled').
    cornerXAnchor := (self paneNamed: 'cornerXAnchor').
    originYStyleFixed := (self paneNamed: 'originYStyleFixed').
    originYStyleScaled := (self paneNamed: 'originYStyleScaled').
    originYAnchor := (self paneNamed: 'originYAnchor').
    cornerYStyleFixed := (self paneNamed: 'cornerYStyleFixed').
    cornerYStyleScaled := (self paneNamed: 'cornerYStyleScaled').
    cornerYAnchor := (self paneNamed: 'cornerYAnchor').
    afterRect := (self paneNamed: 'afterRect').
    beforeRect := (self paneNamed: 'beforeRect').
    bottomRelative := (self paneNamed: 'bottomRelative').
    rightRelative := (self paneNamed: 'rightRelative').
    leftRelative := (self paneNamed: 'leftRelative').
    topRelative := (self paneNamed: 'topRelative').! 
initWindow

    self initInstVars.

    self initializeOnFramer: framingParameters
            rects:               currentRectList
            parentRect:     parentRect.

    afterRect bringToTop.!   
isWBWindow

    ^true!  
newFramerForRect: aRect parentRect: parentsRect

    | anchor coord framer |

    framer := FramingParameters new.
    framer initialExtent: framingParameters initialExtent.

    (xCenteredCheckBox selection) ifTrue: [
        framer xCentered.
    ] ifFalse: [

        anchor := originXAnchor selectedItem.
        coord := aRect left.

        (originXStyleFixed selection) & (anchor ~= 'Pane right') ifTrue: [
            (anchor = 'Window right') ifTrue: [
                coord := parentsRect width - coord.
                framer left: coord relativeTo: #right.
            ] ifFalse: [ (anchor = 'Window center') ifTrue: [
                coord := coord - (parentsRect width // 2).
                framer left: coord relativeTo: #center.
            ] ifFalse: [
                framer left: coord relativeTo: #left.
            ]].
        ].

        (originXStyleScaled selection) ifTrue: [
            coord := coord/parentsRect extent x.
            framer leftProportional: coord.
        ].
        anchor := cornerXAnchor selectedItem.
        coord := aRect right.

        (cornerXStyleFixed selection) & (anchor ~=  'Pane left') ifTrue: [
            (anchor = 'Window right') ifTrue: [
                coord := parentsRect width - coord.
                framer right: coord relativeTo: #right.
            ] ifFalse: [ (anchor = 'Window center') ifTrue: [
                coord := coord - (parentsRect width // 2).
                framer right: coord relativeTo: #center.
            ] ifFalse: [
                framer right: coord relativeTo: #left.
            ]].
        ].

        (cornerXStyleScaled selection) ifTrue: [
            coord := coord/parentsRect extent x.
            framer rightProportional: coord.
        ].
    ].

    (yCenteredCheckBox selection) ifTrue: [
        framer yCentered.
    ] ifFalse: [

        anchor := originYAnchor selectedItem.
        coord := aRect top.

        (originYStyleFixed selection) & (anchor ~= 'Pane bottom') ifTrue: [
            (anchor = 'Window top') ifTrue: [
                framer top: coord relativeTo: #top.
            ] ifFalse: [ (anchor = 'Window center') ifTrue: [
                framer top: coord - (parentsRect height // 2) relativeTo: #center.
            ] ifFalse: [
                framer top: parentsRect height - coord relativeTo: #bottom.
            ]].
        ].

        (originYStyleScaled selection) ifTrue: [
            coord := coord/parentsRect extent y.
            framer topProportional: coord.
        ].

        anchor := cornerYAnchor selectedItem.
        coord := aRect bottom.

        (cornerYStyleFixed selection) & (anchor ~= 'Pane top') ifTrue: [
            (anchor = 'Window top') ifTrue: [
                framer bottom: coord relativeTo: #top.
            ] ifFalse: [ (anchor = 'Window center') ifTrue: [
                framer bottom: coord - (parentsRect height // 2) relativeTo: #center.
            ] ifFalse: [
                framer bottom: parentsRect height - coord relativeTo: #bottom.
            ]].
        ].

        (cornerYStyleScaled selection) ifTrue: [
            coord := coord/parentsRect extent y.
            framer bottomProportional: coord.
        ].
    ].

    framer left isNil & framer right isNil ifTrue: [
        framer left: aRect left relativeTo: #left.
    ].
    framer top isNil & framer bottom isNil ifTrue: [
        framer bottom: aRect bottom relativeTo: #bottom.
    ].

    ^framer! 
ok: ignored

    result := currentRectList collect: [ :r|
        framingParameters initialExtent: r extent.
        self newFramerForRect: r parentRect: parentRect.
    ].
    self close!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Set Framing Parameters';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1298 @ 712; xC; yC; cRDU: (11 @ 702 rightBottom: 1287 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 878 @ 104; lDU: 18 r: #left; rDU: 896 r: #left; tDU: 16 r: #top; bDU: 120 r: #top);
                    startGroup;
                    contents: 'Centering';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 267 @ 32; lDU: 923 r: #left; rDU: 1191 r: #left; tDU: 296 r: #top; bDU: 328 r: #top);
                    paneName: 'pane1';
                    startGroup;
                    contents: 'After resizing:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 18 r: #left; rDU: 155 r: #left; tDU: 496 r: #top; bDU: 528 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Bottom:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 304 @ 32; lDU: 923 r: #left; rDU: 1227 r: #left; tDU: 16 r: #top; bDU: 48 r: #top);
                    paneName: 'pane2';
                    startGroup;
                    contents: 'Before resizing:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 46 r: #left; rDU: 155 r: #left; tDU: 256 r: #top; bDU: 288 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Right:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 347 r: #left; rDU: 539 r: #left; tDU: 384 r: #top; bDU: 416 r: #top);
                    paneName: 'topRelative';
                    rightJustified;
                    startGroup;
                    contents: 'relative to:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 347 r: #left; rDU: 539 r: #left; tDU: 256 r: #top; bDU: 288 r: #top);
                    paneName: 'rightRelative';
                    rightJustified;
                    startGroup;
                    contents: 'relative to:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 347 r: #left; rDU: 539 r: #left; tDU: 152 r: #top; bDU: 184 r: #top);
                    paneName: 'leftRelative';
                    rightJustified;
                    startGroup;
                    contents: 'relative to:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 82 @ 32; lDU: 73 r: #left; rDU: 155 r: #left; tDU: 384 r: #top; bDU: 416 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Top:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 82 @ 32; lDU: 73 r: #left; rDU: 155 r: #left; tDU: 152 r: #top; bDU: 184 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Left:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 347 r: #left; rDU: 539 r: #left; tDU: 496 r: #top; bDU: 528 r: #top);
                    paneName: 'bottomRelative';
                    rightJustified;
                    startGroup;
                    contents: 'relative to:';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 389 @ 40; lDU: 46 r: #left; rDU: 434 r: #left; tDU: 56 r: #top; bDU: 96 r: #top);
                    paneName: 'xCenteredCheckBox';
                    startGroup;
                    tabStop;
                    contents: 'Center &horizontally';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 341 @ 40; lDU: 503 r: #left; rDU: 843 r: #left; tDU: 56 r: #top; bDU: 96 r: #top);
                    paneName: 'yCenteredCheckBox';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #yCenteredToggled:;
                    contents: 'Center &vertically';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 146 @ 40; lDU: 174 r: #left; rDU: 320 r: #left; tDU: 144 r: #top; bDU: 184 r: #top);
                    paneName: 'originXStyleFixed';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #originXStyleChanged:;
                    contents: 'Fixed';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 40; lDU: 174 r: #left; rDU: 347 r: #left; tDU: 184 r: #top; bDU: 224 r: #top);
                    paneName: 'originXStyleScaled';
                    when: #clicked perform: #originXStyleChanged:;
                    contents: 'Scaled';
                    yourself
            );
            addSubpane: (
                WBFramerExample new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 336 @ 200; lDU: 923 r: #left; rDU: 1259 r: #left; tDU: 336 r: #top; bDU: 536 r: #top);
                    paneName: 'afterRect';
                    yourself
            );
            addSubpane: (
                WBFramerExample new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 251 @ 196; lDU: 923 r: #left; rDU: 1175 r: #left; tDU: 52 r: #top; bDU: 248 r: #top);
                    paneName: 'beforeRect';
                    yourself
            );
            addSubpane: (
                WBComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 352 @ 190; lDU: 549 r: #left; rDU: 901 r: #left; tDU: 144 r: #top; bDU: 334 r: #top);
                    paneName: 'originXAnchor';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #select perform: #originXAnchorChanged:;
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 149 @ 40; lDU: 174 r: #left; rDU: 322 r: #left; tDU: 248 r: #top; bDU: 288 r: #top);
                    paneName: 'cornerXStyleFixed';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cornerXStyleChanged:;
                    contents: 'Fixed';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 40; lDU: 174 r: #left; rDU: 347 r: #left; tDU: 288 r: #top; bDU: 328 r: #top);
                    paneName: 'cornerXStyleScaled';
                    when: #clicked perform: #cornerXStyleChanged:;
                    contents: 'Scaled';
                    yourself
            );
            addSubpane: (
                WBComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 352 @ 190; lDU: 553 r: #left; rDU: 905 r: #left; tDU: 252 r: #top; bDU: 442 r: #top);
                    paneName: 'cornerXAnchor';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #select perform: #cornerXAnchorChanged:;
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 149 @ 40; lDU: 174 r: #left; rDU: 322 r: #left; tDU: 376 r: #top; bDU: 416 r: #top);
                    paneName: 'originYStyleFixed';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #originYStyleChanged:;
                    contents: 'Fixed';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 40; lDU: 174 r: #left; rDU: 347 r: #left; tDU: 416 r: #top; bDU: 456 r: #top);
                    paneName: 'originYStyleScaled';
                    when: #clicked perform: #originYStyleChanged:;
                    contents: 'Scaled';
                    yourself
            );
            addSubpane: (
                WBComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 352 @ 190; lDU: 549 r: #left; rDU: 901 r: #left; tDU: 376 r: #top; bDU: 566 r: #top);
                    paneName: 'originYAnchor';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #select perform: #originYAnchorChanged:;
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 149 @ 40; lDU: 174 r: #left; rDU: 322 r: #left; tDU: 488 r: #top; bDU: 528 r: #top);
                    paneName: 'cornerYStyleFixed';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cornerYStyleChanged:;
                    contents: 'Fixed';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 174 @ 40; lDU: 174 r: #left; rDU: 347 r: #left; tDU: 528 r: #top; bDU: 568 r: #top);
                    paneName: 'cornerYStyleScaled';
                    when: #clicked perform: #cornerYStyleChanged:;
                    contents: 'Scaled';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 158 @ 52; lDU: 27 r: #left; rDU: 185 r: #left; tDU: 592 r: #top; bDU: 644 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 158 @ 52; lDU: 201 r: #left; rDU: 359 r: #left; tDU: 592 r: #top; bDU: 644 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
            addSubpane: (
                WBComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 352 @ 190; lDU: 549 r: #left; rDU: 901 r: #left; tDU: 488 r: #top; bDU: 678 r: #top);
                    paneName: 'cornerYAnchor';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #select perform: #cornerYAnchorChanged:;
                    yourself
            );
        yourself
    ).

    self openWindow! 
openOnFramer: framer rects: rectList parentRect: aParentRect

    framingParameters := framer.
    currentRectList := rectList.
    parentRect := aParentRect.

    ^self open.!
originXAnchorChanged:  newAnchor

    (newAnchor selectedItem = 'Pane right') ifTrue: [
        cornerXAnchor disableItem: 'Pane left'.
    ] ifFalse: [
        cornerXAnchor enableItem: 'Pane left'.
    ].

    self setExampleRects.!
originXStyleChanged: styleRadio

    (styleRadio contents = 'Scaled') & (styleRadio selection)  ifTrue: [
        originXAnchor selection: 'Window left'.
        originXAnchor disable.
        leftRelative disable.
    ] ifFalse: [
        leftRelative enable.
        originXAnchor enable.
    ].

    self setExampleRects.!  
originYAnchorChanged:  newAnchor

    (newAnchor selectedItem = 'Pane bottom') ifTrue: [
        cornerYAnchor disableItem: 'Pane top'.
    ] ifFalse: [
        cornerYAnchor enableItem: 'Pane top'.
    ].

    self setExampleRects.! 
originYStyleChanged: styleRadio

    (styleRadio contents = 'Scaled') & (styleRadio selection)  ifTrue: [
        originYAnchor selection: 'Window top'.
        originYAnchor disable.
        topRelative disable.
    ] ifFalse: [
        topRelative enable.
        originYAnchor enable.
    ].

    self setExampleRects.! 
result

    ^result!
setExampleRects

    | pRect framer  |

    hasFramed ifFalse: [ ^self ].

    framer :=self newFramerForRect: currentRectList first parentRect: parentRect.

    pRect := framer value: parentRect.
    pRect := ((parentRect offsetFromLeftTop: pRect) * beforeScaleFactor) rounded + (1@1) extentFromLeftTop:  (pRect extent * beforeScaleFactor) rounded.

    beforeRect paneRect: pRect.

    pRect := framer value: largeParentRect.
    pRect := ((largeParentRect offsetFromLeftTop: pRect) * beforeScaleFactor) rounded + (1@1) extentFromLeftTop:  (pRect extent * beforeScaleFactor) rounded.

    afterRect paneRect: pRect.!
xCenteredToggled: centerCheckBox

    | isCentered |



    isCentered := centerCheckBox selection.

    isCentered  ifTrue: [

        originXStyleFixed selection: true.
        originXStyleScaled selection: false.
        cornerXStyleFixed selection: true.
        cornerXStyleScaled selection: false.

        originXAnchor selection: 'Window left'.
        cornerXAnchor selection: 'Window left'.

        originXStyleFixed disable.
        originXStyleScaled disable.
        cornerXStyleFixed disable.
        cornerXStyleScaled disable.
        originXAnchor disable.
        cornerXAnchor disable.
        leftRelative disable.
        rightRelative disable.
    ] ifFalse: [
        originXStyleFixed enable.
        originXStyleScaled enable.
        cornerXStyleFixed enable.
        cornerXStyleScaled enable.
        originXAnchor enable.
        cornerXAnchor enable.
        leftRelative enable.
        rightRelative enable.
    ].

    self setExampleRects.!  
yCenteredToggled: centerCheckBox

    | isCentered |

    isCentered := centerCheckBox selection.

    isCentered  ifTrue: [

        originYStyleFixed selection: true.
        originYStyleScaled selection: false.
        cornerYStyleFixed selection: true.
        cornerYStyleScaled selection: false.

        originYAnchor selection: 'Window top'.
        cornerYAnchor selection: 'Window top'.

        originYStyleFixed disable.
        originYStyleScaled disable.
        cornerYStyleFixed disable.
        cornerYStyleScaled disable.
        originYAnchor disable.
        cornerYAnchor disable.
        topRelative disable.
        bottomRelative disable.
    ] ifFalse: [
        originYStyleFixed enable.
        originYStyleScaled enable.
        cornerYStyleFixed enable.
        cornerYStyleScaled enable.
        originYAnchor enable.
        cornerYAnchor enable.
        topRelative enable.
        bottomRelative enable.
    ].

    self setExampleRects.! !

! WBListChooser class methods !   
fromList: aList prompt: questionString

    ^super new fromList: aList prompt: questionString!  
isWBInternalClass

    ^true! !

! WBListChooser methods !
cancel: aButton

    self mainView close!   
fromList: aList prompt: questionString

        "Private - Initialize a Prompter window
         and give it control."

    | lineHeight charSize |

    self
        labelWithoutPrefix: '';
        when: #opened perform: #opened:.
    charSize := WindowDialog unitMultiplier.

    lineHeight := charSize y.

    self addSubpane:
        (StaticText new
            centered;
            contents: questionString;
            framingBlock: [:box |
                (box leftTop rightAndDown: lineHeight@5)
                    extentFromLeftTop: (box width - 10) @ lineHeight ] ).

    self addSubpane:
        (self listClass new
            paneName: 'list';
            contents: aList;
            when: #doubleClickSelect perform: #ok:;
            framingBlock: [:box |  ((box leftTop
                     rightAndDown: (1 @ 2) * charSize))
                     rightBottom:  (box rightBottom leftAndUp: (1@3) * charSize) ] ).

    self addSubpane:
        (Button new
            defaultPushButton;
            contents: 'OK';
            when: #clicked perform: #ok:;
            framingBlock: [:box | ((box leftBottom
                        rightAndUp: (1 @ (5/2)) * charSize))
                    extentFromLeftTop: (10 @ 2) * charSize ] ).

    self addSubpane:
        (Button new
            contents: 'Cancel';
            when: #clicked perform: #cancel:;
            framingBlock: [:box | ((box leftBottom
                        rightAndUp: (12 @ (5/2)) * charSize))
                    extentFromLeftTop: (10 @ 2) * charSize ] ).

    self openWindow.

    ^reply!
fromList: aList prompt: questionString selection: s

    sel := s.
    ^self fromList: aList prompt: questionString!   
initWindowSize

    ^180@160!   
isWBWindow

    ^true!  
listClass

    ^ListBox!
ok: aButton

    reply := (self paneNamed: #list) selectedItem.

    self mainView close! 
opened: topPane

        "Private - Dialog is opened, select the text
         and set the initial focus."

    | list |

    list := self paneNamed: #list.

    sel notNil ifTrue: [
        list selection: sel.
    ] ifFalse: [
        list contents notEmpty ifTrue: [
            list selectIndex: 1.
        ].
    ].

    list setFocus.! !

! WBMultiListChooser methods !
listClass

    ^MultipleSelectListBox!  
ok: aButton

    reply := (self paneNamed: #list) selectedItems.

    self mainView close!
opened: topPane

        "Private - Dialog is opened, select the text
         and set the initial focus."

    | list |

    list := self paneNamed: #list.

    sel notNil ifTrue: [
        list selection: sel.
    ].

    list setFocus.!  
preInitWindow

    | charSize |
    charSize := WindowDialog unitMultiplier.

    self addSubpane:
        (Button new
            contents: 'Select All';
            when: #clicked perform: #selectAll:;
            framingBlock: [:box | ((box leftBottom
                        rightAndUp: (23 @ (5/2)) * charSize))
                    extentFromLeftTop: (10 @ 2) * charSize ] ).!  
selectAll: aPane

    | list |
    list := self paneNamed: 'list'.
    list contents do: [ :item | list selectItem: item ].! !

! WBMDIAttributesEditor class methods ! 
isWBInternalClass

    ^true! !

! WBMDIAttributesEditor methods !
cancel: aPane

    result := nil.
    self close!  
currentEvent

    | event |

    event := when.
    (event at: 1) = $* ifTrue: [
        event := event copyFrom: 2 to: event size.
    ].

    ^event asSymbol! 
events

    ^who supportedEvents asSortedCollection!
getValidMethodName: string

    | newString |

    newString := (string select: [ :c | c isAlphaNumeric ]).

    (newString notEmpty and: [ newString first isDigit ]) ifTrue: [
        ^nil
    ].

    ^newString!   
initWindow

    (self paneNamed: 'toolPane') selection: attributes hasToolPane.
    (self paneNamed: 'statusPane') selection: attributes hasStatusPane.
    (self paneNamed: 'titleText') contents: attributes label.!
isWBWindow

    ^true!  
ok: aPane

    attributes toolPane: (self paneNamed: 'toolPane') selection.
    attributes statusPane: (self paneNamed: 'statusPane') selection.
    attributes label: (self paneNamed: 'titleText') contents.

    result := attributes.

    self close!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'MDI Attributes';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 576 @ 520; xC; yC; cRDU: (11 @ 510 rightBottom: 565 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 521 @ 168; lDU: 18 r: #left; rDU: 539 r: #left; tDU: 216 r: #top; bDU: 384 r: #top);
                    startGroup;
                    contents: 'Events For:';
                    yourself
            );
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 521 @ 168; lDU: 18 r: #left; rDU: 539 r: #left; tDU: 24 r: #top; bDU: 192 r: #top);
                    startGroup;
                    contents: 'MDI Frame';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 85 @ 32; lDU: 37 r: #left; rDU: 121 r: #left; tDU: 80 r: #top; bDU: 112 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Title:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 110 @ 32; lDU: 89 r: #left; rDU: 199 r: #left; tDU: 272 r: #top; bDU: 304 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'When:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 137 @ 32; lDU: 64 r: #left; rDU: 201 r: #left; tDU: 328 r: #top; bDU: 360 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Perform:';
                    yourself
            );
            addSubpane: (
                StaticBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 311 @ 152; lDU: 210 r: #left; rDU: 521 r: #left; tDU: 216 r: #top; bDU: 368 r: #top);
                    whiteRect;
                    startGroup;
                    yourself
            );
            addSubpane: (
                EntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 393 @ 48; lDU: 128 r: #left; rDU: 521 r: #left; tDU: 72 r: #top; bDU: 120 r: #top; indent: 3 @ 4);
                    paneName: 'titleText';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 171 @ 40; lDU: 46 r: #left; rDU: 217 r: #left; tDU: 136 r: #top; bDU: 176 r: #top);
                    paneName: 'toolPane';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #toolPaneChecked:;
                    contents: '&Tool Bar';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 224 @ 40; lDU: 293 r: #left; rDU: 517 r: #left; tDU: 136 r: #top; bDU: 176 r: #top);
                    paneName: 'statusPane';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #statusPaneChecked:;
                    contents: '&Status Pane';
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 311 @ 198; lDU: 210 r: #left; rDU: 521 r: #left; tDU: 208 r: #top; bDU: 406 r: #top);
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #whoContents:;
                    when: #select perform: #whoSelected:;
                    yourself
            );
            addSubpane: (
                ComboBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 313 @ 200; lDU: 210 r: #left; rDU: 523 r: #left; tDU: 264 r: #top; bDU: 464 r: #top);
                    paneName: 'when';
                    dropDownList;
                    startGroup;
                    tabStop;
                    when: #getContents perform: #whenContents:;
                    when: #select perform: #whenSelected:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 311 @ 48; lDU: 210 r: #left; rDU: 521 r: #left; tDU: 320 r: #top; bDU: 368 r: #top; indent: 3 @ 4);
                    paneName: 'perform';
                    startGroup;
                    tabStop;
                    when: #getContents perform: #performContents:;
                    when: #textChanged perform: #performChanged:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 56; lDU: 18 r: #left; rDU: 183 r: #left; tDU: 392 r: #top; bDU: 448 r: #top);
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 165 @ 56; lDU: 201 r: #left; rDU: 366 r: #left; tDU: 392 r: #top; bDU: 448 r: #top);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!   
openOn: a

    result := a.
    attributes := a deepCopy.
    eventDict := attributes frameEvents.

    who := Smalltalk at: #MDIFrame ifAbsent: [ self error: 'MDI not installed' ].
    when := self events first.

    self open.!
performChanged: aPane

    (self getValidMethodName: aPane contents) = (eventDict at: self currentEvent ifAbsent: ['']) asString ifTrue: [
        ^self
    ].

    self saveWhenPerform.! 
performContents: aPane

    self updateWhoEvents.

    eventDict isNil ifTrue: [
        aPane contents: ''.
    ] ifFalse: [
        aPane contents: (eventDict at: self currentEvent ifAbsent: [ '' ]).
    ].! 
result

    ^result!
saveWhenPerform

    | methodName savedSelection perform |

    perform := self paneNamed: #perform.


    perform contents hasContent ifTrue: [

        methodName := self getValidMethodName: perform contents.
        (perform contents = methodName) ifFalse: [
            savedSelection := perform getSelection.
            perform contents: methodName.
            perform setSelectionFrom: savedSelection origin x - 1 to: savedSelection corner x - 1.
        ].
        methodName isNil ifFalse: [
            eventDict at: self currentEvent put: (methodName, ':') asSymbol.
        ].
    ] ifFalse: [
        eventDict removeKey: self currentEvent ifAbsent: [].
    ].

    self updateEvents: true.!   
statusPaneChecked: aPane

    attributes hasStatusPane: aPane selection.
    self updateWho.!  
toolPaneChecked: aPane

    attributes hasToolPane: aPane selection.
    self updateWho.!  
updateEvents: refresh

    | oldEvents theEvents sel whenCombo perform |


    whenCombo := self paneNamed: #when.
    perform := self paneNamed: #perform.

    oldEvents := whenCombo contents.
    theEvents := who supportedEvents asArray.

    eventDict isNil ifTrue: [
        theEvents := #().
    ] ifFalse: [
        theEvents := theEvents collect: [:e |
            (eventDict at: e ifAbsent: [ nil ]) isSymbol ifTrue: [ '*', e ] ifFalse: [ e asString ].
        ].
    ].

    theEvents := theEvents asSortedCollection asOrderedCollection.
    theEvents = oldEvents ifTrue: [
        ^self
    ].

    refresh ifTrue: [
        sel := whenCombo selectedItem.
        (sel notNil and: [ sel notEmpty ]) ifTrue: [
            sel first = $* ifTrue: [
                sel := sel copyFrom: 2 to: sel size.
            ].
            perform contents notEmpty ifTrue: [
                sel := '*', sel.
            ].
        ].

        whenCombo
            contents: theEvents;
            selectItem: sel;
            invalidateRect: whenCombo rectangle.
    ] ifFalse: [
        whenCombo
            contents: theEvents;
            selection: 1.
    ].

    when := whenCombo selectedItem.!  
updateWho

    self changed: #whoContents:.!
updateWhoEvents

    who == (Smalltalk at: #MDIFrame ifAbsent: [ nil ]) ifTrue: [
        eventDict := attributes frameEvents.
    ] ifFalse: [
        who == (Smalltalk at: #ToolPane ifAbsent: [ nil ]) ifTrue: [
            eventDict := attributes toolPaneEvents
        ] ifFalse: [
            eventDict := attributes statusPaneEvents.
        ].
    ].!   
whenContents: aPane

    self updateEvents: false.! 
whenSelected: aPane

    when := aPane selectedItem.
    self changed: #performContents:.! 
whoContents: aPane

    | strings |

    strings := OrderedCollection with: 'MDIFrame'.

    attributes hasToolPane  ifTrue: [
        strings add: 'ToolPane'
    ].

    attributes hasStatusPane ifTrue: [
        strings add: 'StatusPane'
    ].

    aPane
        contents: strings;
        selection: strings first.

    self whoSelected: aPane!
whoSelected: aPane

    aPane selectedItem isNil ifTrue: [ ^nil ].
    who := Smalltalk at: aPane selectedItem asSymbol.
    self updateWhoEvents.
    when := self events first.
    self
        changed: #whenContents:;
        changed: #performContents:.! !

! WBMenuEditor class methods !  
isWBInternalClass

    ^true! !

! WBMenuEditor methods ! 
accelCheckBoxChanged: accelCheckBox

    accelCheckBox selection  ifFalse: [
        keyShortCutEditor accelerator: nil.
    ].!  
action: aPane

    "Link this menu option to an action"

    | item list itemIndex |

    list := menuItemsEditor contents asFlatList.
    itemIndex := menuItemsEditor selection.
    list size < itemIndex ifTrue: [
        ^self
    ].
    item := list at: itemIndex.

    WBActionEditor new openOn: item.

    self fillInCurrentItem.!
allowAttributesFor: anItem

    ^anItem hasChildren not & anItem isSeparator not!   
allowDividerFor: anItem

    ^anItem hasChildren not!   
cancel: ignore
    Notifier isAltDown ifTrue: [ ^editedMenu inspect ].
    self close!  
checkKeyAccels

    | currentItem  accelerator |

    currentItem := menuItemsEditor selectedItem.
    accelerator := currentItem accelerator.
    currentItem allRelations do: [ :p |
        p ~= currentItem ifTrue: [
            (accelerator notNil and: [ p accelerator = accelerator ]) ifTrue: [
                ^MessageBox messageNote:  ' Another menu item (', p title stripMnemonic trimBlanks asQuotedString, ') already uses the accelerator ', accelerator fullKeyName,'.  Please choose another.'
            ].
        ].
    ].! 
checkMnemonics

    | currentItem  mnemonic |

    currentItem := menuItemsEditor selectedItem.
    mnemonic := currentItem listString mnemonicChar.

    currentItem parent children do: [ :p |
        p ~= currentItem ifTrue: [
            mnemonic notNil & (p listString mnemonicChar = mnemonic) ifTrue: [
                ^MessageBox messageNote:  'Another menu item (', p listString stripMnemonic trimBlanks asQuotedString, ') already uses the mnemonic ~', mnemonic asUpperCase asString, '.  Please choose another.'
            ].
        ].
    ].!  
commitSelection: menuItemEditor

    | oldIndex |

    (oldIndex := menuItemEditor previousSelection) notNil ifTrue: [
        self updateItem: oldIndex.
    ].

    ^true!  
deleteItem: ignore

    menuItemsEditor deleteSelection.
    self fillInCurrentItem.!  
disableAttributes: bool

    | currentItem |

    currentItem := menuItemsEditor selectedItem.

    (bool) ifTrue: [
        hasAccelCheckBox disable.
        isAlt disable.
        isCtrl disable.
        isShift disable.
        keyShortCutEditor disable.
    ] ifFalse: [
        hasAccelCheckBox enable.
        isAlt enable.
        isCtrl enable.
        isShift enable.
        keyShortCutEditor enable.
   ].!   
fillInCurrentItem

    | currentItem |

    currentItem := menuItemsEditor selectedItem.

    self updateTestButton.

    currentItem selector isMessage ifTrue: [
        currentItem selector receiver isWBAction ifTrue: [
            selectorEditor contents: '<Action: ',currentItem selector receiver script asString,'>'
        ] ifFalse: [
            selectorEditor contents: '<Link: ',currentItem selector receiver asString,'>'
        ].
    ] ifFalse: [ currentItem selector notNil ifTrue: [
        selectorEditor contents: currentItem selector asString.
    ] ifFalse: [
        selectorEditor contents: ''.
    ]].

    dividerState selection: currentItem isSeparator & currentItem hasChildren not.

    self disableAttributes: (self allowAttributesFor: currentItem) not.
    (self allowDividerFor: currentItem) ifTrue: [
        dividerState enable.
    ] ifFalse: [
        dividerState disable.
    ].

    keyShortCutEditor
        accelerator: currentItem accelerator;
        selectAll.

    (self allowAttributesFor: currentItem) ifFalse: [
        keyShortCutEditor accelerator: nil.
    ].

    isShift selection: (currentItem hasChildren not & currentItem accelerator notNil and: [ currentItem accelerator isShift ]).
    isCtrl selection: (currentItem hasChildren not & currentItem accelerator notNil and: [ currentItem accelerator isCtrl ]).
    isAlt selection: (currentItem hasChildren not & currentItem accelerator notNil and: [ currentItem accelerator isAlt ]).
    hasAccelCheckBox selection: currentItem hasChildren not & keyShortCutEditor contents notEmpty.

    currentItem canExdent not ifTrue: [
        shiftLeftButton disable.
    ] ifFalse: [
        shiftLeftButton enable.
    ].
    currentItem canIndent not ifTrue: [
        shiftRightButton disable
    ] ifFalse: [
        shiftRightButton enable.
    ].

    currentItem canMoveUp not ifTrue: [
        shiftUpButton disable.
    ] ifFalse: [
        shiftUpButton enable.
    ].

    currentItem canMoveDown not ifTrue: [
        shiftDownButton disable.
    ] ifFalse: [
        shiftDownButton enable.
    ].!   
getTestItMenu: button

    | m |

    self updateItem: menuItemsEditor selection.
    m :=  menuItemsEditor contents asMenu.
    m owner: self.
    button setPopupMenu: m.!   
initializeOn: aPMenu

    (aPMenu hasChildren) ifFalse: [
        aPMenu addChild: WBPMenuItem new.
    ].

    aPMenu updateListStrings.
    menuItemsEditor contents: aPMenu.
    (self paneNamed: 'listEntryField')
        contents: aPMenu firstChild title;
        selectAll.
    menuItemsEditor selectIndex: 1.

    self fillInCurrentItem.!   
initInstVars

    keyShortCutEditor := (self paneNamed: 'keyShortCutEditor').
    hasAccelCheckBox := (self paneNamed: 'hasAccelCheckBox').
    isShift := (self paneNamed: 'isShift').
    isAlt := (self paneNamed: 'isAlt').
    isCtrl := (self paneNamed: 'isCtrl').
    dividerState := (self paneNamed: 'dividerState').
    shiftUpButton := (self paneNamed: 'shiftUpButton').
    shiftDownButton := (self paneNamed: 'shiftDownButton').
    shiftLeftButton := (self paneNamed: 'shiftLeftButton').
    shiftRightButton := (self paneNamed: 'shiftRightButton').
    testItButton := (self paneNamed: 'testItButton').
    menuItemsEditor := (self paneNamed: 'menuItemsEditor').
    selectorEditor := (self paneNamed: 'selectorEditor').!  
initWindow

    self initInstVars.
    (self paneNamed: 'listEntryField')
        owningListBox: menuItemsEditor.

    self initializeOn: editedMenu.!  
insertItem: ignore

    menuItemsEditor insertAfterSelection.
    self fillInCurrentItem.! 
isWBWindow

    ^true!  
link: aPane

    "Link this menu option to a ViewManager"

    | item list itemIndex |

    list := menuItemsEditor contents asFlatList.
    itemIndex := menuItemsEditor selection.
    list size < itemIndex ifTrue: [
        ^self
    ].
    item := list at: itemIndex.

    WBLinkEditor new openOn: item.

    self fillInCurrentItem.!
menuItemNameChanged: menuEditor

    "If the name is a dash and it's legit, make the item a divider."

    | currentItem titleIsSeparator |

    self checkMnemonics.
    self updateTestButton.

    currentItem := menuEditor selectedItem.
    (self allowDividerFor: currentItem) ifFalse: [
        ^self
    ].

    titleIsSeparator := currentItem title notEmpty and: [ currentItem title first = $- ].

    (titleIsSeparator) ifTrue: [
        dividerState selection: true.
        currentItem isSeparator: true.
        self newDividerState: dividerState.
    ] ifFalse: [

     "If it was a divider, and isn't now, turn the divider off"
        (currentItem isSeparator & titleIsSeparator not) ifTrue: [
            dividerState selection: false.
            currentItem isSeparator: false.
            self newDividerState: dividerState.
        ].
    ].!
newAccelerator: anEntryField

    | accel |

    self warnOfAccelerators.

    self checkKeyAccels.

    (accel := anEntryField accelerator) notNil ifTrue: [
        isAlt selection: accel isAlt.
        isCtrl selection: accel isCtrl.
        isShift selection: accel isShift.
    ].

    hasAccelCheckBox selection:  accel notNil.!   
newDividerState: checkBox

    | isNowDivider  |

    isNowDivider := checkBox selection.

    keyShortCutEditor contents: ''.

    hasAccelCheckBox selection: false.
    self disableAttributes: (self allowAttributesFor: menuItemsEditor selectedItem) not | isNowDivider.

    isNowDivider ifTrue: [
        menuItemsEditor setSelectionText:  '--------'.
     ].!   
newMenuClass

    ^WBPMenu! 
ok: ignore

    self updateItem: menuItemsEditor selection.
    result := self pMenu.
    super close!
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Menu Editor';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1417 @ 568; xC; yC; cRDU: (11 @ 558 rightBottom: 1406 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 503 @ 340; lDU: 878 r: #left; rDU: 1381 r: #left; tDU: 60 r: #top; bDU: 400 r: #top);
                    paneName: 'itemAttributesGroupbox';
                    startGroup;
                    contents: 'Item attributes';
                    yourself
            );
            addSubpane: (
                StaticBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 462 @ 4; lDU: 901 r: #left; rDU: 1362 r: #left; tDU: 236 r: #top; bDU: 240 r: #top);
                    paneName: 'pane2';
                    blackRectangle;
                    startGroup;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 135 @ 32; lDU: 896 r: #left; rDU: 1031 r: #left; tDU: 120 r: #top; bDU: 152 r: #top);
                    paneName: 'pane1';
                    startGroup;
                    contents: 'Selector:';
                    yourself
            );
            addSubpane: (
                WBListEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 585 @ 48; lDU: 21 r: #left; rDU: 606 r: #left; tDU: 18 r: #top; bDU: 66 r: #top; indent: 3 @ 4);
                    paneName: 'listEntryField';
                    startGroup;
                    tabStop;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 329 @ 48; lDU: 1038 r: #left; rDU: 1367 r: #left; tDU: 112 r: #top; bDU: 160 r: #top; indent: 3 @ 4);
                    paneName: 'selectorEditor';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #selectorEditorChanged:;
                    yourself
            );
            addSubpane: (
                WBKeyEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 263 @ 48; lDU: 1104 r: #left; rDU: 1367 r: #left; tDU: 264 r: #top; bDU: 312 r: #top; indent: 3 @ 4);
                    paneName: 'keyShortCutEditor';
                    startGroup;
                    tabStop;
                    when: #keyEntered perform: #newAccelerator:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 222 @ 60; lDU: 626 r: #left; rDU: 848 r: #left; tDU: 76 r: #top; bDU: 136 r: #top);
                    paneName: 'insertItemButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #insertItem:;
                    contents: '&Insert';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 222 @ 60; lDU: 626 r: #left; rDU: 848 r: #left; tDU: 140 r: #top; bDU: 200 r: #top);
                    paneName: 'deleteItemButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #deleteItem:;
                    contents: 'De&lete';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 222 @ 60; lDU: 626 r: #left; rDU: 848 r: #left; tDU: 208 r: #top; bDU: 268 r: #top);
                    paneName: 'shiftUpButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #shiftUp:;
                    contents: 'Shift &up';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 222 @ 60; lDU: 626 r: #left; rDU: 848 r: #left; tDU: 272 r: #top; bDU: 332 r: #top);
                    paneName: 'shiftDownButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #shiftDown:;
                    contents: 'Shift do&wn';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 222 @ 62; lDU: 626 r: #left; rDU: 848 r: #left; tDU: 340 r: #top; bDU: 402 r: #top);
                    paneName: 'testItButton';
                    startGroup;
                    tabStop;
                    when: #getPopupMenu perform: #getTestItMenu:;
                    when: #clicked perform: #testMenu:;
                    contents: '&Test menu';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 40; lDU: 901 r: #left; rDU: 1056 r: #left; tDU: 176 r: #top; bDU: 216 r: #top);
                    paneName: 'dividerState';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #newDividerState:;
                    contents: 'Di&vider';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 60; lDU: 1074 r: #left; rDU: 1230 r: #left; tDU: 168 r: #top; bDU: 228 r: #top);
                    paneName: 'actionButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #action:;
                    contents: 'Action...';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 60; lDU: 1239 r: #left; rDU: 1367 r: #left; tDU: 168 r: #top; bDU: 228 r: #top);
                    paneName: 'linkButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #link:;
                    contents: 'Li&nk...';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 40; lDU: 901 r: #left; rDU: 1102 r: #left; tDU: 268 r: #top; bDU: 308 r: #top);
                    paneName: 'hasAccelCheckBox';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #accelCheckBoxChanged:;
                    contents: '&Key accel:';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 123 @ 40; lDU: 949 r: #left; rDU: 1072 r: #left; tDU: 340 r: #top; bDU: 380 r: #top);
                    paneName: 'isShift';
                    startGroup;
                    tabStop;
                    contents: '&Shift';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 80 @ 40; lDU: 1083 r: #left; rDU: 1163 r: #left; tDU: 340 r: #top; bDU: 380 r: #top);
                    paneName: 'isAlt';
                    startGroup;
                    tabStop;
                    contents: '&Alt';
                    yourself
            );
            addSubpane: (
                CheckBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 183 @ 40; lDU: 1173 r: #left; rDU: 1355 r: #left; tDU: 340 r: #top; bDU: 380 r: #top);
                    paneName: 'isCtrl';
                    startGroup;
                    tabStop;
                    contents: 'Cont&rol';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 290 @ 60; lDU: 21 r: #left; rDU: 311 r: #left; tDU: 424 r: #top; bDU: 484 r: #top);
                    paneName: 'shiftLeftButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #shiftLeft:;
                    contents: '<< &Demote item';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 290 @ 60; lDU: 318 r: #left; rDU: 608 r: #left; tDU: 424 r: #top; bDU: 484 r: #top);
                    paneName: 'shiftRightButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #shiftRight:;
                    contents: '&Promote item >>';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 231 @ 60; lDU: 878 r: #left; rDU: 1109 r: #left; tDU: 424 r: #top; bDU: 484 r: #top);
                    paneName: 'okButton';
                    idOK;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 233 @ 60; lDU: 1147 r: #left; rDU: 1381 r: #left; tDU: 424 r: #top; bDU: 484 r: #top);
                    paneName: 'cancelButton';
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
            addSubpane: (
                WBTreeListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 585 @ 326; lDU: 21 r: #left; rDU: 606 r: #left; tDU: 76 r: #top; bDU: 402 r: #top);
                    paneName: 'menuItemsEditor';
                    ownerDrawFixed;
                    startGroup;
                    tabStop;
                    when: #preSelect perform: #commitSelection:;
                    when: #textChanged perform: #menuItemNameChanged:;
                    when: #select perform: #selectedItem:;
                    yourself
            );
        yourself
    ).

    self openWindow!   
openOn: aMenu

    aMenu isNil ifTrue: [
        editedMenu := self newMenuClass new.
    ] ifFalse: [
        editedMenu := aMenu fullCopy.
    ].
    ^self open.!   
pMenu

    ^menuItemsEditor contents withoutEmptyNodes! 
result

    ^result!
selectedItem: itemsPane

    self fillInCurrentItem.!   
selectorEditorChanged: aPane

    (selectorEditor contents size ~= 0) & (self allowAttributesFor: menuItemsEditor selectedItem) not ifTrue: [
        MessageBox message: 'Cannot set attributes for top level menus.  Press Cr to insert an item, then promote it with Promote item to add menu items to a menu.'.
        selectorEditor setContents: ''.
        menuItemsEditor
            sendInputEvent: #setFocus.
    ].! 
shiftDown: ignore

    menuItemsEditor shiftSelectionDown.! 
shiftLeft: ignore

    menuItemsEditor exdentSelection.!
shiftRight: ignore

    menuItemsEditor indentSelection.!   
shiftUp: ignore

    menuItemsEditor shiftSelectionUp.! 
testMenu: ignore

    testItButton setPopupMenu:  nil.
    testItButton doPopupMenuAt: testItButton cursorWindowPosition!  
updateItem: itemIndex

    | item accel list |

    list := menuItemsEditor contents asFlatList.
    list size < itemIndex ifTrue: [
        ^self
    ].

    item := list at: itemIndex.

    item isSeparator: dividerState selection.

    hasAccelCheckBox selection  ifTrue: [
        accel := keyShortCutEditor accelerator.
        accel isAlt: isAlt selection.
        accel isShift: isShift selection.
        accel isCtrl: isCtrl selection.
        item accelerator: accel.
     ] ifFalse: [
        item accelerator: nil.
    ].

    selectorEditor contents trimBlanks notEmpty ifTrue: [
        (selectorEditor contents first == $<) ifFalse: [
            item selector: selectorEditor contents trimBlanks.
        ].
    ] ifFalse: [
         item selector: nil.
    ].!
updateTestButton

    self pMenu hasChildren ifTrue: [
        testItButton enable.
    ] ifFalse: [
        testItButton disable.
    ].!  
warnOfAccelerators

    warnedAboutAccelerators isNil ifTrue: [
        MessageBox messageNote: 'Warning: Keyboard accelerators in popup menus are not supported in Smalltalk/V.   Those you add here will appear visually, but must be in a menubar to truly function.'.
        warnedAboutAccelerators := true.
    ].! !

! WBMenubarEditor methods !  
allowAttributesFor: anItem

    ^(super allowAttributesFor: anItem) & anItem parent isRoot not! 
allowDividerFor: anItem

    ^(super allowDividerFor: anItem) & anItem parent isRoot not.!  
initWindow

    super initWindow.
    self labelWithoutPrefix: 'Menubar Editor'.!  
newMenuClass

    ^WBPMenubar!  
testMenu: ignore

    | tester |

    self updateItem: menuItemsEditor selection.

    tester := WBMenuTester new.

    tester menubar: menuItemsEditor contents asMenu.
    tester open.!   
warnOfAccelerators

    | accel |

    accel := keyShortCutEditor accelerator.

    (accel isAlt | accel isCtrl | accel isShift) not ifTrue: [
        MessageBox message: 'Digitalk does not support menu accelerators without an augmentation key (ctrl, alt, or shift).  Please add an augmentation key.'
    ].! !

! WBScrapbookRetrieve class methods !   
isWBInternalClass

    ^true! !

! WBScrapbookRetrieve methods !  
cancel: aPane

    Notifier isAltDown ifTrue: [ ^scrapbook inspect ].

    self close!
changeName: aPane
    | newName pageList |
    page isNil | chapter isNil ifTrue: [ ^nil ].
    newName := aPane contents.
    newName = page ifTrue: [ ^nil ].
    ((scrapbook at: chapter) includesKey: newName) ifTrue: [
        (MessageBox confirm: '''',newName,''' already exists. Do you want to replace it?') ifFalse: [
            aPane contents: page.
            ^nil
        ].
    ].
    (scrapbook at: chapter) at: newName put:
        ((scrapbook at: chapter) at: page).
    (scrapbook at: chapter) removeKey: page.
    self loadPages: (pageList := self paneNamed: 'pages').
    pageList selectItem: newName.
    self getPage: pageList.
    (self paneNamed: 'ok') enable.
    chapter = 'Quick Reference' ifTrue: [ removedQuick := true ].!
chapter
    ^chapter!
chapters

    ^scrapbook keys asSortedCollection!   
displayImage: aPane

    | aPen aPage mergeRect centerPoint offset |

    aPane doGraphics: [
        aPane
            backColor: aPane class defaultBackColor;
            erase.
    ].
    chapter isNil | page isNil ifTrue: [ ^nil ].

    aPage := (scrapbook at: self owner chapter) at: page.
    centerPoint := aPane rectangle center.
    mergeRect := aPage first first rect.
    aPage first do: [ :pObject | mergeRect := mergeRect merge: pObject rect ].
    offset := centerPoint -  mergeRect center.
    aPage first do: [ :pObject | pObject rect moveBy: offset ].

    aPane doGraphics: [
        aPage first do: [ :pObject |
            aPane
                backColor: aPane class defaultBackColor;
                foreColor: aPane class defaultForeColor.
            pObject isNil ifFalse: [
                pObject isCompositePane ifTrue: [ pObject realClass: pObject realClass ].
                pObject displayWith: aPane pen clipRect: aPane rectangle.
            ].
        ].
        aPane display.
    ]!  
getChapter: aPane
    | pageList |
    chapter := aPane selectedItem.
    chapter isNil ifFalse: [
        self loadPages: (pageList := self paneNamed: 'pages').
        self pages isEmpty ifFalse: [
            page := self pages first.
            pageList selectItem: page.
            self getPage: pageList.
        ] ifTrue: [
            self displayImage: (self paneNamed: 'graphic').
             (self paneNamed: 'name') contents: ''.
            self updateScrollBar.
        ].
    ].
    chapter = 'Quick Reference' ifTrue: [
        (self paneNamed: 'remove') disable
    ] ifFalse: [
        (self paneNamed: 'remove') enable
    ].!   
getPage: aPane

    page := aPane selectedItem.
    (self paneNamed: 'name') contents: page.
    (self paneNamed: 'ok') enable.
    (self paneNamed: 'remove') enable.
    self displayImage: (self paneNamed: 'graphic').
    self updateScrollBar.!  
getScrollImage: aPane
    | pageList |
    (pageList := self paneNamed: 'pages') selectIndex: aPane position.
    self getPage: pageList.! 
initWindow

    (self paneNamed: 'ok') disable.
    (self paneNamed: 'remove') disable.
    removedQuick := false.!   
loadChapters: aPane

    aPane contents: self chapters.
    (self paneNamed: 'remove') disable.
    chapter := nil.
    page := nil.!
loadPages: aPane

    aPane contents: self pages.
    (self paneNamed: 'ok') disable.
    page := nil.!   
ok: aPane

    (chapter notNil and: [ page notNil ]) ifTrue: [
        layoutPane
            clipboard: ((scrapbook at: chapter) at: page ifAbsent: [ nil ]);
            paste.
        self close
    ].!   
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Retrieve from Scrapbook';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1271 @ 584; lDU: 98 r: #left; tDU: 220 r: #top; cRDU: (11 @ 574 rightBottom: 1259 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 667 @ 512; lDU: 567 r: #left; rDU: 1234 r: #left; tDU: 8 r: #top; bDU: 520 r: #top);
                    startGroup;
                    contents: 'Selected Page';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 32; lDU: 18 r: #left; rDU: 137 r: #left; tDU: 184 r: #top; bDU: 216 r: #top);
                    startGroup;
                    contents: 'Pages:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 18 r: #left; rDU: 174 r: #left; tDU: 8 r: #top; bDU: 40 r: #top);
                    startGroup;
                    contents: 'Chapters:';
                    yourself
            );
            addSubpane: (
                GraphPane new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 631 @ 344; lDU: 585 r: #left; rDU: 1216 r: #left; tDU: 112 r: #top; bDU: 456 r: #top);
                    paneName: 'graphic';
                    noScrollBars;
                    startGroup;
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 105 @ 32; lDU: 576 r: #left; rDU: 681 r: #left; tDU: 56 r: #top; bDU: 88 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Name:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 128 @ 32; lDU: 585 r: #left; rDU: 713 r: #left; tDU: 476 r: #top; bDU: 508 r: #top);
                    paneName: 'count';
                    rightJustified;
                    startGroup;
                    contents: '';
                    foreColor: ClrDarkblue;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 530 @ 136; lDU: 18 r: #left; rDU: 549 r: #left; tDU: 44 r: #top; bDU: 180 r: #top);
                    paneName: 'chapters';
                    startGroup;
                    tabStop;
                    when: #getContents perform: #loadChapters:;
                    when: #select perform: #getChapter:;
                    yourself
            );
            addSubpane: (
                ListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 530 @ 236; lDU: 18 r: #left; rDU: 549 r: #left; tDU: 220 r: #top; bDU: 456 r: #top);
                    paneName: 'pages';
                    startGroup;
                    tabStop;
                    when: #getContents perform: #loadPages:;
                    when: #select perform: #getPage:;
                    when: #doubleClickSelect perform: #ok:;
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 521 @ 48; lDU: 695 r: #left; rDU: 1216 r: #left; tDU: 48 r: #top; bDU: 96 r: #top; indent: 3 @ 4);
                    paneName: 'name';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #changeName:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 167 @ 56; lDU: 18 r: #left; rDU: 185 r: #left; tDU: 464 r: #top; bDU: 520 r: #top);
                    paneName: 'ok';
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 167 @ 56; lDU: 201 r: #left; rDU: 368 r: #left; tDU: 464 r: #top; bDU: 520 r: #top);
                    paneName: 'cancel';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 167 @ 56; lDU: 384 r: #left; rDU: 551 r: #left; tDU: 464 r: #top; bDU: 520 r: #top);
                    paneName: 'remove';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #remove:;
                    contents: '&Remove';
                    yourself
            );
            addSubpane: (
                ScrollBar new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 494 @ 36; lDU: 722 r: #left; rDU: 1216 r: #left; tDU: 472 r: #top; bDU: 508 r: #top);
                    paneName: 'scrollbar';
                    horizontal;
                    startGroup;
                    tabStop;
                    when: #nextLine perform: #getScrollImage:;
                    when: #nextPage perform: #getScrollImage:;
                    when: #sliderPosition perform: #getScrollImage:;
                    when: #prevLine perform: #getScrollImage:;
                    when: #prevPage perform: #getScrollImage:;
                    yourself
            );
        yourself
    ).

    self openWindow!   
openOn: aPane

    scrapbook := PWindowBuilder scrapbook.
    layoutPane := aPane.
    self open! 
page
    ^page!  
pages

    ^chapter isNil ifTrue: [
        OrderedCollection new
    ] ifFalse: [
        (scrapbook at: chapter) keys asSortedCollection
    ]!   
remove: aPane

    chapter isNil ifFalse: [
        page isNil ifFalse: [
            (MessageBox confirm: 'Are you sure you want to remove the page: ''',page,'''?') ifTrue: [
                (scrapbook at: chapter) removeKey: page ifAbsent: [ nil ].
                chapter = 'Quick Reference' ifTrue: [ removedQuick := true ].
                self getChapter: (self paneNamed: 'chapters')
            ].
        ] ifTrue: [
            (MessageBox confirm: 'Are you sure you want to remove the chapter: ''',chapter,'''?') ifTrue: [
                scrapbook removeKey: chapter ifAbsent: [ nil ].
                self loadChapters: (self paneNamed: 'chapters').
                self getChapter: (self paneNamed: 'chapters')
            ].
        ].
    ]! 
removedQuick

    ^removedQuick!
scrapbook

    ^scrapbook!  
updateScrollBar
    | scrollbar size index |
    size := (scrapbook at: chapter) size.
    scrollbar := (self paneNamed: 'scrollbar').
    scrollbar
        minimum: (1 min: size) ;
        maximum: size;
        pageIncrement: 1.
    page isNil ifFalse: [
        index := self pages indexOf: page.
        scrollbar position: index.
    ] ifTrue: [
        index := 0
    ].
    (self paneNamed: 'count') contents: (index asString,' of ',size asString)! !

! WBScrapbookStore class methods ! 
isWBInternalClass

    ^true! !

! WBScrapbookStore methods ! 
cancel: aPane

    Notifier isAltDown ifTrue: [ ^PWindowBuilder scrapbook inspect ].

    self close! 
chapters

    ^PWindowBuilder scrapbook keys asSortedCollection!
getChapter: aPane

    (self paneNamed: 'name') contents isEmpty ifTrue: [ 
        (self paneNamed: 'ok') disable
    ] ifFalse: [ 
        aPane selectedItems isEmpty ifTrue: [
            (self paneNamed: 'ok') disable
        ] ifFalse: [ 
            (self paneNamed: 'ok') enable
        ].
    ]! 
getName: aPane

    aPane contents isEmpty ifTrue: [
        (self paneNamed: 'ok') disable
    ] ifFalse: [ 
        (self paneNamed: 'chapters') selectedItems isEmpty ifTrue: [
            (self paneNamed: 'ok') disable
        ] ifFalse: [
            (self paneNamed: 'ok') enable
        ].
    ]!  
initWindow

    (self paneNamed: 'name') contents: ''.
    (self paneNamed: 'ok') disable.
    isQuick := false.! 
isQuick

    ^isQuick!  
loadChapters: aPane

    aPane contents: self chapters.!
name

    ^(self paneNamed: 'name') contents.!  
newChapter: aPane

    | name |

    name := Prompter prompt: 'Enter name for new chapter.' default: ''.
    (name notNil and: [ name notEmpty ]) ifTrue: [
        (PWindowBuilder scrapbook includesKey: name) ifTrue: [
            ^MessageBox notify: 'Already Exists' withText: '''',name,''' alread exists!!'
        ].
        PWindowBuilder scrapbook at: name asString put: Dictionary new
    ].
    self loadChapters: (self paneNamed: 'chapters').!
ok: aPane

    | name chapter clipboard |

    layoutPane clipboard isNil ifFalse: [
        name := (self paneNamed: 'name') contents.
        name isEmpty ifFalse: [
            clipboard :=  layoutPane clipboard.
            (self paneNamed: 'chapters') selectedItems do: [ :chap |
                chapter := (PWindowBuilder scrapbook at: chap).
                (chapter includesKey: name) ifTrue: [
                    (MessageBox confirm: '''',name,''' already exists. Do you want to replace it?') ifFalse: [^nil]
                ].
                chapter at: name put: clipboard.
                chap = 'Quick Reference' ifTrue: [ isQuick := true ]
            ].
            self close
        ].
    ]! 
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Store in Scrapbook';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 795 @ 464; lDU: 311 r: #left; tDU: 248 r: #top; cRDU: (322 @ 702 rightBottom: 1095 @ 296));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 192 @ 32; lDU: 9 r: #left; rDU: 201 r: #left; tDU: 16 r: #top; bDU: 48 r: #top);
                    rightJustified;
                    startGroup;
                    contents: 'Page Name:';
                    yourself
            );
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 32; lDU: 18 r: #left; rDU: 174 r: #left; tDU: 64 r: #top; bDU: 96 r: #top);
                    startGroup;
                    contents: 'Chapters:';
                    yourself
            );
            addSubpane: (
                WBEntryField new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 549 @ 48; lDU: 210 r: #left; rDU: 759 r: #left; tDU: 8 r: #top; bDU: 56 r: #top; indent: 3 @ 4);
                    paneName: 'name';
                    startGroup;
                    tabStop;
                    when: #textChanged perform: #getName:;
                    yourself
            );
            addSubpane: (
                MultipleSelectListBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 741 @ 232; lDU: 18 r: #left; rDU: 759 r: #left; tDU: 104 r: #top; bDU: 336 r: #top);
                    paneName: 'chapters';
                    startGroup;
                    tabStop;
                    when: #getContents perform: #loadChapters:;
                    when: #select perform: #getChapter:;
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 238 @ 56; lDU: 521 r: #left; rDU: 759 r: #left; tDU: 344 r: #top; bDU: 400 r: #top);
                    paneName: 'newChapter';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #newChapter:;
                    contents: '&New Chapter';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 167 @ 56; lDU: 18 r: #left; rDU: 185 r: #left; tDU: 344 r: #top; bDU: 400 r: #top);
                    paneName: 'ok';
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&Store';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 167 @ 56; lDU: 201 r: #left; rDU: 368 r: #left; tDU: 344 r: #top; bDU: 400 r: #top);
                    paneName: 'cancel';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: 'Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow!   
openOn: aPane

    layoutPane := aPane.
    self open! !

! WBTabEditor class methods !  
isWBInternalClass

    ^true! !

! WBTabEditor methods !  
addLayoutPane

    | scroller layout rect|

    scroller := WBScrollingPane new
        owner: self;
        paneName: 'scrollingPane';
        framingBlock: ( FramingParameters new initialExtent: 310 @ 120; lDU: 10 r: #left; rDU: 0 r: #right; tDU: 0 r: #top; bDU: 170 r: #bottom);
        yourself.

    self addSubpane: scroller.
    layout := self newLayoutPane.

    scroller addSubpane: layout.


    rect := self mainView framingBlock clientRect.
    scroller initSize: rect.
    scroller open.
    scroller buildWindow: self mainView.
    scroller resize: rect.
    layoutPane editedPane: editedPane subpanes: panes.
    scroller scrollIfNecessaryRedraw: false.
    scroller setScrollRanges.
    scroller  showWindow.
    layout  showWindow.!
addTabGroup: aPane

    self disableButtons.
    statusLine contents: 'Click and drag to select.'.
    layoutPane mode: #settingTabGroup.!
cancel: aPane

    result := nil.
    self close!  
deletedGroup: ignore

    statusLine contents: ''.
    self enableButtons.!
disableButtons

    addGroupButton disable.
    removeGroupButton disable.!
enableButtons

    addGroupButton enable.
    removeGroupButton enable.!   
initInstVars

    statusLine := (self paneNamed: 'statusLine').
    setTabbingButton := (self paneNamed: 'setTabbingButton').
    addGroupButton := (self paneNamed: 'addGroupButton').
    removeGroupButton := (self paneNamed: 'removeGroupButton').
    okButton := (self paneNamed: 'okButton').!  
initWindow

    self initInstVars.
    self addLayoutPane.


    statusLine contents: ''.

    panes isEmpty ifTrue: [
        setTabbingButton disable.
        addGroupButton sendInputEvent: #setFocus.
    ] ifFalse: [
        setTabbingButton sendInputEvent: #setFocus.
    ].!  
newLayoutPane

    ^layoutPane := WBTabOrderLayoutPane new
        owner: self owner;
        paneName: 'layoutPane';
        when: #gettingFocus perform: #resetFocus:;
        when: #setTabPosition perform: #tabPlaced:;
        when: #setGroup perform: #setGroup:;
        when: #deletedGroup perform: #deletedGroup:;
        framingBlock: [:b | (b leftTop rightAndDown: -2@-2) extentFromLeftTop: 10000@10000 ];
        yourself!  
ok: aPane

    result := layoutPane exportedPanes.
    self close! 
open

     "WARNING!!  This method was automatically generated by
      WindowBuilder.  Code you add here which does not conform
      to the WindowBuilder API will probably be lost the next time
      you save your layout definition."

     | v |

    self addView: (
        v := self topPaneClass new
            owner: self;
            labelWithoutPrefix:  'Tab Order Editor';
            noSmalltalkMenuBar;
            viewName: 'mainView';
            framingBlock: ( FramingParameters new iDUE: 1335 @ 800; xC; yC; cRDU: (11 @ 790 rightBottom: 1323 @ 48));
            pStyle: #(sysmenu modal titlebar);
            addSubpane: (
                StaticText new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 841 @ 48; lDU: 448 r: #left; rDU: 1289 r: #left; tDU: 62 r: #bottom; bDU: 14 r: #bottom);
                    paneName: 'statusLine';
                    startGroup;
                    contents: 'StaticText';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 414 @ 68; lDU: 18 r: #left; rDU: 432 r: #left; tDU: 158 r: #bottom; bDU: 90 r: #bottom);
                    paneName: 'setTabbingButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #setTabbingOrder:;
                    contents: '&Set tabbing order';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 414 @ 68; lDU: 448 r: #left; rDU: 862 r: #left; tDU: 158 r: #bottom; bDU: 90 r: #bottom);
                    paneName: 'addGroupButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #addTabGroup:;
                    contents: '&Add group';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 414 @ 68; lDU: 878 r: #left; rDU: 1291 r: #left; tDU: 158 r: #bottom; bDU: 90 r: #bottom);
                    paneName: 'removeGroupButton';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #removeTabGroup:;
                    contents: '&Remove group';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 56; lDU: 18 r: #left; rDU: 219 r: #left; tDU: 70 r: #bottom; bDU: 14 r: #bottom);
                    paneName: 'okButton';
                    idOK;
                    defaultPushButton;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #ok:;
                    contents: '&OK';
                    yourself
            );
            addSubpane: (
                Button new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 56; lDU: 229 r: #left; rDU: 430 r: #left; tDU: 70 r: #bottom; bDU: 14 r: #bottom);
                    idCancel;
                    startGroup;
                    tabStop;
                    when: #clicked perform: #cancel:;
                    contents: '&Cancel';
                    yourself
            );
        yourself
    ).

    self openWindow! 
openOn: aPTopPane subpanes: aChildList

    editedPane := aPTopPane.
    panes :=  aChildList.

    ^self open.! 
removeTabGroup: aPane

    self disableButtons.
    statusLine contents: 'Click to delete a group.'.
    layoutPane mode: #removeTabGroup!
resetFocus: ignore

    "Sent by the tab order layout pane;  it should never get the
      input focus, so we give it to someone else"

    setTabbingButton setFocus.!  
result

    ^result!
setGroup: ignore

    self enableButtons.
    statusLine contents: ''.!
setTabbingOrder: aPane

    layoutPane isEditingTabs ifTrue: [
        statusLine contents: ''.
        self enableButtons.
        layoutPane stopEditingTabs.
        ^setTabbingButton contents: '&Set Tabbing Order'
    ].

    setTabbingButton contents: '&Done'.
    self disableButtons.
    statusLine contents: 'Click to set tab order.'.
    layoutPane setTabOrder.!
tabPlaced: ignore

    (layoutPane totalTabCount >  layoutPane tabCount) ifTrue: [
        statusLine contents:
            'Placed ',
            layoutPane tabCount asString,
            ' of ',
            layoutPane totalTabCount asString
    ] ifFalse: [
        statusLine contents: ''.
        (self paneNamed: 'setTabbingButton')
            contents: '&Set tabbing order'.
        self enableButtons.
        layoutPane stopEditingTabs.
    ].! !

! WBAction class methods !   
listActions
    | list class stream |
    list := OrderedCollection new.
    class := self.
    [ class name = 'Object' ] whileFalse: [
        list addAll:
            ((class methodDictionary keys asSortedCollection select: [ :selector |
                selector beginsWith: 'action' ]) collect: [ :method |
                    method copyFrom: 7 to: method size ]).
        class := class superclass
    ].
    ^list!   
perform: aSymbol on: aViewManager

    ^(self window: aViewManager action: aSymbol) perform!
perform: aSymbol on: aViewManager with: anActionButton

    ^(self window: aViewManager button: anActionButton action: aSymbol) perform!
performAction: aSymbol

    ^(self new script: aSymbol) perform!
receiver: anObject

    ^self new receiver: anObject!   
receiver: firstObject originator: secondObject

    ^(self new)
        receiver: firstObject;
        originator: secondObject!  
receiver: firstObject originator: secondObject script: aCollection

    ^(self new)
        receiver: firstObject;
        originator: secondObject;
        script: aCollection!
window: aViewManager

    ^self new receiver: aViewManager! 
window: aViewManager action: aSymbol

    ^(self new)
        receiver: aViewManager;
        script: aSymbol!
window: aViewManager button: anActionButton

    ^(self new)
        receiver: aViewManager;
        originator: anActionButton!  
window: aViewManager button: anActionButton action: aSymbol

    ^(self new)
        receiver: aViewManager;
        originator: anActionButton;
        script: aSymbol! !

! WBAction methods !  
actionCancel
"
Created by OSI - Jan 26, 1993
"
"Close the window"
    ^self window close!
actionInspect
"
Created by OSI - Jan 26, 1993
"
"Inspect the window"
    ^self window inspect!   
button

    ^originator!
isWBAction

    ^true!  
menuItem

    ^originator!  
missingAction
    ^MessageBox message: 'Missing action: ',self script!   
missingAction: aSymbol
    ^MessageBox message: 'Missing action: ',aSymbol,'!!'! 
originator

    ^originator!
originator: anObject

    originator := anObject.
    ^self!   
perform

    self receiver isNil ifTrue: [ self halt.
        ^MessageBox message: 'Receiver not defined!!'
    ] ifFalse: [self script isString ifTrue: [
        (self class listActions includes: self script asString) ifTrue: [
            ^self perform: ('action',self script) asSymbol
        ] ifFalse: [
            ^self missingAction: self script
        ]
    ] ifFalse: [ self script isCollection ifTrue: [
        self script do: [ :action |
            (self class listActions includes: action asString) ifTrue: [
                self perform: ('action',action) asSymbol
            ] ifFalse: [
                ^self missingAction: action
            ]
        ].
    ]]].!   
receiver

    ^receiver!
receiver: anObject

    receiver := anObject.
    ^self!   
script

    ^script!
script: aCollection

    script := aCollection.
    ^self! 
target

    ^receiver!  
window

    ^receiver! !

! WBKeyAccel class methods !
clearKeyConstants

    "     WBKeyAccel clearKeyConstants    "

    KeyConstantsDict := nil.! !

! WBKeyAccel methods ! 
= aKeyAccel

    ^(aKeyAccel isAlt = isAlt) &
     (aKeyAccel isCtrl = isControl) &
     (aKeyAccel isShift = isShift) &
     (aKeyAccel accelKey = keyCode).!   
accelArray: accelArray

    | bits accel |

    bits := accelArray at: 2.
    accel := accelArray at: 1.

    "Can happen in 1.1, if no augmentation keys used.  Most likely case
      is non-ascii, e.g. a function key, so we use AfVirtual as a basis."
    bits isNil ifTrue: [ bits := AfVirtualkey ].

    self accelBits:  bits.

    accel isNil ifTrue: [
        ^keyCode := nil
    ].

    ((bits bitAnd: AfVirtualkey) ~= 0) ifTrue: [
        self keyCode: accel
    ] ifFalse: [
       self keyCode: (KeyboardLibrary mapVirtualKey: accel mapType: 2) asCharacter.
    ].!
accelBits

    | accelBits |

    accelBits := 0.

    (isAlt) ifTrue: [ accelBits := accelBits + AfAlt ].
    (isControl) ifTrue: [ accelBits := accelBits + AfControl ].
    (isShift) ifTrue: [ accelBits := accelBits + AfShift ].

    ^accelBits! 
accelBits: accelBits

    accelBits isNil ifTrue: [
       ^isAlt := isControl := isShift := false
    ].

    isAlt := ((accelBits bitAnd: AfAlt) ~= 0).
    isControl := ((accelBits bitAnd: AfControl) ~= 0).
    isShift := ((accelBits bitAnd: AfShift) ~= 0).!  
accelKey

    ^keyCode! 
constantsDict

    KeyConstantsDict isNil ifTrue: [
        KeyConstantsDict := Dictionary new.
        WBConstants keysDo: [ :k |
            ((k at: 1) = $V) & ((k at: 2) = $k) ifTrue: [
                KeyConstantsDict at: (WBConstants at: k) put: k.
            ].
        ].
    ].

    ^KeyConstantsDict! 
fullKeyName

    | titleString |

    titleString := ''.

    self isCtrl ifTrue: [
        titleString := titleString, 'Ctrl+'.
    ].
    self isAlt ifTrue: [
        titleString := titleString, 'Alt+'.
    ].
    self isShift ifTrue: [
        titleString := titleString, 'Shift+'.
    ].

    ^titleString, self keyName!  
isAlt

    ^isAlt!  
isAlt: bool

    isAlt := bool! 
isCtrl

    ^isControl! 
isCtrl: bool

    isControl := bool!
isShift

    ^isShift!  
isShift: bool

    isShift := bool! 
keyCode: code

    keyCode := code.
    keyCode isCharacter ifFalse: [
        text := self constantsDict at: code ifAbsent: [ ^text := '' ].
        text := text copyFrom: 3 to: text size.
    ] ifTrue: [
        text := CharacterConstants keyAtValue: code ifAbsent: [ String with: code asUpperCase ].
    ].!
keyName

    ^text! 
pmKeyCodeFor: winCode

    ^WinToPMKeyMap at: winCode ifAbsent: [ nil ]!
printAccelOn: aStream

    | pmCode |

    aStream nextPut: $'.

    isAlt ifTrue: [
        aStream nextPutAll: 'Alt'.
    ].
    isShift ifTrue: [
        aStream nextPutAll: 'Shift'.
    ].
    isControl ifTrue: [
        aStream nextPutAll: 'Ctrl'.
    ].

    keyCode notNil ifTrue: [
        aStream nextPut: $+.
    ].

    keyCode isCharacter ifTrue: [
        aStream nextPut: keyCode.
    ] ifFalse: [
        pmCode := self pmKeyCodeFor: keyCode.

        pmCode notNil ifTrue: [
            aStream nextPutAll: pmCode asString
        ].
    ].

    aStream nextPut: $'.! !

! WBMDIAttributes class methods !  
new

    ^super new initialize! !

! WBMDIAttributes methods !
frameEvents

    ^frameEvents!  
frameEvents: dict

    frameEvents := dict.!
hasStatusPane

    ^hasStatusPane!  
hasStatusPane: bool

    hasStatusPane  := bool!
hasToolPane

    ^hasToolPane!  
hasToolPane: bool

    hasToolPane := bool! 
initialize

    frameEvents := Dictionary new.
    label := 'MDI Frame'.
    hasStatusPane := false.
    hasToolPane := false.
    statusPaneEvents := Dictionary new.
    toolPaneEvents := Dictionary new.!  
label

    ^label!  
label: aString

    label := aString!   
statusPane: b

    hasStatusPane :=  ((b = false) | (b isNil)) not.

    b isNil ifTrue: [ ^self ].
    (b isKindOf: (Smalltalk at: #StatusPane ifAbsent: [ nil ])) ifTrue: [
        ^statusPaneEvents := b handlers
    ].

    b ifTrue: [
        statusPaneEvents isNil ifTrue: [
            statusPaneEvents := Dictionary new.
        ].
    ] ifFalse: [
        statusPaneEvents := nil.
    ].!
statusPaneEvents

    ^statusPaneEvents!
toolPane: b

    hasToolPane := ((b = false) | (b isNil)) not.

    b isNil ifTrue: [ ^self ].
    (b isKindOf: (Smalltalk at: #ToolPane ifAbsent: [ nil ])) ifTrue: [
        ^toolPaneEvents := b handlers
    ].

    b ifTrue: [
        toolPaneEvents isNil ifTrue: [
            toolPaneEvents := Dictionary new.
        ].
    ] ifFalse: [
        toolPaneEvents := nil.
    ].!   
toolPaneEvents

    ^toolPaneEvents! !

! WBTabPosition class methods !   
fromTabPosition: anInteger

    ^WBTabPosition new
        basicTabPosition: anInteger!
new

    ^super new initialize.! !

! WBTabPosition methods ! 
<= aTabPosition

    (aTabPosition basicTabPosition > basicTabPosition) ifTrue: [
        ^true
    ].

    (aTabPosition basicTabPosition = basicTabPosition) &
    (aTabPosition groupPosition notNil & groupPosition notNil and: [
        (aTabPosition groupPosition > groupPosition)
    ]) ifTrue: [
        ^true
    ].

    ^false!
>= aTabPosition

    (aTabPosition basicTabPosition < basicTabPosition) ifTrue: [
        ^true
    ].

    (aTabPosition basicTabPosition = basicTabPosition) &
    (aTabPosition groupPosition notNil & groupPosition notNil and: [
        aTabPosition groupPosition < groupPosition
    ]) ifTrue: [
        ^true
    ].

    ^false!  
basicTabPosition

    ^basicTabPosition!
basicTabPosition: anObject

    basicTabPosition := anObject!   
firstInGroup

    ^groupPosition isNil | (groupPosition = 1)!   
groupPosition

    ^groupPosition!  
groupPosition: anObject

    groupPosition := anObject! 
inGroup

    ^groupPosition notNil! 
initialize

    basicTabPosition := 0!  
makeFirstInGroup

    groupPosition := 1.!  
nextBasicTabPosition

    ^WBTabPosition new
            basicTabPosition: basicTabPosition + 1!   
nextTabPosition

    groupPosition notNil ifTrue: [
        ^WBTabPosition new
            basicTabPosition: basicTabPosition;
            groupPosition: groupPosition + 1
    ] ifFalse: [
        ^WBTabPosition new
            basicTabPosition: basicTabPosition + 1
    ].!   
printOn: aStream

    aStream nextPutAll: basicTabPosition asString.
    groupPosition notNil ifTrue: [
        aStream nextPutAll: '.', groupPosition asString.
    ].! 
withinGroup

    ^self inGroup & self firstInGroup not! !

! WBTool class methods !   
bitmap: aBitmap selector: aSymbol

    ^(self new)
        state: #up;
        selector: aSymbol;
        bitmap: aBitmap;
        yourself! !

! WBTool methods !
bitmap

    ^bitmap!
bitmap: aBitmap

    bitmap := aBitmap! 
bitmapSelector

    ^bitmapSelector!
bitmapSelector: aSymbol

    bitmapSelector := aSymbol! 
boundingBox

    boundingBox ifNil: [
        boundingBox := IdentityDictionary new.
        boundingBox
            at: #up put: self upBoundingBox;
            at: #down put: self downBoundingBox;
            at: #disabled put: self disabledBoundingBox.
    ].
    ^boundingBox at: self state ifAbsent: [ 0@0 extent: 0@0 ].!   
boundingBox: aRectangle

    boundingBox := aRectangle! 
disabled

    self state: #disabled!
disabledBoundingBox

    ^self upBoundingBox!   
down

    self state: #down!
downBoundingBox

    ^((self bitmap width // self numImages) @ 0 extent: (self bitmap width // self numImages @ self bitmap height))!   
file

    ^file ifNil: [ file := '' ]!  
file: aString

    file := aString! 
isDisabled

    ^self state == #disabled!   
isDown

    ^self state == #down!   
isEnabled

    ^self isDisabled not!
isUp

    ^self state == #up!   
newBlankBitmap: aBitmap

    ^Bitmap
            width: aBitmap width // self numImages
            height: aBitmap height
            planes: aBitmap planes
            bitCount: aBitmap bitCount.!  
numImages

    ^2!  
numSpaces

    ^numSpaces ifNil: [ numSpaces := 0 ]!
numSpaces: anInteger

    numSpaces := anInteger!   
pen

    ^pen ifNil: [ pen := self bitmap pen ].!   
pen: aPen

    pen := aPen! 
printOn: aStream

    super printOn: aStream.
    aStream nextPut: $>; nextPutAll: self selector asString! 
rbSelector

    ^rbSelector!
rbSelector: aSymbol

    rbSelector := aSymbol! 
rectangle

    ^rectangle!  
rectangle: aRectangle

    rectangle := aRectangle! 
releaseBitmaps

    self file isEmpty ifFalse: [
        self bitmap release.
        self bitmap: nil
    ].!   
selector

    ^selector!
selector: aSymbol

    selector := aSymbol.
    bitmapSelector ifNil: [ bitmapSelector := selector ].! 
state

    ^state!  
state: aSymbol

    state := aSymbol!   
up

    self state: #up!
upBoundingBox

    ^(0 @ 0 extent: (self bitmap width // self numImages @ self bitmap height))! !

! OSTool class methods !   
buttonWidth: w height: h planes: planes
    "Creates a bitmap for holding a tool
    of planes states with extent w@h..."
    " test code...
    BitEditor new openOn: (OSTool buttonWidth: 25 height: 22 planes: 3)
    "

    | button |
    button := Bitmap screenWidth: w * planes height: h.
    button pen fill: ClrPalegray.
    self drawBordersOf: button planes: planes.
    ^button!   
defaultCellSize

    ^OSToolBar defaultCellSize!
drawBordersOf: button planes: planes
    "Draw button borders in button bitmap for holding a tool
    of planes states..."
    | w h |
    h := button height.
    w := button width // planes.

    planes > 2
    ifTrue: [ self gray: button into: (w * 2 @ 0 extent: w @ h - 1) ].

    "esto apesta pero es el codigo de OSI
     que esta en Bitmap para dibujar un boton..."
    button pen
        foreColor: ClrBlack;
        lineFrom: 1@0 to: (w - 1)@0;
        lineFrom: (w + 1)@0 to: (2 * w - 1)@0;
        lineFrom: (2 * w - 1)@1 to: (2 * w - 1)@(h - 1);
        lineFrom: 1@(h - 1) to: (w - 1)@(h - 1);
        lineFrom: (w + 1)@(h - 1) to: (2 * w - 1)@(h - 1);
        lineFrom: 0@1 to: 0@(h - 1);
        lineFrom: (w - 1)@1 to: (w - 1)@(h - 1);
        lineFrom: w@1 to: w@(h - 1);
        foreColor: ClrWhite;
        lineFrom: 1@1 to: 1@(h - 2);
        lineFrom: 2@1 to: (w - 2)@1;
        foreColor: ClrDarkgray;
        lineFrom: 1@(h - 2) to: (w - 1)@(h - 2);
        lineFrom: 2@(h - 3) to: (w - 1)@(h - 3);
        lineFrom: (w - 2)@1 to: (w - 2)@(h - 2);
        lineFrom: (w - 3)@2 to: (w - 3)@(h - 2);
        lineFrom: (w + 1)@1 to: (w + 1)@(h - 1);
        lineFrom: (w + 2)@1 to: (2 * w - 1)@1;
        lineFrom: (w + 2)@2 to: (w + 2)@(h - 1);
        lineFrom: (w + 3)@2 to: (2 * w - 1)@2.

    ^button!   
gray: aBitmap into: aRectangle
    "Private - Gray aRectangle in aBitmap..."


    | step box |
    step := 2. "gray step"
    box := aRectangle.
    aBitmap pen
        foreColor: ClrBlack;
        place: box left + 1 @ box top;goto: box right @ box top;
        place: box left @ (box top + 1);goto: box left @ box bottom;
        place: box right @ (box top + 1);goto: box right @ box bottom;
        place: box left + 1 @ box bottom;goto: box right @ box bottom;
        foreColor: ClrDarkgray;
        place: box left + 1 @ (box bottom - 1);goto: box left @ box top + 1;goto: box right @ (box top +1);
        place: box left + 2 @ (box bottom - 1);goto: box left @ box top + 2;goto: box right @ (box top +2);
        foreColor: ClrWhite.
    box left + 1 to: box right - 1 by: step do: [:x|
      box top + 1 to: box bottom - 1 by: step do: [:y|
        aBitmap pen
            place: x@y;
            goto: x + 1@y.
      ].
    ].! !

! OSTool methods !
cellSize

    cellSize isNil
    ifTrue: [ cellSize := self class defaultCellSize ].

    ^cellSize! 
cellSize: aPoint
    cellSize := aPoint! 
disabledBoundingBox
    | width |
    self numImages = 2 ifTrue: [ ^super disabledBoundingBox ].
    width := self bitmap width // self numImages.
    ^width * 2 @ 0 extent: width @ self bitmap height! 
displayWith: aPen in: aRect

    | box shade |

    aPen
        copy: self pen
        from: self boundingBox
        to: aRect.

    (self numImages = 2 and: [self isDisabled])
    ifTrue: [
        box := aRect insetBy: 2.
        shade := CPBitmapDict at: 'ShadeBitmap' ifAbsent: [^self].
        self fill: box with: shade using: aPen.
    ].!
fill: aRectangle with: shadeBitmap using: aPen
    "Private - Shade the area inside aRectangle"

    aRectangle left "// shadeBitmap width * shadeBitmap width"
        to: aRectangle right
        by: shadeBitmap width
        do: [:x|
            aRectangle top "// shadeBitmap height * shadeBitmap height"
                to: aRectangle bottom
                by: shadeBitmap height
                do: [:y|
                    aPen
                        copyBitmap: shadeBitmap
                        from: shadeBitmap boundingBox
                        at: x@y rule: Srcand
            ]
        ]!
numImages

    self bitmap isNil ifTrue: [^super numImages].
    ^self bitmap width + 1 // self cellSize x! !

! WBTreeNode class methods !  
new

    ^super new initialize! !

! WBTreeNode methods ! 
addChild: aChild

    children addLast: aChild.
    aChild setParent: self.!   
addChild: aChild afterNode: aNode

    children add: aChild after: aNode.
    aChild setParent: self.! 
addChild: aChild  beforeNode: aNode

    children add: aChild before: aNode.
    aChild setParent: self.!  
allRelations

    | root |

    root := self.

    [ root isRoot ] whileFalse: [
        root := root parent.
    ].

    ^root asFlatList! 
asFlatList

    | newList |

    newList := OrderedCollection new.

    (self isRoot) ifFalse: [
        newList add: self.
    ].

    children do: [ :c |
        newList addAll: c asFlatList.
    ].

    ^newList! 
canExdent

    ^self isRoot not and:  [ parent isRoot not ].!   
canIndent

    ^self previousSibling notNil!
canMoveDown

    ^self nextSibling notNil |
        (self isRoot not and: [ parent nextSibling notNil ]).! 
canMoveUp

    ^self previousSibling notNil |
        (self isRoot not and: [ parent previousSibling notNil ]).!   
childAfter: aChild

    ^children after: aChild ifNone: [ nil ]!
childBefore: aChild

    ^children before: aChild ifNone: [ nil ]!  
children

    ^children!
children: c

    children := c! 
copySpecificsTo: copy!
delete

    children notEmpty ifTrue: [
        (MessageBox confirm: self deleteMessage) ifFalse: [
            ^nil
        ].
    ].

    parent removeChild: self.!
deleteMessage

    ^
'Deleting this item will cause subitems to be irretrievably destroyed.                                 Do you wish to do so?'!
depth

    (self isRoot or: [ parent isRoot ])  ifTrue: [
        ^0
    ] ifFalse: [
        ^parent depth + 1
    ].! 
descendantsCount

    | count |

    count := 1.
    children do: [ :c |
        count := count + c descendantsCount.
    ].

    ^count!
exdent

    parent  isRoot ifFalse: [
        self parent: parent parent positioningAfter: parent.
        self shiftLeft.
    ].!   
firstChild

    children isEmpty ifTrue: [ ^nil ].

    ^children first!  
fullCopy

    | copy |

    copy := self class new.
    self fullCopyTo: copy withParent: nil.

    ^copy! 
fullCopyTo: copy  withParent: aParent

    | new |

    copy setChildren: (
        children collect: [ :c |
            new := c class new.
            c fullCopyTo: new withParent: copy.
            new
        ]
    ).

    copy setCurrentString: currentString.
    copy setListString: listString.
    copy setParent: aParent.
    self copySpecificsTo: copy.! 
hasChildren

    ^children notEmpty!
indent

    | newParent |

    self canIndent ifTrue: [
        newParent := self previousSibling.
        self parent: newParent.
        self shiftRight.
    ].!   
indentString

    ^'...'!   
initialize

    children := OrderedCollection new.
    listString := ''.
    currentString := ''.!
insertNode: aNode

    children notEmpty ifTrue: [
        self addChild: aNode beforeNode: children first
    ] ifFalse: [
        parent addChild: aNode afterNode: self.
    ].! 
isLeaf

    ^self hasChildren not!  
isRoot

    ^parent isNil!  
lastChild

    children isEmpty ifTrue: [ ^nil ].

    ^children last!
listString

    (self isRoot) ifTrue: [
        ^'ROOT'
    ] ifFalse: [
        ^currentString
    ].! 
listString: aString

   listString := aString.
   currentString := listString.

    self depth timesRepeat: [
        currentString := self indentString, currentString.
    ].!   
moveDown

    | nextSibling parentSibling |

    self isRoot ifTrue: [
        ^self
    ].

    (nextSibling := self nextSibling) notNil ifTrue: [
        parent removeChild: self.
        parent addChild: self afterNode: nextSibling.
    ] ifFalse: [
        parentSibling := parent nextSibling.
        (parentSibling notNil) ifTrue: [
            parent removeChild: self.
            (nextSibling := parentSibling firstChild) notNil ifTrue: [
                parentSibling addChild: self beforeNode: nextSibling.
            ] ifFalse: [
                parentSibling addChild: self.
            ].
        ].
    ].!   
moveUp

    | prevSibling parentSibling |

    self isRoot ifTrue: [
        ^self
    ].

    (prevSibling := self previousSibling) notNil ifTrue: [
        parent removeChild: self.
        parent addChild: self beforeNode: prevSibling.
    ] ifFalse: [
        parentSibling := parent previousSibling.
        (parentSibling notNil) ifTrue: [
            parent removeChild: self.
            (prevSibling := parentSibling lastChild) notNil ifTrue: [
                parentSibling addChild: self afterNode: prevSibling.
            ] ifFalse: [
                parentSibling addChild: self.
            ].
        ].
    ].!  
nextSibling

    self isRoot ifTrue: [
        ^nil
    ].

    ^parent childAfter: self.!  
nonHierarchicalPosition

    self isRoot ifTrue: [
        ^0
    ].

    ^parent nonHierarchicalPosition + self siblingPosition!   
parent

    ^parent!
parent: aNode

    parent removeChild: self.
    aNode addChild: self.!
parent: aNode positioningAfter: sibling

    parent removeChild: self.
    aNode addChild: self afterNode: sibling.!   
positionOf: anEntry

    | position |

    position := 1.

    children do: [ :c |
        c == anEntry ifTrue: [
            ^position
        ].
        position := position + c descendantsCount.
    ].

    self error:  'Child missing'!  
previousSibling

    self isRoot ifTrue: [
        ^nil
    ].

    ^parent childBefore: self.! 
printOn: aStream

    self isRoot ifTrue: [
        aStream nextPutAll: '(ROOT)'.
    ] ifFalse: [
        aStream nextPutAll: '(', parent listString, '>>', currentString, ')'.
    ].!
removeChild: aChild

    children remove: aChild.!  
setChildren: aList

    children := aList!  
setCurrentString: aString

    currentString := aString!
setListString: aString

    listString := aString.! 
setParent: aParent

    parent := aParent!  
shiftLeft

    children do: [ :c |
        c shiftLeft.
    ].

    (currentString size < self indentString size) ifTrue: [ ^self ].

    currentString := currentString copyFrom: self indentString size + 1 to: currentString size.!
shiftRight

    children do: [ :c |
        c shiftRight.
    ].

    currentString := self indentString, currentString.!   
siblingPosition

    ^parent positionOf: self!  
updateListStrings

    children do: [ :c |
        c listString: c title.
        c updateListStrings.
    ].!   
withoutEmptyNodes

    | newNode |

    newNode := self copy.

    newNode children: (
        (children select: [ :c |
            c title trimBlanks notEmpty
        ]) collect: [ :c |
            c withoutEmptyNodes.
        ]
    ).

    ^newNode! !

! WBPMenu methods !
allSelectors

    | allSelectors newSelectors |

    allSelectors := Dictionary new.

    children do: [ :m |
        newSelectors := m allSelectors.
        newSelectors keysDo: [ :k |
            allSelectors at: k asSymbol put: (newSelectors at: k).
        ].
    ].

    ^allSelectors.!  
asMenu

    | menu |

    menu := Menu new.
    menu title: ''.
    children do: [ :c |
        c appendTo: menu.
    ].

    ^menu!
printOn: aStream

    aStream nextPutAll: 'a ', self class name.!   
storeOn: aStream indentString: indentString

    | mainMenu |

    mainMenu := WBPMenuItem new.
    mainMenu children: children.
    mainMenu storeOn: aStream indentString: indentString.! !

! WBPMenubar methods ! 
allTitles

    ^children collect: [ :n | n title ].!
asMenu

    | realMenus |

    realMenus := OrderedCollection new: children size.
    children do: [ :n | realMenus addLast: n asMenu ].

    ^realMenus!  
storeOn: aStream indentString: indentString

    children do: [ :m |
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, '    addMenu: ('; cr.
        m storeOn: aStream indentString: indentString, '        '.
        aStream cr; nextPutAll: indentString, '    )'.
    ].! !

! WBPMenuItem methods !
accelBits

    keyAccel isNil ifTrue: [ ^nil ].

    ^keyAccel accelBits! 
accelerator

    ^keyAccel! 
accelerator: aKeyAccel

    keyAccel := aKeyAccel!  
accelKey

    keyAccel isNil ifTrue: [ ^nil ].

    ^keyAccel accelKey!   
action

    (selector isNil or: [ (selector isMessage) not or: [ selector receiver isNil ]]) ifTrue: [
        ^nil
    ] ifFalse: [
        selector receiver isWBAction ifTrue: [
            ^selector receiver script asString
        ] ifFalse: [
            ^nil
        ].
    ]!  
action: aString

    (aString isNil or: [ aString isEmpty ]) ifTrue: [ ^nil ].

     selector := (Message new)
                            receiver: (WBAction window: nil action: aString);
                            selector: #perform;
                            arguments: #();
                            yourself!
allSelectors

    | allSelectors newSelectors |

    allSelectors := Dictionary new.
    selector isMessage ifTrue: [ ^allSelectors ].

    selector notNil ifTrue: [
        allSelectors at: selector put: self title.
    ].
    children notNil ifTrue: [
        children do: [ :m |
            newSelectors := m allSelectors.
            newSelectors keysDo: [ :k |
                allSelectors at: k put: (newSelectors at: k).
            ].
        ].
    ].

    ^allSelectors!   
appendTo: theMenu

    self isLeaf ifTrue: [
        self isSeparator ifTrue: [
            theMenu appendSeparator.
        ] ifFalse: [
            theMenu
                appendItem: self fullTitle
                selector: self realSelector
                accelKey: self accelKey
                accelBits: self accelBits.
        ].
    ] ifFalse: [
        theMenu appendSubMenu: self asMenu
    ].!  
asMenu

    | theMenu |

    theMenu := Menu new.
    theMenu title: self fullTitle.

    children do: [ :c |
        c appendTo: theMenu.
    ].

    ^theMenu!   
canIndent

    ^super canIndent and: [ self previousSibling isSeparator not ].! 
copySpecificsTo: copy

    copy isSeparator: isDivider.
    copy accelerator: keyAccel.
    copy selector: selector.! 
deleteMessage

    ^
'Deleting this item will cause submenus to be irretrievably destroyed. Do you wish to do so?'!
Doit self keyName!
fullTitle

    | fullTitle |

    fullTitle := self title.

    (keyAccel notNil and: [ keyAccel keyName notNil ]) ifTrue: [
        fullTitle := fullTitle, (String with: Tab), keyAccel fullKeyName.
    ].

    ^fullTitle!  
initialize

    super initialize.
    listString := ''.
    isDivider := false.!  
isSeparator

    ^isDivider!
isSeparator: bool

    isDivider := bool!   
link

    (selector isNil or: [ (selector isMessage) not or: [ selector receiver isNil ]]) ifTrue: [
        ^nil
    ] ifFalse: [
        selector receiver isWBAction ifTrue: [
            ^nil
        ] ifFalse: [
            ^selector receiver asString
        ].
    ]!   
link: aString

    (aString isNil or: [ aString isEmpty ]) ifTrue: [ ^nil ].
    selector isMessage ifFalse: [
        selector := (Message new)
                            receiver: (Smalltalk at: aString asSymbol);
                            selector: nil;
                            arguments: #();
                            yourself
    ] ifTrue: [
        selector receiver: (Smalltalk at: aString asSymbol)
    ]!
realSelector

    selector isArray ifTrue: [  ^selector ].
    selector isMessage ifTrue: [ ^selector ].
    ^selector isNil ifTrue: [ nil ] ifFalse: [ selector asSymbol ]!  
selector

    ^selector!
selector:  aSelector

    (selector isMessage and: [
        selector receiver isWBAction]) ifTrue: [
        selector receiver receiver: nil
    ].

    selector := aSelector.!  
storeOn: aStream indentString: indentString

    | spaceString |

    spaceString := indentString.
    aStream nextPutAll: spaceString, 'Menu new'; cr.

    spaceString := spaceString, '    '.

    aStream nextPutAll: spaceString, 'title: ', self title asQuotedString.
    aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'owner: ',PWindowBuilder secondArg.
    (self realSelector notNil and: [self realSelector isString]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'selector: #'.
        self realSelector printOn: aStream.
    ].
    children do: [ :c |
        c isLeaf ifTrue: [
            c isSeparator ifTrue: [
                aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'appendSeparator'.
            ] ifFalse: [
                aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'appendItem: ', c fullTitle asQuotedString.
                "Support for link menus"
                c action notNil ifTrue: [
                    aStream nextPutAll:  ' action: #', c action
                ] ifFalse: [ c link isNil ifTrue: [
                    aStream nextPutAll:  ' selector: '.
                    (c realSelector notNil) ifTrue: [
                        aStream nextPut: $#.
                    ].
                    c realSelector printOn: aStream.
                ] ifFalse: [
                    aStream nextPutAll:  ' link: #',c link,' type: #',c type
                ]].
                c accelerator notNil ifTrue: [
                    aStream nextPutAll: ' acceleratorString: '.
                    c accelerator printAccelOn: aStream.
                ].
            ].
        ] ifFalse: [
            aStream nextPutAll: ';'; cr; nextPutAll: spaceString, 'appendSubMenu: ('; cr.
            c storeOn: aStream indentString: spaceString, '    '.
            aStream cr; nextPutAll: spaceString,  ')'.
        ].
    ].!  
title

    ^listString! 
title: aTitle

    self listString: aTitle.!
type

    (selector isNil or: [ (selector isMessage) not or: [ selector selector isNil ]]) ifTrue: [
        ^nil
    ] ifFalse: [
        selector receiver isWBAction ifTrue: [
            ^nil
        ] ifFalse: [selector selector == #openWithParent: ifTrue: [
            ^#Child
        ] ifFalse: [ selector selector == #openWithMyParent: ifTrue: [
            ^#Sibling
        ] ifFalse: [
            ^#Independent
        ]]].
    ]!  
type: aString
    | aSymbol aSelector |
    (aString isNil or: [ aString isEmpty ]) ifTrue: [ ^nil ].
    aSymbol := aString asSymbol.
    aSymbol == #Child ifTrue: [
        aSelector := #openWithParent:
    ] ifFalse: [ aSymbol == #Sibling ifTrue: [
        aSelector := #openWithMyParent:
    ] ifFalse: [
        aSelector := #open
    ]].
    selector isMessage ifFalse: [
        selector := (Message new)
                            receiver: nil;
                            selector: aSelector;
                            arguments: #();
                            yourself
    ] ifTrue: [
        selector selector: aSelector
    ]! !

! Window methods !   
activeTextPane
    "Added by Ale for returning nil by default because this message is sent
     to the systemWindow during MDI Frame activation.
    See OSI changes in MDIFrame>>activeTextPane (mdiDocument is aSystemWindow...)"

    ^nil!   
addSubpane: aWindow

    "Modified by OSI to support CUA keyboard input"
        "Add aWindow as the child of the receiver."
    |id|
    #modifiedByOSI.
    children isNil ifTrue: [
        children := IdentityDictionary new].

    "OSI - Needed to have children represented as OrderedCollection,
      since ordering relevant.  Digitalk stores them as an identity dictionary,
      which loses ordering.  Previous method of sorting on id fails for buttons
      with idOk and idCancel"
    self addToSubpaneOrder: aWindow.

    id := aWindow propertyAt:#id.
    id isNil ifTrue:[ aWindow propertyAt:#id put: self getNextChildId].
    "Check if duplicate 'idCancel' or 'idOK' message might have been sent to the childs of this window."
    children at: self getNextChildSlot put: aWindow.
    aWindow parent: self.
    aWindow owner isNil ifTrue: [
        aWindow owner: self owner].

    (self mainWindow propertyAt: #focusWindow) isNil & aWindow isWsTabstop ifTrue: [
        (aWindow isRadio not or:  [ aWindow selection ]) ifTrue: [
            self mainWindow propertyAt: #focusWindow put: aWindow.
        ].
    ].

    self mainWindow add: aWindow interestIn: aWindow name.! 
addSubpaneDynamically: aSubPane
    "Added by OSI - Add a subpane to a window dynamically"
    #addedByOSI.
    self addSubpane: aSubPane.
    aSubPane open;
        initSize: self rectangle;
        buildWindow: self;
        resize: self rectangle;
        validate.! 
addToSubpaneOrder: aWindow

    "Added by OSI - Needed to have children represented as OrderedCollection,
      since ordering relevant.  Digitalk stores them as an identity dictionary,
      which loses ordering.  Previous method of sorting on id fails for buttons
      with idOk and idCancel"
    (self propertyAt: #subpaneOrder) notNil ifFalse: [
        #addedByOSI.
        self propertyAt: #subpaneOrder put: OrderedCollection new.
    ].

    (self propertyAt: #subpaneOrder) addLast: aWindow.! 
cpBackColor

    "Added by OSI"

    | b |

    #addedByOSI.
    b := self backColor.
    b isArray ifTrue: [
        ^b at: 1      "For 1.0 & 1.1, color is value & brush"
    ].

    ^b!   
createdBy
    "Added by OSI - reports creation information"
    #addedByOSI.
    ^self propertyAt: #createdBy! 
createdBy: aString
    "Added by OSI - records creation information"
    #addedByOSI.
    self propertyAt: #createdBy put: aString.!   
dialogTemplate
    "Added by OSI"
    #addedByOSI.
    ^nil!   
dialogTemplate: ignore
    "Added by OSI"
    #addedByOSI.
    ^self!  
disable
    "Disable the receiver and all its children.
     A disabled window does not receive user input.
    Touched by Ale. for no action when handle is invalid (during getContents)..."
    #modifiedByOStyle.

    self isHandleOk ifFalse: [^self].
    UserLibrary
        enableWindow: self handle
        enable: false.!
enable
    "Enable the receiver and all its children.
     Touched by Ale. For no enabling when handle is invalid..."
    #modifiedByOStyle.

    self isHandleOk ifFalse: [^self].
    UserLibrary
        enableWindow: self handle
        enable: true.!  
extent: e

    "Added by OSI"
    #addedByOSI.
    self propertyAt: #extent put: e!   
font: aFont
       "Set the font for the receiver to aFont.
        LRP patched, don't do anything if the font is already setted..."
    |curFontHandle controlFontHandle|

    aFont isNil | (self font = aFont) ifTrue: [^self].
    self isHandleOk ifFalse: [^self].

    #modifiedByOStyle.

    ((curFontHandle := aFont fontHandle) notNil)
        ifTrue: [
            controlFontHandle :=
                (WinAddress loWordFrom:
                    (UserLibrary
                        sendMessage: handle
                        msg: WmGetfont
                        wparam: 0
                        lparam:0)).
            (curFontHandle ~= controlFontHandle
                and:[ (controlFontHandle = 0 and:
                            [aFont sameLogFont:  SysFont ]) not] )
            ifTrue:[
                UserLibrary
                    sendMessage: handle
                    msg: WmSetfont
                    wparam: aFont fontHandle
                    lparam: 1]].
    self propertyAt: #font put: aFont! 
getId

    "Added by OSI"

    | i |
    #addedByOSI.
    (i := self id) isNil ifTrue: [
        ^1
    ].

    ^i! 
getSubpaneOrder

    "Added by OSI - Needed to have children represented as OrderedCollection,
      since ordering relevant.  Digitalk stores them as an identity dictionary,
      which loses ordering.  Previous method of sorting on id fails for buttons
      with idOk and idCancel"
    | order |

    #addedByOSI.
    (order := self propertyAt: #subpaneOrder) isNil ifTrue: [
        ^OrderedCollection new
    ].

    ^order!
helpManager
    "Added by OSI to fix Digitalk bug"
        "Private - Answer the HelpManager for the receiver."
    #addedByOSI.
    ^self propertyAt: #helpManager!  
iconFile
    "Added by OSI - supports attatching icons to windows"
    #addedByOSI.
    ^self propertyAt: #iconFile!   
iconFile: aString
    "Added by OSI - supports attatching icons to windows"
    self propertyAt: #iconFile put: aString.
    #addedByOSI.
    (File exists: aString) ifTrue: [
        self icon: (Icon fromFile: aString)
    ].!  
invalidateRect: aRectangle
    "Invalidate aRectangle area in the receiver
     thus force the area to be repainted.
     Touched by Ale. For no invalidating when handle is invalid..."
    #modifiedByOStyle.

    self isHandleOk ifFalse: [^self].
    UserLibrary
        invalidateRect: self asParameter
        rectangle: aRectangle asParameter
        erase: true  "erase background."! 
invalidateRect: aRectangle erase:aBoolean
    "Invalidate aRectangle area in the receiver
     thus force the area to be repainted.  If aBoolean
     is true then the area is erased before being repainted.
     Touched by Ale. For no invalidating when handle is invalid..."
    #modifiedByOStyle.

    self isHandleOk ifFalse: [^self].
    UserLibrary
        invalidateRect: self asParameter
        rectangle: aRectangle asParameter
        erase: aBoolean  "erase background."!   
mdiGetActive
    "Returns the current MDI client active.
     WARNING: Don't remove this message,
        see NotificationManager #activeWindow.
    Implemented by Ale..."
    #addedByOStyle.
    ^self!  
minimized
        "Private - Answer false if the receiver is minimized."
    ^false!
modifiedBy
    "Added by OSI - reports modification information"
    #addedByOSI.
    ^self propertyAt: #modifiedBy!   
modifiedBy: aString
    "Added by OSI - records modification information"
    self addedByOSI.
    self propertyAt: #modifiedBy put: aString.! 
moveWindowTo: aRectangle
    "Moves the receiver to aRectangle inside its father window.
    Always repaint the receiver.
    Returns true if successful.
    Implemented by Ale..."
    #addedByOStyle.

    self  isHandleOk ifFalse: [^false].

   ^0 ~= (UserLibrary
        moveWindow: self handle
        left: aRectangle left
        top: aRectangle top
        width: aRectangle width
        height: aRectangle height
        repaint: true)!   
nameForInstVar: sym

    "Added by OSI"
    #addedByOSI.
    self paneName: sym!  
paneName

    "Added by OSI"
    #addedByOSI.
    ^self propertyAt: #paneName!
paneName: aName

    "Added by OSI"
    #addedByOSI.
    ^self propertyAt: #paneName  put: aName! 
paneNamed: aString

    "Added by OSI"

    | aName result |

    aName := aString asString.
    self paneName = aName ifTrue: [
        #addedByOSI.
        ^self
    ].

    children notNil ifTrue: [
        children do: [ :c |
            (result := c paneNamed: aName) notNil ifTrue: [
                ^result
            ].
        ].

    ].

    ^nil!   
redraw
    "Added by OSI. Redraw the entire window."
    #addedByOSI.
    self invalidateRect: nil!
releaseDC: aDisplayContext
    "Private - Release aDisplayContext, the display
     context for the receiver.
    Touched by Ale for no error generation..."
    #modifiedByOStyle.

    (UserLibrary
        releaseDC: handle
        with: aDisplayContext) = 0
            ifTrue: [
                " self error: 'DC not released' "
            ]!  
setStyle: s

    "Added by OSI"
    #addedByOSI.
    self propertyAt: #style put: s.! 
statusPane
        "answer the receiver's status bar"
    ^self mainWindow statusPane!  
tabPosition: ignore

    "Added by OSI"
    #addedByOSI.!  
toolPane
        "Answer the receiver's toolPane if any, else answer nil."

    ^self mainWindow toolPane! 
windowText
   "Modified by OSI to fix intermittent failures. Thanks to Tom Lipkis"
   "Answer the receiver's window text."
    | length string size winAdr |
    #modifiedByOSI.
     handle isValid
        ifTrue:[
            length := self windowTextLength.
            length = 0 ifTrue: [ ^String new ].
            winAdr := WinAddress allocateMemory: length + 1.
            winAdr isNil ifTrue: [ ^String new ].
            size := UserLibrary
                getWindowTextW: self handle
                text: winAdr asParameter
                maxLength: length + 1.
            string := String new: size.
            WinAddress copyFrom: winAdr to: string count: size. winAdr unlockAndFree.
            ^string asNormalizedString ]
        ifFalse:[^ String new]!
wmDropFiles: wordInteger with: longInteger
    "Private - Process the wmQuerydragicon window message.
    Implemented by LRP..."
    #addedByOStyle.
    ^nil!
wmGetminmaxinfo: arg1 with: arg2

    "Added by OSI"
    #addedByOSI.
    ^nil!   
wmGettext: wParam with: lParam

    "Added by OSI"
    #addedByOSI.
    ^nil! 
wmHelp: wordInteger with: longInteger
    "Private - Process the Smalltalk help message.
    Touched by Ale for checking an undefined help manager"
    |context focusWindow subpane name|
    #modifiedByOStyle.
    focusWindow := longInteger \\ 65536.
    wordInteger = MsgfMenu ifTrue:[
        self helpManager notNil ifTrue:[
        context := self helpContext.
        UserLibrary
                sendMessage: focusWindow
                msg:WmCancelmode
                wparam:0
                lparam:0.
            self cancelMode.
            self helpManager displayHelp: context key]].

    wordInteger = MsgfDialogbox ifTrue:[
        self helpManager notNil ifTrue:[
        [subpane isNil and: [focusWindow ~= 0]] whileTrue:[
            subpane := Notifier findWindow: focusWindow.
            subpane isNil ifTrue:[focusWindow := UserLibrary getWindowWord: focusWindow index: GwwHwndparent]].
        subpane isNil ifTrue:[^self].
        name := subpane name.
        self helpManager displayHelp: name]].

    self helpContext: nil.!  
wmKeyup: wordInteger with: longInteger

    "Added by OSI"
    #addedByOSI.
    ^nil! 
wmNchittest: wParam with: lParam
        "Private - allow overlapping panes to get mouse input"
    #addedByOSI.
    ^nil! 
wmNcLbuttondblclk: wParam with: lParam
    " Private - Attend the windows message wmNcLbuttondblclk:with:."
    #addedByOStyle.
    ^nil!  
wmNcLbuttondown: wParam with: lParam
    " Private - Attend the windows message wmNcLbuttondown:with:."
    #addedByOStyle.
    ^nil!  
wmNcLbuttonup: wParam with: lParam
    " Private - Attend the windows message wmNcLbuttonup:with:."
    #addedByOStyle.
    ^nil!  
wmPaletteChanged: wParam with: lParam
    " Private - Attend the windows message wmPaletteChanged:with:."
    #addedByOStyle.
    ^nil!
wmPaletteIsChanging: wParam with: lParam
    " Private - Attend the windows message wmPaletteIsChanging:with:."
    #addedByOStyle.
    ^nil!  
wmQuerydragicon: wordInteger with: longInteger
    "Private - Process the wmQuerydragicon window message.
    Implemented by LRP..."
    #addedByOStyle.
    ^nil!
wmQueryNewPalette: wParam with: lParam
    " Private - Attend the windows message wmQueryNewPalette:with:."
    #addedByOStyle.
    ^nil!  
wmSetcursor: wParam with: lParam
    "Private - Process the set cursor message.
     Touched by Ale to fix a spureous bag (#helpMode returns nil)..."
    | point currentCursor |
    #modifiedByOStyle.
    (self helpManager notNil
     and:[self mainWindow helpManager helpMode == true])
        ifTrue:[
            self mainWindow helpManager setHelpCursor.
            ^1].
    lParam \\ 65536 = Htclient
        ifTrue: [
            currentCursor := self currentCursor.
            currentCursor isNil
                ifTrue:[^nil].
            currentCursor setWinCursor.
            ^1]
        ifFalse: [^nil]!
wmUser99: wparam with: lparam

    "Added by OSI"
    #addedByOSI.
    ^nil!  
wmWindowPosChanged: wordInteger with: longInteger
    "Private - the receiver has been changed of position or size.
     Added by Ale to window motion support.
    Implemented by Ale..."
    #addedByOStyle.
    ^nil! 
wmWindowPosChanging: wParam with: lParam
    " Private - Attend the windows message wmWindowPosChanging:with:."
    #addedByOStyle.
    ^nil!  
wmWinIniChange:wordInteger with: longInteger
        "Private - Process the system initialization file
         WIN.INI change message."
    ^nil! !

! ApplicationWindow class methods !
fileMenu
    "Private - Answer the File menu.
    Touched By Ale for better menu.
    Touched By LRP for Categories & Chunk Analyzer inclusion menu..."
    | tab menu |
    #modifiedByOStyle.
    tab := String with: Tab.
    menu := Menu new.
    menu
        appendItem: '&New Workspace',tab,'Alt+N' selector: #openWorkspace accelKey: $n accelBits: AfAlt | AfChar ;
        appendItem: '&Open...',tab,'Alt+O' selector: #openFile accelKey: $o accelBits: AfAlt | AfChar.

    Smalltalk isRunTime ifFalse: [
      menu
        appendItem: '&Install...',tab,'Alt+I' selector: #install accelKey: $i accelBits: AfAlt | AfChar
    ].

    menu
        appendItem: '&Save',tab,'Alt+S' selector: #accept accelKey: $s accelBits: AfAlt | AfChar;
        appendItem: 'Save &As...',tab,'Alt+A' selector: #saveAs accelKey: $a accelBits: AfAlt | AfChar.

    Smalltalk isRunTime ifFalse: [
      menu
        appendSeparator;
        appendItem: '&Browse Classes',tab,'Alt+B' selector: #openClassBrowser accelKey: $b accelBits: AfAlt | AfChar;
        appendItem: 'Browse Ca&tegories',tab,'Alt+T' selector: #openCategoryBrowser accelKey: $t accelBits: AfAlt | AfChar;
        appendItem: 'Browse Chun&ks',tab,'Alt+K' selector: #openChunkBrowser accelKey: $k accelBits: AfAlt | AfChar;
        appendSeparator;
        yourself
    ].

    (Smalltalk includesKey: #DiskBrowser)
    ifTrue: [
      menu appendItem: 'Browse &Disk',tab,'Alt+D' selector: #openDiskBrowser accelKey: $d accelBits: AfAlt | AfChar
    ].

    menu
        appendItem: '&Print',tab,'Alt+P' selector: #print accelKey: $p accelBits: AfAlt | AfChar ;
        appendItem: '&Restore',tab,'Alt+R' selector: #restore accelKey: $r accelBits: AfAlt | AfChar;
        appendSeparator ;
        appendItem: 'E&xit',tab,'Alt+X' selector: #close accelKey: $x accelBits: AfAlt | AfChar ;
        appendSeparator ;
        appendItem: 'R&un...',tab,'Alt+U' selector: #runProgram accelKey: $u accelBits: AfAlt | AfChar.

    Smalltalk isRunTime ifFalse: [
        menu appendItem: 'C&lean Up' selector: #cleanUp;
            appendItem: 'Save Image...' selector: #saveImage
    ].

    menu title: '&File'.
    ^menu! !

! ApplicationWindow methods !   
activate

    "Modified by OSI to avoid automatically setting
      the focus to a text pane."

        "Private - The receiver was activated."

    | focusWindow |

    self owner isWBWindow ifTrue: [
        focusWindow := self propertyAt: #focusWindow.

        "OSI - Added tests for isActive and
        minimized not; prevent oscillating window effect"
        ((focusWindow notNil and: [ self isActive ]) and:
            [ self minimized not ]) ifTrue: [
            #modifiedByOSI.
            focusWindow setFocus.
            ^super activate
        ].
    ].

    "OSI - Changed activeTextPane to self activeTextPane -
     we had been overriding Digitalk's changes"
    ((self activeTextPane notNil
        and: [self isActive] )
        and: [self minimized not])
            ifTrue: [self activeTextPane setFocus].

    "OSI - Added to prevent mouse capture from staying
    on when halts, etc. occur"
    self clearMouseCapture.

    super activate.!   
add: anObject interestIn: aFacet
    "Add anObject as a dependent of aFacet in the receiver.
     anObject is usually a subpane and aFacet is usually
     a selector (the name of the subpane).
     See also Window addSubpane:
    Touched By LRP for ignoring null facets..."
    #modifiedByOStyle.

    aFacet isNil ifTrue: [^self].
    (dependents at: aFacet ifAbsent: [
        dependents at: aFacet put: OrderedCollection new])
            add: anObject!   
buildWindow
    "Private - Create the host window for the receiver.
    LRP patched check if create:title:.. returns nil.
    Touched by Ale for better reporting of walkback....
    Touched by Ale for sending rectangle in the create:title:style:rectangle:parent: message
        for proper working in WsPopup windows...
    "
    | m answer |
    #modifiedByOStyle.
    style isNil ifTrue: [style := self defaultFrameStyle].
    NewWindow notNil
    ifTrue:[
        NewWindow := nil.
        Terminal bell.
        'A Walkback came up during creation of window'
            displayAt: 0@SysFont height.
        ^self
    ].
    NewWindow := self.
    answer := self create: self winClass
        title: label
        style: style
        rectangle: ((style bitAnd: WsPopup) = 0 ifTrue: [0@0 extent: 0@0] ifFalse: [rectangle]) modifiedByOStyle
        parent: parent.
    NewWindow := nil.

    answer isNil ifTrue: [^nil].
    handle = NullHandle ifTrue: [^nil].

    "menu and subpanes created in the
     wmCreate message process"

    "Set the size of the frame window."
    self handle setWindowPos: nil
            rectangle: rectangle
            fs: SwpNozorder.
    rectangle := self rectangle.

    m := UserLibrary
            getSystemMenu: self asParameter
            revert: 0.
    self propertyAt: #sysMenu put: m.

    self activeTextPane: self searchForDefaultTextPane.!   
cleanUp
    "Private - Clean Up of hole system windows.
    Creating a new transcrip.
    Implemented by Ale..."
    #addedByOStyle.

   "clean up windows"
   Notifier reinitialize.! 
defaultFrameStyle

    "Modified by OSI to allow for setting a specific style from a
     ViewManager"

    "Private - Answer the default frame style for the receiver."
    | fs |

    (fs := self frameStyleFromPStyle) notNil ifTrue: [
        #modifiedByOSI.
        ^fs
    ].

    ^WsMaximizebox |
        WsMinimizebox |
        WsThickframe |
        WsSysmenu |
        WsCaption |
        WsOverlapped |
        WsClipsiblings! 
disableSysMenu: aPosition
    "Private - Disable the item menu at aPosition in the receiver's system menu."

    | m buffer winaddress menuString|
    m := UserLibrary
            getSystemMenu: self asParameter
            revert: 0.
    buffer:=String new:64.
    winaddress:=WinAddress copyToNonSmalltalkMemory: buffer.
    UserLibrary
        getMenuString: m
        position:aPosition
        string:winaddress asParameter
        max:64
        flags:MfByposition.
    menuString:=String fromAddress:winaddress.
    winaddress unlockAndFree.
    UserLibrary
        modifyMenu: m
        position: aPosition
        flags:  MfByposition|MfDisabled|MfGrayed
        newId: (    UserLibrary
            getMenuItemId: m
            position: aPosition)
        newContents: menuString asParameter!
frameStyleFromPStyle
    "Added by OSI - Reimplemented by subclasses"
    #addedByOSI.
    ^nil!   
label

    "Added by OSI"
    #addedByOSI.
    ^label!
label: aString
    "Set the window label of the receiver to aString.
    Touched By Ale for no prefix..."
    #modifiedByOStyle.
    label := aString isEmpty
        ifTrue: [aString]
        ifFalse: [ "WindowLabelPrefix, ' '," aString].
    handle isNil ifTrue: [^self].
    handle = NullHandle ifFalse: [self setWindowText: label].!   
menuWindow: newMenuWindow

    "Added by OSI"
    #addedByOSI.
    menuWindow := newMenuWindow.!  
modifySysMenu: aString  position:aPosition
    "Private - Change the string of the item menu at aPosition in the receiver's system menu."

    | m |
    m := UserLibrary
            getSystemMenu: self asParameter
            revert: 0.
    UserLibrary
        modifyMenu: m
        position: aPosition
        flags:  MfByposition
        newId: (    UserLibrary
            getMenuItemId: m
            position: aPosition)
        newContents: aString asParameter.!
openCategoryBrowser
        "Private - The user selected Browse Categories from
         the File menu.
    Touched by Ale for no direct referencing class.
    Touched By Ale..."
    #modifiedByOStyle.
    (Smalltalk at: #CategoryBrowser) open!
openChunkBrowser
        "Private - The user selected Browse Chunks from
         the File menu.
    Touched by Ale for no direct referencing class.
    Touched By Ale..."
    #modifiedByOStyle.
    (Smalltalk at: #ChunkBrowser) open!  
openDiskBrowser
    "Private - The user selected Browse Disk from the File menu.
    Touched By Ale..."
    #modifiedByOStyle.
    (Smalltalk at: #DiskBrowser ifAbsent: [^nil]) new open!
openFile
        "Private - User selected Open... from the File menu."
    | dialog file |
    dialog := FileDialog new.
    dialog addSmalltalkFileFilters;
             openFile.

    file := dialog file.
    file isNil ifTrue: [^self].
    file := File pathNameReadOnly: file.
    TextWindow new
            sendInputEvent: #openOnFile: with: file.
    file close!
runProgram
    "Private - User selected the Run... menu item
    and wants to run a program.
    Implemented by Ale..."
    | dialog |
    #addedByOStyle.
    dialog := (Smalltalk at: #RunProgramDialog ifAbsent: [^nil]) new.
    dialog open!  
saveImageFile
    "Private - Save the current image and log the event on the change log.
     Touched by Ale for Bitmap patching...."
    | bitmaps result |
    #modifiedByOStyle.
    Bitmap purgeUnusedBitmaps.
    (bitmaps := Bitmap allInstancesPrim) do: [:b| b aboutToSaveImage].
    (Sources at: 2) close.
    Disk makeCurrent.
    result := Smalltalk save.
    bitmaps do: [:each| each restoreFromSaveImage]. "bitmap patch..."
    ^result!
setBackColor: c

    "Added by OSI for PM portability"

    #addedByOSI.
    self backColor: c!  
statusPane
        "Private - Answer the status pane if any, else answer nil."
    ^children detect:[:c| c isStatusPane] ifNone:[nil].! 
statusText
        "Private - Answer the receiver's statusText property."

    ^self propertyAt:#statusText!   
statusText:anObject
        "Private - Set the receiver's statusText property."

    self propertyAt:#statusText put:anObject! 
toolPane
        "answer the receiver's toolPane"
    ^children detect:[:c| c isToolPane] ifNone:[nil].!
validate

    "Altered by OSI to support initWindow method, and to
     set input focus on initialization based on focus order."

    "Private - Create or recreate the window for the receiver."
    self validateBuild isNil ifTrue: [
        ^nil
    ].

    "OSI - Some people still place their window behavior under ApplicationWindow, not ViewManager,
      and ApplicationWindow doesn't respond to mainView"
    (self owner respondsTo: #mainView) ifFalse: [
        #modifiedByOSI.
        self owner initWindow.
    ] ifTrue: [
        (self owner mainView propertyAt: #windowBuilt) isNil ifTrue: [
            self owner mainView propertyAt: #windowBuilt put: true.
            self owner initWindow.
        ].
    ].

    self zoomed ifTrue:[
        self children do:[ :each | each zoomed ifFalse:[each hideWindow]]].

    "OSI - replaced #isKindOf: message"
    (collapsed isRectangle)
        ifTrue:[self showMaximizedWindow]
        ifFalse:[ collapsed < 0
            ifTrue:[self showIconicWindow]
            ifFalse:[self showWindow] ].!
validateBuild
    "Private - Create or recreate the window for the receiver without showing it.
     Touched by LRP for non multiple resizing..."
    | rect |
    CursorManager execute change.
    self buildWindow isNil ifTrue:[CursorManager normal change.^nil].

    #modifiedByOStyle.
    " LRP patch
    rect := 0@0 extent: rectangle extent.
    rectangle := 0 @ 0 extent: 0@ 0.
    self resize: rect.
    "
    children do: [:subpane | subpane validate].
    collapsed isNil ifTrue: [collapsed := 0].
    CursorManager normal change.! 
viewName: aName

    "Added by OSI"

    #addedByOSI.
    self paneName: aName!  
wmCreate: wordInteger with: longInteger
    "Private - Process WM_CREATE messsage.
     Create menu and subpanes.
    Touched by LRP for better resize method"
    | aRectangle |
    NewWindow:=nil.

    (menuWindow buildWindow: handle) isNil
    ifTrue:[ self outOfMemory. ^-1 ].
    self initGraphics.
    self receiveMessages.

    aRectangle := (0 @ 0 extent: rectangle extent). "LRP-patch"
    #modifiedByOStyle.
    children do: [ :subpane |
        subpane initSize: aRectangle.
        (subpane buildWindow: self) isNil
        ifTrue: [ self outOfMemory. ^-1 ]
    ].

    ^nil!
wmGetminmaxinfo: wparam with: lparam
    "Modified by Ale for more secure window placement"
    | info address point |
    #addedByOSI.
    #modifiedByOStyle.

    address := WinAddress new.
    address
        highHalf: lparam // 65536;
        lowHalf: lparam \\ 65536.
    info := WinMinMaxInfo fromAddress: address.

    (self owner respondsTo: #minWindowSize)
    ifTrue: [
        point := self owner minWindowSize.
        point notNil ifTrue: [
            info ptMinTrackSizeX: point x.
            info ptMinTrackSizeY: point y.
        ]
    ].
    (self owner respondsTo: #maxWindowSize)
    ifTrue: [
        point := self owner maxWindowSize.
        point notNil ifTrue: [
            info ptMaxTrackSizeX: point x.
            info ptMaxTrackSizeY: point y.
        ]
    ].
    (self owner respondsTo: #maximizedSize)
    ifTrue: [
        point := self owner maximizedSize.
        point notNil ifTrue: [
            info ptMaxSizeX: point x.
            info ptMaxSizeY: point y.
        ]
    ].
    (self owner respondsTo: #maximizedPosition)
    ifTrue: [
        point := self owner maximizedPosition.
        point notNil ifTrue: [
            info ptMaxPositionX: point x.
            info ptMaxPositionY: point y.
        ]
    ].

    info copyToAddress: address.

    ^nil! !

! TopPane methods ! 
buildMenuBar
    "Private - Build menu bar.
    Altered by C&P.
    Altered by Ale for better implementation.
    Touched By Ale..."
    | eachMenu |
    #modifiedByOStyle.
    super buildMenuBar.
    (self owner isKindOf:
        (Smalltalk at: #CPBitmapManager ifAbsent: []))
    ifFalse: [
        (self owner respondsTo: #saveAs) ifFalse: [
            (eachMenu := menuWindow menuTitled: '&File') notNil
                ifTrue: [eachMenu disableItem: #saveAs]].
    ].
    self event: #menuBuilt!  
close: aPane
    #addedByOSI.
    ^nil! 
frameStyleFromPStyle

    "Added by OSI"

    | s pStyle |

    (pStyle := self pStyle) isNil ifTrue: [
        #addedByOSI.
        ^nil
    ].

    s := WsOverlapped | WsClipsiblings.

    (pStyle includes: #maximize) ifTrue: [
        s := s | WsMaximizebox.
    ].
    (pStyle includes: #minimize) ifTrue: [
        s := s | WsMinimizebox.
    ].
    (pStyle includes: #sizable) ifTrue: [
        s := s | WsThickframe.
    ] ifFalse: [
        s := s | WsBorder.
    ].
    (pStyle includes: #sysmenu) ifTrue: [
        s := s | WsSysmenu.
    ].
    (pStyle includes: #titlebar) ifTrue: [
        s := s | WsCaption.
    ].
    "Support for secondary views as children"
    (self == self owner mainView) ifFalse: [
        (pStyle includes: #mainViewChild) ifTrue: [
            self parent: self owner mainView
        ].
    ].

    ^s! 
handlers

    "Added by OSI"
    #addedByOSI.
    ^handlers!  
pStyle

    "Added by OSI"
    #addedByOSI.
    ^self propertyAt: #pStyle!
pStyle: s

    "Added by OSI"
    #addedByOSI.
    self propertyAt: #pStyle put: s.!  
showRestoredWindow
    "Private - Restore the receiver window from iconic.
    Implemented by Ale..."
    #addedByOStyle.
    UserLibrary
        showWindow: handle
        command: SwRestore!
winIniChange: aString
        "Private - The Windows initialization file WIN.INI changed."
    (aString equalsIgnoreCase: 'intl')
        ifTrue: [ NationalLanguage initialize].! 
wmWinIniChange:wordInteger with: longInteger
        "Private - Process the system initialization file
         WIN.INI change message."
    self sendInputEvent: #winIniChange:
        with: (String fromAddress: (WinAddress fromString: longInteger)).
    ^nil! !

! ChunkTopPane class methods ! 
classComment
	^'This class is used as top pane for all chunk browser windows'
	"Modified: 11.06.93 / 10.12.05 / T.Lentzsch"!
classUpdate
	^'
	"Modified: 11.06.93 / 10.12.05 / T.Lentzsch"'
	"Modified: 11.06.93 / 10.12.05 / T.Lentzsch"!  
fileMenu
	"Private - Answer the File menu."

    ^Menu new
        appendItem: '~New Workspace' selector: #openWorkspace;
        appendItem: '~Open...' selector: #openFile;
        appendItem: '~Install...' selector: #installFile;
        appendSeparator ;
        appendItem: '~Browse Classes	Alt+B' selector: #openClassBrowser accelKey: $b accelBits: AfAlt | AfChar ;
        appendItem: 'Browse ~Disk	Alt+D' selector: #openDiskBrowser accelKey: $d accelBits: AfAlt | AfChar ;
		appendItem: '~Launcher	Alt+L' selector: #openLauncher accelKey: $l accelBits: AfAlt | AfChar;
        appendSeparator ;
        appendItem: 'Save Image...' selector: #saveImage ;
        title: '~File'
	"Modified: 03.06.93 / 09.50.52 / T.Lentzsch"! !

! ChunkTopPane methods !
buildMenuBar
	"Private - Create the menus that make up the menu bar."

	| eachMenu |

	menuWindow addMenu: self class fileMenu owner: self.

	children do: [ :subpane |
		eachMenu := subpane menu.
		eachMenu notNil ifTrue: [
			menuWindow addMenu: eachMenu]].

	menuWindow systemMenu
		insertItem: '~Zoom Text	Alt+Z'
		selector: #zoom
		accelKey: $z
		accelBits: AfChar | AfAlt
		after: 6.
    menuWindow systemMenu
        insertItem: 'Fonts...'
        selector: #setFonts
        accelKey: nil
        accelBits: nil
        after: 7.

    self helpManager notNil ifTrue: [self helpManager buildMenuBar].

    self event: #menuBuilt.
	"Modified: 03.06.93 / 09.50.45 / T.Lentzsch"! !

! DialogTopPane methods ! 
buildItems

    "Modified by OSI to support framing parameters"

        "Private - Build the control items within
         the dialog box.  Answer an array of item
         templates."
    | answer rect text|
    #modifiedByOSI.
    answer := OrderedCollection new.
    children do: [ :subpane |
        "OSI - replaced #isKindOf: tests for SubPane and Rectangle"
        (subpane isSubPane) ifTrue: [
            (rect := subpane framingBlock) isRectangle not
                ifTrue: [rect := rect value: (0@0 extent: rectangle extent)].
            text := subpane initialText.
            text isString ifFalse:[
                text := nil].
            answer add:
                (WinDialogInfo
                    itemTemplateStyle: subpane frameStyle
                    x: rect left
                    y: rect top
                    cx: rect extent x
                    cy: rect extent y
                    id: subpane id
                    className: subpane winClass
                    text: text).
            subpane style: subpane frameStyle.
            subpane initSize: rect ]].
    ^answer! 
buildWindow: aParentWindow

    "Modified by OSI to add #initWindow code, to
     provide dialog caching, to avoid parent being
     nil for framingblock, and to add #sizeWindow call."

        "Private - Create the dialog window for the receiver."
    | winDlgTemplate items winDlgFontInfo tempByteArray m pDlgTemplate|

    #modifiedByOSI.
    "OSI - Fixed Digitalk bug by adding the following two lines.
     Dialogs were never receiving wm_measureitem messages, since these
     messages are sent as soon as the subpanes are created (which is
     before the dialog is created).  Since the dialog wasn't yet created
     and added to the notifier, the notifier had no way of knowing the
     dialog wanted the message."
    NewWindow notNil ifTrue:[NewWindow := nil.  Terminal bell.^self].
    NewWindow := self.

    style isNil ifTrue: [style := self defaultFrameStyle].
    framingBlock isNil
        ifTrue: [
            rectangle := self initSize.
            framingBlock := rectangle]
        ifFalse: [rectangle := framingBlock value: (parent isNil ifFalse: [ parent rectangle] ifTrue: [ Display boundingBox ]) ].

    "Added by OSI to handle potential dialog caching."
    winDlgTemplate := owner dialogTemplate.

    winDlgTemplate isNil ifTrue: [
        winDlgTemplate := WinDialogInfo
            dialogTemplateStyle: style
            itemCount: 0
            x: rectangle origin x
            y: rectangle origin y
            cx: rectangle extent x
            cy: rectangle extent y
            menuName: nil
            className: nil
            text: label.

        winDlgFontInfo := WinDialogInfo         "not used yet"
            fontPointSize: 0 typeFaceName: nil.

        items := self buildItems.
        winDlgTemplate byteAtOffset: 4 put: items size.

        tempByteArray := winDlgTemplate contents.
        items do: [:i |
            tempByteArray := tempByteArray, i contents].
        winDlgTemplate contents: tempByteArray.
    ] ifFalse: [
        self cachedBuildItems.
    ].
    "Added by OSI to handle potential dialog caching."
    owner dialogTemplate: winDlgTemplate.

    "OSI - Folded in fix made by Digitalk"
    pDlgTemplate := WinAddress copyToNonSmalltalkMemory: winDlgTemplate contents.
    handle := WindowHandle fromInteger: (
        UserLibrary
            createDialogIndirect: WIN hInstanceExe
            dialogTemplate: pDlgTemplate asParameter
            parent: parent asParameter
            dialogFunction:
                (WinLong fromBytes: DialogProcInstance) asParameter).
    pDlgTemplate free.

    handle = NullHandle ifTrue: [^self error: 'Dialog creation error'].
    self initGraphics.
    self receiveMessages.

    "OSI - Fixed Digitalk bug. See above."
    NewWindow := nil.

    self buildDialogItems.
    children do: [:subpane | subpane validate].

    owner initWindow.

    self sizeWindow.

    m := UserLibrary
            getSystemMenu: self asParameter
            revert: 0.
    self propertyAt: #sysMenu put: m.
    PoppedModelessWindows add: handle.
    self showWindow.! 
cachedBuildItems

    "Added by OSI to support dialog caching"

    | rect  |
    #addedByOSI.
    children do: [ :subpane |
        subpane isSubPane ifTrue: [
            (rect := subpane framingBlock) isRectangle not
                ifTrue: [rect := rect value: (0@0 extent: rectangle extent)].
            subpane style: subpane frameStyle.
            subpane initSize: rect
        ]
    ].!
close
        "Private - Close the dialog box."

    "Modified by OSI - This was missing"
    #modifiedByOSI.
    "Touched By Ale to support #close event"
    "Ale's code:
    ((self handlesEvent: #close)
    and: [(self event: #close) isNil])
    ifTrue: [^self]."

    "??? Who place this code it's not equal to the upper code;
    is it right? "
    #modifiedByOStyle.
    (self event: #close) notNil ifTrue: [ ^self ].

    parent notNil ifTrue:[ parent enable].
    self hideWindow.
    children size > 0 ifTrue: [
        children do: [:subpane | subpane close]].
    self stopReceivingMessages.

    PoppedModelessWindows remove: handle
        ifAbsent: [].
    self destroy.

    Processor currentProcessIsRecursive ifTrue: [
        ^self].   "no semaphore wait"

   sem notNil ifTrue: [
        sem signal.
        sem := nil.
        Processor suspendActive.]!  
defaultFrameStyle

    "Altered by OSI to allow for setting a specific style from a ViewManager"

        "Private - Answer the default frame style for the receiver."
    | s |

    (s := self frameStyleFromPStyle) isNil ifFalse: [
        #modifiedByOSI.
        ^s
    ].

    ^DsModalframe |
        WsCaption |
        WsSysmenu |
        DsNoidlemsg |
        WsPopup! 
frameStyleFromPStyle

    "Added by OSI."

    | s pStyle |

    (pStyle := self pStyle) isNil ifTrue: [
        #addedByOSI.
        ^nil
    ].
    s := DsNoidlemsg  | WsPopup.

    (pStyle includes: #sysmenu) ifTrue: [
        s := s | WsSysmenu.
    ].
    (pStyle includes: #titlebar) ifTrue: [
        s := s | WsCaption.
    ].
    (pStyle includes: #sysmodal) ifTrue: [
        s := s | DsSysmodal | DsModalframe.
    ].
    (pStyle includes: #modal) ifTrue: [
        s := s | DsModalframe.
    ] ifFalse: [
        s := s | WsBorder.
    ].

    ^s!
mainWindow

    "Altered by OSI to avoid asking for a view that hasn't been created."

        "Answer the receiver's main window.  If the DialogTopPane's
          parent is kind of Window then it returns its parent's main
          window else it returns self. (Needed for cases where
          DialogTopPane is a subpane of TopPane.)"

    #modifiedByOSI.
    ^(owner notNil)
        ifTrue: [
            (owner views size < 1) ifTrue: [
                ^self
            ] ifFalse: [ owner mainView ]
        ] ifFalse: [self]!   
sizeWindow

    "Added by OSI.  Sent by buildWindow: to handle framing params."

    | displayRect clientRect winPosInfo |

    (framingBlock isRectangle) ifTrue: [
        #addedByOSI.
        ^self
    ].

    displayRect := 0@0 extent: Display extent.

    self handle setWindowPos: nil
        rectangle: (framingBlock value: displayRect)
        fs: SwpNozorder.

    clientRect := framingBlock clientRect.

    children size >= 20 ifTrue: [
        children do: [ :subpane |
            subpane resize: (0@0 extent: clientRect extent).
        ].
    ] ifFalse: [
        children do: [ :subpane |
            winPosInfo := UserLibrary beginDeferWindowPos: children size.
            children do: [ :subpane |
                subpane isHandleOk ifTrue: [
                    winPosInfo := subpane
                        resize: (0@0 extent: clientRect extent)
                        deferInfo: winPosInfo
                ].
            ].
            UserLibrary endDeferWindowPos: winPosInfo.
        ].
    ].
    children do: [ :c | c updateRectangle ].! 
statusPane
        "Answer the receiver's statusPane if any, else answer nil."

    parent isNil ifTrue:[^nil].
    ^parent statusPane!   
toolPane
        "Answer the receiver toolPane if any, else answer nil."

    parent isNil ifTrue:[^nil].
    ^parent toolPane!   
wmCreate: wordInteger with: longInteger

    "Added by OSI - fix in buildWindow: causes this to get processed
     when it wasn't before.  We don't want to do anything for
     DialogTopPanes."
    #addedByOSI.
    ^nil! !

! LittleTopDialog class methods ! 
supportedEvents
        "Private - Answer the Set of events that GraphPanes can notify
         their owners about."
    ^super supportedEvents
        add: #eraseBackground;
        yourself! !

! LittleTopDialog methods !
backColor: aColor
    "Set the background color of the receiver.
    ...And forces an erase background event..."

    super backColor: aColor.
    self event: #eraseBackground.!
button1Down: aPoint
    "Private - Left button has been pressed down."

    (super button1Down: aPoint) ifFalse:[^ self].
    self captureMouseInput.
    self clickAt: aPoint.
    self clearMouseCapture.!
clickAt: aPoint
    "Private - a click has been done at aPoint.
     Perform default action"

    (self titleRect containsPoint: aPoint)
    ifTrue: [ self moveWindowTo: self rectangleFromUser ]!  
drawTitle
    "Private - Draw the receiver's top"
    | pen titleRect fillColor |

    self hasTitle ifFalse: [ ^self ].

    pen := self graphicsTool.
    titleRect := self titleRect.
    fillColor := UserLibrary getSysColor:
        (self isActive
            ifTrue: [ColorActivecaption]
            ifFalse: [ColorInactivecaption]).

    self nonClientRectangles
    do: [:border | pen fill: border color: fillColor ].

    pen
        font: self font;
        setTextAlign: TaTop;
        foreColor: (UserLibrary getSysColor:
                (self isActive
                    ifTrue: [ColorCaptiontext]
                    ifFalse: ["ColorInactivecaptiontext"19]));
        setBackMode: Transparent;
        centerWinText: self windowText at: titleRect center - (0@2);
        setBackMode: Opaque;
        foreColor: (UserLibrary getSysColor: ColorWindowframe);
        lineFrom: titleRect left @ (titleRect bottom up: 1) to: titleRect right @ (titleRect bottom up: 1);
        drawChain!
font
    "Returns the instance var of the receiver
     for external manipulation"

    font isNil ifTrue: [ font := Font face: 'Arial' size: 0@(SysFont height // 2) fixedWidth: false ].
    ^font!
font: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    font := anObject! 
getGraphicsTool
        "Private - Answer a graphics tool for the receiver."
    | dc |
    dc := self getDC.
    graphicsTool isNil
        ifTrue: [ graphicsTool := RecordingPen forDC: dc medium: self]
        ifFalse: [ graphicsTool restoreSegments: dc ].
    ^graphicsTool!  
hasStyle: aStyleConstant
    "Private - Returns true if the receiver has a style aStyleConstant"

    ^(style bitAnd: aStyleConstant) ~= 0!
hasTitle
    "Private - Returns true if the receiver has a title"

    ^self hasStyle: WsMaximizebox | WsMinimizebox | WsSysmenu | WsCaption!  
initGraphics
        "Private - Initialize the graphics tool for the receiver"

    handle = NullHandle ifTrue: [^nil].
    graphicsTool := self getGraphicsTool.
    graphicsTool font: self font.
    self graphicsToolForeColor: self foreColor;
        graphicsToolBackColor: self backColor.!
marginExtent
    "Private - Returns the margin of the receiver's frame"

    ^3@3! 
nameForBorder: aPoint
    "Private - Returns the Ht-constant for a point
    in the border of the receiver's view, or nil"

    | margin |
    margin := self marginExtent.
    rectangle isNil ifTrue: [^nil].
    aPoint x <= margin x
    ifTrue: [ "in left border"
        aPoint y <= margin y
        ifTrue: [ ^Httopleft ].
        rectangle height - aPoint y <= margin y
        ifTrue: [ ^Htbottomleft ].
        ^Htleft
    ].
    rectangle width - aPoint x <= margin x
    ifTrue: [ "in right border"
        aPoint y <= margin y
        ifTrue: [ ^Httopright ].
        rectangle height - aPoint y <= margin y
        ifTrue: [ ^Htbottomright ].
        ^Htright
    ].

    aPoint y <= margin y ifTrue: [ ^Httop ].
    rectangle height - aPoint y <= margin y ifTrue: [ ^Htbottom ].

    ^nil!
nonClientRectangles
    "Private - Returns the receiver's top-Rectangle and borders"
    ^(self rectangle nonIntersections: (self rectangle insetBy: self marginExtent))
        , (Array with: self titleRect)!   
rectangleFromUser
    "Private - Answer a rectangle obtained from the user.
     Used for receiver's motion..."
    | rect displacement aPen |
    rect := self frameRectangle.
    displacement := Cursor sense - rect origin.
    aPen := Display pen.
    aPen
        setRop2: R2Notxorpen;
        place: rect origin;
        box: rect corner.
    Notifier consumeInputUntil: [: event |
        event selector = #button1Move:
            ifTrue: [
                aPen
                    place: rect origin;
                    box: rect corner.
                rect moveToLeftTop: Cursor sense - displacement.
                aPen
                    place: rect origin;
                    box: rect corner.
              ].
        event selector = #button1Up:].
    aPen place: rect origin;box: rect corner.
    aPen setRop2: R2Copypen.
    ^rect!   
setWindowText: aString
    "Set the window text of the receiver.
     Implemented by Ale for non side
        effects when handle is invalid"

   self isHandleOk
    ifTrue: [
        super setWindowText: aString.
        " self invalidateRect: self titleRect "
    ]! 
titleRect
    "Private - Returns the receiver's top title rectangle"

    | margin |
    margin := self marginExtent.
    self hasTitle ifFalse: [ ^0@0 extentFromLeftTop: margin ].
    ^margin extentFromLeftTop: self rectangle width - (2 * margin x) @  self font height!  
wmActivate: wordInteger with: longInteger
    "Private - Process the activate message synchronously."

    self nonClientRectangles
    do: [:border| self invalidateRect: border ].

    ^super wmActivate: wordInteger with: longInteger! 
wmErasebkgnd: wordInteger with: longInteger
    "Private - Process the erase background message."
    | oldDC |
    self minimized ifTrue:[^1].     "Do not erase background while minimized"
    graphicsTool isNil ifTrue:[^nil].
    oldDC := graphicsTool privateHandle.
    graphicsTool handle: wordInteger.
    graphicsTool backColor: self backColor.
    graphicsTool erase.
    self drawTitle.
    self event: #eraseBackground.
    graphicsTool handle: oldDC.
    ^1!  
wmNchittest: wParam with: lParam
    "Private - Process mouse input when the receiver must move or resize..."

    | mouse border winPoint |
    #addedByOStyle.
    graphicsTool isNil ifTrue: [^nil].
    mouse := ((WinPoint new:4) uLongAtOffset: 0 put: lParam) asPoint
         mapScreenToClient: self.

    (self titleRect containsPoint: mouse)
    ifTrue: [ ^Htcaption ].

    border := self nameForBorder: mouse.
    border notNil ifTrue: [ ^border ].

    ^nil! !

! MDIChild class methods !  
defMDIChildProcAddress
        "Private - Answer the address of the defMDIChildProc API."

    ^DefMDIChildProcAddress!
new
    "Reimplemented here to add OStyle behavior...
    Implemented by Ale...(see OSMDIFrame...)"

    #addedByOStyle.
    self == MDIChild ifTrue: [ ^OSMDIChild new ].

    ^super new!
startUp
        "Private - Initialize the receiver's class variables."

    DefMDIChildProcAddress:=KernelLibrary  getProcAddress:UserLibrary asParameter procName:'DefMDIChildProc' asParameter.
    DefMDIChildProcAddress:=(WinAddress fromString:DefMDIChildProcAddress) asInteger.!  
supportedEvents
        "Answer the Set of events that MDIChilds can notify
         their owners about."
    ^super supportedEvents
        add: #toggleKey;
        yourself! !

! MDIChild methods !
accel: aChar  afBits: theAfBits

    "Private - Allows a window to intercept character input
     before it is processed either by the menu or the child window.  Returning
     true will cause the character input to be ignored from here on."

    |accelTable index|
    aChar=NumLockKey ifTrue:[self frame event:#toggleKey].
    aChar=InsertKey ifTrue:[self frame event:#toggleKey].
    aChar=CapitalKey ifTrue:[self frame event:#toggleKey].
    (aChar=$Z asciiValue and:[theAfBits = AfAlt]) ifTrue:[self zoom.^true].
    ^super accel: aChar  afBits: theAfBits!  
activate
        "Private - The receiver was activated."

    self isHandleOk ifFalse: [^self]. "already closed"
    super activate.
    self frame childActivate.!  
buildMenuBar
        "Private - Create the menus that make up the menu bar."

    |textPane eachMenu hasSmalltalkMenuBar |

    (self hasSmalltalkMenuBar and:[self menuWindow menus isEmpty]) ifTrue: [
        self menuWindow:self frame makeInitMdiMenu .
        self menuWindow menus isEmpty
            ifTrue:[
                    self menuWindow addMenu:(self fileMenu) owner:self]].

    self hasSmalltalkMenuBar ifTrue:[
        textPane := self searchForDefaultTextPane.
        textPane notNil ifTrue: [
            self menuWindow addMenu: TextPane editMenu owner: textPane.
            Smalltalk isRunTime ifFalse:[
                self menuWindow addMenu: TextPane smalltalkMenu owner: textPane]
            ].

        children do: [ :subpane |
            eachMenu := subpane menu.
            eachMenu notNil ifTrue: [
                self menuWindow addMenu: eachMenu.
                ]].
    ].

    self event:#menuBuilt.

    self mdiMenuWindow:self frame makeMdiMenu.
    self mdiMenuWindow menus do:[:m| self menuWindow addMenu: m].
    self mdiMenuWindow menus do:[:m|
            eachMenu:=self frame  menuWindow menuTitled:m title.
            eachMenu notNil ifTrue:[m copyAttributesFrom:eachMenu]].

    self hasSmalltalkMenuBar ifTrue: [
        (self owner respondsTo: #saveAs) ifFalse: [
            (eachMenu := self menuWindow menuTitled: '&File') notNil
                ifTrue: [eachMenu disableItem: #saveAs]].
    ].

    self menuWindow parent: self frame.
    self menuWindow owner:self.
    self menuWindow systemMenu owner:self.

    "We add the system menus only for mapping the frame system menu items.
    There is no Smalltalk system menus in the MDI documents though."

    self frame hasSmalltalkMenuBar ifTrue: [
        self menuWindow systemMenu
            insertItem: '&Zoom Text    Alt+Z'
            selector: #zoom
            accelKey: $z
            accelBits: AfAlt
            after: 5.
        self menuWindow systemMenu
            insertItem: 'Fonts...'
            selector: #setFonts
            accelKey: nil
            accelBits: nil
            after: 6.
    ].! 
buildWindow
        "Private - Create the document for the receiver."
        "see Microsoft online Q70080 Creating a Hidden MDI Child Window."

    |mdiCreate answer max winaddress m|
    max:=self frame mdiIsMaximized.
    NewWindow notNil ifTrue:[^nil].
    self frame isActive ifFalse:[
        self frame makeActive.
        self frame updateWindow].
    self parent noRedraw:true.

    style isNil ifTrue: [style := self defaultFrameStyle].
    mdiCreate:=WinMdiCreateStruct new.
    mdiCreate szTitle:self label.
    mdiCreate szClass: self winClass.
    mdiCreate hOwner: self dsHandle.
    mdiCreate x:rectangle origin x.
    mdiCreate y:rectangle origin y.
    mdiCreate cx:rectangle width.
    mdiCreate cy:rectangle height.
    mdiCreate style:style.
    mdiCreate lParam:NullHandle.
    winaddress:=WinAddress copyToNonSmalltalkMemory: mdiCreate asParameter.
    NewWindow:=self.
    answer:=WinStructure fromBytes:
    (UserLibrary sendMessage:self parent asParameter
                        msg:WmMdicreate
                        wparam:0
                        lparam:winaddress asParameter).
    NewWindow:=nil.
    mdiCreate free.
    winaddress unlockAndFree.
    handle:=WindowHandle fromInteger:(answer uShortAtOffset:0).
    handle=NullHandle ifTrue:[self panicWmMdiCreate.^nil].
    self frame renumber:self.
    "Set the size of the frame window."
    rectangle := self rectangle.

    m := UserLibrary
            getSystemMenu: self asParameter
            revert: 0.
    self propertyAt: #sysMenu put: m.

    self activeTextPane: self searchForDefaultTextPane.
    self hideWindow.
    self updateClient.
    WinInfo isWindows30 ifTrue:[
        max ifTrue:[self frame mdiMaximize:self]].!   
closeView
    "Private - Close the receiver and all its children."

    |answer active max|

    self isHandleOk ifFalse: [^self]. "already closed"
    #modifiedByOSI.

    answer:=super closeView.
    answer isNil ifTrue:[
        ^nil].

    owner removeView: self.
    self frame childClose.
    self frame renumber:self.
    active:=self frame mdiGetActive.
    active isNil ifTrue:[self setInitMenu].

    self updateClient.

    ^answer!   
contextForItem:anInteger
        "Private - Handle the system menu when the Child document
        is maximized."
    (anInteger between:100 and:150) ifTrue:[
        ^Association key: 'MDIMenu' value: self owner].
    ^super contextForItem:anInteger.! 
deactivate
        "Private - The receiver was deactivated."

    self isHandleOk ifFalse: [^self]. "already closed"
    super deactivate.
    self frame childDeactivate.!  
defaultFrameStyle

    "Modified by OSI to allow for setting a specific style from a
     ViewManager"

        "Private - Answer the default frame style for the receiver."
    | fs |

    ((self respondsTo: #frameStyleFromPStyle) and: [ (fs := self frameStyleFromPStyle) notNil ]) ifTrue: [
        #modifiedByOSI.
        ^fs
    ].

    ^WsMaximizebox |
        WsMinimizebox |
        WsThickframe |
        WsSysmenu |
        WsCaption |
        WsChild |
        WsClipsiblings |
        WsBorder!  
defMDIChildProc
        "Private - Change the default Windows procedure of the receiver
         to use the DefMDIChildProc."
    handle defMDIChildProc:self.!
defWindowProc:msg with:wordInteger with: longInteger
        "Private - MDIChild default procedure."

    ^WinLong fromBytes:(UserLibrary defMDIChildProc: self handle
                        msg: msg
                        wparam: wordInteger
                        lparam: longInteger)!   
destroy
        "Private - destroy the receiver."

    self frame removeMdipane: self.
    self frame mdiDestroy: self.
    self frame avoidDestroyCurrentMenu:self.
    self menuWindow destroy.
    MDISystem mdiSelected:true.! 
disableSystemMenuItemClose
        "Disable the receiver's system menu item close."

    self systemMenuItemClose:false!   
frame
    "Answer the receiver's frame."

    ^frame!  
frame: aFrame
    "Set the receiver's frame to aFrame."

    frame:=aFrame.!   
frameRectangle
        "Answer the receiver's frame area
         as a rectangle."

    ^super frameRectangle mapToWindow:self parent.!   
frameStyleFromPStyle

    "Added by OSI"

    | s pStyle |


    (pStyle := self pStyle) isNil ifTrue: [
        #addedByOSI.
        ^nil
    ].

    s := WsChild | WsClipsiblings.

    (pStyle includes: #maximize) ifTrue: [
        s := s | WsMaximizebox.
    ].
    (pStyle includes: #minimize) ifTrue: [
        s := s | WsMinimizebox.
    ].
    (pStyle includes: #sizable) ifTrue: [
        s := s | WsThickframe.
    ] ifFalse: [
        s := s | WsBorder.
    ].
    (pStyle includes: #sysmenu) ifTrue: [
        s := s | WsSysmenu.
    ].
    (pStyle includes: #titlebar) ifTrue: [
        s := s | WsCaption.
    ].

    ^s!
helpManager
        "Private - Answer the receiver's help manager
        If none, answer the receiver's frame help manager."
    |hm|

    hm := self propertyAt: #helpManager.
    hm notNil ifTrue:[^hm].
    ^self frame propertyAt: #helpManager! 
hideWindow
        "Private - Make the window and all its children invisible."

    self frame mdiIsMaximized ifTrue: [
        self parent noRedraw: true].

    ^super hideWindow!
initialize
        "Private - Initialize the receiver."

    super initialize.
    self systemMenuItemClose:true.!
initMdiWindowSize
    "Modified by OSI with thanks to Robert Gurrieri"
        "Private-Answer the default size of a document."
    |rect extent origin sizeRect offset |

    #modifiedByOSI.
    rect:=self frame mdiClient rectangle.

    "if framingBlock notNil, use it for initial rectangle."
    framingBlock notNil  ifTrue: [
        "If the corner is set to 0@0 use an offset"
        sizeRect := framingBlock value: rect.
        sizeRect leftTop = (0@0) ifTrue: [
            offset := (UserLibrary getSystemMetrics: SmCysize) +
                (UserLibrary getSystemMetrics: SmCyframe).
            ^sizeRect moveTo: ((self frame mdiChildren size - 1) * (offset @ offset))
        ] ifFalse: [
            ^sizeRect
        ].
    ] ifFalse: [
        extent := (rect width * 24 // 25) @ (rect height * 24 // 25).
        extent := extent - ((self frame mdiChildren size - 1) * ( 8 @ 8)).
        origin :=(self frame mdiChildren size - 1) * (8 @ 8).
        ^origin extent: extent
    ].!  
initSize
        "Private - Answer the initial size of the receiver."
    | size |
    self frame isNil ifTrue:[^nil].
    size := (owner respondsTo: #initMdiWindowSize)
                ifTrue: [owner initMdiWindowSize]
                ifFalse: [self initMdiWindowSize].
    ^((size isKindOf: Rectangle)
            ifTrue: [size]
            ifFalse: [
                (size isKindOf: Point)
                    ifTrue: [self boxOfSize: size]
                    ifFalse: [0 @ 0 extent: 100@100]]).!  
isActive
        "Private - Answer true if the receiver's
         is the currently active document."

    ^self frame mdiGetActive==self!
isMDIChild
        "Answer true if receiver is an instance of class
         MDIChild, else answer false."
    ^true!  
label:aString
        "Set the receiver's label without the prefix."

    ^self labelWithoutPrefix:aString!
mdiMenuWindow
    "Private - Answer the receiver's mdiMenuWndow."
    ^mdiMenuWindow!   
mdiMenuWindow:aMenuWindow
    "Private - Set the receiver's mdiMenuWndow."
    mdiMenuWindow:=aMenuWindow!  
mdiSelected
        "Private - Answer if the receiver is already selected."

    ^MDISystem mdiSelected!   
mdiSelected:aBoolean
        "Private - Set the receiver is already selected."

    MDISystem mdiSelected:aBoolean!
menuWindow:aMenuWindow
        "Private - set the receiver's menuWindow."

    ^menuWindow:=aMenuWindow!   
openClassBrowser
        "Private - The user selected Browse Classes from
         the File menu."
    ClassHierarchyBrowser new frame:self frame;openOn: Smalltalk rootClasses.!  
openDiskBrowser
        "Private - The user selected Browse Disk from
         the File menu."
    DiskBrowser new frame:self frame;open!  
openFile
        "Private - User selected Open... from the File menu."
    | dialog file |
    dialog := FileDialog new.
    dialog addSmalltalkFileFilters;
             openFile.

    file := dialog file.
    file isNil ifTrue: [^self].
    file := File pathNameReadOnly: file.
    dialog fileIn
        ifTrue: [
            CursorManager execute change.
            file fileIn.
            CursorManager normal change]
        ifFalse: [TextWindow new  frame:self frame;
            sendInputEvent: #openOnFile: with: file].
    file close! 
openIn: aRectangle
        "Private - Open the receiver in aRectangle."

    self frame isNil & MDISystem isActive ifTrue:[
        self frame:MDISystem frame].
    self buildIcon.
    self frame addMdipane: self.
    self initSize: (self initSize).
    self buildMenuBar.
    children do: [:subpane | subpane open].
    ^self validate!
openWorkspace
        "Private - The user selected New Workspace from
         the File menu."
    TextWindow new
        frame:self frame;
        label: 'Workspace';
        openOn: ''.!
outOfMemory
        "Private - Low resource situation."

    self menuWindow handle=NullHandle ifFalse:[self menuWindow close;destroy].
    super outOfMemory.!   
panicWmMdiCreate

        "Private - Low resource situation- couldn't create an MDI child."

    self updateClient.

    Terminal bell;bell;bell.
    self frame removeMdipane:self.!  
setDocumentMenu
        "Private - set the receiver's menu as the frame's menubar."

    self menuWindow menus isEmpty ifTrue:[^self setInitMenu].
    self frame setDocumentMenu: self.! 
setInitMenu
        "Private - set the initMenu as the frame's menubar."

    self frame setInitMenu!  
showIconicWindow
        "Private - Show the receiver window as an icon."
    self frame mdiIsMaximized ifTrue:[self showWindow.^self].
    super showIconicWindow.!   
showMaximizedWindow
        "Private - Show the receiver window with maximized size."

    self frame mdiMaximize:self.
    self resize: (self rectangle)!
statusPane
        "Answer the receiver's statusPane."

    self frame isNil ifTrue:[^MDISystem frame statusPane].
    ^self frame statusPane!
systemMenuItemClose
        "Private - Answer false if the receiver's system menu item
        close is disabled, else answer true."
    ^self propertyAt: #systemMenuItemClose!   
systemMenuItemClose:aBoolean
        "Private - disable the receiver's system menu item
        close if aBoolean is false."
    self propertyAt: #systemMenuItemClose put:aBoolean.!  
updateClient
        "Private- Update the MDI client."

        self parent noRedraw:false.
        self parent invalidateRect:nil.
        self parent updateWindow.!   
validate
        "Private - Create or recreate the window for the receiver."
    |old answer|

    self parent isHandleOk ifFalse:[^nil].
    old :=  Process enableInterrupts: false. "do not want to receive messages in MDIClient while in buildWindow"
    answer := super validate.
    answer notNil
        ifTrue:[
            self frame mdiActivate:self.
            self updateWindow].
    Process enableInterrupts: old.
    answer isNil ifTrue:[^nil].

    self systemMenuItemClose ifFalse:[self  disableSysMenu:6].
    MDISystem mdiSelected:true.!   
winClass
    "Private- answer the receiver's window class."
    "Same class used for all documents."
    | className wndClass lptr answer|
    className := 'SmalltalkV',self class name.
    wndClass := WinWindowClass new.
    answer:=UserLibrary getClassInfo: WIN hInstanceExe
        className: className asParameter
        wndClass: wndClass asParameter.
    answer ifTrue:[^className].
    UserLibrary getClassInfo: WIN hInstanceExe
        className: 'VWIN' asParameter
        wndClass: wndClass asParameter.
    wndClass style: (CsVredraw | CsHredraw).
    wndClass hIcon:0;
        className: (lptr := WinAddress
            copyToNonSmalltalkMemory: className asAsciiZ) asParameter.
    UserLibrary registerClass: wndClass asParameter.
    lptr unlock; free.
   ^className! 
wmCreate: wordInteger with: longInteger
        "Private - Process WM_CREATE messsage.
        Create menu and subpanes."

    NewWindow:=nil.

    self menuWindow buildPopupWindow isNil ifTrue:[^-1].
    self initGraphics.
    self defMDIChildProc.
    self receiveMessages.

    "Create the subpanes."
    children do: [ :subpane |
        (subpane buildWindow: self) isNil ifTrue: [self outOfMemory.^-1]].

    ^nil!
wmMdiactivate: wordInteger with: longInteger
        "Private - Process the mdiactivate window message."
    "triggers the active and deactivate message."
    |deactivated|
    wordInteger > 0 ifTrue:[self setDocumentMenu.self sendInputEvent:#activate]
                              ifFalse:[self sendInputEvent:#deactivate].

    wordInteger > 0 ifTrue:[MDISystem mdiSelected:false].
    deactivated:=Notifier findWindow:longInteger // 65536.
    deactivated isNil ifTrue:[^self].
    deactivated minimized ifTrue:[MDISystem mdiSelected:true].! !

! OSMDIChild class methods ! 
supportedEvents
    "Answer the Set of events that OSMDIChilds can notify their owners about."

    ^super supportedEvents
        add: #dropFiles; "fileManager's drag&drop support"
        yourself! !

! OSMDIChild methods !  
acceptDropFiles
    "Private - Set the receiver for acepting file drops."

    self dragAcceptFiles: true.!
dragAcceptFiles: aBoolean
    "Private - Set the receiver for acepting file drops."

    self propertyAt: #dropFiles put: #().
    ShellDLL library
        dragAcceptFiles: handle
        state: aBoolean!
droppedFiles
    "Returns currently dropped files list..."
    ^self propertyAt: #dropFiles!
when: anEvent perform: aSymbol
    "Created by Ale for fileManager's drag&drop support..."

    anEvent == #dropFiles
    ifTrue: [
        WinEvents at: 563 put: #wmDropFiles:with:.
        self sendDeferredEvent: #acceptDropFiles.
    ].

    ^super when: anEvent perform: aSymbol!  
wmDropFiles: aHandle with: longInteger
    "Private - Process the wmQuerydragicon window message."
    | count fileName files library |
    library := ShellDLL library.
    count := library
        dragQueryFile: aHandle
        fileNum:  -1
        returnedString:  (fileName := String new: 200)
        size: fileName size.
    files := Array new: count.
    0 to: count - 1 do: [:index  |
        library
            dragQueryFile: aHandle
            fileNum: index
            returnedString:  (fileName := String new: 200)
            size: fileName size.
        files at: index + 1 put: (fileName trimNullTerminator).
    ].
    library dragFinish: aHandle.
    self propertyAt: #dropFiles put: files.
    self event: #dropFiles.
    ^nil! !

! LittleMDIChild class methods !
buildBasicMethodFor: selector in: aClass
    "Private - Build a basic method for a windows message...
     Returns true if successfull..."

    | source result stream |
    Smalltalk isRunTime ifTrue: [^false].
    stream := ReadStream on: selector.
    source := WriteStream on: String new.
    source
        nextPutAll: (stream upTo: $:), ': wParam ', (stream upTo: nil), ' lParam';
        cr;nextPutAll: '    " Private - Attend the windows message ',selector,'."';
        cr;nextPutAll: '    #addedByOStyle.';
        cr;nextPutAll: '    ^nil'.
    source := source contents.
    result := aClass compile: source.
    result isNil ifFalse: [
        Smalltalk
            logSource: source
            forSelector: result key
            inClass: aClass
    ].
    ^result notNil!   
messageTable
    "Private - Returns the aditional messages table..."

    ^#(
        (16r00A1  wmNcLbuttondown:with:)
        (16r00A2  wmNcLbuttonup:with:)
        (16r00A3  wmNcLbuttondblclk:with:)
        (16r0046  wmWindowPosChanging:with:)
        )!  
registerMessages
    "Private - Register aditional messages.
     Returns true if successfull..."

    | msgTable |

    Smalltalk isRunTime ifTrue: [^false].

    msgTable := self messageTable.
    msgTable do: [:tuple|
        (WinEvents at: tuple first) isNil
        ifTrue: [ "Must be registered..."
            (self buildBasicMethodFor: tuple last in: Window) ifFalse: [^false].
            WinEvents at: tuple first put: tuple last.
        ]
    ].

    "Register structures..."
    Dynalink16
        registerType: 'WINDOWPOS'
        as: #(
            (hwnd handle)
            (hwndInsertAfter handle)
            (x short) (y short)
            (cx short) (cy short)
            (flags ushort)
        );yourself.

    ^true!   
supportedEvents
        "Private - Answer the Set of events that GraphPanes can notify
         their owners about."
    ^super supportedEvents
        add: #eraseBackground;
        add: #windowPosChanging;
        add: #windowPosChanged;
        yourself! !

! LittleMDIChild methods !  
bitmapFor: aSymbol
    "Private - Returns the icon for aSymbol"

    | bmp sysBmp |
    bmp := self privateBitmaps at: aSymbol ifAbsent: [].
    bmp isNil ifFalse: [ ^bmp ].
    bmp := Bitmap screenExtent: self font height @ self font height.
    bmp pen
        backColor: WinInfo colorButtonFace;
        erase;
        place: 0@0;
        box: bmp extent - 1.
    aSymbol = #maximize ifTrue: [
        sysBmp := Bitmap fromModule: nil id: ObmZoom.
        bmp pen copyBitmap: sysBmp from: sysBmp boundingBox to: bmp boundingBox.
        sysBmp release.
    ].
    aSymbol = #minimize ifTrue: [
        sysBmp := Bitmap fromModule: nil id: ObmReduce.
        bmp pen copyBitmap: sysBmp from: sysBmp boundingBox to: bmp boundingBox.
        sysBmp release.
    ].
    aSymbol = #restore ifTrue: [
        sysBmp := Bitmap fromModule: nil id: ObmRestore.
        bmp pen copyBitmap: sysBmp from: sysBmp boundingBox to: bmp boundingBox.
        sysBmp release.
    ].
    aSymbol = #sysMenu ifTrue: [
        sysBmp := Bitmap fromModule: nil id: ObmClose.
        bmp pen
                copyBitmap: sysBmp
                from: (WinInfo cyCaption @ 0 corner: sysBmp boundingBox corner)
                to: bmp boundingBox.
        sysBmp release.
    ].

    self privateBitmaps at: aSymbol put: bmp.
    ^bmp!   
close
    "Private - Release resources and close the receiver..."

    self privateBitmaps values do: [:each | each release].
    super close!
defaultFrameStyle
     "Private - Answer the default frame style for the receiver."

    | s |
    (s := self frameStyleFromPStyle) isNil ifFalse: [
        #modifiedByOSI.
        ^s
    ].

    ^ WsChild | WsThickframe!
drawTitle
    "Private - Draw the receiver's top"
    | pen titleRect fillColor |
    pen := self graphicsTool.
    titleRect := self titleRectangle.
    titleRect height > 0 ifFalse: [ ^self ].
    fillColor := UserLibrary getSysColor:
        (self isActive
            ifTrue: [ColorActivecaption]
            ifFalse: [ColorInactivecaption]).
    pen fill: self titleRectangle color: fillColor.

    pen
        font: self font;
        setTextAlign: TaTop;
        foreColor: (UserLibrary getSysColor:
                (self isActive
                    ifTrue: [ColorCaptiontext]
                    ifFalse: ["ColorInactivecaptiontext"19]));
        setBackMode: Transparent;
        centerWinText: self windowText at: titleRect center - (0@2);
        setBackMode: Opaque;
        foreColor: (UserLibrary getSysColor: ColorWindowframe);
        lineFrom: titleRect left @ (titleRect bottom up: 1) to: titleRect right @ (titleRect bottom up: 1);
        drawChain.

        (self hasStyle: WsMaximizebox) ifTrue: [
            (self bitmapFor: (self maximized ifTrue: [#restore] ifFalse: [#maximize]))
                displayAt: self maximizeRectangle origin with: pen
        ].
        (self hasStyle: WsMinimizebox) ifTrue: [ (self bitmapFor: #minimize) displayAt: self minimizeRectangle origin with: pen ].
        (self hasStyle: WsSysmenu) ifTrue: [ (self bitmapFor: #sysMenu) displayAt: self sysRectangle origin with: pen ].! 
frameStyleFromPStyle
    "Returns the settings done by WBuilder...
     Added by OSI"

    | s pStyle |
    #addedByOSI.

    (pStyle := self pStyle) isNil ifTrue: [ ^nil ].

    s :=  WsChild | WsClipsiblings.

    (pStyle includes: #maximize) ifTrue: [ s := s | WsMaximizebox ].
    (pStyle includes: #minimize) ifTrue: [ s := s | WsMinimizebox ].
    (pStyle includes: #sizable) ifTrue: [ s := s | WsThickframe ] ifFalse: [ s := s | WsBorder ].
    (pStyle includes: #sysmenu) ifTrue: [ s := s | WsSysmenu ].
    (pStyle includes: #titlebar) ifTrue: [ s := s | WsCaption ].

    "Support for secondary views as children"
    self == self owner mainView
    ifFalse: [
        (pStyle includes: #mainViewChild)
        ifTrue: [ self parent: self owner mainView ].
    ].

    ^s!
getFreeClientArea: aRectangle
    "Private - Answer the client area available for children of the receiver."

    aRectangle leftTop:(aRectangle leftTop rightAndDown: (0 @ self titleRectangle height)).
    ^aRectangle!
getGraphicsTool
        "Private - Answer a graphics tool for the receiver."
    | dc |
    dc := self getDC.
    graphicsTool isNil
        ifTrue: [ graphicsTool := RecordingPen forDC: dc medium: self]
        ifFalse: [ graphicsTool restoreSegments: dc ].
    ^graphicsTool!  
hasStyle: aStyleConstant
    "Private - Returns true if the receiver has a style aStyleConstant"

    ^(style bitAnd: aStyleConstant) ~= 0!
initGraphics
        "Private - Initialize the graphics tool for the receiver"

    handle = NullHandle ifTrue: [^nil].
    graphicsTool := self getGraphicsTool.
    graphicsTool font: self font.
    self graphicsToolForeColor: self foreColor;
        graphicsToolBackColor: self backColor.!
initialize
    "Private - Initialize the receiver"

    super initialize.
    self propertyAt: #font put: (Font face: 'Arial' size: 0@(SysFont height * 2 // 3) fixedWidth: false).

    ((WinEvents at: 16r00A1) notNil
    or: [ self class registerMessages ])
    ifFalse: [
        MessageBox warning: 'Can''t create ',self class name,' instance ''cause can''t register Windows Messages'.
        ^self class superclass new
    ].! 
marginExtent
    "Private - Returns the margin of the receiver's frame"

    (self hasStyle: WsThickframe) ifTrue: [^0@0].
    ^WinInfo cxBorder @ WinInfo cyBorder!  
maximizeRectangle
    "Private - Returns a rectangle for the maximize button..."

    | titleRect icon |
    titleRect := self titleRectangle.
    icon := self bitmapFor: #maximize.
    ^(titleRect rightBottom leftAndUp: icon extent) extent: icon extent!  
minimizeRectangle
    "Private - Returns a rectangle for the minimize button..."

    | titleRect icon displacement |
    titleRect := self titleRectangle.
    icon := self bitmapFor: #minimize.
    displacement := (self hasStyle: WsMaximizebox)
        ifTrue: [icon width @ 0] ifFalse: [0].
    ^(titleRect rightBottom leftAndUp: icon extent) - displacement extent: icon extent!  
nameForBorder: aPoint
    "Private - Returns the Ht-constant for a point
    in the border of the receiver's view, or nil"

    | margin corner |
    rectangle isNil ifTrue: [^nil].
    (aPoint x < 0 or: [aPoint y < 0]) ifTrue: [^nil].
    self nonClientRectangles
        detect: [:one| one containsPoint: aPoint ]
        ifNone: [^nil].
    margin := self marginExtent.
    corner := WinInfo cyCaption @ WinInfo cyCaption.
    aPoint x <= corner x
    ifTrue: [ "in left border"
        aPoint y <= corner y
        ifTrue: [ ^Httopleft ].
        rectangle height - aPoint y <= corner y
        ifTrue: [ ^Htbottomleft ].
        aPoint x <= margin x ifTrue: [^Htleft] ifFalse: [^nil].
    ].
    rectangle width - aPoint x <= corner x
    ifTrue: [ "in right border"
        aPoint y <= corner y
        ifTrue: [ ^Httopright ].
        rectangle height - aPoint y <= corner y
        ifTrue: [ ^Htbottomright ].
        rectangle width - aPoint x <= margin x
        ifTrue: [^Htright] ifFalse: [^nil]
    ].

    aPoint y <= margin y ifTrue: [ ^Httop ].
    rectangle height - aPoint y <= margin y ifTrue: [ ^Htbottom ].

    ^nil!   
nonClientRectangles
    "Private - Returns the receiver's top-Rectangle and borders"
    ^(self rectangle nonIntersections: (self rectangle insetBy: self marginExtent))
        , (Array with: self titleRectangle)!  
openSystemMenu
     "Private - Open the system menu."

    "No se como mierda hacer para que el system
     menu se abra y se ejecute el item selecto...
    Por lo que lo que hare sera cerrar la ventana..."

    self owner notNil
    ifTrue: [ self owner close ].!  
privateBitmaps
    "Private - Returns the private bitmaps dictionary"
    | dict |
    dict := self propertyAt: #privateBitmaps.
    dict isNil ifTrue: [
        dict := Dictionary new.
        self propertyAt: #privateBitmaps put: dict.
    ].
    ^dict!   
resize: aRectangle repaint: repaint
        "Private - The size of the receiver has been changed
         to aRectangle.  If repaint is true then always repaint
        else repaint only if the aRectangle is different from
        rectangle."

    self getFreeClientArea: aRectangle.
    ^super resize: aRectangle repaint: repaint.!   
setWindowText: aString
    "Set the window text of the receiver."

    | result |
    result := super setWindowText: aString.
    self isHandleOk ifTrue: [ self drawTitle ].
    ^result!  
style
     "Private - Answer the style for the receiver."

    style isNil ifTrue: [ self style: self defaultFrameStyle ].
    ^style!
sysRectangle
    "Private - Returns a rectangle for the system menu button..."

    | titleRect icon |
    titleRect := self titleRectangle.
    icon := self bitmapFor: #sysMenu.
    ^titleRect leftTop extent: icon extent!  
titleRectangle
    "Private - Returns the receiver's top title rectangle"

    | margin titleHeight font |
    margin := self marginExtent.
    titleHeight := (self label size = 0
        and: [ (self hasStyle: WsMaximizebox | WsMinimizebox | WsSysmenu) not])
        ifTrue: [0]
        ifFalse: [
            font := self font.
            font isNil ifTrue: [0] ifFalse: [font height].
        ].
    ^margin extentFromLeftTop: self rectangle width - (2 * margin x) @  titleHeight!  
windowPos
    "Returns the current window position (used when the receiver is changing or has changed...)"
    ^self propertyAt: #windowPos!
wmErasebkgnd: wordInteger with: longInteger
    "Private - Process the erase background message."
    | oldDC |
    self minimized ifTrue:[^1].     "Do not erase background while minimized"
    graphicsTool isNil ifTrue:[^nil].
    oldDC := graphicsTool privateHandle.
    graphicsTool handle: wordInteger.
    graphicsTool backColor: self backColor.
    self drawTitle.
    (self handlesEvent: #eraseBackground)
    ifTrue: [ self event: #eraseBackground ]
    ifFalse: [
        (graphicsTool boundingBox nonIntersections: self titleRectangle)
        do: [:each|
            graphicsTool fill: each color: self backColor
        ].
    ].
    graphicsTool handle: oldDC.
    ^1!   
wmMdiactivate: wordInteger with: longInteger
        "Private - Process the mdiactivate window message."

    self isHandleOk
    ifTrue: [ self invalidateRect: self titleRectangle ].

    ^super wmMdiactivate: wordInteger with: longInteger!   
wmNchittest: wParam with: lParam
    "Private - Process mouse input when the receiver must move or resize..."

    | mouse border winPoint titleRect |
    #addedByOStyle.
    (self minimized or: [ graphicsTool isNil ]) ifTrue: [^nil].
    mouse := ((WinPoint new:4) uLongAtOffset: 0 put: lParam) asPoint
         mapScreenToClient: self.

    titleRect := self titleRectangle.
    (titleRect height > 0 and: [ titleRect containsPoint: mouse])
    ifTrue: [
        ((self hasStyle: WsMaximizebox) and: [ self maximizeRectangle containsPoint: mouse ]) ifTrue: [ ^Htzoom ].
        ((self hasStyle: WsMinimizebox) and: [ self minimizeRectangle containsPoint: mouse ]) ifTrue: [ ^Htreduce ].
        ((self hasStyle: WsSysmenu) and: [ self sysRectangle containsPoint: mouse ]) ifTrue: [ ^Htsysmenu ].
        ^Htcaption
    ].

    border := self nameForBorder: mouse.
    border notNil ifTrue: [ ^border ].

    ^nil!  
wmNcLbuttondown: wParam with: lParam
    "Private - Process mouse button 1 down message in non client area."

    | mouse winPoint titleRect |
    #addedByOStyle.
    (self minimized or: [ graphicsTool isNil ]) ifTrue: [^nil].
    mouse := ((WinPoint new:4) uLongAtOffset: 0 put: lParam) asPoint
         mapScreenToClient: self.

    titleRect := self titleRectangle.
    (titleRect height > 0 and: [ titleRect containsPoint: mouse])
    ifTrue: [
        ((self hasStyle: WsMaximizebox) and: [ self maximizeRectangle containsPoint: mouse ]) ifTrue: [ ^0 ].
        ((self hasStyle: WsMinimizebox) and: [ self minimizeRectangle containsPoint: mouse ]) ifTrue: [ ^0 ].
        ((self hasStyle: WsSysmenu) and: [ self sysRectangle containsPoint: mouse ]) ifTrue: [ ^0 ].
        ^nil
    ].

    ^nil!
wmNcLbuttonup: wParam with: lParam
    "Private - Process mouse button 1 up message in non client area."

    | mouse winPoint titleRect |
    #addedByOStyle.
    (self minimized or: [ graphicsTool isNil ]) ifTrue: [^nil].
    mouse := ((WinPoint new:4) uLongAtOffset: 0 put: lParam) asPoint
         mapScreenToClient: self.

    titleRect := self titleRectangle.
    (titleRect height > 0 and: [ titleRect containsPoint: mouse])
    ifTrue: [
        ((self hasStyle: WsMaximizebox) and: [ self maximizeRectangle containsPoint: mouse ])
        ifTrue: [
            self sendDeferredEvent:
                (self maximized
                    ifTrue: [ #showRestoredWindow ]
                    ifFalse: [ #showMaximizedWindow ]).
            ^0
        ].
        ((self hasStyle: WsMinimizebox) and: [ self minimizeRectangle containsPoint: mouse ])
        ifTrue: [
            self sendDeferredEvent: #showIconicWindow.
            ^0
        ].
        ((self hasStyle: WsSysmenu) and: [ self sysRectangle containsPoint: mouse ])
        ifTrue: [
            self sendDeferredEvent: #openSystemMenu.
            ^0
        ].
        ^nil
    ].

    ^nil! 
wmWindowPosChanged: wParam with: lParam
    "Private - the receiver has been changed of position or size.
     Added by Ale to window motion support.
     Generate a moved event."
    | windowPos |
    windowPos :=
           SelfDefinedStructure
             named: 'WINDOWPOS'
             atAddress: (WinAddress new
                    highHalf: lParam // 65536;
                    lowHalf: lParam \\ 65536;
                    yourself).
     self
        propertyAt: #windowPos
        put: windowPos.

    (self event: #windowPosChanged) notNil
    ifTrue: [ ^0 ].

    ^nil! 
wmWindowPosChanging: wParam with: lParam
    " Private - Attend the windows message wmWindowPosChanging:with:.
    Gets the owner of the receiver an oportunity to control window placement..."
    | windowPos |
    windowPos :=
           SelfDefinedStructure
             named: 'WINDOWPOS'
             atAddress: (WinAddress new
                    highHalf: lParam // 65536;
                    lowHalf: lParam \\ 65536;
                    yourself).
     self
        propertyAt: #windowPos
        put: windowPos.

    (self event: #windowPosChanging) notNil
    ifTrue: [ ^0 ].

    ^nil! !

! WBMDIChild methods ! 
wmMouseactivate: wParam with: lParam
        "Private - If mouse has been clicked on an inactive
         window, select it."
    self mainWindow mdiSelected: true.
    ^MaActivate! !

! MDIFrame class methods ! 
new
    "Reimplemented here to add OStyle behavior...
    Implemented by Ale...(see OSMDIFrame...)"

    #addedByOStyle.
    self == MDIFrame ifTrue: [ ^OSMDIFrame new ].

    ^super new!
startUp
        "Private - Initialize the receiver's class variable."
    |vmLibrary|
    vmLibrary:=DynamicLinkLibrary getHandle:'vwvm20.dll'.
    MDIFrameWndProcAddress:=KernelLibrary  getProcAddress:vmLibrary asParameter procName:'VwDefFrameWndProc' asParameter.
    MDIFrameWndProcAddress:=(WinAddress fromString:MDIFrameWndProcAddress) asInteger.! 
supportedEvents
        "Answer the Set of events that MDIFrames can notify
         their owners about."
    ^super supportedEvents
        add: #mdiMenuBuilt;
        add: #toggleKey;
        add: #childActivate;
        add: #childDeactivate;
        add: #childClose;
        yourself! !

! MDIFrame methods !  
accel: aChar  afBits: theAfBits

    "Private - Allows a window to intercept character input
     before it is processed either by the menu or the child window.  Returning
     true will cause the character input to be ignored from here on."
    |accelTable index|
    aChar=NumLockKey ifTrue:[self event:#toggleKey].
    aChar=InsertKey ifTrue:[self event:#toggleKey].
    aChar=CapitalKey ifTrue:[self event:#toggleKey].
    ^super accel: aChar  afBits: theAfBits!   
activate
    "Modified by OSI"
        "Private - The receiver was activated."

    | focusWindow |

    self isHandleOk ifFalse:[^self].

    self owner isWBWindow ifTrue: [
        #modifiedByOSI.
        focusWindow := self mdiGetActive.
        focusWindow isNil ifTrue: [ ^super activate ].
        focusWindow := focusWindow propertyAt: #focusWindow.
        ((focusWindow notNil and: [ self isActive ]) and: [ self minimized not ]) ifTrue: [
            focusWindow setFocus.
            self event: #activate.
            ^children notNil ifTrue:[
                children do:[ :i| i activate]
            ]
        ].
    ].

    super activate.! 
activeTextPane
        "Answer the subpane of the active MDIChild that has the typing focus."

    |aTextPane mdiDocument|
    mdiDocument:=self mdiGetActive.
    mdiDocument isNil ifTrue:[^nil].
    ^mdiDocument activeTextPane!
addMdipane:aWindow
        "Private - An MDI docuement was created
        Add it to the receiver's mdiChildren."

    mdiChildren addLast: aWindow.
    aWindow parent: self mdiClient.!
avoidDestroyCurrentMenu:anMdiChild

    "Private - see Microsoft online Q67244."
    "do not destroy the menu that is currently in use."
    |menuHandle|

    menuHandle:=UserLibrary getMenu:self asParameter.
    menuHandle:=WinHandle fromInteger:menuHandle.
    menuHandle=anMdiChild menuWindow handle ifTrue:[
        self setInitMenu.
    ].
    ^menuHandle=anMdiChild menuWindow handle! 
buildMenuBar
        "Private - Create the menus that make up the menu bar."

    |mw|

    self event:#menuBuilt.

    self hasSmalltalkMenuBar ifTrue:[
        self menuWindow menus isEmpty ifTrue:[
            self menuWindow addMenu:self fileMenu owner:self]].

    mw:=self makeMdiMenu.
    mw menus do:[:m|
        m isMDIMenu ifFalse:[self menuWindow addMenu:m].
    ].
    self menuWindow systemMenu owner:self.
    self hasSmalltalkMenuBar ifTrue:[
        self menuWindow systemMenu
            insertItem: '&Zoom Text    Alt+Z'
            selector: #zoom
            accelKey: $z
            accelBits: AfAlt
            after: 5.
        self menuWindow systemMenu
            insertItem: 'Fonts...'
            selector: #setFonts
            accelKey: nil
            accelBits: nil
            after: 6].

    self menuWindow owner:self.
    self mdiInitMenu:menuWindow.!
buildWindow
        "Private - Create the host window for the receiver."

    menuWindow:=self mdiInitMenu.
    super buildWindow.!   
cancelMode
        "Private - Cancel any internal mode of the receiver, if any."
    |mdiDocument|
    mdiDocument:=self mdiGetActive.
    mdiDocument notNil
        ifTrue:[mdiDocument cancelMode].
    ^super cancelMode!   
checkItem:itemName forAllMDIChildMenus:menuName
    "Check the menu itemName of the menuName.
    This menu item will be checked for all the MDI documents."

    | theMenu|
    self  mdiChildren do:[:mdi|
        theMenu := mdi menuWindow menuTitled: menuName.
        theMenu checkItem: itemName].
    theMenu:=self mdiInitMenu menuTitled:menuName.
    theMenu notNil ifTrue:[theMenu checkItem:itemName].!   
childActivate
        "Private - an MDI document was created
        Raise the  #childActivate event."
    self event:#childActivate!  
childClose
        "Private - an MDI document was closed.
        Raise the #childClose event."

    self event:#childClose!  
childDeactivate

        "Private - an mdi document was deactivated
        Raise the  childDeactivate event."

    self event:#childDeactivate! 
clearTextModified
        "Private - Clear the modified flag on all the
         receiver's TextPanes."
    mdiChildren do: [:pane |   pane clearTextModified].
    ^super clearTextModified.!
close
        "The receiver is being closed
        Answer nil if one of the receiver's document has not
        been closed."
    super close.
    mdiChildren size >0 ifTrue:[^nil].!  
defaultFrameStyle
        "Private - Answer the default frame style for the receiver."

    ^WsMaximizebox |
        WsMinimizebox |
        WsThickframe |
        WsSysmenu |
        WsCaption |
        WsOverlapped |
        WsClipchildren |
        WsClipsiblings! 
defWindowProc:msg with:wordInteger with: longInteger
        "Private - MDIFrame default proc.
        If the Mdi client handle is null, this is considered as a call to the normal
        default procedure. See Microsoft documentation for the defFrameProc."

    ^WinLong fromBytes:(UserLibrary defFrameProc: self handle
                        mdiClient: self mdiClient asParameter
                        msg: msg
                        wparam: wordInteger
                        lparam: longInteger)!
disableItem:itemName forAllMDIChildMenus:menuName
        "Disable the itemName of the menuName.
        This menu item will be disabled for all the MDI documents.
    Patched by Ale for nul menu test..."

    | theMenu|
    self  mdiChildren do:[:mdi|
        theMenu := mdi menuWindow menuTitled: menuName.
        #modifiedByOStyle. theMenu notNil ifTrue: [ theMenu disableItem: itemName]
    ].
    theMenu:=self mdiInitMenu menuTitled:menuName.
    theMenu notNil ifTrue:[theMenu disableItem:itemName].!   
enableItem:itemName forAllMDIChildMenus:menuName
        "Enable the itemName of the menuName.
        This menu item will be enabled for all the MDI documents."

    | theMenu|
    self  mdiChildren do:[:mdi|
        theMenu := mdi menuWindow menuTitled: menuName.
        theMenu enableItem: itemName].
    theMenu:=self mdiInitMenu menuTitled:menuName.
    theMenu notNil ifTrue:[theMenu enableItem:itemName].!
getFreeClientArea: aRectangle
    "Private - Answer the client area available for children of the receiver.
     It may differ from the actual client area when supplemental windows
     such as a Status Bar or a Tool Bar are added transparently."

    self zoomed ifTrue: [^aRectangle].
    (children select: [:each | each respondsTo: #freeClientArea: ]) do:
        [:eachSupp |eachSupp freeClientArea: aRectangle].
    ^aRectangle! 
getNextMdiChildId
        "Private - Answer the next available id for the reciever's mdiChildren."

   1 to: mdiChildren size + 1 do:[:i|
        mdiChildren at: i ifAbsent:[ ^ i]].!
helpContext
        "Private - Answer the receiver help context."
    |active|

    active := self mdiGetActive.
    active notNil
        ifTrue:[^active helpContext]
        ifFalse:[^super helpContext].! 
helpContext: anAssociation
        "Private - Set the receiver help context."
    |active|

    active := self mdiGetActive.
    active notNil
        ifTrue:[^active helpContext: anAssociation]
        ifFalse:[^super helpContext: anAssociation].!   
helpManager
        "Private - Answer the mdi active document's help manager if any
        else answer the receiver's help manager."

    |active hm|
    active := self mdiGetActive.
    active notNil
        ifTrue:[hm := active propertyAt: #helpManager].
    hm notNil ifTrue:[^hm].
    ^self propertyAt: #helpManager.!   
initialize
        "Private - initialize the receiver"
    super  initialize.
    mdiChildren := OrderedCollection new.!   
isMDIFrame

    "Added by OSI to improve speed in NotificationManager>>activeWindow"
    #addedByOSI.
    ^true!  
makeInitMdiMenu
        "Private - Answer receiver's initial
        menu bar when there is no opened document."
    |tempMenu menu eachMenu|
    tempMenu:=menuWindow.
    menuWindow:=MenuWindow new.
    self event:#menuBuilt.
    menu:=menuWindow.
    menuWindow:=tempMenu.
    menu menus do:[:m|
            eachMenu:=self  menuWindow menuTitled:m title.
            eachMenu notNil ifTrue:[m copyAttributesFrom:eachMenu]].
    ^menu!  
makeMdiMenu
    "Private - Make the receiver's  mdi menu bar
    The menubar is created each time a document
    is created."
    mdiMenu:=MenuWindow new.
    self event:#mdiMenuBuilt.
    self helpManager notNil
        ifTrue: [self helpManager buildMdiMenuBar].
    ^mdiMenu!
mdiActivate:aWindow
        "Private- activate aWindow."
    UserLibrary sendMessage: self mdiClient asParameter
                        msg:WmMdiactivate
                        wparam:aWindow asParameter
                        lparam:0.! 
mdiArrange
        "Arrange the MDI documents."

    UserLibrary sendMessage: self mdiClient asParameter
                        msg:WmMdiiconarrange
                        wparam:0
                        lparam:0.!   
mdiCascade
        "Cascade the MDI documents."

    UserLibrary sendMessage: self mdiClient asParameter
                        msg:WmMdicascade
                        wparam:0
                        lparam:0.!   
mdiChildren
        "Answer a collection of the currently opened MDI documents."

    ^mdiChildren!
mdiClient
        "Private- Answer the receiver's MDI client subpane."

    ^self propertyAt:#mdiClient!   
mdiClient:aSubpane
        "Private- Set the receiver's MDI client subpane."

    self propertyAt:#mdiClient put:aSubpane! 
mdiClose:aWindow
            "Private - close a Window."
            UserLibrary sendMessage: self mdiClient asParameter
                                msg:WmMdirestore
                                wparam:aWindow asParameter
                                lparam:0.
            aWindow close.!  
mdiCloseAll
         "Close all the MDI documents which are not minimized."
    |childrenToClose|
    childrenToClose:=mdiChildren copy.
    childrenToClose do:[:each|
        ((each isHandleOk ifTrue:[each minimized] ifFalse:[false]) not & each systemMenuItemClose)
            ifTrue:[each close]].!   
mdiDestroy:aWindow
        "Private - destroy the mdi document a Window."
            UserLibrary sendMessage: self mdiClient asParameter
                                msg:WmMdidestroy
                                wparam:aWindow asParameter
                                lparam:0.! 
mdiGetActive
        "Answer the MDI active document if any, else answer nil."

    |mdiActive|

    self mdiClient isHandleOk ifFalse:[^nil].
    mdiActive:=(WinStructure fromBytes:(
                            UserLibrary sendMessage: self mdiClient asParameter
                                                msg:WmMdigetactive
                                                wparam:0
                                                lparam:0)) uShortAtOffset:0.

    ^mdiActive:=Notifier findWindow:mdiActive.! 
mdiInitMenu

        "Private - answer the receiver's initMenu."

    ^initMenu!  
mdiInitMenu:aMenuWindow

        "Private - set the receiver's initMenu."

    ^initMenu:=aMenuWindow!
mdiIsMaximized

    "Private - Answer a boolean.Indicates if the active mdi document is minimized."

    |mdiActive|


    mdiActive:=(WinLong fromBytes:(
                            UserLibrary sendMessage: self mdiClient asParameter
                                                msg:WmMdigetactive
                                                wparam:0
                                                lparam:0)) highHalf.
    mdiActive=1 ifTrue:[^true]
                         ifFalse:[^false].!   
mdiMaximize:aWindow
            "Private - Maximize the mdi document aWindow."
            UserLibrary sendMessage: self mdiClient asParameter
                                msg:WmMdimaximize
                                wparam:aWindow asParameter
                                lparam:0.!   
mdiMenu
        "Private- answer MDI Window menu."

    ^menuWindow menus detect:[:m|m isMDIMenu] ifNone:[^menuWindow menus last]! 
mdiMenuWindow
        "Answer the MDI menu window. It contains the menus
        at the right side of the menubar, after the menus specific
        to the MDI document."

    ^mdiMenu! 
mdiNext
        "Private - Activate the next mdi document."
    UserLibrary sendMessage: self mdiClient asParameter
                        msg:WmMdinext
                        wparam:0
                        lparam:0.!
mdiRestore:aWindow
            "Private - restore the MDI document aWindow."
            UserLibrary sendMessage: self mdiClient asParameter
                                msg:WmMdirestore
                                wparam:aWindow asParameter
                                lparam:0.!  
mdiTile
        "Tile the mdi documents."

    UserLibrary sendMessage: self mdiClient asParameter
                        msg:WmMditile
                        wparam:0
                        lparam:0.!
openIn: aRectangle
        "Private - Open the receiver in aRectangle."
    |mdiClient|

    self buildIcon.
    mdiClient:=MDIClient new
                    owner: self.
    self addSubpane:mdiClient.
    self mdiClient:mdiClient.
    self initSize: aRectangle.
    self buildMenuBar.
    children do: [:subpane | subpane open].
    ^self validate! 
removeMdipane: aWindow
        "Private - An mdi document is being closed."

    mdiChildren remove: aWindow ifAbsent:[].! 
renumber:aWindow
        "Private - Renumber the documents."

    |documentsToRenumber i|
    documentsToRenumber:=mdiChildren select:[:each |
            each label = aWindow label].
    documentsToRenumber size > 1 ifTrue:[
        i:=0.
        documentsToRenumber do:[:each |
            i:=i + 1.
            each isHandleOk ifTrue:[
                each setWindowText: each label,':',i printString]]].
    documentsToRenumber size = 1 ifTrue:[
        documentsToRenumber first setWindowText:documentsToRenumber first label]!  
resize: aRectangle repaint: repaint
        "Private - The size of the receiver has been changed
         to aRectangle.  If repaint is true then always repaint
        else repaint only if the aRectangle is different from
        rectangle."
    self getFreeClientArea: aRectangle.
    ^super resize: aRectangle repaint: repaint.! 
setDocumentMenu: anMdiChild
        "Private- Update frame's menu bar."
    |aMenuWindow winlong|
    self mdiGetActive == anMdiChild
        ifFalse:[^self].
    menuWindow:=anMdiChild menuWindow.

    aMenuWindow:=self mdiMenu window handle.
    winlong:=WinLong new.
    winlong uShortAtOffset:0 put: menuWindow handle asInteger.
    winlong uShortAtOffset:2 put: aMenuWindow asInteger.
    UserLibrary sendMessage: self mdiClient asParameter
            msg:WmMdisetmenu
            wparam:0
            lparam: winlong asParameter.

    UserLibrary drawMenuBar: self asParameter.! 
setInitMenu
    "Private-Update the frame menu bar when no mdi documents are opened."
    |aMenuWindow winlong|

    menuWindow:=self mdiInitMenu.

    aMenuWindow:=self mdiMenu window handle.
    winlong:=WinLong new.
    winlong uShortAtOffset:0 put: menuWindow handle asInteger.
    winlong uShortAtOffset:2 put: aMenuWindow asInteger.
    UserLibrary sendMessage: self mdiClient asParameter
            msg:WmMdisetmenu
            wparam:0
            lparam: winlong asParameter.

    UserLibrary drawMenuBar: self asParameter.! 
uncheckItem:itemName forAllMDIChildMenus:menuName
        "Uncheck the itemName of the menuName.
        This menu item will be unchecked for all the MDI documents."

    | theMenu|
    self  mdiChildren do:[:mdi|
        theMenu := mdi menuWindow menuTitled: menuName.
        theMenu uncheckItem: itemName].
    theMenu:=self mdiInitMenu menuTitled:menuName.
    theMenu notNil ifTrue:[theMenu uncheckItem:itemName].!  
validate
        "Private - Reimplemented here to force
        the repainting of the MDIFrame before the
        creation of the MDI documents."
    |answer|

    answer := super validate.
    answer notNil
        ifTrue:[self updateWindow].
    ^answer! 
winClass
        "Private-answer receiver's window class
        Common for all mdi frame."
    | className wndClass lptr answer|
    className := 'SmalltalkV',self class name.
    wndClass := WinWindowClass new.
    answer:=UserLibrary getClassInfo: WIN hInstanceExe
        className: className asParameter
        wndClass: wndClass asParameter.
    answer ifTrue:[^className].
    wndClass := WinWindowClass new.
    wndClass style:0.
    wndClass wndExtra:2.
    wndClass windProc:MDIFrameWndProcAddress.
    wndClass hInstance:WIN hInstanceExe.
    wndClass hIcon:0;
            className: (lptr := WinAddress
            copyToNonSmalltalkMemory: className asAsciiZ) asParameter.
    UserLibrary registerClass: wndClass asParameter.
    lptr unlock; free.
   ^className! 
wmCommand: wordInteger with: longInteger
        "Private - Process the command message.
        need to be reimplemented to send directly
        #performMenuItem to the menuWindow's owner."

    | control|
    (self helpModeCommand: wordInteger) notNil ifTrue:[^0].
    (( longInteger \\ 65536 ) > 0 or: [self isKindOf: DialogTopPane])
        ifTrue: [                    "= 0 for 'enter' key"
            control :=  self childAtId: wordInteger.
            control notNil
                ifTrue: [ control
                    syncControlEvent: ( longInteger // 65536 ) ]]
        ifFalse: [
            self menuWindow owner sendInputEvent: #performMenuItem:     "specify the receiver now !!"
                with: wordInteger ].

    ^nil!
wmErasebkgnd: wordInteger with: longInteger
        "Private - Process the erase background message."
        "Will be erased by the MDIClient"
    ^1!
wmSize: wordInteger with: longInteger
        "Private - Process the erase wmSize message."
        "Reimplemented here because the MDIClient is
        resized by Smalltalk."
    super  wmSize: wordInteger with: longInteger.
    ^true! !

! OSMDIFrame class methods !   
supportedEvents
    "Answer the Set of events that OSMDIFrames can notify their owners about."
    ^super supportedEvents
        add: #dropFiles; "fileManager's drag&drop support"
        yourself! !

! OSMDIFrame methods !
acceptDropFiles
    "Private - Set the receiver for acepting file drops."

    self dragAcceptFiles: true.!
dragAcceptFiles: aBoolean
    "Private - Set the receiver for acepting file drops."

    self propertyAt: #dropFiles put: #().
    ShellDLL library
        dragAcceptFiles: handle
        state: aBoolean!
droppedFiles
    "Returns currently dropped files list..."
    ^self propertyAt: #dropFiles!
when: anEvent perform: aSymbol
    "Created by Ale for fileManager's drag&drop support..."

    anEvent == #dropFiles
    ifTrue: [
        WinEvents at: 563 put: #wmDropFiles:with:.
        self sendDeferredEvent: #acceptDropFiles.
    ].

    ^super when: anEvent perform: aSymbol!  
wmDropFiles: aHandle with: longInteger
    "Private - Process the wmQuerydragicon window message."
    | count fileName files library |
    library := ShellDLL library.
    count := library
        dragQueryFile: aHandle
        fileNum:  -1
        returnedString:  (fileName := String new: 200)
        size: fileName size.
    files := Array new: count.
    0 to: count - 1 do: [:index  |
        library
            dragQueryFile: aHandle
            fileNum: index
            returnedString:  (fileName := String new: 200)
            size: fileName size.
        files at: index + 1 put: (fileName trimNullTerminator).
    ].
    library dragFinish: aHandle.
    self propertyAt: #dropFiles put: files.
    self event: #dropFiles.
    ^nil! !

! TopAppPane class methods !
aditionalEvents
    "Private - Returns the aditional events for the receiver
    extracting them from aditionalEventsTable..."

    | set |
    set := Set new.
    self aditionalEventsTable do: [:tuple|
        tuple size >= 3
        ifTrue: [ set add: (tuple at: 3) ]
    ].
    set remove: #none ifAbsent: [].
    ^set! 
aditionalEventsTable
    "Private - Returns the aditional events table...
    This method can be refined by subclasses."

        "WM_...   wmSelector           eventName (or #none)"
    ^#(
        (16r030F  wmQueryNewPalette:with: queryNewPalette)
        (16r0310  wmPaletteIsChanging:with: paletteIsChanging)
        (16r0311  wmPaletteChanged:with: paletteChanged)
    )! 
buildBasicMethodFor: selector in: aClass
    "Private - Build a basic method for a windows message...
     Returns true if successfull..."

    | source result stream |
    Smalltalk isRunTime ifTrue: [^false].
    stream := ReadStream on: selector.
    source := WriteStream on: String new.
    source
        nextPutAll: (stream upTo: $:), ': wParam ', (stream upTo: nil), ' lParam';
        cr;nextPutAll: '    " Private - Attend the windows message ',selector,'."';
        cr;nextPutAll: '    #addedByOStyle.';
        cr;nextPutAll: '    ^nil'.
    source := source contents.
    result := aClass compile: source.
    result isNil ifFalse: [
        Smalltalk
            logSource: source
            forSelector: result key
            inClass: aClass
    ].
    Transcript cr;nextPutAll: 'Method generated: ',result value printString.
    ^result notNil! 
registerMessages
    "Private - Register aditional messages.
     Returns true if successfull..."

    | msgTable index |

    Smalltalk isRunTime ifTrue: [^false].

    msgTable := self aditionalEventsTable.
    msgTable do: [:tuple|
        index := tuple first.
        (((index between: 1 and: WinEvents size) and: [ (WinEvents at: index) isNil ])
          or: [(WinEventsExtra includesKey: index) not])
        ifTrue: [ "Must be registered..."
            (self buildBasicMethodFor: (tuple at: 2) in: Window) ifFalse: [^false].
            (self buildBasicMethodFor: (tuple at: 2) in: self) ifFalse: [^false].
            (index between: 1 and: WinEvents size)
            ifTrue: [ WinEvents at: index put: (tuple at: 2) ]
            ifFalse: [ WinEventsExtra at: index put: (tuple at: 2) ].
        ]
    ].

    ^true!   
supportedEvents
    "Answer the Set of events that SubPanes can notify their owners about.
    See into the aditional events for new events..."

    ^super supportedEvents
        add: #deactivate;
        add: #dropFiles;
        addAll: self aditionalEvents;
        yourself!
unRegisteredMessage
    "Private - Returns one unregisterd message or nil."

    | index |
    ^self aditionalEventsTable
        detect: [:one|
            index := one first.
            (index between: 1 and: WinEvents size)
            ifTrue: [ (WinEvents at: index) isNil ]
            ifFalse: [ (WinEventsExtra includesKey: index) not ]
        ] ifNone: []! !

! TopAppPane methods !  
acceptDropFiles
    "Private - Set the receiver for acepting file drops."

    self dragAcceptFiles: true.!
amountToJump
    "Private - Returns the amount to jump
     when a cursor key is pressed"
    ^16! 
arrowKeyInput: anInt withKeys: keyArray
    "Private - Cursor positioning keys..."
    | amount direction |
    (owner respondsTo: #arrowKeyInput:withKeys:)
    ifTrue: [
        (owner arrowKeyInput: anInt withKeys: keyArray)
        isNil ifFalse: [^self] "handled by owner"
    ].

    "Move the cursor if arrow keys..."

    "determine amount to move"
    amount := (
        (keyArray includes: ShiftKey)
        or: [keyArray includes: ControlKey])
        ifTrue: [1] ifFalse: [self amountToJump].

    "determine direction"
    anInt = RightKey ifTrue: [direction := 1@0 * amount].
    anInt = LeftKey ifTrue: [direction := -1@0 * amount].
    anInt = UpKey ifTrue: [direction := 0@-1 * amount].
    anInt = DownKey ifTrue: [direction := 0@1 * amount].

    "move the cursor"
    direction notNil
    ifTrue: [Cursor offset: Cursor offset + direction]! 
buildMenuBar
    "Build the menu bar for the receiver"
    | subMenu mainMenu textPane |
    mainMenu := (self owner respondsTo: #getMenu)
        ifTrue:  [self owner getMenu]
        ifFalse: [self fileMenu owner: self].
    mainMenu notNil
    ifTrue: [
        mainMenu owner isNil
        ifTrue: [mainMenu owner: self].
        menuWindow addMenu: mainMenu
    ].
    textPane := self searchForDefaultTextPane.
    textPane notNil ifTrue: [
        menuWindow addMenu: TextPane editMenu owner: textPane.
        Smalltalk isRunTime
        ifFalse: [
            menuWindow addMenu: TextPane smalltalkMenu owner: textPane
        ].
        ].
    children do: [:each|
        subMenu := each menu.
        subMenu notNil
        ifTrue: [ menuWindow addMenu: subMenu ]
    ].
    self event: #menuBuilt!   
clearSelection
    "Private - Selection clearing the selection."
    (owner respondsTo: #clearSelection)
    ifTrue: [owner clearSelection]!   
copySelection
    "Private - Selection copying."
    (owner respondsTo: #copySelection)
    ifTrue: [owner copySelection]! 
cutSelection
    "Private - Selection cutting."
    (owner respondsTo: #cutSelection)
    ifTrue: [owner cutSelection]!
deactivate
    "Deactivates the receiver"
    super deactivate.

    self event: #deactivate.!
dragAcceptFiles: aBoolean
    "Private - Set the receiver for acepting file drops."

    self propertyAt: #dropFiles put: #().
    ShellDLL library
        dragAcceptFiles: handle
        state: aBoolean!
droppedFiles
    "Returns currently dropped files list..."
    ^self propertyAt: #dropFiles!
functionKey: anInt withKeys: keysArray
    "Private - Lets the owner determine what to
     do when funtion key is pressed."
    (owner respondsTo: #functionKey:withKeys:)
    ifTrue: [owner functionKey: anInt withKeys: keysArray]!   
help
    "Private - Process help requirement."
    (owner respondsTo: #help)
    ifTrue: [owner help]! 
initialize
    "Private - Initialize the receiver"

    super initialize.

    (self class unRegisteredMessage notNil and: [ self class registerMessages not ])
    ifTrue: [
        MessageBox warning: 'Can''t create ',self class name,' because can''t register WM_messages'.
        ^self class superclass new
    ].!
pasteSelection
    "Private - Selection pasting..."
    (owner respondsTo: #pasteSelection)
    ifTrue: [owner pasteSelection]!
showMinimizedWindow
    "Private - Show the receiver window as an icon."
    UserLibrary
        showWindow: handle
        command: SwMinimize!  
unknownWinEvent: longStruct with: wordStruct
    "Private - An unknown event from Windows was received;
    if it is for a subpane of the receiver then propagates as
    #unknownWinEvent:wParam:lParam: message..."

    | event |
    children do: [:each|
        each handle asInteger = longStruct
        ifTrue: [
            ^(each respondsTo: #unknownWinEvent:wParam:lParam:)
            ifTrue: [
                event := WinMsgST.
                each
                    unknownWinEvent: event msg
                    wParam: event wparam
                    lParam: event lparam
            ]
        ].
    ].
    ^nil!
virtualKeyInput: anInt withKeys: keyArray
        "Private - Process non-character keys."

    anInt = F1Key
    ifTrue: [^self sendInputEvent: #help].

    anInt = DeleteKey
    ifTrue: [
            (keyArray includes: ShiftKey)
                ifTrue: [^self sendInputEvent: #cutSelection].
            ^self sendInputEvent: #clearSelection
    ].

  anInt = InsertKey
        ifTrue: [
            (keyArray includes: ControlKey)
                ifTrue: [^self sendInputEvent: #copySelection].
            (keyArray includes: ShiftKey)
                ifTrue: [^self sendInputEvent: #pasteSelection]].

    (anInt between: EndKey and: DownKey)
    ifTrue: [
        ^self sendInputEvent: #arrowKeyInput:withKeys:
                    withArgs: (Array with: anInt with: keyArray)
    ].

    (anInt between: F1Key and: F12Key)
    ifTrue: [
        ^self sendInputEvent: #functionKey:withKeys:
                    withArgs: (Array with: anInt with: keyArray)
    ].


    super virtualKeyInput: anInt  withKeys: keyArray.! 
when: anEvent perform: aSymbol
    "Created by LRP for drag&drop support.
     Touched by Ale for proper WinEvents initialization..."
    anEvent == #dropFiles
    ifTrue: [
        WinEvents at: 563 put: #wmDropFiles:with:.
        self sendDeferredEvent: #acceptDropFiles.
    ].

    ^super when: anEvent perform: aSymbol!
winIniChange: aString
    "Private - The Windows initialization file WIN.INI changed."
    super winIniChange: aString.
    self children do:[:each|
        (each respondsTo: #winIniChange:)
        ifTrue: [each winIniChange: aString]
    ]!  
wmDropFiles: aHandle with: longInteger
    "Private - Process the wmQuerydragicon window message."
    | count fileName files library |
    library := ShellDLL library.
    count := library
        dragQueryFile: aHandle
        fileNum:  -1
        returnedString:  (fileName := String new: 200)
        size: fileName size.
    files := Array new: count.
    0 to: count - 1 do: [:index  |
        library
            dragQueryFile: aHandle
            fileNum: index
            returnedString:  (fileName := String new: 200)
            size: fileName size.
        files at: index + 1 put: (fileName trimNullTerminator).
    ].
    library dragFinish: aHandle.
    self propertyAt: #dropFiles put: files.
    self event: #dropFiles.
    ^nil!  
wmPaletteChanged: wParam with: lParam
    " Private - Attend the windows message wmPaletteChanged:with:.
    The WM_PALETTECHANGED message is sent to all top-level
     and overlapped windows after the window with the input focus
     has realized its logical palette, thereby changing the system
     palette. This message allows a window without the input
     focus that uses a color palette to realize its logical palette
     and update its client area.
    An application should return zero if it processes this message."

    | result |
    result := self event: #paletteChanged.
    result notNil ifTrue: [^0].
    ^nil! 
wmPaletteIsChanging: wParam with: lParam
    " Private - Attend the windows message wmPaletteIsChanging:with:.
    The WM_PALETTEISCHANGING message informs applications that
     an application is going to realize its logical palette.
    An application should return zero if it processes this message. "

    | result |
    result := self event: #paletteIsChanging.
    result notNil ifTrue: [^0].
    ^nil! 
wmQuerydragicon: wordInteger with: longInteger
    "Private - Process the wmQuerydragicon window message."
    ^super wmQuerydragicon: wordInteger with: longInteger
    " ^1 "!   
wmQueryNewPalette: wParam with: lParam
    " Private - Attend the windows message wmQueryNewPalette:with:.
    The WM_QUERYNEWPALETTE message informs an application
     that it is about to receive the input focus, giving the application an
     opportunity to realize its logical palette when it receives the focus.
    An application should return nonzero if it realizes its logical palette;
     otherwise, it should return zero. "

    | result |
    result := self event: #queryNewPalette.
    result isInteger ifTrue: [^result].
    ^nil! !

! DrawableTopPane class methods !
aditionalEventsTable
    "Private - Returns the aditional events table..."

    ^#(
        "WM_...   wmSelector           eventName (or #none)"
        (16r0047  wmWindowPosChanged:with: moved)
        (16r0014  wmErasebkgnd:with: eraseBackground)
        ), super aditionalEventsTable!
registerMessages
    "Private - Register aditional messages.
     Returns true if successfull..."

    super registerMessages ifFalse: [^false].

    "Register structures..."
    Dynalink16
        registerType: 'WINDOWPOS'
        as: #(
            (hwnd handle)
            (hwndInsertAfter handle)
            (x short) (y short)
            (cx short) (cy short)
            (flags ushort)
        );yourself.

    ^true!   
supportedEvents
        "Private - Answer the Set of events that GraphPanes can notify
         their owners about."
    ^super supportedEvents
        add: #button1DoubleClick;
        add: #button1Down;
        add: #button1DownShift;
        add: #button1Move;
        add: #button1Up;
        add: #button2DoubleClick;
        add: #button2Down;
        add: #button2Move;
        add: #button2Up;
        add: #mouseMove;
        add: #display;
        yourself! !

! DrawableTopPane methods !   
button1DoubleClick: aPoint
        "Private - Left button has been double clicked.
        Let the owner process the event."
    mouse := aPoint.
    self event: #button1DoubleClick.!   
button1Down: aPoint
        "Private - Left button has been pressed down.
        Let the owner process the event."
    (super button1Down: aPoint) ifFalse:[^ self].
    self captureMouseInput.
    mouse := aPoint.
    self event: #button1Down.!   
button1DownShift: aPoint
        "Private - Left button and shift key are both down.
        Let the owner process the event."
    self captureMouseInput.
    mouse := aPoint.
    self event: #button1DownShift.!  
button1Move: aPoint
        "Private - Left button is down and the
        mouse has been moved.
        Let the owner process the event."
    handle = WindowHandle queryCapture ifFalse: [^self].
    mouse := aPoint.
    self event: #button1Move.! 
button1Up: aPoint
        "Private - Left button has been released.
        Let the owner process the event."
    handle = WindowHandle queryCapture ifFalse: [^self].
    self clearMouseCapture.
    mouse := aPoint.
    self event: #button1Up.!
button2DoubleClick: aPoint
        "Private - Right button has been double clicked.
        Let the owner process the event."
    mouse := aPoint.
    self event: #button2DoubleClick.!  
button2Down: aPoint
        "Private - Right button has been pressed down.
        Let the owner process the event
        or do the right button scrolling."
    mouse := aPoint.
    (self handlesEvent: #button2Down)
        ifFalse: [super button2Down: aPoint]
        ifTrue: [self event: #button2Down].! 
button2Move: aPoint
        "Private - Right button is down and the
        mouse has been moved.
        Let the owner process the event."
    mouse := aPoint.
    self event: #button2Move.!  
button2Up: aPoint
        "Private - Right button has been released.
        Let the owner process the event or
        finish the right button scrolling."
    mouse := aPoint.
    self clearMouseCapture.
    (self handlesEvent: #button2Up)
        ifFalse: [super button2Up: aPoint]
        ifTrue: [self event: #button2Up].!
display
        "Private - Let the owner process the display event
        or draw all the retained segments."

    super display.
    self minimized ifTrue:[^self].

    (self handlesEvent: #display)
        ifTrue: [self event: #display]
        ifFalse: [graphicsTool drawChain]!   
getGraphicsTool
        "Private - Answer a graphics tool for the receiver."
    | dc |
    dc := self getDC.
    graphicsTool isNil
        ifTrue: [ graphicsTool := RecordingPen forDC: dc medium: self]
        ifFalse: [ graphicsTool restoreSegments: dc ].
    ^graphicsTool!  
initGraphics
        "Private - Initialize the graphics tool for the receiver"

    handle = NullHandle ifTrue: [^nil].
    graphicsTool := self getGraphicsTool.
    graphicsTool font: self font.
    self graphicsToolForeColor: self foreColor;
        graphicsToolBackColor: self backColor.!
mouseLocation
        "Answer the mouse location as of the last
         mouse input event received."
    | winPoint |
    winPoint := WinPoint fromPoint: mouse.
    GDILibrary
        dpToLp: graphicsTool handle
        point: winPoint asParameter
        count: 1.
    ^winPoint asPoint!
mouseMove: aPoint
        "Private - Mouse has moved to aPoint.
        Let the owner process the event."
    mouse := aPoint.
    self event: #mouseMove!
windowPos
    "Returns the last windowPos setted from the last
     WM_WindowPosChanged message..."
    ^self propertyAt: #windowPos!  
wmErasebkgnd: wordInteger with: longInteger
    "Private - Process the erase background message."
    | oldDC |
    self minimized ifTrue:[^1].     "Do not erase background while minimized"
    graphicsTool isNil ifTrue:[^nil].
    oldDC := graphicsTool privateHandle.
    graphicsTool handle: wordInteger.
    graphicsTool backColor: self backColor.
    graphicsTool erase.
    self event: #eraseBackground.
    graphicsTool handle: oldDC.
    ^1!   
wmWindowPosChanged: wordInteger with: longInteger
    "Private - the receiver has been changed of position or size.
     Added by Ale to window motion support.
     Generate a moved event."

     self
        propertyAt: #windowPos
        put: (
           SelfDefinedStructure
             named: 'WINDOWPOS'
             atAddress: (
                WinAddress new
                    highHalf: longInteger // 65536;
                    lowHalf: longInteger \\ 65536;
                    yourself
            )
        ).

    self event: #moved.

    ^nil! !

! LittleTopPane class methods ! 
aditionalEventsTable
    "Private - Returns the aditional events table..."

    ^#(
        "WM_...   wmSelector           eventName (or #none)"
        (16r00A1  wmNcLbuttondown:with: none)
        (16r00A2  wmNcLbuttonup:with: none)
        (16r00A3  wmNcLbuttondblclk:with: none)
        (16r0046  wmWindowPosChanging:with: windowPosChanging)
        (16r0047  wmWindowPosChanged:with: windowPosChanged)
        (16r0014  wmErasebkgnd:with: eraseBackground)
        ), super aditionalEventsTable!
registerMessages
    "Private - Register aditional messages.
     Returns true if successfull..."

    super registerMessages ifFalse: [^false].

    "Register structures..."
    Dynalink16
        registerType: 'WINDOWPOS'
        as: #(
            (hwnd handle)
            (hwndInsertAfter handle)
            (x short) (y short)
            (cx short) (cy short)
            (flags ushort)
        );yourself.

    ^true! !

! LittleTopPane methods !
bitmapFor: aSymbol
    "Private - Returns the icon for aSymbol"

    | bmp sysBmp |
    bmp := self privateBitmaps at: aSymbol ifAbsent: [].
    bmp isNil ifFalse: [ ^bmp ].
    bmp := Bitmap screenExtent: self font height @ self font height.
    bmp pen
        backColor: WinInfo colorButtonFace;
        erase;
        place: 0@0;
        box: bmp extent - 1.
    aSymbol = #maximize ifTrue: [
        sysBmp := Bitmap fromModule: nil id: ObmZoom.
        bmp pen copyBitmap: sysBmp from: sysBmp boundingBox to: bmp boundingBox.
        sysBmp release.
    ].
    aSymbol = #minimize ifTrue: [
        sysBmp := Bitmap fromModule: nil id: ObmReduce.
        bmp pen copyBitmap: sysBmp from: sysBmp boundingBox to: bmp boundingBox.
        sysBmp release.
    ].
    aSymbol = #restore ifTrue: [
        sysBmp := Bitmap fromModule: nil id: ObmRestore.
        bmp pen copyBitmap: sysBmp from: sysBmp boundingBox to: bmp boundingBox.
        sysBmp release.
    ].
    aSymbol = #sysMenu ifTrue: [
        sysBmp := Bitmap fromModule: nil id: ObmClose.
        bmp pen
                copyBitmap: sysBmp
                from: (WinInfo cyCaption @ 0 corner: sysBmp boundingBox corner)
                to: bmp boundingBox.
        sysBmp release.
    ].

    self privateBitmaps at: aSymbol put: bmp.
    ^bmp!   
close
    "Private - Release resources and close the receiver..."

    self privateBitmaps values do: [:each | each release].
    super close!
defaultFrameStyle
     "Private - Answer the default frame style for the receiver."

    | s |
    (s := self frameStyleFromPStyle) isNil ifFalse: [
        #modifiedByOSI.
        ^s
    ].

    ^ WsPopup | WsThickframe "| WsMaximize"  "| WsDlgframe"! 
drawTitle
    "Private - Draw the receiver's top"
    | pen titleRect fillColor |
    pen := self graphicsTool.
    titleRect := self titleRectangle.
    titleRect height > 0 ifFalse: [ ^self ].
    fillColor := UserLibrary getSysColor:
        (self isActive
            ifTrue: [ColorActivecaption]
            ifFalse: [ColorInactivecaption]).

    pen fill: self titleRectangle color: fillColor.

    pen
        font: self font;
        setTextAlign: TaTop;
        foreColor: (UserLibrary getSysColor:
                (self isActive
                    ifTrue: [ColorCaptiontext]
                    ifFalse: ["ColorInactivecaptiontext"19]));
        setBackMode: Transparent;
        centerWinText: self windowText at: titleRect center - (0@2);
        setBackMode: Opaque;
        foreColor: (UserLibrary getSysColor: ColorWindowframe);
        lineFrom: titleRect left @ (titleRect bottom up: 1) to: titleRect right @ (titleRect bottom up: 1);
        drawChain.

        (self hasStyle: WsMaximizebox) ifTrue: [
            (self bitmapFor: (self maximized ifTrue: [#restore] ifFalse: [#maximize]))
                displayAt: self maximizeRectangle origin with: pen
        ].
        (self hasStyle: WsMinimizebox) ifTrue: [ (self bitmapFor: #minimize) displayAt: self minimizeRectangle origin with: pen ].
        (self hasStyle: WsSysmenu) ifTrue: [ (self bitmapFor: #sysMenu) displayAt: self sysRectangle origin with: pen ].!   
frameStyleFromPStyle
    "Returns the settings done by WBuilder...
     Added by OSI"

    | s pStyle |
    #addedByOSI.

    (pStyle := self pStyle) isNil ifTrue: [ ^nil ].

    s :=  WsPopup | WsClipsiblings.

    (pStyle includes: #maximize) ifTrue: [ s := s | WsMaximizebox ].
    (pStyle includes: #minimize) ifTrue: [ s := s | WsMinimizebox ].
    (pStyle includes: #sizable) ifTrue: [ s := s | WsThickframe ] ifFalse: [ s := s | WsBorder ].
    (pStyle includes: #sysmenu) ifTrue: [ s := s | WsSysmenu ].
    (pStyle includes: #titlebar) ifTrue: [ s := s | WsCaption ].

    "Support for secondary views as children"
    self == self owner mainView
    ifFalse: [
        (pStyle includes: #mainViewChild)
        ifTrue: [ self parent: self owner mainView ].
    ].

    ^s!
getFreeClientArea: aRectangle
    "Private - Answer the client area available for children of the receiver."

    aRectangle leftTop:(aRectangle leftTop rightAndDown: (0 @ self titleRectangle height)).
    ^aRectangle!
getGraphicsTool
        "Private - Answer a graphics tool for the receiver."
    | dc |
    dc := self getDC.
    graphicsTool isNil
        ifTrue: [ graphicsTool := RecordingPen forDC: dc medium: self]
        ifFalse: [ graphicsTool restoreSegments: dc ].
    ^graphicsTool!  
hasStyle: aStyleConstant
    "Private - Returns true if the receiver has a style aStyleConstant"

    ^(style bitAnd: aStyleConstant) ~= 0!
initGraphics
        "Private - Initialize the graphics tool for the receiver"

    handle = NullHandle ifTrue: [^nil].
    graphicsTool := self getGraphicsTool.
    graphicsTool font: self font.
    self graphicsToolForeColor: self foreColor;
        graphicsToolBackColor: self backColor.!
initialize
    "Private - Initialize the receiver"

    super initialize.
    self
        propertyAt: #font
        put: (Font face: 'Arial' size: 0@(SysFont height * 2 // 3) fixedWidth: false).!
marginExtent
    "Private - Returns the margin of the receiver's frame"

    (self hasStyle: WsThickframe) ifTrue: [^0@0].
    ^WinInfo cxBorder @ WinInfo cyBorder!  
maximizeRectangle
    "Private - Returns a rectangle for the maximize button..."

    | titleRect icon |
    titleRect := self titleRectangle.
    icon := self bitmapFor: #maximize.
    ^(titleRect rightBottom leftAndUp: icon extent) extent: icon extent!  
minimizeRectangle
    "Private - Returns a rectangle for the minimize button..."

    | titleRect icon displacement |
    titleRect := self titleRectangle.
    icon := self bitmapFor: #minimize.
    displacement := (self hasStyle: WsMaximizebox)
        ifTrue: [icon width @ 0] ifFalse: [0].
    ^(titleRect rightBottom leftAndUp: icon extent) - displacement extent: icon extent!  
nameForBorder: aPoint
    "Private - Returns the Ht-constant for a point
    in the border of the receiver's view, or nil"

    | margin corner |
    rectangle isNil ifTrue: [^nil].
    (aPoint x < 0 or: [aPoint y < 0]) ifTrue: [^nil].
    self nonClientRectangles
        detect: [:one| one containsPoint: aPoint ]
        ifNone: [^nil].
    margin := self marginExtent.
    corner := WinInfo cyCaption @ WinInfo cyCaption.
    aPoint x <= corner x
    ifTrue: [ "in left border"
        aPoint y <= corner y
        ifTrue: [ ^Httopleft ].
        rectangle height - aPoint y <= corner y
        ifTrue: [ ^Htbottomleft ].
        aPoint x <= margin x ifTrue: [^Htleft] ifFalse: [^nil].
    ].
    rectangle width - aPoint x <= corner x
    ifTrue: [ "in right border"
        aPoint y <= corner y
        ifTrue: [ ^Httopright ].
        rectangle height - aPoint y <= corner y
        ifTrue: [ ^Htbottomright ].
        rectangle width - aPoint x <= margin x
        ifTrue: [^Htright] ifFalse: [^nil]
    ].

    aPoint y <= margin y ifTrue: [ ^Httop ].
    rectangle height - aPoint y <= margin y ifTrue: [ ^Htbottom ].

    ^nil!   
nonClientRectangles
    "Private - Returns the receiver's top-Rectangle and borders"
    ^(self rectangle nonIntersections: (self rectangle insetBy: self marginExtent))
        , (Array with: self titleRectangle)!  
openSystemMenu
     "Private - Open the system menu."

    "No se como mierda hacer para que el system
     menu se abra y se ejecute el item selecto...
    Por lo que lo que hare sera cerrar la ventana..."

    self owner notNil
    ifTrue: [ self owner close ].!  
privateBitmaps
    "Private - Returns the private bitmaps dictionary"
    | dict |
    dict := self propertyAt: #privateBitmaps.
    dict isNil ifTrue: [
        dict := Dictionary new.
        self propertyAt: #privateBitmaps put: dict.
    ].
    ^dict!   
resize: aRectangle repaint: repaint
        "Private - The size of the receiver has been changed
         to aRectangle.  If repaint is true then always repaint
        else repaint only if the aRectangle is different from
        rectangle."

    self getFreeClientArea: aRectangle.
    ^super resize: aRectangle repaint: repaint.!   
setWindowText: aString
    "Set the window text of the receiver."

    | result |
    result := super setWindowText: aString.
    self isHandleOk ifTrue: [ self drawTitle ].
    ^result!  
style
     "Private - Answer the style for the receiver."

    style isNil ifTrue: [ self style: self defaultFrameStyle ].
    ^style!
sysRectangle
    "Private - Returns a rectangle for the system menu button..."

    | titleRect icon |
    titleRect := self titleRectangle.
    icon := self bitmapFor: #sysMenu.
    ^titleRect leftTop extent: icon extent!  
titleRectangle
    "Private - Returns the receiver's top title rectangle"

    | margin titleHeight font |
    margin := self marginExtent.
    titleHeight := (self label size = 0 and: [ (self hasStyle: WsMaximizebox | WsMinimizebox | WsSysmenu) not])
        ifTrue: [0]
        ifFalse: [
            font := self font.
            font isNil ifTrue: [0] ifFalse: [font height].
        ].
    ^margin extentFromLeftTop: self rectangle width - (2 * margin x) @  titleHeight!   
windowPos
    "Returns the current window position (used when the receiver is changing or has changed...)"
    ^self propertyAt: #windowPos!
wmActivate: wordInteger with: longInteger
    "Private - Process the activate message synchronously."

    (self minimized or: [ graphicsTool isNil ])
    ifFalse: [ self invalidateRect: self titleRectangle ].

    ^super wmActivate: wordInteger with: longInteger!
wmErasebkgnd: wordInteger with: longInteger
    "Private - Process the erase background message."
    | oldDC |
    self minimized ifTrue:[^1].     "Do not erase background while minimized"
    graphicsTool isNil ifTrue:[^nil].
    oldDC := graphicsTool privateHandle.
    graphicsTool handle: wordInteger.
    graphicsTool backColor: self backColor.
    graphicsTool erase.
    self drawTitle.
    self event: #eraseBackground.
    graphicsTool handle: oldDC.
    ^1!  
wmNchittest: wParam with: lParam
    "Private - Process mouse input when the receiver must move or resize..."

    | mouse border winPoint titleRect |
    #addedByOStyle.
    (self minimized or: [ graphicsTool isNil ]) ifTrue: [^nil].
    mouse := ((WinPoint new:4) uLongAtOffset: 0 put: lParam) asPoint
         mapScreenToClient: self.

    titleRect := self titleRectangle.
    (titleRect height > 0 and: [ titleRect containsPoint: mouse])
    ifTrue: [
        ((self hasStyle: WsMaximizebox) and: [ self maximizeRectangle containsPoint: mouse ]) ifTrue: [ ^Htzoom ].
        ((self hasStyle: WsMinimizebox) and: [ self minimizeRectangle containsPoint: mouse ]) ifTrue: [ ^Htreduce ].
        ((self hasStyle: WsSysmenu) and: [ self sysRectangle containsPoint: mouse ]) ifTrue: [ ^Htsysmenu ].
        ^Htcaption
    ].

    border := self nameForBorder: mouse.
    border notNil ifTrue: [ ^border ].

    ^nil!  
wmNcLbuttondown: wParam with: lParam
    "Private - Process mouse button 1 down message in non client area."

    | mouse winPoint titleRect |
    #addedByOStyle.
    (self minimized or: [ graphicsTool isNil ]) ifTrue: [^nil].
    mouse := ((WinPoint new:4) uLongAtOffset: 0 put: lParam) asPoint
         mapScreenToClient: self.

    titleRect := self titleRectangle.
    (titleRect height > 0 and: [ titleRect containsPoint: mouse])
    ifTrue: [
        ((self hasStyle: WsMaximizebox) and: [ self maximizeRectangle containsPoint: mouse ]) ifTrue: [ ^0 ].
        ((self hasStyle: WsMinimizebox) and: [ self minimizeRectangle containsPoint: mouse ]) ifTrue: [ ^0 ].
        ((self hasStyle: WsSysmenu) and: [ self sysRectangle containsPoint: mouse ]) ifTrue: [ ^0 ].
        ^nil
    ].

    ^nil!
wmNcLbuttonup: wParam with: lParam
    "Private - Process mouse button 1 up message in non client area."

    | mouse winPoint titleRect |
    #addedByOStyle.
    (self minimized or: [ graphicsTool isNil ]) ifTrue: [^nil].
    mouse := ((WinPoint new:4) uLongAtOffset: 0 put: lParam) asPoint
         mapScreenToClient: self.

    titleRect := self titleRectangle.
    (titleRect height > 0 and: [ titleRect containsPoint: mouse])
    ifTrue: [
        ((self hasStyle: WsMaximizebox) and: [ self maximizeRectangle containsPoint: mouse ])
        ifTrue: [
            self sendDeferredEvent:
                (self maximized
                    ifTrue: [ #showRestoredWindow ]
                    ifFalse: [ #showMaximizedWindow ]).
            ^0
        ].
        ((self hasStyle: WsMinimizebox) and: [ self minimizeRectangle containsPoint: mouse ])
        ifTrue: [
            self sendDeferredEvent: #showIconicWindow.
            ^0
        ].
        ((self hasStyle: WsSysmenu) and: [ self sysRectangle containsPoint: mouse ])
        ifTrue: [
            self sendDeferredEvent: #openSystemMenu.
            ^0
        ].
        ^nil
    ].

    ^nil! 
wmWindowPosChanged: wParam with: lParam
    "Private - the receiver has been changed of position or size.
     Added by Ale to window motion support.
     Generate a moved event."
    | windowPos |
    windowPos :=
           SelfDefinedStructure
             named: 'WINDOWPOS'
             atAddress: (WinAddress new
                    highHalf: lParam // 65536;
                    lowHalf: lParam \\ 65536;
                    yourself).
     self
        propertyAt: #windowPos
        put: windowPos.

    (self event: #windowPosChanged) notNil
    ifTrue: [ ^0 ].

    ^nil! 
wmWindowPosChanging: wParam with: lParam
    " Private - Attend the windows message wmWindowPosChanging:with:.
    Gets the owner of the receiver an oportunity to control window placement..."
    | windowPos |
    windowPos :=
           SelfDefinedStructure
             named: 'WINDOWPOS'
             atAddress: (WinAddress new
                    highHalf: lParam // 65536;
                    lowHalf: lParam \\ 65536;
                    yourself).
     self
        propertyAt: #windowPos
        put: windowPos.

    (self event: #windowPosChanging) notNil
    ifTrue: [ ^0 ].

    ^nil! !

! WBDialogTopPane methods !
closeView

    super closeView.
    parent isWindow
        ifTrue: [
            parent enable.
            parent makeActive ].
    Processor currentProcessIsRecursive ifTrue: [
        ^self].   "no semaphore wait"
   sem notNil ifTrue: [
        sem signal.
        sem := nil.
        Processor suspendActive.]!  
frameStyleFromPStyle

    "Added by OSI"

    | s pStyle |

    (pStyle := self pStyle) isNil ifTrue: [
        #addedByOSI.
        ^nil
    ].

    s := WsOverlapped | WsClipsiblings | WsDlgframe.

   (pStyle includes: #maximize) ifTrue: [
        s := s | WsMaximizebox.
    ].
    (pStyle includes: #minimize) ifTrue: [
        s := s | WsMinimizebox.
    ].

    (pStyle includes: #sysmenu) ifTrue: [
        s := s | WsSysmenu.
    ].
    (pStyle includes: #titlebar) ifTrue: [
        s := s | WsCaption.
    ].

    ^s!
initSize
        "Private - Answer the initial size of the receiver."
    | size |
    size := self initWindowSize.
    ^(size isRectangle
            ifTrue: [size]
            ifFalse: [
                size isPoint
                    ifTrue: [self boxOfSize: size]
                    ifFalse: [0 @ 0 extent: 100@100]]).!
open
    "Open the dialog box modal to the
     current active window."
    ^ self openModal: nil! 
openModal: aParent
        "Open the dialog box modal to the
         current active window."
    | cursor |
    cursor := Cursor.
    CursorManager execute change.
    aParent isNil ifTrue: [
            parent := WindowHandle queryActive.
            parent := Notifier findWindow: parent]
        ifFalse:[ parent := aParent].
    "Disable parent now to ensure that there are no further
     activities at parent."
    parent notNil ifTrue:[ parent disable].
    super openWindow.
    self event: #opened.
    CursorManager normal change.
    Processor currentProcessIsRecursive ifFalse: [
        self processInput].
    cursor change.!
openWindow
    "Open the dialog box modal to the
     current active window."
    ^ self openModal: nil!   
processInput
        "Private - Make the receiver modal to its owner window.
         This method doesn't return until close has been
         sent to the receiver.  parent should be disabled before
         calling this method."
    sem := Semaphore new.
    [CurrentProcess makeUserIF. Notifier run] fork.
    sem notNil ifTrue: [sem wait].  "diag may be closed before
        getting here"
    CurrentProcess makeUserIF!  
pStyle

    | pStyle |
    pStyle := super pStyle.
    (pStyle includes: #modal) ifFalse: [
        pStyle := (pStyle asSet add: #modal; yourself) asArray.
    ].
    ^pStyle! !

! WBTopPane methods ! 
statusPane

    ^self owner realStatusPane! 
wmMouseactivate: wParam with: lParam
        "Private - If mouse has been clicked on an inactive
         window, select it."
    self mainWindow mdiSelected: true.
    ^MaActivate! !

! DDEAuxClient methods !   
wmDdeAck: wparam with: lparam
        "Private - Pass along a Dde message."
|lParamLo lParamHi command ack busy appReturnCode paramArray|

    dde notNil
        ifTrue: [
           lParamLo := lparam \\ 16r10000.
            lParamHi := lparam // 16r10000.

            dde pendingAck = #WmDdeInitiate
                ifTrue: [
                    dde server: wparam.
                    self ddeAckInitiate: wparam
                       application: (WinHandle atomToString: lParamLo)
                        topic:(WinHandle atomToString: lParamHi).
                    WinHandle deleteAtom: lParamLo.
                    WinHandle deleteAtom: lParamHi. ]

                ifFalse: [
                    ack := (lParamLo bitAnd: 16r8000) = 16r8000.
                    busy := (lParamLo bitAnd: 16r4000) = 16r4000.
                    appReturnCode := lParamLo bitAnd: 16r00FF.
                    answer := ack.
                   dde pendingAck = #WmDdeExecute
                        ifTrue: [

                            "Turned off because when different DDE messages
                              are queued, don't know which message this ack
                              is for. "
                            "
                            lParamHi ~= 0
                                ifTrue: [
                                    command := (String fromAddress: (WinAddress fromString: (KernelLibrary globalLock:lParamHi)))
                                                         trimNullTerminator asNormalizedString.
                                    KernelLibrary globalUnlock: lParamHi.
                                    KernelLibrary globalFree: lParamHi ]
                                ifFalse: [
                                    command := String new ].
                            "
                            "Not sending command string to this method."
                            paramArray := Array new: 5.
                            paramArray at: 1 put: wparam;
                                                at: 2 put: ack;
                                                at: 3 put: busy;
                                                at: 4 put: appReturnCode;
                                                at: 5 put: String new.
                            self sendInputEvent: #ddeAckExecute:ack:busy:appReturnCode:command:
                                        withArgs: paramArray]
                        ifFalse: [
                            dde pendingAck = #WmDdeAdvise
                            ifTrue:[
                                ack
                                ifFalse:[
                                    dde deleteOption ]]
                            ifFalse:[
                                ((dde pendingAck = #WmDdeRequest)
                                    and:[ ack = false])
                                    ifTrue:[answer := nil]].
                            paramArray := Array new: 6.
                            paramArray at: 1 put: wparam;
                                                at: 2 put: dde pendingAck;
                                                at: 3 put: ack;
                                                at: 4 put: busy;
                                                at: 5 put: appReturnCode;
                                                at: 6 put: (WinHandle atomToString:lParamHi).

                            self sendInputEvent: #ddeAck:msg:ack:busy:appReturnCode:item:
                                        withArgs: (paramArray).
                            WinHandle deleteAtom: lParamHi ] ] ].

    dde pendingAck: nil.
    ^nil! 
wmDdeData: wparam with: lparam
        "Private - Pass along a Dde message."
| hData lpData data size item ackReq release requested format value paramArray formattedData|

    hData := 0.
    dde notNil
        ifTrue: [
            hData := lparam \\ 16r10000.
            item := WinHandle atomToString: lparam // 16r10000.

            hData~= 0
                ifTrue: [
                    lpData := WinAddress fromString: (KernelLibrary globalLock: hData).
                    size := WinAddress integerFrom: (KernelLibrary globalSize: hData).
                    data := (WinStructure new: size)
                                        fillFromAddress: lpData.
                    KernelLibrary globalUnlock: hData.
                    ackReq := ((data uShortAtOffset: 0) bitAnd: 16r8000) = 16r8000.
                    release := ((data uShortAtOffset: 0) bitAnd: 16r2000) = 16r2000.
                    requested := ((data uShortAtOffset: 0) bitAnd: 16r1000) = 16r1000.
                    format := data uShortAtOffset: 2.
                    value := data bytesAtOffset: 4 count: size - 4.
                    formattedData = value.
                    format = CfText
                        ifTrue: [
                            formattedData := String new: value size.
                            formattedData replaceFrom: 1 to: value size
                                    with: value startingAt: 1.
                            formattedData := formattedData trimNullTerminator asNormalizedString ].

                    ackReq
                        ifTrue: [
                            dde ackAcceptTo: dde server item: item].


                    release
                        ifTrue: [
                            KernelLibrary globalFree: hData].

                    paramArray := Array new: 4.
                    paramArray at: 1 put: wparam;
                                at: 2 put: format;
                                at: 3 put: formattedData ;
                                at: 4 put: item.

                    requested
                        ifTrue: [
                            self sendInputEvent: #ddeDataRequested:format:data:item:
                                    withArgs: (paramArray) ]
                        ifFalse: [
                            self sendInputEvent: #ddeDataAdvised:format:data:item:
                                    withArgs: (paramArray) ] ]
                ifFalse: [
                   self sendInputEvent: #ddeDataUpdated:item:
                            withArgs: (Array
                            with: wparam
                            with: item) ].
           WinHandle deleteAtom: lparam // 16r10000 ].
    ^nil! !

! DDEAuxServer methods !   
wmDdeExecute: wparam with: lparam
        "Private - Pass along a Dde message."
| hCommand command|

    dde notNil
        ifTrue: [
            hCommand := lparam // 16r10000.

            hCommand ~= 0
                ifTrue: [
                    command := (String fromAddress: ( WinAddress fromString:(KernelLibrary globalLock:hCommand)))
                                     trimNullTerminator asNormalizedString.
                    KernelLibrary globalUnlock: hCommand.

                    self sendInputEvent: #ddeExecute:command:hCommand:
                            withArgs: (Array
                            with: wparam
                            with: command
                            with: hCommand) ] ].

    ^nil!
wmDdePoke: wparam with: lparam
        "Private - Pass along a Dde message."
| hData lpData data size item release format value paramArray formattedData |

    dde notNil
        ifTrue: [
            hData := lparam \\ 16r10000.
            item := WinHandle atomToString: lparam // 16r10000.

            hData~= 0
                ifTrue: [
                    lpData := WinAddress fromString: (KernelLibrary globalLock: hData).
                    size := WinAddress integerFrom: (KernelLibrary globalSize: hData).
                    data := (WinStructure new: size)
                            fillFromAddress: lpData.
                    KernelLibrary globalUnlock: hData.
                    release := ((data uShortAtOffset: 0) bitAnd: 16r2000) = 16r2000.
                    format := data uShortAtOffset: 2.
                    value := data bytesAtOffset: 4 count: size - 4.
                    formattedData = value.
                    format = CfText
                        ifTrue: [
                            formattedData := String new: value size.
                            formattedData replaceFrom: 1 to: value size
                                    with: value startingAt: 1.
                            formattedData := formattedData trimNullTerminator asNormalizedString].

                    paramArray := Array new: 4.
                    paramArray at: 1 put: wparam;
                                        at: 2 put: format;
                                        at: 3 put: formattedData;
                                        at: 4 put: item.
                    self sendInputEvent: #ddePoke:format:data:item:
                    withArgs: (paramArray).

                    WinHandle deleteAtom: lparam // 16r10000.

                    release
                        ifTrue: [ KernelLibrary globalFree: hData.] ] ].
    ^nil! !

! OSDDEAuxServer methods !  
ddeAdviseHotLink:sender ackReq: ackReq format: format item: item hOption: hOption
        "Private - default handling for ddeAdvise"

"  Transcript cr; nextPutAll: 'ddeAdviseHotLink:sender'.      "
    dde ackNotAcceptTo: sender item: item!  
ddeAdviseWarmLink:sender ackReq: ackReq format: format item: item hOption: hOption
        "Private - default handling for ddeAdvise"
    |object|
Transcript cr; nextPutAll: 'ddeAdviseWarmLink:sender'.
    object := dde exportedItemAt: item.

    object isNil
        ifTrue: [
            "Give the receiver object the chance to export the item"
            ((recieverObj respondsTo: #ddeExportItem:)
                and: [recieverObj ddeExportItem: item] )
            ifTrue: [
                object := dde exportedItemAt: item ] ].

    (object notNil and:
        [(DynamicDataExchange getDDEFormat: object class) = format])
        ifTrue: [
            self addWarmLinkedItem: item client: sender format: format ackReq: ackReq.
            dde ackAcceptTo: sender item: item.
            KernelLibrary globalFree: hOption ]
        ifFalse: [
            dde ackNotAcceptTo: sender item: item ]! !

! DialogBox methods !   
queryItemText: itemId
    "Modified by OSI to fix intermittent failures. Thanks to Tom Lipkis"
    "Answer a string containing the text of the
    item whose id is itemId."
    | length answer winAdr |
    #modifiedByOSI.
    handle isValid
        ifFalse:[^ String new].
    winAdr := WinAddress allocateMemory: 256.
    winAdr isNil
        ifTrue: [ ^String new ].
    length := UserLibrary
        getDlgItemTextW: handle
        item: itemId
        text: winAdr asParameter
        maxCount: 256.
    answer := String new: length.
    WinAddress copyFrom: winAdr to: answer count: length. winAdr unlockAndFree.
    ^answer asNormalizedString!   
statusPane
        "Answer the receiver's statusPane if any, else answer nil."
    owner isNil ifTrue:[^nil].
    ^owner statusPane!   
toolPane
        "Answer the receiver's toolPane if any, else answe nil."
    |ownerWindow|
    ownerWindow:=Notifier findWindow:owner asInteger.
    ownerWindow isNil ifTrue:[^nil].
    ^ownerWindow toolPane!
wmHelp: wordInteger with: longInteger
    "Private - Process the Smalltalk help message.
     Patched by ... for proper control Id searching in dialogs..."
    |focusWindow name|
    #modifiedByOStyle.
    focusWindow := longInteger \\ 65536.
    wordInteger = MsgfMenu
        ifTrue:[^super wmHelp: wordInteger with: longInteger].
    wordInteger = MsgfDialogbox ifTrue:[
        name := self itemIds
            at: (UserLibrary getDlgCtrlID: focusWindow asParameter) "Patch"
            ifAbsent: [nil].
        self helpManager displayHelp: name].! !

! FileDialog methods ! 
fileSpec: aFileSpec
    "Sets the initial fileName of the edit control in the File Dialog.
    Patched by Ale for proper parameter setting.
    Touched By Ale..."

    | aFileSpecAddress pFileSpec |
    #modifiedByOStyle.
    pFileSpec := aFileSpec asParameter.
    aFileSpecAddress := WinAddress allocateMemory: 512.
    openFileNameStruct
        lpstrFile: (aFileSpecAddress
            replaceFrom: 1
            to: pFileSpec size
            with: pFileSpec startingAt: 1) asParameter.
    openFileNameStruct
        nMaxFile: aFileSpecAddress
        memorySize.!
initialDir: initialDir
    "Private - Specifies the initial file directory in File dialog."
    "Touched by Ale for proper DirName variable setting..."
    #modifiedByOStyle.
    DirName := initialDir.
    openFileNameStruct
        lpstrInitialDir: (WinAddress
            copyToNonSmalltalkMemory: initialDir asParameter)
                 asParameter! !

! MessageBox class methods !   
messageNote: aString

    "Added by OSI  to avoid the 'Information' title"
    #addedByOSI.
    ^((self
        titled: ''
        withText: aString
        style: MbOk | MbIconinformation) = Idyes)!
okCancel: aString
        "Display a message box with aString as the title and
        'Yes' and 'Cancel' for the choices.  Answer true if the
         selection is Yes, else nil."
    ^((self
        titled: 'Please Confirm'
        withText: aString
        style: MbOkcancel | MbIconquestion) = Idok
        ifTrue: [true] ifFalse: [nil])!
warning: aString
        "Display a message box with aString as the content and
        'OK' for the choices."
    ^((self
        titled: '* Warning *'
        withText: aString
        style: MbOk | "MbIconexclamation" MbIconhand) = Idyes)!  
yesNoCancelTitled: title text: text

    "Added by OSI"

    | r |
    #addedByOSI.
    r := self titled: title withText: text style: MbYesnocancel | MbIconquestion.

    r = 6 ifTrue: [
        ^#yes
    ] ifFalse: [
        r = 7 ifTrue: [
            ^#no
        ] ifFalse: [
            ^nil
        ].
    ].! !

! ModalMessageBox class methods !
titled: aString withText: aString2 style: mbConstants
        "Private - Open a message box with title aString and text aString2
         and style mbConstants (from WinConstants).
         Answer a WinConstant."

    ^super   titled: aString withText: aString2 style: mbConstants | MbSystemmodal!
warning: aString
        "Display a message box with aString as the content and
        'OK' for the choices.
        ModalMessageBox warning: 'Testing...'
    "
    ^((self
        titled: '* Warning *'
        withText: aString
        style: MbOk | MbIconexclamation) = Idyes)! !

! OSDialogBox class methods !   
addItemIds: aCollection to: aDictionary
    "Add aCollection of pairs (itemName itemIds) to aDictionary.
     Returns the dictionary."
    aCollection do: [:each|
        self placeIn: aDictionary name: each first id: each last
    ].
    ^aDictionary!
dllFileName
    "Private - Returns the name for the dll resource file
        as default; aDynamicLinkLibrary is also supported."

    ^ObjectStyleDLL library!   
initItemIds
    "Initialize item IDs for sincronize
     with dialog in dll"
    "
    Example : (ItemIds is a ClassVariable)

    ItemIds := Dictionary new.
    self placeIn: ItemIds name: 'ok' id: 257.

    "
    ^self implementedBySubclass! 
openOn: anObject
    "Open an instance of the receiver
     on anObject"
    ^self new openOn: anObject!   
placeIn: itemIds name: aName id: anInteger
    "Place in the dictionary itemIds
     the new reference named aName
     with id number anInteger"
    itemIds
        at: aName asString put: anInteger;
        at: anInteger put: aName asSymbol! 
tooManyWindows
    "Generates an error because a dialog box
     coudn't be opened"
    ^self error: self name,' not found or too mary windows'! !

! OSDialogBox methods !  
absentControl: aControlName
    "Generates an error because the control
     with aControlName is not found"
    aControlName isInteger "accept as number (ItemId)"
    ifTrue: [^aControlName].
    ^self error: 'Control "', aControlName,'" not found.'!  
basicOpen
    "Private - Open the receiver and perform selection.
     This is the basic mechanism for the receiver
     when building & opening."
    | cursor module |
    cursor := Cursor.
    CursorManager execute change.
    self class initItemIds.

    (module := self class dllFileName) isString
    ifTrue: [self fromDLLFile: module templateName: self dialogName]
    ifFalse: [self fromModule: module id: self dialogName].

    self setUpElements.
    cursor change.
    self showWindow.
    self mustProcessInput ifTrue: [self processInput].
    ^self result! 
comboBox: anId uses: aCollection
    "Notify the receiver that combo box of
     id #anId will use aCollection as labels"
    settings at: anId put: aCollection!  
control: aControlName
    "Returns the id for control named
     aControlName"
    ^self itemIds
        at: aControlName asString
        ifAbsent: [ self absentControl: aControlName ]!   
dialogName
    "Name of the dialog instance"
    ^self implementedBySubclass!   
disableControl: aControlName
    "Disable the control named aControlName"
    ^self disableItem: (self control: aControlName)!  
disableControls: aCollection
    "Disable the controls with names in aColleciton"
    aCollection do: [:each|
        self disableControl: each
    ]!
disableItem: anItem
    "Disable an item"
    UserLibrary
        enableWindow:
          (UserLibrary
              getDlgItem: handle
              item: anItem)
        boolean: false!
drawControl: aStruct
    "Private - Render the control and/or item
     in aStruct (aWinDrawItemStruct)."
    | type aPen |
    type := aStruct ctlType.
    aPen := Pen forDC: aStruct hDC medium: self.
    type == OdtMenu ifTrue: [^self drawOwnedMenu: aStruct with: aPen].
    type == OdtButton ifTrue: [^self drawOwnedButton: aStruct with: aPen].
    type == OdtCombobox ifTrue: [^self drawOwnedComboBox: aStruct with: aPen].
    type == OdtListbox ifTrue: [^self drawOwnedListBox: aStruct with: aPen].! 
drawOwnedButton: aStruct with: aPen
    "Private - Render an owned button
     in aStruct (aWinDrawItemStruct) using aPen."
    ^self implementedBySubclass!   
drawOwnedComboBox: aStruct with: aPen
    "Private - Render an owned combo box
     in aStruct (aWinDrawItemStruct) using aPen."
    ^self implementedBySubclass!  
drawOwnedListBox: aStruct with: aPen
    "Private - Render an owned list box
     in aStruct (aWinDrawItemStruct) using aPen."
    ^self implementedBySubclass!
drawOwnedMenu: aStruct with: aPen
    "Private - Render an owned menu
     in aStruct (aWinDrawItemStruct) using aPen."
    ^self implementedBySubclass!   
enableControl: aControlName
    "Enable the control named aControlName"
    ^self enableItem: (self control: aControlName)! 
enableControls: aCollection
    "Enable the controls with names in aColleciton"
    aCollection do: [:each|
        self enableControl: each
    ]!   
enableItem: anItem
    "Enable an item"
    UserLibrary
        enableWindow:
          (UserLibrary
              getDlgItem: handle
              item: anItem)
        boolean: true!   
focusOnControl: aControlName
    "Enable Focus on the control named aControlName"
    UserLibrary
            postMessage: handle
            msg: WmNextdlgctl
            wparam: (
              UserLibrary
                getDlgItem: handle
                item: (self control: aControlName) )
            lparam: 1.!  
fromDLLFile: aFileName templateName: aTemplateName
    "Open the dialog box whose template name is
     contained in the file identified by aFileName.
     templateName may be a String or an Integer that
     identifies the dialog template."

      (hLibrary :=
            KernelLibrary loadLibrary: aFileName asAsciiZ) >= 32
       ifTrue: [
                self fromModule: hLibrary id: aTemplateName ]
       ifFalse: [
          self error: 'DLL not found : ' , aFileName printString].!
getItems
    "Private - Used for #ok
     The receiver must validate the items settings
     and setUp values in the receiver.
     If an item is invalid 'nil' must be returned"
    ^self implementedBySubclass!   
hasBeenClosed
    "True if the receiver has been closed"
    ^hLibrary isNil!   
helpRequest
    "Private - Help has been requested"
    ^true!  
hideControl: aControlName
        "Hide the item whose name is aControlName."
       ^self hideItem: (self control: aControlName)!  
hideControls: aCollection
        "Hide the item whose name is aControlName."
       aCollection do: [:each|
            self hideControl: each
        ]!
initialize
    "Initializes the receiver"
    super initialize.
    settings := IdentityDictionary new.!   
integerFromControl: anId
    "Returns the integer in anId text
     or nil if error"
     | number stream |
    number :=  (self queryItemText: anId) trimBlanks.
    number isEmpty ifTrue: [^nil].
    ^number asInteger.!
itemIds
        "Private - Answer the item ids dictionary."
    Terminal bell.
    MessageBox message: '*Warning* ItemsIds not implemented'.
     ^super itemIds! 
listBox: anId uses: aCollection
    "Notify the receiver that combo box of
     id #anId will use aCollection as labels"
    settings at: anId put: aCollection!   
mainView
    "Returns the main view of the receiver"
    ^self mainWindow!  
mustProcessInput
    "Private - This method is used for solving
      if the receiver is modal or not.
     This method could be refined in subclasses.
     Reference: self #basicOpen"
    ^true!  
ok
    "SetUp the values in the receiver.
     And close it if the items are all right"
    self getItems notNil
    ifTrue: [ self close ]!  
open
    "Open the receiver and perform selection"
    ^self basicOpen! 
openWithoutParent
    "Open the receiver (as #basicOpen)
     but don't invalidate the parent window.
     Usefull for #open overWriting."
    ^(InvisibleWindow new)
        do: [self basicOpen];
        open!   
queryIndexText: index inListBox: itemId
    "Returns the text in listBox at an index"
    | size message result |
    message := WinStructure new: 32.
    handle isValid
    ifFalse: [^message].
    size := WinAddress loWordFrom:
            (UserLibrary
                sendDlgItemMessage: handle
                item: itemId
                msg: LbGettext
                wparam: index
                lparamStruct: message asParameter).
    result := String new: size.
    result replaceFrom: 1 to: size
       with: (message contents
                 copyFrom: 1 to: size).
    ^result!   
result
    "Result of opening the receiver"
    "Default value is self.
     This method could be refined by subclasses"!  
scroll: anId
    mode: aMode
    position: anInteger
    "The scroll bar anId has been pressed
     The default action is to find the action
     in setting and performIt"
    | actions aBlock |
    "find actions for the scrollBar"
    actions := settings at: anId ifAbsent: [^nil].
    "find aBlock of code to perform"
    aBlock := actions at: aMode ifAbsent: [^nil].
    "perform the action for the scrolling event"
    ^aBlock value: anInteger!  
scroll: itemId position: anInteger redraw: aBoolean
    "SetUp the position for anId scrollBar"

    UserLibrary
        setScrollPos: (UserLibrary
              getDlgItem: handle
              item: itemId)
        bar: SbCtl
        position: anInteger
        redraw: aBoolean!
scroll: itemId
    variesBetween: minInteger
    and: maxInteger
    redraw: aBoolean
    "SetUp the range for anId scrollBar"

    UserLibrary
        setScrollRange:  (UserLibrary
              getDlgItem: handle
              item: itemId)
        bar: SbCtl
        min: minInteger
        max: maxInteger
        redraw: aBoolean!  
scrollEndScroll
    "Returns the number associated
     to event for scrolling to endScroll"
    ^SbEndscroll! 
scrollLineDown
    "Returns the number associated
     to event for scrolling to lineDown"
    ^SbLinedown!
scrollLineUp
    "Returns the number associated
     to event for scrolling to lineUp"
    ^SbLineup!  
scrollPageDown
    "Returns the number associated
     to event for scrolling to pageDown"
    ^SbPagedown!
scrollPageUp
    "Returns the number associated
     to event for scrolling to pageUp"
    ^SbPageup!  
scrollThumbPosition
    "Returns the number associated
     to event for scrolling to thumbPosition"
    ^SbThumbposition! 
scrollThumbTrack
    "Returns the number associated
     to event for scrolling to thumbTrack"
    ^SbThumbtrack!  
scrollToBottom
    "Returns the number associated
     to event for scrolling to bottom"
    ^SbBottom!
scrollToTop
    "Returns the number associated
     to event for scrolling to top"
    ^SbTop! 
selectComboBox: anId with: anItem
    "Select the combo box anId with anItem"
    self
        select: (
            (settings at: anId ifAbsent: [^nil])
            indexOf: anItem ifAbsent: [1]
            ) - 1
        inComboBox: anId!
selectionInCombo: anId
    "Returns the selection in combo box anId.
     Or nil if no matching"
    | index labels |
    labels := (settings at: anId ifAbsent: [^nil]) asArray.
    index := 1 + (self querySelectionInComboBox: anId).
    ^(index between: 1 and: labels size)
    ifTrue: [labels at: index]
    ifFalse: [nil]! 
selectionInListBox: anId
    "Returns the selection in list box anId.
     Or nil if no matching"
    | index labels |
    labels := (settings at: anId ifAbsent: [^nil]) asArray.
    index := 1 + (self querySelectionInListBox: anId).
    ^(index between: 1 and: labels size)
    ifTrue: [labels at: index]
    ifFalse: [nil]! 
selectListBox: anId with: anItem
    "Select the list box anId with anItem"
    self
        select: (
            (settings at: anId ifAbsent: [^nil])
            indexOf: anItem ifAbsent: [1]
            ) - 1
        inListBox: anId!   
setUpComboBox: anId
    "SetUp the combo box anId with items
     extracted from settings (see #comboBox:uses:)"
    self deleteAllItemsInComboBox: anId.
    (settings at: anId ifAbsent: [^nil]) asArray
    do: [:each|
        each isString
        ifTrue: [self add: each toComboBox: anId]
        ifFalse: [self add: each printString toComboBox: anId]
    ].!
setUpElements
    "The receiver must fillIn the blanks
     inside it's controls"
    ^self implementedBySubclass! 
setUpListBox: anId
    "SetUp the list box anId with items
     extracted from settings (see #listBox:uses:)"
    self deleteAllItemsInListBox: anId.
    (settings at: anId ifAbsent: [^nil]) asArray
    do: [:each|
        each isString
        ifTrue: [self add: each toListBox: anId]
        ifFalse: [self add: each printString toListBox: anId]
    ].!  
setUpScroll: itemId between: min and: max to: position
    "SetUp the position for anId scrollBar and its range"
    | item |
    item := itemId isInteger
        ifTrue: [itemId] ifFalse: [self control: itemId].

    self
        scroll: item variesBetween: min and: max redraw: false;
        scroll: item position: position redraw: true!  
updateScroll: name with: number
    "Update the scrollnamed name to number"
    self
        scroll: (self control: name)
        position: number
        redraw: true! 
whenScroll: anId
    mode: aMode
    do: aBlock
    "SetUp the action block to be valued
     when pressing anId scrollBar in mode
     aMode.
     aBlock must be aBlock of code
     with one parameter. The parameter
     will be a position parameter.
     If aBlock isNil then the action will be removed"
    | actions |
    actions := settings at: anId ifAbsent: [Dictionary new].
    aBlock isNil
    ifFalse: [actions at: aMode put: aBlock]
    ifTrue: [actions removeKey: aMode ifAbsent: []].
    settings at: anId put: actions!  
wmDrawitem: wparam with: lparam
        "Private - Render the requested control and/or item."
    | aStruct |
    aStruct := WinDrawItemStruct fromAddress: (
        ( WinAddress new )
            highHalf: ( lparam // 65536 );
            lowHalf: ( lparam \\ 65536 );
            yourself ).
    ^self drawControl: aStruct! 
wmHScroll: wordInteger with: longInteger
    "Private - anHorizontalScrollbar has been pressed
     in the receiver.
     Same action as vertical scroll pressing."
    ^self wmVScroll: wordInteger with: longInteger!   
wmVScroll: wordInteger with: longInteger
    "Private - aVerticalScrollbar has been pressed
     in the receiver.
     If the source of the message is a scroll control,
     then raise a control event."
    | srcHandle srcId |
    "longInteger highHalf is control window handle if from control"
    srcHandle := longInteger // 65536.
    srcHandle = 0
        ifFalse: [
            "find the control"
            srcId := UserLibrary
                getWindowWord: srcHandle
                index: GwwId.
            self itemIds at: srcId ifAbsent: [^nil].
            self
                scroll: srcId
                mode: wordInteger
                position: longInteger \\ 65536
        ].
    ^nil! !

! AboutApp class methods !   
destroyPool
    "Private - Destroy the Pool dictionary...
    AboutApp destroyPool
    "
    | pool |
    self savePool.
    pool := Smalltalk at: #AboutAppConstants ifAbsent: [^self].
    pool associationsDo: [:asoc| asoc key: nil ].
    Smalltalk removeKey: #AboutAppConstants!   
initItemIds
    "Initialize item IDs for sincronize
     with dialog in dll"

    ItemIds := self
            addItemIds: #(
                    (ok 101) (foto 103)
                    (recycle 4) (object 6) (phone 7) (mansilla 8)
                )
            to: Dictionary new.!
loadPool
    "Private - Load the Pool dictionary from the pool file...
    AboutApp loadPool
    "

    Smalltalk
        at: #AboutAppConstants
        put: (Loader new loadFrom: 'AboutApp.Pol')!   
savePool
    "Private - Save the Pool dictionary in a file...
    AboutApp savePool
    "

    Loader new
        unload: (Smalltalk at: #AboutAppConstants)
        on: 'AboutApp.Pol'.! !

! AboutApp methods !
dialogName
    "Name of the dialog instance"
    ^'About'!  
drawOwnedButton: aStruct with: aPen
    "Private - Render an owned button
     in aStruct (aWinDrawItemStruct) using aPen."
    | id box |
    id := aStruct ctlId.
    id = (self control: #foto) ifFalse: [^nil].
    box := aStruct boundingBox.
    Foto
        displayAt: box extent - Foto extent // 2
        with: aPen!
foto
    "Private - Responds to foto events"!
getItems
    "Private - Used for #ok
     The receiver must validate the items settings
     and setUp values in the receiver.
     If an item is invalid 'nil' must be returned"!
itemIds
    "Return the itemIds"
    ^ItemIds!  
setUpElements
    "The receiver must fillIn the blanks
     inside it's controls"

    | extent exit text |

    "actually redraw the foto..."
    self
        disableControl: #foto;
        enableControl: #foto.

    "and check dialog concistency..."
    exit := [ :why |
        MessageBox
            warning: ('Bad Program Copywrite Information\\Call for Object ','St','yle'
                ,' repair services.\',Mansilla,'\',Telefono,' \\Now Program will exit'
                "\Failed in ',why") withCrs.
        Smalltalk isRunTime and: [Smalltalk exit]
    ].

    (Foto isNil or: [
        extent := Foto extent.
        (extent x = 319 and: [extent y = 193]) not
    ]) ifTrue: [exit value: 'Foto'].

    text := self queryItemText: (self control: #object).
    (text asStream nextWord;nextWord) = ('Sty','le')
    ifFalse: [exit value: 'Object'].

    text := self queryItemText: (self control: #mansilla).
    text asStream nextWord = Mansilla asStream nextWord
    ifFalse: [exit value: 'Direccin'].

    text := self queryItemText: (self control: #phone).
    (text asStream upTo: $-;upTo: $-;upTo: $-)  = (Telefono asStream upTo: $-;upTo: $-;upTo: $-)
    ifFalse: [exit value: (text asStream upTo: $-;upTo: $-;upTo: $-)].
    (text asStream upTo: $-;upTo: $-;upTo: $-) = '833' ifFalse: [exit value: 'Dialog Phone'].! !

! RunProgramDialog class methods ! 
initItemIds
    "Initialize item IDs for sincronize
     with dialog in dll"

    ItemIds := self
            addItemIds: #(
                    (ok 1) (cancel 2)
                    (browse 112) (minimized 105)
                    (command 99) (line 119)
                )
            to: Dictionary new.! !

! RunProgramDialog methods !
browse
    "Private - Let the user select a program"
    | dialog file |
    dialog := FileDialog new
            openTitle: 'Seleccione el programa a ejecutar...'
            fileSpec: '*.Exe'
            showFileInButton: false.
    file := dialog file.
    file isNil ifTrue: [^self].
    self
        setItemText: (self control: #line)
        string: (line := file);
        enableControl: #ok;
        focusOnControl: #line!   
dialogName
    "Name of the dialog instance"
    ^'RunProgram'! 
getItems
    "Private - Used for #ok
     The receiver must validate the items settings
     and setUp values in the receiver.
     If an item is invalid 'nil' must be returned"
     | mode commandLine |
    mode :=
        (self queryButton: (self control: #minimized))
            ifTrue: [SwMinimize]
            ifFalse: [SwShownormal].
    commandLine := self queryItemText: (self control: #line).

    [ ProgramManager new run: commandLine mode: mode ] forkAt: 3.

    self saveProgramName: commandLine!   
initialize
    super initialize.
    line := String new.!   
itemIds
    "Return the itemIds"
    ^ItemIds!  
lastUsedPrograms
    "Private - Returns aCollection of last used programs names"
    | profiler result count name |
    profiler := WinProfiler new.
    profiler applicationName: self profileTitle.
    result := OrderedCollection new.
    count := 0.
    [
        count := count + 1.
        name := profiler at: count printString.
        name size = 0
        ifTrue: [name := '']
        ifFalse: [result add: name].
        name isEmpty ] whileFalse: [].
    ^result!
lastUsedPrograms: aCollection
    "Private - Save aCollection as last used programs names"
    | profiler maxLines |
    maxLines := 10.
    profiler := WinProfiler new.
    profiler applicationName: self profileTitle.
    1 to: (maxLines min: aCollection size) do: [:i|
        profiler
            at: i printString
            put: (aCollection at: i)
    ]!   
line
    "Private - Command line is updated"
    | newCommand |
    newCommand := self queryItemText: (self control: #line).
    newCommand size = 0
    ifTrue: [^self disableControl: #ok].
    line size = 0
    ifTrue: [
        self enableControl: #ok
    ].
    line := newCommand!
minimized
    "Private - Ignore minimize button switch"! 
openOn: commandLine
    "Open the receiver for running commandLine"
    line := commandLine.
    ^self open!   
profileTitle
    "Private - Name used for saving las used program names"
    ^'Last Selected Programs to Run'!  
saveProgramName: aString
    "Private - Save aString a las used program name"
    | list |
    list := self lastUsedPrograms.
    [(list remove: aString ifAbsent: []) isNil] whileFalse: [].
    list addFirst: aString.
    self lastUsedPrograms: list!  
setUpElements
    "The receiver must fillIn the blanks
     inside it's controls"
    | list |
    list := self lastUsedPrograms.
    (line isEmpty and: [list notEmpty])
    ifTrue: [line := list first].

    self
        comboBox: (self control: #line)
         uses: list;
         setUpComboBox: (self control: #line);
         setItemText: (self control: #line)
         string: line.

    line isEmpty ifTrue: [self disableControl: #ok].
    self focusOnControl: #line!
showError: anInteger
    "Private - An erro loading program has occurred.
     Notify the user about this"
    | errors label |
    errors := #(
        (0  'Memoria insuficiente')
        (2  'Archivo no encontrado')
        (3  'Archivo no encontrado')
        (5  'Atentado de linkeo dinamico a un programa')
        (6  'La libreria requiere distintos segmentos para ejecutarse')
        (10 'Versin incorrecta de sistema operativo')
        (11 'Archivo ejecutable de formato invlido.')
        (12 'Aplicacin de Sistema Operativo OS/2')
        (13 'Aplicacin de Sistema Operativo DOS 4.0')
        (14 'Formato de ejecutable desconocido')
        (15 'El programa no fu diseado para trabajar en modo protegido.')
        (16 'El programa no puede cargarse ms de una vez.')
        (17 'El programa no puede cargarse ms de una vez.')
        (18 'Aplicacin no preparada para correr en modo protegido')
    ).

    errors do: [:each|
        each first = anInteger
        ifTrue: [label := each last]
    ].
    label isNil ifTrue: [label := 'Error de ejecucin desconocido : ', anInteger printString].

    UserLibrary messageBeep: 0.
    MessageBox warning: label! !

! HelpWindow methods ! 
checkPathName
    "Private - Generates an error is no pathName provided"
    pathName isNil ifFalse: [^self].
    (FileHandle isThere: pathName) ifTrue: [^self].
    self error: ' Help file not available...'!  
close
    "Private - Close the receiver"
    pathName := nil.
    UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpQuit
        data: nil.
    ^super close!   
helpBasics
    "Activates help Basic Skills on 'Basics' topic"
    self checkPathName.
    (UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpKey
        data: 'Basics' asParameter
    ) ifFalse: [self helpFailed: 'Basics']!
helpCommands
    "Activates helpCommands"
    self checkPathName.
    (UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpKey
        data: 'commands' asParameter
    ) ifFalse: [self helpFailed: 'commands']! 
helpContext: anInteger
    "Activates help on a context indexed by anInteger"
    self checkPathName.
    (UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpContext
        data: anInteger
    ) ifFalse: [self helpFailed: anInteger]!   
helpFailed: contextId
    "Private - A help Request has failed. Notify the application
     if it respondsTo: #helpFailed: "
    (StartUpApplication respondsTo: #helpFailed:)
    ifTrue: [StartUpApplication helpFailed: contextId]
    ifFalse: [^self error: 'Help error on file ',pathName ]!   
helpGlossary
    "Activates help Basic Skills on 'Glossary' topic"
    self checkPathName.
    (UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpKey
        data: 'Glossary' asParameter
    ) ifFalse: [self helpFailed: 'Glossary']!
helpIndex
    "Activates index help"
    self checkPathName.
    (UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpIndex
        data: nil
    ) ifFalse: [self helpFailed: 'HelpIndex']!  
helpKey: aKey
    "Activates help on a keys specific item"
    self checkPathName.
    (UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpKey
        data: aKey asParameter
    ) ifFalse: [self helpFailed: aKey]!
helpKeyboard
    "Activates helpKeyboard"
    self checkPathName.
    (UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpKey
        data: 'keys' asParameter
    ) ifFalse: [self helpFailed: 'keys']! 
helpOnHelp
    "Activates helpOnHelp"
    self checkPathName.
    (UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpHelponhelp
        data: nil
    ) ifFalse: [self helpFailed: 'HelpOnHelp']!   
helpOnKey: aKey
    "Activates help on a keys specific item"
    self checkPathName.
    (UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpKey
        data: aKey asParameter
    ) ifFalse: [self helpFailed: aKey]!  
helpProcedures
    "Activates helpProcedures"
    self checkPathName.
    (UserLibrary
        winHelp: handle
        helpFile: pathName asParameter
        command: HelpKey
        data: 'procedures' asParameter
    ) ifFalse: [self helpFailed: 'procedures']! 
initialize
    "Private - Initialize the receiver"
    pathName := 'OStyle.Hlp'.!   
isApplicationWindow
    "Private - Answer true if receiver is an instance of class
     ApplicationWindow, else answer false.
     The receiver must be seen as an application window"
    ^true! 
open
    "Private - Open an invisible Window.
     Used for opening Help files"

    self create: 'VWIN'
         title: 'HelpWindow'
         style: WsPopup
         rectangle: (0 @ 0 extent: 0 @ 0)
         parent: self parent.
    Notifier add: self!
pathName
    "Returns the instance var of the receiver
     for external manipulation"
    ^pathName!  
pathName: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    pathName := anObject! 
validate
        "Private - Build, but don't show the window."

    self buildWindow isNil ifTrue: [^nil].! !

! InvisibleWindow methods !   
close
    "Private - Close the receiver"
    toDo := nil.
    ^super close!
do: aBlock
    "SetUp the toDo block with aBlock.
        aBlock could be :
                aBlock with no parameters
                aMessage to be performed
    "
    toDo := aBlock!
doIt
    "Private - Perofrm the toDo action and close."
    self makeActive.
    toDo isNil ifTrue: []
    ifFalse: [
        toDo isContext
        ifTrue: [ toDo value ]
        ifFalse: [
            "message assumed"
            toDo perform
        ]
    ].
    self sendDeferredEvent: #close!
helpManager
        "Private - Answer the HelpManager for the receiver."
    ^self propertyAt: #helpManager!
isApplicationWindow
    "Private - Answer true if receiver is an instance of class
     ApplicationWindow, else answer false.
     The receiver must be seen as an application window"
    ^true! 
open
    "Private - Open an invisible Window.
     Used for opening non dependent dialogs"

    self create: 'VWIN'
         title: 'InvisibleWindow'
         style: WsPopup
         rectangle: (0 @ 0 extent: 0 @ 0)
         parent: self parent.
    Notifier add: self.
    self sendDeferredEvent: #doIt.!   
validate
        "Private - Build, but don't show the window."

    self buildWindow isNil ifTrue: [^nil].! !

! MenuWindow methods !
addMDIMenu: aMenu
        "Private - Add aMenu to the receiver. The owner is an MDIChild."

    |tempMenu h old|
    handle = NullHandle ifFalse:[
        old :=  Process enableInterrupts: false].
    menus notEmpty
        ifTrue:[
            tempMenu:=self owner mdiMenuWindow menus.
            menus removeAll: tempMenu.
            menus add: aMenu;
            addAll: tempMenu]
        ifFalse:[menus add: aMenu].
    handle = NullHandle ifFalse:[
            h:=self handle.
            self buildPopupWindow isNil ifTrue:[^self].
            self owner setDocumentMenu.
            UserLibrary destroyMenu: h.
            Process enableInterrupts: old].!
asWBPMenu

    "Added by OSI"

    | mw |
    #addedByOSI.
    mw :=  WBPMenu new.
    menus do: [ :m |
        mw addChild: m asPMenuItem.
    ].

    mw updateListStrings.

    ^mw!  
asWBPMenuBar

    "Added by OSI"

    | mw |
    #addedByOSI.
    mw := WBPMenubar new.
    menus do: [ :m |
        mw addChild: m asPMenuItem.
    ].

    mw updateListStrings.
    ^mw!   
destroyMDIMenu: aMenu
        "Private - Destroy an MDI menu from the receiver."
    |h old|
    (menus includes: aMenu) ifFalse:[^self].
    handle = NullHandle ifFalse:[
        old :=  Process enableInterrupts: false].
    menus remove: aMenu ifAbsent: [^self].
    handle = NullHandle ifTrue: [^self].
    h:=self handle.
    self buildPopupWindow isNil ifTrue:[^self].
    self owner setDocumentMenu.
    UserLibrary destroyMenu:h.
    Process enableInterrupts: old.!  
performMenuItem: anInteger

    "Altered by OSI to handle menus with no items"

        "Private - Perform the menu item whose id is anInteger."
    | menu selector |
    #modifiedByOSI.
    (anInteger // 256) > allMenus size ifTrue:[^self].   "MDI min/max button"
    (anInteger // 256) < 1 ifTrue:[^self].   "MDI Windows menu"
    menu := allMenus at: (anInteger // 256).
    menu owner initMenu.
    (menu isDisabled: anInteger \\ 256) ifFalse:[
        menu numberOfItems < 1 ifTrue: [ ^self ].
        selector := menu selectorOf: anInteger \\ 256.
        "OSI - removed #isKindOf: method reference"
        (selector isMessage)
            ifTrue: [^selector perform].
        menu selector isNil
            ifTrue: [
                selector isNil
                    ifFalse: [^menu owner perform: selector]]
            ifFalse: [
                ^menu owner perform: (menu selector) with: selector]]!
wbMenuTitled: aString

    "Added by OSI - Search through all menus, including
      submenus, for the menu described below."

        "Answer the menu whose title is aString. Case is ignored
         and aString can include $&, $~, or neither."
    | plainString |
    #addedByOSI.
    plainString := aString reject: [:c | c = $& | (c = $~)].
    allMenus do: [:m |
        ((m title reject: [:c| c = $& | (c = $~)])
            equalsIgnoreCase: plainString)
             ifTrue: [^m]].
    ^nil! !

! TimerWindow class methods !   
aboutToSaveImage
    Timer notNil
        ifTrue: [
            Timer aboutToSaveImage.
            Timer close.
            Timer := nil ].!
activeTimers
        " Answer all the currently running timers "
    ^Timer isNil
        ifTrue: [ #() ]
        ifFalse: [ Timer activeTimers ]!
isTimerRunning: aTimer
        " Answer whether aTimer is currently running. "
    ^Timer notNil
        and: [ Timer isRunning: aTimer ]! 
startTimer: aTimer interval: anInteger
        " Start aTimer with the specified interval (msec).
        Answer the timer's id. "
    | id |

    ( Timer isNil
    or: [ Timer isValid not ] )
        ifTrue: [ Timer := self new open ].

    id := Timer getId: aTimer.
    Time
        startTimer: id
        period: anInteger
        forWindow: Timer.
    ^id!   
stopAllTimers
        " Stop all active timers "
    Timer notNil
        ifTrue: [ Timer stopAllTimers ].!
stopTimer: aTimer
        " Stop the specified timer. "
    | id |
    ( Timer notNil
    and: [ Timer isValid ] )
        ifTrue: [
            id := Timer getId: aTimer.
            Time
                stopTimer: id
                forWindow: Timer.
            Timer removeId: id ].! !

! TimerWindow methods !
aboutToSaveImage
        " Private - stop timers when image is saved. "
    items size > 0
        ifTrue: [
            self stopAllTimers.
            MessageBox warning: 'All PARTS timers have been stopped.' ].!   
activeTimers
        " Answer all the currently running timers "
    ^items values! 
close
        "Private - Close the Timer aux window"
    self isHandleOk ifTrue: [
        self stopReceivingMessages.
        self destroy.
        self initialize ]!  
createWindow
        " Private "
        " Platform dependent implementation "
    "Touched By Ale for porting to V20"

    #modifiedByOStyle.
    "self platformDependent."

    "VOS implementation:
    ^self create: HwndDesktop
         title: self label
         frameStyle: 0
         frameCreateFlags: 0
         clientStyle: 0
    "
    " VW implementation "
    ^self create: self winClass
         title: self label
         style: WsPopup
         rectangle: ( 0 @ 0 extent: 0 @ 0 )
         parent: self parent!  
getId: timer
        "Answer the id of the timer if one exist else
         create a new one."
    | id |
    id := items keyAtValue: timer ifAbsent: [nil].
    id isNil
        ifTrue: [  " allocate id for new timer "
            1 to: items size + 1 do: [ :i |
                items at: i ifAbsent: [ id := i ] ].
            items at: id put: timer.
            ].
    ^id!   
initialize
        " Private - initialize a new instance. "
    super initialize.
    items := IdentityDictionary new.!
isRunning: aTimerPart
        "Answer whether aTimerPart is currently running."
    items keyAtValue: aTimerPart ifAbsent: [^false].
    ^true!
isValid
    "Implemented by Ale for porting to V20"
    #addedByOStyle.
    ^self isHandleOk!  
label
        " Private "
    ^'TimerWindow'!   
open
        "Private - Open Timer aux window. "
    | anAnswer |
    anAnswer := self createWindow.
    anAnswer notNil
        ifTrue: [ Notifier add: self ].
    ^anAnswer! 
removeId: timerId
        "Remove timerId and its associated timer part from items."
    items removeKey: timerId ifAbsent: []! 
stopAllTimers
        " Stop all currently running timers. "
    items do: [:each | each stopTimer]!
tickDelayed: aPart
        " Private - notify aPart that its tick has occured. "
    aPart tick.!   
timerEvent: anInteger
        "Private - The timer identified by anInteger has gone off.
         Send a notification message to the timer part
        associated with the identifier anInteger."
    (items at: anInteger ifAbsent: [^self]) tick!  
validate
        "Private - Build, but don't show the window."
    self buildWindow isNil ifTrue: [^nil].!  
wmTimer: mp1 with: mp2
        "Private - The timer identified by mp1 has gone off.
         Send a notification message to the timer widget
         associated with the identifier mp1."
    self sendInputEvent: #tickDelayed:
        with: (items at: mp1 asInteger ifAbsent: [^nil]).
    ^nil! !

! SubPane class methods !
supportedEvents
    "Private - Answer the Set of events that SubPanes can notify
     their owners about.
    Touched by LRP for FileManager drag&drop support"
    #modifiedByOStyle.
    ^Set new
        add: #resize;
        add: #display;
        add: #getMenu;
        add: #getContents;
        add: #getPopupMenu;
        add: #gettingFocus;
        add: #losingFocus;
        add: #dragFiles; "FileManager's drag&drop"
        add: #help;
        yourself! !

! SubPane methods !
aboutToSaveImage

    "Modified by OSI to support setting menus in line"

        "Private - Pass this event on to the receiver's children."
    #modifiedByOSI.
    popup notNil ifTrue: [
        popup clearPopup.
    ].
    children size ~= 0
        ifTrue: [
            children do: [:each |
                each aboutToSaveImage]]!  
accel: aChar  afBits: theAfBits
    "Added by OSI - Intercepts the Tab key within CompositePanes"
    self parent isCompositePane ifTrue: [
        aChar = 9 "Tab" ifTrue: [
            theAfBits = 4 "AfShift" ifTrue: [
                (self parent getPreviousFocus: self) ifTrue: [^true ]
            ] ifFalse: [
                (self parent getNextFocus: self) ifTrue: [^true ]
            ].
        ].
        self isGroupable ifTrue: [
            (aChar = 40 "DownKey" or: [aChar = 39 "RightKey"]) ifTrue: [
                self parent getNextFocusInGroup: self. ^true
            ].
            (aChar = 38 "UpKey" or: [aChar = 37 "LeftKey"]) ifTrue: [
                self parent getPreviousFocusInGroup: self. ^true
            ].
        ].
        #addedByOSI.
    ].
    ^super accel: aChar  afBits: theAfBits!   
addStyle: i

    "Added by OSI"

    #addedByOSI.
    ^style := i | (style notNil ifTrue: [ style ]
        ifFalse: [ self defaultStyle ])!
buildWindow: parentWindow
    "Private - Create the window for the receiver
     using parentWindow as the parent.
     LRP patched check if create:title:.. returns nil"
    | ps answer |
    #modifiedByOStyle.
    style isNil ifTrue: [style := self frameStyle].
    answer := self create: self winClass
        title: self initialText
        style:  style
        rectangle: (0@0 extent: 0@0)
        parent: self parent.
    answer isNil ifTrue: [^nil].

    curFont isNil ifTrue: [curFont := self defaultFont].
    self initGraphics.
    self receiveMessages.
    children size ~= 0
        ifTrue: [
            children do: [:each |
                (each buildWindow: self) isNil ifTrue:[self close.^nil]]]! 
framingBlock: aBlock
        "Initialize the framingBlock to the one
         argument block aBlock which, when executed,
         yields the pane frame rectangle."

    framingBlock := aBlock!
framingRatio: aRectangle
        "Initialize the framingBlock to a one argument
         block which, when executed, yields the pane
         frame rectangle proportional with the ratios
         specified by aRectangle."

    framingBlock := [:box |
        box scaleTo: aRectangle].!  
getPopupMenu

    "Added by OSI"
    #addedByOSI.
    ^popup! 
handlers

    "Added by OSI"
    #addedByOSI.
    ^handlers!  
handlers: dict

    "Added by OSI"
    #addedByOSI.
    handlers := dict! 
isButton
    "Added by OSI"
    #addedByOSI.
    ^false!   
isGroupable
    "Added by OSI"
    #addedByOSI.
    ^false!
isSubPane

    "Added by OSI"
    #addedByOSI.
    ^true! 
isWsGroup

    "Added by OSI"
    #addedByOSI.
    ^self style notNil and: [ self style bitIsOn: WsGroup ].!  
isWsTabstop

    "Added by OSI"
    #addedByOSI.
    ^self style notNil and: [ self style bitIsOn: WsTabstop ].!  
realHandlers

    "Added by OSI"
    #addedByOSI.
    ^handlers!  
setDeferredFocus
    "Private - Set focus of the receiver in deferred mode.
    Implemented by LRP..."
    #addedByOStyle.

      DeferredRequests add: (Message new
        receiver: self
        selector: #setFocus
        arguments: Array new ).
      DeferredRequests add: (Message new
        receiver: self
        selector: #selectAll
        arguments: Array new ).
    KeyboardSemaphore signal.!  
show
    "Private - Toggle visible state of the receiver."

    self visible
        ifTrue:[self visible:false]
        ifFalse:[self visible:true].
    self mainWindow resize:self mainWindow rectangle repaint:true.!   
startGroup

    "Added by OSI"
    #addedByOSI.
    self addStyle: WsGroup!   
tabStop

    "Added by OSI"
    #addedByOSI.
    self addStyle: WsTabstop!
visible
        "Private - Answer true if the receiver is logically visible."
    | z |
    (z := self propertyAt: #visible) isNil ifTrue:[^true].
    ^z!
visible: aBoolean
        "Private - Set the visible state of the reciever
         to aBoolean."
    self propertyAt: #visible put: aBoolean.
    aBoolean ifTrue:[
        self showWindow]
    ifFalse:[
        self hideWindow].! 
wmKillfocus: wordInteger with: longInteger
    "Modified by OSI to correct the spelling of #losingFocus"
        "Private - Process the kill focus message."
    #modifiedByOSI.
    super wmKillfocus: wordInteger with: longInteger.
    self event: #losingFocus.
    ^nil!  
wmSetfocus: wordInteger with: longInteger
        "Private - Process the set focus message."

    "Added by OSI"
    #addedByOSI.
    self mainWindow propertyAt: #focusWindow put: self.
    self parent isCompositePane ifTrue: [ self parent setFocus: self ].
    super wmSetfocus: wordInteger with: longInteger.
    self event: #gettingFocus.
    ^nil! !

! ControlPane methods ! 
basicStyle

    "Altered by OSI, to allow external tabstop setting."

        "Private - Answer an Integer with appropriate
         constants combination for basic control style."
    #modifiedByOSI.
    ^WsChild   |
    WsVisible!  
contents: aString

    "Altered by OSI to allow ~ mnemonics from PM"

        "Set the String associated with this control."

    #modifiedByOSI.
    (aString isString) ifTrue: [
        label := aString collect: [:c | (c = $~) ifTrue: [ $& ] ifFalse: [ c ]].
    ] ifFalse: [
        label := aString.
    ].

    (self isHandleOk and: [
        self windowText ~= aString]) ifTrue: [
            self setWindowText: aString asParameter ]! !

! Button methods !   
isButton
    "Added by OSI"
    #addedByOSI.
    ^true!
isGroupable
    "Added by OSI"
    #addedByOSI.
    ^true! 
setDefault
    "Added by OSI"
    #addedByOSI.
    self isHandleOk ifFalse: [^self].
    UserLibrary sendMessage: handle
            msg: BmSetstyle
            wparam: 1
            lparam: self style asParameter! 
setDefault: aBoolean
    "Added by OSI"
    #addedByOSI.
    aBoolean
        ifTrue: [ self setDefault ]
        ifFalse: [ self unsetDefault ]!
setFocus
    "Added by OSI"
    #addedByOSI.
    super setFocus.
    self parent isCompositePane ifTrue: [ self setDefault ].!
unsetDefault
    "Added by OSI"
    #addedByOSI.
    self isHandleOk ifFalse: [^self].
    UserLibrary sendMessage: handle
            msg: BmSetstyle
            wparam: 0
            lparam: self style asParameter!   
wmKillfocus: wParam with: lParam
    "Added by OSI"
    #addedByOSI.
    self parent isCompositePane ifTrue: [ self unsetDefault ].
    ^super wmKillfocus: wParam with: lParam.! !

! DrawnButton methods !
cpContents
    "Added by OSI"
    | contents |
    #addedByOSI.
    contents := self propertyAt: #fileName.
    ^contents isNil
        ifTrue: [ self contents ]
        ifFalse: [ contents ]!   
cpContents: labelOrFileName
    "Added by OSI"
    #addedByOSI.
    labelOrFileName isString ifTrue: [
        self propertyAt: #fileName put: labelOrFileName.
        (self fileExists: labelOrFileName)
            ifTrue: [ bitmap := Bitmap fromFile: labelOrFileName ]
            ifFalse: [
                self pushButton.
                super contents: labelOrFileName.
            ]
    ] ifFalse: [
        self contents: labelOrFileName
    ].! 
cpSize
    "Added by OSI"
    | rect |
    #addedByOSI.
    rectangle isNil
        ifTrue: [
            ^(framingBlock value: self parent rectangle) extent ]
        ifFalse: [ ^self extent ]! 
cpStyle
    "Added by OSI"
    #addedByOSI.
    ^self propertyAt: #cpStyle!
fileExists: fileName
    "Added by OSI - Only valid .BMP files should be allowed"
    | array file exists extension |
    #addedByOSI.
    (fileName includes: $*) ifTrue: [ ^false ].
    array := File splitPath: fileName in: Disk.
    ((file := array at: 3) includes: $.) ifFalse: [ ^false ].
    exists := ((file ~= '.') and: [ (file ~= '..') and: [ File exists: fileName ]]).
    exists ifTrue: [
        file := file asStream.
        extension := (file skipTo: $.; upTo: $.) asUpperCase.
        extension = 'BMP' ifTrue: [ ^true ]].
    ^false! 
fixedSize
        "Modified by OSI to record style information"
        "If the receiver has a bitmap for its
         label (contents), draw the bitmap
         at its fixed size."

    #modifiedByOSI.
    self drawIsotropic.
    self propertyAt: #cpStyle put: #fixedSize.!
invisible
    "Added by OSI - Make the button invisible"

    #addedByOSI.
    drawBlock := [ :ignore | nil ].
    self propertyAt: #cpStyle put: #invisible.!   
stretchToFit
        "Modified by OSI to record style information"
        "If the receiver has a bitmap for its
         label (contents), stretch or shrink the bitmap
         so it fills the receiver."

    #modifiedByOSI.
    self drawAnisotropic.
    self propertyAt: #cpStyle put: #stretchToFit.! !

! ActionButton class methods !
supportedEvents
        "Private - Answer the Set of events that ActionButtons can notify
         their owners about."
    ^super supportedEvents
        remove: #clicked;
        yourself! !

! ActionButton methods ! 
action

    ^action!
action: aSymbol

    action := aSymbol! 
asyncControlEvent: msg
        "Private - Deferred control message handling routine."
    | linkClass |
    (msg = BnClicked) | (msg = BnDoubleclicked) ifTrue: [
        self action notNil ifTrue: [
            WBAction perform: self action on: self owner with: self
        ]
    ]! !

! CPStaticGraphic methods !   
createBitmap: aString
    "Added by OSI"
    | aPoint aBitmap |
    aPoint := self cpSize.
    aBitmap := Bitmap
        screenWidth: aPoint x
        height: aPoint y.
    aBitmap pen
        fill: self backColor;
        foreColor: self foreColor;
        backColor: self backColor;
        setBackMode: Transparent;
        setTextAlign: TaTop;
        font: (self font isNil ifTrue: [ self defaultFont ] ifFalse: [ self font ]);
        centerWinText: aString at: aBitmap boundingBox center.
   self contents: aBitmap! 
disable

    self noRedraw: true.
    super disable.
    self noRedraw: false.!   
initialize
    "Added by OSI"
    super initialize.
    self sendInputEvent: #disable.! !

! LinkButton class methods !  
supportedEvents
        "Private - Answer the Set of events that LinkButtons can notify
         their owners about."
    ^super supportedEvents
        remove: #clicked;
        yourself! !

! LinkButton methods ! 
asyncControlEvent: msg
        "Private - Deferred control message handling routine."
    | linkClass |
    (msg = BnClicked) | (msg = BnDoubleclicked) ifTrue: [
        (self link notNil and: [ Smalltalk includesKey: self link ]) ifTrue: [
            linkClass := Smalltalk at: self link.
            self type == #Independent ifTrue: [
                linkClass new open
            ] ifFalse: [ self type == #Child ifTrue: [
                linkClass new openWithParent: self owner
            ] ifFalse: [ self type == #Sibling ifTrue: [
                linkClass new openWithMyParent: self owner
            ] ifFalse: [ self type == #MDIChild ifTrue: [
                linkClass new openWithMDIParent: self owner
            ] ifFalse: [
                MessageBox message: 'Invalid link type [',self type asString,']!!!!'
            ]]]].
        ] ifFalse: [
            MessageBox message: 'Missing Link [',self link asString,']!!'
        ].
    ]!  
link

    ^link!
link: aSymbol

    link := aSymbol! 
type

    ^type!
type: aSymbol

    type := aSymbol! !

! StaticTextButton methods !   
buildBitmap: aPoint
    "Private - Build the receiver's bitmap"
    bitmap := Bitmap screenExtent: aPoint.
    bitmap pen
        font: self font;
        foreColor: ClrLightgray;
        rectangle: (0@0 extent: aPoint - 1);
        foreColor: ClrBlack;
        displayText: text at: 5@ aPoint y - 3.! 
contents: aString

    aString isString ifFalse: [^super contents: aString].
    text := aString.! 
drawItem: aDrawStruct
         "Private - Draw the requested control item."
    | extent |
    bitmap isNil ifTrue: [self buildBitmap: aDrawStruct boundingBox extent].
    ^super drawItem: aDrawStruct! !

! Toggle methods ! 
isButton
    "Added by OSI"
    #addedByOSI.
    ^false!   
setDefault
    "Added by OSI"
    #addedByOSI.! 
unsetDefault
    "Added by OSI"
    #addedByOSI.! !

! RadioButton methods !  
isRadio

    "Added by OSI"
    #addedByOSI.
    ^true! !

! EntryField methods !   
contents
    "Modified by OSI to fix intermittent failures. Thanks to Tom Lipkis"
    "Answer a string containing the text of the item."
    | length answer struct winAdr |
    #modifiedByOSI.
    self isHandleOk
        ifFalse: [^value].
    struct :=
        WinStructure fromBytes:
                (UserLibrary
                    sendMessage: self asParameter
                    msg: WmGettextlength
                    wparam: nil
                    lparam: nil).
    length := struct shortAtOffset: 0.
    length = 0 ifTrue: [ ^String new ].
    winAdr := WinAddress allocateMemory: length + 1.
    winAdr isNil ifTrue: [ ^String new ].
    UserLibrary
        sendMessage: self asParameter
        msg: WmGettext
        wparam: length + 1
        lparam: winAdr asParameter.
    answer := String new: length.
    WinAddress copyFrom: winAdr to: answer count: length. winAdr unlockAndFree.
    ^answer asNormalizedString!  
initialText
    "Private - Answer the receiver's initial text string
     Touched by Ale for clever implementation...
    Touched By Ale..."
    #modifiedByOStyle.
    ^value isString
        ifTrue: [value]
        ifFalse: [value asString]! 
maxSize

    "Added by OSI - Return the maximum number of
     characters allowed in the receiver"
    #addedByOSI.
    ^self propertyAt: #maxSize.! 
maxSize: anInteger

    "Added by OSI - Set the maximum number of
     characters allowed in the receiver"
    #addedByOSI.
    self propertyAt: #maxSize put: anInteger.
    self setTextLimit: anInteger.!
password

    "Added by OSI - Answer the style for a password protected field"
    #addedByOSI.
    self addStyle: EsPassword.

    ^self style.!   
readonly

    "Added by OSI - Set the entry field to be readonly"
    #addedByOSI.
    self sendInputEvent: #setReadOnly: with: true.!
selectAll

    "Added by OSI"
    #addedByOSI.
    self setSelectionFrom: 0 to: self contents size!   
setReadOnly: aBoolean

    "Added by OSI - Toggle the entry field's readonly state"
    #addedByOSI.
    self isHandleOk ifFalse: [ ^nil ].
    UserLibrary
        sendMessage: self handle
        msg: 1055
        wparam: aBoolean asParameter
        lparam: 0.!  
winClass
    "Private - Answer the window class for the receiver.
     Touched by Ale for Pen for Windows support..."

    | penLibrary |
    #modifiedByOStyle.
    penLibrary := Smalltalk at: #PenWinDLL ifAbsent: [^'EDIT'].
    ^penLibrary penWinPresent
        ifTrue: ['HEDIT'] ifFalse: ['EDIT']! !

! CPEntryField class methods !   
supportedEvents

    | se |

    se := super supportedEvents.
    (se includes: #loosingFocus) ifTrue: [
        se
            remove: #loosingFocus;
            add: #losingFocus.
    ].

    ^se! !

! CPEntryField methods !   
asyncControlEvent: msgId

    msgId = EnChange ifTrue: [
        justSetContents ifTrue: [
            justSetContents := false.
       ] ifFalse: [
            justSetContents := false.
            self event: #textChanged.
            ^nil
        ].
    ].!
calcRectFromFramingBlock: aRectangle oldExtent: oldExtent

    | newRect |

    framingBlock isRectangle ifTrue: [
        newRect := framingBlock.
    ] ifFalse: [
        framingBlock isContext ifTrue: [
            newRect := (framingBlock value: aRectangle).
        ] ifFalse: [
            newRect := framingBlock rectangleIn: aRectangle extent oldExtent: oldExtent.
        ].
    ].

    ^newRect!   
initialize

    super initialize.
    justSetContents := false.!   
modified

    "This entire subclass was created to get around the
      automatic 'Save changes?' dialog that pops up when
      you attempt to close a window containing a modified
      EntryField.  You cannot use #clearTextModified, as that
      is only sent to TextEdit/TextPanes, NOT EntryFields."

    ^false!   
selectAll

    self setSelectionFrom: 0 to: self contents size! 
setContents: aString

    "Touched by Ale for supporting objects..."
    #modifiedByOStyle.
    justSetContents := true.
    super contents: aString asString.!  
wmKillfocus: wParam with: lParam
        "Private - Validate Input before losing focus"
    |newValue|

    newValue := self windowText.
    self losingFocus.
    self event: #losingFocus.
    value := newValue.
    self setSelectionFrom: 0 to: 0.

    ^nil! !

! CPChildEntryField methods !   
buildWindow: parentWindow
    "Subclassed to avoid the initial MDI display problem if the entry field is a child
     of another subpane.   Changed the origin of the rectangle to be outside the
     visible area"

    | ps |
    style isNil ifTrue: [style := self frameStyle].
    self create: self winClass
        title: self initialText
        style:  style
        rectangle: (10000@10000 extent: 0@0)
        parent: self parent.
    handle = NullHandle ifTrue: [^nil].
    curFont isNil ifTrue: [curFont := self defaultFont].
    self initGraphics.
    self receiveMessages.
    children size ~= 0
        ifTrue: [
            children do: [:each |
                (each buildWindow: self) isNil ifTrue:[self close.^nil]]].
    self buildControl: parentWindow!  
nextDialogCtlAfter: aWindow

    | nextWindow |

    nextWindow := aWindow.

    [
        nextWindow := UserLibrary
            getWindow: nextWindow asParameter
            relationship: GwHwndnext.

        nextWindow isNil | (nextWindow = 0) ifTrue: [
            nextWindow := UserLibrary
                getWindow: aWindow asParameter
                relationship: GwHwndfirst.
        ].

        nextWindow := Notifier findWindow: nextWindow.

        nextWindow disabled |
        (nextWindow style bitIsOn: WsTabstop) not &
        (nextWindow ~~ aWindow)
    ] whileTrue: [].

    ^nextWindow!  
nextDialogCtlBefore: aWindow

    | prevWindow |

    prevWindow := aWindow.

    [
        prevWindow := UserLibrary
            getWindow: prevWindow asParameter
            relationship: GwHwndprev.

        prevWindow isNil | (prevWindow = 0) ifTrue: [
            prevWindow := UserLibrary
                getWindow: aWindow asParameter
                relationship: GwHwndlast.
        ].

        prevWindow := Notifier findWindow: prevWindow.

        prevWindow disabled |
        (prevWindow style bitIsOn: WsTabstop) not &
        (prevWindow ~~ aWindow)
    ] whileTrue: [].

    ^prevWindow!  
virtualKeyInput: char withKeys: keyArray

        "Private - Process the character input message."

    (char = VkUp) | (char = VkDown) |
        (char = VkLeft) | (char = VkRight) |
        (char = VkHome) | (char = VkEnd)  ifTrue: [
            self parent virtualKeyInput: char withKeys: keyArray.
            ^true
    ].

    ^nil!   
wmChar: char with: lParam
        "Private - Process the character input message."

    (char = TabKey) ifTrue: [
        (Notifier isKeyDown: VkShift) ifTrue: [
            (self nextDialogCtlBefore: self parent) setFocus.
        ] ifFalse: [
            (self nextDialogCtlAfter: self parent) setFocus.
        ].
        ^true
    ].

    ^nil!  
wmGetdlgcode: wParam with: lParam

    ^DlgcWantallkeys! !

! DrageableEntryField class methods ! 
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #beginDrag;
        add: #drag;
        add: #endDrag;
        yourself! !

! DrageableEntryField methods !  
button1Down: aPoint
    "Private - Process the drag move message"

    (super button1Down: aPoint) ifFalse:[^ self].
    self captureMouseInput.

    server beginDrag.
    self event: #beginDrag.!   
button1Move: aPoint
    "Private - Left button is down and the mouse has been moved.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    server drag.
    self event: #drag.!   
button1Up: aPoint
    "Private - Left button has been released.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    self clearMouseCapture.

    server endDrag.
    self event: #endDrag.!   
dragAndDropServer
    "Returns the current drag & drop server"
    ^server! 
dragAndDropServer: aServer
    "Sets the current drag & drop server"
    server := aServer! 
draggedObject
    "Returns the currently selected object"
    | item |
    (item := self draggedObjectFromOwner) isNil ifFalse: [^item].
    ^self contents!  
draggedObjectFromOwner
    "Private - Returns the currently selected object
     provided by the owner.
    Or nil..."
    | model |

    model := self owner.
    (model respondsTo: #draggedObjectIn:)
    ifTrue: [ "the model wants to provide the proper object to drag"
        ^model draggedObjectIn: self
    ].
    ^nil!
initialize
    "Private - Initializes the receiver"
    label := ''.
    super initialize.
    server := DragAndDropServer for: self! 
initialText
        "Private - Answer the receiver's initial text string"

    value isNil ifTrue: [^String new].
    ^value asString! !

! DrageableEntryObject methods !  
contents
    | text class |
    self isHandleOk
    ifTrue: [ text := super contents]
    ifFalse: [^object].

    (text isString and: [text trimBlanks isEmpty]) "empty or nil"
     ifTrue: [^nil].

    (object isString not and: [text = object asString])
     ifTrue: [^object].


    class := self propertyAt: #objectClass.
    class isNil ifTrue: [^text].

    object := (Smalltalk at: class ifAbsent: [^text]) named: text.
    object isNil ifTrue: [^text].
    ^object!
contents: anObject
    "Set the contents of the receiver and configure selection class"

    object := anObject.

    anObject isNil | anObject isString
    ifFalse: [
        self propertyAt: #objectClass put: anObject class symbol
    ].

    ^super contents:
        (anObject isNil ifTrue: [String new]
            ifFalse: [anObject asString])! 
draggedObjectFromOwner
    "Private - Returns the currently selected object
     provided by the owner.
    Or nil..."
    | result |
    result := super draggedObjectFromOwner.
    result isNil ifTrue: [^self contents "object"].
    ^result! 
object
    "Returns the instance var of the receiver
     for external manipulation"
    ^object!  
selectAll

    "Added by C&P"

    self setSelectionFrom: 0 to: super contents asString size! !

! EnhancedEntryField class methods !   
okCharacterMethods
    ^((self methodDictionary keys select: [ :selector |
        (selector at: 1) = $o and: [
        (selector at: 2) = $k and: [
        (selector at: selector size) = $:]]])
            collect: [ :selector |
            selector asString copyFrom: 3 to: selector size - 1])  asSortedCollection!
okFieldMethods
    ^((self methodDictionary keys select: [ :selector |
        (selector at: 1) = $o and: [
        (selector at: 2) = $k and: [
        (selector at: selector size) ~= $:]]])
            collect: [ :selector |
            selector asString copyFrom: 3 to: selector size ]) asSortedCollection!   
phoneConversionDict
    "Return a dictionary mapping letters to digit for
     phone numbers"

    ^Dictionary new
        at: $A put: $2;
        at: $B put: $2;
        at: $C put: $2;
        at: $D put: $3;
        at: $E put: $3;
        at: $F put: $3;
        at: $G put: $4;
        at: $H put: $4;
        at: $I put: $4;
        at: $J put: $5;
        at: $K put: $5;
        at: $L put: $5;
        at: $M put: $6;
        at: $N put: $6;
        at: $O put: $6;
        at: $P put: $7;
        at: $Q put: $7;
        at: $R put: $7;
        at: $S put: $7;
        at: $T put: $8;
        at: $U put: $8;
        at: $V put: $8;
        at: $W put: $9;
        at: $X put: $9;
        at: $Y put: $9;
        at: $Z put: $9;
        yourself.! !

! EnhancedEntryField methods !  
adjustCase: aString

    self case notNil ifTrue: [
        self case = #UPPER ifTrue: [ ^aString asUpperCase ].
        self case = #lower ifTrue: [ ^aString asLowerCase ].
        self case = #Proper ifTrue: [ ^aString asProperNoun ]
    ].
    ^aString!   
asyncControlEvent: msgId

        "Added to prevent the textChanged message from
         happening when the contents is set, as well as to
         select all when getting focus."

    msgId = EnChange  ifTrue: [
        justSet ifTrue: [
            justSet := false.
        ]  ifFalse: [
            justSet := false.
            self sendInputEvent: #event: with: #textChanged.
            ^nil
        ].
    ].
    msgId = EnKillfocus
        ifTrue: [
            self loseFocus.
            self event: #losingFocus. ^nil ].
    msgId = EnSetfocus
        ifTrue: [
            self perform: self getFocus.
            self event: #gettingFocus. ^nil ].! 
autoTab
    "Not supported under Windows"!   
case

    ^case!
case: aSymbol

    case := aSymbol! 
centered

    self justification: #centered.
    self addStyle: EsCenter.

    ^self style.! 
character

    ^character!  
character: aSymbol

    character := aSymbol!   
contents: aString

    "Prevent the textChanged message from
     happening when the contents is set and
     fix the case"

    justSet := true.
    super contents: (self adjustCase: aString).! 
errorMessage

    ^MessageBox confirm: 'Invalid Input. Retry?'! 
field

    ^field!  
field: aSymbol

    field := aSymbol!   
getFocus

    ^getFocus!
getFocus: aSymbol

    getFocus := aSymbol! 
initialize

    justSet := false.
    self
        getFocus: #selectAll;
        left.
    super initialize!
isAutoTab
    "Not supported under Windows"
    ^false! 
justification

    ^justification!  
justification: aSymbol

    justification := aSymbol!   
left

    self justification: #left!
loseFocus
    "Private - Validate the input prior to losing focus. Reset
     focus if input is invalid."
    self contents: self contents.
    self validateField ifFalse: [
        self errorMessage ifTrue: [ self setFocus ]
    ].!   
okAlpha: aChar
    "Validates whether aChar is a acceptable alpha character
     ( $A - $Z, $a - $z or space)"

    ^aChar isLetter or: [ aChar asciiValue = SpaceKey ]!  
okAlphaNoSpace: aChar
    "Validates whether aChar is a acceptable alpha character
     ( $A - $Z, $a - $z)"

    ^aChar isLetter!
okAlphaNumeric:  aChar
    "Validates whether aChar is a acceptable alpha-numeric character
     ( $A - $Z, $a - $z, $0 - $9, or space)"

    ^aChar isDigit or: [ self okAlpha: aChar ]! 
okAlphaNumericNoSpace: aChar
    "Validates whether aChar is a acceptable alpha character
     ( $A - $Z, $a - $z, $0 - $9)"

    ^aChar isLetter or: [ aChar isDigit ]!  
okAny: aChar

    ^true!
okBoolean: aChar
    "Answer true if aChar is one of 'TtFfYyNn'."

    ^'TtFfYyNn' includes: aChar!
okDate
    "Answer true if contents is a valid date else false."
    | aString answer |
    aString := self contents.
    aString size = 0 ifTrue: [^true].
    answer := Date validateString: aString.
    answer ifTrue: [ self contents: (Date fromString: aString) asString ].
    ^answer.!   
okInteger: aChar
    "Validates whether aChar is a acceptable character for a
     Integer in input string at position pos"
    | pos |
    pos := self getSelection leftTop x.
    ((aChar == $- or: [ aChar == $+ ]) and: [ pos == 1 ]) ifTrue: [ ^true ].
    ^self okPositiveInteger: aChar!
okPhoneNumberExtUS
    "Answer the input as a formated phone number.
     Format is: (999) 999-9999, 999-9999, x999, (999) 999-9999 x999."
    | input dict |
    dict := self class phoneConversionDict.
    input := (self contents collect: [ :aChar |
        dict at: aChar asUpperCase ifAbsent: [ aChar ]]) select: [ :aChar | aChar isDigit ].
    input size >= 10 ifTrue:[
        input size = 10 ifTrue: [
            self contents:
                '(', (input copyFrom: 1 to: 3),
                ') ', (input copyFrom: 4 to: 6),
                '-', (input copyFrom: 7 to: 10)
        ] ifFalse: [
            self contents:
                '(', (input copyFrom: 1 to: 3),
                ') ', (input copyFrom: 4 to: 6),
                '-', (input copyFrom: 7 to: 10),
                ' x', (input copyFrom: 11 to: input size)
        ].
        ^true
    ] ifFalse:[ input size >= 7 ifTrue:[
        self contents:
            (input copyFrom: 1 to: 3), '-',
            (input copyFrom: 4 to: 7).
            ^true
    ] ifFalse: [ input size >= 3 ifTrue:[
        self contents: 'x',input.
        ^true
    ] ifFalse: [ input size = 0 ifTrue:[
        ^true
    ] ifFalse:[
        ^false
    ]]]].!  
okPhoneNumberUS
    "Answer the input as a formated phone number.
     Format is: (999) 999-9999, 999-9999, x999, (999) 999-9999 x999."
    | input dict |
    dict := self class phoneConversionDict.
    input := (self contents collect: [ :aChar |
        dict at: aChar asUpperCase ifAbsent: [ aChar ]]) select: [ :aChar | aChar isDigit ].
    input size >= 10 ifTrue:[
        self contents:
            '(', (input copyFrom: 1 to: 3),
            ') ', (input copyFrom: 4 to: 6),
            '-', (input copyFrom: 7 to: 10).
        ^true
    ] ifFalse: [ input size >= 7 ifTrue: [
        self contents:
            (input copyFrom: 1 to: 3), '-',
            (input copyFrom: 4 to: 7).
        ^true
    ] ifFalse: [ input size = 0 ifTrue:[
        ^true
    ] ifFalse:[
        ^false
    ]]].! 
okPositiveInteger: aChar
    "Validates whether aChar is a acceptable character for a
    Positive Integer"

    ^aChar isDigit!  
okRound2
    "Answer the input rounded to 2 decimal places"

    self contents: ((Float fromString: self contents) roundTo: 0.01) asString.
    ^true.!   
okRound3
    "Answer the input rounded to 3 decimal places"

    self contents: ((Float fromString: self contents) roundTo: 0.001) asString.
    ^true.!  
okSSN
    "Answer the input as a social security number.
    Format is: 999-99-9999."
    | input answer |
    input := self contents select: [ :aChar | aChar isDigit ].
    (answer := input size = 9) ifTrue:[
        self contents:
            (input copyFrom: 1 to: 3), '-',
            (input copyFrom: 4 to: 5), '-',
            (input copyFrom: 6 to: 9).
    ] ifFalse: [ input size = 0 ifTrue:[
        ^true
    ]].
    ^answer!  
okZipCodeUS
    "Answer the input as a zip code.
    Format is: 99999 or 99999-9999."
    | input |
    input := self contents select: [ :aChar | aChar isDigit ].
    input size = 5 ifTrue:[
        self contents: input.
        ^true
    ] ifFalse: [ input size = 9 ifTrue: [
        self contents:
            (input copyFrom: 1 to: 5), '-',
            (input copyFrom: 6 to: 9).
        ^true
    ] ifFalse: [ input size = 0 ifTrue:[
        ^true
    ] ifFalse:[
        ^false
    ]]].! 
right

    self justification: #right.
    self addStyle: EsRight.

    ^self style.!
selectFirst
    "Place cursor at beginning of the text."
    self setSelectionFrom: 0 to: 0!
selectLast
    "Place cursor at end of the text."
    self setSelectionFrom: self contents size to: self contents size! 
validateCharacter: char
    "Private - Validate the character by applying char to
     the character validation function. Returns true if the
     character char is accepted. Returns false if not."

    (char asciiValue =  BackspaceKey) ifTrue: [ ^ true].

    self character notNil ifTrue: [
        (self perform: self character with: char) ifTrue:[
            ^ true
        ] ifFalse:[
            UserLibrary messageBeep: 0.
            ^ false
        ].
    ] ifFalse:[
        ^true
    ].!   
validateField
    "Private - Validate the input. Answer true if the input is
     acceptable else answer false."
    self field notNil ifTrue: [
        ^self perform: self field
    ] ifFalse: [
        ^true
    ].!  
wmChar: wParam with: lParam
    "Private - Only accept valid characters."
    (self validateCharacter: wParam asCharacter) ifTrue: [
        value := self windowText.
        ^ nil
    ] ifFalse: [
        ^ false
    ].! !

! FilteredEntryField methods !  
filterBlock
    "Returns the instance var of the receiver
     for external manipulation"
    ^filterBlock!
filterBlock: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    filterBlock := anObject!   
initialize

    super initialize.!  
wmChar: wordInteger with: longInteger
        "Private - Process the character input message."
    | char |
    char := wordInteger asCharacter.
    ((ControlKeys includes: char) or: [ (filterBlock value: char)]) ifTrue: [
        ^super wmChar: wordInteger with: longInteger
    ].! !

! FloatEntryField methods !
contents

    | i |
    (i := super contents) isNil ifTrue: [ ^0.0 ].
    ^i asFloat! 
contents: aFloat

    aFloat isNil ifTrue: [ ^super contents: '' ].
    super contents: aFloat asString.!  
initialize

    super initialize.
    self filterBlock: [ :aChar| aChar isDigit or: [aChar = NationalLanguage decimalSeparator first] ].! !

! IntegerEntryField methods !   
contents

    | i |
    (i := super contents) isNil ifTrue: [ ^0 ].
    ^i asInteger! 
contents: anInteger

    anInteger isNil ifTrue: [ ^super contents: '' ].
    super contents: anInteger asString.! 
initialize

    super initialize.
    self filterBlock: [ :aChar| aChar isDigit ].! !

! FormattedEntryField class methods ! 
formatDate: input
        "Answer the input as a formated date.
            Format is: MM/DD/YY"
    | formatedOutput |

    formatedOutput := input.
    input size =6
        ifTrue:[
            formatedOutput := (input copyFrom: 1 to: 2) ,
                                        '/', (input copyFrom: 3 to: 4),
                                        '/', (input copyFrom: 5 to: 6).
            "Check if the date is a valid date"
            Date fromString: formatedOutput]
        ifFalse:[input size = 0
            ifTrue:[]
            ifFalse:[
                    MessageBox message: 'Invalid Date']].
    ^ formatedOutput!  
formatDollar: input
        "Answer the input as a formated dollar currency.
            Format is: $ 999,999.99"
    | formatedOutput pos bNeg|

    input class = String ifFalse:[
        ^ String new].
    formatedOutput := (input asFloat roundTo: 0.01) printString.

    (formatedOutput at: 1) = $- ifTrue:[
        bNeg := true.
        formatedOutput :=
            formatedOutput copyFrom: 2 to: formatedOutput size]
    ifFalse:[
        bNeg := false].

    pos := (formatedOutput findFirst:[:ch| ch = $. ]) - 3.

    pos > 1 ifTrue:[
        pos to: 2 by: -3 do:[:i|
            formatedOutput := (formatedOutput copyFrom: 1 to: i - 1),
                                          ',', (formatedOutput copyFrom: i  to:
                                                        formatedOutput size)]].
    bNeg ifTrue:[
        formatedOutput := '- $ ', formatedOutput]
    ifFalse:[
        formatedOutput := '$ ', formatedOutput].

    "If required, add an extra .00"
    (formatedOutput findFirst:[:ch| ch = $. ])
        = (formatedOutput size - 1) ifTrue:[
            formatedOutput := formatedOutput, '0'].
    ^ formatedOutput!   
formatPhoneNumber: input
        "Answer the input as a formated phone number.
            Format is: (999) 999-9999 or 999-9999."
    | formatedOutput focusedWindow|

    formatedOutput := input.
    input size = 7
        ifTrue:[
            formatedOutput := (input copyFrom: 1 to: 3) ,
                                        '-', (input copyFrom: 4 to: 7)]
        ifFalse:[
            input size = 10
                ifTrue:[
                    formatedOutput := '(', (input copyFrom: 1 to: 3),
                            ') ', (input copyFrom: 4 to: 6),
                            '-', (input copyFrom: 7 to: 10)]
                ifFalse:[ input size = 0
                    ifTrue:[]
                    ifFalse:[
                        focusedWindow:= UserLibrary getFocus.
                        MessageBox message: 'Invalid Phone Number'.
                        UserLibrary showCaret: focusedWindow]]].
    ^ formatedOutput! 
validateAlpha: input withChar: ch position: pos
        "Validates whether ch is a acceptable alpha character
            ( $A - $Z, $a - $z or space) in input string at positon
            pos.  Answers true if it is acceptable
            else false."

    (ch isLetter
            or: [ ch asciiValue = SpaceKey] )
        ifTrue:[
            ^true].
    ^ false! 
validateDollar: input withChar: ch position: pos
        "Validates whether ch is a acceptable character for a
            dollar currency in input string at position pos.
            Answers true if it is acceptable
            else false."
    |decimalPos|

    (self
        validateFloat: input
        withChar: ch
        position: pos)
        ifTrue:[
            decimalPos := input indexOf: $. ifAbsent:[ input size].
            (pos > (decimalPos + 2))
                ifTrue:[
                    ^ false]]
        ifFalse:[
            ^ false].
    ^ true! 
validateFloat: input withChar: ch position: pos
        "Validates whether ch is a acceptable character for a
            Float in input string at position pos.
            Answers true if it is acceptable
            else false."

    (ch = $. and: [(input includes: $.) not] )
        ifTrue:[ ^ true].

    ^self
        validateInteger: input
        withChar: ch
        position: pos!
validateInteger: input withChar: ch position: pos
        "Validates whether ch is a acceptable character for a
            Integer in input string at position pos.
            Answers true if it is acceptable
            else false."

    ((ch = $- or: [ch = $+]) and:[ pos = 1])
       ifTrue:[^true].

    ^self
        validatePositiveInteger: input
        withChar: ch
        position: pos! 
validatePositiveInteger: input withChar: ch position: pos
        "Validates whether ch is a acceptable character for a
            Positive Integer in input string at position pos.
            Answers true if it is acceptable
            else false."

    ch isDigit
         ifTrue:[^true].
    ^ false! !

! FormattedEntryField methods !
acceptAlpha
        "Sets the FormattedEntryField to only accept alpha
            characters (A - Z, a- z)."

    self strokeBlock: [:ch|
        self class
            validateAlpha: self windowText
            withChar: ch
            position: self getSelection left].! 
acceptBlock: aBlock
        "Set accept block to aBlock.  When FormattedEntryField
            get a new value, aBlock is evaluated with the new
            value as the argument.  If the new value is accepted,
            aBlock should return the new value as formated output.
            If the new value is not accepted, aBlock should inform
            the user of the problem and just return the new value."

    acceptBlock := aBlock.! 
acceptDate
        "Sets the FormattedEntryField to only accept date.
            (6 digit positive integer.)
            The entered value will be shown in date format."

    self strokeBlock: [:ch|
        self class
            validatePositiveInteger: self windowText
            withChar: ch
            position: self getSelection left].
    self acceptBlock:[ :input|
            self class
                formatDate: input].
    self setTextLimit: 6.! 
acceptDollar
        "Sets the FormattedEntryField to only accept dollar currency.
            (a floating point number with two decimal places.)
            The entered value will be shown in dollar currency format."

    self strokeBlock: [:ch|
        self class
            validateDollar: self windowText
            withChar: ch
            position: self getSelection left].
    self acceptBlock:[ :input|
        self class formatDollar: input].! 
acceptFloat
        "Sets the FormattedEntryField to only accept floating point
            number."

    self strokeBlock: [:ch|
        self class
            validateFloat: self windowText
            withChar: ch
            position: self getSelection left].!  
acceptInteger
        "Sets the FormattedEntryField to only accept integer."

    self strokeBlock: [:ch|
        self class
            validateInteger: self windowText
            withChar: ch
            position: self getSelection left].! 
acceptPhoneNumber
        "Sets the FormattedEntryField to only accept phone number.
           (either a 7 or 10 digit number.)
            The entered value will be shown in phone number format. "

    self strokeBlock: [:ch|
        self class
            validatePositiveInteger: self windowText
            withChar: ch
            position: self getSelection left].
    self acceptBlock:[ :input|
        self class formatPhoneNumber: input].
    self setTextLimit: 10.!  
acceptPositiveInteger
        "Sets the FormattedEntryField to only accept positive integer."

    self strokeBlock: [:ch|
        self class
            validatePositiveInteger: self windowText
            withChar: ch
            position: self getSelection left].!
contents
        "Answer a string containing the text of the item."

         "Note: Don't want to get string from entry field
         because it might contain formated output."

    ^ value!
contents: input
        "Set the String associated with this control."
    |aOutput|

    aOutput := self formatOutput: input.
    super contents: aOutput.

    "Must reset the value with input
      Because value was set with aOutput in superClass"
    value := input.!   
formatedOutput
        "Answers formated output string of the FormattedEntryField."

    formatedOutput notNil
        ifTrue:[ ^ formatedOutput].
    ^ value.! 
formatOutput: input
        "Private - Answers the formated output of input."
    |result|

    formatedOutput := input.
    acceptBlock notNil
        ifTrue: [formatedOutput := acceptBlock value: input].
    ^ formatedOutput!
strokeBlock: aBlock
        "Set stroke block to aBlock.  For each key stroke entered,
            aBlock is evaluated with a Character as the argument.
            If the character is accepted aBlock should return true,
            other wise it should return false."

    strokeBlock := aBlock.!   
validateCharacter: char
        "Private - Validate the character by applying char to
            acceptBlock.
            Returns true if the character char is accepted.
            Returns false if not."

    (char asciiValue =  BackspaceKey)
        ifTrue:[ ^ true].

    strokeBlock notNil
        ifTrue: [(strokeBlock value: char)
                ifTrue:[ ^ true]
                ifFalse:[
                    UserLibrary messageBeep: 0.
                    ^ false]]
        ifFalse:[ ^true]!   
wmChar: wParam with: lParam
        "Private - Only allow valid characters to get through."
    (self validateCharacter: wParam asCharacter)
        ifTrue:[
            value := self windowText.
            ^ nil].
    ^ false!
wmKillfocus: wParam with: lParam
        "Private - format the output before loosing focus"
    super wmKillfocus: wParam with: lParam.
    self contents: self windowText.
    ^ nil!
wmLbuttondown: wParam with: lParam
        "Private - Set the field with input value instead of
                    formatedOutput"

    super wmLbuttondown: wParam with: lParam.
    self setWindowText: value.
    ^ nil!
wmSetfocus: wParam with: lParam
        "Private - Set the field with input string instead of
            formated output."

    super wmSetfocus: wParam with: lParam.
    self windowText ~= value ifTrue:[
        self setWindowText: value.
        self setSelectionFrom:0 to: 16r8000].
    ^ nil! !

! FormattedDateEntry class methods !   
formatDate: input
        "LRP Nov 23, 1992 Answer the input as a formated date.
            Format is: MM/DD/YY"
    | formatedOutput dd mm aa |

    formatedOutput := input.
    input size =6
        ifTrue:[
            formatedOutput := (mm := input copyFrom: 1 to: 2) ,
                                        '/', (dd := input copyFrom: 3 to: 4),
                                        '/', (aa := input copyFrom: 5 to: 6).
            dd :=dd asInteger.
            mm :=mm asInteger.
            aa :=aa asInteger.

            aa <= 10  ifTrue: [
                    MessageBox message:
                        'Invalid Date (bad year)'.
                    ^input
            ].
            (mm >= 1 and: [mm <=12]) ifFalse: [
                    MessageBox message:
                        'Invalid Date (bad month)'.
                    ^input
            ].

            dd := (dd max: 1) min:
                (Date daysInMonth: (Date nameOfMonth: mm)
                    forYear: aa+1900).

            formatedOutput := mm printString , '/' , dd printString , '/',
                aa printString.
            "Check if the date is a valid date"
            Date fromString: formatedOutput]
        ifFalse:[
            input size = 0 ifTrue: [
                ^'mm/dd/aa'
            ]
            ifFalse:[
                    MessageBox message: 'Invalid Date']
            ].
    ^ formatedOutput! !

! FormattedDateEntry methods !
contents
    | date |
    date := super contents.
    date size = 6 ifTrue: [
        ^Date fromString: (self class formatDate: date)
    ] ifFalse: [
        ^nil
    ]! 
contents: input
        "Set the String associated with this control."
    |aOutput|

    aOutput := self formPrint: input.
    super contents: aOutput.

    "Must reset the value with input
      Because value was set with aOutput in superClass"
    value :=aOutput!  
formPrint: aDate
        "Answer a string representing the
         receiver Date in the form: mm/dd/yy."
    | monthNumber dayNumber yearNumber aStream |
    (aDate isKindOf: Date) ifFalse: [^aDate].

    aStream := WriteStream on: (String new: 8).
    dayNumber := aDate dayOfMonth.
    monthNumber := aDate monthIndex.
    yearNumber := aDate year \\ 100.
    monthNumber < 10
        ifTrue: [aStream nextPut: $0].
    aStream nextPutAll: (monthNumber printString).
    dayNumber < 10
        ifTrue: [aStream nextPut: $0].
    aStream nextPutAll: (dayNumber printString),
        yearNumber printString.
    ^aStream contents!  
initialize
    super initialize.
    self acceptDate! !

! OSEntryField class methods !   
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #characterInput;
        yourself! !

! OSEntryField methods ! 
lastCharacterInput
    "Returns the last character input..."

    ^self propertyAt: #lastCharacterInput!   
wmChar: wordInteger with: lParam
        "Private - Process the character input message."

    | char |
    char := wordInteger asCharacter.
    self
        propertyAt: #lastCharacterInput put: char;
        event: #characterInput.

    ^super wmChar: char with: lParam!  
wmGetdlgcode: wParam with: lParam

    ^DlgcWantallkeys! !

! PasswordEntry methods ! 
basicStyle
    "Private - Answer an Integer with appropriate
     constants combination for basic control style."

    ^super basicStyle | EsPassword!
winClass
    "Private - Answer the window class for the receiver.
     Ignore pen support..."
    ^'EDIT'! !

! TextEdit methods !   
noBorders

    "Added by OSI"
    #addedByOSI.
    style := self defaultStyle - WsBorder! 
noScrollBars

    "Added by OSI runtime.  Does nothing.
     Default for TextEdit is no scroll bars."
    #addedByOSI.!   
scrollBars

    "Added by OSI"
    #addedByOSI.
    style := self defaultStyle + WsHscroll + WsVscroll!   
wmGetdlgcode: wParam with: lParam

    "Added by OSI"
    #addedByOSI.
    ^DlgcWantallkeys!  
wordWrap

    "Added by OSI"
    #addedByOSI.
    style := self defaultStyle + WsVscroll - EsAutohscroll! !

! DrageableTextEdit class methods !
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #beginDrag;
        add: #drag;
        add: #endDrag;
        yourself! !

! DrageableTextEdit methods !
button1Down: aPoint
    "Private - Process the drag move message"

    (super button1Down: aPoint) ifFalse:[^ self].
    self captureMouseInput.

    server beginDrag.
    self event: #beginDrag.!   
button1Move: aPoint
    "Private - Left button is down and the mouse has been moved.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    server drag.
    self event: #drag.!   
button1Up: aPoint
    "Private - Left button has been released.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    self clearMouseCapture.

    server endDrag.
    self event: #endDrag.!   
dragAndDropServer
    "Returns the current drag & drop server"
    ^server! 
dragAndDropServer: aServer
    "Sets the current drag & drop server"
    server := aServer! 
draggedObject
    "Returns the currently selected object"
    | item |
    (item := self draggedObjectFromOwner) isNil ifFalse: [^item].
    ^self contents!  
draggedObjectFromOwner
    "Private - Returns the currently selected object
     provided by the owner.
    Or nil..."
    | model |

    model := self owner.
    (model respondsTo: #draggedObjectIn:)
    ifTrue: [ "the model wants to provide the proper object to drag"
        ^model draggedObjectIn: self
    ].
    ^nil!
initialize
    "Private - Initializes the receiver"
    super initialize.
    server := DragAndDropServer for: self! !

! TextEditBox methods !  
defaultStyle
    "The default style for the receiver is with no horizontal scroll."

    ^super defaultStyle  - EsAutohscroll! 
nextDialogCtlAfter: aWindow

    | nextWindow keys index |

    nextWindow := aWindow.

    [
        nextWindow := UserLibrary
            getWindow: nextWindow asParameter
            relationship: GwHwndnext.

        nextWindow isNil | (nextWindow = 0) ifTrue: [
            nextWindow := UserLibrary
                getWindow: aWindow asParameter
                relationship: GwHwndfirst.
        ].

        nextWindow := Notifier findWindow: nextWindow.

        nextWindow isNil ifTrue: [
            keys := aWindow children keys asSortedCollection.
            index := keys indexOf: (aWindow children keyAtValue: self).
            index := index - 1.
            index < 1 ifTrue: [index := keys size].
            nextWindow := aWindow children at: (keys at: index)
        ].

        nextWindow disabled &
        (nextWindow style bitIsOn: WsTabstop) not &
        (nextWindow ~~ aWindow)
    ] whileTrue: [].

    ^nextWindow!  
nextDialogCtlBefore: aWindow

    | prevWindow index keys |

    prevWindow := aWindow.

    [

        prevWindow := UserLibrary
            getWindow: prevWindow asParameter
            relationship: GwHwndprev.

        prevWindow isNil | (prevWindow = 0) ifTrue: [
            prevWindow := UserLibrary
                getWindow: aWindow asParameter
                relationship: GwHwndlast.
        ].

        prevWindow := Notifier findWindow: prevWindow.

        prevWindow isNil ifTrue: [
            keys := aWindow children keys asSortedCollection.
            index := keys indexOf: (aWindow children keyAtValue: self).
            index := index + 1.
            index > keys size ifTrue: [index := 1].
            prevWindow := aWindow children at: (keys at: index)
        ].

        prevWindow disabled &
        (prevWindow style bitIsOn: WsTabstop) not &
        (prevWindow ~~ aWindow)
    ] whileTrue: [].

    ^prevWindow!
noHScroll

    "Added by Ale runtime.  Does nothing.
     Default for TextEdit is no scroll bars."

    style := self defaultStyle  - EsAutohscroll! 
wmChar: char with: lParam
        "Private - Process the character input message."

    (char = TabKey) ifTrue: [
        (Notifier isKeyDown: VkShift) ifTrue: [
            (self nextDialogCtlBefore: self ) setFocus.
        ] ifFalse: [
            (self nextDialogCtlAfter: self ) setFocus.
        ].
        ^true
    ].

    ^nil!  
wmGetdlgcode: wParam with: lParam

    ^DlgcWantallkeys! !

! WBEntryField methods !  
asyncControlEvent: msgId

        "Added to prevent the textChanged message from
         happening when the contents is set, as well as to
         select all when getting focus."

    msgId = EnChange  ifTrue: [
        justSet ifTrue: [
            justSet := false.
        ]  ifFalse: [
            justSet := false.
            self sendInputEvent: #event: with: #textChanged.
            ^nil
        ].
    ].
    msgId = EnSetfocus ifTrue: [ self sendInputEvent: #selectAll. ^nil ].!   
initialize

    justSet := false.
    super initialize!
modified

    "Added to avoid the isTextModified message from returning
     true in WindowBuilder.  Believe it or not, this is checked for
     EntryFields..."

    ^false!   
setContents: aString

        "Added to prevent the textChanged message from
         happening when the contents is set"

    justSet := true.
    super contents: aString.!   
wmKillfocus: wParam with: lParam
        "Private - Validate Input before loosing focus"
    |newValue|

    newValue := self windowText.
    self losingFocus.
    self event: #losingFocus.
    value := newValue.
    self setSelectionFrom: 0 to: 0.

    ^nil! !

! WBKeyEntryField class methods !  
isWBInternalClass

    ^true!   
supportedEvents
        "Answer the Set of events that EntryFields can notify
         their owners about."
    ^super supportedEvents
        add: #keyEntered;
        yourself! !

! WBKeyEntryField methods !  
accelerator

    ^accelerator!  
accelerator: newAccel

    accelerator := newAccel.
    (accelerator isNil) ifTrue: [
        self contents: ''.
        accelerator := WBKeyAccel new.
    ] ifFalse: [
        self contents: accelerator keyName.
    ].!  
initialize

    super initialize.
    accelerator := WBKeyAccel new.!  
keyInput: aChar

    accelerator keyCode: aChar.
    self contents: accelerator keyName.
    self setAugmentKeys.
    self selectAll.
    self event: #keyEntered.! 
setAugmentKeys

    accelerator isAlt: (Notifier isKeyDown: AltKey).
    accelerator isCtrl: (Notifier isKeyDown: VkControl).
    accelerator isShift: (Notifier isKeyDown: VkShift).!
virtualKeyInput: char withKeys: keyArray

        "Private - Process the character input message."
    (char = AltKey) | (char = ControlKey) | (char = ShiftKey) ifFalse: [
        self keyInput: char.
    ].! 
wmChar: theChar with: lParam

    ^true!
wmGetdlgcode: wParam with: lParam

    ^DlgcWantmessage!
wmKeydown: wordInteger with: longInteger
        "Private - Process the key down message."
    | char |

    char := KeyboardLibrary
        mapVirtualKey: wordInteger
        mapType: 2.

    (char = TabKey) ifTrue: [
        ^UserLibrary sendMessage: parent handle
            msg: WmNextdlgctl
            wparam:  ((Notifier isKeyDown: VkShift) ifTrue: [ 1 ] ifFalse: [ 0 ])
            lparam: 0
    ].

    char < 44  ifTrue: [
        (wordInteger = AltKey) | (wordInteger = ControlKey) | (wordInteger = ShiftKey) ifFalse: [
            self sendInputEvent: #keyInput: with: wordInteger.
            ^true
        ].
    ] ifFalse: [

        self sendInputEvent: #keyInput: with: char asCharacter.
    ].

    ^true! !

! WBListEntryField class methods ! 
isWBInternalClass

    ^true! !

! WBListEntryField methods ! 
asyncControlEvent: msgId

    msgId = EnChange ifTrue: [
        justSetContents ifTrue: [
            justSetContents := false.
       ] ifFalse: [
            owningListBox  editBoxTextChanged. ^nil
        ].
    ].!   
initialize

    super initialize.
    justSetContents := false.!   
owningListBox: aListBox

    owningListBox := aListBox.
    aListBox owningEditBox: self.! 
setContents: aString

    justSetContents := true.
    super contents: aString.
    self selectAll.!  
virtualKeyInput: char withKeys: keyArray

        "Private - Process the character input message."

    (char = VkUp) | (char = VkDown) |
        (char = VkLeft) | (char = VkRight) ifTrue: [
            owningListBox virtualKeyInput: char.
            ^true
    ].

    ^nil! 
wmChar: char with: lParam
        "Private - Process the character input message."

    char = ReturnKey ifTrue: [
        owningListBox cr.
        ^true
    ].

    (char = TabKey) ifTrue: [
        UserLibrary sendMessage: parent handle
            msg: WmNextdlgctl
            wparam:  ((Notifier isKeyDown: VkShift) ifTrue: [ 1 ] ifFalse: [ 0 ])
            lparam: 0.
        ^true
    ].

    ^nil!
wmGetdlgcode: wParam with: lParam

    ^DlgcWantallkeys! !

! GroupBox methods !  
isWsTabstop

    "Added by OSI - Allows static text and Groupboxes to
     be in tab order for WB, without adding to style bits."
    #addedByOSI.
    ^(self propertyAt: #tabStop) notNil!  
tabStop

    "Added by OSI - Allows static text and Groupboxes to
     be in tab order for WB, without adding to style bits."
    #addedByOSI.
    self propertyAt: #tabStop put: true! !

! WBGroupBox class methods !
isWBInternalClass

    ^true! !

! ListBox methods !  
asyncControlEvent: anEvent
   "Private - Process single and double selections.
    Touched by Ale for incremental search support."
    #modifiedByOStyle.

    self selectedItem isNil ifTrue: [^nil].
    anEvent= LbnSelchange
        ifTrue: [ "do nothing if a double click queued"
            (CurrentEvents
                detect: [:msg | msg selector = #asyncControlEvent:
                    and: [msg arguments size = 1
                    and: [(msg arguments at: 1) = LbnDblclk]]]
                ifNone: [nil])    "do nothing if a double click queued"
                    notNil ifTrue: [^self].
            ( self commitSelection )
                ifTrue: [
                    "clear the incremental search string"
                    self incrementalSearchText: ''.
                    tempSelection := self selectedItem.
                    self event: #select. ^nil ].
                self selectItem: tempSelection. ^nil ].

    anEvent = LbnDblclk
        ifTrue: [ self event: #doubleClickSelect. ^nil ].!   
boxCurrentMatch
    "Private - This method is implemented for incremental
     search in the receiver.
    Show the receiver at current matching line.
    Implemented by Ale..."
    | index first |
    #addedByOStyle.
    first  := self getTopIndex.
    (index := self matchingLine) isNil
    ifTrue: [
        UserLibrary messageBeep: 0.
        index := first
    ].

    self noRedraw: true.
    self setTopIndex: index.
    self  noRedraw: false.
    self invalidateRect: self rectangle!  
deleteAll
    "Delete the whole list.
    Touched by Ale for:
        - remotion of items when the handle is not Ok yet...
    Touched By Ale..."
    #modifiedByOStyle.
    list := Array new.
    self isHandleOk ifFalse: [^self].
    UserLibrary sendMessage: handle
        msg: LbResetcontent
        wparam: 0
        lparam: 0! 
deleteItemAt: index
    "Private - Delete an item from the receiver.
    Implemented by LRP..."
    #addedByOStyle.
    list isNil ifTrue: [^self].
    self deleteItemInControlAt: index.!  
deleteItemInControlAt: index
    "Private - LRP Delete an item from the receiver.
    Touched by Ale for:
        - remotion of item when handle is not Ok yet...
        - not change the list of the receiver if posible..."
    #modifiedByOStyle.
    list isNil ifTrue: [^self].
    (list respondsTo: #removeIndex:)
    ifFalse: [ list := list asOrderedCollection].
    list removeIndex: index.
    self isHandleOk ifFalse: [^self].

    UserLibrary sendMessage: handle
        msg: LbDeletestring
        wparam: (index - 1)
        lparam: 0.!   
deleteItems: aCollection
    "Private - Delete a collection of items
     from the receiver.
    Implemented by Ale..."
    #addedByOStyle.
    list isNil ifTrue: [^self].
    (list respondsTo: #removeIndex:)
    ifFalse: [ list := list asOrderedCollection].
    aCollection do: [:each| list removeIndex: each ].
    self isHandleOk ifFalse: [^self].

    self noRedraw: true.

    aCollection do: [:each|
        UserLibrary sendMessage: handle
            msg: LbDeletestring
            wparam: each - 1
            lparam: 0.
    ].

    self
        noRedraw: false;
        invalidateRect: nil!
findLineMatching: aString
    "Private - This method is implemented for incremental
     search in the receiver.
    Returns the index for the first line matching aString.
    Implemented by Ale..."
    | index  toFind |
    #addedByOStyle.
    aString size = 0 ifTrue: [^1].
    index  := self getSelection.
    toFind := aString asUpperCase trimBlanks.
    index isNil ifTrue: [index := 1].
    [index <= list size] whileTrue: [
        (toFind isPrefixOf: (list at: index)
            asString asUpperCase trimBlanks)
        ifTrue: [^index].
        index := index + 1.
    ].
    ^nil!  
getCount
    "Private - Answer the number of items in a List.
    Who touched this method? why?"
    #modifiedByOStyle.
    self isHandleOk ifFalse: [^0].
    ^( ( WinStructure fromBytes:
        ( UserLibrary
            sendMessage: self asParameter
            msg: LbGetcount
            wparam: nil
            lparam: nil ) ) shortAtOffset: 0) + 1.! 
incrementalSearchFor: aCharacter
    "Private - This method is implemented for incremental
     search in the receiver.
    Implemented By Ale acording to St/V Carletton tools Goodies."
    | typed |
    #addedByOStyle.

    aCharacter asciiValue = 127 "Ctrl+Backspace"
    ifTrue: [
        self incrementalSearchText: String new.
        ^self boxCurrentMatch
    ].

     typed := self incrementalSearchText.
    aCharacter asciiValue = 8 "Backspace"
     ifTrue: [
        typed size > 1
        ifTrue: [
            self incrementalSearchText:
               (typed copyFrom: 1 to: typed size - 1)
        ] ifFalse: [self incrementalSearchText: String new].
        ^self boxCurrentMatch
    ].

    self incrementalSearchText: typed , (String with: aCharacter).

    self selectWhenSearching
    ifTrue: [self selectMatchingLine]
    ifFalse: [self boxCurrentMatch]!
incrementalSearchText
    "Private - This method is implemented for incremental
     search in the receiver.
     Returns the incremental text typed.
    Implemented by Ale..."
    | typed |
    #addedByOStyle.
    typed := self propertyAt: #incrementalSearchText:.
    typed isNil ifTrue: [^String new].
    ^typed! 
incrementalSearchText: aString
    "Private - This method is implemented for incremental
     search in the receiver.
     Sets the incremental text typed, Returns the receiver.
    Implemented by Ale..."
    #addedByOStyle.
    self propertyAt: #incrementalSearchText: put: aString! 
indexOf: aString

    "Modified by OSI to allow for nil lists."

    "Answer the index of the item aString."

    #modifiedByOSI.
    list isNil ifTrue: [ ^nil ].

    ^list indexOf: aString!  
initialText
    "Private - Answer the receiver's initial text string.
    Implemented by Ale for list pane selected bug during startUp..."
    #addedByOStyle.
    ^String new!   
matchingLine
    "Private - This method is implemented for incremental search in the receiver.
    Returns the index for the line matching the incremental typed string or nil.
    If none matrches the search text will be shrinked to its previous state.
    Implemented by Ale..."
    | index text |
    #addedByOStyle.
    text := self incrementalSearchText.
    index := self findLineMatching: text.
    index isNil
    ifTrue: [
        self incrementalSearchText: (text copyFrom: 1 to: text size - 1)
    ].
    ^index!   
selectMatchingLine
    "Private - This method is implemented for incremental search in the receiver.
    Selects the next line matching the incremental typed text.
    Implemented by Ale..."
    | index |
    #addedByOStyle.
    index := self matchingLine.
    index isNil ifTrue: [^nil].
    self selection: index.
    self event: #select.!
selectWhenSearching
    "Private - This method is implemented for incremental
     search in the receiver.
    Returns true if the receiver selectes when searching.
     The default action is to select..
    Implemented by Ale..."
    | action |
    #addedByOStyle.
    action := self propertyAt: #selectWhenSearching.
    action isNil ifTrue: [^true]. "select as default"
    ^action!   
selectWhenSearching: aBoolean
    "Private - This method is implemented for incremental
     search in the receiver.
    Sets the receiver for select or not when searching.
    Implemented by Ale..."
    #addedByOStyle.
    self
        propertyAt: #selectWhenSearching
        put: aBoolean!  
setItemText: aString
    "Set the text for the selected item to aString.
    Who touched this method? why?"

    | index col size |
    #modifiedByOStyle.

    size := self contents size.
    col := OrderedCollection new: size.
    index := self selectedIndex.
    1 to: size do: [:i |
        i = index
        ifTrue: [col add: aString]
        ifFalse: [col add: (list at: i)].
    ].

    self
        contents: col;
        selectIndex: index.!   
validate
    "Private - Validate the control.
    Touched By Ale for better validation..."
    #modifiedByOStyle.

    super validate.
    curFont isNil
        ifTrue: [self font: self defaultFont]
        ifFalse: [self font: curFont].
    list isNil ifFalse: [self contents: list].
    value notNil ifTrue: [ self selectIndex: value ]! !

! ComboBox methods !
text
    "Added by OSI"
    #addedByOSI.
    ^self windowText.! !

! OSComboBox class methods !  
initialize
    "Private - Initializes the receiver"

    super initialize.
    Smalltalk "set alias for back compatibility"
        at: #DrageableComboBox put: OSComboBox;
        at: #OGComboBox put: OSComboBox;
        yourself! 
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #beginDrag;
        add: #drag;
        add: #endDrag;
        yourself! !

! OSComboBox methods !   
button1Down: aPoint
    "Private - Process the drag move message"

    (super button1Down: aPoint) ifFalse:[^ self].
    self captureMouseInput.

    server beginDrag.
    self event: #beginDrag.!   
button1Move: aPoint
    "Private - Left button is down and the mouse has been moved.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    server drag.
    self event: #drag.!   
button1Up: aPoint
    "Private - Left button has been released.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    self clearMouseCapture.

    server endDrag.
    self event: #endDrag.!   
contents: aCollection
    "Set the receiver's contents to aCollection only when
     aCollection is different from current contents."

     list == aCollection
     ifFalse: [^super contents: aCollection].

     self isHandleOk
     ifTrue: [
            self
                "selection: nil;   "
                invalidateRect: nil
    ].
     ^list!  
dragAndDropServer
    "Returns the current drag & drop server"
    ^server! 
dragAndDropServer: aServer
    "Sets the current drag & drop server"
    server := aServer! 
draggedObject
    "Returns the currently selected object"
    | item |
    (item := self draggedObjectFromOwner) isNil ifFalse: [^item].
    ^self selectedItem!  
draggedObjectFromOwner
    "Private - Returns the currently selected object
     provided by the owner.
    Or nil..."
    | model |

    model := self owner.
    (model respondsTo: #draggedObjectIn:)
    ifTrue: [ "the model wants to provide the proper object to drag"
        ^model draggedObjectIn: self
    ].
    ^nil!
framingBlock: aBlock
        "Initialize the framingBlock to the one
         argument block aBlock which, when executed,
         yields the pane frame rectangle."
    | result minHeight |
    ^super framingBlock: [:rect|
            result := aBlock value: rect.
            result height < (minHeight := self height * 4)
            ifTrue: [result := result origin extent: result width @ minHeight].
            result
        ].!  
initialize
    "Private - Initializes the receiver"
    super initialize.
    server := DragAndDropServer for: self!   
removeSelection
    "Remove currently selected objects..."
    | copy toRemove |
    copy := self contents asOrderedCollection.
    toRemove := self selection.
    toRemove isNil ifTrue: [^nil].
    copy remove: (copy at: self selection) ifAbsent: [^nil].
    self contents: copy!   
validate
    "Private - Validate the control."
    | current oldValue |
    current := list.
    oldValue := value.
    list := nil.
    super validate.
    current isNil ifFalse: [ self contents: current. ].
    oldValue isNil ifFalse: [ self selectIndex: value ].! !

! WBComboBox methods !
buildList

    super contents: (fullList select: [ :el | (disabled includes: el) not ]).
    self selectIndex: value.! 
contents

    ^fullList!
contents: aCollection

    disabled := Set new.
    fullList := aCollection.

    ^super contents: aCollection!  
disableItem: anItem

    self getSelection.
    ((fullList indexOf: anItem) = value) ifTrue: [
        value := value + 1.
        (value > list size) ifTrue: [
            value := 1.
        ].
        self selectIndex: value.
    ].

    disabled add: anItem.

    self buildList.! 
enableItem: anItem

    disabled remove: anItem ifAbsent: [].

    self buildList.!   
initialize

    super initialize.
    disabled := Set new.
    fullList := list.! 
selectedItem
        "Answer the item selected in the receiver."
    ( self getSelection ) isNil
        ifTrue: [ ^nil ]
        ifFalse: [ ^list at: value ]!   
selectItem: anObject

        "Avoid the Combobox version, since it sets the text, and
         loses the selection"

        "Private - Select the item anObject. anObject can
         be an index or a string."

    anObject isInteger
        ifTrue: [ self selectIndex: anObject ]
        ifFalse: [ self selectIndex: (self indexOf: anObject) ]! !

! CPHierarchicalListBox class methods ! 
supportedEvents

    ^Set new
        add: #commitSelection;
        add: #doubleClickSelect;
        add: #getContents;
        add: #getPopupMenu;
        add: #commitSelection;
        add: #select;
        yourself! !

! CPHierarchicalListBox methods !   
asyncControlEvent: anEvent

    "Private - Process single and double selections."

    self selectedItem isNil ifTrue: [
        ^nil
    ].

    anEvent= LbnSelchange  ifTrue: [ "do nothing if a double click queued"
        (CurrentEvents
                detect: [:msg | msg selector = #asyncControlEvent:
                    and: [msg arguments size = 1
                    and: [(msg arguments at: 1) = LbnDblclk]]]
                ifNone: [nil]
        )   notNil ifTrue: [
            ^self
        ].
        self event: #select.
    ].

    anEvent = LbnDblclk  ifTrue: [
        self expandOrCollapse.
        self event: #doubleClickSelect.
        ^nil
    ].!
buildControl: parentWindow

    "Private - Create the control for the receiver."

    "We added this since ST/V 1.1 does not have it"

    super buildControl: parentWindow.
    horizontalExtent notNil ifTrue: [
        self setHExtent: horizontalExtent.
    ].!
childrenMethod

    "Private"

    ^childrenMethod!   
childrenMethod: anObject

    "Private"

    childrenMethod := anObject.
    objectList notNil ifTrue: [
        objectList do: [ :o |
            o getChildren.
        ].
        self updateListBox: false.
    ].! 
commitSelection

    ^(self event: #commitSelection) ~= false!  
contents: aList

    (aList isKindOf: OrderedCollection) ifFalse: [
        objectList := OrderedCollection with: (
            CPTreeNode new object: aList owner: self parent: nil
        ).
    ] ifTrue: [
        objectList := aList collect: [ :object |
            CPTreeNode new object: object owner: self parent: nil
        ].
    ].

    self updateListBox: false.! 
copySpecificsTo: aPane

    aPane nameMethod: self nameMethod.
    aPane childrenMethod: self childrenMethod.
    aPane iconMethod: self iconMethod.! 
defaultStyle

    "Private"

   ^style := self basicStyle |
                WsBorder |
                WsVscroll |
                WsHscroll |
                LbsNotify  |
                LbsNointegralheight  |
                LbsOwnerdrawfixed!   
drawItem: aDrawStruct

    "Private - Draw the requested control item."

    userDrawn := aDrawStruct.
    (list at: self drawIndex) displayWith: graphicsTool inBox: self drawBox.! 
expandOrCollapse

    "Expand or collapse the selected item."

    | selectedIndex |

    (selectedIndex := self selectedIndex) isNil ifTrue: [
        ^self
    ].

    (list at: selectedIndex) expandOrCollapse.
    list := self flatList.
    self updateListBox: true.
    self selectIndex:  selectedIndex.! 
flatList

    "Private"

    | flatList |

    flatList := OrderedCollection new.
    objectList do: [ :o |
        flatList addAll: o asFlatList.
    ].

    ^flatList!  
font

    "Private"

    super font isNil ifTrue: [
        self font: self defaultFont
    ].

    ^super font!  
iconMethod

    "Private"

    ^iconMethod!   
iconMethod: anObject

    "Private"

    iconMethod := anObject!  
indexOf: anObject

    1 to: list size do: [:i |
        (list at: i) object == anObject ifTrue: [ ^i ].
    ].

    ^0!
initialize

    "Private"

    super initialize.
    nameMethod := #printString.
    objectList := OrderedCollection new.!  
insertBlankItems

    "Private"

    | strNonST |

    self isHandleOk & list notNil  ifFalse: [ ^self ].

    self noRedraw: true.

    UserLibrary sendMessage: handle
        msg: LbResetcontent
        wparam: 0
        lparam: 0.

    list size timesRepeat: [
        strNonST := WinAddress copyToNonSmalltalkMemoryZ: '' asParameter.
        UserLibrary sendMessage: handle
            msg: LbInsertstring
            wparam: 16rFFFF       "LitEnd in low word"
            lparam: strNonST asParameter.
        strNonST unlockAndFree.
    ].
    self noRedraw: false.!   
maxDisplayWidth

    "Private"

    | maxDisplayWidth |

    maxDisplayWidth := 0.
    objectList do: [ :o |
        maxDisplayWidth := maxDisplayWidth max: (o maxDisplayWidth: self font).
    ].

    ^maxDisplayWidth! 
maxIconHeight

    "Private"

    | maxHeight |
    maxHeight := 0.
    objectList do: [ :o |
        maxHeight := maxHeight max: o maxIconHeight.
    ].
    ^maxHeight!
measureControl: aStruct

    "Private - Establish the list item height for Windows."

     aStruct itemHeight: (self font height max: self maxIconHeight)!
nameMethod

    "Private"

    ^nameMethod!   
nameMethod: anObject

    "Private"

    nameMethod := anObject!  
releaseDC: aDisplayContext

    "Ignore the error message in 1.1"
        "Private - Release aDisplayContext, the display
         context for the receiver."
    UserLibrary
        releaseDC: handle
        with: aDisplayContext! 
selectedItem

    list isNil | self selectedIndex isNil ifTrue: [
        ^nil
    ].

    ^(list at: self selectedIndex) object!   
selectItem: anObject
        "Select the item anObject. anObject can
         be an index or an object. If anObject is an index,
         the current displayed list is used. If anObject is
         an object , anObject is searched for in the
         hierarchy. If found the list will be automatically
         expanded"
    | node |
    anObject isInteger
        ifTrue: [ self selectIndex: anObject ]
        ifFalse: [
            objectList detect: [ :object |
                (node := object asFullList detect: [ :item |
                    item object = anObject ] ifNone: [ nil ]) notNil ] ifNone: [ nil ].
            node isNil ifFalse: [
                node expandTo.
                self updateListBox: false.
                self selectIndex: (self indexOf: anObject)
            ].
         ].!  
setHExtent: pixelWidth

        "Private - Sets the width in pixels by which a list box can be
        scrolled horizontally.

        We added this since ST/V 1.1 does not have it."

    self isHandleOk  ifTrue:[
            UserLibrary
                sendMessage: self handle
                msg: LbSethorizontalextent
                wparam: pixelWidth
                lparam: 0
    ]  ifFalse:[
            horizontalExtent := pixelWidth
    ].! 
updateItemSizes

    "Private"

    self isHandleOk ifTrue: [
        self setHExtent: self maxDisplayWidth.
        self insertBlankItems.
    ].!
updateListBox: retainScrolling

    "Private
    Touched by Ale for cursor changing"

    | firstVis |
    #modifiedByOStyle.
  CursorManager execute changeFor: [
    list := self flatList.
    firstVis := self getTopIndex.

    self updateItemSizes.

    self isHandleOk ifTrue: [
        retainScrolling ifTrue: [
            self setTopIndex: firstVis.
        ] ifFalse: [
            self
                invalidateRect: nil;
                updateWindow.
        ].
    ].
  ].!
validate

    "Private - avoid superclassing above, since it does a contents:"
    self font: curFont.

    (self isHandleOk and: [ self isVisible not]) ifTrue:[
        self showWindow
    ].

    curFont isNil ifTrue: [
        self font: self defaultFont
    ] ifFalse: [
        self font: curFont
    ].

    self updateListBox: false.

     value notNil  ifTrue: [
        self selectIndex: value
    ].! 
wmChar: wordInteger with: longInteger

    "Private"

    | char name curIndex selectedIndex |

    wordInteger = ReturnKey ifTrue: [
        self event: #doubleClickSelect.
        self expandOrCollapse.
        ^nil
    ].

    char := wordInteger asCharacter asUpperCase.

    (selectedIndex := self selectedIndex) isNil ifTrue: [
        curIndex := 0.
    ] ifFalse: [
        name := (list at: selectedIndex) listString.
        ((name size > 0)  and: [ name first asUpperCase = char  ]) ifTrue: [
            curIndex := selectedIndex.
        ] ifFalse: [
            curIndex := 0.
        ].
    ].

    curIndex + 1 to: list size do: [ :i |
        name := (list at: i) listString.
        ((name size > 0)  and: [ name first asUpperCase = char  ]) ifTrue: [
            self selectIndex: i.
            self event: #select.
            ^nil
        ].
    ].

    1 to: curIndex do: [ :i |
        name := (list at: i) listString.
        ((name size > 0)  and: [ name first asUpperCase = char  ]) ifTrue: [
            self selectIndex: i.
            self event: #select.
            ^nil
        ].
    ].! !

! OSHierarchicalListBox methods ! 
childrenBlock: aBlock
    "Sets the block to be evaluated for geting children of
     the receiuver's elements...
    aBlock must be a one-parameter block
    and must return acollection of children objects"

    self childrenMethod: aBlock.!  
contents: aList

    (aList isKindOf: OrderedCollection) ifFalse: [
        objectList := OrderedCollection with: (
            OSTreeNode new object: aList owner: self parent: nil
        ).
    ] ifTrue: [
        objectList := aList collect: [ :object |
            OSTreeNode new object: object owner: self parent: nil
        ].
    ].

    self updateListBox: false.! 
copySpecificsTo: aPane

    super copySpecificsTo: aPane.
    aPane indentWidth: self indentWidth.!
iconBlock: aBlock
    "Sets the block to be evaluated for geting icons of
     the receiuver's elements...
    aBlock must be a one-parameter block
    and must return anIcon or aBitmap"

    self iconMethod: aBlock.!   
indentWidth
    "Returns the instance var of the receiver
     for external manipulation"
    ^indentWidth!
indentWidth: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    indentWidth := anObject!   
nameBlock: aBlock
    "Sets the block to be evaluated for geting names of
     the receiuver's elements...
    aBlock must be a one-parameter block
    and must return aString"

    self nameMethod: aBlock.! !

! DrawListPane methods !   
drawItem: aDrawStruct

    "Private - Draw the requested control item.
    Implemented by XAVA..."

    | backColor foreColor |

    #addedByOStyle.
    userDrawn := aDrawStruct.

    aDrawStruct itemState & OdsSelected = OdsSelected ifTrue:[
        backColor := UserLibrary getSysColor: ColorHighlight.
        foreColor := UserLibrary getSysColor: ColorHighlighttext.
    ] ifFalse: [
        backColor := self backColor.
        foreColor := self foreColor.
    ].

    graphicsTool
        fill: self drawBox color:  backColor;
        backColor: backColor;
        foreColor: foreColor.

    (self event: #drawItem) notNil
        ifTrue: [ "no default drawing"  ^self].

    ^super drawItem: aDrawStruct! 
highlight: drawStruct

    "Mask out behavior in ControlPane - we do our own highlighting in drawItem: method.
    Implemented by XAVA..."
    #addedByOStyle.
    self drawItem: drawStruct! !

! OSListPane class methods !  
initialize
    "Private - Initializes the receiver"

    super initialize .
    Smalltalk at: #DrageableListPane put: OSListPane. "set class alias..."!   
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #beginDrag;
        add: #drag;
        add: #endDrag;
        yourself! !

! OSListPane methods !   
button1Down: aPoint
    "Private - Process the drag move message"

    (super button1Down: aPoint) ifFalse:[^ self].
    self captureMouseInput.

    server beginDrag.
    self event: #beginDrag.!   
button1Move: aPoint
    "Private - Left button is down and the mouse has been moved.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    server drag.
    self event: #drag.!   
button1Up: aPoint
    "Private - Left button has been released.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    self clearMouseCapture.

    server endDrag.
    self event: #endDrag.!   
dragAndDropServer
    "Returns the current drag & drop server"
    ^server! 
dragAndDropServer: aServer
    "Sets the current drag & drop server"
    server := aServer! 
draggedObject
    "Returns the currently selected object"
    | item |
    (item := self draggedObjectFromOwner) isNil ifFalse: [^item].
    ^self selectedItem!  
draggedObjectFromOwner
    "Private - Returns the currently selected object
     provided by the owner.
    Or nil..."
    | model |

    model := self owner.
    (model respondsTo: #draggedObjectIn:)
    ifTrue: [ "the model wants to provide the proper object to drag"
        ^model draggedObjectIn: self
    ].
    ^nil!
drawItem: aDrawStruct

    "Private - Draw the requested control item.
    Implemented by XAVA for owner drawing support..."

    | backColor foreColor |

    #addedByOStyle.
    userDrawn := aDrawStruct.

    aDrawStruct itemState & OdsSelected = OdsSelected ifTrue:[
        backColor := UserLibrary getSysColor: ColorHighlight.
        foreColor := UserLibrary getSysColor: ColorHighlighttext.
    ] ifFalse: [
        backColor := self backColor.
        foreColor := self foreColor.
    ].

    graphicsTool
        fill: self drawBox color:  backColor;
        backColor: backColor;
        foreColor: foreColor.

    (self event: #drawItem) notNil
        ifTrue: [ "no default drawing"  ^self].

    ^super drawItem: aDrawStruct!   
highlight: drawStruct

    "Mask out behavior in ControlPane - we do our own highlighting in drawItem: method.
    Implemented by XAVA for owner drawing support..."
    #addedByOStyle.
    self drawItem: drawStruct!  
initialize
    "Private - Initializes the receiver"

    super initialize.
    server := DragAndDropServer for: self! 
insertItem: aString
    "Insert a list item into the receiver."
    list add: aString.
    handle = NullHandle
        ifFalse: [ self insertItemInControl: aString ]!
removeSelection
    "Remove currently selected objects..."
    | copy toRemove |
    copy := self contents asOrderedCollection.
    toRemove := self selection.
    toRemove isNil ifTrue: [^nil].
    copy remove: (copy at: self selection) ifAbsent: [^nil].
    self contents: copy!   
wmMousemove: wParam with: lParam
        "Private - Process mouse move message."
    super wmMousemove: wParam with: lParam.
    ^1! !

! DrageableEdit methods !
contents
    "LRP Es un ListPane que solo contiene elemento"
    ^super selection!  
contents: anObject
    "LRP Es un ListPane que solo contiene elemento"
    anObject isNil ifTrue: [^super contents: (Array with: String new)].
    ^super contents: (Array with: anObject); selection: anObject.!  
loosingFocus
    "LRP si se desactiva tiene que deseleccionarse"
    ^self restore! 
wmKillfocus: wordInteger with: longInteger
        "Private - Process the kill focus message."

    "LRP si se desactiva tiene que deseleccionarse"
    self selection: nil.
    ^super wmKillfocus: wordInteger with: longInteger! !

! MultipleSelectListPane methods !  
asyncControlEvent: anEvent
    "Private - Process single and double selections.
    Who touched this method? why?"
    #modifiedByOStyle.

    anEvent= LbnSelchange
        ifTrue: [ "do nothing if a double click queued"
            (CurrentEvents
                detect: [:msg | msg selector = #asyncControlEvent:
                    and: [msg arguments size = 1
                    and: [(msg arguments at: 1) = LbnDblclk]]]
                ifNone: [nil])    "do nothing if a double click queued"
                    notNil ifTrue: [^self].

            ( self commitSelection )
                ifTrue: [
                    tempSelection := self selections.
                    self event: #select]
                ifFalse: [   "restore old selections"
                    self selection: tempSelection].
            ^nil].

    anEvent = LbnDblclk
        ifTrue: [
            self event: #doubleClickSelect.
            ^nil ]!
basicStyle
        "Private - Answer the default style for multiple selection.
    Who touched this method? why?"
    #modifiedByOStyle.
    ^style := super basicStyle  | LbsMultiplesel   | LbsExtendedsel! 
findLineMatching: aString
    "Private - This method is implemented for incremental
     search in the receiver.
    Inhibit incremental search in multiple lists.
    Implemented by Ale..."
    #addedByOStyle.
    ^nil! 
getSelection
    "Private - Answer the collection of selections.
    Who touched this method? why?"
    | count struct |
    #modifiedByOStyle.
    self isHandleOk ifFalse: [^Array new].
    count := ( WinStructure fromBytes:
        ( UserLibrary
            sendMessage: handle
            msg: LbGetselcount
            wparam: 0
            lparam: 0 ) ) shortAtOffset: 0.
    count = LbErr ifTrue: [ ^Array new ].
    struct := WinStructure new: count * 2.
    count := ( WinStructure fromBytes:
        ( UserLibrary
            sendMessage: handle
            msg: LbGetselitems
            wparam: count
            lparamStruct: struct asParameter ) ) shortAtOffset: 0.
    value := OrderedCollection new: count.
    1 to: count do: [ : i |
        value add:
            ( struct shortAtOffset: (i - 1) * 2 ) + 1 ].
    ^value! 
selectedItems
    "Answer a collection of the selected items..
    Who touched this method? why?"
    #modifiedByOStyle.
    (self selections) isNil
        ifTrue: [^nil]
        ifFalse: [^self selections collect: [:each |
            list at: each]]!  
selection
    "Answer the index of the first item selected. Index starts at 1.
    Who touched this method? why?"
    | values |
    #modifiedByOStyle.
    values := self getSelection.
    values size = 0 ifTrue: [^nil].
    ^values first!
selection: anObj
        "If anObj is a collection then select items whose indices
         are in anObj.
         If anObj is nil then unselect all items.
         If anObj is Integer then select the item indexed by anObj.
         Otherwise, select anObj in the list.
    Who touched this method? why?"
    #modifiedByOStyle.
    anObj size > 0
        ifTrue: [
            self noRedraw: true.
            anObj do: [ :i | self selectIndex: i ].
            self noRedraw: false ]
        ifFalse: [super selection: anObj]!  
selections
        "Answer indices of the items selected.
    Who touched this method? why?"
    #modifiedByOStyle.
    value := self getSelection.
    value isNil ifTrue: [ ^Array new ].
    ^value! 
selectIndex: itemIndex
        "Private - Select the item at itemIndex. Index starts at 1.
    Who touched this method? why?"
    | index selectFlag |
    #modifiedByOStyle.
    value isNil ifTrue:[ value := OrderedCollection new].
    (value includes: itemIndex) ifFalse:[
        value add: itemIndex].
    self isHandleOk ifFalse: [^self].
    (itemIndex isNil or: [itemIndex < 1 or: [itemIndex > list size]])
        ifTrue: [index := 65535.
            selectFlag := 0]
        ifFalse: [index := itemIndex - 1.
            selectFlag := 1].
    UserLibrary sendMessage: handle
            msg: LbSetsel
            wparam: selectFlag
            lparam: index!   
unSelectIndex: itemIndex
        "Private - Remove the selection of the item
         at itemIndex. Index starts at 1.
    Who touched this method? why?"
    | index |
    #modifiedByOStyle.
    self isHandleOk ifFalse: [^self].
    (itemIndex isNil or: [itemIndex < 1 or: [itemIndex > list size]])
        ifTrue: [index := 65535]
        ifFalse: [index := itemIndex - 1].
    UserLibrary sendMessage: handle
            msg: LbSetsel
            wparam: 0
            lparam: index!
validate
    "Private - Validate the control.
    Who touched this method? why?"

    #modifiedByOStyle.
    self font: curFont.
    list isNil ifFalse: [
        self contents: list.
        value size > 0
            ifTrue: [
                self noRedraw: true.
                value do: [ :i | self selectIndex: i ].
                self noRedraw: false ].
    ]! !

! MultipleSelectListBox methods !  
selections
        "Answer indices of the items selected.
    Touched by Ale for settign value to nil when invalid..."
    self isHandleOk
    ifTrue: [ value := self getSelection ]
    ifFalse: [ value := nil. #modifiedByOS ].
    value isNil ifTrue: [ ^OrderedCollection new ].
    ^value!
validate
    "Private - Validate the control.
     Touched by LRP for font setting..."
    #modifiedByOStyle.

    self font: curFont.
    list isNil ifFalse: [
        self contents: list.
        value size > 0
            ifTrue: [
                self noRedraw: true.
                value do: [ :i | self selectIndex: i ].
                self noRedraw: false ].
    ]! !

! MultipleSelectDrageableListBox class methods ! 
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #beginDrag;
        add: #drag;
        add: #endDrag;
        yourself! !

! MultipleSelectDrageableListBox methods !   
button1Down: aPoint
    "Private - Process the drag move message"

    (super button1Down: aPoint) ifFalse:[^ self].
    self captureMouseInput.

    server beginDrag.
    self event: #beginDrag.!   
button1DownShift: aPoint
    "Private - Process the drag move message"

    self button1Down: aPoint!  
button1Move: aPoint
    "Private - Left button is down and the mouse has been moved.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    server drag.
    self event: #drag.!   
button1Up: aPoint
    "Private - Left button has been released.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    self clearMouseCapture.

    server endDrag.
    self event: #endDrag.!   
dragAndDropServer
    "Returns the current drag & drop server"
    ^server! 
dragAndDropServer: aServer
    "Sets the current drag & drop server"
    server := aServer! 
draggedObject
    "Returns the currently selected object"
    | items |
    (items := self draggedObjectFromOwner) size = 0 ifFalse: [^items].
    items := self selectedItems.
    ^items size = 1
    ifTrue: [items first]
    ifFalse: [items]!
draggedObjectFromOwner
    "Private - Returns the currently selected object
     provided by the owner.
    Or nil..."
    | model |

    model := self owner.
    (model respondsTo: #draggedObjectIn:)
    ifTrue: [ "the model wants to provide the proper object to drag"
        ^model draggedObjectIn: self
    ].
    ^nil!
initialize
    "Private - Initializes the receiver"
    super initialize.
    server := DragAndDropServer for: self!   
insertItem: aString
    "Insert a list item into the receiver."
    list add: aString.
    handle = NullHandle
        ifFalse: [ self insertItemInControl: aString ]!
isMultipleSelection
    "Private - For drag&drop protocoll..."
    ^self numberOfItemsSelected > 1! 
numberOfItemsSelected
    "Private - Answer the number of selected items."
    | count |
    self isHandleOk ifFalse: [^0].
    count := ( WinStructure fromBytes:
        ( UserLibrary
            sendMessage: handle
            msg: LbGetselcount
            wparam: 0
            lparam: 0 ) ) shortAtOffset: 0.
    count = LbErr ifTrue: [ ^0 ].
    ^count!
removeSelection
    "Remove currently selected objects..."
    | copy toRemove |
    copy := self contents asOrderedCollection.
    toRemove := self selection.
    toRemove isNil ifTrue: [^nil].
    copy removeAll: (copy at: self selectedItems) ifAbsent: [^nil].
    self contents: copy!
wmMousemove: wParam with: lParam
        "Private - Process mouse move message."
    super wmMousemove: wParam with: lParam.
    ^1! !

! WBListBox class methods !  
supportedEvents
        "Answer the Set of events that ListBoxes can notify
         their owners about."
    ^super supportedEvents
        add: #commitSelection;
        add: #highlightItem;
        yourself! !

! WBListBox methods !   
commitSelection

    ^(self event: #commitSelection) ~= false!  
highlight: aDrawStruct

    | answer |

    userDrawn := aDrawStruct.
    (answer := self event: #highlightItem) notNil ifTrue: [
        ^self
    ].
    graphicsTool setHandle: ( aDrawStruct hDC );
        reverse: ( aDrawStruct boundingBox )!
selectIndex: anIndex

    "Digitalk ListBox didn't set tempSelection when selection
     manually set"

    tempSelection := anIndex.
    super selectIndex: anIndex.! !

! WBTreeListBox class methods ! 
isWBInternalClass

    ^true!   
new

    ^super new initialize.!
supportedEvents
        "Answer the Set of events that ListBoxes can notify
         their owners about."
    ^super supportedEvents
        add: #textChanged;
        add: #preSelect;
        yourself! !

! WBTreeListBox methods !   
asyncControlEvent: anEvent
        "Private - Process single and double selections."
    self selectedItem isNil ifTrue: [^nil].
    anEvent= LbnSelchange
        ifTrue: [ "do nothing if a double click queued"
            (CurrentEvents
                detect: [:msg | msg selector = #asyncControlEvent:
                    and: [msg arguments size = 1
                    and: [(msg arguments at: 1) = LbnDblclk]]]
                ifNone: [nil])    "do nothing if a double click queued"
                    notNil ifTrue: [^self].
            ( self commitSelection )
                ifTrue: [
                    tempSelection := self selectedItem.
                    previousSelection := self selection.
                    self setEditBox.
                    self event: #select. ^nil ].
                self selectItem: tempSelection. ^nil ].

    anEvent = LbnDblclk
        ifTrue: [ self event: #doubleClickSelect. ^nil ].!
basicSelectionText: newText

    |  r |

    self selectedItem title: newText.

    r := WinRectangle new.
    UserLibrary sendMessage: self asParameter
        msg: LbGetitemrect
        wparam: self selection - 1
        lparamStruct: r asParameter.

    self invalidateRect: r asRectangle
        erase: false;
        updateWindow.!
commitSelection

    noSelect ifTrue: [
        noSelect := false.
        ^true
    ].

    ^self event: #preSelect!  
contents: aTree

        "Set the receiver's contents to aCollection."
    list := aTree.
    handle = NullHandle
        ifFalse: [
            self noRedraw: true;
                deleteAll;
                insertArray: (list asFlatList collect: [ :i | i listString ]);
                noRedraw: false ].
    ^list!   
cr

    (self contents asFlatList size = self selection) ifTrue: [
        self insertAfterSelection.
    ] ifFalse: [
        self moveSelectionDown.
    ].!  
defaultStyle

    "Private"

   ^style := self basicStyle |
                WsBorder |
                WsVscroll |
                WsHscroll |
                LbsNotify  |
                LbsNointegralheight  |
                LbsOwnerdrawfixed!   
delete

    owningEditBox setFocus.
    self selectedItem delete isNil ifTrue: [
        ^nil
    ].

    (self contents asFlatList size = 0) ifTrue: [
        self contents: (
            self contents
                addChild: self itemType new;
                yourself
        ).
    ].!  
deleteAll
        "Private - Delete the whole list in the control.
         Subclassed by OSI to avoid anticipated later conflicts."

    self isHandleOk ifFalse: [^self].

    UserLibrary sendMessage: handle
        msg: LbResetcontent
        wparam: 0
        lparam: 0!
deleteSelection

    | contents |

    contents := self contents.
    owningEditBox setFocus.

    (contents asFlatList size = 1) ifTrue: [
        self contents: (
            contents
                removeChild: contents children first;
                addChild: self itemType new;
                yourself
        ).
        self wbSelectIndex: 1.
        ^self
    ].

    self performOnSelection: #delete
        selectionDelta: 0
        moveWithSelection: false.

    self selectedItem isNil ifTrue: [
        self wbSelectIndex: self contents asFlatList size.
    ].!  
drawItem: aDrawStruct

    "Private - Draw the requested control item."

    | backColor foreColor |

    userDrawn := aDrawStruct.


    aDrawStruct itemState & OdsSelected = OdsSelected ifTrue:[
        backColor := UserLibrary getSysColor: ColorHighlight.
        foreColor := UserLibrary getSysColor: ColorHighlighttext.
    ] ifFalse: [
        backColor := self backColor.
        foreColor := self foreColor.
    ].

    graphicsTool
        fill: self drawBox color:  backColor;
        backColor: backColor;
        foreColor: foreColor;
        setTextAlign: TaTop;
        displayText: (self flatList at: self drawIndex) listString at: self drawBox leftTop.!   
editBoxTextChanged

    self selectionText: owningEditBox contents.!
exdent

    self selectedItem exdent.
    owningEditBox setFocus.! 
exdentSelection

    self performOnSelection: #exdent
        selectionDelta: nil
        moveWithSelection: false.
    self setEditBox.
    self event: #select!   
flatList

    self drawIndex = self getTopIndex ifTrue: [
        cachedFlatList := list asFlatList.
    ].

    ^cachedFlatList!   
gettingFocus

    self handle isValid ifFalse: [ ^self ].

    owningEditBox notNil ifTrue: [
        owningEditBox  sendInputEvent: #setFocus.
    ].! 
highlight: drawStruct

    "Mask out behavior in ControlPane - we do our own highlighting in drawItem: method."
    self drawItem: drawStruct! 
indent

    self selectedItem indent.
    owningEditBox setFocus.! 
indentSelection

    self performOnSelection: #indent
        selectionDelta: nil
        moveWithSelection: false.
    self setEditBox.
    self event: #select!   
initialize

    super initialize.
    list := WBTreeNode new.
    noSelect := false.! 
insert

    | selection newNode |

    (selection := self selectedItem) notNil ifTrue: [
        newNode := self itemType new.
        selection insertNode:  newNode.
        newNode title: ''.
    ].
    owningEditBox setFocus.!
insertAfterSelection

    self performOnSelection: #insert
        selectionDelta: 1
        moveWithSelection: false!
itemType

    ^WBPMenuItem! 
moveDown

    self selectedItem moveDown.
    owningEditBox setFocus.! 
moveSelectionDown

    self commitSelection.
    self wbSelectIndex: ((self selection + 1) min:  list asFlatList size).
    owningEditBox setFocus.!  
moveSelectionUp

    self commitSelection.
    self wbSelectIndex: ((self selection - 1) max: 1).
    owningEditBox setFocus.!
moveUp

    self selectedItem moveUp.
    owningEditBox setFocus.! 
owningEditBox: aBox

    owningEditBox := aBox.!
performOnSelection: aSymbol  selectionDelta: delta  moveWithSelection: moveWithSelection

    |  oldPosition oldTopIndex positionDelta selection selectionIndex |

    (selection := self selectedItem) isNil ifTrue: [
        ^self
    ].

    self commitSelection.

    oldPosition := selection nonHierarchicalPosition.
    oldTopIndex := self getTopIndex.
    selectionIndex := self selection.


    (self perform: aSymbol) isNil ifTrue: [
        positionDelta := 0.  "Unsuccessful, therefore no delta"
    ] ifFalse: [
        (delta isNil) ifTrue: [
            positionDelta :=  selection nonHierarchicalPosition - oldPosition.
        ] ifFalse: [
            positionDelta := delta.
        ].
    ].

    self noRedraw: true.
    noSelect := moveWithSelection.
    self deleteAll.
    self insertArray: (list asFlatList collect: [ :i | i listString ]).
    self wbSelectIndex: ((selectionIndex + positionDelta max: 1) min: list asFlatList size).
    (moveWithSelection) ifTrue: [
        self setTopIndex: (oldTopIndex + positionDelta max: 1).
    ].
    self noRedraw: false.

    self invalidateRect: self rectangle.! 
previousSelection

    ^previousSelection!  
selectedItem

    ( self selection ) isNil   ifTrue: [
        ^nil
    ]  ifFalse: [
        ^list asFlatList at: value
    ]! 
selectionText: newText

    | selection |

    (selection := self selectedItem) notNil ifTrue: [
        self basicSelectionText: newText.
        self event: #textChanged.
    ].!   
selectIndex: itemIndex
        "Private - Select the item at itemIndex. Index starts at 1."
    | index |
    self isHandleOk ifFalse: [^self].
    itemIndex isNil
        ifTrue: [index := 65535]
        ifFalse: [index := itemIndex - 1].
    UserLibrary sendMessage: handle
            msg: LbSetcursel
            wparam: index
            lparam: 0!   
setEditBox


        owningEditBox setContents: (
            self selectedItem notNil ifTrue: [
                self selectedItem title
            ] ifFalse: [
                ''.
            ]
        ).
        owningEditBox selectAll.!
setSelectionText: newText

    self basicSelectionText: newText.
    self setEditBox.! 
shiftSelectionDown

    self performOnSelection: #moveDown
        selectionDelta: nil
        moveWithSelection: true.!  
shiftSelectionUp

    self performOnSelection: #moveUp
        selectionDelta: nil
        moveWithSelection: true.!  
usesFocus

    ^false!  
virtualKeyInput: aChar

    (Notifier isKeyDown: VkControl) ifTrue: [
        aChar = VkUp ifTrue: [     self shiftSelectionUp. ^nil ].
        aChar = VkDown ifTrue: [  self shiftSelectionDown.  ^nil ].
        aChar = VkLeft ifTrue: [     self exdentSelection.  ^nil ].
        aChar = VkRight ifTrue: [   self indentSelection.  ^nil ].
        aChar = VkBack ifTrue: [ self deleteSelection. ^nil ].
    ] ifFalse: [
        aChar = VkUp ifTrue: [ self moveSelectionUp. ^nil ].
        aChar = VkDown ifTrue: [ self moveSelectionDown. ^nil ].
    ].!   
wbSelectIndex: anIndex

    self selectIndex: anIndex.
    self event: #select.
    previousSelection := anIndex.
    self setEditBox.! !

! MDIClient methods !   
buildControl: parentWindow
        "Private - Create the Control for the receiver."
    (super buildControl: parentWindow) isNil ifTrue:[^nil].
    self receiveAllWindowMessages.!
buildWindow:parentWindow
        "Private - Build the MDI Client."
    |clientCreateStruct addrClassName addrStruct addrTitleName|
    style isNil ifTrue: [style := self frameStyle].
    clientCreateStruct:=WinClientCreateStruct new.
    clientCreateStruct hMenu:parentWindow menuWindow asParameter.
    clientCreateStruct idFirstChild:100.
    addrClassName:=WinAddress copyToNonSmalltalkMemory: self winClass asParameter.
    addrTitleName:=WinAddress copyToNonSmalltalkMemory: '' asParameter.
    addrStruct:=WinAddress copyToNonSmalltalkMemory: clientCreateStruct asParameter.
    handle:= WindowHandle fromInteger:
        (UserLibrary
            createWindow: addrClassName asParameter
            name: addrTitleName asParameter
            style: style
            x: 0
            y: 0
            width: 0
            height: 0
            parent: parentWindow asParameter
            menu: self id
            instance: self dsHandle
            param: addrStruct asParameter).

    addrStruct unlockAndFree.
    addrClassName unlockAndFree.
    addrTitleName unlockAndFree.
    UserLibrary setWindowWord:self parent asParameter index:0 word:self asParameter.
    self initGraphics.
    self receiveMessages.
    self buildControl: parentWindow!   
frameStyle
        "Private - Answer an Integer with appropriate styles in it."
    ^
    WsHscroll |
    WsVscroll |
    WsChild |
    WsClipsiblings |
    WsClipchildren | 1!   
isMDIClient
        "Answer true if receiver is an instance of class
         MDIChild, else answer false."

    ^true!   
selected
        "Private- An MDI document has been selected from the menu bar."
    MDISystem mdiSelected:true.!   
winClass
        "Private - Answer the Windows class for an MDIClient."
    ^'MDICLIENT'!   
wmCommand: wordInteger with: longInteger
        "Private - Process the command message."
    ^nil! 
wmMdiactivate: wordInteger with: longInteger
    "Private - for optimization only."
    |active|

    active:=self parent mdiGetActive.
    active isNil ifTrue:[^nil].
    self sendInputEvent:#selected.
    ^nil! !

! WBHorizontalScrollBar class methods !  
isWBInternalClass

    ^true! !

! WBVerticalScrollBar class methods !
isWBInternalClass

    ^true! !

! StaticPane methods !   
justified
    "This method was missing from the source code - or I didn't load it.
    4-III-94 - xava - Added."

    | justification |
    #addedByOStyle.
    (justification := self propertyAt: #justified) isNil
        ifTrue: [ justification := #left.
                    self propertyAt: #justified put: justification ].
    ^justification! !

! StaticText methods ! 
contents
    "Answer the String associated with this control.
     Touched by LRP...
    30/AGO/93 si contiene un objeto lo devuelve, sino devuelve el string.
    Touched By LRP..."
    #modifiedByOStyle.
    (self propertyAt: #contents) notNil ifTrue: [^self propertyAt: #contents].
    label notNil
        ifTrue:[ ^ label]
        ifFalse:[ ^String new].!  
contents: aString
    "Set the receiver's contents...
    Implemented by LRP..."
    #addedByOStyle.
    self propertyAt: #contents put: aString.
    ^super contents:
        (aString isNil ifTrue: [String new] ifFalse:[ aString])! 
isWsTabstop

    "Added by OSI - Allows static text and Groupboxes to
     be in tab order for WB, without adding to style bits."
    #addedByOSI.
    ^(self propertyAt: #tabStop) notNil!  
showHelp: aString
    "Added by OSI"
    #addedByOSI.
    self contents: aString!  
tabStop

    "Added by OSI - Allows static text and Groupboxes to
     be in tab order for WB, without adding to style bits."
    #addedByOSI.
    self propertyAt: #tabStop put: true! !

! StaticDate methods !  
contents
    "Answer the String associated with this control."
    ^(label notNil and: [label size >0] )
        ifTrue:[label asDate]
        ifFalse:[nil].!
contents: aDate
    "Sets the String associated with this control."
    (aDate isKindOf: Date)
    ifTrue: [^super contents: aDate formPrint].
    ^super contents: aDate!
winIniChange: aString
    "Update the receiver contents..."
    self update! !

! CPSubPane class methods !   
pObject

    ^self new! 
supportedEvents

    ^Set with: #getContents with: #getPopupMenu! !

! CPSubPane methods !
addSubpane: aWindow
        "Add aWindow as the child of the receiver."
    |id|

    "Different for version 1.x of ST/V"
    (Smalltalk version first = $1) ifTrue: [
        children isNil ifTrue: [
            children := IdentityDictionary new
        ].
        children at: self getNextChildId put: aWindow.
        aWindow parent: self.
        aWindow owner isNil ifTrue: [
            aWindow owner: self owner
        ].

        (self mainWindow respondsTo: #add:interestIn:) ifTrue: [
            self mainWindow add: aWindow interestIn: aWindow name.
        ].
        ^self
    ].

    children isNil ifTrue: [
        children := IdentityDictionary new].


    id := aWindow propertyAt:#id.
    id isNil ifTrue:[ aWindow propertyAt:#id put: self getNextChildId].
    "Check if duplicate 'idCancel' or 'idOK' message might have been sent to the childs of this window."
    children at: self getNextChildSlot put: aWindow.
    aWindow parent: self.
    aWindow owner isNil ifTrue: [
        aWindow owner: self owner].

    (self mainWindow propertyAt: #focusWindow) isNil & aWindow isWsTabstop ifTrue: [
        self mainWindow propertyAt: #focusWindow put: aWindow.
    ].

    (self mainWindow respondsTo: #add:interestIn:) ifTrue: [
        self mainWindow add: aWindow interestIn: aWindow name.
    ].!   
backColor

    | c |

    backColor11 notNil ifTrue: [
        ^backColor11
    ] ifFalse: [
        (self propertyAt: #backColor) notNil ifTrue: [
            ^self propertyAt: #backColor
        ] ifFalse: [
            ^self defaultBackColor
        ].
    ].!   
backColor: c

    "(SubPane basicNew respondsTo: #backColor:) ifTrue: ["
        super backColor: c.
    "] ifFalse: [
        backColor11 := c.
    ]."!   
copySpecificsTo: aPane!   
currentClipRect

    | clipbox |

    clipbox := WinRectangle new.
     (GDILibrary
            getClipBox: self pen handle
            rectangle: clipbox  asParameter).

    clipbox := clipbox asRectangle.

    ^clipbox!  
darkerColor

    ^ClrBlack! 
defaultBackColor

    ^self middleColor!
defaultForeColor

    ^UserLibrary getSysColor: ColorWindowframe!   
defaultStyle
        "Private - Answer an Integer with appropriate styles in it."
    ^WsChild   |
    WsVisible!  
disable
    "Disable the receiver.
    Touched by Ale for takin disable foreColor from Windows
    "
    self disabled ifTrue: [ ^self ].

    "Since Digitalk doesn't save the state of whether we're
      disabled before we're built, the test above could have failed, yielding
      no way to enable a cp subpane"
    self propertyAt: #disabled put: true.

    self propertyAt: #holdForeColor put: self foreColor.
    #modifiedByOStyle.
    self foreColor: "ClrDarkgray  Ale patch"
        (UserLibrary getSysColor: ColorGraytext).
    super disable.
    self invalidateRect: nil.! 
disabled

    "Since Digitalk doesn't save the state of whether we're
      disabled before we're built, the test above could have failed, yielding
      no way to enable a cp subpane"

    ^(self propertyAt: #disabled) notNil! 
display

    self displayWith: self pen inRect: self rect clipRect: self rect!  
displayWith: aPen inRect: aRect

    aPen rectangle: aRect;
        place: aRect center;
        centerText: self class name.!
displayWith: aPen inRect: r clipRect: cr

    self displayWith: aPen inRect: r! 
drawFocusRect: r

    self pen notNil ifTrue: [
        self pen
            foreColor: ClrBlack;
            drawFocusRect: r
    ].!  
enable

    "Since Digitalk doesn't save the state of whether we're
      disabled before we're built, the test above could have failed, yielding
      no way to enable a cp subpane"

    "Added test to avoid blinkiness."
    self disabled ifFalse: [ ^self ].

    self propertyAt: #disabled put: nil.


    self foreColor: (self propertyAt: #holdForeColor).
    super enable.
    self invalidateRect: nil.! 
font

    | font |

    (font := super font) isNil ifTrue: [
        ^self defaultFont
    ] ifFalse: [
        ^font
    ].! 
foreColor

    | c |

    foreColor11 notNil ifTrue: [
        ^foreColor11
    ] ifFalse: [
        (self propertyAt: #foreColor) notNil ifTrue: [
            ^self propertyAt: #foreColor
        ] ifFalse: [
            ^self defaultForeColor
        ].
    ].!   
foreColor: c

    "(SubPane basicNew respondsTo: #foreColor:) ifTrue: ["
        super foreColor: c.
    "] ifFalse: [
        foreColor11 := c.
    ]."!   
getGraphicsTool
        "We use a pen here, not a textTool"

    ^graphicsTool := Pen forDC: nil medium: self.!
initialize

    super initialize.!  
inWindowBuilder

    ^rectangle leftTop ~= (0@0)!   
lighterColor

    ^ClrWhite!
losingFocus

    graphicsTool notNil
        ifTrue: [ graphicsTool release]!  
middleColor

    ^ClrPalegray!  
mouseLocation

    ^Cursor offset mapToWindow: self.!   
open

    "Private"

    self event: #getContents.
    super open.!  
propertyAt: p

    properties11 isNil ifFalse: [
        ^properties11 at: p ifAbsent: [ nil ]
    ].

    ^nil!
propertyAt: p put: v

    properties11 isNil ifTrue: [
        properties11 := Dictionary new.
    ].

    v isNil ifTrue: [
        properties11 removeKey: p ifAbsent: [ ].
    ] ifFalse: [
        properties11 at: p put: v.
    ].!   
readSpecificsFrom: aPane

    aPane copySpecificsTo: self.! 
rect

    ^0@0 extent: self extent! 
rectanglePrivate: aRect

    rectangle := aRect.!   
reframe!  
reframeIfNeeded: r

    rectangle = r ifFalse: [
        rectangle := r.
        self reframe.
    ].
    rectangle := r.!  
updateRectangle

    | r |

    super updateRectangle.
    r := self rectangle.
    (r height = 0) | (r width = 0) ifFalse: [
        self reframe.
    ].!   
updateSliders!
validate

    super validate.
    graphicsTool notNil
        ifTrue: [graphicsTool release]! 
virtualKeyInput: anInt  withKeys: keyArray!   
whileMouseStillDown: aBlock

    self captureMouseInput.
    UserLibrary
        setTimer: self handle
        idEvent: nil
        elapsedTime: 50
        timerFunc: nil.
    Notifier consumeInputUntil: [:event |
        aBlock value.
        (Notifier isKeyDown: VkLbutton) not & (Notifier isKeyDown: VkRbutton) not.
    ].
  UserLibrary
        killTimer: self handle
        idEvent: nil.
    self clearMouseCapture.!  
winClass

    | className wndClass lptr answer |

    className := 'CPSub'.
    wndClass := WinWindowClass new.
    answer := UserLibrary getClassInfo: WIN hInstanceExe
        className: className asParameter
        wndClass: wndClass asParameter.
    answer ifTrue:[^className].
    UserLibrary getClassInfo: WIN hInstanceExe
        className: 'VWIN' asParameter
        wndClass: wndClass asParameter.
    wndClass style: (CsOwndc | CsDblclks | CsVredraw | CsHredraw);
        className: (lptr := WinAddress
            copyToNonSmalltalkMemory: className asAsciiZ) asParameter.
    UserLibrary registerClass: wndClass asParameter.
    lptr unlock; free.
   ^className!  
wmErasebkgnd: wordInteger with: longInteger

    ^1!
wmGetdlgcode: wparam with: lparam
        "Private - process WM_GETDLGCODE message."
    ^DlgcWantarrows | DlgcWantchars!   
wmTimer: wordInteger with: longInteger
        "Private - Process the timer message."
    self
        sendMouseMoveInputEvent: #button1Move:
        with: self cursorWindowPosition.
    ^nil! !

! CP3DFrame methods !  
contents

    ^contents!
contents: s

    | r |

    contents := s.

    self handle isValid ifTrue: [
        r := self rectangle.
        self invalidateRect: (r leftTop extentFromLeftTop: r extent x @ (self font height + 10)).
    ].! 
copySpecificsTo: aPane

    aPane style3D: style3D! 
cpStyle

    ^style3D!  
displayWith: pen inRect: r

    "Tocado por Ale para efecto 3D en texto"

    | rect inRect |

    rect := r leftTop extent: self extent.

    style3D == #outline ifFalse: [
        pen
            drawRect3D: (rect expandBy: 1) depth: 2 style: style3D;
            foreColor: self foreColor.
        drawBorder = true ifTrue: [
            pen drawRectangle: rect.
        ].
    ] ifTrue: [
        contents isNil | (contents = '') ifTrue: [
            pen
                fill: (rect leftTop extent: rect width @ self font height) color: self backColor;
                drawRect3D: rect depth: 2 style: style3D.

        ] ifFalse: [
    #modifiedByOS.
            pen
                fill: (rect leftTop extent: rect width @ self font height) color: self backColor;
                drawRect3D: (inRect := rect leftTop + (0@(self font height // 2)) corner: rect corner) depth: 2 style: style3D;
                fill: (rect leftTop + (8@0) extent: ((self font stringExtent: contents stripMnemonic) x + 4) @ self font height) color: self backColor;
                setBackMode: Transparent;
                setTextAlign: TaTop;
           "Tocado por Ale para efecto 3D"
                foreColor: ClrWhite;
                winDrawText: contents at: rect leftTop + (11 @ 1);
            "Fin Ale."
                foreColor: self foreColor;
                winDrawText: contents at: rect leftTop + (10 @ 0).
        ].
    ].!  
drawBorder: bool

    drawBorder := bool!   
generateTabStopsAndGroups

    "Allow our 3D frames to act like standard MS ones.  Don't
     generate the WsTabstop flag if this control is in the focus order."

    ^false!   
in

    style3D := #in.!
initialize

    super initialize.
    style3D := #outline.!
mutationTypes

    ^#(GroupBox CP3DFrame StaticBox)!
out

    style3D := #out.!  
outline

    style3D := #outline.!  
staysToBack

    ^true! 
style3D: s

    style3D := s!   
styles

    ^#(outline in out)! 
usesFocus

    ^true!   
usesMenu

    ^false!   
usesTitle

    ^style3D == #outline!
wmGetdlgcode: wParam with: lParam

    "Added to support keyboard mnemonic doing set selection to next field."
    ^DlgcStatic!
wmGettext: wparam with: lparam

    "Added to provide support for keyboard mnemonics"

    |  address string struct |

    address := WinAddress new
        highHalf: ( lparam // 65536 );
        lowHalf: ( lparam \\ 65536 );
        yourself.

    self contents notNil ifTrue: [
        string := self contents
            copyFrom: 1
            to: (wparam min: self contents size + 1) - 1.
    ] ifFalse: [
        string := ''
    ].

    struct := WinStructure new: wparam.
    struct contents: string asAsciiZ.
    struct copyToAddress: address.

    ^string size!
wmNchittest: wParam with: lParam
        "Private - allow overlapping panes to get mouse input"
  ^  -1  "HtTransparent"! !

! CPBitmapButton class methods ! 
supportedEvents

    ^super supportedEvents
        add: #clicked;
        yourself! !

! CPBitmapButton methods !  
attributeEditor

    ^(Smalltalk at: #WB2BitmapPicker) new! 
bitmap

    ^picture!   
bitmap: bmap

    picture := bmap.! 
button1DoubleClick: point

    self button1Down: point.!
button1Down: point

    | highlighted |

    self setFocus.

    self press.
    highlighted := true.

    self whileMouseStillDown: [
        (self rect containsPoint: self mouseLocation) ifTrue: [
            highlighted ifFalse: [
                self highlight.
                highlighted := true.
            ]
        ] ifFalse: [
            highlighted ifTrue: [
                self unHighlight.
                highlighted := false.
            ]
        ]
    ].
    highlighted ifTrue: [ self releaseButton ].! 
changesSize

    ^true! 
characterInput: c

    c = $  ifTrue: [
        self press.
    ].!   
contents

    ^title!   
contents: aString

    title := aString.

    title = '' ifTrue: [ title := nil ].!   
copySpecificsTo: aPane

    aPane
        bitmap: self bitmap;
        onBitmap: self onBitmap.!  
defaultFont
        "Private - Answer the default font for the control."
    ^(Font fromFont: ButtonFont)!  
displayWith: pen inRect: r clipRect: cRect

    | startY titleExtent space rect region |

    rect := self rect translateBy: r leftTop.

    pen
        foreColor: self foreColor;
        drawRectangle: rect;
        drawRect3D: rect depth: 2 style: #out;
        fill: (rect insetBy: 3) color: self backColor;
        foreColor: self foreColor;
        backColor: self backColor.

    region := pen setClipRect: ((rect insetBy: 3) intersect: cRect).

    title isNil ifTrue: [
        picture isNil ifFalse: [
            picture displayAt: (self extent - picture extent) // 2 + rect leftTop with: pen.
        ].
    ] ifFalse: [

        titleExtent := self font stringExtent: title.
        titleExtent x: (self font wbStringWidth: title).
        pen setTextAlign: TaTop.
        picture isNil ifTrue: [
            self drawTitle: title at: (self extent - titleExtent) // 2 + rect leftTop with: pen
        ] ifFalse: [
            space := self space.

            startY := (((self height - (picture height + space + titleExtent y)) // 2) max: 2) + rect top.

            self drawTitle: title at: (self width - titleExtent x // 2 + rect left) @ (startY + picture height + space) with: pen.

            picture displayAt: (self width - picture width // 2 + rect left) @ startY with: pen.
        ].
    ].

    self haveFocus & self pen notNil ifTrue: [
        self drawFocusRect.
    ].

    pen destroyRegion: region.!  
drawFocusRect

    | r e titleExtent space pictureHeight  |

    title isNil ifTrue: [
        picture isNil ifTrue: [
            r := self rect insetBy: 6.
        ] ifFalse: [
            r := (self extent - picture extent) // 2 + self rect leftTop extent: picture extent.
        ].
    ] ifFalse: [
        titleExtent := self font stringExtent: title.
        picture isNil ifTrue: [
            pictureHeight := space := 0.
        ] ifFalse: [
            pictureHeight := picture height.
            space := self space.
        ].
        r := ((self width - titleExtent x // 2) @ ((self height - (pictureHeight + space + titleExtent y) // 2) + pictureHeight + space)) + self rect leftTop extent: titleExtent.
    ].
    self drawFocusRect: (r expandBy: 1).!  
drawTitle: t at: aPoint with: pen

    pen
        font: self font;
        winDrawText: t at: aPoint.!   
gettingFocus

    self drawFocusRect!   
highlight

    | holdPicture |

    self pen drawRect3D: self rect depth: 2 style: #in.

    onPicture isNil ifFalse: [
        holdPicture := picture.
        picture := onPicture.
        self
            invalidateRect: (self rect insetBy: 3);
            updateWindow.
        picture := holdPicture.
    ].! 
initialize

    pressed := false.
    super initialize.!   
isGroupable

    ^true! 
losingFocus

    self drawFocusRect.
    super losingFocus.!   
mutateSpecificsFrom: aPane

    (aPane respondsTo: #bitmap) ifTrue: [
        self bitmap: aPane bitmap
    ].
    (aPane respondsTo: #onBitmap) ifTrue: [
        self onBitmap: aPane onBitmap
    ].!   
mutationExceptions

    ^#(Toggle CPHorizontalPictureButton)!   
mutationTypes

    ^#(Button CPBitmapButton)!   
onBitmap

    ^onPicture!   
onBitmap: bmap

    onPicture := bmap.! 
press

    pressed := true.
    self highlight.!   
releaseButton

    pressed := false.
    self unHighlight.
    self event: #clicked.! 
space

    ^5!  
storeSpecificsOn: aStream indentString: indentString

    | key |

    (key := CPBitmapDict keyAtValue: self bitmap ifAbsent: [ nil ]) notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'bitmap: (CPBitmapDict at: ', key asQuotedString, ')'.
    ].

    (key := CPBitmapDict keyAtValue: self onBitmap ifAbsent: [ nil ]) notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'onBitmap: (CPBitmapDict at: ', key asQuotedString, ')'.
    ].!
suggestedSize

    | stringExtent |

    picture isNil ifTrue: [
        ^(self font stringExtent: title) + 10
    ] ifFalse: [
        title isNil ifTrue: [
            ^picture extent + 5
        ] ifFalse: [
            stringExtent := (self font stringExtent: title).
            ^((stringExtent x max: picture width) @ (stringExtent y + self space + picture height)) + 5
        ].
    ].!   
unHighlight

    self pen drawRect3D: self rect depth: 2 style: #out.

    onPicture isNil ifFalse: [
        self
            invalidateRect: (self rect insetBy: 3);
            updateWindow.
    ].!  
usesTitle

    ^true!   
wmGetdlgcode: wParam with: lParam

    "This is done to allow us to press the button.
    self haveFocus ifTrue: [
        ^super wmGetdlgcode: wParam with: lParam
    ].                                    "

    ^DlgcButton!  
wmGettext: wparam with: lparam

    |  address string struct |

    address := WinAddress new
        highHalf: ( lparam // 65536 );
        lowHalf: ( lparam \\ 65536 );
        yourself.

    self contents notNil ifTrue: [
        string := self contents
            copyFrom: 1
            to: (wparam min: self contents size + 1) - 1.
    ] ifFalse: [
        string := ''
    ].

    struct := WinStructure new: wparam.
    struct contents: string asAsciiZ.
    struct copyToAddress: address.

    ^string size! 
wmKeydown: wordInteger with: longInteger

    | char |

    char := KeyboardLibrary
        mapVirtualKey: wordInteger
        mapType: 2.

    (char = 32) ifTrue: [
        self press.
    ].

    ^nil!   
wmKeyup: wordInteger with: longInteger

    pressed ifTrue: [
        self releaseButton.
    ].
    ^nil!   
wmUser99: wparam with: lparam

    self
        press;
        releaseButton.

    ^nil! !

! CPBitmapToggle methods !
displayWith: pen inRect: r clipRect: clipRect

    | holdPicture |

    onPicture notNil ifTrue: [
        holdPicture := picture.
        value ifTrue: [
            picture     := onPicture.
        ].
        super displayWith: pen inRect: r clipRect: clipRect.
        picture := holdPicture.
    ] ifFalse: [
        super displayWith: pen inRect: r clipRect: clipRect.
        value ifTrue: [
            pen reverse: ((self rect translateBy: r leftTop) insetBy: 3).
        ].
    ].!   
drawFocusRect

    | holdPicture |

    holdPicture := picture.
    onPicture notNil & value ifTrue: [
        picture     := onPicture.
    ].
    super drawFocusRect.
    picture := holdPicture.!
highlight

    self pen drawRect3D: self rect depth: 2 style: #in!  
initialize

    super initialize.
    value := false.! 
releaseButton

    value := value not.
    self display.
    super releaseButton.!
selection

    ^value!  
selection: boolean

    (value = boolean) ifTrue: [^self].

    value := boolean.

    self handle isValid & self pen notNil ifFalse: [ ^self ].

    self haveFocus ifTrue: [
        self display.
    ] ifFalse: [
        self doGraphics: [ self display ].
    ].!  
unHighlight

    self pen drawRect3D: self rect depth: 2 style: #out.! !

! CPHorizontalPictureButton methods !   
defaultBackColor

    ^UserLibrary getSysColor: ColorWindow!
displayPicture: pen inRect: r

    picture isNil ifTrue: [ ^self ].

    value ifTrue: [
        onPicture displayAt: r left @(self height - onPicture height // 2 + r top) with: pen.
    ] ifFalse: [
        picture displayAt: r left @(self height - picture height // 2 + r top) with: pen.
    ].! 
displayWith: pen inRect: r  clipRect: clipRect

            "Tocado por Ale para efecto 3D"

    | stringOrigin |

    (self backColor = self defaultBackColor) & parent notNil ifTrue: [
        pen fill: r color: parent cpBackColor.
    ] ifFalse: [
        pen fill: r color: self  backColor.
    ].

    title notNil ifTrue: [
        stringOrigin := (r left + self pictureWidth + self space) @ (r top + (self height - self font height // 2)).
        pen
            setTextAlign: TaTop;
            foreColor: self foreColor;
            backColor: self backColor;
            setBackMode: Transparent;
           "Tocado por Ale para efecto 3D"
                foreColor: (ColorConstants at: 'ClrWhite');
                displayText: title at: stringOrigin + 1;
                foreColor: self foreColor;
               displayText: title at: stringOrigin.
    #modifiedByOS.
    ].

    self displayPicture: pen inRect: r.

    self haveFocus ifTrue: [
        self drawFocusRect.
    ].! 
drawFocusRect

    | stringOrigin |

        title isNil ifTrue: [
            self drawFocusRect: self rect.
        ] ifFalse: [
            stringOrigin := self rect leftTop + ((self pictureWidth + self space) @ (self height - self font height // 2)).
            self drawFocusRect: ((stringOrigin extent: (self font stringExtent: title)) expandBy: 1).
        ].! 
highlight

    | buttonRect |

    highlighted ifFalse: [
        highlighted := true.
        buttonRect := (0 @ (self height - picture height // 2) extent: picture extent).
        self pen
            reverse: (buttonRect insetBy: 1)
    ].! 
initialize

    "Touched by Ale for suport of bitmaps in normal CPBitmapDict"

    super initialize.
    highlighted := false.

    #modifiedByOStyle.
    picture := CPBitmapDict at: 'checkBox' ifAbsent: [CPBitmapDict sysAt: 'checkBox'].
    onPicture := CPBitmapDict at: 'checkBoxOn' ifAbsent: [CPBitmapDict sysAt: 'checkBoxOn'].!  
mutateSpecificsFrom: aPane!   
pictureWidth

    picture notNil ifTrue: [
        ^picture width
    ].

    ^0!   
releaseButton

    pressed := false.
    self unHighlight.
    value := value not.
    self displayPicture: self pen inRect: self rect.
    self event: #clicked!   
selection: boolean

    (value = boolean) ifTrue: [^self].

    value := boolean.

    self handle isValid  & self pen notNil ifFalse: [ ^self ].

    self displayPicture: self pen inRect: self rect.!  
suggestedSize

    | titleExtent pictureExtent |

    titleExtent := pictureExtent := 0@0.
    title notNil ifTrue: [
        titleExtent := (self font stringExtent: title).
    ].
    picture notNil ifTrue: [
        pictureExtent := picture extent.
    ].

    ^((titleExtent x + pictureExtent x) @ (pictureExtent y max: titleExtent y)) + (self space @ 0) + 2!
unHighlight

    highlighted := false.
    self displayPicture: self pen inRect: self rect!
wmGetdlgcode: wParam with: lParam

    ^DlgcRadiobutton! !

! CP3DCheckBox methods !  
attributeEditor

    ^nil!  
initialize

    "Touched by Ale.  Ya esta ba hecho en la superclase..."

    super initialize.

    #modifiedByOStyle.
    "
    picture := (CPBitmapDict sysAt: 'checkBox').
    onPicture := (CPBitmapDict sysAt: 'checkBoxOn').
    "!   
storeSpecificsOn: aStream indentString: indentString! !

! CP3DRadioButton methods !
attributeEditor

    ^nil!  
gettingFocus

    self turnOffSiblings.
    self selection: true.
    self setTabstopOn.
    super gettingFocus.!
initialize

    "Touched By Ale for getting bitmaps from default dict"

    super initialize.

    #modifiedByOStyle.
    picture := CPBitmapDict at: 'radioButton' ifAbsent: [CPBitmapDict sysAt: 'radioButton'].
    onPicture := CPBitmapDict at: 'radioButtonOn' ifAbsent: [CPBitmapDict sysAt: 'radioButtonOn'].!
isRadio

    ^true! 
releaseButton

    pressed := false.
    self unHighlight.
    value := true.
    self turnOffSiblings.
    self displayPicture: self pen inRect: self rect.
    self event: #clicked! 
selection: bool

    super selection: bool.
    bool ifTrue: [
        self setTabstopOn.
        self isHandleOk ifTrue: [
            self turnOffSiblings.
        ].
    ].!  
setTabstopOff

    | tempStyle |

    tempStyle := UserLibrary
        getWindowLong: self handle  index: GwlStyle.

    tempStyle := (WinLong fromString: tempStyle) asInteger.

    ((tempStyle bitAnd: WsTabstop) ~= 0) ifTrue: [
        tempStyle := tempStyle - WsTabstop.
    ].

    UserLibrary
        setWindowLong: self handle
        index: GwlStyle
        long: tempStyle.! 
setTabstopOn

    | tempStyle |

    tempStyle := UserLibrary
        getWindowLong: self handle  index: GwlStyle.

    tempStyle := (WinLong fromString: tempStyle) asInteger.

    UserLibrary
        setWindowLong: self handle
        index: GwlStyle
        long: (tempStyle bitOr: WsTabstop).!  
storeSpecificsOn: aStream indentString: indentString! 
turnOffSiblings

    | w |

    w := self.

    (w style bitIsOn: WsGroup) ifFalse: [
    [
        w := UserLibrary
            getWindow: w asParameter
            relationship: GwHwndprev.

        w isNil | (w = 0) ifTrue: [
            false
        ] ifFalse: [
            (w := Notifier findWindow: w) isNil ifTrue: [
                ^self
            ].
            (w ~= self) & (w isRadio) ifTrue: [
                w selection: false.
                (w respondsTo: #setTabstopOff) ifTrue: [
                    w setTabstopOff
                ].
            ].
            (w style bitIsOn: WsGroup) not.
        ]
    ] whileTrue: [].
    ].

    w := self.

    [
        w := UserLibrary
            getWindow: w asParameter
            relationship: GwHwndnext.

        w isNil | (w = 0) ifTrue: [
            false
        ] ifFalse: [
            (w := Notifier findWindow: w) isNil ifTrue: [
                ^self
            ].
            (w style bitIsOn: WsGroup) ifTrue: [
                false
            ] ifFalse: [
                (w ~= self) & (w isRadio) ifTrue: [
                    w selection: false.
                    (w respondsTo: #setTabstopOff) ifTrue: [
                        w setTabstopOff
                    ].
                ].
                true
            ].
        ]
    ] whileTrue: [].!
validate

    super validate.
    self selection ifTrue: [
        self turnOffSiblings.
    ].! !

! CPBitmapPane methods !   
attributeEditor

    ^(Smalltalk at: #WBBitmapPicker) new!  
contents

    ^contents!
contents: c

    contents := c.

    rectangle notNil ifTrue: [
        self invalidateRect: nil
    ].!
copySpecificsTo: aPane

    aPane
        contents: self contents;
        cpStyle: cpStyle!  
cpStyle

    ^cpStyle!  
cpStyle: c

    cpStyle := c!   
displayWith: pen inRect: r
    "Modified by Ale for non-Bitmap support..."
    contents isNil ifTrue: [
        contents := CPBitmapDict values asArray first.
    ].
    parent notNil ifTrue: [
        pen fill: self rect color: parent cpBackColor.
    ].
    pen foreColor: self foreColor; backColor: self backColor.

    #modifiedByOStyle.
    contents isBitmap ifFalse: [
        (cpStyle == #stretchToFit and: [contents respondsTo: #display:inside:using:])
        ifTrue: [ contents display: contents boundingBox inside: r using: pen ]
        ifFalse: [ contents displayAt: r origin with: pen ].
        ^self
    ].

    cpStyle == #stretchToFit ifTrue: [
        pen copyBitmap: contents from: contents boundingBox to: r.
    ] ifFalse: [
        pen copyBitmap: contents from: contents boundingBox at: r leftTop.
    ].!   
fixedSize

    cpStyle := #fixedSize!   
mutationExceptions

    ^#(Toggle CPHorizontalPictureButton)!   
mutationTypes

    ^#(Button CPBitmapButton CPBitmapPane)!  
storeSpecificsOn: aStream indentString: indentString

    | key |

    (key := CPBitmapDict keyAtValue: self contents ifAbsent: [ nil ]) notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'contents: (CPBitmapDict at: ', key asQuotedString, ')'.
    ].!   
stretchToFit

    cpStyle := #stretchToFit! 
styles

    ^#(fixedSize stretchToFit)! 
suggestedSize

    contents isNil ifTrue: [
        ^50@50
    ].
    ^contents extent!  
usesColor

    ^contents notNil and: [ contents isMono ]!   
usesFocus

    ^false!  
usesFont

    ^false!   
usesMenu

    ^false!   
usesTitle

    ^false!  
wmErasebkgnd: wordInteger with: longInteger

    ^nil!  
wmNchittest: wParam with: lParam
        "Private - allow overlapping panes to get mouse input"
  ^  -1  "HtTransparent"! !

! CPScrollingPane class methods !
supportedEvents

    ^super supportedEvents
        add: #doubleClickSelect;
        add: #select;
        add: #commitSelection;
        yourself! !

! CPScrollingPane methods !
amountToPageDown

    "Private"

    ^self amountToPageUp negated!
amountToPageLeft

    "Private"

    ^(self rectangle width - self scrollBarWidth) roundTo: self cellSize x!  
amountToPageRight

    "Private"

    ^self amountToPageLeft negated! 
amountToPageUp

    "Private"

    ^self rectangle height  - self cellSize y roundTo: self cellSize y.!   
amountToScrollDown

    "Private"

    ^self amountToScrollUp negated!
amountToScrollLeft

    "Private"

    ^self cellSize x!  
amountToScrollRight

    "Private"

    ^self amountToScrollLeft negated! 
amountToScrollUp

    "Private"

    ^self cellSize y!
boundedCellForPoint: aPoint

    "Private - make sure cell is no more than one cell outside the
     visible area (for the sake of smoother drag-scrolling)"

    | cell topCell bottomCell |

    cell := self cellForPoint: aPoint.
    topCell := self getTopCell - 1.
    bottomCell := topCell + self fullyVisibleCells + 1.

    ^(cell max: topCell) min: bottomCell!   
button1DoubleClick: aPoint

    "Private"

    self doSetFocus.
    self event: #doubleClickSelect!  
button1Down: aPoint

    | cell point currentSelection |

    self doSetFocus.

    currentSelection := selectedCell.

    self whileMouseStillDown: [
        point := self mouseLocation.
        cell := self boundedCellForPoint: point.
        (self cell: currentSelection differsFrom: cell) & (self inBounds: cell) ifTrue: [
            self unHighlightCell: currentSelection.
            self dragScrolls ifTrue: [
                self keepCellVisible: cell.
            ].
            self highlightCell: cell.
            currentSelection := cell.
        ].
    ].

    (self event: #commitSelection) = false ifFalse: [
        selectedCell := currentSelection.
        self updateSelection.
        self event: #select.
    ] ifTrue: [
        self unHighlightCell: currentSelection.
        self highlightCell: selectedCell.
    ].!  
cell: cell1 differsFrom: cell2

    ^cell1 ~= cell2!
cellForPoint: aPoint

    ^(aPoint + topCorner - self headerExtent max: 0@0) // self cellSize + 1!  
cellsToDraw

    "Answer a rectangle describing the range of cells to draw"

    | drawRect |

    drawRect := self exposedRectangle.

    "Take into account that rectangle origin may be non-zero for
     WB based drawing"
    drawRect := (drawRect leftTop leftAndUp: rectangle leftTop) extentFromLeftTop: drawRect extent.

    drawRect := (drawRect leftTop max: self headerExtent) rightBottom: drawRect rightBottom.


    ^(self cellForPoint: drawRect leftTop)
        rightBottom: (self cellForPoint: drawRect rightBottom).!
cellSize

    ^cellSize!
cellSize: anObject

    cellSize := anObject!   
defaultBackColor

    ^UserLibrary getSysColor: ColorWindow!
defaultFont
        "Private - Answer the default font for the control."
    ^(Font fromFont: ListFont)!
defaultHeaderColor

    ^self middleColor!  
defaultSize

    ^self fullExtent!  
defaultStyle
        "Private - Answer an Integer with appropriate styles in it."

    ^WsBorder |
    WsHscroll |
    WsVscroll |
    WsChild   |
    WsVisible!  
displayWith: aPen inRect: aRect  clipRect: clipRect

    "Private - handle WindowBuilder display event"
    | offset region |

    "Out of WindowBuilder, this component will have a border that causes it to
     display one pixel differently - we're emulating that here with the inset"
    rectangle := aRect leftTop  extentFromLeftTop: aRect extent - 1.

    graphicsTool := aPen.
    aPen rectangle: aRect.
    offset := 1.
    tempClipRect := clipRect.

    GDILibrary offsetViewportOrg: graphicsTool handle
        x: aRect left + offset
        y: aRect top + offset.

    self display.

    GDILibrary offsetViewportOrg: graphicsTool handle
        x: (aRect left + offset) negated
        y: (aRect top + offset) negated.

    "We blow away the previous cliprect down in the display routine"
    self inWindowBuilder ifTrue: [
        region := aPen setClipRect: tempClipRect.
    ].

    aPen
        foreColor: ClrBlack;
        drawRectangle: aRect.

    self inWindowBuilder ifTrue: [
        aPen destroyRegion: region
    ].

    tempClipRect := nil.!  
doSetFocus

    self setFocus!  
dragScrolls

    ^false!
exposedRectangle

    "Answer the rectangle that needs to be drawn"

    "overloaded for use within WindowBuilder"
    (self inWindowBuilder) ifTrue: [
        ^self wbDisplayRectangle
    ].

    ^self currentClipRect!  
fullExtent

    "Private - Answer the logical extent of ourselves, including any
     header and all the cells sizes."

    ^totalCells * cellSize + self headerExtent.! 
fullyVisibleCells

    "Answer the number of cells that are fully visible"

    ^self scrollAreaRectangle extent  // self cellSize!   
getClosestScrollPos: value within: boundPoint

    "Private - answer a scrolling position that is as 'clean'
     as possible - if greater than one cell away already,
     cause a jump scroll by setting to the middle of the
     bound area"

    | newPos |

    (value >= boundPoint x) & (value <= boundPoint y ) ifTrue: [
        ^boundPoint x
    ].

   (value = (boundPoint x - 1))  ifTrue: [
        newPos := value.
    ] ifFalse: [
        (value = (boundPoint y + 1)) ifTrue: [
            newPos := boundPoint x + 1.
        ] ifFalse: [
            newPos := value - ((boundPoint y - boundPoint x) // 2).
        ].
    ].

    ^newPos!  
getScrollRanges

    "Private - answer the scroll ranges of the window"

    | h v minPtr maxPtr |

    minPtr := WinStructure new: 2.
    maxPtr := WinStructure new: 2.

    UserLibrary
        getScrollRange: self asParameter
        bar: SbHorz
        lpMinPos: minPtr asParameter
        lpMaxPos: maxPtr asParameter.

    h := maxPtr uShortAtOffset: 0.

    UserLibrary
        getScrollRange: self asParameter
        bar: SbVert
        lpMinPos: minPtr asParameter
        lpMaxPos: maxPtr asParameter.

    v := maxPtr uShortAtOffset: 0.

    ^h@v!   
gettingFocus

    self showFocus.
    super gettingFocus.! 
getTopCell

    "Answer the upper left visible cell"

    ^(topCorner // self cellSize) + 1!  
headerColor

    ^headerColor!  
headerColor: anObject

    headerColor := anObject! 
hideFocus

    self pen drawFocusRect: (self rectForCell: selectedCell)!
horizontalScrollAreaRectangle

    "Private - Answer the rectangular are that should be scrolled if we
    scroll horizontally (don't scroll the horizontal header)"

    ^0@self headerExtent y  rightBottom:  self rectangle rightBottom!  
inBounds: aCell

    "Private - answer whether the cell is within the existing
     number of cells"

    ^(aCell x >= 1) &
    (aCell y >= 1) &
    (aCell x <= self totalCells x) &
    (aCell y <= self totalCells y)! 
initialize

    super initialize.
    headerColor := self defaultHeaderColor.
    topCorner := 0@0.!  
keepCellVisible: aCell

    "Private - scroll the window to make the cell visible if
     necessary"

    | bottomCell topCell newX newY |

    topCell := self getTopCell.
    bottomCell := topCell + self fullyVisibleCells - 1.

    ((topCell rightBottom: bottomCell) containsPoint: aCell) ifTrue: [
        ^self
    ].

    newX := self getClosestScrollPos: aCell x within: topCell x @ bottomCell x.
    newY := self getClosestScrollPos: aCell y within: topCell y @ bottomCell y.

    self setTopCell: newX@newY.!  
keepSelectionVisible

    self keepCellVisible: selectedCell.!  
losingFocus

    self hideFocus.
    super losingFocus.!   
mutationExceptions

    ^#(CPScrollingPane)!
mutationTypes

    ^#(ListBox CPScrollingPane)! 
pointForCell: aCell

    "Private"

    ^(aCell - 1) * self cellSize - topCorner + self headerExtent! 
realRectangle

    "Private - Answer the rectangle representing the fully visible area of the
     window, taking into account any scrollbars that might be on it."

    | range height width |


    self inWindowBuilder ifTrue: [
        ^0@0 extent: self wbDisplayRectangle extent
    ].

    width := height := 0.
    range := self getScrollRanges.
    range x ~= 0 ifTrue: [
        width := self scrollBarWidth.
    ].

    range y ~= 0 ifTrue: [
        height := self scrollBarHeight.
    ].


    ^0@0 extent: self frameRectangle extent -(width@height).!   
rectForCell: cell

    "Private Answer the rectangle that completely encompasses the
     cell. This will include a one pixel border all the way
     around the cell."
    ^(self pointForCell: cell) extentFromLeftTop: self cellSize + 1! 
reframe

    "Private - the window just resized"

    self setScrollRanges.
    self scrollIfNecessary.
    self updateSliders.!
scrollableRectangle

    "Private - Answer the rectangular area that can be scrolled
     (i.e. the full area - the visible area)"

    | scrollExtent |

    scrollExtent := (self totalCells * self cellSize) - self scrollAreaRectangle extent max: 0@0.

    scrollExtent := ((scrollExtent x + self cellSize x - 1)  truncateTo: self cellSize x) @
        ((scrollExtent y + self cellSize y - 1)  truncateTo: self cellSize y).
    ^0@0 extent: scrollExtent.!
scrollAreaRectangle

    ^self headerExtent rightBottom:  self rectangle rightBottom!   
scrollBarHeight

    ^UserLibrary
        getSystemMetrics: SmCyhscroll!   
scrollBarWidth

    ^UserLibrary
        getSystemMetrics: SmCxvscroll!
scrollHorizontal: scrollAmount

        "Private - Scroll the pane right by anInteger
         number of pixels (if positive) or left by
         the absolute value of anInteger (if negative)."

    self scrollTopCorner: scrollAmount  @ 0! 
scrollIfNecessary

    "Private - force us to scroll if we just got smaller and are
     scrolled out"

    |  newTopCorner fullExtent visibleExtent delta |

    self isHandleOk ifFalse: [
        ^self
    ].

    fullExtent  := self fullExtent.
    visibleExtent := self realRectangle extent.

    newTopCorner := topCorner deepCopy.

    (fullExtent x < (visibleExtent x + topCorner x)) ifTrue: [
        newTopCorner x: (fullExtent x - visibleExtent x max: 0).
    ].

    (fullExtent y < (visibleExtent y + topCorner y)) ifTrue: [
        newTopCorner y: (fullExtent y - visibleExtent y max: 0).
    ].

    (newTopCorner ~= topCorner) ifTrue: [
        delta := topCorner - newTopCorner.
        delta := (delta x roundTo: self cellSize x) @ (delta y roundTo: self cellSize y).
        self scrollTopCorner: delta.
     ].! 
scrollTopCorner: aPoint

    "Private"

    | oldCorner scrollRect point |

    oldCorner := topCorner deepCopy.
    topCorner := topCorner - aPoint.

    scrollRect := self scrollableRectangle.

    topCorner x: ((topCorner x min:  scrollRect width) max: 0).
    topCorner y: ((topCorner y min: scrollRect height) max: 0).

    oldCorner = topCorner ifTrue: [^self].

    (oldCorner y = topCorner y) ifTrue: [
        scrollRect := self verticalScrollAreaRectangle.
    ] ifFalse: [

    "If they scroll in both directions at once, we'd better not
     try blitting, since both row and column headers will both
     need to be updated."

        (oldCorner x = topCorner x) ifFalse: [
            ^self
                invalidateRect: self rectangle;
                updateWindow
        ].
        scrollRect := self horizontalScrollAreaRectangle.
    ].

    point := oldCorner - topCorner.

    point y < 0 ifTrue: [
        point y: (point y max: scrollRect height negated)
    ] ifFalse: [
        point y: (point y min: scrollRect height)
    ].

    UserLibrary scrollWindow: handle
        xAmount: point x
        yAmount: point y
        lpRect: scrollRect asParameter
        clipRect: scrollRect  asParameter.

    self updateWindow.! 
scrollVertical: scrollAmount

        "Private - Scroll the pane down by anInteger
         number of pixels (if positive) or up by
         the absolute value of anInteger (if negative)."

    self scrollTopCorner: 0 @ scrollAmount!   
setScrollRanges

    "Private - Set the ranges for the horizontal and vertical
     scroll bars."

    | rangeRect minHorz maxHorz minVert maxVert rect fullExtent |

    self isHandleOk ifFalse: [
        ^self
    ].

    rangeRect := self scrollableRectangle.
    minHorz := 0.
    maxHorz := rangeRect width.
    minVert := 0.
    maxVert := rangeRect height.


    (self style notNil and: [ self style bitAnd: WsHscroll ]) = 0  ifTrue: [
        maxHorz := 0
    ].
    (self style notNil and: [ self style bitAnd: WsVscroll ]) = 0  ifTrue: [
        maxVert := 0
    ].

    rect := self realRectangle.
    fullExtent := self fullExtent.


    (rect width >= fullExtent x ) ifTrue: [
        maxHorz := 0.
    ].
    (rect height >= fullExtent y) ifTrue: [
        maxVert := 0.
    ].

    maxVert > 0 ifTrue: [
        maxVert := maxVert / cellSize y.
        maxVert := (maxVert / (maxVert / 32767) ceiling) truncated.
    ].

    UserLibrary
        setScrollRange: self asParameter
        bar: SbHorz
        min: minHorz
        max: maxHorz
        redraw: false.

    UserLibrary
        setScrollRange: self asParameter
        bar: SbVert
        min: minVert
        max: maxVert
        redraw: false!  
setTopCell: aCell

    | newTop |

    newTop := (aCell - 1) * self cellSize.

    self scrollTopCorner: topCorner  - newTop.
    self updateVerticalSlider.
    self updateHorizontalSlider.!
showFocus

    self showFocusInCell: selectedCell!  
showFocusInCell: aCell

    | point width |

    point := self pointForCell: aCell.

    width := self totalCells x * self cellSize x max: self rectangle width.

    self pen drawFocusRect: (
        point rightBottom: width@(point y + self cellSize y)
    )! 
totalCells

    ^totalCells!
updateHorizontalSlider

        "Private - Update the horizontal slider position."

   UserLibrary
        setScrollPos: self asParameter
        bar: SbHorz
        position: self topCorner x
        redraw: true.!   
updateRectangle

    rectangle := self rectangle.
    graphicsTool notNil ifTrue: [
        graphicsTool
            width: rectangle width;
            height: rectangle height
    ].
    (rectangle height = 0) | (rectangle width = 0) ifFalse: [
        self reframe.
    ].!
updateSelection

    "Private - Selection just changed. Do nothing by default"! 
updateVerticalSlider

    "Private - Update the vertical slider position."

    | pos h |

    (h := self scrollableRectangle height) = 0 ifTrue: [
        pos := 1.
    ] ifFalse: [
        pos := self topCorner y / cellSize y / (h / cellSize y / 32767) ceiling.
    ].

   UserLibrary
        setScrollPos: self asParameter
        bar: SbVert
        position: pos truncated
        redraw: true.!  
verticalScrollAreaRectangle

    "Private - Answer the rectangular are that should be scrolled if we
    scroll vertically (don't scroll the vertical  header)"

    ^self headerExtent x@ 0 rightBottom:  self rectangle rightBottom!   
visibleCells

    "Private - Answer the number of cells that are full or partially visible"

    ^((self scrollAreaRectangle extent - 1) // self cellSize) + 1!   
visibleRectangle

    | extent |

    "overloaded for use within WindowBuilder"
    (self inWindowBuilder) ifTrue: [
        extent := self wbDisplayRectangle extent
    ] ifFalse: [
        extent := self rectangle extent.
    ].

    ^0@0 extent: extent!   
wbDisplayRectangle

    "Private - WindowBuilder drawing sets up rectangle for us"
    ^rectangle! 
wmHScroll: wordInteger with: longInteger

    "Private - Handle horizontal scrolling."

    | type pos |

    type := wordInteger.
    type = SbLineup ifTrue: [  self scrollHorizontal: self amountToScrollLeft].
    type = SbLinedown ifTrue: [self scrollHorizontal: self amountToScrollRight].
    type = SbPageup ifTrue: [self scrollHorizontal: self amountToPageLeft].
    type = SbPagedown ifTrue: [self scrollHorizontal: self amountToPageRight].
    (type = SbThumbposition) | (type = SbThumbtrack)  ifTrue: [
        pos := WinStructure new: 4.
        pos uLongAtOffset: 0 put: longInteger.
        pos := (pos shortAtOffset: 0) roundTo: self cellSize x.
        self scrollHorizontal: self topCorner x - pos.
        self updateHorizontalSliderTo: pos.
        ^nil
    ].

    self updateHorizontalSlider.
    ^nil! 
wmVScroll: aWordInteger with: aLongInteger

    "Private - handle vertical scrolling"

    | type maxVert factor |

    type := aWordInteger.
    type = SbLineup ifTrue: [self scrollVertical: self amountToScrollUp].
    type = SbLinedown ifTrue: [self scrollVertical: self amountToScrollDown].
    type = SbPageup ifTrue: [self scrollVertical: self amountToPageUp].
    type = SbPagedown ifTrue: [self scrollVertical: self amountToPageDown].
    (type = SbThumbposition) | (type = SbThumbtrack) ifTrue: [
            type := WinStructure new: 4.
            type uLongAtOffset: 0 put: aLongInteger.
            type := type shortAtOffset: 0.
            maxVert := self scrollableRectangle height / cellSize y.
            factor := (maxVert / 32767) ceiling.
            type := type * factor.
            type > (maxVert / 2) ifTrue: [ type := type + factor - 1 ].
            type := type * cellSize y.
            self scrollVertical: self topCorner y - type.
            ^nil
    ].
    self updateVerticalSlider.
   ^nil! !

! CPColumnarListBox class methods !  
supportedEvents

    ^super supportedEvents
        add: #getFields;
        yourself! !

! CPColumnarListBox methods ! 
attributeEditor

    "Private - Used by WindowBuilder"

    ^(Smalltalk at: #WBColumnarListBoxEditor) new!
button1DoubleClick: aPoint

    selectedCell = (self boundedCellForPoint: aPoint) ifFalse: [
        self button1Down: aPoint.
    ].
    super button1DoubleClick: aPoint.! 
calcFieldSizes

    "Private - calculate new field sizes"

    | maxWidth result |

    objects isNil | fields isNil ifTrue: [
        ^self
    ].

    totalFieldWidth := 0.
    headerHeight := 0.

    fields do: [ :f |
        f font: self font.
        headerHeight := headerHeight max: f headerHeight.
        f autoFieldWidth ifTrue: [
            maxWidth := self font stringWidth: f header.
            objects do: [ :o |
                f selector notNil ifTrue: [
                    result := o perform: f selector.
                    result isBitmap ifTrue: [
                        maxWidth := maxWidth max: result width.
                        self cellSize: self cellSize x@(self cellSize y max: result height).
                    ]  ifFalse: [
                        result isString ifFalse: [
                            result := result printString.
                        ].
                        maxWidth := maxWidth max: (self font stringWidth:result).
                    ].
                ].
            ].
            f fieldPixelWidth: maxWidth.
        ].
        totalFieldWidth := totalFieldWidth + self fieldMargin + f fieldPixelWidth.
    ].

    totalFieldWidth := totalFieldWidth + self fieldMargin.

    totalCells := ((totalFieldWidth - 1) // self cellSize x + 1) @ objects size.
    headerHeight := headerHeight + self headerMargin.!  
cell: cell1 differsFrom: cell2

    "Private - answer whether one cell differs from another"

    cell1 isNil ifTrue: [
        ^cell2 notNil
    ].

    ^cell1 y ~= cell2 y!
contents

    "Answer the object list passed in"

    ^objects!   
contents: objectList

    "Set the contents of the listbox"

    objects := objectList.
    self calcFieldSizes.
    selectedCell := nil.
    self isHandleOk ifTrue: [
        self invalidateRect: nil.
        self updateRectangle.
    ].! 
contents: objectList fields: aFieldList

    "Set the contents and fields of the listbox"

    objects := objectList.
    fields := aFieldList.
    self calcFieldSizes.
    selectedCell := nil.
    self isHandleOk ifTrue: [
        self invalidateRect: nil.
        self updateRectangle.
    ].!
copySpecificsTo: aPane

    "Private - used by WindowBuilder"

    aPane fields: (
        self fields collect: [ :f |
            f deepCopy
        ]
    ).
    aPane headerColor: self headerColor.
    aPane showHeader: self showHeader.! 
defaultBackColor

    ^UserLibrary getSysColor: ColorWindow!
defaultFields

    "Private - set up the fields for a blank listbox"

    ^OrderedCollection
        with: (
            CPCLBField new
                header: 'Field 1'
        )
        with: (
            CPCLBField new
                header: 'Field 2'
        )
        with: (
            CPCLBField new
                header: 'Field 3'
        ).!   
defaultHeaderColor

    "Private"

    ^ClrWhite! 
defaultShowHeader

    "Private"

    ^true!  
defaultSize

    "Private"

    ^self fullExtent x@100!   
display

    "Private - respond to repaint messages"

    self pen
        fill: (self inWindowBuilder ifTrue: [
                (0 @ self headerExtent y rightBottom: rectangle extent)
            ] ifFalse: [
                self scrollAreaRectangle
            ])
            color: self backColor;
        backColor: self backColor.

    self displayHeader.

    (objects isNil or: [ objects isEmpty ] ) ifFalse: [
        self displayObjects.
        self highlightCell: selectedCell.
    ].

    self haveFocus ifTrue: [
        self showFocus
    ].!
displayHeader

    "Private - display the header of the listbox"

    | startX startY fieldBeginning hHeight |

    self showHeader ifTrue: [
        self pen
            fill: (0@0 extent: self visibleRectangle width@self headerExtent y)
            color: self headerColor.
        startY := self headerMargin // 2.
        self pen
            setTextAlign: TaTop;
            setBackMode: Transparent;
            foreColor: self foreColor.
        fieldBeginning := topCorner x negated + self leftMargin.
        fields do: [ :f |
            startX := fieldBeginning.
            self pen
                winDrawText: f header
                in: (startX @ startY extentFromLeftTop: f fieldPixelWidth@self headerExtent y)
                format: f windowsJustification.
            fieldBeginning := fieldBeginning + f fieldPixelWidth + self fieldMargin.
        ].
        hHeight := self headerExtent y - 1.
        self pen lineFrom: 0@ hHeight to: self visibleRectangle right @ hHeight.
        self pen setBackMode: Opaque.
     ].!
displayItem: anItem inRect: aRect

    "Private - display a particular item, using aRect as the
     rectangle in which to draw"

    | startX startY displayX result pen region clipRect |

    startX := aRect left right: self leftMargin.
    pen := self pen.
    pen
        setTextAlign: TaTop.

    fields do: [ :f |
        f selector isNil ifTrue: [
            result := nil
        ] ifFalse: [
            result := anItem perform: f selector.
        ].
        result isNil ifFalse: [
            result isBitmap ifTrue: [
                startY := aRect top down: ((aRect height - result height) // 2).
                result displayAt: startX@startY with: pen.
            ] ifFalse: [
                result isString ifFalse: [
                    result := result printString.
                ].
                startY := aRect top down: ((aRect height - self font height) // 2).

                displayX := startX + (f justificationOffsetFor: result).

                clipRect := (startX@startY extentFromLeftTop: (f fieldPixelWidth@self cellSize y)).

                tempClipRect notNil ifTrue: [
                    clipRect := tempClipRect intersect: clipRect.
                ].

                region := pen setClipRect: clipRect.
                pen displayText: result at: displayX@startY.
                self pen destroyRegion: region.
            ].
        ].

        startX := startX + f fieldPixelWidth + self fieldMargin.
    ].! 
displayObjects

    "Private - loop through the objects, displaying each one in turn"

    | range startPos |

    range := self cellsToDraw.
    startPos := self pointForCell: 1@range top.

    self pen setBackMode: Transparent.

    (range top max: 1) to: (range bottom min: objects size) do: [ :i |
        self
            displayItem: (objects at: i)
            inRect: (startPos extent: self scrollAreaRectangle width @ self cellSize y).
        startPos y: startPos y + self cellSize y.
    ].

    self pen setBackMode: Opaque.!   
dragScrolls

    "Private"

    ^true!
fieldMargin

    "Private - answer the width in pixels on each side of a field"

    ^self font width * 3!
fields

    "Answer the fields for this listbox"

    ^fields!
fields: aFieldList

    "Set the fields for this listbox"

    fields := aFieldList.
    self calcFieldSizes.
    self isHandleOk ifTrue: [
        self invalidateRect: nil.
        self updateRectangle.
    ].!  
font: aFont

    super font: aFont.
    cellSize y: aFont height.
    self calcFieldSizes!
fullExtent

    "Private - answer the total extent of the objects + the header"

    ^(totalFieldWidth@(self totalCells y * self cellSize y)) + self headerExtent.!   
fullyVisibleCells

    "Private - answer the number of cells that will display
     fully visible within the window "

    ^totalCells x@super fullyVisibleCells y!  
gettingFocus

    "Private"

    self showFocus.! 
getTopIndex

    "Answer the index of the object visible at the top of the
     listbox"

    ^self getTopCell y!
headerExtent

    "Private - answer how big the header is"

    self showHeader ifTrue: [
        ^0@headerHeight
    ] ifFalse: [
        ^0@0
    ].!   
headerMargin

    "Private - answer the height (beyond the font height) of the
     header in pixels"

    ^5!   
hideFocus

    self showFocus.! 
highlightCell: aCell

    "Private - highlight a cell"

    | box highlightColor region |

    aCell isNil | self handle isValid not ifTrue: [
        ^self
    ].

    (self isCellVisible: aCell) ifFalse: [
        ^self
    ].

    box := self rectForCell: aCell.
    highlightColor := UserLibrary getSysColor: ColorHighlight.

    region := self pen setClipRect: (self headerExtent rightBottom: self rectangle rightBottom).

    self pen
        fill: box
        color: highlightColor;
        foreColor: (UserLibrary getSysColor: ColorHighlighttext);
        setBackMode: Transparent.

    self displayItem: (objects at: aCell y) inRect: box.
    self pen
        foreColor: self foreColor;
        setBackMode: Opaque.

    self haveFocus ifTrue: [
        self showFocusInCell: aCell.
    ].

    self pen destroyRegion: region.!
initialize

    "Private"

    super initialize.
    cellSize := 50@self font height.
    showHeader := self defaultShowHeader.
    fields := self defaultFields.
    self contents: #().!
isCellVisible: aCell

    | topCell bottomCell |

    topCell := self getTopCell y.
    aCell y < topCell ifTrue: [
        ^false
    ].

    bottomCell := topCell + self fullyVisibleCells y.
    aCell y > bottomCell ifTrue: [
        ^false
    ].

    ^true!   
keepCellVisible: aCell

    | savedSelection |

    "Prevent the selection from drawing, since we'll be highlighting
     the item after scrolling"

    aCell isNil ifFalse: [
        savedSelection := selectedCell.
        selectedCell := nil.
        super keepCellVisible: aCell.
        selectedCell := savedSelection.
    ].!
keepSelectionVisible

    super keepSelectionVisible.
    self refreshSelection.!  
leftMargin

    "Private - answer the margin from the left side of the
     listbox, in pixels"

    ^self font width!   
open

    "Private"

    self event: #getFields.
    super open.!
pointForCell: aCell

    "Private"

    ^0@((aCell y - 1) * self cellSize y) - topCorner + self headerExtent! 
rectForCell: cell

    "Private"

    | point |

    point := self pointForCell: cell.

    ^point rightBottom: self rectangle right @(point y + self cellSize y)!
refreshIndex: anIndex

    "Redisplay the object at index anIndex"

    (selectedCell notNil and: [ anIndex = selectedCell y ]) ifTrue: [
        self highlightCell: 1@anIndex.
    ] ifFalse: [
        self unHighlightCell: 1@anIndex.
    ].!
refreshSelection

    "Cause the selection to redraw"

    self refreshIndex: self selection! 
restore
        "Refresh the list from the owner
         and maintain the position in the list
         without selecting it."
    | first |
    first  := self getTopIndex.
    self event: #getContents.
    self setTopIndex: first!   
restoreSelected
        "Refresh the list from the owner
         and keep the old selection. "
    | index  first |
    index := self selection.
    first  := self getTopIndex.
    self noRedraw: true.
    self event: #getContents.
    self setTopIndex: first.
    self selection: index.
    self noRedraw: false.
    self invalidateRect: self rectangle!
restoreSelected: anObject

    | topIndex |

    self noRedraw: true.
    topIndex := self getTopIndex.
    self event: #getContents.
    self setTopIndex: topIndex.
    self selection: anObject.
    self  noRedraw: false.
    self invalidateRect: self rectangle! 
scrollTopCorner: newTopCorner

    "Private"

    self haveFocus ifTrue: [
        self hideFocus.
    ].
    super scrollTopCorner: newTopCorner.
    self haveFocus ifTrue: [
        self showFocus.
    ].! 
searchNameForIndex: anIndex

    "Private"

    | name |

    fields isEmpty | anIndex isNil ifTrue: [ ^nil ].

    name := (objects at: anIndex) perform: (fields at: 1) selector.
    name isBitmap ifTrue: [ ^nil ].

    name isString not ifTrue: [
        name := name printString.
    ].

    ^name!  
selectedIndex

    ^self selection! 
selectedItem

    selectedCell isNil ifTrue: [
        ^nil
    ].

    ^objects at: selectedCell y!
selection

    selectedCell isNil ifTrue: [
        ^nil
    ].

    ^selectedCell y!   
selection: anItem

    | oldCell |

    anItem isNil ifTrue: [
        selectedCell notNil & self isHandleOk  ifTrue: [
            self invalidateRect: (self rectForCell: selectedCell).
            self updateRectangle.
        ].
        ^selectedCell := nil
    ].

    anItem isInteger ifTrue: [
        oldCell := selectedCell.
        selectedCell := 1@((anItem max: 0) min: objects size).
        self isHandleOk ifTrue: [
            oldCell notNil ifTrue: [
                self unHighlightCell: oldCell.
            ].
            selectedCell notNil ifTrue: [
                self highlightCell: selectedCell.
            ].
            self keepSelectionVisible.
        ].
    ] ifFalse: [
        self selection: (objects indexOf: anItem).
    ].!   
setTopCell: aCell

    "Private"

    | newTop |

    newTop := (0@(aCell y - 1)) * self cellSize.

    self scrollTopCorner: topCorner  - newTop.
    self updateVerticalSlider.
    self updateHorizontalSlider.! 
setTopIndex: anIndex

    "Scroll listbox so that the item at anIndex is at the top of
     the listbox"

    self setTopCell: 1@anIndex!
showFocus

    "Private"

    selectedCell isNil ifTrue: [
        ^self
    ].

    self showFocusInCell: selectedCell!  
showFocusInCell: aCell

    "Private"

    | y width |

    y := (self pointForCell: aCell) y.

    (self isCellVisible: aCell) ifFalse: [
        ^self
    ].

    width := self totalCells x * self cellSize x max: self rectangle width.

    self pen drawFocusRect: (
        topCorner x negated@y rightBottom: width@( y + self cellSize y)
    )!
showHeader

    ^showHeader!
showHeader: bool

    showHeader := bool.!  
storeSpecificsOn: aStream indentString: indentString

    "Private"

    self headerColor = self defaultHeaderColor ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'headerColor: (ColorConstants at: ', (ColorConstants keyAtValue: self headerColor) asQuotedString, ')'.
    ].

    self showHeader = self defaultShowHeader ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'showHeader: ', self showHeader asString.
    ].

    self fields = self defaultFields ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'fields: ('; cr.
        aStream nextPutAll: indentString, '    OrderedCollection new'; cr.
        self fields do: [ :f |
            aStream nextPutAll: indentString, '    addLast: ('; cr.
            f storeOn: aStream indentString: indentString, '        '.

            aStream cr; nextPutAll: indentString, '    )'.
            aStream nextPutAll: ';'; cr
        ].

        aStream nextPutAll: indentString, '    yourself'; cr.
        aStream nextPutAll: indentString, ')'.
    ].! 
suggestedSize

    "Private"

    ^self fullExtent x@((rectangle extent y - self headerExtent y roundTo:  cellSize y) + self headerExtent y)! 
unHighlightCell: aCell

    "Private"

    | box region |

    aCell isNil | self handle isValid not ifTrue: [
        ^self
    ].

    (self isCellVisible: aCell) ifFalse: [
        ^self
    ].

    box := self rectForCell: aCell.

    region := self pen setClipRect: (self headerExtent rightBottom: self rectangle rightBottom).

    self pen
        fill: box
        color: self backColor.

    self displayItem: (objects at: aCell y) inRect: box.

    self pen destroyRegion: region.!
virtualKeyInput: anInt  withKeys: keyArray

    "Private"

    | newSel |

    selectedCell isNil ifTrue: [
        ^self
    ].

    anInt =  VkUp ifTrue: [ newSel := self selection - 1 ].
    anInt = VkDown ifTrue: [ newSel := self selection + 1 ].
    (anInt = VkHome) ifTrue: [ newSel := 1].
    (anInt = VkEnd) ifTrue: [ newSel := objects size ].
    (anInt = PageUpKey) ifTrue: [ newSel := (selectedCell y - (self fullyVisibleCells y - 1) max: 1) ].
    (anInt = PageDownKey) ifTrue: [ newSel := (selectedCell y + (self fullyVisibleCells y - 1) min: objects size) ].

    (anInt = VkLeft) ifTrue: [
        self scrollHorizontal: self amountToScrollLeft.
        ^self updateHorizontalSlider
    ].
    (anInt = VkRight) ifTrue: [
        self scrollHorizontal: self amountToScrollRight.
        ^self updateHorizontalSlider
    ].

    (newSel notNil and: [ (newSel > 0) & (newSel <= objects size) ]) ifTrue: [
        (self event: #commitSelection) = false ifFalse: [
            self selection: newSel.
            self event: #select.
        ].
    ].!
wmChar: wordInteger with: longInteger

    "Private"

    | char name curIndex selectedIndex |

    char := wordInteger asCharacter asUpperCase.

    (selectedIndex := self selectedIndex) isNil ifTrue: [
        curIndex := 0.
    ] ifFalse: [
        (name := self searchNameForIndex: selectedIndex) isNil ifTrue: [ ^nil ].

        ((name size > 0)  and: [ name first asUpperCase = char  ]) ifTrue: [
            curIndex := selectedIndex.
        ] ifFalse: [
            curIndex := 0.
        ].
    ].

    curIndex + 1 to: objects size do: [ :i |

        (name := self searchNameForIndex: i) isNil ifTrue: [ ^nil ].

        ((name size > 0)  and: [ name first asUpperCase = char  ]) ifTrue: [
            self selection: i.
            self event: #select.
            ^nil
        ].
    ].

    1 to: curIndex do: [ :i |
        (name := self searchNameForIndex: i) isNil ifTrue: [ ^nil ].
        ((name size > 0)  and: [ name first asUpperCase = char  ]) ifTrue: [
            self selection: i.
            self event: #select.
            ^nil
        ].
    ].!   
wmHScroll: wordInteger with: longInteger

    "Private - Process a WM_HSCROLL message."

    | type  pos |

    type := wordInteger.
    type = SbLineup ifTrue: [  self scrollHorizontal: self amountToScrollLeft].
    type = SbLinedown ifTrue: [self scrollHorizontal: self amountToScrollRight].
    type = SbPageup ifTrue: [self scrollHorizontal: self amountToPageLeft].
    type = SbPagedown ifTrue: [self scrollHorizontal: self amountToPageRight].
    (type = SbThumbposition) | (type = SbThumbtrack)
        ifTrue: [
            pos := WinStructure new: 4.
            pos uLongAtOffset: 0 put: longInteger.
            pos := pos shortAtOffset: 0.
            self updateHorizontalSliderTo: pos.
            self scrollHorizontal: self topCorner x - pos.
            ^nil].
    self updateHorizontalSlider.
    ^nil! !

! CPTableEditor class methods ! 
supportedEvents

    ^super supportedEvents
        add: #textChanged;
        yourself! !

! CPTableEditor methods !   
atRow: row column: column

    "Answer the string that is at column@row.  If there is no value, an
     empty string will be returned.  If there are labels
     (headers) associated with a given row or column, the argument for
     that coordinate may be a string within the label list rather than a numeric
     index.  Example values:  1@'Name', 'Name'@1,  'Name'@'Year', 1@1  "

    | cell c r |


    column isString ifTrue: [
        columnHeader isNil ifTrue: [
            ^self error: 'Need column names before indexing'
        ].
        c := (columnHeader indexOf: column).
    ] ifFalse: [
        c := column.
    ].

    row isString ifTrue: [
        rowHeader isNil ifTrue: [
            ^self error: 'Need row names before indexing'
        ].
        r := (rowHeader indexOf: row).
    ] ifFalse: [
        r := row.
    ].

    ^self cellAt: c@r!
atRow: row column: column put: aString

    "Set the string that is at column@row to aString.   If there are labels
     (headers) associated with a given row or column, the argument for
     that coordinate may be a string within the label list rather than a numeric
     index.  Example rows/columns:  1@'Name', 'Name'@1,  'Name'@'Year', 1@1  "

    | cell x y |

    column isString ifTrue: [
        columnHeader isNil ifTrue: [
            ^self error: 'Need column names before indexing'
        ].
        x := (columnHeader indexOf: column).
    ] ifFalse: [
        x :=column.
    ].

    row isString ifTrue: [
        rowHeader isNil ifTrue: [
            ^self error: 'Need row names before indexing'
        ].
        y := (rowHeader indexOf: row).
    ] ifFalse: [
        y := row.
    ].

    self cellAt: x@y put: aString.

    (x@y) = self selection ifTrue: [
        textEditor setContents: aString
    ] ifFalse: [
        self isHandleOk ifTrue: [
            self invalidateRect: ((self rectForCell: x@y) insetBy: 1@1).
        ].
    ].! 
attributeEditor

    "Private - answer the WindowBuilder editor for this subpane"

    ^(Smalltalk at: #WBTableEditorEditor) new! 
backColor: aColor

    "Private - force the cell texteditor to have the same backcolor as
     the table editor"

    super backColor: aColor.
    textEditor backColor: aColor.!   
button1Down: aPoint

    "Private - Handle changing the selection."

    | savedSelection |

    "Move the text editor off the screen temporarily so it won't be a
     nuisance during scrolling"
    savedSelection := selectedCell.
    selectedCell := -100@-100.
    textEditor resize: self rectangle.
    "Redraw the cell that had the text editor in it"
    self invalidateRect: (self rectForCell: self selection).
    self updateWindow.

    selectedCell := savedSelection.

    super button1Down: aPoint.!  
cacheCellSize

    cellSize := ( self cellWidth * self font width) @ self cellHeight!   
calcHeaderExtent

    "Private - Recalculate the headerExtent (based on the font and
     whether we're showing rows/column headers)"

    | max x y string |

    showRowHeader ifTrue: [
        rowHeader notNil ifTrue: [
            max := 0.
            rowHeader do: [ :s |
                max := (self font stringWidth: s) max: max.
            ].
            x := max.
        ] ifFalse: [
            string := String new: self rows printString size.
            string atAllPut: $0.
            x := self font stringWidth: string
        ].
        "Make sure it looks at minimum proportional to columnheader"
        x := x + (self rowHeaderMargin * 2) max: self font height + (self rowHeaderMargin * 2).
    ] ifFalse: [
        x := 0.
    ].

    showColumnHeader ifTrue: [
        y := self font height + (self columnHeaderMargin * 2).
    ] ifFalse: [
        y := 0.
    ].

    headerExtent := x@y.! 
cellAt: aPoint

    "Private - answer the cell at a given point.  Public method is
     rowAt:column:, which allows either strings or integer indices."

    | cell |

    cells isNil ifTrue: [
        ^''
    ].

    (self sparseStorage) ifTrue: [
        ^cells at: aPoint
    ].

    cell := (cells at: aPoint y) at: aPoint x.
    cell notNil ifTrue: [
        ^cell
    ] ifFalse: [
        ^''
    ].! 
cellAt: aPoint put: aString

    "Private - set the cell at aPoint to aString.  Public method is
     rowAt:column:put:, which allows either strings or integer indices."

    cells isNil ifTrue: [
        self initializeCells.
    ].

    self sparseStorage ifTrue: [
        ^cells at: aPoint put: aString
    ].

    (cells at: aPoint y) at: aPoint x put: aString.!  
cellHeight

    "Private - Answer the height of a cell"

    ^self font height + (2 * self cellTextOffset y).!
cellMargin

    ^5@2!   
cellTextOffset

    "Private - Answer the offset from the left top of a cell for the
     text to be displayed."

    ^5@3!  
cellWidth

    "Private - answer the width of a cell in characters"
    ^cellWidth!
cellWidth: numChars

    "Set the width of a cell, in characters"

    cellWidth := numChars.
    self cacheCellSize.
    self cellSize x: numChars * self font width!  
columnHeaderMargin

    "Private - answer pixel margin above and below column headers"
    ^2! 
columnHeaders

    "Answer the list of column headers being displayed."

    ^columnHeader!   
columnHeaders: anOrderedCollection

    "Set the column headers to anOrderedCollection of strings"

    columnHeader := anOrderedCollection.
    columnHeader notNil ifTrue: [
        self columns: columnHeader size
    ].! 
columns

    "Answer the total number of columns"

    ^totalCells x! 
columns: numColumns

    "Set the total number of columns"

    totalCells x: numColumns.!
copySpecificsTo: aPane

    "Private - copy the details of self into a clone.  Used by WindowBuilder"

    aPane
        rows: self rows;
        columns: self columns;
        cellWidth: self cellWidth;
        headerColor: self headerColor;
        showRowHeader:  self showRowHeader;
        showColumnHeader:self showColumnHeader;
        showGrid: self showGrid;
        sparseStorage: self sparseStorage;
        rowHeaders: self rowHeaders;
        columnHeaders: self columnHeaders.! 
cr

    "Private - process a carriage return from the text editor"

    | newSel |

    (Notifier isKeyDown: VkShift) ifFalse: [
        (self selection = self totalCells) ifTrue: [
            ^self
        ].
        newSel := self selection + (0@1).
        newSel y > self rows ifTrue: [
            newSel := (self selection x + 1)@1.
        ].
        newSel := newSel min: self columns@self rows.
    ] ifTrue: [
        (self selection = (1@1)) ifTrue: [
            ^self
        ].
        newSel := self selection - (0@1).
        newSel y < 1 ifTrue: [
            newSel := (self selection x - 1)@self rows.
        ].
        newSel := newSel max: 1@1.
    ].

    self selection: newSel.!
defaultCellWidth

    "Private"

    ^10! 
defaultColumns

    "Private"

    ^3!
defaultRows

    "Private"

    ^3!   
defaultShowColumnHeader

    "Private"

    ^true!
defaultShowGrid

    "Private"

    ^true!
defaultShowRowHeader

    "Private"

    ^true!   
defaultSparseStorage

    "Private"

    ^false!  
display

    "Private - display the spreadsheet using the current cliprect as a guide
     to which cells to draw"

    | range drawRect |

    drawRect := self exposedRectangle.
    self pen fill: (self headerExtent - topCorner extentFromLeftTop: self totalCells * self cellSize) color: self backColor.
    range := self cellsToDraw.

    self drawRowHeaderIn: range.
    self drawColumnHeaderIn: range.
    self drawGridIn: range.

    self drawExtraBottomArea.
    self drawExtraRightArea.

    (range left max: 1) to: (range right min: self totalCells x) do: [ :c |
        (range top max: 1) to: (range bottom min: self totalCells y) do: [ :r |
            self drawCell: c@r clipRect: drawRect.
        ].
    ].

    self highlightCell: self selection.!  
doSetFocus

    "Private - Hand the focus off to the text editor whenever we
     get it.  Avoid doubledraw by checking if it has focus first."
    textEditor haveFocus ifFalse: [
        textEditor setFocus
    ].! 
drawCell: aPoint

    | cellRect |

    cellRect := self rectForCell: aPoint.

    self pen
        setTextAlign: TaTop;
        setBackMode: Transparent;
        displayText: (self cellAt: aPoint)
        at: ((cellRect left right: self cellMargin x)@(cellRect top + ((cellRect height - self font height) // 2))) - topCorner;
        setBackMode: Opaque.!   
drawCell: aPoint  clipRect: clipRect

    "Private - draw a given cell.  Clipping will be done
     with the intersection of clipRect and the cell's rect."

    | cellRect region |

    cellRect := (self rectForCell: aPoint).

    tempClipRect notNil ifTrue: [
        cellRect := cellRect intersect: tempClipRect
    ].

    region := self pen setClipRect: (cellRect intersect: clipRect).

    self pen
        setTextAlign: TaTop;
        setBackMode: Transparent;
        displayText: (self cellAt: aPoint)
        at: (cellRect left right: self cellTextOffset x )@(cellRect top + ((cellRect height - self font height) // 2));
        setBackMode: Opaque.

    self pen destroyRegion: region.!
drawColumnHeaderIn: range

    "Private - draw the column header within range cells.
     If no column header exists, use spreadsheet numbering
     (A, B, ... AA, AB, ... )"

    | startX startY pixelCellWidth beginX header |

    self showColumnHeader ifFalse: [
        ^self
    ].

    pixelCellWidth := self cellSize x.

    beginX := ((range left max: 1) - 1)  * pixelCellWidth + self headerExtent x - topCorner x.
    startY := self headerExtent y - self font height // 2.

    self pen
        fill: (0 @ 0 extent: self fullExtent x@self headerExtent y)
            color: self headerColor;
        setTextAlign: TaTop;
        font: self font;
        foreColor: self foreColor;
        backColor: self headerColor.

    (range left max: 1) to: (range right min: self columns) do: [ :c |
        columnHeader notNil ifTrue: [
            header := columnHeader at: c.
        ] ifFalse: [
            header := self headerLetterStringFor: c.
        ].

        startX := beginX + ((pixelCellWidth - (self font stringWidth: header)) // 2).

        self pen displayText: header at: startX @ startY.
        beginX := beginX + pixelCellWidth.
    ].!   
drawExtraBottomArea

    "Private - blank over any excess window size below
     the number of rows"

    | rect visRect cornerPoint |

    visRect := self visibleRectangle.
    cornerPoint := (self pointForCell: self totalCells + 1) + 1.

    visRect height < cornerPoint y ifTrue: [
        ^self
    ].

    rect := (0@cornerPoint y)
        rightBottom: visRect rightBottom.

    self pen fill: rect color: self headerColor! 
drawExtraRightArea

    "Private - blank over any excess window size to the right of
     the number of columns"

    | rect cornerPoint visRect |

    visRect := self visibleRectangle.
    cornerPoint := (self pointForCell: totalCells + 1) + 1.

    visRect width < cornerPoint x ifTrue: [
        ^self
    ].

    rect := (cornerPoint x@0)
        rightBottom: visRect right @(cornerPoint y min: visRect height).

    self pen fill: rect color: self headerColor!
drawGridIn: range

    "Private - draw the grid"

    | x y pixelStart fullExtent |

    self showGrid ifFalse: [
        ^self
    ].

    pixelStart := self pointForCell: range leftTop.
    fullExtent := self fullExtent + 1.

    self pen
        foreColor: self gridColor.
        x := pixelStart x.
        y := 0.

    (range left max: 1) to: (range right min: totalCells x + 1) do: [ :c |
        self pen lineFrom: x@ y to: x@(y + fullExtent y).
        x := x + self cellSize x.
    ].

    x := 0.
    y := pixelStart y.

    (range top max: 1) to: (range bottom min: totalCells y + 1) do: [ :r |
        self pen lineFrom: x@y to: (x + fullExtent x)@y.
        y := y + self cellSize y.
    ].

    self pen foreColor: self foreColor.!  
drawRowHeaderIn: range

    "Private - draw the row header within range cells.
     If no row header exists, use numbers"

    | startX startY header headerWidth  |

    self showRowHeader ifFalse: [
        ^self
    ].

    startY := (self pointForCell: range leftTop) y + ((self cellSize y - self font height) // 2).

    self pen
        fill: (0 @ 0 extent: self headerExtent x@self fullExtent y)
            color: self headerColor;
        setTextAlign: TaTop;
        font: self font;
        foreColor: self foreColor;
        setBackMode: Transparent.

    headerWidth := self headerExtent x.

    (range top max: 1) to: (range bottom min: self rows) do: [ :r |
        rowHeader notNil ifTrue: [
            header := rowHeader at: r.
        ] ifFalse: [
            header := r printString.
        ].

        rowHeader notNil ifTrue: [
            startX := self rowHeaderMargin.
        ] ifFalse: [
            startX := (headerWidth - (self font stringWidth: header)) // 2.
        ].

        self pen displayText: header at: startX @ startY.
        startY := startY + self cellSize y.
    ].

    self pen setBackMode: Opaque.!  
font: aFont

    super font: aFont.
    headerExtent := nil.
    self cacheCellSize.
    textEditor font: aFont.!
foreColor: aColor

    super foreColor: aColor.
    textEditor foreColor: aColor.! 
gettingFocus

    "Private"
    self doSetFocus.!  
gridColor

    "Private"
    ^self foreColor!  
headerExtent

    "Private - answer the header extent, caching if nil"
    headerExtent isNil ifTrue: [
        self calcHeaderExtent
    ].

    ^headerExtent!   
headerLetterStringFor: aNumber

    "Private - answer the spread sheet numbering
     for a given number (i.e. A, B, ..., AA, AB, ...)"

    | num string |

    num := aNumber - 1.
    string := ''.

    [  num >= 26 ] whileTrue: [
        string := (String with: ((num \\ 26) + 65) asCharacter), string.
        num := (num // 26) - 1.
    ].

    string := (String with: ((num  \\ 26) + 65) asCharacter), string.

    ^string! 
highlightCell: aCell

    "Private - highlight a given cell with an extra border"

    | drawRect region  |

    self handle isValid not ifTrue: [
        ^self
    ].

    "Clip it in case the cell would draw in the header"
    region := self pen setClipRect: self highlightClipRect.
    drawRect :=  (self rectForCell: aCell) insetBy: 1.

    self pen
        drawRectangle: drawRect;
        destroyRegion: region.!
highlightClipRect

    "Private - Answer the cliprect used in drawing highlights.  If they drew
    a header separator line, we want to prevent it from being drawn
     over. This will be true if headerExtent is non zero"

    | clipLeftTop |


    clipLeftTop := self headerExtent.
    clipLeftTop x = 0 ifFalse: [
        clipLeftTop right: 1.
    ].
    clipLeftTop y = 0 ifFalse: [
        clipLeftTop down: 1.
    ].

    ^clipLeftTop rightBottom: self rectangle rightBottom! 
inBounds: aCell

    "Private - added to avoid scrolling as we drag"

    ^(super inBounds: aCell) & (self inVisibleBounds: aCell)!   
initialize

    "Private"

    cellWidth := self defaultCellWidth.
    self cacheCellSize.

    showRowHeader := self defaultShowRowHeader.
    showColumnHeader := self defaultShowColumnHeader.
    showGrid := self defaultShowGrid.
    sparseStorage := self defaultSparseStorage.
    totalCells := 0@0.
    selectedCell := 1@1.
    textEditor := CPChildEntryField new.

    self addSubpane: textEditor.
    textEditor
        framingBlock: [ :b |
            (self inVisibleBounds: self selection) not | self isHandleOk not ifTrue: [
                10000@10000 extent: 10@10
            ] ifFalse: [
                ((self pointForCell: self selection)
                    rightAndDown: self cellTextOffset
                )  extentFromLeftTop: self cellSize - self cellTextOffset - 2
            ].
        ];
        style: textEditor frameStyle - WsBorder;
        owner: self;
        when: #textChanged perform: #selectionChanged:.

    (textEditor respondsTo: #backColor:) ifTrue: [
        textEditor
            backColor: self defaultBackColor;
            foreColor: self defaultForeColor.
    ].

    "Order dependent - expect the show*  values to be set"
    self columns: self defaultColumns.
    self rows: self defaultRows.

    super initialize.!   
initializeCells

    "Private"

    self sparseStorage ifTrue: [
        ^cells := Dictionary new
    ].

    cells := Array new: totalCells y.
    1 to: cells size do: [ :i |
        cells at: i put: (Array new: totalCells x).
    ].!
inVisibleBounds: aCell

    "Private"

    ^(self getTopCell extentFromLeftTop: self visibleCells - 1)
        containsPoint: aCell! 
rowHeaderMargin

    "Private"
    ^2! 
rowHeaders

    ^rowHeader! 
rowHeaders: headerList

    rowHeader := headerList.
    rowHeader notNil ifTrue: [
        self rows: rowHeader size.
    ].!   
rows

    ^totalCells y!
rows: anObject

    totalCells y: anObject.!
scrollTopCorner: newTopCorner

    "Private"

    super scrollTopCorner: newTopCorner.
    textEditor resize: self rectangle.
    textEditor sendInputEvent: #invalidateRect: with: nil.!   
selectedItem

    ^self cellAt: selectedCell!   
selection

    ^selectedCell!   
selection: aCell

    "Minor hack: - we need to hide the cursor while selecting, since we
     may scroll and blit in the process.  We do this by setting the focus
     to the main window temporarily, and back to ourselves if we have the
     focus initially."

    | shouldSetFocus |

    shouldSetFocus := self isHandleOk and: [ textEditor haveFocus ].

    shouldSetFocus ifTrue: [
        self mainWindow setFocus.
    ].
    self unHighlightCell: selectedCell.
    selectedCell := aCell.
    self highlightCell: selectedCell.
    self keepSelectionVisible.
    self updateSelection.

    shouldSetFocus ifTrue: [
        textEditor setFocus.
    ].!  
selectionChanged: aPane

    "Private - the textPane changed, and is notifying us"

    self cellAt: self selection put: aPane contents.
    self event: #textChanged.!  
showColumnHeader

    ^showColumnHeader!
showColumnHeader: anObject

    showColumnHeader := anObject.

    "Uncache"
    headerExtent := nil.!   
showGrid

    ^showGrid!
showGrid: anObject

    showGrid := anObject!   
showRowHeader

    ^showRowHeader!  
showRowHeader: anObject

    showRowHeader := anObject.

    "Uncache"
    headerExtent := nil.! 
sparseStorage

    ^sparseStorage!  
sparseStorage: anObject

    sparseStorage := anObject! 
storeHeader: headerList on: aStream indentString: indentString

    "Private - used by WindowBuilder for code generation"

    headerList do: [ :h |
        aStream nextPutAll: indentString, 'add: ', h printString, ';'; cr.
    ].
    aStream nextPutAll: indentString, 'yourself'.!  
storeSpecificsOn: aStream indentString: indentString

    "Private - used by WindowBuilder for code generation"

    (self rows ~= self defaultRows) & (self rowHeaders isNil or: [ self rowHeaders size ~= self rows ]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'rows: ', self rows printString.
    ].
    (self columns ~= self defaultColumns) & (self columnHeaders isNil or: [ self columnHeaders size ~= self columns ]) ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'columns: ', self columns printString.
    ].
    self cellWidth = self defaultCellWidth ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'cellWidth: ', self cellWidth printString.
    ].
    self headerColor = self defaultHeaderColor ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'headerColor: (ColorConstants at: ', (ColorConstants keyAtValue: self headerColor) asQuotedString, ')'.
    ].
    (self showRowHeader = self defaultShowRowHeader) ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'showRowHeader: ', self showRowHeader printString.
    ].
    (self showColumnHeader = self defaultShowColumnHeader) ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'showColumnHeader: ', self showColumnHeader printString.
    ].
    (self showRowHeader = self defaultShowGrid) ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'showGrid: ', self showGrid printString.
    ].
    (self sparseStorage = self defaultSparseStorage) ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'sparseStorage: ', self sparseStorage printString.
    ].
    self rowHeaders notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'rowHeaders: ('.
        aStream cr; nextPutAll: indentString, '    OrderedCollection new'; cr.
        self storeHeader: self rowHeaders on: aStream indentString: indentString, '        '.
        aStream cr; nextPutAll: indentString, ')'.
    ].
    self columnHeaders notNil ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'columnHeaders: ('.
        aStream cr; nextPutAll: indentString, '    OrderedCollection new'; cr.
        self storeHeader: self columnHeaders on: aStream indentString: indentString, '        '.
        aStream cr; nextPutAll: indentString, ')'.
    ].!  
suggestedSize

    "Private - used by WindowBuilder for determining best size.
     Round size to nearest cell size;  if we're larger than the number
     of cells, shrink to fit exactly."

    | x y |

    x := (rectangle extent x - self headerExtent x roundTo:  cellSize x) + self headerExtent x.
    y := (rectangle extent y  - self headerExtent y roundTo:  cellSize y) + self headerExtent y.

    ^(x@y min: self fullExtent) + 2 "Add right and bottom border".!   
unHighlightCell: aCell

    "Private"

    | drawRect  region |

    self handle isValid not ifTrue: [
        ^self
    ].

    "Clip it in case the cell would draw in the header"
    region := self pen setClipRect: self highlightClipRect.

    drawRect :=  (self rectForCell: aCell) insetBy: 1.

    self pen
        foreColor:  self backColor;
        drawRectangle: drawRect;
        foreColor: self foreColor;
        destroyRegion: region.! 
updateSelection

    "Private - move the texteditor to the new selection point"

    textEditor
        resize: self rectangle;
        setContents: self selectedItem;
        selectAll.
    self  updateWindow.!   
virtualKeyInput: anInt  withKeys: keyArray

    "Private - process keyboard input sent from texteditor"

    | newSel |

    (keyArray includes: ControlKey) ifTrue: [
        anInt =  VkUp ifTrue: [ newSel := self selection - (0@1) ].
        anInt = VkDown ifTrue: [ newSel := self selection + (0@1) ].
        (anInt = VkHome) ifTrue: [ newSel := 1@1 ].
        (anInt = VkEnd) ifTrue: [ newSel := self totalCells ].
        anInt =  VkLeft ifTrue: [ newSel := self selection - (1@0) ].
        anInt = VkRight ifTrue: [ newSel := self selection + (1@0) ].
    ].

    (newSel notNil and: [ super inBounds: newSel ]) ifTrue: [
        (self event: #commitSelection) = false ifFalse: [
            self selection: newSel.
            self event: #select.
        ].
    ].! !

! OSTableView methods !   
atRow: row column: column put: aString

    "Set the string that is at column@row to aString.   If there are labels
     (headers) associated with a given row or column, the argument for
     that coordinate may be a string within the label list rather than a numeric
     index.  Example rows/columns:  1@'Name', 'Name'@1,  'Name'@'Year', 1@1  "

    | cell x y |

    column isString ifTrue: [
        columnHeader isNil ifTrue: [
            ^self error: 'Need column names before indexing'
        ].
        x := (columnHeader indexOf: column).
    ] ifFalse: [
        x :=column.
    ].

    row isString ifTrue: [
        rowHeader isNil ifTrue: [
            ^self error: 'Need row names before indexing'
        ].
        y := (rowHeader indexOf: row).
    ] ifFalse: [
        y := row.
    ].

    self cellAt: x@y put: aString.

    self isHandleOk ifTrue: [
            self invalidateRect: ((self rectForCell: x@y) insetBy: 1@1).
        ]!   
button1DoubleClick: aPoint

    "Private"

    self event: #doubleClickSelect!
cellAt: aPoint

    "Private - answer the cell at a given point.  Public method is
     rowAt:column:, which allows either strings or integer indices."

    | default |
    default := ''.

    cells isNil ifTrue: [ ^default ].

    (self sparseStorage) ifTrue: [
        ^cells at: aPoint ifAbsent: [default]
    ].

    ^(cells at: aPoint y ifAbsent: [^default])
        at: aPoint x ifAbsent: [default]!  
cellAt: aPoint put: aString

    "Private - set the cell at aPoint to aString.  Public method is
     rowAt:column:put:, which allows either strings or integer indices."

    | row |
    cells isNil ifTrue: [
        self initializeCells.
    ].

    self sparseStorage ifTrue: [
        ^cells at: aPoint put: aString
    ].

    row := cells
        at: aPoint y
        ifAbsent: [ cells at: aPoint y put: Dictionary new ].
    row at: aPoint x put: aString.!   
initialize

    "Private"

    super initialize.

    textEditor framingBlock: [:box| 0@0 - 10 extent: 1@1 ].!  
initializeCells

    "Private"

    cells := Dictionary new.! !

! CPSpinEditor class methods ! 
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #valueChanged;
        yourself! !

! CPSpinEditor methods !   
button1DoubleClick: aPoint

    ^self button1Down: aPoint!  
button1Down: point

    | rect |

    fields do: [ :f |
        f isStatic not & (f rect containsPoint: point)  ifTrue: [
            (f == currentField) ifFalse: [
                currentField losingFocus.
            ].
            currentField := f.
        ].
    ].

    self haveFocus & (currentField inputState == #focus) not ifTrue: [
        currentField gettingFocus.
    ].

    self setFocus.

    ((rect := self decrementRect) containsPoint: point) ifTrue: [
        self pen reverse: (self decrementRect insetBy: 1).
        self buttonPushedInRect: self decrementRect method: #decrement.
        ^self pen reverse: (self decrementRect insetBy: 1)
    ].

    ((rect := self incrementRect) containsPoint: point) ifTrue: [
        self pen reverse: (self incrementRect insetBy: 1).
        self buttonPushedInRect: self incrementRect method: #increment.
        self pen reverse: (self incrementRect insetBy: 1).
    ]! 
buttonPushedInRect: inRect method: methodToSend

    | startTime doneOne |

    startTime := Time millisecondClockValue.
    doneOne := false.
    self whileMouseStillDown: [
        (doneOne not | (Time millisecondClockValue > (startTime + 300))) & (inRect containsPoint: self mouseLocation) ifTrue: [
            self perform: methodToSend.
            self event: #valueChanged.
            doneOne := true.
        ].
    ].! 
buttonWidth

    ^17!   
characterInput: aCharacter

    currentField characterInput: aCharacter.
    currentField inEdit ifFalse: [
        self contents.
        self event: #valueChanged.
    ].!   
close
    "Close the receiver"
"    bmps values do: [:each| each release ].
    bmps := Dictionary new."
    ^super close!
contents

    ^currentField value.! 
contents: newValue

    currentField value: newValue!   
decrement

    currentField decrement.! 
decrementRect

    | e bW |

    e := self extent.
    bW := self buttonWidth.

    ^(e x - bW) @ (e y // 2 - 1)  corner: e!   
displayWith: pen inRect: r clipRect: cRect
    "Private - Display the receiver.
    Touched by Ale for proper frame drawing...
    Touched by Ale for getting bitmaps from defualt dictionary if present..."
    | incRect decRect b rect region  |

    rect := self rect translateBy: r leftTop.
    incRect := self incrementRect translateBy: r leftTop.
    decRect := self decrementRect translateBy: r leftTop.

    pen
        fill: rect color: self backColor;
        yourself.
    #modifiedByOStyle.
        "Patch for no rectangle framing...  (Ale)
        foreColor: self middleColor;
        drawRectangle: rect.
        "

    rect := rect leftTop extent: self extent - ((incRect width - 1) @ 0).

    pen
        drawRectangle: rect;
        drawRect3D: rect depth: 1 style: #in;
        fill: incRect color: self middleColor;
        fill: decRect color: self middleColor;
        drawRect3D: incRect  depth: 1 style: #out;
        drawRect3D: decRect depth: 1 style: #out;
        backColor: self middleColor;
        foreColor: self foreColor.

      "Added test whether we're drawing within WB or not to
      determine whether to draw the fields before or after the bitmaps.  It turns out
      that drawing them before caused bitmap display problems in dialogs (?!!)"
    self inWindowBuilder ifTrue: [
        fields do: [:f | f displayAt: rect leftTop with: pen clipRect: cRect ].
    ].

    #modifiedByOStyle.
    b := CPBitmapDict at: 'littleUpArrow' ifAbsent: [CPBitmapDict sysAt: 'littleUpArrow'].
    pen
        copyBitmap: b
        from: b boundingBox
        at:  incRect leftTop + (incRect extent - b extent // 2)
        rule:  Srcand.

    #modifiedByOStyle.
    b := CPBitmapDict at: 'littleDownArrow' ifAbsent: [CPBitmapDict sysAt: 'littleDownArrow'].
   pen
        copyBitmap: b
        from: b boundingBox
        at:  decRect leftTop + (decRect extent - b extent // 2)
        rule:  Srcand.

    self inWindowBuilder ifFalse: [
        fields do: [:f | f displayAt: rect leftTop with: pen clipRect: cRect ].
    ].!   
fieldRect

    ^(0@0 extent: (self extent x - self buttonWidth) @ (self extent y + 1))
        insetBy: 4@6!   
fields: listOfSpinFields

    fields := listOfSpinFields.
    currentField := fields first.!   
gettingFocus

    currentField gettingFocus!
increment

    currentField increment!  
incrementRect

    | e bW |

    e := self extent.
    bW := self buttonWidth.

    ^(e x - bW) @ 0 corner: e x @ (e y // 2 + 1)!  
initialize

    super initialize.
    fields := OrderedCollection new.!
losingFocus

    currentField losingFocus.
    super losingFocus.! 
max

    ^currentField max! 
max: newValue

    ^currentField max: newValue! 
maxSize

    ^30000 @ self suggestedSize y! 
min

    ^currentField min! 
min: newValue

    currentField min: newValue!  
minSize

    ^ (self buttonWidth + 4) @ self suggestedSize y!   
mutationExceptions

    ^#(CPChildEntryField Toggle CPSpinEditor)!  
mutationTypes

    ^#(EntryField StaticText Toggle CPSpinEditor)!   
reframe

    | totalFixed totalVariable charWidth fieldRect x w widths |

    totalFixed := 0.

    charWidth := self font charWidth: $0.
    widths := Dictionary new.
    fields do: [:f |
        f width >= 1 ifTrue: [
            f isStatic ifTrue: [
                w := (self font stringExtent: f value) x.
            ] ifFalse: [
                f choices notNil ifTrue: [
                    w := 0.
                    f choices do: [:choice | w := w max: (self font stringExtent: choice) x ].
                ] ifFalse: [
                    w := f width * charWidth.
                ].
            ].
            widths at: f put: w + 2.
            totalFixed := totalFixed + w + 2.
        ].
    ].

    fieldRect := self fieldRect.
    totalVariable := fieldRect width - totalFixed.

    x := fieldRect left.
    fields do: [:f |
        f width >= 1 ifTrue: [
            f rect: ((x @ fieldRect top) extent: (widths at: f) @ fieldRect height).
        ] ifFalse: [
            f rect: ((x @ fieldRect top) extent: (f width * totalVariable) rounded @ fieldRect height).
        ].
        x := x + f rect width.
    ].!
shiftLeft

    | f |

    (currentField == fields first) | ((fields select: [:f | f isStatic not ]) size <= 1) ifTrue: [
        ^self
    ].

    f := currentField.
    [   f := fields before: f.
            (f isStatic not) | (f == fields first)
    ] whileFalse: [].

    f == currentField ifFalse: [
        currentField losingFocus.
        currentField := f.
        currentField gettingFocus.
    ].!  
shiftRight

    | f |

    (currentField == fields last) | ((fields select: [:f | f isStatic not ]) size <= 1) ifTrue: [
        ^self
    ].

    f := currentField.
    [   f := fields after: f.
            (f isStatic not) | (f == fields last)
    ] whileFalse: [].

    f == currentField ifFalse: [
        currentField losingFocus.
        currentField := f.
        currentField gettingFocus.
    ].!
suggestedSize

    ^100 @ (self font height + 8)!   
valueChanged! 
virtualKeyInput: anInt  withKeys: keyArray

    | changed |

    changed := false.

    anInt = VkLeft ifTrue:  [^self shiftLeft ].
    anInt = VkRight ifTrue: [^self shiftRight ].

    anInt =  VkUp ifTrue: [  self  increment. changed := true ].
    anInt = VkDown ifTrue: [ self decrement. changed := true ].
    (anInt = VkHome) & currentField min notNil ifTrue: [
        currentField value: currentField min; display. changed := true.
    ].
    (anInt = VkEnd) & currentField max notNil ifTrue: [
        currentField value: currentField max; display. changed := true.
    ].

    changed ifTrue: [
        self event: #valueChanged.
    ].! !

! CPDateEditor methods ! 
addFields: order

    | editFields |

    order == #dmy ifTrue: [
        editFields := Array with: dayField with: monthField with: yearField.
    ] ifFalse: [
        order == #mdy ifTrue: [
            editFields := Array with: monthField with: dayField with: yearField.
        ] ifFalse: [
            editFields := Array with: yearField with: monthField with: dayField.
        ].
    ].

    fields := OrderedCollection new
        add: (editFields at: 1);
        add: (
            SpinField new
                parent: self;
                value: separator
        );
        add: (editFields at: 2);
        add: (
            SpinField new
                parent: self;
                value: separator
        );
        add: (editFields at: 3);
        yourself.

    currentField := fields first.!
attributeEditor

    ^(Smalltalk at: #WBDateEditorEditor) new!  
century

    ^yearField width = 4!  
century: bool

    yearField width: (bool ifTrue: [ 4 ] ifFalse: [ 2 ]).!   
changesSize

    ^true! 
characterInput: aCharacter

    currentField characterInput: aCharacter.
    (fields select: [:f | f inEdit ]) isEmpty ifTrue: [
        self contents.
        self event: #valueChanged.
    ].!  
contents
    "Touched by LRP for better implementation (zero values validation)"
    | d m y |

    (d := self day) = 0 ifTrue: [ ^nil].
    (m :=  self month) = 0  ifTrue: [ ^nil].
    (y := self year) isNil ifTrue: [ ^nil].
    #modifiedByOStyle.

    ^Date newDay: d month: (Date nameOfMonth: m) year: y!  
contents: aDate

    aDate isNil ifTrue: [ ^nil ].
    monthField value: aDate monthIndex.
    dayField value: aDate dayOfMonth.
    yearField value: aDate year!
copySpecificsTo: aPane

    aPane
        separator: self separator;
        format: self format;
        dayLeadingZero: self dayLeadingZero;
        monthLeadingZero: self monthLeadingZero;
        century: self century.!
day

    dayField value: (1 max: (dayField value min: self lastDayInMonth)).
    ^dayField value.! 
dayLeadingZero

    ^dayField showLeadingZeros! 
dayLeadingZero: bool

    dayField showLeadingZeros: bool.! 
decrement

    (currentField == dayField) ifTrue: [
        self decrementDay
    ] ifFalse: [
        (currentField == monthField) ifTrue: [
            self decrementMonth.
        ] ifFalse: [
            self decrementYear.
        ].
    ].

    self contents.!
decrementDay

    (dayField value = 1) ifTrue: [
        self decrementMonth.
        dayField value: self lastDayInMonth.
    ] ifFalse: [
        dayField decrement.
    ].!
decrementMonth

    (monthField value = 1) ifTrue: [
        monthField value: 12.
        self decrementYear.
    ] ifFalse: [
        monthField decrement
    ].!   
decrementYear

    (yearField value = 0) ifTrue: [
        yearField value: 99.
    ] ifFalse: [
        yearField decrement.
    ].!   
format

    ^format!
format: f

    format := f asLowerCase asSymbol.
    self addFields: format.

    self isHandleOk ifTrue: [
        self reframe.
        self invalidateRect: nil.
    ].!   
formatChanged
    "Private - Set the receiver's format"
    self format: (#( mdy dmy ymd ) at: NationalLanguage dateFormat + 1).!   
increment

    (currentField == dayField) ifTrue: [
        self incrementDay
    ] ifFalse: [
        (currentField == monthField) ifTrue: [
            self incrementMonth.
        ] ifFalse: [
            self incrementYear.
        ].
    ].

    self contents.!
incrementDay

    (dayField value = self lastDayInMonth) ifTrue: [
        dayField value: 1.
        self incrementMonth.
    ] ifFalse: [
        dayField increment.
    ].!
incrementMonth

    (monthField value = 12) ifTrue: [
        monthField value: 1.
        self incrementYear.
    ] ifFalse: [
        monthField increment
    ].!   
incrementYear

    (yearField value = 99) ifTrue: [
        yearField value: 0.
    ] ifFalse: [
        yearField increment.
    ].!   
initialize

    super initialize.

    dayField :=
        SpinField new
            parent: self;
            width: 2;
            justification: #right;
            showLeadingZeros: true;
            value: 1.

    monthField :=
        SpinField new
            parent: self;
            width: 2;
            showLeadingZeros: true;
            justification: #right;
            value: 1.

    yearField :=
        SpinField new
            parent: self;
            width: 2;
            min: 0;
            justification: #right;
            value: 1.

    separator := '/'.

    self format: #mdy.

    self contents: Date today.!  
lastDayInMonth
    " LRP 23/JUN/93 patched para que en DDMMAA
    cuando se ingresa el dia no falle "
    | m |
    #modifiedByOStyle.
    m := self month.
    m = 0 ifTrue: [^31].

    ^Date daysInMonth: (Date nameOfMonth: m) forYear: yearField value!  
maxSize

    ^30000 @ self suggestedSize y! 
minSize

    ^self suggestedSize!   
month

    monthField value: ((monthField value max: 1) min: 12).
    ^monthField value!   
monthLeadingZero

    ^monthField showLeadingZeros! 
monthLeadingZero: bool

    monthField showLeadingZeros: bool!  
readSpecificsFrom: aPane

    self
        separator: aPane separator;
        format: aPane format;
        dayLeadingZero: aPane dayLeadingZero;
        monthLeadingZero: aPane monthLeadingZero;
        century: aPane century.!  
separator

    ^separator!  
separator: s

    separator := s.
    fields notNil ifTrue: [
        fields do: [:f | f isStatic ifTrue: [ f value: s ] ].
    ].!  
storeSpecificsOn: aStream indentString: indentString

    self separator = '/' ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'separator: ', self separator asQuotedString.
    ].

    " LRP touched no debe generar formato, en el initialize toma el default del Control Panel"
    #modifiedByOStyle.
"
    self format = #mdy ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'format: #', self format.
    ].
"
    self dayLeadingZero ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'dayLeadingZero: false'.
    ].
    self monthLeadingZero ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'monthLeadingZero: false'.
    ].
    self century ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'century: true'.
    ].!
suggestedSize

    yearField width = 4 ifTrue: [
        ^(self font stringExtent: '00', separator asString, '00', separator asString, '0000') + (33@8)
    ] ifFalse: [
        ^(self font stringExtent: '00', separator asString, '00', separator asString, '00') + (33@8)
    ].!   
winIniChange: aString
    "Update the receiver contents..."
"
    self
        formatChanged;
        display.

    UserLibrary messageBeep: 0.
"!
year
    | y |
    y := yearField value.
    y = 0 ifTrue: [ ^nil ].
    y < 1900 ifTrue: [ y := y + 1900 ].
    ^y! !

! CPNumericEditor methods !
attributeEditor

    ^(Smalltalk at: #WBValuatorEditor) new!
canShowPercentage

    ^false!  
characterInput: aCharacter

    currentField characterInput: aCharacter.
    self contents.
    self event: #valueChanged.!   
contents

    | c |

    (c := super contents) = '-' ifTrue: [
        ^(0 min: (currentField max isNil ifTrue: [ 0 ] ifFalse: [ currentField max ])) max: (currentField min isNil ifTrue: [ 0 ] ifFalse: [ currentField min ])
    ] ifFalse: [
        ^c
    ].!   
controlKeyInput: c

    c == (CharacterConstants at: 'Bs') ifTrue: [
        currentField backspace.
        self contents.
        self event: #valueChanged.
    ].!  
copySpecificsTo: aPane

    aPane
        min: self min;
        max: self max;
        contents: self contents! 
initialize

    super initialize.
    fields := OrderedCollection with:
        (currentField := SpinField new
            parent: self;
            width: 0.99;
            justification: #right;
            value: 0;
            min: nil max: nil).!  
storeSpecificsOn: aStream indentString: indentString

    self min isNil ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'min: ', self min asString.
    ].

    self max isNil ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'max: ', self max asString.
    ].

    self contents = 0 ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'contents: ', self value asString.
    ].!
value

    ^self contents!  
value: v

    self contents: v! !

! CPSpinButton class methods ! 
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        remove: #valueChanged;
        add: #select;
        yourself! !

! CPSpinButton methods ! 
attributeEditor

    ^(Smalltalk at: #WBListEditor) new!
centered

    currentField justification: #center!  
contents

    ^currentField choices!
contents: listOfStrings

    currentField choices: listOfStrings!   
copySpecificsTo: aPane

    aPane
        justification: currentField justification;
        contents: self contents! 
cpStyle

    | styleDict |

    styleDict := Dictionary new.
    styleDict
        at: #left put: #leftJustified;
        at: #right put: #rightJustified;
        at: #center put: #centered.

    ^styleDict at: currentField justification!  
decrement

    ^super increment!
event: theEvent

    theEvent == #valueChanged ifTrue: [
        ^self event: #select
    ].

    ^super event: theEvent!   
increment

    ^super decrement!
initialize

    super initialize.

    fields := OrderedCollection with:
        (currentField := SpinField new
            parent: self;
            width: 0.99;
            choices: #('Monday' 'Tuesday' 'Wednesday' 'Thursday' 'Friday');
            justification: #center).! 
justification: j

    currentField justification: j!
leftJustified

    currentField justification: #left!   
rightJustified

    currentField justification: #right! 
selectedItem

    ^currentField choices at: currentField value! 
selection

    ^currentField value! 
selection: s

    s isInteger ifTrue: [
        currentField value: s
    ] ifFalse: [
        currentField value: (currentField choices indexOf: s).
    ].!   
storeSpecificsOn: aStream indentString: indentString
    "OSI 12/27/92 - Write out the list"
    self contents isNil ifFalse: [
        (self contents isArray and: [ self contents notEmpty ]) ifTrue: [
            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'contents: #( '.
                self contents do:[ :item | aStream nextPutAll: item asQuotedString,' ' ].
                aStream nextPutAll: ')' ] ].!   
styles

    ^#(centered leftJustified rightJustified)!  
usesContents

    ^true!
valueChanged

    self event: #select! !

! CPTimeEditor methods !
amString

    ^meridianField choices first! 
amString: a pmString: p

    meridianField
        choices: (Array with: a with: p);
        width: (a size max: p size).!
attributeEditor

    ^(Smalltalk at: #WBCPTimeEditorEditor) new!
changesSize

    ^true! 
contents

    | hours |

    hours := self hour.

    format == #hour24 ifTrue: [
        hours = 24 ifTrue: [
            hours := 0.
        ].
    ] ifFalse: [
        (meridianField value = 2) ifTrue: [
            hours < 12 ifTrue: [
                hours := hours + 12.
            ].
        ] ifFalse: [
            hours = 12 ifTrue: [
                hours := 0
            ].
        ].
    ].

    ^Time
        hours:hours
        minutes: self minute
        seconds: 0.!   
contents: newTime

    | hours |

    (self contents = newTime or: [ newTime isNil ]) ifTrue: [
        ^self
    ].

    hours := newTime hours.

    format == #hour24 ifTrue: [
        hours = 0 ifTrue: [
            hours := 24.
        ].
    ] ifFalse: [
        (hours >= 12) ifTrue: [
            meridianField value: 2.
            (hours > 12) ifTrue: [
                hours := hours - 12.
            ].
        ] ifFalse: [
            meridianField value: 1.
            (hours = 0) ifTrue: [
                hours := 12.
            ].
        ].
    ].

    hourField value: hours.
    minuteField value: newTime minutes.!
copySpecificsTo: aPane

    aPane
        separator: self separator;
        format: self format;
        leadingZero: self leadingZero;
        amString: self amString pmString: self pmString.!  
decrement

    (currentField == hourField) ifTrue: [
        self decrementHour
    ] ifFalse: [
        (currentField == minuteField) ifTrue: [
            self decrementMinute
        ] ifFalse: [
            meridianField decrement.
        ].
    ].

    self contents! 
decrementHour

    format == #hour24 ifTrue: [
        (self hour = 1) ifTrue: [
            ^hourField value: 24
        ].

        hourField decrement.
    ] ifFalse: [

        (self hour = 1) ifTrue: [
            ^hourField value: 12
        ].

        (self hour = 12) ifTrue: [
            hourField value: 11.
            meridianField decrement.
        ] ifFalse: [
            hourField decrement
        ].
    ].!  
decrementMinute

    (minuteField value = 0) ifTrue: [
        minuteField value: 59.
        self decrementHour.
    ] ifFalse: [
        minuteField decrement
    ].!   
format

    ^format!
format: f

    format := f.
    format == #hour24 ifTrue: [
        fields remove: meridianField ifAbsent: [ nil ].
    ] ifFalse: [
        (fields includes: meridianField) ifFalse: [
            fields add: meridianField.
        ].
    ].

    self isHandleOk ifTrue: [
        self reframe.
        self invalidateRect: nil.
    ].!
hour

    format == #hour12 ifTrue: [
        hourField value: ((hourField value max: 1) min: 12).
    ] ifFalse: [
        hourField value: ((hourField value max: 1) min: 24).
    ].

    ^hourField value!
increment

    (currentField == hourField) ifTrue: [
        self incrementHour
    ] ifFalse: [
        (currentField == minuteField) ifTrue: [
            self incrementMinute
        ] ifFalse: [
            meridianField increment.
        ].
    ].

    self contents! 
incrementHour

    format == #hour24 ifTrue: [
        (self hour = 24) ifTrue: [
            ^hourField value: 1
        ].

        hourField increment.
    ] ifFalse: [
        (self hour = 12) ifTrue: [
            ^hourField value: 1
        ].

        (self hour = 11) ifTrue: [
            hourField value: 12.
            meridianField increment.
        ] ifFalse: [
            hourField increment
        ].
    ].!
incrementMinute

    (minuteField value = 59) ifTrue: [
        minuteField value: 0.
        self incrementHour.
    ] ifFalse: [
        minuteField increment
    ].!   
initialize

    super initialize.

    hourField :=
        SpinField new
            parent: self;
            width: 2;
            justification: #right;
            value: 1.

    minuteField :=
        SpinField new
            parent: self;
            width: 2;
            showLeadingZeros: true;
            justification: #right;
            value: 1.

    meridianField :=
        SpinField new
            parent: self;
            width: 2;
            choices: #('AM' 'PM');
            justification: #center.

    separator := ':'.

    fields := OrderedCollection new
        add: hourField;
        add: (
            SpinField new
                parent: self;
                value: separator;
                justification: #center
        );
        add: minuteField;
        add: (
            SpinField new
                parent: self;
                value: ' '
        );
        add: meridianField;
        yourself.

    currentField := hourField.

    format := #hour12.

    self contents: Time now.!  
leadingZero

    ^hourField showLeadingZeros!   
leadingZero: bool

    hourField showLeadingZeros: bool!
maxSize

    ^30000 @ self suggestedSize y! 
minSize

    ^self suggestedSize!   
minute

    minuteField value: ((minuteField value max: 0) min: 59).

    ^minuteField value! 
pmString

    ^meridianField choices last!  
separator

    ^separator!  
separator: s

    separator := s.
    (fields after: hourField) value: s.! 
storeSpecificsOn: aStream indentString: indentString

    self separator = ':' ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'separator: ', self separator asQuotedString.
    ].
    self amString = 'AM' ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'amString: ', self amString asQuotedString, ' pmString: ', self pmString asQuotedString.
    ].

    self format = #hour12 ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'format: #', self format.
    ].
    self leadingZero ifTrue: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'leadingZero: true'.
    ].!   
suggestedSize

    | merSize |

    format == #hour12 ifTrue: [
        merSize := (self font stringExtent: self amString) x max: (self font stringExtent: self pmString) x.
    ] ifFalse: [
        merSize := 0.
    ].
    ^(self font stringExtent: '00', separator asString, '00 ') + (merSize @ 0) + (33@8)! !

! CPValuator class methods !
supportedEvents

    ^super supportedEvents
        add: #valueChanged;
        yourself! !

! CPValuator methods ! 
attributeEditor

    ^(Smalltalk at: #WBValuatorEditor) new!
bounded: aValue

    | newValue |

    newValue := aValue.

    min notNil & newValue notNil ifTrue: [
        newValue := newValue max: min.
    ].
    max notNil & newValue notNil ifTrue: [
        newValue := newValue min: max.
    ].

    ^newValue!
canShowPercentage

    ^false!  
contents

    ^self value!  
contents: i

    self value: i! 
copySpecificsTo: aPane

    aPane
        min: self min;
        max: self max;
        value: self value.!  
decrement

    self internalValue: self value - 1.! 
increment

    self internalValue: self value + 1.! 
initialize

    super initialize.

    min := 1.
    max := 10.
    value := 3.!
internalValue: aValue

    (self value: aValue) = false ifFalse: [
        self event: #valueChanged.
        self event: #valueChanging.
    ].!
invalidRect

    ^(self rect insetBy: 2)!   
max
    max isNil ifTrue: [ max := 3 ].
    ^max!   
max: value1

    max := value1.

    self internalValue: self value.! 
min
    min isNil ifTrue: [ min := 1 ].
    ^min!   
min: value1

    min := value1.

    self internalValue: self value.! 
mutateSpecificsFrom: aPane

    self initialize.
    (aPane respondsTo: #min) ifTrue: [
        self min: aPane min
    ] ifFalse: [ (aPane respondsTo: #minimum) ifTrue: [
        self min: aPane minimum
    ]].
    (aPane respondsTo: #max) ifTrue: [
        self max: aPane max
    ] ifFalse: [ (aPane respondsTo: #maximum) ifTrue: [
        self max: aPane maximum
    ]].
    (aPane respondsTo: #value) ifTrue: [
        self value: aPane value
    ] ifFalse: [
        self value: self min
    ].
    self max isNil ifTrue: [ self max: 10 ].
    self min isNil ifTrue: [ self min: 1 ].
    self value isNil ifTrue: [ self value: 3 ].!
mutationExceptions

    ^#(CPValuator CPGauge CPSlider)!
mutationTypes

    ^#(CPValuator ScrollBar)!
storeSpecificsOn: aStream indentString: indentString

    self min = 1 ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'min: ', self min asString.
    ].

    self max = 10 ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'max: ', self max asString.
    ].

    self contents = 3 ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'contents: ', self value asString.
    ].!   
usesFont

    ^false!   
value
    value isNil ifTrue: [ value := 3 ].
    ^value!   
value: aValue

    | newValue |

    newValue := self bounded: aValue.

    (value = newValue) ifFalse: [
        value := newValue.
    ] ifTrue: [
        ^false
    ].

    rectangle notNil ifTrue: [
        self invalidateRect: self invalidRect.
    ].!   
virtualKeyInput: anInt  withKeys: keyArray

    anInt =  VkUp ifTrue: [  self  increment ].
    anInt = VkDown ifTrue: [ self decrement ].
    anInt = VkHome ifTrue: [
        self internalValue: min.
    ].
    anInt = VkEnd ifTrue: [
        self internalValue: max.
    ].
    anInt = VkLeft ifTrue:  [self decrement ].
    anInt = VkRight ifTrue: [self increment ].! !

! CPGauge methods !
canShowPercentage

    ^true!   
copySpecificsTo: aPane

    super copySpecificsTo: aPane.
    aPane showPercentage: self showPercentage.!  
displayPercentageWith: pen inRect: rect clipRect: cRect

    | color region |

    showPercentage ifTrue: [

        color := ClrBlack.
        (self foreColor == ClrBlack) | (self backColor == ClrBlack) ifTrue: [
            (self foreColor == ClrWhite) | (self backColor == ClrWhite) ifTrue: [
                color := self middleColor.
            ] ifFalse: [
                color := ClrWhite.
            ].
        ].

        region := pen setClipRect: ((self invalidRect translateBy: rect leftTop) intersect: cRect) .
        pen
            place: rect center;
            foreColor: color;
            setTextAlign: TaTop;
            setBackMode: Transparent;
            font: self font;
            centerText: (self value - self min / (self max - self min) * 100) rounded asString, '%';
            destroyRegion: region.
    ].!  
initialize

    super initialize.
    showPercentage := true.! 
showPercentage

    ^showPercentage!
showPercentage: bool

    showPercentage := bool!   
storeSpecificsOn: aStream indentString: indentString

    super storeSpecificsOn: aStream indentString: indentString.
    self showPercentage ifFalse: [
        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'showPercentage: false'.
    ].! !

! CPCircularGauge methods !
backColorOLD

    | c |

    "(SubPane respondsTo: #backColor) ifTrue: ["
        (c := super backColor) isNil ifTrue: [
            ^parent cpBackColor
        ] ifFalse: [
            ^c
        ].
    "] ifFalse: [
        backColor11 isNil ifTrue: [
            ^self defaultBackColor
        ] ifFalse: [
            ^backColor11
        ].
    ]."!
defaultBackColor

    ^UserLibrary getSysColor: ColorWindow!
displayWith: pen inRect: r clipRect: cRect

    | angle rect major minor b maskBitmap region |

    rect := self rect.

    angle := (self value - self min) * 360 // (self max - self min).
    major := rect width // 2.
    minor := rect height // 2.


    b := Bitmap screenExtent: self extent.
    b pen fill: b boundingBox color: self backColor.

    b pen
        place: rect center;
        foreColor: self foreColor; backColor: self foreColor;
        pieFilled: major minor: minor angles: 270 @  angle;
        foreColor: self backColor; backColor: self backColor.
    angle = 360 ifFalse: [
        b pen
            place: rect center;
            pieFilled: major minor: minor angles: (270 + angle) @ (360 - angle).
    ].
    b pen
        foreColor: ClrBlack;
        ellipse: major minor: minor.

    self displayPercentageWith: b pen inRect: (0@0 extent: rect extent) clipRect: (0@0 extent: cRect extent).


    b displayAt: r leftTop with: pen.

    b release.!  
invalidRect

    ^self rect! !

! CPHorizontalBarGauge methods !  
displayWith: pen inRect: r clipRect: cRect

    | x rect insideRect |

    rect := self rect translateBy: r leftTop.
    insideRect := rect insetBy: 2.

    x := (self value - self min) * insideRect width // (self max - self min).

    pen
        foreColor: ClrBlack;
        drawRectangle: rect;
        drawRect3D: rect depth: 1 style: #in;
        fill: (insideRect leftTop extent: x @ insideRect height) color: self foreColor;
        fill: (insideRect leftTop + (x@0) corner: insideRect corner) color: self backColor.

    self displayPercentageWith: pen inRect: rect clipRect: cRect.!   
mutationRotationList

    ^#(WBVerticalScrollBar CPVerticalBarGauge CPVerticalSlider)!  
suggestedSize

    ^100@20! !

! CPVerticalBarGauge methods ! 
displayWith: pen inRect: r clipRect: cRect

    | y rect insideRect |

    rect := self rect translateBy: r leftTop.
    insideRect := rect insetBy: 2.

    y := (self value - self min) * insideRect height // (self max - self min).

    pen
        foreColor: ClrBlack;
        drawRectangle: rect;
        drawRect3D: rect depth: 1 style: #in;
        fill: (insideRect leftBottom extentFromLeftBottom: insideRect width @ y) color: self foreColor;
        fill: ((insideRect leftBottom up: y) rightTop: insideRect rightTop) color: self backColor.

    self displayPercentageWith: pen inRect: rect clipRect: cRect.!   
mutationRotationList

    ^#(WBHorizontalScrollBar CPHorizontalBarGauge CPHorizontalSlider)!
suggestedSize

    ^20@100! !

! CPSlider class methods ! 
supportedEvents

    ^super supportedEvents
        add: #valueChanged;
        add: #valueChanging;
        yourself! !

! CPSlider methods ! 
backColor: c

    super backColor: c.
    thumbBitmap notNil ifTrue: [
        self reframe.
    ].! 
button1Down: aPoint

    self setFocus.

    (self thumbRect containsPoint: aPoint) ifTrue:  [
        thumbButtonOrigin := (
            self dragForm: thumbBitmap
                origin: thumbButtonOrigin
                constrainedBy: (self rect insetBy: 2)).
        self internalValue: (self pointToValue: thumbButtonOrigin).
    ] ifFalse: [
        self internalValue: (self pointToValue: aPoint - (self thumbSize // 2)).
    ].!  
button2DoubleClick: aPoint

    ^self button2Down: aPoint!  
button2Down: aPoint

    | doneOne startTime |

    self setFocus.
    doneOne := false.
    startTime := Time millisecondClockValue.

    self whileMouseStillDown: [
        (doneOne not | (Time millisecondClockValue > (startTime + 300))) & (self rect containsPoint: self mouseLocation) ifTrue: [
            self button2StillDown: self mouseLocation.
            doneOne := true.
        ].
    ].! 
close

    super close.
    thumbBitmap notNil ifTrue: [
        thumbBitmap release.
    ].!
disable

    self disabled ifTrue: [ ^self ].

    self propertyAt: #holdBackColor put: self backColor.
    self backColor: (ColorConstants at: 'ClrDarkgray').
    super disable.! 
displayWith: pen inRect: r

    | rect |

    rect := self rect translateBy: r leftTop.

    thumbButtonOrigin := self thumbOrigin + rect leftTop.

    pen
        foreColor: self middleColor;
        drawRectangle: rect;
        drawRect3D: rect depth: 1 style: #in;
        fill: (rect insetBy: 2) color: self backColor.

    thumbBitmap displayAt: thumbButtonOrigin with: pen.

    self haveFocus ifTrue: [
        self gettingFocus.
    ].!
dragForm: bitmap origin: origin constrainedBy: constrainRect

    | mouseLoc  moveRect  newPoint delta  |

    moveRect := origin extent: bitmap extent.

    delta := self mouseLocation - moveRect leftTop.

    self whileMouseStillDown: [
        mouseLoc := self mouseLocation.
        newPoint := mouseLoc - delta.

        newPoint x: ((newPoint x rightMost: constrainRect left) leftMost: (constrainRect right left: moveRect width)).
        newPoint y: ((newPoint y lowerOf: constrainRect top) higherOf: (constrainRect bottom up: moveRect height)).

        (newPoint = moveRect leftTop) ifFalse: [
            (moveRect nonIntersections: (newPoint extent: bitmap extent)) do: [:r |
                self pen fill: r color: self backColor.
            ].
            bitmap displayAt: newPoint with: self pen.
            moveRect moveTo: newPoint.
            value := (self pointToValue: moveRect leftTop).

            self event: #valueChanging.
        ].
    ].

    value := nil.

     ^moveRect leftTop!   
enable

    self backColor: (self propertyAt: #holdBackColor).
    super enable.!  
gettingFocus

    self drawFocusRect: ((self thumbOrigin extent: thumbBitmap extent) insetBy: 2 )!  
losingFocus

    self gettingFocus.
    super losingFocus.!
thumbOrigin

    ^2@2!  
thumbRect

     ^thumbButtonOrigin extent: thumbBitmap extent!  
thumbSize

    ^21! 
usesMenu

    ^false! !

! CPHorizontalSlider methods !   
button2StillDown: aPoint

    aPoint x < thumbButtonOrigin x ifTrue: [ self decrement ].
    aPoint x > self thumbRect right ifTrue: [ self increment ].!  
minSize

    ^(4 + self thumbSize) @ 7! 
mutationRotationList

    ^#(WBVerticalScrollBar CPVerticalBarGauge CPVerticalSlider)!  
pointToValue: p

    ^(((p x - 2)) * (self max - self min) // (self width - 4 - thumbBitmap width) + self min).!
reframe

    | c |

    thumbBitmap notNil ifTrue: [
        thumbBitmap release.
    ].

    thumbBitmap := Bitmap screenExtent: self thumbSize @ (rectangle height - 4).

    thumbBitmap pen
        foreColor: self middleColor;
        drawRectangle: thumbBitmap boundingBox;
        fill: (thumbBitmap boundingBox insetBy: 1) color: self backColor;
        foreColor: self darkerColor;
        lineFrom: ((c := thumbBitmap boundingBox center x) @ 3) to: c@(thumbBitmap height - 3);
        foreColor: self lighterColor.
    c := c + 1.
    thumbBitmap pen
        lineFrom: (c @ 3) to: c@(thumbBitmap height - 3);
        drawRect3D: thumbBitmap boundingBox depth: 1 style: #out.!
suggestedSize

    ^100@20! 
thumbOrigin

    self max = self min ifTrue: [
        ^2@2
    ].

    ^(2 + ((self value - self min) * (self width - 4 - thumbBitmap width) // (self max - self min))) @ 2.! !

! CPVerticalSlider methods !
button2StillDown: aPoint

    aPoint y < thumbButtonOrigin y ifTrue: [ self increment ].
    aPoint y > self thumbRect bottom ifTrue: [ self decrement ].! 
minSize

    ^7@(4 + self thumbSize)!   
mutationRotationList

    ^#(WBHorizontalScrollBar CPHorizontalBarGauge CPHorizontalSlider)!
pointToValue: p

    | v |

    v := ((p y - 2) * (self max - self min) // (self height - 4 - thumbBitmap height) + self min).

    ^self max - (v - self min)! 
reframe

    | c |

    thumbBitmap notNil ifTrue: [
        thumbBitmap release.
    ].

    thumbBitmap := Bitmap screenExtent: (self width - 4) @ self thumbSize.

    thumbBitmap pen
        drawRectangle: thumbBitmap boundingBox;
        fill: (thumbBitmap boundingBox insetBy: 1) color: self backColor;
        foreColor: self darkerColor;
        lineFrom: (3 @ (c := thumbBitmap boundingBox center y)) to: (thumbBitmap width - 3) @ c;
        foreColor: self lighterColor.
    c := c + 1.
    thumbBitmap pen
        lineFrom: (3 @ c) to: (thumbBitmap width - 3) @ c;
        drawRect3D: thumbBitmap boundingBox depth: 1 style: #out.!  
suggestedSize

    ^20@100! 
thumbOrigin

    | o |

    self max = self min ifTrue: [
        o := 2
    ] ifFalse: [
        o := ((self value - self min) * (self height - 4 - thumbBitmap height) // (self max - self min)).
    ].

    ^2 @ (self height - 2 - o - thumbBitmap height)! !

! CPValueSet class methods !  
supportedEvents

    ^super supportedEvents
        add: #select;
        add: #doubleClickSelect;
        yourself! !

! CPValueSet methods ! 
attributeEditor

    ^(Smalltalk at: #WBValueSetEditor) new!
backColor: c

    super backColor: c.
    bitmap notNil ifTrue: [
        self cacheBitmap.
    ].!  
bitmapItem: i row: r column: c

    self cellAt: c@r put: i.!   
button1DoubleClick: aPoint

    self setFocus.
    self selection: (self cellForPoint: aPoint).
    self event: #doubleClickSelect!   
button1Down: aPoint

    | cell point currentSelection |

    self setFocus.

    currentSelection := selection.

    self whileMouseStillDown: [
        point := self mouseLocation.
        cell := self cellForPoint: point.
        (self inBounds: cell) ifFalse: [
            "was within the palette on last pass through the loop."
            currentSelection = (0@0) ifFalse: [
                self unHighlightCell: currentSelection.
                currentSelection := 0@0.
            ].
        ] ifTrue: [
            (currentSelection = cell) ifFalse: [
                currentSelection = (0@0) ifFalse: [
                    self unHighlightCell: currentSelection.
                ].
                self highlightCell: cell.
                currentSelection := cell.
            ].
        ].
    ].

    currentSelection ~= (0@0) ifTrue: [
        selection := currentSelection.
        self event: #select.
    ] ifFalse: [
        self highlightCell: selection.
    ].!  
cacheBitmap

    | pixelLoc cellExtent e aRect cellContents region |
                     true ifTrue: [ ^self ].
    cellExtent := self cellExtent.
    e := columnsRows * cellExtent.

    bitmap := Bitmap new ownDCScreenWidth: e x height: e y.

    pixelLoc := 0@0.
    1 to: columnsRows x do: [:c |
        1 to: columnsRows y do: [:r |
            cellContents := self cellAt: c@r.
            aRect := pixelLoc extent: cellExtent.
            bitmap pen
                foreColor: self foreColor;
                backColor: self backColor;
                drawRectangle: aRect;
                fill: (aRect insetBy: 3) color: self backColor;
                drawRect3D: aRect depth: 2 style: #out;
                foreColor: self foreColor;
                backColor: self backColor.
                region := bitmap pen setClipRect: (aRect insetBy: 3).
            cellContents notNil ifTrue: [
                cellContents isBitmap ifTrue: [
                    cellContents displayAt: aRect leftTop + (aRect extent - cellContents extent // 2) with: bitmap pen.
                ] ifFalse: [
                    cellContents isInteger ifTrue: [
                        bitmap pen fill: (aRect insetBy: 3) color: cellContents.
                    ] ifFalse: [
                        bitmap pen
                            setTextAlign: TaTop;
                            displayText: cellContents at: aRect leftTop + (aRect extent - (self font stringExtent: cellContents) // 2).
                    ].
                ].
            ].
            bitmap pen destroyRegion: region.
            pixelLoc y: (pixelLoc y + cellExtent y).
        ].
        pixelLoc y: 0.
        pixelLoc x: (pixelLoc x + cellExtent x).
    ].!   
cellAt: cell
    "Modified by Ale for overflow when clicking outside
     the buttons (about rounding errors)"

    | row |
    #modifiedByOStyle.
    (cell x between: 1 and: cells size) ifFalse: [^nil].
    row := cells at: cell x.
    (cell y between: 1 and: row size) ifFalse: [^nil].
    ^row at: cell y

    "^(cells at: cell x) at: cell y"! 
cellAt: cell put: i

    ^(cells at: cell x) at: cell y put: i! 
cellExtent

    ^self extent // columnsRows!
cellForPoint: aPoint

    ^(aPoint // self cellExtent) + 1! 
cells: c

    cells := c.!  
colorItem: i row: r column: c

    self cellAt: c@r put: i.!
columnsRows

    ^columnsRows!  
columnsRows: p

    | newCells |

    newCells := Array new: p x.
    1 to: p x do: [:i |
        newCells at: i put: (Array new: p y).
    ].

    1 to: (columnsRows x min: p x) do: [:c |
        1 to: (columnsRows y min: p y) do: [:r |
            (newCells at: c) at: r put: (self cellAt: c@r).
        ].
    ].

    columnsRows := p.
    selection := 1@1.
    cells := newCells.! 
copySpecificsTo: aPane

    aPane
        columnsRows: self columnsRows;
        cells: cells deepCopy.!  
displayWith: pen inRect: r

    parent notNil ifTrue: [
        pen fill: self rect color: parent cpBackColor.
    ].
    bitmap isNil ifTrue: [
        self drawOn: pen at: r leftTop.
    ].

    (selection ~= (0@0)) & graphicsTool notNil ifTrue: [
        self highlightCell: selection.
    ].!   
displayWith: pen inRect: r clipRect: cRect

    parent notNil ifTrue: [
        pen fill: self rect color: parent cpBackColor.
    ].
    bitmap isNil ifTrue: [
        self drawOn: pen at: r leftTop clipRect: cRect.
    ].

    (selection ~= (0@0)) & graphicsTool notNil ifTrue: [
        self highlightCell: selection.
    ].!   
drawFocusOn: cell checkFocus: bool

    bool & self haveFocus not ifTrue: [ ^self ].

    self drawFocusRect: ((self rectForCell: cell) insetBy: 4).! 
drawOn: aPen at: aPoint

    | pixelLoc cellExtent e aRect cellContents region |

    cellExtent := self cellExtent.

    pixelLoc := aPoint deepCopy.
    1 to: columnsRows x do: [:c |
        1 to: columnsRows y do: [:r |
            cellContents := self cellAt: c@r.
            aRect := pixelLoc extent: cellExtent.
            aPen
                foreColor: self foreColor;
                backColor: self backColor;
                drawRectangle: aRect;
                fill: (aRect insetBy: 3) color: self backColor;
                drawRect3D: aRect depth: 2 style: #out;
                foreColor: self foreColor;
                backColor: self backColor.
                region := aPen setClipRect: (aRect insetBy: 3).
            cellContents notNil ifTrue: [
                cellContents isBitmap ifTrue: [
                    cellContents displayAt: aRect leftTop + (aRect extent - cellContents extent // 2) with: aPen.
                ] ifFalse: [
                    cellContents isInteger ifTrue: [
                        aPen fill: (aRect insetBy: 3) color: cellContents.
                    ] ifFalse: [
                        aPen
                            setTextAlign: TaTop;
                            displayText: cellContents at: aRect leftTop + (aRect extent - (self font stringExtent: cellContents) // 2).
                    ].
                ].
            ].
            aPen destroyRegion: region.
            pixelLoc y: (pixelLoc y + cellExtent y).
        ].
        pixelLoc y: aPoint y.
        pixelLoc x: (pixelLoc x + cellExtent x).
    ].!   
drawOn: aPen at: aPoint  clipRect: cRect

    | pixelLoc cellExtent e aRect cellContents region |

    cellExtent := self cellExtent.

    pixelLoc := aPoint deepCopy.
    1 to: columnsRows x do: [:c |
        1 to: columnsRows y do: [:r |
            cellContents := self cellAt: c@r.
            aRect := pixelLoc extent: cellExtent.
            region := aPen setClipRect: cRect.

            aPen
                foreColor: self foreColor;
                backColor: self backColor;
                drawRectangle: aRect;
                fill: (aRect insetBy: 3) color: self backColor;
                drawRect3D: aRect depth: 2 style: #out;
                foreColor: self foreColor;
                backColor: self backColor;
                destroyRegion: region.
            (cellContents notNil and: [ cellContents isBitmap not ]) ifTrue: [
                region := aPen setClipRect: ((aRect insetBy: 3) intersect: cRect).
                cellContents isInteger ifTrue: [
                    aPen fill: (aRect insetBy: 3) color: cellContents.
                ] ifFalse: [
                    aPen
                        setTextAlign: TaTop;
                        displayText: cellContents at: aRect leftTop + (aRect extent - (self font stringExtent: cellContents) // 2).
                ].
                aPen destroyRegion: region.
            ].
            pixelLoc y: (pixelLoc y + cellExtent y).
        ].

        pixelLoc y: aPoint y.
        pixelLoc x: (pixelLoc x + cellExtent x).
    ].

    "Moved drawing of bitmaps to end, so they wouldn't
     prevent drawing of other aspects to an offscreen bitmap"
    pixelLoc := aPoint deepCopy.
    1 to: columnsRows x do: [:c |
        1 to: columnsRows y do: [:r |
            cellContents := self cellAt: c@r.
            (cellContents notNil and: [ cellContents isBitmap ]) ifTrue: [

                aRect := pixelLoc extent: cellExtent.
                region := aPen setClipRect: ((aRect insetBy: 3) intersect: cRect).
                cellContents displayAt: aRect leftTop + (aRect extent - cellContents extent // 2) with: aPen.
                aPen destroyRegion: region.
            ].
            pixelLoc y: (pixelLoc y + cellExtent y).
        ].

        pixelLoc y: aPoint y.
        pixelLoc x: (pixelLoc x + cellExtent x).
    ].!  
foreColor: c

    super foreColor: c.
    bitmap notNil ifTrue: [
        self cacheBitmap.
    ].!  
gettingFocus

    self drawFocusOn: selection checkFocus: false!
highlightCell: aPoint
    "Touched by Ale for better drawing..."
    | cell |
    #modifiedByOStyle.
    cell := self cellAt: aPoint.
    cell isNil ifTrue: [^self].

    cell isInteger ifTrue: [
        self pen drawRectangle: ((self rectForCell: aPoint) insetBy: 4).
    ] ifFalse: [
        self pen reverse: ((self rectForCell: aPoint) insetBy: 1).
    ].

    self drawFocusOn: aPoint checkFocus: true!  
inBounds: cell

    ^(cell x > 0) & (cell y > 0) & (cell x <= columnsRows x) & (cell y <= columnsRows y)!   
initialize

    super initialize.
    selection := 1@1.
    self rows: 2 columns: 2.! 
losingFocus

    self drawFocusOn: selection checkFocus: false.
    super losingFocus.!
rectForCell: cell

    | cellExtent |

    cellExtent := self cellExtent.

    ^(cell - 1) * (self cellExtent)
        extent: self cellExtent!
reframe

    (bitmap isNil or: [ bitmap extent ~= (self cellExtent * columnsRows) ]) ifTrue: [
        self cacheBitmap.
    ].!  
rgbItem: i row: r column: c

    self cellAt: c@r put: i.!  
rows: r columns: c

    columnsRows := c @ r.
    selection := 1@1.

    cells := Array new: c.
    1 to: c do: [:i |
        cells at: i put: (Array new: r).
    ].!
selectedItem

    ^self cellAt: selection!  
selection

    ^selection!  
selection: cell

    "Modified by Ale..."
    #modifiedByOStyle.
    self pen notNil ifTrue: [
        self unHighlightCell: selection.
    ].
    selection := cell.
    self pen notNil ifTrue: [
        self highlightCell: cell.
    ].!   
storeSpecificsOn: aStream indentString: indentString

    | key cellContents |

    aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'rows: ', columnsRows y asString, ' columns: ', columnsRows x asString.

    1 to: columnsRows x do: [:c |
        1 to: columnsRows y do: [:r |
            (cellContents := self cellAt: c@r) notNil ifTrue: [
                cellContents isBitmap ifTrue: [
                    (key := CPBitmapDict keyAtValue: cellContents ifAbsent: [ nil ]) notNil ifTrue: [
                        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'bitmapItem: (CPBitmapDict at: ', key asQuotedString, ') row: ', r asString, ' column: ', c asString.
                    ].
                ] ifFalse: [
                    cellContents isInteger ifTrue: [
                        (key := ColorConstants keyAtValue: cellContents ifAbsent: [ nil ]) notNil ifTrue: [
                            aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'colorItem: (ColorConstants at: ', key asQuotedString, ') row: ', r asString, ' column: ', c asString.
                        ].
                    ] ifFalse: [
                        aStream nextPutAll: ';'; cr; nextPutAll: indentString, 'textItem: ', cellContents asQuotedString, ' row: ', r asString, ' column: ', c asString.
                    ].
                ].
            ].
        ].
    ].!
textItem: i row: r column: c

    self cellAt: c@r put: i.! 
unHighlightCell: aPoint

    "Touched by Ale for better drawing..."
    | cell pen |
    #modifiedByOStyle.
    cell := self cellAt: aPoint.
    cell isNil ifTrue: [^self].
    pen := self pen.
    pen isNil ifTrue: [^self].
    self drawFocusOn: aPoint checkFocus: true.
    cell isInteger ifTrue: [
        self pen fill: ((self rectForCell: aPoint) insetBy: 3) color: cell.
    ] ifFalse: [
        self pen reverse: ((self rectForCell: aPoint) insetBy: 1).
    ].!
usesFont

    ^false!   
virtualKeyInput: anInt  withKeys: keyArray

    | newSel |

    anInt =  VkUp ifTrue: [ newSel := selection + (0@-1) ].
    anInt = VkDown ifTrue: [ newSel := selection + (0@1) ].
    (anInt = VkHome) ifTrue: [ newSel := 1@1].
    (anInt = VkEnd) ifTrue: [ newSel := columnsRows ].
    anInt = VkLeft ifTrue:  [ newSel := selection + (-1@0) ].
    anInt = VkRight ifTrue: [ newSel := selection + (1@0) ].

    newSel isNil ifTrue: [
        ^self
    ].

    (self inBounds: newSel) ifTrue: [
        self selection: newSel.
        self event: #select.
    ].! !

! StaticText3D methods ! 
contents
    "Returns the instance var of the receiver
     for external manipulation"
    ^contents!  
contents: aString
    "Sets the receiver's contents and update it"
    | rect |
    contents := aString.
    self handle isValid
    ifTrue: [
        rect := self rectangle.
        self invalidateRect: (rect leftTop extentFromLeftTop: rect extent x @ (self font height + 10)).
    ].!
displayWith: pen inRect: r
    "Private - Display the receiver"

    | rect inRect |
    rect := r leftTop extent: self extent.
    pen
        fill: rect color: self backColor;
        foreColor: self foreColor.
    drawBorder = true
    ifTrue: [ pen drawRectangle: rect ].
    pen
      setBackMode: Transparent;
      setTextAlign: TaTop;
      foreColor: ClrWhite.
    pen place: rect leftTop + 1.
    self drawText: contents with: pen inside: rect.
    pen
        place: rect leftTop;
        foreColor: self foreColor.
    self drawText: contents with: pen inside: rect.!
drawBorder
    "Returns the instance var of the receiver
     for external manipulation"
    ^drawBorder!  
drawBorder: aBoolean
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    drawBorder := aBoolean! 
drawText: aString with: aPen inside: aRectangle
    "Private - Display aString using aPen inside aRectangle"

    | font line stream start displayLine truncate |
    font := aPen font.
    stream := ReadStream on: aString.
    displayLine := [
        aPen
            "
            displayText: line at: aPen location;
            place: 0 @ (aPen location y + font height)
            "
            nextPutAll: line;cr
    ].
    truncate := [ line := line copyFrom: 1 to: line size - 1].
    [stream atEnd or: [ aPen location y > aRectangle bottom ]]
    whileFalse: [
        start := stream position.
        line := stream nextLine.
        (font stringWidth: line) < aRectangle width
        ifTrue: [ displayLine value ]
        ifFalse: [
            [(font stringWidth: line) > aRectangle width and: [line isEmpty not]]
            whileTrue: truncate.
            ((line notEmpty and: [line last isSeparator not])
                 and: [(line select: [:c| c isSeparator]) isEmpty not ])
            ifTrue: [ [ line last isSeparator not ] whileTrue: truncate ].
            stream
                position: start;
                next: line size.
            displayLine value.
        ]
    ].!
usesColor

    ^true!   
usesFont

    ^true!
usesTitle

    ^true! !

! RulerBar class methods !   
boxSize
    "Private - Returns the size for boxes rulers"
    ^1@1 * SysFont height!
supportedEvents

    ^super supportedEvents
        add: #select;
        add: #doubleClick;
        yourself! !

! RulerBar methods ! 
bitmap
    "Returns the instance var of the receiver
     for external manipulation"
    ^bitmap!  
bitmap: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    bitmap := anObject! 
bottom
    "Sets the receivers style..."

    type := #bottom.
    framingBlock := [:box |
        0@ (box height - self boxSize y) extent: box width - self boxSize x @ self boxSize y ].!  
boxFor: aBlock
    "Private - Returns the box for the receiver"

    self isHandleOk ifFalse: [ self visible: false ].

    ^self visible
    ifTrue: [ aBlock value ]
    ifFalse: [ -1@-1 extent: 0@0 ]! 
boxSize
    "Private - Returns the size for boxes rulers"
    ^self class boxSize!  
button1DoubleClick: aPoint
        "Private - Left button has been double clicked.
        Let the owner process the event."

    self event: #doubleClick.!  
button1Down: aPoint
    "Private - Process the click message"

    (super button1Down: aPoint) ifFalse: [^self].

    self event: #select!   
cpStyle

    ^type! 
defaultFont
        "Private - Answer the default font for the ruler."
    ^Font face:'Helv' size:(0 @ (self boxSize y - 5)) fixedWidth:false!  
displayWith: pen inRect: r
    "Private - Display the receiver"

    | rect inRect |
    rect := r leftTop extent: self extent.
    pen
        fill: rect color: self backColor;
        foreColor: self foreColor.
    drawBorder = true
    ifTrue: [ pen drawRect3D: rect depth: 1 style: #out ].

    (#(left right top bottom) includes: type)
    ifTrue: [
        self
            drawMarksFrom: self start
            by: self step
            with: pen
            in: (rect insetBy: 1)
    ].

    bitmap notNil ifTrue: [
        pen copyBitmap: bitmap from: bitmap boundingBox at: r leftTop.
    ].

    contents isNil ifTrue: [^self].
    pen
      setBackMode: Transparent;
      setTextAlign: TaTop;
      foreColor: ClrWhite.
    pen place: rect leftTop + (3@2).
    self drawText: contents with: pen inside: rect.
    pen
        place: rect leftTop + (2@1);
        foreColor: self foreColor.
    self drawText: contents with: pen inside: rect.!  
drawMarksFrom: from by: increment with: pen in: rect
    "Private - Draw the scale in the receiver"

    | positions stream point value origin label |

    stream := ReadStream on: #(
       "type......origin..step..mark"
        left      ( (0.6 0) (0 1) (0.4 0) )
        top      ( (0 0.6) (1 0) (0 0.4) )
        right    ( (0 0) (0 1) (0.4 0) )
        bottom ( (0 0) (1 0) (0 0.4) )
        ).

    [stream atEnd] whileFalse: [
        stream next = type
        ifTrue: [ positions := stream next ]
        ifFalse: [ stream next ]
    ].

    point := [:index| (positions at: index) first @ (positions at: index) last ].

    value := from.
    pen place: rect origin + ((point value: 1) * rect extent) truncated.
    [   origin := pen location.
        rect containsPoint: origin] whileTrue: [
        "falta poner los labels..."
        pen
            foreColor: ClrDarkgray;
            place: origin + 1;
            goto: origin + ((point value: 3) * rect extent) truncated + 1;
            place: origin;
            foreColor: ClrWhite;
            goto: origin + ((point value: 3) * rect extent) truncated;
            place: origin +((point value: 2) * increment);
            yourself.
        value := value + increment.
    ]!   
framingBlock: aBlock
    "FrammingBloxk is Ignored it must be setUp with the style......"!   
initialize
    "Private - Initializes the receiver"

    super initialize.
    drawBorder := true.
    start := 0.
    step := 10.
    type isNil ifTrue: [ self left ].!  
left
    "Sets the receivers style..."

    type := #left.
    framingBlock := [:box |
      self boxFor: [
        box leftTop + (0@self boxSize y) extent: self boxSize x
           @ (box height - self boxSize y) ]
    ].!  
leftBottom
    "Sets the receivers style..."

    type := #leftBottom.
    framingBlock := [:box |
      self boxFor: [
        box leftBottom - (0@ self boxSize y) extent: self boxSize ]
    ].!
leftTop
    "Sets the receivers style..."

    type := #leftTop.
    framingBlock := [:box |
      self boxFor: [
        box leftTop extent: self boxSize ]
    ].!   
right
    "Sets the receivers style..."

    type := #right.
    framingBlock := [:box |
      self boxFor: [
        box right - self boxSize x @ 0 extent: self boxSize x @ (box height - self boxSize y) ]
    ].!  
rightBottom
    "Sets the receivers style..."

    type := #rightBottom.
    framingBlock := [:box |
      self boxFor: [
        box rightBottom - self boxSize y extent: self boxSize ]
    ].!  
rightTop
    "Sets the receivers style..."

    type := #rightTop.
    framingBlock := [:box |
      self boxFor: [
        box rightTop extent: self boxSize ]
    ].!
start
    "Returns the instance var of the receiver
     for external manipulation"

    start isContext ifTrue: [ ^start value: type ].
    ^start! 
start: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    start := anObject!   
step
    "Returns the instance var of the receiver
     for external manipulation"

    step isContext ifTrue: [ ^step value: type ].
    ^step! 
step: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    step := anObject! 
styles

    ^#(left top right bottom leftTop rightTop leftBottom rightBottom)!  
suggestedSize

    ^self boxSize!   
top
    "Sets the receivers style..."

    type := #top.
    framingBlock := [:box |
      self boxFor: [
        box origin + (self boxSize x @0)
         extent: box width - self boxSize x @ self boxSize y ]
    ].! 
type
    "Returns the instance var of the receiver
     for external manipulation"
    ^type!  
usesFocus

    ^false!  
usesMenu

    ^false!   
usesTitle

    ^false! !

! GraphPane methods !   
close
    "Private - Close the receiver and destroy the device context."

    #modifiedByOStyle.
    "must stop receiving messages prior to releasing graphics tool
     & graphics tool releasing is granted by Window>>#close...
     graphicsTool release.
    "
    super close.
    graphicsTool release.!  
mouseLocation
        "Answer the mouse location as of the last
         mouse input event received."
    | winPoint |
    graphicsTool isNil ifTrue: [^0@0].
    winPoint := WinPoint fromPoint: mouse.
    GDILibrary
        dpToLp: graphicsTool handle
        point: winPoint asParameter
        count: 1.
    ^winPoint asPoint!
noBorders

    "Added by OSI"

    #addedByOSI.
    ^style := self basicStyle |
        WsChild   |
        WsVisible! 
noScrollBars

    "Added by OSI"

    #addedByOSI.
    ^style := self basicStyle |
        WsChild   |
        WsVisible |
        WsBorder! !

! NoScrollGraphPane class methods ! 
supportedEvents
        "Private - Answer the Set of events that GraphPanes can notify
         their owners about and events for activation/deactivation."
    ^super supportedEvents
        add: #activate;
        add: #deactivate;
        yourself! !

! NoScrollGraphPane methods !   
activate
    "Activates the receiver"
    super activate.

    self event: #activate.!
backSpace
    "Perform event backSpace"
    Terminal bell!  
currentCursor
    "Private - Answer the mouse cursor that's
    appropriate for the receiver window.
    Implemented by Ale for changing cursor shapes"

    | cursor |
    cursor := self propertyAt: #cursor.
    cursor isNil ifFalse: [^cursor].
    ^super currentCursor!
deactivate
    "Deactivates the receiver"
    super deactivate.

    self event: #deactivate.!
defaultStyle
    "Private - Answer an Integer with appropriate styles in it."
    ^self frameStyle! 
frameStyle
        "Private - Answer an Integer with appropriate FCF_ bits in it."
    ^WsBorder |
    WsChild   |
    WsVisible |
    WsClipsiblings |
    WsClipchildren! 
scrollingRectangle
    "Private - Answer the rectangle."
    ^rectangle!
setCursor: aCursor
    "Private - Set the mouse cursor that's
    appropriate for the receiver window.
    aCursor can be aCursorManager
    or aString to be used for loading
    the cursor from default resource file.
    Implemented By Ale..."
    | cursor |
    aCursor isString
    ifFalse: [ cursor := aCursor ]
    ifTrue: [
        cursor := CursorManager
            loadCursor: aCursor
            fromDLL: ObjectStyleDLL library
    ].
    self propertyAt: #cursor put: cursor! 
setScrollRanges
        "Private - Set scroll ranges."
    UserLibrary
        setScrollRange: self asParameter
        bar: SbHorz
        min: 0
        max: 0
        redraw: false.
    UserLibrary
        setScrollRange: self asParameter
        bar: SbVert
        min: 0
        max: 0
        redraw: false!   
updateSliders
        "Private - Update the slider boxes in the scrollbars."!
validate
        "Private - The window for the receiver was
         just created or recreated."

    rectangle notNil ifTrue: [^super validate].! !

! OSImagePane class methods ! 
supportedEvents
        "Private - Answer the Set of events that GraphPanes can notify
         their owners about and events for activation/deactivation."
    ^super supportedEvents
        add: #activate;
        add: #deactivate;
        add: #setScrollRectangle;
        yourself! !

! OSImagePane methods !  
activate
    "Activates the receiver"
    super activate.

    self event: #activate.!
amountToPageLeft
        "Private - Answer the number of pixels for
         horizontal page scrolling."
    ^self rectangle width * 2 // 3!   
amountToPageUp
        "Private - Answer the number of pixels for
         vertical page scrolling."
    ^self rectangle height * 2 // 3!  
close
    "Private - Close the receiver and destroy the device context.
    Must also release the cursor. Ale."

    self releaseCursor.
    ^super close!   
currentCursor
    "Private - Answer the mouse cursor that's
    appropriate for the receiver window.
    Implemented by Ale for changing cursor shapes"

    | cursor |
    cursor := self propertyAt: #cursor.
    cursor isNil ifFalse: [^cursor].
    ^super currentCursor!
deactivate
    "Deactivates the receiver"
    super deactivate.

    self event: #deactivate.!
initialize
    "Private - Initialize the receiver."
    super initialize.
    self thumbtrack: true.
    topCorner := 0@0.!   
rectangleToDisplay
    "Returns the instance var of the receiver
     for external manipulation"
    ^rectangleToDisplay!  
releaseCursor
    "Private - Releases the current cursor resource
    Implemented by Ale for changing cursor shapes"
    | cursor |
    (self propertyAt: #mustReleaseCursor) = true ifFalse: [^self].
    self propertyAt: #mustReleaseCursor put: nil.
    cursor := self propertyAt: #cursor.
    cursor isNil ifFalse: [^cursor].
    self propertyAt: #cursor put: nil.
    cursor release.!
scrollingRectangle
        "Private - Answer the rectangle expanded by
         its own extent for scrolling purpose."
    | rect |
    rect := self propertyAt: #scrollingRectangle.
    rect notNil ifTrue: [^rect].
    ^super scrollingRectangle!   
scrollingRectangle: aRectangle
    "Sets the scrolling rectangle."
    | left top bottom right rect |
    rect := self rectangle.
    left := aRectangle left min: rect left.
    top := aRectangle top min: rect top.
    right := (aRectangle right - rect width) max: rect right.
    bottom := (aRectangle bottom - rect height) max: rect bottom.
    self
        propertyAt: #scrollingRectangle
        put: (left @ top rightBottom: right@bottom) truncated!  
setCursor: aCursor
    "Private - Set the mouse cursor that's
    appropriate for the receiver window.
    aCursor can be aCursorManager
    or aString to be used for loading
    the cursor from default resource file.
    Implemented By Ale..."
    | cursor |

    aCursor == self currentCursor ifTrue: [^self].

    self releaseCursor. "release old cusor..."

    aCursor isString
    ifFalse: [ cursor := aCursor ]
    ifTrue: [
        "loaded by the default resource file..."
        cursor := CursorManager
            loadCursor: aCursor
            fromDLL: ObjectStyleDLL library.
        "the current cursor will be released automatically"
        self propertyAt: #mustReleaseCursor put: cursor notNil.
    ].
    self propertyAt: #cursor put: cursor!  
setScrollRanges
    "Private - Set the ranges for the horizontal and vertical
        scroll bars."
    | rangeRect minHorz maxHorz minVert maxVert |

    self event: #setScrollRectangle.

    rangeRect := self scrollingRectangle.
    minHorz := rangeRect left.
    maxHorz := rangeRect right.
    minVert := rangeRect top.
    maxVert := rangeRect bottom.
    (self style bitAnd: WsHscroll) = 0
        ifTrue: [minHorz := maxHorz := 0].
    (self style bitAnd: WsVscroll) = 0
        ifTrue: [minVert := maxVert := 0].
    UserLibrary
        setScrollRange: self asParameter
        bar: SbHorz
        min: minHorz
        max: maxHorz
        redraw: false.
    UserLibrary
        setScrollRange: self asParameter
        bar: SbVert
        min: minVert
        max: maxVert
        redraw: false.!  
thumbtrack: aBoolean
    "Use the Thumbtrack option with sliders.
     Usefull when fast scrolling..."

    self propertyAt: #thumbtrack put: aBoolean!   
validate
    "Private - The window for the receiver was just created or recreated.
     Patched by Ale for no validation of invalid saved graphPanes.
     This happends when an error occures when creating the
     pane & save the image with the view open."

    rectangle notNil ifTrue: [^super validate].!  
visibleRectangle
    "Answer the currently displaying rectangle."
    | origin |
    self isHandleOk ifFalse: [^0@0 extent: 0@0].
    graphicsTool isNil ifTrue: [^0@0 extent: 0@0].
    origin := WinPoint fromBytes: (
            GDILibrary getViewportOrg: graphicsTool handle).
    ^self rectangle translateBy: origin asPoint negated! 
wmErasebkgnd: wordInteger with: longInteger
    "Private - Process the Win erase background message."

    ^1! 
wmHScroll: wordInteger with: longInteger
        "Private - Process a WM_HSCROLL message."
    | type sb slider pos |
    type := wordInteger.

    (type = SbThumbtrack and: [true = (self propertyAt: #thumbtrack)])
        ifTrue: [
            pos := WinStructure new: 4.
            pos uLongAtOffset: 0 put: longInteger.
            pos := pos shortAtOffset: 0.
            self updateHorizontalSliderTo: pos.
            self scrollHorizontal: self topCorner x - pos.
            ^nil
        ].

    ^super wmHScroll: wordInteger with: longInteger!  
wmPaint: wparam with: lparam
        "Private - Process the paint message."
    | paintStructure rectStruct |
    paintStructure := WinAddress copyToNonSmalltalkMemory:
        WinPaintStructure new asParameter.

    UserLibrary
         beginPaint: self asParameter
         paintStructure:  paintStructure asParameter.

    rectangleToDisplay := (WinPaintStructure fromAddress: paintStructure) rectangle asRectangle.
    self display.

    UserLibrary
        endPaint: self asParameter
        paintStructure: paintStructure asParameter.

    paintStructure unlockAndFree.
     ^1!
wmVScroll: wordInteger with: longInteger
        "Private - Process a WM_VSCROLL message."
    | type sb slider pos |
    type := wordInteger.

    (type = SbThumbtrack and: [true = (self propertyAt: #thumbtrack)])
        ifTrue: [
            pos := WinStructure new: 4.
            pos uLongAtOffset: 0 put: longInteger.
            pos := pos shortAtOffset: 0.
            self updateVerticalSliderTo: pos.
            self scrollVertical: self topCorner y - pos.
            ^nil
        ].

    ^super wmVScroll: wordInteger with: longInteger! !

! CompositePane class methods ! 
isScratchWindow

    ^false!
open

    self openWithParent: nil! 
openWithParent: aViewManager

    WBCompositePaneTester new openOn: self parent: aViewManager!  
supportedEvents

    ^Set with: #getContents.!  
wbCreated

    ^false!  
wbCreatedClasses

    ^self allSubclasses select: [ :c |
        c wbCreated
    ].! !

! CompositePane methods !   
addSubpane: aWindow
        "Add aWindow as the child of the receiver."
    |id|

    self
        children;
        addToSubpaneOrder: aWindow.

    id := aWindow propertyAt:#id.
    id isNil ifTrue:[ aWindow propertyAt:#id put: self getNextChildId].
    "Check if duplicate 'idCancel' or 'idOK' message might have been sent to the childs of this window."
    self children at: self getNextChildSlot put: aWindow.
    aWindow parent: self.
    aWindow owner isNil ifTrue: [
        aWindow owner: self owner].

    (self mainWindow propertyAt: #focusWindow) isNil & aWindow isWsTabstop ifTrue: [
        self mainWindow propertyAt: #focusWindow put: aWindow.
    ].

    (self mainWindow respondsTo: #add:interestIn:) ifTrue: [
        self mainWindow add: aWindow interestIn: aWindow name.
    ].! 
addSubpanes
    "Does nothing - overriden by subclasses"!
amountToPageLeft
        "Private - Answer the number of pixels for
         horizontal page scrolling."
    ^64!  
amountToPageUp
        "Private - Answer the number of pixels for
         vertical page scrolling."
    ^64!  
amountToScrollLeft
        "Private - Answer the number of pixels
         for horizontal scrolling."
    ^8!  
amountToScrollUp
        "Private - Answer the number of pixels
         for vertical scrolling."
    ^8!  
basicStyle
        "Private - Answer an Integer with appropriate styles in it."
    ^WsChild |
     WsVisible |
     WsClipsiblings!  
borders

    ^style := self basicStyle | WsBorder!  
changed: aFacet

    (self children select: [ :child |
        (child handlers at: #getContents ifAbsent: [ nil ]) == aFacet ]) do: [ :child |
        child update ].!   
charsInColumn
        "Private - Answer the receiver frame height."
    ^rectangle height!  
charsInRow
        "Private - Answer the receiver frame width."
    ^rectangle width!   
children

    children isNil ifTrue: [ children := IdentityDictionary new].
    ^children! 
children: aCollection

    children := aCollection! 
clearFocus
    self setFocus: nil.!  
cpBackColor: aColor

    self backColor isNil ifTrue: [
        self backColor: aColor
    ]! 
cpForeColor: aColor

    self foreColor isNil ifTrue: [
        self foreColor: aColor
    ]! 
defaultStyle
        "Private - Answer an Integer with appropriate styles in it."
    ^self basicStyle.!
disable

    super disable.
    self children do: [ :child | child disable ]!  
display

    self doGraphics: [
        self pen fill: self rectangle color: self backColor
    ].
    super display.!   
enable

    super enable.
    self children do: [ :child | child enable ]! 
frameStyle
        "Private - Answer an Integer with appropriate styles in it."
    ^self basicStyle.!  
framingBlock: aBlock

    (self framingBlock isNil or: [self framingBlock isContext]) ifTrue: [
        super framingBlock: aBlock
    ].
    aBlock isNil ifTrue: [
        super framingBlock: aBlock
    ] ifFalse: [
        initialSize := (aBlock value: Display boundingBox) extent
    ]!
getFocus
    ^self propertyAt: #focus.!  
getGroupFor: aPane
    | order first last index |
    index := (order := self getSubpaneOrder) indexOf: aPane.
    first := (1 to: index) asArray reversed detect: [ :i | (order at: i) isWsGroup] ifNone: [index].
    last := ((index + 1 to: order size) detect: [ :i | (order at: i) isWsGroup] ifNone: [order size + 1]) - 1.
    first == last ifTrue: [ ^Array with: aPane ].
    ^order copyFrom: first to: last!   
getNextFocus: aPane
    | order |
    ((order := self getSubpaneOrder) notEmpty and: [ aPane ~= (order at: order size)]) ifTrue: [
        1 to: order size do: [ :i |
            (order at: i) = aPane ifTrue: [
                i + 1 to: order size do: [ :j |
                    (order at: j) isWsTabstop ifTrue: [
                        (order at: j) setFocus.
                        self clearFocus.
                        ^true
                    ].
                ].
            ].
        ].
    ].
    self parent isCompositePane ifTrue: [
        (self parent getNextFocus: self) ifTrue: [^true]
    ].
    self clearFocus.
    ^false!
getNextFocusInGroup: aPane
    | order index next |
    (order := self getGroupFor: aPane) notEmpty ifTrue: [
        (index := order indexOf: aPane) == order size ifTrue: [
            (next := order at: 1) setFocus
        ] ifFalse: [
            (next := order at: index + 1) setFocus
        ].
    ].
    next isRadio ifTrue: [
        order do: [ :pane |
            pane == next ifTrue: [
                next selection: true
            ] ifFalse: [ pane isRadio ifTrue: [
                pane selection: false
            ]].
        ].
    ].
    self clearFocus.! 
getPreviousFocus: aPane
    | order |
    ((order := self getSubpaneOrder) notEmpty and: [ aPane ~= (order at: 1)]) ifTrue: [
        1 to: order size do: [ :i |
            (order at: i) = aPane ifTrue: [
                (1 to: i - 1) reverseDo: [ :j |
                    (order at: j) isWsTabstop ifTrue: [
                        (order at: j) setFocus.
                        self clearFocus.
                        ^true
                    ].
                ].
            ].
        ].
    ].
    self parent isCompositePane ifTrue: [
        (self parent getPreviousFocus: self) ifTrue: [^true]
    ].
    self clearFocus.
    ^false! 
getPreviousFocusInGroup: aPane
    | order index next |
    (order := self getGroupFor: aPane) notEmpty ifTrue: [
        (index := order indexOf: aPane) == 1 ifTrue: [
            (next := order at: order size) setFocus
        ] ifFalse: [
            (next := order at: index - 1) setFocus.
        ].
    ].
    next isRadio ifTrue: [
        order do: [ :pane |
            pane == next ifTrue: [
                next selection: true
            ] ifFalse: [ pane isRadio ifTrue: [
                pane selection: false
            ]].
        ].
    ].
    self clearFocus.!
gettingFocus
    | pane |
    "Set the focus to the appropriate child"
    pane := self getFocus.
    pane isNil ifTrue: [
        (Notifier isKeyDown: VkShift) ifTrue: [
            pane := self getSubpaneOrder reversed detect: [ :c | c isWsTabstop ] ifNone: [ nil ]
        ] ifFalse: [
            pane := self getSubpaneOrder detect: [ :c | c isWsTabstop ] ifNone: [ nil ]
        ].
    ].
    pane isNil ifFalse: [
        pane isCompositePane ifTrue: [
            pane gettingFocus
        ] ifFalse: [ pane isRadio ifTrue: [
            pane := (self getGroupFor: pane) detect: [ :p | p selection ] ifNone: [ pane ]
        ]].
        pane setFocus
    ].!  
horizontalScrollMaxRange
        "Private - Answer the horizontal scrollbar's max range"
|maxPos|

    UserLibrary getScrollRange: self handle asParameter
                bar: SbHorz
                lpMinPos: (WinStructure new: 2) asParameter
                lpMaxPos: (maxPos := WinStructure new: 2) asParameter.

    ^ maxPos shortAtOffset:0! 
horizontalScrollMinRange
        "Private - Answer the horizontal scrollbar's max range"
|minPos|

    UserLibrary getScrollRange: self handle asParameter
                bar: SbHorz
                lpMinPos: (minPos := WinStructure new: 2) asParameter
                lpMaxPos: (WinStructure new: 2) asParameter.

    ^ minPos shortAtOffset:0! 
horizontalScrollPos
        "Private - Answer the horizontal scrollbar's position"

    ^UserLibrary getScrollPos: self handle asParameter bar: SbHorz!
isCompositePane

    ^true! 
label
    ^''!   
menuWindow

    ^MenuWindow new!
open

    self preInitWindow.
    graphicsTool notNil
        ifTrue: [graphicsTool release].
    ^super open!   
pStyle

    ^#(composite)!  
resize: aRectangle deferInfo: winPosInfo
    | posInfo |
    posInfo := super resize: aRectangle deferInfo: winPosInfo.
    self setScrollRanges.
    self scrollTopCornerTo: 0@0.
    self updateSliders.
    ^posInfo!
scrollbars

    ^style := self basicStyle | WsBorder | WsVscroll | WsHscroll!   
scrollHorizontal: anInteger
        "Private - Scroll the pane right by anInteger
         number of pixels (if positive) or left by
         the absolute value of anInteger (if negative)."
    self scrollTopCorner: anInteger  @ 0!   
scrollingRectangle

    (initialSize isNil or: [initialSize <= rectangle extent]) ifTrue: [
        ^0@0 extent: 0@0
    ] ifFalse: [
        ^0@0 extent: ((initialSize x - rectangle width) @ (initialSize y - rectangle height))
    ].! 
scrollTopCorner: aPoint
        "Private - Move the contents of the receiver
         pane by extent aPoint."
    | oldCorner |
    oldCorner := topCorner deepCopy.
    topCorner := topCorner - aPoint.
    oldCorner = topCorner ifTrue: [^self].
    UserLibrary scrollWindow: handle
        xAmount: aPoint x
        yAmount: aPoint y
        lpRect: nil
        clipRect: nil.
    self doGraphics: [
        GDILibrary offsetViewportOrg: graphicsTool handle
            x: aPoint x
            y: aPoint y
    ].
    UserLibrary updateWindow: self handle.! 
scrollTopCornerTo: aNewCorner
        "Private - Scroll topCorner to aNewCorner"
    self scrollTopCorner: self topCorner - aNewCorner + 1! 
setFocus: aPane
    self propertyAt: #focus put: aPane.! 
setScrollRanges
        "Private - Set the ranges for the horizontal and vertical
          scroll bars."
    | rangeRect minHorz maxHorz minVert maxVert |

    rangeRect := self scrollingRectangle.
    minHorz := rangeRect left.
    maxHorz := rangeRect right.
    minVert := rangeRect top.
    maxVert := rangeRect bottom.
    (self style bitAnd: WsHscroll) = 0
        ifTrue: [minHorz := maxHorz := 0].
    (self style bitAnd: WsVscroll) = 0
        ifTrue: [minVert := maxVert := 0].
    UserLibrary
        setScrollRange: self asParameter
        bar: SbHorz
        min: minHorz
        max: maxHorz
        redraw: false.
    UserLibrary
        setScrollRange: self asParameter
        bar: SbVert
        min: minVert
        max: maxVert
        redraw: false! 
topPaneClass

    ^self class!  
totalWidth

    ^rectangle width!   
update

    (self handlesEvent: #getContents)
        ifTrue: [ super update ]
        ifFalse: [
            self children do: [ :child | child update ]].! 
updateHorizontalSlider
        "Private - Update the horizontal slider position."
   UserLibrary
        setScrollPos: self asParameter
        bar: SbHorz
        position: self topCorner x
        redraw: true.!   
updateSliders

        "Private - Update the slider boxes in the scrollbars."

    handle = NullHandle ifTrue: [^self].
    self updateVerticalSlider.
    self updateHorizontalSlider! 
updateVerticalSlider
        "Private - Update the vertical slider position."
   UserLibrary
        setScrollPos: self asParameter
        bar: SbVert
        position: self topCorner y
        redraw: true.!   
validate

    self children do: [ :child |
        child isButton ifTrue: [ child receiveAllWindowMessages ]
    ].
    self setScrollRanges.
    super validate.
    self sendInputEvent: #updateRectangle.
    self initWindow.
    self event: #getContents.! 
verticalScrollbar

    ^self verticalScrollBar! 
verticalScrollBar

    ^style := self basicStyle | WsBorder | WsVscroll!
verticalScrollMaxRange
        "Private - Answer the vertical scrollbar's max range"
|maxPos|

    UserLibrary getScrollRange: self handle asParameter
                bar: SbVert
                lpMinPos: (WinStructure new: 2) asParameter
                lpMaxPos: (maxPos := WinStructure new: 2) asParameter.

    ^ maxPos shortAtOffset:0! 
verticalScrollMinRange
        "Private - Answer the vertical scrollbar's min range"
|minPos|

    UserLibrary getScrollRange: self handle asParameter
                bar: SbVert
                lpMinPos: (minPos := WinStructure new: 2) asParameter
                lpMaxPos: (WinStructure new: 2) asParameter.

    ^ minPos shortAtOffset:0! 
verticalScrollPos
        "Private - Answer the vertical scrollbar's position"

    ^UserLibrary getScrollPos: self handle asParameter bar: SbVert!
views

    ^Array with: self.!  
wmErasebkgnd: wordInteger with: longInteger
        "Private - Process the erase background message."
    | backColor aColor oldDC |
    (backColor := self backColor) notNil
        ifTrue: [aColor := backColor]
        ifFalse: [aColor := ClrBackground].
    oldDC := graphicsTool privateHandle.
    graphicsTool handle: wordInteger.
    graphicsTool fill: (0 @ 0 extent: self extent)
                color: aColor.
    graphicsTool handle: oldDC.
    ^1!   
wmHScroll: wordInteger with: longInteger
        "Private - Process a WM_HSCROLL message."
    | type sb slider pos |
    type := wordInteger.

    type = SbLineup ifTrue: [
            (self horizontalScrollPos > self horizontalScrollMinRange) ifTrue:[
                 self scrollHorizontal: self amountToScrollLeft]].
    type = SbLinedown ifTrue: [
            (self horizontalScrollPos < self horizontalScrollMaxRange) ifTrue:[
                self scrollHorizontal: self amountToScrollLeft negated]].
    type = SbPageup ifTrue: [
            self scrollHorizontal: (self amountToPageLeft
                min: (self horizontalScrollPos - self horizontalScrollMinRange)) ].
    type = SbPagedown ifTrue: [
            self scrollHorizontal: (self amountToPageLeft
                min: (self horizontalScrollMaxRange - self horizontalScrollPos)) negated].
    type = SbThumbposition
        ifTrue: ["end of tracking"
            pos := WinStructure new: 4.
            pos uLongAtOffset: 0 put: longInteger.
            pos := pos shortAtOffset: 0.
            self updateHorizontalSliderTo: pos.
            self scrollHorizontal: self topCorner x - pos.
            ^nil].
    type = SbThumbtrack
        ifTrue: [^nil]
        ifFalse: [self updateHorizontalSlider].
    ^nil!  
wmNchittest: wParam with: lParam

    ^nil! 
wmVScroll: aWordInteger with: aLongInteger
        "Private - Process a WM_VSCROLL message."
    | type pos |
    type := aWordInteger.
    type = SbLineup ifTrue: [
            (self verticalScrollPos > self verticalScrollMinRange) ifTrue:[
                 self scrollVertical: self amountToScrollUp]].
    type = SbLinedown ifTrue: [
            (self verticalScrollPos < self verticalScrollMaxRange) ifTrue:[
                self scrollVertical: self amountToScrollUp negated]].
    type = SbPageup ifTrue: [
            self scrollVertical: (self amountToPageUp
                min: (self verticalScrollPos - self verticalScrollMinRange)) ].
    type = SbPagedown ifTrue: [
            self scrollVertical: (self amountToPageUp
                min: (self verticalScrollMaxRange - self verticalScrollPos)) negated].
    type = SbThumbposition
        ifTrue: ["end of tracking"
            pos := WinStructure new: 4.
            pos uLongAtOffset: 0 put: aLongInteger.
            pos := pos shortAtOffset: 0.
            self scrollVertical: self topCorner y - pos.
            self updateVerticalSliderTo: pos.
            ^nil].
    type = SbThumbtrack
        ifTrue: [^nil]
        ifFalse: [self updateVerticalSlider].
   ^nil! !

! EntryFieldGroup class methods !  
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #textChanged;
        yourself! !

! EntryFieldGroup methods ! 
addSubpanes

    | numRows contents labelWidth fieldHeight scrollWidth vertOffset lowest |

    contents := self list.
    self font isNil ifTrue: [ self font: self defaultFont ].
    labelWidth := (contents inject: 0 into: [ :max :item | max max: (self font wbStringWidth: item) ]) + 8.
    fieldHeight := self font height + 8.
    scrollWidth := 0.
    self cpStyle isNil ifTrue: [
        vertOffset := self font height + 2.
        self addSubpane: (
            GroupBox new
                owner: self;
                framingBlock: ( FramingParameters new iDUE: initialSize; lP: 0; rP: 1; tP: 0; bP: 1);
                paneName: 'group';
                startGroup;
                contents: self label;
                yourself).
    ] ifFalse: [
        vertOffset := 0.
    ].
    numRows := contents size max: 1.
    1 to: numRows do: [ :row |
            row > self contents size ifFalse: [
                self addSubpane: (
                   StaticText new
                        owner: self;
                        propertyAt: #index put: row;
                        framingBlock: ( FramingParameters new
                            left: 2 relativeTo: #left;
                            right: 2 + labelWidth relativeTo: #left;
                            top: 10 + vertOffset + ((fieldHeight + 4) * (row - 1)) relativeTo: #top;
                            bottom: 2 + vertOffset + ((fieldHeight + 4) * row) relativeTo: #top);
                        rightJustified;
                        contents: (contents at: row),':';
                        yourself).
                self addSubpane: (
                   self fieldClass new
                        owner: self;
                        propertyAt: #index put: row;
                        framingBlock: ( FramingParameters new
                            left: 6 + labelWidth relativeTo: #left;
                            right: 4 + scrollWidth relativeTo: #right;
                            top: 6 + vertOffset + ((fieldHeight + 4) * (row - 1)) relativeTo: #top;
                            bottom: (lowest := 2 + vertOffset + ((fieldHeight + 4) * row)) relativeTo: #top;
                            indent: 3 @ 4);
                        when: #textChanged perform: #textChanged:;
                        contents: (self contents at: (contents at: row));
                        paneName: (contents at: row);
                        startGroup;
                        tabStop;
                        yourself).
           ].
    ].
    initialSize y: lowest + 4.! 
backColor: aColor

    super backColor: aColor.
    self children do: [ :child | child backColor: aColor ].!   
contents

    ^dictionary ifNil: [ dictionary := Dictionary new ].! 
contents: aDictionaryOfStrings

    handle = NullHandle ifFalse: [^self].
    aDictionaryOfStrings isDictionary ifTrue: [
        self list: aDictionaryOfStrings keys asArray.
        dictionary := aDictionaryOfStrings
    ] ifFalse: [ aDictionaryOfStrings size > 0 ifTrue: [
        self list: aDictionaryOfStrings.
        dictionary := Dictionary new.
        aDictionaryOfStrings do: [ :item | dictionary at: item put: '' ].
    ] ifFalse: [
        self list: #().
        dictionary := Dictionary new
    ]].
    self addSubpanes.!   
cpStyle

    ^self propertyAt: #cpStyle!
fieldClass

    ^WBEntryField!  
foreColor: aColor

    super foreColor: aColor.
    self children do: [ :child | child foreColor: aColor ].!   
label

    ^label ifNil: [ label := '' ]!   
label: aString

    | gb |
    label := aString.
    ((gb := self paneNamed: 'group') notNil and: [ gb handle isValid ]) ifTrue: [ gb contents: aString ].!   
list

    ^self propertyAt: #list!  
list: aCollection

    self propertyAt: #list put: aCollection! 
noGroupBox

    self propertyAt: #cpStyle put: #noGroupBox! 
setLabelFont: aFont

    (self children select: [:pane | pane class == StaticText ]) do: [:field | field font: aFont].
    self update!
setValueFont: aFont

    (self children select: [:pane | pane class == self fieldClass ]) do: [:field | field font: aFont].
    self update!   
textChanged: aPane

    self contents at: aPane paneName put: aPane contents.
    self event: #textChanged.!   
verticalScrollBar

    super verticalScrollBar.
    self propertyAt: #cpStyle put: #verticalScrollBar! !

! GroupedToolBars class methods !  
supportedEvents

    ^super supportedEvents
        add: #selectGroup;
        add: #selectingGroup;
        add: #select;
        add: #selecting;
        add: #showHelp;
        add: #doubleClick;
        yourself! !

! GroupedToolBars methods !
addGroup: aSymbol with: tools
    "Add a new group of tools for group named aSymbol"

    contents addLast: (
        Array with: aSymbol with: tools)!   
addSubpanes
    "Private - Add the receiver's panes"

    | bitmap groups |

    contents size = 0
    ifTrue: [ self event: #getContents ].

    groups := self groups.

    self
        addSubpane: (
            (groupPane := self groupPaneClass new)
                owner: self;
                framingBlock: (self frameFor: 0@0);
                when: #select perform: #groupSelect:;
                when: #selecting perform: #selectingGroup:;
                when: #showHelp perform: #paletteHelp:;
                when: #doubleClick perform: #doubleClick:;
                backColor: ClrPalegray;
                yourself
        );
        addSubpane: (
            (toolPane := self toolPaneClass new)
                owner: self;
                framingBlock: (self frameFor: self toolSize + self toolsDistance);
                when: #select perform: #toolSelect:;
                when: #selecting perform: #selectingTool:;
                when: #showHelp perform: #paletteHelp:;
                when: #doubleClick perform: #doubleClick:;
                backColor: ClrPalegray;
                yourself
        );
        yourself.

    toolPane perform: toolStyle.

    groupPane size: 1 @ groups size.
    toolPane size: 1 @ 20.
    contents do: [:tuple|
        groupPane add: tuple first.
        tuple last do: [:tool|
            toolPane on: tuple first add: tool
        ]
    ]! 
bitmapFor: selector
    "Private - Returns the receiver's tool bitmap for selector"

    ^CPBitmapDict
        at: selector asString
        ifAbsent: [
          CPBitmapDict
            sysAt: selector asString
            ifAbsent: [
                CPBitmapDict sysAt: 'toolPaneExample'
            ]
        ]!
contents
    "Returns the instance var of the receiver
     for external manipulation"
    ^contents!  
contents: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    contents := anObject! 
doubleClick: aPane
    "Private - Attends the doubleClick event"

    selection := aPane selectorAt: aPane currentIndex.
    self event: #doubleClick.!   
frameFor: displacement
    "Private - Returns the framingBlock for tool moved by displacement"

    ^[:box|
        self isVertical
        ifTrue: [
            box left + displacement x @ box top
              extent: self toolSize x @ (box height - 1)
        ]
        ifFalse: [
            box left @ (box top + displacement y)
              extent: box width - 1 @ self toolSize y
        ]
    ]! 
groupPaneClass
    "Private - Returns the group pane class"

    ^self isVertical
    ifTrue: [ OSToolPalette ]
    ifFalse: [ OSToolBar ]!  
groups
    "Private - returns the groups selectors..."
    ^contents collect: [:each| each first ]! 
groupSelect: aPane
    "Private - Attends the group selection event"

    selection := aPane selectorAt: aPane currentIndex.
    self event: #selectGroup.
    toolPane switchTo: selection.!
horizontal
    "Sets the shape of the receiver to horizontal tools"

    vertical := false!
initialize
    "Private - Initialize the receiver"

    super initialize.
    self vertical.
    contents := OrderedCollection new.
    toolStyle := #postAutomatic.
    toolsDistance := 1.!  
isVertical
    "True if the receiver is placed vertically"

    ^vertical = true!  
paletteHelp: aPane
    "Private - Attends the tool help event"

    selection := aPane selectorAt: aPane currentIndex.
    self event: #showHelp.!
selectedItem

    ^selection!   
selectingGroup: aPane
    "Private - Attends the group selecting event"

    selection := aPane selectorAt: aPane currentIndex.
    self event: #selectingGroup.
    toolPane switchTo: selection.!  
selectingTool: aPane
    "Private - Attends the tool selecting event"

    selection := aPane selectorAt: aPane currentIndex.
    self event: #selecting.!
toolPaneClass
    "Private - Returns the tool pane class"

    ^self isVertical
    ifTrue: [ OSMultiToolPalette ]
    ifFalse: [ OSMultiToolBar ]!  
toolPaneStyle: aSymbol
    "Sets the tools pane style...
        aSymbol can be #preAutomatic , #postAutomatic or #mdiToolbar
    "

    toolStyle := aSymbol.
    toolPane notNil ifTrue: [
        toolPane perform: aSymbol
    ].!
toolsDistance
    "Returns the instance var of the receiver
     for external manipulation"
    ^toolsDistance!
toolsDistance: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    toolsDistance := anObject!   
toolSelect: aPane
    "Private - Attends the tool selection event"

    selection := aPane selectorAt: aPane currentIndex.
    self event: #select!   
toolSize
    "Private - Returns the receiver's toolSize"

    | size bitmap groups |
    size := self propertyAt: #toolSize.
    size isNil ifTrue: [ ^self toolSize: OSToolBar defaultCellSize ].
    ^size!   
toolSize: aPoint
    "Private - Sets the receiver's tool size"

    self propertyAt: #toolSize put: aPoint.
    ^aPoint!  
vertical
    "Sets the shape of the receiver to vertical tools"

    vertical := true! !

! PaneWithRulers class methods !   
supportedEvents

    ^super supportedEvents
        add: #rulerCreated;
        add: #rulerSelected;
        add: #rulerDoubleClicked;
        add: #rulerToggled;
        add: #getContainedPane;
        yourself!  
wbCreated
    "Puesto por Ale para no editarlo con WB"
    ^false! !

! PaneWithRulers methods !  
addSubpanes
    "Private - Add the receiver's panes"

    | ruler selector |
    "
    self framingBlock: (
        FramingParameters new
            iDUE: 640 @ 488; xC; yC;
            cRDU: (2 @ 486 rightBottom: 638 @ 2)).
    "

    #(leftTop left top) do: [:shape|
        ruler := RulerBar new.
        ruler
            owner: self;
            perform: shape;
            when: #select perform: #rulerSelect:;
            when: #doubleClick perform: #rulerDoubleClick:;
            yourself.
        self
            addSubpane: ruler;
            selectedRuler: ruler;
            event: #rulerCreated.
        rulers add: ruler.
    ].

    self event: #getContainedPane.

    contents notNil
    ifTrue: [
        contents framingBlock: self contentsFramingBlock.
        self addSubpane: contents
    ].!  
contents
    "Returns the receiver's contents"

    ^contents! 
contents: aPane
    "Set the receiver's contents"

    contents := aPane.! 
contentsFramingBlock
    "Private - Returns the graphPane framing block"
    ^[:box|
        self rulers first visible
        ifTrue: [ box origin + RulerBar boxSize corner: box corner ]
        ifFalse: [ box ]
    ]! 
initialize
    "Private - Initialize the receiver."

    super initialize.
    rulers := OrderedCollection new: 3.!   
rulerDoubleClick: aRuler
    "Private - Process ruler doubleclick"

    self selectedRuler: aRuler.
    self event: #rulerDoubleClicked!  
rulers
    ^rulers!  
rulerSelect: aRuler
    "Private - Process ruler selection"

    self selectedRuler: aRuler.
    self event: #rulerSelected!  
selectedRuler
    "Returns the current ruler in use"

    ^self propertyAt: #rulerInUse!   
selectedRuler: aRuler
    "Sets the current ruler in use"

    self propertyAt: #rulerInUse put: aRuler!   
toggleRuler
    "Toggle the rulers state to visible/invisible"
    | visible |
    visible := self rulers first visible.
    self rulers do: [:each|
        each visible: visible not.
        self
            selectedRuler: each;
            event: #rulerToggled.
    ].
    rectangle notNil
    ifTrue: [ children do: [:child| child resize: rectangle ] ]!   
wmErasebkgnd: wordInteger with: longInteger
    "Private - Process the erase background message."
    ^1! !

! RadioButtonGroup class methods !   
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #select;
        yourself! !

! RadioButtonGroup methods ! 
addSubpanes
    | extent numRows index rb fontHeight inset inner |
    fontHeight := (SysFont height + 6) / (SysFont height / 32).
    self cpStyle isNil ifTrue: [
        self addSubpane: (
            GroupBox new
                owner: self;
                framingBlock: ( FramingParameters new iDUE: initialSize; lP: 0; rP: 1; tP: 0; bP: 1);
                paneName: 'group';
                startGroup;
                contents: self label;
                yourself).
        inset := 8 @ fontHeight.
    ] ifFalse: [
        inset := 0 @ 0
    ].
    inner := initialSize - inset.
    numRows := ((self contents size +  self numColumns - 1) // self numColumns) max: 1.
    extent := (inner x // numColumns) @ fontHeight.
    1 to: self numColumns do: [ :column |
        1 to: numRows do: [ :row |
            index := (column - 1) * numRows + row.
            index > self contents size ifFalse: [
                self addSubpane: (
                   rb := self buttonClass new
                        owner: self;
                        propertyAt: #index put: index;
                        framingBlock: ( FramingParameters new
                            iDUE: extent;
                            lP: ((column - 1) / self numColumns) * 0.9 + (((self numColumns - column + 1) / self numColumns) * 0.1);
                            rP: (column / self numColumns) * 0.9 + (((self numColumns - column) / self numColumns) * 0.1);
                            tDU: inset y + ((row - 1) * extent y) r: #top;
                            bDU: inset y + (row * extent y) r: #top);
                        when: #clicked perform: #setRadio:;
                        contents: (self contents at: index);
                        paneName: (self contents at: index);
                        yourself).
                index == 1 ifTrue: [ rb startGroup; tabStop ].
           ].
        ].
    ].! 
backColor: aColor

    super backColor: aColor.
    self children do: [ :child | child backColor: aColor ].!   
buttonClass

    ^RadioButton!  
contents

    ^list ifNil: [ list := #() ].!
contents: aCollection

    handle = NullHandle ifFalse: [^self].
    list := aCollection.
    self addSubpanes.!  
cpStyle

    ^self propertyAt: #cpStyle!
foreColor: aColor

    super foreColor: aColor.
    self children do: [ :child | child foreColor: aColor ].!   
indexOf: aString

    "Answer the index of the item aString."

    list isNil ifTrue: [ ^nil ].
    ^list indexOf: aString!  
label

    ^label ifNil: [ label := '' ]!   
label: aString

    | gb |
    label := aString.
    ((gb := self paneNamed: 'group') notNil and: [ gb handle isValid ]) ifTrue: [ gb contents: aString ].!   
noGroupBox

    self propertyAt: #cpStyle put: #noGroupBox! 
numColumns

    ^numColumns ifNil: [ numColumns := 1 ].!
numColumns: anInteger

    numColumns := anInteger! 
selectedIndex
        "Private - Answer the currently selected item index."
    ^self selection!
selectedItem
        "Answer the item selected in the RadioButtonGroup."
    ( self selection ) isNil
        ifTrue: [ ^nil ]
        ifFalse: [ ^list at: ( self selection ) ]! 
selection

    ^selection!  
selection: anObject

    ( anObject isInteger )
        ifTrue: [ self selectIndex: anObject ]
        ifFalse: [ self selectItem: anObject ]!
selectIndex: itemIndex
    | radioButton |
    radioButton := self children detect: [ :child | child isRadio and: [(child propertyAt: #index) == itemIndex ]].
    self children do: [ :child |
        child isRadio ifTrue: [
            child == radioButton ifTrue: [
                child selection: true
            ] ifFalse: [
                child selection: false
            ].
        ].
    ].! 
selectItem: aString
        "Private - Select the item aString"
    self selectIndex: (self indexOf: aString)!  
setRadio: aPane

    selection := aPane propertyAt: #index.
    self event: #select!   
verticalScrollBar

    super verticalScrollBar.
    self propertyAt: #cpStyle put: #verticalScrollBar! !

! CheckBoxGroup methods !  
buttonClass

    ^CheckBox! 
lastSelection

    ^selection!  
selectedItems
    "Answer a collection of the selected items."
    | sel |
    (sel := self selections) isNil
        ifTrue: [^nil]
        ifFalse: [^self selections collect: [:each | list at: each]]!   
selection
    "Answer the index of the first item selected. Index starts at 1."
    | values |
    values := self selections.
    values size = 0 ifTrue: [^nil].
    ^values first! 
selection: anObj
        "If anObj is a collection then select items whose indices
         are in anObj.
         If anObj is Integer then select the item indexed by anObj.
         Otherwise, select anObj in the list."
    anObj size > 0
        ifTrue: [ anObj do: [ :i | super selection: i ]]
        ifFalse: [super selection: anObj]!
selections

    ^(self children select: [ :child |
        child class == self buttonClass and: [ child selection ]]) collect: [ :child |
            child propertyAt: #index ]! 
selectIndex: index

    (self children detect: [ :child | index = child propertyAt: #index ]) selection: true!  
unSelectIndex: index

    (self children detect: [ :child | index = child propertyAt: #index ]) selection: false! !

! SexPane class methods !
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #sexChanged;
        add: #setToMale;
        add: #setToFemale;
        yourself! 
wbCreated

    ^true! !

! SexPane methods !  
addSubpanes
    (self
        yourself;
            framingBlock: ( FramingParameters new iDUE: 210 @ 136; xC; yC; cRDU: (2 @ 134 rightBottom: 208 @ 2));
            addSubpane: (
                GroupBox new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 201 @ 128; lDU: 0 r: #left; rDU: 5 r: #right; tDU: 0 r: #top; bDU: 4 r: #bottom);
                    startGroup;
                    contents: 'Sex';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 119 @ 40; lDU: 27 r: #left; rDU: 146 r: #left; tDU: 32 r: #top; bDU: 72 r: #top);
                    paneName: 'male';
                    startGroup;
                    tabStop;
                    when: #clicked perform: #setMale:;
                    contents: 'Male';
                    yourself
            );
            addSubpane: (
                RadioButton new
                    owner: self;
                    framingBlock: ( FramingParameters new iDUE: 155 @ 40; lDU: 27 r: #left; rDU: 183 r: #left; tDU: 72 r: #top; bDU: 112 r: #top);
                    paneName: 'female';
                    when: #clicked perform: #setFemale:;
                    contents: 'Female';
                    yourself
            );
        yourself
    ).!
contents

    ^self sex!
contents: aSymbol

    self sex: aSymbol!   
setFemale: aPane

    self sex: #female.
    self event: #setToFemale.!
setMale: aPane

    self sex: #male.
    self event: #setToMale.!  
sex

    ^sex!  
sex: aSymbol
    | list newSex |
    aSymbol isSymbol ifTrue: [
        newSex := aSymbol
    ] ifFalse: [
        newSex := aSymbol asString asLowerCase asSymbol
    ].
    ((list := #(male female)) includes: newSex) ifFalse: [
        ^self error: 'Unknown sex (',newSex asString,') - only #male and #female are allowed.'
    ].
    sex := newSex.
    (self paneNamed: newSex asString) selection: true.
    (list reject: [ :s | s == newSex ]) do: [ :s | (self paneNamed: s asString) selection: false ].
    self event: #sexChanged.! !

! ShadedPane class methods ! 
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #setPaneContents;
        yourself! !

! ShadedPane methods !  
addSubpanes
    "Private - Build receiver's subpanes..."

    self framingBlock: ( FramingParameters new iDUE: 457 @ 400; xC; yC; cRDU: (2 @ 398 rightBottom: 455 @ 2)).

    self event: #setPaneContents.

    self children isEmpty & contents isNil
    ifTrue: [ "Fill with default contents"
        contents := StaticBox new.
    ].
    contents isNil ifTrue: [^self].

    contents framingBlock: self contentsFramingBlock.
    self addSubpane: contents!  
contents
    "Returns the instance var of the receiver
     for external manipulation"
    ^contents!  
contents: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    contents := anObject! 
contentsFramingBlock
    "Private - returns the contents framing block."

    ^[:box| box origin extent: box extent - 8 ]

    "FramingParameters new iDUE: 439 @ 384; lDU: 0 r: #left; rDU: 14 r: #right; tDU: 0 r: #top; bDU: 12 r: #bottom"!  
create: className
    title: nameString
    style: styleInteger
    rectangle: aRectangle
    parent: parentWindow
        "Private - Create a window in the host system whose parent is
         parentWindow with aTitleString and aFrameStyle.
         The receiver's handle is set to the
         resulting client window."

    |addrClassName addrTitleName|
    addrClassName:=WinAddress copyToNonSmalltalkMemory: className asParameter.
    nameString notNil ifTrue:[
        addrTitleName:=WinAddress copyToNonSmalltalkMemory: nameString asParameter].
    handle := WindowHandle fromInteger:
        (UserLibrary
            createWindowEx: self extendedStyle
            className: addrClassName asParameter
            name: addrTitleName asParameter
            style: styleInteger
            x: aRectangle origin x
            y: aRectangle origin y
            width: aRectangle width
            height: aRectangle height
            parent: (parentWindow notNil
                ifTrue: [parentWindow asParameter]
                ifFalse: [nil] )
            menu: ((styleInteger bitAnd: WsChild) ~= 0
                        ifTrue:[self id]
                        ifFalse:[nil])
            instance: self dsHandle
            param: nil).

    addrClassName unlockAndFree.
    addrTitleName notNil ifTrue:[
        addrTitleName unlockAndFree].
    handle = NullHandle ifTrue: [^nil].!  
display
    "Shade the receiver area when display"

    self drawShade!
drawShade
    "Private - Shade the receiver's area"

    | shade |
    shade := CPBitmapDict at: 'ShadeBitmap' ifAbsent: [^self].
    self
        fill: (rectangle right - 8 @ (rectangle top + 8) corner: rectangle corner)
        with: shade;
        fill: (rectangle left + 8 @ (rectangle bottom - 8) corner: rectangle right - 8 @ rectangle bottom)
        with: shade!   
extendedStyle
    "Private - Returns the private extended style for the receiver"
    ^16r20 "Ws_Ex_Transparent"!   
fill: aRectangle with: shadeBitmap
    "Private - Shade the receiver's area"
    | pen |
    pen := self pen.
    pen isNil ifTrue: [^nil].
    aRectangle left // shadeBitmap width * shadeBitmap width
        to: aRectangle right
        by: shadeBitmap width
        do: [:x|
            aRectangle top // shadeBitmap height * shadeBitmap height
                to: aRectangle bottom
                by: shadeBitmap height
                do: [:y|
                    pen
                        copyBitmap: shadeBitmap
                        from: shadeBitmap boundingBox
                        at: x@y rule: Srcand
            ]
        ]!
getGraphicsTool
    "Private - Initialize the drawing tool of the receiver."

    ^Pen forDC: nil medium: self!
wmErasebkgnd: wordInteger with: longInteger
        "Private - Process the erase background message."

    ^1! !

! WBCompositePaneScratchWindow class methods ! 
defaultClass

    ^WBDefaultCompositePaneScratchWindow! 
isScratchWindow

    ^true! 
isWBInternalClass

    ^true!   
resetToDefault

    | fileInStream methodString |

    methodString := WBDefaultCompositePaneScratchWindow sourceCodeAt: #addSubpanes.
    fileInStream := ReadWriteStream on: (String new: methodString size).
    fileInStream
        nextPutAll: '!! WBCompositePaneScratchWindow methods !!';
        nextChunkPut: methodString;
        nextChunkPut: String new.
    fileInStream reset; fileIn.! !

! WBCompositePaneScratchWindow methods ! 
addSubpanes
    (self
        yourself;
            framingBlock: ( FramingParameters new iDUE: 457 @ 200; xC; yC; cRDU: (2 @ 198 rightBottom: 455 @ 2));
        yourself
    ).!   
perform: selector
    "Scratch windows should not perform any events"
    ^MessageBox messageNote: 'Scratch windows cannot do anything. You must first create a new view manager class with the "Save As..." command in order to add behavior.'!
perform: selector with: arg
    "Scratch windows should not perform any events"
    ^self perform: selector!
when: anEvent perform: aSelector
    "Scratch windows should not perform any events"! !

! WBDefaultCompositePaneScratchWindow class methods ! 
isWBInternalClass

    ^true! !

! WBDefaultCompositePaneScratchWindow methods !  
addSubpanes
    (self
        yourself;
            framingBlock: ( FramingParameters new iDUE: 457 @ 200; xC; yC; cRDU: (2 @ 198 rightBottom: 455 @ 2));
        yourself
    ).! !

! ObjectsHolderPane class methods !  
supportedEvents
        "Private - Answer the events supported by this subpane."
    ^super supportedEvents
        add: #doubleClicked;
        add: #beginDrag;
        add: #drag;
        add: #endDrag;
        yourself! !

! ObjectsHolderPane methods !  
aboutToSaveImage
     "Private - Save the receiver's value so it can be restored
       when the image is restarted.
     The receiver destroy all it's icons..."

    self
        initializeIcons;
        discardBitmap.

    ^super aboutToSaveImage!
arrangeAll
    "Private - Arrange the receiver's icons"

    | extent iconsToPlace x y width |
    places := IdentityDictionary new.
    grid := self minimumExtent.
    objects size = 0 ifTrue: [ ^self ].
    extent := grid copy.
    iconsToPlace := objects collect: [:each| self iconFor: each].
    iconsToPlace do: [:each|
        each extent x > extent x ifTrue: [extent x: each extent x].
        each extent y > extent y ifTrue: [extent y: each extent y].
    ].
    grid := extent.

    x := y := 0.
    width := (self rectangle isNil or: [self rectangle width = 0])
        ifTrue: [extent x * 5]
        ifFalse: [self rectangle width max: extent x].
    objects do: [:each|
        places at: x@y put: each.
        x := extent x + x.
        x + (extent x "// 2") > width "si se vera mas de la mitad..."
        ifTrue: [
            y := y + extent y.
            x := 0
        ].
    ].!   
autoArrange
    "The receiver always autoarrange the icons..."
    ^true!   
backTone
    "Private - Returns the color user for backTonning"

    #platformDependent.
    ^WinInfo colorButtonFace "WinInfo colorButtonShadow"!
buildBitmap
    "Private - Create a bitmap with all the receiver's contents icons."

    | aPen |
    self discardBitmap.
    bitmap := Bitmap screenExtent: self iconsExtent.
    aPen := bitmap pen.
    aPen backColor: self backColor.
    aPen erase.
    self displayContentsWith: aPen.!  
button1DoubleClick: aPoint
    "Private - Notify the owner that the user has double clicked.."

    self event:#doubleClicked! 
button1Down: aPoint
    "Private - Process the drag move message"
    | newSelection |

    (super button1Down: aPoint) ifFalse:[^self].
    self captureMouseInput.

    selected notNil
    ifTrue: [self showSelected].

    (newSelection := self objectAt: aPoint) isNil
    ifTrue: [
        selected := nil.
        ^self
    ].

    selected := (Notifier isKeyDown: VkShift)
    ifTrue: [newSelection , selected]
    ifFalse: [newSelection].

    self showSelected.

    server beginDrag.
    self event: #beginDrag.!
button1DownShift: aPoint
    "Private - Left button is pressed down
         together with shift key."
    | newSelection |

    super button1DownShift: aPoint.
    self captureMouseInput.

    (newSelection := self objectAt: aPoint) isNil
    ifTrue: [
        UserLibrary messageBeep: 0.
        ^self
    ].

    newSelection := newSelection asOrderedCollection.
    selected := selected asOrderedCollection.
    selected isNil
    ifFalse: [ "unselect if present"
        newSelection copy do: [:each|
            (selected includes: each)
            ifTrue: [
                newSelection remove: each.
                selected remove: each.
                self mark: (Array with: each).
            ]
        ]
    ].

    selected :=  (newSelection , selected) asArray.

    self mark: newSelection.

    server beginDrag.
    self event: #beginDrag.! 
button1Move: aPoint
    "Private - Left button is down and the mouse has been moved.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."
    selected isNil ifTrue: [^self].

    server drag.
    self event: #drag.!  
button1Up: aPoint
    "Private - Left button has been released.
    Let the owner process the event."

    "handle = WindowHandle queryCapture ifFalse: [^self]."

    self clearMouseCapture.

    selected isNil ifTrue: [^self].

    server endDrag.
    self event: #endDrag.!
close
    "Private - Reimplemented here to release the bitmaps."

    |answer|
    answer := super close.
    self
        discardBitmap;
        initializeIcons.
    ^answer.!  
colorButtonHighlight
    "Private - Returns then colorButtonHighlight value."

    #platformDependent.
    ^WinInfo colorButtonHighlight! 
colorButtonShadow
    "Private - Returns then colorButtonShadow value."

    #platformDependent.
    ^WinInfo colorButtonShadow!  
contents
    "Returns the receiver's contents"
    ^objects!
contents: aCollection
    "Set the receiver's contents"
    objects := aCollection copy.
    selected := nil.
    self
        initializeIcons;
        arrangeAll;
        discardBitmap;
        update: #display!  
defaultFont
    "Private - Answer the default font for StatusPane."
    ^Font face:'Helv' size: 0@(SysFont height - 3) fixedWidth:false!
discardBitmap
    "Private - Discard current bitmap"

    bitmap release.
    bitmap := nil!  
display
    "Private - Display its contents."

    | cursor |
    graphicsTool isNil ifTrue: [^nil].
    bitmap isNil | self autoArrange
    ifTrue:[
        self
            arrangeAll;
            buildBitmap.
        graphicsTool
            fill: (0 @ 0 extent: self extent)
            color: self backColor.
    ].
    bitmap isNil ifTrue: [^self].

    graphicsTool
        copyBitmap: bitmap
        from: bitmap boundingBox
        at: Rectangle leftTopUnit.

    self showSelected!  
displayContentsWith: aPen
    "Private - Display receiver's contents icons with aPen."
    | icon label gap |
    places associationsDo: [:asoc|
        icon := self iconFor: asoc value.
        drawGrid ifTrue: [
            self
                drawShadeFrom: asoc key + 1
                to: asoc key + grid - 1
                with: aPen
        ].
        gap := grid - icon extent // 2.
        placeLabels ifTrue: [gap y: 2].
        placeLabels ifTrue: [
            aPen black; backColor:self backColor.
            (label := self labelFor: asoc value) notNil
            ifTrue: [
              aPen
                font: curFont;
                centerText: label
                at: asoc key + (grid x // 2 @ grid y)
            ]
        ].
        self
            drawIcon: icon
            at: asoc key + gap
            with: aPen.
    ]!
dragAndDropServer
    "Returns the current drag & drop server"
    ^server! 
dragAndDropServer: aServer
    "Sets the current drag & drop server"
    server := aServer! 
draggedObject
    "Returns the currently selected object"
    | item |
    (item := self draggedObjectFromOwner) isNil
    ifFalse: [^item].
    selected isEmpty ifTrue: [^nil].
    ^self isMultipleSelection
     ifTrue: [selected]
     ifFalse:[ selected first]!   
draggedObjectFromOwner
    "Private - Returns the currently selected object
     provided by the owner.
    Or nil..."
    | model |

    model := self owner.
    (model respondsTo: #draggedObjectIn:)
    ifTrue: [ "the model wants to provide the proper object to drag"
        ^model draggedObjectIn: self
    ].
    ^nil!
drawIcon: anIcon at: aPoint with: aPen
    "Private - Display an icon with aPen with aPen."

    (anIcon isMemberOf: Icon)
    ifTrue: [
        UserLibrary
            drawIcon: aPen handle
            x: aPoint x y: aPoint y
            hIcon: anIcon handle.
        ^self
    ].

    "a displayable object assumed..."
    anIcon
        displayAt: aPoint
        with: aPen!  
drawShadeFrom: aPoint to: bPoint with: aPen
    "Private - Draw a button shade with aPen."
    aPen
        place: aPoint;
        foreColor: self colorButtonHighlight;
        goto: aPoint x @ (bPoint y - 1);
        place: aPoint;
        goto: bPoint x - 1 @ aPoint y;
        place: bPoint;
        foreColor: self colorButtonShadow;
        goto: bPoint x @ aPoint y ;
        place: bPoint;
        goto: aPoint x  @ bPoint y;
        fill: ((aPoint corner: bPoint + 1) insetBy: 1)
        color: WinInfo colorButtonFace! 
editSelection
    "Edit the currently selected objects..."

    self withSelectionDo: [:each|
        (each respondsTo: #edit)
        ifTrue: [ each edit ]
        ifFalse: [
            Smalltalk isRunTime
            ifFalse: [ each inspect ]
        ]
    ].! 
iconFor: anObject
    "Private - Returns an icon for displaying anObject"
    | icon register validateIcon |
    anObject isNil ifTrue: [^self nilIcon].
    icon := icons at: anObject ifAbsent: []. "use catched icon"
    icon notNil ifTrue: [^icon].
    register := [:one| icons at: anObject put: one.icon := one].
    validateIcon := [
        icon handle = Icon runtimeIcon
        ifTrue: [ "icon not found"
            icon release.
            icon := nil ].
    ].

     "naturally ask the object for it's icon..."
    (anObject respondsTo: #icon)
    ifTrue: [ ^register value: anObject icon ].

    "try to find an object of the same class"
    icons keysDo: [:each|
        each class == anObject class
        ifTrue: [ ^register value: (icons at: each) ]
    ].

    "Patch for String objects (an icon of name
         'String? cant be created in a dll...)"
    anObject isString ifTrue: [
        icon := Icon fromModule: ObjectStyleDLL library id: 'Text'.
        validateIcon value.
        icon isNil ifFalse: [^register value: icon].
    ].

    "try to infere the icon of the object from it's class & superclasses"
    ((Array with: anObject class), anObject class allSuperclasses)
    do: [:class|
        icon := Icon fromModule: ObjectStyleDLL library id: class name.
        validateIcon value.
        icon isNil ifFalse: [^register value: icon]
    ].

    ^icon isNil
    ifTrue: [register value: self unKnownIcon]
    ifFalse: [register value: icon]! 
iconsExtent
    "Private - Returns the extent of the receiver's bitmap"

    | extent |
    extent := self minimumExtent copy.
    places keysDo: [:place|
        extent x: (extent x max: place x).
        extent y: (extent y max: place y).
    ].
    ^extent + grid!  
initialize
    "Private - Initializes the receiver"
    super initialize.
    server := DragAndDropServer for: self.

    drawGrid := true.
    placeLabels := true"false".

    self backColor: self backTone.

    self contents: #()!
initializeIcons
    "Private - Initializes the receiver's icons.
     Cursors are taken in a similar way"

    icons size = 0
    ifFalse: [
        icons values asSet do: [:each| each release]
    ].
    icons := IdentityDictionary new.

    cursors size = 0
    ifFalse: [
        cursors values asSet do: [:each| each release]
    ].
    cursors := IdentityDictionary new.!
isMultipleSelection
    "True if the receiver has a multiple selection"
    ^selected size > 1! 
labelFor: anObject
    "Private - returns the label for the object anObject"
    | name  maxSize stripLength |
    anObject isNil ifTrue: [^nil].
    name :=
        (anObject respondsTo: #name)
        ifTrue: [anObject name asString]
        ifFalse: [anObject asString].

    ^self labelFromString: name trimBlanks!   
labelFromString: nString
   | size aString maxSize |
    maxSize := 6.
    size := nString size.
    size <= maxSize ifTrue: [^nString].
    aString := nString reject: [:c| c isSeparator].
    aString size <= maxSize ifTrue: [^aString].
    ^aString copyFrom: 1 to: maxSize! 
mark: aCollection
    "Private - Show aCollection as selected"

    aCollection isNil ifTrue: [^self].
    aCollection do: [:current|
        places associationsDo: [:asoc|
            asoc value == current
            ifTrue: [
                self doGraphics: [
                    graphicsTool
                        reverse: (
                            (asoc key extent: grid)
                            insetBy: 1)
                ]
            ]
        ]
    ].! 
minimumExtent
    "Private - Returns the minimum extent for icons"
    | profiler iconExtent |
    iconExtent := self propertyAt: #iconExtent.
    iconExtent notNil ifTrue: [^iconExtent].
    profiler := WinProfiler new.
    profiler
        pathName: nil;
        applicationName: 'Desktop'.
    iconExtent := (profiler at: #IconSpacing ifAbsent: [45]) asInteger
        @ (profiler at: #IconVerticalSpacing ifAbsent: [50]) asInteger.
    self propertyAt: #iconExtent put: iconExtent.
    ^iconExtent!
nilIcon
    "Private - Returns an icon for displaying nil"
    ^icons at: #nil
        ifAbsent: [
            icons
                at: #nil
                put: (Icon fromModule: ObjectStyleDLL library id: 'nil')
        ]!  
objectAt: aPoint
    "Private - Returns the objects at aPoint"
    | some obj |
    some := OrderedCollection new.
    places keysDo: [:each|
        ((each extent: grid) containsPoint: aPoint)
        ifTrue: [
            (obj := places at: each ifAbsent: [nil]) isNil ifFalse: [
                some add: obj.
            ].
        ]
    ].
    some isEmpty ifTrue: [^nil].
    ^some asArray! 
open
        "Private - open the toolPane."

    super open.
    self event:#getContents.!
placeLabels
    "Returns the instance var of the receiver
     for external manipulation"
    ^placeLabels!
placeLabels: aBoolean
    "Sets the instance var of the receiver with aBoolean.
    Update the receiver if needed"
    placeLabels := aBoolean.
    objects isEmpty ifFalse: [self update].!  
removeSelection
    "Remove currently selected objects..."
    | copy toRemove |
    copy := self contents asOrderedCollection.
    toRemove := self selection.
    toRemove isNil ifTrue: [^nil].
    toRemove do: [:each| copy remove: each ifAbsent: []].
    selected := nil.
    self contents: copy.!   
select: aSelection
    "Select aSelection.
    aSelection can be an object in the receiver's contents or
    aCollection of objects in the receiver's contents"

    (objects includes: aSelection)
    ifTrue: [ selected := selected copyWith: aSelection ]
    ifFalse: [
        aSelection do: [:each|
            (objects includes: each)
            ifTrue: [ selected := selected copyWith: each ]
        ]
    ].
    self invalidateRect: nil.! 
selectAll
    "Select all objects"

    selected := Array new , objects.
    self invalidateRect: nil.!   
selection
        "Answer the receiver's current selection.
         Usually implemented by subclasses."
    ^selected!
selection: aSelection
    "Select aSelection.
    aSelection can be an object in the receiver's contents or
    aCollection of objects in the receiver's contents"

    selected := Array new.
    self select: aSelection.!
showSelected
    "Private - Show selected object"

    self mark: selected!
unKnownIcon
    "Private - Returns an icon for displaying unKnown Objects"
    ^icons at: #unKnown
        ifAbsent: [
            icons
                at: #unKnown
                put: (Icon fromModule: ObjectStyleDLL library id: 'notFound')
        ]! 
unSelect: aSelection
    "Select aSelection.
    aSelection can be an object in the receiver's contents or
    aCollection of objects in the receiver's contents"

    (objects includes: aSelection)
    ifTrue: [ selected := selected copyWithout: aSelection ]
    ifFalse: [
        aSelection do: [:each|
            (objects includes: each)
            ifTrue: [ selected := selected copyWithout: each ]
        ]
    ].
    self invalidateRect: nil.! 
unSelectAll
    "unSelect all objects"

    selected := #().
    self invalidateRect: nil.!   
winClass
        "Private - Answer the receiver's window class."

    | className wndClass lptr answer|
    className := self class name.
    wndClass := WinWindowClass new.
    answer:=UserLibrary getClassInfo: WIN hInstanceExe
        className: className asParameter
        wndClass: wndClass asParameter.
    answer ifTrue:[^className].
    UserLibrary getClassInfo: WIN hInstanceExe
        className: 'VWIN' asParameter
        wndClass: wndClass asParameter.
    wndClass style:CsDblclks;
        className: (lptr := WinAddress
            copyToNonSmalltalkMemory: className asAsciiZ) asParameter.
    UserLibrary registerClass: wndClass asParameter.
    lptr unlock; free.
   ^className!   
withSelectionDo: aBlock
    "Evaluates aBlock with currently selected objects..."
    | sel |
    sel := self selection.
    sel isNil ifTrue: [^nil].
    ^sel asArray do: [:each| aBlock value: each ].!   
wmNchittest: wParam with: lParam
        "Private - Process Non-client mouse hit test message.
        Reimplemented here because we want to receive the mouse
        clicks."
    ^nil! !

! ToolPane class methods ! 
supportedEvents
        "Private - Answer the Set of events that ToolPanes can notify
         their owners about."
    ^super supportedEvents
        add: #doubleClicked;
        yourself! !

! ToolPane methods !  
button1DoubleClick: aPoint
        "Private - Notify the owner that the user has double clicked.."

    self event:#doubleClicked.!
button1Down:aPoint
        "Private - Left button is pressed down."

    tools do:[:each |
        (each rectangle containsPoint:aPoint)
            ifTrue:[buttonPressed:=each]].

    buttonPressed isNil ifTrue:[^super button1Down: aPoint].
    self helpContext: (self contextForItem: buttonPressed).
    (self helpManager notNil and:[self helpManager helpMode]) ifTrue:[
        self helpManager displayHelp: self helpContext key.
        buttonPressed := nil.
        ^self].
    buttonState:=true.
    clickState:=true.
    self captureMouseInput.
    self doGraphics:[self drawTool:buttonPressed].
    self showHelp:buttonPressed!  
button1Move:aPoint
        "Private - Left button is down while the mouse
         is moving. Display the help text in the status bar if any."

    |found|
    buttonPressed isNil ifTrue:[^self].
    (buttonPressed rectangle containsPoint:aPoint)
        ifTrue:[found:=true]
        ifFalse:[found:=false].

    found=buttonState ifTrue:[^self].
    buttonState:=found.
    self doGraphics:[self drawTool:buttonPressed].!
button1Up:aPoint
        "Private - Left button is pressed up."

    |found|
    buttonPressed isNil ifTrue:[^self].
    (buttonPressed rectangle containsPoint:aPoint)
        ifTrue:[found:=true]
        ifFalse:[found:=false].
    clickState:=false.
    self clearMouseCapture.
    buttonState ifTrue:[
        buttonState:=false.
        self doGraphics:[self drawTool:buttonPressed]].
    found ifTrue:[self performSelector:buttonPressed].
    buttonPressed:=nil.
    self eraseHelp.!   
buttonState
        "Private - Answer the receiver's buttonState."

    ^buttonState!  
buttonState:aBoolean
        "Private - Set the receiver's buttonState."

    buttonState:=aBoolean!   
close
        "Private - Reimplemented here to release the bitmaps."
    |answer|
    answer := super close.
    toolsBitmap notNil
        ifTrue:[toolsBitmap release].
    ^answer.! 
colorChange
        "Private - Window's color has changed.
        Set the new background color and create the bitmaps."

    colors := self sysColors.
    self backColor: WinInfo colorButtonFace.
    tools do:[:each | each colorChange].
    self makeToolsBitmap.
    ^super colorChange.!  
contents
        "Answer the receiver's contents, i.e.
        a collection of Tool objects."

    ^tools!
contents: aToolCollection
        "Set the receiver's contents.
        aToolCollection is a collection of Tool objects."
    |leftTopPoint i space|

    tools := aToolCollection.
    i := 0.
    space := 0.
    self contents do:[:each |
        each space notNil ifTrue:[space := space + each space].
        leftTopPoint := (i * (each extent x left: 1)) + space  @ 2.
        each rectangle: (Rectangle leftTop:leftTopPoint extent: each extent).
        i := i + 1].
    colors := self sysColors.
    self makeToolsBitmap.!   
contextForItem:aTool
        "Private - The user has clicked a tool
        Answer its context."
    |helpOwner help key selector|
    self statusPane isNil ifTrue:[^nil].
    aTool selector isNil ifTrue:[^nil].
    selector:=aTool selector.
    (selector isKindOf: Message) ifTrue: [
        key:=selector selector.
        helpOwner:=selector receiver
    ] ifFalse:[
        helpOwner:=aTool owner.
        key:=aTool selector
    ].
    helpOwner isNil ifTrue:[^nil].
    key:=key asString.
    ^Association key: key value: helpOwner!
display
        "Private - Display its contents."

    toolsBitmap isNil ifTrue:[^self].
    buttonState:=false.
    graphicsTool
        copyBitmap: toolsBitmap
        from: toolsBitmap boundingBox
        at: Rectangle leftTopUnit!
drawTool:aTool
        "Private - Display the bitmap's tool depending on its state."

    aTool isNil ifTrue:[^self].
    self buttonState
        ifTrue:[aTool displayToolDownWith: graphicsTool]
        ifFalse:[aTool displayToolUpWith: graphicsTool].!   
eraseHelp
        "Private - a tool has been deselected
        Erase the help text."

    self statusPane isNil ifTrue:[^self].
    self statusPane showHelp:nil!   
frameStyle
        "Private - Answer an Integer with appropriate styles in it."
     ^WsChild |
     WsClipsiblings |
     WsBorder!  
freeClientArea:box
    "Private - Set the client area left over."
    self visible ifFalse:[^self].
    box leftTop:(box leftTop rightAndDown: (0 @ self height))! 
getGraphicsTool
        "Private - Initialize an empty pen tool."
    ^Pen forDC: nil medium: self! 
height
        "Answer the receiver's height."

    ^height!   
height:anInteger
        "Set the receiver's height."

    height:=anInteger!  
initialize
        "Private - Initialize the receiver."

    |cxBorder cyBorder screenWidth|
    super initialize.
    tools := OrderedCollection new.
    self height: 27.
    self backColor: WinInfo colorButtonFace.
    cxBorder:=WinInfo cxBorder.
    cyBorder:=WinInfo cyBorder.
    screenWidth := Display width + (2 * cxBorder).
    colors := Array new:4.
    self framingBlock:[:box| (Rectangle leftTopUnit leftAndUp: (cxBorder @ cyBorder)) rightBottom: (screenWidth @ self height)].!  
isToolPane
        "Answer true if receiver is an instance of class
         ToolPane, else answer false."
    ^true!  
makeToolsBitmap
        "Private - Create a bitmap with all the tools."
    |aPen|
    toolsBitmap notNil ifTrue:[toolsBitmap release].
    toolsBitmap := Bitmap screenExtent: (Display width @ self height).
    aPen := toolsBitmap pen.
    aPen backColor: WinInfo colorButtonFace.
    aPen erase.
    tools do:[:each | each displayToolUpWith: aPen].!
open
        "Private - open the toolPane."

    super open.
    self event:#getContents.!
performSelector:aTool
        "Private - The use has clicked a tool
        Perform its selector."
    |selector|
    aTool selector isNil ifTrue:[^self].
    selector:=aTool selector.
    (selector isKindOf: Message)
            ifTrue: [^selector perform].
    aTool owner isNil ifTrue:[^self].
    aTool owner perform:aTool selector.!
showHelp:aTool
        "Private - The use has clicked a tool
        Show the help."
    |help context|
    context := self helpContext.
    context isNil ifTrue:[^self].
    help:=context value statusPaneHelp: context key.
    help isNil ifTrue:[^self].
    self statusPane showHelp:help! 
sysColors
        "Private - Answer system colors for push buttons."

        ^(Array new:4)
            at: 1 put: WinInfo colorButtonText;
            at: 2 put: WinInfo colorButtonShadow;
            at: 3 put: WinInfo colorButtonFace;
            yourself.!  
toolAt: toolSymbol
        "Answer the first tool with the name toolSymbol."

    ^tools detect:[:each | each name = toolSymbol] ifNone:[nil]! 
updateSliders
        "Private - Reimplemented here because ToolPane
         have no scrollbars."! 
validate
        "Private - The window for the receiver was
        just created or recreated. Show the ToolPane if the visible
        property is true."
    |newColors|
    super validate.
    newColors := self sysColors.
    colors = newColors ifFalse:[
        self colorChange].
    self visible ifTrue:[self showWindow].!  
winClass
        "Private - Answer the receiver's window class."

    | className wndClass lptr answer|
    className := 'SmalltalkV',self class name.
    wndClass := WinWindowClass new.
    answer:=UserLibrary getClassInfo: WIN hInstanceExe
        className: className asParameter
        wndClass: wndClass asParameter.
    answer ifTrue:[^className].
    UserLibrary getClassInfo: WIN hInstanceExe
        className: 'VWIN' asParameter
        wndClass: wndClass asParameter.
    wndClass style:CsDblclks;
        className: (lptr := WinAddress
            copyToNonSmalltalkMemory: className asAsciiZ) asParameter.
    UserLibrary registerClass: wndClass asParameter.
    lptr unlock; free.
   ^className!  
wmErasebkgnd: wordInteger with: longInteger
        "Private - Process the erase background message."
    ^1!   
wmNchittest: wParam with: lParam
        "Private - Process Non-client mouse hit test message.
        Reimplemented here because we want to receive the mouse
        clicks."
    ^nil! !

! WBLayoutPane class methods ! 
isWBInternalClass

    ^true!   
supportedEvents

    ^super supportedEvents
        add: #cursorUnloaded;
        add: #selectionChanged;
        add: #operationOccurred;
        add: #changed;
        add: #editPane;
        add: #gettingFocus;
        add: #rightButtonDown;
        yourself! !

! WBLayoutPane methods !
aboutToSaveImage

    graphicsTool release.
    super aboutToSaveImage.!   
alignAll: alignBlock

    | deltaList |

    deltaList := OrderedCollection new.
    selectedPanes do: [ :p |
        deltaList addLast:  (alignBlock value: p)
    ].


    self doAlign: deltaList.!  
alignBottom

    | alignAgainst  |

    rubberBandSelected ifTrue: [
        "Ambiguous selection - choose bottom most pane"
        alignAgainst := self topMostCoord.
        selectedPanes do: [ :p |
            alignAgainst := alignAgainst lowerOf:  p rect bottom.
        ].
    ] ifFalse: [
        alignAgainst := selectedPanes first rect bottom.
    ].


    self alignAll: [:pane | 0 @ (alignAgainst - pane rect bottom) ].! 
alignCenterHorizontal

    | leftMost rightMost fullWidth |

    leftMost := 32000.
    rightMost := 0.
    selectedPanes do: [ :p |
        rightMost := p rect right rightMost: rightMost.
        leftMost := p rect left leftMost: leftMost.
    ].

    fullWidth := rightMost - leftMost.

    self alignAll: [:p | (leftMost + ((fullWidth - p rect width) // 2) - p rect left) @ 0 ].!   
alignCenterVertical

    | topMost bottomMost fullHeight |

    topMost         := self bottomMostCoord.
    bottomMost   := self topMostCoord.
    selectedPanes do: [ :p |
        bottomMost := p rect bottom lowerOf: bottomMost.
        topMost := p rect top higherOf: topMost.
    ].

    fullHeight := (bottomMost - topMost) abs.

    self alignAll: [:p | 0@(((topMost down: ((fullHeight - p rect height)// 2))) - p rect top)].!  
alignDistributeHorizontal

    | leftMost rightMost totalPaneWidth previousPos space deltaList |

    leftMost := 32000.
    rightMost := 0.
    totalPaneWidth := 0.
    selectedPanes do: [ :p |
        rightMost := p rect right rightMost: rightMost.
        leftMost := p rect left leftMost: leftMost.
        totalPaneWidth := totalPaneWidth + p rect width.
    ].

    space := (rightMost - leftMost - totalPaneWidth) // (selectedPanes size - 1).

    selectedPanes := (selectedPanes asSortedCollection: [ :a :b |
        a rect left isLeftOf: b rect left
    ]) asOrderedCollection.

    previousPos := selectedPanes first rect left.

    deltaList := OrderedCollection new.
    selectedPanes do: [ :p |
        deltaList addLast:  (previousPos - p rect left)@0.
        previousPos := previousPos + space + p rect width.
    ].

    self doAlign: deltaList.!
alignDistributeVertical

    |  topMost bottomMost totalPaneHeight previousPos space deltaList |

    topMost := self bottomMostCoord.
    bottomMost := self topMostCoord.
    totalPaneHeight := 0.
    selectedPanes do: [ :p |
        bottomMost := p rect bottom lowerOf: bottomMost.
        topMost := p rect top higherOf: topMost.
        totalPaneHeight := totalPaneHeight + p rect height.
    ].

    space := ((bottomMost - topMost) abs - totalPaneHeight) // (selectedPanes size - 1).

    deltaList := OrderedCollection new.

    selectedPanes := (selectedPanes asSortedCollection: [ :a :b |
        a rect top isAbove: b rect top
    ]) asOrderedCollection.

    previousPos := selectedPanes first rect top.
    selectedPanes do: [ :p |
        deltaList addLast:  0@(previousPos - p rect top).
        previousPos := (previousPos down: space) down: p rect height.
    ].

    self doAlign: deltaList.!  
alignLeft

    | alignAgainst |

    rubberBandSelected ifTrue: [
        "Ambiguous selection - align against leftmost pane in selection"
        alignAgainst := 32000.
        selectedPanes do: [ :p |
            alignAgainst := p rect left leftMost: alignAgainst.
        ].
    ] ifFalse: [
        alignAgainst := selectedPanes first rect left.
    ].

    self alignAll: [:p | (alignAgainst - p rect left)@0 ].!   
alignRight

    | alignAgainst |

    rubberBandSelected ifTrue: [
        "Ambiguous selection - align against rightmost pane in selection"
        alignAgainst := 0.
        selectedPanes do: [ :p |
            alignAgainst := p rect right rightMost: alignAgainst.
        ].
    ] ifFalse: [
        alignAgainst := selectedPanes first rect right.
    ].



    self alignAll: [:p | (alignAgainst - p rect right)@0 ].! 
alignTop

    | alignAgainst |

    rubberBandSelected ifTrue: [

        "Ambiguous selection - align against topmost pane in selection"
        alignAgainst := self bottomMostCoord.
        selectedPanes do: [ :p |
            alignAgainst := p rect top higherOf: alignAgainst.
        ].
    ] ifFalse: [
        alignAgainst := selectedPanes first rect top.
    ].
    self alignAll: [:p | 0@(alignAgainst - p rect top) ].! 
autosizeSelection

    | deltaList s gridSize |

    deltaList := OrderedCollection new.
    gridSize := self gridSize.

    selectedPanes do: [ :p |
        (s := p suggestedSize) isNil ifTrue: [
            deltaList addLast:  0.
        ] ifFalse: [
            "Grid the autosize"
            s := ((s x roundTo: gridSize x) @ (s y roundTo: gridSize y)).
            deltaList addLast: s - p extent
        ].
    ].

    self doAutosize: deltaList.!   
bottomMostCoord

    self isPM ifTrue: [
        ^0
    ] ifFalse: [
        ^30000
    ].! 
bringPaneToFront: c

    panes
        remove: c;
        addFirst: c.

    self displayPane: c clipRect: self editedPaneContentRect.!  
bringToFront

    self
        event: #changed;
        hideSelectionDots;
        bringPaneToFront: selectedPanes first;
        showSelectionDots.!   
buildWindow: arg

    InterfaceObject purgeCache.
    super buildWindow: arg!  
button1DoubleClick: aPoint

    self event: #editPane.! 
button1Down: aPoint

    self button1Down: aPoint shifted: (Notifier isKeyDown: VkControl)! 
button1Down: aPoint shifted: isShifted

    | child |


    self event: #gettingFocus.

    "Are they sizing the edited pane?"
    ((self sizeDotRect expandBy: 2) containsPoint: aPoint) ifTrue: [
        ^self sizeWindowFrom: aPoint
    ].

    "The cursor is loaded, place some panes"
    loadedPanes notNil ifTrue: [
        self placeLoadedPanesAt: aPoint resetCursor: true.
        self event: #cursorUnloaded.
        self checkSelectionChanged.
        ^loadedPanes := nil
    ].

    "Check if they're sizing a child pane"
    selectedPanes do: [:w |
        (self sizePane: w from: aPoint) ifTrue: [
            self checkSelectionChanged.
            ^self
        ].
    ].

    child := self paneHitBy: aPoint.

    isShifted ifTrue: [
        self toggleSelect: child.
    ] ifFalse: [
        child == editedPane ifFalse: [
            self dragSelectedPanesFrom: aPoint childHit: child.
        ] ifTrue: [
            self dragSelectFrom: aPoint.
        ].
    ].

    selectionHasChanged ifTrue: [
            (selectedPanes size > 0 and: [ self referencePane ~= selectedPanes first ]) ifTrue: [
                self referenceClear
            ]].
    self checkSelectionChanged.! 
button1DownShift: aPoint

    self button1Down: aPoint shifted: true!   
button2Down: aPoint

    self event: #gettingFocus.

    loadedPanes isNil ifTrue: [
        ^self event: #rightButtonDown

    ] ifFalse: [
        self placeLoadedPanesAt: aPoint resetCursor: false.

        "They may place again, so copy the loaded subpanes."
        loadedPanes := Array
            with: ((loadedPanes at: 1) collect: [ :aPane | aPane fullCopy ])
            with: (loadedPanes at: 2).
    ].

    self checkSelectionChanged.!  
checkSelectionChanged

    selectionHasChanged ifTrue: [
        self event: #selectionChanged.
        selectionHasChanged := false.
    ].!
clear

    self event: #clear.
    self doClear: nil.! 
clipboard

    ^Clipboard!  
clipboard: anObject

    Clipboard := anObject! 
clipRect

    ^0@0 extent: 10000@10000! 
colorChange
        "Private - Window's color has changed."
    editedPane notNil ifTrue: [
        editedPane resetColors.
        panes do: [ :p |
            p resetColors.
        ].
        self invalidateRect: self rectangle.
    ].!   
copy

    self clipboard:
        ((self getCopyStructure: [ :aPane | aPane fullCopy. ]) at: 1)!   
cut

    self copy.
    self clear.!   
defaultCursor

    loadedPanes notNil ifTrue: [
        ^CursorManager crossHair
    ] ifFalse: [
        ^CursorManager arrow
    ].!  
disableSelectionDots

    KeepDotsHidden := true.!  
display

     | region |

    region := self pen setClipRect: self editedPaneFrameRect.

    editedPane drawFrameWith: self pen at: self editedPaneFrameLeftTop.

    self pen destroyRegion: region.

    self updateRect: (self editedPaneContentLeftTop extentFromLeftTop: self editedPaneContentRect extent).

    "Since we may end up displaying as the result of a arrow key
     move, we don't want to show the selection dots."


    KeepDotsHidden | self drawToBitmap ifFalse: [
        self showSelectionDots.
        self showSizeDot.
   ].! 
displayPane: p clipRect: r

    | region clipRect |

    p resetPen: self pen.

    region := self pen setClipRect: (clipRect := r intersect: p rect).
    p displayWith: self pen clipRect: clipRect.
    self pen destroyRegion: region.!   
doAlign: aDeltaList

    self hideSelectionDots.
    self moveSelectionByDeltaList: aDeltaList.
    self showSelectionDots.!  
doAutosize: aDeltaList

    self doDeltaSize: aDeltaList op: #autosize.!
doByPixel: selector

    "Private - Process an arrow (cursor movement) key."

    self hideSelectionDots.
    self perform: selector.
    self showSelectionDots.!  
doClear: ignore

    | selectedRect savedInfo |

    selectedRect := self selectedRect.

    self hideSelectionDots.
    savedInfo := self getCopyStructure: [:p | p ].

    selectedPanes do: [ :aPane |
        panes remove: aPane.
    ].
    selectedPanes := OrderedCollection new.
    selectionHasChanged := true.

    self updateRect: selectedRect.
    self showSelectionDots.

    self lastOperation: #clear savedInfo: savedInfo.
    self checkSelectionChanged.
    self event: #changed.

    self referenceClear.!   
doDeltaSize: aDeltaList op: anOp

    self hideSelectionDots.
    self sizeSelectionByDeltaList: aDeltaList op: anOp.
    self showSelectionDots.!
doMove: aDelta

    self hideSelectionDots.
    self moveSelectionByDelta: aDelta.
    self showSelectionDots.!   
doReplicateSize: aDeltaList

    self doDeltaSize: aDeltaList op: #replicateSize.!  
doSize: newRect

    self hideSelectionDots.
    self sizeSelectionToRect: newRect.
    self showSelectionDots.!  
doSizeWindow: newExtent

    self lastOperation: #sizeWindow savedInfo: self editedPaneFrameRect extent.

    editedPane extent: newExtent.

    self scrollPane windowHasSized.

    panes do: [:p |
        p reframe: self editedPaneContentRect.
    ].

    self invalidateRect: nil; updateWindow.
    self setFocus.! 
dragRect: aRect from: aPoint constrainedBy: constrainRect gridSize: aGridSize withMethod: method

    | mouseLoc  moveRect  newPoint delta region minMove movedEnough |

    minMove := 3@3.
    movedEnough := false.

    self captureMouseInput.
    moveRect := aRect.

    mouseLoc := aPoint.

    delta := aPoint - moveRect leftTop.
    region := self pen setClipRect: self clipRect.

    self pen drawFocusRect: moveRect.

    Notifier consumeInputUntil: [ :e |
        (e selector = #button1Move:) | (e selector = #button2Move:)  ifTrue: [
            mouseLoc := e arguments first.
         ].

        newPoint := (mouseLoc leftAndUp: constrainRect leftTop) - delta.

        newPoint := (newPoint // aGridSize * aGridSize) rightAndDown: constrainRect leftTop.

        newPoint x: ((newPoint x rightMost: constrainRect left) leftMost: (constrainRect right left: moveRect width)).
        newPoint y: ((newPoint y lowerOf: constrainRect top) higherOf: (constrainRect bottom up: moveRect height)).

        (movedEnough or: [ (newPoint + delta - aPoint) x abs > minMove x or: [ (newPoint + delta - aPoint) y abs > minMove y ]]) ifTrue: [
            movedEnough := true.
            (newPoint = moveRect leftTop) ifFalse: [
                self pen drawFocusRect: moveRect.
                moveRect moveToLeftTop: newPoint.
                method isNil ifFalse: [
                    self perform: method withArguments: (Array with: moveRect).
                ].
                self pen drawFocusRect: moveRect.
            ].
        ].
        (e selector = #button1Up:) | (e selector = #button2Up:)
    ].

    self pen drawFocusRect: moveRect.
    self clearMouseCapture.

    self pen destroyRegion: region.

     ^moveRect leftTop! 
dragSelectedPanesFrom: aPoint childHit: aChild

    | delta selectedRect oldOrigin |

    self hideSelectionDots.

    (selectedPanes includes: aChild) ifFalse: [
        selectedPanes := OrderedCollection with: aChild.
        selectionHasChanged := true.
    ].

    selectedRect := self selectedRect.
    oldOrigin := selectedRect leftTop.

    CursorManager crossHair changeFor: [
        delta := (      self
            dragRect: selectedRect
            from: aPoint
            constrainedBy: ( self editedPaneContentLeftTop extentFromLeftTop: editedPane contentRect extent)
            gridSize: self gridSize
            withMethod: #updatePosition:) - oldOrigin.
    ].

    self moveSelectionByDelta: delta.

    self showSelectionDots.!
dragSelectFrom: aPoint

    | selectedRect containedPanesHit |

    self unselectAll.
    selectedRect := self
            rubberBandRect:    (aPoint rightBottom: aPoint)
            from:               aPoint
            inDirection:        #downRight
            constrainedBy:    self editedPaneFrameRect
            minimumSize:        nil
            maximumSize:        nil
            foldOver:           true
            gridSize:          1@1
            withMethod:         nil.

    (containedPanesHit := panes select: [:c | c hitRect intersects: selectedRect ]) isEmpty ifFalse: [
        self select: containedPanesHit.
    ].!
drawGrid
    ^self owner drawGrid!   
drawGrid: bool
    self owner drawGrid: bool!
drawGridWithin: aRect

        | contentRect left right top bottom p gridSize |

        gridSize := self gridSize.
        self drawGrid ifFalse: [ ^self ].

        contentRect := self editedPaneContentRect.

        left := ((aRect left - contentRect left) truncateTo: gridSize x) + contentRect left.
        right := aRect right.
        top := ((aRect top - contentRect top) truncateTo: gridSize y) + contentRect top.
        bottom := aRect bottom.

        editedPane backColor == ClrPalegray ifTrue: [
            self pen foreColor: ClrDarkgray
        ] ifFalse: [
             self pen foreColor: ClrPalegray
       ].

        p := self pen.
        left to: right by: gridSize x do: [ :curX |
            p lineFrom: curX @ top to: curX @ bottom.
        ].
        top to: bottom by: gridSize y do: [:curY |
            p lineFrom: left @ curY to: right @ curY.
        ].! 
drawToBitmap

    ^false!   
duplicate

    self referencePoint isNil ifTrue: [
        self referencePoint: self paneToReplicate rect leftTop.
    ].
    self referencePane: self paneToReplicate.

    self copy.
    self paste.
    self placeDuplicatePane.!
duplicateOffset
    | grid |
    grid := self gridSize.
    ^self paneToReplicate rect leftTop rightAndDown:
            ((10 roundTo: grid x) @ (10 roundTo: grid y))!   
editedPane

    ^editedPane!
editedPaneContentLeftTop

    ^self editedPaneFrameLeftTop + (editedPane contentRect leftTop - editedPane rect leftTop)!
editedPaneContentRect

    ^self editedPaneContentLeftTop extentFromLeftTop: editedPane contentRect extent! 
editedPaneFrameLeftTop

    ^self margin@self margin!   
editedPaneFrameRect

    ^self editedPaneFrameLeftTop extentFromLeftTop: editedPane frameExtent!
enableSelectionDots

    KeepDotsHidden := false.!  
exportedPanes

    "Pass out the list of panes, setting up their rects to be
     relative to the edited pane's bottom left, not the layout pane's."

    | newPanes thePane|

    newPanes := panes collect: [ :p |
        thePane := p fullCopy.
        thePane rect: ((thePane rect leftTop leftAndUp:  self editedPaneContentRect leftBottom negated) extentFromLeftTop: thePane rect extent).
        thePane
    ].

    ^newPanes!  
fullRectForPanes: paneList

    | left right top bottom rect |

    right  := 0.
    bottom := self topMostCoord.
    left  := 30000.
    top := self bottomMostCoord.

    paneList do: [:p |
        left    := p rect leftTop x leftMost: left.
        right   := p rect rightBottom x rightMost: right.
        top     := p rect leftTop y higherOf: top.
        bottom  := p rect rightBottom y lowerOf: bottom.
    ].

    ^left@top rightBottom: right@bottom.!
getCopyStructure: copyBlock

    "This routine saves 3 pieces of information:
      A) an ordered collection of the panes that were removed
      B) an ordered collection of the relative positions of each of these
         panes to the upper left corner of the rectangle containing them all.
      C) the origin of that rectangle

    The structure for this is:
        Array [1]  =   Array [1] : A
                       Array [2] : B
        Array [2] : C "

    | topLeft savedPanes |

    savedPanes := Array new: 2.

    savedPanes at: 1 put: (
        selectedPanes collect: copyBlock
    ).

    "Collect the origins of the panes to copy, relative to
     each other (thus upleftmost panes will be at 0@0)."

    topLeft := self selectedRect leftTop.
    savedPanes at: 2 put: (selectedPanes collect: [ :aPane |
        aPane rect leftTop - topLeft
    ]).

    ^Array with: savedPanes with: topLeft.! 
getGraphicsTool
        "Private - Answer a graphics tool for the receiver."
    | dc |

    dc := self getDC.
    ^graphicsTool := Pen forDC: dc medium: self!  
gridSize
    ^self owner gridSize!   
gridSize: newSize
    self owner gridSize: newSize!  
hideSelectionDots

    selectedPanes do: [:p |
        self hideSelectionDotsOn: p.
    ].!   
hideSelectionDotsOn: p

    self showSelectionDotsOn: p.!   
hideSizeDot

    self pen execute: [
        self pen
            fill: self sizeDotRect color: ClrWhite
    ] clipRect: self clipRect.! 
importPanes: paneList

   ^paneList collect: [ :s |
        s rect: ((s rect leftTop leftAndUp: self editedPaneContentRect leftBottom) extentFromLeftTop: s rect extent).
    ].! 
initialize

    super initialize.
    panes := OrderedCollection new.
    selectedPanes   := OrderedCollection new.
    KeepDotsHidden := false.
    selectionHasChanged := false.
    inTabEdit := false.
    rubberBandSelected := false.!  
isPM

    ^false!   
lastOperation: aSymbol savedInfo: savedInfo

    lastOperation := aSymbol.
    undoInfo := savedInfo.
    self checkSelectionChanged.
    self event: #operationOccurred.!   
lastOpSymbol

    ^lastOperation!   
loadCursor: aTool

    aTool isNil ifTrue: [
        loadedPanes := nil.
        CursorManager normal change.
    ] ifFalse: [
        loadedPanes := Array with: (Array with: aTool) with: (Array with: 0@0).
    ].! 
margin

    ^8! 
moveSelectionByDelta: aDelta

    | oldSelectedRect  |

    selectedPanes isEmpty | (aDelta = (0@0)) ifTrue: [ ^nil ].

    self event: #changed.

    oldSelectedRect := self selectedRect.
    selectedPanes do: [ :aPane |
        aPane rect moveBy: aDelta.
        self recalcFramerFor: aPane.
    ].

    self updateRects: oldSelectedRect and: self selectedRect.

    self updatePosition: selectedPanes first rect.

    self lastOperation: #move savedInfo: aDelta negated.!  
moveSelectionByDeltaList: aDeltaList

    | oldSelectedRect curPane newDeltaList |

    selectedPanes isEmpty ifTrue: [ ^nil ].

    self event: #changed.

    oldSelectedRect := self selectedRect.
    1 to: selectedPanes size do: [ :i |
        curPane := selectedPanes at: i.
        curPane rect moveBy: (aDeltaList at: i).
        self recalcFramerFor: curPane.
    ].
    self updateRects: oldSelectedRect and: self selectedRect.

    newDeltaList := aDeltaList collect: [ :d | d negated ].

    self lastOperation: #align savedInfo: newDeltaList.!   
moveSelectionDown

    self moveSelectionByDelta: 0@(self isPM ifTrue: [ -1 ] ifFalse: [ 1 ]).! 
moveSelectionLeft

    self moveSelectionByDelta: -1@0.!
moveSelectionRight

    self moveSelectionByDelta: 1@0.!
moveSelectionUp

    self moveSelectionByDelta: 0@(self isPM ifTrue: [ 1 ] ifFalse: [ -1 ]).!   
outmostWindow

    ^parent! 
paneHitBy: aPoint

    | panesHit |

    panesHit := panes select: [:p | p containsPoint: aPoint ].

    panesHit isEmpty ifTrue: [
        ^editedPane
    ] ifFalse: [
        ^panesHit first
    ].!
panes

    ^panes!  
paneToReplicate

    | minTop maxTop minLeft maxLeft minTopPane minLeftPane position |

    rubberBandSelected ifFalse: [
        ^selectedPanes first
    ].

    "Ambiguous selection - choose an appropriate pane (leftmost for
     vertically aligned panes, topmost for horizontally aligned panes)"

    minTop  := self bottomMostCoord.
    maxTop := self topMostCoord.
    minLeft := 30000.
    maxLeft := 0.

    selectedPanes do: [ :p |
        position := p rect leftTop.
        (position x isLeftOf: minLeft) ifTrue: [
            minLeft := position x.
            minLeftPane := p.
        ].
        (position x isRightOf: maxLeft) ifTrue: [
            maxLeft := position x.
        ].
        (position y isAbove: minTop) ifTrue: [
            minTop := position y.
            minTopPane := p.
        ].
        (position y isBelow: maxTop) ifTrue: [
            maxTop := position y.
        ].
    ].

    (maxTop - minTop)abs > (maxLeft - minLeft) abs ifTrue: [
        ^minTopPane
    ] ifFalse: [
        ^minLeftPane
    ].!
paste

    Clipboard isNil ifTrue: [
        ^self
    ].

    CursorManager crossHair change.

    loadedPanes := Array new: 2.
    loadedPanes
        at: 1 put: ((Clipboard at: 1) collect: [ :aPane | aPane fullCopy ]) reversed;
        at: 2 put: ( Clipboard at: 2) reversed.

    self checkSelectionChanged.
    self event: #operationOccurred:.!   
placeDeletedPanesAt: p resetCursor: resetCursor

    | aPane paneList paneOrigins  |

    self unselectAll.

    paneList      := loadedPanes at: 1.
    paneOrigins   := loadedPanes at: 2.

    1 to: paneList size do: [ :paneIndex |
        aPane := paneList at: paneIndex.
        aPane rect moveToLeftTop: (p + (paneOrigins at: paneIndex)).
        panes addFirst: aPane.
    ].

    panes do: [ :aPane |
        self recalcFramerFor: aPane.
    ].

    self event: #changed.

    selectedPanes := paneList asOrderedCollection.
    self updateRect: self selectedRect.
    self select: paneList.

    self showSelectionDots.!   
placeDuplicatePane

    "Place loaded duplicate panes at an offsets to their originals"

    | newPane loc |

    loadedPanes isNil ifTrue: [
        ^self
    ].
    newPane := loadedPanes first first.
    (self referencePoint notNil and: [ self referencePane notNil ]) ifTrue: [
        loc := self referencePane rect leftTop +
            (self referencePane rect leftTop - self referencePoint).
        loc = self referencePoint ifTrue: [ loc := self duplicateOffset ].
        self referencePoint: self referencePane rect leftTop.
        self referencePane: newPane.
    ] ifFalse: [
        loc := self duplicateOffset
    ].

    self placeLoadedPanesAt: loc resetCursor: true interactive: false.
    self event: #cursorUnloaded.
    self checkSelectionChanged.
    loadedPanes := nil!  
placeLoadedPane

    "Place loaded panes in the center of the visible layout,
     or window, whichever is better"

    | newPane loc frameRect |

    loadedPanes isNil ifTrue: [
        ^self
    ].
    newPane := loadedPanes first first.
    frameRect := self visibleFrameRect.
    loc := frameRect leftTop rightAndDown: ((frameRect extent - newPane extent) // 2).

    self placeLoadedPanesAt: loc resetCursor: true interactive: false.
    self event: #cursorUnloaded.
    self checkSelectionChanged.
    loadedPanes := nil!  
placeLoadedPanesAt: aPoint

    self
        disableSelectionDots;
        placeLoadedPanesAt: aPoint resetCursor: true interactive: false;
        event: #cursorUnloaded;
        checkSelectionChanged;
        enableSelectionDots.
    loadedPanes := nil!   
placeLoadedPanesAt: p resetCursor: resetCursor

    self
        placeLoadedPanesAt: p
        resetCursor: resetCursor
        interactive: true.!  
placeLoadedPanesAt: p resetCursor: resetCursor  interactive: isInteractive

    | aPane paneList paneOrigins aPoint mouseStillDown e topStaysToBack gridSize |

    gridSize := self gridSize.
    self unselectAll.

    paneList      := loadedPanes at: 1.
    paneOrigins   := loadedPanes at: 2.

    aPoint := self roundPointToGrid: p.

    "If there's more than one pane, we can't set the size by dragging."
    paneList size = 1 & isInteractive ifTrue: [
        mouseStillDown := true.
        Notifier consumeInputUntil: [ :event |
            (event selector = #button1Up:) | (event selector = #button2Up:)  ifTrue: [
                mouseStillDown := false.
            ].
            (event selector = #button1Move:) |  (event selector = #button2Move:) |
            (event selector = #button1Up:) | (event selector = #button2Up:)
        ].
        mouseStillDown ifTrue: [
            e := (self
                rubberBandRect:    (aPoint extent: 1@1)
                from:               aPoint
                inDirection:        #downRight
                constrainedBy:      (self editedPaneContentLeftTop extentFromLeftTop: editedPane contentRect extent)
                minimumSize:        paneList first minSize
                maximumSize:        paneList first maxSize
                foldOver:           false
                gridSize:           gridSize
                withMethod:         nil) extent.
        ].
    ].

    resetCursor ifTrue: [
        CursorManager normal change.
    ].

    paneList := paneList collect: [:w | w fullCopy ].

    (e notNil and: [ (e y > 3) & (e x > 3) ]) ifTrue: [
        paneList first rect extent: e.
    ].

    panes reverseDo: [ :pane |
        pane staysToBack ifTrue: [
            topStaysToBack  := pane.
        ].
    ].

    1 to: paneList size do: [ :paneIndex |
        aPane := paneList at: paneIndex.
        aPane rect moveToLeftTop: (aPoint + (paneOrigins at: paneIndex)).
        aPane parent: editedPane.
        aPane staysToBack ifTrue: [
            topStaysToBack notNil ifTrue: [
                panes add: aPane before: topStaysToBack.
            ] ifFalse: [
                panes addLast: aPane.
            ].
            topStaysToBack := aPane.
        ] ifFalse: [
            panes addFirst: aPane.
        ].
        aPane tabPosition: nil.
    ].

    panes do: [ :aPane |
        self recalcFramerFor: aPane.
    ].

    self event: #changed.

    selectedPanes := paneList asOrderedCollection.
    self updateRect: self selectedRect.
    self select: paneList.

    self showSelectionDots.
    self lastOperation: #place savedInfo: #notUndoable.!
placeLoadedPanesAtLeftTop

    self
        paste;
        disableSelectionDots;
        sizeWindowExternal: (self rectForPanes: (loadedPanes at: 1)) extent;
        placeLoadedPanesAt: self visibleFrameRect leftTop resetCursor: true interactive: false;
        event: #cursorUnloaded;
        checkSelectionChanged;
        unselectAll;
        enableSelectionDots.
    loadedPanes := nil! 
previousOpSymbol

    ^undoInfo at: 1.! 
recalcFramerFor: aPane

    | windowRect |

    windowRect := self editedPaneContentRect.

    aPane framingBlock isNil ifFalse: [
        aPane framingBlock: (aPane framingBlock newFramerFromNewRect: (windowRect localizeRect: aPane rect) parentRect: (0@0 extent: windowRect extent)).
        aPane reframe: windowRect.
    ].!  
rectForPanes: paneList

    | left right top bottom rect |

    right  := 0.
    bottom := self topMostCoord.
    left  := 30000.
    top := self bottomMostCoord.

    paneList do: [:p |
        left    := p hitRect leftTop x leftMost: left.
        right   := p hitRect rightBottom x rightMost: right.
        top     := p hitRect leftTop y higherOf: top.
        bottom  := p hitRect rightBottom y lowerOf: bottom.
    ].

    ^left@top rightBottom: right@bottom.!
redisplaySelection

    | rect |

    rect := self fullRectForPanes: selectedPanes.
    self updateRect: rect.!  
referenceClear

    self referencePane: nil.
    self referencePoint: nil.!
referencePane

    ^self propertyAt: #referencePane!
referencePane: aPane

    self propertyAt: #referencePane put: aPane!   
referencePoint

    ^self propertyAt: #referencePoint!  
referencePoint: aPoint

    self propertyAt: #referencePoint put: aPoint deepCopy!  
reframeAll

    panes do: [:aPane |
        aPane reframe: self editedPaneContentRect.
    ].!
reframePane: aPane

    | oldRect |

    oldRect := aPane rect deepCopy.

    aPane reframe: self editedPaneContentRect.

    self updateRects: oldRect and: aPane rect.! 
replicateHeight

    | deltaList height |

    height := self paneToReplicate rect height.

    deltaList := OrderedCollection new.

    selectedPanes do: [ :p |
        deltaList addLast:  0@(height - p rect height).
    ].

    self doReplicateSize: deltaList.!   
replicateWidth

    | deltaList width |

    width := self paneToReplicate rect width.

    deltaList := OrderedCollection new.

    selectedPanes do: [ :p |
        deltaList addLast:  (width - p rect width)@0.
    ].

    self doReplicateSize: deltaList.! 
roundPointToGrid: p

    | aPoint offset gridSize |

    gridSize := self gridSize.
    offset := self editedPaneContentLeftTop .

    aPoint := p - offset.
    aPoint := ((aPoint x roundTo: gridSize x) @ (aPoint y roundTo: gridSize y)).
    aPoint := (aPoint + offset) max: 0@0.


    ^aPoint!
rubberBandRect: aRect from: aPoint inDirection: direction constrainedBy: constrainer minimumSize: minSize maximumSize:  maxSize  foldOver: foldOver gridSize: aGridSize withMethod: method

    | region mouseLoc sizeRect constrainRect delta anchor sizer minExtent maxExtent xPositive yPositive  |

    mouseLoc := aPoint.

    minExtent := minSize.
    minSize isNil ifTrue: [
        minExtent := 1@1.
    ].

    maxExtent := maxSize.
    maxSize isNil ifTrue: [
        maxExtent := 30000@30000.
    ].

    sizeRect := aRect.
    constrainRect := constrainer.

    "------- Set up anchor and sizer -------"

    ( #( upLeft up left ) includes: direction) ifTrue: [
        anchor := sizeRect rightBottom.
        sizer := sizeRect leftTop.
    ].

    (#( downRight down right) includes: direction) ifTrue: [
        anchor := sizeRect leftTop.
        sizer := sizeRect rightBottom.
    ].

    (direction == #upRight) ifTrue: [
        anchor := sizeRect left @ sizeRect bottom.
        sizer := sizeRect right @ sizeRect top
    ].

    (direction == #downLeft) ifTrue: [
        anchor := sizeRect right @ sizeRect top.
        sizer := sizeRect left @ sizeRect bottom
    ].

    "------- Set up constrain rect and min extent -------"

    (direction == #up) | (direction == #down) ifTrue: [
        constrainRect := sizeRect left @ constrainRect top rightBottom: sizeRect right @ constrainRect bottom.
        minExtent := sizeRect width @ minExtent y.
    ].
    (direction = #right) | (direction = #left) ifTrue: [
        constrainRect := constrainRect left @ sizeRect top rightBottom: constrainRect right @ sizeRect bottom.
        minExtent := minExtent x @ sizeRect height.
    ].
    constrainRect extent: (constrainRect extent min: maxExtent).

    delta   := aPoint - sizer.
    xPositive := (sizer x isRightOf: anchor x).
    yPositive := (sizer y isBelow: anchor y).

    self captureMouseInput.

    region := self pen setClipRect: self clipRect.
    self pen  drawFocusRect: sizeRect.

    KeepDotsHidden := true. "avoid redraw on drag scroll"
    Notifier consumeInputUntil: [ :e |

        (e selector = #button1Move:) | (e selector = #button2Move:)  ifTrue: [
            mouseLoc :=  e arguments first.
         ] ifFalse: [
            e perform.
        ].

        sizer := ((mouseLoc - delta) leftAndUp:  constrainRect leftTop) // aGridSize * aGridSize rightAndDown: constrainRect leftTop.

        (sizer x isLeftOf: constrainRect left) ifTrue: [ sizer x: constrainRect left ].
        (sizer x isRightOf: constrainRect right) ifTrue: [ sizer x: constrainRect right ].
        (sizer y isAbove: constrainRect top) ifTrue: [ sizer y: constrainRect top ].
        (sizer y isBelow: constrainRect bottom) ifTrue: [ sizer y: constrainRect bottom ].

        xPositive ifTrue: [
            foldOver ifFalse: [
                ((sizer x left: anchor x) isLeftOf: minExtent x) ifTrue: [ sizer x: (anchor x right: minExtent x) ].
            ].
            ((sizer x left: anchor x) isRightOf: constrainRect width) ifTrue: [ sizer x: (anchor x right: constrainRect width) ].
        ] ifFalse: [
            foldOver ifFalse: [
                ((anchor x left: sizer x) isLeftOf: minExtent x) ifTrue: [ sizer x: (anchor x left: minExtent x) ].
            ].
            ((anchor x left: sizer x) isRightOf: constrainRect width) ifTrue: [ sizer x: (anchor x left: constrainRect width) ].
        ].

        yPositive ifTrue: [
            foldOver ifFalse: [
                ((sizer y - anchor y) < minExtent y) ifTrue: [ sizer y: (anchor y + minExtent y) ].
            ].
            ((sizer y - anchor y) > constrainRect height) ifTrue: [ sizer y: (anchor y + constrainRect height) ].
        ] ifFalse: [
            foldOver ifFalse: [
                ((anchor y - sizer y) < minExtent y) ifTrue: [  sizer y: (anchor y - minExtent y) ].
            ].
            ((anchor y - sizer y) > constrainRect height) ifTrue: [ sizer y: (anchor y - constrainRect height) ].
        ].

        (sizer = sizeRect leftTop) | (sizer = sizeRect rightBottom)
         | (sizer = (sizeRect left @ sizeRect bottom))
         | (sizer = (sizeRect right @ sizeRect top)) ifFalse: [

            self pen drawFocusRect: sizeRect.
            (anchor x < sizer x)  ifTrue:  [
                (anchor y < sizer y) ifTrue:  [
                    sizeRect := anchor corner: sizer
                ] ifFalse: [
                    sizeRect := (anchor x)@(sizer y) corner: (sizer x)@(anchor y)
                ]
            ] ifFalse: [
                (anchor y < sizer y) ifTrue: [
                    sizeRect := (sizer x)@(anchor y) corner: (anchor x)@(sizer y)
                ] ifFalse: [
                    sizeRect := sizer corner: anchor
                ]
            ].
            method isNil ifFalse: [
                self perform: method withArguments: (Array with: sizeRect)
            ].
            self pen drawFocusRect: sizeRect.
        ].

         (e selector = #button1Up:) | (e selector = #button2Up:)
    ].

    self pen drawFocusRect: sizeRect.

    KeepDotsHidden := false.
    self clearMouseCapture.
    self pen destroyRegion: region.

     ^sizeRect! 
scrollPane

    ^parent!
select: paneList

    rubberBandSelected := paneList size > 1.

    paneList do: [ :aPane |
        (selectedPanes includes: aPane) ifFalse: [
            self showSelectionDotsOn: aPane.
            selectedPanes := selectedPanes asOrderedCollection.
            selectedPanes add: aPane.
        ].
    ].

    selectionHasChanged := true.!
selectAll

    self unselectAll.
    self select: panes.

    self checkSelectionChanged.!   
selectDots: w

    | rectSize halfRectSize rect |

    rectSize     := 8 @ 8.
    halfRectSize := 4 @ 4.

    rect := w rect.

    ^Array with: ((rect leftTop leftAndUp: halfRectSize) extentFromLeftTop: rectSize)
          with: ((rect rightBottom leftAndUp: halfRectSize) extentFromLeftTop: rectSize)
          with: (((rect right @ rect top) leftAndUp: halfRectSize) extentFromLeftTop: rectSize)
          with: (((rect left  @ rect bottom) leftAndUp: halfRectSize) extentFromLeftTop: rectSize)! 
selectedRect

    ^self rectForPanes: selectedPanes!
selection

    ^selectedPanes!  
selectionOrigin

    "Answer the origin, in local coordinates, of the selected pane.  Assumes
     one pane is selected."

    ^ selectedPanes first rect leftTop - self editedPaneContentRect leftTop.! 
selectionOrigin: aPoint

    "Set the origin, in local coordinates, of the selected pane.  Assumes
     one pane is selected."

    self moveSelectionByDelta: aPoint - self selectionOrigin!
sendToBack

    self
        event: #changed;
        hideSelectionDots.

    panes
        remove: selectedPanes first;
        addLast: selectedPanes first.

    self
        updateRect: selectedPanes first rect;
        showSelectionDots.!
setPanes:  paneList

    panes := self importPanes: paneList.

    panes do: [ :p |
        p parent: editedPane.
    ].!   
showSelectionDots

    selectedPanes do: [:w |
        self showSelectionDotsOn: w.
    ].!   
showSelectionDotsOn: w

    |  region |

    region := self pen setClipRect: self editedPaneFrameRect.

    self pen foreColor: ClrBlack; backColor: ClrWhite.
    (self selectDots: w) do: [:r |
        self pen reverse: r.
    ].

    self pen destroyRegion: region.!
showSizeDot

    self pen execute: [
        self pen fill: self sizeDotRect color: ClrBlack.
    ] clipRect: self clipRect.! 
sizeDotRect

    ^(self editedPaneFrameRect rightBottom rightAndDown: 1@1)
        extentFromLeftTop: self margin@self margin! 
sizePane: aPane direction: direction  from: aPoint

     | newRect cursor gridSize |

    gridSize := self gridSize.
    self unselectAllExcept: aPane.
    self hideSelectionDots.

    (#( downRight upLeft) includes: direction) ifTrue: [
        cursor := CursorManager corner.  "Different names would be better"
    ].
    (#( up down) includes: direction) ifTrue: [
        cursor := CursorManager upDown.
    ].
    (#( downLeft upRight) includes: direction) ifTrue: [
        cursor := CursorManager origin.   "Ack!!  Should be neCorner..."
    ].
    (#( left right) includes: direction) ifTrue: [
        cursor := CursorManager leftRight.
    ].

    cursor changeFor: [
        newRect := self rubberBandRect: aPane rect
            from:           aPoint
            inDirection:      direction
            constrainedBy:  (self editedPaneContentLeftTop extentFromLeftTop: editedPane contentRect extent)
            minimumSize:    nil
            maximumSize:    nil
            foldOver:       false
            gridSize:       gridSize
            withMethod:     #updateSize:.
    ].

    self sizeSelectionToRect: newRect.

    self showSelectionDots.

    ^true!
sizePane: aPane from: aPoint

    | lastEvent newPoint direction selectDots |

    selectDots := self selectDots: aPane.
    newPoint := aPoint.

    1 to: selectDots size do: [ :i |
        (((selectDots at: i) expandBy: 2) containsPoint: aPoint) ifTrue: [

            direction := #( upLeft downRight upRight downLeft ) at: i.

            (Notifier isKeyDown: VkShift)  ifTrue: [
                Notifier consumeInputUntil: [ :e |
                    lastEvent := e.
                    (e selector = #button1Move:) | (e selector = #button2Move:) |
                    (e selector = #button1Up:) | (e selector = #button2Up:) and: [ (e arguments first = aPoint) not ]
                ].

                newPoint := lastEvent arguments first.
                (aPoint y - newPoint y) abs > (aPoint x - newPoint x) abs ifTrue: [
                    (direction == #upLeft ) | (direction == #upRight) ifTrue: [
                        direction := #up.
                    ] ifFalse: [
                        direction := #down.
                    ].
                ] ifFalse: [
                    (direction == #upLeft ) | (direction == #downLeft) ifTrue: [
                        direction := #left
                    ] ifFalse: [
                        direction := #right
                    ].
                ].
            ].
            ^self sizePane: aPane direction: direction from: newPoint
         ].
    ].

    ^false!
sizeSelectionByDelta: sizeDelta

    | aPane |

    selectedPanes isEmpty ifTrue: [ ^self ].

    aPane := selectedPanes first.

    ^self sizeSelectionToRect: (aPane rect leftTop extentFromLeftTop: (aPane rect extent + sizeDelta))!  
sizeSelectionByDeltaList: sizeDeltaList op: op

    | oldSelectedRect size newDeltaList curPane |

    selectedPanes isEmpty ifTrue: [ ^nil ].

    self event: #changed.

    oldSelectedRect := self selectedRect.
    1 to: selectedPanes size do: [ :i |
        curPane := selectedPanes at: i.
        size := curPane rect extent + (sizeDeltaList at: i).
        size := ((size max: curPane minSize) min: curPane maxSize).
        curPane autoSizeFrom == #rightJustified ifTrue: [
            curPane rect: (curPane rect rightTop extentFromRightTop: size)
        ] ifFalse: [ curPane autoSizeFrom == #centered ifTrue: [
            curPane rect: (curPane rect centerTop extentFromCenterTop: size)
        ] ifFalse: [
            curPane rect: (curPane rect leftTop extentFromLeftTop: size)
        ]].
        self recalcFramerFor: curPane.
    ].
    newDeltaList := sizeDeltaList collect: [ :s | s negated ].

    self updateRects: oldSelectedRect and: self selectedRect.

    self lastOperation: op savedInfo: newDeltaList.

    ^true!   
sizeSelectionDown

    self sizeSelectionByDelta: 0@1.! 
sizeSelectionLeft

    self sizeSelectionByDelta: -1@0.!
sizeSelectionRight

    self sizeSelectionByDelta: 1@0.!
sizeSelectionToRect: newRect

    | aPane oldRect  |

    self event: #changed.

    aPane := selectedPanes first.
    oldRect := aPane rect deepCopy.

    aPane rect: (newRect leftTop extentFromLeftTop: ((newRect extent max: aPane minSize) min: aPane maxSize)).
    self recalcFramerFor: aPane.

    self updateRects: oldRect and: aPane rect.

    self updateSize: aPane rect.

    self lastOperation: #size savedInfo: oldRect.

    ^true!
sizeSelectionUp

    self sizeSelectionByDelta: 0@-1.!  
sizeWindowExternal: aPoint

    self event: #changed.
    self hideSelectionDots.
    self hideSizeDot.
    self doSizeWindow: aPoint.!  
sizeWindowFrom: aPoint

     | newRect gridSize |

    gridSize := self gridSize.
    self event: #changed.

    self hideSelectionDots.
    self hideSizeDot.

    CursorManager corner changeFor: [
        newRect := (self rubberBandRect: self editedPaneFrameRect
            from:           aPoint
            inDirection:    #downRight
            constrainedBy:  (0@0 extent: 10000@10000)
            minimumSize:    editedPane minSize
            maximumSize:    editedPane maxSize
            foldOver:       false
            gridSize:       gridSize
            withMethod:     #sizingWindow: ).

        self doSizeWindow: newRect extent.
    ].!  
sizingWindow: aRectangle

    self scrollPane sizingWindow: aRectangle.

    self updateSize: aRectangle.!
sortInZorder: paneList

    | nonTabbed tabbed |

    nonTabbed := OrderedCollection new.
    tabbed := OrderedCollection new.

    paneList do: [ :p |
        p tabPosition isNil ifTrue: [
            nonTabbed addLast: p.
        ] ifFalse: [
            tabbed addLast: p.
        ].
    ].

    tabbed := (tabbed asSortedCollection:  [:a :b |
        a tabPosition >= b tabPosition
    ]) asOrderedCollection.


    nonTabbed do: [ :p |
        tabbed addLast: p.
    ].

    ^tabbed!  
toggleSelect: w

    (selectedPanes includes: w) | (w == editedPane) ifFalse: [
        self select: (OrderedCollection with: w).
    ] ifTrue: [
        self hideSelectionDotsOn: w.
        selectedPanes remove: w ifAbsent: [].
        selectionHasChanged := true.
    ].! 
topMostCoord

    (self isPM) ifTrue: [
        ^30000
    ] ifFalse: [
        ^0
    ].!  
totalLength

    editedPane isNil ifTrue: [
        ^self margin * 2
    ].

    ^(self margin*2) + editedPane frameExtent y!   
totalWidth

    editedPane isNil ifTrue: [
        ^self margin * 2
    ].

    ^self margin*2 + editedPane frameExtent x!  
undo

    | lastDoneOperation lastDoneInfo capLastDoneOp |

    "A might tricky..."
    (lastOperation == #undo) ifTrue: [
        lastDoneOperation := undoInfo at: 1.
        capLastDoneOp := lastDoneOperation asString.
        capLastDoneOp at: 1 put: (capLastDoneOp at: 1) asUpperCase.
        lastDoneInfo := undoInfo at: 2.
        self perform: ('do',capLastDoneOp, ':') asSymbol withArguments: (Array with: lastDoneInfo)
    ] ifFalse: [
        capLastDoneOp := lastOperation asString.
        capLastDoneOp at: 1 put: (capLastDoneOp at: 1) asUpperCase.
        self perform: ('undo', capLastDoneOp, ':') asSymbol withArguments: (Array with: undoInfo).
        self lastOperation: #undo savedInfo: (Array with: lastOperation with: undoInfo).
    ].! 
undoAlign: aDeltaList

    self hideSelectionDots.
    self moveSelectionByDeltaList: aDeltaList.
    self showSelectionDots.!
undoAutosize: aDeltaList

    self doAutosize: aDeltaList.! 
undoClear: savedClearInfo

    loadedPanes := savedClearInfo at: 1.
    self placeDeletedPanesAt: (savedClearInfo at: 2) resetCursor: false.
    loadedPanes := nil.

    self checkSelectionChanged.!  
undoMove: aDelta

    self hideSelectionDots.
    self moveSelectionByDelta: aDelta.
    self showSelectionDots.! 
undoReplicateSize: aDeltaList

    self doReplicateSize: aDeltaList.!   
undoSize: aRect

    self doSize: aRect!
undoSizeWindow: windowSize

    self doSizeWindow: windowSize!  
ungroupComposite

    "Ungroup a CompositePane"

    |  loc newPanes composite |

    self cut.
    self paste.
    loadedPanes isNil ifTrue: [
        ^self
    ].
    composite := loadedPanes first first.
    loc := composite rect leftTop.
    newPanes := composite children.
    loadedPanes at: 1 put: OrderedCollection new.
    loadedPanes at: 2 put: OrderedCollection new.
    newPanes do: [ :pane |
        pane reframe: composite rect.
        (loadedPanes at: 1) add: pane.
        (loadedPanes at: 2) add: (pane rect leftTop - composite rect leftTop).
    ].
    self placeLoadedPanesAt: loc resetCursor: true interactive: false.
    self event: #cursorUnloaded.
    self checkSelectionChanged.
    loadedPanes := nil!   
unselectAll

    self hideSelectionDots.
    selectedPanes := OrderedCollection new.

    selectionHasChanged := true.!  
unselectAllExcept: aPane

    selectedPanes do: [:w |
        (w == aPane) ifFalse: [ self hideSelectionDotsOn: w ].
    ].

    (aPane == editedPane) ifTrue: [
        selectedPanes := OrderedCollection new.
        ^selectionHasChanged := true
    ].


    (selectedPanes includes: aPane) ifFalse:  [
        self showSelectionDotsOn: aPane
    ].

    selectedPanes := OrderedCollection with: aPane.

    selectionHasChanged := true.!   
updatePosition: aRect

    self owner updatePosition: (aRect leftTop - self editedPaneContentRect leftTop).!
updateRect: r

    | clipRect region rect |

    (r intersects: self editedPaneContentRect) ifFalse: [
        ^self
    ] ifTrue: [
        clipRect :=  r intersect: self editedPaneContentRect.
    ].

    region := self pen setClipRect: clipRect.
    self pen fill: r color: editedPane backColor.
    self drawGridWithin: clipRect.
    self pen destroyRegion: region.

    panes reverseDo: [ :p |

        (p rect intersects: r) ifTrue: [
            self displayPane: p clipRect: clipRect.
        ].
    ].!   
updateRects: oldSelectedRect and: newSelectedRect

    (oldSelectedRect intersects: newSelectedRect) ifFalse: [
        self
            updateRect: oldSelectedRect;
            updateRect: newSelectedRect.
    ] ifTrue: [
        self updateRect: ((oldSelectedRect leftTop leftMostAndHighest: newSelectedRect leftTop)
            rightBottom: (oldSelectedRect rightBottom rightMostAndLowest: newSelectedRect rightBottom)).
    ].!  
updateSize: aRect

    self owner updateSize: aRect.!   
updateTitle: aPane

    aPane == editedPane ifTrue: [
        ^aPane drawTitleTextWith: self pen in: (aPane titleRectFrom: self editedPaneFrameLeftTop)
    ].

    self
        hideSelectionDots;
        updateRect: aPane rect;
        showSelectionDots.!  
usesFocus

    ^true!   
visibleFrameRect

    "Answer the client rectangle of the edited window
    that is currently visible in the scrolling pane (i.e.
    the client rectangle intersected with the visible region)"

    | visRect |

    visRect := (self rectangle leftTop + self scrollPane topCorner) extentFromLeftTop: self scrollPane visibleExtent.

    ^(self editedPaneContentRect intersect: visRect).!
winClass
        "Private - Answer the window class of GraphPane."
    | className wndClass lptr answer |
    className := 'WBLayout'.
    wndClass := WinWindowClass new.
    answer := UserLibrary getClassInfo: WIN hInstanceExe
        className: className asParameter
        wndClass: wndClass asParameter.
    answer ifTrue:[^className].
    UserLibrary getClassInfo: WIN hInstanceExe
        className: 'VWIN' asParameter
        wndClass: wndClass asParameter.
    wndClass style: (CsOwndc | CsDblclks | CsVredraw | CsHredraw);
        className: (lptr := WinAddress
            copyToNonSmalltalkMemory: className asAsciiZ) asParameter.
    UserLibrary registerClass: wndClass asParameter.
    lptr unlock; free.
   ^className!
wmNchittest: wParam with: lParam

    ^nil! !

! WBRealLayoutPane class methods ! 
initWinConstants

    AcuFont := SysFont.!  
resetBitmap

    DrawingBitmap := nil.! !

! WBRealLayoutPane methods !   
checkMnemonicConflicts

    | mnemonic |

    (selectedPanes size = 1) ifFalse: [
        ^self
    ].

    (mnemonic := selectedPanes first contents) isString ifFalse: [
        ^self
    ].

    (mnemonic := mnemonic mnemonicChar) isNil ifTrue: [
        ^self
    ].

    panes do: [ :p |
        p contents notNil ifTrue: [
            (p ~= selectedPanes first) & (p contents isString and: [ p contents mnemonicChar = mnemonic ]) ifTrue: [
                ^MessageBox messageNote: 'The ', p realClass name, ' with contents ', p contents asQuotedString stripMnemonic, ' already has the mnemonic &', (String with: mnemonic), '.  Please choose another.'
            ].
        ].
    ].

    editedPane menu notNil ifTrue: [
        editedPane menu children do: [:m |
            (m listString mnemonicChar = mnemonic) ifTrue: [
                ^MessageBox messageNote: 'The menu ', m listString asQuotedString stripMnemonic, ' already has the mnemonic ~', mnemonic asString, '.  Please choose another.'
            ].
        ].
    ].! 
convertChild: c inView: aView

    | newChild newChildClass name |

    newChildClass := (self pseudoClassFor: c class name).

    newChildClass = PScrollBar ifTrue: [
        (c style bitIsOn: SbsVert) ifTrue: [
            newChildClass := PWBVerticalScrollBar
        ] ifFalse: [
            newChildClass := PWBHorizontalScrollBar
        ].
    ].

    newChild := newChildClass new.

    c framingBlock isContext ifTrue: [
        newChild framingBlock: (self framingParametersFor: c framingBlock inView: aView).
    ] ifFalse: [
        newChild framingBlock: c framingBlock.
    ].

    (c respondsTo: #contents) ifTrue: [
        newChild contents: c contents
    ].

    newChild
        handlers: c realHandlers;
        menu: c getPopupMenu;
        paneName: c paneName;
        realClass: c class;
        setStyleFrom:  c style;
        readSpecificsFrom: c;
        parent: aView.

    (c foreColor notNil) ifTrue: [
        newChild foreColor: c foreColor
    ].

    (c backColor notNil) ifTrue: [
        newChild backColor: c backColor
    ].

    newChild menu notNil ifTrue: [
        newChild menu: newChild menu asWBPMenu.
    ].

    c font isNil ifFalse: [
        newChild font: c font.
    ].

    ^newChild!  
convertChildrenToRes: dialogTitle

    | dU answer rect text |

    dU := self realDialogUnit.
    answer := OrderedCollection new.

    panes reverseDo: [ :p |
        rect := p framingBlock value: editedPane contentRect.
        rect := (rect left // dU x) @ (rect top // dU y) rightBottom: (rect right // dU x) @ (rect bottom // dU y).
        text := ''.
        p contents isString ifTrue: [
            text := p contents.
        ].

        answer add:
            (WinDialogInfo
                    itemTemplateStyle: p winStyle
                    x: rect left
                    y: rect top
                    cx: rect extent x
                    cy: rect extent y
                    id: (panes indexOf: p)
                    className: p winClass
                    text: text
            ).
    ].

    ^answer!
convertView: v realClass: aTopPaneClass

    "Altered to fix problem with re-editing windows containing
      multiple groups.  Also contains full fix for editing windows containing
      Ok or Cancel buttons, since last patch didn't completely fix the problem."

    | stayingToBack theChildren viewExtent newView newChildren newChild lastNonGroupTabPos lastGroupTabPos |

    ((v isKindOf: (Smalltalk at: #MDIFrame ifAbsent: [ nil ])) and: [
    v owner topPaneClass ~~ (Smalltalk at: #MDIFrame)]) ifTrue: [
        mdiAttributes := WBMDIAttributes new.
        mdiAttributes
            toolPane: v toolPane;
            statusPane: v statusPane;
            frameEvents: v handlers;
            label: v label.
        ^nil
    ].

    newView := WindowFrameObject newForClass: aTopPaneClass.
    newView realClass: aTopPaneClass.

    v framingBlock notNil ifTrue: [
        viewExtent := (v framingBlock value: Display boundingBox) extent.
    ] ifFalse: [
        (v respondsTo: #initWindowSize) ifTrue: [
            viewExtent := v initWindowSize.
        ] ifFalse: [
            viewExtent := v topPaneClass basicNew initWindowSize.
        ].
        (v isKindOf:  WindowDialog) ifTrue: [
            viewExtent := viewExtent // WindowDialog dialogUnit
        ].
    ].

    newView
        framingBlock: v framingBlock;
        handlers: v handlers;
        extent: viewExtent;
        contents: v label;
        style: v pStyle;
        createdBy: v createdBy;
        modifiedBy: v modifiedBy;
        iconFile: v iconFile.

    v backColor notNil ifTrue: [
        newView backColor: v backColor.
    ].

    v paneName notNil ifTrue: [
        newView paneName: v paneName.
    ] ifFalse: [
        newView paneName: 'mainView'.
    ].

    newView style isNil ifTrue: [
        newView style: newView defaultStyle
    ].

    v menuWindow menus notEmpty ifTrue: [
        newView menu: v menuWindow asWBPMenuBar.
    ] ifFalse: [
        newView menu: nil.
    ].

    newChildren := OrderedCollection new.

    "Needed to have children represented as OrderedCollection,
      since ordering relevant.  Digitalk stores them as an identity dictionary,
      which loses ordering.  Previous method of sorting on id fails for buttons
      with idOk and idCancel"
    theChildren := v getSubpaneOrder.

    stayingToBack := OrderedCollection new.

    "Fixed problem with reading back windows with multiple groups"
    lastNonGroupTabPos := WBTabPosition new.
    lastGroupTabPos := lastNonGroupTabPos.

    theChildren do: [ :c |
        newChild :=  self convertChild: c inView: newView.

        (c isWsGroup) ifTrue: [
            (c isWsTabstop) ifTrue: [
                newChild tabPosition: lastNonGroupTabPos nextBasicTabPosition.
                lastNonGroupTabPos := newChild tabPosition.
                lastGroupTabPos := lastNonGroupTabPos.
            ].
        ] ifFalse: [
            lastGroupTabPos withinGroup ifFalse: [
                  lastGroupTabPos makeFirstInGroup.
            ].
            newChild tabPosition: lastGroupTabPos nextTabPosition.
            lastGroupTabPos := newChild tabPosition.
        ].

        newChild staysToBack ifTrue: [
            stayingToBack addFirst: newChild.
        ] ifFalse: [
            newChildren addLast: newChild.
        ].
    ].


    "Fixed problem with reversed non-taborder controls by reversing
     newChildren below"
    newView children: (newChildren reversed addAllLast: stayingToBack; yourself).

    ^newView!
convertWinChild: c

    | newChild theClass |

    theClass := c class.

    theClass == WBGroupBox ifTrue: [
        theClass := GroupBox.
    ].

    newChild := (self pseudoClassFor: theClass name) new.

    (theClass = WBHorizontalScrollBar) | (theClass = WBVerticalScrollBar) ifTrue: [
        theClass := ScrollBar
    ].
    newChild realClass: theClass.

    c framingBlock isRectangle ifTrue: [
        c framingBlock: ( FramingParameters new initialExtent: (c propertyAt: #extent); left: c framingBlock left relativeTo: #left; right: c framingBlock right relativeTo:  #left; top: c framingBlock top relativeTo:  #top; bottom: c framingBlock bottom relativeTo:  #top)
    ] ifFalse: [
        c framingBlock initialExtent: (c propertyAt: #extent).
    ].

    (c respondsTo: #contents) ifTrue: [
        newChild contents: c contents.
    ].
    newChild
        framingBlock: c framingBlock;
        handlers: c realHandlers;
        menu: c getPopupMenu;
        paneName: c paneName;
        style: (c propertyAt:  #style).

    newChild menu notNil ifTrue: [
        newChild menu: newChild menu asWBPMenu.
    ].

    newChild style isNil ifTrue: [
        newChild style: newChild defaultStyle.
    ].

    c font isNil ifFalse: [
        newChild font: c font.
    ].

    ^newChild!  
drawToBitmap

    ^DrawingBitmap notNil!
editClass: aTopPaneClass

    | holdEditedPane tempInstance oldOpenWindow oldOpenModeless
    openMethodType numArgs args |

    self outmostWindow hideWindow.

    "Support for #createViews and CompositePanes"
    (aTopPaneClass inheritsFrom: CompositePane) ifTrue: [
        openMethodType := #addSubpanes
    ] ifFalse: [
        openMethodType := PWindowBuilder openMethodType
    ].

    openMethodType notNil ifTrue: [
        self propertyAt: #keepOpenMethod put: (aTopPaneClass includesSelector: #open).
        tempInstance := aTopPaneClass new.
        numArgs := openMethodType occurrencesOf: $:.
        args := (Array new: numArgs) atAllPut: tempInstance.
        tempInstance := tempInstance perform: openMethodType withArguments: args.
    ].

    tempInstance isNil ifTrue: [
        self propertyAt: #keepOpenMethod put: nil.
        oldOpenWindow := aTopPaneClass sourceCodeAt: #openWindow.
        PWindowBuilder createMethod: '' titled: 'openWindow' in: aTopPaneClass loggingSource: false.
        oldOpenModeless := aTopPaneClass sourceCodeAt: #openModeless.
        PWindowBuilder createMethod: '' titled: 'openModeless' in: aTopPaneClass loggingSource: false.

        tempInstance := aTopPaneClass new open.

        oldOpenWindow == #openWindow ifFalse: [
            PWindowBuilder createMethod: oldOpenWindow titled: '' in: aTopPaneClass loggingSource: true.
        ] ifTrue: [
            aTopPaneClass removeSelector: #openWindow.
        ].
        oldOpenModeless == #openModeless ifFalse: [
            PWindowBuilder createMethod: oldOpenModeless titled: '' in: aTopPaneClass loggingSource: true.
        ] ifTrue: [
            aTopPaneClass removeSelector: #openModeless.
        ]
    ].
    tempInstance isNil ifTrue: [ ^nil ].
    views := tempInstance views.

    views := (views collect: [:v |
        (self convertView: v realClass: (
                (aTopPaneClass isScratchWindow) ifTrue: [
                       aTopPaneClass defaultClass
                ] ifFalse: [
                    aTopPaneClass
                ]
            )
        ).
    ]) reject: [:vi | vi isNil ].

    holdEditedPane := editedPane.
    views do: [ :v |
        v == views first ifFalse: [
            editedPane := v.
            v children do: [ :p | p reframe: self editedPaneContentRect. ].
        ].
    ].

    self switchToView: views first.

    ^views first! 
editedPaneFrameLeftTop

    ^self margin@self margin!   
editMDIAttributes

    | result |

    mdiAttributes isNil ifTrue: [
        mdiAttributes := WBMDIAttributes new.
    ].

    result :=  WBMDIAttributesEditor new openOn: mdiAttributes.
    result result isNil ifTrue: [
        ^nil
    ].

    mdiAttributes := result result!
eventsSummaryString

    | s spaceTab tab nameString |

    s := WriteStream on: String new.
    tab := String with: Tab.
    spaceTab := '  '.

    "MDI Stuff"
    mdiAttributes frameEvents isEmpty ifFalse: [
        s nextPutAll: 'MDIFrame Events:'; cr.
        (mdiAttributes frameEvents keys asSortedCollection) do: [ :key |
            s nextPutAll: spaceTab, spaceTab, ' when: #', key, tab, tab, 'perform: ', tab, '#', (mdiAttributes frameEvents at: key); cr.
        ].
    ].
    (mdiAttributes hasToolPane and: [ mdiAttributes toolPaneEvents notEmpty ]) ifTrue: [
        s nextPutAll: 'MDI ToolPane Events:'; cr.
        (mdiAttributes toolPaneEvents keys asSortedCollection: [ :a :b |
            (a = #getContents) ifTrue: [
                true
            ] ifFalse: [
                b = #getContents ifTrue: [ false ] ifFalse: [ a < b ]
            ]
        ]) do: [ :key |
            s nextPutAll: spaceTab, spaceTab, ' when: #', key, tab, tab, 'perform: ', tab, '#', (mdiAttributes toolPaneEvents at: key); cr.
        ].
    ].
    (mdiAttributes hasStatusPane and: [ mdiAttributes statusPaneEvents notEmpty ]) ifTrue: [
        s nextPutAll: 'MDI StatusPane Events:'; cr.
        (mdiAttributes statusPaneEvents keys asSortedCollection: [ :a :b |
            (a = #getContents) ifTrue: [
                true
            ] ifFalse: [
                b = #getContents ifTrue: [ false ] ifFalse: [ a < b ]
            ]
        ]) do: [ :key |
            s nextPutAll: spaceTab, spaceTab, ' when: #', key, tab, tab, 'perform: ', tab, '#', (mdiAttributes statusPaneEvents at: key); cr.
        ].
    ].

    views do: [ :v |
        (views size > 1) ifTrue: [
            nameString := ' (', v paneName asQuotedString, ') '.
        ] ifFalse: [
            nameString := ' '.
        ].

        s nextPutAll: 'View', nameString, 'Events:'; cr.
        (v handlers keys asSortedCollection: [ :a :b |
            (a = #getContents) ifTrue: [
                true
            ] ifFalse: [
                b = #getContents ifTrue: [ false ] ifFalse: [ a < b ]
            ]
        ]) do: [ :key |
            s nextPutAll: spaceTab, spaceTab, ' when: #', key, tab, tab, 'perform: ', tab, '#', (v handlers at: key); cr.
        ].
        v handlers isEmpty ifTrue: [
            s nextPutAll: spaceTab, spaceTab, spaceTab, '*** No events assigned ***'; cr.
        ].

        (v children size > 0) ifTrue: [
            s cr; nextPutAll: spaceTab,  'Subpane Events', nameString; cr.
        ].
        (v children asSortedCollection: [ :a :b | a handlers size > b handlers size ]) do: [ :c |
            c paneName isNil ifTrue: [
                c contents isString ifFalse: [
                    nameString := 'Unnamed'.
                ] ifTrue: [
                    nameString := 'Unnamed - text is ', c contents asQuotedString.
                ].
            ] ifFalse: [
                nameString := c paneName asQuotedString.
            ].

            s nextPutAll: spaceTab, spaceTab, c realClass name, ' (', nameString, ')'; cr.

            (c handlers keys asSortedCollection: [ :a :b |
                (a = #getContents) ifTrue: [
                    true
                ] ifFalse: [
                    b = #getContents ifTrue: [ false ] ifFalse: [ a < b ]
                ]
            ]) do: [ :k |
                s nextPutAll: spaceTab, spaceTab, spaceTab, ' when: #', k, ((String new: (20 - k size max: 1)) atAllPut: $ ; yourself), tab, 'perform: ', tab, '#', (c handlers at: k); cr.
            ].
            c handlers isEmpty ifTrue: [
                s nextPutAll: spaceTab, spaceTab, spaceTab, '*** No events assigned ***'; cr.
            ].
            s cr.
        ].
    ].

    ^s contents!   
exportToResFile: fName

    | i hFile f theName dlgTemplate items fStyle r tempByteArray |

    theName := fName.
    ((fName size < 3) or: [ ((fName copyFrom: fName size - 2 to: fName size) asUpperCase = 'RES') not ]) ifTrue: [
        theName := fName, '.res'.
    ].

    f := File newFile: theName.
    hFile := File newFile: (theName copyFrom: 1 to: theName size - 3), 'H'.

    i := 0.
    panes do: [:p |
        p paneName notNil ifTrue: [
            i := i + 1.
            hFile nextPutAll: '#define    ', p paneName asString, '    ', i asString; cr.
        ].
    ].
    hFile close.

    r := editedPane rect origin extent: (self editedPaneContentRect extent / self realDialogUnit) rounded.

    fStyle := DsNoidlemsg | WsClipchildren | WsPopup.

    (editedPane style includes: #sysmenu) ifTrue: [
        fStyle:= fStyle| WsSysmenu.
    ].
    (editedPane style includes: #titlebar) ifTrue: [
        fStyle:= fStyle| WsCaption.
    ].
    (editedPane style includes: #sysmodal) ifTrue: [
        fStyle:= fStyle| DsSysmodal | DsModalframe.
    ].
    (editedPane style includes: #modal) ifTrue: [
        fStyle:= fStyle| DsModalframe.
    ] ifFalse: [
        fStyle:= fStyle| WsBorder.
    ].

    dlgTemplate := WinDialogInfo
        dialogTemplateStyle: fStyle
        itemCount: 0
        x: r origin x
        y: r origin y
        cx: r extent x
        cy: r extent y
        menuName: nil
        className: nil
        text: editedPane contents.

    items := self convertChildrenToRes: editedPane contents.

    dlgTemplate byteAtOffset: 4 put: items size.

    tempByteArray := dlgTemplate contents.
    items do: [:i |
        tempByteArray := tempByteArray, i contents.
    ].
    dlgTemplate contents: tempByteArray.

    "Resource Header"
    #(255 5 0 66 0 16 240)  do: [:b |
        f nextBytePut: b.
    ].
    f nextTwoBytesPut: dlgTemplate contents size;
        nextBytePut: 0;
        nextBytePut: 0.

    dlgTemplate contents do: [:b |
        f nextBytePut: b.
    ].
    f
        close.!  
framingParametersFor:  aFramingBlock inView: aView

    "In case we're reading in an existing window, make life
     a little easier on them by performing a simple conversion of
    framing blocks into framing parameters.  Nothing fancy;  just
    getting the coordinates right."

    | baseRect viewContentRect |

    viewContentRect := 0@0 extent: aView contentRect extent.

    baseRect := aFramingBlock value: viewContentRect.
    aView isDialog ifTrue: [
        baseRect := (baseRect origin // WindowDialog dialogUnit) extent: (baseRect extent // WindowDialog dialogUnit).
    ].

    ^FramingParameters new fromRect: baseRect inRect: viewContentRect.!
importFromResFile: resFile

    | newClass template hFile idDict symName hName |

    (newClass := (PWindowBuilder wbCreateClassDialog new forWindowType: 'Dialog') result) isNil ifTrue: [
        ^nil
    ].

    editedPane := WindowFrameObject new.
    editedPane realClass: newClass.

    views := OrderedCollection with: editedPane.

    template := WinDialogInfo new readFrom: resFile.
    panes := OrderedCollection new.

    idDict := Dictionary new.
    hName := (resFile copyFrom: 1 to: resFile size - 3), 'H'.

    hFile := File pathName: hName.
    [ hFile atEnd not and: [ (hFile nextString: 'define') notNil ] ] whileTrue: [
        symName := hFile nextWord.
        idDict at: hFile nextWord asInteger put: symName.
    ].

    editedPane
        rect: (template origin extent: (template extent * self realDialogUnit) rounded);
        contents: template text.

    editedPane style: (WindowFrameObject styleFrom: template style).

    editedPane extent: editedPane extent + (self editedPaneFrameRect extent - self editedPaneContentRect extent).

    template items do: [:p |
        p rect: ((self editedPaneContentRect origin + (p rect origin  * self realDialogUnit) rounded)
                        extent: (p rect extent * self realDialogUnit) rounded).
        self recalcFramerFor: p.
        p paneName: (idDict at: p resID ifAbsent: [ nil ]).
        panes add: p.
    ].

    panes := panes reversed.

    ^newClass!
importWindow: theClass

    | v tempInstance t initInstVarStream hasName initPos |

    tempInstance := theClass new.
    v := WindowFrameObject new.

    v realClass: theClass.
    self outmostWindow hideWindow.

    tempInstance addSubpanesTo: v.

    views := OrderedCollection with: v.

    v
        framingBlock:  (FramingParameters new initialExtent: tempInstance initWindowExtent);
        extent: tempInstance initWindowExtent;
        contents: tempInstance label;
        style: (self styleFromWinClass: tempInstance).

    (tempInstance respondsTo: #initWindowPosition) ifTrue: [
        initPos := tempInstance initWindowPosition.
        v framingBlock left: initPos x relativeTo: #left.
        v framingBlock top: initPos y relativeTo: #top.
    ] ifFalse: [
        v framingBlock xC; yC.
    ].

    (tempInstance respondsTo: #buildMenuBarFor:) ifTrue: [
        tempInstance buildMenuBarFor: tempInstance.
    ].
    tempInstance menuWindow menus notEmpty ifTrue: [

        v menu: tempInstance menuWindow asWBPMenuBar.
    ] ifFalse: [
        v menu: nil.
    ].

    t := 0.

    "Detect grouping panes, add children with coordinates
      translated, set tabpositions with .x values relative to the
     grouping pane's tab position."
    v children copy do: [:c |
        (c isKindOf: WBInvisibleGroupPane) ifTrue: [
            c children do: [:ch |
                ch framingBlock: ((ch framingBlock leftTop rightAndDown: c framingBlock leftTop) extentFromLeftTop: ch framingBlock extent).
                 v children add: ch
            ].
            v children remove: c.
        ].
    ].
    v children: (
        v children  collect: [:c |
            t := t + 1.
            (self convertWinChild: c) tabPosition: nil; yourself.
        ]
    ).

    theClass
        removeSelector: #addSubpanesTo:;
        removeSelector: #label;
        removeSelector: #buildMenuBarFor:;
        removeSelector: #isModal;
        removeSelector: #defaultFrameStyle;
        removeSelector: #initWindowExtent.

    self switchToView: views first.

    initInstVarStream := WriteStream on: ''.
    panes do: [:p |
        p paneName notNil ifTrue: [
            hasName := true.
            initInstVarStream nextPutAll: '    ',p paneName, ' := self paneNamed: ', p paneName asQuotedString, '.'; cr.
        ].
    ].
    hasName = true ifTrue: [
        PWindowBuilder createMethod: initInstVarStream contents titled: 'initInstVars' in: theClass loggingSource: true.
     ].

    ^theClass!   
initialize

    super initialize.
    mdiAttributes := WBMDIAttributes new.!   
layoutAsBitmap

    | result e drawingGrid |

    "Answer a bitmap that contains an image of the current window."

    e := self editedPaneFrameRect extent.
    DrawingBitmap :=  Bitmap screenExtent: e + self margin.

    drawingGrid := self drawGrid.
    self drawGrid: false.

    self display.

    self drawGrid: drawingGrid.

    result := Bitmap screenExtent: e.
    result pen
        copyBitmap: DrawingBitmap
        from: (self margin @ self margin extent: e)
        at: 0@0.

    DrawingBitmap release.
    DrawingBitmap := nil.

    ^result!   
mdiAttributes

    ^mdiAttributes!  
newView: aName

    | v |

    views add: (v := WindowFrameObject new).
    v
        paneName: aName;
         framingBlock: ( FramingParameters new initialExtent: 200 @ 150; xC; yC);
        style: #(sysmenu sizable minimize maximize titlebar);
        extent: (v framingBlock value: Display boundingBox) extent;
        contents: 'Untitled';
        realClass: views first realClass.

    self switchToView: v.!   
pen

    DrawingBitmap notNil ifTrue: [
        ^DrawingBitmap pen
    ] ifFalse: [
        ^super pen
    ].!  
pseudoClassFor: className

    | superclass pSym |

    pSym := ('P', className) asSymbol.
    (Smalltalk includesKey: pSym) ifTrue: [
        ^Smalltalk at: pSym
    ].

    superclass := (Smalltalk at: className asSymbol) superclass name.

    [ superclass = 'Object' ] whileFalse: [
        pSym := ('P', superclass) asSymbol.
        (Smalltalk includesKey: pSym) ifTrue: [
            ^Smalltalk at: pSym
        ].

        superclass := (Smalltalk at: superclass asSymbol) superclass name.
    ].

    ^PGenericSubpane!
realDialogUnit

    ^(SysFont width / 4) @  (SysFont height / 8).!  
removeView: aName

    | v |

    views size > 1 ifFalse: [
        ^MessageBox messageNote: 'You cannot remove the last view.'
    ].

    views := views reject: [:v | v paneName = aName ].

    editedPane paneName = aName ifTrue: [
        self switchToView: views first.
    ].! 
styleFromWinClass: c

    | theStyle |

    theStyle := OrderedCollection new.

    c isModal ifTrue: [
        theStyle add: #modal.
    ].

    ((c defaultFrameStyle bitAnd:  (WinConstants at: 'WsSysmenu')) = 0) ifFalse: [
        theStyle add: #sysmenu.
    ].

    ((c defaultFrameStyle bitAnd:  (WinConstants at: 'WsMaximizebox' )) = 0) ifFalse: [
        theStyle add: #maximize.
    ].

    ((c defaultFrameStyle bitAnd:  (WinConstants at: 'WsMinimizebox' )) = 0) ifFalse: [
        theStyle add: #minimize.
    ].

    ((c defaultFrameStyle bitAnd:  (WinConstants at: 'WsThickframe' )) = 0) ifFalse: [
        theStyle add: #sizable.
    ].

    ((c defaultFrameStyle bitAnd:  (WinConstants at: 'WsCaption' )) = 0) ifFalse: [
        theStyle add: #titlebar.
    ].

    ^theStyle asArray!   
switchToView: v

    self unselectAll.
    self outmostWindow hideWindow.

    self scrollPane scrollToOrigin.
    editedPane := v.

    self scrollPane
        setScrollRanges.

    panes := editedPane children.

    panes do: [:p | p reframe: self editedPaneContentRect.  ].
    self outmostWindow showWindow.

    self event: #selectionChanged.!  
viewAt: aName

    ^(views select: [:v | v paneName = aName ]) first!   
views

    ^views!  
views: aCollection

    views := aCollection! !

! WBTabOrderLayoutPane class methods !   
supportedEvents

    ^super supportedEvents
        add: #setTabPosition;
        add: #setGroup;
        add: #deletedGroup;
        yourself! !

! WBTabOrderLayoutPane methods !   
addGroupPaneStartingAt: aPoint

    | groupPane min containedPanes |

    modalState := nil.
    self dragSelectFrom: aPoint.

    selectedPanes := selectedPanes select: [ :p | p isGroupable ].

    selectedPanes isEmpty ifTrue: [
        ^self
    ].

    groupPane := PWBInvisibleGroupPane example.
    groupPane rect: (self selectedRect expandBy: 1).

    groups keysDo: [  :g |
        (g rect intersects: groupPane rect)  ifTrue: [
            MessageBox messageNote: 'Overlapping Grouping is not allowed.'.
            ^nil
        ].
    ].

    containedPanes := nonGroupedPanes select: [:p | p staysToBack not & (groupPane rect containsPoint: p rect leftTop) & (groupPane rect containsPoint: p rect rightBottom) ].

    min := WBTabPosition fromTabPosition: 10000.
    containedPanes do: [ :p |
        ((p usesFocus & p tabPosition notNil) and: [ p tabPosition <= min ]) ifTrue: [
            min := p tabPosition
        ].
    ].
    groupPane tabPosition: min.
    panes add: groupPane.

    self resetGroups.
    self normalizeTabOrder.

    self updateRect: self editedPaneContentRect.!
button1Down: aPoint

    | child |

    (modalState = #settingTabGroup) ifTrue: [
        self addGroupPaneStartingAt: aPoint.
        ^self event: #setGroup
    ].


    (modalState = #removeTabGroup) ifTrue: [
        child := self groupPaneHitBy: aPoint.
        child isGrouper ifTrue: [
            panes remove: child.
            self resetGroups.
            self normalizeTabOrder.
            self updateRect: self editedPaneContentRect.
        ].
        modalState := nil.
        ^self event: #deletedGroup
    ].

    child := self paneHitBy: aPoint.
    child ~= editedPane & child usesFocus ifTrue: [
        (self isEditingTabs & child tabPosition isNil) ifTrue: [
            self setTabPositionFor: child.
            self event: #setTabPosition.
            ^self updateRect: (child rect expandBy: 4)
        ].
    ].

    Terminal bell.!   
button1DownShift: aPoint

    "Mask out super behavior"!
button2Down: aPoint

    "Mask out super behavior"! 
display

    | savedFont |

    super display.
    savedFont := self font.

    self pen down.

    panes do: [ :p |
        self displayTabPositionFor: p.
    ].

    self pen font: savedFont.!   
displayTabPositionFor: p

    | location oldFont |

    p tabPosition notNil & p isGrouper not & p usesFocus ifTrue: [
        location := p hitRect center.
        oldFont := self pen font.

        self pen
            place: location;
            backColor: ClrBlack;
            circleFilled: 10;
            foreColor: ClrWhite;
            font: (self fontFor: p);
            centerText: p tabPosition asString at: location;
            foreColor: ClrBlack;
            backColor: ClrWhite;
            font: oldFont
        ].! 
editedPane: aPane subpanes: subPanes

    editedPane := aPane fullCopy.

    panes := self importPanes: subPanes.

    subPanes do: [ :s |
        s parent: aPane.
    ].

    self moveGroupboxesToBack.
    self insertGroupingPanes.
    self resetGroups.
    self normalizeTabOrder.!  
exportedPanes

    ^(self sortInZorder: super exportedPanes) reject: [ :p |
        p isGrouper
    ].!   
fontFor: aPane

    aPane tabPosition inGroup  ifFalse: [
        (LargeNumberFont isNil) ifTrue: [
            LargeNumberFont :=  (Font face: 'Helv' size: 8@18 fixedWidth: true attributes: 0).
        ].
        ^LargeNumberFont
    ] ifTrue: [
        (SmallNumberFont isNil) ifTrue: [
            SmallNumberFont := (Font face: 'Helv' size: 5@10 fixedWidth: false attributes: 0).
        ].
        ^SmallNumberFont
    ].!   
groupPaneHitBy: aPoint

    | panesHit |

    panesHit := panes select: [:p | (p rect containsPoint: aPoint) & p isGrouper ].

    panesHit isEmpty ifTrue: [
        ^editedPane
    ] ifFalse: [
        ^panesHit first
    ].!  
hideSelectionDots

    "Prevent super from displaying"! 
initialize

    super initialize.
    isEditingTabs := false.
    tabCount := 0.! 
insertGroupingPanes

    "Scan through the panes looking for grouped panes, and add a
     grouping pane around each of them.  Panes that are grouped have the
     same integer value in their tabposition, with a mantissa representing
     the order within the group"

    | groupsDict group groupID groupPane |

    groupsDict := Dictionary new.
    panes do: [ :p |
        (p tabPosition notNil and: [ p tabPosition inGroup]) ifTrue: [
            groupID := p tabPosition basicTabPosition.
            group := groupsDict at: groupID ifAbsent: [ OrderedCollection new ].
            group add: p.
            groupsDict at: groupID put: group.
        ].
    ].

    groupsDict do: [ :group |
        groupPane := PWBInvisibleGroupPane example.
        groupPane rect: ((self rectForPanes: group) expandBy: 1).
        groupPane tabPosition: (WBTabPosition fromTabPosition: (groupsDict keyAtValue: group)).
        panes add: groupPane.
    ].!   
isEditingTabs

    ^isEditingTabs!  
mode: aSymbol

    modalState := aSymbol.!  
moveGroupboxesToBack

    panes copy do: [ :p |
        p staysToBack ifTrue: [
            panes remove: p.
            panes addLast: p.
        ].
    ].!  
nextTabPositionFromCollection: paneList

    | max |

    max := WBTabPosition fromTabPosition: 0.
    paneList do: [ :p |
        ((p usesFocus & p tabPosition notNil) and: [ p tabPosition >= max ]) ifTrue: [
            max := p tabPosition
        ]
    ].

    ^max nextTabPosition! 
normalizeTabOrder

    | sortBlock groupedPanes cnt |

    sortBlock :=  [:a :b |
            (b tabPosition isNil) ifTrue: [
                true
            ] ifFalse: [
                a tabPosition isNil ifTrue: [
                    false
                ] ifFalse: [
                    a tabPosition <= b tabPosition
                ]
            ]
     ].

    "Sort and set the tab positions for the outermost level panes,
      including the groups"

    nonGroupedPanes := (nonGroupedPanes asSortedCollection: sortBlock) asOrderedCollection.
    cnt := WBTabPosition fromTabPosition: 1.
    1 to: nonGroupedPanes size do: [ :i |
        (nonGroupedPanes at: i) usesFocus & (nonGroupedPanes at: i) tabPosition notNil ifTrue: [
            (nonGroupedPanes at: i) tabPosition: cnt.
            cnt := cnt nextTabPosition.
        ].
    ].

    "Sort and set the tab positions for the panes within each group"

    groups keysDo: [ :group |
        groupedPanes := groups at: group.
        groupedPanes := (groupedPanes asSortedCollection: sortBlock) asOrderedCollection.
        group tabPosition isNil ifTrue: [
            group tabPosition: cnt.
        ].
        cnt := group tabPosition makeFirstInGroup.
        1 to: groupedPanes size do: [ :i |
            (groupedPanes at: i) usesFocus ifTrue: [
                (groupedPanes at: i) tabPosition: cnt.
                cnt := cnt nextTabPosition.
            ].
        ].
        groups at: group put: groupedPanes.
    ].!
resetGroups

    | newGroup |

    nonGroupedPanes := (panes select: [:p | p isGrouper not ]).
    groups := Dictionary new.

    (panes select: [:p | p isGrouper ]) do: [:g |
        newGroup := nonGroupedPanes select: [:p | p staysToBack not & (g rect containsPoint: p rect leftTop) & (g rect containsPoint: p rect rightBottom) ].
        nonGroupedPanes := nonGroupedPanes select: [:p | (newGroup includes: p) not ].
        groups at: g put: newGroup.
    ].

    nonGroupedPanes addAll: groups keys.!
setTabOrder

    panes do: [ :p |
        p tabPosition: nil.
    ].

    tabCount := 0.
    isEditingTabs := true.
    self updateRect: self editedPaneContentRect.! 
setTabPositionFor: aPane

    | containingGroup tabPosition |

    tabCount := tabCount + 1.

    groups do: [ :c |
        (c includes: aPane) ifTrue: [
            containingGroup := groups keyAtValue: c.
        ].
    ].

    containingGroup notNil ifTrue: [
        (containingGroup tabPosition isNil) ifTrue: [
            containingGroup tabPosition: (self nextTabPositionFromCollection: nonGroupedPanes).
            aPane tabPosition: containingGroup tabPosition copy makeFirstInGroup.
        ] ifFalse: [
            aPane tabPosition: (self nextTabPositionFromCollection: (groups at: containingGroup)).
        ].
    ] ifFalse: [
        aPane tabPosition: (self nextTabPositionFromCollection: nonGroupedPanes).
    ].! 
showSelectionDotsOn: w

    "Prevent them from drawing"!
stopEditingTabs

    isEditingTabs := false.
    self normalizeTabOrder.
    self updateRect: self editedPaneContentRect.!
tabCount

    ^tabCount!
totalTabCount

    ^(panes select: [ :p | p isGrouper not & p usesFocus ]) size!
updateRect: r

    | clipRect region |

    clipRect := r intersect: self editedPaneContentRect.

    region := self pen setClipRect: clipRect.
    self pen fill: r color: editedPane backColor.
    self pen destroyRegion: region.

    panes reverseDo: [ :p |

        (p rect intersects: r) ifTrue: [
            self displayPane: p clipRect: clipRect.
            self displayTabPositionFor: p.
        ].
    ].!
usesFocus

    ^false! !

! OSSubPane class methods ! 
supportedEvents
    "Private - Answer the Set of events that instancves of the receiver
     can notify their owners about."
    ^super supportedEvents
        add: #getContents;
        yourself! !

! OSSubPane methods !  
addStyle: styleBits
    "Private - if style is nil, initialize it appropriately then add the
    given style bits to the flag. Answer the added styleBits."

    "Implemented for V32 compatibility"
    style isNil ifTrue: [ style := self frameStyle ].
    style := style | styleBits.
    ^style! 
open
    "Private"

    self event: #getContents.
    super open.!
removeStyle: styleBits
    "Private - if style is nil, initialize it appropriately then remove
    the given style bits from the flag.  Answer the removed styleBits.
    Implemented for V32 compatibility"

    | mask |
    style isNil ifTrue: [ style := self frameStyle ].
    mask := styleBits bitXor: 16rFFFFFFFF.
    style := style bitAnd: mask.
    ^styleBits! !

! StatusPane class methods !   
supportedEvents
        "Private - Answer the Set of events that ToolPanes can notify
         their owners about."
    ^super supportedEvents
        add: #doubleClicked;
        yourself! !

! StatusPane methods !
button1DoubleClick: aPoint
        "Private - Left button is double clicked.
         Default is do nothing."

    self event: #doubleClicked!
colorChange
        "Private - Window's color has changed
        Set the new background and foreground color."

    colors := self sysColors.
    self backColor: WinInfo colorButtonFace.
    self foreColor:WinInfo colorButtonText.
    ^super colorChange.!   
contents
        "Answer the receiver's contents,
        i.e., a collection of statusBox objects."

    ^statusBoxes!
contents: aStatusBoxCollection
        "Set the receiver's contents."

    statusBoxes := aStatusBoxCollection.
    statusBoxes do:[:each | each statusPane: self].!  
defaultFont
        "Private - Answer the default font for StatusPane."
    ^Font face:'Helv' size:(0 @ (self height - (2 * inset))) fixedWidth:false!  
display
        "Private - Display the statusPane."

    self display3D.
    statusBoxes do:[:each | each displayWith: self graphicsTool].!   
display3D
        "Private - Display the 3D main rectangle."

    |aPen|
    aPen := self graphicsTool.
    aPen fill: (self rectangle leftTop rightBottom: (self rectangle rightTop leftAndDown:( 0 @ 1)))
        color: ClrBlack.
    aPen fill: ((self rectangle leftTop down: 1) rightBottom: (self rectangle rightTop leftAndDown:( 0 @ 2)))
        color: WinInfo colorButtonHighlight.!  
displayHelp
        "Private - Display the help."
    |rect xDisplay pen|
    self display3D.
    xDisplay := self font width.
    rect := xDisplay @ 0 corner: rectangle width @ (rectangle bottom down: 2).
    rect := rect insetBy: (0 @ inset).
    pen:=self graphicsTool.
    pen
        displayText:helpText
        at: (rect leftBottom rightAndUp: self font descender + 1)
        clipRect:rect
        options: EtoOpaque|EtoClipped.! 
fixedSize
        "Set the StatusPane style.  The StatusPane boxes will be fixed size."

    resizable := false!   
frameStyle
        "Private - Answer an Integer with appropriate styles in it."
     ^WsChild |
     WsClipchildren |
     WsClipsiblings!
framingBlock: aBlock
    "Added by OSI"
    #addedByOSI.
    aBlock isContext ifTrue: [
        super framingBlock: aBlock
    ] ifFalse: [
        self propertyAt: #wbFramer put: aBlock
    ].! 
freeClientArea:box
        "Private - Set the client area left over."
    rectangle isNil ifTrue:[^self].
    self visible ifFalse:[^self].
    box height: box height - self height.!
getGraphicsTool
        "Private - Initialize an empty pen tool."
    ^Pen forDC: nil medium: self! 
height
        "Answer the receiver's height."

    ^height!   
height:anInteger
        "Set the receiver's height."

    height:=anInteger!  
initialize
        "Private - Initialize instance variables."
    super initialize.
    self height: WinInfo cyCaption - 1.
    self framingBlock:[:box| (box leftTop down: box height) rightBottom: (box rightBottom down:  self height )].
    colors := self sysColors.
    self backColor: WinInfo colorButtonFace.
    self foreColor:WinInfo colorButtonText.
    self resizable.
    self rightJustified.
    statusBoxes := OrderedCollection new.
    inset := 3.!
initSize: aRectangle
    "Added by OSI"
    | fp |
    #addedByOSI.
    (self parent isMDIFrame not and: [
    (fp := self propertyAt: #wbFramer) notNil]) ifTrue: [
        super framingBlock: fp
    ].
    super initSize: aRectangle!
inset
        "Answer the receiver's inset.
        The height of a StatusBox is the height
        of the statusPane minus two times the inset."

    ^inset!   
inset: anInteger
        "Set the receiver's inset.
        The height of a StatusBox is the height
        of the statusPane minus two times the inset."

    inset := anInteger!   
isLeftJustified
        "Answer true if the receiver is left justified, else answer false."

    ^justified = #left!   
isResizable
        "Answer true if the receiver is left justified, else answer false."

    ^resizable!   
isRightJustified
        "Set the StatusPane style - The StatusPane boxes will be rightJustified."

    ^justified = #right!   
isStatusPane
        "Answer true if receiver is an instance of class
         StatusPane, else answer false."
    ^true!  
justified

    #addedByOSI.
    ^justified!
leftJustified
        "Set the StatusPane style.  The StatusPane boxes will be leftJustified."

    justified := #left!
leftJustifiedFixed
    "Added by OSI"
    #addedByOSI.
    self
        leftJustified;
        fixedSize!
open
        "Private - Open the statusPane."
    super open.
    self font isNil ifTrue:[
        self font: self defaultFont].
    self event:#getContents.!   
resizable
        "Set the StatusPane style.
        The left-most status box in a statusPane rightJusfied
        will be resizable.
        The right-most status box in a leftjustified statusPane
        will be resizable."

    resizable := true!  
rightJustified
        "Set the StatusPane style.  The StatusPane boxes will be rightJustified."

    justified := #right! 
rightJustifiedFixed
    "Added by OSI"
    #addedByOSI.
    self
        rightJustified;
        fixedSize!  
showHelp:anObject
    "Private - Set and display the help text."
    (helpText isNil and:[anObject isNil]) ifTrue:[^self].
    self doGraphics:[
        helpText isNil ifTrue:[self graphicsTool erase].
        helpText:=anObject.
        helpText isNil ifTrue:[self graphicsTool erase.self display].
        helpText notNil ifTrue:[self displayHelp]].!   
startGroup
    "Added by OSI because StatusPanes may not be tabstops"
    #addedByOSI!  
statusBoxAt: statusBoxSymbol
        "Answer the first statusBox with the name statusBoxSymbol."

    ^statusBoxes detect:[:each | each name = statusBoxSymbol] ifNone:[nil]!  
sysColors
        "Private - Answer system colors for StatusPane."

    ^(Array new:2)
                        at: 1 put: WinInfo colorButtonFace;
                        at: 2 put: WinInfo colorButtonText;
                        yourself.!   
tabStop
    "Added by OSI because StatusPanes may not be tabstops"
    #addedByOSI! 
updateRectangle
        "Private - Update variables depending on the actual size of the StatusPane."

    super updateRectangle.
    self isLeftJustified ifTrue:[
        self updateRectangleLeftJustified]
    ifFalse:[
        self updateRectangleRightJustified].!  
updateRectangleLeftJustified
        "Private - Update variables depending on the actual size of the StatusPane."
    |xDisplay rect|

    xDisplay := 0.
    statusBoxes do:[:box |
        xDisplay := xDisplay right: box space.
        rect := xDisplay @ 0 corner: (xDisplay + box width + 6) @ (rectangle bottom down: 2).
        rect := rect insetBy: (0 @ inset).
        box rectangle: rect.
        xDisplay := xDisplay right: box width + 6].

    self isResizable ifFalse: [^self].
    statusBoxes isEmpty ifTrue: [^self].

    box := statusBoxes last.
    xDisplay := xDisplay left: box width + 6.
    rect := xDisplay @ 0 corner: (self rectangle width left: self height) @ (rectangle bottom down: 2).
    rect := rect insetBy: (0 @ inset).
    box rectangle: rect.!
updateRectangleRightJustified
        "Private - Update variables depending on the actual size of the StatusPane."

    |xDisplay rect|

    xDisplay := self rectangle width - self height.
    statusBoxes reverseDo:[:box |
        xDisplay := xDisplay left: box width + 6.
        rect := xDisplay @ 0 corner: (xDisplay + box width + 6) @ (rectangle bottom down: 2).
        rect := rect insetBy: (0 @ inset).
        box rectangle: rect.
        xDisplay := xDisplay left: box space].

    self isResizable ifFalse:[^self].
    statusBoxes isEmpty ifTrue:[^self].

    box := statusBoxes first.
    xDisplay := xDisplay right: box space.
    xDisplay := xDisplay right: box width + 6.
    rect := (box space @ 0) corner: xDisplay @ (rectangle bottom down: 2).
    rect := rect insetBy: (0 @ inset).
    box rectangle: rect.!
updateSliders
        "Private - Reimplemented here because StatusPane
         have no scrollbars."!   
updateStatusBox: aStatusPaneBox
        "Private - aStatusPaneBox has been updated."

    self isHandleOk ifFalse:[^self].
    helpText notNil ifTrue:[^self].
    self doGraphics:[
        aStatusPaneBox displayWith:self graphicsTool].!
validate
        "Private - The window for the receiver was
         just created or recreated.
        Show the StatusPane if its visible property is true."
    |newColors|
    super validate.
    helpText := nil.
    newColors := self sysColors.
    newColors = colors ifFalse:[
            self colorChange].
    self visible ifTrue:[self showWindow].! 
winClass
    "Private- answer the receiver's window class."

    | className wndClass lptr answer|
    className := 'SmalltalkV',self class name.
    (self isRightJustified or:[self isResizable])
        ifTrue:[className := className,'RightJustified'].
    wndClass := WinWindowClass new.
    answer:=UserLibrary getClassInfo: WIN hInstanceExe
        className: className asParameter
        wndClass: wndClass asParameter.
    answer ifTrue:[^className].
    UserLibrary getClassInfo: WIN hInstanceExe
        className: 'VWIN' asParameter
        wndClass: wndClass asParameter.
    wndClass style:CsDblclks.
    (self isRightJustified or:[self isResizable])
            ifTrue:[wndClass style: CsDblclks | CsHredraw].
    wndClass
        className: (lptr := WinAddress
            copyToNonSmalltalkMemory: className asAsciiZ) asParameter.
    UserLibrary registerClass: wndClass asParameter.
    lptr unlock; free.
   ^className! !

! TextPane class methods !   
smalltalkMenu
    "Private - Answer the Smalltalk menu.
    Touched by Ale for more funcionality..."
    | tab |
    #modifiedByOStyle.
    tab := String with: Tab.
    ^Menu new
        appendItem: '&Show It',tab,'Ctrl+S' selector: #printIt accelKey: $s accelBits: AfChar | AfControl ;
        appendItem: '&Do It',tab,'Ctrl+D' selector: #doIt accelKey: $d accelBits: AfChar | AfControl ;
        appendItem: '&Inspect It',tab,'Ctrl+I' selector: #inspectIt accelKey: $i accelBits: AfChar | AfControl  ;
        appendItem: 'File It I&n',tab,'Ctrl+N' selector: #fileItIn accelKey: $n accelBits: AfChar | AfControl  ;
        appendSeparator;
        appendItem: 'Compress C&hanges' selector: #compressChanges;
        appendItem: '&Unused Memory' selector: #unusedMemory;
        title: '&Smalltalk'! !

! TextPane methods !  
compressChanges
    "Private - Perform changes compression.
    Implemented by Ale..."

    #addedByOStyle.
    Smalltalk compressChanges!   
findClass
    "Private - Perform class find if the owner responds to #findClass:.
    Implemented by LRP..."
    | className ownerWindow |
    #addedByOStyle.
    className := self selectedString.
    className size ==0 ifTrue: [^nil].
    ownerWindow := parent owner.
    ownerWindow textModified ifTrue: [^self].
    (ownerWindow respondsTo: #findClass:) ifTrue: [
        ^ownerWindow findClass: className
    ].!   
implementors
    "Private - Open a pane with implementors of the
      method wich name must be selected.
    Implemented by LRP..."
    | selectedMethod |
    #addedByOStyle.
    selectedMethod := self selectedString asSymbol.
    selectedMethod isNil  ifFalse: [
        selectedMethod size ==0 ifTrue: [^nil].
        Smalltalk implementorsOf: selectedMethod
    ].!   
noBorders

    "Added by OSI"
    #addedByOSI.
    ^style := self basicStyle |
        WsChild   |
        WsVisible!   
noScrollBars

    "Added by OSI"
    #addedByOSI.
    ^style := self basicStyle |
        WsBorder |
        WsChild   |
        WsVisible!
popupMenu
    "Private - Answer the popup Menu for the receiver.
    Touched by Leo for Senders,Implementors & FindClass funcionality"
    | m |
    #modifiedByOStyle.
    m := super popupMenu.
    m isNil ifTrue: [m := Menu new
        appendItem: '&Copy' selector: #copySelection;
        appendItem: 'Cu&t' selector: #cutSelection ;
        appendItem: '&Paste' selector: #pasteSelection ;
        appendSeparator ;
        appendItem: '&Do It' selector: #doIt  ;
        appendItem: '&Show It' selector: #printIt  ;
        appendSeparator ;
        appendItem: '&Save' selector: #accept ;
        appendItem: 'A&gain' selector: #again ;
        appendSubMenu: (self class editMenu owner: self).
    Smalltalk isRunTime ifFalse:[
        m appendSubMenu: (self class smalltalkMenu owner: self).
        m
        appendSeparator ;
        appendItem: '&Senders' selector: #senders ;
        appendItem: '&Implementors' selector: #implementors.
        (parent owner  isKindOf: ClassHierarchyBrowser) ifTrue: [
            m appendItem: '&Find Class' selector: #findClass ]
    ].
    m owner: self;
        title: '&TextPanePopup'].
    m getIndex: #accept ifAbsent: [^m]. "Check to be sure the item is there."
    (self mainWindow menuTitled: '&File') isNil ifFalse: [
        m copyItemAttributes: #accept from: (self mainWindow menuTitled: '&File').
    ].
    ^m!   
realHandlers

    "Added by OSI"

    | realHandlers |
    #addedByOSI.
    realHandlers := Dictionary new.
    handlers keysDo: [ :k |
        ((k = #getContents) & ((handlers at: k) isSymbol not)) ifFalse: [
            realHandlers at: k put: (handlers at: k).
        ].
    ].
    ^realHandlers!  
senders
        "Private - Pop-up a window with the
         senders of the selected method."
    | selectedMethod |
    selectedMethod := self selectedString asSymbol.
    selectedMethod isNil  ifFalse: [
        selectedMethod size ==0 ifTrue: [^nil].
        Smalltalk sendersOf: selectedMethod
    ].! 
showSelectionFrom: beginIndex to: endIndex
    "Private - Show selection containing the
     characters from beginIndex to endIndex,
     treating the lines as one string.
    Touched By Ale for selection bounds checkin..."
    #modifiedByOStyle.

    (beginIndex isNil or: [endIndex isNil]) ifTrue: [^self].

    self hideSelection.
    selection :=
        textHolder getSelectionFrom: beginIndex
             to: endIndex - 1.
    selection pane: self.
    self doGraphics: [
        self makeVisible: selection corner;
            displayChanges.
        selection display].!  
unusedMemory
    "Private - Shows unusedMemory.
    Implemented by Ale..."

    #addedByOStyle.
    MessageBox message: 'Unused Memory : ',Smalltalk unusedMemory printString!   
wmGetdlgcode: wparam with: lparam

    "Modified by OSI.  Changed DlgcWantchars to DlgcWantallKeys
      so a TextPane would work (cr works) in a dialog."

        "Private - process WM_GETDLGCODE message."
    #modifiedByOSI.
     ^DlgcWantallkeys
"   ^ DlgcWantchars  "! !

! ChunkTextPane class methods ! 
classComment
	^'This text pane is redefined in its menu and compiler error handling'
	"Modified: 11.06.93 / 10.12.42 / T.Lentzsch"! 
classUpdate
	^'
	"Modified: 11.06.93 / 10.12.42 / T.Lentzsch"'
	"Modified: 11.06.93 / 10.12.42 / T.Lentzsch"! !

! ChunkTextPane methods !   
defaultFont
	"Private - Answer the font used in the text pane"

	^ListFont
	"Modified: 03.06.93 / 09.46.08 / T.Lentzsch"! 
doIt: aString ifFail: aBlock
	"Private - Compile and execute the selected text.
	If no error, log it on the change log
	and answer the result of the evaluation,
	else perform the aBlock."

    | answer |

    evaluate := true.

    answer := Compiler
		evaluate: aString
		in: UndefinedObject
		to: nil
		notifying: self
		ifFail: aBlock.

    Smalltalk logEvaluate: aString.

    ^answer
	"Modified: 02.06.93 / 12.28.12 / T.Lentzsch"!   
doItcompilerError: aString at: anInteger in: codeString for: aClass
	"Private - Display the error message aString
	as the selected text at the indicated position
	anInteger in the source codeString.  Note,
	codeString and aClass are ignored."

	(Smalltalk includesKey: #PM)
	ifTrue: [
		self
			doItcompilerErrorOS2: aString
			at: anInteger
			in: codeString
			for: aClass]
	ifFalse: [
		self
			doItcompilerErrorWin: aString
			at: anInteger
			in: codeString
			for: aClass]
	"Modified: 03.06.93 / 08.08.29 / T.Lentzsch"!  
doItcompilerErrorOS2: aString at: anInteger in: codeString for: aClass
	"Private - Display the error message aString
	as the selected text at the indicated position
	anInteger in the source codeString.  Note,
	codeString and aClass are ignored."

    | pos string |

	self setFocus;makeActive.

	string := aString,'->'.
	self selStart: 1.
	self selEnd: codeString size.

    pos := self convertIndex: anInteger string: codeString.
    pos := pos.
    self selectIndexFrom: pos to: pos.
    self insert: string.
    self selectIndexFrom: pos to: pos + string asMixedString size.
	"Modified: 03.06.93 / 09.39.06 / T.Lentzsch"!   
doItcompilerErrorWin: aString
	at: anInteger
	in: codeString
	for: aClass

	"Private - Display the error message aString
	as the selected text at the indicated position
	anInteger in the source codeString."

    | origin corner box string |

	string := aString,'->'.

    self selection hide.
    box := self replaceWithText:
        (codeString copyFrom: 1 to: anInteger - 1).
    origin := box corner + (1 @ 0).
    self selection selectBefore: origin.
    box := self replaceWithText:
        string trimBlanks.
    corner := box corner.
    self selection selectAfter: corner.
    self
        replaceWithText:
            (codeString copyFrom: anInteger to:
            codeString size).
    self selection origin: origin corner: corner.
    self forceSelectionOntoDisplay
	"Modified: 03.06.93 / 08.10.38 / T.Lentzsch"!  
popupMenu
	"Private - Answer the popup Menu for the receiver"

	| m fm |

	m := Menu new
		appendItem: 'Undo' selector: #copySelection;
		appendSeparator;
		appendItem: 'Copy	Ctrl+Ins' selector: #copySelection;
		appendItem: 'Cut	Shift+Del' selector: #cutSelection;
		appendItem: 'Paste	Shift+Ins' selector: #pasteSelection;
		appendSeparator;
		appendItem: 'Select All' selector: #selectAll;
		appendItem: 'Print Selection' selector: #printSelection;
		appendItem: 'Word Wrap' selector: #toggleWrap;
		appendSeparator;
		appendItem: 'Find/Replace...' selector: #findReplace;
		appendItem: 'Find Again' selector: #again;
        appendSeparator;
        appendItem: 'Do It' selector: #doIt ;
        appendItem: 'Show It' selector: #printIt ;
		appendItem: 'Inspect It' selector: #inspectIt;
        owner: self;
        title: '~TextPanePopup'.

    ^m
	"Modified: 03.06.93 / 09.46.32 / T.Lentzsch"! !

! WBTextPane class methods !  
isWBInternalClass

    ^true!   
messageMenu
        "Answer the Message menu."
    ^Menu new
        appendItem: '&Senders' selector: #senders;
        appendItem: '&Implementors' selector: #implementors;
        appendItem: '&References' selector: #references;
        "appendSeparator ;
        appendItem: '&Check Spelling' selector: #spellCheck;"
        title: '~Message'! 
supportedEvents
        "Private - Answer the Set of events that TextPanes can notify
         their owners about."
    ^super supportedEvents
        add: #textChanged;
        yourself! !

! WBTextPane methods !  
backspace

    super backspace.
    self event: #textChanged!  
characterInput: aCharacter

    super characterInput: aCharacter.
    self event: #textChanged!
cutSelection

    super cutSelection.
    self event: #textChanged!
evaluate: aBoolean

    evaluate := aBoolean!   
implementors

    self selectedItem isEmpty ifTrue: [ ^nil ].
    Smalltalk implementorsOf: self selectedItem asMessage!   
modified

    ^false!   
offset

    ^offset!
offset: anInteger

    offset := anInteger! 
pasteSelection

    super pasteSelection.
    self event: #textChanged!
popupMenu
        "Private - Answer the popup Menu for the receiver."
    | m |
    m := Menu new
        appendItem: '&Copy' selector: #copySelection;
        appendItem: 'Cu&t' selector: #cutSelection ;
        appendItem: '&Paste' selector: #pasteSelection ;
        appendSeparator ;
        appendItem: '&Inspect It' selector: #inspectIt ;
        appendItem: '&Show It' selector: #printIt  ;
         appendItem: '&Do It' selector: #doIt  ;
       appendSeparator ;
        appendItem: '&Senders' selector: #senders;
        appendItem: '&Implementors' selector: #implementors;
        appendItem: '&References' selector: #references.
    m owner: self;
        title: '&TextPanePopup'.
    m getIndex: #accept ifAbsent: [^m]. "Check to be sure the item is there."
    (self mainWindow menuTitled: '&File') isNil ifFalse: [
        m copyItemAttributes: #accept from: (self mainWindow menuTitled: '&File').
    ].
    ^m!  
references
    | global |
    self selectedItem isEmpty ifTrue: [ ^nil ].
    global := Smalltalk associationAt: self selectedItem trimBlanks asSymbol ifAbsent: [ nil ].
    global isNil
        ifFalse: [ Smalltalk sendersOf: global ]
        ifTrue: [ MessageBox message: 'There are no references to ''',self selectedItem,'''.']
        .!  
saveCompilerError: aString at: anInteger in: codeString for: aClass

    ^super
        saveCompilerError: aString
        at: (anInteger - offset)
        in: self contents
        for: aClass!  
senders

    self selectedItem isEmpty ifTrue: [ ^nil ].
    Smalltalk sendersOf: self selectedItem asMessage! !

! WB3DFrame class methods !
isWBInternalClass

    ^true! !

! WB3DFrame methods !
defaultStyle
        "Private - Answer an Integer with appropriate styles in it."
    ^WsChild   |
    WsVisible!  
depth

    ^depth!  
depth: anInteger

    depth := anInteger!   
display

    self doGraphics: [
        self displayWith: self pen inRect: self rect
    ]!   
displayWith: pen inRect: r

    | rect inRect |

    rect := r leftTop extent: self extent.
    pen
        drawRect3D: (rect expandBy: 1) depth: depth style: style3D;
        foreColor: self foreColor.!
getGraphicsTool
        "We use a pen here, not a textTool"

    ^graphicsTool := Pen forDC: nil medium: self.!
in

    style3D := #in.!
initialize

    super initialize.
    style3D := #in.
    depth := 1.!
out

    style3D := #out.!  
rect

    ^0@0 extent: self extent! 
style3D

    ^style3D!  
style3D: s

    style3D := s!   
updateSliders!
wmGetdlgcode: wParam with: lParam

    ^DlgcStatic! 
wmNchittest: wParam with: lParam
        "Private - allow overlapping panes to get mouse input"
  ^  -1  "HtTransparent"! !

! WBFramerExample class methods !
isWBInternalClass

    ^true! !

! WBFramerExample methods !  
defaultStyle
        "Private - Answer an Integer with appropriate styles in it."
    ^WsChild   |
    WsVisible!  
display

    frameRect notNil ifTrue: [
        self pen
            drawRectangle: frameRect;
            fill: (frameRect insetBy: 1) color: ClrWhite.
    ].
    paneRect notNil ifTrue: [
        self pen fill: (paneRect leftTop corner: (paneRect corner min: frameRect corner - 1)) color: ClrBlue.
    ].!  
frameRect

    ^frameRect!  
frameRect: aRect

    frameRect := aRect.!  
getGraphicsTool
        "We use a pen here, not a textTool"
    | dc |

    dc := self getDC.
    ^graphicsTool := Pen forDC: dc medium: self!   
paneRect: aRect

    paneRect := aRect.
    self display.! 
updateSliders!
wmErasebkgnd: wordInteger with: longInteger

    | oldDC |
    oldDC := graphicsTool privateHandle.
    graphicsTool handle: wordInteger.
    graphicsTool fill: (0@0 extent: self extent) color:  (UserLibrary getSysColor: ColorWindow).
    graphicsTool handle: oldDC.
    ^1! !

! WBInvisibleGroupPane class methods ! 
isWBInternalClass

    ^true! !

! WBInvisibleGroupPane methods ! 
addSubpane: aPane

    | id |

    children isNil ifTrue: [
        children := IdentityDictionary new].
    children at: (id := self getNextChildId) put: aPane.
    aPane propertyAt: #id put: id.! !

! WBScrollingPane class methods !   
isWBInternalClass

    ^true! !

! WBScrollingPane methods !  
addSubpane: aPane

    children isNil ifTrue: [
        children := IdentityDictionary new].
    children at: self getNextChildId put: aPane.

    aPane parent: self.
    owner mainView add: aPane interestIn: aPane name.!  
amountToPageLeft

    ^(self visibleExtent x - 10) max: 20! 
amountToPageUp

    ^(self visibleExtent y - 10) max: 20!   
amountToScrollLeft

    ^10!
amountToScrollUp

    ^10!  
childSize

    | theChild |

    (theChild := self firstChild) notNil  ifTrue: [
        ^theChild totalWidth @ theChild totalLength
    ] ifFalse: [
        ^0@0
    ].!
firstChild

    children isNil ifTrue: [
        ^nil
    ].

    ^children values asArray first!   
getScrollRanges

    | h v minPtr maxPtr |

    minPtr := WinStructure new: 2.
    maxPtr := WinStructure new: 2.

    UserLibrary
        getScrollRange: self asParameter
        bar: SbHorz
        lpMinPos: minPtr asParameter
        lpMaxPos: maxPtr asParameter.

    h := maxPtr uShortAtOffset: 0.

    UserLibrary
        getScrollRange: self asParameter
        bar: SbVert
        lpMinPos: minPtr asParameter
        lpMaxPos: maxPtr asParameter.

    v := maxPtr uShortAtOffset: 0.

    ^h@v! 
gettingFocus

    self firstChild setFocus.!
hasChildren

    ^ children notNil and: [ children size > 0 ]!  
initialize

    super initialize.
    topCorner := 0@0.!   
resizeChildren!   
resizeWindow

    super resizeWindow.
    topCorner := 0@0.
    self scrollIfNecessaryRedraw: false.
    self setScrollRanges.
    self updateSliders!  
scrollHorizontal: anInteger

    self scrollTopCorner: anInteger  @ 0!  
scrollIfNecessaryRedraw: redraw

    | childSize visibleExtent newTopCorner |

    self hasChildren ifFalse: [
        ^false
    ].

    childSize       := self childSize.
    visibleExtent := self visibleExtent.


    newTopCorner := topCorner deepCopy.

    (childSize x < (visibleExtent x + topCorner x)) ifTrue: [
        newTopCorner x: (childSize x - visibleExtent x max: 0).
    ].

    (childSize y < (visibleExtent y + topCorner y)) ifTrue: [
        newTopCorner y: (childSize y - visibleExtent y max: 0).
    ].

    (newTopCorner ~= topCorner) ifTrue: [
        self scrollTopCorner: topCorner - newTopCorner unlimited: false.
        topCorner := newTopCorner.
        ^true
     ] ifFalse: [
        topCorner := newTopCorner.
        ^false
    ].! 
scrollToOrigin

    self sendInputEvent: #scrollTopCorner:  with: self topCorner.!  
scrollTopCorner: aPoint

    self scrollTopCorner: aPoint unlimited: false.!
scrollTopCorner: p unlimited: bool

    | oldCorner aPoint scrollRanges |

    aPoint := p x @ p y.

    oldCorner := topCorner deepCopy.

    scrollRanges := self getScrollRanges.

    bool ifFalse: [
        topCorner x: ((topCorner x - aPoint x  min: (scrollRanges x)) max: 0).
        topCorner y: ((topCorner y - aPoint y min: (scrollRanges y)) max: 0).
    ] ifTrue: [
        topCorner x: ((topCorner x - aPoint x) max: 0).
        topCorner y: ((topCorner y - aPoint y) max: 0).
    ].

    oldCorner = topCorner ifFalse: [

        UserLibrary
            scrollWindow: handle
            xAmount: oldCorner x - topCorner x
            yAmount: oldCorner y - topCorner y
            lpRect: nil
            clipRect: nil.

        self updateWindow.
    ].!
scrollVertical: anInteger

    self scrollTopCorner: 0 @ anInteger! 
setScrollRanges

    self setScrollRanges: true!
setScrollRanges: redraw

    | oldRange newRange visibleExtent childSize f |

    visibleExtent := self visibleExtent.
    oldRange := self getScrollRanges.
    childSize := self childSize.
    newRange := (childSize - visibleExtent) max: 0@0.


   UserLibrary
        setScrollRange: self asParameter
        bar: SbHorz
        min: 0
        max: newRange x
        redraw: redraw.

    UserLibrary
        setScrollRange: self asParameter
        bar: SbVert
        min: 0
        max: newRange y
        redraw: redraw.

    ^f = true! 
sizingWindow: aRect

    | mouseLoc deltaX deltaY visibleRect |

    mouseLoc := (Cursor offset mapToWindow: self).
    visibleRect := (0@0 extent: self extent).

    deltaX := deltaY := 0.

    (mouseLoc x isLeftOf: visibleRect left) ifTrue: [
        deltaX := (visibleRect left left: mouseLoc x).
    ] ifFalse: [
        (mouseLoc x isRightOf: visibleRect right) ifTrue: [
            deltaX := (visibleRect right left: mouseLoc x).
        ]
    ].
    (mouseLoc y isAbove: visibleRect top) ifTrue: [
        deltaY := (visibleRect top up: mouseLoc y).
    ] ifFalse: [
        (mouseLoc y isBelow: visibleRect bottom) ifTrue: [
            deltaY := (visibleRect bottom up: mouseLoc y).
        ].
    ].

    self scrollTopCorner: (deltaX@deltaY) unlimited: true.!   
totalLength

    self hasChildren  ifTrue: [
        ^self firstChild totalLength
    ] ifFalse: [
        ^0
    ].!   
totalWidth

   self hasChildren  ifTrue: [
        ^self firstChild totalWidth
    ] ifFalse: [
        ^0
    ].!  
updateHorizontalSlider

    self updateHorizontalSliderTo: topCorner x.!
updateSliders

    handle = NullHandle ifTrue: [^self].

        self updateVerticalSlider.
        self updateHorizontalSlider.!
updateVerticalSlider

     self getScrollRanges.
    self updateVerticalSliderTo: topCorner y! 
visibleExtent

    ^self extent - 2!
windowHasSized

    self setScrollRanges: true.
    self scrollIfNecessaryRedraw: true.
    self updateSliders.!  
wmHScroll: wordInteger with: longInteger
        "This is the main entry point for scrolling frame communication with
    the ScrollingPane.  Subclassed from Subpane to avoid their turning everything
    into a percentage.  Using pixel absolutes is faster and more straightforward."

    | type |

    type := wordInteger.
    type = SbLineup         ifTrue: [self scrollHorizontal: self amountToScrollLeft ].
    type = SbLinedown     ifTrue: [self scrollHorizontal: self amountToScrollLeft negated].
    type = SbPageup        ifTrue: [self scrollHorizontal: self amountToPageLeft ].
    type = SbPagedown    ifTrue: [self scrollHorizontal: self amountToPageLeft negated].

    type = SbThumbposition ifTrue: [
        self updateHorizontalSliderTo: longInteger \\ 65536.
        ^nil
    ].

    type = SbThumbtrack ifTrue: [
        self scrollHorizontal: topCorner x - (longInteger \\ 65536).
        ^nil
    ].

    self updateHorizontalSlider.

   ^nil!
wmVScroll: wordInteger with: longInteger

        "This is the main entry point for scrolling frame communication with
    the ScrollingPane.  Subclassed from Subpane to avoid their turning everything
    into a percentage.  Using pixel absolutes is faster and more straightforward."

    | type |

    type := wordInteger.
    type = SbLineup         ifTrue: [self scrollVertical: self amountToScrollUp].
    type = SbLinedown     ifTrue: [self scrollVertical: self amountToScrollUp negated].
    type = SbPageup        ifTrue: [self scrollVertical: self amountToPageUp].
    type = SbPagedown    ifTrue: [self scrollVertical: self amountToPageUp negated].

    type = SbThumbposition ifTrue: [
        self updateVerticalSliderTo: longInteger \\ 65536.
        ^nil
    ].

    type = SbThumbtrack ifTrue: [
        self scrollVertical: topCorner y - (longInteger \\ 65536).
        ^nil
    ].

    self updateVerticalSlider.

   ^nil!  
zoom

        "Private - Expand the pane to take up the entire area
          of its main window, or back to normal if it is
         already zoomed."
    | mainWindowRect |
    mainWindowRect := (self mainWindow rectangle).
    self mainWindow zoomed: self mainWindow zoomed not.
    self zoomed: self zoomed not.

    self mainWindow noRedraw: true.
    self mainWindow children do: [ :c |
        c ~~ self ifTrue: [
            self zoomed ifTrue: [
                c hideWindow.
            ] ifFalse: [
                c showWindow.
            ].
        ].
    ].
    self mainWindow noRedraw: false.
    self mainWindow invalidateRect: nil.

    self mainWindow zoomed not
        ifTrue: [ "unzoom"
            self mainWindow
                    resize: (mainWindowRect origin extent: mainWindowRect extent)
                    repaint: true]

        ifFalse: [ "zoom"
            rectangle origin: (0@0) extent: (mainWindowRect extent max: 0@0).
            self resizeWindow;
                updateRectangle;
                setFocus.
            self showWindow].! !

! WBToolPalette class methods !
isWBInternalClass

    ^true!   
supportedEvents

    ^super supportedEvents
        add: #select;
        add: #selecting;
        add: #doubleClick;
        add: #gettingFocus;
        add: #showHelp;
        yourself! !

! WBToolPalette methods !
add: aSelector

    ^self add: nil selector: aSelector! 
add: bitmapSelector selector: aSelector
    | key point |
    key := self elements size + 1.
    point := ((key - 1)\\(self size x)+1) @ ((key + (self size x - 1))//(self size x )).
    ^self at: point put: bitmapSelector selector: aSelector.!   
at: key put: bitmapSelector

    ^self at: key put: bitmapSelector selector: nil!   
at: key put: bitmapSelector selector: aSelector

    | selector bitmap file element |

    selector := bitmapSelector isString ifTrue: [ bitmapSelector ] ifFalse: [ aSelector ].
    self useSystem ifTrue: [
        bitmap := CPBitmapDict sysAt: selector asString ifAbsent: [ nil ].
    ] ifFalse: [
        bitmap := CPBitmapDict at: selector asString ifAbsent: [ nil ].
    ].
    bitmap ifNil: [ ^nil ].
    cellSize isNil ifTrue: [ self cellSize: (bitmap width // 2) @ bitmap height ].

    self elements at: key put: (element := self wbToolClass bitmap: bitmap selector: aSelector).
    bitmapSelector isNil ifFalse: [ element bitmapSelector: bitmapSelector ].

    ^element!   
at: key selector: aSelector

    ^self at: key put: nil selector: aSelector!
bitmapFileAt: key
    | element |
    (self validSelection: key) ifFalse: [ ^nil ].

    ^(element := self elementAt: key) isNil
            ifTrue: [ nil ]
            ifFalse: [ element file ]! 
button1DoubleClick: aPane

    self event: #doubleClick!
button1Down: aPoint
    "Touched by Ale for Help (Shift+F1) support"
    | index |
    index := self highlight: selection.
    self event: #gettingFocus.

    self captureMouseInput.
    Notifier consumeInputUntil: [:event |
        index := self highlight: index.
        (event notNil and: [ event selector == #button1Up: ])
    ].
    self clearMouseCapture.

    (self isEnabled: index) ifTrue: [
        selection := index.
        #modifiedByOS.
        (self helpManager notNil and:[self helpManager helpMode]) ifTrue:[
            self helpManager displayHelp: (self selectorAt: selection).
            self unHighlightSelection.
            ^self
        ].
        self isPreAutomatic ifTrue: [self unHighlightBitmap: selection].
        self generateEventFor: selection.
        self eventFor: selection.
        self event: #select.
        self isPostAutomatic ifTrue: [self unHighlightBitmap: selection].
        self isAutomatic ifTrue: [ selection := nil ].
    ] ifFalse: [
        self highlightBitmap: selection.
    ].!  
buttonFrom: anBitmapFile size: aPoint
    | aBitmap |
    anBitmapFile isNil
        ifTrue: [
            aBitmap := Bitmap extent: aPoint.
            aBitmap pen centerText: '?' at: aBitmap boundingBox center.
            ^aBitmap ].
    ^((anBitmapFile includes: $*) not and: [File exists: anBitmapFile])
        ifTrue: [ Bitmap fromFile: anBitmapFile ]
        ifFalse: [
            aBitmap := Bitmap screenExtent: aPoint.
            aBitmap pen
                draw3DButton: (self justFileName: anBitmapFile)
                rect: aBitmap boundingBox
                font: self font.
            aBitmap]! 
cachedElements

    ^cachedElements ifNil: [ cachedElements := Set new ]!   
cachedElements: aCollection

    cachedElements := aCollection! 
cacheRedraw

    ^cacheRedraw ifNil: [ cacheRedraw := false ].! 
cacheRedraw: aBoolean

    cacheRedraw := aBoolean! 
cacheRedrawOff

    self cacheRedraw: false.
    self cachedElements do: [ :element |
        self display: element
    ].
    self cachedElements: nil.!   
cacheRedrawOn

    self cacheRedraw: true.! 
cellHeight
    ^self cellSize y! 
cellSize

    ^cellSize ifNil: [ cellSize := self defaultCellSize ].!   
cellSize: aPoint

    cellSize := aPoint!   
cellWidth
    ^self cellSize x!  
close
        "Private - Close the receiver."
    self releaseBitmaps.
    ^super close!   
collectionType

    ^Dictionary!
currentIndex
    | point |
    point := Cursor offset mapToWindow: self.
    ^((point x - self leftTop x) // self cellWidth + 1) @
        ((point y - self leftTop y) // self cellHeight + 1).!  
defaultCellSize

    ^28@28!
defaultSelection
    ^1@1!   
defaultStyle
        "Private - Answer an Integer with appropriate styles in it."
    ^WsChild   |
    WsVisible!  
disable
    super disable.
    self disableElements.!   
disable: key
    | element |
    (element := self elementAt: key) isNil ifFalse: [
        element isEnabled ifTrue: [
            element disabled.
            self handle isValid ifTrue: [ self display: key ]
        ]
    ].!   
disableElements
    self elements keysDo: [ :key |
        self disable: key ].!
disableItem: aSelector
    self disable: (self elementAtSelector: aSelector)!
display

    1 to: self width do: [ :x |
        1 to: self height do: [ :y |
            self display: x@y
        ]
    ]!
display: key

    self cacheRedraw ifTrue: [
        self cachedElements add: key
    ] ifFalse: [
        self displayBitmap: key
    ].!  
displayBitmap: key

    | element rect |

    element := self elementAt: key.
    element isNil ifTrue: [ ^nil ].

    self doGraphics: [
        self pen
            copy: element pen
            from: element boundingBox
            to: (rect := self rectForKey: key).
        element isDisabled ifTrue: [ self drawDisabledWith: self pen in: rect ].
    ].!  
drawDisabledWith: aPen in: aRect

    aPen
        setLineWidth: 1;
        foreColor: ClrPalegray;
        backColor: ClrPalegray;
        drawRectangle: (aRect insetBy: 1);
        lineFrom: (aRect leftBottom rightAndUp: 2@3) to: (aRect rightBottom leftAndUp: 2@3);
        lineFrom: (aRect rightTop leftAndDown: 3@2) to: (aRect rightBottom leftAndUp: 3@2).!  
elementAt: key

    ^self elements at: key ifAbsent: [ nil ]!   
elementAt: key put: anElementArray

    self elements at: key put: anElementArray!  
elementAtSelector: aSelector
    ^self elements keys detect: [ :key |
        (self selectorAt: key) = aSelector ] ifNone: [ nil ]! 
elements

    ^elements!
elements: aCollection

    elements := aCollection! 
enable
    super enable.
    self enableElements.!  
enable: key
    | element |
    (element := self elementAt: key) isNil ifFalse: [
        element isEnabled ifFalse: [
            element up.
            self handle isValid ifTrue: [ self display: key ]
        ]
    ].! 
enableElements
    self elements keysDo: [ :key |
        self enable: key ].!  
enableItem: aSelector
    self enable: (self elementAtSelector: aSelector)!  
eventFor: key

    | selector |

    selector := self selectorAt: key.

    (selector notNil and: [ selector isSymbol ])
        ifTrue: [
            (self owner class canUnderstand: selector)
                ifTrue: [
                    (selector includes: $:)
                        ifTrue: [self owner perform: selector with: self]
                        ifFalse: [self owner perform: selector]]].! 
generateEventFor: aSelection

    self event: (
        'R', aSelection y asString,
        'C', aSelection x asString) asSymbol.!
getGraphicsTool
        "Private - Initialize an empty pen tool."
    ^Pen forDC: nil medium: self! 
height

    ^self size y!   
highlight: currentSelection
    | index element |
    index := self currentIndex.
    currentSelection = index ifFalse: [ self event: #showHelp ].
    (self isEnabled: index) ifTrue: [
        (currentSelection = index)
            ifFalse: [
                self unHighlightBitmap: currentSelection.
                self highlightBitmap: index.
                self event: #selecting.
            ].
    ] ifFalse: [
        self unHighlightBitmap: currentSelection.
        index := nil
    ].
    ^index!
highlightBitmap: key

    | element |
    element := self elementAt: key.
    (element isNil or: [ element isDisabled ]) ifTrue: [ ^nil ].
    element down.
    self display: key.!
initialize

    super initialize.
    self elements: self newPage.!
isAutomatic
    ^(self isPostAutomatic) | (self isPreAutomatic)! 
isEnabled: key
    | element |
    ^(element := self elementAt: key) isNil
            ifTrue: [ false ]
            ifFalse: [ element isEnabled ]!  
isPostAutomatic
    ^tpStyle = #postAutomatic!   
isPreAutomatic
    ^tpStyle = #preAutomatic! 
justFileName: fileName
    ^((File splitPath: fileName in: Disk) at: 3) upTo: $.!
leftTop

    ^(0@0 extent: self extent) leftTop!
newPage

    ^self collectionType new!  
postAutomatic
    tpStyle := #postAutomatic! 
preAutomatic
    tpStyle := #preAutomatic!   
rectForKey: key

    | element |
    element := self elementAt: key.
    element ifNil: [ ^0@0 extent: 0@0 ].
    element rectangle ifNil: [
        element rectangle:
            ((self leftTop x right: (key x - 1) * (self cellWidth - 1)) @
            (self leftTop y down: (key y - 1) * (self cellHeight - 1))
            extentFromLeftTop: cellSize).
    ].
    ^element rectangle!  
releaseBitmaps
        "Private - Release all bitmaps."
    | aBitmap |
    self elements do: [ :element | element isNil ifFalse: [ element releaseBitmaps ]].
    self elements: nil.!   
selectedItem

    ^selection!   
selectItem: key

    self unHighlightBitmap: selection.
    selection := key.
    self highlightBitmap: key.! 
selector

    ^self selectorAt: selection!  
selectorAt: key
    | element |
    (self validSelection: key) ifFalse: [ ^nil ].

    ^(element := self elementAt: key) isNil
            ifTrue: [ nil ]
            ifFalse: [ element selector ]!   
size

    size isNil ifTrue: [ size := 0@0 ].
    ^size!   
size: aPoint

    size := aPoint.!  
stateAt: key
    | element |
    (self validSelection: key) ifFalse: [ ^nil ].

    ^(element := self elementAt: key) isNil
            ifTrue: [ nil ]
            ifFalse: [ element state ]! 
stateAt: key put: aSymbol
    | element |
    (element := self elementAt: key) isNil ifFalse: [
        element state: aSymbol.
    ].!   
stickerForObjectAt: aPoint

    ^self selectorAt: self currentIndex!
toggle
    tpStyle := #toggle!   
toggleWhite
    tpStyle := #toggleWhite! 
tpStyle
    ^tpStyle!
tpStyle: aSymbol
    tpStyle := aSymbol! 
unHighlightBitmap: key

    | element |
    element := self elementAt: key.
    (element isNil or: [ element isDisabled ]) ifTrue: [ ^nil ].
    element up.
    self display: key.!
unHighlightSelection
    self unHighlightBitmap: selection.
    selection := nil.!  
updateSliders!
useSystem

    ^useSystem ifNil: [ useSystem := false ].!   
useSystem: aBoolean

    useSystem := aBoolean! 
validSelection: key

    ^(self elementAt: key) notNil! 
virtualKeyInput: anInt!   
wbToolClass

    ^WBTool!   
when: anEvent perform: aMessage
        "Notify the owner whenever anEvent occurs by
         performing aMessage.  For compatibility,
         aMessage can be a one argument selector."
    | m |
    m := aMessage.
    "aMessage isSymbol ifTrue: [m := Message new
        receiver: (self owner notNil ifTrue: [self owner] 
            ifFalse: [self sender])
        selector: aMessage
        arguments: (Array with: self)]."
    handlers at: anEvent put: m.!   
width

    ^self size x! !

! OSToolPalette class methods !   
isWBInternalClass

    ^false! !

! OSToolPalette methods !   
add: bitmapSelector selector: aSelector
    | key |
    key := 1@ (elements size + 1).
    ^self at: key put: bitmapSelector selector: aSelector.! 
at: key put: bitmapSelector selector: aSelector

    size := nil. "force resize..."
    ^super at: key put: bitmapSelector selector: aSelector!
defaultCellSize

    ^OSToolBar defaultCellSize!
displayBitmap: key

    | element rect |

    element := self elementAt: key.
    element isNil ifTrue: [ ^nil ].

    self doGraphics: [
        element displayWith: self pen in:(rect := self rectForKey: key).
        element isDisabled ifTrue: [ self drawDisabledWith: self pen in: rect ].
    ].! 
freeClientArea: box
    "Private - Set the client area left over."
    self tpStyle == #mdiToolBar ifFalse: [ ^self ].
    self visible ifFalse: [ ^self ].
    box leftTop: (box leftTop rightAndDown: (self width @ 0))!
initialize
    "Private - Initialize the receiver..."

    super initialize.
    self cellSize: self defaultCellSize.!
isPreAutomatic

    ^super isPreAutomatic or: [ tpStyle = #mdiToolBar ]!
mdiToolBar

    tpStyle := #mdiToolBar.
    self framingBlock: [:box |
        Rectangle leftTopUnit rightBottom: (self width @ box height) ].!   
open

    "Private - Generate #getContents event & Open the receiver.
    Implemented By Ale. Se lo habian olvidado..."

    #addedByOStyle.
    self event: #getContents.
    super open.!
size

    size isNil ifTrue: [
        size := 0@0.
        elements keys do: [:each|
            size
                x: (size x max: each x);
                y: (size y max: each y);
                yourself.
        ].
    ].
    ^size!
wbToolClass

    ^OSTool! !

! WBMultiToolPalette class methods ! 
isWBInternalClass

    ^true! !

! WBMultiToolPalette methods !   
add: aSelector on: name

    ^self add: nil selector: aSelector on: name!   
add: aBitmapFile selector: aSelector on: name
    | key point temp element |
    temp := self elements.
    self elements: (self pageNamed: name).
    key := self elements size + 1.
    point := ((key - 1)\\(self size x)+1) @ ((key + (self size x - 1))//(self size x )).
    element := self at: point put: aBitmapFile selector: aSelector.
    self elements: temp.
    ^element! 
addPage: aPage name: name
    self pages at: name put: aPage.
    ^aPage!   
at: key on: name put: aBitmapFileName

    ^self at: key on: name put: aBitmapFileName selector: nil!   
at: key on: name put: aBitmapFileName selector: aSelector
    | temp element |
    temp := self elements.
    self elements: (self pageNamed: name).
    element := self at: key put: aBitmapFileName selector: aSelector.
    self elements: temp.
    ^element!   
at: key on: name selector: aSelector

    ^self at: key on: name put: nil selector: aSelector!  
bitmapFileAt: key on: name
    | element |
    ^(element := self elementAt: key on: name) isNil
        ifTrue: [ nil ]
        ifFalse: [ element file ]!
buttonFrom: anBitmapFile size: aPoint
    | aBitmap |
    anBitmapFile isNil
        ifTrue: [
            aBitmap := Bitmap extent: aPoint.
            aBitmap pen centerText: '?' at: aBitmap boundingBox center.
            ^aBitmap ].
    ^((anBitmapFile includes: $*) not and: [File exists: anBitmapFile])
        ifTrue: [ Bitmap fromFile: anBitmapFile ]
        ifFalse: [
            aBitmap := Bitmap screenExtent: aPoint.
            aBitmap pen
                draw3DButton: (self justFileName: anBitmapFile)
                rect: aBitmap boundingBox
                font: self font.
            aBitmap]! 
disable: key on: name
    | element |
    (element := self elementAt: key on: name) isNil
            ifFalse: [
                element disabled.
                (self handle isValid and: [ elements == (self pageNamed: name)])
                    ifTrue: [ self display: key ]]! 
elementAt: key on: name
    ^(self pageNamed: name) at: key ifAbsent: [ nil ]!   
enable: key on: name
    | element |
    (element := self elementAt: key on: name) isNil
            ifFalse: [
                element up.
                (self handle isValid and: [ elements == (self pageNamed: name)])
                    ifTrue: [ self display: key ]]!
initialize

    super initialize.
    self pages: Dictionary new.! 
on: name add: aSelector

    ^self add: nil selector: aSelector on: name!   
on: name add: aBitmapFile selector: aSelector

    ^self add: aBitmapFile selector: aSelector on: name! 
pageNamed: name
    ^self pages at: name ifAbsent: [ self addPage: self newPage name: name ]!
pageNames
    ^self pages keys!  
pages
    ^pages!
pages: aDictionary
    pages := aDictionary! 
releaseBitmaps
        "Private - Release all bitmaps."
    | aBitmap |
    self elements: nil.
    self pages do: [ :page |
        page do: [ :element | element releaseBitmaps ]
    ].
    self pages: nil.!   
selectorAt: key on: name
    | element |
    ^(element := self elementAt: key on: name) isNil
        ifTrue: [ nil ]
        ifFalse: [ element selector ]!  
stateAt: key

    ^#up! 
switchTo: name
    | sel |
    self hideWindow.
    self elements: (self pageNamed: name).
    selection := self elementAtSelector: 'ArrowTool'.
    selection isNil ifTrue: [ selection := self defaultSelection ].
    self elements do: [ :element | element up ].
    sel := self elementAt: selection.
    sel isNil ifFalse: [ sel down ].
    self handle isValid ifTrue: [ self display ].
    self showWindow.! !

! OSMultiToolPalette class methods !  
isWBInternalClass

    ^false! !

! OSMultiToolPalette methods !  
add: bitmapSelector selector: aSelector
    | key point |
    key := self elements size + 1.
    self size x = 0
    ifTrue: [point := 0@0]
    ifFalse: [point := ((key - 1)\\(self size x)+1) @ ((key + (self size x - 1))//(self size x ))].
    ^self at: point put: bitmapSelector selector: aSelector.!   
contents
    "Answer the receiver's contents"

    ^self elements! 
defaultCellSize

    ^OSToolBar defaultCellSize!
displayBitmap: key

    | element rect |

    element := self elementAt: key.
    element isNil ifTrue: [ ^nil ].

    self doGraphics: [
        element displayWith: self pen in:(rect := self rectForKey: key).
        element isDisabled ifTrue: [ self drawDisabledWith: self pen in: rect ].
    ].! 
initialize
    "Private - Initialize the receiver..."

    super initialize.
    self cellSize: self defaultCellSize.!
open

    "Private - Generate #getContents event & Open the recever
    Implemented By Ale. Se lo habian olvidado..."

    #addedByOStyle.
    self event: #getContents.
    super open.!  
rectanglePrivate: aRectangle
    "Private - Sets the receiver's rectangle."
    rectangle := aRectangle!
wbToolClass

    ^OSTool! !

! OSMultiToolBar methods !   
add: aBitmapFile selector: aSelector on: name
    | key point temp element |
    temp := self elements.
    self elements: (self pageNamed: name).
    key := self elements size + 1.
    point := self placeForTool: key.
    element := self at: point put: aBitmapFile selector: aSelector.
    self elements: temp.
    ^element! 
button2Down: aPoint

    | index |

    index := self currentIndex.

    (self isEnabled: index) ifTrue: [
        self rbEventFor: index.
    ].!
currentIndex
    | point |
    point := Cursor offset mapToWindow: self.
    self elements keys do: [ :key |
        ((self rectForKey: key) containsPoint: point)
           ifTrue: [ ^key ]
    ].
    ^nil.!   
disableElements
    self elements keys do: [ :key | self disable: key ].!
display

    self elements keys do: [ :key | self display: key ].!  
enableElements
    self elements keys do: [ :key | self enable: key ].!  
freeClientArea: box
    "Private - Set the client area left over."
    self tpStyle == #mdiToolBar ifFalse: [ ^self ].
    self visible ifFalse: [ ^self ].
    box leftTop: (box leftTop rightAndDown: (0 @ self height))!   
generateEventFor: aSelection
    ^nil!   
height
    "Answer the receiver's height."

    ^self cellSize y * self size y!
isPreAutomatic

    ^super isPreAutomatic or: [ tpStyle = #mdiToolBar ]!
mdiToolBar

    tpStyle := #mdiToolBar.
    self framingBlock: [:box |
        Rectangle leftTopUnit rightBottom: (box width @ self height) ].!   
placeForTool: index
    | width |
    width := self size x.
    ^width - 1 + index // width @ (index - 1 \\ width + 1)!
rbEventFor: key

    | selector |

    selector := self rbSelectorAt: key.

    (selector notNil and: [ selector isSymbol ])
        ifTrue: [
            (self owner class canUnderstand: selector)
                ifTrue: [
                    (selector includes: $:)
                        ifTrue: [self owner perform: selector with: self]
                        ifFalse: [self owner perform: selector]]].! 
rbSelectorAt: key
    | element |
    (self validSelection: key) ifFalse: [ ^nil ].

    ^(element := self elementAt: key) isNil
            ifTrue: [ nil ]
            ifFalse: [ element rbSelector ]!   
rectForKey: key
    | element rect |
    key ifNil: [ ^0@0 extent: 0@0 ].
    element := self elementAt: key.
    (element notNil and: [element rectangle notNil])
    ifTrue: [^element rectangle].

    rect := key x @ 1 - 1 * (self cellSize - (1@0)) extent: self cellSize.
    element isNil ifFalse: [ element rectangle: rect ].
    ^rect!  
size

    size isNil ifTrue: [ size := 30 @ 1 ].
    ^size! !

! WBToolBar methods ! 
add: aSelector

    self add: aSelector spaces: 0!  
add: aSelector rbSelector: rbSelector

    ^self add: nil selector: aSelector rbSelector: rbSelector!   
add: bitmapSelector selector: aSelector

    self add: bitmapSelector selector: aSelector spaces: 0!
add: bitmapSelector selector: aSelector rbSelector: rbSelector

    ^self add: bitmapSelector selector: aSelector spaces: 0 rbSelector: rbSelector! 
add: bitmapSelector selector: aSelector spaces: numSpaces

    ^self add: bitmapSelector selector: aSelector spaces: numSpaces rbSelector: nil! 
add: bitmapSelector selector: aSelector spaces: numSpaces rbSelector: rbSelector
    | key element rect |
    key := self elements size + 1.
    self elements add: nil.
    element := self at: key put: bitmapSelector selector: aSelector.
    element isNil ifTrue: [ ^nil ].
    element numSpaces: numSpaces.
    rect := self rectForKey: key - 1.
    element rectangle:
        (Rectangle
            leftTop: (rect rightTop right: numSpaces - 1)
            extent: self cellSize).
    element rbSelector: rbSelector.
    ^element!  
add: aSelector spaces: numSpaces

    ^self add: nil selector: aSelector spaces: numSpaces! 
add: aSelector spaces: numSpaces rbSelector: rbSelector

    ^self add: nil selector: aSelector spaces: numSpaces rbSelector: rbSelector!   
button2Down: aPoint

    | index |

    index := self currentIndex.

    (self isEnabled: index) ifTrue: [
        self rbEventFor: index.
    ].!
collectionType

    ^OrderedCollection! 
currentIndex
    | point |
    point := Cursor offset mapToWindow: self.
    1 to: self elements size do: [ :i |
        (((self elementAt: i) rectangle) containsPoint: point)
            ifTrue: [ ^i ]].
    ^nil.! 
defaultCellSize

    ^25@22!
defaultSelection
    ^1! 
disableElements
    1 to: self elements size do: [ :key |
        self disable: key ].! 
display

    1 to: self elements size do: [ :i | self display: i ]! 
elementAt: key

    ^(key isInteger and: [ key > 0 and: [ key <= self elements size ]])
        ifTrue: [ self elements at: key ]
        ifFalse: [ nil ]!   
elementAtSelector: aSelector
    ^(1 to: self elements size) detect: [ :key |
        (self selectorAt: key) = aSelector ] ifNone: [ nil ]! 
enableElements
    1 to: self elements size do: [ :key |
        self enable: key ].!   
freeClientArea: box
    "Private - Set the client area left over."
    self tpStyle == #mdiToolBar ifFalse: [ ^self ].
    self visible ifFalse: [ ^self ].
    box leftTop: (box leftTop rightAndDown: (0 @ self height))!   
generateEventFor: aSelection
    ^nil!   
height
    "Answer the receiver's height."

    ^self cellSize y!  
isPreAutomatic

    ^super isPreAutomatic or: [ tpStyle = #mdiToolBar ]!
mdiToolBar

    tpStyle := #mdiToolBar.
    self framingBlock: [:box |
        Rectangle leftTopUnit rightBottom: (box width @ self height) ].!   
rbEventFor: key

    | selector |

    selector := self rbSelectorAt: key.

    (selector notNil and: [ selector isSymbol ])
        ifTrue: [
            (self owner class canUnderstand: selector)
                ifTrue: [
                    (selector includes: $:)
                        ifTrue: [self owner perform: selector with: self]
                        ifFalse: [self owner perform: selector]]].! 
rbSelectorAt: key
    | element |
    (self validSelection: key) ifFalse: [ ^nil ].

    ^(element := self elementAt: key) isNil
            ifTrue: [ nil ]
            ifFalse: [ element rbSelector ]!   
rectForKey: key
    | element |
    key ifNil: [ ^0@0 extent: 0@0 ].
    element := self elementAt: key.
    ^element isNil
        ifTrue: [ 0@0 extent: 1@1 ]
        ifFalse: [ element rectangle ]! !

! OSToolBar class methods !
defaultCellSize

    ^25@22!
isWBInternalClass

    ^false!  
supportedEvents

    ^super supportedEvents
        add: #mouseMove;
        yourself! !

! OSToolBar methods ! 
contents
    "Answer the receiver's contents"

    ^self elements! 
defaultCellSize

    ^self class defaultCellSize!   
displayBitmap: key

    | element rect |

    element := self elementAt: key.
    element isNil ifTrue: [ ^nil ].

    self doGraphics: [
        element displayWith: self pen in:(rect := self rectForKey: key).
        element isDisabled ifTrue: [ self drawDisabledWith: self pen in: rect ].
    ].! 
initialize
    "Private - Initialize the receiver..."

    super initialize.
    self cellSize: self defaultCellSize.!
mouseLocation
        "Answer the mouse location as of the last
         mouse input event received."
    | winPoint mouseLocation |
    mouseLocation := self propertyAt: #mouseLocation.
    mouseLocation isNil ifTrue: [^0@0].
    winPoint := WinPoint fromPoint: mouseLocation.
    GDILibrary
        dpToLp: graphicsTool handle
        point: winPoint asParameter
        count: 1.
    ^winPoint asPoint!  
mouseMove: aPoint
        "Private - Mouse has moved to aPoint.
        Let the owner process the event."

    self propertyAt: #mouseLocation put: aPoint.
    self event: #mouseMove!  
open

    "Private - Generate #getContents event & Open the recever
    Implemented By Ale. Se lo habian olvidado..."

    #addedByOStyle.
    self event: #getContents.
    super open.!  
rectanglePrivate: aRectangle
    "Private - Sets the receiver's rectangle."
    rectangle := aRectangle!
rectForKey: key
    | element |
    key ifNil: [ ^0@0 extent: 0@0 ].
    element := self elementAt: key.
    element isNil ifTrue: [^0@0 extent: 1@1 ].

    element rectangle isNil
    ifTrue: [
        element rectangle:
            ((self leftTop x right: (key - 1) * self cellWidth) @ 0
            extentFromLeftTop: cellSize).
    ].

   ^element rectangle!   
wbToolClass

    ^OSTool! !

! SystemWindow class methods !   
startUp
    "Private - Initialize the class.
    Touched by Ale for warning when can't  create system window (CallBacks will not work...)"
    |aWindow|
    SmalltalkSystemWindow := self new.
    SmalltalkSystemWindow create: 'VWIN'
         title: 'SmalltalkSystem'
         style: WsPopup
         rectangle: (0 @ 0 extent: 0 @ 0)
         parent: nil.
    SmalltalkSystemWindow notNil ifTrue: [ Notifier add: SmalltalkSystemWindow ].

    #modifiedByOStyle.
    SmalltalkSystemWindow handle isValid
    ifFalse: [
        MessageBox warning: 'SmalltalkSystemWindow creation has failed.\Callbacks will not work properly' withCrs.
    ].

    WinEventsExtra removeKey: WmStcallback ifAbsent:[].
    (WmStcallback := UserLibrary registerWindowMessage: 'WM_STCALLBACK' asParameter) > 16rC000
        ifTrue:[
            WinEventsExtra at: WmStcallback put: #wmStcallback:with:].! !

! WinHandle methods !   
fileOutSurrogate: anObjectFiler
        " Answer surrogate for object filing if not null or desktop. "
    | surrogate |
    (self = NullHandle) ifTrue: [^self].
    anObjectFiler recordWarningMessage:
            'a ', self class name,
            ' dumped as null handle, won''t be bound when loaded.'.
    surrogate := (self class basicNew: self size)
            replaceFrom: 1 to: self size
            with: NullHandle
            startingAt: 1.
    ^surrogate!
replaceBytesFrom: byteStart
    to: byteStop
    with: aVariableByteObject
    startingAt: byteRepStart
        "Private - replace the bytes of the receiver at index
         positions start through stop with consecutive
         bytes of aVariableByteObject beginning at index
         position repStart.  Answer the receiver."
    | index1 index2 |
    <primitive: 129>
    aVariableByteObject class isBytes
        ifFalse: [self error: 'source must be a byte object'].
    (self == aVariableByteObject and: [byteRepStart < byteStart])
        ifTrue: [ "do backward move for same object"
            index2 := byteRepStart + byteStop - byteStart.
            index1 := byteStop.
            [byteStart <= index1]
                whileTrue: [
                self
                    at: index1
                    put: (aVariableByteObject basicAt: index2) asInteger.
                index1 := index1 - 1.
                index2 := index2 - 1].
            ^self].
    "do forward move"
    index2 := byteRepStart.
    index1 := byteStart.
    [index1 <= byteStop]
        whileTrue: [
            self
                at: index1
                put: (aVariableByteObject basicAt: index2) asInteger.
            index1 := index1 + 1.
            index2 := index2 + 1]! 
replaceFrom: start
    to: stop
    with: aVariableByteObject
    startingAt: repStart
        "Replace the bytes of the receiver at index
         positions start through stop with consecutive
         bytes of aVariableByteObject beginning at index
         position repStart.  Answer the receiver."
    | index1 index2 |
    <primitive: 105>
    (aVariableByteObject isDoubleByteString)
        ifTrue: [
           ^self
                replaceBytesFrom: start to: stop
                with: aVariableByteObject
                startingAt: (aVariableByteObject byteIndexOfCharAt: repStart)].
    (aVariableByteObject class isBytes)
        ifFalse: [
            ^super
                replaceFrom: start
                to: stop
                with: aVariableByteObject
                startingAt: repStart].
    (self == aVariableByteObject and: [repStart < start])
        ifTrue: [ "do backward move for same object"
            index2 := repStart + stop - start.
            index1 := stop.
            [start <= index1]
                whileTrue: [
                self
                    at: index1
                    put: (aVariableByteObject at: index2) asInteger.
                index1 := index1 - 1.
                index2 := index2 - 1].
            ^self].
    "do forward move"
    index2 := repStart.
    index1 := start.
    [index1 <= stop]
        whileTrue: [
            self
                at: index1
                put: (aVariableByteObject at: index2) asInteger.
            index1 := index1 + 1.
            index2 := index2 + 1]! !

! DynamicLinkLibrary class methods !
open: aString
    "Answer an instance of the receiver which refers
     to the Dynamic Link Library named aString.
    Touched by Ale to return nil if failed
     & avoiding #error: message during #startUp causing UAE
     if a DLL is not found..."
    | answer dll errBuf |
    #modifiedByOStyle.
    dll := super new.
    answer := KernelLibrary loadLibrary: aString asParameter.
    answer < 32 ifTrue: [
        "^self error:   an #error: message
                must be avoided during startUp & loading libraries;
                This method will notify user & return nil if failed"
        MessageBox message:
            'Can not open ',aString,
            '\ errCode: ' withCrs, answer printString.
        "This method returns nil..."
        ^nil
    ].
    dll at: 1 put: answer \\ 256.
    dll at: 2 put: answer // 256.
    ^dll! !

! Dynalink16 class methods !
aboutToSaveImage
    "Private - The catched instances must be released.
     WARNING: The instances of the receiver must be
         used sending the message #library to the
         receiver for proper (& automatic) administration.
        The instances of the receiver returned by #library
             mesage must not be released."

    "perform exit action..."
    self exit!  
exit
    "Private - Exit - free all the used libraries"

    Libraries isNil ifTrue: [^self]. "never used..."

    Libraries keys do: [:each| "free used libraries..."
        (Libraries at: each ifAbsent: []) release.
        Libraries removeKey: each ifAbsent: [].
    ].

    Libraries := nil. "Reset the engine..."!  
externalStructureNamed: aName
    "Returns the structure named aName
    at an external address or nil if absent...
    * Warning *
         Memory assosiated with this structure
         must be released with #free
    This method is OSRecomended for building SDStructures..."

    | anAddress definition |
    (SelfDefinedStructure definitions includesKey: aName)
    ifFalse: [ self initializeStructures ].
    definition := SelfDefinedStructure definitions
        at: aName ifAbsent: [^nil].
    anAddress := WinAddress allocateMemory: (definition at: #sizeInBytes).
    ^self structureNamed: aName atAddress: anAddress!   
fileName
        "Answer the receiver's file name."
     ^self implementedBySubclass!   
hasBeenUsed
    "True if the receiver library has been used"
    Libraries isNil ifTrue: [^false].
    ^Libraries includesKey: self symbol!
initialize
    "Private - Initialize the receiver..."

    (Smalltalk startUpObjects includes: Dynalink16)
    ifFalse: [
        Smalltalk
            notifyAtStartUp: Dynalink16;
            notifyAtExit: Dynalink16.
    ].
    Libraries isNil
    ifTrue: [ self initializeLibraries ]! 
initializeLibraries
    "Private - Initialize the Libraries dictionary"
    Libraries := Dictionary new!
initializeStructures
    "Private - Initializes the self defined structures for the DLL's.
    The format has to be somewhat like:

            self
                registerType: 'StructureName'
                as: #( ( fieldName fieldType ) - - - )

        fieldType must be one of the following:
                        byte,                        short,
                        ushort,                     long,
                        ulong,                      handle,
                        word,                        dword

    This metho can be refined by subclasses..."!   
library
    "Returns the only instance of the receiver needed
     This method must be used for proper handling
     of instances of the receiver.
     The startUp code initializes the result during
         Smalltalk startUp.
    This method returns nil if the library can't be found.
    *WARNING* instances returned by this method
         must NOT be released because it is done
         automatically or refreshing the receiver"

    Libraries isNil ifTrue: [self initialize].
    ^Libraries
        at: self symbol
        ifAbsent: [ self openLibrary ]!
openLibrary
    "Private - Returns an open instance of the receiver.
     The opened library will be registered into Libraries"
    | library |
    library := Libraries at: self symbol ifAbsent: [].
    library notNil
    ifTrue: [
        library release.
        Libraries removeKey: self symbol
    ].
    library := self open.
    library isNil
    ifFalse: [
        Libraries
            at: self symbol
            put: library
    ].
    ^library!  
refresh
    "Refresh the library used by the receiver.
     Returns the receiver.
     Ussefull to force reload of the receiver's
       library doing :
            MyDynalink refresh library
        will force the library to be released and reload
    "
    | library |
    Libraries isNil ifTrue: [^self]. "never used..."
    library := Libraries at: self symbol ifAbsent: [^nil].
    library release.
    Libraries removeKey: self symbol ifAbsent: []!
register: aTypeDef as: aStrucName
    "Private - Register a new SelfDefinedStructure with
    name aStrucName with type aTypeDef."

    SelfDefinedStructure
        define: aStrucName
        withFields: (self registerDictionaryFor: aTypeDef)! 
registerDictionaryFor: aTypeDef
    "Private - Returns the dictionary for building
     a new SelfDefinedStructure with type aTypeDef...
    aTypeDef is an array with the specification of the
     record as
        #( name type [rawType] )
     if rawType is not present #yourself will be assumed
    aType can be:
        one of #byte #short #ushort #long #ulong #handle #word #dword
        aSelfDefinedStructure name
        an array identifying a subArray structure (
            e.g:
                #(3 word) can be used for defining an array of 3 words
                #(5 'MyStructure') can be used for define an array of 5 selfDefinedSubstructures named MyStructure
                #(0 'MyStructure') for an open array of structures named MyStructure
                #(9 '*WinRectangle') for an array to nine pointers to WinRectangle structures
            )
    "
    | offset dicc types def sds itemSize count |
    offset := 0.
    dicc := Dictionary new.
    types := Dictionary new.
    types
        "sizes in bytes"
        at: #byte put: 1;
        at: #short put: 2;
        at: #ushort put: 2;
        at: #long put: 4;
        at: #ulong put: 4;
        at: #handle put: #ushort;
        "conversion table for comfortable settings..."
        at: #word put: #ushort;
        at: #dword put: #ulong;
        yourself.

    aTypeDef do: [:each|
        def := each copy.
        def size = 2 ifTrue: [def := def ,#(yourself)].
        sds := def at: 2.
        (#(word dword) includes: sds) ifTrue: [
            sds := types at: sds
        ].
        (sds isArray or: [ sds isMemberOf: String]) ifFalse: [
            (def at: 2) isNumber
            ifFalse: [
                [ (types at: (def at: 2)
                    ifAbsent: [^self error: 'Invalid type definition']) isSymbol ]
                whileTrue: [ def at: 2 put: (types at: (def at: 2)) ]
            ].
        ].
        dicc
            at: def first
            put: (Array
                with: offset
                with: sds
                with: def last).

        count := 1.
        sds := def at: 2.

        sds isArray ifTrue: [ "compute SDS-Array size in bytes..."
            count := sds first.
            sds := sds last.
        ].
        (sds isMemberOf: String) ifTrue: [ "compute SDS size in bytes..."
            sds := SelfDefinedStructure sizeInBytesFor: sds
        ].
        sds isInteger ifFalse: [
            sds := types at: sds ifAbsent: [ ^self error: 'Invalid Type def. ', sds ]
        ].

        offset := count * sds + offset.

        (count = 0 and: [ (each == aTypeDef last) not])
        ifTrue: [ ^self error: 'An open array must be the last field defined...' ].

    ].

    ^dicc!
registerType: aStrucName as: aDefinitionArray
    "Private - Register a new SelfDefinedStructure with
    name aStrucName with type aDefinitionArray.
    aDefinitionArray is an array with the specification of the
     record as
        #( name type [rawType] )
     if rawType is not present #yourself will be assumed
    "
    ^self register: aDefinitionArray as: aStrucName!  
startUp
    "Private - StartUp - Initializes the receiver's subclasses interfase"

    "Ignore old libraries..."
    self initializeLibraries.

    "The new libraries will be initialized when needed
        see the method #library...
    "

    "Set Alias name for compatibility with V32..."
    Smalltalk at: #Dynalink put: Dynalink16.!  
structureNamed: aName
    "Returns the structure named aName or nil if absent...
    This method is OSRecomended for building SDStructures..."

    ^self structureNamed: aName atAddress: nil "default sds creation"!
structureNamed: aName atAddress: anAddress
    "Returns the structure named aName or nil if absent...
    This method is OSRecomended for building SDStructures..."

    (SelfDefinedStructure definitions includesKey: aName)
    ifFalse: [ self initializeStructures ].
    (SelfDefinedStructure definitions includesKey: aName)
    ifFalse: [^nil ].
    ^anAddress isNil
        ifTrue: [ SelfDefinedStructure named: aName ]
        ifFalse: [ SelfDefinedStructure named: aName atAddress: anAddress]! !

! Dynalink16 methods !   
externalStructureNamed: aName
    "Returns the structure named aName
    at an external address or nil if absent...
    * Warning *
         Memory assosiated with this structure
         must be released with #free
    This method is OSRecomended for building SDStructures..."

    ^self class externalStructureNamed: aName! 
free
    "Private - Free the DLL."

    super free. "perform default action..."

    self fillFromAddress: NullHandle. "fill with null handle for non UAEs..."

    Libraries size > 0
    ifTrue: [
        Libraries removeKey: self class symbol ifAbsent: []
    ]! 
invalidArgument
    "Private - Initiate a walkback indicating an invalid argument."
    ^self isNull
    ifTrue: [self error: 'Has an Invalid handle']
    ifFalse: [super invalidArgument]!  
isNull
    "True if the receiver is Null or has an invalid handle"
    ^self = NullHandle!  
isValid
    "True if the receiver has a valid handle"
    ^self isNull not! 
release
    "Release the receiver"
    self free.
    ^super release!  
structureNamed: aSDSName
    "Returns the structure named aName or nil if absent...
    This method is OSRecomended for building SDStructures..."
    ^self class structureNamed: aSDSName!
withPointerTo: aByteObject do: aBlock
    "Evaluates aBlock (with one parameter)
     allocating aByteObject in external memory;
     then free allocated memory...
    This service is implemented for passing pointer
    references to an API. Note that you must declare
     the api entry as an ulong parameter..."

    | buffer bits result |
    bits :=
        (aByteObject isNil  | aByteObject isByteArray or: [ aByteObject isString ])
        ifTrue: [ aByteObject ]
        ifFalse: [ aByteObject contents ]. "SDS asummed"
    buffer := WinAddress copyToNonSmalltalkMemory: bits.
    result := aBlock value: buffer.
    buffer unlockAndFree.
    ^result! !

! ExtMemDLL class methods !   
fileName
        "Answer the receiver's file name."
     ^'wextm102.dll'!   
getErrorTextOfError: aNumber
    "Rckgabe des Fehlertextes "

    0 == aNumber ifTrue: [ ^'kein Fehler aufgetreten' ].
    101 == aNumber ifTrue: [ ^'101 : Start und Stop vertauscht : destFrom > destTo' ].
    102 == aNumber ifTrue: [ ^'102 : ein Grenzwert kleiner-gleich Null : destFrom <= 0, destTo <= 0, srcFrom <= 0' ].
    103 == aNumber ifTrue: [ ^'103 : Startwert (Dest) grer als Lnge : destSize < destFrom' ].
    104 == aNumber ifTrue: [ ^'104 : Endewert (Dest) grer als Lnge : destSize < destTo' ].
    105 == aNumber ifTrue: [ ^'105 : Startwert (Src) grer als Lnge : srcSize < (srcFrom+interval-1)' ].
    106 == aNumber ifTrue: [ ^'106 : Lngenangabe (Dest) falsch; Lngenangabe grer als vorhandener nonSmalltalkMemory :  dpSize = GlobalSize ( destObject ) ; destSize > dpSize' ].
    107 == aNumber ifTrue: [ ^'107 : Lngenangabe (Src) falsch; Lngenangabe grer als vorhandener nonSmalltalkMemory :  spSize = GlobalSize ( srcObject ) ; srcSize > spSize' ].
    ^'kein gltiger Fehlercode'! !

! ExtMemDLL methods !
getErrorTextOfError: aNumber
    "Rckgabe des Fehlertextes "

    ^self class getErrorTextOfError: aNumber!   
replace: destObject
    destSize: destSize
    from: begin
    to: end
    with: srcObject
    srcSize: srcSize

    <api: REPLACEFROMTO struct ulong ulong ulong struct ulong long>
    ^self invalidArgument!   
replace: destObject
    destSize: destSize
    from: destFrom
    to: destTo
    with: srcObject
    srcSize: srcSize
    startingAt: srcFrom

    <api: REPLACEFROMTOWITHSTARTINGAT struct ulong ulong ulong struct ulong ulong long>
    ^self invalidArgument!
replaceHuge: destObject
    destSize: destSize
    from: destFrom
    to: destTo
    with: srcObject
    srcSize: srcSize
    startingAt: srcFrom

    <api: REPLACEHUGE ushort ulong ulong ulong ushort ulong ulong long>
    ^self invalidArgument!
replaceLarge: destObject
    destSize: destSize
    from: destFrom
    to: destTo
    with: srcObject
    srcSize: srcSize
    startingAt: srcFrom

    <api: REPLACELARGE struct ulong ulong ulong struct ulong ulong long>
    ^self invalidArgument! !

! HaloImagingDLL class methods !
initializeStructures
    "Private - Initializes the structures for the interface
       HaloImagingDLL initializeStructures
    "
    self
        registerType: 'HilFpb'  "File Parameter Block"
        as: #(
            (library ulong)
            (width short)
            (height short)
            (imageClass short)
            (bits short)
            (compression short)
            (handle ushort)
            (sequence short)
        );
        registerType: 'HilTrack'
        as: #(
            (trackProc ulong)
            (caption ulong)
        );
        registerType: 'IFFIOM'
        as: #(
            (pos ulong)
            (alloced ulong)
            (length ulong)
            (data ulong)
        ).! !

! IffBmpDLL class methods !  
fileName
        "Answer the receiver's file name."
     ^'IffBmp.dll'
    "Modified: 10/25/93 / 03:11:18 PM / XAVA"! !

! IffBmpDLL methods !   
a
    "Found in DLL by TurboDump but not in .H

    IFFPUTLINE
    IFFCONTROL
    IFFCLOSE
    IFFSEEK
    IFFGETLINE
    IFFOPEN
"
    "Modified: 11/01/93 / 03:19:32 PM / XAVA"! !

! IffEpsDLL class methods ! 
fileName
        "Answer the receiver's file name."
     ^'IffEps.dll'
    "Modified: 10/25/93 / 03:11:06 PM / XAVA"! !

! IffEpsDLL methods !   
a
    "Found in DLL by TurboDump but not in .H

    IFFPUTLINE
    IFFCONTROL
    IFFCLOSE
    IFFSEEK
    IFFGETLINE
     IFFOPEN
"
    "Modified: 11/01/93 / 03:19:44 PM / XAVA"! !

! IffGifDLL class methods !
fileName
        "Answer the receiver's file name."
     ^'IffGif.dll'
    "Modified: 10/25/93 / 03:10:54 PM / XAVA"! !

! IffGifDLL methods !   
a
    "Found in DLL by TurboDump but not in .H

    IFFPUTLINE
    IFFCONTROL
    IFFCLOSE
    IFFSEEK
    IFFGETLINE
     IFFOPEN
"
    "Modified: 11/01/93 / 03:22:16 PM / XAVA"! !

! IffHCutDLL class methods !   
fileName
        "Answer the receiver's file name."
     ^'IffHCut.dll'
    "Modified: 10/25/93 / 03:10:44 PM / XAVA"! !

! IffHCutDLL methods ! 
a
    "Found in DLL by TurboDump but not in .H

    IFFPUTLINE
    IFFCONTROL
    IFFCLOSE
    IFFSEEK
    IFFGETLINE
     IFFOPEN
"
    "Modified: 11/01/93 / 03:37:19 PM / XAVA"! !

! IffJpegDLL class methods !   
fileName
        "Answer the receiver's file name."
     ^'IffJpeg.dll'
    "Modified: 10/25/93 / 03:10:35 PM / XAVA"! !

! IffJpegDLL methods ! 
a
    "Found in DLL by TurboDump but not in .H

    IFFPUTLINE
    IFFCONTROL
    IFFCLOSE
    IFFSEEK
    IFFGETLINE
     IFFOPEN
"
    "Modified: 11/01/93 / 03:38:12 PM / XAVA"! !

! IffPcxDLL class methods !
fileName
        "Answer the receiver's file name."
     ^'IffPcx.dll'
    "Modified: 10/25/93 / 03:10:25 PM / XAVA"! !

! IffPcxDLL methods !   
a
    "Found in DLL by TurboDump but not in .H

    IFFPUTLINE
    IFFCONTROL
    IFFCLOSE
    IFFSEEK
    IFFGETLINE
     IFFOPEN
"
    "Modified: 11/01/93 / 03:38:57 PM / XAVA"! !

! IffPictDLL class methods !   
fileName
        "Answer the receiver's file name."
     ^'IffPict.dll'
    "Modified: 10/25/93 / 03:10:14 PM / XAVA"! !

! IffPictDLL methods ! 
a
    "Found in DLL by TurboDump but not in .H

    IFFPUTLINE
    IFFCONTROL
    IFFCLOSE
    IFFSEEK
    IFFGETLINE
     IFFOPEN
"
    "Modified: 11/01/93 / 03:39:34 PM / XAVA"! !

! IffRasDLL class methods !
fileName
        "Answer the receiver's file name."
     ^'IffRas.dll'
    "Modified: 10/25/93 / 03:10:02 PM / XAVA"! !

! IffRasDLL methods !   
a
    "Found in DLL by TurboDump but not in .H

    IFFPUTLINE
    IFFCONTROL
    IFFCLOSE
    IFFSEEK
    IFFGETLINE
     IFFOPEN
"
    "Modified: 11/01/93 / 03:40:25 PM / XAVA"! !

! IffTgaDLL class methods !
fileName
        "Answer the receiver's file name."
     ^'IffTga.dll'
    "Modified: 10/25/93 / 03:09:53 PM / XAVA"! !

! IffTgaDLL methods !   
a
    "Found in DLL by TurboDump but not in .H

    IFFPUTLINE
    IFFCONTROL
    IFFCLOSE
    IFFSEEK
    IFFGETLINE
     IFFOPEN
"
    "Modified: 11/01/93 / 03:41:11 PM / XAVA"! !

! IffTiffDLL class methods !   
fileName
        "Answer the receiver's file name."
     ^'IffTiff.dll'
    "Modified: 10/25/93 / 03:09:39 PM / XAVA"! !

! IffTiffDLL methods ! 
a
    "Found in DLL by TurboDump but not in .H

    IFFPUTLINE
    IFFCONTROL
    IFFCLOSE
    IFFSEEK
    IFFGETLINE
     IFFOPEN
"
    "Modified: 11/01/93 / 03:41:52 PM / XAVA"! !

! HiFflDLL class methods ! 
fileName
        "Answer the receiver's file name."
     ^'HiFfl.dll'
    "Modified: 10/25/93 / 03:13:04 PM / XAVA"! !

! HiFflDLL methods ! 
hifflClose: fileParameterBlock
    "Closes the file specified by the fileParameterBlock parameter. After
    calling this function, the fileParameterBlock can be released."
    "Note: this function is distinct from the hilImClose function which
    close image instances, not FILES."

    <api: HifflClose struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 11:34:48 AM / XAVA"!  
hifflControl: fileParameterBlock command: command sParam: sParam lParam: lParam pParam: pParam
    "Function used to execute format-specific operations.  Operation is
    specified by the command parameter.
    The next three parameters are general purpose.  The values for these
    parameters will vary depending upon the specified command.  Look
    for the IffCmd..."

    <api: HifflControl struct short short long struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 11:40:07 AM / XAVA"!   
hifflIdentify: fileName bFile: aBoolean
    "Determines the file format of a file or memory file."
    "aBoolean if true the fileName is a file,
                        if false the fileName is a memory file."

    " Patched & Rerouted by Ale to HilDisp...
    <api: HifflIdentify struct short ulong>
    ^self invalidArgument
    "
    ^self hifflIdentify: (aBoolean ifTrue: [ fileName ] ifFalse: [ fileName asParameter16 ])
        size: fileName size
        bFile: aBoolean! 
hifflIdentify: fileName size: anInteger bFile: aBoolean
    "Determines the file format of a file or memory file."
    "aBoolean if true the fileName is a file,
                        if false the fileName is a memory file."

    " Patched & Rerouted by Ale to HilDisp...
    <api: HifflIdentify struct short ulong>
    ^self invalidArgument
    "
    | result library |
    library := HiLDispDLL library.
    result := library identifyFormat: fileName size: anInteger  bFile: aBoolean.
    library checkError.
    ^result! 
hifflOpen: fileParameterBlock fileName: fileName mode: mode
    "Opens the file, and initializes the specified fileParameterBlock."
    "mode can be either IffmRead or IffmWrite"

    <api: HifflOpen struct struct short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 11:31:31 AM / XAVA"! 
hifflRead: fileParameterBlock lineBuffer: buffer numLines: lines
    "Reads one or more image lines from the file."

    <api: HifflRead struct struct short  short>
    ^self invalidArgument
    "Modified: 10/26/93 / 11:21:22 AM / XAVA"!
hifflSeek: fileParameterBlock line: line
    "Moves the internal pointer to the line specified in the first parameter,
    so that the next call to hifflRead will return that line.
    This function is only available when the file is open for read."

    <api: HifflSeek struct short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 11:17:24 AM / XAVA"!
hifflWrite: fileParameterBlock lineBuffer: buffer numLines: lines
    "Writes one or more image lines to the file."

    < api: HifflWrite struct struct short short >
    ^self invalidArgument
    "Modified: 10/26/93 / 11:20:17 AM / XAVA"! !

! HiLConvDLL class methods !
fileName
        "Answer the receiver's file name."
     ^'HiLConv.dll'
    "Modified: 10/25/93 / 03:12:54 PM / XAVA"! !

! HiLConvDLL methods ! 
hilApplyLutChunks: to from: from lut: lut width: width
    "Applies the Response Lookup table to RGB chunky data"

    <api: HilApplyLutChunks struct struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:02:10 PM / XAVA"!
hilApplyLutFloat:to from: from lut: lut width: width lpRange: lpRange
    "Applies the Response Lookup table to a line of floating-point data."

    <api: HilApplyLutFloat struct struct struct ushort struct none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:03:16 PM / XAVA"!
hilApplyLutGray: to from: from lut: lut width: width
    "Applies the Response Lookup table to a line of a gray scale
    data."

    <api: HilApplyLutGray struct struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:04:26 PM / XAVA"!  
hilApplyLutGray12: to from: from lut: lut width: width
    "Applies the Response Lookup table to a line of 12-bit gray scale
    data."

    <api: HilApplyLutGray12 struct struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:04:26 PM / XAVA"! 
hilApplyLutGrayTo: to from: fromAddr lut: lut width: width
    "Applies the Response Lookup table to a line of a gray scale
    data..
    Implemented by Ale for support of fromAddr
     as a longInteger or string pointing to the source structure"

    <api: HilApplyLutGray struct ulong struct ushort none>
    ^self invalidArgument! 
hilChunksToFloat: to from: from width: width lprange: lprange
    "Converts a line of RGB chunky values to Gray Scale 12-bit values
    (luminance values)."

    <api: HilChunksToFloat struct struct ushort struct none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:04:57 PM / XAVA"! 
hilChunksToGray12: to from: from width: width
    "Converts a line of RGB chunky values to Gray Scale 12-bit values
    (luminance values)."

    <api: HilChunksToGray12 struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:05:10 PM / XAVA"!   
hilChunksToPlanes: to from: from width: width
    "Converts a line of RGB-chunky data to RGB planar data."

    <api: HilChunksToPlanes struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:05:30 PM / XAVA"!  
hilColorReduce: iiInst start: start colors: colors lpTrack: lpTrack
    "Converts an image to IMC_PALETTE class and creates a palette with
    the specified number of colors. Palette is filled with the colors that
    occur most frequently in the image (e.g., if 50 colors were specified,
    the 50 most popular colors would be put into the palette)."

    <api: HilColorReduce ushort ushort ushort struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:09:10 PM / XAVA"!
hilConvert: iiInst class: class lpTrack: lpTrack
    "Converts an image to the specified class"

    "This function will create a new virtual image.
    Converting an image to the same class is equivalent to duplicating it.
    class is defined as follows:

    class               description
    IMC_BILEVEL Each pixel is represented by a single bit (1 BPP)
    IMC_GRAY        A pixel is represented by 1 byte (8 BPP)
    IMC_PALETTE A pixel contains a 1 byte index to a palette table.
                                Each entry in the palette table contains the RGB
                                values for that index.  An IMC_PALETTE image can
                                contain up to 256 color, selected from 16.7 million
                                posible colors.
    IMC_RGB         A pixel is represented by 3 bytes (24 BPP); 1 byte
                                for the Red Channel, 1 byte for the Green Channel,
                                and 1 byte for the Blue Channel.  Also called,
                                RGB-chunky, or 'chunky' "

    < api: HilConvert ushort short struct short >
    ^self invalidArgument!  
hilDither: iiInst halftoneStyle: aStyle halftoneOption: anOption lpTrack: lpTrack
    "Converts an image to IMC_BILEVEL, using the specified halftoning method"
    "The halftoneStyle must be one of the following:
        DtrAngleDot, DtrFlatDot, DtrAngleLine, DtrHorzLine, DtrVertLine,
        DtrErrDiff, DtrThreshold or a custom defined style."
    "The halftonOption must be a value from 0 to 3 inclusive.
        For DtrErrDiff this value specifies the error difusion method to apply
        0   Floyd Steinberg (4 Weights)
        1   Stucki (12 Weights)
        2   Floyd Steinberg (Fuzzy)
        3   Random White Noise
        For DtrThreshold this value is ignored."

    <api: HalftoneStyle ushort ushort ushort struct short>
    ^self invlaidArgument!  
hilDtrAddHalftone: kernelSize lpPattern: lpPattern
    "Adds a custom halfton style to the library."
    "Answers the positive halftone style if succesful, -1 if failed"

    <api: HilDtrAddHalftone struct struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 10:39:11 AM / XAVA"!
hilDtrClose: hDtr
    "Closes dither library and releases the allocated buffer"

    <api: HilDtrClose ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 10:40:02 AM / XAVA"! 
hilDtrGetStyles
    "Returns the number of haltone style currently available in the
    Halftone Library."

    <api: HilDtrGetStyles short>
    ^self invalidArgument!  
hilDtrLine: hDtr to: to from: from width: width
    "Dithers a line of IMC_GRAY or IMC_RGB image data."

    <api: HilDtrLine ushort struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:13:42 PM / XAVA"! 
hilDtrOpen: halftoneStyle halftoneOption: halftoneOption class: class width: width
    "Initializes the dither library and allocates buffers."

    <api: HilDtrOpen ushort ushort short ushort short>
    ^self invalidArgument! 
hilDtrRemoveHalftone: halfTone
    "Removes a custom-defined halftone style from the Halftone library."
    "Answers true if succesful, false if error"

    <api: HilDtrRemoveHalftone ushort boolean>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:14:23 PM / XAVA"!
hilFloatToChunks: to from: from width: width lpRange: lpRange
    "Converts a line of floating-point values to RGB chunky values
    (luminance values)."

    <api: HilFloatToChunks struct struct ushort struct none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:14:45 PM / XAVA"!
hilFloatToGray12: to from: from width: width lpRange: lprange
    "Converts a line of Floating-point values to Gray Scale 12-bit values."

    <api: HilFloatToGray12 struct struct ushort struct none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:15:09 PM / XAVA"! 
hilGray12ToChunks: lpChunks from: lpGray12 width: width
    "Converts a line of 12-bit, gray scale values to RGB chnuky values
    (luminance values)."

    <api: HilGray12ToChunks struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:15:36 PM / XAVA"!
hilGray12ToFloat: to from: from width: width lpRange: lpRange
    "Converts a line of 12-bit, gray scale values to RGB chunky values
    (luminance values)."

    <api: HilGray12ToFloat struct struct ushort struct none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:15:51 PM / XAVA"!
hilGray12ToGray: to from: from width: width
    "Converts a line of 12-bit, gray scale values to 8-bit, gray scale values."

    <api: HilGray12ToGray struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:16:46 PM / XAVA"!   
hilGrayToChunks: lpChunks lpGray: lpGray width: width
    "Converts a line of Gray Scale values to RGB values (luminance values)."

    <api: HilGrayToChunks struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:17:12 PM / XAVA"!
hilGrayToFloat: to from: from width: width lpRange: lpRange
    "Converts a line of Gray Scale values to floating-point values."

    <api: HilGrayToFloat struct struct ushort struct none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:17:38 PM / XAVA"!
hilGrayToGray12: to from: from width: width
    "Converts a line of Gray Scale values to Gray Scale 12-bit values."

    <api: HilGrayToGray12 struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:17:48 PM / XAVA"!   
hilMColor: iiInst lpTrack: lpTrack
    "Converts an image to IMC_PALETTE class using the standard
    MColor palette."

    <api: HilMColor ushort struct short>
    ^self invalidArgument!  
hilMColorClose: lpBuffer
    "Unlocks and frees MColor buffer."

    <api: HilMColorClose struct none>
    ^self invalidArgument
    "Modified: 10/26/93 / 10:51:44 AM / XAVA"!  
hilMColorLine: to from: from width: width
    "Converts an RGB-chunky image line to MColor palette data."

    <api: HilMColorLine struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:19:29 PM / XAVA"!   
hilMColorOpen: aWidth
    "Allocates memory buffer for MColoring."

    <api: HilMColorOpen ushort short>
    ^self invalidArgument!  
hilPackBits: to from: from length: length threshold: threshold startBit: startBit
    "Packs a byte into a bit by comparing the bytes value to a specified threshold.
    Values greater or equal to the threshold will set the bit to 1; byte values less
    than the threshold set the bit to 0."
    "startBit is a number from 0 to 7 (inclusive) which specifies the bit position
                    in the destination buffer into which the first byte of the source buffer
                    will be packed.
                    0 corresponds to the most significant bit in the destination buffer."

    <api: HilPackBits struct struct ushort ushort ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:21:11 PM / XAVA"!
hilPaletteToChunks: to from: from palette: palette width: width
    "Converts a line of IMC_PALETTE data to IMC_RGB.  Pixel depth will
    incresae from 8 BPP to 24 BPP."

    <api: HilPaletteToChunks struct struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:21:28 PM / XAVA"! 
hilPlanesToChunks: to from: from width: width
    "Converts a line of RGB image data from planar to chunky."

    <api: HilPlanesToChunks struct struct ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:21:40 PM / XAVA"!
hilShiftBits: to from: from toPix: toPix bitOffset: bitOffset
    "Shifts the bits in a buffer to the left."

    <api: HilShiftBits struct struct ushort ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:22:04 PM / XAVA"!  
hilShiftBitsTo: to from: fromAddr toPix: toPix bitOffset: bitOffset
    "Shifts the bits in a buffer to the left.
    Implemented by Ale for support of fromAddr
     as a longInteger or string pointing to the source structure"

    <api: HilShiftBits struct ulong ushort ushort none>
    ^self invalidArgument!  
hilUnpackBits: to from: from length: length startBit: startBit
    "Unpack bits to bytes using normalized format.  A 0 will generate
    a byte with a 0 value; a bit 1 will generate a byte with value 255."
    "startBit is a number from 0 to 7 (inclusive) which specifies the
                    bit from which to start unpacking.  0 corresponds to the
                    most significant bit in the first byte of the source buffer."

    <api: HilUnpackBits struct struct ushort ushort none>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:22:19 PM / XAVA"! !

! HiLDispDLL class methods ! 
fileName
        "Answer the receiver's file name."
     ^'HiLDisp.dll'! !

! HiLDispDLL methods !
checkError
    "Generates an error if the library has failed..."

    self lastError = 0 ifTrue: [ ^self].
    ^self error: self class name,' : ',self lastErrorString!   
createDibFor: iiInst zoomFactor: integer hDC: aDC
    "Given and image instance compatible with dc aDC...
    If ZoomFactor < 1, we need to scale the image before copying to the dib...
    Returns a handle to a memory DIB.
    The memory MUST be released by the caller..."

    | bpp |
    bpp := (GDILibrary getDeviceCaps: aDC index: Bitspixel)
            * (GDILibrary getDeviceCaps: aDC index: Planes).
    bpp < 8 ifTrue: [ bpp := 8 ].
    ^self createDibFromInst: iiInst zoomFactor: integer memFlag: 0 bpp: bpp!   
createDibFromInst: iiInst zoomFactor: integer memFlag: word bpp: bpp
    "Given and image instance, this function converts it to 1,8,or 24 bit DIB.
    IMC_GRAY and IMC_PALETTE will both convert to 8 bit DIB (the difference is in the color definition).
    If ZoomFactor < 1, we need to scale the image before copying to the dib...
    Returns a handle to a memory DIB.
    The memory MUST be released by the caller..."

    <api: CreateDibFromInst ushort ushort short ushort ushort>
    ^self invalidArgument!
display: hImage hDC: hDC zoomFactor: zoomFactor at: aPoint into: aRectangle
    "Display a Virtual image into hDC..."

    <api: HilDisplay ushort ushort short struct struct ushort>
    ^self invalidArgument!  
identifyFormat: szFileName size: anInteger bFile: aBoolean
    "Returns the address of the format autodetected for file in szFileName.
    if bFile is false szFileName is treated as a memory file address handle..."

    <api: IdentifyFormat struct ulong ushort long>
    ^self invalidArgument!
lastError
    "Returns the last display error number (zero for no error)..."

    "Patched until errors implemented...
    <api: LastDispError ushort>
    ^self invalidArgument
    "
    ^0 "actually don't  consider errors..."!
lastErrorString
    "Returns the last display error string..."

    | number errors |
    number := self lastError.
    number = 0 ifTrue: [ ^'No Display error.' ].

    errors := #(
        'Undefined Error' 'Not Implemented. Yet...' 'Not Fully Implemented.'
        'Zero Width' 'Zero Height'
        'Can''t Allocate DIB' 'Can''t Allocate Palette'
        'File format error'
    ).
    ^(number between: 1 and: errors size)
        ifTrue: [ errors at: number ]
        ifFalse: [ 'Invalid error return' ]! 
loadMemoryImage: bytes size: chunkSize fileFormat: fileFormat lpTrack: lpTrack
    "Loads a memory file into a virtual image."

    <api: LoadMemoryImage struct ulong struct struct short>
    ^self invalidArgument! !

! HiLEnhDLL class methods !   
fileName
        "Answer the receiver's file name."
     ^'HiLEnh.dll'
    "Modified: 10/25/93 / 03:12:46 PM / XAVA"! !

! HiLEnhDLL methods !   
hilBlur: iiInst strength: strength lpTrack: lpTrack
    "Blurs the image by de-emphasizing (softening) the edges in the image."

    <api: HilBlur ushort ushort struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:25:08 PM / XAVA"!  
hilDespeckle: iiInst cellSize: cellSize sensitivity: sensitivity lpTrack: lpTrack
    "Removes 'noise' from the image instance.  Noise is defined as any
    pixel that exceeds the median kernel value by more that the specified
    sensitivity."
    "cellSize is a number 3, 5, or 7."

    <api: HilDespeckle ushort ushort ushort struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:25:42 PM / XAVA"!   
hilFilter: iiInst filterType: filterType lpTrack: lpTrack
    "Applies one of 14 convolution filters to the image instance."
    "filterType must be one of the following:
        FltEdgeThin
        FltEdgeThick
        FltEdgeHorz
        FltEdgeVert
        FltSculptAbove
        FltSculptLeft
        FltSculptDiag
        FltSculptMetal
        FltEmbossAbove
        FltEmbossLeft
        FltEmbossDiag
        FltLineHorz
        FltLineVert
        FltLineBoth"

    <api: HilFilter ushort short struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:27:08 PM / XAVA"!
hilHistEq: iiInst method: method
    "Equalizes the image instance using the specified equalization method."
    "The equalization method must be one of the following:
            EqBestFit
            EqLinear
            EqBell
            EqLogarithmic
            EqExponential"

    <api: HilHistEq ushort short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:28:51 PM / XAVA"!   
hilInvert: iiInst bRed: bRed bGreen: bGreen bBlue: bBlue lpTrack: lpTrack
    "Inverts the gray values of the specified color channels in an image."

    <api: HilInvert ushort boolean boolean boolean struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:29:31 PM / XAVA"!  
hilLutApply: iiInst lpTrack: lpTrack
    "Applies the Response Lookup Table to the instance, then resets the
    BCGM structure and the Response Lookup table."

    <api: HilLutApply ushort struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:29:49 PM / XAVA"!
hilMerge: iiInstDst iiSrc: iiInstSrc operation: operation lpTrack: lpTrack
    "Merges two instances of the same image class"
    "The operation must be one of the following:
        ImmCopy     Replace the destination image with the source image.
        ImmAnd      AND the destination image with the source image.
        ImmOr           OR the destination image with the source image.
        ImmNand     NAND the destination image with the source image.
        ImmNor          NOR the destination image with the source image."
    "Note: for ImcPalette images the results of ANDing, ORing, etc are
    unpredictable because they will be operating upon the indeces of the
    palette, not on the actual color values."

    <api: HilMerge ushort ushort short struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:31:04 PM / XAVA"!   
hilPixelize: iiInst bRed: bRed bGreen: bGreen bBlue: bBlue tileWidth: tileWidth tileHeight: tileHeight lpTrack: lpTrack
    "Tiles the image instance into a visually lower resolution."
    "The bRed, bGreen and bBlue are booleans that specify wether the RGB
    correspondant channel is to be tiled or not."

    <api: HilPixelize ushort boolean boolean boolean ushort ushort struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:31:43 PM / XAVA"! 
hilPosterize: iiInst bRed: bRed bGreen: bGreen bBlue: bBlue bitDepth: bitDepth lpTrack: lpTrack
    "Reduces the number of levels in a color channel by retaining the
    specified number of most significant bits, and setting the remaining
    low order bits to 0."
    "The bRed, bGreen and bBlue booleans specify to posterize the corresponding channels"

    <api: HilPosterize ushort boolean boolean boolean ushort struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:32:29 PM / XAVA"!   
hilSharpen: iiInst strength: strength lpTrack: lpTrack
    "Sharpens the image by accentuating the edges in the image."
    "strength is a number form 0 to 10 (inclusive) indicating
                    the amount of sharpening to perform.  0 sharpens
                    slightly, 10 sharpens heavily."

    <api: HilSharpen ushort ushort struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:33:02 PM / XAVA"! !

! HiLimMgrDLL class methods !  
fileName
        "Answer the receiver's file name."
     ^'HiLimMgr.dll'
    "Modified: 10/25/93 / 03:11:46 PM / XAVA"! !

! HiLimMgrDLL methods !   
a
    "Found in DLL by TurboDump but not in .H
         IMGMGRLINEADDR
         IMGMGRCLOSE
         RESTOREFROMUNDO
         DESTROYUNDO
         IMGMGROPEN
         PUTLINEINUNDO
         IMGMGRINQUIREINSTANCE
         IMGMGRCONTROLINSTANCE
         UNDOINIT
         IMGMGRGETLINE
         GETUNDOHANDLE
         IMGMGRINQMEMREQ
         IMGMGRINQUIRE
         ISLINEINUNDO
         ALLOCATEUNDO
         GETUNDORECT
         IMGMGRCONTROL
         IMGMGRREOPEN
         IMGMGRDESTROY
         ENABLEUNDO
"

    "Modified: 10/26/93 / 02:37:50 PM / XAVA"! 
hilAlloc: flag size: size
    "Non-Documented API"


"LPVOID  HILAPI HilAlloc(WORD Flag, DWORD Size)"
    ^self error
    "Modified: 10/26/93 / 01:48:14 PM / XAVA"!
hilFree: mem
    "Non-Documented Api"


"void    HILAPI HilFree(LPVOID Mem)"
    ^self error
    "Modified: 10/26/93 / 02:15:22 PM / XAVA"! 
hilGammaToIndex: gamma
    "Converts a real Gamma value to an index into HIL's predefined set of
    Gamma tables."

    <api: HilGammaToIndex ulong short>
    ^self invalidArgument
    "Modified: 10/26/93 / 02:34:53 PM / XAVA"!
hilGetGammaTable: table gammaIndex: gammaIndex
    "Gets the gamma Table for the specified Gamma Index."

    <api: HilGetGammaTable struct short boolean>
    ^self invalidMessage
    "Modified: 10/26/93 / 01:38:32 PM / XAVA"!   
hilGetGammaTableSize
    "Gets the number of Gamma tables currently provided in HIL's
    predefined set of Gamma tables."

    <api: HilGetGammaTableSize short>
    ^self invalidArgument
    "Modified: 10/26/93 / 01:22:09 PM / XAVA"!  
hilImClose: iiInst
    "Closes an image instance.
    Note: this function is distinct from hifflClose function which closes
    image FILES not instances."

    <api: HilImClose ushort short>
    ^self invalidArgument
    "Modified: 10/26/93 / 02:32:41 PM / XAVA"!   
hilImControl: ihImage command: command sParam: sParam lParam: lParam pParam: pParam
    "Used to get and set image attributes using the virtual image handle.
    The attribute, and the operation to be performed upon it, are specified
    by the command parameter.
    The next three parameters are general purpose.  The values for these
    parameters will vary depending upon the specified command.
    Look for ImcCmd..."

    <api: HilImControl ushort short short long struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 01:00:15 PM / XAVA"!  
hilImControlInst: iiInst command: command sParam: sParam lParam: lParam pParam: pParam
    "Used to get and set image attributes using the image instance handle.
    The attribute, and the operation to be performed upon it, are specified
    by the command paramater.
    The next three parameters are general purpose.  The values for these
    parameters will vary depending upon the specified command.  Look
    for the ImCmd..."

    <api: HilImControlInst ushort short short long struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 02:05:30 PM / XAVA"!  
hilImCreate: width height: height class: class lpTrack: lpTrack
    "Creates a virtual image in memory."
    "class has to be one of the following:
            ImcBilevel
            ImcGray
            ImcPalette
            ImcRGB"

    <api: HilImCreate short short short struct short>
    ^self invalidArgument!  
hilImDestroy: ihImage
    "Destroys a virtual image in memory.  Must be performed when all
    access to the virtual image is complete."

    <api: HilImDestroy ushort short>
    "Modified: 10/26/93 / 02:27:13 PM / XAVA"!
hilImGetColumn: iiInst column: column buffer: buffer command: command
    "Gets a column of image data from an image instance and puts it in
    a buffer.  Optionally, you may normalize image data placed in the
    buffer."
    "mode must be one of the following:
        ImglCopy        Copy image data without expanding
                                    (unpacking) or normalizing them.
        ImglNormal  For ImcBilevel, expands data to 1 byte
                                per pixel and presente them in normalized
                                format: 0 values will be normalized to 0,
                                1 values will be normalized to 255.
                                For ImcGray12 and ImcFloat normalizes
                                data to the range 0 to 255."

    <api: HilImGetColumn ushort ushort struct short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:39:14 PM / XAVA"! 
hilImGetImageAddr: iiInst
    "Returns the address of a Direct Access virtual image."

    <api: HilImGetImageAddr ushort ushort>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:39:55 PM / XAVA"!   
hilImGetLine: iiInst line: line buffer: buffer command: command
    "Gets a line of image data from an image instace and puts it in a
    buffer.  Optionally, you may normalize ImcBilevel image data placed in the buffer."
    "command must be one of the following:
            ImglCopy        Copy an image data without expanding
                                        (unpacking) or normalizing it.
            ImglNormal  Expand ImcBilevel data to 1 byte per
                                    pixel and present it in normalized format:
                                    0 values will be normalized to 0,
                                    1 values will be normalized to 255.
                                    This parameter has no effect on other
                                    image classes."

    <api: HilImGetLine ushort ushort struct short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:40:20 PM / XAVA"!
hilImGetPolyLineSize: iiInst lpPoints: lpPoints count: count lpPixelSize: lpPixelSize lpByteSize: lpByteSize mode: mode
    "Gets the size of the buffer needed for the polyline drawing in pixels
    and bytes."
    "mode must be one of the following:
        ImglCopy
        ImglNormal"

    <api: HilImGetPolyLineSize ushort struct ushort struct struct short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:41:03 PM / XAVA"! 
hilImGetProp: ihImage id: id lpProperty: lpProperty
    "Gets the property data from a virtual image."

    <api:HilImGetProp ushort short struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 02:25:18 PM / XAVA"!
hilImGetPropInst: iiInst id: id lpProperty: lpProperty
    "Gets the property data from an image instance."

    <api: HilImGetPropInst ushort short struct short>
    ^self invalidArgument
    "Modified: 10/26/93 / 01:34:51 PM / XAVA"!  
hilImHandle: iiInst
    "Gets the handle of the virtual image associated with the specified
    image instance."

    <api: HilImHandle ushort short>
    ^self invalidArgument! 
hilImInqMemReq: width height: height bpp: bpp
    "Non-Documented API"
"Guessing what it does:
    Answers the memory requirements in bytes that needs
    an image of width x height pixels with bpp bytes per pixel."

    <api: HilImInqMemReq short short short ulong>
    ^self invalidArgument
    "Modified: 10/26/93 / 01:32:16 PM / XAVA"!   
hilImLineAddr: iiInst line: line
    "Gets the starting address of an image line in an instance."
    " *WARING* Check documentation for sequential access."

    <api: HilImLineAddr ushort ushort ulong>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:42:56 PM / XAVA"! 
hilImOpen: ihImage access: access lpRect: lpRect
    "Opens an image instance on the virtual image."
    "access must be one of the following:
            ImaRdNoCache    Open for Read Only access; disable caching.
            ImaRdOnly             Open for Read Only.
            ImaRdWr                Open for Read and Write access."

    <api: HilImOpen ushort short struct short>
    ^self invalidArgument!   
hilImPutColumn: iiInst column: column buffer: buffer command: command
    "Writes a column of image data from a user buffer to an image
    instance.  Optionally, data can be unnormalized before being
    written to the instance."
    "command must be one of the following:
            ImplCopy
            ImplNormal"

    <api: HilImPutColumn ushort ushort struct short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:44:47 PM / XAVA"! 
hilImPutLine: iiInst line: line buffer: buffer command: command
    "Writes a line of image data from a user buffer to an image instance.
    Optionally, ImcBilevel data can be normalized before it is written
    to the instance."
    "mode must be one of the following:
        ImplCopy        Copy image data without expanding
                                    (unpacking) or normalizing it.
        ImplNormal  Packs normalized ImcBilevel data to 1 bit
                                per pixel before writing it to the insatnce.
                                0 values will be normalized to 0,
                                255 values will be normalized to 1.
                                This parameter has no effect on other image
                                classes."

    <api: HilImPutLine ushort ushort struct short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:45:29 PM / XAVA"! 
hilImPutPolyLine: iiInst lpPoints: lpPoints count: count buffer: buffer bufSize: bufSize mode: mode
    "Writes image data from a user buffer to an image instance.  The
    buffer indicates pixel values under a polyline."
    "mode must be one of the following:
            ImplCopy
            ImplNormal"

    <api: HilImPutPolyLine ushort struct ushort struct ushort short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:45:56 PM / XAVA"!  
hilImRemoveProp: ihImage id: id
    "Remove a property from a property link list maintained in the
    virtual image."

    <api: HilImRemoveProp ushort short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 02:29:21 PM / XAVA"!  
hilImRemovePropInst: iiInst id: id
    "Remove a property from a temporary property link list maintained
    in the image instance."

    <api: HilImRemovePropInst ushort short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 01:50:54 PM / XAVA"!
hilImSetProp: ihImage property: property propertySize: propertySize id: id
    "Attaches a memory buffer to a property link list maintained in the
    virtual image."
    " *WARNING* the order of the parameters matches de .H file
        not the documentation."
"IMERROR HILAPI HilImSetProp(IMHANDLE ihImage, LPVOID Property, WORD PropertySize, short Id)"

    <api: HilImSetProp ushort struct ushort short short>
    ^self invalidAtribute
    "Modified: 10/26/93 / 04:49:10 PM / XAVA"!   
hilImSetPropInst: iiInst property: property propertySize: propertySize id: id
    "Attaches a memory buffer to a property link list maintained in the
    image instance."
    " *WARNING* the order of the parameters matches de .H file
        not the documentation."
"IMERROR HILAPI HilImSetPropInst(IMINST iiInst, LPVOID Property, WORD PropertySize, short Id)"

    <api: HilImSetPropInst ushort struct ushort short short>
    ^self invalidArgument
    "Modified: 10/26/93 / 04:50:23 PM / XAVA"!  
hilIndexToGamma: gammaIndex
    "Converts a Gamma Index into a real Gamma value."

    <api: HilIndexToGamma short ulong>
    ^self invalidArgument
    "Modified: 10/26/93 / 01:02:44 PM / XAVA"! !

! HiLxFormDLL class methods !
fileName
        "Answer the receiver's file name."
     ^'HiLxForm.dll'
    "Modified: 10/25/93 / 03:11:27 PM / XAVA"! !

! HiLxFormDLL methods !   
hilDistort: iiInst corners: corners lpTrack: lpTrack
    "Stretches the image to the specified corners."

    <api:  HilDistort ushort struct struct short>
    ^self invalidArgument!
hilFileConvert:dstFile dstLib: dstLib bDstFile: bDstFile srcFile: srcFile srcLib: srcLib bSrcFile: bSrcFile lpTrack: lpTrack
    "Converts a file from one file format to another."

    <api: HilFileConvert struct struct boolean struct struct boolean struct short>
    ^self invalidArgument!
hilLoadImage: szFileName fileFormat: fileFormat lpTrack: lpTrack
    "Loads a file into a virtual image."

    <api: HilLoadImage struct struct struct short>
    ^self invalidArgument!  
hilLoadMemoryImage: lphMemoryFile fileFormat: fileFormat lpTrack: lpTrack
    "Loads a memory file into a virtual image."

    "Patched & rerouted to HilDisp by Ale...
    <api: HilLoadMemoryImage struct struct struct short>
    ^self invalidArgument
    "

    | result library |
    library := HiLDispDLL library.
    result := library loadMemoryImage: lphMemoryFile fileFormat: fileFormat lpTrack: lpTrack.
    library checkError.
    ^result!
hilOrient: iiInst type: type lpTrack: lpTrack
    "Changes the orientation of an instance."
    "type must be one of the following:
            OrLeftRight
            OrUpDown
            OrTranspose
            OrRotate270
            OrRotate180
            OrRotate90"

    <api: HilOrient ushort short struct short>
    ^self invalidArgument!
hilRotate: iiInst angle: angle anchor: anchor pAnchor: pAnchor lpTrack: lpTrack
    "Rotates the instance by the specified degree and anchor, and creates a
    new virtual image encompassing the rotated image."
    "anchor must be one of the following:
            RaTopLeft
            RaTop
            RaTopRight
            RaLeft
            RaCenter
            RaRight
            RaBottomLeft
            RaBottom
            RaBottomRight"

    <api: HilRotate ushort short short struct struct short>
    ^self invalidArgument!   
hilSaveImage: szFileName inst: iiInst fileFormat: fileFormat lpTrack: lpTrack
    "Saves an image instance to a file."
    "fileFormat must be one of the following:
            IffLibBmp
            IffLibHcut
            IffLibFlat
            IffLibGif
            IffLibJpeg
            IffLibPcx
            IffLibPict
            IffLibRas
            IffLibTga
            IffLibTiff"

    <api: HilSaveImage struct ushort struct struct short>
    ^self invalidArgument!   
hilSaveMemoryImage: lphMemoryFile iiInst: iiInst fileFormat: fileFormat lpTrack: lpTrack
    "Saves an image instance to a memory file."

    <api: HilSaveMemoryImage struct ushort struct struct short>
    ^self invalidArgument!  
hilScale: iiInst width: width height: height bSmooth: bSmooth lpTrack: lpTrack
    "Scales the image to a new height and width.  Smoothing option can be
    set to reduce jaggedness in the output image."

    <api: HilScale ushort ushort ushort ushort struct short>
    ^self invalidArgument! 
hilScaleBilevel: to from: from toPix: toPix fromPix: fromPix
    "Scales a line of ImcBilevel data using pixel replication."

    <api: HilScaleBilevel struct struct ushort ushort none>
    ^self invalidArgument!  
hilScaleBilinear: lpOut lpLow: lpLow lpHigh: lpHigh byteWidth: byteWidth fraction: fraction
    "Interpolates an image line from two adjacent image lines."

    <api: HilScaleBilinear struct struct struct ushort ushort none>
    ^self invalidArgument!   
hilScaleBilinearChunks: to from: from toPix: toPix fromPix: fromPix
    "Scales a line of ImcRGB data using bilinear scaling."

    <api: HilScaleBilinearChunks struct struct ushort ushort none>
    ^self invalidArgument! 
hilScaleBilinearFloat: lpOut lpLow: lpLow lpHigh: lpHigh byteWidth: byteWidth fraction: fraction
    "Interpolates a floating-point image line from two adjacent image lines."

    <api: HilScaleBilinearFloat struct struct struct ushort ushort none>
    ^self invalidArgument!   
hilScaleBilinearGray: to from: from toLen: toLen fromLen: fromLen
    "Scales a line of ImcGray data using bilienar scaling."

    <api: HilScaleBilinearGray struct struct ushort ushort none>
    ^self invalidArgument!
hilScaleBilinearGray12:  lpOut lpLow: lpLow lpHigh: lpHigh byteWidth: byteWidth fraction: fraction
    "Interpolates a Gray Scale 12-bit image line from two adjacent image lines."

    <api: HilScaleBilinearGray12 struct struct struct ushort ushort none>
    ^self invalidAtribute! 
hilScaleBilinearLineFloat: to from: from toLen: toLen fromLen: fromLen
    "Scales a line of ImcFloat data using bilinear scaling."

    <api: HilScaleBilinearLineFloat struct struct ushort ushort none>
    ^self invalidArgument! 
hilScaleBilinearLineGray12: to from: from toLen: toLen fromLen: fromLen
    "Scales a line of ImcGray12 data using bilinear scaling."

    <api: HilScaleBilinearLineGray12 struct struct struct ushort short>
    ^self invalidArgument! 
hilScaleChunks: to from: from toPix: toPix fromPix: fromPix
    "Scales a line of ImcRGB data using pixel replication."

    <api: HilScaleChunks struct struct ushort ushort none>
    ^self invalidArgument!
hilScaleFactorBilevel: to from: from toPix: toPix zoomFactor: zoomFactor
    "Scales a line of ImcBilevel data using a specified zoom factor."

    <api: HilScaleFactorBilevel struct struct ushort short none>
    ^self invalidArgument!   
hilScaleFactorChunks: to from: from toPix: toPix zoomFactor: zoomFactor
    "Scales a line of ImcRGB data using specified zoom factor."

    <api: HilScaleFactorChunks struct struct ushort short none>
    ^self invalidArgument!   
hilScaleFactorFloat: to from: from toPix: toPix zoomFactor: zoomFactor
    "Scales a line of ImcFloat data using specified zoom factor."

    <api: HilScaleFactorFloat struct struct ushort short none>
    ^self invalidArgument!   
hilScaleFactorGray: to from: from toPix: toPix zoomFactor: zoomFactor
    "Scales a line of ImcGray data using specified zoom factor."

    <api: HilScaleFactorGray struct struct ushort short none>
    ^self invalidArgument!  
hilScaleFactorGray12: to from: from toPix: toPix zoomFactor: zoomFactor
    "Scales a line of ImcGray12 data using specified zoom factor."

    <api: HilScaleFactorGray12 struct struct ushort short none>
    ^self invalidArgument!
hilScaleFloat: to from: from toPix: toPix fromPix: fromPix
    "Scales a line of ImcFloat data using pixel replication."

    <api: HilScaleFloat struct struct ushort ushort none>
    ^self invalidArgument!
hilScaleGray: to from: from toPix: toPix fromPix: fromPix
    "Scales a line of ImcGray data using pixel replication."

    <api: HilScaleGray struct struct ushort ushort none>
    ^self invalidArgument!   
hilScaleGray12: to from: from toPix: toPix fromPix: fromPix
    "Scales a line of ImcGray12 data using pixel replication."

    <api: HilScaleGray12 struct struct ushort ushort none>
    ^self invalidArgument! 
hilScaleGrayTo: to from: fromAddr toPix: toPix fromPix: fromPix
    "Scales a line of ImcGray data using pixel replication.
    Implemented by Ale for support of fromAddr
     as a longInteger or string pointing to the source structure"

    <api: HilScaleGray struct ulong ushort ushort none>
    ^self invalidArgument! !

! MMSystemDLL class methods ! 
fileName
        "Answer the receiver's file name."
    ^'mmSystem.dll'!
initialize
    "Initializes the receiver"
    super initialize.
    self
        initializeMMConstants;
        initializeStructures
    "Modified: 09/09/93 / 08:59:49 AM / Ale"!  
initializeMMConstants
    "Initializes the PoolDictionary
        MMSystemDLL initializeMMConstants
    "

    MultiMediaConstants := Dictionary new.
   MultiMediaConstants
      at: 'SndAsync' put: 1;
      at: 'SndLoop' put: 8;
      at: 'SndMemory' put: 4;
      at: 'SndNodefault' put: 2;
      at: 'SndNostop' put: 16;
      at: 'SndSync' put: 0;
        yourself.!   
initializeStructures
    "Private - Initializes the structures for the interfase"
    MMTypes := Dictionary new.

    self
        type: 'MMTime'
        is: #(
            (wType word)
            (ms dword)
            (sample dword)
            (cb dword)
                (hour byte) (min byte) (sec byte) "SMPTE"
                (frame byte) (fps byte) (dummy byte)
            (songptrpos dword) "midi"
        );
        type: 'DrvConfigInfo'
        is: #(
            (dwDCISize dword)
            (lpszDCISectionName long asWinAddress)
            (lpszDCIAliasName long asWinAddress)
        );
        type: 'WaveHdr'
        is: #(
            (lpData long asWinAddress)    "pointer to locked data buffer"
            (dwBufferLength dword)           "length of data buffer"
            (dwBytesRecorded dword)       "used for input only"
            (dwUser dword)                        "for client's use"
            (dwFlags dword)                       "assorted flags"
            (dwLoops dword)                      "loop control counter"
            (lpNext long asWinAddress)    "reserved for driver"
            (reserved dword)                      "reserved for driver"
        );
        type: 'WaveOutCaps'
        is: #(
            (wMid word)                             "manufacturer ID"
            (wPid word)                              "product ID"
            (vDriverVersion word)             "driver version"
            (szPname 32 asString)           "product name (asciiZ)"
            (dwFormats dword)                 "formats supported"
            (wChannels word)                   "number of source channels supported"
            (dwSupport dword)                  "functionality supported by the driver"
        );
        type: 'WaveInCaps'
        is: #(
            (wMid word)
            (wPid word)
            (vDriverVersion word)
            (szPname 32 asString)
            (dwFormats dword)
            (wChannels word)
        );
        type: 'WaveFormat'
        is: #(
            (wFormatTag word)              "format type"
            (nChannels word)                "number of channels (mono, stereo, etc.)"
            (nSamplesPerSec dword)    "sample rate"
            (nAvgBytesPerSec dword)  "for buffer estimation"
            (nBlockAlign word)               "block size of data"
        );
        type: 'PCMWaveFormat'
        is: #(
            (wFormatTag word)              "format type"
            (nChannels word)                "number of channels (mono, stereo, etc.)"
            (nSamplesPerSec dword)    "sample rate"
            (nAvgBytesPerSec dword)  "for buffer estimation"
            (nBlockAlign word)               "block size of data"
            (wBitsPerSample word)
        );
        type: 'MidiOutCaps'
        is: #(
            (wMid word)                     "Manufacturer ID"
            (wPid word)                      "Product ID"
            (vDriverVersion word)     "driver version"
            (szPname 32 asString)   "product name"
            (wTechnology word)        "type of device"
            (wVoices word)                "# of voices"
            (wNotes word)                 "max # notes"
            (wChannelMask word)     "channels used"
            (dwSupport dword)          "functionality supported by the driver"
        );
        type: 'MidiInCaps'
        is: #(
            (wMid word)                     "Manufacturer ID"
            (wPid word)                      "Product ID"
            (vDriverVersion word)     "driver version"
            (szPname 32 asString)   "product name"
        );
        type: 'MidiHdr'
        is: #(
            (lpData long asWinAddress)  "pointer to locked data block"
            (dwBufferLength dword)         "length of data in data block"
            (dwBytesRecorded dword)     "used for input only"
            (dwUser dword)                      "for client's use"
            (dwFlags dword)                     "assorted flags"
            (lpNext long asWinAddress)  "reserved for driver"
            (reserved dword)                    "reserved for driver"
        );
        type: 'AuxCaps'
        is: #(
            (wMid word)                     "Manufacturer ID"
            (wPid word)                      "Product ID"
            (vDriverVersion word)     "driver version"
            (szPname 32 asString)   "product name"
            (wTechnology word)        "type of device"
            (dwSupport dword)          "functionality supported by the driver"
        );
        type: 'TimeCaps'
        is: #(
            (wPeriodMin word)          "Minimum period supported"
            (wPeriodMax word)         "Maximum period supported"
        );
        type: 'JoyCaps'
        is: #(
            (wMid word)                     "Manufacturer ID"
            (wPid word)                      "Product ID"
            (szPname 32 asString)   "product name"
            (wXmin word) (wXmax word)
            (wYmin word) (wYmax word)
            (wZmin word) (wZmax word)
            (wNumButtons word)
            (wPeriodMin word) (wPeriodMax word)
        );
        type: 'JoyInfo'
        is: #(
            (wXpos word) (wYpos word) (wZpos word)
            (wButtons word)  "buttons states"
        );
        yourself
    "Modified: 09/09/93 / 08:58:27 AM / Ale"! 
register: aName
    "Private - Register the structure aName"

    MMTypes isNil ifTrue: [self initializeStructures].

    self
        register: (MMTypes
            at: aName
            ifAbsent: [^self error: 'Type not registered ',aName])
        as: aName
    "Modified: 09/09/93 / 08:59:16 AM / Ale"!  
register: aTypeDef as: aStrucName
    "Private - Register a new SelfDefinedStructure with
    name aStrucName with type aTypeDef.
    aTypeDef is an array with the specification of the
     record as
        #( name type [rawType] )
     if rawType is not present #yourself will be assumed
    "
    | offset dicc type types def |
    offset := 0.
    dicc := Dictionary new.
    types := Dictionary new.
    types
        "sizes in bytes"
        at: #byte put: 1;
        at: #short put: 2;
        at: #ushort put: 2;
        at: #long put: 4;
        at: #ulong put: 4;
        at: #handle put: 4;
        "conversion table for confortable settings..."
        at: #word put: #short;
        at: #dword put: #ulong;
        yourself.

    aTypeDef do: [:each|
        def := each copy.
        def size = 2 ifTrue: [def := def ,#(yourself)].
        [ (types at: (def at: 2)
                ifAbsent: [^self error: 'Invalid type definition']) isSymbol ]
            whileTrue: [ def at: 2 put: (types at: (def at: 2)) ].
        dicc
            at: def first
            put: (Array
                with: offset
                with: (type := def at: 2)
                with: def last).
        offset := offset + (types at: type).
    ].
    SelfDefinedStructure
        define: aStrucName
        withFields: dicc
    "Modified: 09/09/93 / 08:56:42 AM / Ale"!  
struct: aName
    "Returns an object of the structure aName"

    "Register the structure if not used yet..."
    (SelfDefinedStructure isDefined: aName)
    ifFalse: [self register: aName].

    ^SelfDefinedStructure named: aName!
type: aTypeName is: anArray
    "Private - Stores the definition of aTypeName struc
     into the receiver registraction database"

    MMTypes isNil ifTrue: [self initializeStructures].

    MMTypes
        at: aTypeName
        put: anArray! !

! MMSystemDLL methods !  
free
    "Private - Free the DLL."
    super free.
    self fillFromAddress: NullHandle!   
mciGetError: value returnString: result size: size
    <api: mciGetErrorString long struct ushort boolean>
    ^self invalidArgument!   
mciSendString: aString returnString: result size: size callback: handle
    <api: mciSendString struct struct ushort ushort long>
    ^self invalidArgument!
sndPlaySound: soundName flags: flags
"
  Syntax
    BOOL sndPlaySound(lpszSoundName, wFlags)

    This function plays a waveform sound specified by a filename or by an entry in the
    [sounds] section of WIN.INI. If the sound can't be found, it plays the default sound
    specified by the SystemDefault entry in the [sounds] section of WIN.INI. If there is no
    SystemDefault entry or if the default sound can't be found, the function makes no sound
    and returns FALSE.

  Parameters

    LPSTR  lpszSoundName

    Specifies the name of the sound to play. The function searches the [sounds] section
    of WIN.INI for an entry with this name and plays the associated waveform file. If no
    entry by this name exists, then it assumes the name is the name of a waveform file. If
    this parameter is NULL, any currently playing sound is stopped.

    WORD  wFlags

    Specifies options for playing the sound using one or more of the following flags:

    SND_SYNC

    The sound is played synchronously and the function does not return until the
    sound ends.

    SND_ASYNC

    The sound is played asynchronously and the function returns immediately after
    beginning the sound. To terminate an asynchronously-played sound, call
    sndPlaySound with lpszSoundName set to NULL.

    SND_NODEFAULT

    If the sound can't be found, the function returns silently without playing the default
    sound.

    SND_MEMORY

    The parameter specified by lpszSoundNamepoints to an in-memory image of
    a waveform sound.

    SND_LOOP

    The sound will continue to play repeatedly until sndPlaySound is called again
    with the lpszSoundName parameter set to NULL. You must also specify the
    SND_ASYNC flag to loop sounds.

    SND_NOSTOP

    If a sound is currently playing, the function will immediately return FALSE without
    playing the requested sound.

    Return Value
    Returns TRUE if the sound is played, otherwise returns FALSE.

    Comments

    The sound must fit in available physical memory and be playable by an installed
    waveform audio device driver. The directories searched for sound files are, in order: the
    current directory;the Windows directory; the Windows system directory; the directories
    listed in the PATH environment variable; the list of directories mapped in a network. See
    the Windows OpenFile function for more information about the directory search order.

    If you specify the SND_MEMORY flag, lpszSoundName must point to an in-memory
    image of a waveform sound. If the sound is stored as a resource, use LoadResource
    and LockResource to load and lock the resource and get a pointer to it. If the sound is
    not a resource, you must use GlobalAlloc with the GMEM_MOVEABLE and
    GMEM_SHARE flags set and then GlobalLock to allocate and lock memory for the
    sound.
    "
    <api: sndPlaySound struct ushort boolean>
    ^self invalidArgument!  
version
    "Returns currently supported version"
    ^self class version! !

! ObjectStyleDLL class methods !
fileName
        "Answer the receiver's file name."
     ^'ostyle.dll'! !

! ObjectStyleDLL methods ! 
doesNotUnderstand: aMessage
    ^self error: 'Object Style DLL missing'! 
initialize
        "Private - Initialize self, do nothing."! 
invalidArgument
    "Exit Smalltalk if failed in runTime"
    Smalltalk isRunTime
    ifTrue: [Smalltalk exit].
    ^super invalidArgument!   
query: aString
    <api: Query struct short>
    ^self invalidArgument! 
setPortAddress: anInteger
    <api: SetLptAddr ushort ushort>
    ^self invalidArgument! !

! SentinelProDLL class methods !  
open
    "Open the receiver"
    | dll |
    dll := super open.
    dll isNil ifTrue: [^nil].
    dll open ifFalse: [ dll invalidArgument ].
    ^dll! !

! SentinelProDLL methods !  
close
    "Close the receiver's interfase"
    <api: 'Close_Sent' boolean>
    ^self invalidArgument!  
free
    "Private - Free the DLL."

    self close.
    ^super free!  
open
    "Open the receiver's interfase"
    <api: 'Open_Sent' boolean>
    ^self invalidArgument! 
query: aString
    "Perform query to aString"
    ^self query: aString lenght: aString size!
query: aString lenght: lenght
    <api: ssQuery struct ushort short>
    ^self invalidArgument! !

! PenWinDLL class methods !
fileName
        "Private - Answer the receiver's file name."
     ^'PenWin.Dll'!   
penWinPresent
    "
        True if the Pen Windows engine present...
       PenWinDLL penWinPresent
    "
    | hLib processWriting tpToDp |
    hLib := UserLibrary getSystemMetrics: 41. "SmPenwindows"
    hLib = 0 ifTrue: [^false].
    processWriting := WinAddress
            fromString: (KernelLibrary getProcAddress: hLib procName: 'ProcessWriting' asParameter).
    processWriting asInteger = 0 ifTrue: [^false].
    tpToDp := WinAddress
            fromString: (KernelLibrary getProcAddress: hLib procName: 'TPtoDP' asParameter).
    tpToDp asInteger = 0 ifTrue: [^false].
    ^true! !

! P3ColorDLL class methods !
fileName
    "Private - Answer the receiver's file name."
     ^'P3Color.Dll'! !

! P3ColorDLL methods !  
setBrightness: hImage to: nBrightness
    "Sets the image Brightness value.
    nContrast must be between -127 and 127
    always returns zero"

    <api: SetBrightness ushort short short>
    ^self invalidArgument! 
setContrast: hImage to: nContrast
    "Sets the image Contrast value.
    nContrast must be between -127 and 127
    always returns zero"

    <api: SetContrast ushort short short>
    ^self invalidArgument! 
setHue: hImage to: nHue
    "Sets the image hue value.
    nHue must be between -180 and 180
    always returns zero"

    <api: SetHue ushort short short>
    ^self invalidArgument!  
setSaturation: hImage to: nSaturation
    "Sets the image Saturation value.
    nContrast must be between -127 and 127
    always returns zero"

    <api: SetSaturation ushort short short>
    ^self invalidArgument! !

! P3ConvDLL class methods !
fileName
    "Private - Answer the receiver's file name."
     ^'P3Conv.Dll'! !

! P3ConvDLL methods !
convertTo16Color: hImage options: wOptions
    "Creates a B&W,gray or 256color image to a 16 color image.
    wOptions can be RmNoDither or RmFsDither
    "
    <api: ConvertTo16Color ushort ushort ushort>
    ^self invalidArgument! 
convertToBW: hImage
    "Creates a 16Color,gray or 256color image to a B&W image."
    ^self convertToBW: hImage options: RmFsDither!   
convertToBW: hImage options: wOptions
    "Creates a 16Color,gray or 256color image to a B&W image.
    wOptions can be RmFsDither
    "
    <api: ConvertToBW ushort ushort ushort>
    ^self invalidArgument!  
convertToGray: hImage
    "Creates to a gray scale image."
    <api: ConvertToGray ushort ushort>
    ^self invalidArgument!   
convertToRGB: hImage
    "Creates to a RGB image."
    <api: ConvertToRGB ushort ushort>
    ^self invalidArgument!
grayToCMap: hImage
    "Creates to a new color mapped image from a gray scale image."
    <api: GrayToCMap ushort ushort>
    ^self invalidArgument!   
rgbToCMap256: hImage options: wOptions
    "Creates a color maped image with an optimized 256 color custom palette,
        from anf rgb image up to 16 millon colors.
    wOptions can be RmNoDither or RmFsDither
    "
    <api: RGBToCMap256 ushort ushort ushort>
    ^self invalidArgument! !

! P3DispDLL class methods !  
fileName
    "Private - Answer the receiver's file name."
     ^'P3Disp.Dll'!   
openLibrary
    "Private - Returns an open instance of the receiver or nil"
    | library |
    (library := super openLibrary) isNil
    ifFalse: [
        (library initP3: SmalltalkSystemWindow handle asInteger) = 1
        ifTrue: [
            library
                set256ColorPaletteMode: PalQualCustom256C;
                set256ColorDisplayMethod: RmFsDither;
                setPaletteShareMode: PsShareDefault.
            Libraries
                at: self symbol
                put: library
        ] ifFalse: [library free. library := nil].
    ].
    ^library! !

! P3DispDLL methods !
destroyImage: hImage
    "Destroy an Image"
    <api: DestroyImage ushort boolean>
    ^self invalidArgument!  
displayImage: hImage in: hDc at: aPoint
    "Displays an image on a device context at aPoint"
    ^self
        displayImage: hImage asParameter16
        srcRect: nil
        hDc: hDc asParameter16
        destX: aPoint x asParameter16
        destY: aPoint y asParameter16!
displayImage: hImage srcRect: lpSrcRect hDc: hDc destX: destX destY: destY
    "Displays an image on a device context.
     Returns 0 if Ok or an error code number"
    <api: DisplayImage ushort struct short short short ushort>
    ^self invalidArgument!
initP3: hWnd
    "Private - Initializes the display engine.
     (This method wil be called automatically)"

    <api: InitP3 ushort ushort>
    ^self invalidArgument!  
set256ColorDisplayMethod: wMethod
    "Sets the rendering method used when displaying full rgb images in 256 modes.
      wMethod must be a Rm...Constant defined in P3Constants.
     wMethod can be 0 for querying (no changing) the current method.
    Previous method will be returned."
    <api: Set256ColorDisplayMethod ushort ushort>
    ^self invalidArgument!  
set256ColorPaletteMode: wPalType
    "Sets the palette mode to be used for rgb images on 256 color display.
     wPalType must be a Pal...Constant defined in P3Constants.
     wPalType can be 0 for querying (no changing) the current mode.
    Previous method will be returned."
    <api: Set256ColorPaletteMode ushort ushort>
    ^self invalidArgument!
setPaletteShareMode: wShareMode
    "Sets the palette share mode.
      wShareMode must be a share mode constant defined in P3Constants
     or 0.  The old share mode will be returned."
    <api: SetPaletteShareMode ushort ushort>
    ^self invalidArgument! !

! P3DIBDLL class methods !
fileName
    "Private - Answer the receiver's file name."
     ^'P3Dib.Dll'! !

! P3DIBDLL methods !  
convertDIBToImage: hDIB srcRect: lpSrcRect
    "Converts a Windows DIB to an image.

    *WARNING* The DIB will be destroyed
         and it's handle can't be used anyway
    "

    <api: ConvertDIBToImage ushort struct ushort>
    ^self invalidArgument!
convertImageToDIB: hImage srcRect: lpSrcRect
    "Converts an image to a Windows DIB.

    *WARNING* The image will be destroyed
         and it's handle can't be used anyway
    "

    <api: ConvertImageToDIB ushort struct ushort>
    ^self invalidArgument!
copyDIBToImage: hImage srcRect: lpSrcRect
    "Creates an image from a Windows DIB."

    <api: CopyDIBToImage ushort struct ushort>
    ^self invalidArgument!   
copyImageToDIB: hImage srcRect: lpSrcRect
    "Creates a Windows DIB from an image."

    <api: CopyImageToDIB ushort struct ushort>
    ^self invalidArgument! !

! P3EditDLL class methods !  
fileName
    "Private - Answer the receiver's file name."
     ^'P3Edit.Dll'! !

! P3EditDLL methods !
copyImage: hImage
    "Copy an image.
    The new image handle will be returned or 0 if not successfull"

    <api: CopyImage ushort short>
    ^self invalidArgument!   
copyImageToClipboard: hImage
    "Copy an image from window hWnd to clipboard.
    Returns 0 if successfull else nonZero"

    ^self copyImageToClipboard: hImage
        from: (SmalltalkSystemWindow handle asInteger).
    "Modified: 10/13/93 / 03:15:05 PM / LRP"
    "Modified: 10/13/93 / 03:15:55 PM / LRP"!   
copyImageToClipboard: hImage from: hWnd
    "Copy an image from window hWnd to clipboard.
    Returns 0 if successfull else nonZero"

    <api: CopyImageToClipboard ushort ushort short>
    ^self invalidArgument! 
crop: hImage rect: lpRect
    "Crop an image.
    The new image handle will be returned or 0 if not successfull"

    <api: Crop ushort struct ushort>
    ^self invalidArgument!
flipLeftRight: hImage rect: lpRect
    "Flip an image around vertical axis
    *WARNING* Modifies the image in hImage.
    Return 1 if Ok 0 ifFailed"

    <api: FlipLeftRight ushort struct ushort>
    ^self invalidArgument! 
flipTopBottom: hImage rect: lpRect
    "Flip an image around horizontal axis
    *WARNING* Modifies the image in hImage
    Return 1 if Ok 0 ifFailed"

    <api: FlipTopBottom ushort struct ushort>
    ^self invalidArgument!
getImageFromClipboard: hImage
    "Get an image from clipboard.  Returns image handle if successfull else 0"

    ^self getImageFromClipboard: hImage
        for: (SmalltalkSystemWindow handle asInteger)

    "Modified: 10/13/93 / 03:40:47 PM / LRP"!  
getImageFromClipboard: hImage for: hWnd
    "Get an image from clipboard. Returns image handle if successfull else 0"

    <api: GetImageFromClipboard ushort ushort ushort>
    ^self invalidArgument
    "Modified: 10/13/93 / 03:41:04 PM / LRP"! 
negative: hImage
    "Turns an image into it's negative
    Return 0 if Ok nonZero ifFailed"

    <api: Negative ushort ushort>
    ^self invalidArgument!   
rotate: hImage
    "Rotate an image clockwise 90 degrees.
    The new image handle will be returned or 0 if not successfull"

    ^self rotate: hImage rect: nil! 
rotate: hImage rect: lpRect
    "Rotate an image clockwise 90 degrees.
    The new image handle will be returned or 0 if not successfull"

    "  Da UAE....
        <api: Rotate ushort struct ushort>
    "
    self notImplementedYet.

    ^self invalidArgument!
scaleImage: hImage srcRect: lpRect width: width height: height
    "Scale an image region to a new image of size width@height.
    The new image handle will be returned or 0 if not successfull.
    The original image is not changed.
    width&height must be in pixel coordinates.
    A pixel interpolation method will be used for scaling."

    <api: ScaleImage ushort struct short short ushort>
    ^self invalidArgument!
scaleImageFast: hImage srcRect: lpRect width: width height: height
    "Scale an image region to a new image of size width@height.
    The new image handle will be returned or 0 if not successfull.
    The original image is not changed.
    width&height must be in pixel coordinates.
    A pixel subsampling&replication method will be used for scaling."

    <api: ScaleImageFast ushort struct short short ushort>
    ^self invalidArgument! !

! P3FileDLL class methods ! 
fileName
    "Private - Answer the receiver's file name."
     ^'P3File.Dll'! !

! P3FileDLL methods !
readEmbeddedImageFile: lpFileName fHandle: hFile offset: dwOffset format: nFormat
    "Read and image from a file at dwOffset and returns it's handle.
     This fuction returns an image handle or 0 if failed.
    if lpFileName is provided and hFile is not 0 the Dll will manage the file (open,read&close)
    if hFile is provided the lpFileName will be ignored.
    "

    <api: ReadEmbeddedImageFile struct ushort long short ushort>
    ^self invalidArgument!  
readEmbeddedImageFile: aFile offset: dwOffset format: nFormat
    "Read and image from a file at dwOffset and returns it's handle.
     This fuction returns an image handle or 0 if failed.
    if aFile is a string the file will be open,read & closed
    if aFile is not aString aFile handle is assumed and it will be used.
    "
    | fHandle pathName |

    (aFile isKindOf: FileStream) ifTrue: [
        ^self readEmbeddedImageFile: aFile file fileId offset: dwOffset format: nFormat
    ].

    aFile isString
    ifTrue: [ pathName := aFile asParameter16. fHandle := 0 asParameter16]
    ifFalse: [ pathName := nil. fHandle := fHandle asParameter16 ].

    ^self
        readEmbeddedImageFile: pathName
        fHandle: fHandle
        offset: dwOffset asParameter16
        format: nFormat asParameter16! 
readImageFile: lpFileName
    "Read and image from disk and returns it's handle.
     This fuction returns an image handle or 0.
     if 0 is returned P3Info #getErrorInfo
         will return the error code"

    <api: ReadImageFile struct ushort>
    ^self invalidArgument!
setJpegOptions: quality
    subSampling: subSampling
    decompPixelType: decompPixelType
    decompToColor: decompToColor
    compressToColor: compressToColor
    reserved1: r1 reserved2: r2 reserved3: r3
    "Set the JPEG compression/decompression options.
     Any parameter with a value of 0 will not change the option.

    Quality: 1-99  1=best quality 99 max. compression
    subSampling: Y:U:V ratio (an JpgSubs... constant in P3Constants)
    decompPixelType:  Desired pixel format (an JpgDecomp... constant in P3Constants)
    decompToColor:  Decompress color or gray (an JpgDecomp... constant in P3Constants)
    compressToColor: Compress to color or gray scale
    reserved1 2 & 3: must be set tozero

    Returns 0 if params ok or 1-8 for the number of a bad parameter value
    "
    <api: SetJpegOptions ushort ushort ushort ushort ushort ushort ushort ushort ushort>
    ^self invalidArgument!  
writeEmbeddedImageFile: hImage
    on: lpFileName
    fHandle: hFile
    offset: dwOffset
    format: nFormat
    bytesWritten: lpdwBytesWritten

    "Writes and image to a file at dwOffset and returns the status.
     This fuction returns 0 or an errorNumber if failed.
    if lpFileName is provided and hFile is not 0 the Dll will manage the file (open,read&close)
    if hFile is provided the lpFileName will be ignored.
    lpdwBytesWritten must be a structure (doubleword) for handling the result
    "

    <api: WriteEmbeddedImageFile ushort struct ushort long ushort struct ushort>
    ^self invalidArgument!   
writeEmbeddedImageFile: hImage
    on: aFile
    offset: dwOffset
    format: nFormat

    "Writes and image to a file at dwOffset and returns the status.
     This fuction returns 0 or an errorNumber if failed.
    if aFile is a string the file will be open,read & closed
    if aFile is not aString aFile handle is assumed and it will be used.
    "
    ^
            self halt
                writeEmbeddedImageFile: hImage
                on: aFile
                offset: dwOffset
                format: nFormat
                bytesWritten: (String new: 8)!  
writeEmbeddedImageFile: hImage
    on: aFile
    offset: dwOffset
    format: nFormat
    bytesWritten: lpdwBytesWritten

    "Writes and image to a file at dwOffset and returns the status.
     This fuction returns 0 or an errorNumber if failed.
    if aFile is a string the file will be open,read & closed
    if aFile is not aString aFile handle is assumed and it will be used.
    "
    | fHandle pathName |

    (aFile isKindOf: FileStream) ifTrue: [
        ^self
            writeEmbeddedImageFile: hImage
            on: aFile file fileId asWinHandle asInteger
            offset: dwOffset
            format: nFormat
            bytesWritten: lpdwBytesWritten
    ].

    aFile isString
    ifTrue: [ pathName := aFile asParameter16. fHandle := 0]
    ifFalse: [ pathName := nil. fHandle := aFile ].

    ^self
        writeEmbeddedImageFile: hImage asParameter16
        on: pathName asParameter16
        fHandle: fHandle  asParameter16
        offset: dwOffset  asParameter16
        format: nFormat  asParameter16
        bytesWritten: lpdwBytesWritten asParameter16!  
writeImageFile: hImage on: lpFileName format: wFormat
    "Writes and image to disk.
     This fuction returns an image handle or 0.
     if 0 is returned if Ok else returns the error code"

    <api: WriteImageFile short struct short ushort>
    ^self invalidArgument! !

! P3InfoDLL class methods !  
fileName
    "Private - Answer the receiver's file name."
     ^'P3Info.Dll'! !

! P3InfoDLL methods !
getErrorInfo
    "Returns the last error code of an ReadImage operation"

    <api: GetErrorInfo ushort>
    ^self invalidArgument!   
getImageBitsPerPixel: hImage
    "Returns the number of bits per pixel for hImage"

    <api: GetImageBitsPerPixel ushort ushort>
    ^self invalidArgument!  
getImageHeight: hImage
    "Returns the hImage's height in pixels"

    <api: GetImageHeight ushort short>
    ^self invalidArgument! 
getImageWidth: hImage
    "Returns the hImage's Width in pixels"

    <api: GetImageWidth ushort short>
    ^self invalidArgument! !

! P3PrintDLL class methods !  
fileName
    "Private - Answer the receiver's file name."
     ^'P3Print.Dll'! !

! P3PrintDLL methods !  
endPrinterPage: hPrinterDc
    "Ends current page...
     Returns 0 if ok else nonZero"

    <api: EndPrinterPage ushort short>
    ^self invalidArgument!   
print: hImage on: aPrinter at: aPoint
    ^self
        printImage: hImage
        srcRect: nil
        printerDc: aPrinter deviceContext asParameter16
        xPos: aPoint x asParameter16
        yPos: aPoint y asParameter16
        width: (P3InfoDLL library getImageWidth: hImage) asParameter16
        height: (P3InfoDLL library getImageHeight: hImage) asParameter16!
print: hImage on: aPrinter to: aRectangle
    ^self
        printImage: hImage
        srcRect: nil
        printerDc: aPrinter deviceContext
        xPos: aRectangle left
        yPos: aRectangle top
        width: aRectangle width
        height: aRectangle height!   
print: hImage source: sourceRect destination: destRect printer: aPrinter
    "Print hImage ...
       sourceRect will be the area inside the image's boundingBox (in pixels) to be printed
       destRect will be the destination area for output (in inches)
       aPrinter will be the current printer to use (placed in the current page).
    "
    ^self
        printImage: hImage asParameter
        srcRect: sourceRect truncated asParameter
        printerDc: aPrinter deviceContext asParameter
        xPos: (destRect left * 100) truncated asParameter
        yPos: (destRect top * 100) truncated asParameter
        width: (destRect width * 100 + 1) truncated asParameter
        height: (destRect height * 100 + 1) truncated asParameter! 
printImage: hImage on: hPrinterDc at: position extent: extent
    ^self
        printImage: hImage
        srcRect: nil
        printerDc: hPrinterDc
        xPos: position x
        yPos: position y
        width: extent x
        height: extent y! 
printImage: hImage srcRect: lpSrcRect printerDc: hPrinterDc xPos: xPos yPos: yPos width: width height: height
    "Writes an image to the printer.
     Returns 0 if ok else nonZero"

    <api: PrintImage ushort struct short short short short short short>
    ^self invalidArgument!
startPrinterPage: hPrinterDc
    "Initializes the printer driver for output to the page.
     if hPrinterDc = 0 the curently selected printer will be used.
     Returns hPrinterDc if ok else 0"

    <api: StartPrinterPage ushort short>
    ^self invalidArgument! !

! QELibDLL class methods !  
fileName
        "Answer the receiver's file name."
     ^'qelib.dll'! !

! QELibDLL methods !
checkError
    | err errmsg|

" Q+E Database Library
   Copyright 1991 Pioneer Software Systems, Inc.
   Smalltalk class written by David Motsinger "

    err := self qeErr.
    err=0
       ifTrue:[^false].
    errmsg := self qeErrMsg.
    MessageBox message: errmsg.
    ^true!   
qeAppendSQL: hdbc partialstmt: aString

    <api: qeAppendSQL short struct short>
    ^self invalidArgument!   
qeBeginTran: hdbc
    <api: qeBeginTran short short>
    ^self invalidArgument! 
qeColDateEnd: hstmt colnum: anInt1
   <api: qeColDateEnd short short short>
   ^self invalidArgument!   
qeColDateStart: hstmt colnum: anInt1
   <api: qeColDateStart short short short>
   ^self invalidArgument!   
qeColDBType: hstmt colnum: anInt1
   <api: qeColDBType short short short>
   ^self invalidArgument! 
qeColName: hstmt colnum: anInt1
    | ptr temp |
    ptr := self qeColName2: hstmt colnum: anInt1.
    temp := String fromAddress: (WinAddress fromString: ptr).
    ^temp!   
qeColName2: hstmt colnum: anInt1
   <api: qeColName short short ulong>
   ^self invalidArgument!
qeColPrecision: hstmt colnum: anInt1
   <api: qeColPrecision short short short>
   ^self invalidArgument!   
qeColScale: hstmt colnum: anInt1
   <api: qeColScale short short short>
   ^self invalidArgument!   
qeColType: hstmt colnum: anInt1
   <api: qeColType short short short>
   ^self invalidArgument! 
qeColWidth: hstmt colnum: anInt1
   <api: qeColWidth short short long>
   ^self invalidArgument!
qeCommit: hdbc
    <api: qeCommit short short>
    ^self invalidArgument!   
qeConnect: constring
    <api: qeConnect struct short>
    ^self invalidArgument!   
qeDataLen: hstmt
    <api: qeDataLen short long>
    ^self invalidArgument! 
qeDBErr
    <api: qeDBErr long>
    ^self invalidArgument!  
qeDisconnect: hstmt
    <api: qeDisconnect short short>
    "^self invalidArgument"!
qeEndSQL: hstmt
    <api: qeEndSQL short short>
    " ^self invalidArgument"!   
qeErr
    <api: qeErr short>
    ^self invalidArgument! 
qeErrMsg
    | ptr temp |
    ptr := self qeErrMsg2.
    temp := String fromAddress: (WinAddress fromString: ptr).
    ^temp! 
qeErrMsg2
   <api: qeErrMsg ulong>
   ^self invalidArgument!
qeExecSQL: hdbc stmt: aString
    <api: qeExecSQL short struct short>
    ^self invalidArgument!
qeFetchGetOptions: hstmt
    <api: qeFetchGetOptions short long>
    ^self invalidArgument! 
qeFetchLogClose: hstmt
    <api: qeFetchLogClose short short>
    ^self invalidArgument!
qeFetchNext: hstmt
    <api: qeFetchNext short short>
    ^self invalidArgument!
qeFetchNumRecs: hstmt
    <api: qeFetchNumRecs short long>
    ^self invalidArgument!   
qeFetchPrev: hstmt
    <api: qeFetchPrev short short>
    ^self invalidArgument!
qeFetchRandom: hstmt recnum: anInt1
   <api: qeFetchRandom short long short>
   ^self invalidArgument!  
qeFetchSetOptions: hstmt options: anInt1
   <api: qeFetchSetOptions short long short>
   ^self invalidArgument! 
qeNumCols: hstmt
    <api: qeNumCols short short>
    ^self invalidArgument!
qeNumModRecs: hstmt
    <api: qeNumModRecs short long>
    ^self invalidArgument!   
qeRollback: hdbc
    <api: qeRollback short short>
    ^self invalidArgument!   
qeSetDB: hdbc database: aString
    <api: qeSetDB short struct short>
    ^self invalidArgument!
qeSetSQL: hdbc partialstmt: aString
    <api: qeSetSQL short struct short>
    ^self invalidArgument!   
qeSetupInfo
    | ptr temp |
    ptr := self qeSetupInfo2.
    temp := String fromAddress: (WinAddress fromString: ptr).
    ^temp!   
qeSetupInfo2
   <api: qeSetupInfo ulong>
   ^self invalidArgument!  
qeTraceOff
    <api: qeTraceOff short>
    ^self invalidArgument!   
qeTraceOn: file
    <api: qeTraceOn struct short>
    ^self invalidArgument!
qeValChar: hstmt colnum: anInt1 fmtstring: aString maxlen: anInt2
    | ptr |
    ptr := self qeValChar2: hstmt colnum: anInt1 fmtstring: aString maxlen: anInt2.
    ^String fromAddress: (WinAddress fromString: ptr)!   
qeValChar2: hstmt colnum: anInt1 fmtstring: aString maxlen: anInt2
   <api: qeValChar short short struct short ulong>
   ^self invalidArgument! 
qeValDecimal: hstmt colnum: anInt1 precision: anInt2 scale: anInt3
    | ptr temp |
    ptr := self qeDecimal2: hstmt colnum: anInt1 precision: anInt2 scale: anInt3.
    temp := String fromAddress: (WinAddress fromString: ptr).
    ^temp!
qeValDecimal2: hstmt colnum: anInt1 precision: anInt2 scale: anInt3
  <api: qeValChar short short short short ulong>
   ^self invalidArgument!  
qeValDouble: hstmt colnum: anInt1
   <api: qeValDouble short short double>
   ^self invalidArgument!
qeValInt: hstmt colnum: anInt1
   <api: qeValInt short short short>
   ^self invalidArgument!   
qeValLong: hstmt colnum: anInt1
   <api: qeValLong short short long>
   ^self invalidArgument!  
qeValMultiChar: hstmt startcolnum: anInt1 endcolnum: anInt2 numfmtstring: aString1 datefmtstring: aString2 separator: aString3
    | ptr temp |
    ptr := self qeValMultiChar2: hstmt startcolnum: anInt1 endcolnum: anInt2 numfmtstring: aString1 datefmtstring: aString2 separator: aString3.
    temp := String fromAddress: (WinAddress fromString: ptr).
    ^temp! 
qeValMultiChar2: hstmt startcolnum: anInt1 endcolnum: anInt2 numfmtstring: aString1 datefmtstring: aString2 separator: aString3
   <api: qeValMultiChar short short short struct struct struct ulong>
   ^self invalidArgument! 
qeVerNum
    | ptr temp |
    ptr := self qeVerNum2.
    temp := String fromAddress: (WinAddress fromString: ptr).
    ^temp! 
qeVerNum2
   <api: qeVerNum ulong>
   ^self invalidArgument! !

! ShellDLL class methods !
fileName
    "Answer the library's file name."
    ^'shell.dll'!
hkeyClassesRoot
    "Constant value for HKEY_CLASSES_ROOT value"
    ^1! !

! ShellDLL methods !  
allKeysFor: keyString
    "Returns all the subkeys keys for the root key keyString"
    | keys |
    keys := Set new.
    self withAllKeysFor: keyString do: [:each| keys add: each].
    ^keys! 
allKeysValuesFor: keyString
    "Returns all the subkeys keys for the root key keyString"
    | keys |
    keys := Set new.
    self withAllKeysValuesFor: keyString do: [:each| keys add: each].
    ^keys! 
allRootKeys
    "Returns all the subkeys for the main root key"
    ^self allKeysFor: self class hkeyClassesRoot!   
allRootKeysValues
    "Returns all the subkeys for the main root key"
    ^self allKeysValuesFor: self class hkeyClassesRoot!   
dragAcceptFiles: aWindowHandle  state: aBoolean
    <api: DragAcceptFiles ushort boolean short>
    ^self invalidArgument!  
dragFinish: aHandle
    <api: DragFinish ushort short>
    ^self invalidArgument!   
dragQueryFile: aHandle fileNum: anInteger returnedString: retSt size: retStrSize
    <api: DragQueryFile ushort short struct ushort short>
    ^self invalidArgument!   
execute: hWnd
    operation: lpszOp
    pathName: lpszFile
    arguments: lpszParams
    directory: lpszDir
    show: fsShowCmd
    "Opens or prints the specified file.

    Parameter   Description
    hwnd    Identifies the parent window. This window receives any message
         boxes an application produces (for example, for error reporting).
    lpszOp  Points to a null-terminated string specifying the operation to perform.
          This string can be 'open' or 'print'. If this parameter is NULL, 'open' is the default value.
    lpszFile    Points to a null-terminated string specifying the file to open.
    lpszParams  Points to a null-terminated string specifying parameters passed to the application
         when the lpszFile parameter specifies an executable file. If lpszFile points to a string specifying
         a document file, this parameter is NULL.
    lpszDir Points to a null-terminated string specifying the default directory.
    fsShowCmd   Specifies whether the application window is to be shown when the application is opened.
        This parameter can be one of the following values:
            Value           Meaning
        SW_HIDE             Hides the window and passes activation to another window.
        SW_MINIMIZE     Minimizes the specified window and activates the top-level window in the system's list.
        SW_RESTORE  Activates and displays a window. If the window is minimized or maximized, Windows
                                         restores it to its original size and position (same as SW_SHOWNORMAL).
        SW_SHOW         Activates a window and displays it in its current size and position.
        SW_SHOWMAXIMIZED    Activates a window and displays it as a maximized window.
        SW_SHOWMINIMIZED    Activates a window and displays it as an icon.
        SW_SHOWMINNOACTIVE  Displays a window as an icon. The window that is currently active remains active.
        SW_SHOWNA   Displays a window in its current state. The window that is currently active remains active.
        SW_SHOWNOACTIVATE    Displays a window in its most recent size and position. The window that is currently
                                                         active remains active.
        SW_SHOWNORMAL   Activates and displays a window. If the window is minimized or maximized, Windows
                                                    restores it to its original size and position (same as SW_RESTORE).

    Returns
        The return value is the instance handle of the application that was opened or printed, if
        the function is successful. (This handle could also be the handle of a DDE server
        application.) A return value less than or equal to 32 specifies an error.

    Errors
        The FindExecutable function returns 31 if there is no association for the specified file type.
        The other possible error values are the same as loadModule function.

    Comments
        The file specified by the lpszFile parameter can be a document file or an executable
        file. If it is a document file, this function opens or prints it, depending on the value of the
        lpszOp parameter. If it is an executable file, this function opens it, even if the string 'print'
        is pointed to by lpszOp.
    "

    <api: ShellExecute handle struct struct struct struct short ushort>
    ^self invalidArgument!  
extractIcon: hInstance from: pathName number: aNumber
    "Private - Returns the icon number aNumber in the exe file pathName.
     If aNumber = 0 returns the first found icon,
        aNumber=-1 returns the number of icons in the file.
    pathName can be an Exe,DLL or Ico file...
    Returns :
        handle for the icon if Ok.
        1 if not an executable file.
        0 if there are no icons...
    "
    <api: ExtractIcon ushort struct short ushort>
    ^self invalidArgument! 
extractIconNumber: aNumber from: pathName
    "Private - Returns the icon number aNumber in the exe file pathName"
    ^self
        extractIcon: WIN hInstance asParameter
        from: pathName asParameter
        number: aNumber asParameter!  
findExecutable: pathName inDir: lpszDir onto: lpszResult
    "Finds and retrieves the executable filename that is associated with a specified filename...
    Parameter   Description
    lpszFile    Points to a null-terminated string specifying a filename. This can be a document or executable file.
    lpszDir     Points to a null-terminated string specifying the drive letter and path for the default directory.
    lpszResult  Points to a buffer that receives the name of an executable file when the function returns.
        This null-terminated string specifies the application that is started when the Open command is
        chosen from the File menu in File Manager.

    The return value is greater than 32 if the function is successful.
    If the return value is less than or equal to 32, it specifies an error code.

    Errors
        The FindExecutable function returns 31 if there is no association for the specified file type.
        The other possible error values are the same as loadModule function.

    Comments
        The filename specified in the lpszFile parameter is associated with an executable file
        when an association has been registered between that file's filename extension and an
        executable file in the registration database. An application that produces files with a
        given filename extension typically associates the extension with an executable file when
        the application is installed. "

    <api: FindExecutable struct struct struct ushort>
    ^self invalidArgument! 
firstIconInExe: pathName
    "Returns the first icon in the exe file pathName.
     If there has been a problem returns nil..."
    | icon handle |
    handle := self extractIconNumber: 0 from: pathName.
    (handle = 0 or: [handle = 1]) ifTrue: [^nil].
    ^Icon new
        handle: handle;
        yourself! 
iconsInExe: pathName
    "Returns all the icons in the exe file pathName.
     If there has been a problem returns an empty collection..."
    | result count handle |
    count := self extractIconNumber: -1 from: pathName.
    count = 0 ifTrue: [^#()].
    result := Array new: count.
    1 to: count do: [:i|
        handle := self extractIconNumber: i - 1 from: pathName.
        (handle = 0 or: [handle = 1])
        ifFalse: [ result at: i put: (Icon new handle: handle;yourself) ]
    ].
    ^result! 
oleClassFor: pathName
    "Returns the ole class for the file pathName"
    | ext pairs |
    ext := '.',(pathName reversed upTo: $.) reversed asLowerCase.
    pairs := self allRootKeysValues.
    pairs do: [:asoc|
        asoc key asLowerCase = ext
        ifTrue: [^asoc value]
    ].
    "use package as default class name"
    ^'Package'!  
regCloseKey: hkey
    <api: RegCloseKey ulong long>
    ^self invalidArgument!  
regEnumKey: hkey subkey: subkey into: aBuffer ofSize: size
    "Enumerates the subkeys of a specified key."
    <api: RegEnumKey ulong ulong struct long long>
    ^self invalidArgument!  
regExtensions
    "Returns the registered extensions sorted..."
    | result |
    result := SortedCollection new.
    self withAllRootKeysDo: [:each|
        (each isEmpty not and: [each first = $.])
        ifTrue: [result add: each asLowerCase]
    ].
    ^result asArray!   
regOpenKey: hkey subkey: subkey into: aWinAddress
    <api: RegOpenKey ulong struct struct long>
    ^self invalidArgument! 
regQuery: item for: keyString
    "Returns the value associated to the root key keyString
    and subkey item or nil if failed..."

    | valueBuffer result valueSize hkRoot |
    hkRoot := WinAddress new.
    result := self
        regOpenKey: self class hkeyClassesRoot asParameter
        subkey: keyString asParameter
        into: hkRoot asParameter.
    result = 0 ifFalse: [^nil].
    valueBuffer := String new: 1000.
    valueSize := WinLong new.
    valueSize uLongAtOffset: 0 put: valueBuffer size.
    result := self
        regQueryValue: hkRoot asParameter
        subkey: item asParameter
        into: valueBuffer
        ofSize: valueSize asParameter.
    self regCloseKey: hkRoot asParameter.
    result = 0 ifFalse: [^nil].
    ^valueBuffer upTo: 0 asCharacter!  
regQueryValue: hkey subkey: subkey into: aBuffer ofSize: aWinLong
    <api: RegQueryValue ulong struct struct struct long>
    ^self invalidArgument!   
withAllKeysFor: keyString do: aBlock
    "With all the subkeys keys for the root key keyString perform aBlock.
     Returns the receiver"
    | hkRoot result iSubKey buffer size |
    hkRoot := WinAddress new.
    0 = (result := self
        regOpenKey: keyString asParameter
        subkey: 0 into: hkRoot asParameter) ifFalse: [^self].
    iSubKey := 0.
    buffer := String new: (size := 1000).
    [
        (self
            regEnumKey: keyString asParameter
            subkey: iSubKey
            into: buffer
            ofSize: size ) = 0
        ifTrue: [
            aBlock value: (buffer upTo: 0 asCharacter).
            iSubKey := iSubKey + 1.
            true]
        ifFalse: [false]
    ] whileTrue: [].
    self regCloseKey: hkRoot asParameter.!
withAllKeysValuesFor: keyString do: aBlock
    "With all the subkeys keys for the root key keyString perform aBlock.
     Returns the receiver"
    | hkRoot result iSubKey buffer size asoc valueBuffer valueSize |
    hkRoot := WinAddress new.
    result := self
        regOpenKey: self class hkeyClassesRoot asParameter
        subkey: keyString asParameter
        into: hkRoot asParameter.
    result = 0 ifFalse: [^self].
    iSubKey := 0.
    buffer := String new: (size := 300).
    valueBuffer := String new: 1000.
    valueSize := WinLong new.
    [
        result := self
            regEnumKey: hkRoot asParameter
            subkey: iSubKey
            into: buffer
            ofSize: size.
        result = 0
        ifTrue: [
            valueSize uLongAtOffset: 0 put: valueBuffer size.
            result := self
                regQueryValue: hkRoot asInteger
                subkey: (buffer upTo: 0 asCharacter) asParameter
                into: valueBuffer
                ofSize: valueSize asParameter.
            result = 0 ifTrue: [
                asoc := Association
                    key: (buffer upTo: 0 asCharacter)
                    value: (valueBuffer upTo: 0 asCharacter).
                aBlock value: asoc.
            ].
            iSubKey := iSubKey + 1.
            true]
        ifFalse: [false]
    ] whileTrue: [].
    self regCloseKey: hkRoot asParameter.!   
withAllRootKeysDo: aBlock
    "For all the subkeys for the main root key perform aBlock"
    ^self withAllKeysFor: self class hkeyClassesRoot do: aBlock!   
withAllRootKeysValuesDo: aBlock
    "For all the subkeys for the main root key perform aBlock"
    ^self withAllKeysValuesFor: self class hkeyClassesRoot do: aBlock! !

! VideoForWindowsDLL class methods ! 
aviTwoCC: aString
    "Returns an aviTwoCC equivalent
      #define aviTWOCC(ch0, ch1) ((WORD)(BYTE)(ch0) | ((WORD)(BYTE)(ch1) << 8))
    "
    aString size = 2 ifFalse: [ ^self error: aString,' Must be a 2 character string.' ].
    ^aString!   
fileName
    "Private - Answer the receiver's file name."
     ^'MsVideo.Dll'!  
mmioFourCC: aString
    "Returns an mmioFourCC equivalent
      #define mmioFOURCC( ch0, ch1, ch2, ch3 )\
        ( (DWORD)(BYTE)(ch0) | ( (DWORD)(BYTE)(ch1) << 8 ) |\
        ( (DWORD)(BYTE)(ch2) << 16 ) | ( (DWORD)(BYTE)(ch3) << 24 ) )
    "
    aString size = 4 ifFalse: [ ^self error: aString,' Must be a 4 character string.' ].
    ^aString! !

! VideoForWindowsDLL methods ! 
aviTwoCC: aString
    "Returns an aviTwoCC equivalent..."

    ^self class aviTwoCC: aString!  
getOpenFileNamePreview: lpofn
    "This function is similar to GetOpenFileName defined in COMMDLG.DLL
     except that it has a preview window to display the movie about to be opened.
    Returns true if a file was opened."

    <api: GetOpenFileNamePreview ulong boolean>
    ^self invalidArgument! 
getSaveFileNamePreview: lpofn
    "This function is similar to GetSaveFileName defined in COMMDLG.DLL
     except that it has a preview window to display the movie about to be opened.
    Returns true if a file was opened."

    <api: GetSaveFileNamePreview ulong boolean>
    ^self invalidArgument! 
mmioFourCC: aString
    "Returns an mmioFourCC: equivalent..."

    ^self class mmioFourCC: aString!   
version
    "Returns the version in an array;
        1st element is the major number;
        2nd element is the minor;
        3rd element is the build number.
    "

    | version |
    version := self videoForWindowsVersion.
    ^Array
        with: (version bitShift: -24)
        with: (version bitShift: -16) & 16r00FF
        with: version & 16rFFFF!
videoForWindowsVersion
    "Private - Returns version of VfW"

    <api: VideoForWindowsVersion long>
    ^self invalidArgument! !

! DrawDibDLL class methods !
initializeConstants
    "Private - Initializes the constants for the interface...
        DrawDibDLL initializeConstants.
    "
    "DRAWDIB.H Routines for drawing DIBs to the screen."

    DrawDibConstants size = 0 ifTrue: [
        DrawDibConstants := Dictionary new
    ].

  DrawDibConstants
    at: 'Ddf0001' put: 1;
    at: 'Ddf2000' put: 8192;
    at: 'DdfAnimate' put: 32;
    at: 'DdfBackgroundpal' put: 512;
    at: 'DdfBuffer' put: 64;
    at: 'DdfDontdraw' put: 16;
    at: 'DdfFullscreen' put: 256;
    at: 'DdfHalftone' put: 4096;
    at: 'DdfHurryup' put: 2048;
    at: 'DdfJustdrawit' put: 128;
    at: 'DdfNotkeyframe' put: 1024;
    at: 'DdfPreroll' put: 16;
    at: 'DdfSameDib' put: 8;
    at: 'DdfSameDraw' put: 8;
    at: 'DdfSameHdc' put: 4;
    at: 'DdfSameSize' put: 8;
    at: 'DdfUpdate' put: 2;
    at: 'PdCanDrawDib' put: 1;
    at: 'PdCanStretchdib' put: 2;
    at: 'PdStretchdib11Ok' put: 4;
    at: 'PdStretchdib12Ok' put: 8;
    at: 'PdStretchdib1NOk' put: 16;
    yourself!  
initializeStructures
    "Private - Initializes the structures for the interface..."

    "Structures for drawing DIBs to the screen. (DRAWDIB.H)"
    self
        registerType: 'DRAWDIBTIME'
        as: #(
            (timeCount long)
            (timeDraw long)
            (timeDecompress long)
            (timeDither long)
            (timeStretch long)
            (timeBlt long)
            (timeSetDIBits long)
        );
        yourself! !

! DrawDibDLL methods !
drawDibBegin: hDrawDib
    hdc: hdc
    dxDst: dxDst
    dyDst: dyDst
    lpbi: lpbi
    dxSrc: dxSrc
    dySrc: dySrc
    wFlags: wFlags

    "This function changes parameters of a DrawDib context,
     or it initializes a new DrawDib context.
    Returns TRUE if successful.TEST:OK"

    <api: DrawDibBegin ushort ushort short short ulong short short ushort boolean>
    ^self invalidArgument! 
drawDibChangePalette: hDrawDib start: start len: len entries: lpPalEntries
    "This function sets the palette entries used for drawing device-independent bitmaps.
    Returns TRUE if successful."

    <api: DrawDibChangePalette ushort ushort ushort ulong boolean>
    ^self invalidArgument!  
drawDibClose: hDrawDib
    "This function closes a DrawDib context and frees
     the resources DrawDib allocated for it.
    Returns TRUE if the context closed successfully."

    <api: DrawDibClose ushort boolean>
    ^self invalidArgument!  
drawDibDraw: hDrawDib hdc: hdc
    xDst: xDst yDst: yDst dxDst: dxDst dyDst: dyDst
    lpbi: lpbi lpBits: lpBits
    xSrc: xSrc ySrc: ySrc dxSrc: dxSrc dySrc: dySrc
    wFlags: wFlags

    "This function draws a device-independent bitmap to the screen.
    Returns TRUE if successful.TEST:OK"

    <api: DrawDibDraw ushort ushort
     short short short short
     ulong ulong
     short short short short
     ushort
     boolean>
    ^self invalidArgument!  
drawDibEnd: hDrawDib
    "This function frees a DrawDib context.
    Returns TRUE if successful.TEST:OK"

    <api: DrawDibEnd ushort boolean>
    ^self invalidArgument!
drawDibError: hDrawDib
    "OJO. esta funcion no esta documentada..."

    <api: DrawDibError ushort short>
    ^self invalidArgument!
drawDibGetBuffer: hDrawDib lpbi: lpbi dwSize: dwSize dwFlags: dwFlags
    "This function returns the pointer to the DrawDib decompress buffer.
    Returns a pointer to the buffer used by DrawDib for decompression,
     or NULL if no buffer is used. If lpbi is not NULL, it is filled in with a copy
     of the BITMAPINFOHEADER describing the buffer.
    The structure for lpbi must have room for a BITMAPINFOHEADER and 256 colors."

    <api: DrawDibGetBuffer ushort ulong ulong ulong long>
    ^self invalidArgument! 
drawDibGetPalette: hDrawDib
    "This function obtains the palette used by a DrawDib context.
    Returns a handle for the palette if successful; otherwise, it returns 0."

    <api: DrawDibGetPalette ushort short>
    ^self invalidArgument!
drawDibInit
    "OJO... Esta funcion esta en la dll pero no esta documentada en VFWDDK 1.1"
    <api: DrawDibInit boolean>
    ^self invalidArgument!  
drawDibOpen
    "This function opens a DrawDib context for drawing.
    Returns a handle to a DrawDib context if successful;
     otherwise, it returns zero.
    * Use this function to obtain a handle to a DrawDib context
     before drawing device-independent bitmaps.
    * If drawing multiple device-independent bitmaps simultaneously,
     obtain a handle to a DrawDib context for each bitmap.TEST:OK"

    <api: DrawDibOpen ushort>
    ^self invalidArgument! 
drawDibProfileDisplay: lpbi
    "Profiles the display for DrawDib.
    The very first time an application uses DrawDib capabilities,
     the Windows operating system executes a series of drawing tests
     to determine the display characteristics. Once the DrawDib libraries
     characterize the display, they will not run the tests again unless
     the information is removed (for example, by reinstalling Windows)
     or the user changes the display driver. Applications can use
     DrawDibProfileDisplay to retest the display.
    Returns TRUE if successful."

    <api: DrawDibProfileDisplay ulong long>
    ^self invalidArgument!   
drawDibRealize: hDrawDib hdc: hdc fBackground: aBoolean
    "This function realizes the palette of the display context
     specified in the DrawDib context.
    Returns the number of entries in the logical palette mapped to
     different values in the system palette. If an error occurs or no
     colors were updated, it returns zero. TEST:OK"

    <api: DrawDibRealize ushort ushort boolean short>
    ^self invalidArgument!  
drawDibSetPalette: hDrawDib hPal: hPal
    "This function sets the palette used for drawing device-independent bitmaps.
    Returns TRUE if successful."

    <api: DrawDibSetPalette ushort ushort boolean>
    ^self invalidArgument!  
drawDibStart: hDrawDib rate: rate
    "This function prepares a DrawDib context for streaming playback.
    Rate is the plaiback rate (in milliseconds).
    Returns TRUE if successful."

    <api: DrawDibStart ushort ulong boolean>
    ^self invalidArgument!  
drawDibStop: hDrawDib
    "This function frees the resources used by a DrawDib
     context for streaming playback.
    Returns TRUE if successful."

    <api: DrawDibStop ushort boolean>
    ^self invalidArgument!  
drawDibTime: hDrawDib lpddtime: lpddtime
    "Returns timing information about the drawing during debug operation.
    Returns TRUE if successful."

    <api: DrawDibTime ushort ulong boolean>
    ^self invalidArgument!  
drawDibUpdate: hDrawDib hdc: hdc x: x y: y
    "This macro updates the last buffered frame drawn.
    Returns TRUE if successful."

    ^self
        drawDibDraw: hDrawDib
        hdc: hdc
        xDst: x yDst: y dxDst: 0 dyDst: y
        lpbi: 0 lpBits: 0
        xSrc: x ySrc: y dxSrc: 0 dySrc: y
        wFlags: DdfUpdate! !

! FloatCoprocessorDLL methods !  
getStatus
    "Patched for non spureous coprocessor failures.
    Implemented by Ale..."
    #addedByOStyle.
    ^16r80! !

! GDIDLL methods !  
animatePalette: hPal startIndex: index numEntries: count paletteColors: colors
    "Implemented by Ale..."
    <api: AnimatePalette ushort ushort ushort struct ushort>
    #addedByOStyle.
    ^self invalidArgument!
createPatternBrush: aBitmapHandle
    "Added by OSI"
    <api: CreatePatternBrush ushort ushort>
    #addedByOSI.
    ^self invalidArgument!  
createPolygonRgn: lpPoints count: nCount mode: nPolyFillMode
    "Implemented by Ale..."
    <api: CreatePolygonRgn struct ushort ushort ushort>
    #addedByOStyle.
    ^self invalidArgument!   
equalRgn: sSrcRgn1 to: hSrcRgn2
    "Implemented by Ale..."
    <api: EqualRgn struct struct boolean>
    #addedByOStyle.
    ^self invalidArgument!  
extFloodFill: dc x: anInt1 y: anInt2 color: aColor type: type
    "Implemented by Ale..."
    <api: ExtFloodFill ushort short short ulong ushort boolean>
    #addedByOStyle.
    ^self invalidArgument!  
fillRegion: dc region: hRgn brush: hBrush
    "Implemented by Ale..."
    <api: FillRgn ushort ushort ushort boolean>
    #addedByOStyle.
    ^self invalidArgument!  
floodFill: dc x: anInt1 y: anInt2 color: aColor
    "Implemented By Ale..."
    <api: FloodFill ushort short short ulong boolean>
    #addedByOStyle.
    ^self invalidArgument!  
frameRegion: dc region: hRgn brush: hBrush width: width height: height
    "Implemented By Ale..."
    <api: FrameRgn ushort ushort ushort ushort ushort boolean>
    #addedByOStyle.
    ^self invalidArgument!  
getRgnBox: hRgn in: lpRect
    "Implemented By Ale..."
    <api: GetRgnBox ushort struct ushort>
    #addedByOStyle.
    ^self invalidArgument!   
getSystemPaletteEntries: hDC  startIndex: start numEntries: numEntries  paletteEntries: entries
    "Store into the buffer 'entries' palette information from hDC
     Implemented By Ale..."
    <api: GetSystemPaletteEntries ushort ushort ushort struct ushort>
    #addedByOStyle.
    ^self invalidArgument!   
getViewportOrg: aDeviceContext
    "Retrieves the x and y coordinates of the origin of the viewPort associated with the given context
    Implemented By Ale..."
    <api: GetViewportOrg ushort ulong>
    #addedByOStyle.
    ^self invalidArgument!   
invertRgn: dc region: hRgn
    "Implemented by Ale..."
    <api: InvertRgn ushort ushort boolean>
    #addedByOStyle.
    ^self invalidArgument!  
offsetRgn: hRgn x: x y: y
    "Implemented by Ale..."
    <api: OffsetRgn ushort ushort ushort ushort>
    #addedByOStyle.
    ^self invalidArgument! 
paintRgn: dc region: hRgn
    "Implemented by Ale..."
    <api: PaintRgn ushort ushort boolean>
    #addedByOStyle.
    ^self invalidArgument!
polyLine: dc points: points count: count
    "Implemented by Ale..."
    <api: PolyLine ushort struct short boolean>
    #addedByOStyle.
    ^self invalidArgument!   
ptInRgn: hRgn x: x y: y
    "Implemented by Ale..."
    <api: PtInRegion ushort ushort ushort boolean>
    #addedByOStyle.
    ^self invalidArgument! 
realizePalette: hdc
    "Implemented by Ale..."
    <api: GDIRealizePalette ushort ushort>
    #addedByOStyle.
    ^self invalidArgument! 
selectPalette: aDeviceContext with: anObject forceBackground: aBoolean
    "Touched by Ale for correct GDI selector ussage."
    <api: GDISelectPalette ushort ushort boolean ushort>
    #modifiedByOStyle.
    ^self invalidArgument!   
setAbortProc: aDeviceContext proc: anAddress
    "Implemented By Ale for OSPrinter..."
    <api: SetAbortProc ushort ulong ushort>
    #addedByOStyle.
    ^self invalidArgument! 
setPaletteEntries: hPal startIndex: index numEntries: count paletteColors: colors
    "Implemented by Ale..."
    <api: SetPaletteEntries ushort ushort ushort struct ushort>
    #addedByOStyle.
    ^self invalidArgument! !

! KernelDLL methods !   
getPrivateProfileString: appName keyName: keyName default: default returnedString: resultStr size: anInt fileName: fileName
    "Implemented by Ale..."
    <api: GetPrivateProfileString struct struct struct struct ushort struct ushort>
    #addedByOStyle.
    ^self invalidArgument!
getProfileString: appName keyName: keyName default: defaultStr returnedString: retStr size: anInt
    "Implemented by Ale..."
    <api: GetProfileString struct struct struct struct ushort ushort>
    #addedByOStyle.
    ^self invalidArgument!
getTempDrive
    "Private - Returns aCharacter that specifies a disk drive an application can
    use for temporary files.
    The return value specifies a disk drive for temporary files if the function is successful. If at
    least one hard disk drive is available, the function returns the letter of the first hard disk drive
    (usually C). If no hard disk drives are available, the function returns the letter of the current
    drive.
    Implemented by Ale for temporary files support."

    #addedByOStyle.
    ^((self getTempDrive: 0) \\ 256) asCharacter!   
getTempDrive: ignored
    "Private - Returns an integer that specifies a disk drive the application can
    use for temporary files.
    The return value specifies a disk drive for temporary files if the function is successful. If at
    least one hard disk drive is available, the function returns the letter of the first hard disk drive
    (usually C). If no hard disk drives are available, the function returns the letter of the current
    drive.
    Implemented by Ale for temporary files support."

    <api: GetTempDrive short short>
    #addedByOStyle.
    ^self invalidArgument!   
getTempFileName: prefix
    "Private - Creates a temporary filename of the following form:
        drive:\path\prefixuuuu.TMP
    The following list describes the filename syntax:
    Element     Description
    drive       Drive letter of temp drive.
    path        Path of the temporary file (either the Windows directory
                     or the directory specified in the TEMP environment variable)
    prefix      All the letters (up to the first three) of the string pointed to by the prefix parameter
    uuuu       unique parameter (see sdk information) "

    | holder result |
    #addedByOStyle.
    holder := String new: 512.
    result := self
        getTempFileName: self getTempDrive asciiValue
        prefix: prefix asParameter
        unique: 0
        onto: holder.
    ^holder trimBlanks!  
getTempFileName: driveLetter prefix: prefix unique: unique onto: return
    "Private - Creates a temporary filename of the following form:
        drive:\path\prefixuuuu.TMP
    The following list describes the filename syntax:
    Element     Description
    drive       Drive letter specified by the driveLetter parameter
    path        Path of the temporary file (either the Windows directory
                     or the directory specified in the TEMP environment variable)
    prefix      All the letters (up to the first three) of the string pointed to by the prefix parameter
    uuuu       Hexadecimal value of the number specified by the unique parameter "

    <api: GetTempFileName short struct ushort struct short>
    #addedByOStyle.
    ^self invalidArgument!   
getVersion
    "Added by OSI"
    <api: GetVersion ulong>
    #addedByOSI.
    ^self invalidArgument! 
isDBCSLeadByte: aChar
    <api: IsDBCSLeadByte ushort boolean>
    ^ UserLibrary isTwoByteCharPrefix: aChar!
loadResource: instanceHandle resInfo: aHandle
    "Implemented by Ale..."
    <api: LoadResource ushort ushort ushort>
    #addedByOStyle.
    ^self invalidParameter.!   
lread: aFileHandle string: aString size: anInteger
    "Implemented by Ale..."
    <api: '_lread' short struct ushort ushort>
    #addedByOStyle.
    ^self invalidArgument!  
lwrite: aFileHandle string: aString size: anInteger
    "Implemented by Ale..."
    <api: '_lwrite' short struct ushort ushort>
    #addedByOStyle.
    ^self invalidArgument!
setHandleCount: anInteger
    "Implemented by Ale..."
    <api: SetHandleCount ushort ushort>
    #addedByOStyle.
    ^self invalidParameter.!
sizeOfResource: hInst resInfo: hResInfo
    "Implemented by Ale..."
    <api: SizeOfResource ushort ushort ushort>
    #addedByOStyle.
    ^self invalidParameter.!   
unLockResource: aHandle
    "Touched by Ale..."
    "<api: UnlockResource ushort boolean>"
    <api: GlobalUnlock ushort boolean>
    #modifiedByOStyle.
    ^self invalidParameter.!
writePrivateProfileString: appName key: keyName str: str fileName: fname
    "Implemented By Ale..."
    <api: WritePrivateProfileString struct struct struct struct boolean>
    #addedByOStyle.
    ^self invalidArgument!  
writeProfileString: appName key: keyName str: str
    "Implemented By Ale..."
    <api: WriteProfileString struct struct struct boolean>
    #addedByOStyle.
    ^self invalidArgument! !

! UserDLL methods !  
ansiLower: aString
    <api: AnsiLower struct ulong>
    ^self invalidArgument! 
ansiLowerBuff: aString length: anInteger
    <api: AnsiLowerBuff struct ushort ushort>
    ^self invalidArgument!   
ansiUpper: aString
    <api: AnsiUpper struct ulong>
    ^self invalidArgument! 
ansiUpperBuff: aString length: anInteger
    <api: AnsiUpperBuff struct ushort ushort>
    ^self invalidArgument!   
createDialogIndirect: hInstance dialogTemplate: lpDialogTemplate parent: hWndParent dialogFunction: lpDialogFunc
    "Added by OSI - Folded in fix made by Digitalk"
    <api: CreateDialogIndirect ushort ulong ushort ulong ushort>
    #addedByOSI.
    ^self invalidArgument! 
createWindowEx: exStyle
className: className
name: nameString
style: styleInteger
x: xInteger
y: yInteger
width: widthInteger
height: heightInteger
parent: parentHandle
menu: menuHandle
instance: instanceHandle
param: paramStructure
    "Private - This method only works for non-predefined window classes.
    Implemented by Ale..."
    #addedByOStyle.
    (nameString isByteArray or:[className isByteArray] )
        ifTrue:[ ^self createWindowEx: exStyle
                            uLong: className
                            nameULong: nameString
                            style: styleInteger
                            x: xInteger
                            y: yInteger
                            width: widthInteger
                            height: heightInteger
                            parent: parentHandle
                            menu: menuHandle
                            instance: instanceHandle
                            paramULong: paramStructure]
        ifFalse:[ ^self createWindowEx: exStyle
                            struct: className
                            nameStruct: nameString
                            style: styleInteger
                            x: xInteger
                            y: yInteger
                            width: widthInteger
                            height: heightInteger
                            parent: parentHandle
                            menu: menuHandle
                            instance: instanceHandle
                            param: paramStructure]! 
createWindowEx: exStyle
struct: classNameInteger
nameStruct: nameString
style: styleInteger
x: xInteger
y: yInteger
width: widthInteger
height: heightInteger
parent: parentHandle
menu: menuHandle
instance: instanceHandle
param: paramStructure
    "Private - This method only works for non-predefined window classes.
    Implemented by Ale..."
   <api: CreateWindowEx ulong struct struct ulong short short short short ushort ushort ushort struct ushort>
    #addedByOStyle.
    ^self invalidArgument!   
createWindowEx: exStyle
uLong: className
nameULong: nameString
style: styleInteger
x: xInteger
y: yInteger
width: widthInteger
height: heightInteger
parent: parentHandle
menu: menuHandle
instance: instanceHandle
paramULong: paramStructure
    "Private - This method only works for non-predefined window classes.
    Implemented by Ale..."
   <api: CreateWindowEx ulong ulong ulong ulong short short short short ushort ushort ushort ulong ushort>
    #addedByOStyle.
    ^self invalidArgument!  
defFrameProc: aWindowHandle mdiClient: aClientHandle msg: msgInteger wparam: wordInteger lparam: longInteger
    "Implemented by ???... (Quizas MDI Patches o WBMDI patches)"
    <api: DefFrameProc ushort ushort ushort ushort ulong ulong>
    #addedByOStyle."??"
    ^self invalidArgument!  
defMDIChildProc: aWindowHandle msg: msgInteger wparam: wordInteger lparam: longInteger
    "Implemented by ???... (Quizas MDI Patches o WBMDI patches)"
    <api: DefMDIChildProc ushort ushort ushort ulong ulong>
    #addedByOStyle."??"
    ^self invalidArgument!
drawFocusRect: hDC rectangle: aRect
    "Added by OSI"
    <api: DrawFocusRect ushort struct short>
    #addedByOSI.
    ^self invalidArgument!   
drawText: hDC text: t length: l rect: r format: f
    "Added by OSI"
    <api: DrawText ushort struct short struct ushort short>
    #addedByOSI.
    ^self invalidArgument!  
enableWindow: aWindowHandle boolean: aBoolean
    "Implemented by Ale..."
    <api: EnableWindow ushort boolean boolean>
    #addedByOStyle.
    ^self invalidArgument!   
exitWindowsExec: lpszExe params: lpszParams
    "Implemented by Ale.
    Terminates windows, runs a specified MS-DOS application,
     and then restarts windows.
    WARNING: lpszExe and lpszParams must not be longer than 127 bytes.
    Returns: false if fails (Could fail because of amemory-alocation error or
        if one of the applications in the system does not terminate."

    <api: ExitWindowsExec struct struct boolean>
    #addedByOStyle.
    ^self invalidArgument!   
getClassName: aWindowHandle text: aString maxLength: anInteger
    "Implemented by Ale..."
    <api: GetClassName ushort struct short short>
    #addedByOStyle.
    ^self invalidArgument!   
getDlgCtrlID: hWnd
    "Implemented by Ale..."
    <api: getDlgCtrlID ushort ushort>
    #addedByOStyle.
    ^self invalidArgument!   
getDlgItemTextW: hDlg item: nIDDlgItem text: winAdr maxCount: nMaxCount
   "Added by OSI to fix intermittent failures. Thanks to Tom Lipkis"
    <api: getDlgItemText ushort ushort ulong short short>
    #addedByOSI.
    ^self invalidArgument!
getDoubleClickTime
    "Returns the double click time interval"
    "Implemented by ???..."
      <api: GetDoubleClickTime ushort>
    #addedByOStyle.
     ^self invalidArgument!   
getScrollRange: hWnd bar: barID lpMinPos: lpMinPos lpMaxPos: lpMaxPos
    "Added by OSI"
   <api: GetScrollRange ushort short struct struct short>
    #addedByOSI.
    ^self invalidArgument!
getWindow: aWindow relationship: relationship
    "Added by OSI"
    <api: GetWindow ushort short ushort>
    #addedByOSI.
    ^self invalidArgument! 
getWindow: aWindowHandle  wCmd: anInteger
    "Implemented by Ale..."
    <api: GetWindow ushort short ushort>
    #addedByOStyle.
    ^self invalidArgument! 
getWindowTextW: aWindowHandle text: winAdr maxLength: anInteger
   "Added by OSI to fix intermittent failures. Thanks to Tom Lipkis"
    <api: GetWindowText ushort ulong short short>
     #addedByOSI.
   ^self invalidArgument!
isCharAlpha: aChar
    <api: IsCharAlpha ushort boolean>
    ^self invalidArgument! 
isCharAlphaNumeric: aChar
    <api: IsCharAlphaNumeric ushort boolean>
    ^self invalidArgument!   
isCharLower: aChar
    <api: IsCharLower ushort boolean>
    ^self invalidArgument! 
isCharUpper: aChar
    <api: IsCharUpper ushort boolean>
    ^self invalidArgument! 
isTwoByteCharPrefix: aChar
    <api: IsTwoByteCharPrefix ushort boolean>
    ^self invalidArgument! 
lStrCmp: aString1 withString: aString2
        "The comparison is case-sensitive.
          All strings must be less than 64K in size."
    <api: lStrCmp struct struct short>
    ^self invalidArgument! 
lStrCmpi: aString1 withString: aString2
        "The comparison is case-insensitive.
          All strings must be less than 64K in size."
    <api: lStrCmpi struct struct short>
    ^self invalidArgument! 
moveWindow: aWindowHandle left: nLeft top: nTop width: nWidth height: nHeight repaint: aBoolean
    "Implemented by Ale..."
    <api: MoveWindow ushort ushort ushort ushort ushort boolean boolean>
    #addedByOStyle.
    ^self invalidArgument!   
openIcon: aHandle
    "Added by OSI"
    <api:OPENICON ushort boolean>
    #addedByOSI.
    self invalidArgument! 
registerClipboardFormat: lpzFormatName
    "The RegisterClipboardFormat function registers a new clipboard format.
    The registered format can be used in subsequent clipboard functions as a
    valid format in which to render data, and it will appear in the clipboard's list of
    formats.
    The return value indicates the newly registered format. If the identical format
    name has been registered before, even by a different application, the format's
    reference count is incremented (increased by one) and the same value is
    returned as when the format was originally registered. The return value is zero
    if the format cannot be registered.
    Implemente by Ale for OSClipboardManager..."
    <api: RegisterClipboardFormat struct ushort>
    #addedByOStyle.
    ^self invalidArgument! 
setDlgItemInt: hDlg
item: nIDDlgItem
word: aWord
signed: isSigned
    <api: SetDlgItemInt ushort ushort ushort ushort ushort>
    ^self invalidArgument! 
translateMDISysAccel: hWnd  msg:aWinAddr
    <api: TranslateMDISysAccel ushort ulong boolean>
    ^self invalidArgument!
winHelp: hWnd helpFile: fileName command: command data: data
    "Implemented by Ale..."
    <api: WinHelp ushort struct ushort struct boolean>
    #addedByOStyle.
    ^self invalidArgument! !

! VcExtMemDLL class methods ! 
aboutToSaveImage
    "Prepare VcExtMem as SelfInitializingObject"

    VcExtMem isNil ifFalse: [ VcExtMem aboutToSaveImage ].

    VcExtMem := SelfInitializingObject with: [
        VcExtMem := VcExtMemDLL open: 'wextm102.dll' ] .! 
getErrorTextOfError: aNumber
    "Rckgabe des Fehlertextes "

(0 == aNumber)
ifTrue: [
^'kein Fehler aufgetreten' ].

(101 == aNumber)
ifTrue: [
^'101 : Start und Stop vertauscht
    : destFrom > destTo' ].

(102 == aNumber)
ifTrue: [
^'102 : ein Grenzwert kleiner-gleich Null
    : destFrom <= 0, destTo <= 0, srcFrom <= 0' ].

(103 == aNumber)
ifTrue: [
^'103 : Startwert (Dest) grer als Lnge
    : destSize < destFrom' ].

(104 == aNumber)
ifTrue: [
^'104 : Endewert (Dest) grer als Lnge
    : destSize < destTo' ].

(105 == aNumber)
ifTrue: [
^'105 : Startwert (Src) grer als Lnge
    : srcSize < (srcFrom+interval-1)' ].

(106 == aNumber)
ifTrue: [
^'106 : Lngenangabe (Dest) falsch;
      Lngenangabe grer als vorhandener nonSmalltalkMemory
    :  dpSize = GlobalSize ( destObject ) ; destSize > dpSize' ].

(107 == aNumber)
ifTrue: [
^'107 : Lngenangabe (Src) falsch;
      Lngenangabe grer als vorhandener nonSmalltalkMemory
    :  spSize = GlobalSize ( srcObject ) ; srcSize > spSize' ].

^'kein gltiger Fehlercode'

    "Modified: Aug 26, 1991 / 16:14:58 / E.Voss"! !

! VcExtMemDLL methods ! 
aboutToSaveImage
    "Private - Free the receiver prior to saving image."

    self free.
    VcExtMem := nil.!   
getErrorTextOfError: aNumber
    "Rckgabe des Fehlertextes "

    ^self class getErrorTextOfError: aNumber!   
replace: destObject
    destSize: destSize
    from: begin
    to: end
    with: srcObject
    srcSize: srcSize

    <api: REPLACEFROMTO struct ulong ulong ulong struct ulong long>!  
replace: destObject
    destSize: destSize
    from: destFrom
    to: destTo
    with: srcObject
    srcSize: srcSize
    startingAt: srcFrom

    <api: REPLACEFROMTOWITHSTARTINGAT struct ulong ulong ulong struct ulong ulong long>!   
replaceHuge: destObject
    destSize: destSize
    from: destFrom
    to: destTo
    with: srcObject
    srcSize: srcSize
    startingAt: srcFrom

    <api: REPLACEHUGE ushort ulong ulong ulong ushort ulong ulong long>
    ^self invalidArgument!
replaceLarge: destObject
    destSize: destSize
    from: destFrom
    to: destTo
    with: srcObject
    srcSize: srcSize
    startingAt: srcFrom

    <api: REPLACELARGE struct ulong ulong ulong struct ulong ulong long>! !

! VWVMDLL methods !
containsDoubleByteCharacter: aDBString
        "Private - Answer 1 if aDBString contains
         any double-byte characters, answer 0 if it
         does not. Answer -1 it the api fails."
    <api: CONTAINSDBCHARACTER self long>!
doubleByteString: aDBString toMixedString: aString
        "Private - Answer the length of aString in
          mixed-encoding containing all the characters
         of the double-byte string. Answer -1 it the api fails."
    <api: DBTOMIXEDSTRING self self  long>! 
doubleByteStringSizeFrom: aString leadBytes: leadByteFlags
        "Private - Answer the size of a double-byte
          string containing the characters of aString
          in mixed-encoding. Answer -1 it the api fails."
    <api: MIXEDTODBSTRINGSIZE self self long>! 
loadCollateTable: aCollateTable
        "Private - Initialize the collating-sequence table
          for the current country and language settings.
          This table is used in string comparison primitive.
          Answer -1 if not successful."
    <api: LOADCOLLATETABLE self  ushort>!   
mixedString: aString containsLeadByte: leadByteFlags
        "Private - Answer 1 if aString contains
         any lead-byte characters, answer 0 if it
         does not. Answer -1 it the api fails."
    <api: CONTAINSLEADBYTE self self long>!
mixedString: aString toDoubleByteString: aDBString leadBytes: leadByteFlags
        "Private - Answer the length of a double-byte
          string containing all the characters of aString
          in mixed-encoding. Answer -1 it the api fails."
    <api: MIXEDTODBSTRING self self self long>! 
mixedStringSizeFrom: aDBString
        "Private - Answer the size of a string in
          mixed-encoding containing all the characters of
          the double-byte string. Answer -1 it the api fails."
    <api: DBTOMIXEDSTRINGSIZE self  long>! !

! WindowHandle methods !
defMDIChildProc:anMDIChild
        "Private - Change the default Windows procedure of the receiver
         to use the DefMDIChildProc."
    self propertyAt: 'oldProc'
        put: anMDIChild class defMDIChildProcAddress.! !

! WinInfo class methods ! 
colorButtonFace
        "Answer the button face color."

    ^UserLibrary getSysColor: ColorBtnface!   
colorButtonHighlight
        "Answer the button highlight color."
    |w|
    self isWindows30
            ifTrue:[
                w := WinLong fromInteger:(Pen red:255 green:255 blue:255).
                ^w contents asString].

    ^UserLibrary getSysColor: ColorBtnhighlight!   
colorButtonShadow
        "Answer the button shadow color."

    ^UserLibrary getSysColor: ColorBtnshadow! 
colorButtonText
        "Answer the button text color."

    ^UserLibrary getSysColor: ColorBtntext!   
cxBorder
    "Private - answer the width of a  border."

    ^UserLibrary getSystemMetrics:SmCxborder! 
cxIcon
    "Private - Answer the width of an icon."

    ^UserLibrary getSystemMetrics:SmCxicon!   
cyBorder
    "Private - Answer the height of a  border."

    ^UserLibrary getSystemMetrics:SmCyborder!
cyCaption
    "Private - Answer the height of a title bar."

    ^UserLibrary getSystemMetrics:SmCycaption!
cyIcon
    "Private - Answer the height of an icon."

    ^UserLibrary getSystemMetrics:SmCyicon!  
isWindows30
        "Answer true if windows 30."

    ^((self windowsMajorVersion >= 3)
        and:[self windowsMinorVersion >= 10]) not!
windowsMajorVersion
        "Answer the Windows major version."
    |v|
    v := KernelLibrary getVersion.
    v := WinAddress fromString: v.
    ^v byteAtOffset: 0!
windowsMinorVersion
        "Answer the Windows minor version."
    |v|
    v := KernelLibrary getVersion.
    v := WinAddress fromString: v.
    ^v byteAtOffset: 1! !

! WinLogicalObject methods !  
fileOutSurrogate: anObjectFiler
        " Answer surrogate for object filing.  Zap handle. "
    | surrogate |
    surrogate := self copy.
    surrogate handle: nil.
    ^surrogate! !

! WinStructure methods !  
handleAtOffset: anInteger
    "Answer a WinHandle at anInteger in the receiver.  Offsets are zero relative.
    Implemented by Ale. (se lo habian olvidado...)"

    #addedByOStyle.
    ^WinHandle fromInteger: (self uShortAtOffset: anInteger)!   
handleAtOffset: anInteger put: anObject
    "Store anObject at anInteger in the receiver.
         Offsets are zero relative.
    Implemented by Ale. (se lo habian olvidado...)"

    #addedByOStyle.
    ^self uShortAtOffset: anInteger put: anObject asInteger! !

! HilBCGM methods !
brightness
    "Returns the current brightness value."
    ^self uShortAtOffset: 0! 
brightness: anInteger
    "Sets the current brightness value."
    ^self uShortAtOffset: 0 put: anInteger!  
contrast
    "Returns the current contrast value."
    ^self uShortAtOffset: 2! 
contrast: anInteger
    "Sets the current contrast value."
    ^self uShortAtOffset: 2 put: anInteger!  
gama
    "Returns the current gama value."
    ^self uShortAtOffset: 4! 
gama: anInteger
    "Sets the current gama value."
    ^self uShortAtOffset: 4 put: anInteger! !

! SelfDefinedStructure class methods !  
define: aString withFields: aDictionary
        "Define a memory structure.  aString is the
        name of the structure (to be used later as the
        argument to SelfDefinedStructure named:).  aDictionary
        describes the fields of the structure.  The
        dictionary keys are the symbol names of the fields
        and the values are 3 element Arrays.  The
        first element is the byte offset of the field (zero based)
        within the structure.  The second element is a
        field type symbol (for 1, 2, and 4 byte fields) or
        an integer indicating the number of bytes in the
        field (for larger fields).  The allowable field type symbols
        are:  #byte, #short, #ushort, #long, #ulong, #handle.
        The third element is a selector.  When retrieving a
        field, the value is first extracted in 'raw' form, then
        the selector specified in the third array
        element is sent to this 'raw' field value
        and the resulting object is returned for the field
        value.  For most field types the raw value is an
        integer and so the third element of the array can
        simply be #yourself.
        When the field type (the second array element) is an
        integer (for larger fields), the raw value is a
        ByteArray so the third element of the array
        might be #asString.
    Modified By Ale for SelfDefinedSubStructures support...
        now the field type can be a string with the name of
        a defined SelfDefinedStructure or an array
        specifying an (open) array structure...
    "

    | d max sds |
    #modifiedByOStyle.
    d := IdentityDictionary new.
    max := Association key: nil value: #(0 0).
    aDictionary associationsDo: [:a |
        d at: a key asSymbol put: a value.
        d at: (a key, (String with: $:)) asSymbol put: a value.
        ((a value at: 1) >= (max value at: 1)) ifTrue: [max := a]].
    d at: #sizeInBytes put: (max value at: 1) + (self sizeInBytesFor: (max value at: 2)).

    Definitions at: aString put: d!   
definitions
   "Answer the current definitions dictionary.
    Implemented by Ale for easy dynamic implementation
     of new structures & class initializations...
    Implemented by Ale..."

    #addedByOStyle.
   ^Definitions!   
isDefined: aString
   "Answer true if an instance of a Win struct named aString
    was previously defined using #define:withFields:.
    Implemented by Ale for easy dynamic implementation
     of new structures & class initializations...
    Implemented by Ale..."

    #addedByOStyle.
   ^Definitions includesKey: aString!  
nameOf: aSelfDefinedStructure
    "Answer the name aSelfDefinedStructure.
    Implemented by Ale..."

    #addedByOStyle.
    ^Definitions
        keyAtValue: aSelfDefinedStructure definition
        ifAbsent: [ 'UNKNOWN' ]!   
sizeInBytesFor: item
    "Returns the size in bytes for a structure of name item...
    Added by Ale for SelfDefinedSubStructure functionality."

    | sizes dim |
    #addedByOStyle.

    item isInteger ifTrue: [ ^item ].
    item isArray ifTrue: [
        dim := (item at: 1) max: 1.
        ^(self sizeInBytesFor: (item at: 2)) * dim
    ].

    item isSymbol
    ifTrue: [ "basic type"
        sizes := Dictionary new.
        sizes
            at: #byte put: 1;
            at: #short put: 2;
            at: #ushort put: 2;
            at: #long put: 4;
            at: #ulong put: 4;
            at: #handle put: 4.
        ^sizes at: item
    ].

    ((Definitions includesKey: item) not and: [ item first = $* ])
    ifTrue: [ "Pointer to a structure"
        ^self sizeInBytesFor: #ulong
    ].

    ^(Definitions at: item
        ifAbsent: [
            (Smalltalk includesKey: item asSymbol)
            ifTrue: [ ^(Smalltalk at: item asSymbol) sizeInBytes ].
            ^self error: self name,'  ''',item,''' is undefined.']
        ) at: #sizeInBytes! !

! SelfDefinedStructure methods !  
printOn: aStream
        "Append the ASCII representation of the receiver
         to aStream.  This is the default implementation which
         prints 'a' ('an') followed by the receiver class name."
    | aString |
    aString := self class nameOf: self.
    (aString at: 1) isVowel
        ifTrue: [aStream nextPutAll: 'an ']
        ifFalse: [aStream nextPutAll: 'a '].
    aStream nextPutAll: aString!  
privateAt: aField
    "Private - Answer the field described by aField.
    Modified By Ale for SelfDefinedSubStructures support..."

    | s sds array elementSize address |

    #modifiedByOStyle.
    (sds := aField at: 2) isArray
    ifTrue: [ "an Array Structure may be built..."
        ^(SelfDefinedSubStructure
                arrayOf: sds first
                elements: sds last
                inside: self
                at: (aField at: 1)) perform: (aField at: 3)
    ].
    (sds isMemberOf: String)
    ifTrue: [
        ((Definitions includesKey: sds) not and: [ sds first = $* ])
        ifTrue: [ "its a pointer to a WinStructure or to a SDS..."
            sds := sds copyFrom: 2 to: sds size.
            address := WinAddress fromInteger: (self uLongAtOffset: (aField at: 1)).
            ^((Definitions includesKey: sds) "an SDS name or WinStruct name spected..."
                ifTrue: [ self class named: sds atAddress: address ]
                ifFalse: [ (Smalltalk at: sds asSymbol) atAddress: address ]
                ) perform: (aField at: 3)
        ].
        "a SelfDefinedSubStructure may be built..."
        ^(SelfDefinedSubStructure
            named: sds inside: self
            at: (aField at: 1)) perform: (aField at: 3)
    ].

    s := AtSelectors at: (aField at: 2) ifAbsent: [
        ^(self bytesAtOffset: (aField at: 1) count: (aField at: 2))
            perform: (aField at: 3)].
    ^(self perform: s with: (aField at: 1)) perform: (aField at: 3).!
privateAt: aField put: anObject
    "Private - Set the field described by aField to anObject.
    Modified By Ale for SelfDefinedSubStructures support..."
    | s sds |

    #modifiedByOStyle.
    ((sds := aField at: 2) isMemberOf: String)
    ifTrue: [ "a SelfDefinedSubStructure field must be byte replaced..."
        ^self
            perform: #bytesAtOffset:put:
            with: (aField at: 1)
            with: anObject
    ].

    s := AtPutSelectors at: (aField at: 2) ifAbsent: [
        ^self bytesAtOffset: (aField at: 1) put: anObject].
    ^self perform: (AtPutSelectors at: (aField at: 2))
        with: (aField at: 1)
        with: anObject.! !

! SelfDefinedSubStructure class methods !  
arrayOf: count elements: type inside: aSDS at: start
    "Answer aCollection of elements inside aSDS at start..."

    | array offset itemSize types |
    offset := start.
    types := self basicTypes.

    count = 0 ifTrue: [ "Open Array Structure..."
        ^type isInteger | type isSymbol
        ifTrue: [
            SelfDefinedOpenArray
                definedAs: type
                inside: aSDS
                at: start
        ]
        ifFalse: [
            SelfDefinedOpenArray
                named: type
                inside: aSDS
                at: start
        ]
    ].

    type isInteger ifTrue: [ itemSize := type ]
    ifFalse: [
        type isSymbol
        ifTrue: [ itemSize := types at: type ]
        ifFalse: [ "aSDS"
            itemSize := SelfDefinedStructure sizeInBytesFor: type
        ]
    ].

    array := Array new: count.
    1 to: count do: [:i|
        type isInteger
        ifTrue: [
            array at: i put: (aSDS bytesAtOffset: offset count: type).
        ]
        ifFalse: [
            array
                at: i
                put: (aSDS privateAt: (Array with: offset  with: type with: #yourself))
        ].
        offset := offset + itemSize.
    ].
    ^array!  
basicTypes
    "Private - Returns the dictionary with basic types..."

    | types |
    types := Dictionary new.
    types
        "sizes in bytes"
        at: #byte put: 1;
        at: #short put: 2;
        at: #ushort put: 2;
        at: #long put: 4;
        at: #ulong put: 4;
        at: #handle put: 4;
        yourself.
    ^types!
definedAs: definition inside: aSelfDefinedStructure at: offset
    "Answer an instance of the receiver with definition
    inside aSelfDefinedStructure at offset..."

    ^"(self new: (definition at: #sizeInBytes))"
      self basicNew
        definition: definition;
        contents: aSelfDefinedStructure;
        offset: offset;
        yourself!   
named: aString inside: aSelfDefinedStructure at: offset
        "Answer an instance of the receiver named aString
        which is inside aSelfDefinedStructure at offset..."
    | definition |
    definition := SelfDefinedStructure definitions at: aString.
    ^self definedAs: definition inside: aSelfDefinedStructure at: offset! !

! SelfDefinedSubStructure methods !  
asParameter
    "Answer the receiver in a form suitable for passing
     as a parameter to a host system procedure call."

    ^self contents asParameter!
at: aSymbol
    "Answer the field named aSymbol from the receiver."

    | field selector |
    field := definition at: aSymbol
        ifAbsent: [
            ^super doesNotUnderstand:
                (Message new receiver: self selector: aSymbol arguments: #())
        ].
    ^self privateAt: field.!  
at: aSymbol put: anObject
    "Set the field named aSymbol to anObject."

    | field selector |
    field := definition at: aSymbol
        ifAbsent: [
            ^super doesNotUnderstand:
                (Message new receiver: self selector: aSymbol arguments: #())
        ].
    ^self privateAt: field put: anObject!
byteAtOffset: anInteger
    "Answer the byte at anInteger in the receiver. Offsets
     are zero relative."

    ^contents byteAtOffset: anInteger + self offset! 
byteAtOffset: anInteger put: anObject
    "Store anObject at anInteger in the receiver.
     Offsets are zero relative."

    ^contents byteAtOffset: anInteger + self offset put: anObject!  
bytesAtOffset: anInteger count: anInteger2
        "Answer a ByteArray with anInteger2 bytes copied
         from the receiver starting at anInteger.
         Offsets are zero relative."

    ^contents bytesAtOffset: anInteger + self offset count: anInteger2!  
bytesAtOffset: anInteger put: aByteObject
        "Store aByteObject at anInteger in the receiver.
         Offsets are zero relative."

    ^contents bytesAtOffset: anInteger + self offset put: aByteObject!   
contents
    "Answer the contents of the receiver as a new SelfDefinedStructure."

    | newBytes |
    newBytes := contents bytesAtOffset: self offset count: self sizeInBytes.
    ^(SelfDefinedStructure usingBytes: newBytes)
            definition: definition;
            yourself!
copyToAddress: anAddress
    "Copy the bytes of the receiver to
      Windows memory at anAddress."

    anAddress
        replaceFrom: 1
        to: self sizeinBytes
        with: self contents
        startingAt: 1! 
definition
    "Returns the instance var of the receiver
     for external manipulation"
    ^definition!  
definition: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    definition := anObject! 
doesNotUnderstand: aMessage
    "Private - See if the message selector is one of the
     field names of the receiver.  If so, access that field."
    | field s |
    s := aMessage selector.
    field := definition at: s
        ifAbsent: [^super doesNotUnderstand: aMessage].
    s last = $:
        ifTrue: [self privateAt: field put: aMessage arguments first]
        ifFalse: [^self privateAt: field].!   
fillFromAddress: anAddress
    "Fill the receiver by copying bytes from
     Windows memory at anAddress."

    contents contents
        replaceFrom: 1 + self offset
        to: contents size + self offset
        with: anAddress
        startingAt: 1! 
longAtOffset: anInteger
    "Answer the signed double word (32 bits) at
    anInteger in the receiver. Offsets are zero relative."

    ^contents longAtOffset: anInteger + self offset!  
longAtOffset: anInteger put: anObject
    "Store anObject at anInteger in the receiver.
    Offsets are zero relative."

    ^contents longAtOffset: anInteger + self offset put: anObject!   
offset
    "Returns the instance var of the receiver
     for external manipulation"
    ^offset!  
offset: anObject
    "Sets the instance var of the receiver
     with anObject. (No checking is done)"
    offset := anObject! 
printOn: aStream
    "Append the ASCII representation of the receiver to aStream."

    | aString |
    aString := SelfDefinedStructure nameOf: self.
    (aString at: 1) isVowel
        ifTrue: [aStream nextPutAll: 'an ']
        ifFalse: [aStream nextPutAll: 'a '].
    aStream nextPutAll: aString!   
privateAt: aField
    "Private - Answer the field described by aField."

    | newField |
    newField := aField copy.
    newField at: 1 put: aField first + self offset. "adapt offset"
    ^contents privateAt: newField!
privateAt: aField put: anObject
    "Private - Set the field described by aField to anObject."

    | newField |
    newField := aField copy.
    newField at: 1 put: aField first + self offset. "adapt offset"
    ^contents privateAt: newField put: anObject!   
shortAtOffset: anInteger
    "Answer a signed short integer (16 bits) at anInteger in the
    receiver.  Offsets are zero relative."

    ^contents shortAtOffset: anInteger + self offset!   
shortAtOffset: anInteger put: anObject
    "Store anInteger at anInteger in the receiver.
    Offsets are zero relative."

    ^contents shortAtOffset: anInteger + self offset put: anObject!
size
    "Answer the size in bytes of the structure contents."

    ^self sizeInBytes! 
sizeInBytes
    "Answer the size of the receiver structure in bytes."

    ^definition at: #sizeInBytes!   
uLongAtOffset: anInteger
    "Answer the double word (32 bits) at anInteger in the receiver.
    Offsets are zero relative."

    ^contents uLongAtOffset: anInteger + self offset!   
uLongAtOffset: anInteger put: anObject
    "Store anObject at anInteger in the receiver.
    Offsets are zero relative."

    ^contents uLongAtOffset: anInteger + self offset put: anObject! 
uShortAtOffset: anInteger
    "Answer the word (16 bits) at anInteger in the receiver.
    Offsets are zero relative."

    ^contents uShortAtOffset: anInteger + self offset!
uShortAtOffset: anInteger put: anObject
    "Store a word, anObject, at anInteger in the receiver.
    Offsets are zero relative."

    ^contents uShortAtOffset: anInteger + self offset put: anObject! !

! SelfDefinedOpenArray methods !
at: anIndex
    "Answer the field at anIndex or named aSymbol from the receiver
    indexes are one indexed...."

    anIndex isInteger ifFalse: [ ^super at: anIndex ].
    ^self itemAt: self itemSize * (anIndex - 1) + offset!   
itemAt: anOffset
    "Private - Answer the item at anOffset"

    | sds dict |
    definition isInteger  | definition isSymbol
    ifTrue: [
        dict := Dictionary new.
        dict
            at: #sizeInBytes put: contents sizeInBytes;
            at: #item put: (Array with: 0 with: definition with: #yourself);
            yourself.
        sds := SelfDefinedSubStructure usingBytes: contents.
        sds
            definition: dict;
            offset: anOffset.
         ^sds item
    ].

    ^SelfDefinedSubStructure
        definedAs: definition
        inside: contents
        at: anOffset!   
itemSize
    "Private - Returns the size of an item..."

    definition isDictionary ifTrue: [ ^self sizeInBytes ].
    definition isInteger ifTrue: [ ^definition ].
    ^self class basicTypes at: definition! 
itemType: type
    "Change the elements item type to type.
    type can be:
        aSymbol for basic types (see class method basicTypes)
        anInteger for contiguous bytes in a ByteArray
        aString for a SDS name
    "

    definition := type.! !

! WinBitmapInfoHeader methods !   
byteWidth
    "Private - Answer the number of bytes in a raster line.
    Patched by LRP 24/Nov/93."
    #modifiedByOStyle.
    ^self width * self bitCount  // 8!
clrUsed
    "Private - Returns the number of color indexes used in the bitmap.
    Patched by LRP 24/Nov/93."
    #modifiedByOStyle.
    ^self uLongAtOffset: 32! 
compression
    "Private - Returns the compression type."
    #addedByOStyle.
    ^self uLongAtOffset: 16! 
yPelsPerMeter
    "Private - Returns the vertical resolution in pixels per meter."
    #addedByOStyle.
    ^self uLongAtOffset: 28! !

! WinBitmapInfo methods ! 
palette
    "Answer WinLogPalette which is the color table of the structure.
    Implemented by LRP 22/Nov/93."
    #addedByOStyle.
    ^WinLogPalette fromRgbColor: self colorTable! 
palette: aPalette
    "Sets aPalette in the receiver
    Implemented by LRP 22/Nov/93
    Touched by Ale for empty palette consideration..."
    | colors start |
    #addedByOStyle.
    colors := aPalette colors.
    colors size = 0 ifTrue: [^self].
    start := WinBitmapInfoHeader sizeInBytes + 1.
     ^self contents
        replaceFrom: start
        to: start + colors size - 1
        with: colors
        startingAt: 1! !

! WinClientCreateStruct class methods !  
sizeInBytes
         "Private - Answer the default size in bytes."
    ^4! !

! WinClientCreateStruct methods !   
hMenu

    ^self uShortAtOffset:0!  
hMenu: anInteger

    ^self uShortAtOffset:0  put: anInteger!   
idFirstChild

    ^self shortAtOffset:2!
idFirstChild: anInteger

    ^self shortAtOffset:2  put: anInteger! !

! WinDialogInfo class methods !
dialogTemplateStyle: style itemCount: itemCount x: x y: y cx: cx cy: cy menuName: menuName className: className text: text
        "Private - Answer a new dialog template
         with its attributes set from the parameters."
    |size dlgTemplate classNameOffset textOffset ptext |

    size := 13.         "Base DLGTEMPLATE size"
    classNameOffset := size := size + menuName size + 1.
    textOffset := size := size + className size + 1.
    ptext := (text isNil
        ifTrue: [ String new ]
        ifFalse: [ text ]) asParameter.
    size := size + ptext size.

    dlgTemplate := self new: size.
    dlgTemplate uLongAtOffset: 0 put: style.
    dlgTemplate byteAtOffset: 4 put: itemCount.
    dlgTemplate uShortAtOffset: 5 put: x.
    dlgTemplate uShortAtOffset: 7 put: y.
    dlgTemplate uShortAtOffset: 9 put: cx.
    dlgTemplate uShortAtOffset: 11 put: cy.
    dlgTemplate bytesAtOffset: 13 put: menuName asParameter.
    dlgTemplate bytesAtOffset: classNameOffset put: className asParameter.
    dlgTemplate bytesAtOffset: textOffset put: ptext.

    ^dlgTemplate! 
itemTemplateStyle: style x: x y: y cx: cx cy: cy id: id className: className text: text
        "Private - Calculate the size of a dialog item template
         and answer a new item template with attributes
         set from the arguments."
    |size dlgItemTemplate extraDataSizeOffset textOffset|

    size := 14.         "Base DLGITEMTEMPLATE size"
    textOffset := size := size + className size + 1.
    extraDataSizeOffset := size := size + text size +1.
    size := size + 1.

    dlgItemTemplate := self new: size.
    dlgItemTemplate uShortAtOffset: 0 put: x.
    dlgItemTemplate uShortAtOffset: 2 put: y.
    dlgItemTemplate uShortAtOffset: 4 put: cx.
    dlgItemTemplate uShortAtOffset: 6 put: cy.
    dlgItemTemplate uShortAtOffset: 8 put: id.
    dlgItemTemplate uLongAtOffset: 10 put: style.

    "OSI - For default controls we needed to use a numeric value, not a string,
     since Borland's Resource Workshop doesn't honor string class names for built-in
     controls."
    #modifiedByOSI.
    className isInteger ifTrue: [
        dlgItemTemplate byteAtOffset: 14 put: className asParameter.
    ] ifFalse: [
        dlgItemTemplate bytesAtOffset: 14 put: className asParameter.
    ].
    dlgItemTemplate bytesAtOffset: textOffset put: text asParameter.
    dlgItemTemplate byteAtOffset: extraDataSizeOffset put: 0.

    ^dlgItemTemplate! !

! WinDialogInfo methods ! 
extent

    "Added by OSI"
    #addedByOSI.
    ^(self uShortAtOffset: 9) @ (self uShortAtOffset: 11)!
items

    "Added by OSI"

    | items s r resID style classID b text |

    #addedByOSI.
    s := ReadWriteStream on: (contents copyFrom: 14 to: contents size).

    "Skip menu name, class name, and text"
    s upTo: 0; upTo: 0; upTo: 0.

    (self style bitIsOn: (WinConstants at: 'DsSetfont')) ifTrue: [
        s nextTwoBytes; upTo: 0.
    ].

    items := OrderedCollection new.
    self numberOfItems timesRepeat: [
        r := (s nextTwoBytes @ s nextTwoBytes extent: s nextTwoBytes @ s nextTwoBytes).
        resID := s nextTwoBytes.
        style := s nextFourBytes.
        classID := s next.
        classID < 128 ifTrue: [
            classID := String with: classID asCharacter.
            [ (b := s next) = 0 ] whileFalse: [
                classID := classID, (String with: b asCharacter).
            ].
        ].
        text := ''.
        [ ( b := s next ) = 0 ] whileFalse: [
            text := text, (String with: b asCharacter)
        ].
        items add:
            (InterfaceObject
                newFromStyle: style
                classID: classID
                rect: r
                text: text
                resID: resID
            ).
        s next.
    ].

    ^items!   
numberOfItems
    "Added by OSI"
    #addedByOSI.
    ^self byteAtOffset: 4!   
origin
    "Added by OSI"
    #addedByOSI.
    ^(self uShortAtOffset: 5) @ (self uShortAtOffset: 7)!   
readFrom: fileName

    "Added by OSI"
    | s f |
    #addedByOSI.
    f := File pathName: fileName.

    f nextByte; nextByte; nextByte; nextByte.
    [ f nextByte = 0 ] whileFalse: [ ].
    f nextByte; nextByte.

    s := f nextUShort.
    f nextByte; nextByte.
    contents := ByteArray new: s.
    1 to: s do: [:i |
        contents at: i put: f nextByte.
    ].

    f close.!  
style
    "Added by OSI"
    #addedByOSI.
    ^self uLongAtOffset: 0!  
text

    "Added by OSI"
    | s t |
    #addedByOSI.
    s := ReadStream on: (contents copyFrom: 14 to: contents size).

    "Skip menu name and class name"
    s upTo: 0; upTo: 0.

    t := String new.
    (s upTo: 0) do: [:b | t := t, (String with: b asCharacter) ].

    ^t! !

! WinDropFiles class methods !   
sizeInBytes
         "Private - Answer the default size in bytes."
    ^8! !

! WinDropFiles methods !
initialize
    self sizeStruct: self class sizeInBytes!  
mousePos
    "Mouse Position"

    ^(self uShortAtOffset: 2) @ (self uShortAtOffset: 4)!   
nonClientArea
    "true  if the mouse was in the window's non-client area
        when the button was released"

    ^(self uShortAtOffset: 6) = 1!   
sizeStruct
    "true  if the mouse was in the window's non-client area
        when the button was released"

    ^(self uShortAtOffset: 0)!  
sizeStruct: anInteger
    "true  if the mouse was in the window's non-client area
        when the button was released"

    self uShortAtOffset: 0  put:  anInteger! !

! WinFloat class methods ! 
sizeInBytes
    "Private - Answer the default size in bytes..
    Implemented by ???..."
    #addedByOStyle.
    ^8! !

! WinFloat methods !
asFloat
    "Returns the receiver as a Float object.
    Implemented by ???..."
    | result |
    #addedByOStyle.
    result := Float new.
    WinAddress
        copyFrom: contents
        to: result
        count: contents size.
    ^result! !

! WinLogPalette class methods !
from: aCollection
    "Answer a WinPalette created from aCollection of rgb+flag (in a subArray) values.
     See #printOn: of the receiver's instances...
    Implemented by LRP..."
    | pal stream headerSize readStream |
    #addedByOStyle.
    headerSize := 4.
    pal := self new: aCollection size * 4 + headerSize.
    stream := WriteStream on: pal contents.
    readStream := ReadStream on: aCollection.
    stream
        nextPut: 0;nextPut: 3; "version"
        nextPut: aCollection size \\ 256;
        nextPut: aCollection size // 256.
    [readStream atEnd] whileFalse: [
        stream nextPutAll: readStream next " #( red green blue flag ) "
    ].
    ^pal!   
fromDC: aDeviceContext
    "Returns an instance of the receiver from the deviceContext.
    Implemented by Ale..."
    | result numEntries stream entries count |
    #addedByOStyle.
    numEntries := GDILibrary getDeviceCaps: aDeviceContext index: Sizepalette.
    result := self new: 4 * numEntries + self headerSize.
    stream := WriteStream on: result contents.
    stream
        nextPut: 0;nextPut: 3; "version"
        nextPut: numEntries \\ 256;
        nextPut: numEntries // 256.
    entries := String new: 4 * numEntries.
    count := GDILibrary
        getSystemPaletteEntries: aDeviceContext
        startIndex: 0 numEntries: numEntries
        paletteEntries: entries.
    count = 0 ifTrue: [^self error: 'getting sys pallete'].
    stream nextPutAll: entries.
    ^result!
fromRed: redCollection fromGreen: greenCollection fromBlue: blueCollection fromFlags: flagsCollection
    "Private - Answer a WinPalette created from 3 collections.
    Implemented by LRP..."
    | pal palSize red green blue flags stream |
    #addedByOStyle.
    palSize :=(((redCollection size max: greenCollection size)
                         max: blueCollection size)
                         max: flagsCollection size)*4.
    pal:=self new: palSize  + self headerSize.
    stream := WriteStream on: pal contents.
    red:=ReadStream on: redCollection.
    green:=ReadStream on: greenCollection.
    blue:=ReadStream on: blueCollection.
    flags:=ReadStream on: flagsCollection.
    stream
        nextPut: 0;nextPut: 3; "version"
        nextPut: palSize // 4 \\ 256;
        nextPut: palSize // 4 // 256.
    palSize // 4 timesRepeat: [
        red atEnd ifFalse: [stream nextPut: red next] ifTrue: [stream nextPut: 0].
        green atEnd ifFalse: [stream nextPut: green next] ifTrue: [stream nextPut: 0].
        blue atEnd ifFalse: [stream nextPut: blue next] ifTrue: [stream nextPut: 0].
        flags atEnd ifFalse: [stream nextPut: flags next] ifTrue: [stream nextPut: 0].
        ].

    ^pal!
fromRgbColor: aByteArray
    "Answer an instance of the receiver with its entries copied from aByteArray.
    Implemented by LRP..."
    #addedByOStyle.
    ^self fromRgbColor: aByteArray entries: (aByteArray size) // 4.! 
fromRgbColor: anArrayOfRgbQuads entries: anInteger
    " Answer an instance of the receiver with at most anInteger
    of its  entries copied from aByteArray .  Note that while a
    palette entry is stored as Red-Green-Blue, the RGBquad
    data is actually stored as Blue-Green-Red.
    Look at the structure definitions for LOGPALETTE and RGBQUAD
    in windows.h.
    Implemented by LRP..."
    | logPalette aByteArray count|
    #addedByOStyle.
    count := anArrayOfRgbQuads size.
    aByteArray  := ByteArray new: count.
    0 to: ( (count // 4) - 1 )  do:[ :i |
      aByteArray at: (i * 4 + 1) put: (anArrayOfRgbQuads at: (i * 4 + 3)).
      aByteArray at: (i * 4 + 2) put: (anArrayOfRgbQuads at: (i * 4 + 2)).
      aByteArray at: (i * 4 + 3) put: (anArrayOfRgbQuads at: (i * 4 + 1)).
      aByteArray at: (i * 4 + 4) put: 0. ].

   anInteger < ( aByteArray size  / 4 )
    ifTrue: [
        logPalette := self new: ( 4 + ( anInteger * 4 ) ).
        logPalette uShortAtOffset: 0 put: 16r300.
        logPalette  uShortAtOffset: 2 put: anInteger.
        logPalette contents replaceFrom: 5 to: ( 4 + ( anInteger * 4 ) )
                                        with: aByteArray startingAt: 1]
    ifFalse: [
        logPalette := self new: ( 4 + ( aByteArray size ) ).
        logPalette uShortAtOffset: 0 put: 16r300.
        logPalette  uShortAtOffset: 2 put:  ( ( aByteArray size) /4 ).
        logPalette bytesAtOffset: 4 put: aByteArray].

        ^logPalette! 
headerSize
    "Private - Returns the receiver's header size.
    Implemented by LRP..."
    #addedByOStyle.
    ^4!  
rgbQuadSize
    "Returns the size in bytes of a RGBQuad. Use avoiding the number constant.
    Implemented by LRP 22/Nov/93"
    #addedByOStyle.
    ^4!  
sizeInBytes
    "Private - Answer the default size in bytes."
    #addedByOStyle.
    ^1028! !

! WinLogPalette methods !
= aWinLogPalette
    "Answer true if the contents of the receiver are equal
    to the contents of aWinLogPalette.
    Implemented by LRP..."
    #addedByOStyle.
    ^(self contents = aWinLogPalette contents)!
changeEntry: anIndex to: palEntry
    "Sets the entry at anIndex to palEntry
      * palEntry must be an rgbQuad byteArray
      * anIndex must be zero indexed.
    Implemented by LRP..."
    #addedByOStyle.

    (WriteStream on: contents)
            position: 4 * anIndex + self headerSize;
            nextPutAll: palEntry!   
colors
    "Returns a collection with the colors in the receiver.
    Implemented by LRP..."
    #addedByOStyle.
    contents size <= (self headerSize + 1)
    ifTrue: [^Array new].

    ^contents
        copyFrom: self headerSize + 1
        to: contents size!
colors: aByteArray
    "Sets the colors in the receiver with aByteArray.
    Implemented by LRP..."
    #addedByOStyle.

    (WriteStream on: contents)
        position: self headerSize;
        nextPutAll: aByteArray! 
findColor: anArray
    "Returns a collection with the indices that matches
     anArray (of RGB values) exactly...
    Implemented by LRP..."
    | stream result index rgb failed |
    #addedByOStyle.
    stream := ReadStream on: contents.
    result := OrderedCollection new.
    index := 1.
    stream position: self headerSize.
    [stream atEnd] whileFalse: [
        rgb := Array with: stream next with: stream next with: stream next.
        stream next.
        failed := false.
        1 to: 3 do: [:i| (rgb at: i) = (anArray at: i) ifFalse: [failed := true] ].
        failed ifFalse: [result add: index].
        index := index + 1.
    ].
    ^result!  
getEntriesFrom: aPaletteHandle
    "Fill the receiver's colors from palette with aPaletteHandle.
    Implemented by LRP..."
    | numEntries colors count |
    #addedByOStyle.
    numEntries := self numEntries.
    colors := ByteArray new: 4 * numEntries.
    count := GDILibrary
        getPaletteEntries: aPaletteHandle
        startIndex: 0 numEntries: numEntries
        lpPaletteEntries: colors.
    count = 0 ifTrue: [^self error: 'getting pallete colors'].
    self colors: colors!  
hash
    "Answer the size of the receiver as its hash value.
    Implemented by LRP..."
    #addedByOStyle.

    ^contents hash! 
header
    "Returns the receiver's header.
    Implemented by LRP..."
    #addedByOStyle.

    ^contents copyFrom: 1 to: self headerSize!
headerSize
    "Private - Returns the receiver's header size.
    Implemented by LRP..."
    #addedByOStyle.
    ^self class headerSize!  
numEntries
    "Return the number of color entries.
    Implemented by LRP..."
    #addedByOStyle.
    ^self uShortAtOffset: 2!   
printOn: aStream
    "Place the receiver as a printable string into aStream.
    Implemented by LRP..."
    | colors |
    #addedByOStyle.
    colors := self colors.
    aStream nextPutAll: self class name,' from: #('.

    1 to: colors size by: 4 do: [:index|
        aStream cr;
            next: 2 put: $ ;nextPut: $";
            nextPutAll: (index // 4) printString;nextPut: $";space;
            nextPut: $(.
         index to: index + 3 do: [:i|
            aStream space;nextPutAll: (colors at: i) printString
        ].
         aStream space;nextPut: $).
    ].
    aStream nextPutAll: '    )'!
setFlagsOf: entries to: pcFlag
    "Sets the entries in 'entries' to pcFlag.
    Implemented by LRP..."
    | stream |
    #addedByOStyle.
    stream := WriteStream on: contents.
    entries do: [:each|
        stream
            position: 4 * each + self headerSize + 3;
            nextPut: pcFlag
    ]!  
startIndex: start numEntries: numEntries
    "Implemented by Object Style.
    Implemented by LRP..."
    #addedByOStyle.
    ^self contents copyFrom: (start*4) to: (start + numEntries * 4)! !

! WinLong class methods ! 
fromString: aString
        "Answer the receiver converted from the 4-byte aString.
         This method can be used to convert a ULong return parameter
          (returned as a 4 byte String) to a WinAddress."
    | winLong |
    self addedByOSI.
    winLong := self new.
    winLong contents
        replaceFrom: 1
        to: 4
        with: aString
        startingAt: 1.
   ^winLong! !

! WinAddress class methods !
copyFromDBS: srcObject to: destObject count: bytes
        "Private - Copy bytes from double-byte srcObject to
         destObject. srcObject and destObject must be either
         aVariableByteObject or aWinAddress."
    <primitive: 130>
    ^self primitiveFailed! !

! WinAddress methods !
replaceBytes: count with: aCollection
        "Private - replace count bytes of the receiver
         with bytes of aCollection.  aCollection
         may be either a Smalltalk byte object or
         an instance of WinAddress.  Answer the receiver."
    WinAddress
        copyFromDBS: aCollection
        to: self
        count: count! 
replaceBytesFrom: byteStart
    to: byteStop
    with: aVariableByteObject
    startingAt: byteRepStart
        "Private - replace the bytes of the receiver at index
         positions start through stop with consecutive
         bytes of aVariableByteObject beginning at index
         position repStart.  Answer the receiver."
    | index1 index2 |
    <primitive: 129>
    index2 := byteRepStart.
    index1 := byteStart.
    [index1 <= byteStop]
        whileTrue: [
            self   " must use basicAt: so DoubleByteString parm handled properly "
                at: index1
                put: (aVariableByteObject basicAt: index2) asInteger.
            index1 := index1 + 1.
            index2 := index2 + 1]! 
replaceFrom: start
    to: stop
    with: aCollection
    startingAt: repStart
        "Private - Replace the bytes of the receiver at index
         positions start through stop with consecutive
         element of aCollection beginning at index
         position repStart.  Answer the receiver."
    | index1 index2 |
    <primitive: 105>
    (aCollection isDoubleByteString)
        ifTrue: [
            ^self
                replaceBytesFrom: start to: stop
                with: aCollection
                startingAt: (aCollection byteIndexOfCharAt: repStart)].
    index2 := repStart.
    index1 := start.
    [index1 <= stop]
        whileTrue: [
            self
                at: index1
                put: (aCollection at: index2) asInteger.
            index1 := index1 + 1.
            index2 := index2 + 1]! !

! WinMdiCreateStruct class methods !   
sizeInBytes
         "Private - Answer the default size in bytes."
    ^26! !

! WinMdiCreateStruct methods ! 
cx

    ^self shortAtOffset:14! 
cx: anInteger

    ^self shortAtOffset:14  put: anInteger!  
cy

    ^self shortAtOffset:16! 
cy: anInteger

    ^self shortAtOffset:16  put: anInteger!  
free

    pszClass unlockAndFree.
    pszTitle unlockAndFree.! 
hOwner

    ^self uShortAtOffset:8! 
hOwner: anInteger

    ^self uShortAtOffset:8  put: anInteger!  
lParam

    ^self uLongAtOffset:22! 
lParam: anInteger

    ^self uLongAtOffset:22 put: anInteger!   
style

    ^self uLongAtOffset:18!  
style: anInteger

    ^self uLongAtOffset:18  put: anInteger!   
szClass

    |winaddress|
    winaddress:=WinAddress new.
    winaddress uLongAtOffset: 0 put: (self uLongAtOffset: 0).
    ^String fromAddress: winaddress.!
szClass: aString

    pszClass:=WinAddress copyToNonSmalltalkMemory: aString asAsciiZ.
    self uLongAtOffset: 0 put: pszClass asInteger.! 
szTitle

    |winaddress|
    winaddress:=WinAddress new.
    winaddress uLongAtOffset: 0 put: (self uLongAtOffset: 4).
    ^String fromAddress: winaddress.!
szTitle: aString

    pszTitle:=WinAddress copyToNonSmalltalkMemory: aString asAsciiZ.
    self uLongAtOffset: 4 put: pszTitle asInteger.! 
x

    ^self shortAtOffset:10!  
x: anInteger

    ^self shortAtOffset:10  put: anInteger!   
y

    ^self shortAtOffset:12!  
y: anInteger

    ^self shortAtOffset:12  put: anInteger! !

! WinMinMaxInfo class methods !  
sizeInBytes

    ^20! !

! WinMinMaxInfo methods !
printOn: aStream

    aStream
    nextPutAll: 'ptReservedX: ', self ptReservedX printString; cr;
    nextPutAll: 'ptReservedY: ', self ptReservedY printString; cr;
    nextPutAll: 'ptMaxSizeX: ', self ptMaxSizeX printString; cr;
    nextPutAll: 'ptMaxSizeY: ', self ptMaxSizeY printString; cr;
    nextPutAll: 'ptMaxPositionX: ', self ptMaxPositionX printString; cr;
    nextPutAll: 'ptMaxPositionY: ', self ptMaxPositionY printString; cr;
    nextPutAll: 'ptMinTrackSizeX: ', self ptMinTrackSizeX printString; cr;
    nextPutAll: 'ptMinTrackSizeY: ', self ptMinTrackSizeY printString; cr;
    nextPutAll: 'ptMaxTrackSizeX: ', self ptMaxTrackSizeX printString; cr;
    nextPutAll: 'ptMaxTrackSizeY: ', self ptMaxTrackSizeY printString; cr;
    yourself.!   
ptMaxPositionX

    ^(self uShortAtOffset: 8)!  
ptMaxPositionX: aValue

    ^self uShortAtOffset: 8 put: aValue!
ptMaxPositionY

    ^(self uShortAtOffset: 10)! 
ptMaxPositionY: aValue

    ^self uShortAtOffset: 10 put: aValue!   
ptMaxSizeX

    ^(self uShortAtOffset: 4)!  
ptMaxSizeX: aValue

    ^self uShortAtOffset: 4 put: aValue!
ptMaxSizeY

    ^(self uShortAtOffset: 6)!  
ptMaxSizeY: aValue

    ^self uShortAtOffset: 6 put: aValue!
ptMaxTrackSizeX

    ^(self uShortAtOffset: 16)!
ptMaxTrackSizeX: aValue

    ^self uShortAtOffset: 16 put: aValue!  
ptMaxTrackSizeY

    ^(self uShortAtOffset: 18)!
ptMaxTrackSizeY: aValue

    ^self uShortAtOffset: 18 put: aValue!  
ptMinTrackSizeX

    ^(self uShortAtOffset: 12)!
ptMinTrackSizeX: aValue

    ^self uShortAtOffset: 12 put: aValue!  
ptMinTrackSizeY

    ^(self uShortAtOffset: 14)!
ptMinTrackSizeY: aValue

    ^self uShortAtOffset: 14 put: aValue!  
ptReservedX

    ^(self uShortAtOffset: 0)! 
ptReservedX: aValue

    ^self uShortAtOffset: 0 put: aValue!   
ptReservedY

    ^(self uShortAtOffset: 2)! 
ptReservedY: aValue

    ^self uShortAtOffset: 2 put: aValue! !

! WinPolygon class methods ! 
new: anInteger
        "Answer a new instance of the receiver
         that can hold anInteger number of points."
    ^self new
        contents: (ByteArray new: anInteger * self pointSize)!
pointSize
    "Returns the size in bytes for a point structure"
    ^4 "two words"! 
sizeInBytes
         "Private - Answer the default size in bytes."
    ^0! !

! WinPolygon methods !  
add: aPoint
    "Adds aPoint to the receiver colection.
     Answer aPoint"
    contents := contents , (ByteArray new: 2 * self pointSize).
    self at: self size put: aPoint.
    ^aPoint! 
at: anIndex
    "Returns the point in the receiver at anIndex.
     anIndex must be between 1 and self size."
    | offset |
    ^(self shortAtOffset: (offset := anIndex - 1 * self pointSize))
    @ (self  shortAtOffset: offset + 2)!
at: anIndex put: aPoint
    "Place aPoint in the receiver at anIndex.
     anIndex must be between 1 and self size.
    Returns aPoint"
    | offset |
    self
        shortAtOffset: (offset := anIndex - 1 * self pointSize)
        put: aPoint x;
        shortAtOffset: offset + 2
        put: aPoint y.
    ^aPoint!
points
    "Retuns the receiver as an array of points"
    | array |
    array := Array new: self size.
    1 to: array size do: [:i|
        array at: i put: (self at: i)
    ].
    ^array! 
points: aCollection
    "Sets the receiver as with points in aCollection"
    contents := Array new.
    aCollection do: [:each| self add: each].! 
pointSize
    "Private - Returns the size in bytes for aPoint"
    ^self class pointSize!   
size
    "Returns the size of the receiver in points"
    ^super size // self pointSize! !

! WinTextMetrics methods !
tmStrikeOut
    "Modified by OSI.  They said tmStruckOut."
        "Private - Answer the tmStruckOut field."
    #modifiedByOSI.
    ^self byteAtOffset: 18!  
tmUnderline
    "Modified by OSI, they said tmUnderlined"
        "Private - Answer the tmUnderlined field."
    #modifiedByOSI.
    ^self byteAtOffset: 17! !

! ProxyObjectFromResource class methods !   
aboutToSaveImage
    "Private - Default code.  Redefined by subclasses."

    self allSubclasses do: [:each| each releaseInstances ]!  
releaseInstances
    "Private - Release all the receiver's instances"

    self allInstances do: [:each | each release ]! !

! ProxyObjectFromResource methods ! 
become: anObject
        "The receiver takes on the identity of anObject.
         All the objects that referenced the receiver
         will now point to anObject."
    <primitive: 72>
    ^self primitiveFailed! 
doesNotUnderstand: aMessage
        "Redirects the message to handled object."
    (state isNil and: [ object isNil ])
    ifTrue: [ self privateService: #load ].
    aMessage receiver: object.
    ^aMessage perform! 
isObjectFromResource
    "Answer true if receiver is a kind of ObjectFromResource."
    ^true!  
privateService: service
    "Private - Perform the service named service
     in the receiver. "

    service == #load
    ifTrue: [ "Mark the receiver as #loaded This service must be refined by Subclasses"
        state := #loaded.
        ^self
    ].

    service == #release
    ifTrue: [ "Release the receiver. This service must be refined by Subclasses"
        object release.
        object := state := nil.
        ^self
    ].

    service == #getId ifTrue: [^id].
    service == #getObject ifTrue: [^object].

    service isArray
    ifTrue: [ "a complex service can be used for setting the id."
        service first == #setId ifTrue: [ ^id := service last ]
    ].! 
release
    "Release the receiver.
     Done when saving image..."

    self privateService: #release! !

! ProxyObjectFromModule class methods !   
cantLoad: class id: id from: moduleName
    "Private - Notify the user that the object aProxyObject can't be loaded
     from module..."

    UserLibrary messageBeep: 0.

    Smalltalk isRunTime
    ifFalse: [
        MessageBox
            warning: 'Can''t load Object of class ',class asString
            ,' (id:',id asString,') from module ',moduleName asString
    ]!   
getObject: class from: moduleName id: id
    "Private - Extracts an Object of class class from moduleName...
     If there are any problem loading the object a new object will be created
      sending #new to the class."
    | object dll numBytes ids buffer |
    (class respondsTo: #fromModule:id:)
    ifFalse: [ object := class new "UnSupported protocoll..." ]
    ifTrue: [
        class == Bitmap
        ifTrue: [ "Bitmap #fromModule:id: is not compatible with other classes..."
            moduleName isDynamicLinkLibrary
            ifTrue: [ dll := moduleName ]
            ifFalse: [
                dll := DynamicLinkLibrary open: moduleName.
                dll isDynamicLinkLibrary
                ifFalse: [ class new ] "can't open library this object will be a new object..."
            ].
            object := class fromModule: dll id: id.
            dll free.
        ]
        ifFalse: [
            class == String
            ifTrue: [ "can't call to String>>#fromModule:id: because
                           the message don't free the library handle (This is an ST-BUG)"
                moduleName isDynamicLinkLibrary
                ifTrue: [ dll := moduleName ]
                ifFalse: [ dll := DynamicLinkLibrary open: moduleName].
                dll isDynamicLinkLibrary
                ifFalse: [ class new ] "can't open library this object will be a new object..."
                ifTrue: [
                    object := String new.
                    id isNumber "aCollection of IDs is supported"
                    ifTrue: [ ids := Array with: id ]
                    ifFalse: [ ids := id ].
                    ids do: [:currentID|
                        buffer := String new: 256.
                        numBytes := UserLibrary
                            loadString: dll id: currentID
                            buffer: buffer maxChars: buffer size.
                        object := object , (buffer copyFrom: 1 to: numBytes) asNormalizedString
                    ].
                    dll free.
                ]
            ]
            ifFalse: [ "Standard Protocoll"
                object := class fromModule: moduleName id: id
            ]
        ]
    ].
    object isNil ifTrue: [
        self cantLoad: class id: id from: moduleName.
        ^class new "Load failed..."
    ].
    ^object!
modulesInUse
    "Returns the name of the modules in use"

    ^(self allInstances collect: [:each| each privateService: #getModule ]) asSet!  
ofClass: aClass fromModule: aModuleName id: anId
    "Returns an instance of the receiver initialized.
    aClass can be a Class name or a Class
    The class must respondsTo fromModule:id:
    returning an instance from the resource file
    named aModuleName at offset anId."

    | object realClass |
    realClass := aClass isSymbol
        ifTrue: [ Smalltalk at: aClass ]
        ifFalse: [ aClass ].
    (realClass respondsTo: #fromModule:id:)
    ifFalse: [ ^self error: 'The class must respondsTo #fromModule:id:' ].

    object := self new.
    object
        privateService: (Array with: #setClass with: aClass);
        privateService: (Array with: #setModule with: aModuleName);
        privateService: (Array with: #setId with: anId).
    ^object!  
renameModule: aModuleName to: newModuleName
    "Notify all objects using module aModuleName that now
     the module has been renamed to newModuleName."

    self allInstances do: [:each|
        (each privateService: #getModule) = aModuleName
        ifTrue: [
            each privateService: (
                Array
                    with: #setModule
                    with: newModuleName
                )
        ]
    ]!  
restoreObjectsInModule: aModuleName
    "Reverts all objects in module aModuleName to its original instances"

    self allInstances do: [:each|
        (each privateService: #getModule) = aModuleName
        ifTrue: [ each privateService: #restore ]
    ]! !

! ProxyObjectFromModule methods !
privateService: service
    "Private - Perform the service named service
     in the receiver. "

    | class dll |

    service == #load
    ifTrue: [ "Load receiver's instance."
        class := self privateService: #getClass.
        class isNil ifTrue: [^nil].
        object := ProxyObjectFromModule
                getObject: class from: moduleName id: id
    ].

    service == #getClass ifTrue: [
        ^objectClass isSymbol
            ifTrue: [ Smalltalk at: objectClass ifAbsent: [^nil] ]
            ifFalse: [ objectClass ]
    ].

    service == #getModule ifTrue: [ ^moduleName ].

    service == #restore
    ifTrue: [ "Restore receiver's to instance."
        object isNil ifTrue: [ self privateService: #load ].
        object isNil ifTrue: [^nil].
        ^self become: object
    ].

    service isArray
    ifTrue: [ "a complex service can be used for setting the id."
        service first == #setClass ifTrue: [ ^objectClass := service last ].
        service first == #setModule ifTrue: [ ^moduleName := service last ].
    ].

    ^super privateService: service! !
Copyright 1990-1992 Digitalk Inc.  All rights reserved